/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { enumGetBox, typeCast, Point_$type, markType, markDep } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
export let AnchoredCategorySeries = /*@__PURE__*/ (() => {
    class AnchoredCategorySeries extends CategorySeries {
        constructor() {
            super();
            this.sz = null;
            this.s3 = false;
            this.s1 = null;
            this.sw = null;
            this.s7 = null;
            this.q8 = new CategoryFramePreparer(1, this, this.rc, this, this, this.rc.cr);
        }
        get s0() {
            if (this.sz == null) {
                this.sz = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.ck.n);
            }
            return this.sz;
        }
        getHostReferenceValue() {
            return this.f2();
        }
        bu() {
            let a = new AnchoredCategorySeriesView(this);
            return a;
        }
        lh(a) {
            super.lh(a);
            this.sv = a;
        }
        hk(a, b) {
            let c = this.ja(b);
            if (c == AnchoredCategorySeries.$$p[2]) {
                return this.hl(a, b, this.tb);
            }
            return super.hk(a, b);
        }
        get valueColumn() {
            return this.s1;
        }
        set valueColumn(a) {
            if (this.s1 != a) {
                let b = this.s1;
                this.s1 = a;
                if (!this.s3) {
                    this.raisePropertyChanged("ValueColumn", b, this.s1);
                }
            }
        }
        get tt() {
            return this.c(AnchoredCategorySeries.ti);
        }
        set tt(a) {
            this.h(AnchoredCategorySeries.ti, a);
        }
        eh(a) {
            let b = new Rect(0, 0, 0, 1, 1);
            let c = this.fetchXAxis();
            let d = this.fetchYAxis();
            let e = this.o9(this.bx);
            let f = c != null ? this.q8.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
            return this.s0.c$a(this, this.valueColumn, c, d, f, a);
        }
        ss(a, b, c) {
            if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.ch;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ch.item(g);
            }
            return d;
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            if (this.sv.c3 && this.sv.c2.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.valueColumn);
                        this.valueColumn = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.valueColumn = this.ce(this.tb);
                    }
                    let e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (e != null && !e.cv()) {
                        this.sv.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case AnchoredCategorySeries.$$p[2]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.valueColumn);
                        this.valueColumn = this.ce(this.tb);
                    }
                    this.s7 = this.tb;
                    break;
                case "ValueColumn":
                    if (this.sv.c3) {
                        this.sv.c2.g$i();
                    }
                    let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (f != null && !f.cv()) {
                        this.sv.cr.g(this.gh);
                        this.l0(false);
                    }
                    this.th();
                    this.mj();
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case "ErrorBarSettings":
                    this.l0(false);
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
                case AnchoredCategorySeries.$$p[1]:
                    this.l0(false);
                    break;
            }
        }
        ap(a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        }
        kk(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.sv.cr.g(this.gh);
                    break;
            }
            if (this.sv.c3) {
                this.sv.c2.g$e(a, b, c, d);
            }
            this.th();
            this.mj();
        }
        r2() {
            return this.s4(this.rc);
        }
        s4(a) {
            let b = 0;
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(a);
            let f = typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!c.isEmpty && !d.isEmpty && f != null) {
                let g = new ScalerParams(0, c, d, f.cc, e);
                if (f.cj) {
                    g.b = this.f2();
                }
                b = f.d8(f.k5, g);
            }
            return b;
        }
        tg(a, b, c) {
            let d = this.s4(c);
            if (a.count > 0) {
                let e = d;
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
            }
        }
        st(a, b, c, d) {
            return this.su(a, b, c, d, false);
        }
        su(a, b, c, d, e) {
            return CategorySeries.qx(a, b, c, d, e);
        }
        e3(a, b, c) {
            let d = super.e3(a, b, c);
            let e = c;
            if (this.valueColumn == null || this.valueColumn.count == 0 || e.cr.d < 1) {
                d = false;
            }
            return d;
        }
        kh(a, b) {
            super.kh(a, b);
            let c = b;
            c.cx();
            if (c.c3) {
                c.c2.g$d();
            }
        }
        si(a, b) {
            super.si(a, b);
            this.q9(b).d(a, b);
        }
        sl(a, b) {
            super.sl(a, b);
            let c = typeCast(AnchoredCategorySeriesView.$, b);
            c.b3 = true;
            if (c.c3) {
                c.c2.g$g(a.p);
            }
            if (this.pt()) {
                CategoryMarkerManager.e(this, a.m, b.cu, this.pv);
                this.sf(b, a);
                b.cm();
            }
            this.td(a, b);
        }
        lz(a, b, c, d, e) {
            super.lz(a, b, c, d, e);
            let f = this.a4.a$h.item(d);
            let g = f;
            g.cr.g(this.gh);
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.sw == null) {
                this.sw = new CategoryFrame(3);
            }
            this.sw.u();
            this.si(this.sw, g);
            this.sl(this.sw, g);
        }
        td(a, b) {
        }
        md() {
            super.md();
            if (this.g9 < 0) {
                return;
            }
            this.sv.c7();
            if (this.trendLineBrush != null) {
                this.sv.c5();
            }
            else {
                this.sv.c4();
            }
        }
        hn(a, b) {
            if (this.sv.c3 && a == this.sv.c2.g$j) {
                return null;
            }
            return super.hn(a, b);
        }
        get currentCategoryMode() {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.q2()));
        }
        get scaler() {
            return typeCast(ICategoryScaler_$type, this.q2());
        }
        get yScaler() {
            return typeCast(IScaler_$type, this.rn());
        }
        get bucketizer() {
            return this.sv.cr;
        }
        get currentMode2Index() {
            return this.r6();
        }
        provideCollisionDetector() {
            if (this.sx == 1) {
                return new CollisionAvoider();
            }
            return NonCollisionAvoider.b;
        }
        get trendlinePreparer() {
            return this.sv.c3 ? this.sv.c2 : null;
        }
        kr(a) {
            super.kr(a);
            if (this.sv.c3) {
                this.a6.exportTrendlineData(this, a, this.sv.c2.g$j);
            }
        }
        hh(a) {
            let b = this.fetchXAxis();
            let c = this.fetchYAxis();
            return this.s0.c$b(this, a, this.r3(this.bx), this.valueColumn, b, c, this.sy == 1, (d) => super.hh(d));
        }
        get mayContainUnknowns() {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        }
        f2() {
            return Series.f3(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
        }
        get_s6() {
            return 0;
        }
        get s6() {
            return this.get_s6();
        }
        aq(a) {
            if (a.isEmpty && this.ca != null) {
                a = this.ca.pg;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.o7(this.bx);
            let c = this.q2();
            let d = new ScalerParams(0, a, this.ca.pv, c.cc, this.getEffectiveViewport());
            let e = (c.eb(b.left, d));
            let f = (c.eb(b.right, d));
            if (c.cc) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.s6;
            f += this.s6;
            let h = null;
            if (c.ch) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.ao(n, this.rn(), a);
            return n;
        }
        th() {
            this.fs = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
        }
        get useHighMarkerFidelity() {
            return this.ry;
        }
    }
    AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.ti = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:sy:tj', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:sx:tk', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:tb:ts', [2, null], 'TrendLineType::tq', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::tp', [1, 1.5], 'TrendLinePeriod::to', [1, 7], 'TrendLineBrush::tl', [Brush.$, null], 'TrendLineZIndex:s5:tr', [1, 1001], 'TrendLineDashArray:tu:tm', [DoubleCollection.$], 'TrendLineDashCap:tv:tn', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
})();
/**
 * @hidden
 */
export let AnchoredCategoryBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.i = null;
            this.h = null;
            this.j = 0;
            this.i = a;
        }
        getBucketWithoutUnknowns(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 1.7976931348623157E+308;
            let h = -1.7976931348623157E+308;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        getBucket(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                if (!i) {
                    if (!isNaN_(k)) {
                        g = g < k ? g : k;
                        h = h > k ? h : k;
                    }
                }
                else {
                    if (!isNaN_(k)) {
                        g = k;
                        h = k;
                        i = false;
                    }
                }
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        cacheValues() {
            this.j = this.i.c0.valueColumn.count;
            this.h = this.i.c0.valueColumn.asArray();
        }
        unCacheValues() {
            this.h = null;
        }
    }
    AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredCategorySeriesView = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesView extends CategorySeriesView {
        constructor(a) {
            super(a);
            this.c0 = null;
            this.c1 = null;
            this.c0 = a;
        }
        get c2() {
            if (this.c1 == null) {
                this.c1 = CategoryTrendLineManagerFactory.a(this.c1, this.e.ar(), this.e.mr, this.e, this.e.ck);
            }
            return this.c1;
        }
        set c2(a) {
            this.c1 = a;
        }
        get c3() {
            return this.c1 != null;
        }
        c7() {
            this.c0.tt = null;
        }
        c5() {
            this.c0.tt = this.c0.trendLineBrush;
        }
        c4() {
            this.c0.tt = this.c0.of;
        }
        cs() {
            return new AnchoredCategoryBucketCalculator(this);
        }
        c6() {
            this.cr.cacheValues();
        }
        c8() {
            this.cr.unCacheValues();
        }
        c9(a) {
            let b = this.cu.item(a);
            return this.cp(b);
        }
        a5(a, b) {
            if (a.d) {
                if (this.c0.trendLineType != 0 && !b) {
                    let c = this.c2.g$j;
                    c.ac = this.c0.trendLineThickness;
                    c._stroke = this.c0.tt;
                    c.ai = this.c0.tu;
                    c.ad = this.c0.tv;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        getDefaultTooltipTemplate() {
            return this.c0.s0.c$c(this.e, this.c0.tb);
        }
    }
    AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
})();
//# sourceMappingURL=AnchoredCategorySeries_combined.js.map
