/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, fromEnum, markDep } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-angular-core";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-angular-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Pool$1 } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { round10N } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CategoryBucketCalculator = /*@__PURE__*/ (() => {
    class CategoryBucketCalculator extends Base {
        constructor(a) {
            super();
            this.c = null;
            this.e = 0;
            this.f = 0;
            this.d = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "view");
            }
            this.c = a;
            this.e = -1;
            this.d = 0;
        }
        getBucket(a) {
            return null;
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        g(a) {
            let b = this.c.bv;
            let c = this.c.bu;
            let d = this.c.ct;
            let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
            let f = d.ch;
            if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
                this.d = 0;
                return;
            }
            let g = d.getEffectiveViewport1(this.c);
            let h = d.o7(this.c);
            let i = typeCast(ISortingAxis_$type, e);
            if (i == null || i.i$b == null) {
                let j = new ScalerParams(0, b, c, e.cc, g);
                let k = Math.floor(e.ec(h.left, j, 0));
                let l = Math.ceil(e.ec(h.right, j, 0));
                if (e.cc) {
                    l = Math.ceil(e.ec(h.left, j, 0));
                    k = Math.floor(e.ec(h.right, j, 0));
                }
                let m = Math.floor((l - k + 1) * a / h.width);
                this.d = truncate(Math.max(1, m));
                this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
                this.f = truncate(Math.ceil(l / this.d));
            }
            else {
                this.e = i.i$e(b, c, g, h);
                this.f = i.i$g(b, c, g, h);
                this.d = 1;
            }
        }
        getBucketInfo(a, b, c, d) {
            a = this.e;
            b = this.f;
            c = this.d;
            d = this.c.ct.gh;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let CategoryFramePreparerBase = /*@__PURE__*/ (() => {
    class CategoryFramePreparerBase extends FramePreparer {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super(1, g, h, i);
                            this.g = null;
                            this.h = null;
                            this.m = false;
                            this.o = new List$1(Array_$type, 0);
                            this.p = new List$1(Number_$type, 0);
                            this.n = new List$1(Number_$type, 0);
                            this.h = f;
                            this.g = j;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super(1, d, e, f);
                        this.g = null;
                        this.h = null;
                        this.m = false;
                        this.o = new List$1(Array_$type, 0);
                        this.p = new List$1(Number_$type, 0);
                        this.n = new List$1(Number_$type, 0);
                        this.h = c;
                        this.g = g;
                    }
                    break;
            }
        }
        i(a) {
            let b = new PreparationParams();
            b.f = this.h.useHighMarkerFidelity;
            b.b = this.h.scaler;
            b.c = this.h.yScaler;
            b.d = typeCast(ISortingAxis_$type, b.b);
            b.a = typeCast(CategoryFrame.$, a);
            if (b.a == null || b.b == null || b.c == null) {
                return null;
            }
            let c;
            let d;
            let e;
            let f;
            let g = this.g.getBucketInfo(c, d, e, f);
            c = g.p0;
            d = g.p1;
            e = g.p2;
            f = g.p3;
            b.i = c;
            b.j = d;
            b.h = e;
            b.g = f;
            if (b.j < b.i) {
                return null;
            }
            let h;
            let i;
            let j;
            let k = this.a.getViewInfo(i, h);
            i = k.p0;
            h = k.p1;
            j = this.a.getEffectiveViewport();
            b.m = h;
            b.l = i;
            b.k = j;
            if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
                return null;
            }
            if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.dn) && this.g != null) {
                b.e = true;
            }
            return b;
        }
        r(a, b, c, d) {
            return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
        }
        s(a) {
            return this.r(a.b, a.m, a.l, a.k);
        }
        d(a, b) {
            let c = this.i(a);
            if (c == null || this.g == null) {
                return;
            }
            c.a.f.clear();
            c.a.k.clear();
            c.a.m.clear();
            c.a.p.clear();
            c.a.i.clear();
            c.a.h.clear();
            c.a.g.clear();
            let d = this.c.shouldDisplayMarkers;
            let e = false;
            let f = this.s(c);
            let g = this.j(c);
            if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
                return;
            }
            if (c.d != null && c.d.i$a) {
                c.d.i$h();
            }
            this.g.cacheValues();
            if (this.m && c.d != null && c.d.i$b.count > 0) {
                let h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
                while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                    c.i = c.i - 1;
                    h = c.d.i$b._inner[c.i];
                    this.z(g, h, true, c.e);
                }
                let i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
                while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                    c.j = c.j + 1;
                    i = c.d.i$b._inner[c.j];
                    this.z(g, i, true, c.e);
                }
            }
            if (this.m && c.d == null) {
                let j = c.i;
                let k = this.g.getBucket(j);
                while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                    c.i = c.i - 1;
                    j = c.i;
                    k = this.g.getBucket(j);
                }
                let l = c.j;
                k = this.g.getBucket(l);
                while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                    c.j = c.j + 1;
                    l = c.j;
                    k = this.g.getBucket(l);
                }
            }
            this.w(c, g, f);
            let m = this.t(c, g, f, d, e);
            this.c.updateMarkerCount(m);
            this.v(typeCast(CategoryFrame.$, a), b);
            this.g.unCacheValues();
            return;
        }
        v(a, b) {
        }
        get q() {
            return this.o;
        }
        t(a, b, c, d, e) {
            let f = 0;
            let g = false;
            let h = null;
            let i = false;
            let j = a.d != null;
            let k = a.m;
            let l = a.l;
            let m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.kl;
            let n = a.f;
            let o = this.h.mayContainUnknowns;
            let p = this.o;
            let q = this.n;
            let r = this.p;
            p.clear();
            q.clear();
            r.clear();
            let s = this.g;
            let t = this.h.provideCollisionDetector();
            let u = 0;
            let v = a.k;
            let w = new ScalerParams(0, k, l, a.b.j$a, v);
            let x = ((() => {
                let $ret = new ScalerParams(0, k, l, a.c.j$a, v);
                $ret.b = typeCast(Series.$, this.h) !== null ? this.h.f2() : NaN;
                return $ret;
            })());
            if (j) {
                u = a.b.j$c(2, w) - a.b.j$c(1, w);
                i = this.k();
            }
            let y = a.i;
            let z = a.j;
            let aa = a.a.f;
            let ab = typeCast(IDateTimeAxis_$type, a.b);
            if (ab != null) {
                ab.StartTimeCursor();
            }
            for (let ac = y; ac <= z; ++ac) {
                let ad;
                if (!j) {
                    if (!o) {
                        ad = s.getBucketWithoutUnknowns(ac);
                    }
                    else {
                        ad = s.getBucket(ac);
                    }
                }
                else {
                    ad = ((() => { let ae = this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
                }
                let ae = !m || (m && ad[1] > 0);
                let af = ad[0];
                if (!j || !isNaN_(ad[0])) {
                    aa.add(ad);
                    if (g && i) {
                        if (h != null) {
                            aa.add(h);
                        }
                    }
                    if (d && ae) {
                        let ag = ac * a.h;
                        let ah = ag;
                        if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                            ag = a.d.i$b._inner[ag];
                        }
                        let ai = new Array(ad.length);
                        ai[0] = ad[0];
                        ai[1] = ad[1];
                        ai[2] = ad[2];
                        if (n && ag < b.e) {
                            ai = new Array(ad.length);
                            ai[0] = af;
                            this.z(b, ag, true, a.e);
                            ai[1] = b.c;
                            ai[2] = b.d;
                        }
                        p.add(ai);
                        q.add(a.a.f.count - 1);
                        r.add(ag);
                    }
                }
            }
            if (ab != null) {
                ab.ResetTimeCursor();
            }
            this.y(a, c, j, w, x, e, d);
            if (d) {
                let aj = p.count;
                let ak;
                for (let al = 0; al < aj; al++) {
                    ak = p._inner[al];
                    if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                        ++f;
                    }
                }
            }
            return f;
        }
        k() {
            if (typeCast(Series.$, this.h) !== null) {
                return this.h.c8;
            }
            return false;
        }
        f(a, b, c, d, e, f, g) {
            let h;
            f = null;
            e = false;
            let i = typeCast(CategorySeries.$, this.h);
            let j = a.l;
            let k = a.m;
            let l = a.k;
            let m = new ScalerParams(0, k, j, a.b.j$a, l);
            let n = new ScalerParams(0, k, j, a.c.j$a, l);
            let o = a.e;
            if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            if (i != null && i.ch != null && i.ch.count < a.d.i$b.count) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            let p = a.d.i$b._inner[b];
            let q = a.d.i$d(p);
            let r = q;
            this.z(c, p, false, o);
            while (b < a.j) {
                p = a.d.i$b._inner[b + 1];
                r = a.d.i$d(p);
                this.z(c, p, true, o);
                if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                    if (e) {
                        let s = a.d.i$b._inner[b];
                        this.z(c, s, true, o);
                        f = [a.b.j$b(q, m), c.c, c.d];
                    }
                    break;
                }
                if (!e && this.k()) {
                    let t = a.d.i$b._inner[b];
                    this.z(c, t, true, o);
                    let u = [a.b.j$b(q, m), c.c, c.d];
                    if (!isNaN_(u[0])) {
                        if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                            if (a.d != null) {
                                u[0] = u[0] + g;
                            }
                            a.a.f.add(u);
                            e = true;
                        }
                        else {
                            break;
                        }
                    }
                }
                b++;
                this.u(c, p, o);
            }
            let v = NaN;
            if (!isNaN_(q)) {
                v = a.b.j$b(q, m);
            }
            h = this.e(v, c);
            return {
                ret: h,
                p1: b,
                p4: e,
                p5: f
            };
        }
        y(a, b, c, d, e, f, g) {
            let h = a.h;
            let i = a.a.f.count;
            let j = a.a.f;
            let k = this.o;
            let l = k.count;
            if (f) {
                let m = a.c.j$b(a.c.k5, e);
                a.c.j$e(a.a.k, 0, a.a.k.count, e);
                let n = a.a.k;
                let o = n.count;
                for (let p = 0; p < n.count; p++) {
                    n._inner[p] = Math.abs(n._inner[p] - m);
                }
            }
        }
        w(a, b, c) {
        }
    }
    CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
})();
/**
 * @hidden
 */
export let CategoryFramePreparer = /*@__PURE__*/ (() => {
    class CategoryFramePreparer extends CategoryFramePreparerBase {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                        {
                            let f = d[0];
                            let g = d[1];
                            let h = d[2];
                            let i = d[3];
                            let j = d[4];
                            super(1, f, g, h, i, j);
                            this.aa = new DefaultCategoryTrendlineHost();
                            this.ab = new DefaultSingleValueProvider();
                            this.ac = null;
                            this.ad = null;
                            this.ac = this.aa;
                            if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                                this.ac = typeCast(IHasCategoryTrendline_$type, f);
                            }
                            this.ad = this.ab;
                            if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                                this.ad = typeCast(IHasSingleValueCategory_$type, f);
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        let g = _rest[4];
                        super(1, c, d, e, f, g);
                        this.aa = new DefaultCategoryTrendlineHost();
                        this.ab = new DefaultSingleValueProvider();
                        this.ac = null;
                        this.ad = null;
                        this.ac = this.aa;
                        if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                            this.ac = typeCast(IHasCategoryTrendline_$type, c);
                        }
                        this.ad = this.ab;
                        if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                            this.ad = typeCast(IHasSingleValueCategory_$type, c);
                        }
                    }
                    break;
            }
        }
        l(a, b, c, d, e, f) {
            let g = b[0];
            let h = b[1];
            let i = new Rect(0, g - 5, h - 5, 11, 11);
            if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
                a.m.add({ $type: Point_$type, x: g, y: h });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        }
        j(a) {
            let b = new SingleValuesHolder();
            let c = this.ad.valueColumn;
            b.f = c;
            return b;
        }
        x(a, b, c, d, e, f) {
            if (d) {
                b[0] = b[0] + c;
            }
            else {
                b[0] = a.b.j$b(b[0], e) + c;
            }
            b[1] = a.c.j$b(b[1], f);
            if (a.h > 1 || d) {
                b[2] = a.c.j$b(b[2], f);
            }
            else {
                b[2] = b[1];
            }
        }
        y(a, b, c, d, e, f, g) {
            super.y(a, b, c, d, e, f, g);
            let h = a.h;
            let i = a.a.f.count;
            let j = a.a.f;
            let k = this.q;
            let l = k.count;
            let m = new List$1(Number_$type, 0);
            if (!c) {
                m.add(0);
            }
            let n = new List$1(Number_$type, 0);
            n.add(1);
            if (c || h > 1) {
                n.add(2);
            }
            a.b.j$d(j, m, 0, i, d);
            a.c.j$d(j, n, 0, i, e);
            for (let o = 0; o < i; o++) {
                j._inner[o][0] = j._inner[o][0] + b;
            }
            if (h == 1 && !c) {
                for (let p = 0; p < i; p++) {
                    j._inner[p][2] = j._inner[p][1];
                }
            }
            if (g) {
                a.b.j$d(k, m, 0, l, d);
                a.c.j$d(k, n, 0, l, e);
                for (let q = 0; q < l; q++) {
                    k._inner[q][0] = k._inner[q][0] + b;
                }
                if (h == 1 && !c) {
                    for (let r = 0; r < l; r++) {
                        k._inner[r][2] = k._inner[r][1];
                    }
                }
            }
        }
        w(a, b, c) {
            if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
                return;
            }
            this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
        }
        z(a, b, c, d) {
            let e = a;
            let f = e.f;
            let g = f.item(b);
            let h = g;
            if (d) {
                let i = this.g.getBucket(b);
                g = i[1];
                h = i[1];
            }
            if (c) {
                e.c = g;
                e.d = h;
            }
            else {
                e.a = g;
                e.b = h;
            }
        }
        u(a, b, c) {
            let d = a;
            let e = d.f;
            if (b < e.count) {
                let f;
                if (c) {
                    let g = this.g.getBucket(b);
                    f = g[1];
                }
                else {
                    f = e.item(b);
                }
                d.a = Math.min(d.a, f);
                d.b = Math.max(d.b, f);
            }
        }
        e(a, b) {
            let c = b;
            return [a, c.a, c.b];
        }
    }
    CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
})();
/**
 * @hidden
 */
export let CategorySeries = /*@__PURE__*/ (() => {
    class CategorySeries extends MarkerSeries {
        constructor() {
            super();
            this.q8 = null;
            this.rl = null;
            this.rp = false;
            this.ro = false;
            this.assigningCategoryStyle = null;
            this.assigningCategoryMarkerStyle = null;
            this.rj = null;
            this.rk = null;
            this.q5 = new CategoryFrame(3);
            this.q7 = new CategoryFrame(3);
            this.q3 = new CategoryFrame(3);
            this.q6 = new CategoryFrame(3);
            this.rb = null;
            this.rf = null;
            this.rb = new CategorySeriesRenderManager();
            this.rf = new CategoryTransitionSourceFramePreparer();
            this.rp = false;
            this.ro = false;
            this.ab = CategorySeries.$;
        }
        bu() {
            let a = new CategorySeriesView(this);
            return a;
        }
        get rm() {
            if (this.rl == null) {
                this.rl = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, () => this.ck.n);
            }
            return this.rl;
        }
        cx(a, b, c) {
            if (!this.hasMarkers) {
                return false;
            }
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.fetchXAxis();
            let f = new ScalerParams(1, this.ca.pg, this.pf, e.cc);
            f.c = d;
            let g = this.fetchYAxis();
            let h = new ScalerParams(1, this.ca.pg, this.pf, g.cc);
            h.c = d;
            let i = this.ca.pg;
            let j = this.pf;
            let k = this.currentMode2Index;
            let l = 0;
            if (e.b9 && e.b7) {
                l = e.getSeriesOffset(i, j, d, k, e.categoryMode);
            }
            a.clear();
            this.pq.cf((m) => {
                if (m._visibility == 0) {
                    let n = new SeriesPointOfInterest();
                    let o = m.n;
                    let p = m.o;
                    if (o < this.pf.left || o > this.pf.right || p < this.pf.top || p > this.pf.bottom) {
                        return;
                    }
                    if (e.b6 && !e.b9 && e.categoryMode != 0) {
                        n.b = m.ak;
                    }
                    else {
                        n.b = e.eb(o, f);
                    }
                    if (g.b6 && !g.b9 && g.categoryMode != 0) {
                        n.c = m.ak;
                    }
                    else {
                        n.c = g.eb(p, h);
                    }
                    n.a = m.content;
                    if (b) {
                        n.d = this.r7(n.c, c);
                    }
                    else {
                        n.d = e.fw(m.ak);
                    }
                    a.add(n);
                }
            });
            return true;
        }
        r7(a, b) {
            if (b >= 0) {
                return round10N(a, b).toString();
            }
            else {
                return a.toString();
            }
        }
        lh(a) {
            super.lh(a);
            this.rc = a;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        get categoryAxis() {
            return this.q2();
        }
        q2() {
            return this.fetchXAxis();
        }
        rn() {
            return this.fetchYAxis();
        }
        get_da() {
            return true;
        }
        ac() {
            super.ac();
            this.rc.cr.g(this.gh);
        }
        rv() {
            return (this.assigningCategoryStyle != null && this.rp) || (this.bj != 1);
        }
        rw() {
            return (this.assigningCategoryMarkerStyle != null && this.ro) || (this.bj != 1);
        }
        sk(a) {
            if (this.assigningCategoryStyle != null && this.rp) {
                this.assigningCategoryStyle(this, a);
            }
        }
        sj(a) {
            if (this.assigningCategoryMarkerStyle != null && this.ro) {
                this.assigningCategoryMarkerStyle(this, a);
            }
        }
        qw(a, b) {
            return null;
        }
        kh(a, b) {
            super.kh(a, b);
            if (a) {
                this.se(b);
            }
        }
        bg() {
            let a = super.bg();
            return a;
        }
        ky() {
            super.ky();
            let a = this.fetchXAxis();
            if (a != null) {
                a.hq(false);
            }
            let b = this.fetchYAxis();
            if (b != null) {
                b.hq(false);
            }
        }
        mn(a, b) {
            super.mn(a, b);
            this.rc.cr.g(this.gh);
            this.l0(false);
        }
        mm(a, b) {
            if (this.eu && this.gn < 0.05 && (this.ca == null || !this.ca.d6())) {
                this.ev = true;
            }
            super.mm(a, b);
            this.rc.cr.g(this.gh);
            this.l0(false);
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    let e = this.fetchYAxis();
                    let f = this.fetchXAxis();
                    if (c != null && d == null) {
                        this.kl(f);
                        this.kl(e);
                    }
                    if (c == null && d != null) {
                        this.lr(f);
                        this.lr(e);
                    }
                    this.rc.cr.g(this.gh);
                    this.l0(false);
                    break;
                case "SyncLink":
                    if (this.b5 != null && this.ca != null) {
                        this.rc.cr.g(this.gh);
                    }
                    this.l0(false);
                    break;
                case "TransitionProgress":
                    this.q7.c(this.gn, this.q5, this.q3);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.q3.v();
                        this.sl(this.q3, this.rc);
                        if (this.eu) {
                            this.eu = false;
                            this.ki();
                            this.cb.r = truncate(this.gb());
                            this.cb.b = this.cc;
                        }
                    }
                    else {
                        this.sl(this.q7, this.rc);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case "ErrorBarSettings":
                    this.k7();
                    break;
                case CategorySeries.$$p[4]:
                    this.l0(false);
                    break;
                case CategorySeries.$$p[1]:
                    this.rp = this.rr();
                    this.l0(false);
                    break;
                case CategorySeries.$$p[0]:
                    this.ro = this.rq();
                    this.l0(false);
                    break;
            }
        }
        rr() {
            return this.rt;
        }
        rq() {
            return this.rs;
        }
        r1(a) {
            return this.fy(a, this.fetchXAxis());
        }
        get_d3() {
            return typeCast(ISortingAxis_$type, this.q2()) !== null;
        }
        ar() {
            return this.q2();
        }
        g2(a) {
            return this.rm.b$d(this, a);
        }
        hh(a) {
            return this.rm.b$f(this, a);
        }
        g0(a) {
            let b = truncate(Math.round(this.fw(a)));
            return b;
        }
        fw(a) {
            return this.rm.b$c(this, a);
        }
        aw(a, b, c) {
            if (this.d9(this.bj) && !c) {
                let d = this.ri(a, b, this.rk);
                this.rk = d;
                return d;
            }
            else {
                let e = this.rg(a, b, this.rk);
                e.e = true;
                this.rk = e;
                return e;
            }
        }
        get_dr() {
            return true;
        }
        kf() {
            super.kf();
            this.rj = null;
            this.rk = null;
        }
        av(a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                let d = this.rh(a, b, this.rj);
                this.rj = d;
                return d;
            }
            else {
                let e = this.rg(a, b, this.rj);
                this.rj = e;
                return e;
            }
        }
        r0() {
            return this.rc.cu.a;
        }
        ri(a, b, c) {
            if (!this.pt()) {
                return null;
            }
            let d = this.q4();
            let e = this.r0();
            return this.rm.b$b(this, e, this.r4(this.bx), this.r3(this.bx), d.f, a, b, c);
        }
        rh(a, b, c) {
            let d = this.r4(this.bx);
            let e = this.r5(this.bx);
            let f = this.r3(this.bx);
            let g = this.q4();
            return this.rm.b$a(this, g.f, d, e, f, a, b, c);
        }
        rg(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        q4() {
            let a = this.q3;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.q7;
            }
            return a;
        }
        sg(a, b, c, d, e, f) {
            let g = this.bj != 1;
            this.rb.a1(this.rb.d, d.ch, a, b, c, d, e, f, true);
            this.rb.aa(this.fj);
            let h = this.rb.av;
            let i = null;
            let j = this.ch;
            let k = null;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    k = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                }
                h.b = i;
            }
            h.f = f;
            this.sj(h);
            this.rb.y(this, i, f, g, h.m, this.ca.a3.totalHighlightingProgress);
        }
        sh(a, b, c, d, e, f) {
            let g = this.bj != 1;
            this.rb.a1(this.rb.b, d.ch, a, b, c, d, e, f, false);
            this.rb.ab(this.fj);
            let h = this.rb.aw;
            let i = null;
            let j = this.ch;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.sk(h);
            this.rb.z(this, i, f, g, b < 0);
        }
        e3(a, b, c) {
            let d = super.e3(a, b, c);
            d = d && this.rz(this.fetchXAxis());
            d = d && this.rz(this.fetchYAxis());
            let e = c;
            if (!c.o() || b.isEmpty || a.isEmpty || this.ch == null) {
                d = false;
            }
            if (!d) {
                e.cr.d = 0;
            }
            return d;
        }
        rz(a) {
            if (a == null || a.bh == null) {
                return false;
            }
            let b = typeCast(CategoryAxisBase.$, a);
            if (b != null) {
                if (b.itemsSource == null) {
                    return false;
                }
                if (b.kq < 1) {
                    return false;
                }
            }
            else {
                let c = typeCast(NumericAxisBase.$, a);
                if (c != null) {
                    return c.kv != c.ku;
                }
            }
            return true;
        }
        ek() {
            return this.ru;
        }
        rd() {
            return 12;
        }
        ki() {
            super.ki();
            this.q5.v();
            this.q3.v();
            this.q7.v();
        }
        l1(a) {
            super.l1(a);
            this.rc.cr.g(this.gh);
            if (this.ct(this.bx)) {
                this.q3.y();
                this.q7.y();
                this.q5.y();
                return;
            }
            if (this.em) {
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.sl(this.q7, this.rc);
                }
                else {
                    this.sl(this.q3, this.rc);
                }
                return;
            }
            if (this.ei(a)) {
                let b = this.q5;
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.q5 = this.q7;
                    this.q7 = b;
                }
                else {
                    this.q5 = this.q3;
                    this.q3 = b;
                }
                this.si(this.q3, this.rc);
                if (this.ew) {
                    this.cb.w();
                    this.cb.r = truncate(this.gc());
                    this.cb.b = this.cd != null ? this.cd : this.cc;
                    this.rf.p(this.q5, this.q3, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.re, this.rd(), this.b7, this.b6(), runOn(this, this.r2), this.rc.bu);
                }
                this.kd();
                this.l8();
                if (this.ew) {
                    this.ev = false;
                    this.eu = true;
                }
            }
            else {
                this.si(this.q3, this.rc);
                this.sl(this.q3, this.rc);
            }
        }
        b6() {
            return 3;
        }
        r2() {
            if (this.isVertical) {
                return this.pf.left;
            }
            return this.pf.bottom;
        }
        r6() {
            let a = 0;
            let b = this.fetchXAxis();
            for (let c of fromEnum(this.ca.series)) {
                if (c == this) {
                    return a;
                }
                let d = typeCast(CategorySeries.$, c);
                if (d != null) {
                    let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                    if (e == b && d.preferredCategoryMode(e) == 2) {
                        a++;
                    }
                }
            }
            return -1;
        }
        get GetErrorBarsXAxis() {
            return this.fetchXAxis();
        }
        get GetErrorBarsYAxis() {
            return this.fetchYAxis();
        }
        sf(a, b) {
            this.rb.az(this, this.rw(), runOn(this, this.qw), this.r3(a), this.r4(a));
            let c = this.rb.d;
            let d = c != null;
            let e = this.q2();
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.bv, a.bu, e.cc, f);
            let h = this.ch == null ? 0 : this.ch.count;
            let i = a;
            let j = b.f;
            let k = i.cr.e;
            let l = i.cr.f;
            let m = i.cr.d;
            let n = k * m;
            for (let o = 0; o < a.cu.count; o++) {
                let p = a.cu.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.sg(j, r, h, e, g, a.q);
                }
                this.rb.ac(p, q);
            }
        }
        sl(a, b) {
            this.o6 = a.aa;
            b.au();
        }
        si(a, b) {
            a.u();
        }
        r3(a) {
            return a.cr.d;
        }
        r4(a) {
            return a.cr.e;
        }
        r5(a) {
            return a.cr.f;
        }
        se(a) {
            let b = a;
            b.cu.count = 0;
        }
        l2(a, b) {
            super.l2(a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            let c = typeCast(CategorySeriesView.$, this.bw);
            c.cr.g(this.gh);
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            this.sm();
            this.et = false;
        }
        sm() {
            let a = typeCast(CategorySeriesView.$, this.bw);
            if (!this.en) {
                this.si(this.q6, a);
            }
            this.en = false;
            this.sl(this.q6, a);
        }
        q9(a) {
            let b = typeCast(CategorySeriesView.$, a);
            if (b != null && b.q) {
                if (b.p) {
                    return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cr);
                }
                else {
                    return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.ca.cf.o, this, b.cr);
                }
            }
            else {
                return this.q8;
            }
        }
        an(a) {
            if (this.fetchXAxis() == a) {
                return this.fetchYAxis();
            }
            if (this.fetchYAxis() == a) {
                return this.fetchXAxis();
            }
            return null;
        }
        ag() {
            return [this.fetchXAxis(), this.fetchYAxis()];
        }
        static qx(a, b, c, d, e) {
            let f = null;
            if (b > -1 && !d.isEmpty && !c.isEmpty) {
                let g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
                let h = c.bottom + 10;
                let i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
                let j = c.top - 10;
                f = new Clipper(1, g, h, i, j, e);
            }
            return f;
        }
    }
    CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    CategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:rs:sn', [0, false], 'IsCustomCategoryStyleAllowed:rt:so', [0, false], 'IsTransitionInEnabled:ru:sp', [0, false], 'TransitionInMode:re:sq', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:ry:sr', [0, false]]);
    return CategorySeries;
})();
/**
 * @hidden
 */
export let CategorySeriesView = /*@__PURE__*/ (() => {
    class CategorySeriesView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.ct = null;
            this.cw = 0;
            this.cr = null;
            this.cu = null;
            this.cw = -1;
            this.ct = a;
            this.cr = this.cs();
            this.cu = ((() => {
                let $ret = new Pool$1(Marker.$);
                $ret.create = runOn(this, this.b0);
                $ret.activate = runOn(this, this.cj);
                $ret.disactivate = runOn(this, this.cl);
                $ret.destroy = runOn(this, this.ck);
                return $ret;
            })());
        }
        cv(a) {
            if (this.cw != a.t) {
                return true;
            }
            return false;
        }
        cy(a) {
            this.cw = a.t;
        }
        updateMarkerTemplate(a, b, c) {
            if (!this.b1.pv) {
                let d = this.cu.item(a);
                let e = d.content;
                e.item = this.e.ch.item(b);
                d.ak = b;
                d.al = c;
            }
        }
        cs() {
            return new CategoryBucketCalculator(this);
        }
        get shouldDisplayMarkers() {
            return this.ct.pt();
        }
        updateMarkerCount(a) {
            this.cu.count = a;
        }
        cf(a) {
            this.cu.c(a);
        }
        cx() {
        }
    }
    CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
})();
//# sourceMappingURL=CategoryBucketCalculator_combined.js.map
