/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeAxisDisplayType_$type } from "./TimeAxisDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { Base, enumGetBox, Number_$type, typeGetValue, typeCast, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { NumericYAxis } from "./NumericYAxis";
import { LinearNumericSnapper } from "./LinearNumericSnapper";
import { LabelPosition } from "./LabelPosition";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-angular-core";
import { dateMinValue, dateFromTicks } from "igniteui-angular-core";
import { timeSpanFromMilliseconds } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let CategoryDateTimeXAxis = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxis extends TimeAxisBase {
        constructor() {
            super();
            this.m0 = 0;
            this.m1 = 0;
            this.ab = CategoryDateTimeXAxis.$;
            this.actualMinimumValue = (new Date());
            this.actualMaximumValue = (new Date());
        }
        get_b8() {
            return this.mv == 0;
        }
        a3() {
            return new CategoryDateTimeXAxisView(this);
        }
        ha(a) {
            super.ha(a);
            this.mu = a;
        }
        get m2() {
            return this.m0;
        }
        set m2(a) {
            if (this.m2 != a) {
                let b = this.m0;
                this.m0 = a;
                this.hk("ActualInterval", b, this.m2);
            }
        }
        ej() {
            return this.m2;
        }
        get m6() {
            return typeGetValue(this.c(CategoryDateTimeXAxis.nh));
        }
        set m6(a) {
            this.h(CategoryDateTimeXAxis.nh, a);
        }
        get m3() {
            return this.m1;
        }
        set m3(a) {
            if (this.m3 != a) {
                let b = this.m1;
                this.m1 = a;
                this.hk("ActualMinorInterval", b, this.m3);
            }
        }
        c1(a, b, c) {
            let d = super.c1(a, b, c);
            if (!d) {
                return false;
            }
            return +(this.actualMinimumValue) != +(this.actualMaximumValue);
        }
        dv() {
            return this.m2;
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = !b.isEmpty ? this.js : Rect.empty;
            let d = this.jn();
            let e = this.jm();
            let f = new ScalerParams(0, b, c, this.cc, d);
            if (this.lo == null && !this.lu() && !this.lv()) {
                return;
            }
            if (!b.isEmpty && !c.isEmpty && (this.mv != 1 || this.lo != null)) {
                let g = c.bottom;
                let h = g - c.top;
                if (this.ai != null) {
                    let i = typeCast(NumericYAxis.$, this.ai);
                    if (i != null) {
                        let j = this.hv(g, h, b, c, d, c.top, c.bottom);
                        g = j.p0;
                        h = j.p1;
                    }
                }
                if (isNaN_(g)) {
                    g = 0;
                }
                this.g8(this.a4.ay(), g, c, this.a4.e(), true);
                this.av.bc = h;
                let k = this.a4.a1();
                let l = this.a4.f();
                let m = this.a4.az();
                let n = this.a4.a0();
                let o = this.a4.g();
                if (this.mv == 1) {
                    let p = this.i$e(b, c, d, e);
                    let q = this.i$g(b, c, d, e);
                    if (p < 0 || q < 0) {
                        return;
                    }
                    let r = NaN;
                    for (let s = p; s <= q; s++) {
                        let t = this.lx == null ? s : this.lx._inner[s];
                        let u = this.d8(this.lo.item(t).getTime(), f);
                        if (u == r) {
                            continue;
                        }
                        r = u;
                        if (this.categoryMode == 2) {
                            u += this.cc ? -this.getGroupCenter(s, b, c, d) : this.getGroupCenter(s, b, c, d);
                        }
                        if (u < e.left || u > e.right) {
                            continue;
                        }
                        this.h1(m, u, c, l, false);
                        this.kd.add(u);
                        if (this.j6 != null && s < this.j6.count) {
                            let v = this.j6.item(t);
                            let w = super.fi(v);
                            if (!isNaN_(u) && !isInfinity(u) && w != null) {
                                if ((typeof w === 'string') && Base.equalsStatic(w, "")) {
                                }
                                else {
                                    this.c5.add1(w);
                                    this.c6.add(new LabelPosition(u));
                                }
                            }
                        }
                    }
                }
                else {
                    let x = this.eb(e.left, f);
                    let y = this.eb(e.right, f);
                    let z = Math.min(x, y);
                    let aa = Math.max(x, y);
                    let ab = new LinearNumericSnapper(0, z, aa, e.width, this.el());
                    let ac = this.ls ? this.mz() : ab.g;
                    this.nd(truncate(ac));
                    let ad = truncate(Math.floor((z - this.actualMinimumValue.getTime()) / ac));
                    let ae = truncate(Math.ceil((aa - this.actualMinimumValue.getTime()) / ac));
                    let af = 0;
                    if (this.categoryMode == 2) {
                        af = this.getGroupCenter(0, b, c, d);
                        af = this.cc ? -af : af;
                    }
                    let ag = truncate(Math.ceil(e.right));
                    let ah = truncate(Math.floor(e.left));
                    let ai = this.d8(this.actualMinimumValue.getTime() + ad * ac, f) + af;
                    for (let aj = ad; aj <= ae; aj++) {
                        let ak = this.d8(this.actualMinimumValue.getTime() + (aj + 1) * ac, f) + af;
                        if (!isNaN_(ai) && !isInfinity(ai)) {
                            let al = truncate(Math.round(ai));
                            if (al <= ag) {
                                if (aj % 2 == 0) {
                                    this.h2(k, ai, ak, c);
                                }
                                this.h1(m, ai, c, l, false);
                                this.kd.add(ai);
                                if (this.cs) {
                                    let am = this.m4();
                                    if (am > 0 && am < ac) {
                                        if (ac / am < 20) {
                                            let an = ai;
                                            let ao = Math.abs(this.d8(this.actualMinimumValue.getTime() + am, f) - this.d8(this.actualMinimumValue.getTime(), f));
                                            while (an + ao < ak) {
                                                if (Math.abs(an + ao - ak) < 0.0001) {
                                                    break;
                                                }
                                                an += ao;
                                                if (an > 0) {
                                                    this.h1(n, an, c, o, false);
                                                }
                                            }
                                            this.ne(am);
                                        }
                                    }
                                    else {
                                        for (let ap = 1; ap < ab.i; ++ap) {
                                            let aq = this.d8(this.actualMinimumValue.getTime() + aj * ac + (ap * ac) / ab.i, f) + af;
                                            this.h1(n, aq, c, o, false);
                                        }
                                        if (ab.i > 0) {
                                            this.ne(truncate((ac / ab.i)));
                                        }
                                    }
                                }
                            }
                            if (al >= ah && al <= ag) {
                                let ar = this.actualMinimumValue.getTime() + aj * ac;
                                let ticks_ = truncate(Math.floor(ar));
                                let as = (new Date(ticks_));
                                let at = this.fi(as);
                                if (at != null) {
                                    this.c5.add1(at);
                                    this.c6.add(new LabelPosition(ai));
                                }
                            }
                        }
                        ai = ak;
                    }
                }
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.jq();
                    }
                }
                this.av.a5 = this.c5;
                this.av.a6 = this.c6;
                this.ld();
            }
        }
        mz() {
            return this.m2;
        }
        m4() {
            return this.m6;
        }
        nd(a) {
            this.m2 = a;
        }
        ne(a) {
            this.m3 = a;
        }
        mx() {
            return this.m5 != 0;
        }
        mw() {
            return this.m2 == 0;
        }
        my(a) {
            return this.lo == null ? dateMinValue() : this.lo.item(a);
        }
        nc(a, b) {
            if (a > b || this.j6 == null || this.j6.count == 0) {
                return;
            }
            let c = (a.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            let d = (b.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            this.bh.pw = new Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
        }
        he(a, b, c, d) {
            super.he(a, b, c, d);
            switch (b) {
                case CategoryDateTimeXAxis.$$p[0]:
                    this.ck = true;
                    this.av.ak = this.mv == 1;
                    this.hq(false);
                    break;
                case CategoryDateTimeXAxis.$$p[1]:
                    this.ck = true;
                    this.hq(false);
                    break;
            }
        }
        mk() {
            super.mk();
            if (this.mx()) {
                this.m2 = this.m5;
                let a = this.bh != null ? this.bh.pg : Rect.empty;
                let b = !a.isEmpty ? this.js : Rect.empty;
                let c = Math.abs(this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
                this.ls = this.mw() || (this.mv == 1) || (1 * c / this.mz() > (b.width / a.width)) ? false : true;
            }
            else {
                this.ls = false;
            }
        }
        mi(a, b) {
            let c = b.getTime() - a.getTime();
            let timeOffset_ = truncate(Math.round(intDivide(c, this.kq) / 2));
            return timeOffset_ == 0 ? timeSpanFromMilliseconds(1) : timeSpanFromMilliseconds(timeOffset_);
        }
        get_b7() {
            return true;
        }
        get isVertical() {
            return this.cj;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
        get i$a() {
            return this.b9;
        }
    }
    CategoryDateTimeXAxis.$t = markType(CategoryDateTimeXAxis, 'CategoryDateTimeXAxis', TimeAxisBase.$);
    CategoryDateTimeXAxis.nh = DependencyProperty.i("MinorInterval", Number_$type, CategoryDateTimeXAxis.$, new PropertyMetadata(2, 0, (a, b) => {
        (typeCast(CategoryDateTimeXAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryDateTimeXAxis.$, a)).hq(false);
    }));
    CategoryDateTimeXAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryDateTimeXAxis, 'hk', ['DisplayType:mv:nf', [TimeAxisDisplayType_$type, enumGetBox(TimeAxisDisplayType_$type, 0)], 'Interval:m5:ng', [1, 0]]);
    return CategoryDateTimeXAxis;
})();
/**
 * @hidden
 */
export let CategoryDateTimeXAxisView = /*@__PURE__*/ (() => {
    class CategoryDateTimeXAxisView extends CategoryAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.e0 = AxisDefaults.f;
        }
        o(a) {
            let b = this.n(dateFromTicks(truncate(a)));
            return b;
        }
    }
    CategoryDateTimeXAxisView.$t = markType(CategoryDateTimeXAxisView, 'CategoryDateTimeXAxisView', CategoryAxisBaseView.$);
    return CategoryDateTimeXAxisView;
})();
//# sourceMappingURL=CategoryDateTimeXAxis_combined.js.map
