/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "igniteui-angular-core";
import { MathUtil } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let CategoryXAxis = /*@__PURE__*/ (() => {
    class CategoryXAxis extends CategoryAxisBase {
        constructor() {
            super();
            this.l1 = 1;
            this.l0 = 1;
            this.l4 = null;
            this.lr = 0;
            this.ls = 0;
            this.kd = new List$1(Number_$type, 0);
            this.ab = CategoryXAxis.$;
        }
        a3() {
            return new CategoryXAxisView(this);
        }
        ha(a) {
            super.ha(a);
            this.lo = a;
        }
        get l3() {
            return this.l1;
        }
        set l3(a) {
            this.l1 = a;
        }
        get l2() {
            return this.l0;
        }
        set l2(a) {
            this.l0 = a;
        }
        au() {
            if (this.cz) {
                return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        }
        getCategorySize(a, b, c) {
            let d = this.jq(b, c);
            return d.width / (this.kq * a.width);
        }
        ki(a, b, c) {
            let d = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
            let e = 0;
            if (!isNaN_(this.km)) {
                e = Math.min(this.km, 1);
            }
            else {
                e = 0;
            }
            ;
            let f = 1 - 0.5 * d;
            let g = this.ks == 0 ? 1 : this.ks;
            let h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
            return h;
        }
        getGroupCenter(a, b, c, d) {
            let e = 0.5;
            if (this.ks > 1) {
                let f = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
                let g = 0;
                if (!isNaN_(this.km)) {
                    g = Math.min(this.km, 1);
                }
                let h = 1 - 0.5 * f;
                let i = h / (this.ks - (this.ks - 1) * g);
                let j = (h - i) / (this.ks - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        }
        dv() {
            return this.ly;
        }
        l9(a) {
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            b = b.copy();
            let c = this.js;
            let d = this.jp();
            let e = new Rect(0, 0, 0, 1, 1);
            let f = new ScalerParams(0, e, e, this.cc, d);
            let g = !b.isEmpty && !c.isEmpty && this.j6 != null ? this.j6.indexOf(a) : -1;
            let h = g > -1 ? this.d8(g, f) : NaN;
            if (!isNaN_(h) && this.bh.d0) {
                if (!isNaN_(h)) {
                    if (h < b.left + 0.1 * b.width) {
                        h = h + 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                    if (h > b.right - 0.1 * b.width) {
                        h = h - 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                }
                this.bh.mt(b, false, true);
            }
        }
        d8(a, b) {
            if (!b.c.isEmpty) {
                let c = this.lx(a, NumericScaler.ac, b.c, this.categoryMode);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.lx(a, b.e, b.d, this.categoryMode);
        }
        ln(a) {
            if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        }
        g4(a, b, c, d, e) {
            let f;
            let g = e.e;
            let h = e.d;
            let i = e.c;
            let j = e.a;
            let k = !i.isEmpty;
            let l = this.categoryMode == 0 ? this.kq - 1 : this.kq;
            if (l < 0) {
                l = 0;
            }
            let m = i.left;
            let n = i.width;
            let o = g.left;
            let p = g.width;
            let q = h.left;
            let r = h.width;
            let s = 0;
            let t = 1;
            let u = this.ln(a);
            let v = false;
            if (u != null) {
                v = true;
            }
            let w;
            for (let x = 0; x < b.count; x++) {
                w = b.item(x);
                for (let y = c; y < d; y++) {
                    if (v) {
                        f = u[y];
                    }
                    else {
                        f = a.item(y);
                    }
                    if (k) {
                        let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            z = 1 - z;
                        }
                        z = m + n * (z - s) / t;
                        z = (z - q) / r;
                        let aa = q + r * (z - o) / p;
                        f[w] = aa;
                    }
                    else {
                        let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = q + r * (ab - o) / p;
                        f[w] = ab;
                    }
                }
            }
        }
        d9(a, b, c) {
            if (!b.c.isEmpty) {
                let d = this.lx(a, NumericScaler.ac, b.c, c);
                d = (d - b.d.left) / b.d.width;
                d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
                return d;
            }
            return this.lx(a, b.e, b.d, c);
        }
        lx(a, b, c, d) {
            let e = d == 0 ? this.kq - 1 : this.kq;
            if (e < 0) {
                e = 0;
            }
            let f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
            if (this.cd) {
                f = 1 - f;
            }
            return c.left + c.width * (f - b.left) / b.width;
        }
        eb(a, b) {
            if (!b.c.isEmpty) {
                let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
                return c;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        }
        ec(a, b, c) {
            if (!b.c.isEmpty) {
                let d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                d = (d * b.d.width) + b.d.left;
                d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
                return d;
            }
            return this.getUnscaledValue3(a, b.e, b.d, c);
        }
        getUnscaledValue3(a, b, c, d) {
            let e = b.left + (a - c.left) * b.width / c.width;
            if (this.cd) {
                e = 1 - e;
            }
            let f = d == 0 ? this.kq - 1 : this.kq;
            if (f < 0) {
                f = 0;
            }
            return e * f;
        }
        ma(a, b) {
            if (a == NaN || b == NaN || this.j6 == null || this.j6.count == 0) {
                return;
            }
            let c = a / this.j6.count;
            let d = (b + 1) / this.j6.count;
            this.bh.pw = new Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = this.js;
            let d = this.jn();
            let e = this.jm();
            let f = new ScalerParams(0, b, c, this.cc, d);
            let g = this.a4.ay();
            let h = this.a4.a1();
            let i = this.a4.az();
            let j = this.a4.a0();
            let k = this.a4.e();
            let l = this.a4.f();
            let m = this.a4.g();
            let n = this.j6;
            let o = this.lp();
            this.h0();
            this.g0(g);
            this.g0(h);
            this.g0(i);
            this.g0(j);
            this.c5.clear();
            this.c6.clear();
            this.kd.clear();
            this.a4.at(this, b, c);
            if (b.isEmpty || c.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0 && this.bp.count == 0) {
                this.a4.y();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            if (this.itemsSource == null || o == null || n.count == 0) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
                this.a4.y();
                return;
            }
            if (!b.isEmpty && !c.isEmpty) {
                let p = this.eb(e.left, f);
                let q = this.eb(e.right, f);
                let r = 0;
                let s = false;
                if (this.cy) {
                    let t = Math.abs(q - p);
                    r = Math.ceil(t) + 1;
                    if (this.cc) {
                        if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                            s = true;
                        }
                    }
                    else {
                        if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                            s = true;
                        }
                    }
                }
                if (this.cc) {
                    p = Math.ceil(p);
                    q = Math.floor(q);
                }
                else {
                    p = Math.floor(p);
                    q = Math.ceil(q);
                }
                if (this.cy) {
                    if (Math.abs(q - p) < r) {
                        if (this.cc) {
                            if (s) {
                                q--;
                            }
                            else {
                                p++;
                            }
                        }
                        else {
                            if (s) {
                                q++;
                            }
                            else {
                                p--;
                            }
                        }
                    }
                }
                let u = c.bottom;
                let v = u - c.top;
                if (this.ai != null) {
                    let w = typeCast(NumericYAxis.$, this.ai);
                    if (w != null) {
                        let x = this.hv(u, v, b, c, d, c.top, c.bottom);
                        u = x.p0;
                        v = x.p1;
                    }
                }
                this.g8(g, u, c, k, true);
                this.a4.ao(v);
                let y = Math.min(p, q);
                let z = Math.max(p, q);
                let aa = e.width;
                if (this.cy) {
                    let ab = this.d8(y, f);
                    let ac = this.d8(z, f);
                    aa = Math.abs(ac - ab);
                }
                let ad = new LinearCategorySnapper(1, y, z, aa, this.ly, this.categoryMode, this.el());
                let ae = ad.g;
                while (!this.lq() && ae < 10 && this.ct(ae, b, c, d)) {
                    ae--;
                }
                if (ad.g != ae) {
                    ad = new LinearCategorySnapper(1, y, z, aa, ae, this.categoryMode, this.el());
                }
                let af = Math.floor((y - 0) / ad.g);
                let ag = Math.ceil((z - 0) / ad.g);
                this.lt = ad.g;
                if (!isNaN_(af) && !isNaN_(ag)) {
                    let ah = truncate(af);
                    let ai = truncate(ag);
                    let aj = this.lw(0 + ah * ad.g, f);
                    let ak = this.d8(ad.g, f);
                    let al = Math.abs(ak - this.d8(0, f));
                    this.a4.ap(ak);
                    let am = truncate(Math.ceil(e.right));
                    let an = truncate(Math.floor(e.left));
                    let ao = this.lz;
                    let ap = ao > 0 && ao < ad.g;
                    let aq = c.right;
                    let ar = this.kd;
                    let as = ad.g;
                    let at = truncate(as);
                    let au = this.ks;
                    let av = this.cc;
                    let aw = this.categoryMode;
                    this.l4 = null;
                    for (let ax = ah; ax <= ai; ++ax) {
                        let ay = this.lw(0 + (ax + 1) * ad.g, f);
                        if (aj <= aq) {
                            if (ax % 2 == 0) {
                                this.h2(h, aj, ay, c);
                            }
                            this.h1(i, aj, c, l, false);
                            ar.add(aj);
                        }
                        if (this.categoryMode != 0 && this.ks != 0 && this.cs) {
                            if (ap) {
                                let az = al * this.lz;
                                if (this.cc) {
                                    let a0 = aj;
                                    while (a0 - az > ay) {
                                        a0 -= az;
                                        if (Math.abs(a0 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.h1(j, a0, c, m, false);
                                    }
                                }
                                else {
                                    let a1 = aj;
                                    while (a1 + az < ay) {
                                        a1 += az;
                                        if (Math.abs(a1 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.h1(j, a1, c, m, false);
                                    }
                                }
                                this.lu = this.lz;
                            }
                            else {
                                for (let a2 = 0; a2 < truncate(ad.g); a2++) {
                                    for (let a3 = 0; a3 < this.ks; a3++) {
                                        let a4 = this.getGroupCenter(a3, b, c, d);
                                        if (this.cc) {
                                            a4 = -a4;
                                        }
                                        let a5 = this.d8(a2 + ax * ad.g, f) + a4;
                                        this.h1(j, a5, c, m, false);
                                    }
                                }
                                this.lu = 0.5;
                            }
                        }
                        let a6 = this.lv(ax * as, aj, aw == 0, f);
                        let a7 = truncate(Math.round(a6));
                        if (a7 >= an && a7 <= am) {
                            let a8 = 0;
                            if (as >= 1) {
                                a8 = ax * truncate(Math.floor(as));
                            }
                            else {
                                if ((ax * as) * 2 % 2 == 0) {
                                    a8 = truncate(Math.floor(ax * as));
                                }
                                else {
                                    a8 = -1;
                                }
                            }
                            if (o != null && a8 < n.count && a8 >= 0) {
                                let a9 = o.getItem(a8);
                                let ba = this.fi(a9);
                                this.l4 = a9;
                                if (!isNaN_(a6) && !isInfinity(a6) && ba != null) {
                                    if ((typeof ba === 'string') && Base.equalsStatic(ba, "")) {
                                    }
                                    else {
                                        this.c5.add1(ba);
                                        this.c6.add(new LabelPosition(a6));
                                    }
                                }
                            }
                        }
                        aj = ay;
                    }
                }
                this.l4 = null;
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.jq();
                    }
                }
                this.a4.au(this.c5, this.c6);
                this.ld();
            }
        }
        cx() {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null) {
                return false;
            }
            let a = this.j6.count;
            if (a != this.l2) {
                let b = new AxisRangeChangedEventArgs(0, 1, 1, this.l2, a);
                this.l2 = a;
                this.hl(b);
                return true;
            }
            return false;
        }
        get ly() {
            return this.c(CategoryXAxis.mb);
        }
        set ly(a) {
            this.h(CategoryXAxis.mb, a);
        }
        lq() {
            return !isNaN_(this.ly);
        }
        get lt() {
            return this.lr;
        }
        set lt(a) {
            if (this.lt != a) {
                let b = this.lr;
                this.lr = a;
                this.hk("ActualInterval", b, this.lt);
            }
        }
        ej() {
            return this.lt;
        }
        get lz() {
            return this.c(CategoryXAxis.mc);
        }
        set lz(a) {
            this.h(CategoryXAxis.mc, a);
        }
        get lu() {
            return this.ls;
        }
        set lu(a) {
            if (this.lu != a) {
                let b = this.ls;
                this.ls = a;
                this.hk("ActualMinorInterval", b, this.lu);
            }
        }
        j9(a) {
            if (a == null) {
                return false;
            }
            let b = this.bd();
            if (b == null) {
                return false;
            }
            return b.synchronizeHorizontally;
        }
        get_a1() {
            return 0;
        }
        get a1() {
            return this.get_a1();
        }
        lp() {
            return this.j6;
        }
        lw(a, b) {
            return this.d8(a, b);
        }
        lv(a, b, c, d) {
            if (!c) {
                let e = this.lw(a + 1, d);
                return (b + e) / 2;
            }
            return b;
        }
        get isVertical() {
            return this.cj;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
    }
    CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
    CategoryXAxis.mb = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
        a.hk("Interval", b.oldValue, b.newValue);
        a.hq(false);
    }));
    CategoryXAxis.mc = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
        (typeCast(CategoryXAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).hq(false);
    }));
    return CategoryXAxis;
})();
/**
 * @hidden
 */
export let CategoryXAxisView = /*@__PURE__*/ (() => {
    class CategoryXAxisView extends CategoryAxisBaseView {
        constructor(a) {
            super(a);
            this.bg = null;
            this.bg = a;
        }
        ag() {
            super.ag();
            this.a.e0 = AxisDefaults.f;
        }
    }
    CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
})();
//# sourceMappingURL=CategoryXAxis_combined.js.map
