/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Defaults } from "./Defaults";
import { TranslateTransform } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
export let CrosshairLayer = /*@__PURE__*/ (() => {
    class CrosshairLayer extends AnnotationLayer {
        constructor() {
            super();
            this.xAxisAnnotationFormatLabel = null;
            this.yAxisAnnotationFormatLabel = null;
            this.qw = null;
            this.qv = null;
            let a = new CrosshairLayerFrame();
            let b = new CrosshairLayerFrame();
            let c = new CrosshairLayerFrame();
            let d = this.ha / 1000;
            this.pk = a;
            this.pj = b;
            this.pl = c;
            this.ab = CrosshairLayer.$;
        }
        get_c5() {
            return true;
        }
        get_c3() {
            return true;
        }
        bu() {
            return new CrosshairLayerView(this);
        }
        lh(a) {
            super.lh(a);
            this.qo = a;
        }
        qq() {
            return this.xAxisAnnotationFormatLabel != null;
        }
        qr() {
            return this.yAxisAnnotationFormatLabel != null;
        }
        get s3() {
            return new Thickness(1, this.qy, this.q0, this.qz, this.qx);
        }
        get s4() {
            return new Thickness(1, this.q3, this.q5, this.q4, this.q2);
        }
        p3(a, b) {
            if (this.qp == null || this.qp == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        }
        p5(a, b) {
            super.p5(a, b);
            let c = a;
            let d = this.qu;
            let e = this.qt;
            c.ad.clear();
            c.ae.clear();
            c.ac.clear();
            c.af.clear();
            AxisAnnotationFrameManager.b(c);
            if (this.pq(this.qp)) {
                this.r2(this.qp, c, d, e);
            }
            else {
                for (let f of fromEnum(this.ca.series)) {
                    if (this.pq(f)) {
                        this.r2(f, c, d, e);
                    }
                    if (f.isStacked) {
                        f.ku((g) => {
                            if (this.pq(g)) {
                                this.r2(g, c, d, e);
                            }
                            return true;
                        });
                    }
                }
            }
        }
        pq(a) {
            if (!super.pq(a)) {
                return false;
            }
            if (this.rd != null) {
                if (a.dn) {
                    let b = a.i9();
                    if (!Base.equalsStatic(this.rd, b)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(this.rd, a.name)) {
                        return false;
                    }
                }
            }
            let c = this.py(a);
            if (!c.c) {
                return false;
            }
            return true;
        }
        la() {
            super.la();
            if (!this.as.c && !this.cr()) {
                return;
            }
            if (this.cr()) {
                this.r3(this.pl, false);
            }
            else {
                this.r3(this.pj, false);
            }
        }
        r2(a, b, c, d) {
            let e = this.py(a);
            if (!e.c) {
                return;
            }
            let f = e.d;
            f = a.o2(f, c, d);
            let g = this.of;
            if (g == null) {
                g = this.oj;
            }
            if (g == null) {
                g = a.of;
                if (g != null) {
                    g = this.qo.cb(g);
                }
            }
            let h = g;
            let i = g;
            if (this.sv != null) {
                h = this.sv;
            }
            if (this.sw != null) {
                i = this.sw;
            }
            b.ac.add(h);
            b.af.add(i);
            b.ad.add(f.y);
            b.ae.add(f.x);
            if (this.qs && !isNaN_(f.y)) {
                AxisAnnotationFrameManager.c(b, f, a, this.ca, this.getEffectiveViewport(), g, this.sx, this.sz, this.sy, this.s3, this.q1, this.s0, this.s2, this.s1, this.s4, this.q6, this.s6 == 0, this.s5 == 0);
            }
        }
        r3(a, b) {
            let c = false;
            if (this.qv == null) {
                c = true;
                this.qw = new List$1(Axis.$, 0);
                this.qv = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.qv, this.qw, b, this.q7, this.q8, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
        }
        r1(a, b, c, d, e) {
            let f = a.item(b);
            b++;
            if (e) {
                f._stroke = d.af._inner[c];
                f._fill = d.af._inner[c];
            }
            else {
                f._stroke = d.ac._inner[c];
                f._fill = d.ac._inner[c];
            }
            f.ac = this.fl;
            f.ai = this.os;
            f.ad = this.ot;
            return new Tuple$2(Path.$, Number_$type, f, b);
        }
        p8(a, b) {
            super.p8(a, b);
            let c = this.qo.b5;
            let d = a;
            let e = d.ad.count;
            let f = 0;
            let g = b.bu.left;
            let h = b.bu.right;
            let i = b.bu.top;
            let j = b.bu.bottom;
            let k = this.s6 == 0;
            let l = this.s5 == 0;
            for (let m = 0; m < e; m++) {
                let n = Math.floor(d.ad._inner[m]);
                let o = Math.floor(d.ae._inner[m]);
                let p = null;
                if (k) {
                    if (isNaN_(n)) {
                        continue;
                    }
                    let q = this.r1(c, f, m, d, true);
                    p = q.c;
                    f = q.d;
                    let r = new PathGeometry();
                    let s = new PathFigure();
                    s._startPoint = { $type: Point_$type, x: o, y: i };
                    let t = new LineSegment(1);
                    t.c = { $type: Point_$type, x: o, y: j };
                    s._segments.add(t);
                    r.c.add(s);
                    p.ak = r;
                }
                if (l) {
                    if (isNaN_(n)) {
                        continue;
                    }
                    let u = this.r1(c, f, m, d, false);
                    p = u.c;
                    f = u.d;
                    let v = new PathGeometry();
                    let w = new PathFigure();
                    w._startPoint = { $type: Point_$type, x: g, y: n };
                    let x = new LineSegment(1);
                    x.c = { $type: Point_$type, x: h, y: n };
                    w._segments.add(x);
                    v.c.add(w);
                    p.ak = v;
                }
            }
            c.count = f;
            if (this.cr()) {
                this.r3(this.pl, true);
            }
            else {
                this.r3(this.pj, false);
            }
        }
        eg() {
            return true;
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case CrosshairLayer.$$p[1]:
                    this.l0(true);
                    break;
                case CrosshairLayer.$$p[8]:
                    this.l0(true);
                    break;
                case CrosshairLayer.$$p[4]:
                case CrosshairLayer.$$p[5]:
                    this.l0(true);
                    break;
                case CrosshairLayer.$$p[2]:
                case CrosshairLayer.$$p[9]:
                case CrosshairLayer.$$p[11]:
                case CrosshairLayer.$$p[13]:
                case CrosshairLayer.$$p[15]:
                case CrosshairLayer.$$p[14]:
                case CrosshairLayer.$$p[12]:
                case CrosshairLayer.$$p[16]:
                case CrosshairLayer.$$p[17]:
                case CrosshairLayer.$$p[18]:
                case CrosshairLayer.$$p[20]:
                case CrosshairLayer.$$p[22]:
                case CrosshairLayer.$$p[24]:
                case CrosshairLayer.$$p[23]:
                case CrosshairLayer.$$p[21]:
                case CrosshairLayer.$$p[25]:
                case CrosshairLayer.$$p[26]:
                case CrosshairLayer.$$p[0]:
                case CrosshairLayer.$$p[7]:
                case CrosshairLayer.$$p[6]:
                    this.l0(true);
                    break;
            }
        }
    }
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:sv:r4', [Brush.$, null], 'HorizontalLineVisibility:s5:r5', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:qs:r6', [0, false], 'SkipUnknownValues:qt:r7', [0, true], 'TargetSeriesName:rd:r8', [2, null], 'TargetSeries:qp:r9', [Series.$, null], 'UseInterpolation:qu:sa', [0, true], 'VerticalLineStroke:sw:sb', [Brush.$, null], 'VerticalLineVisibility:s6:sc', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:sx:sd', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:q7:se', [1, -1], 'XAxisAnnotationOutline:sy:sf', [Brush.$, null], 'XAxisAnnotationPaddingBottom:qx:sg', [1, NaN], 'XAxisAnnotationPaddingLeft:qy:sh', [1, NaN], 'XAxisAnnotationPaddingRight:qz:si', [1, NaN], 'XAxisAnnotationPaddingTop:q0:sj', [1, NaN], 'XAxisAnnotationStrokeThickness:q1:sk', [1, NaN], 'XAxisAnnotationTextColor:sz:sl', [Brush.$, null], 'YAxisAnnotationBackground:s0:sm', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:q8:sn', [1, -1], 'YAxisAnnotationOutline:s1:so', [Brush.$, null], 'YAxisAnnotationPaddingBottom:q2:sp', [1, NaN], 'YAxisAnnotationPaddingLeft:q3:sq', [1, NaN], 'YAxisAnnotationPaddingRight:q4:sr', [1, NaN], 'YAxisAnnotationPaddingTop:q5:ss', [1, NaN], 'YAxisAnnotationStrokeThickness:q6:st', [1, NaN], 'YAxisAnnotationTextColor:s2:su', [Brush.$, null]]);
    return CrosshairLayer;
})();
/**
 * @hidden
 */
export let CrosshairLayerView = /*@__PURE__*/ (() => {
    class CrosshairLayerView extends AnnotationLayerView {
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b5 = null;
            this.b6 = null;
            this.b4 = a;
            this.b6 = new List$1(Path.$, 0);
        }
        as() {
            super.as();
            this.b5 = ((() => {
                let $ret = new Pool$1(Path.$);
                $ret.create = runOn(this, this.cc);
                $ret.activate = runOn(this, this.b7);
                $ret.disactivate = runOn(this, this.b9);
                $ret.destroy = runOn(this, this.b8);
                return $ret;
            })());
            this.b4.gm = Defaults.j;
        }
        cc() {
            let a = new Path();
            a.j = new TranslateTransform();
            this.b6.add(a);
            return a;
        }
        b7(a) {
            a._visibility = 0;
        }
        b9(a) {
            a._visibility = 1;
        }
        b8(a) {
            this.b6.remove(a);
        }
        ca(a, b, c, d) {
            if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
                let e = ((() => {
                    let $ret = new LineGeometry();
                    $ret.d = { $type: Point_$type, x: c, y: b };
                    $ret.c = { $type: Point_$type, x: d, y: b };
                    return $ret;
                })());
                a.ak = e;
            }
        }
        cb(a) {
            if (a == null) {
                return a;
            }
            return BrushUtil.l(a, 0.1);
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d && !b) {
                for (let c = 0; c < this.b6.count; c++) {
                    let d = this.b6._inner[c];
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
        }
        al(a) {
            super.al(a);
            for (let b = 0; b < this.b6.count; b++) {
                this.e.a6.exportPathData(a, this.b6._inner[b], "crosshairLine", ["Main", "Crosshair"]);
            }
        }
    }
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
})();
//# sourceMappingURL=CrosshairLayer_combined.js.map
