/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, Base, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Date_$type, markDep, Delegate_$type } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core";
import { IFastItemColumn$1_$type } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-angular-core";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FastReflectionHelper } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-angular-core";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { dateToStringFormat } from "igniteui-angular-core";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { SRProvider } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FinancialEventArgs = /*@__PURE__*/ (() => {
    class FinancialEventArgs extends EventArgs {
        constructor(a, b, c, d, e) {
            super();
            this._position = 0;
            this._count = 0;
            this._dataSource = null;
            this._supportingCalculations = null;
            this._basedOn = null;
            this.position = a;
            this.count = b;
            this.dataSource = c;
            this.supportingCalculations = d;
            if (c != null) {
                c.series = e;
            }
        }
        get position() {
            return this._position;
        }
        set position(a) {
            this._position = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get dataSource() {
            return this._dataSource;
        }
        set dataSource(a) {
            this._dataSource = a;
        }
        get supportingCalculations() {
            return this._supportingCalculations;
        }
        set supportingCalculations(a) {
            this._supportingCalculations = a;
        }
        get basedOn() {
            return this._basedOn;
        }
        set basedOn(a) {
            this._basedOn = a;
        }
    }
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
})();
/**
 * @hidden
 */
export let FinancialBucketCalculator = /*@__PURE__*/ (() => {
    class FinancialBucketCalculator extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.c = 0;
            this.d = 0;
            this.b = 0;
            if (a == null) {
                throw new ArgumentNullException(0, "view");
            }
            this.a = a;
            this.c = -1;
            this.d = this.d;
            this.b = 0;
        }
        getBucket(a) {
            return null;
        }
        getBucketWithoutUnknowns(a) {
            return this.getBucket(a);
        }
        getErrorBucket(a, b) {
            return NaN;
        }
        getBucketInfo(a, b, c, d) {
            a = this.c;
            b = this.d;
            c = this.b;
            d = this.a.bz.gh;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        }
        e(a) {
            let b = this.a.bv;
            let c = this.a.bu;
            let d = this.a.bu;
            if (this.a.bz != null) {
                d = this.a.bz.getEffectiveViewport1(this.a);
            }
            if (b.isEmpty || c.isEmpty || this.a.bz.pq == null) {
                this.b = 0;
                return;
            }
            let e = (this.a.bz.pq != null) ? this.a.bz.pq.cc : false;
            let f = new ScalerParams(0, b, c, e, d);
            let g = this.a.bz.o7(this.a);
            let h = typeCast(ISortingAxis_$type, this.a.bz.pq);
            if (h == null || h.i$b == null) {
                let i = Math.floor(this.a.bz.pq.eb(g.left, f));
                let j = Math.ceil(this.a.bz.pq.eb(g.right, f));
                if (this.a.bz.pq.cc) {
                    j = Math.ceil(this.a.bz.pq.eb(g.left, f));
                    i = Math.floor(this.a.bz.pq.eb(g.right, f));
                }
                let k = Math.floor((j - i + 1) * a / g.width);
                this.b = truncate(Math.max(1, k));
                this.c = truncate(Math.floor(i / this.b));
                this.d = truncate(Math.ceil(j / this.b));
            }
            else {
                this.c = h.i$e(b, c, d, g);
                this.d = h.i$g(b, c, d, g);
                this.b = 1;
            }
        }
        cacheValues() {
        }
        unCacheValues() {
        }
    }
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
})();
/**
 * @hidden
 */
export let FinancialSeries = /*@__PURE__*/ (() => {
    class FinancialSeries extends Series {
        constructor() {
            super();
            this.qh = null;
            this.qf = null;
            this.qg = null;
            this.qe = null;
            this.qi = null;
            this.qr = false;
            this.assigningCategoryStyle = null;
            this.pz = null;
            this.q1 = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
            this.q2 = new Dictionary$2(String_$type, String_$type, 0);
            this.qq = false;
            this.qa = null;
            this.pu = null;
            this.pw = null;
            this.ps = null;
            this.p2 = null;
            this.typical = null;
            this.typicalBasedOn = null;
            this.qp = false;
            this.re = null;
            this.rc = null;
            this.rd = null;
            this.rb = null;
            this.rf = null;
            this.pv = null;
            this.pr = null;
            this.px = 0;
            this.qb = null;
            this.qd = null;
            this.pz = new CategorySeriesRenderManager();
            this.qr = false;
            this.p2 = new CategoryTransitionSourceFramePreparer();
            this.pv = new CategoryFrame(3);
            this.ab = FinancialSeries.$;
            this.py = 0;
        }
        lh(a) {
            super.lh(a);
            this.p7 = a;
        }
        get_di() {
            return true;
        }
        ag() {
            return [this.pq, this.qc];
        }
        hk(a, b) {
            let c = this.ja(b);
            if (c == FinancialSeries.$$p[6]) {
                return this.hl(a, b, this.r6);
            }
            if (c == FinancialSeries.$$p[1]) {
                return this.hl(a, b, this.rx);
            }
            if (c == FinancialSeries.$$p[4]) {
                return this.hl(a, b, this.r2);
            }
            if (c == FinancialSeries.$$p[0]) {
                return this.hl(a, b, this.ru);
            }
            if (c == FinancialSeries.$$p[8]) {
                return this.hl(a, b, this.sa);
            }
            return super.hk(a, b);
        }
        rq() {
            return 2;
        }
        ro() {
            return 4;
        }
        ah(a) {
            let b = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), this.o5(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            let g = this.rq();
            f[0] = { $type: Point_$type, x: c[0], y: c[g] };
            f[1] = { $type: Point_$type, x: d[0], y: d[g] };
            e[0] = f;
            return e;
        }
        ai(a) {
            let b = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), this.o5(a), true);
            if (b == null) {
                return null;
            }
            let c = b[0];
            let d = b[1];
            let e = new Array(1);
            let f = new Array(2);
            f[0] = { $type: Point_$type, x: c[0], y: c[1] };
            f[1] = { $type: Point_$type, x: d[0], y: d[1] };
            e[0] = f;
            return e;
        }
        op() {
            return this.sw;
        }
        oq() {
            return this.sw;
        }
        ke() {
            super.ke();
            this.pq = null;
            this.qc = null;
        }
        get qm() {
            return this.qh;
        }
        set qm(a) {
            if (this.qh != a) {
                let b = this.qh;
                this.qh = a;
                this.raisePropertyChanged("OpenColumn", b, this.qh);
            }
        }
        get qk() {
            return this.qf;
        }
        set qk(a) {
            if (this.qf != a) {
                let b = this.qf;
                this.qf = a;
                this.raisePropertyChanged("HighColumn", b, this.qf);
            }
        }
        get ql() {
            return this.qg;
        }
        set ql(a) {
            if (this.qg != a) {
                let b = this.qg;
                this.qg = a;
                this.raisePropertyChanged("LowColumn", b, this.qg);
            }
        }
        get qj() {
            return this.qe;
        }
        set qj(a) {
            if (this.qe != a) {
                let b = this.qe;
                this.qe = a;
                this.raisePropertyChanged("CloseColumn", b, this.qe);
            }
        }
        get qo() {
            return this.qi;
        }
        set qo(a) {
            if (this.qi != a) {
                let b = this.qi;
                this.qi = a;
                this.raisePropertyChanged("VolumeColumn", b, this.qi);
            }
        }
        qy() {
            return (this.assigningCategoryStyle != null && this.qr) || this.bj != 1;
        }
        si(a) {
            if (this.assigningCategoryStyle != null && this.qr) {
                this.assigningCategoryStyle(this, a);
            }
        }
        sg(a, b, c, d, e, f) {
            let g = this.bj != 1;
            this.pz.a1(this.pz.b, d.ch, a, b, c, d, e, f, false);
            this.pz.ab(this.fj);
            let h = this.pz.aw;
            let i = null;
            let j = this.ch;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.si(h);
            this.pz.z(this, i, f, g, b < 0);
        }
        rg(a) {
            return this.fy(a, this.pq);
        }
        g6(a, b) {
            return this.g7(a, b, this.pq, runOn(this, this.rg), new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo));
        }
        g4(a, b) {
            return this.g5(a, b, this.pq, runOn(this, this.rg), new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo));
        }
        fu(a, b, c, d, e) {
            if (c == null) {
                return Number.POSITIVE_INFINITY;
            }
            let f = this.pq.kq;
            return this.fv(a, b, this.pq, d, e, f, runOn(this, this.rg));
        }
        getOffsetValue() {
            return this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        }
        getCategoryWidth() {
            return this.pq.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        }
        o2(a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, null, null, null);
        }
        f8(a, b, c) {
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo), a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        f4(a, b, c) {
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qk, a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        f6(a, b, c) {
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.ql, a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        ri(a, b, c) {
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qj, a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        rj(a, b, c) {
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qm, a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        rk(a, b, c) {
            let d = this.getEffectiveViewport1(this.bx);
            let e = this.rh(this.bx.bv, this.bx.bu, d);
            let f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qo, a, this.pq, f, e, runOn(this, this.rg), b, c);
        }
        oy(a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.f4), (d, e) => this.g7(d, e, this.pq, runOn(this, this.rg), this.qk), (d, e) => this.g5(d, e, this.pq, runOn(this, this.rg), this.qk));
        }
        o0(a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.f6), (d, e) => this.g7(d, e, this.pq, runOn(this, this.rg), this.ql), (d, e) => this.g5(d, e, this.pq, runOn(this, this.rg), this.ql));
        }
        sy(a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.rj), (d, e) => this.g7(d, e, this.pq, runOn(this, this.rg), this.qm), (d, e) => this.g5(d, e, this.pq, runOn(this, this.rg), this.qm));
        }
        sx(a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.ri), (d, e) => this.g7(d, e, this.pq, runOn(this, this.rg), this.qj), (d, e) => this.g5(d, e, this.pq, runOn(this, this.rg), this.qj));
        }
        sz(a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, runOn(this, this.rk), (d, e) => this.g7(d, e, this.pq, runOn(this, this.rg), this.qo), (d, e) => this.g5(d, e, this.pq, runOn(this, this.rg), this.qo));
        }
        ky() {
            super.ky();
            if (this.pq != null) {
                this.pq.hq(false);
            }
            if (this.qc != null) {
                this.qc.hq(false);
            }
        }
        mn(a, b) {
            this.p7.bx.e(this.gh);
            this.l0(false);
        }
        mm(a, b) {
            if (this.eu && this.gn < 0.05) {
                this.ev = true;
            }
            this.p7.bx.e(this.gh);
            this.l0(false);
        }
        qn(a, b, c) {
            let d = this.ce(b);
            this.q1.addItem(d, b);
            this.q2.addItem(b, c);
            return d;
        }
        sf(a, b) {
            if (b == null) {
                return;
            }
            a.deregisterColumn(b);
            let c = this.q1.item(b);
            this.q2.removeItem(c);
            this.q1.removeItem(b);
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case "SyncLink":
                    if (this.b5 != null && this.ca != null) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        if (this.pq != null) {
                            this.pq.bx(this);
                        }
                        if (this.qc != null) {
                            this.qc.bx(this);
                        }
                    }
                    if (c == null && d != null) {
                        if (this.pq != null) {
                            this.pq.cn(this);
                        }
                        if (this.qc != null) {
                            this.qc.cn(this);
                        }
                    }
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                    break;
                case "FastItemsSource":
                    this.qq = true;
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        this.sf(typeCast(IFastItemsSource_$type, c), this.qm);
                        this.sf(typeCast(IFastItemsSource_$type, c), this.qk);
                        this.sf(typeCast(IFastItemsSource_$type, c), this.ql);
                        this.sf(typeCast(IFastItemsSource_$type, c), this.qj);
                        this.sf(typeCast(IFastItemsSource_$type, c), this.qo);
                        this.qm = null;
                        this.qk = null;
                        this.ql = null;
                        this.qj = null;
                        this.qo = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        if (stringIsNullOrEmpty(this.r6) == false) {
                            this.qm = this.qn(typeCast(IFastItemsSource_$type, d), this.r6, "OpenColumn");
                        }
                        if (stringIsNullOrEmpty(this.rx) == false) {
                            this.qk = this.qn(typeCast(IFastItemsSource_$type, d), this.rx, "HighColumn");
                        }
                        if (stringIsNullOrEmpty(this.r2) == false) {
                            this.ql = this.qn(typeCast(IFastItemsSource_$type, d), this.r2, "LowColumn");
                        }
                        if (stringIsNullOrEmpty(this.ru) == false) {
                            this.qj = this.qn(typeCast(IFastItemsSource_$type, d), this.ru, "CloseColumn");
                        }
                        if (stringIsNullOrEmpty(this.sa) == false) {
                            this.qo = this.qn(typeCast(IFastItemsSource_$type, d), this.sa, "VolumeColumn");
                        }
                    }
                    this.qq = false;
                    if (this.qc != null && !this.qc.cv()) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[6]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qm);
                        this.qm = this.qn(this.ch, this.r6, "OpenColumn");
                    }
                    break;
                case "OpenColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[1]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qk);
                        this.qk = this.qn(this.ch, this.rx, "HighColumn");
                    }
                    break;
                case "HighColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[4]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.ql);
                        this.ql = this.qn(this.ch, this.r2, "LowColumn");
                    }
                    break;
                case "LowColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[0]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qj);
                        this.qj = this.qn(this.ch, this.ru, "CloseColumn");
                    }
                    break;
                case "CloseColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    this.sk();
                    break;
                case FinancialSeries.$$p[8]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qo);
                        this.qo = this.qn(this.ch, this.sa, "VolumeColumn");
                    }
                    break;
                case "VolumeColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[9]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                    this.k7();
                    this.qb = typeCast(ITimeRangeSelectorAxis_$type, this.pq);
                    break;
                case FinancialSeries.$$p[10]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.p7.bx.e(this.gh);
                    if (this.qc != null) {
                        this.qc.cv();
                    }
                    {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.pw.c(this.gn, this.pu, this.ps);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.ps.v();
                        this.sj(this.ps, this.p7);
                        if (this.eu) {
                            this.eu = false;
                            this.ki();
                            this.cb.r = truncate(this.gb());
                            this.cb.b = this.cc;
                        }
                    }
                    else {
                        this.sj(this.pw, this.p7);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case FinancialSeries.$$p[5]:
                    this.l0(false);
                    break;
                case "IsCustomCategoryStyleAllowed":
                    this.qr = this.qu();
                    this.l0(false);
                    break;
                case "CategoryMode":
                    if (this.pq != null) {
                        this.pq.le(true);
                    }
                    break;
            }
        }
        qt(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        qs(a) {
            if (typeCast(CategoryXAxis.$, a) !== null || a.b9) {
                return true;
            }
            return false;
        }
        pj(a, b, c) {
            if (b < a || a < 0 || a > this.ch.count || b < 0 || b > this.ch.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.ch;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ch.item(g);
            }
            return d;
        }
        rn(a) {
            return a.bx.b;
        }
        rp(a) {
            return a.bx.c;
        }
        pi(a, b) {
            return this.pj(a, b, this.qc);
        }
        get_dr() {
            return true;
        }
        kf() {
            super.kf();
            this.qa = null;
        }
        av(a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                let d = this.p9(a, b, this.qa);
                this.qa = d;
                return d;
            }
            else {
                let e = this.p8(a, b, this.qa);
                this.qa = e;
                return e;
            }
        }
        rr(a) {
            let b = this.pt();
            let c = this.bx.bu;
            let d = this.bx.bv;
            let e = this.pq;
            let f = 0;
            if (e.cj) {
                let g = (a.y - d.top) / d.height;
                f = g * c.height + c.top;
            }
            else {
                let h = (a.x - d.left) / d.width;
                f = h * c.width + c.left;
            }
            let i = b.f.count;
            let j = 0;
            for (j = 0; j < i; j++) {
                let k = b.f._inner[j];
                let l = null;
                if (j < i - 1) {
                    l = b.f._inner[j + 1];
                }
                if (k[0] <= f && l == null || l[0] >= f) {
                    if (l != null) {
                        if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                            return j;
                        }
                        else {
                            return j + 1;
                        }
                    }
                    else {
                        return j;
                    }
                }
            }
            return j;
        }
        p9(a, b, c) {
            let d = this.ch.count;
            let e = this.p7.bx.c;
            let f = this.p7.bx.d;
            let g = this.p7.bx.b;
            let h = this.pq;
            let i = -1;
            let j = -1;
            if (h.ch) {
                let k = this.pt();
                let l = this.rr(b);
                i = l;
                j = l;
            }
            else {
                let m = this.g0(b);
                i = truncate(Math.floor((intDivide(m, g)))) * g;
                j = i + (g - 1);
            }
            if (c != null && c.h == i && c.g == j) {
                return c;
            }
            let n = new HighlightingInfo();
            n.b = this;
            n.h = i;
            n.g = j;
            return n;
        }
        p8(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        qu() {
            return this.qw;
        }
        fw(a) {
            let b = this.bx.bv;
            let c = this.bx.bu;
            let d = -1;
            if (!b.isEmpty && !c.isEmpty && this.pq != null) {
                let e = this.getEffectiveViewport1(this.bx);
                let f = new ScalerParams(0, b, c, this.pq.cc, e);
                let g = this.o7(this.bx);
                let h = this.pq.eb(g.left, f);
                let i = this.pq.eb(g.right, f);
                let j = (a.x - b.left) / b.width;
                let k = h + (j * (i - h));
                if (this.pq.categoryMode != 0) {
                    k -= 0.5;
                }
                d = k;
            }
            return d;
        }
        g0(a) {
            return truncate(Math.round(this.fw(a)));
        }
        get_d3() {
            return typeCast(ISortingAxis_$type, this.pq) !== null;
        }
        ar() {
            return this.pq;
        }
        g2(a) {
            let b = this.bx.bv;
            let c = this.bx.bu;
            let d = this.getEffectiveViewport1(this.bx);
            if (b.isEmpty || c.isEmpty) {
                return -1;
            }
            let e = new Rect(0, 0, 0, 1, 1);
            let f = new ScalerParams(0, b, c, this.pq.cc, d);
            let g = typeCast(ISortingAxis_$type, this.pq);
            let h = this.o7(this.bx);
            let i = h.left;
            let j = h.right;
            let k = this.ox(a).x;
            let l = this.pq.eb(k, f);
            let m = this.pq.eb(i, f);
            let n = this.pq.eb(j, f);
            l = Math.max(m, Math.min(n, l));
            let o = g.i$f(l);
            return o;
        }
        hh(a) {
            let b = 0;
            if (typeCast(ISortingAxis_$type, this.pq) !== null) {
                b = this.g2(a);
                if (b == -1) {
                    return null;
                }
            }
            else {
                b = this.g0(a);
            }
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        }
        pt() {
            let a = this.ps;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.pw;
            }
            return a;
        }
        rh(a, b, c) {
            if (this.pq == null) {
                return 0;
            }
            return this.pq.kj(a, b, c, this.g9);
        }
        ek() {
            return this.qx;
        }
        p0() {
            return 11;
        }
        b6() {
            return 3;
        }
        sj(a, b) {
            this.o6 = a.aa;
            b.au();
        }
        sh(a, b) {
            a.u();
        }
        e3(a, b, c) {
            let d = super.e3(a, b, c);
            let e = c;
            if (this.ch == null || this.ch.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.pq == null || this.qc == null || e.bx.b < 1 || this.pq.bh == null || this.qc.bh == null || this.qc.kv == this.qc.ku || this.pq.itemsSource == null || this.pq.kq < 1) {
                e.bx.b = 0;
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            b = this.bx.bv;
            a = this.bx.bu;
            return {
                p0: a,
                p1: b
            };
        }
        rl(a) {
            let b = 0;
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(this.bx);
            if (!c.isEmpty && !d.isEmpty && this.qc != null) {
                let f = new ScalerParams(0, c, d, this.qc.cc, e);
                f.b = this.f2();
                b = this.qc.d8(this.qc.k5, f);
            }
            return b;
        }
        ki() {
            super.ki();
            this.pu.v();
            this.ps.v();
            this.pw.v();
        }
        l1(a) {
            super.l1(a);
            this.p7.bx.e(this.gh);
            if (this.ct(this.bx)) {
                return;
            }
            if (this.em) {
                if (this.cr()) {
                    this.sj(this.pw, this.p7);
                }
                else {
                    this.sj(this.ps, this.p7);
                }
                return;
            }
            if (this.ei(a)) {
                let b = this.pu;
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.pu = this.pw;
                    this.pw = b;
                }
                else {
                    this.pu = this.ps;
                    this.ps = b;
                }
                this.sh(this.ps, this.p7);
                if (this.ew) {
                    this.cb.w();
                    this.cb.r = truncate(this.gc());
                    this.cb.b = this.cd != null ? this.cd : this.cc;
                    this.p2.p(this.pu, this.ps, this.isVertical, this.pq, this.qc, this.p1, this.p0(), this.b7, this.b6(), () => this.rl(this.p7), this.p7.bu);
                }
                this.kd();
                this.l8();
                if (this.ew) {
                    this.ev = false;
                    this.eu = true;
                }
            }
            else {
                this.sh(this.ps, this.p7);
                this.sj(this.ps, this.p7);
            }
        }
        qz(a) {
            for (let b of fromEnum(a)) {
                switch (b) {
                    case "HighColumn":
                        if (this.qk == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.ql == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.qm == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.qj == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.qo == null) {
                            return false;
                        }
                        break;
                }
            }
            return true;
        }
        get q0() {
            return this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null;
        }
        qv() {
            return this.typical != null;
        }
        se(a) {
            this.typical(this, a);
        }
        get q8() {
            return this.q5();
        }
        *_q5() {
            let a = false;
            if (this.qv()) {
                let b = this.p3(0, this.ch.count);
                this.se(new FinancialEventArgs(0, this.ch.count, b, this.p4(b), this));
                if (b.typicalColumn != null) {
                    a = true;
                    for (let c of fromEnum(b.typicalColumn)) {
                        yield c;
                    }
                }
            }
            if (!a) {
                if (this.q0 && this.pq.i$b != null) {
                    let d = this.ch.count;
                    let e = this.pq.i$b;
                    for (let f = 0; f < d; ++f) {
                        yield (this.qk.item(e.item(f)) + this.ql.item(e.item(f)) + this.qj.item(e.item(f))) / 3;
                    }
                }
                else {
                    let g = this.ch.count;
                    for (let h = 0; h < g; ++h) {
                        yield (this.qk.item(h) + this.ql.item(h) + this.qj.item(h)) / 3;
                    }
                }
            }
        }
        q5() {
            return toEnum(() => this._q5());
        }
        get q7() {
            return this.q4();
        }
        *_q4() {
            if (this.q0 && this.pq.i$b != null) {
                let a = this.qk.count;
                let b = this.pq.i$b;
                if (a > 0) {
                    yield this.rm(this.qk.item(b.item(0)) - this.ql.item(b.item(0)));
                }
                for (let c = 1; c < a; ++c) {
                    yield Math.max(this.rm(this.qk.item(b.item(c)) - this.ql.item(b.item(c))), Math.max(this.rm(Math.abs(this.qk.item(b.item(c)) - this.qj.item(b.item(c - 1)))), this.rm(Math.abs(this.ql.item(b.item(c)) - this.qj.item(b.item(c - 1))))));
                }
            }
            else {
                let d = this.qk.count;
                if (d > 0) {
                    yield this.rm(this.qk.item(0) - this.ql.item(0));
                }
                for (let e = 1; e < d; ++e) {
                    yield Math.max(this.rm(this.qk.item(e) - this.ql.item(e)), Math.max(this.rm(Math.abs(this.qk.item(e) - this.qj.item(e - 1))), this.rm(Math.abs(this.ql.item(e) - this.qj.item(e - 1)))));
                }
            }
        }
        q4() {
            return toEnum(() => this._q4());
        }
        get q6() {
            return this.q3();
        }
        *_q3() {
            if (this.q0 && this.pq.i$b != null) {
                let a = this.ql.count;
                let b = this.pq.i$b;
                if (a > 0) {
                    yield this.rm(this.ql.item(b.item(0)));
                }
                for (let c = 1; c < a; c++) {
                    yield Math.min(this.rm(this.ql.item(b.item(c))), this.rm(this.qj.item(b.item(c - 1))));
                }
            }
            else {
                let d = this.ql.count;
                if (d > 0) {
                    yield this.rm(this.ql.item(0));
                }
                for (let e = 1; e < d; e++) {
                    yield Math.min(this.rm(this.ql.item(e)), this.rm(this.qj.item(e - 1)));
                }
            }
        }
        q3() {
            return toEnum(() => this._q3());
        }
        ra(a) {
            if (a == null) {
                return null;
            }
            if (this.q0 && this.pq.i$b != null) {
                return new SafeSortedReadOnlyDoubleCollection(0, a, this.pq.i$b);
            }
            return new SafeReadOnlyDoubleCollection(0, a);
        }
        q9() {
            let a = new List$1(String_$type, 0);
            a.add("HighColumn");
            a.add("LowColumn");
            a.add("CloseColumn");
            if (this.typicalBasedOn != null && this.ch != null && !this.qp) {
                this.qp = true;
                let b = this.p3(0, this.ch.count);
                this.qp = false;
                let c = new FinancialEventArgs(0, this.ch.count, b, this.p4(b), this);
                this.typicalBasedOn(this, c);
                if (c.basedOn != null && c.basedOn.count > 0) {
                    return c.basedOn;
                }
            }
            return a;
        }
        getOpenColumnAsArray() {
            if (this.qm == null) {
                return null;
            }
            if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.re != null) {
                    return this.re.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qm.count);
                let b = this.pq.i$b;
                let c = this.qm.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.re = a;
                return this.re.asArray();
            }
            else {
                return this.qm.asArray();
            }
        }
        getHighColumnAsArray() {
            if (this.qk == null) {
                return null;
            }
            if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rc != null) {
                    return this.rc.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qk.count);
                let b = this.pq.i$b;
                let c = this.qk.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rc = a;
                return this.rc.asArray();
            }
            else {
                return this.qk.asArray();
            }
        }
        getLowColumnAsArray() {
            if (this.ql == null) {
                return null;
            }
            if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rd != null) {
                    return this.rd.asArray();
                }
                let a = new List$1(Number_$type, 2, this.ql.count);
                let b = this.pq.i$b;
                let c = this.ql.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rd = a;
                return this.rd.asArray();
            }
            else {
                return this.ql.asArray();
            }
        }
        getCloseColumnAsArray() {
            if (this.qj == null) {
                return null;
            }
            if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rb != null) {
                    return this.rb.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qj.count);
                let b = this.pq.i$b;
                let c = this.qj.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rb = a;
                return this.rb.asArray();
            }
            else {
                return this.qj.asArray();
            }
        }
        getVolumeColumnAsArray() {
            if (this.qo == null) {
                return null;
            }
            if (this.pq != null && typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rf != null) {
                    return this.rf.asArray();
                }
                let a = new List$1(Number_$type, 2, this.qo.count);
                let b = this.pq.i$b;
                let c = this.qo.asArray();
                for (let d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rf = a;
                return this.rf.asArray();
            }
            else {
                return this.qo.asArray();
            }
        }
        kk(a, b, c, d) {
            super.kk(a, b, c, d);
            if (this.pq == null || !(typeCast(ISortingAxis_$type, this.pq) !== null)) {
                return;
            }
            let e = this.pq.i$b;
            switch (a) {
                case 1:
                    for (let f = b; f < c; f++) {
                        let g = e._inner[f];
                        if (this.re != null) {
                            this.re.insert(f, this.qm.item(g));
                        }
                        if (this.rc != null) {
                            this.rc.insert(f, this.qk.item(g));
                        }
                        if (this.rd != null) {
                            this.rd.insert(f, this.ql.item(g));
                        }
                        if (this.rb != null) {
                            this.rb.insert(f, this.qj.item(g));
                        }
                        if (this.rf != null) {
                            this.rf.insert(f, this.qo.item(g));
                        }
                    }
                    break;
                case 0:
                    if (this.re != null) {
                        this.re.v(b, c);
                    }
                    if (this.rc != null) {
                        this.rc.v(b, c);
                    }
                    if (this.rd != null) {
                        this.rd.v(b, c);
                    }
                    if (this.rb != null) {
                        this.rb.v(b, c);
                    }
                    if (this.rf != null) {
                        this.rf.v(b, c);
                    }
                    break;
                case 4:
                    if (this.re != null) {
                        this.re = new List$1(Number_$type, 0);
                    }
                    if (this.rc != null) {
                        this.rc = new List$1(Number_$type, 0);
                    }
                    if (this.rd != null) {
                        this.rd = new List$1(Number_$type, 0);
                    }
                    if (this.rb != null) {
                        this.rb = new List$1(Number_$type, 0);
                    }
                    if (this.rf != null) {
                        this.rf = new List$1(Number_$type, 0);
                    }
                    break;
                case 3:
                case 2:
                    for (let h = b; h < c; h++) {
                        let i = e._inner[h];
                        if (this.re != null) {
                            this.re._inner[h] = this.qm.item(i);
                        }
                        if (this.rc != null) {
                            this.rc._inner[h] = this.qk.item(i);
                        }
                        if (this.rd != null) {
                            this.rd._inner[h] = this.ql.item(i);
                        }
                        if (this.rb != null) {
                            this.rb._inner[h] = this.qj.item(i);
                        }
                        if (this.rf != null) {
                            this.rf._inner[h] = this.qo.item(i);
                        }
                    }
                    break;
            }
            this.sk();
            this.mj();
        }
        p3(a, b) {
            let c = this.ra(this.qm);
            let d = this.ra(this.qj);
            let e = this.ra(this.qk);
            let f = this.ra(this.ql);
            let g = this.ra(this.qo);
            let h = ((() => {
                let $ret = new FinancialCalculationDataSource();
                $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(this.q8), this.q9());
                $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(this.q7), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("HighColumn");
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(this.q6), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.openColumn = c;
                $ret.closeColumn = d;
                $ret.highColumn = e;
                $ret.lowColumn = f;
                $ret.volumeColumn = g;
                $ret.calculateFrom = a;
                $ret.calculateCount = b;
                $ret.minimumValue = NaN;
                $ret.maximumValue = NaN;
                $ret.count = this.ch != null ? this.ch.count : 0;
                return $ret;
            })());
            return h;
        }
        rm(a) {
            if (isInfinity(a) || isNaN_(a)) {
                return 0;
            }
            return a;
        }
        p4(a) {
            return ((() => {
                let $ret = new FinancialCalculationSupportingCalculations();
                $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
                $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
                $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
                $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
                $ret.h = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.shortPeriod), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.f = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.longPeriod), ((() => {
                    let $ret = new List$1(String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.g = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.shortPeriod), a.typicalColumn.basedOn);
                $ret.e = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.longPeriod), a.typicalColumn.basedOn);
                $ret.k = Series.e8;
                $ret.j = Series.e7;
                $ret.i = runOn(this, this.rm);
                return $ret;
            })());
        }
        get categoryAxis() {
            return this.pq;
        }
        l2(a, b) {
            super.l2(a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            let c = typeCast(FinancialSeriesView.$, this.bw);
            this.bx.a2(b);
            c.bx.e(this.gh);
            if (this.ct(this.bw)) {
                return;
            }
            if (!this.en) {
                this.sh(this.pv, c);
            }
            this.en = false;
            this.sj(this.pv, c);
            this.et = false;
        }
        lz(a, b, c, d, e) {
            super.lz(a, b, c, d, e);
            let f = this.a4.a$h.item(d);
            let g = f;
            g.bx.e(this.gh);
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.pr == null) {
                this.pr = new CategoryFrame(3);
            }
            this.pr.u();
            this.sh(this.pr, g);
            this.sj(this.pr, g);
        }
        an(a) {
            if (this.pq == a) {
                return this.qc;
            }
            if (this.qc == a) {
                return this.pq;
            }
            return null;
        }
        preferredCategoryMode(a) {
            let b = typeCast(IDateTimeAxis_$type, this.pq);
            return b != null ? b.preferredCategoryMode(this) : this.py;
        }
        get py() {
            return this.px;
        }
        set py(a) {
            let b = this.py;
            if (a != b) {
                this.px = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.py));
            }
        }
        get_dx() {
            return true;
        }
        l5(a, b) {
            super.l5(a, b);
            this.sw = a;
        }
        sk() {
            this.fs = this.qj == null || this.qj.count == 0 ? NaN : this.qj.item(this.qj.count - 1);
        }
        hj(a) {
            if (this.qb != null && a != null) {
                if (this.qd == null || this.qd.propertyName != this.qb.dateTimeMemberPath) {
                    this.qd = new FastReflectionHelper(false, this.qb.dateTimeMemberPath);
                }
                let b = this.qd.getPropertyValue(a);
                if (typeCast(Date_$type, b) !== null) {
                    return dateToStringFormat(b, this.qb.itemLabelFormat());
                }
            }
            return super.hj(a);
        }
    }
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:ru:sl', [2, null], 'HighMemberPath:rx:sm', [2, null], 'IsCustomCategoryStyleAllowed:qw:sn', [0, false], 'IsTransitionInEnabled:qx:so', [0, false], 'LowMemberPath:r2:sp', [2, null], 'NegativeBrush:sw:sq', [Brush.$, null], 'OpenMemberPath:r6:sr', [2, null], 'TransitionInMode:p1:ss', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:sa:st', [2, null], 'XAxis:pq:su', [CategoryAxisBase.$, null], 'YAxis:qc:sv', [NumericYAxis.$, null]]);
    return FinancialSeries;
})();
/**
 * @hidden
 */
export let FinancialCalculationSupportingCalculations = /*@__PURE__*/ (() => {
    class FinancialCalculationSupportingCalculations extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = null;
            this.d = null;
            this.b = null;
            this.h = null;
            this.f = null;
            this.g = null;
            this.e = null;
            this.k = null;
            this.j = null;
            this.i = null;
        }
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
})();
/**
 * @hidden
 */
export let DataSourceSupportingCalculation = /*@__PURE__*/ (() => {
    class DataSourceSupportingCalculation extends SupportingCalculation$1 {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = _rest[0];
                        super(Delegate_$type, 0, c);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        super(Delegate_$type, 1, c, d);
                    }
                    break;
            }
        }
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
})();
/**
 * @hidden
 */
export let FinancialCalculationDataSource = /*@__PURE__*/ (() => {
    class FinancialCalculationDataSource extends Base {
        constructor() {
            super(...arguments);
            this._openColumn = null;
            this._closeColumn = null;
            this._highColumn = null;
            this._lowColumn = null;
            this._volumeColumn = null;
            this._indicatorColumn = null;
            this._typicalColumn = null;
            this._trueRange = null;
            this._trueLow = null;
            this._period = 0;
            this._shortPeriod = 0;
            this._longPeriod = 0;
            this._count = 0;
            this._calculateFrom = 0;
            this._calculateCount = 0;
            this._multiplier = 0;
            this._minimumValue = 0;
            this._maximumValue = 0;
            this._specifiesRange = false;
            this._series = null;
        }
        get openColumn() {
            return this._openColumn;
        }
        set openColumn(a) {
            this._openColumn = a;
        }
        get closeColumn() {
            return this._closeColumn;
        }
        set closeColumn(a) {
            this._closeColumn = a;
        }
        get highColumn() {
            return this._highColumn;
        }
        set highColumn(a) {
            this._highColumn = a;
        }
        get lowColumn() {
            return this._lowColumn;
        }
        set lowColumn(a) {
            this._lowColumn = a;
        }
        get volumeColumn() {
            return this._volumeColumn;
        }
        set volumeColumn(a) {
            this._volumeColumn = a;
        }
        get indicatorColumn() {
            return this._indicatorColumn;
        }
        set indicatorColumn(a) {
            this._indicatorColumn = a;
        }
        get typicalColumn() {
            return this._typicalColumn;
        }
        set typicalColumn(a) {
            this._typicalColumn = a;
        }
        get trueRange() {
            return this._trueRange;
        }
        set trueRange(a) {
            this._trueRange = a;
        }
        get trueLow() {
            return this._trueLow;
        }
        set trueLow(a) {
            this._trueLow = a;
        }
        get period() {
            return this._period;
        }
        set period(a) {
            this._period = a;
        }
        get shortPeriod() {
            return this._shortPeriod;
        }
        set shortPeriod(a) {
            this._shortPeriod = a;
        }
        get longPeriod() {
            return this._longPeriod;
        }
        set longPeriod(a) {
            this._longPeriod = a;
        }
        get count() {
            return this._count;
        }
        set count(a) {
            this._count = a;
        }
        get calculateFrom() {
            return this._calculateFrom;
        }
        set calculateFrom(a) {
            this._calculateFrom = a;
        }
        get calculateCount() {
            return this._calculateCount;
        }
        set calculateCount(a) {
            this._calculateCount = a;
        }
        get multiplier() {
            return this._multiplier;
        }
        set multiplier(a) {
            this._multiplier = a;
        }
        get minimumValue() {
            return this._minimumValue;
        }
        set minimumValue(a) {
            this._minimumValue = a;
        }
        get maximumValue() {
            return this._maximumValue;
        }
        set maximumValue(a) {
            this._maximumValue = a;
        }
        get specifiesRange() {
            return this._specifiesRange;
        }
        set specifiesRange(a) {
            this._specifiesRange = a;
        }
        get series() {
            return this._series;
        }
        set series(a) {
            this._series = a;
        }
    }
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
})();
/**
 * @hidden
 */
export let FinancialSeriesView = /*@__PURE__*/ (() => {
    class FinancialSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.bz = null;
            this.bx = null;
            this.b1 = 0;
            this.b1 = -1;
            this.bz = a;
            this.bx = this.by();
        }
        b0(a) {
            if (this.b1 != a.t) {
                return true;
            }
            return false;
        }
        b2(a) {
            this.b1 = a.t;
        }
        as() {
            super.as();
            if (!this.q) {
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.bz.pq.b9) {
                a += "<span>${itemLabel}</span><br/>";
            }
            else if (this.bz.pq.fj != null) {
                a += "<span>${item." + this.bz.pq.fj + "}</span><br/>";
            }
            a += "<span class='ui-priority-primary'";
            let b = this.e.a4.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            let c = new SRProvider(this.w);
            let d = c.b1("financialSeries_Open");
            let e = c.b1("financialSeries_High");
            let f = c.b1("financialSeries_Low");
            let g = c.b1("financialSeries_Close");
            d = stringIsNullOrEmpty(d) ? "Open" : d;
            e = stringIsNullOrEmpty(e) ? "High" : e;
            f = stringIsNullOrEmpty(f) ? "Low" : f;
            g = stringIsNullOrEmpty(g) ? "Close" : g;
            a += ">" + this.bz.hp + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.bz.r6 + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.bz.rx + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.bz.r2 + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.bz.ru + "}</td></tr>";
            if (!stringIsNullOrEmpty(this.bz.sa)) {
                let h = c.b1("financialSeries_Volume");
                h = stringIsNullOrEmpty(h) ? "Volume" : h;
                a += "<tr><td>" + h + ":</td><td>" + "${item." + this.bz.sa + "}</td></tr>";
            }
            a += "</table></div>";
            return a;
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 2;
            this.e.gl = 2;
        }
    }
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
})();
//# sourceMappingURL=FinancialEventArgs_combined.js.map
