/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType } from "igniteui-angular-core";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { RangeInfo } from "./RangeInfo";
import { VerticalLogarithmicScaler } from "./VerticalLogarithmicScaler";
import { FastVerticalLinearScaler } from "./FastVerticalLinearScaler";
import { isNaN_ } from "igniteui-angular-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
export let NumericYAxis = /*@__PURE__*/ (() => {
    class NumericYAxis extends StraightNumericAxisBase {
        constructor() {
            super();
            this.ab = NumericYAxis.$;
            this.j6 = this.j4();
        }
        a3() {
            return new NumericYAxisView(this);
        }
        au() {
            return new VerticalAxisLabelPanel();
        }
        get_cj() {
            return true;
        }
        d7() {
            return this.js.height;
        }
        d8(a, b) {
            if (this.l5 != null) {
                return this.l5.p(a, b);
            }
            return this.l4.p(a, b);
        }
        g5(a, b, c, d) {
            if (this.l5 != null) {
                this.l5.v(a, b, c, d);
                return;
            }
            this.l4.v(a, b, c, d);
        }
        g4(a, b, c, d, e) {
            if (this.l5 != null) {
                this.l5.u(a, b, c, d, e);
                return;
            }
            this.l4.u(a, b, c, d, e);
        }
        eb(a, b) {
            if (this.l5 != null) {
                return this.l5.q(a, b);
            }
            return this.l4.q(a, b);
        }
        g6(a, b, c, d) {
            if (this.l5 != null) {
                this.l5.j(a, b, c, d);
                return;
            }
            this.l4.j(a, b, c, d);
        }
        mm(a, b) {
            if (this.bh == null || a == NaN || b == NaN) {
                return;
            }
            let c = this.ma(a, this);
            let d = this.ma(b, this);
            if (c == NaN || d == NaN) {
                return;
            }
            this.bh.pw = new Rect(0, this.bh.pw.x, d, this.bh.pw.width, c - d);
        }
        j4() {
            let a = super.j4();
            a.b.c = (b) => {
                if (this.ay == null || this.ay.visibility == 0) {
                    this.av.bc = b;
                    if (this.ay != null && (this.ay.location == 7 || this.ay.location == 6)) {
                        this.bh.jq();
                    }
                }
            };
            a.k = (b, c, d) => this.g8(c, d, b.z, b.b, false);
            a.l = (b, c, d, e) => this.g9(c, d, e, b.z);
            a.m = (b, c) => {
                let d = b.y;
                let e = new ScalerParams(0, b.aa, b.z, this.cd, d);
                return this.d8(c, e);
            };
            a.q = (b, c) => true;
            a.j = (b) => this.h1(b.t, b.n, b.z, b.a, true);
            a.e = (b) => {
                b.n = this.ay != null && (this.ay.location == 7 || this.ay.location == 3) ? b.z.right : b.z.left;
                let c = b.y;
                let d = new ScalerParams(0, b.aa, b.z, this.cd, c);
                if (this.ai != null && this.ai.bh != null) {
                    let e = b.n;
                    let f = b.r;
                    let g = this.hv(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                    e = g.p0;
                    f = g.p1;
                    b.n = e;
                    b.r = f;
                }
            };
            a.p = (b, c, d) => {
                let e = Math.round(c);
                return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
            };
            return a;
        }
        j7(a, b, c, d) {
            let e = d;
            let f = super.j7(a, b, c, d);
            let g = new ScalerParams(0, b, a, this.cc, c);
            let h = NaN;
            let i = NaN;
            if (!this.cc && b.top == 0) {
                i = this.ku;
            }
            else if (this.cc && b.bottom == 1) {
                h = this.ku;
            }
            if (isNaN_(h)) {
                h = this.eb(e.bottom, g);
            }
            if (isNaN_(i)) {
                i = this.eb(e.top, g);
            }
            let j = Math.min(h, i);
            let k = Math.max(h, i);
            this.ky = j;
            this.kx = k;
            let l = ((() => {
                let $ret = new RangeInfo();
                $ret.d = j;
                $ret.c = k;
                $ret.b = e.height;
                return $ret;
            })());
            f.k.add(l);
            return f;
        }
        hr(a) {
            super.hr(a);
            let b = this.bh != null ? this.bh.pg : Rect.empty;
            let c = this.js;
            let d = this.jn();
            let e = this.jm();
            let f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        }
        h3(a, b) {
            super.h3(a, b);
            if (b.height != a.height) {
                this.cv();
            }
        }
        get_a1() {
            return 1;
        }
        get a1() {
            return this.get_a1();
        }
        j9() {
            if (this.kk) {
                return new VerticalLogarithmicScaler();
            }
            switch (this.l3) {
                case 0: return new FastVerticalLinearScaler();
                case 1: return new VerticalLogarithmicScaler();
            }
            return null;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
    }
    NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericYAxis;
})();
/**
 * @hidden
 */
export let NumericYAxisView = /*@__PURE__*/ (() => {
    class NumericYAxisView extends StraightNumericAxisBaseView {
        constructor(a) {
            super(a);
            this.bi = null;
            this.bi = a;
        }
        ag() {
            super.ag();
            this.a.jb = AxisDefaults.h;
        }
    }
    NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
    return NumericYAxisView;
})();
//# sourceMappingURL=NumericYAxis_combined.js.map
