/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "igniteui-angular-core";
import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisLabellingMode_$type } from "./TimeAxisLabellingMode";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { EventArgs, runOn, delegateCombine, typeCast, enumGetBox, Date_$type, markType } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeXAxis } from "./TimeXAxis";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { truncate } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue, dateAdd, dateSubtract } from "igniteui-angular-core";
import { timeSpanFromMilliseconds, timeSpanTotalMilliseconds } from "igniteui-angular-core";
/**
 * @hidden
 */
export let OrdinalTimeXAxis = /*@__PURE__*/ (() => {
    class OrdinalTimeXAxis extends CategoryXAxis {
        constructor() {
            super();
            this.mk = dateMaxValue();
            this.mj = dateMinValue();
            this.mq = dateMaxValue();
            this.mp = dateMinValue();
            this.mm = dateMaxValue();
            this.ml = dateMinValue();
            this.m0 = null;
            this.mz = null;
            this.mf = 0;
            this.mh = null;
            this.md = null;
            this.m9 = 0;
            this.mo = dateMinValue();
            this.mn = dateMaxValue();
            this.visibleRangeChanged = null;
            FastItemDateTimeColumn.o();
            this.md = new TimeAxisLabelFormatCollection();
            let a = this.me;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.nb));
            this.l3 = 0;
        }
        ea(a, b, c) {
            return this.d8(a, new ScalerParams(0, b, c, this.cc, this.jn()));
        }
        d9(a, b, c) {
            return this.d8(a, b);
        }
        d8(a, b) {
            if (!b.c.isEmpty) {
                let c = this.mx(a, NumericScaler.ac, b.c);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.mx(a, b.e, b.d);
        }
        mx(a, b, c) {
            let d = this.l2;
            let e = this.l3;
            let f = this.l2 - this.l3;
            let g = f >= 1 ? (a - e) / (d - e) : f == 0 ? 0.5 : NaN;
            if (this.cd) {
                g = 1 - g;
            }
            return c.left + c.width * (g - b.left) / b.width;
        }
        g4(a, b, c, d, e) {
            let f;
            let g = e.e;
            let h = e.d;
            let i = e.c;
            let j = e.a;
            let k = !i.isEmpty;
            let l = i.left;
            let m = i.width;
            let n = g.left;
            let o = g.width;
            let p = h.left;
            let q = h.width;
            let r = 0;
            let s = 1;
            let t = this.l2;
            let u = this.l3;
            let v = this.l2 - this.l3;
            let w = this.ln(a);
            let x = w != null;
            for (let y = 0; y < b.count; y++) {
                let z = b.item(y);
                for (let aa = c; aa < d; aa++) {
                    f = x ? w[aa] : a.item(aa);
                    if (k) {
                        let ab = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = l + m * (ab - r) / s;
                        let ac = (ab - p) / q;
                        ac = p + q * (ac - n) / o;
                        f[z] = ac;
                    }
                    else {
                        let ad = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ad = 1 - ad;
                        }
                        ad = p + q * (ad - n) / o;
                        f[z] = ad;
                    }
                }
            }
        }
        g5(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.d8(a.item(e), d));
            }
        }
        ed(a, b, c) {
            return this.eb(a, new ScalerParams(0, b, this.js, this.cc, this.jn()));
        }
        getUnscaledValue3(a, b, c, d) {
            return this.eb(a, new ScalerParams(0, b, this.js, this.cc, this.jn()));
        }
        eb(a, b) {
            if (!b.c.isEmpty) {
                let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.my(c, NumericScaler.ac, b.c);
                return c;
            }
            return this.my(a, b.e, b.d);
        }
        my(a, b, c) {
            let d = b.left + (a - c.left) * b.width / c.width;
            if (this.cd) {
                d = 1 - d;
            }
            return this.l3 + d * (this.l2 - this.l3);
        }
        ec(a, b, c) {
            return this.eb(a, b);
        }
        g6(a, b, c, d) {
            for (let e = b; e < c; e++) {
                a.item(e, this.eb(a.item(e), d));
            }
        }
        he(a, b, c, d) {
            super.he(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.mi);
                        this.mi = null;
                    }
                    if (this.j6 != null) {
                        this.mi = TimeAxisBase.lq(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeMemberPath":
                    if (this.j6 != null) {
                        this.j6.deregisterColumn(this.mi);
                        this.mi = TimeAxisBase.lq(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeColumn":
                    this.cv();
                    this.m9 = this.m8();
                    break;
                case "MinimumValue":
                case "MaximumValue":
                    this.cv();
                    this.hp();
                    break;
                case "LabellingMode":
                    this.hp();
                    break;
            }
        }
        get actualMinimumValue() {
            return this.mk;
        }
        set actualMinimumValue(a) {
            this.mk = a;
        }
        get actualMaximumValue() {
            return this.mj;
        }
        set actualMaximumValue(a) {
            this.mj = a;
        }
        get visibleMinimum() {
            return this.mq;
        }
        set visibleMinimum(a) {
            this.mq = a;
        }
        get visibleMaximum() {
            return this.mp;
        }
        set visibleMaximum(a) {
            this.mp = a;
        }
        get mu() {
            return this.mm;
        }
        set mu(a) {
            this.mm = a;
        }
        get mt() {
            return this.ml;
        }
        set mt(a) {
            this.ml = a;
        }
        nc() {
            if (this.mi == null || this.mi.count == 0 || this.mi.count < this.l3 - 1) {
                this.actualMinimumValue = dateMinValue();
                this.actualMaximumValue = dateMaxValue();
                return;
            }
            let a = Math.max(0, Math.min(this.l3, this.mi.count - 1));
            let b = Math.max(0, Math.min(this.l2, this.mi.count - 1));
            let c = +(this.actualMinimumValue) != +(this.mi.item(a)) || +(this.actualMaximumValue) != +(this.mi.item(b));
            if (c) {
                let d = this.actualMinimumValue;
                let e = this.actualMaximumValue;
                this.actualMinimumValue = this.mi.item(a);
                this.actualMaximumValue = this.mi.item(b);
                this.nd();
            }
        }
        nd() {
            if (this.mi == null || this.mi.count == 0 || this.bh == null) {
                let a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
                this.visibleMinimum = this.actualMinimumValue;
                this.visibleMaximum = this.actualMaximumValue;
                this.mu = this.visibleMinimum;
                this.mt = this.visibleMaximum;
                if (a && this.visibleRangeChanged != null) {
                    this.visibleRangeChanged(this, EventArgs.empty);
                }
                return;
            }
            let b = this.jm();
            let c = new ScalerParams(1, this.bh.pw, this.bh.pv, this.cc);
            c.c = this.jn();
            let d = this.eb(b.left, c);
            let e = this.eb(b.right, c);
            let f = truncate(Math.floor(d));
            let g = truncate(Math.ceil(e));
            let h = f >= 0 && f < this.mi.count ? this.mi.item(f) : this.actualMinimumValue;
            let i = g >= 0 && g < this.mi.count ? this.mi.item(g) : this.actualMaximumValue;
            let j = h;
            let k = i;
            if (d > f) {
                let l = f + 1;
                let m = l >= 0 && l < this.mi.count ? this.mi.item(l) : i;
                let n = dateAdd(+h, +(timeSpanFromMilliseconds(timeSpanTotalMilliseconds((+m - +h)) * (d - f))));
                j = n;
            }
            if (e < g) {
                let o = g - 1;
                let p = o >= 0 && o < this.mi.count ? this.mi.item(o) : h;
                let q = dateSubtract(+i, +(timeSpanFromMilliseconds(timeSpanTotalMilliseconds((+i - +p)) * (g - e))));
                k = q;
            }
            this.mu = j;
            this.mt = k;
            let r = +(this.visibleMinimum) != +h || +(this.visibleMaximum) != +i;
            this.visibleMinimum = h;
            this.visibleMaximum = i;
            if (r && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, EventArgs.empty);
            }
        }
        hr(a) {
            let b = TimeXAxis.nt(this.actualMinimumValue, false, this.actualMinimumValue, this.mg, this.m7, this.me, this.e3);
            if (b != this.m0 && this.cy) {
                this.hu();
            }
            this.m0 = b;
            super.hr(a);
        }
        get dateTimeMemberPath() {
            return this.mz;
        }
        set dateTimeMemberPath(a) {
            let b = this.dateTimeMemberPath;
            if (a != b) {
                this.mz = a;
                this.hk("DateTimeMemberPath", b, this.dateTimeMemberPath);
            }
        }
        get mg() {
            return this.mf;
        }
        set mg(a) {
            let b = this.mg;
            if (a != b) {
                this.mf = a;
                this.hk("LabellingMode", enumGetBox(TimeAxisLabellingMode_$type, b), enumGetBox(TimeAxisLabellingMode_$type, this.mg));
            }
        }
        get mi() {
            return this.mh;
        }
        set mi(a) {
            if (this.mh != a) {
                let b = this.mh;
                this.mh = a;
                this.hk("DateTimeColumn", b, this.mh);
            }
        }
        h4(a, b) {
            super.h4(a, b);
            this.nd();
        }
        getWindowRectForSelection(a, b) {
            if (this.mi == null) {
                return Rect.empty;
            }
            let c = a > b;
            let d = c ? b : a;
            let e = c ? a : b;
            let f = -1;
            while (++f < this.mi.count && this.mi.item(f) < d) {
            }
            let g = this.mi.count;
            while (--g >= 0 && this.mi.item(g) > e) {
            }
            let h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.cc, this.bh.pk);
            let i = this.d8(f, h);
            let j = this.d8(g + 1, h);
            return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
        }
        get me() {
            return this.md;
        }
        nb(a, b) {
            this.hq(false);
        }
        hg(a) {
            super.hg(a);
            this.dateTimeMemberPath = a;
        }
        fi(a) {
            if (this.at != null) {
                return this.at(a);
            }
            if (this.ah != null) {
                return this.ah.i(a);
            }
            if (!(typeCast(Date_$type, a) !== null)) {
                return super.fi(a);
            }
            let b = dateMinValue();
            let c = false;
            if (this.l4 != null) {
                if (typeCast(Date_$type, this.l4) !== null) {
                    b = this.l4;
                    c = true;
                }
            }
            let d = TimeXAxis.no(a, c, b, this.mg, this.m7, this.me, this.e3);
            return d == null ? super.fi(a) : d;
        }
        fw(a) {
            let b = 0;
            if (this.categoryMode == 0) {
                b = truncate(Math.round(a));
            }
            else {
                b = truncate(Math.floor(a));
            }
            if (b < 0 || b > this.kr - 1) {
                return super.fw(a);
            }
            let c = this.mi.item(b);
            let d = this.fi(c);
            if (d == null) {
                return null;
            }
            return d.toString();
        }
        get na() {
            return +(this.visibleMaximum) - +(this.visibleMinimum);
        }
        get m7() {
            return +(this.mt) - +(this.mu);
        }
        lp() {
            return this.mi;
        }
        h3(a, b) {
            super.h3(a, b);
            this.nd();
        }
        lw(a, b) {
            let c = this.categoryMode == 0 ? 0 : 0.5;
            return super.lw(a + c, b);
        }
        lv(a, b, c, d) {
            return b;
        }
        m8() {
            if (this.mi == null || this.mi.count < 2) {
                return (0);
            }
            return TimeXAxis.nz((a) => this.mi.item(a), this.mi.count);
        }
        itemLabelFormat() {
            return TimeXAxis.nv(this.m9);
        }
        get minimumValue() {
            return this.mo;
        }
        set minimumValue(a) {
            let b = this.minimumValue;
            if (+a != +b) {
                this.mo = a;
                this.he(this, "MinimumValue", b, this.minimumValue);
            }
        }
        get maximumValue() {
            return this.mn;
        }
        set maximumValue(a) {
            let b = this.maximumValue;
            if (+a != +b) {
                this.mn = a;
                this.he(this, "MaximumValue", b, this.maximumValue);
            }
        }
        cx() {
            if (+(this.minimumValue) == +(dateMaxValue()) || +(this.maximumValue) == +(dateMinValue())) {
                return super.cx();
            }
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null || this.mi == null) {
                return false;
            }
            let a = this.l3;
            if (+(this.minimumValue) != +(dateMinValue())) {
                let b = -1;
                while (b++ <= this.mi.count) {
                    if (this.mi.item(b) >= this.minimumValue) {
                        break;
                    }
                }
                a = b;
            }
            let c = this.categoryMode == 0 ? this.j6.count - 1 : this.j6.count;
            if (+(this.maximumValue) != +(dateMaxValue())) {
                let d = this.j6.count;
                while (d-- > 0) {
                    if (this.mi.item(d) <= this.maximumValue) {
                        break;
                    }
                }
                c = d;
            }
            if (a != this.l3 || c != this.l2) {
                let e = new AxisRangeChangedEventArgs(0, this.l3, a, this.l2, c);
                this.l3 = a;
                this.l2 = c;
                this.hl(e);
                this.nc();
                this.k2();
                return true;
            }
            return false;
        }
        lb(a) {
            super.lb(a);
            this.cw(true);
        }
        get isVertical() {
            return this.cj;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
    }
    OrdinalTimeXAxis.$t = markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
    return OrdinalTimeXAxis;
})();
//# sourceMappingURL=OrdinalTimeXAxis.js.map
