/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { runOn, delegateRemove, delegateCombine, typeCast, Point_$type, markType, markDep } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { FastItemIntColumn } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { ColorUtil } from "igniteui-angular-core";
import { CustomPaletteColorScale } from "./CustomPaletteColorScale";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, intDivide } from "igniteui-angular-core";
import { boxArray$1 } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterAreaSeries = /*@__PURE__*/ (() => {
    class ScatterAreaSeries extends ScatterTriangulationSeries {
        constructor() {
            super();
            this.q1 = null;
            this.q6 = null;
            this.qz = null;
            this.q0 = null;
            FastItemIntColumn.m();
            this.ab = ScatterAreaSeries.$;
        }
        get_c7() {
            return true;
        }
        get q3() {
            return this.q1;
        }
        set q3(a) {
            let b = this.q1 != a;
            if (b) {
                let c = this.q1;
                if (this.q1 != null) {
                    let d = this.q1;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.rg));
                }
                this.q1 = a;
                if (this.q1 != null) {
                    let e = this.q1;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.rg));
                }
                this.raisePropertyChanged("ColorScale", c, this.q1);
            }
        }
        rg(a, b) {
            this.ri();
            this.l0(false);
        }
        hk(a, b) {
            let c = this.ja(b);
            if (c == ScatterAreaSeries.$$p[1]) {
                return this.hl(a, b, this.rb);
            }
            return super.hk(a, b);
        }
        get q7() {
            return this.q6;
        }
        set q7(a) {
            let b = this.q7 != a;
            if (b) {
                let c = this.q7;
                this.q6 = a;
                this.raisePropertyChanged("ColorColumn", c, this.q7);
            }
        }
        get_ex() {
            return true;
        }
        set_ex(a) {
            super.set_ex(a);
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.q7);
                        this.q7 = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.q7 = this.ce(this.rb);
                    }
                    this.l0(false);
                    break;
                case ScatterAreaSeries.$$p[1]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q7);
                        this.q7 = this.ce(this.rb);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "ColorScale":
                    this.ri();
                    this.l0(false);
                    this.k7();
                    break;
            }
        }
        l1(a) {
            super.l1(a);
            this.rh(this.bx);
        }
        lz(a, b, c, d, e) {
            super.lz(a, b, c, d, e);
            let f = this.a4.a$h.item(d);
            f.a1(c);
            if (this.ct(f)) {
                return;
            }
            this.rh(f);
        }
        rh(a) {
            if (this.ct(a)) {
                return;
            }
            let b;
            let c;
            let d = a.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            let e = a;
            let f = null;
            let g = null;
            let h = this.pi;
            let i = this.pj;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(1, b, c, h.cc);
            k.c = j;
            let l = new ScalerParams(1, b, c, i.cc);
            l.c = j;
            g = this.q5(a, k, l);
            if (g != null) {
                e.b8(g);
            }
            else {
                e.cb(f);
            }
        }
        re(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            let e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
            let f = a.b0;
            if (f == null || f.length != e) {
                f = new Array(e);
                for (let g = 0; g < e; g++) {
                    f[g] = 0;
                }
            }
            else {
                for (let h = 0; h < e; h++) {
                    f[h] = 0;
                }
            }
            a.b0 = f;
        }
        hh(a) {
            let b = truncate(Math.round(this.pf.width));
            let c = truncate(Math.round(this.pf.height));
            let d = this.bx.b0;
            if (d == null || d.length != (b * c) || this.ps == null || this.ps.count < 1 || this.pt == null || this.pt.count < 1 || this.pu == null || this.pu.count < 1) {
                return null;
            }
            let e = this.ca.pw;
            let f = (a.x - e.left) / e.width;
            let g = (a.y - e.top) / e.height;
            let h = truncate(Math.round(b * f));
            let i = truncate(Math.round(c * g));
            let j = (b * i) + h;
            if (j < 0 || j > d.length - 1) {
                return null;
            }
            let k = d[j] - 1;
            if (k < 0 || k > this.ps.count) {
                return null;
            }
            let l = this.qz.length;
            let m = this.ps.item(k);
            let n = this.pt.item(k);
            let o = this.pu.item(k);
            if ((m >= l) || (n >= l) || (o >= l)) {
                return null;
            }
            let p = (this.qz[m] - this.pf.left) / this.pf.width;
            let q = (this.q0[m] - this.pf.top) / this.pf.height;
            let r = (this.qz[n] - this.pf.left) / this.pf.width;
            let s = (this.q0[n] - this.pf.top) / this.pf.height;
            let t = (this.qz[o] - this.pf.left) / this.pf.width;
            let u = (this.q0[o] - this.pf.top) / this.pf.height;
            let v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
            let w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
            let x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
            if (v < w && v < x) {
                return this.ch.item(m);
            }
            if (w < v && w < x) {
                return this.ch.item(n);
            }
            if (x < v && x < w) {
                return this.ch.item(o);
            }
            return this.ch.item(m);
        }
        q5(a, b, c) {
            let d;
            let e;
            let f = a.getViewInfo(e, d);
            e = f.p0;
            d = f.p1;
            e = new Rect(0, 0, 0, e.width, e.height);
            b = new ScalerParams(0, b.e, e, b.a, b.c);
            c = new ScalerParams(0, c.e, e, c.a, c.c);
            c.b = this.f2();
            let g = a;
            let h = this.pi;
            let i = this.pj;
            let j = this.ps.count;
            let k;
            let xArr_ = this.pv.asArray();
            k = (xArr_.slice(0));
            let l;
            let yArr_ = this.pw.asArray();
            l = (yArr_.slice(0));
            let m = this.q7.asArray();
            let n = this.ps.asArray();
            let o = this.pt.asArray();
            let p = this.pu.asArray();
            this.qz = k;
            this.q0 = l;
            h.g5(boxArray$1(k), 0, k.length, b);
            i.g5(boxArray$1(l), 0, l.length, c);
            let q = this.q2;
            let r = g.b2(b.d, q, this.q7);
            let s = e.top;
            let t = e.left;
            let u = e.right;
            let v = e.bottom;
            let w;
            let x;
            let y;
            let z;
            this.re(g);
            let aa = g.b0;
            let ab = k.length;
            for (let ac = 0; ac < j; ac++) {
                let ad = n[ac];
                let ae = o[ac];
                let af = p[ac];
                if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                    continue;
                }
                let ag = k[ad];
                let ah = l[ad];
                let ai = { $type: Point_$type, x: ag, y: ah };
                let aj = k[ae];
                let ak = l[ae];
                let al = { $type: Point_$type, x: aj, y: ak };
                let am = k[af];
                let an = l[af];
                let ao = { $type: Point_$type, x: am, y: an };
                w = al.y < ao.y ? al.y : ao.y;
                w = ai.y < w ? ai.y : w;
                x = al.y > ao.y ? al.y : ao.y;
                x = ai.y > x ? ai.y : x;
                y = al.x < ao.x ? al.x : ao.x;
                y = ai.x < y ? ai.x : y;
                z = al.x > ao.x ? al.x : ao.x;
                z = ai.x > z ? ai.x : z;
                if (w < v && x > s && y < u && z > t) {
                    let ap = m[ad];
                    let aq = m[ae];
                    let ar = m[af];
                    r.p(ac, aa, ai, al, ao, ap, aq, ar);
                }
            }
            return r;
        }
        q8() {
            let a = new Color();
            let b = this.of;
            if (b == null) {
                a = ColorUtil.r("#000000");
            }
            else {
                a = ColorUtil.q(b);
            }
            let c = new ObservableColorCollection();
            c.add(ColorUtil.v(a, -0.5));
            c.add(a);
            return c;
        }
        ri() {
            let a = this.q3;
            if (a == null) {
                a = ((() => {
                    let $ret = new CustomPaletteColorScale();
                    $ret.palette = this.q8();
                    $ret.interpolationMode = 2;
                    return $ret;
                })());
            }
            else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                let b = a;
                if (b.palette == null || b.palette.count == 0) {
                    b.palette = this.q8();
                }
                a = b;
            }
            let c = new ObservableColorCollection();
            if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                c = a.palette;
            }
            else {
                c = this.q8();
            }
            this.q2 = a;
        }
        md() {
            super.md();
            this.ri();
        }
        kh(a, b) {
            super.kh(a, b);
            let c = b;
            c.b7();
        }
        bu() {
            return new ScatterAreaSeriesView(this);
        }
        lh(a) {
            super.lh(a);
            this.q4 = typeCast(ScatterAreaSeriesView.$, a);
        }
        rf(a) {
            if (this.q4 != null) {
                this.q4.b6(a);
            }
        }
    }
    ScatterAreaSeries.$t = markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
    ScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:q2:rj', [ColorScale.$, null], 'ColorMemberPath:rb:rk', [2, null]]);
    return ScatterAreaSeries;
})();
/**
 * @hidden
 */
export let ScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b1 = null;
            this.bx = null;
            this.b5 = null;
            this.b4 = null;
            this.b3 = null;
            this.b1 = a;
        }
        get b0() {
            return this.bx;
        }
        set b0(a) {
            this.bx = a;
        }
        ca(a, b) {
        }
        b6(a) {
        }
        by() {
            return this.bz(true);
        }
        bz(a) {
            this.b9();
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.left));
            let d = truncate(Math.round(this.bu.width));
            let e = truncate(Math.round(this.bu.height));
            let f = d.toString();
            let g = e.toString();
            if (this.b4.getAttribute("width") != f) {
                this.b4.setAttribute("width", d.toString());
            }
            if (this.b4.getAttribute("height") != g) {
                this.b4.setAttribute("height", e.toString());
            }
            let h = this.b3.g();
            if (a) {
                h.clearRect(0, 0, d, e);
            }
            this.b5 = h.getImageData(0, 0, d, e);
            let imageDataArray_ = this.b5.data;
            return imageDataArray_;
        }
        b9() {
            if (this.b4 == null) {
                this.b4 = this.e.gw.createElement("canvas");
                let a = this.e.gw.get2DCanvasContext(this.b4);
                this.b3 = new RenderingContext(new CanvasViewRenderer(), a);
            }
        }
        b2(a, b, c) {
            let d = truncate(Math.round(this.bu.left));
            let e = truncate(Math.round(this.bu.left));
            let f = truncate(Math.round(this.bu.width));
            let g = truncate(Math.round(this.bu.height));
            return new TriangleRasterizer(this.by(), b, c.minimum, c.maximum, c, f, g);
        }
        b8(a) {
            this.cb(null);
        }
        b7() {
            if (this.b3 != null) {
                this.b3.k(this.bu.left, this.bu.top, this.bu.width, this.bu.height);
            }
            this.aq();
        }
        a6(a, b) {
            super.a6(a, b);
            if (this.b4 == null) {
                return;
            }
            if (b) {
                let c = new Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
            }
            else {
                let d = truncate(Math.round(this.bu.left));
                let e = truncate(Math.round(this.bu.top));
                let f = truncate(Math.round(this.bu.width));
                let g = truncate(Math.round(this.bu.height));
                a.m(this.b4.getNativeElement(), 1, d, e, f, g);
            }
        }
        cb(a) {
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.left));
            let d = truncate(Math.round(this.bu.width));
            let e = truncate(Math.round(this.bu.height));
            this.b9();
            this.b3.g().putImageData(this.b5, 0, 0);
            this.aq();
        }
        al(a) {
            super.al(a);
            let b = truncate(Math.round(this.bu.width));
            let c = truncate(Math.round(this.bu.height));
            let d = this.bz(false);
            if (d == null || d.length == 0) {
                this.e.a6.exportSeriesPixelsData(a, null, b, c);
                return;
            }
            let e = new Array(intDivide(d.length, 4));
            let f;
            for (let g = 0; g < intDivide(d.length, 4); g++) {
                f = g * 4;
                e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
            }
            this.e.a6.exportSeriesPixelsData(a, e, b, c);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a4.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b1.hp + "</span><br/><span>" + "(${item." + this.b1.qg + "}, ${item." + this.b1.qk + "})</span>";
            if (!stringIsNullOrEmpty(this.b1.rb)) {
                a += "<span>, Value: ${item." + this.b1.rb + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    ScatterAreaSeriesView.$t = markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
    return ScatterAreaSeriesView;
})();
//# sourceMappingURL=ScatterAreaSeries_combined.js.map
