/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { Base, enumGetBox, Number_$type, typeCast, fromEnum, Point_$type, runOn, markType, markDep, PointUtil } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { GeometryUtil } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { PathGeometry } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { boxArray$1, arrayShallowClone } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterBase = /*@__PURE__*/ (() => {
    class ScatterBase extends MarkerSeries {
        constructor() {
            super();
            this.rb = null;
            this.rp = null;
            this.rq = null;
            this.t2 = null;
            this.t3 = null;
            this.rk = 1;
            this.qw = null;
            this.qx = null;
            this.rh = null;
            this.rj = null;
            this.rf = null;
            this.ru = false;
            this.rt = false;
            this.q7 = null;
            this.q8 = null;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ro = null;
            this.ri = null;
            this.re = null;
            this.rl = this.rm();
            this.ro = new ScatterSeriesRenderManager();
            this.ri = new ScatterFrame();
            this.t3 = Rect.empty;
            this.t2 = Rect.empty;
        }
        bu() {
            return new ScatterBaseView(this);
        }
        ke() {
            super.ke();
            this.xAxis = null;
            this.yAxis = null;
        }
        lh(a) {
            super.lh(a);
            this.rc = a;
        }
        get_d6() {
            return true;
        }
        ag() {
            return [this.xAxis, this.yAxis];
        }
        hk(a, b) {
            let c = this.ja(b);
            if (c == ScatterBase.$$p[8]) {
                return this.hl(a, b, this.so);
            }
            if (c == ScatterBase.$$p[10]) {
                return this.hl(a, b, this.ss);
            }
            return null;
        }
        cx(a, b, c) {
            if (!this.hasMarkers) {
                return false;
            }
            let d = this.xAxis;
            let e = new ScalerParams(1, this.ca.pg, this.pf, d.cc);
            e.c = this.getEffectiveViewport1(this.bx);
            let f = this.yAxis;
            let g = new ScalerParams(1, this.ca.pg, this.pf, f.cc);
            g.c = this.getEffectiveViewport1(this.bx);
            a.clear();
            this.pq.cf((h) => {
                if (h._visibility == 0) {
                    let i = new SeriesPointOfInterest();
                    let j = h.n;
                    let k = h.o;
                    if (j < this.pf.left || j > this.pf.right || k < this.pf.top || k > this.pf.bottom) {
                        return;
                    }
                    i.b = d.eb(j, e);
                    i.c = f.eb(k, g);
                    i.a = h.content;
                    a.add(i);
                }
            });
            return true;
        }
        bo() {
            if (this.bp == 0) {
                if (this.sc <= 2000) {
                    return 1;
                }
                else {
                    return super.bo();
                }
            }
            else {
                return super.bo();
            }
        }
        pd(a) {
            if (!this.hasMarkers || !this.pt()) {
                return Rect.empty;
            }
            let b = this.pq.by(this.ox(a));
            if (b != null) {
                return this.pq.cp(b);
            }
            return Rect.empty;
        }
        ep(a, b) {
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        }
        get rr() {
            return this.rp;
        }
        set rr(a) {
            if (this.rp != a) {
                let b = this.rr;
                this.rp = a;
                this.raisePropertyChanged("XColumn", b, this.rr);
            }
        }
        get rs() {
            return this.rq;
        }
        set rs(a) {
            if (this.rq != a) {
                let b = this.rs;
                this.rq = a;
                this.raisePropertyChanged("YColumn", b, this.rs);
            }
        }
        get tz() {
            return this.c(ScatterBase.tg);
        }
        set tz(a) {
            this.h(ScatterBase.tg, a);
        }
        get GetErrorBarsXAxis() {
            return this.xAxis;
        }
        get GetErrorBarsYAxis() {
            return this.yAxis;
        }
        ky() {
            super.ky();
            if (this.xAxis != null) {
                this.xAxis.hq(false);
            }
            if (this.yAxis != null) {
                this.yAxis.hq(false);
            }
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            if (this.rc.cx.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.rr);
                        c.deregisterColumn(this.rs);
                        this.rr = null;
                        this.rs = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.rr = this.ce(this.so);
                        this.rs = this.ce(this.ss);
                    }
                    if ((this.yAxis != null && !this.yAxis.cv()) || (this.xAxis != null && !this.xAxis.cv())) {
                        this.l0(false);
                    }
                    break;
                case ScatterBase.$$p[7]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if ((this.xAxis != null && !this.xAxis.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ScatterBase.$$p[9]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if ((this.yAxis != null && !this.yAxis.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ScatterBase.$$p[8]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.rr);
                        this.rr = this.ce(this.so);
                    }
                    break;
                case "XColumn":
                    this.rc.cx.g$i();
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(false);
                    }
                    break;
                case ScatterBase.$$p[10]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.rs);
                        this.rs = this.ce(this.ss);
                    }
                    break;
                case "YColumn":
                    this.rc.cx.g$i();
                    if (this.yAxis != null && !this.yAxis.cv()) {
                        this.l0(false);
                    }
                    break;
                case ScatterBase.$$p[5]:
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterBase.$$p[6]:
                    this.l0(false);
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.rj.c(this.gn, this.rh, this.rf);
                    this.su();
                    try {
                        if (this.ct(this.bx)) {
                            return;
                        }
                        if ((Math.round(this.gn * 100000) / 100000) == 1) {
                            this.te(this.rf, this.rc);
                        }
                        else {
                            this.te(this.rj, this.rc);
                        }
                        if (this.ca != null) {
                            this.ca.ln(this);
                        }
                    }
                    finally {
                        this.tf();
                    }
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case ScatterBase.$$p[0]:
                    if (this.rd != null) {
                        this.rd.r = this;
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
                case ScatterBase.$$p[2]:
                    this.ru = this.r2();
                    this.l0(false);
                    break;
                case ScatterBase.$$p[1]:
                    this.rt = this.r1();
                    this.l0(false);
                    break;
                case ScatterBase.$$p[3]:
                    this.rl = this.rm();
                    break;
            }
        }
        r2() {
            return this.ry;
        }
        r1() {
            return this.rx;
        }
        rw(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        rv(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        tf() {
            this.t2 = Rect.empty;
            this.t3 = Rect.empty;
        }
        su() {
            let a = this.getViewInfo(this.t2, this.t3);
            this.t2 = a.p0;
            this.t3 = a.p1;
        }
        r0(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.so == a || this.ss == a) {
                return true;
            }
            return false;
        }
        kk(a, b, c, d) {
            let e = false;
            if (!this.r0(d, a)) {
                return;
            }
            this.rc.cx.g$e(a, b, c, d);
            if (this.xAxis != null && !this.xAxis.cv()) {
                e = true;
            }
            if (this.yAxis != null && !this.yAxis.cv()) {
                e = true;
            }
            if (e) {
                this.l0(true);
            }
        }
        s6(a) {
            this.s7(a, null);
        }
        s7(a, b) {
            let c = this.rr != null ? this.rr.count : 0;
            let d = this.rs != null ? this.rs.count : 0;
            let e = Math.min(c, d);
            if (e <= this.sc) {
                a.m.clear();
                let f = new List$1(OwnedPoint.$, 0);
                for (let g of fromEnum(a.u.values)) {
                    f.add(g);
                }
                let h = this.ch;
                f.aa((i, j) => {
                    let k = h.indexOf(i.a);
                    let l = h.indexOf(j.a);
                    if (k < l) {
                        return -1;
                    }
                    if (k > l) {
                        return 1;
                    }
                    return 0;
                });
                if (b != null) {
                    b.i = a.m;
                }
                for (let i of fromEnum(f)) {
                    if (h.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
        }
        ap(a) {
            if (a != null && a == this.xAxis && this.rr != null) {
                return new AxisRange(this.rr.minimum, this.rr.maximum);
            }
            if (a != null && a == this.yAxis && this.rs != null) {
                return new AxisRange(this.rs.minimum, this.rs.maximum);
            }
            return null;
        }
        hh(a) {
            let b = this.g0(a);
            if (this.ch != null && b >= 0 && b < this.ch.count) {
                return this.ch.item(b);
            }
            return null;
        }
        get rl() {
            return this.rk;
        }
        set rl(a) {
            let b = this.rk;
            this.rk = a;
            if (b != this.rk) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.rk));
            }
        }
        rm() {
            if (this.rn != 0) {
                return this.rn;
            }
            return this.rz ? 4 : 1;
        }
        g0(a) {
            let b = truncate(Math.round(this.fw(a)));
            return b;
        }
        fw(a) {
            switch (this.rl) {
                case 1: return this.r8(a);
                case 3: return this.r9(a);
                case 2: return this.r6(a);
                case 4: return this.r7(a);
            }
            return -1;
        }
        r7(a) {
            return this.sa(a, false);
        }
        r6(a) {
            let b = this.ox(a);
            let c = b.x;
            let d = b.y;
            if (this.ch == null || this.xAxis == null || this.yAxis == null || this.rr == null || this.rs == null) {
                return -1;
            }
            if (this.ch.count > this.sb) {
                return -1;
            }
            this.sx();
            let e = this.qw;
            let f = this.qx;
            if (e == null || f == null) {
                return -1;
            }
            let g = 1.7976931348623157E+308;
            let h = -1;
            for (let i = 0; i < this.rr.count; i++) {
                let j = e[i];
                let k = f[i];
                let l = (c - j) * (c - j) + (d - k) * (d - k);
                if (l < g) {
                    g = l;
                    h = i;
                }
            }
            return h;
        }
        sx() {
            let a = this.bx.bv;
            let b = this.bx.bu;
            let c = this.getEffectiveViewport();
            if (this.rb == null) {
                return;
            }
            let d = new ScalerParams(0, a, b, this.rb.d, c);
            let e = ((() => {
                let $ret = new ScalerParams(0, a, b, this.rb.e, c);
                $ret.b = this.f2();
                return $ret;
            })());
            if (this.qw == null || this.qx == null) {
                let f = arrayShallowClone(this.rr.asArray());
                let g = arrayShallowClone(this.rs.asArray());
                this.xAxis.g5(boxArray$1(f), 0, f.length, d);
                this.yAxis.g5(boxArray$1(g), 0, g.length, e);
                this.qw = f;
                this.qx = g;
            }
        }
        get_rz() {
            return false;
        }
        get rz() {
            return this.get_rz();
        }
        sa(a, b) {
            if (!this.rz) {
                return -1;
            }
            let c = { $type: Point_$type, x: 0, y: 0 };
            let d = true;
            let e = this.rg();
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.ch == null || this.ch.count > this.sb) {
                return -1;
            }
            this.sx();
            let f = this.qw;
            let g = this.qx;
            if (f == null || g == null) {
                return -1;
            }
            let h = this.ox(a);
            let i = 1.7976931348623157E+308;
            let j = -1;
            for (let k = 0; k < this.qw.length; k++) {
                let l = { $type: Point_$type, x: this.qw[k], y: this.qx[k] };
                if (k > 0) {
                    if (!b || e.j.containsKey(this.ch.item(k)) || e.j.containsKey(this.ch.item(k - 1))) {
                        let m = GeometryUtil.d(h, c, l);
                        if (m < i) {
                            i = m;
                            j = k;
                        }
                    }
                }
                c = l;
            }
            if (j >= 0) {
                let n = { $type: Point_$type, x: this.qw[j], y: this.qx[j] };
                let o = { $type: Point_$type, x: this.qw[j - 1], y: this.qx[j - 1] };
                if (!b || (e.j.containsKey(this.ch.item(j)) && e.j.containsKey(this.ch.item(j - 1)))) {
                    let p = GeometryUtil.h(h, o, n);
                    return (j - 1) + p;
                }
                else if (e.j.containsKey(this.ch.item(j))) {
                    return j;
                }
                else {
                    return j - 1;
                }
            }
            return -1;
        }
        r9(a) {
            return this.sa(a, true);
        }
        r8(a) {
            let b = null;
            let c = 1.7976931348623157E+308;
            let d = this.ox(a);
            let e = d.x;
            let f = d.y;
            if (this.rc.cy.e > this.sb) {
                return -1;
            }
            this.rc.c5((g) => {
                if (g._visibility == 0) {
                    let h = this.rc.cp(g);
                    let i = h.left + h.width / 2;
                    let j = h.top + h.height / 2;
                    let k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        }
        o2(a, b, c) {
            if (this.xAxis == null || this.yAxis == null || this.rr == null || this.rs == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.bx.bv;
            let e = this.bx.bu;
            let f = this.getEffectiveViewport();
            let g = new ScalerParams(0, d, e, this.xAxis.cc, f);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cc, f);
                $ret.b = this.f2();
                return $ret;
            })());
            if (b) {
                let i = this.fw(a);
                if (i == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let j = truncate(Math.floor(i));
                let k = truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.ch.count - 1) {
                    k = this.ch.count - 1;
                }
                if (j > this.ch.count - 1) {
                    j = this.ch.count - 1;
                }
                if (k == j) {
                    let l = this.xAxis.d8(this.rr.item(j), g);
                    let m = this.yAxis.d8(this.rs.item(j), h);
                    return { $type: Point_$type, x: l, y: m };
                }
                let n = i - Math.floor(i);
                let o = this.xAxis.d8(this.rr.item(j), g);
                let p = this.yAxis.d8(this.rs.item(j), h);
                let q = this.xAxis.d8(this.rr.item(k), g);
                let r = this.yAxis.d8(this.rs.item(k), h);
                let s = q - o;
                let t = r - p;
                return { $type: Point_$type, x: o + s * n, y: p + t * n };
            }
            else {
                let u = this.g0(a);
                if (u == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let v = this.xAxis.d8(this.rr.item(u), g);
                let w = this.yAxis.d8(this.rs.item(u), h);
                return { $type: Point_$type, x: v, y: w };
            }
        }
        eh(a) {
            let b = this.ca != null ? this.ca.pg : Rect.empty;
            b = b.copy();
            let c = this.ca != null ? this.ca.pv : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.o9(this.bx);
            let f = new ScalerParams(0, d, d, this.xAxis.cc, e);
            let g = ((() => {
                let $ret = new ScalerParams(0, d, d, this.yAxis.cc, e);
                $ret.b = this.f2();
                return $ret;
            })());
            let h = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            let i = this.xAxis != null && this.rr != null && h < this.rr.count ? this.xAxis.d8(this.rr.item(h), f) : NaN;
            let j = this.yAxis != null && this.rs != null && h < this.rs.count ? this.yAxis.d8(this.rs.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b5 != null) {
                this.b5.ap(this.ca, b, true);
            }
            return h >= 0;
        }
        mm(a, b) {
            this.l0(false);
        }
        mn(a, b) {
            this.l0(false);
        }
        rg() {
            let a = this.rf;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.rj;
            }
            return a;
        }
        sv(a, b, c, d, e) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            let f = this.getEffectiveViewport1(a);
            let g = this.ch;
            let h;
            let i;
            let j = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rb.d, f);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let k = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rb.e, f);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.f2();
                return $ret;
            })());
            let l = false;
            let m = 0;
            if (this.ca != null) {
                if (this.ca.ei()) {
                    let n = this.ca.i1(d, j);
                    l = n.c;
                    m = n.d;
                }
            }
            for (let o = 0; o < c; o++) {
                h = this.rr.item(o);
                i = this.rs.item(o);
                let p = { $type: Point_$type, x: this.rb.a.d8(h, j), y: this.rb.b.d8(i, k) };
                if (l) {
                    if (p.x < e.left || p.x > e.right) {
                        if (p.x + m >= e.left && p.x + m <= e.right) {
                            p = { $type: Point_$type, x: p.x + m, y: i };
                        }
                    }
                }
                if (!isInfinity(p.x) && !isInfinity(p.y)) {
                    let q = g.item(o);
                    if (!b.g.containsKey(q)) {
                        let r = { $type: Point_$type, x: h, y: i };
                        let s = { $type: Point_$type, x: p.x, y: p.y };
                        b.g.addItem(q, ((() => {
                            let $ret = new OwnedPoint();
                            $ret.a = q;
                            $ret.b = r;
                            $ret.c = s;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        s3(a, b) {
            this.qw = null;
            this.qx = null;
            a.j.clear();
            a.n.clear();
            a.h.clear();
            a.l.clear();
            a.i.clear();
            a.k.clear();
            let c = Math.min(this.rr != null ? this.rr.count : 0, this.rs != null ? this.rs.count : 0);
            let d = b.bv;
            let e = b.bu;
            let f = this.getEffectiveViewport1(b);
            let g = new ScalerParams(0, d, e, this.xAxis.cc, f);
            g.c = this.getEffectiveViewport1(b);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cc, f);
                $ret.b = this.f2();
                return $ret;
            })());
            h.c = this.getEffectiveViewport1(b);
            if (c < 1) {
                return;
            }
            this.rb = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.cc;
                $ret.e = this.yAxis.cc;
                $ret.c = this.ch;
                return $ret;
            })());
            let i = b;
            if (c <= this.sc) {
                this.sv(i, a, c, d, e);
            }
            if (this.pt()) {
                b.cv.l(a.j, this.sc, d, e, this.gh);
            }
            let j = ((() => {
                let $ret = new Clipper(0, e, false);
                $ret.i = a.n;
                return $ret;
            })());
            let k = this.o7(b);
            let l = this.xAxis.eb(k.left, g);
            let m = this.xAxis.eb(k.right, g);
            b.cx.h(a.n, this.trendLineType, this.rr, this.rs, this.trendLinePeriod, (n) => this.xAxis.d8(n, g), (n) => this.yAxis.d8(n, h), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.b = this.gh;
                $ret.f = e;
                $ret.g = d;
                return $ret;
            })()), j, l, m);
            this.s1(a, b);
        }
        kh(a, b) {
            super.kh(a, b);
            let c = b;
            c.c4(a);
        }
        get_dr() {
            return true;
        }
        q5(a, b, c) {
            return null;
        }
        q6(a, b, c) {
            let d = this.rg();
            let e = this.rc.by(this.ox(b));
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ch.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            g.e = true;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        }
        pg() {
            if (this.pr != 1 && this.pr != 13) {
                let a = this.pq.cq();
                let b = (a.width / 2) + (this.pw / 2);
                let c = (a.height / 2) + (this.pw / 2);
                return new Thickness(1, b, c, b, c);
            }
            return new Thickness(1, 0, 0, 0, 0);
        }
        q4(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        av(a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                let d = this.q5(a, b, this.q7);
                this.q7 = d;
                return d;
            }
            else {
                let e = this.q4(a, b, this.q7);
                this.q7 = e;
                return e;
            }
        }
        aw(a, b, c) {
            if (this.d9(this.bj) && !c) {
                let d = this.q6(a, b, this.q8);
                this.q8 = d;
                return d;
            }
            else {
                let e = this.q4(a, b, this.q8);
                e.e = true;
                this.q8 = e;
                return e;
            }
        }
        r4() {
            return (this.assigningScatterStyle != null && this.ru) || (this.bj != 1);
        }
        r3() {
            return (this.assigningScatterMarkerStyle != null && this.rt) || (this.bj != 1);
        }
        te(a, b) {
            let c = b.bu;
            this.rb = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.cc;
                $ret.e = this.yAxis.cc;
                return $ret;
            })());
            if (this.pt()) {
                b.cv.j(a.j, this.pv);
                if (this.r3()) {
                    this.sw(b, a);
                }
            }
            b.cm();
            let d = ((() => {
                let $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
                $ret.i = b.cx.g$j.ak;
                return $ret;
            })());
            b.cx.g$h(a.n, d);
            this.tb(a, b);
        }
        qz(a, b) {
            return this.q0(a, b);
        }
        q0(a, b) {
            if (b < a || a < 0 || a > this.rr.count || b < 0 || b > this.rr.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.ch.item(d);
            }
            return c;
        }
        sw(a, b) {
            a.b3 = true;
            this.ro.aw(this, this.r3(), runOn(this, this.qz));
            let c = this.ro.d;
            let d = c != null;
            let e = this.getEffectiveViewport1(a);
            let f = this.ch == null ? 0 : this.ch.count;
            this.rc.cf((g) => {
                if (g._visibility == 0) {
                    let h = g.ak;
                    let i = g.content;
                    if (i == null) {
                        i = new DataContext();
                        g.content = i;
                    }
                    if (d) {
                        this.sy(h, f, a.q);
                    }
                    this.ro.ac(g, i);
                }
            });
        }
        sz(a, b, c) {
            let d = this.bj != 1;
            this.ro.ay(this.ro.b, a, b, false);
            this.ro.ab(this.fj);
            let e = this.ro.av;
            let f = null;
            let g = this.ch;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, false);
                e.b = f;
            }
            e.f = c;
            this.s9(e);
            this.ro.z(this, f, c, d, a < 0);
        }
        sy(a, b, c) {
            let d = this.bj != 1;
            this.ro.ay(this.ro.d, a, b, true);
            this.ro.aa(this.fj);
            let e = this.ro.au;
            let f = null;
            let g = this.ch;
            let h = null;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    h = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.s8(e);
            this.ro.y(this, f, c, d, e.m, this.ca.a3.totalHighlightingProgress);
        }
        s9(a) {
            if (this.assigningScatterStyle != null && this.ru) {
                this.assigningScatterStyle(this, a);
            }
        }
        s8(a) {
            if (this.assigningScatterMarkerStyle != null && this.rt) {
                this.assigningScatterMarkerStyle(this, a);
            }
        }
        s1(a, b) {
            let c = new ErrorBarsHelper(this, b);
            if (this.rd == null) {
                return;
            }
            let d = this.rd.u;
            let e = this.rd.v;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            for (let j of fromEnum(a.j.keys)) {
                let k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            let l = this.s4(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            let m = this.s2(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            let n = this.s0(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            let o = this.s5(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            let p = this.s2(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    let q = new OwnedPoint();
                    q.c = c.l(d, this.rb.a, k.c, f);
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            let r = this.s4(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            let s = this.s2(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            let t = this.s0(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            let u = this.s5(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            let v = this.s2(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    let w = new OwnedPoint();
                    w.c = c.m(e, this.rb.b, k.c, g);
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        s4(a, b, c, d, e, f) {
            if (f) {
                let g;
                let h, i;
                i = this.rb.a;
                if (this.rd.s == 0) {
                    g = a.c.x;
                    h = this.rb.a;
                }
                else {
                    g = a.c.y;
                    h = this.rb.b;
                }
                let j = b.f(g, c, h, i, d, e);
                d = j.p4;
                e = j.p5;
            }
            else {
                let k;
                let l, m;
                m = this.rb.b;
                if (this.rd.t == 0) {
                    k = a.c.x;
                    l = this.rb.a;
                }
                else {
                    k = a.c.y;
                    l = this.rb.b;
                }
                let n = b.f(k, c, l, m, d, e);
                d = n.p4;
                e = n.p5;
            }
            return {
                p3: d,
                p4: e
            };
        }
        s2(a, b, c, d, e, f) {
            if (f) {
                let g = b.j(a.c.x, c, this.rb.a, d, e);
                d = g.p3;
                e = g.p4;
            }
            else {
                let h = b.j(a.c.y, c, this.rb.b, d, e);
                d = h.p3;
                e = h.p4;
            }
            return {
                p3: d,
                p4: e
            };
        }
        s0(a, b, c, d, e, f, g) {
            let h = c.getItemColumn();
            let i = this.ch.indexOf(d);
            if (h != null && i < h.count) {
                let j = h.item(i);
                if (g) {
                    let k = b.h(a.c.x, j, this.rb.a, e, f);
                    e = k.p3;
                    f = k.p4;
                }
                else {
                    let l = b.h(a.c.y, j, this.rb.b, e, f);
                    e = l.p3;
                    f = l.p4;
                }
            }
            else {
                e = NaN;
                f = NaN;
            }
            return {
                p4: e,
                p5: f
            };
        }
        s5(a, b, c, d, e, f) {
            let g = a.i(b, c);
            c = g.p1;
            if (f) {
                let h = a.k(c, b, this.rb.a, d, e);
                d = h.p3;
                e = h.p4;
            }
            else {
                let i = a.k(c, b, this.rb.b, d, e);
                d = i.p3;
                e = i.p4;
            }
            return {
                p2: c,
                p3: d,
                p4: e
            };
        }
        tb(a, b) {
            if (!b.o() || this.rd == null) {
                b.c6();
                return;
            }
            this.tc(a, b);
            this.td(a, b);
        }
        tc(a, b) {
            b.c2();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.rd.u;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.i.containsKey(f)) {
                    let g = a.i.item(f)[0];
                    let h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.h.item(f).c;
                        if (this.rd.o == 1 || this.rd.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.rd.o == 1 || this.rd.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
            b.c7(d);
        }
        td(a, b) {
            b.c3();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.rd.v;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.k.containsKey(f)) {
                    let g = a.k.item(f)[0];
                    let h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.l.item(f).c;
                        if (this.rd.p == 1 || this.rd.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.rd.p == 1 || this.rd.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        e3(a, b, c) {
            let d = true;
            if (!super.e3(a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.rr == null || this.rs == null || this.rr.count == 0 || this.rs.count == 0 || this.ch == null || this.ch.count != this.rr.count || this.ch.count != this.rs.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.kv == this.xAxis.ku || this.yAxis.kv == this.yAxis.ku) {
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            if (!this.t2.isEmpty && !this.t3.isEmpty) {
                a = this.t2;
                b = this.t3;
                return {
                    p0: a,
                    p1: b
                };
            }
            a = this.bx.bu;
            b = this.bx.bv;
            return {
                p0: a,
                p1: b
            };
        }
        l1(a) {
            this.su();
            try {
                if (this.ct(this.bx)) {
                    return;
                }
                if (this.ch != null && this.ch.count > this.sc) {
                    a = false;
                }
                if (this.ei(a) && !this.em) {
                    let b = this.rh;
                    if (this.cr()) {
                        if (this.cb.g) {
                            this.cb.t();
                        }
                        this.rh = this.rj;
                        this.rj = b;
                    }
                    else {
                        this.rh = this.rf;
                        this.rf = b;
                    }
                    this.s3(this.rf, this.rc);
                    this.l8();
                }
                else {
                    if (!this.em) {
                        this.s3(this.rf, this.rc);
                    }
                    this.te(this.rf, this.rc);
                }
            }
            finally {
                this.tf();
            }
        }
        md() {
            super.md();
            if (this.g9 < 0) {
                return;
            }
            this.rc.da();
        }
        l2(a, b) {
            super.l2(a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            let c = typeCast(ScatterBaseView.$, this.bw);
            if (!this.en) {
                this.ri = new ScatterFrame();
                this.s3(this.ri, c);
            }
            this.en = false;
            this.te(this.ri, c);
            this.et = false;
        }
        lz(a, b, c, d, e) {
            super.lz(a, b, c, d, e);
            let f = this.a4.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.re == null) {
                this.re = new ScatterFrame();
            }
            this.s3(this.re, g);
            this.te(this.re, g);
        }
        ta(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        qy(a, b, c, d, e) {
            if (c == null || c.length != this.rb.c.count) {
                c = new Array(this.rb.c.count);
                for (let f = 0; f < this.rb.c.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = this.getEffectiveViewport1(a);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.xAxis.cc, g);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cc, g);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.f2();
                return $ret;
            })());
            let j = this.o7(a);
            let k = this.rb.a.eb(j.left, h);
            let l = this.rb.a.eb(j.right, h);
            let m = this.rb.b.eb(j.bottom, i);
            let n = this.rb.b.eb(j.top, i);
            if (this.rb.d) {
                let o = k;
                k = l;
                l = o;
            }
            if (this.rb.e) {
                let p = m;
                m = n;
                n = p;
            }
            let q = this.rb;
            let r = q.a;
            let s = q.b;
            let t;
            let u;
            let v = this.rr;
            let w = this.rs;
            let x = false;
            let y = 0;
            let z = 0;
            if (this.ca != null) {
                if (this.ca.ei()) {
                    let aa = this.ca.i1(d, h);
                    x = aa.c;
                    y = aa.d;
                    z = r.eb(0 + y, h);
                    let ab = r.eb(0, h);
                    z -= ab;
                }
            }
            for (let ac = 0; ac < this.rb.c.count; ac++) {
                t = v.item(ac);
                u = w.item(ac);
                if (x) {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.d8(t, h);
                        c[ac].y = s.d8(u, i);
                    }
                    else {
                        if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                            c[ac].x = r.d8(t, h) + y;
                            c[ac].y = s.d8(u, i);
                        }
                        else {
                            c[ac].x = NaN;
                            c[ac].y = NaN;
                        }
                    }
                }
                else {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.d8(t, h);
                        c[ac].y = s.d8(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            return c;
        }
        r5(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.ch;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
            }
            return b;
        }
        kr(a) {
            super.kr(a);
            this.a6.exportTrendlineData(this, a, this.rc.cx.g$j);
        }
        f2() {
            return Series.f3(this.rs, null);
        }
    }
    ScatterBase.$t = markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.tg = DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    ScatterBase.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:rd:th', [ScatterErrorBarSettings.$, null], 'IsCustomScatterMarkerStyleAllowed:rx:ti', [0, false], 'IsCustomScatterStyleAllowed:ry:tj', [0, false], 'ItemSearchMode:rn:tk', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sb:tl', [1, 10000], 'MarkerCollisionAvoidance:q3:tm', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:sc:tn', [1, 400], 'XAxis::tv', [NumericXAxis.$, null], 'XMemberPath:so:tw', [2, null], 'YAxis::tx', [NumericYAxis.$, null], 'YMemberPath:ss:ty', [2, null], 'TrendLineType::tt', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::ts', [1, 1.5], 'TrendLinePeriod::tr', [1, 7], 'TrendLineBrush::to', [Brush.$, null], 'TrendLineZIndex:sd:tu', [1, 1001], 'TrendLineDashArray:t0:tp', [DoubleCollection.$], 'TrendLineDashCap:t1:tq', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
})();
/**
 * @hidden
 */
export let ScatterSeriesRenderManager = /*@__PURE__*/ (() => {
    class ScatterSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.au = null;
            this.av = null;
        }
        c() {
            this.au = new AssigningScatterMarkerStyleEventArgs();
            return this.au;
        }
        a() {
            this.av = new AssigningScatterStyleEventArgs();
            return this.av;
        }
        aw(a, b, c) {
            this.w(a, b, c);
        }
        ax(a, b, c) {
            this.x(a, b, c);
        }
        ay(a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        }
    }
    ScatterSeriesRenderManager.$t = markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
    return ScatterSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ScatterBaseView = /*@__PURE__*/ (() => {
    class ScatterBaseView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.cv = null;
            this.ct = null;
            this.cw = null;
            this.c1 = null;
            this.dc = null;
            this.dd = null;
            this.cx = null;
            this.db = null;
            this.cy = null;
            this.cw = a;
            this.cy = new HashPool$2(Base.$, Marker.$);
            this.ch(this.cy);
            this.cx = new ScatterTrendLineManager();
        }
        as() {
            super.as();
            this.cv = this.cu();
            this.dc = new Path();
            this.dd = new Path();
            if (!this.q) {
                this.cw.sc = 2000;
            }
        }
        de(a) {
            if (this.db == null) {
                this.db = new DataTemplateMeasureInfo();
                this.db.context = this.k.g();
            }
            this.db.width = a.width;
            this.db.height = a.height;
            this.db.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.db);
            }
            return new Size(1, this.db.width, this.db.height);
        }
        cu() {
            let a = new NumericMarkerManager(1, (b) => this.cy.item(b), (b) => this.cw.rb.c.item(b), runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz), () => this.cw.q3);
            a.q = runOn(this, this.de);
            return a;
        }
        c9(a) {
            this.cw.ta(a, this.cy);
        }
        c0() {
            return this.b4;
        }
        cs() {
            return this.ct;
        }
        cr() {
            this.ct = this.cw.qy(this, this.cy, this.ct, this.bv, this.bu);
            return this.ct;
        }
        cz() {
            this.c1 = this.cw.r5(this.cy, this.c1);
            return this.c1;
        }
        c2() {
        }
        c7(a) {
        }
        c3() {
        }
        c8(a) {
        }
        da() {
            if (this.cw.trendLineBrush != null) {
                this.cw.tz = this.cw.trendLineBrush;
            }
            else {
                this.cw.tz = this.cw.of;
            }
        }
        cf(a) {
            this.cy.f(a);
        }
        c5(a) {
            this.cy.g(a);
        }
        c6() {
        }
        a5(a, b) {
            super.a5(a, b);
            if (a.d) {
                if (this.cw.trendLineType != 0 && !b) {
                    let c = this.cx.g$j;
                    c.ac = this.cw.trendLineThickness;
                    c._stroke = this.cw.tz;
                    c.ai = this.cw.t0;
                    c.ad = this.cw.t1;
                    a.u(c);
                }
            }
        }
        c4(a) {
            if (a) {
                this.c6();
                this.cy.clear();
            }
            this.cx.g$d();
            this.aq();
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a4.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.hp + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cw.so + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cw.ss + "}</span></div>";
            return a;
        }
    }
    ScatterBaseView.$t = markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
})();
//# sourceMappingURL=ScatterBase_combined.js.map
