/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { DependencyProperty } from "igniteui-angular-core";
import { SplineType_$type } from "./SplineType";
import { AxisRange } from "./AxisRange";
import { Array_$type, typeCast, Point_$type, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CollisionAvoider } from "./CollisionAvoider";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ScalerParams } from "./ScalerParams";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { Numeric } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let SplineSeriesBase = /*@__PURE__*/ (() => {
    class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.uh = null;
            this.un = NaN;
            this.um = NaN;
        }
        bu() {
            return new SplineSeriesBaseView(this);
        }
        lh(a) {
            super.lh(a);
            this.ui = a;
        }
        ap(a) {
            if (!this.uk || this.uh == null || this.uh.length == 0) {
                return super.ap(a);
            }
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            this.uu(this.ui);
            if (this.uh == null || this.uh.length == 0) {
                return null;
            }
            if (a == this.fetchYAxis()) {
                if (isNaN_(this.uq) || isNaN_(this.ur)) {
                    return null;
                }
                return new AxisRange(this.ur, this.uq);
            }
            return null;
        }
        get_c8() {
            return true;
        }
        uf(a) {
            if (a.cr.d == 0) {
                return null;
            }
            let b = new List$1(Array_$type, 0);
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(a);
            let f = 0;
            let g = 0;
            let h = 0;
            let i = this;
            let j = typeCast(CategoryAxisBase.$, i.fetchXAxis());
            let k = i.o7(this.bx);
            let l = i.ch;
            if (c.isEmpty || d.isEmpty || j == null || l == null || l.count == 0) {
                f = 0;
                return null;
            }
            let m = this.gh;
            let n = typeCast(ISortingAxis_$type, j);
            if (n == null || n.i$b == null) {
                let o = new ScalerParams(0, c, d, j.cc, e);
                let p = 0;
                let q = j.kr - 1;
                let r = Math.floor((q - p + 1) * m / k.width);
                f = truncate(Math.max(1, r));
                g = truncate(Math.max(0, Math.floor(p / f) - 1));
                h = truncate(Math.ceil(q / f));
            }
            else {
                g = 0;
                h = j.kr - 1;
                f = 1;
            }
            if (n != null && n.i$b.count != this.ch.count) {
                return null;
            }
            this.uu(a);
            let s = truncate(Math.ceil(d.width / (h - g)));
            let t = new CollisionAvoider();
            if (n != null) {
                return this.ug(a);
            }
            let u = (v) => v;
            let v = (w) => this.valueColumn.item(w);
            let w = a;
            w.c6();
            for (let x = g; x <= h; ++x) {
                let y = null;
                if (f == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        break;
                    }
                    let z = u(x);
                    let aa = v(x);
                    let ab = u(x + 1);
                    let ac = v(x + 1);
                    let ad = ab - z;
                    let ae = this.uh[x];
                    let af = this.uh[x + 1];
                    b.add([aa, ac]);
                    for (let ag = 1; ag < s; ++ag) {
                        let ah = z + ad * ag / s;
                        let ai = (ab - ah) / ad;
                        let aj = (ah - z) / ad;
                        let ak = ai * aa + aj * ac + ((ai * ai * ai - ai) * ae + (aj * aj * aj - aj) * af) * (ad * ad) / 6;
                        b.add([ak, ak]);
                    }
                }
                else {
                    y = a.cr.getBucket(x);
                    if (!isNaN_(y[0])) {
                        b.add([y[1], y[2]]);
                    }
                }
            }
            w.c8();
            return b.toArray();
        }
        ug(a) {
            let b = typeCast(ISortingAxis_$type, this.tw);
            let c = this.getEffectiveViewport1(a);
            let d = a.bv;
            let e = a.bu;
            let f = new List$1(Array_$type, 0);
            if (b == null) {
                return null;
            }
            let g = this.tw;
            let h = 0;
            let i = 0;
            let j = 0;
            let k = this.gh;
            let l = this.o7(this.bx);
            if (b == null || b.i$b == null) {
                let m = new ScalerParams(0, d, e, g.cc, c);
                let n = 0;
                let o = g.kr - 1;
                let p = Math.floor((o - n + 1) * k / l.width);
                h = truncate(Math.max(1, p));
                i = truncate(Math.max(0, Math.floor(n / h) - 1));
                j = truncate(Math.ceil(o / h));
            }
            else {
                i = 0;
                j = g.kr - 1;
                h = 1;
            }
            let q = (r) => r;
            let r = (s) => this.valueColumn.item(b.i$b._inner[s]);
            let s = truncate(Math.ceil(e.width / (j - i)));
            let t = new CollisionAvoider();
            if (h <= 0 || (i <= 0 && j <= 0)) {
                return null;
            }
            for (let u = i; u < j + 1; ++u) {
                let v = null;
                let w = u * h;
                if (b != null && b.i$b != null && w >= 0 && w < b.i$b.count) {
                    w = b.i$b._inner[w];
                }
                if (u >= (this.valueColumn.count - 1)) {
                    break;
                }
                let x = q(u);
                let y = r(u);
                let z = q(u + 1);
                let aa = r(u + 1);
                let ab = z - x;
                let ac = this.uh[u];
                let ad = this.uh[u + 1];
                f.add([y, y]);
                for (let ae = 1; ae < s; ++ae) {
                    let af = ae / s;
                    let ag = x + ab * af;
                    let ah = (z - ag) / ab;
                    let ai = (ag - x) / ab;
                    let aj = ah * y + ai * aa + ((ah * ah * ah - ah) * ac + (ai * ai * ai - ai) * ad) * (ab * ab) / 6;
                    f.add([aj, aj]);
                }
            }
            return f.toArray();
        }
        uv(a, b, c, d, e, f) {
            let g = typeCast(ISortingAxis_$type, d);
            let h = this.getEffectiveViewport1(f);
            if (g == null) {
                return;
            }
            let i = new ScalerParams(0, b, c, d.cc, h);
            let j = new ScalerParams(0, b, c, e.cc, h);
            j.b = this.f2();
            let k = this.pt();
            let l = 0;
            let m = this.up(d, b, c, h);
            let n = (o) => o;
            let o = (p) => this.valueColumn.item(g.i$b._inner[p]);
            let p = this.rc.cr.f;
            let q = this.rc.cr.e;
            let r = truncate(Math.ceil(c.width / (p - q)));
            let s = new CollisionAvoider();
            let t = this.rc.cr.d;
            if (t <= 0 || (q <= 0 && p <= 0)) {
                this.rc.cu.count = l;
                return;
            }
            let u = 0;
            let v = 0;
            for (let w = q; w < p + 1; ++w) {
                let x = null;
                let y = w * t;
                if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                    y = g.i$b._inner[y];
                }
                if (w >= (this.valueColumn.count - 1)) {
                    if (k && this.ul(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.ch.count - 1), l, f, u - 1)) {
                        ++l;
                    }
                    break;
                }
                let z = n(w);
                let aa = o(w);
                let ab = n(w + 1);
                let ac = o(w + 1);
                let ad = ab - z;
                let ae = this.uh[w];
                let af = this.uh[w + 1];
                let ag = g.i$d(g.i$b._inner[w]);
                let ah = d.d8(ag, i) + m;
                let ai = e.d8(aa, j);
                a.f.add([ah, ai, ai]);
                u++;
                v = u;
                for (let aj = 1; aj < r; ++aj) {
                    let ak = aj / r;
                    let al = z + ad * ak;
                    let am = (ab - al) / ad;
                    let an = (al - z) / ad;
                    let ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                    let ap = g.i$d(g.i$b._inner[w]);
                    let aq = g.i$d(g.i$b._inner[w + 1]);
                    let ar = ap + (aq - ap) * ak;
                    al = d.d8(ar, i) + m;
                    ao = e.d8(ao, j);
                    a.f.add([al, ao, ao]);
                    u++;
                }
                if (k) {
                    x = [ah, ai, ai];
                }
                if (k && this.ul(a, x, s, Math.min(y, this.ch.count - 1), l, f, v - 1)) {
                    ++l;
                }
            }
            f.cu.count = l;
        }
        ul(a, b, c, d, e, f, g) {
            let h = b[0];
            let i = b[1];
            let j = new Rect(0, h - 5, i - 5, 11, 11);
            if (!isNaN_(h) && !isNaN_(i) && c.tryAdd(j)) {
                a.m.add({ $type: Point_$type, x: h, y: i });
                let k = f.cu.item(e);
                k.content.item = this.ch.item(d);
                k.al = g;
                return true;
            }
            return false;
        }
        aj(a, b, c, d, e, f) {
            if (a == null || a.ch || this.r3(this.bx) > 1 || this.r3(this.bx) == 0) {
                return super.aj(this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), e, f);
            }
            if (this.q3.f.count == 0) {
                return null;
            }
            let g = this.ui.cr.f;
            let h = this.bx.bu;
            let i = truncate(Math.ceil(h.width));
            if (g != d) {
                i = truncate(Math.ceil(h.width / (g - d)));
            }
            let j = -1;
            let k = -1;
            let l = this.fw(e);
            let m = this.g6(e, f);
            let n = this.g4(e, f);
            let o = truncate(Math.floor(m / this.r3(this.bx)));
            let p = truncate(Math.floor(n / this.r3(this.bx)));
            j = o - this.r4(this.bx);
            k = p - this.r4(this.bx);
            let q = j * i;
            let r = k * i;
            let s = 0;
            if (m != n) {
                s = (l - m) / (n - m);
            }
            let t = truncate(Math.floor(q + s * (r - q)));
            j = t;
            k = t + 1;
            if (j < 0) {
                j = 0;
            }
            if (j > this.q3.f.count - 1) {
                j = this.q3.f.count - 1;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.q3.f.count - 1) {
                k = this.q3.f.count - 1;
            }
            let u = this.q3.f._inner[j];
            let v = this.q3.f._inner[k];
            let w = new Array(2);
            w[0] = u;
            w[1] = v;
            return w;
        }
        si(a, b) {
            super.si(a, b);
            if (a.f.count <= 1) {
                return;
            }
            if (b.cr.d == 0) {
                return;
            }
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.tw;
            let g = this.t2;
            let h = new ScalerParams(0, c, d, f.cc, e);
            let i = ((() => {
                let $ret = new ScalerParams(0, c, d, g.cc, e);
                $ret.b = this.f2();
                return $ret;
            })());
            a.f.clear();
            a.m.clear();
            let j = this.pt();
            let k = 0;
            let l = typeCast(ISortingAxis_$type, this.tw);
            if (l != null && l.i$b.count != this.ch.count) {
                return;
            }
            let m = this.up(f, c, d, e);
            let n = b.cr.d;
            this.uu(b);
            let o = b.cr.f;
            let p = b.cr.e;
            let q = truncate(Math.ceil(d.width / (o - p)));
            let r = new CollisionAvoider();
            if (l != null) {
                this.uv(a, c, d, f, g, b);
                return;
            }
            let s = (t) => t;
            let t = (u) => this.valueColumn.item(u);
            let u = b;
            u.c6();
            let v = 0;
            let w = 0;
            for (let x = p; x <= o; ++x) {
                let y = null;
                if (n == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        if (j && this.ul(a, a.f._inner[a.f.count - 1], r, Math.min(x * n, this.ch.count - 1), k, b, v - 1)) {
                            ++k;
                        }
                        break;
                    }
                    let z = s(x);
                    let aa = t(x);
                    let ab = s(x + 1);
                    let ac = t(x + 1);
                    let ad = ab - z;
                    let ae = this.uh[x];
                    let af = this.uh[x + 1];
                    let ag = f.d8(z, h) + m;
                    let ah = g.d8(aa, i);
                    a.f.add([ag, ah, ah]);
                    v++;
                    w = v;
                    for (let ai = 1; ai < q; ++ai) {
                        let aj = z + ad * ai / q;
                        let ak = (ab - aj) / ad;
                        let al = (aj - z) / ad;
                        let am = ak * aa + al * ac + ((ak * ak * ak - ak) * ae + (al * al * al - al) * af) * (ad * ad) / 6;
                        aj = f.d8(aj, h) + m;
                        am = g.d8(am, i);
                        a.f.add([aj, am, am]);
                        v++;
                    }
                    if (j) {
                        y = b.cr.getBucket(x);
                        y[0] = (f.d8(y[0], h) + m);
                        y[1] = g.d8(y[1], i);
                        y[2] = g.d8(y[2], i);
                    }
                }
                else {
                    y = b.cr.getBucket(x);
                    if (!isNaN_(y[0])) {
                        y[0] = (f.d8(y[0], h) + m);
                        y[1] = g.d8(y[1], i);
                        y[2] = g.d8(y[2], i);
                        a.f.add(y);
                        v++;
                        w = v;
                    }
                }
                if (j && this.ul(a, y, r, Math.min(x * n, this.ch.count - 1), k, b, w - 1)) {
                    ++k;
                }
            }
            u.c8();
            b.cu.count = k;
        }
        uu(a) {
            let b = a.cr.d;
            let c = (d) => d;
            let d = (e) => this.valueColumn.item(e);
            if (b < 1 || this.valueColumn == null || this.valueColumn.count == 0) {
                return;
            }
            if ((this.uh == null || this.uh.length != this.valueColumn.count) && b == 1) {
                let e = this.uj == 0 ? NaN : 0;
                if (this.tw != null && typeCast(ISortingAxis_$type, this.tw) !== null && this.tw.i$b != null) {
                    let f = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.tw.i$b, NaN);
                    d = (g) => f.item(g);
                }
                this.uh = Numeric.c(this.valueColumn.count, c, d, e, e);
                if (this.uk) {
                    let g = -1.7976931348623157E+308;
                    let h = 1.7976931348623157E+308;
                    let i = this.uf(a);
                    if (i == null) {
                        return;
                    }
                    for (let j = 0; j < i.length; j++) {
                        if (isNaN_(i[j][0]) || isNaN_(i[j][1])) {
                            continue;
                        }
                        if (i[j][1] > g) {
                            g = i[j][1];
                        }
                        if (i[j][0] < h) {
                            h = i[j][0];
                        }
                    }
                    this.ur = h;
                    this.uq = g;
                }
            }
        }
        uo(a, b, c, d, e, f, g) {
            let h = d - b;
            let i = b + h * a;
            let j = (d - i) / h;
            let k = (i - b) / h;
            let l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
            return l;
        }
        f0(a, b, c, d, e, f, g, h) {
            let i = NaN;
            if (c >= 0 && c < b.count) {
                i = b.item(c);
            }
            let j = NaN;
            if (d >= 0 && d < b.count) {
                j = b.item(d);
            }
            if (f == 0) {
                return j;
            }
            if (e == b.count - 1) {
                return i;
            }
            if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
                return i;
            }
            if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
                return j;
            }
            let k = e;
            let l = f;
            let m = i;
            let n = j;
            let o = NaN;
            let p = NaN;
            if (this.uh != null && e >= 0 && e < this.uh.length) {
                o = this.uh[e];
            }
            if (this.uh != null && f >= 0 && f < this.uh.length) {
                p = this.uh[f];
            }
            return this.uo(a, k, m, l, n, o, p);
        }
        up(a, b, c, d) {
            let e = this.preferredCategoryMode(a);
            if (e == 0 && a.categoryMode != 0) {
                e = 1;
            }
            let f = 0;
            switch (e) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    f = a.getGroupCenter(this.g9, b, c, d);
                    break;
            }
            if (a.cc) {
                f = -f;
            }
            return f;
        }
        get ur() {
            return this.un;
        }
        set ur(a) {
            this.un = a;
        }
        get uq() {
            return this.um;
        }
        set uq(a) {
            this.um = a;
        }
        uw() {
            this.uh = null;
            this.ur = NaN;
            this.uq = NaN;
            if (this.yAxis != null) {
                this.yAxis.cv();
            }
        }
        lm(a, b, c, d) {
            switch (b) {
                case "ValueColumn":
                case "FastItemsSource":
                    this.uw();
                    break;
            }
            super.lm(a, b, c, d);
            switch (b) {
                case SplineSeriesBase.$$p[1]:
                    this.uw();
                    this.l0(false);
                    this.k7();
                    break;
            }
        }
        kk(a, b, c, d) {
            this.uw();
            super.kk(a, b, c, d);
        }
        get useHighMarkerFidelity() {
            return this.ry;
        }
    }
    SplineSeriesBase.$t = markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
    SplineSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['IsSplineShapePartOfRange:uk:ux', [0, false], 'SplineType:uj:uy', [SplineType_$type, enumGetBox(SplineType_$type, 0)]]);
    return SplineSeriesBase;
})();
/**
 * @hidden
 */
export let SplineSeriesBaseView = /*@__PURE__*/ (() => {
    class SplineSeriesBaseView extends AnchoredCategorySeriesView {
        constructor(a) {
            super(a);
            this.da = null;
            this.da = a;
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        }
    }
    SplineSeriesBaseView.$t = markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);
    return SplineSeriesBaseView;
})();
//# sourceMappingURL=SplineSeriesBase_combined.js.map
