/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { TRIXIndicatorStrategy } from "./TRIXIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export let TRIXIndicator = /*@__PURE__*/ (() => {
    class TRIXIndicator extends StrategyBasedIndicator {
        constructor() {
            super();
            this.s3 = 0;
            this.trendLineBrush = ((() => {
                let $ret = new Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            this.trendLineType = 9;
            this.trendLinePeriod = 9;
        }
        get_tv() {
            return new TRIXIndicatorStrategy();
        }
        get tv() {
            return this.get_tv();
        }
        get_t8() {
            return TRIXIndicator.$;
        }
        get t8() {
            return this.get_t8();
        }
        get ug() {
            return typeGetValue(this.c(TRIXIndicator.uh));
        }
        set ug(a) {
            this.h(TRIXIndicator.uh, a);
        }
        t1() {
            return this.ug;
        }
        ua(a) {
            this.ug = a;
        }
    }
    TRIXIndicator.$t = markType(TRIXIndicator, 'TRIXIndicator', StrategyBasedIndicator.$);
    TRIXIndicator.uh = StrategyBasedIndicator.ud(15, TRIXIndicator.$);
    return TRIXIndicator;
})();
//# sourceMappingURL=TRIXIndicator.js.map
