/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep, TypeRegistrar } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "igniteui-angular-core";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { MathUtil } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue, dateFromTicks } from "igniteui-angular-core";
/**
 * @hidden
 */
export let TimeAxisBase = /*@__PURE__*/ (() => {
    class TimeAxisBase extends CategoryAxisBase {
        constructor() {
            super();
            this.ln = null;
            this.lw = null;
            this.lr = false;
            this.lz = dateMaxValue();
            this.ly = dateMinValue();
            FastItemDateTimeColumn.o();
        }
        d8(a, b) {
            if (!b.c.isEmpty) {
                let c = this.l4(a, NumericScaler.ac, b.c, Rect.empty);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.l4(a, b.e, b.d, b.c);
        }
        fg(a, b) {
            let c = this.gb(b);
            if (c == this.dateTimeMemberPath) {
                return this.fh(a, b, this.dateTimeMemberPath);
            }
            return super.fg(a, b);
        }
        l4(a, b, c, d) {
            let e;
            if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
                e = -1;
            }
            else {
                e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            }
            let f = 0;
            if (this.categoryMode == 2) {
                f = this.getGroupCenter(0, b, c, d);
            }
            if (this.cc) {
                e = 1 - e;
                f = -f;
            }
            return c.left + c.width * (e - b.left) / b.width - f;
        }
        l5(a, b, c) {
            let d;
            if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
                d = -1;
            }
            else {
                d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            }
            let e = 0;
            if (this.cc) {
                d = 1 - d;
                e = -e;
            }
            return c.left + c.width * (d - b.left) / b.width - e;
        }
        eb(a, b) {
            if (!b.c.isEmpty) {
                let c = b.d.left;
                let d = b.d.width;
                if (this.categoryMode != 0) {
                    let e = this.getCategorySize(b.e, b.d, b.c);
                    c += e / 2;
                    d -= e;
                }
                let f = b.e.left + b.e.width * (a - c) / b.d.width;
                f = (f * b.d.width) + b.d.left;
                f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
                return f;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        }
        getUnscaledValue3(a, b, c, d) {
            let e = b.left + b.width * (a - c.left) / c.width;
            if (this.cc) {
                e = 1 - e;
            }
            return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
        }
        i$h() {
            this.mk();
        }
        mk() {
            let a = this.bh != null ? this.bh.pg : Rect.empty;
            let b = !a.isEmpty ? this.js : Rect.empty;
            let c = (new Date());
            let d = (new Date());
            let e = false;
            if (!a.isEmpty && !b.isEmpty && this.lo != null) {
                let f = typeCast(FastItemDateTimeColumn.$, this.lo);
                if (f != null) {
                    if (this.lx == null) {
                        this.ml();
                    }
                }
                else {
                    this.lx = null;
                }
                if (this.lo.count > 0) {
                    e = true;
                    let g = this.lx == null ? 0 : this.lx._inner[0];
                    let h = this.lx == null ? this.lo.count - 1 : this.lx._inner[this.lo.count - 1];
                    c = this.lo.item(g);
                    d = this.lo.item(h);
                    this.ls = false;
                    if (this.categoryMode == 2) {
                        let i = this.mi(c, d);
                        if (+c != +(dateMinValue())) {
                            c = dateSubtract(+c, +i);
                        }
                        d = dateAdd(+d, +i);
                    }
                }
            }
            if (this.lv()) {
                e = true;
                c = this.minimumValue;
            }
            if (this.lu()) {
                e = true;
                d = this.maximumValue;
            }
            let j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
            if (e && j) {
                let k = this.actualMinimumValue;
                let l = this.actualMaximumValue;
                this.actualMinimumValue = c;
                this.actualMaximumValue = d;
                this.mp();
            }
        }
        mp() {
        }
        get lo() {
            return this.ln;
        }
        set lo(a) {
            if (this.ln != a) {
                let b = this.ln;
                this.ln = a;
                this.hk("DateTimeColumn", b, this.ln);
            }
        }
        get lx() {
            return this.lw;
        }
        set lx(a) {
            this.lw = a;
        }
        get i$b() {
            if (this.lx == null) {
                let a = typeCast(FastItemDateTimeColumn.$, this.lo);
                if (a != null) {
                    this.ml();
                }
                else {
                    this.lx = null;
                }
            }
            return this.lx;
        }
        ml() {
            if (this.lt) {
                this.lx = new List$1(Number_$type, 0);
                let a = this.lx;
                let b = this.lo.count;
                for (let c = 0; c < b; c++) {
                    a.add(c);
                }
            }
            else {
                let d = typeCast(FastItemDateTimeColumn.$, this.lo);
                this.lx = d.h();
            }
        }
        i$e(a, b, c, d) {
            return this.l7(a, b, c, d);
        }
        l7(a, b, c, d) {
            if (b.isEmpty) {
                return -1;
            }
            let e = d;
            let f = new ScalerParams(0, a, b, this.cc, c);
            let g, h;
            if (this.cc) {
                h = this.eb(e.left, f);
                g = this.eb(e.right, f);
            }
            else {
                g = this.eb(e.left, f);
                h = this.eb(e.right, f);
            }
            let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
            return this.l6(dateFromTicks(i));
        }
        l6(a) {
            if (this.lo == null || this.lx.count != this.lo.count) {
                return -1;
            }
            let b = new SortedListView$1(Date_$type, this.lo, this.lx);
            let c = this.l8(a, b);
            if (c >= 0 && c < this.lx.count) {
                let d = this.lo.item(this.lx._inner[c]);
                if (d > a) {
                    c--;
                    if (c < 0) {
                        c = 0;
                    }
                }
                return c;
            }
            return this.lx.count - 1;
        }
        i$g(a, b, c, d) {
            return this.ma(a, b, c, d);
        }
        ma(a, b, c, d) {
            if (b.isEmpty) {
                return -1;
            }
            let e = d;
            let f = new ScalerParams(0, a, b, this.cc, c);
            let g, h;
            if (this.cc) {
                h = this.eb(e.left, f);
                g = this.eb(e.right, f);
            }
            else {
                g = this.eb(e.left, f);
                h = this.eb(e.right, f);
            }
            let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
            return this.l9(dateFromTicks(i));
        }
        l9(a) {
            if (this.lo == null || this.lx.count != this.lo.count) {
                return -1;
            }
            let b = new SortedListView$1(Date_$type, this.lo, this.lx);
            let c = this.l8(a, b);
            if (c >= this.lx.count) {
                c = this.lx.count - 1;
            }
            if (c >= 0 && c < this.lx.count) {
                let d = this.lo.item(this.lx._inner[c]);
                if (d < a) {
                    c++;
                    if (c > this.lx.count - 1) {
                        c = this.lx.count - 1;
                    }
                }
                return c;
            }
            return 0;
        }
        i$d(a) {
            if (this.lo == null) {
                return NaN;
            }
            let b = this.ln.item(a);
            let c = b.getTime();
            let d = c;
            return d;
        }
        i$c(a) {
            let b = this;
            if (b.i$b == null) {
                return -1;
            }
            let c = new SortedListView$1(Date_$type, this.lo, b.i$b);
            let ticks_ = a;
            let d = (new Date(ticks_));
            let e = this.l8(d, c);
            if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
                let diff1_ = d.getTime() - c.item(e - 1).getTime();
                let diff2_ = c.item(e).getTime() - d.getTime();
                let f = e - 1;
                let g = e;
                if (f < 0 && g >= 0) {
                    return g;
                }
                if (g > b.i$b.count - 1 && f < b.i$b.count) {
                    return f;
                }
                if (f < 0 && g < 0) {
                    return -1;
                }
                if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                    return -1;
                }
                let h = diff1_ / (diff1_ + diff2_);
                if (isNaN_(h)) {
                    h = 0;
                }
                return f + h;
            }
            if (e >= 0 && e < b.i$b.count) {
                return e;
            }
            let i = this.jn();
            if (e == b.i$b.count && this.bh != null && this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, i)) < (this.js.right + 2)) {
                return e - 1;
            }
            if (e == -1 && this.bh != null && Math.abs(this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, i)) - this.js.left) < 2) {
                return 0;
            }
            return -1;
        }
        l8(a, b) {
            let c = this;
            if (this.lo == null || c.i$b == null) {
                return -1;
            }
            let d = -1;
            let e = ArrayExtension.binarySearch$11(Date_$type, b, (f) => {
                if (a < f) {
                    return -1;
                }
                if (a > f) {
                    return 1;
                }
                return 0;
            });
            if (e >= 0) {
                d = e;
            }
            else {
                d = ~e;
            }
            while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
                d--;
            }
            return d;
        }
        i$f(a) {
            let b = this;
            if (b.i$b == null || this.lo == null || b.i$b.count != this.lo.count) {
                return -1;
            }
            let c = new SortedListView$1(Date_$type, this.lo, b.i$b);
            let ticks_ = a;
            let d = (new Date(ticks_));
            let e = this.l8(d, c);
            let f = this.jn();
            if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
                let g = +d - +(c.item(e - 1));
                let h = +(c.item(e)) - +d;
                if (g < h) {
                    e = e - 1;
                }
            }
            if (e >= 0 && e < b.i$b.count) {
                return b.i$b._inner[e];
            }
            if (e == b.i$b.count && this.bh != null && this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, f)) < (this.js.right + 2)) {
                return e - 1;
            }
            if (e == -1 && this.bh != null && Math.abs(this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, f)) - this.js.left) < 2) {
                return 0;
            }
            return -1;
        }
        i$i() {
            this.lx = null;
            this.hp();
        }
        get_ls() {
            return this.lr;
        }
        set_ls(a) {
            this.lr = a;
        }
        get ls() {
            return this.get_ls();
        }
        set ls(a) {
            this.set_ls(a);
        }
        hg(a) {
            super.hg(a);
            this.dateTimeMemberPath = a;
        }
        hj(a) {
            super.hj(a);
            this.minimumValue = a;
        }
        hi(a) {
            super.hj(a);
            this.maximumValue = a;
        }
        cx() {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            let a = this.actualMinimumValue.getTime();
            let b = this.actualMaximumValue.getTime();
            this.mk();
            let c = !this.lv() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
            let d = !this.lu() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
            let e = new AxisRangeChangedEventArgs(0, a, c, b, d);
            this.hl(e);
            return true;
        }
        lv() {
            if (+(this.minimumValue) == +(dateMinValue())) {
                return false;
            }
            return (this.minimumValue != null);
        }
        lu() {
            if (+(this.maximumValue) == +(dateMaxValue())) {
                return false;
            }
            return (this.maximumValue != null);
        }
        get actualMinimumValue() {
            return this.lz;
        }
        set actualMinimumValue(a) {
            let b = +(this.lz) != +a;
            if (b) {
                let c = this.lz;
                this.lz = a;
                this.hk("ActualMinimumValue", c, a);
            }
        }
        fl() {
            return this.actualMinimumValue;
        }
        get actualMaximumValue() {
            return this.ly;
        }
        set actualMaximumValue(a) {
            let b = +(this.ly) != +a;
            if (b) {
                let c = this.ly;
                this.ly = a;
                this.hk("ActualMaximumValue", c, a);
            }
        }
        fk() {
            return this.maximumValue;
        }
        mm(a) {
            this.hr(a);
            if (this.j6 == null) {
                return;
            }
            for (let b of fromEnum(this.c4())) {
                b.l0(a);
            }
        }
        he(a, b, c, d) {
            super.he(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.lo);
                        this.lo = null;
                        e.event = delegateRemove(e.event, runOn(this, this.mj));
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.lx = null;
                        this.lo = this.lp(this.dateTimeMemberPath);
                        f.event = delegateCombine(f.event, runOn(this, this.mj));
                    }
                    this.mm(false);
                    break;
                case TimeAxisBase.$$p[0]:
                    if (this.j6 != null) {
                        this.j6.deregisterColumn(this.lo);
                        this.lo = this.lp(this.dateTimeMemberPath);
                        this.lx = null;
                    }
                    break;
                case TimeAxisBase.$$p[3]:
                    this.cv();
                    this.mm(false);
                    break;
                case TimeAxisBase.$$p[2]:
                    this.cv();
                    this.mm(false);
                    break;
                case "DateTimeColumn":
                    this.mk();
                    break;
            }
        }
        mj(a, b) {
            this.lx = null;
        }
        lp(a) {
            return TimeAxisBase.lq(a, this);
        }
        static lq(a, b) {
            if (a == null) {
                return b.j6.registerColumnDateTime(null, null, false);
            }
            let c = null;
            let d = SeriesViewer.b1(a, b.coercionMethods);
            c = d.a;
            return b.j6.registerColumnDateTime(a, c, b.expectFunctions);
        }
        au() {
            if (this.cz) {
                return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        }
        get_a1() {
            return 0;
        }
        get a1() {
            return this.get_a1();
        }
        hr(a) {
            super.hr(a);
            let b = this.a4.ay();
            let c = this.a4.a1();
            let d = this.a4.az();
            let e = this.a4.a0();
            let f = this.a4.e();
            let g = this.a4.f();
            let h = this.a4.g();
            this.h0();
            this.g0(b);
            this.g0(c);
            this.g0(d);
            this.g0(e);
            this.c5.clear();
            this.c6.clear();
            this.kd.clear();
            this.av.ac = this;
            let i = this.bh != null ? this.bh.pg : Rect.empty;
            let j = !i.isEmpty ? this.js : Rect.empty;
            this.av.cx = i;
            this.av.cw = j;
            if (i.isEmpty || j.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0) {
                this.av.ab.clear();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            this.mk();
        }
        get_b9() {
            return true;
        }
        startCursor() {
        }
        resetCursor() {
        }
        StartTimeCursor() {
            this.startCursor();
        }
        ResetTimeCursor() {
            this.resetCursor();
        }
        getCategorySize(a, b, c) {
            if (this.kq == 0) {
                return 0;
            }
            let d = this.jq(b, c);
            return d.width / (this.kq * a.width);
        }
        getGroupCenter(a, b, c, d) {
            return this.getCategorySize(b, c, d) * 0.5;
        }
        ki(a, b, c) {
            let d = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
            let e = 1 - 0.5 * d;
            let f = this.getCategorySize(a, b, c) * e;
            return f;
        }
        get_ch() {
            return true;
        }
        mi(a, b) {
            return (0);
        }
        preferredCategoryMode(a) {
            return this.b7 ? 0 : 1;
        }
        get isVertical() {
            return this.cj;
        }
        j$c(a, b) {
            return this.eb.apply(this, arguments);
        }
        j$b(a, b) {
            return this.d8.apply(this, arguments);
        }
        j$d(a, b, c, d, e) {
            this.g4.apply(this, arguments);
        }
        j$e(a, b, c, d) {
            this.g5.apply(this, arguments);
        }
        j$f(a, b, c, d) {
            this.g6.apply(this, arguments);
        }
        get j$a() {
            return this.cc;
        }
        get i$a() {
            return this.b9;
        }
    }
    TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'hk', ['DateTimeMemberPath::mq', [2, null], 'IsDataPreSorted:lt:mr', [0, false], 'MaximumValue::ms', [3, null], 'MinimumValue::mt', [3, null]]);
    return TimeAxisBase;
})();
//# sourceMappingURL=TimeAxisBase.js.map
