/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Point_$type, typeCast, Delegate_$type, markType, markDep } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { AxisAnnotationFrame } from "./AxisAnnotationFrame";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { SeriesView } from "./SeriesView";
import { NotImplementedException } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { stringFormat } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ValueOverlay = /*@__PURE__*/ (() => {
    class ValueOverlay extends Series {
        constructor() {
            super();
            this.py = 0;
            this.pz = 0;
            this.pv = 0;
            this.pj = null;
            this.pp = null;
            this.po = null;
            this.ab = ValueOverlay.$;
        }
        f8(a, b, c) {
            return this.p0;
        }
        pw(a, b) {
            let c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
            let d = Math.acos((a.x - b.x) / c);
            if ((a.y - b.y) < 0) {
                d = (2 * Math.PI) - d;
            }
            return d;
        }
        o2(a, b, c) {
            if (this.pi == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.px();
            let e = NaN;
            let f = NaN;
            let g = NaN;
            let h = { $type: Point_$type, x: 0.5, y: 0.5 };
            let i = NaN;
            switch (this.pi.a1) {
                case 2:
                    i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                    g = d;
                    e = h.x + Math.cos(g) * i;
                    f = h.y + Math.sin(g) * i;
                    f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
                    e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
                    break;
                case 0:
                    e = d;
                    f = a.y;
                    f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
                    break;
                case 1:
                    f = d;
                    e = a.x;
                    e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
                    break;
                case 3:
                    g = this.pw(a, h);
                    i = d;
                    e = h.x + Math.cos(g) * i;
                    f = h.y + Math.sin(g) * i;
                    f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
                    e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
                    break;
            }
            return { $type: Point_$type, x: e, y: f };
        }
        g0(a) {
            throw new NotImplementedException(0);
        }
        hh(a) {
            return this;
        }
        eh(a) {
            return false;
        }
        ap(a) {
            let b = typeCast(NumericAxisBase.$, a);
            let c = this.p0;
            if (isNaN_(c) || isInfinity(c)) {
                return null;
            }
            return new AxisRange(c, c);
        }
        l1(a) {
            this.kh(true, this.bx);
            if (!this.pn()) {
                if (this.pj != null) {
                    this.qi(NaN, this.cr());
                }
                return;
            }
            if (this.ei(a)) {
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    let b = this.py;
                    this.py = this.pz;
                    this.pz = b;
                }
                else {
                    this.py = this.pv;
                }
                this.pv = this.px();
                this.l8();
            }
            else {
                this.pv = this.px();
                this.qh(this.pv, this.pl);
            }
        }
        px() {
            let a, b;
            let c = this.getViewInfo(b, a);
            b = c.p0;
            a = c.p1;
            let d = this.getEffectiveViewport1(this.bx);
            let e = new ScalerParams(0, a, b, this.pi.cc, d);
            return this.pi.d8(this.p0, e);
        }
        qh(a, b) {
            if (this.pi == null) {
                return;
            }
            let c = typeCast(CategoryAxisBase.$, this.pi);
            if (c != null && !c.b9) {
                if (this.p0 > c.kr - 1) {
                    return;
                }
                if (c.categoryMode != 0) {
                    let d = this.getEffectiveViewport1(b);
                    let e = 0.5 * c.getCategorySize(b.bv, b.bu, d);
                    let f = false;
                    if (c.cj && !c.cc) {
                        f = true;
                    }
                    if (typeCast(CategoryXAxis.$, c) !== null && c.cc) {
                        f = true;
                    }
                    if (f) {
                        e = -e;
                    }
                    a += e;
                }
            }
            let g = typeCast(NumericAxisBase.$, this.pi);
            if (g != null) {
                if (this.p0 < g.kv || this.p0 > g.ku) {
                    return;
                }
                if (g.kl && this.p0 < 0) {
                    return;
                }
            }
            let h;
            switch (this.pi.a1) {
                case 2:
                case 3:
                    h = this.pi.jk(a, b.bv, b.bu, this.getEffectiveViewport1(b), this.o7(b));
                    break;
                default:
                    h = this.pi.jk(a, b.bv, b.bu);
                    break;
            }
            if (h != null) {
                b.by(h);
            }
            if (!b.q) {
                this.qi(a, this.cr());
            }
        }
        e3(a, b, c) {
            let d = true;
            d = super.e3(a, b, c);
            if (!c.o() || b.isEmpty || a.isEmpty || this.pi == null || this.pi.bh == null) {
                d = false;
            }
            return d;
        }
        mn(a, b) {
            this.l0(false);
        }
        mm(a, b) {
            this.l0(false);
        }
        kk(a, b, c, d) {
            throw new NotImplementedException(0);
        }
        lm(a, b, c, d) {
            super.lm(a, b, c, d);
            switch (b) {
                case ValueOverlay.$$p[10]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.pz = this.py + this.gn * (this.pv - this.py);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.qh(this.pv, this.pl);
                    }
                    else {
                        this.qh(this.pz, this.pl);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case ValueOverlay.$$p[12]:
                    let e = typeCast(NumericAxisBase.$, this.pi);
                    if (e != null) {
                        e.cv();
                    }
                    this.l0(true);
                    this.k8();
                    break;
                case ValueOverlay.$$p[11]:
                case ValueOverlay.$$p[9]:
                case ValueOverlay.$$p[0]:
                case ValueOverlay.$$p[2]:
                case ValueOverlay.$$p[3]:
                case ValueOverlay.$$p[8]:
                case ValueOverlay.$$p[4]:
                case ValueOverlay.$$p[5]:
                case ValueOverlay.$$p[6]:
                case ValueOverlay.$$p[7]:
                    this.l0(true);
                    break;
            }
        }
        ky() {
            super.ky();
            if (this.pi != null) {
                this.pi.hq(false);
            }
        }
        kh(a, b) {
            super.kh(a, b);
            let c = b;
            c.bx();
        }
        pn() {
            if (this.pi == null || this.pi.bh == null || isNaN_(this.p0) || this._visibility != 0) {
                return false;
            }
            let a = typeCast(CategoryAxisBase.$, this.pi);
            if (a != null && a.kr == 0) {
                return false;
            }
            return true;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        get categoryAxis() {
            return typeCast(CategoryAxisBase.$, this.pi);
        }
        bu() {
            return new ValueOverlayView(this);
        }
        lh(a) {
            super.lh(a);
            this.pl = typeCast(ValueOverlayView.$, a);
        }
        l2(a, b) {
            super.l2(a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw) || !this.pn()) {
                return;
            }
            let c = this.getEffectiveViewport1(this.bx);
            let d = this.pi.d8(this.p0, new ScalerParams(0, this.bw.bv, a, this.pi.cc, c));
            this.qh(d, typeCast(ValueOverlayView.$, this.bw));
            this.et = false;
        }
        getOffsetValue() {
            return 0;
        }
        getCategoryWidth() {
            return 0;
        }
        get qz() {
            return new Thickness(1, this.pr, this.pt, this.ps, this.pq);
        }
        ag() {
            return [this.pi];
        }
        qi(a, b) {
            if (isNaN_(a)) {
                if (this.pj != null) {
                    AxisAnnotationFrameManager.b(this.pj);
                    AxisAnnotationFrameManager.d(this, this.pj, true, this.po, this.pp, b, this.p1, this.p1, this.pk, this.pk);
                }
                return;
            }
            let c = false;
            if (this.po == null) {
                c = true;
                this.pp = new List$1(Axis.$, 0);
                this.po = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            this.pj = new AxisAnnotationFrame();
            let d = this.of;
            if (d == null) {
                d = this.oj;
            }
            let e = this.pi.cj;
            AxisAnnotationFrameManager.c(this.pj, { $type: Point_$type, x: a, y: a }, this, this.ca, this.getEffectiveViewport(), d, this.qw, this.qy, this.qx, this.qz, this.pu, this.qw, this.qy, this.qx, this.qz, this.pu, !e && this.pm, e && this.pm);
            AxisAnnotationFrameManager.d(this, this.pj, c, this.po, this.pp, b, this.p1, this.p1, this.pk, this.pk);
        }
        get_ed() {
            return true;
        }
        qd(a) {
            if (this.pi != null) {
                return this.pi.fw(a);
            }
            return null;
        }
        get qf() {
            let a = this.qd(this.p0);
            return a != null ? a : stringFormat("{0:0.##}", this.p0);
        }
    }
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackground:qw:qj', [Brush.$, null], 'AxisAnnotationFormatLabel:pk:qk', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:p1:ql', [1, -1], 'AxisAnnotationOutline:qx:qm', [Brush.$, null], 'AxisAnnotationPaddingBottom:pq:qn', [1, NaN], 'AxisAnnotationPaddingLeft:pr:qo', [1, NaN], 'AxisAnnotationPaddingRight:ps:qp', [1, NaN], 'AxisAnnotationPaddingTop:pt:qq', [1, NaN], 'AxisAnnotationStrokeThickness:pu:qr', [1, NaN], 'AxisAnnotationTextColor:qy:qs', [Brush.$, null], 'Axis:pi:qt', [Axis.$, null], 'IsAxisAnnotationEnabled:pm:qu', [0, false], 'Value:p0:qv', [1, 0]]);
    return ValueOverlay;
})();
/**
 * @hidden
 */
export let ValueOverlayView = /*@__PURE__*/ (() => {
    class ValueOverlayView extends SeriesView {
        constructor(a) {
            super(a);
            this.bz = null;
            this.bz = new Path();
        }
        bb() {
            super.bb();
            this.bz._stroke = this.e.of;
            this.bz.ac = this.e.fl;
            this.bz.ai = this.e.os;
            this.bz.ad = this.e.ot;
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.bz._stroke = a;
            this.bz.ac = this.e.fl + 3;
            this.bz._stroke = a;
            this.bz.ac = this.e.fl + 3;
        }
        by(a) {
            this.bz.ak = a;
            this.aq();
        }
        bx() {
            this.bz.ak = null;
            this.aq();
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                a.s(this.bz);
            }
        }
        al(a) {
            super.al(a);
            this.e.a6.exportPathData(a, this.bz, "ValueOverlayPath", []);
        }
    }
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
})();
//# sourceMappingURL=ValueOverlay_combined.js.map
