import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { TreemapNodeStyleMappingTargetType_$type } from "./TreemapNodeStyleMappingTargetType";
import { TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgxTreemapNodeStyleComponent } from "./igx-treemap-node-style-component";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-angular-core";
import * as i0 from "@angular/core";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export let IgxTreemapNodeStyleMappingComponent = /*@__PURE__*/ (() => {
    class IgxTreemapNodeStyleMappingComponent extends IgxTreemapNodeStyleComponent {
        constructor() {
            super();
        }
        createImplementation() {
            return new TreemapNodeStyleMapping();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        /**
         * Gets or sets the unique name of the mapping.
        */
        get targetType() {
            return this.i.bf;
        }
        set targetType(v) {
            this.i.bf = ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
        }
        /**
         * Gets or sets the unique name of the mapping.
        */
        get name() {
            return this.i.bs;
        }
        set name(v) {
            this.i.bs = v;
        }
        /**
         * Gets or sets the minimum value to which the mapping applies.
        */
        get minimumValue() {
            return this.i.bl;
        }
        set minimumValue(v) {
            this.i.bl = +v;
        }
        /**
         * Gets or sets the maximum value to which the mapping applies.
        */
        get maximumValue() {
            return this.i.bk;
        }
        set maximumValue(v) {
            this.i.bk = +v;
        }
        /**
         * Gets or sets the value to which the mapping applies.
        */
        get value() {
            return this.i.bn;
        }
        set value(v) {
            this.i.bn = v;
        }
        /**
         * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
        */
        get mappingMode() {
            return this.i.bh;
        }
        set mappingMode(v) {
            this.i.bh = ensureEnum(TreemapValueMappingMode_$type, v);
        }
    }
    IgxTreemapNodeStyleMappingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    IgxTreemapNodeStyleMappingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTreemapNodeStyleMappingComponent, selector: "igx-treemap-node-style-mapping", inputs: { targetType: "targetType", name: "name", minimumValue: "minimumValue", maximumValue: "maximumValue", value: "value", mappingMode: "mappingMode" }, providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(() => IgxTreemapNodeStyleMappingComponent) }], usesInheritance: true, ngImport: i0, template: ``, isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
    return IgxTreemapNodeStyleMappingComponent;
})();
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'igx-treemap-node-style-mapping',
                    template: ``,
                    providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(() => IgxTreemapNodeStyleMappingComponent) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { targetType: [{
                type: Input
            }], name: [{
                type: Input
            }], minimumValue: [{
                type: Input
            }], maximumValue: [{
                type: Input
            }], value: [{
                type: Input
            }], mappingMode: [{
                type: Input
            }] } });
//# sourceMappingURL=igx-treemap-node-style-mapping-component.js.map
