/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "igniteui-angular-core";
import { MathUtil } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { AxisDefaults } from "./AxisDefaults";
/**
 * @hidden
 */
var CategoryXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryXAxis, _super);
    function CategoryXAxis() {
        var _this = _super.call(this) || this;
        _this.l1 = 1;
        _this.l0 = 1;
        _this.l4 = null;
        _this.lr = 0;
        _this.ls = 0;
        _this.kd = new List$1(Number_$type, 0);
        _this.ab = CategoryXAxis.$;
        return _this;
    }
    CategoryXAxis.prototype.a3 = function () {
        return new CategoryXAxisView(this);
    };
    CategoryXAxis.prototype.ha = function (a) {
        _super.prototype.ha.call(this, a);
        this.lo = a;
    };
    Object.defineProperty(CategoryXAxis.prototype, "l3", {
        get: function () {
            return this.l1;
        },
        set: function (a) {
            this.l1 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "l2", {
        get: function () {
            return this.l0;
        },
        set: function (a) {
            this.l0 = a;
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.au = function () {
        if (this.cz) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    CategoryXAxis.prototype.getCategorySize = function (a, b, c) {
        var d = this.jq(b, c);
        return d.width / (this.kq * a.width);
    };
    CategoryXAxis.prototype.ki = function (a, b, c) {
        var d = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
        var e = 0;
        if (!isNaN_(this.km)) {
            e = Math.min(this.km, 1);
        }
        else {
            e = 0;
        }
        ;
        var f = 1 - 0.5 * d;
        var g = this.ks == 0 ? 1 : this.ks;
        var h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    };
    CategoryXAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.ks > 1) {
            var f = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
            var g = 0;
            if (!isNaN_(this.km)) {
                g = Math.min(this.km, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.ks - (this.ks - 1) * g);
            var j = (h - i) / (this.ks - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryXAxis.prototype.dv = function () {
        return this.ly;
    };
    CategoryXAxis.prototype.l9 = function (a) {
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        b = b.copy();
        var c = this.js;
        var d = this.jp();
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, e, e, this.cc, d);
        var g = !b.isEmpty && !c.isEmpty && this.j6 != null ? this.j6.indexOf(a) : -1;
        var h = g > -1 ? this.d8(g, f) : NaN;
        if (!isNaN_(h) && this.bh.d0) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.bh.mt(b, false, true);
        }
    };
    CategoryXAxis.prototype.d8 = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.lx(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.lx(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.ln = function (a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    };
    CategoryXAxis.prototype.g4 = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.categoryMode == 0 ? this.kq - 1 : this.kq;
        if (l < 0) {
            l = 0;
        }
        var m = i.left;
        var n = i.width;
        var o = g.left;
        var p = g.width;
        var q = h.left;
        var r = h.width;
        var s = 0;
        var t = 1;
        var u = this.ln(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        var w;
        for (var x = 0; x < b.count; x++) {
            w = b.item(x);
            for (var y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    z = (z - q) / r;
                    var aa = q + r * (z - o) / p;
                    f[w] = aa;
                }
                else {
                    var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    };
    CategoryXAxis.prototype.d9 = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = this.lx(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.lx(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.lx = function (a, b, c, d) {
        var e = d == 0 ? this.kq - 1 : this.kq;
        if (e < 0) {
            e = 0;
        }
        var f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.cd) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    };
    CategoryXAxis.prototype.eb = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.ec = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + (a - c.left) * b.width / c.width;
        if (this.cd) {
            e = 1 - e;
        }
        var f = d == 0 ? this.kq - 1 : this.kq;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    };
    CategoryXAxis.prototype.ma = function (a, b) {
        if (a == NaN || b == NaN || this.j6 == null || this.j6.count == 0) {
            return;
        }
        var c = a / this.j6.count;
        var d = (b + 1) / this.j6.count;
        this.bh.pw = new Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
    };
    CategoryXAxis.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.bh != null ? this.bh.pg : Rect.empty;
        var c = this.js;
        var d = this.jn();
        var e = this.jm();
        var f = new ScalerParams(0, b, c, this.cc, d);
        var g = this.a4.ay();
        var h = this.a4.a1();
        var i = this.a4.az();
        var j = this.a4.a0();
        var k = this.a4.e();
        var l = this.a4.f();
        var m = this.a4.g();
        var n = this.j6;
        var o = this.lp();
        this.h0();
        this.g0(g);
        this.g0(h);
        this.g0(i);
        this.g0(j);
        this.c5.clear();
        this.c6.clear();
        this.kd.clear();
        this.a4.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0 && this.bp.count == 0) {
            this.a4.y();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            this.a4.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var p = this.eb(e.left, f);
            var q = this.eb(e.right, f);
            var r = 0;
            var s = false;
            if (this.cy) {
                var t = Math.abs(q - p);
                r = Math.ceil(t) + 1;
                if (this.cc) {
                    if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                        s = true;
                    }
                }
                else {
                    if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                        s = true;
                    }
                }
            }
            if (this.cc) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            if (this.cy) {
                if (Math.abs(q - p) < r) {
                    if (this.cc) {
                        if (s) {
                            q--;
                        }
                        else {
                            p++;
                        }
                    }
                    else {
                        if (s) {
                            q++;
                        }
                        else {
                            p--;
                        }
                    }
                }
            }
            var u = c.bottom;
            var v = u - c.top;
            if (this.ai != null) {
                var w = typeCast(NumericYAxis.$, this.ai);
                if (w != null) {
                    var x = this.hv(u, v, b, c, d, c.top, c.bottom);
                    u = x.p0;
                    v = x.p1;
                }
            }
            this.g8(g, u, c, k, true);
            this.a4.ao(v);
            var y = Math.min(p, q);
            var z = Math.max(p, q);
            var aa = e.width;
            if (this.cy) {
                var ab = this.d8(y, f);
                var ac = this.d8(z, f);
                aa = Math.abs(ac - ab);
            }
            var ad = new LinearCategorySnapper(1, y, z, aa, this.ly, this.categoryMode, this.el());
            var ae = ad.g;
            while (!this.lq() && ae < 10 && this.ct(ae, b, c, d)) {
                ae--;
            }
            if (ad.g != ae) {
                ad = new LinearCategorySnapper(1, y, z, aa, ae, this.categoryMode, this.el());
            }
            var af = Math.floor((y - 0) / ad.g);
            var ag = Math.ceil((z - 0) / ad.g);
            this.lt = ad.g;
            if (!isNaN_(af) && !isNaN_(ag)) {
                var ah = truncate(af);
                var ai = truncate(ag);
                var aj = this.lw(0 + ah * ad.g, f);
                var ak = this.d8(ad.g, f);
                var al = Math.abs(ak - this.d8(0, f));
                this.a4.ap(ak);
                var am = truncate(Math.ceil(e.right));
                var an = truncate(Math.floor(e.left));
                var ao = this.lz;
                var ap = ao > 0 && ao < ad.g;
                var aq = c.right;
                var ar = this.kd;
                var as = ad.g;
                var at = truncate(as);
                var au = this.ks;
                var av = this.cc;
                var aw = this.categoryMode;
                this.l4 = null;
                for (var ax = ah; ax <= ai; ++ax) {
                    var ay = this.lw(0 + (ax + 1) * ad.g, f);
                    if (aj <= aq) {
                        if (ax % 2 == 0) {
                            this.h2(h, aj, ay, c);
                        }
                        this.h1(i, aj, c, l, false);
                        ar.add(aj);
                    }
                    if (this.categoryMode != 0 && this.ks != 0 && this.cs) {
                        if (ap) {
                            var az = al * this.lz;
                            if (this.cc) {
                                var a0 = aj;
                                while (a0 - az > ay) {
                                    a0 -= az;
                                    if (Math.abs(a0 - ay) < 0.0001) {
                                        break;
                                    }
                                    this.h1(j, a0, c, m, false);
                                }
                            }
                            else {
                                var a1 = aj;
                                while (a1 + az < ay) {
                                    a1 += az;
                                    if (Math.abs(a1 - ay) < 0.0001) {
                                        break;
                                    }
                                    this.h1(j, a1, c, m, false);
                                }
                            }
                            this.lu = this.lz;
                        }
                        else {
                            for (var a2 = 0; a2 < truncate(ad.g); a2++) {
                                for (var a3 = 0; a3 < this.ks; a3++) {
                                    var a4 = this.getGroupCenter(a3, b, c, d);
                                    if (this.cc) {
                                        a4 = -a4;
                                    }
                                    var a5 = this.d8(a2 + ax * ad.g, f) + a4;
                                    this.h1(j, a5, c, m, false);
                                }
                            }
                            this.lu = 0.5;
                        }
                    }
                    var a6 = this.lv(ax * as, aj, aw == 0, f);
                    var a7 = truncate(Math.round(a6));
                    if (a7 >= an && a7 <= am) {
                        var a8 = 0;
                        if (as >= 1) {
                            a8 = ax * truncate(Math.floor(as));
                        }
                        else {
                            if ((ax * as) * 2 % 2 == 0) {
                                a8 = truncate(Math.floor(ax * as));
                            }
                            else {
                                a8 = -1;
                            }
                        }
                        if (o != null && a8 < n.count && a8 >= 0) {
                            var a9 = o.getItem(a8);
                            var ba = this.fi(a9);
                            this.l4 = a9;
                            if (!isNaN_(a6) && !isInfinity(a6) && ba != null) {
                                if ((typeof ba === 'string') && Base.equalsStatic(ba, "")) {
                                }
                                else {
                                    this.c5.add1(ba);
                                    this.c6.add(new LabelPosition(a6));
                                }
                            }
                        }
                    }
                    aj = ay;
                }
            }
            this.l4 = null;
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.jq();
                }
            }
            this.a4.au(this.c5, this.c6);
            this.ld();
        }
    };
    CategoryXAxis.prototype.cx = function () {
        if (this.ck && this.cy) {
            this.bb = this.ba();
        }
        if (this.j6 == null) {
            return false;
        }
        var a = this.j6.count;
        if (a != this.l2) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.l2, a);
            this.l2 = a;
            this.hl(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryXAxis.prototype, "ly", {
        get: function () {
            return this.c(CategoryXAxis.mb);
        },
        set: function (a) {
            this.h(CategoryXAxis.mb, a);
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.lq = function () {
        return !isNaN_(this.ly);
    };
    Object.defineProperty(CategoryXAxis.prototype, "lt", {
        get: function () {
            return this.lr;
        },
        set: function (a) {
            if (this.lt != a) {
                var b = this.lr;
                this.lr = a;
                this.hk("ActualInterval", b, this.lt);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.ej = function () {
        return this.lt;
    };
    Object.defineProperty(CategoryXAxis.prototype, "lz", {
        get: function () {
            return this.c(CategoryXAxis.mc);
        },
        set: function (a) {
            this.h(CategoryXAxis.mc, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "lu", {
        get: function () {
            return this.ls;
        },
        set: function (a) {
            if (this.lu != a) {
                var b = this.ls;
                this.ls = a;
                this.hk("ActualMinorInterval", b, this.lu);
            }
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.j9 = function (a) {
        if (a == null) {
            return false;
        }
        var b = this.bd();
        if (b == null) {
            return false;
        }
        return b.synchronizeHorizontally;
    };
    CategoryXAxis.prototype.get_a1 = function () {
        return 0;
    };
    Object.defineProperty(CategoryXAxis.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.lp = function () {
        return this.j6;
    };
    CategoryXAxis.prototype.lw = function (a, b) {
        return this.d8(a, b);
    };
    CategoryXAxis.prototype.lv = function (a, b, c, d) {
        if (!c) {
            var e = this.lw(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    };
    Object.defineProperty(CategoryXAxis.prototype, "isVertical", {
        get: function () {
            return this.cj;
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.prototype.j$c = function (a, b) {
        return this.eb.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$b = function (a, b) {
        return this.d8.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.g4.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$e = function (a, b, c, d) {
        this.g5.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$f = function (a, b, c, d) {
        this.g6.apply(this, arguments);
    };
    Object.defineProperty(CategoryXAxis.prototype, "j$a", {
        get: function () {
            return this.cc;
        },
        enumerable: false,
        configurable: true
    });
    CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
    CategoryXAxis.mb = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.hk("Interval", b.oldValue, b.newValue);
        a.hq(false);
    }));
    CategoryXAxis.mc = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryXAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).hq(false);
    }));
    return CategoryXAxis;
}(CategoryAxisBase));
export { CategoryXAxis };
/**
 * @hidden
 */
var CategoryXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryXAxisView, _super);
    function CategoryXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryXAxisView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        this.a.e0 = AxisDefaults.f;
    };
    CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
}(CategoryAxisBaseView));
export { CategoryXAxisView };
//# sourceMappingURL=CategoryXAxis_combined.js.map
