/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FastItemDateTimeColumn } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep, TypeRegistrar } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "igniteui-angular-core";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { MathUtil } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue, dateFromTicks } from "igniteui-angular-core";
/**
 * @hidden
 */
var TimeAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisBase, _super);
    function TimeAxisBase() {
        var _this = _super.call(this) || this;
        _this.ln = null;
        _this.lw = null;
        _this.lr = false;
        _this.lz = dateMaxValue();
        _this.ly = dateMinValue();
        FastItemDateTimeColumn.o();
        return _this;
    }
    TimeAxisBase.prototype.d8 = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.l4(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.l4(a, b.e, b.d, b.c);
    };
    TimeAxisBase.prototype.fg = function (a, b) {
        var c = this.gb(b);
        if (c == this.dateTimeMemberPath) {
            return this.fh(a, b, this.dateTimeMemberPath);
        }
        return _super.prototype.fg.call(this, a, b);
    };
    TimeAxisBase.prototype.l4 = function (a, b, c, d) {
        var e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.cc) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    };
    TimeAxisBase.prototype.l5 = function (a, b, c) {
        var d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var e = 0;
        if (this.cc) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    };
    TimeAxisBase.prototype.eb = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.d.left;
            var d = b.d.width;
            if (this.categoryMode != 0) {
                var e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            var f = b.e.left + b.e.width * (a - c) / b.d.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    TimeAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (this.cc) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    };
    TimeAxisBase.prototype.i$h = function () {
        this.mk();
    };
    TimeAxisBase.prototype.mk = function () {
        var a = this.bh != null ? this.bh.pg : Rect.empty;
        var b = !a.isEmpty ? this.js : Rect.empty;
        var c = (new Date());
        var d = (new Date());
        var e = false;
        if (!a.isEmpty && !b.isEmpty && this.lo != null) {
            var f = typeCast(FastItemDateTimeColumn.$, this.lo);
            if (f != null) {
                if (this.lx == null) {
                    this.ml();
                }
            }
            else {
                this.lx = null;
            }
            if (this.lo.count > 0) {
                e = true;
                var g = this.lx == null ? 0 : this.lx._inner[0];
                var h = this.lx == null ? this.lo.count - 1 : this.lx._inner[this.lo.count - 1];
                c = this.lo.item(g);
                d = this.lo.item(h);
                this.ls = false;
                if (this.categoryMode == 2) {
                    var i = this.mi(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.lv()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.lu()) {
            e = true;
            d = this.maximumValue;
        }
        var j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            var k = this.actualMinimumValue;
            var l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.mp();
        }
    };
    TimeAxisBase.prototype.mp = function () {
    };
    Object.defineProperty(TimeAxisBase.prototype, "lo", {
        get: function () {
            return this.ln;
        },
        set: function (a) {
            if (this.ln != a) {
                var b = this.ln;
                this.ln = a;
                this.hk("DateTimeColumn", b, this.ln);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "lx", {
        get: function () {
            return this.lw;
        },
        set: function (a) {
            this.lw = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$b", {
        get: function () {
            if (this.lx == null) {
                var a = typeCast(FastItemDateTimeColumn.$, this.lo);
                if (a != null) {
                    this.ml();
                }
                else {
                    this.lx = null;
                }
            }
            return this.lx;
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.ml = function () {
        if (this.lt) {
            this.lx = new List$1(Number_$type, 0);
            var a = this.lx;
            var b = this.lo.count;
            for (var c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            var d = typeCast(FastItemDateTimeColumn.$, this.lo);
            this.lx = d.h();
        }
    };
    TimeAxisBase.prototype.i$e = function (a, b, c, d) {
        return this.l7(a, b, c, d);
    };
    TimeAxisBase.prototype.l7 = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.cc, c);
        var g, h;
        if (this.cc) {
            h = this.eb(e.left, f);
            g = this.eb(e.right, f);
        }
        else {
            g = this.eb(e.left, f);
            h = this.eb(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
        return this.l6(dateFromTicks(i));
    };
    TimeAxisBase.prototype.l6 = function (a) {
        if (this.lo == null || this.lx.count != this.lo.count) {
            return -1;
        }
        var b = new SortedListView$1(Date_$type, this.lo, this.lx);
        var c = this.l8(a, b);
        if (c >= 0 && c < this.lx.count) {
            var d = this.lo.item(this.lx._inner[c]);
            if (d > a) {
                c--;
                if (c < 0) {
                    c = 0;
                }
            }
            return c;
        }
        return this.lx.count - 1;
    };
    TimeAxisBase.prototype.i$g = function (a, b, c, d) {
        return this.ma(a, b, c, d);
    };
    TimeAxisBase.prototype.ma = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.cc, c);
        var g, h;
        if (this.cc) {
            h = this.eb(e.left, f);
            g = this.eb(e.right, f);
        }
        else {
            g = this.eb(e.left, f);
            h = this.eb(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
        return this.l9(dateFromTicks(i));
    };
    TimeAxisBase.prototype.l9 = function (a) {
        if (this.lo == null || this.lx.count != this.lo.count) {
            return -1;
        }
        var b = new SortedListView$1(Date_$type, this.lo, this.lx);
        var c = this.l8(a, b);
        if (c >= this.lx.count) {
            c = this.lx.count - 1;
        }
        if (c >= 0 && c < this.lx.count) {
            var d = this.lo.item(this.lx._inner[c]);
            if (d < a) {
                c++;
                if (c > this.lx.count - 1) {
                    c = this.lx.count - 1;
                }
            }
            return c;
        }
        return 0;
    };
    TimeAxisBase.prototype.i$d = function (a) {
        if (this.lo == null) {
            return NaN;
        }
        var b = this.ln.item(a);
        var c = b.getTime();
        var d = c;
        return d;
    };
    TimeAxisBase.prototype.i$c = function (a) {
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.lo, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.l8(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var diff1_ = d.getTime() - c.item(e - 1).getTime();
            var diff2_ = c.item(e).getTime() - d.getTime();
            var f = e - 1;
            var g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            var h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        var i = this.jn();
        if (e == b.i$b.count && this.bh != null && this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, i)) < (this.js.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, i)) - this.js.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.l8 = function (a, b) {
        var c = this;
        if (this.lo == null || c.i$b == null) {
            return -1;
        }
        var d = -1;
        var e = ArrayExtension.binarySearch$11(Date_$type, b, function (f) {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    };
    TimeAxisBase.prototype.i$f = function (a) {
        var b = this;
        if (b.i$b == null || this.lo == null || b.i$b.count != this.lo.count) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.lo, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.l8(d, c);
        var f = this.jn();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var g = +d - +(c.item(e - 1));
            var h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.bh != null && this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, f)) < (this.js.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, f)) - this.js.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.i$i = function () {
        this.lx = null;
        this.hp();
    };
    TimeAxisBase.prototype.get_ls = function () {
        return this.lr;
    };
    TimeAxisBase.prototype.set_ls = function (a) {
        this.lr = a;
    };
    Object.defineProperty(TimeAxisBase.prototype, "ls", {
        get: function () {
            return this.get_ls();
        },
        set: function (a) {
            this.set_ls(a);
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.hg = function (a) {
        _super.prototype.hg.call(this, a);
        this.dateTimeMemberPath = a;
    };
    TimeAxisBase.prototype.hj = function (a) {
        _super.prototype.hj.call(this, a);
        this.minimumValue = a;
    };
    TimeAxisBase.prototype.hi = function (a) {
        _super.prototype.hj.call(this, a);
        this.maximumValue = a;
    };
    TimeAxisBase.prototype.cx = function () {
        if (this.ck && this.cy) {
            this.bb = this.ba();
        }
        var a = this.actualMinimumValue.getTime();
        var b = this.actualMaximumValue.getTime();
        this.mk();
        var c = !this.lv() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        var d = !this.lu() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        var e = new AxisRangeChangedEventArgs(0, a, c, b, d);
        this.hl(e);
        return true;
    };
    TimeAxisBase.prototype.lv = function () {
        if (+(this.minimumValue) == +(dateMinValue())) {
            return false;
        }
        return (this.minimumValue != null);
    };
    TimeAxisBase.prototype.lu = function () {
        if (+(this.maximumValue) == +(dateMaxValue())) {
            return false;
        }
        return (this.maximumValue != null);
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMinimumValue", {
        get: function () {
            return this.lz;
        },
        set: function (a) {
            var b = +(this.lz) != +a;
            if (b) {
                var c = this.lz;
                this.lz = a;
                this.hk("ActualMinimumValue", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.fl = function () {
        return this.actualMinimumValue;
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMaximumValue", {
        get: function () {
            return this.ly;
        },
        set: function (a) {
            var b = +(this.ly) != +a;
            if (b) {
                var c = this.ly;
                this.ly = a;
                this.hk("ActualMaximumValue", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.fk = function () {
        return this.maximumValue;
    };
    TimeAxisBase.prototype.mm = function (a) {
        var e_1, _a;
        this.hr(a);
        if (this.j6 == null) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.l0(a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    TimeAxisBase.prototype.he = function (a, b, c, d) {
        _super.prototype.he.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.lo);
                    this.lo = null;
                    e.event = delegateRemove(e.event, runOn(this, this.mj));
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.lx = null;
                    this.lo = this.lp(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.mj));
                }
                this.mm(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.j6 != null) {
                    this.j6.deregisterColumn(this.lo);
                    this.lo = this.lp(this.dateTimeMemberPath);
                    this.lx = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cv();
                this.mm(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cv();
                this.mm(false);
                break;
            case "DateTimeColumn":
                this.mk();
                break;
        }
    };
    TimeAxisBase.prototype.mj = function (a, b) {
        this.lx = null;
    };
    TimeAxisBase.prototype.lp = function (a) {
        return TimeAxisBase.lq(a, this);
    };
    TimeAxisBase.lq = function (a, b) {
        if (a == null) {
            return b.j6.registerColumnDateTime(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.b1(a, b.coercionMethods);
        c = d.a;
        return b.j6.registerColumnDateTime(a, c, b.expectFunctions);
    };
    TimeAxisBase.prototype.au = function () {
        if (this.cz) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    TimeAxisBase.prototype.get_a1 = function () {
        return 0;
    };
    Object.defineProperty(TimeAxisBase.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.hr = function (a) {
        _super.prototype.hr.call(this, a);
        var b = this.a4.ay();
        var c = this.a4.a1();
        var d = this.a4.az();
        var e = this.a4.a0();
        var f = this.a4.e();
        var g = this.a4.f();
        var h = this.a4.g();
        this.h0();
        this.g0(b);
        this.g0(c);
        this.g0(d);
        this.g0(e);
        this.c5.clear();
        this.c6.clear();
        this.kd.clear();
        this.av.ac = this;
        var i = this.bh != null ? this.bh.pg : Rect.empty;
        var j = !i.isEmpty ? this.js : Rect.empty;
        this.av.cx = i;
        this.av.cw = j;
        if (i.isEmpty || j.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0) {
            this.av.ab.clear();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        this.mk();
    };
    TimeAxisBase.prototype.get_b9 = function () {
        return true;
    };
    TimeAxisBase.prototype.startCursor = function () {
    };
    TimeAxisBase.prototype.resetCursor = function () {
    };
    TimeAxisBase.prototype.StartTimeCursor = function () {
        this.startCursor();
    };
    TimeAxisBase.prototype.ResetTimeCursor = function () {
        this.resetCursor();
    };
    TimeAxisBase.prototype.getCategorySize = function (a, b, c) {
        if (this.kq == 0) {
            return 0;
        }
        var d = this.jq(b, c);
        return d.width / (this.kq * a.width);
    };
    TimeAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    };
    TimeAxisBase.prototype.ki = function (a, b, c) {
        var d = !isNaN_(this.kf) ? MathUtil.b(this.kf, 0, 1) : 0;
        var e = 1 - 0.5 * d;
        var f = this.getCategorySize(a, b, c) * e;
        return f;
    };
    TimeAxisBase.prototype.get_ch = function () {
        return true;
    };
    TimeAxisBase.prototype.mi = function (a, b) {
        return (0);
    };
    TimeAxisBase.prototype.preferredCategoryMode = function (a) {
        return this.b7 ? 0 : 1;
    };
    Object.defineProperty(TimeAxisBase.prototype, "isVertical", {
        get: function () {
            return this.cj;
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.prototype.j$c = function (a, b) {
        return this.eb.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$b = function (a, b) {
        return this.d8.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$d = function (a, b, c, d, e) {
        this.g4.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$e = function (a, b, c, d) {
        this.g5.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$f = function (a, b, c, d) {
        this.g6.apply(this, arguments);
    };
    Object.defineProperty(TimeAxisBase.prototype, "j$a", {
        get: function () {
            return this.cc;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$a", {
        get: function () {
            return this.b9;
        },
        enumerable: false,
        configurable: true
    });
    TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'hk', ['DateTimeMemberPath::mq', [2, null], 'IsDataPreSorted:lt:mr', [0, false], 'MaximumValue::ms', [3, null], 'MinimumValue::mt', [3, null]]);
    return TimeAxisBase;
}(CategoryAxisBase));
export { TimeAxisBase };
//# sourceMappingURL=TimeAxisBase.js.map
