/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { VerticalAlignment_$type } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-angular-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.l0 = null;
        _this.l1 = null;
        _this.mh = 0;
        _this.mj = 5;
        _this.mi = 0;
        _this.mg = 5;
        _this.my = 5;
        _this.m0 = 0;
        _this.mz = 5;
        _this.mx = 0;
        _this.rr = null;
        _this.ry = null;
        _this.rp = null;
        _this.rq = null;
        _this.ms = 0;
        _this.m9 = 0;
        _this.mr = NaN;
        _this.m8 = NaN;
        _this.mu = NaN;
        _this.nb = NaN;
        _this.mt = NaN;
        _this.na = NaN;
        _this.mq = NaN;
        _this.m7 = NaN;
        _this.rx = null;
        _this.r4 = null;
        _this.oj = null;
        _this.on = null;
        _this.ol = null;
        _this.op = null;
        _this.oe = null;
        _this.of = null;
        _this.rs = null;
        _this.rz = null;
        _this.mk = DeviceUtils.g(1);
        _this.m1 = DeviceUtils.g(1);
        _this.ml = DeviceUtils.g(1);
        _this.m2 = DeviceUtils.g(1);
        _this.ru = null;
        _this.r1 = null;
        _this.rv = null;
        _this.r2 = null;
        _this.mm = DeviceUtils.g(1);
        _this.m3 = DeviceUtils.g(1);
        _this.mn = DeviceUtils.g(8);
        _this.m4 = 0;
        _this.rw = null;
        _this.r3 = null;
        _this.mo = DeviceUtils.g(1);
        _this.m5 = DeviceUtils.g(1);
        _this.ok = null;
        _this.oo = null;
        _this.rt = null;
        _this.r0 = null;
        _this.mf = 0;
        _this.mw = 0;
        _this.me = NaN;
        _this.mv = NaN;
        _this.mp = 0;
        _this.m6 = -90;
        _this.ma = false;
        _this.mb = false;
        _this.rk = 1;
        _this.sn = 1;
        _this.rj = 1;
        _this.rl = 2;
        _this.sl = 0;
        _this.sm = 1;
        _this.sr = 0;
        _this.ss = 0;
        _this.l8 = 4;
        _this.l6 = 4;
        _this.oi = null;
        _this.lu = null;
        _this.om = null;
        _this.lv = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.ly();
            var c = this.lz();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.jl = function () {
        _super.prototype.jl.call(this);
        var a = this.ly();
        var b = this.lz();
        if (a != null && a.ay != null) {
            this.r7 = a.ay.textColor;
        }
        if (b != null && b.ay != null) {
            this.se = b.ay.textColor;
        }
        this.sc = AxisDefaults.j;
        this.sj = AxisDefaults.j;
        this.r8 = AxisDefaults.h;
        this.sf = AxisDefaults.h;
        this.sb = AxisDefaults.g;
        this.si = AxisDefaults.g;
    };
    XYChart.prototype.j7 = function (a, b, c) {
        var _this = this;
        _super.prototype.j7.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.rb(function (d) { return d.leftMargin = _this.nj; });
                break;
            case "XAxisLabelTopMargin":
                this.rb(function (d) { return d.topMargin = _this.nl; });
                break;
            case "XAxisLabelRightMargin":
                this.rb(function (d) { return d.rightMargin = _this.nk; });
                break;
            case "XAxisLabelBottomMargin":
                this.rb(function (d) { return d.bottomMargin = _this.ni; });
                break;
            case "YAxisLabelLeftMargin":
                this.rg(function (d) { return d.leftMargin = _this.n0; });
                break;
            case "YAxisLabelTopMargin":
                this.rg(function (d) { return d.topMargin = _this.n2; });
                break;
            case "YAxisLabelRightMargin":
                this.rg(function (d) { return d.rightMargin = _this.n1; });
                break;
            case "YAxisLabelBottomMargin":
                this.rg(function (d) { return d.bottomMargin = _this.nz; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.r5 = this.ln(this.r7);
                this.r6 = this.ln(this.se);
                break;
            case "XAxisLabelTextColor":
                this.r5 = this.ln(this.r7);
                break;
            case "YAxisLabelTextColor":
                this.r6 = this.ln(this.se);
                break;
            case "ActualXAxisLabelTextColor":
                this.rb(function (d) { return d.textColor = _this.r5; });
                break;
            case "ActualYAxisLabelTextColor":
                this.rg(function (d) { return d.textColor = _this.r6; });
                break;
            case "XAxisTitleMargin":
                this.rd(function (d) { return d.margin = _this.nu; });
                break;
            case "YAxisTitleMargin":
                this.ri(function (d) { return d.margin = _this.ob; });
                break;
            case "XAxisTitleLeftMargin":
                this.rd(function (d) { return d.leftMargin = _this.nt; });
                break;
            case "YAxisTitleLeftMargin":
                this.ri(function (d) { return d.leftMargin = _this.oa; });
                break;
            case "XAxisTitleTopMargin":
                this.rd(function (d) { return d.topMargin = _this.nw; });
                break;
            case "YAxisTitleTopMargin":
                this.ri(function (d) { return d.topMargin = _this.od; });
                break;
            case "XAxisTitleRightMargin":
                this.rd(function (d) { return d.rightMargin = _this.nv; });
                break;
            case "YAxisTitleRightMargin":
                this.ri(function (d) { return d.rightMargin = _this.oc; });
                break;
            case "XAxisTitleBottomMargin":
                this.rd(function (d) { return d.bottomMargin = _this.ns; });
                break;
            case "YAxisTitleBottomMargin":
                this.ri(function (d) { return d.bottomMargin = _this.n9; });
                break;
            case "XAxisTitleTextColor":
                this.rd(function (d) { return d.textColor = _this.sd; });
                break;
            case "YAxisTitleTextColor":
                this.ri(function (d) { return d.textColor = _this.sk; });
                break;
            case "XAxisFormatLabel":
                this.q9(function (d) { return d.at = _this.l2; });
                break;
            case "YAxisFormatLabel":
                this.re(function (d) { return d.at = _this.l3; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "l2", {
        get: function () {
            return this.l0;
        },
        set: function (a) {
            var b = this.l2;
            if (a != b) {
                this.l0 = a;
                this.j6("XAxisFormatLabel", b, this.l2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "l3", {
        get: function () {
            return this.l1;
        },
        set: function (a) {
            var b = this.l3;
            if (a != b) {
                this.l1 = a;
                this.j6("YAxisFormatLabel", b, this.l3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nj", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            var b = this.nj;
            if (a != b) {
                this.mh = a;
                this.j6("XAxisLabelLeftMargin", b, this.nj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nl", {
        get: function () {
            return this.mj;
        },
        set: function (a) {
            var b = this.nl;
            if (a != b) {
                this.mj = a;
                this.j6("XAxisLabelTopMargin", b, this.nl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nk", {
        get: function () {
            return this.mi;
        },
        set: function (a) {
            var b = this.nk;
            if (a != b) {
                this.mi = a;
                this.j6("XAxisLabelRightMargin", b, this.nk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ni", {
        get: function () {
            return this.mg;
        },
        set: function (a) {
            var b = this.ni;
            if (a != b) {
                this.mg = a;
                this.j6("XAxisLabelBottomMargin", b, this.ni);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n0", {
        get: function () {
            return this.my;
        },
        set: function (a) {
            var b = this.n0;
            if (a != b) {
                this.my = a;
                this.j6("YAxisLabelLeftMargin", b, this.n0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n2", {
        get: function () {
            return this.m0;
        },
        set: function (a) {
            var b = this.n2;
            if (a != b) {
                this.m0 = a;
                this.j6("YAxisLabelTopMargin", b, this.n2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n1", {
        get: function () {
            return this.mz;
        },
        set: function (a) {
            var b = this.n1;
            if (a != b) {
                this.mz = a;
                this.j6("YAxisLabelRightMargin", b, this.n1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nz", {
        get: function () {
            return this.mx;
        },
        set: function (a) {
            var b = this.nz;
            if (a != b) {
                this.mx = a;
                this.j6("YAxisLabelBottomMargin", b, this.nz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "r7", {
        get: function () {
            return this.rr;
        },
        set: function (a) {
            var b = this.r7;
            if (a != b) {
                this.rr = a;
                this.j6("XAxisLabelTextColor", b, this.r7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "se", {
        get: function () {
            return this.ry;
        },
        set: function (a) {
            var b = this.se;
            if (a != b) {
                this.ry = a;
                this.j6("YAxisLabelTextColor", b, this.se);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "r5", {
        get: function () {
            return this.rp;
        },
        set: function (a) {
            var b = this.rp;
            if (a != b) {
                this.rp = a;
                this.j6("ActualXAxisLabelTextColor", b, this.r5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "r6", {
        get: function () {
            return this.rq;
        },
        set: function (a) {
            var b = this.rq;
            if (a != b) {
                this.rq = a;
                this.j6("ActualYAxisLabelTextColor", b, this.r6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nu", {
        get: function () {
            return this.ms;
        },
        set: function (a) {
            var b = this.nu;
            if (a != b) {
                this.ms = a;
                this.j6("XAxisTitleMargin", b, this.nu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ob", {
        get: function () {
            return this.m9;
        },
        set: function (a) {
            var b = this.ob;
            if (a != b) {
                this.m9 = a;
                this.j6("YAxisTitleMargin", b, this.ob);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nt", {
        get: function () {
            return this.mr;
        },
        set: function (a) {
            var b = this.nt;
            if (a != b) {
                this.mr = a;
                this.j6("XAxisTitleLeftMargin", b, this.nt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oa", {
        get: function () {
            return this.m8;
        },
        set: function (a) {
            var b = this.oa;
            if (a != b) {
                this.m8 = a;
                this.j6("YAxisTitleLeftMargin", b, this.oa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nw", {
        get: function () {
            return this.mu;
        },
        set: function (a) {
            var b = this.nw;
            if (a != b) {
                this.mu = a;
                this.j6("XAxisTitleTopMargin", b, this.nw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "od", {
        get: function () {
            return this.nb;
        },
        set: function (a) {
            var b = this.od;
            if (a != b) {
                this.nb = a;
                this.j6("YAxisTitleTopMargin", b, this.od);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nv", {
        get: function () {
            return this.mt;
        },
        set: function (a) {
            var b = this.nv;
            if (a != b) {
                this.mt = a;
                this.j6("XAxisTitleRightMargin", b, this.nv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oc", {
        get: function () {
            return this.na;
        },
        set: function (a) {
            var b = this.oc;
            if (a != b) {
                this.na = a;
                this.j6("YAxisTitleRightMargin", b, this.oc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ns", {
        get: function () {
            return this.mq;
        },
        set: function (a) {
            var b = this.ns;
            if (a != b) {
                this.mq = a;
                this.j6("XAxisTitleBottomMargin", b, this.ns);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n9", {
        get: function () {
            return this.m7;
        },
        set: function (a) {
            var b = this.n9;
            if (a != b) {
                this.m7 = a;
                this.j6("YAxisTitleBottomMargin", b, this.n9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sd", {
        get: function () {
            return this.rx;
        },
        set: function (a) {
            var b = this.sd;
            if (a != b) {
                this.rx = a;
                this.j6("XAxisTitleTextColor", b, this.sd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sk", {
        get: function () {
            return this.r4;
        },
        set: function (a) {
            var b = this.sk;
            if (a != b) {
                this.r4 = a;
                this.j6("YAxisTitleTextColor", b, this.sk);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.j8 = function (a, b, c) {
        var _this = this;
        _super.prototype.j8.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.rb(function (d) { return d.textStyle = _this.o7; });
                break;
            case "YAxisLabelTextStyle":
                this.rg(function (d) { return d.textStyle = _this.qc; });
                break;
            case "XAxisTitleTextStyle":
                this.rd(function (d) { return d.textStyle = _this.pv; });
                break;
            case "YAxisTitleTextStyle":
                this.ri(function (d) { return d.textStyle = _this.q0; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "o7", {
        get: function () {
            return this.oj;
        },
        set: function (a) {
            var b = this.o7;
            if (a != b) {
                this.oj = a;
                this.j6("XAxisLabelTextStyle", b, this.o7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "qc", {
        get: function () {
            return this.on;
        },
        set: function (a) {
            var b = this.qc;
            if (a != b) {
                this.on = a;
                this.j6("YAxisLabelTextStyle", b, this.qc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "pv", {
        get: function () {
            return this.ol;
        },
        set: function (a) {
            var b = this.pv;
            if (a != b) {
                this.ol = a;
                this.j6("XAxisTitleTextStyle", b, this.pv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "q0", {
        get: function () {
            return this.op;
        },
        set: function (a) {
            var b = this.q0;
            if (a != b) {
                this.op = a;
                this.j6("YAxisTitleTextStyle", b, this.q0);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.q6 = function (a) {
        var _this = this;
        this.q3(a, function (b) { return b.leftMargin = _this.nj; });
        this.q3(a, function (b) { return b.topMargin = _this.nl; });
        this.q3(a, function (b) { return b.rightMargin = _this.nk; });
        this.q3(a, function (b) { return b.bottomMargin = _this.ni; });
        this.q3(a, function (b) { return b.textColor = _this.r5; });
        this.q4(a, function (b) { return b.textColor = _this.sd; });
        this.q4(a, function (b) { return b.leftMargin = _this.nt; });
        this.q4(a, function (b) { return b.topMargin = _this.nw; });
        this.q4(a, function (b) { return b.rightMargin = _this.nv; });
        this.q4(a, function (b) { return b.bottomMargin = _this.ns; });
        this.q3(a, function (b) { return b.textStyle = _this.o7; });
        this.q4(a, function (b) { return b.textStyle = _this.pv; });
    };
    XYChart.prototype.q8 = function (a) {
        var _this = this;
        this.q3(a, function (b) { return b.leftMargin = _this.n0; });
        this.q3(a, function (b) { return b.topMargin = _this.n2; });
        this.q3(a, function (b) { return b.rightMargin = _this.n1; });
        this.q3(a, function (b) { return b.bottomMargin = _this.nz; });
        this.q3(a, function (b) { return b.textColor = _this.r6; });
        this.q4(a, function (b) { return b.textColor = _this.sk; });
        this.q4(a, function (b) { return b.leftMargin = _this.oa; });
        this.q4(a, function (b) { return b.topMargin = _this.od; });
        this.q4(a, function (b) { return b.rightMargin = _this.oc; });
        this.q4(a, function (b) { return b.bottomMargin = _this.n9; });
        this.q3(a, function (b) { return b.textStyle = _this.qc; });
        this.q4(a, function (b) { return b.textStyle = _this.q0; });
    };
    XYChart.prototype.ko = function (a) {
        var b = this.ab(a);
        var c = this.bb(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.gz(a);
        c.hp = this.g0(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.q9 = function (a) {
        this.ra(a, null);
    };
    XYChart.prototype.ra = function (a, b) {
        a(this.ly());
    };
    XYChart.prototype.rf = function (a, b) {
        a(this.lz());
    };
    XYChart.prototype.re = function (a) {
        this.rf(a, true);
    };
    XYChart.prototype.rd = function (a) {
        this.q4(this.ly(), a);
    };
    XYChart.prototype.ri = function (a) {
        this.q4(this.lz(), a);
    };
    XYChart.prototype.rg = function (a) {
        this.q3(this.lz(), a);
    };
    XYChart.prototype.rb = function (a) {
        this.q3(this.ly(), a);
    };
    XYChart.prototype.nc = function (a) {
        var b = this.ly();
        return b.d8(a, new ScalerParams(1, this.lt, this.ls, b.cc));
    };
    XYChart.prototype.ne = function (a) {
        var b = this.ly();
        return b.eb(a, new ScalerParams(1, this.lt, this.ls, b.cc));
    };
    XYChart.prototype.nd = function (a) {
        var b = this.lz();
        return b.d8(a, new ScalerParams(1, this.lt, this.ls, b.cc));
    };
    XYChart.prototype.nf = function (a) {
        var b = this.lz();
        return b.eb(a, new ScalerParams(1, this.lt, this.ls, b.cc));
    };
    XYChart.prototype.kl = function (a) {
        _super.prototype.kl.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.ly();
            var c = this.lz();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.os = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.jg = function (a) {
        _super.prototype.jg.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.ly());
            this.dataChart.axes.add(this.lz());
        }
    };
    XYChart.prototype.q5 = function (a) {
        var _this = this;
        if (a != null && this.fd != null && a.e4 == null) {
            a.provideRenderer(this.fd);
        }
        a.jb = this.r8;
        a.ef = this.nm;
        a.jc = this.r9;
        a.ei = this.nn;
        a.je = this.sb;
        a.ez = this.no;
        a.jd = this.sa;
        a.e0 = this.np;
        a.jf = this.sc;
        a.e1 = this.nq;
        a.cy = true;
        var b = a == this.ly();
        if (b) {
            a.gp = this.pm;
        }
        a.fj = this.og;
        a.fz = this.oy;
        a.ag = this.lw;
        this.q3(a, function (c) { return c.angle = _this.nh; });
        this.q3(a, function (c) {
            if (c.extent != _this.ng) {
                c.extent = _this.ng;
            }
        });
        this.q3(a, function (c) { return c.horizontalAlignment = _this.rm; });
        this.q3(a, function (c) { return c.verticalAlignment = _this.so; });
        this.q3(a, function (c) { return c.visibility = _this.st; });
        this.q3(a, function (c) { return c.location = _this.l4(_this.l7); });
        this.q4(a, function (c) { return c.horizontalAlignment = _this.rn; });
        this.q4(a, function (c) { return c.angle = _this.nr; });
        this.q6(a);
    };
    XYChart.prototype.q7 = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.fd != null && a.e4 == null) {
            a.provideRenderer(this.fd);
        }
        this.q3(a, function (b) { return b.angle = _this.ny; });
        this.q3(a, function (b) {
            if (b.extent != _this.nx) {
                b.extent = _this.nx;
            }
        });
        this.q3(a, function (b) { return b.horizontalAlignment = _this.ro; });
        this.q3(a, function (b) { return b.verticalAlignment = _this.sp; });
        this.q3(a, function (b) { return b.visibility = _this.su; });
        this.q3(a, function (b) { return b.location = _this.l5(_this.l9); });
        this.q4(a, function (b) { return b.verticalAlignment = _this.sq; });
        this.q4(a, function (b) { return b.angle = _this.n8; });
        a.jb = this.sf;
        a.ef = this.n3;
        a.jc = this.sg;
        a.ei = this.n4;
        a.je = this.si;
        a.ez = this.n5;
        a.jd = this.sh;
        a.e0 = this.n6;
        a.jf = this.sj;
        a.e1 = this.n7;
        var b = a == this.lz();
        if (b) {
            a.gp = this.qr;
        }
        a.fz = this.p3;
        a.ag = this.lx;
        this.q8(a);
    };
    XYChart.prototype.jd = function () {
        _super.prototype.jd.call(this);
        this.q5(this.ly());
        this.q7(this.lz());
    };
    XYChart.prototype.q3 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.ay == null) {
            a.ay = new AxisLabelSettings();
            a.ay.angle = a.dw();
            a.ay.bottomMargin = a.dx();
            a.ay.leftMargin = a.dy();
            a.ay.rightMargin = a.dz();
            a.ay.topMargin = a.d0();
            a.ay.horizontalAlignment = a.i6();
            a.ay.location = a.az();
            a.ay.verticalAlignment = a.jz();
        }
        b(a.ay);
    };
    XYChart.prototype.q4 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.be == null) {
            a.be = new TitleSettings();
            a.be.bottomMargin = a.d2();
            a.be.leftMargin = a.d3();
            a.be.rightMargin = a.d4();
            a.be.topMargin = a.d5();
            a.be.location = a.a0();
            a.be.angle = a.d1();
            a.be.horizontalAlignment = a.i7();
            a.be.verticalAlignment = a.j0();
        }
        b(a.be);
    };
    XYChart.prototype.j6 = function (a, b, c) {
        var _this = this;
        _super.prototype.j6.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.rb(function (d) { return d.angle = _this.nh; });
                break;
            case "YAxisLabelAngle":
                this.rg(function (d) { return d.angle = _this.ny; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.rb(function (d) { return d.horizontalAlignment = _this.rm; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.rg(function (d) { return d.horizontalAlignment = _this.ro; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.rb(function (d) { return d.verticalAlignment = _this.so; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.rg(function (d) { return d.verticalAlignment = _this.sp; });
                break;
            case "XAxisLabelVisibility":
                this.rb(function (d) { return d.visibility = _this.st; });
                break;
            case "YAxisLabelVisibility":
                this.rg(function (d) { return d.visibility = _this.su; });
                break;
            case "XAxisLabel":
                this.q9(function (d) { return d.fj = _this.og; });
                break;
            case "YAxisLabel":
                this.re(function (d) { return d.fj = _this.oh; });
                break;
            case "XAxisLabelFormat":
                this.q9(function (d) { return d.fz = _this.oy; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.q9(function (d) { return d.ag = _this.lw; });
                break;
            case "YAxisLabelFormat":
                this.re(function (d) { return d.fz = _this.p3; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.re(function (d) { return d.ag = _this.lx; });
                break;
            case "XAxisTitleAngle":
                this.rd(function (d) { return d.angle = _this.nr; });
                break;
            case "YAxisTitleAngle":
                this.ri(function (d) { return d.angle = _this.n8; });
                break;
            case "XAxisTitleAlignment":
                this.rd(function (d) { return d.horizontalAlignment = _this.rn; });
                break;
            case "YAxisTitleAlignment":
                this.ri(function (d) { return d.verticalAlignment = _this.sq; });
                break;
            case "XAxisTitle":
                this.q9(function (d) { return d.gp = _this.pm; });
                break;
            case "YAxisTitle":
                this.rf(function (d) { return d.gp = _this.qr; }, false);
                break;
            case "XAxisMajorStroke":
                this.ra(function (d) { return d.jb = _this.r8; }, a);
                break;
            case "YAxisMajorStroke":
                this.re(function (d) { return d.jb = _this.sf; });
                break;
            case "XAxisMajorStrokeThickness":
                this.ra(function (d) { return d.ef = _this.nm; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.re(function (d) { return d.ef = _this.n3; });
                break;
            case "XAxisMinorStroke":
                this.q9(function (d) { return d.jc = _this.r9; });
                break;
            case "YAxisMinorStroke":
                this.re(function (d) { return d.jc = _this.sg; });
                break;
            case "XAxisMinorStrokeThickness":
                this.q9(function (d) { return d.ei = _this.nn; });
                break;
            case "YAxisMinorStrokeThickness":
                this.re(function (d) { return d.ei = _this.n4; });
                break;
            case "XAxisTickLength":
                this.q9(function (d) { return d.e0 = _this.np; });
                break;
            case "YAxisTickLength":
                this.re(function (d) { return d.e0 = _this.n6; });
                break;
            case "XAxisTickStroke":
                this.q9(function (d) { return d.jf = _this.sc; });
                break;
            case "YAxisTickStroke":
                this.re(function (d) { return d.jf = _this.sj; });
                break;
            case "XAxisTickStrokeThickness":
                this.q9(function (d) { return d.e1 = _this.nq; });
                break;
            case "YAxisTickStrokeThickness":
                this.re(function (d) { return d.e1 = _this.n7; });
                break;
            case "XAxisStroke":
                this.q9(function (d) { return d.je = _this.sb; });
                break;
            case "YAxisStroke":
                this.re(function (d) { return d.je = _this.si; });
                break;
            case "XAxisStrokeThickness":
                this.q9(function (d) { return d.ez = _this.no; });
                break;
            case "YAxisStrokeThickness":
                this.re(function (d) { return d.ez = _this.n5; });
                break;
            case "XAxisExtent":
                this.rb(function (d) { return d.extent = _this.ng; });
                break;
            case "YAxisExtent":
                this.rg(function (d) { return d.extent = _this.nx; });
                break;
            case "XAxisStrip":
                this.q9(function (d) { return d.jd = _this.sa; });
                break;
            case "YAxisStrip":
                this.re(function (d) { return d.jd = _this.sh; });
                break;
            case "XAxisInverted":
                this.q9(function (d) { return d.cc = _this.mc; });
                break;
            case "YAxisInverted":
                this.re(function (d) { return d.cc = _this.md; });
                break;
            case "YAxisLabelLocation":
                this.rh();
                break;
            case "XAxisLabelLocation":
                this.rc();
                break;
        }
    };
    XYChart.prototype.rh = function () {
        var a = this.l5(this.l9);
        if (a == 2 || a == 7) {
            this.ro = 2;
        }
        else {
            this.ro = 0;
        }
        this.rg(function (b) { return b.location = a; });
    };
    XYChart.prototype.rc = function () {
        var a = this.l4(this.l7);
        if (a == 1 || a == 5) {
            this.so = 0;
        }
        else {
            this.so = 2;
        }
        this.rb(function (b) { return b.location = a; });
    };
    XYChart.prototype.l5 = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.ai == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.l4 = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "og", {
        get: function () {
            return this.oe;
        },
        set: function (a) {
            var b = this.og;
            if (a != b) {
                this.oe = a;
                this.j6("XAxisLabel", b, this.og);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oh", {
        get: function () {
            return this.of;
        },
        set: function (a) {
            var b = this.oh;
            if (a != b) {
                this.of = a;
                this.j6("YAxisLabel", b, this.oh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "r8", {
        get: function () {
            return this.rs;
        },
        set: function (a) {
            var b = this.r8;
            if (a != b) {
                this.rs = a;
                this.j6("XAxisMajorStroke", b, this.r8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sf", {
        get: function () {
            return this.rz;
        },
        set: function (a) {
            var b = this.sf;
            if (a != b) {
                this.rz = a;
                this.j6("YAxisMajorStroke", b, this.sf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nm", {
        get: function () {
            return this.mk;
        },
        set: function (a) {
            var b = this.nm;
            if (a != b) {
                this.mk = a;
                this.j6("XAxisMajorStrokeThickness", b, this.nm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n3", {
        get: function () {
            return this.m1;
        },
        set: function (a) {
            var b = this.n3;
            if (a != b) {
                this.m1 = a;
                this.j6("YAxisMajorStrokeThickness", b, this.n3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nn", {
        get: function () {
            return this.ml;
        },
        set: function (a) {
            var b = this.nn;
            if (a != b) {
                this.ml = a;
                this.j6("XAxisMinorStrokeThickness", b, this.nn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n4", {
        get: function () {
            return this.m2;
        },
        set: function (a) {
            var b = this.n4;
            if (a != b) {
                this.m2 = a;
                this.j6("YAxisMinorStrokeThickness", b, this.n4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sa", {
        get: function () {
            return this.ru;
        },
        set: function (a) {
            var b = this.sa;
            if (a != b) {
                this.ru = a;
                this.j6("XAxisStrip", b, this.sa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sh", {
        get: function () {
            return this.r1;
        },
        set: function (a) {
            var b = this.sh;
            if (a != b) {
                this.r1 = a;
                this.j6("YAxisStrip", b, this.sh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sb", {
        get: function () {
            return this.rv;
        },
        set: function (a) {
            var b = this.sb;
            if (a != b) {
                this.rv = a;
                this.j6("XAxisStroke", b, this.sb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "si", {
        get: function () {
            return this.r2;
        },
        set: function (a) {
            var b = this.si;
            if (a != b) {
                this.r2 = a;
                this.j6("YAxisStroke", b, this.si);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "no", {
        get: function () {
            return this.mm;
        },
        set: function (a) {
            var b = this.no;
            if (a != b) {
                this.mm = a;
                this.j6("XAxisStrokeThickness", b, this.no);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n5", {
        get: function () {
            return this.m3;
        },
        set: function (a) {
            var b = this.n5;
            if (a != b) {
                this.m3 = a;
                this.j6("YAxisStrokeThickness", b, this.n5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "np", {
        get: function () {
            return this.mn;
        },
        set: function (a) {
            var b = this.np;
            if (a != b) {
                this.mn = a;
                this.j6("XAxisTickLength", b, this.np);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n6", {
        get: function () {
            return this.m4;
        },
        set: function (a) {
            var b = this.n6;
            if (a != b) {
                this.m4 = a;
                this.j6("YAxisTickLength", b, this.n6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sc", {
        get: function () {
            return this.rw;
        },
        set: function (a) {
            var b = this.sc;
            if (a != b) {
                this.rw = a;
                this.j6("XAxisTickStroke", b, this.sc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sj", {
        get: function () {
            return this.r3;
        },
        set: function (a) {
            var b = this.sj;
            if (a != b) {
                this.r3 = a;
                this.j6("YAxisTickStroke", b, this.sj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nq", {
        get: function () {
            return this.mo;
        },
        set: function (a) {
            var b = this.nq;
            if (a != b) {
                this.mo = a;
                this.j6("XAxisTickStrokeThickness", b, this.nq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n7", {
        get: function () {
            return this.m5;
        },
        set: function (a) {
            var b = this.n7;
            if (a != b) {
                this.m5 = a;
                this.j6("YAxisTickStrokeThickness", b, this.n7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "pm", {
        get: function () {
            return this.ok;
        },
        set: function (a) {
            var b = this.pm;
            if (a != b) {
                this.ok = a;
                this.j6("XAxisTitle", b, this.pm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "qr", {
        get: function () {
            return this.oo;
        },
        set: function (a) {
            var b = this.qr;
            if (a != b) {
                this.oo = a;
                this.j6("YAxisTitle", b, this.qr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "r9", {
        get: function () {
            return this.rt;
        },
        set: function (a) {
            var b = this.r9;
            if (a != b) {
                this.rt = a;
                this.j6("XAxisMinorStroke", b, this.r9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sg", {
        get: function () {
            return this.r0;
        },
        set: function (a) {
            var b = this.sg;
            if (a != b) {
                this.r0 = a;
                this.j6("YAxisMinorStroke", b, this.sg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nh", {
        get: function () {
            return this.mf;
        },
        set: function (a) {
            var b = this.nh;
            if (a != b) {
                this.mf = a;
                this.j6("XAxisLabelAngle", b, this.nh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ny", {
        get: function () {
            return this.mw;
        },
        set: function (a) {
            var b = this.ny;
            if (a != b) {
                this.mw = a;
                this.j6("YAxisLabelAngle", b, this.ny);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ng", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            var b = this.ng;
            if (a != b) {
                this.me = a;
                this.j6("XAxisExtent", b, this.ng);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nx", {
        get: function () {
            return this.mv;
        },
        set: function (a) {
            var b = this.nx;
            if (a != b) {
                this.mv = a;
                this.j6("YAxisExtent", b, this.nx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nr", {
        get: function () {
            return this.mp;
        },
        set: function (a) {
            var b = this.nr;
            if (a != b) {
                this.mp = a;
                this.j6("XAxisTitleAngle", b, this.nr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n8", {
        get: function () {
            return this.m6;
        },
        set: function (a) {
            var b = this.n8;
            if (a != b) {
                this.m6 = a;
                this.j6("YAxisTitleAngle", b, this.n8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mc", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            var b = this.mc;
            if (a != b) {
                this.ma = a;
                this.j6("XAxisInverted", b, this.mc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "md", {
        get: function () {
            return this.mb;
        },
        set: function (a) {
            var b = this.md;
            if (a != b) {
                this.mb = a;
                this.j6("YAxisInverted", b, this.md);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "rn", {
        get: function () {
            return this.rk;
        },
        set: function (a) {
            var b = this.rn;
            if (a != b) {
                this.rk = a;
                this.j6("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.rn));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sq", {
        get: function () {
            return this.sn;
        },
        set: function (a) {
            var b = this.sq;
            if (a != b) {
                this.sn = a;
                this.j6("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.sq));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "rm", {
        get: function () {
            return this.rj;
        },
        set: function (a) {
            var b = this.rm;
            if (a != b) {
                this.rj = a;
                this.j6("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.rm));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_ro = function () {
        return this.rl;
    };
    XYChart.prototype.set_ro = function (a) {
        var b = this.ro;
        if (a != b) {
            this.rl = a;
            this.j6("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ro));
        }
    };
    Object.defineProperty(XYChart.prototype, "ro", {
        get: function () {
            return this.get_ro();
        },
        set: function (a) {
            this.set_ro(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "so", {
        get: function () {
            return this.sl;
        },
        set: function (a) {
            var b = this.so;
            if (a != b) {
                this.sl = a;
                this.j6("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.so));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "sp", {
        get: function () {
            return this.sm;
        },
        set: function (a) {
            var b = this.sp;
            if (a != b) {
                this.sm = a;
                this.j6("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.sp));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "st", {
        get: function () {
            return this.sr;
        },
        set: function (a) {
            var b = this.st;
            if (a != b) {
                this.sr = a;
                this.j6("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.st));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "su", {
        get: function () {
            return this.ss;
        },
        set: function (a) {
            var b = this.su;
            if (a != b) {
                this.ss = a;
                this.j6("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.su));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_l9 = function () {
        return this.l8;
    };
    XYChart.prototype.set_l9 = function (a) {
        var b = this.l9;
        if (a != b) {
            this.l8 = a;
            this.j6("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.l9));
        }
    };
    Object.defineProperty(XYChart.prototype, "l9", {
        get: function () {
            return this.get_l9();
        },
        set: function (a) {
            this.set_l9(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_l7 = function () {
        return this.l6;
    };
    XYChart.prototype.set_l7 = function (a) {
        var b = this.l7;
        if (a != b) {
            this.l6 = a;
            this.j6("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.l7));
        }
    };
    Object.defineProperty(XYChart.prototype, "l7", {
        get: function () {
            return this.get_l7();
        },
        set: function (a) {
            this.set_l7(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oy", {
        get: function () {
            return this.oi;
        },
        set: function (a) {
            var b = this.oi;
            if (a != b) {
                this.oi = a;
                this.j6("XAxisLabelFormat", b, this.oi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "lw", {
        get: function () {
            return this.lu;
        },
        set: function (a) {
            var b = this.lu;
            if (a != b) {
                this.lu = a;
                this.j6("XAxisLabelFormatSpecifiers", b, this.lu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "p3", {
        get: function () {
            return this.om;
        },
        set: function (a) {
            var b = this.om;
            if (a != b) {
                this.om = a;
                this.j6("YAxisLabelFormat", b, this.om);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "lx", {
        get: function () {
            return this.lv;
        },
        set: function (a) {
            var b = this.lv;
            if (a != b) {
                this.lv = a;
                this.j6("YAxisLabelFormatSpecifiers", b, this.lv);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
//# sourceMappingURL=XYChart.js.map
