import { __extends } from "tslib";
import { IgxDataContext } from "igniteui-angular-core";
import { PieSliceDataContext as PieSliceDataContext_internal } from "./PieSliceDataContext";
import { ensureBool } from "igniteui-angular-core";
/**
 * DataContext for a pie slice.
*/
var IgxPieSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxPieSliceDataContext, _super);
    function IgxPieSliceDataContext() {
        return _super.call(this) || this;
    }
    IgxPieSliceDataContext.prototype.createImplementation = function () {
        return new PieSliceDataContext_internal();
    };
    Object.defineProperty(IgxPieSliceDataContext.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxPieSliceDataContext.prototype, "percentValue", {
        /**
         * Gets or sets the value of this slice as a percentage of the total pie.
        */
        get: function () {
            return this.i.percentValue;
        },
        set: function (v) {
            this.i.percentValue = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxPieSliceDataContext.prototype, "isOthersSlice", {
        /**
         * Gets or sets whether this slice is an Others slice or not.
        */
        get: function () {
            return this.i.isOthersSlice;
        },
        set: function (v) {
            this.i.isOthersSlice = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgxPieSliceDataContext;
}(IgxDataContext));
export { IgxPieSliceDataContext };
//# sourceMappingURL=igx-pie-slice-data-context.js.map
