import { ensureBool, fromPoint, fromRect, brushToString } from "igniteui-angular-core";
/**
 * Contains PieChart click event data.
*/
var IgxSliceClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgxSliceClickEventArgs() {
    }
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxSliceClickEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxSliceClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "isSelected", {
        /**
         * Gets or sets whether the slice is selected.
        */
        get: function () {
            return this.i.isSelected;
        },
        set: function (v) {
            this.i.isSelected = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "isExploded", {
        /**
         * Gets or sets whether the slice is exploded.
        */
        get: function () {
            return this.i.isExploded;
        },
        set: function (v) {
            this.i.isExploded = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "isOthersSlice", {
        /**
         * Gets whether the current slice is part of the others slice.
        */
        get: function () {
            return this.i.isOthersSlice;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "index", {
        /**
         * Gets the index of the slice that was clicked.
        */
        get: function () {
            return this.i.index;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "dataContext", {
        /**
         * Gets the slice data context.
        */
        get: function () {
            return this.i.dataContext;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "originalEvent", {
        /**
         * Holds a reference to the original event that triggered slice click.
        */
        get: function () {
            return this.i.originalEvent;
        },
        set: function (v) {
            this.i.originalEvent = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "origin", {
        /**
         * Gets the origin location of the slice.
        */
        get: function () {
            return fromPoint(this.i.origin);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "radius", {
        /**
         * Gets the radius of the slice.
        */
        get: function () {
            return this.i.radius;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "bounds", {
        /**
         * Gets the bounds of the slice.
        */
        get: function () {
            return fromRect(this.i.bounds);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "startAngle", {
        /**
         * Gets the start angle of the slice.
        */
        get: function () {
            return this.i.startAngle;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "endAngle", {
        /**
         * Gets the end angle of the slice.
        */
        get: function () {
            return this.i.endAngle;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "fill", {
        /**
         * Gets the fill color of the slice.
        */
        get: function () {
            return brushToString(this.i.fill);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxSliceClickEventArgs.prototype, "outline", {
        /**
         * Gets the outline color of the slice.
        */
        get: function () {
            return brushToString(this.i.outline);
        },
        enumerable: false,
        configurable: true
    });
    return IgxSliceClickEventArgs;
}());
export { IgxSliceClickEventArgs };
//# sourceMappingURL=igx-slice-click-event-args.js.map
