import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private sz;
    get s0(): IAnchoredCategorySeriesInteractionManager;
    sv: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    protected bu(): SeriesView;
    lh(a: SeriesView): void;
    s3: boolean;
    constructor();
    tb: string;
    hk(a: any, b: string): any;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private s1;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get tt(): Brush;
    set tt(a: Brush);
    static readonly ti: DependencyProperty;
    trendLineThickness: number;
    tv: PenLineCap;
    tu: DoubleCollection;
    trendLinePeriod: number;
    s5: number;
    eh(a: any): boolean;
    protected ss(a: number, b: number, c: Axis): any[];
    protected lm(a: any, b: string, c: any, d: any): void;
    ap(a: Axis): AxisRange;
    protected kk(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected r2(): number;
    s4(a: CategorySeriesView): number;
    tg(a: PointCollection, b: number, c: CategorySeriesView): void;
    st(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    su(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    e3(a: Rect, b: Rect, c: SeriesView): boolean;
    kh(a: boolean, b: SeriesView): void;
    si(a: CategoryFrame, b: CategorySeriesView): void;
    sl(a: CategoryFrame, b: CategorySeriesView): void;
    sw: CategoryFrame;
    lz(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    td(a: CategoryFrame, b: CategorySeriesView): void;
    protected md(): void;
    hn(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected s7: string;
    abstract te(a: Axis): void;
    abstract tf(a: Axis): void;
    protected kr(a: any): void;
    sx: CategorySeriesMarkerCollisionAvoidance;
    hh(a: Point): any;
    sy: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    f2(): number;
    protected get_s6(): number;
    protected get s6(): number;
    aq(a: Rect): AxisRange;
    private th;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c1;
    get c2(): ITrendLineManager;
    set c2(a: ITrendLineManager);
    get c3(): boolean;
    c7(): void;
    c5(): void;
    c4(): void;
    cs(): CategoryBucketCalculator;
    c6(): void;
    c8(): void;
    c9(a: number): Rect;
    protected a5(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
