import { Base, Type, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-angular-core";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-angular-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected get q(): List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    private aa;
    private ab;
    protected ac: IHasCategoryTrendline;
    protected ad: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    q8: CategoryFramePreparer;
    protected bu(): SeriesView;
    rc: CategorySeriesView;
    private rl;
    get rm(): ICategorySeriesInteractionManager;
    cx(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private r7;
    lh(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get categoryAxis(): CategoryAxisBase;
    q2(): CategoryAxisBase;
    rn(): NumericAxisBase;
    protected get_da(): boolean;
    constructor();
    ac(): void;
    rt: boolean;
    rs: boolean;
    protected rp: boolean;
    protected ro: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    rv(): boolean;
    protected rw(): boolean;
    protected sk(a: AssigningCategoryStyleEventArgs): void;
    protected sj(a: AssigningCategoryMarkerStyleEventArgs): void;
    qw(a: number, b: number): any[];
    kh(a: boolean, b: SeriesView): void;
    bg(): SeriesComponentsForView;
    ky(): void;
    ry: boolean;
    protected mn(a: Rect, b: Rect): void;
    re: CategoryTransitionInMode;
    ru: boolean;
    protected mm(a: Rect, b: Rect): void;
    protected lm(a: any, b: string, c: any, d: any): void;
    protected rr(): boolean;
    protected rq(): boolean;
    r1(a: Point): number;
    protected get_d3(): boolean;
    ar(): CategoryAxisBase;
    g2(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    hh(a: Point): any;
    g0(a: Point): number;
    fw(a: Point): number;
    private rj;
    private rk;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    protected get_dr(): boolean;
    kf(): void;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    protected r0(): List$1<Marker>;
    protected ri(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rh(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rg(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    q5: CategoryFrame;
    q7: CategoryFrame;
    q3: CategoryFrame;
    q6: CategoryFrame;
    q4(): CategoryFrame;
    rb: CategorySeriesRenderManager;
    protected sg(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    sh(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    e3(a: Rect, b: Rect, c: SeriesView): boolean;
    private rz;
    protected ek(): boolean;
    protected rd(): CategoryTransitionInMode;
    rf: CategoryTransitionSourceFramePreparer;
    protected ki(): void;
    l1(a: boolean): void;
    protected b6(): TransitionInSpeedType;
    protected r2(): number;
    r6(): number;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    sf(a: CategorySeriesView, b: CategoryFrame): void;
    sl(a: CategoryFrame, b: CategorySeriesView): void;
    si(a: CategoryFrame, b: CategorySeriesView): void;
    r3(a: SeriesView): number;
    r4(a: SeriesView): number;
    r5(a: SeriesView): number;
    se(a: SeriesView): void;
    l2(a: Rect, b: RenderSurface): void;
    sm(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract rx(): boolean;
    q9(a: CategorySeriesView): CategoryFramePreparer;
    an(a: Axis): Axis;
    ag(): Axis[];
    static qx(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    ct: CategorySeries;
    cw: number;
    cv(a: CategoryFrame): boolean;
    cy(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cr: CategoryBucketCalculator;
    cs(): CategoryBucketCalculator;
    cu: Pool$1<Marker>;
    get shouldDisplayMarkers(): boolean;
    updateMarkerCount(a: number): void;
    cf(a: (arg1: Marker) => void): void;
    cx(): void;
}
