import { Type } from "igniteui-angular-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum ComputedPlotAreaMarginMode {
    /**
     * Computed plot area margin mode is determined by the component.
     */
    Auto = 0,
    /**
     * The series in the chart are queried for their requested margins to incorporate into the plot area margin.
     */
    Series = 1,
    /**
     * There is no automatic determination of the plot area margin.
     */
    None = 2
}
/**
 * @hidden
 */
export declare let ComputedPlotAreaMarginMode_$type: Type;
