import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    lh(a: SeriesView): void;
    p7: FinancialSeriesView;
    protected get_di(): boolean;
    ag(): Axis[];
    hk(a: any, b: string): any;
    protected rq(): number;
    private ro;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    sw: Brush;
    op(): Brush;
    oq(): Brush;
    ke(): void;
    pq: CategoryAxisBase;
    qc: NumericYAxis;
    r6: string;
    get qm(): IFastItemColumn$1<number>;
    set qm(a: IFastItemColumn$1<number>);
    private qh;
    rx: string;
    get qk(): IFastItemColumn$1<number>;
    set qk(a: IFastItemColumn$1<number>);
    private qf;
    r2: string;
    get ql(): IFastItemColumn$1<number>;
    set ql(a: IFastItemColumn$1<number>);
    private qg;
    ru: string;
    get qj(): IFastItemColumn$1<number>;
    set qj(a: IFastItemColumn$1<number>);
    private qe;
    sa: string;
    get qo(): IFastItemColumn$1<number>;
    set qo(a: IFastItemColumn$1<number>);
    private qi;
    qw: boolean;
    protected qr: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    qy(): boolean;
    protected si(a: AssigningCategoryStyleEventArgs): void;
    protected pz: CategorySeriesRenderManager;
    protected sg(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    rg(a: Point): number;
    g6(a: Point, b: boolean): number;
    g4(a: Point, b: boolean): number;
    fu(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    o2(a: Point, b: boolean, c: boolean): Point;
    f8(a: Point, b: boolean, c: boolean): number;
    f4(a: Point, b: boolean, c: boolean): number;
    f6(a: Point, b: boolean, c: boolean): number;
    ri(a: Point, b: boolean, c: boolean): number;
    rj(a: Point, b: boolean, c: boolean): number;
    rk(a: Point, b: boolean, c: boolean): number;
    oy(a: Point, b: boolean, c: boolean): Point;
    o0(a: Point, b: boolean, c: boolean): Point;
    sy(a: Point, b: boolean, c: boolean): Point;
    sx(a: Point, b: boolean, c: boolean): Point;
    sz(a: Point, b: boolean, c: boolean): Point;
    ky(): void;
    protected mn(a: Rect, b: Rect): void;
    protected mm(a: Rect, b: Rect): void;
    protected q1: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected q2: Dictionary$2<string, string>;
    private qn;
    private sf;
    private qq;
    protected lm(a: any, b: string, c: any, d: any): void;
    qt(a: any): boolean;
    qs(a: any): boolean;
    protected pj(a: number, b: number, c: Axis): any[];
    protected rn(a: SeriesView): number;
    protected rp(a: SeriesView): number;
    pi(a: number, b: number): any[];
    private qa;
    protected get_dr(): boolean;
    kf(): void;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    rr(a: Point): number;
    protected p9(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected p8(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected qu(): boolean;
    fw(a: Point): number;
    g0(a: Point): number;
    protected get_d3(): boolean;
    ar(): CategoryAxisBase;
    g2(a: Point): number;
    hh(a: Point): any;
    pu: CategoryFrame;
    pw: CategoryFrame;
    ps: CategoryFrame;
    pt(): CategoryFrame;
    protected rh(a: Rect, b: Rect, c: Rect): number;
    p1: CategoryTransitionInMode;
    qx: boolean;
    protected ek(): boolean;
    protected p0(): CategoryTransitionInMode;
    protected b6(): TransitionInSpeedType;
    sj(a: CategoryFrame, b: FinancialSeriesView): void;
    sh(a: CategoryFrame, b: FinancialSeriesView): void;
    e3(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    p2: CategoryTransitionSourceFramePreparer;
    rl(a: FinancialSeriesView): number;
    protected ki(): void;
    l1(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected qz(a: IList$1<string>): boolean;
    get q0(): boolean;
    protected qv(): boolean;
    protected se(a: FinancialEventArgs): void;
    protected get q8(): IEnumerable$1<number>;
    private _q5;
    private q5;
    protected get q7(): IEnumerable$1<number>;
    private _q4;
    private q4;
    protected get q6(): IEnumerable$1<number>;
    private _q3;
    private q3;
    ra(a: IList$1<number>): IList$1<number>;
    private qp;
    protected q9(): IList$1<string>;
    private re;
    getOpenColumnAsArray(): number[];
    private rc;
    getHighColumnAsArray(): number[];
    private rd;
    getLowColumnAsArray(): number[];
    private rb;
    getCloseColumnAsArray(): number[];
    private rf;
    getVolumeColumnAsArray(): number[];
    protected kk(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected p3(a: number, b: number): FinancialCalculationDataSource;
    rm(a: number): number;
    protected p4(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private pv;
    l2(a: Rect, b: RenderSurface): void;
    private pr;
    lz(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    an(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private px;
    get py(): CategoryMode;
    set py(a: CategoryMode);
    protected get_dx(): boolean;
    l5(a: Brush, b: Brush): void;
    private sk;
    private qb;
    private qd;
    hj(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bz: FinancialSeries;
    bx: FinancialBucketCalculator;
    b1: number;
    b0(a: CategoryFrame): boolean;
    b2(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract by(): FinancialBucketCalculator;
    as(): void;
    getDefaultTooltipTemplate(): string;
    protected af(): void;
}
