import { Base, Type, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { AssigningRadialStyleEventArgs } from "./AssigningRadialStyleEventArgs";
import { AssigningRadialMarkerStyleEventArgs } from "./AssigningRadialMarkerStyleEventArgs";
import { RadialAxes } from "./RadialAxes";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class RadialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: RadialBaseView;
    constructor(a: RadialBaseView);
    c: number;
    d: number;
    b: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RadialBase extends MarkerSeries implements IHasCategoryModePreference {
    static $t: Type;
    lh(a: SeriesView): void;
    q8: RadialBaseView;
    constructor();
    private r0;
    get categoryAxis(): CategoryAxisBase;
    ar(): CategoryAxisBase;
    qw(a: number, b: number): any[];
    protected rd: RadialSeriesRenderManager;
    cx(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private rv;
    re: SeriesRenderer$2<RadialFrame, RadialBaseView>;
    protected get_d4(): boolean;
    rl: boolean;
    rk: boolean;
    protected rg: boolean;
    protected rf: boolean;
    protected get_dr(): boolean;
    private q4;
    private q5;
    protected q1(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected q2(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected q3(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningRadialStyle: (sender: any, args: AssigningRadialStyleEventArgs) => void;
    assigningRadialMarkerStyle: (sender: any, args: AssigningRadialMarkerStyleEventArgs) => void;
    protected rp(): boolean;
    protected ro(): boolean;
    protected r3(a: AssigningRadialStyleEventArgs): void;
    protected r2(a: AssigningRadialMarkerStyleEventArgs): void;
    rr(a: SeriesView): number;
    rs(a: SeriesView): number;
    qz: CategoryAngleAxis;
    q6: NumericRadiusAxis;
    ag(): Axis[];
    rj: boolean;
    protected mn(a: Rect, b: Rect): void;
    protected mm(a: Rect, b: Rect): void;
    abstract preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected lm(a: any, b: string, c: any, d: any): void;
    protected rn(): boolean;
    protected rm(): boolean;
    ri(a: any): boolean;
    rh(a: any): boolean;
    hh(a: Point): any;
    rq(a: Point): number;
    fw(a: Point): number;
    g0(a: Point): number;
    eh(a: any): boolean;
    rb: RadialFrame;
    rc: RadialFrame;
    q9: RadialFrame;
    ra(): RadialFrame;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    abstract r1(a: RadialFrame, b: RadialBaseView): void;
    abstract r4(a: RadialFrame, b: RadialBaseView): void;
    q7: RadialAxes;
    ky(): void;
    e3(a: Rect, b: Rect, c: SeriesView): boolean;
    l1(a: boolean): void;
    rt(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialBaseView extends MarkerSeriesView {
    static $t: Type;
    cs: RadialBucketCalculator;
    cr: RadialBase;
    constructor(a: RadialBase);
    ct: Pool$1<Marker>;
    cf(a: (arg1: Marker) => void): void;
    cu: number;
    cv: Point;
}
