import { Type } from "igniteui-angular-core";
/**
 * Describes the highlighting mode to use for the series in the chart.
 */
export declare enum SeriesHighlightingBehavior {
    /**
     * Highlighting behavior is determined by the component.
     */
    Auto = 0,
    /**
     * Series are highlighted when the cursor is directly above them.
     */
    DirectlyOver = 1,
    /**
     * The nearest items to the cursor will be highlighted.
     */
    NearestItems = 2,
    /**
     * The nearest items to the cursor will be highlighted, the main shapes of the series will not be de-emphasized.
     */
    NearestItemsRetainMainShapes = 3,
    /**
     * The nearest items to the cursor will be highlighted, the main shapes of the series closest to the cursor will not be de-emphasized.
     */
    NearestItemsAndSeries = 4
}
/**
 * @hidden
 */
export declare let SeriesHighlightingBehavior_$type: Type;
