import { IgxFinancialCalculationDataSource } from './igx-financial-calculation-data-source';
import { IgxFinancialCalculationSupportingCalculations } from './igx-financial-calculation-supporting-calculations';
import { FinancialEventArgs as FinancialEventArgs_internal } from "./FinancialEventArgs";
/**
 * Parameterizes a financial calculation event.
*/
export declare class IgxFinancialEventArgs {
    protected _implementation: any;
    get i(): FinancialEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    get basedOn(): string[];
    set basedOn(v: string[]);
    /**
 * The beginning position that should be calculated from.
*/
    get position(): number;
    set position(v: number);
    static ngAcceptInputType_position: number | string;
    /**
     * The number of positions that should be calculated from the start.
    */
    get count(): number;
    set count(v: number);
    static ngAcceptInputType_count: number | string;
    /**
     * The data to use for the calculation.
    */
    get dataSource(): IgxFinancialCalculationDataSource;
    set dataSource(v: IgxFinancialCalculationDataSource);
    /**
     * The supporting calculations to use in the calculation.
    */
    get supportingCalculations(): IgxFinancialCalculationSupportingCalculations;
    set supportingCalculations(v: IgxFinancialCalculationSupportingCalculations);
}
