import { OnDestroy, Renderer2, ElementRef, NgZone } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { Legend } from "./Legend";
import { FinancialLegend } from './FinancialLegend';
import * as i0 from "@angular/core";
/**
 * Represents a legend that displays information about each series, most often used in financial charting.
*/
export declare class IgxFinancialLegendComponent extends IgxLegendBaseComponent implements OnDestroy {
    private renderer;
    private elRef;
    private ngZone;
    container: Element;
    constructor(renderer: Renderer2, elRef: ElementRef, ngZone: NgZone);
    private _wrapper;
    ngOnDestroy(): void;
    protected createImplementation(): Legend;
    get i(): FinancialLegend;
    /**
 * Gets if the legend is a financial legend.
*/
    get isFinancial(): boolean;
    static ngAcceptInputType_isFinancial: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxFinancialLegendComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxFinancialLegendComponent, "igx-financial-legend", never, {}, {}, never, never>;
}
