import { ILegendSeries } from "igniteui-angular-core";
import { ILegendOwner } from "igniteui-angular-core";
import { LegendMouseButtonEventArgs as LegendMouseButtonEventArgs_internal } from "./LegendMouseButtonEventArgs";
/**
 * Provides data for legend mouse button related events.
*/
export declare class IgxLegendMouseButtonEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): LegendMouseButtonEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets a value that indicates the present state of the event handling for a routed
     * event as it travels the route.
     * ChartMouseButton events are not routed events; setting this property effects the underlying
     * MouseButtonEvent.
    */
    get handled(): boolean;
    set handled(v: boolean);
    static ngAcceptInputType_handled: boolean | string;
    /**
     * Gets a reference to the object that raised the event.
    */
    get originalSource(): any;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item(): any;
    set item(v: any);
    /**
     * Gets the series associated with the current event.
    */
    get series(): ILegendSeries;
    set series(v: ILegendSeries);
    /**
     * Gets the Chart associated with the current event.
    */
    get chart(): ILegendOwner;
    set chart(v: ILegendOwner);
    /**
     * The legend item that was the target of the mouse event.
    */
    get legendItem(): any;
    set legendItem(v: any);
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString(): string;
}
