import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { IgxItemwiseStrategyBasedIndicatorComponent } from "./igx-itemwise-strategy-based-indicator-component";
import { MarketFacilitationIndexIndicator } from "./MarketFacilitationIndexIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent Market Facilitation Index indicator series.
 * The Market Facilitation Index (MFI) indicator is represented by
 * the difference of the high and the low for a bar divided by the volume.
 * Default required members: High, Low, Volume
*
* The Market Facilitation Index (MFI) indicator is represented by the difference of the high and the low for a bar divided by the volume.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-market-facilitation-index-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-market-facilitation-index-indicator>
* </igx-data-chart>
* ```
*/
export declare class IgxMarketFacilitationIndexIndicatorComponent extends IgxItemwiseStrategyBasedIndicatorComponent {
    protected createImplementation(): MarketFacilitationIndexIndicator;
    /**
                                 * @hidden
                                 */
    get i(): MarketFacilitationIndexIndicator;
    constructor();
    /**
     * Gets default display type for the current Financial Indicator
    */
    get defaultDisplayType(): IndicatorDisplayType;
    static ngAcceptInputType_defaultDisplayType: IndicatorDisplayType | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxMarketFacilitationIndexIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxMarketFacilitationIndexIndicatorComponent, "igx-market-facilitation-index-indicator", never, {}, {}, never, never>;
}
