import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { MassIndexIndicator } from "./MassIndexIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent Mass Index indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Mass Index indicator series.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-mass-index-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-mass-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMassIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.volumeMemberPath= "volume";
* this.chart.series.add(series);
* ```
*/
export declare class IgxMassIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): MassIndexIndicator;
    /**
                                 * @hidden
                                 */
    get i(): MassIndexIndicator;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxMassIndexIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxMassIndexIndicatorComponent, "igx-mass-index-indicator", never, {}, {}, never, never>;
}
