import { IgxStraightNumericAxisBaseComponent } from "./igx-straight-numeric-axis-base-component";
import { NumericYAxis } from "./NumericYAxis";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent numeric Y axis.
*
* The `IgxNumericYAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the Y-axis. Location of labels varies according to the value in a data column that is mapped using the `YMemberPath` property for Scatter Series or `ValueMemberPath` property for Category Series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-column-series>
* </igx-data-chart>
* ```
*/
export declare class IgxNumericYAxisComponent extends IgxStraightNumericAxisBaseComponent {
    protected createImplementation(): NumericYAxis;
    /**
                                 * @hidden
                                 */
    get i(): NumericYAxis;
    constructor();
    /**
     * Gets if the current axis is of vertical axis
    */
    get isVertical(): boolean;
    static ngAcceptInputType_isVertical: boolean | string;
    scrollRangeIntoView(minimum: number, maximum: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxNumericYAxisComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxNumericYAxisComponent, "igx-numeric-y-axis", never, {}, {}, never, never>;
}
