import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { PointSeries } from "./PointSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent point series.
*
* You can use the `IgxPointSeriesComponent` plot a value along a category or date.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis
* 		#yAxis>
*     <igx-numeric-y-axis>
*     </igx-numeric-y-axis>
*     <igx-point-series
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		valueMemberPath="coal">
*     </igx-point-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxPointSeriesComponent = new IgxPointSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "coal";
* this.chart.series.add(series);
* ```
*/
export declare class IgxPointSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    protected createImplementation(): PointSeries;
    /**
                                 * @hidden
                                 */
    get i(): PointSeries;
    constructor();
    /**
     * Gets whether the series has only marker as visuals
    */
    get hasOnlyMarkers(): boolean;
    static ngAcceptInputType_hasOnlyMarkers: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPointSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxPointSeriesComponent, "igx-point-series", never, {}, {}, never, never>;
}
