import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { RadialColumnSeries } from "./RadialColumnSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent radial column series.
 * Compare values across categories by using radial rectangles.
*/
export declare class IgxRadialColumnSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    protected createImplementation(): RadialColumnSeries;
    /**
                                 * @hidden
                                 */
    get i(): RadialColumnSeries;
    constructor();
    /**
     * Gets whether the current series shows a column shape.
    */
    get isColumn(): boolean;
    static ngAcceptInputType_isColumn: boolean | string;
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    static ngAcceptInputType_isMarkerlessDisplayPreferred: boolean | string;
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX(): number;
    set radiusX(v: number);
    static ngAcceptInputType_radiusX: number | string;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY(): number;
    set radiusY(v: number);
    static ngAcceptInputType_radiusY: number | string;
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate(): void;
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan(): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxRadialColumnSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxRadialColumnSeriesComponent, "igx-radial-column-series", never, { "radiusX": "radiusX"; "radiusY": "radiusY"; }, {}, never, never>;
}
