import { UnknownValuePlotting } from "igniteui-angular-core";
import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { RadialLineSeries } from "./RadialLineSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent radial line series.
*/
export declare class IgxRadialLineSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    protected createImplementation(): RadialLineSeries;
    /**
                                 * @hidden
                                 */
    get i(): RadialLineSeries;
    constructor();
    /**
     * Gets whether the current series shows only line shapes.
    */
    get isLineOnly(): boolean;
    static ngAcceptInputType_isLineOnly: boolean | string;
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting(): UnknownValuePlotting;
    set unknownValuePlotting(v: UnknownValuePlotting);
    static ngAcceptInputType_unknownValuePlotting: UnknownValuePlotting | string;
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxRadialLineSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxRadialLineSeriesComponent, "igx-radial-line-series", never, { "unknownValuePlotting": "unknownValuePlotting"; }, {}, never, never>;
}
