import { IgSize } from "igniteui-angular-core";
import { IgPoint } from "igniteui-angular-core";
import { IgxRingSeriesBaseComponent } from "./igx-ring-series-base-component";
import { Ring as Ring_internal } from "./Ring";
/**
 * Represents data for Ring.RingControl element.
*/
export declare class IgxRing {
    protected createImplementation(): Ring_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): Ring_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the index of ring in the chart.
    */
    get index(): number;
    set index(v: number);
    static ngAcceptInputType_index: number | string;
    /**
     * Gets the inner extend of the ring in percentage.
    */
    get innerExtend(): number;
    set innerExtend(v: number);
    static ngAcceptInputType_innerExtend: number | string;
    /**
     * Gets the size of the ring.
    */
    get controlSize(): IgSize;
    set controlSize(v: IgSize);
    static ngAcceptInputType_controlSize: IgSize | string;
    /**
     * Gets the center point of the ring.
    */
    get center(): IgPoint;
    set center(v: IgPoint);
    static ngAcceptInputType_center: IgPoint | string;
    /**
     * Gets reference to ring series.
    */
    get ringSeries(): IgxRingSeriesBaseComponent;
    set ringSeries(v: IgxRingSeriesBaseComponent);
    /**
     * Gets the ring breadth.
    */
    get ringBreadth(): number;
    set ringBreadth(v: number);
    static ngAcceptInputType_ringBreadth: number | string;
    findByName(name: string): any;
    /**
     * Renders the arcs.
    
    */
    renderArcs(): boolean;
    /**
     * Prepares data needed to create Arcs.
    
    */
    prepareArcs(): void;
}
