import { IgRect } from "igniteui-angular-core";
import { IgPoint } from "igniteui-angular-core";
import { SliceEventArgs as SliceEventArgs_internal } from "./SliceEventArgs";
/**
 * Contains PieChart click event data.
*/
export declare class IgxSliceEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): SliceEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets whether the slice is selected.
    */
    get isSelected(): boolean;
    set isSelected(v: boolean);
    static ngAcceptInputType_isSelected: boolean | string;
    /**
     * Gets or sets whether the slice is exploded.
    */
    get isExploded(): boolean;
    set isExploded(v: boolean);
    static ngAcceptInputType_isExploded: boolean | string;
    /**
     * Gets whether the current slice is part of the others slice.
    */
    get isOthersSlice(): boolean;
    static ngAcceptInputType_isOthersSlice: boolean | string;
    /**
     * Gets the index of the slice that was clicked.
    */
    get index(): number;
    static ngAcceptInputType_index: number | string;
    /**
     * Gets the origin location of the slice.
    */
    get origin(): IgPoint;
    static ngAcceptInputType_origin: IgPoint | string;
    /**
     * Gets the radius of the slice.
    */
    get radius(): number;
    static ngAcceptInputType_radius: number | string;
    /**
     * Gets the bounds of the slice.
    */
    get bounds(): IgRect;
    static ngAcceptInputType_bounds: IgRect | string;
    /**
     * Gets the start angle of the slice.
    */
    get startAngle(): number;
    static ngAcceptInputType_startAngle: number | string;
    /**
     * Gets the end angle of the slice.
    */
    get endAngle(): number;
    static ngAcceptInputType_endAngle: number | string;
    /**
     * Gets the fill color of the slice.
    */
    get fill(): string;
    /**
     * Gets the outline color of the slice.
    */
    get outline(): string;
    /**
     * Gets the slice data context.
    */
    get dataContext(): any;
    /**
     * Holds a reference to the original event that triggered slice click.
    */
    get originalEvent(): any;
    set originalEvent(v: any);
}
