import { IgxSplineSeriesBaseComponent } from "./igx-spline-series-base-component";
import { SplineSeries } from "./SplineSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent spline series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-spline-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-spline-series>
* </igx-data-chart>
* ```
*/
export declare class IgxSplineSeriesComponent extends IgxSplineSeriesBaseComponent {
    protected createImplementation(): SplineSeries;
    /**
                                 * @hidden
                                 */
    get i(): SplineSeries;
    constructor();
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline(): boolean;
    static ngAcceptInputType_isSpline: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxSplineSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxSplineSeriesComponent, "igx-spline-series", never, {}, {}, never, never>;
}
