import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { StepLineSeries } from "./StepLineSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent step line series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-step-line-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-step-line-series>
* </igx-data-chart>
* ```
*
* ```ts
*    let series = new IgxStepLineSeriesComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.valueMemberPath="value";
*    this.chart.series.add(series);
* ```
*/
export declare class IgxStepLineSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    protected createImplementation(): StepLineSeries;
    /**
                                 * @hidden
                                 */
    get i(): StepLineSeries;
    constructor();
    /**
     * Gets whether the current series shows only line shapes.
    */
    get isLineOnly(): boolean;
    static ngAcceptInputType_isLineOnly: boolean | string;
    /**
     * Gets whether the current series shows step shapes.
    */
    get isStep(): boolean;
    static ngAcceptInputType_isStep: boolean | string;
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    static ngAcceptInputType_isMarkerlessDisplayPreferred: boolean | string;
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine(): boolean;
    static ngAcceptInputType_isAreaOrLine: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxStepLineSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxStepLineSeriesComponent, "igx-step-line-series", never, {}, {}, never, never>;
}
