import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { UltimateOscillatorIndicator } from "./UltimateOscillatorIndicator";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent Ultimate Oscillator indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgxUltimateOscillatorIndicatorComponent` which represents a IgxDataChartComponent Ultimate Oscillator indicator series.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-ultimate-oscillator-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-ultimate-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxUltimateOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
export declare class IgxUltimateOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): UltimateOscillatorIndicator;
    /**
                                 * @hidden
                                 */
    get i(): UltimateOscillatorIndicator;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxUltimateOscillatorIndicatorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxUltimateOscillatorIndicatorComponent, "igx-ultimate-oscillator-indicator", never, {}, {}, never, never>;
}
