(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('tslib'), require('igniteui-angular-core')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', 'tslib', 'igniteui-angular-core'], factory) :
    (global = global || self, factory(global['igniteui-angular-charts'] = {}, global.i0, global.i1, global.tslib, global.i2));
}(this, (function (exports, i0, i1, tslib, i2) { 'use strict';

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IAnnotationLayerProxy_$type = new i2.Type(null, 'IAnnotationLayerProxy');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes mode for selecting marker type when the series marker type is set to automatic.
     */
    var MarkerAutomaticBehavior = /*@__PURE__*/ (function (MarkerAutomaticBehavior) {
        /**
         * Sets a circle marker on most series and no marker on bar, column, waterfall, polygon, and step series.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["CircleSmart"] = 0] = "CircleSmart";
        /**
         * Sets no visible marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["None"] = 1] = "None";
        /**
         * Sets an marker on most series based on its index and no marker on bar, column, waterfall, polygon, and step series.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["SmartIndexed"] = 2] = "SmartIndexed";
        /**
         * Sets marker for each series in the chart based on its index: circle, triangle, pyramid, etc.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Indexed"] = 3] = "Indexed";
        /**
         * Sets circle marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Circle"] = 4] = "Circle";
        /**
         * Sets flat-top triangle marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Triangle"] = 5] = "Triangle";
        /**
         * Sets flat-base triangle marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Pyramid"] = 6] = "Pyramid";
        /**
         * Sets square marker shape on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Square"] = 7] = "Square";
        /**
         * Sets diamond marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Diamond"] = 8] = "Diamond";
        /**
         * Sets pentagon marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Pentagon"] = 9] = "Pentagon";
        /**
         * Sets Hexagon marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Hexagon"] = 10] = "Hexagon";
        /**
         * Sets four-pointed star marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Tetragram"] = 11] = "Tetragram";
        /**
         * Sets five-pointed star marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Pentagram"] = 12] = "Pentagram";
        /**
         * Sets six-pointed star marker on all series in the chart.
         */
        MarkerAutomaticBehavior[MarkerAutomaticBehavior["Hexagram"] = 13] = "Hexagram";
        return MarkerAutomaticBehavior;
    })({});
    /**
     * @hidden
     */
    var MarkerAutomaticBehavior_$type = i2.markEnum('MarkerAutomaticBehavior', 'CircleSmart,0|None,1|SmartIndexed,2|Indexed,3|Circle,4|Triangle,5|Pyramid,6|Square,7|Diamond,8|Pentagon,9|Hexagon,10|Tetragram,11|Pentagram,12|Hexagram,13');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes the highlighting mode to use for the series in the chart.
     */
    var SeriesHighlightingMode = /*@__PURE__*/ (function (SeriesHighlightingMode) {
        /**
         * Highlighting mode is determined by the component.
         */
        SeriesHighlightingMode[SeriesHighlightingMode["Auto"] = 0] = "Auto";
        /**
         * No highlighting is defined at the chart level. Individual series may have local highlight settings.
         */
        SeriesHighlightingMode[SeriesHighlightingMode["None"] = 1] = "None";
        /**
         * Series will brighten when hovered, and, if applicable brighten indiviudal shapes or markers.
         */
        SeriesHighlightingMode[SeriesHighlightingMode["BrightenSpecific"] = 2] = "BrightenSpecific";
        /**
         * Series will brighten when hovered.
         */
        SeriesHighlightingMode[SeriesHighlightingMode["Brighten"] = 3] = "Brighten";
        /**
         * Series will fade if they aren't the hovered series, and, if applicable other shapes in the hovered series will fade.
         */
        SeriesHighlightingMode[SeriesHighlightingMode["FadeOthersSpecific"] = 4] = "FadeOthersSpecific";
        /**
         * Series will fade if they aren't the hovered series, and, if applicable other shapes in the hovered series will fade.
         */
        SeriesHighlightingMode[SeriesHighlightingMode["FadeOthers"] = 5] = "FadeOthers";
        return SeriesHighlightingMode;
    })({});
    /**
     * @hidden
     */
    var SeriesHighlightingMode_$type = i2.markEnum('SeriesHighlightingMode', 'Auto,0|None,1|BrightenSpecific,2|Brighten,3|FadeOthersSpecific,4|FadeOthers,5');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes the highlighting mode to use for the series in the chart.
     */
    var SeriesHighlightingBehavior = /*@__PURE__*/ (function (SeriesHighlightingBehavior) {
        /**
         * Highlighting behavior is determined by the component.
         */
        SeriesHighlightingBehavior[SeriesHighlightingBehavior["Auto"] = 0] = "Auto";
        /**
         * Series are highlighted when the cursor is directly above them.
         */
        SeriesHighlightingBehavior[SeriesHighlightingBehavior["DirectlyOver"] = 1] = "DirectlyOver";
        /**
         * The nearest items to the cursor will be highlighted.
         */
        SeriesHighlightingBehavior[SeriesHighlightingBehavior["NearestItems"] = 2] = "NearestItems";
        /**
         * The nearest items to the cursor will be highlighted, the main shapes of the series will not be de-emphasized.
         */
        SeriesHighlightingBehavior[SeriesHighlightingBehavior["NearestItemsRetainMainShapes"] = 3] = "NearestItemsRetainMainShapes";
        /**
         * The nearest items to the cursor will be highlighted, the main shapes of the series closest to the cursor will not be de-emphasized.
         */
        SeriesHighlightingBehavior[SeriesHighlightingBehavior["NearestItemsAndSeries"] = 4] = "NearestItemsAndSeries";
        return SeriesHighlightingBehavior;
    })({});
    /**
     * @hidden
     */
    var SeriesHighlightingBehavior_$type = i2.markEnum('SeriesHighlightingBehavior', 'Auto,0|DirectlyOver,1|NearestItems,2|NearestItemsRetainMainShapes,3|NearestItemsAndSeries,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes the highlighting mode to use for the series in the chart.
     */
    var LegendHighlightingMode = /*@__PURE__*/ (function (LegendHighlightingMode) {
        /**
         * Highlighting mode is determined by the component.
         */
        LegendHighlightingMode[LegendHighlightingMode["Auto"] = 0] = "Auto";
        /**
         * Legend will not attempt to highlight series when rolling over legend items.
         */
        LegendHighlightingMode[LegendHighlightingMode["None"] = 1] = "None";
        /**
         * On rollover of legend, series will highlight matching the highlight configuration of the series.
         */
        LegendHighlightingMode[LegendHighlightingMode["MatchSeries"] = 2] = "MatchSeries";
        return LegendHighlightingMode;
    })({});
    /**
     * @hidden
     */
    var LegendHighlightingMode_$type = i2.markEnum('LegendHighlightingMode', 'Auto,0|None,1|MatchSeries,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes the type of legend badge that represents a series in a legend
     */
    var LegendItemBadgeShape = /*@__PURE__*/ (function (LegendItemBadgeShape) {
        /**
         * Specifies automatic badge with best match of series type, e.g. Square badge for Area Series, Line badge for Line Series etc.
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Automatic"] = 0] = "Automatic";
        /**
         * Specifies a circle badge in a legend
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Circle"] = 1] = "Circle";
        /**
         * Specifies a thin line badge in a legend
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Line"] = 2] = "Line";
        /**
         * Specifies a square badge in a legend
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Square"] = 3] = "Square";
        /**
         * Specifies a marker badge in a legend (if series supports markers otherwise a circle badge)
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Marker"] = 4] = "Marker";
        /**
         * Specifies a thick horizontal bar in a legend
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Bar"] = 5] = "Bar";
        /**
         * Specifies a thick vertical column in a legend
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Column"] = 6] = "Column";
        /**
         * Specifies hidden badge in a legend, next to the series title
         */
        LegendItemBadgeShape[LegendItemBadgeShape["Hidden"] = 7] = "Hidden";
        return LegendItemBadgeShape;
    })({});
    /**
     * @hidden
     */
    var LegendItemBadgeShape_$type = i2.markEnum('LegendItemBadgeShape', 'Automatic,0|Circle,1|Line,2|Square,3|Marker,4|Bar,5|Column,6|Hidden,7');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes mode of legend badges that represent all series in a legend
     */
    var LegendItemBadgeMode = /*@__PURE__*/ (function (LegendItemBadgeMode) {
        /**
         * Specifies legend badges with simplified visuals of series, e.g. with fixed thickness, no overlaid markers
         */
        LegendItemBadgeMode[LegendItemBadgeMode["Simplified"] = 0] = "Simplified";
        /**
         * Specifies legend badges that match all visuals of series such as thickness and markers (if supported by a series)
         */
        LegendItemBadgeMode[LegendItemBadgeMode["MatchSeries"] = 1] = "MatchSeries";
        return LegendItemBadgeMode;
    })({});
    /**
     * @hidden
     */
    var LegendItemBadgeMode_$type = i2.markEnum('LegendItemBadgeMode', 'Simplified,0|MatchSeries,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors for performing hit testing in the chart/map.
     */
    var ChartHitTestMode = /*@__PURE__*/ (function (ChartHitTestMode) {
        /**
         * Automatically decide the appropriate hit test mode for the content.
         */
        ChartHitTestMode[ChartHitTestMode["Auto"] = 0] = "Auto";
        /**
         * Use a computational based approach to determine which series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded.
         */
        ChartHitTestMode[ChartHitTestMode["Computational"] = 1] = "Computational";
        /**
         * Use a color encoded off screen buffer for hit testing. This can have extremely rare false positives where the wrong series is hit (this is due to our inability to disable anti-aliasing in our color buffer), but should always be O(1) time for determining a hit series. This increases frame render time, however. Consider using this if hit testing time is degrading performance.
         */
        ChartHitTestMode[ChartHitTestMode["ColorEncoded"] = 2] = "ColorEncoded";
        /**
         * Let each series decide which hit testing mode to use individually based on their own hit test mode.
         */
        ChartHitTestMode[ChartHitTestMode["Mixed"] = 3] = "Mixed";
        /**
         * Let each series decide which hit testing mode to use individually based on their own hit test mode, but evaluate all computational hits before evaluating any color encoding hits.
         */
        ChartHitTestMode[ChartHitTestMode["MixedFavoringComputational"] = 4] = "MixedFavoringComputational";
        return ChartHitTestMode;
    })({});
    /**
     * @hidden
     */
    var ChartHitTestMode_$type = i2.markEnum('ChartHitTestMode', 'Auto,0|Computational,1|ColorEncoded,2|Mixed,3|MixedFavoringComputational,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of UI response to user panning and zooming operations.
     */
    var WindowResponse = /*@__PURE__*/ (function (WindowResponse) {
        /**
         * Defer the view update until after the user action is complete.
         */
        WindowResponse[WindowResponse["Deferred"] = 0] = "Deferred";
        /**
         * Update the view immediately while the user action is happening.
         */
        WindowResponse[WindowResponse["Immediate"] = 1] = "Immediate";
        return WindowResponse;
    })({});
    /**
     * @hidden
     */
    var WindowResponse_$type = i2.markEnum('WindowResponse', 'Deferred,0|Immediate,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesViewerComponentsFromView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerComponentsFromView, _super);
        function SeriesViewerComponentsFromView() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            return _this;
        }
        SeriesViewerComponentsFromView.$t = i2.markType(SeriesViewerComponentsFromView, 'SeriesViewerComponentsFromView');
        return SeriesViewerComponentsFromView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var ZoomCoercionMode = /*@__PURE__*/ (function (ZoomCoercionMode) {
        /**
         * Zoom coercion mode is decided by the component.
         */
        ZoomCoercionMode[ZoomCoercionMode["Auto"] = 0] = "Auto";
        /**
         * The zoom window is constrained to the axis bounds.
         */
        ZoomCoercionMode[ZoomCoercionMode["AxisConstrained"] = 1] = "AxisConstrained";
        /**
         * The zoom window is unconstrained by the axis bounds.
         */
        ZoomCoercionMode[ZoomCoercionMode["Unconstrained"] = 2] = "Unconstrained";
        return ZoomCoercionMode;
    })({});
    /**
     * @hidden
     */
    var ZoomCoercionMode_$type = i2.markEnum('ZoomCoercionMode', 'Auto,0|AxisConstrained,1|Unconstrained,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SyncSettings = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SyncSettings, _super);
        function SyncSettings() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            return _this;
        }
        SyncSettings.prototype.ai = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        SyncSettings.$t = i2.markType(SyncSettings, 'SyncSettings', i2.FrameworkElement.$, [i2.INotifyPropertyChanged_$type]);
        SyncSettings.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, SyncSettings, 'ai', ['SyncChannel', [2, null], 'SynchronizeHorizontally', [0, true], 'SynchronizeVertically', [0, true]]);
        return SyncSettings;
    }(i2.FrameworkElement));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesViewerComponentsForView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerComponentsForView, _super);
        function SeriesViewerComponentsForView() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SeriesViewerComponentsForView.$t = i2.markType(SeriesViewerComponentsForView, 'SeriesViewerComponentsForView');
        return SeriesViewerComponentsForView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScalerParams = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScalerParams, _super);
        function ScalerParams(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.e = null;
            _this.d = null;
            _this.c = null;
            _this.a = false;
            _this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        _this.e = c;
                        _this.d = d;
                        _this.c = f;
                        _this.a = e;
                        _this.b = NaN;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = [c, d, e, i2.Rect.empty];
                        {
                            var h = f[0];
                            var i = f[1];
                            var j = f[2];
                            var k = f[3];
                            _this.e = h;
                            _this.d = i;
                            _this.c = k;
                            _this.a = j;
                            _this.b = NaN;
                        }
                    }
                    break;
            }
            return _this;
        }
        ScalerParams.$t = i2.markType(ScalerParams, 'ScalerParams');
        return ScalerParams;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesViewerManipulationEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerManipulationEventArgs, _super);
        function SeriesViewerManipulationEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._isZoomPan = false;
            _this._isDragZoom = false;
            return _this;
        }
        Object.defineProperty(SeriesViewerManipulationEventArgs.prototype, "isZoomPan", {
            get: function () {
                return this._isZoomPan;
            },
            set: function (a) {
                this._isZoomPan = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerManipulationEventArgs.prototype, "isDragZoom", {
            get: function () {
                return this._isDragZoom;
            },
            set: function (a) {
                this._isDragZoom = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerManipulationEventArgs.$t = i2.markType(SeriesViewerManipulationEventArgs, 'SeriesViewerManipulationEventArgs', i2.EventArgs.$);
        return SeriesViewerManipulationEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RefreshCompletedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RefreshCompletedEventArgs, _super);
        function RefreshCompletedEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RefreshCompletedEventArgs.$t = i2.markType(RefreshCompletedEventArgs, 'RefreshCompletedEventArgs', i2.EventArgs.$);
        return RefreshCompletedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available positions for axis title in respect to axis labels
     */
    var AxisTitlePosition = /*@__PURE__*/ (function (AxisTitlePosition) {
        /**
         * Displays the axis title in automatically selected position based on orientation and location of the axis:
         * <para/> - left title position for vertical axis located on left of the chart,
         * <para/> - right title position for vertical axis located on right of the chart,
         * <para/> - top title position for horizontal axis located on top of the chart,
         * <para/> - bottom title position for horizontal axis located on bottom of the chart,
         */
        AxisTitlePosition[AxisTitlePosition["Auto"] = 0] = "Auto";
        /**
         * Displays the axis title to the left of labels on vertical axis
         */
        AxisTitlePosition[AxisTitlePosition["Left"] = 1] = "Left";
        /**
         * Displays the axis title to the right of labels on vertical axis
         */
        AxisTitlePosition[AxisTitlePosition["Right"] = 2] = "Right";
        /**
         * Displays the axis title on top of labels on horizontal axis
         */
        AxisTitlePosition[AxisTitlePosition["Top"] = 3] = "Top";
        /**
         * Displays the axis title on bottom of labels on horizontal axis
         */
        AxisTitlePosition[AxisTitlePosition["Bottom"] = 4] = "Bottom";
        return AxisTitlePosition;
    })({});
    /**
     * @hidden
     */
    var AxisTitlePosition_$type = i2.markEnum('AxisTitlePosition', 'Auto,0|Left,1|Right,2|Top,3|Bottom,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CoercionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CoercionInfo, _super);
        function CoercionInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.a = null;
            return _this;
        }
        CoercionInfo.$t = i2.markType(CoercionInfo, 'CoercionInfo');
        return CoercionInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChartContentType_$type = i2.markEnum('ChartContentType', 'Series,0|Axis,1|Background,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITileZoomTile_$type = new i2.Type(null, 'ITileZoomTile');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RenderSurface = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RenderSurface, _super);
        function RenderSurface() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            return _this;
        }
        RenderSurface.$t = i2.markType(RenderSurface, 'RenderSurface');
        return RenderSurface;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LabelPanelsArrangeState = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LabelPanelsArrangeState, _super);
        function LabelPanelsArrangeState() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = 0;
            _this.h = 0;
            _this.b = 0;
            _this.e = 0;
            _this.f = 0;
            _this.g = 0;
            _this.c = 0;
            _this.d = 0;
            return _this;
        }
        LabelPanelsArrangeState.$t = i2.markType(LabelPanelsArrangeState, 'LabelPanelsArrangeState');
        return LabelPanelsArrangeState;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerTemplates, _super);
        function MarkerTemplates() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MarkerTemplates.n = function (a, b, c) {
            a.beginPath();
            var d = b.actualItemBrush;
            var e = b.outline;
            if (d != null) {
                if (d.isGradient) {
                    var f = c.availableWidth / 2;
                    var g = c.availableHeight / 2;
                    var h = c.xPosition - f;
                    var i = c.yPosition - f;
                    h += c.renderOffsetX;
                    i += c.renderOffsetY;
                    var j = i2.CanvasViewRenderer.j(a, d, h, i, h + c.availableWidth, i + c.availableHeight, b.thickness, false);
                    a.fillStyle = j;
                }
                else {
                    if (a.fillStyle != d._fill) {
                        a.fillStyle = d._fill;
                    }
                }
            }
            if (b.outline != null) {
                if (b.outline.isGradient) {
                    var k = c.availableWidth / 2;
                    var l = c.availableHeight / 2;
                    var m = c.xPosition - k;
                    var n = c.yPosition - k;
                    m += c.renderOffsetX;
                    n += c.renderOffsetY;
                    var o = i2.CanvasViewRenderer.j(a, b.outline, m, n, m + c.availableWidth, n + c.availableHeight, b.thickness, true);
                    a.strokeStyle = o;
                }
                else {
                    if (a.strokeStyle != b.outline._fill) {
                        a.strokeStyle = b.outline._fill;
                    }
                }
                a.lineWidth = b.thickness;
            }
        };
        MarkerTemplates.a = function (a, b) {
            a.closePath();
            if (b.actualItemBrush != null) {
                a.fill();
            }
            if (b.outline != null) {
                a.stroke();
            }
        };
        MarkerTemplates.b = function (a) {
            a.isConstant = true;
            a.width = 8;
            a.height = 8;
        };
        MarkerTemplates.d = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = Math.min(a.availableWidth, a.availableHeight) / 2;
            b.arc(a.xPosition, a.yPosition, d, 0, (Math.PI * 2), false);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.m = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f, g);
            b.lineTo(f + e, g + a.availableHeight);
            b.lineTo(f + a.availableWidth, g + 0);
            b.lineTo(f, g);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.j = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f, g + a.availableHeight);
            b.lineTo(f + e, g + 0);
            b.lineTo(f + a.availableWidth, g + a.availableHeight);
            b.lineTo(f, g + a.availableHeight);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.k = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.rect(f, g, a.availableWidth, a.availableHeight);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.c = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var left_ = (a.xPosition - e);
            var top_ = (a.yPosition - d);
            b.rect((left_ | 0), (top_ | 0), a.availableWidth, a.availableHeight);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.e = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f + 0, g + d);
            b.lineTo(f + e, g + a.availableHeight);
            b.lineTo(f + a.availableWidth, g + d);
            b.lineTo(f + e, g + 0);
            b.lineTo(f + 0, g + d);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.h = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
            b.lineTo(f + ((0.1956000030040741 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
            b.lineTo(f + ((1.6499999761581421 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
            b.lineTo(f + ((6.3499999046325684 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
            b.lineTo(f + ((7.8043999671936035 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.f = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
            b.lineTo(f + ((0.35600000619888306 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
            b.lineTo(f + ((0.35600000619888306 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + (a.availableHeight));
            b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
            b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.l = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
            b.lineTo(f + ((2.5855998992919922 / 8) * a.availableWidth), g + ((2.5856 / 8) * a.availableHeight));
            b.lineTo(f + ((0 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
            b.lineTo(f + ((2.5855998992919922 / 8) * a.availableWidth), g + ((5.4144001007080078 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((8 / 8) * a.availableHeight));
            b.lineTo(f + ((5.4144001007080078 / 8) * a.availableWidth), g + ((5.4144001007080078 / 8) * a.availableHeight));
            b.lineTo(f + ((8 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
            b.lineTo(f + ((5.4144001007080078 / 8) * a.availableWidth), g + ((2.5855998992919922 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.i = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
            b.lineTo(f + ((2.8243999481201172 / 8) * a.availableWidth), g + ((2.382 / 8) * a.availableHeight));
            b.lineTo(f + ((0.1956 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
            b.lineTo(f + ((2.0980000495910645 / 8) * a.availableWidth), g + ((4.6180000305175781 / 8) * a.availableHeight));
            b.lineTo(f + ((1.6488000154495239 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
            b.lineTo(f + ((6.3512 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
            b.lineTo(f + ((5.9019999504089355 / 8) * a.availableWidth), g + ((4.6180000305175781 / 8) * a.availableHeight));
            b.lineTo(f + ((7.8043999671936035 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
            b.lineTo(f + ((5.1756000518798828 / 8) * a.availableWidth), g + ((2.3819999694824219 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.g = function (a) {
            var b = a.context;
            var c = a.data;
            MarkerTemplates.n(b, c, a);
            var d = (a.availableHeight / 2);
            var e = (a.availableWidth / 2);
            var f = (a.xPosition - e);
            var g = (a.yPosition - d);
            b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
            b.lineTo(f + ((3 / 8) * a.availableWidth), g + ((2.268 / 8) * a.availableHeight));
            b.lineTo(f + ((0.536 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
            b.lineTo(f + ((2 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
            b.lineTo(f + ((0.536 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
            b.lineTo(f + ((3 / 8) * a.availableWidth), g + ((5.73199987411499 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((8 / 8) * a.availableHeight));
            b.lineTo(f + ((5 / 8) * a.availableWidth), g + ((5.73199987411499 / 8) * a.availableHeight));
            b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
            b.lineTo(f + ((6 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
            b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
            b.lineTo(f + ((5 / 8) * a.availableWidth), g + ((2.2679998874664307 / 8) * a.availableHeight));
            b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
            MarkerTemplates.a(b, c);
        };
        MarkerTemplates.$t = i2.markType(MarkerTemplates, 'MarkerTemplates');
        return MarkerTemplates;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var AxisLabelsLocation = /*@__PURE__*/ (function (AxisLabelsLocation) {
        /**
         * Places the axis labels at the top, outside of the plotting area.
         */
        AxisLabelsLocation[AxisLabelsLocation["OutsideTop"] = 0] = "OutsideTop";
        /**
         * Places the axis labels at the bottom, outside of the plotting area
         */
        AxisLabelsLocation[AxisLabelsLocation["OutsideBottom"] = 1] = "OutsideBottom";
        /**
         * Places the axis labels to the left, outside of the plotting area.
         */
        AxisLabelsLocation[AxisLabelsLocation["OutsideLeft"] = 2] = "OutsideLeft";
        /**
         * Places the axis labels to the right, outside of the plotting area.
         */
        AxisLabelsLocation[AxisLabelsLocation["OutsideRight"] = 3] = "OutsideRight";
        /**
         * Places the axis labels inside the plotting area above the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        AxisLabelsLocation[AxisLabelsLocation["InsideTop"] = 4] = "InsideTop";
        /**
         * Places the axis labels inside the plotting area below the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        AxisLabelsLocation[AxisLabelsLocation["InsideBottom"] = 5] = "InsideBottom";
        /**
         * Places the axis labels inside the plotting area and to the left of the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        AxisLabelsLocation[AxisLabelsLocation["InsideLeft"] = 6] = "InsideLeft";
        /**
         * Places the axis labels inside the plotting area and to the right of the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        AxisLabelsLocation[AxisLabelsLocation["InsideRight"] = 7] = "InsideRight";
        return AxisLabelsLocation;
    })({});
    /**
     * @hidden
     */
    var AxisLabelsLocation_$type = i2.markEnum('AxisLabelsLocation', 'OutsideTop,0|OutsideBottom,1|OutsideLeft,2|OutsideRight,3|InsideTop,4|InsideBottom,5|InsideLeft,6|InsideRight,7');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IProvidesViewport_$type = new i2.Type(null, 'IProvidesViewport');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PointerTooltipStyle = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointerTooltipStyle, _super);
        function PointerTooltipStyle() {
            var _this = _super.call(this) || this;
            _this.b = 0;
            _this.a = 0;
            _this.d = null;
            _this.c = null;
            _this.b = NaN;
            _this.a = NaN;
            return _this;
        }
        PointerTooltipStyle.$t = i2.markType(PointerTooltipStyle, 'PointerTooltipStyle');
        return PointerTooltipStyle;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultPaletteInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultPaletteInfo, _super);
        function DefaultPaletteInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.f = null;
            _this.b = null;
            _this.c = null;
            _this.g = null;
            _this.d = null;
            _this.e = null;
            _this.k = null;
            _this.j = null;
            _this.h = null;
            _this.i = null;
            return _this;
        }
        DefaultPaletteInfo.$t = i2.markType(DefaultPaletteInfo, 'DefaultPaletteInfo');
        return DefaultPaletteInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisDefaults = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisDefaults, _super);
        function AxisDefaults() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AxisDefaults.$t = i2.markType(AxisDefaults, 'AxisDefaults');
        AxisDefaults.a = i2.DeviceUtils.g(1);
        AxisDefaults.c = i2.DeviceUtils.g(1);
        AxisDefaults.b = i2.DeviceUtils.g(1);
        AxisDefaults.e = i2.DeviceUtils.g(1);
        AxisDefaults.d = i2.DeviceUtils.g(0);
        AxisDefaults.f = i2.DeviceUtils.g(8);
        AxisDefaults.g = i2.BrushUtil.g(255, 158, 158, 158);
        AxisDefaults.i = null;
        AxisDefaults.h = i2.BrushUtil.g(255, 196, 196, 196);
        AxisDefaults.j = i2.BrushUtil.g(255, 158, 158, 158);
        return AxisDefaults;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Defaults = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Defaults, _super);
        function Defaults() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Defaults.$t = i2.markType(Defaults, 'Defaults');
        Defaults.ae = i2.BrushUtil.g(255, 187, 187, 187);
        Defaults.j = i2.DeviceUtils.g(1);
        Defaults.ag = i2.BrushUtil.g(255, 255, 255, 255);
        Defaults.af = i2.BrushUtil.g(255, 0, 0, 0);
        Defaults.v = i2.DeviceUtils.g(2);
        Defaults.w = 16;
        Defaults.u = 16;
        Defaults.t = 6;
        Defaults.s = i2.DeviceUtils.g(12);
        Defaults.r = i2.DeviceUtils.g(12);
        Defaults.ab = i2.DeviceUtils.g(2);
        Defaults.ad = i2.DeviceUtils.g(2);
        Defaults.ac = i2.DeviceUtils.g(1);
        Defaults.ah = i2.BrushUtil.g(255, 238, 88, 121);
        Defaults.ai = i2.BrushUtil.g(255, 238, 88, 121);
        Defaults.l = i2.DeviceUtils.g(1);
        Defaults.k = i2.DeviceUtils.g(5);
        Defaults.g = 1;
        Defaults.i = i2.DeviceUtils.g(1);
        Defaults.h = i2.DeviceUtils.g(4);
        Defaults.c = 1;
        Defaults.e = 2;
        Defaults.aq = i2.ColorUtil.r("#000000");
        Defaults.ap = i2.ColorUtil.r("#ee5879");
        Defaults.al = i2.BrushUtil.g(255, 0, 0, 0);
        Defaults.ak = i2.BrushUtil.g(255, 238, 88, 121);
        Defaults.q = i2.DeviceUtils.g(4);
        Defaults.x = i2.DeviceUtils.g(5);
        Defaults.aa = i2.DeviceUtils.g(2);
        Defaults.am = i2.BrushUtil.g(255, 0, 0, 0);
        Defaults.z = i2.DeviceUtils.g(2);
        Defaults.y = i2.DeviceUtils.g(2);
        Defaults.f = 1;
        Defaults.b = 1;
        Defaults.aj = i2.BrushUtil.g(255, 0, 0, 0);
        Defaults.p = i2.DeviceUtils.g(1);
        Defaults.o = i2.DeviceUtils.g(2);
        Defaults.d = 1;
        Defaults.a = 1;
        Defaults.n = i2.DeviceUtils.g(2);
        Defaults.m = i2.DeviceUtils.g(2);
        Defaults.ao = i2.BrushUtil.g(255, 170, 211, 223);
        Defaults.an = i2.BrushUtil.g(255, 255, 255, 255);
        return Defaults;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisRange = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisRange, _super);
        function AxisRange(a, b) {
            var _this = _super.call(this) || this;
            _this.c = 0;
            _this.b = 0;
            _this.c = a;
            _this.b = b;
            return _this;
        }
        AxisRange.prototype.equals = function (a) {
            return a != null && this.c == a.c && this.b == a.b;
        };
        AxisRange.prototype.equals1 = function (a) {
            return this.equals(i2.typeCast(AxisRange.$, a));
        };
        AxisRange.prototype.getHashCode = function () {
            return _super.prototype.getHashCode.call(this);
        };
        AxisRange.$t = i2.markType(AxisRange, 'AxisRange', i2.Base.$, [i2.IEquatable$1_$type.specialize(-1)]).initSelfReferences();
        return AxisRange;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Snapper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Snapper, _super);
        function Snapper() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 7;
            _this.a = false;
            return _this;
        }
        Object.defineProperty(Snapper.prototype, "f", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Snapper.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
            },
            enumerable: false,
            configurable: true
        });
        Snapper.d = function (a, b) {
            var c = 1;
            if (b > 0) {
                for (; b > 0; --b) {
                    c *= a;
                }
            }
            else {
                for (; b < 0; ++b) {
                    c /= a;
                }
            }
            return c;
        };
        Snapper.e = function (a, b) {
            var c = i2.truncate(Math.floor(i2.log10(a)));
            var d = a / Math.pow(10, c);
            if (b) {
                var e = d < 1.5 ? 1 : d < 3 ? 2 : d < 7 ? 5 : 10;
                return e * Math.pow(10, c);
            }
            else {
                var f = d <= 1 ? 1 : d <= 2 ? 2 : d <= 5 ? 5 : 10;
                return f * Math.pow(10, c);
            }
        };
        Snapper.$t = i2.markType(Snapper, 'Snapper');
        return Snapper;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LinearNumericSnapper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LinearNumericSnapper, _super);
        function LinearNumericSnapper(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.g = 0;
            _this.j = 0;
            _this.i = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        if (f > 0) {
                            _this.f = f;
                            _this.b = true;
                        }
                        _this.k(c, d, e, 10);
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        if (g > 0) {
                            _this.f = g;
                            _this.b = true;
                        }
                        _this.k(c, d, e, f);
                    }
                    break;
            }
            return _this;
        }
        LinearNumericSnapper.prototype.k = function (a, b, c, d) {
            this.g = NaN;
            this.j = 0;
            this.i = 0;
            var e = 0;
            if (c < 100) {
                e = 4;
            }
            else {
                e = Math.min(d, i2.truncate((c / this.f)));
            }
            if (e > 0) {
                var f = this.h(a, b, e);
                if (this.b && f > e) {
                    this.g = NaN;
                    f = this.h(a, b, e - 1);
                }
                e = f;
                if (c / e > this.f * 10) {
                    this.i = 10;
                }
                else {
                    if (c / e > this.f * 5) {
                        this.i = 5;
                    }
                    else {
                        if (c / e > this.f * 2) {
                            this.i = 2;
                        }
                    }
                }
                this.j = Math.max(-i2.truncate(Math.floor(i2.log10(this.g))), 0);
            }
        };
        LinearNumericSnapper.prototype.h = function (a, b, c) {
            var d = Snapper.e(b - a, false);
            var e = Math.max(1, c - 1);
            this.g = Snapper.e(d / e, true);
            var f = Math.floor(a / this.g) * this.g;
            var g = Math.ceil(b / this.g) * this.g;
            var h = i2.truncate(Math.round((g - f) / this.g));
            return h;
        };
        LinearNumericSnapper.$t = i2.markType(LinearNumericSnapper, 'LinearNumericSnapper', Snapper.$);
        return LinearNumericSnapper;
    }(Snapper));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IAxisAnnotation_$type = new i2.Type(null, 'IAxisAnnotation');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisAnnotationCollection, _super);
        function AxisAnnotationCollection() {
            var _this = _super.call(this, IAxisAnnotation_$type, 0) || this;
            _this.collectionResetting = null;
            return _this;
        }
        AxisAnnotationCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        AxisAnnotationCollection.$t = i2.markType(AxisAnnotationCollection, 'AxisAnnotationCollection', i2.ObservableCollection$1.$.specialize(IAxisAnnotation_$type));
        return AxisAnnotationCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LabelPosition = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LabelPosition, _super);
        function LabelPosition(a) {
            var _this = _super.call(this) || this;
            _this.c = 0;
            _this.a = false;
            _this.d = null;
            _this.b = false;
            _this.c = a;
            return _this;
        }
        LabelPosition.$t = i2.markType(LabelPosition, 'LabelPosition');
        return LabelPosition;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LabelFontHeuristics = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LabelFontHeuristics, _super);
        function LabelFontHeuristics() {
            var _this = _super.call(this) || this;
            _this.b = 0;
            _this.e = 0;
            _this.c = 0;
            _this.d = 0;
            _this.a = false;
            _this.b = NaN;
            _this.e = NaN;
            _this.c = NaN;
            _this.d = NaN;
            return _this;
        }
        LabelFontHeuristics.$t = i2.markType(LabelFontHeuristics, 'LabelFontHeuristics');
        return LabelFontHeuristics;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisComponentsFromView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisComponentsFromView, _super);
        function AxisComponentsFromView() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.d = null;
            _this.c = null;
            return _this;
        }
        AxisComponentsFromView.$t = i2.markType(AxisComponentsFromView, 'AxisComponentsFromView');
        return AxisComponentsFromView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisRangeChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisRangeChangedEventArgs, _super);
        function AxisRangeChangedEventArgs(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        _this = _super.call(this) || this;
                        _this._oldMinimumValue = 0;
                        _this._minimumValue = 0;
                        _this._oldMaximumValue = 0;
                        _this._maximumValue = 0;
                        _this.oldMinimumValue = c;
                        _this.minimumValue = d;
                        _this.oldMaximumValue = e;
                        _this.maximumValue = f;
                    }
                    break;
                case 1:
                    {
                        _this = _super.call(this) || this;
                        _this._oldMinimumValue = 0;
                        _this._minimumValue = 0;
                        _this._oldMaximumValue = 0;
                        _this._maximumValue = 0;
                    }
                    break;
            }
            return _this;
        }
        Object.defineProperty(AxisRangeChangedEventArgs.prototype, "oldMinimumValue", {
            get: function () {
                return this._oldMinimumValue;
            },
            set: function (a) {
                this._oldMinimumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisRangeChangedEventArgs.prototype, "minimumValue", {
            get: function () {
                return this._minimumValue;
            },
            set: function (a) {
                this._minimumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisRangeChangedEventArgs.prototype, "oldMaximumValue", {
            get: function () {
                return this._oldMaximumValue;
            },
            set: function (a) {
                this._oldMaximumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisRangeChangedEventArgs.prototype, "maximumValue", {
            get: function () {
                return this._maximumValue;
            },
            set: function (a) {
                this._maximumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        AxisRangeChangedEventArgs.$t = i2.markType(AxisRangeChangedEventArgs, 'AxisRangeChangedEventArgs', i2.EventArgs.$);
        return AxisRangeChangedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PathRenderingInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PathRenderingInfo, _super);
        function PathRenderingInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.e = null;
            _this.d = null;
            _this.f = null;
            _this.a = false;
            return _this;
        }
        Object.defineProperty(PathRenderingInfo.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                if (a < 0) {
                    this.b = a * -1;
                }
                else {
                    this.b = a;
                }
            },
            enumerable: false,
            configurable: true
        });
        PathRenderingInfo.$t = i2.markType(PathRenderingInfo, 'PathRenderingInfo');
        return PathRenderingInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RenderRequestedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RenderRequestedEventArgs, _super);
        function RenderRequestedEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._animate = false;
            return _this;
        }
        Object.defineProperty(RenderRequestedEventArgs.prototype, "animate", {
            get: function () {
                return this._animate;
            },
            set: function (a) {
                this._animate = a;
            },
            enumerable: false,
            configurable: true
        });
        RenderRequestedEventArgs.$t = i2.markType(RenderRequestedEventArgs, 'RenderRequestedEventArgs', i2.EventArgs.$);
        return RenderRequestedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryMode_$type = i2.markEnum('CategoryMode', 'Mode0,0|Mode1,1|Mode2,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available modes of displaying elements in the chart grid, such as gridlines.
     */
    var GridMode = /*@__PURE__*/ (function (GridMode) {
        /**
         * No chart grid.
         */
        GridMode[GridMode["None"] = 0] = "None";
        /**
         * Chart grid should be rendered before or in front of the data series.
         */
        GridMode[GridMode["BeforeSeries"] = 1] = "BeforeSeries";
        /**
         * Chart grid should be rendered behind or in back of the data series.
         */
        GridMode[GridMode["BehindSeries"] = 2] = "BehindSeries";
        return GridMode;
    })({});
    /**
     * @hidden
     */
    var GridMode_$type = i2.markEnum('GridMode', 'None,0|BeforeSeries,1|BehindSeries,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TickmarkValues, _super);
        function TickmarkValues() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.o = 0;
            _this.m = 0;
            _this.n = 0;
            _this.l = 0;
            _this.p = 0;
            _this.q = 0;
            _this.r = 0;
            return _this;
        }
        TickmarkValues.prototype.s = function (a) {
            this.o = a.m;
        };
        TickmarkValues.$t = i2.markType(TickmarkValues, 'TickmarkValues', i2.DependencyObject.$);
        return TickmarkValues;
    }(i2.DependencyObject));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IScaler_$type = new i2.Type(null, 'IScaler');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ICategoryScaler_$type = new i2.Type(null, 'ICategoryScaler', null, [IScaler_$type]);

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RangeInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeInfo, _super);
        function RangeInfo() {
            var _this = _super.call(this) || this;
            _this.d = 0;
            _this.c = 0;
            _this.a = 0;
            _this.b = 0;
            _this.e = 0;
            _this.a = -1;
            _this.e = -1;
            return _this;
        }
        RangeInfo.$t = i2.markType(RangeInfo, 'RangeInfo');
        return RangeInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisRenderingParametersBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisRenderingParametersBase, _super);
        function AxisRenderingParametersBase() {
            var _this = _super.call(this) || this;
            _this.o = 0;
            _this.z = null;
            _this.aa = null;
            _this.y = null;
            _this.x = null;
            _this.k = null;
            _this.e = null;
            _this.f = null;
            _this.w = null;
            _this.u = null;
            _this.v = null;
            _this.t = null;
            _this.m = 0;
            _this.l = 0;
            _this.n = 0;
            _this.r = 0;
            _this.s = null;
            _this.p = 0;
            _this.g = false;
            _this.h = false;
            _this.j = false;
            _this.b = null;
            _this.a = null;
            _this.c = null;
            _this.d = null;
            _this.q = 0;
            _this.k = new i2.List$1(RangeInfo.$, 0);
            return _this;
        }
        AxisRenderingParametersBase.prototype.i = function () {
            return false;
        };
        AxisRenderingParametersBase.$t = i2.markType(AxisRenderingParametersBase, 'AxisRenderingParametersBase');
        return AxisRenderingParametersBase;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumericAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericAxisRenderingParameters, _super);
        function NumericAxisRenderingParameters() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.ab = false;
            return _this;
        }
        NumericAxisRenderingParameters.prototype.i = function () {
            return true;
        };
        NumericAxisRenderingParameters.$t = i2.markType(NumericAxisRenderingParameters, 'NumericAxisRenderingParameters', AxisRenderingParametersBase.$);
        return NumericAxisRenderingParameters;
    }(AxisRenderingParametersBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LogarithmicNumericSnapper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LogarithmicNumericSnapper, _super);
        function LogarithmicNumericSnapper(a, b, c, d) {
            var _this = _super.call(this) || this;
            _this.g = 0;
            _this.h = 0;
            _this.g = 1;
            _this.h = c;
            return _this;
        }
        LogarithmicNumericSnapper.$t = i2.markType(LogarithmicNumericSnapper, 'LogarithmicNumericSnapper', Snapper.$);
        return LogarithmicNumericSnapper;
    }(Snapper));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LogarithmicTickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LogarithmicTickmarkValues, _super);
        function LogarithmicTickmarkValues() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.t = null;
            _this.u = null;
            return _this;
        }
        LogarithmicTickmarkValues.prototype.s = function (a) {
            _super.prototype.s.call(this, a);
            var b = new LogarithmicNumericSnapper(a.n, a.m, this.x, a.k);
            this.m = 1;
            this.r = i2.truncate(b.h);
            this.p = i2.truncate(Math.floor(i2.logBase(Math.max(4.94065645841247E-324, a.n), this.x)));
            this.q = i2.truncate(Math.ceil(i2.logBase(Math.max(4.94065645841247E-324, a.m), this.x)));
        };
        Object.defineProperty(LogarithmicTickmarkValues.prototype, "x", {
            get: function () {
                return i2.typeGetValue(this.c(LogarithmicTickmarkValues.z));
            },
            set: function (a) {
                this.h(LogarithmicTickmarkValues.z, a);
            },
            enumerable: false,
            configurable: true
        });
        LogarithmicTickmarkValues.prototype.v = function (a) {
            var b = a * this.m;
            return Math.pow(this.x, b);
        };
        LogarithmicTickmarkValues.prototype.j = function () {
            var a = this.p;
            var b = this.q;
            var c = this.o;
            var d = 0;
            for (var e = a; e <= b; ++e) {
                var f = this.v(e);
                if (f <= c) {
                    d++;
                }
            }
            if (this.t == null || this.t.length != d) {
                this.t = new Array(d);
            }
            var g = this.t;
            var h = 0;
            for (var i = a; i <= b; ++i) {
                var j = this.v(i);
                if (j <= c) {
                    g[h] = j;
                    h++;
                }
            }
            return g;
        };
        LogarithmicTickmarkValues.prototype.k = function () {
            var a = this.p;
            var b = this.q;
            var c = this.x;
            var d = this.r;
            var e = this.o;
            var f = 0;
            for (var g = a; g <= b; ++g) {
                var h = this.v(g);
                var i = Math.pow(c, g);
                for (var j = 1; j < this.r - 1; ++j) {
                    var k = h + j * i;
                    if (k <= e) {
                        f++;
                    }
                }
            }
            if (this.u == null || this.u.length != f) {
                this.u = new Array(f);
            }
            var l = this.u;
            var m = 0;
            for (var n = a; n <= b; ++n) {
                var o = this.v(n);
                var p = Math.pow(c, n);
                for (var q = 1; q < this.r - 1; ++q) {
                    var r = o + q * p;
                    if (r <= e) {
                        l[m] = r;
                        m++;
                    }
                }
            }
            return l;
        };
        LogarithmicTickmarkValues.$t = i2.markType(LogarithmicTickmarkValues, 'LogarithmicTickmarkValues', TickmarkValues.$);
        LogarithmicTickmarkValues.z = i2.DependencyProperty.i("LogarithmBase", i2.Number_$type, LogarithmicTickmarkValues.$, new i2.PropertyMetadata(2, 10, function (a, b) {
        }));
        return LogarithmicTickmarkValues;
    }(TickmarkValues));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LinearTickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LinearTickmarkValues, _super);
        function LinearTickmarkValues() {
            var _this = _super.call(this) || this;
            _this.y = 0;
            _this.x = 0;
            _this.t = null;
            _this.u = null;
            _this.y = 0;
            return _this;
        }
        LinearTickmarkValues.prototype.s = function (a) {
            _super.prototype.s.call(this, a);
            var b;
            if (this.y != 0) {
                b = new LinearNumericSnapper(1, a.n, a.m, a.k, this.y, a.h);
            }
            else {
                b = new LinearNumericSnapper(0, a.n, a.m, a.k, a.h);
            }
            this.m = b.g;
            if ((a.d) && a.l > 0 && (a.m - a.n) / a.l < 1000) {
                this.m = a.l;
            }
            if (a.i != -1) {
                this.m = a.i;
            }
            if (this.m == 0) {
                this.p = 0;
                this.q = 0;
            }
            else {
                this.p = i2.truncate(Math.floor((a.n - a.g) / this.m));
                this.q = i2.truncate(Math.ceil((a.m - a.g) / this.m));
            }
            this.r = b.i;
            if (a.p != -1) {
                this.r = a.p;
            }
            this.n = a.j;
            this.x = a.g;
        };
        LinearTickmarkValues.prototype.j = function () {
            var a = 0;
            var b = this.p;
            if (!i2.isNaN_(this.m)) {
                a = this.q - b + 1;
                if (a < 0) {
                    a = 0;
                }
            }
            if (this.t == null || this.t.length != a) {
                this.t = new Array(a);
            }
            var c = this.t;
            for (var d = 0; d < a; ++d) {
                var e = this.x + (d + b) * this.m;
                c[d] = e;
            }
            return c;
        };
        LinearTickmarkValues.prototype.k = function () {
            if (this.n > 0) {
                return this.w();
            }
            return this.v();
        };
        LinearTickmarkValues.prototype.v = function () {
            var a = this.p;
            var b = this.q;
            var c = this.r;
            var d = this.m;
            var e = this.x;
            var f = this.o;
            var g = d / c;
            var h = 0;
            for (var i = a; i < b; ++i) {
                if (c > 0) {
                    for (var j = 1; j < c; ++j) {
                        var k = e + i * d + (j * g);
                        if (k <= f) {
                            h++;
                        }
                    }
                }
            }
            if (this.u == null || this.u.length != h) {
                this.u = new Array(h);
            }
            var l = this.u;
            var m = 0;
            for (var n = a; n < b; ++n) {
                if (c > 0) {
                    for (var o = 1; o < c; ++o) {
                        var p = e + n * d + (o * g);
                        if (p <= this.o) {
                            l[m] = p;
                            m++;
                        }
                    }
                }
            }
            return l;
        };
        LinearTickmarkValues.prototype.w = function () {
            var a = this.p;
            var b = this.q;
            var c = this.r;
            var d = this.m;
            var e = this.x;
            var f = this.o;
            var g = d / c;
            var h = 0;
            for (var i = a; i < b; ++i) {
                var j = e + i * this.m;
                var k = this.o;
                if (i + 1 <= this.q) {
                    k = this.x + ((i + 1) * this.m);
                }
                if (k > this.o) {
                    k = this.o;
                }
                while (j < k) {
                    j += this.n;
                    if (j < k) {
                        h++;
                    }
                }
            }
            if (this.u == null || this.u.length != h) {
                this.u = new Array(h);
            }
            var l = this.u;
            var m = 0;
            for (var n = a; n < b; ++n) {
                var o = e + n * this.m;
                var p = this.o;
                if (n + 1 <= this.q) {
                    p = this.x + ((n + 1) * this.m);
                }
                if (p > this.o) {
                    p = this.o;
                }
                while (o < p) {
                    o += this.n;
                    if (o < p) {
                        l[m] = o;
                        m++;
                    }
                }
            }
            return l;
        };
        LinearTickmarkValues.$t = i2.markType(LinearTickmarkValues, 'LinearTickmarkValues', TickmarkValues.$);
        return LinearTickmarkValues;
    }(TickmarkValues));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TickmarkValuesInitializationParameters = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TickmarkValuesInitializationParameters, _super);
        function TickmarkValuesInitializationParameters() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.n = 0;
            _this.m = 0;
            _this.g = 0;
            _this.f = 0;
            _this.k = 0;
            _this.d = false;
            _this.l = 0;
            _this.i = 0;
            _this.p = 0;
            _this.a = 0;
            _this.q = 0;
            _this.r = null;
            _this.s = null;
            _this.e = false;
            _this.o = null;
            _this.b = null;
            _this.c = null;
            _this.j = 0;
            _this.h = 0;
            return _this;
        }
        TickmarkValuesInitializationParameters.$t = i2.markType(TickmarkValuesInitializationParameters, 'TickmarkValuesInitializationParameters');
        return TickmarkValuesInitializationParameters;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryAxisRenderingParameters, _super);
        function CategoryAxisRenderingParameters() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.ae = 0;
            _this.ab = 0;
            _this.ad = false;
            _this.af = 0;
            _this.ac = false;
            return _this;
        }
        CategoryAxisRenderingParameters.$t = i2.markType(CategoryAxisRenderingParameters, 'CategoryAxisRenderingParameters', AxisRenderingParametersBase.$);
        return CategoryAxisRenderingParameters;
    }(AxisRenderingParametersBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumberAbbreviatorFactory = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumberAbbreviatorFactory, _super);
        function NumberAbbreviatorFactory() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NumberAbbreviatorFactory.a = function (a) {
            if (!i2.TypeRegistrar.isRegistered("NumberAbbreviator")) {
                return null;
            }
            var b = i2.TypeRegistrar.create("NumberAbbreviator");
            return b;
        };
        NumberAbbreviatorFactory.$t = i2.markType(NumberAbbreviatorFactory, 'NumberAbbreviatorFactory');
        return NumberAbbreviatorFactory;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available highlighting states
     */
    var HighlightingState = /*@__PURE__*/ (function (HighlightingState) {
        /**
         * Highlight is transitioning out.
         */
        HighlightingState[HighlightingState["outward"] = 0] = "outward";
        /**
         * Highlight is transitioning in.
         */
        HighlightingState[HighlightingState["inward"] = 1] = "inward";
        /**
         * Highlight is active and not transitioning in or out.
         */
        HighlightingState[HighlightingState["Static"] = 2] = "Static";
        return HighlightingState;
    })({});
    /**
     * @hidden
     */
    var HighlightingState_$type = i2.markEnum('HighlightingState', 'Out:outward,0|In:inward,1|Static,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Marker = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Marker, _super);
        function Marker() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.am = null;
            _this.an = null;
            _this.ak = 0;
            _this.al = 0;
            _this.ai = 0;
            _this.aj = 0;
            return _this;
        }
        Marker.$t = i2.markType(Marker, 'Marker', i2.ContentControl.$);
        return Marker;
    }(i2.ContentControl));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var ComputedPlotAreaMarginMode = /*@__PURE__*/ (function (ComputedPlotAreaMarginMode) {
        /**
         * Computed plot area margin mode is determined by the component.
         */
        ComputedPlotAreaMarginMode[ComputedPlotAreaMarginMode["Auto"] = 0] = "Auto";
        /**
         * The series in the chart are queried for their requested margins to incorporate into the plot area margin.
         */
        ComputedPlotAreaMarginMode[ComputedPlotAreaMarginMode["Series"] = 1] = "Series";
        /**
         * There is no automatic determination of the plot area margin.
         */
        ComputedPlotAreaMarginMode[ComputedPlotAreaMarginMode["None"] = 2] = "None";
        return ComputedPlotAreaMarginMode;
    })({});
    /**
     * @hidden
     */
    var ComputedPlotAreaMarginMode_$type = i2.markEnum('ComputedPlotAreaMarginMode', 'Auto,0|Series,1|None,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var SeriesVisibleRangeMode = /*@__PURE__*/ (function (SeriesVisibleRangeMode) {
        /**
         * Visible range mode is managed by the component.
         */
        SeriesVisibleRangeMode[SeriesVisibleRangeMode["Auto"] = 0] = "Auto";
        /**
         * Only the series values are considered for evaluating the visible range.
         */
        SeriesVisibleRangeMode[SeriesVisibleRangeMode["ValuesOnly"] = 1] = "ValuesOnly";
        /**
         * The reference value is included in the series visible range.
         */
        SeriesVisibleRangeMode[SeriesVisibleRangeMode["IncludeReferenceValue"] = 2] = "IncludeReferenceValue";
        return SeriesVisibleRangeMode;
    })({});
    /**
     * @hidden
     */
    var SeriesVisibleRangeMode_$type = i2.markEnum('SeriesVisibleRangeMode', 'Auto,0|ValuesOnly,1|IncludeReferenceValue,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var SeriesOutlineMode = /*@__PURE__*/ (function (SeriesOutlineMode) {
        /**
         * Outline mode is managed by the series.
         */
        SeriesOutlineMode[SeriesOutlineMode["Auto"] = 0] = "Auto";
        /**
         * This series should show the outline portion of the visual.
         */
        SeriesOutlineMode[SeriesOutlineMode["Visible"] = 1] = "Visible";
        /**
         * The series should hide the outline portion of the visual.
         */
        SeriesOutlineMode[SeriesOutlineMode["Collapsed"] = 2] = "Collapsed";
        return SeriesOutlineMode;
    })({});
    /**
     * @hidden
     */
    var SeriesOutlineMode_$type = i2.markEnum('SeriesOutlineMode', 'Auto,0|Visible,1|Collapsed,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of speeds used when transitioning in a series.
     */
    var TransitionInSpeedType = /*@__PURE__*/ (function (TransitionInSpeedType) {
        /**
         * A speed type is automatically selected.
         */
        TransitionInSpeedType[TransitionInSpeedType["Auto"] = 0] = "Auto";
        /**
         * All speeds are normal, data points will arrive at the same time.
         */
        TransitionInSpeedType[TransitionInSpeedType["Normal"] = 1] = "Normal";
        /**
         * Data points will arrive later if their value is further from the start point.
         */
        TransitionInSpeedType[TransitionInSpeedType["ValueScaled"] = 2] = "ValueScaled";
        /**
         * Data points will arrive later if their index is further from the axis origin.
         */
        TransitionInSpeedType[TransitionInSpeedType["IndexScaled"] = 3] = "IndexScaled";
        /**
         * Data points will arrive at random times.
         */
        TransitionInSpeedType[TransitionInSpeedType["Random"] = 4] = "Random";
        return TransitionInSpeedType;
    })({});
    /**
     * @hidden
     */
    var TransitionInSpeedType_$type = i2.markEnum('TransitionInSpeedType', 'Auto,0|Normal,1|ValueScaled,2|IndexScaled,3|Random,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors for performing hit testing in the chart/map.
     */
    var SeriesHitTestMode = /*@__PURE__*/ (function (SeriesHitTestMode) {
        /**
         * Automatically decide the appropriate hit test mode for the series.
         */
        SeriesHitTestMode[SeriesHitTestMode["Auto"] = 0] = "Auto";
        /**
         * Use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded.
         */
        SeriesHitTestMode[SeriesHitTestMode["Computational"] = 1] = "Computational";
        /**
         * Use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
         */
        SeriesHitTestMode[SeriesHitTestMode["ColorEncoded"] = 2] = "ColorEncoded";
        return SeriesHitTestMode;
    })({});
    /**
     * @hidden
     */
    var SeriesHitTestMode_$type = i2.markEnum('SeriesHitTestMode', 'Auto,0|Computational,1|ColorEncoded,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesComponentsForView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesComponentsForView, _super);
        function SeriesComponentsForView() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SeriesComponentsForView.$t = i2.markType(SeriesComponentsForView, 'SeriesComponentsForView');
        return SeriesComponentsForView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var MarkerOutlineMode = /*@__PURE__*/ (function (MarkerOutlineMode) {
        /**
         * Outline mode is managed by the series.
         */
        MarkerOutlineMode[MarkerOutlineMode["Auto"] = 0] = "Auto";
        /**
         * This series base its marker brush on the marker outlines collection.
         */
        MarkerOutlineMode[MarkerOutlineMode["Normal"] = 1] = "Normal";
        /**
         * The series should match the marker outline to the marker brush.
         */
        MarkerOutlineMode[MarkerOutlineMode["MatchMarkerBrush"] = 2] = "MatchMarkerBrush";
        return MarkerOutlineMode;
    })({});
    /**
     * @hidden
     */
    var MarkerOutlineMode_$type = i2.markEnum('MarkerOutlineMode', 'Auto,0|Normal,1|MatchMarkerBrush,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the axis labels in the chart.
     */
    var MarkerFillMode = /*@__PURE__*/ (function (MarkerFillMode) {
        /**
         * Outline mode is managed by the series.
         */
        MarkerFillMode[MarkerFillMode["Auto"] = 0] = "Auto";
        /**
         * This series base its marker brush on the marker outlines collection.
         */
        MarkerFillMode[MarkerFillMode["Normal"] = 1] = "Normal";
        /**
         * The series should match the marker fill to the marker outline.
         */
        MarkerFillMode[MarkerFillMode["MatchMarkerOutline"] = 2] = "MatchMarkerOutline";
        return MarkerFillMode;
    })({});
    /**
     * @hidden
     */
    var MarkerFillMode_$type = i2.markEnum('MarkerFillMode', 'Auto,0|Normal,1|MatchMarkerOutline,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesComponentsFromView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesComponentsFromView, _super);
        function SeriesComponentsFromView() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SeriesComponentsFromView.$t = i2.markType(SeriesComponentsFromView, 'SeriesComponentsFromView');
        return SeriesComponentsFromView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of marker than can be displayed by default by series with markers.
     */
    var MarkerType = /*@__PURE__*/ (function (MarkerType) {
        /**
         * Marker hasn't been set.
         */
        MarkerType[MarkerType["Unset"] = 0] = "Unset";
        /**
         * No marker shapes.
         */
        MarkerType[MarkerType["None"] = 1] = "None";
        /**
         * Automatic marker shape.
         */
        MarkerType[MarkerType["Automatic"] = 2] = "Automatic";
        /**
         * Circle marker shape.
         */
        MarkerType[MarkerType["Circle"] = 3] = "Circle";
        /**
         * Flat-top triangle marker shape.
         */
        MarkerType[MarkerType["Triangle"] = 4] = "Triangle";
        /**
         * Flat-base triangle marker shape.
         */
        MarkerType[MarkerType["Pyramid"] = 5] = "Pyramid";
        /**
         * Square marker shape.
         */
        MarkerType[MarkerType["Square"] = 6] = "Square";
        /**
         * Diamond marker shape.
         */
        MarkerType[MarkerType["Diamond"] = 7] = "Diamond";
        /**
         * Pentagon marker shape.
         */
        MarkerType[MarkerType["Pentagon"] = 8] = "Pentagon";
        /**
         * Hexagon marker shape.
         */
        MarkerType[MarkerType["Hexagon"] = 9] = "Hexagon";
        /**
         * Four-pointed star marker shape.
         */
        MarkerType[MarkerType["Tetragram"] = 10] = "Tetragram";
        /**
         * Five-pointed star marker shape.
         */
        MarkerType[MarkerType["Pentagram"] = 11] = "Pentagram";
        /**
         * Six-pointed star marker shape.
         */
        MarkerType[MarkerType["Hexagram"] = 12] = "Hexagram";
        /**
         * Renders transparent circular markers.
         */
        MarkerType[MarkerType["Hidden"] = 13] = "Hidden";
        return MarkerType;
    })({});
    /**
     * @hidden
     */
    var MarkerType_$type = i2.markEnum('MarkerType', 'Unset,0|None,1|Automatic,2|Circle,3|Triangle,4|Pyramid,5|Square,6|Diamond,7|Pentagon,8|Hexagon,9|Tetragram,10|Pentagram,11|Hexagram,12|Hidden,13');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesViewer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewer, _super);
        function SeriesViewer() {
            var _this = _super.call(this) || this;
            _this._widget = null;
            _this.cf = null;
            _this.cq = null;
            _this.a4 = null;
            _this.b7 = null;
            _this.bk = new SeriesCollection();
            _this._skipDataCleanup = false;
            _this.cg = null;
            _this.ap = null;
            _this.o7 = null;
            _this.plotAreaMouseLeftButtonDown = null;
            _this.plotAreaMouseLeftButtonUp = null;
            _this.plotAreaClicked = null;
            _this.plotAreaMouseEnter = null;
            _this.plotAreaMouseLeave = null;
            _this.plotAreaMouseOver = null;
            _this.bm = 1;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.c0 = false;
            _this.seriesCursorMouseMove = null;
            _this.seriesMouseLeftButtonDown = null;
            _this.seriesMouseLeftButtonUp = null;
            _this.seriesMouseMove = null;
            _this.seriesMouseEnter = null;
            _this.seriesMouseLeave = null;
            _this.cv = false;
            _this.pf = i2.Rect.empty;
            _this.pd = i2.Rect.empty;
            _this.ct = true;
            _this.pc = null;
            _this.c8 = false;
            _this.f7 = 30;
            _this.d9 = false;
            _this.br = new SeriesViewerComponentsForView();
            _this.cy = false;
            _this.ar = 0;
            _this.aq = 1;
            _this.seriesAnimating = null;
            _this.cw = false;
            _this.b2 = 0;
            _this.c2 = false;
            _this.de = false;
            _this.cu = false;
            _this.iq = null;
            _this.viewerManipulationStarting = null;
            _this.viewerManipulationEnding = null;
            _this.c6 = false;
            _this.c3 = false;
            _this.windowRectChanged = null;
            _this.sizeChanged = null;
            _this.dl = false;
            _this.actualWindowRectChanged = null;
            _this.gridAreaRectChanged = null;
            _this.dg = false;
            _this._syncChannel = null;
            _this.bt = null;
            _this.en = false;
            _this.c5 = false;
            _this.dk = false;
            _this.eq = false;
            _this.bx = 1;
            _this.px = null;
            _this.f9 = 0;
            _this.bj = null;
            _this.c4 = false;
            _this.eo = false;
            _this.pe = i2.Rect.empty;
            _this.ev = new Date();
            _this.es = false;
            _this.refreshCompleted = null;
            _this.gk = null;
            _this.gj = null;
            _this.oq = null;
            _this.op = null;
            _this.fe = NaN;
            _this.fc = NaN;
            _this.fd = NaN;
            _this.fb = NaN;
            _this.fa = NaN;
            _this.e8 = NaN;
            _this.e9 = NaN;
            _this.e7 = NaN;
            _this.gh = null;
            _this.al = null;
            _this.am = null;
            _this.ak = null;
            _this.c1 = false;
            _this.cs = false;
            _this._syncSettings = null;
            _this.destroyed = false;
            _this.gf = null;
            _this.et = new i2.Dictionary$2(i2.String_$type, i2.Base.$, 0);
            _this.d7 = false;
            _this.ff = NaN;
            _this.e4 = NaN;
            _this.e6 = NaN;
            _this.e2 = NaN;
            _this.e1 = 20;
            _this.e0 = NaN;
            _this.cx = true;
            _this.e5 = NaN;
            _this.e3 = NaN;
            _this.gi = null;
            _this.ex = 1;
            _this.ew = NaN;
            _this.pb = null;
            _this.dj = false;
            _this.ey = 0;
            _this.ez = 0;
            _this.m4 = null;
            _this.av = null;
            _this.dp = false;
            _this.dq = false;
            _this.dm = false;
            _this.cz = false;
            _this.f8 = 0;
            _this.dc = false;
            _this.dt = false;
            _this.seriesDataUpdated = null;
            i2.DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
            i2.DVContainer.instance.registerIfLoaded("InteractivityFactoryManager");
            i2.DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
            _this.pb = i2.Rect.empty;
            _this.o7 = { $type: i2.Point_$type, x: NaN, y: NaN };
            _this.ev = i2.dateNow();
            _this.dp = false;
            _this.dq = false;
            _this.al = new i2.CanvasRenderScheduler();
            _this.am = new i2.CanvasRenderScheduler();
            _this.ak = new i2.CanvasRenderScheduler();
            SeriesViewer.ps = new i2.Rect(0, 0, 0, 1, 1);
            _this.syncSettings = ((function () {
                var $ret = new SyncSettings();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = true;
                return $ret;
            })());
            _this.cf = _this.ce();
            _this.k5(_this.cf);
            _this.cf.c1();
            _this.mh();
            _this.jm();
            _this.actualSyncLink = new SyncLink();
            _this.mp(null, _this.actualSyncLink);
            _this.ap = new ChartContentManager(_this);
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.lh(a, b.propertyName, b.oldValue, b.newValue); });
            var a = _this.series;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.l6));
            var b = _this.series;
            b.collectionResetting = i2.delegateCombine(b.collectionResetting, i2.runOn(_this, _this.l7));
            _this.cg = new i2.DoubleAnimator(0, 1, _this.gd);
            var c = _this.cg;
            c.propertyChanged = i2.delegateCombine(c.propertyChanged, i2.runOn(_this, _this.jl));
            _this.cf.bx();
            _this.jo();
            _this.jn();
            return _this;
        }
        Object.defineProperty(SeriesViewer.prototype, "widget", {
            get: function () {
                return this._widget;
            },
            set: function (a) {
                this._widget = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.staticInit = function () {
            SeriesViewer.ps = new i2.Rect(0, 0, 0, 1, 1);
        };
        Object.defineProperty(SeriesViewer.prototype, "cr", {
            get: function () {
                if (this.cq == null) {
                    this.cq = new i2.SRProvider(this.cf.j.ae);
                }
                return this.cq;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "a5", {
            get: function () {
                var _this = this;
                if (this.a4 == null) {
                    this.a4 = i2.DVContainer.instance.createInstance(ISeriesViewerInteractionManager_$type, function () { return _this.cr.n; });
                }
                return this.a4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "dv", {
            get: function () {
                return i2.DVContainer.instance.checkLoaded("InteractivityFactoryManager");
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.jm = function () {
            if (this.b7 != null && this.b8 == null) {
                var a = this.b8;
                a.thumbnailSizeChanged = i2.delegateRemove(a.thumbnailSizeChanged, i2.runOn(this, this.ld));
            }
            if (this.b8 != null) {
                var b = this.b8;
                b.thumbnailSizeChanged = i2.delegateCombine(b.thumbnailSizeChanged, i2.runOn(this, this.ld));
            }
            if (this.gi != null) {
                this.b8.backgroundImageUri = this.gi;
            }
            if (this.b8 != null) {
                this.b8.initializeScalingRatio(this.fh);
            }
            if (this.b7 == null && this.b8 != null) {
                this.j0();
            }
            this.b7 = this.b8;
        };
        SeriesViewer.prototype.ld = function (a, b) {
            var e_1, _a;
            this.b8.surfaceIsDirty = true;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.et = true;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        SeriesViewer.prototype.jn = function () {
            this.cf.cl();
            if (this.b8 != null) {
                this.b8.initializeScalingRatio(this.fh);
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "series", {
            get: function () {
                return this.bk;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.l6 = function (a, b) {
            var e_2, _a, e_3, _b;
            this.dc = this.di();
            if (b.oldItems != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        c.b5 = null;
                        c.ca = null;
                        this.l0(c);
                        this.cf.dv(c);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
            if (b.newItems != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var d = _f.value;
                        if (!this.cf.aq(d)) {
                            this.mi(d);
                            this.cf.bp(d);
                            d.ca = this;
                            d.b5 = this.actualSyncLink;
                            d.ml();
                        }
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            this.jz();
            this.j5();
            this.kj();
        };
        SeriesViewer.prototype.jp = function () {
            this.j5();
        };
        SeriesViewer.prototype.j5 = function () {
        };
        Object.defineProperty(SeriesViewer.prototype, "skipDataCleanup", {
            get: function () {
                return this._skipDataCleanup;
            },
            set: function (a) {
                this._skipDataCleanup = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.l0 = function (a) {
            if (!this.skipDataCleanup) {
                if (i2.typeCast(Series.$, a) !== null) {
                    a.itemsSource = null;
                }
                else if (i2.typeCast(CategoryAxisBase.$, a) !== null) {
                    a.itemsSource = null;
                }
            }
            this.l2(a.name, true);
        };
        SeriesViewer.prototype.l7 = function (a, b) {
            var e_4, _a;
            this.dc = this.di();
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.b5 = null;
                    c.ca = null;
                    this.l0(c);
                    this.cf.dv(c);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        };
        SeriesViewer.prototype.js = function (a, b, c, d) {
            var e = this.pv;
            var f = e.width;
            var g = e.height;
            var h = f / g;
            var i = a / b;
            if (i2.isNaN_(h)) {
                return {
                    p0: a,
                    p1: b
                };
            }
            if (i2.isNaN_(i) || c || d || Math.abs(h - i) > 0.0001) {
                if (c && d) {
                    if (a > b) {
                        b = a / h;
                    }
                    else {
                        a = b * h;
                    }
                }
                else if (c) {
                    b = a / h;
                }
                else {
                    a = b * h;
                }
            }
            if (b > 1) {
                var j = 1 / b;
                b = 1;
                a = a * j;
            }
            if (a > 1) {
                var k = 1 / a;
                a = 1;
                b = b * k;
            }
            return {
                p0: a,
                p1: b
            };
        };
        SeriesViewer.prototype.di = function () {
            return false;
        };
        Object.defineProperty(SeriesViewer.prototype, "ek", {
            get: function () {
                return this.d2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "dr", {
            get: function () {
                return this.a4 != null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "a3", {
            get: function () {
                var a = this.a5.f$b;
                if (a.executionContext == null) {
                    a.executionContext = this.cf.l();
                }
                if (a.ensureAnimator == null) {
                    a.ensureAnimator = i2.runOn(this, this.jg);
                }
                return a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.jg = function () {
            {
                var a = this.cg;
                if (!a.f() && a.r > 0) {
                    a.v();
                }
                if (a.r == 0) {
                    this.mk(1);
                }
            }
        };
        SeriesViewer.prototype.jl = function (a, b) {
            this.mk(this.cg.o);
        };
        SeriesViewer.prototype.mk = function (a) {
            var b = this.a3.tick(a);
            if (a == 1 && b && this.cg.r > 0) {
                this.cg.v();
            }
            var c = this.a3.dirtySeries;
            if (this.a3.allDirty) {
                var d = this.series;
                for (var e = 0; e < d.count; e++) {
                    var f = d._inner[e];
                    f.lk();
                }
            }
            else {
                for (var g = 0; g < c.count; g++) {
                    var h = c._inner[g];
                    h.lk();
                }
            }
            if (!b) {
                this.cg.w();
            }
        };
        SeriesViewer.prototype.jk = function () {
            this.cf.ch();
            this.jj();
            for (var a = 0; a < this.series.count; a++) {
                if (this.series._inner[a].c6) {
                }
            }
        };
        SeriesViewer.prototype.ou = function (a) {
            return this.ot(this.ag, a);
        };
        SeriesViewer.prototype.o0 = function (a) {
            return this.ot(this.aj, a);
        };
        SeriesViewer.prototype.oy = function (a) {
            return this.ot(this.ah, a);
        };
        SeriesViewer.prototype.oz = function (a) {
            return this.ot(this.ai, a);
        };
        SeriesViewer.prototype.ot = function (a, b) {
            if (a == null || a.count == 0) {
                return null;
            }
            else {
                return a.item(b % a.count);
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "o8", {
            get: function () {
                return this.o7;
            },
            set: function (a) {
                if (i2.PointUtil.notEquals(this.o7, a)) {
                    var b = this.o7;
                    this.o7 = a;
                    this.ll("CrosshairPoint", b, this.o7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "du", {
            get: function () {
                return this.b6 == 1 || this.b6 == 2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "legend", {
            get: function () {
                return this.c(SeriesViewer.no);
            },
            set: function (a) {
                this.h(SeriesViewer.no, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "da", {
            get: function () {
                return this.c(SeriesViewer.m6);
            },
            set: function (a) {
                this.h(SeriesViewer.m6, a);
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.ku = function (a, b) {
            this.c0 = false;
            var c = false;
            c = false;
            if (this.cf.k.ai) {
                return;
            }
            if (this.plotAreaMouseLeftButtonDown != null) {
                var d = this.ba(a, b, c);
                this.plotAreaMouseLeftButtonDown(this, d);
            }
        };
        SeriesViewer.prototype.ba = function (a, b, c) {
            var d = { $type: i2.Point_$type, x: a.x, y: a.y };
            var e = { $type: i2.Point_$type, x: a.x, y: a.y };
            if (!this.pv.isEmpty) {
                if (c) {
                    e.x -= this.pv.left;
                    e.y -= this.pv.top;
                }
                else {
                    d.x += this.pv.left;
                    d.y += this.pv.top;
                }
            }
            var f = new PlotAreaMouseButtonEventArgs(this, d, e);
            f.manipulationOccurred = this.c0;
            return f;
        };
        SeriesViewer.prototype.be = function (a, b, c) {
            var d = { $type: i2.Point_$type, x: a.x, y: a.y };
            var e = { $type: i2.Point_$type, x: a.x, y: a.y };
            if (!this.pv.isEmpty) {
                if (c) {
                    e.x -= this.pv.left;
                    e.y -= this.pv.top;
                }
                else {
                    d.x += this.pv.left;
                    d.y += this.pv.top;
                }
            }
            var f = new PlotAreaMouseEventArgs(this, d, e);
            return f;
        };
        SeriesViewer.prototype.kv = function (a, b, c) {
            var d = false;
            d = false;
            if (this.cf.k.ai) {
                return;
            }
            if (this.plotAreaMouseLeftButtonUp != null) {
                var e = this.ba(a, b, d);
                this.plotAreaMouseLeftButtonUp(this, e);
            }
            if (!this.c0 && !c) {
                if (this.plotAreaClicked != null) {
                    var f = this.ba(a, b, d);
                    this.plotAreaClicked(this, f);
                }
            }
            this.c0 = false;
        };
        Object.defineProperty(SeriesViewer.prototype, "d2", {
            get: function () {
                return this.c(SeriesViewer.nk);
            },
            set: function (a) {
                this.h(SeriesViewer.nk, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "ej", {
            get: function () {
                return this.c(SeriesViewer.n5);
            },
            set: function (a) {
                this.h(SeriesViewer.n5, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "bq", {
            get: function () {
                return i2.EnumUtil.getEnumValue(SeriesHighlightingMode_$type, this.c(SeriesViewer.ng));
            },
            set: function (a) {
                this.h(SeriesViewer.ng, i2.enumGetBox(SeriesHighlightingMode_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.bp = function () {
            if (this.bo == 0) {
                return 1;
            }
            if (this.bq == 3 || this.bq == 5) {
                if (this.bo == 2) {
                    return 4;
                }
            }
            return this.bo;
        };
        Object.defineProperty(SeriesViewer.prototype, "bn", {
            get: function () {
                return this.bm;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "bo", {
            get: function () {
                return i2.EnumUtil.getEnumValue(SeriesHighlightingBehavior_$type, this.c(SeriesViewer.nf));
            },
            set: function (a) {
                this.h(SeriesViewer.nf, i2.enumGetBox(SeriesHighlightingBehavior_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "a6", {
            get: function () {
                return i2.EnumUtil.getEnumValue(LegendHighlightingMode_$type, this.c(SeriesViewer.nl));
            },
            set: function (a) {
                this.h(SeriesViewer.nl, i2.enumGetBox(LegendHighlightingMode_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "a8", {
            get: function () {
                return i2.EnumUtil.getEnumValue(LegendItemBadgeShape_$type, this.c(SeriesViewer.nn));
            },
            set: function (a) {
                this.h(SeriesViewer.nn, i2.enumGetBox(LegendItemBadgeShape_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "a7", {
            get: function () {
                return i2.EnumUtil.getEnumValue(LegendItemBadgeMode_$type, this.c(SeriesViewer.nm));
            },
            set: function (a) {
                this.h(SeriesViewer.nm, i2.enumGetBox(LegendItemBadgeMode_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.ll = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        SeriesViewer.prototype.kl = function () {
            this.km(this.series);
        };
        SeriesViewer.prototype.km = function (a) {
            var e_5, _a;
            try {
                for (var _b = tslib.__values(i2.fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    var c = b.a0;
                    if (c == null) {
                        continue;
                    }
                    var d = b.mq;
                    if (d == null) {
                        continue;
                    }
                    if (c.containsChild(d)) {
                        c.removeChild(d);
                    }
                    if (!c.containsChild(d) && b.ph != 1) {
                        c.addChildInOrder(d, b);
                    }
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        };
        SeriesViewer.prototype.kx = function (a, b, c) {
            this.lq(a, b, i2.typeCast(i2.MouseEventArgs.$, c));
        };
        SeriesViewer.prototype.k1 = function (a, b, c) {
            this.lu(a, b, i2.typeCast(i2.MouseEventArgs.$, c));
        };
        SeriesViewer.prototype.ky = function (a, b, c) {
            this.lr(a, b, i2.typeCast(i2.MouseEventArgs.$, c));
        };
        SeriesViewer.prototype.kz = function (a, b, c) {
            this.ls(a, b, i2.typeCast(i2.MouseButtonEventArgs.$, c));
        };
        SeriesViewer.prototype.k0 = function (a, b, c) {
            var d = i2.typeCast(i2.MouseButtonEventArgs.$, c);
            if (d != null) {
                this.lt(a, b, i2.typeCast(i2.MouseButtonEventArgs.$, c));
            }
        };
        SeriesViewer.prototype.i1 = function (a, b) {
            return null;
        };
        Object.defineProperty(SeriesViewer.prototype, "d8", {
            get: function () {
                return this.c0;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.j4 = function () {
            if (!this.cv) {
                this.cv = true;
                this.c0 = true;
                if (this.viewerManipulationStarting != null) {
                    var a = new SeriesViewerManipulationEventArgs();
                    a.isDragZoom = true;
                    this.viewerManipulationStarting(this, a);
                }
            }
        };
        SeriesViewer.prototype.k2 = function (a, b, c) {
        };
        SeriesViewer.prototype.k3 = function (a, b, c) {
        };
        SeriesViewer.prototype.lo = function (a, b) {
            if (this.seriesCursorMouseMove != null && this.de) {
                this.seriesCursorMouseMove(this, new ChartCursorEventArgs(this, a, b));
            }
        };
        SeriesViewer.prototype.ls = function (a, b, c) {
            if (this.seriesMouseLeftButtonDown != null) {
                this.seriesMouseLeftButtonDown(this, new DataChartMouseButtonEventArgs(this, a, b, c));
            }
        };
        SeriesViewer.prototype.lt = function (a, b, c) {
            if (this.seriesMouseLeftButtonUp != null) {
                this.seriesMouseLeftButtonUp(this, new DataChartMouseButtonEventArgs(this, a, b, c));
            }
        };
        SeriesViewer.prototype.mb = function (a) {
            this.a5.f$am(this, a);
        };
        SeriesViewer.prototype.mc = function (a) {
            a = { $type: i2.Point_$type, x: a.x - this.pv.left, y: a.y - this.pv.top };
            var b = this.pa(a);
            if (this.ej) {
                this.ja(b);
            }
            else {
                var c = this.bn;
                var d = c == 2 || c == 3 || c == 4;
                if (d) {
                    this.ml(b);
                    for (var e = 0; e < this.series.count; e++) {
                        var f = this.series._inner[e];
                        f.mk(b);
                        if (f.isStacked) {
                            f.ku(function (g) {
                                g.mk(b);
                                return true;
                            });
                        }
                    }
                }
            }
        };
        SeriesViewer.prototype.lu = function (a, b, c) {
            if (this.seriesMouseMove != null) {
                this.seriesMouseMove(this, new ChartMouseEventArgs(this, a, b, c));
            }
        };
        SeriesViewer.prototype.lq = function (a, b, c) {
            if (this.seriesMouseEnter != null) {
                this.seriesMouseEnter(this, new ChartMouseEventArgs(this, a, b, c));
            }
        };
        SeriesViewer.prototype.lr = function (a, b, c) {
            if (this.seriesMouseLeave != null) {
                this.seriesMouseLeave(this, new ChartMouseEventArgs(this, a, b, c));
            }
        };
        SeriesViewer.prototype.j3 = function () {
            if (this.cv) {
                this.cv = false;
                if (this.viewerManipulationEnding != null) {
                    var a = new SeriesViewerManipulationEventArgs();
                    a.isDragZoom = true;
                    this.viewerManipulationEnding(this, a);
                }
            }
        };
        SeriesViewer.prototype.get_pv = function () {
            return this.pf;
        };
        Object.defineProperty(SeriesViewer.prototype, "pv", {
            get: function () {
                return this.get_pv();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "pk", {
            get: function () {
                return this.pd;
            },
            set: function (a) {
                this.pd = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.pp = function (a, b, c) {
            if (c.isEmpty) {
                return c;
            }
            var d = c;
            var e = b;
            var f = (d.left - e.left) / e.width;
            var g = (d.top - e.top) / e.height;
            var h = (d.right - e.left) / e.width;
            var i = (d.bottom - e.top) / e.height;
            f = a.left + f * a.width;
            g = a.top + g * a.height;
            h = a.left + h * a.width;
            i = a.top + i * a.height;
            return new i2.Rect(0, f, g, h - f, i - g);
        };
        SeriesViewer.prototype.get_pj = function () {
            if (this.ct) {
                this.ct = false;
                var a = this.pn(this.pv, this.pk, this.pg);
                this.pc = a;
            }
            return this.pc;
        };
        Object.defineProperty(SeriesViewer.prototype, "pj", {
            get: function () {
                return this.get_pj();
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.pn = function (a, b, c) {
            var d = b;
            var e = c;
            var f = a;
            if (f.isEmpty) {
                return i2.Rect.empty;
            }
            if (d.isEmpty) {
                return a;
            }
            var g = (d.left - f.left) / f.width;
            var h = (d.right - f.left) / f.width;
            var i = (d.top - f.top) / f.height;
            var j = (d.bottom - f.top) / f.height;
            g = f.left + (g - e.left) / e.width * f.width;
            h = f.left + (h - e.left) / e.width * f.width;
            i = f.top + (i - e.top) / e.height * f.height;
            j = f.top + (j - e.top) / e.height * f.height;
            var k = new i2.Rect(0, g, i, h - g, j - i);
            k.intersect(f);
            return k;
        };
        SeriesViewer.prototype.pi = function (a) {
            this.ct = true;
            return i2.Rect.empty;
        };
        SeriesViewer.prototype.po = function () {
            return this.pv;
        };
        SeriesViewer.prototype.mg = function (a) {
            a.js = this.pv;
        };
        Object.defineProperty(SeriesViewer.prototype, "ga", {
            get: function () {
                return this.f7;
            },
            set: function (a) {
                this.f7 = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.lg = function (a, b) {
            if (!b.isEmpty) {
                this.pf = b;
                this.pd = this.pi(this.pf);
                this.cf.en(this.pf);
            }
            if (this.di()) {
                if (this.actualSyncLink != null) {
                    this.ms(this.pg, false);
                }
            }
            this.kw(a, b);
        };
        SeriesViewer.prototype.bs = function () {
            return this.br;
        };
        SeriesViewer.prototype.i7 = function (a, b) {
            var c = false;
            c = true;
            if (this.pv.containsPoint(a)) {
                if (!this.cy) {
                    this.cy = true;
                    if (this.plotAreaMouseEnter != null) {
                        var d = this.be(a, false, c);
                        d.isDuringManipulation = b;
                        this.plotAreaMouseEnter(this, d);
                    }
                }
                else {
                    this.cy = true;
                    if (this.plotAreaMouseOver != null) {
                        var e = this.be(a, false, c);
                        e.isDuringManipulation = b;
                        this.plotAreaMouseOver(this, e);
                    }
                }
            }
            else {
                if (this.cy) {
                    this.cy = false;
                    if (this.plotAreaMouseLeave != null) {
                        var f = this.be(a, false, c);
                        f.isDuringManipulation = b;
                        this.plotAreaMouseLeave(this, f);
                    }
                }
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "at", {
            get: function () {
                return this.ar;
            },
            set: function (a) {
                var b = this.ar;
                this.ar = a;
                if (b != this.ar) {
                    this.ll("ContentHitTestMode", i2.enumGetBox(ChartHitTestMode_$type, b), i2.enumGetBox(ChartHitTestMode_$type, this.ar));
                }
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.lw = function () {
            this.as = this.au();
        };
        SeriesViewer.prototype.au = function () {
            if (!this.dv) {
                return 1;
            }
            return this.a5.f$a(this);
        };
        Object.defineProperty(SeriesViewer.prototype, "as", {
            get: function () {
                return this.aq;
            },
            set: function (a) {
                var b = this.aq;
                this.aq = a;
                if (b != this.aq) {
                    this.ll("ActualContentHitTestMode", i2.enumGetBox(ChartHitTestMode_$type, b), i2.enumGetBox(ChartHitTestMode_$type, this.aq));
                }
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.ln = function (a) {
            if (this.seriesAnimating != null) {
                this.seriesAnimating(a);
            }
        };
        SeriesViewer.prototype.d3 = function () {
            return this.d4() || this.d5();
        };
        SeriesViewer.prototype.onDetachedFromUI = function () {
            this.cf.cz();
            SyncManager.e(this);
        };
        SeriesViewer.prototype.onAttachedToUI = function () {
            this.cf.ct();
            SyncManager.c(this);
        };
        Object.defineProperty(SeriesViewer.prototype, "b6", {
            get: function () {
                return this.b2;
            },
            set: function (a) {
                if (this.b6 != a) {
                    var b = this.b2;
                    this.b2 = a;
                    if (this.dv) {
                        this.a5.f$ae(this);
                    }
                    if (b == 1 && this.b2 != 1) {
                        this.j3();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.ko = function (a) {
            this.ja(this.pa(a));
        };
        SeriesViewer.prototype.kp = function (a, b) {
            var c = false;
            c = false;
            this.ja({ $type: i2.Point_$type, x: NaN, y: NaN });
            if (this.cy) {
                this.cy = false;
                if (this.plotAreaMouseLeave != null) {
                    var d = this.be(a, false, c);
                    d.isDuringManipulation = b;
                    this.plotAreaMouseLeave(this, d);
                }
            }
        };
        SeriesViewer.prototype.ed = function (a, b) {
            return this.a5.f$e(this, a, b);
        };
        SeriesViewer.prototype.ke = function (a) {
            this.a5.f$n(this, a);
        };
        SeriesViewer.prototype.ec = function (a) {
            return this.a5.f$d(this, a);
        };
        Object.defineProperty(SeriesViewer.prototype, "db", {
            get: function () {
                return this.cu;
            },
            set: function (a) {
                this.cu = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.get_dw = function () {
            return this.dc || this.ep();
        };
        Object.defineProperty(SeriesViewer.prototype, "dw", {
            get: function () {
                return this.get_dw();
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.kg = function (a) {
            this.a5.f$p(this, a);
        };
        Object.defineProperty(SeriesViewer.prototype, "dh", {
            get: function () {
                return this.cu;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.kt = function (a) {
            this.a5.f$ac(this, a);
        };
        SeriesViewer.prototype.kh = function (a, b) {
            this.a5.f$q(this, a, b);
        };
        SeriesViewer.prototype.kf = function (a) {
            this.a5.f$o(this, a);
        };
        Object.defineProperty(SeriesViewer.prototype, "ee", {
            get: function () {
                return this.c2;
            },
            set: function (a) {
                this.c2 = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.lb = function () {
            this.a5.f$aj(this);
        };
        SeriesViewer.prototype.ks = function (a) {
            this.a5.f$ab(this, a);
        };
        SeriesViewer.prototype.lc = function (a, b, c, d) {
            this.a5.f$ak(this, a, b, c, d);
        };
        SeriesViewer.prototype.kr = function (a) {
            this.a5.f$aa(this, a);
        };
        SeriesViewer.prototype.k8 = function (a, b, c, d) {
            this.a5.f$ag(this, a, b, c, d);
        };
        SeriesViewer.prototype.kn = function (a) {
            this.a5.f$x(this, a);
        };
        SeriesViewer.prototype.kq = function (a) {
            this.a5.f$z(this, a);
        };
        SeriesViewer.prototype.ki = function (a) {
            this.a5.f$r(this, a);
        };
        SeriesViewer.prototype.k7 = function (a, b, c, d) {
            this.a5.f$af(this, a, b, c, d);
        };
        SeriesViewer.prototype.kk = function (a) {
            this.cf.eg(a.height);
        };
        SeriesViewer.prototype.jj = function () {
            if (this.cu) {
                this.ja({ $type: i2.Point_$type, x: NaN, y: NaN });
                this.cf.ce();
            }
            this.cu = false;
        };
        SeriesViewer.prototype.j8 = function (a, b) {
            this.a5.f$m(this, a, b);
        };
        SeriesViewer.prototype.b4 = function (a) {
            var b = this.cf.k != null && this.cf.k.ai ? this.b5 : this.b3;
            if (b != 3) {
                return b;
            }
            return this.cf.m(a);
        };
        SeriesViewer.prototype.la = function () {
            this.c5 = false;
            if (!this.c6) {
                this.c6 = true;
                this.c0 = true;
                if (this.viewerManipulationStarting != null) {
                    var a = new SeriesViewerManipulationEventArgs();
                    a.isZoomPan = true;
                    this.viewerManipulationStarting(this, a);
                }
            }
            this.a5.f$ai(this);
        };
        SeriesViewer.prototype.k9 = function () {
            if (this.c6) {
                this.c6 = false;
                if (this.viewerManipulationEnding != null) {
                    var a = new SeriesViewerManipulationEventArgs();
                    a.isZoomPan = true;
                    this.viewerManipulationEnding(this, a);
                }
            }
            this.a5.f$ah(this);
        };
        SeriesViewer.prototype.md = function () {
            this.a5.f$an(this);
        };
        SeriesViewer.prototype.je = function () {
            if (this.c5) {
                this.kb();
            }
            this.a5.f$j(this);
        };
        SeriesViewer.prototype.i9 = function () {
            this.i8();
        };
        SeriesViewer.prototype.i8 = function () {
            if (this.dv) {
                this.a5.f$g(this);
            }
        };
        SeriesViewer.prototype.le = function () {
        };
        SeriesViewer.prototype.lz = function () {
        };
        SeriesViewer.prototype.lx = function () {
            for (var a = 0; a < this.series.count; a++) {
                this.series._inner[a].l0(false);
            }
            this.ji(false, false, true);
        };
        SeriesViewer.prototype.j7 = function (a, b) {
            this.a5.f$l(this, a, b);
        };
        SeriesViewer.prototype.ei = function () {
            return false;
        };
        Object.defineProperty(SeriesViewer.prototype, "em", {
            get: function () {
                return this.c3;
            },
            set: function (a) {
                this.c3 = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.j6 = function (a, b, c) {
            this.a5.f$k(this, a, b, c);
        };
        SeriesViewer.prototype.mq = function (a, b) {
            if (b.propertyName == SyncSettings.$$p[0]) {
                SyncManager.b(this, b.oldValue, b.newValue);
            }
        };
        SeriesViewer.prototype.mp = function (a, b) {
            var e_6, _a;
            if (a != null) {
                a.ab.remove(this);
                a.propertyUpdated = i2.delegateRemove(a.propertyUpdated, this.propertyUpdated);
            }
            if (b != null) {
                b.ab.add(this);
                b.propertyUpdated = i2.delegateCombine(b.propertyUpdated, this.propertyUpdated);
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.b5 = this.actualSyncLink;
                    c.ca = this;
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        };
        SeriesViewer.prototype.ja = function (a) {
            this.actualSyncLink.ak(this, a);
        };
        SeriesViewer.prototype.ms = function (a, b) {
            this.mt(a, b, !b);
        };
        SeriesViewer.prototype.mt = function (a, b, c) {
            if (!b) {
                this.actualSyncLink.ap(this, a, c);
            }
            else {
                if (!this.d4() && !this.d5()) {
                    return;
                }
                var d = !a.isEmpty && !i2.isNaN_(a.x) && !i2.isNaN_(a.y) && !i2.isNaN_(a.width) && !i2.isNaN_(a.height);
                var e = a;
                if (d && !this.d4()) {
                    e = new i2.Rect(0, 0, a.y, 1, a.height);
                }
                if (d && !this.d5()) {
                    e = new i2.Rect(0, a.x, 0, a.width, 1);
                }
                this.actualSyncLink.ao(this, e);
            }
        };
        SeriesViewer.prototype.lf = function (a, b) {
            if (!b) {
                this.actualSyncLink.al(this, a);
            }
            else {
                if (!this.d4() && !this.d5()) {
                    return;
                }
                var c = !a.isEmpty && !i2.isNaN_(a.x) && !i2.isNaN_(a.y) && !i2.isNaN_(a.width) && !i2.isNaN_(a.height);
                var d = a;
                if (c && !this.d4()) {
                    d = new i2.Rect(0, 0, a.y, 1, a.height);
                }
                if (c && !this.d5()) {
                    d = new i2.Rect(0, a.x, 0, a.width, 1);
                }
                this.actualSyncLink.al(this, d);
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "d0", {
            get: function () {
                return this.actualSyncLink != null;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype._eu = function () {
            var _a, _b, a, e_7_1;
            var e_7, _c;
            return tslib.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (this.actualSyncLink == null) {
                            return [2 /*return*/, undefined];
                        }
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        _a = tslib.__values(i2.fromEnum(this.actualSyncLink.ag)), _b = _a.next();
                        _d.label = 2;
                    case 2:
                        if (!!_b.done)
                            return [3 /*break*/, 5];
                        a = _b.value;
                        return [4 /*yield*/, a];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_7_1 = _d.sent();
                        e_7 = { error: e_7_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_c = _a.return))
                                _c.call(_a);
                        }
                        finally {
                            if (e_7)
                                throw e_7.error;
                        }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        };
        SeriesViewer.prototype.eu = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._eu(); });
        };
        SeriesViewer.prototype.pa = function (a) {
            a = { $type: i2.Point_$type, x: a.x + this.pv.left, y: a.y + this.pv.top };
            var b = this.pj;
            var c = this.pg.left + this.pg.width * (a.x - b.left) / b.width;
            var d = this.pg.top + this.pg.height * (a.y - b.top) / b.height;
            return { $type: i2.Point_$type, x: c, y: d };
        };
        SeriesViewer.prototype.pu = function (a) {
            a = new i2.Rect(0, a.left + this.pv.left, a.top + this.pv.top, a.width, a.height);
            var b = this.pj;
            var c = this.pg.left + this.pg.width * (a.left - b.left) / b.width;
            var d = this.pg.top + this.pg.height * (a.top - b.top) / b.height;
            var e = this.pg.left + this.pg.width * (a.right - b.left) / b.width;
            var f = this.pg.top + this.pg.height * (a.bottom - b.top) / b.height;
            return new i2.Rect(0, c, d, e - c, f - d);
        };
        SeriesViewer.prototype.lv = function (a, b) {
            if (this.windowRectChanged != null && i2.Rect.l_op_Inequality(a, b)) {
                this.windowRectChanged(this, new i2.RectChangedEventArgs(a, b));
            }
        };
        SeriesViewer.prototype.k6 = function (a, b) {
            this.lv(a, b);
        };
        SeriesViewer.prototype.k4 = function (a, b) {
            if (this.sizeChanged != null && i2.Size.l_op_Inequality(a, b)) {
                this.sizeChanged(this, new i2.RectChangedEventArgs(new i2.Rect(1, 0, 0, a), new i2.Rect(1, 0, 0, b)));
            }
        };
        SeriesViewer.prototype.eg = function (a, b) {
            if (a.width != b.width || a.height != b.height || a.x != b.x || a.y != b.y) {
                return true;
            }
            return false;
        };
        SeriesViewer.prototype.lj = function (a, b) {
            if (this.actualWindowRectChanged != null && this.eg(a, b)) {
                this.actualWindowRectChanged(this, new i2.RectChangedEventArgs(a, b));
            }
        };
        SeriesViewer.prototype.l5 = function () {
            this.cf.dz();
        };
        SeriesViewer.prototype.lk = function (a, b) {
            if (this.gridAreaRectChanged != null && i2.Rect.l_op_Inequality(a, b)) {
                this.gridAreaRectChanged(this, new i2.RectChangedEventArgs(a, b));
            }
        };
        SeriesViewer.prototype.get_dx = function () {
            return false;
        };
        Object.defineProperty(SeriesViewer.prototype, "dx", {
            get: function () {
                return this.get_dx();
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.kw = function (a, b) {
            this.lk(a, b);
            if (this.dv) {
                this.a5.f$al(this);
            }
            if (this.dx && (i2.Rect.l_op_Equality(a, null) || a.isEmpty || a.width == 0 || a.height == 0)) {
                this.ms(this.pw, false);
            }
            else {
                this.jo();
            }
        };
        SeriesViewer.prototype.jr = function () {
            this.jo();
        };
        Object.defineProperty(SeriesViewer.prototype, "syncChannel", {
            get: function () {
                return this._syncChannel;
            },
            set: function (a) {
                this._syncChannel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "actualSyncLink", {
            get: function () {
                return this.bt;
            },
            set: function (a) {
                var b = this.bt;
                this.bt = a;
                this.ll("ActualSyncLink", b, this.bt);
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.jq = function () {
            this.cf.d0();
        };
        SeriesViewer.prototype.kc = function () {
            this.c5 = true;
        };
        SeriesViewer.prototype.ka = function () {
            this.c5 = false;
        };
        SeriesViewer.prototype.kb = function () {
            if (this.c5) {
                if (this.c6) {
                    this.c6 = false;
                    if (this.viewerManipulationEnding != null) {
                        var a = new SeriesViewerManipulationEventArgs();
                        a.isZoomPan = true;
                        this.viewerManipulationEnding(this, a);
                    }
                    this.c0 = false;
                }
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "b8", {
            get: function () {
                return this.cf.i().a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.mm = function (a) {
            if (this.b8 != null) {
                this.b8.mobileMode = a;
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "by", {
            get: function () {
                return this.bx;
            },
            set: function (a) {
                this.bx = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.bz = function () {
            if (this.b0 == 0) {
                return 1;
            }
            return this.b0;
        };
        SeriesViewer.prototype.dd = function () {
            return this.b6 == 0 && !this.c2 && !this.c3;
        };
        SeriesViewer.prototype.c9 = function () {
            if (this.actualSyncLink != null && this.actualSyncLink.ag.count > 0) {
                var a = true;
                a = this.dd();
                if (!a) {
                    return false;
                }
                for (var b = 0; b < this.actualSyncLink.ag.count; b++) {
                    if (!this.actualSyncLink.ag.item(b).dd()) {
                        return false;
                    }
                }
                return true;
            }
            else {
                return this.dd();
            }
        };
        SeriesViewer.prototype.i6 = function () {
            if (this.b6 == 2) {
                this.cf.bt();
                this.b6 = 0;
                this.k9();
                this.lf(i2.Rect.empty, true);
                if (this.bw == 1) {
                    this.ms(this.px, true);
                }
            }
            if (this.b6 == 1) {
                this.cf.bt();
                this.b6 = 0;
                this.k9();
                this.cf.cc();
                this.lf(i2.Rect.empty, true);
            }
        };
        SeriesViewer.prototype.notifyCrosshairUpdate = function () {
        };
        SeriesViewer.prototype.mr = function (a, b) {
            var c = this.f5;
            this.pw = new i2.Rect(0, this.fi, this.fj, i2.MathUtil.b(a, c, 1), i2.MathUtil.b(b, c, 1));
        };
        SeriesViewer.prototype.fn = function () {
            return 1;
        };
        SeriesViewer.prototype.fo = function () {
            return 1;
        };
        SeriesViewer.prototype.lh = function (a, b, c, d) {
            var e_8, _a, e_9, _b, e_10, _c;
            switch (b) {
                case SeriesViewer.$$p[33]:
                    this.cf.dg();
                    break;
                case SeriesViewer.$$p[30]:
                    this.cf.dg();
                    break;
                case SeriesViewer.$$p[41]:
                    this.by = this.bz();
                    break;
                case "ActualContentHitTestMode":
                    this.j1();
                    break;
                case "ContentHitTestMode":
                    this.lw();
                    break;
                case SeriesViewer.$$p[32]:
                    this.cf.de(c, d);
                    this.cf.dg();
                    break;
                case SeriesViewer.$$p[29]:
                    this.cf.da(c, d);
                    this.cf.dg();
                    break;
                case "TitleTextStyle":
                case "TitleTextColor":
                case "SubtitleTextStyle":
                case "SubtitleTextColor":
                case "TitleTopMargin":
                case "TitleLeftMargin":
                case "TitleRightMargin":
                case "TitleBottomMargin":
                case "SubtitleTopMargin":
                case "SubtitleLeftMargin":
                case "SubtitleRightMargin":
                case "SubtitleBottomMargin":
                    this.cf.dg();
                    break;
                case SeriesViewer.$$p[23]:
                case SeriesViewer.$$p[24]:
                case SeriesViewer.$$p[25]:
                    this.cf.c8();
                    break;
                case "PixelScalingRatio":
                    if (i2.isNaN_(i2.DeviceUtils.a(this.fr))) {
                        this.jn();
                    }
                    else {
                        this.fh = i2.DeviceUtils.a(this.fr);
                    }
                    break;
                case "InteractionPixelScalingRatio":
                    this.fg = this.fp;
                    break;
                case "ActualPixelScalingRatio":
                    this.cf.dm();
                    break;
                case SeriesViewer.$$p[10]:
                    this.cf.cm();
                    break;
                case "ActualSyncLink":
                    this.mp(i2.typeCast(SyncLink.$, c), i2.typeCast(SyncLink.$, d));
                    break;
                case SeriesViewer.$$p[3]:
                    if (!this.dk) {
                        this.eq = true;
                    }
                    if (this.p0 == 0) {
                        this.de = true;
                    }
                    else {
                        this.de = this.c7;
                    }
                    if (this.dv) {
                        this.a5.f$al(this);
                    }
                    break;
                case "CrosshairPoint":
                    if (this.dv) {
                        if (this.eb) {
                            this.ml(this.o8);
                        }
                        this.a5.f$al(this);
                    }
                    this.notifyCrosshairUpdate();
                    break;
                case SeriesViewer.$$p[39]:
                    if (this.actualSyncLink != null) {
                        this.f9++;
                        this.ms(d, false);
                        this.f9--;
                    }
                    if (!this.pw.equals1(c) && this.f9 == 0) {
                        this.k6(c, this.pw);
                    }
                    this.jo();
                    break;
                case SeriesViewer.$$p[36]:
                    this.fi = this.f3;
                    break;
                case SeriesViewer.$$p[37]:
                    this.fj = this.f4;
                    break;
                case "ActualWindowPositionVertical":
                case "ActualWindowPositionHorizontal":
                    if (!this.eo) {
                        this.mr(this.fn(), this.fo());
                    }
                    break;
                case SeriesViewer.$$p[11]:
                    this.cf.c2();
                    break;
                case SeriesViewer.$$p[9]:
                    this.cg.r = this.gd;
                    break;
                case SeriesViewer.$$p[16]:
                    this.mo();
                    break;
                case "ActualWindowRect":
                    this.ct = true;
                    if (this.eg(c, d)) {
                        this.i2();
                    }
                    if (d.width == 1 && d.height == 1 && c.isEmpty) {
                        this.es = true;
                    }
                    this.lj(c, d);
                    break;
                case SeriesViewer.$$p[20]:
                    this.cf.c7(d);
                    break;
                case SeriesViewer.$$p[35]:
                    this.c8 = this.er;
                    break;
                case SeriesViewer.$$p[42]:
                    this.ga = this.ge;
                    this.i8();
                    break;
                case SeriesViewer.$$p[22]:
                    this.a5.f$ad(this);
                    break;
                case "HighlightingMode":
                case "HighlightingBehavior":
                    this.bm = this.bp();
                    if (this.dv) {
                        var e = this.a3;
                        e.highlightingBehavior = this.bn;
                    }
                    break;
                case "LegendItemBadgeShape":
                    try {
                        for (var _d = tslib.__values(i2.fromEnum(this.series)), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var f = _e.value;
                            f.a9 = this.a8;
                        }
                    }
                    catch (e_8_1) {
                        e_8 = { error: e_8_1 };
                    }
                    finally {
                        try {
                            if (_e && !_e.done && (_a = _d.return))
                                _a.call(_d);
                        }
                        finally {
                            if (e_8)
                                throw e_8.error;
                        }
                    }
                    break;
                case "LegendItemBadgeMode":
                    try {
                        for (var _f = tslib.__values(i2.fromEnum(this.series)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var g = _g.value;
                            g.a7 = this.a7;
                        }
                    }
                    catch (e_9_1) {
                        e_9 = { error: e_9_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_9)
                                throw e_9.error;
                        }
                    }
                    break;
                case SeriesViewer.$$p[1]:
                case SeriesViewer.$$p[15]:
                case SeriesViewer.$$p[13]:
                case SeriesViewer.$$p[14]:
                case SeriesViewer.$$p[12]:
                    try {
                        for (var _h = tslib.__values(i2.fromEnum(this.series)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var h = _j.value;
                            h.k2();
                        }
                    }
                    catch (e_10_1) {
                        e_10 = { error: e_10_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_10)
                                throw e_10.error;
                        }
                    }
                    break;
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "ds", {
            get: function () {
                return this.bn == 2 || this.bn == 3 || this.bn == 4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "eb", {
            get: function () {
                return this.bn == 2 || this.bn == 3 || this.bn == 4;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.ml = function (a) {
            var _this = this;
            var b = 1.7976931348623157E+308;
            var c = null;
            for (var d = 0; d < this.series.count; d++) {
                var e = this.series._inner[d];
                if (e.c6) {
                    continue;
                }
                if (e.cy && e.c1) {
                    continue;
                }
                if (e.isStacked) {
                    e.ku(function (f) {
                        var g = _this.i0(f, b, c, a);
                        if (g == null) {
                            return true;
                        }
                        b = g.c;
                        c = g.d;
                        return true;
                    });
                }
                var f = this.i0(e, b, c, a);
                if (f == null) {
                    continue;
                }
                b = f.c;
                c = f.d;
            }
            this.bj = c;
        };
        SeriesViewer.prototype.i0 = function (a, b, c, d) {
            var e = a.ox(d);
            var f = a.o2(d, true, true);
            if (i2.isNaN_(f.x) || i2.isNaN_(f.y)) {
                return null;
            }
            var g = (e.x - f.x) * (e.x - f.x) + (e.y - f.y) * (e.y - f.y);
            if (g < b) {
                b = g;
                c = a;
            }
            return new i2.Tuple$2(i2.Number_$type, Series.$, b, c);
        };
        SeriesViewer.prototype.mo = function () {
            this.c4 = this.p1 == 0;
            this.cf.dl();
            this.mn();
            this.cf.ej();
            this.jq();
            this.jz();
        };
        SeriesViewer.prototype.j1 = function () {
            this.cf.cs();
        };
        SeriesViewer.prototype.mn = function () {
            if (this.b8 == null) {
                return;
            }
            this.b8.visibility = this.p1;
            this.b8.isZoomable = this.d3();
        };
        Object.defineProperty(SeriesViewer.prototype, "pq", {
            get: function () {
                return this.pe;
            },
            set: function (a) {
                var b = this.pe;
                this.pe = a;
                if (this.pe.isEmpty) {
                    this.cf.cg();
                }
                else {
                    this.cf.ek(this.pv, this.pt(this.pq));
                    this.cf.d9();
                    this.ll("PreviewRect", b, this.pe);
                }
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.mf = function () {
            this.fi = this.pg.x;
            this.fj = this.pg.y;
        };
        SeriesViewer.prototype.i2 = function () {
            this.es = false;
            this.ev = i2.dateNow();
            if (this.dr) {
                for (var a = 0; a < this.series.count; a++) {
                    this.series._inner[a].kf();
                }
                this.a3.clear();
            }
            if (this.cg.f()) {
                this.cg.w();
            }
            var b = this.eo;
            this.eo = true;
            this.mf();
            this.eo = b;
            this.cf.ch();
            this.cf.em(this.pg);
        };
        SeriesViewer.prototype.pt = function (a) {
            if (this.pv.isEmpty) {
                return i2.Rect.empty;
            }
            var b = this.pv;
            var c = b.left + (b.width * (a.left - this.pg.left) / this.pg.width);
            var d = b.top + (b.height * (a.top - this.pg.top) / this.pg.height);
            var e = b.left + (b.width * (a.right - this.pg.left) / this.pg.width);
            var f = b.top + (b.height * (a.bottom - this.pg.top) / this.pg.height);
            return new i2.Rect(0, c, d, e - c, f - d);
        };
        SeriesViewer.prototype.lm = function () {
            if (this.refreshCompleted != null && !this.destroyed) {
                this.refreshCompleted(this, new RefreshCompletedEventArgs());
            }
        };
        SeriesViewer.prototype.k5 = function (a) {
            this.mn();
        };
        Object.defineProperty(SeriesViewer.prototype, "im", {
            get: function () {
                return this.gk;
            },
            set: function (a) {
                var b = this.gk;
                this.gk = a;
                this.ll("TitleTextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "h9", {
            get: function () {
                return this.gj;
            },
            set: function (a) {
                var b = this.gj;
                this.gj = a;
                this.ll("SubtitleTextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "o6", {
            get: function () {
                return this.oq;
            },
            set: function (a) {
                var b = this.oq;
                this.oq = a;
                this.ll("TitleTextColor", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "o5", {
            get: function () {
                return this.op;
            },
            set: function (a) {
                var b = this.op;
                this.op = a;
                this.ll("SubtitleTextColor", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "f1", {
            get: function () {
                return this.fe;
            },
            set: function (a) {
                var b = this.fe;
                this.fe = a;
                this.ll("TitleTopMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fz", {
            get: function () {
                return this.fc;
            },
            set: function (a) {
                var b = this.fc;
                this.fc = a;
                this.ll("TitleLeftMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "f0", {
            get: function () {
                return this.fd;
            },
            set: function (a) {
                var b = this.fd;
                this.fd = a;
                this.ll("TitleRightMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fy", {
            get: function () {
                return this.fb;
            },
            set: function (a) {
                var b = this.fb;
                this.fb = a;
                this.ll("TitleBottomMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fx", {
            get: function () {
                return this.fa;
            },
            set: function (a) {
                var b = this.fa;
                this.fa = a;
                this.ll("SubtitleTopMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fv", {
            get: function () {
                return this.e8;
            },
            set: function (a) {
                var b = this.e8;
                this.e8 = a;
                this.ll("SubtitleLeftMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fw", {
            get: function () {
                return this.e9;
            },
            set: function (a) {
                var b = this.e9;
                this.e9 = a;
                this.ll("SubtitleRightMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fu", {
            get: function () {
                return this.e7;
            },
            set: function (a) {
                var b = this.e7;
                this.e7 = a;
                this.ll("SubtitleBottomMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.py = function () {
            return this.cf.fe();
        };
        SeriesViewer.prototype.pz = function () {
            return this.cf.ff();
        };
        SeriesViewer.prototype.an = function (a) {
            return this.cf.c(a);
        };
        SeriesViewer.prototype.ao = function (a) {
            return this.cf.d(a);
        };
        SeriesViewer.prototype.getFontHeight = function () {
            return this.cf.a9;
        };
        SeriesViewer.prototype.provideContainer = function (a) {
            this.cf.cx(a);
        };
        SeriesViewer.prototype.j9 = function (a, b) {
            this.cf.cy(a, b);
        };
        SeriesViewer.prototype.notifyContainerResized = function () {
            this.cf.cr();
        };
        SeriesViewer.prototype.pl = function () {
            return this.cf.e8();
        };
        SeriesViewer.prototype.jf = function () {
            this.cf.b5();
        };
        SeriesViewer.prototype.o9 = function () {
            return this.cf.e5();
        };
        SeriesViewer.prototype.ci = function () {
            return this.cf.t();
        };
        SeriesViewer.prototype.ch = function () {
            return this.cf.q();
        };
        SeriesViewer.prototype.ov = function () {
            return this.cf.ex();
        };
        SeriesViewer.prototype.ow = function () {
            return this.cf.e0();
        };
        SeriesViewer.prototype.i4 = function (a) {
            this.cf.bp(a);
        };
        SeriesViewer.prototype.l1 = function (a) {
            this.cf.dv(a);
        };
        Object.defineProperty(SeriesViewer.prototype, "ea", {
            get: function () {
                return this.c1;
            },
            set: function (a) {
                var b = this.c1;
                this.c1 = a;
                if (b != this.c1) {
                    this.cf.co(this.c1);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "c7", {
            get: function () {
                return this.cs;
            },
            set: function (a) {
                var b = this.cs;
                this.cs = a;
                if (b != this.cs) {
                    this.cf.bk(this.cs);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "syncSettings", {
            get: function () {
                return this._syncSettings;
            },
            set: function (a) {
                this._syncSettings = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.i3 = function (a) {
            this.cf.bn(a);
        };
        SeriesViewer.prototype.l3 = function (a) {
            this.cf.dw(a);
        };
        SeriesViewer.prototype.jy = function (source_, a, b, c) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            var d = this.actualSyncLink.ae(source_);
            if (d == null) {
                return;
            }
            d.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        SeriesViewer.prototype.jt = function (source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            var a = this.actualSyncLink.ae(source_);
            if (a == null) {
                return;
            }
            a.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        SeriesViewer.prototype.jw = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            var c = this.actualSyncLink.ae(source_);
            if (c == null) {
                return;
            }
            c.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        SeriesViewer.prototype.jx = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            var c = this.actualSyncLink.ae(source_);
            if (c == null) {
                return;
            }
            c.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        SeriesViewer.prototype.destroy = function () {
            this.destroyed = true;
            var a = new i2.List$1(Series.$, 0);
            for (var b = 0; b < this.series.count; b++) {
                a.add(this.series._inner[b]);
            }
            for (var c = 0; c < a.count; c++) {
                if (a._inner[c].bx != null) {
                    a._inner[c].bx.aj();
                }
                this.series.remove(a._inner[c]);
                this.l2(a._inner[c].name, true);
                a._inner[c].itemsSource = null;
                a._inner[c].ln(null, null);
            }
            this.jd();
            this.l4();
            this.onDetachedFromUI();
            this.cf.cx(null);
        };
        SeriesViewer.prototype.jd = function () {
        };
        SeriesViewer.prototype.ma = function (source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            this.gf = source_;
            this.mj();
        };
        SeriesViewer.prototype.l4 = function () {
            this.gf = null;
            this.mj();
        };
        SeriesViewer.prototype.l9 = function (a, source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (i2.stringIsNullOrEmpty(a) == false) {
                if (!this.et.containsKey(a)) {
                    this.et.addItem(a, source_);
                }
                else {
                    this.et.item(a, source_);
                }
            }
            this.mj();
        };
        SeriesViewer.prototype.l2 = function (a, b) {
            if (i2.stringIsNullOrEmpty(a) == false) {
                if (this.et.containsKey(a)) {
                    this.et.removeItem(a);
                }
            }
            if (!b) {
                this.mj();
            }
        };
        SeriesViewer.prototype.l8 = function (a, b) {
            if (a.itemsSource != b) {
                a.itemsSource = b;
            }
        };
        SeriesViewer.prototype.mi = function (a) {
            if (!this.d7) {
                return;
            }
            if (i2.typeCast(Series.$, a) !== null) {
                var b = a;
                if (this.et.containsKey(b.name)) {
                    var c = this.et.item(b.name);
                    this.l8(b, c);
                }
                else {
                    this.l8(b, this.gf);
                }
            }
            if (i2.typeCast(CategoryAxisBase.$, a) !== null) {
                var d = a;
                if (this.et.containsKey(d.name)) {
                    var e = this.et.item(d.name);
                    if (d.itemsSource != e) {
                        d.itemsSource = e;
                    }
                }
                else {
                    if (d.itemsSource != this.gf) {
                        d.itemsSource = this.gf;
                    }
                }
            }
        };
        SeriesViewer.prototype.mj = function () {
            var e_11, _a;
            if (!this.d7) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    this.mi(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        };
        Object.defineProperty(SeriesViewer.prototype, "f2", {
            get: function () {
                return this.ff;
            },
            set: function (a) {
                this.ff = a;
                this.jq();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fq", {
            get: function () {
                return this.e4;
            },
            set: function (a) {
                this.e4 = a;
                this.jq();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "ft", {
            get: function () {
                return this.e6;
            },
            set: function (a) {
                this.e6 = a;
                this.jq();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fm", {
            get: function () {
                return this.e2;
            },
            set: function (a) {
                this.e2 = a;
                this.jq();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fl", {
            get: function () {
                return this.e1;
            },
            set: function (a) {
                this.e1 = a;
                this.jq();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fk", {
            get: function () {
                return this.e0;
            },
            set: function (a) {
                this.e0 = a;
                this.jq();
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.eh = function () {
            return false;
        };
        Object.defineProperty(SeriesViewer.prototype, "dn", {
            get: function () {
                return this.cx;
            },
            set: function (a) {
                var b = this.cx;
                this.cx = a;
                this.ll("IsAntiAliasingEnabledDuringInteraction", b, this.cx);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fr", {
            get: function () {
                return this.e5;
            },
            set: function (a) {
                var b = this.e5;
                this.e5 = a;
                this.ll("PixelScalingRatio", b, this.e5);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fp", {
            get: function () {
                return this.e3;
            },
            set: function (a) {
                var b = this.e3;
                this.e3 = a;
                this.ll("InteractionPixelScalingRatio", b, this.e3);
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.b1 = function (a, b) {
            var c = new CoercionInfo();
            c.b = a;
            c.a = null;
            var d = i2.FastItemsSource.f(a);
            if (d.d == null) {
                return c;
            }
            if (b != null) {
                var methods_ = b;
                var key_ = d.d;
                var val_ = null;
                if (typeof methods_[key_] != 'undefined') {
                    val_ = methods_[key_];
                }
                ;
                c.b = d.c;
                c.a = val_;
            }
            else if (d.d == "defaultDateParse") {
                var e = i2.defaultDVDateParse;
                c.b = d.c;
                c.a = e;
            }
            return c;
        };
        Object.defineProperty(SeriesViewer.prototype, "hl", {
            get: function () {
                return this.gi;
            },
            set: function (a) {
                this.gi = a;
                if (this.b8 == null) {
                    return;
                }
                this.b8.backgroundImageUri = this.gi;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fh", {
            get: function () {
                return this.ex;
            },
            set: function (a) {
                var b = this.ex;
                this.ex = a;
                this.ll("ActualPixelScalingRatio", b, this.ex);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fg", {
            get: function () {
                return this.ew;
            },
            set: function (a) {
                var b = this.ew;
                this.ew = a;
                this.ll("ActualInteractionPixelScalingRatio", b, this.ew);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "pg", {
            get: function () {
                return this.pb;
            },
            set: function (a) {
                var b = i2.Rect.l_op_Inequality(this.pb, a);
                if (b) {
                    var c = this.pb;
                    this.pb = a;
                    this.ll("ActualWindowRect", c, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.pm = function () {
            return this.pg;
        };
        SeriesViewer.prototype.jo = function () {
            if (this.dj) {
                return;
            }
            this.pg = this.ph();
        };
        SeriesViewer.prototype.pr = function () {
            return i2.Rect.empty;
        };
        SeriesViewer.prototype.ph = function () {
            var a = this.pw.left;
            var b = this.pw.top;
            var c = this.pw.width;
            var d = this.pw.height;
            if (this.by == 1) {
                a = Math.min(1, Math.max(0, this.pw.left));
                c = Math.min(1, Math.max(0, this.pw.width));
            }
            if (this.by == 1) {
                b = Math.min(1, Math.max(0, this.pw.top));
                d = Math.min(1, Math.max(0, this.pw.height));
            }
            return new i2.Rect(0, a, b, c, d);
        };
        SeriesViewer.prototype.gg = function (a, b) {
            return this.cf.bj(a, b);
        };
        Object.defineProperty(SeriesViewer.prototype, "fi", {
            get: function () {
                return this.ey;
            },
            set: function (a) {
                var b = this.ey;
                this.ey = a;
                this.ll("ActualWindowPositionHorizontal", b, this.ey);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewer.prototype, "fj", {
            get: function () {
                return this.ez;
            },
            set: function (a) {
                var b = this.ez;
                this.ez = a;
                this.ll("ActualWindowPositionVertical", b, this.ez);
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.j0 = function () {
            if (this.c4 && this.b8 != null) {
                this.b8.surfaceIsDirty = true;
                this.b8.doRefresh(false);
            }
            this.i9();
        };
        SeriesViewer.prototype.jz = function () {
            if (this.c4 && this.b8 != null) {
                this.b8.surfaceIsDirty = true;
                this.b8.doRefresh(false);
            }
            this.i9();
        };
        SeriesViewer.prototype.flush = function () {
            this.ji(true, true, true);
        };
        SeriesViewer.prototype.ji = function (a, b, c) {
            this.ap.y();
            if (a) {
                this.cf.b6();
                this.ap.y();
            }
            if (c) {
                this.al.i();
            }
            if (b) {
                this.cf.a.i();
            }
            this.es = true;
        };
        SeriesViewer.prototype.ep = function () {
            return false;
        };
        SeriesViewer.prototype.ly = function (a, b) {
            if (this.m4 != null) {
                this.me(this.m4);
                this.m4 = null;
                this.av = null;
            }
            this.m4 = a;
            this.av = this.ap.k(2, a, b);
        };
        SeriesViewer.prototype.me = function (a) {
            this.ap.ad(2, a);
            this.m4 = null;
            this.av = null;
        };
        SeriesViewer.prototype.jb = function () {
            this.ap.ac(2, this.m4, this.av, false);
        };
        SeriesViewer.prototype.kj = function () {
            var a = false;
            var b = false;
            var c = false;
            for (var d = 0; d < this.series.count; d++) {
                var e = this.series._inner[d];
                if (e.dd) {
                    a = true;
                }
                if (e.de) {
                    b = true;
                }
                if (e.c6) {
                    c = true;
                }
            }
            this.dp = a;
            this.dq = b;
            this.dm = c;
        };
        Object.defineProperty(SeriesViewer.prototype, "d1", {
            get: function () {
                return this.c4;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewer.prototype.i5 = function () {
            this.cf.bq();
            for (var a = 0; a < this.series.count; a++) {
                this.series._inner[a].la();
            }
        };
        SeriesViewer.prototype.d6 = function () {
            return this.cf.am();
        };
        SeriesViewer.prototype.gc = function () {
            var a = this.f8;
            this.f8++;
            return a;
        };
        SeriesViewer.prototype.cl = function () {
            if (this.im == null) {
                return null;
            }
            return i2.FontUtil.toFontInfo(this.cf.j.ae, this.im);
        };
        SeriesViewer.prototype.ck = function () {
            if (this.h9 == null) {
                return null;
            }
            return i2.FontUtil.toFontInfo(this.cf.j.ae, this.h9);
        };
        SeriesViewer.prototype.mh = function () {
            var a = false;
            a = this.c7;
            this.dk = true;
            this.de = (a && !this.eq) || this.p0 == 0;
            this.dk = false;
        };
        SeriesViewer.prototype.lp = function () {
            if (this.seriesDataUpdated != null) {
                this.seriesDataUpdated(this, i2.EventArgs.empty);
            }
        };
        SeriesViewer.$t = i2.markType(SeriesViewer, 'SeriesViewer', i2.Control.$, [i2.INotifyPropertyChanged_$type, i2.ILegendOwner_$type, i2.IInternalLegendOwner_$type]);
        SeriesViewer.no = i2.DependencyProperty.i("Legend", i2.IChartLegend_$type, SeriesViewer.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("Legend", b.oldValue, b.newValue);
        }));
        SeriesViewer.m6 = i2.DependencyProperty.i("AnimateSeriesWhenAxisRangeChanges", i2.Boolean_$type, SeriesViewer.$, new i2.PropertyMetadata(2, false, function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("AnimateSeriesWhenAxisRangeChanges", b.oldValue, b.newValue);
        }));
        SeriesViewer.nk = i2.DependencyProperty.i("IsWindowSyncedToVisibleRange", i2.Boolean_$type, SeriesViewer.$, new i2.PropertyMetadata(2, false, function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("IsWindowSyncedToVisibleRange", b.oldValue, b.newValue);
        }));
        SeriesViewer.n5 = i2.DependencyProperty.i("ShouldSimulateHoverMoveCrosshairPoint", i2.Boolean_$type, SeriesViewer.$, new i2.PropertyMetadata(2, false, function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("ShouldSimulateHoverMoveCrosshairPoint", b.oldValue, b.newValue);
        }));
        SeriesViewer.ng = i2.DependencyProperty.i("HighlightingMode", SeriesHighlightingMode_$type, SeriesViewer.$, new i2.PropertyMetadata(2, i2.enumGetBox(SeriesHighlightingMode_$type, 0), function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("HighlightingMode", b.oldValue, b.newValue);
        }));
        SeriesViewer.nf = i2.DependencyProperty.i("HighlightingBehavior", SeriesHighlightingBehavior_$type, SeriesViewer.$, new i2.PropertyMetadata(2, i2.enumGetBox(SeriesHighlightingBehavior_$type, 0), function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("HighlightingBehavior", b.oldValue, b.newValue);
        }));
        SeriesViewer.nl = i2.DependencyProperty.i("LegendHighlightingMode", LegendHighlightingMode_$type, SeriesViewer.$, new i2.PropertyMetadata(2, i2.enumGetBox(LegendHighlightingMode_$type, 0), function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("LegendHighlightingMode", b.oldValue, b.newValue);
        }));
        SeriesViewer.nn = i2.DependencyProperty.i("LegendItemBadgeShape", LegendItemBadgeShape_$type, SeriesViewer.$, new i2.PropertyMetadata(2, i2.enumGetBox(LegendItemBadgeShape_$type, 0), function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("LegendItemBadgeShape", b.oldValue, b.newValue);
        }));
        SeriesViewer.nm = i2.DependencyProperty.i("LegendItemBadgeMode", LegendItemBadgeMode_$type, SeriesViewer.$, new i2.PropertyMetadata(2, i2.enumGetBox(LegendItemBadgeMode_$type, 0), function (a, b) {
            var c = i2.typeCast(SeriesViewer.$, a);
            c.ll("LegendItemBadgeMode", b.oldValue, b.newValue);
        }));
        SeriesViewer.ps = i2.Rect.empty;
        SeriesViewer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, SeriesViewer, 'll', ['ActualPlotAreaBorderBrush:or:m5', [i2.Brush.$, null], 'Brushes:ag:m7', [i2.BrushCollection.$, null], 'CircleMarkerTemplate:mu:m8', [i2.DataTemplate.$, null], 'CrosshairVisibility:p0:m9', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'DefaultInteraction:b3:na', [i2.InteractionState_$type, i2.enumGetBox(i2.InteractionState_$type, 3)], 'DiamondMarkerTemplate:mv:nb', [i2.DataTemplate.$, null], 'DragModifier:on:nc', [i2.ModifierKeys_$type, i2.enumGetBox(i2.ModifierKeys_$type, 2)], 'HexagonMarkerTemplate:mw:nd', [i2.DataTemplate.$, null], 'HexagramMarkerTemplate:mx:ne', [i2.DataTemplate.$, null], 'HighlightingTransitionDuration:gd:nh', [1, 300], 'IsPagePanningAllowed:dy:ni', [0, true], 'IsSurfaceInteractionDisabled:dz:nj', [0, false], 'MarkerAutomaticBehavior:a9:np', [MarkerAutomaticBehavior_$type, i2.enumGetBox(MarkerAutomaticBehavior_$type, 4)], 'MarkerBrushes:ah:nq', [i2.BrushCollection.$, null], 'MarkerOutlines:ai:nr', [i2.BrushCollection.$, null], 'Outlines:aj:ns', [i2.BrushCollection.$, null], 'OverviewPlusDetailPaneVisibility:p1:nt', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'PanModifier:oo:nu', [i2.ModifierKeys_$type, i2.enumGetBox(i2.ModifierKeys_$type, 4)], 'PentagonMarkerTemplate:my:nv', [i2.DataTemplate.$, null], 'PentagramMarkerTemplate:mz:nw', [i2.DataTemplate.$, null], 'PlotAreaBackground:o1:nx', [i2.Brush.$, null], 'PlotAreaBorderBrush:o2:ny', [i2.Brush.$, null], 'PreferHigherResolutionTiles:ef:nz', [0, false], 'PreviewPathFill:o3:n0', [i2.Brush.$, null], 'PreviewPathOpacity:fs:n1', [1, NaN], 'PreviewPathStroke:o4:n2', [i2.Brush.$, null], 'PyramidMarkerTemplate:m0:n3', [i2.DataTemplate.$, null], 'RightButtonDefaultInteraction:b5:n4', [i2.InteractionState_$type, i2.enumGetBox(i2.InteractionState_$type, 3)], 'SquareMarkerTemplate:m1:n6', [i2.DataTemplate.$, null], 'SubtitleHorizontalAlignment:ol:n7', [i2.HorizontalAlignment_$type, i2.enumGetBox(i2.HorizontalAlignment_$type, 1)], 'Subtitle:h2:n8', [2, null], 'TetragramMarkerTemplate:m2:n9', [i2.DataTemplate.$, null], 'TitleHorizontalAlignment:om:oa', [i2.HorizontalAlignment_$type, i2.enumGetBox(i2.HorizontalAlignment_$type, 1)], 'Title:ie:ob', [2, null], 'TriangleMarkerTemplate:m3:oc', [i2.DataTemplate.$, null], 'UseTiledZooming:er:od', [0, false], 'WindowPositionHorizontal:f3:oe', [1, NaN], 'WindowPositionVertical:f4:of', [1, NaN], 'WindowRectMinWidth:f5:og', [1, 0.0001], 'WindowRect:pw:oh', [i2.Rect.$, new i2.Rect(0, 0, 0, 1, 1)], 'WindowResponse:bw:oi', [WindowResponse_$type, i2.enumGetBox(WindowResponse_$type, 1)], 'ZoomCoercionMode:b0:oj', [ZoomCoercionMode_$type, i2.enumGetBox(ZoomCoercionMode_$type, 0)], 'ZoomTileCacheSize:ge:ok', [1, 30]]);
        return SeriesViewer;
    }(i2.Control));
    /**
     * @hidden
     */
    var SeriesViewerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerView, _super);
        function SeriesViewerView(a) {
            var _this = _super.call(this) || this;
            _this.p = null;
            _this.a = null;
            _this.n = null;
            _this.o = null;
            _this.g = null;
            _this.b = null;
            _this.ai = false;
            _this.fd = null;
            _this.fc = null;
            _this.fb = null;
            _this.fa = null;
            _this.h = new SeriesViewerComponentsFromView();
            _this.j = null;
            _this.w = null;
            _this.z = null;
            _this.y = null;
            _this.x = null;
            _this.an = false;
            _this.ao = false;
            _this.bi = null;
            _this.k = null;
            _this.a9 = 0;
            _this.a8 = 0;
            _this.a7 = 0;
            _this.e6 = i2.Rect.empty;
            _this.aj = false;
            _this.a1 = 0;
            _this.az = 0;
            _this.a0 = 0;
            _this.ay = 0;
            _this.ak = true;
            _this.aa = false;
            _this.a2 = NaN;
            _this.e7 = i2.Rect.empty;
            _this.ab = false;
            _this.af = false;
            _this.ae = false;
            _this.av = false;
            _this.eq = null;
            _this.ep = null;
            _this.ad = false;
            _this.ac = false;
            _this.ag = true;
            _this.ax = null;
            _this.ar = false;
            _this.bg = 0;
            _this.ah = true;
            _this.a8 = 0;
            _this.a7 = 0;
            _this.p = a;
            _this.p.o8 = { $type: i2.Point_$type, x: NaN, y: NaN };
            _this.p.bw = 1;
            _this.j = new SeriesViewerViewManager(_this);
            _this.fa = ((function () {
                var $ret = new i2.Line();
                $ret.visibility = 1;
                return $ret;
            })());
            _this.fb = ((function () {
                var $ret = new i2.Line();
                $ret.visibility = 1;
                return $ret;
            })());
            return _this;
        }
        SeriesViewerView.prototype.l = function () {
            return new i2.DOMExecutionContext(this.j.ae);
        };
        SeriesViewerView.prototype.cl = function () {
            this.j.a9();
        };
        SeriesViewerView.prototype.c1 = function () {
            this.p.dk = true;
            this.p.p0 = 1;
            this.p.dk = false;
            this.fc = new i2.Path();
            this.fd = new i2.Rectangle();
            this.fd._visibility = 1;
            this.d3();
            this.g = new SeriesCollection();
            this.b = new AxisCollection();
            this.a = new i2.CanvasRenderScheduler();
            this.a.l(this);
            this.a.e.add(this.p.am);
            if (this.p.p1 == 0) {
                this.ck();
            }
            var a = this.p;
            a.windowRectChanged = i2.delegateCombine(a.windowRectChanged, i2.runOn(this, this.cq));
            var b = this.p;
            b.gridAreaRectChanged = i2.delegateCombine(b.gridAreaRectChanged, i2.runOn(this, this.cp));
            this.o = new OverviewPlusDetailViewportHost(this);
            this.dl();
        };
        SeriesViewerView.prototype.e = function () {
            for (var a = 0; a < this.g.count; a++) {
                if (this.g._inner[a].a4.a$c) {
                    return this.g._inner[a];
                }
            }
            return null;
        };
        SeriesViewerView.prototype.ck = function () {
            if (this.n == null) {
                this.n = this.j.g();
            }
            this.p.b8.provideContext(this.z);
            this.p.b8.provideContainer(this.bi);
            this.p.b8.provideEventSource(this.k);
            this.n.world = new i2.Rect(0, 0, 0, 1, 1);
            this.n.window = this.p.pw;
            this.n.surfaceViewer = i2.TypeRegistrar.create("SeriesViewerSurfaceViewer", this.p, this);
            this.n.viewScheduler = this.a;
            this.ej();
            var a = this.n;
            a.windowChanging = i2.delegateCombine(a.windowChanging, i2.runOn(this, this.dk));
            var b = this.n;
            b.windowChanged = i2.delegateCombine(b.windowChanged, i2.runOn(this, this.dj));
        };
        SeriesViewerView.prototype.dk = function (a, b) {
            var c = b.newValue;
            if (this.n != null) {
                c = this.n.changeRect(b.oldValue, b.newValue, this.p.d4(), this.p.d5(), this.n.world);
            }
            if (c.isEmpty) {
                this.n.window = b.oldValue;
            }
            else if (!c.equals1(b.newValue)) {
                this.n.window = c;
            }
            if (this.p.bw == 1) {
                var d = this.p.pv.width / this.p.pv.height;
                c = new i2.Rect(0, c.left / d, c.top, c.width / d, c.height);
                this.p.pw = c;
            }
        };
        SeriesViewerView.prototype.dj = function (a, b) {
            var c = b.newValue;
            if (this.n != null) {
                c = this.n.changeRect(b.oldValue, b.newValue, this.p.d4(), this.p.d5(), this.n.world);
            }
            if (c.isEmpty) {
                c = b.oldValue;
            }
            else if (!c.equals1(b.newValue)) {
                this.n.window = c;
            }
            var d = this.p.pv.width / this.p.pv.height;
            c = new i2.Rect(0, c.left / d, c.top, c.width / d, c.height);
            this.p.pw = c;
        };
        SeriesViewerView.prototype.ej = function () {
            if (this.n == null) {
                return;
            }
            if (this.p.p1 != 0) {
                return;
            }
            var a = 1;
            if (this.p.pv.isEmpty == false) {
                a = this.p.pv.width / this.p.pv.height;
            }
            var b = this.n.world;
            var c = new i2.Rect(0, 0, 0, a, 1);
            this.n.world = c;
            if (b.width != c.width || b.height != c.height || b.x != c.x || b.y != c.y) {
                this.n.surfaceViewer.isDirty = true;
            }
            this.n.window = new i2.Rect(0, this.p.pw.left * a, this.p.pw.top, this.p.pw.width * a, this.p.pw.height);
        };
        SeriesViewerView.prototype.cq = function (a, b) {
            this.ej();
        };
        SeriesViewerView.prototype.cp = function (a, b) {
            this.ej();
        };
        SeriesViewerView.prototype.b8 = function (a, b, c) {
            var e_12, _a;
            var d = true;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.p.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (d && e.et) {
                        d = false;
                        c.a.k(0, 0, a, b);
                    }
                    e.l2(new i2.Rect(0, 0, 0, a, b), c);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        };
        SeriesViewerView.prototype.d2 = function () {
            this.j.bl();
        };
        SeriesViewerView.prototype.ca = function () {
        };
        SeriesViewerView.prototype.d4 = function () {
            this.j.bm();
        };
        SeriesViewerView.prototype.ch = function () {
            for (var a = 0; a < this.p.series.count; a++) {
                this.p.series._inner[a].bx.ap();
            }
        };
        SeriesViewerView.prototype.b9 = function () {
        };
        SeriesViewerView.prototype.cb = function () {
        };
        SeriesViewerView.prototype.dv = function (a) {
            var _this = this;
            var b = this.g.indexOf(a);
            if (b >= 0) {
                this.g.removeAt(b);
            }
            if (a.isStacked) {
                a.ku(function (c) {
                    c.ca = null;
                    b = _this.g.indexOf(c);
                    if (b >= 0) {
                        _this.g.removeAt(b);
                    }
                    return true;
                });
            }
            this.p.lw();
            a.ln(null, null);
            this.c9();
        };
        SeriesViewerView.prototype.c9 = function () {
            if (this.p.destroyed) {
                return;
            }
            if (this.g.count == 0) {
                if (this.y != null && i2.Rect.l_op_Inequality(this.p.pv, null) && !this.p.pv.isEmpty) {
                    this.eo();
                }
            }
            this.p.al.o(this.y, this.x);
        };
        SeriesViewerView.prototype.eo = function () {
            if (this.y != null && i2.Rect.l_op_Inequality(this.p.pv, null) && !this.p.pv.isEmpty) {
                if (this.p.fh != 1) {
                    this.y.z();
                    this.y.aa(this.p.fh, this.p.fh);
                }
                this.y.k(this.p.pv.left, this.p.pv.top, this.p.pv.width, this.p.pv.height);
                if (this.p.fh != 1) {
                    this.y.y();
                }
            }
        };
        SeriesViewerView.prototype.aq = function (a) {
            a.li(a.bx.bu, this.e6);
            return this.g.contains(a);
        };
        Object.defineProperty(SeriesViewerView.prototype, "au", {
            get: function () {
                return this.ai;
            },
            set: function (a) {
                this.ai = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerView.prototype.bp = function (a) {
            var _this = this;
            if (!this.g.contains(a)) {
                this.g.add(a);
                if (a.isStacked) {
                    a.ku(function (b) {
                        _this.g.add(b);
                        return true;
                    });
                }
                this.p.lw();
            }
            a.ln(this.y, this.x);
            this.p.jq();
        };
        SeriesViewerView.prototype.dq = function (a) {
            this.x = a;
            for (var b = 0; b < this.g.count; b++) {
                this.g._inner[b].ln(this.y, this.x);
            }
            for (var c = 0; c < this.b.count; c++) {
                this.b._inner[c].hf(this.y, this.x);
            }
        };
        SeriesViewerView.prototype.bx = function () {
        };
        SeriesViewerView.prototype.bt = function () {
            this.cc();
            this.ch();
        };
        SeriesViewerView.prototype.cc = function () {
            this.fd._visibility = 1;
            this.cn();
        };
        SeriesViewerView.prototype.b7 = function () {
        };
        SeriesViewerView.prototype.dn = function () {
        };
        SeriesViewerView.prototype.d5 = function () {
            this.fd._visibility = 0;
            this.cn();
        };
        SeriesViewerView.prototype.ed = function (a) {
            this.fd.o = a.top + this.p.pv.top;
            this.fd.n = a.left + this.p.pv.left;
            this.fd.width = a.width;
            this.fd.height = a.height;
            this.c8();
            this.fd._fill = null;
            this.fd.ac = 0.5;
            this.cn();
        };
        SeriesViewerView.prototype.bw = function () {
        };
        SeriesViewerView.prototype.dc = function () {
        };
        SeriesViewerView.prototype.el = function (a, b, c, d) {
            this.fb.ak = a;
            this.fb.am = b;
            this.fb.al = c;
            this.fb.an = d;
            this.cn();
        };
        SeriesViewerView.prototype.ea = function () {
            this.fb._visibility = 0;
            this.cn();
        };
        SeriesViewerView.prototype.ci = function () {
            if (this.fb._visibility == 0) {
                this.fb._visibility = 1;
                this.cn();
            }
        };
        SeriesViewerView.prototype.ee = function (a, b, c, d) {
            this.fa.ak = a;
            this.fa.am = b;
            this.fa.al = c;
            this.fa.an = d;
            this.cn();
        };
        SeriesViewerView.prototype.d6 = function () {
            this.fa._visibility = 0;
            this.cn();
        };
        SeriesViewerView.prototype.cd = function () {
            if (this.fa._visibility == 0) {
                this.fa._visibility = 1;
                this.cn();
            }
        };
        SeriesViewerView.prototype.cg = function () {
            this.fc._visibility = 1;
            this.cn();
        };
        SeriesViewerView.prototype.e3 = function (a) {
            var b = new i2.PathFigureCollection();
            var c = new i2.PathFigure();
            c._isClosed = true;
            c._startPoint = { $type: i2.Point_$type, x: a.left, y: a.top };
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.left, y: a.bottom }));
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.right, y: a.bottom }));
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.right, y: a.top }));
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.left, y: a.top }));
            b.add(c);
            return b;
        };
        SeriesViewerView.prototype.e4 = function (a) {
            var b = new i2.PathFigureCollection();
            var c = new i2.PathFigure();
            c._isClosed = true;
            c._startPoint = { $type: i2.Point_$type, x: a.left, y: a.top };
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.right, y: a.top }));
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.right, y: a.bottom }));
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.left, y: a.bottom }));
            c._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: a.left, y: a.top }));
            b.add(c);
            return b;
        };
        SeriesViewerView.prototype.ek = function (a, b) {
            b.intersect(a);
            var c = new i2.PathGeometry();
            c.c = this.e4(a);
            var d = new i2.PathGeometry();
            d.c = this.e3(b);
            var e = new i2.GeometryGroup();
            e.d.add(c);
            e.d.add(d);
            this.fc.ak = e;
            this.c8();
            this.cn();
        };
        SeriesViewerView.prototype.d9 = function () {
            this.fc._visibility = 0;
            this.cn();
        };
        SeriesViewerView.prototype.em = function (a) {
        };
        SeriesViewerView.prototype.dt = function (a) {
            var b = this.b.indexOf(a);
            this.b.removeAt(b);
            a.hf(null, null);
            this.d0();
            this.p.l2(a.name, true);
        };
        SeriesViewerView.prototype.du = function (a) {
        };
        SeriesViewerView.prototype.bo = function (a) {
            if (!this.b.contains(a)) {
                this.b.add(a);
            }
            a.hf(this.y, this.x);
            this.d0();
        };
        SeriesViewerView.prototype.bl = function (a) {
        };
        SeriesViewerView.prototype.i = function () {
            this.h.a = this.n;
            return this.h;
        };
        SeriesViewerView.aw = function (a) {
            var b = a.ca.series;
            var c = new i2.List$1(Series.$, 0);
            for (var d = 0; d < b.count; d++) {
                c.add(b._inner[d]);
                if (b._inner[d].isStacked) {
                    b._inner[d].ku(function (e) {
                        c.add(e);
                        return true;
                    });
                }
            }
            return c;
        };
        SeriesViewerView.prototype.dz = function () {
            this.p.pw = new i2.Rect(0, 0, 0, 1, 1);
        };
        SeriesViewerView.prototype.cx = function (a) {
            var e_13, _a, e_14, _b;
            var _this = this;
            if (a == this.bi) {
                return;
            }
            if (a == null) {
                if (this.k != null) {
                    this.k.ar();
                }
                this.j.bf(null);
                this.w = null;
                this.z = null;
                this.y = null;
                this.x = null;
                this.k = null;
                if (this.p.b8 != null) {
                    this.p.b8.provideContext(null);
                    this.p.b8.provideContainer(null);
                    this.p.b8.provideEventSource(null);
                }
                return;
            }
            this.bi = a;
            if (this.au) {
                this.a.e.add(this.p.al);
            }
            this.j.bf(a);
            this.w = this.j.t;
            this.z = this.j.w;
            this.y = this.j.v;
            this.x = this.j.u;
            this.an = false;
            try {
                this.an = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
            }
            catch (b) {
            }
            this.ao = false;
            try {
                this.ao = (window.PointerEvent !== undefined);
            }
            catch (c) {
            }
            if (this.an || this.ao) {
                this.av = true;
            }
            this.k = this.j.f;
            if (this.k != null) {
                this.k.bg = this.p.pv;
                this.k.al = i2.runOn(this, this.as);
                var d = this.k;
                d.onContactCompleted = i2.delegateCombine(d.onContactCompleted, function (d, e) { return _this.cu(d, e, _this.k.aj); });
                var e = this.k;
                e.onContactMoved = i2.delegateCombine(e.onContactMoved, i2.runOn(this, this.cv));
                var f = this.k;
                f.onContactStarted = i2.delegateCombine(f.onContactStarted, i2.runOn(this, this.cw));
                var g = this.k;
                g.onDragCompleted = i2.delegateCombine(g.onDragCompleted, i2.runOn(this.p, this.p.kf));
                var h = this.k;
                h.onFlingStarted = i2.delegateCombine(h.onFlingStarted, i2.runOn(this, this.al));
                var i = this.k;
                i.onDragDelta = i2.delegateCombine(i.onDragDelta, function (i) { return _this.p.kg(i); });
                var j = this.k;
                j.onDragStarted = i2.delegateCombine(j.onDragStarted, function (j) { return _this.p.kh(j, true); });
                var k = this.k;
                k.onKeyDown = i2.delegateCombine(k.onKeyDown, i2.runOn(this.p, this.p.ec));
                var l = this.k;
                l.onMouseDown = i2.delegateCombine(l.onMouseDown, i2.runOn(this, this.c3));
                var m = this.k;
                m.onMouseLeave = i2.delegateCombine(m.onMouseLeave, i2.runOn(this, this.c4));
                var n = this.k;
                n.onMouseOver = i2.delegateCombine(n.onMouseOver, i2.runOn(this, this.c5));
                var o = this.k;
                o.onMouseUp = i2.delegateCombine(o.onMouseUp, i2.runOn(this, this.c6));
                var p = this.k;
                p.onMouseWheel = i2.delegateCombine(p.onMouseWheel, i2.runOn(this.p, this.p.ed));
                if (this.k.ak) {
                    var q = this.k;
                    q.onZoomDelta = i2.delegateCombine(q.onZoomDelta, function (q, r, s, t) { return _this.p.k8(q, r, s, t); });
                    var r = this.k;
                    r.onZoomStarted = i2.delegateCombine(r.onZoomStarted, function (r, s, t, u) { return _this.p.lc(r, s, t, u); });
                    var s = this.k;
                    s.onZoomCompleted = i2.delegateCombine(s.onZoomCompleted, function (s, t, u, v) { return _this.p.k7(s, t, u, v); });
                }
                else {
                    var t = this.k;
                    t.onPinchDelta = i2.delegateCombine(t.onPinchDelta, function (t, u) { return _this.p.kr(u); });
                    var u = this.k;
                    u.onPinchStarted = i2.delegateCombine(u.onPinchStarted, function (u, v) { return _this.p.ks(u); });
                    var v = this.k;
                    v.onGestureCompleted = i2.delegateCombine(v.onGestureCompleted, function (v, w) { return _this.p.ki(v); });
                }
                var w = this.k;
                w.onDoubleTap = i2.delegateCombine(w.onDoubleTap, function (w) { return _this.p.ke(w); });
                var x = this.k;
                x.onHold = i2.delegateCombine(x.onHold, i2.runOn(this, this.c0));
            }
            if (this.p.b8 != null) {
                this.p.b8.provideContext(this.z);
                this.p.b8.provideContainer(a);
                this.p.b8.provideEventSource(this.k);
            }
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.b)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var y = _d.value;
                    y.a4.aw();
                    this.bo(y);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.g)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var z = _f.value;
                    this.bp(z);
                }
            }
            catch (e_14_1) {
                e_14 = { error: e_14_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_14)
                        throw e_14.error;
                }
            }
        };
        SeriesViewerView.prototype.al = function (a, b, c) {
            if (this.p.db) {
                return false;
            }
            return true;
        };
        SeriesViewerView.prototype.cv = function (a, b) {
            this.p.j7(a, b);
        };
        SeriesViewerView.prototype.cw = function (a, b) {
            this.p.a5.f$s(this.p, a, b);
        };
        SeriesViewerView.prototype.c0 = function (a) {
            this.p.kt(a);
        };
        SeriesViewerView.prototype.cu = function (a, b, c) {
            this.p.j6(a, b, c);
        };
        SeriesViewerView.prototype.dr = function (a) {
        };
        SeriesViewerView.prototype.get_ap = function () {
            return false;
        };
        Object.defineProperty(SeriesViewerView.prototype, "ap", {
            get: function () {
                return this.get_ap();
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerView.prototype.ec = function () {
            this.a9 = i2.FontUtil.getCurrentFontHeight(this.j.ae, this.p.getFontInfo());
        };
        SeriesViewerView.prototype.f = function (a, b, c, d) {
            var _this = this;
            return {
                ret: ((function () { var e = _this.p.a5.f$c(_this.p, _this.g, _this.x, a, b, c, d); c = e.p5; return e.ret; })()),
                p2: c
            };
        };
        SeriesViewerView.prototype.bd = function () {
            return this.a8;
        };
        SeriesViewerView.prototype.bc = function () {
            return this.a7;
        };
        SeriesViewerView.prototype.cr = function () {
            this.j.bc();
        };
        SeriesViewerView.prototype.cy = function (a, b) {
            var c = this.a8;
            var d = this.a7;
            if (this.a8 != a) {
                this.aj = true;
            }
            this.a8 = a;
            if (this.a7 != b) {
                this.aj = true;
            }
            this.a7 = b;
            if (this.aj) {
                var e = new i2.Size(1, c, d);
                var f = new i2.Size(1, a, b);
                this.p.k4(e, f);
            }
            this.dg();
            this.d0();
            this.p.al.o(this.y, this.x);
        };
        SeriesViewerView.prototype.d0 = function () {
            this.ag = true;
            this.p.ap.z();
        };
        SeriesViewerView.prototype.b2 = function () {
            var e_15, _a, e_16, _b, e_17, _c, e_18, _d;
            var _this = this;
            if (this.a8 == 0 || this.a7 == 0) {
                return;
            }
            this.ag = false;
            this.aa = false;
            if (this.ak) {
                this.df();
                this.db();
                this.ak = false;
                this.cn();
            }
            var a = this.a8;
            var b = this.a7;
            var c = this.p.fq;
            var d = this.p.ft;
            var e = this.p.fm;
            var f = this.p.f2;
            var g = this.p.fk;
            var h = this.p.fl;
            if (i2.isNaN_(g)) {
                g = this.a9 / 2;
            }
            if (i2.isNaN_(h)) {
                h = 0;
            }
            var i = this.p.eh();
            var j = new i2.List$1(AxisLabelPanelBase.$, 0);
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var k = _f.value;
                    if (k.av != null) {
                        j.add(k.av);
                        k.av.bs = function () { return _this.aj; };
                    }
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_a = _e.return))
                        _a.call(_e);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
            if (i) {
                var l = false;
                var m = false;
                var n = false;
                var o = false;
                try {
                    for (var _g = tslib.__values(i2.fromEnum(j)), _h = _g.next(); !_h.done; _h = _g.next()) {
                        var p = _h.value;
                        if (LabelPanelArranger.b(p) == 2 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                            l = true;
                        }
                        if (LabelPanelArranger.b(p) == 3 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                            m = true;
                        }
                        if (LabelPanelArranger.b(p) == 0 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                            n = true;
                        }
                        if (LabelPanelArranger.b(p) == 1 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                            o = true;
                        }
                        if (p.ac != null && p.ac.ay != null) {
                            p.ac.ay.c = p.ac.ay.location;
                        }
                    }
                }
                catch (e_16_1) {
                    e_16 = { error: e_16_1 };
                }
                finally {
                    try {
                        if (_h && !_h.done && (_b = _g.return))
                            _b.call(_g);
                    }
                    finally {
                        if (e_16)
                            throw e_16.error;
                    }
                }
                if (l || m) {
                    if (!n && i2.isNaN_(f)) {
                        f = g;
                    }
                    if (!o && i2.isNaN_(e)) {
                        e = g;
                    }
                }
                if (o || n) {
                    if (!l && i2.isNaN_(c)) {
                        c = h;
                    }
                    if (!m && i2.isNaN_(d)) {
                        d = h;
                    }
                }
            }
            if (i2.isNaN_(f)) {
                f = 0;
            }
            if (i2.isNaN_(c)) {
                c = 0;
            }
            if (i2.isNaN_(d)) {
                d = 0;
            }
            if (i2.isNaN_(e)) {
                e = 0;
            }
            var q = this.bf();
            f += q;
            var r = this.be();
            f += r;
            var s = new i2.Rect(0, c, f, a - (c + d), b - (f + e));
            s = LabelPanelArranger.e(j, s);
            var t = new i2.Size(1, Math.max(0, a - (c + d)), Math.max(0, b - (f + e)));
            if (this.p.di() && s.width != s.height) {
                if (s.width < s.height) {
                    f += (s.height - s.width) / 2;
                    s.top = s.top + ((s.height - s.width) / 2);
                    t.height = t.height - (s.height - s.width);
                    s.height = s.width;
                }
                else {
                    c += (s.width - s.height) / 2;
                    s.left = s.left + ((s.width - s.height) / 2);
                    t.width = t.width - (s.width - s.height);
                    s.width = s.height;
                }
            }
            this.a1 = f - (q + r);
            this.az = c;
            this.a0 = d;
            this.ay = e;
            this.e6 = s;
            var u = ((function () {
                var $ret = new LabelPanelsArrangeState();
                $ret.f = c;
                $ret.c = c;
                $ret.a = f + t.height;
                $ret.b = f + t.height;
                $ret.g = c + t.width;
                $ret.d = c + t.width;
                $ret.h = f;
                $ret.e = f;
                return $ret;
            })());
            LabelPanelArranger.d(j, u, this.e6, function (v, w) {
                if (!v.cu.equals1(w)) {
                    if (v.ac != null) {
                        v.ac.cl = true;
                    }
                    v.cu = w;
                    v.ac.a4.ad();
                }
            });
            var v = false;
            if (this.aj) {
                this.aj = false;
                v = true;
            }
            this.p.lg(this.p.pv, this.e6);
            try {
                for (var _j = tslib.__values(i2.fromEnum(this.b)), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var w = _k.value;
                    if (i2.Rect.l_op_Equality(w.js, null) || w.js.isEmpty) {
                        this.aa = true;
                    }
                    if (w.js.equals1(this.e6) && !this.j.y()) {
                        continue;
                    }
                    w.g7(w.js, this.e6);
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_k && !_k.done && (_c = _j.return))
                        _c.call(_j);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
            try {
                for (var _l = tslib.__values(i2.fromEnum(this.g)), _m = _l.next(); !_m.done; _m = _l.next()) {
                    var x = _m.value;
                    if (i2.Rect.l_op_Equality(x.bx.bu, null) || x.bx.bu.isEmpty) {
                        this.aa = true;
                    }
                    if (x.bx.bu.equals1(this.e6) && !this.j.y()) {
                        continue;
                    }
                    x.li(x.bx.bu, this.e6);
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_m && !_m.done && (_d = _l.return))
                        _d.call(_l);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
            this.eh();
            this.ds(this.e6);
            this.j.bb(false);
        };
        SeriesViewerView.prototype.eh = function () {
            if (this.p.b8 != null && !this.e6.isEmpty) {
                var a = this.p.b8;
                var b = (this.p.c7) ? this.e6.width : Number.POSITIVE_INFINITY;
                var c = (this.p.c7) ? this.e6.height : Number.POSITIVE_INFINITY;
                var d = a.getDesiredSize(new i2.Size(1, b, c));
                this.p.b8.arrange(new i2.Rect(0, this.e6.right - d.width, this.e6.bottom - d.height, d.width, d.height));
                this.ej();
            }
        };
        SeriesViewerView.prototype.v = function () {
            var a = this.p.getFontInfo();
            var b = this.s();
            if (this.p.cl() != null) {
                a = this.p.cl();
            }
            else if (b != null) {
                a = b;
            }
            return a;
        };
        SeriesViewerView.prototype.u = function () {
            var a = this.p.getFontInfo();
            var b = this.r();
            if (this.p.ck() != null) {
                a = this.p.ck();
            }
            else if (b != null) {
                a = b;
            }
            return a;
        };
        SeriesViewerView.prototype.e2 = function () {
            var a = this.p.getFontBrush();
            var b = this.ez();
            if (this.p.o6 != null) {
                a = this.p.o6;
            }
            else if (b != null) {
                a = b;
            }
            return a;
        };
        SeriesViewerView.prototype.e1 = function () {
            var a = this.p.getFontBrush();
            var b = this.ey();
            if (this.p.o5 != null) {
                a = this.p.o5;
            }
            else if (b != null) {
                a = b;
            }
            return a;
        };
        SeriesViewerView.prototype.bf = function () {
            if (this.p.ie == null || !(i2.typeCast(XamDataChart.$, this.p) !== null)) {
                return 0;
            }
            var a = this.v();
            var b = 0;
            b = i2.FontUtil.getCurrentFontHeight(this.j.ae, a);
            var c = this.fh();
            b += c.e + c.b;
            return b;
        };
        SeriesViewerView.prototype.be = function () {
            if (this.p.h2 == null || !(i2.typeCast(XamDataChart.$, this.p) !== null)) {
                return 0;
            }
            if (!i2.isNaN_(this.a2)) {
                return this.a2;
            }
            var a = this.u();
            this.a2 = i2.FontUtil.getCurrentFontHeight(this.j.ae, a);
            var b = this.fg();
            this.a2 += b.e + b.b;
            return this.a2;
        };
        SeriesViewerView.prototype.fh = function () {
            var a = this.j.cd();
            var b = i2.isNaN_(this.p.f1) ? a.e : this.p.f1;
            var c = i2.isNaN_(this.p.fz) ? a.c : this.p.fz;
            var d = i2.isNaN_(this.p.f0) ? a.d : this.p.f0;
            var e = i2.isNaN_(this.p.fy) ? a.b : this.p.fy;
            return new i2.Thickness(1, c, b, d, e);
        };
        SeriesViewerView.prototype.fg = function () {
            var a = this.j.cc();
            var b = i2.isNaN_(this.p.fx) ? a.e : this.p.fx;
            var c = i2.isNaN_(this.p.fv) ? a.c : this.p.fv;
            var d = i2.isNaN_(this.p.fw) ? a.d : this.p.fw;
            var e = i2.isNaN_(this.p.fu) ? a.b : this.p.fu;
            return new i2.Thickness(1, c, b, d, e);
        };
        SeriesViewerView.prototype.ds = function (a) {
        };
        SeriesViewerView.prototype.cn = function () {
            if (!this.af) {
                if (this.z != null) {
                    this.af = true;
                    this.a.o(this.z, null);
                }
            }
        };
        SeriesViewerView.prototype.dx = function () {
            if (this.z == null) {
                return;
            }
            if (this.z.d) {
                if (this.p.fh != 1) {
                    this.z.z();
                    this.z.aa(this.p.fh, this.p.fh);
                }
                if (!this.e7.isEmpty) {
                    if (!this.au) {
                        this.z.k(this.e7.left, this.e7.top, this.e7.width, this.e7.height);
                    }
                }
            }
            this.dy();
            if (this.z.d) {
                if (this.p.fh != 1) {
                    this.z.y();
                }
            }
        };
        SeriesViewerView.prototype.isValid = function () {
            return true;
        };
        SeriesViewerView.prototype.preRender = function () {
            this.j.a5(this.a8, this.a7);
            this.dp();
        };
        SeriesViewerView.prototype.dp = function () {
        };
        SeriesViewerView.prototype.dy = function () {
            if (this.z.d) {
                this.e7 = new i2.Rect(0, 0, 0, this.a8, this.a7);
                if (this.ax != null && this.ax.count > 0) {
                    this.cf();
                    this.z.z();
                    this.z.ae(this.p.pv);
                    if (!this.au) {
                        this.z.k(this.p.pv.left, this.p.pv.top, this.p.pv.width, this.p.pv.height);
                    }
                }
                this.z.r(this.fa);
                this.z.r(this.fb);
                this.z.s(this.fc);
                this.z.v(this.fd);
                this.z.ac(this.v());
                if (this.eq != null) {
                    this.eq.am = this.e2();
                    this.z.w(this.eq);
                }
                this.z.ac(this.u());
                if (this.ep != null) {
                    this.ep.am = this.e1();
                    this.z.w(this.ep);
                }
                if (this.ax != null && this.ax.count > 0) {
                    this.j.bk(this.ax);
                    this.z.y();
                }
                if (this.ar) {
                    this.d8();
                    this.ar = false;
                    this.ax.clear();
                    this.p.a5.f$h(this.p);
                    this.cn();
                }
            }
        };
        SeriesViewerView.prototype.cz = function () {
            this.j.bg();
        };
        SeriesViewerView.prototype.ct = function () {
            this.j.be();
        };
        SeriesViewerView.prototype.e8 = function () {
            return new i2.Rect(0, 0, 0, this.a8, this.a7);
        };
        SeriesViewerView.prototype.e5 = function () {
            return this.j.b7();
        };
        SeriesViewerView.prototype.d3 = function () {
            this.p.mu = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.d;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.m3 = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.m;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.m0 = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.j;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.m1 = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.k;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.mv = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.e;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.my = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.h;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.mw = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.f;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.m2 = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.l;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.mz = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.i;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
            this.p.mx = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.g;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
        };
        SeriesViewerView.prototype.eb = function () {
            this.j.bo();
            this.d1();
            var a = this.a9;
            this.ec();
            if (a != this.a9) {
                this.p.jq();
            }
        };
        SeriesViewerView.prototype.dl = function () {
            if (this.p.p1 == 0) {
                this.ck();
                this.p.jm();
            }
            if (this.p.b8 != null) {
                var a = this.p.p1;
                this.p.b8.visibility = a;
                this.p.b8.doRefresh(false);
            }
        };
        SeriesViewerView.prototype.as = function (a) {
            return this.p.a5.f$f(this.p, a);
        };
        SeriesViewerView.prototype.c5 = function (a, b, c) {
            this.p.a5.f$v(this.p, this.g, this.x, a, b, c);
            this.p.i7(a, this.p.b6 != 0 || this.p.d8);
        };
        SeriesViewerView.prototype.c4 = function (a) {
            this.p.a5.f$u(this.p, a);
        };
        SeriesViewerView.prototype.c3 = function (a) {
            this.p.a5.f$t(this.p, this.k, a);
        };
        SeriesViewerView.prototype.c6 = function (a) {
            this.p.a5.f$w(this.p, this.k, a);
        };
        SeriesViewerView.prototype.d1 = function () {
        };
        Object.defineProperty(SeriesViewerView.prototype, "ew", {
            get: function () {
                return this.k.bd;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerView.prototype.en = function (a) {
            if (this.k != null) {
                this.k.bg = this.p.pv;
            }
        };
        SeriesViewerView.prototype.co = function (a) {
            this.p.a5.f$y(this.p, a);
            this.p.c7 = a;
        };
        SeriesViewerView.prototype.bk = function (a) {
            this.p.mh();
            this.j.bv(a);
            if (this.p.b8 != null) {
                this.p.b8.mobileMode = a;
            }
            this.ei();
        };
        SeriesViewerView.prototype.ei = function () {
            this.p.mo();
        };
        Object.defineProperty(SeriesViewerView.prototype, "isDirty", {
            get: function () {
                return this.af;
            },
            set: function (a) {
                this.af = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerView.prototype.undirty = function (a) {
            this.af = false;
            this.dx();
        };
        Object.defineProperty(SeriesViewerView.prototype, "index", {
            get: function () {
                return 10;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerView.prototype.postRender = function () {
        };
        SeriesViewerView.prototype.b6 = function () {
            this.d0();
        };
        SeriesViewerView.prototype.ce = function () {
            this.j.a8();
        };
        SeriesViewerView.prototype.d7 = function () {
            this.j.bn();
        };
        SeriesViewerView.prototype.bv = function (a) {
            this.j.ax();
        };
        SeriesViewerView.prototype.bm = function (a) {
            this.j.at(a);
        };
        SeriesViewerView.prototype.ef = function (a) {
            this.j.bt(a);
        };
        SeriesViewerView.prototype.eg = function (a) {
            this.j.bu(a);
        };
        SeriesViewerView.prototype.bn = function (a) {
            this.j.au(a);
        };
        SeriesViewerView.prototype.dw = function (a) {
            this.j.bj(a);
        };
        SeriesViewerView.prototype.c7 = function (a) {
            this.p.al.o(this.y, this.z);
        };
        SeriesViewerView.prototype.bu = function (a) {
        };
        SeriesViewerView.prototype.m = function (a) {
            if (this.p.c7) {
                return 2;
            }
            else {
                return 1;
            }
        };
        SeriesViewerView.prototype.c2 = function () {
            if (this.k != null) {
                this.k.ac = this.p.dz;
            }
            if (this.n != null) {
                this.n.isSurfaceInteractionDisabled = this.p.dz;
            }
        };
        SeriesViewerView.prototype.bb = function (a, b) {
            if (a == null || this.z == null) {
                return 0;
            }
            this.z.ac(b);
            return this.z.e(a);
        };
        SeriesViewerView.prototype.ba = function (a, b) {
            if (a == null) {
                return 0;
            }
            var c = 0;
            c = i2.FontUtil.getCurrentFontHeight(this.j.ae, b);
            return c;
        };
        SeriesViewerView.prototype.dg = function () {
            this.ak = true;
            this.d0();
            this.cn();
        };
        SeriesViewerView.prototype.er = function (a, b, c, d) {
            if (a == null) {
                return null;
            }
            var e = ((function () {
                var $ret = new i2.TextBlock();
                $ret.ak = a;
                $ret.o = b.e;
                return $ret;
            })());
            var f = this.bb(e, c);
            e.o = b.e;
            var g = this.ba(a, c);
            e.m = f;
            e.l = g;
            switch (d) {
                case 0:
                    e.n = b.c;
                    break;
                case 2:
                    e.n = Math.max((this.a8 - b.d) - f, b.c);
                    break;
                case 1:
                case 3:
                default:
                    var h = (this.a8 / 2) - (f / 2);
                    h += b.c;
                    h -= b.d;
                    e.n = h;
                    break;
            }
            return e;
        };
        SeriesViewerView.prototype.df = function () {
            this.eq = i2.typeCast(XamDataChart.$, this.p) !== null ? this.er(this.p.ie, this.fh(), this.v(), this.ev()) : null;
        };
        SeriesViewerView.prototype.db = function () {
            this.a2 = NaN;
            this.ep = i2.typeCast(XamDataChart.$, this.p) !== null ? this.er(this.p.h2, this.fg(), this.u(), this.eu()) : null;
            if (this.ep != null) {
                this.ep.o += this.bf();
            }
        };
        SeriesViewerView.prototype.c = function (a) {
            var b = this.j.c();
            if (b == 0) {
                var c = LabelPanelArranger.b(a.av);
                if (a.ai == null) {
                    if (c == 4) {
                        return 4;
                    }
                    if (c == 5) {
                        return 3;
                    }
                }
                else {
                    if (c == 4) {
                        return 3;
                    }
                    if (c == 5) {
                        return 4;
                    }
                }
                if (c == 0) {
                    return 3;
                }
                return 4;
            }
            return b;
        };
        SeriesViewerView.prototype.d = function (a) {
            var b = this.j.d();
            if (b == 0) {
                var c = LabelPanelArranger.b(a.av);
                if (a.ai == null) {
                    if (c == 7) {
                        return 1;
                    }
                    if (c == 6) {
                        return 2;
                    }
                }
                else {
                    if (c == 7) {
                        return 2;
                    }
                    if (c == 6) {
                        return 1;
                    }
                }
                if (c == 3) {
                    return 2;
                }
                return 1;
            }
            return b;
        };
        SeriesViewerView.prototype.dh = function () {
            if (!i2.isNaN_(this.p.fg)) {
                if (!i2.isNaN_(i2.DeviceUtils.a(this.p.fr))) {
                    this.p.fh = i2.DeviceUtils.a(this.p.fr);
                }
                else {
                    this.cl();
                }
            }
            if (!this.p.dn) {
                this.j.a4();
            }
        };
        SeriesViewerView.prototype.di = function () {
            if (!i2.isNaN_(i2.DeviceUtils.a(this.p.fg))) {
                this.p.fh = i2.DeviceUtils.a(this.p.fg);
            }
            if (!this.p.dn) {
                this.j.a3();
            }
        };
        SeriesViewerView.prototype.t = function () {
            return this.j.r();
        };
        SeriesViewerView.prototype.e0 = function () {
            return this.j.b6();
        };
        SeriesViewerView.prototype.q = function () {
            return this.j.q();
        };
        SeriesViewerView.prototype.ex = function () {
            return this.j.b5();
        };
        SeriesViewerView.prototype.s = function () {
            return this.j.p();
        };
        SeriesViewerView.prototype.r = function () {
            return this.j.o();
        };
        SeriesViewerView.prototype.ez = function () {
            return this.j.b4();
        };
        SeriesViewerView.prototype.ey = function () {
            return this.j.b3();
        };
        Object.defineProperty(SeriesViewerView.prototype, "a4", {
            get: function () {
                return this.az;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerView.prototype, "a5", {
            get: function () {
                return this.a0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerView.prototype, "a6", {
            get: function () {
                return this.a1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerView.prototype, "a3", {
            get: function () {
                return this.ay;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerView.prototype, "et", {
            get: function () {
                return this.eq;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerView.prototype, "es", {
            get: function () {
                return this.ep;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerView.prototype.e9 = function () {
            return new i2.Rect(0, 0, 0, this.a8, this.a7);
        };
        SeriesViewerView.prototype.ff = function () {
            return this.j.cf();
        };
        SeriesViewerView.prototype.fe = function () {
            return this.j.ce();
        };
        SeriesViewerView.prototype.da = function (a, b) {
            this.ac = true;
        };
        SeriesViewerView.prototype.de = function (a, b) {
            this.ad = true;
        };
        SeriesViewerView.prototype.ev = function () {
            if (this.ad) {
                return this.p.om;
            }
            else {
                var a = 1;
                switch (this.j.as()) {
                    case "left":
                        a = 0;
                        break;
                    case "right":
                        a = 2;
                        break;
                }
                return a;
            }
        };
        SeriesViewerView.prototype.eu = function () {
            if (this.ac) {
                return this.p.ol;
            }
            else {
                var a = 1;
                switch (this.j.ar()) {
                    case "left":
                        a = 0;
                        break;
                    case "right":
                        a = 2;
                        break;
                }
                return a;
            }
        };
        SeriesViewerView.prototype.bq = function () {
            if (this.ag) {
                this.b2();
                if (this.aa) {
                    this.p.ap.y();
                }
                if (this.ag) {
                    this.b2();
                }
            }
        };
        SeriesViewerView.prototype.am = function () {
            if (this.p.es) {
                return false;
            }
            if ((i2.dateNow().getTime() - this.p.ev.getTime()) < 300) {
                return true;
            }
            return false;
        };
        SeriesViewerView.prototype.b5 = function () {
            this.j.a5(this.a8, this.a7);
        };
        SeriesViewerView.prototype.cm = function () {
            this.j.ba(this.p.dy);
        };
        SeriesViewerView.prototype.at = function (a) {
            var b = this.p.pg;
            var c = b.top > 0;
            var d = b.left > 0;
            var e = b.right < 1;
            var f = b.bottom < 1;
            var g = a.y < 0;
            var h = a.y > 0;
            var i = a.x < 0;
            var j = a.x > 0;
            if (c && g) {
                return true;
            }
            if (d && i) {
                return true;
            }
            if (f && h) {
                return true;
            }
            if (j && e) {
                return true;
            }
            return false;
        };
        SeriesViewerView.prototype.dm = function () {
            this.j.bi();
            this.p.al.o(this.y, this.x);
            this.p.am.o(this.y, null);
            this.p.ak.o(this.y, this.x);
            this.a.o(this.z, null);
        };
        SeriesViewerView.prototype.b3 = function (a, b, c) {
            this.ar = false;
            if (this.ax == null) {
                this.ax = new i2.List$1(ITileZoomTile_$type, 0);
            }
            for (var d = 0; d < this.ax.count; d++) {
                while (d < this.ax.count && !a.containsKey(this.ax._inner[d].content)) {
                    this.ax.removeAt(d);
                }
            }
            for (var e = 0; e < b.count; e++) {
                this.ax.add(b._inner[e]);
            }
            this.cn();
        };
        SeriesViewerView.prototype.bh = function (a, b, c) {
            return this.j.an(a, b, c);
        };
        SeriesViewerView.prototype.b0 = function () {
            this.j.a1();
        };
        SeriesViewerView.prototype.b1 = function (a) {
            this.j.a2(a);
        };
        SeriesViewerView.prototype.cj = function () {
            if (this.ax == null) {
                return;
            }
            this.ar = true;
            this.cn();
        };
        SeriesViewerView.prototype.by = function () {
            this.j.az();
        };
        SeriesViewerView.prototype.br = function () {
            this.j.av();
        };
        SeriesViewerView.prototype.bz = function (a) {
            this.j.a0(a);
            this.p.kc();
        };
        SeriesViewerView.prototype.bs = function () {
            this.j.aw();
            this.p.ka();
        };
        SeriesViewerView.prototype.cf = function () {
            if (this.ah) {
                this.ah = false;
                this.y.k(this.p.pv.left, this.p.pv.top, this.p.pv.width, this.p.pv.height);
                this.p.al.c = true;
            }
        };
        SeriesViewerView.prototype.d8 = function () {
            if (!this.ah) {
                this.ah = true;
                this.p.al.c = false;
                this.p.al.o(this.y, this.x);
            }
        };
        SeriesViewerView.prototype.dd = function () {
        };
        SeriesViewerView.prototype.cs = function () {
            this.j.bd();
        };
        SeriesViewerView.prototype.c8 = function () {
            this.fc._fill = this.p.o3 == null ? this.j.b2() : this.p.o3;
            this.fc._opacity = i2.isNaN_(this.p.fs) ? 0.1 : this.p.fs;
            this.fd._stroke = this.p.o4 == null ? this.j.b2() : this.p.o4;
        };
        SeriesViewerView.prototype.b4 = function (a) {
            if (this.j.ae == null) {
                this.p.provideContainer(a);
            }
        };
        SeriesViewerView.prototype.bj = function (a, b) {
            return this.j.ao(a, b);
        };
        SeriesViewerView.$t = i2.markType(SeriesViewerView, 'SeriesViewerView', i2.Base.$, [i2.ISchedulableRender_$type]);
        return SeriesViewerView;
    }(i2.Base));
    /**
     * @hidden
     */
    var OverviewPlusDetailViewportHost = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OverviewPlusDetailViewportHost, _super);
        function OverviewPlusDetailViewportHost(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            if (a == null) {
                throw new i2.ArgumentNullException(0, "view");
            }
            _this.a = a;
            return _this;
        }
        OverviewPlusDetailViewportHost.prototype.getViewInfo = function (a, b) {
            a = new i2.Rect(0, 0, 0, this.a.n.worldRectViewport.width, this.a.n.worldRectViewport.height);
            b = SeriesViewer.ps;
            return {
                p0: a,
                p1: b
            };
        };
        OverviewPlusDetailViewportHost.prototype.getEffectiveViewport = function () {
            if (!this.a.p.dx) {
                if (this.a.p.pk.isEmpty) {
                    return this.a.p.pk;
                }
                return this.a.p.pp(this.a.n.previewViewportdRect, this.a.p.pv, this.a.p.pk);
            }
            return i2.Rect.empty;
        };
        OverviewPlusDetailViewportHost.$t = i2.markType(OverviewPlusDetailViewportHost, 'OverviewPlusDetailViewportHost', i2.Base.$, [IProvidesViewport_$type]);
        return OverviewPlusDetailViewportHost;
    }(i2.Base));
    /**
     * @hidden
     */
    var SeriesViewerViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerViewManager, _super);
        function SeriesViewerViewManager(a) {
            var _this = _super.call(this) || this;
            _this.ae = null;
            _this.af = null;
            _this.aj = null;
            _this.ai = null;
            _this.ag = null;
            _this.ak = null;
            _this.t = null;
            _this.w = null;
            _this.v = null;
            _this.u = null;
            _this.x = null;
            _this.f = null;
            _this.j = null;
            _this.ah = null;
            _this.ab = 0;
            _this.aa = 0;
            _this.ac = 1;
            _this.ad = 0;
            _this.l = null;
            _this.b9 = new i2.Thickness(0, 0);
            _this.aq = null;
            _this.ap = i2.stringEmpty();
            _this.b8 = new i2.Thickness(0, 0);
            _this.bz = null;
            _this.by = null;
            _this.k = null;
            _this.a = 0;
            _this.b = 0;
            _this.n = null;
            _this.b1 = null;
            _this.m = null;
            _this.b0 = null;
            _this.ca = new i2.Thickness(0, 0);
            _this.cb = new i2.Thickness(0, 0);
            _this.h = null;
            _this.z = new i2.Dictionary$2(i2.String_$type, i2.Tuple$2.$.specialize(i2.DomWrapper_$type, i2.RenderingContext.$), 0);
            _this.al = -1;
            _this.am = -1;
            _this.s = null;
            _this.j = a;
            return _this;
        }
        SeriesViewerViewManager.prototype.bi = function () {
        };
        SeriesViewerViewManager.prototype.bf = function (a) {
            if (a == null) {
                if (this.f != null) {
                    this.f.ar();
                }
                this.ae = null;
                if (this.af != null) {
                    this.af.remove();
                }
                this.af = null;
                if (this.aj != null) {
                    this.aj.remove();
                }
                this.aj = null;
                if (this.ai != null) {
                    this.ai.remove();
                }
                this.ai = null;
                if (this.ag != null) {
                    this.ag.remove();
                }
                this.ag = null;
                if (this.ak != null) {
                    this.ak.remove();
                }
                this.ak = null;
                this.t = null;
                this.w = null;
                this.v = null;
                this.u = null;
                if (this.ah != null) {
                    this.ah.remove();
                }
                this.ah = null;
                this.f = null;
                this.j.p.cg.u(null);
                this.j.p.al.j(null);
                this.j.p.am.j(null);
                this.j.p.ak.j(null);
                this.j.a.j(null);
                return;
            }
            this.ae = a;
            this.j.p.cg.u(this.ae);
            this.j.p.al.j(this.ae);
            this.j.p.am.j(this.ae);
            this.j.p.ak.j(this.ae);
            this.j.a.j(this.ae);
            this.j.p.ap.aa(this.ae);
            this.bh();
            this.ae.rootWrapper.setStyleProperty("position", "relative");
            this.af = this.ae.createElement("canvas");
            this.af.setStyleProperty("position", "absolute");
            this.af.setStyleProperty("top", "0px");
            this.af.setStyleProperty("left", "0px");
            this.aj = this.ae.createElement("canvas");
            this.aj.setStyleProperty("position", "absolute");
            this.aj.setStyleProperty("top", "0px");
            this.aj.setStyleProperty("left", "0px");
            this.ai = this.ae.createElement("canvas");
            this.ai.setStyleProperty("position", "absolute");
            this.ai.setStyleProperty("top", "0px");
            this.ai.setStyleProperty("left", "0px");
            this.ag = this.ae.createElement("canvas");
            this.ag.setStyleProperty("position", "absolute");
            this.ag.setStyleProperty("top", "0px");
            this.ag.setStyleProperty("left", "0px");
            this.ak = this.ae.createElement("canvas");
            this.ak.setStyleProperty("position", "absolute");
            this.ak.setStyleProperty("top", "0px");
            this.ak.setStyleProperty("left", "0px");
            this.ae.append(this.af);
            this.ae.append(this.ai);
            this.ae.append(this.aj);
            this.t = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.af));
            this.w = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.aj));
            this.v = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ai));
            if (this.j.p.as != 1) {
                this.u = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
                this.s = this.u;
            }
            else {
                this.u = new i2.RenderingContext(null, null);
            }
            this.x = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ak));
            this.j.dr(this.t);
            this.j.cy(this.ae.rootWrapper.width(), this.ae.rootWrapper.height());
            {
                if ((i2.TypeRegistrar.isRegistered('CanvasGestureDOMEventProxy'))) {
                    var overlayCanvas_ = this.aj;
                    var container_ = this.ae;
                    this.f = (i2.TypeRegistrar.create('CanvasGestureDOMEventProxy', overlayCanvas_, container_, false));
                }
                else {
                    this.f = null;
                }
                if (this.f != null) {
                    this.f.am = i2.runOn(this.j, this.j.at);
                }
            }
            this.ah = this.ae.createElement("div");
            this.ah.hide();
            this.ah.setStyleProperty("position", "absolute");
            this.ah.setStyleProperty("z-index", "10000");
            this.ah.addClass(this.j.p.iq);
            this.ae.append(this.ah);
        };
        SeriesViewerViewManager.bx = function (a, b) {
            b();
            return;
        };
        SeriesViewerViewManager.prototype.bh = function () {
            this.j.d1();
            this.j.ec();
            this.bo();
        };
        SeriesViewerViewManager.prototype.a9 = function () {
            var a = this.j.p.fr;
            var b = this.j.p.fh;
            if (!i2.isNaN_(a) && a != 0) {
                return;
            }
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
                this.j.p.fh = window.devicePixelRatio;
            }
        };
        SeriesViewerViewManager.prototype.g = function () {
            if ((i2.TypeRegistrar.isRegistered('XamOverviewPlusDetailPane'))) {
                var overlayCanvas_ = this.aj;
                var container_ = this.ae;
                return (i2.TypeRegistrar.create('XamOverviewPlusDetailPane'));
            }
            return null;
        };
        SeriesViewerViewManager.prototype.bl = function () {
            this.aj.setStyleProperty("cursor", "default");
        };
        SeriesViewerViewManager.prototype.bm = function () {
            this.aj.setStyleProperty("cursor", "pointer");
        };
        SeriesViewerViewManager.prototype.b2 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#000000";
                return $ret;
            })());
        };
        SeriesViewerViewManager.prototype.ay = function (a, b, c) {
            this.ab = a;
            this.aa = b;
            this.ac = c;
            var d = a;
            var e = b;
            if (c != 1) {
                d = Math.round(a * c);
                e = Math.round(b * c);
            }
            if (this.af != null) {
                this.af.setAttribute("width", d.toString());
                this.af.setAttribute("height", e.toString());
                this.af.setStyleProperty("width", a.toString() + "px");
                this.af.setStyleProperty("height", b.toString() + "px");
            }
            if (this.aj != null) {
                this.aj.setAttribute("width", d.toString());
                this.aj.setAttribute("height", e.toString());
                this.aj.setStyleProperty("width", a.toString() + "px");
                this.aj.setStyleProperty("height", b.toString() + "px");
                this.aj.setAttribute("tabindex", "0");
                this.aj.setStyleProperty("outline", "0");
            }
            if (this.ai != null) {
                this.ai.setAttribute("width", d.toString());
                this.ai.setAttribute("height", e.toString());
                this.ai.setStyleProperty("width", a.toString() + "px");
                this.ai.setStyleProperty("height", b.toString() + "px");
            }
            if (this.ag != null) {
                this.ag.setAttribute("width", d.toString());
                this.ag.setAttribute("height", e.toString());
                this.ag.setStyleProperty("width", a.toString() + "px");
                this.ag.setStyleProperty("height", b.toString() + "px");
            }
            if (this.ak != null) {
                this.ak.setAttribute("width", d.toString());
                this.ak.setAttribute("height", e.toString());
                this.ak.setStyleProperty("width", a.toString() + "px");
                this.ak.setStyleProperty("height", b.toString() + "px");
            }
            this.j.p.al.n();
            this.j.p.am.n();
            this.j.p.ak.n();
        };
        SeriesViewerViewManager.prototype.b7 = function () {
            if (this.f == null) {
                return { $type: i2.Point_$type, x: 0, y: 0 };
            }
            var a = this.f.bf(this.ae.rootWrapper);
            return { $type: i2.Point_$type, x: a.left, y: a.top };
        };
        SeriesViewerViewManager.prototype.y = function () {
            return false;
        };
        SeriesViewerViewManager.prototype.bb = function (a) {
        };
        SeriesViewerViewManager.prototype.a7 = function (a, b, c, d, e) {
            var f = this.e();
            a = f.a;
            b = f.f;
            c = f.k;
            d = f.h;
            e = f.i;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d,
                p4: e
            };
        };
        SeriesViewerViewManager.prototype.e = function () {
            var e_19, _a;
            var a = new DefaultPaletteInfo();
            a.a = new i2.BrushCollection();
            a.f = new i2.BrushCollection();
            a.b = new i2.BrushCollection();
            a.c = new i2.BrushCollection();
            var b = new i2.List$1(i2.String_$type, 0);
            b.add("background-image");
            this.ae.startCSSQuery();
            var c = this.ae.getCssDefaultValuesForClassCollection("ui-chart-fill-palette-", b.toArray());
            var d = c.length;
            var e = this.ae.getCssDefaultValuesForClassCollection("ui-chart-outline-palette-", b.toArray());
            var f = e.length;
            var g = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-fill-palette-", b.toArray());
            var h = g.length;
            var i = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-outline-palette-", b.toArray());
            var j = i.length;
            for (var k = 0; k < d; k++) {
                a.a.add(i2.CssGradientUtil.brushFromGradientString(c[k][0]));
            }
            for (var l = 0; l < f; l++) {
                a.f.add(i2.CssGradientUtil.brushFromGradientString(e[l][0]));
            }
            for (var m = 0; m < h; m++) {
                a.b.add(i2.CssGradientUtil.brushFromGradientString(g[m][0]));
            }
            for (var n = 0; n < j; n++) {
                a.c.add(i2.CssGradientUtil.brushFromGradientString(i[n][0]));
            }
            b.clear();
            var o = 0;
            var p = 0;
            var q = Math.min(d, f);
            var r = null;
            if (d == 0) {
                b.add("background-color");
            }
            if (f == 0) {
                b.add("border-top-color");
                p = d == 0 ? 1 : 0;
            }
            if (b.count > 0) {
                r = this.ae.getCssDefaultValuesForClassCollection("ui-chart-palette-", b.toArray());
                q = r.length;
            }
            if (d == 0) {
                if (q > 0) {
                    for (var s = 0; s < q; s++) {
                        var t = new i2.Brush();
                        t._fill = r[s][o];
                        a.a.add(t);
                    }
                }
                else {
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#8BDC5C";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#8961A9";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#6DB1FF";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#82E9D9";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#EA3C63";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#735656";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#F8CE4F";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#A8A8B7";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#E051A9";
                        return $ret;
                    })()));
                    a.a.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#FF903B";
                        return $ret;
                    })()));
                }
            }
            if (f == 0) {
                if (q > 0) {
                    for (var u = 0; u < q; u++) {
                        var v = new i2.Brush();
                        v._fill = r[u][p];
                        a.f.add(v);
                    }
                }
                else {
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#8BDC5C";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#8961A9";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#6DB1FF";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#82E9D9";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#EA3C63";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#735656";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#F8CE4F";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#A8A8B7";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#E051A9";
                        return $ret;
                    })()));
                    a.f.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#FF903B";
                        return $ret;
                    })()));
                }
            }
            b.clear();
            var w = Math.min(h, j);
            if (h == 0) {
                b.add("background-color");
            }
            if (j == 0) {
                b.add("border-top-color");
                p = h == 0 ? 1 : 0;
            }
            if (b.count > 0) {
                r = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-palette-", b.toArray());
                w = r.length;
            }
            if (h == 0) {
                if (w > 0) {
                    var _loop_1 = function (x) {
                        var y = ((function () {
                            var $ret = new i2.Brush();
                            $ret.fill = r[x][o];
                            return $ret;
                        })());
                        a.b.add(y);
                    };
                    for (var x = 0; x < w; x++) {
                        _loop_1(x);
                    }
                }
                else {
                    a.b.add(((function () {
                        var $ret = new i2.Brush();
                        $ret.fill = "#FFFFFF";
                        return $ret;
                    })()));
                }
            }
            if (j == 0) {
                if (w > 0) {
                    var _loop_2 = function (z) {
                        var aa = ((function () {
                            var $ret = new i2.Brush();
                            $ret.fill = r[z][p];
                            return $ret;
                        })());
                        a.c.add(aa);
                    };
                    for (var z = 0; z < w; z++) {
                        _loop_2(z);
                    }
                }
                else {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(a.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var ab = _c.value;
                            a.c.add(ab);
                        }
                    }
                    catch (e_19_1) {
                        e_19 = { error: e_19_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_19)
                                throw e_19.error;
                        }
                    }
                }
            }
            var ac = this.ae.getCssDefaultPropertyValue("ui-chart-axis", "border-top-color");
            if (ac != null) {
                a.i = new i2.Brush();
                a.i._fill = ac;
            }
            else {
                a.i = AxisDefaults.g;
            }
            a.k = new i2.Brush();
            a.k._fill = this.ae.getCssDefaultPropertyValue("", "color");
            a.j = Defaults.ae;
            var ad = this.ae.getCssDefaultPropertyValue("ui-chart-crosshair", "border-top-color");
            if (ad != null) {
                a.j = new i2.Brush();
                a.j._fill = ad;
            }
            this.ae.endCSSQuery();
            a.h = i2.FontUtil.getFont(this.ae);
            var ae = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#ee5879";
                return $ret;
            })());
            a.d = new i2.BrushCollection();
            a.d.add(ae);
            a.e = new i2.BrushCollection();
            a.e.add(ae);
            return a;
        };
        SeriesViewerViewManager.prototype.a6 = function (a, b, c, d, e, f) {
            this.ae.startCSSQuery();
            var g = this.ae.getCssDefaultPropertyValue("ui-chart-area-fill-opacity", "opacity");
            a = g != null ? parseFloat(g) : 1;
            b = new Array(4);
            var h = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-top");
            var i = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-right");
            var j = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-bottom");
            var k = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-left");
            b[0] = h != null ? parseFloat(h) : NaN;
            b[1] = i != null ? parseFloat(i) : NaN;
            b[2] = j != null ? parseFloat(j) : NaN;
            b[3] = k != null ? parseFloat(k) : NaN;
            c = d = null;
            var l = this.ae.getCssDefaultPropertyValue("ui-chart-axis-stroke", "border-top-color");
            if (l != null) {
                var m = new i2.Brush();
                m._fill = l;
                c = m;
            }
            var n = this.ae.getCssDefaultPropertyValue("ui-chart-axis-major-line", "border-top-color");
            if (n != null) {
                var o = new i2.Brush();
                o._fill = n;
                d = o;
            }
            var p = this.ae.getCssDefaultPropertyValue("ui-chart-aligned-gridlines", "visibility");
            f = p != null && p == "visible";
            var q = this.ae.getCssDefaultPropertyValue("ui-chart-category-axis-tick", "height");
            if (q != null) {
                e = parseFloat(q);
                if (Math.abs(e) > 4000) {
                    e = 0;
                }
            }
            else {
                q = this.ae.getCssDefaultPropertyValue("ui-chart-category-axis-tick", "width");
                e = q != null ? parseFloat(q) : 0;
            }
            this.ae.endCSSQuery();
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d,
                p4: e,
                p5: f
            };
        };
        SeriesViewerViewManager.prototype.ax = function () {
            this.ah.removeChildren();
        };
        SeriesViewerViewManager.prototype.bt = function (x_) {
            var box_ = this.ah;
            var offset_ = this.f.bf(this.ah);
            var a = this.b7();
            x_ = a.x + this.j.p.pv.left + x_;
            box_.setOffset(x_, this.j.p.pv.top + this.ad + a.y);
        };
        SeriesViewerViewManager.prototype.bu = function (y_) {
            this.ad = y_;
            var box_ = this.ah;
            var offset_ = this.ah.getOffset();
            var a = this.b7();
            y_ = this.j.p.pv.top + this.ad + a.y;
            box_.setOffset(offset_.left, y_);
        };
        SeriesViewerViewManager.prototype.at = function (a) {
            var b = a;
            b.show();
            this.ah.append(b);
        };
        SeriesViewerViewManager.prototype.a8 = function () {
            this.ah.hide();
        };
        SeriesViewerViewManager.prototype.bn = function () {
            this.ah.show();
        };
        SeriesViewerViewManager.prototype.au = function (a) {
            this.ae.appendToBody(a);
        };
        SeriesViewerViewManager.prototype.bj = function (a) {
            a.remove();
        };
        SeriesViewerViewManager.prototype.bc = function () {
            if (this.ae == null) {
                return;
            }
            this.a9();
            this.j.cy(this.ae.rootWrapper.width(), this.ae.rootWrapper.height());
        };
        SeriesViewerViewManager.prototype.p = function () {
            return this.l;
        };
        SeriesViewerViewManager.prototype.cd = function () {
            return this.b9;
        };
        SeriesViewerViewManager.prototype.as = function () {
            return this.aq;
        };
        SeriesViewerViewManager.prototype.ar = function () {
            return this.ap;
        };
        SeriesViewerViewManager.prototype.cc = function () {
            return this.b8;
        };
        SeriesViewerViewManager.prototype.b4 = function () {
            return this.bz;
        };
        SeriesViewerViewManager.prototype.b3 = function () {
            return this.by;
        };
        SeriesViewerViewManager.prototype.o = function () {
            return this.k;
        };
        SeriesViewerViewManager.prototype.c = function () {
            return this.a;
        };
        SeriesViewerViewManager.prototype.d = function () {
            return this.b;
        };
        SeriesViewerViewManager.prototype.r = function () {
            return this.n;
        };
        SeriesViewerViewManager.prototype.b6 = function () {
            return this.b1;
        };
        SeriesViewerViewManager.prototype.q = function () {
            return this.m;
        };
        SeriesViewerViewManager.prototype.b5 = function () {
            return this.b0;
        };
        SeriesViewerViewManager.prototype.ce = function () {
            return this.ca;
        };
        SeriesViewerViewManager.prototype.cf = function () {
            return this.cb;
        };
        SeriesViewerViewManager.prototype.bo = function () {
            this.ae.startCSSQuery();
            this.bq();
            this.bp();
            this.bs();
            this.br();
            this.bw();
            this.ae.endCSSQuery();
        };
        SeriesViewerViewManager.prototype.bw = function () {
            var a = "ui-chart-pointer-tooltip";
            var b = this.ae.getCssDefaultPropertyValue(a, "background-color");
            var c = this.ae.getCssDefaultPropertyValue(a, "border-top-color");
            var d = this.ae.getCssDefaultPropertyValue(a, "border-top-left-radius");
            var e = this.ae.getCssDefaultPropertyValue(a, "border-top-width");
            var f = new PointerTooltipStyle();
            f.a = d != null ? parseFloat(d) : 0;
            f.c = b != null ? i2.Brush.create(b) : ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "white";
                return $ret;
            })());
            f.d = c != null ? i2.Brush.create(c) : ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "gray";
                return $ret;
            })());
            f.b = e != null ? parseFloat(e) : 0;
            this.h = f;
        };
        SeriesViewerViewManager.prototype.bq = function () {
            var _this = this;
            var a = "ui-chart-title";
            this.l = i2.FontUtil.getFontForClass(this.ae, a);
            this.bz = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
                return $ret;
            })());
            this.aq = this.ae.getCssDefaultPropertyValue(a, "text-align");
            if (this.aq == null) {
                this.aq = "center";
            }
            var b = this.ae.getCssDefaultPropertyValue(a, "margin-top");
            var c = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
            var d = this.ae.getCssDefaultPropertyValue(a, "margin-left");
            var e = this.ae.getCssDefaultPropertyValue(a, "margin-right");
            var f = b != null ? parseFloat(b) : 0;
            var g = c != null ? parseFloat(c) : 0;
            var h = d != null ? parseFloat(d) : 0;
            var i = e != null ? parseFloat(e) : 0;
            this.b9 = new i2.Thickness(1, h, f, i, g);
        };
        SeriesViewerViewManager.prototype.bp = function () {
            var _this = this;
            var a = "ui-chart-subtitle";
            this.k = i2.FontUtil.getFontForClass(this.ae, a);
            this.by = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
                return $ret;
            })());
            this.ap = this.ae.getCssDefaultPropertyValue(a, "text-align");
            if (this.ap == null) {
                this.ap = "center";
            }
            var b = this.ae.getCssDefaultPropertyValue(a, "margin-top");
            var c = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
            var d = this.ae.getCssDefaultPropertyValue(a, "margin-left");
            var e = this.ae.getCssDefaultPropertyValue(a, "margin-right");
            var f = b != null ? parseFloat(b) : 0;
            var g = c != null ? parseFloat(c) : 0;
            var h = d != null ? parseFloat(d) : 0;
            var i = e != null ? parseFloat(e) : 0;
            this.b8 = new i2.Thickness(1, h, f, i, g);
        };
        SeriesViewerViewManager.prototype.br = function () {
            var _this = this;
            var a = "ui-chart-horizontal-axis-title";
            this.m = i2.FontUtil.getFontForClass(this.ae, a);
            this.b0 = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
                return $ret;
            })());
            var b = this.ae.getCssDefaultPropertyValue(a, "vertical-align");
            if (b == null) {
                this.a = 0;
            }
            else if (b.toLowerCase() == "bottom") {
                this.a = 4;
            }
            else {
                this.a = 3;
            }
            var c = this.ae.getCssDefaultPropertyValue(a, "margin-top");
            var d = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
            var e = this.ae.getCssDefaultPropertyValue(a, "margin-left");
            var f = this.ae.getCssDefaultPropertyValue(a, "margin-right");
            var g = c != null ? parseFloat(c) : 2;
            var h = d != null ? parseFloat(d) : 2;
            var i = e != null ? parseFloat(e) : 2;
            var j = f != null ? parseFloat(f) : 2;
            this.ca = new i2.Thickness(1, i, g, j, h);
        };
        SeriesViewerViewManager.prototype.bs = function () {
            var _this = this;
            var a = "ui-chart-vertical-axis-title";
            this.n = i2.FontUtil.getFontForClass(this.ae, a);
            this.b1 = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
                return $ret;
            })());
            var b = this.ae.getCssDefaultPropertyValue(a, "text-align");
            if (b == null) {
                this.b = 0;
            }
            else if (b.toLowerCase() == "right") {
                this.b = 2;
            }
            else {
                this.b = 1;
            }
            var c = this.ae.getCssDefaultPropertyValue(a, "margin-top");
            var d = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
            var e = this.ae.getCssDefaultPropertyValue(a, "margin-left");
            var f = this.ae.getCssDefaultPropertyValue(a, "margin-right");
            var g = c != null ? parseFloat(c) : 0;
            var h = d != null ? parseFloat(d) : 0;
            var i = e != null ? parseFloat(e) : 0;
            var j = f != null ? parseFloat(f) : 0;
            this.cb = new i2.Thickness(1, i, g, j, h);
        };
        SeriesViewerViewManager.prototype.a5 = function (a, b) {
            var c = this.j.p.fh;
            if (a != this.ab || b != this.aa || c != this.ac) {
                this.ay(a, b, this.j.p.fh);
                this.j.p.al.i();
                this.j.a.i();
            }
        };
        SeriesViewerViewManager.prototype.i = function () {
            return this.h;
        };
        SeriesViewerViewManager.prototype.ba = function (a) {
            if (this.f == null) {
                return;
            }
            this.f.aa = a;
            this.f.am = i2.runOn(this.j, this.j.at);
        };
        SeriesViewerViewManager.prototype.an = function (a, b, c) {
            var _this = this;
            var d;
            if (!((function () { var e = _this.z.tryGetValue(b.iD.toString(), d); d = e.p1; return e.ret; })())) {
                var e = this.ae.createElement("canvas");
                e.setAttribute("width", c.toString());
                e.setAttribute("height", c.toString());
                e.setStyleProperty("width", c.toString() + "px");
                e.setStyleProperty("height", c.toString() + "px");
                var f = this.ae.get2DCanvasContext(e);
                var g = new i2.RenderingContext(new i2.CanvasViewRenderer(), f);
                var h = new i2.Tuple$2(i2.DomWrapper_$type, i2.RenderingContext.$, e, g);
                d = h;
                this.z.addItem(b.iD.toString(), d);
            }
            var i = new i2.Rect(0, 0, 0, c, c);
            var j = new RenderSurface();
            j.a = d.d;
            for (var k = 0; k < this.j.p.series.count; k++) {
                var l = this.j.p.series._inner[k];
                l.lz(i, a, j, "tile", 1);
            }
            this.j.p.ak.i();
            return d.c;
        };
        SeriesViewerViewManager.prototype.a2 = function (a) {
            this.z.removeItem(a.iD.toString());
        };
        SeriesViewerViewManager.prototype.a1 = function () {
            this.z.clear();
        };
        SeriesViewerViewManager.prototype.bk = function (a) {
            for (var b = 0; b < a.count; b++) {
                var c = a._inner[b];
                var d = c.content;
                this.j.z.m(d.getNativeElement(), 1, c.xPosition + this.j.p.pv.left, c.yPosition + this.j.p.pv.top, c.width, c.height);
            }
        };
        SeriesViewerViewManager.prototype.az = function () {
            var _this = this;
            if (this.al != -1) {
                this.av();
            }
            if (this.ae != null) {
                this.al = this.ae.setTimeout(function () { return _this.j.p.a5.f$i(_this.j.p); }, 5000);
            }
            else {
                this.al = window.setTimeout(function () { return _this.j.p.a5.f$i(_this.j.p); }, 5000);
            }
        };
        SeriesViewerViewManager.prototype.av = function () {
            if (this.al != -1) {
                if (this.ae != null) {
                    this.ae.clearTimeout(this.al);
                }
                else {
                    window.clearTimeout(this.al);
                }
                this.al = -1;
            }
        };
        SeriesViewerViewManager.prototype.a0 = function (a) {
            var _this = this;
            if (this.am != -1) {
                this.aw();
            }
            if (this.ae != null) {
                this.am = this.ae.setTimeout(function () { return _this.j.p.je(); }, a);
            }
            else {
                this.am = window.setTimeout(function () { return _this.j.p.je(); }, a);
            }
        };
        SeriesViewerViewManager.prototype.aw = function () {
            if (this.am != -1) {
                if (this.ae != null) {
                    this.ae.clearTimeout(this.am);
                }
                else {
                    window.clearTimeout(this.am);
                }
                this.am = -1;
            }
        };
        SeriesViewerViewManager.prototype.bd = function () {
            if (this.j.p.as != 1) {
                if (this.s == null) {
                    this.u = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
                    this.s = this.u;
                }
                else {
                    this.u = this.s;
                }
            }
            else {
                this.u = new i2.RenderingContext(null, null);
            }
            this.j.dq(this.u);
        };
        SeriesViewerViewManager.prototype.bv = function (a) {
            if (this.ae != null) {
                var b = "igTouch";
                if (a) {
                    this.ae.rootWrapper.addClass(b);
                }
                else {
                    this.ae.rootWrapper.removeClass(b);
                }
            }
        };
        SeriesViewerViewManager.prototype.a3 = function () {
        };
        SeriesViewerViewManager.prototype.a4 = function () {
        };
        SeriesViewerViewManager.prototype.bg = function () {
            if (this.f != null) {
                this.f.bc(this.aj, "");
            }
        };
        SeriesViewerViewManager.prototype.be = function () {
            this.a9();
            if (this.f != null) {
                this.f.aq(this.aj, "");
            }
        };
        SeriesViewerViewManager.prototype.ao = function (a, b) {
            var c = this.ae.createElement("canvas");
            c.setStyleProperty("width", a + "px");
            c.setStyleProperty("height", b + "px");
            c.setProperty("width", a);
            c.setProperty("height", b);
            var d = this.ae.get2DCanvasContext(c);
            if (this.t != null) {
                d.drawImage(this.af.getNativeElement(), 0, 0, a, b);
            }
            if (this.v != null) {
                d.drawImage(this.ai.getNativeElement(), 0, 0, a, b);
            }
            if (this.w != null) {
                d.drawImage(this.aj.getNativeElement(), 0, 0, a, b);
            }
            var e = this.ae.createElement("img");
            var sCanv_ = c.getNativeElement();
            e.setProperty("src", sCanv_.toDataURL('image/png'));
            return e.getNativeElement();
        };
        SeriesViewerViewManager.$t = i2.markType(SeriesViewerViewManager, 'SeriesViewerViewManager');
        return SeriesViewerViewManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var AutoRangeCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AutoRangeCalculator, _super);
        function AutoRangeCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AutoRangeCalculator.a = function (a, b, c, d, e, f, g) {
            f = !i2.isNaN_(b) && !i2.isInfinity(b) ? b : Number.POSITIVE_INFINITY;
            g = !i2.isNaN_(c) && !i2.isInfinity(c) ? c : Number.NEGATIVE_INFINITY;
            var h = f;
            var i = g;
            if (i2.isInfinity(h) || i2.isInfinity(i)) {
                if (a != null) {
                    var j = a.j2();
                    if (j != null) {
                        h = Math.min(h, j.c);
                        i = Math.max(i, j.b);
                    }
                }
            }
            if (!i2.isInfinity(h) && !i2.isInfinity(i)) {
                if (h == i && h != 0) {
                    h *= h > 0 ? 0.9 : 1.1;
                    i *= i > 0 ? 1.1 : 0.9;
                }
                if (h == i && h == 0) {
                    i = 1;
                }
                if (b > c) {
                    var k = c;
                    c = b;
                    b = k;
                }
                var l = i2.isNaN_(b) || i2.isInfinity(b) ? h : b;
                var m = i2.isNaN_(c) || i2.isInfinity(c) ? i : c;
                if (d) {
                    if (l <= 0) {
                        if (m > 1) {
                            l = 1;
                        }
                        else {
                            l = Math.pow(e, Math.floor(i2.logBase(m, e)));
                        }
                    }
                    if (i2.isNaN_(b) || i2.isInfinity(b)) {
                        var n = i2.logBase(l, e);
                        h = Math.pow(e, Math.floor(n));
                    }
                    else {
                        h = l;
                    }
                    if (i2.isNaN_(c) || i2.isInfinity(c)) {
                        i = Math.pow(e, Math.ceil(i2.logBase(m, e)));
                    }
                    else {
                        i = m;
                    }
                }
                else {
                    var o = Math.pow(10, Math.floor(i2.log10(m - l)) - 1);
                    var p = a.d7();
                    if (a != null && p > 0 && (!a.kj && !a.ki)) {
                        var q = new LinearNumericSnapper(0, h, i, p, a.el());
                        o = q.g;
                    }
                    if ((i2.isNaN_(b) || i2.isInfinity(b)) && !i2.isNaN_(h) && !i2.isNaN_(o) && o != 0) {
                        {
                            h = o * Math.floor(h / o);
                        }
                    }
                    else {
                        h = l;
                    }
                    if ((i2.isNaN_(c) || i2.isInfinity(c)) && !i2.isNaN_(i) && !i2.isNaN_(o) && o != 0) {
                        var r = Math.ceil(i / o);
                        {
                            i = o * r;
                        }
                    }
                    else {
                        i = m;
                    }
                }
            }
            f = h;
            g = i;
            return {
                p5: f,
                p6: g
            };
        };
        AutoRangeCalculator.$t = i2.markType(AutoRangeCalculator, 'AutoRangeCalculator');
        return AutoRangeCalculator;
    }(i2.Base));
    /**
     * @hidden
     */
    var IAxisAnnotationManager_$type = new i2.Type(null, 'IAxisAnnotationManager');
    /**
     * @hidden
     */
    var AxisLabelSettings = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelSettings, _super);
        function AxisLabelSettings() {
            var _this = _super.call(this) || this;
            _this.aa = null;
            _this.ax = null;
            _this.b = 1;
            _this.a2 = 0;
            _this.h = true;
            _this.c = 0;
            _this.a = null;
            _this.m = 0;
            _this.o = NaN;
            _this.p = 2;
            _this.q = 2;
            _this.r = 2;
            _this.n = 2;
            _this.au = 0;
            _this.az = 1;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.f = null;
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.aq(a, b.propertyName, b.oldValue, b.newValue); });
            return _this;
        }
        Object.defineProperty(AxisLabelSettings.prototype, "textStyle", {
            get: function () {
                return this.aa;
            },
            set: function (a) {
                var b = this.aa;
                this.aa = a;
                this.ar("TextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "textColor", {
            get: function () {
                return this.ax;
            },
            set: function (a) {
                var b = this.ax;
                this.ax = a;
                this.ar("TextColor", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "location", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                this.ar("Location", i2.enumGetBox(AxisLabelsLocation_$type, b), i2.enumGetBox(AxisLabelsLocation_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "visibility", {
            get: function () {
                return this.a2;
            },
            set: function (a) {
                var b = this.a2;
                this.a2 = a;
                this.ar("Visibility", i2.enumGetBox(i2.Visibility_$type, b), i2.enumGetBox(i2.Visibility_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "showFirstLabel", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.h;
                this.h = a;
                this.ar("ShowFirstLabel", b, a);
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelSettings.prototype.registerAxis = function (a) {
            this.a = a;
        };
        AxisLabelSettings.prototype.unregisterAxis = function (a) {
            this.a = null;
        };
        Object.defineProperty(AxisLabelSettings.prototype, "angle", {
            get: function () {
                return this.m;
            },
            set: function (a) {
                var b = this.m;
                this.m = a;
                this.ar("Angle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "extent", {
            get: function () {
                return this.o;
            },
            set: function (a) {
                var b = this.o;
                this.o = a;
                this.ar("Extent", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "margin", {
            set: function (a) {
                this.leftMargin = a;
                this.bottomMargin = a;
                this.rightMargin = a;
                this.topMargin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "leftMargin", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                var b = this.p;
                this.p = a;
                this.ar("LeftMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "rightMargin", {
            get: function () {
                return this.q;
            },
            set: function (a) {
                var b = this.q;
                this.q = a;
                this.ar("RightMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "topMargin", {
            get: function () {
                return this.r;
            },
            set: function (a) {
                var b = this.r;
                this.r = a;
                this.ar("TopMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "bottomMargin", {
            get: function () {
                return this.n;
            },
            set: function (a) {
                var b = this.n;
                this.n = a;
                this.ar("BottomMargin", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "horizontalAlignment", {
            get: function () {
                return this.au;
            },
            set: function (a) {
                var b = this.au;
                this.au = a;
                this.ar("HorizontalAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelSettings.prototype, "verticalAlignment", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                var b = this.az;
                this.az = a;
                this.ar("VerticalAlignment", i2.enumGetBox(i2.VerticalAlignment_$type, b), i2.enumGetBox(i2.VerticalAlignment_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelSettings.prototype.ar = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        AxisLabelSettings.prototype.aq = function (a, b, c, d) {
            switch (b) {
                case "Location":
                    this.c = this.location;
                    break;
            }
            if (this.a == null || this.a.bf == null) {
                return;
            }
            switch (b) {
                case "Angle":
                    this.a.ck = true;
                    this.a.hp();
                    break;
                case "TextStyle":
                    this.f = null;
                    this.a.ck = true;
                    if (this.a.bh != null) {
                        this.a.bh.jq();
                    }
                    this.a.hp();
                    break;
                case "Location":
                case "Extent":
                case "Visibility":
                case "HorizontalAlignment":
                case "VerticalAlignment":
                case "TopMargin":
                case "RightMargin":
                case "BottomMargin":
                case "LeftMargin":
                case "ShowFirstLabel":
                    this.a.ck = true;
                    if (this.a.bh != null) {
                        this.a.bh.jq();
                    }
                    this.a.hp();
                    break;
                case "TextColor":
                    this.a.hp();
                    break;
            }
        };
        AxisLabelSettings.prototype.j = function () {
            return this.m != 0;
        };
        AxisLabelSettings.prototype.k = function () {
            return !i2.isNaN_(this.o);
        };
        Object.defineProperty(AxisLabelSettings.prototype, "i", {
            get: function () {
                return this.textStyle != null;
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelSettings.prototype.g = function (a) {
            if (this.f == null) {
                this.f = i2.FontUtil.toFontInfo(a, this.textStyle);
            }
            return this.f;
        };
        AxisLabelSettings.$t = i2.markType(AxisLabelSettings, 'AxisLabelSettings', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        AxisLabelSettings.extentPropertyDefault = NaN;
        return AxisLabelSettings;
    }(i2.Base));
    /**
     * @hidden
     */
    var TitleSettings = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TitleSettings, _super);
        function TitleSettings() {
            var _this = _super.call(this) || this;
            _this.a4 = 0;
            _this.horizontalAlignment = 1;
            _this.leftMargin = NaN;
            _this.rightMargin = NaN;
            _this.topMargin = NaN;
            _this.bottomMargin = NaN;
            return _this;
        }
        Object.defineProperty(TitleSettings.prototype, "position", {
            get: function () {
                return this.a4;
            },
            set: function (a) {
                var b = this.a4;
                this.a4 = a;
                this.ar("AxisTitlePosition", i2.enumGetBox(AxisTitlePosition_$type, b), i2.enumGetBox(AxisTitlePosition_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        TitleSettings.prototype.aq = function (a, b, c, d) {
            _super.prototype.aq.call(this, a, b, c, d);
            if (this.a == null || this.a.bh == null) {
                return;
            }
            switch (b) {
                case "AxisTitlePosition":
                    this.a.ck = true;
                    this.a.hp();
                    break;
            }
        };
        TitleSettings.$t = i2.markType(TitleSettings, 'TitleSettings', AxisLabelSettings.$);
        return TitleSettings;
    }(AxisLabelSettings));
    /**
     * @hidden
     */
    var Axis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Axis, _super);
        function Axis() {
            var _this = _super.call(this) || this;
            _this.a4 = null;
            _this.bs = null;
            _this.a8 = null;
            _this.a6 = null;
            _this.h5 = null;
            _this.bm = null;
            _this.bg = null;
            _this.br = null;
            _this.bw = false;
            _this.dd = NaN;
            _this.c8 = 50;
            _this.dj = 0;
            _this.dg = 150;
            _this.ar = 0;
            _this.dc = NaN;
            _this.dn = 0;
            _this.di = 0;
            _this.df = 180;
            _this.bj = null;
            _this.bi = null;
            _this.fm = "Verdana";
            _this.de = NaN;
            _this.dq = 0;
            _this.dk = 8;
            _this.dh = 16;
            _this.e7 = -1;
            _this.e6 = 1;
            _this.e5 = 3;
            _this.e8 = 0;
            _this.jy = 0;
            _this.dm = 0;
            _this.dl = 2;
            _this.h6 = null;
            _this.dr = 0;
            _this.cd = false;
            _this.cp = false;
            _this.cr = false;
            _this.rangeChanged = null;
            _this.ak = new AxisAnnotationCollection();
            _this.al = new AxisAnnotationCollection();
            _this.jl = i2.Rect.empty;
            _this.jr = null;
            _this.c5 = null;
            _this.c6 = null;
            _this.av = null;
            _this.bv = false;
            _this.a5 = null;
            _this.e4 = null;
            _this.ah = null;
            _this._coercionMethods = null;
            _this.bu = false;
            _this.cs = false;
            _this.c0 = false;
            _this.renderRequested = null;
            _this.bb = null;
            _this.cl = false;
            _this.da = NaN;
            _this.db = -1;
            _this.cm = false;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.c7 = null;
            _this.c3 = new i2.Dictionary$2(i2.String_$type, i2.String_$type, 0);
            _this.c2 = new i2.Dictionary$2(i2.String_$type, i2.FastReflectionHelper.$, 0);
            _this.jx = new i2.Size();
            _this.ao = new AxisComponentsForView();
            _this.du = 0;
            _this.c9 = 0;
            _this.bq = null;
            _this.bp = null;
            _this.bo = null;
            _this.aw = new AxisLabelSettings();
            _this.e3 = null;
            i2.DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
            i2.DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
            _this.du = NaN;
            _this.a4 = _this.a3();
            _this.ha(_this.a4);
            _this.a4.ag();
            _this.bq = ((function () {
                var $ret = new i2.Pool$1(i2.TextBlock.$);
                $ret.create = i2.runOn(_this.a4, _this.a4.ax);
                $ret.activate = i2.runOn(_this.a4, _this.a4.aq);
                $ret.disactivate = i2.runOn(_this.a4, _this.a4.as);
                $ret.destroy = i2.runOn(_this.a4, _this.a4.ar);
                return $ret;
            })());
            _this.bp = ((function () {
                var $ret = new i2.Pool$1(i2.TextBlock.$);
                $ret.create = i2.runOn(_this.a4, _this.a4.ax);
                $ret.activate = i2.runOn(_this.a4, _this.a4.aq);
                $ret.disactivate = i2.runOn(_this.a4, _this.a4.as);
                $ret.destroy = i2.runOn(_this.a4, _this.a4.ar);
                return $ret;
            })());
            _this.bo = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this.a4, _this.a4.bc);
                $ret.activate = i2.runOn(_this.a4, _this.a4.p);
                $ret.disactivate = i2.runOn(_this.a4, _this.a4.r);
                $ret.destroy = i2.runOn(_this.a4, _this.a4.q);
                return $ret;
            })());
            _this.jr = i2.Rect.empty;
            _this.c5 = new i2.List$1(i2.Base.$, 0);
            _this.c6 = new i2.List$1(LabelPosition.$, 0);
            _this.av = _this.au();
            _this.av.af = _this.ay;
            _this.av.ac = _this;
            _this.c7 = new i2.List$1(Series.$, 0);
            var a = _this.ak;
            a.collectionResetting = i2.delegateCombine(a.collectionResetting, i2.runOn(_this, _this.gu));
            var b = _this.ak;
            b.collectionChanged = i2.delegateCombine(b.collectionChanged, i2.runOn(_this, _this.gt));
            var c = _this.al;
            c.collectionResetting = i2.delegateCombine(c.collectionResetting, i2.runOn(_this, _this.gw));
            var d = _this.al;
            d.collectionChanged = i2.delegateCombine(d.collectionChanged, i2.runOn(_this, _this.gv));
            _this.ab = Axis.$;
            if (_this.ay != null) {
                _this.aw = _this.ay;
            }
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (e, f) { return _this.he(e, f.propertyName, f.oldValue, f.newValue); });
            _this.br = function (e, f) {
                if (_this.bh == null || !_this.bh.dl) {
                    _this.h4(f.oldRect, f.newRect);
                }
            };
            _this.a4.v();
            return _this;
        }
        Axis.prototype.a3 = function () {
            return new AxisView(this);
        };
        Axis.prototype.ha = function (a) {
        };
        Axis.prototype.gx = function () {
            if (this.b5) {
                this.a7.onAddAnnotations(this);
            }
        };
        Object.defineProperty(Axis.prototype, "bt", {
            get: function () {
                if (this.bs == null) {
                    this.bs = new i2.SRProvider(this.e4);
                }
                if (this.bs.l == null) {
                    this.bs.l = this.e4;
                }
                return this.bs;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "a9", {
            get: function () {
                var _this = this;
                if (this.a8 == null) {
                    this.a8 = i2.DVContainer.instance.createInstance(IAxisVisualDataManager_$type, function () { return _this.bt.q; });
                }
                return this.a8;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.d7 = function () {
            return this.js.width;
        };
        Axis.prototype.fl = function () {
            return null;
        };
        Axis.prototype.fk = function () {
            return null;
        };
        Axis.prototype.get_b6 = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "b6", {
            get: function () {
                return this.get_b6();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_ce = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "ce", {
            get: function () {
                return this.get_ce();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_b4 = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "b4", {
            get: function () {
                return this.get_b4();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_cg = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "cg", {
            get: function () {
                return this.get_cg();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_cj = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "cj", {
            get: function () {
                return this.get_cj();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_ch = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "ch", {
            get: function () {
                return this.get_ch();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_b9 = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "b9", {
            get: function () {
                return this.get_b9();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_cf = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "cf", {
            get: function () {
                return this.get_cf();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_b7 = function () {
            return false;
        };
        Object.defineProperty(Axis.prototype, "b7", {
            get: function () {
                return this.get_b7();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_b8 = function () {
            return true;
        };
        Object.defineProperty(Axis.prototype, "b8", {
            get: function () {
                return this.get_b8();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.aj = function () {
            return this.ai;
        };
        Object.defineProperty(Axis.prototype, "a7", {
            get: function () {
                var _this = this;
                if (this.a6 == null) {
                    this.a6 = i2.DVContainer.instance.createInstance(IAxisAnnotationManager_$type, function () { return _this.bt.n; });
                    this.a6.owner = this;
                }
                return this.a6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "b5", {
            get: function () {
                return i2.DVContainer.instance.checkLoaded("AnnotationFactoryManager");
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.gv = function (a, b) {
            if (!this.b5) {
                return;
            }
            this.a7.onAutoAnnotionsChanged(this, this.al, b);
        };
        Axis.prototype.gw = function (a, b) {
            if (!this.b5) {
                return;
            }
            this.a7.onAutoAnnotionsReset(this, this.al, b);
        };
        Axis.prototype.gt = function (a, b) {
            if (!this.b5) {
                return;
            }
            this.a7.onAnnotionsChanged(this, this.ak, b);
        };
        Axis.prototype.gu = function (a, b) {
            if (!this.b5) {
                return;
            }
            this.a7.onAnnotionsReset(this, this.ak, b);
        };
        Axis.prototype.provideRenderer = function (a) {
            this.e4 = a;
            this.gy();
            this.av.af = this.ay;
        };
        Axis.prototype.g7 = function (a, b) {
            if (!a.equals1(b)) {
                this.h3(a, b);
            }
        };
        Axis.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.a4.aj();
        };
        Object.defineProperty(Axis.prototype, "bn", {
            get: function () {
                return this.bm;
            },
            set: function (a) {
                if (this.bn != a) {
                    var b = this.bn;
                    this.bm = a;
                    this.hk("FastItemsSourceProvider", b, this.bm);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "bh", {
            get: function () {
                return this.bg;
            },
            set: function (a) {
                if (this.bh != a) {
                    var b = this.bh;
                    this.bg = a;
                    this.hk("SeriesViewer", b, this.bg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "bf", {
            get: function () {
                return i2.typeCast(XamDataChart.$, this.bh);
            },
            set: function (a) {
                this.bh = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "cz", {
            get: function () {
                return this.bw;
            },
            set: function (a) {
                if (this.bw == a) {
                    return;
                }
                this.bw = a;
                var b = null;
                if (this.av != null && i2.Rect.l_op_Inequality(this.av.cu, null)) {
                    b = this.av.cu;
                }
                this.av = this.au();
                this.av.ac = this;
                this.av.af = this.ay;
                if (i2.Rect.l_op_Inequality(b, null)) {
                    this.av.cu = b;
                }
                if (this.bh != null && this.bh.cf != null) {
                    this.av.ae.ak(this.bh.cf.y);
                    this.ho(true);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "ep", {
            get: function () {
                return this.dd;
            },
            set: function (a) {
                var b = this.dd;
                if (b != a) {
                    this.dd = a;
                    this.dp = a;
                    this.ho(true);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "dp", {
            get: function () {
                return this.c8;
            },
            set: function (a) {
                this.c8 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "ev", {
            get: function () {
                return this.dj;
            },
            set: function (a) {
                this.dj = a;
                this.ho(true);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "es", {
            get: function () {
                return this.dg;
            },
            set: function (a) {
                this.dg = a;
                this.ho(true);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "as", {
            get: function () {
                return this.ar;
            },
            set: function (a) {
                var b = this.ar;
                if (b != a) {
                    this.ar = a;
                    this.ho(true);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "eo", {
            get: function () {
                return this.dc;
            },
            set: function (a) {
                this.dc = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "eu", {
            get: function () {
                return this.di;
            },
            set: function (a) {
                this.di = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "er", {
            get: function () {
                return this.df;
            },
            set: function (a) {
                this.df = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "bl", {
            get: function () {
                if (this.bj == null) {
                    if (this.bi == null) {
                        this.bi = this.a4.i();
                    }
                    return this.bi;
                }
                return this.bj;
            },
            set: function (a) {
                this.bj = a;
                this.de = i2.FontUtil.getFontSize(this.bj);
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "gg", {
            get: function () {
                return this.fm;
            },
            set: function (a) {
                this.fm = a;
                var b = this.de;
                if (i2.isNaN_(b)) {
                    b = 12;
                }
                this.bl.n = a;
                this.bl.d = b;
                this.av.b3();
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "eq", {
            get: function () {
                return this.de;
            },
            set: function (a) {
                this.de = a;
                this.bl = i2.FontUtil.getFontWithNewFontSize(this.bl, this.de);
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "ew", {
            get: function () {
                return this.dk;
            },
            set: function (a) {
                this.dk = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "et", {
            get: function () {
                return this.dh;
            },
            set: function (a) {
                this.dh = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "fc", {
            get: function () {
                return this.e7;
            },
            set: function (a) {
                this.e7 = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "fb", {
            get: function () {
                return this.e6;
            },
            set: function (a) {
                this.e6 = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "fa", {
            get: function () {
                return this.e5;
            },
            set: function (a) {
                this.e5 = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "j1", {
            get: function () {
                return this.jy;
            },
            set: function (a) {
                this.jy = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "ey", {
            get: function () {
                return this.dm;
            },
            set: function (a) {
                this.dm = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "ex", {
            get: function () {
                return this.dl;
            },
            set: function (a) {
                this.dl = a;
                this.hn();
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.hw = function () {
            this.av.cj();
        };
        Axis.prototype.hn = function () {
            this.ho(false);
        };
        Axis.prototype.ho = function (a) {
            if (a) {
                this.av.ci();
            }
            this.ck = true;
            this.hm();
        };
        Axis.prototype.hz = function () {
            if (this.e0 > 0) {
                this.dr = this.e0;
                return;
            }
            var a = i2.typeCast(XamDataChart.$, this.bh);
            if (a != null && i2.isNaN_(this.e0) && this.b6 && (this.cj || this.a1 == 0)) {
                this.dr = a.p9.fl;
                return;
            }
            this.dr = 0;
        };
        Object.defineProperty(Axis.prototype, "cy", {
            get: function () {
                return this.c(Axis.i5);
            },
            set: function (a) {
                this.h(Axis.i5, a);
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.dw = function () {
            return 0;
        };
        Axis.prototype.i6 = function () {
            if (this.cj) {
                return 2;
            }
            return 0;
        };
        Axis.prototype.jz = function () {
            return 1;
        };
        Axis.prototype.i7 = function () {
            return 1;
        };
        Axis.prototype.j0 = function () {
            return 1;
        };
        Axis.prototype.dy = function () {
            if (this.cj) {
                return i2.DeviceUtils.g(5);
            }
            return 0;
        };
        Axis.prototype.d0 = function () {
            if (!this.cj && !this.b4) {
                return i2.DeviceUtils.g(5);
            }
            return 0;
        };
        Axis.prototype.dz = function () {
            if (this.cj) {
                return i2.DeviceUtils.g(5);
            }
            return 0;
        };
        Axis.prototype.dx = function () {
            if (!this.cj && !this.b4) {
                return i2.DeviceUtils.g(5);
            }
            return 0;
        };
        Axis.prototype.d3 = function () {
            return NaN;
        };
        Axis.prototype.d5 = function () {
            return NaN;
        };
        Axis.prototype.d4 = function () {
            return NaN;
        };
        Axis.prototype.d2 = function () {
            return NaN;
        };
        Axis.prototype.az = function () {
            if (this.cj) {
                return 2;
            }
            if (this.cg) {
                return 5;
            }
            return 1;
        };
        Axis.prototype.a0 = function () {
            return 1;
        };
        Axis.prototype.hl = function (a) {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, a);
            }
        };
        Axis.prototype.d1 = function () {
            if (this.cj) {
                return -90;
            }
            return 0;
        };
        Axis.prototype.dv = function () {
            return NaN;
        };
        Object.defineProperty(Axis.prototype, "am", {
            get: function () {
                return this.ak;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "an", {
            get: function () {
                return this.al;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "js", {
            get: function () {
                if (this.jr.isEmpty) {
                    return this.jl;
                }
                return this.jr;
            },
            set: function (a) {
                this.jl = a;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.h0 = function () {
            var a = 0;
            var b = i2.typeCast(XamDataChart.$, this.bh);
            if (b != null && b.p6 == 0) {
                a = 1;
            }
            this.a4.av(a);
        };
        Axis.prototype.c1 = function (a, b, c) {
            return this.bh != null;
        };
        Axis.prototype.ci = function () {
            var a = i2.Rect.empty;
            if (this.bh != null) {
                a = this.bh.pw;
            }
            return this.c1(this.js, a, this.a4);
        };
        Axis.prototype.h3 = function (a, b) {
            this.cl = false;
            this.js = b;
            this.ck = true;
            this.cv();
            this.hq(false);
            if (this.bh != null) {
                this.bh.ap.ae(1, this, this.a5, b);
            }
        };
        Object.defineProperty(Axis.prototype, "ck", {
            get: function () {
                return this.bv;
            },
            set: function (a) {
                this.bv = a;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.jp = function () {
            if (this.bh == null || this.bh.pk.isEmpty) {
                return i2.Rect.empty;
            }
            var a = this.bh.pk;
            var b = this.js;
            var c = (a.left - b.left) / b.width;
            var d = (a.top - b.top) / b.height;
            var e = (a.right - b.left) / b.width;
            var f = (a.bottom - b.top) / b.height;
            return new i2.Rect(0, c, d, e - c, f - d);
        };
        Axis.prototype.h4 = function (a, b) {
            this.ck = true;
            this.hq(true);
        };
        Axis.prototype.hm = function () {
            this.hq(false);
        };
        Axis.prototype.he = function (a, b, c, d) {
            var e_20, _a;
            switch (b) {
                case Axis.$$p[10]:
                case Axis.$$p[11]:
                    if (this.fz != null) {
                        this.ah = new i2.BindingFormatter();
                        this.ah.j = this.fz;
                        this.ah.d = this.ag;
                    }
                    else {
                        this.ah = null;
                    }
                    break;
                case "SeriesViewer":
                    var e = i2.typeCast(SeriesViewer.$, c);
                    if (e != null) {
                        this.e4 = null;
                        e.actualWindowRectChanged = i2.delegateRemove(e.actualWindowRectChanged, this.br);
                        e.ap.ad(1, this);
                        this.a4.aa(e);
                    }
                    var f = i2.typeCast(SeriesViewer.$, d);
                    if (f != null) {
                        this.e4 = f.cf.j.ae;
                        f.actualWindowRectChanged = i2.delegateCombine(f.actualWindowRectChanged, this.br);
                        this.a5 = f.ap.k(1, this, i2.runOn(this, this.g2));
                        if (this.ay == null && this.e4 != null) {
                            this.provideRenderer(this.e4);
                        }
                        this.a4.u(f);
                        if (this.cm && !this.a5.e) {
                            this.cm = false;
                            this.cv();
                        }
                        this.hy();
                        this.hz();
                    }
                    break;
                case Axis.$$p[8]:
                    this.hq(false);
                    break;
                case Axis.$$p[21]:
                    this.cr = this.cq;
                    this.hq(false);
                    break;
                case Axis.$$p[20]:
                    this.cp = this.co;
                    this.hq(false);
                    break;
                case Axis.$$p[9]:
                    this.cd = this.cc;
                    var g = new AxisRangeChangedEventArgs(0, 0, 0, 1, 1);
                    this.g1(g);
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.c7)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var h = _c.value;
                            h.ky();
                            if (h.ca != null) {
                                h.k7();
                            }
                        }
                    }
                    catch (e_20_1) {
                        e_20 = { error: e_20_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_20)
                                throw e_20.error;
                        }
                    }
                    break;
                case Axis.$$p[12]:
                    this.a4.ah();
                    if (i2.typeCast(i2.DataTemplate.$, d) !== null) {
                        this.c0 = true;
                    }
                    else {
                        this.c0 = false;
                    }
                    this.ck = true;
                    this.ht();
                    this.hq(false);
                    break;
                case Axis.$$p[16]:
                case Axis.$$p[19]:
                case Axis.$$p[25]:
                    this.hq(false);
                    break;
                case Axis.$$p[13]:
                    var i = i2.typeCast(AxisLabelSettings.$, d);
                    if (i != null) {
                        i.registerAxis(this);
                        this.aw = i;
                    }
                    else {
                        this.aw = new AxisLabelSettings();
                    }
                    if (this.av != null) {
                        this.av.af = this.aw;
                    }
                    this.hc();
                    this.ck = true;
                    this.hq(false);
                    break;
                case Axis.$$p[30]:
                    this.a4.ak();
                    break;
                case Axis.$$p[31]:
                    var j = i2.typeCast(TitleSettings.$, d);
                    if (j != null) {
                        j.registerAxis(this);
                    }
                    else {
                        j = new TitleSettings();
                    }
                    if (this.h6 != null) {
                        this.h6.dataContext = j;
                    }
                    this.hd();
                    this.hq(false);
                    break;
                case Axis.$$p[26]:
                    this.ck = true;
                    this.hz();
                    this.a4.ad();
                    this.hq(false);
                    break;
                case Axis.$$p[5]:
                case "UseEnhancedIntervalManagement":
                case Axis.$$p[6]:
                    this.ck = true;
                    this.hq(false);
                    break;
                case Axis.$$p[3]:
                    if (this.bh != null) {
                        this.bh.jq();
                    }
                    break;
                case Axis.$$p[18]:
                    this.hy();
                    if (d != null) {
                        this.cs = true;
                        this.hq(false);
                    }
                    else {
                        this.cs = false;
                    }
                    break;
                case Axis.$$p[4]:
                    if (this.ai != null) {
                        this.ai.hp();
                    }
                    break;
                case Axis.$$p[24]:
                case Axis.$$p[15]:
                    this.hy();
                    this.hq(false);
                    break;
                case Axis.$$p[23]:
                case Axis.$$p[14]:
                case Axis.$$p[17]:
                case Axis.$$p[7]:
                case Axis.$$p[28]:
                case Axis.$$p[29]:
                case Axis.$$p[27]:
                case Axis.$$p[2]:
                case Axis.$$p[0]:
                case Axis.$$p[1]:
                case Axis.$$p[22]:
                    this.hq(false);
                    break;
                case "MinExtent":
                    this.a4.ad();
                    break;
            }
        };
        Axis.prototype.hc = function () {
            if (this.a4.m()) {
                this.a4.w(this.aw);
            }
        };
        Axis.prototype.hd = function () {
            this.a4.ak();
        };
        Object.defineProperty(Axis.prototype, "coercionMethods", {
            get: function () {
                return this._coercionMethods;
            },
            set: function (a) {
                this._coercionMethods = a;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.get_expectFunctions = function () {
            return this.bu;
        };
        Axis.prototype.set_expectFunctions = function (a) {
            this.bu = a;
        };
        Object.defineProperty(Axis.prototype, "expectFunctions", {
            get: function () {
                return this.get_expectFunctions();
            },
            set: function (a) {
                this.set_expectFunctions(a);
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.ht = function () {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            if (this.a4.m()) {
                this.a4.an();
            }
        };
        Axis.prototype.g9 = function (a, b, c, d) {
            var e = Math.min(b, c);
            var f = Math.max(b, c);
            if (e < d.bottom && f > d.top) {
                var g = new i2.RectangleGeometry();
                g.e = new i2.Rect(0, d.left, e, d.width, f - e);
                a.add(g);
            }
        };
        Axis.prototype.g8 = function (a, b, c, d, e) {
            var f = b <= c.bottom && b >= c.top;
            if (!e && f) {
                f = !this.cb(b, d.c, c, false);
            }
            if (f) {
                if (d.a) {
                    b = this.ds(b, c.top, c.bottom, d);
                }
                var g = new i2.LineGeometry();
                g.d = { $type: i2.Point_$type, x: c.left, y: b };
                g.c = { $type: i2.Point_$type, x: c.right, y: b };
                a.add(g);
            }
        };
        Axis.prototype.h2 = function (a, b, c, d) {
            var e = Math.min(b, c);
            var f = Math.max(b, c);
            if (f > d.left && e < d.right) {
                var g = new i2.RectangleGeometry();
                g.e = new i2.Rect(0, e, d.top, f - e, d.height);
                a.add(g);
            }
        };
        Axis.prototype.h1 = function (a, b, c, d, e) {
            var f = b >= c.left && b <= c.right;
            if (!f) {
                var g = i2.truncate(Math.round(b));
                var h = i2.truncate(Math.round(c.left));
                var i = i2.truncate(Math.round(c.right));
                if (g >= h && g <= i) {
                    f = true;
                }
            }
            if (!e && f) {
                f = !this.cb(b, d.c, c, true);
            }
            if (f) {
                if (d.a) {
                    b = this.ds(b, c.left, c.right, d);
                }
                var j = new i2.LineGeometry();
                j.d = { $type: i2.Point_$type, x: b, y: c.top };
                j.c = { $type: i2.Point_$type, x: b, y: c.bottom };
                a.add(j);
            }
        };
        Axis.prototype.cb = function (a, b, c, d) {
            var e_21, _a;
            var e = false;
            var f = i2.typeCast(XamDataChart.$, this.bh);
            if (f != null && f.qo && !c.isEmpty) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(f.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var g = _c.value;
                        if (g._visibility != 0 || g.ez < 1 || g.ja == null || i2.BrushUtilCore.a(g.ja) || g.js.isEmpty) {
                            continue;
                        }
                        if (g.ai != null && g.b1()) {
                            var h = this.cj ? c.left : c.top;
                            var i = 0;
                            var j = g.hv(h, i, g.bh.pw, c, g.jn(), d ? c.left : c.top, d ? c.right : c.bottom);
                            h = j.p0;
                            i = j.p1;
                            var k = i2.Rect.empty;
                            var l = i2.Rect.empty;
                            if (d && g.cj) {
                                k = new i2.Rect(0, h - (g.ez / 2), g.js.top, g.ez, g.js.height);
                                l = new i2.Rect(0, a - (b / 2), c.top, b, c.height);
                            }
                            else if (!d && !g.cj) {
                                k = new i2.Rect(0, g.js.left, h - (g.ez / 2), g.js.width, g.ez);
                                l = new i2.Rect(0, c.left, a - (b / 2), c.width, b);
                            }
                            if (k.left <= l.right && l.left <= k.right && k.top <= l.bottom && l.top <= k.bottom) {
                                e = true;
                                break;
                            }
                        }
                        else {
                            var m = i2.Rect.empty;
                            var n = i2.Rect.empty;
                            if (d && g.cj) {
                                m = new i2.Rect(0, g.js.left, g.js.top, g.ez, g.js.height);
                                n = new i2.Rect(0, a - (b / 2), c.top, b, c.height);
                            }
                            else if (!d && !g.cj) {
                                m = new i2.Rect(0, g.js.left, g.js.bottom - (g.ez / 2), g.js.width, g.ez);
                                n = new i2.Rect(0, c.left, a - (b / 2), c.width, b);
                            }
                            if (m.left <= n.right && n.left <= m.right && m.top <= n.bottom && n.top <= m.bottom) {
                                e = true;
                                break;
                            }
                        }
                    }
                }
                catch (e_21_1) {
                    e_21 = { error: e_21_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_21)
                            throw e_21.error;
                    }
                }
            }
            return e;
        };
        Axis.prototype.hv = function (a, b, c, d, e, f, g) {
            var h = Math.abs(f - g);
            a = this.fe;
            a = this.ai.en(a);
            var i = i2.typeCast(CategoryAxisBase.$, this.ai);
            if (i != null && i.categoryMode == 2) {
                var j = 0.5 * i.getCategorySize(c, d, e);
                var k = i.a1 == 0;
                if (i.cc == k) {
                    j = -j;
                }
                a = a + j;
            }
            b = a - f;
            if (a < f) {
                a = f;
            }
            else if (a > g) {
                a = g;
            }
            if (b < 0) {
                b = 0;
            }
            else if (b > h) {
                b = h;
            }
            return {
                p0: a,
                p1: b
            };
        };
        Axis.prototype.ds = function (a, b, c, d) {
            var e = a;
            if (d != null && d.c > 0) {
                var f = d.c % 2;
                if (f == 0 || f == 1) {
                    var g = 1;
                    e = Math.floor(a);
                    if (e + 0.5 < a) {
                        g = -1;
                        e = Math.ceil(a);
                    }
                    if (f == 1) {
                        e += 0.5 * g;
                    }
                    if (e >= c) {
                        e -= 1;
                    }
                    else if (e <= b) {
                        e += 1;
                    }
                }
            }
            return e;
        };
        Axis.prototype.g0 = function (a) {
            this.a4.z(a);
        };
        Axis.prototype.gz = function () {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            this.a4.x();
            this.c5.clear();
            this.c6.clear();
        };
        Axis.prototype.hp = function () {
            this.hq(false);
        };
        Axis.prototype.hq = function (a) {
            if (this.bh != null) {
                this.bh.ap.ac(1, this, this.a5, a);
                if (this.renderRequested != null) {
                    var b = new RenderRequestedEventArgs();
                    b.animate = a;
                    this.renderRequested(this, b);
                    a = b.animate;
                }
            }
        };
        Axis.prototype.em = function () {
            if (this.bb == null) {
                return -1;
            }
            if (i2.isNaN_(this.bb.b)) {
                return -1;
            }
            if (this.ay != null && (this.ay.angle != 0)) {
                return -1;
            }
            return Math.max(Axis.eh, this.bb.b);
        };
        Axis.prototype.ek = function () {
            if (this.bb == null) {
                return -1;
            }
            if (i2.isNaN_(this.bb.d) && i2.isNaN_(this.da)) {
                return -1;
            }
            if (this.ay != null && (this.ay.angle != 0)) {
                return -1;
            }
            var a = this.bb.d;
            if (!i2.isNaN_(this.da) && this.e9 == -1) {
                return this.da;
            }
            return Math.max(Axis.eh, this.bb.d);
        };
        Axis.prototype.ct = function (a, b, c, d) {
            if (this.b6 && this.by && this.b2()) {
                if (a > 1) {
                    var e = a - 1;
                    if (e < 1) {
                        return false;
                    }
                    var f = this.d6(e, b, c, d);
                    if (i2.isNaN_(f)) {
                        return false;
                    }
                    if (f > this.da) {
                        return true;
                    }
                }
            }
            return false;
        };
        Axis.prototype.d6 = function (a, b, c, d) {
            return NaN;
        };
        Axis.prototype.el = function () {
            if (this.cj) {
                return this.em();
            }
            else {
                return this.ek();
            }
        };
        Object.defineProperty(Axis.prototype, "cu", {
            get: function () {
                return this.e9 == -1;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.g2 = function (a) {
            if (this.a4.l()) {
                return;
            }
            var b = 0;
            var c = 0;
            if (this.c6 != null && this.c6.count > 0) {
                b = this.c6._inner[this.c6.count - 1].c;
                c = this.c6.count;
            }
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            this.hr(a);
            if (!this.cj && this.ck && this.cy && this.cu) {
                if (this.bz()) {
                    this.hr(a);
                }
            }
            var d = 1;
            var e = 0;
            if (this.c6 != null && this.c6.count > 0) {
                d = this.c6._inner[this.c6.count - 1].c;
                e = this.c6.count;
            }
            if (this.cz) {
                this.ck = true;
            }
            var f = false;
            if (d != b || e != c || this.ck) {
                this.ck = false;
                if (this.a4.m()) {
                    this.a4.ad();
                    f = true;
                }
            }
            this.a4.ac();
            if (!f) {
                this.g3();
            }
        };
        Axis.prototype.bz = function () {
            if (!i2.isNaN_(this.da) || this.c5 == null || this.c5.count == 0) {
                return false;
            }
            var a = this.bk();
            if (a == null) {
                return false;
            }
            var b = -1.7976931348623157E+308;
            for (var c = 0; c < this.c5.count; c++) {
                var d = this.c5._inner[c];
                if (typeof d === 'string') {
                    var e = i2.FontUtil.measureStringWidth(d, a, this.a4.j);
                    b = Math.max(e, b);
                }
            }
            b += 5;
            if (this.ay != null) {
                b += this.ay.leftMargin + this.ay.rightMargin;
            }
            this.da = b;
            return true;
        };
        Axis.prototype.hs = function () {
            this.da = NaN;
            this.hq(false);
        };
        Axis.prototype.b2 = function () {
            return !i2.isNaN_(this.da) && this.e9 == -1;
        };
        Axis.prototype.dt = function (a, b) {
            return a;
        };
        Axis.prototype.hu = function () {
            this.da = NaN;
        };
        Axis.prototype.ba = function () {
            var a = this.bk();
            if (a == null) {
                return null;
            }
            var b = "W";
            if (this.a4.j == null) {
                return null;
            }
            var c = i2.FontUtil.measureStringWidth(b, a, this.a4.j);
            if (this.db != c || this.bb == null) {
                this.db = c;
                var d = i2.FontUtil.getCurrentFontHeight(this.bh.cf.j.ae, a);
                if (this.bb == null) {
                    this.bb = new LabelFontHeuristics();
                }
                this.bb.b = d;
                this.bb.c = this.e9;
                this.bb.a = this.by;
                this.bb.e = c;
                this.bb.d = this.bb.e * this.bb.c;
            }
            return this.bb;
        };
        Axis.prototype.bk = function () {
            var a = null;
            if (this.bh != null) {
                a = this.bh.getFontInfo();
            }
            if (this.ay != null && this.ay.i) {
                if (this.bh != null) {
                    a = this.ay.g(this.bh.cf.j.ae);
                }
            }
            return a;
        };
        Axis.prototype.g3 = function () {
            if (!this.a4.m()) {
                return;
            }
            if (!this.b3()) {
                this.a4.ab();
            }
        };
        Axis.prototype.cv = function () {
            return this.cw(false);
        };
        Axis.prototype.cw = function (a) {
            if (a || this.bh == null) {
                var b = this.cx();
                if (b) {
                    this.ck = true;
                }
                this.cm = false;
                return b;
            }
            if (!this.cm) {
                this.cm = true;
                this.bh.ap.ab(this, this.a5);
            }
            return false;
        };
        Axis.prototype.cx = function () {
            return false;
        };
        Axis.prototype.hr = function (a) {
            if (this.h6 != null) {
                if ((this.be == null || this.be.visibility == 0) && (this.ay == null || this.ay.visibility == 0) && this.gp != null) {
                    this.h6._visibility = 0;
                }
                else {
                    this.h6._visibility = 1;
                }
            }
        };
        Axis.prototype.hy = function () {
            var e_22, _a, e_23, _b;
            var a = i2.typeCast(XamDataChart.$, this.bh);
            if (a == null) {
                return;
            }
            var b = null, c = null, d = null;
            if (this.b6 && !this.b4) {
                b = a.s3;
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.c7)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var e = _d.value;
                        if (e.d6 || e.d4 || e.d0 || e.d4) {
                            c = a.s1;
                            d = a.s2;
                            break;
                        }
                    }
                }
                catch (e_22_1) {
                    e_22 = { error: e_22_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_22)
                            throw e_22.error;
                    }
                }
            }
            else if (this.ce && !this.b4) {
                c = a.s1;
                d = a.s2;
                b = this.ai != null ? a.s3 : null;
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.c7)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var f = _f.value;
                        if (f.d6 || f.d4 || f.d0 || f.d4) {
                            b = a.s3;
                            break;
                        }
                    }
                }
                catch (e_23_1) {
                    e_23 = { error: e_23_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_23)
                            throw e_23.error;
                    }
                }
            }
            else if (this.b4 || this.a1 == 3) {
                b = a.s3;
                c = a.s1;
                d = a.s2;
            }
            this.ja = this.je != null ? this.je : b;
            this.i8 = this.jb != null ? this.jb : c;
            this.i9 = this.jc != null ? this.jc : d;
        };
        Axis.prototype.hk = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        Axis.prototype.cn = function (a) {
            var b = this.c7.contains(a);
            if (!b) {
                this.c7.add(a);
            }
            this.hy();
            return !b;
        };
        Axis.prototype.bx = function (a) {
            var b = this.c7.contains(a);
            if (b) {
                this.c7.remove(a);
            }
            this.hy();
            return b;
        };
        Axis.prototype.fg = function (a, b) {
            var c = this.gb(b);
            if (c == Axis.$$p[12]) {
                return this.fh(a, b, this.fj);
            }
            return null;
        };
        Axis.prototype.gb = function (a) {
            if (!this.c3.containsKey(a)) {
                var b = a.charAt(0).toUpperCase() + a.substr(1);
                this.c3.addItem(a, b);
            }
            return this.c3.item(a);
        };
        Axis.prototype.fh = function (a, b, c) {
            var d = null;
            if (!this.c2.containsKey(b)) {
                d = new i2.FastReflectionHelper(false, c);
                this.c2.addItem(b, d);
            }
            else {
                d = this.c2.item(b);
            }
            d.propertyName = c;
            return d.getPropertyValue(a);
        };
        Axis.prototype.fi = function (a) {
            return this.a4.n(a);
        };
        Axis.prototype.fw = function (a) {
            return this.a4.o(a);
        };
        Axis.prototype.ej = function () {
            return NaN;
        };
        Axis.prototype.d8 = function (a, b) {
            return 0;
        };
        Axis.prototype.d9 = function (a, b, c) {
            return 0;
        };
        Axis.prototype.jo = function (a) {
            if (this.bh == null) {
                return i2.Rect.empty;
            }
            if (!a.equals1(this.js)) {
                return i2.Rect.empty;
            }
            return this.bh.pk;
        };
        Axis.prototype.jn = function () {
            if (this.bh == null) {
                return i2.Rect.empty;
            }
            return this.bh.pk;
        };
        Axis.prototype.jm = function () {
            if (this.bh == null || this.bh.pj.isEmpty) {
                return this.js;
            }
            return this.bh.pj;
        };
        Axis.prototype.jq = function (a, b) {
            if (b.isEmpty) {
                return a;
            }
            return b;
        };
        Axis.prototype.ea = function (a, b, c) {
            var d = this.jo(c);
            var e = new ScalerParams(0, b, c, this.cc, d);
            return this.d8(a, e);
        };
        Axis.prototype.g5 = function (a, b, c, d) {
        };
        Axis.prototype.g4 = function (a, b, c, d, e) {
        };
        Axis.prototype.eb = function (a, b) {
            return 0;
        };
        Axis.prototype.ec = function (a, b, c) {
            return 0;
        };
        Axis.prototype.ed = function (a, b, c) {
            var d = this.jo(c);
            var e = new ScalerParams(0, b, c, this.cc, d);
            return this.eb(a, e);
        };
        Axis.prototype.g6 = function (a, b, c, d) {
        };
        Axis.prototype.en = function (a) {
            var b = this.jn();
            var c = new ScalerParams(0, this.bh.pg, this.js, this.cc, b);
            return this.d8(a, c);
        };
        Axis.prototype.hb = function (a) {
            var b = false;
            if (this.jx.width == 0 || this.jx.height == 0) {
                this.jr = new i2.Rect(0, 0, 0, a.width, a.height);
            }
            else {
                b = true;
                this.jr = new i2.Rect(0, 0, 0, this.jx.width, this.jx.height);
            }
            if (b) {
                this.a5.c = true;
                this.ck = true;
                this.av.cd();
                this.cw(true);
            }
        };
        Axis.prototype.hx = function () {
            this.jr = i2.Rect.empty;
            this.av.ck();
        };
        Axis.prototype.ap = function () {
            this.ao.a = this.av;
            return this.ao;
        };
        Object.defineProperty(Axis.prototype, "eg", {
            get: function () {
                return this.c9;
            },
            set: function (a) {
                var b = this.eg;
                if (a != b) {
                    this.c9 = a;
                    this.hk("MinExtent", b, this.eg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.b3 = function () {
            if (!i2.isNaN_(this.du)) {
                return true;
            }
            if (this.ay == null) {
                return false;
            }
            else {
                return this.ay.k();
            }
        };
        Axis.prototype.ee = function () {
            if (!i2.isNaN_(this.du)) {
                return this.du;
            }
            if (this.ay == null) {
                return 50;
            }
            return this.ay.extent;
        };
        Axis.prototype.gy = function () {
            this.a4.t();
        };
        Axis.prototype.g1 = function (a) {
            this.hl(a);
        };
        Object.defineProperty(Axis.prototype, "jt", {
            get: function () {
                return this.aq().a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "ju", {
            get: function () {
                return this.aq().b;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "jw", {
            get: function () {
                return this.a4.c().d;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Axis.prototype, "jv", {
            get: function () {
                return this.aq().c;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.bd = function () {
            return SyncManager.a(this.bg);
        };
        Axis.prototype.aq = function () {
            return this.a4.c();
        };
        Object.defineProperty(Axis.prototype, "ax", {
            get: function () {
                return this.aw;
            },
            enumerable: false,
            configurable: true
        });
        Axis.prototype.hf = function (a, b) {
            if (this.av != null) {
                this.av.ce(a);
            }
            this.a4.af(a, b);
        };
        Axis.prototype.b1 = function () {
            return this.fe != null;
        };
        Axis.prototype.ff = function () {
            return this.a9.exportVisualData(this);
        };
        Axis.prototype._c4 = function () {
            var a, b;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        a = 0;
                        _a.label = 1;
                    case 1:
                        if (!(a < this.c7.count))
                            return [3 /*break*/, 4];
                        b = this.c7._inner[a];
                        return [4 /*yield*/, b];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        a++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        Axis.prototype.c4 = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._c4(); });
        };
        Axis.prototype.hg = function (a) {
        };
        Axis.prototype.hj = function (a) {
        };
        Axis.prototype.hi = function (a) {
        };
        Axis.prototype.jk = function (a, b, c, d, e) {
            if (d === void 0) {
                d = null;
            }
            if (e === void 0) {
                e = null;
            }
            if (this.cj) {
                var f = new i2.LineGeometry();
                f.d = { $type: i2.Point_$type, x: c.left, y: a };
                f.c = { $type: i2.Point_$type, x: c.right, y: a };
                return f;
            }
            else {
                var g = new i2.LineGeometry();
                g.d = { $type: i2.Point_$type, x: a, y: c.bottom };
                g.c = { $type: i2.Point_$type, x: a, y: c.top };
                return g;
            }
        };
        Axis.$t = i2.markType(Axis, 'Axis', i2.Control.$, [i2.INotifyPropertyChanged_$type]);
        Axis.i5 = i2.DependencyProperty.i("UseEnhancedIntervalManagement", i2.Boolean_$type, Axis.$, new i2.PropertyMetadata(2, false, function (a, b) { return a.hk("UseEnhancedIntervalManagement", b.oldValue, b.newValue); }));
        Axis.eh = 7;
        Axis.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, Axis, 'hk', ['ActualMajorStroke:i8:h7', [i2.Brush.$], 'ActualMinorStroke:i9:h8', [i2.Brush.$], 'ActualStroke:ja:h9', [i2.Brush.$], 'CrossingAxis:ai:ia', [Axis.$], 'CrossingValue:fe:ib', [4, null], 'EnhancedIntervalMinimumCharacters:e9:ic', [1, -1], 'EnhancedIntervalPreferMoreCategoryLabels:by:id', [0, false], 'FormatLabel:at:ie', [i2.Delegate_$type], 'IsDisabled:ca:ig', [0, false], 'IsInverted:cc:ih', [0, false], 'LabelFormat:fz:ii', [2, null], 'LabelFormatSpecifiers:ag:ij', [i2.Array_$type, null], 'Label:fj:ik', [4, null], 'LabelSettings:ay:il', [AxisLabelSettings.$, null], 'MajorStrokeDashArray:jg:im', [i2.DoubleCollection.$], 'MajorStroke:jb:io', [i2.Brush.$], 'MajorStrokeThickness:ef:ip', [1, 1], 'MinorStrokeDashArray:jh:iq', [i2.DoubleCollection.$], 'MinorStroke:jc:ir', [i2.Brush.$], 'MinorStrokeThickness:ei:is', [1, 1], 'ShouldAvoidAnnotationCollisions:co:it', [0, false], 'ShouldKeepAnnotationsInView:cq:iu', [0, false], 'Strip:jd:iv', [i2.Brush.$], 'StrokeDashArray:ji:iw', [i2.DoubleCollection.$], 'Stroke:je:ix', [i2.Brush.$], 'StrokeThickness:ez:iy', [1, i2.DeviceUtils.g(2)], 'TickLength:e0:iz', [1, NaN], 'TickStrokeDashArray:jj:i0', [i2.DoubleCollection.$], 'TickStroke:jf:i1', [i2.Brush.$], 'TickStrokeThickness:e1:i2', [1, i2.DeviceUtils.g(2)], 'Title:gp:i3', [2], 'TitleSettings:be:i4', [TitleSettings.$, null]]);
        return Axis;
    }(i2.Control));
    /**
     * @hidden
     */
    var AxisCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisCollection, _super);
        function AxisCollection() {
            var _this = _super.call(this, Axis.$, 0) || this;
            _this.collectionResetting = null;
            _this.propertyChanged = i2.delegateCombine(_this.propertyChanged, function (a, b) {
                if (b.propertyName == "Name") {
                    for (var c = 0; c < _this.count; ++c) {
                        if (_this._inner[c].name == b.propertyName) {
                            _this.ac(new i2.NotifyCollectionChangedEventArgs(2, 2, _this._inner[c], _this._inner[c], c));
                        }
                    }
                }
            });
            return _this;
        }
        AxisCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        AxisCollection.$t = i2.markType(AxisCollection, 'AxisCollection', i2.ObservableCollection$1.$.specialize(Axis.$));
        return AxisCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var AxisLabelManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelManager, _super);
        function AxisLabelManager() {
            var _this = _super.call(this) || this;
            _this.e = null;
            _this.f = null;
            _this.b = null;
            _this.a = null;
            _this.c = null;
            _this.c = function (a) {
            };
            return _this;
        }
        AxisLabelManager.prototype.n = function (a, b) {
            this.e.clear();
            this.f.clear();
            this.b.ac = this.a;
            this.b.cx = a;
            this.b.cw = b;
            if (b.isEmpty || a.isEmpty) {
                this.s(0);
                this.a.bp.count = 0;
                this.a.bo.count = 0;
            }
            if (this.a.bq.count == 0 && this.a.bp.count == 0) {
                this.b.ab.clear();
            }
        };
        AxisLabelManager.prototype.i = function (a, b) {
            this.e.add1(a);
            this.f.add(b);
        };
        AxisLabelManager.prototype.t = function () {
            this.b.a5 = this.e;
            this.b.a6 = this.f;
        };
        AxisLabelManager.j = function (a, b) {
            AxisLabelManager.k(a, false, b);
        };
        AxisLabelManager.k = function (a, b, c) {
        };
        AxisLabelManager.l = function (a, b, c) {
        };
        AxisLabelManager.m = function (a, b) {
            AxisLabelManager.l(a, true, b);
        };
        AxisLabelManager.prototype.h = function (a) {
            this.b.ab.add(a);
        };
        AxisLabelManager.prototype.r = function (a) {
            this.b.br = a;
        };
        AxisLabelManager.prototype.o = function (a) {
            this.c(a);
        };
        AxisLabelManager.prototype.u = function (a) {
            var b = this.a.bq.item(a);
            return b;
        };
        AxisLabelManager.prototype.s = function (a) {
            if (this.a == null) {
                return;
            }
            this.a.bq.count = a;
        };
        Object.defineProperty(AxisLabelManager.prototype, "d", {
            get: function () {
                if (this.a == null || this.a.ay == null) {
                    return false;
                }
                return this.a.ay.visibility != 0;
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelManager.prototype.q = function () {
            this.a.bq.count = 0;
            this.a.bp.count = 0;
            this.a.bo.count = 0;
            this.a.av.a7.clear();
        };
        AxisLabelManager.prototype.p = function () {
            this.a.ck = true;
        };
        AxisLabelManager.prototype.g = function () {
            this.a.gx();
        };
        AxisLabelManager.$t = i2.markType(AxisLabelManager, 'AxisLabelManager');
        return AxisLabelManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var AxisLabelPanelBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelPanelBase, _super);
        function AxisLabelPanelBase() {
            var _this = _super.call(this) || this;
            _this.cr = null;
            _this.br = 0;
            _this.ac = null;
            _this.aj = false;
            _this.az = null;
            _this.a6 = null;
            _this.cw = null;
            _this.cq = i2.Rect.empty;
            _this.cp = null;
            _this.cv = null;
            _this.a8 = 0;
            _this.bs = null;
            _this.a7 = null;
            _this.a4 = null;
            _this.af = null;
            _this.an = false;
            _this.ar = false;
            _this.as = false;
            _this.at = false;
            _this.bu = null;
            _this.ak = false;
            _this.a9 = 50;
            _this.ba = 0;
            _this.bb = 0;
            _this.cz = new i2.Size();
            _this.ba = NaN;
            _this.cw = i2.Rect.empty;
            _this.cv = i2.Rect.empty;
            _this.cu = i2.Rect.empty;
            _this.ae = _this.ad();
            _this.cc(_this.ae);
            _this.ae.am();
            _this.a7 = new i2.List$1(i2.FrameworkElement.$, 0);
            _this.a6 = new i2.List$1(LabelPosition.$, 0);
            _this.a4 = new i2.List$1(i2.Rect.$, 0);
            _this.as = false;
            _this.ar = false;
            _this.at = false;
            _this.an = false;
            _this.aj = false;
            return _this;
        }
        AxisLabelPanelBase.prototype.ad = function () {
            return new AxisLabelPanelBaseView(this);
        };
        AxisLabelPanelBase.prototype.cc = function (a) {
        };
        AxisLabelPanelBase.prototype.b3 = function () {
        };
        AxisLabelPanelBase.prototype.cj = function () {
        };
        AxisLabelPanelBase.prototype.ci = function () {
        };
        Object.defineProperty(AxisLabelPanelBase.prototype, "av", {
            get: function () {
                return this.aj;
            },
            set: function (a) {
                this.aj = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelPanelBase.prototype, "a5", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                var b = this.az;
                this.az = a;
                if (b == null && b != a) {
                    this.b9();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelPanelBase.prototype, "cx", {
            get: function () {
                return this.cq;
            },
            set: function (a) {
                var b = this.cq;
                this.cq = a;
                this.cn(b, this.cq);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelPanelBase.prototype, "cu", {
            get: function () {
                if (!this.cv.isEmpty) {
                    return this.cv;
                }
                return this.cp;
            },
            set: function (a) {
                var b = this.cp;
                this.cp = a;
                this.b8(b, this.cp);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelPanelBase.prototype, "bc", {
            get: function () {
                return this.a8;
            },
            set: function (a) {
                this.a8 = a;
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelPanelBase.prototype.am = function (a, b) {
            for (var c = 0; c < a.count - 1; c++) {
                if (b._inner[c]) {
                    continue;
                }
                for (var d = c; d < a.count - 1; d++) {
                    if (b._inner[d + 1]) {
                        continue;
                    }
                    if (a._inner[c].intersectsWith(a._inner[d + 1])) {
                        return true;
                    }
                }
            }
            return false;
        };
        AxisLabelPanelBase.prototype.bt = function (a, b, c) {
            return {
                ret: 0,
                p1: b
            };
        };
        AxisLabelPanelBase.prototype.a1 = function () {
            return null;
        };
        AxisLabelPanelBase.prototype.b1 = function () {
        };
        AxisLabelPanelBase.prototype.bx = function (a) {
        };
        AxisLabelPanelBase.prototype.bh = function () {
            return this.af != null ? this.af.angle : 0;
        };
        AxisLabelPanelBase.prototype.bl = function () {
            return this.ac.be != null ? this.ac.be.angle : 0;
        };
        AxisLabelPanelBase.prototype.aq = function (a, b) {
            if (a == 0 && !this.ac.b4 && this.af != null) {
                if (this.ac.cj) {
                    if (!this.af.showFirstLabel && this.ac.bh.fo() == 1) {
                        return false;
                    }
                }
                else {
                    if (!this.af.showFirstLabel && this.ac.bh.fn() == 1) {
                        return false;
                    }
                }
            }
            return true;
        };
        AxisLabelPanelBase.prototype.bg = function (a) {
            return this.ae.m(a);
        };
        AxisLabelPanelBase.prototype.bq = function (a) {
            return this.ae.w(a);
        };
        AxisLabelPanelBase.prototype.bi = function (a) {
            return this.ae.n(a);
        };
        AxisLabelPanelBase.prototype.bf = function (a) {
            return this.ae.l(a);
        };
        AxisLabelPanelBase.prototype.ao = function () {
            return false;
        };
        AxisLabelPanelBase.prototype.cn = function (a, b) {
        };
        AxisLabelPanelBase.prototype.b8 = function (a, b) {
        };
        AxisLabelPanelBase.prototype.a3 = function () {
            if (this.ab.count < 1 || this.a6.count == 0) {
                return new i2.List$1(i2.Rect.$, 0);
            }
            this.a7 = new i2.List$1(i2.FrameworkElement.$, 0);
            this.a4 = new i2.List$1(i2.Rect.$, 0);
            this.b1();
            this.ae.ae();
            var a = this.bh();
            if (a % 360 == 0) {
                this.ar = false;
            }
            if (this.a7.count == 0) {
                return new i2.List$1(i2.Rect.$, 0);
            }
            this.a4 = this.a1();
            this.a4 = this.a2(this.a4);
            this.aj = true;
            return this.a4;
        };
        AxisLabelPanelBase.prototype.a2 = function (a) {
            var _this = this;
            if (this.ac.co || this.ac.cq) {
                var b = this.ae.p();
                var c = this.ae.r();
                var d = this.ae.q();
                var e = this.ae.o();
                var f = Math.max(b, Math.max(c, Math.max(d, e)));
                var g_1 = new i2.Thickness(0, f);
                if (this.ar) {
                    g_1 = new i2.Thickness(0, Math.sqrt((f * f) / 2));
                }
                var h = this.a0(a);
                var i = new i2.List$1(i2.Thickness.$, 0);
                if (h.count < 1) {
                    return a;
                }
                h.aa(function (j, k) {
                    var l = _this.cs(j, a._inner[j], g_1);
                    var m = _this.cs(k, a._inner[k], g_1);
                    var n = l.top;
                    var o = m.top;
                    if (n < o) {
                        return -1;
                    }
                    if (n > o) {
                        return 1;
                    }
                    return 0;
                });
                for (var j = 0; j < h.count; j++) {
                    var k = h._inner[j];
                    var l = a._inner[k];
                    var m = this.cs(k, a._inner[k], g_1);
                    var n = this.ac.bh.pv.top;
                    if (this.ac.cq) {
                        if (l.top < (this.ac.bh.pv.top - n)) {
                            l = new i2.Rect(0, l.left, l.top + ((this.ac.bh.pv.top - n) - l.top), l.width, l.height);
                            a._inner[k] = l;
                        }
                    }
                }
                var o = this.ap(a, h, g_1);
                if (o && (this.ac.co)) {
                    for (var p = 0; p < h.count - 1; p++) {
                        var q = h._inner[p];
                        var r = h._inner[p + 1];
                        var s = a._inner[q];
                        var t = a._inner[r];
                        var u = this.cs(q, a._inner[q], g_1);
                        var v = this.cs(r, a._inner[r], g_1);
                        if (u.intersectsWith(v) || u.top > v.bottom) {
                            var w = new i2.Rect(0, t.left, u.bottom + 1 + (t.top - v.top), t.width, t.height);
                            a._inner[r] = w;
                        }
                    }
                }
                for (var x = h.count - 1; x >= 0; x--) {
                    var y = h._inner[x];
                    var z = a._inner[y];
                    var aa = this.cs(y, a._inner[y], g_1);
                    var ab = this.ac.bh.cf.a3;
                    if (this.ac.cq) {
                        if (aa.bottom > this.ac.bh.pv.bottom + ab) {
                            z = new i2.Rect(0, z.left, z.top - (aa.bottom - (this.ac.bh.pv.bottom + ab)), z.width, z.height);
                            a._inner[y] = z;
                        }
                    }
                }
                if (this.ac.co) {
                    for (var ac = h.count - 1; ac >= 1; ac--) {
                        var ad = h._inner[ac];
                        var ae = h._inner[ac - 1];
                        var af = a._inner[ad];
                        var ag = a._inner[ae];
                        var ah = this.cs(ad, a._inner[ad], g_1);
                        var ai = this.cs(ae, a._inner[ae], g_1);
                        if (ah.intersectsWith(ai) || ah.top < ai.bottom) {
                            var aj = new i2.Rect(0, ag.left, ah.top - (ai.height + 1 + (ag.top - ai.top)), ag.width, ag.height);
                            a._inner[ae] = aj;
                        }
                    }
                }
                return a;
            }
            else {
                return a;
            }
        };
        AxisLabelPanelBase.prototype.cs = function (a, b, c) {
            var d = this.a6._inner[a];
            var e = d.d;
            if (i2.isNaN_(e.c) || i2.isNaN_(e.e) || i2.isNaN_(e.d) || i2.isNaN_(e.b)) {
                e = c;
            }
            if (e.c > c.c || e.e > c.e || e.d > c.d || e.b > c.b) {
                e = c;
            }
            var f = new i2.Rect(0, b.left - e.c, b.top - e.e, b.width + e.c + e.d, b.height + e.e + e.b);
            return f;
        };
        AxisLabelPanelBase.prototype.ap = function (a, b, c) {
            if (b.count <= 1) {
                return false;
            }
            for (var d = 0; d < b.count - 1; d++) {
                var e = b._inner[d];
                var f = b._inner[d + 1];
                var g = a._inner[e];
                var h = a._inner[f];
                var i = this.cs(e, a._inner[e], c);
                var j = this.cs(f, a._inner[f], c);
                if (i.intersectsWith(j)) {
                    return true;
                }
            }
            return false;
        };
        AxisLabelPanelBase.prototype.a0 = function (a) {
            var b = new i2.List$1(i2.Number_$type, 0);
            for (var c = 0; c < a.count; c++) {
                var d = this.a6._inner[c].a;
                if (d) {
                    b.add(c);
                }
            }
            return b;
        };
        AxisLabelPanelBase.prototype.bk = function (a, b) {
            var c = a * (Math.PI / 180);
            var d = Math.abs(b.width * Math.cos(c)) + Math.abs(b.height * Math.sin(c));
            return d;
        };
        AxisLabelPanelBase.prototype.bj = function (a, b) {
            var c = a * (Math.PI / 180);
            var d = Math.abs(b.height * Math.cos(c)) + Math.abs(b.width * Math.sin(c));
            return d;
        };
        AxisLabelPanelBase.prototype.bo = function () {
            var a = this.ae.k();
            return a;
        };
        AxisLabelPanelBase.prototype.bm = function () {
            var a = this.ae.j();
            return a;
        };
        AxisLabelPanelBase.prototype.bn = function () {
            if (this.ac.gp == null || (this.ac.be != null && this.ac.be.visibility == 1)) {
                return 0;
            }
            var a = this.bm();
            var b = this.bo();
            var c = new i2.Rect(0, 0, 0, b, a);
            var d = this.bl();
            var e = i2.RectUtil.w(c, d);
            return e.height + this.ae.v() + this.ae.s();
        };
        AxisLabelPanelBase.prototype.bp = function () {
            if (this.ac.gp == null || (this.ac.be != null && this.ac.be.visibility == 1)) {
                return 0;
            }
            var a = this.bm();
            var b = this.bo();
            var c = new i2.Rect(0, 0, 0, b, a);
            var d = this.bl();
            var e = i2.RectUtil.w(c, d);
            return e.width + this.ae.t() + this.ae.u();
        };
        AxisLabelPanelBase.prototype.cy = function (a) {
            if (this.ac == null || this.ab.count == 0) {
                return a;
            }
            this.b0(a);
            this.b4();
            this.bz(a);
            this.a4 = this.a3();
            if (this.a7.count != this.a4.count) {
                return a;
            }
            var b = this.ae.p();
            var c = this.ae.r();
            var d = this.ae.q();
            var e = this.ae.o();
            if (this.ar) {
                for (var f = 0; f < this.a7.count; f++) {
                    if (this.aq(f, this.a4._inner[f])) {
                        this.ae.aa(this.a7._inner[f], this.a4._inner[f], b, c, d, e);
                    }
                    this.cg(this.a7._inner[f], this.bh());
                }
            }
            for (var g = 0; g < this.a7.count; g++) {
                if (!this.ar) {
                    this.ae.ad(this.a7._inner[g]);
                }
                if (this.aq(g, this.a4._inner[g])) {
                    this.ae.aa(this.a7._inner[g], this.a4._inner[g], b, c, d, e);
                }
                else {
                    this.ae.aa(this.a7._inner[g], new i2.Rect(0, 0, 0, 0, 0), b, c, d, e);
                }
            }
            if (this.ac.bp.count > 0) {
                this.ac.a7.arrangeAnnotations(this.ac, this.ae, this.a7, this.a4, this.ar, this.bh(), b, c, d, e);
            }
            this.bx(a);
            if (this.ao() && this.al && this.ac != null && this.ac.bf != null && !this.ac.cl && this.ac.bf.qn && !this.ac.bf.qj && this.a4 != null && this.a4.count > 0) {
                this.ac.bf.sg(this, this.cu, this.a4._inner[0], this.a4._inner[this.a4.count - 1]);
            }
            return a;
        };
        Object.defineProperty(AxisLabelPanelBase.prototype, "al", {
            get: function () {
                return this.ac.ay != null && (this.ac.ay.c != 5 && this.ac.ay.c != 4);
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelPanelBase.prototype.ct = function () {
            return i2.Rect.empty;
        };
        AxisLabelPanelBase.prototype.b0 = function (a) {
            if (this.ac.h6 == null) {
                return;
            }
            this.ae.ah(this.ac.h6, new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            var b = Math.abs(this.bl() - 0) > 1E-06;
            var c = this.ct();
            var d = c.left + (c.width / 2);
            var e = c.top + (c.height / 2);
            var f = this.bo() + this.ae.t() + this.ae.u();
            var g = this.bm() + this.ae.v() + this.ae.s();
            var h = f / 2;
            var i = g / 2;
            var j = new i2.Rect(0, d - h, e - i, f, g);
            if (b) {
                this.ch(this.ac.h6);
            }
            else {
                this.ae.ad(this.ac.h6);
            }
            this.ae.aa(this.ac.h6, j, this.ae.t(), this.ae.v(), this.ae.u(), this.ae.s());
            if ((this.ac.be == null || this.ac.be.visibility == 0) && (this.ac.ay == null || this.ac.ay.visibility == 0) && this.ac.gp != null) {
                this.ac.h6._visibility = 0;
            }
            else {
                this.ac.h6._visibility = 1;
                this.ae.aa(this.ac.h6, new i2.Rect(0, 0, 0, 0, 0), 0, 0, 0, 0);
            }
        };
        AxisLabelPanelBase.prototype.bz = function (a) {
            this.ae.ab(a);
        };
        AxisLabelPanelBase.prototype.b4 = function () {
        };
        AxisLabelPanelBase.prototype.ay = function () {
            if (i2.typeCast(CategoryAxisBase.$, this.ac) !== null) {
                return this.ac.kd;
            }
            if (i2.typeCast(NumericAxisBase.$, this.ac) !== null) {
                var a = new i2.List$1(i2.Number_$type, 0);
                var d = this.ac.kb.j();
                for (var c = 0; c < d.length; c++) {
                    var b = d[c];
                    var e = this.ac.jn();
                    var f = new ScalerParams(0, this.ac.bh.pw, this.ac.js, this.ac.cd, e);
                    a.add(this.ac.d8(b, f));
                }
                return a;
            }
            return null;
        };
        Object.defineProperty(AxisLabelPanelBase.prototype, "ag", {
            get: function () {
                var a = this.af != null ? this.af.c : this.ah();
                if (this.ac.ai == null) {
                    if (a == 4) {
                        a = 5;
                    }
                    else if (a == 5) {
                        a = 4;
                    }
                    else if (a == 6) {
                        a = 7;
                    }
                    else if (a == 7) {
                        a = 6;
                    }
                }
                return a;
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelPanelBase.prototype.cm = function (a, b, c, d, e, f) {
            var g = b;
            var h = b;
            if (f != null) {
                var i = f.c / 2;
                g -= i;
                h += i;
            }
            if (h >= e.left && g <= e.right) {
                if (f.a) {
                    b = this.ac.ds(b, e.left, e.right, f);
                }
                var j = new i2.LineGeometry();
                j.d = { $type: i2.Point_$type, x: b, y: c };
                j.c = { $type: i2.Point_$type, x: b, y: d };
                a.add(j);
            }
        };
        AxisLabelPanelBase.prototype.b7 = function (a, b, c, d, e, f) {
            if (b <= e.bottom && b >= e.top) {
                if (f.a) {
                    b = this.ac.ds(b, e.top, e.bottom, f);
                }
                var g = new i2.LineGeometry();
                g.d = { $type: i2.Point_$type, x: c, y: b };
                g.c = { $type: i2.Point_$type, x: d, y: b };
                a.add(g);
            }
        };
        AxisLabelPanelBase.prototype.cg = function (a, b) {
            var c = this.bh();
            this.ae.ai(a, c);
        };
        AxisLabelPanelBase.prototype.ch = function (a) {
            var b = this.bl();
            this.b6(a, b);
        };
        AxisLabelPanelBase.prototype.b6 = function (a, b) {
            var c = i2.typeCast(i2.FrameworkElement.$, a);
            var d = this.bm();
            var e = this.bo();
            var f = 0.5 * e;
            var g = 0.5 * d;
            var h = ((function () {
                var $ret = new i2.RotateTransform();
                $ret.j = b;
                $ret.k = f;
                $ret.l = g;
                return $ret;
            })());
            var i = new i2.TransformGroup();
            i.j.add(h);
            c.j = i;
        };
        AxisLabelPanelBase.prototype.c0 = function (a) {
            var e_24, _a;
            if ((this.ab.contains(this.ac.h6) == false) && this.ac.h6 != null) {
                this.ab.add(this.ac.h6);
                AxisLabelManager.m(this.ac.h6, this.ac.be);
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ab)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b != this.ac.h6 && b != this.ae.av) {
                        this.ae.ag(b);
                    }
                }
            }
            catch (e_24_1) {
                e_24 = { error: e_24_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_24)
                        throw e_24.error;
                }
            }
            var c = (this.ac == null || this.a9 <= 0 || i2.isNaN_(this.a9)) ? 50 : this.a9;
            if (this.ac != null && (this.ac.c7 == null || this.ac.c7.count == 0)) {
                if (this.ac.b3()) {
                    c = this.ac.ee();
                }
            }
            var d = this.ao();
            c = Math.min(c, d ? a.height : a.width);
            c = i2.isInfinity(c) ? 50 : c;
            return d ? new i2.Size(1, 50, c) : new i2.Size(1, c, 50);
        };
        Object.defineProperty(AxisLabelPanelBase.prototype, "bd", {
            get: function () {
                return this.c(AxisLabelPanelBase.co);
            },
            set: function (a) {
                this.h(AxisLabelPanelBase.co, a);
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelPanelBase.prototype.ai = function (a) {
            if (a == null) {
                return this.ac.bh.an(this.ac);
            }
            if (a.position == 0) {
                if (this.ac != null && this.ac.bh != null) {
                    return this.ac.bh.an(this.ac);
                }
                return 4;
            }
            return a.position;
        };
        AxisLabelPanelBase.prototype.ah = function () {
            return 1;
        };
        AxisLabelPanelBase.prototype.au = function (a) {
            return true;
        };
        AxisLabelPanelBase.prototype._aw = function () {
            var _a, _b, a, e_25_1;
            var e_25, _c;
            return tslib.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 7]);
                        _a = tslib.__values(i2.fromEnum(this.ab)), _b = _a.next();
                        _d.label = 1;
                    case 1:
                        if (!!_b.done)
                            return [3 /*break*/, 4];
                        a = _b.value;
                        if (!(a != this.ac.h6 && a != this.ae.av))
                            return [3 /*break*/, 3];
                        return [4 /*yield*/, a];
                    case 2:
                        _d.sent();
                        _d.label = 3;
                    case 3:
                        _b = _a.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_25_1 = _d.sent();
                        e_25 = { error: e_25_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_b && !_b.done && (_c = _a.return))
                                _c.call(_a);
                        }
                        finally {
                            if (e_25)
                                throw e_25.error;
                        }
                        return [7 /*endfinally*/];
                    case 7: return [2 /*return*/];
                }
            });
        };
        AxisLabelPanelBase.prototype.aw = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._aw(); });
        };
        AxisLabelPanelBase.prototype.bw = function (a, b, c, d, e) {
            var f = this.ae.x(b, c, d, e);
            return f;
        };
        AxisLabelPanelBase.prototype.b2 = function (a) {
            if (this.bu == null || this.bg(this.bu) < this.bg(a)) {
                this.bu = a;
            }
        };
        AxisLabelPanelBase.prototype.cb = function (a) {
            this.a7.add(a);
        };
        AxisLabelPanelBase.prototype._ax = function () {
            var a, b;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        a = 0;
                        _a.label = 1;
                    case 1:
                        if (!(a < this.ac.bq.count))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, this.ac.bq.item(a)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        a++;
                        return [3 /*break*/, 1];
                    case 4:
                        b = 0;
                        _a.label = 5;
                    case 5:
                        if (!(b < this.ac.bp.count))
                            return [3 /*break*/, 8];
                        return [4 /*yield*/, this.ac.bp.item(b)];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7:
                        b++;
                        return [3 /*break*/, 5];
                    case 8: return [2 /*return*/];
                }
            });
        };
        AxisLabelPanelBase.prototype.ax = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._ax(); });
        };
        AxisLabelPanelBase.prototype.b5 = function () {
            this.ae.af();
            this.cl();
        };
        AxisLabelPanelBase.prototype.cl = function () {
            this.a4 = this.a3();
        };
        AxisLabelPanelBase.prototype.b9 = function () {
        };
        AxisLabelPanelBase.prototype.be = function (a) {
            return this.a9;
        };
        AxisLabelPanelBase.prototype.cd = function () {
            this.cv = new i2.Rect(0, 0, 0, this.cz.width, this.cz.height);
        };
        AxisLabelPanelBase.prototype.ck = function () {
            this.cv = i2.Rect.empty;
        };
        AxisLabelPanelBase.prototype.ca = function () {
            this.ae.aj();
        };
        AxisLabelPanelBase.prototype.ce = function (a) {
            this.ae.ak(a);
        };
        AxisLabelPanelBase.prototype.by = function () {
            this.ae.y();
        };
        AxisLabelPanelBase.prototype.cf = function () {
            this.ae.an();
        };
        AxisLabelPanelBase.$t = i2.markType(AxisLabelPanelBase, 'AxisLabelPanelBase', i2.Panel.$);
        AxisLabelPanelBase.co = i2.DependencyProperty.i("Extent", i2.Number_$type, AxisLabelPanelBase.$, new i2.PropertyMetadata(2, 50, function (a, b) { return a.a9 = b.newValue; }));
        return AxisLabelPanelBase;
    }(i2.Panel));
    /**
     * @hidden
     */
    var CategoryAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryAxisBase, _super);
        function CategoryAxisBase() {
            var _this = _super.call(this) || this;
            _this.kd = null;
            _this.j5 = null;
            _this.ko = 0;
            _this.kq = 0;
            _this.j3 = 0;
            _this.kp = 0;
            _this.j7 = false;
            _this.kd = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        CategoryAxisBase.prototype.a3 = function () {
            return new CategoryAxisBaseView(this);
        };
        CategoryAxisBase.prototype.get_b8 = function () {
            return false;
        };
        CategoryAxisBase.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.j2 = a;
        };
        CategoryAxisBase.prototype.d6 = function (a, b, c, d) {
            var e = this.getCategorySize(b, c, d);
            var f = e * a;
            return f;
        };
        CategoryAxisBase.prototype.c1 = function (a, b, c) {
            var d = _super.prototype.c1.call(this, a, b, c);
            if (!d) {
                return false;
            }
            return this.itemsSource != null && this.kq > 0;
        };
        CategoryAxisBase.prototype.la = function () {
            if (this.j6 != null && this.bn != null && this.itemsSource != null) {
                this.j6 = this.bn.releaseFastItemsSource(this.itemsSource);
            }
        };
        CategoryAxisBase.prototype.k9 = function () {
            if (this.j6 == null && this.bn != null && this.itemsSource != null) {
                this.j6 = this.bn.getFastItemsSource(this.itemsSource);
            }
        };
        CategoryAxisBase.prototype.get_b6 = function () {
            return true;
        };
        CategoryAxisBase.prototype.ll = function (a, b, c) {
            if (this.b4) {
                return i2.Rect.empty;
            }
            return this.lm(a, b, c, this.cj);
        };
        CategoryAxisBase.prototype.lm = function (a, b, c, d) {
            var e = 0;
            var f = a.x;
            var g = this.js.left;
            var h = this.js.right;
            if (d) {
                f = a.y;
                g = this.js.top;
                h = this.js.bottom;
            }
            var i = this.kd;
            if ((d && !this.cc) || (!d && this.cc)) {
                i = new i2.List$1(i2.Number_$type, 0);
                for (var j = this.kd.count - 1; j >= 0; j--) {
                    i.add(this.kd._inner[j]);
                }
            }
            if (this.categoryMode == 0) {
                if (b) {
                    var k = void 0;
                    if (d) {
                        k = new i2.Rect(0, this.js.left, a.y - c / 2, this.js.width, c);
                    }
                    else {
                        k = new i2.Rect(0, a.x - c / 2, this.js.top, c, this.js.height);
                    }
                    k.intersect(this.js);
                    return k;
                }
                else {
                    if (f > h) {
                        return i2.Rect.empty;
                    }
                    if (f < g) {
                        return i2.Rect.empty;
                    }
                    var l = 1.7976931348623157E+308;
                    var m = -1;
                    for (e = 0; e < i.count; e++) {
                        var n = Math.abs(i._inner[e] - f);
                        if (n < l) {
                            l = n;
                            m = e;
                        }
                    }
                    if (m == -1) {
                        return i2.Rect.empty;
                    }
                    var o = i._inner[m];
                    var p = void 0;
                    if (d) {
                        p = new i2.Rect(0, this.js.left, o - c / 2, this.js.width, c);
                    }
                    else {
                        p = new i2.Rect(0, o - c / 2, this.js.top, c, this.js.height);
                    }
                    p.intersect(this.js);
                    return p;
                }
            }
            else {
                for (e = 0; e < i.count; e++) {
                    if (i._inner[e] > f) {
                        break;
                    }
                }
                if (e == 0) {
                    return i2.Rect.empty;
                }
                if (f > h) {
                    return i2.Rect.empty;
                }
                if (f < g) {
                    return i2.Rect.empty;
                }
                var q = this.js.right;
                if (d) {
                    q = this.js.bottom;
                }
                if (e < i.count) {
                    q = i._inner[e];
                }
                if (d) {
                    return new i2.Rect(0, this.js.left, i._inner[e - 1], this.js.width, q - i._inner[e - 1]);
                }
                else {
                    return new i2.Rect(0, i._inner[e - 1], this.js.top, q - i._inner[e - 1], this.js.height);
                }
            }
        };
        Object.defineProperty(CategoryAxisBase.prototype, "itemsSource", {
            get: function () {
                return this.c(CategoryAxisBase.li);
            },
            set: function (a) {
                this.h(CategoryAxisBase.li, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryAxisBase.prototype, "kr", {
            get: function () {
                return this.ko;
            },
            set: function (a) {
                this.ko = a;
                this.kq = this.ko;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryAxisBase.prototype, "categoryMode", {
            get: function () {
                return this.j3;
            },
            set: function (a) {
                if (this.j3 != a) {
                    var b = this.j3;
                    this.j3 = a;
                    this.hk("CategoryMode", i2.enumGetBox(CategoryMode_$type, b), i2.enumGetBox(CategoryMode_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryAxisBase.prototype, "ks", {
            get: function () {
                return this.kp;
            },
            set: function (a) {
                if (a != this.kp) {
                    var b = this.kp;
                    this.kp = a;
                    this.hk("GroupCount", b, this.kp);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryAxisBase.prototype.eb = function (a, b) {
            return NaN;
        };
        CategoryAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
            return NaN;
        };
        CategoryAxisBase.prototype.getCategorySize = function (a, b, c) {
            return NaN;
        };
        CategoryAxisBase.prototype.ki = function (a, b, c) {
            return NaN;
        };
        CategoryAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
            return NaN;
        };
        CategoryAxisBase.prototype.kn = function (a) {
            var b = this.bh.pw;
            var c = this.js;
            var d = this.jn();
            var e = new ScalerParams(0, b, c, this.cc, d);
            return this.eb(a, e);
        };
        CategoryAxisBase.prototype._kc = function () {
            var _a, _b, a, e_26_1, _c, _d, b, _e, _f, c, e_27_1, e_28_1;
            var e_26, _g, e_28, _h, e_27, _j;
            return tslib.__generator(this, function (_k) {
                switch (_k.label) {
                    case 0:
                        _k.trys.push([0, 5, 6, 7]);
                        _a = tslib.__values(i2.fromEnum(this.c7)), _b = _a.next();
                        _k.label = 1;
                    case 1:
                        if (!!_b.done)
                            return [3 /*break*/, 4];
                        a = _b.value;
                        return [4 /*yield*/, a];
                    case 2:
                        _k.sent();
                        _k.label = 3;
                    case 3:
                        _b = _a.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_26_1 = _k.sent();
                        e_26 = { error: e_26_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_b && !_b.done && (_g = _a.return))
                                _g.call(_a);
                        }
                        finally {
                            if (e_26)
                                throw e_26.error;
                        }
                        return [7 /*endfinally*/];
                    case 7:
                        if (!(this.bh != null && this.bh.d0 && this.j9(this.bh)))
                            return [3 /*break*/, 21];
                        _k.label = 8;
                    case 8:
                        _k.trys.push([8, 19, 20, 21]);
                        _c = tslib.__values(i2.fromEnum(this.bh.eu())), _d = _c.next();
                        _k.label = 9;
                    case 9:
                        if (!!_d.done)
                            return [3 /*break*/, 18];
                        b = _d.value;
                        if (!(b != this.bh))
                            return [3 /*break*/, 17];
                        _k.label = 10;
                    case 10:
                        _k.trys.push([10, 15, 16, 17]);
                        _e = (e_27 = void 0, tslib.__values(i2.fromEnum(b.series))), _f = _e.next();
                        _k.label = 11;
                    case 11:
                        if (!!_f.done)
                            return [3 /*break*/, 14];
                        c = _f.value;
                        return [4 /*yield*/, c];
                    case 12:
                        _k.sent();
                        _k.label = 13;
                    case 13:
                        _f = _e.next();
                        return [3 /*break*/, 11];
                    case 14: return [3 /*break*/, 17];
                    case 15:
                        e_27_1 = _k.sent();
                        e_27 = { error: e_27_1 };
                        return [3 /*break*/, 17];
                    case 16:
                        try {
                            if (_f && !_f.done && (_j = _e.return))
                                _j.call(_e);
                        }
                        finally {
                            if (e_27)
                                throw e_27.error;
                        }
                        return [7 /*endfinally*/];
                    case 17:
                        _d = _c.next();
                        return [3 /*break*/, 9];
                    case 18: return [3 /*break*/, 21];
                    case 19:
                        e_28_1 = _k.sent();
                        e_28 = { error: e_28_1 };
                        return [3 /*break*/, 21];
                    case 20:
                        try {
                            if (_d && !_d.done && (_h = _c.return))
                                _h.call(_c);
                        }
                        finally {
                            if (e_28)
                                throw e_28.error;
                        }
                        return [7 /*endfinally*/];
                    case 21: return [2 /*return*/];
                }
            });
        };
        CategoryAxisBase.prototype.kc = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._kc(); });
        };
        CategoryAxisBase.prototype.j8 = function (a) {
            return this.c7.contains(a);
        };
        CategoryAxisBase.prototype.j9 = function (a) {
            return false;
        };
        CategoryAxisBase.prototype._kb = function () {
            var a, _a, _b, b, c, _c, _d, d, e_29_1, e_30_1;
            var e_30, _e, e_29, _f;
            return tslib.__generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        a = i2.typeCast(XamDataChart.$, this.bh);
                        if (!(a != null && a.d0 && this.j9(a)))
                            return [3 /*break*/, 14];
                        _g.label = 1;
                    case 1:
                        _g.trys.push([1, 12, 13, 14]);
                        _a = tslib.__values(i2.fromEnum(a.eu())), _b = _a.next();
                        _g.label = 2;
                    case 2:
                        if (!!_b.done)
                            return [3 /*break*/, 11];
                        b = _b.value;
                        if (!(b != this.bh))
                            return [3 /*break*/, 10];
                        c = i2.typeCast(XamDataChart.$, b);
                        if (!(c != null))
                            return [3 /*break*/, 10];
                        _g.label = 3;
                    case 3:
                        _g.trys.push([3, 8, 9, 10]);
                        _c = (e_29 = void 0, tslib.__values(i2.fromEnum(c.axes))), _d = _c.next();
                        _g.label = 4;
                    case 4:
                        if (!!_d.done)
                            return [3 /*break*/, 7];
                        d = _d.value;
                        if (!(i2.typeCast(CategoryAxisBase.$, d) !== null))
                            return [3 /*break*/, 6];
                        return [4 /*yield*/, i2.typeCast(CategoryAxisBase.$, d)];
                    case 5:
                        _g.sent();
                        _g.label = 6;
                    case 6:
                        _d = _c.next();
                        return [3 /*break*/, 4];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_29_1 = _g.sent();
                        e_29 = { error: e_29_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (_d && !_d.done && (_f = _c.return))
                                _f.call(_c);
                        }
                        finally {
                            if (e_29)
                                throw e_29.error;
                        }
                        return [7 /*endfinally*/];
                    case 10:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 11: return [3 /*break*/, 14];
                    case 12:
                        e_30_1 = _g.sent();
                        e_30 = { error: e_30_1 };
                        return [3 /*break*/, 14];
                    case 13:
                        try {
                            if (_b && !_b.done && (_e = _a.return))
                                _e.call(_a);
                        }
                        finally {
                            if (e_30)
                                throw e_30.error;
                        }
                        return [7 /*endfinally*/];
                    case 14: return [2 /*return*/];
                }
            });
        };
        CategoryAxisBase.prototype.kb = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._kb(); });
        };
        CategoryAxisBase.prototype.le = function (a) {
            var e_31, _a, e_32, _b;
            if (this.j7) {
                return;
            }
            try {
                this.j7 = true;
                var b = 0;
                var c = 0;
                var d = false;
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.kc())), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var e = _d.value;
                        if (!e.da && !e.d4 && !e.di) {
                            continue;
                        }
                        var f = e;
                        var g = f.preferredCategoryMode(this);
                        if (g == 2) {
                            b = 2;
                            d = true;
                            if (this.j8(e)) {
                                c++;
                            }
                        }
                        if (g == 1 && !d) {
                            b = 1;
                        }
                    }
                }
                catch (e_31_1) {
                    e_31 = { error: e_31_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_31)
                            throw e_31.error;
                    }
                }
                var h = this.ka;
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.kb())), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var i = _f.value;
                        if (i.ka) {
                            h = true;
                        }
                        if (a) {
                            i.le(false);
                        }
                    }
                }
                catch (e_32_1) {
                    e_32 = { error: e_32_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_32)
                            throw e_32.error;
                    }
                }
                if (b == 0 && h) {
                    b = 2;
                    if (c == 0) {
                        c = 1;
                    }
                }
                this.categoryMode = b;
                this.ks = c;
            }
            finally {
                this.j7 = false;
            }
        };
        CategoryAxisBase.prototype.he = function (a, b, c, d) {
            var e_33, _a, e_34, _b, e_35, _c;
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSourceProvider":
                    if ((i2.typeCast(i2.IFastItemsSourceProvider_$type, c)) != null) {
                        this.j6 = c.releaseFastItemsSource(this.itemsSource);
                    }
                    if ((i2.typeCast(i2.IFastItemsSourceProvider_$type, d)) != null) {
                        this.j6 = d.getFastItemsSource(this.itemsSource);
                    }
                    this.kr = 0;
                    if (this.j6 != null) {
                        this.kr = this.j6.count;
                    }
                    this.le(true);
                    break;
                case "ItemsSource":
                    if (this.bn != null) {
                        this.j6 = this.bn.getFastItemsSource(this.itemsSource);
                    }
                    break;
                case CategoryAxisBase.$$p[0]:
                    var e = i2.typeCast(i2.IFastItemsSource_$type, c);
                    this.k1();
                    this.ck = true;
                    if (e != null) {
                        e.event = i2.delegateRemove(e.event, i2.runOn(this, this.k4));
                    }
                    this.kr = 0;
                    if (this.j6 != null) {
                        this.kr = this.j6.count;
                    }
                    if (this.j6 != null) {
                        var f = this.j6;
                        f.event = i2.delegateCombine(f.event, i2.runOn(this, this.k4));
                        this.hq(false);
                        try {
                            for (var _d = tslib.__values(i2.fromEnum(this.c4())), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var g = _e.value;
                                g.l0(false);
                                if (g.ca != null) {
                                    g.k7();
                                }
                            }
                        }
                        catch (e_33_1) {
                            e_33 = { error: e_33_1 };
                        }
                        finally {
                            try {
                                if (_e && !_e.done && (_a = _d.return))
                                    _a.call(_d);
                            }
                            finally {
                                if (e_33)
                                    throw e_33.error;
                            }
                        }
                    }
                    else {
                        this.gz();
                        try {
                            for (var _f = tslib.__values(i2.fromEnum(this.c4())), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var h = _g.value;
                                h.kh(true, h.bx);
                                if (h.ca != null) {
                                    h.k7();
                                }
                            }
                        }
                        catch (e_34_1) {
                            e_34 = { error: e_34_1 };
                        }
                        finally {
                            try {
                                if (_g && !_g.done && (_b = _f.return))
                                    _b.call(_f);
                            }
                            finally {
                                if (e_34)
                                    throw e_34.error;
                            }
                        }
                    }
                    break;
                case "ItemsCount":
                    this.hl(new AxisRangeChangedEventArgs(0, 0, 0, i2.typeGetValue((c)) - 1, i2.typeGetValue((d)) - 1));
                    this.hq(false);
                    break;
                case CategoryAxisBase.$$p[3]:
                    this.ck = true;
                    this.lf();
                    this.hq(false);
                    this.k2();
                    break;
                case "CategoryMode":
                    this.ck = true;
                    this.hq(false);
                    this.lc();
                    this.k2();
                    break;
                case CategoryAxisBase.$$p[2]:
                case CategoryAxisBase.$$p[1]:
                    this.ck = true;
                    try {
                        for (var _h = tslib.__values(i2.fromEnum(this.c4())), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var i = _j.value;
                            i.et = true;
                            var j = i2.typeCast(IHasCategoryModePreference_$type, i);
                            if (j != null && j.preferredCategoryMode(this) == 2) {
                                i.l0(false);
                            }
                        }
                    }
                    catch (e_35_1) {
                        e_35 = { error: e_35_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_35)
                                throw e_35.error;
                        }
                    }
                    this.hq(false);
                    if (this.bh != null) {
                        this.bh.jz();
                    }
                    break;
                case Axis.$$p[4]:
                case Axis.$$p[3]:
                    this.ck = true;
                    this.hq(true);
                    break;
            }
        };
        CategoryAxisBase.prototype.k2 = function () {
            var e_36, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.l0(false);
                }
            }
            catch (e_36_1) {
                e_36 = { error: e_36_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_36)
                        throw e_36.error;
                }
            }
        };
        CategoryAxisBase.prototype.k4 = function (a, b) {
            this.lb(b);
        };
        CategoryAxisBase.prototype.lb = function (a) {
            switch (a.action) {
                case 3:
                case 0:
                case 1:
                case 2:
                case 4:
                    if (this.j6 != null) {
                        this.kr = this.j6.count;
                    }
                    this.hq(false);
                    break;
            }
            if (this.j6 != null) {
                this.kr = this.j6.count;
            }
        };
        CategoryAxisBase.prototype.lf = function () {
            var e_37, _a;
            var a = false, b = false;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c7)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = i2.typeCast(IHasCategoryModePreference_$type, c);
                    if (d == null) {
                        continue;
                    }
                    var e = d.preferredCategoryMode(this);
                    a = a || e == 1;
                    b = b || e == 2;
                }
            }
            catch (e_37_1) {
                e_37 = { error: e_37_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_37)
                        throw e_37.error;
                }
            }
            var f = b ? 2 : a ? 1 : 0;
            if (f == 0 && this.ka) {
                f = 1;
                if (this.ks == 0) {
                    this.ks = 1;
                }
            }
            this.categoryMode = f;
        };
        CategoryAxisBase.prototype.cn = function (a) {
            var e_38, _a;
            var b = _super.prototype.cn.call(this, a);
            if (b) {
                this.le(true);
                var c = i2.typeCast(IHasCategoryModePreference_$type, a);
                if (c != null && c.preferredCategoryMode(this) == 2) {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var d = _c.value;
                            var e = i2.typeCast(IHasCategoryModePreference_$type, d);
                            if (e != null && e != c && e.preferredCategoryMode(this) == 2) {
                                d.l0(false);
                            }
                        }
                    }
                    catch (e_38_1) {
                        e_38 = { error: e_38_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_38)
                                throw e_38.error;
                        }
                    }
                }
                this.hq(false);
                this.cv();
            }
            return b;
        };
        CategoryAxisBase.prototype.bx = function (a) {
            var e_39, _a;
            var b = _super.prototype.bx.call(this, a);
            if (b) {
                this.le(true);
                var c = i2.typeCast(IHasCategoryModePreference_$type, a);
                if (c != null && c.preferredCategoryMode(this) != 0) {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var d = _c.value;
                            var e = i2.typeCast(IHasCategoryModePreference_$type, d);
                            if (e != null) {
                                d.l0(false);
                            }
                        }
                    }
                    catch (e_39_1) {
                        e_39 = { error: e_39_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_39)
                                throw e_39.error;
                        }
                    }
                }
                this.hq(false);
            }
            return b;
        };
        CategoryAxisBase.prototype.lc = function () {
            var e_40, _a;
            var a = null;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b.da) {
                        var c = b.an(this);
                        if (c != null && c.ai == this) {
                            a = c;
                        }
                    }
                }
            }
            catch (e_40_1) {
                e_40 = { error: e_40_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_40)
                        throw e_40.error;
                }
            }
            if (a != null) {
                a.hp();
            }
        };
        CategoryAxisBase.prototype.k1 = function () {
            this.j5 = this.j6;
        };
        CategoryAxisBase.prototype.ld = function () {
            var a = this.ay;
            if (a == null) {
                a = new AxisLabelSettings();
            }
            if (a.visibility == 1) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            else {
                var b = 0;
                b = this.j2.bf(this.c5);
                this.bq.count = b;
            }
        };
        CategoryAxisBase.prototype.k3 = function (a) {
            if (this.j6 != null) {
                this.j6.handleCollectionChanged(a);
            }
        };
        CategoryAxisBase.prototype.k8 = function (a, b, c) {
            this.k3(new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        CategoryAxisBase.prototype.k5 = function () {
            this.k3(new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        CategoryAxisBase.prototype.k6 = function (a, b) {
            this.k3(new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        CategoryAxisBase.prototype.k7 = function (a, b) {
            this.k3(new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        CategoryAxisBase.prototype.kj = function (a, b, c, d) {
            return this.kk(a, b, c, d, this.categoryMode);
        };
        CategoryAxisBase.prototype.kk = function (a, b, c, d, e) {
            var f = 0;
            var g = e;
            if (g == 0 && this.categoryMode != 0) {
                g = 1;
            }
            switch (g) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * this.getCategorySize(a, b, c);
                    break;
                case 2:
                    f = this.getGroupCenter(d, a, b, c);
                    break;
            }
            if (this.cj != this.cc) {
                f *= -1;
            }
            return f;
        };
        CategoryAxisBase.prototype.getSeriesOffset = function (a, b, c, d, e) {
            return this.kk(a, b, c, d, e);
        };
        Object.defineProperty(CategoryAxisBase.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        CategoryAxisBase.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        CategoryAxisBase.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        CategoryAxisBase.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        CategoryAxisBase.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        CategoryAxisBase.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(CategoryAxisBase.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        CategoryAxisBase.$t = i2.markType(CategoryAxisBase, 'CategoryAxisBase', Axis.$, [ICategoryScaler_$type]);
        CategoryAxisBase.li = i2.DependencyProperty.i("ItemsSource", i2.IEnumerable_$type, CategoryAxisBase.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(CategoryAxisBase.$, a);
            if (c.bn != null) {
                c.bn.releaseFastItemsSource(b.oldValue);
            }
            a.hk("ItemsSource", b.oldValue, b.newValue);
        }));
        CategoryAxisBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryAxisBase, 'hk', ['FastItemsSource:j6:lg', [i2.IFastItemsSource_$type], 'Gap:kf:lh', [1, 0.2], 'Overlap:km:lj', [1, 0], 'UseClusteringMode:ka:lk', [0, false]]);
        return CategoryAxisBase;
    }(Axis));
    /**
     * @hidden
     */
    var HorizontalAxisLabelPanelBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAxisLabelPanelBase, _super);
        function HorizontalAxisLabelPanelBase() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.dd = 0;
            _this.da = 0;
            _this.dc = 0;
            _this.db = 0;
            return _this;
        }
        HorizontalAxisLabelPanelBase.prototype.ad = function () {
            return new HorizontalAxisLabelPanelBaseView(this);
        };
        HorizontalAxisLabelPanelBase.prototype.cc = function (a) {
            _super.prototype.cc.call(this, a);
            this.c1 = a;
        };
        HorizontalAxisLabelPanelBase.prototype.b1 = function () {
            this.c1.az();
        };
        HorizontalAxisLabelPanelBase.prototype.c3 = function () {
            return this.af != null && this.af.j() && this.bh() % 360 != 0;
        };
        HorizontalAxisLabelPanelBase.prototype.c4 = function () {
            return this.an && !this.ar;
        };
        HorizontalAxisLabelPanelBase.prototype.ao = function () {
            return true;
        };
        HorizontalAxisLabelPanelBase.prototype.a1 = function () {
            var _this = this;
            var a = new i2.List$1(i2.Rect.$, 0);
            var b = new i2.List$1(i2.Boolean_$type, 0);
            this.as = false;
            this.ar = false;
            this.at = false;
            var c = this.af != null ? (this.af.angle) : 0;
            var d = c * Math.PI / 180;
            if (this.c3()) {
                this.ar = true;
            }
            this.an = false;
            this.df(a, b, d);
            this.an = this.an || this.am(a, b);
            if (this.an) {
                this.dh(a, b);
            }
            else {
                this.di();
            }
            var e = this.ac.b3();
            if (!e) {
                this.de(c);
            }
            else {
                this.ae.ac();
            }
            if (this.ar) {
                for (var f = 0; f < a.count; f++) {
                    var g = a._inner[f];
                    g.x = this.a6._inner[f].c;
                    a._inner[f] = g;
                }
            }
            var h = 0;
            if (this.c4()) {
                h = ((function () { var i = _this.bt(_this.da, a, b); a = i.p1; return i.ret; })());
            }
            if (this.an && !this.as) {
                if (h > 0) {
                    if (this.c1.ay()) {
                        this.at = true;
                    }
                }
            }
            if (this.an && this.c2()) {
                var i = this.cu.width;
                var j = this.c8();
                var k = this.c7();
                var l = this.a6.count > 1 ? this.a6._inner[1].c - this.a6._inner[0].c : i;
                var m = Math.abs(l * 0.8);
                var n = 0;
                var o = Math.abs(Math.atan(this.da / l) * 180 / Math.PI);
                var p = this.ae.p();
                var q = this.ae.q();
                for (var r = 0; r < a.count; r++) {
                    if (this.ak) {
                        if (r > 0 && r < a.count - 1) {
                            var s = this.a6.count > 1 ? this.a6._inner[r].c - (a._inner[r - 1].x + a._inner[r - 1].width) : i;
                            var t = this.a6.count > 1 ? a._inner[r + 1].x - this.a6._inner[r].c : i;
                            m = Math.abs(Math.min(Math.abs(s * 2), Math.abs(t * 2)) * 0.8);
                        }
                        else {
                            if (r == 0) {
                                var u = this.a6.count > 1 ? a._inner[r + 1].x - this.a6._inner[r].c : i;
                                m = Math.abs((l * 2) * 0.8);
                            }
                            if (r == a.count - 1) {
                                var v = this.a6.count > 1 ? this.a6._inner[r].c - (a._inner[r - 1].x + a._inner[r - 1].width) : i;
                                m = Math.abs((v * 2) * 0.8);
                            }
                        }
                    }
                    var w = Math.min(a._inner[r].width, m);
                    n = this.ar ? this.a6._inner[r].c : this.a6._inner[r].c - w / 2;
                    var x = i2.AngleSimplifier.a(c);
                    var y = (x >= o && x <= 180 - o) || (x >= 180 + o && x <= 360 - o);
                    var z = a._inner[r];
                    if (this.ar && y) {
                        var aa = this.bq(this.a7._inner[r]);
                        m = Math.min(j / Math.abs(Math.sin(d)), aa);
                    }
                    z.x = n;
                    z.width = Math.min(m, z.width);
                    a._inner[r] = z;
                    if (!(i2.typeCast(i2.TextBlock.$, this.a7._inner[r]) !== null)) {
                        this.a7._inner[r].width = Math.min(m, z.width);
                    }
                    var ab = i2.typeCast(i2.TextBlock.$, this.a7._inner[r]);
                    if (ab != null) {
                        var ac = this.bw(r, ab, m, p, q);
                        if (this.at) {
                            ab.height = k;
                        }
                        else if (!i2.Base.equalsStatic(ab.ak, ac)) {
                            ab.ak = ac;
                            this.a7._inner[r].width = Math.min(m, this.bg(this.a7._inner[r]));
                            this.dc = Math.min(this.dc, this.a7._inner[r].width);
                        }
                    }
                }
                if (!e) {
                    this.de(c);
                }
            }
            if (this.c5()) {
                this.dg(a);
            }
            return a;
        };
        HorizontalAxisLabelPanelBase.prototype.df = function (a, b, c) {
            var d = this.bn();
            var e = this.c9();
            this.da = -1.7976931348623157E+308;
            this.dd = -1.7976931348623157E+308;
            this.db = -1.7976931348623157E+308;
            this.dc = -1.7976931348623157E+308;
            var f = this.ae.p();
            var g = this.ae.q();
            var h = this.ae.r();
            var i = this.ae.o();
            var j = this.cu.top;
            var k = (this.cu.height - d);
            var l = false;
            for (var m = 0; m < this.a7.count; m++) {
                if (!this.a6._inner[m].a) {
                    l = true;
                }
            }
            for (var n = 0; n < this.a7.count; n++) {
                if (this.a6 == null || n >= this.a6.count) {
                    break;
                }
                var o = void 0, p = void 0, q = void 0, r = void 0, s = void 0, t = void 0;
                var u = this.a7._inner[n];
                s = this.bg(u);
                t = this.bf(u);
                r = s + this.ae.p() + this.ae.q();
                q = t + h + i;
                var v = this.a6._inner[n].a;
                if (this.ar) {
                    o = this.a6._inner[n].c;
                }
                else {
                    o = this.a6._inner[n].c - r / 2;
                }
                p = j + e;
                if (!v || !l) {
                    this.da = Math.max(q, this.da);
                    this.dd = Math.max(r, this.dd);
                    this.db = Math.max(t, this.db);
                    this.dc = Math.max(s, this.dc);
                }
                var w = new i2.Rect(0, o, p, r, q);
                a.add(w);
                b.add(v);
                var x = r * Math.abs(Math.sin(c));
                this.an = this.an || x > k;
            }
        };
        HorizontalAxisLabelPanelBase.prototype.de = function (a) {
            var b = a * (Math.PI / 180);
            var c = Math.abs(this.dc * Math.sin(b)) + Math.abs(this.db * Math.cos(b));
            c += this.ae.r() + this.ae.o();
            var d = this.bn();
            this.bd = (c) + (d) + this.ac.dr;
        };
        HorizontalAxisLabelPanelBase.prototype.dg = function (a) {
            this.c1.a0(a);
        };
        HorizontalAxisLabelPanelBase.prototype.dh = function (a, b) {
        };
        HorizontalAxisLabelPanelBase.prototype.di = function () {
        };
        HorizontalAxisLabelPanelBase.prototype.cg = function (a, b) {
            var c = a.l;
            var d = a.m;
            var e = 0;
            var f = c / 2;
            var g = new i2.TransformGroup();
            var h = i2.AngleSimplifier.a(this.bh());
            var i = ((function () {
                var $ret = new i2.RotateTransform();
                $ret.j = h;
                $ret.k = e;
                $ret.l = f;
                return $ret;
            })());
            var j = 0;
            var k = 0;
            if (h != 0 && h != 360) {
                if (h > 0 && h < 180) {
                    j = -Math.sin(i2.MathUtil.k(h)) * (c / 2);
                }
                else {
                    i.k = d;
                    k = -d;
                    j = -Math.sin(i2.MathUtil.k(h - 180)) * (c / 2);
                }
            }
            var l = ((function () {
                var $ret = new i2.TranslateTransform();
                $ret.k = j;
                $ret.j = k;
                return $ret;
            })());
            g.j.add(i);
            g.j.add(l);
            a.j = g;
        };
        HorizontalAxisLabelPanelBase.prototype.c5 = function () {
            return !this.as && !this.ar;
        };
        HorizontalAxisLabelPanelBase.prototype.c2 = function () {
            return true;
        };
        HorizontalAxisLabelPanelBase.prototype.bt = function (a, b, c) {
            var d = 0;
            var e = new i2.List$1(i2.Rect.$, 0);
            var f = this.c9() + this.cu.top;
            var g = this.c8();
            var h = f + g;
            if (a * 3 <= this.a9) {
                d = 3;
            }
            else if (a * 2 <= this.a9) {
                d = 2;
            }
            else {
                return {
                    ret: d,
                    p1: b
                };
            }
            var i = 0;
            for (var j = 0; j < b.count; j++) {
                var k = i2.RectUtil.p(b._inner[j]);
                if (!c._inner[j]) {
                    if (i % d == 0) {
                        k.y = f;
                    }
                    else if (i % d == d - 1) {
                        k.y = h - k.height;
                    }
                    else {
                        k.y = (f + (g / 2)) - k.height / 2;
                    }
                    i++;
                }
                e.add(k);
            }
            this.an = this.am(e, c);
            if (!this.an) {
                this.as = true;
                b = e;
            }
            return {
                ret: d,
                p1: b
            };
        };
        HorizontalAxisLabelPanelBase.prototype.ct = function () {
            var a = this.ai(this.ac.be);
            var b = this.bn();
            var c = this.ag;
            var d = 0;
            if (a == 3) {
                d += this.cu.top;
                if (c == 1 || c == 5) {
                    d += this.ac.dr;
                }
            }
            else {
                d = this.cu.bottom - b;
                if (c == 4 || c == 0) {
                    d -= this.ac.dr;
                }
            }
            var e = this.bp();
            var f = 0;
            var g = this.ac.be == null ? 1 : this.ac.be.horizontalAlignment;
            if (g == 0) {
                f = this.cu.left;
            }
            else if (g == 2) {
                f = this.cu.right - e;
            }
            else {
                f = (this.cu.left + (this.cu.width / 2)) - (e / 2);
            }
            return new i2.Rect(0, f, d, e, b);
        };
        HorizontalAxisLabelPanelBase.prototype.c9 = function () {
            var a = 0;
            var b = this.ai(this.ac.be);
            if (b == 3) {
                a += this.bn();
            }
            var c = this.ag;
            if (c == 1 || c == 5) {
                a += this.ac.dr;
            }
            return a;
        };
        HorizontalAxisLabelPanelBase.prototype.c6 = function () {
            var a = 0;
            var b = this.ai(this.ac.be);
            if (b == 4) {
                a += this.bn();
            }
            var c = this.ag;
            if (c == 0 || c == 4) {
                a += this.ac.dr;
            }
            return a;
        };
        HorizontalAxisLabelPanelBase.prototype.c8 = function () {
            var a = (this.a9 - this.c9()) - this.c6();
            if (a < 0) {
                a = 0;
            }
            return a;
        };
        HorizontalAxisLabelPanelBase.prototype.c7 = function () {
            var a = ((this.c8() - this.ae.r()) - this.ae.o());
            if (a < 0) {
                a = 0;
            }
            return a;
        };
        HorizontalAxisLabelPanelBase.prototype.b4 = function () {
            var e_41, _a;
            var a = this.ae.at();
            this.ac.g0(a);
            if (this.af != null && this.af.visibility != 0) {
                return;
            }
            var b = this.ac.dr;
            if (b == 0) {
                return;
            }
            var c = this.ay();
            if (c == null) {
                return;
            }
            var d = this.cu.top;
            var e;
            var f = this.ag;
            if (f == 0 || f == 4) {
                d = this.cu.bottom;
                e = d - this.ac.dr;
            }
            else {
                e = d + this.ac.dr;
            }
            var g = this.ae.b();
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    this.cm(a, h, d, e, this.cw, g);
                }
            }
            catch (e_41_1) {
                e_41 = { error: e_41_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_41)
                        throw e_41.error;
                }
            }
            if (!this.ab.contains(this.ae.av)) {
                this.ab.add(this.ae.av);
            }
        };
        HorizontalAxisLabelPanelBase.prototype.a2 = function (a) {
            var _this = this;
            if (this.ac.co || this.ac.cq) {
                var b = this.ae.p();
                var c = this.ae.r();
                var d = this.ae.q();
                var e = this.ae.o();
                var f = Math.max(b, Math.max(c, Math.max(d, e)));
                var g_2 = new i2.Thickness(0, f);
                if (this.ar) {
                    g_2 = new i2.Thickness(0, Math.sqrt((f * f) / 2));
                }
                var h = this.a0(a);
                var i = new i2.List$1(i2.Thickness.$, 0);
                if (h.count < 1) {
                    return a;
                }
                h.aa(function (j, k) {
                    var l = _this.cs(j, a._inner[j], g_2);
                    var m = _this.cs(k, a._inner[k], g_2);
                    var n = l.left;
                    var o = m.left;
                    if (n < o) {
                        return -1;
                    }
                    if (n > o) {
                        return 1;
                    }
                    return 0;
                });
                for (var j = 0; j < h.count; j++) {
                    var k = h._inner[j];
                    var l = a._inner[k];
                    var m = this.cs(k, a._inner[k], g_2);
                    var n = this.ac.bh.pv.left;
                    if (this.ac.cq) {
                        if (l.left < (this.ac.bh.pv.left - n)) {
                            l = new i2.Rect(0, l.left + ((this.ac.bh.pv.left - n) - l.left), l.top, l.width, l.height);
                            a._inner[k] = l;
                        }
                    }
                }
                var o = this.ap(a, h, g_2);
                if (o && (this.ac.co)) {
                    for (var p = 0; p < h.count - 1; p++) {
                        var q = h._inner[p];
                        var r = h._inner[p + 1];
                        var s = a._inner[q];
                        var t = a._inner[r];
                        var u = this.cs(q, a._inner[q], g_2);
                        var v = this.cs(r, a._inner[r], g_2);
                        if (u.intersectsWith(v) || u.left > v.right) {
                            var w = new i2.Rect(0, u.right + 1 + (t.left - v.left), t.top, t.width, t.height);
                            a._inner[r] = w;
                        }
                    }
                }
                for (var x = h.count - 1; x >= 0; x--) {
                    var y = h._inner[x];
                    var z = a._inner[y];
                    var aa = this.cs(y, a._inner[y], g_2);
                    var ab = this.ac.bh.cf.a5;
                    if (this.ac.cq) {
                        if (aa.right > this.ac.bh.pv.right + ab) {
                            z = new i2.Rect(0, z.left - (aa.right - (this.ac.bh.pv.right + ab)), z.top, z.width, z.height);
                            a._inner[y] = z;
                        }
                    }
                }
                if (this.ac.co) {
                    for (var ac = h.count - 1; ac >= 1; ac--) {
                        var ad = h._inner[ac];
                        var ae = h._inner[ac - 1];
                        var af = a._inner[ad];
                        var ag = a._inner[ae];
                        var ah = this.cs(ad, a._inner[ad], g_2);
                        var ai = this.cs(ae, a._inner[ae], g_2);
                        if (ah.intersectsWith(ai) || ah.left < ai.right) {
                            var aj = new i2.Rect(0, ah.left - (ai.width + 1) + (ag.left - ai.left), ag.top, ag.width, ag.height);
                            a._inner[ae] = aj;
                        }
                    }
                }
                return a;
            }
            else {
                return a;
            }
        };
        HorizontalAxisLabelPanelBase.$t = i2.markType(HorizontalAxisLabelPanelBase, 'HorizontalAxisLabelPanelBase', AxisLabelPanelBase.$);
        return HorizontalAxisLabelPanelBase;
    }(AxisLabelPanelBase));
    /**
     * @hidden
     */
    var HorizontalAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAxisLabelPanel, _super);
        function HorizontalAxisLabelPanel() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalAxisLabelPanel.prototype.ah = function () {
            return 1;
        };
        HorizontalAxisLabelPanel.prototype.au = function (a) {
            return a == 5 || a == 4 || a == 1 || a == 0;
        };
        HorizontalAxisLabelPanel.$t = i2.markType(HorizontalAxisLabelPanel, 'HorizontalAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
        return HorizontalAxisLabelPanel;
    }(HorizontalAxisLabelPanelBase));
    /**
     * @hidden
     */
    var NumericAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericAxisBase, _super);
        function NumericAxisBase() {
            var _this = _super.call(this) || this;
            _this.kp = 0;
            _this.k1 = 0;
            _this.ks = 0;
            _this.ko = 0;
            _this.k0 = 0;
            _this.kr = 0;
            _this.kn = 0;
            _this.kq = 0;
            _this.ke = false;
            _this.k8 = 0;
            _this.j6 = null;
            _this.km = false;
            _this.ka = null;
            _this.kd = false;
            _this.k8 = 10;
            return _this;
        }
        NumericAxisBase.prototype.a3 = function () {
            return new NumericAxisBaseView(this);
        };
        NumericAxisBase.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.j3 = a;
        };
        NumericAxisBase.prototype.dt = function (a, b) {
            var c = a < this.kv ? this.kv : a;
            c = a > this.ku ? this.ku : c;
            return c;
        };
        NumericAxisBase.prototype.get_ce = function () {
            return true;
        };
        Object.defineProperty(NumericAxisBase.prototype, "kv", {
            get: function () {
                return this.kp;
            },
            set: function (a) {
                if (this.kv != a) {
                    var b = this.kp;
                    this.kp = a;
                    this.k1 = Math.log(this.kv);
                    this.hk("ActualMinimumValue", b, this.kv);
                }
            },
            enumerable: false,
            configurable: true
        });
        NumericAxisBase.prototype.fl = function () {
            return this.k3;
        };
        Object.defineProperty(NumericAxisBase.prototype, "ky", {
            get: function () {
                return this.ks;
            },
            set: function (a) {
                if (this.ky != a) {
                    var b = this.ks;
                    this.ks = a;
                    this.hk("ActualVisibleMinimumValue", b, this.ky);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "ku", {
            get: function () {
                return this.ko;
            },
            set: function (a) {
                if (this.ku != a) {
                    var b = this.ko;
                    this.ko = a;
                    this.k0 = Math.log(this.ku);
                    this.hk("ActualMaximumValue", b, this.ku);
                }
            },
            enumerable: false,
            configurable: true
        });
        NumericAxisBase.prototype.fk = function () {
            return this.ku;
        };
        Object.defineProperty(NumericAxisBase.prototype, "kx", {
            get: function () {
                return this.kr;
            },
            set: function (a) {
                if (this.kx != a) {
                    var b = this.kr;
                    this.kr = a;
                    this.hk("ActualVisibleMaximumValue", b, this.kx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "kt", {
            get: function () {
                return this.kn;
            },
            set: function (a) {
                if (this.kt != a) {
                    var b = this.kn;
                    this.kn = a;
                    this.hk("ActualInterval", b, this.kt);
                }
            },
            enumerable: false,
            configurable: true
        });
        NumericAxisBase.prototype.ej = function () {
            return this.kt;
        };
        Object.defineProperty(NumericAxisBase.prototype, "kw", {
            get: function () {
                return this.kq;
            },
            set: function (a) {
                if (this.kw != a) {
                    var b = this.kq;
                    this.kq = a;
                    this.hk("ActualMinorInterval", b, this.kw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "kg", {
            get: function () {
                return this.ke;
            },
            set: function (a) {
                if (this.kg != a) {
                    var b = this.ke;
                    if (b != a) {
                        this.ke = a;
                        this.hk("ActualIsLogarithmic", b, this.kg);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "kl", {
            get: function () {
                return this.kg && this.kv > 0 && this.k8 > 1;
            },
            enumerable: false,
            configurable: true
        });
        NumericAxisBase.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            if (this.kl && this.bh != null) {
                var b = this.jn();
                var c = this.jm();
                var d = this.j7(this.js, this.bh.pg, b, c);
                if (d == null) {
                    return;
                }
                var _loop_3 = function (e) {
                    var f = this_1.k7;
                    var g = d.k._inner[e];
                    var h = Math.min(g.d, g.c);
                    var i = Math.max(g.d, g.c);
                    var j = Math.floor(i2.logBase(h, f));
                    var k = Math.ceil(i2.logBase(i, f));
                    if (k - j < 2) {
                        if (i2.typeCast(LogarithmicTickmarkValues.$, this_1.ka) !== null) {
                            this_1.ka = new LinearTickmarkValues();
                        }
                    }
                    else {
                        this_1.ka = this_1.kc != null ? this_1.kc : ((function () {
                            var $ret = new LogarithmicTickmarkValues();
                            $ret.x = f;
                            return $ret;
                        })());
                    }
                };
                var this_1 = this;
                for (var e = 0; e < d.k.count; e++) {
                    _loop_3(e);
                }
            }
        };
        NumericAxisBase.prototype.hj = function (a) {
            _super.prototype.hj.call(this, a);
            this.k3 = a;
        };
        NumericAxisBase.prototype.hi = function (a) {
            _super.prototype.hj.call(this, a);
            this.k2 = a;
        };
        NumericAxisBase.prototype.he = function (a, b, c, d) {
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case NumericAxisBase.$$p[4]:
                    this.cv();
                    this.hq(false);
                    break;
                case NumericAxisBase.$$p[3]:
                    this.cv();
                    this.hq(false);
                    break;
                case NumericAxisBase.$$p[1]:
                    this.km = true;
                    this.kg = this.kk;
                    break;
                case Axis.$$p[4]:
                case Axis.$$p[3]:
                case NumericAxisBase.$$p[0]:
                case NumericAxisBase.$$p[5]:
                    this.ck = true;
                    this.hq(false);
                    break;
                case NumericAxisBase.$$p[2]:
                    this.km = true;
                    this.k8 = this.k7;
                    if (this.kg) {
                        this.cv();
                        this.ls();
                        this.hq(false);
                    }
                    break;
                case NumericAxisBase.$$p[6]:
                    var e = new AxisRangeChangedEventArgs(0, this.kv, this.kv, this.ku, this.ku);
                    this.hl(e);
                    this.ck = true;
                    this.hq(false);
                    break;
                case Axis.$$p[13]:
                    this.j6 = this.j4();
                    this.ck = true;
                    this.hq(false);
                    break;
                case "TickmarkValues":
                    this.lu();
                    break;
                case "ActualIsLogarithmic":
                    this.cv();
                    this.ls();
                    this.ck = true;
                    this.lu();
                    this.hq(false);
                    break;
                case "ActualTickmarkValues":
                    this.ck = true;
                    this.hq(false);
                    break;
                case "AbbreviateLargeNumbers":
                    this.hq(false);
                    break;
            }
        };
        NumericAxisBase.prototype.ls = function () {
            var e_42, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.l0(false);
                }
            }
            catch (e_42_1) {
                e_42 = { error: e_42_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_42)
                        throw e_42.error;
                }
            }
        };
        NumericAxisBase.prototype.j2 = function () {
            var e_43, _a;
            var a = new AxisRange(Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY);
            var b = false;
            if (this.bh != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        var d = c.ap(this);
                        if (d != null) {
                            b = true;
                            a = new AxisRange(Math.min(a.c, d.c), Math.max(a.b, d.b));
                        }
                    }
                }
                catch (e_43_1) {
                    e_43 = { error: e_43_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_43)
                            throw e_43.error;
                    }
                }
            }
            if (b) {
                return a;
            }
            return null;
        };
        NumericAxisBase.prototype.lq = function (a, b, c, d, e, f, g) {
            var h = AutoRangeCalculator.a(a, b, c, d, e, f, g);
            f = h.p5;
            g = h.p6;
            return {
                p5: f,
                p6: g
            };
        };
        NumericAxisBase.prototype.cx = function () {
            var a = this.kg && !i2.isNaN_(this.k7) && !i2.isInfinity(this.k7) && this.k7 > 1;
            var b;
            var c;
            var d = this.lq(this, this.k3, this.k2, a, this.k7, b, c);
            b = d.p5;
            c = d.p6;
            if (b != this.kv || c != this.ku || this.km) {
                this.km = false;
                var e = new AxisRangeChangedEventArgs(0, this.kv, b, this.ku, c);
                this.kv = b;
                this.ku = c;
                this.hl(e);
                this.lt(e);
                this.hq(true);
                return true;
            }
            return false;
        };
        NumericAxisBase.prototype.lt = function (a) {
        };
        NumericAxisBase.prototype.cn = function (a) {
            var b = _super.prototype.cn.call(this, a);
            if (b) {
                this.cv();
            }
            return b;
        };
        NumericAxisBase.prototype.bx = function (a) {
            var b = _super.prototype.bx.call(this, a);
            if (b) {
                this.cv();
            }
            return b;
        };
        NumericAxisBase.prototype.j5 = function (a) {
            return new NumericAxisRenderer(a);
        };
        NumericAxisBase.prototype.j4 = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new AxisLabelManager();
                $ret.a = _this;
                $ret.f = _this.c6;
                $ret.e = _this.c5;
                $ret.b = _this.av;
                return $ret;
            })());
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            var b = this.j5(a);
            b.u = function () {
                var c = _this.a4.ay();
                var d = _this.a4.a1();
                var e = _this.a4.az();
                var f = _this.a4.a0();
                _this.h0();
                _this.g0(c);
                _this.g0(d);
                _this.g0(e);
                _this.g0(f);
            };
            b.o = function (c, d) { return !d.isEmpty && !c.isEmpty; };
            b.d = function (c, d, e, f) { return _this.j7(c, d, e, f); };
            b.g = function (c) { return _this.fi(c); };
            return b;
        };
        NumericAxisBase.prototype.j8 = function () {
            return new NumericAxisRenderingParameters();
        };
        NumericAxisBase.prototype.lr = function () {
        };
        NumericAxisBase.prototype.j9 = function () {
            return null;
        };
        NumericAxisBase.prototype.j7 = function (a, b, c, d) {
            var e = this.j8();
            var f = this.a4.ay();
            var g = this.a4.a1();
            var h = this.a4.az();
            var i = this.a4.a0();
            var j = this.a4.e();
            var k = this.a4.f();
            var l = this.a4.g();
            e.t = f;
            e.w = g;
            e.u = h;
            e.v = i;
            e.a = j;
            e.c = k;
            e.d = l;
            e.l = this.ku;
            e.m = this.kv;
            e.h = this.ki;
            e.f = this.kb;
            e.z = a;
            e.y = c;
            e.x = d;
            e.aa = b;
            e.o = this.el();
            e.g = this.kh();
            e.p = this.kz;
            e.q = this.k4;
            e.s = this.fj;
            if (this.fj == null && (this.at != null || this.ah != null)) {
                e.s = "Format";
            }
            e.j = this.cs;
            e.ab = this.kf;
            return e;
        };
        NumericAxisBase.prototype.k6 = function (a) {
            var b = this.jn();
            var c = new ScalerParams(0, this.bh.pg, this.js, this.cc, b);
            return this.eb(a, c);
        };
        NumericAxisBase.prototype.kh = function () {
            return !i2.isNaN_(this.kz);
        };
        Object.defineProperty(NumericAxisBase.prototype, "kj", {
            get: function () {
                return !i2.isNaN_(this.k3);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "ki", {
            get: function () {
                return !i2.isNaN_(this.k2);
            },
            enumerable: false,
            configurable: true
        });
        NumericAxisBase.prototype.lu = function () {
            if (this.kc != null) {
                this.kb = this.kc;
            }
            else if (this.kg) {
                this.kb = new LogarithmicTickmarkValues();
                this.j3.bf();
            }
            else {
                this.kb = new LinearTickmarkValues();
            }
        };
        Object.defineProperty(NumericAxisBase.prototype, "kc", {
            get: function () {
                return i2.typeCast(TickmarkValues.$, this.c(NumericAxisBase.l2));
            },
            set: function (a) {
                this.h(NumericAxisBase.l2, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "kb", {
            get: function () {
                if (this.ka == null) {
                    this.lu();
                }
                return this.ka;
            },
            set: function (a) {
                var b = this.ka;
                var c = b != a;
                if (c) {
                    this.ka = a;
                    this.hk("ActualTickmarkValues", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NumericAxisBase.prototype, "kf", {
            get: function () {
                return this.kd;
            },
            set: function (a) {
                var b = this.kf;
                if (a != b) {
                    this.kd = a;
                    this.hk("AbbreviateLargeNumbers", b, this.kf);
                }
            },
            enumerable: false,
            configurable: true
        });
        NumericAxisBase.$t = i2.markType(NumericAxisBase, 'NumericAxisBase', Axis.$);
        NumericAxisBase.l2 = i2.DependencyProperty.i("TickmarkValues", TickmarkValues.$, NumericAxisBase.$, new i2.PropertyMetadata(1, function (a, b) { return a.hk("TickmarkValues", b.oldValue, b.newValue); }));
        NumericAxisBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, NumericAxisBase, 'hk', ['Interval:kz:lv', [1, NaN], 'IsLogarithmic:kk:lw', [0, false], 'LogarithmBase:k7:lx', [1, 10], 'MaximumValue:k2:ly', [1, NaN], 'MinimumValue:k3:lz', [1, NaN], 'MinorInterval:k4:l0', [1, NaN], 'ReferenceValue:k5:l1', [1, 0]]);
        return NumericAxisBase;
    }(Axis));
    /**
     * @hidden
     */
    var NumericScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericScaler, _super);
        function NumericScaler() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.o = 0;
            _this.n = 0;
            _this.m = 0;
            return _this;
        }
        NumericScaler.prototype.y = function (a) {
            this.l = a;
        };
        NumericScaler.prototype.x = function (a) {
            this.k = a;
        };
        NumericScaler.prototype.w = function (a, b, c) {
            switch (a) {
                case NumericScaler.$$p[1]:
                    this.o = this.l;
                    this.z();
                    break;
                case NumericScaler.$$p[0]:
                    this.n = this.k;
                    this.z();
                    break;
            }
        };
        NumericScaler.prototype.z = function () {
            if (i2.isNaN_(this.l) || i2.isNaN_(this.k) || i2.isInfinity(this.l) || i2.isInfinity(this.k) || this.l < (-7.9228162514264338E+28) || this.k > (7.9228162514264338E+28)) {
                this.m = this.k - this.l;
            }
            else {
                this.m = this.k - this.l;
            }
        };
        NumericScaler.prototype.j = function (a, b, c, d) {
            var e = new i2.List$1(i2.Number_$type, 2, a.count);
            for (var f = b; f < c; f++) {
                e.add(this.q(a.item(f), d));
            }
            return e;
        };
        NumericScaler.prototype.v = function (a, b, c, d) {
            for (var e = b; e < c; e++) {
                a.item(e, this.p(a.item(e), d));
            }
        };
        NumericScaler.prototype.u = function (a, b, c, d, e) {
            for (var f = 0; f < b.count; f++) {
                var g = b.item(f);
                for (var h = c; h < d; h++) {
                    a.item(h)[g] = this.p(a.item(h)[g], e);
                }
            }
        };
        NumericScaler.$t = i2.markType(NumericScaler, 'NumericScaler', i2.DependencyObject.$);
        NumericScaler.ac = new i2.Rect(0, 0, 0, 1, 1);
        NumericScaler.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, NumericScaler, 'w', ['ActualMaximumValue:k:aa', [1, NaN], 'ActualMinimumValue:l:ab', [1, NaN]]);
        return NumericScaler;
    }(i2.DependencyObject));
    /**
     * @hidden
     */
    var AxisRendererBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisRendererBase, _super);
        function AxisRendererBase(a) {
            var _this = _super.call(this) || this;
            _this.u = null;
            _this.o = null;
            _this.v = null;
            _this.m = null;
            _this.l = null;
            _this.k = null;
            _this.q = null;
            _this.n = null;
            _this.j = null;
            _this.e = null;
            _this.p = null;
            _this.h = null;
            _this.t = null;
            _this.b = null;
            _this.g = null;
            _this.d = null;
            _this.r = null;
            _this.a = null;
            _this.f = null;
            _this.i = null;
            _this.u = function () {
            };
            _this.o = function (b, c) { return false; };
            _this.v = function () {
            };
            _this.m = function (b, c) { return c; };
            _this.l = function (b, c, d, e) {
            };
            _this.k = function (b, c, d) {
            };
            _this.q = function (b, c) { return false; };
            _this.n = function (b, c) { return _this.q(b, c); };
            _this.j = function (b) {
            };
            _this.e = function (b) {
            };
            _this.p = function (b, c, d) { return false; };
            _this.h = function (b, c) { return new LabelPosition(c); };
            _this.t = function (b, c) { return c; };
            _this.g = function (b) { return null; };
            _this.r = function (b, c, d, e) { return c; };
            _this.a = function (b, c, d, e) { return c; };
            _this.b = a;
            _this.d = function (b, c, d, e) { return null; };
            return _this;
        }
        AxisRendererBase.prototype.c = function (a, b, c, d, e) {
            var e_44, _a;
            this.x(c, b);
            if (this.o(b, c)) {
                this.v();
                var f_1 = this.d(b, c, d, e);
                this.x(c, b);
                if (f_1 == null) {
                    this.aa();
                    return null;
                }
                if (f_1.k.count > 1 && !f_1.g) {
                    this.ab(f_1);
                }
                var _loop_4 = function (g) {
                    f_1.e = g;
                    if (i2.isNaN_(g.c) || i2.isInfinity(g.c) || i2.isNaN_(g.d) || i2.isInfinity(g.d)) {
                        return "continue";
                    }
                    if (g.d == g.c) {
                        return "continue";
                    }
                    this_2.e(f_1);
                    this_2.b.o(f_1.r);
                    var h = 0;
                    var i = 0;
                    var j = false;
                    var k = function (l) { return l; };
                    if (this_2.f != null) {
                        k = this_2.i;
                    }
                    if (i2.typeCast(CategoryAxisRenderingParameters.$, f_1) !== null) {
                        h = f_1.ab;
                        i = f_1.af;
                        j = f_1.ac;
                    }
                    f_1.f = this_2.s(f_1);
                    f_1.f.s(((function () {
                        var $ret = new TickmarkValuesInitializationParameters();
                        $ret.n = f_1.e.d;
                        $ret.m = f_1.e.c;
                        $ret.g = f_1.m;
                        $ret.f = f_1.l;
                        $ret.k = f_1.e.b;
                        $ret.d = f_1.g;
                        $ret.l = f_1.p;
                        $ret.j = f_1.q;
                        $ret.h = f_1.o;
                        $ret.i = f_1.e.a;
                        $ret.p = f_1.e.e;
                        $ret.a = h;
                        $ret.q = i;
                        $ret.s = f_1.aa;
                        $ret.r = f_1.z;
                        $ret.e = j;
                        $ret.c = k;
                        return $ret;
                    })()));
                    this_2.y(f_1);
                };
                var this_2 = this;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(f_1.k)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var g = _c.value;
                        _loop_4(g);
                    }
                }
                catch (e_44_1) {
                    e_44 = { error: e_44_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_44)
                            throw e_44.error;
                    }
                }
                this.z();
                return f_1;
            }
            return null;
        };
        AxisRendererBase.prototype.aa = function () {
            this.b.q();
        };
        AxisRendererBase.prototype.ab = function (a) {
            var e_45, _a, e_46, _b;
            var b = -1.7976931348623157E+308;
            var c = -2147483648;
            var d = 0;
            var e = 0;
            var f = false;
            var g = function (h) { return h; };
            if (this.f != null) {
                g = this.i;
            }
            if (i2.typeCast(CategoryAxisRenderingParameters.$, a) !== null) {
                d = a.ab;
                e = a.af;
                f = a.ac;
            }
            var _loop_5 = function (h) {
                a.e = h;
                a.f.s(((function () {
                    var $ret = new TickmarkValuesInitializationParameters();
                    $ret.n = h.d;
                    $ret.m = h.c;
                    $ret.g = a.m;
                    $ret.f = a.l;
                    $ret.k = h.b;
                    $ret.d = a.g;
                    $ret.l = a.p;
                    $ret.i = h.a;
                    $ret.p = h.e;
                    $ret.h = a.o;
                    $ret.j = a.q;
                    $ret.a = d;
                    $ret.q = e;
                    $ret.s = a.aa;
                    $ret.r = a.z;
                    $ret.e = f;
                    $ret.c = g;
                    return $ret;
                })()));
                h.a = a.f.m;
                h.e = a.f.r;
                if (!i2.isNaN_(a.f.m)) {
                    b = Math.max(b, a.f.m);
                    c = Math.max(c, a.f.r);
                }
            };
            try {
                for (var _c = tslib.__values(i2.fromEnum(a.k)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var h = _d.value;
                    _loop_5(h);
                }
            }
            catch (e_45_1) {
                e_45 = { error: e_45_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_45)
                        throw e_45.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(a.k)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var i = _f.value;
                    if (i.a == b) {
                        i.a = -1;
                        i.e = -1;
                    }
                    else {
                        i.a = b;
                        i.e = c;
                    }
                }
            }
            catch (e_46_1) {
                e_46 = { error: e_46_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_46)
                        throw e_46.error;
                }
            }
        };
        AxisRendererBase.prototype.x = function (a, b) {
            this.u();
            this.b.n(a, b);
            this.b.t();
        };
        AxisRendererBase.prototype.z = function () {
            var e_47, _a;
            this.b.t();
            var a = false;
            if (this.b.d) {
                this.b.s(0);
            }
            else {
                var b = 0;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.b.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        var d = i2.typeCast(i2.FrameworkElement.$, c);
                        if (d == null) {
                            d = this.b.u(b);
                            var e = d.ak;
                            var f = c.toString();
                            var g = 0;
                            var h = 0;
                            if (e != null) {
                                g = e.length;
                            }
                            if (f != null) {
                                h = f.length;
                            }
                            if (g != h) {
                                a = true;
                            }
                            d.ak = f;
                            b++;
                        }
                        else {
                            this.b.h(d);
                        }
                    }
                }
                catch (e_47_1) {
                    e_47 = { error: e_47_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_47)
                            throw e_47.error;
                    }
                }
                if (a) {
                    this.b.p();
                }
                this.b.g();
                this.b.s(b);
            }
        };
        AxisRendererBase.prototype.s = function (a) {
            return a.f;
        };
        AxisRendererBase.prototype.y = function (a) {
            var b = a.f.j();
            var c = a.f.k();
            this.b.r(this.m(a, a.f.m));
            this.j(a);
            for (var d = 0; d < b.length; d++) {
                var e = a.f.p + d;
                var f = b[d];
                var g = f;
                var h = 0;
                if (d < b.length - 1) {
                    h = b[d + 1];
                }
                else {
                    h = Number.POSITIVE_INFINITY;
                }
                g = this.r(a, g, e, a.f.m);
                h = this.r(a, h, e, a.f.m);
                var i = this.m(a, g);
                var j = this.m(a, h);
                if (this.q(a, i)) {
                    if (e % 2 == 0 && this.n(a, j) && !i2.isInfinity(j)) {
                        this.l(a, a.w, i, j);
                    }
                    a.b = a.c;
                    this.k(a, a.u, i);
                    a.b = null;
                }
                i = this.a(a, i, e, a.f.m);
                if (!i2.isNaN_(i) && !i2.isInfinity(i) && this.p(a, i, d == b.length - 1)) {
                    var k = this.w(a, g, e, a.f.m);
                    if (k != null) {
                        this.b.i(k, this.h(a, i));
                    }
                }
            }
            if (a.j) {
                for (var l = 0; l < c.length; l++) {
                    var m = c[l];
                    var n = this.m(a, m);
                    a.b = a.d;
                    this.k(a, a.v, n);
                    a.b = null;
                }
            }
        };
        AxisRendererBase.prototype.w = function (a, b, c, d) {
            return null;
        };
        AxisRendererBase.$t = i2.markType(AxisRendererBase, 'AxisRendererBase');
        return AxisRendererBase;
    }(i2.Base));
    /**
     * @hidden
     */
    var NumericAxisRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericAxisRenderer, _super);
        function NumericAxisRenderer(a) {
            var _this = _super.call(this, a) || this;
            _this.ac = null;
            _this.ad = false;
            return _this;
        }
        NumericAxisRenderer.prototype.w = function (a, b, c, d) {
            var e;
            if (a.s != null) {
                e = this.g(b);
            }
            else {
                b = Math.round(b * 1000000) / 1000000;
                if (a.i() && a.ab) {
                    return this.ae(b);
                }
                e = i2.MathUtil.n(b);
            }
            return e;
        };
        NumericAxisRenderer.prototype.ae = function (a) {
            if (this.ad) {
                return a.toString();
            }
            if (this.ac == null) {
                this.ac = NumberAbbreviatorFactory.a(this.b.a.bt);
                if (this.ac == null) {
                    this.ad = true;
                    return a.toString();
                }
            }
            return this.ac.abbreviate(a);
        };
        NumericAxisRenderer.$t = i2.markType(NumericAxisRenderer, 'NumericAxisRenderer', AxisRendererBase.$);
        return NumericAxisRenderer;
    }(AxisRendererBase));
    /**
     * @hidden
     */
    var VerticalAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalAxisLabelPanel, _super);
        function VerticalAxisLabelPanel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.da = 0;
            _this.c7 = 0;
            _this.c9 = 0;
            _this.c8 = 0;
            return _this;
        }
        VerticalAxisLabelPanel.prototype.ad = function () {
            return new VerticalAxisLabelPanelView(this);
        };
        VerticalAxisLabelPanel.prototype.cc = function (a) {
            _super.prototype.cc.call(this, a);
            this.c1 = a;
        };
        VerticalAxisLabelPanel.prototype.b1 = function () {
            this.c1.ay();
        };
        VerticalAxisLabelPanel.prototype.bl = function () {
            return this.ac.be != null ? this.ac.be.angle : -90;
        };
        VerticalAxisLabelPanel.prototype.c3 = function () {
            var a = 0;
            var b = this.ai(this.ac.be);
            if (b == 1) {
                a += this.bp();
            }
            var c = this.ag;
            if (c == 3 || c == 7) {
                a += this.ac.dr;
            }
            return a;
        };
        VerticalAxisLabelPanel.prototype.c5 = function () {
            var a = 0;
            var b = this.ai(this.ac.be);
            if (b == 2) {
                a += this.bp();
            }
            var c = this.ag;
            if (c == 2 || c == 6) {
                a += this.ac.dr;
            }
            return a;
        };
        VerticalAxisLabelPanel.prototype.c6 = function () {
            var a = (this.a9 - this.c3()) - this.c5();
            if (a < 0) {
                a = 0;
            }
            return a;
        };
        VerticalAxisLabelPanel.prototype.c4 = function () {
            var a = ((this.c6() - this.ae.p()) - this.ae.q());
            if (a < 0) {
                a = 0;
            }
            return a;
        };
        VerticalAxisLabelPanel.prototype.a1 = function () {
            var a = new i2.List$1(i2.Rect.$, 0);
            this.as = false;
            this.ar = false;
            if (this.af != null && this.af.j() && this.bh() % 360 != 0) {
                this.ar = true;
            }
            this.da = -1.7976931348623157E+308;
            this.c7 = -1.7976931348623157E+308;
            this.c9 = -1.7976931348623157E+308;
            this.c8 = -1.7976931348623157E+308;
            var b = this.ae.p();
            var c = this.ae.r();
            var d = this.ae.q();
            var e = this.ae.o();
            var f = this.c3();
            var g = false;
            if (!i2.isNaN_(this.ba)) {
                this.da = Math.max(this.ba, this.da);
                this.c9 = Math.max(this.bb, this.c9);
            }
            for (var h = 0; h < this.a7.count; h++) {
                var i = this.a7._inner[h];
                var j = this.a6._inner[h].a;
                var k = this.bf(i);
                var l = this.bg(i);
                var m = k + c + e;
                var n = l + b + d;
                var o = this.cu.left + f;
                var p = this.a6._inner[h].c - m / 2;
                if (j) {
                    var q = this.ba;
                    if ((i2.isNaN_(this.ba) || n > this.ba || this.a6._inner[h].b) && !g) {
                        if (this.a6._inner[h].b) {
                            g = true;
                        }
                        this.a6._inner[h].b = false;
                        this.ba = n;
                        this.bb = l;
                    }
                    this.da = Math.max(this.ba, this.da);
                    this.c7 = Math.max(m, this.c7);
                    this.c9 = Math.max(this.bb, this.c9);
                    this.c8 = Math.max(k, this.c8);
                }
                else {
                    this.da = Math.max(n, this.da);
                    this.c7 = Math.max(m, this.c7);
                    this.c9 = Math.max(l, this.c9);
                    this.c8 = Math.max(k, this.c8);
                }
                var r = new i2.Rect(0, o, p, n, m);
                a.add(r);
            }
            var s = 0;
            if (this.ar) {
                s = this.bh() % 360;
                if (s < 0) {
                    s += 360;
                }
            }
            var t = this.ac.b3();
            if (!t) {
                this.db(s, b, d);
            }
            else {
                this.ae.ac();
            }
            if (this.ar) {
                for (var u = 0; u < a.count; u++) {
                    var v = a._inner[u];
                    v.y = this.a6._inner[u].c - this.c7 / 2;
                    a._inner[u] = v;
                }
            }
            var w = false;
            if (!this.ar && this.da <= this.a9) {
                w = true;
            }
            if (!w) {
                var x = this.cu.height;
                var y = this.c6();
                var z = y;
                var aa = this.a6.count > 1 ? Math.abs(this.a6._inner[1].c - this.a6._inner[0].c) : x;
                var ab = Math.abs(Math.asin(aa / this.da) * (180 / Math.PI));
                var ac = (s >= ab && s <= 180 - ab) || (s - 180 >= ab && s - 180 <= 180 - ab);
                for (var ad = 0; ad < a.count; ad++) {
                    if (this.ar) {
                        var ae = s * (Math.PI / 180);
                        var af = this.bq(this.a7._inner[ad]);
                        z = Math.min(y / Math.abs(Math.cos(ae)), af);
                        if (ac) {
                            var ag = void 0;
                            if (s > 0 && s < 90) {
                                ag = (Math.PI / 180) * (90 - s);
                            }
                            else if (s > 270 && s < 360) {
                                ag = (Math.PI / 180) * (s - 270);
                            }
                            else {
                                ag = 0;
                            }
                            z = aa / Math.cos(ag);
                        }
                    }
                    var ah = a._inner[ad];
                    ah.width = Math.min(ah.width, z);
                    a._inner[ad] = ah;
                    if (!(i2.typeCast(i2.TextBlock.$, this.a7._inner[ad]) !== null)) {
                        this.a7._inner[ad].width = z;
                    }
                    var ai = i2.typeCast(i2.TextBlock.$, this.a7._inner[ad]);
                    if (ai != null) {
                        var aj = this.bw(ad, ai, z, b, d);
                        if (!i2.Base.equalsStatic(ai.ak, aj)) {
                            ai.ak = aj;
                            this.a7._inner[ad].width = z;
                        }
                    }
                }
                if (!t) {
                    this.db(s, b, d);
                }
            }
            if (this.c2()) {
                this.dc(a);
            }
            return a;
        };
        VerticalAxisLabelPanel.prototype.db = function (a, b, c) {
            var d = a * (Math.PI / 180);
            var e = Math.abs(this.c9 * Math.cos(d)) + Math.abs(this.c8 * Math.sin(d));
            var f = this.bp();
            var g = (e + b + c) + (f) + this.ac.dr;
            this.bd = Math.max(this.ac.eg, g);
        };
        VerticalAxisLabelPanel.prototype.dc = function (a) {
            this.c1.az(a, this.da);
        };
        VerticalAxisLabelPanel.prototype.cg = function (a, b) {
            var c = 0;
            var d = this.c8 / 2;
            var e = new i2.TransformGroup();
            var f = i2.AngleSimplifier.a(this.bh());
            var g = ((function () {
                var $ret = new i2.RotateTransform();
                $ret.j = f;
                $ret.k = c;
                $ret.l = d;
                return $ret;
            })());
            var h = 0;
            var i = 0;
            if (f != 0 && f != 360) {
                f -= 90;
                if (f > 0 && f < 180) {
                    g.k = this.c9;
                    h = -this.c9 + this.c8 / 2;
                    h = h + Math.sin(i2.MathUtil.k(f - 180)) * (this.c8 / 2);
                }
                else {
                    if (f >= 180) {
                        h = h - Math.cos(i2.MathUtil.k(f)) * (this.c8 / 2);
                    }
                    else {
                        h = h + Math.cos(i2.MathUtil.k(f)) * (this.c8 / 2);
                    }
                }
            }
            var j = ((function () {
                var $ret = new i2.TranslateTransform();
                $ret.j = h;
                $ret.k = i;
                return $ret;
            })());
            e.j.add(g);
            e.j.add(j);
            a.j = e;
        };
        VerticalAxisLabelPanel.prototype.c2 = function () {
            return !this.as && !this.ar;
        };
        VerticalAxisLabelPanel.prototype.ct = function () {
            var a = this.ai(this.ac.be);
            var b = this.bp();
            var c = this.ag;
            var d = 0;
            if (a == 1) {
                d += this.cu.left;
                if (c == 3 || c == 7) {
                    d += this.ac.dr;
                }
            }
            else {
                d = this.cu.right - b;
                if (c == 6 || c == 2) {
                    d -= this.ac.dr;
                }
            }
            var e = this.bn();
            var f = 0;
            var g = this.ac.be == null ? 1 : this.ac.be.verticalAlignment;
            if (g == 0) {
                f = this.cu.top;
            }
            else if (g == 2) {
                f = this.cu.bottom - e;
            }
            else {
                f = (this.cu.top + (this.cu.height / 2)) - (e / 2);
            }
            return new i2.Rect(0, d, f, b, e);
        };
        VerticalAxisLabelPanel.prototype.ai = function (a) {
            if (a == null) {
                return this.ac.bh.ao(this.ac);
            }
            if (a.position == 0) {
                if (this.ac != null && this.ac.bh != null) {
                    return this.ac.bh.ao(this.ac);
                }
                return 1;
            }
            return a.position;
        };
        VerticalAxisLabelPanel.prototype.ah = function () {
            return 2;
        };
        VerticalAxisLabelPanel.prototype.au = function (a) {
            return a == 2 || a == 3 || a == 6 || a == 7;
        };
        VerticalAxisLabelPanel.prototype.b4 = function () {
            var e_48, _a;
            var a = this.ae.at();
            this.ac.g0(a);
            if (this.af != null && this.af.visibility != 0) {
                return;
            }
            var b = this.ac.dr;
            if (b == 0) {
                return;
            }
            var c = this.ay();
            if (c == null) {
                return;
            }
            var d = this.cu.left;
            var e;
            var f = this.ag;
            if (f == 2 || f == 6) {
                d = this.cu.right;
                e = d - b;
            }
            else {
                e = d + b;
            }
            var g = this.ae.b();
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    this.b7(a, h, d, e, this.cw, g);
                }
            }
            catch (e_48_1) {
                e_48 = { error: e_48_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_48)
                        throw e_48.error;
                }
            }
            if (!this.ab.contains(this.ae.av)) {
                this.ab.add(this.ae.av);
            }
        };
        VerticalAxisLabelPanel.$t = i2.markType(VerticalAxisLabelPanel, 'VerticalAxisLabelPanel', AxisLabelPanelBase.$);
        return VerticalAxisLabelPanel;
    }(AxisLabelPanelBase));
    /**
     * @hidden
     */
    var IHasCategoryAxis_$type = new i2.Type(null, 'IHasCategoryAxis');
    /**
     * @hidden
     */
    var IHasCategoryModePreference_$type = new i2.Type(null, 'IHasCategoryModePreference', null, [IHasCategoryAxis_$type]);
    /**
     * @hidden
     */
    var IHighlightingManager_$type = new i2.Type(null, 'IHighlightingManager');
    /**
     * @hidden
     */
    var HighlightingInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighlightingInfo, _super);
        function HighlightingInfo() {
            var _this = _super.call(this) || this;
            _this.i = 0;
            _this.h = 0;
            _this.g = 0;
            _this.a = 0;
            _this.f = 0;
            _this.e = false;
            _this.d = false;
            _this.c = false;
            _this.b = null;
            _this.a = HighlightingState.outward;
            _this.f = 0;
            _this.e = false;
            return _this;
        }
        HighlightingInfo.$t = i2.markType(HighlightingInfo, 'HighlightingInfo');
        return HighlightingInfo;
    }(i2.Base));
    /**
     * @hidden
     */
    var ISeriesInteractionManager_$type = new i2.Type(null, 'ISeriesInteractionManager');
    /**
     * @hidden
     */
    var ISeriesViewerInteractionManager_$type = new i2.Type(null, 'ISeriesViewerInteractionManager');
    /**
     * @hidden
     */
    var IDataChartVisualDataManager_$type = new i2.Type(null, 'IDataChartVisualDataManager');
    /**
     * @hidden
     */
    var IAxisVisualDataManager_$type = new i2.Type(null, 'IAxisVisualDataManager');
    /**
     * @hidden
     */
    var ISeriesVisualDataManager_$type = new i2.Type(null, 'ISeriesVisualDataManager');
    /**
     * @hidden
     */
    var XamDataChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamDataChart, _super);
        function XamDataChart() {
            var _this = _super.call(this) || this;
            _this._xsr = null;
            _this.p7 = null;
            _this.qv = 1;
            _this.qw = 1;
            _this.qj = false;
            _this.qm = false;
            _this.qx = 0;
            _this.qy = 0;
            _this.rd = NaN;
            _this.re = NaN;
            _this.p2 = new AxisCollection();
            _this.axisRangeChanged = null;
            _this.qa = null;
            _this.qd = false;
            _this.qs = 0;
            _this.qu = 0;
            _this.qt = 0;
            _this.qr = 0;
            _this.q0 = NaN;
            _this.q2 = NaN;
            _this.q1 = NaN;
            _this.qz = NaN;
            _this.ab = XamDataChart.$;
            var a = _this.axes;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.sb));
            var b = _this.axes;
            b.collectionResetting = i2.delegateCombine(b.collectionResetting, i2.runOn(_this, _this.sc));
            return _this;
        }
        Object.defineProperty(XamDataChart.prototype, "XSRP", {
            get: function () {
                if (this._xsr == null) {
                    this._xsr = new i2.SRProvider(this.cf.j.ae);
                }
                return this._xsr;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "p8", {
            get: function () {
                var _this = this;
                if (this.p7 == null) {
                    this.p7 = i2.DVContainer.instance.createInstance(IDataChartVisualDataManager_$type, function () { return _this.XSRP.q; });
                }
                return this.p7;
            },
            enumerable: false,
            configurable: true
        });
        XamDataChart.staticInit = function () {
            XamDataChart.rc = -1.7976931348623157E+308;
            XamDataChart.rb = 1.7976931348623157E+308;
        };
        XamDataChart.rl = function (a) {
            if (a.ca == null) {
                return -1;
            }
            if (!a.ds) {
                return -1;
            }
            var b = XamDataChartView.aw(a);
            if (b.count == 0) {
                return -1;
            }
            var c = -1;
            for (var d = 0; d < b.count; d++) {
                c = Math.max(c, b._inner[d].g9);
            }
            var e = c + 1;
            if (a.dn) {
                e = a.gz();
                if (e == -1) {
                    return -1;
                }
                var f = a.be();
                e = f.g9 + e;
            }
            return e;
        };
        XamDataChart.prototype.lh = function (a, b, c, d) {
            var e_49, _a, e_50, _b, e_51, _c;
            _super.prototype.lh.call(this, a, b, c, d);
            switch (b) {
                case XamDataChart.$$p[15]:
                    this.q7 = this.rj;
                    break;
                case XamDataChart.$$p[16]:
                    this.q8 = this.rk;
                    break;
                case "ActualWindowScaleHorizontal":
                case "ActualWindowScaleVertical":
                    if (!this.eo) {
                        this.mr(this.fn(), this.fo());
                    }
                    break;
                case XamDataChart.$$p[7]:
                    this.cf.fm(d);
                    {
                        try {
                            for (var _d = tslib.__values(i2.fromEnum(this.axes)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var e = _e.value;
                                e.hp();
                            }
                        }
                        catch (e_49_1) {
                            e_49 = { error: e_49_1 };
                        }
                        finally {
                            try {
                                if (_e && !_e.done && (_a = _d.return))
                                    _a.call(_d);
                            }
                            finally {
                                if (e_49)
                                    throw e_49.error;
                            }
                        }
                    }
                    break;
                case XamDataChart.$$p[8]:
                    this.qi = this.qh;
                    break;
                case XamDataChart.$$p[14]:
                    this.ql = this.qp;
                    break;
                case XamDataChart.$$p[9]:
                case XamDataChart.$$p[11]:
                    this.mn();
                    break;
                case XamDataChart.$$p[0]:
                case XamDataChart.$$p[13]:
                    if (c != d) {
                        try {
                            for (var _f = tslib.__values(i2.fromEnum(this.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var f = _g.value;
                                f.ck = true;
                                f.hp();
                            }
                        }
                        catch (e_50_1) {
                            e_50 = { error: e_50_1 };
                        }
                        finally {
                            try {
                                if (_g && !_g.done && (_b = _f.return))
                                    _b.call(_f);
                            }
                            finally {
                                if (e_50)
                                    throw e_50.error;
                            }
                        }
                    }
                    break;
                case XamDataChart.$$p[6]:
                case XamDataChart.$$p[4]:
                case XamDataChart.$$p[5]:
                    try {
                        for (var _h = tslib.__values(i2.fromEnum(this.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var g = _j.value;
                            g.hy();
                        }
                    }
                    catch (e_51_1) {
                        e_51 = { error: e_51_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_51)
                                throw e_51.error;
                        }
                    }
                    break;
                case XamDataChart.$$p[3]:
                    this.se();
                    break;
            }
        };
        XamDataChart.prototype.j5 = function () {
            _super.prototype.j5.call(this);
            if (this.p4 == 1) {
                this.se();
            }
        };
        XamDataChart.prototype.si = function () {
            this.se();
        };
        XamDataChart.prototype.se = function () {
            var e_52, _a, e_53, _b;
            var a = this.s4();
            this.qd = false;
            if (!i2.isNaN_(this.rg)) {
                this.q4 = this.rg;
            }
            else {
                this.q4 = a.c;
            }
            if (!i2.isNaN_(this.ri)) {
                this.q6 = this.ri;
            }
            else {
                this.q6 = a.e;
            }
            if (!i2.isNaN_(this.rh)) {
                this.q5 = this.rh;
            }
            else {
                this.q5 = a.d;
            }
            if (!i2.isNaN_(this.rf)) {
                this.q3 = this.rf;
            }
            else {
                this.q3 = a.b;
            }
            this.pk = this.pi(this.pv);
            if (this.qd) {
                this.qd = false;
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.ck = true;
                        b.hp();
                    }
                }
                catch (e_52_1) {
                    e_52 = { error: e_52_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_52)
                            throw e_52.error;
                    }
                }
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.l0(false);
                    }
                }
                catch (e_53_1) {
                    e_53 = { error: e_53_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_53)
                            throw e_53.error;
                    }
                }
            }
        };
        XamDataChart.prototype.s4 = function () {
            switch (this.p4) {
                case 1:
                    var a = this.s5();
                    return a;
                default: return new i2.Thickness(1, 0, 0, 0, 0);
            }
        };
        XamDataChart.prototype.s5 = function () {
            var a = new i2.Thickness(1, 0, 0, 0, 0);
            for (var b = 0; b < this.series.count; b++) {
                var c = this.series._inner[b];
                var d = c.pg();
                a = new i2.Thickness(1, Math.max(d.c, a.c), Math.max(d.e, a.e), Math.max(d.d, a.d), Math.max(d.b, a.b));
            }
            return a;
        };
        XamDataChart.prototype.fn = function () {
            return this.q7;
        };
        XamDataChart.prototype.fo = function () {
            return this.q8;
        };
        XamDataChart.prototype.mf = function () {
            _super.prototype.mf.call(this);
            this.q7 = this.pg.width;
            this.q8 = this.pg.height;
        };
        Object.defineProperty(XamDataChart.prototype, "q7", {
            get: function () {
                return this.qv;
            },
            set: function (a) {
                var b = this.qv;
                this.qv = a;
                this.ll("ActualWindowScaleHorizontal", b, this.qv);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "q8", {
            get: function () {
                return this.qw;
            },
            set: function (a) {
                var b = this.qw;
                this.qw = a;
                this.ll("ActualWindowScaleVertical", b, this.qw);
            },
            enumerable: false,
            configurable: true
        });
        XamDataChart.prototype.d4 = function () {
            return this.qi;
        };
        XamDataChart.prototype.d5 = function () {
            return this.ql;
        };
        XamDataChart.prototype.sh = function () {
            this.qj = false;
            this.qm = true;
            for (var a = 0; a < this.axes.count; a++) {
                this.axes._inner[a].ck = true;
                this.axes._inner[a].hp();
            }
        };
        XamDataChart.prototype.sg = function (a, b, c, d) {
            if (a.ac == null) {
                return;
            }
            if (a.ac.ck || a.ac.js.isEmpty) {
                return;
            }
            var e = false;
            for (var f = 0; f < this.axes.count; f++) {
                var g = this.axes._inner[f].av.bd;
                this.axes._inner[f].av.b5();
                if (this.axes._inner[f].av.bd != g) {
                    e = true;
                }
            }
            if (e) {
                return;
            }
            if (i2.isNaN_(this.rd)) {
                this.rd = this.cf.a4;
                this.re = this.cf.a5;
            }
            var h = false;
            if (this.qm) {
                this.qm = false;
                h = true;
            }
            this.qj = true;
            var i = 0;
            var j = 0;
            var k = 0;
            var l = c.left + k;
            var m = d.right + k;
            var n = 0;
            n = this.pv.right + this.cf.a5;
            if (l < 0) {
                i = -l;
                i += this.q9;
            }
            if (m > n) {
                j = m - n;
                j += this.q9;
            }
            if (h) {
                if (l > 0) {
                    i = -l;
                    i += this.q9;
                }
                if (m < n) {
                    j = -(n - m);
                    j += this.q9;
                }
            }
            var o = false;
            var p = false;
            if (i != 0 || j != 0) {
                o = true;
                this.qx = this.qx + i;
                this.qy = this.qy + j;
                if (this.qx > this.ra) {
                    this.qx = this.ra;
                    p = true;
                }
                if (this.qy > this.ra) {
                    this.qy = this.ra;
                    p = true;
                }
                if (this.qx < 0) {
                    this.qx = 0;
                    p = true;
                }
                if (this.qy < 0) {
                    this.qy = 0;
                    p = true;
                }
            }
            else {
                return;
            }
            this.en = true;
            this.fq = this.rd + this.qx;
            this.ft = this.re + this.qy;
            this.en = false;
            this.d9 = o;
            if (p) {
                return;
            }
            if (this.d9) {
                for (var q = 0; q < this.axes.count; q++) {
                    this.axes._inner[q].ck = true;
                    this.axes._inner[q].hq(false);
                }
                this.ji(true, false, false);
                this.qj = false;
                for (var r = 0; r < this.axes.count; r++) {
                    this.axes._inner[r].ck = true;
                    this.axes._inner[r].hq(false);
                }
                this.ji(true, false, false);
            }
        };
        Object.defineProperty(XamDataChart.prototype, "axes", {
            get: function () {
                return this.p2;
            },
            enumerable: false,
            configurable: true
        });
        XamDataChart.prototype.sb = function (a, b) {
            var e_54, _a, e_55, _b, e_56, _c;
            if (b.oldItems != null) {
                try {
                    for (var _d = tslib.__values(i2.fromEn(b.oldItems)), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var c = _e.value;
                        if (c != null) {
                            c.bn = null;
                            c.bh = null;
                            this.l0(c);
                            this.cf.dt(c);
                            c.rangeChanged = i2.delegateRemove(c.rangeChanged, i2.runOn(this, this.sd));
                            this.cf.du(c);
                            if (c.c7 != null) {
                                try {
                                    for (var _f = (e_55 = void 0, tslib.__values(i2.fromEnum(c.c4()))), _g = _f.next(); !_g.done; _g = _f.next()) {
                                        var d = _g.value;
                                        d.l0(false);
                                    }
                                }
                                catch (e_55_1) {
                                    e_55 = { error: e_55_1 };
                                }
                                finally {
                                    try {
                                        if (_g && !_g.done && (_b = _f.return))
                                            _b.call(_f);
                                    }
                                    finally {
                                        if (e_55)
                                            throw e_55.error;
                                    }
                                }
                            }
                        }
                    }
                }
                catch (e_54_1) {
                    e_54 = { error: e_54_1 };
                }
                finally {
                    try {
                        if (_e && !_e.done && (_a = _d.return))
                            _a.call(_d);
                    }
                    finally {
                        if (e_54)
                            throw e_54.error;
                    }
                }
                if (this.axes.count == 0) {
                    this.l5();
                }
            }
            if (b.newItems != null) {
                try {
                    for (var _h = tslib.__values(i2.fromEn(b.newItems)), _j = _h.next(); !_j.done; _j = _h.next()) {
                        var e = _j.value;
                        if (e != null) {
                            this.mi(e);
                            e.bn = this.actualSyncLink;
                            e.bh = this;
                            e.a4.aw();
                            this.cf.bo(e);
                            e.rangeChanged = i2.delegateCombine(e.rangeChanged, i2.runOn(this, this.sd));
                            this.cf.bl(e);
                        }
                    }
                }
                catch (e_56_1) {
                    e_56 = { error: e_56_1 };
                }
                finally {
                    try {
                        if (_j && !_j.done && (_c = _h.return))
                            _c.call(_h);
                    }
                    finally {
                        if (e_56)
                            throw e_56.error;
                    }
                }
            }
            this.jz();
        };
        XamDataChart.prototype.sc = function (a, b) {
            var e_57, _a, e_58, _b, e_59, _c, e_60, _d;
            var c = new i2.List$1(Series.$, 0);
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.axes)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    if (d.c7 != null) {
                        try {
                            for (var _g = (e_58 = void 0, tslib.__values(i2.fromEnum(d.c4()))), _h = _g.next(); !_h.done; _h = _g.next()) {
                                var e = _h.value;
                                if (!c.contains(e)) {
                                    c.add(e);
                                }
                            }
                        }
                        catch (e_58_1) {
                            e_58 = { error: e_58_1 };
                        }
                        finally {
                            try {
                                if (_h && !_h.done && (_b = _g.return))
                                    _b.call(_g);
                            }
                            finally {
                                if (e_58)
                                    throw e_58.error;
                            }
                        }
                    }
                    d.bn = null;
                    d.bh = null;
                    this.l0(d);
                    this.cf.dt(d);
                    d.rangeChanged = i2.delegateRemove(d.rangeChanged, i2.runOn(this, this.sd));
                    this.cf.du(d);
                    this.l5();
                }
            }
            catch (e_57_1) {
                e_57 = { error: e_57_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_a = _e.return))
                        _a.call(_e);
                }
                finally {
                    if (e_57)
                        throw e_57.error;
                }
            }
            try {
                for (var _j = tslib.__values(i2.fromEnum(this.series)), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var f = _k.value;
                    if (!c.contains(f)) {
                        c.add(f);
                    }
                }
            }
            catch (e_59_1) {
                e_59 = { error: e_59_1 };
            }
            finally {
                try {
                    if (_k && !_k.done && (_c = _j.return))
                        _c.call(_j);
                }
                finally {
                    if (e_59)
                        throw e_59.error;
                }
            }
            try {
                for (var _l = tslib.__values(i2.fromEnum(c)), _m = _l.next(); !_m.done; _m = _l.next()) {
                    var g = _m.value;
                    g.l0(false);
                }
            }
            catch (e_60_1) {
                e_60 = { error: e_60_1 };
            }
            finally {
                try {
                    if (_m && !_m.done && (_d = _l.return))
                        _d.call(_l);
                }
                finally {
                    if (e_60)
                        throw e_60.error;
                }
            }
        };
        XamDataChart.prototype.sd = function (a, b) {
            var e_61, _a, e_62, _b, e_63, _c;
            var c = i2.typeCast(Axis.$, a);
            if (c == null) {
                return;
            }
            this.jz();
            if (this.axisRangeChanged != null) {
                this.axisRangeChanged(this, new ChartAxisRangeChangedEventArgs(this, c, b.oldMinimumValue, b.minimumValue, b.oldMaximumValue, b.maximumValue));
            }
            if (c.ai != null) {
                c.ai.hm();
            }
            c.hm();
            var d = this.da;
            if (i2.typeCast(CategoryAxisBase.$, c) !== null) {
                d = true;
            }
            try {
                for (var _d = tslib.__values(i2.fromEnum(c.c4())), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var e = _e.value;
                    e.et = true;
                    this.jz();
                    e.l0(d);
                }
            }
            catch (e_61_1) {
                e_61 = { error: e_61_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_61)
                        throw e_61.error;
                }
            }
            if (c.bh != null) {
                try {
                    for (var _f = tslib.__values(i2.fromEnum(c.bh.series)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var f = _g.value;
                        XamDataChart.sf(c, d, f);
                    }
                }
                catch (e_62_1) {
                    e_62 = { error: e_62_1 };
                }
                finally {
                    try {
                        if (_g && !_g.done && (_b = _f.return))
                            _b.call(_f);
                    }
                    finally {
                        if (e_62)
                            throw e_62.error;
                    }
                }
            }
            try {
                for (var _h = tslib.__values(i2.fromEnum(this.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var g = _j.value;
                    if (g != c && g.ai != null && g.ai == c) {
                        g.hm();
                    }
                }
            }
            catch (e_63_1) {
                e_63 = { error: e_63_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_63)
                        throw e_63.error;
                }
            }
        };
        XamDataChart.sf = function (a, b, c) {
        };
        XamDataChart.prototype.mp = function (a, b) {
            var e_64, _a;
            _super.prototype.mp.call(this, a, b);
            if (this.axes == null) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.bn = this.actualSyncLink;
                    c.bh = this;
                }
            }
            catch (e_64_1) {
                e_64 = { error: e_64_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_64)
                        throw e_64.error;
                }
            }
        };
        XamDataChart.prototype.getFontInfo = function () {
            this.qa = this.p9.fj;
            return this.qa;
        };
        XamDataChart.prototype.sj = function () {
            var e_65, _a, e_66, _b;
            this.cf.eb();
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    a.hq(false);
                }
            }
            catch (e_65_1) {
                e_65 = { error: e_65_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_65)
                        throw e_65.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    b.bx.bj();
                    b.l0(false);
                }
            }
            catch (e_66_1) {
                e_66 = { error: e_66_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_66)
                        throw e_66.error;
                }
            }
        };
        XamDataChart.prototype.getFontBrush = function () {
            return this.p9.fr;
        };
        XamDataChart.prototype.jd = function () {
            _super.prototype.jd.call(this);
            var a = new i2.List$1(Axis.$, 0);
            for (var b = 0; b < this.axes.count; b++) {
                a.add(this.axes._inner[b]);
            }
            for (var c = 0; c < a.count; c++) {
                this.axes.remove(a._inner[c]);
                if (i2.typeCast(CategoryAxisBase.$, a._inner[c]) !== null) {
                    var d = a._inner[c];
                    this.l2(d.name, true);
                    d.itemsSource = null;
                }
                a._inner[c].hf(null, null);
            }
        };
        XamDataChart.prototype.os = function () {
            return this.p9.fn;
        };
        XamDataChart.prototype.eh = function () {
            return true;
        };
        XamDataChart.prototype.mj = function () {
            var e_67, _a;
            _super.prototype.mj.call(this);
            if (!this.d7) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    this.mi(a);
                }
            }
            catch (e_67_1) {
                e_67 = { error: e_67_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_67)
                        throw e_67.error;
                }
            }
        };
        XamDataChart.prototype.di = function () {
            if (this.qk) {
                return true;
            }
            return this.qg();
        };
        XamDataChart.prototype.qg = function () {
            for (var a = 0; a < this.series.count; a++) {
                if (this.series._inner[a].d4 || this.series._inner[a].d0) {
                    return true;
                }
            }
            for (var b = 0; b < this.axes.count; b++) {
                if (this.axes._inner[b].b4 || this.axes._inner[b].cg) {
                    return true;
                }
            }
            return false;
        };
        XamDataChart.prototype.ce = function () {
            return new XamDataChartView(this);
        };
        XamDataChart.prototype.k5 = function (a) {
            _super.prototype.k5.call(this, a);
            this.p9 = a;
        };
        XamDataChart.prototype.lx = function () {
            for (var a = 0; a < this.p2.count; a++) {
                this.p2._inner[a].ck = true;
                this.p2._inner[a].hq(false);
            }
            _super.prototype.lx.call(this);
        };
        Object.defineProperty(XamDataChart.prototype, "q4", {
            get: function () {
                return this.qs;
            },
            set: function (a) {
                var b = this.qs;
                this.qs = a;
                if (this.qs != b) {
                    this.qd = true;
                    this.ll(XamDataChart.ro, b, this.qs);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "q6", {
            get: function () {
                return this.qu;
            },
            set: function (a) {
                var b = this.qu;
                this.qu = a;
                if (this.qu != b) {
                    this.qd = true;
                    this.ll(XamDataChart.rq, b, this.qu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "q5", {
            get: function () {
                return this.qt;
            },
            set: function (a) {
                var b = this.qt;
                this.qt = a;
                if (this.qt != b) {
                    this.qd = true;
                    this.ll(XamDataChart.rp, b, this.qt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "q3", {
            get: function () {
                return this.qr;
            },
            set: function (a) {
                var b = this.qr;
                this.qr = a;
                if (this.qr != b) {
                    this.qd = true;
                    this.ll(XamDataChart.rn, b, this.qr);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "rg", {
            get: function () {
                return this.q0;
            },
            set: function (a) {
                this.q0 = a;
                this.se();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "ri", {
            get: function () {
                return this.q2;
            },
            set: function (a) {
                this.q2 = a;
                this.se();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "rh", {
            get: function () {
                return this.q1;
            },
            set: function (a) {
                this.q1 = a;
                this.se();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDataChart.prototype, "rf", {
            get: function () {
                return this.qz;
            },
            set: function (a) {
                this.qz = a;
                this.se();
            },
            enumerable: false,
            configurable: true
        });
        XamDataChart.prototype.pi = function (a) {
            var b = _super.prototype.pi.call(this, a);
            if (a.isEmpty) {
                return i2.Rect.empty;
            }
            if (this.q4 == 0 && this.q6 == 0 && this.q5 == 0 && this.q3 == 0) {
                return i2.Rect.empty;
            }
            if (this.q4 + this.q5 >= a.width || this.q6 + this.q3 >= a.height) {
                return i2.Rect.empty;
            }
            var c = new i2.Rect(0, a.left + this.q4, a.top + this.q6, a.width - this.q4 - this.q5, a.height - this.q6 - this.q3);
            return c;
        };
        XamDataChart.prototype.po = function () {
            var a = this.pv;
            var b = this.pw;
            var c = this.pk;
            if (c.isEmpty || a.isEmpty) {
                return a;
            }
            if (c.containsRect(a)) {
                return a;
            }
            if (a.containsRect(c)) {
                return c;
            }
            return a;
        };
        XamDataChart.prototype.rm = function () {
            return this.p8.exportVisualData(this);
        };
        XamDataChart.prototype.r0 = function () {
            var cvd_ = this.rm();
            cvd_.scaleByViewport();
            return (cvd_.serialize());
        };
        XamDataChart.prototype.le = function () {
            _super.prototype.le.call(this);
            for (var a = 0; a < this.axes.count; a++) {
                var b = this.axes._inner[a];
                var c = 50;
                if (!i2.isNaN_(b.av.bd)) {
                    c = b.av.bd;
                }
                b.du = c;
            }
        };
        XamDataChart.prototype.lz = function () {
            _super.prototype.lz.call(this);
            for (var a = 0; a < this.axes.count; a++) {
                var b = this.axes._inner[a];
                b.du = NaN;
                b.ck = true;
                b.hq(false);
            }
        };
        XamDataChart.prototype.qq = function (a) {
            var e_68, _a;
            var b = new i2.List$1(Axis.$, 0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = c.an(a);
                    if (d != null) {
                        b.add(d);
                    }
                }
            }
            catch (e_68_1) {
                e_68 = { error: e_68_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_68)
                        throw e_68.error;
                }
            }
            return b;
        };
        XamDataChart.$t = i2.markType(XamDataChart, 'XamDataChart', SeriesViewer.$);
        XamDataChart.rc = 0;
        XamDataChart.rb = 0;
        XamDataChart.ro = "ActualPlotAreaMarginLeft";
        XamDataChart.rq = "ActualPlotAreaMarginTop";
        XamDataChart.rp = "ActualPlotAreaMarginRight";
        XamDataChart.rn = "ActualPlotAreaMarginBottom";
        XamDataChart.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, XamDataChart, 'll', ['AlignsGridLinesToPixels:qe:sk', [0, true], 'AutoExpandMarginExtraPadding:q9:sl', [1, i2.DeviceUtils.g(2)], 'AutoExpandMarginMaximumValue:ra:sm', [1, 60], 'ComputedPlotAreaMarginMode:p4:sn', [ComputedPlotAreaMarginMode_$type, i2.enumGetBox(ComputedPlotAreaMarginMode_$type, 0)], 'DefaultAxisMajorStroke:s1:so', [i2.Brush.$, null], 'DefaultAxisMinorStroke:s2:sp', [i2.Brush.$, null], 'DefaultAxisStroke:s3:sq', [i2.Brush.$, null], 'GridMode:p6:sr', [GridMode_$type, i2.enumGetBox(GridMode_$type, 2)], 'HorizontalZoomable:qh:ss', [0, false], 'IsHorizontalZoomEnabled:qi:st', [0, false], 'IsSquare:qk:su', [0, false], 'IsVerticalZoomEnabled:ql:sv', [0, false], 'ShouldAutoExpandMarginForInitialLabels:qn:sw', [0, false], 'ShouldClipGridlines:qo:sx', [0, true], 'VerticalZoomable:qp:sy', [0, false], 'WindowScaleHorizontal:rj:sz', [1, NaN], 'WindowScaleVertical:rk:s0', [1, NaN]]);
        return XamDataChart;
    }(SeriesViewer));
    /**
     * @hidden
     */
    var LabelPanelArranger = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LabelPanelArranger, _super);
        function LabelPanelArranger() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LabelPanelArranger.e = function (a, b) {
            var e_69, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = c.ac;
                    var e = d.ai;
                    e = LabelPanelArranger.a(c, d, e);
                    var f = LabelPanelArranger.b(c);
                    var g = 0;
                    var h = 0;
                    var i = 0;
                    if (d.b3()) {
                        c.ae.ac();
                        i = c.bd;
                    }
                    else {
                        i = c.be(b);
                    }
                    g = i;
                    h = i;
                    if (c.ac.ay != null && c.ac.ay.visibility != 0) {
                        h = 0;
                        g = 0;
                    }
                    if (c.ao()) {
                        switch (f) {
                            case 0:
                                b.y = Math.max(0, b.top + h);
                                b.height = Math.max(0, b.height - h);
                                d.ay.c = 0;
                                break;
                            case 4:
                                if (e != null && (c.bc - b.top < h && i2.typeCast(HorizontalAxisLabelPanel.$, c) !== null)) {
                                    d.ay.c = 5;
                                }
                                else {
                                    d.ay.c = 4;
                                }
                                break;
                            case 5:
                                if (e != null && (b.bottom - c.bc < h && i2.typeCast(HorizontalAxisLabelPanel.$, c) !== null)) {
                                    if (d.ay != null) {
                                        d.ay.c = 4;
                                    }
                                }
                                else {
                                    if (d.ay != null) {
                                        d.ay.c = 5;
                                    }
                                }
                                break;
                            case 1:
                            default:
                                if (d.ay != null) {
                                    d.ay.c = 1;
                                }
                                b.height = Math.max(0, b.height - h);
                                break;
                        }
                    }
                    if (i2.typeCast(VerticalAxisLabelPanel.$, c) !== null) {
                        switch (f) {
                            case 3:
                                b.width = Math.max(0, b.width - g);
                                d.ay.c = 3;
                                break;
                            case 6:
                                if (e != null && c.bc - b.left < g) {
                                    d.ay.c = 7;
                                }
                                else {
                                    d.ay.c = 6;
                                }
                                break;
                            case 7:
                                if (e != null && b.right - c.bc < g) {
                                    d.ay.c = 6;
                                }
                                else {
                                    d.ay.c = 7;
                                }
                                break;
                            case 2:
                            default:
                                if (d.ay != null) {
                                    d.ay.c = 2;
                                }
                                b.x = Math.max(0, b.left + g);
                                b.width = Math.max(0, b.width - g);
                                break;
                        }
                    }
                    if (c.ac.b4) {
                        if (d.ay != null) {
                            d.ay.c = f;
                        }
                    }
                }
            }
            catch (e_69_1) {
                e_69 = { error: e_69_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_69)
                        throw e_69.error;
                }
            }
            return b;
        };
        LabelPanelArranger.a = function (a, b, c) {
            return b.aj();
        };
        LabelPanelArranger.b = function (a) {
            if (a == null) {
                return 1;
            }
            else {
                var b = a.ac;
                if (b != null && b.ay != null) {
                    var c = b.ay.c;
                    if (!a.au(c)) {
                        return a.ah();
                    }
                    return c;
                }
                else {
                    return a.ah();
                }
            }
        };
        LabelPanelArranger.c = function (a, b, c, d) {
            var e = a.ac;
            var f = e.ai;
            f = LabelPanelArranger.a(a, e, f);
            var g = LabelPanelArranger.b(a);
            var h;
            var i = a.be(c);
            var j = Math.max(0, i);
            var k = Math.max(0, i);
            if (a.ac != null && a.ac.ay != null && a.ac.ay.visibility == 1) {
                return;
            }
            switch (g) {
                case 3:
                    b.g = b.g - k;
                    b.d = b.d - k;
                    h = new i2.Rect(0, b.g, c.top, k, c.height);
                    d(a, h);
                    break;
                case 2:
                    h = new i2.Rect(0, b.f, c.top, k, c.height);
                    d(a, h);
                    b.f = b.f + k;
                    b.c = b.c + k;
                    break;
                case 7:
                    if (f != null) {
                        h = new i2.Rect(0, b.f + a.bc, c.top, k, c.height);
                    }
                    else {
                        b.d = b.d - k;
                        h = new i2.Rect(0, b.d, c.top, k, c.height);
                    }
                    d(a, h);
                    break;
                case 6:
                    if (f != null) {
                        h = new i2.Rect(0, b.f + a.bc - k, c.top, k, c.height);
                    }
                    else {
                        h = new i2.Rect(0, b.c, c.top, k, c.height);
                        b.c = b.c + k;
                    }
                    d(a, h);
                    break;
                case 1:
                    b.a = b.a - j;
                    b.b = b.b - j;
                    h = new i2.Rect(0, c.left, b.a, c.width, j);
                    d(a, h);
                    break;
                case 0:
                    h = new i2.Rect(0, c.left, b.h, c.width, j);
                    d(a, h);
                    b.h = b.h + j;
                    b.e = b.e + j;
                    break;
                case 5:
                    if (f != null) {
                        h = new i2.Rect(0, c.left, b.h + a.bc, c.width, j);
                    }
                    else {
                        b.b = b.b - j;
                        h = new i2.Rect(0, c.left, b.b, c.width, j);
                    }
                    d(a, h);
                    break;
                case 4:
                    if (f != null) {
                        h = new i2.Rect(0, c.left, b.h + a.bc - j, c.width, j);
                    }
                    else {
                        h = new i2.Rect(0, c.left, b.e, c.width, j);
                        b.e = b.e + j;
                    }
                    d(a, h);
                    break;
            }
            if (a.ac.b4) {
                h = new i2.Rect(0, c.left, c.top, c.width, c.height);
                d(a, h);
            }
        };
        LabelPanelArranger.d = function (a, b, c, d) {
            var e_70, _a, e_71, _b, e_72, _c;
            var e = new i2.List$1(AxisLabelPanelBase.$, 0);
            var f = new i2.List$1(AxisLabelPanelBase.$, 0);
            try {
                for (var _d = tslib.__values(i2.fromEnum(a)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var g = _e.value;
                    var h = LabelPanelArranger.b(g);
                    switch (h) {
                        case 1:
                        case 2:
                        case 0:
                        case 3:
                            f.add(g);
                            break;
                        case 5:
                        case 6:
                        case 4:
                        case 7:
                            e.add(g);
                            break;
                    }
                }
            }
            catch (e_70_1) {
                e_70 = { error: e_70_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_70)
                        throw e_70.error;
                }
            }
            try {
                for (var _f = tslib.__values(i2.fromEnum(f)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var i = _g.value;
                    LabelPanelArranger.c(i, b, c, d);
                }
            }
            catch (e_71_1) {
                e_71 = { error: e_71_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_71)
                        throw e_71.error;
                }
            }
            try {
                for (var _h = tslib.__values(i2.fromEnum(e)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var j = _j.value;
                    LabelPanelArranger.c(j, b, c, d);
                }
            }
            catch (e_72_1) {
                e_72 = { error: e_72_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_72)
                        throw e_72.error;
                }
            }
        };
        LabelPanelArranger.$t = i2.markType(LabelPanelArranger, 'LabelPanelArranger');
        return LabelPanelArranger;
    }(i2.Base));
    /**
     * @hidden
     */
    var ChartContentManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartContentManager, _super);
        function ChartContentManager(a) {
            var _this = _super.call(this) || this;
            _this.l = null;
            _this.r = new i2.Dictionary$2(ChartContentType_$type, i2.Dictionary$2.$.specialize(i2.DependencyObject.$, ContentInfo.$), 0);
            _this.t = new i2.List$1(Series.$, 0);
            _this.m = false;
            _this.v = null;
            _this.q = false;
            _this.o = false;
            _this.n = false;
            _this.p = false;
            _this.p = true;
            _this.o = true;
            _this.n = true;
            _this.r.addItem(0, new i2.Dictionary$2(i2.DependencyObject.$, ContentInfo.$, 0));
            _this.r.addItem(1, new i2.Dictionary$2(i2.DependencyObject.$, ContentInfo.$, 0));
            _this.r.addItem(2, new i2.Dictionary$2(i2.DependencyObject.$, ContentInfo.$, 0));
            _this.l = a;
            return _this;
        }
        Object.defineProperty(ChartContentManager.prototype, "u", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                this.t = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartContentManager.prototype.k = function (a, b, c) {
            var d = this.j(a, b);
            d.a = c;
            return d;
        };
        ChartContentManager.prototype.ad = function (a, b) {
            var c = this.r.item(a);
            if (c.containsKey(b)) {
                c.removeItem(b);
            }
            var d = i2.typeCast(Series.$, b);
            if (d != null && this.u.contains(d)) {
                this.u.remove(d);
            }
        };
        ChartContentManager.prototype.aa = function (a) {
            var b = this.v;
            this.v = a;
            if (this.m && b == null && this.v != null) {
                this.v.setTimeout(i2.runOn(this, this.w), 0);
            }
        };
        ChartContentManager.prototype.z = function () {
            if (!this.m) {
                this.m = true;
                if (this.v != null) {
                    this.v.setTimeout(i2.runOn(this, this.w), 0);
                }
                else {
                }
            }
        };
        ChartContentManager.prototype.ac = function (a, b, c, d) {
            var e = c;
            if (!e.c) {
                e.b = d;
            }
            else {
                if (!d) {
                    e.b = false;
                }
            }
            if (!e.c) {
                e.c = true;
                this.z();
            }
        };
        ChartContentManager.prototype.j = function (a, b) {
            var c = this.r.item(a);
            var d = null;
            if (!((function () { var e = c.tryGetValue(b, d); d = e.p1; return e.ret; })())) {
                d = new ContentInfo();
                d.h = b;
                c.addItem(b, d);
                var e = i2.typeCast(Series.$, b);
                if (e != null && !this.u.contains(e)) {
                    if (e.dn) {
                        var f = e.be();
                        var g = this.u.indexOf(f) + 1;
                        g += e.g3();
                        if (this.u.count <= g || f.g8() == 0 || g == -1) {
                            this.u.add(e);
                        }
                        else {
                            this.u.insert(g, e);
                        }
                    }
                    else {
                        this.u.add(e);
                    }
                }
            }
            return d;
        };
        ChartContentManager.prototype.y = function () {
            this.w();
        };
        ChartContentManager.prototype.w = function () {
            var e_73, _a;
            if (this.l == null || this.r == null) {
                return;
            }
            if (!this.m) {
                return;
            }
            this.m = false;
            if (this.l != null) {
                this.l.i5();
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.s())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.f();
                }
            }
            catch (e_73_1) {
                e_73 = { error: e_73_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_73)
                        throw e_73.error;
                }
            }
            if (!this.m) {
                this.l.lm();
            }
        };
        ChartContentManager.prototype._s = function () {
            var a, _a, _b, b, e_74_1, c, _c, _d, d, _e, _f, e, _g, _h, f, e_75_1, _j, _k, g, e_76_1;
            var e_74, _l, e_77, _m, e_78, _o, e_75, _p, e_76, _q;
            return tslib.__generator(this, function (_r) {
                switch (_r.label) {
                    case 0:
                        a = null;
                        a = this.r.item(1);
                        _r.label = 1;
                    case 1:
                        _r.trys.push([1, 6, 7, 8]);
                        _a = tslib.__values(i2.fromEnum(a.values)), _b = _a.next();
                        _r.label = 2;
                    case 2:
                        if (!!_b.done)
                            return [3 /*break*/, 5];
                        b = _b.value;
                        return [4 /*yield*/, b];
                    case 3:
                        _r.sent();
                        _r.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_74_1 = _r.sent();
                        e_74 = { error: e_74_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_l = _a.return))
                                _l.call(_a);
                        }
                        finally {
                            if (e_74)
                                throw e_74.error;
                        }
                        return [7 /*endfinally*/];
                    case 8:
                        a = this.r.item(0);
                        c = new i2.List$1(ContentInfo.$, 0);
                        try {
                            for (_c = tslib.__values(i2.fromEnum(this.u)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                d = _d.value;
                                if (!d.c6) {
                                    c.add(a.item(d));
                                }
                            }
                        }
                        catch (e_77_1) {
                            e_77 = { error: e_77_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_m = _c.return))
                                    _m.call(_c);
                            }
                            finally {
                                if (e_77)
                                    throw e_77.error;
                            }
                        }
                        try {
                            for (_e = tslib.__values(i2.fromEnum(this.u)), _f = _e.next(); !_f.done; _f = _e.next()) {
                                e = _f.value;
                                if (e.c6) {
                                    c.add(a.item(e));
                                }
                            }
                        }
                        catch (e_78_1) {
                            e_78 = { error: e_78_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_o = _e.return))
                                    _o.call(_e);
                            }
                            finally {
                                if (e_78)
                                    throw e_78.error;
                            }
                        }
                        _r.label = 9;
                    case 9:
                        _r.trys.push([9, 14, 15, 16]);
                        _g = tslib.__values(i2.fromEnum(c)), _h = _g.next();
                        _r.label = 10;
                    case 10:
                        if (!!_h.done)
                            return [3 /*break*/, 13];
                        f = _h.value;
                        return [4 /*yield*/, f];
                    case 11:
                        _r.sent();
                        _r.label = 12;
                    case 12:
                        _h = _g.next();
                        return [3 /*break*/, 10];
                    case 13: return [3 /*break*/, 16];
                    case 14:
                        e_75_1 = _r.sent();
                        e_75 = { error: e_75_1 };
                        return [3 /*break*/, 16];
                    case 15:
                        try {
                            if (_h && !_h.done && (_p = _g.return))
                                _p.call(_g);
                        }
                        finally {
                            if (e_75)
                                throw e_75.error;
                        }
                        return [7 /*endfinally*/];
                    case 16:
                        a = this.r.item(2);
                        _r.label = 17;
                    case 17:
                        _r.trys.push([17, 22, 23, 24]);
                        _j = tslib.__values(i2.fromEnum(a.values)), _k = _j.next();
                        _r.label = 18;
                    case 18:
                        if (!!_k.done)
                            return [3 /*break*/, 21];
                        g = _k.value;
                        return [4 /*yield*/, g];
                    case 19:
                        _r.sent();
                        _r.label = 20;
                    case 20:
                        _k = _j.next();
                        return [3 /*break*/, 18];
                    case 21: return [3 /*break*/, 24];
                    case 22:
                        e_76_1 = _r.sent();
                        e_76 = { error: e_76_1 };
                        return [3 /*break*/, 24];
                    case 23:
                        try {
                            if (_k && !_k.done && (_q = _j.return))
                                _q.call(_j);
                        }
                        finally {
                            if (e_76)
                                throw e_76.error;
                        }
                        return [7 /*endfinally*/];
                    case 24: return [2 /*return*/];
                }
            });
        };
        ChartContentManager.prototype.s = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._s(); });
        };
        ChartContentManager.prototype.x = function (a) {
            var e_79, _a, e_80, _b, e_81, _c;
            try {
                for (var _d = tslib.__values(i2.fromEnum(this.r.item(1).values)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var b = _e.value;
                    b.h.hb(a);
                }
            }
            catch (e_79_1) {
                e_79 = { error: e_79_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_79)
                        throw e_79.error;
                }
            }
            try {
                for (var _f = tslib.__values(i2.fromEnum(this.r.item(1).values)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var c = _g.value;
                    c.f();
                }
            }
            catch (e_80_1) {
                e_80 = { error: e_80_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_80)
                        throw e_80.error;
                }
            }
            try {
                for (var _h = tslib.__values(i2.fromEnum(this.r.item(1).values)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var d = _j.value;
                    d.h.hx();
                }
            }
            catch (e_81_1) {
                e_81 = { error: e_81_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_81)
                        throw e_81.error;
                }
            }
        };
        ChartContentManager.prototype.ae = function (a, b, c, d) {
            c.i = d;
        };
        ChartContentManager.prototype.ab = function (a, b) {
            if (!b.e) {
                b.e = true;
                this.z();
            }
        };
        ChartContentManager.$t = i2.markType(ChartContentManager, 'ChartContentManager', i2.DependencyObject.$);
        return ChartContentManager;
    }(i2.DependencyObject));
    /**
     * @hidden
     */
    var ContentInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContentInfo, _super);
        function ContentInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.h = null;
            _this.a = null;
            _this.b = false;
            _this.c = false;
            _this.i = null;
            _this.e = false;
            return _this;
        }
        Object.defineProperty(ContentInfo.prototype, "d", {
            get: function () {
                if (this.i.isEmpty) {
                    return false;
                }
                if (this.i.width == 0 && this.i.height == 0) {
                    return false;
                }
                return true;
            },
            enumerable: false,
            configurable: true
        });
        ContentInfo.prototype.g = function () {
            if (this.e && i2.typeCast(Axis.$, this.h) !== null) {
                this.e = false;
                var a = this.c;
                this.c = true;
                var b = this.h.cw(true);
                if (!b) {
                    this.c = a;
                }
            }
        };
        ContentInfo.prototype.f = function () {
            this.g();
            if (i2.typeCast(Axis.$, this.h) !== null) {
                var a = i2.typeCast(Axis.$, this.h);
                if (a.ai != null) {
                    var b = a.ai;
                    if (b.a5 != null && b.a5.e) {
                        b.a5.g();
                    }
                }
            }
            if (this.c) {
                this.c = false;
                this.a(this.b);
                this.b = false;
            }
        };
        ContentInfo.$t = i2.markType(ContentInfo, 'ContentInfo');
        return ContentInfo;
    }(i2.Base));
    /**
     * @hidden
     */
    var Series = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Series, _super);
        function Series() {
            var _this = _super.call(this) || this;
            _this.bx = null;
            _this.hc = 0;
            _this.o6 = null;
            _this.gv = null;
            _this.cj = null;
            _this.a5 = null;
            _this.a3 = null;
            _this.cb = null;
            _this.mr = null;
            _this.e5 = new i2.Dictionary$2(i2.String_$type, i2.String_$type, 0);
            _this.e4 = new i2.Dictionary$2(i2.String_$type, i2.FastReflectionHelper.$, 0);
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.renderRequested = null;
            _this.eu = false;
            _this.bw = null;
            _this.as = null;
            _this.co = true;
            _this.em = false;
            _this.en = false;
            _this.cp = false;
            _this.cu = false;
            _this.b4 = null;
            _this.b9 = null;
            _this.fa = null;
            _this.bc = null;
            _this.ci = null;
            _this.gs = null;
            _this.mo = null;
            _this.az = null;
            _this.b3 = 0;
            _this.b2 = 0;
            _this.cw = false;
            _this.ff = NaN;
            _this.fc = NaN;
            _this.fd = NaN;
            _this.fe = NaN;
            _this.ok = null;
            _this.ol = null;
            _this.fr = i2.DeviceUtils.g(2);
            _this.bi = 1;
            _this.fb = 0.2;
            _this.cn = false;
            _this.by = 1;
            _this.bq = 1;
            _this.hf = null;
            _this.bf = new SeriesComponentsForView();
            _this.cq = false;
            _this.hr = null;
            _this.gu = null;
            _this._coercionMethods = null;
            _this.cm = false;
            _this.bm = 0;
            _this.bl = 0;
            _this.cl = null;
            _this.ow = { $type: i2.Point_$type, x: NaN, y: NaN };
            _this.fg = NaN;
            _this.fh = NaN;
            i2.DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
            i2.DVContainer.instance.registerIfLoaded("InteractivityFactoryManager");
            i2.DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
            _this.hc = Series.gx++;
            _this.et = true;
            _this.o6 = i2.Rect.empty;
            _this.bx = _this.bu();
            _this.bx.bu = i2.Rect.empty;
            _this.lh(_this.bx);
            _this.bx.n = true;
            _this.bx.as();
            _this.bx.n = false;
            _this.ab = Series.$;
            _this.ci = function (a, b) {
                if (_this.ca == null || !_this.ca.dl) {
                    _this.mn(b.oldRect, b.newRect);
                }
            };
            _this.bc = function (a, b) { return _this.lm(a, b.propertyName, b.oldValue, b.newValue); };
            _this.gs = function (a, b) {
                if (_this.ca != null) {
                    _this.et = true;
                    _this.ca.j0();
                }
                _this.kk(b.action, b.position, b.count, b.propertyName);
            };
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.lm(a, b.propertyName, b.oldValue, b.newValue); });
            _this.mr = new i2.Canvas();
            _this.cb = new i2.DoubleAnimator(0, 1, _this.ha);
            var a = _this.cb;
            a.propertyChanged = i2.delegateCombine(a.propertyChanged, i2.runOn(_this, _this.j9));
            _this.g(Series.n9, ((function () {
                var $ret = new i2.Binding(1, "Visibility");
                $ret.d = _this;
                return $ret;
            })()));
            _this.bn = _this.bo();
            _this.bz = _this.b0();
            return _this;
        }
        Object.defineProperty(Series.prototype, "gw", {
            get: function () {
                return this.gv;
            },
            set: function (a) {
                this.gv = a;
                this.cb.u(this.gv);
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.provideRenderer = function (a) {
            this.gw = a;
        };
        Series.prototype.jb = function () {
            return this.a4.a$r(this);
        };
        Series.prototype.mh = function (a) {
        };
        Series.prototype.mg = function (a) {
        };
        Series.prototype.mi = function (a) {
        };
        Series.prototype.j9 = function (a, b) {
            this.gn = this.cb.o;
        };
        Object.defineProperty(Series.prototype, "ck", {
            get: function () {
                if (this.cj == null) {
                    this.cj = new i2.SRProvider(this.gw);
                }
                if (this.cj.l == null) {
                    if (this.gw != null) {
                        this.cj.l = this.gw;
                    }
                    else if (this.ca != null && this.ca.cf != null && this.ca.cf.j != null && this.ca.cf.j.ae != null) {
                        this.cj.l = this.ca.cf.j.ae;
                    }
                }
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "a6", {
            get: function () {
                var _this = this;
                if (this.a5 == null) {
                    this.a5 = i2.DVContainer.instance.createInstance(ISeriesVisualDataManager_$type, function () { return _this.ck.q; });
                }
                return this.a5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "e6", {
            get: function () {
                return this.a4.a$h;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "a4", {
            get: function () {
                var _this = this;
                if (this.a3 == null) {
                    this.a3 = i2.DVContainer.instance.createInstance(ISeriesInteractionManager_$type, function () { return _this.ck.n; });
                    if (this.toolTip != null) {
                        this.a3.a$aj(this, this.toolTip);
                    }
                }
                return this.a3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "dt", {
            get: function () {
                return i2.DVContainer.instance.checkLoaded("InteractivityFactoryManager");
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.lh = function (a) {
        };
        Series.prototype.lf = function () {
            this.ka(this.a0, this.a0);
            if (this.ch == null && this.b5 != null && this.itemsSource != null) {
                this.ch = this.b5.getFastItemsSource(this.itemsSource);
            }
            this.bx.av();
        };
        Series.prototype.lg = function () {
            this.kg();
            if (this.ch != null && this.b5 != null && this.itemsSource != null) {
                this.ch = this.b5.releaseFastItemsSource(this.itemsSource);
            }
            this.bx.aw();
        };
        Series.prototype.bv = function () {
            return this.bu();
        };
        Series.prototype.bu = function () {
            return new SeriesView(this);
        };
        Series.prototype.e0 = function () {
            return false;
        };
        Series.prototype.hk = function (a, b) {
            return null;
        };
        Series.prototype.onLegendItemOver = function (a) {
        };
        Series.prototype.onLegendItemPointerUp = function (a) {
        };
        Series.prototype.onLegendItemPointerDown = function (a) {
        };
        Series.prototype.onLegendItemEnter = function (a) {
            if (this.dr && this.dt && this.ca != null && (this.ca.a6 == 0 || this.ca.a6 == 2) && this.bj != 1) {
                this.a4.a$v(this, a, { $type: i2.Point_$type, x: NaN, y: NaN }, false, true, false, a == null, this == this.ca.bj, false);
            }
        };
        Series.prototype.onLegendItemLeave = function (a) {
            if (this.dr && this.dt && this.ca != null && (this.ca.a6 == 0 || this.ca.a6 == 2) && this.bj != 1) {
                this.a4.a$v(this, a, { $type: i2.Point_$type, x: NaN, y: NaN }, false, true, true, a == null, this == this.ca.bj, false);
            }
        };
        Series.prototype.ja = function (a) {
            if (!this.e5.containsKey(a)) {
                var b = a.charAt(0).toUpperCase() + a.substr(1);
                this.e5.addItem(a, b);
            }
            return this.e5.item(a);
        };
        Series.prototype.hl = function (a, b, c) {
            var d = null;
            if (!this.e4.containsKey(b)) {
                d = new i2.FastReflectionHelper(false, c);
                this.e4.addItem(b, d);
            }
            else {
                d = this.e4.item(b);
            }
            d.propertyName = c;
            return d.getPropertyValue(a);
        };
        Series.prototype.fw = function (a) {
            return this.g0(a);
        };
        Series.prototype.g2 = function (a) {
            return -1;
        };
        Series.prototype.get_d3 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d3", {
            get: function () {
                return this.get_d3();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ar = function () {
            return null;
        };
        Series.prototype.g0 = function (a) {
            return -1;
        };
        Series.prototype.pg = function () {
            return new i2.Thickness(1, 0, 0, 0, 0);
        };
        Series.prototype.hh = function (a) {
            return null;
        };
        Series.prototype.hm = function (a, b) {
            return a.hh(b);
        };
        Series.prototype.ax = function (a, b, c, d) {
            return a.av(b, c, d);
        };
        Series.prototype.ay = function (a, b, c, d) {
            return a.aw(b, c, d);
        };
        Series.prototype.gz = function () {
            return -1;
        };
        Series.prototype.g3 = function () {
            return -1;
        };
        Series.prototype.g8 = function () {
            return -1;
        };
        Object.defineProperty(Series.prototype, "container", {
            get: function () {
                return this.ca;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "hasSubItems", {
            get: function () {
                return this.cz();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.cz = function () {
            return false;
        };
        Series.prototype.forSubItems = function (a) {
            this.kt(a);
        };
        Series.prototype.kt = function (a) {
        };
        Series.prototype.ku = function (a) {
        };
        Series.prototype.i9 = function () {
            return null;
        };
        Series.prototype.op = function () {
            return this.oj;
        };
        Series.prototype.oq = function () {
            return this.oo;
        };
        Series.prototype.resolveLegendIndex = function () {
            return this.g9;
        };
        Series.prototype.be = function () {
            return null;
        };
        Series.prototype.get_c6 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c6", {
            get: function () {
                return this.get_c6();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c3 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c3", {
            get: function () {
                return this.get_c3();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c2 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c2", {
            get: function () {
                return this.get_c2();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c5 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c5", {
            get: function () {
                return this.get_c5();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c4 = function () {
            return true;
        };
        Object.defineProperty(Series.prototype, "c4", {
            get: function () {
                return this.get_c4();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_isVertical = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "isVertical", {
            get: function () {
                return this.get_isVertical();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dn = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dn", {
            get: function () {
                return this.get_dn();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c8 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c8", {
            get: function () {
                return this.get_c8();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c7 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c7", {
            get: function () {
                return this.get_c7();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dv = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dv", {
            get: function () {
                return this.get_dv();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_du = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "du", {
            get: function () {
                return this.get_du();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_ea = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "ea", {
            get: function () {
                return this.get_ea();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_db = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "db", {
            get: function () {
                return this.get_db();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c9 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c9", {
            get: function () {
                return this.get_c9();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_ee = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "ee", {
            get: function () {
                return this.get_ee();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d2 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d2", {
            get: function () {
                return this.get_d2();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d1 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d1", {
            get: function () {
                return this.get_d1();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dz = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dz", {
            get: function () {
                return this.get_dz();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dy = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dy", {
            get: function () {
                return this.get_dy();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_ec = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "ec", {
            get: function () {
                return this.get_ec();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_eb = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "eb", {
            get: function () {
                return this.get_eb();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d8 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d8", {
            get: function () {
                return this.get_d8();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d0 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d0", {
            get: function () {
                return this.get_d0();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d6 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d6", {
            get: function () {
                return this.get_d6();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d4 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d4", {
            get: function () {
                return this.get_d4();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_isStacked = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "isStacked", {
            get: function () {
                return this.get_isStacked();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_di = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "di", {
            get: function () {
                return this.get_di();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d5 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d5", {
            get: function () {
                return this.get_d5();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_da = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "da", {
            get: function () {
                return this.get_da();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dp = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dp", {
            get: function () {
                return this.get_dp();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_d7 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "d7", {
            get: function () {
                return this.get_d7();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_ed = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "ed", {
            get: function () {
                return this.get_ed();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.bd = function () {
            return null;
        };
        Series.prototype.get_c0 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "c0", {
            get: function () {
                return this.get_c0();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dl = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dl", {
            get: function () {
                return this.get_dl();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dk = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dk", {
            get: function () {
                return this.get_dk();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dj = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dj", {
            get: function () {
                return this.get_dj();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dm = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dm", {
            get: function () {
                return this.get_dm();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dd = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dd", {
            get: function () {
                return this.get_dd();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_de = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "de", {
            get: function () {
                return this.get_de();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.fu = function (a, b, c, d, e) {
            return Number.POSITIVE_INFINITY;
        };
        Series.prototype.fv = function (a, b, c, d, e, f, g) {
            return this.a4.a$j(this, a, b, c, d, e, f, g);
        };
        Series.prototype.get_e2 = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "e2", {
            get: function () {
                return this.get_e2();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ga = function (a, b, c, d, e, f, g, h) {
            return this.a4.a$m(this, a, b, c, d, e, f, g, h);
        };
        Series.prototype.f0 = function (a, b, c, d, e, f, g, h) {
            return this.a4.a$l(this, a, b, c, d, e, f, g, h);
        };
        Series.prototype.g7 = function (a, b, c, d, e) {
            return this.a4.a$o(this, a, b, c, d, e);
        };
        Series.prototype.fz = function (a) {
            return (a ? 10 : 3);
        };
        Series.prototype.ah = function (a) {
            return null;
        };
        Series.prototype.ai = function (a) {
            return null;
        };
        Series.prototype.eo = function (a, b) {
            return this.a4.a$d(this, a, b);
        };
        Series.prototype.aj = function (a, b, c, d, e, f) {
            return this.a4.a$a(this, a, b, c, d, e, f);
        };
        Series.prototype.eq = function (a, b, c) {
            return this.a4.a$e(this, a, b, c);
        };
        Series.prototype.er = function (a, b) {
            return this.a4.a$f(this, a, b);
        };
        Series.prototype.g5 = function (a, b, c, d, e) {
            return this.a4.a$n(this, a, b, c, d, e);
        };
        Series.prototype.fy = function (a, b) {
            return this.a4.a$k(this, a, b);
        };
        Series.prototype.g6 = function (a, b) {
            return -1;
        };
        Series.prototype.g4 = function (a, b) {
            return -1;
        };
        Series.prototype.f8 = function (a, b, c) {
            return NaN;
        };
        Series.prototype.o2 = function (a, b, c) {
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        Series.prototype.pb = function (a) {
            return i2.Rect.empty;
        };
        Series.prototype.ak = function (a) {
            var b = this.pb(a);
            if (!b.isEmpty) {
                var c = new Array(1);
                c[0] = b;
                return c;
            }
            return null;
        };
        Series.prototype.pc = function (a) {
            return this.pb(this.o5(a));
        };
        Series.prototype.al = function (a) {
            return this.ak(this.o5(a));
        };
        Series.prototype.pd = function (a) {
            return i2.Rect.empty;
        };
        Series.prototype.pe = function (a) {
            return this.pd(this.o5(a));
        };
        Series.prototype.es = function (a, b) {
            return this.a4.a$g(this, a, b);
        };
        Series.prototype.o4 = function (a, b, c, d, e, f, g, h, i) {
            return this.a4.a$al(this, a, b, c, d, e, f, g, h, i);
        };
        Series.prototype.f4 = function (a, b, c) {
            return this.f8(a, b, c);
        };
        Series.prototype.oy = function (a, b, c) {
            return this.o2(a, b, c);
        };
        Series.prototype.f6 = function (a, b, c) {
            return this.f8(a, b, c);
        };
        Series.prototype.o0 = function (a, b, c) {
            return this.o2(a, b, c);
        };
        Series.prototype.o3 = function (a, b, c) {
            var d = this.o5(a);
            return this.o2(d, b, c);
        };
        Series.prototype.f9 = function (a, b, c) {
            var d = this.o5(a);
            return this.f8(d, b, c);
        };
        Series.prototype.oz = function (a, b, c) {
            var d = this.o5(a);
            return this.oy(d, b, c);
        };
        Series.prototype.f5 = function (a, b, c) {
            var d = this.o5(a);
            return this.f4(d, b, c);
        };
        Series.prototype.o1 = function (a, b, c) {
            var d = this.o5(a);
            return this.o0(d, b, c);
        };
        Series.prototype.f7 = function (a, b, c) {
            var d = this.o5(a);
            return this.f6(d, b, c);
        };
        Series.prototype.g1 = function (a) {
            var b = this.o5(a);
            return this.g0(b);
        };
        Series.prototype.f1 = function () {
            return 0;
        };
        Series.prototype.fx = function (a) {
            var b = this.o5(a);
            return this.fw(b);
        };
        Series.prototype.hi = function (a) {
            var b = this.o5(a);
            return this.hh(b);
        };
        Series.prototype.cx = function (a, b, c) {
            return false;
        };
        Series.prototype.raisePropertyChanged = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        Series.prototype.get_hasMarkers = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "hasMarkers", {
            get: function () {
                return this.get_hasMarkers();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.kx = function () {
        };
        Series.prototype.om = function () {
            return null;
        };
        Series.prototype.on = function () {
            return null;
        };
        Series.prototype.mv = function () {
            return null;
        };
        Series.prototype.ft = function () {
            return NaN;
        };
        Series.prototype.o5 = function (a) {
            var b = this.ca != null ? this.ca.pj : this.bx.bu;
            var c = this.bx.bv;
            var d = { $type: i2.Point_$type, x: c.left + c.width * (a.x - b.left) / b.width, y: c.top + c.height * (a.y - b.top) / b.height };
            return d;
        };
        Series.prototype.ox = function (a) {
            var b = this.ca != null ? this.ca.pj : this.bx.bu;
            var c = this.bx.bv;
            var d = b.left + (a.x - c.left) / c.width * b.width;
            var e = b.top + (a.y - c.top) / c.height * b.height;
            return { $type: i2.Point_$type, x: d, y: e };
        };
        Series.prototype.hn = function (a, b) {
            var c = this.bx.c(a);
            var d = c != null ? c.item : null;
            if (d == null) {
                var e = this.o5(b);
                d = this.hh(e);
            }
            return d;
        };
        Series.prototype.eh = function (a) {
            return false;
        };
        Series.prototype.ap = function (a) {
            return new AxisRange(NaN, NaN);
        };
        Series.prototype.aq = function (a) {
            return new AxisRange(NaN, NaN);
        };
        Series.prototype.ao = function (a, b, c) {
            this.kq();
            if (!this.isVertical) {
                if (this.fm == 0 && this.fp == 0) {
                    return a;
                }
                var d = new ScalerParams(0, c, this.ca.pv, b.cc, this.getEffectiveViewport());
                d.b = this.f2();
                var e = b.d8(a.c, d);
                var f = b.d8(a.b, d);
                if (b.cc) {
                    f += this.fm;
                    e -= this.fp;
                }
                else {
                    f -= this.fp;
                    e += this.fm;
                }
                var g = b.eb(e, d);
                var h = b.eb(f, d);
                return new AxisRange(g, h);
            }
            else {
                return a;
            }
        };
        Series.prototype.kq = function () {
            if (i2.isNaN_(this.fp)) {
                var a = this.pg();
                this.fp = a.e;
                if (i2.isNaN_(this.fp)) {
                    this.fp = 0;
                }
            }
            if (i2.isNaN_(this.fm)) {
                var b = this.pg();
                this.fm = b.b;
                if (i2.isNaN_(this.fm)) {
                    this.fm = 0;
                }
            }
            if (i2.isNaN_(this.fn)) {
                var c = this.pg();
                this.fn = c.c;
                if (i2.isNaN_(this.fn)) {
                    this.fn = 0;
                }
            }
            if (i2.isNaN_(this.fo)) {
                var d = this.pg();
                this.fo = d.d;
                if (i2.isNaN_(this.fo)) {
                    this.fo = 0;
                }
            }
        };
        Series.prototype.l0 = function (a) {
            this.em = false;
            if (this.ca != null) {
                this.ca.ap.ac(0, this, this.as, a);
                if (this.renderRequested != null) {
                    var b = new RenderRequestedEventArgs();
                    b.animate = a;
                    this.renderRequested(this, b);
                    a = b.animate;
                }
            }
        };
        Series.prototype.kn = function (a) {
            this.l1(a);
            this.em = false;
        };
        Series.prototype.l1 = function (a) {
            if (this.ew && !this.ek()) {
                this.ev = false;
            }
        };
        Series.prototype.kd = function () {
            if (this.eu && !this.ew) {
                this.cb.r = i2.truncate(Math.max(this.gb(), this.gc()));
                this.ki();
            }
        };
        Series.prototype.ki = function () {
        };
        Series.prototype.l2 = function (a, b) {
            if (this.bw == null) {
                this.bw = this.bu();
                this.bw.q = true;
                if (this.ca != null) {
                    this.ca.am.l(this.bw);
                    this.bw.a = this.ca.am;
                }
                this.bw.as();
            }
            this.bw.bu = a;
        };
        Series.prototype.lz = function (a, b, c, d, e) {
            this.a4.a$t(this, a, b, d, e);
        };
        Series.prototype.getEffectiveViewport1 = function (a) {
            if (this.ca == null) {
                return i2.Rect.empty;
            }
            if (a.p) {
                return this.ca.pk;
            }
            if (a.q) {
                if (this.ca.pk.isEmpty) {
                    return this.ca.pk;
                }
                var b = this.ca.pp(a.bu, this.ca.pv, this.ca.pk);
                return b;
            }
            return this.ca.pk;
        };
        Series.prototype.o7 = function (a) {
            if (this.ca == null || this.ca.pj.isEmpty) {
                return a.bu;
            }
            if (a.p) {
                return a.bu;
            }
            if (a.q) {
                if (this.ca.pk.isEmpty) {
                    return a.bu;
                }
                if (this.ca.pj.equals1(this.ca.pv)) {
                    return a.bu;
                }
                var b = this.ca.pp(a.bu, this.ca.pv, this.ca.pk);
                var c = this.ca.pn(a.bu, b, this.ca.pg);
                return c;
            }
            return this.ca.pj;
        };
        Series.prototype.pa = function (a) {
            if (!this.pf.equals1(a)) {
                return i2.Rect.empty;
            }
            return this.getEffectiveViewport();
        };
        Series.prototype.o9 = function (a) {
            if (this.ca == null || this.ca.pk.isEmpty) {
                return i2.Rect.empty;
            }
            var b = this.ca.pk;
            var c = a.bu;
            var d = (b.left - c.left) / c.width;
            var e = (b.top - c.top) / c.height;
            var f = (b.right - c.left) / c.width;
            var g = (b.bottom - c.top) / c.height;
            return new i2.Rect(0, d, e, f - d, g - e);
        };
        Series.prototype.getEffectiveViewport = function () {
            return this.getEffectiveViewport1(this.bx);
        };
        Series.prototype.lu = function () {
            this.lv(null);
        };
        Series.prototype.get_cy = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "cy", {
            get: function () {
                return this.get_cy();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_c1 = function () {
            return this.bj == 2 || this.bj == 4;
        };
        Object.defineProperty(Series.prototype, "c1", {
            get: function () {
                return this.get_c1();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.lv = function (a) {
            if (this.dt) {
                this.a4.a$ae(this, a);
            }
        };
        Series.prototype.lw = function (a) {
            if (this.dt) {
                this.a4.a$af(this, a, this.ca);
            }
        };
        Series.prototype.getViewInfo = function (a, b) {
            a = this.bx.bu;
            b = this.bx.bv;
            return {
                p0: a,
                p1: b
            };
        };
        Series.prototype.e3 = function (a, b, c) {
            if (a.width == 0 || a.height == 0) {
                return false;
            }
            if (this.dn) {
                return true;
            }
            return this._visibility == 0;
        };
        Series.prototype.kh = function (a, b) {
            if (a) {
                this.et = true;
            }
        };
        Series.prototype.cs = function () {
            return this.ct(this.bx);
        };
        Series.prototype.ct = function (a) {
            var b = a.bu;
            var c = a.bv;
            if (!this.e3(b, c, a)) {
                this.kh(true, a);
                return true;
            }
            return false;
        };
        Series.prototype.li = function (a, b) {
            this.bx.bu = b;
            this.mm(a, b);
            if (this.ca != null) {
                this.ca.ap.ae(0, this, this.as, b);
            }
        };
        Series.prototype.mn = function (a, b) {
        };
        Series.prototype.mm = function (a, b) {
        };
        Object.defineProperty(Series.prototype, "et", {
            get: function () {
                return this.co;
            },
            set: function (a) {
                this.co = a;
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ks = function (a) {
            a.ko();
        };
        Series.prototype.k8 = function () {
            this.en = false;
            this.et = true;
            if (this.ca != null) {
                this.ca.j0();
            }
        };
        Series.prototype.k2 = function () {
            this.md();
            this.lj();
        };
        Series.prototype.k7 = function () {
            this.en = false;
            this.et = true;
            if (this.ca != null) {
                this.ca.jz();
            }
        };
        Series.prototype.get_ds = function () {
            return true;
        };
        Object.defineProperty(Series.prototype, "ds", {
            get: function () {
                return this.get_ds();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_isUsableInLegend = function () {
            return true;
        };
        Object.defineProperty(Series.prototype, "isUsableInLegend", {
            get: function () {
                return this.get_isUsableInLegend();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ld = function () {
            this.bx.ao();
        };
        Series.prototype.k9 = function () {
            this.lj();
        };
        Series.prototype.lj = function () {
            this.bx.az();
            this.ll(false);
            this.me();
        };
        Series.prototype.lk = function () {
            this.bx.az();
            this.ll(true);
        };
        Series.prototype.eg = function () {
            return false;
        };
        Series.prototype.ll = function (a) {
            if (this.as == null || this.as.c) {
                return;
            }
            var b = this.bx.bu;
            var c = this.bx.bv;
            var d = this.e3(b, c, this.bx);
            var e = this.ca != null && this.ca.d1 && this.bw != null && this.e3(this.bw.bu, this.bw.bv, this.bw);
            if (d) {
                if (a) {
                    this.em = !this.eg();
                    this.kn(false);
                }
                else {
                    this.l0(false);
                    this.em = !this.eg();
                }
            }
            if (e) {
                if (!this.et) {
                    this.k7();
                    this.en = true;
                }
            }
        };
        Object.defineProperty(Series.prototype, "ev", {
            get: function () {
                return this.cp;
            },
            set: function (a) {
                this.cp = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "ew", {
            get: function () {
                if (this.ev == false) {
                    return false;
                }
                return this.gc() > 0;
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.v = function () {
            _super.prototype.v.call(this);
            this.raisePropertyChanged("Opacity", this._opacity, this._opacity);
        };
        Series.prototype.w = function (a, b) {
            _super.prototype.w.call(this, a, b);
            this.raisePropertyChanged("Visibility", i2.enumGetBox(i2.Visibility_$type, a), i2.enumGetBox(i2.Visibility_$type, b));
        };
        Series.prototype.lc = function () {
        };
        Series.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case "SyncLink":
                    if (i2.typeCast(SyncLink.$, c) !== null) {
                        var e = c;
                        e.propertyUpdated = i2.delegateRemove(e.propertyUpdated, this.bc);
                        this.lt(i2.typeCast(i2.IFastItemsSourceProvider_$type, c));
                    }
                    if (i2.typeCast(SyncLink.$, d) !== null) {
                        var f = d;
                        f.propertyUpdated = i2.delegateCombine(f.propertyUpdated, this.bc);
                        this.ls(i2.typeCast(i2.IFastItemsSourceProvider_$type, d));
                    }
                    if (this.g9 == -1) {
                        this.g9 = XamDataChart.rl(this);
                    }
                    break;
                case Series.$$p[24]:
                    this.br = this.bt();
                    this.mc();
                    this.ko();
                    this.lj();
                    break;
                case SeriesViewer.$$p[1]:
                case SeriesViewer.$$p[14]:
                case SeriesViewer.$$p[13]:
                case SeriesViewer.$$p[15]:
                    this.ko();
                    break;
                case "HighlightingMode":
                    this.bj = this.bk();
                    break;
                case "SeriesViewer":
                    if (i2.typeCast(SeriesViewer.$, c) !== null) {
                        this.gw = null;
                        var g = c;
                        g.windowRectChanged = i2.delegateRemove(g.windowRectChanged, this.ci);
                        var h = c.series;
                        h.collectionChanged = i2.delegateRemove(h.collectionChanged, this.fa);
                        var i = c;
                        i.propertyUpdated = i2.delegateRemove(i.propertyUpdated, this.bc);
                        c.ap.ad(0, this);
                        this.lv(c);
                        this.bx.ak(c);
                    }
                    if (i2.typeCast(SeriesViewer.$, d) !== null) {
                        this.gw = d.cf.j.ae;
                        var j = d;
                        j.windowRectChanged = i2.delegateCombine(j.windowRectChanged, this.ci);
                        var k = d.series;
                        k.collectionChanged = i2.delegateCombine(k.collectionChanged, this.fa);
                        var l = d;
                        l.propertyUpdated = i2.delegateCombine(l.propertyUpdated, this.bc);
                        this.as = d.ap.k(0, this, i2.runOn(this, this.kn));
                        this.bx.ag(d);
                        this.bj = this.bk();
                        this.ma();
                        this.kp();
                        this.hc = this.ca.gc();
                    }
                    if (this.ca == null) {
                        this.externalObject._ensureTooltipDestroyed();
                        this.cb.w();
                    }
                    if (this.g9 != -1) {
                        this.md();
                    }
                    if (this.g9 == -1 || d == null) {
                        this.g9 = XamDataChart.rl(this);
                    }
                    this.a0 = this.a1();
                    this.kb(i2.typeCast(SeriesViewer.$, c), i2.typeCast(SeriesViewer.$, d));
                    break;
                case Series.$$p[34]:
                    if (this.bx != null) {
                        this.bx.ay();
                    }
                    break;
                case "HitTestMode":
                    this.bn = this.bo();
                    break;
                case "ActualHitTestMode":
                    if (this.ca != null) {
                        this.ca.lw();
                    }
                    break;
                case "LegendItemBadgeTemplate":
                case "LegendItemTemplate":
                case Series.$$p[19]:
                case Series.$$p[18]:
                    this.md();
                    this.lj();
                    break;
                case Series.$$p[21]:
                    this.mb();
                    break;
                case Series.$$p[5]:
                case Series.$$p[9]:
                case Series.$$p[25]:
                case Series.$$p[10]:
                case Series.$$p[11]:
                    this.ko();
                    this.lj();
                    break;
                case "Index":
                    if (i2.typeGetValue(c) != i2.typeGetValue(d)) {
                        this.lc();
                        this.br = this.bt();
                        this.mc();
                        this.mb();
                        this.ko();
                        this.lj();
                    }
                    break;
                case "RadiusX":
                case "RadiusY":
                case "RoundedCornersLocation":
                    this.lj();
                    break;
                case Series.$$p[8]:
                    this.ma();
                    this.lj();
                    break;
                case Series.$$p[32]:
                case Series.$$p[12]:
                case Series.$$p[22]:
                    this.lj();
                    break;
                case Series.$$p[16]:
                    this.ld();
                    this.lj();
                    break;
                case Series.$$p[42]:
                case Series.$$p[28]:
                case Series.$$p[27]:
                case Series.$$p[29]:
                case Series.$$p[30]:
                    this.lj();
                    break;
                case Series.$$p[33]:
                    this.mc();
                    if (this.a7 == 1) {
                        this.me();
                    }
                    break;
                case Series.$$p[2]:
                case Series.$$p[3]:
                    this.lj();
                    break;
                case Series.$$p[1]:
                case Series.$$p[6]:
                case Series.$$p[7]:
                    this.ok = this.of;
                    this.ol = this.oi;
                    this.fr = this.fl;
                    this.oh = this.oi;
                    this.og = this.of;
                    this.lj();
                    this.bx.bj();
                    if (this.toolTip != null && this.a3 != null) {
                        this.a4.a$aj(this, this.toolTip);
                    }
                    break;
                case "Visibility":
                    this.bx.bk();
                    break;
                case "ItemsSource":
                    if (this.b5 != null) {
                        this.ls(this.b5);
                    }
                    break;
                case Series.$$p[13]:
                    if (c != d && d != null) {
                        this.ev = true;
                    }
                    this.k8();
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        var m = c;
                        m.event = i2.delegateRemove(m.event, this.gs);
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        var n = d;
                        n.event = i2.delegateCombine(n.event, this.gs);
                    }
                    break;
                case "Legend":
                    if (d != null) {
                        if (a == this) {
                            d.seriesOwner = this;
                        }
                        else if (i2.typeCast(XamDataChart.$, a) !== null) {
                            d.chartOwner = a;
                        }
                    }
                    this.a0 = this.a1();
                    break;
                case "ActualLegend":
                    this.ka(i2.typeCast(i2.IChartLegend_$type, c), i2.typeCast(i2.IChartLegend_$type, d));
                    break;
                case "LegendItem":
                    this.kc(i2.typeCast(i2.Control.$, c), i2.typeCast(i2.Control.$, d));
                    break;
                case Series.$$p[20]:
                    this.bx.at();
                    break;
                case Series.$$p[35]:
                    if (this.a3 != null) {
                        this.a4.a$aj(this, this.toolTip);
                    }
                    break;
                case "CrosshairPoint":
                    if (this.ca != null) {
                        this.mk(this.ca.o8);
                    }
                    if (this.ca != null) {
                        if (!this.cu) {
                            this.ca.lo(this, this.hh(this.ca.o8));
                        }
                    }
                    break;
                case Series.$$p[26]:
                    this.l0(false);
                    this.k7();
                    break;
                case Series.$$p[46]:
                    this.fp = this.gr;
                    if (this.ca != null) {
                        this.ca.jr();
                    }
                    break;
                case Series.$$p[43]:
                    this.fm = this.go;
                    if (this.ca != null) {
                        this.ca.jr();
                    }
                    break;
                case Series.$$p[36]:
                case Series.$$p[37]:
                    this.cb.w();
                    this.cb.r = this.ha;
                    this.cb.b = this.cc;
                    this.l0(false);
                    break;
                case "DiscreteLegendItemTemplate":
                    this.l0(false);
                    break;
                case "VisibilityProxy":
                    if (c != d) {
                        this.l0(false);
                    }
                    this.k7();
                    this.bx.bk();
                    break;
                case Series.$$p[17]:
                    this.bj = this.bk();
                    this.l0(false);
                    break;
                case Series.$$p[14]:
                    this.fj = i2.isNaN_(this.gd) ? 0.2 : this.gd;
                    break;
                case Series.$$p[31]:
                    this.kp();
                    break;
                case "FinalValue":
                    this.mj();
                    break;
                case Series.$$p[47]:
                    this.bz = this.b0();
                    break;
            }
        };
        Series.prototype.mc = function () {
            var a = this.br;
            var b = this.gm;
            if (i2.isNaN_(b)) {
                b = i2.DeviceUtils.g(2);
            }
            if (a == 2) {
                b = 1;
            }
            if (this.fl != b) {
                this.fl = b;
            }
            this.fr = this.fl;
        };
        Series.prototype.mk = function (a) {
            if (this.ca != null && this.ca.dv && this.bj != 1 && this.ca.ds) {
                if (i2.isNaN_(a.x) || i2.isNaN_(a.y)) {
                    this.a4.a$v(this, null, a, false, false, false, false, this.ca.bj == this, true);
                }
                else {
                    this.a4.a$v(this, this.hh(a), a, false, false, false, false, this.ca.bj == this, false);
                }
            }
        };
        Series.prototype.kp = function () {
            if (this.ca != null && (this.externalObject.owner)) {
                var sv_ = this.ca;
                this.externalObject.owner._ensureDefaultTooltip(this.externalObject);
                ;
            }
        };
        Series.prototype.get_dr = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dr", {
            get: function () {
                return this.get_dr();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.km = function (a) {
            a.cu = true;
        };
        Object.defineProperty(Series.prototype, "b5", {
            get: function () {
                return this.b4;
            },
            set: function (a) {
                if (this.b5 != a) {
                    var b = this.b5;
                    this.b4 = a;
                    this.raisePropertyChanged("SyncLink", b, this.b5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "ca", {
            get: function () {
                return this.b9;
            },
            set: function (a) {
                if (this.ca != a) {
                    var b = this.ca;
                    this.b9 = a;
                    this.raisePropertyChanged("SeriesViewer", b, this.b9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "b8", {
            get: function () {
                return i2.typeCast(XamDataChart.$, this.ca);
            },
            set: function (a) {
                this.ca = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "itemsSource", {
            get: function () {
                return this.c(Series.ng);
            },
            set: function (a) {
                this.h(Series.ng, a);
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.kk = function (a, b, c, d) {
            if (this.ca != null) {
                this.ca.lp();
            }
        };
        Object.defineProperty(Series.prototype, "legend", {
            get: function () {
                return this.c(Series.nm);
            },
            set: function (a) {
                this.h(Series.nm, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "mq", {
            get: function () {
                if (this.mo == null && this.a0 != null) {
                    this.mo = this.mp();
                }
                return this.mo;
            },
            set: function (a) {
                if (this.mq != a) {
                    var b = this.mq;
                    this.mo = a;
                    this.raisePropertyChanged("LegendItem", b, this.mo);
                }
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ho = function () {
            return this.mp();
        };
        Series.prototype.mp = function () {
            var _this = this;
            var a = i2.typeCast(i2.ContentControl.$, this.mo);
            var b = this.legendItemTemplate;
            if (b == null) {
                b = this.bx.bl(this.b3);
            }
            if (b != null) {
                if (a == null) {
                    a = new i2.ContentControl();
                }
                a.content = ((function () {
                    var $ret = new i2.DataContext();
                    $ret.series = _this;
                    $ret.item = null;
                    return $ret;
                })());
                a.ah = b;
            }
            else {
                a = null;
            }
            return a;
        };
        Object.defineProperty(Series.prototype, "a0", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                if (this.a0 != a) {
                    var b = this.az;
                    this.az = a;
                    this.raisePropertyChanged("ActualLegend", b, this.az);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "legendItemBadgeTemplate", {
            get: function () {
                return this.c(Series.nj);
            },
            set: function (a) {
                this.h(Series.nj, a);
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.mu = function () {
            return this.legendItemBadgeTemplate;
        };
        Object.defineProperty(Series.prototype, "legendItemTemplate", {
            get: function () {
                return this.c(Series.nk);
            },
            set: function (a) {
                this.h(Series.nk, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "mt", {
            get: function () {
                return this.c(Series.m8);
            },
            set: function (a) {
                this.h(Series.m8, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "g9", {
            get: function () {
                return i2.typeGetValue(this.c(Series.nc));
            },
            set: function (a) {
                this.h(Series.nc, a);
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ml = function () {
            this.md();
        };
        Series.prototype.ko = function () {
            this.md();
        };
        Series.prototype.md = function () {
            this.k7();
            if (this.g9 < 0) {
                return;
            }
            if (this.oj != null) {
                this.bx.a7();
                this.bx.ah();
            }
            else {
                this.of = this.ca == null ? null : this.ca.ou(this.g9);
            }
            if (this.br == 2) {
                this.bx.a8();
                this.oi = this.of;
            }
            else {
                if (this.oo != null) {
                    this.bx.a8();
                    this.bx.ai();
                }
                else {
                    this.oi = this.ca == null ? null : this.ca.o0(this.g9);
                }
            }
            if ((this.d6 || this.dp) && this.d2) {
                this.of = this.oi;
            }
            else if ((this.d6 || this.dp) && this.c7) {
                this.oi = this.of;
            }
            else if ((this.d6 || this.dp) && this.du) {
                this.oi = this.of;
            }
            else if (this.ec && this.a9 == 2) {
                this.of = this.oi;
            }
        };
        Series.prototype.cr = function () {
            return this.cb.f();
        };
        Series.prototype.l8 = function () {
            this.cb.v();
        };
        Object.defineProperty(Series.prototype, "fp", {
            get: function () {
                return this.ff;
            },
            set: function (a) {
                this.ff = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "fm", {
            get: function () {
                return this.fc;
            },
            set: function (a) {
                this.fc = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "fn", {
            get: function () {
                return this.fd;
            },
            set: function (a) {
                this.fd = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "fo", {
            get: function () {
                return this.fe;
            },
            set: function (a) {
                this.fe = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "bj", {
            get: function () {
                return this.bi;
            },
            set: function (a) {
                var b = this.bi;
                this.bi = a;
                if (b != this.bi) {
                    this.raisePropertyChanged("ActualHighlightingMode", i2.enumGetBox(SeriesHighlightingMode_$type, b), i2.enumGetBox(SeriesHighlightingMode_$type, this.bi));
                }
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.bk = function () {
            if (!this.dr) {
                return 1;
            }
            if (this.ca != null) {
                if (this.ca.bq != 1 && this.ca.bq != 0 && !this.dc) {
                    return this.ca.bq;
                }
            }
            if (this.dq) {
                return 2;
            }
            return 1;
        };
        Series.prototype.d9 = function (a) {
            switch (a) {
                case 2:
                case 4: return true;
            }
            return false;
        };
        Object.defineProperty(Series.prototype, "fj", {
            get: function () {
                return this.fb;
            },
            set: function (a) {
                var b = this.fb;
                this.fb = a;
                if (b != this.fb) {
                    this.raisePropertyChanged("ActualHighlightingFadeOpacity", b, this.fb);
                }
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dh = function () {
            return true;
        };
        Object.defineProperty(Series.prototype, "dh", {
            get: function () {
                return this.get_dh();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ma = function () {
            var a = (i2.typeCast(XamDataChart.$, this.ca));
            if (a != null) {
                this.fi = i2.isNaN_(this.fq) ? a.p9.fk : this.fq;
            }
        };
        Series.prototype.mb = function () {
            this.fk = i2.isNaN_(this.ge) ? this.gi() : this.ge;
        };
        Series.prototype.gi = function () {
            return 1;
        };
        Object.defineProperty(Series.prototype, "df", {
            get: function () {
                return this.cn;
            },
            set: function (a) {
                this.cn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "bz", {
            get: function () {
                return this.by;
            },
            set: function (a) {
                this.by = a;
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.b0 = function () {
            if (this.b1 == 0) {
                return 1;
            }
            return this.b1;
        };
        Object.defineProperty(Series.prototype, "br", {
            get: function () {
                return this.bq;
            },
            set: function (a) {
                this.bq = a;
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.bt = function () {
            if (this.bs == 0) {
                return 1;
            }
            return this.bs;
        };
        Series.prototype.au = function (a) {
            var _this = this;
            return ((function () {
                var $ret = new i2.DataContext();
                $ret.series = _this;
                $ret.item = a;
                return $ret;
            })());
        };
        Series.prototype.b6 = function () {
            return 1;
        };
        Series.prototype.ly = function () {
            this.bx.a3();
        };
        Series.prototype.l3 = function () {
            this.ev = true;
            this.l0(true);
        };
        Series.prototype.lx = function () {
            this.ke();
        };
        Series.prototype.ke = function () {
        };
        Series.prototype.ky = function () {
        };
        Series._e8 = function (a, b, c) {
            var d;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        d = b;
                        _a.label = 1;
                    case 1:
                        if (!(d < c))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, a(d)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        d++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        Series.e8 = function (a, b, c) {
            return i2.toEnum(function () { return Series._e8(a, b, c); });
        };
        Series.e7 = function (a, b) {
            return Series.e8(a, 0, b);
        };
        Series.prototype.bg = function () {
            return this.bf;
        };
        Series.prototype.l4 = function (a) {
            this.mf(a);
        };
        Series.prototype.gb = function () {
            return this.ha;
        };
        Series.prototype.gc = function () {
            return this.hb;
        };
        Series.prototype.get_ex = function () {
            return this.cq;
        };
        Series.prototype.set_ex = function (a) {
            this.cq = a;
        };
        Object.defineProperty(Series.prototype, "ex", {
            get: function () {
                return this.get_ex();
            },
            set: function (a) {
                this.set_ex(a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "ej", {
            get: function () {
                return this.ex;
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.kf = function () {
            this.a4.a$s();
        };
        Series.prototype.av = function (a, b, c) {
            return null;
        };
        Series.prototype.aw = function (a, b, c) {
            return null;
        };
        Series.prototype.le = function (a, b, c, d) {
            this.a4.a$y(this, a, b, c, d);
        };
        Series.prototype.l7 = function (a) {
            this.a4.a$ai(this, a);
        };
        Series.prototype.kb = function (a, b) {
            if (this.a0 != null && this.mq != null) {
                if (b == null && this.a0.containsChild(this.mq)) {
                    this.a0.removeChild(this.mq);
                }
                if (b != null && !this.a0.containsChild(this.mq) && this.ph != 1) {
                    this.a0.addChildInOrder(this.mq, this);
                }
            }
        };
        Series.prototype.kg = function () {
            if (this.a0 == null || this.mq == null) {
                return;
            }
            this.a0.removeChild(this.mq);
        };
        Series.prototype.ka = function (a, b) {
            if (this.mq != null) {
                if (a != null && a.containsChild(this.mq)) {
                    a.removeChild(this.mq);
                }
                if (this.ca != null && b != null && !b.containsChild(this.mq) && this.ph != 1) {
                    b.addChildInOrder(this.mq, this);
                }
            }
        };
        Series.prototype.kc = function (a, b) {
            if (this.a0 != null) {
                if (a != null && this.a0.containsChild(a)) {
                    this.a0.removeChild(a);
                }
                if (this.ca != null && b != null && this.ph != 1) {
                    this.a0.addChildInOrder(b, this);
                }
            }
        };
        Series.prototype.lt = function (a) {
            this.ch = a.releaseFastItemsSource(this.itemsSource);
        };
        Series.prototype.ls = function (a) {
            this.ch = a.getFastItemsSource(this.itemsSource);
        };
        Series.prototype.a1 = function () {
            if (this.legend != null) {
                return this.legend;
            }
            if (this.ca != null && this.ca.legend != null) {
                return this.ca.legend;
            }
            return null;
        };
        Series.prototype.ek = function () {
            return false;
        };
        Series.prototype.ei = function (a) {
            return (a && this.gb() > 0) || this.cr() || (this.ew && this.ek() && this.gc() > 0);
        };
        Series.prototype.kl = function (a) {
            if (a != null) {
                a.bx(this);
            }
        };
        Series.prototype.lr = function (a) {
            if (a != null) {
                a.cn(this);
            }
        };
        Series.prototype.bh = function () {
            return this.bx.g();
        };
        Series.prototype.mf = function (a) {
            this.bx.a9(a);
        };
        Series.prototype.l6 = function (a, b) {
            this.a4.a$ah(this, a, b);
        };
        Series.prototype.get_ez = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "ez", {
            get: function () {
                return this.get_ez();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ln = function (a, b) {
            this.bx.ar(a, b);
        };
        Series.prototype.lp = function (a) {
            this.li(this.pf, a);
        };
        Series.prototype.kw = function (a) {
            if (this.ch != null) {
                this.ch.handleCollectionChanged(a);
            }
        };
        Series.prototype.k5 = function (a, b, c) {
            this.kw(new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        Series.prototype.k1 = function () {
            this.kw(new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        Series.prototype.k3 = function (a, b) {
            this.kw(new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        Series.prototype.k4 = function (a, b) {
            this.kw(new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        Series.prototype.l9 = function () {
            this.l0(false);
        };
        Series.prototype.ep = function (a, b) {
            return false;
        };
        Series.prototype.get_coercionMethods = function () {
            return this._coercionMethods;
        };
        Series.prototype.set_coercionMethods = function (a) {
            this._coercionMethods = a;
        };
        Object.defineProperty(Series.prototype, "coercionMethods", {
            get: function () {
                return this.get_coercionMethods();
            },
            set: function (a) {
                this.set_coercionMethods(a);
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_expectFunctions = function () {
            return this.cm;
        };
        Series.prototype.set_expectFunctions = function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.raisePropertyChanged("ExpectFunctions", b, this.cm);
            }
        };
        Object.defineProperty(Series.prototype, "expectFunctions", {
            get: function () {
                return this.get_expectFunctions();
            },
            set: function (a) {
                this.set_expectFunctions(a);
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.at = function (a, b) {
            return null;
        };
        Object.defineProperty(Series.prototype, "bp", {
            get: function () {
                return this.bm;
            },
            set: function (a) {
                var b = this.bm;
                this.bm = a;
                if (b != this.bm) {
                    this.raisePropertyChanged("HitTestMode", i2.enumGetBox(SeriesHitTestMode_$type, b), i2.enumGetBox(SeriesHitTestMode_$type, this.bm));
                }
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.bo = function () {
            return this.bp == 0 ? 2 : this.bp;
        };
        Object.defineProperty(Series.prototype, "bn", {
            get: function () {
                return this.bl;
            },
            set: function (a) {
                var b = this.bl;
                this.bl = a;
                if (b != this.bl) {
                    this.raisePropertyChanged("ActualHitTestMode", i2.enumGetBox(SeriesHitTestMode_$type, b), i2.enumGetBox(SeriesHitTestMode_$type, this.bl));
                }
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.ce = function (a) {
            if (a == null) {
                return this.ch.registerColumn(null, null, false);
            }
            var b = null;
            var c = SeriesViewer.b1(a, this.coercionMethods);
            b = c.a;
            return this.ch.registerColumn(a, b, this.expectFunctions);
        };
        Series.prototype.cf = function (a) {
            if (a == null) {
                return this.ch.registerColumnInt(null, null, false);
            }
            var b = null;
            var c = SeriesViewer.b1(a, this.coercionMethods);
            b = c.a;
            return this.ch.registerColumnInt(a, b, this.expectFunctions);
        };
        Series.prototype.cg = function (a) {
            if (a == null) {
                return this.ch.registerColumnObject(null, null, false);
            }
            var b = null;
            var c = SeriesViewer.b1(a, this.coercionMethods);
            b = c.a;
            return this.ch.registerColumnObject(a, b, this.expectFunctions);
        };
        Object.defineProperty(Series.prototype, "pf", {
            get: function () {
                return this.bx != null ? this.bx.bu : i2.Rect.empty;
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dx = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dx", {
            get: function () {
                return this.get_dx();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.get_dw = function () {
            return false;
        };
        Object.defineProperty(Series.prototype, "dw", {
            get: function () {
                return this.get_dw();
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.l5 = function (a, b) {
        };
        Series.prototype.kj = function (a, b) {
            this.a6.copyVisualData(a, b);
        };
        Series.prototype.hg = function () {
            var a = this.a6.exportVisualData(this, this.pf);
            this.kr(a);
            this.bx.al(a);
            return a;
        };
        Series.prototype.kr = function (a) {
        };
        Series.prototype.kz = function (a) {
            if (this.ow.x != a.x || this.ow.y != a.y) {
                this.ow = a;
                this.lb(a);
            }
        };
        Series.prototype.lb = function (a) {
        };
        Series.prototype.k0 = function () {
        };
        Series.prototype.k6 = function () {
        };
        Series.prototype.an = function (a) {
            return null;
        };
        Series.prototype.ag = function () {
            return null;
        };
        Series.prototype.f2 = function () {
            return NaN;
        };
        Series.f3 = function (a, b) {
            if (a == null || a.count == 0) {
                return NaN;
            }
            if (b != null && b.i$b != null) {
                if (b.i$b.count != a.count) {
                    return NaN;
                }
                for (var c = 0; c < a.count; c++) {
                    if (!i2.isNaN_(a.item(b.i$b._inner[c])) && a.item(b.i$b._inner[c]) != 0) {
                        return a.item(b.i$b._inner[c]);
                    }
                }
            }
            for (var d = 0; d < a.count; d++) {
                if (!i2.isNaN_(a.item(d)) && a.item(d) != 0) {
                    return a.item(d);
                }
            }
            return NaN;
        };
        Series.prototype.la = function () {
        };
        Object.defineProperty(Series.prototype, "fs", {
            get: function () {
                return this.fg;
            },
            set: function (a) {
                var b = this.fs;
                if (a != b) {
                    this.fg = a;
                    this.raisePropertyChanged("FinalValue", b, this.fs);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "gg", {
            get: function () {
                return this.fh;
            },
            set: function (a) {
                var b = this.gg;
                if (a != b) {
                    this.fh = a;
                    this.raisePropertyChanged("PercentChange", b, this.gg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.mj = function () {
            var a = this.f2();
            this.gg = (this.fs - a) / a * 100;
        };
        Series.prototype.hj = function (a) {
            return null;
        };
        Object.defineProperty(Series.prototype, "h5", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.bz) ? this.ck.bz : "Open";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "hu", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.bw) ? this.ck.bw : "Close";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "hv", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.bx) ? this.ck.bx : "High";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "h3", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.by) ? this.ck.by : "Low";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "ia", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.b0) ? this.ck.b0 : "Volume";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "h9", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.b9) ? this.ck.b9 : "Value";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Series.prototype, "h7", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.ck.m) ? this.ck.m : "Radius";
            },
            enumerable: false,
            configurable: true
        });
        Series.prototype.me = function () {
            this.ms = this.mu();
            this.bx.bj();
        };
        Series.prototype.am = function () {
            var a = this.a9;
            if (a == 0) {
                a = this.ba();
            }
            var b = 0;
            if (a == 3) {
                if (this.dl || this.dk || this.ee) {
                    b = 6;
                }
                else if (this.dj) {
                    b = 7;
                }
                else {
                    b = 5;
                }
            }
            else if (a == 4) {
                if (this.hasMarkers) {
                    b = 8;
                }
                else {
                    b = 0;
                }
            }
            else if (a == 2) {
                if (this.hasMarkers && !this.c6) {
                    b = 1;
                }
                else {
                    b = 2;
                }
            }
            else if (a == 1) {
                b = 0;
            }
            else if (a == 5) {
                b = 3;
            }
            else if (a == 6) {
                b = 4;
            }
            else if (a == 7) {
                b = 9;
            }
            return b;
        };
        Series.prototype.a8 = function (a) {
            return a;
        };
        Series.prototype.ba = function () {
            if (this.c7 || this.c9 || this.db || this.d1 || this.d8 || this.dl || this.dj || this.dk || this.ec || this.ee) {
                return this.a8(3);
            }
            else if (this.dv || this.ea || this.d2 || this.du || this.ed) {
                return this.a8(2);
            }
            else if (this.c6 || this.dz || this.dy) {
                return this.a8(1);
            }
            else if (this.c0) {
                return this.a8(4);
            }
            return this.a8(1);
        };
        Series.$t = i2.markType(Series, 'Series', i2.Control.$, [i2.INotifyPropertyChanged_$type, IProvidesViewport_$type, i2.ILegendSeries_$type, i2.ILegendSeriesInternal_$type, i2.ILegendOwner_$type, i2.ILegendTemplateProvider_$type]);
        Series.gx = 0;
        Series.n9 = i2.DependencyProperty.i("VisibilityProxy", i2.Visibility_$type, Series.$, new i2.PropertyMetadata(2, i2.enumGetBox(i2.Visibility_$type, 0), function (a, b) { return a.raisePropertyChanged("VisibilityProxy", b.oldValue, b.newValue); }));
        Series.ng = i2.DependencyProperty.i("ItemsSource", i2.IEnumerable_$type, Series.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(Series.$, a);
            if (c.b5 != null) {
                c.b5.releaseFastItemsSource(b.oldValue);
            }
            a.raisePropertyChanged("ItemsSource", b.oldValue, b.newValue);
        }));
        Series.nm = i2.DependencyProperty.i("Legend", i2.IChartLegend_$type, Series.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(Series.$, a);
            c.raisePropertyChanged("Legend", b.oldValue, b.newValue);
        }));
        Series.nj = i2.DependencyProperty.i("LegendItemBadgeTemplate", i2.DataTemplate.$, Series.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(Series.$, a);
            c.raisePropertyChanged("LegendItemBadgeTemplate", b.oldValue, b.newValue);
            if (c.mq != null) {
                c.mq = c.mp();
            }
        }));
        Series.nk = i2.DependencyProperty.i("LegendItemTemplate", i2.DataTemplate.$, Series.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(Series.$, a);
            c.raisePropertyChanged("LegendItemTemplate", b.oldValue, b.newValue);
            if (c.mq != null) {
                c.mq = c.mp();
            }
        }));
        Series.m8 = i2.DependencyProperty.i("DiscreteLegendItemTemplate", i2.DataTemplate.$, Series.$, new i2.PropertyMetadata(2, null, function (a, b) {
            var c = i2.typeCast(Series.$, a);
            c.raisePropertyChanged("DiscreteLegendItemTemplate", b.oldValue, b.newValue);
        }));
        Series.nc = i2.DependencyProperty.i("Index", i2.Number_$type, Series.$, new i2.PropertyMetadata(2, -1, function (a, b) {
            var c = i2.typeCast(Series.$, a);
            c.raisePropertyChanged("Index", b.oldValue, b.newValue);
            if (c.mq != null) {
                c.mq = c.mp();
            }
        }));
        Series.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, Series, 'raisePropertyChanged', ['ActualAreaFillOpacity:fi:mw', [1, 1], 'ActualBrush:of:mx', [i2.Brush.$], 'ActualLegendItemBadgeBrush:og:my', [i2.Brush.$], 'ActualLegendItemBadgeOutline:oh:mz', [i2.Brush.$], 'ActualLegendItemBadgeTemplate:ms:m0', [i2.DataTemplate.$], 'ActualMarkerFillOpacity:fk:m1', [1, 1], 'ActualOutline:oi:m2', [i2.Brush.$], 'ActualThickness:fl:m3', [1, i2.DeviceUtils.g(2)], 'AreaFillOpacity:fq:m4', [1, NaN], 'Brush:oj:m5', [i2.Brush.$, null], 'DashArray:os:m6', [i2.DoubleCollection.$], 'DashCap:ot:m7', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)], 'EndCap:ou:m9', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 2)], 'FastItemsSource:ch:na', [i2.IFastItemsSource_$type], 'HighlightingFadeOpacity:gd:nb', [1, NaN], 'IsComponentHighlightingModeIgnored:dc:nd', [0, false], 'IsDropShadowEnabled:dg:ne', [0, false], 'IsHighlightingEnabled:dq:nf', [0, false], 'LegendItemBadgeMode:a7:nh', [LegendItemBadgeMode_$type, i2.enumGetBox(LegendItemBadgeMode_$type, 0)], 'LegendItemBadgeShape:a9:ni', [LegendItemBadgeShape_$type, i2.enumGetBox(LegendItemBadgeShape_$type, 0)], 'LegendItemVisibility:ph:nl', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'MarkerFillOpacity:ge:nn', [1, NaN], 'MiterLimit:gf:no', [1, 0], 'MouseOverEnabled:ef:np', [0, true], 'OutlineMode:bs:nq', [SeriesOutlineMode_$type, i2.enumGetBox(SeriesOutlineMode_$type, 0)], 'Outline:oo:nr', [i2.Brush.$, null], 'Resolution:gh:ns', [1, 1], 'ShadowBlur:gj:nt', [1, NaN], 'ShadowColor:or:nu', [i2.Color.$], 'ShadowOffsetX:gk:nv', [1, NaN], 'ShadowOffsetY:gl:nw', [1, NaN], 'ShowDefaultTooltip:el:nx', [0, false], 'StartCap:ov:ny', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 2)], 'Thickness:gm:nz', [1, i2.DeviceUtils.g(2)], 'Title:hp:n0', [4, "Series Title"], 'ToolTip::n1', [4, null], 'TransitionDuration:ha:n2', [1, 0], 'TransitionEasingFunction:cc:n3', [i2.Delegate_$type, null], 'TransitionInDuration:hb:n4', [1, 1000], 'TransitionInEasingFunction:cd:n5', [i2.Delegate_$type, null], 'TransitionInSpeedType:b7:n6', [TransitionInSpeedType_$type, i2.enumGetBox(TransitionInSpeedType_$type, 0)], 'TransitionProgress:gn:n7', [1, 0], 'UseSingleShadow:e1:n8', [0, true], 'VisibleRangeMarginBottom:go:oa', [1, NaN], 'VisibleRangeMarginLeft:gp:ob', [1, NaN], 'VisibleRangeMarginRight:gq:oc', [1, NaN], 'VisibleRangeMarginTop:gr:od', [1, NaN], 'VisibleRangeMode:b1:oe', [SeriesVisibleRangeMode_$type, i2.enumGetBox(SeriesVisibleRangeMode_$type, 0)]]);
        return Series;
    }(i2.Control));
    /**
     * @hidden
     */
    var MarkerSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerSeries, _super);
        function MarkerSeries() {
            var _this = _super.call(this) || this;
            _this.pm = 1;
            _this.pi = 1;
            _this.qc = null;
            return _this;
        }
        MarkerSeries.prototype.pg = function () {
            if (this.pr != 1 && this.pr != 13) {
                var a = this.pq.cq();
                var b = (a.width / 2) + (this.pw / 2);
                var c = (a.height / 2) + (this.pw / 2);
                return new i2.Thickness(1, b, c, b, c);
            }
            return new i2.Thickness(1, 0, 0, 0, 0);
        };
        MarkerSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.pq = a;
        };
        MarkerSeries.prototype.get_hasMarkers = function () {
            return true;
        };
        MarkerSeries.prototype.om = function () {
            return this.qr;
        };
        MarkerSeries.prototype.on = function () {
            return this.qs;
        };
        MarkerSeries.prototype.mv = function () {
            return this.qc;
        };
        Object.defineProperty(MarkerSeries.prototype, "pn", {
            get: function () {
                return this.pm;
            },
            set: function (a) {
                this.pm = a;
            },
            enumerable: false,
            configurable: true
        });
        MarkerSeries.prototype.pp = function () {
            if (this.po == 0) {
                return 1;
            }
            return this.po;
        };
        MarkerSeries.prototype.mh = function (a) {
            _super.prototype.mh.call(this, a);
            this.po = a;
        };
        Object.defineProperty(MarkerSeries.prototype, "pj", {
            get: function () {
                return this.pi;
            },
            set: function (a) {
                this.pi = a;
            },
            enumerable: false,
            configurable: true
        });
        MarkerSeries.prototype.pl = function () {
            if (this.pk == 0) {
                return 1;
            }
            return this.pk;
        };
        MarkerSeries.prototype.mg = function (a) {
            _super.prototype.mg.call(this, a);
            this.pk = a;
        };
        MarkerSeries.prototype.mi = function (a) {
            _super.prototype.mi.call(this, a);
            this.pw = a;
        };
        MarkerSeries.prototype.ft = function () {
            return this.pw;
        };
        Object.defineProperty(MarkerSeries, "qe", {
            get: function () {
                if (MarkerSeries.qa == null) {
                    MarkerSeries.qa = new i2.DataTemplate();
                }
                return MarkerSeries.qa;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerSeries.prototype, "qt", {
            get: function () {
                return this.c(MarkerSeries.qi);
            },
            set: function (a) {
                this.h(MarkerSeries.qi, a);
            },
            enumerable: false,
            configurable: true
        });
        MarkerSeries.prototype.pt = function () {
            return this.qc != null && ((this.pr != 1 && this.pr != 0) || this.qd != null);
        };
        MarkerSeries.prototype.lc = function () {
            _super.prototype.lc.call(this);
            this.pn = this.pp();
            this.pj = this.pl();
        };
        MarkerSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "MarkerBrush":
                case MarkerSeries.$$p[9]:
                case MarkerSeries.$$p[5]:
                case MarkerSeries.$$p[7]:
                case MarkerSeries.$$p[8]:
                    this.md();
                    this.lj();
                    break;
                case MarkerSeries.$$p[4]:
                    this.pn = this.pp();
                    this.md();
                    this.lj();
                    break;
                case MarkerSeries.$$p[3]:
                    this.pj = this.pl();
                    this.md();
                    this.lj();
                    break;
                case MarkerSeries.$$p[2]:
                    this.qc = d;
                    if (c == MarkerSeries.qe || d == MarkerSeries.qe || (c == null || d != null)) {
                        this.pq.cg();
                        var e = i2.typeCast(MarkerSeriesView.$, this.bw);
                        if (e != null) {
                            e.cg();
                        }
                        this.l0(false);
                    }
                    this.bx.bj();
                    if (this.toolTip != null && this.dt) {
                        this.a4.a$aj(this, this.toolTip);
                    }
                    this.k7();
                    break;
                case MarkerSeries.$$p[10]:
                    this.pq.cn(this.pv);
                    this.l0(false);
                    break;
                case MarkerSeries.$$p[0]:
                case MarkerSeries.$$p[1]:
                    if (this.c0) {
                        this.og = this.om();
                        this.oh = this.on();
                    }
                    break;
            }
        };
        MarkerSeries.p0 = function (a) {
            switch (a) {
                case 3:
                case 13: return SeriesViewer.$$p[2];
                case 4: return SeriesViewer.$$p[34];
                case 5: return SeriesViewer.$$p[26];
                case 6: return SeriesViewer.$$p[28];
                case 7: return SeriesViewer.$$p[5];
                case 8: return SeriesViewer.$$p[18];
                case 9: return SeriesViewer.$$p[7];
                case 10: return SeriesViewer.$$p[31];
                case 11: return SeriesViewer.$$p[19];
                case 12: return SeriesViewer.$$p[8];
                case 0:
                case 1:
                default: return null;
            }
        };
        MarkerSeries.ps = function (a, b) {
            var c = 1;
            var d = 0;
            if (a != null && a.ca != null) {
                d = a.ca.a9;
            }
            if (a == null || a.ca == null) {
                c = 1;
                return c;
            }
            if (b != 2 && b != 0) {
                c = b;
            }
            else {
                if (d == 4) {
                    c = 3;
                }
                else if (d == 5) {
                    c = 4;
                }
                else if (d == 9) {
                    c = 8;
                }
                else if (d == 11) {
                    c = 10;
                }
                else if (d == 8) {
                    c = 7;
                }
                else if (d == 7) {
                    c = 6;
                }
                else if (d == 10) {
                    c = 9;
                }
                else if (d == 12) {
                    c = 11;
                }
                else if (d == 6) {
                    c = 5;
                }
                else if (d == 13) {
                    c = 12;
                }
                else if (d == 1) {
                    c = 1;
                }
                else if (d == 0) {
                    if (a.dw) {
                        c = 1;
                    }
                    else {
                        c = 3;
                    }
                }
                else if (d == 3 || d == 2) {
                    if (d == 2) {
                        if (a.dw) {
                            c = 1;
                            return c;
                        }
                    }
                    if (a.g9 < 0) {
                        c = 1;
                    }
                    else {
                        var e = [3, 4, 8, 10, 7, 6, 9, 11, 5, 12];
                        c = e[a.g9 % e.length];
                    }
                }
            }
            return c;
        };
        MarkerSeries.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            if (this.pq.b2()) {
                this.pq.ce();
                this.pq.b8();
            }
            else {
                var a = MarkerSeries.ps(this, this.pr);
                var b = MarkerSeries.p0(a);
                if (b == null) {
                    this.qb = MarkerSeries.qe;
                }
                else {
                    this.pq.cb(b);
                }
            }
            if (this.qt != null && this.pr != 13) {
                this.pq.cc();
                this.pq.b9();
            }
            else {
                if (this.pr == 13) {
                    this.qr = this.bx.bq();
                }
                else {
                    if (this.pj != 2) {
                        if (this.ca != null) {
                            var c = this.ca.oy(this.g9);
                            if (!i2.isNaN_(this.fk) && this.fk != 1) {
                                c = i2.BrushUtil.o(c, this.fk);
                            }
                            this.qr = c;
                        }
                        else {
                            this.qr = null;
                        }
                    }
                }
            }
            if (this.qu != null) {
                this.pq.cd();
                this.pq.ca();
            }
            else {
                if (this.pr == 13) {
                    this.qs = this.bx.bq();
                }
                else {
                    if (this.pn == 2) {
                        this.qs = this.qr;
                    }
                    else {
                        this.qs = this.ca == null ? null : this.ca.oz(this.g9);
                    }
                }
            }
            if (this.pj == 2 && this.qt == null && this.pr != 13) {
                if (this.qs != null) {
                    var d = this.qs;
                    if (!i2.isNaN_(this.fk) && this.fk != 1) {
                        d = i2.BrushUtil.o(d, this.fk);
                    }
                    this.qr = d;
                }
                else {
                    this.qr = null;
                }
            }
        };
        MarkerSeries.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            this.a6.exportMarkerVisualData(this, a);
        };
        MarkerSeries.prototype.pu = function (a, b) {
            if (this.hasMarkers && this.pt()) {
                var c = this.pe(a);
                if (c.isEmpty) {
                    return false;
                }
                var d = i2.RectUtil.r(c, this.fz(b));
                if (d.containsPoint(a)) {
                    return true;
                }
            }
            return false;
        };
        MarkerSeries.prototype.at = function (a, b) {
            var c = this.pq.by(a);
            var d = null;
            if (c != null) {
                d = c.content;
            }
            return d;
        };
        MarkerSeries.$t = i2.markType(MarkerSeries, 'MarkerSeries', Series.$);
        MarkerSeries.qa = null;
        MarkerSeries.qi = i2.DependencyProperty.i("MarkerBrush", i2.Brush.$, MarkerSeries.$, new i2.PropertyMetadata(1, function (a, b) {
            var c = (i2.typeCast(MarkerSeries.$, a));
            c.raisePropertyChanged("MarkerBrush", b.oldValue, b.newValue);
        }));
        MarkerSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, MarkerSeries, 'raisePropertyChanged', ['ActualMarkerBrush:qr:qf', [i2.Brush.$], 'ActualMarkerOutline:qs:qg', [i2.Brush.$], 'ActualMarkerTemplate:qb:qh', [i2.DataTemplate.$, null], 'MarkerFillMode:pk:qj', [MarkerFillMode_$type, i2.enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:po:qk', [MarkerOutlineMode_$type, i2.enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:qu:ql', [i2.Brush.$], 'MarkerStyle:qv:qm', [i2.Style.$], 'MarkerTemplate:qd:qn', [i2.DataTemplate.$, null], 'MarkerThickness:pw:qo', [1, i2.DeviceUtils.g(2)], 'MarkerType:pr:qp', [MarkerType_$type, i2.enumGetBox(MarkerType_$type, 1)], 'UseLightweightMarkers:pv:qq', [0, false]]);
        return MarkerSeries;
    }(Series));
    /**
     * @hidden
     */
    var SyncLink = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SyncLink, _super);
        function SyncLink() {
            var _this = _super.call(this) || this;
            _this.ai = null;
            _this.af = new i2.Dictionary$2(i2.IEnumerable_$type, i2.FastItemsSourceReference.$, 0);
            _this.aq = null;
            _this.ab = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.am(a, b.propertyName, b.oldValue, b.newValue); });
            _this.ab = new ChartCollection();
            var a = _this.ab;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.aj));
            _this.aq = new i2.Rect(0, 0, 0, 1, 1);
            return _this;
        }
        SyncLink.prototype.am = function (a, b, c, d) {
        };
        SyncLink.prototype.releaseFastItemsSource = function (a) {
            var _this = this;
            if (a != null) {
                var b_1 = null;
                if (((function () { var c = _this.af.tryGetValue(a, b_1); b_1 = c.p1; return c.ret; })())) {
                    --b_1.b;
                    if (b_1.b == 0) {
                        this.af.removeItem(a);
                    }
                }
            }
            return null;
        };
        SyncLink.ad = function (a) {
            return ((function () {
                var $ret = new i2.FastItemsSource();
                $ret.e = a;
                return $ret;
            })());
        };
        SyncLink.prototype.getFastItemsSource = function (a) {
            var _this = this;
            if (SyncLink.ah == null) {
                SyncLink.ah = SyncLink.ad;
            }
            var b = null;
            if (a != null) {
                var c_1 = null;
                if (!((function () { var d = _this.af.tryGetValue(a, c_1); c_1 = d.p1; return d.ret; })())) {
                    b = SyncLink.ah(a);
                    c_1 = new i2.FastItemsSourceReference(b);
                    this.af.addItem(a, c_1);
                }
                c_1.b++;
                b = c_1.a;
            }
            return b;
        };
        SyncLink.prototype.ae = function (a) {
            var _this = this;
            var b = null;
            if (a != null) {
                var c_2 = null;
                if (!((function () { var d = _this.af.tryGetValue(a, c_2); c_2 = d.p1; return d.ret; })())) {
                    return null;
                }
                b = c_2.a;
            }
            return b;
        };
        SyncLink.prototype.ar = function (a, b, c) {
            return this.as(a, b, c, false);
        };
        SyncLink.prototype.as = function (a, b, c, d) {
            if (!c.isEmpty) {
                c = new i2.Rect(0, c.left, c.top, c.width, c.height);
                var e = a.f5;
                if (b == a) {
                    if (!d) {
                        if (!b.d4()) {
                            c.x = b.pw.x;
                            c.width = b.pw.width;
                        }
                        if (!b.d5()) {
                            c.y = b.pw.y;
                            c.height = b.pw.height;
                        }
                    }
                }
                else {
                    var f = SyncManager.a(b);
                    if (f == null || !f.synchronizeHorizontally) {
                        c.x = b.pw.x;
                        c.width = b.pw.width;
                    }
                    if (f == null || !f.synchronizeVertically) {
                        c.y = b.pw.y;
                        c.height = b.pw.height;
                    }
                }
                var g = 0.5 * (c.left + c.right);
                var h = 0.5 * (c.top + c.bottom);
                var i = c.width;
                var j = c.height;
                var k = i2.MathUtil.b(c.width, e, 1);
                var l = i2.MathUtil.b(c.height, e, 1);
                var m = false;
                if (a.ep() && !a.pv.isEmpty) {
                    var n = a.pv;
                    var o = n.width / n.height;
                    var p = k * n.width;
                    var q = l * n.height;
                    var r = p / q;
                    if (r != o) {
                        if (q * o > p) {
                            p = q * o;
                            k = p / n.width;
                        }
                        else {
                            q = p / o;
                            l = q / n.height;
                        }
                    }
                }
                else if (a.di()) {
                    var s = false;
                    var t = false;
                    if (Math.abs(k - a.pg.width) > e) {
                        s = true;
                    }
                    if (Math.abs(l - a.pg.height) > e) {
                        t = true;
                    }
                    var u = a.js(k, l, s, t);
                    k = u.p0;
                    l = u.p1;
                    k = i2.MathUtil.b(k, e, 1);
                    l = i2.MathUtil.b(l, e, 1);
                }
                else if (b.ek && c.width < 1) {
                    var v = 1.7976931348623157E+308;
                    var w = -1.7976931348623157E+308;
                    var x = c.left;
                    var y = c.right;
                    var z = c.top;
                    var aa = c.bottom;
                    var ab = c.width;
                    var ac = c.height;
                    if (b.by == 1) {
                        if (x < 0) {
                            x = 0;
                            y = x + ab;
                        }
                        if (y > 1) {
                            y = 1;
                            x = y - ab;
                        }
                        if (z < 0) {
                            z = 0;
                            aa = z + ac;
                        }
                        if (aa > 1) {
                            aa = 1;
                            z = aa - ac;
                        }
                    }
                    var ad = new i2.Rect(0, x, z, y - x, aa - z);
                    for (var ae = 0; ae < b.series.count; ae++) {
                        var af = b.series._inner[ae];
                        if (af.c6) {
                            continue;
                        }
                        var ag = af.ag();
                        var ah = null;
                        for (var ai = 0; ai < ag.length; ai++) {
                            if (ag[ai].cj) {
                                ah = ag[ai];
                            }
                        }
                        if (ah != null) {
                            var aj = new i2.Rect(0, 0, 0, 1, 1);
                            var ak = new ScalerParams(0, aj, aj, ah.cc, b.pp(aj, b.pv, b.pk));
                            ak.b = af.f2();
                            var al = af.aq(ad);
                            var am = al == null || al.c == 1.7976931348623157E+308 || i2.isNaN_(al.c);
                            if (am) {
                                continue;
                            }
                            var an = ah.d8(al.c, ak);
                            var ao = ah.d8(al.b, ak);
                            if (ah.cc) {
                                var ap = an;
                                an = ao;
                                ao = ap;
                            }
                            w = Math.max(w, an);
                            v = Math.min(v, ao);
                            if (af.bz == 2) {
                                if (ah.ce) {
                                    var aq = ah;
                                    var ar = aq.k5;
                                    ar = ah.dt(ar, ak);
                                    var as = ah.d8(ar, ak);
                                    w = Math.max(w, as);
                                    v = Math.min(v, as);
                                }
                            }
                        }
                    }
                    var at = (v == 1.7976931348623157E+308 || w == -1.7976931348623157E+308 || i2.isNaN_(v) || i2.isNaN_(w));
                    if (!at) {
                        c = new i2.Rect(0, c.left, v, c.width, w - v);
                        k = c.width;
                        l = c.height;
                        m = true;
                    }
                }
                var au = k != i;
                var av = l != j;
                var aw = au && !m ? g - 0.5 * k : c.left;
                var ax = av && !m ? h - 0.5 * l : c.top;
                var ay = au && !m ? g + 0.5 * k : c.right;
                var az = av && !m ? h + 0.5 * l : c.bottom;
                if (b.by == 1) {
                    if (aw < 0) {
                        aw = 0;
                        ay = aw + k;
                    }
                    if (ay > 1) {
                        ay = 1;
                        aw = ay - k;
                    }
                    if (ax < 0) {
                        ax = 0;
                        az = ax + l;
                    }
                    if (az > 1) {
                        az = 1;
                        ax = az - l;
                    }
                }
                c = new i2.Rect(0, aw, ax, ay - aw, az - ax);
            }
            return c;
        };
        Object.defineProperty(SyncLink.prototype, "ag", {
            get: function () {
                return this.ab;
            },
            enumerable: false,
            configurable: true
        });
        SyncLink.prototype.aj = function (a, b) {
            var e_82, _a;
            if (b.newItems != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEn(b.newItems)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        if (c.pw.isEmpty) {
                            c.pw = this.ar(null, c, this.aq);
                        }
                    }
                }
                catch (e_82_1) {
                    e_82 = { error: e_82_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_82)
                            throw e_82.error;
                    }
                }
            }
        };
        SyncLink.prototype.ak = function (a, b) {
            var e_83, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ag)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (c == a) {
                        c.o8 = { $type: i2.Point_$type, x: b.x, y: b.y };
                    }
                    else {
                        var d = { $type: i2.Point_$type, x: b.x, y: b.y };
                        var e = SyncManager.a(c);
                        if (e == null || !e.synchronizeHorizontally) {
                            d.x = NaN;
                        }
                        if (e == null || !e.synchronizeVertically) {
                            d.y = NaN;
                        }
                        c.o8 = d;
                    }
                }
            }
            catch (e_83_1) {
                e_83 = { error: e_83_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_83)
                        throw e_83.error;
                }
            }
        };
        SyncLink.prototype.al = function (a, b) {
            var e_84, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ag)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.pq = this.ar(a, c, b);
                }
            }
            catch (e_84_1) {
                e_84 = { error: e_84_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_84)
                        throw e_84.error;
                }
            }
        };
        SyncLink.prototype.ao = function (a, b) {
            this.ap(a, b, false);
        };
        SyncLink.prototype.ap = function (a, b, c) {
            var e_85, _a;
            var d = b.isEmpty || i2.isNaN_(b.x) || i2.isNaN_(b.y) || i2.isNaN_(b.width) || i2.isNaN_(b.height);
            if (!d && !a.dg) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.ag)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        e.dg = true;
                        e.pw = this.as(a, e, b, c);
                        e.dg = false;
                    }
                }
                catch (e_85_1) {
                    e_85 = { error: e_85_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_85)
                            throw e_85.error;
                    }
                }
            }
        };
        SyncLink.prototype.an = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        SyncLink.$t = i2.markType(SyncLink, 'SyncLink', i2.FrameworkElement.$, [i2.INotifyPropertyChanged_$type, i2.IFastItemsSourceProvider_$type]);
        SyncLink.ah = null;
        return SyncLink;
    }(i2.FrameworkElement));
    /**
     * @hidden
     */
    var SyncLinkManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SyncLinkManager, _super);
        function SyncLinkManager() {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.d = new i2.Dictionary$2(i2.String_$type, SyncLink.$, 0);
            return _this;
        }
        SyncLinkManager.instance = function () {
            if (SyncLinkManager.b == null) {
                SyncLinkManager.b = new SyncLinkManager();
            }
            return SyncLinkManager.b;
        };
        Object.defineProperty(SyncLinkManager.prototype, "e", {
            get: function () {
                return this.d.count;
            },
            enumerable: false,
            configurable: true
        });
        SyncLinkManager.prototype.getLink = function (a) {
            var _this = this;
            var b;
            if (((function () { var c = _this.d.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                return b;
            }
            b = new SyncLink();
            b.ai = a;
            this.d.addItem(a, b);
            return b;
        };
        SyncLinkManager.prototype.releaseLink = function (a) {
            if (a.ag.count == 0 && a.ai != null && this.d.containsKey(a.ai)) {
                this.d.removeItem(a.ai);
            }
        };
        SyncLinkManager.$t = i2.markType(SyncLinkManager, 'SyncLinkManager');
        SyncLinkManager.b = null;
        return SyncLinkManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var SyncManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SyncManager, _super);
        function SyncManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SyncManager.e = function (a) {
            var b = SyncManager.a(a);
            if (b == null) {
                return;
            }
            if (!a.d0) {
                return;
            }
            if (a.syncChannel != b.syncChannel) {
                return;
            }
            SyncManager.b(a, a.syncChannel, null);
        };
        SyncManager.c = function (a) {
            var b = SyncManager.a(a);
            if (b == null) {
                return;
            }
            if (a.d0 && a.syncChannel == b.syncChannel) {
                return;
            }
            var c = null;
            if (a.d0) {
                c = a.syncChannel;
            }
            SyncManager.b(a, c, b.syncChannel);
        };
        SyncManager.b = function (a, b, c) {
            if (a != null) {
                if (i2.stringIsNullOrEmpty(c)) {
                    var d = a.actualSyncLink;
                    a.actualSyncLink = null;
                    a.actualSyncLink = new SyncLink();
                    if (d != null) {
                        SyncLinkManager.instance().releaseLink(d);
                    }
                    a.syncChannel = null;
                }
                else {
                    if (!i2.stringIsNullOrEmpty(b)) {
                        var e = a.actualSyncLink;
                        a.actualSyncLink = null;
                        if (e != null) {
                            SyncLinkManager.instance().releaseLink(e);
                        }
                    }
                    a.actualSyncLink = SyncLinkManager.instance().getLink(c);
                    a.syncChannel = c;
                }
            }
        };
        SyncManager.d = function (a, b) {
            a.syncSettings = b;
        };
        SyncManager.a = function (a) {
            return a.syncSettings;
        };
        SyncManager.$t = i2.markType(SyncManager, 'SyncManager');
        return SyncManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var ChartCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartCollection, _super);
        function ChartCollection() {
            var _this = _super.call(this, SeriesViewer.$, 0) || this;
            _this.collectionResetting = null;
            return _this;
        }
        ChartCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        ChartCollection.$t = i2.markType(ChartCollection, 'ChartCollection', i2.ObservableCollection$1.$.specialize(SeriesViewer.$));
        return ChartCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var SeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesCollection, _super);
        function SeriesCollection() {
            var _this = _super.call(this, Series.$, 0) || this;
            _this.collectionResetting = null;
            return _this;
        }
        SeriesCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        SeriesCollection.$t = i2.markType(SeriesCollection, 'SeriesCollection', i2.ObservableCollection$1.$.specialize(Series.$));
        return SeriesCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var PlotAreaMouseEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PlotAreaMouseEventArgs, _super);
        function PlotAreaMouseEventArgs(a, b, c) {
            var _this = _super.call(this) || this;
            _this._chartPosition = null;
            _this._plotAreaPosition = null;
            _this._isDuringManipulation = false;
            _this._viewer = null;
            _this.viewer = a;
            _this.chartPosition = b;
            _this.plotAreaPosition = c;
            return _this;
        }
        Object.defineProperty(PlotAreaMouseEventArgs.prototype, "chartPosition", {
            get: function () {
                return this._chartPosition;
            },
            set: function (a) {
                this._chartPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PlotAreaMouseEventArgs.prototype, "plotAreaPosition", {
            get: function () {
                return this._plotAreaPosition;
            },
            set: function (a) {
                this._plotAreaPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PlotAreaMouseEventArgs.prototype, "isDuringManipulation", {
            get: function () {
                return this._isDuringManipulation;
            },
            set: function (a) {
                this._isDuringManipulation = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PlotAreaMouseEventArgs.prototype, "viewer", {
            get: function () {
                return this._viewer;
            },
            set: function (a) {
                this._viewer = a;
            },
            enumerable: false,
            configurable: true
        });
        PlotAreaMouseEventArgs.$t = i2.markType(PlotAreaMouseEventArgs, 'PlotAreaMouseEventArgs', i2.EventArgs.$);
        return PlotAreaMouseEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var PlotAreaMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PlotAreaMouseButtonEventArgs, _super);
        function PlotAreaMouseButtonEventArgs(a, b, c) {
            var _this = _super.call(this) || this;
            _this._chartPosition = null;
            _this._plotAreaPosition = null;
            _this._manipulationOccurred = false;
            _this._viewer = null;
            _this.viewer = a;
            _this.chartPosition = b;
            _this.plotAreaPosition = c;
            return _this;
        }
        Object.defineProperty(PlotAreaMouseButtonEventArgs.prototype, "chartPosition", {
            get: function () {
                return this._chartPosition;
            },
            set: function (a) {
                this._chartPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PlotAreaMouseButtonEventArgs.prototype, "plotAreaPosition", {
            get: function () {
                return this._plotAreaPosition;
            },
            set: function (a) {
                this._plotAreaPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PlotAreaMouseButtonEventArgs.prototype, "manipulationOccurred", {
            get: function () {
                return this._manipulationOccurred;
            },
            set: function (a) {
                this._manipulationOccurred = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PlotAreaMouseButtonEventArgs.prototype, "viewer", {
            get: function () {
                return this._viewer;
            },
            set: function (a) {
                this._viewer = a;
            },
            enumerable: false,
            configurable: true
        });
        PlotAreaMouseButtonEventArgs.$t = i2.markType(PlotAreaMouseButtonEventArgs, 'PlotAreaMouseButtonEventArgs', i2.EventArgs.$);
        return PlotAreaMouseButtonEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var ChartCursorEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartCursorEventArgs, _super);
        function ChartCursorEventArgs(a, b, c) {
            var _this = _super.call(this) || this;
            _this._item = null;
            _this._series = null;
            _this._seriesViewer = null;
            _this.seriesViewer = a;
            _this.series = b;
            _this.item = c;
            return _this;
        }
        ChartCursorEventArgs.prototype.toString = function () {
            return this.seriesViewer.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "");
        };
        Object.defineProperty(ChartCursorEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartCursorEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartCursorEventArgs.prototype, "seriesViewer", {
            get: function () {
                return this._seriesViewer;
            },
            set: function (a) {
                this._seriesViewer = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartCursorEventArgs.prototype, "chart", {
            get: function () {
                return i2.typeCast(XamDataChart.$, this.seriesViewer);
            },
            enumerable: false,
            configurable: true
        });
        ChartCursorEventArgs.$t = i2.markType(ChartCursorEventArgs, 'ChartCursorEventArgs', i2.EventArgs.$);
        return ChartCursorEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var DataChartMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DataChartMouseButtonEventArgs, _super);
        function DataChartMouseButtonEventArgs(a, b, c, d) {
            var _this = _super.call(this) || this;
            _this.g = null;
            _this._item = null;
            _this._series = null;
            _this._chart = null;
            _this.chart = a;
            _this.series = b;
            _this.item = c;
            _this.g = d;
            return _this;
        }
        DataChartMouseButtonEventArgs.prototype.toString = function () {
            return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
        };
        Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "handled", {
            get: function () {
                return this.g.handled;
            },
            set: function (a) {
                this.g.handled = a;
            },
            enumerable: false,
            configurable: true
        });
        DataChartMouseButtonEventArgs.prototype.getPosition = function (a) {
            return this.g.getPosition(a);
        };
        Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "originalSource", {
            get: function () {
                return this.g.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "chart", {
            get: function () {
                return this._chart;
            },
            set: function (a) {
                this._chart = a;
            },
            enumerable: false,
            configurable: true
        });
        DataChartMouseButtonEventArgs.$t = i2.markType(DataChartMouseButtonEventArgs, 'DataChartMouseButtonEventArgs', i2.EventArgs.$);
        return DataChartMouseButtonEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var ChartMouseEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartMouseEventArgs, _super);
        function ChartMouseEventArgs(a, b, c, d) {
            var _this = _super.call(this) || this;
            _this.f = null;
            _this._item = null;
            _this._series = null;
            _this._chart = null;
            _this.chart = a;
            _this.series = b;
            _this.item = c;
            _this.f = d;
            return _this;
        }
        ChartMouseEventArgs.prototype.toString = function () {
            return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
        };
        ChartMouseEventArgs.prototype.getPosition = function (a) {
            return this.f.getPosition(a);
        };
        Object.defineProperty(ChartMouseEventArgs.prototype, "originalSource", {
            get: function () {
                return this.f.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartMouseEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartMouseEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartMouseEventArgs.prototype, "chart", {
            get: function () {
                return this._chart;
            },
            set: function (a) {
                this._chart = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartMouseEventArgs.$t = i2.markType(ChartMouseEventArgs, 'ChartMouseEventArgs', i2.EventArgs.$);
        return ChartMouseEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var AxisComponentsForView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisComponentsForView, _super);
        function AxisComponentsForView() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            return _this;
        }
        AxisComponentsForView.$t = i2.markType(AxisComponentsForView, 'AxisComponentsForView');
        return AxisComponentsForView;
    }(i2.Base));
    /**
     * @hidden
     */
    var AxisLabelPanelBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelPanelBaseView, _super);
        function AxisLabelPanelBaseView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.av = null;
            _this.e = null;
            _this.au = i2.Rect.empty;
            _this.c = null;
            _this.h = 0;
            _this.i = NaN;
            _this.a = a;
            return _this;
        }
        AxisLabelPanelBaseView.prototype.aa = function (a, b, c, d, e, f) {
            var g = i2.typeCast(i2.FrameworkElement.$, a);
            if (g != null) {
                g._visibility = 0;
                if (b.width == 0 && b.height == 0) {
                    g._visibility = 1;
                }
                var h = b.height - (d + f);
                var i = b.width - (c + e);
                g.n = b.left + c;
                g.o = b.top + d;
                if (i < 0) {
                    i = 0;
                }
                if (h < 0) {
                    h = 0;
                }
                g.l = h;
                g.m = i;
                if (g.j != null) {
                    var j = g.j;
                    var k = j.j._inner[0];
                    k.k = k.k + g.n;
                    k.l = k.l + g.o;
                }
            }
        };
        AxisLabelPanelBaseView.prototype.z = function (a, b, c, d, e, f, g, h) {
            var i = Math.max(e, Math.max(f, Math.max(g, h)));
            var j = new i2.Thickness(0, i);
            if (this.a.ar) {
                j = new i2.Thickness(0, Math.sqrt((i * i) / 2));
            }
            var k = c.d;
            if (i2.isNaN_(k.c) || i2.isNaN_(k.e) || i2.isNaN_(k.d) || i2.isNaN_(k.b)) {
                k = j;
            }
            if (k.c > j.c || k.e > j.e || k.d > j.d || k.b > j.b) {
                k = j;
            }
            var l = new i2.Rect(0, d.left - k.c, d.top - k.e, d.width + k.c + k.d, d.height + k.e + k.b);
            var m = a.j;
            a.j = null;
            this.aa(a, l, e, f, g, h);
            a.j = m;
            a.width = a.m;
            a.height = a.l;
        };
        AxisLabelPanelBaseView.prototype.ad = function (a) {
            var b = a;
            b.j = null;
        };
        AxisLabelPanelBaseView.prototype.ag = function (a) {
        };
        AxisLabelPanelBaseView.prototype.ah = function (a, b) {
        };
        AxisLabelPanelBaseView.prototype.ai = function (a, b) {
            var c = i2.typeCast(i2.FrameworkElement.$, a);
            var d = 0;
            var e = 0;
            var f = new i2.TransformGroup();
            var g = ((function () {
                var $ret = new i2.RotateTransform();
                $ret.j = b;
                $ret.k = d;
                $ret.l = e;
                return $ret;
            })());
            f.j.add(g);
            c.j = f;
        };
        AxisLabelPanelBaseView.prototype.aq = function (a, b, c, d, e, f, g, h, i) {
            var j = Math.max(e, Math.max(f, Math.max(g, h)));
            var k = new i2.Thickness(0, j);
            if (this.a.ar) {
                k = new i2.Thickness(0, Math.sqrt((j * j) / 2));
            }
            var l = c.d;
            if (i2.isNaN_(l.c) || i2.isNaN_(l.e) || i2.isNaN_(l.d) || i2.isNaN_(l.b)) {
                l = k;
            }
            if (l.c > k.c || l.e > k.e || l.d > k.d || l.b > k.b) {
                l = k;
            }
            var m = b.j;
            var n = new i2.TransformGroup();
            var o = a.n + l.c;
            var p = a.o + l.e;
            n.j.add(m);
            a.j = n;
        };
        AxisLabelPanelBaseView.prototype.x = function (a, b, c, d) {
            var e = a.ak.length;
            var f = a.ak;
            var g = a.ak;
            while ((this.m(a) + c + d) > b && e > 0) {
                e--;
                f = f.substr(0, e) + "\u2026";
                a.ak = f;
            }
            a.ak = g;
            return f;
        };
        AxisLabelPanelBaseView.prototype.ae = function () {
            var e_86, _a;
            if (this.e == null) {
                return;
            }
            var a = this.g();
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    var c = i2.typeCast(i2.FrameworkElement.$, b);
                    if (c != null) {
                        this.a.cb(c);
                    }
                    this.a.b2(b);
                }
            }
            catch (e_86_1) {
                e_86 = { error: e_86_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_86)
                        throw e_86.error;
                }
            }
        };
        AxisLabelPanelBaseView.prototype.g = function () {
            var a = this.a.ax();
            var b = this.a.aw();
            if (!this.a.ac.c0) {
                return a;
            }
            else {
                return b;
            }
        };
        AxisLabelPanelBaseView.prototype.l = function (a) {
            return this.h;
        };
        AxisLabelPanelBaseView.prototype.n = function (a) {
            return this.l(a) + this.r() + this.o();
        };
        AxisLabelPanelBaseView.prototype.am = function () {
            this.av = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                $ret.ab = false;
                return $ret;
            })());
        };
        AxisLabelPanelBaseView.prototype.m = function (a) {
            var b = a;
            if (b != null && b.ak != null) {
                return this.e.e(b);
            }
            return 0;
        };
        AxisLabelPanelBaseView.prototype.w = function (a) {
            var b = a;
            if (b != null && b.ak != null) {
                return this.m(a) + this.p() + this.q();
            }
            return 0;
        };
        AxisLabelPanelBaseView.prototype.ac = function () {
            this.a.bd = this.a.ac.ee();
        };
        AxisLabelPanelBaseView.prototype.aj = function () {
            this.af();
            this.a.c0(new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        };
        AxisLabelPanelBaseView.prototype.f = function () {
            return this.e;
        };
        AxisLabelPanelBaseView.prototype.ak = function (a) {
            this.e = a;
        };
        AxisLabelPanelBaseView.prototype.y = function () {
            if (this.a.cu.isEmpty) {
                return;
            }
            var a = this.a.a9;
            this.a.cy(new i2.Size(1, this.a.cu.width, this.a.cu.height));
            if (this.a.a9 != a) {
                this.a.ac.bf.jq();
                this.al();
            }
        };
        AxisLabelPanelBaseView.prototype.al = function () {
        };
        AxisLabelPanelBaseView.prototype.ao = function (a) {
            this.e.w(a);
        };
        AxisLabelPanelBaseView.prototype.an = function () {
            var e_87, _a, e_88, _b;
            if (this.e == null) {
                return;
            }
            if (this.e.d) {
                if (this.a.ac.bh != null && this.a.ac.bh.fh != 1) {
                    this.e.z();
                    this.e.aa(this.a.ac.bh.fh, this.a.ac.bh.fh);
                }
                this.af();
                this.au = this.a.cu;
                var a = this.a.ac.bf.getFontBrush();
                if (this.a.af != null && this.a.af.textColor != null) {
                    a = this.a.af.textColor;
                }
                if (this.a.j != null) {
                    this.e.z();
                    this.e.j(this.a.j);
                }
                var b = false;
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.g())), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        var d = i2.typeCast(i2.TextBlock.$, c);
                        if (d != null) {
                            if (d.s != 0) {
                                b = true;
                                continue;
                            }
                            d.am = a;
                            if (d.j != null) {
                                this.e.z();
                                this.e.j(d.j);
                            }
                            this.ao(d);
                            if (d.j != null) {
                                this.e.y();
                            }
                        }
                    }
                }
                catch (e_87_1) {
                    e_87 = { error: e_87_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_87)
                            throw e_87.error;
                    }
                }
                if (b) {
                    try {
                        for (var _e = tslib.__values(i2.fromEnum(this.a.ab)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var e = _f.value;
                            var f = i2.typeCast(i2.Rectangle.$, e);
                            if (f != null) {
                                if (f.s == 0) {
                                    continue;
                                }
                                if (f.j != null) {
                                    this.e.z();
                                    this.e.j(f.j);
                                }
                                this.e.v(f);
                                if (f.j != null) {
                                    this.e.y();
                                }
                            }
                            var g = i2.typeCast(i2.TextBlock.$, e);
                            if (g != null) {
                                if (g.s == 0) {
                                    continue;
                                }
                                if (g.j != null) {
                                    this.e.z();
                                    this.e.j(g.j);
                                }
                                if (g.am == null) {
                                    g.am = a;
                                }
                                this.e.w(g);
                                if (g.j != null) {
                                    this.e.y();
                                }
                            }
                        }
                    }
                    catch (e_88_1) {
                        e_88 = { error: e_88_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_88)
                                throw e_88.error;
                        }
                    }
                }
                if (this.a.j != null) {
                    this.e.y();
                }
                this.ap();
                a = this.as();
                this.e.ac(this.d());
                var h = this.a.ac.h6;
                if (h != null) {
                    h.am = a;
                    if (h.j != null) {
                        this.e.z();
                        this.e.j(h.j);
                    }
                    this.e.w(h);
                    if (h.j != null) {
                        this.e.y();
                    }
                }
                if (this.a.ac.bh != null && this.a.ac.bh.fh != 1) {
                    this.e.y();
                }
            }
        };
        AxisLabelPanelBaseView.prototype.d = function () {
            var a = this.a.ac.bh.getFontInfo();
            if (this.a.ac.be != null && this.a.ac.be.textStyle != null) {
                a = this.a.ac.be.g(this.a.ac.bh.cf.j.ae);
            }
            else {
                var b = this.a.ac.bh.ch();
                if (b != null) {
                    a = b;
                }
            }
            return a;
        };
        AxisLabelPanelBaseView.prototype.as = function () {
            var a = this.a.ac.bf.getFontBrush();
            if (this.a.ac.be != null && this.a.ac.be.textColor != null) {
                a = this.a.ac.be.textColor;
            }
            else {
                var b = this.a.ac.bh.ov();
                if (b != null) {
                    a = b;
                }
            }
            return a;
        };
        AxisLabelPanelBaseView.prototype.af = function () {
            if (this.e == null) {
                return;
            }
            var a = this.a.ac.bh.getFontInfo();
            if (this.a.af != null && this.a.af.textStyle != null) {
                a = this.a.af.g(this.a.ac.bh.cf.j.ae);
            }
            if (this.c != a) {
                this.c = a;
                this.ar();
            }
            this.e.ac(a);
        };
        AxisLabelPanelBaseView.prototype.ar = function () {
            if (this.a.ac != null && this.a.ac.bh != null) {
                if (this.a.af == null || this.a.af.textStyle == null) {
                    this.h = this.a.ac.bh.cf.a9;
                    return;
                }
                if (this.h == 0) {
                    this.h = this.a.ac.bh.cf.a9;
                }
                var a = this.h;
                var b = this.a.ac.bh.getFontInfo();
                if (this.a.af != null && this.a.af.textStyle != null) {
                    b = this.a.af.g(this.a.ac.bh.cf.j.ae);
                }
                var c = i2.FontUtil.getCurrentFontHeight(this.a.ac.bh.cf.j.ae, b);
                this.h = c;
                if (a != this.h) {
                    this.a.ac.bh.jq();
                }
            }
        };
        AxisLabelPanelBaseView.prototype.j = function () {
            if (this.a.ac.gp == null) {
                return 0;
            }
            if (this.a.ac.be != null && this.a.ac.be.visibility == 1) {
                return 0;
            }
            if (!i2.isNaN_(this.i)) {
                return this.i;
            }
            var a = this.d();
            if (this.a.ac.bh == null) {
                return this.h;
            }
            this.i = i2.FontUtil.getCurrentFontHeight(this.a.ac.bh.cf.j.ae, a);
            return this.i;
        };
        AxisLabelPanelBaseView.prototype.k = function () {
            if (this.a.ac.be != null && this.a.ac.be.visibility == 1) {
                return 0;
            }
            if (this.e == null) {
                return 0;
            }
            var a = this.a.ac.h6;
            if (a != null && a.ak != null) {
                this.e.ac(this.d());
                var b = this.e.e(a);
                this.af();
                return b;
            }
            return 0;
        };
        AxisLabelPanelBaseView.prototype.ap = function () {
            if (this.a.ab.count == 0) {
                return;
            }
            if (this.a.ac.jf == null) {
                this.av._stroke = this.a.ac.bf.os();
            }
            else {
                this.av._stroke = this.a.ac.jf;
            }
            this.av.ac = this.a.ac.e1;
            this.e.s(this.av);
        };
        AxisLabelPanelBaseView.prototype.ab = function (a) {
        };
        AxisLabelPanelBaseView.prototype.aw = function () {
            return this.a.ac.bh.py();
        };
        AxisLabelPanelBaseView.prototype.v = function () {
            if (this.a.ac.be != null && !i2.isNaN_(this.a.ac.be.topMargin)) {
                return Math.max(0, this.a.ac.be.topMargin);
            }
            else {
                return this.aw().e;
            }
        };
        AxisLabelPanelBaseView.prototype.s = function () {
            if (this.a.ac.be != null && !i2.isNaN_(this.a.ac.be.bottomMargin)) {
                return Math.max(0, this.a.ac.be.bottomMargin);
            }
            else {
                return this.aw().b;
            }
        };
        AxisLabelPanelBaseView.prototype.t = function () {
            if (this.a.ac.be != null && !i2.isNaN_(this.a.ac.be.leftMargin)) {
                return Math.max(0, this.a.ac.be.leftMargin);
            }
            else {
                return this.aw().c;
            }
        };
        AxisLabelPanelBaseView.prototype.u = function () {
            if (this.a.ac.be != null && !i2.isNaN_(this.a.ac.be.rightMargin)) {
                return Math.max(0, this.a.ac.be.rightMargin);
            }
            else {
                return this.aw().d;
            }
        };
        AxisLabelPanelBaseView.prototype.at = function () {
            return this.av.ak.d;
        };
        AxisLabelPanelBaseView.prototype.b = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new PathRenderingInfo();
                $ret.e = _this.a.ac.jf;
                $ret.c = _this.a.ac.e1;
                return $ret;
            })());
            if (this.a.ac != null && i2.typeCast(XamDataChart.$, this.a.ac.bf) !== null) {
                var b = this.a.ac.bf;
                if (b.qe && b.b6 != 2 && b.b6 != 1) {
                    a.a = true;
                }
            }
            return a;
        };
        AxisLabelPanelBaseView.prototype.r = function () {
            if (this.a.af == null) {
                return 0;
            }
            return Math.max(0, this.a.af.topMargin);
        };
        AxisLabelPanelBaseView.prototype.p = function () {
            if (this.a.af == null) {
                return 0;
            }
            return Math.max(0, this.a.af.leftMargin);
        };
        AxisLabelPanelBaseView.prototype.q = function () {
            if (this.a.af == null) {
                return 0;
            }
            return Math.max(0, this.a.af.rightMargin);
        };
        AxisLabelPanelBaseView.prototype.o = function () {
            if (this.a.af == null) {
                return 0;
            }
            return Math.max(0, this.a.af.bottomMargin);
        };
        AxisLabelPanelBaseView.$t = i2.markType(AxisLabelPanelBaseView, 'AxisLabelPanelBaseView');
        return AxisLabelPanelBaseView;
    }(i2.Base));
    /**
     * @hidden
     */
    var AxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisView, _super);
        function AxisView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a7 = null;
            _this.a8 = null;
            _this.ba = null;
            _this.a9 = null;
            _this.b = new AxisComponentsFromView();
            _this.h = null;
            _this.k = null;
            _this.j = null;
            _this._isDirty = false;
            _this.bb = null;
            _this.a5 = i2.Rect.empty;
            _this.a = a;
            _this.bb = new i2.Rectangle();
            return _this;
        }
        AxisView.prototype.ag = function () {
            this.a7 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                return $ret;
            })());
            this.ba = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                $ret.ab = false;
                $ret.stroke = null;
                return $ret;
            })());
            this.a8 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                $ret.ab = false;
                return $ret;
            })());
            this.a9 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                $ret.ab = false;
                return $ret;
            })());
            this.a.jf = AxisDefaults.j;
            this.a.e0 = AxisDefaults.d;
            this.a.e1 = AxisDefaults.e;
            this.a.ef = AxisDefaults.b;
            this.a.ei = AxisDefaults.c;
            this.a.ez = AxisDefaults.a;
        };
        AxisView.prototype.ai = function (a) {
        };
        AxisView.prototype.ax = function () {
            var a = new i2.TextBlock();
            return a;
        };
        AxisView.prototype.aq = function (a) {
            a._visibility = 0;
            a.s = 0;
            if (a.x == null) {
                this.a.av.ab.add(a);
            }
        };
        AxisView.prototype.as = function (a) {
            a._visibility = 1;
        };
        AxisView.prototype.ar = function (a) {
            if (this.a.av.ab.contains(a)) {
                this.a.av.ab.remove(a);
            }
        };
        AxisView.prototype.bc = function () {
            var a = new i2.Rectangle();
            return a;
        };
        AxisView.prototype.p = function (a) {
            if (a.x == null) {
                this.d.ab.add(a);
            }
            a._visibility = 0;
        };
        AxisView.prototype.r = function (a) {
            a._visibility = 1;
        };
        AxisView.prototype.q = function (a) {
            if (this.a.av.ab.contains(a)) {
                this.a.av.ab.remove(a);
            }
        };
        AxisView.prototype.aj = function () {
        };
        AxisView.prototype.m = function () {
            return true;
        };
        Object.defineProperty(AxisView.prototype, "index", {
            get: function () {
                if (this.a.bh != null && this.a.bh.dx) {
                    return this.a.bh.series.count + 1;
                }
                var a = i2.typeCast(XamDataChart.$, this.a.bf);
                var b = 0;
                if (a == null) {
                    return 0;
                }
                if (a != null && a.p6 == 1) {
                    var c = 0;
                    for (var d = 0; d < this.a.bh.series.count; d++) {
                        if (this.a.bh.series._inner[d].isStacked) {
                            c += this.a.bh.series._inner[d].g8();
                        }
                        else {
                            c++;
                        }
                    }
                    b = c;
                }
                return b + a.axes.indexOf(this.a);
            },
            enumerable: false,
            configurable: true
        });
        AxisView.prototype.ad = function () {
            this.d.ca();
            this.d.by();
        };
        AxisView.prototype.ab = function () {
            this.d.b5();
        };
        AxisView.prototype.x = function () {
            if (this.d != null) {
                this.d.ab.clear();
            }
            this.z(this.a7.ak.d);
            this.z(this.ba.ak.d);
            this.z(this.a8.ak.d);
            this.z(this.a9.ak.d);
            this.ae();
        };
        AxisView.prototype.av = function (a) {
            this.a7._visibility = a;
            this.a8._visibility = a;
            this.ba._visibility = a;
            this.a9._visibility = a;
        };
        AxisView.prototype.an = function () {
        };
        AxisView.prototype.w = function (a) {
            this.a.ck = true;
            if (this.a.bh != null) {
                this.a.bh.jq();
            }
            this.a.hp();
        };
        AxisView.prototype.c = function () {
            this.b.a = this.a7;
            this.b.b = this.a8;
            this.b.c = this.a9;
            this.b.d = this.ba;
            return this.b;
        };
        AxisView.prototype.z = function (a) {
            if (a != null) {
                a.clear();
            }
        };
        AxisView.prototype.ay = function () {
            return this.a7.ak.d;
        };
        AxisView.prototype.e = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new PathRenderingInfo();
                $ret.e = _this.a.je;
                $ret.c = _this.a.ez;
                $ret.f = _this.a.ji;
                return $ret;
            })());
            if (i2.typeCast(XamDataChart.$, this.a.bf) !== null) {
                var b = this.a.bf;
                if (b.qe && b.b6 != 2 && b.b6 != 1) {
                    a.a = true;
                }
            }
            return a;
        };
        AxisView.prototype.a1 = function () {
            return this.ba.ak.d;
        };
        AxisView.prototype.az = function () {
            return this.a8.ak.d;
        };
        AxisView.prototype.f = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new PathRenderingInfo();
                $ret.e = _this.a.jb;
                $ret.c = _this.a.ef;
                $ret.f = _this.a.jg;
                return $ret;
            })());
            if (i2.typeCast(XamDataChart.$, this.a.bf) !== null) {
                var b = this.a.bf;
                if (b.qe && b.b6 != 2 && b.b6 != 1) {
                    a.a = true;
                }
            }
            return a;
        };
        AxisView.prototype.a0 = function () {
            return this.a9.ak.d;
        };
        AxisView.prototype.g = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new PathRenderingInfo();
                $ret.e = _this.a.jc;
                $ret.c = _this.a.ei;
                $ret.f = _this.a.jh;
                return $ret;
            })());
            if (i2.typeCast(XamDataChart.$, this.a.bf) !== null) {
                var b = this.a.bf;
                if (b.qe && b.b6 != 2 && b.b6 != 1) {
                    a.a = true;
                }
            }
            return a;
        };
        Object.defineProperty(AxisView.prototype, "d", {
            get: function () {
                return this.a.ap().a;
            },
            enumerable: false,
            configurable: true
        });
        AxisView.prototype.at = function (a, b, c) {
            this.d.ac = a;
            this.d.cx = b;
            this.d.cw = c;
            this.ae();
        };
        AxisView.prototype.y = function () {
            this.d.ab.clear();
            this.ae();
        };
        AxisView.prototype.ap = function (a) {
            this.d.br = a;
            this.ae();
        };
        AxisView.prototype.au = function (a, b) {
            this.d.a5 = a;
            this.d.a6 = b;
        };
        AxisView.prototype.ao = function (a) {
            this.d.bc = a;
        };
        AxisView.prototype.v = function () {
        };
        AxisView.prototype.o = function (a) {
            return null;
        };
        AxisView.prototype.n = function (dataItem_) {
            if (this.a.at != null) {
                return this.a.at(dataItem_);
            }
            if (this.a.ah != null) {
                return this.a.ah.i(dataItem_);
            }
            var label_ = this.a.fj;
            var a = typeof dataItem_ === 'number' && typeof label_ === 'string';
            var labelValue_ = null;
            if (this.h != null) {
                labelValue_ = this.h.getPropertyValue(dataItem_);
                if ((labelValue_ === undefined)) {
                    labelValue_ = label_;
                }
            }
            else {
                labelValue_ = a ? i2.stringFormat(label_, dataItem_) : (typeof dataItem_[label_] != 'undefined') ? dataItem_[label_] : label_;
                ;
            }
            if (this.a.expectFunctions) {
                if ((typeof (labelValue_) == 'function')) {
                    labelValue_ = labelValue_();
                }
            }
            return labelValue_;
        };
        AxisView.prototype.af = function (a, b) {
            this.j = a;
            this.k = b;
        };
        Object.defineProperty(AxisView.prototype, "isDirty", {
            get: function () {
                return this._isDirty;
            },
            set: function (a) {
                this._isDirty = a;
            },
            enumerable: false,
            configurable: true
        });
        AxisView.prototype.ae = function () {
            if (this.a.bf == null || this.j == null) {
                return;
            }
            if (!this.isDirty) {
                this.isDirty = true;
                this.a.bf.al.o(this.j, this.k);
            }
        };
        AxisView.prototype.undirty = function (a) {
            this.isDirty = false;
            this.al(a);
        };
        AxisView.prototype.al = function (a) {
            if (this.j == null) {
                return;
            }
            if (this.j.d) {
                if (this.a.bh != null && this.a.bh.fh != 1) {
                    this.j.z();
                    this.j.aa(this.a.bh.fh, this.a.bh.fh);
                }
                var b = this.a.bf.pl();
                if (a) {
                    this.j.k(b.left, b.top, b.width, b.height);
                }
                if (a) {
                    if (this.a.bh.o1 != null && !this.a.js.isEmpty) {
                        this.bb.o = this.a.js.top;
                        this.bb.n = this.a.js.left;
                        this.bb.width = this.a.js.width;
                        this.bb.height = this.a.js.height;
                        this.bb._fill = this.a.bh.o1;
                        this.j.v(this.bb);
                    }
                }
                this.j.z();
                this.j.ae(this.a.js);
                this.am();
                this.j.y();
                if (this.a.bh != null && this.a.bh.fh != 1) {
                    this.j.y();
                }
            }
            if (this.k.d) {
                if (this.a.bh != null && this.a.bh.fh != 1) {
                    this.k.z();
                    this.k.aa(this.a.bh.fh, this.a.bh.fh);
                }
                var c = this.a5;
                var d = this.a.bf.pl();
                if (!c.isEmpty && a) {
                    this.k.k(d.left, d.top, d.width, d.height);
                }
                if (this.a.bh != null && this.a.bh.fh != 1) {
                    this.k.y();
                }
            }
        };
        AxisView.prototype.postRender = function () {
            this.d.cf();
        };
        AxisView.prototype.am = function () {
            if (this.j.d) {
                this.a7._stroke = this.a.ja;
                this.ba._fill = this.a.jd;
                this.a9._stroke = this.a.i9;
                this.a8._stroke = this.a.i8;
                this.a9.ac = this.a.ei;
                this.a8.ac = this.a.ef;
                this.a7.ac = this.a.ez;
                this.a9.ai = this.a.jh;
                this.a8.ai = this.a.jg;
                this.a7.ai = this.a.ji;
                this.a5 = this.a.js;
                this.j.s(this.a7);
                this.j.s(this.ba);
                this.j.s(this.a8);
                this.j.s(this.a9);
            }
        };
        AxisView.prototype.ac = function () {
            this.ae();
        };
        AxisView.prototype.aa = function (a) {
            if (a != null) {
                a.al.r(this);
                a.cf.cn();
            }
        };
        AxisView.prototype.u = function (a) {
            if (a != null) {
                a.al.l(this);
                this.ae();
            }
        };
        AxisView.prototype.i = function () {
            if (this.a.bh == null || this.a.bh.cf.j.ae == null) {
                return null;
            }
            return i2.FontUtil.getFont(this.a.bh.cf.j.ae);
        };
        AxisView.prototype.l = function () {
            return this.j == null;
        };
        AxisView.prototype.ak = function () {
            if (this.a.b4 || this.a.cg) {
                return;
            }
            if (this.a.gp == null) {
                this.a.h6 = null;
                this.a.ck = true;
                this.a.hp();
                return;
            }
            if (this.a.h6 == null) {
                var a = new i2.TextBlock();
                a.ak = this.a.gp;
                a.dataContext = this.a.be;
                this.a.h6 = a;
            }
            else {
                this.a.h6.ak = this.a.gp;
                this.a.h6.dataContext = this.a.be;
            }
            this.a.ck = true;
            this.a.hp();
        };
        AxisView.prototype.t = function () {
            var a;
            var b = new AxisLabelSettings();
            if (this.a.b4) {
                a = "ui-angular-axis-labels";
                b.margin = 0;
            }
            else if (this.a.cj) {
                a = "ui-vertical-axis-labels";
                b.location = 2;
            }
            else if (this.a.a1 == 3) {
                a = "ui-radial-axis-labels";
                b.location = 5;
            }
            else {
                a = "ui-horizontal-axis-labels";
                b.location = 1;
            }
            this.s(b, a);
        };
        AxisView.prototype.aw = function () {
            if (this.a.bh == null) {
                return;
            }
            var a = this.a.bh.p9;
            var b = a.fq;
            var c = a.fp;
            if (this.a.je == null) {
                if (b == null) {
                    this.a.je = a.fn;
                }
                else if (b.color.l != 0) {
                    this.a.je = b;
                }
            }
            if (this.a.jb == null) {
                if (c == null) {
                    this.a.jb = a.fn;
                }
                else if (c.color.l != 0) {
                    this.a.jb = c;
                }
            }
        };
        AxisView.prototype.s = function (a, b) {
            this.a.e4.startCSSQuery();
            var c = this.a.e4.getCssDefaultPropertyValue(b, "margin-top");
            var d = this.a.e4.getCssDefaultPropertyValue(b, "margin-right");
            var e = this.a.e4.getCssDefaultPropertyValue(b, "margin-bottom");
            var f = this.a.e4.getCssDefaultPropertyValue(b, "margin-left");
            var g = this.a.e4.getCssDefaultPropertyValue(b, "text-align");
            var h = this.a.e4.getCssDefaultPropertyValue(b, "vertical-align");
            var i = this.a.e4.getCssDefaultPropertyValue(b, "color");
            this.a.e4.endCSSQuery();
            if (c != null) {
                a.topMargin = parseFloat(c);
            }
            if (d != null) {
                a.rightMargin = parseFloat(d);
            }
            if (e != null) {
                a.bottomMargin = parseFloat(e);
            }
            if (f != null) {
                a.leftMargin = parseFloat(f);
            }
            if (i != null) {
                if (a.textColor == null) {
                    a.textColor = new i2.Brush();
                }
                a.textColor._fill = i;
            }
            if (g != null) {
                switch (g) {
                    case "right":
                        a.horizontalAlignment = 2;
                        break;
                    case "left":
                        a.horizontalAlignment = 0;
                        break;
                    default:
                        a.horizontalAlignment = 1;
                        break;
                }
            }
            if (h != null) {
                switch (h) {
                    case "top":
                        a.verticalAlignment = 0;
                        break;
                    case "bottom":
                        a.verticalAlignment = 2;
                        break;
                    default:
                        a.verticalAlignment = 1;
                        break;
                }
            }
            this.a.ay = a;
        };
        AxisView.prototype.preRender = function () {
            if (this.a.bh != null) {
                this.a.bh.jf();
            }
        };
        AxisView.prototype.isValid = function () {
            return this.a != null && !this.a.js.isEmpty;
        };
        AxisView.prototype.a2 = function (a) {
            return { $type: i2.Point_$type, x: a.n, y: a.o };
        };
        AxisView.prototype.a3 = function () {
            return { $type: i2.Point_$type, x: this.a.av.cu.left, y: this.a.av.cu.top };
        };
        AxisView.prototype.a6 = function () {
            var a = this.a.av.cu;
            return a;
        };
        AxisView.prototype.a4 = function (a) {
            return { $type: i2.Point_$type, x: a.n, y: a.o };
        };
        AxisView.prototype.bd = function (a) {
            var b = this.a.av.ae.t();
            var c = this.a.av.ae.v();
            var d = this.a.av.ae.u();
            var e = this.a.av.ae.s();
            return new i2.Thickness(1, b, c, d, e);
        };
        AxisView.prototype.ah = function () {
            if (i2.FastReflectionHelper.needsHelper(this.a.fj)) {
                this.h = new i2.FastReflectionHelper(true, this.a.fj);
            }
            else {
                this.h = null;
            }
        };
        AxisView.$t = i2.markType(AxisView, 'AxisView', i2.Base.$, [i2.ISchedulableRender_$type]);
        return AxisView;
    }(i2.Base));
    /**
     * @hidden
     */
    var CategoryAxisBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryAxisBaseView, _super);
        function CategoryAxisBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.be = null;
            _this.be = a;
            return _this;
        }
        CategoryAxisBaseView.prototype.o = function (a) {
            var b = 0;
            if (this.be.categoryMode == 0) {
                b = i2.truncate(Math.round(a));
            }
            else {
                b = i2.truncate(Math.floor(a));
            }
            if (b < 0 || b > this.a.kr - 1) {
                return null;
            }
            var c = this.a.j6.item(b);
            var d = this.n(c);
            if (d == null) {
                return null;
            }
            return d.toString();
        };
        CategoryAxisBaseView.prototype.bf = function (a) {
            var b = 0;
            var c = false;
            for (var d = 0; d < a.count; d++) {
                var e = i2.typeCast(i2.FrameworkElement.$, a._inner[d]);
                if (e == null) {
                    e = this.a.bq.item(d);
                    var f = a._inner[d] == null ? "" : a._inner[d].toString();
                    var g = e.ak;
                    var h = 0;
                    var i = 0;
                    if (g != null) {
                        h = g.length;
                    }
                    if (f != null) {
                        i = f.length;
                    }
                    if (h != i) {
                        c = true;
                    }
                    e.ak = f;
                    b++;
                }
                else {
                    this.d.ab.add(e);
                }
            }
            if (c) {
                this.a.ck = true;
            }
            this.a.gx();
            return b;
        };
        CategoryAxisBaseView.$t = i2.markType(CategoryAxisBaseView, 'CategoryAxisBaseView', AxisView.$);
        return CategoryAxisBaseView;
    }(AxisView));
    /**
     * @hidden
     */
    var HorizontalAxisLabelPanelBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAxisLabelPanelBaseView, _super);
        function HorizontalAxisLabelPanelBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.ax = null;
            _this.ax = a;
            return _this;
        }
        HorizontalAxisLabelPanelBaseView.prototype.az = function () {
        };
        HorizontalAxisLabelPanelBaseView.prototype.ay = function () {
            return false;
        };
        HorizontalAxisLabelPanelBaseView.prototype.a0 = function (a) {
            var b = this.a.bn();
            var c, d;
            c = this.ax.c9();
            d = this.ax.c6();
            var e = this.a.af != null ? this.a.af.verticalAlignment : 1;
            var f = this.a.a9;
            var g = a.count;
            var h = this.a.cu;
            var i = this.ax.c8();
            var j = i / 2;
            for (var k = 0; k < g; k++) {
                var l = a._inner[k];
                var m = l.height / 2;
                switch (e) {
                    case 0:
                        l.y = h.top + c;
                        break;
                    case 1:
                    case 3:
                        l.y = (h.top + c + j) - m;
                        break;
                    case 2:
                        l.y = (h.bottom - d) - l.height;
                        break;
                }
            }
        };
        HorizontalAxisLabelPanelBaseView.$t = i2.markType(HorizontalAxisLabelPanelBaseView, 'HorizontalAxisLabelPanelBaseView', AxisLabelPanelBaseView.$);
        return HorizontalAxisLabelPanelBaseView;
    }(AxisLabelPanelBaseView));
    /**
     * @hidden
     */
    var NumericAxisBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericAxisBaseView, _super);
        function NumericAxisBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.be = null;
            _this.be = a;
            return _this;
        }
        NumericAxisBaseView.prototype.bf = function () {
        };
        NumericAxisBaseView.prototype.o = function (a) {
            var b = this.be.j6.d(this.be.js, this.be.bh.pg, this.be.jn(), this.be.jm());
            return this.be.j6.w(b, a, -1, NaN);
        };
        NumericAxisBaseView.$t = i2.markType(NumericAxisBaseView, 'NumericAxisBaseView', AxisView.$);
        return NumericAxisBaseView;
    }(AxisView));
    /**
     * @hidden
     */
    var VerticalAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalAxisLabelPanelView, _super);
        function VerticalAxisLabelPanelView(a) {
            var _this = _super.call(this, a) || this;
            _this.ax = null;
            _this.ax = a;
            return _this;
        }
        VerticalAxisLabelPanelView.prototype.ay = function () {
        };
        VerticalAxisLabelPanelView.prototype.d = function () {
            var a = this.a.ac.bh.getFontInfo();
            if (this.a.ac.be != null && this.a.ac.be.textStyle != null) {
                a = this.a.ac.be.g(this.a.ac.bh.cf.j.ae);
            }
            else {
                var b = this.a.ac.bh.ci();
                if (b != null) {
                    a = b;
                }
            }
            return a;
        };
        VerticalAxisLabelPanelView.prototype.aw = function () {
            return this.a.ac.bh.pz();
        };
        VerticalAxisLabelPanelView.prototype.as = function () {
            var a = this.a.ac.bf.getFontBrush();
            if (this.a.ac.be != null && this.a.ac.be.textColor != null) {
                a = this.a.ac.be.textColor;
            }
            else {
                var b = this.a.ac.bh.ow();
                if (b != null) {
                    a = b;
                }
            }
            return a;
        };
        VerticalAxisLabelPanelView.prototype.az = function (a, b) {
            var c, d;
            c = this.ax.c3();
            d = this.ax.c5();
            var e = this.a.af != null ? this.a.af.horizontalAlignment : 1;
            var f = this.a.a9;
            var g = this.ax.c6();
            var h = g / 2;
            var i = this.a.cu;
            for (var j = 0; j < a.count; j++) {
                var k = a._inner[j];
                var l = k.width / 2;
                switch (e) {
                    case 0:
                        k.x = i.left + c;
                        break;
                    case 1:
                    case 3:
                        k.x = (i.left + c + h) - l;
                        break;
                    case 2:
                        k.x = (i.right - d) - k.width;
                        break;
                }
            }
        };
        VerticalAxisLabelPanelView.$t = i2.markType(VerticalAxisLabelPanelView, 'VerticalAxisLabelPanelView', AxisLabelPanelBaseView.$);
        return VerticalAxisLabelPanelView;
    }(AxisLabelPanelBaseView));
    /**
     * @hidden
     */
    var XamDataChartView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamDataChartView, _super);
        function XamDataChartView(a) {
            var _this = _super.call(this, a) || this;
            _this.fi = null;
            _this.fr = null;
            _this.fn = null;
            _this.fo = null;
            _this.fq = null;
            _this.fp = null;
            _this.fk = 0;
            _this.fl = 0;
            _this.fj = null;
            _this.fi = a;
            return _this;
        }
        XamDataChartView.prototype.fm = function (a) {
            this.p.al.p();
        };
        XamDataChartView.prototype.dp = function () {
            _super.prototype.dp.call(this);
            if (this.b.count == 0 && this.y != null) {
                if (this.p.fh != 1) {
                    this.y.z();
                    this.y.aa(this.p.fh, this.p.fh);
                }
                this.y.k(0, 0, this.a8, this.a7);
                if (this.p.fh != 1) {
                    this.y.y();
                }
            }
        };
        XamDataChartView.prototype.d1 = function () {
            var e_89, _a;
            var a, b;
            var c = 1, d = 0;
            var e = false;
            var f = this.j.e();
            var g;
            var h = this.j.a6(c, g, a, b, d, e);
            c = h.p0;
            g = h.p1;
            a = h.p2;
            b = h.p3;
            d = h.p4;
            e = h.p5;
            if (i2.isNaN_(this.p.f2)) {
                this.p.f2 = g[0];
            }
            if (i2.isNaN_(this.p.ft)) {
                this.p.ft = g[1];
            }
            if (i2.isNaN_(this.p.fm)) {
                this.p.fm = g[2];
            }
            if (i2.isNaN_(this.p.fq)) {
                this.p.fq = g[3];
            }
            this.fi.s3 = f.i;
            this.fi.s1 = AxisDefaults.h;
            this.fi.s2 = AxisDefaults.i;
            this.fi.qe = e;
            this.fq = a;
            this.fp = b;
            this.fi.ag = f.a;
            this.fi.aj = f.f;
            this.fi.ah = f.b != null ? f.b : new i2.BrushCollection();
            this.fi.ai = f.c != null ? f.c : new i2.BrushCollection();
            if (this.fi.ah.count == 0) {
                for (var i = 0; i < f.a.count; i++) {
                    this.fi.ah.add(f.a.item(i));
                }
            }
            if (f.c.count == 0) {
                for (var j = 0; j < f.f.count; j++) {
                    this.fi.ai.add(f.f.item(j));
                }
            }
            this.fo = f.j;
            this.fr = f.k;
            this.fj = f.h;
            this.fn = f.i;
            this.fk = c;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.fi.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var k = _c.value;
                    k.ma();
                }
            }
            catch (e_89_1) {
                e_89 = { error: e_89_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_89)
                        throw e_89.error;
                }
            }
            this.fl = d;
        };
        XamDataChartView.prototype.dy = function () {
            this.fb.ac = Defaults.j;
            this.fa.ac = Defaults.j;
            this.fb._stroke = this.fo;
            this.fa._stroke = this.fo;
            _super.prototype.dy.call(this);
        };
        XamDataChartView.$t = i2.markType(XamDataChartView, 'XamDataChartView', SeriesViewerView.$);
        return XamDataChartView;
    }(SeriesViewerView));
    /**
     * @hidden
     */
    var SeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesView, _super);
        function SeriesView(a) {
            var _this = _super.call(this) || this;
            _this.e = null;
            _this.s = false;
            _this.h = null;
            _this.d = null;
            _this._isDirty = false;
            _this.bw = null;
            _this.bn = null;
            _this.v = 0;
            _this.br = i2.Rect.empty;
            _this.bm = new i2.Brush();
            _this.f = new SeriesComponentsFromView();
            _this.k = null;
            _this.l = null;
            _this.bs = null;
            _this.bt = null;
            _this.m = false;
            _this.a = null;
            _this.r = false;
            _this.n = false;
            _this.p = false;
            _this.ad = null;
            _this.v = NaN;
            _this.r = true;
            _this.e = a;
            _this.q = false;
            _this.bw = new i2.Rectangle();
            _this.s = false;
            return _this;
        }
        SeriesView.prototype.getDefaultTooltipTemplate = function () {
            return this.e.a4.a$q(this.e);
        };
        SeriesView.prototype.ap = function () {
            if (this.e.dt) {
                this.e.a4.a$u(this.e);
            }
        };
        SeriesView.prototype.j = function () {
            return new i2.DOMExecutionContext(this.e.ca.cf.j.ae);
        };
        Object.defineProperty(SeriesView.prototype, "i", {
            get: function () {
                if (this.h == null) {
                    this.h = this.j();
                }
                return this.h;
            },
            enumerable: false,
            configurable: true
        });
        SeriesView.prototype.as = function () {
            if (!this.q) {
                this.e.fq = 0.8;
                this.e.b3 = 0;
                this.e.b2 = 1;
                this.d = new i2.DataContext();
                this.d.series = this.e;
                this.e.cd = i2.EasingFunctions.cubicEase;
                this.af();
            }
        };
        SeriesView.prototype.getEffectiveViewport = function () {
            return this.e.getEffectiveViewport1(this);
        };
        SeriesView.prototype.az = function () {
            this.aq();
        };
        SeriesView.prototype.aj = function () {
        };
        Object.defineProperty(SeriesView.prototype, "w", {
            get: function () {
                if (this.e.ca != null) {
                    return this.e.ca.cf.j.ae;
                }
                return null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesView.prototype, "isDirty", {
            get: function () {
                return this._isDirty;
            },
            set: function (a) {
                this._isDirty = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesView.prototype.get_index = function () {
            if (this.e == null || this.e.ca == null) {
                return 0;
            }
            if (this.e.ca.dx) {
                if (this.e.dp) {
                    return this.e.ca.series.indexOf(this.e);
                }
                else {
                    var a = this.e.ca.series.indexOf(this.e);
                    if (a >= 0) {
                        return a;
                    }
                    for (var b = 0; b < this.e.ca.series.count; b++) {
                        if (this.e.ca.series._inner[b].dp) {
                            var c = this.e.ca.series._inner[b].bd();
                            if (c == this.e) {
                                return b;
                            }
                        }
                    }
                    return a;
                }
            }
            var d = i2.typeCast(XamDataChart.$, this.e.b8);
            var e = 0;
            if (d != null) {
                if (d.p6 == 2 || d.p6 == 0) {
                    e = d.axes.count;
                }
            }
            var f = 0;
            for (var g = 0; g < this.e.ca.series.count; g++) {
                if (this.e.ca.series._inner[g] == this.e) {
                    break;
                }
                if (this.e.ca.series._inner[g].isStacked) {
                    f += this.e.ca.series._inner[g].g8();
                }
                else {
                    f++;
                }
            }
            return e + f;
        };
        Object.defineProperty(SeriesView.prototype, "index", {
            get: function () {
                return this.get_index();
            },
            enumerable: false,
            configurable: true
        });
        SeriesView.prototype.aq = function () {
            if (this.e.ca == null) {
                return;
            }
            if (!this.isDirty) {
                this.isDirty = true;
                this.a.o(this.k, this.l);
            }
        };
        SeriesView.prototype.undirty = function (a) {
            this.isDirty = false;
            this.a4(a);
        };
        SeriesView.prototype.au = function () {
            this.aq();
        };
        SeriesView.prototype.bq = function () {
            if (this.bn == null) {
                this.bn = ((function () {
                    var $ret = new i2.Brush();
                    $ret.color = i2.Color.u(0, 0, 0, 0);
                    return $ret;
                })());
            }
            return this.bn;
        };
        SeriesView.prototype.u = function () {
            if (!i2.isNaN_(this.v)) {
                return this.v;
            }
            if (this.e.ca != null) {
                return this.e.ca.fh;
            }
            else {
                return 1;
            }
        };
        SeriesView.prototype.a4 = function (a) {
            if (this.k == null) {
                return;
            }
            if (this.br.isEmpty) {
                this.br = this.bu;
            }
            var b = this.br;
            var c = this.e.ca.pl();
            var d = c.left;
            var e = c.top;
            var f = c.width;
            var g = c.height;
            var h = this.u();
            if (this.p) {
                d = this.bu.left;
                e = this.bu.top;
                f = this.bu.width;
                g = this.bu.height;
            }
            if (this.k.d) {
                if (h != 1) {
                    this.k.z();
                    this.k.aa(h, h);
                }
                if (a) {
                    this.k.k(d, e, f, g);
                }
                if (a) {
                    if (this.e.ca.o1 != null && !this.bu.isEmpty) {
                        this.bw.o = this.bu.top;
                        this.bw.n = this.bu.left;
                        this.bw.width = this.bu.width;
                        this.bw.height = this.bu.height;
                        this.bw._fill = this.e.ca.o1;
                        this.k.v(this.bw);
                    }
                }
                if (h != 1) {
                    this.k.y();
                }
            }
            if (this.l != null && this.r) {
                if (this.l.d) {
                    if (this.e.ca != null && h != 1) {
                        this.l.z();
                        this.l.aa(h, h);
                    }
                    if (!b.isEmpty && a) {
                        this.l.k(b.left, b.top, b.width, b.height);
                    }
                    this.ba(true);
                    this.a6(this.l, true);
                    this.a5(this.l, true);
                    if (h != 1) {
                        this.l.y();
                    }
                }
            }
            if (this.k.d && this.r) {
                if (h != 1) {
                    this.k.z();
                    this.k.aa(h, h);
                }
                this.k.z();
                if (!this.q && i2.Rect.l_op_Inequality(this.e.o6, null) && !this.e.o6.isEmpty && (this.e.o6.width != 1 || this.e.o6.height != 1)) {
                    this.k.ae(new i2.Rect(0, this.bu.left + this.bu.width * this.e.o6.left, this.bu.top + this.bu.height * this.e.o6.top, this.bu.width * this.e.o6.width, this.bu.height * this.e.o6.height));
                }
                else {
                    this.k.ae(this.bu);
                }
                this.ba(false);
                this.k.ad(this.e._opacity);
                if (this.e.dg && this.e.dh && !this.q) {
                    if (this.e.e1) {
                        this.k.o(this.e.or.colorString, 0, this.e.gk, this.e.gl);
                        var i = this.e.ca.cf.j.x;
                        var j = this.e.ca.cf.j.ak;
                        if (h != 1) {
                            i.z();
                            i.aa(h, h);
                        }
                        i.k(c.left, c.top, c.width, c.height);
                        this.a6(i, false);
                        this.a5(i, false);
                        this.k.m(j.getNativeElement(), 1, 0, 0, c.width, c.height);
                        if (h != 1) {
                            i.y();
                        }
                    }
                    else {
                        this.k.o(this.e.or.colorString, this.e.gj, this.e.gk, this.e.gl);
                        this.a6(this.k, false);
                        this.a5(this.k, false);
                    }
                    this.k.l();
                }
                else {
                    this.a6(this.k, false);
                    this.a5(this.k, false);
                }
                this.k.ad(1);
                this.k.y();
                if (h != 1) {
                    this.k.y();
                }
            }
        };
        SeriesView.prototype.bd = function (a, b, c) {
            if (c) {
                this.bf(a, b);
            }
            else {
                this.be(a, b);
            }
        };
        SeriesView.prototype.bg = function (a, b, c) {
            if (c) {
                this.bi(a, b);
            }
            else {
                this.bh(a, b);
            }
        };
        SeriesView.prototype.aa = function (a, b) {
            if (b) {
                return this.ab(a);
            }
            else {
                return this.ac(a);
            }
        };
        SeriesView.prototype.ab = function (a) {
            return null;
        };
        SeriesView.prototype.ac = function (a) {
            return null;
        };
        SeriesView.prototype.be = function (a, b) {
        };
        SeriesView.prototype.bh = function (a, b) {
        };
        SeriesView.prototype.bf = function (a, b) {
        };
        SeriesView.prototype.bi = function (a, b) {
        };
        SeriesView.prototype.ba = function (a) {
            if (a) {
                this.bc();
            }
            else {
                this.bb();
            }
        };
        SeriesView.prototype.bb = function () {
        };
        SeriesView.prototype.bc = function () {
        };
        SeriesView.prototype.bp = function (a) {
            return this.bo();
        };
        SeriesView.prototype.bo = function () {
            var a = this.e.hc;
            var num_ = (a + 1) * 1000;
            var b = ((num_ & 0x3F) << 2);
            num_ = (num_ >> 6);
            var c = ((num_ & 0x3F) << 2);
            num_ = (num_ >> 6);
            var d = ((num_ & 0x3F) << 2);
            this.bm._fill = "rgb(" + b + "," + c + "," + d + ")";
            return this.bm;
        };
        SeriesView.prototype.a6 = function (a, b) {
            this.br = this.bu;
        };
        SeriesView.prototype.a5 = function (a, b) {
        };
        SeriesView.prototype.ax = function () {
        };
        SeriesView.prototype.am = function () {
        };
        SeriesView.prototype.an = function () {
        };
        SeriesView.prototype.g = function () {
            return this.f;
        };
        SeriesView.prototype.a9 = function (a) {
        };
        SeriesView.prototype.t = function () {
            return true;
        };
        SeriesView.prototype.aw = function () {
        };
        SeriesView.prototype.av = function () {
        };
        SeriesView.prototype.a7 = function () {
            this.e.of = null;
        };
        SeriesView.prototype.ah = function () {
            this.e.of = this.e.oj;
        };
        SeriesView.prototype.a8 = function () {
            this.e.oi = null;
        };
        SeriesView.prototype.ai = function () {
            this.e.oi = this.e.oo;
        };
        SeriesView.prototype.c = function (a) {
            if (i2.typeCast(i2.DataContext.$, a) !== null) {
                return a;
            }
            return null;
        };
        SeriesView.prototype.ar = function (a, b) {
            this.k = a;
            this.l = b;
        };
        Object.defineProperty(SeriesView.prototype, "bu", {
            get: function () {
                return this.bs;
            },
            set: function (a) {
                this.bs = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesView.prototype.get_bv = function () {
            if (this.p) {
                return this.bt;
            }
            else if (this.q) {
                return XamDataChart.ps;
            }
            else {
                return this.e.ca != null ? this.e.ca.pg : i2.Rect.empty;
            }
        };
        Object.defineProperty(SeriesView.prototype, "bv", {
            get: function () {
                return this.get_bv();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesView.prototype, "q", {
            get: function () {
                return this.m;
            },
            set: function (a) {
                this.m = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesView.prototype.ak = function (a) {
            if (a != null) {
                this.a.r(this);
                if (this.e.bw != null) {
                    this.e.bw.a.r(this.e.bw);
                }
            }
        };
        SeriesView.prototype.ag = function (a) {
            var e_90, _a;
            if (a != null) {
                if (this.e.ez) {
                    this.k = this.e.ca.cf.z;
                    a.cf.a.l(this);
                    this.a = a.cf.a;
                }
                else {
                    this.k = this.e.ca.cf.y;
                    a.al.l(this);
                    this.a = a.al;
                }
                if (this.e.bw != null) {
                    a.am.l(this.e.bw);
                    this.e.bw.a = a.am;
                    this.e.bw.aq();
                }
                if (this.e.dt) {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.e.a4.a$h.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var b = _c.value;
                            a.ak.l(this.e.a4.a$h.item(b));
                            this.e.a4.a$h.item(b).a = a.ak;
                            this.e.a4.a$h.item(b).aq();
                        }
                    }
                    catch (e_90_1) {
                        e_90 = { error: e_90_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_90)
                                throw e_90.error;
                        }
                    }
                }
                this.aq();
            }
        };
        SeriesView.prototype.postRender = function () {
            this.a0();
        };
        SeriesView.prototype.a0 = function () {
        };
        SeriesView.prototype.b = function (a) {
            return null;
        };
        SeriesView.prototype.a2 = function (a) {
            this.e.bw.k = a.a;
        };
        SeriesView.prototype.al = function (a) {
        };
        SeriesView.prototype.bj = function () {
            if (this.n) {
                return;
            }
            if (this.e.ca != null) {
                var a = (this.e.legend != null) ? this.e.legend : this.e.ca.legend;
                if (a != null && this.e.mq != null && a.containsChild(this.e.mq)) {
                    a.removeChild(this.e.mq);
                    var b = this.e.ho();
                    b.content.actualItemBrush = this.e.of;
                    b.content.outline = this.e.oi;
                    b.content.thickness = this.e.fl;
                    a.addChildInOrder(this.e.mq, this.e);
                }
            }
        };
        SeriesView.prototype.at = function () {
            this.e.ka(this.e.a0, this.e.a0);
        };
        SeriesView.prototype.ay = function () {
            this.bj();
        };
        SeriesView.prototype.getViewInfo = function (a, b) {
            a = this.bu;
            b = this.bv;
            return {
                p0: a,
                p1: b
            };
        };
        SeriesView.prototype.o = function () {
            return this.k != null;
        };
        SeriesView.prototype.bk = function () {
            this.r = this.e._visibility == 0;
            this.aq();
        };
        SeriesView.prototype.a3 = function () {
            this.e.a4.a$ag(this.e);
        };
        SeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 5;
            this.e.gl = 5;
        };
        SeriesView.prototype.ao = function () {
        };
        SeriesView.prototype.preRender = function () {
            if (this.e.ca != null && !this.q) {
                this.e.ca.jf();
            }
        };
        SeriesView.prototype.isValid = function () {
            return true;
        };
        SeriesView.prototype.a1 = function (a) {
            this.k = a.a;
        };
        SeriesView.prototype.bl = function (type_) {
            var legendTemplates_ = i2.TypeRegistrar.get("LegendTemplates");
            var a = (legendTemplates_.resolveLegendItemTemplate(type_));
            return a;
        };
        SeriesView.$t = i2.markType(SeriesView, 'SeriesView', i2.Base.$, [i2.ISchedulableRender_$type, IProvidesViewport_$type]);
        return SeriesView;
    }(i2.Base));
    /**
     * @hidden
     */
    var MarkerSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerSeriesView, _super);
        function MarkerSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.b1 = null;
            _this.b5 = 1;
            _this.b7 = Defaults.ab;
            _this.b6 = 3;
            _this.b4 = null;
            _this.b3 = false;
            _this.bx = new Marker();
            _this.co = null;
            _this.bx = new Marker();
            _this.bx.content = new i2.DataContext();
            _this.b1 = a;
            return _this;
        }
        MarkerSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.b4 = new i2.List$1(Marker.$, 0);
            this.co = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = MarkerTemplates.c;
                $ret.measure = MarkerTemplates.b;
                return $ret;
            })());
        };
        MarkerSeriesView.prototype.cg = function () {
            var e_91, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.b4)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.ah = this.b1.qc;
                }
            }
            catch (e_91_1) {
                e_91 = { error: e_91_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_91)
                        throw e_91.error;
                }
            }
            this.aq();
        };
        MarkerSeriesView.prototype.cq = function () {
            if (this.k == null) {
                return new i2.Size(1, 0, 0);
            }
            var a = new i2.DataTemplatePassInfo();
            a.isHitTestRender = false;
            a.context = this.k.g();
            a.viewportTop = this.bu.top;
            a.viewportLeft = this.bu.left;
            a.viewportWidth = this.bu.width;
            a.viewportHeight = this.bu.height;
            a.passID = "TestMeasure";
            var b = new i2.DataTemplateRenderInfo();
            b.isHitTestRender = false;
            b.passInfo = a;
            var c = new i2.DataTemplateMeasureInfo();
            c.passInfo = a;
            var d = this.k.g();
            c.context = d;
            b.context = d;
            var e = 0;
            var f = 0;
            if (this.b1.qc != null && this.b1.qc.passStarting != null) {
                this.b1.qc.passStarting(a);
            }
            var g = this.b1.qc;
            if (this.b4.count > 0) {
                var h = this.b4._inner[0];
                c.data = h.content;
                c.width = h.width;
                c.height = h.height;
                c.renderOffsetX = 0;
                c.renderOffsetY = 0;
                c.renderContext = this.k;
                g = h.ah;
            }
            var i = 0;
            var j = 0;
            if (g != null && g.measure != null) {
                g.measure(c);
                i = c.width;
                j = c.height;
            }
            if (this.b1.qc != null && this.b1.qc.passCompleted != null) {
                this.b1.qc.passCompleted(a);
            }
            return new i2.Size(1, i, j);
        };
        MarkerSeriesView.prototype.cn = function (a) {
        };
        MarkerSeriesView.prototype.b0 = function () {
            var _this = this;
            var a = new Marker();
            a.content = ((function () {
                var $ret = new i2.DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
            a.ah = this.b1.qc;
            this.b4.add(a);
            return a;
        };
        MarkerSeriesView.prototype.cj = function (a) {
            a._visibility = 0;
        };
        MarkerSeriesView.prototype.cl = function (a) {
            a._visibility = 1;
        };
        MarkerSeriesView.prototype.ck = function (a) {
            this.b4.remove(a);
        };
        MarkerSeriesView.prototype.b2 = function () {
            return this.b1.qd != null;
        };
        MarkerSeriesView.prototype.ce = function () {
            this.b1.qb = null;
        };
        MarkerSeriesView.prototype.b8 = function () {
            this.b1.qb = this.b1.qd;
        };
        MarkerSeriesView.prototype.cp = function (a) {
            var b = a.n;
            var c = a.o;
            var d = a.m;
            var e = a.l;
            return new i2.Rect(0, b - d / 2, c - d / 2, d, e);
        };
        MarkerSeriesView.prototype.cb = function (a) {
            switch (a) {
                case SeriesViewer.$$p[2]:
                    this.b1.qb = this.b1.ca.mu;
                    break;
                case SeriesViewer.$$p[34]:
                    this.b1.qb = this.b1.ca.m3;
                    break;
                case SeriesViewer.$$p[26]:
                    this.b1.qb = this.b1.ca.m0;
                    break;
                case SeriesViewer.$$p[28]:
                    this.b1.qb = this.b1.ca.m1;
                    break;
                case SeriesViewer.$$p[5]:
                    this.b1.qb = this.b1.ca.mv;
                    break;
                case SeriesViewer.$$p[18]:
                    this.b1.qb = this.b1.ca.my;
                    break;
                case SeriesViewer.$$p[7]:
                    this.b1.qb = this.b1.ca.mw;
                    break;
                case SeriesViewer.$$p[31]:
                    this.b1.qb = this.b1.ca.m2;
                    break;
                case SeriesViewer.$$p[19]:
                    this.b1.qb = this.b1.ca.mz;
                    break;
                case SeriesViewer.$$p[8]:
                    this.b1.qb = this.b1.ca.mx;
                    break;
            }
        };
        MarkerSeriesView.prototype.cc = function () {
            this.b1.qr = null;
        };
        MarkerSeriesView.prototype.b9 = function () {
            if (!i2.isNaN_(this.e.fk) && this.e.fk != 1) {
                var a = i2.BrushUtil.o(this.b1.qt, this.e.fk);
                this.b1.qr = a;
            }
            else {
                this.b1.qr = this.b1.qt;
            }
        };
        MarkerSeriesView.prototype.cd = function () {
            this.b1.qs = null;
        };
        MarkerSeriesView.prototype.ca = function () {
            this.b1.qs = this.b1.qu;
        };
        MarkerSeriesView.prototype.cm = function () {
            this.aq();
        };
        MarkerSeriesView.prototype.bh = function (a, b) {
            _super.prototype.bh.call(this, a, b);
            if (!this.b3) {
                var c = a;
                var d = c.content;
                if (d != null) {
                    d.actualItemBrush = this.b1.qr;
                    if (d.itemBrush != null) {
                        d.actualItemBrush = d.itemBrush;
                    }
                    d.outline = this.b1.qs;
                    d.thickness = this.b1.pw;
                }
            }
        };
        MarkerSeriesView.prototype.bi = function (a, b) {
            _super.prototype.bi.call(this, a, b);
            var c = a;
            this.bx._visibility = c._visibility;
            this.bx.ah = c.ah;
            this.bx.width = c.width;
            this.bx.height = c.height;
            this.bx.m = c.m;
            this.bx.l = c.l;
            this.bx.n = c.n;
            this.bx.o = c.o;
            var d = this.bp(b);
            var e = this.bx.content;
            var f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.b5 + this.b6;
            }
        };
        MarkerSeriesView.prototype.b = function (a) {
            if (a >= 0 && a < this.b4.count) {
                return this.b4._inner[a].content;
            }
            return _super.prototype.b.call(this, a);
        };
        MarkerSeriesView.prototype.a5 = function (a, b) {
            _super.prototype.a5.call(this, a, b);
            if (a.d) {
                var c = new i2.DataTemplatePassInfo();
                c.isHitTestRender = b;
                c.context = a.g();
                c.viewportTop = this.bu.top;
                c.viewportLeft = this.bu.left;
                c.viewportWidth = this.bu.width;
                c.viewportHeight = this.bu.height;
                c.passID = "Markers";
                var d = new i2.DataTemplateRenderInfo();
                d.isHitTestRender = b;
                d.passInfo = c;
                var e = new i2.DataTemplateMeasureInfo();
                e.passInfo = c;
                var f = false;
                var g = a.g();
                e.context = g;
                d.context = g;
                var h = 0;
                var i = 0;
                if (this.b1.qc != null && this.b1.qc.passStarting != null) {
                    this.b1.qc.passStarting(c);
                }
                for (var j = 0; j < this.b4.count; j++) {
                    var k = this.b4._inner[j];
                    if (k._visibility == 1) {
                        continue;
                    }
                    this.bg(k, j, b);
                    if (b) {
                        k = this.bx;
                    }
                    if (!f) {
                        e.data = k.content;
                        e.width = k.width;
                        e.height = k.height;
                        e.renderOffsetX = 0;
                        e.renderOffsetY = 0;
                        e.renderContext = a;
                        var l = k.ah;
                        if (l.measure != null) {
                            e.data = k.content;
                            l.measure(e);
                            f = e.isConstant;
                            if (f) {
                                h = e.width;
                                i = e.height;
                            }
                        }
                        d.availableWidth = e.width;
                        d.availableHeight = e.height;
                        d.renderOffsetX = e.renderOffsetX;
                        d.renderOffsetY = e.renderOffsetY;
                        d.renderContext = a;
                    }
                    else {
                        d.availableWidth = h;
                        d.availableHeight = i;
                    }
                    if (!i2.isNaN_(k.width) && !i2.isInfinity(k.width)) {
                        d.availableWidth = k.width;
                    }
                    if (!i2.isNaN_(k.height) && !i2.isInfinity(k.height)) {
                        d.availableHeight = k.height;
                    }
                    a.p(d, k);
                    k.m = d.availableWidth;
                    k.l = d.availableHeight;
                    k.ai = d.renderOffsetX;
                    k.aj = d.renderOffsetY;
                }
                if (this.b1.qc != null && this.b1.qc.passCompleted != null) {
                    this.b1.qc.passCompleted(c);
                }
            }
        };
        MarkerSeriesView.prototype.ch = function (a) {
            a.create = i2.runOn(this, this.b0);
            a.destroy = i2.runOn(this, this.ck);
            a.activate = i2.runOn(this, this.cj);
            a.disactivate = i2.runOn(this, this.cl);
        };
        MarkerSeriesView.prototype.ci = function (a) {
            a.create = i2.runOn(this, this.b0);
            a.destroy = i2.runOn(this, this.ck);
            a.activate = i2.runOn(this, this.cj);
            a.disactivate = i2.runOn(this, this.cl);
        };
        MarkerSeriesView.prototype.by = function (a) {
            var b = this.bz(a, 0);
            if (b == null) {
                b = this.bz(a, 3);
            }
            return b;
        };
        MarkerSeriesView.prototype.bz = function (a, b) {
            var c;
            var d;
            var e;
            var f;
            for (var g = this.b4.count - 1; g >= 0; g--) {
                var h = this.b4._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        };
        MarkerSeriesView.$t = i2.markType(MarkerSeriesView, 'MarkerSeriesView', SeriesView.$);
        return MarkerSeriesView;
    }(SeriesView));
    /**
     * @hidden
     */
    var ChartAxisRangeChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartAxisRangeChangedEventArgs, _super);
        function ChartAxisRangeChangedEventArgs(a, b, c, d, e, f) {
            var _this = _super.call(this) || this;
            _this._chart = null;
            _this._axis = null;
            _this._oldMinimumValue = 0;
            _this._minimumValue = 0;
            _this._oldMaximumValue = 0;
            _this._maximumValue = 0;
            _this.chart = a;
            _this.axis = b;
            _this.oldMinimumValue = c;
            _this.minimumValue = d;
            _this.oldMaximumValue = e;
            _this.maximumValue = f;
            return _this;
        }
        Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "chart", {
            get: function () {
                return this._chart;
            },
            set: function (a) {
                this._chart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "axis", {
            get: function () {
                return this._axis;
            },
            set: function (a) {
                this._axis = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "oldMinimumValue", {
            get: function () {
                return this._oldMinimumValue;
            },
            set: function (a) {
                this._oldMinimumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "minimumValue", {
            get: function () {
                return this._minimumValue;
            },
            set: function (a) {
                this._minimumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "oldMaximumValue", {
            get: function () {
                return this._oldMaximumValue;
            },
            set: function (a) {
                this._oldMaximumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "maximumValue", {
            get: function () {
                return this._maximumValue;
            },
            set: function (a) {
                this._maximumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartAxisRangeChangedEventArgs.$t = i2.markType(ChartAxisRangeChangedEventArgs, 'ChartAxisRangeChangedEventArgs', i2.EventArgs.$);
        return ChartAxisRangeChangedEventArgs;
    }(i2.EventArgs));
    (function (v) { i2.callStaticConstructors(); })(true);

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnnotationLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnnotationLayer, _super);
        function AnnotationLayer() {
            var _this = _super.call(this) || this;
            _this.ql = null;
            _this.pk = null;
            _this.pj = null;
            _this.pl = null;
            _this.qj = { $type: i2.Point_$type, x: NaN, y: NaN };
            _this.pm = false;
            _this.ql = { $type: i2.Point_$type, x: NaN, y: NaN };
            return _this;
        }
        AnnotationLayer.prototype.bu = function () {
            return new AnnotationLayerView(this);
        };
        AnnotationLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.pi = a;
        };
        AnnotationLayer.prototype.pq = function (a) {
            if (a == null) {
                return false;
            }
            if (a.c6) {
                return false;
            }
            if (a.ed) {
                return false;
            }
            if (a == this) {
                return false;
            }
            return a.e3(a.bx.bu, a.bx.bv, a.bx);
        };
        AnnotationLayer.prototype.get_dd = function () {
            return this.pn;
        };
        AnnotationLayer.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        AnnotationLayer.prototype.get_ds = function () {
            return this.ps || this.pt;
        };
        AnnotationLayer.prototype.get_isUsableInLegend = function () {
            return this.pt;
        };
        AnnotationLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    var e = c;
                    var f = d;
                    if (e != null) {
                        this.qc(e.series);
                        var g = e.series;
                        g.collectionChanged = i2.delegateRemove(g.collectionChanged, i2.runOn(this, this.p9));
                        if (i2.typeCast(XamDataChart.$, e) !== null) {
                            var h = e;
                            this.qb(h.axes);
                            var i = h.axes;
                            i.collectionChanged = i2.delegateRemove(i.collectionChanged, i2.runOn(this, this.pz));
                        }
                    }
                    if (f != null) {
                        this.p7(f.series);
                        var j = f.series;
                        j.collectionChanged = i2.delegateCombine(j.collectionChanged, i2.runOn(this, this.p9));
                        if (i2.typeCast(XamDataChart.$, f) !== null) {
                            var k = f;
                            this.p6(k.axes);
                            var l = k.axes;
                            l.collectionChanged = i2.delegateCombine(l.collectionChanged, i2.runOn(this, this.pz));
                        }
                    }
                    break;
                case AnnotationLayer.$$p[3]:
                case AnnotationLayer.$$p[2]:
                    if (this.ds) {
                        if (this.g9 == -1) {
                            this.g9 = XamDataChart.rl(this);
                        }
                    }
                    else {
                        this.g9 = -1;
                        this.of = null;
                        this.oi = null;
                    }
                    if (this.ca != null) {
                        this.ca.kl();
                    }
                    this.l0(true);
                    break;
                case "TransitionProgress":
                    this.pl.c(this.gn, this.pk, this.pj);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.p8(this.pj, this.bx);
                    }
                    else {
                        this.p8(this.pl, this.bx);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case AnnotationLayer.$$p[1]:
                    if (this.ca != null) {
                        this.ca.kj();
                    }
                    break;
                case AnnotationLayer.$$p[0]:
                    this.ql = this.qk;
                    this.lb(this.qk);
                    break;
                case "ShouldRenderAsOverlay":
                    if (this.ca != null) {
                        this.bx.ak(this.ca);
                        this.bx.ag(this.ca);
                    }
                    break;
            }
        };
        AnnotationLayer.prototype.qc = function (a) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (!(b == this)) {
                        b.renderRequested = i2.delegateRemove(b.renderRequested, i2.runOn(this, this.qa));
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.qb = function (a) {
            var e_2, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.renderRequested = i2.delegateRemove(b.renderRequested, i2.runOn(this, this.p0));
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.p7 = function (a) {
            var e_3, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (!(b == this)) {
                        b.renderRequested = i2.delegateCombine(b.renderRequested, i2.runOn(this, this.qa));
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.p6 = function (a) {
            var e_4, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.renderRequested = i2.delegateCombine(b.renderRequested, i2.runOn(this, this.p0));
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.po = function (a) {
            if (a == null) {
                return false;
            }
            return true;
        };
        AnnotationLayer.prototype.p0 = function (a, b) {
            if (this.po(a)) {
                this.p2(a, b.animate);
            }
        };
        AnnotationLayer.prototype.pp = function (a) {
            if (a == null) {
                return false;
            }
            if (a.c6) {
                return false;
            }
            return true;
        };
        AnnotationLayer.prototype.qa = function (a, b) {
            if (this.pp(a)) {
                this.p3(a, b.animate);
            }
        };
        AnnotationLayer.prototype.p2 = function (a, b) {
        };
        AnnotationLayer.prototype.p3 = function (a, b) {
        };
        AnnotationLayer.prototype.p9 = function (a, b) {
            this.p4(b);
        };
        AnnotationLayer.prototype.pz = function (a, b) {
            this.p1(b);
        };
        AnnotationLayer.prototype.qh = function () {
            if (this.of != null) {
                return this.of;
            }
            return this.oj;
        };
        AnnotationLayer.prototype.qi = function () {
            if (this.oi != null) {
                return this.oi;
            }
            return this.oo;
        };
        AnnotationLayer.prototype.p1 = function (a) {
            var e_5, _a, e_6, _b;
            if (a.oldItems != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.renderRequested = i2.delegateRemove(b.renderRequested, i2.runOn(this, this.p0));
                    }
                }
                catch (e_5_1) {
                    e_5 = { error: e_5_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_5)
                            throw e_5.error;
                    }
                }
            }
            if (a.newItems != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.renderRequested = i2.delegateCombine(c.renderRequested, i2.runOn(this, this.p0));
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.p4 = function (a) {
            var e_7, _a, e_8, _b;
            if (a.oldItems != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.renderRequested = i2.delegateRemove(b.renderRequested, i2.runOn(this, this.qa));
                    }
                }
                catch (e_7_1) {
                    e_7 = { error: e_7_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_7)
                            throw e_7.error;
                    }
                }
            }
            if (a.newItems != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.renderRequested = i2.delegateCombine(c.renderRequested, i2.runOn(this, this.qa));
                    }
                }
                catch (e_8_1) {
                    e_8 = { error: e_8_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_8)
                            throw e_8.error;
                    }
                }
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.mn = function (a, b) {
            this.l0(false);
        };
        AnnotationLayer.prototype.mm = function (a, b) {
            this.l0(true);
        };
        AnnotationLayer.prototype.l1 = function (a) {
            _super.prototype.l1.call(this, a);
            if (this.ct(this.bx)) {
                return;
            }
            if (this.ei(a) && !this.em) {
                var b = this.pk;
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.pk = this.pl;
                    this.pl = b;
                }
                else {
                    this.pk = this.pj;
                    this.pj = b;
                }
                this.p5(this.pj, this.bx);
                this.l8();
            }
            else {
                if (!this.em) {
                    this.p5(this.pj, this.bx);
                }
                this.p8(this.pj, this.bx);
            }
        };
        AnnotationLayer.prototype.get_c6 = function () {
            return true;
        };
        AnnotationLayer.prototype.p5 = function (a, b) {
        };
        AnnotationLayer.prototype.p8 = function (a, b) {
            this.pi.b1();
        };
        AnnotationLayer.prototype.py = function (a) {
            var b = { $type: i2.Point_$type, x: this.qj.x, y: this.qj.y };
            if (a.isVertical) {
                if (i2.isNaN_(this.qj.y)) {
                    return new i2.Tuple$2(i2.Boolean_$type, i2.Point_$type, false, b);
                }
                if (i2.isNaN_(this.qj.x)) {
                    b.x = 0;
                    return new i2.Tuple$2(i2.Boolean_$type, i2.Point_$type, true, b);
                }
            }
            else {
                if (i2.isNaN_(this.qj.x)) {
                    return new i2.Tuple$2(i2.Boolean_$type, i2.Point_$type, false, b);
                }
                if (i2.isNaN_(this.qj.y)) {
                    b.y = 0;
                    return new i2.Tuple$2(i2.Boolean_$type, i2.Point_$type, true, b);
                }
            }
            return new i2.Tuple$2(i2.Boolean_$type, i2.Point_$type, true, b);
        };
        AnnotationLayer.prototype.lb = function (a) {
            _super.prototype.lb.call(this, a);
            if (i2.isNaN_(this.ql.x) && i2.isNaN_(this.ql.y)) {
                if (i2.isNaN_(a.x) && i2.isNaN_(a.y)) {
                    this.pi.b0();
                    return;
                }
                else {
                    this.pi.b2();
                    this.qj = a;
                }
            }
            else {
                this.pi.b2();
                this.qj = this.ql;
            }
            this.l0(true);
        };
        AnnotationLayer.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (!this.bx.t()) {
                d = false;
                return d;
            }
            return d;
        };
        AnnotationLayer.prototype.get_ez = function () {
            return this.pr;
        };
        Object.defineProperty(AnnotationLayer.prototype, "pr", {
            get: function () {
                return this.pm;
            },
            set: function (a) {
                var b = this.pm;
                this.pm = a;
                this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.pm);
            },
            enumerable: false,
            configurable: true
        });
        AnnotationLayer.$t = i2.markType(AnnotationLayer, 'AnnotationLayer', Series.$);
        AnnotationLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:qk:qd', [i2.Point_$type, { $type: i2.Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:pn:qe', [0, true], 'UseIndex:ps:qf', [0, false], 'UseLegend:pt:qg', [0, false]]);
        return AnnotationLayer;
    }(Series));
    /**
     * @hidden
     */
    var AnnotationLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnnotationLayerView, _super);
        function AnnotationLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.bx = null;
            _this.by = false;
            _this.bz = -1;
            _this.bx = a;
            return _this;
        }
        AnnotationLayerView.prototype.b3 = function () {
            if (this.by) {
                this.by = false;
                this.bz = -1;
                this.bx.qj = { $type: i2.Point_$type, x: NaN, y: NaN };
                this.bx.l0(true);
            }
        };
        AnnotationLayerView.prototype.b0 = function () {
            this.by = true;
            if (this.e.gw != null) {
                this.e.gw.setTimeout(i2.runOn(this, this.b3), 300);
            }
            else {
                this.bz = window.setTimeout(i2.runOn(this, this.b3), 300);
            }
        };
        AnnotationLayerView.prototype.b2 = function () {
            if (this.by == true) {
                this.by = false;
                if (this.bz != -1) {
                    window.clearTimeout(this.bz);
                    this.bz = -1;
                }
            }
        };
        AnnotationLayerView.prototype.b1 = function () {
            this.aq();
        };
        AnnotationLayerView.$t = i2.markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
        return AnnotationLayerView;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available collision modes of callout layers.
     */
    var CalloutCollisionMode = /*@__PURE__*/ (function (CalloutCollisionMode) {
        /**
         * Automatically decide the collision strategy.
         */
        CalloutCollisionMode[CalloutCollisionMode["Auto"] = 0] = "Auto";
        /**
         * Use a simulated annealing based collision strategy. This is higher quality, but takes longer, and is performed time-sliced in the background until an acceptable quality is reached.
         */
        CalloutCollisionMode[CalloutCollisionMode["SimulatedAnnealing"] = 1] = "SimulatedAnnealing";
        /**
         * Use a greedy algorithm to avoid collisions. This is cheap and predictable, but of comparatively low quality.
         */
        CalloutCollisionMode[CalloutCollisionMode["Greedy"] = 2] = "Greedy";
        /**
         * Use a greedy algorithm with localized center of mass hints to avoid collisions. This is relatively cheap to perform, compared to the simulated annealing approach, but is of comparatively lower quality.
         */
        CalloutCollisionMode[CalloutCollisionMode["GreedyCenterOfMass"] = 3] = "GreedyCenterOfMass";
        return CalloutCollisionMode;
    })({});
    /**
     * @hidden
     */
    var CalloutCollisionMode_$type = i2.markEnum('CalloutCollisionMode', 'Auto,0|SimulatedAnnealing,1|Greedy,2|GreedyCenterOfMass,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Frame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Frame, _super);
        function Frame() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Frame.a = function (a, b, c, d) {
            var e = c.count;
            var f = d.count;
            var g = Math.max(e, f);
            var h = 1 - b;
            if (a.count < g) {
                a.s(a.count, new Array(g - a.count));
            }
            if (a.count > g) {
                a.v(g, a.count - g);
            }
            for (var i = 0; i < Math.min(e, f); ++i) {
                a._inner[i] = { $type: i2.Point_$type, x: c._inner[i].x * h + d._inner[i].x * b, y: c._inner[i].y * h + d._inner[i].y * b };
            }
            if (e < f) {
                var j = e > 0 ? c._inner[e - 1] : { $type: i2.Point_$type, x: 0, y: 0 };
                for (var k = e; k < f; ++k) {
                    a._inner[k] = { $type: i2.Point_$type, x: j.x * h + d._inner[k].x * b, y: j.y * h + d._inner[k].y * b };
                }
            }
            if (e > f) {
                var l = f > 0 ? d._inner[f - 1] : { $type: i2.Point_$type, x: 0, y: 0 };
                for (var m = f; m < e; ++m) {
                    a._inner[m] = { $type: i2.Point_$type, x: c._inner[m].x * h + l.x * b, y: c._inner[m].y * h + l.y * b };
                }
            }
        };
        Frame.d = function (a, b, c, d, e) {
            var f = c.count;
            var g = d.count;
            var h = Math.max(f, g);
            var i = 1 - b;
            if (a.count < h) {
                a.s(a.count, new Array(h - a.count));
            }
            if (a.count > h) {
                a.v(h, a.count - h);
            }
            var j;
            var k;
            for (var l = 0; l < Math.min(f, g); ++l) {
                j = b * e._inner[l];
                j = j > 1 ? 1 : j;
                k = 1 - j;
                a._inner[l] = { $type: i2.Point_$type, x: c._inner[l].x * k + d._inner[l].x * j, y: c._inner[l].y * k + d._inner[l].y * j };
            }
            if (f < g) {
                var m = f > 0 ? c._inner[f - 1] : { $type: i2.Point_$type, x: 0, y: 0 };
                for (var n = f; n < g; ++n) {
                    j = b * e._inner[n];
                    j = j > 1 ? 1 : j;
                    k = 1 - j;
                    a._inner[n] = { $type: i2.Point_$type, x: m.x * k + d._inner[n].x * j, y: m.y * k + d._inner[n].y * j };
                }
            }
            if (f > g) {
                var o = g > 0 ? d._inner[g - 1] : { $type: i2.Point_$type, x: 0, y: 0 };
                for (var p = g; p < f; ++p) {
                    j = b * e._inner[p];
                    j = j > 1 ? 1 : j;
                    k = 1 - j;
                    a._inner[p] = { $type: i2.Point_$type, x: c._inner[p].x * k + o.x * j, y: c._inner[p].y * k + o.y * j };
                }
            }
        };
        Frame.b = function (a, b, c, d) {
            var e = c.count;
            var f = d.count;
            var g = Math.max(e, f);
            var h = 1 - b;
            if (a.count < g) {
                var i = new Array(g - a.count);
                for (var j = 0; j < g - a.count; j++) {
                    i[j] = 0;
                }
                a.s(a.count, i);
            }
            if (a.count > g) {
                a.v(g, a.count - g);
            }
            for (var k = 0; k < Math.min(e, f); ++k) {
                a._inner[k] = c._inner[k] * h + d._inner[k] * b;
            }
            if (e < f) {
                var l = e > 0 ? c._inner[e - 1] : 0;
                for (var m = e; m < f; ++m) {
                    a._inner[m] = l * h + d._inner[m] * b;
                }
            }
            if (e > f) {
                var n = f > 0 ? d._inner[f - 1] : 0;
                for (var o = f; o < e; ++o) {
                    a._inner[o] = c._inner[o] * h + n * b;
                }
            }
        };
        Frame.e = function (a, b, c, d, e) {
            var f = c.count;
            var g = d.count;
            var h = Math.max(f, g);
            var i = 1 - b;
            if (a.count < h) {
                var j = new Array(h - a.count);
                for (var k = 0; k < h - a.count; k++) {
                    j[k] = 0;
                }
                a.s(a.count, j);
            }
            if (a.count > h) {
                a.v(h, a.count - h);
            }
            var l;
            var m;
            for (var n = 0; n < Math.min(f, g); ++n) {
                l = b * e._inner[n];
                l = l > 1 ? 1 : l;
                m = 1 - l;
                a._inner[n] = c._inner[n] * m + d._inner[n] * l;
            }
            if (f < g) {
                var o = f > 0 ? c._inner[f - 1] : 0;
                for (var p = f; p < g; ++p) {
                    l = b * e._inner[p];
                    l = l > 1 ? 1 : l;
                    m = 1 - l;
                    a._inner[p] = o * m + d._inner[p] * l;
                }
            }
            if (f > g) {
                var q = g > 0 ? d._inner[g - 1] : 0;
                for (var r = g; r < f; ++r) {
                    l = b * e._inner[r];
                    l = l > 1 ? 1 : l;
                    m = 1 - l;
                    a._inner[r] = c._inner[r] * m + q * l;
                }
            }
        };
        Frame.$t = i2.markType(Frame, 'Frame');
        return Frame;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FrameExtended = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FrameExtended, _super);
        function FrameExtended() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FrameExtended.b = function (a, b, c, d) {
            var e = i2.BrushUtil.k(b, a, c, d);
            return e;
        };
        FrameExtended.a = function (a, b, c, d, e) {
            var f = c.count;
            var g = d.count;
            var h = Math.max(f, g);
            var i = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "transparent";
                return $ret;
            })());
            var j = 1 - b;
            if (a.count < h) {
                var k = new Array(h - a.count);
                for (var l = 0; l < h - a.count; l++) {
                    k[l] = new i2.Brush();
                }
                a.s(a.count, k);
            }
            if (a.count > h) {
                a.v(h, a.count - h);
            }
            for (var m = 0; m < Math.min(f, g); ++m) {
                a._inner[m] = FrameExtended.b(b, c._inner[m], d._inner[m], e);
            }
            if (f < g) {
                var n = f > 0 ? c._inner[f - 1] : i;
                for (var o = f; o < g; ++o) {
                    a._inner[o] = FrameExtended.b(b, n, d._inner[o], e);
                }
            }
            if (f > g) {
                var p = g > 0 ? d._inner[g - 1] : i;
                for (var q = g; q < f; ++q) {
                    a._inner[q] = FrameExtended.b(b, c._inner[q], p, e);
                }
            }
        };
        FrameExtended.$t = i2.markType(FrameExtended, 'FrameExtended');
        return FrameExtended;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutLayerFrame, _super);
        function CalloutLayerFrame() {
            var _this = _super.call(this) || this;
            _this.p = null;
            _this.m = null;
            _this.q = null;
            _this.o = null;
            _this.h = null;
            _this.g = null;
            _this.f = null;
            _this.n = null;
            _this.j = null;
            _this.l = null;
            _this.k = null;
            _this.i = null;
            _this.t = null;
            _this.u = null;
            _this.r = null;
            _this.s = null;
            _this.p = new i2.List$1(i2.Base.$, 0);
            _this.m = new i2.List$1(i2.Base.$, 0);
            _this.q = new i2.List$1(i2.Base.$, 0);
            _this.o = new i2.List$1(i2.Brush.$, 0);
            _this.h = new i2.List$1(i2.Brush.$, 0);
            _this.g = new i2.List$1(i2.Brush.$, 0);
            _this.f = new i2.List$1(i2.Brush.$, 0);
            _this.n = new i2.List$1(i2.Number_$type, 0);
            _this.j = new i2.List$1(i2.Number_$type, 0);
            _this.l = new i2.List$1(i2.Number_$type, 0);
            _this.k = new i2.List$1(i2.Number_$type, 0);
            _this.i = new i2.List$1(i2.Number_$type, 0);
            _this.t = new i2.List$1(i2.Number_$type, 0);
            _this.u = new i2.List$1(i2.Number_$type, 0);
            _this.r = new i2.List$1(i2.Number_$type, 0);
            _this.s = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        CalloutLayerFrame.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            FrameExtended.a(this.o, a, d.o, e.o, 0);
            FrameExtended.a(this.f, a, d.f, e.f, 0);
            FrameExtended.a(this.h, a, d.h, e.h, 0);
            FrameExtended.a(this.g, a, d.g, e.g, 0);
            Frame.b(this.j, a, d.j, e.j);
            Frame.b(this.l, a, d.l, e.l);
            Frame.b(this.k, a, d.k, e.k);
            Frame.b(this.i, a, d.i, e.i);
            Frame.b(this.n, a, d.n, e.n);
            Frame.b(this.t, a, d.t, e.t);
            Frame.b(this.u, a, d.u, e.u);
            Frame.b(this.r, a, d.r, e.r);
            Frame.b(this.s, a, d.s, e.s);
            CalloutLayerFrame.v(this.p, a, d.p, e.p);
            CalloutLayerFrame.v(this.m, a, d.m, e.m);
            CalloutLayerFrame.v(this.q, a, d.q, e.q);
        };
        CalloutLayerFrame.v = function (a, b, c, d) {
            var e = c.count;
            var f = d.count;
            var g = Math.max(e, f);
            var h = 1 - b;
            if (a.count < g) {
                var i = new Array(g - a.count);
                for (var j = 0; j < g - a.count; j++) {
                    i[j] = null;
                }
                a.s(a.count, i);
            }
            if (a.count > g) {
                a.v(g, a.count - g);
            }
            for (var k = 0; k < Math.min(e, f); ++k) {
                if (b == 0) {
                    a._inner[k] = c._inner[k];
                }
                else {
                    a._inner[k] = d._inner[k];
                }
            }
            if (e < f) {
                var l = e > 0 ? c._inner[e - 1] : null;
                for (var m = e; m < f; ++m) {
                    if (b == 0) {
                        a._inner[m] = l;
                    }
                    else {
                        a._inner[m] = d._inner[m];
                    }
                }
            }
            if (e > f) {
                var n = f > 0 ? d._inner[f - 1] : null;
                for (var o = f; o < e; ++o) {
                    if (b == 0) {
                        a._inner[o] = c._inner[o];
                    }
                    else {
                        a._inner[o] = n;
                    }
                }
            }
        };
        CalloutLayerFrame.$t = i2.markType(CalloutLayerFrame, 'CalloutLayerFrame', Frame.$);
        return CalloutLayerFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutAnnotation = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutAnnotation, _super);
        function CalloutAnnotation() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.propertyChanged = null;
            _this.k = null;
            _this.ab = 0;
            _this.ac = 0;
            _this.am = null;
            _this.aw = null;
            _this.aa = null;
            _this.z = null;
            _this.l = null;
            _this._formatLabel = null;
            _this.bk = null;
            _this.bh = null;
            _this.bj = null;
            _this.bi = null;
            _this.x = 0;
            _this.o = false;
            _this.n = true;
            _this.bo = null;
            _this.u = NaN;
            _this.w = NaN;
            _this.v = NaN;
            _this.t = NaN;
            return _this;
        }
        CalloutAnnotation.prototype.a0 = function (a, b, c) {
            this.az(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        CalloutAnnotation.prototype.az = function (a, b, c) {
            switch (a) {
                case CalloutAnnotation.$$p[13]:
                    this.ab = c;
                    break;
                case CalloutAnnotation.$$p[14]:
                    this.ac = c;
                    break;
                case CalloutAnnotation.$$p[9]:
                    this.l = c;
                    break;
                case CalloutAnnotation.$$p[5]:
                    this.z = c;
                    break;
                case CalloutAnnotation.$$p[6]:
                    this.aa = c;
                    break;
                case CalloutAnnotation.$$p[12]:
                    this.am = c;
                    break;
                case CalloutAnnotation.$$p[11]:
                    this.bk = c;
                    break;
                case CalloutAnnotation.$$p[7]:
                    this.bi = c;
                    break;
                case CalloutAnnotation.$$p[8]:
                    this.bj = c;
                    break;
                case CalloutAnnotation.$$p[4]:
                    this.bh = c;
                    break;
                case CalloutAnnotation.$$p[10]:
                    this.x = c;
                    break;
                case CalloutAnnotation.$$p[1]:
                    this.n = true;
                    this.u = c;
                    break;
                case CalloutAnnotation.$$p[3]:
                    this.n = true;
                    this.w = c;
                    break;
                case CalloutAnnotation.$$p[2]:
                    this.n = true;
                    this.v = c;
                    break;
                case CalloutAnnotation.$$p[0]:
                    this.n = true;
                    this.t = c;
                    break;
            }
            this.o = true;
        };
        Object.defineProperty(CalloutAnnotation.prototype, "formatLabel", {
            get: function () {
                return this._formatLabel;
            },
            set: function (a) {
                this._formatLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutAnnotation.prototype, "backgroundPadding", {
            get: function () {
                if (this.n) {
                    this.n = false;
                    this.bo = new i2.Thickness(1, this.u, this.w, this.v, this.t);
                }
                return this.bo;
            },
            set: function (a) {
                this.backgroundPaddingLeft = a.c;
                this.backgroundPaddingTop = a.e;
                this.backgroundPaddingRight = a.d;
                this.backgroundPaddingBottom = a.b;
            },
            enumerable: false,
            configurable: true
        });
        CalloutAnnotation.$t = i2.markType(CalloutAnnotation, 'CalloutAnnotation', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type]);
        CalloutAnnotation.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CalloutAnnotation, 'a0', ['BackgroundPaddingBottom', [1, NaN], 'BackgroundPaddingLeft', [1, NaN], 'BackgroundPaddingRight', [1, NaN], 'BackgroundPaddingTop', [1, NaN], 'Background', [i2.Brush.$, null], 'Content', [4, null], 'Key', [4, null], 'LeaderBrush', [i2.Brush.$, null], 'Outline', [i2.Brush.$, null], 'Series', [Series.$, null], 'StrokeThickness', [1, 0], 'TextColor', [i2.Brush.$, null], 'Text', [2, null], 'XValue', [4, 0], 'YValue', [4, 0]]);
        return CalloutAnnotation;
    }(i2.DependencyObject));
    /**
     * @hidden
     */
    var CalloutAnnotationWrapper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutAnnotationWrapper, _super);
        function CalloutAnnotationWrapper() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.c = null;
            return _this;
        }
        Object.defineProperty(CalloutAnnotationWrapper.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
                this.a.k = this;
            },
            enumerable: false,
            configurable: true
        });
        CalloutAnnotationWrapper.prototype.equals = function (a) {
            var b = i2.typeCast(CalloutAnnotationWrapper.$, a);
            if (b == null) {
                return _super.prototype.equals.call(this, a);
            }
            if (b.b == null && this.b == null) {
                return _super.prototype.equals.call(this, a);
            }
            if (b.b == null) {
                return false;
            }
            if (this.b.aa != null || b.b.aa != null) {
                return i2.Base.equalsStatic(this.b.aa, b.b.aa);
            }
            return _super.prototype.equals.call(this, a);
        };
        CalloutAnnotationWrapper.prototype.getHashCode = function () {
            if (this.b == null || this.b.aa == null) {
                return _super.prototype.getHashCode.call(this);
            }
            return i2.Base.getHashCodeStatic(this.b.aa);
        };
        CalloutAnnotationWrapper.$t = i2.markType(CalloutAnnotationWrapper, 'CalloutAnnotationWrapper');
        return CalloutAnnotationWrapper;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesPointOfInterest = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesPointOfInterest, _super);
        function SeriesPointOfInterest() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.c = null;
            _this.a = null;
            _this.d = null;
            return _this;
        }
        SeriesPointOfInterest.$t = i2.markType(SeriesPointOfInterest, 'SeriesPointOfInterest');
        return SeriesPointOfInterest;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutLabelUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutLabelUpdatingEventArgs, _super);
        function CalloutLabelUpdatingEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.d = null;
            _this._item = null;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutLabelUpdatingEventArgs.$t = i2.markType(CalloutLabelUpdatingEventArgs, 'CalloutLabelUpdatingEventArgs');
        return CalloutLabelUpdatingEventArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutSeriesSelectingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutSeriesSelectingEventArgs, _super);
        function CalloutSeriesSelectingEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.d = null;
            _this._item = null;
            _this.a = null;
            _this.e = null;
            return _this;
        }
        Object.defineProperty(CalloutSeriesSelectingEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutSeriesSelectingEventArgs.$t = i2.markType(CalloutSeriesSelectingEventArgs, 'CalloutSeriesSelectingEventArgs');
        return CalloutSeriesSelectingEventArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutStyleUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutStyleUpdatingEventArgs, _super);
        function CalloutStyleUpdatingEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._xValue = null;
            _this._yValue = null;
            _this._item = null;
            _this._series = null;
            _this._background = null;
            _this._textColor = null;
            _this._outline = null;
            _this._leaderBrush = null;
            _this._strokeThickness = 0;
            return _this;
        }
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "xValue", {
            get: function () {
                return this._xValue;
            },
            set: function (a) {
                this._xValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "yValue", {
            get: function () {
                return this._yValue;
            },
            set: function (a) {
                this._yValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "background", {
            get: function () {
                return this._background;
            },
            set: function (a) {
                this._background = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "textColor", {
            get: function () {
                return this._textColor;
            },
            set: function (a) {
                this._textColor = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "outline", {
            get: function () {
                return this._outline;
            },
            set: function (a) {
                this._outline = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "leaderBrush", {
            get: function () {
                return this._leaderBrush;
            },
            set: function (a) {
                this._leaderBrush = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "strokeThickness", {
            get: function () {
                return this._strokeThickness;
            },
            set: function (a) {
                this._strokeThickness = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutStyleUpdatingEventArgs.$t = i2.markType(CalloutStyleUpdatingEventArgs, 'CalloutStyleUpdatingEventArgs');
        return CalloutStyleUpdatingEventArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ViewportUtils = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ViewportUtils, _super);
        function ViewportUtils() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ViewportUtils.c = function (a, b, c) {
            return c.left + c.width * (a - b.left) / b.width;
        };
        ViewportUtils.a = function (a, b, c) {
            return ((a - c.left) * b.width / c.width) + b.left;
        };
        ViewportUtils.f = function (a, b, c) {
            return c.top + c.height * (a - b.top) / b.height;
        };
        ViewportUtils.e = function (a, b, c) {
            return ((a - c.top) * b.height / c.height) + b.top;
        };
        ViewportUtils.d = function (a, b, c) {
            return c.width * a / b.width;
        };
        ViewportUtils.b = function (a, b, c) {
            return b.width * a / c.width;
        };
        ViewportUtils.g = function (a, b, c) {
            return c.height * a / b.height;
        };
        ViewportUtils.$t = i2.markType(ViewportUtils, 'ViewportUtils');
        return ViewportUtils;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutContentUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutContentUpdatingEventArgs, _super);
        function CalloutContentUpdatingEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.d = null;
            _this._item = null;
            _this.a = null;
            return _this;
        }
        Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutContentUpdatingEventArgs.$t = i2.markType(CalloutContentUpdatingEventArgs, 'CalloutContentUpdatingEventArgs');
        return CalloutContentUpdatingEventArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutKey = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutKey, _super);
        function CalloutKey(a, b) {
            var _this = _super.call(this) || this;
            _this._item = null;
            _this.a = null;
            _this.item = a;
            _this.a = b;
            return _this;
        }
        Object.defineProperty(CalloutKey.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutKey.prototype.getHashCode = function () {
            return i2.Base.getHashCodeStatic(this.item) ^ i2.Base.getHashCodeStatic(this.a);
        };
        CalloutKey.prototype.equals = function (a) {
            var b = i2.typeCast(CalloutKey.$, a);
            if (b == null) {
                return _super.prototype.equals.call(this, a);
            }
            return i2.Base.referenceEquals(this.item, b.item) && this.a == b.a;
        };
        CalloutKey.$t = i2.markType(CalloutKey, 'CalloutKey');
        return CalloutKey;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutViewHelper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutViewHelper, _super);
        function CalloutViewHelper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CalloutViewHelper.a = function (a, b, c, d, e, f, g, h) {
            var i = Math.sqrt((c - a) * (c - a) + (d - b) * (d - b));
            var j = (c - a) / i;
            var k = (d - b) / i;
            var l = a - e;
            var m = b - f;
            var n = g - e;
            var o = h - f;
            var p = -k;
            var q = j;
            var r = n * p + o * q;
            var s = n * m - o * l;
            var t = l * p + m * q;
            var u = s / r;
            var v = t / r;
            if (u >= 0 && v >= 0 && v <= 1) {
                return u;
            }
            return Number.POSITIVE_INFINITY;
        };
        CalloutViewHelper.b = function (a, b, c, d) {
            var e = a.x;
            var f = a.y;
            var g = 0;
            var h = 0;
            var i = 0;
            var j = 0;
            var k = 0;
            var l = 0;
            if (e < 0) {
                g = -e;
                k = g;
                e = 0;
            }
            if (f < 0) {
                h = -f;
                l = h;
                f = 0;
            }
            if (e > b) {
                i = e - b;
            }
            if (f > c) {
                j = f - c;
            }
            var m = new i2.Thickness(1, g, h, i, j);
            var n = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l, k, l + c);
            var o = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l, k + b, l);
            var p = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l + c, k + b, l + c);
            var q = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k + b, l, k + b, l + c);
            var r = Math.min(n, Math.min(o, Math.min(p, q)));
            var s = 0;
            var t = 0;
            if (i2.isInfinity(r)) {
                s = e;
                t = f;
            }
            else {
                var u = k + b / 2;
                var v = l + c / 2;
                var w = e;
                var x = f;
                var y = Math.sqrt((u - w) * (u - w) + (v - x) * (v - x));
                var z = (u - w) / y;
                var aa = (v - x) / y;
                s = w + z * r;
                t = x + aa * r;
            }
            d.ak = e;
            d.am = f;
            d.al = s;
            d.an = t;
            return m;
        };
        CalloutViewHelper.$t = i2.markType(CalloutViewHelper, 'CalloutViewHelper');
        return CalloutViewHelper;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutLayer, _super);
        function CalloutLayer() {
            var _this = _super.call(this) || this;
            _this.calloutStyleUpdating = null;
            _this.qx = null;
            _this.qy = null;
            _this.qz = null;
            _this.qw = null;
            _this.qv = null;
            _this.rm = new i2.HashSet$1(CalloutAnnotationWrapper.$, 0);
            _this.rp = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            _this.rq = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            _this.qt = null;
            _this.rn = new i2.LinkedList$1(CalloutAnnotationWrapper.$);
            _this.rk = new i2.Dictionary$2(CalloutAnnotationWrapper.$, i2.LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
            _this.q5 = null;
            _this.ui = new i2.Rect(0, 0, 0, 1, 1);
            _this.rc = false;
            _this.r0 = 0;
            _this.uh = i2.Rect.empty;
            _this.ra = false;
            _this.rb = false;
            _this.calloutContentUpdating = null;
            _this.calloutLabelUpdating = null;
            _this.calloutSeriesSelecting = null;
            _this.ro = new i2.List$1(SeriesPointOfInterest.$, 0);
            _this.re = false;
            _this.rf = false;
            _this.rs = 0;
            _this.rd = false;
            _this.q9 = true;
            i2.FastItemObjectColumn.m();
            _this.ps = true;
            var a = new CalloutLayerFrame();
            var b = new CalloutLayerFrame();
            var c = new CalloutLayerFrame();
            var d = _this.ha / 1000;
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = CalloutLayer.$;
            return _this;
        }
        CalloutLayer.prototype.get_c2 = function () {
            return true;
        };
        CalloutLayer.prototype.s9 = function (a, b) {
            this.rq.clear();
            this.l0(false);
        };
        CalloutLayer.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            var e = this.rl();
            switch (a) {
                case 3:
                    this.tl(b, e);
                    break;
                case 1:
                    for (var f = b; f < b + c; f++) {
                        var g = new CalloutAnnotation();
                        var h = new CalloutAnnotationWrapper();
                        h.b = g;
                        h.b.series = this.qs;
                        this.rq.insert(f, h);
                        this.tl(f, e);
                    }
                    break;
                case 0:
                    this.rq.v(b, c);
                    break;
                case 2:
                    for (var i = b; i < b + c; i++) {
                        this.tl(i, e);
                    }
                    break;
                case 4:
                    this.rq.clear();
                    for (var j = 0; j < this.ch.count; j++) {
                        var k = new CalloutAnnotation();
                        var l = new CalloutAnnotationWrapper();
                        l.b = k;
                        l.b.series = this.qs;
                        this.rq.add(l);
                        this.tl(j, e);
                    }
                    break;
            }
            this.l0(true);
        };
        CalloutLayer.prototype.ei = function (a) {
            return false;
        };
        CalloutLayer.prototype.rl = function () {
            var a = new i2.Dictionary$2(i2.String_$type, Series.$, 0);
            if (this.ca != null) {
                for (var b = 0; b < this.ca.series.count; b++) {
                    var c = this.ca.series._inner[b];
                    if (c.name != null && !a.containsKey(c.name)) {
                        a.addItem(c.name, c);
                    }
                }
            }
            return a;
        };
        CalloutLayer.prototype.tl = function (a, b) {
            var _this = this;
            if (this.q4 == null || this.q2 == null) {
                return;
            }
            var c = a;
            if (this.q3 != null) {
                c = this.q3.item(a);
            }
            var d = this.q4.item(a);
            var e = this.q2.item(a);
            var f = this.rq._inner[a];
            if (this.q1 != null) {
                if (f.b.aa != this.q1.item(a)) {
                    f.b.key = this.q1.item(a);
                }
            }
            if (this.rk.containsKey(f)) {
                f.b = this.rk.item(f).c.b;
            }
            f.b.xValue = c;
            f.b.yValue = d;
            if (this.calloutLabelUpdating != null) {
                var g = ((function () {
                    var $ret = new CalloutLabelUpdatingEventArgs();
                    $ret.c = c;
                    $ret.d = d;
                    $ret.item = _this.ch.item(a);
                    return $ret;
                })());
                this.calloutLabelUpdating(this, g);
                if (g.b != null && !i2.Base.equalsStatic(g.b, f.b.am)) {
                    var h = g.b;
                    f.b.text = h != null ? h.toString() : "";
                }
            }
            else {
                f.b.text = e != null ? e.toString() : "";
            }
            if (this.q0 != null) {
                f.b.content = this.q0.item(a);
            }
            else {
                f.b.content = this.ch.item(a);
            }
            if (this.calloutSeriesSelecting != null) {
                var i = ((function () {
                    var $ret = new CalloutSeriesSelectingEventArgs();
                    $ret.c = c;
                    $ret.d = d;
                    $ret.item = _this.ch.item(a);
                    return $ret;
                })());
                this.calloutSeriesSelecting(this, i);
                if (i.a != null) {
                    f.b.series = i.a;
                }
                else if (i.e != null) {
                    if (b.containsKey(i.e)) {
                        f.b.series = b.item(i.e);
                    }
                }
            }
            this.tm(f);
        };
        CalloutLayer.prototype.tm = function (a) {
            var b = new i2.Thickness(0, 3);
            if (i2.isNaN_(this.uk.c) || i2.isNaN_(this.uk.e) || i2.isNaN_(this.uk.d) || i2.isNaN_(this.uk.b)) {
                b = new i2.Thickness(0, 3);
            }
            else {
                b = this.uk;
            }
            var c = this.ud != null ? this.ud : this.qp.ci(a.b.l);
            var d = this.ug != null ? this.ug : this.qp.cl();
            var e = this.uf != null ? this.uf : this.qp.ck();
            var f = this.ue != null ? this.ue : this.qp.cj(a.b.l);
            var g = i2.isNaN_(this.ry) ? 0 : this.ry;
            if (this.ri && this.calloutStyleUpdating != null) {
                var h = new CalloutStyleUpdatingEventArgs();
                h.item = a.b.z;
                h.xValue = a.b.ab;
                h.yValue = a.b.ac;
                h.series = a.b.l;
                h.background = c;
                h.textColor = d;
                h.outline = e;
                h.leaderBrush = f;
                h.strokeThickness = g;
                this.calloutStyleUpdating(this, h);
                c = h.background;
                d = h.textColor;
                e = h.outline;
                f = h.leaderBrush;
                g = h.strokeThickness;
            }
            a.b.backgroundPadding = b;
            a.b.background = c;
            a.b.textColor = d;
            a.b.outline = e;
            a.b.leaderBrush = f;
            a.b.strokeThickness = g;
        };
        CalloutLayer.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == CalloutLayer.$$p[19]) {
                return this.hl(a, b, this.sv);
            }
            if (c == CalloutLayer.$$p[24]) {
                return this.hl(a, b, this.s4);
            }
            if (c == CalloutLayer.$$p[25]) {
                return this.hl(a, b, this.s7);
            }
            if (c == CalloutLayer.$$p[18]) {
                return this.hl(a, b, this.ss);
            }
            if (c == CalloutLayer.$$p[14]) {
                return this.hl(a, b, this.sm);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(CalloutLayer.prototype, "q2", {
            get: function () {
                return this.qx;
            },
            set: function (a) {
                if (this.qx != a) {
                    var b = this.qx;
                    this.qx = a;
                    this.raisePropertyChanged("LabelColumn", b, this.qx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutLayer.prototype, "q3", {
            get: function () {
                return this.qy;
            },
            set: function (a) {
                if (this.qy != a) {
                    var b = this.qy;
                    this.qy = a;
                    this.raisePropertyChanged("XColumn", b, this.qy);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutLayer.prototype, "q4", {
            get: function () {
                return this.qz;
            },
            set: function (a) {
                if (this.qz != a) {
                    var b = this.qz;
                    this.qz = a;
                    this.raisePropertyChanged("YColumn", b, this.qz);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutLayer.prototype, "q1", {
            get: function () {
                return this.qw;
            },
            set: function (a) {
                if (this.qw != a) {
                    var b = this.qw;
                    this.qw = a;
                    this.raisePropertyChanged("KeyColumn", b, this.qw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutLayer.prototype, "q0", {
            get: function () {
                return this.qv;
            },
            set: function (a) {
                if (this.qv != a) {
                    var b = this.qv;
                    this.qv = a;
                    this.raisePropertyChanged("ContentColumn", b, this.qv);
                }
            },
            enumerable: false,
            configurable: true
        });
        CalloutLayer.prototype.tb = function (a, b) {
            if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
                var c = a.k;
                if (!this.rm.contains(c)) {
                    this.rm.add_1(c);
                    this.rp.add(c);
                    this.l0(false);
                }
            }
        };
        CalloutLayer.prototype.bu = function () {
            return new CalloutLayerView(this);
        };
        CalloutLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qp = a;
        };
        Object.defineProperty(CalloutLayer.prototype, "uk", {
            get: function () {
                return new i2.Thickness(1, this.ru, this.rw, this.rv, this.rt);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutLayer.prototype, "qu", {
            get: function () {
                if (this.qt == null) {
                    this.qt = i2.FontUtil.toFontInfo(this.gw, this.s0);
                }
                return this.qt;
            },
            enumerable: false,
            configurable: true
        });
        CalloutLayer.prototype.p3 = function (a, b) {
            if (this.qs == null || this.qs == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        CalloutLayer.prototype.p5 = function (a, b) {
            var e_1, _a;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            c.p.clear();
            c.q.clear();
            c.m.clear();
            c.f.clear();
            c.h.clear();
            c.g.clear();
            c.j.clear();
            c.l.clear();
            c.k.clear();
            c.i.clear();
            c.n.clear();
            c.o.clear();
            c.t.clear();
            c.u.clear();
            c.r.clear();
            c.s.clear();
            var d = this.rr();
            var e = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            if (this.rg) {
                if (this.pq(this.qs)) {
                    this.ti(this.qs, c, e);
                }
                else {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var f = _c.value;
                            if (this.pq(f)) {
                                this.ti(f, c, e);
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
            }
            this.th(c, d, e);
        };
        CalloutLayer.prototype.mn = function (a, b) {
            _super.prototype.mn.call(this, a, b);
            var c = b.width - this.ui.width;
            var d = b.height - this.ui.height;
            var e = 0;
            if (Math.abs(c) > Math.abs(d)) {
                e = c;
                this.rs = c * this.pf.width;
            }
            else {
                e = d;
                this.rs = d * this.pf.height;
            }
            if (e > 0 && this.rs > 5) {
                this.rf = true;
            }
            if (e < 0 && this.rs > 5) {
                this.re = true;
            }
        };
        CalloutLayer.prototype.mm = function (a, b) {
            _super.prototype.mm.call(this, a, b);
            if (!a.equals1(b)) {
                this.rd = true;
            }
        };
        Object.defineProperty(CalloutLayer.prototype, "uj", {
            get: function () {
                return this.uh;
            },
            set: function (a) {
                this.uh = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutLayer.prototype.th = function (a, b, c) {
            var e_2, _a;
            if (this.ca != null) {
                this.ui = this.ca.pg;
            }
            if (this.pf.isEmpty) {
                return;
            }
            this.uj = new i2.Rect(0, this.pf.left, this.pf.top, this.pf.width, this.pf.height);
            if (this.q5 != null && this.sj != null && this.sj != this.q5.ak) {
                this.td();
            }
            if (this.q5 == null) {
                var d = this.q6();
                if (d != null) {
                    this.q5 = d;
                    var e = this.q5;
                    e.labelsMoved = i2.delegateCombine(e.labelsMoved, i2.runOn(this, this.ta));
                }
                else {
                    var f = this.o7(this.bx);
                    var g = 0;
                    if (this.qs != null) {
                        if (this.qs.isVertical) {
                            g = 2;
                        }
                    }
                    else {
                        var h = false;
                        if (this.ca != null && this.ca.series.count > 0) {
                            h = true;
                            try {
                                for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    var i = _c.value;
                                    if (!i.c6) {
                                        if (!i.isVertical) {
                                            h = false;
                                        }
                                    }
                                }
                            }
                            catch (e_2_1) {
                                e_2 = { error: e_2_1 };
                            }
                            finally {
                                try {
                                    if (_c && !_c.done && (_a = _b.return))
                                        _a.call(_b);
                                }
                                finally {
                                    if (e_2)
                                        throw e_2.error;
                                }
                            }
                        }
                        if (h) {
                            g = 2;
                        }
                    }
                    this.q5 = new i2.LabelCollisionManager(this.pf.right, this.pf.bottom, this.pf, this.qp.j(), this.rx, this.q7(), g, this.r4(), this.r3(), this.rh);
                    if (this.sj != null) {
                        this.q5.ak = this.sj;
                        this.q5.ai = this;
                    }
                    var j = this.q5;
                    j.labelsMoved = i2.delegateCombine(j.labelsMoved, i2.runOn(this, this.ta));
                }
            }
            if (this.re) {
                this.re = false;
                if (this.q5.ag > 2) {
                    this.rc = true;
                }
            }
            if (this.rf) {
                this.rf = false;
                if (this.rs > 5) {
                    this.rc = true;
                }
            }
            if (this.rd) {
                this.rd = false;
                this.q5.ay(this.pf.right, this.pf.bottom, this.pf);
                this.rc = true;
            }
            var k = new i2.HashSet$1(CalloutAnnotationWrapper.$, 0);
            var l = new i2.HashSet$1(CalloutAnnotationWrapper.$, 0);
            var m = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            var n = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            var o = new i2.HashSet$1(CalloutAnnotationWrapper.$, 0);
            for (var p = 0; p < b.count; p++) {
                o.add_1(b._inner[p]);
            }
            for (var q = 0; q < c.count; q++) {
                o.add_1(c._inner[q]);
            }
            var r = this.rn.c;
            while (r != null) {
                var s = r.a;
                if (!o.contains(r.c)) {
                    n.add(r.c);
                    l.add_1(r.c);
                    var t = r.c.b;
                    t.propertyChanged = i2.delegateRemove(t.propertyChanged, i2.runOn(this, this.tb));
                    this.rn.h(r);
                    this.rk.removeItem(r.c);
                    this.q5.ax(r.c.c);
                }
                r = s;
            }
            for (var u = 0; u < b.count; u++) {
                if (!this.rk.containsKey(b._inner[u])) {
                    this.rn.f(b._inner[u]);
                    var v = b._inner[u].b;
                    v.propertyChanged = i2.delegateCombine(v.propertyChanged, i2.runOn(this, this.tb));
                    this.rk.addItem(b._inner[u], this.rn.d);
                    m.add(b._inner[u]);
                    k.add_1(b._inner[u]);
                    this.rc = true;
                }
            }
            for (var w = 0; w < c.count; w++) {
                if (!this.rk.containsKey(c._inner[w])) {
                    this.rn.f(c._inner[w]);
                    this.rk.addItem(c._inner[w], this.rn.d);
                    var x = c._inner[w].b;
                    x.propertyChanged = i2.delegateCombine(x.propertyChanged, i2.runOn(this, this.tb));
                    m.add(c._inner[w]);
                    k.add_1(c._inner[w]);
                    this.rc = true;
                }
            }
            if (this.ra == true) {
                this.ra = false;
                this.rc = true;
            }
            if (this.rp.count > 0) {
                this.rc = true;
                this.rp.clear();
                this.rm.clear();
            }
            r = this.rn.c;
            while (r != null) {
                var y = this.q8(r.c);
                if (y == null) {
                    return;
                }
                if (!i2.Base.equalsStatic(y, r.c.c.c)) {
                    var z = false;
                    if (r.c.c.c == null) {
                        z = true;
                    }
                    var aa = r.c.c;
                    aa.o = y.b;
                    aa.p = y.c;
                    if (!i2.isNaN_(aa.o) && !i2.isNaN_(aa.p)) {
                        aa.n = y.e;
                        aa.m = y.d;
                        if (aa.b == null) {
                            this.q5.p(aa);
                        }
                        if (z) {
                            this.q5.al(aa);
                        }
                        else {
                            this.q5.au(aa);
                        }
                    }
                }
                r = r.a;
            }
            var ab = this.q5.ah();
            var ac = this.q5.q();
            if (this.rc && (ab != 0 || ac)) {
                this.rc = false;
                this.r0 = 0x7FFFFFFF;
                if (this.sj != null) {
                    var ad = true;
                    for (var ae = 0; ae < this.ca.series.count; ae++) {
                        var af = this.ca.series._inner[ae];
                        if (af.c6 && i2.typeCast(CalloutLayer.$, af) !== null) {
                            var ag = af;
                            if (ag.sj == this.sj) {
                                if (!ag.uj.equals1(this.q5.a0)) {
                                    ad = false;
                                    break;
                                }
                            }
                        }
                    }
                    if (ad) {
                        this.q5.az();
                    }
                    else {
                        this.q5.am();
                        this.q5.an();
                    }
                }
                else {
                    this.q5.az();
                }
            }
            else {
                this.q5.an();
            }
            var ah = this.rn.c;
            while (ah != null) {
                var ai = ah.c;
                a.m.add1(ai);
                a.f.add(ai.b.bh);
                a.h.add(ai.b.bj);
                a.g.add(ai.b.bi);
                a.j.add(ai.b.backgroundPadding.c);
                a.l.add(ai.b.backgroundPadding.e);
                a.k.add(ai.b.backgroundPadding.d);
                a.i.add(ai.b.backgroundPadding.b);
                a.n.add(ai.b.x);
                a.o.add(ai.b.bk);
                a.p.add1(ai.b.am);
                a.q.add1(ai.b.z);
                var aj = ai.c;
                a.t.add(ai.c.o - (ai.c.g - ai.c.l));
                a.u.add(ai.c.p - (ai.c.h - ai.c.k));
                a.r.add(ai.c.g - ai.c.l);
                a.s.add(ai.c.h - ai.c.k);
                ah = ah.a;
            }
        };
        CalloutLayer.prototype.td = function () {
            if (this.q5 != null) {
                var a = this.rn.c;
                while (a != null) {
                    var b = a.c.c;
                    if (b != null) {
                        this.q5.ax(b);
                    }
                    a = a.a;
                }
                var c = this.q5;
                c.labelsMoved = i2.delegateRemove(c.labelsMoved, i2.runOn(this, this.ta));
                this.q5 = null;
            }
            this.tc();
        };
        CalloutLayer.prototype.q6 = function () {
            if (this.ca == null) {
                return null;
            }
            for (var a = 0; a < this.ca.series.count; a++) {
                var b = this.ca.series._inner[a];
                if (b.c6 && i2.typeCast(CalloutLayer.$, b) !== null) {
                    var c = b;
                    if (c != this) {
                        if (c.sj != null && c.sj == this.sj) {
                            if (c.q5 != null) {
                                return c.q5;
                            }
                        }
                    }
                }
            }
            return null;
        };
        CalloutLayer.prototype.r3 = function () {
            return 20000;
        };
        CalloutLayer.prototype.r4 = function () {
            return 300;
        };
        CalloutLayer.prototype.q7 = function () {
            switch (this.qm) {
                case 0: return 2;
                case 2: return 1;
                case 3: return 2;
                case 1: return 0;
            }
            return 2;
        };
        CalloutLayer.prototype.ta = function (a) {
            var b = this.q5.ah();
            if (b < this.r0) {
                this.r0 = b;
                this.l0(false);
            }
        };
        CalloutLayer.prototype.q8 = function (a) {
            var b = this.qs;
            if (a.b.l != null) {
                b = a.b.l;
            }
            if (b == null) {
                for (var c = 0; c < this.ca.series.count; c++) {
                    var d = this.ca.series._inner[c];
                    if (!d.c6) {
                        b = d;
                        break;
                    }
                }
            }
            if (b == null) {
                return null;
            }
            var e = b.ag();
            var f = b.f2();
            var g = null;
            var h = null;
            var i = false;
            for (var j = 0; j < e.length; j++) {
                if (e[j].b4) {
                    i = true;
                    g = e[j];
                }
                else if (e[j].cg) {
                    i = true;
                    h = e[j];
                }
                else if (e[j].cj) {
                    h = e[j];
                }
                else {
                    g = e[j];
                }
            }
            if (g == null || h == null) {
                return null;
            }
            if (!g.ci() || !h.ci()) {
                return null;
            }
            var k = 0;
            var l = 0;
            if (g.b6 && g.categoryMode != 0) {
                if (b.di) {
                    k = b.getOffsetValue();
                }
                else if (b.da) {
                    k = b.getOffsetValue();
                }
            }
            if (h.b6 && h.categoryMode != 0) {
                if (b.da) {
                    l = b.getOffsetValue();
                }
            }
            var m = new ScalerParams(0, this.ca.pg, g.js, g.cc, g.jn());
            m.b = f;
            var n = new ScalerParams(0, this.ca.pg, h.js, h.cc, h.jn());
            n.b = f;
            var o = 0;
            var p = 0;
            if (i) {
                o = g.d8(this.rz(a.b.ab), m) + k;
                p = h.d8(this.rz(a.b.ac), n) + l;
                var q = o;
                var r = p;
                var s = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
                var t = s.x + (r * Math.cos(q));
                o = ViewportUtils.c(t, m.e, m.d);
                var u = s.y + (r * Math.sin(q));
                p = ViewportUtils.f(u, n.e, n.d);
            }
            else {
                o = g.d8(this.rz(a.b.ab), m) + k;
                p = h.d8(this.rz(a.b.ac), n) + l;
            }
            var v = new i2.QuadTreeBoundingBox();
            v.b = o;
            v.c = p;
            v.e = 3;
            v.d = 3;
            v.g = a.b;
            return v;
        };
        CalloutLayer.prototype.rz = function (a) {
            if (i2.typeCast(i2.Date_$type, a) !== null) {
                return a.getTime();
            }
            if (a == null) {
                return 0;
            }
            return a;
        };
        CalloutLayer.prototype.rr = function () {
            var a = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            for (var b = 0; b < this.rq.count; b++) {
                if (i2.stringIsNullOrEmpty(this.rq._inner[b].b.am)) {
                    continue;
                }
                if (this.rq._inner[b].c == null) {
                    var c = new i2.LabelCollisionInfo();
                    this.rq._inner[b].c = c;
                    var d = this.qp.cn(this.r5(this.rq._inner[b]), this.rq._inner[b].b.backgroundPadding);
                    c.k = d.height / 2;
                    c.l = d.width / 2;
                }
                var e = this.q8(this.rq._inner[b]);
                if (e == null || e.b < this.pf.left || e.b > this.pf.right || e.c < this.pf.top || e.c > this.pf.bottom) {
                    continue;
                }
                a.add(this.rq._inner[b]);
            }
            return a;
        };
        CalloutLayer.prototype.r5 = function (a) {
            return a.b.am;
        };
        CalloutLayer.prototype.pq = function (a) {
            if (!_super.prototype.pq.call(this, a)) {
                return false;
            }
            if (this.sx != null) {
                if (a.dn) {
                    var b = a.i9();
                    if (!i2.Base.equalsStatic(this.sx, b)) {
                        return false;
                    }
                }
                else {
                    if (!i2.Base.equalsStatic(this.sx, a.name)) {
                        return false;
                    }
                }
            }
            return true;
        };
        CalloutLayer.prototype.la = function () {
            _super.prototype.la.call(this);
            if (!this.as.c && !this.cr()) {
                return;
            }
            if (this.q9) {
                this.q9 = false;
                this.tf();
            }
            if (this.cr()) {
                this.tk(this.pl, false);
            }
            else {
                this.tk(this.pj, false);
            }
        };
        CalloutLayer.prototype.tg = function () {
            if (!this.rb) {
                this.rb = true;
                this.l0(true);
            }
        };
        CalloutLayer.prototype.ti = function (a, b, c) {
            var d = false;
            if (this.rb) {
                this.rb = false;
                d = true;
            }
            if (a.cx(this.ro, this.rj, this.r1)) {
                var e = this.ro;
                var _loop_1 = function (f) {
                    var g = e._inner[f];
                    var h = g.a.item != null ? g.a.item : g.a;
                    var i = a;
                    var j = new CalloutKey(h, i);
                    var k = new CalloutAnnotationWrapper();
                    var l = new CalloutAnnotation();
                    k.b = l;
                    l.key = j;
                    var m = false;
                    if (this_1.rk.containsKey(k)) {
                        k = this_1.rk.item(k).c;
                        l = k.b;
                        m = d;
                    }
                    else {
                        m = true;
                    }
                    var n = l.ab;
                    var o = l.ac;
                    if (this_1.rz(n) != this_1.rz(g.b)) {
                        l.xValue = g.b;
                    }
                    if (this_1.rz(o) != this_1.rz(g.c)) {
                        l.yValue = g.c;
                    }
                    l.series = a;
                    var p = false;
                    if (g.d != l.aw) {
                        l.aw = g.d;
                        p = true;
                    }
                    if (m || p) {
                        if (this_1.calloutLabelUpdating != null) {
                            var q = ((function () {
                                var $ret = new CalloutLabelUpdatingEventArgs();
                                $ret.c = l.ab;
                                $ret.d = l.ac;
                                $ret.item = h;
                                return $ret;
                            })());
                            this_1.calloutLabelUpdating(this_1, q);
                            if (q.b != null && !i2.Base.equalsStatic(q.b, k.b.am)) {
                                var r = q.b;
                                k.b.text = r != null ? r.toString() : "";
                            }
                        }
                        else {
                            if (g.d != null) {
                                l.text = g.d;
                            }
                        }
                    }
                    if (l.am == null) {
                        return "continue";
                    }
                    if (m || p) {
                        if (this_1.calloutContentUpdating != null) {
                            var s = ((function () {
                                var $ret = new CalloutContentUpdatingEventArgs();
                                $ret.c = l.ab;
                                $ret.d = l.ac;
                                $ret.item = h;
                                $ret.a = h;
                                return $ret;
                            })());
                            this_1.calloutContentUpdating(this_1, s);
                            if (s.a != null && s.a != k.b.z) {
                                k.b.content = s.a;
                            }
                        }
                        else {
                            if (h != null && h != k.b.z) {
                                k.b.content = h;
                            }
                        }
                    }
                    if (m) {
                        this_1.tm(k);
                    }
                    if (k.c == null) {
                        var t = new i2.LabelCollisionInfo();
                        k.c = t;
                        var u = this_1.qp.cn(this_1.r5(k), k.b.backgroundPadding);
                        t.k = u.height / 2;
                        t.l = u.width / 2;
                    }
                    var v = this_1.q8(k);
                    if (v == null || v.b < this_1.pf.left || v.b > this_1.pf.right || v.c < this_1.pf.top || v.c > this_1.pf.bottom) {
                        return "continue";
                    }
                    c.add(k);
                };
                var this_1 = this;
                for (var f = 0; f < this.ro.count; f++) {
                    _loop_1(f);
                }
            }
        };
        CalloutLayer.prototype.bo = function () {
            return 1;
        };
        CalloutLayer.prototype.at = function (a, b) {
            var c = this.q5.d(a, b);
            if (c == null) {
                return null;
            }
            return c.u;
        };
        CalloutLayer.prototype.ep = function (a, b) {
            if (this.q5 == null) {
                return false;
            }
            return this.q5.d(a, b) != null;
        };
        CalloutLayer.prototype.tk = function (a, b) {
            var e_3, _a;
            var c = 0;
            var d = new i2.HashSet$1(CalloutAnnotationWrapper.$, 0);
            for (c = 0; c < a.p.count; c++) {
                var e = a.m._inner[c];
                if (i2.isNaN_(a.t._inner[c]) || i2.isNaN_(a.u._inner[c])) {
                    continue;
                }
                var f = this.qp.b8.item(e);
                d.add_1(e);
                if (f.f != a.p._inner[c]) {
                    f.f = a.p._inner[c];
                    var g = f.s();
                }
                f.c = a.n._inner[c];
                f.k = a.f._inner[c];
                f.n = a.o._inner[c];
                f.m = f.c > 0 ? a.h._inner[c] : this.bx.bq();
                f.l = a.g._inner[c];
                f.v = new i2.Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
                this.qp.cg(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
                this.qp.ch(f, e, a.q._inner[c]);
                f.p = { $type: i2.Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
            }
            var h = new i2.List$1(CalloutAnnotationWrapper.$, 0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.qp.b8.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var i = _c.value;
                    if (!d.contains(i)) {
                        h.add(i);
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            for (var j = 0; j < h.count; j++) {
                this.qp.b8.h(h._inner[j]);
            }
        };
        CalloutLayer.prototype.p8 = function (a, b) {
            _super.prototype.p8.call(this, a, b);
            if (this.cr()) {
                this.tk(this.pl, true);
            }
            else {
                this.tk(this.pj, false);
            }
        };
        CalloutLayer.prototype.eg = function () {
            return true;
        };
        CalloutLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case CalloutLayer.$$p[22]:
                    this.qt = null;
                    this.qp.cf();
                    this.l0(true);
                    break;
                case CalloutLayer.$$p[20]:
                case CalloutLayer.$$p[21]:
                    this.l0(true);
                    break;
                case CalloutLayer.$$p[13]:
                    this.l0(true);
                    break;
                case "SeriesViewer":
                    if (c != null) {
                        var e = c;
                        e.seriesAnimating = i2.delegateRemove(e.seriesAnimating, i2.runOn(this, this.tj));
                    }
                    if (d != null) {
                        var f = d;
                        f.seriesAnimating = i2.delegateCombine(f.seriesAnimating, i2.runOn(this, this.tj));
                    }
                    if (d == null) {
                        this.td();
                    }
                    break;
                case CalloutLayer.$$p[15]:
                case CalloutLayer.$$p[16]:
                case CalloutLayer.$$p[1]:
                case CalloutLayer.$$p[5]:
                case CalloutLayer.$$p[4]:
                case CalloutLayer.$$p[7]:
                case CalloutLayer.$$p[9]:
                case CalloutLayer.$$p[8]:
                case CalloutLayer.$$p[6]:
                case CalloutLayer.$$p[11]:
                case CalloutLayer.$$p[12]:
                    this.te();
                    break;
                case CalloutLayer.$$p[19]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q2);
                        this.q2 = this.cg(this.sv);
                    }
                    break;
                case "LabelColumn":
                    this.te();
                    break;
                case CalloutLayer.$$p[14]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q0);
                        this.q0 = this.cg(this.sm);
                    }
                    break;
                case "ContentColumn":
                    this.te();
                    break;
                case CalloutLayer.$$p[24]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q3);
                        this.q3 = i2.stringIsNullOrEmpty(this.s4) == false ? this.cg(this.s4) : null;
                    }
                    break;
                case "XColumn":
                    this.te();
                    break;
                case CalloutLayer.$$p[25]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q4);
                        this.q4 = this.cg(this.s7);
                    }
                    break;
                case "YColumn":
                    this.te();
                    break;
                case CalloutLayer.$$p[18]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q1);
                        this.q1 = this.cg(this.ss);
                    }
                    break;
                case "KeyColumn":
                    this.te();
                    break;
                case "FastItemsSource":
                    this.ra = true;
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.q2);
                        c.deregisterColumn(this.q0);
                        c.deregisterColumn(this.q3);
                        c.deregisterColumn(this.q4);
                        c.deregisterColumn(this.q1);
                        this.q2 = null;
                        this.q0 = null;
                        this.q3 = null;
                        this.q4 = null;
                        this.q1 = null;
                        this.rq.clear();
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.q2 = this.cg(this.sv);
                        this.q0 = this.cg(this.sm);
                        if (i2.stringIsNullOrEmpty(this.s4) == false) {
                            this.q3 = this.cg(this.s4);
                        }
                        this.q4 = this.cg(this.s7);
                        this.q1 = this.cg(this.ss);
                    }
                    this.te();
                    break;
            }
        };
        CalloutLayer.prototype.tj = function (a) {
            if (a.c6) {
                return;
            }
            if ((a == this.qs || this.qs == null) && this.rg) {
                this.l0(false);
            }
        };
        CalloutLayer.prototype.te = function () {
            if (this.q9 == false) {
                this.q9 = true;
                this.l0(false);
            }
        };
        CalloutLayer.prototype.tc = function () {
            this.qp.b8.clear();
            this.rn.g();
            this.rk.clear();
        };
        CalloutLayer.prototype.tf = function () {
            if (this.q4 == null || this.q2 == null) {
                var a = this.rn.c;
                while (a != null) {
                    this.tm(a.c);
                    a = a.a;
                }
                return;
            }
            var b = this.rl();
            for (var c = 0; c < this.q4.count; c++) {
                var d = void 0;
                if (this.rq.count <= c) {
                    var e = new CalloutAnnotation();
                    d = new CalloutAnnotationWrapper();
                    d.b = e;
                    d.b.series = this.qs;
                    this.rq.add(d);
                }
                else {
                    d = this.rq._inner[c];
                }
                this.tl(c, b);
            }
        };
        CalloutLayer.$t = i2.markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
        CalloutLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:r1:tn', [1, 5], 'CalloutBackground:ud:to', [i2.Brush.$, null], 'CalloutCollisionMode:qm:tp', [CalloutCollisionMode_$type, i2.enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:r2:tq', [1, -1], 'CalloutLeaderBrush:ue:tr', [i2.Brush.$, null], 'CalloutOutline:uf:ts', [i2.Brush.$, null], 'CalloutPaddingBottom:rt:tt', [1, NaN], 'CalloutPaddingLeft:ru:tu', [1, NaN], 'CalloutPaddingRight:rv:tv', [1, NaN], 'CalloutPaddingTop:rw:tw', [1, NaN], 'CalloutPositionPadding:rx:tx', [1, 10], 'CalloutStrokeThickness:ry:ty', [1, NaN], 'CalloutTextColor:ug:tz', [i2.Brush.$, null], 'CollisionChannel:sj:t0', [2, null], 'ContentMemberPath:sm:t1', [2, null], 'IsAutoCalloutBehaviorEnabled:rg:t2', [0, false], 'IsCalloutOffsettingEnabled:rh:t3', [0, true], 'IsCustomCalloutStyleEnabled:ri:t4', [0, false], 'KeyMemberPath:ss:t5', [2, null], 'LabelMemberPath:sv:t6', [2, null], 'TargetSeriesName:sx:t7', [2, null], 'TargetSeries:qs:t8', [Series.$, null], 'TextStyle:s0:t9', [2, null], 'UseValueForAutoCalloutLabels:rj:ua', [0, true], 'XMemberPath:s4:ub', [2, null], 'YMemberPath:s7:uc', [2, null]]);
        return CalloutLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var CalloutLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutLayerView, _super);
        function CalloutLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b9 = null;
            _this.b8 = null;
            _this.ca = NaN;
            _this.b5 = null;
            _this.b4 = a;
            _this.b9 = new i2.List$1(CalloutView.$, 0);
            return _this;
        }
        CalloutLayerView.prototype.as = function () {
            var _this = this;
            _super.prototype.as.call(this);
            this.b8 = ((function () {
                var $ret = new i2.HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
                $ret.create = i2.runOn(_this, _this.b6);
                $ret.activate = i2.runOn(_this, _this.cc);
                $ret.disactivate = i2.runOn(_this, _this.ce);
                $ret.destroy = i2.runOn(_this, _this.cd);
                return $ret;
            })());
        };
        CalloutLayerView.prototype.b6 = function () {
            var a = new CalloutView(this);
            this.b9.add(a);
            return a;
        };
        CalloutLayerView.prototype.cc = function (a) {
            a.w = 0;
        };
        CalloutLayerView.prototype.ce = function (a) {
            a.w = 1;
        };
        CalloutLayerView.prototype.cd = function (a) {
            this.b9.remove(a);
        };
        CalloutLayerView.prototype.cm = function (a) {
            if (a == null) {
                return a;
            }
            return i2.BrushUtil.l(a, 0.1);
        };
        CalloutLayerView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            a.ac(this.b7());
            if (a.d && !b) {
                for (var c = 0; c < this.b9.count; c++) {
                    var d = this.b9._inner[c];
                    if (d.w == 0) {
                        d.h(a);
                    }
                }
            }
        };
        CalloutLayerView.prototype.b7 = function () {
            if (this.b4.qu != null) {
                return this.b4.qu;
            }
            return this.e.ca.getFontInfo();
        };
        CalloutLayerView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            for (var b = 0; b < this.b9.count; b++) {
                var c = this.b9._inner[b];
                if (c.w != 0) {
                    continue;
                }
                c.g(this.b4, this.b7(), a);
            }
        };
        CalloutLayerView.prototype.co = function (a) {
            this.k.ac(this.b7());
            this.ca = this.cb();
            return new i2.Size(1, this.k.f(a.ak), this.ca);
        };
        CalloutLayerView.prototype.cb = function () {
            var a = this.b7();
            if (i2.isNaN_(this.ca)) {
                var b = i2.FontUtil.getCurrentFontHeight(this.e.ca.cf.j.ae, a);
                this.ca = b;
            }
            return this.ca;
        };
        CalloutLayerView.prototype.cn = function (a, b) {
            if (this.b5 == null) {
                this.b5 = new CalloutView(this);
            }
            this.b5.f = a;
            this.b5.v = b;
            var c = this.b5.s();
            this.b5.f = null;
            return c;
        };
        CalloutLayerView.prototype.cg = function (a, b, c) {
            a.d = b;
            a.e = c;
        };
        CalloutLayerView.prototype.ch = function (a, b, c) {
            a.i(this.e, b, c);
        };
        CalloutLayerView.prototype.ci = function (a) {
            if (a != null) {
                return this.cm(a.ok);
            }
            return this.e.ok;
        };
        CalloutLayerView.prototype.cl = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 255, 255, 255);
                return $ret;
            })());
        };
        CalloutLayerView.prototype.ck = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 255, 255, 255);
                return $ret;
            })());
        };
        CalloutLayerView.prototype.cj = function (a) {
            if (a != null) {
                return this.cm(a.of);
            }
            return this.e.of;
        };
        CalloutLayerView.prototype.cf = function () {
            this.ca = NaN;
        };
        CalloutLayerView.$t = i2.markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
        return CalloutLayerView;
    }(AnnotationLayerView));
    /**
     * @hidden
     */
    var CalloutView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutView, _super);
        function CalloutView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.w = 0;
            _this.j = null;
            _this.r = null;
            _this.o = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.q = null;
            _this.u = new i2.Thickness(0, 0);
            _this.t = null;
            _this.d = 0;
            _this.e = 0;
            _this.b = null;
            _this.q = new i2.Line();
            _this.q.ab = false;
            _this.q._stroke = ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 0, 0, 0);
                return $ret;
            })());
            _this.q.ac = 2;
            _this.j = new i2.TextBlock();
            _this.r = new i2.Rectangle();
            _this.r.ac = 0;
            _this.a = a;
            _this.w = 0;
            return _this;
        }
        CalloutView.prototype.h = function (a) {
            a.z();
            a.af(this.d, this.e);
            var b = new i2.TranslateTransform();
            b.j = this.t.c;
            b.k = this.t.e;
            this.r.j = b;
            a.r(this.q);
            a.z();
            this.r.width = this.j.m + this.u.c + this.u.d;
            this.r.height = this.j.l + this.u.e + this.u.b;
            a.j(this.r.j);
            a.v(this.r);
            this.j.o = this.u.e;
            this.j.n = this.u.c;
            a.w(this.j);
            a.y();
            a.y();
        };
        Object.defineProperty(CalloutView.prototype, "p", {
            get: function () {
                return this.o;
            },
            set: function (a) {
                if (this.o.x != a.x || this.o.y != a.y) {
                    var b = this.s();
                    var c = b.height;
                    var d = b.width;
                    this.o = a;
                    var e = CalloutViewHelper.b(this.p, d, c, this.q);
                    this.t = e;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "n", {
            get: function () {
                return this.j.am;
            },
            set: function (a) {
                this.j.am = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "m", {
            get: function () {
                return this.r._stroke;
            },
            set: function (a) {
                this.r._stroke = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "l", {
            get: function () {
                return this.q._stroke;
            },
            set: function (a) {
                this.q._stroke = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "k", {
            get: function () {
                return this.r._fill;
            },
            set: function (a) {
                this.r._fill = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "c", {
            get: function () {
                return this.r.ac;
            },
            set: function (a) {
                this.r.ac = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "v", {
            get: function () {
                return this.u;
            },
            set: function (a) {
                this.u = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutView.prototype, "f", {
            get: function () {
                return this.j.ak;
            },
            set: function (a) {
                if (a == null) {
                    this.j.ak = "";
                }
                else {
                    this.j.ak = a.toString();
                }
                var b = this.s();
                var c = b.height;
                var d = b.width;
                var e = CalloutViewHelper.b(this.p, d, c, this.q);
                this.t = e;
            },
            enumerable: false,
            configurable: true
        });
        CalloutView.prototype.s = function () {
            var a = this.a.co(this.j);
            this.j.m = a.width;
            this.j.l = a.height;
            return new i2.Size(1, a.width + this.u.c + this.u.d, a.height + this.u.e + this.u.b);
        };
        CalloutView.prototype.i = function (a, b, c) {
            if (this.b == null) {
                this.b = new i2.DataContext();
            }
            this.b.series = a;
            this.b.item = c;
            if (b.c != null) {
                b.c.u = this.b;
            }
        };
        CalloutView.prototype.g = function (a, b, c) {
            a.a6.exportCalloutData(this.d, this.e, this.t.c, this.t.e, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
        };
        CalloutView.$t = i2.markType(CalloutView, 'CalloutView');
        return CalloutView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnnotationLayerProxy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnnotationLayerProxy, _super);
        function AnnotationLayerProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnnotationLayerProxy.prototype.matchesType = function (a) {
            if (!a.c6) {
                return false;
            }
            return true;
        };
        AnnotationLayerProxy.prototype.setCrosshairHorizontalLineVisibility = function (a, b) {
            a.s5 = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairVerticalLineVisibility = function (a, b) {
            a.s6 = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairHorizontalLineStroke = function (a, b) {
            a.sv = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairVerticalLineStroke = function (a, b) {
            a.sw = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairXAxisForeground = function (a, b) {
            a.sz = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairYAxisForeground = function (a, b) {
            a.s2 = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairXAxisBackground = function (a, b) {
            a.sx = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairYAxisBackground = function (a, b) {
            a.s0 = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairYAxisPrecision = function (a, b) {
            a.q8 = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairXAxisPrecision = function (a, b) {
            a.q7 = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairOnAxesEnabled = function (a, b) {
            a.qs = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairUseInterpolation = function (a, b) {
            a.qu = b;
        };
        AnnotationLayerProxy.prototype.setCrosshairThickness = function (a, b) {
            a.gm = b;
        };
        AnnotationLayerProxy.prototype.setFinalValuePrecision = function (a, b) {
            a.qy = b;
        };
        AnnotationLayerProxy.prototype.setFinalValueBackground = function (a, b) {
            a.rq = b;
        };
        AnnotationLayerProxy.prototype.setFinalValueForeground = function (a, b) {
            a.rs = b;
        };
        AnnotationLayerProxy.prototype.setContentMemberPath = function (a, b) {
            a.sm = b;
        };
        AnnotationLayerProxy.prototype.setLabelMemberPath = function (a, b) {
            a.sv = b;
        };
        AnnotationLayerProxy.prototype.setXMemberPath = function (a, b) {
            a.s4 = b;
        };
        AnnotationLayerProxy.prototype.setYMemberPath = function (a, b) {
            a.s7 = b;
        };
        AnnotationLayerProxy.prototype.setTargetSeries = function (a, b) {
            a.qs = b;
        };
        AnnotationLayerProxy.prototype.setCollisionChannel = function (a, b) {
            a.sj = b;
        };
        AnnotationLayerProxy.prototype.isCalloutLayer = function (a) {
            if (i2.typeCast(CalloutLayer.$, a) !== null) {
                return true;
            }
            return false;
        };
        AnnotationLayerProxy.prototype.addCalloutStyleUpdating = function (a, b) {
            var c = a;
            c.calloutStyleUpdating = i2.delegateCombine(c.calloutStyleUpdating, b);
        };
        AnnotationLayerProxy.prototype.removeCalloutStyleUpdating = function (a, b) {
            var c = a;
            c.calloutStyleUpdating = i2.delegateRemove(c.calloutStyleUpdating, b);
        };
        AnnotationLayerProxy.prototype.setCalloutStyleUpdatingEventEnabled = function (a, b) {
            a.ri = b;
        };
        AnnotationLayerProxy.$t = i2.markType(AnnotationLayerProxy, 'AnnotationLayerProxy', i2.Base.$, [IAnnotationLayerProxy_$type]);
        return AnnotationLayerProxy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAnnotationLayerProxyModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAnnotationLayerProxyModule() {
            i2.TypeRegistrar.register('AnnotationLayerProxy', AnnotationLayerProxy.$type);
        }
        IgxAnnotationLayerProxyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAnnotationLayerProxyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyModule, imports: [i1.CommonModule] });
        IgxAnnotationLayerProxyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyModule, imports: [[i1.CommonModule,
                ]] });
        return IgxAnnotationLayerProxyModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAnnotationLayerProxyDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAnnotationLayerProxyDynamicModule() {
            i2.TypeRegistrar.registerCons('AnnotationLayerProxy', AnnotationLayerProxy);
            i2.TypeRegistrar.register('AnnotationLayerProxy', AnnotationLayerProxy.$type);
        }
        IgxAnnotationLayerProxyDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAnnotationLayerProxyDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyDynamicModule, imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxAnnotationLayerProxyModule] });
        IgxAnnotationLayerProxyDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyDynamicModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule
                ], IgxAnnotationLayerProxyModule] });
        return IgxAnnotationLayerProxyDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerProxyDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxAnnotationLayerProxyModule
                        ],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available positions on the crossing axis at which the category tooltip can be displayed.
     */
    var CategoryTooltipLayerPosition = /*@__PURE__*/ (function (CategoryTooltipLayerPosition) {
        /**
         * A position is selected automatically
         */
        CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["Auto"] = 0] = "Auto";
        /**
         * Displays at the outside start of the axis.
         */
        CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["OutsideStart"] = 1] = "OutsideStart";
        /**
         * Displays at the inside start of the axis.
         */
        CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["InsideStart"] = 2] = "InsideStart";
        /**
         * Displays at the inside end of the axis.
         */
        CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["InsideEnd"] = 3] = "InsideEnd";
        /**
         * Displays at the outside end of the axis.
         */
        CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["OutsideEnd"] = 4] = "OutsideEnd";
        return CategoryTooltipLayerPosition;
    })({});
    /**
     * @hidden
     */
    var CategoryTooltipLayerPosition_$type = i2.markEnum('CategoryTooltipLayerPosition', 'Auto,0|OutsideStart,1|InsideStart,2|InsideEnd,3|OutsideEnd,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryToolTipLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryToolTipLayerFrame, _super);
        function CategoryToolTipLayerFrame() {
            var _this = _super.call(this) || this;
            _this.f = 0;
            _this.k = 0;
            _this.h = 0;
            _this.g = 0;
            _this.j = 0;
            _this.i = 0;
            _this.k = NaN;
            _this.l = NaN;
            _this.g = NaN;
            _this.h = NaN;
            _this.j = NaN;
            _this.i = NaN;
            return _this;
        }
        Object.defineProperty(CategoryToolTipLayerFrame.prototype, "l", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryToolTipLayerFrame.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            if (i2.isNaN_(d.k)) {
                this.k = e.k;
            }
            else {
                this.k = d.k + (e.k - d.k) * a;
            }
            if (i2.isNaN_(d.l)) {
                this.l = e.l;
            }
            else {
                this.l = d.l + (e.l - d.l) * a;
            }
            if (i2.isNaN_(d.g)) {
                this.g = e.g;
            }
            else {
                this.g = d.g + (e.g - d.g) * a;
            }
            if (i2.isNaN_(d.h)) {
                this.h = e.h;
            }
            else {
                this.h = d.h + (e.h - d.h) * a;
            }
            if (i2.isNaN_(d.j)) {
                this.j = e.j;
            }
            else {
                this.j = d.j + (e.j - d.j) * a;
            }
            if (i2.isNaN_(d.i)) {
                this.i = e.k;
            }
            else {
                this.i = d.i + (e.i - d.i) * a;
            }
        };
        CategoryToolTipLayerFrame.$t = i2.markType(CategoryToolTipLayerFrame, 'CategoryToolTipLayerFrame', Frame.$);
        return CategoryToolTipLayerFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryTooltipSeriesInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryTooltipSeriesInfo, _super);
        function CategoryTooltipSeriesInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.a = null;
            _this.b = null;
            return _this;
        }
        CategoryTooltipSeriesInfo.$t = i2.markType(CategoryTooltipSeriesInfo, 'CategoryTooltipSeriesInfo');
        return CategoryTooltipSeriesInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available positions to anchor the pointer to the PointerTooltip.
     */
    var PointerTooltipPointerLocation = /*@__PURE__*/ (function (PointerTooltipPointerLocation) {
        /**
         * The anchor is decided automatically.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["Auto"] = 0] = "Auto";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopLeft"] = 1] = "TopLeft";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopMiddle"] = 2] = "TopMiddle";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopRight"] = 3] = "TopRight";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightTop"] = 4] = "RightTop";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightMiddle"] = 5] = "RightMiddle";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightBottom"] = 6] = "RightBottom";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomRight"] = 7] = "BottomRight";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomMiddle"] = 8] = "BottomMiddle";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomLeft"] = 9] = "BottomLeft";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftBottom"] = 10] = "LeftBottom";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftMiddle"] = 11] = "LeftMiddle";
        /**
         * The anchor is top left of the content.
         */
        PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftTop"] = 12] = "LeftTop";
        return PointerTooltipPointerLocation;
    })({});
    /**
     * @hidden
     */
    var PointerTooltipPointerLocation_$type = i2.markEnum('PointerTooltipPointerLocation', 'Auto,0|TopLeft,1|TopMiddle,2|TopRight,3|RightTop,4|RightMiddle,5|RightBottom,6|BottomRight,7|BottomMiddle,8|BottomLeft,9|LeftBottom,10|LeftMiddle,11|LeftTop,12');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PointerTooltip = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointerTooltip, _super);
        function PointerTooltip() {
            var _this = _super.call(this) || this;
            _this.aq = null;
            _this.ai = null;
            _this.am = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.bw = null;
            _this.cq = null;
            _this.cr = null;
            _this.au = false;
            _this.cf = { $type: i2.Point_$type, x: NaN, y: NaN };
            _this.ak = 0;
            _this.aw = 0;
            _this.av = 0;
            _this.ao = null;
            _this.as = false;
            _this.ap = null;
            i2.DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
            _this.ab = PointerTooltip.$;
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.br(a, b.propertyName, b.oldValue, b.newValue); });
            _this.am = new PointerTooltipView(_this);
            return _this;
        }
        Object.defineProperty(PointerTooltip.prototype, "ar", {
            get: function () {
                if (this.aq == null) {
                    this.aq = new i2.SRProvider(this.am.j);
                }
                return this.aq;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PointerTooltip.prototype, "aj", {
            get: function () {
                var _this = this;
                if (this.ai == null) {
                    this.ai = i2.DVContainer.instance.createInstance(ISeriesVisualDataManager_$type, function () { return _this.ar.q; });
                }
                return this.ai;
            },
            enumerable: false,
            configurable: true
        });
        PointerTooltip.prototype.bt = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        PointerTooltip.prototype.br = function (a, b, c, d) {
            switch (b) {
                case PointerTooltip.$$p[15]:
                    this.bq();
                    break;
                case PointerTooltip.$$p[16]:
                    this.bq();
                    break;
            }
        };
        PointerTooltip.prototype.bn = function () {
            if (this.am.d(this.content)) {
                this.bq();
            }
        };
        PointerTooltip.prototype.bq = function () {
            this.au = true;
        };
        PointerTooltip.prototype.at = function (a, b) {
            if (Math.abs(a - b) < 1E-05) {
                return true;
            }
            return false;
        };
        PointerTooltip.prototype.cs = function (a) {
            this.au = false;
            var b = 0;
            var c = 0;
            var d = this.am.x(a);
            b = d.width;
            c = d.height;
            if (this.ak == this.al && this.at(this.cf.x, this.cn.x) && this.at(this.cf.y, this.cn.y)) {
                this.a0 = b;
                this.az = c;
                if (this.ct == 0) {
                    b += this.aw;
                    c += this.av;
                    this.ay = this.a0 + this.aw;
                    this.ax = this.az + this.av;
                }
                return new i2.Size(1, b, c);
            }
            var e = { $type: i2.Point_$type, x: 0, y: 0 };
            var f = { $type: i2.Point_$type, x: b * 0.5, y: 0 };
            var g = { $type: i2.Point_$type, x: b, y: 0 };
            var h = { $type: i2.Point_$type, x: b, y: c };
            var i = { $type: i2.Point_$type, x: b * 0.5, y: c };
            var j = { $type: i2.Point_$type, x: 0, y: c };
            var k = { $type: i2.Point_$type, x: 0, y: c * 0.5 };
            var l = { $type: i2.Point_$type, x: b, y: c * 0.5 };
            var m = b;
            var n = c;
            var o = b;
            var p = c;
            var q = { $type: i2.Point_$type, x: 0, y: 0 };
            var r = { $type: i2.Point_$type, x: 0, y: 0 };
            var s = { $type: i2.Point_$type, x: 0, y: 0 };
            var t = { $type: i2.Point_$type, x: 0, y: 0 };
            var u = this.a1;
            var v = this.a2;
            var w = this.al;
            var x = this.cn;
            var y = 0;
            var z = 0;
            var aa = Math.pow(e.x - x.x, 2) + Math.pow(e.y - x.y, 2);
            var ab = Math.pow(f.x - x.x, 2) + Math.pow(f.y - x.y, 2);
            var ac = Math.pow(g.x - x.x, 2) + Math.pow(g.y - x.y, 2);
            var ad = Math.pow(l.x - x.x, 2) + Math.pow(l.y - x.y, 2);
            var ae = Math.pow(h.x - x.x, 2) + Math.pow(h.y - x.y, 2);
            var af = Math.pow(i.x - x.x, 2) + Math.pow(i.y - x.y, 2);
            var ag = Math.pow(j.x - x.x, 2) + Math.pow(j.y - x.y, 2);
            var ah = Math.pow(k.x - x.x, 2) + Math.pow(k.y - x.y, 2);
            var ai = 1.7976931348623157E+308;
            ai = Math.min(ai, aa);
            ai = Math.min(ai, ab);
            ai = Math.min(ai, ac);
            ai = Math.min(ai, ad);
            ai = Math.min(ai, ae);
            ai = Math.min(ai, af);
            ai = Math.min(ai, ag);
            ai = Math.min(ai, ah);
            if (w == 0) {
                if (ai == aa) {
                    w = 12;
                    if (x.x >= e.x) {
                        w = 1;
                    }
                }
                if (ai == ah) {
                    w = 11;
                }
                if (ai == ag) {
                    w = 10;
                    if (x.x >= j.x) {
                        w = 9;
                    }
                }
                if (ai == ac) {
                    w = 4;
                    if (x.x <= g.x) {
                        w = 3;
                    }
                }
                if (ai == ad) {
                    w = 5;
                }
                if (ai == ae) {
                    w = 6;
                    if (x.x <= h.x) {
                        w = 7;
                    }
                }
                if (ai == ab) {
                    w = 2;
                }
                if (ai == af) {
                    w = 8;
                }
            }
            var aj = i2.DeviceUtils.g(3);
            switch (w) {
                case 1:
                    q = { $type: i2.Point_$type, x: e.x + u, y: e.y };
                    r = { $type: i2.Point_$type, x: e.x + u + v, y: e.y };
                    s = { $type: i2.Point_$type, x: e.x + u, y: e.y + aj };
                    t = { $type: i2.Point_$type, x: e.x + u + v, y: e.y + aj };
                    break;
                case 2:
                    q = { $type: i2.Point_$type, x: ((e.x + g.x) / 2) - (v / 2), y: e.y };
                    r = { $type: i2.Point_$type, x: ((e.x + g.x) / 2) + (v / 2), y: e.y };
                    s = { $type: i2.Point_$type, x: ((e.x + g.x) / 2) - (v / 2), y: e.y + aj };
                    t = { $type: i2.Point_$type, x: ((e.x + g.x) / 2) + (v / 2), y: e.y + aj };
                    break;
                case 3:
                    q = { $type: i2.Point_$type, x: g.x - u, y: e.y };
                    r = { $type: i2.Point_$type, x: (g.x - u) - v, y: e.y };
                    s = { $type: i2.Point_$type, x: g.x - u, y: e.y + aj };
                    t = { $type: i2.Point_$type, x: (g.x - u) - v, y: e.y + aj };
                    break;
                case 4:
                    q = { $type: i2.Point_$type, x: g.x, y: g.y + u };
                    r = { $type: i2.Point_$type, x: g.x, y: g.y + u + v };
                    s = { $type: i2.Point_$type, x: g.x - aj, y: g.y + u };
                    t = { $type: i2.Point_$type, x: g.x - aj, y: g.y + u + v };
                    break;
                case 5:
                    q = { $type: i2.Point_$type, x: g.x, y: ((g.y + h.y) / 2) - (v / 2) };
                    r = { $type: i2.Point_$type, x: g.x, y: ((g.y + h.y) / 2) + (v / 2) };
                    s = { $type: i2.Point_$type, x: g.x - aj, y: ((g.y + h.y) / 2) - (v / 2) };
                    t = { $type: i2.Point_$type, x: g.x - aj, y: ((g.y + h.y) / 2) + (v / 2) };
                    break;
                case 6:
                    q = { $type: i2.Point_$type, x: h.x, y: h.y - u };
                    r = { $type: i2.Point_$type, x: h.x, y: h.y - u - v };
                    s = { $type: i2.Point_$type, x: h.x - aj, y: h.y - u };
                    t = { $type: i2.Point_$type, x: h.x - aj, y: h.y - u - v };
                    break;
                case 7:
                    q = { $type: i2.Point_$type, x: h.x - u, y: h.y };
                    r = { $type: i2.Point_$type, x: (h.x - u) - v, y: h.y };
                    s = { $type: i2.Point_$type, x: h.x - u, y: h.y - aj };
                    t = { $type: i2.Point_$type, x: (h.x - u) - v, y: h.y - aj };
                    break;
                case 8:
                    q = { $type: i2.Point_$type, x: ((j.x + h.x) / 2) - (v / 2), y: h.y };
                    r = { $type: i2.Point_$type, x: ((j.x + h.x) / 2) + (v / 2), y: h.y };
                    s = { $type: i2.Point_$type, x: ((j.x + h.x) / 2) - (v / 2), y: h.y - aj };
                    t = { $type: i2.Point_$type, x: ((j.x + h.x) / 2) + (v / 2), y: h.y - aj };
                    break;
                case 9:
                    q = { $type: i2.Point_$type, x: j.x + u, y: j.y };
                    r = { $type: i2.Point_$type, x: j.x + u + v, y: j.y };
                    s = { $type: i2.Point_$type, x: j.x + u, y: j.y - aj };
                    t = { $type: i2.Point_$type, x: j.x + u + v, y: j.y - aj };
                    break;
                case 10:
                    q = { $type: i2.Point_$type, x: e.x, y: j.y - u };
                    r = { $type: i2.Point_$type, x: e.x, y: (j.y - u) - v };
                    s = { $type: i2.Point_$type, x: e.x + aj, y: j.y - u };
                    t = { $type: i2.Point_$type, x: e.x + aj, y: (j.y - u) - v };
                    break;
                case 11:
                    q = { $type: i2.Point_$type, x: e.x, y: ((e.y + j.y) / 2) - (v / 2) };
                    r = { $type: i2.Point_$type, x: e.x, y: ((e.y + j.y) / 2) + (v / 2) };
                    s = { $type: i2.Point_$type, x: e.x + aj, y: ((e.y + j.y) / 2) - (v / 2) };
                    t = { $type: i2.Point_$type, x: e.x + aj, y: ((e.y + j.y) / 2) + (v / 2) };
                    break;
                case 12:
                    q = { $type: i2.Point_$type, x: e.x, y: e.y + u };
                    r = { $type: i2.Point_$type, x: e.x, y: e.y + u + v };
                    s = { $type: i2.Point_$type, x: e.x + aj, y: e.y + u };
                    t = { $type: i2.Point_$type, x: e.x + aj, y: e.y + u + v };
                    break;
            }
            var ak = { $type: i2.Point_$type, x: x.x, y: x.y };
            if (ak.y < e.y) {
                var al = e.y - ak.y;
                ak = { $type: i2.Point_$type, x: ak.x, y: 0 };
                p += al;
                e = { $type: i2.Point_$type, x: e.x, y: e.y + al };
                g = { $type: i2.Point_$type, x: g.x, y: g.y + al };
                j = { $type: i2.Point_$type, x: j.x, y: j.y + al };
                h = { $type: i2.Point_$type, x: h.x, y: h.y + al };
                q = { $type: i2.Point_$type, x: q.x, y: q.y + al };
                r = { $type: i2.Point_$type, x: r.x, y: r.y + al };
                s = { $type: i2.Point_$type, x: s.x, y: s.y + al };
                t = { $type: i2.Point_$type, x: t.x, y: t.y + al };
            }
            else {
                p = Math.max(ak.y, n);
            }
            if (ak.x < e.x) {
                var am = e.x - ak.x;
                ak = { $type: i2.Point_$type, x: 0, y: ak.y };
                o += am;
                e = { $type: i2.Point_$type, x: e.x + am, y: e.y };
                g = { $type: i2.Point_$type, x: g.x + am, y: g.y };
                j = { $type: i2.Point_$type, x: j.x + am, y: j.y };
                h = { $type: i2.Point_$type, x: h.x + am, y: h.y };
                q = { $type: i2.Point_$type, x: q.x + am, y: q.y };
                r = { $type: i2.Point_$type, x: r.x + am, y: r.y };
                s = { $type: i2.Point_$type, x: s.x + am, y: s.y };
                t = { $type: i2.Point_$type, x: t.x + am, y: t.y };
            }
            else {
                o = Math.max(ak.x, m);
            }
            y = o - m;
            z = p - n;
            this.aw = y;
            this.av = z;
            this.ak = this.al;
            this.cf = this.cn;
            this.cm = ak;
            this.ck = q;
            this.cl = r;
            this.a0 = m;
            this.az = n;
            this.ay = o;
            this.ax = p;
            this.ci = e;
            this.cj = g;
            this.ch = h;
            this.cg = j;
            var an = new i2.PointCollection(0);
            an.add(t);
            an.add(this.cl);
            an.add(this.cm);
            an.add(this.ck);
            an.add(s);
            this.cp = an;
            if (this.cq != null) {
                this.cq.ak = an;
            }
            var ao = new i2.PointCollection(0);
            ao.add(this.cl);
            ao.add(this.cm);
            ao.add(this.ck);
            this.co = ao;
            if (this.cr != null) {
                this.cr.ak = ao;
            }
            if (this.ct == 1) {
                return new i2.Size(1, b, c);
            }
            return new i2.Size(1, o, p);
        };
        PointerTooltip.prototype.bo = function () {
            this.bv();
            this.am.r();
        };
        PointerTooltip.prototype.bp = function () {
            this._visibility = 1;
            this.am.s();
        };
        PointerTooltip.prototype.bu = function (a, b) {
            if (this.au) {
                this.cs(new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            }
            this.am.v(a, b);
        };
        PointerTooltip.prototype.bs = function (a) {
            this.am.u(a);
        };
        PointerTooltip.prototype.bm = function () {
            if (!this.as) {
                if (this.ao != null && this.am.l != null) {
                    this.as = true;
                    this.ao.aq(this.am.l, "pointerTooltip" + i2.Base.getHashCodeStatic(this));
                }
            }
        };
        PointerTooltip.prototype.bv = function () {
            if (this.as) {
                if (this.ao != null && this.am.l != null) {
                    this.as = false;
                    this.ao.bc(this.am.l, "pointerTooltip" + i2.Base.getHashCodeStatic(this));
                }
                this.ao = null;
            }
        };
        PointerTooltip.prototype.a3 = function () {
            if (this._visibility == 1) {
                return null;
            }
            return this.am.q();
        };
        PointerTooltip.$t = i2.markType(PointerTooltip, 'PointerTooltip', i2.ContentControl.$, [i2.INotifyPropertyChanged_$type]);
        PointerTooltip.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PointerTooltip, 'bt', ['ActualBoxBottomLeftPosition:cg:bx', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'ActualBoxBottomRightPosition:ch:by', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'ActualBoxFullHeight:ax:bz', [1, 0], 'ActualBoxFullWidth:ay:b0', [1, 0], 'ActualBoxHeight:az:b1', [1, 0], 'ActualBoxTopLeftPosition:ci:b2', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'ActualBoxTopRightPosition:cj:b3', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'ActualBoxWidth:a0:b4', [1, 0], 'ActualPointerFirstPosition:ck:b5', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'ActualPointerSecondPosition:cl:b6', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'ActualPointerStartPosition:cm:b7', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'PointerInset:a1:b8', [1, i2.DeviceUtils.g(7.5)], 'PointerLocation:al:b9', [PointerTooltipPointerLocation_$type, i2.enumGetBox(PointerTooltipPointerLocation_$type, 0)], 'PointerOutlinePoints:co:ca', [i2.PointCollection.$, null], 'PointerPoints:cp:cb', [i2.PointCollection.$, null], 'PointerPosition:cn:cc', [i2.Point_$type, { $type: i2.Point_$type, x: 0, y: 0 }], 'PointerVisibility:ct:cd', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'PointerWidth:a2:ce', [1, i2.DeviceUtils.g(5)]]);
        return PointerTooltip;
    }(i2.ContentControl));
    /**
     * @hidden
     */
    var PointerTooltipView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointerTooltipView, _super);
        function PointerTooltipView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.n = null;
            _this.p = null;
            _this.o = null;
            _this.l = null;
            _this.k = null;
            _this.b = null;
            _this.m = null;
            _this.w = null;
            _this.c = false;
            _this.i = 0;
            _this.h = 0;
            _this.g = -1;
            _this.e = -1;
            _this.f = 1;
            _this.j = null;
            _this.a = a;
            _this.a.cq = new i2.Polygon();
            _this.a.cr = new i2.Polyline();
            _this.l = null;
            _this.t();
            return _this;
        }
        PointerTooltipView.prototype.t = function () {
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != this.f) {
                this.f = window.devicePixelRatio;
            }
        };
        PointerTooltipView.prototype.x = function (a) {
            var b = this.a.content;
            b = b.clone();
            var c = new i2.Size(1, 0, 0);
            if (this.n == null) {
                this.n = this.j.createElement("div");
                this.n.addClass("ui-chart-pointer-tooltip-container");
                this.n.setStyleProperty("position", "absolute");
                this.n.setStyleProperty("visibility", "hidden");
                this.n.setStyleProperty("top", "0px");
                this.n.setStyleProperty("left", "0px");
                this.p = this.j.createElement("div");
                this.p.setStyleProperty("position", "relative");
                this.o = this.j.createElement("div");
                this.o.addClass("ui-chart-pointer-tooltip-content-container");
                this.o.setStyleProperty("position", "absolute");
                this.o.setStyleProperty("top", "0px");
                this.o.setStyleProperty("left", "0px");
                this.n.append(this.p);
                this.p.append(this.o);
            }
            this.n.remove();
            this.j.appendToBody(this.n);
            this.o.append(b);
            c = new i2.Size(1, this.o.outerWidthWithMargin(), this.o.outerHeightWithMargin());
            this.n.remove();
            b.remove();
            return c;
        };
        PointerTooltipView.prototype.v = function (a, b) {
            if (this.l == null) {
                this.l = this.j.createElement("div");
                this.l.addClass("ui-chart-pointer-tooltip-container");
                this.l.setStyleProperty("position", "absolute");
                this.l.setStyleProperty("top", "0px");
                this.l.setStyleProperty("left", "0px");
                var c = this.j.createElement("div");
                c.setStyleProperty("position", "relative");
                this.k = this.j.createElement("canvas");
                this.k.setStyleProperty("position", "absolute");
                this.k.setStyleProperty("top", "0px");
                this.k.setStyleProperty("left", "0px");
                this.m = this.j.createElement("div");
                this.m.addClass("ui-chart-pointer-tooltip-content-container");
                this.m.setStyleProperty("position", "absolute");
                this.m.setStyleProperty("top", "0px");
                this.m.setStyleProperty("left", "0px");
                c.append(this.k);
                c.append(this.m);
                this.l.append(c);
                this.b = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.j.get2DCanvasContext(this.k));
                this.l.hide();
                this.j.appendToBody(this.l);
            }
            this.a.bm();
            if (this.a._visibility == 1 && this.c) {
                this.l.hide();
                this.c = false;
                return;
            }
            var d = null;
            if (this.a.content != null) {
                d = this.a.content;
                d.remove();
            }
            this.m.removeChildren();
            if (d != null) {
                var cont_ = this.m;
                var xPos_ = this.a.ci.x.toString() + "px";
                var yPos_ = this.a.ci.y.toString() + "px";
                cont_.setRawStyleProperty("left", xPos_);
                cont_.setRawStyleProperty("top", yPos_);
                this.m.append(d);
            }
            var e = this.a.ap;
            var f = 1;
            this.t();
            if (e != null) {
                f = !i2.isNaN_(e.b) ? e.b : 1;
            }
            var g = i2.truncate(Math.ceil(this.a.ay + (f * 2)));
            var h = i2.truncate(Math.ceil(this.a.ax + (f * 2)));
            if (g != this.i || h != this.h) {
                this.k.setStyleProperty("width", g.toString() + "px");
                this.k.setStyleProperty("height", h.toString() + "px");
                this.k.setAttribute("width", (g * this.f).toString());
                this.k.setAttribute("height", (h * this.f).toString());
                this.i = g;
                this.h = h;
            }
            if (this.b.d && this.f != 1) {
                this.b.z();
                this.b.aa(this.f, this.f);
            }
            this.b.k(0, 0, this.i, this.h);
            var i = new i2.Rectangle();
            i.width = this.a.a0;
            i.height = this.a.az;
            i.n = this.a.ci.x;
            i.o = this.a.ci.y;
            if (e != null) {
                i._fill = e.c != null ? e.c : ((function () {
                    var $ret = new i2.Brush();
                    $ret.fill = "white";
                    return $ret;
                })());
                i._stroke = e.d != null ? e.d : ((function () {
                    var $ret = new i2.Brush();
                    $ret.fill = "black";
                    return $ret;
                })());
                i.ac = !i2.isNaN_(e.b) ? e.b : 1;
                i.am = !i2.isNaN_(e.a) ? e.a : 0;
                i.an = !i2.isNaN_(e.a) ? e.a : 0;
            }
            else {
                i._fill = ((function () {
                    var $ret = new i2.Brush();
                    $ret.fill = "white";
                    return $ret;
                })());
                i._stroke = ((function () {
                    var $ret = new i2.Brush();
                    $ret.fill = "black";
                    return $ret;
                })());
                i.ac = 1;
            }
            this.w = i;
            var j = this.a.cq;
            var k = this.a.cr;
            j._fill = i._fill;
            k._stroke = i._stroke;
            this.b.v(i);
            this.b.t(j);
            this.b.u(k);
            var x_ = a + "px";
            var y_ = b + "px";
            var container_ = this.l;
            container_.setRawStyleProperty("left", x_);
            container_.setRawStyleProperty("top", y_);
            if (this.a._visibility == 0 && !this.c) {
                this.l.show();
                this.c = true;
            }
            if (this.b.d && this.f != 1) {
                this.b.y();
            }
        };
        PointerTooltipView.prototype.q = function () {
            return this.a.aj.exportPointerTooltipData(this.a.cq, this.a.cr, this.w, new i2.Rect(0, 0, 0, this.a.ay, this.a.ax));
        };
        PointerTooltipView.prototype.d = function (a) {
            var b = this.g;
            var c = this.e;
            var d = this.x(new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            if (d.width != b || d.height != c) {
                return true;
            }
            return false;
        };
        PointerTooltipView.prototype.r = function () {
            this.j = null;
            this.l.hide();
            this.l.remove();
            this.l = null;
            this.n = null;
            this.p = null;
            this.o = null;
            this.l = null;
            this.k = null;
            this.m = null;
        };
        PointerTooltipView.prototype.s = function () {
            this.l.hide();
        };
        PointerTooltipView.prototype.u = function (a) {
            this.j = a;
        };
        PointerTooltipView.$t = i2.markType(PointerTooltipView, 'PointerTooltipView');
        return PointerTooltipView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryToolTipLayer, _super);
        function CategoryToolTipLayer() {
            var _this = _super.call(this) || this;
            var a = new CategoryToolTipLayerFrame();
            var b = new CategoryToolTipLayerFrame();
            var c = new CategoryToolTipLayerFrame();
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = CategoryToolTipLayer.$;
            return _this;
        }
        CategoryToolTipLayer.prototype.get_c5 = function () {
            return true;
        };
        CategoryToolTipLayer.prototype.bu = function () {
            return new CategoryToolTipLayerView(this);
        };
        CategoryToolTipLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qo = a;
        };
        CategoryToolTipLayer.prototype.get_de = function () {
            return true;
        };
        CategoryToolTipLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case CategoryToolTipLayer.$$p[0]:
                    this.l0(true);
                    break;
                case CategoryToolTipLayer.$$p[2]:
                    this.l0(true);
                    break;
                case CategoryToolTipLayer.$$p[1]:
                    this.l0(true);
                    break;
                case "SeriesViewer":
                    this.qo.cf();
                    break;
            }
        };
        CategoryToolTipLayer.prototype.p2 = function (a, b) {
            if (this.qm == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        CategoryToolTipLayer.prototype.p3 = function (a, b) {
            if (!this.as.c) {
                this.l0(b);
            }
        };
        CategoryToolTipLayer.prototype.p5 = function (a, b) {
            var e_1, _a, e_2, _b;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            var d = this.qq;
            c.l = NaN;
            c.k = NaN;
            c.g = NaN;
            c.h = NaN;
            c.k = NaN;
            c.l = NaN;
            if (i2.isNaN_(this.qj.x) && i2.isNaN_(this.qj.y)) {
                this.qo.cd(this.qo.ca());
                return;
            }
            if (this.qm != null) {
                var e = this.qm;
                if (e == null || !e.b6 || e.b4) {
                    return;
                }
                if (!e.ci()) {
                    return;
                }
                var f = e;
                var g = this.qp(f.c7, d);
                this.qv(g, c, d);
            }
            else {
                if (i2.typeCast(XamDataChart.$, this.ca) !== null) {
                    var h = this.ca;
                    var i = true;
                    var j = false;
                    var k = new i2.List$1(Series.$, 0);
                    try {
                        for (var _c = tslib.__values(i2.fromEnum(h.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var l = _d.value;
                            if (l.b6 && !l.b4) {
                                if (!l.ci()) {
                                    continue;
                                }
                                if (i) {
                                    i = false;
                                    j = l.cj;
                                }
                                else {
                                    if (l.cj != j) {
                                        continue;
                                    }
                                }
                                try {
                                    for (var _e = (e_2 = void 0, tslib.__values(i2.fromEnum(l.c7))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                        var m = _f.value;
                                        k.add(m);
                                    }
                                }
                                catch (e_2_1) {
                                    e_2 = { error: e_2_1 };
                                }
                                finally {
                                    try {
                                        if (_f && !_f.done && (_b = _e.return))
                                            _b.call(_e);
                                    }
                                    finally {
                                        if (e_2)
                                            throw e_2.error;
                                    }
                                }
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                    var n = this.qp(k, d);
                    this.qv(n, c, d);
                }
            }
        };
        CategoryToolTipLayer.prototype.qp = function (a, b) {
            var c = 1.7976931348623157E+308;
            var d = -1.7976931348623157E+308;
            var e = new i2.List$1(i2.DataContext.$, 0);
            var f = new i2.List$1(i2.Base.$, 0);
            var g = false;
            var h = true;
            for (var i = 0; i < a.count; i++) {
                var j = a.item(i);
                if (!j.di && !j.da) {
                    continue;
                }
                if (j.isStacked) {
                    continue;
                }
                var k = j;
                if (!k.categoryAxis.ci()) {
                    continue;
                }
                if (h) {
                    g = j.isVertical;
                }
                else {
                    if (g != j.isVertical) {
                        continue;
                    }
                }
                var l = this.py(j);
                if (!l.c) {
                    continue;
                }
                var m = j.o2(l.d, b, false);
                if (g) {
                    if (!i2.isNaN_(m.y)) {
                        c = Math.min(c, m.y);
                        d = Math.max(d, m.y);
                    }
                }
                else {
                    if (!i2.isNaN_(m.x)) {
                        c = Math.min(c, m.x);
                        d = Math.max(d, m.x);
                    }
                }
                var n = this.qr(j);
                if (n == null) {
                    continue;
                }
                var o = null;
                var p = j.hh(this.qj);
                if (j.df && p != null) {
                    o = j.au(p);
                }
                else {
                    o = new i2.DataContext();
                    o.item = p;
                    o.series = j;
                }
                e.add(o);
                f.add1(n);
            }
            var q = 0;
            var r = 0;
            if (g) {
                r = (c + d) / 2;
                q = this.pf.right;
                if (this.qn == 2 || this.qn == 1) {
                    q = this.pf.left;
                }
                if (r < 0 || r > this.pf.bottom) {
                    r = NaN;
                }
            }
            else {
                q = (c + d) / 2;
                r = this.pf.top;
                if (this.qn == 2 || this.qn == 1) {
                    r = this.pf.bottom;
                }
                if (q < 0 || q > this.pf.right) {
                    q = NaN;
                }
            }
            var s = new CategoryTooltipSeriesInfo();
            s.c = { $type: i2.Point_$type, x: q, y: r };
            s.a = e;
            s.b = f;
            return s;
        };
        CategoryToolTipLayer.prototype.kx = function () {
            this.qj = { $type: i2.Point_$type, x: NaN, y: NaN };
            this.bx.ap();
        };
        CategoryToolTipLayer.prototype.qv = function (a, b, c) {
            var d = a.c;
            var e = a.a;
            var f = a.b;
            d = this.qo.cg(d);
            var g = 0;
            var h = this.bx.bu;
            var i = this.qo.ca();
            this.qo.cc();
            var j = false;
            if (e.count == 0) {
                this.bx.ap();
                return;
            }
            var k = false;
            for (var l = 0; l < e.count; l++) {
                var m = e._inner[l].series;
                j = m.isVertical;
                var n = e._inner[l];
                var o = f._inner[l];
                if (this.qo.b7(m, o, n)) {
                    k = true;
                }
                g++;
            }
            if (!k) {
                this.qo.cd(i);
                return;
            }
            var p = this.qo.ch(i);
            var q = 0;
            var r = 0;
            var s = 0;
            var t = 0;
            var u = false;
            var v = false;
            var w = this.qn;
            if (w == 2 || w == 3) {
                v = true;
            }
            if (w == 2 || w == 1) {
                u = true;
            }
            var x = this.qo.ci();
            if (j) {
                if (!u && !v && d.x + (p.width + i2.DeviceUtils.g(10)) > x.width) {
                    v = true;
                }
                if (u && !v && d.x - (p.width + i2.DeviceUtils.g(10)) < 0) {
                    v = true;
                }
            }
            else {
                if (!u && !v && d.y - (p.height + 10) < 0) {
                    v = true;
                }
                if (u && !v && d.y + (p.height + 10) > x.height) {
                    v = true;
                }
            }
            var y = i2.DeviceUtils.g(10);
            var z = i2.DeviceUtils.g(5);
            if (!u) {
                if (!j) {
                    z = p.height + y;
                }
                if (v) {
                    if (j) {
                        z = z + p.width + y;
                    }
                    else {
                        z = 0;
                    }
                }
            }
            else {
                if (j) {
                    z = p.width + y;
                    if (v) {
                        z = 0;
                    }
                }
                else {
                    z = i2.DeviceUtils.g(5);
                    if (v) {
                        z = z + p.height + y;
                    }
                }
            }
            if (j) {
                r = 0 - (y + i2.DeviceUtils.g(5));
                if (u) {
                    r = (r * -1) + p.width;
                }
                q = p.height / 2;
                t = d.y - p.height / 2;
                s = d.x - z;
            }
            else {
                q = p.height + i2.DeviceUtils.g(10) + i2.DeviceUtils.g(5);
                if (u) {
                    q = 0 - (y + i2.DeviceUtils.g(5));
                }
                r = p.width / 2;
                s = d.x - p.width / 2;
                t = d.y - z;
            }
            if (j) {
                if (t < 0) {
                    q -= 0 - t;
                    t = 0;
                }
                if (t + p.height > x.height) {
                    q += (t + p.height) - x.height;
                    t = x.height - p.height;
                }
            }
            else {
                if (s < 0) {
                    r -= 0 - s;
                    s = 0;
                }
                if (s + p.width > x.width) {
                    r += (s + p.width) - x.width;
                    s = x.width - p.width;
                }
            }
            b.k = s;
            b.l = t;
            b.g = r;
            b.h = q;
            b.j = p.width;
            b.i = p.height;
        };
        CategoryToolTipLayer.prototype.qr = function (a) {
            return a.toolTip;
        };
        CategoryToolTipLayer.prototype.p8 = function (a, b) {
            _super.prototype.p8.call(this, a, b);
            var c = a;
            var d = b.bu.left;
            var e = b.bu.right;
            var f = b.bu.top;
            var g = b.bu.bottom;
            var h = this.qo.ca();
            if (i2.isNaN_(c.k) || i2.isNaN_(c.l) || i2.isNaN_(c.g) || i2.isNaN_(c.h)) {
                this.qo.cd(h);
                return;
            }
            var i = c.k;
            var j = c.l;
            var k = c.g;
            var l = c.h;
            this.qo.ce(h, i, j, k, l);
        };
        CategoryToolTipLayer.prototype.eg = function () {
            return true;
        };
        CategoryToolTipLayer.$t = i2.markType(CategoryToolTipLayer, 'CategoryToolTipLayer', AnnotationLayer.$);
        CategoryToolTipLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryToolTipLayer, 'raisePropertyChanged', ['TargetAxis:qm:qw', [Axis.$, null], 'ToolTipPosition:qn:qx', [CategoryTooltipLayerPosition_$type, i2.enumGetBox(CategoryTooltipLayerPosition_$type, 0)], 'UseInterpolation:qq:qy', [0, false]]);
        return CategoryToolTipLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var CategoryToolTipLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryToolTipLayerView, _super);
        function CategoryToolTipLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b5 = null;
            _this._tooltips = null;
            _this.b8 = null;
            _this.b6 = false;
            _this._htmlTest = null;
            _this.b4 = a;
            _this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
            return _this;
        }
        CategoryToolTipLayerView.prototype.ca = function () {
            if (this.b5 == null) {
                this.b5 = new PointerTooltip();
                this.b5.bs(this.e.gw);
                this.b5.ao = this.e.ca.cf.k;
                this._tooltips = this.e.gw.createElement("div");
                this.b8 = this.e.gw.createElement("div");
                this.b5._visibility = 0;
            }
            return this.b5;
        };
        CategoryToolTipLayerView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (this.b5 != null) {
                this.b5._visibility = 1;
            }
        };
        CategoryToolTipLayerView.prototype.aj = function () {
            _super.prototype.aj.call(this);
            if (this.b5 != null) {
                this.b5.bo();
                this.b5 = null;
            }
        };
        Object.defineProperty(CategoryToolTipLayerView.prototype, "htmlTest", {
            get: function () {
                return this._htmlTest;
            },
            set: function (a) {
                this._htmlTest = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryToolTipLayerView.prototype.b7 = function (a, b, c) {
            if (a.hr == "default") {
                a.hr = a.bx.getDefaultTooltipTemplate();
            }
            var template_ = a.hr;
            var context_ = c;
            if (a.toolTip == null) {
                return false;
            }
            var tooltip_ = a.toolTip;
            if ((tooltip_.updateToolTip)) {
                tooltip_._inPointer = true;
                tooltip_.updateToolTip(context_, true);
                tooltip_.setStyleProperty('position', 'relative');
                tooltip_.setStyleProperty('left', '');
                tooltip_.setStyleProperty('top', '');
                tooltip_.remove();
            }
            this._tooltips.append(a.toolTip);
            return true;
        };
        CategoryToolTipLayerView.prototype.ch = function (a) {
            var b = a;
            b.content = this._tooltips;
            var c = new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
            b.ct = 1;
            var d = b.cs(new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            b.ct = 0;
            return d;
        };
        CategoryToolTipLayerView.prototype.cg = function (a) {
            var b = 0;
            var c = 0;
            if (this.e.ca != null) {
                var d = this.e.ca.o9();
                b += d.x;
                c += d.y;
            }
            return { $type: i2.Point_$type, x: b + a.x, y: c + a.y };
        };
        CategoryToolTipLayerView.prototype.ce = function (a, b, c, d, e) {
            var f = a;
            var g = f.content;
            f.cn = { $type: i2.Point_$type, x: d, y: e };
            f._visibility = 0;
            f.n = b;
            f.o = c;
        };
        CategoryToolTipLayerView.prototype.ci = function () {
            var a = (window.innerWidth);
            var b = (window.innerHeight);
            return new i2.Size(1, a, b);
        };
        CategoryToolTipLayerView.prototype.cd = function (a) {
            this._tooltips.removeChildren();
            this.b8.removeChildren();
            this.b5._visibility = 1;
        };
        CategoryToolTipLayerView.prototype.cc = function () {
            if (this._tooltips != null) {
                this._tooltips.removeChildren();
            }
        };
        CategoryToolTipLayerView.prototype.cf = function () {
        };
        CategoryToolTipLayerView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (b) {
                return;
            }
            var c = null;
            if (this.e.ca != null) {
                c = this.e.ca.cf.j.i();
            }
            var d = 0;
            var e = 0;
            var f = this.e.ca;
            if (f != null) {
                var g = f.cf.j.b7();
                d += g.x;
                e += g.y;
            }
            if (this.b5 != null) {
                this.b5.ap = c;
                this.b5.bu(this.b5.n, this.b5.o);
            }
        };
        CategoryToolTipLayerView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            var b = this.b5;
            var c = 0;
            var d = 0;
            if (this.e.ca != null) {
                var e = this.e.ca.o9();
                c += e.x;
                d += e.y;
            }
            var f = b.a3();
            var g = b.n - c;
            var h = b.o - d;
            var i = new i2.List$1(i2.String_$type, 0);
            var j = this._tooltips.getChildCount();
            for (var k = 0; k < j; k++) {
                var indexliteral_ = k.toString();
                var l = this._tooltips.getChildAt(k).getText();
                var m = l.toString();
                i.add(m);
            }
            this.e.a6.addPointerTooltipData(a, f, g, h, i);
        };
        CategoryToolTipLayerView.$t = i2.markType(CategoryToolTipLayerView, 'CategoryToolTipLayerView', AnnotationLayerView.$);
        return CategoryToolTipLayerView;
    }(AnnotationLayerView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * EventArgs class for RenderRequested events.
    *
    * Use the `RenderRequested` class for RenderRequested events.
    */
    var IgxRenderRequestedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxRenderRequestedEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxRenderRequestedEventArgs.prototype.createImplementation = function () {
            return new RenderRequestedEventArgs();
        };
        Object.defineProperty(IgxRenderRequestedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxRenderRequestedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxRenderRequestedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxRenderRequestedEventArgs.prototype, "animate", {
            /**
             * True if animation is requested.
            *
            * Use the `animate` property true if the animation is requested.
            *
            * ```ts
            * e.animation = true;
            * ```
            */
            get: function () {
                return this.i.animate;
            },
            set: function (v) {
                this.i.animate = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxRenderRequestedEventArgs;
    }());

    /**
     * Provides data for Axis RangeChanged events.
    *
    * The `IgxAxisRangeChangedEventArgs` event fire when the axis range changes.
    */
    var IgxAxisRangeChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxAxisRangeChangedEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxAxisRangeChangedEventArgs.prototype.createImplementation = function () {
            return new AxisRangeChangedEventArgs(0);
        };
        Object.defineProperty(IgxAxisRangeChangedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisRangeChangedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxAxisRangeChangedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxAxisRangeChangedEventArgs.prototype, "oldMinimumValue", {
            /**
             * Gets the minimum value before the range changed. The reported minimum is the effective,
             * not the set value.
            *
            * The `oldMinimumValue` property is used to gets the minimum value before the range changed.
            */
            get: function () {
                return this.i.oldMinimumValue;
            },
            set: function (v) {
                this.i.oldMinimumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisRangeChangedEventArgs.prototype, "minimumValue", {
            /**
             * Gets the minimum value after the range changed. The reported minimum is the effective,
             * not the set value.
            *
            * The `minimumValue` property is used to getsthe minimum value after the range changed.
            *
            * ```ts
            *   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) :void {
            * 	let maxVal= e.maximumValue
            * 	let minVal= e.minimumValue
            *
            *     }
            * ```
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisRangeChangedEventArgs.prototype, "oldMaximumValue", {
            /**
             * Gets the maximum value before the range changed. The reported maximum is the effective,
             * not the set value.
            *
            * The `oldMaximumValue` property is used to gets the maximum value before the range changed.
            */
            get: function () {
                return this.i.oldMaximumValue;
            },
            set: function (v) {
                this.i.oldMaximumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisRangeChangedEventArgs.prototype, "maximumValue", {
            /**
             * Gets the maximum value after the range changed. The reported maximum is the effective,
             * not the set value.
            *
            * The `maximumValue` property is used to gets the maximum value after the range changed.
            *
            * ```ts
            *   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) :void {
            * 	let maxVal= e.maximumValue
            * 	let minVal= e.minimumValue
            *
            *     }
            * ```
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAxisRangeChangedEventArgs;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisAnnotation = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisAnnotation, _super);
        function AxisAnnotation() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.propertyChanged = null;
            _this.l = false;
            _this._formatLabel = null;
            _this.k = false;
            _this.j = null;
            return _this;
        }
        AxisAnnotation.prototype.resetCachedExtent = function () {
            this.l = true;
        };
        AxisAnnotation.prototype.checkForExtentReset = function (a) {
            if (this.l) {
                this.l = false;
                a();
            }
        };
        AxisAnnotation.prototype.ad = function (a, b, c) {
            this.ac(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        AxisAnnotation.prototype.ac = function (a, b, c) {
            this.k = true;
            switch (a) {
                case AxisAnnotation.$$p[5]:
                case AxisAnnotation.$$p[6]:
                    if (this.labelFormat != null) {
                        this.j = new i2.BindingFormatter();
                        this.j.j = this.labelFormat;
                        this.j.d = this.labelFormatSpecifiers;
                    }
                    else {
                        this.j = null;
                    }
                    break;
            }
        };
        AxisAnnotation.prototype.resolveLabelValue = function () {
            if (this.text != null) {
                return this.text;
            }
            if (this.formatLabel != null) {
                return this.formatLabel(this.value);
            }
            if (this.j != null) {
                return this.j.i(this.value);
            }
            if (this.value == null) {
                return null;
            }
            return this.value.toString();
        };
        Object.defineProperty(AxisAnnotation.prototype, "formatLabel", {
            get: function () {
                return this._formatLabel;
            },
            set: function (a) {
                this._formatLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisAnnotation.prototype, "backgroundPadding", {
            get: function () {
                return new i2.Thickness(1, this.backgroundPaddingLeft, this.backgroundPaddingTop, this.backgroundPaddingRight, this.backgroundPaddingBottom);
            },
            set: function (a) {
                this.backgroundPaddingLeft = a.c;
                this.backgroundPaddingTop = a.e;
                this.backgroundPaddingRight = a.d;
                this.backgroundPaddingBottom = a.b;
            },
            enumerable: false,
            configurable: true
        });
        AxisAnnotation.$t = i2.markType(AxisAnnotation, 'AxisAnnotation', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type, IAxisAnnotation_$type]);
        AxisAnnotation.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, AxisAnnotation, 'ad', ['BackgroundPaddingBottom', [1, NaN], 'BackgroundPaddingLeft', [1, NaN], 'BackgroundPaddingRight', [1, NaN], 'BackgroundPaddingTop', [1, NaN], 'Background', [i2.Brush.$, null], 'LabelFormat', [2, null], 'LabelFormatSpecifiers', [i2.Array_$type, null], 'Outline', [i2.Brush.$, null], 'StrokeThickness', [1, 0], 'TextColor', [i2.Brush.$, null], 'Text', [2, null], 'Value', [4, null]]);
        return AxisAnnotation;
    }(i2.DependencyObject));

    /**
     * Represents an axis annotation
    */
    var IgxAxisAnnotation = /** @class */ /*@__PURE__*/ (function () {
        function IgxAxisAnnotation() {
            this._zoneRunner = null;
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxAxisAnnotation.prototype.createImplementation = function () {
            return new AxisAnnotation();
        };
        Object.defineProperty(IgxAxisAnnotation.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisAnnotation.prototype.onImplementationCreated = function () {
        };
        IgxAxisAnnotation.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxAxisAnnotation.prototype, "value", {
            /**
             * Gets or sets the value at which this annotation is displayed on the axis.
            */
            get: function () {
                return this.i.value;
            },
            set: function (v) {
                this.i.value = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "text", {
            /**
             * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
            */
            get: function () {
                return this.i.text;
            },
            set: function (v) {
                this.i.text = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "labelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.labelFormat;
            },
            set: function (v) {
                this.i.labelFormat = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "labelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LabelFormat string.
            */
            get: function () {
                return this.i.labelFormatSpecifiers;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.labelFormatSpecifiers = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "formatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
            */
            get: function () {
                return this.i.formatLabel;
            },
            set: function (v) {
                this.i.formatLabel = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "textColor", {
            /**
             * Gets or sets the color to use for the text in the annotation.
            */
            get: function () {
                return i2.brushToString(this.i.textColor);
            },
            set: function (v) {
                this.i.textColor = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "background", {
            /**
             * Gets or sets the background to use for tha axis annotation box.
            */
            get: function () {
                return i2.brushToString(this.i.background);
            },
            set: function (v) {
                this.i.background = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "outline", {
            /**
             * Gets or sets the Outline to use for tha axis annotation box.
            */
            get: function () {
                return i2.brushToString(this.i.outline);
            },
            set: function (v) {
                this.i.outline = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "strokeThickness", {
            /**
             * Gets or sets the border stroke thickness to use for tha axis annotation box.
            */
            get: function () {
                return this.i.strokeThickness;
            },
            set: function (v) {
                this.i.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "backgroundPaddingLeft", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingLeft;
            },
            set: function (v) {
                this.i.backgroundPaddingLeft = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "backgroundPaddingTop", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingTop;
            },
            set: function (v) {
                this.i.backgroundPaddingTop = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "backgroundPaddingRight", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingRight;
            },
            set: function (v) {
                this.i.backgroundPaddingRight = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisAnnotation.prototype, "backgroundPaddingBottom", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingBottom;
            },
            set: function (v) {
                this.i.backgroundPaddingBottom = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisAnnotation.prototype.findByName = function (name) {
            if (this.labelFormatSpecifiers != null && i2.arrayFindByName(this.labelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.labelFormatSpecifiers, name);
            }
            return null;
        };
        IgxAxisAnnotation.prototype.resetCachedExtent = function () {
            this.i.resetCachedExtent();
        };
        IgxAxisAnnotation.prototype.resolveLabelValue = function () {
            var iv = this.i.resolveLabelValue();
            return (iv);
        };
        IgxAxisAnnotation.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        return IgxAxisAnnotation;
    }());

    var IgxAxisAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAxisAnnotationCollection, _super);
        function IgxAxisAnnotationCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxAxisAnnotation.$type) {
                IgxAxisAnnotation.$type = i2.markType(IgxAxisAnnotation, "AxisAnnotation");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxAxisAnnotationCollection.prototype._createInnerColl = function () {
            if (!IgxAxisAnnotation.$type) {
                IgxAxisAnnotation.$type = i2.markType(IgxAxisAnnotation, "AxisAnnotation");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxAxisAnnotation.$type, IAxisAnnotation_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxAxisAnnotation();
                    ext._implementation = int;
                }
                return ext;
            };
            return coll;
        };
        return IgxAxisAnnotationCollection;
    }(i2.IgCollection));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Represents the base class from which all axis types are derived.
    *
    * The `IgxAxisComponent` is an array of axis objects.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    var IgxAxisComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxAxisComponent() {
            this._renderer = null;
            this._annotations = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._rangeChanged = null;
            this._renderRequested = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        Object.defineProperty(IgxAxisComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxAxisComponent.prototype, "axisInternal", {
            get: function () {
                return this.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxAxisComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxAxisComponent.prototype, "name", {
            get: function () {
                //console.log("getting axis anme: " + this.i.name)
                return this.i.name;
            },
            set: function (value) {
                //console.log("setting axis name: " + value);
                this.i.name = value;
                //console.log("checking axis anme: " + this.i.name)
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.provideData = function (data) {
        };
        IgxAxisComponent.prototype._provideRenderer = function (renderer) {
            this._renderer = renderer;
            this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
        };
        IgxAxisComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxAxisComponent.prototype, "isCategory", {
            /**
         * Gets or sets if the current axis is of category axis type
        */
            get: function () {
                return this.i.b6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isNumeric", {
            /**
             * Gets or sets if the current axis is of numeric axis type
            *
            *     Gets or sets if the current axis is of numeric axis type
            */
            get: function () {
                return this.i.ce;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isAngular", {
            /**
             * Gets if the current axis is of angular axis type
            */
            get: function () {
                return this.i.b4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isRadial", {
            /**
             * Gets or sets if the current axis is of radial axis type
            */
            get: function () {
                return this.i.cg;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isVertical", {
            /**
             * Gets if the current axis is a vertical axis.
            */
            get: function () {
                return this.i.cj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isSorting", {
            /**
             * Gets or sets if the current axis is sorting data items
            */
            get: function () {
                return this.i.ch;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isDateTime", {
            /**
             * Gets or sets if the current axis is of date time axis type
            */
            get: function () {
                return this.i.b9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isPiecewise", {
            /**
             * Gets or sets if the axis is a piecewise scaling function.
            */
            get: function () {
                return this.i.cf;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isCategoryDateTime", {
            /**
             * Gets if the current axis is of category date time axis type
            */
            get: function () {
                return this.i.b7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isContinuous", {
            /**
             * Gets if the current axis is a continuous rather than a discrete scale
            */
            get: function () {
                return this.i.b8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "formatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
            *
            * The `formatLabel` function takes an object that produces a formatted label for displaying in the chart.
            *
            * ```html
            * <igx-data-chart [dataSource]="data" >
            *     <igx-category-x-axis
            * 		name="xAxis"
            * 		FormatLabel="xAxis_FormatLabel" />
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.at;
            },
            set: function (v) {
                this.i.at = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "title", {
            /**
             * Gets or sets the Title property.
            *
            * Use `title` property to display the title of the component.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.gp;
            },
            set: function (v) {
                this.i.gp = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "stroke", {
            /**
             * Gets or sets the Stroke property.
             * Null is treated as auto. The axis stroke will be displayed or not based on the axis type and series used with it.
            *
            * Use `stroke` property to set the stroke of the chart.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		stroke="blue"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.je);
            },
            set: function (v) {
                this.i.je = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "actualStroke", {
            /**
             * Gets or sets the effective stroke used for the axis.
            */
            get: function () {
                return i2.brushToString(this.i.ja);
            },
            set: function (v) {
                this.i.ja = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "strokeThickness", {
            /**
             * Gets or sets the StrokeThickness property.
            *
            * Use `strokeThickness` property for the thickness of the stroke.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		strokeThickness= 5
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.ez;
            },
            set: function (v) {
                this.i.ez = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "strip", {
            /**
             * Gets or sets the Strip property.
            *
            * Use `strip` property to set the strip of the chart.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		 strip= "grey"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.jd);
            },
            set: function (v) {
                this.i.jd = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "majorStroke", {
            /**
             * Gets or sets the MajorStroke property.
             * Null is treated as auto. Major lines will be displayed or not based on the axis type and series used with it.
            *
            * Gets or sets the `majorStroke` using this property.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 	   majorStroke="black"
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.jb);
            },
            set: function (v) {
                this.i.jb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "actualMajorStroke", {
            /**
             * Gets or sets the ActualMajorStroke property.
            *
            * The `actualMajorStroke` property is used for ActualMajorStroke of the axis.
            */
            get: function () {
                return i2.brushToString(this.i.i8);
            },
            set: function (v) {
                this.i.i8 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "majorStrokeThickness", {
            /**
             * Gets or sets the MajorStrokeThickness property.
            *
            * Gets or sets the `majorStrokeThickness` using this property.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 	  majorStrokeThickness="1"
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.ef;
            },
            set: function (v) {
                this.i.ef = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "minorStroke", {
            /**
             * Gets or sets the MinorStroke property.
            *
            * Gets or sets the minorStroke thickness using `minorStrokeThickness` property.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 	 minorStrokeThickness="1"
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.jc);
            },
            set: function (v) {
                this.i.jc = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "actualMinorStroke", {
            /**
             * Gets or sets the ActualMinorStroke property.
            *
            * The `actualMinorStroke` property is used for ActualMinorStroke of the axis.
            */
            get: function () {
                return i2.brushToString(this.i.i9);
            },
            set: function (v) {
                this.i.i9 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "minorStrokeThickness", {
            /**
             * Gets or sets the MinorStrokeThickness property.
            */
            get: function () {
                return this.i.ei;
            },
            set: function (v) {
                this.i.ei = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "tickStroke", {
            /**
             * Gets or sets the TickStroke property.
            *
            * Use `tickStroke` property for the color of the tickmarks.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		tickStroke="black"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.jf);
            },
            set: function (v) {
                this.i.jf = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "tickStrokeThickness", {
            /**
             * Gets or sets the TickStrokeThickness property.
            *
            * Use `tickStrokeThickness` property for thickness of the stroke tickmarks.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		tickStrokeThicknes="2"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.e1;
            },
            set: function (v) {
                this.i.e1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "tickLength", {
            /**
             * Gets or sets the TickLength property.
            *
            * Use `tickLength` property for The length of the tickmarks to display for this axis.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		tickLength="5"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.e0;
            },
            set: function (v) {
                this.i.e0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isDisabled", {
            /**
             * Gets or sets the IsDisabled property. If true, the axis will not be rendered.
            *
            * The `isDisabled` property is used to decide if the axis will not be rendered.
            */
            get: function () {
                return this.i.ca;
            },
            set: function (v) {
                this.i.ca = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "isInverted", {
            /**
             * Gets or sets the IsInverted property.
            *
            * Gets or sets the `isInverted` property.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		isInverted= true
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.cc;
            },
            set: function (v) {
                this.i.cc = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "shouldAvoidAnnotationCollisions", {
            /**
             * Gets or sets whether annotations should be shifted to avoid collision, even if this would result in them appearing where they shouldn't be along the scale.
            */
            get: function () {
                return this.i.co;
            },
            set: function (v) {
                this.i.co = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "shouldKeepAnnotationsInView", {
            /**
             * ets or sets whether annotations should be kept in view, even if they aren't positioned where they should appear on the scale.
            */
            get: function () {
                return this.i.cq;
            },
            set: function (v) {
                this.i.cq = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "useEnhancedIntervalManagement", {
            /**
             * Gets or sets whether to use more advanced heuristics when determining the initial number of labels to render, before resolving collisions, etc.
            *
            * Use `useEnhancedIntervalManagement` property to gets/sets whether to use more advanced heuristics when determining the initial number of labels to render,
            * before resolving collisions, etc.
            */
            get: function () {
                return this.i.cy;
            },
            set: function (v) {
                this.i.cy = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "enhancedIntervalMinimumCharacters", {
            /**
             * Gets or sets the minimum desired characters to be displayed for horizontal axes when using advanced label heuristics. -1 will attempt to adjust the interval to precisely fit the horizontal labels.
            *
            * The `enhancedIntervalMinimumCharacters` property is used to set the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		enhancedIntervalMinimumCharacters=5
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.e9;
            },
            set: function (v) {
                this.i.e9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "enhancedIntervalPreferMoreCategoryLabels", {
            /**
             * Gets or sets whether the enhanced interval management should prefer to show all the labels if possible without collisions for supported types of category axes. This is for use with EnhancedIntervalMinimumCharacters = -1 and axes that have an integral interval.
            */
            get: function () {
                return this.i.by;
            },
            set: function (v) {
                this.i.by = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelTextStyle", {
            /**
             * Gets or sets the text style to use for axis labels.
            *
            * The `labelTextStyle` property Overrides the style of the text used for the axis labels.
            */
            get: function () {
                return this.i.ay ? this.i.ay.textStyle : null;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.textStyle = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelTextColor", {
            /**
             * The color of the {0}.
            *
            * The `labelTextColor` property Overrides the color of the text used for the axis labels.
            */
            get: function () {
                return i2.brushToString(this.i.ay ? this.i.ay.textColor : null);
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.textColor = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelLocation", {
            /**
             * Gets or sets the location of the {0}.
            *
            * The `Location` property is used for the location.
            */
            get: function () {
                return this.i.ay ? this.i.ay.location : 0;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.location = i2.ensureEnum(AxisLabelsLocation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelVisibility", {
            /**
             * Gets or sets the visibility of the {0}.
            *
            * The `Visibility` property is used for the visibility of the axis.
            */
            get: function () {
                return this.i.ay ? this.i.ay.visibility : 0;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.visibility = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelShowFirstLabel", {
            /**
             * Gets or sets whether the first label is displayed when the zoom level is set to 1.
            *
            * The `ShowFirstLabel` is used to check whether the first label is displayed when the zoom level is set to 1.
            */
            get: function () {
                return this.i.ay ? this.i.ay.showFirstLabel : false;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.showFirstLabel = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelAngle", {
            /**
             * Gets or sets the angle of the {0}.
            *
            * The `Angle` property is used to set the angle of the axis.
            */
            get: function () {
                return this.i.ay ? this.i.ay.angle : NaN;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.angle = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelExtent", {
            /**
             * Distance between the axis and the edge of the control.
            *
            * The `Extent` property is used for the extent.
            */
            get: function () {
                return this.i.ay ? this.i.ay.extent : NaN;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.extent = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelLeftMargin", {
            /**
             * Margin applied to the left of the {0}.
            *
            * The `labelLeftMargin` property is used for the left margin of the labels.
            */
            get: function () {
                return this.i.ay ? this.i.ay.leftMargin : NaN;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.leftMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelRightMargin", {
            /**
             * Margin applied to the right of the {0}.
            *
            * The `labelRightMargin` property is used for the right margin of the labels.
            */
            get: function () {
                return this.i.ay ? this.i.ay.rightMargin : NaN;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.rightMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelTopMargin", {
            /**
             * Margin applied above the {0}.
            *
            * The `labelTopMargin` property is used for the top margin of the labels.
            */
            get: function () {
                return this.i.ay ? this.i.ay.topMargin : NaN;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.topMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelBottomMargin", {
            /**
             * Margin applied below the {0}.
            *
            * The `labelBottomMargin` is used to set the bottom margin of the labels.
            */
            get: function () {
                return this.i.ay ? this.i.ay.bottomMargin : NaN;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.bottomMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelHorizontalAlignment", {
            /**
             * Gets or sets the horizontal alignment of the {0}.
            *
            * The `HorizontalAlignment` property is used for the horizontal alignment.
            */
            get: function () {
                return this.i.ay ? this.i.ay.horizontalAlignment : 0;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.horizontalAlignment = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelVerticalAlignment", {
            /**
             * Gets or sets the vertical alignment of the {0}.
            *
            * The `VerticalAlignment` property is used for the vertical alignment of the axis.
            */
            get: function () {
                return this.i.ay ? this.i.ay.verticalAlignment : 0;
            },
            set: function (v) {
                this.ensureLabelSettings();
                this.i.ay.verticalAlignment = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.ensureLabelSettings = function () {
            if (this.i.ay) {
                return;
            }
            this.i.ay = new AxisLabelSettings();
            this.i.ay.location = this.i.az();
            this.i.ay.angle = this.i.dw();
            this.i.ay.leftMargin = this.i.dy();
            this.i.ay.rightMargin = this.i.dz();
            this.i.ay.topMargin = this.i.d0();
            this.i.ay.bottomMargin = this.i.dx();
            this.i.ay.horizontalAlignment = this.i.i6();
            this.i.ay.verticalAlignment = this.i.jz();
        };
        Object.defineProperty(IgxAxisComponent.prototype, "crossingAxis", {
            /**
             * Gets or sets the CrossingAxis property.
            *
            * The `crossingAxis` property is used for CrossingAxis .
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		crossingAxis= "xAxis"
            * 		crossingValue= 700
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                if (this.i.ai == null) {
                    return null;
                }
                if (!this.i.ai.externalObject) {
                    var e = IgxAxisComponent._createFromInternal(this.i.ai);
                    if (e) {
                        e._implementation = this.i.ai;
                    }
                    this.i.ai.externalObject = e;
                }
                return this.i.ai.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.ai = null : this.i.ai = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "crossingValue", {
            /**
             * Gets or sets the CrossingValue property.
            *
            * The `crossingValue` property is used for CrossingValue of the axis.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		crossingAxis= "xAxis"
            * 		crossingValue= 700
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.fe;
            },
            set: function (v) {
                this.i.fe = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titlePosition", {
            /**
             * Gets or sets the title position relative to the axis labels.
            */
            get: function () {
                return this.i.be ? this.i.be.position : 0;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.position = i2.ensureEnum(AxisTitlePosition_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleTextStyle", {
            /**
             * Gets or sets the text style to use for axis labels.
            *
            * The `labelTextStyle` property Overrides the style of the text used for the axis labels.
            */
            get: function () {
                return this.i.be ? this.i.be.textStyle : null;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.textStyle = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleTextColor", {
            /**
             * The color of the {0}.
            *
            * The `labelTextColor` property Overrides the color of the text used for the axis labels.
            */
            get: function () {
                return i2.brushToString(this.i.be ? this.i.be.textColor : null);
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.textColor = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleLocation", {
            /**
             * Gets or sets the location of the {0}.
            *
            * The `Location` property is used for the location.
            */
            get: function () {
                return this.i.be ? this.i.be.location : 0;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.location = i2.ensureEnum(AxisLabelsLocation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleVisibility", {
            /**
             * Gets or sets the visibility of the {0}.
            *
            * The `Visibility` property is used for the visibility of the axis.
            */
            get: function () {
                return this.i.be ? this.i.be.visibility : 0;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.visibility = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleShowFirstLabel", {
            /**
             * Gets or sets whether the first label is displayed when the zoom level is set to 1.
            *
            * The `ShowFirstLabel` is used to check whether the first label is displayed when the zoom level is set to 1.
            */
            get: function () {
                return this.i.be ? this.i.be.showFirstLabel : false;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.showFirstLabel = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleAngle", {
            /**
             * Gets or sets the angle of the {0}.
            *
            * The `Angle` property is used to set the angle of the axis.
            */
            get: function () {
                return this.i.be ? this.i.be.angle : NaN;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.angle = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleExtent", {
            /**
             * Distance between the axis and the edge of the control.
            *
            * The `Extent` property is used for the extent.
            */
            get: function () {
                return this.i.be ? this.i.be.extent : NaN;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.extent = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleLeftMargin", {
            /**
             * Margin applied to the left of the {0}.
            *
            * The `labelLeftMargin` property is used for the left margin of the labels.
            */
            get: function () {
                return this.i.be ? this.i.be.leftMargin : NaN;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.leftMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleRightMargin", {
            /**
             * Margin applied to the right of the {0}.
            *
            * The `labelRightMargin` property is used for the right margin of the labels.
            */
            get: function () {
                return this.i.be ? this.i.be.rightMargin : NaN;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.rightMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleTopMargin", {
            /**
             * Margin applied above the {0}.
            *
            * The `labelTopMargin` property is used for the top margin of the labels.
            */
            get: function () {
                return this.i.be ? this.i.be.topMargin : NaN;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.topMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleBottomMargin", {
            /**
             * Margin applied below the {0}.
            *
            * The `labelBottomMargin` is used to set the bottom margin of the labels.
            */
            get: function () {
                return this.i.be ? this.i.be.bottomMargin : NaN;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.bottomMargin = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleHorizontalAlignment", {
            /**
             * Gets or sets the horizontal alignment of the {0}.
            *
            * The `HorizontalAlignment` property is used for the horizontal alignment.
            */
            get: function () {
                return this.i.be ? this.i.be.horizontalAlignment : 0;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.horizontalAlignment = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "titleVerticalAlignment", {
            /**
             * Gets or sets the vertical alignment of the {0}.
            *
            * The `VerticalAlignment` property is used for the vertical alignment of the axis.
            */
            get: function () {
                return this.i.be ? this.i.be.verticalAlignment : 0;
            },
            set: function (v) {
                this.ensureTitleSettings();
                this.i.be.verticalAlignment = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.ensureTitleSettings = function () {
            if (this.i.be) {
                return;
            }
            this.i.be = new TitleSettings();
            this.i.be.location = this.i.a0();
            this.i.be.angle = this.i.d1();
            this.i.be.leftMargin = this.i.d3();
            this.i.be.rightMargin = this.i.d4();
            this.i.be.topMargin = this.i.d5();
            this.i.be.bottomMargin = this.i.d2();
            this.i.be.horizontalAlignment = this.i.i7();
            this.i.be.verticalAlignment = this.i.j0();
        };
        Object.defineProperty(IgxAxisComponent.prototype, "annotations", {
            /**
             * Gets the current annotations for the axis.
            */
            get: function () {
                if (this._annotations === null) {
                    var coll = new IgxAxisAnnotationCollection();
                    var innerColl = this.i.am;
                    if (!innerColl) {
                        innerColl = new AxisAnnotationCollection();
                    }
                    this._annotations = coll._fromInner(innerColl);
                }
                return this._annotations;
            },
            set: function (v) {
                if (this._annotations !== null) {
                    this._annotations._setSyncTarget(null);
                    this._annotations = null;
                }
                var coll = new IgxAxisAnnotationCollection();
                this._annotations = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(IAxisAnnotation_$type);
                var innerColl = this.i.am;
                if (!innerColl) {
                    innerColl = new AxisAnnotationCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._annotations._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "coercionMethods", {
            /**
             * Gets or sets the coercion methods to use when loading data from data sources.
             * Should be specified before setting any member paths, if being used. Setting it later
             * will not cause data to be re-imported into the chart.
            *
            * The	`coercionMethods` methods is to use when loading data from data sources. Should be specified before setting any member paths, if being used.
            * Setting it later will not cause data to be reimported into the chart.
            */
            get: function () {
                return this.i.coercionMethods;
            },
            set: function (v) {
                this.i.coercionMethods = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "expectFunctions", {
            /**
             * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
             * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
             * This value must be set before assigning an item's source to take effect.
            */
            get: function () {
                return this.i.expectFunctions;
            },
            set: function (v) {
                this.i.expectFunctions = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "label", {
            /**
             * Gets or sets the axis label format string.
            *
            * The `label` property is used for label mapping of the axis labels.
            */
            get: function () {
                return this.i.fj;
            },
            set: function (v) {
                this.i.fj = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.fz;
            },
            set: function (v) {
                this.i.fz = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "labelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LabelFormat string.
            */
            get: function () {
                return this.i.ag;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ag = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.findByName = function (name) {
            if (this.crossingAxis && this.crossingAxis.name && this.crossingAxis.name == name) {
                return this.crossingAxis;
            }
            if (this.annotations != null && this.annotations.findByName && this.annotations.findByName(name)) {
                return this.annotations.findByName(name);
            }
            if (this.labelFormatSpecifiers != null && i2.arrayFindByName(this.labelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.labelFormatSpecifiers, name);
            }
            return null;
        };
        Object.defineProperty(IgxAxisComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxAxisComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("AxisComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this.crossingAxis && this.crossingAxis._styling) {
                this.crossingAxis._styling(container, component, this);
            }
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Renders the axis with no animation.

    */
        IgxAxisComponent.prototype.renderAxis = function () {
            this.i.hp();
        };
        /**
         * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
        
        */
        IgxAxisComponent.prototype.resetCachedEnhancedInterval = function () {
            this.i.hs();
        };
        IgxAxisComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.fg(item, memberPathName);
            return (iv);
        };
        /**
         * Gets the label for a data item.
        
        * @param value  * The unscaled value to get a label for.
        */
        IgxAxisComponent.prototype.getValueLabel = function (value) {
            var iv = this.i.fw(value);
            return (iv);
        };
        /**
         * Scales a value from axis space into screen space.
        
        * @param unscaledValue  * The unscaled axis value to scale.
        */
        IgxAxisComponent.prototype.scaleValue = function (unscaledValue) {
            var iv = this.i.en(unscaledValue);
            return (iv);
        };
        Object.defineProperty(IgxAxisComponent.prototype, "rangeChanged", {
            /**
             * Occurs when the axis range changes.
            */
            get: function () {
                var _this = this;
                if (this._rangeChanged == null) {
                    this._rangeChanged = new i0.EventEmitter();
                    this.i.rangeChanged = i2.delegateCombine(this.i.rangeChanged, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxAxisRangeChangedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeRangeChanged) {
                                _this.beforeRangeChanged(_this, outerArgs);
                            }
                            _this._rangeChanged.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._rangeChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAxisComponent.prototype, "renderRequested", {
            /**
             * This event is raised every time a render has been requested from a series.
            */
            get: function () {
                var _this = this;
                if (this._renderRequested == null) {
                    this._renderRequested = new i0.EventEmitter();
                    this.i.renderRequested = i2.delegateCombine(this.i.renderRequested, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxRenderRequestedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeRenderRequested) {
                                _this.beforeRenderRequested(_this, outerArgs);
                            }
                            _this._renderRequested.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._renderRequested;
            },
            enumerable: false,
            configurable: true
        });
        IgxAxisComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAxisComponent, selector: "ng-component", inputs: { name: "name", formatLabel: "formatLabel", title: "title", stroke: "stroke", actualStroke: "actualStroke", strokeThickness: "strokeThickness", strip: "strip", majorStroke: "majorStroke", actualMajorStroke: "actualMajorStroke", majorStrokeThickness: "majorStrokeThickness", minorStroke: "minorStroke", actualMinorStroke: "actualMinorStroke", minorStrokeThickness: "minorStrokeThickness", tickStroke: "tickStroke", tickStrokeThickness: "tickStrokeThickness", tickLength: "tickLength", isDisabled: "isDisabled", isInverted: "isInverted", shouldAvoidAnnotationCollisions: "shouldAvoidAnnotationCollisions", shouldKeepAnnotationsInView: "shouldKeepAnnotationsInView", useEnhancedIntervalManagement: "useEnhancedIntervalManagement", enhancedIntervalMinimumCharacters: "enhancedIntervalMinimumCharacters", enhancedIntervalPreferMoreCategoryLabels: "enhancedIntervalPreferMoreCategoryLabels", labelTextStyle: "labelTextStyle", labelTextColor: "labelTextColor", labelLocation: "labelLocation", labelVisibility: "labelVisibility", labelShowFirstLabel: "labelShowFirstLabel", labelAngle: "labelAngle", labelExtent: "labelExtent", labelLeftMargin: "labelLeftMargin", labelRightMargin: "labelRightMargin", labelTopMargin: "labelTopMargin", labelBottomMargin: "labelBottomMargin", labelHorizontalAlignment: "labelHorizontalAlignment", labelVerticalAlignment: "labelVerticalAlignment", crossingAxis: "crossingAxis", crossingValue: "crossingValue", titlePosition: "titlePosition", titleTextStyle: "titleTextStyle", titleTextColor: "titleTextColor", titleLocation: "titleLocation", titleVisibility: "titleVisibility", titleShowFirstLabel: "titleShowFirstLabel", titleAngle: "titleAngle", titleExtent: "titleExtent", titleLeftMargin: "titleLeftMargin", titleRightMargin: "titleRightMargin", titleTopMargin: "titleTopMargin", titleBottomMargin: "titleBottomMargin", titleHorizontalAlignment: "titleHorizontalAlignment", titleVerticalAlignment: "titleVerticalAlignment", annotations: "annotations", coercionMethods: "coercionMethods", expectFunctions: "expectFunctions", label: "label", labelFormat: "labelFormat", labelFormatSpecifiers: "labelFormatSpecifiers" }, outputs: { rangeChanged: "rangeChanged", renderRequested: "renderRequested" }, ngImport: i0, template: "", isInline: true });
        return IgxAxisComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { name: [{
                    type: i0.Input
                }], formatLabel: [{
                    type: i0.Input
                }], title: [{
                    type: i0.Input
                }], stroke: [{
                    type: i0.Input
                }], actualStroke: [{
                    type: i0.Input
                }], strokeThickness: [{
                    type: i0.Input
                }], strip: [{
                    type: i0.Input
                }], majorStroke: [{
                    type: i0.Input
                }], actualMajorStroke: [{
                    type: i0.Input
                }], majorStrokeThickness: [{
                    type: i0.Input
                }], minorStroke: [{
                    type: i0.Input
                }], actualMinorStroke: [{
                    type: i0.Input
                }], minorStrokeThickness: [{
                    type: i0.Input
                }], tickStroke: [{
                    type: i0.Input
                }], tickStrokeThickness: [{
                    type: i0.Input
                }], tickLength: [{
                    type: i0.Input
                }], isDisabled: [{
                    type: i0.Input
                }], isInverted: [{
                    type: i0.Input
                }], shouldAvoidAnnotationCollisions: [{
                    type: i0.Input
                }], shouldKeepAnnotationsInView: [{
                    type: i0.Input
                }], useEnhancedIntervalManagement: [{
                    type: i0.Input
                }], enhancedIntervalMinimumCharacters: [{
                    type: i0.Input
                }], enhancedIntervalPreferMoreCategoryLabels: [{
                    type: i0.Input
                }], labelTextStyle: [{
                    type: i0.Input
                }], labelTextColor: [{
                    type: i0.Input
                }], labelLocation: [{
                    type: i0.Input
                }], labelVisibility: [{
                    type: i0.Input
                }], labelShowFirstLabel: [{
                    type: i0.Input
                }], labelAngle: [{
                    type: i0.Input
                }], labelExtent: [{
                    type: i0.Input
                }], labelLeftMargin: [{
                    type: i0.Input
                }], labelRightMargin: [{
                    type: i0.Input
                }], labelTopMargin: [{
                    type: i0.Input
                }], labelBottomMargin: [{
                    type: i0.Input
                }], labelHorizontalAlignment: [{
                    type: i0.Input
                }], labelVerticalAlignment: [{
                    type: i0.Input
                }], crossingAxis: [{
                    type: i0.Input
                }], crossingValue: [{
                    type: i0.Input
                }], titlePosition: [{
                    type: i0.Input
                }], titleTextStyle: [{
                    type: i0.Input
                }], titleTextColor: [{
                    type: i0.Input
                }], titleLocation: [{
                    type: i0.Input
                }], titleVisibility: [{
                    type: i0.Input
                }], titleShowFirstLabel: [{
                    type: i0.Input
                }], titleAngle: [{
                    type: i0.Input
                }], titleExtent: [{
                    type: i0.Input
                }], titleLeftMargin: [{
                    type: i0.Input
                }], titleRightMargin: [{
                    type: i0.Input
                }], titleTopMargin: [{
                    type: i0.Input
                }], titleBottomMargin: [{
                    type: i0.Input
                }], titleHorizontalAlignment: [{
                    type: i0.Input
                }], titleVerticalAlignment: [{
                    type: i0.Input
                }], annotations: [{
                    type: i0.Input
                }], coercionMethods: [{
                    type: i0.Input
                }], expectFunctions: [{
                    type: i0.Input
                }], label: [{
                    type: i0.Input
                }], labelFormat: [{
                    type: i0.Input
                }], labelFormatSpecifiers: [{
                    type: i0.Input
                }], rangeChanged: [{
                    type: i0.Output
                }], renderRequested: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSeriesComponent_PROVIDERS = [];
    /**
     * Represents the base class for all IgxDataChartComponent series.
    */
    var IgxSeriesComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxSeriesComponent() {
            //@Input()
            //set opacity(value: number) {
            //    this.i.opacity = +value;
            //}
            //get opacity(): number {
            //    return this.i.opacity;
            //}
            //@Input()
            //set visibility(v: Visibility) {
            //    this.i.visibility = ensureEnum<Visibility>(Visibility_$type, v);
            //}
            //get visibility(): Visibility {
            //    return this.i.visibility;
            //}
            this._chartLevelData = null;
            this._dataSource = null;
            this._tooltipTemplate = null;
            this._tooltipContent = null;
            this._tooltipContainerTemplate = null;
            this._renderer = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._renderRequested = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        Object.defineProperty(IgxSeriesComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype.onImplementationCreated = function () {
        };
        IgxSeriesComponent.prototype.createImplementation = function () {
            return null;
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "seriesInternal", {
            get: function () {
                return this.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "name", {
            get: function () {
                return this.i.name;
            },
            set: function (value) {
                this.i.name = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "legend", {
            /**
             * Gets or sets the legend used for the current series.
            */
            get: function () {
                if (this.i.legend != null)
                    return this.i.legend.externalObject;
            },
            set: function (v) {
                if (v != undefined && v != null)
                    this.i.legend = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype.provideData = function (data) {
            this._chartLevelData = data;
            this.updateDataSource();
        };
        IgxSeriesComponent.prototype.onUpdateDataSource = function (dataSource) {
            return dataSource;
        };
        IgxSeriesComponent.prototype.updateDataSource = function () {
            if (this._dataSource == null) {
                this.i.itemsSource = this.onUpdateDataSource(this._chartLevelData);
            }
            else {
                this.i.itemsSource = this.onUpdateDataSource(this._dataSource);
            }
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "dataSource", {
            get: function () {
                if (this._dataSource != null) {
                    return this._dataSource;
                }
                return this.i.itemsSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.updateDataSource();
                //console.log("setting axis data source: " + value)
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype.bindAxes = function (axes) {
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "tooltipTemplate", {
            get: function () {
                return this._tooltipTemplate;
            },
            set: function (value) {
                this._tooltipTemplate = value;
                if (value == null) {
                    if (this._tooltipContent !== null) {
                        this._tooltipContent.destroy();
                        this._tooltipContent = null;
                    }
                }
                if (this._tooltipContent != null) {
                    this._tooltipContent.instance.template = this._tooltipTemplate;
                }
                else {
                    if (this.owner != null) {
                        this.owner._ensureTooltipCreated(this);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "tooltipContainerTemplate", {
            get: function () {
                return this._tooltipContainerTemplate;
            },
            set: function (value) {
                this._tooltipContainerTemplate = value;
                if (this._tooltipContent != null) {
                    this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
                }
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype._ensureTooltipCreated = function (createTooltip, createWrapper) {
            if (this._tooltipTemplate == null) {
                this.i.toolTip = null;
            }
            if (this._tooltipContent == null && this._tooltipTemplate != null) {
                var tooltip = createTooltip();
                if (tooltip == null) {
                    return;
                }
                this._tooltipContent = tooltip;
                tooltip.instance.template = this._tooltipTemplate;
                this.i.toolTip = createWrapper(tooltip.location.nativeElement);
            }
        };
        IgxSeriesComponent.prototype._ensureTooltipDestroyed = function () {
            if (this._tooltipContent !== null) {
                this._tooltipContent.destroy();
                this._tooltipContent = null;
            }
        };
        IgxSeriesComponent.prototype._provideRenderer = function (renderer) {
            this._renderer = renderer;
            this._zoneRunner = function (act) {
                if (renderer !== null) {
                    renderer._ngZone.run(act);
                }
                else {
                    act();
                }
            };
        };
        IgxSeriesComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationLayer", {
            /**
         * Gets whether the series is an annotation layer.
        *
        * ```ts
        * let isAnnotationLayer: boolean = this.series.isAnnotationLayer;
        * ```
        */
            get: function () {
                return this.i.c6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationCrosshairLayer", {
            /**
             * Gets whether the series is an crosshair annotation layer.
            */
            get: function () {
                return this.i.c3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationCalloutLayer", {
            /**
             * Gets whether the series is an callout annotation layer.
            */
            get: function () {
                return this.i.c2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationHoverLayer", {
            /**
             * Gets whether the series is an annotation layer displayed only when hovering over the chart.
             * Crosshair Layer, Category Highlight Layer, Category Tooltip Layer, Item Tooltip Layer
            */
            get: function () {
                return this.i.c5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationFinalValue", {
            /**
             * Gets whether the series is final value annotation layer.
            */
            get: function () {
                return this.i.c4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isVertical", {
            /**
             * Gets whether the current series is oriented vertically.
            *
            * ```ts
            * let isVertical: boolean = this.series.isVertical;
            * ```
            */
            get: function () {
                return this.i.isVertical;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isFragment", {
            /**
             * Gets whether the current series is a stack fragment.
            *
            * ```ts
            * let isFragment: boolean = this.series.isFragment;
            * ```
            */
            get: function () {
                return this.i.dn;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            *
            * ```ts
            * let isAreaorLine: boolean = this.series.isAreaorLine;
            * ```
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isLineContour", {
            /**
             * Gets whether the current series shows a line contour shape.
            */
            get: function () {
                return this.i.du;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isBar", {
            /**
             * Gets whether the current series shows a horizontal column shape.
            */
            get: function () {
                return this.i.c9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isWaterfall", {
            /**
             * Gets whether the current series shows a waterfall column shape.
            */
            get: function () {
                return this.i.ee;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isPolyline", {
            /**
             * Gets whether the current series shows a polyline shape.
            */
            get: function () {
                return this.i.d2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isPolygon", {
            /**
             * Gets whether the current series shows a polygon shape.
            */
            get: function () {
                return this.i.d1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isPixel", {
            /**
             * Gets whether the current series shows pixels.
            */
            get: function () {
                return this.i.dz;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isPie", {
            /**
             * Gets whether the current series shows a pie shape.
            */
            get: function () {
                return this.i.dy;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isTile", {
            /**
             * Gets whether the current series shows a tile imagery.
            */
            get: function () {
                return this.i.ec;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isStep", {
            /**
             * Gets whether the current series shows step shapes.
            */
            get: function () {
                return this.i.eb;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isShapeControl", {
            /**
             * Gets whether the current series shows interactive shape controls.
            */
            get: function () {
                return this.i.d8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isPolar", {
            /**
             * Gets whether the current series is a polar type series.
            *
            * ```ts
            * let isPolar: boolean = this.series.isPolar;
            * ```
            */
            get: function () {
                return this.i.d0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isScatter", {
            /**
             * Gets whether the current series is a scatter type series.
            *
            * ```ts
            * let isScatter: boolean = this.series.isScatter;
            * ```
            */
            get: function () {
                return this.i.d6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isRadial", {
            /**
             * Gets whether the current series is a radial type series.
            *
            * ```ts
            * let isRadial: boolean = this.series.isRadial;
            * ```
            */
            get: function () {
                return this.i.d4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isStacked", {
            /**
             * Gets whether the current series is a stacked type series.
            *
            * ```ts
            * let isStacked: boolean = this.series.isStacked;
            * ```
            */
            get: function () {
                return this.i.isStacked;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isFinancial", {
            /**
             * Gets whether the current series is a financial type series.
            *
            * ```ts
            * let isFinancial: boolean = this.series.isFinancial;
            * ```
            */
            get: function () {
                return this.i.di;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isRange", {
            /**
             * Gets whether the current series is a range type series.
            *
            * ```ts
            * let isRange: boolean = this.series.isRange;
            * ```
            */
            get: function () {
                return this.i.d5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isCategory", {
            /**
             * Gets whether the current series is a category type series.
            *
            * ```ts
            * let isCategory: boolean = this.series.isCategory;
            * ```
            */
            get: function () {
                return this.i.da;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isGeographic", {
            /**
             * Gets whether the current series is a geographic series.
            *
            * ```ts
            * let isGeographic: boolean = this.series.isGeographic;
            * ```
            */
            get: function () {
                return this.i.dp;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isShape", {
            /**
             * Gets whether the current series is a shape type series.
            */
            get: function () {
                return this.i.d7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isValueOverlay", {
            /**
             * Gets whether the series is a value overlay.
            */
            get: function () {
                return this.i.ed;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "hasOnlyMarkers", {
            /**
             * Gets whether the series has only marker as visuals
            */
            get: function () {
                return this.i.c0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isFinancialSeries", {
            /**
             * Gets whether the series has financial OHLC/candlestick visuals
            */
            get: function () {
                return this.i.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isFinancialOverlay", {
            /**
             * Gets whether the series is financial overlay
            */
            get: function () {
                return this.i.dk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isFinancialIndicator", {
            /**
             * Gets whether the series is financial indicator
            */
            get: function () {
                return this.i.dj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isFinancialWaterfall", {
            /**
             * Gets whether the series is financial waterfall
            */
            get: function () {
                return this.i.dm;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultCrosshairBehaviorDisabled", {
            /**
             * Gets whether the default crosshair behavior should be disabled if this series is present.
            *
            * `isDefaultCrosshairBehaviorDisabled` defaults to true for annotation layers. When not using annotaion layers, you can show crosshairs by setting the chart's `CrosshairVisibility` to true.
            *
            * ```ts
            * let isDefaultCrosshairBehaviorDisabled: boolean = this.series.isDefaultCrosshairBehaviorDisabled;
            * ```
            */
            get: function () {
                return this.i.dd;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultTooltipBehaviorDisabled", {
            /**
             * Gets whether the default tooltip behavior should be disabled if this series is present.
            *
            * ```ts
            *  let isDefaultTooltipBehaviorDisabled: boolean = this.series.isDefaultTooltipBehaviorDisabled;
            * ```
            */
            get: function () {
                return this.i.de;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "hasMarkers", {
            /**
             * Returns whether the current series supports visual markers.
            *
            * ```ts
            * let hasMarkers: boolean = this.series.hasMarkers;
            * ```
            */
            get: function () {
                return this.i.hasMarkers;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isIndexed", {
            /**
             * Gets if the series uses an index, which can be used to auto-assign it a color.
            *
            * ```ts
            * let isIndexed: boolean = this.series.isIndexed;
            * ```
            */
            get: function () {
                return this.i.ds;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isUsableInLegend", {
            /**
             * Gets if the series should appear in any legends.
            *
            * ```ts
            * let isUsableInLegend: boolean = this.series.isUsableInLegend;
            * ```
            */
            get: function () {
                return this.i.isUsableInLegend;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "legendItemVisibility", {
            /**
             * Gets or sets the legend item visibility for the current series object.
            *
            * The `LegendItemVisibilty` can be used to exclude only certain `IgxSeriesComponent` from the `IgxLegendComponent`.
            */
            get: function () {
                return this.i.ph;
            },
            set: function (v) {
                this.i.ph = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "legendItemBadgeTemplate", {
            /**
             * Gets or sets the LegendItemBadgeTemplate property.
             * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
             * the series object itself.
            */
            get: function () {
                return this.i.legendItemBadgeTemplate;
            },
            set: function (v) {
                this.i.legendItemBadgeTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualLegendItemBadgeTemplate", {
            /**
             * Gets the actual legend item badge template used by the series.
            */
            get: function () {
                return this.i.ms;
            },
            set: function (v) {
                this.i.ms = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualLegendItemBadgeOutline", {
            /**
             * Gets the effective legend badge outline for the current series.
            */
            get: function () {
                return i2.brushToString(this.i.oh);
            },
            set: function (v) {
                this.i.oh = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualLegendItemBadgeBrush", {
            /**
             * Gets the effective legend badge fill for the current series.
            */
            get: function () {
                return i2.brushToString(this.i.og);
            },
            set: function (v) {
                this.i.og = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "legendItemBadgeShape", {
            /**
             * Gets or sets the type of legend badge representing the current series in a legend.
             * This property will be ignored when the LegendItemTemplate/LegendItemBadgeTemplate property is set on the series
            */
            get: function () {
                return this.i.a9;
            },
            set: function (v) {
                this.i.a9 = i2.ensureEnum(LegendItemBadgeShape_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "legendItemBadgeMode", {
            /**
             * Gets or sets the mode of legend badge representing the current series in a legend.
             * This property will be ignored when the LegendItemTemplate/LegendItemBadgeTemplate property is set on the series
            */
            get: function () {
                return this.i.a7;
            },
            set: function (v) {
                this.i.a7 = i2.ensureEnum(LegendItemBadgeMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "legendItemTemplate", {
            /**
             * Gets or sets the LegendItemTemplate property.
             * The legend item control content is created according to the LegendItemTemplate on-demand by
             * the series object itself.
            */
            get: function () {
                return this.i.legendItemTemplate;
            },
            set: function (v) {
                this.i.legendItemTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "discreteLegendItemTemplate", {
            /**
             * Gets or sets the DiscreteLegendItemTemplate property.
             * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
             * the series object itself.
            */
            get: function () {
                return this.i.mt;
            },
            set: function (v) {
                this.i.mt = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "transitionEasingFunction", {
            /**
             * Gets or sets the easing function used to morph the current series.
            *
            * The `TransitioninDuration` and `transitionEasingFunction` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
            *
            * ```ts
            * this.series.transitionEasingFunction =  EasingFunctions.cubicEase;
            * ```
            */
            get: function () {
                return this.i.cc;
            },
            set: function (v) {
                this.i.cc = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "transitionInEasingFunction", {
            /**
             * Gets or sets the EasingFunction used to morph the current series during the initial transition.
            *
            * The `transitionInEasingFunction` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
            *
            * ```ts
            * this.series.transitionInEasingFunction =  EasingFunctions.cubicEase;
            * ```
            */
            get: function () {
                return this.i.cd;
            },
            set: function (v) {
                this.i.cd = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "transitionDuration", {
            /**
             * Gets or sets the duration of the current series's morph.
            *
            * The `transitionDuration` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     animateSeriesWhenAxisRangeChanges=true>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionDuration=500
            *         transitionInDuration=500>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.transitionDuration = 500;
            * ```
            */
            get: function () {
                return this.i.ha;
            },
            set: function (v) {
                this.i.ha = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "resolution", {
            /**
             * Gets or sets the current series object's rendering resolution.
            *
            * Setting the `resolution` on a Series to a higher value can help with performance, but it will lower the graphical fidelity of the line. As such, it can be increased up until the fidelity is unacceptable.
            *
            * ```html
            *  <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         resolution=1.5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.resolution = 1.5;
            * ```
            */
            get: function () {
                return this.i.gh;
            },
            set: function (v) {
                this.i.gh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "visibleRangeMarginTop", {
            /**
             * Gets or sets the top margin to use when getting a visible axis range for the series.
            */
            get: function () {
                return this.i.gr;
            },
            set: function (v) {
                this.i.gr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "visibleRangeMarginBottom", {
            /**
             * Gets or sets the bottom margin to use when getting a visible axis range for the series.
            */
            get: function () {
                return this.i.go;
            },
            set: function (v) {
                this.i.go = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "visibleRangeMarginLeft", {
            /**
             * Gets or sets the left margin to use when getting a visible axis range for the series.
            */
            get: function () {
                return this.i.gp;
            },
            set: function (v) {
                this.i.gp = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "visibleRangeMarginRight", {
            /**
             * Gets or sets the right margin to use when getting a visible axis range for the series.
            */
            get: function () {
                return this.i.gq;
            },
            set: function (v) {
                this.i.gq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "title", {
            /**
             * Gets or sets the Title property.
             * The legend item control is created according to the Title on-demand by
             * the series object itself.
            *
            * The `IgxSeriesComponent` `title` may be used in tooltips and legends.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         showDefaultTooltip="true"
            *         title="InStock Items">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.title = "InStock Items";
            * ```
            */
            get: function () {
                return this.i.hp;
            },
            set: function (v) {
                this.i.hp = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "brush", {
            /**
             * Gets or sets the brush to use for the series.
            *
            * The `brush` along with the `outline` and `Negative Brush` can be used to affect the visuals of the `IgxSeriesComponent`.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         brush="red">
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.brush = "red";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.oj);
            },
            set: function (v) {
                this.i.oj = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualBrush", {
            /**
             * Gets the effective brush for the current series object.
            *
            * ```ts
            * let actualBrush: string = series.actualBrush;
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.of);
            },
            set: function (v) {
                this.i.of = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "outline", {
            /**
             * Gets or sets the brush to use for the outline of the series.
             * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
            *
            * The `outline` along with the `brush` and `NegativeBrush` can be used to affect the visuals of the `IgxSeriesComponent`.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         outline="red">
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.brush = "red";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.oo);
            },
            set: function (v) {
                this.i.oo = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualOutline", {
            /**
             * Gets the effective outline for the current series object.
            *
            * ```ts
            * let actualOutline: string = series.ActualOutline;
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.oi);
            },
            set: function (v) {
                this.i.oi = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "thickness", {
            /**
             * Gets or sets the width of the current series object's line thickness.
            *
            * Depending on the `IgxSeriesComponent` type, this can be the main brush used, or just the outline. For example, when using a `IgxLineSeriesComponent` it will affect the thickness of the lines drawn, whereas when using a `IgxColumnSeriesComponent` it will affect the outer border thickness of the columns.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.thickness=5;
            * ```
            */
            get: function () {
                return this.i.gm;
            },
            set: function (v) {
                this.i.gm = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualThickness", {
            /**
             * Gets the effective Thickness for the current series object.
            */
            get: function () {
                return this.i.fl;
            },
            set: function (v) {
                this.i.fl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualHighlightingMode", {
            /**
             * Gets actual highlighting mode
            */
            get: function () {
                return this.i.bj;
            },
            set: function (v) {
                this.i.bj = i2.ensureEnum(SeriesHighlightingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualHighlightingFadeOpacity", {
            /**
             * Gets actual highlighting fade opacity
            */
            get: function () {
                return this.i.fj;
            },
            set: function (v) {
                this.i.fj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "highlightingFadeOpacity", {
            /**
             * Gets or sets the target opacity to fade to for fade style highlighting.
            */
            get: function () {
                return this.i.gd;
            },
            set: function (v) {
                this.i.gd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isComponentHighlightingModeIgnored", {
            /**
             * Gets or sets whether the component level highlight mode is ignored.
            */
            get: function () {
                return this.i.dc;
            },
            set: function (v) {
                this.i.dc = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isHighlightingEnabled", {
            /**
             * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightEnabled="true">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.isHighlightingEnabled = true;
            * ```
            */
            get: function () {
                return this.i.dq;
            },
            set: function (v) {
                this.i.dq = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isDropShadowEnabled", {
            /**
             * Gets or sets whether drop shadow should be enabled for this series.
            *
            * `isDropShadowEnabled` is used to decide whether drop shadow should be enabled for this series.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled=true>
            *     </igx-line-series>
            *     </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.isDropShadowEnabled = true;
            * ```
            */
            get: function () {
                return this.i.dg;
            },
            set: function (v) {
                this.i.dg = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "shadowBlur", {
            /**
             * Gets or sets the shadow blur.
             * This property is ignored when Series.UseSingleShadow is set to true.
            *
            * `shadowBlur` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowBlur="7"
            *         shadowColor="blue">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shadowBlur = 7;
            * ```
            */
            get: function () {
                return this.i.gj;
            },
            set: function (v) {
                this.i.gj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "shadowColor", {
            /**
             * Gets or sets the drop shadow color.
            *
            * `shadowColor` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowBlur="7"
            *         shadowColor="blue">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shadowColor = "blue";
            * ```
            */
            get: function () {
                return i2.colorToString(this.i.or);
            },
            set: function (v) {
                this.i.or = i2.stringToColor(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "useSingleShadow", {
            /**
             * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
             * When this property is set to true, no Series.ShadowBlur is applied.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled=true
            *         markerType="circle"
            *         useSingleShadow=true>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.useSingleShadow = true;
            * ```
            */
            get: function () {
                return this.i.e1;
            },
            set: function (v) {
                this.i.e1 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "shadowOffsetX", {
            /**
             * Gets or sets the drop shadow x-offset.
            *
            * `shadowOffsetX` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowOffsetX="10"
            *         shadowOffsetY="10">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shadowOffsetX = 10;
            * ```
            */
            get: function () {
                return this.i.gk;
            },
            set: function (v) {
                this.i.gk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "shadowOffsetY", {
            /**
             * Gets or sets the drop shadow y-offset.
            *
            * `shadowOffsetY` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowOffsetX="10"
            *         shadowOffsetY="10">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shadowOffsetY = 10;
            * ```
            */
            get: function () {
                return this.i.gl;
            },
            set: function (v) {
                this.i.gl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "areaFillOpacity", {
            /**
             * Gets or sets the opacity applied to the area fill visual.
             * This property only applies to series that have area visual.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         areaFillOpacity=.5>
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.fq;
            },
            set: function (v) {
                this.i.fq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualAreaFillOpacity", {
            /**
             * Gets the actual opacity applied to the area fill visual.
            *
            * ```ts
            * let actualFillOpacity: number = series.actualAreaFillOpacity;
            * ```
            */
            get: function () {
                return this.i.fi;
            },
            set: function (v) {
                this.i.fi = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "markerFillOpacity", {
            /**
             * Gets or sets the opacity applied to the fill of the markers.
             * This property only applies to series that have area visual.
            */
            get: function () {
                return this.i.ge;
            },
            set: function (v) {
                this.i.ge = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualMarkerFillOpacity", {
            /**
             * Gets the actual opacity applied to the fill of the markers.
            */
            get: function () {
                return this.i.fk;
            },
            set: function (v) {
                this.i.fk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultToolTipSelected", {
            /**
             * Gets if the default tooltip has been selected for display.
            *
            * To use the default tooltip set `showDefaultTooltip` to true.
            *
            * ```ts
            * let isDefaultToolTipSelected: boolean = this.series.isDefaultToolTipSelected;
            * ```
            */
            get: function () {
                return this.i.df;
            },
            set: function (v) {
                this.i.df = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "showDefaultTooltip", {
            /**
             * Gets or sets whether default tooltip will be shown.
            *
            * The default tooltips display all the information relevant to the particular series item (series title, data values, axis values etc.) and are styled to match the series' style. When using default tooltips, you should also set the series `title`.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         showDefaultTooltip="true"
            *         title="InStock Items">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.showDefaultTooltip ="true";
            * ```
            */
            get: function () {
                return this.i.el;
            },
            set: function (v) {
                this.i.el = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "visibleRangeMode", {
            /**
             * Gets or sets the visible range mode to use.
            */
            get: function () {
                return this.i.b1;
            },
            set: function (v) {
                this.i.b1 = i2.ensureEnum(SeriesVisibleRangeMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "outlineMode", {
            /**
             * Gets or sets the outline mode to use for the series.
            */
            get: function () {
                return this.i.bs;
            },
            set: function (v) {
                this.i.bs = i2.ensureEnum(SeriesOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "transitionInDuration", {
            /**
             * Gets or sets the duration of the current series's transition in morph.
            *
            * The `transitionInDuration` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionDuration=500
            *         transitionInDuration=500>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.transitionDuration = 500;
            * ```
            */
            get: function () {
                return this.i.hb;
            },
            set: function (v) {
                this.i.hb = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "transitionInSpeedType", {
            /**
             * Gets or sets the duration of the current series's transition in morph.
            *
            * The `transitionInSpeedType` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionInDuration=500>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.transitionInSpeedType = TransitionInSpeedType.IndexScaled;
            * ```
            */
            get: function () {
                return this.i.b7;
            },
            set: function (v) {
                this.i.b7 = i2.ensureEnum(TransitionInSpeedType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "mouseOverEnabled", {
            /**
             * Gets or sets the whether the chart reacts to mouse move events.
            */
            get: function () {
                return this.i.ef;
            },
            set: function (v) {
                this.i.ef = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "coercionMethods", {
            /**
             * Gets or sets the coercion methods to use when loading data from data sources.
             * Should be specified before setting any member paths, if being used. Setting it later
             * will not cause data to be reimported into the chart.
            *
            * ```html
            *  <igx-data-chart
            *       [dataSource]="data"
            *      >
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis
            *         #yAxis>
            *       </igx-numeric-y-axis>
            *       <igx-line-series
            *       [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       valueMemberPath="value">
            *      </igx-line-series>
            *        <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         [coercionMethods]= cMethods
            *         valueMemberPath="value!ValueCoercion">
            *        </igx-line-series>
            *     </igx-data-chart>
            * ```
            *
            * &lt;-- position: content member-->
            *
            * ```ts
            * cMethods: any = {
            *     ValueCoercion: function(value:number): number {return value+2;}
            *  }
            * ```
            */
            get: function () {
                return this.i.coercionMethods;
            },
            set: function (v) {
                this.i.coercionMethods = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "expectFunctions", {
            /**
             * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
             * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
             * This value must be set before assigning an item's source to take effect.
            *
            * `expectFunctions` is used to decide whether the series should expect that its data source members need to be called as functions to get their values.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     expectFunctions=true
            *     valueMemberPath="MyFunction">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.expectFunctions=true;
            * ```
            */
            get: function () {
                return this.i.expectFunctions;
            },
            set: function (v) {
                this.i.expectFunctions = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "hitTestMode", {
            /**
             * Method of hit testing to use when pointing to items in this series.
            *
            * The `hitTestMode` can be set to either:
            *
            * -   `Auto`: automatically decide the appropriate hit test mode for the series.
            * -   `ColorEncoded`: use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
            * -   `Computational`: use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded
            *
            * ```ts
            * this.series.hitTestMode = SeriesHitTestMode.Computational;
            * ```
            */
            get: function () {
                return this.i.bp;
            },
            set: function (v) {
                this.i.bp = i2.ensureEnum(SeriesHitTestMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualHitTestMode", {
            /**
             * Resolved method of hit testing to use when pointing to items in the chart.
            *
            * ```ts
            * let hitTestMode: SeriesHitTestMode = this.series.actualHitTestMode;
            * ```
            */
            get: function () {
                return this.i.bn;
            },
            set: function (v) {
                this.i.bn = i2.ensureEnum(SeriesHitTestMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isNegativeColorSupported", {
            /**
             * Overridden by derived series classes to indicate when negative colors are supported or not.
            */
            get: function () {
                return this.i.dx;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when markerless display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "finalValue", {
            /**
             * The final value of this series.
            */
            get: function () {
                return this.i.fs;
            },
            set: function (v) {
                this.i.fs = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "percentChange", {
            /**
             * The percent change from the beginning to the end of this series.
            */
            get: function () {
                return this.i.gg;
            },
            set: function (v) {
                this.i.gg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualOpenLabel", {
            /**
             * Gets the text that is displayed for the Open label in the tooltip.
            */
            get: function () {
                return this.i.h5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualCloseLabel", {
            /**
             * Gets the text that is displayed for the Close label in the tooltip.
            */
            get: function () {
                return this.i.hu;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualHighLabel", {
            /**
             * Gets the text that is displayed for the High label in the tooltip.
            */
            get: function () {
                return this.i.hv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualLowLabel", {
            /**
             * Gets the text that is displayed for the Low label in the tooltip.
            */
            get: function () {
                return this.i.h3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualVolumeLabel", {
            /**
             * Gets the text that is displayed for the Volume label in the tooltip.
            */
            get: function () {
                return this.i.ia;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualValueLabel", {
            /**
             * Gets the text that is displayed for the Value label in the tooltip.
            */
            get: function () {
                return this.i.h9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "actualRadiusLabel", {
            /**
             * Gets the text that is displayed for the Value label in the tooltip.
            */
            get: function () {
                return this.i.h7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "opacity", {
            get: function () {
                return this.i.opacity;
            },
            set: function (v) {
                this.i.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesComponent.prototype, "visibility", {
            get: function () {
                return this.i.visibility;
            },
            set: function (v) {
                this.i.visibility = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype.findByName = function (name) {
            if (this.legend && this.legend.name && this.legend.name == name) {
                return this.legend;
            }
            return null;
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxSeriesComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("SeriesComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Gets the brush for tooltip labels.

    */
        IgxSeriesComponent.prototype.resolveTooltipBrush = function () {
            var iv = this.i.jb();
            return (iv);
        };
        IgxSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        *
        * ```ts
        * let index: number = this.series.getExactItemIndex({x:.5,y:.5});
        * ```
        */
        IgxSeriesComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item item index associated with the specified world position
        
        *
        * ```ts
        * let index: number = this.series.getItemIndex({x:.5,y:.5});
        * ```
        */
        IgxSeriesComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        *
        * ```ts
        * let item: number = this.series.getItem({x:.5,y:.5});
        * ```
        */
        IgxSeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        IgxSeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxSeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxSeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxSeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        *
        * ```ts
        * let box: IgxRect = this.series.getSeriesValueBoundingBox({x:.8,y:.8});
        * ```
        */
        IgxSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        *
        * ```ts
        * let box: IgxRect = this.series.getSeriesValueMarkerBoundingBox({x:.8,y:.8});
        * ```
        */
        IgxSeriesComponent.prototype.getSeriesValueMarkerBoundingBox = function (world) {
            var iv = this.i.pd(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        IgxSeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f4(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxSeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.oy(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxSeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f6(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxSeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o0(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxSeriesComponent.prototype.getSeriesValuePositionFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
            var iv = this.i.o3(i2.toPoint(mouse), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxSeriesComponent.prototype.getSeriesValueFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
            var iv = this.i.f9(i2.toPoint(mouse), useInterpolation, skipUnknowns);
            return (iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        *
        * ```ts
        * let span: number = this.series.getItemSpan();
        * ```
        */
        IgxSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        /**
         * Hides any internal tooltips presented by the series, if any.
        
        */
        IgxSeriesComponent.prototype.hideToolTips = function () {
            this.i.kx();
        };
        /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        *
        * ```ts
        * this.series.toWorldPosition({x:500,y:500});
        * ```
        */
        IgxSeriesComponent.prototype.toWorldPosition = function (seriesPoint) {
            var iv = this.i.o5(i2.toPoint(seriesPoint));
            return i2.fromPoint(iv);
        };
        /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        *
        * ```ts
        * let pt: IgxPoint = this.series.fromWorldPosition({x:.5,y:.5});
        * ```
        */
        IgxSeriesComponent.prototype.fromWorldPosition = function (world) {
            var iv = this.i.ox(i2.toPoint(world));
            return i2.fromPoint(iv);
        };
        /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        *
        * ```ts
        * this.series.scrollIntoView(dataItem);
        * ```
        */
        IgxSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Renders the series.
        
        * @param animate  * True if the change should be animated.
        *
        * ```ts
        * this.series.renderSeries(true);
        * ```
        */
        IgxSeriesComponent.prototype.renderSeries = function (animate) {
            this.i.l0(animate);
        };
        /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
        IgxSeriesComponent.prototype.getEffectiveViewport = function () {
            var iv = this.i.getEffectiveViewport();
            return i2.fromRect(iv);
        };
        /**
         * Removes all alternate views of this series.
        
        */
        IgxSeriesComponent.prototype.removeAllAlternateViews = function () {
            this.i.lu();
        };
        /**
         * Removes an alternate view of this series.
        
        * @param viewIdentifier  * The string identifier for the view to remove.
        */
        IgxSeriesComponent.prototype.removeAlternateView = function (viewIdentifier) {
            this.i.lw(viewIdentifier);
        };
        /**
         * Called to notify about changes to indexed-based properties, e.g. Brushes, Outlines, MarkerBrushes, MarkerOutlines and refresh series
        
        */
        IgxSeriesComponent.prototype.notifyIndexedPropertiesChanged = function () {
            this.i.k2();
        };
        /**
         * Notifies the series that a visual property has changed, requiring a visual update.
        
        */
        IgxSeriesComponent.prototype.notifyVisualPropertiesChanged = function () {
            this.i.k9();
        };
        /**
         * Replays the assigned transition in animation, if any.
        
        *
        * ```ts
        * this.series.replayTransitionIn();
        * ```
        */
        IgxSeriesComponent.prototype.replayTransitionIn = function () {
            this.i.l3();
        };
        /**
         * Call to null out the axes of the series;
        
        */
        IgxSeriesComponent.prototype.removeAxes = function () {
            this.i.lx();
        };
        /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        *
        * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
        *
        * ```ts
        * this.series.simulateHover({x:250,y:250});
        * ```
        */
        IgxSeriesComponent.prototype.simulateHover = function (point) {
            this.i.l7(i2.toPoint(point));
        };
        /**
         * Called when this series' Style is updated.
        
        */
        IgxSeriesComponent.prototype.styleUpdated = function () {
            this.i.l9();
        };
        IgxSeriesComponent.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
            this.i.l5(i2.stringToBrush(negativeBrush), i2.stringToBrush(negativeOutline));
        };
        /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        *
        * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
        *
        * ```ts
        * this.crosshair.moveCursorPoint({x:.5,y:.5});
        * ```
        */
        IgxSeriesComponent.prototype.moveCursorPoint = function (point) {
            this.i.kz(i2.toPoint(point));
        };
        Object.defineProperty(IgxSeriesComponent.prototype, "renderRequested", {
            /**
             * This event is raised every time a render has been requested from a series.
            */
            get: function () {
                var _this = this;
                if (this._renderRequested == null) {
                    this._renderRequested = new i0.EventEmitter();
                    this.i.renderRequested = i2.delegateCombine(this.i.renderRequested, function (o, e) {
                        var outerArgs = new IgxRenderRequestedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeRenderRequested) {
                            _this.beforeRenderRequested(_this, outerArgs);
                        }
                        _this._renderRequested.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._renderRequested;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSeriesComponent, selector: "ng-component", inputs: { name: "name", legend: "legend", dataSource: "dataSource", tooltipTemplate: "tooltipTemplate", tooltipContainerTemplate: "tooltipContainerTemplate", legendItemVisibility: "legendItemVisibility", legendItemBadgeTemplate: "legendItemBadgeTemplate", actualLegendItemBadgeTemplate: "actualLegendItemBadgeTemplate", actualLegendItemBadgeOutline: "actualLegendItemBadgeOutline", actualLegendItemBadgeBrush: "actualLegendItemBadgeBrush", legendItemBadgeShape: "legendItemBadgeShape", legendItemBadgeMode: "legendItemBadgeMode", legendItemTemplate: "legendItemTemplate", discreteLegendItemTemplate: "discreteLegendItemTemplate", transitionEasingFunction: "transitionEasingFunction", transitionInEasingFunction: "transitionInEasingFunction", transitionDuration: "transitionDuration", resolution: "resolution", visibleRangeMarginTop: "visibleRangeMarginTop", visibleRangeMarginBottom: "visibleRangeMarginBottom", visibleRangeMarginLeft: "visibleRangeMarginLeft", visibleRangeMarginRight: "visibleRangeMarginRight", title: "title", brush: "brush", actualBrush: "actualBrush", outline: "outline", actualOutline: "actualOutline", thickness: "thickness", actualThickness: "actualThickness", actualHighlightingMode: "actualHighlightingMode", actualHighlightingFadeOpacity: "actualHighlightingFadeOpacity", highlightingFadeOpacity: "highlightingFadeOpacity", isComponentHighlightingModeIgnored: "isComponentHighlightingModeIgnored", isHighlightingEnabled: "isHighlightingEnabled", isDropShadowEnabled: "isDropShadowEnabled", shadowBlur: "shadowBlur", shadowColor: "shadowColor", useSingleShadow: "useSingleShadow", shadowOffsetX: "shadowOffsetX", shadowOffsetY: "shadowOffsetY", areaFillOpacity: "areaFillOpacity", actualAreaFillOpacity: "actualAreaFillOpacity", markerFillOpacity: "markerFillOpacity", actualMarkerFillOpacity: "actualMarkerFillOpacity", isDefaultToolTipSelected: "isDefaultToolTipSelected", showDefaultTooltip: "showDefaultTooltip", visibleRangeMode: "visibleRangeMode", outlineMode: "outlineMode", transitionInDuration: "transitionInDuration", transitionInSpeedType: "transitionInSpeedType", mouseOverEnabled: "mouseOverEnabled", coercionMethods: "coercionMethods", expectFunctions: "expectFunctions", hitTestMode: "hitTestMode", actualHitTestMode: "actualHitTestMode", finalValue: "finalValue", percentChange: "percentChange", opacity: "opacity", visibility: "visibility" }, outputs: { renderRequested: "renderRequested" }, ngImport: i0, template: "", isInline: true });
        return IgxSeriesComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { name: [{
                    type: i0.Input
                }], legend: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], tooltipTemplate: [{
                    type: i0.Input
                }], tooltipContainerTemplate: [{
                    type: i0.Input
                }], legendItemVisibility: [{
                    type: i0.Input
                }], legendItemBadgeTemplate: [{
                    type: i0.Input
                }], actualLegendItemBadgeTemplate: [{
                    type: i0.Input
                }], actualLegendItemBadgeOutline: [{
                    type: i0.Input
                }], actualLegendItemBadgeBrush: [{
                    type: i0.Input
                }], legendItemBadgeShape: [{
                    type: i0.Input
                }], legendItemBadgeMode: [{
                    type: i0.Input
                }], legendItemTemplate: [{
                    type: i0.Input
                }], discreteLegendItemTemplate: [{
                    type: i0.Input
                }], transitionEasingFunction: [{
                    type: i0.Input
                }], transitionInEasingFunction: [{
                    type: i0.Input
                }], transitionDuration: [{
                    type: i0.Input
                }], resolution: [{
                    type: i0.Input
                }], visibleRangeMarginTop: [{
                    type: i0.Input
                }], visibleRangeMarginBottom: [{
                    type: i0.Input
                }], visibleRangeMarginLeft: [{
                    type: i0.Input
                }], visibleRangeMarginRight: [{
                    type: i0.Input
                }], title: [{
                    type: i0.Input
                }], brush: [{
                    type: i0.Input
                }], actualBrush: [{
                    type: i0.Input
                }], outline: [{
                    type: i0.Input
                }], actualOutline: [{
                    type: i0.Input
                }], thickness: [{
                    type: i0.Input
                }], actualThickness: [{
                    type: i0.Input
                }], actualHighlightingMode: [{
                    type: i0.Input
                }], actualHighlightingFadeOpacity: [{
                    type: i0.Input
                }], highlightingFadeOpacity: [{
                    type: i0.Input
                }], isComponentHighlightingModeIgnored: [{
                    type: i0.Input
                }], isHighlightingEnabled: [{
                    type: i0.Input
                }], isDropShadowEnabled: [{
                    type: i0.Input
                }], shadowBlur: [{
                    type: i0.Input
                }], shadowColor: [{
                    type: i0.Input
                }], useSingleShadow: [{
                    type: i0.Input
                }], shadowOffsetX: [{
                    type: i0.Input
                }], shadowOffsetY: [{
                    type: i0.Input
                }], areaFillOpacity: [{
                    type: i0.Input
                }], actualAreaFillOpacity: [{
                    type: i0.Input
                }], markerFillOpacity: [{
                    type: i0.Input
                }], actualMarkerFillOpacity: [{
                    type: i0.Input
                }], isDefaultToolTipSelected: [{
                    type: i0.Input
                }], showDefaultTooltip: [{
                    type: i0.Input
                }], visibleRangeMode: [{
                    type: i0.Input
                }], outlineMode: [{
                    type: i0.Input
                }], transitionInDuration: [{
                    type: i0.Input
                }], transitionInSpeedType: [{
                    type: i0.Input
                }], mouseOverEnabled: [{
                    type: i0.Input
                }], coercionMethods: [{
                    type: i0.Input
                }], expectFunctions: [{
                    type: i0.Input
                }], hitTestMode: [{
                    type: i0.Input
                }], actualHitTestMode: [{
                    type: i0.Input
                }], finalValue: [{
                    type: i0.Input
                }], percentChange: [{
                    type: i0.Input
                }], opacity: [{
                    type: i0.Input
                }], visibility: [{
                    type: i0.Input
                }], renderRequested: [{
                    type: i0.Output
                }] } });

    /**
     * Represents the base class for annotation layer types. Annotations will usually disable some of the default hover/touch behaviors of the chart when they are introduced to the series collection.
     * In return they provide some valuable information as the cursor is moved by hovering over the chart, or performing a press-hold-drag interaction in touch mode.
    */
    var IgxAnnotationLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAnnotationLayerComponent, _super);
        function IgxAnnotationLayerComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "useIndex", {
            /**
             * Gets or sets whether this series should take up an index for auto brush coloring.
            */
            get: function () {
                return this.i.ps;
            },
            set: function (v) {
                this.i.ps = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "useLegend", {
            /**
             * Gets or sets whether this series interacts with the chart legend.
            */
            get: function () {
                return this.i.pt;
            },
            set: function (v) {
                this.i.pt = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "cursorPosition", {
            /**
             * Gets or sets the world position to use instead of the pointer position for this annotation layer. If you set this value, rather than responding to the pointer, this layer will be fixed on the provided world position.
             * A world position has x and y values that range from 0 to 1 that represent the global position of the cursor relative to the entire ranges of the axes. The default of (NaN, NaN) means that the layer should react to pointer movement.
            */
            get: function () {
                return i2.fromPoint(this.i.qk);
            },
            set: function (v) {
                this.i.qk = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "isDefaultCrosshairDisabled", {
            /**
             * Gets or sets whether the series viewer's default crosshair should be disabled by the presence of this layer.
            */
            get: function () {
                return this.i.pn;
            },
            set: function (v) {
                this.i.pn = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "isDefaultCrosshairBehaviorDisabled", {
            /**
             * Gets whether or not the default crosshair behavior is disabled.
            */
            get: function () {
                return this.i.dd;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "isIndexed", {
            /**
             * Gets if the series uses an index, which can be used to auto-assign it a color.
            */
            get: function () {
                return this.i.ds;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "isUsableInLegend", {
            /**
             * Gets if the series should appear in any legends.
            */
            get: function () {
                return this.i.isUsableInLegend;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "isAnnotationLayer", {
            /**
             * Gets whether this series is an annotation layer.
            */
            get: function () {
                return this.i.c6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnnotationLayerComponent.prototype, "shouldRenderAsOverlay", {
            /**
             * Gets or sets whether this layer renders as an overlay or not.
            */
            get: function () {
                return this.i.pr;
            },
            set: function (v) {
                this.i.pr = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxAnnotationLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAnnotationLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAnnotationLayerComponent, selector: "ng-component", inputs: { useIndex: "useIndex", useLegend: "useLegend", cursorPosition: "cursorPosition", isDefaultCrosshairDisabled: "isDefaultCrosshairDisabled", shouldRenderAsOverlay: "shouldRenderAsOverlay" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxAnnotationLayerComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnnotationLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { useIndex: [{
                    type: i0.Input
                }], useLegend: [{
                    type: i0.Input
                }], cursorPosition: [{
                    type: i0.Input
                }], isDefaultCrosshairDisabled: [{
                    type: i0.Input
                }], shouldRenderAsOverlay: [{
                    type: i0.Input
                }] } });

    /**
     * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
    */
    var IgxCategoryToolTipLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryToolTipLayerComponent, _super);
        function IgxCategoryToolTipLayerComponent() {
            return _super.call(this) || this;
        }
        IgxCategoryToolTipLayerComponent.prototype.createImplementation = function () {
            return new CategoryToolTipLayer();
        };
        Object.defineProperty(IgxCategoryToolTipLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryToolTipLayerComponent.prototype, "isAnnotationHoverLayer", {
            /**
             * Gets whether the series is an annotation layer displayed only when hovering over the chart.
            */
            get: function () {
                return this.i.c5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryToolTipLayerComponent.prototype, "isDefaultTooltipBehaviorDisabled", {
            /**
             * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
            */
            get: function () {
                return this.i.de;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryToolTipLayerComponent.prototype, "targetAxis", {
            /**
             * Gets or sets the Axis to target this annotation to. If null, this annotation layer will not render content.
            */
            get: function () {
                if (this.i.qm == null) {
                    return null;
                }
                if (!this.i.qm.externalObject) {
                    var e = IgxAxisComponent._createFromInternal(this.i.qm);
                    if (e) {
                        e._implementation = this.i.qm;
                    }
                    this.i.qm.externalObject = e;
                }
                return this.i.qm.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qm = null : this.i.qm = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryToolTipLayerComponent.prototype, "useInterpolation", {
            /**
             * Gets or sets whether to use value interpolation when drawing the tooltips.
            */
            get: function () {
                return this.i.qq;
            },
            set: function (v) {
                this.i.qq = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryToolTipLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetAxis && this.targetAxis.name && this.targetAxis.name == name) {
                return this.targetAxis;
            }
            return null;
        };
        IgxCategoryToolTipLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetAxis && this.targetAxis._styling) {
                this.targetAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Hides any tooltips presented by the layer, if any.
        
        */
        IgxCategoryToolTipLayerComponent.prototype.hideToolTips = function () {
            this.i.kx();
        };
        IgxCategoryToolTipLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryToolTipLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryToolTipLayerComponent, selector: "igx-category-tool-tip-layer", inputs: { targetAxis: "targetAxis", useInterpolation: "useInterpolation" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCategoryToolTipLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCategoryToolTipLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryToolTipLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-tool-tip-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCategoryToolTipLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCategoryToolTipLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { targetAxis: [{
                    type: i0.Input
                }], useInterpolation: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryToolTipLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryToolTipLayerModule() {
        }
        IgxCategoryToolTipLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryToolTipLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerModule, declarations: [IgxCategoryToolTipLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxCategoryToolTipLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxCategoryToolTipLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxCategoryToolTipLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryToolTipLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxCategoryToolTipLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryToolTipLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryToolTipLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryToolTipLayerComponent", IgxCategoryToolTipLayerComponent);
            i2.TypeRegistrar.register("CategoryToolTipLayer", CategoryToolTipLayer.$type);
        }
        IgxCategoryToolTipLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryToolTipLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerDynamicModule, imports: [i1.CommonModule, IgxCategoryToolTipLayerModule], exports: [IgxCategoryToolTipLayerModule] });
        IgxCategoryToolTipLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerDynamicModule, imports: [[i1.CommonModule, IgxCategoryToolTipLayerModule], IgxCategoryToolTipLayerModule] });
        return IgxCategoryToolTipLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryToolTipLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryToolTipLayerModule],
                        exports: [IgxCategoryToolTipLayerModule],
                        entryComponents: [IgxCategoryToolTipLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryToolTipCollisionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryToolTipCollisionInfo, _super);
        function CategoryToolTipCollisionInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.c = 0;
            _this.b = 0;
            _this.a = 0;
            return _this;
        }
        CategoryToolTipCollisionInfo.$t = i2.markType(CategoryToolTipCollisionInfo, 'CategoryToolTipCollisionInfo');
        return CategoryToolTipCollisionInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemTooltipLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemTooltipLayerFrame, _super);
        function ItemTooltipLayerFrame() {
            var _this = _super.call(this) || this;
            _this.o = null;
            _this.n = null;
            _this.g = null;
            _this.f = null;
            _this.l = null;
            _this.j = null;
            _this.i = null;
            _this.m = null;
            _this.k = null;
            _this.h = null;
            _this.o = new i2.List$1(i2.Number_$type, 0);
            _this.n = new i2.List$1(i2.Number_$type, 0);
            _this.g = new i2.List$1(i2.Number_$type, 0);
            _this.f = new i2.List$1(i2.Number_$type, 0);
            _this.l = new i2.List$1(i2.Base.$, 0);
            _this.j = new i2.List$1(i2.Base.$, 0);
            _this.i = new i2.List$1(i2.Base.$, 0);
            _this.m = new i2.List$1(i2.Number_$type, 0);
            _this.k = new i2.List$1(i2.Number_$type, 0);
            _this.h = new i2.List$1(i2.Brush.$, 0);
            return _this;
        }
        ItemTooltipLayerFrame.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            Frame.b(this.o, a, d.o, e.o);
            Frame.b(this.n, a, d.n, e.n);
            Frame.b(this.g, a, d.g, e.g);
            Frame.b(this.f, a, d.f, e.f);
            Frame.b(this.m, a, d.m, e.m);
            Frame.b(this.k, a, d.k, e.k);
            FrameExtended.a(this.h, a, d.h, e.h, 0);
            i2.InterpolationUtil.c(i2.Base.$, this.l, a, d.l, e.l, function () { return null; }, function (f, g, h, i) { return i; });
            i2.InterpolationUtil.c(i2.Base.$, this.j, a, d.j, e.j, function () { return null; }, function (f, g, h, i) { return i; });
            i2.InterpolationUtil.c(i2.Base.$, this.i, a, d.i, e.i, function () { return null; }, function (f, g, h, i) { return i; });
        };
        ItemTooltipLayerFrame.$t = i2.markType(ItemTooltipLayerFrame, 'ItemTooltipLayerFrame', Frame.$);
        return ItemTooltipLayerFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemTooltipCollisionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemTooltipCollisionInfo, _super);
        function ItemTooltipCollisionInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.e = null;
            _this.d = 0;
            _this.c = 0;
            _this.a = 0;
            _this.b = 0;
            return _this;
        }
        ItemTooltipCollisionInfo.$t = i2.markType(ItemTooltipCollisionInfo, 'ItemTooltipCollisionInfo');
        return ItemTooltipCollisionInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemToolTipLayer, _super);
        function ItemToolTipLayer() {
            var _this = _super.call(this) || this;
            var a = new ItemTooltipLayerFrame();
            var b = new ItemTooltipLayerFrame();
            var c = new ItemTooltipLayerFrame();
            var d = _this.ha / 1000;
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = ItemToolTipLayer.$;
            return _this;
        }
        ItemToolTipLayer.prototype.get_c5 = function () {
            return true;
        };
        ItemToolTipLayer.prototype.bu = function () {
            return new ItemToolTipLayerView(this);
        };
        ItemToolTipLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qm = a;
        };
        ItemToolTipLayer.prototype.get_de = function () {
            return true;
        };
        ItemToolTipLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case ItemToolTipLayer.$$p[1]:
                case ItemToolTipLayer.$$p[2]:
                    this.l0(true);
                    break;
                case ItemToolTipLayer.$$p[3]:
                    this.l0(true);
                    break;
                case ItemToolTipLayer.$$p[0]:
                    this.l0(true);
                    break;
            }
        };
        ItemToolTipLayer.prototype.p3 = function (a, b) {
            if (this.qn == null || this.qn == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        ItemToolTipLayer.prototype.pq = function (a) {
            if (!_super.prototype.pq.call(this, a)) {
                return false;
            }
            if (this.qt != null) {
                if (a.dn) {
                    var b = a.i9();
                    if (!i2.Base.equalsStatic(this.qt, b)) {
                        return false;
                    }
                }
                else {
                    if (!i2.Base.equalsStatic(this.qt, a.name)) {
                        return false;
                    }
                }
            }
            var c = this.py(a);
            if (!c.c) {
                return false;
            }
            return true;
        };
        ItemToolTipLayer.prototype.p5 = function (a, b) {
            var e_1, _a;
            var _this = this;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            var d = this.qm.b5;
            var e = this.qq;
            var f = this.qp;
            c.o.clear();
            c.i.clear();
            c.n.clear();
            c.g.clear();
            c.f.clear();
            c.l.clear();
            c.j.clear();
            c.m.clear();
            c.k.clear();
            c.h.clear();
            if (i2.isNaN_(this.qj.x) && i2.isNaN_(this.qj.y)) {
                d.count = 0;
                return;
            }
            var g = 0;
            if (this.pq(this.qn)) {
                this.qy(this.qn, c, e, f, 0);
                g++;
            }
            else {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        if (this.pq(h)) {
                            this.qy(h, c, e, f, g);
                            g++;
                        }
                        if (h.isStacked) {
                            h.ku(function (i) {
                                if (_this.pq(i)) {
                                    _this.qy(i, c, e, f, g);
                                    g++;
                                }
                                return true;
                            });
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                this.qx(c);
            }
            d.count = g;
        };
        ItemToolTipLayer.prototype.qx = function (a) {
            var b = new i2.List$1(ItemTooltipCollisionInfo.$, 0);
            for (var c = 0; c < a.f.count; c++) {
                var d = new ItemTooltipCollisionInfo();
                d.d = c;
                d.e = { $type: i2.Point_$type, x: a.f._inner[c], y: a.g._inner[c] };
                d.c = a.m._inner[c];
                d.a = a.k._inner[c];
                d.b = a.o._inner[c];
                if (i2.isNaN_(d.e.x) || i2.isNaN_(d.e.y)) {
                    continue;
                }
                b.add(d);
            }
            b.aa(function (e, f) {
                if (e.e.y < f.e.y) {
                    return -1;
                }
                if (e.e.y > f.e.y) {
                    return 1;
                }
                if (e.b < f.b) {
                    return -1;
                }
                if (e.b > f.b) {
                    return 1;
                }
                return 0;
            });
            var e = this.qo(b);
            if (!e) {
                return;
            }
            for (var f = 0; f < b.count - 1; f++) {
                var g = b._inner[f];
                var h = b._inner[f + 1];
                var i = new i2.Rect(0, g.e.x, g.e.y, g.c, g.a);
                var j = new i2.Rect(0, h.e.x, h.e.y, h.c, h.a);
                if (i.intersectsWith(j) || i.top > j.bottom) {
                    h.e = { $type: i2.Point_$type, x: h.e.x, y: i.bottom + 1 };
                }
            }
            if (b._inner[b.count - 1].e.y + b._inner[b.count - 1].a > this.bx.bu.height) {
                b._inner[b.count - 1].e = { $type: i2.Point_$type, x: b._inner[b.count - 1].e.x, y: b._inner[b.count - 1].e.y - ((b._inner[b.count - 1].e.y + b._inner[b.count - 1].a) - this.bx.bu.height) };
            }
            for (var k = b.count - 1; k >= 1; k--) {
                var l = b._inner[k];
                var m = b._inner[k - 1];
                var n = new i2.Rect(0, l.e.x, l.e.y, l.c, l.a);
                var o = new i2.Rect(0, m.e.x, m.e.y, m.c, m.a);
                if (n.intersectsWith(o) || n.top < o.bottom) {
                    m.e = { $type: i2.Point_$type, x: m.e.x, y: n.top - (o.height + 1) };
                }
            }
            for (var p = 0; p < b.count; p++) {
                var q = b._inner[p].d;
                var r = b._inner[p];
                a.f._inner[q] = r.e.x;
                a.g._inner[q] = r.e.y;
            }
        };
        ItemToolTipLayer.prototype.qo = function (a) {
            if (a.count <= 1) {
                return false;
            }
            var b = this.bx.bu;
            for (var c = 0; c < a.count - 1; c++) {
                var d = a._inner[c];
                var e = a._inner[c + 1];
                var f = new i2.Rect(0, d.e.x, d.e.y, d.c, d.a);
                var g = new i2.Rect(0, e.e.x, e.e.y, e.c, e.a);
                if (f.intersectsWith(g)) {
                    return true;
                }
            }
            return false;
        };
        ItemToolTipLayer.prototype.qy = function (a, b, c, d, e) {
            var f = this.py(a);
            if (!f.c) {
                return;
            }
            var g = a.o2(f.d, c, d);
            var h = this.qm.b5;
            var i = this.qr(a);
            var j = this.qj;
            if (!c) {
                j = this.o5(g);
            }
            var k = a.hh(j);
            var l = h.item(e);
            var m = this.bx.bu;
            var n = null;
            if (a.df && k != null) {
                n = a.au(k);
            }
            else {
                n = new i2.DataContext();
                n.item = k;
                n.series = a;
            }
            if (!this.qm.b6(a, l, i, n)) {
                return;
            }
            var o = this.qm.cg(l, i, n);
            b.i.add1(l);
            b.j.add1(n);
            b.l.add1(i);
            var p = g.x;
            var q = g.x;
            q = Math.max(q, m.left);
            q = Math.min(q, m.right);
            b.n.add(q);
            var r = g.y;
            r = Math.max(r, m.top);
            r = Math.min(r, m.bottom);
            b.o.add(r);
            var s = i2.DeviceUtils.g(10);
            var t = g.x + s;
            if (t + o.width > m.right) {
                t = (p - o.width) - s;
            }
            if (t < m.left) {
                t = m.left;
            }
            b.f.add(t);
            var u = (g.y - o.height) - s;
            if (u + o.height > m.bottom) {
                u = (m.bottom - o.height) - s;
            }
            if (u < m.top) {
                u = m.top;
            }
            b.g.add(u);
            b.m.add(o.width);
            b.k.add(o.height);
            var v = this.of;
            if (v == null) {
                v = this.oj;
            }
            if (v == null) {
                v = a.of;
            }
            b.h.add(v);
        };
        ItemToolTipLayer.prototype.qr = function (a) {
            return a.toolTip;
        };
        ItemToolTipLayer.prototype.kx = function () {
            this.qj = { $type: i2.Point_$type, x: NaN, y: NaN };
            this.qm.ce();
        };
        ItemToolTipLayer.prototype.p8 = function (a, b) {
            _super.prototype.p8.call(this, a, b);
            var c = a;
            var d = c.o.count;
            var e = b.bu.left;
            var f = b.bu.right;
            var g = b.bu.top;
            var h = b.bu.bottom;
            for (var i = 0; i < d; i++) {
                if (i2.isNaN_(c.n._inner[i]) || i2.isNaN_(c.o._inner[i]) || i2.isNaN_(c.f._inner[i]) || i2.isNaN_(c.g._inner[i]) || c.l._inner[i] == null || c.j._inner[i] == null) {
                    this.qm.cd(c.i._inner[i]);
                    continue;
                }
                var j = c.f._inner[i];
                var k = c.g._inner[i];
                var l = c.m._inner[i];
                var m = c.k._inner[i];
                var n = false;
                if (j < e && Math.abs(j - e) > 1) {
                    n = true;
                }
                if (k < g && Math.abs(k - g) > 1) {
                    n = true;
                }
                if ((j + l) > f && Math.abs((j + l) - f) > 1) {
                    n = true;
                }
                if ((k + m) > h && Math.abs((k + m) - h) > 1) {
                    n = true;
                }
                if (n) {
                    this.qm.cd(c.i._inner[i]);
                    continue;
                }
                var o = c.i._inner[i];
                var p = Math.min(c.f._inner[i], c.n._inner[i]);
                var q = Math.min(c.g._inner[i], c.o._inner[i]);
                var r = c.n._inner[i] - c.f._inner[i];
                var s = c.o._inner[i] - c.g._inner[i];
                this.qm.cf(o, p, q, r, s);
            }
        };
        ItemToolTipLayer.prototype.eg = function () {
            return true;
        };
        ItemToolTipLayer.$t = i2.markType(ItemToolTipLayer, 'ItemToolTipLayer', AnnotationLayer.$);
        ItemToolTipLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ItemToolTipLayer, 'raisePropertyChanged', ['SkipUnknownValues:qp:qz', [0, true], 'TargetSeriesName:qt:q0', [2, null], 'TargetSeries:qn:q1', [Series.$, null], 'UseInterpolation:qq:q2', [0, false]]);
        return ItemToolTipLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var ItemToolTipLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemToolTipLayerView, _super);
        function ItemToolTipLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b5 = null;
            _this.b7 = null;
            _this._htmlTest = null;
            _this.b4 = a;
            _this.b7 = new i2.List$1(PointerTooltip.$, 0);
            return _this;
        }
        ItemToolTipLayerView.prototype.as = function () {
            var _this = this;
            _super.prototype.as.call(this);
            this.b5 = ((function () {
                var $ret = new i2.Pool$1(i2.Base.$);
                $ret.create = i2.runOn(_this, _this.b8);
                $ret.activate = i2.runOn(_this, _this.ca);
                $ret.disactivate = i2.runOn(_this, _this.cc);
                $ret.destroy = i2.runOn(_this, _this.cb);
                return $ret;
            })());
            this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
        };
        ItemToolTipLayerView.prototype.aj = function () {
            _super.prototype.aj.call(this);
            for (var a = 0; a < this.b5.a.count; a++) {
                this.b5.a._inner[a].bo();
            }
            for (var b = 0; b < this.b5.b.count; b++) {
                this.b5.b._inner[b].bo();
            }
            this.b5.clear();
        };
        ItemToolTipLayerView.prototype.b8 = function () {
            var a = new PointerTooltip();
            a.bs(this.e.gw);
            a._visibility = 1;
            a.ao = this.e.ca.cf.k;
            this.b7.add(a);
            return a;
        };
        ItemToolTipLayerView.prototype.ca = function (a) {
            var b = a;
        };
        ItemToolTipLayerView.prototype.cc = function (a) {
            var b = a;
            b._visibility = 1;
        };
        ItemToolTipLayerView.prototype.cb = function (a) {
            var b = a;
            b.bv();
            b.content = null;
            this.b7.remove1(a);
        };
        Object.defineProperty(ItemToolTipLayerView.prototype, "htmlTest", {
            get: function () {
                return this._htmlTest;
            },
            set: function (a) {
                this._htmlTest = a;
            },
            enumerable: false,
            configurable: true
        });
        ItemToolTipLayerView.prototype.b6 = function (a, b, c, d) {
            var e = b;
            if (a.hr == "default") {
                a.hr = a.bx.getDefaultTooltipTemplate();
            }
            var template_ = a.hr;
            var context_ = d;
            if (a.toolTip == null) {
                return false;
            }
            var tooltip_ = a.toolTip;
            if ((tooltip_.updateToolTip)) {
                tooltip_._inPointer = true;
                tooltip_.updateToolTip(context_, true);
                tooltip_.setStyleProperty('position', 'relative');
                tooltip_.setStyleProperty('left', '');
                tooltip_.setStyleProperty('top', '');
            }
            e.content = a.toolTip;
            return true;
        };
        ItemToolTipLayerView.prototype.cg = function (a, b, c) {
            var d = a;
            var e = d.content;
            var f = new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
            d.ct = 1;
            var g = d.cs(new i2.Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
            d.ct = 0;
            return g;
        };
        ItemToolTipLayerView.prototype.cf = function (a, b, c, d, e) {
            var f = null;
            if (this.e.ca != null) {
                f = this.e.ca.cf.j.i();
            }
            var g = a;
            g.ap = f;
            var h = g.content;
            g.cn = { $type: i2.Point_$type, x: d, y: e };
            g._visibility = 0;
            g.n = b;
            g.o = c;
        };
        ItemToolTipLayerView.prototype.cd = function (a) {
            if (a != null) {
                var b = a;
                b._visibility = 1;
            }
        };
        ItemToolTipLayerView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (b) {
                return;
            }
            var c = 0;
            var d = 0;
            var e = this.e.ca;
            if (e != null) {
                var f = e.cf.j.b7();
                c += f.x;
                d += f.y;
            }
            for (var g = 0; g < this.b7.count; g++) {
                this.b7._inner[g].bu(this.b7._inner[g].n + c, this.b7._inner[g].o + d);
            }
        };
        ItemToolTipLayerView.prototype.al = function (a) {
            var e_2, _a;
            _super.prototype.al.call(this, a);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.b5.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var tooltip_ = _c.value;
                    if (tooltip_._visibility != 0) {
                        continue;
                    }
                    var b = tooltip_;
                    var c = b.a3();
                    var d = b.n;
                    var e = b.o;
                    var f = new i2.List$1(i2.String_$type, 0);
                    var g = i2.typeCast(i2.DomWrapper_$type, b.content);
                    if (g != null) {
                        var h = g.getText();
                        f.add(h);
                    }
                    this.e.a6.addPointerTooltipData(a, c, d, e, f);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        ItemToolTipLayerView.prototype.ce = function () {
            for (var a = 0; a < this.b7.count; a++) {
                this.cd(this.b7._inner[a]);
            }
        };
        ItemToolTipLayerView.$t = i2.markType(ItemToolTipLayerView, 'ItemToolTipLayerView', AnnotationLayerView.$);
        return ItemToolTipLayerView;
    }(AnnotationLayerView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents an annotation layer that displays tooltips for all target series individually.
    */
    var IgxItemToolTipLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxItemToolTipLayerComponent, _super);
        function IgxItemToolTipLayerComponent() {
            return _super.call(this) || this;
        }
        IgxItemToolTipLayerComponent.prototype.createImplementation = function () {
            return new ItemToolTipLayer();
        };
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "isAnnotationHoverLayer", {
            /**
             * Gets whether the series is an annotation layer displayed only when hovering over the chart.
            */
            get: function () {
                return this.i.c5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "isDefaultTooltipBehaviorDisabled", {
            /**
             * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
            */
            get: function () {
                return this.i.de;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "targetSeriesName", {
            /**
             * Gets or sets the name of the series series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                return this.i.qt;
            },
            set: function (v) {
                this.i.qt = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "targetSeries", {
            /**
             * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                if (this.i.qn == null) {
                    return null;
                }
                if (!this.i.qn.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.qn);
                    if (e) {
                        e._implementation = this.i.qn;
                    }
                    this.i.qn.externalObject = e;
                }
                return this.i.qn.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qn = null : this.i.qn = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "useInterpolation", {
            /**
             * Gets or sets whether to use value interpolation when drawing the tooltips.
            */
            get: function () {
                return this.i.qq;
            },
            set: function (v) {
                this.i.qq = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemToolTipLayerComponent.prototype, "skipUnknownValues", {
            /**
             * Gets or sets whether to skip past unknown values when searching for series values.
            */
            get: function () {
                return this.i.qp;
            },
            set: function (v) {
                this.i.qp = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxItemToolTipLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
                return this.targetSeries;
            }
            return null;
        };
        IgxItemToolTipLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetSeries && this.targetSeries._styling) {
                this.targetSeries._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Hides any tooltips presented by the layer, if any.
        
        */
        IgxItemToolTipLayerComponent.prototype.hideToolTips = function () {
            this.i.kx();
        };
        IgxItemToolTipLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxItemToolTipLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxItemToolTipLayerComponent, selector: "igx-item-tool-tip-layer", inputs: { targetSeriesName: "targetSeriesName", targetSeries: "targetSeries", useInterpolation: "useInterpolation", skipUnknownValues: "skipUnknownValues" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxItemToolTipLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxItemToolTipLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxItemToolTipLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-item-tool-tip-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxItemToolTipLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxItemToolTipLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { targetSeriesName: [{
                    type: i0.Input
                }], targetSeries: [{
                    type: i0.Input
                }], useInterpolation: [{
                    type: i0.Input
                }], skipUnknownValues: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxItemToolTipLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxItemToolTipLayerModule() {
        }
        IgxItemToolTipLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxItemToolTipLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerModule, declarations: [IgxItemToolTipLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxItemToolTipLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxItemToolTipLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxItemToolTipLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxItemToolTipLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxItemToolTipLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxItemToolTipLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxItemToolTipLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxItemToolTipLayerComponent", IgxItemToolTipLayerComponent);
            i2.TypeRegistrar.register("ItemToolTipLayer", ItemToolTipLayer.$type);
        }
        IgxItemToolTipLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxItemToolTipLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerDynamicModule, imports: [i1.CommonModule, IgxItemToolTipLayerModule], exports: [IgxItemToolTipLayerModule] });
        IgxItemToolTipLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerDynamicModule, imports: [[i1.CommonModule, IgxItemToolTipLayerModule], IgxItemToolTipLayerModule] });
        return IgxItemToolTipLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemToolTipLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxItemToolTipLayerModule],
                        exports: [IgxItemToolTipLayerModule],
                        entryComponents: [IgxItemToolTipLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisAnnotationFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisAnnotationFrame, _super);
        function AxisAnnotationFrame() {
            var _this = _super.call(this) || this;
            _this.n = null;
            _this.h = null;
            _this.g = null;
            _this.m = null;
            _this.j = null;
            _this.l = null;
            _this.k = null;
            _this.i = null;
            _this.y = null;
            _this.s = null;
            _this.r = null;
            _this.x = null;
            _this.u = null;
            _this.w = null;
            _this.v = null;
            _this.t = null;
            _this.p = null;
            _this.aa = null;
            _this.o = null;
            _this.z = null;
            _this.f = null;
            _this.q = null;
            _this.n = new i2.List$1(i2.Brush.$, 0);
            _this.g = new i2.List$1(i2.Brush.$, 0);
            _this.h = new i2.List$1(i2.Brush.$, 0);
            _this.j = new i2.List$1(i2.Number_$type, 0);
            _this.k = new i2.List$1(i2.Number_$type, 0);
            _this.l = new i2.List$1(i2.Number_$type, 0);
            _this.i = new i2.List$1(i2.Number_$type, 0);
            _this.m = new i2.List$1(i2.Number_$type, 0);
            _this.y = new i2.List$1(i2.Brush.$, 0);
            _this.r = new i2.List$1(i2.Brush.$, 0);
            _this.s = new i2.List$1(i2.Brush.$, 0);
            _this.u = new i2.List$1(i2.Number_$type, 0);
            _this.v = new i2.List$1(i2.Number_$type, 0);
            _this.w = new i2.List$1(i2.Number_$type, 0);
            _this.t = new i2.List$1(i2.Number_$type, 0);
            _this.x = new i2.List$1(i2.Number_$type, 0);
            _this.f = new i2.List$1(Axis.$, 0);
            _this.q = new i2.List$1(Axis.$, 0);
            _this.p = new i2.List$1(i2.Number_$type, 0);
            _this.o = new i2.List$1(i2.Number_$type, 0);
            _this.aa = new i2.List$1(i2.Number_$type, 0);
            _this.z = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        AxisAnnotationFrame.ab = function (a, b, c, d) {
            var e = c.count;
            var f = d.count;
            var g = Math.max(e, f);
            var h = 1 - b;
            if (a.count < g) {
                var i = new Array(g - a.count);
                for (var j = 0; j < g - a.count; j++) {
                    i[j] = null;
                }
                a.s(a.count, i);
            }
            if (a.count > g) {
                a.v(g, a.count - g);
            }
            for (var k = 0; k < Math.min(e, f); ++k) {
                if (b == 0) {
                    a._inner[k] = c._inner[k];
                }
                else {
                    a._inner[k] = d._inner[k];
                }
            }
            if (e < f) {
                var l = e > 0 ? c._inner[e - 1] : null;
                for (var m = e; m < f; ++m) {
                    if (b == 0) {
                        a._inner[m] = l;
                    }
                    else {
                        a._inner[m] = d._inner[m];
                    }
                }
            }
            if (e > f) {
                var n = f > 0 ? d._inner[f - 1] : null;
                for (var o = f; o < e; ++o) {
                    if (b == 0) {
                        a._inner[o] = c._inner[o];
                    }
                    else {
                        a._inner[o] = n;
                    }
                }
            }
        };
        AxisAnnotationFrame.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            FrameExtended.a(this.n, a, d.n, e.n, 0);
            FrameExtended.a(this.g, a, d.g, e.g, 0);
            FrameExtended.a(this.h, a, d.h, e.h, 0);
            Frame.b(this.j, a, d.j, e.j);
            Frame.b(this.k, a, d.k, e.k);
            Frame.b(this.l, a, d.l, e.l);
            Frame.b(this.i, a, d.i, e.i);
            Frame.b(this.m, a, d.m, e.m);
            FrameExtended.a(this.y, a, d.y, e.y, 0);
            FrameExtended.a(this.r, a, d.r, e.r, 0);
            FrameExtended.a(this.s, a, d.s, e.s, 0);
            Frame.b(this.u, a, d.u, e.u);
            Frame.b(this.v, a, d.v, e.v);
            Frame.b(this.w, a, d.w, e.w);
            Frame.b(this.t, a, d.t, e.t);
            Frame.b(this.x, a, d.x, e.x);
            AxisAnnotationFrame.ab(this.f, a, d.f, e.f);
            AxisAnnotationFrame.ab(this.q, a, d.q, e.q);
        };
        AxisAnnotationFrame.$t = i2.markType(AxisAnnotationFrame, 'AxisAnnotationFrame', Frame.$);
        return AxisAnnotationFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LinearCategorySnapper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LinearCategorySnapper, _super);
        function LinearCategorySnapper(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.g = 0;
            _this.h = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = [c, d, e, NaN, 0, f];
                        {
                            var i = g[0];
                            var j = g[1];
                            var k = g[2];
                            var l = g[3];
                            var m = g[4];
                            var n = g[5];
                            if (n > 0) {
                                _this.f = n;
                                _this.b = true;
                            }
                            _this.g = l;
                            _this.h = 0;
                            var o = Math.min(10, i2.truncate((k / _this.f)));
                            if (o > 0) {
                                var p = _this.i(i, j, o);
                                if (_this.b && p > o) {
                                    _this.g = l;
                                    p = _this.i(i, j, o - 1);
                                }
                                o = p;
                                if (k / o > _this.f * 10) {
                                    _this.h = 10;
                                }
                                else {
                                    if (k / o > _this.f * 5) {
                                        _this.h = 5;
                                    }
                                    else {
                                        if (k / o > _this.f * 2) {
                                            _this.h = 2;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        var h = _rest[5];
                        if (h > 0) {
                            _this.f = h;
                            _this.b = true;
                        }
                        _this.g = f;
                        _this.h = 0;
                        var i = Math.min(10, i2.truncate((e / _this.f)));
                        if (i > 0) {
                            var j = _this.i(c, d, i);
                            if (_this.b && j > i) {
                                _this.g = f;
                                j = _this.i(c, d, i - 1);
                            }
                            i = j;
                            if (e / i > _this.f * 10) {
                                _this.h = 10;
                            }
                            else {
                                if (e / i > _this.f * 5) {
                                    _this.h = 5;
                                }
                                else {
                                    if (e / i > _this.f * 2) {
                                        _this.h = 2;
                                    }
                                }
                            }
                        }
                    }
                    break;
            }
            return _this;
        }
        LinearCategorySnapper.prototype.i = function (a, b, c) {
            var d = Snapper.e(b - a, false);
            if (i2.isNaN_(this.g)) {
                var e = Math.max(c - 1, 1);
                this.g = Snapper.e(d / e, true);
            }
            if (this.g < 1) {
                this.g = 1;
            }
            var f = Math.floor(a / this.g) * this.g;
            var g = Math.ceil(b / this.g) * this.g;
            var h = i2.truncate(Math.round((g - f) / this.g));
            return h;
        };
        LinearCategorySnapper.$t = i2.markType(LinearCategorySnapper, 'LinearCategorySnapper', Snapper.$);
        return LinearCategorySnapper;
    }(Snapper));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available scaling behaviors of a numeric axis.
     */
    var NumericScaleMode = /*@__PURE__*/ (function (NumericScaleMode) {
        /**
         * Scale values on a linear number line.
         */
        NumericScaleMode[NumericScaleMode["Linear"] = 0] = "Linear";
        /**
         * Scale values on a logarithmic number line.
         */
        NumericScaleMode[NumericScaleMode["Logarithmic"] = 1] = "Logarithmic";
        return NumericScaleMode;
    })({});
    /**
     * @hidden
     */
    var NumericScaleMode_$type = i2.markEnum('NumericScaleMode', 'Linear,0|Logarithmic,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LogarithmicScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LogarithmicScaler, _super);
        function LogarithmicScaler() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.ae = 0;
            _this.ad = 0;
            return _this;
        }
        LogarithmicScaler.prototype.w = function (a, b, c) {
            _super.prototype.w.call(this, a, b, c);
            switch (a) {
                case NumericScaler.$$p[1]:
                    this.ae = Math.log(this.l);
                    break;
                case NumericScaler.$$p[0]:
                    this.ad = Math.log(this.k);
                    break;
            }
        };
        LogarithmicScaler.prototype.t = function (a, b, c, d, e) {
            var f;
            var g;
            var h = AutoRangeCalculator.a(a, b, c, true, a.k7, f, g);
            f = h.p5;
            g = h.p6;
            d = f;
            e = g;
            return {
                p3: d,
                p4: e
            };
        };
        LogarithmicScaler.$t = i2.markType(LogarithmicScaler, 'LogarithmicScaler', NumericScaler.$);
        return LogarithmicScaler;
    }(NumericScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StraightNumericAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StraightNumericAxisBase, _super);
        function StraightNumericAxisBase() {
            var _this = _super.call(this) || this;
            _this.l5 = null;
            _this.l9 = false;
            _this.mj();
            return _this;
        }
        StraightNumericAxisBase.prototype.a3 = function () {
            return new StraightNumericAxisBaseView(this);
        };
        StraightNumericAxisBase.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.l8 = a;
        };
        Object.defineProperty(StraightNumericAxisBase.prototype, "l7", {
            get: function () {
                return this.c(StraightNumericAxisBase.ml);
            },
            set: function (a) {
                this.h(StraightNumericAxisBase.ml, a);
            },
            enumerable: false,
            configurable: true
        });
        StraightNumericAxisBase.mh = function (a, b) {
            var c = i2.typeCast(StraightNumericAxisBase.$, a);
            c.mj();
            c.hk("Scaler", b.oldValue, b.newValue);
        };
        StraightNumericAxisBase.prototype.l6 = function () {
            return null;
        };
        StraightNumericAxisBase.prototype.get_l4 = function () {
            if (this.l5 == null) {
                this.mj();
            }
            return this.l5;
        };
        StraightNumericAxisBase.prototype.set_l4 = function (a) {
            var b = this.l5 != a;
            if (b) {
                var c = this.l5;
                this.l5 = a;
                this.hk("ActualScaler", c, a);
            }
        };
        Object.defineProperty(StraightNumericAxisBase.prototype, "l4", {
            get: function () {
                return this.get_l4();
            },
            set: function (a) {
                this.set_l4(a);
            },
            enumerable: false,
            configurable: true
        });
        StraightNumericAxisBase.prototype.lq = function (a, b, c, d, e, f, g) {
            var h = this.l4.t(a, b, c, f, g);
            f = h.p3;
            g = h.p4;
            return {
                p5: f,
                p6: g
            };
        };
        StraightNumericAxisBase.prototype.mi = function (a) {
            var b = this.l9;
            this.l9 = true;
            a();
            this.l9 = b;
        };
        StraightNumericAxisBase.prototype.mj = function () {
            var a = this.l7;
            if (a == null) {
                a = this.j9();
            }
            this.l4 = a;
            if (this.l4 == null) {
                throw new i2.ArgumentNullException(0, "ActualScaler");
            }
            this.me();
        };
        StraightNumericAxisBase.prototype.me = function () {
            this.l8.bh();
        };
        StraightNumericAxisBase.prototype.he = function (a, b, c, d) {
            if (this.l9) {
                return;
            }
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case NumericAxisBase.$$p[2]:
                    this.mj();
                    break;
                case NumericAxisBase.$$p[1]:
                    this.mj();
                    break;
                case StraightNumericAxisBase.$$p[0]:
                    this.mj();
                    break;
                case "Scaler":
                    this.mj();
                    break;
                case "ActualScaler":
                    this.kg = i2.typeCast(LogarithmicScaler.$, this.l4) !== null;
                    this.me();
                    this.cv();
                    this.hq(false);
                    break;
                case "ActualMaximumValue":
                    this.mf();
                    break;
                case "ActualMinimumValue":
                    this.mg();
                    this.mj();
                    break;
            }
        };
        StraightNumericAxisBase.prototype.mg = function () {
            this.l4.y(this.kv);
        };
        StraightNumericAxisBase.prototype.mf = function () {
            this.l4.x(this.ku);
        };
        StraightNumericAxisBase.prototype.ma = function (a, b) {
            if (a < this.kv) {
                a = this.kv;
            }
            else if (a > this.ku) {
                a = this.ku;
            }
            if (!b.cj) {
                return (a - this.kv) / (this.ku - this.kv);
            }
            else {
                return (a - this.ku) / (this.kv - this.ku);
            }
        };
        StraightNumericAxisBase.$t = i2.markType(StraightNumericAxisBase, 'StraightNumericAxisBase', NumericAxisBase.$);
        StraightNumericAxisBase.ml = i2.DependencyProperty.i("Scaler", NumericScaler.$, StraightNumericAxisBase.$, new i2.PropertyMetadata(2, null, StraightNumericAxisBase.mh));
        StraightNumericAxisBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StraightNumericAxisBase, 'hk', ['ScaleMode:l3:mk', [NumericScaleMode_$type, i2.enumGetBox(NumericScaleMode_$type, 0)]]);
        return StraightNumericAxisBase;
    }(NumericAxisBase));
    /**
     * @hidden
     */
    var StraightNumericAxisBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StraightNumericAxisBaseView, _super);
        function StraightNumericAxisBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        StraightNumericAxisBaseView.prototype.bh = function () {
            this.bg.l4.x(this.bg.ku);
            this.bg.l4.y(this.bg.kv);
        };
        StraightNumericAxisBaseView.$t = i2.markType(StraightNumericAxisBaseView, 'StraightNumericAxisBaseView', NumericAxisBaseView.$);
        return StraightNumericAxisBaseView;
    }(NumericAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VerticalLogarithmicScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalLogarithmicScaler, _super);
        function VerticalLogarithmicScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VerticalLogarithmicScaler.prototype.q = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
                c = (c * b.d.height) + b.d.top;
                c = this.ag(c, NumericScaler.ac, b.c, b.a);
                return c;
            }
            return this.ag(a, b.e, b.d, b.a);
        };
        VerticalLogarithmicScaler.prototype.p = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.af(a, NumericScaler.ac, b.c, b.a);
                c = (c - b.d.top) / b.d.height;
                c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
                return c;
            }
            return this.af(a, b.e, b.d, b.a);
        };
        VerticalLogarithmicScaler.prototype.af = function (a, b, c, d) {
            if (i2.isNaN_(a)) {
                return NaN;
            }
            var e;
            if (a <= 0) {
                e = (Math.log(this.o) - this.ae) / (this.ad - this.ae);
            }
            else {
                e = (Math.log(a) - this.ae) / (this.ad - this.ae);
            }
            if (!d) {
                e = 1 - e;
            }
            return c.top + c.height * (e - b.top) / b.height;
        };
        VerticalLogarithmicScaler.prototype.ag = function (a, b, c, d) {
            var e = b.top + b.height * (a - c.top) / c.height;
            if (!d) {
                e = 1 - e;
            }
            return Math.exp(e * (this.ad - this.ae) + this.ae);
        };
        VerticalLogarithmicScaler.$t = i2.markType(VerticalLogarithmicScaler, 'VerticalLogarithmicScaler', LogarithmicScaler.$);
        return VerticalLogarithmicScaler;
    }(LogarithmicScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LinearScaler, _super);
        function LinearScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LinearScaler.prototype.t = function (a, b, c, d, e) {
            var f;
            var g;
            var h = AutoRangeCalculator.a(a, b, c, false, -1, f, g);
            f = h.p5;
            g = h.p6;
            d = f;
            e = g;
            return {
                p3: d,
                p4: e
            };
        };
        LinearScaler.$t = i2.markType(LinearScaler, 'LinearScaler', NumericScaler.$);
        return LinearScaler;
    }(NumericScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VerticalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalLinearScaler, _super);
        function VerticalLinearScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VerticalLinearScaler.prototype.q = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
                c = (c * b.d.height) + b.d.top;
                c = this.ae(c, NumericScaler.ac, b.c, b.a);
                return c;
            }
            return this.ae(a, b.e, b.d, b.a);
        };
        VerticalLinearScaler.prototype.p = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.ad(a, NumericScaler.ac, b.c, b.a);
                c = (c - b.d.top) / b.d.height;
                c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
                return c;
            }
            return this.ad(a, b.e, b.d, b.a);
        };
        VerticalLinearScaler.prototype.v = function (a, b, c, d) {
            var e;
            var f = d.e;
            var g = d.d;
            var h = d.c;
            var i = d.a;
            var j = !h.isEmpty;
            var k = this.m;
            var l = this.o;
            var m = h.top;
            var n = h.height;
            var o = f.top;
            var p = f.height;
            var q = g.top;
            var r = g.height;
            var s = 0;
            var t = 1;
            var u = i2.ArrayAccessHelper.b(a);
            var v = false;
            if (u != null) {
                v = true;
            }
            for (var w = b; w < c; w++) {
                if (v) {
                    e = u[w];
                }
                else {
                    e = a.item(w);
                }
                if (j) {
                    var x = (e - l) / (k);
                    if (!i) {
                        x = 1 - x;
                    }
                    x = m + n * (x - s) / t;
                    var y = (x - q) / r;
                    y = q + r * (y - o) / p;
                    if (v) {
                        u[w] = y;
                    }
                    else {
                        a.item(w, y);
                    }
                }
                else {
                    var z = (e - l) / (k);
                    if (!i) {
                        z = 1 - z;
                    }
                    z = q + r * (z - o) / p;
                    if (v) {
                        u[w] = z;
                    }
                    else {
                        a.item(w, z);
                    }
                }
            }
        };
        VerticalLinearScaler.prototype.ad = function (a, b, c, d) {
            var e = (a - this.o) / (this.m);
            if (!d) {
                e = 1 - e;
            }
            return c.top + c.height * (e - b.top) / b.height;
        };
        VerticalLinearScaler.prototype.ae = function (a, b, c, d) {
            var e = b.top + b.height * (a - c.top) / c.height;
            if (!d) {
                e = 1 - e;
            }
            return this.o + e * (this.m);
        };
        VerticalLinearScaler.$t = i2.markType(VerticalLinearScaler, 'VerticalLinearScaler', LinearScaler.$);
        return VerticalLinearScaler;
    }(LinearScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FastVerticalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FastVerticalLinearScaler, _super);
        function FastVerticalLinearScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FastVerticalLinearScaler.prototype.u = function (a, b, c, d, e) {
            var f;
            var g = e.e;
            var h = e.d;
            var i = e.c;
            var j = e.a;
            var k = !i.isEmpty;
            var l = this.m;
            var m = this.o;
            var n = i.top;
            var o = i.height;
            var p = g.top;
            var q = g.height;
            var r = h.top;
            var s = h.height;
            var t = 0;
            var u = 1;
            var v = i2.ArrayAccessHelper.a(a);
            var w = false;
            if (v != null) {
                w = true;
            }
            var x;
            for (var y = 0; y < b.count; y++) {
                x = b.item(y);
                for (var z = c; z < d; z++) {
                    if (w) {
                        f = v[z];
                    }
                    else {
                        f = a.item(z);
                    }
                    if (k) {
                        var aa = (f[x] - m) / (l);
                        if (!j) {
                            aa = 1 - aa;
                        }
                        aa = n + o * (aa - t) / u;
                        var ab = (aa - r) / s;
                        ab = r + s * (ab - p) / q;
                        f[x] = ab;
                    }
                    else {
                        var ac = (f[x] - m) / (l);
                        if (!j) {
                            ac = 1 - ac;
                        }
                        ac = r + s * (ac - p) / q;
                        f[x] = ac;
                    }
                }
            }
        };
        FastVerticalLinearScaler.$t = i2.markType(FastVerticalLinearScaler, 'FastVerticalLinearScaler', VerticalLinearScaler.$);
        return FastVerticalLinearScaler;
    }(VerticalLinearScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumericYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericYAxis, _super);
        function NumericYAxis() {
            var _this = _super.call(this) || this;
            _this.ab = NumericYAxis.$;
            _this.j6 = _this.j4();
            return _this;
        }
        NumericYAxis.prototype.a3 = function () {
            return new NumericYAxisView(this);
        };
        NumericYAxis.prototype.au = function () {
            return new VerticalAxisLabelPanel();
        };
        NumericYAxis.prototype.get_cj = function () {
            return true;
        };
        NumericYAxis.prototype.d7 = function () {
            return this.js.height;
        };
        NumericYAxis.prototype.d8 = function (a, b) {
            if (this.l5 != null) {
                return this.l5.p(a, b);
            }
            return this.l4.p(a, b);
        };
        NumericYAxis.prototype.g5 = function (a, b, c, d) {
            if (this.l5 != null) {
                this.l5.v(a, b, c, d);
                return;
            }
            this.l4.v(a, b, c, d);
        };
        NumericYAxis.prototype.g4 = function (a, b, c, d, e) {
            if (this.l5 != null) {
                this.l5.u(a, b, c, d, e);
                return;
            }
            this.l4.u(a, b, c, d, e);
        };
        NumericYAxis.prototype.eb = function (a, b) {
            if (this.l5 != null) {
                return this.l5.q(a, b);
            }
            return this.l4.q(a, b);
        };
        NumericYAxis.prototype.g6 = function (a, b, c, d) {
            if (this.l5 != null) {
                this.l5.j(a, b, c, d);
                return;
            }
            this.l4.j(a, b, c, d);
        };
        NumericYAxis.prototype.mm = function (a, b) {
            if (this.bh == null || a == NaN || b == NaN) {
                return;
            }
            var c = this.ma(a, this);
            var d = this.ma(b, this);
            if (c == NaN || d == NaN) {
                return;
            }
            this.bh.pw = new i2.Rect(0, this.bh.pw.x, d, this.bh.pw.width, c - d);
        };
        NumericYAxis.prototype.j4 = function () {
            var _this = this;
            var a = _super.prototype.j4.call(this);
            a.b.c = function (b) {
                if (_this.ay == null || _this.ay.visibility == 0) {
                    _this.av.bc = b;
                    if (_this.ay != null && (_this.ay.location == 7 || _this.ay.location == 6)) {
                        _this.bh.jq();
                    }
                }
            };
            a.k = function (b, c, d) { return _this.g8(c, d, b.z, b.b, false); };
            a.l = function (b, c, d, e) { return _this.g9(c, d, e, b.z); };
            a.m = function (b, c) {
                var d = b.y;
                var e = new ScalerParams(0, b.aa, b.z, _this.cd, d);
                return _this.d8(c, e);
            };
            a.q = function (b, c) { return true; };
            a.j = function (b) { return _this.h1(b.t, b.n, b.z, b.a, true); };
            a.e = function (b) {
                b.n = _this.ay != null && (_this.ay.location == 7 || _this.ay.location == 3) ? b.z.right : b.z.left;
                var c = b.y;
                var d = new ScalerParams(0, b.aa, b.z, _this.cd, c);
                if (_this.ai != null && _this.ai.bh != null) {
                    var e = b.n;
                    var f = b.r;
                    var g = _this.hv(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                    e = g.p0;
                    f = g.p1;
                    b.n = e;
                    b.r = f;
                }
            };
            a.p = function (b, c, d) {
                var e = Math.round(c);
                return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
            };
            return a;
        };
        NumericYAxis.prototype.j7 = function (a, b, c, d) {
            var e = d;
            var f = _super.prototype.j7.call(this, a, b, c, d);
            var g = new ScalerParams(0, b, a, this.cc, c);
            var h = NaN;
            var i = NaN;
            if (!this.cc && b.top == 0) {
                i = this.ku;
            }
            else if (this.cc && b.bottom == 1) {
                h = this.ku;
            }
            if (i2.isNaN_(h)) {
                h = this.eb(e.bottom, g);
            }
            if (i2.isNaN_(i)) {
                i = this.eb(e.top, g);
            }
            var j = Math.min(h, i);
            var k = Math.max(h, i);
            this.ky = j;
            this.kx = k;
            var l = ((function () {
                var $ret = new RangeInfo();
                $ret.d = j;
                $ret.c = k;
                $ret.b = e.height;
                return $ret;
            })());
            f.k.add(l);
            return f;
        };
        NumericYAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = this.js;
            var d = this.jn();
            var e = this.jm();
            var f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        };
        NumericYAxis.prototype.h3 = function (a, b) {
            _super.prototype.h3.call(this, a, b);
            if (b.height != a.height) {
                this.cv();
            }
        };
        NumericYAxis.prototype.get_a1 = function () {
            return 1;
        };
        Object.defineProperty(NumericYAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        NumericYAxis.prototype.j9 = function () {
            if (this.kk) {
                return new VerticalLogarithmicScaler();
            }
            switch (this.l3) {
                case 0: return new FastVerticalLinearScaler();
                case 1: return new VerticalLogarithmicScaler();
            }
            return null;
        };
        NumericYAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        NumericYAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        NumericYAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        NumericYAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        NumericYAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(NumericYAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        NumericYAxis.$t = i2.markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
        return NumericYAxis;
    }(StraightNumericAxisBase));
    /**
     * @hidden
     */
    var NumericYAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericYAxisView, _super);
        function NumericYAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bi = null;
            _this.bi = a;
            return _this;
        }
        NumericYAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.jb = AxisDefaults.h;
        };
        NumericYAxisView.$t = i2.markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
        return NumericYAxisView;
    }(StraightNumericAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryXAxis, _super);
        function CategoryXAxis() {
            var _this = _super.call(this) || this;
            _this.l1 = 1;
            _this.l0 = 1;
            _this.l4 = null;
            _this.lr = 0;
            _this.ls = 0;
            _this.kd = new i2.List$1(i2.Number_$type, 0);
            _this.ab = CategoryXAxis.$;
            return _this;
        }
        CategoryXAxis.prototype.a3 = function () {
            return new CategoryXAxisView(this);
        };
        CategoryXAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.lo = a;
        };
        Object.defineProperty(CategoryXAxis.prototype, "l3", {
            get: function () {
                return this.l1;
            },
            set: function (a) {
                this.l1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryXAxis.prototype, "l2", {
            get: function () {
                return this.l0;
            },
            set: function (a) {
                this.l0 = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.prototype.au = function () {
            if (this.cz) {
                return (i2.TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        };
        CategoryXAxis.prototype.getCategorySize = function (a, b, c) {
            var d = this.jq(b, c);
            return d.width / (this.kq * a.width);
        };
        CategoryXAxis.prototype.ki = function (a, b, c) {
            var d = !i2.isNaN_(this.kf) ? i2.MathUtil.b(this.kf, 0, 1) : 0;
            var e = 0;
            if (!i2.isNaN_(this.km)) {
                e = Math.min(this.km, 1);
            }
            else {
                e = 0;
            }
            ;
            var f = 1 - 0.5 * d;
            var g = this.ks == 0 ? 1 : this.ks;
            var h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
            return h;
        };
        CategoryXAxis.prototype.getGroupCenter = function (a, b, c, d) {
            var e = 0.5;
            if (this.ks > 1) {
                var f = !i2.isNaN_(this.kf) ? i2.MathUtil.b(this.kf, 0, 1) : 0;
                var g = 0;
                if (!i2.isNaN_(this.km)) {
                    g = Math.min(this.km, 1);
                }
                var h = 1 - 0.5 * f;
                var i = h / (this.ks - (this.ks - 1) * g);
                var j = (h - i) / (this.ks - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        };
        CategoryXAxis.prototype.dv = function () {
            return this.ly;
        };
        CategoryXAxis.prototype.l9 = function (a) {
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            b = b.copy();
            var c = this.js;
            var d = this.jp();
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = new ScalerParams(0, e, e, this.cc, d);
            var g = !b.isEmpty && !c.isEmpty && this.j6 != null ? this.j6.indexOf(a) : -1;
            var h = g > -1 ? this.d8(g, f) : NaN;
            if (!i2.isNaN_(h) && this.bh.d0) {
                if (!i2.isNaN_(h)) {
                    if (h < b.left + 0.1 * b.width) {
                        h = h + 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                    if (h > b.right - 0.1 * b.width) {
                        h = h - 0.4 * b.width;
                        b.x = h - 0.5 * b.width;
                    }
                }
                this.bh.mt(b, false, true);
            }
        };
        CategoryXAxis.prototype.d8 = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.lx(a, NumericScaler.ac, b.c, this.categoryMode);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.lx(a, b.e, b.d, this.categoryMode);
        };
        CategoryXAxis.prototype.ln = function (a) {
            if (i2.typeCast(i2.List$1.$.specialize(i2.Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        };
        CategoryXAxis.prototype.g4 = function (a, b, c, d, e) {
            var f;
            var g = e.e;
            var h = e.d;
            var i = e.c;
            var j = e.a;
            var k = !i.isEmpty;
            var l = this.categoryMode == 0 ? this.kq - 1 : this.kq;
            if (l < 0) {
                l = 0;
            }
            var m = i.left;
            var n = i.width;
            var o = g.left;
            var p = g.width;
            var q = h.left;
            var r = h.width;
            var s = 0;
            var t = 1;
            var u = this.ln(a);
            var v = false;
            if (u != null) {
                v = true;
            }
            var w;
            for (var x = 0; x < b.count; x++) {
                w = b.item(x);
                for (var y = c; y < d; y++) {
                    if (v) {
                        f = u[y];
                    }
                    else {
                        f = a.item(y);
                    }
                    if (k) {
                        var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            z = 1 - z;
                        }
                        z = m + n * (z - s) / t;
                        z = (z - q) / r;
                        var aa = q + r * (z - o) / p;
                        f[w] = aa;
                    }
                    else {
                        var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = q + r * (ab - o) / p;
                        f[w] = ab;
                    }
                }
            }
        };
        CategoryXAxis.prototype.d9 = function (a, b, c) {
            if (!b.c.isEmpty) {
                var d = this.lx(a, NumericScaler.ac, b.c, c);
                d = (d - b.d.left) / b.d.width;
                d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
                return d;
            }
            return this.lx(a, b.e, b.d, c);
        };
        CategoryXAxis.prototype.lx = function (a, b, c, d) {
            var e = d == 0 ? this.kq - 1 : this.kq;
            if (e < 0) {
                e = 0;
            }
            var f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
            if (this.cd) {
                f = 1 - f;
            }
            return c.left + c.width * (f - b.left) / b.width;
        };
        CategoryXAxis.prototype.eb = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
                return c;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        };
        CategoryXAxis.prototype.ec = function (a, b, c) {
            if (!b.c.isEmpty) {
                var d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                d = (d * b.d.width) + b.d.left;
                d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
                return d;
            }
            return this.getUnscaledValue3(a, b.e, b.d, c);
        };
        CategoryXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
            var e = b.left + (a - c.left) * b.width / c.width;
            if (this.cd) {
                e = 1 - e;
            }
            var f = d == 0 ? this.kq - 1 : this.kq;
            if (f < 0) {
                f = 0;
            }
            return e * f;
        };
        CategoryXAxis.prototype.ma = function (a, b) {
            if (a == NaN || b == NaN || this.j6 == null || this.j6.count == 0) {
                return;
            }
            var c = a / this.j6.count;
            var d = (b + 1) / this.j6.count;
            this.bh.pw = new i2.Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
        };
        CategoryXAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = this.js;
            var d = this.jn();
            var e = this.jm();
            var f = new ScalerParams(0, b, c, this.cc, d);
            var g = this.a4.ay();
            var h = this.a4.a1();
            var i = this.a4.az();
            var j = this.a4.a0();
            var k = this.a4.e();
            var l = this.a4.f();
            var m = this.a4.g();
            var n = this.j6;
            var o = this.lp();
            this.h0();
            this.g0(g);
            this.g0(h);
            this.g0(i);
            this.g0(j);
            this.c5.clear();
            this.c6.clear();
            this.kd.clear();
            this.a4.at(this, b, c);
            if (b.isEmpty || c.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0 && this.bp.count == 0) {
                this.a4.y();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            if (this.itemsSource == null || o == null || n.count == 0) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
                this.a4.y();
                return;
            }
            if (!b.isEmpty && !c.isEmpty) {
                var p = this.eb(e.left, f);
                var q = this.eb(e.right, f);
                var r = 0;
                var s = false;
                if (this.cy) {
                    var t = Math.abs(q - p);
                    r = Math.ceil(t) + 1;
                    if (this.cc) {
                        if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                            s = true;
                        }
                    }
                    else {
                        if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                            s = true;
                        }
                    }
                }
                if (this.cc) {
                    p = Math.ceil(p);
                    q = Math.floor(q);
                }
                else {
                    p = Math.floor(p);
                    q = Math.ceil(q);
                }
                if (this.cy) {
                    if (Math.abs(q - p) < r) {
                        if (this.cc) {
                            if (s) {
                                q--;
                            }
                            else {
                                p++;
                            }
                        }
                        else {
                            if (s) {
                                q++;
                            }
                            else {
                                p--;
                            }
                        }
                    }
                }
                var u = c.bottom;
                var v = u - c.top;
                if (this.ai != null) {
                    var w = i2.typeCast(NumericYAxis.$, this.ai);
                    if (w != null) {
                        var x = this.hv(u, v, b, c, d, c.top, c.bottom);
                        u = x.p0;
                        v = x.p1;
                    }
                }
                this.g8(g, u, c, k, true);
                this.a4.ao(v);
                var y = Math.min(p, q);
                var z = Math.max(p, q);
                var aa = e.width;
                if (this.cy) {
                    var ab = this.d8(y, f);
                    var ac = this.d8(z, f);
                    aa = Math.abs(ac - ab);
                }
                var ad = new LinearCategorySnapper(1, y, z, aa, this.ly, this.categoryMode, this.el());
                var ae = ad.g;
                while (!this.lq() && ae < 10 && this.ct(ae, b, c, d)) {
                    ae--;
                }
                if (ad.g != ae) {
                    ad = new LinearCategorySnapper(1, y, z, aa, ae, this.categoryMode, this.el());
                }
                var af = Math.floor((y - 0) / ad.g);
                var ag = Math.ceil((z - 0) / ad.g);
                this.lt = ad.g;
                if (!i2.isNaN_(af) && !i2.isNaN_(ag)) {
                    var ah = i2.truncate(af);
                    var ai = i2.truncate(ag);
                    var aj = this.lw(0 + ah * ad.g, f);
                    var ak = this.d8(ad.g, f);
                    var al = Math.abs(ak - this.d8(0, f));
                    this.a4.ap(ak);
                    var am = i2.truncate(Math.ceil(e.right));
                    var an = i2.truncate(Math.floor(e.left));
                    var ao = this.lz;
                    var ap = ao > 0 && ao < ad.g;
                    var aq = c.right;
                    var ar = this.kd;
                    var as = ad.g;
                    var at = i2.truncate(as);
                    var au = this.ks;
                    var av = this.cc;
                    var aw = this.categoryMode;
                    this.l4 = null;
                    for (var ax = ah; ax <= ai; ++ax) {
                        var ay = this.lw(0 + (ax + 1) * ad.g, f);
                        if (aj <= aq) {
                            if (ax % 2 == 0) {
                                this.h2(h, aj, ay, c);
                            }
                            this.h1(i, aj, c, l, false);
                            ar.add(aj);
                        }
                        if (this.categoryMode != 0 && this.ks != 0 && this.cs) {
                            if (ap) {
                                var az = al * this.lz;
                                if (this.cc) {
                                    var a0 = aj;
                                    while (a0 - az > ay) {
                                        a0 -= az;
                                        if (Math.abs(a0 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.h1(j, a0, c, m, false);
                                    }
                                }
                                else {
                                    var a1 = aj;
                                    while (a1 + az < ay) {
                                        a1 += az;
                                        if (Math.abs(a1 - ay) < 0.0001) {
                                            break;
                                        }
                                        this.h1(j, a1, c, m, false);
                                    }
                                }
                                this.lu = this.lz;
                            }
                            else {
                                for (var a2 = 0; a2 < i2.truncate(ad.g); a2++) {
                                    for (var a3 = 0; a3 < this.ks; a3++) {
                                        var a4 = this.getGroupCenter(a3, b, c, d);
                                        if (this.cc) {
                                            a4 = -a4;
                                        }
                                        var a5 = this.d8(a2 + ax * ad.g, f) + a4;
                                        this.h1(j, a5, c, m, false);
                                    }
                                }
                                this.lu = 0.5;
                            }
                        }
                        var a6 = this.lv(ax * as, aj, aw == 0, f);
                        var a7 = i2.truncate(Math.round(a6));
                        if (a7 >= an && a7 <= am) {
                            var a8 = 0;
                            if (as >= 1) {
                                a8 = ax * i2.truncate(Math.floor(as));
                            }
                            else {
                                if ((ax * as) * 2 % 2 == 0) {
                                    a8 = i2.truncate(Math.floor(ax * as));
                                }
                                else {
                                    a8 = -1;
                                }
                            }
                            if (o != null && a8 < n.count && a8 >= 0) {
                                var a9 = o.getItem(a8);
                                var ba = this.fi(a9);
                                this.l4 = a9;
                                if (!i2.isNaN_(a6) && !i2.isInfinity(a6) && ba != null) {
                                    if ((typeof ba === 'string') && i2.Base.equalsStatic(ba, "")) {
                                    }
                                    else {
                                        this.c5.add1(ba);
                                        this.c6.add(new LabelPosition(a6));
                                    }
                                }
                            }
                        }
                        aj = ay;
                    }
                }
                this.l4 = null;
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.jq();
                    }
                }
                this.a4.au(this.c5, this.c6);
                this.ld();
            }
        };
        CategoryXAxis.prototype.cx = function () {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null) {
                return false;
            }
            var a = this.j6.count;
            if (a != this.l2) {
                var b = new AxisRangeChangedEventArgs(0, 1, 1, this.l2, a);
                this.l2 = a;
                this.hl(b);
                return true;
            }
            return false;
        };
        Object.defineProperty(CategoryXAxis.prototype, "ly", {
            get: function () {
                return this.c(CategoryXAxis.mb);
            },
            set: function (a) {
                this.h(CategoryXAxis.mb, a);
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.prototype.lq = function () {
            return !i2.isNaN_(this.ly);
        };
        Object.defineProperty(CategoryXAxis.prototype, "lt", {
            get: function () {
                return this.lr;
            },
            set: function (a) {
                if (this.lt != a) {
                    var b = this.lr;
                    this.lr = a;
                    this.hk("ActualInterval", b, this.lt);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.prototype.ej = function () {
            return this.lt;
        };
        Object.defineProperty(CategoryXAxis.prototype, "lz", {
            get: function () {
                return this.c(CategoryXAxis.mc);
            },
            set: function (a) {
                this.h(CategoryXAxis.mc, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryXAxis.prototype, "lu", {
            get: function () {
                return this.ls;
            },
            set: function (a) {
                if (this.lu != a) {
                    var b = this.ls;
                    this.ls = a;
                    this.hk("ActualMinorInterval", b, this.lu);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.prototype.j9 = function (a) {
            if (a == null) {
                return false;
            }
            var b = this.bd();
            if (b == null) {
                return false;
            }
            return b.synchronizeHorizontally;
        };
        CategoryXAxis.prototype.get_a1 = function () {
            return 0;
        };
        Object.defineProperty(CategoryXAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.prototype.lp = function () {
            return this.j6;
        };
        CategoryXAxis.prototype.lw = function (a, b) {
            return this.d8(a, b);
        };
        CategoryXAxis.prototype.lv = function (a, b, c, d) {
            if (!c) {
                var e = this.lw(a + 1, d);
                return (b + e) / 2;
            }
            return b;
        };
        Object.defineProperty(CategoryXAxis.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        CategoryXAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        CategoryXAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        CategoryXAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        CategoryXAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(CategoryXAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        CategoryXAxis.$t = i2.markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
        CategoryXAxis.mb = i2.DependencyProperty.i("Interval", i2.Number_$type, CategoryXAxis.$, new i2.PropertyMetadata(2, NaN, function (a, b) {
            a.hk("Interval", b.oldValue, b.newValue);
            a.hq(false);
        }));
        CategoryXAxis.mc = i2.DependencyProperty.i("MinorInterval", i2.Number_$type, CategoryXAxis.$, new i2.PropertyMetadata(2, NaN, function (a, b) {
            (i2.typeCast(CategoryXAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
            (i2.typeCast(CategoryXAxis.$, a)).hq(false);
        }));
        return CategoryXAxis;
    }(CategoryAxisBase));
    /**
     * @hidden
     */
    var CategoryXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryXAxisView, _super);
        function CategoryXAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        CategoryXAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.e0 = AxisDefaults.f;
        };
        CategoryXAxisView.$t = i2.markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
        return CategoryXAxisView;
    }(CategoryAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisAnnotationFrameManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisAnnotationFrameManager, _super);
        function AxisAnnotationFrameManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AxisAnnotationFrameManager.e = function (a, b, c) {
            var d = new i2.Color();
            if (i2.typeCast(i2.LinearGradientBrush.$, a) !== null) {
                if (a.gradientStops == null || a.gradientStops.length < 1) {
                    var e = new i2.Brush();
                    e.color = b;
                    return e;
                }
                d = a.gradientStops[0].color;
            }
            else {
                d = a.color;
            }
            var f = i2.ColorUtil.a(d);
            var g = i2.ColorUtil.a(c);
            var h = i2.ColorUtil.a(b);
            var i = (f[3] + 0.05) / (h[3] + 0.05);
            var j = (g[3] + 0.05) / (f[3] + 0.05);
            if (i > j) {
                var k = new i2.Brush();
                k.color = b;
            }
            var l = new i2.Brush();
            l.color = c;
            return l;
        };
        AxisAnnotationFrameManager.c = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r) {
            var s = c.ag();
            var t = null;
            var u = null;
            for (var v = 0; v < s.length; v++) {
                if (s[v].cj) {
                    u = s[v];
                }
                else {
                    t = s[v];
                }
            }
            var w = i2.Color.u(255, 102, 102, 102);
            var x = i2.Color.u(255, 255, 255, 255);
            if (t != null) {
                var y = new ScalerParams(1, d.pg, t.js, t.cc);
                y.c = e;
                var z = t.eb(b.x, y);
                a.p.add(z);
                a.o.add(z);
                if (g != null) {
                    a.g.add(g);
                }
                else {
                    a.g.add(f);
                }
                if (h != null) {
                    a.n.add(h);
                }
                else {
                    a.n.add(AxisAnnotationFrameManager.e(a.g._inner[a.g.count - 1], w, x));
                }
                a.j.add(j.c);
                a.l.add(j.e);
                a.k.add(j.d);
                a.i.add(j.b);
                if (!i2.isNaN_(k)) {
                    a.m.add(k);
                }
                else {
                    a.m.add(NaN);
                }
                if (i != null) {
                    a.h.add(i);
                }
                else {
                    a.h.add(null);
                }
                if (q) {
                    a.f.add(t);
                }
                else {
                    a.f.add(null);
                }
            }
            if (u != null) {
                var aa = new ScalerParams(1, d.pg, u.js, u.cc);
                aa.c = e;
                var ab = u.eb(b.y, aa);
                a.aa.add(ab);
                a.z.add(ab);
                if (l != null) {
                    a.r.add(l);
                }
                else {
                    a.r.add(f);
                }
                if (m != null) {
                    a.y.add(m);
                }
                else {
                    a.y.add(AxisAnnotationFrameManager.e(a.r._inner[a.r.count - 1], w, x));
                }
                a.u.add(o.c);
                a.w.add(o.e);
                a.v.add(o.d);
                a.t.add(o.b);
                if (!i2.isNaN_(p)) {
                    a.x.add(p);
                }
                else {
                    a.x.add(NaN);
                }
                if (n != null) {
                    a.s.add(n);
                }
                else {
                    a.s.add(null);
                }
                if (r) {
                    a.q.add(u);
                }
                else {
                    a.q.add(null);
                }
            }
        };
        AxisAnnotationFrameManager.b = function (a) {
            a.f.clear();
            a.q.clear();
            a.p.clear();
            a.aa.clear();
            a.o.clear();
            a.z.clear();
            a.g.clear();
            a.h.clear();
            a.j.clear();
            a.l.clear();
            a.k.clear();
            a.i.clear();
            a.m.clear();
            a.n.clear();
            a.r.clear();
            a.s.clear();
            a.u.clear();
            a.w.clear();
            a.v.clear();
            a.t.clear();
            a.x.clear();
            a.y.clear();
        };
        AxisAnnotationFrameManager.a = function (a, b, c) {
            if (!b.ce) {
                return a;
            }
            var d = 0;
            if (c >= 0) {
                d = c;
            }
            else {
                var e = b.ej();
                d = e == 0 ? 0 : i2.truncate(Math.max(-Math.floor(i2.log10(e)), 0));
                d += 1;
            }
            return i2.round10N(a, d);
        };
        AxisAnnotationFrameManager.d = function (a, b, c, d, e, f, g, h, i, j) {
            var k = new i2.List$1(Axis.$, 0);
            var l = new i2.HashSet$1(Axis.$, 0);
            var m = new i2.Dictionary$2(Axis.$, i2.Number_$type, 0);
            var _loop_1 = function (n) {
                var o = b.f._inner[n];
                if (o != null) {
                    if (!l.contains(o)) {
                        k.add(o);
                        m.item(o, 0);
                        l.add_1(o);
                    }
                    var p = void 0;
                    if (!d.containsKey(o)) {
                        p = new i2.Pool$1(AxisAnnotation.$);
                        p.create = function () { return new AxisAnnotation(); };
                        p.destroy = function (q) {
                        };
                        p.activate = function (q) { return o.an.add(q); };
                        p.disactivate = function (q) { return o.an.remove(q); };
                        d.item(o, p);
                        e.add(o);
                    }
                    else {
                        p = d.item(o);
                    }
                    var q = p.item(m.item(o));
                    m.item(o, m.item(o) + 1);
                    q.k = false;
                    q.value = b.o._inner[n];
                    var r = b.p._inner[n];
                    if (i != null) {
                        var s = i(r);
                        q.text = s;
                    }
                    else {
                        r = AxisAnnotationFrameManager.a(r, o, g);
                        if (o.bh != null) {
                            q.text = o.fw(r);
                        }
                    }
                    q.textColor = b.n._inner[n];
                    q.background = b.g._inner[n];
                    q.backgroundPadding = new i2.Thickness(1, b.j._inner[n], b.l._inner[n], b.k._inner[n], b.i._inner[n]);
                    q.outline = b.h._inner[n];
                    q.strokeThickness = b.m._inner[n];
                    if (q.k) {
                        q.k = false;
                        c = true;
                    }
                }
            };
            for (var n = 0; n < b.p.count; n++) {
                _loop_1(n);
            }
            var _loop_2 = function (t) {
                var u = b.q._inner[t];
                if (u != null) {
                    if (!l.contains(u)) {
                        k.add(u);
                        m.item(u, 0);
                        l.add_1(u);
                    }
                    var v = void 0;
                    if (!d.containsKey(u)) {
                        v = new i2.Pool$1(AxisAnnotation.$);
                        v.create = function () { return new AxisAnnotation(); };
                        v.destroy = function (w) {
                        };
                        v.activate = function (w) { return u.an.add(w); };
                        v.disactivate = function (w) { return u.an.remove(w); };
                        d.item(u, v);
                        e.add(u);
                    }
                    else {
                        v = d.item(u);
                    }
                    var w = v.item(m.item(u));
                    m.item(u, m.item(u) + 1);
                    w.k = false;
                    var x = b.aa._inner[t];
                    w.value = b.z._inner[t];
                    if (j != null) {
                        var y = j(x);
                        w.text = y;
                    }
                    else {
                        x = AxisAnnotationFrameManager.a(x, u, h);
                        if (u.bh != null) {
                            w.text = u.fw(x);
                        }
                    }
                    w.textColor = b.y._inner[t];
                    w.background = b.r._inner[t];
                    w.backgroundPadding = new i2.Thickness(1, b.u._inner[t], b.w._inner[t], b.v._inner[t], b.t._inner[t]);
                    w.outline = b.s._inner[t];
                    w.strokeThickness = b.x._inner[t];
                    if (w.k) {
                        w.k = false;
                        c = true;
                    }
                }
            };
            for (var t = 0; t < b.aa.count; t++) {
                _loop_2(t);
            }
            for (var z = 0; z < k.count; z++) {
                if (d.containsKey(k._inner[z])) {
                    var aa = d.item(k._inner[z]);
                    aa.count = m.item(k._inner[z]);
                }
            }
            for (var ab = e.count - 1; ab >= 0; ab--) {
                if (!l.contains(e._inner[ab])) {
                    c = true;
                    var ac = d.item(e._inner[ab]);
                    ac.count = 0;
                    ac.activate = null;
                    ac.create = null;
                    ac.destroy = null;
                    ac.disactivate = null;
                    d.removeItem(e._inner[ab]);
                    e.removeAt(ab);
                }
            }
            if (c && f) {
                for (var ad = 0; ad < k.count; ad++) {
                    var ae = k._inner[ad];
                    if (ae.a5.c) {
                        ae.g2(true);
                        ae.a5.c = false;
                    }
                }
            }
        };
        AxisAnnotationFrameManager.$t = i2.markType(AxisAnnotationFrameManager, 'AxisAnnotationFrameManager');
        return AxisAnnotationFrameManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ValueOverlay, _super);
        function ValueOverlay() {
            var _this = _super.call(this) || this;
            _this.py = 0;
            _this.pz = 0;
            _this.pv = 0;
            _this.pj = null;
            _this.pp = null;
            _this.po = null;
            _this.ab = ValueOverlay.$;
            return _this;
        }
        ValueOverlay.prototype.f8 = function (a, b, c) {
            return this.p0;
        };
        ValueOverlay.prototype.pw = function (a, b) {
            var c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
            var d = Math.acos((a.x - b.x) / c);
            if ((a.y - b.y) < 0) {
                d = (2 * Math.PI) - d;
            }
            return d;
        };
        ValueOverlay.prototype.o2 = function (a, b, c) {
            if (this.pi == null) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            var d = this.px();
            var e = NaN;
            var f = NaN;
            var g = NaN;
            var h = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            var i = NaN;
            switch (this.pi.a1) {
                case 2:
                    i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                    g = d;
                    e = h.x + Math.cos(g) * i;
                    f = h.y + Math.sin(g) * i;
                    f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
                    e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
                    break;
                case 0:
                    e = d;
                    f = a.y;
                    f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
                    break;
                case 1:
                    f = d;
                    e = a.x;
                    e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
                    break;
                case 3:
                    g = this.pw(a, h);
                    i = d;
                    e = h.x + Math.cos(g) * i;
                    f = h.y + Math.sin(g) * i;
                    f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
                    e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
                    break;
            }
            return { $type: i2.Point_$type, x: e, y: f };
        };
        ValueOverlay.prototype.g0 = function (a) {
            throw new i2.NotImplementedException(0);
        };
        ValueOverlay.prototype.hh = function (a) {
            return this;
        };
        ValueOverlay.prototype.eh = function (a) {
            return false;
        };
        ValueOverlay.prototype.ap = function (a) {
            var b = i2.typeCast(NumericAxisBase.$, a);
            var c = this.p0;
            if (i2.isNaN_(c) || i2.isInfinity(c)) {
                return null;
            }
            return new AxisRange(c, c);
        };
        ValueOverlay.prototype.l1 = function (a) {
            this.kh(true, this.bx);
            if (!this.pn()) {
                if (this.pj != null) {
                    this.qi(NaN, this.cr());
                }
                return;
            }
            if (this.ei(a)) {
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    var b = this.py;
                    this.py = this.pz;
                    this.pz = b;
                }
                else {
                    this.py = this.pv;
                }
                this.pv = this.px();
                this.l8();
            }
            else {
                this.pv = this.px();
                this.qh(this.pv, this.pl);
            }
        };
        ValueOverlay.prototype.px = function () {
            var a, b;
            var c = this.getViewInfo(b, a);
            b = c.p0;
            a = c.p1;
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, a, b, this.pi.cc, d);
            return this.pi.d8(this.p0, e);
        };
        ValueOverlay.prototype.qh = function (a, b) {
            if (this.pi == null) {
                return;
            }
            var c = i2.typeCast(CategoryAxisBase.$, this.pi);
            if (c != null && !c.b9) {
                if (this.p0 > c.kr - 1) {
                    return;
                }
                if (c.categoryMode != 0) {
                    var d = this.getEffectiveViewport1(b);
                    var e = 0.5 * c.getCategorySize(b.bv, b.bu, d);
                    var f = false;
                    if (c.cj && !c.cc) {
                        f = true;
                    }
                    if (i2.typeCast(CategoryXAxis.$, c) !== null && c.cc) {
                        f = true;
                    }
                    if (f) {
                        e = -e;
                    }
                    a += e;
                }
            }
            var g = i2.typeCast(NumericAxisBase.$, this.pi);
            if (g != null) {
                if (this.p0 < g.kv || this.p0 > g.ku) {
                    return;
                }
                if (g.kl && this.p0 < 0) {
                    return;
                }
            }
            var h;
            switch (this.pi.a1) {
                case 2:
                case 3:
                    h = this.pi.jk(a, b.bv, b.bu, this.getEffectiveViewport1(b), this.o7(b));
                    break;
                default:
                    h = this.pi.jk(a, b.bv, b.bu);
                    break;
            }
            if (h != null) {
                b.by(h);
            }
            if (!b.q) {
                this.qi(a, this.cr());
            }
        };
        ValueOverlay.prototype.e3 = function (a, b, c) {
            var d = true;
            d = _super.prototype.e3.call(this, a, b, c);
            if (!c.o() || b.isEmpty || a.isEmpty || this.pi == null || this.pi.bh == null) {
                d = false;
            }
            return d;
        };
        ValueOverlay.prototype.mn = function (a, b) {
            this.l0(false);
        };
        ValueOverlay.prototype.mm = function (a, b) {
            this.l0(false);
        };
        ValueOverlay.prototype.kk = function (a, b, c, d) {
            throw new i2.NotImplementedException(0);
        };
        ValueOverlay.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case ValueOverlay.$$p[10]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.pz = this.py + this.gn * (this.pv - this.py);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.qh(this.pv, this.pl);
                    }
                    else {
                        this.qh(this.pz, this.pl);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case ValueOverlay.$$p[12]:
                    var e = i2.typeCast(NumericAxisBase.$, this.pi);
                    if (e != null) {
                        e.cv();
                    }
                    this.l0(true);
                    this.k8();
                    break;
                case ValueOverlay.$$p[11]:
                case ValueOverlay.$$p[9]:
                case ValueOverlay.$$p[0]:
                case ValueOverlay.$$p[2]:
                case ValueOverlay.$$p[3]:
                case ValueOverlay.$$p[8]:
                case ValueOverlay.$$p[4]:
                case ValueOverlay.$$p[5]:
                case ValueOverlay.$$p[6]:
                case ValueOverlay.$$p[7]:
                    this.l0(true);
                    break;
            }
        };
        ValueOverlay.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.pi != null) {
                this.pi.hq(false);
            }
        };
        ValueOverlay.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.bx();
        };
        ValueOverlay.prototype.pn = function () {
            if (this.pi == null || this.pi.bh == null || i2.isNaN_(this.p0) || this._visibility != 0) {
                return false;
            }
            var a = i2.typeCast(CategoryAxisBase.$, this.pi);
            if (a != null && a.kr == 0) {
                return false;
            }
            return true;
        };
        ValueOverlay.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        Object.defineProperty(ValueOverlay.prototype, "categoryAxis", {
            get: function () {
                return i2.typeCast(CategoryAxisBase.$, this.pi);
            },
            enumerable: false,
            configurable: true
        });
        ValueOverlay.prototype.bu = function () {
            return new ValueOverlayView(this);
        };
        ValueOverlay.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.pl = i2.typeCast(ValueOverlayView.$, a);
        };
        ValueOverlay.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw) || !this.pn()) {
                return;
            }
            var c = this.getEffectiveViewport1(this.bx);
            var d = this.pi.d8(this.p0, new ScalerParams(0, this.bw.bv, a, this.pi.cc, c));
            this.qh(d, i2.typeCast(ValueOverlayView.$, this.bw));
            this.et = false;
        };
        ValueOverlay.prototype.getOffsetValue = function () {
            return 0;
        };
        ValueOverlay.prototype.getCategoryWidth = function () {
            return 0;
        };
        Object.defineProperty(ValueOverlay.prototype, "qz", {
            get: function () {
                return new i2.Thickness(1, this.pr, this.pt, this.ps, this.pq);
            },
            enumerable: false,
            configurable: true
        });
        ValueOverlay.prototype.ag = function () {
            return [this.pi];
        };
        ValueOverlay.prototype.qi = function (a, b) {
            if (i2.isNaN_(a)) {
                if (this.pj != null) {
                    AxisAnnotationFrameManager.b(this.pj);
                    AxisAnnotationFrameManager.d(this, this.pj, true, this.po, this.pp, b, this.p1, this.p1, this.pk, this.pk);
                }
                return;
            }
            var c = false;
            if (this.po == null) {
                c = true;
                this.pp = new i2.List$1(Axis.$, 0);
                this.po = new i2.Dictionary$2(Axis.$, i2.Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            this.pj = new AxisAnnotationFrame();
            var d = this.of;
            if (d == null) {
                d = this.oj;
            }
            var e = this.pi.cj;
            AxisAnnotationFrameManager.c(this.pj, { $type: i2.Point_$type, x: a, y: a }, this, this.ca, this.getEffectiveViewport(), d, this.qw, this.qy, this.qx, this.qz, this.pu, this.qw, this.qy, this.qx, this.qz, this.pu, !e && this.pm, e && this.pm);
            AxisAnnotationFrameManager.d(this, this.pj, c, this.po, this.pp, b, this.p1, this.p1, this.pk, this.pk);
        };
        ValueOverlay.prototype.get_ed = function () {
            return true;
        };
        ValueOverlay.prototype.qd = function (a) {
            if (this.pi != null) {
                return this.pi.fw(a);
            }
            return null;
        };
        Object.defineProperty(ValueOverlay.prototype, "qf", {
            get: function () {
                var a = this.qd(this.p0);
                return a != null ? a : i2.stringFormat("{0:0.##}", this.p0);
            },
            enumerable: false,
            configurable: true
        });
        ValueOverlay.$t = i2.markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
        ValueOverlay.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackground:qw:qj', [i2.Brush.$, null], 'AxisAnnotationFormatLabel:pk:qk', [i2.Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:p1:ql', [1, -1], 'AxisAnnotationOutline:qx:qm', [i2.Brush.$, null], 'AxisAnnotationPaddingBottom:pq:qn', [1, NaN], 'AxisAnnotationPaddingLeft:pr:qo', [1, NaN], 'AxisAnnotationPaddingRight:ps:qp', [1, NaN], 'AxisAnnotationPaddingTop:pt:qq', [1, NaN], 'AxisAnnotationStrokeThickness:pu:qr', [1, NaN], 'AxisAnnotationTextColor:qy:qs', [i2.Brush.$, null], 'Axis:pi:qt', [Axis.$, null], 'IsAxisAnnotationEnabled:pm:qu', [0, false], 'Value:p0:qv', [1, 0]]);
        return ValueOverlay;
    }(Series));
    /**
     * @hidden
     */
    var ValueOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ValueOverlayView, _super);
        function ValueOverlayView(a) {
            var _this = _super.call(this, a) || this;
            _this.bz = null;
            _this.bz = new i2.Path();
            return _this;
        }
        ValueOverlayView.prototype.bb = function () {
            _super.prototype.bb.call(this);
            this.bz._stroke = this.e.of;
            this.bz.ac = this.e.fl;
            this.bz.ai = this.e.os;
            this.bz.ad = this.e.ot;
        };
        ValueOverlayView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.bz._stroke = a;
            this.bz.ac = this.e.fl + 3;
            this.bz._stroke = a;
            this.bz.ac = this.e.fl + 3;
        };
        ValueOverlayView.prototype.by = function (a) {
            this.bz.ak = a;
            this.aq();
        };
        ValueOverlayView.prototype.bx = function () {
            this.bz.ak = null;
            this.aq();
        };
        ValueOverlayView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                a.s(this.bz);
            }
        };
        ValueOverlayView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.bz, "ValueOverlayPath", []);
        };
        ValueOverlayView.$t = i2.markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
        return ValueOverlayView;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents the class of the value overlay. The value overlay is a line or circle representing a value on an axis.
    */
    var IgxValueOverlayComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxValueOverlayComponent, _super);
        function IgxValueOverlayComponent() {
            return _super.call(this) || this;
        }
        IgxValueOverlayComponent.prototype.createImplementation = function () {
            return new ValueOverlay();
        };
        Object.defineProperty(IgxValueOverlayComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axis", {
            /**
             * Gets or sets the axis used by the value overlay.
            */
            get: function () {
                if (this.i.pi == null) {
                    return null;
                }
                if (!this.i.pi.externalObject) {
                    var e = IgxAxisComponent._createFromInternal(this.i.pi);
                    if (e) {
                        e._implementation = this.i.pi;
                    }
                    this.i.pi.externalObject = e;
                }
                return this.i.pi.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pi = null : this.i.pi = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "value", {
            /**
             * Gets or sets the value of the overlay.
            */
            get: function () {
                return this.i.p0;
            },
            set: function (v) {
                this.i.p0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "isAxisAnnotationEnabled", {
            /**
             * Gets or sets whether to draw annotations over the axes where the crosshair meets with them.
            */
            get: function () {
                return this.i.pm;
            },
            set: function (v) {
                this.i.pm = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationFormatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for the axis annotation.
            */
            get: function () {
                return this.i.pk;
            },
            set: function (v) {
                this.i.pk = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationTextColor", {
            /**
             * Gets or sets the color to use for the axis annotation text. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.qy);
            },
            set: function (v) {
                this.i.qy = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationBackground", {
            /**
             * Gets or sets the color to use for the axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.qw);
            },
            set: function (v) {
                this.i.qw = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationInterpolatedValuePrecision", {
            /**
             * Gets or sets the precision to use displaying values for interpolated positions.
            */
            get: function () {
                return this.i.p1;
            },
            set: function (v) {
                this.i.p1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationOutline", {
            /**
             * Gets or sets the color to use for the axis annotation outline. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.qx);
            },
            set: function (v) {
                this.i.qx = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationPaddingLeft", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.pr;
            },
            set: function (v) {
                this.i.pr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationPaddingTop", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.pt;
            },
            set: function (v) {
                this.i.pt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationPaddingRight", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.ps;
            },
            set: function (v) {
                this.i.ps = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationPaddingBottom", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.pq;
            },
            set: function (v) {
                this.i.pq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "axisAnnotationStrokeThickness", {
            /**
             * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.pu;
            },
            set: function (v) {
                this.i.pu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "isValueOverlay", {
            /**
             * Gets whether the series is a value overlay.
            */
            get: function () {
                return this.i.ed;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueOverlayComponent.prototype, "labelResolved", {
            get: function () {
                return this.i.qf;
            },
            enumerable: false,
            configurable: true
        });
        IgxValueOverlayComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.axis && this.axis.name && this.axis.name == name) {
                return this.axis;
            }
            return null;
        };
        IgxValueOverlayComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.axis && this.axis._styling) {
                this.axis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxValueOverlayComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxValueOverlayComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Gets the item item index associated with the specified world position
        
        * @param world
        */
        IgxValueOverlayComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxValueOverlayComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
        IgxValueOverlayComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Gets the label for a data item.
        
        * @param value  * The unscaled value to get a label for.
        */
        IgxValueOverlayComponent.prototype.getLabel = function (value) {
            var iv = this.i.qd(value);
            return (iv);
        };
        IgxValueOverlayComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxValueOverlayComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxValueOverlayComponent, selector: "igx-value-overlay", inputs: { axis: "axis", value: "value", isAxisAnnotationEnabled: "isAxisAnnotationEnabled", axisAnnotationFormatLabel: "axisAnnotationFormatLabel", axisAnnotationTextColor: "axisAnnotationTextColor", axisAnnotationBackground: "axisAnnotationBackground", axisAnnotationInterpolatedValuePrecision: "axisAnnotationInterpolatedValuePrecision", axisAnnotationOutline: "axisAnnotationOutline", axisAnnotationPaddingLeft: "axisAnnotationPaddingLeft", axisAnnotationPaddingTop: "axisAnnotationPaddingTop", axisAnnotationPaddingRight: "axisAnnotationPaddingRight", axisAnnotationPaddingBottom: "axisAnnotationPaddingBottom", axisAnnotationStrokeThickness: "axisAnnotationStrokeThickness" }, providers: [{ provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxValueOverlayComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxValueOverlayComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-value-overlay',
                        template: "",
                        providers: [{ provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxValueOverlayComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { axis: [{
                    type: i0.Input
                }], value: [{
                    type: i0.Input
                }], isAxisAnnotationEnabled: [{
                    type: i0.Input
                }], axisAnnotationFormatLabel: [{
                    type: i0.Input
                }], axisAnnotationTextColor: [{
                    type: i0.Input
                }], axisAnnotationBackground: [{
                    type: i0.Input
                }], axisAnnotationInterpolatedValuePrecision: [{
                    type: i0.Input
                }], axisAnnotationOutline: [{
                    type: i0.Input
                }], axisAnnotationPaddingLeft: [{
                    type: i0.Input
                }], axisAnnotationPaddingTop: [{
                    type: i0.Input
                }], axisAnnotationPaddingRight: [{
                    type: i0.Input
                }], axisAnnotationPaddingBottom: [{
                    type: i0.Input
                }], axisAnnotationStrokeThickness: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxValueOverlayModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxValueOverlayModule() {
        }
        IgxValueOverlayModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxValueOverlayModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayModule, declarations: [IgxValueOverlayComponent], imports: [i1.CommonModule], exports: [IgxValueOverlayComponent] });
        IgxValueOverlayModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayModule, imports: [[i1.CommonModule]] });
        return IgxValueOverlayModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxValueOverlayComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxValueOverlayComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxValueOverlayDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxValueOverlayDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxValueOverlayComponent", IgxValueOverlayComponent);
            i2.TypeRegistrar.register("ValueOverlay", ValueOverlay.$type);
        }
        IgxValueOverlayDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxValueOverlayDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayDynamicModule, imports: [i1.CommonModule, IgxValueOverlayModule], exports: [IgxValueOverlayModule] });
        IgxValueOverlayDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayDynamicModule, imports: [[i1.CommonModule, IgxValueOverlayModule], IgxValueOverlayModule] });
        return IgxValueOverlayDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueOverlayDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxValueOverlayModule],
                        exports: [IgxValueOverlayModule],
                        entryComponents: [IgxValueOverlayComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IAnnotationInfoProvider_$type = new i2.Type(null, 'IAnnotationInfoProvider');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnnotationInfoProvider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnnotationInfoProvider, _super);
        function AnnotationInfoProvider() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnnotationInfoProvider.$t = i2.markType(AnnotationInfoProvider, 'AnnotationInfoProvider');
        return AnnotationInfoProvider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisAnnotationManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisAnnotationManager, _super);
        function AxisAnnotationManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._owner = null;
            return _this;
        }
        Object.defineProperty(AxisAnnotationManager.prototype, "owner", {
            get: function () {
                return this._owner;
            },
            set: function (a) {
                this._owner = a;
            },
            enumerable: false,
            configurable: true
        });
        AxisAnnotationManager.prototype.onAddAnnotations = function (a) {
            var b = 0;
            for (var c = 0; c < a.an.count; c++) {
                b = this.a(a, a.an._inner[c], b);
            }
            for (var d = 0; d < a.am.count; d++) {
                b = this.a(a, a.am._inner[d], b);
            }
            a.bo.count = b;
            a.bp.count = b;
        };
        AxisAnnotationManager.prototype.a = function (a, b, c) {
            var d = NaN;
            d = b.value;
            var e = new LabelPosition(a.en(d));
            if (a.b7) {
                var f = a;
                if (f.categoryMode == 2) {
                    var g = a.bh.pg;
                    var h = a.js;
                    var i = a.jn();
                    e.c += (a.cc ? -f.getCategorySize(g, h, i) * 0.5 : f.getCategorySize(g, h, i) * 0.5);
                }
            }
            var j = e.c;
            if (a.cj) {
                if (e.c > a.js.bottom || e.c < a.js.top) {
                    return c;
                }
            }
            else {
                if (e.c > a.js.right || e.c < a.js.left) {
                    return c;
                }
            }
            var k = a.bo.item(c);
            var l = a.bp.item(c);
            var m = 100 + c * 2;
            c++;
            l.ak = b.resolveLabelValue();
            if (b.textColor != null) {
                l.am = b.textColor;
            }
            k._fill = b.background;
            k._stroke = b.outline;
            k.ac = b.strokeThickness;
            k.s = m;
            l.s = m + 1;
            b.checkForExtentReset(function () { return e.b = true; });
            e.a = true;
            e.d = b.backgroundPadding;
            a.c6.add(e);
            a.c5.add1(l.ak);
            return c;
        };
        AxisAnnotationManager.prototype.arrangeAnnotations = function (a, b, c, d, e, f, g, h, i, j) {
            for (var k = 0; k < a.bp.count; k++) {
                var l = a.bo.item(k);
                var m = -1;
                for (var n = c.count - 1; n >= 0; n--) {
                    if (c._inner[n] == a.bp.item(k)) {
                        m = n;
                        break;
                    }
                }
                if (m == -1) {
                    continue;
                }
                if (e) {
                    b.z(l, a.bp.item(k), a.c6._inner[m], d._inner[m], g, h, i, j);
                    b.aq(l, a.bp.item(k), a.c6._inner[m], d._inner[m], g, h, i, j, f);
                }
                else {
                    b.z(l, a.bp.item(k), a.c6._inner[m], d._inner[m], g, h, i, j);
                }
            }
        };
        AxisAnnotationManager.prototype.b = function (a, b) {
            this.owner.ck = true;
            this.owner.hp();
        };
        AxisAnnotationManager.prototype.c = function (a) {
            if (a.oldItems != null) {
                for (var b = 0; b < a.oldItems.count; b++) {
                    var c = a.oldItems.item(b);
                    if (c == null) {
                        continue;
                    }
                    var d = c;
                    d.propertyChanged = i2.delegateRemove(d.propertyChanged, i2.runOn(this, this.b));
                }
            }
            if (a.newItems != null) {
                for (var e = 0; e < a.newItems.count; e++) {
                    var f = a.newItems.item(e);
                    if (f == null) {
                        continue;
                    }
                    var g = f;
                    g.propertyChanged = i2.delegateCombine(g.propertyChanged, i2.runOn(this, this.b));
                }
            }
            this.owner.ck = true;
            this.owner.hp();
        };
        AxisAnnotationManager.prototype.onAnnotionsChanged = function (a, b, c) {
            this.c(c);
        };
        AxisAnnotationManager.prototype.onAnnotionsReset = function (a, b, c) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    d.propertyChanged = i2.delegateRemove(d.propertyChanged, i2.runOn(this, this.b));
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        AxisAnnotationManager.prototype.onAutoAnnotionsChanged = function (a, b, c) {
            this.c(c);
        };
        AxisAnnotationManager.prototype.onAutoAnnotionsReset = function (a, b, c) {
            var e_2, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    d.propertyChanged = i2.delegateRemove(d.propertyChanged, i2.runOn(this, this.b));
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        AxisAnnotationManager.$t = i2.markType(AxisAnnotationManager, 'AxisAnnotationManager', i2.Base.$, [IAxisAnnotationManager_$type]);
        return AxisAnnotationManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnnotationFactoryManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnnotationFactoryManager, _super);
        function AnnotationFactoryManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnnotationFactoryManager.register = function () {
            if (!AnnotationFactoryManager.a) {
                i2.DVContainer.instance.registerFactory(IAnnotationInfoProvider_$type, function () { return new AnnotationInfoProvider(); });
                i2.DVContainer.instance.registerFactory(IAxisAnnotationManager_$type, function () { return new AxisAnnotationManager(); });
                AnnotationFactoryManager.a = true;
            }
        };
        AnnotationFactoryManager.$t = i2.markType(AnnotationFactoryManager, 'AnnotationFactoryManager');
        AnnotationFactoryManager.a = false;
        return AnnotationFactoryManager;
    }(i2.Base));

    /**
     * Represents a callout annotation
    */
    var IgxCalloutAnnotation = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutAnnotation() {
            this._zoneRunner = null;
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxCalloutAnnotation.prototype.createImplementation = function () {
            return new CalloutAnnotation();
        };
        Object.defineProperty(IgxCalloutAnnotation.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutAnnotation.prototype.onImplementationCreated = function () {
        };
        IgxCalloutAnnotation.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxCalloutAnnotation.prototype, "xValue", {
            /**
             * Gets or sets the XValue at which this annotation is displayed on the axis.
            */
            get: function () {
                return this.i.xValue;
            },
            set: function (v) {
                this.i.xValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "yValue", {
            /**
             * Gets or sets the YValue at which this annotation is displayed on the axis.
            */
            get: function () {
                return this.i.yValue;
            },
            set: function (v) {
                this.i.yValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "text", {
            /**
             * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
            */
            get: function () {
                return this.i.text;
            },
            set: function (v) {
                this.i.text = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "key", {
            /**
             * Gets or sets the Key that should be annotated.
            */
            get: function () {
                return this.i.key;
            },
            set: function (v) {
                this.i.key = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "content", {
            /**
             * Gets or sets the Content that should be annotated.
            */
            get: function () {
                return this.i.content;
            },
            set: function (v) {
                this.i.content = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "series", {
            /**
             * Gets or sets the series to which the callout pertains to. Leave unset for an automatic value.
            */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "formatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
            */
            get: function () {
                return this.i.formatLabel;
            },
            set: function (v) {
                this.i.formatLabel = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "textColor", {
            /**
             * Gets or sets the color to use for the text in the annotation.
            */
            get: function () {
                return i2.brushToString(this.i.textColor);
            },
            set: function (v) {
                this.i.textColor = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "background", {
            /**
             * Gets or sets the background to use for tha axis annotation box.
            */
            get: function () {
                return i2.brushToString(this.i.background);
            },
            set: function (v) {
                this.i.background = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "outline", {
            /**
             * Gets or sets the Outline to use for tha axis annotation box.
            */
            get: function () {
                return i2.brushToString(this.i.outline);
            },
            set: function (v) {
                this.i.outline = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "leaderBrush", {
            /**
             * Gets or sets the LeaderBrush to use for tha axis annotation box.
            */
            get: function () {
                return i2.brushToString(this.i.leaderBrush);
            },
            set: function (v) {
                this.i.leaderBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "strokeThickness", {
            /**
             * Gets or sets the border stroke thickness to use for tha axis annotation box.
            */
            get: function () {
                return this.i.strokeThickness;
            },
            set: function (v) {
                this.i.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "backgroundPaddingLeft", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingLeft;
            },
            set: function (v) {
                this.i.backgroundPaddingLeft = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "backgroundPaddingTop", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingTop;
            },
            set: function (v) {
                this.i.backgroundPaddingTop = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "backgroundPaddingRight", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingRight;
            },
            set: function (v) {
                this.i.backgroundPaddingRight = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutAnnotation.prototype, "backgroundPaddingBottom", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.backgroundPaddingBottom;
            },
            set: function (v) {
                this.i.backgroundPaddingBottom = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutAnnotation.prototype.findByName = function (name) {
            if (this.series && this.series.name && this.series.name == name) {
                return this.series;
            }
            return null;
        };
        IgxCalloutAnnotation.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        return IgxCalloutAnnotation;
    }());

    var IgxCalloutAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCalloutAnnotationCollection, _super);
        function IgxCalloutAnnotationCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxCalloutAnnotation.$type) {
                IgxCalloutAnnotation.$type = i2.markType(IgxCalloutAnnotation, "IgxCalloutAnnotation");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxCalloutAnnotationCollection.prototype._createInnerColl = function () {
            if (!IgxCalloutAnnotation.$type) {
                IgxCalloutAnnotation.$type = i2.markType(IgxCalloutAnnotation, "IgxCalloutAnnotation");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxCalloutAnnotation.$type, CalloutAnnotation.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxCalloutAnnotation();
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxCalloutAnnotationCollection;
    }(i2.IgCollection));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutAnnotationCollection, _super);
        function CalloutAnnotationCollection() {
            var _this = _super.call(this, CalloutAnnotation.$, 0) || this;
            _this.collectionResetting = null;
            return _this;
        }
        CalloutAnnotationCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        CalloutAnnotationCollection.$t = i2.markType(CalloutAnnotationCollection, 'CalloutAnnotationCollection', i2.ObservableCollection$1.$.specialize(CalloutAnnotation.$));
        return CalloutAnnotationCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryHighlightFrameRect = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryHighlightFrameRect, _super);
        function CategoryHighlightFrameRect() {
            var _this = _super.call(this) || this;
            _this.f = 0;
            _this.e = 0;
            _this.b = 0;
            _this.c = 0;
            _this.a = 0;
            _this.g = null;
            _this.h = null;
            _this.d = 0;
            _this.f = 0;
            _this.e = NaN;
            _this.b = NaN;
            _this.c = NaN;
            _this.b = NaN;
            _this.a = NaN;
            _this.d = NaN;
            return _this;
        }
        CategoryHighlightFrameRect.$t = i2.markType(CategoryHighlightFrameRect, 'CategoryHighlightFrameRect');
        return CategoryHighlightFrameRect;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DictInterpolator$3 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DictInterpolator$3, _super);
        function DictInterpolator$3($tKey, $tValue, $tFrame, a, b, c, d) {
            var _this = _super.call(this) || this;
            _this.$tKey = null;
            _this.$tValue = null;
            _this.$tFrame = null;
            _this.b = null;
            _this.d = null;
            _this.e = null;
            _this.c = null;
            _this.a = null;
            _this.$tKey = $tKey;
            _this.$tValue = $tValue;
            _this.$tFrame = $tFrame;
            _this.$type = _this.$type.specialize(_this.$tKey, _this.$tValue, _this.$tFrame);
            _this.b = a;
            _this.d = b;
            _this.e = c;
            _this.c = d;
            _this.a = i2.Type.getDefaultValue(_this.$tValue);
            return _this;
        }
        DictInterpolator$3.prototype.f = function (a, b, c, d, e, f) {
            var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
            var g = new i2.List$1(this.$tKey, 0);
            var _loop_1 = function (h) {
                var i = this_1.a;
                var j = this_1.a;
                var k = a.item(h);
                var l = ((function () { var m = c.tryGetValue(h, i); i = m.p1; return m.ret; })());
                var m = ((function () { var n = d.tryGetValue(h, j); j = n.p1; return n.ret; })());
                if (!l && !m) {
                    g.add(h);
                }
                else {
                    this_1.b(k, b, i, j, e, f);
                    if (!this_1.e(k)) {
                        g.add(h);
                    }
                }
            };
            var this_1 = this;
            try {
                for (var _e = tslib.__values(i2.fromEnum(a.keys)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var h = _f.value;
                    _loop_1(h);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_a = _e.return))
                        _a.call(_e);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _g = tslib.__values(i2.fromEnum(g)), _h = _g.next(); !_h.done; _h = _g.next()) {
                    var n = _h.value;
                    a.removeItem(n);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_h && !_h.done && (_b = _g.return))
                        _b.call(_g);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            var _loop_2 = function (o) {
                var p = c.item(o);
                var q = this_2.a;
                var r = this_2.a;
                var s = d.tryGetValue(o, q);
                q = s.p1;
                var t = ((function () { var u = a.tryGetValue(o, r); r = u.p1; return u.ret; })());
                if (!t) {
                    r = this_2.c();
                    this_2.b(r, b, p, q, e, f);
                    if (!this_2.e(r)) {
                        return "continue";
                    }
                    a.addItem(this_2.d(r), r);
                }
            };
            var this_2 = this;
            try {
                for (var _j = tslib.__values(i2.fromEnum(c.keys)), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var o = _k.value;
                    _loop_2(o);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_k && !_k.done && (_c = _j.return))
                        _c.call(_j);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            var _loop_3 = function (u) {
                var v = d.item(u);
                var w = this_3.a;
                var x = this_3.a;
                var y = ((function () { var z = c.tryGetValue(u, w); w = z.p1; return z.ret; })());
                var z = ((function () { var aa = a.tryGetValue(u, x); x = aa.p1; return aa.ret; })());
                if (!z && !y) {
                    x = this_3.c();
                    this_3.b(x, b, w, v, e, f);
                    if (!this_3.e(x)) {
                        return "continue";
                    }
                    a.addItem(this_3.d(x), x);
                }
            };
            var this_3 = this;
            try {
                for (var _l = tslib.__values(i2.fromEnum(d.keys)), _m = _l.next(); !_m.done; _m = _l.next()) {
                    var u = _m.value;
                    _loop_3(u);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_m && !_m.done && (_d = _l.return))
                        _d.call(_l);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        };
        DictInterpolator$3.$t = i2.markType(DictInterpolator$3, 'DictInterpolator$3');
        return DictInterpolator$3;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryHighlightLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryHighlightLayerFrame, _super);
        function CategoryHighlightLayerFrame() {
            var _this = _super.call(this) || this;
            _this.g = null;
            _this.f = null;
            _this.g = new i2.Dictionary$2(i2.Number_$type, CategoryHighlightFrameRect.$, 0);
            _this.f = new DictInterpolator$3(i2.Number_$type, CategoryHighlightFrameRect.$, CategoryHighlightLayerFrame.$, i2.runOn(_this, _this.h), function (a) { return a.f; }, function (a) { return true; }, function () { return new CategoryHighlightFrameRect(); });
            return _this;
        }
        CategoryHighlightLayerFrame.prototype.h = function (a, b, c, d, e, f) {
            if (d != null) {
                a.f = d.f;
            }
            else if (c != null) {
                a.f = c.f;
            }
            else {
                a.f = 0;
            }
            if (c == null || i2.isNaN_(c.e)) {
                a.e = d != null ? d.e : NaN;
            }
            else if (d == null || i2.isNaN_(d.e)) {
                a.e = NaN;
            }
            else {
                a.e = c.e + b * (d.e - c.e);
            }
            if (c == null || i2.isNaN_(c.b)) {
                a.b = d != null ? d.b : NaN;
            }
            else if (d == null || i2.isNaN_(d.b)) {
                a.b = NaN;
            }
            else {
                a.b = c.b + b * (d.b - c.b);
            }
            if (c == null || i2.isNaN_(c.c)) {
                a.c = d != null ? d.c : NaN;
            }
            else if (d == null || i2.isNaN_(d.c)) {
                a.c = NaN;
            }
            else {
                a.c = c.c + b * (d.c - c.c);
            }
            if (c == null || i2.isNaN_(c.a)) {
                a.a = d != null ? d.a : NaN;
            }
            else if (d == null || i2.isNaN_(d.a)) {
                a.a = NaN;
            }
            else {
                a.a = c.a + b * (d.a - c.a);
            }
            if (c == null || i2.isNaN_(c.d)) {
                a.d = d != null ? d.d : NaN;
            }
            else if (d == null || i2.isNaN_(d.d)) {
                a.d = NaN;
            }
            else {
                a.d = c.d + b * (d.d - c.d);
            }
            if (c == null || c.g == null) {
                a.g = d != null ? d.g : null;
            }
            else if (d == null || d.g == null) {
                a.g = null;
            }
            else {
                a.g = i2.BrushUtil.k(c.g, b, d.g, 0);
            }
            if (c == null || c.h == null) {
                a.h = d != null ? d.h : null;
            }
            else if (d == null || d.h == null) {
                a.h = null;
            }
            else {
                a.h = i2.BrushUtil.k(c.h, b, d.h, 0);
            }
        };
        CategoryHighlightLayerFrame.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            this.f.f(this.g, a, d.g, e.g, d, e);
        };
        CategoryHighlightLayerFrame.$t = i2.markType(CategoryHighlightLayerFrame, 'CategoryHighlightLayerFrame', Frame.$);
        return CategoryHighlightLayerFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryHighlightLayer, _super);
        function CategoryHighlightLayer() {
            var _this = _super.call(this) || this;
            var a = new CategoryHighlightLayerFrame();
            var b = new CategoryHighlightLayerFrame();
            var c = new CategoryHighlightLayerFrame();
            var d = _this.ha / 1000;
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = CategoryHighlightLayer.$;
            return _this;
        }
        CategoryHighlightLayer.prototype.get_c5 = function () {
            return true;
        };
        CategoryHighlightLayer.prototype.bu = function () {
            return new CategoryHighlightLayerView(this);
        };
        CategoryHighlightLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qn = a;
        };
        Object.defineProperty(CategoryHighlightLayer.prototype, "qq", {
            get: function () {
                return this.c(CategoryHighlightLayer.qx);
            },
            set: function (a) {
                this.h(CategoryHighlightLayer.qx, a);
            },
            enumerable: false,
            configurable: true
        });
        CategoryHighlightLayer.prototype.p2 = function (a, b) {
            if (this.qm == null || this.qm == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        CategoryHighlightLayer.prototype.qo = function (a) {
            return a != null && a.ci();
        };
        CategoryHighlightLayer.prototype.p5 = function (a, b) {
            var e_1, _a;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            c.g.clear();
            var d = this.qp;
            if (i2.isNaN_(this.qj.x) && i2.isNaN_(this.qj.y)) {
                return;
            }
            if (this.qm != null) {
                if (this.qo(this.qm)) {
                    this.qv(this.qm, c, d);
                }
            }
            else {
                if (i2.typeCast(XamDataChart.$, this.ca) !== null) {
                    var e = this.ca;
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(e.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var f = _c.value;
                            if (i2.typeCast(CategoryAxisBase.$, f) !== null && this.qo(f)) {
                                this.qv(f, c, d);
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
            }
        };
        CategoryHighlightLayer.prototype.qv = function (a, b, c) {
            if (this.bx == null || this.bx.bv.isEmpty || this.bx.bu.isEmpty) {
                return;
            }
            var d = this.qj.x;
            if (a.cj && i2.isNaN_(d)) {
                d = 0;
            }
            d = this.bx.bu.left + this.bx.bu.width * (d - this.bx.bv.left) / this.bx.bv.width;
            var e = this.qj.y;
            if (!a.cj && i2.isNaN_(e)) {
                e = 0;
            }
            e = this.bx.bu.top + this.bx.bu.height * (e - this.bx.bv.top) / this.bx.bv.height;
            var f = a.ll({ $type: i2.Point_$type, x: d, y: e }, c, this.qq);
            this.qu(f, b, a);
        };
        CategoryHighlightLayer.prototype.qu = function (a, b, c) {
            var d = new CategoryHighlightFrameRect();
            d.b = a.left;
            d.e = a.top;
            d.c = a.right;
            d.a = a.bottom;
            d.g = this.qh();
            d.h = this.qi();
            if (d.g == null) {
                d.g = this.qn.cc(c.ja);
            }
            if (d.h == null) {
                d.h = this.qn.cc(c.ja);
            }
            d.d = this.fl;
            d.f = i2.Base.getHashCodeStatic(c);
            if (!a.isEmpty) {
                b.g.addItem(d.f, d);
            }
        };
        CategoryHighlightLayer.prototype.p8 = function (a, b) {
            var e_2, _a;
            _super.prototype.p8.call(this, a, b);
            var c = this.qn.b5;
            var d = a;
            var e = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(d.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    var g = c.item(e);
                    this.qw(f, g);
                    e++;
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            c.count = e;
        };
        CategoryHighlightLayer.prototype.eg = function () {
            return true;
        };
        CategoryHighlightLayer.prototype.qw = function (a, b) {
            if (i2.isNaN_(a.b) || i2.isNaN_(a.e) || i2.isNaN_(a.a) || i2.isNaN_(a.c) || i2.isNaN_(a.d)) {
                b._visibility = 1;
                return;
            }
            this.qn.b7(b, a.b, a.e, a.c - a.b, a.a - a.e);
            b._fill = a.g;
            b._stroke = a.h;
            b.ac = a.d;
            if (this.os != null) {
                b.ai = this.os;
            }
            else {
                b.ai = null;
            }
            b.ad = this.ot;
        };
        CategoryHighlightLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case CategoryHighlightLayer.$$p[0]:
                    this.l0(true);
                    break;
                case CategoryHighlightLayer.$$p[1]:
                    this.l0(true);
                    break;
            }
        };
        CategoryHighlightLayer.$t = i2.markType(CategoryHighlightLayer, 'CategoryHighlightLayer', AnnotationLayer.$);
        CategoryHighlightLayer.qx = i2.DependencyProperty.i("BAndHighlightWidth", i2.Number_$type, CategoryHighlightLayer.$, new i2.PropertyMetadata(2, 10, function (a, b) { return a.raisePropertyChanged("BAndHighlightWidth", b.oldValue, b.newValue); }));
        CategoryHighlightLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryHighlightLayer, 'raisePropertyChanged', ['TargetAxis:qm:qy', [CategoryAxisBase.$, null], 'UseInterpolation:qp:qz', [0, false]]);
        return CategoryHighlightLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var CategoryHighlightLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryHighlightLayerView, _super);
        function CategoryHighlightLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b5 = null;
            _this.b6 = null;
            _this.b4 = a;
            _this.b6 = new i2.List$1(i2.Rectangle.$, 0);
            return _this;
        }
        CategoryHighlightLayerView.prototype.as = function () {
            var _this = this;
            _super.prototype.as.call(this);
            this.b5 = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.cd);
                $ret.activate = i2.runOn(_this, _this.b8);
                $ret.disactivate = i2.runOn(_this, _this.ca);
                $ret.destroy = i2.runOn(_this, _this.b9);
                return $ret;
            })());
        };
        CategoryHighlightLayerView.prototype.cd = function () {
            var a = new i2.Rectangle();
            a.ab = false;
            this.b6.add(a);
            return a;
        };
        CategoryHighlightLayerView.prototype.b8 = function (a) {
            a._visibility = 0;
        };
        CategoryHighlightLayerView.prototype.ca = function (a) {
            a._visibility = 1;
        };
        CategoryHighlightLayerView.prototype.b9 = function (a) {
            this.b6.remove(a);
        };
        CategoryHighlightLayerView.prototype.cb = function (a) {
            if (a == null) {
                return a;
            }
            return i2.BrushUtil.l(a, 0.1);
        };
        CategoryHighlightLayerView.prototype.cc = function (a) {
            if (a != null) {
                var b = i2.BrushUtil.l(a, 0.3);
                if (b.isGradient) {
                    var c = b;
                    if (c.gradientStops != null) {
                        for (var d = 0; d < c.gradientStops.length; d++) {
                            var e = c.gradientStops[d];
                            e.color = i2.Color.u(i2.truncate(Math.round((e.color.l) * 0.2)), e.color.o, e.color.n, e.color.m);
                            e.color = e.color;
                        }
                    }
                }
                else {
                    b.color = i2.Color.u(i2.truncate(Math.round((b.color.l) * 0.2)), b.color.o, b.color.n, b.color.m);
                    b.color = b.color;
                }
                return b;
            }
            else {
                return null;
            }
        };
        CategoryHighlightLayerView.prototype.b7 = function (a, b, c, d, e) {
            a._visibility = 0;
            a.n = b;
            a.o = c;
            a.width = d;
            a.height = e;
        };
        CategoryHighlightLayerView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d && !b) {
                for (var c = 0; c < this.b6.count; c++) {
                    var d = this.b6._inner[c];
                    if (d._visibility == 0) {
                        a.v(d);
                    }
                }
            }
        };
        CategoryHighlightLayerView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            for (var b = 0; b < this.b6.count; b++) {
                this.e.a6.exportRectangleData(a, this.b6._inner[b], "cihRect", ["Main", "CategoryItem"]);
            }
        };
        CategoryHighlightLayerView.$t = i2.markType(CategoryHighlightLayerView, 'CategoryHighlightLayerView', AnnotationLayerView.$);
        return CategoryHighlightLayerView;
    }(AnnotationLayerView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents the base class for all IgxDataChartComponent category-based axes.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxCategoryAxisBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryAxisBaseComponent, _super);
        function IgxCategoryAxisBaseComponent() {
            var _this = _super.call(this) || this;
            _this._chartLevelData = null;
            _this._dataSource = null;
            if (_this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
            }
            return _this;
        }
        IgxCategoryAxisBaseComponent.prototype.provideData = function (data) {
            this._chartLevelData = data;
            this.updateDataSource();
        };
        IgxCategoryAxisBaseComponent.prototype.updateDataSource = function () {
            if (this._dataSource == null) {
                this.i.itemsSource = this._chartLevelData;
            }
            else {
                this.i.itemsSource = this._dataSource;
            }
        };
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "dataSource", {
            get: function () {
                if (this._dataSource != null) {
                    return this._dataSource;
                }
                return this.i.itemsSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.updateDataSource();
                //console.log("setting axis data source: " + value)
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "i", {
            /**
                                     * @hidden
                                     */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "isContinuous", {
            /**
         * Gets if the current axis is a continuous rather than a discrete scale
        */
            get: function () {
                return this.i.b8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "isCategory", {
            /**
             * Checks if the axis is of category axis type
            */
            get: function () {
                return this.i.b6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "itemsCount", {
            /**
             * Gets the number of items in the current category axis items source.
            */
            get: function () {
                return this.i.kr;
            },
            set: function (v) {
                this.i.kr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "gap", {
            /**
             * Gets or sets the amount of space between adjacent categories for the current axis object.
             * The gap is silently clamped to the range [0, 1] when used.
            *
            * Use the `gap` property to configure the spacing between items on a category axis with item spacing.
            *
            * A `gap` of 0 allocates no space between items.  A `gap` of 1 allocates a space between items equal to the width of one item.
            *
            * To set the item spacing to 75% the width of one item, set the `gap` to 0.75, as in this code:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         gap="0.75"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.kf;
            },
            set: function (v) {
                this.i.kf = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "overlap", {
            /**
             * Gets or sets the amount of overlap between adjacent categories for the current axis object.
             * The overlap is silently clamped to the range [-1, 1] when used.
            *
            * Use the `overlap` property to configure the spacing between items on a category axis with item spacing and more than one series.
            *
            * An `overlap` of 0 places grouped items adjacent to each other.  An `overlap` of 1 places grouped items in the same axis space, completely overlapping.  An `overlap` of -1 places a space between grouped items equal to the width of one item.
            *
            * To place grouped items with 75% overlap, set the `overlap` to 0.75, as in this code:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *
            *     <igx-category-x-axis
            *         label="label"
            *         overlap="0.75"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *       </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.km;
            },
            set: function (v) {
                this.i.km = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAxisBaseComponent.prototype, "useClusteringMode", {
            /**
             * Gets or sets whether the category axis should use clustering display mode even if no series are present that would force clustering mode.
            *
            * `useClusteringMode` applies grouping and spacing to a category axis equivalent to the grouping that occurs when grouping series, such as ColumnSeries, are used.
            *
            * Try setting it on an axis displaying financial series to adjust the spacing on the left and right sides of the axis:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="financialData">
            *     <igx-category-x-axis
            *     label="time"
            *     useClusteringMode="true"
            *     #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *     </igx-column-series>
            *     <igx-financial-price-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume">
            *     </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.ka;
            },
            set: function (v) {
                this.i.ka = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryAxisBaseComponent.prototype.getCategoryBoundingBox = function (point, useInterpolation, singularWidth) {
            var iv = this.i.ll(i2.toPoint(point), useInterpolation, singularWidth);
            return i2.fromRect(iv);
        };
        IgxCategoryAxisBaseComponent.prototype.getCategoryBoundingBoxHelper = function (point, useInterpolation, singularWidth, isVertical) {
            var iv = this.i.lm(i2.toPoint(point), useInterpolation, singularWidth, isVertical);
            return i2.fromRect(iv);
        };
        /**
         * Unscales a value from screen space into axis space.
        
        * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
        */
        IgxCategoryAxisBaseComponent.prototype.unscaleValue = function (unscaledValue) {
            var iv = this.i.kn(unscaledValue);
            return (iv);
        };
        IgxCategoryAxisBaseComponent.prototype.notifySetItem = function (index, oldItem, newItem) {
            this.i.k8(index, oldItem, newItem);
        };
        /**
         * Used to manually notify the axis that the data source has reset or cleared its items.
        
        */
        IgxCategoryAxisBaseComponent.prototype.notifyClearItems = function () {
            this.i.k5();
        };
        IgxCategoryAxisBaseComponent.prototype.notifyInsertItem = function (index, newItem) {
            this.i.k6(index, newItem);
        };
        IgxCategoryAxisBaseComponent.prototype.notifyRemoveItem = function (index, oldItem) {
            this.i.k7(index, oldItem);
        };
        IgxCategoryAxisBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAxisBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryAxisBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryAxisBaseComponent, selector: "ng-component", inputs: { dataSource: "dataSource", itemsCount: "itemsCount", gap: "gap", overlap: "overlap", useClusteringMode: "useClusteringMode" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxCategoryAxisBaseComponent;
    }(IgxAxisComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAxisBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { dataSource: [{
                    type: i0.Input
                }], itemsCount: [{
                    type: i0.Input
                }], gap: [{
                    type: i0.Input
                }], overlap: [{
                    type: i0.Input
                }], useClusteringMode: [{
                    type: i0.Input
                }] } });

    /**
     * Represents an annotation layer that targets a category axis, or all category axes in the chart.
     * If the axis contains any series that are aligned between major gridlines of the axis (column, waterfall, etc) this will render a shape that fills the current category.
     * Otherwise it will render a band with an adjustable thickness at the closest gridline to the pointer position.
     * Setting UseIterpolation to true will cause the x position in the latter case to become affixed to the x position of the pointer.
    */
    var IgxCategoryHighlightLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryHighlightLayerComponent, _super);
        function IgxCategoryHighlightLayerComponent() {
            return _super.call(this) || this;
        }
        IgxCategoryHighlightLayerComponent.prototype.createImplementation = function () {
            return new CategoryHighlightLayer();
        };
        Object.defineProperty(IgxCategoryHighlightLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryHighlightLayerComponent.prototype, "isAnnotationHoverLayer", {
            /**
             * Gets whether the series is an annotation layer displayed only when hovering over the chart.
            */
            get: function () {
                return this.i.c5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryHighlightLayerComponent.prototype, "targetAxis", {
            /**
             * Gets or sets the axis to target this annotation to. If null, this annotation targets all category axes simultaneously.
            */
            get: function () {
                if (this.i.qm == null) {
                    return null;
                }
                if (!this.i.qm.externalObject) {
                    var e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.qm);
                    if (e) {
                        e._implementation = this.i.qm;
                    }
                    this.i.qm.externalObject = e;
                }
                return this.i.qm.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qm = null : this.i.qm = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryHighlightLayerComponent.prototype, "useInterpolation", {
            /**
             * Gets or sets whether to use value interpolation when drawing a line through the best value for the pointer position.
            */
            get: function () {
                return this.i.qp;
            },
            set: function (v) {
                this.i.qp = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryHighlightLayerComponent.prototype, "bandHighlightWidth", {
            /**
             * Gets or sets the width to use for the highlight region if drawing a band rather than filling a category.
            */
            get: function () {
                return this.i.qq;
            },
            set: function (v) {
                this.i.qq = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryHighlightLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetAxis && this.targetAxis.name && this.targetAxis.name == name) {
                return this.targetAxis;
            }
            return null;
        };
        IgxCategoryHighlightLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetAxis && this.targetAxis._styling) {
                this.targetAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxCategoryHighlightLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryHighlightLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryHighlightLayerComponent, selector: "igx-category-highlight-layer", inputs: { targetAxis: "targetAxis", useInterpolation: "useInterpolation", bandHighlightWidth: "bandHighlightWidth" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCategoryHighlightLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCategoryHighlightLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryHighlightLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-highlight-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCategoryHighlightLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCategoryHighlightLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { targetAxis: [{
                    type: i0.Input
                }], useInterpolation: [{
                    type: i0.Input
                }], bandHighlightWidth: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryHighlightLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryHighlightLayerModule() {
        }
        IgxCategoryHighlightLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryHighlightLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerModule, declarations: [IgxCategoryHighlightLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxCategoryHighlightLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxCategoryHighlightLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxCategoryHighlightLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryHighlightLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxCategoryHighlightLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryHighlightLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryHighlightLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryHighlightLayerComponent", IgxCategoryHighlightLayerComponent);
            i2.TypeRegistrar.register("CategoryHighlightLayer", CategoryHighlightLayer.$type);
        }
        IgxCategoryHighlightLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryHighlightLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerDynamicModule, imports: [i1.CommonModule, IgxCategoryHighlightLayerModule], exports: [IgxCategoryHighlightLayerModule] });
        IgxCategoryHighlightLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerDynamicModule, imports: [[i1.CommonModule, IgxCategoryHighlightLayerModule], IgxCategoryHighlightLayerModule] });
        return IgxCategoryHighlightLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryHighlightLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryHighlightLayerModule],
                        exports: [IgxCategoryHighlightLayerModule],
                        entryComponents: [IgxCategoryHighlightLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    var IgxCalloutStyleUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutStyleUpdatingEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxCalloutStyleUpdatingEventArgs.prototype.createImplementation = function () {
            return new CalloutStyleUpdatingEventArgs();
        };
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutStyleUpdatingEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxCalloutStyleUpdatingEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "xValue", {
            get: function () {
                return this.i.xValue;
            },
            set: function (v) {
                this.i.xValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "yValue", {
            get: function () {
                return this.i.yValue;
            },
            set: function (v) {
                this.i.yValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "item", {
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "series", {
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "background", {
            get: function () {
                return i2.brushToString(this.i.background);
            },
            set: function (v) {
                this.i.background = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "textColor", {
            get: function () {
                return i2.brushToString(this.i.textColor);
            },
            set: function (v) {
                this.i.textColor = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "outline", {
            get: function () {
                return i2.brushToString(this.i.outline);
            },
            set: function (v) {
                this.i.outline = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "leaderBrush", {
            get: function () {
                return i2.brushToString(this.i.leaderBrush);
            },
            set: function (v) {
                this.i.leaderBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "strokeThickness", {
            get: function () {
                return this.i.strokeThickness;
            },
            set: function (v) {
                this.i.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxCalloutStyleUpdatingEventArgs;
    }());

    /**
     * Represents event arguments for updating content of callout layer
    */
    var IgxCalloutContentUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutContentUpdatingEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxCalloutContentUpdatingEventArgs.prototype.createImplementation = function () {
            return new CalloutContentUpdatingEventArgs();
        };
        Object.defineProperty(IgxCalloutContentUpdatingEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutContentUpdatingEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxCalloutContentUpdatingEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxCalloutContentUpdatingEventArgs.prototype, "xValue", {
            /**
             * Gets data X-value assositated with callout layer
            */
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                this.i.c = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutContentUpdatingEventArgs.prototype, "yValue", {
            /**
             * Gets data Y-value assositated with callout layer
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutContentUpdatingEventArgs.prototype, "item", {
            /**
             * Gets data item assositated with callout layer
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutContentUpdatingEventArgs.prototype, "content", {
            /**
             * Gets or sets content displayed by callout layer
            */
            get: function () {
                return this.i.a;
            },
            set: function (v) {
                this.i.a = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxCalloutContentUpdatingEventArgs;
    }());

    /**
     * Represents event arguments for updating label of callout layer
    */
    var IgxCalloutLabelUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutLabelUpdatingEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxCalloutLabelUpdatingEventArgs.prototype.createImplementation = function () {
            return new CalloutLabelUpdatingEventArgs();
        };
        Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutLabelUpdatingEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxCalloutLabelUpdatingEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "xValue", {
            /**
             * Gets data X-value assositated with callout layer
            */
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                this.i.c = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "yValue", {
            /**
             * Gets data Y-value assositated with callout layer
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "item", {
            /**
             * Gets data item assositated with callout layer
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLabelUpdatingEventArgs.prototype, "label", {
            /**
             * Gets or sets label displayed by callout layer
            */
            get: function () {
                return this.i.b;
            },
            set: function (v) {
                this.i.b = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxCalloutLabelUpdatingEventArgs;
    }());

    /**
     * Represents event arguments for selecting callout layer
    */
    var IgxCalloutSeriesSelectingEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutSeriesSelectingEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxCalloutSeriesSelectingEventArgs.prototype.createImplementation = function () {
            return new CalloutSeriesSelectingEventArgs();
        };
        Object.defineProperty(IgxCalloutSeriesSelectingEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutSeriesSelectingEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxCalloutSeriesSelectingEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxCalloutSeriesSelectingEventArgs.prototype, "xValue", {
            /**
             * Gets data X-value assositated with callout layer
            */
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                this.i.c = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutSeriesSelectingEventArgs.prototype, "yValue", {
            /**
             * Gets data Y-value assositated with callout layer
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutSeriesSelectingEventArgs.prototype, "item", {
            /**
             * Gets data item assositated with callout layer
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutSeriesSelectingEventArgs.prototype, "series", {
            /**
             * Gets or sets series object assositated with callout layer
            */
            get: function () {
                if (this.i.a == null) {
                    return null;
                }
                if (!this.i.a.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.a);
                    if (e) {
                        e._implementation = this.i.a;
                    }
                    this.i.a.externalObject = e;
                }
                return this.i.a.externalObject;
            },
            set: function (v) {
                v == null ? this.i.a = null : this.i.a = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutSeriesSelectingEventArgs.prototype, "seriesName", {
            /**
             * Gets or sets series name assositated with callout layer
            */
            get: function () {
                return this.i.e;
            },
            set: function (v) {
                this.i.e = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxCalloutSeriesSelectingEventArgs;
    }());

    /**
     * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
    */
    var IgxCalloutLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCalloutLayerComponent, _super);
        function IgxCalloutLayerComponent() {
            var _this = _super.call(this) || this;
            _this._calloutStyleUpdating = null;
            _this._calloutContentUpdating = null;
            _this._calloutLabelUpdating = null;
            _this._calloutSeriesSelecting = null;
            return _this;
        }
        IgxCalloutLayerComponent.prototype.createImplementation = function () {
            return new CalloutLayer();
        };
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "isAnnotationCalloutLayer", {
            /**
             * Gets whether the series is an callout annotation layer.
            */
            get: function () {
                return this.i.c2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "labelMemberPath", {
            /**
             * Gets or sets the label mapping property for the callouts.
            */
            get: function () {
                return this.i.sv;
            },
            set: function (v) {
                this.i.sv = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "xMemberPath", {
            /**
             * Gets or sets the label mapping property for the callouts.
            */
            get: function () {
                return this.i.s4;
            },
            set: function (v) {
                this.i.s4 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "yMemberPath", {
            /**
             * Gets or sets the label mapping property for the callouts.
            */
            get: function () {
                return this.i.s7;
            },
            set: function (v) {
                this.i.s7 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "keyMemberPath", {
            /**
             * Gets or sets the key mapping property for the callouts.
            */
            get: function () {
                return this.i.ss;
            },
            set: function (v) {
                this.i.ss = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "isCalloutOffsettingEnabled", {
            /**
             * Gets or sets whether to allow the callouts to be variable distances from the target points, for suppporting collision modes.
            */
            get: function () {
                return this.i.rh;
            },
            set: function (v) {
                this.i.rh = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "contentMemberPath", {
            /**
             * Gets or sets the content mapping property for the callouts.
            */
            get: function () {
                return this.i.sm;
            },
            set: function (v) {
                this.i.sm = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "targetSeriesName", {
            /**
             * Gets or sets the name of the series series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                return this.i.sx;
            },
            set: function (v) {
                this.i.sx = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "targetSeries", {
            /**
             * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                if (this.i.qs == null) {
                    return null;
                }
                if (!this.i.qs.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.qs);
                    if (e) {
                        e._implementation = this.i.qs;
                    }
                    this.i.qs.externalObject = e;
                }
                return this.i.qs.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qs = null : this.i.qs = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "collisionChannel", {
            /**
             * Gets or sets a channel name to identify other callout layers within the chart to share collision information with.
            */
            get: function () {
                return this.i.sj;
            },
            set: function (v) {
                this.i.sj = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "isAutoCalloutBehaviorEnabled", {
            /**
             * Gets or sets how to select the final value to annotate.
            */
            get: function () {
                return this.i.rg;
            },
            set: function (v) {
                this.i.rg = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "useValueForAutoCalloutLabels", {
            /**
             * Gets or sets whether to use values, rather than labels for auto callout labels.
            */
            get: function () {
                return this.i.rj;
            },
            set: function (v) {
                this.i.rj = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "isCustomCalloutStyleEnabled", {
            /**
             * Gets or sets whether to allow for custom callout styles.
            */
            get: function () {
                return this.i.ri;
            },
            set: function (v) {
                this.i.ri = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "autoCalloutLabelPrecision", {
            /**
             * Gets or sets the precision to use when values are used for the auto callout labels.
            */
            get: function () {
                return this.i.r1;
            },
            set: function (v) {
                this.i.r1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutTextColor", {
            /**
             * Gets or sets the color to use for the callout text. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.ug);
            },
            set: function (v) {
                this.i.ug = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutBackground", {
            /**
             * Gets or sets the brush that specifies how the backgrounds for the callouts of the layer are painted. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.ud);
            },
            set: function (v) {
                this.i.ud = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutInterpolatedValuePrecision", {
            /**
             * Gets or sets the precision to use displaying values for interpolated crosshair positions.
            */
            get: function () {
                return this.i.r2;
            },
            set: function (v) {
                this.i.r2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutOutline", {
            /**
             * Gets or sets the brush that specifies how the outlines for the callouts of the layer are painted.
            */
            get: function () {
                return i2.brushToString(this.i.uf);
            },
            set: function (v) {
                this.i.uf = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutLeaderBrush", {
            /**
             * Gets or sets the brush that specifies how the leader lines for the callouts of the layer are painted.
            */
            get: function () {
                return i2.brushToString(this.i.ue);
            },
            set: function (v) {
                this.i.ue = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutPaddingLeft", {
            /**
             * Gets or sets the left padding to use withing the callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.ru;
            },
            set: function (v) {
                this.i.ru = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutPaddingTop", {
            /**
             * Gets or sets the top padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.rw;
            },
            set: function (v) {
                this.i.rw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutPaddingRight", {
            /**
             * Gets or sets the right padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.rv;
            },
            set: function (v) {
                this.i.rv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutPaddingBottom", {
            /**
             * Gets or sets the bottom padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.rt;
            },
            set: function (v) {
                this.i.rt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutCollisionMode", {
            /**
             * Gets or sets the strategy to use for avoiding collisions between the callouts in this layer. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.qm;
            },
            set: function (v) {
                this.i.qm = i2.ensureEnum(CalloutCollisionMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutPositionPadding", {
            /**
             * Gets or sets the padding to add to the callout positioning. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.rx;
            },
            set: function (v) {
                this.i.rx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutStrokeThickness", {
            /**
             * Gets or sets the stroke thickness for the callout backing. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.ry;
            },
            set: function (v) {
                this.i.ry = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "textStyle", {
            /**
             * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.s0;
            },
            set: function (v) {
                this.i.s0 = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
                return this.targetSeries;
            }
            return null;
        };
        IgxCalloutLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetSeries && this.targetSeries._styling) {
                this.targetSeries._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxCalloutLayerComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Invalidates content of callout layer
        
        */
        IgxCalloutLayerComponent.prototype.invalidateCalloutContent = function () {
            this.i.tg();
        };
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutStyleUpdating", {
            /**
             * Event raised when updating style of callout layer
            */
            get: function () {
                var _this = this;
                if (this._calloutStyleUpdating == null) {
                    this._calloutStyleUpdating = new i0.EventEmitter();
                    this.i.calloutStyleUpdating = i2.delegateCombine(this.i.calloutStyleUpdating, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxCalloutStyleUpdatingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeCalloutStyleUpdating) {
                                _this.beforeCalloutStyleUpdating(_this, outerArgs);
                            }
                            _this._calloutStyleUpdating.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._calloutStyleUpdating;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutContentUpdating", {
            /**
             * Raised to allow you to decide on the content for an automatically created callout.
            */
            get: function () {
                var _this = this;
                if (this._calloutContentUpdating == null) {
                    this._calloutContentUpdating = new i0.EventEmitter();
                    this.i.calloutContentUpdating = i2.delegateCombine(this.i.calloutContentUpdating, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxCalloutContentUpdatingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeCalloutContentUpdating) {
                                _this.beforeCalloutContentUpdating(_this, outerArgs);
                            }
                            _this._calloutContentUpdating.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._calloutContentUpdating;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutLabelUpdating", {
            /**
             * Raised to allow you to decide on the label for an automatically created callout.
            */
            get: function () {
                var _this = this;
                if (this._calloutLabelUpdating == null) {
                    this._calloutLabelUpdating = new i0.EventEmitter();
                    this.i.calloutLabelUpdating = i2.delegateCombine(this.i.calloutLabelUpdating, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxCalloutLabelUpdatingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeCalloutLabelUpdating) {
                                _this.beforeCalloutLabelUpdating(_this, outerArgs);
                            }
                            _this._calloutLabelUpdating.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._calloutLabelUpdating;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCalloutLayerComponent.prototype, "calloutSeriesSelecting", {
            /**
             * Raised to allow you to select a target series for a data bound callout.
            */
            get: function () {
                var _this = this;
                if (this._calloutSeriesSelecting == null) {
                    this._calloutSeriesSelecting = new i0.EventEmitter();
                    this.i.calloutSeriesSelecting = i2.delegateCombine(this.i.calloutSeriesSelecting, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxCalloutSeriesSelectingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeCalloutSeriesSelecting) {
                                _this.beforeCalloutSeriesSelecting(_this, outerArgs);
                            }
                            _this._calloutSeriesSelecting.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._calloutSeriesSelecting;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalloutLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCalloutLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCalloutLayerComponent, selector: "igx-callout-layer", inputs: { labelMemberPath: "labelMemberPath", xMemberPath: "xMemberPath", yMemberPath: "yMemberPath", keyMemberPath: "keyMemberPath", isCalloutOffsettingEnabled: "isCalloutOffsettingEnabled", contentMemberPath: "contentMemberPath", targetSeriesName: "targetSeriesName", targetSeries: "targetSeries", collisionChannel: "collisionChannel", isAutoCalloutBehaviorEnabled: "isAutoCalloutBehaviorEnabled", useValueForAutoCalloutLabels: "useValueForAutoCalloutLabels", isCustomCalloutStyleEnabled: "isCustomCalloutStyleEnabled", autoCalloutLabelPrecision: "autoCalloutLabelPrecision", calloutTextColor: "calloutTextColor", calloutBackground: "calloutBackground", calloutInterpolatedValuePrecision: "calloutInterpolatedValuePrecision", calloutOutline: "calloutOutline", calloutLeaderBrush: "calloutLeaderBrush", calloutPaddingLeft: "calloutPaddingLeft", calloutPaddingTop: "calloutPaddingTop", calloutPaddingRight: "calloutPaddingRight", calloutPaddingBottom: "calloutPaddingBottom", calloutCollisionMode: "calloutCollisionMode", calloutPositionPadding: "calloutPositionPadding", calloutStrokeThickness: "calloutStrokeThickness", textStyle: "textStyle" }, outputs: { calloutStyleUpdating: "calloutStyleUpdating", calloutContentUpdating: "calloutContentUpdating", calloutLabelUpdating: "calloutLabelUpdating", calloutSeriesSelecting: "calloutSeriesSelecting" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCalloutLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCalloutLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCalloutLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-callout-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCalloutLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCalloutLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { labelMemberPath: [{
                    type: i0.Input
                }], xMemberPath: [{
                    type: i0.Input
                }], yMemberPath: [{
                    type: i0.Input
                }], keyMemberPath: [{
                    type: i0.Input
                }], isCalloutOffsettingEnabled: [{
                    type: i0.Input
                }], contentMemberPath: [{
                    type: i0.Input
                }], targetSeriesName: [{
                    type: i0.Input
                }], targetSeries: [{
                    type: i0.Input
                }], collisionChannel: [{
                    type: i0.Input
                }], isAutoCalloutBehaviorEnabled: [{
                    type: i0.Input
                }], useValueForAutoCalloutLabels: [{
                    type: i0.Input
                }], isCustomCalloutStyleEnabled: [{
                    type: i0.Input
                }], autoCalloutLabelPrecision: [{
                    type: i0.Input
                }], calloutTextColor: [{
                    type: i0.Input
                }], calloutBackground: [{
                    type: i0.Input
                }], calloutInterpolatedValuePrecision: [{
                    type: i0.Input
                }], calloutOutline: [{
                    type: i0.Input
                }], calloutLeaderBrush: [{
                    type: i0.Input
                }], calloutPaddingLeft: [{
                    type: i0.Input
                }], calloutPaddingTop: [{
                    type: i0.Input
                }], calloutPaddingRight: [{
                    type: i0.Input
                }], calloutPaddingBottom: [{
                    type: i0.Input
                }], calloutCollisionMode: [{
                    type: i0.Input
                }], calloutPositionPadding: [{
                    type: i0.Input
                }], calloutStrokeThickness: [{
                    type: i0.Input
                }], textStyle: [{
                    type: i0.Input
                }], calloutStyleUpdating: [{
                    type: i0.Output
                }], calloutContentUpdating: [{
                    type: i0.Output
                }], calloutLabelUpdating: [{
                    type: i0.Output
                }], calloutSeriesSelecting: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCalloutLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutLayerModule() {
        }
        IgxCalloutLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCalloutLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerModule, declarations: [IgxCalloutLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxCalloutLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxCalloutLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxCalloutLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCalloutLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxCalloutLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCalloutLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalloutLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCalloutLayerComponent", IgxCalloutLayerComponent);
            i2.TypeRegistrar.register("CalloutLayer", CalloutLayer.$type);
        }
        IgxCalloutLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCalloutLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerDynamicModule, imports: [i1.CommonModule, IgxCalloutLayerModule], exports: [IgxCalloutLayerModule] });
        IgxCalloutLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerDynamicModule, imports: [[i1.CommonModule, IgxCalloutLayerModule], IgxCalloutLayerModule] });
        return IgxCalloutLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCalloutLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCalloutLayerModule],
                        exports: [IgxCalloutLayerModule],
                        entryComponents: [IgxCalloutLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinalValueLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinalValueLayerFrame, _super);
        function FinalValueLayerFrame() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FinalValueLayerFrame.$t = i2.markType(FinalValueLayerFrame, 'FinalValueLayerFrame', AxisAnnotationFrame.$);
        return FinalValueLayerFrame;
    }(AxisAnnotationFrame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Gets or sets how to select the final value to annotate.
     */
    var FinalValueSelectionMode = /*@__PURE__*/ (function (FinalValueSelectionMode) {
        /**
         * A mode is selected automatically
         */
        FinalValueSelectionMode[FinalValueSelectionMode["Auto"] = 0] = "Auto";
        /**
         * Displays the last value visible.
         */
        FinalValueSelectionMode[FinalValueSelectionMode["FinalVisible"] = 1] = "FinalVisible";
        /**
         * Displays an interpolated last value for when the series leaves view.
         */
        FinalValueSelectionMode[FinalValueSelectionMode["FinalVisibleInterpolated"] = 2] = "FinalVisibleInterpolated";
        /**
         * Displays the last value in the series, whether visible or not.
         */
        FinalValueSelectionMode[FinalValueSelectionMode["Final"] = 3] = "Final";
        return FinalValueSelectionMode;
    })({});
    /**
     * @hidden
     */
    var FinalValueSelectionMode_$type = i2.markEnum('FinalValueSelectionMode', 'Auto,0|FinalVisible,1|FinalVisibleInterpolated,2|Final,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinalValueLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinalValueLayer, _super);
        function FinalValueLayer() {
            var _this = _super.call(this) || this;
            _this.axisAnnotationFormatLabel = null;
            _this.qs = null;
            _this.qr = null;
            var a = new FinalValueLayerFrame();
            var b = new FinalValueLayerFrame();
            var c = new FinalValueLayerFrame();
            var d = _this.ha / 1000;
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = FinalValueLayer.$;
            return _this;
        }
        FinalValueLayer.prototype.get_c4 = function () {
            return true;
        };
        FinalValueLayer.prototype.bu = function () {
            return new FinalValueLayerView(this);
        };
        FinalValueLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qn = a;
        };
        Object.defineProperty(FinalValueLayer.prototype, "ru", {
            get: function () {
                return new i2.Thickness(1, this.qu, this.qw, this.qv, this.qt);
            },
            enumerable: false,
            configurable: true
        });
        FinalValueLayer.prototype.qq = function () {
            return this.axisAnnotationFormatLabel != null;
        };
        FinalValueLayer.prototype.p3 = function (a, b) {
            if (this.qp == null || this.qp == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        FinalValueLayer.prototype.p5 = function (a, b) {
            var e_1, _a;
            var _this = this;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            c.f.clear();
            c.q.clear();
            c.p.clear();
            c.aa.clear();
            c.o.clear();
            c.z.clear();
            c.g.clear();
            c.h.clear();
            c.j.clear();
            c.l.clear();
            c.k.clear();
            c.i.clear();
            c.m.clear();
            c.n.clear();
            c.r.clear();
            c.s.clear();
            c.u.clear();
            c.w.clear();
            c.v.clear();
            c.t.clear();
            c.x.clear();
            c.y.clear();
            if (this.pq(this.qp)) {
                this.rc(this.qp, c);
            }
            else {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        if (this.pq(d)) {
                            this.rc(d, c);
                        }
                        if (d.isStacked) {
                            d.ku(function (e) {
                                if (_this.pq(e)) {
                                    _this.rc(e, c);
                                }
                                return true;
                            });
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        FinalValueLayer.prototype.pq = function (a) {
            if (!_super.prototype.pq.call(this, a)) {
                return false;
            }
            if (this.q9 != null) {
                if (a.dn) {
                    var b = a.i9();
                    if (!i2.Base.equalsStatic(this.q9, b)) {
                        return false;
                    }
                }
                else {
                    if (!i2.Base.equalsStatic(this.q9, a.name)) {
                        return false;
                    }
                }
            }
            return true;
        };
        FinalValueLayer.prototype.la = function () {
            _super.prototype.la.call(this);
            if (!this.as.c && !this.cr()) {
                return;
            }
            if (this.cr()) {
                this.rd(this.pl, false);
            }
            else {
                this.rd(this.pj, false);
            }
        };
        FinalValueLayer.prototype.rt = function (a) {
            var b = NaN;
            var c = NaN;
            var d = this.qo;
            if (d == 0) {
                d = 1;
            }
            var e = false;
            if (d == 2) {
                e = true;
            }
            if (a.isVertical) {
                var f = a.ar();
                if (f != null) {
                    if (d == 1 || d == 2) {
                        if (f.cc) {
                            c = a.o5({ $type: i2.Point_$type, x: this.pf.right, y: this.pf.bottom }).y;
                        }
                        else {
                            c = a.o5({ $type: i2.Point_$type, x: this.pf.right, y: this.pf.top }).y;
                        }
                    }
                    else {
                        if (f.cc) {
                            c = 1;
                        }
                        else {
                            c = 0;
                        }
                    }
                }
                return a.o2({ $type: i2.Point_$type, x: 0, y: c }, e, true);
            }
            else {
                var g = a.ar();
                if (g != null) {
                    if (d == 1 || d == 2) {
                        if (g.cc) {
                            b = a.o5({ $type: i2.Point_$type, x: this.pf.left, y: this.pf.top }).x;
                        }
                        else {
                            b = a.o5({ $type: i2.Point_$type, x: this.pf.right, y: this.pf.top }).x;
                        }
                    }
                    else {
                        if (g.cc) {
                            b = 0;
                        }
                        else {
                            b = 1;
                        }
                    }
                }
                if (a.di) {
                    return a.o2({ $type: i2.Point_$type, x: b, y: 0 }, e, true);
                }
                else {
                    return a.o2({ $type: i2.Point_$type, x: b, y: 0 }, e, true);
                }
            }
        };
        FinalValueLayer.prototype.rc = function (a, b) {
            var c = this.rt(a);
            var d = this.o5(c);
            var e = this.of;
            if (e == null) {
                e = this.oj;
            }
            if (e == null) {
                e = a.of;
                if (e != null) {
                    e = this.qn.b5(e);
                }
            }
            AxisAnnotationFrameManager.c(b, c, a, this.ca, this.getEffectiveViewport(), e, this.rq, this.rs, this.rr, this.ru, this.qx, this.rq, this.rs, this.rr, this.ru, this.qx, a.isVertical, !a.isVertical);
        };
        FinalValueLayer.prototype.rd = function (a, b) {
            var c = false;
            if (this.qr == null) {
                c = true;
                this.qs = new i2.List$1(Axis.$, 0);
                this.qr = new i2.Dictionary$2(Axis.$, i2.Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.qr, this.qs, b, this.qy, this.qy, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
        };
        FinalValueLayer.prototype.p8 = function (a, b) {
            _super.prototype.p8.call(this, a, b);
            if (this.cr()) {
                this.rd(this.pl, true);
            }
            else {
                this.rd(this.pj, false);
            }
        };
        FinalValueLayer.prototype.eg = function () {
            return true;
        };
        FinalValueLayer.prototype.lm = function (a, b, c, d) {
            var e_2, _a;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case FinalValueLayer.$$p[10]:
                case FinalValueLayer.$$p[11]:
                    this.l0(true);
                    break;
                case FinalValueLayer.$$p[0]:
                case FinalValueLayer.$$p[2]:
                case FinalValueLayer.$$p[4]:
                case FinalValueLayer.$$p[6]:
                case FinalValueLayer.$$p[5]:
                case FinalValueLayer.$$p[3]:
                case FinalValueLayer.$$p[7]:
                case FinalValueLayer.$$p[8]:
                case FinalValueLayer.$$p[9]:
                    this.l0(true);
                    break;
                case "SeriesViewer":
                    var e = this.qs;
                    var f = this.qr;
                    if (f != null) {
                        var _loop_1 = function (g) {
                            var h = g.value;
                            h.c(function (i) { return g.key.am.remove(i); });
                            h.clear();
                        };
                        try {
                            for (var _b = tslib.__values(i2.fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var g = _c.value;
                                _loop_1(g);
                            }
                        }
                        catch (e_2_1) {
                            e_2 = { error: e_2_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_2)
                                    throw e_2.error;
                            }
                        }
                        e.clear();
                        f.clear();
                    }
                    break;
            }
        };
        FinalValueLayer.$t = i2.markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
        FinalValueLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackground:rq:re', [i2.Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:qy:rf', [1, -1], 'AxisAnnotationOutline:rr:rg', [i2.Brush.$, null], 'AxisAnnotationPaddingBottom:qt:rh', [1, NaN], 'AxisAnnotationPaddingLeft:qu:ri', [1, NaN], 'AxisAnnotationPaddingRight:qv:rj', [1, NaN], 'AxisAnnotationPaddingTop:qw:rk', [1, NaN], 'AxisAnnotationStrokeThickness:qx:rl', [1, NaN], 'AxisAnnotationTextColor:rs:rm', [i2.Brush.$, null], 'FinalValueSelectionMode:qo:rn', [FinalValueSelectionMode_$type, i2.enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:q9:ro', [2, null], 'TargetSeries:qp:rp', [Series.$, null]]);
        return FinalValueLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var FinalValueLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinalValueLayerView, _super);
        function FinalValueLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b4 = a;
            return _this;
        }
        FinalValueLayerView.prototype.as = function () {
            _super.prototype.as.call(this);
        };
        FinalValueLayerView.prototype.b5 = function (a) {
            if (a == null) {
                return a;
            }
            return i2.BrushUtil.l(a, 0.1);
        };
        FinalValueLayerView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
        };
        FinalValueLayerView.$t = i2.markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
        return FinalValueLayerView;
    }(AnnotationLayerView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
    */
    var IgxFinalValueLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinalValueLayerComponent, _super);
        function IgxFinalValueLayerComponent() {
            return _super.call(this) || this;
        }
        IgxFinalValueLayerComponent.prototype.createImplementation = function () {
            return new FinalValueLayer();
        };
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "isAnnotationFinalValue", {
            /**
             * Gets whether the series is final value annotation layer.
            */
            get: function () {
                return this.i.c4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "targetSeriesName", {
            /**
             * Gets or sets the name of the series series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                return this.i.q9;
            },
            set: function (v) {
                this.i.q9 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "targetSeries", {
            /**
             * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                if (this.i.qp == null) {
                    return null;
                }
                if (!this.i.qp.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.qp);
                    if (e) {
                        e._implementation = this.i.qp;
                    }
                    this.i.qp.externalObject = e;
                }
                return this.i.qp.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qp = null : this.i.qp = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "finalValueSelectionMode", {
            /**
             * Gets or sets how to select the final value to annotate.
            */
            get: function () {
                return this.i.qo;
            },
            set: function (v) {
                this.i.qo = i2.ensureEnum(FinalValueSelectionMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationTextColor", {
            /**
             * Gets or sets the color to use for the axis annotation text. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.rs);
            },
            set: function (v) {
                this.i.rs = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationBackground", {
            /**
             * Gets or sets the color to use for the axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.rq);
            },
            set: function (v) {
                this.i.rq = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationInterpolatedValuePrecision", {
            /**
             * Gets or sets the precision to use displaying values for interpolated crosshair positions.
            */
            get: function () {
                return this.i.qy;
            },
            set: function (v) {
                this.i.qy = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationOutline", {
            /**
             * Gets or sets the color to use for the axis annotation outline. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.rr);
            },
            set: function (v) {
                this.i.rr = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingLeft", {
            /**
             * Gets or sets the left padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qu;
            },
            set: function (v) {
                this.i.qu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingTop", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qw;
            },
            set: function (v) {
                this.i.qw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingRight", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qv;
            },
            set: function (v) {
                this.i.qv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingBottom", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qt;
            },
            set: function (v) {
                this.i.qt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinalValueLayerComponent.prototype, "axisAnnotationStrokeThickness", {
            /**
             * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.qx;
            },
            set: function (v) {
                this.i.qx = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinalValueLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
                return this.targetSeries;
            }
            return null;
        };
        IgxFinalValueLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetSeries && this.targetSeries._styling) {
                this.targetSeries._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxFinalValueLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFinalValueLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinalValueLayerComponent, selector: "igx-final-value-layer", inputs: { targetSeriesName: "targetSeriesName", targetSeries: "targetSeries", finalValueSelectionMode: "finalValueSelectionMode", axisAnnotationTextColor: "axisAnnotationTextColor", axisAnnotationBackground: "axisAnnotationBackground", axisAnnotationInterpolatedValuePrecision: "axisAnnotationInterpolatedValuePrecision", axisAnnotationOutline: "axisAnnotationOutline", axisAnnotationPaddingLeft: "axisAnnotationPaddingLeft", axisAnnotationPaddingTop: "axisAnnotationPaddingTop", axisAnnotationPaddingRight: "axisAnnotationPaddingRight", axisAnnotationPaddingBottom: "axisAnnotationPaddingBottom", axisAnnotationStrokeThickness: "axisAnnotationStrokeThickness" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxFinalValueLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFinalValueLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFinalValueLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-final-value-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxFinalValueLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFinalValueLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { targetSeriesName: [{
                    type: i0.Input
                }], targetSeries: [{
                    type: i0.Input
                }], finalValueSelectionMode: [{
                    type: i0.Input
                }], axisAnnotationTextColor: [{
                    type: i0.Input
                }], axisAnnotationBackground: [{
                    type: i0.Input
                }], axisAnnotationInterpolatedValuePrecision: [{
                    type: i0.Input
                }], axisAnnotationOutline: [{
                    type: i0.Input
                }], axisAnnotationPaddingLeft: [{
                    type: i0.Input
                }], axisAnnotationPaddingTop: [{
                    type: i0.Input
                }], axisAnnotationPaddingRight: [{
                    type: i0.Input
                }], axisAnnotationPaddingBottom: [{
                    type: i0.Input
                }], axisAnnotationStrokeThickness: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinalValueLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinalValueLayerModule() {
        }
        IgxFinalValueLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinalValueLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerModule, declarations: [IgxFinalValueLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxFinalValueLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxFinalValueLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxFinalValueLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFinalValueLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxFinalValueLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinalValueLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinalValueLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxFinalValueLayerComponent", IgxFinalValueLayerComponent);
            i2.TypeRegistrar.register("FinalValueLayer", FinalValueLayer.$type);
        }
        IgxFinalValueLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinalValueLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerDynamicModule, imports: [i1.CommonModule, IgxFinalValueLayerModule], exports: [IgxFinalValueLayerModule] });
        IgxFinalValueLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerDynamicModule, imports: [[i1.CommonModule, IgxFinalValueLayerModule], IgxFinalValueLayerModule] });
        return IgxFinalValueLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinalValueLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxFinalValueLayerModule],
                        exports: [IgxFinalValueLayerModule],
                        entryComponents: [IgxFinalValueLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CrosshairLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CrosshairLayerFrame, _super);
        function CrosshairLayerFrame() {
            var _this = _super.call(this) || this;
            _this.ad = null;
            _this.ae = null;
            _this.ac = null;
            _this.af = null;
            _this.ad = new i2.List$1(i2.Number_$type, 0);
            _this.ae = new i2.List$1(i2.Number_$type, 0);
            _this.ac = new i2.List$1(i2.Brush.$, 0);
            _this.af = new i2.List$1(i2.Brush.$, 0);
            return _this;
        }
        CrosshairLayerFrame.prototype.c = function (a, b, c) {
            _super.prototype.c.call(this, a, b, c);
            var d = b;
            var e = c;
            Frame.b(this.ad, a, d.ad, e.ad);
            Frame.b(this.ae, a, d.ae, e.ae);
            FrameExtended.a(this.ac, a, d.ac, e.ac, 0);
            FrameExtended.a(this.af, a, d.af, e.af, 0);
        };
        CrosshairLayerFrame.$t = i2.markType(CrosshairLayerFrame, 'CrosshairLayerFrame', AxisAnnotationFrame.$);
        return CrosshairLayerFrame;
    }(AxisAnnotationFrame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemHighlightFrameRect = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemHighlightFrameRect, _super);
        function ItemHighlightFrameRect() {
            var _this = _super.call(this) || this;
            _this.f = 0;
            _this.e = 0;
            _this.b = 0;
            _this.c = 0;
            _this.a = 0;
            _this.i = null;
            _this.j = null;
            _this.h = null;
            _this.g = null;
            _this.d = 0;
            _this.f = 0;
            _this.e = NaN;
            _this.b = NaN;
            _this.c = NaN;
            _this.b = NaN;
            _this.a = NaN;
            _this.d = NaN;
            return _this;
        }
        ItemHighlightFrameRect.$t = i2.markType(ItemHighlightFrameRect, 'ItemHighlightFrameRect');
        return ItemHighlightFrameRect;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available shapes for a category item highlight.
     */
    var CategoryItemHighlightType = /*@__PURE__*/ (function (CategoryItemHighlightType) {
        /**
         * The default depends on the series being highlighted.
         */
        CategoryItemHighlightType[CategoryItemHighlightType["Auto"] = 0] = "Auto";
        /**
         * The highlight should use a marker shape.
         */
        CategoryItemHighlightType[CategoryItemHighlightType["Marker"] = 1] = "Marker";
        /**
         * The highlight should use a filled band shape.
         */
        CategoryItemHighlightType[CategoryItemHighlightType["Shape"] = 2] = "Shape";
        return CategoryItemHighlightType;
    })({});
    /**
     * @hidden
     */
    var CategoryItemHighlightType_$type = i2.markEnum('CategoryItemHighlightType', 'Auto,0|Marker,1|Shape,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryItemHighlightLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryItemHighlightLayerFrame, _super);
        function CategoryItemHighlightLayerFrame() {
            var _this = _super.call(this) || this;
            _this.g = null;
            _this.f = null;
            _this.g = new i2.Dictionary$2(i2.Number_$type, ItemHighlightFrameRect.$, 0);
            _this.f = new DictInterpolator$3(i2.Number_$type, ItemHighlightFrameRect.$, CategoryItemHighlightLayerFrame.$, i2.runOn(_this, _this.h), function (a) { return a.f; }, function (a) { return true; }, function () { return new ItemHighlightFrameRect(); });
            return _this;
        }
        CategoryItemHighlightLayerFrame.prototype.h = function (a, b, c, d, e, f) {
            if (d != null) {
                a.f = d.f;
            }
            else if (c != null) {
                a.f = c.f;
            }
            else {
                a.f = 0;
            }
            if (c == null || i2.isNaN_(c.e)) {
                a.e = d != null ? d.e : NaN;
            }
            else if (d == null || i2.isNaN_(d.e)) {
                a.e = NaN;
            }
            else {
                a.e = c.e + b * (d.e - c.e);
            }
            if (c == null || i2.isNaN_(c.b)) {
                a.b = d != null ? d.b : NaN;
            }
            else if (d == null || i2.isNaN_(d.b)) {
                a.b = NaN;
            }
            else {
                a.b = c.b + b * (d.b - c.b);
            }
            if (c == null || i2.isNaN_(c.c)) {
                a.c = d != null ? d.c : NaN;
            }
            else if (d == null || i2.isNaN_(d.c)) {
                a.c = NaN;
            }
            else {
                a.c = c.c + b * (d.c - c.c);
            }
            if (c == null || i2.isNaN_(c.a)) {
                a.a = d != null ? d.a : NaN;
            }
            else if (d == null || i2.isNaN_(d.a)) {
                a.a = NaN;
            }
            else {
                a.a = c.a + b * (d.a - c.a);
            }
            if (c == null || i2.isNaN_(c.d)) {
                a.d = d != null ? d.d : NaN;
            }
            else if (d == null || i2.isNaN_(d.d)) {
                a.d = NaN;
            }
            else {
                a.d = c.d + b * (d.d - c.d);
            }
            if (c == null || c.i == null) {
                a.i = d != null ? d.i : null;
            }
            else if (d == null || d.i == null) {
                a.i = null;
            }
            else {
                a.i = i2.BrushUtil.k(c.i, b, d.i, 0);
            }
            if (c == null || c.j == null) {
                a.j = d != null ? d.j : null;
            }
            else if (d == null || d.j == null) {
                a.j = null;
            }
            else {
                a.j = i2.BrushUtil.k(c.j, b, d.j, 0);
            }
            if (c == null || c.h == null) {
                a.h = d != null ? d.h : null;
            }
            else if (d == null || d.j == null) {
                a.h = null;
            }
            else {
                a.h = d.h;
            }
            if (c == null || c.g == null) {
                a.g = d != null ? d.g : null;
            }
            else if (d == null || d.j == null) {
                a.g = null;
            }
            else {
                a.g = d.g;
            }
        };
        CategoryItemHighlightLayerFrame.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            this.f.f(this.g, a, d.g, e.g, d, e);
        };
        CategoryItemHighlightLayerFrame.$t = i2.markType(CategoryItemHighlightLayerFrame, 'CategoryItemHighlightLayerFrame', Frame.$);
        return CategoryItemHighlightLayerFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryItemHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryItemHighlightLayer, _super);
        function CategoryItemHighlightLayer() {
            var _this = _super.call(this) || this;
            _this.qs = false;
            _this.qr = true;
            _this.qv = 10;
            var a = new CategoryItemHighlightLayerFrame();
            var b = new CategoryItemHighlightLayerFrame();
            var c = new CategoryItemHighlightLayerFrame();
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = CategoryItemHighlightLayer.$;
            return _this;
        }
        CategoryItemHighlightLayer.prototype.get_c5 = function () {
            return true;
        };
        CategoryItemHighlightLayer.prototype.bu = function () {
            return new CategoryItemHighlightLayerView(this);
        };
        CategoryItemHighlightLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qm = a;
        };
        CategoryItemHighlightLayer.prototype.p3 = function (a, b) {
            if (this.qq == null || this.qq == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        CategoryItemHighlightLayer.prototype.pq = function (a) {
            if (!_super.prototype.pq.call(this, a)) {
                return false;
            }
            if (this.q4 != null) {
                if (a.dn) {
                    var b = a.i9();
                    if (!i2.Base.equalsStatic(this.q4, b)) {
                        return false;
                    }
                }
                else {
                    if (!i2.Base.equalsStatic(this.q4, a.name)) {
                        return false;
                    }
                }
            }
            var c = this.py(a);
            if (!c.c) {
                return false;
            }
            return true;
        };
        CategoryItemHighlightLayer.prototype.p5 = function (a, b) {
            var e_1, _a;
            var _this = this;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            var d = this.qu;
            c.g.clear();
            if (i2.isNaN_(this.qj.x) && i2.isNaN_(this.qj.y)) {
                return;
            }
            if (this.pq(this.qq)) {
                this.ra(this.qq, c, d);
            }
            else {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        if (this.pq(e)) {
                            this.ra(e, c, d);
                        }
                        if (e.isStacked) {
                            e.ku(function (f) {
                                if (_this.pq(f)) {
                                    _this.ra(f, c, d);
                                }
                                return true;
                            });
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        CategoryItemHighlightLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case CategoryItemHighlightLayer.$$p[4]:
                case CategoryItemHighlightLayer.$$p[5]:
                case CategoryItemHighlightLayer.$$p[2]:
                case CategoryItemHighlightLayer.$$p[3]:
                    this.l0(true);
                    break;
                case CategoryItemHighlightLayer.$$p[7]:
                case CategoryItemHighlightLayer.$$p[8]:
                    this.l0(true);
                    break;
                case CategoryItemHighlightLayer.$$p[9]:
                    this.qs = d;
                    this.l0(true);
                    break;
                case CategoryItemHighlightLayer.$$p[1]:
                    this.l0(true);
                    break;
                case CategoryItemHighlightLayer.$$p[0]:
                    this.qv = this.qw;
                    this.l0(true);
                    break;
                case CategoryItemHighlightLayer.$$p[6]:
                    this.qr = d;
                    this.l0(true);
                    break;
            }
        };
        CategoryItemHighlightLayer.prototype.ra = function (a, b, c) {
            if (this.bx == null || this.bx.bv.isEmpty || this.bx.bu.isEmpty) {
                return;
            }
            if (!a.da && !a.di) {
                return;
            }
            var d = a;
            if (d.categoryAxis == null) {
                return;
            }
            var e = this.qj.x;
            e = this.bx.bu.left + this.bx.bu.width * (e - this.bx.bv.left) / this.bx.bv.width;
            var f = this.qj.y;
            f = this.bx.bu.top + this.bx.bu.height * (f - this.bx.bv.top) / this.bx.bv.height;
            var g = this.qt;
            var h = true;
            var i = i2.typeCast(IHasCategoryModePreference_$type, a);
            var j = 0;
            if (i != null) {
                j = i.preferredCategoryMode(d.categoryAxis);
                if (j == 2) {
                    h = false;
                }
            }
            var k = true;
            if (!h || this.qn == 2) {
                k = false;
            }
            if (this.qn == 1) {
                k = true;
            }
            var l = this.py(a);
            if (!l.c) {
                return;
            }
            if (k) {
                var m = a.o2(l.d, this.qu, g);
                if (j != 0 && !d.categoryAxis.ch) {
                    var n = m.x;
                    if (a.di) {
                        n -= a.getOffsetValue();
                        n += a.getCategoryWidth() * 0.5;
                        m = { $type: i2.Point_$type, x: n, y: m.y };
                    }
                    else if (a.da) {
                        n -= a.getOffsetValue();
                        n += a.getCategoryWidth() * 0.5;
                        m = { $type: i2.Point_$type, x: n, y: m.y };
                    }
                }
                if (!i2.isNaN_(m.x) && !i2.isNaN_(m.y)) {
                    m = this.o5(m);
                }
                this.q8(m, b, a);
            }
            else {
                var o = a.o2(l.d, this.qu, g);
                var p = void 0;
                var q = this.getEffectiveViewport1(this.bx);
                if (a.isVertical) {
                    var r = o.y;
                    var s = d.categoryAxis;
                    var t = this.qv;
                    if (j != 0) {
                        t = s.ki(this.bx.bv, this.bx.bu, q);
                    }
                    if (i2.isNaN_(t) || i2.isInfinity(t)) {
                        return;
                    }
                    p = new i2.Rect(0, this.pf.left, r - t / 2, this.pf.width, t);
                }
                else {
                    var u = o.x;
                    var v = d.categoryAxis;
                    var w = this.qv;
                    if (j != 0) {
                        w = v.ki(this.bx.bv, this.bx.bu, q);
                    }
                    if (i2.isNaN_(w) || i2.isInfinity(w)) {
                        return;
                    }
                    p = new i2.Rect(0, u - w / 2, this.pf.top, w, this.pf.height);
                }
                p.intersect(this.bx.bu);
                this.q9(p, b, a);
            }
        };
        CategoryItemHighlightLayer.prototype.q8 = function (a, b, c) {
            var d = new ItemHighlightFrameRect();
            d.b = a.x;
            d.e = a.y;
            d.i = this.qh();
            if (this.ro != null) {
                d.i = this.ro;
            }
            d.j = this.qi();
            if (this.rp != null) {
                d.j = this.rp;
            }
            if (d.i == null) {
                if (c.hasMarkers) {
                    d.i = this.qm.ci(c.om());
                }
                else {
                    d.i = this.qm.ci(c.of);
                }
            }
            if (d.j == null) {
                if (c.hasMarkers) {
                    d.j = this.qm.ci(c.on());
                }
                else {
                    d.j = this.qm.ci(c.oi);
                }
            }
            d.d = this.fl;
            d.f = i2.Base.getHashCodeStatic(c);
            d.g = this.qo(c, a);
            var e = (i2.typeCast(MarkerSeries.$, c) !== null) ? c.qb : null;
            if (e == null || e == MarkerSeries.qe || (this.qp != 2 && this.qp != 0)) {
                var f = MarkerSeries.ps(c, 2);
                if (this.qp != 2 && this.qp != 0) {
                    f = this.qp;
                }
                switch (f) {
                    case 3:
                    case 13:
                        e = this.ca.mu;
                        break;
                    case 4:
                        e = this.ca.m3;
                        break;
                    case 5:
                        e = this.ca.m0;
                        break;
                    case 6:
                        e = this.ca.m1;
                        break;
                    case 7:
                        e = this.ca.mv;
                        break;
                    case 8:
                        e = this.ca.my;
                        break;
                    case 9:
                        e = this.ca.mw;
                        break;
                    case 10:
                        e = this.ca.m2;
                        break;
                    case 11:
                        e = this.ca.mz;
                        break;
                    case 12:
                        e = this.ca.mx;
                        break;
                }
            }
            d.h = this.rd != null ? this.rd : e;
            if (!i2.isNaN_(d.b) && !i2.isNaN_(d.e)) {
                b.g.addItem(d.f, d);
            }
        };
        CategoryItemHighlightLayer.prototype.qo = function (a, b) {
            var c = a.hh(b);
            var d = a.fw(b);
            if (this.qu && d != Math.floor(d)) {
                c = null;
            }
            return ((function () {
                var $ret = new i2.DataContext();
                $ret.series = a;
                $ret.item = c;
                return $ret;
            })());
        };
        CategoryItemHighlightLayer.prototype.q9 = function (a, b, c) {
            var d = new ItemHighlightFrameRect();
            d.b = a.left;
            d.e = a.top;
            d.c = a.right;
            d.a = a.bottom;
            d.i = this.qh();
            d.j = this.qi();
            if (d.i == null) {
                if (c != null) {
                    d.i = this.qm.cj(c.of);
                }
            }
            if (d.j == null) {
                if (c != null) {
                    d.j = this.qm.cj(c.oi);
                }
            }
            d.d = this.fl;
            d.f = i2.Base.getHashCodeStatic(c);
            if (!a.isEmpty) {
                b.g.addItem(d.f, d);
            }
        };
        CategoryItemHighlightLayer.prototype.p8 = function (a, b) {
            var e_2, _a;
            _super.prototype.p8.call(this, a, b);
            var c = this.qm.b6;
            var d = this.qm.b5;
            var e = 0;
            var f = 0;
            var g = a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(g.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    if (h.h != null) {
                        var i = d.item(f);
                        this.rb(h, i);
                        f++;
                    }
                    else {
                        var j = c.item(e);
                        this.rc(h, j);
                        e++;
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            c.count = e;
            d.count = f;
        };
        CategoryItemHighlightLayer.prototype.rb = function (a, b) {
            if (i2.isNaN_(a.b) || i2.isNaN_(a.e) || i2.isNaN_(a.d) || a.g == null) {
                b._visibility = 1;
                return;
            }
            var c = { $type: i2.Point_$type, x: a.b, y: a.e };
            var d = a.g;
            d.itemBrush = a.i;
            var e = d.series.o2(c, this.cr() || this.qs, this.qr);
            if (i2.isNaN_(e.x) || i2.isNaN_(e.y)) {
                b._visibility = 1;
                return;
            }
            this.qm.cc(b, e.x, e.y);
            b.ah = a.h;
            b.content = a.g;
        };
        CategoryItemHighlightLayer.prototype.rc = function (a, b) {
            if (i2.isNaN_(a.b) || i2.isNaN_(a.e) || i2.isNaN_(a.a) || i2.isNaN_(a.c) || i2.isNaN_(a.d)) {
                b._visibility = 1;
                return;
            }
            this.qm.cd(b, a.b, a.e, a.c - a.b, a.a - a.e);
            b._fill = a.i;
            b._stroke = a.j;
            b.ac = a.d;
            if (this.os != null) {
                b.ai = this.os;
            }
            else {
                b.ai = null;
            }
            b.ad = this.ot;
        };
        CategoryItemHighlightLayer.prototype.eg = function () {
            return true;
        };
        CategoryItemHighlightLayer.$t = i2.markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
        CategoryItemHighlightLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:qw:re', [1, 10], 'HighlightType:qn:rf', [CategoryItemHighlightType_$type, i2.enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerBrush:ro:rg', [i2.Brush.$, null], 'MarkerOutline:rp:rh', [i2.Brush.$, null], 'MarkerTemplate:rd:ri', [i2.DataTemplate.$, null], 'MarkerType:qp:rj', [MarkerType_$type, i2.enumGetBox(MarkerType_$type, 2)], 'SkipUnknownValues:qt:rk', [0, true], 'TargetSeriesName:q4:rl', [2, null], 'TargetSeries:qq:rm', [Series.$, null], 'UseInterpolation:qu:rn', [0, false]]);
        return CategoryItemHighlightLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var CategoryItemHighlightLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryItemHighlightLayerView, _super);
        function CategoryItemHighlightLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b6 = null;
            _this.b5 = null;
            _this.b7 = null;
            _this.b8 = null;
            _this.b4 = a;
            _this.b7 = new i2.List$1(i2.ContentControl.$, 0);
            _this.b8 = new i2.List$1(i2.Rectangle.$, 0);
            return _this;
        }
        CategoryItemHighlightLayerView.prototype.as = function () {
            var _this = this;
            _super.prototype.as.call(this);
            this.b6 = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.ck);
                $ret.activate = i2.runOn(_this, _this.ce);
                $ret.disactivate = i2.runOn(_this, _this.cg);
                $ret.destroy = i2.runOn(_this, _this.cf);
                return $ret;
            })());
            this.b5 = ((function () {
                var $ret = new i2.Pool$1(i2.ContentControl.$);
                $ret.create = i2.runOn(_this, _this.ch);
                $ret.activate = i2.runOn(_this, _this.b9);
                $ret.disactivate = i2.runOn(_this, _this.cb);
                $ret.destroy = i2.runOn(_this, _this.ca);
                return $ret;
            })());
        };
        CategoryItemHighlightLayerView.prototype.ck = function () {
            var a = new i2.Rectangle();
            a.ab = false;
            this.b8.add(a);
            return a;
        };
        CategoryItemHighlightLayerView.prototype.ce = function (a) {
            a._visibility = 0;
        };
        CategoryItemHighlightLayerView.prototype.cg = function (a) {
            a._visibility = 1;
        };
        CategoryItemHighlightLayerView.prototype.cf = function (a) {
            this.b8.remove(a);
        };
        CategoryItemHighlightLayerView.prototype.ch = function () {
            var a = new Marker();
            this.b7.add(a);
            return a;
        };
        CategoryItemHighlightLayerView.prototype.b9 = function (a) {
            a._visibility = 0;
        };
        CategoryItemHighlightLayerView.prototype.cb = function (a) {
            a._visibility = 1;
        };
        CategoryItemHighlightLayerView.prototype.ca = function (a) {
            this.b7.remove(a);
        };
        CategoryItemHighlightLayerView.prototype.ci = function (a) {
            if (a == null) {
                return a;
            }
            return i2.BrushUtil.l(a, 0.3);
        };
        CategoryItemHighlightLayerView.prototype.cj = function (a) {
            if (a != null) {
                var b = i2.BrushUtil.l(a, 0.3);
                if (b.isGradient) {
                    var c = b;
                    if (c.gradientStops != null) {
                        for (var d = 0; d < c.gradientStops.length; d++) {
                            var e = c.gradientStops[d];
                            e.color = i2.Color.u(i2.truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                            e.color = e.color;
                        }
                    }
                }
                else {
                    b.color = i2.Color.u(i2.truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                    b.color = b.color;
                }
                return b;
            }
            else {
                return null;
            }
        };
        CategoryItemHighlightLayerView.prototype.cd = function (a, b, c, d, e) {
            a._visibility = 0;
            a.n = b;
            a.o = c;
            a.width = d;
            a.height = e;
        };
        CategoryItemHighlightLayerView.prototype.cc = function (a, b, c) {
            a.n = b;
            a.o = c;
        };
        CategoryItemHighlightLayerView.prototype.bh = function (a, b) {
            _super.prototype.bh.call(this, a, b);
            var c = a;
            var d = c.content;
            if (d != null) {
                if (d.itemBrush != null) {
                    d.actualItemBrush = d.itemBrush;
                }
                var e = d.series;
                if (e.hasMarkers) {
                    d.outline = e.on();
                }
                d.thickness = e.ft();
            }
        };
        CategoryItemHighlightLayerView.prototype.a6 = function (a, b) {
            var e_3, _a;
            _super.prototype.a6.call(this, a, b);
            if (a.d && !b) {
                for (var c = 0; c < this.b8.count; c++) {
                    var d = this.b8._inner[c];
                    if (d._visibility == 0) {
                        a.v(d);
                    }
                }
                if (this.b7.count > 0) {
                    var e = new i2.DataTemplatePassInfo();
                    e.isHitTestRender = b;
                    e.context = a.g();
                    e.viewportTop = this.bu.top;
                    e.viewportLeft = this.bu.left;
                    e.viewportWidth = this.bu.width;
                    e.viewportHeight = this.bu.height;
                    e.passID = "ItemMarkers";
                    var f = new i2.DataTemplateRenderInfo();
                    f.isHitTestRender = b;
                    f.passInfo = e;
                    var g = new i2.DataTemplateMeasureInfo();
                    g.passInfo = e;
                    var h = false;
                    var i = a.g();
                    g.context = i;
                    f.context = i;
                    g.renderContext = a;
                    f.renderContext = a;
                    var j = 0;
                    var k = 0;
                    var l = new i2.Dictionary$2(i2.DataTemplate.$, i2.DataTemplate.$, 0);
                    for (var m = 0; m < this.b7.count; m++) {
                        var n = this.b7._inner[m];
                        var o = n.ah;
                        if (!l.containsKey(o)) {
                            l.addItem(o, o);
                            if (o != null && o.passStarting != null) {
                                o.passStarting(e);
                            }
                        }
                        if (n._visibility == 1) {
                            continue;
                        }
                        this.bg(n, m, b);
                        if (!h) {
                            g.data = n.content;
                            g.width = n.width;
                            g.height = n.height;
                            if (o.measure != null) {
                                g.data = n.content;
                                o.measure(g);
                                h = g.isConstant;
                                if (h) {
                                    j = g.width;
                                    k = g.height;
                                }
                            }
                            f.availableWidth = g.width;
                            f.availableHeight = g.height;
                        }
                        else {
                            f.availableWidth = j;
                            f.availableHeight = k;
                        }
                        if (!i2.isNaN_(n.width) && !i2.isInfinity(n.width)) {
                            f.availableWidth = n.width;
                        }
                        if (!i2.isNaN_(n.height) && !i2.isInfinity(n.height)) {
                            f.availableHeight = n.height;
                        }
                        a.p(f, n);
                        n.m = f.availableWidth;
                        n.l = f.availableHeight;
                    }
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(l.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var p = _c.value;
                            if (p != null && p.passCompleted != null) {
                                p.passCompleted(e);
                            }
                        }
                    }
                    catch (e_3_1) {
                        e_3 = { error: e_3_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_3)
                                throw e_3.error;
                        }
                    }
                }
            }
        };
        CategoryItemHighlightLayerView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            for (var b = 0; b < this.b8.count; b++) {
                this.e.a6.exportRectangleData(a, this.b8._inner[b], "catItemRect", ["Main", "CategoryItem"]);
            }
            for (var c = 0; c < this.b7.count; c++) {
                this.e.a6.exportMarkerVisualDataFromMarker(this.e, a, this.b7._inner[c]);
            }
        };
        CategoryItemHighlightLayerView.$t = i2.markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);
        return CategoryItemHighlightLayerView;
    }(AnnotationLayerView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents an annotation layer that highlights items in a series that use a category axis
     * either by drawing a banded shape at their position, or by rendering a marker at their position.
     * Depending on the type of series, the default highlight will be affected. To override
     * the type of highlight used, you can set the HighlightType property.
    */
    var IgxCategoryItemHighlightLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryItemHighlightLayerComponent, _super);
        function IgxCategoryItemHighlightLayerComponent() {
            return _super.call(this) || this;
        }
        IgxCategoryItemHighlightLayerComponent.prototype.createImplementation = function () {
            return new CategoryItemHighlightLayer();
        };
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "isAnnotationHoverLayer", {
            /**
             * Gets whether the series is an annotation layer displayed only when hovering over the chart.
            */
            get: function () {
                return this.i.c5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "targetSeries", {
            /**
             * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                if (this.i.qq == null) {
                    return null;
                }
                if (!this.i.qq.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.qq);
                    if (e) {
                        e._implementation = this.i.qq;
                    }
                    this.i.qq.externalObject = e;
                }
                return this.i.qq.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qq = null : this.i.qq = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "targetSeriesName", {
            /**
             * Gets or sets the name of the series series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                return this.i.q4;
            },
            set: function (v) {
                this.i.q4 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "useInterpolation", {
            /**
             * Gets or sets whether to use value interpolation when drawing a line through the best value for the pointer position.
            */
            get: function () {
                return this.i.qu;
            },
            set: function (v) {
                this.i.qu = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "highlightType", {
            /**
             * Gets or sets which type of highlight shape to use when highlighting items.
            */
            get: function () {
                return this.i.qn;
            },
            set: function (v) {
                this.i.qn = i2.ensureEnum(CategoryItemHighlightType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "markerType", {
            /**
             * Gets or sets which type of marker to use when highlighting items, if appropriate.
            */
            get: function () {
                return this.i.qp;
            },
            set: function (v) {
                this.i.qp = i2.ensureEnum(MarkerType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "markerBrush", {
            /**
             * Gets or sets which color to use for the marker when highlighting items, if appropriate.
            */
            get: function () {
                return i2.brushToString(this.i.ro);
            },
            set: function (v) {
                this.i.ro = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "markerOutline", {
            /**
             * Gets or sets which outline color to use for the marker when highlighting items, if appropriate.
            */
            get: function () {
                return i2.brushToString(this.i.rp);
            },
            set: function (v) {
                this.i.rp = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "markerTemplate", {
            /**
             * Gets or sets the template to use for marker visuals for the current series object.
            */
            get: function () {
                return this.i.rd;
            },
            set: function (v) {
                this.i.rd = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "bandHighlightWidth", {
            /**
             * Gets or sets the width to use for the highlight region if highlighting items in a grid aligned series (line, spline, etc), with a banded shape.
            */
            get: function () {
                return this.i.qw;
            },
            set: function (v) {
                this.i.qw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryItemHighlightLayerComponent.prototype, "skipUnknownValues", {
            /**
             * Gets or sets whether to skip unknown values when searching for series values.
            */
            get: function () {
                return this.i.qt;
            },
            set: function (v) {
                this.i.qt = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryItemHighlightLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
                return this.targetSeries;
            }
            return null;
        };
        IgxCategoryItemHighlightLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetSeries && this.targetSeries._styling) {
                this.targetSeries._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxCategoryItemHighlightLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryItemHighlightLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryItemHighlightLayerComponent, selector: "igx-category-item-highlight-layer", inputs: { targetSeries: "targetSeries", targetSeriesName: "targetSeriesName", useInterpolation: "useInterpolation", highlightType: "highlightType", markerType: "markerType", markerBrush: "markerBrush", markerOutline: "markerOutline", markerTemplate: "markerTemplate", bandHighlightWidth: "bandHighlightWidth", skipUnknownValues: "skipUnknownValues" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCategoryItemHighlightLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCategoryItemHighlightLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryItemHighlightLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-item-highlight-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCategoryItemHighlightLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCategoryItemHighlightLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { targetSeries: [{
                    type: i0.Input
                }], targetSeriesName: [{
                    type: i0.Input
                }], useInterpolation: [{
                    type: i0.Input
                }], highlightType: [{
                    type: i0.Input
                }], markerType: [{
                    type: i0.Input
                }], markerBrush: [{
                    type: i0.Input
                }], markerOutline: [{
                    type: i0.Input
                }], markerTemplate: [{
                    type: i0.Input
                }], bandHighlightWidth: [{
                    type: i0.Input
                }], skipUnknownValues: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryItemHighlightLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryItemHighlightLayerModule() {
        }
        IgxCategoryItemHighlightLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryItemHighlightLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerModule, declarations: [IgxCategoryItemHighlightLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxCategoryItemHighlightLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxCategoryItemHighlightLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxCategoryItemHighlightLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryItemHighlightLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxCategoryItemHighlightLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryItemHighlightLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryItemHighlightLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryItemHighlightLayerComponent", IgxCategoryItemHighlightLayerComponent);
            i2.TypeRegistrar.register("CategoryItemHighlightLayer", CategoryItemHighlightLayer.$type);
        }
        IgxCategoryItemHighlightLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryItemHighlightLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerDynamicModule, imports: [i1.CommonModule, IgxCategoryItemHighlightLayerModule], exports: [IgxCategoryItemHighlightLayerModule] });
        IgxCategoryItemHighlightLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerDynamicModule, imports: [[i1.CommonModule, IgxCategoryItemHighlightLayerModule], IgxCategoryItemHighlightLayerModule] });
        return IgxCategoryItemHighlightLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryItemHighlightLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryItemHighlightLayerModule],
                        exports: [IgxCategoryItemHighlightLayerModule],
                        entryComponents: [IgxCategoryItemHighlightLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CrosshairLayer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CrosshairLayer, _super);
        function CrosshairLayer() {
            var _this = _super.call(this) || this;
            _this.xAxisAnnotationFormatLabel = null;
            _this.yAxisAnnotationFormatLabel = null;
            _this.qw = null;
            _this.qv = null;
            var a = new CrosshairLayerFrame();
            var b = new CrosshairLayerFrame();
            var c = new CrosshairLayerFrame();
            var d = _this.ha / 1000;
            _this.pk = a;
            _this.pj = b;
            _this.pl = c;
            _this.ab = CrosshairLayer.$;
            return _this;
        }
        CrosshairLayer.prototype.get_c5 = function () {
            return true;
        };
        CrosshairLayer.prototype.get_c3 = function () {
            return true;
        };
        CrosshairLayer.prototype.bu = function () {
            return new CrosshairLayerView(this);
        };
        CrosshairLayer.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.qo = a;
        };
        CrosshairLayer.prototype.qq = function () {
            return this.xAxisAnnotationFormatLabel != null;
        };
        CrosshairLayer.prototype.qr = function () {
            return this.yAxisAnnotationFormatLabel != null;
        };
        Object.defineProperty(CrosshairLayer.prototype, "s3", {
            get: function () {
                return new i2.Thickness(1, this.qy, this.q0, this.qz, this.qx);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CrosshairLayer.prototype, "s4", {
            get: function () {
                return new i2.Thickness(1, this.q3, this.q5, this.q4, this.q2);
            },
            enumerable: false,
            configurable: true
        });
        CrosshairLayer.prototype.p3 = function (a, b) {
            if (this.qp == null || this.qp == a) {
                if (!this.as.c) {
                    this.l0(b);
                }
            }
        };
        CrosshairLayer.prototype.p5 = function (a, b) {
            var e_1, _a;
            var _this = this;
            _super.prototype.p5.call(this, a, b);
            var c = a;
            var d = this.qu;
            var e = this.qt;
            c.ad.clear();
            c.ae.clear();
            c.ac.clear();
            c.af.clear();
            AxisAnnotationFrameManager.b(c);
            if (this.pq(this.qp)) {
                this.r2(this.qp, c, d, e);
            }
            else {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var f = _c.value;
                        if (this.pq(f)) {
                            this.r2(f, c, d, e);
                        }
                        if (f.isStacked) {
                            f.ku(function (g) {
                                if (_this.pq(g)) {
                                    _this.r2(g, c, d, e);
                                }
                                return true;
                            });
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        CrosshairLayer.prototype.pq = function (a) {
            if (!_super.prototype.pq.call(this, a)) {
                return false;
            }
            if (this.rd != null) {
                if (a.dn) {
                    var b = a.i9();
                    if (!i2.Base.equalsStatic(this.rd, b)) {
                        return false;
                    }
                }
                else {
                    if (!i2.Base.equalsStatic(this.rd, a.name)) {
                        return false;
                    }
                }
            }
            var c = this.py(a);
            if (!c.c) {
                return false;
            }
            return true;
        };
        CrosshairLayer.prototype.la = function () {
            _super.prototype.la.call(this);
            if (!this.as.c && !this.cr()) {
                return;
            }
            if (this.cr()) {
                this.r3(this.pl, false);
            }
            else {
                this.r3(this.pj, false);
            }
        };
        CrosshairLayer.prototype.r2 = function (a, b, c, d) {
            var e = this.py(a);
            if (!e.c) {
                return;
            }
            var f = e.d;
            f = a.o2(f, c, d);
            var g = this.of;
            if (g == null) {
                g = this.oj;
            }
            if (g == null) {
                g = a.of;
                if (g != null) {
                    g = this.qo.cb(g);
                }
            }
            var h = g;
            var i = g;
            if (this.sv != null) {
                h = this.sv;
            }
            if (this.sw != null) {
                i = this.sw;
            }
            b.ac.add(h);
            b.af.add(i);
            b.ad.add(f.y);
            b.ae.add(f.x);
            if (this.qs && !i2.isNaN_(f.y)) {
                AxisAnnotationFrameManager.c(b, f, a, this.ca, this.getEffectiveViewport(), g, this.sx, this.sz, this.sy, this.s3, this.q1, this.s0, this.s2, this.s1, this.s4, this.q6, this.s6 == 0, this.s5 == 0);
            }
        };
        CrosshairLayer.prototype.r3 = function (a, b) {
            var c = false;
            if (this.qv == null) {
                c = true;
                this.qw = new i2.List$1(Axis.$, 0);
                this.qv = new i2.Dictionary$2(Axis.$, i2.Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            AxisAnnotationFrameManager.d(this, a, c, this.qv, this.qw, b, this.q7, this.q8, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
        };
        CrosshairLayer.prototype.r1 = function (a, b, c, d, e) {
            var f = a.item(b);
            b++;
            if (e) {
                f._stroke = d.af._inner[c];
                f._fill = d.af._inner[c];
            }
            else {
                f._stroke = d.ac._inner[c];
                f._fill = d.ac._inner[c];
            }
            f.ac = this.fl;
            f.ai = this.os;
            f.ad = this.ot;
            return new i2.Tuple$2(i2.Path.$, i2.Number_$type, f, b);
        };
        CrosshairLayer.prototype.p8 = function (a, b) {
            _super.prototype.p8.call(this, a, b);
            var c = this.qo.b5;
            var d = a;
            var e = d.ad.count;
            var f = 0;
            var g = b.bu.left;
            var h = b.bu.right;
            var i = b.bu.top;
            var j = b.bu.bottom;
            var k = this.s6 == 0;
            var l = this.s5 == 0;
            for (var m = 0; m < e; m++) {
                var n = Math.floor(d.ad._inner[m]);
                var o = Math.floor(d.ae._inner[m]);
                var p = null;
                if (k) {
                    if (i2.isNaN_(n)) {
                        continue;
                    }
                    var q = this.r1(c, f, m, d, true);
                    p = q.c;
                    f = q.d;
                    var r = new i2.PathGeometry();
                    var s = new i2.PathFigure();
                    s._startPoint = { $type: i2.Point_$type, x: o, y: i };
                    var t = new i2.LineSegment(1);
                    t.c = { $type: i2.Point_$type, x: o, y: j };
                    s._segments.add(t);
                    r.c.add(s);
                    p.ak = r;
                }
                if (l) {
                    if (i2.isNaN_(n)) {
                        continue;
                    }
                    var u = this.r1(c, f, m, d, false);
                    p = u.c;
                    f = u.d;
                    var v = new i2.PathGeometry();
                    var w = new i2.PathFigure();
                    w._startPoint = { $type: i2.Point_$type, x: g, y: n };
                    var x = new i2.LineSegment(1);
                    x.c = { $type: i2.Point_$type, x: h, y: n };
                    w._segments.add(x);
                    v.c.add(w);
                    p.ak = v;
                }
            }
            c.count = f;
            if (this.cr()) {
                this.r3(this.pl, true);
            }
            else {
                this.r3(this.pj, false);
            }
        };
        CrosshairLayer.prototype.eg = function () {
            return true;
        };
        CrosshairLayer.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case CrosshairLayer.$$p[1]:
                    this.l0(true);
                    break;
                case CrosshairLayer.$$p[8]:
                    this.l0(true);
                    break;
                case CrosshairLayer.$$p[4]:
                case CrosshairLayer.$$p[5]:
                    this.l0(true);
                    break;
                case CrosshairLayer.$$p[2]:
                case CrosshairLayer.$$p[9]:
                case CrosshairLayer.$$p[11]:
                case CrosshairLayer.$$p[13]:
                case CrosshairLayer.$$p[15]:
                case CrosshairLayer.$$p[14]:
                case CrosshairLayer.$$p[12]:
                case CrosshairLayer.$$p[16]:
                case CrosshairLayer.$$p[17]:
                case CrosshairLayer.$$p[18]:
                case CrosshairLayer.$$p[20]:
                case CrosshairLayer.$$p[22]:
                case CrosshairLayer.$$p[24]:
                case CrosshairLayer.$$p[23]:
                case CrosshairLayer.$$p[21]:
                case CrosshairLayer.$$p[25]:
                case CrosshairLayer.$$p[26]:
                case CrosshairLayer.$$p[0]:
                case CrosshairLayer.$$p[7]:
                case CrosshairLayer.$$p[6]:
                    this.l0(true);
                    break;
            }
        };
        CrosshairLayer.$t = i2.markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
        CrosshairLayer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:sv:r4', [i2.Brush.$, null], 'HorizontalLineVisibility:s5:r5', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'IsAxisAnnotationEnabled:qs:r6', [0, false], 'SkipUnknownValues:qt:r7', [0, true], 'TargetSeriesName:rd:r8', [2, null], 'TargetSeries:qp:r9', [Series.$, null], 'UseInterpolation:qu:sa', [0, true], 'VerticalLineStroke:sw:sb', [i2.Brush.$, null], 'VerticalLineVisibility:s6:sc', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'XAxisAnnotationBackground:sx:sd', [i2.Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:q7:se', [1, -1], 'XAxisAnnotationOutline:sy:sf', [i2.Brush.$, null], 'XAxisAnnotationPaddingBottom:qx:sg', [1, NaN], 'XAxisAnnotationPaddingLeft:qy:sh', [1, NaN], 'XAxisAnnotationPaddingRight:qz:si', [1, NaN], 'XAxisAnnotationPaddingTop:q0:sj', [1, NaN], 'XAxisAnnotationStrokeThickness:q1:sk', [1, NaN], 'XAxisAnnotationTextColor:sz:sl', [i2.Brush.$, null], 'YAxisAnnotationBackground:s0:sm', [i2.Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:q8:sn', [1, -1], 'YAxisAnnotationOutline:s1:so', [i2.Brush.$, null], 'YAxisAnnotationPaddingBottom:q2:sp', [1, NaN], 'YAxisAnnotationPaddingLeft:q3:sq', [1, NaN], 'YAxisAnnotationPaddingRight:q4:sr', [1, NaN], 'YAxisAnnotationPaddingTop:q5:ss', [1, NaN], 'YAxisAnnotationStrokeThickness:q6:st', [1, NaN], 'YAxisAnnotationTextColor:s2:su', [i2.Brush.$, null]]);
        return CrosshairLayer;
    }(AnnotationLayer));
    /**
     * @hidden
     */
    var CrosshairLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CrosshairLayerView, _super);
        function CrosshairLayerView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b5 = null;
            _this.b6 = null;
            _this.b4 = a;
            _this.b6 = new i2.List$1(i2.Path.$, 0);
            return _this;
        }
        CrosshairLayerView.prototype.as = function () {
            var _this = this;
            _super.prototype.as.call(this);
            this.b5 = ((function () {
                var $ret = new i2.Pool$1(i2.Path.$);
                $ret.create = i2.runOn(_this, _this.cc);
                $ret.activate = i2.runOn(_this, _this.b7);
                $ret.disactivate = i2.runOn(_this, _this.b9);
                $ret.destroy = i2.runOn(_this, _this.b8);
                return $ret;
            })());
            this.b4.gm = Defaults.j;
        };
        CrosshairLayerView.prototype.cc = function () {
            var a = new i2.Path();
            a.j = new i2.TranslateTransform();
            this.b6.add(a);
            return a;
        };
        CrosshairLayerView.prototype.b7 = function (a) {
            a._visibility = 0;
        };
        CrosshairLayerView.prototype.b9 = function (a) {
            a._visibility = 1;
        };
        CrosshairLayerView.prototype.b8 = function (a) {
            this.b6.remove(a);
        };
        CrosshairLayerView.prototype.ca = function (a, b, c, d) {
            if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
                var e = ((function () {
                    var $ret = new i2.LineGeometry();
                    $ret.d = { $type: i2.Point_$type, x: c, y: b };
                    $ret.c = { $type: i2.Point_$type, x: d, y: b };
                    return $ret;
                })());
                a.ak = e;
            }
        };
        CrosshairLayerView.prototype.cb = function (a) {
            if (a == null) {
                return a;
            }
            return i2.BrushUtil.l(a, 0.1);
        };
        CrosshairLayerView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d && !b) {
                for (var c = 0; c < this.b6.count; c++) {
                    var d = this.b6._inner[c];
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
        };
        CrosshairLayerView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            for (var b = 0; b < this.b6.count; b++) {
                this.e.a6.exportPathData(a, this.b6._inner[b], "crosshairLine", ["Main", "Crosshair"]);
            }
        };
        CrosshairLayerView.$t = i2.markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
        return CrosshairLayerView;
    }(AnnotationLayerView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
    */
    var IgxCrosshairLayerComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCrosshairLayerComponent, _super);
        function IgxCrosshairLayerComponent() {
            return _super.call(this) || this;
        }
        IgxCrosshairLayerComponent.prototype.createImplementation = function () {
            return new CrosshairLayer();
        };
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "isAnnotationHoverLayer", {
            /**
             * Gets whether the series is an annotation layer displayed only when hovering over the chart.
            */
            get: function () {
                return this.i.c5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "isAnnotationCrosshairLayer", {
            /**
             * Gets whether the series is an crosshair annotation layer.
            */
            get: function () {
                return this.i.c3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "horizontalLineStroke", {
            /**
             * Gets or sets the color to use for the horizontal line. Leave null for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.sv);
            },
            set: function (v) {
                this.i.sv = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "verticalLineStroke", {
            /**
             * Gets or sets the color to use for vertical line. Leave null for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.sw);
            },
            set: function (v) {
                this.i.sw = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "targetSeriesName", {
            /**
             * Gets or sets the name of the series series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                return this.i.rd;
            },
            set: function (v) {
                this.i.rd = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "targetSeries", {
            /**
             * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
            */
            get: function () {
                if (this.i.qp == null) {
                    return null;
                }
                if (!this.i.qp.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.qp);
                    if (e) {
                        e._implementation = this.i.qp;
                    }
                    this.i.qp.externalObject = e;
                }
                return this.i.qp.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qp = null : this.i.qp = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "useInterpolation", {
            /**
             * Gets or sets whether to use value interpolation when drawing a line through the best value for the cursor position.
            */
            get: function () {
                return this.i.qu;
            },
            set: function (v) {
                this.i.qu = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "isAxisAnnotationEnabled", {
            /**
             * Gets or sets whether to draw annotations over the axes where the crosshair meets with them.
            */
            get: function () {
                return this.i.qs;
            },
            set: function (v) {
                this.i.qs = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationTextColor", {
            /**
             * Gets or sets the color to use for the x axis annotation text. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.sz);
            },
            set: function (v) {
                this.i.sz = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationBackground", {
            /**
             * Gets or sets the color to use for the x axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.sx);
            },
            set: function (v) {
                this.i.sx = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationInterpolatedValuePrecision", {
            /**
             * Gets or sets the precision to use displaying values for interpolated crosshair positions.
            */
            get: function () {
                return this.i.q7;
            },
            set: function (v) {
                this.i.q7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationOutline", {
            /**
             * Gets or sets the color to use for the x axis annotation outline. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.sy);
            },
            set: function (v) {
                this.i.sy = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingLeft", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qy;
            },
            set: function (v) {
                this.i.qy = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingTop", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.q0;
            },
            set: function (v) {
                this.i.q0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingRight", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qz;
            },
            set: function (v) {
                this.i.qz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingBottom", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.qx;
            },
            set: function (v) {
                this.i.qx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingLeft", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.q3;
            },
            set: function (v) {
                this.i.q3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingTop", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.q5;
            },
            set: function (v) {
                this.i.q5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingRight", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.q4;
            },
            set: function (v) {
                this.i.q4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingBottom", {
            /**
             * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
            */
            get: function () {
                return this.i.q2;
            },
            set: function (v) {
                this.i.q2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "xAxisAnnotationStrokeThickness", {
            /**
             * Gets or sets the stroke thickness for the x axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.q1;
            },
            set: function (v) {
                this.i.q1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationTextColor", {
            /**
             * Gets or sets the color to use for the y axis annotation text. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.s2);
            },
            set: function (v) {
                this.i.s2 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationBackground", {
            /**
             * Gets or sets the color to use for the y axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.s0);
            },
            set: function (v) {
                this.i.s0 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationInterpolatedValuePrecision", {
            /**
             * Gets or sets the precision to use displaying values for interpolated crosshair positions.
            */
            get: function () {
                return this.i.q8;
            },
            set: function (v) {
                this.i.q8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationOutline", {
            /**
             * Gets or sets the color to use for the y axis annotation outline. Leave unset for an automatic value.
            */
            get: function () {
                return i2.brushToString(this.i.s1);
            },
            set: function (v) {
                this.i.s1 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "yAxisAnnotationStrokeThickness", {
            /**
             * Gets or sets the stroke thickness for the y axis annotation backing. Leave unset for an automatic value.
            */
            get: function () {
                return this.i.q6;
            },
            set: function (v) {
                this.i.q6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "verticalLineVisibility", {
            /**
             * Gets or sets whether to display the vertical line.
            */
            get: function () {
                return this.i.s6;
            },
            set: function (v) {
                this.i.s6 = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "horizontalLineVisibility", {
            /**
             * Gets or sets whether to display the horizontal line.
            */
            get: function () {
                return this.i.s5;
            },
            set: function (v) {
                this.i.s5 = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCrosshairLayerComponent.prototype, "skipUnknownValues", {
            /**
             * Gets or sets whether to skip unknown values when searching for series values.
            */
            get: function () {
                return this.i.qt;
            },
            set: function (v) {
                this.i.qt = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxCrosshairLayerComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
                return this.targetSeries;
            }
            return null;
        };
        IgxCrosshairLayerComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.targetSeries && this.targetSeries._styling) {
                this.targetSeries._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxCrosshairLayerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCrosshairLayerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCrosshairLayerComponent, selector: "igx-crosshair-layer", inputs: { horizontalLineStroke: "horizontalLineStroke", verticalLineStroke: "verticalLineStroke", targetSeriesName: "targetSeriesName", targetSeries: "targetSeries", useInterpolation: "useInterpolation", isAxisAnnotationEnabled: "isAxisAnnotationEnabled", xAxisAnnotationTextColor: "xAxisAnnotationTextColor", xAxisAnnotationBackground: "xAxisAnnotationBackground", xAxisAnnotationInterpolatedValuePrecision: "xAxisAnnotationInterpolatedValuePrecision", xAxisAnnotationOutline: "xAxisAnnotationOutline", xAxisAnnotationPaddingLeft: "xAxisAnnotationPaddingLeft", xAxisAnnotationPaddingTop: "xAxisAnnotationPaddingTop", xAxisAnnotationPaddingRight: "xAxisAnnotationPaddingRight", xAxisAnnotationPaddingBottom: "xAxisAnnotationPaddingBottom", yAxisAnnotationPaddingLeft: "yAxisAnnotationPaddingLeft", yAxisAnnotationPaddingTop: "yAxisAnnotationPaddingTop", yAxisAnnotationPaddingRight: "yAxisAnnotationPaddingRight", yAxisAnnotationPaddingBottom: "yAxisAnnotationPaddingBottom", xAxisAnnotationStrokeThickness: "xAxisAnnotationStrokeThickness", yAxisAnnotationTextColor: "yAxisAnnotationTextColor", yAxisAnnotationBackground: "yAxisAnnotationBackground", yAxisAnnotationInterpolatedValuePrecision: "yAxisAnnotationInterpolatedValuePrecision", yAxisAnnotationOutline: "yAxisAnnotationOutline", yAxisAnnotationStrokeThickness: "yAxisAnnotationStrokeThickness", verticalLineVisibility: "verticalLineVisibility", horizontalLineVisibility: "horizontalLineVisibility", skipUnknownValues: "skipUnknownValues" }, providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCrosshairLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCrosshairLayerComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCrosshairLayerComponent;
    }(IgxAnnotationLayerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-crosshair-layer',
                        template: "",
                        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: i0.forwardRef(function () { return IgxCrosshairLayerComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCrosshairLayerComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { horizontalLineStroke: [{
                    type: i0.Input
                }], verticalLineStroke: [{
                    type: i0.Input
                }], targetSeriesName: [{
                    type: i0.Input
                }], targetSeries: [{
                    type: i0.Input
                }], useInterpolation: [{
                    type: i0.Input
                }], isAxisAnnotationEnabled: [{
                    type: i0.Input
                }], xAxisAnnotationTextColor: [{
                    type: i0.Input
                }], xAxisAnnotationBackground: [{
                    type: i0.Input
                }], xAxisAnnotationInterpolatedValuePrecision: [{
                    type: i0.Input
                }], xAxisAnnotationOutline: [{
                    type: i0.Input
                }], xAxisAnnotationPaddingLeft: [{
                    type: i0.Input
                }], xAxisAnnotationPaddingTop: [{
                    type: i0.Input
                }], xAxisAnnotationPaddingRight: [{
                    type: i0.Input
                }], xAxisAnnotationPaddingBottom: [{
                    type: i0.Input
                }], yAxisAnnotationPaddingLeft: [{
                    type: i0.Input
                }], yAxisAnnotationPaddingTop: [{
                    type: i0.Input
                }], yAxisAnnotationPaddingRight: [{
                    type: i0.Input
                }], yAxisAnnotationPaddingBottom: [{
                    type: i0.Input
                }], xAxisAnnotationStrokeThickness: [{
                    type: i0.Input
                }], yAxisAnnotationTextColor: [{
                    type: i0.Input
                }], yAxisAnnotationBackground: [{
                    type: i0.Input
                }], yAxisAnnotationInterpolatedValuePrecision: [{
                    type: i0.Input
                }], yAxisAnnotationOutline: [{
                    type: i0.Input
                }], yAxisAnnotationStrokeThickness: [{
                    type: i0.Input
                }], verticalLineVisibility: [{
                    type: i0.Input
                }], horizontalLineVisibility: [{
                    type: i0.Input
                }], skipUnknownValues: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCrosshairLayerModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCrosshairLayerModule() {
        }
        IgxCrosshairLayerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCrosshairLayerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerModule, declarations: [IgxCrosshairLayerComponent], imports: [i1.CommonModule, IgxAnnotationLayerProxyModule], exports: [IgxCrosshairLayerComponent, IgxAnnotationLayerProxyModule] });
        IgxCrosshairLayerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerModule, imports: [[i1.CommonModule, IgxAnnotationLayerProxyModule], IgxAnnotationLayerProxyModule] });
        return IgxCrosshairLayerModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCrosshairLayerComponent],
                        imports: [i1.CommonModule, IgxAnnotationLayerProxyModule],
                        exports: [IgxCrosshairLayerComponent, IgxAnnotationLayerProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCrosshairLayerDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCrosshairLayerDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCrosshairLayerComponent", IgxCrosshairLayerComponent);
            i2.TypeRegistrar.register("CrosshairLayer", CrosshairLayer.$type);
        }
        IgxCrosshairLayerDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCrosshairLayerDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerDynamicModule, imports: [i1.CommonModule, IgxCrosshairLayerModule], exports: [IgxCrosshairLayerModule] });
        IgxCrosshairLayerDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerDynamicModule, imports: [[i1.CommonModule, IgxCrosshairLayerModule], IgxCrosshairLayerModule] });
        return IgxCrosshairLayerDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCrosshairLayerDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCrosshairLayerModule],
                        exports: [IgxCrosshairLayerModule],
                        entryComponents: [IgxCrosshairLayerComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHorizontalAnchoredCategorySeriesProxy_$type = new i2.Type(null, 'IHorizontalAnchoredCategorySeriesProxy');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IBucketizer_$type = new i2.Type(null, 'IBucketizer');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISortingAxis_$type = new i2.Type(null, 'ISortingAxis');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISupportsErrorBars_$type = new i2.Type(null, 'ISupportsErrorBars');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISupportsMarkers_$type = new i2.Type(null, 'ISupportsMarkers');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultSupportsMarkers = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultSupportsMarkers, _super);
        function DefaultSupportsMarkers() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(DefaultSupportsMarkers.prototype, "shouldDisplayMarkers", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        DefaultSupportsMarkers.prototype.updateMarkerCount = function (a) {
        };
        DefaultSupportsMarkers.prototype.updateMarkerTemplate = function (a, b, c) {
        };
        DefaultSupportsMarkers.$t = i2.markType(DefaultSupportsMarkers, 'DefaultSupportsMarkers', i2.Base.$, [ISupportsMarkers_$type]);
        return DefaultSupportsMarkers;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultProvidesViewport = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultProvidesViewport, _super);
        function DefaultProvidesViewport() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DefaultProvidesViewport.prototype.getViewInfo = function (a, b) {
            a = i2.Rect.empty;
            b = i2.Rect.empty;
            return {
                p0: a,
                p1: b
            };
        };
        DefaultProvidesViewport.prototype.getEffectiveViewport = function () {
            return i2.Rect.empty;
        };
        DefaultProvidesViewport.$t = i2.markType(DefaultProvidesViewport, 'DefaultProvidesViewport', i2.Base.$, [IProvidesViewport_$type]);
        return DefaultProvidesViewport;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultSupportsErrorBars = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultSupportsErrorBars, _super);
        function DefaultSupportsErrorBars() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(DefaultSupportsErrorBars.prototype, "GetErrorBarsXAxis", {
            get: function () {
                return null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultSupportsErrorBars.prototype, "GetErrorBarsYAxis", {
            get: function () {
                return null;
            },
            enumerable: false,
            configurable: true
        });
        DefaultSupportsErrorBars.$t = i2.markType(DefaultSupportsErrorBars, 'DefaultSupportsErrorBars', i2.Base.$, [ISupportsErrorBars_$type]);
        return DefaultSupportsErrorBars;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FramePreparer, _super);
        function FramePreparer(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.c = null;
            _this.a = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = [i2.typeCast(ISupportsMarkers_$type, c), i2.typeCast(IProvidesViewport_$type, c), i2.typeCast(ISupportsErrorBars_$type, c)];
                        {
                            var f = d[0];
                            var g = d[1];
                            var h = d[2];
                            _this.c = new DefaultSupportsMarkers();
                            _this.a = new DefaultProvidesViewport();
                            _this.b = new DefaultSupportsErrorBars();
                            if (f != null) {
                                _this.c = f;
                            }
                            if (g != null) {
                                _this.a = g;
                            }
                            if (h != null) {
                                _this.b = h;
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        _this.c = new DefaultSupportsMarkers();
                        _this.a = new DefaultProvidesViewport();
                        _this.b = new DefaultSupportsErrorBars();
                        if (c != null) {
                            _this.c = c;
                        }
                        if (d != null) {
                            _this.a = d;
                        }
                        if (e != null) {
                            _this.b = e;
                        }
                    }
                    break;
            }
            return _this;
        }
        FramePreparer.$t = i2.markType(FramePreparer, 'FramePreparer');
        return FramePreparer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IIsCategoryBased_$type = new i2.Type(null, 'IIsCategoryBased');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryFrame, _super);
        function CategoryFrame(a) {
            var _this = _super.call(this) || this;
            _this.z = null;
            _this.f = new i2.List$1(i2.Array_$type, 0);
            _this.k = new i2.List$1(i2.Number_$type, 0);
            _this.l = new i2.List$1(i2.Number_$type, 0);
            _this.m = new i2.List$1(i2.Point_$type, 0);
            _this.n = new i2.List$1(i2.Number_$type, 0);
            _this.p = new i2.List$1(i2.Point_$type, 0);
            _this.q = new i2.List$1(i2.Number_$type, 0);
            _this.i = new i2.List$1(i2.Point_$type, 0);
            _this.j = new i2.List$1(i2.Number_$type, 0);
            _this.h = new i2.List$1(i2.Number_$type, 0);
            _this.g = new i2.List$1(i2.Number_$type, 0);
            _this.o = new i2.List$1(i2.Number_$type, 0);
            _this.t = 0;
            _this.s = 0;
            _this.aa = null;
            _this.z = new i2.Rect(0, 0, 0, 1, 1);
            _this.s = a;
            _this.w();
            return _this;
        }
        CategoryFrame.prototype.c = function (a, b, c) {
            this.w();
            var d = i2.typeCast(CategoryFrame.$, b);
            var e = i2.typeCast(CategoryFrame.$, c);
            var f = d.f.count;
            var g = e.f.count;
            var h = Math.max(f, g);
            var i = Math.max(d.m.count, e.m.count);
            var j = Math.max(d.p.count, e.p.count);
            var k = Math.max(d.k.count, e.k.count);
            var l = Math.max(d.i.count, e.i.count);
            var m = d.o.count > 0;
            if (m) {
                this.x(this.o, a, d.o, e.o, h);
            }
            var n = d.n.count > 0;
            if (n) {
                this.x(this.n, a, d.n, e.n, i);
            }
            var o = d.q.count > 0;
            if (o) {
                this.x(this.q, a, d.q, e.q, j);
            }
            var p = d.l.count > 0;
            if (p) {
                this.x(this.l, a, d.l, e.l, k);
            }
            var q = d.j.count > 0;
            if (q) {
                this.x(this.j, a, d.j, e.j, l);
            }
            if (this.f.count < h) {
                while (this.f.count < h) {
                    this.f.add(new Array(this.s));
                }
            }
            if (this.f.count > h) {
                this.f.v(h, this.f.count - h);
            }
            if (m) {
                var r = 0;
                for (var s = 0; s < Math.min(f, g); ++s) {
                    var t = this.f._inner[s];
                    r = a * this.o._inner[s];
                    r = r > 1 ? 1 : r;
                    for (var u = 0; u < this.s; ++u) {
                        t[u] = d.f._inner[s][u] + r * (e.f._inner[s][u] - d.f._inner[s][u]);
                    }
                }
            }
            else {
                for (var v = 0; v < Math.min(f, g); ++v) {
                    var w = this.f._inner[v];
                    for (var x = 0; x < this.s; ++x) {
                        w[x] = d.f._inner[v][x] + a * (e.f._inner[v][x] - d.f._inner[v][x]);
                    }
                }
            }
            if (f < g) {
                var y = new Array(this.s);
                for (var z = this.s - 1; z >= 0; --z) {
                    y[z] = d.f.count > 0 ? d.f._inner[d.f.count - 1][z] : 0;
                }
                if (m) {
                    var aa = 0;
                    for (var ab = f; ab < g; ++ab) {
                        var ac = this.f._inner[ab];
                        aa = a * this.o._inner[ab];
                        aa = aa > 1 ? 1 : aa;
                        for (var ad = this.s - 1; ad >= 0; --ad) {
                            ac[ad] = y[ad] + aa * (e.f._inner[ab][ad] - y[ad]);
                        }
                    }
                }
                else {
                    for (var ae = f; ae < g; ++ae) {
                        var af = this.f._inner[ae];
                        for (var ag = this.s - 1; ag >= 0; --ag) {
                            af[ag] = y[ag] + a * (e.f._inner[ae][ag] - y[ag]);
                        }
                    }
                }
            }
            if (f > g) {
                var ah = new Array(this.s);
                for (var ai = this.s - 1; ai >= 0; --ai) {
                    ah[ai] = e.f.count > 0 ? e.f._inner[e.f.count - 1][ai] : 0;
                }
                if (m) {
                    var aj = 0;
                    for (var ak = g; ak < f; ++ak) {
                        var al = this.f._inner[ak];
                        aj = a * this.o._inner[ak];
                        aj = aj > 1 ? 1 : aj;
                        for (var am = this.s - 1; am >= 0; --am) {
                            al[am] = d.f._inner[ak][am] + aj * (ah[am] - d.f._inner[ak][am]);
                        }
                    }
                }
                else {
                    for (var an = g; an < f; ++an) {
                        var ao = this.f._inner[an];
                        for (var ap = this.s - 1; ap >= 0; --ap) {
                            ao[ap] = d.f._inner[an][ap] + a * (ah[ap] - d.f._inner[an][ap]);
                        }
                    }
                }
            }
            if (n) {
                Frame.d(this.m, a, d.m, e.m, this.n);
            }
            else {
                Frame.a(this.m, a, d.m, e.m);
            }
            if (o) {
                Frame.d(this.p, a, d.p, e.p, this.q);
            }
            else {
                Frame.a(this.p, a, d.p, e.p);
            }
            if (p) {
                Frame.d(this.i, a, d.i, e.i, this.l);
            }
            else {
                Frame.a(this.i, a, d.i, e.i);
            }
            if (q) {
                Frame.e(this.h, a, d.h, e.h, this.j);
                Frame.e(this.g, a, d.g, e.g, this.j);
            }
            else {
                Frame.b(this.h, a, d.h, e.h);
                Frame.b(this.g, a, d.g, e.g);
            }
            var aq = d.aa;
            var ar = e.aa;
            if (i2.Rect.l_op_Equality(aq, null)) {
                aq = this.z;
            }
            if (i2.Rect.l_op_Equality(ar, null)) {
                ar = this.z;
            }
            var as = aq.left + (ar.left - aq.left) * a;
            var at = aq.top + (ar.top - aq.top) * a;
            var au = Math.max(0, aq.width + (ar.width - aq.width) * a);
            var av = Math.max(0, aq.height + (ar.height - aq.height) * a);
            this.aa = new i2.Rect(0, as, at, au, av);
        };
        CategoryFrame.prototype.x = function (a, b, c, d, e) {
            if (d.count == 0) {
                for (var f = 0; f < c.count; f++) {
                    d.add(c._inner[f]);
                }
            }
            else {
                Frame.b(a, b, c, d);
            }
            if (a.count < e) {
                var g = a.count;
                for (var h = 0; h < e - g; h++) {
                    a.add(1);
                }
            }
        };
        CategoryFrame.prototype.v = function () {
            this.o.clear();
            this.q.clear();
            this.n.clear();
            this.l.clear();
            this.j.clear();
        };
        CategoryFrame.prototype.u = function () {
            this.w();
            this.v();
            this.aa = this.z;
        };
        CategoryFrame.prototype.y = function () {
            this.u();
            this.f.clear();
            this.i.clear();
            this.k.clear();
            this.m.clear();
            this.p.clear();
        };
        CategoryFrame.prototype.w = function () {
            CategoryFrame.r++;
            if (CategoryFrame.r >= (0x7FFFFFFF - 1)) {
                CategoryFrame.r = 0;
            }
            this.t = CategoryFrame.r;
        };
        CategoryFrame.$t = i2.markType(CategoryFrame, 'CategoryFrame', Frame.$);
        CategoryFrame.r = 0;
        return CategoryFrame;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PreparationParams = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PreparationParams, _super);
        function PreparationParams() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.i = 0;
            _this.j = 0;
            _this.h = 0;
            _this.g = 0;
            _this.m = null;
            _this.l = null;
            _this.k = null;
            _this.b = null;
            _this.d = null;
            _this.c = null;
            _this.a = null;
            _this.e = false;
            _this.f = false;
            return _this;
        }
        PreparationParams.$t = i2.markType(PreparationParams, 'PreparationParams');
        return PreparationParams;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IDateTimeAxis_$type = new i2.Type(null, 'IDateTimeAxis');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHasTrendline_$type = new i2.Type(null, 'IHasTrendline');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHasCategoryTrendline_$type = new i2.Type(null, 'IHasCategoryTrendline', null, [IHasTrendline_$type]);
    /**
     * @hidden
     */
    var IPreparesCategoryTrendline_$type = new i2.Type(null, 'IPreparesCategoryTrendline');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHasSingleValueCategory_$type = new i2.Type(null, 'IHasSingleValueCategory');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultCategoryTrendlinePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultCategoryTrendlinePreparer, _super);
        function DefaultCategoryTrendlinePreparer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DefaultCategoryTrendlinePreparer.prototype.prepareLine = function (a, b, c, d) {
        };
        DefaultCategoryTrendlinePreparer.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
        };
        DefaultCategoryTrendlinePreparer.$t = i2.markType(DefaultCategoryTrendlinePreparer, 'DefaultCategoryTrendlinePreparer', i2.Base.$, [IPreparesCategoryTrendline_$type]);
        return DefaultCategoryTrendlinePreparer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultCategoryTrendlineHost = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultCategoryTrendlineHost, _super);
        function DefaultCategoryTrendlineHost() {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = new DefaultCategoryTrendlinePreparer();
            return _this;
        }
        Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "trendlinePreparer", {
            get: function () {
                return this.a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "trendLineType", {
            get: function () {
                return 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "trendLinePeriod", {
            get: function () {
                return 1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "isVertical", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        DefaultCategoryTrendlineHost.$t = i2.markType(DefaultCategoryTrendlineHost, 'DefaultCategoryTrendlineHost', i2.Base.$, [IHasCategoryTrendline_$type]);
        return DefaultCategoryTrendlineHost;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultSingleValueProvider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultSingleValueProvider, _super);
        function DefaultSingleValueProvider() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(DefaultSingleValueProvider.prototype, "valueColumn", {
            get: function () {
                return new i2.FastItemColumn(new i2.FastItemsSource(), null, null, false);
            },
            enumerable: false,
            configurable: true
        });
        DefaultSingleValueProvider.$t = i2.markType(DefaultSingleValueProvider, 'DefaultSingleValueProvider', i2.Base.$, [IHasSingleValueCategory_$type]);
        return DefaultSingleValueProvider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ValuesHolder = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ValuesHolder, _super);
        function ValuesHolder() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = 0;
            _this.b = 0;
            _this.c = 0;
            _this.d = 0;
            return _this;
        }
        ValuesHolder.$t = i2.markType(ValuesHolder, 'ValuesHolder');
        return ValuesHolder;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SingleValuesHolder = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SingleValuesHolder, _super);
        function SingleValuesHolder() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            return _this;
        }
        SingleValuesHolder.prototype.get_e = function () {
            if (this.f != null) {
                return this.f.count;
            }
            return 0;
        };
        Object.defineProperty(SingleValuesHolder.prototype, "e", {
            get: function () {
                return this.get_e();
            },
            enumerable: false,
            configurable: true
        });
        SingleValuesHolder.$t = i2.markType(SingleValuesHolder, 'SingleValuesHolder', ValuesHolder.$);
        return SingleValuesHolder;
    }(ValuesHolder));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ICategorySeriesInteractionManager_$type = new i2.Type(null, 'ICategorySeriesInteractionManager');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available transition effects that can applied to initial rendering of a series
     */
    var CategoryTransitionInMode = /*@__PURE__*/ (function (CategoryTransitionInMode) {
        /**
         * Series transitions in an automatically chosen based on type of series and its orientation
         */
        CategoryTransitionInMode[CategoryTransitionInMode["Auto"] = 0] = "Auto";
        /**
         * Series transitions in from the reference value of the value axis.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["FromZero"] = 1] = "FromZero";
        /**
         * Series sweeps in from the left
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromLeft"] = 2] = "SweepFromLeft";
        /**
         * Series sweeps in from the right
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromRight"] = 3] = "SweepFromRight";
        /**
         * Series sweeps in from the top.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromTop"] = 4] = "SweepFromTop";
        /**
         * Series sweeps in from the bottom.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromBottom"] = 5] = "SweepFromBottom";
        /**
         * Series sweeps in from the center.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCenter"] = 6] = "SweepFromCenter";
        /**
         * Series accordions in from the left.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromLeft"] = 7] = "AccordionFromLeft";
        /**
         * Series accordions in from the right.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromRight"] = 8] = "AccordionFromRight";
        /**
         * Series accordions in from the top.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromTop"] = 9] = "AccordionFromTop";
        /**
         * Series accordions in from the bottom.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromBottom"] = 10] = "AccordionFromBottom";
        /**
         * Series expands from the value midpoints.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["Expand"] = 11] = "Expand";
        /**
         * Series sweeps in from the category axis minimum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCategoryAxisMinimum"] = 12] = "SweepFromCategoryAxisMinimum";
        /**
         * Series sweeps in from the category axis maximum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCategoryAxisMaximum"] = 13] = "SweepFromCategoryAxisMaximum";
        /**
         * Series sweeps in from the value axis minimum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromValueAxisMinimum"] = 14] = "SweepFromValueAxisMinimum";
        /**
         * Series sweeps in from the value axis maximum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["SweepFromValueAxisMaximum"] = 15] = "SweepFromValueAxisMaximum";
        /**
         * Series accordions in from the category axis minimum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromCategoryAxisMinimum"] = 16] = "AccordionFromCategoryAxisMinimum";
        /**
         * Series accordions in from the category axis maximum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromCategoryAxisMaximum"] = 17] = "AccordionFromCategoryAxisMaximum";
        /**
         * Series accordions in from the value axis minimum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromValueAxisMinimum"] = 18] = "AccordionFromValueAxisMinimum";
        /**
         * Series accordions in from the value axis maximum.
         */
        CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromValueAxisMaximum"] = 19] = "AccordionFromValueAxisMaximum";
        return CategoryTransitionInMode;
    })({});
    /**
     * @hidden
     */
    var CategoryTransitionInMode_$type = i2.markEnum('CategoryTransitionInMode', 'Auto,0|FromZero,1|SweepFromLeft,2|SweepFromRight,3|SweepFromTop,4|SweepFromBottom,5|SweepFromCenter,6|AccordionFromLeft,7|AccordionFromRight,8|AccordionFromTop,9|AccordionFromBottom,10|Expand,11|SweepFromCategoryAxisMinimum,12|SweepFromCategoryAxisMaximum,13|SweepFromValueAxisMinimum,14|SweepFromValueAxisMaximum,15|AccordionFromCategoryAxisMinimum,16|AccordionFromCategoryAxisMaximum,17|AccordionFromValueAxisMinimum,18|AccordionFromValueAxisMaximum,19');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryTransitionSourceFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryTransitionSourceFramePreparer, _super);
        function CategoryTransitionSourceFramePreparer() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = new i2.Random(0);
            return _this;
        }
        CategoryTransitionSourceFramePreparer.prototype.p = function (a, b, c, d, e, f, g, h, i, j, k) {
            a.aa = new i2.Rect(0, 0, 0, 1, 1);
            a.f.clear();
            a.k.clear();
            a.m.clear();
            a.p.clear();
            a.i.clear();
            a.h.clear();
            a.g.clear();
            var l = false;
            var m = false;
            if (e != null) {
                l = e.cc;
            }
            if (d != null) {
                m = d.cc;
            }
            var n = f;
            if (n == 0) {
                n = g;
            }
            switch (n) {
                case 1:
                    var o = j();
                    this.t(a, b, o, c);
                    break;
                case 7:
                    this.r(a, b, false, c, k);
                    break;
                case 9:
                    this.s(a, b, true, c, k);
                    break;
                case 10:
                    this.s(a, b, false, c, k);
                    break;
                case 8:
                    this.r(a, b, true, c, k);
                    break;
                case 2:
                    this.u(a, b, false);
                    break;
                case 3:
                    this.u(a, b, true);
                    break;
                case 4:
                    this.v(a, b, true);
                    break;
                case 5:
                    this.v(a, b, false);
                    break;
                case 6:
                    this.j(a, b);
                    a.aa = new i2.Rect(0, 0.5, 0.5, 0, 0);
                    break;
                case 16:
                    if (c) {
                        this.s(a, b, l, c, k);
                    }
                    else {
                        this.r(a, b, m, c, k);
                    }
                    break;
                case 17:
                    if (c) {
                        this.s(a, b, !l, c, k);
                    }
                    else {
                        this.r(a, b, !m, c, k);
                    }
                    break;
                case 18:
                    if (c) {
                        this.r(a, b, m, c, k);
                    }
                    else {
                        this.s(a, b, l, c, k);
                    }
                    break;
                case 19:
                    if (c) {
                        this.r(a, b, !m, c, k);
                    }
                    else {
                        this.s(a, b, !l, c, k);
                    }
                    break;
                case 12:
                    if (c) {
                        this.v(a, b, l);
                    }
                    else {
                        this.u(a, b, m);
                    }
                    break;
                case 13:
                    if (c) {
                        this.v(a, b, !l);
                    }
                    else {
                        this.u(a, b, !m);
                    }
                    break;
                case 14:
                    if (c) {
                        this.u(a, b, m);
                    }
                    else {
                        this.v(a, b, l);
                    }
                    break;
                case 15:
                    if (c) {
                        this.u(a, b, !m);
                    }
                    else {
                        this.v(a, b, !l);
                    }
                    break;
                case 11:
                    this.q(a, b);
                    break;
            }
            if (h == 0) {
                h = i;
            }
            a.v();
            b.v();
            switch (h) {
                case 3:
                    this.b(a.f.count, n, a.o, b.o, d, e, c, k);
                    this.b(a.m.count, n, a.n, b.n, d, e, c, k);
                    this.b(a.p.count, n, a.q, b.q, d, e, c, k);
                    this.b(a.i.count, n, a.l, b.l, d, e, c, k);
                    this.b(a.h.count, n, a.j, b.j, d, e, c, k);
                    break;
                case 2:
                    var p = j();
                    this.d(a.f.count, p, n, a.f, b.f, a.o, b.o, d, e, c, k);
                    this.f(a.m.count, p, n, a.m, b.m, a.n, b.n, d, e, c, k);
                    this.f(a.p.count, p, n, a.p, b.p, a.q, b.q, d, e, c, k);
                    this.f(a.i.count, p, n, a.i, b.i, a.l, b.l, d, e, c, k);
                    this.e(a.h.count, p, n, a.h, b.h, a.j, b.j, d, e, c, k);
                    break;
                case 4:
                    this.c(a.f.count, n, a.o, b.o);
                    this.c(a.m.count, n, a.n, b.n);
                    this.c(a.p.count, n, a.q, b.q);
                    this.c(a.i.count, n, a.l, b.l);
                    this.c(a.h.count, n, a.j, b.j);
                    break;
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.c = function (a, b, c, d) {
            if (a == 0) {
                return;
            }
            for (var e = 0; e < a; e++) {
                c.add(1 + this.a.nextDouble());
                d.add(1 + this.a.nextDouble());
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.d = function (a, b, c, d, e, f, g, h, i, j, k) {
            if (a == 0) {
                return;
            }
            var l = false;
            var m = i;
            if (j) {
                m = h;
            }
            if (m != null) {
                l = m.cc;
            }
            var n = k.bottom;
            var o = k.bottom;
            var p = k.top;
            if (j) {
                o = k.right;
                p = k.left;
            }
            if (l) {
                o = k.top;
                p = k.bottom;
                if (j) {
                    o = k.left;
                    p = k.right;
                }
            }
            b = Math.max(b, Math.min(p, o));
            b = Math.min(b, Math.max(p, o));
            n = 0;
            var q;
            for (var r = 0; r < a; r++) {
                q = e._inner[r];
                for (var s = 1; s < q.length; s++) {
                    if (i2.isNaN_(q[s]) || i2.isInfinity(q[s])) {
                        continue;
                    }
                    n = Math.max(n, Math.abs(b - q[s]));
                }
            }
            var t;
            var u;
            var v;
            for (var w = 0; w < a; w++) {
                q = e._inner[w];
                t = Math.abs(q[1] - b);
                u = Math.abs(q[1] - b);
                for (var x = 1; x < q.length; x++) {
                    if (i2.isNaN_(q[x]) || i2.isInfinity(q[x])) {
                        continue;
                    }
                    t = Math.max(Math.abs(q[x] - b), t);
                    u = Math.min(Math.abs(q[x] - b), u);
                }
                var y = (t + u) / 2;
                if (i2.isNaN_(y) || n == 0) {
                    v = 1;
                }
                else {
                    v = y / n;
                }
                f.add(2 - v);
                g.add(2 - v);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.f = function (a, b, c, d, e, f, g, h, i, j, k) {
            if (a == 0) {
                return;
            }
            var l = false;
            var m = i;
            if (j) {
                m = h;
            }
            if (m != null) {
                l = m.cc;
            }
            var n = k.bottom;
            var o = k.bottom;
            var p = k.top;
            if (j) {
                o = k.right;
                p = k.left;
            }
            if (l) {
                o = k.top;
                p = k.bottom;
                if (j) {
                    o = k.left;
                    p = k.right;
                }
            }
            b = Math.max(b, Math.min(p, o));
            b = Math.min(b, Math.max(p, o));
            n = 0;
            var q;
            for (var r = 0; r < a; r++) {
                q = e._inner[r];
                if (j) {
                    if (i2.isNaN_(q.x) || i2.isInfinity(q.x)) {
                        continue;
                    }
                    n = Math.max(n, Math.abs(q.x - b));
                }
                else {
                    if (i2.isNaN_(q.y) || i2.isInfinity(q.y)) {
                        continue;
                    }
                    n = Math.max(n, Math.abs(q.y - b));
                }
            }
            var s;
            for (var t = 0; t < a; t++) {
                q = e._inner[t];
                var u = void 0;
                if (j) {
                    u = q.x;
                }
                else {
                    u = q.y;
                }
                if (i2.isNaN_(u) || i2.isInfinity(u) || n == 0) {
                    s = 1;
                }
                else {
                    s = Math.abs(u - b) / n;
                }
                f.add(2 - s);
                g.add(2 - s);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.e = function (a, b, c, d, e, f, g, h, i, j, k) {
            if (a == 0) {
                return;
            }
            var l = false;
            var m = i;
            if (j) {
                m = h;
            }
            if (m != null) {
                l = m.cc;
            }
            var n = k.bottom;
            var o = k.bottom;
            var p = k.top;
            if (j) {
                o = k.right;
                p = k.left;
            }
            if (l) {
                o = k.top;
                p = k.bottom;
                if (j) {
                    o = k.left;
                    p = k.right;
                }
            }
            b = Math.max(b, Math.min(p, o));
            b = Math.min(b, Math.max(p, o));
            n = 0;
            var q;
            for (var r = 0; r < a; r++) {
                q = e._inner[r];
                if (i2.isNaN_(q) || i2.isInfinity(q)) {
                    continue;
                }
                n = Math.max(n, Math.abs(q - b));
            }
            var s;
            for (var t = 0; t < a; t++) {
                q = e._inner[t];
                var u = void 0;
                u = q;
                if (n == 0 || i2.isNaN_(u) || i2.isInfinity(u)) {
                    s = 1;
                }
                else {
                    s = Math.abs(u - b) / n;
                }
                f.add(2 - s);
                g.add(2 - s);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.b = function (a, b, c, d, e, f, g, h) {
            if (a == 0) {
                return;
            }
            var i = e;
            if (g) {
                i = f;
            }
            var j = false;
            if (i != null) {
                j = i.cc;
            }
            var k;
            for (var l = 0; l < a; l++) {
                if (a == 1) {
                    k = 1;
                }
                else {
                    k = l / (a - 1);
                }
                k = 1 - k;
                c.add(1 + k);
                d.add(1 + k);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.q = function (a, b) {
            a.f.clear();
            a.k.clear();
            a.m.clear();
            a.p.clear();
            a.i.clear();
            a.h.clear();
            a.g.clear();
            this.g(a.f, b.f);
            this.h(a.k, b.k);
            this.k(a.m, b.m);
            this.k(a.p, b.p);
            this.k(a.i, b.i);
            this.h(a.h, b.h);
            this.h(a.g, b.g);
            var c = a.f.count;
            var d = a.f;
            var e;
            var f;
            var g;
            var h;
            for (var i = 0; i < c; i++) {
                e = d._inner[i];
                f = e[1];
                g = e[1];
                for (var j = 2; j < e.length; j++) {
                    f = Math.min(f, e[j]);
                    g = Math.max(g, e[j]);
                }
                h = (f + g) / 2;
                for (var k = 1; k < e.length; k++) {
                    e[k] = h;
                }
            }
            var l = a.h.count;
            var m = a.h;
            var n = a.g;
            for (var o = 0; o < l; o++) {
                m._inner[o] = 0;
                n._inner[o] = 0;
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.u = function (a, b, c) {
            if (c) {
                this.j(a, b);
                a.aa = new i2.Rect(0, 1, 0, 0, 1);
            }
            else {
                this.j(a, b);
                a.aa = new i2.Rect(0, 0, 0, 0, 1);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.v = function (a, b, c) {
            if (c) {
                this.j(a, b);
                a.aa = new i2.Rect(0, 0, 0, 1, 0);
            }
            else {
                this.j(a, b);
                a.aa = new i2.Rect(0, 0, 1, 1, 0);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.j = function (a, b) {
            a.f.clear();
            a.k.clear();
            a.m.clear();
            a.p.clear();
            a.i.clear();
            a.h.clear();
            a.g.clear();
            this.g(a.f, b.f);
            this.h(a.k, b.k);
            this.k(a.m, b.m);
            this.k(a.p, b.p);
            this.k(a.i, b.i);
            this.h(a.h, b.h);
            this.h(a.g, b.g);
        };
        CategoryTransitionSourceFramePreparer.prototype.o = function (a, b, c, d, e) {
            var f = b.count;
            var g;
            var h;
            for (var i = 0; i < f; i++) {
                g = b._inner[i];
                if (e) {
                    if (c) {
                        h = { $type: i2.Point_$type, x: d, y: g.y };
                    }
                    else {
                        h = { $type: i2.Point_$type, x: g.x, y: d };
                    }
                }
                else {
                    if (c) {
                        h = { $type: i2.Point_$type, x: g.x, y: d };
                    }
                    else {
                        h = { $type: i2.Point_$type, x: d, y: g.y };
                    }
                }
                a.add(h);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.k = function (a, b) {
            var c = b.count;
            var d;
            var e;
            for (var f = 0; f < c; f++) {
                d = b._inner[f];
                e = { $type: i2.Point_$type, x: d.x, y: d.y };
                a.add(e);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.g = function (a, b) {
            var c = b.count;
            var d = b;
            var e;
            var f;
            var g = a;
            for (var h = 0; h < c; h++) {
                f = d._inner[h];
                e = new Array(f.length);
                for (var i = 0; i < e.length; i++) {
                    e[i] = f[i];
                }
                g.add(e);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.l = function (a, b, c, d, e) {
            var f = b.count;
            var g = b;
            var h;
            var i;
            var j = a;
            for (var k = 0; k < f; k++) {
                i = g._inner[k];
                h = new Array(i.length);
                if (e) {
                    h[0] = i[0];
                    for (var l = 1; l < h.length; l++) {
                        h[l] = d;
                    }
                }
                else {
                    h[0] = d;
                    for (var m = 1; m < h.length; m++) {
                        h[m] = i[m];
                    }
                }
                j.add(h);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.n = function (a, b) {
            var c = b.count;
            var d;
            for (var e = 0; e < c; e++) {
                d = b._inner[e];
                a.add(d);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.i = function (a, b) {
            var c = b.count;
            var d;
            for (var e = 0; e < c; e++) {
                d = b._inner[e];
                a.add(d);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.h = function (a, b) {
            var c = b.count;
            var d;
            for (var e = 0; e < c; e++) {
                d = b._inner[e];
                a.add(d);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.m = function (a, b, c, d, e) {
            var f = b.count;
            var g;
            for (var h = 0; h < f; h++) {
                g = b._inner[h];
                a.add(g);
            }
        };
        CategoryTransitionSourceFramePreparer.prototype.r = function (a, b, c, d, e) {
            var f = e.right;
            if (!c) {
                f = e.left;
            }
            var g = false;
            if (d) {
                g = true;
            }
            this.l(a.f, b.f, d, f, g);
            this.m(a.k, b.k, d, f, g);
            this.o(a.m, b.m, d, f, g);
            this.o(a.p, b.p, d, f, g);
            this.o(a.i, b.i, d, f, g);
            this.m(a.h, b.h, d, f, g);
            this.m(a.g, b.g, d, f, g);
        };
        CategoryTransitionSourceFramePreparer.prototype.s = function (a, b, c, d, e) {
            var f = e.bottom;
            if (c) {
                f = e.top;
            }
            var g = true;
            if (d) {
                g = false;
            }
            this.l(a.f, b.f, d, f, g);
            this.m(a.k, b.k, d, f, g);
            this.o(a.m, b.m, d, f, g);
            this.o(a.p, b.p, d, f, g);
            this.o(a.i, b.i, d, f, g);
            this.m(a.h, b.h, d, f, g);
            this.m(a.g, b.g, d, f, g);
        };
        CategoryTransitionSourceFramePreparer.prototype.t = function (a, b, c, d) {
            this.l(a.f, b.f, d, c, true);
            this.m(a.k, b.k, d, c, true);
            this.o(a.m, b.m, d, c, true);
            this.o(a.p, b.p, d, c, true);
            this.o(a.i, b.i, d, c, true);
            this.m(a.h, b.h, d, c, true);
            this.m(a.g, b.g, d, c, true);
        };
        CategoryTransitionSourceFramePreparer.$t = i2.markType(CategoryTransitionSourceFramePreparer, 'CategoryTransitionSourceFramePreparer');
        return CategoryTransitionSourceFramePreparer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesRenderManager, _super);
        function SeriesRenderManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.ag = null;
            _this.ah = null;
            _this.m = 0;
            _this.am = null;
            _this.ao = 0;
            _this.k = 0;
            _this.l = 0;
            _this.j = 0;
            _this.i = 0;
            _this.aq = 0;
            _this.ap = 0;
            _this.ak = null;
            _this.al = null;
            _this.t = 0;
            _this.an = null;
            _this.ar = 0;
            _this.r = 0;
            _this.s = 0;
            _this.q = 0;
            _this.p = 0;
            _this.at = 0;
            _this.as = 0;
            _this.ai = null;
            _this.aj = null;
            _this.n = 0;
            _this.o = 0;
            _this.f = false;
            _this.e = false;
            _this.ae = null;
            _this.af = null;
            _this.g = 0;
            _this.h = 0;
            _this.b = null;
            _this.d = null;
            return _this;
        }
        SeriesRenderManager.prototype.w = function (a, b, c) {
            this.e = false;
            this.ai = a.om();
            this.aj = a.on();
            this.n = 1;
            this.o = a.ft();
            this.ae = this.ai;
            this.af = this.aj;
            this.g = this.n;
            this.h = this.o;
            var d = b;
            this.d = null;
            if (d) {
                this.d = this.c();
                this.d.j = 0;
                this.d.l = 0;
                this.d.m = 0;
                if (a.ca != null && a.bj != 1) {
                    this.d.j = a.ca.a3.maxMarkerHighlightingProgress;
                    this.d.l = a.ca.a3.sumMarkerHighlightingProgress;
                    this.d.m = a.ca.a3.totalHighlightingProgress;
                }
                this.d.a = c;
            }
        };
        SeriesRenderManager.prototype.c = function () {
            return null;
        };
        SeriesRenderManager.prototype.x = function (a, b, c) {
            this.f = false;
            this.ak = a.of;
            this.al = a.oi;
            this.t = a.fl;
            this.an = a.os;
            this.ar = a.ot;
            this.r = 0;
            this.s = 0;
            this.q = 1;
            this.p = a.gf;
            this.at = a.ov;
            this.as = a.ou;
            this.ag = this.ak;
            this.ah = this.al;
            this.m = this.t;
            this.am = this.an;
            this.ao = this.ar;
            this.k = this.r;
            this.l = this.s;
            this.j = this.q;
            this.i = this.p;
            this.aq = this.at;
            this.ap = this.as;
            var d = b;
            this.b = null;
            if (d) {
                this.b = this.a();
                this.b.j = 0;
                this.b.l = 0;
                this.b.m = 0;
                if (a.ca != null && a.bj != 1) {
                    this.b.j = a.ca.a3.maxHighlightingProgress;
                    this.b.l = a.ca.a3.sumHighlightingProgress;
                    this.b.m = a.ca.a3.totalHighlightingProgress;
                }
                this.b.a = c;
            }
        };
        SeriesRenderManager.prototype.a = function () {
            return null;
        };
        SeriesRenderManager.prototype.ad = function (a, b, c, d, e) {
            var f = this.ag;
            if (e) {
                f = this.ah;
            }
            if (c) {
                a._fill = f;
            }
            else {
                if (b) {
                    a._stroke = f;
                }
                else {
                    a._fill = f;
                    a._stroke = this.ah;
                }
                a.ac = this.m;
                a.ai = this.am;
                a.ad = this.ao;
                if (d) {
                }
            }
            a._opacity = this.j;
        };
        SeriesRenderManager.prototype.ac = function (a, b) {
            a._opacity = this.g;
            b.itemBrush = this.ae;
            b.thickness = this.h;
            b.actualItemBrush = b.itemBrush;
            b.outline = this.af;
        };
        SeriesRenderManager.prototype.u = function (a, b, c, d, e, f) {
            if (a.bj == 1) {
                return;
            }
            this.j = a.a4.a$i(a, b, this.j, c, d, e, f);
            this.ag = a.a4.a$ak(a, b, this.ag);
            this.ah = a.a4.a$ak(a, b, this.ah);
        };
        SeriesRenderManager.prototype.v = function (a, b, c, d, e) {
            if (a.bj == 1) {
                return;
            }
            this.g = a.a4.a$i(a, b, this.g, c, d, e, false);
            this.ae = a.a4.a$ak(a, b, this.ae);
            this.af = a.a4.a$ak(a, b, this.af);
        };
        SeriesRenderManager.prototype.ab = function (a) {
            this.ag = this.ak;
            this.ah = this.al;
            this.m = this.t;
            this.am = this.an;
            this.ao = this.ar;
            this.k = this.r;
            this.l = this.s;
            this.j = this.q;
            var b = this.b;
            b.p = this.ag;
            b.q = this.ah;
            b.t = this.m;
            b.u = this.am;
            b.v = this.ao;
            b.r = this.k;
            b.s = this.l;
            b.k = this.j;
            b.e = this.f;
            b.i = a;
            b.d = false;
        };
        SeriesRenderManager.prototype.z = function (a, b, c, d, e) {
            var f = this.b;
            this.ag = f.p;
            this.ah = f.q;
            this.m = f.t;
            this.am = f.u;
            this.ao = f.v;
            this.k = f.r;
            this.l = f.s;
            this.j = f.k;
            if (d && !f.d && !c) {
                this.u(a, b, f.m, f.m, f.i, e);
            }
        };
        SeriesRenderManager.prototype.aa = function (a) {
            this.ae = this.ai;
            this.af = this.aj;
            this.g = this.n;
            var b = this.d;
            b.p = this.ae;
            b.q = this.af;
            b.k = this.g;
            b.e = this.e;
            b.i = a;
            b.d = false;
        };
        SeriesRenderManager.prototype.y = function (a, b, c, d, e, f) {
            var g = this.d;
            this.ae = g.p;
            this.af = g.q;
            this.g = g.k;
            if (d && !g.d && !c) {
                this.v(a, b, e, f, g.i);
            }
        };
        SeriesRenderManager.$t = i2.markType(SeriesRenderManager, 'SeriesRenderManager');
        return SeriesRenderManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningSeriesStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningSeriesStyleEventArgsBase, _super);
        function AssigningSeriesStyleEventArgsBase() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.o = 0;
            _this.n = 0;
            _this.h = new Date();
            _this.g = new Date();
            _this.a = null;
            _this.p = null;
            _this.q = null;
            _this.k = 0;
            _this.i = 0;
            _this.b = null;
            _this.j = 0;
            _this.l = 0;
            _this.m = 0;
            _this.d = false;
            _this.c = false;
            _this.e = false;
            _this.f = false;
            return _this;
        }
        AssigningSeriesStyleEventArgsBase.$t = i2.markType(AssigningSeriesStyleEventArgsBase, 'AssigningSeriesStyleEventArgsBase');
        return AssigningSeriesStyleEventArgsBase;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningCategoryStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningCategoryStyleEventArgsBase, _super);
        function AssigningCategoryStyleEventArgsBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningCategoryStyleEventArgsBase.$t = i2.markType(AssigningCategoryStyleEventArgsBase, 'AssigningCategoryStyleEventArgsBase', AssigningSeriesStyleEventArgsBase.$);
        return AssigningCategoryStyleEventArgsBase;
    }(AssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningCategoryMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningCategoryMarkerStyleEventArgs, _super);
        function AssigningCategoryMarkerStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningCategoryMarkerStyleEventArgs.$t = i2.markType(AssigningCategoryMarkerStyleEventArgs, 'AssigningCategoryMarkerStyleEventArgs', AssigningCategoryStyleEventArgsBase.$);
        return AssigningCategoryMarkerStyleEventArgs;
    }(AssigningCategoryStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningSeriesShapeStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningSeriesShapeStyleEventArgsBase, _super);
        function AssigningSeriesShapeStyleEventArgsBase() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.t = 0;
            _this.u = null;
            _this.v = 0;
            _this.r = 0;
            _this.s = 0;
            return _this;
        }
        AssigningSeriesShapeStyleEventArgsBase.$t = i2.markType(AssigningSeriesShapeStyleEventArgsBase, 'AssigningSeriesShapeStyleEventArgsBase', AssigningSeriesStyleEventArgsBase.$);
        return AssigningSeriesShapeStyleEventArgsBase;
    }(AssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningCategoryStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningCategoryStyleEventArgs, _super);
        function AssigningCategoryStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningCategoryStyleEventArgs.$t = i2.markType(AssigningCategoryStyleEventArgs, 'AssigningCategoryStyleEventArgs', AssigningSeriesShapeStyleEventArgsBase.$);
        return AssigningCategoryStyleEventArgs;
    }(AssigningSeriesShapeStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategorySeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategorySeriesRenderManager, _super);
        function CategorySeriesRenderManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.ax = 0;
            _this.ay = 0;
            _this.av = null;
            _this.aw = null;
            return _this;
        }
        CategorySeriesRenderManager.prototype.c = function () {
            this.av = new AssigningCategoryMarkerStyleEventArgs();
            return this.av;
        };
        CategorySeriesRenderManager.prototype.a = function () {
            this.aw = new AssigningCategoryStyleEventArgs();
            return this.aw;
        };
        CategorySeriesRenderManager.prototype.az = function (a, b, c, d, e) {
            this.ax = d;
            this.ay = e;
            this.w(a, b, c);
        };
        CategorySeriesRenderManager.prototype.a0 = function (a, b, c, d, e) {
            this.ax = d;
            this.ay = e;
            this.x(a, b, c);
        };
        CategorySeriesRenderManager.prototype.au = function (a, b) {
            var c = this.ax;
            var d = Math.min(b * c, a - 1);
            var e = Math.min(d + c - 1, a - 1);
            var f = new Array(2);
            f[0] = Math.min(d + this.ay * c, a - 1);
            f[1] = Math.min(e + this.ay * c, a - 1);
            return f;
        };
        CategorySeriesRenderManager.prototype.a1 = function (a, b, c, d, e, f, g, h, i) {
            if (d == -1) {
                if (b) {
                    a.c = true;
                    a.h = f.fl();
                    a.g = f.fk();
                }
                else {
                    a.c = false;
                    a.o = 0;
                    a.n = e - 1;
                }
            }
            else {
                if (b) {
                    var longStart_ = i2.truncate(f.eb(c._inner[d][0], g));
                    var longEnd_ = longStart_;
                    if (d + 1 < c.count) {
                        longEnd_ = i2.truncate(f.eb(c._inner[d + 1][0], g));
                    }
                    a.c = true;
                    a.h = (new Date(longStart_));
                    a.g = (new Date(longEnd_));
                    if (f.cc) {
                        var j = a.g;
                        a.g = a.h;
                        a.h = j;
                    }
                    if (i) {
                        a.o = d;
                        a.n = d;
                    }
                    else {
                        var k = this.au(e, d);
                        a.o = k[0];
                        a.n = k[1];
                    }
                }
                else {
                    if (i) {
                        a.o = d;
                        a.n = d;
                    }
                    else {
                        var l = this.au(e, d);
                        a.c = false;
                        a.o = l[0];
                        a.n = l[1];
                    }
                }
            }
        };
        CategorySeriesRenderManager.$t = i2.markType(CategorySeriesRenderManager, 'CategorySeriesRenderManager', SeriesRenderManager.$);
        return CategorySeriesRenderManager;
    }(SeriesRenderManager));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryBucketCalculator, _super);
        function CategoryBucketCalculator(a) {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.e = 0;
            _this.f = 0;
            _this.d = 0;
            if (a == null) {
                throw new i2.ArgumentNullException(0, "view");
            }
            _this.c = a;
            _this.e = -1;
            _this.d = 0;
            return _this;
        }
        CategoryBucketCalculator.prototype.getBucket = function (a) {
            return null;
        };
        CategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            return this.getBucket(a);
        };
        CategoryBucketCalculator.prototype.getErrorBucket = function (a, b) {
            return NaN;
        };
        CategoryBucketCalculator.prototype.g = function (a) {
            var b = this.c.bv;
            var c = this.c.bu;
            var d = this.c.ct;
            var e = i2.typeCast(CategoryAxisBase.$, d.fetchXAxis());
            var f = d.ch;
            if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
                this.d = 0;
                return;
            }
            var g = d.getEffectiveViewport1(this.c);
            var h = d.o7(this.c);
            var i = i2.typeCast(ISortingAxis_$type, e);
            if (i == null || i.i$b == null) {
                var j = new ScalerParams(0, b, c, e.cc, g);
                var k = Math.floor(e.ec(h.left, j, 0));
                var l = Math.ceil(e.ec(h.right, j, 0));
                if (e.cc) {
                    l = Math.ceil(e.ec(h.left, j, 0));
                    k = Math.floor(e.ec(h.right, j, 0));
                }
                var m = Math.floor((l - k + 1) * a / h.width);
                this.d = i2.truncate(Math.max(1, m));
                this.e = i2.truncate(Math.max(0, Math.floor(k / this.d) - 1));
                this.f = i2.truncate(Math.ceil(l / this.d));
            }
            else {
                this.e = i.i$e(b, c, g, h);
                this.f = i.i$g(b, c, g, h);
                this.d = 1;
            }
        };
        CategoryBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
            a = this.e;
            b = this.f;
            c = this.d;
            d = this.c.ct.gh;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        };
        CategoryBucketCalculator.prototype.cacheValues = function () {
        };
        CategoryBucketCalculator.prototype.unCacheValues = function () {
        };
        CategoryBucketCalculator.$t = i2.markType(CategoryBucketCalculator, 'CategoryBucketCalculator', i2.Base.$, [IBucketizer_$type]);
        return CategoryBucketCalculator;
    }(i2.Base));
    /**
     * @hidden
     */
    var CategoryFramePreparerBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryFramePreparerBase, _super);
        function CategoryFramePreparerBase(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = [c, i2.typeCast(ISupportsMarkers_$type, c), i2.typeCast(IProvidesViewport_$type, c), i2.typeCast(ISupportsErrorBars_$type, c), i2.typeCast(IBucketizer_$type, c)];
                        {
                            var f = d[0];
                            var g = d[1];
                            var h = d[2];
                            var i = d[3];
                            var j = d[4];
                            _this = _super.call(this, 1, g, h, i) || this;
                            _this.g = null;
                            _this.h = null;
                            _this.m = false;
                            _this.o = new i2.List$1(i2.Array_$type, 0);
                            _this.p = new i2.List$1(i2.Number_$type, 0);
                            _this.n = new i2.List$1(i2.Number_$type, 0);
                            _this.h = f;
                            _this.g = j;
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        _this = _super.call(this, 1, d, e, f) || this;
                        _this.g = null;
                        _this.h = null;
                        _this.m = false;
                        _this.o = new i2.List$1(i2.Array_$type, 0);
                        _this.p = new i2.List$1(i2.Number_$type, 0);
                        _this.n = new i2.List$1(i2.Number_$type, 0);
                        _this.h = c;
                        _this.g = g;
                    }
                    break;
            }
            return _this;
        }
        CategoryFramePreparerBase.prototype.i = function (a) {
            var b = new PreparationParams();
            b.f = this.h.useHighMarkerFidelity;
            b.b = this.h.scaler;
            b.c = this.h.yScaler;
            b.d = i2.typeCast(ISortingAxis_$type, b.b);
            b.a = i2.typeCast(CategoryFrame.$, a);
            if (b.a == null || b.b == null || b.c == null) {
                return null;
            }
            var c;
            var d;
            var e;
            var f;
            var g = this.g.getBucketInfo(c, d, e, f);
            c = g.p0;
            d = g.p1;
            e = g.p2;
            f = g.p3;
            b.i = c;
            b.j = d;
            b.h = e;
            b.g = f;
            if (b.j < b.i) {
                return null;
            }
            var h;
            var i;
            var j;
            var k = this.a.getViewInfo(i, h);
            i = k.p0;
            h = k.p1;
            j = this.a.getEffectiveViewport();
            b.m = h;
            b.l = i;
            b.k = j;
            if (i2.Rect.l_op_Equality(b.m, i2.Rect.empty) || i2.Rect.l_op_Equality(b.l, i2.Rect.empty)) {
                return null;
            }
            if (this.h != null && (i2.typeCast(Series.$, this.h) !== null && this.h.dn) && this.g != null) {
                b.e = true;
            }
            return b;
        };
        CategoryFramePreparerBase.prototype.r = function (a, b, c, d) {
            return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
        };
        CategoryFramePreparerBase.prototype.s = function (a) {
            return this.r(a.b, a.m, a.l, a.k);
        };
        CategoryFramePreparerBase.prototype.d = function (a, b) {
            var c = this.i(a);
            if (c == null || this.g == null) {
                return;
            }
            c.a.f.clear();
            c.a.k.clear();
            c.a.m.clear();
            c.a.p.clear();
            c.a.i.clear();
            c.a.h.clear();
            c.a.g.clear();
            var d = this.c.shouldDisplayMarkers;
            var e = false;
            var f = this.s(c);
            var g = this.j(c);
            if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
                return;
            }
            if (c.d != null && c.d.i$a) {
                c.d.i$h();
            }
            this.g.cacheValues();
            if (this.m && c.d != null && c.d.i$b.count > 0) {
                var h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
                while ((i2.isNaN_(g.c) || i2.isNaN_(g.d)) && c.i > 0) {
                    c.i = c.i - 1;
                    h = c.d.i$b._inner[c.i];
                    this.z(g, h, true, c.e);
                }
                var i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
                while ((i2.isNaN_(g.c) || i2.isNaN_(g.d)) && c.j < g.e - 1) {
                    c.j = c.j + 1;
                    i = c.d.i$b._inner[c.j];
                    this.z(g, i, true, c.e);
                }
            }
            if (this.m && c.d == null) {
                var j = c.i;
                var k = this.g.getBucket(j);
                while ((i2.isNaN_(k[1]) || i2.isNaN_(k[2])) && c.i > 0) {
                    c.i = c.i - 1;
                    j = c.i;
                    k = this.g.getBucket(j);
                }
                var l = c.j;
                k = this.g.getBucket(l);
                while ((i2.isNaN_(k[1]) || i2.isNaN_(k[2])) && c.j < (i2.intDivide(g.e, c.h))) {
                    c.j = c.j + 1;
                    l = c.j;
                    k = this.g.getBucket(l);
                }
            }
            this.w(c, g, f);
            var m = this.t(c, g, f, d, e);
            this.c.updateMarkerCount(m);
            this.v(i2.typeCast(CategoryFrame.$, a), b);
            this.g.unCacheValues();
            return;
        };
        CategoryFramePreparerBase.prototype.v = function (a, b) {
        };
        Object.defineProperty(CategoryFramePreparerBase.prototype, "q", {
            get: function () {
                return this.o;
            },
            enumerable: false,
            configurable: true
        });
        CategoryFramePreparerBase.prototype.t = function (a, b, c, d, e) {
            var _this = this;
            var f = 0;
            var g = false;
            var h = null;
            var i = false;
            var j = a.d != null;
            var k = a.m;
            var l = a.l;
            var m = i2.typeCast(NumericAxisBase.$, a.c) !== null && a.c.kl;
            var n = a.f;
            var o = this.h.mayContainUnknowns;
            var p = this.o;
            var q = this.n;
            var r = this.p;
            p.clear();
            q.clear();
            r.clear();
            var s = this.g;
            var t = this.h.provideCollisionDetector();
            var u = 0;
            var v = a.k;
            var w = new ScalerParams(0, k, l, a.b.j$a, v);
            var x = ((function () {
                var $ret = new ScalerParams(0, k, l, a.c.j$a, v);
                $ret.b = i2.typeCast(Series.$, _this.h) !== null ? _this.h.f2() : NaN;
                return $ret;
            })());
            if (j) {
                u = a.b.j$c(2, w) - a.b.j$c(1, w);
                i = this.k();
            }
            var y = a.i;
            var z = a.j;
            var aa = a.a.f;
            var ab = i2.typeCast(IDateTimeAxis_$type, a.b);
            if (ab != null) {
                ab.StartTimeCursor();
            }
            var _loop_1 = function (ac) {
                var ad = void 0;
                if (!j) {
                    if (!o) {
                        ad = s.getBucketWithoutUnknowns(ac);
                    }
                    else {
                        ad = s.getBucket(ac);
                    }
                }
                else {
                    ad = ((function () { var ae = _this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
                }
                var ae = !m || (m && ad[1] > 0);
                var af = ad[0];
                if (!j || !i2.isNaN_(ad[0])) {
                    aa.add(ad);
                    if (g && i) {
                        if (h != null) {
                            aa.add(h);
                        }
                    }
                    if (d && ae) {
                        var ag = ac * a.h;
                        var ah = ag;
                        if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                            ag = a.d.i$b._inner[ag];
                        }
                        var ai = new Array(ad.length);
                        ai[0] = ad[0];
                        ai[1] = ad[1];
                        ai[2] = ad[2];
                        if (n && ag < b.e) {
                            ai = new Array(ad.length);
                            ai[0] = af;
                            this_1.z(b, ag, true, a.e);
                            ai[1] = b.c;
                            ai[2] = b.d;
                        }
                        p.add(ai);
                        q.add(a.a.f.count - 1);
                        r.add(ag);
                    }
                }
                out_ac_1 = ac;
            };
            var this_1 = this, out_ac_1;
            for (var ac = y; ac <= z; ++ac) {
                _loop_1(ac);
                ac = out_ac_1;
            }
            if (ab != null) {
                ab.ResetTimeCursor();
            }
            this.y(a, c, j, w, x, e, d);
            if (d) {
                var aj = p.count;
                var ak = void 0;
                for (var al = 0; al < aj; al++) {
                    ak = p._inner[al];
                    if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                        ++f;
                    }
                }
            }
            return f;
        };
        CategoryFramePreparerBase.prototype.k = function () {
            if (i2.typeCast(Series.$, this.h) !== null) {
                return this.h.c8;
            }
            return false;
        };
        CategoryFramePreparerBase.prototype.f = function (a, b, c, d, e, f, g) {
            var h;
            f = null;
            e = false;
            var i = i2.typeCast(CategorySeries.$, this.h);
            var j = a.l;
            var k = a.m;
            var l = a.k;
            var m = new ScalerParams(0, k, j, a.b.j$a, l);
            var n = new ScalerParams(0, k, j, a.c.j$a, l);
            var o = a.e;
            if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            if (i != null && i.ch != null && i.ch.count < a.d.i$b.count) {
                return {
                    ret: [NaN, NaN, NaN],
                    p1: b,
                    p4: e,
                    p5: f
                };
            }
            var p = a.d.i$b._inner[b];
            var q = a.d.i$d(p);
            var r = q;
            this.z(c, p, false, o);
            while (b < a.j) {
                p = a.d.i$b._inner[b + 1];
                r = a.d.i$d(p);
                this.z(c, p, true, o);
                if (r - q >= d || i2.isNaN_(c.c) || i2.isNaN_(c.d)) {
                    if (e) {
                        var s = a.d.i$b._inner[b];
                        this.z(c, s, true, o);
                        f = [a.b.j$b(q, m), c.c, c.d];
                    }
                    break;
                }
                if (!e && this.k()) {
                    var t = a.d.i$b._inner[b];
                    this.z(c, t, true, o);
                    var u = [a.b.j$b(q, m), c.c, c.d];
                    if (!i2.isNaN_(u[0])) {
                        if (!i2.isNaN_(u[1]) && !i2.isNaN_(u[2])) {
                            if (a.d != null) {
                                u[0] = u[0] + g;
                            }
                            a.a.f.add(u);
                            e = true;
                        }
                        else {
                            break;
                        }
                    }
                }
                b++;
                this.u(c, p, o);
            }
            var v = NaN;
            if (!i2.isNaN_(q)) {
                v = a.b.j$b(q, m);
            }
            h = this.e(v, c);
            return {
                ret: h,
                p1: b,
                p4: e,
                p5: f
            };
        };
        CategoryFramePreparerBase.prototype.y = function (a, b, c, d, e, f, g) {
            var h = a.h;
            var i = a.a.f.count;
            var j = a.a.f;
            var k = this.o;
            var l = k.count;
            if (f) {
                var m = a.c.j$b(a.c.k5, e);
                a.c.j$e(a.a.k, 0, a.a.k.count, e);
                var n = a.a.k;
                var o = n.count;
                for (var p = 0; p < n.count; p++) {
                    n._inner[p] = Math.abs(n._inner[p] - m);
                }
            }
        };
        CategoryFramePreparerBase.prototype.w = function (a, b, c) {
        };
        CategoryFramePreparerBase.$t = i2.markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
        return CategoryFramePreparerBase;
    }(FramePreparer));
    /**
     * @hidden
     */
    var CategoryFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryFramePreparer, _super);
        function CategoryFramePreparer(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = [c, i2.typeCast(ISupportsMarkers_$type, c), i2.typeCast(IProvidesViewport_$type, c), i2.typeCast(ISupportsErrorBars_$type, c), i2.typeCast(IBucketizer_$type, c)];
                        {
                            var f = d[0];
                            var g = d[1];
                            var h = d[2];
                            var i = d[3];
                            var j = d[4];
                            _this = _super.call(this, 1, f, g, h, i, j) || this;
                            _this.aa = new DefaultCategoryTrendlineHost();
                            _this.ab = new DefaultSingleValueProvider();
                            _this.ac = null;
                            _this.ad = null;
                            _this.ac = _this.aa;
                            if (i2.typeCast(IHasCategoryTrendline_$type, f) !== null) {
                                _this.ac = i2.typeCast(IHasCategoryTrendline_$type, f);
                            }
                            _this.ad = _this.ab;
                            if (i2.typeCast(IHasSingleValueCategory_$type, f) !== null) {
                                _this.ad = i2.typeCast(IHasSingleValueCategory_$type, f);
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        _this = _super.call(this, 1, c, d, e, f, g) || this;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        _this.ab = new DefaultSingleValueProvider();
                        _this.ac = null;
                        _this.ad = null;
                        _this.ac = _this.aa;
                        if (i2.typeCast(IHasCategoryTrendline_$type, c) !== null) {
                            _this.ac = i2.typeCast(IHasCategoryTrendline_$type, c);
                        }
                        _this.ad = _this.ab;
                        if (i2.typeCast(IHasSingleValueCategory_$type, c) !== null) {
                            _this.ad = i2.typeCast(IHasSingleValueCategory_$type, c);
                        }
                    }
                    break;
            }
            return _this;
        }
        CategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
            var g = b[0];
            var h = b[1];
            var i = new i2.Rect(0, g - 5, h - 5, 11, 11);
            if (!i2.isNaN_(g) && !i2.isNaN_(h) && !i2.isInfinity(g) && !i2.isInfinity(h) && c.tryAdd(i)) {
                a.m.add({ $type: i2.Point_$type, x: g, y: h });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        };
        CategoryFramePreparer.prototype.j = function (a) {
            var b = new SingleValuesHolder();
            var c = this.ad.valueColumn;
            b.f = c;
            return b;
        };
        CategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
            if (d) {
                b[0] = b[0] + c;
            }
            else {
                b[0] = a.b.j$b(b[0], e) + c;
            }
            b[1] = a.c.j$b(b[1], f);
            if (a.h > 1 || d) {
                b[2] = a.c.j$b(b[2], f);
            }
            else {
                b[2] = b[1];
            }
        };
        CategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
            _super.prototype.y.call(this, a, b, c, d, e, f, g);
            var h = a.h;
            var i = a.a.f.count;
            var j = a.a.f;
            var k = this.q;
            var l = k.count;
            var m = new i2.List$1(i2.Number_$type, 0);
            if (!c) {
                m.add(0);
            }
            var n = new i2.List$1(i2.Number_$type, 0);
            n.add(1);
            if (c || h > 1) {
                n.add(2);
            }
            a.b.j$d(j, m, 0, i, d);
            a.c.j$d(j, n, 0, i, e);
            for (var o = 0; o < i; o++) {
                j._inner[o][0] = j._inner[o][0] + b;
            }
            if (h == 1 && !c) {
                for (var p = 0; p < i; p++) {
                    j._inner[p][2] = j._inner[p][1];
                }
            }
            if (g) {
                a.b.j$d(k, m, 0, l, d);
                a.c.j$d(k, n, 0, l, e);
                for (var q = 0; q < l; q++) {
                    k._inner[q][0] = k._inner[q][0] + b;
                }
                if (h == 1 && !c) {
                    for (var r = 0; r < l; r++) {
                        k._inner[r][2] = k._inner[r][1];
                    }
                }
            }
        };
        CategoryFramePreparer.prototype.w = function (a, b, c) {
            if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
                return;
            }
            this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
        };
        CategoryFramePreparer.prototype.z = function (a, b, c, d) {
            var e = a;
            var f = e.f;
            var g = f.item(b);
            var h = g;
            if (d) {
                var i = this.g.getBucket(b);
                g = i[1];
                h = i[1];
            }
            if (c) {
                e.c = g;
                e.d = h;
            }
            else {
                e.a = g;
                e.b = h;
            }
        };
        CategoryFramePreparer.prototype.u = function (a, b, c) {
            var d = a;
            var e = d.f;
            if (b < e.count) {
                var f = void 0;
                if (c) {
                    var g = this.g.getBucket(b);
                    f = g[1];
                }
                else {
                    f = e.item(b);
                }
                d.a = Math.min(d.a, f);
                d.b = Math.max(d.b, f);
            }
        };
        CategoryFramePreparer.prototype.e = function (a, b) {
            var c = b;
            return [a, c.a, c.b];
        };
        CategoryFramePreparer.$t = i2.markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
        return CategoryFramePreparer;
    }(CategoryFramePreparerBase));
    /**
     * @hidden
     */
    var CategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategorySeries, _super);
        function CategorySeries() {
            var _this = _super.call(this) || this;
            _this.q8 = null;
            _this.rl = null;
            _this.rp = false;
            _this.ro = false;
            _this.assigningCategoryStyle = null;
            _this.assigningCategoryMarkerStyle = null;
            _this.rj = null;
            _this.rk = null;
            _this.q5 = new CategoryFrame(3);
            _this.q7 = new CategoryFrame(3);
            _this.q3 = new CategoryFrame(3);
            _this.q6 = new CategoryFrame(3);
            _this.rb = null;
            _this.rf = null;
            _this.rb = new CategorySeriesRenderManager();
            _this.rf = new CategoryTransitionSourceFramePreparer();
            _this.rp = false;
            _this.ro = false;
            _this.ab = CategorySeries.$;
            return _this;
        }
        CategorySeries.prototype.bu = function () {
            var a = new CategorySeriesView(this);
            return a;
        };
        Object.defineProperty(CategorySeries.prototype, "rm", {
            get: function () {
                var _this = this;
                if (this.rl == null) {
                    this.rl = i2.DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, function () { return _this.ck.n; });
                }
                return this.rl;
            },
            enumerable: false,
            configurable: true
        });
        CategorySeries.prototype.cx = function (a, b, c) {
            var _this = this;
            if (!this.hasMarkers) {
                return false;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.fetchXAxis();
            var f = new ScalerParams(1, this.ca.pg, this.pf, e.cc);
            f.c = d;
            var g = this.fetchYAxis();
            var h = new ScalerParams(1, this.ca.pg, this.pf, g.cc);
            h.c = d;
            var i = this.ca.pg;
            var j = this.pf;
            var k = this.currentMode2Index;
            var l = 0;
            if (e.b9 && e.b7) {
                l = e.getSeriesOffset(i, j, d, k, e.categoryMode);
            }
            a.clear();
            this.pq.cf(function (m) {
                if (m._visibility == 0) {
                    var n = new SeriesPointOfInterest();
                    var o = m.n;
                    var p = m.o;
                    if (o < _this.pf.left || o > _this.pf.right || p < _this.pf.top || p > _this.pf.bottom) {
                        return;
                    }
                    if (e.b6 && !e.b9 && e.categoryMode != 0) {
                        n.b = m.ak;
                    }
                    else {
                        n.b = e.eb(o, f);
                    }
                    if (g.b6 && !g.b9 && g.categoryMode != 0) {
                        n.c = m.ak;
                    }
                    else {
                        n.c = g.eb(p, h);
                    }
                    n.a = m.content;
                    if (b) {
                        n.d = _this.r7(n.c, c);
                    }
                    else {
                        n.d = e.fw(m.ak);
                    }
                    a.add(n);
                }
            });
            return true;
        };
        CategorySeries.prototype.r7 = function (a, b) {
            if (b >= 0) {
                return i2.round10N(a, b).toString();
            }
            else {
                return a.toString();
            }
        };
        CategorySeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.rc = a;
        };
        CategorySeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        Object.defineProperty(CategorySeries.prototype, "categoryAxis", {
            get: function () {
                return this.q2();
            },
            enumerable: false,
            configurable: true
        });
        CategorySeries.prototype.q2 = function () {
            return this.fetchXAxis();
        };
        CategorySeries.prototype.rn = function () {
            return this.fetchYAxis();
        };
        CategorySeries.prototype.get_da = function () {
            return true;
        };
        CategorySeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.rc.cr.g(this.gh);
        };
        CategorySeries.prototype.rv = function () {
            return (this.assigningCategoryStyle != null && this.rp) || (this.bj != 1);
        };
        CategorySeries.prototype.rw = function () {
            return (this.assigningCategoryMarkerStyle != null && this.ro) || (this.bj != 1);
        };
        CategorySeries.prototype.sk = function (a) {
            if (this.assigningCategoryStyle != null && this.rp) {
                this.assigningCategoryStyle(this, a);
            }
        };
        CategorySeries.prototype.sj = function (a) {
            if (this.assigningCategoryMarkerStyle != null && this.ro) {
                this.assigningCategoryMarkerStyle(this, a);
            }
        };
        CategorySeries.prototype.qw = function (a, b) {
            return null;
        };
        CategorySeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            if (a) {
                this.se(b);
            }
        };
        CategorySeries.prototype.bg = function () {
            var a = _super.prototype.bg.call(this);
            return a;
        };
        CategorySeries.prototype.ky = function () {
            _super.prototype.ky.call(this);
            var a = this.fetchXAxis();
            if (a != null) {
                a.hq(false);
            }
            var b = this.fetchYAxis();
            if (b != null) {
                b.hq(false);
            }
        };
        CategorySeries.prototype.mn = function (a, b) {
            _super.prototype.mn.call(this, a, b);
            this.rc.cr.g(this.gh);
            this.l0(false);
        };
        CategorySeries.prototype.mm = function (a, b) {
            if (this.eu && this.gn < 0.05 && (this.ca == null || !this.ca.d6())) {
                this.ev = true;
            }
            _super.prototype.mm.call(this, a, b);
            this.rc.cr.g(this.gh);
            this.l0(false);
        };
        CategorySeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    var e = this.fetchYAxis();
                    var f = this.fetchXAxis();
                    if (c != null && d == null) {
                        this.kl(f);
                        this.kl(e);
                    }
                    if (c == null && d != null) {
                        this.lr(f);
                        this.lr(e);
                    }
                    this.rc.cr.g(this.gh);
                    this.l0(false);
                    break;
                case "SyncLink":
                    if (this.b5 != null && this.ca != null) {
                        this.rc.cr.g(this.gh);
                    }
                    this.l0(false);
                    break;
                case "TransitionProgress":
                    this.q7.c(this.gn, this.q5, this.q3);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.q3.v();
                        this.sl(this.q3, this.rc);
                        if (this.eu) {
                            this.eu = false;
                            this.ki();
                            this.cb.r = i2.truncate(this.gb());
                            this.cb.b = this.cc;
                        }
                    }
                    else {
                        this.sl(this.q7, this.rc);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case "ErrorBarSettings":
                    this.k7();
                    break;
                case CategorySeries.$$p[4]:
                    this.l0(false);
                    break;
                case CategorySeries.$$p[1]:
                    this.rp = this.rr();
                    this.l0(false);
                    break;
                case CategorySeries.$$p[0]:
                    this.ro = this.rq();
                    this.l0(false);
                    break;
            }
        };
        CategorySeries.prototype.rr = function () {
            return this.rt;
        };
        CategorySeries.prototype.rq = function () {
            return this.rs;
        };
        CategorySeries.prototype.r1 = function (a) {
            return this.fy(a, this.fetchXAxis());
        };
        CategorySeries.prototype.get_d3 = function () {
            return i2.typeCast(ISortingAxis_$type, this.q2()) !== null;
        };
        CategorySeries.prototype.ar = function () {
            return this.q2();
        };
        CategorySeries.prototype.g2 = function (a) {
            return this.rm.b$d(this, a);
        };
        CategorySeries.prototype.hh = function (a) {
            return this.rm.b$f(this, a);
        };
        CategorySeries.prototype.g0 = function (a) {
            var b = i2.truncate(Math.round(this.fw(a)));
            return b;
        };
        CategorySeries.prototype.fw = function (a) {
            return this.rm.b$c(this, a);
        };
        CategorySeries.prototype.aw = function (a, b, c) {
            if (this.d9(this.bj) && !c) {
                var d = this.ri(a, b, this.rk);
                this.rk = d;
                return d;
            }
            else {
                var e = this.rg(a, b, this.rk);
                e.e = true;
                this.rk = e;
                return e;
            }
        };
        CategorySeries.prototype.get_dr = function () {
            return true;
        };
        CategorySeries.prototype.kf = function () {
            _super.prototype.kf.call(this);
            this.rj = null;
            this.rk = null;
        };
        CategorySeries.prototype.av = function (a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                var d = this.rh(a, b, this.rj);
                this.rj = d;
                return d;
            }
            else {
                var e = this.rg(a, b, this.rj);
                this.rj = e;
                return e;
            }
        };
        CategorySeries.prototype.r0 = function () {
            return this.rc.cu.a;
        };
        CategorySeries.prototype.ri = function (a, b, c) {
            if (!this.pt()) {
                return null;
            }
            var d = this.q4();
            var e = this.r0();
            return this.rm.b$b(this, e, this.r4(this.bx), this.r3(this.bx), d.f, a, b, c);
        };
        CategorySeries.prototype.rh = function (a, b, c) {
            var d = this.r4(this.bx);
            var e = this.r5(this.bx);
            var f = this.r3(this.bx);
            var g = this.q4();
            return this.rm.b$a(this, g.f, d, e, f, a, b, c);
        };
        CategorySeries.prototype.rg = function (a, b, c) {
            var d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        };
        CategorySeries.prototype.q4 = function () {
            var a = this.q3;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.q7;
            }
            return a;
        };
        CategorySeries.prototype.sg = function (a, b, c, d, e, f) {
            var g = this.bj != 1;
            this.rb.a1(this.rb.d, d.ch, a, b, c, d, e, f, true);
            this.rb.aa(this.fj);
            var h = this.rb.av;
            var i = null;
            var j = this.ch;
            var k = null;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    k = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                }
                h.b = i;
            }
            h.f = f;
            this.sj(h);
            this.rb.y(this, i, f, g, h.m, this.ca.a3.totalHighlightingProgress);
        };
        CategorySeries.prototype.sh = function (a, b, c, d, e, f) {
            var g = this.bj != 1;
            this.rb.a1(this.rb.b, d.ch, a, b, c, d, e, f, false);
            this.rb.ab(this.fj);
            var h = this.rb.aw;
            var i = null;
            var j = this.ch;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.sk(h);
            this.rb.z(this, i, f, g, b < 0);
        };
        CategorySeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            d = d && this.rz(this.fetchXAxis());
            d = d && this.rz(this.fetchYAxis());
            var e = c;
            if (!c.o() || b.isEmpty || a.isEmpty || this.ch == null) {
                d = false;
            }
            if (!d) {
                e.cr.d = 0;
            }
            return d;
        };
        CategorySeries.prototype.rz = function (a) {
            if (a == null || a.bh == null) {
                return false;
            }
            var b = i2.typeCast(CategoryAxisBase.$, a);
            if (b != null) {
                if (b.itemsSource == null) {
                    return false;
                }
                if (b.kq < 1) {
                    return false;
                }
            }
            else {
                var c = i2.typeCast(NumericAxisBase.$, a);
                if (c != null) {
                    return c.kv != c.ku;
                }
            }
            return true;
        };
        CategorySeries.prototype.ek = function () {
            return this.ru;
        };
        CategorySeries.prototype.rd = function () {
            return 12;
        };
        CategorySeries.prototype.ki = function () {
            _super.prototype.ki.call(this);
            this.q5.v();
            this.q3.v();
            this.q7.v();
        };
        CategorySeries.prototype.l1 = function (a) {
            _super.prototype.l1.call(this, a);
            this.rc.cr.g(this.gh);
            if (this.ct(this.bx)) {
                this.q3.y();
                this.q7.y();
                this.q5.y();
                return;
            }
            if (this.em) {
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.sl(this.q7, this.rc);
                }
                else {
                    this.sl(this.q3, this.rc);
                }
                return;
            }
            if (this.ei(a)) {
                var b = this.q5;
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.q5 = this.q7;
                    this.q7 = b;
                }
                else {
                    this.q5 = this.q3;
                    this.q3 = b;
                }
                this.si(this.q3, this.rc);
                if (this.ew) {
                    this.cb.w();
                    this.cb.r = i2.truncate(this.gc());
                    this.cb.b = this.cd != null ? this.cd : this.cc;
                    this.rf.p(this.q5, this.q3, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.re, this.rd(), this.b7, this.b6(), i2.runOn(this, this.r2), this.rc.bu);
                }
                this.kd();
                this.l8();
                if (this.ew) {
                    this.ev = false;
                    this.eu = true;
                }
            }
            else {
                this.si(this.q3, this.rc);
                this.sl(this.q3, this.rc);
            }
        };
        CategorySeries.prototype.b6 = function () {
            return 3;
        };
        CategorySeries.prototype.r2 = function () {
            if (this.isVertical) {
                return this.pf.left;
            }
            return this.pf.bottom;
        };
        CategorySeries.prototype.r6 = function () {
            var e_1, _a;
            var a = 0;
            var b = this.fetchXAxis();
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (c == this) {
                        return a;
                    }
                    var d = i2.typeCast(CategorySeries.$, c);
                    if (d != null) {
                        var e = i2.typeCast(CategoryAxisBase.$, d.fetchXAxis());
                        if (e == b && d.preferredCategoryMode(e) == 2) {
                            a++;
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return -1;
        };
        Object.defineProperty(CategorySeries.prototype, "GetErrorBarsXAxis", {
            get: function () {
                return this.fetchXAxis();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategorySeries.prototype, "GetErrorBarsYAxis", {
            get: function () {
                return this.fetchYAxis();
            },
            enumerable: false,
            configurable: true
        });
        CategorySeries.prototype.sf = function (a, b) {
            this.rb.az(this, this.rw(), i2.runOn(this, this.qw), this.r3(a), this.r4(a));
            var c = this.rb.d;
            var d = c != null;
            var e = this.q2();
            if (e == null) {
                return;
            }
            var f = this.getEffectiveViewport1(a);
            var g = new ScalerParams(0, a.bv, a.bu, e.cc, f);
            var h = this.ch == null ? 0 : this.ch.count;
            var i = a;
            var j = b.f;
            var k = i.cr.e;
            var l = i.cr.f;
            var m = i.cr.d;
            var n = k * m;
            for (var o = 0; o < a.cu.count; o++) {
                var p = a.cu.item(o);
                var q = p.content;
                if (d) {
                    var r = p.al;
                    this.sg(j, r, h, e, g, a.q);
                }
                this.rb.ac(p, q);
            }
        };
        CategorySeries.prototype.sl = function (a, b) {
            this.o6 = a.aa;
            b.au();
        };
        CategorySeries.prototype.si = function (a, b) {
            a.u();
        };
        CategorySeries.prototype.r3 = function (a) {
            return a.cr.d;
        };
        CategorySeries.prototype.r4 = function (a) {
            return a.cr.e;
        };
        CategorySeries.prototype.r5 = function (a) {
            return a.cr.f;
        };
        CategorySeries.prototype.se = function (a) {
            var b = a;
            b.cu.count = 0;
        };
        CategorySeries.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            var c = i2.typeCast(CategorySeriesView.$, this.bw);
            c.cr.g(this.gh);
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            this.sm();
            this.et = false;
        };
        CategorySeries.prototype.sm = function () {
            var a = i2.typeCast(CategorySeriesView.$, this.bw);
            if (!this.en) {
                this.si(this.q6, a);
            }
            this.en = false;
            this.sl(this.q6, a);
        };
        CategorySeries.prototype.q9 = function (a) {
            var b = i2.typeCast(CategorySeriesView.$, a);
            if (b != null && b.q) {
                if (b.p) {
                    return new CategoryFramePreparer(1, i2.typeCast(IIsCategoryBased_$type, this), i2.typeCast(ISupportsMarkers_$type, b), b, this, b.cr);
                }
                else {
                    return new CategoryFramePreparer(1, i2.typeCast(IIsCategoryBased_$type, this), i2.typeCast(ISupportsMarkers_$type, b), this.ca.cf.o, this, b.cr);
                }
            }
            else {
                return this.q8;
            }
        };
        CategorySeries.prototype.an = function (a) {
            if (this.fetchXAxis() == a) {
                return this.fetchYAxis();
            }
            if (this.fetchYAxis() == a) {
                return this.fetchXAxis();
            }
            return null;
        };
        CategorySeries.prototype.ag = function () {
            return [this.fetchXAxis(), this.fetchYAxis()];
        };
        CategorySeries.qx = function (a, b, c, d, e) {
            var f = null;
            if (b > -1 && !d.isEmpty && !c.isEmpty) {
                var g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
                var h = c.bottom + 10;
                var i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
                var j = c.top - 10;
                f = new i2.Clipper(1, g, h, i, j, e);
            }
            return f;
        };
        CategorySeries.$t = i2.markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
        CategorySeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:rs:sn', [0, false], 'IsCustomCategoryStyleAllowed:rt:so', [0, false], 'IsTransitionInEnabled:ru:sp', [0, false], 'TransitionInMode:re:sq', [CategoryTransitionInMode_$type, i2.enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:ry:sr', [0, false]]);
        return CategorySeries;
    }(MarkerSeries));
    /**
     * @hidden
     */
    var CategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategorySeriesView, _super);
        function CategorySeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.ct = null;
            _this.cw = 0;
            _this.cr = null;
            _this.cu = null;
            _this.cw = -1;
            _this.ct = a;
            _this.cr = _this.cs();
            _this.cu = ((function () {
                var $ret = new i2.Pool$1(Marker.$);
                $ret.create = i2.runOn(_this, _this.b0);
                $ret.activate = i2.runOn(_this, _this.cj);
                $ret.disactivate = i2.runOn(_this, _this.cl);
                $ret.destroy = i2.runOn(_this, _this.ck);
                return $ret;
            })());
            return _this;
        }
        CategorySeriesView.prototype.cv = function (a) {
            if (this.cw != a.t) {
                return true;
            }
            return false;
        };
        CategorySeriesView.prototype.cy = function (a) {
            this.cw = a.t;
        };
        CategorySeriesView.prototype.updateMarkerTemplate = function (a, b, c) {
            if (!this.b1.pv) {
                var d = this.cu.item(a);
                var e = d.content;
                e.item = this.e.ch.item(b);
                d.ak = b;
                d.al = c;
            }
        };
        CategorySeriesView.prototype.cs = function () {
            return new CategoryBucketCalculator(this);
        };
        Object.defineProperty(CategorySeriesView.prototype, "shouldDisplayMarkers", {
            get: function () {
                return this.ct.pt();
            },
            enumerable: false,
            configurable: true
        });
        CategorySeriesView.prototype.updateMarkerCount = function (a) {
            this.cu.count = a;
        };
        CategorySeriesView.prototype.cf = function (a) {
            this.cu.c(a);
        };
        CategorySeriesView.prototype.cx = function () {
        };
        CategorySeriesView.$t = i2.markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
        return CategorySeriesView;
    }(MarkerSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrendLineSeries_$type = new i2.Type(null, 'ITrendLineSeries');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IAnchoredCategorySeriesInteractionManager_$type = new i2.Type(null, 'IAnchoredCategorySeriesInteractionManager');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available methods of collision avoidance of category series' markers.
     */
    var CategorySeriesMarkerCollisionAvoidance = /*@__PURE__*/ (function (CategorySeriesMarkerCollisionAvoidance) {
        /**
         * Collision avoidance is disabled.
         */
        CategorySeriesMarkerCollisionAvoidance[CategorySeriesMarkerCollisionAvoidance["None"] = 0] = "None";
        /**
         * Items colliding with other items will be hidden from view.
         */
        CategorySeriesMarkerCollisionAvoidance[CategorySeriesMarkerCollisionAvoidance["Omit"] = 1] = "Omit";
        return CategorySeriesMarkerCollisionAvoidance;
    })({});
    /**
     * @hidden
     */
    var CategorySeriesMarkerCollisionAvoidance_$type = i2.markEnum('CategorySeriesMarkerCollisionAvoidance', 'None,0|Omit,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Determines the item returned in hit-testing when mousing over an object which represents several consolidated items.
     */
    var ConsolidatedItemHitTestBehavior = /*@__PURE__*/ (function (ConsolidatedItemHitTestBehavior) {
        /**
         * Returns the item based on the X-location only.  Will return one of the consolidated items.
         */
        ConsolidatedItemHitTestBehavior[ConsolidatedItemHitTestBehavior["Basic"] = 0] = "Basic";
        /**
         * Returns the item with the nearest Y-location out of all the items with a matching X-location.
         */
        ConsolidatedItemHitTestBehavior[ConsolidatedItemHitTestBehavior["NearestY"] = 1] = "NearestY";
        return ConsolidatedItemHitTestBehavior;
    })({});
    /**
     * @hidden
     */
    var ConsolidatedItemHitTestBehavior_$type = i2.markEnum('ConsolidatedItemHitTestBehavior', 'Basic,0|NearestY,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryMarkerManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryMarkerManager, _super);
        function CategoryMarkerManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CategoryMarkerManager.e = function (a, b, c, d) {
            var e = a.pt();
            if (c == null) {
                return;
            }
            if (e) {
                var f = false;
                CategoryMarkerManager.a = false;
                for (var g = 0; g < b.count; ++g) {
                    CategoryMarkerManager.d(c, g, b, d, f);
                }
                CategoryMarkerManager.a = false;
                c.count = b.count;
            }
        };
        CategoryMarkerManager.d = function (a, b, c, d, e) {
            a.item(b).n = c._inner[b].x;
            a.item(b).o = c._inner[b].y;
        };
        CategoryMarkerManager.$t = i2.markType(CategoryMarkerManager, 'CategoryMarkerManager');
        CategoryMarkerManager.a = false;
        CategoryMarkerManager.c = 0;
        CategoryMarkerManager.b = 0;
        return CategoryMarkerManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IDetectsCollisions_$type = new i2.Type(null, 'IDetectsCollisions');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CollisionAvoider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CollisionAvoider, _super);
        function CollisionAvoider() {
            var _this = _super.call(this) || this;
            _this.a = new i2.List$1(i2.Rect.$, 0);
            return _this;
        }
        CollisionAvoider.prototype.tryAdd = function (a) {
            for (var b = this.a.count - 1; b >= 0; --b) {
                if (a.left > this.a._inner[b].right) {
                    break;
                }
                if (this.a._inner[b].intersectsWith(a)) {
                    return false;
                }
            }
            if (this.a.count == 0 || a.right >= this.a._inner[this.a.count - 1].right) {
                this.a.add(a);
            }
            else {
                this.a.add(a);
                this.a.aa(function (c, d) { return Math.sign(c.right - d.right); });
            }
            return true;
        };
        CollisionAvoider.prototype.clear = function () {
            this.a.clear();
        };
        CollisionAvoider.$t = i2.markType(CollisionAvoider, 'CollisionAvoider', i2.Base.$, [IDetectsCollisions_$type]);
        return CollisionAvoider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NonCollisionAvoider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NonCollisionAvoider, _super);
        function NonCollisionAvoider() {
            return _super.call(this) || this;
        }
        Object.defineProperty(NonCollisionAvoider, "b", {
            get: function () {
                if (NonCollisionAvoider.a == null) {
                    NonCollisionAvoider.a = new NonCollisionAvoider();
                }
                return NonCollisionAvoider.a;
            },
            enumerable: false,
            configurable: true
        });
        NonCollisionAvoider.prototype.clear = function () {
        };
        NonCollisionAvoider.prototype.tryAdd = function (a) {
            return true;
        };
        NonCollisionAvoider.$t = i2.markType(NonCollisionAvoider, 'NonCollisionAvoider', i2.Base.$, [IDetectsCollisions_$type]);
        NonCollisionAvoider.a = null;
        return NonCollisionAvoider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryTrendLineManagerFactory = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryTrendLineManagerFactory, _super);
        function CategoryTrendLineManagerFactory() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CategoryTrendLineManagerFactory.a = function (a, b, c, d, e) {
            if (b != null && i2.typeCast(ISortingAxis_$type, b) !== null) {
                if (a != null) {
                    a.g$f();
                }
                if (!i2.TypeRegistrar.isRegistered("SortingTrendLineManager")) {
                    throw new i2.NotSupportedException(1, e.p);
                }
                var f = i2.TypeRegistrar.create("SortingTrendLineManager", (function (g) {
                    var h = g;
                    var i = i2.typeCast(ISortingAxis_$type, b);
                    if (i != null) {
                        g = Math.min(g, i.i$b.count - 1);
                        h = i.i$b._inner[g];
                    }
                    return i.i$d(h);
                }), (function (g, h, i) {
                    var j = d.getEffectiveViewport1(d.bx);
                    var k = new ScalerParams(0, i, h, b.cc, j);
                    return b.eb(g, k);
                }));
                f.g$c(c, d);
                return f;
            }
            else if (a == null || a.g$a != 0) {
                if (a != null) {
                    a.g$f();
                }
                if (!i2.TypeRegistrar.isRegistered("CategoryTrendLineManager")) {
                    throw new i2.NotSupportedException(1, e.p);
                }
                var g = i2.TypeRegistrar.create("CategoryTrendLineManager");
                g.g$c(c, d);
                return g;
            }
            return a;
        };
        CategoryTrendLineManagerFactory.$t = i2.markType(CategoryTrendLineManagerFactory, 'CategoryTrendLineManagerFactory');
        return CategoryTrendLineManagerFactory;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredCategorySeries, _super);
        function AnchoredCategorySeries() {
            var _this = _super.call(this) || this;
            _this.sz = null;
            _this.s3 = false;
            _this.s1 = null;
            _this.sw = null;
            _this.s7 = null;
            _this.q8 = new CategoryFramePreparer(1, _this, _this.rc, _this, _this, _this.rc.cr);
            return _this;
        }
        Object.defineProperty(AnchoredCategorySeries.prototype, "s0", {
            get: function () {
                var _this = this;
                if (this.sz == null) {
                    this.sz = i2.DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, function () { return _this.ck.n; });
                }
                return this.sz;
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.prototype.getHostReferenceValue = function () {
            return this.f2();
        };
        AnchoredCategorySeries.prototype.bu = function () {
            var a = new AnchoredCategorySeriesView(this);
            return a;
        };
        AnchoredCategorySeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.sv = a;
        };
        AnchoredCategorySeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == AnchoredCategorySeries.$$p[2]) {
                return this.hl(a, b, this.tb);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(AnchoredCategorySeries.prototype, "valueColumn", {
            get: function () {
                return this.s1;
            },
            set: function (a) {
                if (this.s1 != a) {
                    var b = this.s1;
                    this.s1 = a;
                    if (!this.s3) {
                        this.raisePropertyChanged("ValueColumn", b, this.s1);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredCategorySeries.prototype, "tt", {
            get: function () {
                return this.c(AnchoredCategorySeries.ti);
            },
            set: function (a) {
                this.h(AnchoredCategorySeries.ti, a);
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.prototype.eh = function (a) {
            var b = new i2.Rect(0, 0, 0, 1, 1);
            var c = this.fetchXAxis();
            var d = this.fetchYAxis();
            var e = this.o9(this.bx);
            var f = c != null ? this.q8.r(i2.typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
            return this.s0.c$a(this, this.valueColumn, c, d, f, a);
        };
        AnchoredCategorySeries.prototype.ss = function (a, b, c) {
            if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
                return null;
            }
            var d = new Array((b - a) + 1);
            var e = c.ch;
            var f = null;
            if (e) {
                f = c.i$b;
            }
            for (var g = a; g <= b; g++) {
                var h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ch.item(g);
            }
            return d;
        };
        AnchoredCategorySeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.sv.c3 && this.sv.c2.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            switch (b) {
                case "FastItemsSource":
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.valueColumn);
                        this.valueColumn = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.valueColumn = this.ce(this.tb);
                    }
                    var e = i2.typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (e != null && !e.cv()) {
                        this.sv.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case AnchoredCategorySeries.$$p[2]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.valueColumn);
                        this.valueColumn = this.ce(this.tb);
                    }
                    this.s7 = this.tb;
                    break;
                case "ValueColumn":
                    if (this.sv.c3) {
                        this.sv.c2.g$i();
                    }
                    var f = i2.typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (f != null && !f.cv()) {
                        this.sv.cr.g(this.gh);
                        this.l0(false);
                    }
                    this.th();
                    this.mj();
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case "ErrorBarSettings":
                    this.l0(false);
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
                case AnchoredCategorySeries.$$p[1]:
                    this.l0(false);
                    break;
            }
        };
        AnchoredCategorySeries.prototype.ap = function (a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        };
        AnchoredCategorySeries.prototype.kk = function (a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.sv.cr.g(this.gh);
                    break;
            }
            if (this.sv.c3) {
                this.sv.c2.g$e(a, b, c, d);
            }
            this.th();
            this.mj();
        };
        AnchoredCategorySeries.prototype.r2 = function () {
            return this.s4(this.rc);
        };
        AnchoredCategorySeries.prototype.s4 = function (a) {
            var b = 0;
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(a);
            var f = i2.typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!c.isEmpty && !d.isEmpty && f != null) {
                var g = new ScalerParams(0, c, d, f.cc, e);
                if (f.cj) {
                    g.b = this.f2();
                }
                b = f.d8(f.k5, g);
            }
            return b;
        };
        AnchoredCategorySeries.prototype.tg = function (a, b, c) {
            var d = this.s4(c);
            if (a.count > 0) {
                var e = d;
                a.add({ $type: i2.Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: i2.Point_$type, x: a._inner[0].x, y: e });
            }
        };
        AnchoredCategorySeries.prototype.st = function (a, b, c, d) {
            return this.su(a, b, c, d, false);
        };
        AnchoredCategorySeries.prototype.su = function (a, b, c, d, e) {
            return CategorySeries.qx(a, b, c, d, e);
        };
        AnchoredCategorySeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            var e = c;
            if (this.valueColumn == null || this.valueColumn.count == 0 || e.cr.d < 1) {
                d = false;
            }
            return d;
        };
        AnchoredCategorySeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.cx();
            if (c.c3) {
                c.c2.g$d();
            }
        };
        AnchoredCategorySeries.prototype.si = function (a, b) {
            _super.prototype.si.call(this, a, b);
            this.q9(b).d(a, b);
        };
        AnchoredCategorySeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = i2.typeCast(AnchoredCategorySeriesView.$, b);
            c.b3 = true;
            if (c.c3) {
                c.c2.g$g(a.p);
            }
            if (this.pt()) {
                CategoryMarkerManager.e(this, a.m, b.cu, this.pv);
                this.sf(b, a);
                b.cm();
            }
            this.td(a, b);
        };
        AnchoredCategorySeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            g.cr.g(this.gh);
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.sw == null) {
                this.sw = new CategoryFrame(3);
            }
            this.sw.u();
            this.si(this.sw, g);
            this.sl(this.sw, g);
        };
        AnchoredCategorySeries.prototype.td = function (a, b) {
        };
        AnchoredCategorySeries.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            this.sv.c7();
            if (this.trendLineBrush != null) {
                this.sv.c5();
            }
            else {
                this.sv.c4();
            }
        };
        AnchoredCategorySeries.prototype.hn = function (a, b) {
            if (this.sv.c3 && a == this.sv.c2.g$j) {
                return null;
            }
            return _super.prototype.hn.call(this, a, b);
        };
        Object.defineProperty(AnchoredCategorySeries.prototype, "currentCategoryMode", {
            get: function () {
                return this.preferredCategoryMode(i2.typeCast(CategoryAxisBase.$, this.q2()));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredCategorySeries.prototype, "scaler", {
            get: function () {
                return i2.typeCast(ICategoryScaler_$type, this.q2());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredCategorySeries.prototype, "yScaler", {
            get: function () {
                return i2.typeCast(IScaler_$type, this.rn());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredCategorySeries.prototype, "bucketizer", {
            get: function () {
                return this.sv.cr;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredCategorySeries.prototype, "currentMode2Index", {
            get: function () {
                return this.r6();
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.prototype.provideCollisionDetector = function () {
            if (this.sx == 1) {
                return new CollisionAvoider();
            }
            return NonCollisionAvoider.b;
        };
        Object.defineProperty(AnchoredCategorySeries.prototype, "trendlinePreparer", {
            get: function () {
                return this.sv.c3 ? this.sv.c2 : null;
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            if (this.sv.c3) {
                this.a6.exportTrendlineData(this, a, this.sv.c2.g$j);
            }
        };
        AnchoredCategorySeries.prototype.hh = function (a) {
            var _this = this;
            var b = this.fetchXAxis();
            var c = this.fetchYAxis();
            return this.s0.c$b(this, a, this.r3(this.bx), this.valueColumn, b, c, this.sy == 1, function (d) { return _super.prototype.hh.call(_this, d); });
        };
        Object.defineProperty(AnchoredCategorySeries.prototype, "mayContainUnknowns", {
            get: function () {
                return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.prototype.f2 = function () {
            return Series.f3(this.valueColumn, i2.typeCast(ISortingAxis_$type, this.fetchXAxis()));
        };
        AnchoredCategorySeries.prototype.get_s6 = function () {
            return 0;
        };
        Object.defineProperty(AnchoredCategorySeries.prototype, "s6", {
            get: function () {
                return this.get_s6();
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.prototype.aq = function (a) {
            if (a.isEmpty && this.ca != null) {
                a = this.ca.pg;
            }
            if (this.valueColumn == null) {
                return null;
            }
            var b = this.o7(this.bx);
            var c = this.q2();
            var d = new ScalerParams(0, a, this.ca.pv, c.cc, this.getEffectiveViewport());
            var e = (c.eb(b.left, d));
            var f = (c.eb(b.right, d));
            if (c.cc) {
                var g = e;
                e = f;
                f = g;
            }
            e -= this.s6;
            f += this.s6;
            var h = null;
            if (c.ch) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (i2.isNaN_(e) || i2.isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            var i = 1.7976931348623157E+308;
            var j = -1.7976931348623157E+308;
            if (i2.truncate(e) <= i2.truncate(f)) {
                for (var k = i2.truncate(e); k <= i2.truncate(f); k++) {
                    var l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    var m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (i2.isInfinity(m) || i2.isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            var n = new AxisRange(i, j);
            n = this.ao(n, this.rn(), a);
            return n;
        };
        AnchoredCategorySeries.prototype.th = function () {
            this.fs = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
        };
        Object.defineProperty(AnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeries.$t = i2.markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
        AnchoredCategorySeries.ti = i2.DependencyProperty.i("ActualTrendLineBrush", i2.Brush.$, AnchoredCategorySeries.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
        AnchoredCategorySeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:sy:tj', [ConsolidatedItemHitTestBehavior_$type, i2.enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:sx:tk', [CategorySeriesMarkerCollisionAvoidance_$type, i2.enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:tb:ts', [2, null], 'TrendLineType::tq', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'TrendLineThickness::tp', [1, 1.5], 'TrendLinePeriod::to', [1, 7], 'TrendLineBrush::tl', [i2.Brush.$, null], 'TrendLineZIndex:s5:tr', [1, 1001], 'TrendLineDashArray:tu:tm', [i2.DoubleCollection.$], 'TrendLineDashCap:tv:tn', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)]]);
        return AnchoredCategorySeries;
    }(CategorySeries));
    /**
     * @hidden
     */
    var AnchoredCategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredCategoryBucketCalculator, _super);
        function AnchoredCategoryBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.i = null;
            _this.h = null;
            _this.j = 0;
            _this.i = a;
            return _this;
        }
        AnchoredCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            var b = this.h;
            var c = this.j;
            var d = a * this.d;
            var e = d + this.d - 1;
            var f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            var g = 1.7976931348623157E+308;
            var h = -1.7976931348623157E+308;
            var i = true;
            for (var j = d; j <= e; ++j) {
                var k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        };
        AnchoredCategoryBucketCalculator.prototype.getBucket = function (a) {
            var b = this.h;
            var c = this.j;
            var d = a * this.d;
            var e = d + this.d - 1;
            var f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            var g = 0;
            var h = 0;
            var i = true;
            for (var j = d; j <= e; ++j) {
                var k = b[j];
                if (!i) {
                    if (!i2.isNaN_(k)) {
                        g = g < k ? g : k;
                        h = h > k ? h : k;
                    }
                }
                else {
                    if (!i2.isNaN_(k)) {
                        g = k;
                        h = k;
                        i = false;
                    }
                }
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        };
        AnchoredCategoryBucketCalculator.prototype.cacheValues = function () {
            this.j = this.i.c0.valueColumn.count;
            this.h = this.i.c0.valueColumn.asArray();
        };
        AnchoredCategoryBucketCalculator.prototype.unCacheValues = function () {
            this.h = null;
        };
        AnchoredCategoryBucketCalculator.$t = i2.markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
        return AnchoredCategoryBucketCalculator;
    }(CategoryBucketCalculator));
    /**
     * @hidden
     */
    var AnchoredCategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredCategorySeriesView, _super);
        function AnchoredCategorySeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c1 = null;
            _this.c0 = a;
            return _this;
        }
        Object.defineProperty(AnchoredCategorySeriesView.prototype, "c2", {
            get: function () {
                if (this.c1 == null) {
                    this.c1 = CategoryTrendLineManagerFactory.a(this.c1, this.e.ar(), this.e.mr, this.e, this.e.ck);
                }
                return this.c1;
            },
            set: function (a) {
                this.c1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredCategorySeriesView.prototype, "c3", {
            get: function () {
                return this.c1 != null;
            },
            enumerable: false,
            configurable: true
        });
        AnchoredCategorySeriesView.prototype.c7 = function () {
            this.c0.tt = null;
        };
        AnchoredCategorySeriesView.prototype.c5 = function () {
            this.c0.tt = this.c0.trendLineBrush;
        };
        AnchoredCategorySeriesView.prototype.c4 = function () {
            this.c0.tt = this.c0.of;
        };
        AnchoredCategorySeriesView.prototype.cs = function () {
            return new AnchoredCategoryBucketCalculator(this);
        };
        AnchoredCategorySeriesView.prototype.c6 = function () {
            this.cr.cacheValues();
        };
        AnchoredCategorySeriesView.prototype.c8 = function () {
            this.cr.unCacheValues();
        };
        AnchoredCategorySeriesView.prototype.c9 = function (a) {
            var b = this.cu.item(a);
            return this.cp(b);
        };
        AnchoredCategorySeriesView.prototype.a5 = function (a, b) {
            if (a.d) {
                if (this.c0.trendLineType != 0 && !b) {
                    var c = this.c2.g$j;
                    c.ac = this.c0.trendLineThickness;
                    c._stroke = this.c0.tt;
                    c.ai = this.c0.tu;
                    c.ad = this.c0.tv;
                    a.u(c);
                }
            }
            _super.prototype.a5.call(this, a, b);
        };
        AnchoredCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
            return this.c0.s0.c$c(this.e, this.c0.tb);
        };
        AnchoredCategorySeriesView.$t = i2.markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
        return AnchoredCategorySeriesView;
    }(CategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHorizontalAnchoredCategorySeriesInteractionManager_$type = new i2.Type(null, 'IHorizontalAnchoredCategorySeriesInteractionManager');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAnchoredCategorySeries, _super);
        function HorizontalAnchoredCategorySeries() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.t0 = null;
            _this.tw = null;
            _this.t2 = null;
            _this.ty = 0;
            return _this;
        }
        Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "t1", {
            get: function () {
                var _this = this;
                if (this.t0 == null) {
                    this.t0 = i2.DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.ck.n; });
                }
                return this.t0;
            },
            enumerable: false,
            configurable: true
        });
        HorizontalAnchoredCategorySeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.xAxis = null;
            this.yAxis = null;
        };
        HorizontalAnchoredCategorySeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        HorizontalAnchoredCategorySeries.prototype.q2 = function () {
            return this.tw;
        };
        HorizontalAnchoredCategorySeries.prototype.rn = function () {
            return this.t2;
        };
        HorizontalAnchoredCategorySeries.prototype.pd = function (a) {
            if (this.q3 == null || this.q3.m.count == 0 || !this.hasMarkers || !this.pt()) {
                return i2.Rect.empty;
            }
            return this.t1.d$d(this, this.q3.m, a, i2.runOn(this, this.ue));
        };
        HorizontalAnchoredCategorySeries.prototype.ue = function (a) {
            return this.sv.c9(a);
        };
        HorizontalAnchoredCategorySeries.prototype.t6 = function (a, b, c) {
            return this.t1.d$c(this, this.rn(), a, b, c);
        };
        HorizontalAnchoredCategorySeries.prototype.ah = function (a) {
            return this.t1.d$a(this, this.q3.f, this.r3(this.bx), this.r4(this.bx), a);
        };
        HorizontalAnchoredCategorySeries.prototype.ai = function (a) {
            return this.t1.d$b(this, this.q3.f, this.r3(this.bx), this.r4(this.bx), a);
        };
        HorizontalAnchoredCategorySeries.prototype.ep = function (a, b) {
            if (this.eo(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        HorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
            return this.q8.r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        HorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
            var a = this.getEffectiveViewport1(this.bx);
            return this.q2().getCategorySize(this.bx.bv, this.bx.bu, a);
        };
        HorizontalAnchoredCategorySeries.prototype.f8 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.q2();
            var f = new ScalerParams(0, this.ca.pg, this.bx.bu, e.cc, d);
            var g = this.q8.r(e, this.ca.pg, this.bx.bu, d);
            return this.ga(this.valueColumn, a, e, f, g, i2.runOn(this, this.r1), b, c);
        };
        HorizontalAnchoredCategorySeries.prototype.g6 = function (a, b) {
            return this.g7(a, b, this.q2(), i2.runOn(this, this.r1), this.valueColumn);
        };
        HorizontalAnchoredCategorySeries.prototype.g4 = function (a, b) {
            return this.g5(a, b, this.q2(), i2.runOn(this, this.r1), this.valueColumn);
        };
        HorizontalAnchoredCategorySeries.prototype.fu = function (a, b, c, d, e) {
            if (this.valueColumn == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.fv(a, b, this.q2(), d, e, this.valueColumn.count, i2.runOn(this, this.r1));
        };
        HorizontalAnchoredCategorySeries.prototype.o2 = function (a, b, c) {
            if (this.q2() == null || this.rn() == null) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            return this.o4(a, b, c, this.q8.r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.rn(), this.q2(), null, null, null);
        };
        HorizontalAnchoredCategorySeries.prototype.fetchXAxis = function () {
            return this.tw;
        };
        HorizontalAnchoredCategorySeries.prototype.fetchYAxis = function () {
            return this.t2;
        };
        HorizontalAnchoredCategorySeries.prototype.te = function (a) {
            this.xAxis = i2.typeCast(CategoryAxisBase.$, a);
        };
        HorizontalAnchoredCategorySeries.prototype.tf = function (a) {
            this.yAxis = i2.typeCast(NumericYAxis.$, a);
        };
        HorizontalAnchoredCategorySeries.prototype.rx = function () {
            return this.t2 != null && this.t2.cv();
        };
        HorizontalAnchoredCategorySeries.prototype.ua = function (a) {
            this.tw = a;
        };
        HorizontalAnchoredCategorySeries.prototype.ub = function (a) {
            this.t2 = a;
        };
        HorizontalAnchoredCategorySeries.prototype.qw = function (a, b) {
            return this.ss(a, b, this.tw);
        };
        HorizontalAnchoredCategorySeries.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case HorizontalAnchoredCategorySeries.$$p[0]:
                    this.ua(this.xAxis);
                    if (this.sv.c3) {
                        this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.tw, this.mr, this, this.ck);
                    }
                    break;
                case "TrendLineType":
                    var e = i2.EnumUtil.getEnumValue(i2.TrendLineType_$type, d);
                    if (e != 0) {
                        this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.tw, this.mr, this, this.ck);
                    }
                    break;
            }
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case HorizontalAnchoredCategorySeries.$$p[0]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.ua(this.xAxis);
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                        this.k7();
                    }
                    break;
                case HorizontalAnchoredCategorySeries.$$p[1]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.ub(this.yAxis);
                        this.rc.cr.g(this.gh);
                        this.rx();
                        this.l0(false);
                        this.k7();
                    }
                    break;
                case "CategoryMode":
                    if (this.xAxis != null) {
                        this.xAxis.le(true);
                    }
                    break;
            }
        };
        HorizontalAnchoredCategorySeries.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            if (this.tw != null && i2.typeCast(ISortingAxis_$type, this.tw) !== null) {
                this.tw.i$i();
            }
            switch (a) {
                case 4:
                    if (this.tw != null) {
                        this.tw.cv();
                    }
                    if (this.t2 != null && !this.t2.cv()) {
                        this.l0(true);
                    }
                    break;
                case 1:
                    if (this.tw != null) {
                        this.tw.cv();
                    }
                    if (this.t2 != null && !this.t2.cv()) {
                        this.l0(true);
                    }
                    break;
                case 0:
                    if (this.tw != null) {
                        this.tw.cv();
                    }
                    if (this.t2 != null && !this.t2.cv()) {
                        this.l0(true);
                    }
                    break;
                case 2:
                    if (this.s7 != null && this.sv.cr.d > 0 && this.t2 != null && !this.t2.cv()) {
                        this.l0(true);
                    }
                    break;
                case 3:
                    if (d == this.s7) {
                        if (this.tw != null) {
                            this.tw.cv();
                        }
                        if (this.t2 != null && !this.t2.cv()) {
                            this.l0(true);
                        }
                    }
                    break;
            }
        };
        HorizontalAnchoredCategorySeries.prototype.t4 = function (a) {
            if (i2.typeCast(CategoryXAxis.$, a) !== null || a.b9) {
                return true;
            }
            return false;
        };
        HorizontalAnchoredCategorySeries.prototype.t5 = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "tz", {
            get: function () {
                return this.ty;
            },
            set: function (a) {
                var b = this.tz;
                if (a != b) {
                    this.ty = a;
                    this.raisePropertyChanged("CategoryMode", i2.enumGetBox(CategoryMode_$type, b), i2.enumGetBox(CategoryMode_$type, this.tz));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        HorizontalAnchoredCategorySeries.$t = i2.markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
        HorizontalAnchoredCategorySeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::uc', [CategoryAxisBase.$, null], 'YAxis::ud', [NumericYAxis.$, null]]);
        return HorizontalAnchoredCategorySeries;
    }(AnchoredCategorySeries));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalAnchoredCategorySeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAnchoredCategorySeriesProxy, _super);
        function HorizontalAnchoredCategorySeriesProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalAnchoredCategorySeriesProxy.prototype.matchesType = function (a) {
            return i2.typeCast(HorizontalAnchoredCategorySeries.$, a) !== null;
        };
        HorizontalAnchoredCategorySeriesProxy.prototype.setCategoryMode = function (a, b) {
            a.tz = b;
        };
        HorizontalAnchoredCategorySeriesProxy.prototype.setValueMemberPath = function (a, b) {
            a.tb = b;
        };
        HorizontalAnchoredCategorySeriesProxy.prototype.setXAxis = function (a, b) {
            a.xAxis = b;
        };
        HorizontalAnchoredCategorySeriesProxy.prototype.setYAxis = function (a, b) {
            a.yAxis = b;
        };
        HorizontalAnchoredCategorySeriesProxy.$t = i2.markType(HorizontalAnchoredCategorySeriesProxy, 'HorizontalAnchoredCategorySeriesProxy', i2.Base.$, [IHorizontalAnchoredCategorySeriesProxy_$type]);
        return HorizontalAnchoredCategorySeriesProxy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHorizontalAnchoredCategorySeriesProxyModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHorizontalAnchoredCategorySeriesProxyModule() {
            i2.TypeRegistrar.register('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy.$type);
        }
        IgxHorizontalAnchoredCategorySeriesProxyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHorizontalAnchoredCategorySeriesProxyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyModule, imports: [i1.CommonModule] });
        IgxHorizontalAnchoredCategorySeriesProxyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyModule, imports: [[i1.CommonModule,
                ]] });
        return IgxHorizontalAnchoredCategorySeriesProxyModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHorizontalAnchoredCategorySeriesProxyDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHorizontalAnchoredCategorySeriesProxyDynamicModule() {
            i2.TypeRegistrar.registerCons('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy);
            i2.TypeRegistrar.register('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy.$type);
        }
        IgxHorizontalAnchoredCategorySeriesProxyDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHorizontalAnchoredCategorySeriesProxyDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyDynamicModule, imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxHorizontalAnchoredCategorySeriesProxyDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyDynamicModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule
                ], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxHorizontalAnchoredCategorySeriesProxyDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesProxyDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxHorizontalAnchoredCategorySeriesProxyModule
                        ],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Enum used to determine positioning logic for data items which have been consolidated into a single visual element.
     */
    var ConsolidatedItemsPosition = /*@__PURE__*/ (function (ConsolidatedItemsPosition) {
        /**
         * Consolidated Items should be positioned using their minimum value.
         */
        ConsolidatedItemsPosition[ConsolidatedItemsPosition["Minimum"] = 0] = "Minimum";
        /**
         * Consolidated Items should be positioned using their maximum value.
         */
        ConsolidatedItemsPosition[ConsolidatedItemsPosition["Maximum"] = 1] = "Maximum";
        /**
         * Consolidated Items should be positioned at the midpoint of the range.
         */
        ConsolidatedItemsPosition[ConsolidatedItemsPosition["Median"] = 2] = "Median";
        /**
         * Consolidated Items should be positioned using the value nearest to the reference value of the corresponding axis.
         */
        ConsolidatedItemsPosition[ConsolidatedItemsPosition["RelativeMinimum"] = 3] = "RelativeMinimum";
        /**
         * Consolidated Items should be positioned using the value farthest from the reference value of the corresponding axis.
         */
        ConsolidatedItemsPosition[ConsolidatedItemsPosition["RelativeMaximum"] = 4] = "RelativeMaximum";
        return ConsolidatedItemsPosition;
    })({});
    /**
     * @hidden
     */
    var ConsolidatedItemsPosition_$type = i2.markEnum('ConsolidatedItemsPosition', 'Minimum,0|Maximum,1|Median,2|RelativeMinimum,3|RelativeMaximum,4');

    /**
     * Represents the base class for all IgxDataChartComponent numeric axes.
    */
    var IgxNumericAxisBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxNumericAxisBaseComponent, _super);
        function IgxNumericAxisBaseComponent() {
            var _this = _super.call(this) || this;
            _this._actualMinimumValueChange = null;
            _this._actualMaximumValueChange = null;
            _this._actualIntervalChange = null;
            _this._actualMinorIntervalChange = null;
            return _this;
        }
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "isNumeric", {
            /**
             * Gets or sets if the current axis is of numeric axis type
            */
            get: function () {
                return this.i.ce;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "minimumValue", {
            /**
             * Gets or sets the MinimumValue property.
            *
            * Used to set the minimum value of a numeric axis. To get the minimum value in effect on a numeric axis use `actualMinimumValue`.
            *
            * ```ts
            * this.yAxis.minimumValue = 0;
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         minimumValue=0
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.k3;
            },
            set: function (v) {
                this.i.k3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMinimumValue", {
            /**
             * Gets the effective minimum value for the current numeric axis object.
            *
            * ```ts
            * let effectiveMinValue: number = yAxis.actualMinimumValue;
            * ```
            */
            get: function () {
                return this.i.kv;
            },
            set: function (v) {
                this.i.kv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualVisibleMinimumValue", {
            /**
             * Gets the effective minimum value for the current numeric axis object.
            *
            * The `actualVisibleMinimumValue` is used to get the current visible maximum value for the a numeric axis. Note, at times the `actualVisibleMinimumValue` may differ from the `actualMinimumValue`, for example when the chart is zoomed.
            *
            * ```ts
            * let effectiveVisibleMinValue: number = yAxis.actualVisibleMinimumValue;
            * ```
            */
            get: function () {
                return this.i.ky;
            },
            set: function (v) {
                this.i.ky = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "maximumValue", {
            /**
             * Gets or sets the MaximumValue property.
            *
            * Used to set the maximum value of a numeric axis. To get the maximum value in effect on a numeric axis use `actualMaximumValue`.
            *
            * ```ts
            * this.yAxis.maximumValue = 80;
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         maximumValue=80
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.k2;
            },
            set: function (v) {
                this.i.k2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMaximumValue", {
            /**
             * Gets the effective maximum value for the current numeric axis object.
            *
            * ```ts
            * let effectiveMaxValue: number = yAxis.actualMaximumValue;
            * ```
            */
            get: function () {
                return this.i.ku;
            },
            set: function (v) {
                this.i.ku = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualVisibleMaximumValue", {
            /**
             * Gets the effective visible maximum value for the current numeric axis object.
            *
            * The `actualVisibleMaximumValue` is used to get the current visible maximum value for the a numeric axis. Note, at times the `actualVisibleMaximumValue` may differ from the `actualMaximumValue`, for example when the chart is zoomed.
            *
            * ```ts
            * let effectiveVisibleMaxValue: number = yAxis.actualVisibleMaximumValue;
            * ```
            */
            get: function () {
                return this.i.kx;
            },
            set: function (v) {
                this.i.kx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "interval", {
            /**
             * Gets or sets the Interval property.
            *
            * The `interval` is used to get or set the numeric axis major interval which specifies how frequent major gridlines and axis labels are rendered on an axis.
            *
            * ```ts
            * this.yAxis.interval = 20;
            * ```
            *
            * ```html
            * <igx-data-chart
            *       [dataSource]="data">
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis
            *         >
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis
            *         interval="20"
            *         #yAxis>
            *       </igx-numeric-y-axis>
            *
            *       <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *       </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.kz;
            },
            set: function (v) {
                this.i.kz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualInterval", {
            /**
             * Gets the effective value for the current Interval.
            *
            * ```ts
            * let effectiveInterval: number = yAxis.actualInterval;
            * ```
            */
            get: function () {
                return this.i.kt;
            },
            set: function (v) {
                this.i.kt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "minorInterval", {
            /**
             * Gets or sets the MinorInterval property.
            *
            * The `minorInterval` is used to get or set the numeric axis minor interval which specifies how frequent minor gridlines are rendered on an axis. Please note, in order for minor gridlines to be displayed the following may also need to be set: `MinorStroke`, `MinorStrokeThickness`.
            *
            * ```ts
            * this.yAxis.minorInterval = 2.5;
            * this.yAxis.minorStroke = 'blue';
            * this.yAxis.minorStrokeThickness = 1;
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         minorInterval= 2.5
            *         minorStroke="blue"
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.k4;
            },
            set: function (v) {
                this.i.k4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMinorInterval", {
            /**
             * Gets the effective value for the current MinorInterval.
            *
            * ```ts
            * let effectiveMinorInterval: number = yAxis.actualMinorInterval;
            * ```
            */
            get: function () {
                return this.i.kw;
            },
            set: function (v) {
                this.i.kw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "referenceValue", {
            /**
             * Gets or sets the ReferenceValue property.
            *
            * Used to get or set a reference value on a numeric axis which when used with an area, bar, or column series will result in the series shapes being drawn above or below the specified value.
            *
            * ```ts
            * this.yAxis.referenceValue = 30;
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         referenceValue=30
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.k5;
            },
            set: function (v) {
                this.i.k5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "isLogarithmic", {
            /**
             * Gets or sets the IsLogarithmic property.
            *
            * `isLogarithmic` is used to get or set whether the numeric axis scaler is in linear or logarithmic mode. For logarithmic scaling, this can be used in conjunction with `logarithmBase` to further define the logarithmic scale.
            *
            * ```ts
            * this.yAxis.isLogarithmic= true;
            * this.yAxis.logarithmBase = 2;
            * ```
            *
            * ```html
            * <igx-data-chart
            *       [dataSource]="data">
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis
            *         isLogarithmic=true
            *         logarithmBase=2
            *         #yAxis>
            *       </igx-numeric-y-axis>
            *       <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *       </igx-line-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.kk;
            },
            set: function (v) {
                this.i.kk = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualIsLogarithmic", {
            /**
             * Determines if the axis has a valid logarithmic scale.
            *
            * ```ts
            * let effectiveLogarithmic: boolean = this.yAxis.actualIsLogarithmic
            * ```
            */
            get: function () {
                return this.i.kg;
            },
            set: function (v) {
                this.i.kg = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "logarithmBase", {
            /**
             * Gets or sets the LogarithmBase property.
            *
            * `logarithmBase` is used to get or set logarithm base when a numeric axis is in Logarithmic scale mode. For logarithmic scaling, this is used in conjunction with `isLogarithmic` or `ScaleMode` to set logarithmic scaling.
            *
            * ```ts
            * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
            * this.yAxis.logarithmBase = 2;
            * ```
            *
            * ```html
            * <igx-data-chart
            *       [dataSource]="data">
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis
            *         scaleMode="Logarithmic"
            *         logarithmBase=2
            *         #yAxis>
            *       </igx-numeric-y-axis>
            *       <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *       </igx-line-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.k7;
            },
            set: function (v) {
                this.i.k7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "hasUserMinimum", {
            /**
             * Determines if the axis has a user-defined minimum.
            *
            *  `hasUserMaximum` is used to determine if a numeric axis has a user definied maximum value.
            *
            * ```ts
            * let hasSetMaximum: boolean = this.yAxis.hasUserMaximum;
            * ```
            */
            get: function () {
                return this.i.kj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "hasUserMaximum", {
            /**
             * Determines if the axis has a user-defined maximum.
            *
            *  `hasUserMinimum` is used to determine if a numeric axis has a user definied minium value.
            *
            * ```ts
            * let hasSetMinimum: boolean = this.yAxis.hasUserMinimum;
            * ```
            */
            get: function () {
                return this.i.ki;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "abbreviateLargeNumbers", {
            /**
             * A boolean indicating whether or not to abbreviate large numbers.
            */
            get: function () {
                return this.i.kf;
            },
            set: function (v) {
                this.i.kf = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Unscales a value from screen space into axis space.
        
        * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
        *
        * Unscales a value from screen space into axis space.
        *
        * ```ts
        * let dataValue: number = this.yAxis.unscaleValue(pixel);
        * ```
        */
        IgxNumericAxisBaseComponent.prototype.unscaleValue = function (unscaledValue) {
            var iv = this.i.k6(unscaledValue);
            return (iv);
        };
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMinimumValueChange", {
            get: function () {
                var _this = this;
                if (this._actualMinimumValueChange == null) {
                    this._actualMinimumValueChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMinimumValue;
                        if (_this.beforeActualMinimumValueChange) {
                            _this.beforeActualMinimumValueChange(_this, ext);
                        }
                        _this._actualMinimumValueChange.emit(ext);
                    });
                }
                return this._actualMinimumValueChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMaximumValueChange", {
            get: function () {
                var _this = this;
                if (this._actualMaximumValueChange == null) {
                    this._actualMaximumValueChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMaximumValue;
                        if (_this.beforeActualMaximumValueChange) {
                            _this.beforeActualMaximumValueChange(_this, ext);
                        }
                        _this._actualMaximumValueChange.emit(ext);
                    });
                }
                return this._actualMaximumValueChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualIntervalChange == null) {
                    this._actualIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualInterval;
                        if (_this.beforeActualIntervalChange) {
                            _this.beforeActualIntervalChange(_this, ext);
                        }
                        _this._actualIntervalChange.emit(ext);
                    });
                }
                return this._actualIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMinorIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualMinorIntervalChange == null) {
                    this._actualMinorIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMinorInterval;
                        if (_this.beforeActualMinorIntervalChange) {
                            _this.beforeActualMinorIntervalChange(_this, ext);
                        }
                        _this._actualMinorIntervalChange.emit(ext);
                    });
                }
                return this._actualMinorIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        IgxNumericAxisBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAxisBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxNumericAxisBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxNumericAxisBaseComponent, selector: "ng-component", inputs: { minimumValue: "minimumValue", actualMinimumValue: "actualMinimumValue", actualVisibleMinimumValue: "actualVisibleMinimumValue", maximumValue: "maximumValue", actualMaximumValue: "actualMaximumValue", actualVisibleMaximumValue: "actualVisibleMaximumValue", interval: "interval", actualInterval: "actualInterval", minorInterval: "minorInterval", actualMinorInterval: "actualMinorInterval", referenceValue: "referenceValue", isLogarithmic: "isLogarithmic", actualIsLogarithmic: "actualIsLogarithmic", logarithmBase: "logarithmBase", abbreviateLargeNumbers: "abbreviateLargeNumbers" }, outputs: { actualMinimumValueChange: "actualMinimumValueChange", actualMaximumValueChange: "actualMaximumValueChange", actualIntervalChange: "actualIntervalChange", actualMinorIntervalChange: "actualMinorIntervalChange" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxNumericAxisBaseComponent;
    }(IgxAxisComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAxisBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { minimumValue: [{
                    type: i0.Input
                }], actualMinimumValue: [{
                    type: i0.Input
                }], actualVisibleMinimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }], actualMaximumValue: [{
                    type: i0.Input
                }], actualVisibleMaximumValue: [{
                    type: i0.Input
                }], interval: [{
                    type: i0.Input
                }], actualInterval: [{
                    type: i0.Input
                }], minorInterval: [{
                    type: i0.Input
                }], actualMinorInterval: [{
                    type: i0.Input
                }], referenceValue: [{
                    type: i0.Input
                }], isLogarithmic: [{
                    type: i0.Input
                }], actualIsLogarithmic: [{
                    type: i0.Input
                }], logarithmBase: [{
                    type: i0.Input
                }], abbreviateLargeNumbers: [{
                    type: i0.Input
                }], actualMinimumValueChange: [{
                    type: i0.Output
                }], actualMaximumValueChange: [{
                    type: i0.Output
                }], actualIntervalChange: [{
                    type: i0.Output
                }], actualMinorIntervalChange: [{
                    type: i0.Output
                }] } });

    /**
     * Defines a set of basic methods and properties used to create a StraightNumeric axis.
    */
    var IgxStraightNumericAxisBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStraightNumericAxisBaseComponent, _super);
        function IgxStraightNumericAxisBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxStraightNumericAxisBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStraightNumericAxisBaseComponent.prototype, "scaleMode", {
            /**
             * Gets or sets the axis scale mode.
            *
            * `scaleMode` can be used on numeric axes to allow scaling data values using built-in scalers. The available scalers are linear or logarithmic.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis
            *         scaleMode="logarithmic">
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
            * ```
            */
            get: function () {
                return this.i.l3;
            },
            set: function (v) {
                this.i.l3 = i2.ensureEnum(NumericScaleMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxStraightNumericAxisBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStraightNumericAxisBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStraightNumericAxisBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStraightNumericAxisBaseComponent, selector: "ng-component", inputs: { scaleMode: "scaleMode" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxStraightNumericAxisBaseComponent;
    }(IgxNumericAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStraightNumericAxisBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { scaleMode: [{
                    type: i0.Input
                }] } });

    /**
     * Represents a IgxDataChartComponent numeric Y axis.
    *
    * The `IgxNumericYAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the Y-axis. Location of labels varies according to the value in a data column that is mapped using the `YMemberPath` property for Scatter Series or `ValueMemberPath` property for Category Series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    var IgxNumericYAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxNumericYAxisComponent, _super);
        function IgxNumericYAxisComponent() {
            return _super.call(this) || this;
        }
        IgxNumericYAxisComponent.prototype.createImplementation = function () {
            return new NumericYAxis();
        };
        Object.defineProperty(IgxNumericYAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericYAxisComponent.prototype, "isVertical", {
            /**
             * Gets if the current axis is of vertical axis
            */
            get: function () {
                return this.i.cj;
            },
            enumerable: false,
            configurable: true
        });
        IgxNumericYAxisComponent.prototype.scrollRangeIntoView = function (minimum, maximum) {
            this.i.mm(minimum, maximum);
        };
        IgxNumericYAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxNumericYAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxNumericYAxisComponent, selector: "igx-numeric-y-axis", providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericYAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericYAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxNumericYAxisComponent;
    }(IgxStraightNumericAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-numeric-y-axis',
                        template: "",
                        providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericYAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericYAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Contains contextual information about a highlighting.
    */
    var IgxHighlightingInfo = /** @class */ /*@__PURE__*/ (function () {
        function IgxHighlightingInfo() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxHighlightingInfo.prototype.createImplementation = function () {
            return new HighlightingInfo();
        };
        Object.defineProperty(IgxHighlightingInfo.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxHighlightingInfo.prototype.onImplementationCreated = function () {
        };
        IgxHighlightingInfo.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxHighlightingInfo.prototype, "startIndex", {
            /**
             * The index of the first highlighted item.
            *
            * You can use `startIndex` to get or set the first highlighted item for the series.
            *
            * ```html
            * <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true" (assigningCategoryStyle)="assigningSeries($event)"   >
            * </igx-column-series>
            * ```
            */
            get: function () {
                return this.i.h;
            },
            set: function (v) {
                this.i.h = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "endIndex", {
            /**
             * The index of the last highlighted item.
            *
            * You can use the `endIndex` to get or set the last highlighted item for the series.
            *
            * ```html
            * <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
            *       </igx-column-series>
            * ```
            */
            get: function () {
                return this.i.g;
            },
            set: function (v) {
                this.i.g = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "state", {
            /**
             * The state of the highlighting.
            *
            * You can use the `state` to get or set the transitioning state of the highlighting, between In, Out, or Static.
            */
            get: function () {
                return this.i.a;
            },
            set: function (v) {
                this.i.a = i2.ensureEnum(HighlightingState_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "progress", {
            /**
             * A number between 0 and 1 representing the progress of the highlighting.
            *
            * You can use the `progress` property to set a number between 0 and 1 representing the progress of the highlighting.
            *
            * ```html
            * <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
            *       </igx-column-series>
            * ```
            */
            get: function () {
                return this.i.f;
            },
            set: function (v) {
                this.i.f = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "isMarker", {
            /**
             * True if this HighlightingInfo represents a marker highlighting.
            *
            * You can set the `isMarker` to True if the HighlightingInfo represents a marker highlighting. Otherwise set to false.
            *
            * ```html
            * <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
            *       </igx-column-series>
            * ```
            */
            get: function () {
                return this.i.e;
            },
            set: function (v) {
                this.i.e = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "isFullRange", {
            /**
             * True if this HighlightingInfo represents a full selection of the data.
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "isExclusive", {
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                this.i.c = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighlightingInfo.prototype, "series", {
            /**
             * The series in context.
            *
            * You can use the `series` property to get the series in context.
            *
            * ```html
            * <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
            *       </igx-column-series>
            * ```
            */
            get: function () {
                if (this.i.b == null) {
                    return null;
                }
                if (!this.i.b.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.b);
                    if (e) {
                        e._implementation = this.i.b;
                    }
                    this.i.b.externalObject = e;
                }
                return this.i.b.externalObject;
            },
            set: function (v) {
                v == null ? this.i.b = null : this.i.b = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxHighlightingInfo.prototype.findByName = function (name) {
            if (this.series && this.series.name && this.series.name == name) {
                return this.series;
            }
            return null;
        };
        return IgxHighlightingInfo;
    }());

    /**
     * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
    */
    var IgxAssigningSeriesStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function () {
        function IgxAssigningSeriesStyleEventArgsBase() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxAssigningSeriesStyleEventArgsBase.prototype.createImplementation = function () {
            return null;
        };
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxAssigningSeriesStyleEventArgsBase.prototype.onImplementationCreated = function () {
        };
        IgxAssigningSeriesStyleEventArgsBase.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "startIndex", {
            /**
             * Gets the start index
            */
            get: function () {
                return this.i.o;
            },
            set: function (v) {
                this.i.o = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "endIndex", {
            /**
             * Gets the end index
            */
            get: function () {
                return this.i.n;
            },
            set: function (v) {
                this.i.n = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "startDate", {
            /**
             * Gets the start date, if applicable
            */
            get: function () {
                return this.i.h;
            },
            set: function (v) {
                this.i.h = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "endDate", {
            /**
             * Gets the end date, if applicable
            */
            get: function () {
                return this.i.g;
            },
            set: function (v) {
                this.i.g = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "getItems", {
            /**
             * Gets a function that will return the items associated with this event.
            */
            get: function () {
                return this.i.a;
            },
            set: function (v) {
                this.i.a = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "fill", {
            /**
             * Gets or sets fill brush to use for the current item.
            */
            get: function () {
                return i2.brushToString(this.i.p);
            },
            set: function (v) {
                this.i.p = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "stroke", {
            /**
             * Gets or sets stroke to use for the current item.
            */
            get: function () {
                return i2.brushToString(this.i.q);
            },
            set: function (v) {
                this.i.q = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "opacity", {
            /**
             * Gets or sets opacity to use for the current item.
            */
            get: function () {
                return this.i.k;
            },
            set: function (v) {
                this.i.k = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "fadeOpacity", {
            /**
             * Gets or sets opacity to use for the current item.
            */
            get: function () {
                return this.i.i;
            },
            set: function (v) {
                this.i.i = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "highlightingInfo", {
            /**
             * Gets or sets highlighting info
            */
            get: function () {
                if (this.i.b == null) {
                    return null;
                }
                if (!this.i.b.externalObject) {
                    var e = new IgxHighlightingInfo();
                    e._implementation = this.i.b;
                    this.i.b.externalObject = e;
                }
                return this.i.b.externalObject;
            },
            set: function (v) {
                v == null ? this.i.b = null : this.i.b = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "maxAllSeriesHighlightingProgress", {
            /**
             * Gets the max highlighting progress from all series.
            */
            get: function () {
                return this.i.j;
            },
            set: function (v) {
                this.i.j = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "sumAllSeriesHighlightingProgress", {
            /**
             * Gets the sum of highlighting progress from all series.
            */
            get: function () {
                return this.i.l;
            },
            set: function (v) {
                this.i.l = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "totalAllSeriesHighlightingProgress", {
            /**
             * Gets the average of highlighting progress from all the series.
            */
            get: function () {
                return this.i.m;
            },
            set: function (v) {
                this.i.m = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "highlightingHandled", {
            /**
             * Gets or sets if highlighting was handled by this event handler, and whether internal highlighting logic should be skipped.
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "hasDateRange", {
            /**
             * Gets if this event has a valid date range
            */
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                this.i.c = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "isNegativeShape", {
            /**
             * Gets if the current shape is identified as a negative shape if this series supports discrete negative shapes.
            */
            get: function () {
                return this.i.e;
            },
            set: function (v) {
                this.i.e = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesStyleEventArgsBase.prototype, "isThumbnail", {
            /**
             * Gets if the current event is being raised for the thumbnail image.
            */
            get: function () {
                return this.i.f;
            },
            set: function (v) {
                this.i.f = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxAssigningSeriesStyleEventArgsBase.prototype.findByName = function (name) {
            if (this.highlightingInfo && this.highlightingInfo.name && this.highlightingInfo.name == name) {
                return this.highlightingInfo;
            }
            return null;
        };
        return IgxAssigningSeriesStyleEventArgsBase;
    }());

    /**
     * Represents event arguments class for the AssigningCategoryStyleEvent
    */
    var IgxAssigningSeriesShapeStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningSeriesShapeStyleEventArgsBase, _super);
        function IgxAssigningSeriesShapeStyleEventArgsBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "strokeThickness", {
            /**
             * Gets or sets stroke thickness to use for the current item.
            */
            get: function () {
                return this.i.t;
            },
            set: function (v) {
                this.i.t = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "radiusX", {
            /**
             * Gets or sets corner radius X to use for the current item, if applicable.
            */
            get: function () {
                return this.i.r;
            },
            set: function (v) {
                this.i.r = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "radiusY", {
            /**
             * Gets or sets corner radius Y to use for the current item, if applicable.
            */
            get: function () {
                return this.i.s;
            },
            set: function (v) {
                this.i.s = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningSeriesShapeStyleEventArgsBase;
    }(IgxAssigningSeriesStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningCategoryStyleEvent
    *
    * The `AssigningCategoryStyle` event fired to allow you to override the style of items in a category or financial series
    */
    var IgxAssigningCategoryStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningCategoryStyleEventArgs, _super);
        function IgxAssigningCategoryStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningCategoryStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningCategoryStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningCategoryStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningCategoryStyleEventArgs;
    }(IgxAssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
    */
    var IgxAssigningCategoryStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningCategoryStyleEventArgsBase, _super);
        function IgxAssigningCategoryStyleEventArgsBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAssigningCategoryStyleEventArgsBase.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningCategoryStyleEventArgsBase;
    }(IgxAssigningSeriesStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningCategoryStyleEvent
    *
    * The `assigningCategoryMarkerStyle` event fired to allow you to override the style of markers for the items in a category or financial series.
    */
    var IgxAssigningCategoryMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningCategoryMarkerStyleEventArgs, _super);
        function IgxAssigningCategoryMarkerStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningCategoryMarkerStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningCategoryMarkerStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningCategoryMarkerStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningCategoryMarkerStyleEventArgs;
    }(IgxAssigningCategoryStyleEventArgsBase));

    /**
     * Represents the base class for series containing markers.
    *
    * MarkerSeries represents the base class for series containing markers.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    *         label="label"
    *         #xAxis
    *         >
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    *       </igx-numeric-y-axis>
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *      valueMemberPath="value">
    *      </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series: IgxMarkerSeriesComponent = new IgxMarkerSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxMarkerSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMarkerSeriesComponent, _super);
        function IgxMarkerSeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "hasMarkers", {
            /**
             * Returns whether the current series supports visual markers.
            *
            * `hasMarkers` property is overriden, it returns whether the current series supports visual markers. You can use it like this:
            *
            * ```ts
            *  let gotMarkers: boolean = this.series.hasMarkers;
            * ```
            */
            get: function () {
                return this.i.hasMarkers;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerType", {
            /**
             * Gets or sets the marker type for the current series object.
             * This property is ignored when the MarkerTemplate property is set
            *
            * `markerType` property gets or sets the marker type for the current series object. For example, you can set it like this:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	 <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            * 	 <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *      valueMemberPath="value"
            * 	 markerType = "circle">
            *      </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.markerType = "circle";
            * ```
            */
            get: function () {
                return this.i.pr;
            },
            set: function (v) {
                this.i.pr = i2.ensureEnum(MarkerType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerOutlineMode", {
            /**
             * Gets or sets whether the marker outline is based on the marker brush of the series rather than the marker outlines collection.
            */
            get: function () {
                return this.i.po;
            },
            set: function (v) {
                this.i.po = i2.ensureEnum(MarkerOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerFillMode", {
            /**
             * Gets or sets whether the marker fill is based on the marker outline of the series rather than the marker brushes collection.
            */
            get: function () {
                return this.i.pk;
            },
            set: function (v) {
                this.i.pk = i2.ensureEnum(MarkerFillMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerTemplate", {
            /**
             * Gets or sets the MarkerTemplate for the current series object.
            *
            * `markerTemplate` property gets or sets the MarkerTemplate for the current series object. For example, you can use it like this:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis #yAxis>
            *       </igx-numeric-y-axis>
            * 	 <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *      valueMemberPath="value"
            * 	 markerTemplate="circleMarkerTemplate">
            *      </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.qd;
            },
            set: function (v) {
                this.i.qd = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerThickness", {
            /**
             * Gets or sets thickness of the marker outline
            */
            get: function () {
                return this.i.pw;
            },
            set: function (v) {
                this.i.pw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "actualMarkerTemplate", {
            /**
             * Gets the effective marker template for the current series object.
            *
            * `actualMarkerTemplate` property gets the effective marker template for the current series object. You can use it like this:
            *
            * ```ts
            *  let effectiveMarkerTemplate: IgxDataTemplate = this.series.actualMarkerTemplate;
            * ```
            */
            get: function () {
                return this.i.qb;
            },
            set: function (v) {
                this.i.qb = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerBrush", {
            /**
             * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
            *
            * `markerBrush` property gets or sets the brush that specifies how the current series object's marker interiors are painted. You can use it like this:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis #yAxis>
            *       </igx-numeric-y-axis>
            * 	 <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *      valueMemberPath="value"
            * 	 markerBrush = "blue">
            *      </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.markerBrush = "red";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.qt);
            },
            set: function (v) {
                this.i.qt = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "actualMarkerBrush", {
            /**
             * Gets the effective marker brush for the current series object.
            *
            * `actualMarkerBrush` property gets the effective marker brush for the current series object. For example, you can use it like this:
            *
            * ```ts
            *  let effectiveMarkerBrush: string = this.series.actualMarkerBrush;
            *
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.qr);
            },
            set: function (v) {
                this.i.qr = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "markerOutline", {
            /**
             * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
            *
            * `markerOutline` property gets or sets the brush that specifies how the current series object's marker outlines are painted. You can use it like this:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis #yAxis>
            *       </igx-numeric-y-axis>
            * 	 <igx-column-series
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *      valueMemberPath="value"
            * 	 markerOutline = "blue">
            *      </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.markerOutline = "red";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.qu);
            },
            set: function (v) {
                this.i.qu = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarkerSeriesComponent.prototype, "actualMarkerOutline", {
            /**
             * Gets the effective marker outline for the current series object.
            *
            *     `ActualMarkerOutline` property gets the effective marker outline for the current series object. You can use it like this:
            *
            * ```ts
            *  let effectiveMarkerOutline: string = this.series.actualMarkerOutline;
            *
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.qs);
            },
            set: function (v) {
                this.i.qs = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxMarkerSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarkerSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxMarkerSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxMarkerSeriesComponent, selector: "ng-component", inputs: { markerType: "markerType", markerOutlineMode: "markerOutlineMode", markerFillMode: "markerFillMode", markerTemplate: "markerTemplate", markerThickness: "markerThickness", actualMarkerTemplate: "actualMarkerTemplate", markerBrush: "markerBrush", actualMarkerBrush: "actualMarkerBrush", markerOutline: "markerOutline", actualMarkerOutline: "actualMarkerOutline" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxMarkerSeriesComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarkerSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { markerType: [{
                    type: i0.Input
                }], markerOutlineMode: [{
                    type: i0.Input
                }], markerFillMode: [{
                    type: i0.Input
                }], markerTemplate: [{
                    type: i0.Input
                }], markerThickness: [{
                    type: i0.Input
                }], actualMarkerTemplate: [{
                    type: i0.Input
                }], markerBrush: [{
                    type: i0.Input
                }], actualMarkerBrush: [{
                    type: i0.Input
                }], markerOutline: [{
                    type: i0.Input
                }], actualMarkerOutline: [{
                    type: i0.Input
                }] } });

    /**
     * Represents the base class for IgxDataChartComponent category series.
    *
    * `IgxCategorySeriesComponent` class represents the base class for IgxDataChartComponent category series.
    *
    * ```html
    *     <igx-data-chart [dataSource]="data" >
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    *       <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isTransitionInEnabled="true">
    *       </igx-column-series>
    *     </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxCategorySeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategorySeriesComponent, _super);
        function IgxCategorySeriesComponent() {
            var _this = _super.call(this) || this;
            _this._assigningCategoryStyle = null;
            _this._assigningCategoryMarkerStyle = null;
            return _this;
        }
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "isCategory", {
            /**
             * Gets whether or not this series is Category series
            */
            get: function () {
                return this.i.da;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "isCustomCategoryStyleAllowed", {
            /**
             * Gets or sets whether this category series should allow custom style overrides of its individual visuals.
            */
            get: function () {
                return this.i.rt;
            },
            set: function (v) {
                this.i.rt = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "isCustomCategoryMarkerStyleAllowed", {
            /**
             * Gets or sets whether this category series should allow custom style overrides of its individual marker visuals.
            */
            get: function () {
                return this.i.rs;
            },
            set: function (v) {
                this.i.rs = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "useHighMarkerFidelity", {
            /**
             * Sets or Gets whether to increase marker fidelity for extreme data shapes that have lots of Y variation over short X intervals.
            *
            * Set `useHighMarkerFidelity` when your data has high variation along the y-axis within a short span of this x-axis.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         markerType="circle"
            *         useHighMarkerFidelity="true">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath= "value";
            * series.useHighMarkerFidelity= "true";
            * this.chart.series.add(series);
            * ```
            *
            * ```ts
            *       this.columnSeries2.useHighMarkerFidelity= "true";
            * ```
            */
            get: function () {
                return this.i.ry;
            },
            set: function (v) {
                this.i.ry = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "transitionInMode", {
            /**
             * Gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
             * Note: Transitions are not currently supported for stacked series.
            *
            * `transitionInMode` controls the direction of the transition-in animation.
            *
            * ```html
            *     <igx-data-chart
            *       [dataSource]="data" >
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis #yAxis>
            *       </igx-numeric-y-axis>
            *
            *       <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isTransitionInEnabled="true"
            *         transitionInMode="accordionfromRight">
            *       </igx-column-series>
            *     </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath="value";
            * series.transitionInMode="accordionfromRight";
            * this.chart.series.add(series);
            * ```
            *
            * ```ts
            *
            * 	this.columnSeries2.transitionInMode= "accordionfromRight";
            * ```
            */
            get: function () {
                return this.i.re;
            },
            set: function (v) {
                this.i.re = i2.ensureEnum(CategoryTransitionInMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "isTransitionInEnabled", {
            /**
             * Gets or sets whether the series should transition into the plot area when a new data source is assigned.
             * Note: Transitions are not currently supported for stacked series.
            *
            * Set `isTransitionInEnabled` to true if you want your chart series to animate into position when the chart is loading into view.
            *
            * ```html
            *     <igx-data-chart [dataSource]="data" >
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis #yAxis>
            *       </igx-numeric-y-axis>
            *
            *       <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isTransitionInEnabled="true">
            *       </igx-column-series>
            *     </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath="value";
            * series.isTransitionInEnabled="true";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.ru;
            },
            set: function (v) {
                this.i.ru = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
        IgxCategorySeriesComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        */
        IgxCategorySeriesComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxCategorySeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the index of the item based on world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxCategorySeriesComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
        IgxCategorySeriesComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "assigningCategoryStyle", {
            /**
             * Event raised when Assigning Category Style
            */
            get: function () {
                var _this = this;
                if (this._assigningCategoryStyle == null) {
                    this._assigningCategoryStyle = new i0.EventEmitter();
                    this.i.assigningCategoryStyle = i2.delegateCombine(this.i.assigningCategoryStyle, function (o, e) {
                        var outerArgs = new IgxAssigningCategoryStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningCategoryStyle) {
                            _this.beforeAssigningCategoryStyle(_this, outerArgs);
                        }
                        _this._assigningCategoryStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningCategoryStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategorySeriesComponent.prototype, "assigningCategoryMarkerStyle", {
            /**
             * Event raised when Assigning Category Marker Style
            */
            get: function () {
                var _this = this;
                if (this._assigningCategoryMarkerStyle == null) {
                    this._assigningCategoryMarkerStyle = new i0.EventEmitter();
                    this.i.assigningCategoryMarkerStyle = i2.delegateCombine(this.i.assigningCategoryMarkerStyle, function (o, e) {
                        var outerArgs = new IgxAssigningCategoryMarkerStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningCategoryMarkerStyle) {
                            _this.beforeAssigningCategoryMarkerStyle(_this, outerArgs);
                        }
                        _this._assigningCategoryMarkerStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningCategoryMarkerStyle;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategorySeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategorySeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategorySeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategorySeriesComponent, selector: "ng-component", inputs: { isCustomCategoryStyleAllowed: "isCustomCategoryStyleAllowed", isCustomCategoryMarkerStyleAllowed: "isCustomCategoryMarkerStyleAllowed", useHighMarkerFidelity: "useHighMarkerFidelity", transitionInMode: "transitionInMode", isTransitionInEnabled: "isTransitionInEnabled" }, outputs: { assigningCategoryStyle: "assigningCategoryStyle", assigningCategoryMarkerStyle: "assigningCategoryMarkerStyle" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxCategorySeriesComponent;
    }(IgxMarkerSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategorySeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { isCustomCategoryStyleAllowed: [{
                    type: i0.Input
                }], isCustomCategoryMarkerStyleAllowed: [{
                    type: i0.Input
                }], useHighMarkerFidelity: [{
                    type: i0.Input
                }], transitionInMode: [{
                    type: i0.Input
                }], isTransitionInEnabled: [{
                    type: i0.Input
                }], assigningCategoryStyle: [{
                    type: i0.Output
                }], assigningCategoryMarkerStyle: [{
                    type: i0.Output
                }] } });

    /**
     * Represents the base class for all IgxDataChartComponent anchored category/value series.
    *
    * The `IgxAnchoredCategorySeriesComponent` represents the base class for all IgxDataChartComponent anchored category/value series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle" >
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    var IgxAnchoredCategorySeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAnchoredCategorySeriesComponent, _super);
        function IgxAnchoredCategorySeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "valueMemberPath", {
            /**
             * Gets or sets the value mapping property for the current series object.
            *
            * The `valueMemberPath` property is used for the value mapping property of the current series object.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value" >
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.tb;
            },
            set: function (v) {
                this.i.tb = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the trend type for the current series object.
            *
            * The `trendLineType` property is used for the current series object's trend type.'
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         markerType="circle"
            *         trendLineType="simpleAverage" >
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.trendLineType= "CubicFit";
            * ```
            */
            get: function () {
                return this.i.trendLineType;
            },
            set: function (v) {
                this.i.trendLineType = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the brush to use to draw the trend line.
            *
            * The `trendLineBrush` property is used to brush the trend line.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         markerType="circle"
            *         trendLineBrush= "grey"	>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.trendLineBrush="red";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.trendLineBrush);
            },
            set: function (v) {
                this.i.trendLineBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "actualTrendLineBrush", {
            /**
             * Gets the effective TrendLineBrush for this series.
            *
            * The `actualTrendLineBrush` property is used to gets the effective `trendLineBrush` for this series.
            */
            get: function () {
                return i2.brushToString(this.i.tt);
            },
            set: function (v) {
                this.i.tt = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the current series object's trend line.
            *
            * The `trendLineThickness` property is used for thickness of the current series object's trend line.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         markerType="circle"
            * 		trendLineThickness= 2  >
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.trendLineThickness= 2;
            * ```
            */
            get: function () {
                return this.i.trendLineThickness;
            },
            set: function (v) {
                this.i.trendLineThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the trend line period for the current series.
             * The typical, and initial, value for trend line period is 7.
            *
            * The `trendLinePeriod` property is used for trend line period of the current series.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         markerType="circle"
            *         trendLinePeriod: "7">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.trendLinePeriod= 7;
            * ```
            */
            get: function () {
                return this.i.trendLinePeriod;
            },
            set: function (v) {
                this.i.trendLinePeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "markerCollisionAvoidance", {
            /**
             * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
            *
            * The `markerCollisionAvoidance` property controls the technique the chart uses to avoid overlapping markers.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         markerType="circle"
            * 		markerCollisionAvoidance= "fade"
            *         >
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.sx;
            },
            set: function (v) {
                this.i.sx = i2.ensureEnum(CategorySeriesMarkerCollisionAvoidance_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredCategorySeriesComponent.prototype, "consolidatedItemHitTestBehavior", {
            /**
             * Determines the item returned in hit-testing when the pointer is over an object which represents several consolidated items.
            *
            * The `consolidatedItemHitTestBehavior` property is used to determines returned item in hit-testing when the pointer is over an object which represents several consolidated items.
            */
            get: function () {
                return this.i.sy;
            },
            set: function (v) {
                this.i.sy = i2.ensureEnum(ConsolidatedItemHitTestBehavior_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxAnchoredCategorySeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        *
        * The `scrollIntoView` method is used to notifies the target axis or series that it should scroll the requested data item into view.
        *
        * ```ts
        * this.series.scrollIntoView(dataItem);
        * ```
        */
        IgxAnchoredCategorySeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        *
        * The `getItem` method is used to gets the item that is the best match for the specified world coordinates.
        *
        * ```ts
        * let item: number = this.series.getItem({x:.5,y:.5});
        * ```
        */
        IgxAnchoredCategorySeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        IgxAnchoredCategorySeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnchoredCategorySeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAnchoredCategorySeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAnchoredCategorySeriesComponent, selector: "ng-component", inputs: { valueMemberPath: "valueMemberPath", trendLineType: "trendLineType", trendLineBrush: "trendLineBrush", actualTrendLineBrush: "actualTrendLineBrush", trendLineThickness: "trendLineThickness", trendLinePeriod: "trendLinePeriod", markerCollisionAvoidance: "markerCollisionAvoidance", consolidatedItemHitTestBehavior: "consolidatedItemHitTestBehavior" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxAnchoredCategorySeriesComponent;
    }(IgxCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnchoredCategorySeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { valueMemberPath: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], actualTrendLineBrush: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], markerCollisionAvoidance: [{
                    type: i0.Input
                }], consolidatedItemHitTestBehavior: [{
                    type: i0.Input
                }] } });

    /**
     * Base class for anchored category series with a category x-axis and a numeric y-axis.
    *
    * Instantiate HorizontalAnchoredCategorySeries
    *
    * ```html
    *  <igx-data-chart
    *       [dataSource]="data"  >
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *           >
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxHorizontalAnchoredCategorySeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxHorizontalAnchoredCategorySeriesComponent, _super);
        function IgxHorizontalAnchoredCategorySeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxHorizontalAnchoredCategorySeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalAnchoredCategorySeriesComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for this series.
            *
            * Instantiate xAxis
            *
            * <!-- Angular -->
            *
            * ```js
            *  <igx-data-chart
            *       [dataSource]="data"  >
            * 	  <igx-category-x-axis
            *         label="label"
            *         #xAxis
            *         >
            *       </igx-category-x-axis>
            * 	 <igx-column-series
            *     ...
            *         [xAxis]="xAxis"
            *     ...
            *           >
            *       </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath="value";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                if (this.i.xAxis == null) {
                    return null;
                }
                if (!this.i.xAxis.externalObject) {
                    var e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.xAxis);
                    if (e) {
                        e._implementation = this.i.xAxis;
                    }
                    this.i.xAxis.externalObject = e;
                }
                return this.i.xAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalAnchoredCategorySeriesComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for this series.
            *
            * Instantiate yAxis
            *
            * <!-- Angular -->
            *
            * ```js
            *  <igx-data-chart
            *       [dataSource]="data"  >
            * 	  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            *       </igx-numeric-y-axis>
            * 	 <igx-column-series
            *     ...
            *         [yAxis]="yAxis"
            *     ...
            *           >
            *       </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath="value";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                if (this.i.yAxis == null) {
                    return null;
                }
                if (!this.i.yAxis.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
                    if (e) {
                        e._implementation = this.i.yAxis;
                    }
                    this.i.yAxis.externalObject = e;
                }
                return this.i.yAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxHorizontalAnchoredCategorySeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        *
        * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
        *
        * <!-- Angular JS -->
        *
        *     var x = financialSeries.GetSeriesValueMarkerBoundingBox(new IgxPoint());
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getSeriesValueMarkerBoundingBox = function (world) {
            var iv = this.i.pd(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        *
        * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
        *
        * <!-- Angular JS -->
        *
        *       var g = series.getOffsetValue();
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        *
        * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        */
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.t4(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        IgxHorizontalAnchoredCategorySeriesComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.t5(axis);
            return (iv);
        };
        IgxHorizontalAnchoredCategorySeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxHorizontalAnchoredCategorySeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxHorizontalAnchoredCategorySeriesComponent, selector: "ng-component", inputs: { xAxis: "xAxis", yAxis: "yAxis" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxHorizontalAnchoredCategorySeriesComponent;
    }(IgxAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalAnchoredCategorySeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PointSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointSeries, _super);
        function PointSeries() {
            var _this = _super.call(this) || this;
            _this.ab = PointSeries.$;
            return _this;
        }
        PointSeries.prototype.get_c0 = function () {
            return true;
        };
        PointSeries.prototype.bu = function () {
            return new PointSeriesView(this);
        };
        PointSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.uf = a;
        };
        PointSeries.prototype.gi = function () {
            return 0.7;
        };
        PointSeries.prototype.pl = function () {
            if (this.pk == 0) {
                return 2;
            }
            return _super.prototype.pl.call(this);
        };
        PointSeries.prototype.ep = function (a, b) {
            var c = this.o2(this.o5(a), true, false);
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        PointSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
        };
        Object.defineProperty(PointSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        PointSeries.$t = i2.markType(PointSeries, 'PointSeries', HorizontalAnchoredCategorySeries.$);
        return PointSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var PointSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointSeriesView, _super);
        function PointSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.da = a;
            return _this;
        }
        PointSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
        };
        PointSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 2;
            this.e.gl = 2;
            this.e.e1 = false;
        };
        PointSeriesView.$t = i2.markType(PointSeriesView, 'PointSeriesView', AnchoredCategorySeriesView.$);
        return PointSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent point series.
    *
    * You can use the `IgxPointSeriesComponent` plot a value along a category or date.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis
    * 		#yAxis>
    *     <igx-numeric-y-axis>
    *     </igx-numeric-y-axis>
    *     <igx-point-series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		valueMemberPath="coal">
    *     </igx-point-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series: IgxPointSeriesComponent = new IgxPointSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "coal";
    * this.chart.series.add(series);
    * ```
    */
    var IgxPointSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPointSeriesComponent, _super);
        function IgxPointSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxPointSeriesComponent.prototype.createImplementation = function () {
            return new PointSeries();
        };
        Object.defineProperty(IgxPointSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPointSeriesComponent.prototype, "hasOnlyMarkers", {
            /**
             * Gets whether the series has only marker as visuals
            */
            get: function () {
                return this.i.c0;
            },
            enumerable: false,
            configurable: true
        });
        IgxPointSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPointSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPointSeriesComponent, selector: "igx-point-series", providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPointSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-point-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPointSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPointSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPointSeriesModule() {
        }
        IgxPointSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPointSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesModule, declarations: [IgxPointSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxPointSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxPointSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxPointSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPointSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxPointSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPointSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPointSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPointSeriesComponent", IgxPointSeriesComponent);
            i2.TypeRegistrar.register("PointSeries", PointSeries.$type);
        }
        IgxPointSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPointSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesDynamicModule, imports: [i1.CommonModule, IgxPointSeriesModule], exports: [IgxPointSeriesModule] });
        IgxPointSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesDynamicModule, imports: [[i1.CommonModule, IgxPointSeriesModule], IgxPointSeriesModule] });
        return IgxPointSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPointSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPointSeriesModule],
                        exports: [IgxPointSeriesModule],
                        entryComponents: [IgxPointSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryLineRasterizer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryLineRasterizer, _super);
        function CategoryLineRasterizer() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = false;
            _this.n = new i2.PointCollection(0);
            return _this;
        }
        Object.defineProperty(CategoryLineRasterizer.prototype, "o", {
            get: function () {
                return this.n;
            },
            set: function (a) {
                this.n = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryLineRasterizer.prototype.m = function (a, b, c, d, e, f, g, h, i, j) {
            var k = new i2.PathGeometry();
            var l = new i2.PathGeometry();
            var m = new i2.PathGeometry();
            a.ak = k;
            b.ak = l;
            c.ak = m;
            k.c = new i2.PathFigureCollection();
            l.c = new i2.PathFigureCollection();
            m.c = new i2.PathFigureCollection();
            var n = new i2.List$1(i2.PolyLineSegment.$, 0);
            var o = new i2.List$1(i2.PolyLineSegment.$, 0);
            var p = new i2.List$1(i2.PolyLineSegment.$, 0);
            var q = new i2.List$1(i2.PolyLineSegment.$, 0);
            if (g == 0 || g == 1) {
                var r = g == 1 ? h : null;
                var s = 0;
                for (var t = 0; t < d; t++) {
                    if (i2.isNaN_(e._inner[t][1])) {
                        var u = t - s;
                        var v = (g == 0 && u > 0) || (g == 1 && u > 1);
                        if (v) {
                            if (g == 1 || n.count == 0) {
                                var w = new i2.PolyLineSegment();
                                var x = new i2.PolyLineSegment();
                                var y = new i2.PolyLineSegment();
                                var z = new i2.PolyLineSegment();
                                n.add(w);
                                o.add(x);
                                p.add(y);
                                q.add(z);
                            }
                            this.l(n._inner[n.count - 1]._points, o._inner[o.count - 1]._points, p._inner[p.count - 1]._points, q._inner[q.count - 1]._points, s, t - 1, e, f, r, i, j);
                        }
                        s = t + 1;
                    }
                }
                if (g == 1 || n.count == 0) {
                    var aa = new i2.PolyLineSegment();
                    var ab = new i2.PolyLineSegment();
                    var ac = new i2.PolyLineSegment();
                    var ad = new i2.PolyLineSegment();
                    n.add(aa);
                    o.add(ad);
                    p.add(ab);
                    q.add(ac);
                }
                this.l(n._inner[n.count - 1]._points, o._inner[o.count - 1]._points, p._inner[p.count - 1]._points, q._inner[q.count - 1]._points, s, d - 1, e, f, r, i, j);
                if (r == null && n.count == 1 && h != null) {
                    this.d(n._inner[0], h);
                    if (o.count == 1) {
                        this.d(o._inner[0], h);
                    }
                }
            }
            else {
                n.add(new i2.PolyLineSegment());
                o.add(new i2.PolyLineSegment());
                p.add(new i2.PolyLineSegment());
                q.add(new i2.PolyLineSegment());
                this.k(n._inner[0]._points, o._inner[0]._points, p._inner[0]._points, q._inner[0]._points, d, e, f, h, i, j);
            }
            var _loop_1 = function (ae) {
                var e_1, _a;
                var af = n._inner[ae];
                var ag = o._inner[ae];
                var ah = p._inner[ae];
                var ai = q._inner[ae];
                if (af._points.count > 0) {
                    var aj = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = af._points._inner[0];
                        return $ret;
                    })());
                    aj._segments.add(af);
                    k.c.add(aj);
                }
                if (ag._points.count > 0) {
                    var ak = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = ag._points._inner[0];
                        return $ret;
                    })());
                    ak._segments.add(ag);
                    m.c.add(ak);
                }
                if (ah._points.count > 0 && ai._points.count > 0) {
                    var al_1 = new i2.PolyLineSegment();
                    if (h != null) {
                        var am = h.f;
                        h.f = true;
                        h.i = al_1._points;
                        h.k(ah._points, false);
                        h.k(ai._points, true);
                        h.i = null;
                        h.f = am;
                    }
                    else {
                        try {
                            for (var _b = (e_1 = void 0, tslib.__values(i2.fromEnum(ah._points))), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var an = _c.value;
                                al_1._points.add(an);
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                        for (var ao = ai._points.count - 1; ao >= 0; ao--) {
                            al_1._points.add(ai._points._inner[ao]);
                        }
                    }
                    if (al_1._points.count > 0) {
                        var ap = ((function () {
                            var $ret = new i2.PathFigure();
                            $ret.startPoint = al_1._points._inner[0];
                            return $ret;
                        })());
                        ap._segments.add(al_1);
                        l.c.add(ap);
                    }
                }
            };
            for (var ae = 0; ae < n.count; ae++) {
                _loop_1(ae);
            }
        };
        CategoryLineRasterizer.prototype.d = function (a, b) {
            var c = a._points;
            a._points = new i2.PointCollection(0);
            b.i = a._points;
            b.k(c, false);
            b.i = null;
        };
        CategoryLineRasterizer.prototype.k = function (a, b, c, d, e, f, g, h, i, j) {
            this.l(a, b, c, d, 0, e - 1, f, g, h, i, j);
        };
        CategoryLineRasterizer.prototype.e = function (a, b, c, d, e, f, g) {
            var h = i2.FastFlattener.a(new i2.List$1(i2.Number_$type, 0), d, e, f, b, c, g);
            var i = i2.ArrayAccessHelper.c(h);
            var j = i2.ArrayAccessHelper.a(d);
            var k = i != null;
            var l = j != null;
            var m = 0;
            var n = h.count;
            var o;
            var p;
            var q;
            if (e) {
                for (var r = 0; r < n; r++) {
                    m = k ? i[r] : h.item(r);
                    o = l ? j[m] : d._inner[m];
                    p = o[0];
                    q = o[1];
                    var s = { $type: i2.Point_$type, x: p, y: q };
                    a.add(s);
                }
            }
            else if (f) {
                for (var t = 0; t < n; t++) {
                    m = k ? i[t] : h.item(t);
                    o = l ? j[m] : d._inner[m];
                    p = o[0];
                    q = o[2];
                    var u = { $type: i2.Point_$type, x: p, y: q };
                    a.add(u);
                }
            }
            else {
                for (var v = 0; v < n; v++) {
                    m = k ? i[v] : h.item(v);
                    o = l ? j[m] : d._inner[m];
                    p = o[2];
                    q = o[3];
                    var w = { $type: i2.Point_$type, x: p, y: q };
                    a.add(w);
                }
            }
        };
        CategoryLineRasterizer.prototype.b = function (a, b, c, d) {
            c.i = a;
            c.k(b, false);
            c.i = null;
        };
        CategoryLineRasterizer.prototype.c = function (a, b, c, d, e) {
            var f = c.f;
            c.f = e;
            this.b(a, b, c, d);
            c.f = f;
        };
        CategoryLineRasterizer.prototype.l = function (a, b, c, d, e, f, g, h, i, j, k) {
            if (f > -1) {
                if (j == 1 && !this.a) {
                    var l = new i2.PointCollection(0);
                    this.e(l, e, f, g, true, h, k);
                    if (i != null) {
                        this.b(a, l, i, k);
                    }
                    else {
                        this.f(a, l);
                    }
                }
                else {
                    var m = new i2.PointCollection(0);
                    var n = new i2.PointCollection(0);
                    this.e(m, e, f, g, true, h, k);
                    this.e(n, e, f, g, false, h, k);
                    this.f(c, m);
                    this.f(d, n);
                    if (i != null) {
                        this.b(a, m, i, k);
                        this.b(b, n, i, k);
                    }
                    else {
                        this.f(a, m);
                        this.f(b, n);
                    }
                }
            }
        };
        CategoryLineRasterizer.prototype.i = function (a, b, c, d, e, f, g, h, i, j, k) {
            this.j(a, b, c, d, e, f, g, h, i, j, k, null);
        };
        CategoryLineRasterizer.prototype.j = function (a, b, c, d, e, f, g, h, i, j, k, l) {
            var m = new i2.PathGeometry();
            var n = new i2.PathGeometry();
            var o = new i2.PathGeometry();
            var p = new i2.PathGeometry();
            a.ak = m;
            b.ak = n;
            c.ak = o;
            d.ak = p;
            m.c = new i2.PathFigureCollection();
            n.c = new i2.PathFigureCollection();
            o.c = new i2.PathFigureCollection();
            p.c = new i2.PathFigureCollection();
            var q = new i2.List$1(i2.PolyLineSegment.$, 0);
            var r = new i2.List$1(i2.PolyLineSegment.$, 0);
            var s = new i2.List$1(i2.PolyLineSegment.$, 0);
            var t = new i2.List$1(i2.PolyLineSegment.$, 0);
            if (k == 0 || k == 1) {
                var u = k == 1 ? l : null;
                var v = 0;
                for (var w = 0; w < e; w++) {
                    if (i2.isNaN_(f._inner[w][1])) {
                        var x = w - v;
                        var y = (k == 0 && x > 0) || (k == 1 && x > 1);
                        if (y) {
                            if (k == 1 || r.count == 0) {
                                var z = new i2.PolyLineSegment();
                                var aa = new i2.PolyLineSegment();
                                var ab = new i2.PolyLineSegment();
                                var ac = new i2.PolyLineSegment();
                                q.add(z);
                                r.add(aa);
                                s.add(ab);
                                t.add(ac);
                            }
                            var ad = void 0;
                            var ae = void 0;
                            var af = void 0;
                            var ag = void 0;
                            if (l != null && k == 1) {
                                ad = new i2.PointCollection(0);
                                ae = new i2.PointCollection(0);
                                af = new i2.PointCollection(0);
                                ag = new i2.PointCollection(0);
                            }
                            else {
                                ad = q._inner[q.count - 1]._points;
                                ae = r._inner[r.count - 1]._points;
                                af = s._inner[s.count - 1]._points;
                                ag = t._inner[t.count - 1]._points;
                            }
                            this.g(ad, ae, af, ag, v, w - 1, f, g, null, h, i);
                            if (k == 1) {
                                j(ad, ae, af, ag, false);
                                if (l != null) {
                                    this.c(q._inner[q.count - 1]._points, ad, l, i, true);
                                    this.c(r._inner[r.count - 1]._points, ae, l, i, false);
                                    this.c(s._inner[s.count - 1]._points, af, l, i, true);
                                    this.c(t._inner[t.count - 1]._points, ag, l, i, false);
                                }
                            }
                        }
                        v = w + 1;
                    }
                }
                if (k == 1 || r.count == 0) {
                    var ah = new i2.PolyLineSegment();
                    var ai = new i2.PolyLineSegment();
                    var aj = new i2.PolyLineSegment();
                    var ak = new i2.PolyLineSegment();
                    q.add(ah);
                    r.add(ai);
                    s.add(aj);
                    t.add(ak);
                }
                var al = void 0;
                var am = void 0;
                var an = void 0;
                var ao = void 0;
                if (l != null) {
                    al = new i2.PointCollection(0);
                    this.f(al, q._inner[q.count - 1]._points);
                    am = new i2.PointCollection(0);
                    this.f(am, r._inner[r.count - 1]._points);
                    an = new i2.PointCollection(0);
                    this.f(an, s._inner[s.count - 1]._points);
                    ao = new i2.PointCollection(0);
                    this.f(ao, t._inner[t.count - 1]._points);
                    q._inner[q.count - 1]._points.clear();
                    r._inner[r.count - 1]._points.clear();
                    s._inner[s.count - 1]._points.clear();
                    t._inner[t.count - 1]._points.clear();
                }
                else {
                    al = q._inner[q.count - 1]._points;
                    am = r._inner[r.count - 1]._points;
                    an = s._inner[s.count - 1]._points;
                    ao = t._inner[t.count - 1]._points;
                }
                this.g(al, am, an, ao, v, e - 1, f, g, null, h, i);
                j(al, am, an, ao, true);
                if (l != null) {
                    this.c(q._inner[q.count - 1]._points, al, l, i, true);
                    this.c(r._inner[r.count - 1]._points, am, l, i, false);
                    this.c(s._inner[s.count - 1]._points, an, l, i, true);
                    this.c(t._inner[t.count - 1]._points, ao, l, i, false);
                }
            }
            else {
                q.add(new i2.PolyLineSegment());
                r.add(new i2.PolyLineSegment());
                s.add(new i2.PolyLineSegment());
                t.add(new i2.PolyLineSegment());
                this.h(q._inner[0]._points, r._inner[0]._points, s._inner[0]._points, t._inner[0]._points, 0, e - 1, f, g, h, i);
                j(q._inner[0]._points, r._inner[0]._points, s._inner[0]._points, t._inner[0]._points, true);
            }
            var _loop_2 = function (ap) {
                var aq = q._inner[ap];
                var ar = r._inner[ap];
                var as = s._inner[ap];
                var at = t._inner[ap];
                if (aq._points.count > 0) {
                    var au = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = aq._points._inner[0];
                        return $ret;
                    })());
                    au._segments.add(aq);
                    m.c.add(au);
                }
                if (ar._points.count > 0) {
                    var av = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = ar._points._inner[0];
                        return $ret;
                    })());
                    av._segments.add(ar);
                    n.c.add(av);
                }
                if (as._points.count > 0) {
                    var aw = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = as._points._inner[0];
                        return $ret;
                    })());
                    aw._segments.add(as);
                    o.c.add(aw);
                }
                if (at._points.count > 0) {
                    var ax = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = at._points._inner[0];
                        return $ret;
                    })());
                    ax._segments.add(at);
                    p.c.add(ax);
                }
            };
            for (var ap = 0; ap < r.count; ap++) {
                _loop_2(ap);
            }
        };
        CategoryLineRasterizer.prototype.h = function (a, b, c, d, e, f, g, h, i, j) {
            this.g(a, b, c, d, e, f, g, h, null, i, j);
        };
        CategoryLineRasterizer.prototype.g = function (a, b, c, d, e, f, g, h, i, j, k) {
            this.o.clear();
            if (j == 1 && !this.a) {
                var l = i2.FastFlattener.a(new i2.List$1(i2.Number_$type, 0), g, true, h, e, f, k);
                var m = l.count;
                var n = 0;
                var o = void 0;
                var p = void 0;
                var q = void 0;
                var r = new i2.PointCollection(0);
                for (var s = 0; s < m; s++) {
                    n = l.item(s);
                    o = g._inner[n];
                    p = o[0];
                    q = o[1];
                    r.add({ $type: i2.Point_$type, x: p, y: q });
                }
                if (i != null) {
                    this.c(a, r, i, k, true);
                    this.c(d, r, i, k, false);
                    this.c(this.o, r, i, k, false);
                }
                else {
                    this.f(a, r);
                    this.f(d, r);
                    this.f(this.o, r);
                }
            }
            else {
                var t = i2.FastFlattener.a(new i2.List$1(i2.Number_$type, 0), g, true, h, e, f, k);
                var u = i2.FastFlattener.a(new i2.List$1(i2.Number_$type, 0), g, false, h, e, f, k);
                var v = t.count;
                var w = u.count;
                var x = 0;
                var y = void 0;
                var z = void 0;
                var aa = void 0;
                var ab = new i2.PointCollection(0);
                var ac = new i2.PointCollection(0);
                for (var ad = 0; ad < v; ad++) {
                    x = t.item(ad);
                    y = g._inner[x];
                    z = y[0];
                    aa = y[1];
                    ab.add({ $type: i2.Point_$type, x: z, y: aa });
                    ac.add({ $type: i2.Point_$type, x: z, y: aa });
                }
                var ae = new i2.PointCollection(0);
                var af = void 0;
                var ag = void 0;
                for (var ah = w - 1; ah >= 0; ah--) {
                    x = u.item(ah);
                    y = g._inner[x];
                    if (h) {
                        af = y[0];
                        ag = y[2];
                    }
                    else {
                        af = y[2];
                        ag = y[3];
                    }
                    ae.add({ $type: i2.Point_$type, x: af, y: ag });
                    ac.add({ $type: i2.Point_$type, x: af, y: ag });
                }
                if (i != null) {
                    this.c(a, ab, i, k, true);
                    this.c(b, ab, i, k, false);
                    this.c(d, ae, i, k, false);
                    this.c(c, ac, i, k, true);
                    this.c(this.o, ab, i, k, false);
                }
                else {
                    this.f(a, ab);
                    this.f(b, ab);
                    this.f(d, ae);
                    this.f(c, ac);
                    this.f(this.o, ab);
                }
            }
        };
        CategoryLineRasterizer.prototype.f = function (a, b) {
            var c = b.count;
            for (var d = 0; d < c; d++) {
                a.add(b._inner[d]);
            }
        };
        CategoryLineRasterizer.$t = i2.markType(CategoryLineRasterizer, 'CategoryLineRasterizer');
        return CategoryLineRasterizer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AreaSeries, _super);
        function AreaSeries() {
            var _this = _super.call(this) || this;
            _this.ug = null;
            _this.ug = new CategoryLineRasterizer();
            _this.ab = AreaSeries.$;
            _this.tz = 0;
            return _this;
        }
        AreaSeries.prototype.bu = function () {
            return new AreaSeriesView(this);
        };
        AreaSeries.prototype.rd = function () {
            return 1;
        };
        AreaSeries.prototype.b0 = function () {
            if (this.b1 == 0) {
                return 2;
            }
            return _super.prototype.b0.call(this);
        };
        AreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.uf = a;
        };
        AreaSeries.prototype.get_c8 = function () {
            return true;
        };
        AreaSeries.prototype.get_c7 = function () {
            return true;
        };
        AreaSeries.prototype.preferredCategoryMode = function (a) {
            return this.tz;
        };
        AreaSeries.prototype.ep = function (a, b) {
            var c = this.o2(this.o5(a), true, false);
            if (this.t6(a, c, b)) {
                return true;
            }
            if (this.eo(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        AreaSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.db();
        };
        AreaSeries.prototype.sl = function (a, b) {
            var _this = this;
            _super.prototype.sl.call(this, a, b);
            var c = b.cr.d;
            var d = i2.typeCast(AreaSeriesView.$, b);
            var e = a.f;
            var f = this.getEffectiveViewport1(d);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var g = false;
            var h = this.rb.b;
            if (h != null) {
                g = true;
            }
            if (g) {
                var i = new ScalerParams(0, b.bv, b.bu, this.tw.cc, f);
                this.sh(e, -1, this.valueColumn.count, this.tw, i, b.q);
            }
            var j = d.dm;
            var k = d.dn;
            var l = d.dp;
            var m = d.dq;
            this.rb.ad(j, true, false, true, true);
            this.rb.ad(k, true, false, true, true);
            this.rb.ad(l, false, true, false, false);
            this.rb.ad(m, false, true, false, false);
            if (b.cv(a)) {
                d.dd(e.count, e, true, c, this.gh, function (n, o, p, q, r) { return _this.tg(n, a.f.count, b); }, this.unknownValuePlotting, e.count == 1 ? null : this.su(e, e.count - 1, b.bu, b.bv, true));
                b.cy(a);
            }
            var n = this.fetchYAxis();
            l._opacity = this.rb.j * this.fi;
            m._opacity = 0.5 * this.rb.j * this.fi;
        };
        AreaSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case AreaSeries.$$p[0]:
                    this.q8.m = this.unknownValuePlotting == 0;
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        Object.defineProperty(AreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        AreaSeries.$t = i2.markType(AreaSeries, 'AreaSeries', HorizontalAnchoredCategorySeries.$, [i2.IUnknownValuePlotting_$type]);
        AreaSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, AreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting::ui', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return AreaSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var AreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AreaSeriesView, _super);
        function AreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.di = new i2.Path();
            _this.dk = new i2.Path();
            _this.dj = new i2.Path();
            _this.dl = new i2.Path();
            _this.de = new i2.Path();
            _this.dg = new i2.Path();
            _this.df = new i2.Path();
            _this.dh = new i2.Path();
            _this.da = a;
            return _this;
        }
        AreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.da.pr = Defaults.e;
            }
        };
        Object.defineProperty(AreaSeriesView.prototype, "dm", {
            get: function () {
                return this.dk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AreaSeriesView.prototype, "dn", {
            get: function () {
                return this.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AreaSeriesView.prototype, "dp", {
            get: function () {
                return this.di;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AreaSeriesView.prototype, "dq", {
            get: function () {
                return this.dj;
            },
            enumerable: false,
            configurable: true
        });
        AreaSeriesView.prototype.db = function () {
            this.di.ak = null;
            this.dj.ak = null;
            this.dk.ak = null;
            this.dl.ak = null;
            this.aq();
        };
        AreaSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
            this.dd(a, b, c, d, e, f, g, null);
        };
        AreaSeriesView.prototype.dd = function (a, b, c, d, e, f, g, h) {
            this.da.ug.a = i2.typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.da.ug.j(this.di, this.dk, this.dj, this.dl, a, b, c, d, e, f, g, h);
            this.aq();
        };
        AreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.de.ak = this.di.ak;
            this.dg.ak = this.dk.ak;
            this.df.ak = this.dj.ak;
            this.dh.ak = this.dl.ak;
            var a = this.bo();
            this.de._fill = a;
            this.de._opacity = 1;
            this.df._fill = a;
            this.df._opacity = 1;
            this.dg._stroke = a;
            this.dg.ac = this.e.fl + 3;
            this.dh._stroke = a;
            this.dh.ac = this.e.fl + 3;
        };
        AreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (b) {
                a.s(this.de);
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
            }
            else {
                a.s(this.di);
                a.s(this.dj);
                a.s(this.dk);
                a.s(this.dl);
            }
        };
        AreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dk, "lowerShape", ["Lower"]);
            this.e.a6.exportPathData(a, this.dl, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
            this.e.a6.exportPathData(a, this.di, "fillShape", ["Fill"]);
        };
        AreaSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 1;
            this.e.gl = -3;
        };
        AreaSeriesView.$t = i2.markType(AreaSeriesView, 'AreaSeriesView', AnchoredCategorySeriesView.$);
        return AreaSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent area series.
     * Displays trend over time or ordered categories.Useful when there are many data points and the order is important.
    *
    * The `IgxAreaSeriesComponent` class represents a IgxDataChartComponent area series.Displays trend over time or ordered categories.
    *
    * Useful when there are many data points and the order is important.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"  >
    *     </igx-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series: IgxAreaSeriesComponent = new IgxAreaSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "Value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAreaSeriesComponent, _super);
        function IgxAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxAreaSeriesComponent.prototype.createImplementation = function () {
            return new AreaSeries();
        };
        Object.defineProperty(IgxAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAreaSeriesComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            *
            * The `isAreaOrLine` is used to check if the current series shows an area or line shape.
            *
            * ```ts
            * let series: IgxAreaSeriesComponent = new IgxAreaSeriesComponent();
            * let x= series.isAreaOrLine;
            * ```
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAreaSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            *
            * The `unknownValuePlotting` property is used to determines how unknown values will be plotted on the chart.
            *
            * Null and Double.NaN are two examples of unknown values.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            * 		unknownValuePlotting="DontPlot"  >
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.unknownValuePlotting = UnknownValuePlotting.LinearInterpolate;
            * ```
            */
            get: function () {
                return this.i.unknownValuePlotting;
            },
            set: function (v) {
                this.i.unknownValuePlotting = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAreaSeriesComponent, selector: "igx-area-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxAreaSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-area-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAreaSeriesModule() {
        }
        IgxAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesModule, declarations: [IgxAreaSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxAreaSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxAreaSeriesComponent", IgxAreaSeriesComponent);
            i2.TypeRegistrar.register("AreaSeries", AreaSeries.$type);
        }
        IgxAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxAreaSeriesModule], exports: [IgxAreaSeriesModule] });
        IgxAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxAreaSeriesModule], IgxAreaSeriesModule] });
        return IgxAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxAreaSeriesModule],
                        exports: [IgxAreaSeriesModule],
                        entryComponents: [IgxAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColumnSeries, _super);
        function ColumnSeries() {
            var _this = _super.call(this) || this;
            _this.ul = null;
            _this.ug = 0;
            _this.ab = ColumnSeries.$;
            _this.tz = 2;
            return _this;
        }
        ColumnSeries.prototype.get_db = function () {
            return true;
        };
        ColumnSeries.prototype.get_dw = function () {
            return true;
        };
        ColumnSeries.prototype.bu = function () {
            return new ColumnSeriesView(this);
        };
        ColumnSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.uf = a;
        };
        ColumnSeries.prototype.b0 = function () {
            if (this.b1 == 0) {
                return 2;
            }
            return _super.prototype.b0.call(this);
        };
        ColumnSeries.prototype.rd = function () {
            return 1;
        };
        ColumnSeries.prototype.get_cy = function () {
            return true;
        };
        ColumnSeries.prototype.preferredCategoryMode = function (a) {
            return this.tz;
        };
        ColumnSeries.prototype.pb = function (a) {
            if (this.ul == null) {
                this.ul = i2.runOn(this, this.ui);
            }
            var b = this.t2 != null ? this.t2 : this.yAxis;
            var c = this.tw;
            return this.s0.c$d(this, a, c, b, this.q3, this.r3(this.bx), this.r4(this.bx), this.ul);
        };
        ColumnSeries.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        ColumnSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a && c.db != null) {
                c.db.count = 0;
            }
        };
        ColumnSeries.prototype.f1 = function () {
            return this.tw.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        ColumnSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = a.f;
            if (!b.t()) {
                return;
            }
            var d = b.bv;
            var e = b.bu;
            var f = this.getEffectiveViewport1(b);
            var g = new ScalerParams(0, d, e, this.t2.cc, f);
            g.b = this.f2();
            var h = new ScalerParams(0, d, e, this.tw.cc, f);
            var i = this.t2;
            var j = i.d8(i.k5, g);
            var k = this.tw.ki(d, e, f);
            var l = this.tw;
            var m = b;
            if (i2.isNaN_(k) || i2.isInfinity(k)) {
                m.db.count = 0;
                return;
            }
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            this.rb.r = this.uj;
            this.rb.s = this.uk;
            this.rb.k = this.uj;
            this.rb.l = this.uk;
            var n = false;
            var o = this.rb.b;
            if (o != null) {
                n = true;
            }
            var p = this.tw.ch;
            var q = p ? this.tw : null;
            var r = this.valueColumn.count;
            var s = this.r3(b);
            var t = 0;
            for (var u = 0; u < c.count; ++u) {
                var v = c._inner[u][0] - 0.5 * k;
                var w = this.ui(c._inner[u]);
                var x = j;
                w = Math.max(w, -100);
                x = Math.min(x, e.bottom + 100);
                var y = Math.abs(x - w);
                if (i2.isInfinity(y)) {
                    continue;
                }
                var z = m.db.item(t);
                t++;
                z.width = k;
                z.height = y;
                if (n) {
                    this.sh(c, u, r, l, h, b.q);
                }
                if (z.dataContext != null) {
                    var aa = z.dataContext;
                    if (s == 1) {
                        var ab = this.rb.au(r, u)[0];
                        if (ab >= 0 && ab < this.ch.count) {
                            if (q != null && q.i$b != null && q.i$b.count > ab) {
                                ab = q.i$b._inner[ab];
                            }
                            aa.item = this.ch.item(ab);
                        }
                    }
                    else {
                        aa.item = null;
                    }
                }
                this.rb.ad(z, false, false, false, false);
                z.am = this.rb.k;
                z.an = this.rb.l;
                m.dg(z, v, Math.min(x, w));
            }
            m.db.count = t;
            b.cy(a);
        };
        Object.defineProperty(ColumnSeries.prototype, "uh", {
            get: function () {
                return this.ug;
            },
            set: function (a) {
                if (this.uh != a) {
                    var b = this.uh;
                    this.ug = a;
                    this.raisePropertyChanged("ConsolidatedColumnVerticalPosition", i2.enumGetBox(ConsolidatedItemsPosition_$type, b), i2.enumGetBox(ConsolidatedItemsPosition_$type, this.uh));
                }
            },
            enumerable: false,
            configurable: true
        });
        ColumnSeries.prototype.ui = function (a) {
            if (a == null || a.length < 3) {
                return NaN;
            }
            switch (this.uh) {
                case 0: return a[1];
                case 1: return a[2];
                case 2: return (a[1] + a[2]) / 2;
                case 3:
                    var b = (a[1] + a[2]) / 2;
                    if (this.yAxis == null) {
                        return b;
                    }
                    var c = this.yAxis.eb(b, new ScalerParams(1, this.ca.pw, this.ca.pv, this.yAxis.cc));
                    if (c < this.yAxis.k5) {
                        return a[2];
                    }
                    else {
                        return a[1];
                    }
                case 4:
                    var d = (a[1] + a[2]) / 2;
                    var e = this.yAxis.eb(d, new ScalerParams(1, this.ca.pw, this.ca.pv, this.yAxis.cc));
                    if (this.yAxis == null) {
                        return d;
                    }
                    if (e < this.yAxis.k5) {
                        return a[1];
                    }
                    else {
                        return a[2];
                    }
                default: return (a[1] + a[2]) / 2;
            }
        };
        Object.defineProperty(ColumnSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        ColumnSeries.$t = i2.markType(ColumnSeries, 'ColumnSeries', HorizontalAnchoredCategorySeries.$);
        ColumnSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ColumnSeries, 'raisePropertyChanged', ['RadiusX:uj:up', [1, 0], 'RadiusY:uk:uq', [1, 0]]);
        return ColumnSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var ColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColumnSeriesView, _super);
        function ColumnSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.dc = null;
            _this.dh = new i2.Rectangle();
            _this.db = null;
            _this.da = a;
            _this.db = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.di);
                $ret.activate = i2.runOn(_this, _this.dd);
                $ret.disactivate = i2.runOn(_this, _this.df);
                $ret.destroy = i2.runOn(_this, _this.de);
                return $ret;
            })());
            return _this;
        }
        ColumnSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.dc = new i2.List$1(i2.Rectangle.$, 0);
            if (!this.q) {
                this.da.gh = Defaults.h;
                this.da.gm = Defaults.i;
                this.da.pr = Defaults.c;
            }
        };
        ColumnSeriesView.prototype.di = function () {
            var a = new i2.Rectangle();
            this.dc.add(a);
            a._visibility = 1;
            return a;
        };
        ColumnSeriesView.prototype.dd = function (a) {
            a._visibility = 0;
        };
        ColumnSeriesView.prototype.df = function (a) {
            a._visibility = 1;
        };
        ColumnSeriesView.prototype.de = function (a) {
            this.dc.remove(a);
        };
        ColumnSeriesView.prototype.dg = function (a, b, c) {
            if (!this.isDirty) {
                this.aq();
            }
            a.o = c;
            a.n = b;
        };
        ColumnSeriesView.prototype.ac = function (a) {
            return this.dc._inner[a];
        };
        ColumnSeriesView.prototype.ab = function (a) {
            var b = this.dc._inner[a];
            this.dh._visibility = b._visibility;
            this.dh.n = b.n;
            this.dh.o = b.o;
            this.dh.width = b.width;
            this.dh.height = b.height;
            var c = this.bp(a);
            this.dh._fill = c;
            this.dh._stroke = c;
            this.dh.ac = this.e.fl + 3;
            return this.dh;
        };
        ColumnSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.dc.count; c++) {
                    var d = this.aa(c, b);
                    this.bd(d, c, b);
                    a.v(d);
                }
            }
        };
        ColumnSeriesView.prototype.al = function (a) {
            var e_1, _a, e_2, _b;
            _super.prototype.al.call(this, a);
            var b = 0;
            var c = new i2.List$1(i2.Rectangle.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.db.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    c.add(d);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            c.aa(function (e, f) {
                if (e.n < f.n) {
                    return -1;
                }
                else if (e.n > f.n) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    this.e.a6.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            b++;
        };
        ColumnSeriesView.$t = i2.markType(ColumnSeriesView, 'ColumnSeriesView', AnchoredCategorySeriesView.$);
        return ColumnSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent column series.
     * Compare values across categories by using vertical rectangles.Use it when the order of categories is not important or for displaying
     * item counts such as a histogram.
    *
    * ```html
    *     <igx-data-chart [dataSource]="data" >
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    *       <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value" >
    *       </igx-column-series>
    *     </igx-data-chart>
    * ```
    */
    var IgxColumnSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxColumnSeriesComponent, _super);
        function IgxColumnSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxColumnSeriesComponent.prototype.createImplementation = function () {
            return new ColumnSeries();
        };
        Object.defineProperty(IgxColumnSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnSeriesComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.uk;
            },
            set: function (v) {
                this.i.uk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnSeriesComponent.prototype, "consolidatedColumnVerticalPosition", {
            /**
             * The positioning logic to use for columns which have been consolidated into a single visual element.
            */
            get: function () {
                return this.i.uh;
            },
            set: function (v) {
                this.i.uh = i2.ensureEnum(ConsolidatedItemsPosition_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
        IgxColumnSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxColumnSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxColumnSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxColumnSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxColumnSeriesComponent, selector: "igx-column-series", inputs: { radiusX: "radiusX", radiusY: "radiusY", consolidatedColumnVerticalPosition: "consolidatedColumnVerticalPosition" }, providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxColumnSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-column-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }], consolidatedColumnVerticalPosition: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxColumnSeriesModule() {
        }
        IgxColumnSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxColumnSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesModule, declarations: [IgxColumnSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxColumnSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxColumnSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxColumnSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxColumnSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxColumnSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxColumnSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxColumnSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxColumnSeriesComponent", IgxColumnSeriesComponent);
            i2.TypeRegistrar.register("ColumnSeries", ColumnSeries.$type);
        }
        IgxColumnSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxColumnSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesDynamicModule, imports: [i1.CommonModule, IgxColumnSeriesModule], exports: [IgxColumnSeriesModule] });
        IgxColumnSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesDynamicModule, imports: [[i1.CommonModule, IgxColumnSeriesModule], IgxColumnSeriesModule] });
        return IgxColumnSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxColumnSeriesModule],
                        exports: [IgxColumnSeriesModule],
                        entryComponents: [IgxColumnSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LineSeries, _super);
        function LineSeries() {
            var _this = _super.call(this) || this;
            _this.uf = null;
            _this.uf = new CategoryLineRasterizer();
            _this.ab = LineSeries.$;
            _this.tz = 0;
            return _this;
        }
        LineSeries.prototype.get_dv = function () {
            return true;
        };
        LineSeries.prototype.bu = function () {
            return new LineSeriesView(this);
        };
        LineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ug = a;
        };
        LineSeries.prototype.get_c8 = function () {
            return true;
        };
        LineSeries.prototype.preferredCategoryMode = function (a) {
            return this.tz;
        };
        LineSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.db();
        };
        LineSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = b.cr.d;
            var d = i2.typeCast(LineSeriesView.$, b);
            var e = a.f;
            var f = this.getEffectiveViewport1(b);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var g = false;
            var h = this.rb.b;
            if (h != null) {
                g = true;
            }
            if (g) {
                var i = new ScalerParams(0, b.bv, b.bu, this.tw.cc, f);
                this.sh(e, -1, this.valueColumn.count, this.tw, i, b.q);
            }
            var j = d.dh;
            var k = d.di;
            var l = d.dg;
            this.rb.ad(j, true, false, true, false);
            this.rb.ad(k, true, false, true, false);
            this.rb.ad(l, false, true, false, false);
            l._opacity = 0.75 * this.rb.j;
            if (b.cv(a)) {
                d.dc(e.count, e, true, this.unknownValuePlotting, this.st(e, e.count - 1, b.bu, b.bv), c, this.gh);
                b.cy(a);
            }
        };
        LineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case LineSeries.$$p[0]:
                    this.q8.m = this.unknownValuePlotting == 0;
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        Object.defineProperty(LineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        LineSeries.$t = i2.markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [i2.IUnknownValuePlotting_$type]);
        LineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::ui', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return LineSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var LineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LineSeriesView, _super);
        function LineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.dk = new i2.Path();
            _this.dj = new i2.Path();
            _this.dl = new i2.Path();
            _this.df = new i2.Path();
            _this.de = new i2.Path();
            _this.dd = new i2.Path();
            _this.da = a;
            return _this;
        }
        LineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.da.pr = Defaults.e;
            }
        };
        Object.defineProperty(LineSeriesView.prototype, "dh", {
            get: function () {
                return this.dk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LineSeriesView.prototype, "di", {
            get: function () {
                return this.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LineSeriesView.prototype, "dg", {
            get: function () {
                return this.dj;
            },
            enumerable: false,
            configurable: true
        });
        LineSeriesView.prototype.db = function () {
            this.dj.ak = null;
            this.dk.ak = null;
            this.dl.ak = null;
            this.aq();
        };
        LineSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
            this.da.uf.a = i2.typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.da.uf.m(this.dk, this.dj, this.dl, a, b, c, d, e, f, g);
            this.aq();
        };
        LineSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        LineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.de.ak = this.dk.ak;
            this.df.ak = this.dl.ak;
            this.dd.ak = this.dj.ak;
            var a = this.bo();
            this.de._stroke = a;
            this.de.ac = this.e.fl + 3;
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
            this.dd._fill = a;
            this.dd._opacity = 1;
        };
        LineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.dd);
                    a.s(this.de);
                    a.s(this.df);
                }
                else {
                    a.s(this.dj);
                    a.s(this.dk);
                    a.s(this.dl);
                }
            }
        };
        LineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dk, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.dl, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
        };
        LineSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        LineSeriesView.$t = i2.markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);
        return LineSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent line series.
     * Displays trend over time or ordered categories.Useful when there are many data points and the order is important.
    *
    * `IgxLineSeriesComponent` belongs to a group of `IgxCategorySeriesComponent` and it is rendered using a collection of points connected by straight line segments.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series: IgxLineSeriesComponent = new IgxLineSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxLineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxLineSeriesComponent, _super);
        function IgxLineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxLineSeriesComponent.prototype.createImplementation = function () {
            return new LineSeries();
        };
        Object.defineProperty(IgxLineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLineSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLineSeriesComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            *
            * Gets whether the `IgxSeriesComponent` shows an area or a line shape.
            *
            * ```ts
            * let isAreaOrLine: boolean = series.isAreaOrLine;
            * ```
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLineSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            *
            * Determines how unknown values will be plotted for the `IgxSeriesComponent`. This can be set to `LinearInterpolate` to create a continous shape or `DontPlot` to create breaks in the series.
            *
            * Null and Double.NaN are two examples of unknown values.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         unknownValuePlotting="LinearInterpolate">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.unknownValuePlotting = UnknownValuePlotting.LinearInterpolate;
            * ```
            */
            get: function () {
                return this.i.unknownValuePlotting;
            },
            set: function (v) {
                this.i.unknownValuePlotting = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxLineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxLineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxLineSeriesComponent, selector: "igx-line-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxLineSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-line-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLineSeriesModule() {
        }
        IgxLineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesModule, declarations: [IgxLineSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxLineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxLineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxLineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxLineSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxLineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxLineSeriesComponent", IgxLineSeriesComponent);
            i2.TypeRegistrar.register("LineSeries", LineSeries.$type);
        }
        IgxLineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesDynamicModule, imports: [i1.CommonModule, IgxLineSeriesModule], exports: [IgxLineSeriesModule] });
        IgxLineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesDynamicModule, imports: [[i1.CommonModule, IgxLineSeriesModule], IgxLineSeriesModule] });
        return IgxLineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxLineSeriesModule],
                        exports: [IgxLineSeriesModule],
                        entryComponents: [IgxLineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of Spline calculations.
     */
    var SplineType = /*@__PURE__*/ (function (SplineType) {
        /**
         * Calculates the spline using a natural spline calculation formula.
         */
        SplineType[SplineType["Natural"] = 0] = "Natural";
        /**
         * Calculated the spline using a clamped spline calculation formula.
         */
        SplineType[SplineType["Clamped"] = 1] = "Clamped";
        return SplineType;
    })({});
    /**
     * @hidden
     */
    var SplineType_$type = i2.markEnum('SplineType', 'Natural,0|Clamped,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SafeEnumerable = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SafeEnumerable, _super);
        function SafeEnumerable(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = a;
            return _this;
        }
        SafeEnumerable.prototype.c = function (a) {
            if (i2.isInfinity(a) || i2.isNaN_(a)) {
                return 0;
            }
            return a;
        };
        SafeEnumerable.prototype._b = function () {
            var _a, _c, a, e_1_1;
            var e_1, _d;
            return tslib.__generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        if (this.a == null) {
                            return [2 /*return*/, undefined];
                        }
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 6, 7, 8]);
                        _a = tslib.__values(i2.fromEnum(this.a)), _c = _a.next();
                        _e.label = 2;
                    case 2:
                        if (!!_c.done)
                            return [3 /*break*/, 5];
                        a = _c.value;
                        return [4 /*yield*/, this.c(a)];
                    case 3:
                        _e.sent();
                        _e.label = 4;
                    case 4:
                        _c = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _e.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_c && !_c.done && (_d = _a.return))
                                _d.call(_a);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        };
        SafeEnumerable.prototype.b = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._b(); });
        };
        SafeEnumerable.prototype.getEnumerator = function () {
            return i2.getEnumerator(this.b());
        };
        SafeEnumerable.prototype.getEnumeratorObject = function () {
            return this.getEnumerator();
        };
        SafeEnumerable.$t = i2.markType(SafeEnumerable, 'SafeEnumerable', i2.Base.$, [i2.IEnumerable$1_$type.specialize(i2.Number_$type)]);
        return SafeEnumerable;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SafeReadOnlyDoubleCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SafeReadOnlyDoubleCollection, _super);
        function SafeReadOnlyDoubleCollection(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        _this.a = new i2.ReadOnlyCollection$1(i2.Number_$type, 1, c);
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        _this.a = new i2.ReadOnlyCollection$1(i2.Number_$type, 1, c);
                        _this.b = d;
                    }
                    break;
            }
            return _this;
        }
        SafeReadOnlyDoubleCollection.prototype.c = function (a) {
            if (i2.isInfinity(a) || i2.isNaN_(a)) {
                return this.b;
            }
            return a;
        };
        SafeReadOnlyDoubleCollection.prototype.indexOf = function (a) {
            return this.a.indexOf(a);
        };
        SafeReadOnlyDoubleCollection.prototype.insert = function (a, b) {
            this.a.insert(a, b);
        };
        SafeReadOnlyDoubleCollection.prototype.removeAt = function (a) {
            this.a.removeAt(a);
        };
        SafeReadOnlyDoubleCollection.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                this.a.item(a, b);
                return b;
            }
            else {
                return this.c(this.a.item(a));
            }
        };
        SafeReadOnlyDoubleCollection.prototype.add = function (a) {
            this.a.add(a);
        };
        SafeReadOnlyDoubleCollection.prototype.clear = function () {
            this.a.clear();
        };
        SafeReadOnlyDoubleCollection.prototype.contains = function (a) {
            return this.a.contains(a);
        };
        SafeReadOnlyDoubleCollection.prototype.copyTo = function (a, b) {
            for (var c = b; c < a.length; c++) {
                a[c] = this.item(c);
            }
        };
        Object.defineProperty(SafeReadOnlyDoubleCollection.prototype, "count", {
            get: function () {
                return this.a.count;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SafeReadOnlyDoubleCollection.prototype, "isReadOnly", {
            get: function () {
                return this.a.isReadOnly;
            },
            enumerable: false,
            configurable: true
        });
        SafeReadOnlyDoubleCollection.prototype.remove = function (a) {
            return this.a.remove(a);
        };
        SafeReadOnlyDoubleCollection.prototype.getEnumerator = function () {
            return new SafeEnumerable(this.a).getEnumerator();
        };
        SafeReadOnlyDoubleCollection.prototype.getEnumeratorObject = function () {
            return this.getEnumerator();
        };
        SafeReadOnlyDoubleCollection.$t = i2.markType(SafeReadOnlyDoubleCollection, 'SafeReadOnlyDoubleCollection', i2.Base.$, [i2.IList$1_$type.specialize(i2.Number_$type)]);
        return SafeReadOnlyDoubleCollection;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SafeSortedReadOnlyDoubleCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SafeSortedReadOnlyDoubleCollection, _super);
        function SafeSortedReadOnlyDoubleCollection(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = null;
            _this.c = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        _this.a = new SafeReadOnlyDoubleCollection(0, c);
                        _this.b = d;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        _this.a = new SafeReadOnlyDoubleCollection(1, c, e);
                        _this.b = d;
                        _this.c = e;
                    }
                    break;
            }
            return _this;
        }
        SafeSortedReadOnlyDoubleCollection.prototype.d = function (a) {
            if (i2.isInfinity(a) || i2.isNaN_(a)) {
                return this.c;
            }
            return a;
        };
        SafeSortedReadOnlyDoubleCollection.prototype.indexOf = function (a) {
            var b = this.a.indexOf(a);
            return this.b.indexOf(b);
        };
        SafeSortedReadOnlyDoubleCollection.prototype.insert = function (a, b) {
            this.a.insert(a, b);
        };
        SafeSortedReadOnlyDoubleCollection.prototype.removeAt = function (a) {
            this.a.removeAt(a);
        };
        SafeSortedReadOnlyDoubleCollection.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                this.a.item(a, b);
                return b;
            }
            else {
                var b_1 = this.b.item(a);
                return this.d(this.a.item(b_1));
            }
        };
        SafeSortedReadOnlyDoubleCollection.prototype.add = function (a) {
            this.a.add(a);
        };
        SafeSortedReadOnlyDoubleCollection.prototype.clear = function () {
            this.a.clear();
        };
        SafeSortedReadOnlyDoubleCollection.prototype.contains = function (a) {
            return this.a.contains(a);
        };
        SafeSortedReadOnlyDoubleCollection.prototype.copyTo = function (a, b) {
            for (var c = b; c < a.length; c++) {
                a[c] = this.item(c);
            }
        };
        Object.defineProperty(SafeSortedReadOnlyDoubleCollection.prototype, "count", {
            get: function () {
                return this.a.count;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SafeSortedReadOnlyDoubleCollection.prototype, "isReadOnly", {
            get: function () {
                return this.a.isReadOnly;
            },
            enumerable: false,
            configurable: true
        });
        SafeSortedReadOnlyDoubleCollection.prototype.remove = function (a) {
            return this.a.remove(a);
        };
        SafeSortedReadOnlyDoubleCollection.prototype._getEnumerator = function () {
            var a;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        a = 0;
                        _a.label = 1;
                    case 1:
                        if (!(a < this.a.count))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, this.item(a)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        a++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        SafeSortedReadOnlyDoubleCollection.prototype.getEnumerator = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._getEnumerator(); }).getEnumerator();
        };
        SafeSortedReadOnlyDoubleCollection.prototype.getEnumeratorObject = function () {
            return this.getEnumerator();
        };
        SafeSortedReadOnlyDoubleCollection.$t = i2.markType(SafeSortedReadOnlyDoubleCollection, 'SafeSortedReadOnlyDoubleCollection', i2.Base.$, [i2.IList$1_$type.specialize(i2.Number_$type)]);
        return SafeSortedReadOnlyDoubleCollection;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SplineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineSeriesBase, _super);
        function SplineSeriesBase() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.uh = null;
            _this.un = NaN;
            _this.um = NaN;
            return _this;
        }
        SplineSeriesBase.prototype.bu = function () {
            return new SplineSeriesBaseView(this);
        };
        SplineSeriesBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ui = a;
        };
        SplineSeriesBase.prototype.ap = function (a) {
            if (!this.uk || this.uh == null || this.uh.length == 0) {
                return _super.prototype.ap.call(this, a);
            }
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            this.uu(this.ui);
            if (this.uh == null || this.uh.length == 0) {
                return null;
            }
            if (a == this.fetchYAxis()) {
                if (i2.isNaN_(this.uq) || i2.isNaN_(this.ur)) {
                    return null;
                }
                return new AxisRange(this.ur, this.uq);
            }
            return null;
        };
        SplineSeriesBase.prototype.get_c8 = function () {
            return true;
        };
        SplineSeriesBase.prototype.uf = function (a) {
            var _this = this;
            if (a.cr.d == 0) {
                return null;
            }
            var b = new i2.List$1(i2.Array_$type, 0);
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(a);
            var f = 0;
            var g = 0;
            var h = 0;
            var i = this;
            var j = i2.typeCast(CategoryAxisBase.$, i.fetchXAxis());
            var k = i.o7(this.bx);
            var l = i.ch;
            if (c.isEmpty || d.isEmpty || j == null || l == null || l.count == 0) {
                f = 0;
                return null;
            }
            var m = this.gh;
            var n = i2.typeCast(ISortingAxis_$type, j);
            if (n == null || n.i$b == null) {
                var o = new ScalerParams(0, c, d, j.cc, e);
                var p = 0;
                var q = j.kr - 1;
                var r = Math.floor((q - p + 1) * m / k.width);
                f = i2.truncate(Math.max(1, r));
                g = i2.truncate(Math.max(0, Math.floor(p / f) - 1));
                h = i2.truncate(Math.ceil(q / f));
            }
            else {
                g = 0;
                h = j.kr - 1;
                f = 1;
            }
            if (n != null && n.i$b.count != this.ch.count) {
                return null;
            }
            this.uu(a);
            var s = i2.truncate(Math.ceil(d.width / (h - g)));
            var t = new CollisionAvoider();
            if (n != null) {
                return this.ug(a);
            }
            var u = function (v) { return v; };
            var v = function (w) { return _this.valueColumn.item(w); };
            var w = a;
            w.c6();
            for (var x = g; x <= h; ++x) {
                var y = null;
                if (f == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        break;
                    }
                    var z = u(x);
                    var aa = v(x);
                    var ab = u(x + 1);
                    var ac = v(x + 1);
                    var ad = ab - z;
                    var ae = this.uh[x];
                    var af = this.uh[x + 1];
                    b.add([aa, ac]);
                    for (var ag = 1; ag < s; ++ag) {
                        var ah = z + ad * ag / s;
                        var ai = (ab - ah) / ad;
                        var aj = (ah - z) / ad;
                        var ak = ai * aa + aj * ac + ((ai * ai * ai - ai) * ae + (aj * aj * aj - aj) * af) * (ad * ad) / 6;
                        b.add([ak, ak]);
                    }
                }
                else {
                    y = a.cr.getBucket(x);
                    if (!i2.isNaN_(y[0])) {
                        b.add([y[1], y[2]]);
                    }
                }
            }
            w.c8();
            return b.toArray();
        };
        SplineSeriesBase.prototype.ug = function (a) {
            var _this = this;
            var b = i2.typeCast(ISortingAxis_$type, this.tw);
            var c = this.getEffectiveViewport1(a);
            var d = a.bv;
            var e = a.bu;
            var f = new i2.List$1(i2.Array_$type, 0);
            if (b == null) {
                return null;
            }
            var g = this.tw;
            var h = 0;
            var i = 0;
            var j = 0;
            var k = this.gh;
            var l = this.o7(this.bx);
            if (b == null || b.i$b == null) {
                var m = new ScalerParams(0, d, e, g.cc, c);
                var n = 0;
                var o = g.kr - 1;
                var p = Math.floor((o - n + 1) * k / l.width);
                h = i2.truncate(Math.max(1, p));
                i = i2.truncate(Math.max(0, Math.floor(n / h) - 1));
                j = i2.truncate(Math.ceil(o / h));
            }
            else {
                i = 0;
                j = g.kr - 1;
                h = 1;
            }
            var q = function (r) { return r; };
            var r = function (s) { return _this.valueColumn.item(b.i$b._inner[s]); };
            var s = i2.truncate(Math.ceil(e.width / (j - i)));
            var t = new CollisionAvoider();
            if (h <= 0 || (i <= 0 && j <= 0)) {
                return null;
            }
            for (var u = i; u < j + 1; ++u) {
                var v = null;
                var w = u * h;
                if (b != null && b.i$b != null && w >= 0 && w < b.i$b.count) {
                    w = b.i$b._inner[w];
                }
                if (u >= (this.valueColumn.count - 1)) {
                    break;
                }
                var x = q(u);
                var y = r(u);
                var z = q(u + 1);
                var aa = r(u + 1);
                var ab = z - x;
                var ac = this.uh[u];
                var ad = this.uh[u + 1];
                f.add([y, y]);
                for (var ae = 1; ae < s; ++ae) {
                    var af = ae / s;
                    var ag = x + ab * af;
                    var ah = (z - ag) / ab;
                    var ai = (ag - x) / ab;
                    var aj = ah * y + ai * aa + ((ah * ah * ah - ah) * ac + (ai * ai * ai - ai) * ad) * (ab * ab) / 6;
                    f.add([aj, aj]);
                }
            }
            return f.toArray();
        };
        SplineSeriesBase.prototype.uv = function (a, b, c, d, e, f) {
            var _this = this;
            var g = i2.typeCast(ISortingAxis_$type, d);
            var h = this.getEffectiveViewport1(f);
            if (g == null) {
                return;
            }
            var i = new ScalerParams(0, b, c, d.cc, h);
            var j = new ScalerParams(0, b, c, e.cc, h);
            j.b = this.f2();
            var k = this.pt();
            var l = 0;
            var m = this.up(d, b, c, h);
            var n = function (o) { return o; };
            var o = function (p) { return _this.valueColumn.item(g.i$b._inner[p]); };
            var p = this.rc.cr.f;
            var q = this.rc.cr.e;
            var r = i2.truncate(Math.ceil(c.width / (p - q)));
            var s = new CollisionAvoider();
            var t = this.rc.cr.d;
            if (t <= 0 || (q <= 0 && p <= 0)) {
                this.rc.cu.count = l;
                return;
            }
            var u = 0;
            var v = 0;
            for (var w = q; w < p + 1; ++w) {
                var x = null;
                var y = w * t;
                if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                    y = g.i$b._inner[y];
                }
                if (w >= (this.valueColumn.count - 1)) {
                    if (k && this.ul(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.ch.count - 1), l, f, u - 1)) {
                        ++l;
                    }
                    break;
                }
                var z = n(w);
                var aa = o(w);
                var ab = n(w + 1);
                var ac = o(w + 1);
                var ad = ab - z;
                var ae = this.uh[w];
                var af = this.uh[w + 1];
                var ag = g.i$d(g.i$b._inner[w]);
                var ah = d.d8(ag, i) + m;
                var ai = e.d8(aa, j);
                a.f.add([ah, ai, ai]);
                u++;
                v = u;
                for (var aj = 1; aj < r; ++aj) {
                    var ak = aj / r;
                    var al = z + ad * ak;
                    var am = (ab - al) / ad;
                    var an = (al - z) / ad;
                    var ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                    var ap = g.i$d(g.i$b._inner[w]);
                    var aq = g.i$d(g.i$b._inner[w + 1]);
                    var ar = ap + (aq - ap) * ak;
                    al = d.d8(ar, i) + m;
                    ao = e.d8(ao, j);
                    a.f.add([al, ao, ao]);
                    u++;
                }
                if (k) {
                    x = [ah, ai, ai];
                }
                if (k && this.ul(a, x, s, Math.min(y, this.ch.count - 1), l, f, v - 1)) {
                    ++l;
                }
            }
            f.cu.count = l;
        };
        SplineSeriesBase.prototype.ul = function (a, b, c, d, e, f, g) {
            var h = b[0];
            var i = b[1];
            var j = new i2.Rect(0, h - 5, i - 5, 11, 11);
            if (!i2.isNaN_(h) && !i2.isNaN_(i) && c.tryAdd(j)) {
                a.m.add({ $type: i2.Point_$type, x: h, y: i });
                var k = f.cu.item(e);
                k.content.item = this.ch.item(d);
                k.al = g;
                return true;
            }
            return false;
        };
        SplineSeriesBase.prototype.aj = function (a, b, c, d, e, f) {
            if (a == null || a.ch || this.r3(this.bx) > 1 || this.r3(this.bx) == 0) {
                return _super.prototype.aj.call(this, this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), e, f);
            }
            if (this.q3.f.count == 0) {
                return null;
            }
            var g = this.ui.cr.f;
            var h = this.bx.bu;
            var i = i2.truncate(Math.ceil(h.width));
            if (g != d) {
                i = i2.truncate(Math.ceil(h.width / (g - d)));
            }
            var j = -1;
            var k = -1;
            var l = this.fw(e);
            var m = this.g6(e, f);
            var n = this.g4(e, f);
            var o = i2.truncate(Math.floor(m / this.r3(this.bx)));
            var p = i2.truncate(Math.floor(n / this.r3(this.bx)));
            j = o - this.r4(this.bx);
            k = p - this.r4(this.bx);
            var q = j * i;
            var r = k * i;
            var s = 0;
            if (m != n) {
                s = (l - m) / (n - m);
            }
            var t = i2.truncate(Math.floor(q + s * (r - q)));
            j = t;
            k = t + 1;
            if (j < 0) {
                j = 0;
            }
            if (j > this.q3.f.count - 1) {
                j = this.q3.f.count - 1;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.q3.f.count - 1) {
                k = this.q3.f.count - 1;
            }
            var u = this.q3.f._inner[j];
            var v = this.q3.f._inner[k];
            var w = new Array(2);
            w[0] = u;
            w[1] = v;
            return w;
        };
        SplineSeriesBase.prototype.si = function (a, b) {
            var _this = this;
            _super.prototype.si.call(this, a, b);
            if (a.f.count <= 1) {
                return;
            }
            if (b.cr.d == 0) {
                return;
            }
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.tw;
            var g = this.t2;
            var h = new ScalerParams(0, c, d, f.cc, e);
            var i = ((function () {
                var $ret = new ScalerParams(0, c, d, g.cc, e);
                $ret.b = _this.f2();
                return $ret;
            })());
            a.f.clear();
            a.m.clear();
            var j = this.pt();
            var k = 0;
            var l = i2.typeCast(ISortingAxis_$type, this.tw);
            if (l != null && l.i$b.count != this.ch.count) {
                return;
            }
            var m = this.up(f, c, d, e);
            var n = b.cr.d;
            this.uu(b);
            var o = b.cr.f;
            var p = b.cr.e;
            var q = i2.truncate(Math.ceil(d.width / (o - p)));
            var r = new CollisionAvoider();
            if (l != null) {
                this.uv(a, c, d, f, g, b);
                return;
            }
            var s = function (t) { return t; };
            var t = function (u) { return _this.valueColumn.item(u); };
            var u = b;
            u.c6();
            var v = 0;
            var w = 0;
            for (var x = p; x <= o; ++x) {
                var y = null;
                if (n == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        if (j && this.ul(a, a.f._inner[a.f.count - 1], r, Math.min(x * n, this.ch.count - 1), k, b, v - 1)) {
                            ++k;
                        }
                        break;
                    }
                    var z = s(x);
                    var aa = t(x);
                    var ab = s(x + 1);
                    var ac = t(x + 1);
                    var ad = ab - z;
                    var ae = this.uh[x];
                    var af = this.uh[x + 1];
                    var ag = f.d8(z, h) + m;
                    var ah = g.d8(aa, i);
                    a.f.add([ag, ah, ah]);
                    v++;
                    w = v;
                    for (var ai = 1; ai < q; ++ai) {
                        var aj = z + ad * ai / q;
                        var ak = (ab - aj) / ad;
                        var al = (aj - z) / ad;
                        var am = ak * aa + al * ac + ((ak * ak * ak - ak) * ae + (al * al * al - al) * af) * (ad * ad) / 6;
                        aj = f.d8(aj, h) + m;
                        am = g.d8(am, i);
                        a.f.add([aj, am, am]);
                        v++;
                    }
                    if (j) {
                        y = b.cr.getBucket(x);
                        y[0] = (f.d8(y[0], h) + m);
                        y[1] = g.d8(y[1], i);
                        y[2] = g.d8(y[2], i);
                    }
                }
                else {
                    y = b.cr.getBucket(x);
                    if (!i2.isNaN_(y[0])) {
                        y[0] = (f.d8(y[0], h) + m);
                        y[1] = g.d8(y[1], i);
                        y[2] = g.d8(y[2], i);
                        a.f.add(y);
                        v++;
                        w = v;
                    }
                }
                if (j && this.ul(a, y, r, Math.min(x * n, this.ch.count - 1), k, b, w - 1)) {
                    ++k;
                }
            }
            u.c8();
            b.cu.count = k;
        };
        SplineSeriesBase.prototype.uu = function (a) {
            var _this = this;
            var b = a.cr.d;
            var c = function (d) { return d; };
            var d = function (e) { return _this.valueColumn.item(e); };
            if (b < 1 || this.valueColumn == null || this.valueColumn.count == 0) {
                return;
            }
            if ((this.uh == null || this.uh.length != this.valueColumn.count) && b == 1) {
                var e = this.uj == 0 ? NaN : 0;
                if (this.tw != null && i2.typeCast(ISortingAxis_$type, this.tw) !== null && this.tw.i$b != null) {
                    var f_1 = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.tw.i$b, NaN);
                    d = function (g) { return f_1.item(g); };
                }
                this.uh = i2.Numeric.c(this.valueColumn.count, c, d, e, e);
                if (this.uk) {
                    var g = -1.7976931348623157E+308;
                    var h = 1.7976931348623157E+308;
                    var i = this.uf(a);
                    if (i == null) {
                        return;
                    }
                    for (var j = 0; j < i.length; j++) {
                        if (i2.isNaN_(i[j][0]) || i2.isNaN_(i[j][1])) {
                            continue;
                        }
                        if (i[j][1] > g) {
                            g = i[j][1];
                        }
                        if (i[j][0] < h) {
                            h = i[j][0];
                        }
                    }
                    this.ur = h;
                    this.uq = g;
                }
            }
        };
        SplineSeriesBase.prototype.uo = function (a, b, c, d, e, f, g) {
            var h = d - b;
            var i = b + h * a;
            var j = (d - i) / h;
            var k = (i - b) / h;
            var l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
            return l;
        };
        SplineSeriesBase.prototype.f0 = function (a, b, c, d, e, f, g, h) {
            var i = NaN;
            if (c >= 0 && c < b.count) {
                i = b.item(c);
            }
            var j = NaN;
            if (d >= 0 && d < b.count) {
                j = b.item(d);
            }
            if (f == 0) {
                return j;
            }
            if (e == b.count - 1) {
                return i;
            }
            if (i2.isNaN_(j) && g != 0 && a <= 0.5 && !h) {
                return i;
            }
            if (i2.isNaN_(i) && g != 0 && a >= 0.5 && !h) {
                return j;
            }
            var k = e;
            var l = f;
            var m = i;
            var n = j;
            var o = NaN;
            var p = NaN;
            if (this.uh != null && e >= 0 && e < this.uh.length) {
                o = this.uh[e];
            }
            if (this.uh != null && f >= 0 && f < this.uh.length) {
                p = this.uh[f];
            }
            return this.uo(a, k, m, l, n, o, p);
        };
        SplineSeriesBase.prototype.up = function (a, b, c, d) {
            var e = this.preferredCategoryMode(a);
            if (e == 0 && a.categoryMode != 0) {
                e = 1;
            }
            var f = 0;
            switch (e) {
                case 0:
                    f = 0;
                    break;
                case 1:
                    f = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    f = a.getGroupCenter(this.g9, b, c, d);
                    break;
            }
            if (a.cc) {
                f = -f;
            }
            return f;
        };
        Object.defineProperty(SplineSeriesBase.prototype, "ur", {
            get: function () {
                return this.un;
            },
            set: function (a) {
                this.un = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineSeriesBase.prototype, "uq", {
            get: function () {
                return this.um;
            },
            set: function (a) {
                this.um = a;
            },
            enumerable: false,
            configurable: true
        });
        SplineSeriesBase.prototype.uw = function () {
            this.uh = null;
            this.ur = NaN;
            this.uq = NaN;
            if (this.yAxis != null) {
                this.yAxis.cv();
            }
        };
        SplineSeriesBase.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case "ValueColumn":
                case "FastItemsSource":
                    this.uw();
                    break;
            }
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case SplineSeriesBase.$$p[1]:
                    this.uw();
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        SplineSeriesBase.prototype.kk = function (a, b, c, d) {
            this.uw();
            _super.prototype.kk.call(this, a, b, c, d);
        };
        Object.defineProperty(SplineSeriesBase.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        SplineSeriesBase.$t = i2.markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
        SplineSeriesBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['IsSplineShapePartOfRange:uk:ux', [0, false], 'SplineType:uj:uy', [SplineType_$type, i2.enumGetBox(SplineType_$type, 0)]]);
        return SplineSeriesBase;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var SplineSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineSeriesBaseView, _super);
        function SplineSeriesBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.da = a;
            return _this;
        }
        SplineSeriesBaseView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        SplineSeriesBaseView.$t = i2.markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);
        return SplineSeriesBaseView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineAreaSeries, _super);
        function SplineAreaSeries() {
            var _this = _super.call(this) || this;
            _this.uz = null;
            _this.uz = new CategoryLineRasterizer();
            _this.ab = SplineAreaSeries.$;
            return _this;
        }
        SplineAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        SplineAreaSeries.prototype.get_ea = function () {
            return true;
        };
        SplineAreaSeries.prototype.bu = function () {
            return new SplineAreaSeriesView(this);
        };
        SplineAreaSeries.prototype.rd = function () {
            return 1;
        };
        SplineAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.u0 = a;
        };
        SplineAreaSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        SplineAreaSeries.prototype.b0 = function () {
            if (this.b1 == 0) {
                return 2;
            }
            return _super.prototype.b0.call(this);
        };
        SplineAreaSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.dc();
        };
        SplineAreaSeries.prototype.ep = function (a, b) {
            var c = this.o2(this.o5(a), true, false);
            if (this.t6(a, c, b)) {
                return true;
            }
            if (this.eo(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        SplineAreaSeries.prototype.sl = function (a, b) {
            var _this = this;
            _super.prototype.sl.call(this, a, b);
            var c = this.rc.cr.d;
            var d = i2.typeCast(SplineAreaSeriesView.$, b);
            var e = a.f;
            var f = this.getEffectiveViewport1(b);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var g = false;
            var h = this.rb.b;
            if (h != null) {
                g = true;
            }
            if (g) {
                var i = new ScalerParams(0, b.bv, b.bu, this.tw.cc, f);
                this.sh(e, -1, this.valueColumn.count, this.tw, i, b.q);
            }
            var j = d.dn;
            var k = d.dp;
            var l = d.dq;
            var m = d.dr;
            this.rb.ad(j, true, false, true, true);
            this.rb.ad(k, true, false, true, true);
            this.rb.ad(l, false, true, false, false);
            this.rb.ad(m, false, true, false, false);
            l._opacity = this.rb.j * this.fi;
            m._opacity = 0.5 * this.rb.j * this.fi;
            if (b.cv(a)) {
                d.de(a.f.count, e, true, c, this.gh, function (n, o, p, q, r) { return _this.tg(n, a.f.count, b); }, 1, a.f.count == 1 ? null : this.su(e, e.count - 1, b.bu, b.bv, true));
                b.cy(a);
            }
            var n = this.fetchYAxis();
        };
        Object.defineProperty(SplineAreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        SplineAreaSeries.$t = i2.markType(SplineAreaSeries, 'SplineAreaSeries', SplineSeriesBase.$);
        return SplineAreaSeries;
    }(SplineSeriesBase));
    /**
     * @hidden
     */
    var SplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineAreaSeriesView, _super);
        function SplineAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.db = null;
            _this.dj = new i2.Path();
            _this.dl = new i2.Path();
            _this.dk = new i2.Path();
            _this.dm = new i2.Path();
            _this.df = new i2.Path();
            _this.dh = new i2.Path();
            _this.dg = new i2.Path();
            _this.di = new i2.Path();
            _this.db = a;
            return _this;
        }
        SplineAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.db.pr = Defaults.e;
            }
        };
        Object.defineProperty(SplineAreaSeriesView.prototype, "dn", {
            get: function () {
                return this.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineAreaSeriesView.prototype, "dp", {
            get: function () {
                return this.dm;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineAreaSeriesView.prototype, "dq", {
            get: function () {
                return this.dj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineAreaSeriesView.prototype, "dr", {
            get: function () {
                return this.dk;
            },
            enumerable: false,
            configurable: true
        });
        SplineAreaSeriesView.prototype.dc = function () {
            this.dj.ak = null;
            this.dk.ak = null;
            this.dl.ak = null;
            this.dm.ak = null;
            this.aq();
        };
        SplineAreaSeriesView.prototype.dd = function (a, b, c, d, e, f, g) {
            this.de(a, b, c, d, e, f, g, null);
        };
        SplineAreaSeriesView.prototype.de = function (a, b, c, d, e, f, g, h) {
            this.db.uz.a = i2.typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.db.uz.j(this.dj, this.dl, this.dk, this.dm, a, b, c, d, e, f, g, h);
            this.aq();
        };
        SplineAreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.df.ak = this.dj.ak;
            this.dh.ak = this.dl.ak;
            this.dg.ak = this.dk.ak;
            this.di.ak = this.dm.ak;
            var a = this.bo();
            this.df._fill = a;
            this.df._opacity = 1;
            this.dg._fill = a;
            this.dg._opacity = 1;
            this.dh._stroke = a;
            this.dh.ac = this.e.fl + 3;
            this.di._stroke = a;
            this.di.ac = this.e.fl + 3;
        };
        SplineAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (b) {
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
                a.s(this.di);
            }
            else {
                a.s(this.dj);
                a.s(this.dk);
                a.s(this.dl);
                a.s(this.dm);
            }
        };
        SplineAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dl, "lowerShape", ["Lower"]);
            this.e.a6.exportPathData(a, this.dm, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPathData(a, this.dk, "translucentShape", ["Translucent"]);
            this.e.a6.exportPathData(a, this.dj, "fillShape", ["Fill"]);
        };
        SplineAreaSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 1;
            this.e.gl = -3;
        };
        SplineAreaSeriesView.$t = i2.markType(SplineAreaSeriesView, 'SplineAreaSeriesView', SplineSeriesBaseView.$);
        return SplineAreaSeriesView;
    }(SplineSeriesBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents the base class for all IgxDataChartComponent spline series.
    */
    var IgxSplineSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSplineSeriesBaseComponent, _super);
        function IgxSplineSeriesBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "isSplineShapePartOfRange", {
            /**
             * Gets or sets whether to include the spline shape in the axis range requested of the axis.
            */
            get: function () {
                return this.i.uk;
            },
            set: function (v) {
                this.i.uk = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "splineType", {
            /**
             * Gets or sets the type of spline to be rendered.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-spline-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         splineType="clamped"
            *         valueMemberPath="value">
            *     </igx-spline-area-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.splineType = SplineType.Clamped;
            * ```
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = i2.ensureEnum(SplineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxSplineSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSplineSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSplineSeriesBaseComponent, selector: "ng-component", inputs: { isSplineShapePartOfRange: "isSplineShapePartOfRange", splineType: "splineType" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxSplineSeriesBaseComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { isSplineShapePartOfRange: [{
                    type: i0.Input
                }], splineType: [{
                    type: i0.Input
                }] } });

    /**
     * Represents a IgxDataChartComponent spline area series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-spline-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-spline-area-series>
    * </igx-data-chart>
    * ```
    */
    var IgxSplineAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSplineAreaSeriesComponent, _super);
        function IgxSplineAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxSplineAreaSeriesComponent.prototype.createImplementation = function () {
            return new SplineAreaSeries();
        };
        Object.defineProperty(IgxSplineAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineAreaSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        IgxSplineAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSplineAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSplineAreaSeriesComponent, selector: "igx-spline-area-series", providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSplineAreaSeriesComponent;
    }(IgxSplineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-spline-area-series',
                        template: "",
                        providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineAreaSeriesModule() {
        }
        IgxSplineAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesModule, declarations: [IgxSplineAreaSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxSplineAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxSplineAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxSplineAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSplineAreaSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxSplineAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxSplineAreaSeriesComponent", IgxSplineAreaSeriesComponent);
            i2.TypeRegistrar.register("SplineAreaSeries", SplineAreaSeries.$type);
        }
        IgxSplineAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxSplineAreaSeriesModule], exports: [IgxSplineAreaSeriesModule] });
        IgxSplineAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxSplineAreaSeriesModule], IgxSplineAreaSeriesModule] });
        return IgxSplineAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxSplineAreaSeriesModule],
                        exports: [IgxSplineAreaSeriesModule],
                        entryComponents: [IgxSplineAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineSeries, _super);
        function SplineSeries() {
            var _this = _super.call(this) || this;
            _this.uz = null;
            _this.uz = new CategoryLineRasterizer();
            _this.ab = SplineSeries.$;
            return _this;
        }
        SplineSeries.prototype.get_ea = function () {
            return true;
        };
        SplineSeries.prototype.bu = function () {
            return new SplineSeriesView(this);
        };
        SplineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.u0 = a;
        };
        SplineSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        SplineSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.dc();
        };
        SplineSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = b;
            var d = c.cr.d;
            var e = i2.typeCast(SplineSeriesView.$, b);
            var f = a.f;
            var g = this.getEffectiveViewport1(b);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var h = false;
            var i = this.rb.b;
            if (i != null) {
                h = true;
            }
            if (h) {
                var j = new ScalerParams(0, b.bv, b.bu, this.tw.cc, g);
                this.sh(f, -1, this.valueColumn.count, this.tw, j, b.q);
            }
            var k = e.di;
            var l = e.dj;
            var m = e.dh;
            this.rb.ad(k, true, false, true, false);
            this.rb.ad(l, true, false, true, false);
            this.rb.ad(m, false, true, false, false);
            m._opacity = 0.75 * this.rb.j;
            if (b.cv(a)) {
                e.dd(f.count, f, true, 1, this.st(f, f.count - 1, b.bu, b.bv), d, this.gh);
                b.cy(a);
            }
        };
        Object.defineProperty(SplineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        SplineSeries.$t = i2.markType(SplineSeries, 'SplineSeries', SplineSeriesBase.$);
        return SplineSeries;
    }(SplineSeriesBase));
    /**
     * @hidden
     */
    var SplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineSeriesView, _super);
        function SplineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.db = null;
            _this.dl = new i2.Path();
            _this.dk = new i2.Path();
            _this.dm = new i2.Path();
            _this.dg = new i2.Path();
            _this.df = new i2.Path();
            _this.de = new i2.Path();
            _this.db = a;
            return _this;
        }
        SplineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.db.pr = Defaults.e;
            }
        };
        Object.defineProperty(SplineSeriesView.prototype, "di", {
            get: function () {
                return this.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineSeriesView.prototype, "dj", {
            get: function () {
                return this.dm;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineSeriesView.prototype, "dh", {
            get: function () {
                return this.dk;
            },
            enumerable: false,
            configurable: true
        });
        SplineSeriesView.prototype.dc = function () {
            this.dk.ak = null;
            this.dl.ak = null;
            this.dm.ak = null;
            this.aq();
        };
        SplineSeriesView.prototype.dd = function (a, b, c, d, e, f, g) {
            this.db.uz.a = i2.typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.db.uz.m(this.dl, this.dk, this.dm, a, b, c, d, e, f, g);
            this.aq();
        };
        SplineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.df.ak = this.dl.ak;
            this.dg.ak = this.dm.ak;
            this.de.ak = this.dk.ak;
            var a = this.bo();
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
            this.dg._stroke = a;
            this.dg.ac = this.e.fl + 3;
            this.de._fill = a;
            this.de._opacity = 1;
        };
        SplineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.de);
                    a.s(this.df);
                    a.s(this.dg);
                }
                else {
                    a.s(this.dk);
                    a.s(this.dl);
                    a.s(this.dm);
                }
            }
        };
        SplineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dl, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.dm, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.dk, "translucentShape", ["Translucent"]);
        };
        SplineSeriesView.$t = i2.markType(SplineSeriesView, 'SplineSeriesView', SplineSeriesBaseView.$);
        return SplineSeriesView;
    }(SplineSeriesBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent spline series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-spline-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-spline-series>
    * </igx-data-chart>
    * ```
    */
    var IgxSplineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSplineSeriesComponent, _super);
        function IgxSplineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxSplineSeriesComponent.prototype.createImplementation = function () {
            return new SplineSeries();
        };
        Object.defineProperty(IgxSplineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        IgxSplineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSplineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSplineSeriesComponent, selector: "igx-spline-series", providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSplineSeriesComponent;
    }(IgxSplineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-spline-series',
                        template: "",
                        providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineSeriesModule() {
        }
        IgxSplineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesModule, declarations: [IgxSplineSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxSplineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxSplineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxSplineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSplineSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxSplineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxSplineSeriesComponent", IgxSplineSeriesComponent);
            i2.TypeRegistrar.register("SplineSeries", SplineSeries.$type);
        }
        IgxSplineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesDynamicModule, imports: [i1.CommonModule, IgxSplineSeriesModule], exports: [IgxSplineSeriesModule] });
        IgxSplineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesDynamicModule, imports: [[i1.CommonModule, IgxSplineSeriesModule], IgxSplineSeriesModule] });
        return IgxSplineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxSplineSeriesModule],
                        exports: [IgxSplineSeriesModule],
                        entryComponents: [IgxSplineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StepAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StepAreaSeries, _super);
        function StepAreaSeries() {
            var _this = _super.call(this) || this;
            _this.uf = null;
            _this.uf = new CategoryLineRasterizer();
            _this.ab = StepAreaSeries.$;
            return _this;
        }
        StepAreaSeries.prototype.bu = function () {
            return new StepAreaSeriesView(this);
        };
        StepAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ug = a;
        };
        StepAreaSeries.prototype.get_c8 = function () {
            return true;
        };
        StepAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        StepAreaSeries.prototype.get_eb = function () {
            return true;
        };
        StepAreaSeries.prototype.get_dw = function () {
            return true;
        };
        StepAreaSeries.prototype.b0 = function () {
            if (this.b1 == 0) {
                return 2;
            }
            return _super.prototype.b0.call(this);
        };
        StepAreaSeries.prototype.preferredCategoryMode = function (a) {
            return i2.typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
        };
        StepAreaSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.db();
        };
        StepAreaSeries.prototype.uh = function (a, b, c, d, e) {
            if (b) {
                if (e) {
                    if ((a & 1) == 0 || ((i2.intDivide(a, 2)) + 1) >= c.f.count) {
                        return c.f._inner[(i2.intDivide(a, 2))][0];
                    }
                    return c.f._inner[(i2.intDivide(a, 2)) + 1][0];
                }
                return c.f._inner[(i2.intDivide(a, 2))][0] + ((a & 1) == 1 ? -d : d);
            }
            if (e) {
                if ((a & 1) == 0 || ((i2.intDivide(a, 2)) + 1) >= c.f.count) {
                    return c.f._inner[(i2.intDivide(a, 2))][0];
                }
                return c.f._inner[(i2.intDivide(a, 2)) + 1][0];
            }
            return c.f._inner[(i2.intDivide(a, 2))][0] + ((a & 1) == 0 ? -d : d);
        };
        StepAreaSeries.prototype.rd = function () {
            return 1;
        };
        StepAreaSeries.prototype.f0 = function (a, b, c, d, e, f, g, h) {
            var i = NaN;
            if (c >= 0 && c < b.count) {
                i = b.item(c);
            }
            var j = NaN;
            if (d >= 0 && d < b.count) {
                j = b.item(d);
            }
            if (f == 0) {
                return j;
            }
            if (e == b.count - 1) {
                return i;
            }
            if (i2.isNaN_(j) && g != 0 && a <= 0.5 && !h) {
                return i;
            }
            if (i2.isNaN_(i) && g != 0 && a >= 0.5 && !h) {
                return j;
            }
            if (a > 0.5) {
                return j;
            }
            return i;
        };
        StepAreaSeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 2;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        StepAreaSeries.prototype.sl = function (a, b) {
            var _this = this;
            _super.prototype.sl.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = i2.typeCast(ISortingAxis_$type, this.tw) != null;
            var g = this.tw != null ? 0.5 * this.tw.getCategorySize(c, d, e) : 0;
            if (this.tw != null && this.tw.cc) {
                g = -g;
            }
            var h = a.f.count * 2;
            var i = new i2.List$1(i2.Array_$type, 2, h);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var j = false;
            var k = this.rb.b;
            if (k != null) {
                j = true;
            }
            for (var l = 0; l < h; l++) {
                var m = new Array(4);
                m[0] = this.uh(l, false, a, g, f);
                m[1] = a.f._inner[(i2.intDivide(l, 2))][1];
                m[2] = this.uh(l, true, a, g, f);
                m[3] = a.f._inner[(i2.intDivide(l, 2))][2];
                i.add(m);
            }
            var n = this.rc.cr.d;
            if (j) {
                var o = new ScalerParams(0, b.bv, b.bu, this.tw.cc, e);
                this.sh(i, -1, this.valueColumn.count, this.tw, o, b.q);
            }
            var p = i2.typeCast(StepAreaSeriesView.$, b);
            var q = p.dp;
            var r = p.dq;
            var s = p.dm;
            var t = p.dn;
            this.rb.ad(q, true, false, true, true);
            this.rb.ad(r, true, false, true, true);
            this.rb.ad(s, false, true, false, false);
            this.rb.ad(t, false, true, false, false);
            if (b.cv(a)) {
                p.dd(h, i, false, n, this.gh, function (u, v, w, x, y) { return _this.tg(u, 2 * a.f.count, b); }, 1, this.su(i, i.count - 1, b.bu, b.bv, true));
                b.cy(a);
            }
            var u = this.fetchYAxis();
            p.dm._opacity = this.fi;
            p.dn._opacity = 0.5 * this.fi;
        };
        Object.defineProperty(StepAreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StepAreaSeries.$t = i2.markType(StepAreaSeries, 'StepAreaSeries', HorizontalAnchoredCategorySeries.$);
        return StepAreaSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var StepAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StepAreaSeriesView, _super);
        function StepAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.di = new i2.Path();
            _this.dk = new i2.Path();
            _this.dj = new i2.Path();
            _this.dl = new i2.Path();
            _this.de = new i2.Path();
            _this.dg = new i2.Path();
            _this.df = new i2.Path();
            _this.dh = new i2.Path();
            _this.da = a;
            return _this;
        }
        StepAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.da.pr = Defaults.c;
            }
        };
        Object.defineProperty(StepAreaSeriesView.prototype, "dm", {
            get: function () {
                return this.di;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StepAreaSeriesView.prototype, "dp", {
            get: function () {
                return this.dk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StepAreaSeriesView.prototype, "dn", {
            get: function () {
                return this.dj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StepAreaSeriesView.prototype, "dq", {
            get: function () {
                return this.dl;
            },
            enumerable: false,
            configurable: true
        });
        StepAreaSeriesView.prototype.db = function () {
            this.di.ak = null;
            this.dj.ak = null;
            this.dk.ak = null;
            this.dl.ak = null;
            this.aq();
        };
        StepAreaSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
            this.dc(a, b, c, d, e, f, g);
        };
        StepAreaSeriesView.prototype.dd = function (a, b, c, d, e, f, g, h) {
            this.da.uf.a = i2.typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.da.uf.j(this.di, this.dk, this.dj, this.dl, a, b, c, d, e, f, g, h);
            this.aq();
        };
        StepAreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.de.ak = this.di.ak;
            this.dg.ak = this.dk.ak;
            this.df.ak = this.dj.ak;
            this.dh.ak = this.dl.ak;
            var a = this.bo();
            this.de._fill = a;
            this.de._opacity = 1;
            this.df._fill = a;
            this.df._opacity = 1;
            this.dg._stroke = a;
            this.dg.ac = this.e.fl + 3;
            this.dh._stroke = a;
            this.dh.ac = this.e.fl + 3;
        };
        StepAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (b) {
                a.s(this.de);
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
            }
            else {
                a.s(this.di);
                a.s(this.dj);
                a.s(this.dk);
                a.s(this.dl);
            }
        };
        StepAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dk, "lowerShape", ["Lower"]);
            this.e.a6.exportPathData(a, this.dl, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
            this.e.a6.exportPathData(a, this.di, "fillShape", ["Fill"]);
        };
        StepAreaSeriesView.$t = i2.markType(StepAreaSeriesView, 'StepAreaSeriesView', AnchoredCategorySeriesView.$);
        return StepAreaSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent step area series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-step-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-step-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    *    let series = new IgxStepAreaSeriesComponent();
    *    series.xAxis = this.xAxis;
    *    series.yAxis = this.yAxis;
    *    series.valueMemberPath="value";
    *    this.chart.series.add(series);
    * ```
    */
    var IgxStepAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStepAreaSeriesComponent, _super);
        function IgxStepAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStepAreaSeriesComponent.prototype.createImplementation = function () {
            return new StepAreaSeries();
        };
        Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "isStep", {
            /**
             * Gets whether the current series shows step shapes.
            */
            get: function () {
                return this.i.eb;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        IgxStepAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStepAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStepAreaSeriesComponent, selector: "igx-step-area-series", providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStepAreaSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-step-area-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStepAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStepAreaSeriesModule() {
        }
        IgxStepAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStepAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesModule, declarations: [IgxStepAreaSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxStepAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxStepAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxStepAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStepAreaSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxStepAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStepAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStepAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStepAreaSeriesComponent", IgxStepAreaSeriesComponent);
            i2.TypeRegistrar.register("StepAreaSeries", StepAreaSeries.$type);
        }
        IgxStepAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStepAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxStepAreaSeriesModule], exports: [IgxStepAreaSeriesModule] });
        IgxStepAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxStepAreaSeriesModule], IgxStepAreaSeriesModule] });
        return IgxStepAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStepAreaSeriesModule],
                        exports: [IgxStepAreaSeriesModule],
                        entryComponents: [IgxStepAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StepLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StepLineSeries, _super);
        function StepLineSeries() {
            var _this = _super.call(this) || this;
            _this.uf = null;
            _this.uf = new CategoryLineRasterizer();
            _this.ab = StepLineSeries.$;
            return _this;
        }
        StepLineSeries.prototype.get_dv = function () {
            return true;
        };
        StepLineSeries.prototype.get_eb = function () {
            return true;
        };
        StepLineSeries.prototype.get_dw = function () {
            return true;
        };
        StepLineSeries.prototype.bu = function () {
            return new StepLineSeriesView(this);
        };
        StepLineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ug = a;
        };
        StepLineSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
        };
        StepLineSeries.prototype.preferredCategoryMode = function (a) {
            return i2.typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
        };
        StepLineSeries.prototype.get_c8 = function () {
            return true;
        };
        StepLineSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.db();
        };
        StepLineSeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 2;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        StepLineSeries.prototype.f0 = function (a, b, c, d, e, f, g, h) {
            var i = NaN;
            if (c >= 0 && c < b.count) {
                i = b.item(c);
            }
            var j = NaN;
            if (d >= 0 && d < b.count) {
                j = b.item(d);
            }
            if (f == 0) {
                return j;
            }
            if (e == b.count - 1) {
                return i;
            }
            if (i2.isNaN_(j) && g != 0 && a <= 0.5 && !h) {
                return i;
            }
            if (i2.isNaN_(i) && g != 0 && a >= 0.5 && !h) {
                return j;
            }
            if (a > 0.5) {
                return j;
            }
            return i;
        };
        StepLineSeries.prototype.uh = function (a, b, c, d, e, f) {
            var g;
            if (b) {
                if (f) {
                    g = (a & 1) == 0;
                    if (g || (i2.intDivide(a, 2)) + 1 < 0) {
                        return c.f._inner[(i2.intDivide(a, 2))][0];
                    }
                    if (c.f.count == (i2.intDivide(a, 2)) + 1) {
                        return c.f._inner[(i2.intDivide(a, 2))][0];
                    }
                    return c.f._inner[(i2.intDivide(a, 2)) + 1][0];
                }
                g = (a & 1) == 0;
                return c.f._inner[(i2.intDivide(a, 2))][0] + (g ? d : -d);
            }
            if (f) {
                g = (a & 1) == 0;
                if (g || ((i2.intDivide(a, 2)) + 1) >= c.f.count) {
                    return c.f._inner[(i2.intDivide(a, 2))][0];
                }
                if (c.f.count == (i2.intDivide(a, 2)) + 1) {
                    return c.f._inner[(i2.intDivide(a, 2))][0];
                }
                return c.f._inner[(i2.intDivide(a, 2)) + 1][0];
            }
            g = (a & 1) == 0;
            return c.f._inner[(i2.intDivide(a, 2))][0] + (g ? -d : d);
        };
        StepLineSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = i2.typeCast(ISortingAxis_$type, this.tw) != null;
            var g = this.tw.cc;
            var h = 0;
            if (this.tw != null) {
                h = 0.5 * this.tw.getCategorySize(c, d, e);
            }
            var i = a.f;
            var j = 2 * i.count;
            var k = new i2.List$1(i2.Array_$type, 2, j);
            if (!this.tw.cc) {
                for (var l = 0; l < j; l++) {
                    var m = new Array(4);
                    m[0] = this.uh(l, false, a, h, g, f);
                    m[1] = a.f._inner[(i2.intDivide(l, 2))][1];
                    m[2] = this.uh(l, true, a, h, g, f);
                    m[3] = a.f._inner[(i2.intDivide(l, 2))][2];
                    k.add(m);
                }
            }
            else {
                for (var n = 0; n < j; n++) {
                    var o = new Array(4);
                    o[0] = this.uh(n, true, a, h, g, f);
                    o[1] = a.f._inner[(i2.intDivide(n, 2))][1];
                    o[2] = this.uh(n, true, a, h, g, f);
                    o[3] = a.f._inner[(i2.intDivide(n, 2))][2];
                    k.add(o);
                }
            }
            var p = i2.typeCast(StepLineSeriesView.$, b);
            var q = p.cr.d;
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var r = false;
            var s = this.rb.b;
            if (s != null) {
                r = true;
            }
            if (r) {
                var t = new ScalerParams(0, b.bv, b.bu, this.tw.cc, e);
                this.sh(i, -1, this.valueColumn.count, this.tw, t, b.q);
            }
            var u = p.dh;
            var v = p.di;
            var w = p.dg;
            this.rb.ad(u, true, false, true, false);
            this.rb.ad(v, true, false, true, false);
            this.rb.ad(w, false, true, false, false);
            w._opacity = 0.75 * this.rb.j;
            if (b.cv(a)) {
                p.dc(j, k, false, 1, this.st(k, j - 1, b.bu, b.bv), q, this.gh);
                b.cy(a);
            }
        };
        Object.defineProperty(StepLineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StepLineSeries.$t = i2.markType(StepLineSeries, 'StepLineSeries', HorizontalAnchoredCategorySeries.$);
        return StepLineSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var StepLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StepLineSeriesView, _super);
        function StepLineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.dk = new i2.Path();
            _this.dj = new i2.Path();
            _this.dl = new i2.Path();
            _this.df = new i2.Path();
            _this.de = new i2.Path();
            _this.dd = new i2.Path();
            _this.da = a;
            return _this;
        }
        StepLineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.da.pr = Defaults.c;
            }
        };
        Object.defineProperty(StepLineSeriesView.prototype, "dh", {
            get: function () {
                return this.dk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StepLineSeriesView.prototype, "di", {
            get: function () {
                return this.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StepLineSeriesView.prototype, "dg", {
            get: function () {
                return this.dj;
            },
            enumerable: false,
            configurable: true
        });
        StepLineSeriesView.prototype.db = function () {
            this.dj.ak = null;
            this.dk.ak = null;
            this.dl.ak = null;
            this.aq();
        };
        StepLineSeriesView.prototype.dc = function (a, b, c, d, e, f, g) {
            this.da.uf.a = i2.typeCast(ISortingAxis_$type, this.ct.fetchXAxis()) !== null ? true : false;
            this.da.uf.m(this.dk, this.dj, this.dl, a, b, c, d, e, f, g);
            this.aq();
        };
        StepLineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.de.ak = this.dk.ak;
            this.df.ak = this.dl.ak;
            this.dd.ak = this.dj.ak;
            var a = this.bo();
            this.de._stroke = a;
            this.de.ac = this.e.fl + 3;
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
            this.dd._fill = a;
            this.dd._opacity = 1;
        };
        StepLineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.dd);
                    a.s(this.de);
                    a.s(this.df);
                }
                else {
                    a.s(this.dj);
                    a.s(this.dk);
                    a.s(this.dl);
                }
            }
        };
        StepLineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dk, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.dl, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
        };
        StepLineSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        StepLineSeriesView.$t = i2.markType(StepLineSeriesView, 'StepLineSeriesView', AnchoredCategorySeriesView.$);
        return StepLineSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent step line series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-step-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-step-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    *    let series = new IgxStepLineSeriesComponent();
    *    series.xAxis = this.xAxis;
    *    series.yAxis = this.yAxis;
    *    series.valueMemberPath="value";
    *    this.chart.series.add(series);
    * ```
    */
    var IgxStepLineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStepLineSeriesComponent, _super);
        function IgxStepLineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStepLineSeriesComponent.prototype.createImplementation = function () {
            return new StepLineSeries();
        };
        Object.defineProperty(IgxStepLineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepLineSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepLineSeriesComponent.prototype, "isStep", {
            /**
             * Gets whether the current series shows step shapes.
            */
            get: function () {
                return this.i.eb;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepLineSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStepLineSeriesComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        IgxStepLineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStepLineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStepLineSeriesComponent, selector: "igx-step-line-series", providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStepLineSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-step-line-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStepLineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStepLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStepLineSeriesModule() {
        }
        IgxStepLineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStepLineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesModule, declarations: [IgxStepLineSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxStepLineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxStepLineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxStepLineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStepLineSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxStepLineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStepLineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStepLineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStepLineSeriesComponent", IgxStepLineSeriesComponent);
            i2.TypeRegistrar.register("StepLineSeries", StepLineSeries.$type);
        }
        IgxStepLineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStepLineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesDynamicModule, imports: [i1.CommonModule, IgxStepLineSeriesModule], exports: [IgxStepLineSeriesModule] });
        IgxStepLineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesDynamicModule, imports: [[i1.CommonModule, IgxStepLineSeriesModule], IgxStepLineSeriesModule] });
        return IgxStepLineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStepLineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStepLineSeriesModule],
                        exports: [IgxStepLineSeriesModule],
                        entryComponents: [IgxStepLineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var WaterfallSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WaterfallSeries, _super);
        function WaterfallSeries() {
            var _this = _super.call(this) || this;
            _this.ab = WaterfallSeries.$;
            return _this;
        }
        WaterfallSeries.prototype.get_ee = function () {
            return true;
        };
        WaterfallSeries.prototype.get_dw = function () {
            return true;
        };
        WaterfallSeries.prototype.get_dm = function () {
            return true;
        };
        WaterfallSeries.prototype.bu = function () {
            return new WaterfallSeriesView(this);
        };
        WaterfallSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.uf = a;
        };
        WaterfallSeries.prototype.preferredCategoryMode = function (a) {
            return 2;
        };
        WaterfallSeries.prototype.get_dx = function () {
            return true;
        };
        WaterfallSeries.prototype.l5 = function (a, b) {
            _super.prototype.l5.call(this, a, b);
            this.uq = a;
            this.ur = b;
        };
        WaterfallSeries.prototype.op = function () {
            return this.uq;
        };
        WaterfallSeries.prototype.oq = function () {
            return this.ur;
        };
        WaterfallSeries.prototype.b0 = function () {
            if (this.b1 == 0) {
                return 2;
            }
            return _super.prototype.b0.call(this);
        };
        WaterfallSeries.prototype.get_cy = function () {
            return true;
        };
        WaterfallSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case WaterfallSeries.$$p[3]:
                case WaterfallSeries.$$p[2]:
                case WaterfallSeries.$$p[0]:
                case WaterfallSeries.$$p[1]:
                    this.l0(false);
                    break;
            }
        };
        WaterfallSeries.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        WaterfallSeries.prototype.pb = function (a) {
            var _this = this;
            if (this.uf == null || this.uf.db == null || this.uf.db.count == 0 || this.xAxis == null) {
                return i2.Rect.empty;
            }
            var b = this.uf.db;
            var c = this.ox(a);
            var d = -1;
            var e = this.xAxis.cc;
            var f = this.pf.right * 2;
            if (e) {
                d = i2.ArrayExtension.binarySearch$1(i2.Rectangle.$, b, function (g) {
                    var h = _this.uf.di(g);
                    return (f - c.x) < (f - (h.left + h.width / 2)) ? -1 : ((f - c.x) > (f - (h.left + h.width / 2)) ? 1 : 0);
                });
            }
            else {
                d = i2.ArrayExtension.binarySearch$1(i2.Rectangle.$, b, function (g) {
                    var h = _this.uf.di(g);
                    return c.x < (h.left + h.width / 2) ? -1 : (c.x > (h.left + h.width / 2) ? 1 : 0);
                });
            }
            if (d < 0) {
                d = ~d;
                d--;
            }
            if (d < 0) {
                d = 0;
            }
            if (d > b.count - 1) {
                d = b.count - 1;
            }
            var g = d;
            var h = d;
            if (g < 0) {
                g--;
            }
            if (h < b.count - 1) {
                h++;
            }
            var i = this.us(g);
            var j = this.us(d);
            var k = this.us(h);
            var l = i.left + i.width / 2;
            var m = j.left + j.width / 2;
            var n = k.left + k.width / 2;
            var o = Math.abs(l - c.x);
            var p = Math.abs(m - c.x);
            var q = Math.abs(n - c.x);
            var r = i.containsPoint(c);
            var s = j.containsPoint(c);
            var t = k.containsPoint(c);
            if (p <= o && p <= q) {
                if (!e && t) {
                    return k;
                }
                if (e && r) {
                    return i;
                }
                return j;
            }
            if (o <= p && o <= q) {
                if (!e && s) {
                    return j;
                }
                return i;
            }
            if (q <= p && q <= o) {
                if (e && s) {
                    return j;
                }
                return k;
            }
            return i2.Rect.empty;
        };
        WaterfallSeries.prototype.us = function (a) {
            return this.uf.dh(a);
        };
        WaterfallSeries.prototype.rd = function () {
            return 1;
        };
        WaterfallSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            this.uf.db.count = 0;
        };
        WaterfallSeries.prototype.get_s6 = function () {
            return 1;
        };
        WaterfallSeries.prototype.f1 = function () {
            return this.tw.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        WaterfallSeries.prototype.sl = function (a, b) {
            var c = b;
            _super.prototype.sl.call(this, a, b);
            var d = b.bv;
            var e = b.bu;
            var f = this.getEffectiveViewport1(b);
            var g = this.tw.ki(d, e, f);
            var h = this.ug;
            var i = this.uh;
            var j;
            var k = this.s4(b);
            var l = NaN;
            var m = c.db;
            var n;
            var o = 0;
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            this.rb.r = this.ug;
            this.rb.s = this.uh;
            this.rb.k = this.ug;
            this.rb.l = this.uh;
            var p = false;
            var q = this.rb.b;
            if (q != null) {
                p = true;
            }
            var r = this.tw.ch;
            var s = this.valueColumn.count;
            var t = a.f;
            var u = this.tw;
            var v = new ScalerParams(0, d, e, this.tw.cc, f);
            var w = this.of;
            var x = this.uq;
            var y = this.oi;
            var z = this.ur || y;
            if (a.f.count > 0) {
                j = a.f._inner[0][0] - 0.5 * g;
                var aa = a.f._inner[0][1];
                if (!i2.isNaN_(aa)) {
                    if (aa > k) {
                        n = m.item(o);
                        o++;
                        c.dg(n, j, k);
                        n.width = g;
                        n.height = Math.abs(k - aa);
                        this.rb.ak = x;
                        this.rb.ag = x;
                        this.rb.al = z;
                        this.rb.ah = z;
                        this.rb.f = true;
                        if (p) {
                            this.sh(t, 0, s, u, v, b.q);
                        }
                        this.rb.ad(n, false, false, false, false);
                        n.am = this.rb.k;
                        n.an = this.rb.l;
                    }
                    else {
                        n = m.item(o);
                        o++;
                        c.dg(n, j, aa);
                        n.width = g;
                        n.height = Math.abs(aa - k);
                        this.rb.ak = w;
                        this.rb.ag = w;
                        this.rb.al = y;
                        this.rb.ah = y;
                        this.rb.f = false;
                        if (p) {
                            this.sh(t, 0, s, u, v, b.q);
                        }
                        this.rb.ad(n, false, false, false, false);
                        n.am = this.rb.k;
                        n.an = this.rb.l;
                    }
                    l = aa;
                }
                else {
                    l = k;
                }
            }
            for (var ab = 1; ab < a.f.count; ++ab) {
                var ac = a.f._inner[ab];
                j = a.f._inner[ab][0] - 0.5 * g;
                var ad = ac[1];
                if (!i2.isNaN_(ad)) {
                    n = m.item(o);
                    o++;
                    c.dg(n, j, Math.min(l, ad));
                    n.width = g;
                    n.height = Math.abs(l - ad);
                    this.rb.ak = w;
                    this.rb.ag = w;
                    this.rb.al = y;
                    this.rb.ah = y;
                    this.rb.f = false;
                    if (l > ad) {
                        if (p) {
                            this.sh(t, ab, s, u, v, b.q);
                        }
                    }
                    else {
                        this.rb.ak = x;
                        this.rb.ag = x;
                        this.rb.al = z;
                        this.rb.ah = z;
                        this.rb.f = true;
                        if (p) {
                            this.sh(t, ab, s, u, v, b.q);
                        }
                    }
                    this.rb.ad(n, false, false, false, false);
                    n.am = this.rb.k;
                    n.an = this.rb.l;
                    l = ad;
                }
            }
            m.count = o;
            b.cy(a);
        };
        Object.defineProperty(WaterfallSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        WaterfallSeries.$t = i2.markType(WaterfallSeries, 'WaterfallSeries', HorizontalAnchoredCategorySeries.$);
        WaterfallSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, WaterfallSeries, 'raisePropertyChanged', ['NegativeBrush:uq:um', [i2.Brush.$, null], 'NegativeOutline:ur:un', [i2.Brush.$, null], 'RadiusX:ug:uo', [1, 0], 'RadiusY:uh:up', [1, 0]]);
        return WaterfallSeries;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var WaterfallSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WaterfallSeriesView, _super);
        function WaterfallSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.dc = null;
            _this.dj = new i2.Rectangle();
            _this.db = null;
            _this.da = a;
            _this.db = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.dk);
                $ret.activate = i2.runOn(_this, _this.dd);
                $ret.disactivate = i2.runOn(_this, _this.df);
                $ret.destroy = i2.runOn(_this, _this.de);
                return $ret;
            })());
            return _this;
        }
        WaterfallSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.dc = new i2.List$1(i2.Rectangle.$, 0);
            if (!this.q) {
                this.da.pr = Defaults.c;
                this.da.gh = Defaults.h;
                this.da.gm = Defaults.i;
                this.da.uq = Defaults.ah;
                this.da.ur = Defaults.ai;
            }
        };
        WaterfallSeriesView.prototype.dk = function () {
            var a = new i2.Rectangle();
            this.dc.add(a);
            a._visibility = 1;
            return a;
        };
        WaterfallSeriesView.prototype.dd = function (a) {
            a._visibility = 0;
        };
        WaterfallSeriesView.prototype.df = function (a) {
            a._visibility = 1;
        };
        WaterfallSeriesView.prototype.de = function (a) {
            this.dc.remove(a);
        };
        WaterfallSeriesView.prototype.dg = function (a, b, c) {
            var d = false;
            if (a.o != c) {
                d = true;
                a.o = c;
            }
            if (a.n != b) {
                d = true;
                a.n = b;
            }
            if (d) {
                this.aq();
            }
        };
        WaterfallSeriesView.prototype.ac = function (a) {
            return this.dc._inner[a];
        };
        WaterfallSeriesView.prototype.ab = function (a) {
            var b = this.dc._inner[a];
            this.dj._visibility = b._visibility;
            this.dj.n = b.n;
            this.dj.o = b.o;
            this.dj.width = b.width;
            this.dj.height = b.height;
            var c = this.bp(a);
            this.dj._fill = c;
            this.dj._stroke = c;
            this.dj.ac = this.e.fl + 3;
            return this.dj;
        };
        WaterfallSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.dc.count; c++) {
                    var d = this.aa(c, b);
                    this.bd(d, c, b);
                    a.v(d);
                }
            }
        };
        WaterfallSeriesView.prototype.al = function (a) {
            var e_1, _a, e_2, _b;
            _super.prototype.al.call(this, a);
            var b = 0;
            var c = new i2.List$1(i2.Rectangle.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.db.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    c.add(d);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            c.aa(function (e, f) {
                if (e.n < f.n) {
                    return -1;
                }
                else if (e.n > f.n) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    var f = "Negative";
                    if (e._fill == this.e.of) {
                        f = "Positive";
                    }
                    this.e.a6.exportRectangleData(a, e, "column" + b, ["Main", f]);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            b++;
        };
        WaterfallSeriesView.prototype.dh = function (a) {
            var b = this.db.item(a);
            return new i2.Rect(0, b.n, b.o, b.width, b.height);
        };
        WaterfallSeriesView.prototype.di = function (a) {
            return new i2.Rect(0, a.n, a.o, a.width, a.height);
        };
        WaterfallSeriesView.$t = i2.markType(WaterfallSeriesView, 'WaterfallSeriesView', AnchoredCategorySeriesView.$);
        return WaterfallSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent waterfall column series.
    *
    * `IgxWaterfallSeriesComponent` belongs to a group of `IgxCategorySeriesComponent` and it is rendered using a collection of vertical columns that show the difference between consecutive data points.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-waterfall-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-waterfall-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series: IgxWaterfallSeriesComponent = new IgxWaterfallSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxWaterfallSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxWaterfallSeriesComponent, _super);
        function IgxWaterfallSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxWaterfallSeriesComponent.prototype.createImplementation = function () {
            return new WaterfallSeries();
        };
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "isWaterfall", {
            /**
             * Gets whether the current series shows a waterfall column shape.
            */
            get: function () {
                return this.i.ee;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "isFinancialWaterfall", {
            /**
             * Gets whether the series is financial waterfall
            */
            get: function () {
                return this.i.dm;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "isNegativeColorSupported", {
            /**
             * Overridden by derived series classes to indicate when negative colors are supported or not.
            */
            get: function () {
                return this.i.dx;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "negativeBrush", {
            /**
             * Gets or sets the brush to use for negative portions of the series.
            *
            * Gets or sets the color used to draw negative declines in values for this `IgxWaterfallSeriesComponent`.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-waterfall-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         negativeBrush="#ff0000"
            *         valueMemberPath="value">
            *     </igx-waterfall-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath = "value";
            * series.negativeBrush = "#ff0000";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.uq);
            },
            set: function (v) {
                this.i.uq = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            *
            * Gets or sets the amount to round corners in the direction of the X axis in this series.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-waterfall-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         radiusX="15"
            *         radiusY="15"
            *         valueMemberPath="value">
            *     </igx-waterfall-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath = "value";
            * series.radiusX = 15;
            * series.radiusY = 15;
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            *
            * Gets or sets the amount to round corners in the direction of the Y axis in this series.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-waterfall-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         radiusX="15"
            *         radiusY="15"
            *         valueMemberPath="value">
            *     </igx-waterfall-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath = "value";
            * series.radiusX = 15;
            * series.radiusY = 15;
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.uh;
            },
            set: function (v) {
                this.i.uh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWaterfallSeriesComponent.prototype, "negativeOutline", {
            /**
             * Brush to use for outlining negative elements in the waterfall series.
            *
            * Gets or sets the color used to draw borders of negative declines in values for this `IgxWaterfallSeriesComponent`.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-waterfall-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         negativeOutline="#ff0000"
            *         valueMemberPath="value">
            *     </igx-waterfall-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath = "value";
            * series.negativeOutline = "#ff0000";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.ur);
            },
            set: function (v) {
                this.i.ur = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxWaterfallSeriesComponent.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
            this.i.l5(i2.stringToBrush(negativeBrush), i2.stringToBrush(negativeOutline));
        };
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        *
        * Returns a bounding box `Rect` for a data value given a `Point`.
        *
        * ```ts
        * let box : IgxRect = series.getSeriesValueBoundingBox({x: 4, y: 7});
        * ```
        */
        IgxWaterfallSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        *
        * Returns the width of items in the `IgxWaterfallSeriesComponent`.
        *
        * ```ts
        * let itemSpan: number = series.GetItemSpan();
        * ```
        */
        IgxWaterfallSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxWaterfallSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxWaterfallSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxWaterfallSeriesComponent, selector: "igx-waterfall-series", inputs: { negativeBrush: "negativeBrush", radiusX: "radiusX", radiusY: "radiusY", negativeOutline: "negativeOutline" }, providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxWaterfallSeriesComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-waterfall-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWaterfallSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { negativeBrush: [{
                    type: i0.Input
                }], radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }], negativeOutline: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxWaterfallSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxWaterfallSeriesModule() {
        }
        IgxWaterfallSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxWaterfallSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesModule, declarations: [IgxWaterfallSeriesComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxWaterfallSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxWaterfallSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxWaterfallSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxWaterfallSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxWaterfallSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxWaterfallSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxWaterfallSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxWaterfallSeriesComponent", IgxWaterfallSeriesComponent);
            i2.TypeRegistrar.register("WaterfallSeries", WaterfallSeries.$type);
        }
        IgxWaterfallSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxWaterfallSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesDynamicModule, imports: [i1.CommonModule, IgxWaterfallSeriesModule], exports: [IgxWaterfallSeriesModule] });
        IgxWaterfallSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesDynamicModule, imports: [[i1.CommonModule, IgxWaterfallSeriesModule], IgxWaterfallSeriesModule] });
        return IgxWaterfallSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWaterfallSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxWaterfallSeriesModule],
                        exports: [IgxWaterfallSeriesModule],
                        entryComponents: [IgxWaterfallSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available tooltip types to display in the chart.
     */
    var ToolTipType = /*@__PURE__*/ (function (ToolTipType) {
        /**
         * Display default tooltip for each series in the chart.
         */
        ToolTipType[ToolTipType["Default"] = 0] = "Default";
        /**
         * Display individual tooltips for all series in the chart.
         */
        ToolTipType[ToolTipType["Item"] = 1] = "Item";
        /**
         * Display combined tooltip for all series in the chart.
         */
        ToolTipType[ToolTipType["Category"] = 2] = "Category";
        /**
         * Display no tooltips in the chart.
         */
        ToolTipType[ToolTipType["None"] = 3] = "None";
        return ToolTipType;
    })({});
    /**
     * @hidden
     */
    var ToolTipType_$type = i2.markEnum('ToolTipType', 'Default,0|Item,1|Category,2|None,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available display modes of crosshairs lines in the chart.
     */
    var CrosshairsDisplayMode = /*@__PURE__*/ (function (CrosshairsDisplayMode) {
        /**
         * Display crosshair lines depending on chart type, e.g. no vertical crosshair lines for column and waterfall charts.
         */
        CrosshairsDisplayMode[CrosshairsDisplayMode["Auto"] = 0] = "Auto";
        /**
         * Display no crosshair lines in the chart.
         */
        CrosshairsDisplayMode[CrosshairsDisplayMode["None"] = 1] = "None";
        /**
         * Display horizontal line of crosshairs in the chart.
         */
        CrosshairsDisplayMode[CrosshairsDisplayMode["Horizontal"] = 2] = "Horizontal";
        /**
         * Display vertical line of crosshairs in the chart.
         */
        CrosshairsDisplayMode[CrosshairsDisplayMode["Vertical"] = 3] = "Vertical";
        /**
         * Display both horizontal and vertical lines of crosshairs in the chart.
         */
        CrosshairsDisplayMode[CrosshairsDisplayMode["Both"] = 4] = "Both";
        return CrosshairsDisplayMode;
    })({});
    /**
     * @hidden
     */
    var CrosshairsDisplayMode_$type = i2.markEnum('CrosshairsDisplayMode', 'Auto,0|None,1|Horizontal,2|Vertical,3|Both,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChartSeriesEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartSeriesEventArgs, _super);
        function ChartSeriesEventArgs(a) {
            var _this = _super.call(this) || this;
            _this._series = null;
            _this.series = a;
            return _this;
        }
        Object.defineProperty(ChartSeriesEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartSeriesEventArgs.$t = i2.markType(ChartSeriesEventArgs, 'ChartSeriesEventArgs');
        return ChartSeriesEventArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DomainChartSeriesPointerEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DomainChartSeriesPointerEventArgs, _super);
        function DomainChartSeriesPointerEventArgs(a, b) {
            var _this = _super.call(this) || this;
            _this._series = null;
            _this._item = null;
            _this.series = a;
            _this.item = b;
            return _this;
        }
        Object.defineProperty(DomainChartSeriesPointerEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChartSeriesPointerEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        DomainChartSeriesPointerEventArgs.$t = i2.markType(DomainChartSeriesPointerEventArgs, 'DomainChartSeriesPointerEventArgs');
        return DomainChartSeriesPointerEventArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DomainChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DomainChart, _super);
        function DomainChart() {
            var _this = _super.call(this) || this;
            _this.fd = null;
            _this.fc = null;
            _this.cz = null;
            _this.dn = NaN;
            _this.fb = null;
            _this.d1 = 0;
            _this.d2 = 0;
            _this.d3 = 0;
            _this.d0 = 0;
            _this.dw = 0;
            _this.dy = 0;
            _this.dx = 0;
            _this.dv = 0;
            _this.k9 = null;
            _this.la = null;
            _this.dk = NaN;
            _this.d4 = NaN;
            _this.du = NaN;
            _this.di = NaN;
            _this.e3 = 0;
            _this.br = null;
            _this.ew = null;
            _this.cu = false;
            _this.an = null;
            _this.fr = null;
            _this.ft = null;
            _this.bp = null;
            _this.c3 = null;
            _this.propertyChanged = null;
            _this.e2 = 0;
            _this.co = false;
            _this.aj = null;
            _this.cy = null;
            _this.seriesAdded = null;
            _this.seriesRemoved = null;
            _this.seriesPointerEnter = null;
            _this.seriesPointerLeave = null;
            _this.seriesPointerMove = null;
            _this.seriesPointerDown = null;
            _this.seriesPointerUp = null;
            _this.calloutStyleUpdating = null;
            _this.c2 = null;
            _this.bu = null;
            _this.bx = false;
            _this.c9 = null;
            _this.c7 = null;
            _this.b = null;
            _this.a = null;
            _this.g = null;
            _this.j = null;
            _this.e = null;
            _this.f = null;
            _this.al = null;
            _this.b3 = true;
            _this.b5 = true;
            _this.b7 = false;
            _this.b8 = false;
            _this.b4 = false;
            _this.lr = new i2.Rect(0, 0, 0, 1, 1);
            _this.fs = null;
            _this.fq = null;
            _this.ky = 1;
            _this.kx = 1;
            _this.bn = 0;
            _this.dt = 1;
            _this.dz = NaN;
            _this.bh = 0;
            _this.az = 0;
            _this.ax = 0;
            _this.dl = NaN;
            _this.dm = NaN;
            _this.a4 = null;
            _this.av = 4;
            _this.h = null;
            _this.i = null;
            _this.e1 = 400;
            _this.df = NaN;
            _this.bw = false;
            _this.k = null;
            _this.bl = 0;
            _this.d5 = i2.DeviceUtils.g(1.5);
            _this.bv = true;
            _this.dq = NaN;
            _this.ds = NaN;
            _this.dr = NaN;
            _this.dp = NaN;
            _this.x = 0;
            _this.bf = 0;
            _this.bd = 0;
            _this.ap = 0;
            _this.at = 0;
            _this.ar = 0;
            _this.b6 = false;
            _this.dg = i2.DeviceUtils.g(2);
            _this.dh = i2.DeviceUtils.g(60);
            _this.e4 = 7;
            _this.bj = 0;
            _this.z = 0;
            _this.b1 = false;
            _this.k6 = null;
            _this.dj = NaN;
            _this.k5 = null;
            _this.b0 = true;
            _this.k1 = null;
            _this.k3 = null;
            _this.k2 = null;
            _this.k4 = null;
            _this.ey = -1;
            _this.ez = -1;
            _this.b2 = false;
            _this.k7 = null;
            _this.k8 = null;
            _this.e0 = -1;
            _this.bz = false;
            _this.by = false;
            _this.c8 = null;
            _this.fo = null;
            _this.fp = null;
            _this.fn = "CalloutLabel";
            _this.fm = "CalloutContent";
            _this.c2 = new i2.List$1(i2.Delegate_$type, 0);
            _this.jj();
            _this.i1();
            return _this;
        }
        DomainChart.prototype.provideContainer = function (a) {
            if (a == null) {
                this.jz(function (b) { return b.provideContainer(null); });
                return;
            }
            var b = this.fd;
            this.fd = a;
            if (this.bu != null && this.fd != null && b == null) {
                this.fd.setTimeout(this.bu, 0);
                this.bu = null;
            }
            var c = ((function () {
                var $ret = new XamDataChart();
                $ret.dt = true;
                return $ret;
            })());
            c.provideContainer(a);
            this.dataChart = c;
            this.jk();
        };
        DomainChart.prototype.destroy = function () {
            this.provideContainer(null);
        };
        DomainChart.prototype.jk = function () {
            if (this.dataChart == null) {
                return;
            }
            var a = this.dataChart.cf.j.e();
            this.n = a.a;
            this.r = a.f;
            this.p = a.b;
            this.q = a.c;
            this.t = a.g;
            this.ea = Defaults.j;
            this.jl();
        };
        DomainChart.prototype.jl = function () {
        };
        DomainChart.prototype.jh = function (a) {
            if (a == null) {
                return;
            }
            a.f1 = this.et;
            a.fz = this.er;
            a.f0 = this.es;
            a.fy = this.eq;
            a.o6 = this.lp;
            a.fv = this.em;
            a.fx = this.eo;
            a.fw = this.en;
            a.fu = this.el;
            a.o5 = this.lo;
            if (!i2.isNaN_(this.ee)) {
                a.fr = this.ee;
            }
        };
        DomainChart.prototype.je = function () {
        };
        DomainChart.prototype.jn = function (a, b) {
            a.ha = this.e9;
            a.cc = this.bs;
        };
        DomainChart.prototype.j7 = function (a, b, c) {
            var _this = this;
            switch (a) {
                case "TitleTopMargin":
                    if (this.dataChart != null) {
                        this.dataChart.f1 = this.et;
                    }
                    break;
                case "TitleLeftMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fz = this.er;
                    }
                    break;
                case "PixelScalingRatio":
                    if (this.dataChart != null) {
                        this.jz(function (d) { return d.fr = _this.ee; });
                    }
                    break;
                case "TitleRightMargin":
                    if (this.dataChart != null) {
                        this.dataChart.f0 = this.es;
                    }
                    break;
                case "TitleBottomMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fy = this.eq;
                    }
                    break;
                case "TitleTextColor":
                    if (this.dataChart != null) {
                        this.dataChart.o6 = this.lp;
                    }
                    break;
                case "SubtitleLeftMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fv = this.em;
                    }
                    break;
                case "SubtitleTopMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fx = this.eo;
                    }
                    break;
                case "SubtitleRightMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fw = this.en;
                    }
                    break;
                case "SubtitleBottomMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fu = this.el;
                    }
                    break;
                case "SubtitleTextColor":
                    if (this.dataChart != null) {
                        this.dataChart.o5 = this.lo;
                    }
                    break;
                case "LeftMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fq = this.eb;
                    }
                    break;
                case "TopMargin":
                    if (this.dataChart != null) {
                        this.dataChart.f2 = this.eu;
                    }
                    break;
                case "RightMargin":
                    if (this.dataChart != null) {
                        this.dataChart.ft = this.ek;
                    }
                    break;
                case "BottomMargin":
                    if (this.dataChart != null) {
                        this.dataChart.fm = this.d9;
                    }
                    break;
                case "TransitionDuration":
                    this.ja(function (d) { return d.ha = _this.e9; });
                    break;
                case "TransitionEasingFunction":
                    this.ja(function (d) { return d.cc = _this.bs; });
                    break;
            }
        };
        Object.defineProperty(DomainChart.prototype, "tooltipTemplate", {
            get: function () {
                return i2.ArrayExtension.getModulus$1(i2.Base.$, this.tooltipTemplates, 0);
            },
            set: function (a) {
                this.tooltipTemplates = a == null ? null : new i2.List$1(i2.Base.$, 1, [a]);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "tooltipTemplates", {
            get: function () {
                return this.cz;
            },
            set: function (a) {
                var b = this.tooltipTemplates;
                if (a != b) {
                    this.cz = a;
                    this.j6("TooltipTemplates", b, this.tooltipTemplates);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ee", {
            get: function () {
                return this.dn;
            },
            set: function (a) {
                var b = this.dn;
                if (a != b) {
                    this.dn = a;
                    this.j6("PixelScalingRatio", b, this.ee);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "toolTip", {
            get: function () {
                return this.fb;
            },
            set: function (a) {
                var b = this.toolTip;
                if (b != a) {
                    this.fb = a;
                    this.j6("ToolTip", b, this.toolTip);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "er", {
            get: function () {
                return this.d1;
            },
            set: function (a) {
                var b = this.er;
                if (a != b) {
                    this.d1 = a;
                    this.j6("TitleLeftMargin", b, this.er);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "es", {
            get: function () {
                return this.d2;
            },
            set: function (a) {
                var b = this.es;
                if (a != b) {
                    this.d2 = a;
                    this.j6("TitleRightMargin", b, this.es);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "et", {
            get: function () {
                return this.d3;
            },
            set: function (a) {
                var b = this.et;
                if (a != b) {
                    this.d3 = a;
                    this.j6("TitleTopMargin", b, this.et);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "eq", {
            get: function () {
                return this.d0;
            },
            set: function (a) {
                var b = this.eq;
                if (a != b) {
                    this.d0 = a;
                    this.j6("TitleBottomMargin", b, this.eq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "em", {
            get: function () {
                return this.dw;
            },
            set: function (a) {
                var b = this.em;
                if (a != b) {
                    this.dw = a;
                    this.j6("SubtitleLeftMargin", b, this.em);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "eo", {
            get: function () {
                return this.dy;
            },
            set: function (a) {
                var b = this.eo;
                if (a != b) {
                    this.dy = a;
                    this.j6("SubtitleTopMargin", b, this.eo);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "en", {
            get: function () {
                return this.dx;
            },
            set: function (a) {
                var b = this.en;
                if (a != b) {
                    this.dx = a;
                    this.j6("SubtitleRightMargin", b, this.en);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "el", {
            get: function () {
                return this.dv;
            },
            set: function (a) {
                var b = this.el;
                if (a != b) {
                    this.dv = a;
                    this.j6("SubtitleBottomMargin", b, this.el);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lo", {
            get: function () {
                return this.k9;
            },
            set: function (a) {
                var b = this.lo;
                if (a != b) {
                    this.k9 = a;
                    this.j6("SubtitleTextColor", b, this.lo);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lp", {
            get: function () {
                return this.la;
            },
            set: function (a) {
                var b = this.lp;
                if (a != b) {
                    this.la = a;
                    this.j6("TitleTextColor", b, this.lp);
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_eb = function () {
            return this.dk;
        };
        DomainChart.prototype.set_eb = function (a) {
            var b = this.eb;
            if (a != b) {
                this.dk = a;
                this.j6("LeftMargin", b, this.eb);
            }
        };
        Object.defineProperty(DomainChart.prototype, "eb", {
            get: function () {
                return this.get_eb();
            },
            set: function (a) {
                this.set_eb(a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "eu", {
            get: function () {
                return this.d4;
            },
            set: function (a) {
                var b = this.eu;
                if (a != b) {
                    this.d4 = a;
                    this.j6("TopMargin", b, this.eu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ek", {
            get: function () {
                return this.du;
            },
            set: function (a) {
                var b = this.ek;
                if (a != b) {
                    this.du = a;
                    this.j6("RightMargin", b, this.ek);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "d9", {
            get: function () {
                return this.di;
            },
            set: function (a) {
                var b = this.d9;
                if (a != b) {
                    this.di = a;
                    this.j6("BottomMargin", b, this.d9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "e9", {
            get: function () {
                return this.e3;
            },
            set: function (a) {
                var b = this.e9;
                if (a != b) {
                    this.e3 = a;
                    this.j6("TransitionDuration", b, this.e9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "bs", {
            get: function () {
                return this.br;
            },
            set: function (a) {
                var b = this.bs;
                if (a != b) {
                    this.br = a;
                    this.j6("TransitionEasingFunction", b, this.bs);
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.ji = function (a) {
            if (this.dataChart == null) {
                return;
            }
            a.im = this.ih;
            a.h9 = this.h5;
        };
        DomainChart.prototype.jo = function (a, b) {
            this.jp(a, b);
        };
        DomainChart.prototype.jf = function () {
        };
        DomainChart.prototype.jp = function (a, b) {
            if (a == null) {
                return;
            }
            var toolTipTemplate_ = i2.ArrayExtension.getModulus$1(i2.Base.$, this.tooltipTemplates, b);
            if (toolTipTemplate_ == null) {
                a.el = true;
            }
            else {
                var series_ = a;
                a.el = false;
                series_.externalObject.tooltipTemplate = toolTipTemplate_;
            }
        };
        DomainChart.prototype.kv = function (a, b, c) {
        };
        DomainChart.prototype.ff = function (a) {
            return a;
            return null;
        };
        DomainChart.prototype.ex = function (a) {
            return null;
        };
        DomainChart.prototype.j8 = function (a, b, c) {
            var _this = this;
            switch (a) {
                case "SubtitleTextStyle":
                    if (this.dataChart != null) {
                        this.dataChart.h9 = this.h5;
                    }
                    break;
                case "TitleTextStyle":
                    if (this.dataChart != null) {
                        this.dataChart.im = this.ih;
                    }
                    break;
                case "TooltipTemplate":
                    if (this.cu) {
                        return;
                    }
                    this.cu = true;
                    this.tooltipTemplate = this.ff(this.tooltipTemplate);
                    this.cu = false;
                    if (this.dataChart != null) {
                        this.dataChart.gh = this.tooltipTemplate;
                    }
                    this.toolTip = this.tooltipTemplate;
                    break;
                case "ToolTip":
                    this.jb(function (d, e) { return _this.jp(d, e); });
                    break;
                case "TooltipTemplates":
                    if (this.tooltipTemplates == null) {
                        break;
                    }
                    this.cu = true;
                    this.jb(function (d, e) {
                        var f = _this.ff(i2.ArrayExtension.getModulus$1(i2.Base.$, _this.tooltipTemplates, e));
                        var series_ = d;
                        var templ_ = f;
                        series_.externalObject.tooltipTemplate = templ_;
                    });
                    this.cu = false;
                    break;
            }
        };
        Object.defineProperty(DomainChart.prototype, "ao", {
            get: function () {
                return this.an;
            },
            set: function (a) {
                var b = this.ao;
                if (a != b) {
                    this.an = a;
                    this.j6("Widget", b, this.ao);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "h5", {
            get: function () {
                return this.fr;
            },
            set: function (a) {
                var b = this.h5;
                if (a != b) {
                    this.fr = a;
                    this.j6("SubtitleTextStyle", b, this.h5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ih", {
            get: function () {
                return this.ft;
            },
            set: function (a) {
                var b = this.ih;
                if (a != b) {
                    this.ft = a;
                    this.j6("TitleTextStyle", b, this.ih);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "dataChart", {
            get: function () {
                return this.bp;
            },
            set: function (a) {
                var b = this.dataChart;
                if (b != a) {
                    this.bp = a;
                    this.j6("DataChart", b, this.dataChart);
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.onDetachedFromUI = function () {
            this.jz(function (a) { return a.onDetachedFromUI(); });
        };
        DomainChart.prototype.onAttachedToUI = function () {
            this.jz(function (a) { return a.onAttachedToUI(); });
        };
        DomainChart.prototype.jj = function () {
            var e_1, _a, e_2, _b;
            this.c3 = new i2.List$1(MarkerType_$type, 0);
            this.ac = new i2.DataSeriesAdapter().e;
            if (this.d != null) {
                this.ac.includedProperties = this.d;
            }
            if (this.c != null) {
                this.ac.excludedProperties = this.c;
            }
            this.ac.supportedSeriesTypes = this.c5.toArray();
            this.ac.rules.clear();
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.c4)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.ac.rules.add(a);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var b = new i2.List$1(i2.String_$type, 0);
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.ac.rules)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    b.add(i2.getInstanceType(c).typeName);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            var d = this.ac.dataSeries;
            d.collectionChanged = i2.delegateCombine(d.collectionChanged, i2.runOn(this, this.j2));
        };
        DomainChart.prototype.cq = function (a) {
            return a != 24 && this.c5.contains(a);
        };
        DomainChart.prototype.notifyResized = function () {
            this.jz(function (a) { return a.notifyContainerResized(); });
        };
        DomainChart.prototype.jx = function () {
            this.jz(function (a) {
                for (var b = 0; b < a.series.count; b++) {
                    a.series._inner[b].k9();
                }
            });
        };
        DomainChart.prototype.i5 = function () {
            if (this.dataChart == null) {
                return;
            }
            if (this.co) {
                this.kp();
            }
            this.dataChart.flush();
        };
        DomainChart.prototype.jc = function () {
            if (this.dataChart == null) {
                return;
            }
            this.dataChart.jk();
        };
        DomainChart.prototype.kd = function (a) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        DomainChart.prototype.i6 = function (a) {
            this.i7(function (b, c) { return a(b); });
        };
        DomainChart.prototype.i7 = function (a) {
            if (this.dataChart == null) {
                return;
            }
            for (var b = 0; b < this.dataChart.series.count; b++) {
                a(this.dataChart.series._inner[b], b);
            }
        };
        DomainChart.prototype.ja = function (a) {
            this.jb(function (b, c) { return a(b); });
        };
        DomainChart.prototype.jb = function (a) {
            if (this.dataChart == null) {
                return;
            }
            for (var b = 0; b < this.dataChart.series.count; b++) {
                var c = this.dataChart.series._inner[b];
                if (!c.c5) {
                    a(c, b);
                }
            }
        };
        DomainChart.prototype.i8 = function (a) {
            this.i9(function (b, c) { return a(b); });
        };
        DomainChart.prototype.i9 = function (a) {
            if (this.dataChart == null) {
                return;
            }
            for (var b = 0; b < this.dataChart.series.count; b++) {
                var c = this.dataChart.series._inner[b];
                if (c.c6) {
                    a(c, b);
                }
            }
        };
        DomainChart.prototype.km = function () {
            this.i6(function (a) { return a.l3(); });
        };
        DomainChart.prototype.jz = function (a) {
            this.j0(a, true);
        };
        DomainChart.prototype.j0 = function (a, b) {
            this.j1(a, b, null);
        };
        DomainChart.prototype.j1 = function (a, b, c) {
            if (this.dataChart == null) {
                return;
            }
            a(this.dataChart);
        };
        DomainChart.prototype.cr = function (a) {
            if (!this.cq(a.suggestedSeries)) {
                return false;
            }
            var b = a.data;
            if (b == null) {
                return false;
            }
            return true;
        };
        DomainChart.prototype.cj = function () {
            if (this.dataChart == null) {
                return false;
            }
            return true;
        };
        DomainChart.prototype.gz = function (a) {
            var b = "series_" + (this.dataChart.series.count + 1) + "_" + i2.EnumUtil.getName(i2.DataSeriesType_$type, a.suggestedSeries);
            return b;
        };
        DomainChart.prototype.g0 = function (a, b) {
            if (this.cm && this.cx) {
                var c = "";
                var d = 5 + Math.round(DomainChart.fk.nextDouble() * 4);
                for (var e = 0; e < d; e++) {
                    c = c + "\u2588";
                }
                return c;
            }
            if (i2.stringIsNullOrEmpty(a.title)) {
                var f = i2.EnumUtil.getName(i2.DataSeriesType_$type, b);
                return f + (this.dataChart.series.count + 1);
            }
            else {
                return a.title;
            }
        };
        DomainChart.prototype.gy = function () {
            return i2.stringEmpty();
        };
        DomainChart.prototype.kp = function () {
            var e_3, _a, e_4, _b;
            if (this.dataChart == null) {
                return;
            }
            this.co = false;
            this.kr();
            if (this.actualItemsSource == null) {
                return;
            }
            var a = new i2.List$1(MarkerType_$type, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.ac.dataSeries)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.add(this.a1(b.suggestedMarker));
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            this.c3 = a;
            var c = 0;
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.ac.dataSeries)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    if (!this.cr(d)) {
                        continue;
                    }
                    if (d.index < 0) {
                        d.index = c;
                    }
                    this.kn(d);
                    this.ko(d);
                    c++;
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            this.kw();
            this.i7(i2.runOn(this, this.jm));
        };
        DomainChart.prototype.bc = function (seriesType_) {
            return (this.externalObject.createSeries(seriesType_).i);
        };
        DomainChart.prototype.a6 = function () {
            return this.bc(28);
        };
        DomainChart.prototype.a8 = function () {
            return this.bc(27);
        };
        DomainChart.prototype.a9 = function () {
            return this.bc(29);
        };
        DomainChart.prototype.ba = function () {
            return this.bc(25);
        };
        DomainChart.prototype.a7 = function () {
            return this.bc(26);
        };
        Object.defineProperty(DomainChart.prototype, "ak", {
            get: function () {
                if (i2.TypeRegistrar.isRegistered("AnnotationLayerProxy")) {
                    return i2.TypeRegistrar.create("AnnotationLayerProxy");
                }
                else {
                    throw new i2.BaseError(1, "annotation layer module is not loaded, but is required.");
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ch", {
            get: function () {
                return (i2.TypeRegistrar.isRegistered("AnnotationLayerProxy"));
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.ci = function (a) {
            if (!this.ch) {
                return false;
            }
            return this.ak.matchesType(a);
        };
        DomainChart.prototype.kw = function () {
            var a = this.c1("", true);
            if (a != null) {
                for (var b = 0; b < a.count; b++) {
                    this.dataChart.series.add(a._inner[b]);
                }
            }
        };
        DomainChart.prototype.ck = function () {
            return this.aa == 0 || this.aa == 4 || this.aa == 2;
        };
        DomainChart.prototype.cl = function () {
            return this.aa == 0 || this.aa == 4 || this.aa == 3;
        };
        DomainChart.prototype.c1 = function (a, b) {
            var e_5, _a, e_6, _b;
            if (!this.ch) {
                return null;
            }
            var c = new i2.List$1(Series.$, 0);
            if (b) {
                if (this.bz) {
                    var d = 1;
                    if (this.c8 == null) {
                        try {
                            for (var _c = tslib.__values(i2.fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var e = _d.value;
                                var f = this.a6();
                                this.ak.setTargetSeries(f, e);
                                this.ak.setCollisionChannel(f, "MainChartCollisionChannel");
                                this.ku(f, e, this.ac.dataSeries._inner[d - 1]);
                                f.name = a + i2.getInstanceType(f).typeName + d.toString();
                                c.add(f);
                                d++;
                            }
                        }
                        catch (e_5_1) {
                            e_5 = { error: e_5_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_5)
                                    throw e_5.error;
                            }
                        }
                        ;
                    }
                    else {
                        var g = this.a6();
                        this.ku(g, null, this.ac.dataSeries._inner[d - 1]);
                        g.name = a + i2.getInstanceType(g).typeName + d.toString();
                        c.add(g);
                    }
                }
            }
            switch (this.z) {
                case 0:
                case 4:
                case 3:
                case 2:
                    {
                        var h = this.a8();
                        this.ak.setCrosshairThickness(h, this.dj);
                        this.ak.setCrosshairUseInterpolation(h, !this.b1);
                        this.ak.setCrosshairHorizontalLineVisibility(h, this.ck() ? 0 : 1);
                        this.ak.setCrosshairHorizontalLineStroke(h, this.k5);
                        this.ak.setCrosshairVerticalLineVisibility(h, this.cl() ? 0 : 1);
                        this.ak.setCrosshairVerticalLineStroke(h, this.k6);
                        this.ak.setCrosshairOnAxesEnabled(h, this.b0);
                        this.ak.setCrosshairXAxisBackground(h, this.k1);
                        this.ak.setCrosshairXAxisForeground(h, this.k2);
                        this.ak.setCrosshairYAxisBackground(h, this.k3);
                        this.ak.setCrosshairYAxisForeground(h, this.k4);
                        this.ak.setCrosshairXAxisPrecision(h, this.ey);
                        this.ak.setCrosshairYAxisPrecision(h, this.ez);
                        c.add(h);
                        break;
                    }
                case 1:
                    {
                        break;
                    }
            }
            if (this.b2) {
                var i = this.a9();
                this.ak.setFinalValueBackground(i, this.k7);
                this.ak.setFinalValueForeground(i, this.k8);
                this.ak.setFinalValuePrecision(i, this.e0);
                c.add(i);
            }
            if (b) {
                switch (this.bj) {
                    case 1:
                        {
                            var j = this.ba();
                            c.add(j);
                            break;
                        }
                    case 2:
                        {
                            var k = this.a7();
                            c.add(k);
                            break;
                        }
                    case 3:
                        {
                            this.i6(function (l) { return l.el = false; });
                            break;
                        }
                    case 0:
                        {
                            this.i6(function (l) { return l.el = true; });
                            break;
                        }
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var l = _f.value;
                    if (i2.stringIsNullOrEmpty(l.name) == false) {
                        continue;
                    }
                    l.name = a + i2.getInstanceType(l).typeName;
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            return c;
        };
        DomainChart.prototype.ku = function (a, b, c) {
            a.itemsSource = this.c8 != null ? this.c8 : b.itemsSource;
            this.ak.setXMemberPath(a, this.fo);
            this.ak.setYMemberPath(a, this.fp);
            this.ak.setLabelMemberPath(a, this.fn);
            this.ak.setContentMemberPath(a, this.fm);
        };
        DomainChart.prototype.kr = function () {
            this.ks(this.dataChart);
        };
        DomainChart.prototype.ks = function (a) {
            var e_7, _a;
            var _this = this;
            if (a != null && a == this.dataChart) {
                this.kq();
            }
            if (a == null || a.series.count == 0) {
                return;
            }
            this.i6(function (b) {
                if (_this.ci(b) && _this.ak.isCalloutLayer(b)) {
                    _this.ak.removeCalloutStyleUpdating(b, i2.runOn(_this, _this.kc));
                }
                _this.kk(b);
            });
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.kt(b);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            a.series.clear();
        };
        DomainChart.prototype.kt = function (a) {
            a.itemsSource = null;
            a.legend = null;
            a.ke();
        };
        DomainChart.prototype.j2 = function (a, b) {
            if (this.dataChart == null) {
                return;
            }
            var c = b.oldItems == null ? "null" : b.oldItems.count.toString();
            var d = b.newItems == null ? "null" : b.newItems.count.toString();
            if (this.co) {
                return;
            }
            var e = this.kb(i2.runOn(this, this.i3), this.co);
            this.co = e.p1;
        };
        DomainChart.prototype.i3 = function () {
            this.kp();
        };
        DomainChart.prototype.lj = function (a) {
            return i2.ArrayExtension.getModulus$1(i2.Brush.$, this.l, a);
        };
        DomainChart.prototype.lm = function (a) {
            return i2.ArrayExtension.getModulus$1(i2.Brush.$, this.m, a);
        };
        DomainChart.prototype.lk = function (a) {
            return i2.ArrayExtension.getModulus$1(i2.Brush.$, this.p, a);
        };
        DomainChart.prototype.ll = function (a) {
            return i2.ArrayExtension.getModulus$1(i2.Brush.$, this.q, a);
        };
        DomainChart.prototype.lq = function (a) {
            var b = new i2.Color();
            if (this.l == null || this.l.count == 0) {
                b = i2.ArrayExtension.getModulus$1(i2.Color.$, this.c0, a);
            }
            else {
                var c = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.l, a);
                if (c == null) {
                    b = i2.ArrayExtension.getModulus$1(i2.Color.$, this.c0, a);
                }
                else {
                    b = i2.ColorUtil.q(c);
                }
            }
            return b;
        };
        DomainChart.prototype.bt = function (a) {
            var b = new i2.ObservableColorCollection();
            b.add(i2.ColorUtil.v(a, 0.5));
            b.add(a);
            return b;
        };
        DomainChart.prototype.o = function (a) {
            var b = this.bt(a);
            var c = i2.BrushCollectionUtil.a(b);
            return c;
        };
        Object.defineProperty(DomainChart.prototype, "c0", {
            get: function () {
                if (this.cy != null) {
                    return this.cy;
                }
                this.cy = new i2.List$1(i2.Color.$, 0);
                this.cy.add(i2.ColorUtil.r("#8BDC5C"));
                this.cy.add(i2.ColorUtil.r("#8961A9"));
                this.cy.add(i2.ColorUtil.r("#6DB1FF"));
                this.cy.add(i2.ColorUtil.r("#82E9D9"));
                this.cy.add(i2.ColorUtil.r("#EA3C63"));
                this.cy.add(i2.ColorUtil.r("#735656"));
                this.cy.add(i2.ColorUtil.r("#F8CE4F"));
                this.cy.add(i2.ColorUtil.r("#A8A8B7"));
                this.cy.add(i2.ColorUtil.r("#E051A9"));
                this.cy.add(i2.ColorUtil.r("#FF903B"));
                return this.cy;
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.fe = function () {
            if (this.dataChart == null) {
                return null;
            }
            return this.dataChart.rm();
        };
        DomainChart.prototype.jq = function (a, b) {
        };
        DomainChart.prototype.jr = function (a, b, c) {
        };
        DomainChart.prototype.a1 = function (a) {
            if (a == 2) {
                return 3;
            }
            else if (a == 12) {
                return 13;
            }
            else if (a == 6) {
                return 7;
            }
            else if (a == 8) {
                return 9;
            }
            else if (a == 11) {
                return 12;
            }
            else if (a == 1) {
                return 1;
            }
            else if (a == 7) {
                return 8;
            }
            else if (a == 10) {
                return 11;
            }
            else if (a == 4) {
                return 5;
            }
            else if (a == 5) {
                return 6;
            }
            else if (a == 9) {
                return 10;
            }
            else if (a == 3) {
                return 4;
            }
            else if (a == 13) {
                return 0;
            }
            return 2;
        };
        DomainChart.prototype.jw = function (source_, a, b, c) {
            if (this.ac != null) {
                this.ac.notifySetItem(source_, a, b, c);
            }
            if (this.dataChart != null) {
                this.dataChart.jy(source_, a, b, c);
            }
        };
        DomainChart.prototype.js = function (source_) {
            if (this.ac != null) {
                this.ac.notifyClearItems(source_);
            }
            if (this.dataChart != null) {
                this.dataChart.jt(source_);
            }
        };
        DomainChart.prototype.jt = function (source_, a, b) {
            if (this.ac != null) {
                this.ac.notifyInsertItem(source_, a, b);
            }
            if (this.dataChart != null) {
                this.dataChart.jw(source_, a, b);
            }
        };
        DomainChart.prototype.ju = function (source_, a, b) {
            if (this.ac != null) {
                this.ac.notifyRemoveItem(source_, a, b);
            }
            if (this.dataChart != null) {
                this.dataChart.jx(source_, a, b);
            }
        };
        DomainChart.prototype.ke = function (a) {
            if (this.seriesAdded != null && a != null) {
                this.seriesAdded(this, new ChartSeriesEventArgs(a));
            }
        };
        DomainChart.prototype.kk = function (a) {
            if (this.seriesRemoved != null && a != null) {
                this.seriesRemoved(this, new ChartSeriesEventArgs(a));
            }
        };
        DomainChart.prototype.kg = function (a, b) {
            if (this.seriesPointerEnter != null && a != null) {
                this.seriesPointerEnter(this, new DomainChartSeriesPointerEventArgs(a, b));
            }
        };
        DomainChart.prototype.kh = function (a, b) {
            if (this.seriesPointerLeave != null && a != null) {
                this.seriesPointerLeave(this, new DomainChartSeriesPointerEventArgs(a, b));
            }
        };
        DomainChart.prototype.ki = function (a, b) {
            if (this.seriesPointerMove != null && a != null) {
                this.seriesPointerMove(this, new DomainChartSeriesPointerEventArgs(a, b));
            }
        };
        DomainChart.prototype.kf = function (a, b) {
            if (this.seriesPointerDown != null && a != null) {
                this.seriesPointerDown(this, new DomainChartSeriesPointerEventArgs(a, b));
            }
        };
        DomainChart.prototype.kj = function (a, b) {
            if (this.seriesPointerUp != null && a != null) {
                this.seriesPointerUp(this, new DomainChartSeriesPointerEventArgs(a, b));
            }
        };
        DomainChart.prototype.kc = function (a, b) {
            if (this.calloutStyleUpdating != null && a != null) {
                this.calloutStyleUpdating(this, b);
            }
        };
        DomainChart.prototype.ka = function (a) {
            var _this = this;
            if (!this.c2.contains(a)) {
                this.c2.add(a);
                var b = false;
                var c = this.kb(function () {
                    a();
                    _this.c2.remove(a);
                }, b);
                b = c.p1;
            }
        };
        DomainChart.prototype.kb = function (a, b) {
            if (!b) {
                b = true;
                if (this.fd != null) {
                    this.fd.setTimeout(a, 0);
                }
                else {
                    this.bu = a;
                }
            }
            return {
                p1: b
            };
        };
        DomainChart.prototype.get_cs = function () {
            return true;
        };
        Object.defineProperty(DomainChart.prototype, "cs", {
            get: function () {
                return this.get_cs();
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.jg = function (a) {
            var _this = this;
            var b = a == this.dataChart;
            if (b) {
                a.ag = this.l;
            }
            if (b) {
                a.aj = this.m;
            }
            a.ah = this.p;
            a.ai = this.q;
            a.a9 = this.aw;
            a.legend = this.legend;
            a.qi = this.cn;
            a.ql = this.ct && this.cs;
            if (a.bq != this.bg || a.bo != this.be) {
                a.cf.b4(this.fd);
                a.bq = this.bg;
                a.bo = this.be;
            }
            a.p4 = this.y;
            if (!i2.isNaN_(this.eg)) {
                a.rg = this.eg;
            }
            if (!i2.isNaN_(this.ei)) {
                a.ri = this.ei;
            }
            if (!i2.isNaN_(this.eh)) {
                a.rh = this.eh;
            }
            if (!i2.isNaN_(this.ef)) {
                a.rf = this.ef;
            }
            a.a6 = this.aq;
            a.qn = this.cv;
            a.q9 = this.d7;
            a.ra = this.d8;
            a.seriesMouseEnter = i2.delegateCombine(a.seriesMouseEnter, function (c, d) { return _this.kg(d.series, d.item); });
            a.seriesMouseLeave = i2.delegateCombine(a.seriesMouseLeave, function (c, d) { return _this.kh(d.series, d.item); });
            a.seriesMouseMove = i2.delegateCombine(a.seriesMouseMove, function (c, d) { return _this.ki(d.series, d.item); });
            a.seriesMouseLeftButtonDown = i2.delegateCombine(a.seriesMouseLeftButtonDown, function (c, d) { return _this.kf(d.series, d.item); });
            a.seriesMouseLeftButtonUp = i2.delegateCombine(a.seriesMouseLeftButtonUp, function (c, d) { return _this.kj(d.series, d.item); });
            if (b) {
                a.pw = this.lt;
            }
            if (b) {
                a.ie = this.h9;
            }
            a.om = this.k0;
            if (b) {
                a.h2 = this.hy;
            }
            a.ol = this.kz;
            a.qe = this.b9;
            a.da = this.ca;
            a.fq = this.eb;
            a.ft = this.ek;
            a.f2 = this.eu;
            a.fm = this.d9;
            if (a == this.dataChart) {
                this.kp();
            }
            this.jh(a);
            this.ji(a);
        };
        DomainChart.prototype.s = function (a) {
            var e_8, _a;
            if (!this.cw || !this.cx || this.itemsSource != null) {
                return a;
            }
            if (a == null) {
                return null;
            }
            var b = new i2.BrushCollection();
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = i2.BrushUtil.r(c);
                    b.add(d);
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            return b;
        };
        DomainChart.prototype.ln = function (a) {
            if (!this.cw || !this.cx || this.itemsSource != null) {
                return a;
            }
            var b = i2.BrushUtil.g(0, 0, 0, 0);
            return b;
        };
        DomainChart.prototype.jm = function (a, b) {
            if (!i2.isNaN_(this.ej)) {
                a.gh = this.ej;
            }
            if (!i2.isNaN_(this.ep) && !a.c6) {
                a.gm = this.ep;
            }
            if (!i2.isNaN_(this.ea) && a.c6) {
                a.gm = this.ea;
            }
            a.a9 = this.au;
            a.a7 = this.as;
            a.bs = this.bi;
            a.mh(this.a0);
            a.mg(this.ay);
            a.ge = this.ec;
            if (!i2.isNaN_(this.ep)) {
                a.mi(this.ed);
            }
            if (!i2.isNaN_(this.d6)) {
                a.fq = this.d6;
            }
            if (a.isUsableInLegend) {
                a.legend = this.legend;
            }
            if (i2.typeCast(i2.IUnknownValuePlotting_$type, a) !== null) {
                a.unknownValuePlotting = this.bo;
            }
            a.dq = this.cp;
            if (this.ci(a) && this.ak.isCalloutLayer(a)) {
                this.ak.setCalloutStyleUpdatingEventEnabled(a, this.cc);
                this.ak.addCalloutStyleUpdating(a, i2.runOn(this, this.kc));
            }
            this.iz(a, b);
            this.i0(a, b);
            this.jn(a, b);
            this.jo(a, b);
            this.ke(a);
        };
        Object.defineProperty(DomainChart.prototype, "cb", {
            get: function () {
                return this.bx;
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.i4 = function () {
            if (!this.bx) {
                this.bx = true;
                this.jd();
            }
        };
        DomainChart.prototype.jd = function () {
            this.je();
            this.jf();
        };
        DomainChart.prototype.kl = function (a) {
            this.ks(a);
        };
        DomainChart.prototype.i0 = function (a, b) {
            var c = i2.typeCast(ITrendLineSeries_$type, a);
            if (c != null) {
                c.trendLineBrush = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.t, b);
                c.trendLineThickness = this.ev;
                c.trendLineType = this.bm;
                c.trendLinePeriod = this.fa;
            }
        };
        DomainChart.prototype.a3 = function (a, b) {
            if (this.a5 == null || this.a5.count == 0) {
                if (this.c3 == null || this.c3.count == 0) {
                    return a != null && a.dw ? 1 : 2;
                }
                var c = i2.ArrayExtension.getModulus$1(MarkerType_$type, this.c3, b);
                if (c == 0 && a != null) {
                    c = a.dw ? 1 : 2;
                    if (c == 2) {
                        c = this.a2(a);
                    }
                }
                if (c == 2) {
                    if (a == null) {
                        return 1;
                    }
                    else {
                        return 2;
                    }
                }
                return c;
            }
            return i2.ArrayExtension.getModulus$1(MarkerType_$type, this.a5, b);
        };
        DomainChart.prototype.a2 = function (a) {
            return 2;
        };
        DomainChart.prototype.dd = function () {
            if (this.itemsSource != null) {
                return this.itemsSource;
            }
            if (this.cw) {
                return this.de();
            }
            return null;
        };
        DomainChart.prototype.get_cm = function () {
            if (this.itemsSource == null && this.cw) {
                if (this.de() != null) {
                    return true;
                }
            }
            return false;
        };
        Object.defineProperty(DomainChart.prototype, "cm", {
            get: function () {
                return this.get_cm();
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.de = function () {
            return null;
        };
        DomainChart.prototype.j6 = function (a, b, c) {
            var _this = this;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            switch (a) {
                case "DataChart":
                    this.kl(i2.typeCast(XamDataChart.$, b));
                    this.jg(i2.typeCast(XamDataChart.$, c));
                    break;
                case "ShouldUseSkeletonStyleForMockData":
                case "ShouldDisplayMockData":
                    this.actualItemsSource = this.dd();
                    this.l = this.s(this.n);
                    this.m = this.s(this.r);
                    break;
                case "ActualBrushes":
                    this.j1(function (d) { return d.ag = _this.l; }, true, a);
                    break;
                case "ActualOutlines":
                    this.j1(function (d) { return d.aj = _this.m; }, true, a);
                    break;
                case "ActualItemsSource":
                    if (this.cw) {
                        this.l = this.s(this.n);
                        this.m = this.s(this.r);
                    }
                    this.ac.itemsSource = this.actualItemsSource;
                    break;
                case "ItemsSource":
                    this.actualItemsSource = this.dd();
                    break;
                case "IncludedProperties":
                    this.ac.includedProperties = this.d;
                    break;
                case "ExcludedProperties":
                    this.ac.excludedProperties = this.c;
                    break;
                case "Brushes":
                    this.l = this.s(this.n);
                    break;
                case "Outlines":
                    this.m = this.s(this.r);
                    break;
                case "Legend":
                    this.jz(function (d) { return d.legend = _this.legend; });
                    break;
                case "HighlightingMode":
                    this.jz(function (d) { return d.bq = _this.bg; });
                    break;
                case "HighlightingBehavior":
                    this.jz(function (d) { return d.bo = _this.be; });
                    break;
                case "LegendHighlightingMode":
                    this.jz(function (d) { return d.a6 = _this.aq; });
                    break;
                case "LegendItemBadgeShape":
                    this.jz(function (d) { return d.a8 = _this.au; });
                    break;
                case "LegendItemBadgeMode":
                    this.jz(function (d) { return d.a7 = _this.as; });
                    break;
                case "PlotAreaMarginLeft":
                    this.jz(function (d) { return d.rg = _this.eg; });
                    break;
                case "PlotAreaMarginTop":
                    this.jz(function (d) { return d.ri = _this.ei; });
                    break;
                case "PlotAreaMarginRight":
                    this.jz(function (d) { return d.rh = _this.eh; });
                    break;
                case "PlotAreaMarginBottom":
                    this.jz(function (d) { return d.rf = _this.ef; });
                    break;
                case "ComputedPlotAreaMarginMode":
                    this.jz(function (d) { return d.p4 = _this.y; });
                    break;
                case "ShouldAutoExpandMarginForInitialLabels":
                    this.jz(function (d) { return d.qn = _this.cv; });
                    break;
                case "AutoExpandMarginExtraPadding":
                    this.jz(function (d) { return d.q9 = _this.d7; });
                    break;
                case "AutoExpandMarginMaximumValue":
                    this.jz(function (d) { return d.ra = _this.d8; });
                    break;
                case "IsHorizontalZoomEnabled":
                    this.jz(function (d) { return d.qi = _this.cn; });
                    break;
                case "IsVerticalZoomEnabled":
                    this.jz(function (d) { return d.ql = _this.ct; });
                    break;
                case "WindowRect":
                    this.j0(function (d) { return d.pw = _this.lt; }, false);
                    break;
                case "Title":
                    this.j0(function (d) { return d.ie = _this.h9; }, false);
                    break;
                case "Subtitle":
                    this.j0(function (d) { return d.h2 = _this.hy; }, false);
                    break;
                case "TitleAlignment":
                    this.jz(function (d) { return d.om = _this.k0; });
                    break;
                case "SubtitleAlignment":
                    this.jz(function (d) { return d.ol = _this.kz; });
                    break;
                case "UnknownValuePlotting":
                    this.i6(function (d) {
                        if (i2.typeCast(i2.IUnknownValuePlotting_$type, d) !== null) {
                            d.unknownValuePlotting = _this.bo;
                        }
                    });
                    break;
                case "IsSeriesHighlightingEnabled":
                    this.i6(function (d) { return d.dq = _this.cp; });
                    break;
                case "Thickness":
                    if (!i2.isNaN_(this.ep)) {
                        this.ja(function (d) { return d.gm = _this.ep; });
                    }
                    break;
                case "OutlineMode":
                    this.ja(function (d) { return d.bs = _this.bi; });
                    break;
                case "MarkerFillOpacity":
                    this.ja(function (d) { return d.ge = _this.ec; });
                    break;
                case "MarkerThickness":
                    if (!i2.isNaN_(this.ed)) {
                        this.ja(function (d) { return d.mi(_this.ed); });
                    }
                    break;
                case "MarkerOutlineMode":
                    this.ja(function (d) { return d.mh(_this.a0); });
                    break;
                case "MarkerFillMode":
                    this.ja(function (d) { return d.mg(_this.ay); });
                    break;
                case "Resolution":
                    if (!i2.isNaN_(this.ej)) {
                        this.i6(function (d) { return d.gh = _this.ej; });
                    }
                    break;
                case "AreaFillOpacity":
                    if (!i2.isNaN_(this.d6)) {
                        this.i6(function (d) { return d.fq = _this.d6; });
                    }
                    break;
                case "TrendLineBrushes":
                case "TrendLineType":
                case "TrendLineThickness":
                case "TrendLinePeriod":
                    this.i7(function (d, e) { return _this.i0(d, e); });
                    break;
                case "MarkerMaxCount":
                    this.jb(function (d, e) { return _this.iz(d, e); });
                    break;
                case "MarkerTypes":
                    var d = i2.typeCast(i2.ObservableCollection$1.$.specialize(MarkerType_$type), b);
                    if (d != null) {
                        d.collectionChanged = i2.delegateRemove(d.collectionChanged, i2.runOn(this, this.j4));
                    }
                    var e = i2.typeCast(i2.ObservableCollection$1.$.specialize(MarkerType_$type), c);
                    if (e != null) {
                        e.collectionChanged = i2.delegateCombine(e.collectionChanged, i2.runOn(this, this.j4));
                    }
                    this.jb(function (f, g) { return _this.iz(f, g); });
                    break;
                case "MarkerAutomaticBehavior":
                    this.jz(function (f) { return f.a9 = _this.aw; });
                    this.jb(function (f, g) { return _this.iz(f, g); });
                    break;
                case "MarkerBrushes":
                    this.jz(function (f) { return f.ah = _this.p; });
                    break;
                case "MarkerOutlines":
                    this.jz(function (f) { return f.ai = _this.q; });
                    break;
                case "AlignsGridLinesToPixels":
                    this.jz(function (f) { return f.qe = _this.b9; });
                    break;
                case "AnimateSeriesWhenAxisRangeChanges":
                    this.jz(function (f) { return f.da = _this.ca; });
                    break;
                case "ToolTipType":
                case "CrosshairsDisplayMode":
                case "CrosshairsSnapToData":
                case "CrosshairsLineVerticalStroke":
                case "CrosshairsLineHorizontalStroke":
                case "CrosshairsLineThickness":
                case "CrosshairsAnnotationXAxisBackground":
                case "CrosshairsAnnotationXAxisTextColor":
                case "CrosshairsAnnotationYAxisBackground":
                case "CrosshairsAnnotationYAxisTextColor":
                case "CrosshairsAnnotationEnabled":
                case "CrosshairsAnnotationXAxisPrecision":
                case "CrosshairsAnnotationYAxisPrecision":
                case "FinalValueAnnotationsVisible":
                case "FinalValueAnnotationsPrecision":
                case "FinalValueAnnotationsTextColor":
                case "FinalValueAnnotationsBackground":
                case "CalloutsVisible":
                case "CalloutsItemsSource":
                case "CalloutsXMemberPath":
                case "CalloutsYMemberPath":
                case "CalloutsLabelMemberPath":
                case "CalloutsContentMemberPath":
                    var f = this.kb(i2.runOn(this, this.i3), this.co);
                    this.co = f.p1;
                    break;
            }
            this.j7(a, b, c);
            this.j8(a, b, c);
        };
        DomainChart.prototype.j4 = function (a, b) {
            var _this = this;
            this.jb(function (c, d) { return _this.iz(c, d); });
        };
        Object.defineProperty(DomainChart.prototype, "itemsSource", {
            get: function () {
                return this.c9;
            },
            set: function (a) {
                var b = this.itemsSource;
                if (b != a) {
                    this.c9 = a;
                    this.j6("ItemsSource", b, this.itemsSource);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "actualItemsSource", {
            get: function () {
                return this.c7;
            },
            set: function (a) {
                var b = this.actualItemsSource;
                if (b != a) {
                    this.c7 = a;
                    this.j6("ActualItemsSource", b, this.actualItemsSource);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "d", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                if (b != this.b) {
                    this.j6("IncludedProperties", b, this.b);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "c", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (b != this.a) {
                    this.j6("ExcludedProperties", b, this.a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "n", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                var b = this.n;
                if (a != b) {
                    this.g = a;
                    this.j6("Brushes", b, this.n);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "r", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                var b = this.r;
                if (a != b) {
                    this.j = a;
                    this.j6("Outlines", b, this.r);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "l", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                var b = this.e;
                if (a != b) {
                    this.e = a;
                    this.j6("ActualBrushes", b, this.l);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "m", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                var b = this.f;
                if (a != b) {
                    this.f = a;
                    this.j6("ActualOutlines", b, this.m);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "legend", {
            get: function () {
                return this.al;
            },
            set: function (a) {
                var b = this.legend;
                if (a != b) {
                    this.al = a;
                    this.j6("Legend", b, this.legend);
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_cn = function () {
            return this.b3;
        };
        DomainChart.prototype.set_cn = function (a) {
            var b = this.cn;
            if (a != b) {
                this.b3 = a;
                this.j6("IsHorizontalZoomEnabled", b, this.cn);
            }
        };
        Object.defineProperty(DomainChart.prototype, "cn", {
            get: function () {
                return this.get_cn();
            },
            set: function (a) {
                this.set_cn(a);
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_ct = function () {
            return this.b5;
        };
        DomainChart.prototype.set_ct = function (a) {
            var b = this.ct;
            if (a != b) {
                this.b5 = a;
                this.j6("IsVerticalZoomEnabled", b, this.ct);
            }
        };
        Object.defineProperty(DomainChart.prototype, "ct", {
            get: function () {
                return this.get_ct();
            },
            set: function (a) {
                this.set_ct(a);
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_cw = function () {
            return this.b7;
        };
        DomainChart.prototype.set_cw = function (a) {
            var b = this.cw;
            if (a != b) {
                this.b7 = a;
                this.j6("ShouldDisplayMockData", b, this.cw);
            }
        };
        Object.defineProperty(DomainChart.prototype, "cw", {
            get: function () {
                return this.get_cw();
            },
            set: function (a) {
                this.set_cw(a);
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_cx = function () {
            return this.b8;
        };
        DomainChart.prototype.set_cx = function (a) {
            var b = this.cx;
            if (a != b) {
                this.b8 = a;
                this.j6("ShouldUseSkeletonStyleForMockData", b, this.cx);
            }
        };
        Object.defineProperty(DomainChart.prototype, "cx", {
            get: function () {
                return this.get_cx();
            },
            set: function (a) {
                this.set_cx(a);
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_cp = function () {
            return this.b4;
        };
        DomainChart.prototype.set_cp = function (a) {
            var b = this.cp;
            if (a != b) {
                this.b4 = a;
                this.j6("IsSeriesHighlightingEnabled", b, this.cp);
            }
        };
        Object.defineProperty(DomainChart.prototype, "cp", {
            get: function () {
                return this.get_cp();
            },
            set: function (a) {
                this.set_cp(a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lt", {
            get: function () {
                return this.lr;
            },
            set: function (a) {
                var b = this.lt;
                if (i2.Rect.l_op_Inequality(a, b)) {
                    this.lr = a;
                    this.j6("WindowRect", b, this.lt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ls", {
            get: function () {
                return this.dataChart != null ? this.dataChart.pv : i2.Rect.empty;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "h9", {
            get: function () {
                return this.fs;
            },
            set: function (a) {
                var b = this.h9;
                if (a != b) {
                    this.fs = a;
                    this.j6("Title", b, this.h9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "hy", {
            get: function () {
                return this.fq;
            },
            set: function (a) {
                var b = this.hy;
                if (a != b) {
                    this.fq = a;
                    this.j6("Subtitle", b, this.hy);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "k0", {
            get: function () {
                return this.ky;
            },
            set: function (a) {
                var b = this.k0;
                if (b != a) {
                    this.ky = a;
                    this.j6("TitleAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, this.k0));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "kz", {
            get: function () {
                return this.kx;
            },
            set: function (a) {
                var b = this.kz;
                if (b != a) {
                    this.kx = a;
                    this.j6("SubtitleAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, this.kz));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "bo", {
            get: function () {
                return this.bn;
            },
            set: function (a) {
                var b = this.bo;
                if (a != b) {
                    this.bn = a;
                    this.j6("UnknownValuePlotting", i2.enumGetBox(i2.UnknownValuePlotting_$type, b), i2.enumGetBox(i2.UnknownValuePlotting_$type, this.bo));
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.get_ej = function () {
            return this.dt;
        };
        DomainChart.prototype.set_ej = function (a) {
            var b = this.ej;
            if (a != b) {
                this.dt = a;
                this.j6("Resolution", b, this.ej);
            }
        };
        Object.defineProperty(DomainChart.prototype, "ej", {
            get: function () {
                return this.get_ej();
            },
            set: function (a) {
                this.set_ej(a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ep", {
            get: function () {
                return this.dz;
            },
            set: function (a) {
                var b = this.ep;
                if (a != b) {
                    this.dz = a;
                    this.j6("Thickness", b, this.ep);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "bi", {
            get: function () {
                return this.bh;
            },
            set: function (a) {
                var b = this.bi;
                if (a != b) {
                    this.bh = a;
                    this.j6("OutlineMode", i2.enumGetBox(SeriesOutlineMode_$type, b), i2.enumGetBox(SeriesOutlineMode_$type, this.bi));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "a0", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                var b = this.a0;
                if (a != b) {
                    this.az = a;
                    this.j6("MarkerOutlineMode", i2.enumGetBox(MarkerOutlineMode_$type, b), i2.enumGetBox(MarkerOutlineMode_$type, this.a0));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ay", {
            get: function () {
                return this.ax;
            },
            set: function (a) {
                var b = this.ay;
                if (a != b) {
                    this.ax = a;
                    this.j6("MarkerFillMode", i2.enumGetBox(MarkerFillMode_$type, b), i2.enumGetBox(MarkerFillMode_$type, this.ay));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ec", {
            get: function () {
                return this.dl;
            },
            set: function (a) {
                var b = this.ec;
                if (a != b) {
                    this.dl = a;
                    this.j6("MarkerFillOpacity", b, this.ec);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ed", {
            get: function () {
                return this.dm;
            },
            set: function (a) {
                var b = this.ed;
                if (a != b) {
                    this.dm = a;
                    this.j6("MarkerThickness", b, this.ed);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "a5", {
            get: function () {
                return this.a4;
            },
            set: function (a) {
                var b = this.a5;
                if (a != b) {
                    this.a4 = a;
                    this.j6("MarkerTypes", b, this.a5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "aw", {
            get: function () {
                return this.av;
            },
            set: function (a) {
                var b = this.aw;
                if (a != b) {
                    this.av = a;
                    this.j6("MarkerAutomaticBehavior", i2.enumGetBox(MarkerAutomaticBehavior_$type, b), i2.enumGetBox(MarkerAutomaticBehavior_$type, this.aw));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "p", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.p;
                if (a != b) {
                    this.h = a;
                    this.j6("MarkerBrushes", b, this.p);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "q", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                var b = this.q;
                if (!i2.Base.equalsStatic(a, b)) {
                    this.i = a;
                    this.j6("MarkerOutlines", b, this.q);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "e8", {
            get: function () {
                return this.e1;
            },
            set: function (a) {
                var b = this.e1;
                if (a != b) {
                    this.e1 = a;
                    this.j6("MarkerMaxCount", b, this.e1);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "d6", {
            get: function () {
                return this.df;
            },
            set: function (a) {
                var b = this.d6;
                if (a != b) {
                    this.df = a;
                    this.j6("AreaFillOpacity", b, this.d6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ca", {
            get: function () {
                return this.bw;
            },
            set: function (a) {
                var b = this.bw;
                if (a != b) {
                    this.bw = a;
                    this.j6("AnimateSeriesWhenAxisRangeChanges", b, this.bw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "t", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                var b = this.t;
                if (a != b) {
                    this.k = a;
                    this.j6("TrendLineBrushes", b, this.t);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "bm", {
            get: function () {
                return this.bl;
            },
            set: function (a) {
                var b = this.bm;
                if (a != b) {
                    this.bl = a;
                    this.j6("TrendLineType", i2.enumGetBox(i2.TrendLineType_$type, b), i2.enumGetBox(i2.TrendLineType_$type, this.bm));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ev", {
            get: function () {
                return this.d5;
            },
            set: function (a) {
                var b = this.ev;
                if (a != b) {
                    this.d5 = a;
                    this.j6("TrendLineThickness", b, this.ev);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "b9", {
            get: function () {
                return this.bv;
            },
            set: function (a) {
                var b = this.b9;
                if (a != b) {
                    this.bv = a;
                    this.j6("AlignsGridLinesToPixels", b, this.b9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "eg", {
            get: function () {
                return this.dq;
            },
            set: function (a) {
                var b = this.dq;
                this.dq = a;
                if (a != b) {
                    this.j6("PlotAreaMarginLeft", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ei", {
            get: function () {
                return this.ds;
            },
            set: function (a) {
                var b = this.ds;
                this.ds = a;
                if (a != b) {
                    this.j6("PlotAreaMarginTop", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "eh", {
            get: function () {
                return this.dr;
            },
            set: function (a) {
                var b = this.dr;
                this.dr = a;
                if (a != b) {
                    this.j6("PlotAreaMarginRight", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ef", {
            get: function () {
                return this.dp;
            },
            set: function (a) {
                var b = this.dp;
                this.dp = a;
                if (a != b) {
                    this.j6("PlotAreaMarginBottom", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.prototype.j5 = function () {
        };
        Object.defineProperty(DomainChart.prototype, "y", {
            get: function () {
                return this.x;
            },
            set: function (a) {
                var b = this.y;
                if (a != b) {
                    this.x = a;
                    this.j6("ComputedPlotAreaMarginMode", i2.enumGetBox(ComputedPlotAreaMarginMode_$type, b), i2.enumGetBox(ComputedPlotAreaMarginMode_$type, this.y));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "bg", {
            get: function () {
                return this.bf;
            },
            set: function (a) {
                var b = this.bg;
                if (a != b) {
                    this.bf = a;
                    this.j6("HighlightingMode", i2.enumGetBox(SeriesHighlightingMode_$type, b), i2.enumGetBox(SeriesHighlightingMode_$type, this.bg));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "be", {
            get: function () {
                return this.bd;
            },
            set: function (a) {
                var b = this.be;
                if (a != b) {
                    this.bd = a;
                    this.j6("HighlightingBehavior", i2.enumGetBox(SeriesHighlightingBehavior_$type, b), i2.enumGetBox(SeriesHighlightingBehavior_$type, this.be));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "aq", {
            get: function () {
                return this.ap;
            },
            set: function (a) {
                var b = this.aq;
                if (a != b) {
                    this.ap = a;
                    this.j6("LegendHighlightingMode", i2.enumGetBox(LegendHighlightingMode_$type, b), i2.enumGetBox(LegendHighlightingMode_$type, this.aq));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "au", {
            get: function () {
                return this.at;
            },
            set: function (a) {
                var b = this.au;
                if (a != b) {
                    this.at = a;
                    this.j6("LegendItemBadgeShape", i2.enumGetBox(LegendItemBadgeShape_$type, b), i2.enumGetBox(LegendItemBadgeShape_$type, this.au));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "as", {
            get: function () {
                return this.ar;
            },
            set: function (a) {
                var b = this.as;
                if (a != b) {
                    this.ar = a;
                    this.j6("LegendItemBadgeMode", i2.enumGetBox(LegendItemBadgeMode_$type, b), i2.enumGetBox(LegendItemBadgeMode_$type, this.as));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "cv", {
            get: function () {
                return this.b6;
            },
            set: function (a) {
                var b = this.cv;
                if (a != b) {
                    this.b6 = a;
                    this.j6("ShouldAutoExpandMarginForInitialLabels", b, this.cv);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "d7", {
            get: function () {
                return this.dg;
            },
            set: function (a) {
                var b = this.d7;
                if (a != b) {
                    this.dg = a;
                    this.j6("AutoExpandMarginExtraPadding", b, this.d7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "d8", {
            get: function () {
                return this.dh;
            },
            set: function (a) {
                var b = this.d8;
                if (a != b) {
                    this.dh = a;
                    this.j6("AutoExpandMarginMaximumValue", b, this.d8);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "fa", {
            get: function () {
                return this.e4;
            },
            set: function (a) {
                var b = this.fa;
                if (a != b) {
                    this.e4 = a;
                    this.j6("TrendLinePeriod", b, this.fa);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "bk", {
            get: function () {
                return this.bj;
            },
            set: function (a) {
                var b = this.bk;
                if (a != b) {
                    this.bj = a;
                    this.j6("ToolTipType", i2.enumGetBox(ToolTipType_$type, b), i2.enumGetBox(ToolTipType_$type, this.bk));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "aa", {
            get: function () {
                return this.z;
            },
            set: function (a) {
                var b = this.aa;
                if (a != b) {
                    this.z = a;
                    this.j6("CrosshairsDisplayMode", i2.enumGetBox(CrosshairsDisplayMode_$type, b), i2.enumGetBox(CrosshairsDisplayMode_$type, this.aa));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "cf", {
            get: function () {
                return this.b1;
            },
            set: function (a) {
                var b = this.cf;
                if (a != b) {
                    this.b1 = a;
                    this.j6("CrosshairsSnapToData", b, this.cf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lg", {
            get: function () {
                return this.k6;
            },
            set: function (a) {
                var b = this.lg;
                if (a != b) {
                    this.k6 = a;
                    this.j6("CrosshairsLineVerticalStroke", b, this.lg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ea", {
            get: function () {
                return this.dj;
            },
            set: function (a) {
                var b = this.ea;
                if (a != b) {
                    this.dj = a;
                    this.j6("CrosshairsLineThickness", b, this.ea);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lf", {
            get: function () {
                return this.k5;
            },
            set: function (a) {
                var b = this.lf;
                if (a != b) {
                    this.k5 = a;
                    this.j6("CrosshairsLineHorizontalStroke", b, this.lf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ce", {
            get: function () {
                return this.b0;
            },
            set: function (a) {
                var b = this.ce;
                if (a != b) {
                    this.b0 = a;
                    this.j6("CrosshairsAnnotationEnabled", b, this.ce);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lb", {
            get: function () {
                return this.k1;
            },
            set: function (a) {
                var b = this.lb;
                if (a != b) {
                    this.k1 = a;
                    this.j6("CrosshairsAnnotationXAxisBackground", b, this.lb);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "ld", {
            get: function () {
                return this.k3;
            },
            set: function (a) {
                var b = this.ld;
                if (a != b) {
                    this.k3 = a;
                    this.j6("CrosshairsAnnotationYAxisBackground", b, this.ld);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lc", {
            get: function () {
                return this.k2;
            },
            set: function (a) {
                var b = this.lc;
                if (a != b) {
                    this.k2 = a;
                    this.j6("CrosshairsAnnotationXAxisTextColor", b, this.lc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "le", {
            get: function () {
                return this.k4;
            },
            set: function (a) {
                var b = this.le;
                if (a != b) {
                    this.k4 = a;
                    this.j6("CrosshairsAnnotationYAxisTextColor", b, this.le);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "e5", {
            get: function () {
                return this.ey;
            },
            set: function (a) {
                var b = this.e5;
                if (a != b) {
                    this.ey = a;
                    this.j6("CrosshairsAnnotationXAxisPrecision", b, this.e5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "e6", {
            get: function () {
                return this.ez;
            },
            set: function (a) {
                var b = this.e6;
                if (a != b) {
                    this.ez = a;
                    this.j6("CrosshairsAnnotationYAxisPrecision", b, this.e6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "cg", {
            get: function () {
                return this.b2;
            },
            set: function (a) {
                var b = this.cg;
                if (a != b) {
                    this.b2 = a;
                    this.j6("FinalValueAnnotationsVisible", b, this.cg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "lh", {
            get: function () {
                return this.k7;
            },
            set: function (a) {
                var b = this.lh;
                if (a != b) {
                    this.k7 = a;
                    this.j6("FinalValueAnnotationsBackground", b, this.lh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "li", {
            get: function () {
                return this.k8;
            },
            set: function (a) {
                var b = this.li;
                if (a != b) {
                    this.k8 = a;
                    this.j6("FinalValueAnnotationsTextColor", b, this.li);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "e7", {
            get: function () {
                return this.e0;
            },
            set: function (a) {
                var b = this.e7;
                if (a != b) {
                    this.e0 = a;
                    this.j6("FinalValueAnnotationsPrecision", b, this.e7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "cd", {
            get: function () {
                return this.bz;
            },
            set: function (a) {
                var b = this.cd;
                if (a != b) {
                    this.bz = a;
                    this.j6("CalloutsVisible", b, this.cd);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "cc", {
            get: function () {
                return this.by;
            },
            set: function (a) {
                var b = this.cc;
                if (a != b) {
                    this.by = a;
                    this.j6("CalloutStyleUpdatingEventEnabled", b, this.cc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "calloutsItemsSource", {
            get: function () {
                return this.c8;
            },
            set: function (a) {
                var b = this.calloutsItemsSource;
                if (a != b) {
                    this.c8 = a;
                    this.j6("CalloutsItemsSource", b, this.calloutsItemsSource);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "gb", {
            get: function () {
                return this.fo;
            },
            set: function (a) {
                var b = this.gb;
                if (a != b) {
                    this.fo = a;
                    this.j6("CalloutsXMemberPath", b, this.gb);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "gd", {
            get: function () {
                return this.fp;
            },
            set: function (a) {
                var b = this.gd;
                if (a != b) {
                    this.fp = a;
                    this.j6("CalloutsYMemberPath", b, this.gd);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "f7", {
            get: function () {
                return this.fn;
            },
            set: function (a) {
                var b = this.f7;
                if (a != b) {
                    this.fn = a;
                    this.j6("CalloutsLabelMemberPath", b, this.f7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DomainChart.prototype, "f4", {
            get: function () {
                return this.fm;
            },
            set: function (a) {
                var b = this.f4;
                if (a != b) {
                    this.fm = a;
                    this.j6("CalloutsContentMemberPath", b, this.f4);
                }
            },
            enumerable: false,
            configurable: true
        });
        DomainChart.$t = i2.markType(DomainChart, 'DomainChart', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        DomainChart.fl = new i2.Random(0);
        DomainChart.fk = new i2.Random(0);
        return DomainChart;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the y-axis labels in the chart.
     */
    var YAxisLabelLocation = /*@__PURE__*/ (function (YAxisLabelLocation) {
        /**
         * Places the y-axis labels to the left, outside of the plotting area.
         */
        YAxisLabelLocation[YAxisLabelLocation["OutsideLeft"] = 0] = "OutsideLeft";
        /**
         * Places the y-axis labels to the right, outside of the plotting area.
         */
        YAxisLabelLocation[YAxisLabelLocation["OutsideRight"] = 1] = "OutsideRight";
        /**
         * Places the y-axis labels inside the plotting area and to the left of the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        YAxisLabelLocation[YAxisLabelLocation["InsideLeft"] = 2] = "InsideLeft";
        /**
         * Places the y-axis labels inside the plotting area and to the right of the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        YAxisLabelLocation[YAxisLabelLocation["InsideRight"] = 3] = "InsideRight";
        /**
         * Places the y-axis labels based on the type of chart component.
         * Axis Labels Outside Right for Financial Chart and Outside Left for other charts.
         */
        YAxisLabelLocation[YAxisLabelLocation["Auto"] = 4] = "Auto";
        return YAxisLabelLocation;
    })({});
    /**
     * @hidden
     */
    var YAxisLabelLocation_$type = i2.markEnum('YAxisLabelLocation', 'OutsideLeft,0|OutsideRight,1|InsideLeft,2|InsideRight,3|Auto,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available locations of the x-axis labels in the chart.
     */
    var XAxisLabelLocation = /*@__PURE__*/ (function (XAxisLabelLocation) {
        /**
         * Places the x-axis labels at the top, outside of the plotting area.
         */
        XAxisLabelLocation[XAxisLabelLocation["OutsideTop"] = 0] = "OutsideTop";
        /**
         * Places the x-axis labels at the bottom, outside of the plotting area
         */
        XAxisLabelLocation[XAxisLabelLocation["OutsideBottom"] = 1] = "OutsideBottom";
        /**
         * Places the x-axis labels inside the plotting area above the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        XAxisLabelLocation[XAxisLabelLocation["InsideTop"] = 2] = "InsideTop";
        /**
         * Places the x-axis labels inside the plotting area below the axis line.
         * CrossingAxis should be set for this setting to take effect.
         */
        XAxisLabelLocation[XAxisLabelLocation["InsideBottom"] = 3] = "InsideBottom";
        /**
         * Places the x-axis labels based on the type of chart component.
         * Axis Labels Outside Bottom for all types of charts.
         */
        XAxisLabelLocation[XAxisLabelLocation["Auto"] = 4] = "Auto";
        return XAxisLabelLocation;
    })({});
    /**
     * @hidden
     */
    var XAxisLabelLocation_$type = i2.markEnum('XAxisLabelLocation', 'OutsideTop,0|OutsideBottom,1|InsideTop,2|InsideBottom,3|Auto,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XYChart, _super);
        function XYChart() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.l0 = null;
            _this.l1 = null;
            _this.mh = 0;
            _this.mj = 5;
            _this.mi = 0;
            _this.mg = 5;
            _this.my = 5;
            _this.m0 = 0;
            _this.mz = 5;
            _this.mx = 0;
            _this.rr = null;
            _this.ry = null;
            _this.rp = null;
            _this.rq = null;
            _this.ms = 0;
            _this.m9 = 0;
            _this.mr = NaN;
            _this.m8 = NaN;
            _this.mu = NaN;
            _this.nb = NaN;
            _this.mt = NaN;
            _this.na = NaN;
            _this.mq = NaN;
            _this.m7 = NaN;
            _this.rx = null;
            _this.r4 = null;
            _this.oj = null;
            _this.on = null;
            _this.ol = null;
            _this.op = null;
            _this.oe = null;
            _this.of = null;
            _this.rs = null;
            _this.rz = null;
            _this.mk = i2.DeviceUtils.g(1);
            _this.m1 = i2.DeviceUtils.g(1);
            _this.ml = i2.DeviceUtils.g(1);
            _this.m2 = i2.DeviceUtils.g(1);
            _this.ru = null;
            _this.r1 = null;
            _this.rv = null;
            _this.r2 = null;
            _this.mm = i2.DeviceUtils.g(1);
            _this.m3 = i2.DeviceUtils.g(1);
            _this.mn = i2.DeviceUtils.g(8);
            _this.m4 = 0;
            _this.rw = null;
            _this.r3 = null;
            _this.mo = i2.DeviceUtils.g(1);
            _this.m5 = i2.DeviceUtils.g(1);
            _this.ok = null;
            _this.oo = null;
            _this.rt = null;
            _this.r0 = null;
            _this.mf = 0;
            _this.mw = 0;
            _this.me = NaN;
            _this.mv = NaN;
            _this.mp = 0;
            _this.m6 = -90;
            _this.ma = false;
            _this.mb = false;
            _this.rk = 1;
            _this.sn = 1;
            _this.rj = 1;
            _this.rl = 2;
            _this.sl = 0;
            _this.sm = 1;
            _this.sr = 0;
            _this.ss = 0;
            _this.l8 = 4;
            _this.l6 = 4;
            _this.oi = null;
            _this.lu = null;
            _this.om = null;
            _this.lv = null;
            return _this;
        }
        XYChart.prototype.provideContainer = function (a) {
            if (a != null) {
                var b = this.ly();
                var c = this.lz();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            _super.prototype.provideContainer.call(this, a);
        };
        XYChart.prototype.jl = function () {
            _super.prototype.jl.call(this);
            var a = this.ly();
            var b = this.lz();
            if (a != null && a.ay != null) {
                this.r7 = a.ay.textColor;
            }
            if (b != null && b.ay != null) {
                this.se = b.ay.textColor;
            }
            this.sc = AxisDefaults.j;
            this.sj = AxisDefaults.j;
            this.r8 = AxisDefaults.h;
            this.sf = AxisDefaults.h;
            this.sb = AxisDefaults.g;
            this.si = AxisDefaults.g;
        };
        XYChart.prototype.j7 = function (a, b, c) {
            var _this = this;
            _super.prototype.j7.call(this, a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.rb(function (d) { return d.leftMargin = _this.nj; });
                    break;
                case "XAxisLabelTopMargin":
                    this.rb(function (d) { return d.topMargin = _this.nl; });
                    break;
                case "XAxisLabelRightMargin":
                    this.rb(function (d) { return d.rightMargin = _this.nk; });
                    break;
                case "XAxisLabelBottomMargin":
                    this.rb(function (d) { return d.bottomMargin = _this.ni; });
                    break;
                case "YAxisLabelLeftMargin":
                    this.rg(function (d) { return d.leftMargin = _this.n0; });
                    break;
                case "YAxisLabelTopMargin":
                    this.rg(function (d) { return d.topMargin = _this.n2; });
                    break;
                case "YAxisLabelRightMargin":
                    this.rg(function (d) { return d.rightMargin = _this.n1; });
                    break;
                case "YAxisLabelBottomMargin":
                    this.rg(function (d) { return d.bottomMargin = _this.nz; });
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.r5 = this.ln(this.r7);
                    this.r6 = this.ln(this.se);
                    break;
                case "XAxisLabelTextColor":
                    this.r5 = this.ln(this.r7);
                    break;
                case "YAxisLabelTextColor":
                    this.r6 = this.ln(this.se);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.rb(function (d) { return d.textColor = _this.r5; });
                    break;
                case "ActualYAxisLabelTextColor":
                    this.rg(function (d) { return d.textColor = _this.r6; });
                    break;
                case "XAxisTitleMargin":
                    this.rd(function (d) { return d.margin = _this.nu; });
                    break;
                case "YAxisTitleMargin":
                    this.ri(function (d) { return d.margin = _this.ob; });
                    break;
                case "XAxisTitleLeftMargin":
                    this.rd(function (d) { return d.leftMargin = _this.nt; });
                    break;
                case "YAxisTitleLeftMargin":
                    this.ri(function (d) { return d.leftMargin = _this.oa; });
                    break;
                case "XAxisTitleTopMargin":
                    this.rd(function (d) { return d.topMargin = _this.nw; });
                    break;
                case "YAxisTitleTopMargin":
                    this.ri(function (d) { return d.topMargin = _this.od; });
                    break;
                case "XAxisTitleRightMargin":
                    this.rd(function (d) { return d.rightMargin = _this.nv; });
                    break;
                case "YAxisTitleRightMargin":
                    this.ri(function (d) { return d.rightMargin = _this.oc; });
                    break;
                case "XAxisTitleBottomMargin":
                    this.rd(function (d) { return d.bottomMargin = _this.ns; });
                    break;
                case "YAxisTitleBottomMargin":
                    this.ri(function (d) { return d.bottomMargin = _this.n9; });
                    break;
                case "XAxisTitleTextColor":
                    this.rd(function (d) { return d.textColor = _this.sd; });
                    break;
                case "YAxisTitleTextColor":
                    this.ri(function (d) { return d.textColor = _this.sk; });
                    break;
                case "XAxisFormatLabel":
                    this.q9(function (d) { return d.at = _this.l2; });
                    break;
                case "YAxisFormatLabel":
                    this.re(function (d) { return d.at = _this.l3; });
                    break;
            }
        };
        Object.defineProperty(XYChart.prototype, "l2", {
            get: function () {
                return this.l0;
            },
            set: function (a) {
                var b = this.l2;
                if (a != b) {
                    this.l0 = a;
                    this.j6("XAxisFormatLabel", b, this.l2);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "l3", {
            get: function () {
                return this.l1;
            },
            set: function (a) {
                var b = this.l3;
                if (a != b) {
                    this.l1 = a;
                    this.j6("YAxisFormatLabel", b, this.l3);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nj", {
            get: function () {
                return this.mh;
            },
            set: function (a) {
                var b = this.nj;
                if (a != b) {
                    this.mh = a;
                    this.j6("XAxisLabelLeftMargin", b, this.nj);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nl", {
            get: function () {
                return this.mj;
            },
            set: function (a) {
                var b = this.nl;
                if (a != b) {
                    this.mj = a;
                    this.j6("XAxisLabelTopMargin", b, this.nl);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nk", {
            get: function () {
                return this.mi;
            },
            set: function (a) {
                var b = this.nk;
                if (a != b) {
                    this.mi = a;
                    this.j6("XAxisLabelRightMargin", b, this.nk);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "ni", {
            get: function () {
                return this.mg;
            },
            set: function (a) {
                var b = this.ni;
                if (a != b) {
                    this.mg = a;
                    this.j6("XAxisLabelBottomMargin", b, this.ni);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n0", {
            get: function () {
                return this.my;
            },
            set: function (a) {
                var b = this.n0;
                if (a != b) {
                    this.my = a;
                    this.j6("YAxisLabelLeftMargin", b, this.n0);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n2", {
            get: function () {
                return this.m0;
            },
            set: function (a) {
                var b = this.n2;
                if (a != b) {
                    this.m0 = a;
                    this.j6("YAxisLabelTopMargin", b, this.n2);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n1", {
            get: function () {
                return this.mz;
            },
            set: function (a) {
                var b = this.n1;
                if (a != b) {
                    this.mz = a;
                    this.j6("YAxisLabelRightMargin", b, this.n1);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nz", {
            get: function () {
                return this.mx;
            },
            set: function (a) {
                var b = this.nz;
                if (a != b) {
                    this.mx = a;
                    this.j6("YAxisLabelBottomMargin", b, this.nz);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "r7", {
            get: function () {
                return this.rr;
            },
            set: function (a) {
                var b = this.r7;
                if (a != b) {
                    this.rr = a;
                    this.j6("XAxisLabelTextColor", b, this.r7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "se", {
            get: function () {
                return this.ry;
            },
            set: function (a) {
                var b = this.se;
                if (a != b) {
                    this.ry = a;
                    this.j6("YAxisLabelTextColor", b, this.se);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "r5", {
            get: function () {
                return this.rp;
            },
            set: function (a) {
                var b = this.rp;
                if (a != b) {
                    this.rp = a;
                    this.j6("ActualXAxisLabelTextColor", b, this.r5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "r6", {
            get: function () {
                return this.rq;
            },
            set: function (a) {
                var b = this.rq;
                if (a != b) {
                    this.rq = a;
                    this.j6("ActualYAxisLabelTextColor", b, this.r6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nu", {
            get: function () {
                return this.ms;
            },
            set: function (a) {
                var b = this.nu;
                if (a != b) {
                    this.ms = a;
                    this.j6("XAxisTitleMargin", b, this.nu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "ob", {
            get: function () {
                return this.m9;
            },
            set: function (a) {
                var b = this.ob;
                if (a != b) {
                    this.m9 = a;
                    this.j6("YAxisTitleMargin", b, this.ob);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nt", {
            get: function () {
                return this.mr;
            },
            set: function (a) {
                var b = this.nt;
                if (a != b) {
                    this.mr = a;
                    this.j6("XAxisTitleLeftMargin", b, this.nt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "oa", {
            get: function () {
                return this.m8;
            },
            set: function (a) {
                var b = this.oa;
                if (a != b) {
                    this.m8 = a;
                    this.j6("YAxisTitleLeftMargin", b, this.oa);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nw", {
            get: function () {
                return this.mu;
            },
            set: function (a) {
                var b = this.nw;
                if (a != b) {
                    this.mu = a;
                    this.j6("XAxisTitleTopMargin", b, this.nw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "od", {
            get: function () {
                return this.nb;
            },
            set: function (a) {
                var b = this.od;
                if (a != b) {
                    this.nb = a;
                    this.j6("YAxisTitleTopMargin", b, this.od);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nv", {
            get: function () {
                return this.mt;
            },
            set: function (a) {
                var b = this.nv;
                if (a != b) {
                    this.mt = a;
                    this.j6("XAxisTitleRightMargin", b, this.nv);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "oc", {
            get: function () {
                return this.na;
            },
            set: function (a) {
                var b = this.oc;
                if (a != b) {
                    this.na = a;
                    this.j6("YAxisTitleRightMargin", b, this.oc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "ns", {
            get: function () {
                return this.mq;
            },
            set: function (a) {
                var b = this.ns;
                if (a != b) {
                    this.mq = a;
                    this.j6("XAxisTitleBottomMargin", b, this.ns);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n9", {
            get: function () {
                return this.m7;
            },
            set: function (a) {
                var b = this.n9;
                if (a != b) {
                    this.m7 = a;
                    this.j6("YAxisTitleBottomMargin", b, this.n9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sd", {
            get: function () {
                return this.rx;
            },
            set: function (a) {
                var b = this.sd;
                if (a != b) {
                    this.rx = a;
                    this.j6("XAxisTitleTextColor", b, this.sd);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sk", {
            get: function () {
                return this.r4;
            },
            set: function (a) {
                var b = this.sk;
                if (a != b) {
                    this.r4 = a;
                    this.j6("YAxisTitleTextColor", b, this.sk);
                }
            },
            enumerable: false,
            configurable: true
        });
        XYChart.prototype.j8 = function (a, b, c) {
            var _this = this;
            _super.prototype.j8.call(this, a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.rb(function (d) { return d.textStyle = _this.o7; });
                    break;
                case "YAxisLabelTextStyle":
                    this.rg(function (d) { return d.textStyle = _this.qc; });
                    break;
                case "XAxisTitleTextStyle":
                    this.rd(function (d) { return d.textStyle = _this.pv; });
                    break;
                case "YAxisTitleTextStyle":
                    this.ri(function (d) { return d.textStyle = _this.q0; });
                    break;
            }
        };
        Object.defineProperty(XYChart.prototype, "o7", {
            get: function () {
                return this.oj;
            },
            set: function (a) {
                var b = this.o7;
                if (a != b) {
                    this.oj = a;
                    this.j6("XAxisLabelTextStyle", b, this.o7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "qc", {
            get: function () {
                return this.on;
            },
            set: function (a) {
                var b = this.qc;
                if (a != b) {
                    this.on = a;
                    this.j6("YAxisLabelTextStyle", b, this.qc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "pv", {
            get: function () {
                return this.ol;
            },
            set: function (a) {
                var b = this.pv;
                if (a != b) {
                    this.ol = a;
                    this.j6("XAxisTitleTextStyle", b, this.pv);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "q0", {
            get: function () {
                return this.op;
            },
            set: function (a) {
                var b = this.q0;
                if (a != b) {
                    this.op = a;
                    this.j6("YAxisTitleTextStyle", b, this.q0);
                }
            },
            enumerable: false,
            configurable: true
        });
        XYChart.prototype.q6 = function (a) {
            var _this = this;
            this.q3(a, function (b) { return b.leftMargin = _this.nj; });
            this.q3(a, function (b) { return b.topMargin = _this.nl; });
            this.q3(a, function (b) { return b.rightMargin = _this.nk; });
            this.q3(a, function (b) { return b.bottomMargin = _this.ni; });
            this.q3(a, function (b) { return b.textColor = _this.r5; });
            this.q4(a, function (b) { return b.textColor = _this.sd; });
            this.q4(a, function (b) { return b.leftMargin = _this.nt; });
            this.q4(a, function (b) { return b.topMargin = _this.nw; });
            this.q4(a, function (b) { return b.rightMargin = _this.nv; });
            this.q4(a, function (b) { return b.bottomMargin = _this.ns; });
            this.q3(a, function (b) { return b.textStyle = _this.o7; });
            this.q4(a, function (b) { return b.textStyle = _this.pv; });
        };
        XYChart.prototype.q8 = function (a) {
            var _this = this;
            this.q3(a, function (b) { return b.leftMargin = _this.n0; });
            this.q3(a, function (b) { return b.topMargin = _this.n2; });
            this.q3(a, function (b) { return b.rightMargin = _this.n1; });
            this.q3(a, function (b) { return b.bottomMargin = _this.nz; });
            this.q3(a, function (b) { return b.textColor = _this.r6; });
            this.q4(a, function (b) { return b.textColor = _this.sk; });
            this.q4(a, function (b) { return b.leftMargin = _this.oa; });
            this.q4(a, function (b) { return b.topMargin = _this.od; });
            this.q4(a, function (b) { return b.rightMargin = _this.oc; });
            this.q4(a, function (b) { return b.bottomMargin = _this.n9; });
            this.q3(a, function (b) { return b.textStyle = _this.qc; });
            this.q4(a, function (b) { return b.textStyle = _this.q0; });
        };
        XYChart.prototype.ko = function (a) {
            var b = this.ab(a);
            var c = this.bb(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.gz(a);
            c.hp = this.g0(a, b);
            this.dataChart.series.add(c);
        };
        XYChart.prototype.q9 = function (a) {
            this.ra(a, null);
        };
        XYChart.prototype.ra = function (a, b) {
            a(this.ly());
        };
        XYChart.prototype.rf = function (a, b) {
            a(this.lz());
        };
        XYChart.prototype.re = function (a) {
            this.rf(a, true);
        };
        XYChart.prototype.rd = function (a) {
            this.q4(this.ly(), a);
        };
        XYChart.prototype.ri = function (a) {
            this.q4(this.lz(), a);
        };
        XYChart.prototype.rg = function (a) {
            this.q3(this.lz(), a);
        };
        XYChart.prototype.rb = function (a) {
            this.q3(this.ly(), a);
        };
        XYChart.prototype.nc = function (a) {
            var b = this.ly();
            return b.d8(a, new ScalerParams(1, this.lt, this.ls, b.cc));
        };
        XYChart.prototype.ne = function (a) {
            var b = this.ly();
            return b.eb(a, new ScalerParams(1, this.lt, this.ls, b.cc));
        };
        XYChart.prototype.nd = function (a) {
            var b = this.lz();
            return b.d8(a, new ScalerParams(1, this.lt, this.ls, b.cc));
        };
        XYChart.prototype.nf = function (a) {
            var b = this.lz();
            return b.eb(a, new ScalerParams(1, this.lt, this.ls, b.cc));
        };
        XYChart.prototype.kl = function (a) {
            _super.prototype.kl.call(this, a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                var b = this.ly();
                var c = this.lz();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        };
        XYChart.os = function (a, b) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = c.findMatchingHint(16);
                    if (d != null) {
                        var e = d.path;
                        return e;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return null;
        };
        XYChart.prototype.jg = function (a) {
            _super.prototype.jg.call(this, a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.ly());
                this.dataChart.axes.add(this.lz());
            }
        };
        XYChart.prototype.q5 = function (a) {
            var _this = this;
            if (a != null && this.fd != null && a.e4 == null) {
                a.provideRenderer(this.fd);
            }
            a.jb = this.r8;
            a.ef = this.nm;
            a.jc = this.r9;
            a.ei = this.nn;
            a.je = this.sb;
            a.ez = this.no;
            a.jd = this.sa;
            a.e0 = this.np;
            a.jf = this.sc;
            a.e1 = this.nq;
            a.cy = true;
            var b = a == this.ly();
            if (b) {
                a.gp = this.pm;
            }
            a.fj = this.og;
            a.fz = this.oy;
            a.ag = this.lw;
            this.q3(a, function (c) { return c.angle = _this.nh; });
            this.q3(a, function (c) {
                if (c.extent != _this.ng) {
                    c.extent = _this.ng;
                }
            });
            this.q3(a, function (c) { return c.horizontalAlignment = _this.rm; });
            this.q3(a, function (c) { return c.verticalAlignment = _this.so; });
            this.q3(a, function (c) { return c.visibility = _this.st; });
            this.q3(a, function (c) { return c.location = _this.l4(_this.l7); });
            this.q4(a, function (c) { return c.horizontalAlignment = _this.rn; });
            this.q4(a, function (c) { return c.angle = _this.nr; });
            this.q6(a);
        };
        XYChart.prototype.q7 = function (a) {
            var _this = this;
            if (a == null) {
                return;
            }
            if (this.fd != null && a.e4 == null) {
                a.provideRenderer(this.fd);
            }
            this.q3(a, function (b) { return b.angle = _this.ny; });
            this.q3(a, function (b) {
                if (b.extent != _this.nx) {
                    b.extent = _this.nx;
                }
            });
            this.q3(a, function (b) { return b.horizontalAlignment = _this.ro; });
            this.q3(a, function (b) { return b.verticalAlignment = _this.sp; });
            this.q3(a, function (b) { return b.visibility = _this.su; });
            this.q3(a, function (b) { return b.location = _this.l5(_this.l9); });
            this.q4(a, function (b) { return b.verticalAlignment = _this.sq; });
            this.q4(a, function (b) { return b.angle = _this.n8; });
            a.jb = this.sf;
            a.ef = this.n3;
            a.jc = this.sg;
            a.ei = this.n4;
            a.je = this.si;
            a.ez = this.n5;
            a.jd = this.sh;
            a.e0 = this.n6;
            a.jf = this.sj;
            a.e1 = this.n7;
            var b = a == this.lz();
            if (b) {
                a.gp = this.qr;
            }
            a.fz = this.p3;
            a.ag = this.lx;
            this.q8(a);
        };
        XYChart.prototype.jd = function () {
            _super.prototype.jd.call(this);
            this.q5(this.ly());
            this.q7(this.lz());
        };
        XYChart.prototype.q3 = function (a, b) {
            if (a == null) {
                return;
            }
            if (a.ay == null) {
                a.ay = new AxisLabelSettings();
                a.ay.angle = a.dw();
                a.ay.bottomMargin = a.dx();
                a.ay.leftMargin = a.dy();
                a.ay.rightMargin = a.dz();
                a.ay.topMargin = a.d0();
                a.ay.horizontalAlignment = a.i6();
                a.ay.location = a.az();
                a.ay.verticalAlignment = a.jz();
            }
            b(a.ay);
        };
        XYChart.prototype.q4 = function (a, b) {
            if (a == null) {
                return;
            }
            if (a.be == null) {
                a.be = new TitleSettings();
                a.be.bottomMargin = a.d2();
                a.be.leftMargin = a.d3();
                a.be.rightMargin = a.d4();
                a.be.topMargin = a.d5();
                a.be.location = a.a0();
                a.be.angle = a.d1();
                a.be.horizontalAlignment = a.i7();
                a.be.verticalAlignment = a.j0();
            }
            b(a.be);
        };
        XYChart.prototype.j6 = function (a, b, c) {
            var _this = this;
            _super.prototype.j6.call(this, a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.rb(function (d) { return d.angle = _this.nh; });
                    break;
                case "YAxisLabelAngle":
                    this.rg(function (d) { return d.angle = _this.ny; });
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.rb(function (d) { return d.horizontalAlignment = _this.rm; });
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.rg(function (d) { return d.horizontalAlignment = _this.ro; });
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.rb(function (d) { return d.verticalAlignment = _this.so; });
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.rg(function (d) { return d.verticalAlignment = _this.sp; });
                    break;
                case "XAxisLabelVisibility":
                    this.rb(function (d) { return d.visibility = _this.st; });
                    break;
                case "YAxisLabelVisibility":
                    this.rg(function (d) { return d.visibility = _this.su; });
                    break;
                case "XAxisLabel":
                    this.q9(function (d) { return d.fj = _this.og; });
                    break;
                case "YAxisLabel":
                    this.re(function (d) { return d.fj = _this.oh; });
                    break;
                case "XAxisLabelFormat":
                    this.q9(function (d) { return d.fz = _this.oy; });
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.q9(function (d) { return d.ag = _this.lw; });
                    break;
                case "YAxisLabelFormat":
                    this.re(function (d) { return d.fz = _this.p3; });
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.re(function (d) { return d.ag = _this.lx; });
                    break;
                case "XAxisTitleAngle":
                    this.rd(function (d) { return d.angle = _this.nr; });
                    break;
                case "YAxisTitleAngle":
                    this.ri(function (d) { return d.angle = _this.n8; });
                    break;
                case "XAxisTitleAlignment":
                    this.rd(function (d) { return d.horizontalAlignment = _this.rn; });
                    break;
                case "YAxisTitleAlignment":
                    this.ri(function (d) { return d.verticalAlignment = _this.sq; });
                    break;
                case "XAxisTitle":
                    this.q9(function (d) { return d.gp = _this.pm; });
                    break;
                case "YAxisTitle":
                    this.rf(function (d) { return d.gp = _this.qr; }, false);
                    break;
                case "XAxisMajorStroke":
                    this.ra(function (d) { return d.jb = _this.r8; }, a);
                    break;
                case "YAxisMajorStroke":
                    this.re(function (d) { return d.jb = _this.sf; });
                    break;
                case "XAxisMajorStrokeThickness":
                    this.ra(function (d) { return d.ef = _this.nm; }, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.re(function (d) { return d.ef = _this.n3; });
                    break;
                case "XAxisMinorStroke":
                    this.q9(function (d) { return d.jc = _this.r9; });
                    break;
                case "YAxisMinorStroke":
                    this.re(function (d) { return d.jc = _this.sg; });
                    break;
                case "XAxisMinorStrokeThickness":
                    this.q9(function (d) { return d.ei = _this.nn; });
                    break;
                case "YAxisMinorStrokeThickness":
                    this.re(function (d) { return d.ei = _this.n4; });
                    break;
                case "XAxisTickLength":
                    this.q9(function (d) { return d.e0 = _this.np; });
                    break;
                case "YAxisTickLength":
                    this.re(function (d) { return d.e0 = _this.n6; });
                    break;
                case "XAxisTickStroke":
                    this.q9(function (d) { return d.jf = _this.sc; });
                    break;
                case "YAxisTickStroke":
                    this.re(function (d) { return d.jf = _this.sj; });
                    break;
                case "XAxisTickStrokeThickness":
                    this.q9(function (d) { return d.e1 = _this.nq; });
                    break;
                case "YAxisTickStrokeThickness":
                    this.re(function (d) { return d.e1 = _this.n7; });
                    break;
                case "XAxisStroke":
                    this.q9(function (d) { return d.je = _this.sb; });
                    break;
                case "YAxisStroke":
                    this.re(function (d) { return d.je = _this.si; });
                    break;
                case "XAxisStrokeThickness":
                    this.q9(function (d) { return d.ez = _this.no; });
                    break;
                case "YAxisStrokeThickness":
                    this.re(function (d) { return d.ez = _this.n5; });
                    break;
                case "XAxisExtent":
                    this.rb(function (d) { return d.extent = _this.ng; });
                    break;
                case "YAxisExtent":
                    this.rg(function (d) { return d.extent = _this.nx; });
                    break;
                case "XAxisStrip":
                    this.q9(function (d) { return d.jd = _this.sa; });
                    break;
                case "YAxisStrip":
                    this.re(function (d) { return d.jd = _this.sh; });
                    break;
                case "XAxisInverted":
                    this.q9(function (d) { return d.cc = _this.mc; });
                    break;
                case "YAxisInverted":
                    this.re(function (d) { return d.cc = _this.md; });
                    break;
                case "YAxisLabelLocation":
                    this.rh();
                    break;
                case "XAxisLabelLocation":
                    this.rc();
                    break;
            }
        };
        XYChart.prototype.rh = function () {
            var a = this.l5(this.l9);
            if (a == 2 || a == 7) {
                this.ro = 2;
            }
            else {
                this.ro = 0;
            }
            this.rg(function (b) { return b.location = a; });
        };
        XYChart.prototype.rc = function () {
            var a = this.l4(this.l7);
            if (a == 1 || a == 5) {
                this.so = 0;
            }
            else {
                this.so = 2;
            }
            this.rb(function (b) { return b.location = a; });
        };
        XYChart.prototype.l5 = function (a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.ai == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        };
        XYChart.prototype.l4 = function (a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        };
        Object.defineProperty(XYChart.prototype, "og", {
            get: function () {
                return this.oe;
            },
            set: function (a) {
                var b = this.og;
                if (a != b) {
                    this.oe = a;
                    this.j6("XAxisLabel", b, this.og);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "oh", {
            get: function () {
                return this.of;
            },
            set: function (a) {
                var b = this.oh;
                if (a != b) {
                    this.of = a;
                    this.j6("YAxisLabel", b, this.oh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "r8", {
            get: function () {
                return this.rs;
            },
            set: function (a) {
                var b = this.r8;
                if (a != b) {
                    this.rs = a;
                    this.j6("XAxisMajorStroke", b, this.r8);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sf", {
            get: function () {
                return this.rz;
            },
            set: function (a) {
                var b = this.sf;
                if (a != b) {
                    this.rz = a;
                    this.j6("YAxisMajorStroke", b, this.sf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nm", {
            get: function () {
                return this.mk;
            },
            set: function (a) {
                var b = this.nm;
                if (a != b) {
                    this.mk = a;
                    this.j6("XAxisMajorStrokeThickness", b, this.nm);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n3", {
            get: function () {
                return this.m1;
            },
            set: function (a) {
                var b = this.n3;
                if (a != b) {
                    this.m1 = a;
                    this.j6("YAxisMajorStrokeThickness", b, this.n3);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nn", {
            get: function () {
                return this.ml;
            },
            set: function (a) {
                var b = this.nn;
                if (a != b) {
                    this.ml = a;
                    this.j6("XAxisMinorStrokeThickness", b, this.nn);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n4", {
            get: function () {
                return this.m2;
            },
            set: function (a) {
                var b = this.n4;
                if (a != b) {
                    this.m2 = a;
                    this.j6("YAxisMinorStrokeThickness", b, this.n4);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sa", {
            get: function () {
                return this.ru;
            },
            set: function (a) {
                var b = this.sa;
                if (a != b) {
                    this.ru = a;
                    this.j6("XAxisStrip", b, this.sa);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sh", {
            get: function () {
                return this.r1;
            },
            set: function (a) {
                var b = this.sh;
                if (a != b) {
                    this.r1 = a;
                    this.j6("YAxisStrip", b, this.sh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sb", {
            get: function () {
                return this.rv;
            },
            set: function (a) {
                var b = this.sb;
                if (a != b) {
                    this.rv = a;
                    this.j6("XAxisStroke", b, this.sb);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "si", {
            get: function () {
                return this.r2;
            },
            set: function (a) {
                var b = this.si;
                if (a != b) {
                    this.r2 = a;
                    this.j6("YAxisStroke", b, this.si);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "no", {
            get: function () {
                return this.mm;
            },
            set: function (a) {
                var b = this.no;
                if (a != b) {
                    this.mm = a;
                    this.j6("XAxisStrokeThickness", b, this.no);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n5", {
            get: function () {
                return this.m3;
            },
            set: function (a) {
                var b = this.n5;
                if (a != b) {
                    this.m3 = a;
                    this.j6("YAxisStrokeThickness", b, this.n5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "np", {
            get: function () {
                return this.mn;
            },
            set: function (a) {
                var b = this.np;
                if (a != b) {
                    this.mn = a;
                    this.j6("XAxisTickLength", b, this.np);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n6", {
            get: function () {
                return this.m4;
            },
            set: function (a) {
                var b = this.n6;
                if (a != b) {
                    this.m4 = a;
                    this.j6("YAxisTickLength", b, this.n6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sc", {
            get: function () {
                return this.rw;
            },
            set: function (a) {
                var b = this.sc;
                if (a != b) {
                    this.rw = a;
                    this.j6("XAxisTickStroke", b, this.sc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sj", {
            get: function () {
                return this.r3;
            },
            set: function (a) {
                var b = this.sj;
                if (a != b) {
                    this.r3 = a;
                    this.j6("YAxisTickStroke", b, this.sj);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nq", {
            get: function () {
                return this.mo;
            },
            set: function (a) {
                var b = this.nq;
                if (a != b) {
                    this.mo = a;
                    this.j6("XAxisTickStrokeThickness", b, this.nq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n7", {
            get: function () {
                return this.m5;
            },
            set: function (a) {
                var b = this.n7;
                if (a != b) {
                    this.m5 = a;
                    this.j6("YAxisTickStrokeThickness", b, this.n7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "pm", {
            get: function () {
                return this.ok;
            },
            set: function (a) {
                var b = this.pm;
                if (a != b) {
                    this.ok = a;
                    this.j6("XAxisTitle", b, this.pm);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "qr", {
            get: function () {
                return this.oo;
            },
            set: function (a) {
                var b = this.qr;
                if (a != b) {
                    this.oo = a;
                    this.j6("YAxisTitle", b, this.qr);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "r9", {
            get: function () {
                return this.rt;
            },
            set: function (a) {
                var b = this.r9;
                if (a != b) {
                    this.rt = a;
                    this.j6("XAxisMinorStroke", b, this.r9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sg", {
            get: function () {
                return this.r0;
            },
            set: function (a) {
                var b = this.sg;
                if (a != b) {
                    this.r0 = a;
                    this.j6("YAxisMinorStroke", b, this.sg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nh", {
            get: function () {
                return this.mf;
            },
            set: function (a) {
                var b = this.nh;
                if (a != b) {
                    this.mf = a;
                    this.j6("XAxisLabelAngle", b, this.nh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "ny", {
            get: function () {
                return this.mw;
            },
            set: function (a) {
                var b = this.ny;
                if (a != b) {
                    this.mw = a;
                    this.j6("YAxisLabelAngle", b, this.ny);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "ng", {
            get: function () {
                return this.me;
            },
            set: function (a) {
                var b = this.ng;
                if (a != b) {
                    this.me = a;
                    this.j6("XAxisExtent", b, this.ng);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nx", {
            get: function () {
                return this.mv;
            },
            set: function (a) {
                var b = this.nx;
                if (a != b) {
                    this.mv = a;
                    this.j6("YAxisExtent", b, this.nx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "nr", {
            get: function () {
                return this.mp;
            },
            set: function (a) {
                var b = this.nr;
                if (a != b) {
                    this.mp = a;
                    this.j6("XAxisTitleAngle", b, this.nr);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "n8", {
            get: function () {
                return this.m6;
            },
            set: function (a) {
                var b = this.n8;
                if (a != b) {
                    this.m6 = a;
                    this.j6("YAxisTitleAngle", b, this.n8);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "mc", {
            get: function () {
                return this.ma;
            },
            set: function (a) {
                var b = this.mc;
                if (a != b) {
                    this.ma = a;
                    this.j6("XAxisInverted", b, this.mc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "md", {
            get: function () {
                return this.mb;
            },
            set: function (a) {
                var b = this.md;
                if (a != b) {
                    this.mb = a;
                    this.j6("YAxisInverted", b, this.md);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "rn", {
            get: function () {
                return this.rk;
            },
            set: function (a) {
                var b = this.rn;
                if (a != b) {
                    this.rk = a;
                    this.j6("XAxisTitleAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, this.rn));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sq", {
            get: function () {
                return this.sn;
            },
            set: function (a) {
                var b = this.sq;
                if (a != b) {
                    this.sn = a;
                    this.j6("YAxisTitleAlignment", i2.enumGetBox(i2.VerticalAlignment_$type, b), i2.enumGetBox(i2.VerticalAlignment_$type, this.sq));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "rm", {
            get: function () {
                return this.rj;
            },
            set: function (a) {
                var b = this.rm;
                if (a != b) {
                    this.rj = a;
                    this.j6("XAxisLabelHorizontalAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, this.rm));
                }
            },
            enumerable: false,
            configurable: true
        });
        XYChart.prototype.get_ro = function () {
            return this.rl;
        };
        XYChart.prototype.set_ro = function (a) {
            var b = this.ro;
            if (a != b) {
                this.rl = a;
                this.j6("YAxisLabelHorizontalAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, this.ro));
            }
        };
        Object.defineProperty(XYChart.prototype, "ro", {
            get: function () {
                return this.get_ro();
            },
            set: function (a) {
                this.set_ro(a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "so", {
            get: function () {
                return this.sl;
            },
            set: function (a) {
                var b = this.so;
                if (a != b) {
                    this.sl = a;
                    this.j6("XAxisLabelVerticalAlignment", i2.enumGetBox(i2.VerticalAlignment_$type, b), i2.enumGetBox(i2.VerticalAlignment_$type, this.so));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "sp", {
            get: function () {
                return this.sm;
            },
            set: function (a) {
                var b = this.sp;
                if (a != b) {
                    this.sm = a;
                    this.j6("YAxisLabelVerticalAlignment", i2.enumGetBox(i2.VerticalAlignment_$type, b), i2.enumGetBox(i2.VerticalAlignment_$type, this.sp));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "st", {
            get: function () {
                return this.sr;
            },
            set: function (a) {
                var b = this.st;
                if (a != b) {
                    this.sr = a;
                    this.j6("XAxisLabelVisibility", i2.enumGetBox(i2.Visibility_$type, b), i2.enumGetBox(i2.Visibility_$type, this.st));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "su", {
            get: function () {
                return this.ss;
            },
            set: function (a) {
                var b = this.su;
                if (a != b) {
                    this.ss = a;
                    this.j6("YAxisLabelVisibility", i2.enumGetBox(i2.Visibility_$type, b), i2.enumGetBox(i2.Visibility_$type, this.su));
                }
            },
            enumerable: false,
            configurable: true
        });
        XYChart.prototype.get_l9 = function () {
            return this.l8;
        };
        XYChart.prototype.set_l9 = function (a) {
            var b = this.l9;
            if (a != b) {
                this.l8 = a;
                this.j6("YAxisLabelLocation", i2.enumGetBox(YAxisLabelLocation_$type, b), i2.enumGetBox(YAxisLabelLocation_$type, this.l9));
            }
        };
        Object.defineProperty(XYChart.prototype, "l9", {
            get: function () {
                return this.get_l9();
            },
            set: function (a) {
                this.set_l9(a);
            },
            enumerable: false,
            configurable: true
        });
        XYChart.prototype.get_l7 = function () {
            return this.l6;
        };
        XYChart.prototype.set_l7 = function (a) {
            var b = this.l7;
            if (a != b) {
                this.l6 = a;
                this.j6("XAxisLabelLocation", i2.enumGetBox(XAxisLabelLocation_$type, b), i2.enumGetBox(XAxisLabelLocation_$type, this.l7));
            }
        };
        Object.defineProperty(XYChart.prototype, "l7", {
            get: function () {
                return this.get_l7();
            },
            set: function (a) {
                this.set_l7(a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "oy", {
            get: function () {
                return this.oi;
            },
            set: function (a) {
                var b = this.oi;
                if (a != b) {
                    this.oi = a;
                    this.j6("XAxisLabelFormat", b, this.oi);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "lw", {
            get: function () {
                return this.lu;
            },
            set: function (a) {
                var b = this.lu;
                if (a != b) {
                    this.lu = a;
                    this.j6("XAxisLabelFormatSpecifiers", b, this.lu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "p3", {
            get: function () {
                return this.om;
            },
            set: function (a) {
                var b = this.om;
                if (a != b) {
                    this.om = a;
                    this.j6("YAxisLabelFormat", b, this.om);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XYChart.prototype, "lx", {
            get: function () {
                return this.lv;
            },
            set: function (a) {
                var b = this.lv;
                if (a != b) {
                    this.lv = a;
                    this.j6("YAxisLabelFormatSpecifiers", b, this.lv);
                }
            },
            enumerable: false,
            configurable: true
        });
        XYChart.$t = i2.markType(XYChart, 'XYChart', DomainChart.$);
        return XYChart;
    }(DomainChart));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of data visualizations in the Category Chart
     */
    var CategoryChartType = /*@__PURE__*/ (function (CategoryChartType) {
        /**
         * Specifies category line series with markers at each data point
         */
        CategoryChartType[CategoryChartType["Line"] = 0] = "Line";
        /**
         * Specifies category area series
         */
        CategoryChartType[CategoryChartType["Area"] = 1] = "Area";
        /**
         * Specifies category column chart with vertical rectangles at each data point
         */
        CategoryChartType[CategoryChartType["Column"] = 2] = "Column";
        /**
         * Specifies category point chart with markers at each data point
         */
        CategoryChartType[CategoryChartType["Point"] = 3] = "Point";
        /**
         * Specifies category step line chart
         */
        CategoryChartType[CategoryChartType["StepLine"] = 4] = "StepLine";
        /**
         * Specifies category step area chart
         */
        CategoryChartType[CategoryChartType["StepArea"] = 5] = "StepArea";
        /**
         * Specifies category spline line series with markers at each data point
         */
        CategoryChartType[CategoryChartType["Spline"] = 6] = "Spline";
        /**
         * Specifies category spline area series
         */
        CategoryChartType[CategoryChartType["SplineArea"] = 7] = "SplineArea";
        /**
         * Specifies category waterfall chart
         */
        CategoryChartType[CategoryChartType["Waterfall"] = 8] = "Waterfall";
        /**
         * Specifies automatic selection of chart type based on suggestions from Data Adapter
         */
        CategoryChartType[CategoryChartType["Auto"] = 9] = "Auto";
        return CategoryChartType;
    })({});
    /**
     * @hidden
     */
    var CategoryChartType_$type = i2.markEnum('CategoryChartType', 'Line,0|Area,1|Column,2|Point,3|StepLine,4|StepArea,5|Spline,6|SplineArea,7|Waterfall,8|Auto,9');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryChartMockDataItem = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryChartMockDataItem, _super);
        function CategoryChartMockDataItem() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._label = null;
            _this._series1 = 0;
            _this._series2 = 0;
            _this._series3 = 0;
            return _this;
        }
        Object.defineProperty(CategoryChartMockDataItem.prototype, "label", {
            get: function () {
                return this._label;
            },
            set: function (a) {
                this._label = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChartMockDataItem.prototype, "series1", {
            get: function () {
                return this._series1;
            },
            set: function (a) {
                this._series1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChartMockDataItem.prototype, "series2", {
            get: function () {
                return this._series2;
            },
            set: function (a) {
                this._series2 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChartMockDataItem.prototype, "series3", {
            get: function () {
                return this._series3;
            },
            set: function (a) {
                this._series3 = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryChartMockDataItem.$t = i2.markType(CategoryChartMockDataItem, 'CategoryChartMockDataItem');
        return CategoryChartMockDataItem;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryChartMockDataGenerator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryChartMockDataGenerator, _super);
        function CategoryChartMockDataGenerator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CategoryChartMockDataGenerator.a = function () {
            var a = new i2.List$1(CategoryChartMockDataItem.$, 0);
            a.add(((function () {
                var $ret = new CategoryChartMockDataItem();
                $ret.label = "Item A";
                $ret.series1 = 3;
                $ret.series2 = 4;
                $ret.series3 = 7;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new CategoryChartMockDataItem();
                $ret.label = "Item B";
                $ret.series1 = 4;
                $ret.series2 = 3;
                $ret.series3 = 6;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new CategoryChartMockDataItem();
                $ret.label = "Item C";
                $ret.series1 = 7;
                $ret.series2 = 2;
                $ret.series3 = 5;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new CategoryChartMockDataItem();
                $ret.label = "Item D";
                $ret.series1 = 6;
                $ret.series2 = 4;
                $ret.series3 = 7;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new CategoryChartMockDataItem();
                $ret.label = "Item E";
                $ret.series1 = 5;
                $ret.series2 = 5;
                $ret.series3 = 8;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new CategoryChartMockDataItem();
                $ret.label = "Item F";
                $ret.series1 = 4;
                $ret.series2 = 8;
                $ret.series3 = 9;
                return $ret;
            })()));
            var arr_ = a.toArray();
            return arr_;
        };
        CategoryChartMockDataGenerator.$t = i2.markType(CategoryChartMockDataGenerator, 'CategoryChartMockDataGenerator');
        return CategoryChartMockDataGenerator;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryChart, _super);
        function CategoryChart() {
            var _this = _super.call(this) || this;
            _this.ug = 1000;
            _this.tf = null;
            _this.sz = 9;
            _this.s1 = 1;
            _this.tj = false;
            _this.s3 = 0;
            _this.td = 0;
            _this.tt = 0;
            _this.tu = 0;
            _this.ts = 0;
            _this.tv = 0;
            _this.tw = NaN;
            _this.tl = false;
            _this.uh = 10;
            _this.ty = NaN;
            _this.tx = NaN;
            _this.tz = 0;
            _this.sv = null;
            _this.sw = null;
            _this.tk = true;
            _this.th = false;
            _this.ti = false;
            _this.tr = null;
            _this.i4();
            return _this;
        }
        CategoryChart.prototype.jl = function () {
            _super.prototype.jl.call(this);
            if (this.dataChart == null) {
                return;
            }
            var a = this.dataChart.cf.j.e();
            this.sx = a.d;
            this.sy = a.e;
            if (this.r7 == null) {
                this.r7 = a.k;
            }
            if (this.se == null) {
                this.se = a.k;
            }
            this.n6 = 0;
            this.sf = AxisDefaults.h;
            this.si = null;
            this.sb = AxisDefaults.g;
            this.r8 = null;
            this.np = AxisDefaults.f;
            this.sc = AxisDefaults.j;
            this.nq = AxisDefaults.e;
            this.ce = true;
            this.cf = false;
            this.aa = 0;
            this.ea = Defaults.j;
            this.lg = Defaults.ae;
            this.lb = Defaults.af;
            this.lc = Defaults.ag;
        };
        CategoryChart.prototype.jn = function (a, b) {
            _super.prototype.jn.call(this, a, b);
            a.hb = this.ui;
            a.cd = this.tg;
        };
        CategoryChart.prototype.j7 = function (a, b, c) {
            var _this = this;
            _super.prototype.j7.call(this, a, b, c);
            switch (a) {
                case "TransitionInDuration":
                    this.ja(function (d) { return d.hb = _this.ui; });
                    break;
                case "TransitionInEasingFunction":
                    this.ja(function (d) { return d.cd = _this.tg; });
                    break;
            }
        };
        Object.defineProperty(CategoryChart.prototype, "ui", {
            get: function () {
                return this.ug;
            },
            set: function (a) {
                var b = this.ui;
                if (a != b) {
                    this.ug = a;
                    this.j6("TransitionInDuration", b, this.ui);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "tg", {
            get: function () {
                return this.tf;
            },
            set: function (a) {
                var b = this.tg;
                if (a != b) {
                    this.tf = a;
                    this.j6("TransitionInEasingFunction", b, this.tg);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryChart.prototype.ul = function () {
            var cvd_ = this.fe();
            cvd_.scaleByViewport();
            return (cvd_.serialize());
        };
        CategoryChart.prototype.jg = function (a) {
            _super.prototype.jg.call(this, a);
            a.da = this.ca;
        };
        CategoryChart.prototype.jm = function (a, b) {
            _super.prototype.jm.call(this, a, b);
            var c = i2.typeCast(HorizontalAnchoredCategorySeries.$, a);
            if (c == null) {
                return;
            }
            c.sx = this.s2;
            c.ru = this.to;
            c.re = this.s4;
            c.b7 = this.te;
            c.trendLineBrush = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.t, b);
            c.trendLineType = this.bm;
            c.trendLineThickness = this.ev;
            c.pr = this.a3(a, b);
            if (a.dx) {
                a.l5(i2.ArrayExtension.getModulus$1(i2.Brush.$, this.sx, b), i2.ArrayExtension.getModulus$1(i2.Brush.$, this.sy, b));
            }
        };
        CategoryChart.prototype.s5 = function () {
            return new CategoryXAxis();
        };
        CategoryChart.prototype.s9 = function () {
            return new NumericYAxis();
        };
        CategoryChart.prototype.i1 = function () {
            this.xAxis = this.s5();
            this.xAxis.name = "xAxis";
            var a = this.xAxis;
            a.propertyChanged = i2.delegateCombine(a.propertyChanged, i2.runOn(this, this.u9));
            this.yAxis = this.s9();
            this.yAxis.name = "yAxis";
            var b = this.yAxis;
            b.propertyChanged = i2.delegateCombine(b.propertyChanged, i2.runOn(this, this.va));
            if (this.xAxis.ay == null) {
                this.xAxis.ay = new AxisLabelSettings();
            }
            if (this.yAxis.ay == null) {
                this.yAxis.ay = new AxisLabelSettings();
            }
        };
        CategoryChart.prototype.q7 = function (a) {
            _super.prototype.q7.call(this, a);
            a.kf = this.tp;
        };
        CategoryChart.prototype.get_ai = function () {
            return 0;
        };
        Object.defineProperty(CategoryChart.prototype, "ai", {
            get: function () {
                return this.get_ai();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "s0", {
            get: function () {
                return this.sz;
            },
            set: function (a) {
                if (a != this.sz) {
                    var b = this.s0;
                    this.sz = a;
                    this.j6("ChartType", i2.enumGetBox(CategoryChartType_$type, b), i2.enumGetBox(CategoryChartType_$type, this.s0));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "s2", {
            get: function () {
                return this.s1;
            },
            set: function (a) {
                var b = this.s2;
                if (a != b) {
                    this.s1 = a;
                    this.j6("MarkerCollisionAvoidance", i2.enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), i2.enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.s2));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "to", {
            get: function () {
                return this.tj;
            },
            set: function (a) {
                var b = this.to;
                if (a != b) {
                    this.tj = a;
                    this.j6("IsTransitionInEnabled", b, this.to);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "s4", {
            get: function () {
                return this.s3;
            },
            set: function (a) {
                var b = this.s4;
                if (a != b) {
                    this.s3 = a;
                    this.j6("TransitionInMode", i2.enumGetBox(CategoryTransitionInMode_$type, b), i2.enumGetBox(CategoryTransitionInMode_$type, this.s4));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "te", {
            get: function () {
                return this.td;
            },
            set: function (a) {
                var b = this.te;
                if (a != b) {
                    this.td = a;
                    this.j6("TransitionInSpeedType", i2.enumGetBox(TransitionInSpeedType_$type, b), i2.enumGetBox(TransitionInSpeedType_$type, this.te));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "t7", {
            get: function () {
                return this.tt;
            },
            set: function (a) {
                var b = this.t7;
                if (a != b) {
                    this.tt = a;
                    this.j6("XAxisInterval", b, this.t7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "t8", {
            get: function () {
                return this.tu;
            },
            set: function (a) {
                var b = this.t8;
                if (a != b) {
                    this.tu = a;
                    this.j6("XAxisMinorInterval", b, this.t8);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "t6", {
            get: function () {
                return this.ts;
            },
            set: function (a) {
                var b = this.t6;
                if (a != b) {
                    this.ts = a;
                    this.j6("XAxisGap", b, this.t6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "t9", {
            get: function () {
                return this.tv;
            },
            set: function (a) {
                var b = this.t9;
                if (a != b) {
                    this.tv = a;
                    this.j6("XAxisOverlap", b, this.t9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "uc", {
            get: function () {
                return this.tw;
            },
            set: function (a) {
                var b = this.uc;
                if (a != b) {
                    this.tw = a;
                    this.j6("YAxisInterval", b, this.uc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "tq", {
            get: function () {
                return this.tl;
            },
            set: function (a) {
                var b = this.tq;
                if (a != b) {
                    this.tl = a;
                    this.j6("YAxisIsLogarithmic", b, this.tq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "uj", {
            get: function () {
                return this.uh;
            },
            set: function (a) {
                var b = this.uj;
                if (a != b) {
                    this.uh = a;
                    this.j6("YAxisLogarithmBase", b, this.uj);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "ue", {
            get: function () {
                return this.ty;
            },
            set: function (a) {
                var b = this.ue;
                if (a != b) {
                    this.ty = a;
                    this.j6("YAxisMinimumValue", b, this.ue);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "ud", {
            get: function () {
                return this.tx;
            },
            set: function (a) {
                var b = this.ud;
                if (a != b) {
                    this.tx = a;
                    this.j6("YAxisMaximumValue", b, this.ud);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "uf", {
            get: function () {
                return this.tz;
            },
            set: function (a) {
                var b = this.uf;
                if (a != b) {
                    this.tz = a;
                    this.j6("YAxisMinorInterval", b, this.uf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "t5", {
            get: function () {
                return this.xAxis.l3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "t4", {
            get: function () {
                return this.xAxis.l2;
            },
            enumerable: false,
            configurable: true
        });
        CategoryChart.prototype.t1 = function () {
            return this.t5;
        };
        CategoryChart.prototype.t3 = function () {
            return this.ub;
        };
        CategoryChart.prototype.t0 = function () {
            return this.t4;
        };
        CategoryChart.prototype.t2 = function () {
            return this.ua;
        };
        Object.defineProperty(CategoryChart.prototype, "ub", {
            get: function () {
                return this.yAxis.kv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "ua", {
            get: function () {
                return this.yAxis.ku;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "sx", {
            get: function () {
                return this.sv;
            },
            set: function (a) {
                var b = this.sx;
                if (a != b) {
                    this.sv = a;
                    this.j6("NegativeBrushes", b, this.sx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "sy", {
            get: function () {
                return this.sw;
            },
            set: function (a) {
                var b = this.sy;
                if (a != b) {
                    this.sw = a;
                    this.j6("NegativeOutlines", b, this.sy);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "tp", {
            get: function () {
                return this.tk;
            },
            set: function (a) {
                var b = this.tp;
                if (a != b) {
                    this.tk = a;
                    this.j6("YAxisAbbreviateLargeNumbers", b, this.tp);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "tm", {
            get: function () {
                return this.th;
            },
            set: function (a) {
                var b = this.tm;
                if (a != b) {
                    this.th = a;
                    this.j6("IsCategoryHighlightingEnabled", b, this.tm);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "tn", {
            get: function () {
                return this.ti;
            },
            set: function (a) {
                var b = this.tn;
                if (a != b) {
                    this.ti = a;
                    this.j6("IsItemHighlightingEnabled", b, this.tn);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryChart.prototype.get_c5 = function () {
            var a = new i2.List$1(i2.DataSeriesType_$type, 0);
            if (i2.TypeRegistrar.isRegistered("AreaSeries")) {
                a.add(2);
            }
            if (i2.TypeRegistrar.isRegistered("ColumnSeries")) {
                a.add(1);
            }
            if (i2.TypeRegistrar.isRegistered("LineSeries")) {
                a.add(0);
            }
            if (i2.TypeRegistrar.isRegistered("PointSeries")) {
                a.add(10);
            }
            if (i2.TypeRegistrar.isRegistered("SplineSeries")) {
                a.add(6);
            }
            if (i2.TypeRegistrar.isRegistered("SplineAreaSeries")) {
                a.add(7);
            }
            if (i2.TypeRegistrar.isRegistered("StepAreaSeries")) {
                a.add(5);
            }
            if (i2.TypeRegistrar.isRegistered("StepLineSeries")) {
                a.add(4);
            }
            if (i2.TypeRegistrar.isRegistered("WaterfallSeries")) {
                a.add(8);
            }
            return a;
        };
        Object.defineProperty(CategoryChart.prototype, "c5", {
            get: function () {
                return this.get_c5();
            },
            enumerable: false,
            configurable: true
        });
        CategoryChart.prototype.de = function () {
            if (this.tr == null) {
                this.tr = CategoryChartMockDataGenerator.a();
            }
            return this.tr;
        };
        CategoryChart.prototype.u9 = function (a, b) {
            switch (b.propertyName) {
                case "ActualMinimum":
                    this.kd("XAxisActualMinimum");
                    break;
                case "ActualMaximum":
                    this.kd("XAxisActualMaximum");
                    break;
            }
        };
        CategoryChart.prototype.va = function (a, b) {
            switch (b.propertyName) {
                case "ActualMinimumValue":
                    this.kd("YAxisActualMinimum");
                    break;
                case "ActualMaximumValue":
                    this.kd("YAxisActualMaximum");
                    break;
            }
        };
        CategoryChart.prototype.kp = function () {
            _super.prototype.kp.call(this);
            this.xAxis.fj = this.og == null ? XYChart.os(this.xAxis, this.ac.dataSeries) : this.og;
            this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        };
        Object.defineProperty(CategoryChart.prototype, "xAxis", {
            get: function () {
                return this._xAxis;
            },
            set: function (a) {
                this._xAxis = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryChart.prototype, "yAxis", {
            get: function () {
                return this._yAxis;
            },
            set: function (a) {
                this._yAxis = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryChart.prototype.s8 = function (a, b) {
            switch (a) {
                case 2: return this.bc(1);
                case 3: return this.bc(10);
                case 0: return this.bc(0);
                case 1: return this.bc(2);
                case 6: return this.bc(6);
                case 7: return this.bc(7);
                case 4: return this.bc(4);
                case 5: return this.bc(5);
                case 8: return this.bc(8);
                case 9: return this.s7(b);
                default: return this.bc(1);
            }
        };
        CategoryChart.prototype.s7 = function (a) {
            return this.bc(a);
        };
        CategoryChart.prototype.ab = function (a) {
            switch (this.s0) {
                case 1: return 2;
                case 0: return 0;
                case 3: return 10;
                case 6: return 6;
                case 7: return 7;
                case 5: return 5;
                case 4: return 4;
                case 8: return 8;
                case 9: return a.suggestedSeries;
                default:
                case 2: return 1;
            }
        };
        CategoryChart.prototype.bb = function (a, b) {
            var c = this.s8(this.s0, a.suggestedSeries);
            c.tb = a.findMatchingHint(0).path;
            c.xAxis = this.xAxis;
            c.yAxis = this.yAxis;
            return c;
        };
        CategoryChart.prototype.kn = function (a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.kk = true;
                this.yAxis.k7 = 10;
            }
        };
        CategoryChart.prototype.kq = function () {
            this.yAxis.kk = this.tq;
            this.yAxis.k7 = this.uj;
        };
        CategoryChart.prototype.get_c4 = function () {
            return ((function () {
                var $ret = new i2.List$1(i2.IDataSeriesAdapterRule_$type, 0);
                $ret.add(new i2.SimpleCategorySeriesRule());
                $ret.add(new i2.SubCollectionsRule());
                return $ret;
            })());
        };
        Object.defineProperty(CategoryChart.prototype, "c4", {
            get: function () {
                return this.get_c4();
            },
            enumerable: false,
            configurable: true
        });
        CategoryChart.prototype.iz = function (a, b) {
            var c = i2.typeCast(HorizontalAnchoredCategorySeries.$, a);
            if (c != null) {
                c.sx = this.s2;
                c.pr = this.a3(a, b);
            }
        };
        CategoryChart.prototype.u7 = function (a) {
            this.u8(function (b, c) { return a(b); });
        };
        CategoryChart.prototype.u8 = function (a) {
            if (this.dataChart == null) {
                return;
            }
            for (var b = 0; b < this.dataChart.series.count; b++) {
                var c = i2.typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]);
                if (c == null) {
                    continue;
                }
                a(c, b);
            }
        };
        CategoryChart.prototype.ly = function () {
            return this.xAxis;
        };
        CategoryChart.prototype.lz = function () {
            return this.yAxis;
        };
        CategoryChart.prototype.tb = function () {
            return this.bc(30);
        };
        CategoryChart.prototype.tc = function () {
            return this.bc(31);
        };
        CategoryChart.prototype.c1 = function (a, b) {
            var c = _super.prototype.c1.call(this, a, b);
            if (c != null) {
                var d = new i2.List$1(Series.$, 0);
                if (this.th) {
                    d.add(this.tb());
                }
                if (this.ti) {
                    d.add(this.tc());
                }
                for (var e = 0; e < d.count; e++) {
                    var f = d._inner[e];
                    f.name = a + i2.getInstanceType(f).typeName;
                    c.add(f);
                }
            }
            return c;
        };
        CategoryChart.prototype.ku = function (a, b, c) {
            _super.prototype.ku.call(this, a, b, c);
            if (this.ac.dataSeries.count > 0) {
                if (i2.stringIsNullOrEmpty(this.gb)) {
                    this.ak.setXMemberPath(a, c.getMemberPathFor(16));
                }
                if (i2.stringIsNullOrEmpty(this.gd)) {
                    this.ak.setYMemberPath(a, c.getMemberPathFor(0));
                }
                if (i2.stringIsNullOrEmpty(this.f7)) {
                    this.ak.setLabelMemberPath(a, c.getMemberPathFor(0));
                }
                if (i2.stringIsNullOrEmpty(this.f4)) {
                    this.ak.setContentMemberPath(a, c.getMemberPathFor(0));
                }
            }
        };
        CategoryChart.prototype.cl = function () {
            if (this.aa == 4 || this.aa == 3) {
                return true;
            }
            else if (this.aa == 0) {
                if (this.s0 == 2 || this.s0 == 8) {
                    return false;
                }
                else if (this.s0 == 9 && this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > 0) {
                    var a = this.ac.dataSeries._inner[0].suggestedSeries;
                    if (a == 1 || a == 8) {
                        return false;
                    }
                }
                return true;
            }
            return false;
        };
        CategoryChart.prototype.j6 = function (a, b, c) {
            var _this = this;
            _super.prototype.j6.call(this, a, b, c);
            switch (a) {
                case "ChartType":
                    this.kp();
                    break;
                case "MarkerCollisionAvoidance":
                    this.u7(function (d) { return d.sx = _this.s2; });
                    break;
                case "IsTransitionInEnabled":
                    this.u7(function (d) { return d.ru = _this.to; });
                    break;
                case "TransitionInMode":
                    this.u7(function (d) { return d.re = _this.s4; });
                    break;
                case "TransitionInSpeedType":
                    this.u7(function (d) { return d.b7 = _this.te; });
                    break;
                case "XAxisInterval":
                    this.xAxis.ly = this.t7;
                    break;
                case "XAxisMinorInterval":
                    this.xAxis.lz = this.t8;
                    break;
                case "XAxisGap":
                    this.xAxis.kf = this.t6;
                    break;
                case "XAxisOverlap":
                    this.xAxis.km = this.t9;
                    break;
                case "YAxisInterval":
                    this.yAxis.kz = this.uc;
                    break;
                case "YAxisIsLogarithmic":
                    this.yAxis.kk = this.tq;
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.k7 = this.uj;
                    break;
                case "YAxisMinimumValue":
                    this.yAxis.k3 = this.ue;
                    break;
                case "YAxisMaximumValue":
                    this.yAxis.k2 = this.ud;
                    break;
                case "YAxisMinorInterval":
                    this.yAxis.k4 = this.uf;
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.u8(function (d, e) {
                        if (d.dx) {
                            d.l5(i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.sx, e), i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.sy, e));
                        }
                    });
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.re(function (d) { return d.kf = _this.tp; });
                    break;
                case "IsCategoryHighlightingEnabled":
                case "IsItemHighlightingEnabled":
                    this.kp();
                    break;
            }
        };
        CategoryChart.$t = i2.markType(CategoryChart, 'CategoryChart', XYChart.$);
        return CategoryChart;
    }(XYChart));

    /**
     * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
    */
    var IgxChartSeriesEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxChartSeriesEventArgs() {
        }
        Object.defineProperty(IgxChartSeriesEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxChartSeriesEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxChartSeriesEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxChartSeriesEventArgs.prototype, "series", {
            /**
             * Gets the series.
            */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        return IgxChartSeriesEventArgs;
    }());

    /**
     * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
    *
    * The `IgxDomainChartSeriesPointerEventArgs` class provide events for chart's SeriesAdded and SeriesRemoved.
    *
    * `SeriesPointerDown` get fired when the pointer is press down over a Series.
    *
    * ```html
    *  <igx-financial-chart
    *       #chart
    *       [dataSource]="data"
    *       (seriesPointerDown)=chart_seriesPointerDown()
    *       >
    *     </igx-financial-chart>
    * ```
    *
    * ```ts
    * this.chart.seriesPointerDown = this.chart_seriesPointerDown();
    * ```
    */
    var IgxDomainChartSeriesPointerEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxDomainChartSeriesPointerEventArgs() {
        }
        Object.defineProperty(IgxDomainChartSeriesPointerEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxDomainChartSeriesPointerEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxDomainChartSeriesPointerEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxDomainChartSeriesPointerEventArgs.prototype, "series", {
            /**
             * Gets the series hit by the pointer.
            *
            * Use the `series` property to get the series.
            *
            * ```ts
            *  var series= args.series;
            * ```
            */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartSeriesPointerEventArgs.prototype, "item", {
            /**
             * Gets the item hit by the pointer.
            *
            * Use the `item` property to get the items.
            *
            * <https://www.infragistics.com/help/wpf/infragisticswpf.controls.charts.xamdatachart~infragistics.controls.charts.domainchartseriespointereventargs~item>
            *
            * ```ts
            * var Chartitem = args.item;
            * ```
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxDomainChartSeriesPointerEventArgs;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerTypeCollection, _super);
        function MarkerTypeCollection() {
            return _super.call(this, MarkerType_$type, 0) || this;
        }
        MarkerTypeCollection.$t = i2.markType(MarkerTypeCollection, 'MarkerTypeCollection', i2.ObservableCollection$1.$.specialize(MarkerType_$type));
        return MarkerTypeCollection;
    }(i2.ObservableCollection$1));

    var IgxMarkerTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMarkerTypeCollection, _super);
        function IgxMarkerTypeCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxMarkerTypeCollection.prototype._ensureOuter = function (item) {
            return i2.ensureEnum(MarkerType_$type, item);
        };
        IgxMarkerTypeCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(MarkerType_$type, MarkerType_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxMarkerTypeCollection;
    }(i2.IgCollection));

    /**
     * Represents a base class for all domain charts that can plot scatter data and shapefiles
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       bottomMargin= 20>
    *     </igx-category-chart>
    * ```
    */
    var IgxDomainChartComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxDomainChartComponent() {
            this._calloutsDataSource = null;
            this._markerTypes = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._seriesAdded = null;
            this._seriesRemoved = null;
            this._seriesPointerEnter = null;
            this._seriesPointerLeave = null;
            this._seriesPointerMove = null;
            this._seriesPointerDown = null;
            this._seriesPointerUp = null;
            this._calloutStyleUpdating = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxDomainChartComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxDomainChartComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxDomainChartComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxDomainChartComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxDomainChartComponent.prototype, "tooltipTemplate", {
            /**
            * Sets or gets the template reference to use for tooltips for all the series.
            *
            *
            */
            get: function () {
                return this.i.tooltipTemplate;
            },
            set: function (v) {
                this.i.tooltipTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "tooltipTemplates", {
            /**
            * Sets or gets the template references to use for tooltips for all the series, in order.
            *
            *
            */
            get: function () {
                var ret = [];
                if (this.i.tooltipTemplates) {
                    for (var ii = 0; ii < this.i.tooltipTemplates.count; ii++) {
                        ret.push(this.i.tooltipTemplates.item(ii));
                    }
                }
                return ret;
            },
            set: function (v) {
                this.i.tooltipTemplates.clear();
                if (v) {
                    for (var ii = 0; ii < v.length; ii++) {
                        this.i.tooltipTemplates.add(v[ii]);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "legend", {
            get: function () {
                if (this.i.legend != null)
                    return this.i.legend.externalObject;
            },
            set: function (v) {
                if (v != undefined && v != null)
                    this.i.legend = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutsDataSource", {
            get: function () {
                return this._calloutsDataSource;
            },
            set: function (value) {
                this._calloutsDataSource = value;
                this.bindCalloutsData();
            },
            enumerable: false,
            configurable: true
        });
        IgxDomainChartComponent.prototype.bindCalloutsData = function () {
            if (this.i != null && this.i !== undefined) {
                this.i.calloutsItemsSource = this._calloutsDataSource;
            }
        };
        Object.defineProperty(IgxDomainChartComponent.prototype, "pixelScalingRatio", {
            /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
            get: function () {
                return this.i.ee;
            },
            set: function (v) {
                this.i.ee = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleLeftMargin", {
            /**
             * Gets or sets the left margin of chart title
            *
            *  Use `titleLeftMargin` property for the left margin of chart title.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            * 	titleLeftMargin= 10>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.titleLeftMargin = 10;
            * ```
            */
            get: function () {
                return this.i.er;
            },
            set: function (v) {
                this.i.er = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleRightMargin", {
            /**
             * Gets or sets the right margin of chart title
            *
            *  Use `titleLeftMargin` property for the right margin of chart title.
            *
            * ```html
            * <igx-category-chart
            * 		yAxisMinimumValue="0"
            * 		[dataSource]="data"
            * 		titleRightMargin= 10>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.titleRightMargin = 10;
            * ```
            */
            get: function () {
                return this.i.es;
            },
            set: function (v) {
                this.i.es = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleTopMargin", {
            /**
             * Gets or sets the top margin of chart title
            *
            *  Use `titleTopMargin` property for the top margin of chart title.
            *
            * ```html
            * <igx-category-chart
            *      yAxisMinimumValue="0"
            *      [dataSource]="data"
            *      title="Countries"
            *      titleTopMargin=10 >
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.titleTopMargin = 10;
            * ```
            */
            get: function () {
                return this.i.et;
            },
            set: function (v) {
                this.i.et = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleBottomMargin", {
            /**
             * Gets or sets the bottom margin of chart title
            *
            *  Use `titleBottomMargin` property for the bottom margin of chart title.
            *
            * ```html
            * <igx-category-chart
            *    yAxisMinimumValue="0"
            *    [dataSource]="data"
            *    titleBottomMargin= 10 >
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.titleBottomMargin = 5;
            * ```
            */
            get: function () {
                return this.i.eq;
            },
            set: function (v) {
                this.i.eq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleLeftMargin", {
            /**
             * Gets or sets the left margin of chart subtitle
            *
            * Use `subtitleLeftMargin` property for the left margin of chart subtitle.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     subtitleLeftMargin= 20>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleLeftMargin = 20 ;
            * ```
            */
            get: function () {
                return this.i.em;
            },
            set: function (v) {
                this.i.em = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleTopMargin", {
            /**
             * Gets or sets the top margin of chart subtitle
            *
            * Use `subtitleTopMargin` property for the top margin of chart subtitle.
            *
            * ```html
            *    <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       subtitle= "This is a subtitle"
            *       subtitleTopMargin=10>
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleTopMargin = 10;
            * ```
            */
            get: function () {
                return this.i.eo;
            },
            set: function (v) {
                this.i.eo = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleRightMargin", {
            /**
             * Gets or sets the right margin of chart subtitle
            *
            * Use `subtitleRightMargin` property for the right margin of chart subtitle.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     subtitleRightMargin= 10>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.subtitleRightMargin = 20 ;
            * ```
            */
            get: function () {
                return this.i.en;
            },
            set: function (v) {
                this.i.en = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleBottomMargin", {
            /**
             * Gets or sets the bottom margin of chart subtitle
            *
            * Use `subtitleBottomMargin` property for the bottom margin of chart subtitle.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            * 	subtitleBottomMargin=10>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleBottomMargin = 10 ;
            * ```
            */
            get: function () {
                return this.i.el;
            },
            set: function (v) {
                this.i.el = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleTextColor", {
            /**
             * Gets or sets color of chart subtitle
            *
            * Use `subtitleTextColor` property to color the subtitle.
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       subtitle= "This is a subtitle"
            *       subtitleTextColor= 'blue'>
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleTextColor = "#ff0000" ;
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.lo);
            },
            set: function (v) {
                this.i.lo = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleTextColor", {
            /**
             * Gets or sets color of chart title
            *
            *  Use `titleTextColor` property to color the chart title
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       titleTextColor= "red">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.titleTextColor="red" ;
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.lp);
            },
            set: function (v) {
                this.i.lp = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "leftMargin", {
            /**
             * Gets or sets the left margin of the chart content.
            *
            * Use the 'leftMargin' property for the left margin of the chart content.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       leftMargin=20>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.leftMargin = 20;
            * ```
            */
            get: function () {
                return this.i.eb;
            },
            set: function (v) {
                this.i.eb = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "topMargin", {
            /**
             * Gets or sets the top margin of the chart content.
            *
            * Use `topMargin` property for the margin of the chart content.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     topMargin= 20>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.topMargin=20;
            * ```
            */
            get: function () {
                return this.i.eu;
            },
            set: function (v) {
                this.i.eu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "rightMargin", {
            /**
             * Gets or sets the right margin of the chart content.
            *
            * Use `rightMargin` property for the right margin of the chart content.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     rightMargin=20>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *   this.chart.rightMargin = 20 ;
            * ```
            */
            get: function () {
                return this.i.ek;
            },
            set: function (v) {
                this.i.ek = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "bottomMargin", {
            /**
             * Gets or sets the bottom margin around the chart content.
            *
            * Use the `bottomMargin` property for the bottom margin around the chart content.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       bottomMargin= 20>
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.bottomMargin=20;
            * ```
            */
            get: function () {
                return this.i.d9;
            },
            set: function (v) {
                this.i.d9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "transitionDuration", {
            /**
             * Gets or sets the duration used for animating series plots when the data is changing
            *
            * Use the `transitionDuration` property to animating between data values.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     transitionDuration="500">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.transitionDuratio= 500;
            * ```
            */
            get: function () {
                return this.i.e9;
            },
            set: function (v) {
                this.i.e9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "transitionEasingFunction", {
            /**
             * Gets or sets the easing function used for animating series plots when the data is changing.
             * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
            *
            * The 'transitionInEasingFunction' property used for easing function for animating series plots when the chart is loading into view.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     transitionInEasingFunction= "cubic">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.transitionInEasingFunction=  this.cubicFunc;
            *
            * cubicFunc(time: number) : number
            *   {
            *     return time;
            *   }
            * ```
            */
            get: function () {
                return this.i.bs;
            },
            set: function (v) {
                this.i.bs = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleTextStyle", {
            /**
             * Gets or sets CSS font property for the chart subtitle
            *
            * Use `subtitleTextStyle` property for the CSS font of the chart subtitle.
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       subtitle= "This is a subtitle"
            *       subtitleTextStyle ="16pt Verdona">
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleTextStyle= "16pt Verdona";
            * ```
            */
            get: function () {
                return this.i.h5;
            },
            set: function (v) {
                this.i.h5 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleTextStyle", {
            /**
             * Gets or sets CSS font property for the chart title
            *
            * Use `titleTextStyle` property for the CSS font property of the chart title
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       titleTextStyle= "24pt Verdona">
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleTextStyle = "24pt Verdona";
            * ```
            */
            get: function () {
                return this.i.ih;
            },
            set: function (v) {
                this.i.ih = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "domainType", {
            /**
             * Gets the domain type of this chart
            */
            get: function () {
                return this.i.ai;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "includedProperties", {
            /**
             * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
            *
            * The `includedProperties` property used to include the properties for the consideration of the category chart.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     includedProperties="ProductName,Cost" >
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.includedProperties = ["ProductName", "Cost"];
            * ```
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.d = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "excludedProperties", {
            /**
             * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
            *
            * The `excludedProperties` property used for the property paths that should be excluded from consideration by the category chart.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     excludedProperties="ID">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.excludedProperties = ["ID", "Discount"];
            * ```
            */
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.c = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "brushes", {
            /**
             * Gets or sets the palette of brushes to use for coloring the chart series.
             * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
            *
            * Use the `brushes` property to  set the brushes.
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       Brushes="#ff0000, #cc0000, #aa0000">
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.brushes = ["#ff0000","#00ff00"];
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.n);
            },
            set: function (v) {
                this.i.n = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "outlines", {
            /**
             * Gets or sets the palette of brushes to use for outlines on the chart series.
             * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
            *
            *  Use the `outlines` property to sets the palette of brushes to use for outlines on the chart series
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     outlines="#ff0000, #cc0000, #aa0000">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.r);
            },
            set: function (v) {
                this.i.r = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "actualBrushes", {
            /**
             * Gets the actual palette of brushes to use for coloring the chart series.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.l);
            },
            set: function (v) {
                this.i.l = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "actualOutlines", {
            /**
             * Gets the actual palette of brushes to use for outlines on the chart series.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.m);
            },
            set: function (v) {
                this.i.m = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "isHorizontalZoomEnabled", {
            /**
             * Gets or sets whether the chart can be horizontally zoomed through user interactions.
            *
            * Use the `isHorizontalZoomEnabled` property to allow chart horizontally zoomed .
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       isHorizontalZoomEnabled=true>
            *   </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.isHorizontalZoomEnabled = true;
            * ```
            */
            get: function () {
                return this.i.cn;
            },
            set: function (v) {
                this.i.cn = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "isVerticalZoomEnabled", {
            /**
             * Gets or sets whether the chart can be vertically zoomed through user interactions.
            *
            * Use the `isVerticalZoomEnabled` property to allow chart zoom vertically.
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       isVerticalZoomEnabled=true>
            *     </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.isVerticalZoomEnabled = true;
            * ```
            */
            get: function () {
                return this.i.ct;
            },
            set: function (v) {
                this.i.ct = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "shouldDisplayMockData", {
            /**
             * Gets or sets whether the chart should display mock data when the data source has not been provided, if supported for this type of chart.
            */
            get: function () {
                return this.i.cw;
            },
            set: function (v) {
                this.i.cw = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "shouldUseSkeletonStyleForMockData", {
            /**
             * Gets or sets whether the chart should use a faded skeleton style for mock data.
            */
            get: function () {
                return this.i.cx;
            },
            set: function (v) {
                this.i.cx = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "isSeriesHighlightingEnabled", {
            /**
             * Gets or sets whether the chart can highlight series through user interactions.
             * This property applies to Category Chart and Financial Chart controls.
            */
            get: function () {
                return this.i.cp;
            },
            set: function (v) {
                this.i.cp = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "windowRect", {
            /**
             * Gets or sets the rectangle representing the current scroll and zoom state of the chart.
             * WindowRect is expressed as a Rectangle with coordinates and sizes between 0 and 1.
            *
            * Use `windowRect` property representing the current scroll and zoom state of the chart.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       WindowRect=[0,0,1,1]>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.windowRect =[0,0,1,1];
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.lt);
            },
            set: function (v) {
                this.i.lt = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "viewport", {
            /**
             * Gets a rectangle representing the bounds of the plot area.
            *
            * `viewport` property representing the bounds of the plot area.
            *
            * ```ts
            * let viewport:Rect =  this.chart.viewport;
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.ls);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "chartTitle", {
            /**
             * Gets or sets text to display above the plot area.
            *
            * Use the `chartTitle` property to display the text above the plot area.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     title="This is a Title">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.title= "This is a Title";
            * ```
            */
            get: function () {
                return this.i.h9;
            },
            set: function (v) {
                this.i.h9 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitle", {
            /**
             * Gets or sets text to display below the Title, above the plot area.
            *
            * Use the `subtitle` property to display the text below  and above the plot area.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     subtitle= "This is a subtitle">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.subtitle ="CategoryChart Subtitle" ;
            * ```
            */
            get: function () {
                return this.i.hy;
            },
            set: function (v) {
                this.i.hy = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "titleAlignment", {
            /**
             * Gets or sets horizontal alignment which determines the title position, relative to the left and right edges of the control.
            *
            * Use the `titleAlignment` property for the horizontal alignment of the title.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     titleAlignment= "center">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.titleAlignment = HorizontalAlignment.Center;
            * ```
            */
            get: function () {
                return this.i.k0;
            },
            set: function (v) {
                this.i.k0 = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleAlignment", {
            /**
             * Gets or sets horizontal alignment which determines the subtitle position, relative to the left and right edges of the control.
            *
            * Use the `subtitleAlignment` property to Gets or sets horizontal alignment.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     subtitleAlignment= "center">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleAlignment = HorizontalAlignment.Right;
            * ```
            */
            get: function () {
                return this.i.kz;
            },
            set: function (v) {
                this.i.kz = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "unknownValuePlotting", {
            /**
             * Gets or sets the behavior that determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            *
            * Use the `unknownValuePlotting` property to determines the behavior that how unknown values will be plotted on the chart.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       unknownValuePlotting= "dontPlot">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.unknownValuePlotting =UnknownValuePlotting.DontPlot;
            * ```
            */
            get: function () {
                return this.i.bo;
            },
            set: function (v) {
                this.i.bo = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "resolution", {
            /**
             * Gets or sets the rendering resolution for all series in this chart.
             * Where n = Resolution, for every n horizontal pixels, combine all items into a single data point.  When Resolution = 0, all data points will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
            *
            * Use the `resolution` property if the callouts should be display.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     resolution= 2>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *   this.chart.resolution = 2 ;
            * ```
            */
            get: function () {
                return this.i.ej;
            },
            set: function (v) {
                this.i.ej = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "thickness", {
            /**
             * Gets or sets the thickness for all series in this chart. Depending on the ChartType, this can be the main brush used, or just the outline.
            *
            * Use the `thickness` property for the thickness of all the series in this chart.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     thickness=5>
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.ep;
            },
            set: function (v) {
                this.i.ep = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "outlineMode", {
            /**
             * Gets or sets the OutlineMode for all series in this chart.
            */
            get: function () {
                return this.i.bi;
            },
            set: function (v) {
                this.i.bi = i2.ensureEnum(SeriesOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerOutlineMode", {
            /**
             * Gets or sets the MarkerOutlineMode for all series that support markers in this chart.
            */
            get: function () {
                return this.i.a0;
            },
            set: function (v) {
                this.i.a0 = i2.ensureEnum(MarkerOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerFillMode", {
            /**
             * Gets or sets the MarkerFillMode for all series that support markers in this chart.
            */
            get: function () {
                return this.i.ay;
            },
            set: function (v) {
                this.i.ay = i2.ensureEnum(MarkerFillMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerFillOpacity", {
            /**
             * Gets or sets the Marker Fill Opacity for all series that support markers in this chart.
            */
            get: function () {
                return this.i.ec;
            },
            set: function (v) {
                this.i.ec = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerThickness", {
            /**
             * Gets or sets the Marker Thickness for all series that support markers in this chart.
            */
            get: function () {
                return this.i.ed;
            },
            set: function (v) {
                this.i.ed = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerTypes", {
            /**
             * Gets or sets the marker shapes used for indicating location of data points in this chart.
             * This property applies only to these chart types: point, line, spline, bubble, and polygon
            */
            get: function () {
                if (this._markerTypes === null) {
                    var coll = new IgxMarkerTypeCollection();
                    var innerColl = this.i.a5;
                    if (!innerColl) {
                        innerColl = new MarkerTypeCollection();
                    }
                    this._markerTypes = coll._fromInner(innerColl);
                    this.i.a5 = innerColl;
                }
                return this._markerTypes;
            },
            set: function (v) {
                if (this._markerTypes !== null) {
                    this._markerTypes._setSyncTarget(null);
                    this._markerTypes = null;
                }
                var coll = new IgxMarkerTypeCollection();
                this._markerTypes = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(MarkerType_$type);
                var innerColl = this.i.a5;
                if (!innerColl) {
                    innerColl = new MarkerTypeCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._markerTypes._setSyncTarget(syncColl);
                this.i.a5 = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerAutomaticBehavior", {
            /**
             * Gets or sets the default marker type for all series plotted in this chart.
             * This property is ignored when the MarkerTypes property is set
            */
            get: function () {
                return this.i.aw;
            },
            set: function (v) {
                this.i.aw = i2.ensureEnum(MarkerAutomaticBehavior_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerBrushes", {
            /**
             * Gets or sets the palette of brushes used for rendering fill area of data point markers.
             * This property applies only to these chart types: point, line, spline, bubble, and polygon
            *
            * `markerBrushes` property used for rendering fill area of data point markers.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     markerBrushes="#ff0000, #cc0000, #aa0000">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.markerBrushes=[ "#ff0000", "#ffff00", "#00ffff" ];
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.p);
            },
            set: function (v) {
                this.i.p = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerOutlines", {
            /**
             * Gets or sets the palette of brushes used for rendering outlines of data point markers.
             * This property applies only to these chart types: point, line, spline, bubble, and polygon
            *
            * `markerOutlines` property used for rendering outlines of data point markers.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     markerOutlines="#ff0000, #cc0000, #aa0000">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.markerOutlines= ["#ff0000", "#ffff00", "#00ffff"] ;
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.q);
            },
            set: function (v) {
                this.i.q = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "markerMaxCount", {
            /**
             * Gets or sets the maximum number of markers displayed in the plot area of the chart.
            *
            * `markerMaxCount` property used to display maximum number of markers in the plot area of the chart.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     markerMaxCount=100 >
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.markerMaxCount = 100 ;
            * ```
            */
            get: function () {
                return this.i.e8;
            },
            set: function (v) {
                this.i.e8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "areaFillOpacity", {
            /**
             * Gets or sets the fill opacity for all series that have area visuals in this chart.
             * For example, Area, SplineArea, Column chart types
            */
            get: function () {
                return this.i.d6;
            },
            set: function (v) {
                this.i.d6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "animateSeriesWhenAxisRangeChanges", {
            /**
             * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
            */
            get: function () {
                return this.i.ca;
            },
            set: function (v) {
                this.i.ca = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "trendLineBrushes", {
            /**
             * Gets or sets the palette of brushes to used for coloring trend lines in this chart.
             * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
            *
            * Use the `trendLineBrushes` property for coloring trend lines in the chart.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     trendLineBrushes="#ff0000,#aa0000">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.trendLineBrushes=["#ff0000", "#ffff00", "#00ffff"]	;
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.t);
            },
            set: function (v) {
                this.i.t = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the formula used for calculating trend lines in this chart.
             * This property applies only to these chart types: point, line, spline, and bubble
            *
            * Use the `trendLineType` property for calculating trend lines.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       trendLineType= "cubicFit">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.trendLineType = TrendLineType.CubicFit;
            * ```
            */
            get: function () {
                return this.i.bm;
            },
            set: function (v) {
                this.i.bm = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the trend lines in this chart.
             * This property applies only to these chart types: point, line, spline, and bubble
            *
            * Use the `trendLineThickness` property for the thickness of the trend lines in the chart.
            *
            * ```html
            * <igx-category-chart
            *     yAxisMinimumValue="0"
            *     [dataSource]="data"
            *     trendLineThickness= 2>
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.trendLineThickness=2;
            * ```
            */
            get: function () {
                return this.i.ev;
            },
            set: function (v) {
                this.i.ev = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "alignsGridLinesToPixels", {
            /**
             * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
            *
            * Use `alignsGridLinesToPixels` propert to indicat whether grid and tick lines are aligned to device pixels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     AlignsGridLinesToPixels="true">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  this.chart.alignsGridLinesToPixels= true;
            * ```
            */
            get: function () {
                return this.i.b9;
            },
            set: function (v) {
                this.i.b9 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "plotAreaMarginLeft", {
            /**
             * Margin applied to the Left of the plot area.
            */
            get: function () {
                return this.i.eg;
            },
            set: function (v) {
                this.i.eg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "plotAreaMarginTop", {
            /**
             * Margin applied to the Top of the plot area.
            */
            get: function () {
                return this.i.ei;
            },
            set: function (v) {
                this.i.ei = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "plotAreaMarginRight", {
            /**
             * Margin applied to the right of the plot area.
            */
            get: function () {
                return this.i.eh;
            },
            set: function (v) {
                this.i.eh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "plotAreaMarginBottom", {
            /**
             * Margin applied below the plot area.
            */
            get: function () {
                return this.i.ef;
            },
            set: function (v) {
                this.i.ef = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "computedPlotAreaMarginMode", {
            /**
             * Gets or sets the highlighting mode to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
            */
            get: function () {
                return this.i.y;
            },
            set: function (v) {
                this.i.y = i2.ensureEnum(ComputedPlotAreaMarginMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "highlightingMode", {
            /**
             * Gets or sets the highlighting mode to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
            */
            get: function () {
                return this.i.bg;
            },
            set: function (v) {
                this.i.bg = i2.ensureEnum(SeriesHighlightingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "highlightingBehavior", {
            /**
             * Gets or sets the highlighting Behavior to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
            */
            get: function () {
                return this.i.be;
            },
            set: function (v) {
                this.i.be = i2.ensureEnum(SeriesHighlightingBehavior_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "legendHighlightingMode", {
            /**
             * Gets or sets the highlighting mode to use for the legend linked to the component, when supported.
            */
            get: function () {
                return this.i.aq;
            },
            set: function (v) {
                this.i.aq = i2.ensureEnum(LegendHighlightingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "legendItemBadgeShape", {
            /**
             * Gets or sets the type of legend badges representing all series displayed in a legend linked to this component
             * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on a series
            */
            get: function () {
                return this.i.au;
            },
            set: function (v) {
                this.i.au = i2.ensureEnum(LegendItemBadgeShape_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "legendItemBadgeMode", {
            /**
             * Gets or sets the mode of legend badges representing all series displayed in a legend linked to this component.
             * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on a series
            */
            get: function () {
                return this.i.as;
            },
            set: function (v) {
                this.i.as = i2.ensureEnum(LegendItemBadgeMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "shouldAutoExpandMarginForInitialLabels", {
            /**
             * Gets or sets a whether the series viewer should auto expand margins to accommodate the initial horizontal axis labels.
            */
            get: function () {
                return this.i.cv;
            },
            set: function (v) {
                this.i.cv = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "autoExpandMarginExtraPadding", {
            /**
             * Gets or sets the extra amount the series viewer should auto expand margins to accommodate the initial horizontal axis labels.
            */
            get: function () {
                return this.i.d7;
            },
            set: function (v) {
                this.i.d7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "autoExpandMarginMaximumValue", {
            /**
             * Gets or sets the maximum amount the series viewer should auto expand margins to accommodate the initial horizontal axis labels.
            */
            get: function () {
                return this.i.d8;
            },
            set: function (v) {
                this.i.d8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "trendLinePeriod", {
            get: function () {
                return this.i.fa;
            },
            set: function (v) {
                this.i.fa = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "toolTipType", {
            /**
             * Gets or sets the style of tooltip to be displayed.
            */
            get: function () {
                return this.i.bk;
            },
            set: function (v) {
                this.i.bk = i2.ensureEnum(ToolTipType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsDisplayMode", {
            /**
             * Gets or sets the crosshairs to be displayed.
            */
            get: function () {
                return this.i.aa;
            },
            set: function (v) {
                this.i.aa = i2.ensureEnum(CrosshairsDisplayMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsSnapToData", {
            /**
             * Gets or sets whether crosshairs will snap to the nearest data point.
            */
            get: function () {
                return this.i.cf;
            },
            set: function (v) {
                this.i.cf = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsLineVerticalStroke", {
            /**
             * Gets or sets the color to apply to vertical crosshairs line.
            */
            get: function () {
                return i2.brushToString(this.i.lg);
            },
            set: function (v) {
                this.i.lg = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsLineThickness", {
            /**
             * Gets or sets thickness of crosshairs lines.
            */
            get: function () {
                return this.i.ea;
            },
            set: function (v) {
                this.i.ea = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsLineHorizontalStroke", {
            /**
             * Gets or sets the color to apply to horizontal crosshairs line.
            */
            get: function () {
                return i2.brushToString(this.i.lf);
            },
            set: function (v) {
                this.i.lf = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationEnabled", {
            /**
             * Gets or sets whether annotations are shown along the axis for crosshair values
            */
            get: function () {
                return this.i.ce;
            },
            set: function (v) {
                this.i.ce = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationXAxisBackground", {
            /**
             * Gets or sets the background of crosshair annotation on x-axis.
            */
            get: function () {
                return i2.brushToString(this.i.lb);
            },
            set: function (v) {
                this.i.lb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationYAxisBackground", {
            /**
             * Gets or sets the background of crosshair annotation on y-axis.
            */
            get: function () {
                return i2.brushToString(this.i.ld);
            },
            set: function (v) {
                this.i.ld = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationXAxisTextColor", {
            /**
             * Gets or sets the text color of crosshair annotation on x-axis.
            */
            get: function () {
                return i2.brushToString(this.i.lc);
            },
            set: function (v) {
                this.i.lc = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationYAxisTextColor", {
            /**
             * Gets or sets the text color of crosshair annotation on y-axis.
            */
            get: function () {
                return i2.brushToString(this.i.le);
            },
            set: function (v) {
                this.i.le = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationXAxisPrecision", {
            /**
             * Gets or sets precision on interpolated values of crosshairs on x-axis.
            */
            get: function () {
                return this.i.e5;
            },
            set: function (v) {
                this.i.e5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "crosshairsAnnotationYAxisPrecision", {
            /**
             * Gets or sets precision on interpolated values of crosshairs on y-axis.
            */
            get: function () {
                return this.i.e6;
            },
            set: function (v) {
                this.i.e6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "finalValueAnnotationsVisible", {
            /**
             * Gets or sets whether annotations for the final value of each series is displayed on the axis.
            */
            get: function () {
                return this.i.cg;
            },
            set: function (v) {
                this.i.cg = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "finalValueAnnotationsBackground", {
            /**
             * Gets or sets the background of final value annotation.
            */
            get: function () {
                return i2.brushToString(this.i.lh);
            },
            set: function (v) {
                this.i.lh = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "finalValueAnnotationsTextColor", {
            /**
             * Gets or sets the text color of final value annotation.
            */
            get: function () {
                return i2.brushToString(this.i.li);
            },
            set: function (v) {
                this.i.li = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "finalValueAnnotationsPrecision", {
            /**
             * Gets or sets precision on final value annotation.
            */
            get: function () {
                return this.i.e7;
            },
            set: function (v) {
                this.i.e7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutsVisible", {
            /**
             * Gets or sets if callouts should be displayed.
            */
            get: function () {
                return this.i.cd;
            },
            set: function (v) {
                this.i.cd = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutStyleUpdatingEventEnabled", {
            /**
             * Gets or sets if event annotations should be displayed.
            */
            get: function () {
                return this.i.cc;
            },
            set: function (v) {
                this.i.cc = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutsXMemberPath", {
            /**
             * Gets or sets the member path of the X data for the callouts.
            */
            get: function () {
                return this.i.gb;
            },
            set: function (v) {
                this.i.gb = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutsYMemberPath", {
            /**
             * Gets or sets the member path of the Y data for the callouts.
            */
            get: function () {
                return this.i.gd;
            },
            set: function (v) {
                this.i.gd = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutsLabelMemberPath", {
            /**
             * Gets or sets the member path of the label data for the callouts.
            */
            get: function () {
                return this.i.f7;
            },
            set: function (v) {
                this.i.f7 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutsContentMemberPath", {
            /**
             * Gets or sets the member path of the content data for the callouts.
            */
            get: function () {
                return this.i.f4;
            },
            set: function (v) {
                this.i.f4 = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxDomainChartComponent.prototype.findByName = function (name) {
            if (this.legend && this.legend.name && this.legend.name == name) {
                return this.legend;
            }
            if (this.markerTypes != null && this.markerTypes.findByName && this.markerTypes.findByName(name)) {
                return this.markerTypes.findByName(name);
            }
            return null;
        };
        Object.defineProperty(IgxDomainChartComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxDomainChartComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxDomainChartComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("DomainChartComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Provides a container for this control

    *
    * `provideContainer` method provide container for the control.
    *
    * ```ts
    *     this.chart.provideContainer("Container");
    * ```
    */
        IgxDomainChartComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        /**
         * Destroy this control
        
        *
        * Use the `destroy` property to destroy the chart.
        *
        * ```ts
        * this.chart.destroy();
        * ```
        */
        IgxDomainChartComponent.prototype.destroy = function () {
            this.i.destroy();
        };
        /**
         * Called when the control has been resized.
        
        *
        * `notifyResized` method Called when the control has been resized.
        *
        * ```ts
        * this.chart.notifyResized();
        * ```
        */
        IgxDomainChartComponent.prototype.notifyResized = function () {
            this.i.notifyResized();
        };
        IgxDomainChartComponent.prototype.notifyVisualPropertiesChanged = function () {
            this.i.jx();
        };
        /**
         * Forces any pending refresh to the chart to be finished.
        
        *
        * Method `flush` used to Forces any pending deferred work to render on the chart before continuing.
        *
        * ```ts
        * this.chart.flush();
        * ```
        */
        IgxDomainChartComponent.prototype.flush = function () {
            this.i.i5();
        };
        /**
         * Hides the active main tooltip, if displayed.
        
        *
        * Use the `hideToolTip` method to hide the active tooltip.
        *
        * ```ts
        * this.chart.hideToolTip();
        * ```
        */
        IgxDomainChartComponent.prototype.hideToolTip = function () {
            this.i.jc();
        };
        /**
         * Replays transition-in animation on all series in the chart.
        
        */
        IgxDomainChartComponent.prototype.replayTransitionIn = function () {
            this.i.km();
        };
        IgxDomainChartComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.jw(source_, index, oldItem, newItem);
        };
        /**
         * Used to manually notify the chart that the data source has reset or cleared its items.
        
        *
        * Use `notifyClearItems` method to notifies the chart that the items have been cleared from an associated data source.
        *
        * ```ts
        * this.chart.notifyClearItems(this.data);
        * ```
        */
        IgxDomainChartComponent.prototype.notifyClearItems = function (source_) {
            this.i.js(source_);
        };
        IgxDomainChartComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.jt(source_, index, newItem);
        };
        IgxDomainChartComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.ju(source_, index, oldItem);
        };
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesAdded", {
            /**
             * Event raised when a series is initialized and added to this chart.
            *
            * `SeriesAdded` event raised when a series is initialized and added to this chart.
            *
            * ```html
            *  <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       (seriesAdded)="CategoryChart_SeriesAdded()"
            *      >
            * </igx-category-chart>
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesAdded == null) {
                    this._seriesAdded = new i0.EventEmitter();
                    this.i.seriesAdded = i2.delegateCombine(this.i.seriesAdded, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxChartSeriesEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesAdded) {
                                _this.beforeSeriesAdded(_this, outerArgs);
                            }
                            _this._seriesAdded.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesAdded;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesRemoved", {
            /**
             * Event raised when a series is removed from this chart.
            *
            * `SeriesRemoved` event raised when a series is removed from this chart.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       (seriesRemoved)="CategoryChart_seriesRemoved()">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  CategoryChart_seriesRemoved(sender: any , aregs: ChartSeriesEventArgs)
            *   {
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesRemoved == null) {
                    this._seriesRemoved = new i0.EventEmitter();
                    this.i.seriesRemoved = i2.delegateCombine(this.i.seriesRemoved, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxChartSeriesEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesRemoved) {
                                _this.beforeSeriesRemoved(_this, outerArgs);
                            }
                            _this._seriesRemoved.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesRemoved;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerEnter", {
            /**
             * Occurs when the pointer enters a Series.
            *
            * `SeriesPointerEnter` event raised when the pointer enters a Series.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       (seriesPointerEnter)="CategoryChart_seriesPointerEnter()" >
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * CategoryChart_seriesPointerEnter(sender: any , aregs: ChartSeriesEventArgs)
            *   {
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesPointerEnter == null) {
                    this._seriesPointerEnter = new i0.EventEmitter();
                    this.i.seriesPointerEnter = i2.delegateCombine(this.i.seriesPointerEnter, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesPointerEnter) {
                                _this.beforeSeriesPointerEnter(_this, outerArgs);
                            }
                            _this._seriesPointerEnter.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesPointerEnter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerLeave", {
            /**
             * Occurs when the pointer leaves a Series.
            *
            * `SeriesPointerLeave` event raised when the pointer leaves a Series.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       (seriesPointerLeave)= "CategoryChart_seriesPointerLeave()" >
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * CategoryChart_seriesPointerLeave(sender: any , aregs: ChartSeriesEventArgs)
            *   {
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesPointerLeave == null) {
                    this._seriesPointerLeave = new i0.EventEmitter();
                    this.i.seriesPointerLeave = i2.delegateCombine(this.i.seriesPointerLeave, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesPointerLeave) {
                                _this.beforeSeriesPointerLeave(_this, outerArgs);
                            }
                            _this._seriesPointerLeave.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesPointerLeave;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerMove", {
            /**
             * Occurs when the pointer moves over a Series.
            *
            * `SeriesPointerMove` event raised when the pointer moves over a Series.
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *        (seriesPointerMove)="CategoryChart_seriesPointerMove()">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            *  CategoryChart_seriesPointerMove(sender: any , aregs: ChartSeriesEventArgs)
            *   {
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesPointerMove == null) {
                    this._seriesPointerMove = new i0.EventEmitter();
                    this.i.seriesPointerMove = i2.delegateCombine(this.i.seriesPointerMove, function (o, e) {
                        var outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesPointerMove) {
                            _this.beforeSeriesPointerMove(_this, outerArgs);
                        }
                        _this._seriesPointerMove.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._seriesPointerMove;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerDown", {
            /**
             * Occurs when the pointer is pressed down over a Series.
            *
            * `SeriesPointerDown` event raised when the pointer is pressed down over a Series
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       (seriesPointerDown)="CategoryChart_seriesPointerDown()" >
            * </igx-category-chart>
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesPointerDown == null) {
                    this._seriesPointerDown = new i0.EventEmitter();
                    this.i.seriesPointerDown = i2.delegateCombine(this.i.seriesPointerDown, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesPointerDown) {
                                _this.beforeSeriesPointerDown(_this, outerArgs);
                            }
                            _this._seriesPointerDown.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesPointerDown;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerUp", {
            /**
             * Occurs when the pointer is released over a Series.
            *
            * `SeriesPointerUp` event raised when the pointer is released over a Series.
            *
            * ```ts
            *  CategoryChart_seriesPointerUp(sender: any , aregs: ChartSeriesEventArgs)
            *   {
            *
            *   }
            * ```
            *
            * ```html
            * <igx-category-chart
            *       yAxisMinimumValue="0"
            *       [dataSource]="data"
            *       (seriesPointerUp)="CategoryChart_seriesPointerUp()" >
            * </igx-category-chart>
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesPointerUp == null) {
                    this._seriesPointerUp = new i0.EventEmitter();
                    this.i.seriesPointerUp = i2.delegateCombine(this.i.seriesPointerUp, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesPointerUp) {
                                _this.beforeSeriesPointerUp(_this, outerArgs);
                            }
                            _this._seriesPointerUp.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesPointerUp;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDomainChartComponent.prototype, "calloutStyleUpdating", {
            /**
             * Occurs when the style of a callout is updated.
            */
            get: function () {
                var _this = this;
                if (this._calloutStyleUpdating == null) {
                    this._calloutStyleUpdating = new i0.EventEmitter();
                    this.i.calloutStyleUpdating = i2.delegateCombine(this.i.calloutStyleUpdating, function (o, e) {
                        var outerArgs = new IgxCalloutStyleUpdatingEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeCalloutStyleUpdating) {
                            _this.beforeCalloutStyleUpdating(_this, outerArgs);
                        }
                        _this._calloutStyleUpdating.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._calloutStyleUpdating;
            },
            enumerable: false,
            configurable: true
        });
        IgxDomainChartComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxDomainChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDomainChartComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxDomainChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxDomainChartComponent, selector: "ng-component", inputs: { tooltipTemplate: "tooltipTemplate", tooltipTemplates: "tooltipTemplates", legend: "legend", calloutsDataSource: "calloutsDataSource", pixelScalingRatio: "pixelScalingRatio", titleLeftMargin: "titleLeftMargin", titleRightMargin: "titleRightMargin", titleTopMargin: "titleTopMargin", titleBottomMargin: "titleBottomMargin", subtitleLeftMargin: "subtitleLeftMargin", subtitleTopMargin: "subtitleTopMargin", subtitleRightMargin: "subtitleRightMargin", subtitleBottomMargin: "subtitleBottomMargin", subtitleTextColor: "subtitleTextColor", titleTextColor: "titleTextColor", leftMargin: "leftMargin", topMargin: "topMargin", rightMargin: "rightMargin", bottomMargin: "bottomMargin", transitionDuration: "transitionDuration", transitionEasingFunction: "transitionEasingFunction", subtitleTextStyle: "subtitleTextStyle", titleTextStyle: "titleTextStyle", includedProperties: "includedProperties", excludedProperties: "excludedProperties", brushes: "brushes", outlines: "outlines", actualBrushes: "actualBrushes", actualOutlines: "actualOutlines", isHorizontalZoomEnabled: "isHorizontalZoomEnabled", isVerticalZoomEnabled: "isVerticalZoomEnabled", shouldDisplayMockData: "shouldDisplayMockData", shouldUseSkeletonStyleForMockData: "shouldUseSkeletonStyleForMockData", isSeriesHighlightingEnabled: "isSeriesHighlightingEnabled", windowRect: "windowRect", chartTitle: "chartTitle", subtitle: "subtitle", titleAlignment: "titleAlignment", subtitleAlignment: "subtitleAlignment", unknownValuePlotting: "unknownValuePlotting", resolution: "resolution", thickness: "thickness", outlineMode: "outlineMode", markerOutlineMode: "markerOutlineMode", markerFillMode: "markerFillMode", markerFillOpacity: "markerFillOpacity", markerThickness: "markerThickness", markerTypes: "markerTypes", markerAutomaticBehavior: "markerAutomaticBehavior", markerBrushes: "markerBrushes", markerOutlines: "markerOutlines", markerMaxCount: "markerMaxCount", areaFillOpacity: "areaFillOpacity", animateSeriesWhenAxisRangeChanges: "animateSeriesWhenAxisRangeChanges", trendLineBrushes: "trendLineBrushes", trendLineType: "trendLineType", trendLineThickness: "trendLineThickness", alignsGridLinesToPixels: "alignsGridLinesToPixels", plotAreaMarginLeft: "plotAreaMarginLeft", plotAreaMarginTop: "plotAreaMarginTop", plotAreaMarginRight: "plotAreaMarginRight", plotAreaMarginBottom: "plotAreaMarginBottom", computedPlotAreaMarginMode: "computedPlotAreaMarginMode", highlightingMode: "highlightingMode", highlightingBehavior: "highlightingBehavior", legendHighlightingMode: "legendHighlightingMode", legendItemBadgeShape: "legendItemBadgeShape", legendItemBadgeMode: "legendItemBadgeMode", shouldAutoExpandMarginForInitialLabels: "shouldAutoExpandMarginForInitialLabels", autoExpandMarginExtraPadding: "autoExpandMarginExtraPadding", autoExpandMarginMaximumValue: "autoExpandMarginMaximumValue", trendLinePeriod: "trendLinePeriod", toolTipType: "toolTipType", crosshairsDisplayMode: "crosshairsDisplayMode", crosshairsSnapToData: "crosshairsSnapToData", crosshairsLineVerticalStroke: "crosshairsLineVerticalStroke", crosshairsLineThickness: "crosshairsLineThickness", crosshairsLineHorizontalStroke: "crosshairsLineHorizontalStroke", crosshairsAnnotationEnabled: "crosshairsAnnotationEnabled", crosshairsAnnotationXAxisBackground: "crosshairsAnnotationXAxisBackground", crosshairsAnnotationYAxisBackground: "crosshairsAnnotationYAxisBackground", crosshairsAnnotationXAxisTextColor: "crosshairsAnnotationXAxisTextColor", crosshairsAnnotationYAxisTextColor: "crosshairsAnnotationYAxisTextColor", crosshairsAnnotationXAxisPrecision: "crosshairsAnnotationXAxisPrecision", crosshairsAnnotationYAxisPrecision: "crosshairsAnnotationYAxisPrecision", finalValueAnnotationsVisible: "finalValueAnnotationsVisible", finalValueAnnotationsBackground: "finalValueAnnotationsBackground", finalValueAnnotationsTextColor: "finalValueAnnotationsTextColor", finalValueAnnotationsPrecision: "finalValueAnnotationsPrecision", calloutsVisible: "calloutsVisible", calloutStyleUpdatingEventEnabled: "calloutStyleUpdatingEventEnabled", calloutsXMemberPath: "calloutsXMemberPath", calloutsYMemberPath: "calloutsYMemberPath", calloutsLabelMemberPath: "calloutsLabelMemberPath", calloutsContentMemberPath: "calloutsContentMemberPath" }, outputs: { seriesAdded: "seriesAdded", seriesRemoved: "seriesRemoved", seriesPointerEnter: "seriesPointerEnter", seriesPointerLeave: "seriesPointerLeave", seriesPointerMove: "seriesPointerMove", seriesPointerDown: "seriesPointerDown", seriesPointerUp: "seriesPointerUp", calloutStyleUpdating: "calloutStyleUpdating" }, ngImport: i0, template: "", isInline: true });
        return IgxDomainChartComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDomainChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { tooltipTemplate: [{
                    type: i0.Input
                }], tooltipTemplates: [{
                    type: i0.Input
                }], legend: [{
                    type: i0.Input
                }], calloutsDataSource: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], titleLeftMargin: [{
                    type: i0.Input
                }], titleRightMargin: [{
                    type: i0.Input
                }], titleTopMargin: [{
                    type: i0.Input
                }], titleBottomMargin: [{
                    type: i0.Input
                }], subtitleLeftMargin: [{
                    type: i0.Input
                }], subtitleTopMargin: [{
                    type: i0.Input
                }], subtitleRightMargin: [{
                    type: i0.Input
                }], subtitleBottomMargin: [{
                    type: i0.Input
                }], subtitleTextColor: [{
                    type: i0.Input
                }], titleTextColor: [{
                    type: i0.Input
                }], leftMargin: [{
                    type: i0.Input
                }], topMargin: [{
                    type: i0.Input
                }], rightMargin: [{
                    type: i0.Input
                }], bottomMargin: [{
                    type: i0.Input
                }], transitionDuration: [{
                    type: i0.Input
                }], transitionEasingFunction: [{
                    type: i0.Input
                }], subtitleTextStyle: [{
                    type: i0.Input
                }], titleTextStyle: [{
                    type: i0.Input
                }], includedProperties: [{
                    type: i0.Input
                }], excludedProperties: [{
                    type: i0.Input
                }], brushes: [{
                    type: i0.Input
                }], outlines: [{
                    type: i0.Input
                }], actualBrushes: [{
                    type: i0.Input
                }], actualOutlines: [{
                    type: i0.Input
                }], isHorizontalZoomEnabled: [{
                    type: i0.Input
                }], isVerticalZoomEnabled: [{
                    type: i0.Input
                }], shouldDisplayMockData: [{
                    type: i0.Input
                }], shouldUseSkeletonStyleForMockData: [{
                    type: i0.Input
                }], isSeriesHighlightingEnabled: [{
                    type: i0.Input
                }], windowRect: [{
                    type: i0.Input
                }], chartTitle: [{
                    type: i0.Input
                }], subtitle: [{
                    type: i0.Input
                }], titleAlignment: [{
                    type: i0.Input
                }], subtitleAlignment: [{
                    type: i0.Input
                }], unknownValuePlotting: [{
                    type: i0.Input
                }], resolution: [{
                    type: i0.Input
                }], thickness: [{
                    type: i0.Input
                }], outlineMode: [{
                    type: i0.Input
                }], markerOutlineMode: [{
                    type: i0.Input
                }], markerFillMode: [{
                    type: i0.Input
                }], markerFillOpacity: [{
                    type: i0.Input
                }], markerThickness: [{
                    type: i0.Input
                }], markerTypes: [{
                    type: i0.Input
                }], markerAutomaticBehavior: [{
                    type: i0.Input
                }], markerBrushes: [{
                    type: i0.Input
                }], markerOutlines: [{
                    type: i0.Input
                }], markerMaxCount: [{
                    type: i0.Input
                }], areaFillOpacity: [{
                    type: i0.Input
                }], animateSeriesWhenAxisRangeChanges: [{
                    type: i0.Input
                }], trendLineBrushes: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], alignsGridLinesToPixels: [{
                    type: i0.Input
                }], plotAreaMarginLeft: [{
                    type: i0.Input
                }], plotAreaMarginTop: [{
                    type: i0.Input
                }], plotAreaMarginRight: [{
                    type: i0.Input
                }], plotAreaMarginBottom: [{
                    type: i0.Input
                }], computedPlotAreaMarginMode: [{
                    type: i0.Input
                }], highlightingMode: [{
                    type: i0.Input
                }], highlightingBehavior: [{
                    type: i0.Input
                }], legendHighlightingMode: [{
                    type: i0.Input
                }], legendItemBadgeShape: [{
                    type: i0.Input
                }], legendItemBadgeMode: [{
                    type: i0.Input
                }], shouldAutoExpandMarginForInitialLabels: [{
                    type: i0.Input
                }], autoExpandMarginExtraPadding: [{
                    type: i0.Input
                }], autoExpandMarginMaximumValue: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], toolTipType: [{
                    type: i0.Input
                }], crosshairsDisplayMode: [{
                    type: i0.Input
                }], crosshairsSnapToData: [{
                    type: i0.Input
                }], crosshairsLineVerticalStroke: [{
                    type: i0.Input
                }], crosshairsLineThickness: [{
                    type: i0.Input
                }], crosshairsLineHorizontalStroke: [{
                    type: i0.Input
                }], crosshairsAnnotationEnabled: [{
                    type: i0.Input
                }], crosshairsAnnotationXAxisBackground: [{
                    type: i0.Input
                }], crosshairsAnnotationYAxisBackground: [{
                    type: i0.Input
                }], crosshairsAnnotationXAxisTextColor: [{
                    type: i0.Input
                }], crosshairsAnnotationYAxisTextColor: [{
                    type: i0.Input
                }], crosshairsAnnotationXAxisPrecision: [{
                    type: i0.Input
                }], crosshairsAnnotationYAxisPrecision: [{
                    type: i0.Input
                }], finalValueAnnotationsVisible: [{
                    type: i0.Input
                }], finalValueAnnotationsBackground: [{
                    type: i0.Input
                }], finalValueAnnotationsTextColor: [{
                    type: i0.Input
                }], finalValueAnnotationsPrecision: [{
                    type: i0.Input
                }], calloutsVisible: [{
                    type: i0.Input
                }], calloutStyleUpdatingEventEnabled: [{
                    type: i0.Input
                }], calloutsXMemberPath: [{
                    type: i0.Input
                }], calloutsYMemberPath: [{
                    type: i0.Input
                }], calloutsLabelMemberPath: [{
                    type: i0.Input
                }], calloutsContentMemberPath: [{
                    type: i0.Input
                }], seriesAdded: [{
                    type: i0.Output
                }], seriesRemoved: [{
                    type: i0.Output
                }], seriesPointerEnter: [{
                    type: i0.Output
                }], seriesPointerLeave: [{
                    type: i0.Output
                }], seriesPointerMove: [{
                    type: i0.Output
                }], seriesPointerDown: [{
                    type: i0.Output
                }], seriesPointerUp: [{
                    type: i0.Output
                }], calloutStyleUpdating: [{
                    type: i0.Output
                }] } });

    /**
     * Represents a base class for domain charts with X/Y axes
    */
    var IgxXYChartComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxXYChartComponent, _super);
        function IgxXYChartComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxXYChartComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisFormatLabel", {
            /**
             * Gets or sets function which takes an context object and returns a formatted label for the X-axis.
            *
            * To customize the text of the x-axis label, set `xAxisFormatLabel` to a single-parameter function.  The argument passed to that function will be your data item.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     [xAxisFormatLabel]="formatX"
            *     xAxisExtent="250">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * formatX(item: any): string {
            *     return "[ " + item.label + "! ]";
            * }
            * ```
            */
            get: function () {
                return this.i.l2;
            },
            set: function (v) {
                this.i.l2 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisFormatLabel", {
            /**
             * Gets or sets function which takes a context object and returns a formatted label for the Y-axis.
            *
            * To customize the text of the y-axis label, set `yAxisFormatLabel` to a single-parameter function.  The argument passed to that function will be the numeric value corresponding to a position on the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     [yAxisFormatLabel]="formatY">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * formatY(value: any): string {
            *     return "[ " + value+ "! ]";
            * }
            * ```
            */
            get: function () {
                return this.i.l3;
            },
            set: function (v) {
                this.i.l3 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelLeftMargin", {
            /**
             * Gets or sets the left margin of labels on the X-axis
            *
            * Use the `xAxisLabelLeftMargin` property to apply a margin left of the x-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelLeftMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelLeftMargin ="100";
            * ```
            */
            get: function () {
                return this.i.nj;
            },
            set: function (v) {
                this.i.nj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelTopMargin", {
            /**
             * Gets or sets the top margin of labels on the X-axis
            *
            * Use the `xAxisLabelTopMargin` property to apply a margin above the x-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleTopMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleTopMargin="250";
            * ```
            */
            get: function () {
                return this.i.nl;
            },
            set: function (v) {
                this.i.nl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelRightMargin", {
            /**
             * Gets or sets the right margin of labels on the X-axis
            *
            * Use the `xAxisLabelRightMargin` property to apply a margin right of the x-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelRightMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelRightMargin="100";
            * ```
            */
            get: function () {
                return this.i.nk;
            },
            set: function (v) {
                this.i.nk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelBottomMargin", {
            /**
             * Gets or sets the bottom margin of labels on the X-axis
            *
            * Use the `xAxisLabelBottomMargin` property to apply a margin below the x-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelBottomMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelBottomMargin ="100";
            * ```
            */
            get: function () {
                return this.i.ni;
            },
            set: function (v) {
                this.i.ni = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelLeftMargin", {
            /**
             * Gets or sets the left margin of labels on the Y-axis
            *
            * Use the `yAxisLabelLeftMargin` property to apply a margin left of the y-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelLeftMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart. yAxisLabelLeftMargin="250";
            * ```
            */
            get: function () {
                return this.i.n0;
            },
            set: function (v) {
                this.i.n0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelTopMargin", {
            /**
             * Gets or sets the top margin of labels on the Y-axis
            *
            * Use the `yAxisLabelTopMargin` property to apply a margin above the y-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelTopMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelTopMargin="250";
            * ```
            */
            get: function () {
                return this.i.n2;
            },
            set: function (v) {
                this.i.n2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelRightMargin", {
            /**
             * Gets or sets the right margin of labels on the Y-axis
            *
            * Use the `yAxisLabelRightMargin` property to apply a margin right of the y-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelRightMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelRightMargin="250";
            * ```
            */
            get: function () {
                return this.i.n1;
            },
            set: function (v) {
                this.i.n1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelBottomMargin", {
            /**
             * Gets or sets the bottom margin of labels on the Y-axis
            *
            * Use the `yAxisLabelBottomMargin` property to apply a margin below the y-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelBottomMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelBottomMargin="250";
            * ```
            */
            get: function () {
                return this.i.nz;
            },
            set: function (v) {
                this.i.nz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelTextColor", {
            /**
             * Gets or sets color of labels on the X-axis
            *
            * To change the color of x-axis labels, set the `xAxisLabelTextColor` property to a color string.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelTextColor="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelTextColor="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.r7);
            },
            set: function (v) {
                this.i.r7 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelTextColor", {
            /**
             * Gets or sets color of labels on the Y-axis
            *
            * To change the color of y-axis labels, set the `yAxisLabelTextColor` property to a color string.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelTextColor="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelTextColor="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.se);
            },
            set: function (v) {
                this.i.se = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "actualXAxisLabelTextColor", {
            /**
             * Gets the actual color of labels on the X-axis
            */
            get: function () {
                return i2.brushToString(this.i.r5);
            },
            set: function (v) {
                this.i.r5 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "actualYAxisLabelTextColor", {
            /**
             * Gets the actual color of labels on the Y-axis
            */
            get: function () {
                return i2.brushToString(this.i.r6);
            },
            set: function (v) {
                this.i.r6 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleMargin", {
            /**
             * Gets or sets the margin around a title on the X-axis
            *
            * Use the `xAxisTitleMargin` property to set a margin around the y-axis title.
            */
            get: function () {
                return this.i.nu;
            },
            set: function (v) {
                this.i.nu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleMargin", {
            /**
             * Gets or sets the margin around a title on the Y-axis
            *
            * Use the `yAxisTitleMargin` property to set a margin around the y-axis title.
            */
            get: function () {
                return this.i.ob;
            },
            set: function (v) {
                this.i.ob = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleLeftMargin", {
            /**
             * Gets or sets the left margin of a title on the X-axis
            *
            * Use the `xAxisTitleLeftMargin` property to apply a margin left of the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleAlignment="left"
            *     xAxisTitleLeftMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleLeftMargin="150";
            * ```
            */
            get: function () {
                return this.i.nt;
            },
            set: function (v) {
                this.i.nt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleLeftMargin", {
            /**
             * Gets or sets the left margin of a title on the Y-axis
            *
            * Use the `yAxisTitleLeftMargin` property to apply a margin left of the y-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleLeftMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleLeftMargin="150";
            * ```
            */
            get: function () {
                return this.i.oa;
            },
            set: function (v) {
                this.i.oa = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleTopMargin", {
            /**
             * Gets or sets the top margin of a title on the X-axis
            *
            * Use the `xAxisTitleTopMargin` property to apply a margin above the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleTopMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleTopMargin="150";
            * ```
            */
            get: function () {
                return this.i.nw;
            },
            set: function (v) {
                this.i.nw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleTopMargin", {
            /**
             * Gets or sets the top margin of a title on the Y-axis
            *
            * Use the `yAxisTitleTopMargin` property to apply a margin above the y-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleAlignment="top"
            *     yAxisTitleTopMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleTopMargin="150";
            * ```
            */
            get: function () {
                return this.i.od;
            },
            set: function (v) {
                this.i.od = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleRightMargin", {
            /**
             * Gets or sets the right margin of a title on the X-axis
            *
            * Use the `xAxisTitleRightMargin` property to apply a margin right of the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleAlignment="right"
            *     xAxisTitleRightMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleRightMargin="100";
            * ```
            */
            get: function () {
                return this.i.nv;
            },
            set: function (v) {
                this.i.nv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleRightMargin", {
            /**
             * Gets or sets the right margin of a title on the Y-axis
            *
            * Use the `yAxisTitleRightMargin` property to apply a margin right of the y-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleRightMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleRightMargin="150";
            * ```
            */
            get: function () {
                return this.i.oc;
            },
            set: function (v) {
                this.i.oc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleBottomMargin", {
            /**
             * Gets or sets the bottom margin of a title on the X-axis
            *
            * Use the `xAxisTitleBottomMargin` property to apply a margin below the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleBottomMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleBottomMargin="150";
            * ```
            */
            get: function () {
                return this.i.ns;
            },
            set: function (v) {
                this.i.ns = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleBottomMargin", {
            /**
             * Gets or sets the bottom margin of a title on the Y-axis
            *
            * Use the `yAxisTitleBottomMargin` property to apply a margin below the y-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleAlignment="bottom"
            *     yAxisTitleBottomMargin="100">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleBottomMargin="150";
            * ```
            */
            get: function () {
                return this.i.n9;
            },
            set: function (v) {
                this.i.n9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleTextColor", {
            /**
             * Gets or sets color of title on the X-axis
            *
            * To change the color of the x-axis title, set the `xAxisTitleTextColor` property to a color string.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleTextColor="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleTextColor="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sd);
            },
            set: function (v) {
                this.i.sd = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleTextColor", {
            /**
             * Gets or sets color of title on the Y-axis
            *
            * To change the color of the y-axis title, set the `yAxisTitleTextColor` property to a color string.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleTextColor="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleTextColor="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sk);
            },
            set: function (v) {
                this.i.sk = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelTextStyle", {
            /**
             * Gets or sets CSS font property for labels on X-axis
            *
            * To change the font of x-axis labels, set the `xAxisLabelTextStyle` property.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelTextStyle="italic 15px arial, sans-serif">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelTextStyle="italic 15px arial, sans-serif";
            * ```
            */
            get: function () {
                return this.i.o7;
            },
            set: function (v) {
                this.i.o7 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelTextStyle", {
            /**
             * Gets or sets CSS font property for labels on Y-axis
            *
            * To change the font of x-axis labels, set the `yAxisLabelTextStyle` property.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelTextStyle="italic 15px arial, sans-serif">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart. yAxisLabelTextStyle="italic 15px arial, sans-serif";
            * ```
            */
            get: function () {
                return this.i.qc;
            },
            set: function (v) {
                this.i.qc = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleTextStyle", {
            /**
             * Gets or sets CSS font property for title on X-axis
            *
            * To change the font of the x-axis title, set the `xAxisTitleTextStyle` property.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleTextStyle="italic 15px arial, sans-serif">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleTextStyle="italic 15px arial, sans-serif";
            * ```
            */
            get: function () {
                return this.i.pv;
            },
            set: function (v) {
                this.i.pv = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleTextStyle", {
            /**
             * Gets or sets CSS font property for title on Y-axis
            *
            * To change the font of the x-axis title, set the `yAxisTitleTextStyle` property.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="y axis"
            *     yAxisTitleTextStyle="italic 15px arial, sans-serif">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleTextStyle="italic 15px arial, sans-serif";
            * ```
            */
            get: function () {
                return this.i.q0;
            },
            set: function (v) {
                this.i.q0 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabel", {
            /**
             * Gets or sets the format for labels along the X-axis.
            */
            get: function () {
                return this.i.og;
            },
            set: function (v) {
                this.i.og = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabel", {
            /**
             * Gets or sets the property or string from which the labels are derived.
            */
            get: function () {
                return this.i.oh;
            },
            set: function (v) {
                this.i.oh = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisMajorStroke", {
            /**
             * Gets or sets the color to apply to major gridlines along the X-axis.
            *
            * Set `xAxisMajorStroke` to control the color of major gridlines extending vertically from the x-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisMajorStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisMajorStroke="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.r8);
            },
            set: function (v) {
                this.i.r8 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisMajorStroke", {
            /**
             * Gets or sets the color to apply to major gridlines along the Y-axis.
            *
            * Set `yAxisMajorStroke` to control the color of major gridlines extending horizontally from the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMajorStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisMajorStroke="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sf);
            },
            set: function (v) {
                this.i.sf = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisMajorStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to major gridlines along the X-axis.
            *
            * Set `xAxisMajorStrokeThickness` to control the thickness of major gridlines extending vertically from the x-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisMajorStroke="green"
            *     xAxisMajorStrokeThickness="3">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisMajorStrokeThickness="3" ;
            * ```
            */
            get: function () {
                return this.i.nm;
            },
            set: function (v) {
                this.i.nm = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisMajorStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to major gridlines along the Y-axis.
            *
            * Set `yAxisMajorStrokeThickness` to control the thickness of major gridlines extending horizontally from the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMajorStrokeThickness="3">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisMajorStrokeThickness="2";
            * ```
            */
            get: function () {
                return this.i.n3;
            },
            set: function (v) {
                this.i.n3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisMinorStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to minor gridlines along the X-axis.
            *
            * Set `xAxisMinorStrokeThickness` to control the thickness of minor gridlines extending vertically from the x-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisMinorStroke="green"
            *     xAxisMinorStrokeThickness="3">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisMinorStrokeThickness="3";
            * ```
            */
            get: function () {
                return this.i.nn;
            },
            set: function (v) {
                this.i.nn = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisMinorStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to minor gridlines along the Y-axis.
            *
            * Set `yAxisMinorStrokeThickness` to control the thickness of minor gridlines extending horizontally from the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMinorStroke="green"
            *     yAxisMinorStrokeThickness="3">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisMinorStrokeThickness="3";
            * ```
            */
            get: function () {
                return this.i.n4;
            },
            set: function (v) {
                this.i.n4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisStrip", {
            /**
             * Gets or sets the color to apply to stripes along the X-axis.
            *
            * Set `xAxisStrip` to control the alternating color of stripes extending vertically from the x-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisStrip="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisStrip="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sa);
            },
            set: function (v) {
                this.i.sa = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisStrip", {
            /**
             * Gets or sets the color to apply to stripes along the Y-axis.
            *
            * Set `yAxisStrip` to control the alternating color of stripes extending horizontally from the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisStrip="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisStrip="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sh);
            },
            set: function (v) {
                this.i.sh = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisStroke", {
            /**
             * Gets or sets the color to apply to the X-axis line.
            *
            * Set `xAxisStroke` to control the color of the x-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisStroke="green"";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sb);
            },
            set: function (v) {
                this.i.sb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisStroke", {
            /**
             * Gets or sets the color to apply to the Y-axis line.
            *
            * Set `yAxisStroke` to control the color of the y-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisStroke="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.si);
            },
            set: function (v) {
                this.i.si = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to the X-axis line.
            *
            * Set `xAxisStrokeThickness` to control the thickness of the x-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisStrokeThickness="3">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisStrokeThickness="2";
            * ```
            */
            get: function () {
                return this.i.no;
            },
            set: function (v) {
                this.i.no = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to the Y-axis line.
            *
            * Set `yAxisStrokeThickness` to control the thickness of the y-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisStroke="green"
            *     yAxisStrokeThickness="3">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart. yAxisStrokeThickness="2";
            * ```
            */
            get: function () {
                return this.i.n5;
            },
            set: function (v) {
                this.i.n5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTickLength", {
            /**
             * Gets or sets the length of tickmarks along the X-axis.
            *
            * Set `xAxisTickLength` to control the length of tickmarks extending vertically from the x-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTickLength="23">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTickLength="25";
            * ```
            */
            get: function () {
                return this.i.np;
            },
            set: function (v) {
                this.i.np = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTickLength", {
            /**
             * Gets or sets the length of tickmarks along the Y-axis.
            *
            * Set `yAxisTickLength` to control the length of tickmarks extending horizontally from the y-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTickLength="23">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTickLength="25";
            * ```
            */
            get: function () {
                return this.i.n6;
            },
            set: function (v) {
                this.i.n6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTickStroke", {
            /**
             * Gets or sets the color to apply to tickmarks along the X-axis.
            *
            * Set `xAxisTickStroke` to control the color of tickmarks extending vertically from the x-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTickStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart. xAxisTickStroke="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sc);
            },
            set: function (v) {
                this.i.sc = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTickStroke", {
            /**
             * Gets or sets the color to apply to tickmarks along the Y-axis.
            *
            * Set `yAxisTickStroke` to control the color of tickmarks extending horizontally from the y-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTickLength="5"
            *     yAxisTickStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTickStroke="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sj);
            },
            set: function (v) {
                this.i.sj = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTickStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to tickmarks along the X-axis.
            *
            * Set `xAxisTickStrokeThickness` to control the thickness of tickmarks extending vertically from the x-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTickStrokeThickness="10">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTickStrokeThickness="20";
            * ```
            */
            get: function () {
                return this.i.nq;
            },
            set: function (v) {
                this.i.nq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTickStrokeThickness", {
            /**
             * Gets or sets the thickness to apply to tickmarks along the Y-axis.
            *
            * Set `yAxisTickStrokeThickness` to control the thickness of tickmarks extending vertically from the y-axis line.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTickLength="5"
            *     yAxisTickStrokeThickness="10">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTickStrokeThickness="25";
            * ```
            */
            get: function () {
                return this.i.n7;
            },
            set: function (v) {
                this.i.n7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitle", {
            /**
             * Gets or sets the Text to display below the X-axis.
            *
            * Set `xAxisTitle` to display a label adjacent to the x-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart. xAxisTitle="x axis";
            * ```
            */
            get: function () {
                return this.i.pm;
            },
            set: function (v) {
                this.i.pm = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitle", {
            /**
             * Gets or sets the Text to display to the left of the Y-axis.
            *
            * Set `yAxisTitle` to display a label adjacent to the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitle="y axis";
            * ```
            */
            get: function () {
                return this.i.qr;
            },
            set: function (v) {
                this.i.qr = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisMinorStroke", {
            /**
             * Gets or sets the color to apply to minor gridlines along the X-axis.
            *
            * Set `xAxisMinorStroke` to control the color of minor gridlines extending vertically from the x-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisMinorStroke="green">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisExtent="250";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.r9);
            },
            set: function (v) {
                this.i.r9 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisMinorStroke", {
            /**
             * Gets or sets the color to apply to minor gridlines along the Y-axis.
            *
            * Set `yAxisMinorStroke` to control the color of minor gridlines extending horizontally from the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMinorStroke="green"
            *     yAxisMinorStrokeThickness="1">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisMinorStroke="green";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sg);
            },
            set: function (v) {
                this.i.sg = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelAngle", {
            /**
             * Gets or sets the angle of rotation for labels along the X-axis.
            *
            * To control the rotation of labels on the x-axis, set the `xAxisLabelAngle` property to a number of rotational degrees.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelAngle="45">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelAngle="45";
            * ```
            */
            get: function () {
                return this.i.nh;
            },
            set: function (v) {
                this.i.nh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelAngle", {
            /**
             * Gets or sets the angle of rotation for labels along the Y-axis.
            *
            * To control the rotation of labels on the y-axis, set the `yAxisLabelAngle` property to a number of rotational degrees.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelAngle="45">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelAngle="25";
            * ```
            */
            get: function () {
                return this.i.ny;
            },
            set: function (v) {
                this.i.ny = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisExtent", {
            /**
             * Gets or sets the distance between the X-axis and the bottom of the chart.
            *
            * To allocate space between the x-axis and the edge of the chart, set the `xAxisExtent` property.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisExtent="250">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisExtent="250";
            * ```
            */
            get: function () {
                return this.i.ng;
            },
            set: function (v) {
                this.i.ng = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisExtent", {
            /**
             * Gets or sets the distance between the Y-axis and the left edge of the chart.
            *
            * To allocate space between the x-axis and the edge of the chart, set the `xAxisExtent` property.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisExtent="250">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisExtent="250";
            * ```
            */
            get: function () {
                return this.i.nx;
            },
            set: function (v) {
                this.i.nx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleAngle", {
            /**
             * Gets or sets the angle of rotation for the X-axis title.
            *
            * Set `xAxisTitleAngle` to control the rotation of the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleAngle="45">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleAngle="50";
            * ```
            */
            get: function () {
                return this.i.nr;
            },
            set: function (v) {
                this.i.nr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleAngle", {
            /**
             * Gets or sets the angle of rotation for the Y-axis title.
            *
            * Set `yAxisTitleAngle` to control the rotation of the y-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleAngle="45">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleAngle="25";
            * ```
            */
            get: function () {
                return this.i.n8;
            },
            set: function (v) {
                this.i.n8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisInverted", {
            /**
             * Gets or sets whether to invert the direction of the X-axis by placing the first data items on the right side of the chart.
            *
            * To reverse the direction of items along the x-axis, set the `xAxisInverted` property to true.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisInverted="true">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.XAxisInverted="True";
            * ```
            */
            get: function () {
                return this.i.mc;
            },
            set: function (v) {
                this.i.mc = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisInverted", {
            /**
             * Gets or sets whether to invert the direction of the Y-axis by placing the minimum numeric value at the top of the chart.
            *
            * You can use `yAxisInverted` to invert the scale of the y axis like this:
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisInverted="true"
            * >
            *
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisInverted="true";
            * ```
            *
            * The default value of `yAxisInverted` is false.
            */
            get: function () {
                return this.i.md;
            },
            set: function (v) {
                this.i.md = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisTitleAlignment", {
            /**
             * Gets or sets Horizontal alignment of the X-axis title.
            *
            * Set `xAxisTitleAlignment` to control the horizontal alignment of the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisTitle="x axis"
            *     xAxisTitleAlignment="right">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisTitleAlignment="right";
            * ```
            */
            get: function () {
                return this.i.rn;
            },
            set: function (v) {
                this.i.rn = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisTitleAlignment", {
            /**
             * Gets or sets Vertical alignment of the Y-axis title.
            *
            * Set `yAxisTitleAlignment` to control the vertical alignment of the x-axis title.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisTitle="y axis"
            *     yAxisTitleAlignment="bottom">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisTitleAlignment="bottom";
            * ```
            */
            get: function () {
                return this.i.sq;
            },
            set: function (v) {
                this.i.sq = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelHorizontalAlignment", {
            /**
             * Gets or sets Horizontal alignment of X-axis labels.
            */
            get: function () {
                return this.i.rm;
            },
            set: function (v) {
                this.i.rm = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelHorizontalAlignment", {
            /**
             * Gets or sets Horizontal alignment of Y-axis labels.
            *
            * Set the `yAxisLabelHorizontalAlignment` property to change the horizontal alignment of y-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisExtent="250"
            *     yAxisLabelHorizontalAlignment="left">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.ro;
            },
            set: function (v) {
                this.i.ro = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelVerticalAlignment", {
            /**
             * Gets or sets Vertical alignment of X-axis labels.
            *
            * Use the `xAxisLabelVerticalAlignment` property to change the vertical position of x-axis labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisExtent="250"
            *     xAxisLabelVerticalAlignment="bottom">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelVerticalAlignment="bottom";
            * ```
            */
            get: function () {
                return this.i.so;
            },
            set: function (v) {
                this.i.so = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelVerticalAlignment", {
            /**
             * Gets or sets Vertical alignment of Y-axis labels.
            */
            get: function () {
                return this.i.sp;
            },
            set: function (v) {
                this.i.sp = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelVisibility", {
            /**
             * Gets or sets Visibility of X-axis labels.
            *
            * To hide the x-axis labels, set `xAxisLabelVisibility` to collapsed.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisLabelVisibility="collapsed">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.xAxisLabelVisibility="collapsed";
            * ```
            */
            get: function () {
                return this.i.st;
            },
            set: function (v) {
                this.i.st = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelVisibility", {
            /**
             * Gets or sets Visibility of Y-axis labels.
            *
            * To hide the y-axis labels, set `yAxisLabelVisibility` to collapsed.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelVisibility="collapsed">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelVisibility="collapsed"";
            * ```
            */
            get: function () {
                return this.i.su;
            },
            set: function (v) {
                this.i.su = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelLocation", {
            /**
             * Gets or sets location of Y-axis labels, relative to the plot area.
            *
            * Set the `yAxisLabelLocation` property to change the location of the y-axis and its labels.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisLabelLocation="outsideRight">
            * </igx-category-chart>
            * ```
            *
            * ```ts
            * this.chart.yAxisLabelLocation="outsideRight";
            * ```
            */
            get: function () {
                return this.i.l9;
            },
            set: function (v) {
                this.i.l9 = i2.ensureEnum(YAxisLabelLocation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelLocation", {
            /**
             * Gets or sets location of X-axis labels, relative to the plot area.
            */
            get: function () {
                return this.i.l7;
            },
            set: function (v) {
                this.i.l7 = i2.ensureEnum(XAxisLabelLocation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelFormat", {
            /**
             * Gets or sets the format string for the X axis label.
            */
            get: function () {
                return this.i.oy;
            },
            set: function (v) {
                this.i.oy = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "xAxisLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the XAxisLabelFormat string.
            */
            get: function () {
                return this.i.lw;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.lw = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelFormat", {
            /**
             * Gets or sets the format string for the Y axis label.
            */
            get: function () {
                return this.i.p3;
            },
            set: function (v) {
                this.i.p3 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxXYChartComponent.prototype, "yAxisLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the YAxisLabelFormat string.
            */
            get: function () {
                return this.i.lx;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.lx = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxXYChartComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxisLabelFormatSpecifiers != null && i2.arrayFindByName(this.xAxisLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.xAxisLabelFormatSpecifiers, name);
            }
            if (this.yAxisLabelFormatSpecifiers != null && i2.arrayFindByName(this.yAxisLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.yAxisLabelFormatSpecifiers, name);
            }
            return null;
        };
        /**
         * Called by the UI framework to provide a UI container for rendering this control.
        
        * @param container  * The UI container element.
        */
        IgxXYChartComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        /**
         * Converts the given visual location to a data value.
        
        * @param unscaledValue  * The x-coordinate of the location to scale.
        */
        IgxXYChartComponent.prototype.getScaledValueX = function (unscaledValue) {
            var iv = this.i.nc(unscaledValue);
            return (iv);
        };
        /**
         * Converts the given data value to a visual location.
        
        * @param scaledValue  * The data value to un-scale.
        */
        IgxXYChartComponent.prototype.getUnscaledValueX = function (scaledValue) {
            var iv = this.i.ne(scaledValue);
            return (iv);
        };
        /**
         * Converts the given visual location to a data value.
        
        * @param unscaledValue  * The y-coordinate of the location to scale.
        */
        IgxXYChartComponent.prototype.getScaledValueY = function (unscaledValue) {
            var iv = this.i.nd(unscaledValue);
            return (iv);
        };
        /**
         * Converts the given data value to a visual location.
        
        * @param scaledValue  * The data value to un-scale.
        */
        IgxXYChartComponent.prototype.getUnscaledValueY = function (scaledValue) {
            var iv = this.i.nf(scaledValue);
            return (iv);
        };
        IgxXYChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxXYChartComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxXYChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxXYChartComponent, selector: "ng-component", inputs: { xAxisFormatLabel: "xAxisFormatLabel", yAxisFormatLabel: "yAxisFormatLabel", xAxisLabelLeftMargin: "xAxisLabelLeftMargin", xAxisLabelTopMargin: "xAxisLabelTopMargin", xAxisLabelRightMargin: "xAxisLabelRightMargin", xAxisLabelBottomMargin: "xAxisLabelBottomMargin", yAxisLabelLeftMargin: "yAxisLabelLeftMargin", yAxisLabelTopMargin: "yAxisLabelTopMargin", yAxisLabelRightMargin: "yAxisLabelRightMargin", yAxisLabelBottomMargin: "yAxisLabelBottomMargin", xAxisLabelTextColor: "xAxisLabelTextColor", yAxisLabelTextColor: "yAxisLabelTextColor", actualXAxisLabelTextColor: "actualXAxisLabelTextColor", actualYAxisLabelTextColor: "actualYAxisLabelTextColor", xAxisTitleMargin: "xAxisTitleMargin", yAxisTitleMargin: "yAxisTitleMargin", xAxisTitleLeftMargin: "xAxisTitleLeftMargin", yAxisTitleLeftMargin: "yAxisTitleLeftMargin", xAxisTitleTopMargin: "xAxisTitleTopMargin", yAxisTitleTopMargin: "yAxisTitleTopMargin", xAxisTitleRightMargin: "xAxisTitleRightMargin", yAxisTitleRightMargin: "yAxisTitleRightMargin", xAxisTitleBottomMargin: "xAxisTitleBottomMargin", yAxisTitleBottomMargin: "yAxisTitleBottomMargin", xAxisTitleTextColor: "xAxisTitleTextColor", yAxisTitleTextColor: "yAxisTitleTextColor", xAxisLabelTextStyle: "xAxisLabelTextStyle", yAxisLabelTextStyle: "yAxisLabelTextStyle", xAxisTitleTextStyle: "xAxisTitleTextStyle", yAxisTitleTextStyle: "yAxisTitleTextStyle", xAxisLabel: "xAxisLabel", yAxisLabel: "yAxisLabel", xAxisMajorStroke: "xAxisMajorStroke", yAxisMajorStroke: "yAxisMajorStroke", xAxisMajorStrokeThickness: "xAxisMajorStrokeThickness", yAxisMajorStrokeThickness: "yAxisMajorStrokeThickness", xAxisMinorStrokeThickness: "xAxisMinorStrokeThickness", yAxisMinorStrokeThickness: "yAxisMinorStrokeThickness", xAxisStrip: "xAxisStrip", yAxisStrip: "yAxisStrip", xAxisStroke: "xAxisStroke", yAxisStroke: "yAxisStroke", xAxisStrokeThickness: "xAxisStrokeThickness", yAxisStrokeThickness: "yAxisStrokeThickness", xAxisTickLength: "xAxisTickLength", yAxisTickLength: "yAxisTickLength", xAxisTickStroke: "xAxisTickStroke", yAxisTickStroke: "yAxisTickStroke", xAxisTickStrokeThickness: "xAxisTickStrokeThickness", yAxisTickStrokeThickness: "yAxisTickStrokeThickness", xAxisTitle: "xAxisTitle", yAxisTitle: "yAxisTitle", xAxisMinorStroke: "xAxisMinorStroke", yAxisMinorStroke: "yAxisMinorStroke", xAxisLabelAngle: "xAxisLabelAngle", yAxisLabelAngle: "yAxisLabelAngle", xAxisExtent: "xAxisExtent", yAxisExtent: "yAxisExtent", xAxisTitleAngle: "xAxisTitleAngle", yAxisTitleAngle: "yAxisTitleAngle", xAxisInverted: "xAxisInverted", yAxisInverted: "yAxisInverted", xAxisTitleAlignment: "xAxisTitleAlignment", yAxisTitleAlignment: "yAxisTitleAlignment", xAxisLabelHorizontalAlignment: "xAxisLabelHorizontalAlignment", yAxisLabelHorizontalAlignment: "yAxisLabelHorizontalAlignment", xAxisLabelVerticalAlignment: "xAxisLabelVerticalAlignment", yAxisLabelVerticalAlignment: "yAxisLabelVerticalAlignment", xAxisLabelVisibility: "xAxisLabelVisibility", yAxisLabelVisibility: "yAxisLabelVisibility", yAxisLabelLocation: "yAxisLabelLocation", xAxisLabelLocation: "xAxisLabelLocation", xAxisLabelFormat: "xAxisLabelFormat", xAxisLabelFormatSpecifiers: "xAxisLabelFormatSpecifiers", yAxisLabelFormat: "yAxisLabelFormat", yAxisLabelFormatSpecifiers: "yAxisLabelFormatSpecifiers" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxXYChartComponent;
    }(IgxDomainChartComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxXYChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxisFormatLabel: [{
                    type: i0.Input
                }], yAxisFormatLabel: [{
                    type: i0.Input
                }], xAxisLabelLeftMargin: [{
                    type: i0.Input
                }], xAxisLabelTopMargin: [{
                    type: i0.Input
                }], xAxisLabelRightMargin: [{
                    type: i0.Input
                }], xAxisLabelBottomMargin: [{
                    type: i0.Input
                }], yAxisLabelLeftMargin: [{
                    type: i0.Input
                }], yAxisLabelTopMargin: [{
                    type: i0.Input
                }], yAxisLabelRightMargin: [{
                    type: i0.Input
                }], yAxisLabelBottomMargin: [{
                    type: i0.Input
                }], xAxisLabelTextColor: [{
                    type: i0.Input
                }], yAxisLabelTextColor: [{
                    type: i0.Input
                }], actualXAxisLabelTextColor: [{
                    type: i0.Input
                }], actualYAxisLabelTextColor: [{
                    type: i0.Input
                }], xAxisTitleMargin: [{
                    type: i0.Input
                }], yAxisTitleMargin: [{
                    type: i0.Input
                }], xAxisTitleLeftMargin: [{
                    type: i0.Input
                }], yAxisTitleLeftMargin: [{
                    type: i0.Input
                }], xAxisTitleTopMargin: [{
                    type: i0.Input
                }], yAxisTitleTopMargin: [{
                    type: i0.Input
                }], xAxisTitleRightMargin: [{
                    type: i0.Input
                }], yAxisTitleRightMargin: [{
                    type: i0.Input
                }], xAxisTitleBottomMargin: [{
                    type: i0.Input
                }], yAxisTitleBottomMargin: [{
                    type: i0.Input
                }], xAxisTitleTextColor: [{
                    type: i0.Input
                }], yAxisTitleTextColor: [{
                    type: i0.Input
                }], xAxisLabelTextStyle: [{
                    type: i0.Input
                }], yAxisLabelTextStyle: [{
                    type: i0.Input
                }], xAxisTitleTextStyle: [{
                    type: i0.Input
                }], yAxisTitleTextStyle: [{
                    type: i0.Input
                }], xAxisLabel: [{
                    type: i0.Input
                }], yAxisLabel: [{
                    type: i0.Input
                }], xAxisMajorStroke: [{
                    type: i0.Input
                }], yAxisMajorStroke: [{
                    type: i0.Input
                }], xAxisMajorStrokeThickness: [{
                    type: i0.Input
                }], yAxisMajorStrokeThickness: [{
                    type: i0.Input
                }], xAxisMinorStrokeThickness: [{
                    type: i0.Input
                }], yAxisMinorStrokeThickness: [{
                    type: i0.Input
                }], xAxisStrip: [{
                    type: i0.Input
                }], yAxisStrip: [{
                    type: i0.Input
                }], xAxisStroke: [{
                    type: i0.Input
                }], yAxisStroke: [{
                    type: i0.Input
                }], xAxisStrokeThickness: [{
                    type: i0.Input
                }], yAxisStrokeThickness: [{
                    type: i0.Input
                }], xAxisTickLength: [{
                    type: i0.Input
                }], yAxisTickLength: [{
                    type: i0.Input
                }], xAxisTickStroke: [{
                    type: i0.Input
                }], yAxisTickStroke: [{
                    type: i0.Input
                }], xAxisTickStrokeThickness: [{
                    type: i0.Input
                }], yAxisTickStrokeThickness: [{
                    type: i0.Input
                }], xAxisTitle: [{
                    type: i0.Input
                }], yAxisTitle: [{
                    type: i0.Input
                }], xAxisMinorStroke: [{
                    type: i0.Input
                }], yAxisMinorStroke: [{
                    type: i0.Input
                }], xAxisLabelAngle: [{
                    type: i0.Input
                }], yAxisLabelAngle: [{
                    type: i0.Input
                }], xAxisExtent: [{
                    type: i0.Input
                }], yAxisExtent: [{
                    type: i0.Input
                }], xAxisTitleAngle: [{
                    type: i0.Input
                }], yAxisTitleAngle: [{
                    type: i0.Input
                }], xAxisInverted: [{
                    type: i0.Input
                }], yAxisInverted: [{
                    type: i0.Input
                }], xAxisTitleAlignment: [{
                    type: i0.Input
                }], yAxisTitleAlignment: [{
                    type: i0.Input
                }], xAxisLabelHorizontalAlignment: [{
                    type: i0.Input
                }], yAxisLabelHorizontalAlignment: [{
                    type: i0.Input
                }], xAxisLabelVerticalAlignment: [{
                    type: i0.Input
                }], yAxisLabelVerticalAlignment: [{
                    type: i0.Input
                }], xAxisLabelVisibility: [{
                    type: i0.Input
                }], yAxisLabelVisibility: [{
                    type: i0.Input
                }], yAxisLabelLocation: [{
                    type: i0.Input
                }], xAxisLabelLocation: [{
                    type: i0.Input
                }], xAxisLabelFormat: [{
                    type: i0.Input
                }], xAxisLabelFormatSpecifiers: [{
                    type: i0.Input
                }], yAxisLabelFormat: [{
                    type: i0.Input
                }], yAxisLabelFormatSpecifiers: [{
                    type: i0.Input
                }] } });

    var defaultFont = "\"Verdana\", Arial, sans-serif";
    var DataChartStylingDefaults = (function () {
        var DataChartStylingDefaults = {
            "ui-chart-category-axis-tick": {
                "height": "5px",
                "color": "rgba(102, 102, 102, 0.2470)"
            },
            "ui-chart-area-fill-opacity": {
                "opacity": "0.7"
            },
            "ui-chart-aligned-gridlines": {
                "visibility": "visible"
            },
            "ui-chart-axis-stroke": {
                /* transparent is treated as auto */
                "border-top-color": "transparent"
            },
            "ui-chart-axis-major-line": {
                /* transparent is treated as auto */
                "border-top-color": "transparent"
            },
            "font-family": defaultFont,
            "font-style": "normal",
            "font-weight": "normal",
            "font-size": "11px",
            "color": "#666666",
            "font-variant": "",
            "line-height": "",
            "default-font-height": 13
        };
        i2.addPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-axis", null, "rgba(102, 102, 102, 0.2470)");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-chart-title", defaultFont, "16px", "#666", "0px", "0px", "0px", "5px");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-chart-subtitle", defaultFont, "11px", "#666", "0px", "0px", "0px", "5px");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-chart-horizontal-axis-title", defaultFont, "11px", "#666", "0px", "0px", "0px", "5px");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-chart-vertical-axis-title", defaultFont, "11px", "#666", "0px", "0px", "5px", "0px");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-horizontal-axis-labels", defaultFont, "12px", "#666", "0px", "5px", "0px", "5px", null, "top");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-vertical-axis-labels", defaultFont, "12px", "#666", "5px", "0px", "5px", "0px", "right");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-angular-axis-labels", null, null, "#666", "5px", "5px", "5px", "5px");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-radial-axis-labels", null, null, "#666", "0px", "5px", "0px", "5px", null, "top");
        i2.addTextThemeEntry(DataChartStylingDefaults, "ui-funnel-slice", defaultFont, "12px", "#666", "0px", "5px", "0px", "5px", null, "top");
        i2.addBrushPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-palette", ["#8BDC5C", "#8961A9", "#6DB1FF", "#82E9D9", "#EA3C63", "#735656", "#F8CE4F", "#A8A8B7", "#E051A9", "#FF903B"], null);
        i2.addBrushPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-marker-palette", ["#ffffff", "#ffffff", "#ffffff", "#ffffff", "#ffffff", "#ffffff", "#ffffff", "#ffffff", "#ffffff", "#ffffff"], ["#8BDC5C", "#8961A9", "#6DB1FF", "#82E9D9", "#EA3C63", "#735656", "#F8CE4F", "#A8A8B7", "#E051A9", "#FF903B"]);
        return DataChartStylingDefaults;
    })();

    /**
     * Represents a IgxDataChartComponent category X axis.
    *
    * `IgxCategoryXAxisComponent` class represents a IgxDataChartComponent category X axis.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="label" >
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxCategoryXAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryXAxisComponent, _super);
        function IgxCategoryXAxisComponent() {
            var _this = _super.call(this) || this;
            _this._actualIntervalChange = null;
            _this._actualMinorIntervalChange = null;
            return _this;
        }
        IgxCategoryXAxisComponent.prototype.createImplementation = function () {
            return new CategoryXAxis();
        };
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "interval", {
            /**
             * Gets or sets the frequency of displayed labels.
             * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
            *
            * `interval` determines how often to show a label, tickmark, and/or gridline along the x-axis.  Set this property to _n_ to display a label every _nth_ item.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *   <igx-category-x-axis #xAxis
            *     label="label"
            *     interval="3">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * xAxis.interval="3";
            * series.yAxis = this.yAxis;
            *
            * series.valueMemberPath="value";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.ly;
            },
            set: function (v) {
                this.i.ly = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "actualInterval", {
            /**
             * Gets the effective value for the current Interval.
            *
            * ```ts
            * let effectiveInterval: number = xAxis.actualInterval;
            * ```
            */
            get: function () {
                return this.i.lt;
            },
            set: function (v) {
                this.i.lt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "minorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines.
             * The set value is a factor that determines how the minor lines will be displayed.
            *
            * `minorInterval` determines how often to show a minor gridline along the x-axis.  This property is relevant only when the displayed series is a type with grouping, like column series.
            *
            * `minorInterval` is expressed as a number between 0 and 1, representing the frequency of the interval.  To display minor gridlines representing 10ths of an item width, set `minorInterval` to 0.1.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *   <igx-category-x-axis #xAxis
            *     label="label"
            *     minorInterval="0.1"
            *     minorStroke="green"
            *     minorStrokeThickness="1">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * xAxis.minorInterval="0.1";
            * series.yAxis = this.yAxis;
            * series.valueMemberPath="value";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.lz;
            },
            set: function (v) {
                this.i.lz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "actualMinorInterval", {
            /**
             * Gets the effective value for the current MinorInterval.
            *
            * ```ts
            * let effectiveMinorInterval: number = xAxis.actualMinorInterval;
            * ```
            */
            get: function () {
                return this.i.lu;
            },
            set: function (v) {
                this.i.lu = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Scrolls the specified item into view.
        
        * @param item  * Data item to scroll into view
        */
        IgxCategoryXAxisComponent.prototype.scrollIntoView = function (item) {
            this.i.l9(item);
        };
        IgxCategoryXAxisComponent.prototype.scrollRangeIntoView = function (minimum, maximum) {
            this.i.ma(minimum, maximum);
        };
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "actualIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualIntervalChange == null) {
                    this._actualIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualInterval;
                        if (_this.beforeActualIntervalChange) {
                            _this.beforeActualIntervalChange(_this, ext);
                        }
                        _this._actualIntervalChange.emit(ext);
                    });
                }
                return this._actualIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryXAxisComponent.prototype, "actualMinorIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualMinorIntervalChange == null) {
                    this._actualMinorIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMinorInterval;
                        if (_this.beforeActualMinorIntervalChange) {
                            _this.beforeActualMinorIntervalChange(_this, ext);
                        }
                        _this._actualMinorIntervalChange.emit(ext);
                    });
                }
                return this._actualMinorIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryXAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryXAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryXAxisComponent, selector: "igx-category-x-axis", inputs: { interval: "interval", actualInterval: "actualInterval", minorInterval: "minorInterval", actualMinorInterval: "actualMinorInterval" }, outputs: { actualIntervalChange: "actualIntervalChange", actualMinorIntervalChange: "actualMinorIntervalChange" }, providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryXAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryXAxisComponent;
    }(IgxCategoryAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-x-axis',
                        template: "",
                        providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryXAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { interval: [{
                    type: i0.Input
                }], actualInterval: [{
                    type: i0.Input
                }], minorInterval: [{
                    type: i0.Input
                }], actualMinorInterval: [{
                    type: i0.Input
                }], actualIntervalChange: [{
                    type: i0.Output
                }], actualMinorIntervalChange: [{
                    type: i0.Output
                }] } });

    /**
     * Represents a chart with an ordinal X-axis and a numeric Y-axis.
    *
    * **Ignite UI for Angular Category Chart** - [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/CategoryChart.html)
    *
    * The Ignite UI Category Chart is a lightweight, highly performant chart. It can be easily configured to display category data using an extremely simple and intuitive API. All you need to do is provide your data to the chart and it will take care of everything else.
    *
    * Example:
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"    >
    * </igx-category-chart>
    * ```
    */
    var IgxCategoryChartComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryChartComponent, _super);
        function IgxCategoryChartComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = _super.call(this) || this;
            _this.renderer = renderer;
            _this._elRef = _elRef;
            _this.ngZone = ngZone;
            _this.injector = injector;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this._dataSource = null;
            _this._defaultTooltips = null;
            if (_this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
            }
            _this._zoneRunner = function (act) { return ngZone.run(act); };
            _this.container = renderer.createElement("div");
            renderer.appendChild(_elRef.element.nativeElement, _this.container);
            renderer.setStyle(_this.container, "display", "block");
            renderer.setStyle(_this.container, "width", "100%");
            renderer.setStyle(_this.container, "height", "100%");
            var root;
            root = _this.container;
            if (_this.container != null) {
                root = _this.container;
            }
            var ren = new i2.AngularRenderer(root, _this.renderer, window.document, _this.ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            var chart = _this.i;
            _this._chart = chart;
            if (chart.xAxis) {
                var x = new IgxCategoryXAxisComponent();
                x._provideRenderer(ren);
                x._implementation = chart.xAxis;
                chart.xAxis.externalObject = x;
            }
            if (chart.yAxis) {
                var y = new IgxNumericYAxisComponent();
                y._provideRenderer(ren);
                y._implementation = chart.yAxis;
                chart.yAxis.externalObject = y;
            }
            chart.provideContainer(ren);
            _this.bindData();
            chart.notifyResized();
            ren.addSizeWatcher(function () {
                _this._chart.notifyResized();
            });
            return _this;
        }
        Object.defineProperty(IgxCategoryChartComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryChartComponent.prototype.ngOnDestroy = function () {
            this._chart.destroy();
            this._wrapper.destroy();
        };
        IgxCategoryChartComponent.prototype.createImplementation = function () {
            return new CategoryChart();
        };
        Object.defineProperty(IgxCategoryChartComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryChartComponent.prototype.createSeriesComponent = function (type) {
            if (i2.TypeRegistrar.isRegistered(type)) {
                var s = i2.TypeRegistrar.create(type);
                s.owner = this;
                s._provideRenderer(this.renderer);
                return s;
            }
            else {
                //we shouldn't get here, hopefully.
                throw Error("series type not loaded: " + type);
            }
        };
        IgxCategoryChartComponent.prototype.createSeries = function (type) {
            switch (type) {
                case i2.DataSeriesType.Area:
                    return this.createSeriesComponent('IgxAreaSeriesComponent');
                case i2.DataSeriesType.Column:
                    return this.createSeriesComponent('IgxColumnSeriesComponent');
                case i2.DataSeriesType.Line:
                    return this.createSeriesComponent('IgxLineSeriesComponent');
                case i2.DataSeriesType.Point:
                    return this.createSeriesComponent('IgxPointSeriesComponent');
                case i2.DataSeriesType.Spline:
                    return this.createSeriesComponent('IgxSplineSeriesComponent');
                case i2.DataSeriesType.SplineArea:
                    return this.createSeriesComponent('IgxSplineAreaSeriesComponent');
                case i2.DataSeriesType.StepArea:
                    return this.createSeriesComponent('IgxStepAreaSeriesComponent');
                case i2.DataSeriesType.StepLine:
                    return this.createSeriesComponent('IgxStepLineSeriesComponent');
                case i2.DataSeriesType.Waterfall:
                    return this.createSeriesComponent('IgxWaterfallSeriesComponent');
                case i2.DataSeriesType.ItemToolTipLayer:
                    return this.createSeriesComponent('IgxItemToolTipLayerComponent');
                case i2.DataSeriesType.CategoryToolTipLayer:
                    return this.createSeriesComponent('IgxCategoryToolTipLayerComponent');
                case i2.DataSeriesType.CrosshairLayer:
                    return this.createSeriesComponent('IgxCrosshairLayerComponent');
                case i2.DataSeriesType.FinalValueLayer:
                    return this.createSeriesComponent('IgxFinalValueLayerComponent');
                case i2.DataSeriesType.CalloutLayer:
                    return this.createSeriesComponent('IgxCalloutLayerComponent');
                case i2.DataSeriesType.CategoryHighlightLayer:
                    return this.createSeriesComponent('IgxCategoryHighlightLayerComponent');
                case i2.DataSeriesType.CategoryItemHighlightLayer:
                    return this.createSeriesComponent('IgxCategoryItemHighlightLayerComponent');
                default:
                    return this.createSeriesComponent('IgxColumnSeriesComponent');
            }
        };
        Object.defineProperty(IgxCategoryChartComponent.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.bindData();
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryChartComponent.prototype.bindData = function () {
            if (this._chart != null && this._chart !== undefined) {
                this._chart.itemsSource = this._dataSource;
            }
        };
        IgxCategoryChartComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (i2.TypeRegistrar.isRegistered("IgxDataChartDefaultTooltipsComponent")) {
                var c = i2.TypeRegistrar.get("IgxDataChartDefaultTooltipsComponent");
                var cf = this.componentFactoryResolver.resolveComponentFactory(c);
                //let cr = cf.create(this.injector);
                var cr_1 = this._dynamicContent.createComponent(cf);
                this._defaultTooltips = cr_1;
                cr_1.instance.onContentReady.subscribe(function () {
                    _this._onDefaultTooltipsReady(cr_1);
                });
                this.container.appendChild(cr_1.location.nativeElement);
            }
            this._styling(this.container, this);
        };
        IgxCategoryChartComponent.prototype.createTooltip = function () {
            if (!i2.TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
                return null;
            }
            var t = i2.TypeRegistrar.get("IgxTooltipContainerComponent");
            var cf = this.componentFactoryResolver.resolveComponentFactory(t);
            //let cr = cf.create(this.injector);
            var cr = this._dynamicContent.createComponent(cf);
            var ele = cr.location.nativeElement;
            var self = this;
            ele.updateToolTip = function (c, isSubContent) {
                if (c.externalObject) {
                    c = c.externalObject;
                }
                else {
                    var ext = new i2.IgxDataContext();
                    ext._implementation = c;
                    c = ext;
                }
                if (!isSubContent) {
                    if (ele.parentElement != self.container) {
                        if (ele.parentElement != null) {
                            ele.parentElement.removeChild(ele);
                        }
                        self.container.appendChild(ele);
                    }
                }
                else {
                    c.isSubContent = true;
                }
                cr.instance.context = c;
                ele.style.display = "block";
                return true;
            };
            ele.hideToolTip = function () {
                ele.style.display = "none";
            };
            ele.style.display = "none";
            return cr;
        };
        IgxCategoryChartComponent.prototype._ensureTooltipCreated = function (series) {
            var _this = this;
            series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
                var wrapper = new i2.AngularWrapper(ele, _this.renderer, _this.ngZone);
                wrapper.updateToolTip = ele.updateToolTip;
                wrapper.hideToolTip = ele.hideToolTip;
                return wrapper;
            });
        };
        IgxCategoryChartComponent.prototype._createXAxis = function () {
            var x = new IgxCategoryXAxisComponent();
            x._provideRenderer(this.renderer);
            return x.i;
        };
        IgxCategoryChartComponent.prototype._createYAxis = function () {
            var y = new IgxNumericYAxisComponent();
            y.provideRenderer(this.renderer);
            return y.i;
        };
        IgxCategoryChartComponent.prototype._ensureDefaultTooltip = function (series) {
            if (this._defaultTooltips == null) {
                return;
            }
            this._defaultTooltips.instance["ensureDefaultTooltip"](series);
        };
        IgxCategoryChartComponent.prototype._onDefaultTooltipsReady = function (cr) {
            if (this.i.dataChart) {
                var currSeries = this.i.dataChart.series;
                for (var i = 0; i < currSeries.count; i++) {
                    if (currSeries.item(i).externalObject.showDefaultTooltip) {
                        this._ensureDefaultTooltip(currSeries.item(i).externalObject);
                    }
                }
            }
        };
        Object.defineProperty(IgxCategoryChartComponent.prototype, "transitionInDuration", {
            /**
         * Gets or sets the duration used for animating series plots when the chart is loading into view
        *
        * `transitionInDuration` controls the length of time taken by the transition-in animation.  Try setting it to 2 seconds:
        *
        * ```html
        * <igx-category-chart
        *     [dataSource]="data"
        *     isTransitionInEnabled="true"
        *     transitionInDuration="2000">
        * </igx-category-chart>
        * ```
        */
            get: function () {
                return this.i.ui;
            },
            set: function (v) {
                this.i.ui = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "transitionInEasingFunction", {
            /**
             * Gets or sets the easing function used for animating series plots when the chart is loading into view
             * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
            */
            get: function () {
                return this.i.tg;
            },
            set: function (v) {
                this.i.tg = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "domainType", {
            /**
             * Gets domain type of this chart
            */
            get: function () {
                return this.i.ai;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "chartType", {
            /**
             * Gets or sets the type of chart series to generate from the data.
            *
            * The `chartType` property determines the type of data series to display.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     chartType="stepArea">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.s0;
            },
            set: function (v) {
                this.i.s0 = i2.ensureEnum(CategoryChartType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "markerCollisionAvoidance", {
            /**
             * Gets or sets the behavior for markers in each series which are placed too close together for the current view, resulting in a collision.
            *
            * `markerCollisionAvoidance` controls the technique the chart uses to avoid overlapping markers.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     markerCollisionAvoidance="none">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.s2;
            },
            set: function (v) {
                this.i.s2 = i2.ensureEnum(CategorySeriesMarkerCollisionAvoidance_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "isTransitionInEnabled", {
            /**
             * Gets or sets whether animation of series plots is enabled when the chart is loading into view
            *
            * Set `isTransitionInEnabled` to true if you want your chart series to animate into position when the chart is loading into view.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     isTransitionInEnabled="true">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.to;
            },
            set: function (v) {
                this.i.to = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "transitionInMode", {
            /**
             * Gets or sets the method that determines how to animate series plots when the chart is loading into view
            *
            * `transitionInMode` controls the direction of the transition-in animation.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     isTransitionInEnabled="true"
            *     transitionInMode="accordionfromRight">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.s4;
            },
            set: function (v) {
                this.i.s4 = i2.ensureEnum(CategoryTransitionInMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "transitionInSpeedType", {
            /**
             * Gets or sets the arrival speed used for animating series plots when the chart is loading into view
            *
            * `transitionInSpeedType` controls the speed of the transition-in animation.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     isTransitionInEnabled="true"
            *     transitionInSpeedType="indexScaled">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.te;
            },
            set: function (v) {
                this.i.te = i2.ensureEnum(TransitionInSpeedType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "xAxisInterval", {
            /**
             * Gets or sets the frequency of displayed labels along the X-axis.
             * Gets or sets the set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
            *
            * `xAxisInterval` determines how often to show a label, tickmark, and/or gridline along the x-axis.  Set this property to _n_ to display a label every _nth_ item.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisInterval="3">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.t7;
            },
            set: function (v) {
                this.i.t7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "xAxisMinorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines along the X-axis.
             * Gets or sets the set value is a factor that determines how the minor lines will be displayed.
            *
            * `xAxisMinorInterval` determines how often to show a minor gridline along the x-axis.  This property is relevant only when the displayed series is a type with grouping, like column series.
            *
            * `xAxisMinorInterval` is expressed as a number between 0 and 1, representing the frequency of the interval.  To display minor gridlines representing 10ths of an item width, set `xAxisMinorInterval` to 0.1.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisMinorInterval="0.1"
            *     xAxisMinorStroke="green"
            *     xAxisMinorStrokeThickness="1">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.t8;
            },
            set: function (v) {
                this.i.t8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "xAxisGap", {
            /**
             * Gets or sets the amount of space between adjacent categories for the X-axis.
             * The gap is silently clamped to the range [0, 1] when used.
            *
            * Use the `xAxisGap` property to configure the spacing between items on the x-axis.  This property is relevant only when the displayed series is a type with item spacing, like column series.
            *
            * An `xAxisGap` of 0 allocates no space between items.  An `xAxisGap` of 1 allocates a space between items equal to the width of one item.
            *
            * To set the item spacing to 75% the width of one item, set the `xAxisGap` to 0.75, as in this code:
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisGap="0.75">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.t6;
            },
            set: function (v) {
                this.i.t6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "xAxisOverlap", {
            /**
             * Gets or sets the amount of overlap between adjacent categories for the X-axis.
             * Gets or sets the overlap is silently clamped to the range [-1, 1] when used.
            *
            * Use the `xAxisOverlap` property to configure the spacing between items on the x-axis.  This property is relevant only when the displayed series is a type with item spacing, like column series.
            *
            * An `xAxisOverlap` of 0 places grouped items adjacent to each other.  An `xAxisOverlap` of 1 places grouped items in the same axis space, completely overlapping.  An `xAxisOverlap` of -1 places a space between grouped items equal to the width of one item.
            *
            * To place grouped items with 75% overlap, set the `xAxisOverlap` to 0.75, as in this code:
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     xAxisOverlap="0.75">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.t9;
            },
            set: function (v) {
                this.i.t9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisInterval", {
            /**
             * Gets or sets the distance between each label and grid line along the Y-axis.
            *
            * `yAxisInterval` determines how often to show a label, tickmark, and/or gridline along the y-axis.  Set this property to a number less than the numeric range of the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisInterval="10">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.uc;
            },
            set: function (v) {
                this.i.uc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisIsLogarithmic", {
            /**
             * Gets or sets whether the Y-axis should use a logarithmic scale instead of a linear one.
             * Since log(-1) is imaginary and log(0) is undefined, it is recommended to enable this property only when the Y-axis minimum is greater than zero.
            *
            * Set `yAxisIsLogarithmic` to true if you want the y-axis to be a logarithmic scale.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisIsLogarithmic="true">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.tq;
            },
            set: function (v) {
                this.i.tq = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisLogarithmBase", {
            /**
             * Gets or sets the base value to use in the log function when mapping the position of data items along the Y-axis.
             * This property is effective only when YAxisIsLogarithmic is true.
            *
            * When `yAxisIsLogarithmic` is true, `yAxisLogarithmBase` sets the logarithm base of the y-axis scale.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisIsLogarithmic="true"
            *     yAxisLogarithmBase="2">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisMinimumValue", {
            /**
             * Gets or sets the data value corresponding to the minimum value of the Y-axis.
            *
            * `yAxisMaximumValue` determines the minimum of the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMinimumValue="42">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.ue;
            },
            set: function (v) {
                this.i.ue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisMaximumValue", {
            /**
             * Gets or sets the data value corresponding to the maximum value of the Y-axis.
            *
            * `yAxisMaximumValue` determines the maximum of the y-axis.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMaximumValue="42">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.ud;
            },
            set: function (v) {
                this.i.ud = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisMinorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines along the Y-axis.
            *
            * `yAxisMinorInterval` determines how often to show a minor gridline along the y-axis.  Set this property to a number less than the y-axis interval.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisMinorInterval="2"
            *     yAxisMinorStroke="green"
            *     yAxisMinorStrokeThickness="1">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.uf;
            },
            set: function (v) {
                this.i.uf = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "xAxisActualMinimum", {
            /**
             * Gets the current minimum value for the X-axis.
            */
            get: function () {
                return this.i.t5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "xAxisActualMaximum", {
            /**
             * Gets the current maximum value for the X-axis.
            */
            get: function () {
                return this.i.t4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisActualMinimum", {
            /**
             * Gets the current minimum value for the Y-axis.
            */
            get: function () {
                return this.i.ub;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisActualMaximum", {
            /**
             * Gets the current maximum value for the Y-axis.
            */
            get: function () {
                return this.i.ua;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "negativeBrushes", {
            /**
             * Gets or sets the palette used for coloring negative items of Waterfall chart type.
            *
            * `negativeBrushes` controls the brushes used by the chart for negative data, when the `chartType` is one that supports negative brushes.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     chartType="waterfall"
            *     negativeBrushes="#ff0000, #cc0000, #aa0000">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.sx);
            },
            set: function (v) {
                this.i.sx = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "negativeOutlines", {
            /**
             * Brushes to use for drawing negative elements, when using a chart type with contextual coloring, such as Waterfall.
            *
            * `negativeOutlines` controls the outlines used by the chart for negative data, when the `chartType` is one that supports negative brushes.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     chartType="waterfall"
            *     negativeOutlines="#0000ff, #0000cc, #0000aa">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.sy);
            },
            set: function (v) {
                this.i.sy = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "yAxisAbbreviateLargeNumbers", {
            /**
             * Gets or sets whether the large numbers on the Y-axis labels are abbreviated.
            *
            * To abbreviate on the y-axis using formats like "1K" or "1M," set `yAxisAbbreviateLargeNumbers` to true.
            *
            * ```html
            * <igx-category-chart
            *     [dataSource]="data"
            *     yAxisAbbreviateLargeNumbers="true">
            * </igx-category-chart>
            * ```
            */
            get: function () {
                return this.i.tp;
            },
            set: function (v) {
                this.i.tp = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "isCategoryHighlightingEnabled", {
            /**
             * Gets or sets whether the category should be highlighted when hovered
            */
            get: function () {
                return this.i.tm;
            },
            set: function (v) {
                this.i.tm = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryChartComponent.prototype, "isItemHighlightingEnabled", {
            /**
             * Gets or sets whether the item should be highlighted when hovered
            */
            get: function () {
                return this.i.tn;
            },
            set: function (v) {
                this.i.tn = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        /**
     * Export serialized visual data.

    */
        IgxCategoryChartComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.ul();
            return (iv);
        };
        IgxCategoryChartComponent.prototype.getCurrentXAxisActualMinimum = function () {
            var iv = this.i.t1();
            return (iv);
        };
        IgxCategoryChartComponent.prototype.getCurrentYAxisActualMinimum = function () {
            var iv = this.i.t3();
            return (iv);
        };
        IgxCategoryChartComponent.prototype.getCurrentXAxisActualMaximum = function () {
            var iv = this.i.t0();
            return (iv);
        };
        IgxCategoryChartComponent.prototype.getCurrentYAxisActualMaximum = function () {
            var iv = this.i.t2();
            return (iv);
        };
        IgxCategoryChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryChartComponent, selector: "igx-category-chart", inputs: { height: "height", width: "width", dataSource: "dataSource", transitionInDuration: "transitionInDuration", transitionInEasingFunction: "transitionInEasingFunction", chartType: "chartType", markerCollisionAvoidance: "markerCollisionAvoidance", isTransitionInEnabled: "isTransitionInEnabled", transitionInMode: "transitionInMode", transitionInSpeedType: "transitionInSpeedType", xAxisInterval: "xAxisInterval", xAxisMinorInterval: "xAxisMinorInterval", xAxisGap: "xAxisGap", xAxisOverlap: "xAxisOverlap", yAxisInterval: "yAxisInterval", yAxisIsLogarithmic: "yAxisIsLogarithmic", yAxisLogarithmBase: "yAxisLogarithmBase", yAxisMinimumValue: "yAxisMinimumValue", yAxisMaximumValue: "yAxisMaximumValue", yAxisMinorInterval: "yAxisMinorInterval", negativeBrushes: "negativeBrushes", negativeOutlines: "negativeOutlines", yAxisAbbreviateLargeNumbers: "yAxisAbbreviateLargeNumbers", isCategoryHighlightingEnabled: "isCategoryHighlightingEnabled", isItemHighlightingEnabled: "isItemHighlightingEnabled" }, host: { classAttribute: "ig-category-chart igx-category-chart" }, providers: [], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], usesInheritance: true, ngImport: i0, template: "<ng-container #dynamicContent></ng-container>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryChartComponent;
    }(IgxXYChartComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-chart',
                        template: "<ng-container #dynamicContent></ng-container>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-category-chart igx-category-chart' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], transitionInDuration: [{
                    type: i0.Input
                }], transitionInEasingFunction: [{
                    type: i0.Input
                }], chartType: [{
                    type: i0.Input
                }], markerCollisionAvoidance: [{
                    type: i0.Input
                }], isTransitionInEnabled: [{
                    type: i0.Input
                }], transitionInMode: [{
                    type: i0.Input
                }], transitionInSpeedType: [{
                    type: i0.Input
                }], xAxisInterval: [{
                    type: i0.Input
                }], xAxisMinorInterval: [{
                    type: i0.Input
                }], xAxisGap: [{
                    type: i0.Input
                }], xAxisOverlap: [{
                    type: i0.Input
                }], yAxisInterval: [{
                    type: i0.Input
                }], yAxisIsLogarithmic: [{
                    type: i0.Input
                }], yAxisLogarithmBase: [{
                    type: i0.Input
                }], yAxisMinimumValue: [{
                    type: i0.Input
                }], yAxisMaximumValue: [{
                    type: i0.Input
                }], yAxisMinorInterval: [{
                    type: i0.Input
                }], negativeBrushes: [{
                    type: i0.Input
                }], negativeOutlines: [{
                    type: i0.Input
                }], yAxisAbbreviateLargeNumbers: [{
                    type: i0.Input
                }], isCategoryHighlightingEnabled: [{
                    type: i0.Input
                }], isItemHighlightingEnabled: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryXAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryXAxisModule() {
        }
        IgxCategoryXAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryXAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisModule, declarations: [IgxCategoryXAxisComponent], imports: [i1.CommonModule], exports: [IgxCategoryXAxisComponent] });
        IgxCategoryXAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisModule, imports: [[i1.CommonModule]] });
        return IgxCategoryXAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryXAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCategoryXAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryXAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryXAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryXAxisComponent", IgxCategoryXAxisComponent);
            i2.TypeRegistrar.register("CategoryXAxis", CategoryXAxis.$type);
        }
        IgxCategoryXAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryXAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisDynamicModule, imports: [i1.CommonModule, IgxCategoryXAxisModule], exports: [IgxCategoryXAxisModule] });
        IgxCategoryXAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisDynamicModule, imports: [[i1.CommonModule, IgxCategoryXAxisModule], IgxCategoryXAxisModule] });
        return IgxCategoryXAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryXAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryXAxisModule],
                        exports: [IgxCategoryXAxisModule],
                        entryComponents: [IgxCategoryXAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericYAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericYAxisModule() {
        }
        IgxNumericYAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericYAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisModule, declarations: [IgxNumericYAxisComponent], imports: [i1.CommonModule], exports: [IgxNumericYAxisComponent] });
        IgxNumericYAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisModule, imports: [[i1.CommonModule]] });
        return IgxNumericYAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxNumericYAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxNumericYAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericYAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericYAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxNumericYAxisComponent", IgxNumericYAxisComponent);
            i2.TypeRegistrar.register("NumericYAxis", NumericYAxis.$type);
        }
        IgxNumericYAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericYAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisDynamicModule, imports: [i1.CommonModule, IgxNumericYAxisModule], exports: [IgxNumericYAxisModule] });
        IgxNumericYAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisDynamicModule, imports: [[i1.CommonModule, IgxNumericYAxisModule], IgxNumericYAxisModule] });
        return IgxNumericYAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericYAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxNumericYAxisModule],
                        exports: [IgxNumericYAxisModule],
                        entryComponents: [IgxNumericYAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryChartCoreModule() {
        }
        IgxCategoryChartCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryChartCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreModule, declarations: [IgxCategoryChartComponent], imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule], exports: [IgxCategoryChartComponent,
                IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule] });
        IgxCategoryChartCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreModule, imports: [[i1.CommonModule, IgxCategoryXAxisDynamicModule,
                    IgxNumericYAxisDynamicModule
                ], IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule] });
        return IgxCategoryChartCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryChartComponent],
                        exports: [IgxCategoryChartComponent,
                            IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryChartCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryChartCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxCategoryChartComponent', IgxCategoryChartComponent);
        }
        IgxCategoryChartCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryChartCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreDynamicModule, imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxCategoryChartCoreModule], exports: [IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxCategoryChartCoreModule] });
        IgxCategoryChartCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreDynamicModule, imports: [[i1.CommonModule, IgxCategoryXAxisDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxCategoryChartCoreModule
                ], IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxCategoryChartCoreModule] });
        return IgxCategoryChartCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxCategoryChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxCategoryChartCoreModule
                        ],
                        entryComponents: [IgxCategoryChartComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var INumberAbbreviator_$type = new i2.Type(null, 'INumberAbbreviator');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumberAbbreviator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumberAbbreviator, _super);
        function NumberAbbreviator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NumberAbbreviator.prototype.abbreviate = function (a) {
            var b = Math.abs(a);
            var c = ['Q', 'T', 'B', 'M', 'K'];
            var d = [1E+15, 1000000000000, 1000000000, 1000000, 1000];
            for (var e = 0; e < c.length; e++) {
                if (b >= d[e]) {
                    return i2.round10N(a / d[e], 1).toString() + c[e];
                }
            }
            return i2.MathUtil.n(a);
        };
        NumberAbbreviator.$t = i2.markType(NumberAbbreviator, 'NumberAbbreviator', i2.Base.$, [INumberAbbreviator_$type]);
        return NumberAbbreviator;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumberAbbreviatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumberAbbreviatorModule() {
            i2.TypeRegistrar.register('NumberAbbreviator', NumberAbbreviator.$type);
        }
        IgxNumberAbbreviatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumberAbbreviatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorModule, imports: [i1.CommonModule] });
        IgxNumberAbbreviatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorModule, imports: [[i1.CommonModule,
                ]] });
        return IgxNumberAbbreviatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumberAbbreviatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumberAbbreviatorDynamicModule() {
            i2.TypeRegistrar.registerCons('NumberAbbreviator', NumberAbbreviator);
            i2.TypeRegistrar.register('NumberAbbreviator', NumberAbbreviator.$type);
        }
        IgxNumberAbbreviatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumberAbbreviatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorDynamicModule, imports: [i1.CommonModule, IgxNumberAbbreviatorModule], exports: [IgxNumberAbbreviatorModule] });
        IgxNumberAbbreviatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorDynamicModule, imports: [[i1.CommonModule, IgxNumberAbbreviatorModule
                ], IgxNumberAbbreviatorModule] });
        return IgxNumberAbbreviatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumberAbbreviatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumberAbbreviatorModule
                        ],
                        imports: [i1.CommonModule, IgxNumberAbbreviatorModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesInteractionManager, _super);
        function SeriesInteractionManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.a$p = null;
            _this.a$c = false;
            _this.i = false;
            _this.c = false;
            _this.d = false;
            _this.e = true;
            _this.f = false;
            _this._toolTipObject = null;
            _this.p = null;
            _this.t = null;
            _this.o = null;
            _this.j = false;
            _this.k = new i2.Dictionary$2(i2.String_$type, SeriesView.$, 0);
            return _this;
        }
        SeriesInteractionManager.prototype.a$j = function (a, b, c, d, e, f, g, h) {
            if (d == null) {
                return Number.POSITIVE_INFINITY;
            }
            if (c < 0 || c > g - 1) {
                return Number.POSITIVE_INFINITY;
            }
            var i;
            var j = NaN;
            var k = NaN;
            var l = NaN;
            var m = NaN;
            if (d.ch) {
                var n = d;
                i = h(b);
                var o = i2.truncate(Math.floor(i));
                var p = i2.truncate(Math.ceil(i));
                m = i - o;
                if (o >= 0 && o < g) {
                    var q = n.i$d(n.i$b._inner[o]);
                    j = d.d8(q, e) + f;
                }
                else {
                    j = NaN;
                }
                if (p >= 0 && p < g) {
                    var r = n.i$d(n.i$b._inner[p]);
                    k = d.d8(r, e) + f;
                }
                else {
                    k = NaN;
                }
                if (i2.isNaN_(j) && !i2.isNaN_(k)) {
                    j = k;
                }
                if (i2.isNaN_(k) && !i2.isNaN_(j)) {
                    k = j;
                }
                if (c >= 0 && c < g) {
                    var s = n.i$d(n.i$b._inner[c]);
                    l = d.d8(s, e) + f;
                }
            }
            else {
                i = a.fw(b);
                var t = i2.truncate(Math.floor(i));
                var u = i2.truncate(Math.ceil(i));
                m = i - t;
                if (t >= 0 && t < g) {
                    j = d.d8(t, e) + f;
                }
                else {
                    j = NaN;
                }
                if (u >= 0 && u < g) {
                    k = d.d8(u, e) + f;
                }
                else {
                    k = NaN;
                }
                if (i2.isNaN_(j) && !i2.isNaN_(k)) {
                    j = k;
                }
                if (i2.isNaN_(k) && !i2.isNaN_(j)) {
                    k = j;
                }
                if (c >= 0 && c < g) {
                    l = d.d8(c, e) + f;
                }
            }
            var v = j + m * (k - j);
            return Math.abs(l - v);
        };
        SeriesInteractionManager.prototype.a$l = function (a, b, c, d, e, f, g, h, i) {
            var j = NaN;
            if (d >= 0 && d < c.count) {
                j = c.item(d);
            }
            var k = NaN;
            if (e >= 0 && e < c.count) {
                k = c.item(e);
            }
            if (g == 0) {
                return k;
            }
            if (f == c.count - 1) {
                return j;
            }
            if (i2.isNaN_(k) && h != 0 && b <= 0.5 && !i) {
                return j;
            }
            if (i2.isNaN_(j) && h != 0 && b >= 0.5 && !i) {
                return k;
            }
            return j * (1 - b) + k * b;
        };
        SeriesInteractionManager.prototype.a$a = function (a, b, c, d, e, f, g) {
            if (b == null) {
                return null;
            }
            var h = -1;
            var i = -1;
            if (b.ch) {
                var j = a.ox(f);
                var k = -1;
                var l = b.cc;
                var m = a.bx.bu.right * 2;
                k = SeriesInteractionManager.n(c, j, l, m);
                if (k < 0) {
                    k = ~k;
                    k--;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > c.count - 1) {
                    k = c.count - 1;
                }
                var n = k;
                var o = k + 1;
                if (o > c.count - 1) {
                    o = c.count - 1;
                }
                h = n;
                i = o;
            }
            else {
                var p = a.g6(f, g);
                var q = a.g4(f, g);
                var r = i2.truncate(Math.floor(p / d));
                var s = i2.truncate(Math.floor(q / d));
                h = r - e;
                i = s - e;
                if (i == h) {
                    i++;
                }
            }
            if (h < 0) {
                h = 0;
            }
            if (h > c.count - 1) {
                h = c.count - 1;
            }
            if (i < 0) {
                i = 0;
            }
            if (i > c.count - 1) {
                i = c.count - 1;
            }
            if (h < 0 || i < 0) {
                return null;
            }
            var t = c._inner[h];
            var u = c._inner[i];
            var v = new Array(2);
            v[0] = t;
            v[1] = u;
            return v;
        };
        SeriesInteractionManager.n = function (a, b, c, d) {
            var e = 0;
            var f = a.count - 1;
            while (e <= f) {
                var g = (e + ((f - e) >> 1));
                var h = void 0;
                var i = a.item(g);
                if (c) {
                    h = (d - b.x) < (d - i[0]) ? -1 : ((d - b.x) > (d - i[0]) ? 1 : 0);
                }
                else {
                    h = b.x < i[0] ? -1 : (b.x > i[0] ? 1 : 0);
                }
                if (h < 0) {
                    f = g - 1;
                }
                else if (h > 0) {
                    e = g + 1;
                }
                else {
                    return g;
                }
            }
            return ~e;
        };
        SeriesInteractionManager.prototype.a$o = function (a, b, c, d, e, f) {
            if (d == null) {
                return -1;
            }
            var g = d.ch;
            var h = a.e2;
            var i = null;
            if (g) {
                i = d;
            }
            var j = -1;
            var k = -1;
            var l = -1;
            if (g) {
                j = e(b);
                if (i2.isNaN_(j)) {
                    return -1;
                }
                k = i2.truncate(Math.floor(j));
                l = i2.truncate(Math.ceil(j));
            }
            else {
                j = a.fw(b);
                if (i2.isNaN_(j)) {
                    return -1;
                }
                k = i2.truncate(Math.floor(j));
                l = i2.truncate(Math.ceil(j));
            }
            if (f == null) {
                return -1;
            }
            if (k < 0 || k > f.count - 1) {
                return -1;
            }
            if (!c) {
                return k;
            }
            var m = NaN;
            if (g && !h) {
                if (k < i.i$b.count && i.i$b._inner[k] < f.count) {
                    m = f.item(i.i$b._inner[k]);
                }
            }
            else {
                m = f.item(k);
            }
            while (i2.isNaN_(m)) {
                k--;
                if (k < 0 || k > f.count - 1) {
                    return -1;
                }
                if (g && !h) {
                    m = f.item(i.i$b._inner[k]);
                }
                else {
                    m = f.item(k);
                }
            }
            return k;
        };
        SeriesInteractionManager.prototype.a$m = function (a, b, c, d, e, f, g, h, i) {
            if (b == null) {
                return NaN;
            }
            var j = a.e2;
            var k = a.g7(c, i, d, g, b);
            var l = a.g5(c, i, d, g, b);
            var m = a.fu(c, k, d, e, f);
            var n = a.fu(c, l, d, e, f);
            var o = k;
            var p = l;
            var q = d.ch;
            if (q && !j) {
                var r = d;
                if (k >= 0 && k < r.i$b.count) {
                    k = r.i$b._inner[k];
                }
                if (l >= 0 && k < r.i$b.count) {
                    l = r.i$b._inner[l];
                }
            }
            var s = m / (n + m);
            if (m == 0) {
                s = 0;
            }
            if (n == 0) {
                s = 1;
            }
            if (!h) {
                if (n <= m) {
                    if (l >= 0 && l < b.count) {
                        return b.item(l);
                    }
                }
                else {
                    if (k >= 0 && k < b.count) {
                        return b.item(k);
                    }
                }
                return NaN;
            }
            return a.f0(s, b, k, l, o, p, f, q);
        };
        SeriesInteractionManager.prototype.a$d = function (a, b, c) {
            var d = a.ai(b);
            var e = a.ah(b);
            if (d == null) {
                return false;
            }
            for (var f = 0; f < d.length; f++) {
                var g = d[f];
                if (g == null || g.length != 2) {
                    continue;
                }
                if (i2.GeometryUtil.a(b, g[0], g[1], a.fl / 2 + a.fz(c))) {
                    return true;
                }
                if (e != null && f < e.length) {
                    var h = e[f];
                    if (h == null || h.length != 2) {
                        continue;
                    }
                    if (i2.GeometryUtil.a(b, h[0], h[1], a.fl / 2 + a.fz(c))) {
                        return true;
                    }
                    if (i2.GeometryUtil.a(b, g[0], h[0], a.fl / 2 + a.fz(c))) {
                        return true;
                    }
                    if (i2.GeometryUtil.a(b, g[1], h[1], a.fl / 2 + a.fz(c))) {
                        return true;
                    }
                    var i = new Array(5);
                    i[0] = h[0];
                    i[1] = h[1];
                    i[2] = g[1];
                    i[3] = g[0];
                    i[4] = h[0];
                    if (i2.PolygonUtil.a(i2.boxArray$1(i), b)) {
                        return true;
                    }
                }
            }
            return false;
        };
        SeriesInteractionManager.prototype.a$e = function (a, b, c, d) {
            if (d == null) {
                return false;
            }
            for (var e = 0; e < d.c.count; e++) {
                var f = d.c._inner[e];
                for (var g = 0; g < f._segments.count; g++) {
                    var h = f._segments._inner[g];
                    if (i2.GeometryUtil.b(b, f._startPoint, h._points, a.fz(c))) {
                        return true;
                    }
                }
            }
            return false;
        };
        SeriesInteractionManager.prototype.a$f = function (a, b, c) {
            if (c == null) {
                return false;
            }
            if (c.c.count > 0) {
                var d = c.c._inner[0];
                if (d._segments.count > 0) {
                    var e = d._segments._inner[0];
                    if (i2.PolygonUtil.a(e._points, b)) {
                        return true;
                    }
                }
            }
            return false;
        };
        SeriesInteractionManager.prototype.a$n = function (a, b, c, d, e, f) {
            var g = a.e2;
            var h = d.ch;
            var i = null;
            if (h) {
                i = d;
            }
            var j = -1;
            var k = -1;
            var l = -1;
            if (h) {
                j = e(b);
                if (i2.isNaN_(j)) {
                    return -1;
                }
                k = i2.truncate(Math.floor(j));
                l = i2.truncate(Math.ceil(j));
            }
            else {
                j = a.fw(b);
                if (i2.isNaN_(j)) {
                    return -1;
                }
                k = i2.truncate(Math.floor(j));
                l = i2.truncate(Math.ceil(j));
            }
            if (f == null) {
                return -1;
            }
            if (l < 0 || l > f.count - 1) {
                return -1;
            }
            if (!c) {
                return l;
            }
            var m = NaN;
            if (h && !g) {
                if (l < i.i$b.count && i.i$b._inner[l] < f.count) {
                    m = f.item(i.i$b._inner[l]);
                }
            }
            else {
                m = f.item(l);
            }
            while (i2.isNaN_(m)) {
                l++;
                if (l < 0 || l > f.count - 1) {
                    return -1;
                }
                if (h && !g) {
                    m = f.item(i.i$b._inner[l]);
                }
                else {
                    m = f.item(l);
                }
            }
            return l;
        };
        SeriesInteractionManager.prototype.a$k = function (a, b, c) {
            var d = a.bx.bv;
            var e = a.bx.bu;
            if (d.isEmpty || e.isEmpty || c == null) {
                return -1;
            }
            var f = a.getEffectiveViewport1(a.bx);
            var g = null;
            if (c.ch) {
                g = c;
            }
            var h = new ScalerParams(0, d, e, c.cc, f);
            if (a.ca == null) {
                return -1;
            }
            h.c = a.getEffectiveViewport1(a.bx);
            var i = a.o7(a.bx);
            var j = 0;
            if (c.cj) {
                var k = c.eb(i.top, h);
                var l = c.eb(i.bottom, h);
                var m = (b.y - d.top) / d.height;
                j = k + ((l - k) * m);
            }
            else {
                if (c.b7) {
                    var n = c.eb(i.left, h);
                    var o = c.eb(i.right, h);
                    var p = (b.x - d.left) / d.width;
                    j = n + ((o - n) * p);
                }
                else {
                    var q = a.ox(b);
                    j = c.eb(q.x, h);
                }
            }
            if (c.b9) {
            }
            var r = g.i$c(j);
            return r;
        };
        SeriesInteractionManager.prototype.a$g = function (a, b, c) {
            var d = a.pc(b);
            if (d.isEmpty) {
                return false;
            }
            var e = i2.RectUtil.r(d, a.fz(c));
            return e.containsPoint(b);
        };
        SeriesInteractionManager.prototype.a$al = function (a, b, c, d, e, f, g, h, i, j) {
            if (f == null || g == null || a.bx == null || a.bx.bv.isEmpty || a.bx.bu.isEmpty) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            var k = a.getEffectiveViewport1(a.bx);
            var l = new ScalerParams(0, a.bx.bv, a.bx.bu, f.cc, k);
            if (f.cj) {
                l.b = a.f2();
            }
            l.c = a.getEffectiveViewport1(a.bx);
            var m = a.bx;
            var n = a.o7(m);
            var o;
            if (g.cj) {
                o = b.y;
                o = n.top + n.height * (o - m.bv.top) / m.bv.height;
            }
            else {
                o = b.x;
                o = n.left + n.width * (o - m.bv.left) / m.bv.width;
            }
            if (!c && g != null) {
                var p = void 0;
                var q = void 0;
                if (i != null) {
                    p = i(b, d);
                }
                else {
                    p = a.g6(b, d);
                }
                if (j != null) {
                    q = j(b, d);
                }
                else {
                    q = a.g4(b, d);
                }
                if (p == -1 && q == -1) {
                    return { $type: i2.Point_$type, x: NaN, y: NaN };
                }
                var r = new ScalerParams(0, m.bv, m.bu, g.cc, k);
                r.c = a.ca.pk;
                var s = a.fu(b, p, g, r, e);
                var t = a.fu(b, q, g, r, e);
                var u = q;
                var v = p;
                if (g.ch) {
                    var w = g;
                    if (u >= 0 && u < w.i$b.count) {
                        u = w.i$d(w.i$b._inner[i2.truncate(u)]);
                    }
                    if (v >= 0 && v < w.i$b.count) {
                        v = w.i$d(w.i$b._inner[i2.truncate(v)]);
                    }
                }
                if ((t + s) != 0) {
                    var x = t / (s + t);
                    if (Math.abs(x - 0.5) < 1E-07) {
                        t = s;
                    }
                }
                if (t <= s) {
                    o = g.d8(u, r) + e;
                }
                else {
                    o = g.d8(v, r) + e;
                }
            }
            else {
                if (g.b6 && !g.b9 && g.categoryMode != 0) {
                    var y = 0.5 * g.getCategorySize(m.bv, m.bu, a.getEffectiveViewport1(m));
                    if (a.isVertical) {
                        y = y * -1;
                    }
                    if (g.cc) {
                        y = y * -1;
                    }
                    o -= y;
                    o += e;
                }
            }
            var z;
            if (h != null) {
                z = h(b, c, d);
            }
            else {
                z = a.f8(b, c, d);
            }
            var aa = f.d8(z, l);
            if (g.cj) {
                return { $type: i2.Point_$type, x: aa, y: o };
            }
            else {
                return { $type: i2.Point_$type, x: o, y: aa };
            }
        };
        SeriesInteractionManager.prototype.a$s = function () {
            this.a = null;
            this.b = null;
        };
        SeriesInteractionManager.prototype.a$v = function (a, b, c, d, e, f, g, h, i) {
            if (d) {
                return;
            }
            if (a.ca.d6() && !f) {
                return;
            }
            if (a.bj == 1) {
                return;
            }
            if (a.ca == null) {
                return;
            }
            var j = a.ca.bn;
            var k = j == 2 || j == 3 || j == 4;
            var l = j == 2 || j == 4;
            if (!g) {
                if (k) {
                    e = false;
                }
            }
            if ((a.cy && a.c1) || g) {
                l = false;
            }
            if (j == 2) {
                h = false;
            }
            if (j == 3) {
                h = true;
            }
            var m = null;
            var n = null;
            var o = a.ca.a3;
            var p = a.ca.cg;
            var q = (f && g) || (f && !k) || i || (l && !h);
            var r = !q && (g || e || (k && !l) || (k && l && h));
            var s = (f && (!k || g)) || i || (!a.c1 && k && l && !h);
            var t = !s && (e || (k && a.c1) || (!a.c1 && k && !l) || (!a.c1 && k && l && h));
            if (q && this.a != null) {
                m = this.a;
            }
            else {
                m = a.av(b, c, g);
                if (this.a != null && this.a != m) {
                    if (a.ca != null) {
                        o.endHighlight(this.a);
                    }
                }
                this.a = m;
            }
            if (a.hasMarkers) {
                if (s && this.b != null) {
                    n = this.b;
                }
                else {
                    n = a.aw(b, c, g);
                    if (this.b != null && this.b != n) {
                        o.endHighlight(this.b);
                    }
                    this.b = n;
                }
            }
            if (q) {
                o.endHighlight(m);
            }
            else {
                if (r) {
                    if (m != null && m.d) {
                        m.c = g || !k;
                    }
                    o.startHighlight(m);
                }
            }
            if (s) {
                if (n != null) {
                    o.endHighlight(n);
                }
            }
            else {
                if (t) {
                    if (n != null) {
                        o.startHighlight(n);
                    }
                }
            }
            this.q(a);
        };
        SeriesInteractionManager.prototype.q = function (a) {
            if (a.ca != null) {
                var b = a.ca.cg;
                if (!b.f() && b.r > 0) {
                    b.v();
                }
                if (b.r == 0) {
                    a.ca.mk(1);
                }
            }
        };
        SeriesInteractionManager.prototype.a$i = function (a, b, c, d, e, f, g) {
            if (a.bj == 3 || a.bj == 2) {
                return c;
            }
            else if (a.bj == 5 || a.bj == 4) {
                var h = 0;
                if (b != null) {
                    h = b.f;
                }
                if (h > 1) {
                    h = 1;
                }
                if (d > 1) {
                    d = 1;
                }
                if (e > 1) {
                    e = 1;
                }
                h = h - Math.max(d, e);
                c = f + (1 + h) * (1 - f);
                return c;
            }
            else {
                return c;
            }
        };
        SeriesInteractionManager.prototype.a$ak = function (a, b, c) {
            if (a.bj == 3 || a.bj == 2) {
                var d = 0;
                if (b != null) {
                    d = b.f;
                }
                var e = d;
                e = e * 0.5;
                return this.s(c, e);
            }
            else if (a.bj == 5 || a.bj == 4) {
                return c;
            }
            else {
                return c;
            }
        };
        SeriesInteractionManager.prototype.s = function (a, b) {
            if (a == null) {
                return a;
            }
            if (b == 0) {
                return a;
            }
            return i2.BrushUtil.l(a, b);
        };
        SeriesInteractionManager.prototype.a$y = function (a, b, c, d, e) {
            var f = a.bx;
            f.am();
            this.a$c = true;
            var g = a.hn(c, b);
            this.a$p = g;
            if (!e && a.ca != null && !a.as.c) {
                this.r(a, b, g, d);
            }
            this.c = false;
            if (a.ej && g == null) {
                this.c = true;
            }
            if (a.ca != null && !this.c) {
                if (a.ej) {
                    this.d = true;
                }
                this.a$v(a, g, a.o5(b), e, true, false, false, a == a.ca.bj, false);
                a.ca.kx(a, g, d);
            }
        };
        SeriesInteractionManager.prototype.a$ai = function (a, b) {
            var c = null;
            var d = null;
            var e;
            var f = ((function () { var g = a.ca.cf.f(b, false, e, false); e = g.p2; return g.ret; })());
            if (f != a) {
                if (this.a$c) {
                    this.a$z(a, b, null, null, false);
                }
                if (a.ca != null) {
                    a.ca.mc(b);
                }
                return;
            }
            c = e;
            if (a.ca != null) {
                a.ca.mc(b);
            }
            if (!this.a$c) {
                this.a$y(a, b, c, d, false);
            }
            this.a$ab(a, b, c, d, false);
        };
        SeriesInteractionManager.prototype.a$ab = function (a, b, c, d, e) {
            this.a$c = true;
            var f = a.hn(c, b);
            if (!e) {
                this.r(a, b, f, d);
            }
            if (f != null) {
                this.a$p = f;
            }
            if (a.ca != null && f != null && this.c) {
                this.c = false;
                this.d = true;
                this.a$v(a, f, a.o5(b), e, true, false, false, a == a.ca.bj, false);
                a.ca.kx(a, f, d);
            }
            if (a.ca != null && (!a.ej || f != null) && !this.c) {
                this.a$v(a, f, a.o5(b), e, true, false, false, a == a.ca.bj, false);
                a.ca.k1(a, f, d);
            }
            if (f == null && !this.c && a.ej) {
                this.a$v(a, f, a.o5(b), e, false, true, false, a == a.ca.bj, false);
                a.ca.ky(a, this.a$p, d);
                this.d = false;
                this.c = true;
            }
        };
        SeriesInteractionManager.prototype.a$z = function (a, b, c, d, e) {
            a.bx.an();
            this.a$c = false;
            var f = this.a$p;
            a.bx.ap();
            if (a.ca != null && (this.d || !a.ej)) {
                this.d = false;
                this.c = false;
                this.a$v(a, f, a.o5(b), e, false, true, false, a == a.ca.bj, false);
                a.ca.ky(a, f, d);
            }
        };
        SeriesInteractionManager.prototype.a$w = function (a, b, c, d) {
            this.i = true;
            if (a.ca != null) {
                a.ca.kz(a, a.hn(c, b), d);
            }
        };
        SeriesInteractionManager.prototype.a$aa = function (a, b, c, d) {
            this.i = false;
            if (a.ca != null) {
                a.ca.k0(a, a.hn(c, b), d);
            }
        };
        SeriesInteractionManager.prototype.a$x = function (a, b, c, d) {
            if (a.bx.s) {
                return;
            }
            if (this.i) {
                this.a$aa(a, b, c, d);
            }
            if (this.a$c) {
                this.a$z(a, b, c, d, false);
            }
        };
        SeriesInteractionManager.prototype.a$ac = function (a, b, c, d) {
            if (a.ca != null) {
                a.ca.k2(a, a.hn(c, b), d);
            }
        };
        SeriesInteractionManager.prototype.a$ad = function (a, b, c, d) {
            if (a.ca != null) {
                a.ca.k3(a, a.hn(c, b), d);
            }
        };
        Object.defineProperty(SeriesInteractionManager.prototype, "g", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesInteractionManager.prototype, "a$b", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesInteractionManager.prototype.r = function (a, b, c, d) {
            var e = false;
            if (a.ca != null) {
                e = a.ca.dq;
            }
            if (e) {
                return;
            }
            if (a.ca == null || a.ca.dh) {
                return;
            }
            this.j = true;
            this.t = b;
            this.o = c;
            a.bx.d.item = c;
            a.bx.d.itemLabel = a.hj(c);
            var f = a.ca.o9();
            var pos_ = { $type: i2.Point_$type, x: b.x + 15 + f.x, y: b.y + 15 + f.y };
            var context_ = a.bx.d;
            var g = false;
            if (this._toolTipObject != null) {
                g = (this._toolTipObject._inPointer);
                this._toolTipObject._inPointer = false;
            }
            if (this._toolTipObject != null) {
                if (this.f || g) {
                    this.f = false;
                    this._toolTipObject.remove();
                    this._toolTipObject.setStyleProperty("position", "absolute");
                    this._toolTipObject.addClass(a.ca.iq);
                    a.ca.i3(this._toolTipObject);
                    this._toolTipObject.hide();
                }
                if (this.e) {
                    a.ca.i3(this._toolTipObject);
                    this.e = false;
                }
                context_.hideOthers = true;
                if ((this._toolTipObject.updateToolTip && !this._toolTipObject.updateToolTip(context_))) {
                    this.a$u(a);
                }
                var h = window.pageXOffset;
                var i = window.pageYOffset;
                var j = document.documentElement.clientWidth;
                var k = document.documentElement.clientHeight;
                var l = this._toolTipObject.outerWidthWithMargin();
                var m = this._toolTipObject.outerHeightWithMargin();
                var n = pos_.x;
                var o = pos_.y;
                var p = 5;
                var q = 30;
                if (l + n - h + p > j) {
                    pos_.x -= q;
                    pos_.x -= l;
                }
                if (m + o - i + p > k) {
                    pos_.y -= q;
                    pos_.y -= m;
                }
                this._toolTipObject.setOffset(pos_.x, pos_.y);
            }
        };
        SeriesInteractionManager.prototype.a$ah = function (a, b, c) {
            this.j = true;
            var d = { $type: i2.Point_$type, x: b.x + a.bx.bu.left, y: b.y + a.bx.bu.top };
            var e = a.hn(null, d);
            if (a.bx.d != null) {
                a.bx.d.series = a;
                a.bx.d.item = e;
            }
            var tooltip_ = this._toolTipObject;
            var context_ = a.bx.d;
            var f = false;
            if (this._toolTipObject != null) {
                f = (this._toolTipObject._inPointer);
                this._toolTipObject._inPointer = false;
            }
            if (context_ != null) {
                context_.hideOthers = false;
            }
            if ((!this.f || f) && tooltip_ != null) {
                this.f = true;
                tooltip_.remove();
                tooltip_.setStyleProperty("position", "relative");
                tooltip_.setStyleProperty("top", "");
                tooltip_.setStyleProperty("left", "");
                tooltip_.removeClass(a.ca.iq);
            }
            if (this._toolTipObject != null) {
                if (tooltip_.updateToolTip) {
                    tooltip_.updateToolTip(context_);
                }
                ;
            }
            if (tooltip_ != null) {
                c(tooltip_);
            }
        };
        SeriesInteractionManager.prototype.a$q = function (a) {
            var b = "<div class='ui-chart-default-tooltip-content'><span";
            var c = this.a$r(a);
            if (!i2.stringIsNullOrEmpty(c)) {
                b += " style='color:" + c + "'";
            }
            b += ">" + a.hp + "</span></div>";
            return b;
        };
        SeriesInteractionManager.prototype.h = function (a, b) {
            var c = a != null && i2.Color.e(i2.toNullable(i2.Color.$, a.color), i2.toNullable(i2.Color.$, null));
            c = c && a.color.l > 0;
            c = c && i2.Color.d(a.color, b);
            return !c;
        };
        SeriesInteractionManager.prototype.a$r = function (a) {
            var b = new i2.Color();
            var c = a != null && a.ca != null && a.ca.cf != null && a.ca.cf.j != null ? a.ca.cf.j.ae : null;
            c.startCSSQuery();
            b.colorString = c.getCssDefaultPropertyValue("ui-chart-pointer-tooltip", "background-color");
            c.endCSSQuery();
            if (!this.h(a.oi, b)) {
                return a.oi._fill;
            }
            if (!this.h(a.of, b)) {
                return a.of._fill;
            }
            return null;
        };
        SeriesInteractionManager.prototype.a$u = function (a) {
            if (this._toolTipObject != null && this.j) {
                this.j = false;
                var context_ = a.bx.d;
                if (this._toolTipObject.hideToolTip) {
                    this._toolTipObject.hideToolTip(context_);
                }
                ;
            }
        };
        SeriesInteractionManager.prototype.a$aj = function (a, b) {
            var c = this._toolTipObject;
            this.p = null;
            this._toolTipObject = null;
            if (typeof b === 'string') {
                this.p = b;
            }
            else {
                this._toolTipObject = b;
                if (this._toolTipObject != null) {
                    this._toolTipObject.setStyleProperty("position", "absolute");
                    this._toolTipObject.setStyleProperty("top", "0px");
                    this._toolTipObject.setStyleProperty("left", "0px");
                    this._toolTipObject.setStyleProperty("z-index", "10000");
                    this._toolTipObject.setStyleProperty("pointer-events", "none");
                    var d = a.oi != null && i2.Color.e(i2.toNullable(i2.Color.$, a.oi.color), i2.toNullable(i2.Color.$, null)) && a.oi.color.l > 0;
                    if (d) {
                        this._toolTipObject.setStyleProperty("border-color", a.oi._fill);
                    }
                }
                else {
                    if (!this.e && c != null) {
                        a.ca.l3(c);
                        this.e = true;
                    }
                }
            }
        };
        SeriesInteractionManager.prototype.a$ag = function (a) {
        };
        Object.defineProperty(SeriesInteractionManager.prototype, "a$h", {
            get: function () {
                return this.k;
            },
            enumerable: false,
            configurable: true
        });
        SeriesInteractionManager.prototype.a$t = function (a, b, c, d, e) {
            var _this = this;
            var f;
            if (!((function () { var g = _this.k.tryGetValue(d, f); f = g.p1; return g.ret; })())) {
                f = a.bv();
                f.q = true;
                f.p = true;
                if (a.ca != null) {
                    f.a = a.ca.ak;
                    a.ca.ak.l(f);
                }
                f.as();
                f.ad = d;
                this.k.item(d, f);
            }
            f.v = e;
            f.bu = b;
            f.bt = c;
        };
        SeriesInteractionManager.prototype.a$af = function (a, b, c) {
            var _this = this;
            var d;
            var e = c;
            if (e == null) {
                e = a.ca;
            }
            if (((function () { var f = _this.k.tryGetValue(b, d); d = f.p1; return f.ret; })())) {
                if (e != null) {
                    d.a = null;
                    e.ak.r(d);
                }
                this.k.removeItem(b);
            }
        };
        SeriesInteractionManager.prototype.a$ae = function (a, b) {
            var e_1, _a;
            var c = new i2.List$1(i2.String_$type, 0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.k.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    c.add(d);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            for (var e = 0; e < c.count; e++) {
                this.a$af(a, c._inner[e], b);
            }
        };
        SeriesInteractionManager.$t = i2.markType(SeriesInteractionManager, 'SeriesInteractionManager', i2.Base.$, [ISeriesInteractionManager_$type]);
        return SeriesInteractionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IVerticalAnchoredCategorySeriesInteractionManager_$type = new i2.Type(null, 'IVerticalAnchoredCategorySeriesInteractionManager');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategorySeriesInteractionManager, _super);
        function CategorySeriesInteractionManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CategorySeriesInteractionManager.prototype.b$c = function (a, b) {
            var c = a.bx.bv;
            var d = a.bx.bu;
            var e = a.ar();
            var f = a.getEffectiveViewport1(a.bx);
            var g = a.o7(a.bx);
            var h = -1;
            if (e != null && !c.isEmpty && !d.isEmpty) {
                var i = new ScalerParams(0, c, d, e.cc, f);
                var j = e.eb(g.left, i);
                var k = e.eb(g.right, i);
                var l = (b.x - c.left) / c.width;
                var m = j + (l * (k - j));
                if (e.categoryMode != 0) {
                    m -= 0.5;
                }
                h = m;
            }
            return h;
        };
        CategorySeriesInteractionManager.prototype.b$f = function (a, b) {
            var c = 0;
            if (a.d3) {
                c = a.g2(b);
                if (c == -1) {
                    return null;
                }
            }
            else if (b.x == 1 && a.ch != null) {
                c = a.ch.count - 1;
            }
            else {
                c = a.g0(b);
            }
            return c >= 0 && a.ch != null && c < a.ch.count ? a.ch.item(c) : null;
        };
        CategorySeriesInteractionManager.prototype.b$d = function (a, b) {
            var c = a.bx.bv;
            var d = a.bx.bu;
            var e = a.getEffectiveViewport1(a.bx);
            if (c.isEmpty || d.isEmpty) {
                return -1;
            }
            if (i2.isNaN_(b.x)) {
                return -1;
            }
            var f = a.ar();
            if (f == null) {
                return -1;
            }
            var g = i2.typeCast(ISortingAxis_$type, f);
            var h = a.o7(a.bx);
            var i = new ScalerParams(0, c, d, f.cc, e);
            var j = 0;
            if (f.cf) {
                var k = (b.x - c.left) / c.width;
                var l = k * h.width + h.left;
                j = f.eb(l, i);
            }
            else {
                var m = f.eb(h.left, i);
                var n = f.eb(h.right, i);
                var o = (b.x - c.left) / c.width;
                j = m + ((n - m) * o);
            }
            var p = g.i$f(j);
            return p;
        };
        CategorySeriesInteractionManager.prototype.b$e = function (a, b, c) {
            var d = a.bx.bu;
            var e = a.bx.bv;
            var f = a.ar();
            var g = 0;
            if (f.cj) {
                var h = (c.y - e.top) / e.height;
                g = h * d.height + d.top;
            }
            else {
                var i = (c.x - e.left) / e.width;
                g = i * d.width + d.left;
            }
            if (f.cc) {
                var j = b.count;
                var k = 0;
                for (k = j - 1; k >= 0; k--) {
                    var l = b._inner[k];
                    var m = null;
                    if (k > 0) {
                        m = b._inner[k - 1];
                    }
                    if (l[0] <= g && m == null || m[0] >= g) {
                        if (m != null) {
                            if (Math.abs(l[0] - g) < Math.abs(m[0] - g)) {
                                return k;
                            }
                            else {
                                return k - 1;
                            }
                        }
                        else {
                            return k;
                        }
                    }
                }
                return k;
            }
            else {
                var n = b.count;
                var o = 0;
                for (o = 0; o < n; o++) {
                    var p = b._inner[o];
                    var q = null;
                    if (o < n - 1) {
                        q = b._inner[o + 1];
                    }
                    if (p[0] <= g && q == null || q[0] >= g) {
                        if (q != null) {
                            if (Math.abs(p[0] - g) < Math.abs(q[0] - g)) {
                                return o;
                            }
                            else {
                                return o + 1;
                            }
                        }
                        else {
                            return o;
                        }
                    }
                }
                return o;
            }
        };
        CategorySeriesInteractionManager.prototype.b$a = function (a, b, c, d, e, f, g, h) {
            if (a.ch == null) {
                return null;
            }
            if (e == 0) {
                return null;
            }
            var i = a.ch.count;
            var j = a.ar();
            var k = -1;
            var l = -1;
            if (j.ch) {
                var m = this.b$e(a, b, g);
                k = m;
                l = m;
            }
            else {
                var n = a.g0(g);
                k = i2.truncate(Math.floor((i2.intDivide(n, e)))) * e;
                l = k + (e - 1);
            }
            if (h != null && h.h == k && h.g == l) {
                return h;
            }
            var o = new HighlightingInfo();
            o.b = a;
            o.h = k;
            o.g = l;
            return o;
        };
        CategorySeriesInteractionManager.prototype.b$b = function (a, b, c, d, e, f, g, h) {
            if (a.ch == null) {
                return null;
            }
            if (d == 0) {
                return null;
            }
            if (e == null || e.count == 0) {
                return null;
            }
            var i = a.ch.count;
            var j = a.ar();
            var k = -1;
            var l = -1;
            var m = -1;
            if (j.ch) {
                var n = this.b$e(a, e, g);
                m = n;
                k = n;
                l = n;
            }
            else {
                var o = a.g0(g);
                m = i2.truncate(Math.floor((i2.intDivide(o, d)))) - c;
                k = m;
                l = m;
            }
            if (h != null && h.h == k && h.g == l) {
                return h;
            }
            var p = b;
            var q = p.count;
            if (p == null) {
                return null;
            }
            if (q == 0) {
                return null;
            }
            for (var r = 0; r < q; r++) {
                if (p._inner[r].al == m) {
                    var s = new HighlightingInfo();
                    s.b = a;
                    s.h = p._inner[r].al;
                    s.g = p._inner[r].al;
                    s.e = true;
                    return s;
                }
            }
            var t = a.ox(g);
            var u = p._inner[0].al;
            if (a.isVertical) {
                var v = e._inner[p._inner[0].al][0];
                var w = (t.y - v) * (t.y - v);
                var x = void 0;
                for (var y = 0; y < q; y++) {
                    v = e._inner[p._inner[y].al][0];
                    x = (t.y - v) * (t.y - v);
                    if (x <= w) {
                        w = x;
                        u = p._inner[y].al;
                    }
                }
            }
            else {
                var z = e._inner[p._inner[0].al][0];
                var aa = (t.x - z) * (t.x - z);
                var ab = void 0;
                for (var ac = 0; ac < q; ac++) {
                    z = e._inner[p._inner[ac].al][0];
                    ab = (t.x - z) * (t.x - z);
                    if (ab <= aa) {
                        aa = ab;
                        u = p._inner[ac].al;
                    }
                }
            }
            var ad = new HighlightingInfo();
            ad.b = a;
            ad.e = true;
            ad.h = u;
            ad.g = ad.h;
            if (h != null && h.h == ad.h && h.g == ad.g) {
                return h;
            }
            return ad;
        };
        CategorySeriesInteractionManager.$t = i2.markType(CategorySeriesInteractionManager, 'CategorySeriesInteractionManager', i2.Base.$, [ICategorySeriesInteractionManager_$type]);
        return CategorySeriesInteractionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnchoredCategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredCategorySeriesInteractionManager, _super);
        function AnchoredCategorySeriesInteractionManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AnchoredCategorySeriesInteractionManager.prototype.c$b = function (a, b, c, d, e, f, g, h) {
            if (!g) {
                return h(b);
            }
            if (e == null || e.ch || f == null || d == null || i2.isNaN_(b.x) || i2.isNaN_(b.y)) {
                return h(b);
            }
            if (c <= 1) {
                return h(b);
            }
            var i = i2.truncate(Math.round(a.fw(b)));
            if (i < 0 || i >= a.ch.count) {
                return h(b);
            }
            var j = i2.intDivide(i, c);
            var k = c * j;
            var l = Math.min(k + c, d.count - 1);
            var m = a.o7(a.bx);
            var n = new ScalerParams(0, a.ca.pw, a.ca.pv, f.cc, a.ca.pk);
            var o = m.top;
            var p = m.bottom;
            var q = o + (p - o) * b.y;
            var r = f.eb(q, n);
            var s = 1.7976931348623157E+308;
            var t = k;
            for (var u = k; u <= l; u++) {
                var v = Math.abs(d.item(u) - r);
                if (v < s) {
                    s = v;
                    t = u;
                }
            }
            return a.ch.item(t);
        };
        AnchoredCategorySeriesInteractionManager.prototype.c$a = function (a, b, c, d, e, f) {
            var g = a.bx.bv;
            g = g.copy();
            var h = a.bx.bu;
            var i = new i2.Rect(0, 0, 0, 1, 1);
            var j = !g.isEmpty && !h.isEmpty && a.ch != null ? a.ch.indexOf(f) : -1;
            var k = a.o9(a.bx);
            var l = new ScalerParams(0, i, i, c.cc, k);
            var m = new ScalerParams(0, i, i, d.cc, k);
            m.b = a.f2();
            var n = c != null ? c.d8(j, l) : NaN;
            n += e;
            var o = d != null && b != null && j < b.count ? d.d8(b.item(j), m) : NaN;
            if (!i2.isNaN_(n)) {
                if (n < g.left + 0.1 * g.width) {
                    n = n + 0.4 * g.width;
                    g.x = n - 0.5 * g.width;
                }
                if (n > g.right - 0.1 * g.width) {
                    n = n - 0.4 * g.width;
                    g.x = n - 0.5 * g.width;
                }
            }
            if (!i2.isNaN_(o)) {
                if (o < g.top + 0.1 * g.height) {
                    o = o + 0.4 * g.height;
                    g.y = o - 0.5 * g.height;
                }
                if (o > g.bottom - 0.1 * g.height) {
                    o = o - 0.4 * g.height;
                    g.y = o - 0.5 * g.height;
                }
            }
            if (a.b5 != null) {
                a.b5.ap(a.ca, g, true);
            }
            return j >= 0;
        };
        AnchoredCategorySeriesInteractionManager.prototype.c$c = function (a, b) {
            var c = "<div class='ui-chart-default-tooltip-content'>";
            var d = null;
            d = a.ar();
            if (d.b9) {
                var e = d;
                c += "<span>${item." + e.dateTimeMemberPath + "}</span><br/>";
            }
            else if (d != null && d.fj != null) {
                c += "<span>${item." + d.fj.toString() + "}</span><br/>";
            }
            c += "<span";
            var f = a.a4.a$r(a);
            if (!i2.stringIsNullOrEmpty(f)) {
                c += " style='color:" + f + "'";
            }
            c += ">${series.title}: </span><span class='ui-priority-primary'>" + "${item." + b + "}</span></div>";
            return c;
        };
        AnchoredCategorySeriesInteractionManager.prototype.c$d = function (a, b, c, d, e, f, g, h) {
            if (c == null || d == null) {
                return i2.Rect.empty;
            }
            var i = a.ox(b);
            var j = a.bx.bv;
            var k = a.bx.bu;
            var l = a.getEffectiveViewport1(a.bx);
            var m = new ScalerParams(0, j, k, d.cc, l);
            m.b = a.f2();
            var n = a.aj(a.ar(), e.f, f, g, b, true);
            if (n == null) {
                return i2.Rect.empty;
            }
            var o = n[0];
            var p = n[1];
            var q = Math.abs(i.x - o[0]);
            var r = Math.abs(i.x - p[0]);
            var s = d.d8(d.k5, m);
            var t = c.ki(j, k, l);
            if (q < r) {
                var u = o[0] - 0.5 * t;
                var v = h(o);
                var w = s;
                return new i2.Rect(0, u, Math.min(v, w), t, Math.max(v, w) - Math.min(v, w));
            }
            else {
                var x = p[0] - 0.5 * t;
                var y = h(p);
                var z = s;
                return new i2.Rect(0, x, Math.min(y, z), t, Math.max(y, z) - Math.min(y, z));
            }
        };
        AnchoredCategorySeriesInteractionManager.$t = i2.markType(AnchoredCategorySeriesInteractionManager, 'AnchoredCategorySeriesInteractionManager', i2.Base.$, [IAnchoredCategorySeriesInteractionManager_$type]);
        return AnchoredCategorySeriesInteractionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalAnchoredCategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAnchoredCategorySeriesInteractionManager, _super);
        function HorizontalAnchoredCategorySeriesInteractionManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$a = function (a, b, c, d, e) {
            var f = a.aj(a.ar(), b, c, d, a.o5(e), true);
            if (f == null) {
                return null;
            }
            var g = f[0];
            var h = f[1];
            var i = new Array(1);
            var j = new Array(2);
            j[0] = { $type: i2.Point_$type, x: g[0], y: g[2] };
            j[1] = { $type: i2.Point_$type, x: h[0], y: h[2] };
            i[0] = j;
            return i;
        };
        HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$b = function (a, b, c, d, e) {
            var f = a.aj(a.ar(), b, c, d, a.o5(e), true);
            if (f == null) {
                return null;
            }
            var g = f[0];
            var h = f[1];
            var i = new Array(1);
            var j = new Array(2);
            j[0] = { $type: i2.Point_$type, x: g[0], y: g[1] };
            j[1] = { $type: i2.Point_$type, x: h[0], y: h[1] };
            i[0] = j;
            return i;
        };
        HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$d = function (a, b, c, d) {
            if (b == null || b.count == 0) {
                return i2.Rect.empty;
            }
            var e = a.ox(c);
            var f = -1;
            var g = a.ar();
            var h = g.cc;
            var i = a.bx.bu.right * 2;
            if (h) {
                f = i2.ArrayExtension.binarySearch$11(i2.Point_$type, b, function (j) { return (i - e.x) < (i - j.x) ? -1 : ((i - e.x) > (i - j.x) ? 1 : 0); });
            }
            else {
                f = i2.ArrayExtension.binarySearch$11(i2.Point_$type, b, function (j) { return e.x < j.x ? -1 : (e.x > j.x ? 1 : 0); });
            }
            if (f < 0) {
                f = ~f;
            }
            if (f < 0) {
                f = 0;
            }
            if (f > b.count - 1) {
                f = b.count - 1;
            }
            var j = f;
            var k = f;
            if (j > 0) {
                j--;
            }
            if (k < b.count - 1) {
                k++;
            }
            var l = b._inner[j].x;
            var m = b._inner[f].x;
            var n = b._inner[k].x;
            var o = Math.abs(l - e.x);
            var p = Math.abs(m - e.x);
            var q = Math.abs(n - e.x);
            var r = d(j);
            var s = d(f);
            var t = d(k);
            var u = r.containsPoint(e);
            var v = s.containsPoint(e);
            var w = t.containsPoint(e);
            if (p <= o && p <= q) {
                if (!h && w) {
                    return t;
                }
                if (h && u) {
                    return r;
                }
                return s;
            }
            if (o <= p && o <= q) {
                if (!h && v) {
                    return s;
                }
                return d(j);
            }
            if (q <= p && q <= o) {
                if (h && v) {
                    return s;
                }
                return d(k);
            }
            return i2.Rect.empty;
        };
        HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$c = function (a, b, c, d, e) {
            if (i2.isNaN_(d.x) || i2.isNaN_(d.y)) {
                return false;
            }
            var f = 0;
            if (b != null) {
                f = b.en(b.k5);
            }
            if ((c.y >= f && c.y <= d.y) || (c.y <= f && c.y >= d.y)) {
                return true;
            }
            return false;
        };
        HorizontalAnchoredCategorySeriesInteractionManager.$t = i2.markType(HorizontalAnchoredCategorySeriesInteractionManager, 'HorizontalAnchoredCategorySeriesInteractionManager', i2.Base.$, [IHorizontalAnchoredCategorySeriesInteractionManager_$type]);
        return HorizontalAnchoredCategorySeriesInteractionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VerticalAnchoredCategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalAnchoredCategorySeriesInteractionManager, _super);
        function VerticalAnchoredCategorySeriesInteractionManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VerticalAnchoredCategorySeriesInteractionManager.prototype.e$a = function (a, b) {
            var c = a.ca != null ? a.ca.pg : i2.Rect.empty;
            var d = a.bx.bu;
            var e = a.o7(a.bx);
            var f = a.getEffectiveViewport1(a.bx);
            var g = a.ar();
            var h = -1;
            if (g != null && !c.isEmpty && !d.isEmpty) {
                var i = new ScalerParams(0, c, d, g.cc, f);
                var j = g.eb(e.top, i);
                var k = g.eb(e.bottom, i);
                var l = (b.y - c.top) / c.height;
                var m = j + (l * (k - j));
                if (g.categoryMode != 0) {
                    m -= 0.5;
                }
                h = m;
            }
            return h;
        };
        VerticalAnchoredCategorySeriesInteractionManager.prototype.e$b = function (a, b, c, d) {
            if (b == null || b.count == 0) {
                return i2.Rect.empty;
            }
            var e = a.ox(c);
            var f = -1;
            var g = a.ar().cc;
            var h = a.bx.bu.bottom * 2;
            if (g) {
                f = i2.ArrayExtension.binarySearch$11(i2.Point_$type, b, function (i) { return (h - e.y) < (h - i.y) ? -1 : ((h - e.y) > (h - i.y) ? 1 : 0); });
            }
            else {
                f = i2.ArrayExtension.binarySearch$11(i2.Point_$type, b, function (i) { return e.y < i.y ? -1 : (e.y > i.y ? 1 : 0); });
            }
            if (f < 0) {
                f = ~f;
            }
            if (f < 0) {
                f = 0;
            }
            if (f > b.count - 1) {
                f = b.count - 1;
            }
            var i = f;
            var j = f;
            if (i > 0) {
                i--;
            }
            if (j < b.count - 1) {
                j++;
            }
            var k = b._inner[i].y;
            var l = b._inner[f].y;
            var m = b._inner[j].y;
            var n = Math.abs(k - e.y);
            var o = Math.abs(l - e.y);
            var p = Math.abs(m - e.y);
            var q = d(i);
            var r = d(f);
            var s = d(j);
            var t = q.containsPoint(e);
            var u = r.containsPoint(e);
            var v = s.containsPoint(e);
            if (o <= n && o <= p) {
                if (!g && v) {
                    return s;
                }
                if (g && t) {
                    return q;
                }
                return r;
            }
            if (n <= o && n <= p) {
                if (!g && u) {
                    return r;
                }
                return d(i);
            }
            if (p <= o && p <= n) {
                if (g && u) {
                    return r;
                }
                return d(j);
            }
            return i2.Rect.empty;
        };
        VerticalAnchoredCategorySeriesInteractionManager.$t = i2.markType(VerticalAnchoredCategorySeriesInteractionManager, 'VerticalAnchoredCategorySeriesInteractionManager', i2.Base.$, [IVerticalAnchoredCategorySeriesInteractionManager_$type]);
        return VerticalAnchoredCategorySeriesInteractionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HighlightingInfoComparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighlightingInfoComparer, _super);
        function HighlightingInfoComparer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HighlightingInfoComparer.prototype.equalsC = function (a, b) {
            if (a == null && b != null) {
                return false;
            }
            if (a != null && b == null) {
                return false;
            }
            return a.e == b.e && a.h == b.h && a.g == b.g && a.b == b.b;
        };
        HighlightingInfoComparer.prototype.getHashCodeC = function (a) {
            var b = 23;
            b = b * 31 + (a.e ? 1 : 0);
            b = b * 31 + a.h;
            b = b * 31 + a.g;
            b = b * 31 + (a.b != null ? i2.Base.getHashCodeStatic(a.b) : 0);
            return b;
        };
        HighlightingInfoComparer.$t = i2.markType(HighlightingInfoComparer, 'HighlightingInfoComparer', i2.Base.$, [i2.IEqualityComparer$1_$type.specialize(HighlightingInfo.$)]);
        return HighlightingInfoComparer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HighlightingData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighlightingData, _super);
        function HighlightingData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.c = 0;
            _this.e = 0;
            _this.d = 0;
            _this.b = 0;
            return _this;
        }
        HighlightingData.$t = i2.markType(HighlightingData, 'HighlightingData');
        return HighlightingData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HighlightingManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighlightingManager, _super);
        function HighlightingManager() {
            var _this = _super.call(this) || this;
            _this._highlightingBehavior = 0;
            _this._executionContext = null;
            _this._ensureAnimator = null;
            _this.e = new i2.Dictionary$2(HighlightingInfo.$, HighlightingInfo.$, 2, new HighlightingInfoComparer());
            _this.i = new i2.List$1(HighlightingInfo.$, 0);
            _this.h = new i2.Dictionary$2(HighlightingInfo.$, HighlightingInfo.$, 2, new HighlightingInfoComparer());
            _this.j = new i2.List$1(HighlightingInfo.$, 0);
            _this.b = false;
            _this.c = false;
            _this.o = 0;
            _this.n = 0;
            _this.l = new i2.List$1(HighlightingInfo.$, 0);
            _this.m = 0;
            _this._dirtySeries = null;
            _this._allDirty = false;
            _this.f = new i2.Dictionary$2(Series.$, i2.Boolean_$type, 0);
            _this.g = new i2.Dictionary$2(Series.$, HighlightingData.$, 0);
            _this.k = new i2.List$1(Series.$, 0);
            _this._inProgress = false;
            _this._maxHighlightingProgress = 0;
            _this._sumHighlightingProgress = 0;
            _this._maxMarkerHighlightingProgress = 0;
            _this._sumMarkerHighlightingProgress = 0;
            _this._totalHighlightingProgress = 0;
            _this.highlightingBehavior = 1;
            _this.dirtySeries = new i2.List$1(Series.$, 0);
            _this.n = 200;
            return _this;
        }
        Object.defineProperty(HighlightingManager.prototype, "highlightingBehavior", {
            get: function () {
                return this._highlightingBehavior;
            },
            set: function (a) {
                this._highlightingBehavior = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "d", {
            get: function () {
                return this.highlightingBehavior == 1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "executionContext", {
            get: function () {
                return this._executionContext;
            },
            set: function (a) {
                this._executionContext = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "ensureAnimator", {
            get: function () {
                return this._ensureAnimator;
            },
            set: function (a) {
                this._ensureAnimator = a;
            },
            enumerable: false,
            configurable: true
        });
        HighlightingManager.prototype.startHighlight = function (a) {
            if (a == null) {
                return;
            }
            this.a(a);
            this.inProgress = true;
            if (!this.e.containsKey(a)) {
                a.a = HighlightingState.inward;
                this.e.item(a, a);
                this.i.add(a);
            }
            else {
                a = this.e.item(a);
            }
            if (a.a == HighlightingState.outward) {
                a.a = HighlightingState.inward;
            }
        };
        HighlightingManager.prototype.a = function (a) {
            var b = null;
            if (this.h.containsKey(a)) {
                a = this.h.item(a);
                this.h.removeItem(a);
                this.j.remove(a);
                b = a;
            }
            var c = this.l;
            for (var d = 0; d < this.j.count; d++) {
                var e = this.j._inner[d];
                if (e.d && a.d && a.b == e.b) {
                    if (b == null) {
                        this.h.removeItem(e);
                        this.j.remove(e);
                        var f = this.e.item(e);
                        this.e.removeItem(f);
                        this.i.remove(f);
                        f.h = a.h;
                        f.g = a.g;
                        f.c = a.c;
                        this.e.item(f, f);
                        this.i.add(f);
                        b = f;
                    }
                    else {
                        c.add(e);
                    }
                }
                if (this.d && e.b != a.b) {
                    c.add(e);
                }
                if (e.b == a.b && e.e == a.e && !e.d && (e.h != a.h || e.g != a.g)) {
                    c.add(e);
                }
            }
            for (var g = 0; g < c.count; g++) {
                this.j.remove(c._inner[g]);
                this.h.removeItem(c._inner[g]);
                this.q(c._inner[g]);
            }
            c.clear();
            if (b != null) {
                return b;
            }
            return a;
        };
        HighlightingManager.prototype.endHighlight = function (a) {
            if (a == null) {
                return;
            }
            if (!this.e.containsKey(a)) {
                return;
            }
            else {
                a = this.e.item(a);
            }
            this.r(a);
        };
        HighlightingManager.prototype.r = function (a) {
            if (this.h.containsKey(a)) {
                var b = this.h.item(a);
            }
            else {
                this.h.addItem(a, a);
                this.j.add(a);
                a.i = this.executionContext.getCurrentRelativeTime();
            }
            this.b = true;
            if (!this.c) {
                this.c = true;
                this.executionContext.executeDelayed(i2.runOn(this, this.p), this.n);
            }
        };
        HighlightingManager.prototype.p = function () {
            this.c = false;
            if (!this.b) {
                return;
            }
            var a = this.l;
            var b = 0;
            var c = this.executionContext.getCurrentRelativeTime();
            for (var d = 0; d < this.j.count; d++) {
                var e = this.j._inner[d];
                if (c - e.i >= this.n) {
                    a.add(e);
                }
                else {
                    b = Math.max(b, this.n - (c - e.i));
                }
            }
            for (var f = 0; f < a.count; f++) {
                this.j.remove(a._inner[f]);
                this.h.removeItem(a._inner[f]);
                this.q(a._inner[f]);
            }
            if (a.count > 0) {
                if (this.ensureAnimator != null) {
                    this.ensureAnimator();
                }
            }
            a.clear();
            if (b > 0) {
                this.b = true;
                this.c = true;
                this.executionContext.executeDelayed(i2.runOn(this, this.p), b);
            }
        };
        HighlightingManager.prototype.q = function (a) {
            if (a.a == HighlightingState.inward) {
                a.a = HighlightingState.outward;
            }
            if (a.a == 2) {
                a.a = HighlightingState.outward;
                a.f = 1;
            }
        };
        HighlightingManager.prototype.clear = function () {
            this.j.clear();
            this.h.clear();
            this.b = false;
            this.i.clear();
            this.e.clear();
            this.maxHighlightingProgress = 0;
            this.sumHighlightingProgress = 0;
            this.maxMarkerHighlightingProgress = 0;
            this.sumMarkerHighlightingProgress = 0;
            this.totalHighlightingProgress = 0;
        };
        HighlightingManager.prototype.getHighlightingInfo = function (a, b, c, d, e) {
            for (var f = 0; f < this.i.count; f++) {
                var g = this.i._inner[f];
                var h = g.h;
                var i = g.g;
                if (((c >= h && d <= i) || g.d) && g.e == e && a == g.b && (g.a == HighlightingState.inward || g.a == 2)) {
                    return g;
                }
            }
            for (var j = 0; j < this.i.count; j++) {
                var k = this.i._inner[j];
                var l = k.h;
                var m = k.g;
                if (((c >= l && d <= m) || k.d) && k.e == e && a == k.b && (k.a == HighlightingState.outward)) {
                    return k;
                }
            }
            return null;
        };
        Object.defineProperty(HighlightingManager.prototype, "dirtySeries", {
            get: function () {
                return this._dirtySeries;
            },
            set: function (a) {
                this._dirtySeries = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "allDirty", {
            get: function () {
                return this._allDirty;
            },
            set: function (a) {
                this._allDirty = a;
            },
            enumerable: false,
            configurable: true
        });
        HighlightingManager.prototype.tick = function (a) {
            var e_1, _a;
            this.f.clear();
            this.dirtySeries.clear();
            this.g.clear();
            this.allDirty = false;
            var b = 0;
            if (this.m > a) {
                b = (1 - this.m) + a;
            }
            else {
                b = a - this.m;
            }
            this.m = a;
            var c = false;
            var d = new i2.List$1(HighlightingInfo.$, 0);
            this.maxHighlightingProgress = 0;
            this.sumHighlightingProgress = 0;
            this.maxMarkerHighlightingProgress = 0;
            this.sumMarkerHighlightingProgress = 0;
            this.totalHighlightingProgress = 0;
            var e = false;
            var f = false;
            var g = false;
            var h = 0;
            var i = 0;
            var j = 0;
            var k = 0;
            var l = 0;
            var m = 0;
            for (var n = 0; n < this.i.count; n++) {
                var o = this.i._inner[n];
                if (o.a == HighlightingState.inward) {
                    if (o.e) {
                        e = true;
                        j = j + Math.min(1 - o.f, b);
                    }
                    else {
                        if (!this.d && !o.d) {
                            g = true;
                            l = l + Math.min(1 - o.f, b);
                        }
                        else {
                            f = true;
                            h = h + Math.min(1 - o.f, b);
                        }
                    }
                }
                if (o.a == HighlightingState.outward) {
                    if (o.e) {
                        k = k + Math.min(o.f, b);
                    }
                    else {
                        if (!this.d && !o.d) {
                            m = m + Math.min(o.f, b);
                        }
                        else {
                            i = i + Math.min(o.f, b);
                        }
                    }
                }
            }
            var p = 1;
            var q = 1;
            var r = 1;
            if (f && i > h) {
                var s = i - h;
                p = h / i;
            }
            if (e && k > j) {
                var t = k - j;
                q = j / k;
            }
            if (g && m > l) {
                var u = m - l;
                r = l / m;
            }
            else {
                r = p;
            }
            var v;
            for (var w = 0; w < this.i.count; w++) {
                var x = this.i._inner[w];
                v = b;
                if (x.a == HighlightingState.outward) {
                    v = Math.min(v, x.f);
                    if (x.e) {
                        v = v * q;
                    }
                    else {
                        if (x.d) {
                            v = v * p;
                        }
                        else {
                            v = v * r;
                        }
                    }
                    x.f = x.f - v;
                }
                else {
                    x.f = x.f + v;
                }
                if (x.a == 2) {
                    x.f = 1;
                }
                if (x.f > 1) {
                    x.f = 1;
                }
                if (x.f < 0) {
                    x.f = 0;
                }
                if (x.e) {
                    this.maxMarkerHighlightingProgress = Math.max(x.f, this.maxMarkerHighlightingProgress);
                    this.sumMarkerHighlightingProgress = this.sumMarkerHighlightingProgress + x.f;
                }
                else {
                    this.maxHighlightingProgress = Math.max(x.f, this.maxHighlightingProgress);
                    this.sumHighlightingProgress = this.sumHighlightingProgress + x.f;
                }
                if (x.a != HighlightingState.outward && x.f != 1) {
                    c = true;
                }
                if (x.a == HighlightingState.outward && x.f != 0) {
                    c = true;
                }
                if (x.f == 1 && x.a == HighlightingState.inward) {
                    x.a = 2;
                }
                if (x.f == 0 && x.a == HighlightingState.outward) {
                    d.add(x);
                }
                if (this.isCrossSeriesHighlight(x.b)) {
                    this.allDirty = true;
                }
                else {
                    if (!this.f.containsKey(x.b)) {
                        this.f.addItem(x.b, true);
                        this.dirtySeries.add(x.b);
                    }
                }
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var y = _c.value;
                    this.e.removeItem(y);
                    this.i.remove(y);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            if (this.e.count == 0) {
                this.inProgress = false;
                this.maxHighlightingProgress = 0;
                this.sumHighlightingProgress = 0;
                this.maxMarkerHighlightingProgress = 0;
                this.sumMarkerHighlightingProgress = 0;
                this.totalHighlightingProgress = 0;
            }
            this.k.clear();
            for (var z = 0; z < this.i.count; z++) {
                var aa = this.i._inner[z];
                var ab = null;
                if (this.g.containsKey(aa.b)) {
                    ab = this.g.item(aa.b);
                }
                else {
                    ab = new HighlightingData();
                    ab.b = 0;
                    ab.e = 0;
                    ab.a = aa.b;
                    ab.c = 0;
                    ab.d = 0;
                    this.g.addItem(aa.b, ab);
                    this.k.add(aa.b);
                }
                if (aa.e) {
                    ab.c += aa.f;
                }
                else {
                    if (aa.d) {
                        if (aa.c) {
                            ab.d += aa.f;
                        }
                        else {
                            ab.e += aa.f;
                        }
                    }
                    else {
                        ab.b += aa.f;
                    }
                }
            }
            if (this.d) {
                this.totalHighlightingProgress = Math.max(this.sumHighlightingProgress, this.sumMarkerHighlightingProgress);
            }
            else {
                var ac = 0;
                var ad = 0;
                var ae = 0;
                var af = 0;
                var ag = 0;
                var ah = 0;
                var ai = 0;
                for (var aj = 0; aj < this.k.count; aj++) {
                    var ak = this.g.item(this.k._inner[aj]);
                    if (ak.b > 0) {
                        ah++;
                    }
                    if (ak.c > 0) {
                        ai++;
                    }
                    if (ak.e > 0) {
                        ae++;
                    }
                    ac += ak.b;
                    ad += ak.e;
                    ag += ak.d;
                    af += ak.c;
                }
                if (ah > 0) {
                    ac = ac / ah;
                }
                if (ai > 0) {
                    af = af / ai;
                }
                if (this.highlightingBehavior == 3) {
                    if (ae > 0) {
                        ad = ad / ae;
                    }
                }
                this.totalHighlightingProgress = Math.max(ag, Math.max(ac, Math.max(ad, af)));
            }
            if (!c) {
                this.m = 0;
            }
            return c;
        };
        HighlightingManager.prototype.isCrossSeriesHighlight = function (a) {
            if (a.bj == 5 || a.bj == 4) {
                return true;
            }
            return false;
        };
        Object.defineProperty(HighlightingManager.prototype, "inProgress", {
            get: function () {
                return this._inProgress;
            },
            set: function (a) {
                this._inProgress = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "maxHighlightingProgress", {
            get: function () {
                return this._maxHighlightingProgress;
            },
            set: function (a) {
                this._maxHighlightingProgress = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "sumHighlightingProgress", {
            get: function () {
                return this._sumHighlightingProgress;
            },
            set: function (a) {
                this._sumHighlightingProgress = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "maxMarkerHighlightingProgress", {
            get: function () {
                return this._maxMarkerHighlightingProgress;
            },
            set: function (a) {
                this._maxMarkerHighlightingProgress = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "sumMarkerHighlightingProgress", {
            get: function () {
                return this._sumMarkerHighlightingProgress;
            },
            set: function (a) {
                this._sumMarkerHighlightingProgress = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighlightingManager.prototype, "totalHighlightingProgress", {
            get: function () {
                return this._totalHighlightingProgress;
            },
            set: function (a) {
                this._totalHighlightingProgress = a;
            },
            enumerable: false,
            configurable: true
        });
        HighlightingManager.$t = i2.markType(HighlightingManager, 'HighlightingManager', i2.Base.$, [IHighlightingManager_$type]);
        return HighlightingManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITileZoomTileInfo_$type = new i2.Type(null, 'ITileZoomTileInfo');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TileZoomTileInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TileZoomTileInfo, _super);
        function TileZoomTileInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._zoomLevel = 0;
            _this._xPosition = 0;
            _this._yPosition = 0;
            return _this;
        }
        Object.defineProperty(TileZoomTileInfo.prototype, "zoomLevel", {
            get: function () {
                return this._zoomLevel;
            },
            set: function (a) {
                this._zoomLevel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTileInfo.prototype, "xPosition", {
            get: function () {
                return this._xPosition;
            },
            set: function (a) {
                this._xPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTileInfo.prototype, "yPosition", {
            get: function () {
                return this._yPosition;
            },
            set: function (a) {
                this._yPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        TileZoomTileInfo.prototype.toString = function () {
            return this.zoomLevel + "_" + this.xPosition + "_" + this.yPosition;
        };
        TileZoomTileInfo.$t = i2.markType(TileZoomTileInfo, 'TileZoomTileInfo', i2.Base.$, [ITileZoomTileInfo_$type]);
        return TileZoomTileInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TileZoomInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TileZoomInfo, _super);
        function TileZoomInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.g = null;
            _this.e = 0;
            _this.d = 0;
            _this.c = 0;
            _this.b = 0;
            _this.a = 0;
            return _this;
        }
        TileZoomInfo.$t = i2.markType(TileZoomInfo, 'TileZoomInfo');
        return TileZoomInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TileZoomManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TileZoomManager, _super);
        function TileZoomManager(a, b, c) {
            var _this = _super.call(this) || this;
            _this.e = null;
            _this.av = null;
            _this.aw = null;
            _this.au = null;
            _this.i = false;
            _this.v = 0;
            _this.k = null;
            _this.l = null;
            _this.n = null;
            _this.q = -1;
            _this.ao = null;
            _this.p = 1;
            _this.r = 1;
            _this.y = 0;
            _this.o = null;
            _this.m = null;
            _this.d = null;
            _this.f = false;
            _this.h = false;
            _this.e = a;
            var d = _this.e;
            d.actualWindowRectChanged = i2.delegateCombine(d.actualWindowRectChanged, i2.runOn(_this, _this.am));
            var e = _this.e;
            e.gridAreaRectChanged = i2.delegateCombine(e.gridAreaRectChanged, i2.runOn(_this, _this.an));
            _this.d = new TileZoomTileCache(c, _this);
            _this.o = new i2.List$1(TileZoomTileInfo.$, 0);
            _this.m = new i2.List$1(TileZoomTile.$, 0);
            _this.k = new i2.Dictionary$2(TileZoomTile.$, ITileZoomTile_$type, 0);
            _this.l = new i2.Dictionary$2(TileZoomTile.$, ITileZoomTile_$type, 0);
            _this.n = new i2.List$1(ITileZoomTile_$type, 0);
            _this.h = b;
            _this.ai();
            return _this;
        }
        TileZoomManager.prototype.ai = function () {
            this.av = this.e.pv;
            this.ao = this.ap(this.av);
            var a = this.s();
            this.ac();
            this.ab();
            this.q = a;
            this.v = this.t(a);
            this.au = new i2.Rect(0, 0, 0, a, a);
        };
        TileZoomManager.prototype.ap = function (a) {
            return new i2.Rect(0, a.left, a.top, a.width * this.p, a.height * this.r);
        };
        TileZoomManager.prototype.t = function (a) {
            var b = a / 512;
            var c = i2.logBase(b, 2);
            return c;
        };
        TileZoomManager.prototype.s = function () {
            var a = Math.max(this.ao.width, this.ao.height);
            var b = 1;
            var c = 512;
            while (c < a) {
                b++;
                c = 512 * b;
            }
            return c;
        };
        TileZoomManager.prototype.an = function (a, b) {
            this.ai();
            this.aj();
        };
        TileZoomManager.prototype.am = function (a, b) {
            this.aj();
        };
        TileZoomManager.prototype.aj = function () {
            this.f = true;
            this.aw = this.e.pg;
            if (this.i) {
                if (this.j(this.aw)) {
                    this.ai();
                }
                this.af();
                this.ak();
                this.ag();
            }
        };
        TileZoomManager.prototype.j = function (a) {
            var b = 1;
            var c = 1;
            if (this.g(a)) {
                if (a.width > a.height) {
                    var d = 1;
                    if (a.height != 0) {
                        d = a.width / a.height;
                    }
                    var e = 0;
                    var f = 1;
                    while (f < d) {
                        e++;
                        f = i2.truncate(Math.pow(3, e));
                    }
                    f = i2.truncate(Math.pow(3, e - 1));
                    c = f;
                    if (c == 0 || i2.isInfinity(c) || i2.isNaN_(c)) {
                        c = 1;
                    }
                }
                else {
                    var g = 1;
                    if (a.width != 0) {
                        g = a.height / a.width;
                    }
                    var h = 0;
                    var i = 1;
                    while (i < g) {
                        h++;
                        i = i2.truncate(Math.pow(3, h));
                    }
                    i = i2.truncate(Math.pow(3, h - 1));
                    b = i;
                    if (i2.isInfinity(b) || i2.isNaN_(b)) {
                        b = 1;
                    }
                }
            }
            else {
                b = 1;
                c = 1;
            }
            var j = c != this.r || b != this.p;
            this.p = b;
            this.r = c;
            return j;
        };
        TileZoomManager.prototype.g = function (a) {
            return (a.width / a.height) > 3 || (a.height / a.width) > 3;
        };
        TileZoomManager.prototype.ag = function () {
            var e_1, _a;
            var a = this.a();
            for (var b = 0; b < this.m.count; b++) {
                this.aa(a, this.m._inner[b]);
            }
            var c = new i2.Dictionary$2(i2.Base.$, ITileZoomTile_$type, 0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.l.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    c.addItem(this.l.item(d).content, this.l.item(d));
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.e.cf.b3(c, this.n, 512);
        };
        TileZoomManager.prototype.aa = function (a, b) {
            var c = this.as(b, a);
            var d = c.left * a.b;
            var e = c.top * a.a;
            var f = c.right * a.b;
            var g = c.bottom * a.a;
            var h = d - a.f.left;
            var i = e - a.f.top;
            var j = f - d;
            var k = g - e;
            b.xPosition = h / this.p;
            b.yPosition = i / this.r;
            b.width = j / this.p;
            b.height = k / this.r;
        };
        TileZoomManager.prototype.ak = function () {
            var e_2, _a;
            var a = this.a();
            this.k.clear();
            for (var b = 0; b < this.m.count; b++) {
                var c = this.m._inner[b];
                this.k.addItem(c, c);
            }
            this.m.clear();
            this.l.clear();
            this.n.clear();
            for (var d = 0; d < this.o.count; d++) {
                var e = this.o._inner[d];
                var f = this.d.b(e);
                if (f == null) {
                    f = this.b(e, a);
                    this.d.f(f);
                }
                if (this.k.containsKey(f)) {
                    this.k.removeItem(f);
                    this.l.addItem(f, f);
                }
                else {
                    this.z(f);
                    this.n.add(f);
                }
                this.m.add(f);
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.k.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    this.ad(g);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        TileZoomManager.prototype.ad = function (a) {
        };
        TileZoomManager.prototype.z = function (a) {
        };
        TileZoomManager.prototype.b = function (a, b) {
            var c = this.c(a);
            var d = this.as(c, b);
            var e = this.ar();
            var f = 1 / e.width;
            var g = e.height;
            if (e.width > e.height) {
                f = e.width;
                g = 1 / e.height;
            }
            var h = (d.left - e.left) * f;
            var i = (d.top - e.top) * g;
            var j = (d.right - e.left) * f;
            var k = (d.bottom - e.top) * g;
            d = new i2.Rect(0, h, i, j - h, k - i);
            var l = this.e.cf.bh(d, c, i2.truncate(512));
            c.content = l;
            return c;
        };
        TileZoomManager.prototype.ar = function () {
            var a = this.e.pv;
            var b = this.e.pk;
            if (b.isEmpty) {
                return new i2.Rect(0, 0, 0, 1, 1);
            }
            var c = (b.left - a.left) / a.width;
            var d = (b.top - a.top) / a.height;
            var e = (b.right - a.left) / a.width;
            var f = (b.bottom - a.top) / a.height;
            return new i2.Rect(0, c, d, e - c, f - d);
        };
        TileZoomManager.prototype.as = function (a, b) {
            var c = a.info.xPosition * 512;
            var d = a.info.yPosition * 512;
            var e = c + 512;
            var f = d + 512;
            var g = c / b.d;
            var h = d / b.c;
            var i = 512 / b.d;
            var j = 512 / b.c;
            return new i2.Rect(0, g, h, i, j);
        };
        TileZoomManager.prototype.c = function (a) {
            var b = 0;
            b = this.y;
            this.y++;
            var c = new TileZoomTile();
            c.info = a;
            c.iD = b;
            return c;
        };
        TileZoomManager.prototype.a = function () {
            var a = this.aq(this.aw);
            var b = this.x(a);
            var c = Math.pow(2, b) * 512;
            var d = c;
            var e = (this.ao.width / this.au.width) * c;
            var f = (this.ao.height / this.au.height) * d;
            var g = (this.ao.width / a.width);
            var h = (this.ao.height / a.height);
            var i = a.left * g;
            var j = a.top * h;
            var k = a.right * g;
            var l = a.bottom * h;
            var m = new TileZoomInfo();
            m.f = new i2.Rect(0, i, j, k - i, l - j);
            var n = this.at(this.aw, m.f, b, g, h, e, f);
            var o = n.left * e;
            var p = n.top * f;
            var q = n.right * e;
            var r = n.bottom * f;
            m.g = new i2.Rect(0, o, p, q - o, r - p);
            m.e = b;
            m.d = e;
            m.c = f;
            m.b = g;
            m.a = h;
            return m;
        };
        TileZoomManager.prototype.aq = function (a) {
            return a;
        };
        TileZoomManager.prototype.at = function (a, b, c, d, e, f, g) {
            var h = (a.left + a.right) / 2;
            var i = (a.top + a.bottom) / 2;
            var j = a.width;
            var k = a.height;
            j = j * d / f;
            k = k * e / g;
            var l = j / 2;
            var m = k / 2;
            return new i2.Rect(0, h - l, i - m, j, k);
        };
        TileZoomManager.prototype.af = function () {
            var a = this.a();
            var b = 512 * a.b / a.d;
            var c = 512 * a.a / a.c;
            var d = i2.truncate(Math.floor(a.f.left / b));
            var e = i2.truncate(Math.floor(a.f.top / c));
            var f = i2.truncate(Math.floor(a.f.right / b));
            var g = i2.truncate(Math.floor(a.f.bottom / c));
            this.o.clear();
            var _loop_1 = function (h) {
                var _loop_2 = function (i) {
                    this_1.o.add(((function () {
                        var $ret = new TileZoomTileInfo();
                        $ret.xPosition = i;
                        $ret.yPosition = h;
                        $ret.zoomLevel = a.e;
                        return $ret;
                    })()));
                };
                for (var i = d; i <= f; i++) {
                    _loop_2(i);
                }
            };
            var this_1 = this;
            for (var h = e; h <= g; h++) {
                _loop_1(h);
            }
        };
        TileZoomManager.prototype.x = function (a) {
            var b = 1 / a.width;
            var c = 1 / a.height;
            var d;
            var e;
            if (this.h) {
                d = Math.floor(i2.logBase(b, 2));
                e = Math.floor(i2.logBase(c, 2));
            }
            else {
                d = Math.ceil(i2.logBase(b, 2));
                e = Math.ceil(i2.logBase(c, 2));
            }
            var f = Math.min(d, e) + (this.v);
            return i2.truncate(f);
        };
        TileZoomManager.prototype.ab = function () {
            if (!this.f) {
                return;
            }
            this.f = false;
            this.e.cf.b0();
            this.d.g();
        };
        TileZoomManager.prototype.al = function () {
            this.i = true;
        };
        TileZoomManager.prototype.ah = function () {
            this.i = false;
            this.e.cf.cj();
        };
        TileZoomManager.prototype.ae = function (a) {
            this.e.cf.b1(a);
        };
        TileZoomManager.prototype.ac = function () {
            this.m.clear();
            this.o.clear();
            this.k.clear();
        };
        TileZoomManager.$t = i2.markType(TileZoomManager, 'TileZoomManager');
        return TileZoomManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var TileZoomTileCache = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TileZoomTileCache, _super);
        function TileZoomTileCache(a, b) {
            var _this = _super.call(this) || this;
            _this.c = new i2.Dictionary$2(i2.String_$type, TileZoomTile.$, 0);
            _this.d = new i2.LinkedList$1(TileZoomTile.$);
            _this.e = 0;
            _this.a = null;
            _this.e = a;
            _this.a = b;
            return _this;
        }
        TileZoomTileCache.prototype.g = function () {
            this.c.clear();
            this.d = new i2.LinkedList$1(TileZoomTile.$);
        };
        TileZoomTileCache.prototype.i = function (a) {
            this.d.h(a.b);
            this.d.f(a);
            a.b = this.d.d;
        };
        TileZoomTileCache.prototype.f = function (a) {
            this.d.f(a);
            this.c.addItem(a.info.toString(), a);
            a.a = this;
            a.b = this.d.d;
            while (this.c.count > this.e) {
                this.h(this.d.c.c);
            }
        };
        TileZoomTileCache.prototype.h = function (a) {
            this.d.h(a.b);
            this.c.removeItem(a.info.toString());
            this.a.ae(a);
        };
        TileZoomTileCache.prototype.b = function (a) {
            if (this.c.containsKey(a.toString())) {
                var b = this.c.item(a.toString());
                b.touch();
                return b;
            }
            return null;
        };
        TileZoomTileCache.$t = i2.markType(TileZoomTileCache, 'TileZoomTileCache');
        return TileZoomTileCache;
    }(i2.Base));
    /**
     * @hidden
     */
    var TileZoomTile = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TileZoomTile, _super);
        function TileZoomTile() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._info = null;
            _this.a = null;
            _this.b = null;
            _this._content = null;
            _this._xPosition = 0;
            _this._width = 0;
            _this._yPosition = 0;
            _this._height = 0;
            _this._iD = 0;
            return _this;
        }
        Object.defineProperty(TileZoomTile.prototype, "info", {
            get: function () {
                return this._info;
            },
            set: function (a) {
                this._info = a;
            },
            enumerable: false,
            configurable: true
        });
        TileZoomTile.prototype.touch = function () {
            if (this.a == null) {
                return;
            }
            this.a.i(this);
        };
        Object.defineProperty(TileZoomTile.prototype, "content", {
            get: function () {
                return this._content;
            },
            set: function (a) {
                this._content = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTile.prototype, "xPosition", {
            get: function () {
                return this._xPosition;
            },
            set: function (a) {
                this._xPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTile.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (a) {
                this._width = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTile.prototype, "yPosition", {
            get: function () {
                return this._yPosition;
            },
            set: function (a) {
                this._yPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTile.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TileZoomTile.prototype, "iD", {
            get: function () {
                return this._iD;
            },
            set: function (a) {
                this._iD = a;
            },
            enumerable: false,
            configurable: true
        });
        TileZoomTile.$t = i2.markType(TileZoomTile, 'TileZoomTile', i2.Base.$, [ITileZoomTile_$type]);
        return TileZoomTile;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesViewerInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerInteractionManager, _super);
        function SeriesViewerInteractionManager() {
            var _this = _super.call(this) || this;
            _this.r = 0;
            _this.s = 0;
            _this.af = null;
            _this.o = 0;
            _this.p = 0;
            _this.n = 0;
            _this.q = 0;
            _this.h = false;
            _this.ag = null;
            _this.ai = null;
            _this.j = false;
            _this.e = null;
            _this.b = null;
            _this.ah = null;
            _this.aj = null;
            _this.d = null;
            _this.a = null;
            _this.g = false;
            _this.ah = i2.Rect.empty;
            _this.ag = i2.Rect.empty;
            return _this;
        }
        Object.defineProperty(SeriesViewerInteractionManager.prototype, "f$b", {
            get: function () {
                if (this.b == null) {
                    this.b = new HighlightingManager();
                }
                return this.b;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerInteractionManager.prototype.f$am = function (a, b) {
            var c = null;
            var d = null;
            var e = null;
            e = a.cf.e();
            var f;
            var g = ((function () { var h = a.cf.f(b, false, f, false); f = h.p2; return h.ret; })());
            if (g != e) {
                if (e.a4.a$c) {
                    e.a4.a$z(e, b, null, null, false);
                }
            }
            c = f;
            if (a != null) {
                a.mc(b);
            }
            if (g != null && !g.a4.a$c) {
                g.a4.a$y(g, b, c, d, false);
            }
        };
        SeriesViewerInteractionManager.prototype.f$a = function (a) {
            if (a.at != 0) {
                return a.at;
            }
            var b = 1;
            var c = false;
            var d = false;
            for (var e = 0; e < a.series.count; e++) {
                var f = a.series._inner[e];
                if (f.isStacked) {
                    f.ku(function (g) {
                        if (g.bn == 2) {
                            c = true;
                        }
                        if (g.bn == 1) {
                            d = true;
                        }
                        return true;
                    });
                }
                else {
                    if (f.bn == 2) {
                        c = true;
                    }
                    if (f.bn == 1) {
                        d = true;
                    }
                }
            }
            if (d) {
                b = 1;
            }
            if (c) {
                b = 2;
            }
            if (c && d) {
                b = 3;
            }
            return b;
        };
        SeriesViewerInteractionManager.prototype.f$al = function (a) {
            var b = a.o8;
            var c = b;
            var d = a.cf;
            var e = a.c9();
            var f = a.db;
            var g = a.ee;
            var h = a.em;
            if (!e) {
                c = { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            if (c.x < 0 || c.x > 1 || c.y < 0 || c.y > 1) {
                c = { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            for (var i = 0; i < a.series.count; i++) {
                var j = a.series._inner[i];
                j.kz(c);
            }
            var k = a.b6 == 0 && !a.dp && (a.de || f) && !g && !h;
            var l = a.pv;
            if (k && !i2.isNaN_(b.x) && !l.isEmpty) {
                var m = l.width * (b.x - a.pg.left) / a.pg.width;
                d.el(l.left + m, l.top, l.left + m, l.bottom);
                d.ea();
                d.ef(m);
            }
            else {
                d.ci();
            }
            if (k && !i2.isNaN_(b.y) && !l.isEmpty) {
                var n = l.height * (b.y - a.pg.top) / a.pg.height;
                d.ee(l.left, l.top + n, l.right, l.top + n);
                d.d6();
            }
            else {
                d.cd();
            }
        };
        SeriesViewerInteractionManager.prototype.f$ae = function (a) {
            switch (a.b6) {
                case 0:
                    a.cf.d2();
                    this.f$al(a);
                    a.cf.ca();
                    break;
                case 1:
                    a.cf.d4();
                    a.cf.ch();
                    this.f$al(a);
                    a.cf.b9();
                    break;
                case 2:
                    a.cf.d4();
                    a.cf.ch();
                    this.f$al(a);
                    a.cf.cb();
                    break;
            }
        };
        SeriesViewerInteractionManager.prototype.f$p = function (a, b) {
            if (b.x >= 0 && b.y >= 0 && b.x <= a.pv.width && b.y <= a.pv.height) {
                this.ab(a, b);
            }
            else {
                a.jj();
            }
        };
        SeriesViewerInteractionManager.prototype.ab = function (a, b) {
            var e_1, _a;
            var c = a.cf;
            var d = a.pv;
            if (a.dq || a.dp) {
                return;
            }
            if (a.db && a.de) {
                var e = d.height > d.width;
                c.bv(e);
                try {
                    for (var _b = tslib.__values(i2.fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var f = _c.value;
                        if (f.isStacked) {
                            f.ku(function (g) {
                                if (g._visibility == 0) {
                                    g.l6(b, i2.runOn(c, c.bm));
                                }
                                return true;
                            });
                        }
                        else {
                            if (f._visibility == 0) {
                                f.l6(b, i2.runOn(c, c.bm));
                            }
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                c.d7();
            }
        };
        SeriesViewerInteractionManager.prototype.aa = function (a, b) {
            if (a.de || a.dm) {
                a.db = true;
                a.k9();
                this.ag = new i2.Rect(0, b.x, b.y, 0, 0);
                this.ai = new i2.Rect(0, b.x, b.y, 0, 0);
                a.b6 = 0;
                a.ja(a.pa(b));
            }
        };
        SeriesViewerInteractionManager.prototype.f$ac = function (a, b) {
            this.aa(a, b);
            this.ab(a, b);
            this.f$al(a);
        };
        SeriesViewerInteractionManager.prototype.f$q = function (a, b, c) {
            if (!a.db) {
                this.ad(a, b, c);
            }
        };
        SeriesViewerInteractionManager.prototype.f$o = function (a, b) {
            this.ah = i2.Rect.empty;
            a.jj();
        };
        SeriesViewerInteractionManager.prototype.f$aj = function (a) {
            var b = a.cf;
            this.q = 1;
            a.db = false;
            b.cg();
            b.cc();
            b.ce();
            a.ja({ $type: i2.Point_$type, x: NaN, y: NaN });
            b.cd();
            b.ci();
            b.ch();
            a.b6 = 0;
            this.h = true;
            a.ee = true;
            a.la();
        };
        SeriesViewerInteractionManager.prototype.f$ab = function (a, b) {
            this.f$aj(a);
        };
        SeriesViewerInteractionManager.prototype.f$ak = function (a, b, c, d, e) {
            this.r = b.x;
            this.s = b.y;
            this.o = c;
            this.p = d;
            this.n = e;
            this.af = a.pg;
            this.f$aj(a);
        };
        SeriesViewerInteractionManager.prototype.f$aa = function (a, b) {
            var c = a.cf;
            c.cd();
            c.ci();
            if (c.av) {
                this.w(a, b);
            }
            else {
                this.y(a, b);
                this.q = b;
            }
        };
        SeriesViewerInteractionManager.prototype.f$ag = function (a, b, c, d, e) {
            var f = a.cf;
            f.cd();
            f.ci();
            this.o = this.o * c;
            this.p = this.p * d;
            this.n = this.n * e;
            if (a.dw) {
                this.o = this.n;
                this.p = this.n;
            }
            var g = a.pg;
            var h = a.pv;
            var i = b.x - this.r;
            var j = b.y - this.s;
            this.r = b.x;
            this.s = b.y;
            var k = g.width;
            var l = g.height;
            var m = this.af.width / this.o;
            var n = this.af.height / this.p;
            if (m > 1) {
                m = 1;
            }
            if (n > 1) {
                n = 1;
            }
            var o = { $type: i2.Point_$type, x: b.x, y: b.y };
            var p = { $type: i2.Point_$type, x: (o.x - h.left) / h.width * g.width + g.left, y: (o.y - h.top) / h.height * g.height + g.top };
            var q = new i2.Rect(0, g.left, g.top, m, n);
            var r = { $type: i2.Point_$type, x: (p.x - q.left) / q.width * h.width + h.left, y: (p.y - q.top) / q.height * h.height + h.top };
            var s = (r.x - o.x) - i;
            var t = (r.y - o.y) - j;
            var u = s / h.width * q.width;
            var v = t / h.height * q.height;
            q = new i2.Rect(0, q.left + u, q.top + v, q.width, q.height);
            g = q;
            a.ms(g, true);
        };
        SeriesViewerInteractionManager.prototype.f$x = function (a, b) {
            this.ag = new i2.Rect(0, b.x, b.y, 0, 0);
            this.ai = new i2.Rect(0, b.x, b.y, 0, 0);
        };
        SeriesViewerInteractionManager.prototype.x = function (a, b, c) {
            var d = a.pg.width;
            var e = a.pg.height;
            var f = a.pg.left + d / 2;
            var g = a.pg.top + e / 2;
            d = d / b;
            e = e / b;
            var h = f - d / 2;
            var i = g - e / 2;
            a.ms(new i2.Rect(0, h, i, d, e), true);
        };
        SeriesViewerInteractionManager.prototype.f$z = function (a, b) {
            var c = a.cf;
            if (c.av) {
                this.w(a, b);
            }
            else {
                this.y(a, b);
            }
            this.ag = i2.Rect.empty;
            a.ee = false;
        };
        SeriesViewerInteractionManager.prototype.f$r = function (a, b) {
            a.ee = false;
            this.ag = i2.Rect.empty;
            a.jj();
        };
        SeriesViewerInteractionManager.prototype.f$af = function (a, b, c, d, e) {
            a.ee = false;
            this.ag = i2.Rect.empty;
            a.jj();
        };
        SeriesViewerInteractionManager.prototype.w = function (a, b) {
            var c = a.pw;
            var d = 1 / b;
            var e = { $type: i2.Point_$type, x: c.x + c.width / 2, y: c.y + c.height / 2 };
            var f = { $type: i2.Point_$type, x: c.x - e.x, y: c.y - e.y };
            var g = new i2.Rect(0, f.x * d + e.x, f.y * d + e.y, c.width * d, c.height * d);
            a.ms(g, true);
        };
        SeriesViewerInteractionManager.prototype.y = function (a, b) {
            var c = a.pv;
            var d = a.pw;
            var e = b - this.q;
            if (e != 0) {
                var f = 0.03;
                var g = e < 0 ? 1 + f : 1 - f;
                var h = { $type: i2.Point_$type, x: d.x + d.width / 2, y: d.y + d.height / 2 };
                var i = { $type: i2.Point_$type, x: d.x - h.x, y: d.y - h.y };
                var j = new i2.Rect(0, i.x * g + h.x, i.y * g + h.y, d.width * g, d.height * g);
                a.ms(j, true);
            }
        };
        SeriesViewerInteractionManager.prototype.f$m = function (a, b, c) {
            if (!a.ee) {
                this.h = false;
            }
            this.ad(a, b, c);
            a.ku(b, c);
        };
        SeriesViewerInteractionManager.prototype.ad = function (a, b, c) {
            var d;
            var e = a.cf;
            var f = a.b4(c);
            if (e.ew == 0) {
                switch (f) {
                    case 1:
                        d = a.d3() ? f : 0;
                        break;
                    default:
                        d = f;
                        break;
                }
            }
            else {
                if (e.ew == a.on) {
                    d = 1;
                }
                else if (e.ew == a.oo) {
                    d = 2;
                }
                else {
                    d = 0;
                }
            }
            switch (d) {
                case 1:
                case 2:
                    a.cf.b7();
                    a.cf.dn();
                    break;
            }
            a.b6 = d;
            switch (a.b6) {
                case 1:
                    a.ja({ $type: i2.Point_$type, x: NaN, y: NaN });
                    this.ag = new i2.Rect(0, b.x, b.y, 0, 0);
                    this.ai = new i2.Rect(0, b.x, b.y, 0, 0);
                    this.ah = new i2.Rect(0, b.x, b.y, 0, 0);
                    e.d5();
                    e.ed(this.ag);
                    a.lf(i2.Rect.empty, true);
                    break;
                case 2:
                    this.ag = new i2.Rect(0, b.x, b.y, 0, 0);
                    this.ah = new i2.Rect(0, b.x, b.y, 0, 0);
                    break;
            }
            this.aj = a.pg;
            a.px = a.pg;
        };
        SeriesViewerInteractionManager.prototype.f$ai = function (a) {
            a.md();
            a.cf.di();
        };
        SeriesViewerInteractionManager.prototype.f$ah = function (a) {
            a.je();
            a.cf.dh();
        };
        SeriesViewerInteractionManager.prototype.f$an = function (a) {
            if (a.c8 && !this.j) {
                this.j = true;
                this.ac(a);
            }
        };
        SeriesViewerInteractionManager.prototype.f$j = function (a) {
            if (this.j) {
                this.z(a);
                this.j = false;
            }
        };
        SeriesViewerInteractionManager.prototype.f$g = function (a) {
            if (this.e == null) {
                return;
            }
            this.f.ab();
        };
        Object.defineProperty(SeriesViewerInteractionManager.prototype, "f", {
            get: function () {
                return this.e;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerInteractionManager.prototype.ac = function (a) {
            if (this.e == null) {
                this.e = new TileZoomManager(a, true, a.ga);
                this.e.h = !a.ef;
            }
            a.dl = true;
            a.le();
            this.e.al();
            a.cf.br();
            a.cf.bs();
        };
        SeriesViewerInteractionManager.prototype.z = function (a) {
            if (this.e == null) {
                return;
            }
            a.dl = false;
            a.cf.dd();
            this.e.ah();
            a.lx();
            a.cf.by();
        };
        SeriesViewerInteractionManager.prototype.f$i = function (a) {
            a.i8();
            a.lz();
        };
        SeriesViewerInteractionManager.prototype.l = function (a) {
            return a.b6 == 2;
        };
        SeriesViewerInteractionManager.prototype.m = function (a, b) {
            return a.bw == 1 || b || a.c8;
        };
        SeriesViewerInteractionManager.prototype.k = function (a) {
            return a.b6 == 1;
        };
        SeriesViewerInteractionManager.prototype.f$l = function (a, b, c) {
            var d = a.cf;
            if (this.ag.isEmpty && c) {
                this.ad(a, b, c);
            }
            var e = 2;
            if (c) {
                e = 10;
            }
            var f = false;
            var g = new i2.Rect(2, { $type: i2.Point_$type, x: this.ag.x, y: this.ag.y }, b);
            var h = new i2.Rect(0, 0, 0, 0, 0);
            if (!this.ah.isEmpty) {
                h = new i2.Rect(2, { $type: i2.Point_$type, x: this.ah.x, y: this.ah.y }, b);
            }
            if (h.width > e && h.height > e) {
                f = true;
            }
            if (!a.ee) {
                if (f) {
                    this.h = false;
                }
            }
            if (!a.ee && (a.db || !c)) {
                a.ja(a.pa(b));
            }
            if (this.k(a)) {
                if (f) {
                    var i = a.pu(g);
                    a.lf(i, true);
                }
                else {
                    a.lf(i2.Rect.empty, true);
                }
                a.j4();
                d.ed(g);
            }
            var j = a.pv;
            var k = a.pg;
            if (this.l(a)) {
                var l = j;
                var m = k.left + k.width * (this.ag.x - b.x) / l.width;
                var n = k.top + k.height * (this.ag.y - b.y) / l.height;
                var o = new i2.Rect(0, m, n, k.width, k.height);
                if (this.m(a, c)) {
                    if (h.width != 0 || h.height != 0) {
                        a.la();
                    }
                    a.lf(i2.Rect.empty, true);
                    a.ms(o, true);
                    this.ag = new i2.Rect(3, b, new i2.Size(1, 0, 0));
                    this.ai = new i2.Rect(3, b, new i2.Size(1, 0, 0));
                }
                else {
                    a.lf(o, true);
                }
            }
            this.ai = new i2.Rect(3, b, new i2.Size(1, 0, 0));
            d.bu(b);
        };
        SeriesViewerInteractionManager.prototype.f$k = function (a, b, c, d) {
            var e = a.cf;
            var f = 2;
            if (c) {
                f = 10;
            }
            var g = a.pv;
            var h = a.pg;
            if (!this.h) {
                var i = false;
                var j = new i2.Rect(2, { $type: i2.Point_$type, x: this.ag.x, y: this.ag.y }, b);
                if (j.width > f && j.height > f) {
                    i = true;
                }
                if (a.b6 == 1) {
                    a.j3();
                    e.cc();
                    if (i) {
                        a.ms(a.pu(j), true);
                    }
                }
                if (a.b6 == 2) {
                    var k = g;
                    var l = h.left + h.width * (this.ag.x - b.x) / k.width;
                    var m = h.top + h.height * (this.ag.y - b.y) / k.height;
                    a.ms(new i2.Rect(0, l, m, h.width, h.height), true);
                }
            }
            var n = false;
            var o = new i2.Rect(2, { $type: i2.Point_$type, x: this.ah.x, y: this.ah.y }, b);
            if (o.width > f || o.height > f) {
                n = true;
            }
            if (n) {
                a.em = true;
            }
            a.b6 = 0;
            a.lf(i2.Rect.empty, true);
            e.bw();
            a.em = false;
            e.cd();
            e.ci();
            if (c) {
                e.ch();
                e.cd();
                e.ci();
                e.ce();
            }
            a.jj();
            a.k9();
            a.kv(b, c, d);
        };
        SeriesViewerInteractionManager.prototype.f$ad = function (a) {
            if (this.f != null) {
                this.f.h = !a.ef;
            }
        };
        SeriesViewerInteractionManager.prototype.f$d = function (a, b) {
            var c = a.cf;
            var d = a.pg;
            if (a.b6 == 2 && b == 8) {
                c.bt();
                a.b6 = 0;
                a.k9();
                a.lf(i2.Rect.empty, true);
                if (a.bw == 1) {
                    a.ms(this.aj, true);
                }
                return true;
            }
            if (a.b6 == 1 && b == 8) {
                c.bt();
                a.b6 = 0;
                a.k9();
                c.cc();
                a.lf(i2.Rect.empty, true);
                return true;
            }
            var e = i2.Rect.empty;
            var f = false;
            switch (b) {
                case 13:
                    f = true;
                    e = new i2.Rect(0, 0, 0, 1, 1);
                    break;
                case 11:
                    f = true;
                    e = new i2.Rect(0, d.left - 0.1 * d.width, d.top - 0.1 * d.height, 1.2 * d.width, 1.2 * d.height);
                    break;
                case 10:
                    f = true;
                    e = new i2.Rect(0, d.left + 0.1 * d.width, d.top + 0.1 * d.height, 0.8 * d.width, 0.8 * d.height);
                    break;
                case 14:
                    f = true;
                    e = new i2.Rect(0, d.left - 0.1 * d.width, d.top, d.width, d.height);
                    e.x = e.x - Math.min(e.left, 0);
                    break;
                case 16:
                    f = true;
                    e = new i2.Rect(0, d.left + 0.1 * d.width, d.top, d.width, d.height);
                    e.x = e.x - Math.max(e.right - 1, 0);
                    break;
                case 15:
                    f = true;
                    e = new i2.Rect(0, d.left, d.top - 0.1 * d.height, d.width, d.height);
                    e.y = e.y - Math.min(e.top, 0);
                    break;
                case 17:
                    f = true;
                    e = new i2.Rect(0, d.left, d.top + 0.1 * d.height, d.width, d.height);
                    e.y = e.y - Math.max(e.bottom - 1, 0);
                    break;
            }
            if (!e.isEmpty && i2.Rect.l_op_Inequality(e, d)) {
                a.ms(e, true);
            }
            return f;
        };
        SeriesViewerInteractionManager.prototype.f$e = function (a, b, c) {
            var d = a.cf;
            var e = a.pg;
            var f = e.left + e.width * b.x / a.pv.width;
            var g = e.top + e.height * b.y / a.pv.height;
            var h = 1 - i2.MathUtil.b(c, -0.5, 0.5);
            var i = Math.max(0, f - h * (f - e.left));
            var j = Math.min(1, g + h * (e.bottom - g));
            var k = Math.min(1, f + h * (e.right - f));
            var l = Math.max(0, g - h * (g - e.top));
            a.la();
            this.v(a, 1000);
            a.ms(new i2.Rect(0, i, l, k - i, j - l), true);
            return a.d3();
        };
        SeriesViewerInteractionManager.prototype.v = function (a, b) {
            a.cf.bz(b);
        };
        SeriesViewerInteractionManager.prototype.f$n = function (a, b) {
            var c = a.pg;
            var d = c.left + c.width * b.x / a.pv.width;
            var e = c.top + c.height * b.y / a.pv.height;
            var f = 0.7;
            var g = Math.max(0, d - f * (d - c.left));
            var h = Math.min(1, e + f * (c.bottom - e));
            var i = Math.min(1, d + f * (c.right - d));
            var j = Math.max(0, e - f * (e - c.top));
            a.ms(new i2.Rect(0, g, j, i - g, h - j), true);
        };
        SeriesViewerInteractionManager.prototype.f$h = function (a) {
            this.f.ac();
        };
        SeriesViewerInteractionManager.prototype.f$c = function (a, b, c, d, e, f, g) {
            var e_2, _a;
            var h = true;
            var i = false;
            var j = false;
            var k = a;
            if (k.as == 1) {
                h = false;
                i = true;
            }
            if (k.as == 3 || k.as == 4) {
                i = true;
            }
            if (k.as == 4) {
                j = true;
            }
            var l = i2.truncate(Math.round(d.x));
            var m = i2.truncate(Math.round(d.y));
            f = null;
            var n = -1;
            if (h && c != null) {
                var o = l;
                var p = m;
                if (a.fh != 1) {
                    o = i2.truncate(Math.round(d.x * a.fh));
                    p = i2.truncate(Math.round(d.y * a.fh));
                }
                var q = c.a(o, p);
                if (q == null || q.length == 0) {
                    f = null;
                    return {
                        ret: null,
                        p5: f
                    };
                }
                if ((q[0] > 0 || q[1] > 0 || q[2] > 0) && q[3] == 255) {
                    var num2_ = q[2];
                    if (num2_ % 4 != 0) {
                        num2_ = num2_ + (4 - (num2_ % 4));
                    }
                    var num1_ = q[1];
                    if (num1_ % 4 != 0) {
                        num1_ = num1_ + (4 - (num1_ % 4));
                    }
                    var num0_ = q[0];
                    if (num0_ % 4 != 0) {
                        num0_ = num0_ + (4 - (num0_ % 4));
                    }
                    var num_ = 0;
                    num_ = (num2_ >> 2);
                    num_ = (num_ << 6);
                    num_ = (num_ | (num1_ >> 2));
                    num_ = (num_ << 6);
                    num_ = (num_ | (num0_ >> 2));
                    n = i2.truncate(Math.floor((i2.intDivide(num_, 1000))));
                    n--;
                }
            }
            var r = null;
            var s = -1;
            if (n >= 0) {
                var t_1 = false;
                var u_1 = 0;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var v = _c.value;
                        if (!v.ef) {
                            continue;
                        }
                        if (t_1) {
                            break;
                        }
                        if (v.isStacked) {
                            v.ku(function (w) {
                                if (w.hc == n) {
                                    r = w;
                                    s = u_1;
                                    t_1 = true;
                                    return false;
                                }
                                return true;
                            });
                        }
                        else if (v.hc == n) {
                            r = v;
                            s = u_1;
                            break;
                        }
                        u_1++;
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
            var w = null;
            if (i) {
                var x = false;
                for (var y = b.count - 1; y >= 0; y--) {
                    var z = b._inner[y];
                    if (!z.ef) {
                        continue;
                    }
                    var aa = z.bx;
                    if (!z.e3(aa.bu, aa.bv, aa)) {
                        continue;
                    }
                    if (!x && y < s && h && !j) {
                        if (r != null) {
                            w = r;
                            x = true;
                            break;
                        }
                    }
                    if (z != null && z.bn == 1) {
                        if (z.ep(d, g)) {
                            w = z;
                            break;
                        }
                    }
                }
                if (h && !x) {
                    if (r != null) {
                        w = r;
                        x = true;
                    }
                }
            }
            else {
                w = r;
            }
            if (w != null) {
                var ab = w.at({ $type: i2.Point_$type, x: l, y: m }, g);
                if (ab != null) {
                    f = ab;
                }
                return {
                    ret: w,
                    p5: f
                };
            }
            return {
                ret: null,
                p5: f
            };
        };
        SeriesViewerInteractionManager.prototype.f$f = function (a, b) {
            if (i2.PointUtil.equals(b, null)) {
                return false;
            }
            var c = b.x;
            var d = b.y;
            if (c >= a.pv.left && d >= a.pv.top && c <= a.pv.left + a.pv.width && d <= a.pv.top + a.pv.height) {
                var e = a.b8;
                if (e != null && e.viewShouldInteract(b)) {
                    return false;
                }
                return true;
            }
            return false;
        };
        SeriesViewerInteractionManager.prototype.c = function (a) {
            if (a != null) {
                return a.be();
            }
            else {
                return null;
            }
        };
        SeriesViewerInteractionManager.prototype.f$v = function (a, b, c, d, e, f) {
            var _this = this;
            if (!f && a.c7) {
                this.ae(a, false);
            }
            var g = new i2.MouseEventArgs();
            g.position = d;
            if (a.b6 == 2 || a.b6 == 1 || a.ee || (a.b8 != null && a.b8.isPinching)) {
                if (this.d != null) {
                    this.d.a4.a$z(this.d, g.position, this.a, g, f);
                    this.d = null;
                }
                return;
            }
            var h = null;
            var i = ((function () { var j = _this.f$c(a, b, c, d, !e, h, f); h = j.p5; return j.ret; })());
            this.a = h;
            var j = this.c(i);
            if (i != null) {
                var k = false;
                var l = false;
                if (this.d != i) {
                    l = true;
                }
                if (this.d == null || l) {
                    k = true;
                }
                if (k) {
                    if (l) {
                        if (this.d != null) {
                            j = this.c(this.d);
                            this.d.a4.a$z(this.d, g.position, h, g, f);
                            if (j != null) {
                                j.a4.a$z(j, g.position, h, g, f);
                            }
                        }
                    }
                    this.d = i;
                    i.le(g.position, h, g, f);
                    if (j != null) {
                        j.le(g.position, h, g, f);
                    }
                }
                else {
                    this.d = i;
                    i.a4.a$ab(i, g.position, h, g, f);
                    if (j != null) {
                        j.a4.a$ab(j, g.position, h, g, f);
                    }
                }
            }
            else {
                if (this.d != null) {
                    j = this.c(this.d);
                    this.d.a4.a$z(this.d, g.position, h, g, f);
                    if (j != null) {
                        j.a4.a$z(j, g.position, h, g, f);
                    }
                    this.d = null;
                }
                for (var m = 0; m < a.series.count; m++) {
                    var n = a.series._inner[m];
                    if (n.a4.a$b) {
                        j = this.c(n);
                        n.a4.a$z(n, g.position, n.a4.a$p, g, f);
                        if (j != null) {
                            j.a4.a$z(j, g.position, n.a4.a$p, g, f);
                        }
                    }
                }
            }
        };
        SeriesViewerInteractionManager.prototype.f$u = function (a, b) {
            if (this.d != null) {
                var c = this.c(this.d);
                var d = new i2.MouseEventArgs();
                d.position = b;
                this.d.a4.a$z(this.d, d.position, null, d, false);
                if (c != null) {
                    c.a4.a$z(c, d.position, null, d, false);
                }
                this.d = null;
            }
            a.kp(b, a.b6 != 0 || a.d8);
        };
        SeriesViewerInteractionManager.prototype.f$t = function (a, b, c) {
            if (this.d != null) {
                var d = new i2.MouseButtonEventArgs();
                d.position = c;
                if (b.ai) {
                    this.d.a4.a$ac(this.d, d.position, this.a, d);
                }
                else {
                    this.d.a4.a$w(this.d, d.position, this.a, d);
                }
            }
        };
        SeriesViewerInteractionManager.prototype.f$w = function (a, b, c) {
            var d;
            var e = (this.d != null) ? this.d : ((function () { var f = a.cf.f(c, false, d, false); d = f.p2; return f.ret; })());
            if (e != null) {
                var f = new i2.MouseButtonEventArgs();
                f.position = c;
                if (b.ai) {
                    e.a4.a$ad(e, f.position, this.a, f);
                }
                else {
                    e.a4.a$aa(e, f.position, this.a, f);
                }
            }
        };
        SeriesViewerInteractionManager.prototype.f$s = function (a, b, c) {
            if (!c && a.ea) {
                this.ae(a, false);
            }
            if (c && !a.ea) {
                this.ae(a, true);
            }
            a.j8(b, c);
        };
        SeriesViewerInteractionManager.prototype.ae = function (a, b) {
            if (a != null) {
                if (!this.i) {
                    a.c7 = b;
                }
            }
        };
        SeriesViewerInteractionManager.prototype.f$y = function (a, b) {
            this.g = true;
        };
        Object.defineProperty(SeriesViewerInteractionManager.prototype, "i", {
            get: function () {
                return this.g;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerInteractionManager.$t = i2.markType(SeriesViewerInteractionManager, 'SeriesViewerInteractionManager', i2.Base.$, [ISeriesViewerInteractionManager_$type]);
        return SeriesViewerInteractionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var InteractivityFactoryManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(InteractivityFactoryManager, _super);
        function InteractivityFactoryManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InteractivityFactoryManager.register = function () {
            if (!InteractivityFactoryManager.a) {
                i2.TypeRegistrar.register("InteractivityFactoryManager", InteractivityFactoryManager.$);
                i2.DVContainer.instance.registerFactory(ISeriesInteractionManager_$type, function () { return new SeriesInteractionManager(); });
                i2.DVContainer.instance.registerFactory(ICategorySeriesInteractionManager_$type, function () { return new CategorySeriesInteractionManager(); });
                i2.DVContainer.instance.registerFactory(IAnchoredCategorySeriesInteractionManager_$type, function () { return new AnchoredCategorySeriesInteractionManager(); });
                i2.DVContainer.instance.registerFactory(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return new HorizontalAnchoredCategorySeriesInteractionManager(); });
                i2.DVContainer.instance.registerFactory(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return new VerticalAnchoredCategorySeriesInteractionManager(); });
                i2.DVContainer.instance.registerFactory(ISeriesViewerInteractionManager_$type, function () { return new SeriesViewerInteractionManager(); });
                InteractivityFactoryManager.a = true;
            }
        };
        InteractivityFactoryManager.$t = i2.markType(InteractivityFactoryManager, 'InteractivityFactoryManager');
        InteractivityFactoryManager.a = false;
        return InteractivityFactoryManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartDefaultTooltipsComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartDefaultTooltipsComponent(_changeDetectorRef) {
            this._changeDetectorRef = _changeDetectorRef;
            this.onContentReady = new i0.EventEmitter();
        }
        IgxDataChartDefaultTooltipsComponent.prototype.ensureDefaultTooltip = function (series) {
            if (series.isPolar) {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.polarTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.polarTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
            else if (series.isRadial) {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.radialTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.radialTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
            else if (series.isShape) {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.shapeTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.shapeTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
            else if (series.isScatter) {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.scatterTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.scatterTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
            else if (series.isCategory &&
                !series.isFinancial) {
                var tooltip = series.isVertical ? this.anchoredVerticalCategoryTooltip : series.isRange ? this.rangeTooltip : this.anchoredCategoryTooltip;
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = tooltip;
                }
                else {
                    if (series.tooltipTemplate === tooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
            else if (series.isFinancial) {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.financialTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.financialTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
        };
        IgxDataChartDefaultTooltipsComponent.prototype.format = function (value) {
            if (value == undefined || value == null) {
                return "";
            }
            if (value.getTime) {
                return this.shortDate(value);
            }
            return value.toString();
        };
        IgxDataChartDefaultTooltipsComponent.prototype.shortDate = function (item) {
            if (item == undefined || item == null) {
                return "";
            }
            return item.toLocaleDateString() + " " + item.toLocaleTimeString();
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasOpen = function (series) {
            return series.openMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getOpenValue = function (series, item) {
            return this.getItemValue(series, item, "openMemberPath", series.openMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasHigh = function (series) {
            return series.highMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getHighValue = function (series, item) {
            return this.getItemValue(series, item, "highMemberPath", series.highMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasLow = function (series) {
            return series.lowMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getLowValue = function (series, item) {
            return this.getItemValue(series, item, "lowMemberPath", series.lowMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasClose = function (series) {
            return series.closeMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getCloseValue = function (series, item) {
            return this.getItemValue(series, item, "closeMemberPath", series.closeMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasVolume = function (series) {
            return series.volumeMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getVolumeValue = function (series, item) {
            return this.getItemValue(series, item, "volumeMemberPath", series.volumeMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getAnchoredValue = function (series, item) {
            return this.getItemValue(series, item, "valueMemberPath", series.valueMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getXValue = function (series, item) {
            return this.getItemValue(series, item, "xMemberPath", series.xMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getYValue = function (series, item) {
            return this.getItemValue(series, item, "yMemberPath", series.yMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasRadius = function (series) {
            return series.radiusMemberPath !== undefined;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getRadiusValue = function (series, item) {
            return this.getItemValue(series, item, "radiusMemberPath", series.radiusMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getAngleValue = function (series, item) {
            return this.getItemValue(series, item, "angleMemberPath", series.angleMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasValue = function (series) {
            return series.valueMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getItemValue = function (series, item, memberPath, memberPathValue) {
            return series.getItemValue(item, memberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getValue = function (series, item) {
            return this.getItemValue(series, item, "valueMemberPath", series.valueMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getBrush = function (series) {
            return series.actualBrush;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasXY = function (series, item) {
            return series.xMemberPath && series.yMemberPath && item[series.xMemberPath] && item[series.yMemberPath];
        };
        IgxDataChartDefaultTooltipsComponent.prototype.hasColor = function (series) {
            return series.colorMemberPath;
        };
        IgxDataChartDefaultTooltipsComponent.prototype.getColorValue = function (series, item) {
            return this.getItemValue(series, item, "colorMemberPath", series.colorMemberPath);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.asAny = function (item) {
            return item;
        };
        IgxDataChartDefaultTooltipsComponent.register = function () {
            i2.TypeRegistrar.registerCons("IgxDataChartDefaultTooltipsComponent", IgxDataChartDefaultTooltipsComponent);
        };
        IgxDataChartDefaultTooltipsComponent.prototype.ngAfterContentInit = function () {
            this.onContentReady.emit({});
        };
        IgxDataChartDefaultTooltipsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartDefaultTooltipsComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
        IgxDataChartDefaultTooltipsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxDataChartDefaultTooltipsComponent, selector: "igx-data-chart-default-tooltips", outputs: { onContentReady: "onContentReady" }, viewQueries: [{ propertyName: "anchoredCategoryTooltip", first: true, predicate: ["anchoredCategoryTooltip"], descendants: true, static: true }, { propertyName: "anchoredVerticalCategoryTooltip", first: true, predicate: ["anchoredVerticalCategoryTooltip"], descendants: true, static: true }, { propertyName: "financialTooltip", first: true, predicate: ["financialTooltip"], descendants: true, static: true }, { propertyName: "polarTooltip", first: true, predicate: ["polarTooltip"], descendants: true, static: true }, { propertyName: "radialTooltip", first: true, predicate: ["radialTooltip"], descendants: true, static: true }, { propertyName: "rangeTooltip", first: true, predicate: ["rangeTooltip"], descendants: true, static: true }, { propertyName: "scatterTooltip", first: true, predicate: ["scatterTooltip"], descendants: true, static: true }, { propertyName: "shapeTooltip", first: true, predicate: ["shapeTooltip"], descendants: true, static: true }], ngImport: i0, template: "\n    <ng-template #anchoredCategoryTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n            <span *ngIf=\"series.xAxis.isDateTime\">{{shortDate(series.xAxis.getItemValue(asAny(item),'dateTimeMemberPath'))}}</span>\n            <br *ngIf=\"series.xAxis.isDateTime\" />\n            <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>\n            <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <span class=\"ui-tooltip-priority\">{{getAnchoredValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #anchoredVerticalCategoryTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n            <span *ngIf=\"series.yAxis.isDateTime\">{{shortDate(series.yAxis.getItemValue(asAny(item), 'dateTimeMemberPath'))}}</span>\n            <br *ngIf=\"series.yAxis.isDateTime\" />\n            <span *ngIf=\"!series.yAxis.isDateTime && series.yAxis.label\">{{format(series.yAxis.getItemValue(asAny(item), 'label'))}}</span>\n            <br *ngIf=\"!series.yAxis.isDateTime && series.yAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <span class=\"ui-tooltip-priority\">{{getAnchoredValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #financialTooltip let-series=\"series\" let-item=\"item\" let-itemLabel=\"itemLabel\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n            <span *ngIf=\"series.xAxis.isDateTime\">{{itemLabel}}</span>\n            <br *ngIf=\"series.xAxis.isDateTime\" />\n            <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>\n            <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <table>\n                <tr *ngIf=\"hasOpen(series)\"><td>{{series.actualOpenLabel}}:</td><td>{{getOpenValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasHigh(series)\"><td>{{series.actualHighLabel}}:</td><td>{{getHighValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasLow(series)\"><td>{{series.actualLowLabel}}:</td><td>{{getLowValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasClose(series)\"><td>{{series.actualCloseLabel}}:</td><td>{{getCloseValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasVolume(series)\"><td>{{series.actualVolumeLabel}}:</td><td>{{getVolumeValue(series, item)}}</td></tr>\n            </table>\n        </div>\n    </ng-template>    \n    <ng-template #scatterTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">   \n            <span [style.color]=\"getBrush(series)\">{{series.title}}</span>\n            <br/>\n            <span *ngIf=\"hasRadius(series)\">({{getXValue(series, item)}}, {{getYValue(series, item)}}), {{series.actualRadiusLabel}}: {{getRadiusValue(series, item)}}</span>\n            <span *ngIf=\"!hasRadius(series)\">x: {{getXValue(series, item)}}</span>\n            <br *ngIf=\"!hasRadius(series)\"/>\n            <span *ngIf=\"!hasRadius(series)\">y: {{getYValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #polarTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">\n            <span>{{getAngleValue(series, item)}}</span>\n            <br/>\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: {{getRadiusValue(series, item)}}</span> \n        </div>\n    </ng-template>\n    <ng-template #radialTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">\n            <span>{{series.angleAxis.label}}</span>\n            <br/>\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: {{getAnchoredValue(series, item)}}</span> \n        </div>\n    </ng-template>    \n    <ng-template #rangeTooltip let-series=\"series\" let-item=\"item\">\n    <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n        <span *ngIf=\"series.xAxis.isDateTime\">{{shortDate(series.xAxis.getItemValue(asAny(item), 'dateTimeMemberPath'))}}</span>\n        <br *ngIf=\"series.xAxis.isDateTime\" />\n        <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>\n        <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n        <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n        <span class=\"ui-tooltip-priority\">{{getLowValue(series, item)}} - {{getHighValue(series, item)}}</span>\n    </div>\n    </ng-template>    \n    <ng-template #shapeTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">   \n            <span [style.color]=\"getBrush(series)\">{{series.title}}</span>\n            <br *ngIf=\"hasXY(series, item)\"/>\n            <span *ngIf=\"hasXY(series, item)\">({{getXValue(series, item)}}, {{getYValue(series, item)}})</span>\n            <br *ngIf=\"hasColor(series)\"/>\n            <span *ngIf=\"hasColor(series)\">{{series.actualValueLabel}}: {{getColorValue(series, item)}}</span>\n            <br *ngIf=\"hasValue(series)\"/>\n            <span *ngIf=\"hasValue(series)\">{{series.actualValueLabel}}: {{item}}</span>\n        </div>\n    </ng-template>\n  ", isInline: true, directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxDataChartDefaultTooltipsComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartDefaultTooltipsComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-data-chart-default-tooltips',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: "\n    <ng-template #anchoredCategoryTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n            <span *ngIf=\"series.xAxis.isDateTime\">{{shortDate(series.xAxis.getItemValue(asAny(item),'dateTimeMemberPath'))}}</span>\n            <br *ngIf=\"series.xAxis.isDateTime\" />\n            <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>\n            <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <span class=\"ui-tooltip-priority\">{{getAnchoredValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #anchoredVerticalCategoryTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n            <span *ngIf=\"series.yAxis.isDateTime\">{{shortDate(series.yAxis.getItemValue(asAny(item), 'dateTimeMemberPath'))}}</span>\n            <br *ngIf=\"series.yAxis.isDateTime\" />\n            <span *ngIf=\"!series.yAxis.isDateTime && series.yAxis.label\">{{format(series.yAxis.getItemValue(asAny(item), 'label'))}}</span>\n            <br *ngIf=\"!series.yAxis.isDateTime && series.yAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <span class=\"ui-tooltip-priority\">{{getAnchoredValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #financialTooltip let-series=\"series\" let-item=\"item\" let-itemLabel=\"itemLabel\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n            <span *ngIf=\"series.xAxis.isDateTime\">{{itemLabel}}</span>\n            <br *ngIf=\"series.xAxis.isDateTime\" />\n            <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>\n            <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <table>\n                <tr *ngIf=\"hasOpen(series)\"><td>{{series.actualOpenLabel}}:</td><td>{{getOpenValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasHigh(series)\"><td>{{series.actualHighLabel}}:</td><td>{{getHighValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasLow(series)\"><td>{{series.actualLowLabel}}:</td><td>{{getLowValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasClose(series)\"><td>{{series.actualCloseLabel}}:</td><td>{{getCloseValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasVolume(series)\"><td>{{series.actualVolumeLabel}}:</td><td>{{getVolumeValue(series, item)}}</td></tr>\n            </table>\n        </div>\n    </ng-template>    \n    <ng-template #scatterTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">   \n            <span [style.color]=\"getBrush(series)\">{{series.title}}</span>\n            <br/>\n            <span *ngIf=\"hasRadius(series)\">({{getXValue(series, item)}}, {{getYValue(series, item)}}), {{series.actualRadiusLabel}}: {{getRadiusValue(series, item)}}</span>\n            <span *ngIf=\"!hasRadius(series)\">x: {{getXValue(series, item)}}</span>\n            <br *ngIf=\"!hasRadius(series)\"/>\n            <span *ngIf=\"!hasRadius(series)\">y: {{getYValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #polarTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">\n            <span>{{getAngleValue(series, item)}}</span>\n            <br/>\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: {{getRadiusValue(series, item)}}</span> \n        </div>\n    </ng-template>\n    <ng-template #radialTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">\n            <span>{{series.angleAxis.label}}</span>\n            <br/>\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: {{getAnchoredValue(series, item)}}</span> \n        </div>\n    </ng-template>    \n    <ng-template #rangeTooltip let-series=\"series\" let-item=\"item\">\n    <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">            \n        <span *ngIf=\"series.xAxis.isDateTime\">{{shortDate(series.xAxis.getItemValue(asAny(item), 'dateTimeMemberPath'))}}</span>\n        <br *ngIf=\"series.xAxis.isDateTime\" />\n        <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>\n        <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n        <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n        <span class=\"ui-tooltip-priority\">{{getLowValue(series, item)}} - {{getHighValue(series, item)}}</span>\n    </div>\n    </ng-template>    \n    <ng-template #shapeTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\" style=\"white-space:nowrap\">   \n            <span [style.color]=\"getBrush(series)\">{{series.title}}</span>\n            <br *ngIf=\"hasXY(series, item)\"/>\n            <span *ngIf=\"hasXY(series, item)\">({{getXValue(series, item)}}, {{getYValue(series, item)}})</span>\n            <br *ngIf=\"hasColor(series)\"/>\n            <span *ngIf=\"hasColor(series)\">{{series.actualValueLabel}}: {{getColorValue(series, item)}}</span>\n            <br *ngIf=\"hasValue(series)\"/>\n            <span *ngIf=\"hasValue(series)\">{{series.actualValueLabel}}: {{item}}</span>\n        </div>\n    </ng-template>\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { anchoredCategoryTooltip: [{
                    type: i0.ViewChild,
                    args: ["anchoredCategoryTooltip", { static: true }]
                }], anchoredVerticalCategoryTooltip: [{
                    type: i0.ViewChild,
                    args: ["anchoredVerticalCategoryTooltip", { static: true }]
                }], financialTooltip: [{
                    type: i0.ViewChild,
                    args: ["financialTooltip", { static: true }]
                }], polarTooltip: [{
                    type: i0.ViewChild,
                    args: ["polarTooltip", { static: true }]
                }], radialTooltip: [{
                    type: i0.ViewChild,
                    args: ["radialTooltip", { static: true }]
                }], rangeTooltip: [{
                    type: i0.ViewChild,
                    args: ["rangeTooltip", { static: true }]
                }], scatterTooltip: [{
                    type: i0.ViewChild,
                    args: ["scatterTooltip", { static: true }]
                }], shapeTooltip: [{
                    type: i0.ViewChild,
                    args: ["shapeTooltip", { static: true }]
                }], onContentReady: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartInteractivityModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartInteractivityModule() {
            i2.TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
            InteractivityFactoryManager.register();
            i2.TypeRegistrar.registerCons('IgxDataChartDefaultTooltipsComponent', IgxDataChartDefaultTooltipsComponent);
        }
        IgxDataChartInteractivityModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartInteractivityModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityModule, declarations: [IgxDataChartDefaultTooltipsComponent], imports: [i1.CommonModule, i2.IgxDVInteractivityModule], exports: [IgxDataChartDefaultTooltipsComponent,
                i2.IgxDVInteractivityModule] });
        IgxDataChartInteractivityModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityModule, imports: [[i1.CommonModule, i2.IgxDVInteractivityModule
                ], i2.IgxDVInteractivityModule] });
        return IgxDataChartInteractivityModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxDataChartDefaultTooltipsComponent],
                        exports: [IgxDataChartDefaultTooltipsComponent,
                            i2.IgxDVInteractivityModule
                        ],
                        imports: [i1.CommonModule, i2.IgxDVInteractivityModule
                        ],
                        entryComponents: [IgxDataChartDefaultTooltipsComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartInteractivityDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartInteractivityDynamicModule() {
            i2.TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
            InteractivityFactoryManager.register();
            i2.TypeRegistrar.registerCons('IgxDataChartDefaultTooltipsComponent', IgxDataChartDefaultTooltipsComponent);
        }
        IgxDataChartInteractivityDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartInteractivityDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityDynamicModule, imports: [i1.CommonModule, i2.IgxDVInteractivityDynamicModule,
                IgxDataChartInteractivityModule], exports: [i2.IgxDVInteractivityDynamicModule,
                IgxDataChartInteractivityModule] });
        IgxDataChartInteractivityDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityDynamicModule, imports: [[i1.CommonModule, i2.IgxDVInteractivityDynamicModule,
                    IgxDataChartInteractivityModule
                ], i2.IgxDVInteractivityDynamicModule,
                IgxDataChartInteractivityModule] });
        return IgxDataChartInteractivityDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartInteractivityDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxDVInteractivityDynamicModule,
                            IgxDataChartInteractivityModule
                        ],
                        imports: [i1.CommonModule, i2.IgxDVInteractivityDynamicModule,
                            IgxDataChartInteractivityModule
                        ],
                        entryComponents: [IgxDataChartDefaultTooltipsComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrendLineManager_$type = new i2.Type(null, 'ITrendLineManager');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendLineManagerBase$1 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrendLineManagerBase$1, _super);
        function TrendLineManagerBase$1($tTrendColumn) {
            var _this = _super.call(this) || this;
            _this.$tTrendColumn = null;
            _this.d = null;
            _this.a = null;
            _this.g = ((function () {
                var $ret = new i2.Polyline();
                $ret.ab = false;
                return $ret;
            })());
            _this.$tTrendColumn = $tTrendColumn;
            _this.$type = _this.$type.specialize(_this.$tTrendColumn);
            _this.d = new i2.List$1(_this.$tTrendColumn, 0);
            return _this;
        }
        Object.defineProperty(TrendLineManagerBase$1.prototype, "g$j", {
            get: function () {
                return this.g;
            },
            enumerable: false,
            configurable: true
        });
        TrendLineManagerBase$1.prototype.g$g = function (a) {
            this.g$h(a, null);
        };
        TrendLineManagerBase$1.prototype.c = function (a) {
            return a == 1 || a == 2 || a == 3 || a == 4 || a == 5 || a == 6 || a == 7 || a == 8;
        };
        TrendLineManagerBase$1.prototype.b = function (a) {
            return a == 9 || a == 10 || a == 11 || a == 12 || a == 13;
        };
        TrendLineManagerBase$1.prototype.g$h = function (a, b) {
            var e_1, _a;
            this.g$j.ak.clear();
            if (b != null) {
                b.i = this.g$j.ak;
            }
            if (a != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        if (!i2.isNaN_(c.x) && !i2.isNaN_(c.y)) {
                            if (b != null) {
                                b.j(c);
                            }
                            else {
                                this.g$j.ak.add(c);
                            }
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            this.g$j.ab = this.g$j.ak.count > 0;
        };
        TrendLineManagerBase$1.prototype.e = function (a, b, c) {
            this.f(a, b, c, null);
        };
        TrendLineManagerBase$1.prototype.f = function (a, b, c, d) {
            var e_2, _a;
            if (d != null) {
                d.i = c;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(i2.Flattener.d(a.count, function (f) { return a.item(f).x; }, function (f) { return a.item(f).y; }, b.b))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (d != null) {
                        d.j(a.item(e));
                    }
                    else {
                        c.add(a.item(e));
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        TrendLineManagerBase$1.prototype.g$c = function (a, b) {
            if (a == null || b == null) {
                return;
            }
            if (this.g$j.x != null) {
                this.g$f();
            }
            a.ab.add(this.g$j);
        };
        TrendLineManagerBase$1.prototype.g$f = function () {
            if (this.g$j == null) {
                return;
            }
            var a = i2.typeCast(i2.Panel.$, this.g$j.x);
            if (a != null) {
                a.ab.remove(this.g$j);
            }
        };
        TrendLineManagerBase$1.prototype.g$d = function () {
            this.g$j.ak.clear();
        };
        TrendLineManagerBase$1.prototype.g$i = function () {
            this.a = null;
            this.d.clear();
        };
        TrendLineManagerBase$1.prototype.g$e = function (a, b, c, d) {
            switch (a) {
                case 3:
                case 2:
                case 1:
                case 0:
                case 4:
                    this.g$i();
                    break;
            }
        };
        TrendLineManagerBase$1.prototype.g$b = function (a, b, c, d) {
            var e = false;
            switch (b) {
                case "TrendLineType":
                case "TrendLinePeriod":
                    this.g$i();
                    e = true;
                    break;
                case "TrendLineThickness":
                    e = true;
                    break;
                case Series.$$p[13]:
                    e = true;
                    this.g$i();
                    break;
            }
            return e;
        };
        TrendLineManagerBase$1.$t = i2.markType(TrendLineManagerBase$1, 'TrendLineManagerBase$1', i2.Base.$, [ITrendLineManager_$type]);
        return TrendLineManagerBase$1;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendResolutionParams = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrendResolutionParams, _super);
        function TrendResolutionParams() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = 0;
            _this.e = 0;
            _this.c = 0;
            _this.f = null;
            _this.g = null;
            _this.b = 0;
            _this.a = 0;
            return _this;
        }
        TrendResolutionParams.$t = i2.markType(TrendResolutionParams, 'TrendResolutionParams');
        return TrendResolutionParams;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryTrendLineManagerBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryTrendLineManagerBase, _super);
        function CategoryTrendLineManagerBase() {
            return _super.call(this, i2.Number_$type) || this;
        }
        CategoryTrendLineManagerBase.prototype.get_g$a = function () {
            return 0;
        };
        Object.defineProperty(CategoryTrendLineManagerBase.prototype, "g$a", {
            get: function () {
                return this.get_g$a();
            },
            enumerable: false,
            configurable: true
        });
        CategoryTrendLineManagerBase.prototype.prepareLine = function (a, b, c, d) {
            var e = b.k;
            var f = new ScalerParams(0, b.m, b.l, b.b.j$a, e);
            var g = new ScalerParams(0, b.m, b.l, b.c.j$a, e);
            if (i2.typeCast(Series.$, a) !== null) {
                g.b = a.f2();
            }
            var h = c.f;
            if (b.d != null && b.d.i$b != null) {
                h = new SafeSortedReadOnlyDoubleCollection(0, h, b.d.i$b);
            }
            var i = ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = b.h;
                $ret.d = b.i;
                $ret.e = b.j;
                $ret.a = d;
                $ret.b = b.g;
                $ret.f = b.l;
                return $ret;
            })());
            if (a.trendLineType != 0) {
                if (a.isVertical) {
                    this.prepareLineCore(b.a.p, a.trendLineType, h, a.trendLinePeriod, function (j) { return b.c.j$b(j, g); }, function (j) { return b.b.j$b(j, f); }, i);
                }
                else {
                    this.prepareLineCore(b.a.p, a.trendLineType, h, a.trendLinePeriod, function (j) { return b.b.j$b(j, f); }, function (j) { return b.c.j$b(j, g); }, i);
                }
            }
        };
        CategoryTrendLineManagerBase.$t = i2.markType(CategoryTrendLineManagerBase, 'CategoryTrendLineManagerBase', TrendLineManagerBase$1.$.specialize(i2.Number_$type), [IPreparesCategoryTrendline_$type]);
        return CategoryTrendLineManagerBase;
    }(TrendLineManagerBase$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendFitCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrendFitCalculator, _super);
        function TrendFitCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TrendFitCalculator.a = function (a, b, c, d, e, f, g, h, i, j, k) {
            if (d == null) {
                switch (b) {
                    case 1:
                        d = i2.LeastSquaresFit.k(e, f, g);
                        break;
                    case 2:
                        d = i2.LeastSquaresFit.o(e, f, g);
                        break;
                    case 3:
                        d = i2.LeastSquaresFit.i(e, f, g);
                        break;
                    case 4:
                        d = i2.LeastSquaresFit.p(e, f, g);
                        break;
                    case 5:
                        d = i2.LeastSquaresFit.q(e, f, g);
                        break;
                    case 7:
                        d = i2.LeastSquaresFit.j(e, f, g);
                        break;
                    case 6:
                        d = i2.LeastSquaresFit.l(e, f, g);
                        break;
                    case 8:
                        d = i2.LeastSquaresFit.n(e, f, g);
                        break;
                    default: throw new i2.NotImplementedException(0);
                }
            }
            if (d == null) {
                return null;
            }
            for (var l = 0; l < c.f.width; l += 2) {
                var m = l / (c.f.width - 1);
                var n = j + m * (k - j);
                var o = NaN;
                switch (b) {
                    case 1:
                        o = i2.LeastSquaresFit.ad(d, n);
                        break;
                    case 2:
                        o = i2.LeastSquaresFit.ah(d, n);
                        break;
                    case 3:
                        o = i2.LeastSquaresFit.ab(d, n);
                        break;
                    case 4:
                        o = i2.LeastSquaresFit.ai(d, n);
                        break;
                    case 5:
                        o = i2.LeastSquaresFit.aj(d, n);
                        break;
                    case 7:
                        o = i2.LeastSquaresFit.ac(d, n);
                        break;
                    case 6:
                        o = i2.LeastSquaresFit.ae(d, n);
                        break;
                    case 8:
                        o = i2.LeastSquaresFit.ag(d, n);
                        break;
                    default: throw new i2.NotImplementedException(0);
                }
                n = h(n);
                o = i(o);
                if (!i2.isNaN_(o) && !i2.isInfinity(o)) {
                    a.add({ $type: i2.Point_$type, x: n + c.a, y: o });
                }
            }
            return d;
        };
        TrendFitCalculator.$t = i2.markType(TrendFitCalculator, 'TrendFitCalculator');
        return TrendFitCalculator;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendAverageCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrendAverageCalculator, _super);
        function TrendAverageCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TrendAverageCalculator.a = function (a, b, c) {
            var d;
            switch (a) {
                case 9:
                case 10:
                case 11:
                case 13:
                    if (c < 1) {
                        c = 1;
                    }
                    break;
            }
            switch (a) {
                case 9:
                    d = i2.TrendCalculators.e(b, c);
                    break;
                case 10:
                    d = i2.TrendCalculators.b(b, c);
                    break;
                case 11:
                    d = i2.TrendCalculators.c(b, c);
                    break;
                case 12:
                    d = i2.TrendCalculators.a(b);
                    break;
                case 13:
                    d = i2.TrendCalculators.g(b, c);
                    break;
                default: throw new i2.NotImplementedException(0);
            }
            return d;
        };
        TrendAverageCalculator.b = function (a, b, c, d) {
            var e_1, _a;
            if (b.count == 0) {
                var e = TrendAverageCalculator.a(a, c, d);
                try {
                    for (var _b = tslib.__values(i2.fromEnum(e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var f = _c.value;
                        b.add(f);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        TrendAverageCalculator.c = function (a, b, c, d, e) {
            if (b.count == 0) {
                var f = i2.getEnumerator(TrendAverageCalculator.a(a, c, e));
                var g = i2.getEnumerator(TrendAverageCalculator.a(a, d, e));
                while (f.moveNext() && g.moveNext()) {
                    b.add({ $type: i2.Point_$type, x: f.current, y: g.current });
                }
            }
        };
        TrendAverageCalculator.$t = i2.markType(TrendAverageCalculator, 'TrendAverageCalculator');
        return TrendAverageCalculator;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryTrendLineManager, _super);
        function CategoryTrendLineManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CategoryTrendLineManager.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
            var h = g.d * g.c;
            var i = g.e * g.c;
            var j = new i2.List$1(i2.Point_$type, 0);
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(j, b, g, this.a, c.count, function (k) { return (k + 1); }, function (k) { return c.item(k); }, function (k) { return e(k - 1); }, f, h + 1, i + 1);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.b(b, this.d, c, d);
                for (var k = g.d; k <= g.e; k += 1) {
                    var l = k * g.c;
                    if (l >= 0 && l < this.d.count) {
                        var m = e(l);
                        var n = f(this.d._inner[l]);
                        j.add({ $type: i2.Point_$type, x: m + g.a, y: n });
                    }
                }
            }
            this.e(j, g, a);
        };
        CategoryTrendLineManager.$t = i2.markType(CategoryTrendLineManager, 'CategoryTrendLineManager', CategoryTrendLineManagerBase.$);
        return CategoryTrendLineManager;
    }(CategoryTrendLineManagerBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SortingTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SortingTrendLineManager, _super);
        function SortingTrendLineManager(a, b) {
            var _this = _super.call(this) || this;
            _this.h = null;
            _this.i = null;
            _this.h = a;
            _this.i = b;
            return _this;
        }
        SortingTrendLineManager.prototype.get_g$a = function () {
            return 1;
        };
        SortingTrendLineManager.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
            var _this = this;
            var h = g.d * g.c;
            var i = g.e * g.c;
            var j = new i2.List$1(i2.Point_$type, 0);
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(j, b, g, this.a, c.count, function (k) { return (k + 1); }, function (k) { return c.item(k); }, function (k) {
                    var l = i2.truncate(Math.floor(k));
                    var m = i2.truncate(Math.ceil(k));
                    var n = k - l;
                    var o;
                    if (m <= i) {
                        o = _this.h(l) + n * (_this.h(m) - _this.h(l));
                    }
                    else {
                        o = _this.h(l) + n * (_this.h(i2.truncate(i)) - _this.h(l));
                    }
                    return e(o);
                }, f, h, i);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.b(b, this.d, c, d);
                for (var k = g.d; k <= g.e; k += 1) {
                    var l = k * g.c;
                    var m = this.h(l);
                    if (l >= 0 && l < this.d.count) {
                        var n = e(m);
                        var o = f(this.d._inner[l]);
                        j.add({ $type: i2.Point_$type, x: n + g.a, y: o });
                    }
                }
            }
            this.e(j, g, a);
        };
        SortingTrendLineManager.$t = i2.markType(SortingTrendLineManager, 'SortingTrendLineManager', CategoryTrendLineManagerBase.$);
        return SortingTrendLineManager;
    }(CategoryTrendLineManagerBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCategoryTrendLineModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCategoryTrendLineModule() {
            i2.TypeRegistrar.register('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory.$type);
            i2.TypeRegistrar.register('CategoryTrendLineManager', CategoryTrendLineManager.$type);
            i2.TypeRegistrar.register('SortingTrendLineManager', SortingTrendLineManager.$type);
        }
        IgxDataChartCategoryTrendLineModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCategoryTrendLineModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineModule, imports: [i1.CommonModule] });
        IgxDataChartCategoryTrendLineModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineModule, imports: [[i1.CommonModule,
                ]] });
        return IgxDataChartCategoryTrendLineModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCategoryTrendLineDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCategoryTrendLineDynamicModule() {
            i2.TypeRegistrar.registerCons('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory);
            i2.TypeRegistrar.registerCons('CategoryTrendLineManager', CategoryTrendLineManager);
            i2.TypeRegistrar.registerCons('SortingTrendLineManager', SortingTrendLineManager);
            i2.TypeRegistrar.register('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory.$type);
            i2.TypeRegistrar.register('CategoryTrendLineManager', CategoryTrendLineManager.$type);
            i2.TypeRegistrar.register('SortingTrendLineManager', SortingTrendLineManager.$type);
        }
        IgxDataChartCategoryTrendLineDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCategoryTrendLineDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineDynamicModule, imports: [i1.CommonModule, IgxDataChartCategoryTrendLineModule], exports: [IgxDataChartCategoryTrendLineModule] });
        IgxDataChartCategoryTrendLineDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineDynamicModule, imports: [[i1.CommonModule, IgxDataChartCategoryTrendLineModule
                ], IgxDataChartCategoryTrendLineModule] });
        return IgxDataChartCategoryTrendLineDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryTrendLineDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxDataChartCategoryTrendLineModule
                        ],
                        imports: [i1.CommonModule, IgxDataChartCategoryTrendLineModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartAnnotationModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartAnnotationModule() {
            i2.TypeRegistrar.register('AnnotationFactoryManager', AnnotationFactoryManager.$type);
        }
        IgxDataChartAnnotationModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartAnnotationModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationModule, imports: [i1.CommonModule, IgxCrosshairLayerModule,
                IgxCategoryToolTipLayerModule,
                IgxItemToolTipLayerModule,
                IgxCategoryItemHighlightLayerModule,
                IgxCategoryHighlightLayerModule,
                IgxFinalValueLayerModule,
                IgxCalloutLayerModule], exports: [IgxCrosshairLayerModule,
                IgxCategoryToolTipLayerModule,
                IgxItemToolTipLayerModule,
                IgxCategoryItemHighlightLayerModule,
                IgxCategoryHighlightLayerModule,
                IgxFinalValueLayerModule,
                IgxCalloutLayerModule] });
        IgxDataChartAnnotationModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationModule, imports: [[i1.CommonModule, IgxCrosshairLayerModule,
                    IgxCategoryToolTipLayerModule,
                    IgxItemToolTipLayerModule,
                    IgxCategoryItemHighlightLayerModule,
                    IgxCategoryHighlightLayerModule,
                    IgxFinalValueLayerModule,
                    IgxCalloutLayerModule
                ], IgxCrosshairLayerModule,
                IgxCategoryToolTipLayerModule,
                IgxItemToolTipLayerModule,
                IgxCategoryItemHighlightLayerModule,
                IgxCategoryHighlightLayerModule,
                IgxFinalValueLayerModule,
                IgxCalloutLayerModule] });
        return IgxDataChartAnnotationModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCrosshairLayerModule,
                            IgxCategoryToolTipLayerModule,
                            IgxItemToolTipLayerModule,
                            IgxCategoryItemHighlightLayerModule,
                            IgxCategoryHighlightLayerModule,
                            IgxFinalValueLayerModule,
                            IgxCalloutLayerModule
                        ],
                        imports: [i1.CommonModule, IgxCrosshairLayerModule,
                            IgxCategoryToolTipLayerModule,
                            IgxItemToolTipLayerModule,
                            IgxCategoryItemHighlightLayerModule,
                            IgxCategoryHighlightLayerModule,
                            IgxFinalValueLayerModule,
                            IgxCalloutLayerModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartAnnotationDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartAnnotationDynamicModule() {
            i2.TypeRegistrar.registerCons('AnnotationFactoryManager', AnnotationFactoryManager);
            i2.TypeRegistrar.register('AnnotationFactoryManager', AnnotationFactoryManager.$type);
        }
        IgxDataChartAnnotationDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartAnnotationDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationDynamicModule, imports: [i1.CommonModule, IgxCrosshairLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxDataChartAnnotationModule], exports: [IgxCrosshairLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxDataChartAnnotationModule] });
        IgxDataChartAnnotationDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationDynamicModule, imports: [[i1.CommonModule, IgxCrosshairLayerDynamicModule,
                    IgxCategoryToolTipLayerDynamicModule,
                    IgxItemToolTipLayerDynamicModule,
                    IgxCategoryItemHighlightLayerDynamicModule,
                    IgxCategoryHighlightLayerDynamicModule,
                    IgxFinalValueLayerDynamicModule,
                    IgxCalloutLayerDynamicModule,
                    IgxDataChartAnnotationModule
                ], IgxCrosshairLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxDataChartAnnotationModule] });
        return IgxDataChartAnnotationDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartAnnotationDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCrosshairLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxDataChartAnnotationModule
                        ],
                        imports: [i1.CommonModule, IgxCrosshairLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxDataChartAnnotationModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryChartModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryChartModule() {
        }
        IgxCategoryChartModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryChartModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartModule, imports: [i1.CommonModule, IgxCategoryChartCoreModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorModule,
                IgxDataChartInteractivityModule,
                IgxDataChartCategoryTrendLineModule,
                IgxDataChartAnnotationModule], exports: [IgxCategoryChartCoreModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorModule,
                IgxDataChartInteractivityModule,
                IgxDataChartCategoryTrendLineModule,
                IgxDataChartAnnotationModule] });
        IgxCategoryChartModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartModule, imports: [[i1.CommonModule, IgxCategoryChartCoreModule,
                    IgxLineSeriesDynamicModule,
                    IgxAreaSeriesDynamicModule,
                    IgxColumnSeriesDynamicModule,
                    IgxSplineSeriesDynamicModule,
                    IgxSplineAreaSeriesDynamicModule,
                    IgxStepLineSeriesDynamicModule,
                    IgxStepAreaSeriesDynamicModule,
                    IgxPointSeriesDynamicModule,
                    IgxWaterfallSeriesDynamicModule,
                    IgxCrosshairLayerDynamicModule,
                    IgxCalloutLayerDynamicModule,
                    IgxItemToolTipLayerDynamicModule,
                    IgxCategoryToolTipLayerDynamicModule,
                    IgxCategoryHighlightLayerDynamicModule,
                    IgxCategoryItemHighlightLayerDynamicModule,
                    IgxFinalValueLayerDynamicModule,
                    IgxNumberAbbreviatorModule,
                    IgxDataChartInteractivityModule,
                    IgxDataChartCategoryTrendLineModule,
                    IgxDataChartAnnotationModule
                ], IgxCategoryChartCoreModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorModule,
                IgxDataChartInteractivityModule,
                IgxDataChartCategoryTrendLineModule,
                IgxDataChartAnnotationModule] });
        return IgxCategoryChartModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryChartCoreModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxSplineSeriesDynamicModule,
                            IgxSplineAreaSeriesDynamicModule,
                            IgxStepLineSeriesDynamicModule,
                            IgxStepAreaSeriesDynamicModule,
                            IgxPointSeriesDynamicModule,
                            IgxWaterfallSeriesDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorModule,
                            IgxDataChartInteractivityModule,
                            IgxDataChartCategoryTrendLineModule,
                            IgxDataChartAnnotationModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryChartCoreModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxSplineSeriesDynamicModule,
                            IgxSplineAreaSeriesDynamicModule,
                            IgxStepLineSeriesDynamicModule,
                            IgxStepAreaSeriesDynamicModule,
                            IgxPointSeriesDynamicModule,
                            IgxWaterfallSeriesDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorModule,
                            IgxDataChartInteractivityModule,
                            IgxDataChartCategoryTrendLineModule,
                            IgxDataChartAnnotationModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryChartDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryChartDynamicModule() {
        }
        IgxCategoryChartDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryChartDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartDynamicModule, imports: [i1.CommonModule, IgxCategoryChartCoreDynamicModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxDataChartCategoryTrendLineDynamicModule,
                IgxDataChartAnnotationDynamicModule,
                IgxCategoryChartModule], exports: [IgxCategoryChartCoreDynamicModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxDataChartCategoryTrendLineDynamicModule,
                IgxDataChartAnnotationDynamicModule,
                IgxCategoryChartModule] });
        IgxCategoryChartDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartDynamicModule, imports: [[i1.CommonModule, IgxCategoryChartCoreDynamicModule,
                    IgxLineSeriesDynamicModule,
                    IgxAreaSeriesDynamicModule,
                    IgxColumnSeriesDynamicModule,
                    IgxSplineSeriesDynamicModule,
                    IgxSplineAreaSeriesDynamicModule,
                    IgxStepLineSeriesDynamicModule,
                    IgxStepAreaSeriesDynamicModule,
                    IgxPointSeriesDynamicModule,
                    IgxWaterfallSeriesDynamicModule,
                    IgxCrosshairLayerDynamicModule,
                    IgxCalloutLayerDynamicModule,
                    IgxItemToolTipLayerDynamicModule,
                    IgxCategoryToolTipLayerDynamicModule,
                    IgxCategoryHighlightLayerDynamicModule,
                    IgxCategoryItemHighlightLayerDynamicModule,
                    IgxFinalValueLayerDynamicModule,
                    IgxNumberAbbreviatorDynamicModule,
                    IgxDataChartInteractivityDynamicModule,
                    IgxDataChartCategoryTrendLineDynamicModule,
                    IgxDataChartAnnotationDynamicModule,
                    IgxCategoryChartModule
                ], IgxCategoryChartCoreDynamicModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxDataChartCategoryTrendLineDynamicModule,
                IgxDataChartAnnotationDynamicModule,
                IgxCategoryChartModule] });
        return IgxCategoryChartDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryChartDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryChartCoreDynamicModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxSplineSeriesDynamicModule,
                            IgxSplineAreaSeriesDynamicModule,
                            IgxStepLineSeriesDynamicModule,
                            IgxStepAreaSeriesDynamicModule,
                            IgxPointSeriesDynamicModule,
                            IgxWaterfallSeriesDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxDataChartCategoryTrendLineDynamicModule,
                            IgxDataChartAnnotationDynamicModule,
                            IgxCategoryChartModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryChartCoreDynamicModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxSplineSeriesDynamicModule,
                            IgxSplineAreaSeriesDynamicModule,
                            IgxStepLineSeriesDynamicModule,
                            IgxStepAreaSeriesDynamicModule,
                            IgxPointSeriesDynamicModule,
                            IgxWaterfallSeriesDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxDataChartCategoryTrendLineDynamicModule,
                            IgxDataChartAnnotationDynamicModule,
                            IgxCategoryChartModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RangeValueList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeValueList, _super);
        function RangeValueList(a, b) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = null;
            _this.a = a;
            _this.b = b;
            return _this;
        }
        RangeValueList.prototype.indexOf = function (a) {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.insert = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.removeAt = function (a) {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                var b_1 = NaN;
                var c = NaN;
                if (this.a != null && a >= 0 && a < this.a.count) {
                    b_1 = this.a.item(a);
                }
                if (this.b != null && a >= 0 && a < this.b.count) {
                    c = this.b.item(a);
                }
                var d = i2.isNaN_(b_1);
                var e = i2.isNaN_(c);
                if (!d && !e) {
                    return (b_1 + c) / 2;
                }
                if (!d) {
                    return b_1;
                }
                if (!e) {
                    return c;
                }
                return NaN;
            }
        };
        RangeValueList.prototype.add = function (a) {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.clear = function () {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.contains = function (a) {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.copyTo = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        Object.defineProperty(RangeValueList.prototype, "count", {
            get: function () {
                var a = 0;
                var b = 0;
                if (this.a != null) {
                    a = this.a.count;
                }
                if (this.b != null) {
                    b = this.b.count;
                }
                var c = 0;
                c = Math.max(c, a);
                c = Math.max(c, b);
                return c;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeValueList.prototype, "isReadOnly", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        RangeValueList.prototype.remove = function (a) {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.getEnumerator = function () {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.prototype.getEnumeratorObject = function () {
            throw new i2.NotImplementedException(0);
        };
        RangeValueList.$t = i2.markType(RangeValueList, 'RangeValueList', i2.Base.$, [i2.IList$1_$type.specialize(i2.Number_$type)]);
        return RangeValueList;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Tooltip = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Tooltip, _super);
        function Tooltip() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._updateToolTip = null;
            _this._hideToolTip = null;
            return _this;
        }
        Object.defineProperty(Tooltip.prototype, "updateToolTip", {
            get: function () {
                return this._updateToolTip;
            },
            set: function (a) {
                this._updateToolTip = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Tooltip.prototype, "hideToolTip", {
            get: function () {
                return this._hideToolTip;
            },
            set: function (a) {
                this._hideToolTip = a;
            },
            enumerable: false,
            configurable: true
        });
        Tooltip.$t = i2.markType(Tooltip, 'Tooltip', HTMLElement.$);
        return Tooltip;
    }(HTMLElement));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IDomainChartWidget_$type = new i2.Type(null, 'IDomainChartWidget');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available types of domain charts.
     */
    var DomainType = /*@__PURE__*/ (function (DomainType) {
        /**
         * Specifies category domain for Category Chart
         */
        DomainType[DomainType["Category"] = 0] = "Category";
        /**
         * Specifies financial domain for Financial Chart
         */
        DomainType[DomainType["Financial"] = 1] = "Financial";
        /**
         * Specifies scatter domain for Scatter Charts
         */
        DomainType[DomainType["Scatter"] = 2] = "Scatter";
        /**
         * Specifies shape domain for Shape Charts
         */
        DomainType[DomainType["Shape"] = 3] = "Shape";
        return DomainType;
    })({});
    /**
     * @hidden
     */
    var DomainType_$type = i2.markEnum('DomainType', 'Category,0|Financial,1|Scatter,2|Shape,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieChartStyleInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartStyleInfo, _super);
        function PieChartStyleInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.f = null;
            _this.g = null;
            _this.c = null;
            _this.h = null;
            _this.i = null;
            _this.e = 0;
            _this.d = 0;
            return _this;
        }
        PieChartStyleInfo.$t = i2.markType(PieChartStyleInfo, 'PieChartStyleInfo');
        return PieChartStyleInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieSliceVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieSliceVisualData, _super);
        function PieSliceVisualData() {
            var _this = _super.call(this) || this;
            _this._startAngle = 0;
            _this._endAngle = 0;
            _this._origin = null;
            _this._explodedOrigin = null;
            _this._radius = 0;
            _this._explodedRadius = 0;
            _this._innerExtentStart = 0;
            _this._innerExtentEnd = 0;
            _this._isSelected = false;
            _this._isExploded = false;
            _this._isOthersSlice = false;
            _this._index = 0;
            _this._label = null;
            _this._labelAngle = 0;
            _this._labelBounds = null;
            _this._appearance = null;
            _this._labelAppearance = null;
            _this._leaderLineAppearance = null;
            _this._slicePath = null;
            _this._leaderLinePath = null;
            _this.labelBounds = i2.RectData.empty;
            return _this;
        }
        Object.defineProperty(PieSliceVisualData.prototype, "startAngle", {
            get: function () {
                return this._startAngle;
            },
            set: function (a) {
                this._startAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "endAngle", {
            get: function () {
                return this._endAngle;
            },
            set: function (a) {
                this._endAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "origin", {
            get: function () {
                return this._origin;
            },
            set: function (a) {
                this._origin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "explodedOrigin", {
            get: function () {
                return this._explodedOrigin;
            },
            set: function (a) {
                this._explodedOrigin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "radius", {
            get: function () {
                return this._radius;
            },
            set: function (a) {
                this._radius = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "explodedRadius", {
            get: function () {
                return this._explodedRadius;
            },
            set: function (a) {
                this._explodedRadius = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "innerExtentStart", {
            get: function () {
                return this._innerExtentStart;
            },
            set: function (a) {
                this._innerExtentStart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "innerExtentEnd", {
            get: function () {
                return this._innerExtentEnd;
            },
            set: function (a) {
                this._innerExtentEnd = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "isSelected", {
            get: function () {
                return this._isSelected;
            },
            set: function (a) {
                this._isSelected = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "isExploded", {
            get: function () {
                return this._isExploded;
            },
            set: function (a) {
                this._isExploded = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "isOthersSlice", {
            get: function () {
                return this._isOthersSlice;
            },
            set: function (a) {
                this._isOthersSlice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "index", {
            get: function () {
                return this._index;
            },
            set: function (a) {
                this._index = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "label", {
            get: function () {
                return this._label;
            },
            set: function (a) {
                this._label = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "labelAngle", {
            get: function () {
                return this._labelAngle;
            },
            set: function (a) {
                this._labelAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "labelBounds", {
            get: function () {
                return this._labelBounds;
            },
            set: function (a) {
                this._labelBounds = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "appearance", {
            get: function () {
                return this._appearance;
            },
            set: function (a) {
                this._appearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "labelAppearance", {
            get: function () {
                return this._labelAppearance;
            },
            set: function (a) {
                this._labelAppearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "leaderLineAppearance", {
            get: function () {
                return this._leaderLineAppearance;
            },
            set: function (a) {
                this._leaderLineAppearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "slicePath", {
            get: function () {
                return this._slicePath;
            },
            set: function (a) {
                this._slicePath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceVisualData.prototype, "leaderLinePath", {
            get: function () {
                return this._leaderLinePath;
            },
            set: function (a) {
                this._leaderLinePath = a;
            },
            enumerable: false,
            configurable: true
        });
        PieSliceVisualData.prototype.scaleByViewport = function (a) {
            if (this.slicePath != null) {
                this.slicePath.scaleByViewport(a);
            }
            if (this.leaderLinePath != null) {
                this.leaderLinePath.scaleByViewport(a);
            }
            if (!this.labelBounds.isEmpty) {
                var b = (this.labelBounds.left - a.left) / a.width;
                var c = (this.labelBounds.top - a.top) / a.height;
                var d = ((this.labelBounds.left + this.labelBounds.width) - a.left) / a.width;
                var e = ((this.labelBounds.top + this.labelBounds.height) - a.top) / a.height;
                this.labelBounds = new i2.RectData(b, c, d - b, e - c);
            }
            if (this.origin != null) {
                this.origin = new i2.PointData((this.origin.x - a.left) / a.width, (this.origin.y - a.top) / a.height);
            }
            if (this.explodedOrigin != null) {
                this.explodedOrigin = new i2.PointData((this.explodedOrigin.x - a.left) / a.width, (this.explodedOrigin.y - a.top) / a.height);
            }
        };
        PieSliceVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.label != null) {
                a.u("label: \"" + this.label + "\", ");
            }
            if (this.appearance != null) {
                a.u("appearance: " + this.appearance.serialize() + ", ");
            }
            if (this.labelAppearance != null) {
                a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
            }
            if (this.leaderLineAppearance != null) {
                a.u("leaderLineAppearance: " + this.leaderLineAppearance.serialize() + ", ");
            }
            if (this.slicePath != null) {
                a.u("slicePath: " + this.slicePath.serialize() + ", ");
            }
            if (this.leaderLinePath != null) {
                var b = this.leaderLinePath.serialize();
                if (b != null) {
                    a.u("leaderLinePath: " + b + ", ");
                }
            }
            a.u("labelAngle: " + this.labelAngle + ", ");
            a.u("labelBounds: { left: " + this.labelBounds.left + ", top: " + this.labelBounds.top + ", width: " + this.labelBounds.width + ", height: " + this.labelBounds.height + "}");
            a.u("}");
            return a.toString();
        };
        PieSliceVisualData.$t = i2.markType(PieSliceVisualData, 'PieSliceVisualData');
        return PieSliceVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieSliceVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieSliceVisualDataList, _super);
        function PieSliceVisualDataList() {
            return _super.call(this, PieSliceVisualData.$, 0) || this;
        }
        PieSliceVisualDataList.$t = i2.markType(PieSliceVisualDataList, 'PieSliceVisualDataList', i2.List$1.$.specialize(PieSliceVisualData.$));
        return PieSliceVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartVisualData, _super);
        function PieChartVisualData() {
            var _this = _super.call(this) || this;
            _this._slices = null;
            _this._othersSlice = null;
            _this._name = null;
            _this._viewport = null;
            _this._width = 0;
            _this._height = 0;
            _this._others = null;
            _this._radiusFactor = 0;
            _this._leaderLineMargin = 0;
            _this._isViewportScaled = false;
            _this._dipScalingRatio = 0;
            _this.slices = new PieSliceVisualDataList();
            _this.others = new i2.List$1(i2.Base.$, 0);
            _this.dipScalingRatio = 1;
            return _this;
        }
        Object.defineProperty(PieChartVisualData.prototype, "slices", {
            get: function () {
                return this._slices;
            },
            set: function (a) {
                this._slices = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "othersSlice", {
            get: function () {
                return this._othersSlice;
            },
            set: function (a) {
                this._othersSlice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (a) {
                this._width = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "others", {
            get: function () {
                return this._others;
            },
            set: function (a) {
                this._others = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "radiusFactor", {
            get: function () {
                return this._radiusFactor;
            },
            set: function (a) {
                this._radiusFactor = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "leaderLineMargin", {
            get: function () {
                return this._leaderLineMargin;
            },
            set: function (a) {
                this._leaderLineMargin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "isViewportScaled", {
            get: function () {
                return this._isViewportScaled;
            },
            set: function (a) {
                this._isViewportScaled = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartVisualData.prototype, "dipScalingRatio", {
            get: function () {
                return this._dipScalingRatio;
            },
            set: function (a) {
                this._dipScalingRatio = a;
            },
            enumerable: false,
            configurable: true
        });
        PieChartVisualData.prototype.scaleByViewport = function () {
            if (this.isViewportScaled) {
                return;
            }
            this.isViewportScaled = true;
            for (var a = 0; a < this.slices.count; a++) {
                this.slices._inner[a].scaleByViewport(this.viewport);
            }
            if (this.othersSlice != null) {
                this.othersSlice.scaleByViewport(this.viewport);
            }
        };
        PieChartVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("name: " + this.name + ",");
            a.u("leaderLineMargin: " + this.leaderLineMargin + ",");
            a.u("radiusFactor: " + this.radiusFactor + ",");
            a.u("width: " + this.width + ",");
            a.u("height: " + this.height + ",");
            a.u("isViewportScaled: " + (this.isViewportScaled ? "true" : "false") + ", ");
            a.u("slices: [");
            for (var b = 0; b < this.slices.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.slices._inner[b].serialize());
            }
            a.u("],");
            a.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}");
            a.l(", dipScalingRatio: " + this.dipScalingRatio.toString());
            a.u("}");
            return a.toString();
        };
        PieChartVisualData.$t = i2.markType(PieChartVisualData, 'PieChartVisualData');
        return PieChartVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available positions of labels.
     */
    var LabelsPosition = /*@__PURE__*/ (function (LabelsPosition) {
        /**
         * No labels will be displayed.
         */
        LabelsPosition[LabelsPosition["None"] = 0] = "None";
        /**
         * Labels will be displayed in the center.
         */
        LabelsPosition[LabelsPosition["Center"] = 1] = "Center";
        /**
         * Labels will be displayed inside and by the edge of the container.
         */
        LabelsPosition[LabelsPosition["InsideEnd"] = 2] = "InsideEnd";
        /**
         * Labels will be displayed outside the container.
         */
        LabelsPosition[LabelsPosition["OutsideEnd"] = 3] = "OutsideEnd";
        /**
         * Labels will automatically decide their location.
         */
        LabelsPosition[LabelsPosition["BestFit"] = 4] = "BestFit";
        return LabelsPosition;
    })({});
    /**
     * @hidden
     */
    var LabelsPosition_$type = i2.markEnum('LabelsPosition', 'None,0|Center,1|InsideEnd,2|OutsideEnd,3|BestFit,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of a callout line for the labels.
     */
    var LeaderLineType = /*@__PURE__*/ (function (LeaderLineType) {
        /**
         * A straight line is drawn between the slice and its label.
         */
        LeaderLineType[LeaderLineType["Straight"] = 0] = "Straight";
        /**
         * A curved line is drawn between the slice and its label. The line follows makes a natural turn from the slice to the label.
         */
        LeaderLineType[LeaderLineType["Arc"] = 1] = "Arc";
        /**
         * A curved line is drawn between the slice and its label. The line starts radially from the slice and then turns to the label.
         */
        LeaderLineType[LeaderLineType["Spline"] = 2] = "Spline";
        return LeaderLineType;
    })({});
    /**
     * @hidden
     */
    var LeaderLineType_$type = i2.markEnum('LeaderLineType', 'Straight,0|Arc,1|Spline,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors for calculating and grouping slices into the Others slice.
     */
    var OthersCategoryType = /*@__PURE__*/ (function (OthersCategoryType) {
        /**
         * Data value is compared directly to the value of OthersCategoryThreshold.
         */
        OthersCategoryType[OthersCategoryType["Number"] = 0] = "Number";
        /**
         * Data value is compared to OthersCategoryThreshold as a percentage of the total.
         */
        OthersCategoryType[OthersCategoryType["Percent"] = 1] = "Percent";
        return OthersCategoryType;
    })({});
    /**
     * @hidden
     */
    var OthersCategoryType_$type = i2.markEnum('OthersCategoryType', 'Number,0|Percent,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IndexCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IndexCollection, _super);
        function IndexCollection() {
            return _super.call(this, i2.Number_$type, 0) || this;
        }
        IndexCollection.prototype.r = function (a, b) {
            if (!this.contains(b)) {
                _super.prototype.r.call(this, a, b);
            }
        };
        IndexCollection.prototype.x = function (a, b) {
            if (this.contains(b)) {
                this.remove(b);
                this.r(a, b);
            }
            else {
                _super.prototype.x.call(this, a, b);
            }
        };
        IndexCollection.$t = i2.markType(IndexCollection, 'IndexCollection', i2.ObservableCollection$1.$.specialize(i2.Number_$type));
        return IndexCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available modes for selecting slices.
     */
    var SliceSelectionMode = /*@__PURE__*/ (function (SliceSelectionMode) {
        /**
         * Slices can be programmatically selected but cannot be selected through the UI.
         */
        SliceSelectionMode[SliceSelectionMode["Manual"] = 0] = "Manual";
        /**
         * Single slice can be selected through the UI.
         */
        SliceSelectionMode[SliceSelectionMode["Single"] = 1] = "Single";
        /**
         * Multiple slices can be selected through the UI.
         */
        SliceSelectionMode[SliceSelectionMode["Multiple"] = 2] = "Multiple";
        return SliceSelectionMode;
    })({});
    /**
     * @hidden
     */
    var SliceSelectionMode_$type = i2.markEnum('SliceSelectionMode', 'Manual,0|Single,1|Multiple,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SelectedItemChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SelectedItemChangedEventArgs, _super);
        function SelectedItemChangedEventArgs(a, b) {
            var _this = _super.call(this) || this;
            _this._oldItem = null;
            _this._newItem = null;
            _this.oldItem = a;
            _this.newItem = b;
            return _this;
        }
        Object.defineProperty(SelectedItemChangedEventArgs.prototype, "oldItem", {
            get: function () {
                return this._oldItem;
            },
            set: function (a) {
                this._oldItem = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SelectedItemChangedEventArgs.prototype, "newItem", {
            get: function () {
                return this._newItem;
            },
            set: function (a) {
                this._newItem = a;
            },
            enumerable: false,
            configurable: true
        });
        SelectedItemChangedEventArgs.$t = i2.markType(SelectedItemChangedEventArgs, 'SelectedItemChangedEventArgs', i2.EventArgs.$);
        return SelectedItemChangedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SelectedItemChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SelectedItemChangingEventArgs, _super);
        function SelectedItemChangingEventArgs(a, b) {
            var _this = _super.call(this, a, b) || this;
            _this._cancel = false;
            return _this;
        }
        Object.defineProperty(SelectedItemChangingEventArgs.prototype, "cancel", {
            get: function () {
                return this._cancel;
            },
            set: function (a) {
                this._cancel = a;
            },
            enumerable: false,
            configurable: true
        });
        SelectedItemChangingEventArgs.$t = i2.markType(SelectedItemChangingEventArgs, 'SelectedItemChangingEventArgs', SelectedItemChangedEventArgs.$);
        return SelectedItemChangingEventArgs;
    }(SelectedItemChangedEventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SelectedItemsChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SelectedItemsChangedEventArgs, _super);
        function SelectedItemsChangedEventArgs(a, b, c) {
            var _this = _super.call(this) || this;
            _this._oldItems = null;
            _this._newItems = null;
            _this._currentItems = null;
            _this.oldItems = a;
            _this.newItems = b;
            _this.currentItems = c;
            return _this;
        }
        Object.defineProperty(SelectedItemsChangedEventArgs.prototype, "oldItems", {
            get: function () {
                return this._oldItems;
            },
            set: function (a) {
                this._oldItems = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SelectedItemsChangedEventArgs.prototype, "newItems", {
            get: function () {
                return this._newItems;
            },
            set: function (a) {
                this._newItems = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SelectedItemsChangedEventArgs.prototype, "currentItems", {
            get: function () {
                return this._currentItems;
            },
            set: function (a) {
                this._currentItems = a;
            },
            enumerable: false,
            configurable: true
        });
        SelectedItemsChangedEventArgs.$t = i2.markType(SelectedItemsChangedEventArgs, 'SelectedItemsChangedEventArgs', i2.EventArgs.$);
        return SelectedItemsChangedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SelectedItemsChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SelectedItemsChangingEventArgs, _super);
        function SelectedItemsChangingEventArgs(a, b, c) {
            var _this = _super.call(this, a, b, c) || this;
            _this._cancel = false;
            return _this;
        }
        Object.defineProperty(SelectedItemsChangingEventArgs.prototype, "cancel", {
            get: function () {
                return this._cancel;
            },
            set: function (a) {
                this._cancel = a;
            },
            enumerable: false,
            configurable: true
        });
        SelectedItemsChangingEventArgs.$t = i2.markType(SelectedItemsChangingEventArgs, 'SelectedItemsChangingEventArgs', SelectedItemsChangedEventArgs.$);
        return SelectedItemsChangingEventArgs;
    }(SelectedItemsChangedEventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieChartMockDataItem = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartMockDataItem, _super);
        function PieChartMockDataItem() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._Label = null;
            _this._Value = 0;
            return _this;
        }
        Object.defineProperty(PieChartMockDataItem.prototype, "Label", {
            get: function () {
                return this._Label;
            },
            set: function (a) {
                this._Label = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartMockDataItem.prototype, "Value", {
            get: function () {
                return this._Value;
            },
            set: function (a) {
                this._Value = a;
            },
            enumerable: false,
            configurable: true
        });
        PieChartMockDataItem.$t = i2.markType(PieChartMockDataItem, 'PieChartMockDataItem');
        return PieChartMockDataItem;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieChartMockDataGenerator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartMockDataGenerator, _super);
        function PieChartMockDataGenerator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PieChartMockDataGenerator.a = function () {
            var a = new i2.List$1(PieChartMockDataItem.$, 0);
            a.add(((function () {
                var $ret = new PieChartMockDataItem();
                $ret.Label = "Item A";
                $ret.Value = 10;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new PieChartMockDataItem();
                $ret.Label = "Item B";
                $ret.Value = 4;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new PieChartMockDataItem();
                $ret.Label = "Item C";
                $ret.Value = 15;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new PieChartMockDataItem();
                $ret.Label = "Item D";
                $ret.Value = 7;
                return $ret;
            })()));
            a.add(((function () {
                var $ret = new PieChartMockDataItem();
                $ret.Label = "Item E";
                $ret.Value = 5;
                return $ret;
            })()));
            var arr_ = a.toArray();
            return arr_;
        };
        PieChartMockDataGenerator.$t = i2.markType(PieChartMockDataGenerator, 'PieChartMockDataGenerator');
        return PieChartMockDataGenerator;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieLegendTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieLegendTemplates, _super);
        function PieLegendTemplates() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PieLegendTemplates.f = function (a) {
            var b = a.data;
            var c = b.series;
            var d = c.legendItemBadgeTemplate;
            var e = b.legendLabel != null ? b.legendLabel : b.itemLabel;
            if (e == null) {
                e = "Pie Item";
            }
            i2.LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
        };
        PieLegendTemplates.c = function (a) {
            var b = a.data;
            var c = b.series;
            var d = c.legendItemBadgeTemplate;
            var e = b.legendLabel != null ? b.legendLabel : b.itemLabel;
            if (e == null) {
                e = "Doughnut Item";
            }
            i2.LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
        };
        PieLegendTemplates.a = function (a) {
        };
        PieLegendTemplates.d = function (a) {
        };
        PieLegendTemplates.e = function (a) {
            var b = a.data;
            var c = a.context;
            var d = new i2.RenderingContext(new i2.CanvasViewRenderer(), c);
            var e = b.series;
            var f = b.itemBrush;
            var g = b.outline;
            var h = b.thickness;
            var i = new i2.Rectangle();
            i.width = a.availableWidth - (h * 2) - 2;
            i.height = a.availableHeight - (h * 2);
            i.n = h + 1;
            i.o = h;
            i.ac = h;
            i._fill = f;
            i._stroke = g;
            d.v(i);
        };
        PieLegendTemplates.b = function (a) {
            var b = a.data;
            var c = a.context;
            var d = new i2.RenderingContext(new i2.CanvasViewRenderer(), c);
            var e = b.itemBrush;
            var f = b.outline;
            var g = b.thickness;
            var h = new i2.Rectangle();
            h.width = a.availableWidth - (g * 2) - 2;
            h.height = a.availableHeight - (g * 2);
            h.n = g + 1;
            h.o = g;
            h.ac = g;
            h._fill = e;
            h._stroke = f;
            d.v(h);
        };
        PieLegendTemplates.$t = i2.markType(PieLegendTemplates, 'PieLegendTemplates');
        return PieLegendTemplates;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PieChartViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartViewManager, _super);
        function PieChartViewManager(a) {
            var _this = _super.call(this) || this;
            _this.n = null;
            _this.p = null;
            _this.s = null;
            _this.r = null;
            _this.q = null;
            _this.k = 0;
            _this.j = 0;
            _this.l = 1;
            _this.ap = null;
            _this.e = null;
            _this.g = null;
            _this.f = null;
            _this.h = null;
            _this.a = null;
            _this.c = null;
            _this._toolTipObject = null;
            _this.u = null;
            _this.i = true;
            _this.a = a;
            return _this;
        }
        PieChartViewManager.prototype.aa = function () {
            var a = this.n.rootWrapper.width();
            var b = this.n.rootWrapper.height();
            this.ad(a, b);
        };
        PieChartViewManager.prototype.ad = function (a, b) {
            this.z();
            this.c.bg = new i2.Rect(0, 0, 0, a, b);
            var c = this.a.a.cz;
            if (c == this.l && a == this.k && b == this.j) {
                return;
            }
            this.k = a;
            this.j = b;
            this.l = c;
            this.a.ba();
        };
        PieChartViewManager.prototype.ae = function () {
            if (this.c != null) {
                this.c.bc(this.p, "");
            }
        };
        PieChartViewManager.prototype.ab = function () {
            this.z();
            if (this.c != null) {
                this.c.aq(this.p, "");
            }
        };
        PieChartViewManager.prototype.z = function () {
            var a = this.a.a.dc;
            var b = this.a.a.cz;
            if (!i2.isNaN_(a) && a != 0) {
                return;
            }
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
                this.a.a.cz = window.devicePixelRatio;
            }
        };
        PieChartViewManager.prototype.w = function (a, b) {
            var c = this.a.a.cz;
            if (a != this.k || b != this.j || c != this.l) {
                this.k = a;
                this.j = b;
                this.l = this.a.a.cz;
                this.ao();
            }
        };
        PieChartViewManager.prototype.ao = function () {
            this.ap = new i2.Rect(0, 0, 0, this.k, this.j);
            var a = this.k;
            var b = this.j;
            var c = this.l;
            if (c != 1) {
                a = Math.round(this.k * c);
                b = Math.round(this.j * c);
            }
            this.p.setAttribute("width", a.toString());
            this.p.setAttribute("height", b.toString());
            this.p.setStyleProperty("width", this.k.toString() + "px");
            this.p.setStyleProperty("height", this.j.toString() + "px");
            this.r.setAttribute("width", a.toString());
            this.r.setAttribute("height", b.toString());
            this.r.setStyleProperty("width", this.k.toString() + "px");
            this.r.setStyleProperty("height", this.j.toString() + "px");
            this.q.setAttribute("width", a.toString());
            this.q.setAttribute("height", b.toString());
            this.q.setStyleProperty("width", this.k.toString() + "px");
            this.q.setStyleProperty("height", this.j.toString() + "px");
            this.s.setAttribute("width", a.toString());
            this.s.setAttribute("height", b.toString());
            this.s.setStyleProperty("width", this.k.toString() + "px");
            this.s.setStyleProperty("height", this.j.toString() + "px");
            return this.ap;
        };
        PieChartViewManager.prototype.d = function () {
            return this.a.b.c;
        };
        PieChartViewManager.prototype.an = function () {
            var a = i2.DOMEventProxy.cz(this.n.rootWrapper);
            return { $type: i2.Point_$type, x: a.left, y: a.top };
        };
        PieChartViewManager.prototype.ah = function (a) {
            if (this.n != null) {
                this.n.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        };
        PieChartViewManager.prototype.b = function () {
            var _this = this;
            var a = new PieChartStyleInfo();
            var b;
            var c;
            var d = i2.BrushUtil.e("chart", this.n, b, c);
            b = d.p2;
            c = d.p3;
            a.a = b;
            a.b = c;
            this.n.startCSSQuery();
            a.f = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = _this.n.getCssDefaultPropertyValue("ui-chart-innerlabels", "color");
                return $ret;
            })());
            a.g = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = _this.n.getCssDefaultPropertyValue("ui-chart-outerlabels", "color");
                return $ret;
            })());
            this.n.endCSSQuery();
            a.c = i2.FontUtil.getFont(this.n);
            a.e = i2.DeviceUtils.g(6);
            a.i = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#00000033";
                return $ret;
            })());
            a.d = 1;
            return a;
        };
        PieChartViewManager.prototype.ai = function (a) {
            a._stroke = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#000000";
                return $ret;
            })());
            a._fill = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#222222";
                return $ret;
            })());
        };
        PieChartViewManager.prototype.ac = function (a) {
            if (a == null) {
                if (this.c != null) {
                    this.c.ar();
                }
                this.n = null;
                this.p = null;
                this.r = null;
                this.q = null;
                this.s = null;
                this.e = null;
                this.g = null;
                this.f = null;
                this.h = null;
                this.c = null;
                return;
            }
            var b = a;
            this.n = b;
            this.a.bb();
            this.a.bk();
            this.n.rootWrapper.setStyleProperty("position", "relative");
            this.n.rootWrapper.addClass("ui-corner-all");
            this.n.rootWrapper.addClass("ui-widget-content");
            this.p = this.n.createElement("canvas");
            this.p.setStyleProperty("position", "absolute");
            this.p.setStyleProperty("top", "0px");
            this.p.setStyleProperty("left", "0px");
            this.r = this.n.createElement("canvas");
            this.r.setStyleProperty("position", "absolute");
            this.r.setStyleProperty("top", "0px");
            this.r.setStyleProperty("left", "0px");
            this.q = this.n.createElement("canvas");
            this.q.setStyleProperty("position", "absolute");
            this.q.setStyleProperty("top", "0px");
            this.q.setStyleProperty("left", "0px");
            this.s = this.n.createElement("canvas");
            this.s.setStyleProperty("position", "absolute");
            this.s.setStyleProperty("top", "0px");
            this.s.setStyleProperty("left", "0px");
            this.n.append(this.p);
            this.n.append(this.r);
            this.n.append(this.q);
            this.n.append(this.s);
            this.e = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.n.get2DCanvasContext(this.p));
            this.g = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.n.get2DCanvasContext(this.r));
            this.f = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
            this.h = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.n.get2DCanvasContext(this.s));
            this.c = new i2.DOMEventProxy(this.s, this.n, false);
            var c = this.c;
            c.onMouseOver = i2.delegateCombine(c.onMouseOver, i2.runOn(this.a, this.a.aj));
            var d = this.c;
            d.onMouseLeave = i2.delegateCombine(d.onMouseLeave, i2.runOn(this.a, this.a.ai));
            var e = this.c;
            e.onMouseDown = i2.delegateCombine(e.onMouseDown, i2.runOn(this.a, this.a.ah));
            var f = this.c;
            f.onMouseUp = i2.delegateCombine(f.onMouseUp, i2.runOn(this.a, this.a.ak));
            this.c.ac = this.a.a.cc;
            this.ad(this.n.rootWrapper.width(), this.n.rootWrapper.height());
        };
        PieChartViewManager.prototype.v = function (a) {
            this.n.append(a);
        };
        PieChartViewManager.prototype.af = function (a) {
            if (this.c == null) {
                return;
            }
            this.c.ac = a;
        };
        PieChartViewManager.prototype.t = function () {
            return this.n;
        };
        PieChartViewManager.prototype.x = function (a) {
            a.width = this.k;
            a.height = this.j;
        };
        PieChartViewManager.prototype.ak = function (a) {
            this.u = null;
            this._toolTipObject = null;
            if (typeof a === 'string') {
                this.u = a;
            }
            else {
                this._toolTipObject = a;
                if (this._toolTipObject != null) {
                    this._toolTipObject.setStyleProperty("position", "absolute");
                    this._toolTipObject.setStyleProperty("white-space", "nowrap");
                    this._toolTipObject.setStyleProperty("top", "0");
                    this._toolTipObject.setStyleProperty("left", "0");
                    this._toolTipObject.setStyleProperty("z-index", "10000");
                }
            }
        };
        PieChartViewManager.prototype.aj = function (pos_, context_) {
            if (this._toolTipObject != null) {
                if (this.i) {
                    this.v(this._toolTipObject);
                    this.i = false;
                }
                context_.hideOthers = true;
                if (this._toolTipObject.updateToolTip) {
                    this._toolTipObject.updateToolTip(context_);
                }
                ;
                this._toolTipObject.setOffset(pos_.x, pos_.y);
            }
        };
        PieChartViewManager.prototype.y = function (a) {
            if (this._toolTipObject != null) {
                var context_ = a;
                if (this._toolTipObject.hideToolTip) {
                    this._toolTipObject.hideToolTip(context_);
                }
                ;
            }
        };
        PieChartViewManager.prototype.al = function (style_) {
            var a = null;
            var fillColor_ = null;
            if (style_ != null) {
                if (style_.fill) {
                    fillColor_ = style_.fill;
                }
                ;
                if (fillColor_ != null) {
                    a = i2.Brush.create(fillColor_);
                }
            }
            return a;
        };
        PieChartViewManager.prototype.am = function (style_) {
            var a = null;
            var outlineColor_ = null;
            if (style_ != null) {
                if (style_.stroke) {
                    outlineColor_ = style_.stroke;
                }
                ;
                if (outlineColor_ != null) {
                    a = i2.Brush.create(outlineColor_);
                }
            }
            return a;
        };
        PieChartViewManager.prototype.m = function (style_) {
            var actualOutlineThickness_ = NaN;
            if (style_ != null) {
                if (style_.strokeThickness) {
                    actualOutlineThickness_ = style_.strokeThickness;
                }
                ;
            }
            return actualOutlineThickness_;
        };
        PieChartViewManager.prototype.ag = function () {
        };
        PieChartViewManager.$t = i2.markType(PieChartViewManager, 'PieChartViewManager');
        return PieChartViewManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var LabelClickEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LabelClickEventArgs, _super);
        function LabelClickEventArgs(a, b) {
            var _this = _super.call(this) || this;
            _this._slice = null;
            _this.c = true;
            _this.slice = a;
            return _this;
        }
        Object.defineProperty(LabelClickEventArgs.prototype, "slice", {
            get: function () {
                return this._slice;
            },
            set: function (a) {
                this._slice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LabelClickEventArgs.prototype, "item", {
            get: function () {
                if (this.slice != null) {
                    return this.slice.dataContext;
                }
                else {
                    return null;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LabelClickEventArgs.prototype, "allowSliceClick", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        LabelClickEventArgs.$t = i2.markType(LabelClickEventArgs, 'LabelClickEventArgs', i2.EventArgs.$);
        return LabelClickEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var SliceClickEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceClickEventArgs, _super);
        function SliceClickEventArgs(a, b) {
            var _this = _super.call(this) || this;
            _this._slice = null;
            _this.d = false;
            _this.c = false;
            _this._originalEvent = null;
            _this.slice = a;
            _this.originalEvent = b;
            if (a == null) {
                return _this;
            }
            _this.d = a.isSelected;
            _this.c = a.isExploded;
            return _this;
        }
        Object.defineProperty(SliceClickEventArgs.prototype, "slice", {
            get: function () {
                return this._slice;
            },
            set: function (a) {
                this._slice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "isSelected", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
                this.slice.ai.gx(this.slice, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "isExploded", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
                this.slice.isExploded = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "isOthersSlice", {
            get: function () {
                return this.slice.isOthersSlice;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "index", {
            get: function () {
                return this.slice.a5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "dataContext", {
            get: function () {
                if (this.slice != null) {
                    return this.slice.dataContext;
                }
                return null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "originalEvent", {
            get: function () {
                return this._originalEvent;
            },
            set: function (a) {
                this._originalEvent = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "origin", {
            get: function () {
                return this.slice.isExploded ? this.slice.b3 : this.slice.b7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "radius", {
            get: function () {
                return this.slice.isExploded ? this.slice.ay : this.slice.a2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "bounds", {
            get: function () {
                return this.slice.isExploded ? this.slice.b9 : this.slice.cc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "startAngle", {
            get: function () {
                return this.slice.a3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "endAngle", {
            get: function () {
                return this.slice.ax;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "fill", {
            get: function () {
                return this.slice.b0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickEventArgs.prototype, "outline", {
            get: function () {
                return this.slice.b1;
            },
            enumerable: false,
            configurable: true
        });
        SliceClickEventArgs.$t = i2.markType(SliceClickEventArgs, 'SliceClickEventArgs', i2.EventArgs.$);
        return SliceClickEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var SliceEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceEventArgs, _super);
        function SliceEventArgs(a, b) {
            var _this = _super.call(this) || this;
            _this._slice = null;
            _this.d = false;
            _this.c = false;
            _this._originalEvent = null;
            _this.slice = a;
            _this.originalEvent = b;
            if (a == null) {
                return _this;
            }
            _this.d = a.isSelected;
            _this.c = a.isExploded;
            return _this;
        }
        Object.defineProperty(SliceEventArgs.prototype, "slice", {
            get: function () {
                return this._slice;
            },
            set: function (a) {
                this._slice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "isSelected", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
                this.slice.ai.gx(this.slice, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "isExploded", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
                this.slice.isExploded = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "isOthersSlice", {
            get: function () {
                return this.slice.isOthersSlice;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "index", {
            get: function () {
                return this.slice.a5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "origin", {
            get: function () {
                return this.slice.isExploded ? this.slice.b3 : this.slice.b7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "radius", {
            get: function () {
                return this.slice.isExploded ? this.slice.ay : this.slice.a2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "bounds", {
            get: function () {
                return this.slice.isExploded ? this.slice.b9 : this.slice.cc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "startAngle", {
            get: function () {
                return this.slice.a3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "endAngle", {
            get: function () {
                return this.slice.ax;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "fill", {
            get: function () {
                return this.slice.b0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "outline", {
            get: function () {
                return this.slice.b1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "dataContext", {
            get: function () {
                if (this.slice != null) {
                    if (this.slice.isOthersSlice) {
                        return this.slice.dataContext.toArray();
                    }
                    return this.slice.dataContext;
                }
                return null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceEventArgs.prototype, "originalEvent", {
            get: function () {
                return this._originalEvent;
            },
            set: function (a) {
                this._originalEvent = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceEventArgs.$t = i2.markType(SliceEventArgs, 'SliceEventArgs', i2.EventArgs.$);
        return SliceEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var PieLabel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieLabel, _super);
        function PieLabel() {
            var _this = _super.call(this) || this;
            _this.ah = null;
            _this.ao = null;
            _this.ai = 0;
            _this.aj = null;
            _this.ap = null;
            _this.aq = null;
            _this.ag = 0;
            return _this;
        }
        PieLabel.prototype.ak = function (a) {
            if (a.a.az == 3) {
                this.ao = a.b1(this);
                var b = i2.typeCast(i2.TextBlock.$, this.aj);
                var c = b.ak;
                a.a.gu();
                var d = this.ah.isExploded ? this.ah.b5 : this.ah.b7;
                var e = i2.GeometryUtil.m(d, this.ai, this.ah.a2 + a.a.c8);
                var f = a.b2.width;
                if (a.y(b) + e.x > f && e.x < f) {
                    while (c.length > 0 && a.y(b) + e.x > f) {
                        c = c.substr(0, c.length - 1);
                        b.ak = c;
                    }
                    if (c.length > 3) {
                        c = c.substr(0, c.length - 3);
                        c = c + "...";
                    }
                    else {
                        if (a.y("...") < this.ao.width) {
                            c = "...";
                        }
                        else {
                            c = i2.stringEmpty();
                        }
                    }
                }
                var g = new i2.TextBlock();
                g.ak = c;
                this.aj = g;
            }
        };
        PieLabel.prototype.al = function () {
        };
        PieLabel.prototype.am = function () {
            this.ap._visibility = this.ah.ai.i7 != 0 ? this.ah.ai.i7 : this.ah.aj._visibility;
            var a;
            var b = this.ah.ai.c9;
            var c = i2.GeometryUtil.m(this.ah.b6(), this.ai, this.ah.a2);
            this.ap.ak = c.x;
            this.ap.am = c.y;
            if (this.ai < 90 || this.ai >= 270) {
                a = { $type: i2.Point_$type, x: this.ao.left, y: (this.ao.top + this.ao.bottom) / 2 };
            }
            else {
                a = { $type: i2.Point_$type, x: this.ao.right, y: (this.ao.top + this.ao.bottom) / 2 };
            }
            if (b > 0) {
                var d = i2.GeometryUtil.g(c, a);
                if (b < d) {
                    a = i2.GeometryUtil.o(a, c, b);
                }
                else {
                    a = c;
                }
            }
            this.ap.al = a.x;
            this.ap.an = a.y;
        };
        PieLabel.prototype.an = function () {
            this.aq._visibility = this.ah.ai.i7 != 0 ? this.ah.ai.i7 : this.ah.aj._visibility;
            var a = this.ah.b6();
            var b = this.aq.ak.c._inner[0];
            var c = b._segments._inner[0];
            var d = this.ah.ai.c9;
            var e = (this.ao.top + this.ao.bottom) / 2;
            var f = i2.GeometryUtil.m(a, this.ai, this.ah.a2);
            var g = i2.GeometryUtil.m(a, this.ai, this.ah.a2 + this.ah.ai.c8 / 2);
            var h;
            var i;
            var j;
            var k = e;
            if (this.ai < 90 && this.ai >= 0) {
                h = { $type: i2.Point_$type, x: this.ao.left - 30, y: k };
                j = { $type: i2.Point_$type, x: this.ao.left, y: e };
            }
            else if (this.ai < 180 && this.ai >= 90) {
                h = { $type: i2.Point_$type, x: this.ao.right + 30, y: k };
                j = { $type: i2.Point_$type, x: this.ao.right, y: e };
            }
            else if (this.ai < 270 && this.ai >= 180) {
                h = { $type: i2.Point_$type, x: this.ao.right + 30, y: k };
                j = { $type: i2.Point_$type, x: this.ao.right, y: e };
            }
            else {
                h = { $type: i2.Point_$type, x: this.ao.left - 30, y: k };
                j = { $type: i2.Point_$type, x: this.ao.left, y: e };
            }
            if (d > 0) {
                var l = i2.GeometryUtil.g(f, j);
                if (d < l) {
                    i = i2.GeometryUtil.o(j, f, d);
                    var m = g.x - f.x;
                    var n = g.y - f.y;
                    g = i2.GeometryUtil.o(g, f, d);
                    var o = g.x - f.x;
                    var p = g.y - f.y;
                    if ((m > 0 && o < 0) || (m < 0 && o > 0) || (n > 0 && p < 0) || (n < 0 && p > 0)) {
                        g = f;
                    }
                    h = i2.GeometryUtil.o(h, f, d);
                    var q = i2.GeometryUtil.g(f, i) / i2.GeometryUtil.g(f, j);
                    h.x = f.x + (h.x - f.x) * q;
                    h.y = f.y + (h.y - f.y) * q;
                }
                else {
                    this.aq._visibility = 1;
                    return;
                }
            }
            else {
                i = j;
            }
            if (this.ai < 180 && this.ai >= 0) {
                if (g.y > h.y) {
                    g.y = f.y;
                }
            }
            else {
                if (g.y < h.y) {
                    g.y = f.y;
                }
            }
            b._startPoint = f;
            if (this.ah.ai.a0 == 1) {
                c.e = f;
            }
            else {
                c.e = g;
            }
            c.f = h;
            c.g = i;
        };
        PieLabel.$t = i2.markType(PieLabel, 'PieLabel', i2.Control.$);
        return PieLabel;
    }(i2.Control));
    /**
     * @hidden
     */
    var PieChartBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartBase, _super);
        function PieChartBase() {
            var _this = _super.call(this) || this;
            _this.a3 = null;
            _this.by = false;
            _this.b1 = false;
            _this.b0 = false;
            _this.b2 = false;
            _this.bz = false;
            _this.b5 = false;
            _this.b4 = false;
            _this.b3 = false;
            _this.a7 = null;
            _this.cr = null;
            _this.ct = null;
            _this.cs = null;
            _this.cu = null;
            _this.dh = null;
            _this.bo = null;
            _this.dj = 0;
            _this.db = 0;
            _this.dg = 0;
            _this.cl = null;
            _this.ck = null;
            _this.cj = null;
            _this.c1 = 0;
            _this.ci = null;
            _this.a6 = null;
            _this._xsr = null;
            _this.bm = null;
            _this.bn = null;
            _this.au = new IndexCollection();
            _this.av = new IndexCollection();
            _this.cw = NaN;
            _this.cv = 1;
            _this._selectedItems = null;
            _this.labelClick = null;
            _this.selectedItemChanging = null;
            _this.selectedItemsChanging = null;
            _this.selectedItemChanged = null;
            _this.selectedItemsChanged = null;
            _this.sliceClick = null;
            _this.bv = null;
            _this.bu = null;
            _this.i2 = null;
            _this.ap = null;
            _this.as = null;
            _this.aq = null;
            _this.ar = null;
            _this.cm = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.dk = null;
            _this.sliceEnter = null;
            _this.sliceLeave = null;
            _this.sliceHover = null;
            _this.dp = null;
            _this.i2 = i2.Rect.empty;
            var a = _this.a2();
            _this.gj(a);
            a.a1();
            _this.ab = PieChartBase.$;
            _this.cl = new i2.List$1(i2.Number_$type, 0);
            _this.ck = new i2.List$1(i2.Number_$type, 0);
            _this.cj = new i2.List$1(i2.Base.$, 0);
            _this.a7 = function (b, c) { return _this.gn(b, c.propertyName, c.oldValue, c.newValue); };
            _this.cr = function (b, c) {
                _this.gu();
                _this.gt();
            };
            _this.cs = function (b, c) {
                if (_this.b6) {
                    _this.gm();
                    _this.gl();
                    _this.gu();
                    _this.gs();
                }
            };
            _this.ct = function (b, c) { return _this.gw(c); };
            _this.cu = function (b, c) { return _this.gc(c); };
            _this.dh = function (b, c) { return _this.fs(c.action, c.position, c.count, c.propertyName); };
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, _this.a7);
            var b = _this.selectedSlices;
            b.collectionChanged = i2.delegateCombine(b.collectionChanged, _this.ct);
            _this.b2 = true;
            var c = _this.explodedSlices;
            c.collectionChanged = i2.delegateCombine(c.collectionChanged, _this.cs);
            _this.bz = true;
            _this.selectedItems = new i2.ObjectCollection(0);
            var d = _this.selectedItems;
            d.collectionChanged = i2.delegateCombine(d.collectionChanged, _this.cu);
            _this.bv = ((function () {
                var $ret = new i2.Pool$1(Slice.$);
                $ret.create = i2.runOn(_this.a3, _this.a3.g);
                $ret.activate = i2.runOn(_this.a3, _this.a3.be);
                $ret.disactivate = i2.runOn(_this.a3, _this.a3.bg);
                $ret.destroy = i2.runOn(_this.a3, _this.a3.bf);
                return $ret;
            })());
            _this.bu = ((function () {
                var $ret = new i2.Pool$1(PieLabel.$);
                $ret.create = i2.runOn(_this.a3, _this.a3.d);
                $ret.activate = i2.runOn(_this.a3, _this.a3.ar);
                $ret.disactivate = i2.runOn(_this.a3, _this.a3.at);
                $ret.destroy = i2.runOn(_this.a3, _this.a3.as);
                return $ret;
            })());
            _this.a6 = new PieChartSliceSelector(_this);
            i2.FastItemObjectColumn.m();
            return _this;
        }
        PieChartBase.prototype.a2 = function () {
            return new PieChartBaseView(this);
        };
        PieChartBase.prototype.gj = function (a) {
            this.a3 = a;
        };
        PieChartBase.prototype.onDetachedFromUI = function () {
            this.a3.a0();
        };
        PieChartBase.prototype.onAttachedToUI = function () {
            this.a3.ax();
        };
        Object.defineProperty(PieChartBase.prototype, "bt", {
            get: function () {
                return this.bo;
            },
            set: function (a) {
                if (this.bo != a) {
                    var b = this.bo;
                    this.bo = a;
                    this.gp("ValueColumn", b, this.bo);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "cy", {
            get: function () {
                return Math.abs(this.c7) > 1 ? this.c7 : this.c7 * 100;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "XSRP", {
            get: function () {
                if (this._xsr == null) {
                    this._xsr = new i2.SRProvider(this.a3.c.n);
                }
                return this._xsr;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "d6", {
            get: function () {
                var a = this.XSRP.b1("InvalidLabelBinding");
                if (i2.stringIsNullOrWhiteSpace(a)) {
                    a = "There is no such value for the labels to bind.";
                }
                return a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "c7", {
            get: function () {
                return this.c(PieChartBase.hk);
            },
            set: function (a) {
                var b = a;
                if (i2.isNaN_(a) || i2.isInfinity(a)) {
                    b = 0;
                }
                if (a < 0) {
                    b = 0;
                }
                if (a > 100) {
                    b = 100;
                }
                this.h(PieChartBase.hk, b);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "bp", {
            get: function () {
                return this.bm;
            },
            set: function (a) {
                if (this.bm != a) {
                    var b = this.bp;
                    this.bm = a;
                    this.gp("LabelColumn", b, this.bp);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "bq", {
            get: function () {
                return this.bn;
            },
            set: function (a) {
                if (this.bn != a) {
                    var b = this.bq;
                    this.bn = a;
                    this.gp("LegendLabelColumn", b, this.bq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "cx", {
            get: function () {
                var a = this.c2;
                if (i2.isNaN_(a) || i2.isInfinity(a) || a < 0) {
                    return 0;
                }
                if (a > 1) {
                    return 1;
                }
                return a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "c0", {
            get: function () {
                var a = this.dd;
                if (i2.isNaN_(a) || i2.isInfinity(a) || a < 0) {
                    return 0;
                }
                if (a > 1) {
                    return 1;
                }
                return a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "explodedSlices", {
            get: function () {
                return this.au;
            },
            set: function (a) {
                var b = this.au;
                if (b != null) {
                    var c = this.au;
                    c.collectionChanged = i2.delegateRemove(c.collectionChanged, this.cs);
                }
                this.bz = false;
                this.au = a;
                if (this.au != null) {
                    var d = this.au;
                    d.collectionChanged = i2.delegateCombine(d.collectionChanged, this.cs);
                    this.bz = true;
                }
                if (this.b6) {
                    this.gm();
                    this.gl();
                    this.gu();
                    this.gs();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "selectedSlices", {
            get: function () {
                return this.av;
            },
            set: function (a) {
                var b = this.av;
                b.collectionChanged = i2.delegateRemove(b.collectionChanged, this.ct);
                this.b2 = false;
                this.av = a;
                if (this.av != null) {
                    var c = this.av;
                    c.collectionChanged = i2.delegateCombine(c.collectionChanged, this.ct);
                    this.b2 = true;
                }
                if (this.b7) {
                    this.gm();
                    this.gl();
                    this.gu();
                    this.gs();
                    this.gt();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "g7", {
            get: function () {
                return i2.typeCast(i2.DataTemplate.$, this.c(PieChartBase.hu));
            },
            set: function (a) {
                this.h(PieChartBase.hu, a);
            },
            enumerable: false,
            configurable: true
        });
        PieChartBase.prototype.b9 = function () {
            return this.a4 != null;
        };
        PieChartBase.prototype.ca = function () {
            return this.a5 != null;
        };
        Object.defineProperty(PieChartBase.prototype, "dc", {
            get: function () {
                return this.cw;
            },
            set: function (a) {
                var b = this.cw;
                this.cw = a;
                this.gp("PixelScalingRatio", b, this.cw);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "cz", {
            get: function () {
                return this.cv;
            },
            set: function (a) {
                var b = this.cv;
                this.cv = a;
                this.gp("ActualPixelScalingRatio", b, this.cv);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "selectedItem", {
            get: function () {
                return this.c(PieChartBase.ig);
            },
            set: function (a) {
                this.h(PieChartBase.ig, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "selectedItems", {
            get: function () {
                return this._selectedItems;
            },
            set: function (a) {
                this._selectedItems = a;
            },
            enumerable: false,
            configurable: true
        });
        PieChartBase.prototype.f8 = function (a, b) {
            if (this.labelClick != null) {
                this.labelClick(a, b);
            }
        };
        PieChartBase.prototype.ga = function (a, b) {
            if (this.selectedItemChanging != null) {
                this.selectedItemChanging(a, b);
            }
        };
        PieChartBase.prototype.gd = function (a, b) {
            if (this.selectedItemsChanging != null) {
                this.selectedItemsChanging(a, b);
            }
        };
        PieChartBase.prototype.f9 = function (a, b) {
            if (this.selectedItemChanged != null) {
                this.selectedItemChanged(a, b);
            }
        };
        PieChartBase.prototype.gb = function (a, b) {
            if (this.selectedItemsChanged != null) {
                this.selectedItemsChanged(a, b);
            }
        };
        PieChartBase.prototype.gf = function (a, b) {
            if (this.sliceClick != null) {
                this.sliceClick(a, b);
            }
        };
        PieChartBase.prototype.fu = function (a, b) {
            if (!this.bz) {
                return;
            }
            if (!this.explodedSlices.contains(a.a5) && b) {
                this.explodedSlices.add(a.a5);
            }
            if (this.explodedSlices.contains(a.a5) && !b) {
                this.explodedSlices.remove(a.a5);
            }
        };
        PieChartBase.prototype.gx = function (a, b) {
            this.b4 = true;
            if (!this.selectedSlices.contains(a.a5) && b) {
                this.selectedSlices.add(a.a5);
            }
            if (this.selectedSlices.contains(a.a5) && !b) {
                this.selectedSlices.remove(a.a5);
            }
            this.b4 = false;
        };
        PieChartBase.prototype.gy = function (a) {
            this.a3.bc(a);
        };
        PieChartBase.prototype.dl = function (a) {
            return this.a3.ad(a);
        };
        PieChartBase.prototype.i1 = function (a, b) {
            var c = new i2.Rect(0, 0, 0, 0, 0);
            return c;
        };
        PieChartBase.prototype.b8 = function (a, b) {
            var c = a.ah;
            if (c == null) {
                return false;
            }
            var d = c.b6();
            var e = this.iw == 1 ? c.a3 : c.ax;
            var f = this.iw == 1 ? c.ax : c.a3;
            var g = false;
            var h = false;
            var i = i2.GeometryUtil.m(d, e, c.a2);
            var j = i2.GeometryUtil.m(d, f, c.a2);
            e = PieChartBase.c3(i.x, d.x, i.y, d.y);
            f = PieChartBase.c3(j.x, d.x, j.y, d.y);
            if (this.cb(c)) {
                h = true;
            }
            var k;
            k = i2.MathUtil.e(a.ao.right - d.x, a.ao.top - d.y);
            if (k > c.a2) {
                return false;
            }
            k = i2.MathUtil.e(a.ao.right - d.x, a.ao.bottom - d.y);
            if (k > c.a2) {
                return false;
            }
            k = i2.MathUtil.e(a.ao.left - d.x, a.ao.top - d.y);
            if (k > c.a2) {
                return false;
            }
            k = i2.MathUtil.e(a.ao.left - d.x, a.ao.bottom - d.y);
            if (k > c.a2) {
                return false;
            }
            if (h) {
                return true;
            }
            if (e > f) {
                e = e - 360;
                g = true;
            }
            var l;
            l = PieChartBase.c3(a.ao.right, d.x, a.ao.top, d.y);
            if (g && l > 180 && l < 360) {
                l = l - 360;
            }
            if (l < e || l > f) {
                return false;
            }
            l = PieChartBase.c3(a.ao.right, d.x, a.ao.bottom, d.y);
            if (g && l > 180 && l < 360) {
                l = l - 360;
            }
            if (l < e || l > f) {
                return false;
            }
            l = PieChartBase.c3(a.ao.left, d.x, a.ao.top, d.y);
            if (g && l > 180 && l < 360) {
                l = l - 360;
            }
            if (l < e || l > f) {
                return false;
            }
            l = PieChartBase.c3(a.ao.left, d.x, a.ao.bottom, d.y);
            if (g && l > 180 && l < 360) {
                l = l - 360;
            }
            if (l < e || l > f) {
                return false;
            }
            return true;
        };
        PieChartBase.de = function (a) {
            var b = Math.round(a * Math.pow(10, 5)) / Math.pow(10, 5);
            return b;
        };
        PieChartBase.prototype.cb = function (a) {
            return PieChartBase.de(Math.abs(a.ax - a.a3)) == 360;
        };
        PieChartBase.c3 = function (a, b, c, d) {
            var e = i2.MathUtil.e(a - b, c - d);
            var f = Math.asin((c - d) / e) * 180 / Math.PI;
            if (a < b) {
                f = 180 - f;
            }
            if (a > b) {
                f = 360 + f;
            }
            if (f == 360) {
                f = 0;
            }
            return i2.GeometryUtil.i(f);
        };
        PieChartBase.g3 = function (a) {
            var b = new Array(a.count);
            for (var c = 0; c < a.count; c++) {
                var d = a._inner[c];
                var e = d.ah;
                var f = i2.GeometryUtil.m(e.b7, d.ai, e.a2);
                b[c] = f.y;
            }
            for (var g = 0; g < a.count; g++) {
                for (var h = g + 1; h < a.count; h++) {
                    if (b[g] >= b[h]) {
                        var i = a._inner[g];
                        a._inner[g] = a._inner[h];
                        a._inner[h] = i;
                        var j = b[g];
                        b[g] = b[h];
                        b[h] = j;
                    }
                }
            }
        };
        PieChartBase.prototype.gv = function (a) {
            var e_1, _a, e_2, _b;
            if (a.count == 0) {
                return;
            }
            var b = this.a3.b2.width;
            var c = this.a3.b2.height;
            var d = a.count;
            var e = a._inner[0].ah.a2;
            var f = a._inner[0].ah.b6();
            var g = true;
            var h = 0;
            var i = Number.POSITIVE_INFINITY;
            var j = Number.NEGATIVE_INFINITY;
            for (var k = 0; k < d - 1; k++) {
                var l = a._inner[k];
                var m = a._inner[k + 1];
                if (l.ao.intersectsWith(m.ao)) {
                    h++;
                }
            }
            var n = 0;
            try {
                for (var _c = tslib.__values(i2.fromEnum(a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var o = _d.value;
                    i = Math.min(i, o.ao.height);
                    j = Math.max(j, o.ao.height);
                    n += o.ao.height;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            if (n > c) {
                g = false;
            }
            if (g && h > 0) {
                for (var p = 0; p < d - 1; p++) {
                    for (var q = p + 1; q < d; q++) {
                        var r = a._inner[p];
                        var s = a._inner[q];
                        if (r.ao.intersectsWith(s.ao)) {
                            var t = s.ao;
                            t.y = Math.min(r.ao.bottom + 0.01, c - i);
                            var u = this.c8 + e;
                            var v = Math.abs(f.y - (t.y + i / 2));
                            var w = Math.sqrt(Math.abs(u * u - v * v));
                            var x = i2.GeometryUtil.i(s.ai);
                            if (x > 90 && x < 270) {
                                w = (t.width + w) * -1;
                            }
                            t.x = f.x + w;
                            s.ao = t;
                        }
                    }
                }
                for (var y = d - 1; y > 0; y--) {
                    for (var z = y - 1; z >= 0; z--) {
                        var aa = a._inner[y];
                        var ab = a._inner[z];
                        if (aa.ao.intersectsWith(ab.ao)) {
                            var ac = ab.ao;
                            ac.y = Math.max(aa.ao.top - i - 0.01, 0);
                            var ad = this.c8 + e;
                            var ae = Math.abs(f.y - (ac.y + i / 2));
                            var af = Math.sqrt(Math.abs(ad * ad - ae * ae));
                            var ag = i2.GeometryUtil.i(ab.ai);
                            if (ag > 90 && ag < 270) {
                                af = (ac.width + af) * -1;
                            }
                            ac.x = f.x + af;
                            ab.ao = ac;
                        }
                    }
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var ah = _f.value;
                    var ai = ah.ao;
                    if (ai.left > b || ai.right < 0) {
                        ah._visibility = 1;
                        if (this.a0 == 0) {
                            ah.ap._visibility = 1;
                        }
                        else {
                            ah.aq._visibility = 1;
                        }
                    }
                    else if (ai.left < 0) {
                        var aj = Math.abs(ai.x);
                        ai.x = 0;
                        if (aj > ai.width) {
                            ai.width = 0;
                        }
                        else {
                        }
                        ah.ao = ai;
                    }
                    else if (ai.right > b) {
                        var ak = ai.right - b;
                        if (ak > ai.width) {
                            ai.width = 0;
                        }
                        else {
                            ai.width = ai.width - ak;
                        }
                        ah.ao = ai;
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        PieChartBase.prototype.fs = function (a, b, c, d) {
            this.gr();
        };
        PieChartBase.prototype.gr = function () {
            this.gk();
            this.gm();
            this.gl();
            this.gu();
            this.gs();
            this.gt();
            this.a3.br();
        };
        PieChartBase.prototype.gk = function () {
            var e_3, _a;
            this.dg = 0;
            this.db = 0;
            this.cl.clear();
            this.ck.clear();
            this.cj.clear();
            if (this.actualItemsSource == null || this.bk == null) {
                return;
            }
            if (this.bt == null || this.bt.count == 0) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.bt)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (i2.isNaN_(a) || i2.isInfinity(a) || a <= 0) {
                        continue;
                    }
                    this.dg = this.dg + a;
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            for (var b = 0; b < this.bt.count; b++) {
                var c = this.bt.item(b);
                var d = c <= 0;
                if (i2.isNaN_(c) || i2.isInfinity(c) || d) {
                    continue;
                }
                var e = this.a1 == 1 ? c / this.dg : c;
                var f = this.a1 == 1 ? this.da / 100 : this.da;
                var g = true;
                if (e <= f && g) {
                    this.db = this.db + c;
                    this.ck.add(b);
                    this.cj.add1(this.bk.item(b));
                }
                else {
                    this.cl.add(b);
                }
            }
        };
        PieChartBase.prototype.gm = function () {
            if (this.actualItemsSource == null || this.bk == null) {
                this.bv.count = 0;
                return;
            }
            var a = this.cl.count;
            var b = this.ck.count > 0;
            var c = PieChartBase.de(this.c1);
            var d = PieChartBase.de(this.c1);
            if (b) {
                a++;
            }
            this.dj = a;
            for (var e = 0; e < a; e++) {
                var f = false;
                var g = void 0;
                if (e == a - 1 && b) {
                    g = this.db;
                    f = true;
                }
                else {
                    g = this.bt.item(this.cl._inner[e]);
                }
                if (this.iw == 1) {
                    d += PieChartBase.de(Math.abs(g) * 360 / this.dg);
                }
                else {
                    d -= PieChartBase.de(Math.abs(g) * 360 / this.dg);
                }
                var h = this.bv.item(e);
                h.aw = true;
                h.a3 = c;
                h.ax = d;
                h.a1 = this.cy;
                h.a0 = this.cy;
                h.isOthersSlice = f;
                h.ay = this.cx;
                h.a5 = e;
                h.dataContext = f ? this.cj : this.bk.item(this.cl._inner[e]);
                this.a6.j(h);
                h.isExploded = this.bz ? this.explodedSlices.contains(e) : false;
                c = d;
                h.aw = false;
            }
            this.bv.count = a;
        };
        PieChartBase.prototype.fc = function () {
            var a = this.XSRP.b7;
            if (i2.stringIsNullOrWhiteSpace(a)) {
                a = "Others";
            }
            return this.e1 != null ? this.e1 : a;
        };
        PieChartBase.prototype.gl = function () {
            var _this = this;
            if (this.actualItemsSource == null || this.bk == null) {
                this.bu.count = 0;
                return;
            }
            if (this.bp == null || this.bp.count == 0 || this.az == 0) {
                this.bu.count = 0;
            }
            var a = this.cl.count;
            if (this.ck.count > 0) {
                a++;
            }
            this.a3.au();
            var b = 0;
            var _loop_1 = function (c) {
                var d = i2.stringEmpty();
                var e = false;
                var f;
                var g = null;
                if (c == a - 1 && this_1.ck.count > 0) {
                    f = this_1.fc();
                    e = true;
                    if (this_1.b9() || this_1.ap != null || this_1.as != null) {
                        var h = ((function () {
                            var $ret = new PieSliceDataContext();
                            $ret.series = _this;
                            $ret.item = e ? _this.cj : _this.bk.item(_this.cl._inner[c]);
                            $ret.percentValue = _this.c6(_this.bv.item(c));
                            $ret.isOthersSlice = e;
                            return $ret;
                        })());
                        if (f != null) {
                            h.itemLabel = f.toString();
                            h.legendLabel = f.toString();
                        }
                        var i = h;
                        i = i.flatten();
                        if (this_1.ap != null && !e) {
                            f = this_1.ap.i(i);
                        }
                        else if (this_1.as != null && e) {
                            f = this_1.as.i(i);
                        }
                        else if (this_1.b9()) {
                            f = this_1.a4(i);
                        }
                    }
                    if (null != f) {
                        d = f.toString();
                    }
                    else {
                        d = this_1.fc();
                    }
                }
                else {
                    if (this_1.bp != null && this_1.bp.count >= this_1.cl.count) {
                        f = this_1.bp.item(this_1.cl._inner[c]);
                    }
                    else {
                        f = null;
                    }
                    g = (this_1.bq != null && this_1.bq.count > 0) ? this_1.bq.item(this_1.cl._inner[c]) : null;
                    if (this_1.b9() || this_1.ap != null || this_1.as != null) {
                        var j = ((function () {
                            var $ret = new PieSliceDataContext();
                            $ret.series = _this;
                            $ret.item = e ? _this.cj : _this.bk.item(_this.cl._inner[c]);
                            $ret.itemLabel = f != null ? f.toString() : null;
                            $ret.legendLabel = g != null ? g.toString() : f != null ? f.toString() : null;
                            $ret.percentValue = _this.c6(_this.bv.item(c));
                            $ret.isOthersSlice = e;
                            return $ret;
                        })());
                        var k = j;
                        k = k.flatten();
                        var formattedLabel_ = null;
                        if ((this_1.ap != null && !e) || (this_1.as != null && e)) {
                            if (e) {
                                formattedLabel_ = this_1.as.i(k);
                            }
                            else {
                                formattedLabel_ = this_1.ap.i(k);
                            }
                        }
                        else {
                            formattedLabel_ = this_1.a4(k);
                        }
                        if (null == formattedLabel_ && this_1.bp != null && this_1.bp.count > 0) {
                            f = this_1.bp.item(this_1.cl._inner[c]);
                        }
                        else {
                            f = formattedLabel_;
                        }
                    }
                    var label_ = f;
                    var errorMsg_ = this_1.d6;
                    if (label_ === undefined) {
                        throw new Error(errorMsg_);
                    }
                    ;
                    if (null != f) {
                        d = f.toString();
                    }
                    else {
                        d = null;
                    }
                }
                if (this_1.bp != null && this_1.bp.count > 0) {
                    var l = this_1.bu.item(c);
                    var m = this_1.bv.item(c);
                    m.aj = l;
                    l.ai = i2.GeometryUtil.i((m.a3 + m.ax) / 2);
                    l.ah = m;
                    l.aj = ((function () {
                        var $ret = new i2.TextBlock();
                        $ret.ak = d;
                        return $ret;
                    })());
                    if (this_1.g7 == null) {
                        l.dataContext = e ? this_1.cj : this_1.bk.item(this_1.cl._inner[c]);
                        l.ak(this_1.a3);
                    }
                    else {
                    }
                    l._visibility = 0;
                    l.ao = this_1.a3.b1(l);
                    b++;
                }
                if (this_1.bq != null && this_1.bq.count > 0) {
                    var n = this_1.bv.item(c);
                    n.bf = g != null ? g.toString() : null;
                }
            };
            var this_1 = this;
            for (var c = 0; c < a; c++) {
                _loop_1(c);
            }
            this.bu.count = b;
        };
        PieChartBase.prototype.gu = function () {
            var e_4, _a;
            if (this.actualItemsSource == null || this.bk == null) {
                return;
            }
            var a = this.a3.b3();
            this.i2 = new i2.Rect(0, 0, 0, a.width, a.height);
            var b = this.a3.aa();
            var c = this.a3.z(this.i5);
            b = i2.isNaN_(b) ? 0 : b / 2;
            c = i2.isNaN_(c) ? 0 : c / 2;
            b = Math.max(c, b);
            var d = Math.min(a.width / 2, a.height / 2);
            var e = { $type: i2.Point_$type, x: a.width / 2, y: a.height / 2 };
            var f = d * this.c0;
            var g = f + b;
            if (g > d) {
                var h = g - d;
                f = f - h;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.bv.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var i = _c.value;
                    var j = i2.GeometryUtil.l(a.width, a.height, true, (i.a3 + i.ax) / 2, f * this.cx);
                    i.aw = true;
                    i.a1 = this.cy;
                    i.a0 = this.cy;
                    i.a2 = f;
                    i.ay = this.cx;
                    i.b7 = e;
                    i.b5 = j;
                    this.gy(i);
                    i.aw = false;
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            this.a3.br();
        };
        PieChartBase.prototype.gs = function () {
            var e_5, _a, e_6, _b, e_7, _c, e_8, _d, e_9, _e;
            var a = this.a3.b2.width;
            var b = this.a3.b2.height;
            if (b == 0 || a == 0) {
                return;
            }
            if (this.bu.a.count == 0 || this.az == 0) {
                this.bu.count = 0;
                return;
            }
            var c = new i2.List$1(PieLabel.$, 0);
            var d = new i2.List$1(PieLabel.$, 0);
            var e = new i2.List$1(PieLabel.$, 0);
            var f = new i2.List$1(PieLabel.$, 0);
            try {
                for (var _f = tslib.__values(i2.fromEnum(this.bu.a)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var g = _g.value;
                    var h = g.ah;
                    if (h == null) {
                        continue;
                    }
                    var i = h.b6();
                    var j = g.ao.width;
                    var k = g.ao.height;
                    if (this.az == 1 || this.az == 4) {
                        var l = h.a2 * h.a1 / 100;
                        var m = i2.GeometryUtil.m(i, g.ai, h.a2 - (h.a2 - l) / 2);
                        g.ao = new i2.Rect(0, m.x - j / 2, m.y - k / 2, j, k);
                        var n = this.b8(g, m);
                        if (n || this.az == 1) {
                            if (this.ir == null) {
                                h.f(Slice.bp);
                            }
                            else {
                                h.b2 = this.ir;
                            }
                            h.au = true;
                            e.add(g);
                            g.ag = 1;
                            if (g.ah.ai.a0 == 0) {
                                g.ap._visibility = 1;
                            }
                            else {
                                g.aq._visibility = 1;
                            }
                            if (!n && this.az == 1) {
                                g._visibility = 1;
                            }
                            else {
                                g._visibility = 0;
                            }
                            continue;
                        }
                    }
                    if (this.az == 2 || this.az == 4) {
                        var o = PieChartBase.c4(i, h.a2, g);
                        var p = i2.GeometryUtil.m(i, g.ai, o);
                        g.ao = new i2.Rect(0, p.x - j / 2, p.y - k / 2, j, k);
                        var q = this.b8(g, p);
                        if (q || this.az == 2) {
                            if (this.ir == null) {
                                h.f(Slice.bp);
                            }
                            else {
                                h.b2 = this.ir;
                            }
                            h.au = true;
                            f.add(g);
                            g.ag = 2;
                            if (g.ah.ai.a0 == 0) {
                                g.ap._visibility = 1;
                            }
                            else {
                                g.aq._visibility = 1;
                            }
                            if (!q && this.az == 2) {
                                g._visibility = 1;
                            }
                            else {
                                g._visibility = 0;
                            }
                            continue;
                        }
                    }
                    if (this.is == null) {
                        h.f(Slice.bp);
                    }
                    else {
                        h.b2 = this.is;
                    }
                    h.au = false;
                    var r = i2.GeometryUtil.m(i, g.ai, h.a2 + this.c8);
                    g.ag = 3;
                    g._visibility = 0;
                    g.al();
                    if (g.ai < 90 && g.ai >= 0) {
                        g.ao = new i2.Rect(0, r.x, r.y, j, k);
                        c.add(g);
                    }
                    else if (g.ai < 180 && g.ai >= 90) {
                        g.ao = new i2.Rect(0, r.x - j, r.y, j, k);
                        d.add(g);
                    }
                    else if (g.ai < 270 && g.ai >= 180) {
                        g.ao = new i2.Rect(0, r.x - j, r.y - k, j, k);
                        d.add(g);
                    }
                    else {
                        g.ao = new i2.Rect(0, r.x, r.y - k, j, k);
                        c.add(g);
                    }
                    if (g.ao.y < 0) {
                        g.ao = new i2.Rect(0, g.ao.x, 0, g.ao.width, g.ao.height);
                    }
                    if (g.ao.bottom > b) {
                        g.ao = new i2.Rect(0, g.ao.x, b - g.ao.height, g.ao.width, g.ao.height);
                    }
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_a = _f.return))
                        _a.call(_f);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            PieChartBase.g3(c);
            this.gv(c);
            PieChartBase.g3(d);
            this.gv(d);
            try {
                for (var _h = tslib.__values(i2.fromEnum(e)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var s = _j.value;
                    this.a3.bm(s, s.ao.x, s.ao.y);
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_b = _h.return))
                        _b.call(_h);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            try {
                for (var _k = tslib.__values(i2.fromEnum(f)), _l = _k.next(); !_l.done; _l = _k.next()) {
                    var t = _l.value;
                    this.a3.bm(t, t.ao.x, t.ao.y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_l && !_l.done && (_c = _k.return))
                        _c.call(_k);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            try {
                for (var _m = tslib.__values(i2.fromEnum(c)), _o = _m.next(); !_o.done; _o = _m.next()) {
                    var u = _o.value;
                    this.a3.bm(u, u.ao.x, u.ao.y);
                    if (u.ah.ai.a0 == 0) {
                        u.am();
                    }
                    else {
                        u.an();
                    }
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_o && !_o.done && (_d = _m.return))
                        _d.call(_m);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            try {
                for (var _p = tslib.__values(i2.fromEnum(d)), _q = _p.next(); !_q.done; _q = _p.next()) {
                    var v = _q.value;
                    this.a3.bm(v, v.ao.x, v.ao.y);
                    if (v.ah.ai.a0 == 0) {
                        v.am();
                    }
                    else {
                        v.an();
                    }
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_q && !_q.done && (_e = _p.return))
                        _e.call(_p);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            this.a3.br();
        };
        PieChartBase.c4 = function (a, b, c) {
            var d = c.ai * Math.PI / 180;
            var e = 1;
            var f = i2.GeometryUtil.m({ $type: i2.Point_$type, x: 0, y: 0 }, c.ai, e);
            var g = PieChartBase.iy(c);
            var h = Math.sqrt(g.x * g.x + g.y * g.y);
            var i = { $type: i2.Point_$type, x: g.x / h, y: g.y / h };
            var j = PieChartBase.c5(f, i);
            var k = h / b;
            var l = j * k;
            var m = l;
            var n = i2.GeometryUtil.f({ $type: i2.Point_$type, x: 0, y: 0 }, f);
            var o = i2.GeometryUtil.f({ $type: i2.Point_$type, x: 0, y: 0 }, i);
            if (o < n) {
                m = -m;
            }
            var p = i2.GeometryUtil.m(a, (d + m) * 180 / Math.PI, b);
            var q = PieChartBase.ix(c, p);
            var r = Math.sqrt((q.x - a.x) * (q.x - a.x) + (q.y - a.y) * (q.y - a.y));
            var s = r - 5;
            return s;
        };
        PieChartBase.ix = function (a, b) {
            var c = i2.GeometryUtil.i(a.ai);
            var d = a.ao.width / 2;
            var e = a.ao.height / 2;
            if (c >= 0 && c <= 90) {
                return { $type: i2.Point_$type, x: b.x - d, y: b.y - e };
            }
            if (c >= 90 && c <= 180) {
                return { $type: i2.Point_$type, x: b.x + d, y: b.y - e };
            }
            if (c >= 180 && c <= 270) {
                return { $type: i2.Point_$type, x: b.x + d, y: b.y + e };
            }
            return { $type: i2.Point_$type, x: b.x - d, y: b.y + e };
        };
        PieChartBase.c5 = function (a, b) {
            var c = a.x * b.x + a.y * b.y;
            var d = Math.sqrt(a.x * a.x + a.y * a.y);
            var e = Math.sqrt(b.x * b.x + b.y * b.y);
            var f = Math.acos(c / (d * e));
            return f;
        };
        PieChartBase.iy = function (a) {
            var b = i2.GeometryUtil.i(a.ai);
            var c = a.ao.width / 2;
            var d = a.ao.height / 2;
            if (b >= 0 && b <= 90) {
                return { $type: i2.Point_$type, x: c, y: d };
            }
            if (b >= 90 && b <= 180) {
                return { $type: i2.Point_$type, x: -c, y: d };
            }
            if (b >= 180 && b <= 270) {
                return { $type: i2.Point_$type, x: -c, y: -d };
            }
            return { $type: i2.Point_$type, x: c, y: -d };
        };
        PieChartBase.prototype.gt = function () {
            var e_10, _a;
            var _this = this;
            if (this.legend == null || !this.legend.isItemwise) {
                return;
            }
            if ((this.bp == null || this.bp.count == 0) && (this.bq == null || this.bq.count == 0)) {
                this.legend.clearLegendItemsForSeries(this);
                return;
            }
            this.ci = new i2.List$1(i2.UIElement.$, 0);
            var _loop_2 = function (a) {
                var b = new i2.ContentControl();
                var c = this_2.dl(a);
                var d = this_2.a3.bt(a);
                var e = this_2.a3.bu(a);
                b.content = ((function () {
                    var $ret = new PieSliceDataContext();
                    $ret.series = _this;
                    $ret.slice = a;
                    $ret.item = a.dataContext;
                    $ret.itemBrush = d;
                    $ret.outline = e;
                    $ret.thickness = a.a4;
                    $ret.itemLabel = c != null ? c.toString() : null;
                    $ret.legendLabel = a.isOthersSlice ? _this.fc() : a.bf != null ? a.bf : (c != null ? c.toString() : null);
                    $ret.percentValue = _this.c6(a);
                    $ret.isOthersSlice = a.isOthersSlice;
                    return $ret;
                })());
                var f = b.content;
                if (this_2.ca() || this_2.aq != null || this_2.ar != null) {
                    var g = null;
                    if (this_2.ca()) {
                        g = this_2.a5(b.content);
                    }
                    if (this_2.aq != null && !f.isOthersSlice) {
                        g = this_2.aq.i(b.content);
                    }
                    if (this_2.ar != null && f.isOthersSlice) {
                        g = this_2.ar.i(b.content);
                    }
                    if (g != null) {
                        f.legendLabel = g.toString();
                    }
                }
                if (this_2.legendItemTemplate != null) {
                    b.ah = this_2.legendItemTemplate;
                }
                this_2.ci.add(b);
            };
            var this_2 = this;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.bv.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    _loop_2(a);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
            if (this.legend.isItemwise) {
                var h = this.legend;
                h.createItemwiseLegendItems(this.ci, this);
            }
        };
        PieChartBase.prototype.bj = function () {
            var a = new PieChartVisualData();
            a.viewport = i2.RectData.b(this.i2);
            this.a3.an(a);
            for (var b = 0; b < this.bv.count; b++) {
                var c = this.bv.item(b).am();
                a.slices.add(c);
                if (this.bv.item(b).isOthersSlice) {
                    a.othersSlice = this.bv.item(b).am();
                }
            }
            a.others = this.cj;
            a.name = this.name;
            a.radiusFactor = this.c0;
            a.leaderLineMargin = this.c9;
            return a;
        };
        PieChartBase.prototype.d1 = function () {
            var a = this.bj();
            a.scaleByViewport();
            return a.serialize();
        };
        PieChartBase.prototype.br = function (a) {
            var b = null;
            return this.bk.registerColumn(a, b, false);
        };
        PieChartBase.prototype.bs = function (a) {
            var b = null;
            return this.bk.registerColumnObject(a, b, false);
        };
        PieChartBase.prototype.gn = function (a, b, c, d) {
            var e_11, _a;
            switch (b) {
                case PieChartBase.$$p[13]:
                    this.actualItemsSource = this.cp();
                    break;
                case PieChartBase.$$p[43]:
                case PieChartBase.$$p[44]:
                    this.ir = this.iv(this.it);
                    this.is = this.iv(this.iu);
                    this.ak = this.ao(this.am);
                    this.al = this.ao(this.al);
                    this.actualItemsSource = this.cp();
                    break;
                case PieChartBase.$$p[1]:
                    if (this.ce) {
                        this.ak = this.ao(this.am);
                        this.al = this.ao(this.al);
                        this.ir = this.iv(this.it);
                        this.is = this.iv(this.iu);
                    }
                    this.bk = ((function () {
                        var $ret = new i2.FastItemsSource();
                        $ret.e = d;
                        return $ret;
                    })());
                    break;
                case PieChartBase.$$p[15]:
                case PieChartBase.$$p[16]:
                    if (this.eb != null) {
                        this.ap = new i2.BindingFormatter();
                        this.ap.j = this.eb;
                        this.ap.d = this.ag;
                    }
                    else {
                        this.ap = null;
                    }
                    break;
                case PieChartBase.$$p[37]:
                case PieChartBase.$$p[38]:
                    if (this.e5 != null) {
                        this.as = new i2.BindingFormatter();
                        this.as.j = this.e5;
                        this.as.d = this.aj;
                    }
                    else {
                        this.as = null;
                    }
                    break;
                case PieChartBase.$$p[27]:
                case PieChartBase.$$p[28]:
                    if (this.er != null) {
                        this.aq = new i2.BindingFormatter();
                        this.aq.j = this.er;
                        this.aq.d = this.ah;
                    }
                    else {
                        this.aq = null;
                    }
                    break;
                case PieChartBase.$$p[30]:
                case PieChartBase.$$p[31]:
                    if (this.ew != null) {
                        this.ar = new i2.BindingFormatter();
                        this.ar.j = this.ew;
                        this.ar.d = this.ai;
                    }
                    else {
                        this.ar = null;
                    }
                    break;
                case PieChartBase.$$p[9]:
                    if (i2.typeCast(i2.FastItemsSource.$, c) != null) {
                        var e = c;
                        e.event = i2.delegateRemove(e.event, this.dh);
                        this.b0 = false;
                        c.deregisterColumn(this.bt);
                        c.deregisterColumn(this.bp);
                        this.bt = null;
                        this.bp = null;
                        this.selectedItem = null;
                        this.selectedItems.clear();
                        if (this.selectedSlices != null) {
                            this.selectedSlices.clear();
                        }
                        (i2.typeCast(i2.FastItemsSource.$, c)).deregisterColumn(this.bq);
                        this.bq = null;
                    }
                    if (i2.typeCast(i2.FastItemsSource.$, d) != null) {
                        var f = d;
                        f.event = i2.delegateCombine(f.event, this.dh);
                        this.b0 = true;
                        this.bt = this.br(this.fd(this.fq));
                        this.bp = this.bs(this.fb(this.ef));
                        this.bq = this.bs(this.eu);
                        this.gm();
                        if (this.selectedItem != null || this.selectedItems.count > 0) {
                            this.g5();
                        }
                        else if (this.selectedSlices != null && this.selectedSlices.count > 0) {
                            this.g6();
                        }
                    }
                    this.gr();
                    break;
                case PieChartBase.$$p[49]:
                    if (this.bk != null) {
                        this.bk.deregisterColumn(this.bt);
                        this.bt = this.br(this.fd(this.fq));
                    }
                    break;
                case PieChartBase.$$p[29]:
                    if (this.bk != null) {
                        this.bk.deregisterColumn(this.bq);
                        this.bq = this.bs(this.eu);
                        this.gl();
                        this.gs();
                        this.gt();
                    }
                    break;
                case PieChartBase.$$p[11]:
                    this.gt();
                    break;
                case PieChartBase.$$p[10]:
                case PieChartBase.$$p[18]:
                    if (this.bk != null) {
                        this.bk.deregisterColumn(this.bp);
                        this.bp = this.bs(this.fb(this.ef));
                        this.gl();
                        this.gs();
                        this.gt();
                    }
                    break;
                case PieChartBase.$$p[45]:
                    this.c1 = d;
                    this.gm();
                    this.gl();
                    this.gu();
                    this.gs();
                    break;
                case PieChartBase.$$p[47]:
                    this.a3.bp(this.dn);
                    break;
                case PieChartBase.$$p[32]:
                    var g = i2.typeCast(i2.IChartLegend_$type, c);
                    if (g != null) {
                        g.clearLegendItemsForSeries(this);
                    }
                    this.gt();
                    break;
                case PieChartBase.$$p[25]:
                case PieChartBase.$$p[26]:
                    this.gt();
                    break;
                case PieChartBase.$$p[40]:
                case PieChartBase.$$p[8]:
                case PieChartBase.$$p[46]:
                    this.gm();
                    this.gl();
                    this.gu();
                    this.gs();
                    break;
                case PieChartBase.$$p[33]:
                case PieChartBase.$$p[41]:
                    this.gu();
                    this.gt();
                    break;
                case PieChartBase.$$p[7]:
                    this.ak = this.ao(this.am);
                    break;
                case PieChartBase.$$p[39]:
                    this.al = this.ao(this.an);
                    break;
                case PieChartBase.$$p[0]:
                    if (c != null) {
                        var h = c;
                        h.collectionChanged = i2.delegateRemove(h.collectionChanged, this.cr);
                        this.by = false;
                    }
                    if (d != null) {
                        var i = d;
                        i.collectionChanged = i2.delegateCombine(i.collectionChanged, this.cr);
                        this.by = true;
                    }
                    this.gu();
                    this.gt();
                    break;
                case PieChartBase.$$p[4]:
                    if (c != null) {
                        var j = c;
                        j.collectionChanged = i2.delegateRemove(j.collectionChanged, this.cr);
                        this.b1 = false;
                    }
                    if (d != null) {
                        var k = d;
                        k.collectionChanged = i2.delegateCombine(k.collectionChanged, this.cr);
                        this.b1 = true;
                    }
                    this.gu();
                    this.gt();
                    break;
                case "ValueColumn":
                case PieChartBase.$$p[35]:
                case PieChartBase.$$p[36]:
                    this.gr();
                    this.g5();
                    this.g6();
                    break;
                case PieChartBase.$$p[5]:
                case PieChartBase.$$p[6]:
                    this.gr();
                    break;
                case PieChartBase.$$p[20]:
                    this.gl();
                    this.gs();
                    this.a3.br();
                    break;
                case PieChartBase.$$p[17]:
                    this.ir = this.iv(this.it);
                    break;
                case PieChartBase.$$p[19]:
                    this.is = this.iv(this.iu);
                    break;
                case PieChartBase.$$p[2]:
                case PieChartBase.$$p[3]:
                case PieChartBase.$$p[14]:
                    this.gl();
                    this.gs();
                    break;
                case PieChartBase.$$p[34]:
                    this.gl();
                    this.gs();
                    this.gt();
                    break;
                case PieChartBase.$$p[24]:
                    this.gs();
                    break;
                case PieChartBase.$$p[22]:
                    this.gs();
                    break;
                case "TextStyle":
                    this.a3.bh();
                    break;
                case "PixelScalingRatio":
                    if (i2.isNaN_(i2.DeviceUtils.a(this.dc))) {
                        this.cz = 1;
                    }
                    else {
                        this.cz = i2.DeviceUtils.a(this.dc);
                    }
                    break;
                case "ActualPixelScalingRatio":
                    this.a3.a3();
                    break;
                case "LabelTemplate":
                    this.gl();
                    this.gs();
                    break;
                case PieChartBase.$$p[23]:
                case PieChartBase.$$p[21]:
                    this.bu.c(i2.runOn(this.a3, this.a3.bl));
                    this.gs();
                    break;
                case PieChartBase.$$p[12]:
                    this.a3.a2();
                    break;
                case "InnerExtent":
                    this.gr();
                    break;
                case "SelectedItem":
                    if (!this.b4) {
                        this.gm();
                        this.gu();
                        this.gt();
                    }
                    break;
                case PieChartBase.$$p[42]:
                    if (i2.EnumUtil.getEnumValue(SliceSelectionMode_$type, d) == 1 && this.selectedItems != null && this.selectedItems.count > 1) {
                        this.selectedItems.clear();
                    }
                    else if (i2.EnumUtil.getEnumValue(SliceSelectionMode_$type, d) == 2 && this.selectedItem != null && this.selectedItems != null) {
                        if (!this.selectedItems.contains1(this.selectedItem)) {
                            if (i2.typeCast(PieSliceOthersContext.$, this.selectedItem) !== null) {
                                var l = i2.typeCast(PieSliceOthersContext.$, this.selectedItem);
                                try {
                                    for (var _b = tslib.__values(i2.fromEn(l.data)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                        var m = _c.value;
                                        this.selectedItems.add1(m);
                                    }
                                }
                                catch (e_11_1) {
                                    e_11 = { error: e_11_1 };
                                }
                                finally {
                                    try {
                                        if (_c && !_c.done && (_a = _b.return))
                                            _a.call(_b);
                                    }
                                    finally {
                                        if (e_11)
                                            throw e_11.error;
                                    }
                                }
                            }
                            else {
                                this.selectedItems.add1(this.selectedItem);
                            }
                            this.g6();
                        }
                    }
                    this.g5();
                    this.gm();
                    this.gu();
                    break;
            }
        };
        PieChartBase.prototype.ao = function (a) {
            var e_12, _a;
            if (!this.ce || !this.cf || this.itemsSource != null) {
                return a;
            }
            if (a == null) {
                return null;
            }
            var b = new i2.BrushCollection();
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = i2.BrushUtil.r(c);
                    b.add(d);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
            return b;
        };
        PieChartBase.prototype.iv = function (a) {
            if (!this.ce || !this.cf || this.itemsSource != null) {
                return a;
            }
            var b = i2.BrushUtil.g(0, 0, 0, 0);
            return b;
        };
        PieChartBase.prototype.fb = function (a) {
            if (this.ce && this.itemsSource == null) {
                return "Label";
            }
            return a;
        };
        PieChartBase.prototype.fd = function (a) {
            if (this.ce && this.itemsSource == null) {
                return "Value";
            }
            return a;
        };
        PieChartBase.prototype.cp = function () {
            if (this.itemsSource != null) {
                return this.itemsSource;
            }
            if (!this.ce) {
                return null;
            }
            if (this.cm == null) {
                this.cm = PieChartMockDataGenerator.a();
            }
            return this.cm;
        };
        PieChartBase.prototype.gw = function (a) {
            if (this.b5) {
                return;
            }
            this.g6();
            if (this.b7) {
                this.gm();
                this.gu();
                this.gt();
            }
        };
        PieChartBase.prototype.gc = function (a) {
            if (a.action == 4 && a.newItems == null && a.oldItems == null) {
                return;
            }
            if (this.b4) {
                return;
            }
            this.g5();
            if (this.b7) {
                this.gm();
                this.gu();
                this.gt();
            }
            var b = new i2.ObjectCollection(0);
            if (a.oldItems != null) {
                for (var c = 0; c < a.oldItems.count; c++) {
                    b.add1(a.oldItems.item(c));
                }
            }
            var d = new i2.ObjectCollection(0);
            if (a.newItems != null) {
                for (var e = 0; e < a.newItems.count; e++) {
                    d.add1(a.newItems.item(e));
                }
            }
            var f = this.selectedItems;
            this.gb(this, new SelectedItemsChangedEventArgs(b, d, f));
        };
        PieChartBase.prototype.gp = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        PieChartBase.prototype.g6 = function () {
            var e_13, _a, e_14, _b;
            if (this.actualItemsSource == null || this.bv.a.count == 0) {
                return;
            }
            this.b4 = true;
            var a = this.selectedSlices.count;
            if (a == 0) {
                if (this.selectedItems.count > 0) {
                    this.selectedItems.clear();
                }
                if (this.selectedItem != null) {
                    this.selectedItem = null;
                }
            }
            if (this.bi == 1) {
                if (a != 0) {
                    var b_1 = this.bv.a._inner[this.selectedSlices._inner[a - 1]];
                    if (b_1.isOthersSlice) {
                        this.selectedItem = ((function () {
                            var $ret = new PieSliceOthersContext();
                            $ret.data = i2.typeCast(i2.IList_$type, b_1.dataContext);
                            $ret.slice = b_1;
                            return $ret;
                        })());
                    }
                    else {
                        this.selectedItem = b_1.dataContext;
                    }
                }
            }
            else if (this.bi == 2) {
                if (a != 0) {
                    this.selectedItems.clear();
                    try {
                        for (var _c = tslib.__values(i2.fromEnum(this.selectedSlices)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var c = _d.value;
                            var d = this.bv.a._inner[c];
                            if (d.isOthersSlice) {
                                var e = i2.typeCast(i2.IEnumerable_$type, d.dataContext);
                                try {
                                    for (var _e = (e_14 = void 0, tslib.__values(i2.fromEn(e))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                        var f = _f.value;
                                        this.a6.e(f);
                                    }
                                }
                                catch (e_14_1) {
                                    e_14 = { error: e_14_1 };
                                }
                                finally {
                                    try {
                                        if (_f && !_f.done && (_b = _e.return))
                                            _b.call(_e);
                                    }
                                    finally {
                                        if (e_14)
                                            throw e_14.error;
                                    }
                                }
                            }
                            else {
                                this.a6.e(d.dataContext);
                            }
                        }
                    }
                    catch (e_13_1) {
                        e_13 = { error: e_13_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_13)
                                throw e_13.error;
                        }
                    }
                    this.selectedItem = this.bv.a._inner[this.selectedSlices._inner[a - 1]].dataContext;
                }
            }
            this.b4 = false;
        };
        PieChartBase.prototype.g5 = function () {
            var e_15, _a;
            if (this.actualItemsSource == null || this.bv.a.count == 0) {
                return;
            }
            this.b5 = true;
            this.selectedSlices.clear();
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.bv.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (this.a6.d(a)) {
                        this.selectedSlices.add(a.a5);
                    }
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
            this.b5 = false;
        };
        PieChartBase.prototype.g1 = function (a, b) {
            this.g2(a, b, false);
        };
        PieChartBase.prototype.g2 = function (a, b, c) {
            if (this.b7) {
                if (this.bi == 1) {
                    this.a6.k(a);
                }
                else if (this.bi == 2) {
                    this.a6.i(a);
                }
            }
            var d = new SliceClickEventArgs(a, this.a3.ae(b));
            this.gf(this, d);
            if (!c) {
                this.a3.bn(a, b);
            }
        };
        PieChartBase.prototype.g0 = function (a) {
            this.a3.ak(a);
        };
        PieChartBase.prototype.cd = function (a, b) {
            var c = new LabelClickEventArgs(a, this.a3.ae(b));
            this.f8(this, c);
            return c.allowSliceClick;
        };
        PieChartBase.prototype.fw = function (a, b) {
            if (a != this.dk) {
                this.dk = a;
                if (a != null) {
                    this.gg(a, b);
                }
            }
            this.a3.bn(a, b);
        };
        PieChartBase.prototype.be = function (a, b) {
            return new SliceEventArgs(a, b);
        };
        PieChartBase.prototype.gg = function (a, b) {
            if (this.sliceEnter != null) {
                this.sliceEnter(a, this.be(a, b));
            }
        };
        PieChartBase.prototype.gh = function (a, b) {
            if (this.sliceLeave != null) {
                this.sliceLeave(a, this.be(a, b));
            }
        };
        PieChartBase.prototype.gi = function (a, b) {
            if (this.sliceHover != null) {
                this.sliceHover(a, this.be(a, b));
            }
        };
        PieChartBase.prototype.fz = function (a, b, c) {
            if (a != this.dk) {
                var d = this.dk;
                if (d != null) {
                    this.gh(d, b);
                }
                this.dk = a;
                if (this.dk != null) {
                    this.gg(a, b);
                }
            }
            else {
                if (this.dk != null) {
                    this.gi(a, b);
                }
            }
            this.a3.bn(a, b);
        };
        PieChartBase.prototype.fy = function (a, b) {
            this.fz(a, b, false);
        };
        PieChartBase.prototype.fx = function (a, b) {
            this.a3.al();
            if (this.dk != null) {
                if (this.dk != null) {
                    this.gh(this.dk, b);
                }
                this.dk = null;
            }
        };
        PieChartBase.prototype.ge = function () {
            this.gr();
        };
        PieChartBase.prototype.provideContainer = function (a) {
            this.a3.ay(a);
        };
        PieChartBase.prototype.f6 = function (a, b) {
            this.a3.az(a, b);
        };
        PieChartBase.prototype.notifyContainerResized = function () {
            this.a3.aw();
        };
        PieChartBase.prototype.i0 = function () {
            return this.a3.b0();
        };
        PieChartBase.prototype.iz = function () {
            return this.a3.bx();
        };
        PieChartBase.prototype.destroy = function () {
            this.gq();
            this.a3.ay(null);
        };
        PieChartBase.prototype.fv = function () {
            this.a3.ao();
        };
        Object.defineProperty(PieChartBase.prototype, "fl", {
            get: function () {
                return this.dp;
            },
            set: function (a) {
                var b = this.dp;
                this.dp = a;
                this.gp("TextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "container", {
            get: function () {
                return this;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "isStacked", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "isVertical", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "hasMarkers", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "isUsableInLegend", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieChartBase.prototype, "hasSubItems", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        PieChartBase.prototype.c6 = function (a) {
            if (a == null || this.bt == null || this.cl == null) {
                return NaN;
            }
            if (a.isOthersSlice) {
                return this.db / this.dg * 100;
            }
            else {
                return this.bt.item(this.cl._inner[a.a5]) / this.dg * 100;
            }
        };
        PieChartBase.prototype.f4 = function (source_, a, b, c) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.cg(source_)) {
                return;
            }
            var d = this.bk;
            if (d == null) {
                return;
            }
            d.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        PieChartBase.prototype.f0 = function (source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.cg(source_)) {
                return;
            }
            var a = this.bk;
            a.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        PieChartBase.prototype.cg = function (a) {
            return PieChartBase.ch(a, this.itemsSource);
        };
        PieChartBase.ch = function (a, b) {
            return a == b;
        };
        PieChartBase.prototype.f2 = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.cg(source_)) {
                return;
            }
            var c = this.bk;
            if (c == null) {
                return;
            }
            c.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        PieChartBase.prototype.f3 = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.cg(source_)) {
                return;
            }
            var c = this.bk;
            if (c == null) {
                return;
            }
            c.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        PieChartBase.prototype.gz = function (source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            this.itemsSource = source_;
        };
        PieChartBase.prototype.gq = function () {
            this.itemsSource = null;
        };
        PieChartBase.prototype.g4 = function () {
            this.a3.bh();
        };
        PieChartBase.prototype.bl = function () {
            return i2.FontUtil.toFontInfo(this.a3.c.n, this.fl);
        };
        PieChartBase.prototype.resolveLegendIndex = function () {
            return -1;
        };
        PieChartBase.prototype.forSubItems = function (a) {
        };
        PieChartBase.$t = i2.markType(PieChartBase, 'PieChartBase', i2.Control.$, [i2.INotifyPropertyChanged_$type, i2.ILegendOwner_$type, i2.ILegendSeries_$type, i2.ILegendTemplateProvider_$type]);
        PieChartBase.hk = i2.DependencyProperty.i("InnerExtent", i2.Number_$type, PieChartBase.$, new i2.PropertyMetadata(2, 0, function (a, b) { return a.gp("InnerExtent", b.oldValue, b.newValue); }));
        PieChartBase.hu = i2.DependencyProperty.i("LabelTemplate", i2.DataTemplate.$, PieChartBase.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.gp("LabelTemplate", b.oldValue, b.newValue); }));
        PieChartBase.ig = i2.DependencyProperty.i("SelectedItem", i2.Base.$, PieChartBase.$, new i2.PropertyMetadata(1, function (a, b) {
            var c = i2.typeCast(PieChartBase.$, a);
            if (c.b3) {
                return;
            }
            var d = new SelectedItemChangingEventArgs(b.oldValue, b.newValue);
            c.ga(c, d);
            if (!d.cancel) {
                if (!c.b4) {
                    c.g5();
                }
                c.gp("SelectedItem", b.oldValue, b.newValue);
                c.f9(a, new SelectedItemChangedEventArgs(b.oldValue, b.newValue));
            }
            else {
                c.b3 = true;
                c.selectedItem = b.oldValue;
                c.b3 = false;
            }
        }));
        PieChartBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PieChartBase, 'gp', ['ActualBrushes:ak:g8', [i2.BrushCollection.$, null], 'ActualItemsSource::g9', [i2.IEnumerable_$type, null], 'ActualLabelInnerColor:ir:ha', [i2.Brush.$, null], 'ActualLabelOuterColor:is:hb', [i2.Brush.$, null], 'ActualOutlines:al:hc', [i2.BrushCollection.$, null], 'AllowSliceExplosion:b6:hd', [0, true], 'AllowSliceSelection:b7:he', [0, true], 'Brushes:am:hf', [i2.BrushCollection.$, null], 'ExplodedRadius:c2:hg', [1, 0.2], 'FastItemsSource:bk:hh', [i2.FastItemsSource.$], 'FormatLabel:a4:hi', [i2.Delegate_$type], 'FormatLegendLabel:a5:hj', [i2.Delegate_$type], 'IsSurfaceInteractionDisabled:cc:hl', [0, false], 'ItemsSource::hm', [i2.IEnumerable_$type, null], 'LabelExtent:c8:hn', [1, 10], 'LabelFormat:eb:ho', [2, null], 'LabelFormatSpecifiers:ag:hp', [i2.Array_$type, null], 'LabelInnerColor:it:hq', [i2.Brush.$, null], 'LabelMemberPath:ef:hr', [2], 'LabelOuterColor:iu:hs', [i2.Brush.$, null], 'LabelsPosition:az:ht', [LabelsPosition_$type, i2.enumGetBox(LabelsPosition_$type, 1)], 'LeaderLineMargin:c9:hv', [1, 6], 'LeaderLineStyle:i3:hw', [i2.Style.$, null], 'LeaderLineType:a0:hx', [LeaderLineType_$type, i2.enumGetBox(LeaderLineType_$type, 0)], 'LeaderLineVisibility:i7:hy', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'LegendItemBadgeTemplate::hz', [i2.DataTemplate.$, null], 'LegendItemTemplate::h0', [i2.DataTemplate.$, null], 'LegendLabelFormat:er:h1', [2, null], 'LegendLabelFormatSpecifiers:ah:h2', [i2.Array_$type, null], 'LegendLabelMemberPath:eu:h3', [2], 'LegendOthersLabelFormat:ew:h4', [2, null], 'LegendOthersLabelFormatSpecifiers:ai:h5', [i2.Array_$type, null], 'Legend::h6', [i2.IChartLegend_$type, null], 'OthersCategoryStyle:i4:h7', [i2.Style.$, null], 'OthersCategoryText:e1:h8', [2, null], 'OthersCategoryThreshold:da:h9', [1, 3], 'OthersCategoryType:a1:ia', [OthersCategoryType_$type, i2.enumGetBox(OthersCategoryType_$type, 1)], 'OthersLabelFormat:e5:ib', [2, null], 'OthersLabelFormatSpecifiers:aj:ic', [i2.Array_$type, null], 'Outlines:an:id', [i2.BrushCollection.$, null], 'RadiusFactor:dd:ie', [1, 0.9], 'SelectedStyle:i5:ih', [i2.Style.$, null], 'SelectionMode:bi:ii', [SliceSelectionMode_$type, i2.enumGetBox(SliceSelectionMode_$type, 1)], 'ShouldDisplayMockData:ce:ij', [0, false], 'ShouldUseSkeletonStyleForMockData:cf:ik', [0, false], 'StartAngle:df:il', [1, 0], 'SweepDirection:iw:im', [i2.SweepDirection_$type, i2.enumGetBox(i2.SweepDirection_$type, 1)], 'ToolTip:dn:io', [4, null], 'ToolTipStyle:i6:ip', [i2.Style.$, null], 'ValueMemberPath:fq:iq', [2, null]]);
        return PieChartBase;
    }(i2.Control));
    /**
     * @hidden
     */
    var PieChartSliceSelector = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartSliceSelector, _super);
        function PieChartSliceSelector(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = a;
            return _this;
        }
        PieChartSliceSelector.prototype.d = function (a) {
            var b = a.dataContext;
            if (this.a.bi == 1) {
                if (a.isOthersSlice) {
                    var c = i2.typeCast(i2.IList_$type, b);
                    if (c != null && c.contains(this.a.selectedItem)) {
                        return true;
                    }
                    if (i2.typeCast(PieSliceOthersContext.$, this.a.selectedItem) !== null) {
                        return true;
                    }
                }
                if (b == this.a.selectedItem) {
                    return true;
                }
            }
            else if (this.a.bi == 2) {
                if (this.c(a)) {
                    return true;
                }
            }
            else if (this.a.bi == 0) {
                if (this.a.selectedSlices.contains(a.a5)) {
                    return true;
                }
            }
            return false;
        };
        PieChartSliceSelector.prototype.c = function (a) {
            var e_16, _a;
            var b = a.dataContext;
            if (a.isOthersSlice) {
                try {
                    for (var _b = tslib.__values(i2.fromEn(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        if (this.a.selectedItems.contains1(c)) {
                            return true;
                        }
                    }
                }
                catch (e_16_1) {
                    e_16 = { error: e_16_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_16)
                            throw e_16.error;
                    }
                }
            }
            else {
                if (this.a.selectedItems.contains1(b)) {
                    return true;
                }
            }
            return false;
        };
        PieChartSliceSelector.prototype.h = function (a) {
            var b = a.dataContext;
            if (!a.isOthersSlice) {
                if (this.a.selectedItem != b) {
                    return b;
                }
                else {
                    return null;
                }
            }
            else {
                if (i2.typeCast(PieSliceOthersContext.$, this.a.selectedItem) !== null) {
                    return null;
                }
                else {
                    return ((function () {
                        var $ret = new PieSliceOthersContext();
                        $ret.data = i2.typeCast(i2.IList_$type, a.dataContext);
                        $ret.slice = a;
                        return $ret;
                    })());
                }
            }
        };
        PieChartSliceSelector.prototype.f = function (a, b) {
            var c = false;
            if (b) {
                if (this.a.selectedItems.contains1(a)) {
                    c = this.g(a);
                }
            }
            else {
                if (!this.a.selectedItems.contains1(a)) {
                    c = this.b(a);
                }
                else {
                    c = this.g(a);
                }
            }
            return c;
        };
        PieChartSliceSelector.prototype.e = function (a) {
            return this.f(a, false);
        };
        PieChartSliceSelector.prototype.g = function (a) {
            var b = new SelectedItemsChangingEventArgs(this.a.selectedItems, new i2.ObjectCollection(0), this.a.selectedItems);
            this.a.gd(this, b);
            if (!b.cancel) {
                this.a.selectedItems.remove1(a);
            }
            return b.cancel;
        };
        PieChartSliceSelector.prototype.b = function (a) {
            var b = new SelectedItemsChangingEventArgs(this.a.selectedItems, ((function () {
                var $ret = new i2.ObjectCollection(0);
                $ret.add1(a);
                return $ret;
            })()), this.a.selectedItems);
            this.a.gd(this, b);
            if (!b.cancel) {
                this.a.selectedItems.add1(a);
            }
            return b.cancel;
        };
        PieChartSliceSelector.prototype.k = function (a) {
            this.a.selectedItem = this.h(a);
        };
        PieChartSliceSelector.prototype.i = function (a) {
            var e_17, _a, e_18, _b;
            var b = new i2.List$1(i2.Base.$, 1, this.a.selectedItems);
            if (a.isOthersSlice) {
                var c = i2.typeCast(i2.IList_$type, a.dataContext);
                var d = 0;
                try {
                    for (var _c = tslib.__values(i2.fromEn(c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var e = _d.value;
                        if (this.a.selectedItems.contains1(e)) {
                            d++;
                        }
                    }
                }
                catch (e_17_1) {
                    e_17 = { error: e_17_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_17)
                            throw e_17.error;
                    }
                }
                var f = d > 0 && d < c.count;
                try {
                    for (var _e = tslib.__values(i2.fromEn(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var g = _f.value;
                        this.f(g, f);
                    }
                }
                catch (e_18_1) {
                    e_18 = { error: e_18_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_18)
                            throw e_18.error;
                    }
                }
                if (this.c(a)) {
                    this.a.selectedItem = ((function () {
                        var $ret = new PieSliceOthersContext();
                        $ret.data = i2.typeCast(i2.IList_$type, a.dataContext);
                        $ret.slice = a;
                        return $ret;
                    })());
                }
                else {
                    this.a.selectedItem = this.a.selectedItems.count > 0 ? this.a.selectedItems._inner[this.a.selectedItems.count - 1] : null;
                }
            }
            else {
                this.e(a.dataContext);
                this.a.selectedItem = this.a.selectedItems.count > 0 ? this.a.selectedItems._inner[this.a.selectedItems.count - 1] : null;
            }
        };
        PieChartSliceSelector.prototype.j = function (a) {
            if (a != null) {
                a.av = true;
                a.isSelected = this.d(a);
                a.av = false;
            }
        };
        PieChartSliceSelector.$t = i2.markType(PieChartSliceSelector, 'PieChartSliceSelector');
        return PieChartSliceSelector;
    }(i2.Base));
    /**
     * @hidden
     */
    var PieSliceOthersContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieSliceOthersContext, _super);
        function PieSliceOthersContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._data = null;
            _this._slice = null;
            return _this;
        }
        Object.defineProperty(PieSliceOthersContext.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (a) {
                this._data = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceOthersContext.prototype, "slice", {
            get: function () {
                return this._slice;
            },
            set: function (a) {
                this._slice = a;
            },
            enumerable: false,
            configurable: true
        });
        PieSliceOthersContext.$t = i2.markType(PieSliceOthersContext, 'PieSliceOthersContext');
        return PieSliceOthersContext;
    }(i2.Base));
    /**
     * @hidden
     */
    var Slice = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Slice, _super);
        function Slice() {
            var _this = _super.call(this) || this;
            _this.al = null;
            _this.b8 = null;
            _this.ai = null;
            _this.aj = null;
            _this.bf = null;
            _this.b9 = null;
            _this.b3 = null;
            _this.aq = false;
            _this.au = false;
            _this.av = false;
            _this.an = false;
            _this.cc = null;
            _this.b0 = null;
            _this.b1 = null;
            var a = _this.ak();
            _this.bl(a);
            a.b();
            _this.av = false;
            return _this;
        }
        Slice.prototype.ak = function () {
            return new SliceView(this);
        };
        Slice.prototype.bl = function (a) {
            this.al = a;
        };
        Object.defineProperty(Slice.prototype, "isSelected", {
            get: function () {
                return this.c(Slice.bv);
            },
            set: function (a) {
                this.h(Slice.bv, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Slice.prototype, "isExploded", {
            get: function () {
                return this.c(Slice.bt);
            },
            set: function (a) {
                this.h(Slice.bt, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Slice.prototype, "isOthersSlice", {
            get: function () {
                return this.c(Slice.bu);
            },
            set: function (a) {
                this.h(Slice.bu, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Slice.prototype, "b2", {
            get: function () {
                return this.c(Slice.bp);
            },
            set: function (a) {
                this.h(Slice.bp, a);
            },
            enumerable: false,
            configurable: true
        });
        Slice.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.al.c();
        };
        Slice.prototype.az = function () {
            var a = Math.abs(PieChartBase.de(this.ax - this.a3)) == 360;
            if (a) {
                return this.a2;
            }
            return this.a2;
        };
        Slice.prototype.cb = function () {
            var a = (this.ai != null && this.ai.b6) ? true : false;
            var b = this.az();
            if (this.isExploded && a && this.ai.dj > 1) {
                var c = new i2.Rect(0, this.b5.x - b, this.b5.y - b, b * 2, b * 2);
                return c;
            }
            return new i2.Rect(0, this.b7.x - b, this.b7.y - b, b * 2, b * 2);
        };
        Slice.prototype.b6 = function () {
            if (this.isExploded && this.ai != null && this.ai.b6 && this.ai.dj > 1) {
                if (this.aq) {
                    return this.b3;
                }
                return this.b5;
            }
            return this.b7;
        };
        Object.defineProperty(Slice.prototype, "aw", {
            get: function () {
                return this.an;
            },
            set: function (a) {
                var b = this.an;
                this.an = a;
                if (b && !this.an) {
                    this.bk();
                }
            },
            enumerable: false,
            configurable: true
        });
        Slice.prototype.bk = function () {
            var _this = this;
            if (this.aw) {
                return;
            }
            var a = this.al.f();
            var b = this.ai.i2;
            if (i2.isNaN_(this.a3) || i2.isNaN_(this.ax) || i2.isNaN_(this.a2) || i2.isNaN_(this.ay) || this.a5 < 0 || this.ai == null || b.width == 0 || b.height == 0 || (this.b7.x == 0 && this.b7.y == 0) || (this.b5.x == 0 && this.b5.y == 0) || this.a3 == this.ax) {
                return;
            }
            this.b8 = this.cb();
            var c = i2.GeometryUtil.e(this.b8);
            var d = this.b8.height / 2;
            var e = this.az();
            var f = i2.RectUtil.l(this.b8);
            var g = Slice.b4(i2.MathUtil.k(this.a3), c, f, d, 100);
            var h = Slice.b4(i2.MathUtil.k(this.ax), c, f, d, 100);
            var i = Slice.b4(i2.MathUtil.k(this.ax), c, f, this.a2, this.a0);
            var j = Slice.b4(i2.MathUtil.k(this.a3), c, f, this.a2, this.a1);
            var k = Math.abs(PieChartBase.de(this.ax - this.a3)) == 360;
            if (k) {
                if (this.a0 == 0) {
                    var l = ((function () {
                        var $ret = new i2.EllipseGeometry();
                        $ret.e = f;
                        $ret.c = _this.a2;
                        $ret.d = _this.a2;
                        return $ret;
                    })());
                    a.ak = l;
                    return;
                }
                else if (this.a0 > 0) {
                    var m_1 = new i2.Size(1, this.a2, this.a2);
                    var n_1 = new i2.Size(1, this.a2 * this.a0 / 100, this.a2 * this.a0 / 100);
                    var o_1 = ((function () {
                        var $ret = i2.PointUtil.create();
                        $ret.x = f.x - _this.a2;
                        $ret.y = f.y;
                        return $ret;
                    })());
                    var p_1 = ((function () {
                        var $ret = i2.PointUtil.create();
                        $ret.x = f.x + _this.a2;
                        $ret.y = f.y;
                        return $ret;
                    })());
                    var q_1 = ((function () {
                        var $ret = i2.PointUtil.create();
                        $ret.x = f.x - _this.a2 * _this.a0 / 100;
                        $ret.y = f.y;
                        return $ret;
                    })());
                    var r_1 = ((function () {
                        var $ret = i2.PointUtil.create();
                        $ret.x = f.x + _this.a2 * _this.a0 / 100;
                        $ret.y = f.y;
                        return $ret;
                    })());
                    var s_1 = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = o_1;
                        return $ret;
                    })());
                    var t = new i2.PathSegmentCollection();
                    var u = ((function () {
                        var $ret = new i2.ArcSegment();
                        $ret.f = m_1;
                        $ret.d = 1;
                        $ret.e = p_1;
                        return $ret;
                    })());
                    t.add(u);
                    s_1._segments = t;
                    var v_1 = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = r_1;
                        return $ret;
                    })());
                    var w = new i2.PathSegmentCollection();
                    var x = ((function () {
                        var $ret = new i2.ArcSegment();
                        $ret.f = n_1;
                        $ret.d = 0;
                        $ret.e = q_1;
                        return $ret;
                    })());
                    w.add(x);
                    v_1._segments = w;
                    var y_1 = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = o_1;
                        return $ret;
                    })());
                    var z = new i2.PathSegmentCollection();
                    var aa = ((function () {
                        var $ret = new i2.ArcSegment();
                        $ret.f = m_1;
                        $ret.d = 0;
                        $ret.e = p_1;
                        return $ret;
                    })());
                    z.add(aa);
                    y_1._segments = z;
                    var ab_1 = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = r_1;
                        return $ret;
                    })());
                    var ac = new i2.PathSegmentCollection();
                    var ad = ((function () {
                        var $ret = new i2.ArcSegment();
                        $ret.f = n_1;
                        $ret.d = 1;
                        $ret.e = q_1;
                        return $ret;
                    })());
                    ac.add(ad);
                    ab_1._segments = ac;
                    var ae_1 = ((function () {
                        var $ret = new i2.PathFigureCollection();
                        $ret.add(s_1);
                        $ret.add(v_1);
                        $ret.add(y_1);
                        $ret.add(ab_1);
                        return $ret;
                    })());
                    var af = ((function () {
                        var $ret = new i2.PathGeometry();
                        $ret.c = ae_1;
                        return $ret;
                    })());
                    var ag = new i2.GeometryGroup();
                    ag.d.add(af);
                    a.ak = ag;
                    return;
                }
                else {
                    var ah = ((function () {
                        var $ret = new i2.GeometryGroup();
                        $ret.c = 0;
                        return $ret;
                    })());
                    ah.d.add(((function () {
                        var $ret = new i2.EllipseGeometry();
                        $ret.e = f;
                        $ret.c = _this.a2;
                        $ret.d = _this.a2;
                        return $ret;
                    })()));
                    ah.d.add(((function () {
                        var $ret = new i2.EllipseGeometry();
                        $ret.e = f;
                        $ret.c = _this.a2 * _this.a0 / 100;
                        $ret.d = _this.a2 * _this.a0 / 100;
                        return $ret;
                    })()));
                    a.ak = ah;
                    return;
                }
            }
            var ai = new i2.PathGeometry();
            a.ak = ai;
            var aj = ((function () {
                var $ret = new i2.PathFigure();
                $ret.isClosed = true;
                return $ret;
            })());
            ai.c = new i2.PathFigureCollection();
            ai.c.add(aj);
            aj._startPoint = g;
            var ak = Math.abs(this.ax - this.a3) > 180;
            var al = new i2.ArcSegment();
            al.e = h;
            al.f = new i2.Size(1, this.b8.width / 2, this.b8.height / 2);
            al.b = ak;
            if (this.ax > this.a3) {
                al.d = 1;
            }
            else {
                al.d = 0;
            }
            aj._segments = new i2.PathSegmentCollection();
            aj._segments.add(al);
            var am = new i2.LineSegment(1);
            am.c = i;
            aj._segments.add(am);
            var an = Math.sqrt(Math.pow(i.x - h.x, 2) + Math.pow(i.y - h.y, 2));
            var ao = e - an;
            var ap = new i2.ArcSegment();
            ap.e = j;
            if (ao < 0) {
                ao = 0.1;
            }
            ap.f = new i2.Size(1, ao, ao);
            ap.b = al.b;
            ap.d = 0;
            aj._segments.add(ap);
            var aq = this.ca(a, g, h, this.a3, this.ax, f, e);
            this.cc = aq;
            var ar = true;
            if (ar && this.b8.height > 0 && this.b8.width > 0 && !b.containsRect(aq)) {
                var as = aq;
                var at = new i2.Rect(0, 0, 0, b.width, b.height);
                at.intersect(as);
                var au = i2.GeometryUtil.i((this.a3 + this.ax) / 2);
                var av = au / 180 * Math.PI;
                var aw = Math.abs((as.height - at.height) / Math.sin(av));
                var ax = Math.abs((as.width - at.width) / Math.cos(av));
                if (i2.isNaN_(aw) || i2.isInfinity(aw)) {
                    aw = 0;
                }
                if (i2.isNaN_(ax) || i2.isInfinity(ax)) {
                    ax = 0;
                }
                var ay = Math.max(aw, ax);
                var az = i2.GeometryUtil.l(this.ai.i2.width, this.ai.i2.height, true, au, this.a2 * this.ai.cx - ay);
                this.al.d(az.x - this.b5.x, az.y - this.b5.y);
                this.aq = true;
                this.b3 = az;
                this.b9 = new i2.Rect(0, as.x - (az.x - this.b5.x), as.y - (az.y - this.b5.y), as.width, as.height);
            }
            else {
                this.aq = false;
                this.al.e();
            }
        };
        Slice.prototype.ap = function (a) {
            var b = this.ai.i2;
            if (this._visibility == 1) {
                return false;
            }
            if (i2.isNaN_(this.a3) || i2.isNaN_(this.ax) || i2.isNaN_(this.a2) || i2.isNaN_(this.ay) || this.a5 < 0 || this.ai == null || b.width == 0 || b.height == 0 || (this.b7.x == 0 && this.b7.y == 0) || (this.b5.x == 0 && this.b5.y == 0)) {
                return false;
            }
            var c = this.az();
            var d = ((this.a0 / 100) * c);
            var e = c;
            var f = this.b7;
            if (this.isExploded && this.ai.b6 && this.ai.dj > 1) {
                f = this.b5;
                if (this.aq) {
                    f = this.b3;
                }
            }
            var g = d * d;
            var h = e * e;
            var i = Math.pow(a.x - f.x, 2) + Math.pow(a.y - f.y, 2);
            if (i < g || i > h) {
                return false;
            }
            var j = Math.atan2(a.y - f.y, a.x - f.x);
            j = j * 180 / Math.PI;
            return this.ao(j);
        };
        Slice.prototype.ao = function (a) {
            a = i2.GeometryUtil.i(a);
            var b = Math.min(this.a3, this.ax);
            var c = Math.max(this.a3, this.ax);
            return (a > b && a < c) || (a - 360 > b && a - 360 < c) || (a + 360 > b && a + 360 < c);
        };
        Slice.prototype.ca = function (a, b, c, d, e, f, g) {
            var e_19, _a;
            var h = new i2.List$1(i2.Point_$type, 0);
            h.add(b);
            h.add(c);
            h.add(f);
            d = i2.GeometryUtil.i(d);
            e = i2.GeometryUtil.i(e);
            if ((0 > d && 0 < e) || (360 > d && 360 < e) || (e < d)) {
                h.add(i2.GeometryUtil.m(f, 0, g));
            }
            if (90 > d && 90 < e) {
                h.add(i2.GeometryUtil.m(f, 90, g));
            }
            if (180 > d && 180 < e) {
                h.add(i2.GeometryUtil.m(f, 180, g));
            }
            if (270 > d && 270 < e) {
                h.add(i2.GeometryUtil.m(f, 270, g));
            }
            var i = 1.7976931348623157E+308;
            var j = 1.7976931348623157E+308;
            var k = -1.7976931348623157E+308;
            var l = -1.7976931348623157E+308;
            try {
                for (var _b = tslib.__values(i2.fromEnum(h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var m = _c.value;
                    i = Math.min(i, m.x);
                    j = Math.min(j, m.y);
                    k = Math.max(k, m.x);
                    l = Math.max(l, m.y);
                }
            }
            catch (e_19_1) {
                e_19 = { error: e_19_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_19)
                        throw e_19.error;
                }
            }
            return new i2.Rect(0, i, j, k - i, l - j);
        };
        Slice.prototype.am = function () {
            var a = new PieSliceVisualData();
            a.appearance = new i2.PrimitiveAppearanceData();
            a.labelAppearance = new i2.LabelAppearanceData();
            a.leaderLineAppearance = new i2.PrimitiveAppearanceData();
            a.startAngle = this.a3;
            a.endAngle = this.ax;
            a.explodedOrigin = i2.PointData.b(this.b5);
            a.explodedRadius = this.ay;
            a.origin = i2.PointData.b(this.b7);
            a.radius = this.az();
            a.index = this.a5;
            a.innerExtentEnd = this.a0;
            a.innerExtentStart = this.a1;
            a.isExploded = this.isExploded;
            a.isOthersSlice = this.isOthersSlice;
            a.isSelected = this.isSelected;
            if (this.aj != null) {
                a.labelAppearance.angle = this.aj.ai;
                a.labelBounds = i2.RectData.b(this.aj.ao);
                a.labelAngle = this.aj.ai;
                if (i2.typeCast(i2.TextBlock.$, this.aj.aj) !== null) {
                    var b = i2.typeCast(i2.TextBlock.$, this.aj.aj);
                    a.label = b.ak;
                    var c = null;
                    a.labelAppearance.labelBrush = i2.AppearanceHelper.b(b.am);
                    a.labelAppearance.text = b.ak;
                    if (this.ai != null) {
                        c = this.ai.bl();
                        if (c == null) {
                            c = this.ai.a3.b.c;
                        }
                    }
                    a.labelAppearance = i2.AppearanceHelper.c(b, c);
                    a.labelAppearance.visibility = this.aj._visibility == 0;
                }
                else {
                    a.label = this.aj.aj.toString();
                }
                if (this.aj.ap != null) {
                    a.leaderLineAppearance.fill = i2.AppearanceHelper.b(this.aj.ap._fill);
                    a.leaderLineAppearance.opacity = this.aj.ap._opacity;
                    a.leaderLineAppearance.stroke = i2.AppearanceHelper.b(this.aj.ap._stroke);
                    a.leaderLineAppearance.strokeThickness = this.aj.ap.ac;
                    a.leaderLineAppearance.isVisible = this.aj.ap._visibility == 0;
                    a.leaderLinePath = new i2.PathVisualData(2, "leaderLine", this.aj.ap);
                }
                else if (this.aj.aq != null) {
                    a.leaderLineAppearance.fill = i2.AppearanceHelper.b(this.aj.aq._fill);
                    a.leaderLineAppearance.opacity = this.aj.aq._opacity;
                    a.leaderLineAppearance.stroke = i2.AppearanceHelper.b(this.aj.aq._stroke);
                    a.leaderLineAppearance.strokeThickness = this.aj.aq.ac;
                    a.leaderLineAppearance.isVisible = this.aj.aq._visibility == 0;
                    a.leaderLinePath = new i2.PathVisualData(1, "leaderLine", this.aj.aq);
                }
            }
            if (this.al != null) {
                var d = this.al.f();
                a.slicePath = new i2.PathVisualData(1, "slicePath", d);
                a.appearance.fill = i2.AppearanceHelper.b(d._fill);
                a.appearance.opacity = d._opacity;
                a.appearance.stroke = i2.AppearanceHelper.b(d._stroke);
                a.appearance.strokeThickness = d.ac;
                a.appearance.isVisible = d._visibility == 0;
            }
            return a;
        };
        Slice.b4 = function (a, b, c, d, e) {
            if (d == 0) {
                return c;
            }
            var f = Math.cos(a);
            var g = Math.sin(a);
            var h = Math.sqrt(d * d / (1 - (b * Math.pow(f, 2))));
            h *= (e / 100);
            return { $type: i2.Point_$type, x: h * f + c.x, y: h * g + c.y };
        };
        Slice.$t = i2.markType(Slice, 'Slice', i2.ContentControl.$);
        Slice.bv = i2.DependencyProperty.i("IsSelected", i2.Boolean_$type, Slice.$, new i2.PropertyMetadata(2, false, function (a, b) {
            var c = i2.typeCast(Slice.$, a);
            if (!c.av) {
                var d = b.newValue;
                if (c.ai != null) {
                    c.ai.gx(c, d);
                }
            }
        }));
        Slice.bt = i2.DependencyProperty.i("IsExploded", i2.Boolean_$type, Slice.$, new i2.PropertyMetadata(2, false, function (a, b) {
            var c = i2.typeCast(Slice.$, a);
            var d = b.newValue;
            if (c.ai != null) {
                c.ai.fu(c, d);
            }
        }));
        Slice.bu = i2.DependencyProperty.i("IsOtherSlice", i2.Boolean_$type, Slice.$, new i2.PropertyMetadata(2, false, function (a, b) { return a.bk(); }));
        Slice.bp = i2.DependencyProperty.i("Foreground", i2.Brush.$, Slice.$, new i2.PropertyMetadata(1, null));
        Slice.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, Slice, 'bk', ['EndAngle:ax:bm', [1, 0], 'ExplodedOrigin:b5:bn', [i2.Point_$type, i2.PointUtil.create()], 'ExplodedRadius:ay:bo', [1, 0], 'Index:a5:bq', [1, -1], 'InnerExtentEnd:a0:br', [1, 0], 'InnerExtentStart:a1:bs', [1, 0], 'Origin:b7:bw', [i2.Point_$type, i2.PointUtil.create()], 'Radius:a2:bx', [1, 0], 'StartAngle:a3:by', [1, 0], 'StrokeThickness:a4:bz', [1, 1]]);
        return Slice;
    }(i2.ContentControl));
    /**
     * @hidden
     */
    var PieChartBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieChartBaseView, _super);
        function PieChartBaseView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.bs = null;
            _this.b = null;
            _this.h = null;
            _this.j = null;
            _this.i = null;
            _this.k = null;
            _this.c = null;
            _this.b2 = null;
            _this.l = false;
            _this.bz = i2.Rect.empty;
            _this.f = null;
            _this.u = null;
            _this.t = null;
            _this.v = 0;
            _this.by = null;
            _this.ag = null;
            _this.s = false;
            _this.e = null;
            _this.a = a;
            _this.c = new PieChartViewManager(_this);
            return _this;
        }
        PieChartBaseView.prototype.a1 = function () {
            this.e = new PieSliceDataContext();
            this.e.series = this.a;
            this.b2 = i2.Rect.empty;
            this.u = new i2.List$1(Slice.$, 0);
            this.t = new i2.List$1(PieLabel.$, 0);
            this.a.legendItemTemplate = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = PieLegendTemplates.f;
                $ret.measure = PieLegendTemplates.a;
                return $ret;
            })());
            this.a.legendItemBadgeTemplate = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = PieLegendTemplates.e;
                $ret.measure = PieLegendTemplates.d;
                return $ret;
            })());
            this.c.z();
        };
        PieChartBaseView.prototype.bb = function () {
            var a = this.c.b();
            if (this.a.am == null) {
                this.a.am = a.a;
            }
            if (this.a.an == null) {
                this.a.an = a.b;
            }
            if (this.a.i5 == null) {
                this.a.i5 = ((function () {
                    var $ret = new i2.Style();
                    $ret.fill = a.h != null ? a.h.color.colorString : null;
                    $ret.stroke = a.i != null ? a.i.color.colorString : null;
                    $ret.strokeThickness = a.e;
                    $ret.opacity = a.d;
                    return $ret;
                })());
            }
            this.b = a;
            if (this.a.fl != null) {
                this.b.c = this.a.bl();
            }
        };
        PieChartBaseView.prototype.ax = function () {
            this.c.ab();
        };
        PieChartBaseView.prototype.a0 = function () {
            this.c.ae();
        };
        PieChartBaseView.prototype.ay = function (a) {
            if (a == null) {
                this.l = false;
                this.c.ac(null);
                this.h = null;
                this.j = null;
                this.i = null;
                this.k = null;
                return;
            }
            this.c.ac(a);
            this.h = this.c.e;
            this.j = this.c.g;
            this.i = this.c.f;
            this.k = this.c.h;
        };
        PieChartBaseView.prototype.b0 = function () {
            return this.b2;
        };
        PieChartBaseView.prototype.bx = function () {
            return this.c.an();
        };
        PieChartBaseView.prototype.ba = function () {
            this.b2 = this.c.ao();
            this.a.ge();
        };
        PieChartBaseView.prototype.av = function () {
            if (!this.l) {
                this.l = true;
                this.c.ah(i2.runOn(this, this.bi));
            }
        };
        PieChartBaseView.prototype.bi = function () {
            if (this.l) {
                this.l = false;
                this.a5();
            }
        };
        PieChartBaseView.prototype.a5 = function () {
            this.am();
            this.c.w(this.b2.width, this.b2.height);
            var a = this.k == this.j;
            if (this.k != null && this.k.d && !a) {
                if (this.a.cz != 1) {
                    this.k.z();
                    this.k.aa(this.a.cz, this.a.cz);
                }
                if (!this.bz.isEmpty) {
                    this.k.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
                }
            }
            if (this.i != null && this.i.d && !a) {
                if (this.a.cz != 1) {
                    this.i.z();
                    this.i.aa(this.a.cz, this.a.cz);
                }
                if (!this.bz.isEmpty) {
                    this.i.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
                }
            }
            if (this.j != null && this.j.d) {
                if (this.a.cz != 1) {
                    this.j.z();
                    this.j.aa(this.a.cz, this.a.cz);
                }
                if (!this.bz.isEmpty) {
                    this.j.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
                }
            }
            if (this.h != null && this.h.d && !a) {
                if (this.a.cz != 1) {
                    this.h.z();
                    this.h.aa(this.a.cz, this.a.cz);
                }
                if (!this.bz.isEmpty) {
                    this.h.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
                }
            }
            this.a6();
            if (!this.bz.isEmpty && this.a.cz != 1) {
                if (this.k != null && this.k.d && !a) {
                    this.k.y();
                }
                if (this.i != null && this.i.d && !a) {
                    this.i.y();
                }
                if (this.j != null && this.j.d) {
                    this.j.y();
                }
                if (this.h != null && this.h.d && !a) {
                    this.h.y();
                }
            }
        };
        PieChartBaseView.prototype.a6 = function () {
            var e_20, _a;
            this.bz = this.b2;
            if (this.j != null && this.j.d) {
                this.a9();
                this.a7();
            }
            if (this.i != null && this.i.d) {
                var a = this.b.c;
                if (this.a.fl != null) {
                    a = this.a.bl();
                }
                this.i.ac(a);
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.t)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        if (b._visibility == 0) {
                            var c = b.aj;
                            if (c != null) {
                                {
                                    if (b.ah.b2 == null) {
                                        if (b.ah.au) {
                                            c.am = this.b.f;
                                        }
                                        else {
                                            c.am = this.b.g;
                                        }
                                    }
                                    else {
                                        c.am = b.ah.b2;
                                    }
                                    this.i.w(c);
                                }
                            }
                            var d = b.ah.b0;
                            if (b.ah.y != null) {
                                var e = new i2.Path();
                                this.j.i(e, b.ah.y);
                                if (e._fill != null) {
                                    d = e._fill;
                                }
                            }
                            if (this.a.a0 != 0 && b.aq != null) {
                                b.aq._stroke = d;
                                b.aq.ac = 1;
                                if (this.a.i3 != null) {
                                    this.i.i(b.aq, this.a.i3);
                                }
                                this.i.s(b.aq);
                            }
                            if (this.a.a0 == 0 && b.ap != null) {
                                b.ap._stroke = d;
                                b.ap.ac = 1;
                                if (this.a.i3 != null) {
                                    this.i.i(b.ap, this.a.i3);
                                }
                                this.i.r(b.ap);
                            }
                        }
                    }
                }
                catch (e_20_1) {
                    e_20 = { error: e_20_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_20)
                            throw e_20.error;
                    }
                }
            }
        };
        PieChartBaseView.prototype.a8 = function (a) {
            if (a._visibility != 0) {
                return;
            }
            var b = a.al.f();
            this.c.ai(b);
            b.ac = 1;
            b._opacity = a._opacity;
            if (a.b0 != null) {
                b._fill = a.b0;
            }
            if (a.b1 != null) {
                b._stroke = a.b1;
            }
            if (a.y != null) {
                this.j.i(b, a.y);
            }
            if (b.j != null) {
                this.j.z();
                this.j.j(b.j);
            }
            var c = b._fill;
            var d = b._stroke;
            var e = this.m(a, b, this.j);
            this.j.s(b);
            if (e) {
                b._fill = c;
                b._stroke = d;
            }
            if (b.j != null) {
                this.j.y();
            }
        };
        PieChartBaseView.prototype.a9 = function () {
            var e_21, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (!a.isSelected) {
                        this.a8(a);
                    }
                }
            }
            catch (e_21_1) {
                e_21 = { error: e_21_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_21)
                        throw e_21.error;
                }
            }
        };
        PieChartBaseView.prototype.a7 = function () {
            var e_22, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (a.isSelected) {
                        this.a8(a);
                    }
                }
            }
            catch (e_22_1) {
                e_22 = { error: e_22_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_22)
                        throw e_22.error;
                }
            }
        };
        PieChartBaseView.prototype.m = function (a, b, c) {
            return false;
        };
        PieChartBaseView.prototype.aj = function (a, b, c) {
            var d = this.f;
            this.bj(a);
            if (this.f == null && d != null) {
                var e = ((function () {
                    var $ret = new i2.MouseEventArgs();
                    $ret.position = a;
                    return $ret;
                })());
                this.a.fx(this.f, e);
            }
            else if (this.f != null) {
                var f = ((function () {
                    var $ret = new i2.MouseEventArgs();
                    $ret.position = a;
                    return $ret;
                })());
                this.a.fy(this.f, f);
            }
        };
        PieChartBaseView.prototype.ai = function (a) {
            var b = this.f;
            this.bj(a);
            var c = ((function () {
                var $ret = new i2.MouseEventArgs();
                $ret.position = a;
                return $ret;
            })());
            this.a.fx(b, c);
        };
        PieChartBaseView.prototype.ah = function (a) {
            this.bj(a);
        };
        PieChartBaseView.prototype.ak = function (a) {
            this.ap(a);
        };
        PieChartBaseView.prototype.ap = function (a) {
            var e_23, _a;
            var b = ((function () {
                var $ret = new i2.MouseButtonEventArgs();
                $ret.position = a;
                return $ret;
            })());
            var c = true;
            var d = null;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.t)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    var f = e.ao.containsPoint(a);
                    if (f) {
                        d = e;
                        c = this.a.cd(e.ah, b);
                        break;
                    }
                }
            }
            catch (e_23_1) {
                e_23 = { error: e_23_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_23)
                        throw e_23.error;
                }
            }
            this.bj(a);
            if (this.f == null && c && d != null) {
                this.a.g1(d.ah, b);
            }
            else if (this.f != null && c) {
                this.a.g1(this.f, b);
            }
        };
        PieChartBaseView.prototype.bj = function (a) {
            this.f = null;
            for (var b = 0; b < this.u.count; b++) {
                if (this.u._inner[b]._visibility == 0 && this.u._inner[b].ap(a)) {
                    this.f = this.u._inner[b];
                    break;
                }
            }
        };
        PieChartBaseView.prototype.n = function (a) {
            var e_24, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.t)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    var c = b.ao.containsPoint(a);
                    if (c) {
                        return true;
                    }
                }
            }
            catch (e_24_1) {
                e_24 = { error: e_24_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_24)
                        throw e_24.error;
                }
            }
            return false;
        };
        PieChartBaseView.prototype.p = function (a) {
            for (var b = 0; b < this.u.count; b++) {
                if (this.u._inner[b]._visibility == 0 && this.u._inner[b].ap(a)) {
                    return true;
                }
            }
            return false;
        };
        PieChartBaseView.prototype.o = function (a) {
            return this.n(a) || this.p(a);
        };
        PieChartBaseView.prototype.bd = function () {
            this.a.ge();
        };
        PieChartBaseView.prototype.al = function () {
            this.aq();
        };
        PieChartBaseView.prototype.bn = function (a, b) {
            var c = b;
            this.bo(c.position, a, b);
        };
        PieChartBaseView.prototype.g = function () {
            var a = new Slice();
            a.ai = this.a;
            this.u.add(a);
            return a;
        };
        PieChartBaseView.prototype.be = function (a) {
            a._visibility = 0;
        };
        PieChartBaseView.prototype.bg = function (a) {
            a._visibility = 1;
        };
        PieChartBaseView.prototype.bf = function (a) {
            a.ai = null;
            this.u.remove(a);
        };
        PieChartBaseView.prototype.d = function () {
            var a = new PieLabel();
            if (this.a.a0 == 0) {
                a.ap = new i2.Line();
            }
            else {
                a.aq = new i2.Path();
                var b = new i2.PathGeometry();
                b.c.add(new i2.PathFigure());
                b.c._inner[0]._segments.add(new i2.BezierSegment(0));
                a.aq.ak = b;
            }
            this.t.add(a);
            return a;
        };
        PieChartBaseView.prototype.ar = function (a) {
            a._visibility = 0;
        };
        PieChartBaseView.prototype.at = function (a) {
            a._visibility = 1;
        };
        PieChartBaseView.prototype.as = function (a) {
            this.t.remove(a);
        };
        PieChartBaseView.prototype.bl = function (a) {
            if ((this.a.a0 != 0 && a.aq != null) || (this.a.a0 == 0 && a.ap != null)) {
                return;
            }
            if (this.a.a0 == 0) {
                a.aq = null;
                a.ap = new i2.Line();
            }
            else {
                a.ap = null;
                a.aq = new i2.Path();
                var b = new i2.PathGeometry();
                var c = new i2.PathFigure();
                c._startPoint = { $type: i2.Point_$type, x: NaN, y: NaN };
                b.c.add(c);
                b.c._inner[0]._segments.add(new i2.BezierSegment(0));
                a.aq.ak = b;
            }
        };
        PieChartBaseView.prototype.bc = function (a) {
            if (this.a.i4 != null && a.isOthersSlice) {
                a.b0 = this.bv(a.a5);
                a.b1 = this.bw(a.a5);
                a.y = this.a.i4;
            }
            else if (a.isSelected && this.a.b7 && this.a.i5 != null) {
                a.y = this.a.i5;
            }
            else {
                a.y = null;
                a.b0 = this.bv(a.a5);
                a.b1 = this.bw(a.a5);
            }
        };
        PieChartBaseView.prototype.bv = function (a) {
            if (this.a.ak != null && a >= 0 && this.a.ak.count > 0) {
                return this.a.ak.item(a % this.a.ak.count);
            }
            return null;
        };
        PieChartBaseView.prototype.bw = function (a) {
            if (this.a.al != null && a >= 0 && this.a.al.count > 0) {
                return this.a.al.item(a % this.a.al.count);
            }
            return null;
        };
        PieChartBaseView.prototype.ad = function (a) {
            if (a == null || a.aj == null) {
                return this.a.ef;
            }
            var b = a.aj;
            var c = b.aj;
            if (i2.typeCast(i2.TextBlock.$, c) !== null) {
                return c.ak;
            }
            return c;
        };
        PieChartBaseView.prototype.y = function (a) {
            var b = i2.typeCast(i2.TextBlock.$, a);
            if (b != null && b.ak != null && this.i != null) {
                return this.i.e(b) + 0;
            }
            return 0;
        };
        PieChartBaseView.prototype.bk = function () {
            this.v = i2.FontUtil.getCurrentFontHeight(this.c.n, this.c.d());
        };
        PieChartBaseView.prototype.x = function (a) {
            return this.v + 0;
        };
        PieChartBaseView.prototype.b1 = function (a) {
            var b = a.aj;
            if (i2.typeCast(i2.TextBlock.$, b) !== null) {
                var c = this.y(b);
                var d = this.x(b);
                return new i2.Rect(0, 0, 0, c, d);
            }
            return i2.Rect.empty;
        };
        PieChartBaseView.prototype.b3 = function () {
            return new i2.Size(1, this.b2.width, this.b2.height);
        };
        PieChartBaseView.prototype.bm = function (a, b, c) {
            var d = i2.typeCast(i2.TextBlock.$, a.aj);
            if (d != null) {
                d.n = b;
                d.o = c;
            }
            this.av();
        };
        PieChartBaseView.prototype.bp = function (a) {
            this.bq(a);
        };
        PieChartBaseView.prototype.br = function () {
            this.av();
        };
        PieChartBaseView.prototype.au = function () {
            this.am();
        };
        PieChartBaseView.prototype.am = function () {
            var a = this.b.c;
            if (this.a.fl != null) {
                a = this.a.bl();
            }
            if (this.i != null) {
                this.i.ac(a);
            }
        };
        PieChartBaseView.prototype.az = function (a, b) {
            this.c.ad(a, b);
        };
        PieChartBaseView.prototype.aw = function () {
            this.c.aa();
        };
        Object.defineProperty(PieChartBaseView.prototype, "af", {
            get: function () {
                return this.c != null && this.c.n != null ? this.c.n.getResourceString("invalidLabelBinding") : "There is no such value for the labels to bind.";
            },
            enumerable: false,
            configurable: true
        });
        PieChartBaseView.prototype.aq = function () {
            if (this.s == true) {
                this.s = false;
                this.c.y(this.e);
            }
        };
        PieChartBaseView.prototype.bq = function (a) {
            this.c.ak(a);
        };
        PieChartBaseView.prototype.bo = function (a, b, c) {
            this.s = true;
            this.by = a;
            if (b == null) {
                this.ag = null;
                this.e.item = null;
            }
            else {
                this.ag = b.dataContext;
                this.e.item = b.dataContext;
                this.e.slice = b;
            }
            var d = this.a.iz();
            var pos_ = { $type: i2.Point_$type, x: a.x + 15 + d.x, y: a.y + 15 + d.y };
            var context_ = this.e;
            this.c.aj(pos_, context_);
        };
        PieChartBaseView.prototype.bh = function () {
            this.bb();
            this.bk();
            this.a.gr();
        };
        PieChartBaseView.prototype.a2 = function () {
            this.c.af(this.a.cc);
        };
        PieChartBaseView.prototype.ac = function () {
            return this.c.t();
        };
        PieChartBaseView.prototype.ao = function () {
            if (this.l) {
                this.bi();
            }
        };
        PieChartBaseView.prototype.r = function () {
            return this.ac() != null;
        };
        PieChartBaseView.prototype.an = function (a) {
            this.c.x(a);
        };
        PieChartBaseView.prototype.q = function () {
            return true;
        };
        PieChartBaseView.prototype.a4 = function () {
        };
        PieChartBaseView.prototype.bt = function (a) {
            var b = this.c.al(a.y);
            if (b != null) {
                return b;
            }
            return a.b0;
        };
        PieChartBaseView.prototype.bu = function (a) {
            var b = this.c.am(a.y);
            if (b != null) {
                return b;
            }
            return a.b1;
        };
        PieChartBaseView.prototype.w = function (a) {
            return this.c.m(a.y);
        };
        PieChartBaseView.prototype.z = function (a) {
            return this.c.m(a);
        };
        PieChartBaseView.prototype.aa = function () {
            var e_25, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (!a.isSelected) {
                        return a.a4;
                    }
                }
            }
            catch (e_25_1) {
                e_25 = { error: e_25_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_25)
                        throw e_25.error;
                }
            }
            return NaN;
        };
        PieChartBaseView.prototype.a3 = function () {
            this.c.ag();
            this.av();
        };
        PieChartBaseView.prototype.ae = function (a) {
            return this.c.c.ap;
        };
        PieChartBaseView.$t = i2.markType(PieChartBaseView, 'PieChartBaseView');
        return PieChartBaseView;
    }(i2.Base));
    /**
     * @hidden
     */
    var PieSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PieSliceDataContext, _super);
        function PieSliceDataContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._slice = null;
            _this._percentValue = 0;
            _this._isOthersSlice = false;
            return _this;
        }
        Object.defineProperty(PieSliceDataContext.prototype, "slice", {
            get: function () {
                return this._slice;
            },
            set: function (a) {
                this._slice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceDataContext.prototype, "percentValue", {
            get: function () {
                return this._percentValue;
            },
            set: function (a) {
                this._percentValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PieSliceDataContext.prototype, "isOthersSlice", {
            get: function () {
                return this._isOthersSlice;
            },
            set: function (a) {
                this._isOthersSlice = a;
            },
            enumerable: false,
            configurable: true
        });
        PieSliceDataContext.prototype.flatten = function () {
            var e_26, _a;
            var ret_ = _super.prototype.flatten.call(this);
            var percentValue_ = this.percentValue;
            var isOthersSlice_ = this.isOthersSlice;
            ret_.percentValue = percentValue_;
            ret_.isOthersSlice = isOthersSlice_;
            if (isOthersSlice_ && this.item != null) {
                var items_ = [];
                try {
                    for (var _b = tslib.__values(i2.fromEn(this.item)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var currItem_ = _c.value;
                        items_.push(currItem_);
                    }
                }
                catch (e_26_1) {
                    e_26 = { error: e_26_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_26)
                            throw e_26.error;
                    }
                }
                ret_.item = items_;
            }
            return ret_;
        };
        PieSliceDataContext.$t = i2.markType(PieSliceDataContext, 'PieSliceDataContext', i2.DataContext.$);
        return PieSliceDataContext;
    }(i2.DataContext));
    /**
     * @hidden
     */
    var SliceView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceView, _super);
        function SliceView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.g = null;
            _this.a = a;
            return _this;
        }
        SliceView.prototype.b = function () {
            this.g = new i2.Path();
            this.a.content = this.g;
        };
        SliceView.prototype.c = function () {
            this.a.bk();
        };
        SliceView.prototype.f = function () {
            return this.g;
        };
        SliceView.prototype.d = function (a, b) {
            this.g.j = ((function () {
                var $ret = new i2.TranslateTransform();
                $ret.j = a;
                $ret.k = b;
                return $ret;
            })());
        };
        SliceView.prototype.e = function () {
            this.g.j = null;
        };
        SliceView.$t = i2.markType(SliceView, 'SliceView');
        return SliceView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HoleDimensionsChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HoleDimensionsChangedEventArgs, _super);
        function HoleDimensionsChangedEventArgs(a, b) {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.b = 0;
            _this.d = a;
            _this.b = b;
            return _this;
        }
        Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "center", {
            get: function () {
                return this.d;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "radius", {
            get: function () {
                return this.b;
            },
            enumerable: false,
            configurable: true
        });
        HoleDimensionsChangedEventArgs.$t = i2.markType(HoleDimensionsChangedEventArgs, 'HoleDimensionsChangedEventArgs', i2.EventArgs.$);
        return HoleDimensionsChangedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DoughnutChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DoughnutChartVisualData, _super);
        function DoughnutChartVisualData() {
            var _this = _super.call(this) || this;
            _this._series = null;
            _this._height = 0;
            _this._width = 0;
            _this._holeRadius = 0;
            _this._dipScalingRatio = 0;
            _this._viewport = null;
            _this.dipScalingRatio = 1;
            return _this;
        }
        Object.defineProperty(DoughnutChartVisualData.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DoughnutChartVisualData.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DoughnutChartVisualData.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (a) {
                this._width = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DoughnutChartVisualData.prototype, "holeRadius", {
            get: function () {
                return this._holeRadius;
            },
            set: function (a) {
                this._holeRadius = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DoughnutChartVisualData.prototype, "dipScalingRatio", {
            get: function () {
                return this._dipScalingRatio;
            },
            set: function (a) {
                this._dipScalingRatio = a;
            },
            enumerable: false,
            configurable: true
        });
        DoughnutChartVisualData.prototype.scaleByViewport = function () {
            var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
            if (this.series != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var a = _f.value;
                        try {
                            for (var _g = (e_2 = void 0, tslib.__values(i2.fromEnum(a.rings))), _h = _g.next(); !_h.done; _h = _g.next()) {
                                var b = _h.value;
                                try {
                                    for (var _j = (e_3 = void 0, tslib.__values(i2.fromEnum(b.arcs))), _k = _j.next(); !_k.done; _k = _j.next()) {
                                        var c = _k.value;
                                        try {
                                            for (var _l = (e_4 = void 0, tslib.__values(i2.fromEnum(c.a))), _m = _l.next(); !_m.done; _m = _l.next()) {
                                                var d = _m.value;
                                                d.scaleByViewport(this.viewport);
                                            }
                                        }
                                        catch (e_4_1) {
                                            e_4 = { error: e_4_1 };
                                        }
                                        finally {
                                            try {
                                                if (_m && !_m.done && (_d = _l.return))
                                                    _d.call(_l);
                                            }
                                            finally {
                                                if (e_4)
                                                    throw e_4.error;
                                            }
                                        }
                                    }
                                }
                                catch (e_3_1) {
                                    e_3 = { error: e_3_1 };
                                }
                                finally {
                                    try {
                                        if (_k && !_k.done && (_c = _j.return))
                                            _c.call(_j);
                                    }
                                    finally {
                                        if (e_3)
                                            throw e_3.error;
                                    }
                                }
                            }
                        }
                        catch (e_2_1) {
                            e_2 = { error: e_2_1 };
                        }
                        finally {
                            try {
                                if (_h && !_h.done && (_b = _g.return))
                                    _b.call(_g);
                            }
                            finally {
                                if (e_2)
                                    throw e_2.error;
                            }
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_a = _e.return))
                            _a.call(_e);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        DoughnutChartVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (!i2.isNaN_(this.width)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("width: ");
                a.u(this.width.toString());
            }
            if (!i2.isNaN_(this.height)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("height: ");
                a.u(this.height.toString());
            }
            if (!i2.isNaN_(this.holeRadius)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("holeRadius: ");
                a.u(this.holeRadius.toString());
            }
            if (this.viewport != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.u("viewport: {");
                a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
                a.u("}");
            }
            if (this.series != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.u("series: [");
                for (var c = 0; c < this.series.count; c++) {
                    if (c != 0) {
                        a.l(", ");
                    }
                    a.l(this.series._inner[c].serialize());
                }
                a.u("]");
            }
            if (!b) {
                a.l(", ");
            }
            a.l("dipScalingRatio: " + this.dipScalingRatio.toString());
            a.u("}");
            return a.toString();
        };
        Object.defineProperty(DoughnutChartVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        DoughnutChartVisualData.$t = i2.markType(DoughnutChartVisualData, 'DoughnutChartVisualData');
        return DoughnutChartVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RingSeriesVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingSeriesVisualData, _super);
        function RingSeriesVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._name = null;
            _this._labelExtent = 0;
            _this._labelsPosition = null;
            _this._leaderLineType = null;
            _this._leaderLineVisibility = false;
            _this._leaderLineMargin = 0;
            _this._rings = null;
            return _this;
        }
        Object.defineProperty(RingSeriesVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesVisualData.prototype, "labelExtent", {
            get: function () {
                return this._labelExtent;
            },
            set: function (a) {
                this._labelExtent = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesVisualData.prototype, "labelsPosition", {
            get: function () {
                return this._labelsPosition;
            },
            set: function (a) {
                this._labelsPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesVisualData.prototype, "leaderLineType", {
            get: function () {
                return this._leaderLineType;
            },
            set: function (a) {
                this._leaderLineType = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesVisualData.prototype, "leaderLineVisibility", {
            get: function () {
                return this._leaderLineVisibility;
            },
            set: function (a) {
                this._leaderLineVisibility = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesVisualData.prototype, "leaderLineMargin", {
            get: function () {
                return this._leaderLineMargin;
            },
            set: function (a) {
                this._leaderLineMargin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesVisualData.prototype, "rings", {
            get: function () {
                return this._rings;
            },
            set: function (a) {
                this._rings = a;
            },
            enumerable: false,
            configurable: true
        });
        RingSeriesVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (this.name != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("name: ");
                a.u("'" + this.name + "'");
            }
            if (!i2.isNaN_(this.labelExtent)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("labelExtent: ");
                a.u(this.labelExtent.toString());
            }
            if (this.labelsPosition != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("labelsPosition: ");
                a.u("'" + this.labelsPosition + "'");
            }
            if (this.leaderLineType != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("leaderLineType: ");
                a.u("'" + this.leaderLineType + "'");
            }
            a.l(", leaderLineVisibility: ");
            a.u(this.leaderLineVisibility ? "true" : "false");
            if (!i2.isNaN_(this.leaderLineMargin)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("leaderLineMargin: ");
                a.u(this.leaderLineMargin.toString());
            }
            a.u(", rings: [");
            for (var c = 0; c < this.rings.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.rings._inner[c].serialize());
            }
            a.u("]}");
            return a.toString();
        };
        RingSeriesVisualData.$t = i2.markType(RingSeriesVisualData, 'RingSeriesVisualData');
        return RingSeriesVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RingSeriesVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingSeriesVisualDataList, _super);
        function RingSeriesVisualDataList() {
            return _super.call(this, RingSeriesVisualData.$, 0) || this;
        }
        RingSeriesVisualDataList.$t = i2.markType(RingSeriesVisualDataList, 'RingSeriesVisualDataList', i2.List$1.$.specialize(RingSeriesVisualData.$));
        return RingSeriesVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceVisualData, _super);
        function SliceVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._pieSlice = null;
            _this._outline = null;
            _this._labelVisualData = null;
            _this._backgroundPath = null;
            _this._origin = null;
            _this._explodedOrigin = null;
            _this._isExploded = false;
            _this._isSelected = false;
            _this._index = 0;
            _this._radius = 0;
            _this._startAngle = 0;
            _this._endAngle = 0;
            _this._visibility = false;
            return _this;
        }
        Object.defineProperty(SliceVisualData.prototype, "pieSlice", {
            get: function () {
                return this._pieSlice;
            },
            set: function (a) {
                this._pieSlice = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "outline", {
            get: function () {
                return this._outline;
            },
            set: function (a) {
                this._outline = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "labelVisualData", {
            get: function () {
                return this._labelVisualData;
            },
            set: function (a) {
                this._labelVisualData = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "backgroundPath", {
            get: function () {
                return this._backgroundPath;
            },
            set: function (a) {
                this._backgroundPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "origin", {
            get: function () {
                return this._origin;
            },
            set: function (a) {
                this._origin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "explodedOrigin", {
            get: function () {
                return this._explodedOrigin;
            },
            set: function (a) {
                this._explodedOrigin = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "isExploded", {
            get: function () {
                return this._isExploded;
            },
            set: function (a) {
                this._isExploded = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "isSelected", {
            get: function () {
                return this._isSelected;
            },
            set: function (a) {
                this._isSelected = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "index", {
            get: function () {
                return this._index;
            },
            set: function (a) {
                this._index = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "radius", {
            get: function () {
                return this._radius;
            },
            set: function (a) {
                this._radius = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "startAngle", {
            get: function () {
                return this._startAngle;
            },
            set: function (a) {
                this._startAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "endAngle", {
            get: function () {
                return this._endAngle;
            },
            set: function (a) {
                this._endAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceVisualData.prototype, "visibility", {
            get: function () {
                return this._visibility;
            },
            set: function (a) {
                this._visibility = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceVisualData.prototype.scaleByViewport = function (a) {
            this.origin = new i2.PointData((this.origin.x - a.left) / a.width, (this.origin.y - a.top) / a.height);
            this.explodedOrigin = new i2.PointData((this.explodedOrigin.x - a.left) / a.width, (this.explodedOrigin.y - a.top) / a.height);
        };
        SliceVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (this.pieSlice != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("pieSlice: ");
                a.u(this.pieSlice.serialize());
            }
            if (this.labelVisualData != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("labelVisualData: ");
                a.u(this.labelVisualData.serialize());
            }
            if (this.backgroundPath != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("backgroundPath: ");
                a.u(this.backgroundPath.serialize());
            }
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("isExploded: ");
            a.u(this.isExploded.toString().toLowerCase());
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("isSelected: ");
            a.u(this.isSelected.toString().toLowerCase());
            if (!i2.isNaN_(this.explodedOrigin.x) && !i2.isNaN_(this.explodedOrigin.y)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("explodedOrigin: ");
                a.u("{ x: " + this.explodedOrigin.x.toString() + ", y: " + this.explodedOrigin.y.toString() + "}");
            }
            if (!i2.isNaN_(this.origin.x) && !i2.isNaN_(this.origin.y)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("origin: ");
                a.u("{ x: " + this.origin.x.toString() + ", y: " + this.origin.y.toString() + "}");
            }
            if (!i2.isNaN_(this.index)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("index: ");
                a.u(this.index.toString());
            }
            if (!i2.isNaN_(this.radius)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("radius: ");
                a.u(this.radius.toString());
            }
            a.l(", visibility: ");
            a.u(this.visibility ? "true" : "false");
            if (!i2.isNaN_(this.startAngle)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("startAngle: ");
                a.u(this.startAngle.toString());
            }
            if (!i2.isNaN_(this.endAngle)) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("endAngle: ");
                a.u(this.endAngle.toString());
            }
            a.u("}");
            return a.toString();
        };
        SliceVisualData.$t = i2.markType(SliceVisualData, 'SliceVisualData');
        return SliceVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DoughnutChartLabelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DoughnutChartLabelVisualData, _super);
        function DoughnutChartLabelVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._labelValue = null;
            _this._labelSize = null;
            _this._labelPosition = null;
            return _this;
        }
        Object.defineProperty(DoughnutChartLabelVisualData.prototype, "labelValue", {
            get: function () {
                return this._labelValue;
            },
            set: function (a) {
                this._labelValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DoughnutChartLabelVisualData.prototype, "labelSize", {
            get: function () {
                return this._labelSize;
            },
            set: function (a) {
                this._labelSize = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DoughnutChartLabelVisualData.prototype, "labelPosition", {
            get: function () {
                return this._labelPosition;
            },
            set: function (a) {
                this._labelPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        DoughnutChartLabelVisualData.prototype.scaleByViewport = function (a) {
            this.labelPosition = new i2.PointData((this.labelPosition.x - a.left) / a.width, (this.labelPosition.y - a.top) / a.height);
            this.labelSize = new i2.SizeData((this.labelSize.width) / a.width, (this.labelSize.height) / a.height);
        };
        DoughnutChartLabelVisualData.prototype.serialize = function () {
            var a = "{ labelValue: '";
            a += this.labelValue == null ? i2.stringEmpty() : this.labelValue;
            a += "', labelSize: { width: " + this.labelSize.width + ", height: " + this.labelSize.height + "}, labelPosition: { x: " + this.labelPosition.x + ", y: " + this.labelPosition.y + "}}";
            return a;
        };
        DoughnutChartLabelVisualData.$t = i2.markType(DoughnutChartLabelVisualData, 'DoughnutChartLabelVisualData');
        return DoughnutChartLabelVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RingVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingVisualData, _super);
        function RingVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._arcs = null;
            return _this;
        }
        Object.defineProperty(RingVisualData.prototype, "arcs", {
            get: function () {
                return this._arcs;
            },
            set: function (a) {
                this._arcs = a;
            },
            enumerable: false,
            configurable: true
        });
        RingVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (this.arcs != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.u("arcs: [");
                for (var c = 0; c < this.arcs.count; c++) {
                    if (c != 0) {
                        a.l(", ");
                    }
                    a.l(this.arcs._inner[c].c());
                }
                a.u("]");
            }
            a.u("}");
            return a.toString();
        };
        RingVisualData.$t = i2.markType(RingVisualData, 'RingVisualData');
        return RingVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RingVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingVisualDataList, _super);
        function RingVisualDataList() {
            return _super.call(this, RingVisualData.$, 0) || this;
        }
        RingVisualDataList.$t = i2.markType(RingVisualDataList, 'RingVisualDataList', i2.List$1.$.specialize(RingVisualData.$));
        return RingVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ArcVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ArcVisualData, _super);
        function ArcVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            return _this;
        }
        ArcVisualData.prototype.d = function (a) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.scaleByViewport(a);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        ArcVisualData.prototype.c = function () {
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (this.b != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("leaderLine: ");
                a.u(this.b.serialize());
            }
            if (this.a != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.u("slices: [");
                for (var c = 0; c < this.a.count; c++) {
                    if (c != 0) {
                        a.l(", ");
                    }
                    a.l(this.a._inner[c].serialize());
                }
            }
            a.u("]}");
            return a.toString();
        };
        ArcVisualData.$t = i2.markType(ArcVisualData, 'ArcVisualData');
        return ArcVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ArcVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ArcVisualDataList, _super);
        function ArcVisualDataList() {
            return _super.call(this, ArcVisualData.$, 0) || this;
        }
        ArcVisualDataList.$t = i2.markType(ArcVisualDataList, 'ArcVisualDataList', i2.List$1.$.specialize(ArcVisualData.$));
        return ArcVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceVisualDataList, _super);
        function SliceVisualDataList() {
            return _super.call(this, SliceVisualData.$, 0) || this;
        }
        SliceVisualDataList.$t = i2.markType(SliceVisualDataList, 'SliceVisualDataList', i2.List$1.$.specialize(SliceVisualData.$));
        return SliceVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Arc = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Arc, _super);
        function Arc() {
            var _this = _super.call(this) || this;
            _this.ja = null;
            _this.i8 = null;
            _this.jd = 0;
            _this.ab = Arc.$;
            return _this;
        }
        Arc.prototype.a2 = function () {
            return new ArcView(this);
        };
        Arc.prototype.gj = function (a) {
            _super.prototype.gj.call(this, a);
            this.i9 = a;
        };
        Object.defineProperty(Arc.prototype, "jb", {
            get: function () {
                return this.ja;
            },
            set: function (a) {
                var b = this.ja;
                this.ja = a;
                this.i9.b6(b, this.ja);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Arc.prototype, "je", {
            get: function () {
                if (this.jb != null) {
                    return this.jb.i;
                }
                return 0;
            },
            enumerable: false,
            configurable: true
        });
        Arc.prototype.gf = function (a, b) {
            _super.prototype.gf.call(this, a, b);
            if (this.jb != null) {
                this.jb.c.ax.bu(a, b);
            }
        };
        Arc.prototype.fu = function (a, b) {
            if (this.jb != null && this.jb.d != null) {
                _super.prototype.fu.call(this, a, b);
                var c = this.jc(a);
                if (c != null) {
                    this.jb.d.bj(c, b);
                }
            }
        };
        Arc.prototype.gx = function (a, b) {
            if (this.jb != null && this.jb.d != null) {
                _super.prototype.gx.call(this, a, b);
                var c = this.jc(a);
                if (c != null) {
                    this.jb.d.b5(c, b);
                }
            }
        };
        Arc.prototype.jc = function (a) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.i8.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b.b == a) {
                        return b;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return null;
        };
        Arc.prototype.gw = function (a) {
            if (this.b7) {
                this.gm();
                this.gu();
                this.gt();
            }
        };
        Arc.prototype.gm = function () {
            if (this.actualItemsSource == null || this.bk == null) {
                this.bv.count = 0;
                return;
            }
            var a = this.cl.count;
            var b = this.ck.count > 0;
            var c = PieChartBase.de(this.c1);
            var d = PieChartBase.de(this.c1);
            this.dj = a;
            if (b) {
                a++;
            }
            for (var e = 0; e < a; e++) {
                var f = false;
                var g = void 0;
                if (e == a - 1 && b) {
                    g = this.db;
                    f = true;
                }
                else {
                    g = this.bt.item(this.cl._inner[e]);
                }
                if (this.iw == 1) {
                    d += PieChartBase.de(Math.abs(g) * this.jf / this.dg);
                }
                else {
                    d -= PieChartBase.de(Math.abs(g) * this.jf / this.dg);
                }
                var h = this.bv.item(e);
                if (this.cy >= 100) {
                    h._visibility = 1;
                }
                else {
                    h._visibility = 0;
                }
                h.aw = true;
                h.a3 = c;
                h.ax = d;
                h.a1 = h.a0 = this.cy;
                h.isOthersSlice = f;
                h.ay = this.cx;
                h.a5 = e;
                h.dataContext = f ? this.cj : this.bk.item(this.cl._inner[e]);
                h.isExploded = this.explodedSlices.contains(e);
                h.isSelected = this.selectedSlices.contains(e);
                c = d;
                h.aw = false;
            }
            this.bv.count = a;
            if (this.i8 != null) {
                this.i8.q(this);
            }
        };
        Arc.prototype.gt = function () {
            var e_2, _a;
            var _this = this;
            var a = i2.typeCast(i2.IChartLegend_$type, this.legend);
            if (a == null) {
                return;
            }
            if (this.bp == null || this.bp.count == 0 || ((this.jb != null && this.jb.c != null) && (this.jb.d != null && !this.jb.d.series.contains(this.jb.c)))) {
                a.clearLegendItemsForSeries(this.jb.c);
                return;
            }
            this.ci = new i2.List$1(i2.UIElement.$, 0);
            var _loop_1 = function (b) {
                var c = new i2.ContentControl();
                var d = this_1.dl(b);
                var e = b.b0;
                var f = b.isOthersSlice ? this_1.e1 : (this_1.bq != null && this_1.bq.count > 0) ? this_1.bq.item(this_1.cl._inner[b.a5]) : null;
                f = (f == null && this_1.bp.count > 0) ? this_1.bp.item(this_1.cl._inner[b.a5]) : f;
                c.content = ((function () {
                    var $ret = new PieSliceDataContext();
                    $ret.series = _this.jb.c;
                    $ret.slice = b;
                    $ret.item = b.dataContext;
                    $ret.itemBrush = e;
                    $ret.legendLabel = f != null ? f.toString() : null;
                    $ret.itemLabel = d != null ? d.toString() : null;
                    $ret.percentValue = _this.c6(b);
                    $ret.isOthersSlice = b.isOthersSlice;
                    return $ret;
                })());
                var g = c.content;
                if (this_1.a5 != null) {
                    var h = this_1.a5(g);
                    if (h != null) {
                        g.legendLabel = h.toString();
                    }
                }
                if (this_1.aq != null && !g.isOthersSlice) {
                    var i = this_1.aq.i(g);
                    g.legendLabel = i;
                }
                if (this_1.ar != null && g.isOthersSlice) {
                    var j = this_1.ar.i(g);
                    g.legendLabel = j;
                }
                if (this_1.legendItemTemplate != null) {
                    c.ah = this_1.legendItemTemplate;
                }
                this_1.ci.add(c);
            };
            var this_1 = this;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.bv.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    _loop_1(b);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            if (a.isItemwise) {
                var k = a;
                k.createLegendItemsInsert(this.ci, this.jb.c);
            }
        };
        Arc.prototype.gn = function (a, b, c, d) {
            _super.prototype.gn.call(this, a, b, c, d);
            switch (b) {
                case Arc.$$p[0]:
                    this.jd = d;
                    this.gm();
                    this.gl();
                    this.gu();
                    this.gs();
                    break;
                case "RadiusFactor":
                    if (this.jb != null && this.jb.d != null) {
                        this.jb.d.bw();
                    }
                    break;
                case "Legend":
                    var e = i2.typeCast(i2.IChartLegend_$type, c);
                    if (e != null && this.jb != null && this.jb.c != null) {
                        e.clearLegendItemsForSeries(this.jb.c);
                    }
                    break;
            }
        };
        Arc.prototype.jg = function () {
            return this.a3.ac();
        };
        Arc.$t = i2.markType(Arc, 'Arc', PieChartBase.$);
        Arc.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, Arc, 'gp', ['EndAngle:jf:ji', [1, 360]]);
        return Arc;
    }(PieChartBase));
    /**
     * @hidden
     */
    var ArcItem = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ArcItem, _super);
        function ArcItem() {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.b = null;
            _this.n = null;
            _this.l = 0;
            _this.m = 0;
            _this.k = 0;
            _this.i = 0;
            _this.j = 0;
            _this.c = 0;
            _this.a = null;
            _this.g = null;
            _this.e = null;
            _this.h = null;
            _this.k = 0;
            _this.i = 360;
            _this.g = new i2.List$1(SliceItem.$, 0);
            return _this;
        }
        ArcItem.prototype.o = function (a, b) {
            var e_3, _a;
            var c = 0;
            var d = 0;
            var e = new i2.List$1(i2.Number_$type, 0);
            var f = new i2.List$1(i2.Number_$type, 0);
            var g = new i2.List$1(i2.Base.$, 0);
            this.g.clear();
            if (this.h == null) {
                return;
            }
            var h = new i2.FastItemsSource();
            h.e = this.h;
            var i = this.f(h, this.n);
            if (i == null || i.count == 0) {
                h.deregisterColumn(i);
                h.m();
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(i)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var j = _c.value;
                    if (i2.isNaN_(j) || i2.isInfinity(j) || j <= 0) {
                        continue;
                    }
                    c = c + j;
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            for (var k = 0; k < i.count; k++) {
                var l = i.item(k);
                if (i2.isNaN_(l) || i2.isInfinity(l) || l <= 0) {
                    continue;
                }
                var m = this.c == 1 ? l / c : l;
                var n = this.c == 1 ? this.j / 100 : this.j;
                if (m <= n) {
                    d = d + l;
                    f.add(k);
                    g.add1(h.item(k));
                }
                else {
                    e.add(k);
                }
            }
            var o = e.count;
            var p = f.count > 0;
            var q = PieChartBase.de(a);
            var r = PieChartBase.de(a);
            if (p) {
                o++;
            }
            var _loop_2 = function (s) {
                var t = false;
                var u = void 0;
                if (s == o - 1 && p) {
                    u = d;
                    t = true;
                }
                else {
                    u = i.item(e._inner[s]);
                }
                var v = 1;
                if (v == 1) {
                    r += PieChartBase.de(Math.abs(u) * b / c);
                }
                else {
                    r -= PieChartBase.de(Math.abs(u) * b / c);
                }
                this_2.g.add(((function () {
                    var $ret = new SliceItem();
                    $ret.e = q;
                    $ret.d = r - q;
                    $ret.g = t ? g : h.item(e._inner[s]);
                    return $ret;
                })()));
                q = r;
            };
            var this_2 = this;
            for (var s = 0; s < o; s++) {
                _loop_2(s);
            }
            h.deregisterColumn(i);
            h.m();
        };
        ArcItem.prototype.f = function (a, b) {
            var c = null;
            return a.registerColumn(b, c, false);
        };
        ArcItem.prototype.p = function (a) {
            var b = this.e == null ? a : this.e.e;
            var c = this.e == null ? 360 : this.e.d;
            this.o(b, c);
        };
        ArcItem.prototype.q = function (a) {
            var _this = this;
            this.g.clear();
            var _loop_3 = function (b) {
                var c = a.bv.item(b);
                this_3.g.add(((function () {
                    var $ret = new SliceItem();
                    $ret.e = c.a3;
                    $ret.d = c.ax - c.a3;
                    $ret.f = b;
                    $ret.a = _this;
                    $ret.g = c.dataContext;
                    $ret.c = c.isOthersSlice;
                    $ret.b = c;
                    return $ret;
                })()));
            };
            var this_3 = this;
            for (var b = 0; b < a.bv.count; b++) {
                _loop_3(b);
            }
        };
        ArcItem.$t = i2.markType(ArcItem, 'ArcItem');
        return ArcItem;
    }(i2.Base));
    /**
     * @hidden
     */
    var RingSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingSeriesBase, _super);
        function RingSeriesBase() {
            var _this = _super.call(this) || this;
            _this.as = null;
            _this.ax = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.bd = null;
            _this.a2 = false;
            _this.a1 = false;
            _this.bb = null;
            _this.eh = null;
            _this.aw = null;
            _this.c9 = null;
            _this.az = null;
            _this.eh = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.as = function (a, b) { return _this.c4(a, b.propertyName, b.oldValue, b.newValue); };
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, _this.as);
            _this.aw = _this.av();
            _this.c1(_this.aw);
            _this.aw.k();
            _this.bb = function (a, b) { return _this.cv(b.action, b.position, b.count, b.propertyName); };
            return _this;
        }
        RingSeriesBase.prototype.c6 = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        Object.defineProperty(RingSeriesBase.prototype, "el", {
            get: function () {
                if (this.ek != null) {
                    return this.ek;
                }
                if (this.ax != null && this.ax.cg != null) {
                    return this.ax.cg;
                }
                return null;
            },
            set: function (a) {
                var b = this.el;
                if (this.ek != null && a != this.ek) {
                    a = this.ek;
                }
                this.c6("SelectedStyleResolved", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "co", {
            get: function () {
                return this.bd;
            },
            set: function (a) {
                var b = this.bd;
                this.bd = a;
                this.c6("TextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "da", {
            get: function () {
                return i2.typeCast(i2.DataTemplate.$, this.c(RingSeriesBase.dp));
            },
            set: function (a) {
                this.h(RingSeriesBase.dp, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "a3", {
            get: function () {
                return this.c(RingSeriesBase.df);
            },
            set: function (a) {
                this.a2 = true;
                this.h(RingSeriesBase.df, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "a4", {
            get: function () {
                if (!this.a2) {
                    return this.ax.ax;
                }
                else {
                    return this.a3;
                }
            },
            enumerable: false,
            configurable: true
        });
        RingSeriesBase.prototype.c4 = function (a, b, c, d) {
            if (b == RingSeriesBase.$$p[4]) {
                this.ay = ((function () {
                    var $ret = new i2.FastItemsSource();
                    $ret.e = d;
                    return $ret;
                })());
            }
            if (b == RingSeriesBase.$$p[1]) {
                if (i2.typeCast(i2.FastItemsSource.$, c) != null) {
                    var e = (i2.typeCast(i2.FastItemsSource.$, c));
                    e.event = i2.delegateRemove(e.event, this.bb);
                    this.a1 = false;
                }
                if (i2.typeCast(i2.FastItemsSource.$, d) != null) {
                    var f = (i2.typeCast(i2.FastItemsSource.$, d));
                    f.event = i2.delegateCombine(f.event, this.bb);
                    this.a1 = true;
                }
                this.c3();
            }
            switch (b) {
                case RingSeriesBase.$$p[32]:
                    this.el = d;
                    break;
                case RingSeriesBase.$$p[36]:
                    this.c3();
                    break;
            }
        };
        Object.defineProperty(RingSeriesBase.prototype, "container", {
            get: function () {
                return this.ax;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "isStacked", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "isVertical", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "isUsableInLegend", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "hasMarkers", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingSeriesBase.prototype, "hasSubItems", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        RingSeriesBase.prototype.cv = function (a, b, c, d) {
            this.c3();
        };
        RingSeriesBase.prototype.av = function () {
            return new RingSeriesBaseView(this);
        };
        RingSeriesBase.prototype.c1 = function (a) {
        };
        RingSeriesBase.prototype.c5 = function (a) {
            this.aw.n(a);
        };
        RingSeriesBase.prototype.cu = function () {
            if (this.aw != null) {
                this.aw.i();
            }
        };
        RingSeriesBase.prototype.cy = function (a, b) {
            this.cw(new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        RingSeriesBase.prototype.c0 = function (a, b, c) {
            this.cw(new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        RingSeriesBase.prototype.cx = function () {
            this.cw(new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        RingSeriesBase.prototype.cz = function (a, b) {
            this.cw(new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        RingSeriesBase.prototype.cw = function (a) {
            if (this.ay != null) {
                this.ay.handleCollectionChanged(a);
            }
        };
        RingSeriesBase.prototype.resolveLegendIndex = function () {
            return -1;
        };
        RingSeriesBase.prototype.forSubItems = function (a) {
        };
        Object.defineProperty(RingSeriesBase.prototype, "a0", {
            get: function () {
                if (this.az == null) {
                    this.az = new i2.SRProvider(this.aw.g);
                }
                return this.az;
            },
            enumerable: false,
            configurable: true
        });
        RingSeriesBase.prototype.cj = function () {
            var a = this.a0.b7;
            if (i2.stringIsNullOrWhiteSpace(a)) {
                a = "Others";
            }
            return this.ca != null ? this.ca : a;
        };
        RingSeriesBase.$t = i2.markType(RingSeriesBase, 'RingSeriesBase', i2.Control.$, [i2.INotifyPropertyChanged_$type, i2.ILegendSeries_$type, i2.ILegendTemplateProvider_$type]);
        RingSeriesBase.dp = i2.DependencyProperty.i("LabelTemplate", i2.DataTemplate.$, RingSeriesBase.$, new i2.PropertyMetadata(2, null, function (a, b) { return (i2.typeCast(RingSeriesBase.$, a)).c6("LabelTemplate", b.oldValue, b.newValue); }));
        RingSeriesBase.df = i2.DependencyProperty.i("IsSurfaceInteractionDisabled", i2.Boolean_$type, RingSeriesBase.$, new i2.PropertyMetadata(2, false, function (a, b) { return a.c6("IsSurfaceInteractionDisabled", b.oldValue, b.newValue); }));
        RingSeriesBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RingSeriesBase, 'c6', ['Brushes:ak:db', [i2.BrushCollection.$, null], 'FastItemsSource:ay:dc', [i2.FastItemsSource.$], 'FormatLabel:aq:dd', [i2.Delegate_$type], 'FormatLegendLabel:ar:de', [i2.Delegate_$type], 'ItemsSource::dg', [i2.IEnumerable_$type, null], 'LabelExtent:a6:dh', [1, 10], 'LabelFormat:bl:di', [2, null], 'LabelFormatSpecifiers:ag:dj', [i2.Array_$type, null], 'LabelInnerColor:ef:dk', [i2.Brush.$, null], 'LabelMemberPath:bp:dl', [2], 'LabelOuterColor:eg:dm', [i2.Brush.$, null], 'LabelsPosition:an:dn', [LabelsPosition_$type, i2.enumGetBox(LabelsPosition_$type, 1)], 'LeaderLineMargin:a7:dq', [1, 6], 'LeaderLineStyle:ei:dr', [i2.Style.$, null], 'LeaderLineType:ao:ds', [LeaderLineType_$type, i2.enumGetBox(LeaderLineType_$type, 0)], 'LeaderLineVisibility:en:dt', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'LegendItemBadgeTemplate::du', [i2.DataTemplate.$, null], 'LegendItemTemplate::dv', [i2.DataTemplate.$, null], 'LegendLabelFormat:b0:dw', [2, null], 'LegendLabelFormatSpecifiers:ah:dx', [i2.Array_$type, null], 'LegendLabelMemberPath:b3:dy', [2], 'LegendOthersLabelFormat:b5:dz', [2, null], 'LegendOthersLabelFormatSpecifiers:ai:d0', [i2.Array_$type, null], 'Legend::d1', [i2.IChartLegend_$type, null], 'OthersCategoryStyle:ej:d2', [i2.Style.$, null], 'OthersCategoryText:ca:d3', [2, null], 'OthersCategoryThreshold:a8:d4', [1, 3], 'OthersCategoryType:ap:d5', [OthersCategoryType_$type, i2.enumGetBox(OthersCategoryType_$type, 1)], 'OthersLabelFormat:ce:d6', [2, null], 'OthersLabelFormatSpecifiers:aj:d7', [i2.Array_$type, null], 'Outlines:al:d8', [i2.BrushCollection.$, null], 'RadiusFactor:a9:d9', [1, 0.9], 'SelectedStyle:ek:ea', [i2.Style.$, null], 'StartAngle:ba:eb', [1, 0], 'ToolTip::ec', [4, null], 'ToolTipStyle:em:ed', [i2.Style.$, null], 'ValueMemberPath:cs:ee', [2, null]]);
        return RingSeriesBase;
    }(i2.Control));
    /**
     * @hidden
     */
    var Ring = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Ring, _super);
        function Ring() {
            var _this = _super.call(this) || this;
            _this.j = 0;
            _this.h = 0;
            _this.q = new i2.Size();
            _this.p = null;
            _this._ringControl = null;
            _this.b = null;
            _this.i = 0;
            _this.g = null;
            _this.d = null;
            _this.e = false;
            _this.p = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.q = new i2.Size(1, 0, 0);
            _this.ringControl = ((function () {
                var $ret = new RingControl();
                $ret.ai = _this;
                return $ret;
            })());
            _this.g = new i2.List$1(ArcItem.$, 0);
            _this.e = true;
            return _this;
        }
        Object.defineProperty(Ring.prototype, "ringControl", {
            get: function () {
                return this._ringControl;
            },
            set: function (a) {
                this._ringControl = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Ring.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
                this.b.aw.h(this.ringControl);
                if (this.ringControl != null) {
                    this.ringControl.ak.s(a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Ring.prototype.f = function () {
            if (this.ringControl != null && this.ringControl.ak.d()) {
                var a = void 0, b = void 0;
                a = this.p.x - this.c.eh.x;
                b = this.p.y - this.c.eh.y;
                this.ringControl.ak.v(a, b);
                return this.ringControl.an();
            }
            return false;
        };
        Ring.prototype.o = function () {
            if (this.ringControl != null) {
                this.ringControl.width = this.q.width;
                this.ringControl.height = this.q.height;
                this.c.aw.h(this.ringControl);
                this.ringControl.ao = this.g;
            }
        };
        Ring.prototype.l = function (source_, a, b) {
            this.ringControl.as(source_, a, b);
        };
        Ring.prototype.k = function (source_) {
            this.ringControl.ar(source_);
        };
        Ring.prototype.m = function (source_, a, b) {
            this.ringControl.at(source_, a, b);
        };
        Ring.prototype.n = function (source_, a, b, c) {
            this.ringControl.au(source_, a, b, c);
        };
        Ring.$t = i2.markType(Ring, 'Ring');
        return Ring;
    }(i2.Base));
    /**
     * @hidden
     */
    var RingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingCollection, _super);
        function RingCollection() {
            return _super.call(this, Ring.$, 0) || this;
        }
        RingCollection.prototype.p = function () {
            var e_4, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (a.e) {
                        var b = 0;
                        var c = a.ringControl.arcs.count;
                        while (b < c) {
                            a.ringControl.arcs.destroy(a.ringControl.arcs.item(b));
                            b++;
                        }
                        a.ringControl.arcs.count = 0;
                        a.ringControl = null;
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            _super.prototype.p.call(this);
        };
        RingCollection.prototype.u = function (a) {
            var b = this._inner[a];
            if (b.e) {
                b.ringControl.arcs.destroy(b.ringControl.arcs.item(a));
                b.ringControl.arcs.count = 0;
                b.ringControl = null;
            }
            _super.prototype.u.call(this, a);
        };
        RingCollection.$t = i2.markType(RingCollection, 'RingCollection', i2.ObservableCollection$1.$.specialize(Ring.$));
        return RingCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var RingControl = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingControl, _super);
        function RingControl() {
            var _this = _super.call(this) || this;
            _this.ak = null;
            _this.ah = null;
            _this.arcs = null;
            _this.ao = null;
            _this.a0 = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.ab = RingControl.$;
            _this.ak = _this.aj();
            _this.ax(_this.ak);
            _this.ak.r();
            _this.arcs = ((function () {
                var $ret = new i2.Pool$1(Arc.$);
                $ret.create = i2.runOn(_this.ak, _this.ak.a);
                $ret.activate = i2.runOn(_this.ak, _this.ak.l);
                $ret.disactivate = i2.runOn(_this.ak, _this.ak.n);
                $ret.destroy = i2.runOn(_this.ak, _this.ak.m);
                return $ret;
            })());
            return _this;
        }
        Object.defineProperty(RingControl.prototype, "al", {
            get: function () {
                return this.ai.c;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RingControl.prototype, "ai", {
            get: function () {
                return this.ah;
            },
            set: function (a) {
                this.ah = a;
                if (this.ah == null) {
                    this.ak.s(null);
                }
                else {
                    this.ak.s(this.ah.c);
                }
            },
            enumerable: false,
            configurable: true
        });
        RingControl.prototype.aj = function () {
            return new RingControlView(this);
        };
        RingControl.prototype.ax = function (a) {
        };
        RingControl.prototype.az = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        RingControl.prototype.aw = function () {
            this.an();
        };
        RingControl.prototype.an = function () {
            var e_5, _a;
            if (this.ao == null) {
                return false;
            }
            if (!this.ak.d()) {
                return false;
            }
            var a = 0;
            var b = false;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ao)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = this.arcs.item(a);
                    d.i8 = c;
                    if (d.c7 != this.ai.h) {
                        d.c7 = this.ai.h;
                    }
                    if ((d.width != this.ai.q.width || d.height != this.ai.q.height) && d.a3.r()) {
                        d.width = this.ai.q.width;
                        d.height = this.ai.q.height;
                        this.ak.ab(d);
                        b = true;
                    }
                    if (d.df != c.k) {
                        d.df = c.k;
                    }
                    if (d.jf != c.i) {
                        d.jf = c.i;
                    }
                    if (d.itemsSource != c.h) {
                        d.itemsSource = c.h;
                    }
                    if (d.am != c.a) {
                        d.am = c.a;
                    }
                    this.ak.t(d, 0, 0);
                    a++;
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            this.arcs.count = a;
            return b;
        };
        RingControl.prototype.ay = function (a) {
            this.ak.w(a);
        };
        RingControl.prototype.av = function () {
            this.ak.q();
        };
        RingControl.prototype.ap = function () {
            return this.ak.j();
        };
        RingControl.prototype.as = function (source_, a, b) {
            for (var c = 0; c < this.arcs.count; c++) {
                this.arcs.item(c).f2(source_, a, b);
            }
        };
        RingControl.prototype.ar = function (source_) {
            for (var a = 0; a < this.arcs.count; a++) {
                this.arcs.item(a).f0(source_);
            }
        };
        RingControl.prototype.at = function (source_, a, b) {
            for (var c = 0; c < this.arcs.count; c++) {
                this.arcs.item(c).f3(source_, a, b);
            }
        };
        RingControl.prototype.au = function (source_, a, b, c) {
            for (var d = 0; d < this.arcs.count; d++) {
                this.arcs.item(d).f4(source_, a, b, c);
            }
        };
        RingControl.$t = i2.markType(RingControl, 'RingControl', i2.Control.$, [i2.INotifyPropertyChanged_$type]);
        return RingControl;
    }(i2.Control));
    /**
     * @hidden
     */
    var RingSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingSeriesCollection, _super);
        function RingSeriesCollection() {
            return _super.call(this, RingSeriesBase.$, 0) || this;
        }
        RingSeriesCollection.$t = i2.markType(RingSeriesCollection, 'RingSeriesCollection', i2.ObservableCollection$1.$.specialize(RingSeriesBase.$));
        return RingSeriesCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var SliceItem = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceItem, _super);
        function SliceItem() {
            var _this = _super.call(this) || this;
            _this.e = 0;
            _this.d = 0;
            _this.a = null;
            _this.f = 0;
            _this.b = null;
            _this.g = null;
            _this.c = false;
            return _this;
        }
        SliceItem.$t = i2.markType(SliceItem, 'SliceItem');
        return SliceItem;
    }(i2.Base));
    /**
     * @hidden
     */
    var SliceCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceCollection, _super);
        function SliceCollection() {
            var _this = _super.call(this, SliceItem.$, 0) || this;
            _this.ae = false;
            _this.ag = false;
            return _this;
        }
        SliceCollection.prototype.r = function (a, b) {
            if (this.contains(b)) {
                return;
            }
            var c = this.ah(b.b);
            if (c != -1) {
                _super.prototype.x.call(this, c, b);
            }
            else {
                _super.prototype.r.call(this, a, b);
                if (this.ae) {
                    if (this.ag) {
                        b.b.isSelected = true;
                    }
                    else {
                        b.b.isExploded = true;
                    }
                }
            }
        };
        SliceCollection.prototype.x = function (a, b) {
            if (this.ae) {
                if (this.ag) {
                    this._inner[a].b.isSelected = false;
                }
                else {
                    this._inner[a].b.isExploded = false;
                }
            }
            _super.prototype.x.call(this, a, b);
        };
        SliceCollection.prototype.u = function (a) {
            var b = this._inner[a];
            _super.prototype.u.call(this, a);
            if (this.ae) {
                if (this.ag) {
                    b.b.isSelected = false;
                }
                else {
                    b.b.isExploded = false;
                }
            }
        };
        SliceCollection.prototype.remove = function (a) {
            var b = this.ah(a.b);
            if (b != -1) {
                this.u(b);
                return true;
            }
            else {
                return false;
            }
        };
        SliceCollection.prototype.p = function () {
            while (this.count > 0) {
                this.u(0);
            }
        };
        SliceCollection.prototype.ah = function (a) {
            for (var b = 0; b < this.count; b++) {
                if (this._inner[b].b == a) {
                    return b;
                }
            }
            return -1;
        };
        SliceCollection.$t = i2.markType(SliceCollection, 'SliceCollection', i2.ObservableCollection$1.$.specialize(SliceItem.$));
        return SliceCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var XamDoughnutChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamDoughnutChart, _super);
        function XamDoughnutChart() {
            var _this = _super.call(this) || this;
            _this.al = new RingSeriesCollection();
            _this.aj = new RingCollection();
            _this.ap = ((function () {
                var $ret = new SliceCollection();
                $ret.ae = true;
                $ret.ag = true;
                return $ret;
            })());
            _this.ao = ((function () {
                var $ret = new SliceCollection();
                $ret.ae = true;
                $ret.ag = false;
                return $ret;
            })());
            _this.ah = null;
            _this.a0 = NaN;
            _this.az = 1;
            _this.au = null;
            _this.sliceClick = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.holeDimensionsChanged = null;
            var a = _this.at();
            _this.bv(a);
            a.s();
            _this.ab = XamDoughnutChart.$;
            _this.ah = function (b, c) { return _this.bz(b, c.propertyName, c.oldValue, c.newValue); };
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, _this.ah);
            var b = _this.series;
            b.collectionChanged = i2.delegateCombine(b.collectionChanged, i2.runOn(_this, _this.b6));
            return _this;
        }
        Object.defineProperty(XamDoughnutChart.prototype, "ak", {
            get: function () {
                return this.aj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDoughnutChart.prototype, "series", {
            get: function () {
                return this.al;
            },
            enumerable: false,
            configurable: true
        });
        XamDoughnutChart.prototype.b6 = function (a, b) {
            var e_6, _a;
            var c = new i2.List$1(RingSeriesBase.$, 0);
            if (b.oldItems != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEn(b.oldItems)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        if (b.newItems == null || !b.newItems.contains(d)) {
                            d.cu();
                            this.au.w(d);
                        }
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
            }
            this.bx();
            this.b2();
        };
        Object.defineProperty(XamDoughnutChart.prototype, "a3", {
            get: function () {
                return this.c(XamDoughnutChart.cc);
            },
            set: function (a) {
                this.h(XamDoughnutChart.cc, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDoughnutChart.prototype, "ar", {
            get: function () {
                return this.ap;
            },
            set: function (a) {
                this.ap.clear();
                this.ap.ae = false;
                this.ap = a;
                this.ap.ae = true;
                this.ap.ag = true;
                for (var b = 0; b < this.ap.count; b++) {
                    this.ap._inner[b].b.isSelected = true;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDoughnutChart.prototype, "aq", {
            get: function () {
                return this.ao;
            },
            set: function (a) {
                this.ao.clear();
                this.ao.ae = false;
                this.ao = a;
                this.ao.ae = true;
                this.ao.ag = false;
                for (var b = 0; b < this.ao.count; b++) {
                    this.ao._inner[b].b.isExploded = true;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDoughnutChart.prototype, "a4", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                var b = this.a0;
                this.a0 = a;
                this.b1("PixelScalingRatio", b, this.a0);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamDoughnutChart.prototype, "a1", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                var b = this.az;
                this.az = a;
                this.b1("ActualPixelScalingRatio", b, this.az);
            },
            enumerable: false,
            configurable: true
        });
        XamDoughnutChart.prototype.destroy = function () {
            var e_7, _a;
            this.au.v(null);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.cu();
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        };
        XamDoughnutChart.prototype.b5 = function (a, b) {
            if (b) {
                this.ar.add(a);
            }
            else {
                this.ar.remove(a);
            }
        };
        XamDoughnutChart.prototype.bj = function (a, b) {
            if (b) {
                this.aq.add(a);
            }
            else {
                this.aq.remove(a);
            }
        };
        XamDoughnutChart.prototype.bz = function (a, b, c, d) {
            var e_8, _a, e_9, _b, e_10, _c, e_11, _d, e_12, _e;
            switch (b) {
                case XamDoughnutChart.$$p[5]:
                    try {
                        for (var _f = tslib.__values(i2.fromEnum(this.series)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var e = _g.value;
                            e.el = d;
                        }
                    }
                    catch (e_8_1) {
                        e_8 = { error: e_8_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_a = _f.return))
                                _a.call(_f);
                        }
                        finally {
                            if (e_8)
                                throw e_8.error;
                        }
                    }
                    break;
                case XamDoughnutChart.$$p[0]:
                    for (var f = 0; f < this.aj.count; f++) {
                        try {
                            for (var _h = (e_9 = void 0, tslib.__values(i2.fromEnum(this.aj._inner[f].ringControl.arcs.a))), _j = _h.next(); !_j.done; _j = _h.next()) {
                                var g = _j.value;
                                g.b6 = this.av;
                            }
                        }
                        catch (e_9_1) {
                            e_9 = { error: e_9_1 };
                        }
                        finally {
                            try {
                                if (_j && !_j.done && (_b = _h.return))
                                    _b.call(_h);
                            }
                            finally {
                                if (e_9)
                                    throw e_9.error;
                            }
                        }
                    }
                    break;
                case XamDoughnutChart.$$p[1]:
                    for (var h = 0; h < this.aj.count; h++) {
                        try {
                            for (var _k = (e_10 = void 0, tslib.__values(i2.fromEnum(this.aj._inner[h].ringControl.arcs.a))), _l = _k.next(); !_l.done; _l = _k.next()) {
                                var i = _l.value;
                                i.b7 = this.aw;
                            }
                        }
                        catch (e_10_1) {
                            e_10 = { error: e_10_1 };
                        }
                        finally {
                            try {
                                if (_l && !_l.done && (_c = _k.return))
                                    _c.call(_k);
                            }
                            finally {
                                if (e_10)
                                    throw e_10.error;
                            }
                        }
                    }
                    break;
                case "PixelScalingRatio":
                    var j = i2.DeviceUtils.a(this.a4);
                    if (i2.isNaN_(j)) {
                        this.a1 = 1;
                    }
                    else {
                        this.a1 = j;
                    }
                    break;
                case "ActualPixelScalingRatio":
                    try {
                        for (var _m = tslib.__values(i2.fromEnum(this.aj)), _o = _m.next(); !_o.done; _o = _m.next()) {
                            var k = _o.value;
                            try {
                                for (var _p = (e_12 = void 0, tslib.__values(i2.fromEnum(k.ringControl.arcs.a))), _q = _p.next(); !_q.done; _q = _p.next()) {
                                    var l = _q.value;
                                    l.cz = this.a1;
                                }
                            }
                            catch (e_12_1) {
                                e_12 = { error: e_12_1 };
                            }
                            finally {
                                try {
                                    if (_q && !_q.done && (_e = _p.return))
                                        _e.call(_p);
                                }
                                finally {
                                    if (e_12)
                                        throw e_12.error;
                                }
                            }
                        }
                    }
                    catch (e_11_1) {
                        e_11 = { error: e_11_1 };
                    }
                    finally {
                        try {
                            if (_o && !_o.done && (_d = _m.return))
                                _d.call(_m);
                        }
                        finally {
                            if (e_11)
                                throw e_11.error;
                        }
                    }
                    break;
            }
        };
        XamDoughnutChart.prototype.at = function () {
            return new XamDoughnutChartView(this);
        };
        XamDoughnutChart.prototype.bv = function (a) {
            this.au = a;
        };
        XamDoughnutChart.prototype.b2 = function () {
            this.by();
            this.b4();
            this.b3();
            this.bw();
            this.au.z();
        };
        XamDoughnutChart.prototype.b4 = function () {
            var e_13, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.c8();
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        };
        XamDoughnutChart.prototype.bw = function () {
            var a = this.au.ab;
            if (a.isEmpty || a.width == 0 || a.height == 0) {
                return;
            }
            var b = { $type: i2.Point_$type, x: a.width / 2, y: a.height / 2 };
            var c = Math.min(a.width / 2, a.height / 2);
            var d = 0.9;
            if (this.series.count > 0) {
                d = this.series._inner[0].a9;
                if (i2.isNaN_(d) || i2.isInfinity(d) || d < 0) {
                    d = 0;
                }
                else if (d > 1) {
                    d = 1;
                }
            }
            var e = this.a3 * c / 100 * d;
            this.au.x(e * 2, e * 2);
            this.au.u(b.x - e, b.y - e);
        };
        XamDoughnutChart.prototype.b3 = function () {
            var e_14, _a, e_15, _b;
            var a = false;
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.aj)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    if (b.f()) {
                        a = true;
                    }
                }
            }
            catch (e_14_1) {
                e_14 = { error: e_14_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_14)
                        throw e_14.error;
                }
            }
            if (a) {
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.aj)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.c.aw.l();
                    }
                }
                catch (e_15_1) {
                    e_15 = { error: e_15_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_15)
                            throw e_15.error;
                    }
                }
            }
        };
        XamDoughnutChart.prototype.by = function () {
            var e_16, _a;
            var a = this.au.ab;
            if (a.isEmpty || a.width == 0 || a.height == 0) {
                return;
            }
            var b = { $type: i2.Point_$type, x: a.width / 2, y: a.height / 2 };
            var c = Math.min(a.width / 2, a.height / 2);
            var d = Math.max(a.width / 2, a.height / 2);
            if (a.width > a.height) {
                c = c + d;
                d = c - d;
                c = c - d;
            }
            var e = ((100 - this.a3) / 100 * c) / this.aj.count;
            var f = ((100 - this.a3) / 100 * d) / this.aj.count;
            var g = this.a3 * c / 100;
            var h = this.a3 * d / 100;
            var i = 1;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.aj)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var j = _c.value;
                    var k = (g + (e * i));
                    var l = (h + (f * i));
                    j.i = e;
                    j.q = new i2.Size(1, k * 2, l * 2);
                    j.p = { $type: i2.Point_$type, x: b.x - k, y: b.y - l };
                    j.h = 100 - (e / k * 100);
                    j.o();
                    i++;
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        };
        XamDoughnutChart.prototype.bx = function () {
            var e_17, _a;
            this.aq.clear();
            this.ar.clear();
            this.aj.clear();
            this.au.j();
            this.au.i();
            var a = 0;
            for (var b = 0; b < this.series.count; b++) {
                var c = this.series._inner[b];
                c.ax = this;
                this.au.h(c);
                var series_ = c;
                series_.externalObject.sychronizeCollections();
                var d = c.au();
                try {
                    for (var _b = (e_17 = void 0, tslib.__values(i2.fromEnum(d))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        e.d = this;
                        e.j = a;
                        this.aj.add(e);
                        a++;
                    }
                }
                catch (e_17_1) {
                    e_17 = { error: e_17_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_17)
                            throw e_17.error;
                    }
                }
            }
        };
        XamDoughnutChart.prototype.bt = function () {
            if (this.au != null) {
                this.height = this.au.ab.height;
                this.width = this.au.ab.width;
            }
            this.b2();
        };
        XamDoughnutChart.prototype.bu = function (a, b) {
            var c = a;
            var d = c.jb.c;
            if (d.a4) {
                return;
            }
            if (this.sliceClick != null) {
                this.sliceClick(a, b);
            }
        };
        XamDoughnutChart.prototype.b1 = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        XamDoughnutChart.prototype.onDetachedFromUI = function () {
            var e_18, _a, e_19, _b;
            this.au.r();
            for (var a = 0; a < this.aj.count; a++) {
                try {
                    for (var _c = (e_18 = void 0, tslib.__values(i2.fromEnum(this.aj._inner[a].ringControl.arcs.a))), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.onDetachedFromUI();
                    }
                }
                catch (e_18_1) {
                    e_18 = { error: e_18_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_18)
                            throw e_18.error;
                    }
                }
                try {
                    for (var _e = (e_19 = void 0, tslib.__values(i2.fromEnum(this.aj._inner[a].ringControl.arcs.b))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.onDetachedFromUI();
                    }
                }
                catch (e_19_1) {
                    e_19 = { error: e_19_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_19)
                            throw e_19.error;
                    }
                }
            }
        };
        XamDoughnutChart.prototype.onAttachedToUI = function () {
            var e_20, _a, e_21, _b;
            this.au.q();
            for (var a = 0; a < this.aj.count; a++) {
                try {
                    for (var _c = (e_20 = void 0, tslib.__values(i2.fromEnum(this.aj._inner[a].ringControl.arcs.a))), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.onAttachedToUI();
                    }
                }
                catch (e_20_1) {
                    e_20 = { error: e_20_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_20)
                            throw e_20.error;
                    }
                }
                try {
                    for (var _e = (e_21 = void 0, tslib.__values(i2.fromEnum(this.aj._inner[a].ringControl.arcs.b))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.onAttachedToUI();
                    }
                }
                catch (e_21_1) {
                    e_21 = { error: e_21_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_21)
                            throw e_21.error;
                    }
                }
            }
        };
        XamDoughnutChart.prototype.provideContainer = function (a) {
            this.au.v(a);
        };
        XamDoughnutChart.prototype.notifyResized = function () {
            this.au.y();
        };
        XamDoughnutChart.prototype.bd = function () {
            return this.au.g();
        };
        XamDoughnutChart.prototype.cf = function () {
            return this.au.aa;
        };
        XamDoughnutChart.prototype.a2 = function () {
            return this.au.d;
        };
        XamDoughnutChart.prototype.bk = function () {
            var a;
            var b;
            for (var c = 0; c < this.series.count; c++) {
                b = this.series._inner[c].au();
                for (var d = 0; d < b.count; d++) {
                    a = b._inner[d].ringControl.ak.h();
                    for (var e = 0; e < a.count; e++) {
                        a._inner[e].fv();
                    }
                }
            }
        };
        XamDoughnutChart.prototype.bs = function () {
            if (this.holeDimensionsChanged != null) {
                this.holeDimensionsChanged(this, new HoleDimensionsChangedEventArgs(this.cf(), this.a2()));
            }
        };
        XamDoughnutChart.prototype.as = function () {
            var a = new DoughnutChartVisualData();
            a.series = new RingSeriesVisualDataList();
            a.viewport = i2.RectData.b(this.au.ab);
            this.au.o(a);
            return a;
        };
        XamDoughnutChart.prototype.bc = function () {
            var a = this.as();
            a.scaleByViewport();
            return a.serialize();
        };
        XamDoughnutChart.prototype._ay = function (a) {
            var _a, _b, b, e_22_1;
            var e_22, _c;
            return tslib.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 7]);
                        _a = tslib.__values(i2.fromEnum(this.series)), _b = _a.next();
                        _d.label = 1;
                    case 1:
                        if (!!_b.done)
                            return [3 /*break*/, 4];
                        b = _b.value;
                        if (!PieChartBase.ch(a, b.itemsSource))
                            return [3 /*break*/, 3];
                        return [4 /*yield*/, b];
                    case 2:
                        _d.sent();
                        _d.label = 3;
                    case 3:
                        _b = _a.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_22_1 = _d.sent();
                        e_22 = { error: e_22_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_b && !_b.done && (_c = _a.return))
                                _c.call(_a);
                        }
                        finally {
                            if (e_22)
                                throw e_22.error;
                        }
                        return [7 /*endfinally*/];
                    case 7: return [2 /*return*/];
                }
            });
        };
        XamDoughnutChart.prototype.ay = function (a) {
            var _this = this;
            return i2.toEnum(function () { return _this._ay(a); });
        };
        XamDoughnutChart.prototype.bm = function (source_, a, b) {
            var e_23, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.cy(a, b);
                }
            }
            catch (e_23_1) {
                e_23 = { error: e_23_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_23)
                        throw e_23.error;
                }
            }
        };
        XamDoughnutChart.prototype.bp = function (source_, a, b, c) {
            var e_24, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    d.c0(a, b, c);
                }
            }
            catch (e_24_1) {
                e_24 = { error: e_24_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_24)
                        throw e_24.error;
                }
            }
        };
        XamDoughnutChart.prototype.bl = function (source_) {
            var e_25, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.cx();
                }
            }
            catch (e_25_1) {
                e_25 = { error: e_25_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_25)
                        throw e_25.error;
                }
            }
        };
        XamDoughnutChart.prototype.bn = function (source_, a, b) {
            var e_26, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.cz(a, b);
                }
            }
            catch (e_26_1) {
                e_26 = { error: e_26_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_26)
                        throw e_26.error;
                }
            }
        };
        XamDoughnutChart.$t = i2.markType(XamDoughnutChart, 'XamDoughnutChart', i2.Control.$, [i2.INotifyPropertyChanged_$type, i2.ILegendOwner_$type]);
        XamDoughnutChart.cc = i2.DependencyProperty.i("InnerExtent", i2.Number_$type, XamDoughnutChart.$, new i2.PropertyMetadata(2, 40, function (a, b) {
            var c = b.newValue;
            if (c < 0 || c > 100) {
                if (b.oldValue != null) {
                    a.a3 = b.oldValue;
                }
                return;
            }
            a.b2();
            a.b1("InnerExtent", b.oldValue, b.newValue);
        }));
        XamDoughnutChart.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, XamDoughnutChart, 'b1', ['AllowSliceExplosion:av:b8', [0, true], 'AllowSliceSelection:aw:b9', [0, true], 'CenterData:a5:ca', [4, null], 'CenterDataTemplate:b7:cb', [i2.DataTemplate.$, null], 'IsSurfaceInteractionDisabled:ax:cd', [0, false], 'SelectedStyle:cg:ce', [i2.Style.$, null]]);
        return XamDoughnutChart;
    }(i2.Control));
    /**
     * @hidden
     */
    var ArcView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ArcView, _super);
        function ArcView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b4 = a;
            return _this;
        }
        ArcView.prototype.b6 = function (a, b) {
            this.e.series = this.b4.jb.c;
        };
        ArcView.prototype.b5 = function () {
            return this.f;
        };
        ArcView.prototype.b7 = function () {
            this.bb();
            this.bs = new i2.Brush();
            var a = this.c.t();
            this.bs._fill = a.rootWrapper.getStyleProperty("color");
        };
        ArcView.$t = i2.markType(ArcView, 'ArcView', PieChartBaseView.$);
        return ArcView;
    }(PieChartBaseView));
    /**
     * @hidden
     */
    var RingControlView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingControlView, _super);
        function RingControlView(a) {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.f = new i2.List$1(Arc.$, 0);
            _this.g = new i2.List$1(Arc.$, 0);
            _this.i = null;
            _this.e = new i2.Dictionary$2(Arc.$, i2.DomRenderer_$type, 0);
            _this.c = null;
            _this.b = a;
            return _this;
        }
        RingControlView.prototype.a = function () {
            var a = new Arc();
            a.o = 0;
            a.n = 0;
            a.jb = this.b.ai;
            this.f.add(a);
            this.z(a);
            if (a.fl != this.b.al.co) {
                a.fl = this.b.al.co;
            }
            a.c8 = this.b.al.a6;
            a.a4 = this.b.al.aq;
            a.ef = this.b.al.bp;
            a.az = this.b.al.an;
            a.g7 = this.b.al.da;
            a.fq = this.b.al.cs;
            if (this.b.al.toolTip != null) {
                a.dn = this.b.al.toolTip;
            }
            a.i7 = this.b.al.en;
            a.i3 = this.b.al.ei;
            a.a0 = this.b.al.ao;
            a.c9 = this.b.al.a7;
            a.da = this.b.al.a8;
            a.a1 = this.b.al.ap;
            a.e1 = this.b.al.cj();
            a.i4 = this.b.al.ej;
            a.legend = this.b.al.legend;
            a.legendItemTemplate = this.b.al.legendItemTemplate;
            a.legendItemBadgeTemplate = this.b.al.legendItemBadgeTemplate;
            a.an = this.b.al.al;
            a.it = this.b.al.ef;
            a.iu = this.b.al.eg;
            a.df = this.b.al.ba;
            a.am = this.b.al.ak;
            a.i5 = this.b.al.el;
            a.cc = true;
            a.dd = this.b.al.a9;
            a.b6 = this.b.al.ax.av;
            a.b7 = this.b.al.ax.aw;
            a.a5 = this.b.al.ar;
            a.eu = this.b.al.b3;
            a.cz = this.b.al.ax.a1;
            return a;
        };
        RingControlView.prototype.l = function (a) {
            var b = this.e.item(a).rootWrapper;
            if (b != null) {
                b.show();
            }
            this.g.add(a);
        };
        RingControlView.prototype.n = function (a) {
            var b = this.e.item(a).rootWrapper;
            if (b != null) {
                b.hide();
            }
            this.g.remove(a);
        };
        RingControlView.prototype.m = function (a) {
            this.o(a);
            this.f.remove(a);
        };
        RingControlView.prototype.h = function () {
            return this.f;
        };
        RingControlView.prototype.r = function () {
        };
        RingControlView.prototype.aa = function () {
            this.b.aw();
        };
        RingControlView.prototype.t = function (a, b, c) {
            b = b + this.b.n;
            c = c + this.b.o;
            if (this.c != null) {
                b = b + this.c.n;
                c = c + this.c.o;
            }
            if (a.n != b || a.o != c) {
                a.n = b;
                a.o = c;
                this.u(a, this.e.item(a).rootWrapper);
            }
        };
        RingControlView.prototype.w = function (a) {
            var e_27, _a, e_28, _b;
            if (a == null) {
                this.b.arcs.count = 0;
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.f)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.destroy();
                    }
                }
                catch (e_27_1) {
                    e_27 = { error: e_27_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_27)
                            throw e_27.error;
                    }
                }
                this.f.clear();
                this.e.clear();
                this.g.clear();
                return;
            }
            this.i = a;
            this.i.rootWrapper.setStyleProperty("position", "relative");
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    var d = this.e.item(c);
                    this.i.append(d.rootWrapper);
                    c.i9.b7();
                }
            }
            catch (e_28_1) {
                e_28 = { error: e_28_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_28)
                        throw e_28.error;
                }
            }
            this.aa();
        };
        RingControlView.prototype.z = function (a) {
            var b = this.i.createElement("div");
            b.setStyleProperty("position", "absolute");
            this.e.addItem(a, this.i.getSubRenderer(b));
            this.k(a, b);
            this.u(a, b);
            if (this.i != null) {
                this.i.append(b);
            }
            a.provideContainer(this.e.item(a));
            b.setStyleProperty("position", "absolute");
        };
        RingControlView.prototype.k = function (a, b) {
            b.setStyleProperty("width", a.width.toString() + "px");
            b.setStyleProperty("height", a.height.toString() + "px");
        };
        RingControlView.prototype.u = function (a, b) {
            b.setStyleProperty("top", a.o.toString() + "px");
            b.setStyleProperty("left", a.n.toString() + "px");
        };
        RingControlView.prototype.o = function (a) {
            var b = this.e.item(a);
            b.rootWrapper.remove();
            this.e.removeItem(a);
            a.provideContainer(null);
        };
        RingControlView.prototype.ab = function (a) {
            this.k(a, a.jg().rootWrapper);
            a.f6(a.width, a.height);
        };
        RingControlView.prototype.d = function () {
            return this.i != null;
        };
        RingControlView.prototype.q = function () {
        };
        RingControlView.prototype.s = function (a) {
            this.c = a;
            if (a != null) {
                a.propertyUpdated = i2.delegateCombine(a.propertyUpdated, i2.runOn(this, this.y));
            }
        };
        RingControlView.prototype.y = function (a, b) {
            switch (b.propertyName) {
                case "LabelExtent":
                    for (var c = 0; c < this.f.count; c++) {
                        this.f._inner[c].c8 = b.newValue;
                    }
                    break;
                case "LabelMemberPath":
                    for (var d = 0; d < this.f.count; d++) {
                        this.f._inner[d].ef = b.newValue;
                    }
                    break;
                case "LabelsPosition":
                    for (var e = 0; e < this.f.count; e++) {
                        this.f._inner[e].az = i2.EnumUtil.getEnumValue(LabelsPosition_$type, b.newValue);
                    }
                    break;
                case "LabelTemplate":
                    for (var f = 0; f < this.f.count; f++) {
                        this.f._inner[f].g7 = b.newValue;
                    }
                    break;
                case "ValueMemberPath":
                    for (var g = 0; g < this.f.count; g++) {
                        this.f._inner[g].fq = b.newValue;
                    }
                    break;
                case "ToolTip":
                    for (var h = 0; h < this.f.count; h++) {
                        this.f._inner[h].dn = b.newValue;
                    }
                    break;
                case "LeaderLineVisibility":
                    for (var i = 0; i < this.f.count; i++) {
                        this.f._inner[i].i7 = i2.EnumUtil.getEnumValue(i2.Visibility_$type, b.newValue);
                    }
                    break;
                case "LeaderLineStyle":
                    for (var j = 0; j < this.f.count; j++) {
                        this.f._inner[j].i3 = b.newValue;
                    }
                    break;
                case "LeaderLineType":
                    for (var k = 0; k < this.f.count; k++) {
                        this.f._inner[k].a0 = i2.EnumUtil.getEnumValue(LeaderLineType_$type, b.newValue);
                    }
                    break;
                case "LeaderLineMargin":
                    for (var l = 0; l < this.f.count; l++) {
                        this.f._inner[l].c9 = b.newValue;
                    }
                    break;
                case "OthersCategoryThreshold":
                    for (var m = 0; m < this.f.count; m++) {
                        this.f._inner[m].da = b.newValue;
                    }
                    break;
                case "OthersCategoryType":
                    for (var n = 0; n < this.f.count; n++) {
                        this.f._inner[n].a1 = i2.EnumUtil.getEnumValue(OthersCategoryType_$type, b.newValue);
                    }
                    break;
                case "OthersCategoryText":
                    for (var o = 0; o < this.f.count; o++) {
                        this.f._inner[o].e1 = b.newValue;
                    }
                    break;
                case "OthersCategoryStyle":
                    for (var p = 0; p < this.f.count; p++) {
                        this.f._inner[p].i4 = b.newValue;
                    }
                    break;
                case "Legend":
                    for (var q = 0; q < this.f.count; q++) {
                        this.f._inner[q].legend = b.newValue;
                    }
                    break;
                case "LegendItemTemplate":
                    for (var r = 0; r < this.f.count; r++) {
                        this.f._inner[r].legendItemTemplate = b.newValue;
                    }
                    break;
                case "LegendItemBadgeTemplate":
                    for (var s = 0; s < this.f.count; s++) {
                        this.f._inner[s].legendItemBadgeTemplate = b.newValue;
                    }
                    break;
                case "Outlines":
                    for (var t = 0; t < this.f.count; t++) {
                        this.f._inner[t].an = b.newValue;
                    }
                    break;
                case "Brushes":
                    for (var u = 0; u < this.f.count; u++) {
                        this.f._inner[u].am = b.newValue;
                    }
                    break;
                case "SelectedStyle":
                    for (var v = 0; v < this.f.count; v++) {
                        this.f._inner[v].i5 = b.newValue;
                    }
                    break;
                case "SelectedStyleResolved":
                    for (var w = 0; w < this.f.count; w++) {
                        this.f._inner[w].i5 = b.newValue;
                    }
                    break;
                case "RadiusFactor":
                    for (var x = 0; x < this.f.count; x++) {
                        this.f._inner[x].dd = b.newValue;
                    }
                    break;
            }
        };
        RingControlView.prototype.p = function () {
            var e_29, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.fv();
                }
            }
            catch (e_29_1) {
                e_29 = { error: e_29_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_29)
                        throw e_29.error;
                }
            }
        };
        RingControlView.prototype.j = function () {
            return this.i;
        };
        RingControlView.prototype.v = function (a, b) {
            this.b.n = a;
            this.b.o = b;
            this.x();
        };
        RingControlView.prototype.x = function () {
            for (var a = 0; a < this.f.count; a++) {
                var b = this.f._inner[a];
                this.t(b, 0, 0);
            }
        };
        RingControlView.$t = i2.markType(RingControlView, 'RingControlView');
        return RingControlView;
    }(i2.Base));
    /**
     * @hidden
     */
    var RingSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingSeriesBaseView, _super);
        function RingSeriesBaseView(a) {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.f = null;
            _this.g = null;
            _this.a = null;
            _this.b = null;
            _this.o = null;
            _this.d = null;
            _this.f = new i2.List$1(RingControl.$, 0);
            _this.c = a;
            return _this;
        }
        RingSeriesBaseView.prototype.k = function () {
            this.c.legendItemTemplate = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = PieLegendTemplates.c;
                $ret.measure = PieLegendTemplates.a;
                return $ret;
            })());
            this.c.legendItemBadgeTemplate = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = PieLegendTemplates.b;
                $ret.measure = PieLegendTemplates.d;
                return $ret;
            })());
        };
        RingSeriesBaseView.prototype.h = function (a) {
            if (!this.f.contains(a)) {
                this.f.add(a);
            }
            if (this.g != null && (a.ap() != this.g)) {
                a.ay(this.g);
            }
        };
        RingSeriesBaseView.prototype.j = function (a, b, c, d, e) {
            var f = i2.BrushUtil.e("chart", a, b, c);
            b = f.p2;
            c = f.p3;
            var g = new Array(b.count * 2);
            for (var h = 0; h < g.length; h += 2) {
                g[h] = "#fff";
                g[h + 1] = b.item(i2.intDivide(h, 2))._fill;
            }
            var i = i2.BrushUtil.e("doughnut", a, b, c, g);
            b = i.p2;
            c = i.p3;
            d = new i2.Brush();
            d._fill = this.g.rootWrapper.getStyleProperty("color");
            e = i2.FontUtil.getFont(a);
            return {
                p1: b,
                p2: c,
                p3: d,
                p4: e
            };
        };
        RingSeriesBaseView.prototype.n = function (a) {
            var e_30, _a, e_31, _b;
            if (a == null) {
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.f)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        b.ay(null);
                    }
                }
                catch (e_30_1) {
                    e_30 = { error: e_30_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_30)
                            throw e_30.error;
                    }
                }
                return;
            }
            this.g = a;
            var c;
            var d;
            var e;
            var f;
            var g = this.j(this.g, c, d, e, f);
            c = g.p1;
            d = g.p2;
            e = g.p3;
            f = g.p4;
            this.a = c;
            this.b = d;
            this.o = e;
            this.d = f;
            if (this.c.ak == null) {
                this.c.ak = this.a;
            }
            if (this.c.al == null) {
                this.c.al = this.b;
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var h = _f.value;
                    h.ay(this.g);
                }
            }
            catch (e_31_1) {
                e_31 = { error: e_31_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_31)
                        throw e_31.error;
                }
            }
        };
        RingSeriesBaseView.prototype.e = function () {
            return true;
        };
        RingSeriesBaseView.prototype.i = function () {
            this.n(null);
        };
        RingSeriesBaseView.prototype.l = function () {
            for (var a = 0; a < this.f.count; a++) {
                var b = this.f._inner[a];
                for (var c = 0; c < b.arcs.a.count; c++) {
                    var d = b.arcs.a._inner[c];
                    d.fv();
                }
            }
        };
        RingSeriesBaseView.prototype.m = function (a, b) {
            this.c.n = a;
            this.c.o = b;
            this.c.eh = { $type: i2.Point_$type, x: a, y: b };
        };
        RingSeriesBaseView.$t = i2.markType(RingSeriesBaseView, 'RingSeriesBaseView');
        return RingSeriesBaseView;
    }(i2.Base));
    /**
     * @hidden
     */
    var XamDoughnutChartView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamDoughnutChartView, _super);
        function XamDoughnutChartView(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.aa = null;
            _this.d = 0;
            _this.c = null;
            _this.ab = null;
            _this.f = null;
            _this.e = null;
            _this.b = null;
            _this.ab = i2.Rect.empty;
            _this.aa = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.d = 0;
            _this.c = new i2.List$1(RingSeriesBase.$, 0);
            _this.a = a;
            return _this;
        }
        XamDoughnutChartView.prototype.s = function () {
            this.p();
        };
        XamDoughnutChartView.prototype.z = function () {
        };
        XamDoughnutChartView.prototype.h = function (a) {
            if (!this.c.contains(a)) {
                a.c5(this.e);
                this.c.add(a);
            }
        };
        XamDoughnutChartView.prototype.w = function (a) {
            if (this.c.contains(a)) {
                a.c5(null);
                this.c.remove(a);
            }
        };
        XamDoughnutChartView.prototype.i = function () {
        };
        XamDoughnutChartView.prototype.y = function () {
            if (this.e == null) {
                return;
            }
            this.p();
            var a = this.e.rootWrapper.width();
            var b = this.e.rootWrapper.height();
            this.ab = new i2.Rect(0, 0, 0, a, b);
            if (this.b != null) {
                this.b.bg = this.ab;
            }
            this.a.bt();
        };
        XamDoughnutChartView.prototype.v = function (a) {
            if (a == null) {
                if (this.b != null) {
                    this.b.ar();
                }
                return;
            }
            var b = a;
            this.e = b;
            var c = this.e.rootWrapper.width();
            var d = this.e.rootWrapper.height();
            this.ab = new i2.Rect(0, 0, 0, c, d);
            this.b = new i2.DOMEventProxy(this.e.rootWrapper, this.e, false);
            this.b.bg = this.ab;
            var e = this.b;
            e.onMouseOver = i2.delegateCombine(e.onMouseOver, i2.runOn(this, this.m));
            var f = this.b;
            f.onMouseLeave = i2.delegateCombine(f.onMouseLeave, i2.runOn(this, this.l));
            var g = this.b;
            g.onMouseDown = i2.delegateCombine(g.onMouseDown, i2.runOn(this, this.k));
            var h = this.b;
            h.onMouseUp = i2.delegateCombine(h.onMouseUp, i2.runOn(this, this.n));
            this.y();
        };
        XamDoughnutChartView.prototype.t = function (a, b, c) {
            for (var d = this.c.count - 1; d >= 0; d--) {
                var e = this.c._inner[d];
                if (e.a4) {
                    continue;
                }
                var f = e.aw.f;
                for (var g = 0; g < f.count; g++) {
                    var h = f._inner[g];
                    var i = h.arcs.a;
                    for (var j = 0; j < i.count; j++) {
                        var k = i._inner[j];
                        var l = { $type: i2.Point_$type, x: a.x - k.n, y: a.y - k.o };
                        b(k.a3, l);
                        if (c == "mouseUp") {
                            var m = k.i9.b5();
                            if (m != null) {
                                return;
                            }
                        }
                    }
                }
            }
        };
        XamDoughnutChartView.prototype.n = function (a) {
            this.t(a, function (b, c) { return b.ak(c); }, "mouseUp");
        };
        XamDoughnutChartView.prototype.k = function (a) {
            this.t(a, function (b, c) { return b.ah(c); }, "mouseDown");
        };
        XamDoughnutChartView.prototype.l = function (a) {
            this.t(a, function (b, c) { return b.ai(c); }, "mouseLeave");
        };
        XamDoughnutChartView.prototype.m = function (a, b, c) {
            this.t(a, function (d, e) { return d.aj(e, b, c); }, "mouseOver");
        };
        XamDoughnutChartView.prototype.g = function () {
            return this.e.rootWrapper.getAttribute("id");
        };
        XamDoughnutChartView.prototype.u = function (a, b) {
            if (!this.ab.isEmpty && this.ab.width != 0 && this.ab.height != 0) {
                var c = this.aa.x;
                var d = this.aa.y;
                this.aa.x = this.ab.width / 2;
                this.aa.y = this.ab.height / 2;
                if (this.aa.x != c || this.aa.y != d) {
                    this.a.bs();
                }
            }
        };
        XamDoughnutChartView.prototype.x = function (a, b) {
            var c = this.d;
            this.d = a / 2;
            if (c != this.d) {
                this.a.bs();
            }
        };
        XamDoughnutChartView.prototype.j = function () {
        };
        XamDoughnutChartView.prototype.o = function (a) {
            a.width = this.a.width;
            a.height = this.a.height;
            a.holeRadius = this.a.a2();
            for (var b = 0; b < this.a.series.count; b++) {
                a.series.add(new RingSeriesVisualData());
                a.series._inner[b].rings = new RingVisualDataList();
                a.series._inner[b].name = this.a.series._inner[b].name;
                a.series._inner[b].labelExtent = this.a.series._inner[b].a6;
                a.series._inner[b].leaderLineMargin = this.a.series._inner[b].a7;
                a.series._inner[b].leaderLineType = i2.EnumUtil.getName(LeaderLineType_$type, this.a.series._inner[b].ao);
                a.series._inner[b].labelsPosition = i2.EnumUtil.getName(LabelsPosition_$type, this.a.series._inner[b].an);
                a.series._inner[b].leaderLineVisibility = this.a.series._inner[b].en == 0;
                for (var c = 0; c < this.a.series._inner[b].au().count; c++) {
                    a.series._inner[b].rings.add(new RingVisualData());
                    a.series._inner[b].rings._inner[c].arcs = new ArcVisualDataList();
                    for (var d = 0; d < this.a.series._inner[b].au()._inner[c].g.count; d++) {
                        a.series._inner[b].rings._inner[c].arcs.add(new ArcVisualData());
                        a.series._inner[b].rings._inner[c].arcs._inner[d].a = new SliceVisualDataList();
                        var _loop_4 = function (e) {
                            if (null == this_4.a.series._inner[b].au()._inner[c].g._inner[d].g._inner[e].b) {
                                return "continue";
                            }
                            a.series._inner[b].rings._inner[c].arcs._inner[d].a.add(new SliceVisualData());
                            var f = new SliceVisualData();
                            var g = this_4.a.series._inner[b].au()._inner[c].g._inner[d].g._inner[e].b;
                            f.visibility = g._visibility == 0;
                            f.endAngle = g.ax;
                            f.startAngle = g.a3;
                            f.radius = g.a2;
                            f.origin = i2.PointData.b(g.b7);
                            f.explodedOrigin = i2.PointData.b(g.b5);
                            f.index = g.a5;
                            f.isExploded = g.isExploded;
                            f.isSelected = g.isSelected;
                            f.outline = i2.AppearanceHelper.a(g.b1);
                            f.backgroundPath = new i2.PathVisualData(1, "slicePath", g.al.f());
                            a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e] = f;
                            var h = g.aj;
                            if (null != h) {
                                a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e].labelVisualData = ((function () {
                                    var $ret = new DoughnutChartLabelVisualData();
                                    $ret.labelSize = i2.SizeData.b(i2.RectUtil.z(h.ao));
                                    $ret.labelValue = h.aj.ak;
                                    return $ret;
                                })());
                                if (!i2.isNaN_(h.n) && !i2.isNaN_(h.o)) {
                                    a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e].labelVisualData.labelPosition = new i2.PointData(h.n, h.o);
                                }
                            }
                        };
                        var this_4 = this;
                        for (var e = 0; e < this.a.series._inner[b].au()._inner[c].g._inner[d].g.count; e++) {
                            _loop_4(e);
                        }
                    }
                }
            }
        };
        XamDoughnutChartView.prototype.p = function () {
            var a = this.a.a4;
            var b = this.a.a1;
            if (!i2.isNaN_(a) && a != 0) {
                return;
            }
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
                this.a.a1 = window.devicePixelRatio;
            }
        };
        XamDoughnutChartView.prototype.r = function () {
            if (this.b != null) {
                this.b.bc(this.e.rootWrapper, "");
            }
        };
        XamDoughnutChartView.prototype.q = function () {
            this.p();
            if (this.b != null) {
                this.b.aq(this.e.rootWrapper, "");
            }
        };
        XamDoughnutChartView.$t = i2.markType(XamDoughnutChartView, 'XamDoughnutChartView');
        return XamDoughnutChartView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Contains PieChart click event data.
    */
    var IgxSliceClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxSliceClickEventArgs() {
        }
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxSliceClickEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxSliceClickEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "isSelected", {
            /**
             * Gets or sets whether the slice is selected.
            */
            get: function () {
                return this.i.isSelected;
            },
            set: function (v) {
                this.i.isSelected = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "isExploded", {
            /**
             * Gets or sets whether the slice is exploded.
            */
            get: function () {
                return this.i.isExploded;
            },
            set: function (v) {
                this.i.isExploded = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "isOthersSlice", {
            /**
             * Gets whether the current slice is part of the others slice.
            */
            get: function () {
                return this.i.isOthersSlice;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "index", {
            /**
             * Gets the index of the slice that was clicked.
            */
            get: function () {
                return this.i.index;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "dataContext", {
            /**
             * Gets the slice data context.
            */
            get: function () {
                return this.i.dataContext;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "originalEvent", {
            /**
             * Holds a reference to the original event that triggered slice click.
            */
            get: function () {
                return this.i.originalEvent;
            },
            set: function (v) {
                this.i.originalEvent = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "origin", {
            /**
             * Gets the origin location of the slice.
            */
            get: function () {
                return i2.fromPoint(this.i.origin);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "radius", {
            /**
             * Gets the radius of the slice.
            */
            get: function () {
                return this.i.radius;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "bounds", {
            /**
             * Gets the bounds of the slice.
            */
            get: function () {
                return i2.fromRect(this.i.bounds);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "startAngle", {
            /**
             * Gets the start angle of the slice.
            */
            get: function () {
                return this.i.startAngle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "endAngle", {
            /**
             * Gets the end angle of the slice.
            */
            get: function () {
                return this.i.endAngle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "fill", {
            /**
             * Gets the fill color of the slice.
            */
            get: function () {
                return i2.brushToString(this.i.fill);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceClickEventArgs.prototype, "outline", {
            /**
             * Gets the outline color of the slice.
            */
            get: function () {
                return i2.brushToString(this.i.outline);
            },
            enumerable: false,
            configurable: true
        });
        return IgxSliceClickEventArgs;
    }());

    /**
     * EventArgs class holding information about the dimensions of a hole in a doughnut chart.
    */
    var IgxHoleDimensionsChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxHoleDimensionsChangedEventArgs() {
        }
        Object.defineProperty(IgxHoleDimensionsChangedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxHoleDimensionsChangedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxHoleDimensionsChangedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxHoleDimensionsChangedEventArgs.prototype, "center", {
            /**
             * The center point of the hole.
            */
            get: function () {
                return i2.fromPoint(this.i.center);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHoleDimensionsChangedEventArgs.prototype, "radius", {
            /**
             * The radius of the hole.
            */
            get: function () {
                return this.i.radius;
            },
            enumerable: false,
            configurable: true
        });
        return IgxHoleDimensionsChangedEventArgs;
    }());

    /**
     * Represents a IgxDoughnutChartComponent base series.
    */
    var IgxRingSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxRingSeriesBaseComponent() {
            //
            this._dataSource = null;
            this._tooltipTemplate = null;
            this._tooltipContent = null;
            this._tooltipContainerTemplate = null;
            this._showDefaultTooltip = false;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._propertyUpdated = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxRingSeriesBaseComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxRingSeriesBaseComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.bindData();
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.bindData = function () {
            if (this.i != null && this.i !== undefined) {
                this.i.itemsSource = this._dataSource;
            }
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.onImplementationCreated = function () {
        };
        IgxRingSeriesBaseComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "legend", {
            get: function () {
                if (this.i.legend != null)
                    return this.i.legend.externalObject;
            },
            set: function (v) {
                if (v != undefined && v != null)
                    this.i.legend = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "tooltipTemplate", {
            get: function () {
                return this._tooltipTemplate;
            },
            set: function (value) {
                this._tooltipTemplate = value;
                if (value == null) {
                    if (this._tooltipContent !== null) {
                        this._tooltipContent.destroy();
                        this._tooltipContent = null;
                    }
                }
                if (this._tooltipContent != null) {
                    this._tooltipContent.instance.template = this._tooltipTemplate;
                }
                else {
                    if (this.owner != null) {
                        this.owner._ensureTooltipCreated(this);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "tooltipContainerTemplate", {
            get: function () {
                return this._tooltipContainerTemplate;
            },
            set: function (value) {
                this._tooltipContainerTemplate = value;
                if (this._tooltipContent != null) {
                    this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
                }
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype._ensureTooltipCreated = function (createTooltip, createWrapper) {
            if (this._tooltipTemplate == null) {
                this.i.toolTip = null;
            }
            if (this._tooltipContent == null && this._tooltipTemplate != null) {
                var tooltip = createTooltip();
                if (tooltip == null) {
                    return;
                }
                this._tooltipContent = tooltip;
                tooltip.instance.template = this._tooltipTemplate;
                this.i.toolTip = createWrapper(tooltip.location.nativeElement);
            }
        };
        IgxRingSeriesBaseComponent.prototype._ensureTooltipDestroyed = function () {
            if (this._tooltipContent !== null) {
                this._tooltipContent.destroy();
                this._tooltipContent = null;
            }
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "showDefaultTooltip", {
            /**
             * Gets or sets whether default tooltip will be shown.
            */
            get: function () {
                return this._showDefaultTooltip;
            },
            set: function (v) {
                this._showDefaultTooltip = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.sychronizeCollections = function () { };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "valueMemberPath", {
            /**
         * Gets or Sets the property name that contains the values.
        */
            get: function () {
                return this.i.cs;
            },
            set: function (v) {
                this.i.cs = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelMemberPath", {
            /**
             * Gets or sets the property name that contains the labels.
            */
            get: function () {
                return this.i.bp;
            },
            set: function (v) {
                this.i.bp = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "legendLabelMemberPath", {
            /**
             * Gets or sets the property name that contains the legend labels.
            */
            get: function () {
                return this.i.b3;
            },
            set: function (v) {
                this.i.b3 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelsPosition", {
            /**
             * Gets or sets the position of chart labels.
            */
            get: function () {
                return this.i.an;
            },
            set: function (v) {
                this.i.an = i2.ensureEnum(LabelsPosition_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineVisibility", {
            /**
             * Gets or sets whether the leader lines are visible.
            */
            get: function () {
                return this.i.en;
            },
            set: function (v) {
                this.i.en = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.ei ? this.i.ei.fill : null;
            },
            set: function (v) {
                this.ensureLeaderLineStyle();
                this.i.ei.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.ei ? this.i.ei.stroke : null;
            },
            set: function (v) {
                this.ensureLeaderLineStyle();
                this.i.ei.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.ei ? this.i.ei.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureLeaderLineStyle();
                this.i.ei.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.ei ? this.i.ei.opacity : NaN;
            },
            set: function (v) {
                this.ensureLeaderLineStyle();
                this.i.ei.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.ensureLeaderLineStyle = function () {
            if (this.i.ei) {
                return;
            }
            this.i.ei = new i2.Style();
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineType", {
            /**
             * Gets or sets what type of leader lines will be used for the outside end labels.
            */
            get: function () {
                return this.i.ao;
            },
            set: function (v) {
                this.i.ao = i2.ensureEnum(LeaderLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "leaderLineMargin", {
            /**
             * Gets or sets the margin between a label and its leader line. The default is 6 pixels.
            */
            get: function () {
                return this.i.a7;
            },
            set: function (v) {
                this.i.a7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryThreshold", {
            /**
             * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
            */
            get: function () {
                return this.i.a8;
            },
            set: function (v) {
                this.i.a8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryType", {
            /**
             * Gets or sets whether to use numeric or percent-based threshold value.
            */
            get: function () {
                return this.i.ap;
            },
            set: function (v) {
                this.i.ap = i2.ensureEnum(OthersCategoryType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryText", {
            /**
             * Gets or sets the label of the Others slice.
            */
            get: function () {
                return this.i.ca;
            },
            set: function (v) {
                this.i.ca = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "formatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
            */
            get: function () {
                return this.i.aq;
            },
            set: function (v) {
                this.i.aq = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "formatLegendLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
            */
            get: function () {
                return this.i.ar;
            },
            set: function (v) {
                this.i.ar = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.bl;
            },
            set: function (v) {
                this.i.bl = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LabelFormat string.
            */
            get: function () {
                return this.i.ag;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ag = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersLabelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.ce;
            },
            set: function (v) {
                this.i.ce = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the OthersLabelFormat string.
            */
            get: function () {
                return this.i.aj;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.aj = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "legendLabelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.b0;
            },
            set: function (v) {
                this.i.b0 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "legendLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LegendLabelFormat string.
            */
            get: function () {
                return this.i.ah;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ah = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "legendOthersLabelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.b5;
            },
            set: function (v) {
                this.i.b5 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "legendOthersLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LegendOthersLabelFormat string.
            */
            get: function () {
                return this.i.ai;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ai = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelExtent", {
            /**
             * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
            */
            get: function () {
                return this.i.a6;
            },
            set: function (v) {
                this.i.a6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "startAngle", {
            /**
             * Gets or sets the starting angle of the chart.
             * The default zero value is equivalent to 3 o'clock.
            */
            get: function () {
                return this.i.ba;
            },
            set: function (v) {
                this.i.ba = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.ej ? this.i.ej.fill : null;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.ej.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.ej ? this.i.ej.stroke : null;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.ej.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.ej ? this.i.ej.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.ej.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "othersCategoryOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.ej ? this.i.ej.opacity : NaN;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.ej.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.ensureOthersCategoryStyle = function () {
            if (this.i.ej) {
                return;
            }
            this.i.ej = new i2.Style();
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "selectedSliceFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.ek ? this.i.ek.fill : null;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.ek.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "selectedSliceStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.ek ? this.i.ek.stroke : null;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.ek.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "selectedSliceStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.ek ? this.i.ek.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.ek.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "selectedSliceOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.ek ? this.i.ek.opacity : NaN;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.ek.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.ensureSelectedStyle = function () {
            if (this.i.ek) {
                return;
            }
            this.i.ek = new i2.Style();
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "brushes", {
            /**
             * Gets or sets the palette of brushes to use for coloring the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ak);
            },
            set: function (v) {
                this.i.ak = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "outlines", {
            /**
             * Gets or sets the palette of brushes to use for outlines on the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.al);
            },
            set: function (v) {
                this.i.al = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelOuterColor", {
            /**
             * Gets or sets the color for labels rendered outside of the pie chart.
            */
            get: function () {
                return i2.brushToString(this.i.eg);
            },
            set: function (v) {
                this.i.eg = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "labelInnerColor", {
            /**
             * Gets or sets the color for labels rendered inside of the pie chart.
            */
            get: function () {
                return i2.brushToString(this.i.ef);
            },
            set: function (v) {
                this.i.ef = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "isSurfaceInteractionDisabled", {
            /**
             * Gets or sets whether all surface interactions with the plot area should be disabled.
            */
            get: function () {
                return this.i.a3;
            },
            set: function (v) {
                this.i.a3 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "radiusFactor", {
            /**
             * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
            */
            get: function () {
                return this.i.a9;
            },
            set: function (v) {
                this.i.a9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.findByName = function (name) {
            if (this.legend && this.legend.name && this.legend.name == name) {
                return this.legend;
            }
            if (this.labelFormatSpecifiers != null && i2.arrayFindByName(this.labelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.labelFormatSpecifiers, name);
            }
            if (this.othersLabelFormatSpecifiers != null && i2.arrayFindByName(this.othersLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.othersLabelFormatSpecifiers, name);
            }
            if (this.legendLabelFormatSpecifiers != null && i2.arrayFindByName(this.legendLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.legendLabelFormatSpecifiers, name);
            }
            if (this.legendOthersLabelFormatSpecifiers != null && i2.arrayFindByName(this.legendOthersLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.legendOthersLabelFormatSpecifiers, name);
            }
            return null;
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxRingSeriesBaseComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("RingSeriesBaseComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Called by the UI framework to provide a UI container for rendering this control.

    * @param container  * The UI container element.
    */
        IgxRingSeriesBaseComponent.prototype.provideContainer = function (container) {
            this.i.c5(container);
        };
        Object.defineProperty(IgxRingSeriesBaseComponent.prototype, "propertyUpdated", {
            /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
            get: function () {
                var _this = this;
                if (this._propertyUpdated == null) {
                    this._propertyUpdated = new i0.EventEmitter();
                    this.i.propertyUpdated = i2.delegateCombine(this.i.propertyUpdated, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new i2.IgxPropertyUpdatedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePropertyUpdated) {
                                _this.beforePropertyUpdated(_this, outerArgs);
                            }
                            _this._propertyUpdated.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._propertyUpdated;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesBaseComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxRingSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRingSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRingSeriesBaseComponent, selector: "ng-component", inputs: { dataSource: "dataSource", legend: "legend", tooltipTemplate: "tooltipTemplate", tooltipContainerTemplate: "tooltipContainerTemplate", showDefaultTooltip: "showDefaultTooltip", valueMemberPath: "valueMemberPath", labelMemberPath: "labelMemberPath", legendLabelMemberPath: "legendLabelMemberPath", labelsPosition: "labelsPosition", leaderLineVisibility: "leaderLineVisibility", leaderLineFill: "leaderLineFill", leaderLineStroke: "leaderLineStroke", leaderLineStrokeThickness: "leaderLineStrokeThickness", leaderLineOpacity: "leaderLineOpacity", leaderLineType: "leaderLineType", leaderLineMargin: "leaderLineMargin", othersCategoryThreshold: "othersCategoryThreshold", othersCategoryType: "othersCategoryType", othersCategoryText: "othersCategoryText", formatLabel: "formatLabel", formatLegendLabel: "formatLegendLabel", labelFormat: "labelFormat", labelFormatSpecifiers: "labelFormatSpecifiers", othersLabelFormat: "othersLabelFormat", othersLabelFormatSpecifiers: "othersLabelFormatSpecifiers", legendLabelFormat: "legendLabelFormat", legendLabelFormatSpecifiers: "legendLabelFormatSpecifiers", legendOthersLabelFormat: "legendOthersLabelFormat", legendOthersLabelFormatSpecifiers: "legendOthersLabelFormatSpecifiers", labelExtent: "labelExtent", startAngle: "startAngle", othersCategoryFill: "othersCategoryFill", othersCategoryStroke: "othersCategoryStroke", othersCategoryStrokeThickness: "othersCategoryStrokeThickness", othersCategoryOpacity: "othersCategoryOpacity", selectedSliceFill: "selectedSliceFill", selectedSliceStroke: "selectedSliceStroke", selectedSliceStrokeThickness: "selectedSliceStrokeThickness", selectedSliceOpacity: "selectedSliceOpacity", brushes: "brushes", outlines: "outlines", labelOuterColor: "labelOuterColor", labelInnerColor: "labelInnerColor", isSurfaceInteractionDisabled: "isSurfaceInteractionDisabled", radiusFactor: "radiusFactor" }, outputs: { propertyUpdated: "propertyUpdated" }, ngImport: i0, template: "", isInline: true });
        return IgxRingSeriesBaseComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { dataSource: [{
                    type: i0.Input
                }], legend: [{
                    type: i0.Input
                }], tooltipTemplate: [{
                    type: i0.Input
                }], tooltipContainerTemplate: [{
                    type: i0.Input
                }], showDefaultTooltip: [{
                    type: i0.Input
                }], valueMemberPath: [{
                    type: i0.Input
                }], labelMemberPath: [{
                    type: i0.Input
                }], legendLabelMemberPath: [{
                    type: i0.Input
                }], labelsPosition: [{
                    type: i0.Input
                }], leaderLineVisibility: [{
                    type: i0.Input
                }], leaderLineFill: [{
                    type: i0.Input
                }], leaderLineStroke: [{
                    type: i0.Input
                }], leaderLineStrokeThickness: [{
                    type: i0.Input
                }], leaderLineOpacity: [{
                    type: i0.Input
                }], leaderLineType: [{
                    type: i0.Input
                }], leaderLineMargin: [{
                    type: i0.Input
                }], othersCategoryThreshold: [{
                    type: i0.Input
                }], othersCategoryType: [{
                    type: i0.Input
                }], othersCategoryText: [{
                    type: i0.Input
                }], formatLabel: [{
                    type: i0.Input
                }], formatLegendLabel: [{
                    type: i0.Input
                }], labelFormat: [{
                    type: i0.Input
                }], labelFormatSpecifiers: [{
                    type: i0.Input
                }], othersLabelFormat: [{
                    type: i0.Input
                }], othersLabelFormatSpecifiers: [{
                    type: i0.Input
                }], legendLabelFormat: [{
                    type: i0.Input
                }], legendLabelFormatSpecifiers: [{
                    type: i0.Input
                }], legendOthersLabelFormat: [{
                    type: i0.Input
                }], legendOthersLabelFormatSpecifiers: [{
                    type: i0.Input
                }], labelExtent: [{
                    type: i0.Input
                }], startAngle: [{
                    type: i0.Input
                }], othersCategoryFill: [{
                    type: i0.Input
                }], othersCategoryStroke: [{
                    type: i0.Input
                }], othersCategoryStrokeThickness: [{
                    type: i0.Input
                }], othersCategoryOpacity: [{
                    type: i0.Input
                }], selectedSliceFill: [{
                    type: i0.Input
                }], selectedSliceStroke: [{
                    type: i0.Input
                }], selectedSliceStrokeThickness: [{
                    type: i0.Input
                }], selectedSliceOpacity: [{
                    type: i0.Input
                }], brushes: [{
                    type: i0.Input
                }], outlines: [{
                    type: i0.Input
                }], labelOuterColor: [{
                    type: i0.Input
                }], labelInnerColor: [{
                    type: i0.Input
                }], isSurfaceInteractionDisabled: [{
                    type: i0.Input
                }], radiusFactor: [{
                    type: i0.Input
                }], propertyUpdated: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    var IgxRingSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRingSeriesCollection, _super);
        function IgxRingSeriesCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxRingSeriesBaseComponent.$type) {
                IgxRingSeriesBaseComponent.$type = i2.markType(IgxRingSeriesBaseComponent, "IgxRingSeriesBaseComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxRingSeriesCollection.prototype._createInnerColl = function () {
            if (!IgxRingSeriesBaseComponent.$type) {
                IgxRingSeriesBaseComponent.$type = i2.markType(IgxRingSeriesBaseComponent, "IgxRingSeriesBaseComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxRingSeriesBaseComponent.$type, RingSeriesBase.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = IgxRingSeriesBaseComponent._createFromInternal(int);
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxRingSeriesCollection;
    }(i2.IgCollection));

    /**
     * DataContext for a pie slice.
    */
    var IgxPieSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPieSliceDataContext, _super);
        function IgxPieSliceDataContext() {
            return _super.call(this) || this;
        }
        IgxPieSliceDataContext.prototype.createImplementation = function () {
            return new PieSliceDataContext();
        };
        Object.defineProperty(IgxPieSliceDataContext.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieSliceDataContext.prototype, "percentValue", {
            /**
             * Gets or sets the value of this slice as a percentage of the total pie.
            */
            get: function () {
                return this.i.percentValue;
            },
            set: function (v) {
                this.i.percentValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieSliceDataContext.prototype, "isOthersSlice", {
            /**
             * Gets or sets whether this slice is an Others slice or not.
            */
            get: function () {
                return this.i.isOthersSlice;
            },
            set: function (v) {
                this.i.isOthersSlice = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxPieSliceDataContext;
    }(i2.IgxDataContext));

    /**
     * Represents concentric circles divided on arcs  depending on data.
    */
    var IgxDoughnutChartComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = this;
            this.renderer = renderer;
            this._elRef = _elRef;
            this.ngZone = ngZone;
            this.injector = injector;
            this.componentFactoryResolver = componentFactoryResolver;
            /**
             * The series actually present in the chart. Do not directly modify this array.
             * This array's contents can be modified by causing Angular to reproject the child content.
             * Or adding and removing series from the manual series collection on the series property.
             */
            this.actualSeries = [];
            this._seriesAdapter = null;
            this._series = null;
            this._defaultTooltips = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._sliceClick = null;
            this._holeDimensionsChanged = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
            this._zoneRunner = function (act) { return ngZone.run(act); };
            this.container = renderer.createElement("div");
            renderer.appendChild(_elRef.element.nativeElement, this.container);
            renderer.setStyle(this.container, "display", "block");
            renderer.setStyle(this.container, "width", "100%");
            renderer.setStyle(this.container, "height", "100%");
            var root;
            root = this.container;
            if (this.container != null) {
                root = this.container;
            }
            var ren = new i2.AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
            this._wrapper = ren;
            var chart = this.i;
            this._chart = chart;
            this._seriesAdapter = new i2.CollectionAdapter([], this.i.series, this.actualSeries, function (c) { return c.i; }, function (i) {
                i.owner = _this;
                // (<any>i)._provideRenderer(this._dataSource);
                if (_this.container && _this.container.parentElement) {
                    i._styling(_this.container, _this, _this);
                }
                _this._ensureDefaultTooltip(i);
                _this._ensureTooltipCreated(i);
            }, function (i) {
                //(<any>i)._provideRenderer(null);
            });
            chart.provideContainer(ren);
            ren.addSizeWatcher(function () {
                _this._chart.notifyResized();
            });
        }
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype.ngOnDestroy = function () {
            this._chart.destroy();
            this._wrapper.destroy();
        };
        IgxDoughnutChartComponent.prototype.onImplementationCreated = function () {
        };
        IgxDoughnutChartComponent.prototype.createImplementation = function () {
            return new XamDoughnutChart();
        };
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype.createSeriesComponent = function (type) {
            if (i2.TypeRegistrar.isRegistered(type)) {
                var s = i2.TypeRegistrar.create(type);
                s.owner = this;
                s._provideRenderer(this._wrapper);
                return s;
            }
            else {
                //we shouldn't get here, hopefully.
                throw Error("series type not loaded: " + type);
            }
        };
        IgxDoughnutChartComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (i2.TypeRegistrar.isRegistered("IgxDoughnutChartDefaultTooltipsComponent")) {
                var c = i2.TypeRegistrar.get("IgxDoughnutChartDefaultTooltipsComponent");
                var cf = this.componentFactoryResolver.resolveComponentFactory(c);
                var cr_1 = this._dynamicContent.createComponent(cf);
                this._defaultTooltips = cr_1;
                cr_1.instance.onContentReady.subscribe(function () {
                    _this._onDefaultTooltipsReady(cr_1);
                });
            }
            this._seriesAdapter.updateQuery(this.contentSeries);
            this._styling(this.container, this);
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    currSeries[i]._styling(this.container, this, this);
                }
            }
            this.i.notifyResized();
        };
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "series", {
            /**
             * A collection or manually added series for the chart.
            */
            get: function () {
                var _this = this;
                if (this._series === null) {
                    var coll = new IgxRingSeriesCollection();
                    var inner = coll._innerColl;
                    inner.addListener(function (sender, e) {
                        switch (e.action) {
                            case i2.NotifyCollectionChangedAction.Add:
                                _this._seriesAdapter.addManualItem(e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Remove:
                                _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                                break;
                            case i2.NotifyCollectionChangedAction.Replace:
                                _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                                _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Reset:
                                _this._seriesAdapter.clearManualItems();
                                break;
                        }
                    });
                    this._series = coll;
                }
                return this._series;
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype._ensureTooltipCreated = function (series) {
            var _this = this;
            series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
                var wrapper = new i2.AngularWrapper(ele, _this.renderer, _this.ngZone);
                wrapper.updateToolTip = ele.updateToolTip;
                wrapper.hideToolTip = ele.hideToolTip;
                return wrapper;
            });
        };
        IgxDoughnutChartComponent.prototype._ensureDefaultTooltip = function (series) {
            if (this._defaultTooltips == null) {
                return;
            }
            this._defaultTooltips.instance["ensureDefaultTooltip"](series);
        };
        IgxDoughnutChartComponent.prototype._onDefaultTooltipsReady = function (cr) {
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    if (currSeries[i].showDefaultTooltip) {
                        this._ensureDefaultTooltip(currSeries[i]);
                    }
                }
            }
        };
        IgxDoughnutChartComponent.prototype.createTooltip = function () {
            if (!i2.TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
                return null;
            }
            var t = i2.TypeRegistrar.get("IgxTooltipContainerComponent");
            var cf = this.componentFactoryResolver.resolveComponentFactory(t);
            var cr = this._dynamicContent.createComponent(cf);
            var ele = cr.location.nativeElement;
            var self = this;
            ele.updateToolTip = function (c) {
                if (c.externalObject) {
                    c = c.externalObject;
                }
                else {
                    var ext = new IgxPieSliceDataContext();
                    ext._implementation = c;
                    c = ext;
                }
                if (ele.parentElement != self.container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self.container.appendChild(ele);
                }
                cr.instance.context = c;
                if (c.series.showDefaultTooltip) {
                    var tooltipContainers = ele.getElementsByClassName("ui-tooltip-container");
                    if (tooltipContainers.length > 0)
                        tooltipContainers[0].style.borderColor = c.i.slice.background.fill;
                }
                ele.style.display = "block";
                return true;
            };
            ele.hideToolTip = function () {
                ele.style.display = "none";
            };
            ele.style.display = "none";
            return cr;
        };
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "allowSliceSelection", {
            /**
         * Gets or sets whether the slices can be selected.
        */
            get: function () {
                return this.i.aw;
            },
            set: function (v) {
                this.i.aw = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "isSurfaceInteractionDisabled", {
            /**
             * Gets or sets whether all surface interactions with the plot area should be disabled.
            */
            get: function () {
                return this.i.ax;
            },
            set: function (v) {
                this.i.ax = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "allowSliceExplosion", {
            /**
             * Gets or sets whether the slices can be exploded.
            */
            get: function () {
                return this.i.av;
            },
            set: function (v) {
                this.i.av = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "innerExtent", {
            /**
             * Gets or sets the inner extent of the doughnut chart. It is percent from the outer ring's radius.
            */
            get: function () {
                return this.i.a3;
            },
            set: function (v) {
                this.i.a3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "selectedSliceFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.cg ? this.i.cg.fill : null;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.cg.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "selectedSliceStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.cg ? this.i.cg.stroke : null;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.cg.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "selectedSliceStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.cg ? this.i.cg.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.cg.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "selectedSliceOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.cg ? this.i.cg.opacity : NaN;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.cg.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype.ensureSelectedStyle = function () {
            if (this.i.cg) {
                return;
            }
            this.i.cg = new i2.Style();
        };
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.a4;
            },
            set: function (v) {
                this.i.a4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "actualPixelScalingRatio", {
            /**
             * Resolved pixel scaling ratio. Unless explicitly overridden by the IgxDoughnutChart.PixelScalingRatioComponent property,
             * this one returns the default ratio enforced by device. High resolution devices will initialize this property
             * to a higher value.
            */
            get: function () {
                return this.i.a1;
            },
            set: function (v) {
                this.i.a1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype.findByName = function (name) {
            if (this.series != null && this.series.findByName && this.series.findByName(name)) {
                return this.series.findByName(name);
            }
            return null;
        };
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxDoughnutChartComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("DoughnutChartComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Called by the UI framework to provide a UI container for rendering this control.

    * @param container  * The UI container element.
    */
        IgxDoughnutChartComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        /**
         * Called when the control has been resized.
        
        */
        IgxDoughnutChartComponent.prototype.notifyResized = function () {
            this.i.notifyResized();
        };
        /**
         * Gets the ID of the UI container.
        
        */
        IgxDoughnutChartComponent.prototype.getContainerID = function () {
            var iv = this.i.bd();
            return (iv);
        };
        /**
         * Gets the center coordinates of the doughnut chart's center presenter.
        
        */
        IgxDoughnutChartComponent.prototype.getCenterCoordinates = function () {
            var iv = this.i.cf();
            return i2.fromPoint(iv);
        };
        /**
         * Gets the hole radius of the doughnut chart's center presenter.
        
        */
        IgxDoughnutChartComponent.prototype.getHoleRadius = function () {
            var iv = this.i.a2();
            return (iv);
        };
        /**
         * Use to force the doughnut chart to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the doughnut chart needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the doughnut chart.
        
        */
        IgxDoughnutChartComponent.prototype.flush = function () {
            this.i.bk();
        };
        /**
         * Returns the chart visuals expressed as a serialized string.
        
        */
        IgxDoughnutChartComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.bc();
            return (iv);
        };
        IgxDoughnutChartComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.bm(source_, index, newItem);
        };
        IgxDoughnutChartComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.bp(source_, index, oldItem, newItem);
        };
        /**
         * Used to manually notify the chart that the data source has reset or cleared its items.
        
        */
        IgxDoughnutChartComponent.prototype.notifyClearItems = function (source_) {
            this.i.bl(source_);
        };
        IgxDoughnutChartComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.bn(source_, index, oldItem);
        };
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "sliceClick", {
            /**
             * Raised when the slice is clicked.
            */
            get: function () {
                var _this = this;
                if (this._sliceClick == null) {
                    this._sliceClick = new i0.EventEmitter();
                    this.i.sliceClick = i2.delegateCombine(this.i.sliceClick, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSliceClickEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceClick) {
                                _this.beforeSliceClick(_this, outerArgs);
                            }
                            _this._sliceClick.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceClick;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDoughnutChartComponent.prototype, "holeDimensionsChanged", {
            /**
             * Raised when the dimensions (center point or radius) of the doughnut hole change.
            */
            get: function () {
                var _this = this;
                if (this._holeDimensionsChanged == null) {
                    this._holeDimensionsChanged = new i0.EventEmitter();
                    this.i.holeDimensionsChanged = i2.delegateCombine(this.i.holeDimensionsChanged, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxHoleDimensionsChangedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeHoleDimensionsChanged) {
                                _this.beforeHoleDimensionsChanged(_this, outerArgs);
                            }
                            _this._holeDimensionsChanged.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._holeDimensionsChanged;
            },
            enumerable: false,
            configurable: true
        });
        IgxDoughnutChartComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxDoughnutChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxDoughnutChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxDoughnutChartComponent, selector: "igx-doughnut-chart", inputs: { height: "height", width: "width", allowSliceSelection: "allowSliceSelection", isSurfaceInteractionDisabled: "isSurfaceInteractionDisabled", allowSliceExplosion: "allowSliceExplosion", innerExtent: "innerExtent", selectedSliceFill: "selectedSliceFill", selectedSliceStroke: "selectedSliceStroke", selectedSliceStrokeThickness: "selectedSliceStrokeThickness", selectedSliceOpacity: "selectedSliceOpacity", pixelScalingRatio: "pixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio" }, outputs: { sliceClick: "sliceClick", holeDimensionsChanged: "holeDimensionsChanged" }, host: { classAttribute: "ig-doughnut-chart igx-doughnut-chart" }, providers: [], queries: [{ propertyName: "contentSeries", predicate: IgxRingSeriesBaseComponent }], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], ngImport: i0, template: "<ng-container #dynamicContent></ng-container>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxDoughnutChartComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-doughnut-chart',
                        template: "<ng-container #dynamicContent></ng-container>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-doughnut-chart igx-doughnut-chart' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { contentSeries: [{
                    type: i0.ContentChildren,
                    args: [IgxRingSeriesBaseComponent]
                }], _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], allowSliceSelection: [{
                    type: i0.Input
                }], isSurfaceInteractionDisabled: [{
                    type: i0.Input
                }], allowSliceExplosion: [{
                    type: i0.Input
                }], innerExtent: [{
                    type: i0.Input
                }], selectedSliceFill: [{
                    type: i0.Input
                }], selectedSliceStroke: [{
                    type: i0.Input
                }], selectedSliceStrokeThickness: [{
                    type: i0.Input
                }], selectedSliceOpacity: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], actualPixelScalingRatio: [{
                    type: i0.Input
                }], sliceClick: [{
                    type: i0.Output
                }], holeDimensionsChanged: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartDefaultTooltipsComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartDefaultTooltipsComponent(_changeDetectorRef) {
            this._changeDetectorRef = _changeDetectorRef;
            this.onContentReady = new i0.EventEmitter();
        }
        IgxDoughnutChartDefaultTooltipsComponent.prototype.ensureDefaultTooltip = function (series) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.doughnutSliceTooltip;
            }
            else {
                if (series.tooltipTemplate === this.doughnutSliceTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        };
        IgxDoughnutChartDefaultTooltipsComponent.prototype.getSliceLabel = function (series, item) {
            return item[series.labelMemberPath];
        };
        IgxDoughnutChartDefaultTooltipsComponent.prototype.getValue = function (series, item) {
            return item[this.getValueMemberPath(series)];
        };
        IgxDoughnutChartDefaultTooltipsComponent.prototype.getValueMemberPath = function (series) {
            return series.valueMemberPath;
        };
        IgxDoughnutChartDefaultTooltipsComponent.prototype.getBrush = function (i) {
            if (i.slice.background)
                return i.slice.background.fill;
            return "black";
        };
        IgxDoughnutChartDefaultTooltipsComponent.register = function () {
            i2.TypeRegistrar.registerCons("IgxDoughnutChartDefaultTooltipsComponent", IgxDoughnutChartDefaultTooltipsComponent);
        };
        IgxDoughnutChartDefaultTooltipsComponent.prototype.ngAfterContentInit = function () {
            this.onContentReady.emit({});
        };
        IgxDoughnutChartDefaultTooltipsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartDefaultTooltipsComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
        IgxDoughnutChartDefaultTooltipsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxDoughnutChartDefaultTooltipsComponent, selector: "igx-dougnut-chart-default-tooltips", outputs: { onContentReady: "onContentReady" }, viewQueries: [{ propertyName: "doughnutSliceTooltip", first: true, predicate: ["doughnutSliceTooltip"], descendants: true, static: true }], ngImport: i0, template: "\n    <ng-template #doughnutSliceTooltip let-series=\"series\" let-item=\"item\" let-implementation=\"i\">\n        <div class='ui-chart-default-tooltip-content'>            \n            <span [style.color]=\"getBrush(implementation)\">{{getSliceLabel(series, item)}}</span>\n            <br/>\n            <span class=\"ui-tooltip-priority\">{{getValueMemberPath(series)}} : {{getValue(series, item)}}</span>\n        </div>\n    </ng-template>\n  ", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxDoughnutChartDefaultTooltipsComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartDefaultTooltipsComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-dougnut-chart-default-tooltips',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: "\n    <ng-template #doughnutSliceTooltip let-series=\"series\" let-item=\"item\" let-implementation=\"i\">\n        <div class='ui-chart-default-tooltip-content'>            \n            <span [style.color]=\"getBrush(implementation)\">{{getSliceLabel(series, item)}}</span>\n            <br/>\n            <span class=\"ui-tooltip-priority\">{{getValueMemberPath(series)}} : {{getValue(series, item)}}</span>\n        </div>\n    </ng-template>\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { doughnutSliceTooltip: [{
                    type: i0.ViewChild,
                    args: ["doughnutSliceTooltip", { static: true }]
                }], onContentReady: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartInteractivityModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartInteractivityModule() {
            i2.TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
            InteractivityFactoryManager.register();
            IgxDoughnutChartDefaultTooltipsComponent.register();
        }
        IgxDoughnutChartInteractivityModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDoughnutChartInteractivityModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityModule, declarations: [IgxDoughnutChartDefaultTooltipsComponent], imports: [i1.CommonModule, i2.IgxDVInteractivityModule], exports: [IgxDoughnutChartDefaultTooltipsComponent,
                i2.IgxDVInteractivityModule] });
        IgxDoughnutChartInteractivityModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityModule, imports: [[i1.CommonModule, i2.IgxDVInteractivityModule
                ], i2.IgxDVInteractivityModule] });
        return IgxDoughnutChartInteractivityModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxDoughnutChartDefaultTooltipsComponent],
                        exports: [IgxDoughnutChartDefaultTooltipsComponent,
                            i2.IgxDVInteractivityModule
                        ],
                        imports: [i1.CommonModule, i2.IgxDVInteractivityModule
                        ],
                        entryComponents: [IgxDoughnutChartDefaultTooltipsComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartInteractivityDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartInteractivityDynamicModule() {
            i2.TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
            InteractivityFactoryManager.register();
            IgxDoughnutChartDefaultTooltipsComponent.register();
        }
        IgxDoughnutChartInteractivityDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDoughnutChartInteractivityDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityDynamicModule, imports: [i1.CommonModule, i2.IgxDVInteractivityDynamicModule,
                IgxDoughnutChartInteractivityModule], exports: [i2.IgxDVInteractivityDynamicModule,
                IgxDoughnutChartInteractivityModule] });
        IgxDoughnutChartInteractivityDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityDynamicModule, imports: [[i1.CommonModule, i2.IgxDVInteractivityDynamicModule,
                    IgxDoughnutChartInteractivityModule
                ], i2.IgxDVInteractivityDynamicModule,
                IgxDoughnutChartInteractivityModule] });
        return IgxDoughnutChartInteractivityDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartInteractivityDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxDVInteractivityDynamicModule,
                            IgxDoughnutChartInteractivityModule
                        ],
                        imports: [i1.CommonModule, i2.IgxDVInteractivityDynamicModule,
                            IgxDoughnutChartInteractivityModule
                        ],
                        entryComponents: [IgxDoughnutChartDefaultTooltipsComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents data for Ring.RingControl element.
    */
    var IgxRing = /** @class */ /*@__PURE__*/ (function () {
        function IgxRing() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxRing.prototype.createImplementation = function () {
            return new Ring();
        };
        Object.defineProperty(IgxRing.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxRing.prototype.onImplementationCreated = function () {
        };
        IgxRing.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxRing.prototype, "index", {
            /**
             * Gets the index of ring in the chart.
            */
            get: function () {
                return this.i.j;
            },
            set: function (v) {
                this.i.j = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRing.prototype, "innerExtend", {
            /**
             * Gets the inner extend of the ring in percentage.
            */
            get: function () {
                return this.i.h;
            },
            set: function (v) {
                this.i.h = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRing.prototype, "controlSize", {
            /**
             * Gets the size of the ring.
            */
            get: function () {
                return i2.fromSize(this.i.q);
            },
            set: function (v) {
                this.i.q = i2.toSize(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRing.prototype, "center", {
            /**
             * Gets the center point of the ring.
            */
            get: function () {
                return i2.fromPoint(this.i.p);
            },
            set: function (v) {
                this.i.p = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRing.prototype, "ringSeries", {
            /**
             * Gets reference to ring series.
            */
            get: function () {
                if (this.i.c == null) {
                    return null;
                }
                if (!this.i.c.externalObject) {
                    var e = IgxRingSeriesBaseComponent._createFromInternal(this.i.c);
                    if (e) {
                        e._implementation = this.i.c;
                    }
                    this.i.c.externalObject = e;
                }
                return this.i.c.externalObject;
            },
            set: function (v) {
                v == null ? this.i.c = null : this.i.c = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRing.prototype, "ringBreadth", {
            /**
             * Gets the ring breadth.
            */
            get: function () {
                return this.i.i;
            },
            set: function (v) {
                this.i.i = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRing.prototype.findByName = function (name) {
            if (this.ringSeries && this.ringSeries.name && this.ringSeries.name == name) {
                return this.ringSeries;
            }
            return null;
        };
        /**
         * Renders the arcs.
        
        */
        IgxRing.prototype.renderArcs = function () {
            var iv = this.i.f();
            return (iv);
        };
        /**
         * Prepares data needed to create Arcs.
        
        */
        IgxRing.prototype.prepareArcs = function () {
            this.i.o();
        };
        return IgxRing;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RingSeries, _super);
        function RingSeries() {
            var _this = _super.call(this) || this;
            _this.eo = null;
            _this.eo = ((function () {
                var $ret = new Ring();
                $ret.c = _this;
                $ret.e = false;
                return $ret;
            })());
            var a = ((function () {
                var $ret = new ArcItem();
                $ret.k = _this.ba;
                $ret.d = _this.eo;
                $ret.n = _this.cs;
                $ret.c = _this.ap;
                $ret.j = _this.a8;
                return $ret;
            })());
            _this.eo.g.add(a);
            _this.ab = RingSeries.$;
            return _this;
        }
        RingSeries.prototype.c4 = function (a, b, c, d) {
            _super.prototype.c4.call(this, a, b, c, d);
            if (b == RingSeriesBase.$$p[6]) {
                for (var e = 0; e < this.eo.ringControl.arcs.count; e++) {
                    this.eo.ringControl.arcs.item(e).eb = d;
                }
            }
            if (b == RingSeriesBase.$$p[7]) {
                for (var f = 0; f < this.eo.ringControl.arcs.count; f++) {
                    this.eo.ringControl.arcs.item(f).ag = d;
                }
            }
            if (b == RingSeriesBase.$$p[28]) {
                for (var g = 0; g < this.eo.ringControl.arcs.count; g++) {
                    this.eo.ringControl.arcs.item(g).e5 = d;
                }
            }
            if (b == RingSeriesBase.$$p[29]) {
                for (var h = 0; h < this.eo.ringControl.arcs.count; h++) {
                    this.eo.ringControl.arcs.item(h).aj = d;
                }
            }
            if (b == RingSeriesBase.$$p[18]) {
                for (var i = 0; i < this.eo.ringControl.arcs.count; i++) {
                    this.eo.ringControl.arcs.item(i).er = d;
                }
            }
            if (b == RingSeriesBase.$$p[19]) {
                for (var j = 0; j < this.eo.ringControl.arcs.count; j++) {
                    this.eo.ringControl.arcs.item(j).ah = d;
                }
            }
            if (b == RingSeriesBase.$$p[21]) {
                for (var k = 0; k < this.eo.ringControl.arcs.count; k++) {
                    this.eo.ringControl.arcs.item(k).ew = d;
                }
            }
            if (b == RingSeriesBase.$$p[22]) {
                for (var l = 0; l < this.eo.ringControl.arcs.count; l++) {
                    this.eo.ringControl.arcs.item(l).ai = d;
                }
            }
            if (b == RingSeriesBase.$$p[2]) {
                for (var m = 0; m < this.eo.ringControl.arcs.count; m++) {
                    this.eo.ringControl.arcs.item(m).a4 = d;
                }
            }
            if (b == RingSeriesBase.$$p[3]) {
                for (var n = 0; n < this.eo.ringControl.arcs.count; n++) {
                    this.eo.ringControl.arcs.item(n).a5 = d;
                }
            }
            if (b == RingSeriesBase.$$p[20]) {
                for (var o = 0; o < this.eo.ringControl.arcs.count; o++) {
                    this.eo.ringControl.arcs.item(o).eu = this.b3;
                }
            }
            if (b == RingSeriesBase.$$p[0]) {
                this.c2();
            }
            if (b == RingSeriesBase.$$p[33]) {
                if (this.eo.g != null && this.eo.g.count > 0) {
                    this.eo.g._inner[0].k = this.ba;
                }
            }
            if (b == RingSeriesBase.$$p[36]) {
                if (this.eo.g != null && this.eo.g.count > 0) {
                    this.eo.g._inner[0].n = this.cs;
                    this.c3();
                }
            }
            if (this.eo != null && this.aw.e()) {
                this.eo.o();
                if (this.eo.f()) {
                    this.eo.c.aw.l();
                }
            }
        };
        RingSeries.prototype.au = function () {
            var a = new RingCollection();
            if (this.eo.g._inner[0].g.count > 0) {
                a.add(this.eo);
            }
            return a;
        };
        RingSeries.prototype.c3 = function () {
            if (this.eo != null) {
                this.eo.g._inner[0].h = this.itemsSource;
                this.eo.g._inner[0].p(this.ba);
                if (this.ax != null) {
                    this.ax.bx();
                    this.ax.b2();
                }
            }
        };
        RingSeries.prototype.c2 = function () {
            if (this.eo != null) {
                this.eo.g._inner[0].a = this.ak;
            }
        };
        RingSeries.prototype.c8 = function () {
            if (this.eo != null) {
                this.width = this.eo.q.width;
                this.height = this.eo.q.height;
                this.aw.m(this.eo.p.x, this.eo.p.y);
            }
        };
        RingSeries.prototype.c7 = function () {
            var e_1, _a;
            if (this.eo != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.eo.ringControl.arcs.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var a = _c.value;
                        a.gt();
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        RingSeries.prototype.cy = function (a, b) {
            _super.prototype.cy.call(this, a, b);
            if (this.eo != null) {
                this.eo.l(this.itemsSource, a, b);
            }
        };
        RingSeries.prototype.cx = function () {
            _super.prototype.cx.call(this);
            if (this.eo != null) {
                this.eo.k(this.itemsSource);
            }
        };
        RingSeries.prototype.cz = function (a, b) {
            _super.prototype.cz.call(this, a, b);
            if (this.eo != null) {
                this.eo.m(this.itemsSource, a, b);
            }
        };
        RingSeries.prototype.c0 = function (a, b, c) {
            _super.prototype.c0.call(this, a, b, c);
            if (this.eo != null) {
                this.eo.n(this.itemsSource, a, b, c);
            }
        };
        RingSeries.$t = i2.markType(RingSeries, 'RingSeries', RingSeriesBase.$);
        return RingSeries;
    }(RingSeriesBase));

    var IgxIndexCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxIndexCollection, _super);
        function IgxIndexCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxIndexCollection.prototype._ensureOuter = function (item) {
            return +item;
        };
        IgxIndexCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(i2.Number_$type, i2.Number_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxIndexCollection;
    }(i2.IgCollection));

    /**
     * Represents one ring in IgxDoughnutChartComponent series.
    */
    var IgxRingSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRingSeriesComponent, _super);
        function IgxRingSeriesComponent() {
            var _this = _super.call(this) || this;
            _this._explodedSlices = null;
            _this._selectedSlices = null;
            return _this;
        }
        IgxRingSeriesComponent.prototype.createImplementation = function () {
            return new RingSeries();
        };
        Object.defineProperty(IgxRingSeriesComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesComponent.prototype, "explodedSlices", {
            /**
             * Gets or sets the collection of exploded slice indices.
            */
            get: function () {
                if (this._explodedSlices === null) {
                    var coll = new IgxIndexCollection();
                    var innerColl = void 0;
                    if (this.ring.i.ringControl.arcs.count == 0) {
                        innerColl = new IndexCollection();
                    }
                    else {
                        innerColl = this.ring.i.ringControl.arcs.item(0).explodedSlices;
                    }
                    this._explodedSlices = coll._fromInner(innerColl);
                }
                return this._explodedSlices;
            },
            set: function (v) {
                if (this._explodedSlices !== null) {
                    this._explodedSlices._setSyncTarget(null);
                    this._explodedSlices = null;
                }
                var coll = new IgxIndexCollection();
                this._explodedSlices = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Number_$type);
                var innerColl;
                if (this.ring.i.ringControl.arcs.count == 0) {
                    innerColl = new IndexCollection();
                }
                else {
                    innerColl = this.ring.i.ringControl.arcs.item(0).explodedSlices;
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._explodedSlices._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRingSeriesComponent.prototype, "selectedSlices", {
            /**
             * Gets or sets the collection of selected slice indices.
            */
            get: function () {
                if (this._selectedSlices === null) {
                    var coll = new IgxIndexCollection();
                    var innerColl = void 0;
                    if (this.ring.i.ringControl.arcs.count == 0) {
                        innerColl = new IndexCollection();
                    }
                    else {
                        innerColl = this.ring.i.ringControl.arcs.item(0).selectedSlices;
                    }
                    this._selectedSlices = coll._fromInner(innerColl);
                }
                return this._selectedSlices;
            },
            set: function (v) {
                if (this._selectedSlices !== null) {
                    this._selectedSlices._setSyncTarget(null);
                    this._selectedSlices = null;
                }
                var coll = new IgxIndexCollection();
                this._selectedSlices = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Number_$type);
                var innerColl;
                if (this.ring.i.ringControl.arcs.count == 0) {
                    innerColl = new IndexCollection();
                }
                else {
                    innerColl = this.ring.i.ringControl.arcs.item(0).selectedSlices;
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._selectedSlices._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesComponent.prototype.sychronizeCollections = function () {
            if (this._explodedSlices) {
                var inner = this._explodedSlices._inner;
                if (inner && inner !== this.ring.i.ringControl.arcs.item(0).explodedSlices) {
                    this._explodedSlices._inner = this.ring.i.ringControl.arcs.item(0).explodedSlices;
                    for (var i = 0; i < inner.count; i++) {
                        this._explodedSlices.add(inner.item(i));
                    }
                }
            }
            if (this._selectedSlices) {
                var inner = this._selectedSlices._inner;
                if (inner && inner !== this.ring.i.ringControl.arcs.item(0).selectedSlices) {
                    this._selectedSlices._inner = this.ring.i.ringControl.arcs.item(0).selectedSlices;
                    for (var i = 0; i < inner.count; i++) {
                        this._selectedSlices.add(inner.item(i));
                    }
                }
            }
        };
        Object.defineProperty(IgxRingSeriesComponent.prototype, "ring", {
            /**
         * Gets reference to the ring data.
        */
            get: function () {
                if (this.i.eo == null) {
                    return null;
                }
                if (!this.i.eo.externalObject) {
                    var e = new IgxRing();
                    e._implementation = this.i.eo;
                    this.i.eo.externalObject = e;
                }
                return this.i.eo.externalObject;
            },
            set: function (v) {
                v == null ? this.i.eo = null : this.i.eo = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxRingSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.ring && this.ring.name && this.ring.name == name) {
                return this.ring;
            }
            return null;
        };
        IgxRingSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRingSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRingSeriesComponent, selector: "igx-ring-series", inputs: { explodedSlices: "explodedSlices", selectedSlices: "selectedSlices", ring: "ring" }, providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxRingSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRingSeriesComponent;
    }(IgxRingSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-ring-series',
                        template: "",
                        providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxRingSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { explodedSlices: [{
                    type: i0.Input
                }], selectedSlices: [{
                    type: i0.Input
                }], ring: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRingSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRingSeriesModule() {
        }
        IgxRingSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRingSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesModule, declarations: [IgxRingSeriesComponent], imports: [i1.CommonModule], exports: [IgxRingSeriesComponent] });
        IgxRingSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesModule, imports: [[i1.CommonModule]] });
        return IgxRingSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRingSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxRingSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRingSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRingSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRingSeriesComponent", IgxRingSeriesComponent);
            i2.TypeRegistrar.register("RingSeries", RingSeries.$type);
        }
        IgxRingSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRingSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesDynamicModule, imports: [i1.CommonModule, IgxRingSeriesModule], exports: [IgxRingSeriesModule] });
        IgxRingSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesDynamicModule, imports: [[i1.CommonModule, IgxRingSeriesModule], IgxRingSeriesModule] });
        return IgxRingSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRingSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRingSeriesModule],
                        exports: [IgxRingSeriesModule],
                        entryComponents: [IgxRingSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartCoreModule() {
        }
        IgxDoughnutChartCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDoughnutChartCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreModule, declarations: [IgxDoughnutChartComponent], imports: [i1.CommonModule, IgxRingSeriesModule], exports: [IgxRingSeriesModule,
                IgxDoughnutChartComponent] });
        IgxDoughnutChartCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreModule, imports: [[i1.CommonModule, IgxRingSeriesModule
                ], IgxRingSeriesModule] });
        return IgxDoughnutChartCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxDoughnutChartComponent],
                        exports: [IgxRingSeriesModule,
                            IgxDoughnutChartComponent
                        ],
                        imports: [i1.CommonModule, IgxRingSeriesModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxDoughnutChartComponent', IgxDoughnutChartComponent);
        }
        IgxDoughnutChartCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDoughnutChartCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreDynamicModule, imports: [i1.CommonModule, IgxRingSeriesDynamicModule,
                IgxDoughnutChartCoreModule], exports: [IgxRingSeriesDynamicModule,
                IgxDoughnutChartCoreModule] });
        IgxDoughnutChartCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreDynamicModule, imports: [[i1.CommonModule, IgxRingSeriesDynamicModule,
                    IgxDoughnutChartCoreModule
                ], IgxRingSeriesDynamicModule,
                IgxDoughnutChartCoreModule] });
        return IgxDoughnutChartCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxRingSeriesDynamicModule,
                            IgxDoughnutChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxRingSeriesDynamicModule,
                            IgxDoughnutChartCoreModule
                        ],
                        entryComponents: [IgxDoughnutChartComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartModule() {
        }
        IgxDoughnutChartModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDoughnutChartModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartModule, imports: [i1.CommonModule, IgxDoughnutChartInteractivityModule,
                IgxDoughnutChartCoreModule], exports: [IgxDoughnutChartInteractivityModule,
                IgxDoughnutChartCoreModule] });
        IgxDoughnutChartModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartModule, imports: [[i1.CommonModule, IgxDoughnutChartInteractivityModule,
                    IgxDoughnutChartCoreModule
                ], IgxDoughnutChartInteractivityModule,
                IgxDoughnutChartCoreModule] });
        return IgxDoughnutChartModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxDoughnutChartInteractivityModule,
                            IgxDoughnutChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxDoughnutChartInteractivityModule,
                            IgxDoughnutChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDoughnutChartDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDoughnutChartDynamicModule() {
        }
        IgxDoughnutChartDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDoughnutChartDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartDynamicModule, imports: [i1.CommonModule, IgxDoughnutChartInteractivityDynamicModule,
                IgxDoughnutChartCoreDynamicModule,
                IgxDoughnutChartModule], exports: [IgxDoughnutChartInteractivityDynamicModule,
                IgxDoughnutChartCoreDynamicModule,
                IgxDoughnutChartModule] });
        IgxDoughnutChartDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartDynamicModule, imports: [[i1.CommonModule, IgxDoughnutChartInteractivityDynamicModule,
                    IgxDoughnutChartCoreDynamicModule,
                    IgxDoughnutChartModule
                ], IgxDoughnutChartInteractivityDynamicModule,
                IgxDoughnutChartCoreDynamicModule,
                IgxDoughnutChartModule] });
        return IgxDoughnutChartDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDoughnutChartDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxDoughnutChartInteractivityDynamicModule,
                            IgxDoughnutChartCoreDynamicModule,
                            IgxDoughnutChartModule
                        ],
                        imports: [i1.CommonModule, IgxDoughnutChartInteractivityDynamicModule,
                            IgxDoughnutChartCoreDynamicModule,
                            IgxDoughnutChartModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Node$1 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Node, _super);
        function Node(a, b) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = null;
            _this.a = b;
            _this.b = a;
            return _this;
        }
        Node.$t = i2.markType(Node, 'Node');
        return Node;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IgQueue$1 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgQueue$1, _super);
        function IgQueue$1($t) {
            var _this = _super.call(this) || this;
            _this.$t = null;
            _this.e = 0;
            _this.b = null;
            _this.a = null;
            _this.c = null;
            _this.$t = $t;
            _this.$type = _this.$type.specialize(_this.$t);
            return _this;
        }
        Object.defineProperty(IgQueue$1.prototype, "d", {
            get: function () {
                return (this.e == 0);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgQueue$1.prototype, "f", {
            get: function () {
                return this.e;
            },
            enumerable: false,
            configurable: true
        });
        IgQueue$1.prototype.h = function (a) {
            if (this.e == 0) {
                this.b = this.a = new Node$1(a, this.b);
            }
            else {
                this.a.a = new Node$1(a, this.a.a);
                this.a = this.a.a;
            }
            this.e++;
        };
        IgQueue$1.prototype.g = function (a) {
            this.c = this.b;
            if (this.e == 0) {
                throw new i2.BaseError(1, "tried to serve from an empty Queue");
            }
            this.b = this.b.a;
            this.e--;
            a = i2.typeCast(this.$t, this.c.b);
            return {
                p0: a
            };
        };
        IgQueue$1.$t = i2.markType(IgQueue$1, 'IgQueue$1');
        return IgQueue$1;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HierarchicalRingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HierarchicalRingSeries, _super);
        function HierarchicalRingSeries() {
            var _this = _super.call(this) || this;
            _this.ep = null;
            _this.ab = HierarchicalRingSeries.$;
            return _this;
        }
        HierarchicalRingSeries.prototype.au = function () {
            if (this.itemsSource == null) {
                return new RingCollection();
            }
            this.ep = this.eq(this.itemsSource);
            return this.ep;
        };
        HierarchicalRingSeries.prototype.c4 = function (a, b, c, d) {
            var e_1, _a, e_2, _b, e_3, _c;
            _super.prototype.c4.call(this, a, b, c, d);
            switch (b) {
                case RingSeriesBase.$$p[33]:
                    var e = c;
                    var f = d;
                    var g = f - e;
                    if (this.ep != null && this.ep.count > 0) {
                        for (var h = 0; h < this.ep.count; h++) {
                            var i = this.ep._inner[h];
                            try {
                                for (var _d = (e_1 = void 0, tslib.__values(i2.fromEnum(i.g))), _e = _d.next(); !_e.done; _e = _d.next()) {
                                    var j = _e.value;
                                    j.k = j.k + g;
                                }
                            }
                            catch (e_1_1) {
                                e_1 = { error: e_1_1 };
                            }
                            finally {
                                try {
                                    if (_e && !_e.done && (_a = _d.return))
                                        _a.call(_d);
                                }
                                finally {
                                    if (e_1)
                                        throw e_1.error;
                                }
                            }
                        }
                    }
                    break;
                case RingSeriesBase.$$p[0]:
                    this.c2();
                    break;
                case HierarchicalRingSeries.$$p[0]:
                    this.c3();
                    break;
            }
            if (this.ep != null && this.aw.e()) {
                var k = false;
                try {
                    for (var _f = tslib.__values(i2.fromEnum(this.ep)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var l = _g.value;
                        l.o();
                        if (l.f()) {
                            k = true;
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_g && !_g.done && (_b = _f.return))
                            _b.call(_f);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                if (k) {
                    try {
                        for (var _h = tslib.__values(i2.fromEnum(this.ep)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var m = _j.value;
                            m.c.aw.l();
                        }
                    }
                    catch (e_3_1) {
                        e_3 = { error: e_3_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_3)
                                throw e_3.error;
                        }
                    }
                }
            }
        };
        HierarchicalRingSeries.prototype.c3 = function () {
            if (this.ax != null) {
                this.ax.bx();
                this.ax.b2();
            }
        };
        HierarchicalRingSeries.prototype.c2 = function () {
            var e_4, _a, e_5, _b;
            if (this.ep != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.ep)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var a = _d.value;
                        try {
                            for (var _e = (e_5 = void 0, tslib.__values(i2.fromEnum(a.g))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var b = _f.value;
                                this.ev(b);
                            }
                        }
                        catch (e_5_1) {
                            e_5 = { error: e_5_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_5)
                                    throw e_5.error;
                            }
                        }
                    }
                }
                catch (e_4_1) {
                    e_4 = { error: e_4_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_4)
                            throw e_4.error;
                    }
                }
            }
        };
        HierarchicalRingSeries.prototype.c8 = function () {
            if (this.ep != null && this.ep.count > 0) {
                var a = this.ep._inner[this.ep.count - 1];
                this.width = a.q.width;
                this.height = a.q.height;
                this.aw.m(a.p.x, a.p.y);
            }
        };
        HierarchicalRingSeries.prototype.c7 = function () {
            var e_6, _a;
            for (var a = 0; a < this.ep.count; a++) {
                try {
                    for (var _b = (e_6 = void 0, tslib.__values(i2.fromEnum(this.ep._inner[a].ringControl.arcs.a))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        b.gt();
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
            }
        };
        HierarchicalRingSeries.prototype.es = function (obj_) {
            var memberPath_ = this.et;
            if ((obj_[memberPath_] !== undefined)) {
                return (obj_[memberPath_]);
            }
            return null;
        };
        HierarchicalRingSeries.prototype.eq = function (a) {
            var _this = this;
            var b = new IgQueue$1(ArcItem.$);
            var c = new IgQueue$1(ArcItem.$);
            var d = ((function () {
                var $ret = new ArcItem();
                $ret.m = 0;
                $ret.h = a;
                $ret.n = _this.cs;
                $ret.c = _this.ap;
                $ret.j = _this.a8;
                return $ret;
            })());
            d.p(this.ba);
            var e = ((function () {
                var $ret = new ArcItem();
                $ret.m = -1;
                $ret.h = null;
                return $ret;
            })());
            c.h(d);
            b.h(e);
            var f = new RingCollection();
            var g = null;
            var h = -1;
            var _loop_1 = function () {
                var e_7, _a;
                var i;
                var j = c.g(i);
                i = j.p0;
                var k = void 0;
                var l = b.g(k);
                k = l.p0;
                if (i == null) {
                    return "continue";
                }
                var m = 0;
                var _loop_2 = function (n) {
                    var o = this_1.es(n.g);
                    if ((o != null && this_1.er(o) == false) || n.c) {
                        var p = ((function () {
                            var $ret = new ArcItem();
                            $ret.m = i.m + 1;
                            $ret.h = n.c ? ((function () {
                                var $ret = new i2.List$1(i2.Number_$type, 0);
                                $ret.add(0);
                                return $ret;
                            })()) : o;
                            $ret.l = m;
                            $ret.b = i;
                            $ret.n = _this.cs;
                            $ret.e = n;
                            return $ret;
                        })());
                        p.p(this_1.ba);
                        c.h(p);
                        b.h(i);
                    }
                    m++;
                };
                try {
                    for (var _b = (e_7 = void 0, tslib.__values(i2.fromEnum(i.g))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var n = _c.value;
                        _loop_2(n);
                    }
                }
                catch (e_7_1) {
                    e_7 = { error: e_7_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_7)
                            throw e_7.error;
                    }
                }
                var q = this_1.eo(i, k, h, g);
                if (q != g) {
                    f.add(q);
                    g = q;
                }
                h = i.m;
            };
            var this_1 = this;
            while (c.f > 0) {
                _loop_1();
            }
            return f;
        };
        HierarchicalRingSeries.prototype.eo = function (a, b, c, d) {
            var _this = this;
            a.k = a.e == null ? this.ba : a.e.e;
            a.i = a.e == null ? 360 : a.e.d;
            this.ev(a);
            if (a.m != c) {
                var e = ((function () {
                    var $ret = new Ring();
                    $ret.c = _this;
                    return $ret;
                })());
                e.g.add(a);
                a.d = e;
                return e;
            }
            a.d = d;
            d.g.add(a);
            return d;
        };
        HierarchicalRingSeries.prototype.er = function (a) {
            var e_8, _a;
            try {
                for (var _b = tslib.__values(i2.fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    return false;
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            return true;
        };
        HierarchicalRingSeries.prototype.ev = function (a) {
            if (a.b == null) {
                a.a = this.ak;
            }
            else if (a.b.m == 0) {
                a.a = new i2.BrushCollection();
                if (a.b.a != null) {
                    a.a.add(a.b.a.item(a.l % a.b.a.count));
                }
            }
            else {
                a.a = a.b.a;
            }
        };
        HierarchicalRingSeries.$t = i2.markType(HierarchicalRingSeries, 'HierarchicalRingSeries', RingSeriesBase.$);
        HierarchicalRingSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, HierarchicalRingSeries, 'c6', ['ChildrenMemberPath:et:ew', [2]]);
        return HierarchicalRingSeries;
    }(RingSeriesBase));

    /**
     * Represents a IgxDoughnutChartComponent hierarchical series.
    */
    var IgxHierarchicalRingSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxHierarchicalRingSeriesComponent, _super);
        function IgxHierarchicalRingSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxHierarchicalRingSeriesComponent.prototype.createImplementation = function () {
            return new HierarchicalRingSeries();
        };
        Object.defineProperty(IgxHierarchicalRingSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHierarchicalRingSeriesComponent.prototype, "childrenMemberPath", {
            /**
             * Gets or sets the property name that contains the children items collection.
            */
            get: function () {
                return this.i.et;
            },
            set: function (v) {
                this.i.et = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxHierarchicalRingSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxHierarchicalRingSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxHierarchicalRingSeriesComponent, selector: "igx-hierarchical-ring-series", inputs: { childrenMemberPath: "childrenMemberPath" }, providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxHierarchicalRingSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxHierarchicalRingSeriesComponent;
    }(IgxRingSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-hierarchical-ring-series',
                        template: "",
                        providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxHierarchicalRingSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { childrenMemberPath: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHierarchicalRingSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHierarchicalRingSeriesModule() {
        }
        IgxHierarchicalRingSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHierarchicalRingSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesModule, declarations: [IgxHierarchicalRingSeriesComponent], imports: [i1.CommonModule], exports: [IgxHierarchicalRingSeriesComponent] });
        IgxHierarchicalRingSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesModule, imports: [[i1.CommonModule]] });
        return IgxHierarchicalRingSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxHierarchicalRingSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxHierarchicalRingSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHierarchicalRingSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHierarchicalRingSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxHierarchicalRingSeriesComponent", IgxHierarchicalRingSeriesComponent);
            i2.TypeRegistrar.register("HierarchicalRingSeries", HierarchicalRingSeries.$type);
        }
        IgxHierarchicalRingSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHierarchicalRingSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesDynamicModule, imports: [i1.CommonModule, IgxHierarchicalRingSeriesModule], exports: [IgxHierarchicalRingSeriesModule] });
        IgxHierarchicalRingSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesDynamicModule, imports: [[i1.CommonModule, IgxHierarchicalRingSeriesModule], IgxHierarchicalRingSeriesModule] });
        return IgxHierarchicalRingSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHierarchicalRingSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxHierarchicalRingSeriesModule],
                        exports: [IgxHierarchicalRingSeriesModule],
                        entryComponents: [IgxHierarchicalRingSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisBreak = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisBreak, _super);
        function TimeAxisBreak() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = new Date();
            _this.a = new Date();
            _this.h = (0);
            _this.propertyChanged = null;
            return _this;
        }
        Object.defineProperty(TimeAxisBreak.prototype, "d", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.d;
                if (+a != +b) {
                    this.b = a;
                    this.j("Start", b, this.d);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisBreak.prototype, "c", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.c;
                if (+a != +b) {
                    this.a = a;
                    this.j("End", b, this.c);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisBreak.prototype, "i", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.i;
                if (a != b) {
                    this.h = a;
                    this.j("Interval", b, this.i);
                }
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBreak.prototype.j = function (a, b, c) {
            this.k(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        TimeAxisBreak.prototype.k = function (a, b, c) {
        };
        TimeAxisBreak.$t = i2.markType(TimeAxisBreak, 'TimeAxisBreak', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return TimeAxisBreak;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisBreakComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisBreakComponent() {
            this._renderer = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._zoneRunner = null;
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisBreakComponent.prototype.onImplementationCreated = function () {
        };
        IgxTimeAxisBreakComponent.prototype.createImplementation = function () {
            return new TimeAxisBreak();
        };
        IgxTimeAxisBreakComponent.prototype.ngOnInit = function () {
        };
        IgxTimeAxisBreakComponent.prototype._provideRenderer = function (renderer) {
            this._renderer = renderer;
            this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
        };
        IgxTimeAxisBreakComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "start", {
            /**
         * The start time of the axis break.
        *
        * Use `start` property for the start time of the axis break.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-time-x-axis
        * 		dateTimeMemberPath="date"
        * 		#xAxis>
        *     </igx-time-x-axis>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * let xAxis = new IgxTimeXAxisComponent();
        * xAxis.dataTimeMemberPath="date";
        * this.chart.axes.add(xAxis);
        * ```
        */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "end", {
            /**
             * The end time of the axis break.
            *
            * Use `end` property for the end time of the axis break.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-time-x-axis
            * 		dateTimeMemberPath="date"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let xAxis = new IgxTimeXAxisComponent();
            * xAxis.dataTimeMemberPath="date";
            * this.chart.axes.add(xAxis);
            * ```
            */
            get: function () {
                return this.i.c;
            },
            set: function (v) {
                this.i.c = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "interval", {
            /**
             * The interval at which to repeat this break, expressed as a TimeSpan.
            *
            * Use `interval` property to se the interval at which to repeat this break, expressed as a TimeSpan.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-time-x-axis
            * 		dateTimeMemberPath="date"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let xAxis = new IgxTimeXAxisComponent();
            * xAxis.dataTimeMemberPath="date";
            * this.chart.axes.add(xAxis);
            * ```
            */
            get: function () {
                return this.i.i;
            },
            set: function (v) {
                this.i.i = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisBreakComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisBreakComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxTimeAxisBreakComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("TimeAxisBreakComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxTimeAxisBreakComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxTimeAxisBreakComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTimeAxisBreakComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTimeAxisBreakComponent, selector: "igx-time-axis-break", inputs: { start: "start", end: "end", interval: "interval" }, providers: [], ngImport: i0, template: "", isInline: true });
        return IgxTimeAxisBreakComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-time-axis-break',
                        template: "",
                        providers: []
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { start: [{
                    type: i0.Input
                }], end: [{
                    type: i0.Input
                }], interval: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Enum representing a unit of time.
     */
    var TimeAxisIntervalType = /*@__PURE__*/ (function (TimeAxisIntervalType) {
        /**
         * Ticks are ten millionths of seconds.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Ticks"] = 0] = "Ticks";
        /**
         * Milliseconds.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Milliseconds"] = 1] = "Milliseconds";
        /**
         * Seconds.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Seconds"] = 2] = "Seconds";
        /**
         * Minutes.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Minutes"] = 3] = "Minutes";
        /**
         * Hours.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Hours"] = 4] = "Hours";
        /**
         * Days.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Days"] = 5] = "Days";
        /**
         * Weeks.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Weeks"] = 6] = "Weeks";
        /**
         * Months.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Months"] = 7] = "Months";
        /**
         * Years.
         */
        TimeAxisIntervalType[TimeAxisIntervalType["Years"] = 8] = "Years";
        return TimeAxisIntervalType;
    })({});
    /**
     * @hidden
     */
    var TimeAxisIntervalType_$type = i2.markEnum('TimeAxisIntervalType', 'Ticks,0|Milliseconds,1|Seconds,2|Minutes,3|Hours,4|Days,5|Weeks,6|Months,7|Years,8');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisInterval = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisInterval, _super);
        function TimeAxisInterval() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.j = (0);
            _this.e = 0;
            _this.a = 0;
            _this.propertyChanged = null;
            return _this;
        }
        Object.defineProperty(TimeAxisInterval.prototype, "k", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                var b = this.k;
                if (a != b) {
                    this.j = a;
                    this.l("Range", b, this.k);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisInterval.prototype, "f", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                var b = this.f;
                if (a != b) {
                    this.e = a;
                    this.l("Interval", b, this.f);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisInterval.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.b;
                if (a != b) {
                    this.a = a;
                    this.l("Interval", i2.enumGetBox(TimeAxisIntervalType_$type, b), i2.enumGetBox(TimeAxisIntervalType_$type, this.b));
                }
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisInterval.prototype.d = function (a) {
            var b;
            switch (this.b) {
                case 0:
                    var c = 10000;
                    return i2.dateAddSeconds(a, 1 / c);
                case 1:
                    b = i2.dateAddSeconds(a, 1 / 1000);
                    return i2.dateFromValues(b.getFullYear(), i2.dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), b.getSeconds(), b.getMilliseconds());
                case 2:
                    b = i2.dateAddSeconds(a, 1);
                    return i2.dateFromValues(b.getFullYear(), i2.dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), b.getSeconds(), 0);
                case 3:
                    b = i2.dateAddMinutes(a, 1);
                    return i2.dateFromValues(b.getFullYear(), i2.dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), 0, 0);
                case 4:
                case 5:
                    b = i2.dateAddHours(a, 1);
                    return i2.dateFromValues(b.getFullYear(), i2.dateGetMonth(b), b.getDate(), b.getHours(), 0, 0, 0);
                case 6:
                case 7:
                case 8:
                    b = i2.dateAddDays(a, 1);
                    return i2.dateFromValues(b.getFullYear(), i2.dateGetMonth(b), b.getDate(), 0, 0, 0, 0);
                default: return a;
            }
        };
        TimeAxisInterval.prototype.c = function (a) {
            var b = +(i2.dateMaxValue()) - +a;
            switch (this.b) {
                case 0:
                    var c = 10000;
                    if (b > i2.timeSpanFromTicks(i2.truncate(this.f))) {
                        return i2.dateAddSeconds(a, this.f / c);
                    }
                    return i2.dateMaxValue();
                case 1:
                    if (b > i2.timeSpanFromMilliseconds(this.f)) {
                        return i2.dateAddSeconds(a, this.f / 1000);
                    }
                    return i2.dateMaxValue();
                case 2:
                    if (b > i2.timeSpanFromSeconds(this.f)) {
                        return i2.dateAddSeconds(a, this.f);
                    }
                    return i2.dateMaxValue();
                case 3:
                    if (b > i2.timeSpanFromMinutes(this.f)) {
                        return i2.dateAddMinutes(a, this.f);
                    }
                    return i2.dateMaxValue();
                case 4:
                    if (b > i2.timeSpanFromHours(this.f)) {
                        return i2.dateAddHours(a, this.f);
                    }
                    return i2.dateMaxValue();
                case 5:
                    if (b > i2.timeSpanFromDays(this.f)) {
                        return i2.dateAddDays(a, this.f);
                    }
                    return i2.dateMaxValue();
                case 6:
                    if (b > i2.timeSpanFromDays(7 * this.f)) {
                        return i2.dateAddDays(a, this.f * 7);
                    }
                    return i2.dateMaxValue();
                case 7:
                    if (b > i2.timeSpanFromDays(31 * i2.truncate(this.f))) {
                        return i2.dateAddMonths(a, i2.truncate(this.f));
                    }
                    return i2.dateMaxValue();
                case 8:
                    if (b > i2.timeSpanFromDays(365 * i2.truncate(this.f))) {
                        return i2.dateAddYears(a, i2.truncate(this.f));
                    }
                    return i2.dateMaxValue();
                default: return a;
            }
        };
        TimeAxisInterval.prototype.l = function (a, b, c) {
            this.m(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        TimeAxisInterval.prototype.m = function (a, b, c) {
        };
        TimeAxisInterval.$t = i2.markType(TimeAxisInterval, 'TimeAxisInterval', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return TimeAxisInterval;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisIntervalComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisIntervalComponent() {
            this._renderer = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._zoneRunner = null;
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisIntervalComponent.prototype.onImplementationCreated = function () {
        };
        IgxTimeAxisIntervalComponent.prototype.createImplementation = function () {
            return new TimeAxisInterval();
        };
        IgxTimeAxisIntervalComponent.prototype.ngOnInit = function () {
        };
        IgxTimeAxisIntervalComponent.prototype._provideRenderer = function (renderer) {
            this._renderer = renderer;
            this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
        };
        IgxTimeAxisIntervalComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "range", {
            /**
         * The visible axis range at which to apply this interval.
        *
        * Use `range` property for the visible axis range at which to apply this interval.
        *
        * ```ts
        * let xAxis = new IgxTimeXAxisComponent();
        * xAxis.dataTimeMemberPath="date";
        * this.chart.axes.add(xAxis);
        * ```
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        * 	<igx-time-x-axis
        * 		[labelFormats]="labelFormats"
        * 		dateTimeMemberPath="time"
        *
        * 		#xAxis>
        *     </igx-time-x-axis>
        * </igx-data-chart>
        * ```
        */
            get: function () {
                return this.i.k;
            },
            set: function (v) {
                this.i.k = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "interval", {
            /**
             * The interval, expressed as a multiple of IntervalType.
            *
            * Use the `interval` property expressed as a multiple of IntervalType.
            *
            * ```ts
            * let xAxis = new IgxTimeXAxisComponent();
            * xAxis.dataTimeMemberPath="date";
            * this.chart.axes.add(xAxis);
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-time-x-axis
            * 		[labelFormats]="labelFormats"
            * 		dateTimeMemberPath="time"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.f;
            },
            set: function (v) {
                this.i.f = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "intervalType", {
            /**
             * The unit of time for this interval.
            *
            * The `intervalType` is the unit of time for this interval.
            */
            get: function () {
                return this.i.b;
            },
            set: function (v) {
                this.i.b = i2.ensureEnum(TimeAxisIntervalType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisIntervalComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisIntervalComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxTimeAxisIntervalComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("TimeAxisIntervalComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxTimeAxisIntervalComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxTimeAxisIntervalComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTimeAxisIntervalComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTimeAxisIntervalComponent, selector: "igx-time-axis-interval", inputs: { range: "range", interval: "interval", intervalType: "intervalType" }, providers: [], ngImport: i0, template: "", isInline: true });
        return IgxTimeAxisIntervalComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-time-axis-interval',
                        template: "",
                        providers: []
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { range: [{
                    type: i0.Input
                }], interval: [{
                    type: i0.Input
                }], intervalType: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisLabelFormat = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisLabelFormat, _super);
        function TimeAxisLabelFormat() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.n = (0);
            _this.a = null;
            _this.d = null;
            _this.c = null;
            _this.b = null;
            _this.propertyChanged = null;
            return _this;
        }
        Object.defineProperty(TimeAxisLabelFormat.prototype, "o", {
            get: function () {
                return this.n;
            },
            set: function (a) {
                var b = this.o;
                if (a != b) {
                    this.n = a;
                    this.p("Range", b, this.o);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisLabelFormat.prototype, "e", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.e;
                if (a != b) {
                    this.a = a;
                    this.p("Format", b, this.e);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisLabelFormat.prototype, "l", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                var b = this.l;
                if (a != b) {
                    this.d = a;
                    this.p("RepeatedYearFormat", b, this.l);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisLabelFormat.prototype, "j", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.j;
                if (a != b) {
                    this.c = a;
                    this.p("RepeatedMonthFormat", b, this.j);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisLabelFormat.prototype, "h", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.h;
                if (a != b) {
                    this.b = a;
                    this.p("RepeatedDayFormat", b, this.h);
                }
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisLabelFormat.prototype.p = function (a, b, c) {
            this.q(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        TimeAxisLabelFormat.prototype.q = function (a, b, c) {
        };
        TimeAxisLabelFormat.$t = i2.markType(TimeAxisLabelFormat, 'TimeAxisLabelFormat', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return TimeAxisLabelFormat;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisLabelFormatComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisLabelFormatComponent() {
            this._renderer = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._zoneRunner = null;
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisLabelFormatComponent.prototype.onImplementationCreated = function () {
        };
        IgxTimeAxisLabelFormatComponent.prototype.createImplementation = function () {
            return new TimeAxisLabelFormat();
        };
        IgxTimeAxisLabelFormatComponent.prototype.ngOnInit = function () {
        };
        IgxTimeAxisLabelFormatComponent.prototype._provideRenderer = function (renderer) {
            this._renderer = renderer;
            this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
        };
        IgxTimeAxisLabelFormatComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "range", {
            /**
         * The visible axis range at which to apply this label format.
        *
        * The `range` property provide the visible axis range at which to apply this label format.
        *
        * ```ts
        * let labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "hh:mm:ss";
        * labelFormat.range = 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "hh:mm";
        * labelFormat.range = 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "MMM-dd-yy";
        * labelFormat.range = 24 * 60 * 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * ```
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        * 	<igx-time-x-axis
        * 		[labelFormats]="labelFormats"
        * 		dateTimeMemberPath="time"
        * 		#xAxis>
        *     </igx-time-x-axis>
        * </igx-data-chart>
        * ```
        */
            get: function () {
                return this.i.o;
            },
            set: function (v) {
                this.i.o = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "format", {
            /**
             * The DateTime format string to apply.
             * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
            *
            * The `format` property provide the DateTime format string to apply.
            *
            * ```ts
            * let labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "hh:mm:ss";
            * labelFormat.range = 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "hh:mm";
            * labelFormat.range = 60 * 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "MMM-dd-yy";
            * labelFormat.range = 24 * 60 * 60 * 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-time-x-axis
            * 		[labelFormats]="labelFormats"
            * 		dateTimeMemberPath="time"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.e;
            },
            set: function (v) {
                this.i.e = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "repeatedYearFormat", {
            /**
             * The DateTime format string to apply, if the year is repeated from the prior date.
             * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
            */
            get: function () {
                return this.i.l;
            },
            set: function (v) {
                this.i.l = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "repeatedMonthFormat", {
            /**
             * The DateTime format string to apply, if the month is repeated from the prior date.
             * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
            */
            get: function () {
                return this.i.j;
            },
            set: function (v) {
                this.i.j = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "repeatedDayFormat", {
            /**
             * The DateTime format string to apply, if the day is repeated from the prior date.
             * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
            */
            get: function () {
                return this.i.h;
            },
            set: function (v) {
                this.i.h = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisLabelFormatComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxTimeAxisLabelFormatComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisLabelFormatComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxTimeAxisLabelFormatComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("TimeAxisLabelFormatComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxTimeAxisLabelFormatComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxTimeAxisLabelFormatComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTimeAxisLabelFormatComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTimeAxisLabelFormatComponent, selector: "igx-time-axis-label-format", inputs: { range: "range", format: "format", repeatedYearFormat: "repeatedYearFormat", repeatedMonthFormat: "repeatedMonthFormat", repeatedDayFormat: "repeatedDayFormat" }, providers: [], ngImport: i0, template: "", isInline: true });
        return IgxTimeAxisLabelFormatComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-time-axis-label-format',
                        template: "",
                        providers: []
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { range: [{
                    type: i0.Input
                }], format: [{
                    type: i0.Input
                }], repeatedYearFormat: [{
                    type: i0.Input
                }], repeatedMonthFormat: [{
                    type: i0.Input
                }], repeatedDayFormat: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IAngleScaler_$type = new i2.Type(null, 'IAngleScaler');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryAxisRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryAxisRenderer, _super);
        function CategoryAxisRenderer(a) {
            return _super.call(this, a) || this;
        }
        CategoryAxisRenderer.prototype.ac = function (a, b, c, d, e) {
            var f = i2.typeCast(CategoryAxisRenderingParameters.$, a);
            var g = 0;
            if (f != null) {
                g = f.ab;
            }
            var h = new LinearCategorySnapper(1, a.e.d, a.e.c, a.e.b, a.p, g, a.o);
            b = h.g;
            if (a.e.a != -1) {
                b = a.e.a;
            }
            var i = Math.floor((a.e.d - a.m) / b);
            var j = Math.ceil((a.e.c - a.m) / b);
            d = i2.truncate(i);
            e = i2.truncate(j);
            c = i2.truncate(h.h);
            if (a.e.e != -1) {
                c = a.e.e;
            }
            return {
                p1: b,
                p2: c,
                p3: d,
                p4: e
            };
        };
        CategoryAxisRenderer.prototype.w = function (a, b, c, d) {
            var e = i2.typeCast(CategoryAxisRenderingParameters.$, a);
            if (e == null) {
                return null;
            }
            var f = 0;
            if (d >= 1) {
                f = c * i2.truncate(Math.floor(d));
            }
            else {
                if ((c * d) * 2 % 2 == 0) {
                    f = i2.truncate(Math.floor(c * d));
                }
                else {
                    f = -1;
                }
            }
            var g = null;
            if ((e.ae > 0 && f < e.ae && f >= 0) || e.ad) {
                while (f >= e.ae && e.ad) {
                    f -= e.ae;
                }
                g = this.g(f);
            }
            return g;
        };
        CategoryAxisRenderer.prototype.ad = function (a, b, c, d, e, f) {
            var g = i2.typeCast(CategoryAxisRenderingParameters.$, a);
            if (g.ab != 0 && g.af != 0) {
                for (var h = 0; h < i2.truncate(b); h++) {
                    for (var i = 0; i < g.af; i++) {
                        var j = this.f(i, a.aa, a.z, a.y);
                        if (g.ac) {
                            j = -j;
                        }
                        var k = this.m(a, h + e * b) + j;
                        a.b = a.d;
                        this.k(a, a.v, k);
                        a.b = null;
                    }
                }
            }
        };
        CategoryAxisRenderer.$t = i2.markType(CategoryAxisRenderer, 'CategoryAxisRenderer', AxisRendererBase.$);
        return CategoryAxisRenderer;
    }(AxisRendererBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IPolarRadialRenderingParameters_$type = new i2.Type(null, 'IPolarRadialRenderingParameters');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarAxisRenderingParameters, _super);
        function PolarAxisRenderingParameters() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._minLength = 0;
            _this._maxLength = 0;
            _this._center = null;
            _this._minAngle = 0;
            _this._maxAngle = 0;
            _this._crossingAngleRadians = 0;
            _this._effectiveMaximum = 0;
            return _this;
        }
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "minLength", {
            get: function () {
                return this._minLength;
            },
            set: function (a) {
                this._minLength = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "maxLength", {
            get: function () {
                return this._maxLength;
            },
            set: function (a) {
                this._maxLength = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "center", {
            get: function () {
                return this._center;
            },
            set: function (a) {
                this._center = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "minAngle", {
            get: function () {
                return this._minAngle;
            },
            set: function (a) {
                this._minAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "maxAngle", {
            get: function () {
                return this._maxAngle;
            },
            set: function (a) {
                this._maxAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "crossingAngleRadians", {
            get: function () {
                return this._crossingAngleRadians;
            },
            set: function (a) {
                this._crossingAngleRadians = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAxisRenderingParameters.prototype, "effectiveMaximum", {
            get: function () {
                return this._effectiveMaximum;
            },
            set: function (a) {
                this._effectiveMaximum = a;
            },
            enumerable: false,
            configurable: true
        });
        PolarAxisRenderingParameters.$t = i2.markType(PolarAxisRenderingParameters, 'PolarAxisRenderingParameters', NumericAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);
        return PolarAxisRenderingParameters;
    }(NumericAxisRenderingParameters));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialAxisRenderingParameters, _super);
        function RadialAxisRenderingParameters() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._minLength = 0;
            _this._maxLength = 0;
            _this._center = null;
            _this._crossingAngleRadians = 0;
            _this._minAngle = 0;
            _this._maxAngle = 0;
            _this._effectiveMaximum = 0;
            return _this;
        }
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "minLength", {
            get: function () {
                return this._minLength;
            },
            set: function (a) {
                this._minLength = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "maxLength", {
            get: function () {
                return this._maxLength;
            },
            set: function (a) {
                this._maxLength = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "center", {
            get: function () {
                return this._center;
            },
            set: function (a) {
                this._center = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "crossingAngleRadians", {
            get: function () {
                return this._crossingAngleRadians;
            },
            set: function (a) {
                this._crossingAngleRadians = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "minAngle", {
            get: function () {
                return this._minAngle;
            },
            set: function (a) {
                this._minAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "maxAngle", {
            get: function () {
                return this._maxAngle;
            },
            set: function (a) {
                this._maxAngle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialAxisRenderingParameters.prototype, "effectiveMaximum", {
            get: function () {
                return this._effectiveMaximum;
            },
            set: function (a) {
                this._effectiveMaximum = a;
            },
            enumerable: false,
            configurable: true
        });
        RadialAxisRenderingParameters.$t = i2.markType(RadialAxisRenderingParameters, 'RadialAxisRenderingParameters', CategoryAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);
        return RadialAxisRenderingParameters;
    }(CategoryAxisRenderingParameters));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarAxisRenderingManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarAxisRenderingManager, _super);
        function PolarAxisRenderingManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PolarAxisRenderingManager.prototype.p = function (a, b, c, d, e, f) {
            var g = ViewportUtils.d(a, e, f);
            var h = ViewportUtils.g(a, e, f);
            var i = ViewportUtils.c(b.x, e, f);
            var j = ViewportUtils.f(b.y, e, f);
            if (d - c < Math.PI && d - c > 0) {
                var k = { $type: i2.Point_$type, x: ViewportUtils.c(b.x + a * Math.cos(c), e, f), y: ViewportUtils.f(b.y + a * Math.sin(c), e, f) };
                var l_1 = { $type: i2.Point_$type, x: ViewportUtils.c(b.x + a * Math.cos(d), e, f), y: ViewportUtils.f(b.y + a * Math.sin(d), e, f) };
                var m = new i2.PathFigure();
                m._startPoint = k;
                m._isClosed = false;
                m._segments.add(((function () {
                    var $ret = new i2.ArcSegment();
                    $ret.b = false;
                    $ret.e = l_1;
                    $ret.f = new i2.Size(1, g, h);
                    $ret.d = 1;
                    return $ret;
                })()));
                return m;
            }
            else {
                var n = new i2.PathFigure();
                n._startPoint = { $type: i2.Point_$type, x: i, y: j - h };
                n._isClosed = true;
                n._segments.add(((function () {
                    var $ret = new i2.ArcSegment();
                    $ret.b = false;
                    $ret.e = { $type: i2.Point_$type, x: i, y: j + h };
                    $ret.f = new i2.Size(1, g, h);
                    $ret.d = 1;
                    return $ret;
                })()));
                n._segments.add(((function () {
                    var $ret = new i2.ArcSegment();
                    $ret.b = false;
                    $ret.e = { $type: i2.Point_$type, x: i, y: j - h };
                    $ret.f = new i2.Size(1, g, h);
                    $ret.d = 1;
                    return $ret;
                })()));
                return n;
            }
        };
        PolarAxisRenderingManager.prototype.j = function (a, b, c, d, e, f, g, h) {
            var i = Math.min(b, c);
            var j = Math.max(b, c);
            var k = new i2.PathGeometry();
            var l = null;
            var m = null;
            var n = null;
            var o = null;
            if (i > 0) {
                l = this.p(i, f, g, h, e, d);
                if (h - g < Math.PI && h - g > 0) {
                    var p = i2.typeCast(i2.ArcSegment.$, l._segments._inner[0]);
                    if (p != null) {
                        var q_1 = { $type: i2.Point_$type, x: ViewportUtils.c(f.x + j * Math.cos(h), e, d), y: ViewportUtils.f(f.y + j * Math.sin(h), e, d) };
                        m = ((function () {
                            var $ret = new i2.LineSegment(1);
                            $ret.c = q_1;
                            return $ret;
                        })());
                    }
                }
            }
            if (j > 0) {
                n = this.p(j, f, g, h, e, d);
            }
            if (i > 0) {
                if (h - g < Math.PI && h - g > 0) {
                    var r = n._startPoint;
                    var s = i2.typeCast(i2.ArcSegment.$, n._segments._inner[0]);
                    if (s != null) {
                        n._startPoint = s.e;
                        s.e = r;
                        s.d = 0;
                        var t_1 = { $type: i2.Point_$type, x: ViewportUtils.c(f.x + i * Math.cos(g), e, d), y: ViewportUtils.f(f.y + i * Math.sin(g), e, d) };
                        o = ((function () {
                            var $ret = new i2.LineSegment(1);
                            $ret.c = t_1;
                            return $ret;
                        })());
                    }
                }
            }
            if (m != null && o != null) {
                l._segments.add(m);
                var u = n._segments._inner[0];
                n._segments.remove(u);
                l._segments.add(u);
                l._segments.add(o);
                l._isClosed = true;
                k.c.add(l);
            }
            else {
                if (l != null) {
                    k.c.add(l);
                    this.o(n);
                }
                if (n != null) {
                    k.c.add(n);
                }
            }
            a.add(k);
        };
        PolarAxisRenderingManager.prototype.o = function (a) {
            if (a._segments.count > 1) {
                var b = i2.typeCast(i2.ArcSegment.$, a._segments._inner[0]);
                var c = i2.typeCast(i2.ArcSegment.$, a._segments._inner[1]);
                a._segments._inner[0] = c;
                a._segments._inner[1] = b;
                var d = c.e;
                var e = a._startPoint;
                var f = b.e;
                a._startPoint = d;
                c.e = f;
                b.e = e;
                b.d = 0;
                c.d = 0;
            }
            else {
                var g = a._startPoint;
                var h = i2.typeCast(i2.ArcSegment.$, a._segments._inner[0]);
                if (h != null) {
                    a._startPoint = h.e;
                    h.e = g;
                    h.d = 0;
                }
            }
        };
        PolarAxisRenderingManager.prototype.i = function (a, b, c, d, e, f, g) {
            if (b > 0) {
                var h = new i2.PathGeometry();
                h.c.add(this.p(b, e, f, g, d, c));
                a.add(h);
            }
        };
        PolarAxisRenderingManager.prototype.n = function (a, b, c, d, e, f, g, h) {
            var i = Math.min(b, c);
            var j = Math.max(b, c);
            var k = false;
            if (j - i > Math.PI) {
                k = true;
            }
            var l = Math.cos(i);
            var m = Math.sin(i);
            var n = h.x + l * f;
            var o = h.y + m * f;
            var p = h.x + l * g;
            var q = h.y + m * g;
            var r = Math.cos(j);
            var s = Math.sin(j);
            var t = h.x + r * f;
            var u = h.y + s * f;
            var v = h.x + r * g;
            var w = h.y + s * g;
            n = ViewportUtils.c(n, e, d);
            o = ViewportUtils.f(o, e, d);
            p = ViewportUtils.c(p, e, d);
            q = ViewportUtils.f(q, e, d);
            t = ViewportUtils.c(t, e, d);
            u = ViewportUtils.f(u, e, d);
            v = ViewportUtils.c(v, e, d);
            w = ViewportUtils.f(w, e, d);
            var x = new i2.PathFigure();
            x._startPoint = { $type: i2.Point_$type, x: n, y: o };
            x._isClosed = true;
            x._segments.add(((function () {
                var $ret = new i2.LineSegment(1);
                $ret.c = { $type: i2.Point_$type, x: p, y: q };
                return $ret;
            })()));
            x._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = { $type: i2.Point_$type, x: v, y: w };
                $ret.f = new i2.Size(1, ViewportUtils.d(g, e, d), ViewportUtils.g(g, e, d));
                $ret.d = 1;
                $ret.b = k;
                return $ret;
            })()));
            x._segments.add(((function () {
                var $ret = new i2.LineSegment(1);
                $ret.c = { $type: i2.Point_$type, x: t, y: u };
                return $ret;
            })()));
            x._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = { $type: i2.Point_$type, x: n, y: o };
                $ret.f = new i2.Size(1, ViewportUtils.d(f, e, d), ViewportUtils.g(f, e, d));
                $ret.d = 0;
                $ret.b = k;
                return $ret;
            })()));
            var y = new i2.PathGeometry();
            y.c.add(x);
            a.add(y);
        };
        PolarAxisRenderingManager.prototype.m = function (a, b, c, d, e, f, g) {
            var h = new i2.LineGeometry();
            var i = Math.cos(b);
            var j = Math.sin(b);
            var k = g.x + i * e;
            var l = g.y + j * e;
            var m = g.x + i * f;
            var n = g.y + j * f;
            k = ViewportUtils.c(k, d, c);
            l = ViewportUtils.f(l, d, c);
            m = ViewportUtils.c(m, d, c);
            n = ViewportUtils.f(n, d, c);
            h.d = { $type: i2.Point_$type, x: k, y: l };
            h.c = { $type: i2.Point_$type, x: m, y: n };
            a.add(h);
        };
        PolarAxisRenderingManager.prototype.a = function (a, b) {
            return a.x >= b.left && a.x <= b.right;
        };
        PolarAxisRenderingManager.prototype.b = function (a, b) {
            return a.y >= b.top && a.y <= b.bottom;
        };
        PolarAxisRenderingManager.prototype.c = function (a, b) {
            var c = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.top, 2));
            var d = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.top, 2));
            var e = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.bottom, 2));
            var f = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.bottom, 2));
            return Math.min(c, Math.min(d, Math.min(e, f)));
        };
        PolarAxisRenderingManager.prototype.d = function (a, b) {
            var c = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.top, 2));
            var d = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.top, 2));
            var e = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.bottom, 2));
            var f = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.bottom, 2));
            return Math.max(c, Math.max(d, Math.max(e, f)));
        };
        PolarAxisRenderingManager.prototype.f = function (a) {
            var b = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            if (this.a(b, a) && this.b(b, a)) {
                return 0;
            }
            if (this.a(b, a)) {
                if (b.y < a.top) {
                    return a.top - b.y;
                }
                else {
                    return b.y - a.bottom;
                }
            }
            if (this.b(b, a)) {
                if (b.x < a.left) {
                    return a.left - b.x;
                }
                else {
                    return b.x - a.right;
                }
            }
            return this.c(b, a);
        };
        PolarAxisRenderingManager.prototype.g = function (a) {
            var b = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            return this.d(b, a);
        };
        PolarAxisRenderingManager.prototype.e = function (a, b) {
            var c = Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
            var d = Math.acos((b.x - a.x) / c);
            if ((b.y - a.y) < 0) {
                d = (2 * Math.PI) - d;
            }
            return d;
        };
        PolarAxisRenderingManager.prototype.h = function (a, b) {
            return ((a.y - 0.5) * b.x) + ((0.5 - a.x) * b.y) + ((a.x * 0.5) - (0.5 * a.y));
        };
        PolarAxisRenderingManager.prototype.l = function (a, b, c) {
            var d = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            if (this.a(d, a) && this.b(d, a)) {
                b = 0;
                c = Math.PI * 2;
                return {
                    p1: b,
                    p2: c
                };
            }
            var e = this.e(d, { $type: i2.Point_$type, x: a.left, y: a.top });
            var f = this.e(d, { $type: i2.Point_$type, x: a.right, y: a.top });
            var g = this.e(d, { $type: i2.Point_$type, x: a.right, y: a.bottom });
            var h = this.e(d, { $type: i2.Point_$type, x: a.left, y: a.bottom });
            if (this.b(d, a) && a.left > d.x) {
                b = e;
                c = 2 * Math.PI + h;
                return {
                    p1: b,
                    p2: c
                };
            }
            b = Math.min(e, Math.min(f, Math.min(g, h)));
            c = Math.max(e, Math.max(f, Math.max(g, h)));
            return {
                p1: b,
                p2: c
            };
        };
        PolarAxisRenderingManager.prototype.k = function (a, b, c, d, e, f, g) {
            var h;
            var i;
            var j = this.l(a, h, i);
            h = j.p1;
            i = j.p2;
            var k = Math.min(h, i);
            var l = Math.max(h, i);
            if (i2.typeCast(PolarAxisRenderingParameters.$, b) !== null) {
                b.minAngle = k;
                b.maxAngle = l;
            }
            else if (i2.typeCast(RadialAxisRenderingParameters.$, b) !== null) {
                b.minAngle = k;
                b.maxAngle = l;
            }
            if (h == 0 && i == Math.PI * 2) {
                var m = c;
                var n = d;
                var o_1 = Math.min(m, n);
                var p_1 = Math.max(m, n);
                b.k.add(((function () {
                    var $ret = new RangeInfo();
                    $ret.d = o_1;
                    $ret.c = p_1;
                    $ret.b = g;
                    return $ret;
                })()));
                return;
            }
            else {
                if (i > Math.PI * 2) {
                    i = i - Math.PI * 2;
                }
                var q = f(h);
                var r = f(i);
                if (q < c || q > d) {
                    q = f(h + Math.PI * 2);
                }
                if (r < c || r > d) {
                    r = f(i + Math.PI * 2);
                }
                var s_1 = Math.min(q, r);
                var t_2 = Math.max(q, r);
                if ((!e && q > r) || (e && q < r)) {
                    var u_1 = (d - t_2);
                    var v_1 = (s_1 - c);
                    b.k.add(((function () {
                        var $ret = new RangeInfo();
                        $ret.d = t_2;
                        $ret.c = d;
                        $ret.b = (u_1 / (u_1 + v_1)) * g;
                        return $ret;
                    })()));
                    b.k.add(((function () {
                        var $ret = new RangeInfo();
                        $ret.d = c;
                        $ret.c = s_1;
                        $ret.b = (v_1 / (u_1 + v_1)) * g;
                        return $ret;
                    })()));
                }
                else {
                    b.k.add(((function () {
                        var $ret = new RangeInfo();
                        $ret.d = s_1;
                        $ret.c = t_2;
                        $ret.b = g;
                        return $ret;
                    })()));
                }
            }
        };
        PolarAxisRenderingManager.$t = i2.markType(PolarAxisRenderingManager, 'PolarAxisRenderingManager');
        return PolarAxisRenderingManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryTickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryTickmarkValues, _super);
        function CategoryTickmarkValues() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.v = 0;
            _this.z = 0;
            _this.aa = null;
            _this.ab = null;
            _this.x = false;
            _this.w = null;
            _this.y = 0;
            _this.t = null;
            _this.u = null;
            return _this;
        }
        CategoryTickmarkValues.prototype.s = function (a) {
            _super.prototype.s.call(this, a);
            var b = a.a;
            this.v = b;
            this.z = a.q;
            this.aa = a.r;
            this.ab = a.s;
            this.x = a.e;
            this.w = a.c;
            var c = new LinearCategorySnapper(1, a.n, a.m, a.k, a.l, b, a.h);
            var d = c.g;
            if (a.i != -1) {
                d = a.i;
            }
            var e = Math.floor((a.n - a.g) / d);
            var f = Math.ceil((a.m - a.g) / d);
            var g = i2.truncate(e);
            var h = i2.truncate(f);
            var i = i2.truncate(c.h);
            if (a.p != -1) {
                i = a.p;
            }
            this.m = d;
            this.n = a.j;
            this.p = g;
            this.q = h;
            this.r = i;
            this.y = a.g;
        };
        CategoryTickmarkValues.prototype.j = function () {
            var a = this.p;
            var b = this.q - a + 1;
            if (b < 0) {
                b = 0;
            }
            if (this.t == null || this.t.length != b) {
                this.t = new Array(b);
            }
            var c = this.t;
            for (var d = 0; d < b; ++d) {
                var e = this.y + (d + a) * this.m;
                c[d] = e;
            }
            return c;
        };
        CategoryTickmarkValues.prototype.k = function () {
            var a = this.m;
            var b = this.q;
            var c = this.p;
            var d = this.z;
            var e = this.v;
            a = Math.min(a, 20);
            var f = 0;
            for (var g = c; g < b; ++g) {
                if (e != 0 && d != 0) {
                    for (var h = 0; h < i2.truncate(a); h++) {
                        for (var i = 0; i < d; i++) {
                            f++;
                        }
                    }
                }
            }
            if (this.u == null || this.u.length != f) {
                this.u = new Array(f);
            }
            var j = this.u;
            var k = 0;
            for (var l = c; l < b; ++l) {
                if (e != 0 && d != 0) {
                    for (var m = 0; m < i2.truncate(a); m++) {
                        for (var n = 0; n < d; n++) {
                            var o = this.w(n);
                            var p = m + (l * a) + o;
                            j[k] = p;
                            k++;
                        }
                    }
                }
            }
            return this.u;
        };
        CategoryTickmarkValues.$t = i2.markType(CategoryTickmarkValues, 'CategoryTickmarkValues', TickmarkValues.$);
        return CategoryTickmarkValues;
    }(TickmarkValues));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialAxisLabelPanel, _super);
        function RadialAxisLabelPanel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.dq = null;
            _this.dm = 0;
            _this.dl = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        RadialAxisLabelPanel.prototype.ad = function () {
            return new RadialAxisLabelPanelView(this);
        };
        RadialAxisLabelPanel.prototype.cc = function (a) {
            _super.prototype.cc.call(this, a);
            this.dj = a;
        };
        Object.defineProperty(RadialAxisLabelPanel.prototype, "dk", {
            get: function () {
                return !this.al;
            },
            enumerable: false,
            configurable: true
        });
        RadialAxisLabelPanel.prototype.c4 = function () {
            return this.an && (!this.ar || this.bh() == -180);
        };
        RadialAxisLabelPanel.prototype.c5 = function () {
            return !this.as;
        };
        RadialAxisLabelPanel.prototype.bx = function (a) {
            _super.prototype.bx.call(this, a);
            if (this.dm % 360 == 0 || this.al) {
                this.dj.a3();
            }
            else {
                this.dj.a2(a);
            }
        };
        RadialAxisLabelPanel.prototype.bh = function () {
            var a = _super.prototype.bh.call(this);
            if (this.dk) {
                a -= (this.dm * 180) / Math.PI;
            }
            return a;
        };
        RadialAxisLabelPanel.prototype.c3 = function () {
            return this.bh() % 360 != 0;
        };
        RadialAxisLabelPanel.prototype.c2 = function () {
            if (this.al) {
                return true;
            }
            var a = this.dm * 180 / Math.PI;
            if (a < 30 || a > 330 || (a > 150 && a < 210)) {
                return true;
            }
            return false;
        };
        RadialAxisLabelPanel.prototype.cg = function (a, b) {
            var c = b * Math.PI / 180;
            var d = Math.abs(Math.sin(c));
            if (this.ac.ay != null && this.ac.ay.c == 4) {
                d = d * -1;
            }
            this.dj.a4(a, b, d);
        };
        RadialAxisLabelPanel.prototype.dp = function () {
            var e_1, _a;
            var a = 1.7976931348623157E+308;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.a6)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    a = Math.min(b.c, a);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return a;
        };
        RadialAxisLabelPanel.prototype.dn = function () {
            var e_2, _a;
            var a = -1.7976931348623157E+308;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.a6)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    a = Math.max(b.c, a);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            return a;
        };
        RadialAxisLabelPanel.prototype.dh = function (a, b) {
            var c;
            if (this.ac.cc) {
                c = this.dp();
            }
            else {
                c = this.dn();
            }
            var d = new i2.List$1(i2.Number_$type, 0);
            var e = new i2.List$1(i2.Boolean_$type, 0);
            for (var f = 0; f < this.a6.count; f++) {
                var g = this.a6._inner[f];
                if (g.c == c && !g.a) {
                    d.add(this.a6.indexOf(g));
                }
            }
            this.dl = d;
            var h = new i2.List$1(i2.Rect.$, 0);
            for (var i = 0; i < a.count; i++) {
                var j = a._inner[i];
                var k = this.a6._inner[i].a;
                if (!this.dl.contains(i)) {
                    h.add(j);
                    e.add(k);
                }
            }
            this.an = this.am(h, e);
        };
        RadialAxisLabelPanel.prototype.aq = function (a, b) {
            if (this.dl.contains(a)) {
                return false;
            }
            else {
                return _super.prototype.aq.call(this, a, b);
            }
        };
        RadialAxisLabelPanel.prototype.di = function () {
            this.dl = new i2.List$1(i2.Number_$type, 0);
            _super.prototype.di.call(this);
        };
        RadialAxisLabelPanel.prototype.ah = function () {
            return 5;
        };
        RadialAxisLabelPanel.prototype.au = function (a) {
            return a == 5 || a == 4 || a == 1 || a == 0;
        };
        RadialAxisLabelPanel.prototype.b4 = function () {
        };
        RadialAxisLabelPanel.$t = i2.markType(RadialAxisLabelPanel, 'RadialAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
        return RadialAxisLabelPanel;
    }(HorizontalAxisLabelPanelBase));
    /**
     * @hidden
     */
    var RadialAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialAxisLabelPanelView, _super);
        function RadialAxisLabelPanelView(a) {
            var _this = _super.call(this, a) || this;
            _this.a1 = null;
            _this.a1 = a;
            return _this;
        }
        RadialAxisLabelPanelView.prototype.a4 = function (a, b, c) {
            var d = this.m(a);
            var e = this.l(a);
            var f = new i2.TransformGroup();
            f.j.add(((function () {
                var $ret = new i2.RotateTransform();
                $ret.j = b;
                $ret.k = d / 2;
                $ret.l = e / 2;
                return $ret;
            })()));
            f.j.add(((function () {
                var $ret = new i2.TranslateTransform();
                $ret.j = d / -2;
                $ret.k = d / 2 * c;
                return $ret;
            })()));
            a.j = f;
        };
        RadialAxisLabelPanelView.prototype.a3 = function () {
            this.a.j = null;
        };
        RadialAxisLabelPanelView.prototype.a2 = function (a) {
            var _this = this;
            var b = ViewportUtils.f(0.5, this.a.cx, this.a.cw);
            this.a.j = ((function () {
                var $ret = new i2.RotateTransform();
                $ret.j = (_this.a1.dm * 180) / Math.PI;
                $ret.k = _this.a1.dq.x;
                $ret.l = (_this.a1.dq.y * a.height) + b;
                return $ret;
            })());
        };
        RadialAxisLabelPanelView.prototype.al = function () {
            _super.prototype.al.call(this);
            this.a.cy(new i2.Size(1, this.a.cu.width, this.a.cu.height));
        };
        RadialAxisLabelPanelView.$t = i2.markType(RadialAxisLabelPanelView, 'RadialAxisLabelPanelView', HorizontalAxisLabelPanelBaseView.$);
        return RadialAxisLabelPanelView;
    }(HorizontalAxisLabelPanelBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AngleAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AngleAxisLabelPanel, _super);
        function AngleAxisLabelPanel() {
            var _this = _super.call(this) || this;
            _this.c2 = false;
            _this.c8 = null;
            _this.c6 = 0;
            _this.c3 = 0;
            _this.c5 = 0;
            _this.c4 = 0;
            return _this;
        }
        AngleAxisLabelPanel.prototype.ad = function () {
            return new AngleAxisLabelPanelView(this);
        };
        AngleAxisLabelPanel.prototype.cc = function (a) {
            _super.prototype.cc.call(this, a);
            this.c1 = a;
        };
        AngleAxisLabelPanel.prototype.aq = function (a, b) {
            if (!i2.Extensions.b(b)) {
                return false;
            }
            if (this.ac == null || this.ac.js.isEmpty) {
                return _super.prototype.aq.call(this, a, b);
            }
            return true;
        };
        AngleAxisLabelPanel.prototype.a1 = function () {
            var a = new i2.List$1(i2.Rect.$, 0);
            var b = new i2.List$1(i2.Boolean_$type, 0);
            if (this.a7.count != this.a6.count) {
                return a;
            }
            this.c1.ay(a, b);
            var c = false;
            this.an = this.am(a, b);
            if (!this.ac.b3()) {
                c = true;
                this.bd = this.c6 / 2;
                this.bd = this.bd + this.c7();
            }
            else {
                c = true;
                this.c1.ac();
            }
            if (c) {
                for (var d = 0; d < a.count; d++) {
                    var e = this.a7._inner[d];
                    var f = this.a6._inner[d];
                    var g = a._inner[d];
                    var h = this.c8(f.c);
                    var i = h.x - this.bg(e) / 2;
                    var j = h.y - this.bf(e) / 2;
                    g.x = i;
                    g.y = j;
                    a._inner[d] = g;
                }
            }
            return a;
        };
        AngleAxisLabelPanel.prototype.c7 = function () {
            var a;
            var b;
            b = this.ac;
            a = null;
            if (b != null) {
                a = i2.typeCast(XamDataChart.$, b.bh);
            }
            if (a == null || b == null) {
                return 0;
            }
            var c = new i2.List$1(Axis.$, 0);
            for (var d = 0; d < a.axes.count; d++) {
                var e = a.axes._inner[d];
                if ((i2.typeCast(NumericAngleAxis.$, e) !== null || i2.typeCast(CategoryAngleAxis.$, e) !== null) && i2.typeCast(AngleAxisLabelPanel.$, e.av) !== null && e.av.a7.count > 0 && (!e.b3()) && !e.b1() && (e.ai == null || this.ac.ai == null || e.ai.ma == b.ai.ma)) {
                    c.add(e);
                }
            }
            var f = c.indexOf(b);
            if (f == -1) {
                return 0;
            }
            var g = 0;
            var h = 5;
            if (f == 0) {
                g += h;
            }
            else {
                g += c._inner[f - 1].av.bd;
                g += c._inner[f].av.bd * 2 + h;
            }
            return g;
        };
        AngleAxisLabelPanel.prototype.ah = function () {
            return 4;
        };
        AngleAxisLabelPanel.prototype.au = function (a) {
            return a == 4 || a == 5;
        };
        AngleAxisLabelPanel.$t = i2.markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
        return AngleAxisLabelPanel;
    }(AxisLabelPanelBase));
    /**
     * @hidden
     */
    var CategoryAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryAngleAxis, _super);
        function CategoryAngleAxis() {
            var _this = _super.call(this) || this;
            _this.lt = null;
            _this.lq = null;
            _this.lu = false;
            _this.ly = NaN;
            _this.lr = null;
            _this.lz = 0;
            _this.lw = 0;
            _this.lx = 0;
            _this.ma = 1;
            _this.ab = CategoryAngleAxis.$;
            _this.lq = _this.lp();
            _this.lt = new PolarAxisRenderingManager();
            return _this;
        }
        CategoryAngleAxis.prototype.a3 = function () {
            return new CategoryAngleAxisView(this);
        };
        CategoryAngleAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.lo = a;
        };
        CategoryAngleAxis.prototype.get_b4 = function () {
            return true;
        };
        CategoryAngleAxis.prototype.au = function () {
            var _this = this;
            var a = new AngleAxisLabelPanel();
            a.c8 = function (b) {
                var c = _this.bh != null ? _this.bh.pg : i2.Rect.empty;
                var d = !c.isEmpty ? _this.js : i2.Rect.empty;
                return _this.mn(b, { $type: i2.Point_$type, x: 0.5, y: 0.5 }, c, d, _this.av.bd);
            };
            return a;
        };
        CategoryAngleAxis.prototype.l8 = function (a) {
            return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
        };
        CategoryAngleAxis.prototype.lp = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new AxisLabelManager();
                $ret.a = _this;
                $ret.f = _this.c6;
                $ret.e = _this.c5;
                $ret.b = _this.av;
                return $ret;
            })());
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            var b = new CategoryAxisRenderer(a);
            b.u = function () {
                var c = _this.a4.ay();
                var d = _this.a4.a1();
                var e = _this.a4.az();
                var f = _this.a4.a0();
                _this.h0();
                _this.g0(c);
                _this.g0(d);
                _this.g0(e);
                _this.g0(f);
            };
            b.o = function (c, d) { return !d.isEmpty && !c.isEmpty && _this.ls != null; };
            b.d = function (c, d, e, f) { return _this.ln(c, d, e, f); };
            b.v = function () {
                if (!_this.lu) {
                    _this.lu = true;
                    _this.ls.cv();
                    _this.lu = false;
                }
            };
            b.g = function (c) {
                var d = i2.typeGetValue(c);
                if (d > _this.j6.count - 1) {
                    d -= _this.j6.count;
                }
                var e = _this.j6.item(d);
                return _this.fi(e);
            };
            b.b.c = function (c) {
                var e_1, _a;
                if ((_this.ay == null || _this.ay.visibility == 0) && _this.ls != null && _this.ly != c) {
                    var d = i2.typeCast(XamDataChart.$, _this.bh);
                    if (d == null) {
                        return;
                    }
                    _this.ly = c;
                    _this.av.bc = c;
                    d.jq();
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(d.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var e = _c.value;
                            if (e != _this && i2.typeCast(AngleAxisLabelPanel.$, e.av) !== null) {
                                e.a4.ad();
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
            };
            b.k = function (c, d, e) {
                var f = i2.typeCast(RadialAxisRenderingParameters.$, c);
                _this.lt.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
            };
            b.l = function (c, d, e, f) {
                var g = i2.typeCast(RadialAxisRenderingParameters.$, c);
                _this.lt.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
            };
            b.m = function (c, d) { return _this.getScaledAngle(d); };
            b.q = function (c, d) {
                if (_this.l8(d - _this.lz) < 0) {
                    return false;
                }
                if (_this.l8(d - _this.lz - (2 * Math.PI)) > 0) {
                    return false;
                }
                return true;
            };
            b.j = function (c) {
                var d = i2.typeCast(RadialAxisRenderingParameters.$, c);
                if (d.e == d.k._inner[0]) {
                    _this.lt.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
                }
            };
            b.e = function (c) {
                c.n = _this.l2();
                c.r = c.n;
            };
            b.p = function (c, d, e) {
                var f = i2.typeCast(RadialAxisRenderingParameters.$, c);
                if (e) {
                    return false;
                }
                var g = _this.mn(d, f.center, c.aa, c.z, 0);
                if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                    return true;
                }
                return false;
            };
            b.a = function (c, d, e, f) {
                var g = c.y;
                var h = new ScalerParams(0, c.aa, c.z, _this.cc, g);
                var i = d;
                if (_this.categoryMode != 0) {
                    var j = (e * f) + 1;
                    j = Math.min(j, _this.kq);
                    var k = _this.d8(j, h);
                    i = (d + k) / 2;
                }
                return i;
            };
            b.f = i2.runOn(this, this.getGroupCenter);
            b.i = i2.runOn(this, this.l5);
            return b;
        };
        CategoryAngleAxis.prototype.mn = function (a, b, c, d, e) {
            var f = this.l2();
            var g = ViewportUtils.b(e, c, d);
            if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
                g *= -1;
            }
            var h = b.x + (f + g) * Math.cos(a);
            var i = b.y + (f + g) * Math.sin(a);
            h = ViewportUtils.c(h, c, d);
            i = ViewportUtils.f(i, c, d);
            return { $type: i2.Point_$type, x: h, y: i };
        };
        CategoryAngleAxis.prototype.l2 = function () {
            if (this.ls == null) {
                return 0;
            }
            if (!this.b1()) {
                return this.ls.mf();
            }
            else {
                return this.ls.mg((this.fe));
            }
        };
        CategoryAngleAxis.prototype.ln = function (a, b, c, d) {
            if (this.j6 == null) {
                return null;
            }
            var e = new RadialAxisRenderingParameters();
            var f = this.j6.count - 1;
            var g = this.a4.ay();
            var h = this.a4.a1();
            var i = this.a4.az();
            var j = this.a4.a0();
            e.t = g;
            e.w = h;
            e.u = i;
            e.v = j;
            e.l = f;
            e.m = 0;
            e.h = false;
            e.z = a;
            e.y = c;
            e.x = d;
            e.aa = b;
            e.g = this.lv();
            e.p = this.l6;
            e.o = this.el();
            e.q = this.l7;
            e.s = this.fj;
            var k = this.lt.f(b);
            var l = this.lt.g(b);
            var m = 0.5 * this.ls.ma;
            var n = 0.5 * this.ls.l9;
            var o = k;
            var p = l;
            var q = this.ls.mf();
            if (i2.isNaN_(q) || i2.isInfinity(q)) {
                return null;
            }
            if (p >= m) {
                p = q;
            }
            if (o < n) {
                o = n;
            }
            var r = a.width;
            this.lt.k(b, e, 0, this.j6.count, this.cc, i2.runOn(this, this.getUnscaledAngle), r);
            var s = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            e.center = s;
            e.maxLength = p;
            e.minLength = o;
            e.effectiveMaximum = q;
            e.ae = this.j6.count;
            e.ab = this.categoryMode;
            e.ad = true;
            e.ac = this.cc;
            e.af = this.ks;
            e.f = new CategoryTickmarkValues();
            e.j = this.cs;
            return e;
        };
        CategoryAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
            var d = this.lt.l(a, b, c);
            b = d.p1;
            c = d.p2;
            return {
                p1: b,
                p2: c
            };
        };
        CategoryAngleAxis.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.hq(false);
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "ls", {
            get: function () {
                if (this.lr != null) {
                    return this.lr;
                }
                var a = i2.typeCast(XamDataChart.$, this.bh);
                if (a != null) {
                    for (var b = 0; b < a.axes.count; b++) {
                        if (i2.typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                            return a.axes._inner[b];
                        }
                    }
                }
                return this.lr;
            },
            set: function (a) {
                this.lr = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.prototype.aj = function () {
            return this.ls;
        };
        CategoryAngleAxis.prototype.getCategorySize = function (a, b, c) {
            return 2 * Math.PI / this.kq;
        };
        CategoryAngleAxis.prototype.ki = function (a, b, c) {
            var d = !i2.isNaN_(this.kf) ? i2.MathUtil.b(this.kf, 0, 1) : 0;
            var e = 0;
            if (!i2.isNaN_(this.km)) {
                e = Math.min(this.km, 1);
            }
            var f = 1 - 0.5 * d;
            return this.getCategorySize(a, b, c) * f / (this.ks - (this.ks - 1) * e);
        };
        CategoryAngleAxis.prototype.getGroupCenter = function (a, b, c, d) {
            var e = 0.5;
            if (this.ks > 1) {
                var f = !i2.isNaN_(this.kf) ? i2.MathUtil.b(this.kf, 0, 1) : 0;
                var g = 0;
                if (!i2.isNaN_(this.km)) {
                    g = Math.min(this.km, 1);
                }
                var h = 1 - 0.5 * f;
                var i = h / (this.ks - (this.ks - 1) * g);
                var j = (h - i) / (this.ks - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        };
        CategoryAngleAxis.prototype.l5 = function (a) {
            var b = 0.5;
            if (this.ks > 1) {
                var c = !i2.isNaN_(this.kf) ? i2.MathUtil.b(this.kf, 0, 1) : 0;
                var d = 0;
                if (!i2.isNaN_(this.km)) {
                    d = Math.min(this.km, 1);
                }
                var e = 1 - 0.5 * c;
                var f = e / (this.ks - (this.ks - 1) * d);
                var g = (e - f) / (this.ks - 1);
                b = 0.25 * c + 0.5 * f + a * g;
            }
            return b;
        };
        CategoryAngleAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = !b.isEmpty ? this.js : i2.Rect.empty;
            var d = this.jn();
            var e = this.jm();
            var f = this.lq.c(a, c, b, d, e);
            if (f != null) {
                this.l0 = f.f.m;
                this.l1 = f.f.l;
            }
        };
        CategoryAngleAxis.prototype.l4 = function (a, b) {
            var c;
            var d;
            var e = this.lt.l(b, c, d);
            c = e.p1;
            d = e.p2;
            if (c == 0) {
                if (this.cc) {
                    return this.kq;
                }
                else {
                    return 0;
                }
            }
            var f = this.getUnscaledAngle(c);
            if (f < 0 || f > this.kq) {
                f = this.getUnscaledAngle(c + Math.PI * 2);
            }
            return f;
        };
        CategoryAngleAxis.prototype.l3 = function (a, b) {
            var c;
            var d;
            var e = this.lt.l(b, c, d);
            c = e.p1;
            d = e.p2;
            if (d > Math.PI * 2) {
                d = d - Math.PI * 2;
            }
            if (d == Math.PI * 2) {
                if (this.cc) {
                    return 0;
                }
                else {
                    return this.kq;
                }
            }
            var f = this.getUnscaledAngle(d);
            if (f < 0 || f > this.kq) {
                f = this.getUnscaledAngle(d + Math.PI * 2);
            }
            return f;
        };
        CategoryAngleAxis.prototype.getScaledAngle = function (a) {
            var b = this.kq;
            var c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
            if (this.cd) {
                c = 1 - c;
            }
            return (c * 2 * Math.PI) + this.lz;
        };
        CategoryAngleAxis.prototype.getUnscaledAngle = function (a) {
            if (a < this.lz) {
                a += 2 * Math.PI;
            }
            var b = (a - this.lz) / (2 * Math.PI);
            if (this.cc) {
                b = 1 - b;
            }
            return b * (this.kq);
        };
        CategoryAngleAxis.prototype.d8 = function (a, b) {
            return this.getScaledAngle(a);
        };
        CategoryAngleAxis.prototype.eb = function (a, b) {
            return this.getUnscaledAngle(a);
        };
        CategoryAngleAxis.prototype.he = function (a, b, c, d) {
            var e_2, _a, e_3, _b, e_4, _c;
            _super.prototype.he.call(this, a, b, c, d);
            var e = i2.typeCast(XamDataChart.$, this.bh);
            switch (b) {
                case "CrossingAxis":
                    var f = i2.typeCast(NumericRadiusAxis.$, d);
                    this.mj(f);
                    if (f != null) {
                        f.mp(this);
                    }
                    this.ck = true;
                    this.hq(false);
                    break;
                case CategoryAngleAxis.$$p[0]:
                    this.lz = this.l9;
                    while (this.lz < 0) {
                        this.lz += 360;
                    }
                    while (this.lz >= 360) {
                        this.lz -= 360;
                    }
                    this.lz = (this.lz * Math.PI) / 180;
                    this.ck = true;
                    this.hq(false);
                    try {
                        for (var _d = tslib.__values(i2.fromEnum(this.c7)), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var g = _e.value;
                            g.l0(false);
                            g.k7();
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_e && !_e.done && (_a = _d.return))
                                _a.call(_d);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    break;
                case "Label":
                    if (e != null) {
                        try {
                            for (var _f = tslib.__values(i2.fromEnum(e.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var h = _g.value;
                                h.ck = true;
                                h.hp();
                            }
                        }
                        catch (e_3_1) {
                            e_3 = { error: e_3_1 };
                        }
                        finally {
                            try {
                                if (_g && !_g.done && (_b = _f.return))
                                    _b.call(_f);
                            }
                            finally {
                                if (e_3)
                                    throw e_3.error;
                            }
                        }
                    }
                    break;
                case "CrossingValue":
                    if (e != null) {
                        try {
                            for (var _h = tslib.__values(i2.fromEnum(e.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                                var i = _j.value;
                                if (i2.typeCast(NumericAngleAxis.$, i) !== null || i2.typeCast(CategoryAngleAxis.$, i) !== null) {
                                    i.ck = true;
                                    i.hp();
                                }
                            }
                        }
                        catch (e_4_1) {
                            e_4 = { error: e_4_1 };
                        }
                        finally {
                            try {
                                if (_j && !_j.done && (_c = _h.return))
                                    _c.call(_h);
                            }
                            finally {
                                if (e_4)
                                    throw e_4.error;
                            }
                        }
                    }
                    break;
                case "LabelSettings":
                    this.lq = this.lp();
                    this.mh();
                    this.ck = true;
                    this.hq(false);
                    break;
            }
        };
        CategoryAngleAxis.prototype.mh = function () {
            this.ly = NaN;
        };
        CategoryAngleAxis.prototype.mj = function (a) {
            this.ls = a;
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "l6", {
            get: function () {
                return this.c(CategoryAngleAxis.mk);
            },
            set: function (a) {
                this.h(CategoryAngleAxis.mk, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryAngleAxis.prototype, "l0", {
            get: function () {
                return this.lw;
            },
            set: function (a) {
                if (this.l0 != a) {
                    var b = this.lw;
                    this.lw = a;
                    this.hk("ActualInterval", b, this.l0);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.prototype.ej = function () {
            return this.l0;
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "l7", {
            get: function () {
                return this.c(CategoryAngleAxis.ml);
            },
            set: function (a) {
                this.h(CategoryAngleAxis.ml, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryAngleAxis.prototype, "l1", {
            get: function () {
                return this.lx;
            },
            set: function (a) {
                if (this.l1 != a) {
                    var b = this.lx;
                    this.lx = a;
                    this.hk("ActualMinorInterval", b, this.l1);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.prototype.lv = function () {
            return !i2.isNaN_(this.l6);
        };
        CategoryAngleAxis.prototype.get_a1 = function () {
            return 2;
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.prototype.cx = function () {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null) {
                return false;
            }
            var a = this.j6.count;
            if (a != this.mb) {
                var b = new AxisRangeChangedEventArgs(0, 1, 1, this.mb, a);
                this.mb = a;
                this.hl(b);
                return true;
            }
            return false;
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "mb", {
            get: function () {
                return this.ma;
            },
            set: function (a) {
                this.ma = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.prototype.jk = function (a, b, c, d, e) {
            if (d === void 0) {
                d = null;
            }
            if (e === void 0) {
                e = null;
            }
            var f = i2.typeCast(RadialAxisRenderingParameters.$, this.lq.d(c, b, d, e));
            if (f == null) {
                return null;
            }
            var g = Math.cos(a);
            var h = Math.sin(a);
            var i = f.center.x + g * f.minLength;
            var j = f.center.y + h * f.minLength;
            var k = f.center.x + g * f.maxLength;
            var l = f.center.y + h * f.maxLength;
            i = ViewportUtils.c(i, b, c);
            j = ViewportUtils.f(j, b, c);
            k = ViewportUtils.c(k, b, c);
            l = ViewportUtils.f(l, b, c);
            var m = new i2.LineGeometry();
            m.d = { $type: i2.Point_$type, x: i, y: j };
            m.c = { $type: i2.Point_$type, x: k, y: l };
            return m;
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        CategoryAngleAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        CategoryAngleAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        CategoryAngleAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        CategoryAngleAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(CategoryAngleAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        CategoryAngleAxis.$t = i2.markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
        CategoryAngleAxis.mk = i2.DependencyProperty.i("Interval", i2.Number_$type, CategoryAngleAxis.$, new i2.PropertyMetadata(2, NaN, function (a, b) {
            a.hk("Interval", b.oldValue, b.newValue);
            a.hq(false);
        }));
        CategoryAngleAxis.ml = i2.DependencyProperty.i("MinorInterval", i2.Number_$type, CategoryAngleAxis.$, new i2.PropertyMetadata(2, NaN, function (a, b) {
            (i2.typeCast(CategoryAngleAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
            (i2.typeCast(CategoryAngleAxis.$, a)).hq(false);
        }));
        CategoryAngleAxis.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryAngleAxis, 'hk', ['StartAngleOffset:l9:mm', [1, 0]]);
        return CategoryAngleAxis;
    }(CategoryAxisBase));
    /**
     * @hidden
     */
    var NumericAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericAngleAxis, _super);
        function NumericAngleAxis() {
            var _this = _super.call(this) || this;
            _this.l6 = null;
            _this.l7 = false;
            _this.l8 = NaN;
            _this.l9 = 0;
            _this.l4 = null;
            _this.ab = NumericAngleAxis.$;
            _this.l6 = new PolarAxisRenderingManager();
            _this.j6 = _this.j4();
            return _this;
        }
        NumericAngleAxis.prototype.a3 = function () {
            return new NumericAngleAxisView(this);
        };
        NumericAngleAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.l3 = a;
        };
        NumericAngleAxis.prototype.get_b4 = function () {
            return true;
        };
        NumericAngleAxis.prototype.au = function () {
            var _this = this;
            var a = new AngleAxisLabelPanel();
            a.c8 = function (b) {
                var c = _this.bh != null ? _this.bh.pg : i2.Rect.empty;
                var d = !c.isEmpty ? _this.js : i2.Rect.empty;
                return _this.mj(b, { $type: i2.Point_$type, x: 0.5, y: 0.5 }, c, d, _this.av.bd);
            };
            return a;
        };
        NumericAngleAxis.prototype.ma = function () {
            if (this.l5 == null) {
                return 0;
            }
            if (!this.b1()) {
                return this.l5.mf();
            }
            else {
                return this.l5.mg((this.fe));
            }
        };
        NumericAngleAxis.prototype.mc = function (a) {
            return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
        };
        NumericAngleAxis.prototype.j4 = function () {
            var _this = this;
            var a = _super.prototype.j4.call(this);
            a.b.c = function (b) {
                var e_5, _a;
                if ((_this.ay == null || _this.ay.visibility == 0) && _this.l5 != null && _this.l8 != b) {
                    var c = i2.typeCast(XamDataChart.$, _this.bh);
                    if (c == null) {
                        return;
                    }
                    _this.l8 = b;
                    _this.av.bc = b;
                    c.jq();
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(c.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var d = _c.value;
                            if (d != _this && i2.typeCast(AngleAxisLabelPanel.$, d.av) !== null) {
                                d.a4.ad();
                            }
                        }
                    }
                    catch (e_5_1) {
                        e_5 = { error: e_5_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_5)
                                throw e_5.error;
                        }
                    }
                }
            };
            a.e = function (b) {
                b.n = _this.ma();
                b.r = b.n;
            };
            a.j = function (b) {
                var c = i2.typeCast(PolarAxisRenderingParameters.$, b);
                if (c.e == c.k._inner[0]) {
                    _this.l6.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
                }
            };
            a.k = function (b, c, d) {
                var e = i2.typeCast(PolarAxisRenderingParameters.$, b);
                _this.l6.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
            };
            a.l = function (b, c, d, e) {
                var f = i2.typeCast(PolarAxisRenderingParameters.$, b);
                _this.l6.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
            };
            a.d = function (b, c, d, e) {
                var f = i2.typeCast(PolarAxisRenderingParameters.$, _this.j7(b, c, d, e));
                return f;
            };
            a.v = function () {
                if (!_this.l7) {
                    _this.l7 = true;
                    _this.l5.cv();
                    _this.l7 = false;
                }
            };
            a.m = function (b, c) { return _this.getScaledAngle(c); };
            a.o = function (b, c) { return !c.isEmpty && !b.isEmpty && _this.l5 != null; };
            a.q = function (b, c) {
                if (_this.mc(c - _this.l9) < 0) {
                    return false;
                }
                if (_this.mc(c - _this.l9 - (2 * Math.PI)) > 0) {
                    return false;
                }
                return true;
            };
            a.p = function (b, c, d) {
                var e = i2.typeCast(PolarAxisRenderingParameters.$, b);
                var f = _this.mj(_this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
                var g = _this.mj(c, e.center, b.aa, b.z, 0);
                if (d && i2.MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                    return false;
                }
                if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                    return true;
                }
                return false;
            };
            a.r = function (b, c, d, e) {
                if (c < b.m && i2.typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                    return b.m;
                }
                else if (c > b.l && (i2.typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                    return b.l;
                }
                return c;
            };
            return a;
        };
        NumericAngleAxis.prototype.mj = function (a, b, c, d, e) {
            var f = this.ma();
            var g = ViewportUtils.b(e, c, d);
            if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
                g *= -1;
            }
            var h = b.x + (f + g) * Math.cos(a);
            var i = b.y + (f + g) * Math.sin(a);
            h = ViewportUtils.c(h, c, d);
            i = ViewportUtils.f(i, c, d);
            return { $type: i2.Point_$type, x: h, y: i };
        };
        NumericAngleAxis.prototype.d8 = function (a, b) {
            return this.getScaledAngle(a);
        };
        NumericAngleAxis.prototype.getScaledAngle1 = function (a, b, c) {
            var d = 0;
            if (b) {
                d = (Math.log(a) - this.k1) / (this.k0 - this.k1);
            }
            else {
                d = (a - this.kv) / (this.ku - this.kv);
            }
            if (c) {
                d = 1 - d;
            }
            return (d * 2 * Math.PI) + this.l9;
        };
        NumericAngleAxis.prototype.getScaledAngle = function (a) {
            return this.getScaledAngle1(a, this.kl, this.cd);
        };
        NumericAngleAxis.prototype.eb = function (a, b) {
            return this.getUnscaledAngle(a);
        };
        NumericAngleAxis.prototype.getUnscaledAngle = function (a) {
            var b = (a - this.l9) / (2 * Math.PI);
            if (this.cc) {
                b = 1 - b;
            }
            if (this.kl) {
                return Math.exp(b * (this.k0 - this.k1) + this.k1);
            }
            else {
                return this.kv + b * (this.ku - this.kv);
            }
        };
        NumericAngleAxis.prototype.he = function (a, b, c, d) {
            var e_6, _a, e_7, _b, e_8, _c;
            _super.prototype.he.call(this, a, b, c, d);
            var e = i2.typeCast(XamDataChart.$, this.bh);
            switch (b) {
                case "CrossingAxis":
                    var f = i2.typeCast(NumericRadiusAxis.$, d);
                    this.mh(f);
                    if (f != null) {
                        f.mp(this);
                    }
                    this.hq(false);
                    break;
                case NumericAngleAxis.$$p[0]:
                    this.l9 = this.md;
                    while (this.l9 < 0) {
                        this.l9 += 360;
                    }
                    while (this.l9 >= 360) {
                        this.l9 -= 360;
                    }
                    this.l9 = (this.md * Math.PI) / 180;
                    this.hq(false);
                    try {
                        for (var _d = tslib.__values(i2.fromEnum(this.c4())), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var g = _e.value;
                            g.l0(false);
                            g.k7();
                        }
                    }
                    catch (e_6_1) {
                        e_6 = { error: e_6_1 };
                    }
                    finally {
                        try {
                            if (_e && !_e.done && (_a = _d.return))
                                _a.call(_d);
                        }
                        finally {
                            if (e_6)
                                throw e_6.error;
                        }
                    }
                    break;
                case "Label":
                    if (e != null) {
                        try {
                            for (var _f = tslib.__values(i2.fromEnum(e.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var h = _g.value;
                                h.hp();
                            }
                        }
                        catch (e_7_1) {
                            e_7 = { error: e_7_1 };
                        }
                        finally {
                            try {
                                if (_g && !_g.done && (_b = _f.return))
                                    _b.call(_f);
                            }
                            finally {
                                if (e_7)
                                    throw e_7.error;
                            }
                        }
                    }
                    break;
                case "CrossingValue":
                    if (e != null) {
                        try {
                            for (var _h = tslib.__values(i2.fromEnum(e.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                                var i = _j.value;
                                if (i2.typeCast(NumericAngleAxis.$, i) !== null || i2.typeCast(CategoryAngleAxis.$, i) !== null) {
                                    i.hp();
                                }
                            }
                        }
                        catch (e_8_1) {
                            e_8 = { error: e_8_1 };
                        }
                        finally {
                            try {
                                if (_j && !_j.done && (_c = _h.return))
                                    _c.call(_h);
                            }
                            finally {
                                if (e_8)
                                    throw e_8.error;
                            }
                        }
                    }
                    break;
                case "LabelSettings":
                    this.j6 = this.j4();
                    this.mf();
                    this.ck = true;
                    this.hq(false);
                    break;
            }
        };
        NumericAngleAxis.prototype.mf = function () {
            this.l8 = NaN;
        };
        NumericAngleAxis.prototype.j8 = function () {
            return new PolarAxisRenderingParameters();
        };
        NumericAngleAxis.prototype.j7 = function (a, b, c, d) {
            var e = i2.typeCast(PolarAxisRenderingParameters.$, _super.prototype.j7.call(this, a, b, c, d));
            var f = this.l6.f(b);
            var g = this.l6.g(b);
            var h = 0.5 * this.l5.ma;
            var i = 0.5 * this.l5.l9;
            var j = f;
            var k = g;
            var l = this.l5.mf();
            if (i2.isNaN_(l) || i2.isInfinity(l)) {
                return null;
            }
            if (k >= h) {
                k = l;
            }
            if (j < i) {
                j = i;
            }
            var m = a.width;
            this.l6.k(b, e, this.kv, this.ku, this.cc, i2.runOn(this, this.getUnscaledAngle), m);
            var n = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            e.center = n;
            e.maxLength = k;
            e.minLength = j;
            e.effectiveMaximum = l;
            return e;
        };
        NumericAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
            var d = this.l6.l(a, b, c);
            b = d.p1;
            c = d.p2;
            return {
                p1: b,
                p2: c
            };
        };
        NumericAngleAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = !b.isEmpty ? this.js : i2.Rect.empty;
            var d = this.jn();
            var e = this.jm();
            var f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        };
        Object.defineProperty(NumericAngleAxis.prototype, "l5", {
            get: function () {
                if (this.l4 != null) {
                    return this.l4;
                }
                var a = i2.typeCast(XamDataChart.$, this.bh);
                if (a != null) {
                    for (var b = 0; b < a.axes.count; b++) {
                        if (a.axes._inner[b].cg) {
                            return a.axes._inner[b];
                        }
                    }
                }
                return this.l4;
            },
            set: function (a) {
                this.l4 = a;
            },
            enumerable: false,
            configurable: true
        });
        NumericAngleAxis.prototype.aj = function () {
            return this.l5;
        };
        NumericAngleAxis.prototype.mh = function (a) {
            this.l5 = a;
        };
        NumericAngleAxis.prototype.h3 = function (a, b) {
            _super.prototype.h3.call(this, a, b);
            if (b.height != a.height || b.width != a.width) {
                this.cv();
            }
        };
        NumericAngleAxis.prototype.get_a1 = function () {
            return 2;
        };
        Object.defineProperty(NumericAngleAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        NumericAngleAxis.prototype.jk = function (a, b, c, d, e) {
            if (d === void 0) {
                d = null;
            }
            if (e === void 0) {
                e = null;
            }
            if (this.l5 == null) {
                return null;
            }
            var f = i2.typeCast(PolarAxisRenderingParameters.$, this.j7(c, b, d, e));
            if (f == null) {
                return null;
            }
            var g = Math.cos(a);
            var h = Math.sin(a);
            var i = f.center.x + g * f.minLength;
            var j = f.center.y + h * f.minLength;
            var k = f.center.x + g * f.maxLength;
            var l = f.center.y + h * f.maxLength;
            i = ViewportUtils.c(i, b, c);
            j = ViewportUtils.f(j, b, c);
            k = ViewportUtils.c(k, b, c);
            l = ViewportUtils.f(l, b, c);
            var m = new i2.LineGeometry();
            m.d = { $type: i2.Point_$type, x: i, y: j };
            m.c = { $type: i2.Point_$type, x: k, y: l };
            return m;
        };
        NumericAngleAxis.$t = i2.markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
        NumericAngleAxis.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, NumericAngleAxis, 'hk', ['StartAngleOffset:md:mi', [1, 0]]);
        return NumericAngleAxis;
    }(NumericAxisBase));
    /**
     * @hidden
     */
    var NumericRadiusAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericRadiusAxis, _super);
        function NumericRadiusAxis() {
            var _this = _super.call(this) || this;
            _this.l6 = null;
            _this.l7 = false;
            _this.l8 = NaN;
            _this.ma = 0;
            _this.l9 = 0;
            _this.mc = 0;
            _this.l3 = null;
            _this.ab = NumericRadiusAxis.$;
            _this.ma = _this.mk;
            _this.l9 = _this.mj;
            _this.l6 = new PolarAxisRenderingManager();
            _this.j6 = _this.j4();
            return _this;
        }
        NumericRadiusAxis.prototype.a3 = function () {
            return new NumericRadiusAxisView(this);
        };
        NumericRadiusAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.l5 = a;
        };
        NumericRadiusAxis.prototype.get_cg = function () {
            return true;
        };
        NumericRadiusAxis.prototype.d7 = function () {
            var a = this.ma;
            var b = this.l9;
            var c = Math.min(this.me(), this.md()) * (a - b) / 2;
            c = Math.max(c, 14);
            return c;
        };
        NumericRadiusAxis.prototype.me = function () {
            return this.js.width;
        };
        NumericRadiusAxis.prototype.md = function () {
            return this.js.height;
        };
        NumericRadiusAxis.prototype.au = function () {
            return new RadialAxisLabelPanel();
        };
        NumericRadiusAxis.prototype.mb = function (a) {
            if (a == null) {
                return 0;
            }
            return a;
        };
        NumericRadiusAxis.prototype.j4 = function () {
            var _this = this;
            var a = _super.prototype.j4.call(this);
            a.b.c = function (b) {
                if ((_this.ay == null || _this.ay.visibility == 0) && _this.l4 != null) {
                    if ((_this.ay == null || (_this.ay.c == 4 || _this.ay.c == 5)) && _this.l8 != b) {
                        _this.l8 = b;
                        _this.av.bc = b;
                        _this.bh.jq();
                    }
                }
            };
            a.k = function (b, c, d) {
                var e = i2.typeCast(PolarAxisRenderingParameters.$, b);
                _this.l6.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
            };
            a.l = function (b, c, d, e) {
                if (d == e) {
                    return;
                }
                var f = i2.typeCast(PolarAxisRenderingParameters.$, b);
                _this.l6.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
            };
            a.m = function (b, c) { return _this.mg(c); };
            a.q = function (b, c) {
                var d = i2.typeCast(PolarAxisRenderingParameters.$, b);
                return c <= d.effectiveMaximum;
            };
            a.n = function (b, c) {
                var d = i2.typeCast(PolarAxisRenderingParameters.$, b);
                return c <= d.effectiveMaximum;
            };
            a.j = function (b) {
                var c = i2.typeCast(PolarAxisRenderingParameters.$, b);
                _this.l6.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
            };
            a.e = function (b) {
                b.n = _this.ay == null || (_this.ay.c == 4 || _this.ay.c == 0) ? b.z.top : b.z.bottom;
                b.r = b.n;
                var c = i2.typeCast(PolarAxisRenderingParameters.$, b);
                c.crossingAngleRadians = (_this.mb(_this.fe) * Math.PI) / 180;
                if (_this.ay == null || (_this.ay.c == 4 || _this.ay.c == 5)) {
                    c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                    c.r = c.n;
                    var d = i2.typeCast(RadialAxisLabelPanel.$, _this.av);
                    if (d != null) {
                        var e = 0;
                        if (_this.ay != null && _this.ay.c == 4) {
                            e = 1;
                        }
                        d.dq = { $type: i2.Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                        d.dm = c.crossingAngleRadians;
                    }
                }
            };
            a.p = function (b, c, d) {
                var e = i2.typeCast(PolarAxisRenderingParameters.$, b);
                if (_this.l4 == null) {
                    return false;
                }
                if (c > e.effectiveMaximum) {
                    return false;
                }
                var f = false;
                f = _this.ay == null || (_this.ay.c == 4 || _this.ay.c == 5);
                var g = 0;
                if (f) {
                    g = _this.mc;
                }
                var h = e.center.x + c * Math.cos(g);
                var i = e.center.y + c * Math.sin(g);
                h = ViewportUtils.c(h, e.aa, e.z);
                i = ViewportUtils.f(i, e.aa, e.z);
                if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                    return true;
                }
                return false;
            };
            a.h = function (b, c) {
                var d = i2.typeCast(PolarAxisRenderingParameters.$, b);
                return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
            };
            a.r = function (b, c, d, e) {
                if (c < b.m) {
                    return b.m;
                }
                else if (c > b.l) {
                    return b.l;
                }
                return c;
            };
            return a;
        };
        NumericRadiusAxis.prototype.d8 = function (a, b) {
            return this.mg(a);
        };
        NumericRadiusAxis.prototype.mh = function (a, b, c, d, e) {
            var f = 0;
            if (b) {
                if (a <= 0) {
                    f = (Math.log(this.kv) - this.k1) / (this.k0 - this.k1);
                }
                else {
                    f = (Math.log(a) - this.k1) / (this.k0 - this.k1);
                }
            }
            else {
                f = (a - this.kv) / (this.ku - this.kv);
            }
            if (c) {
                f = 1 - f;
            }
            f = e + (f * (d - e));
            f /= 2;
            return f;
        };
        NumericRadiusAxis.prototype.mg = function (a) {
            return this.mh(a, this.kl, this.cd, this.ma, this.l9);
        };
        NumericRadiusAxis.prototype.mi = function (a) {
            var b = a * 2;
            b = (b - this.l9) / (this.ma - this.l9);
            if (this.cc) {
                b = 1 - b;
            }
            if (this.kl) {
                return Math.exp(b * (this.k0 - this.k1) + this.k1);
            }
            else {
                return this.kv + b * (this.ku - this.kv);
            }
        };
        NumericRadiusAxis.prototype.eb = function (a, b) {
            return this.mi(a);
        };
        NumericRadiusAxis.prototype.he = function (a, b, c, d) {
            var e_9, _a, e_10, _b;
            switch (b) {
                case "CrossingValue":
                    this.mc = this.mb(this.fe) * Math.PI / 180;
                    break;
            }
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case NumericRadiusAxis.$$p[1]:
                    this.ma = this.mk;
                    if (this.ma < 0) {
                        this.ma = 0.1;
                    }
                    if (this.ma > 1) {
                        this.ma = 1;
                    }
                    if (this.l9 >= this.ma) {
                        this.l9 = this.ma - 0.01;
                        if (this.l9 < 0) {
                            this.l9 = 0;
                            this.ma = 0.01;
                        }
                    }
                    this.ck = true;
                    this.hq(false);
                    if (this.l4 != null) {
                        this.l4.hp();
                    }
                    try {
                        for (var _c = tslib.__values(i2.fromEnum(this.c4())), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var e = _d.value;
                            e.l0(false);
                        }
                    }
                    catch (e_9_1) {
                        e_9 = { error: e_9_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_9)
                                throw e_9.error;
                        }
                    }
                    break;
                case NumericRadiusAxis.$$p[0]:
                    this.l9 = this.mj;
                    if (this.l9 < 0) {
                        this.l9 = 0.1;
                    }
                    if (this.l9 > 1) {
                        this.l9 = 1;
                    }
                    if (this.l9 >= this.ma) {
                        this.l9 = this.ma - 0.01;
                        if (this.l9 < 0) {
                            this.l9 = 0;
                            this.ma = 0.01;
                        }
                    }
                    this.ck = true;
                    this.hq(false);
                    if (this.l4 != null) {
                        this.l4.hp();
                    }
                    try {
                        for (var _e = tslib.__values(i2.fromEnum(this.c4())), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var f = _f.value;
                            f.et = true;
                            f.l0(false);
                        }
                    }
                    catch (e_10_1) {
                        e_10 = { error: e_10_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_10)
                                throw e_10.error;
                        }
                    }
                    if (this.bh != null) {
                        this.bh.jz();
                    }
                    break;
                case "CrossingAxis":
                    var g = i2.typeCast(NumericAngleAxis.$, d);
                    var h = i2.typeCast(CategoryAngleAxis.$, d);
                    if (g == null && h == null) {
                        this.mp(null);
                    }
                    if (g != null) {
                        this.mp(g);
                        g.mh(this);
                    }
                    if (h != null) {
                        this.mp(h);
                        h.mj(this);
                    }
                    this.ck = true;
                    this.hq(false);
                    break;
                case "IsInverted":
                    if (this.l4 != null) {
                        this.l4.ck = true;
                        this.l4.hq(false);
                    }
                    break;
            }
        };
        NumericRadiusAxis.prototype.mp = function (a) {
            this.l4 = a;
        };
        Object.defineProperty(NumericRadiusAxis.prototype, "l4", {
            get: function () {
                if (this.l3 != null) {
                    return this.l3;
                }
                var a = i2.typeCast(XamDataChart.$, this.bh);
                if (a != null) {
                    for (var b = 0; b < a.axes.count; b++) {
                        if (i2.typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || i2.typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                            return a.axes._inner[b];
                        }
                    }
                }
                return this.l3;
            },
            set: function (a) {
                this.l3 = a;
            },
            enumerable: false,
            configurable: true
        });
        NumericRadiusAxis.prototype.aj = function () {
            return this.l4;
        };
        NumericRadiusAxis.prototype.j8 = function () {
            return new PolarAxisRenderingParameters();
        };
        NumericRadiusAxis.prototype.j7 = function (a, b, c, d) {
            var e = i2.typeCast(PolarAxisRenderingParameters.$, _super.prototype.j7.call(this, a, b, c, d));
            var f = this.l6.f(b);
            var g = this.l6.g(b);
            var h = 0.5 * this.ma;
            var i = 0.5 * this.l9;
            var j, k;
            if (i2.Rect.l_op_Equality(b, SeriesViewer.ps)) {
                k = this.ku;
                j = this.kv;
            }
            else {
                k = Math.min(g, h);
                j = this.mi(f);
                k = this.mi(k);
                var l = this.mq(a, b, j, k);
                j = l.p2;
                k = l.p3;
            }
            var m = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            var n = f;
            var o = g;
            var p = Math.min(a.width, a.height) * (this.ma - this.l9) / 2;
            e.center = m;
            var q = Math.max(o, n);
            var r = Math.min(n, o);
            e.maxLength = q;
            e.minLength = r;
            var s = Math.min(j, k);
            var t = Math.max(j, k);
            if (s < this.kv) {
                s = this.kv;
            }
            if (t > this.ku) {
                t = this.ku;
            }
            this.ky = s;
            this.kx = t;
            e.k.add(((function () {
                var $ret = new RangeInfo();
                $ret.d = s;
                $ret.c = t;
                $ret.b = p;
                return $ret;
            })()));
            var u = i2.typeCast(IAngleScaler_$type, this.l4);
            if (u != null) {
                var v = void 0;
                var w = void 0;
                var x = u.getMinMaxAngle(b, v, w);
                v = x.p1;
                w = x.p2;
                e.minAngle = Math.min(v, w);
                e.maxAngle = Math.max(v, w);
            }
            var y = this.mf();
            if (o >= h) {
                o = y;
            }
            if (n < i) {
                n = i;
            }
            e.minLength = n;
            e.maxLength = o;
            e.effectiveMaximum = y;
            e.f = this.kb;
            var z = i2.typeCast(LinearTickmarkValues.$, e.f);
            if (z != null) {
                z.y = this.ml(m, e.minLength, e.maxLength, b, a);
            }
            return e;
        };
        NumericRadiusAxis.prototype.mq = function (a, b, c, d) {
            var e = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            var f = 0;
            if (this.cc) {
                f = this.mg(this.kv);
            }
            else {
                f = this.mg(this.ku);
            }
            var g = 0;
            if (this.fe != null) {
                g = this.mc;
            }
            var h = e.x + f * Math.cos(g);
            var i = e.y + f * Math.sin(g);
            e.x = ViewportUtils.c(e.x, b, a);
            e.y = ViewportUtils.f(e.y, b, a);
            h = ViewportUtils.c(h, b, a);
            i = ViewportUtils.f(i, b, a);
            if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
                if (this.cc) {
                    d = this.kv;
                }
                else {
                    d = this.ku;
                }
            }
            if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
                if (this.cc) {
                    c = this.ku;
                }
                else {
                    c = this.kv;
                }
            }
            return {
                p2: c,
                p3: d
            };
        };
        NumericRadiusAxis.prototype.ml = function (a, b, c, d, e) {
            var f = ViewportUtils.d(c - b, d, e);
            var g = f / Math.min(e.width, e.height);
            if (g > 0.7) {
                return 10;
            }
            return 5;
        };
        NumericRadiusAxis.prototype.mf = function () {
            var a = 0;
            if (!this.cc) {
                a = this.mg(this.ku);
            }
            else {
                a = this.mg(this.kv);
            }
            return a;
        };
        NumericRadiusAxis.prototype.lt = function (a) {
            if (this.l4 != null) {
                this.l4.hp();
            }
        };
        NumericRadiusAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = !b.isEmpty ? this.js : i2.Rect.empty;
            var d = this.jn();
            var e = this.jm();
            var f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        };
        NumericRadiusAxis.prototype.h3 = function (a, b) {
            _super.prototype.h3.call(this, a, b);
            if (b.height != a.height || b.width != a.width) {
                this.cv();
            }
        };
        NumericRadiusAxis.prototype.mo = function (a, b, c, d, e) {
            var f = i2.typeCast(IPolarRadialRenderingParameters_$type, this.j7(b, c, d, e));
            if (f == null) {
                return;
            }
            this.l6.j(a.d, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
        };
        NumericRadiusAxis.prototype.get_a1 = function () {
            return 3;
        };
        Object.defineProperty(NumericRadiusAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        NumericRadiusAxis.prototype.jk = function (a, b, c, d, e) {
            if (d === void 0) {
                d = null;
            }
            if (e === void 0) {
                e = null;
            }
            var f = i2.typeCast(PolarAxisRenderingParameters.$, this.j7(c, b, d, e));
            var g = a;
            var h = new i2.PathGeometry();
            var i = ViewportUtils.d(g, b, c);
            var j = ViewportUtils.g(g, b, c);
            if (i <= 0 || j <= 0) {
                return null;
            }
            var k = ViewportUtils.c(f.center.x, b, c);
            var l = ViewportUtils.f(f.center.y, b, c);
            if (f.maxAngle - f.minAngle < Math.PI && f.maxAngle - f.minAngle > 0) {
                var m = { $type: i2.Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.minAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.minAngle), b, c) };
                var n_1 = { $type: i2.Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.maxAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.maxAngle), b, c) };
                var o = new i2.PathFigure();
                o._startPoint = m;
                o._isClosed = false;
                o._segments.add(((function () {
                    var $ret = new i2.ArcSegment();
                    $ret.b = false;
                    $ret.e = n_1;
                    $ret.f = new i2.Size(1, i, j);
                    $ret.d = 1;
                    return $ret;
                })()));
                h.c.add(o);
            }
            else {
                var p = new i2.PathFigure();
                p._startPoint = { $type: i2.Point_$type, x: k, y: l - j };
                p._isClosed = true;
                p._segments.add(((function () {
                    var $ret = new i2.ArcSegment();
                    $ret.b = false;
                    $ret.e = { $type: i2.Point_$type, x: k, y: l + j };
                    $ret.f = new i2.Size(1, i, j);
                    $ret.d = 1;
                    return $ret;
                })()));
                p._segments.add(((function () {
                    var $ret = new i2.ArcSegment();
                    $ret.b = false;
                    $ret.e = { $type: i2.Point_$type, x: k, y: l - j };
                    $ret.f = new i2.Size(1, i, j);
                    $ret.d = 1;
                    return $ret;
                })()));
                h.c.add(p);
            }
            return h;
        };
        NumericRadiusAxis.$t = i2.markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
        NumericRadiusAxis.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, NumericRadiusAxis, 'hk', ['InnerRadiusExtentScale:mj:mr', [1, 0], 'RadiusExtentScale:mk:ms', [1, 0.75]]);
        return NumericRadiusAxis;
    }(NumericAxisBase));
    /**
     * @hidden
     */
    var AngleAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AngleAxisLabelPanelView, _super);
        function AngleAxisLabelPanelView(a) {
            var _this = _super.call(this, a) || this;
            _this.ax = null;
            _this.ax = a;
            return _this;
        }
        AngleAxisLabelPanelView.prototype.am = function () {
            _super.prototype.am.call(this);
            this.ax.c2 = true;
        };
        AngleAxisLabelPanelView.prototype.ay = function (a, b) {
            this.ax.c6 = -1.7976931348623157E+308;
            this.ax.c3 = -1.7976931348623157E+308;
            this.ax.c5 = -1.7976931348623157E+308;
            this.ax.c4 = -1.7976931348623157E+308;
            for (var c = 0; c < this.a.a7.count; c++) {
                var d = this.a.a7._inner[c];
                var e = this.a.a6._inner[c];
                var f = e.a;
                var g = this.ax.c8(e.c);
                var h = this.m(d);
                var i = this.l(d);
                var j = h + this.p() + this.q();
                var k = i + this.r() + this.o();
                var l = g.x - j / 2;
                var m = g.y - k / 2;
                this.ax.c5 = Math.max(h, this.ax.c5);
                this.ax.c4 = Math.max(i, this.ax.c4);
                this.ax.c6 = Math.max(j, this.ax.c6);
                this.ax.c3 = Math.max(k, this.ax.c3);
                var n = new i2.Rect(0, l, m, j, k);
                a.add(n);
                b.add(f);
            }
        };
        AngleAxisLabelPanelView.prototype.o = function () {
            return 0;
        };
        AngleAxisLabelPanelView.prototype.p = function () {
            return 0;
        };
        AngleAxisLabelPanelView.prototype.q = function () {
            return 0;
        };
        AngleAxisLabelPanelView.prototype.r = function () {
            return 0;
        };
        AngleAxisLabelPanelView.$t = i2.markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
        return AngleAxisLabelPanelView;
    }(AxisLabelPanelBaseView));
    /**
     * @hidden
     */
    var CategoryAngleAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryAngleAxisView, _super);
        function CategoryAngleAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        CategoryAngleAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.jb = AxisDefaults.h;
            this.a.je = AxisDefaults.g;
        };
        CategoryAngleAxisView.$t = i2.markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
        return CategoryAngleAxisView;
    }(CategoryAxisBaseView));
    /**
     * @hidden
     */
    var NumericAngleAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericAngleAxisView, _super);
        function NumericAngleAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        NumericAngleAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.jb = AxisDefaults.h;
            this.a.je = AxisDefaults.g;
        };
        NumericAngleAxisView.$t = i2.markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
        return NumericAngleAxisView;
    }(NumericAxisBaseView));
    /**
     * @hidden
     */
    var NumericRadiusAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericRadiusAxisView, _super);
        function NumericRadiusAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        NumericRadiusAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.jb = AxisDefaults.h;
            this.a.je = AxisDefaults.g;
        };
        NumericRadiusAxisView.$t = i2.markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
        return NumericRadiusAxisView;
    }(NumericAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories.
    *
    * `IgxCategoryAngleAxisComponent` represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="dataSource"   >
    *     <igx-category-angle-axis name="angleAxis" label="Department" />
    *     <igx-numeric-radius-axis name="radiusAxis" />
    *  </igx-data-chart>
    * ```
    */
    var IgxCategoryAngleAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryAngleAxisComponent, _super);
        function IgxCategoryAngleAxisComponent() {
            var _this = _super.call(this) || this;
            _this._actualIntervalChange = null;
            return _this;
        }
        IgxCategoryAngleAxisComponent.prototype.createImplementation = function () {
            return new CategoryAngleAxis();
        };
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "isAngular", {
            /**
             * Checks if the axis is of angular type
            */
            get: function () {
                return this.i.b4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "startAngleOffset", {
            /**
             * Indicates the angle in degress that the chart's 0th angle should be offset.
            *
            * Indicates the angle in degress that the chart's 0th angle should be offset.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="dataSource"   >
            *     <igx-category-angle-axis name="angleAxis" startAngleOffset=30/>
            *     <igx-numeric-radius-axis name="radiusAxis" />
            *  </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.l9;
            },
            set: function (v) {
                this.i.l9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "interval", {
            /**
             * Gets or sets the frequency of displayed labels.
             * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
            *
            * Gets or sets the frequency of displayed labels.The set value is a factor that determines which labels will be hidden.
            * For example, an interval of 2 will display every other label.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="dataSource"   >
            *     <igx-category-angle-axis name="angleAxis" interval =2 />
            *     <igx-numeric-radius-axis name="radiusAxis" />
            *  </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.l6;
            },
            set: function (v) {
                this.i.l6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "actualInterval", {
            /**
             * Gets the effective value for the current Interval.
            *
            * Gets the effective value for the current Interval.
            */
            get: function () {
                return this.i.l0;
            },
            set: function (v) {
                this.i.l0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "minorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines.
             * The set value is a factor that determines how the minor lines will be displayed.
            *
            * Gets or sets the frequency of displayed minor lines. The set value is a factor that determines how the minor lines will be displayed.
            */
            get: function () {
                return this.i.l7;
            },
            set: function (v) {
                this.i.l7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "actualMinorInterval", {
            /**
             * Gets the effective value for the current MinorInterval.
            *
            * Get the effective value for the current minorInterval.
            */
            get: function () {
                return this.i.l1;
            },
            set: function (v) {
                this.i.l1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Gets the scaled angle in radians from the raw axis value.
        
        * @param unscaledAngle  * The raw axis value.
        */
        IgxCategoryAngleAxisComponent.prototype.getScaledAngle = function (unscaledAngle) {
            var iv = this.i.getScaledAngle(unscaledAngle);
            return (iv);
        };
        /**
         * Gets the raw axis value from the scaled angle in radians.
        
        */
        IgxCategoryAngleAxisComponent.prototype.getUnscaledAngle = function (scaledAngle) {
            var iv = this.i.getUnscaledAngle(scaledAngle);
            return (iv);
        };
        Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "actualIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualIntervalChange == null) {
                    this._actualIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualInterval;
                        if (_this.beforeActualIntervalChange) {
                            _this.beforeActualIntervalChange(_this, ext);
                        }
                        _this._actualIntervalChange.emit(ext);
                    });
                }
                return this._actualIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryAngleAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryAngleAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryAngleAxisComponent, selector: "igx-category-angle-axis", inputs: { startAngleOffset: "startAngleOffset", interval: "interval", actualInterval: "actualInterval", minorInterval: "minorInterval", actualMinorInterval: "actualMinorInterval" }, outputs: { actualIntervalChange: "actualIntervalChange" }, providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryAngleAxisComponent;
    }(IgxCategoryAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-angle-axis',
                        template: "",
                        providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { startAngleOffset: [{
                    type: i0.Input
                }], interval: [{
                    type: i0.Input
                }], actualInterval: [{
                    type: i0.Input
                }], minorInterval: [{
                    type: i0.Input
                }], actualMinorInterval: [{
                    type: i0.Input
                }], actualIntervalChange: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryAngleAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryAngleAxisModule() {
        }
        IgxCategoryAngleAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryAngleAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisModule, declarations: [IgxCategoryAngleAxisComponent], imports: [i1.CommonModule], exports: [IgxCategoryAngleAxisComponent] });
        IgxCategoryAngleAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisModule, imports: [[i1.CommonModule]] });
        return IgxCategoryAngleAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryAngleAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCategoryAngleAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryAngleAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryAngleAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryAngleAxisComponent", IgxCategoryAngleAxisComponent);
            i2.TypeRegistrar.register("CategoryAngleAxis", CategoryAngleAxis.$type);
        }
        IgxCategoryAngleAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryAngleAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisDynamicModule, imports: [i1.CommonModule, IgxCategoryAngleAxisModule], exports: [IgxCategoryAngleAxisModule] });
        IgxCategoryAngleAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisDynamicModule, imports: [[i1.CommonModule, IgxCategoryAngleAxisModule], IgxCategoryAngleAxisModule] });
        return IgxCategoryAngleAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryAngleAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryAngleAxisModule],
                        exports: [IgxCategoryAngleAxisModule],
                        entryComponents: [IgxCategoryAngleAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SortedListView$1 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SortedListView$1, _super);
        function SortedListView$1($t, a, b) {
            var _this = _super.call(this) || this;
            _this.$t = null;
            _this.c = null;
            _this.d = null;
            _this.$t = $t;
            _this.$type = _this.$type.specialize(_this.$t);
            _this.c = b;
            _this.d = a;
            return _this;
        }
        SortedListView$1.prototype.add = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SortedListView$1.prototype.clear = function () {
            throw new i2.NotImplementedException(0);
        };
        SortedListView$1.prototype.contains = function (a) {
            return this.d.contains(a);
        };
        SortedListView$1.prototype.indexOf = function (a) {
            return this.c.indexOf(this.d.indexOf(a));
        };
        SortedListView$1.prototype.insert = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        Object.defineProperty(SortedListView$1.prototype, "a", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SortedListView$1.prototype, "isReadOnly", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        SortedListView$1.prototype.remove = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SortedListView$1.prototype.removeAt = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SortedListView$1.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                throw new i2.NotImplementedException(0);
                return b;
            }
            else {
                return this.d.item(this.c.item(a));
            }
        };
        Object.defineProperty(SortedListView$1.prototype, "count", {
            get: function () {
                return this.d.count;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SortedListView$1.prototype, "b", {
            get: function () {
                throw new i2.NotImplementedException(0);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SortedListView$1.prototype, "e", {
            get: function () {
                throw new i2.NotImplementedException(0);
            },
            enumerable: false,
            configurable: true
        });
        SortedListView$1.prototype._getEnumeratorObject = function () {
            var a;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        a = 0;
                        _a.label = 1;
                    case 1:
                        if (!(a < this.count))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, i2.getBoxIfEnum(this.$t, this.item(a))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        a++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        SortedListView$1.prototype.getEnumeratorObject = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._getEnumeratorObject(); }).getEnumeratorObject();
        };
        SortedListView$1.prototype._getEnumerator = function () {
            var a;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        a = 0;
                        _a.label = 1;
                    case 1:
                        if (!(a < this.count))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, this.item(a)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        a++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        SortedListView$1.prototype.getEnumerator = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._getEnumerator(); }).getEnumerator();
        };
        SortedListView$1.prototype.copyTo = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        SortedListView$1.$t = i2.markType(SortedListView$1, 'SortedListView$1', i2.Base.$, [i2.IList$1_$type.specialize(0)]);
        return SortedListView$1;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisBase, _super);
        function TimeAxisBase() {
            var _this = _super.call(this) || this;
            _this.ln = null;
            _this.lw = null;
            _this.lr = false;
            _this.lz = i2.dateMaxValue();
            _this.ly = i2.dateMinValue();
            i2.FastItemDateTimeColumn.o();
            return _this;
        }
        TimeAxisBase.prototype.d8 = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.l4(a, NumericScaler.ac, b.c, i2.Rect.empty);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.l4(a, b.e, b.d, b.c);
        };
        TimeAxisBase.prototype.fg = function (a, b) {
            var c = this.gb(b);
            if (c == this.dateTimeMemberPath) {
                return this.fh(a, b, this.dateTimeMemberPath);
            }
            return _super.prototype.fg.call(this, a, b);
        };
        TimeAxisBase.prototype.l4 = function (a, b, c, d) {
            var e;
            if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
                e = -1;
            }
            else {
                e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            }
            var f = 0;
            if (this.categoryMode == 2) {
                f = this.getGroupCenter(0, b, c, d);
            }
            if (this.cc) {
                e = 1 - e;
                f = -f;
            }
            return c.left + c.width * (e - b.left) / b.width - f;
        };
        TimeAxisBase.prototype.l5 = function (a, b, c) {
            var d;
            if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
                d = -1;
            }
            else {
                d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            }
            var e = 0;
            if (this.cc) {
                d = 1 - d;
                e = -e;
            }
            return c.left + c.width * (d - b.left) / b.width - e;
        };
        TimeAxisBase.prototype.eb = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.d.left;
                var d = b.d.width;
                if (this.categoryMode != 0) {
                    var e = this.getCategorySize(b.e, b.d, b.c);
                    c += e / 2;
                    d -= e;
                }
                var f = b.e.left + b.e.width * (a - c) / b.d.width;
                f = (f * b.d.width) + b.d.left;
                f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
                return f;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        };
        TimeAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
            var e = b.left + b.width * (a - c.left) / c.width;
            if (this.cc) {
                e = 1 - e;
            }
            return i2.truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
        };
        TimeAxisBase.prototype.i$h = function () {
            this.mk();
        };
        TimeAxisBase.prototype.mk = function () {
            var a = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var b = !a.isEmpty ? this.js : i2.Rect.empty;
            var c = (new Date());
            var d = (new Date());
            var e = false;
            if (!a.isEmpty && !b.isEmpty && this.lo != null) {
                var f = i2.typeCast(i2.FastItemDateTimeColumn.$, this.lo);
                if (f != null) {
                    if (this.lx == null) {
                        this.ml();
                    }
                }
                else {
                    this.lx = null;
                }
                if (this.lo.count > 0) {
                    e = true;
                    var g = this.lx == null ? 0 : this.lx._inner[0];
                    var h = this.lx == null ? this.lo.count - 1 : this.lx._inner[this.lo.count - 1];
                    c = this.lo.item(g);
                    d = this.lo.item(h);
                    this.ls = false;
                    if (this.categoryMode == 2) {
                        var i = this.mi(c, d);
                        if (+c != +(i2.dateMinValue())) {
                            c = i2.dateSubtract(+c, +i);
                        }
                        d = i2.dateAdd(+d, +i);
                    }
                }
            }
            if (this.lv()) {
                e = true;
                c = this.minimumValue;
            }
            if (this.lu()) {
                e = true;
                d = this.maximumValue;
            }
            var j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
            if (e && j) {
                var k = this.actualMinimumValue;
                var l = this.actualMaximumValue;
                this.actualMinimumValue = c;
                this.actualMaximumValue = d;
                this.mp();
            }
        };
        TimeAxisBase.prototype.mp = function () {
        };
        Object.defineProperty(TimeAxisBase.prototype, "lo", {
            get: function () {
                return this.ln;
            },
            set: function (a) {
                if (this.ln != a) {
                    var b = this.ln;
                    this.ln = a;
                    this.hk("DateTimeColumn", b, this.ln);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisBase.prototype, "lx", {
            get: function () {
                return this.lw;
            },
            set: function (a) {
                this.lw = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisBase.prototype, "i$b", {
            get: function () {
                if (this.lx == null) {
                    var a = i2.typeCast(i2.FastItemDateTimeColumn.$, this.lo);
                    if (a != null) {
                        this.ml();
                    }
                    else {
                        this.lx = null;
                    }
                }
                return this.lx;
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.prototype.ml = function () {
            if (this.lt) {
                this.lx = new i2.List$1(i2.Number_$type, 0);
                var a = this.lx;
                var b = this.lo.count;
                for (var c = 0; c < b; c++) {
                    a.add(c);
                }
            }
            else {
                var d = i2.typeCast(i2.FastItemDateTimeColumn.$, this.lo);
                this.lx = d.h();
            }
        };
        TimeAxisBase.prototype.i$e = function (a, b, c, d) {
            return this.l7(a, b, c, d);
        };
        TimeAxisBase.prototype.l7 = function (a, b, c, d) {
            if (b.isEmpty) {
                return -1;
            }
            var e = d;
            var f = new ScalerParams(0, a, b, this.cc, c);
            var g, h;
            if (this.cc) {
                h = this.eb(e.left, f);
                g = this.eb(e.right, f);
            }
            else {
                g = this.eb(e.left, f);
                h = this.eb(e.right, f);
            }
            var i = Math.max(i2.dateMinValue().getTime(), Math.min(i2.dateMaxValue().getTime(), i2.truncate(g)));
            return this.l6(i2.dateFromTicks(i));
        };
        TimeAxisBase.prototype.l6 = function (a) {
            if (this.lo == null || this.lx.count != this.lo.count) {
                return -1;
            }
            var b = new SortedListView$1(i2.Date_$type, this.lo, this.lx);
            var c = this.l8(a, b);
            if (c >= 0 && c < this.lx.count) {
                var d = this.lo.item(this.lx._inner[c]);
                if (d > a) {
                    c--;
                    if (c < 0) {
                        c = 0;
                    }
                }
                return c;
            }
            return this.lx.count - 1;
        };
        TimeAxisBase.prototype.i$g = function (a, b, c, d) {
            return this.ma(a, b, c, d);
        };
        TimeAxisBase.prototype.ma = function (a, b, c, d) {
            if (b.isEmpty) {
                return -1;
            }
            var e = d;
            var f = new ScalerParams(0, a, b, this.cc, c);
            var g, h;
            if (this.cc) {
                h = this.eb(e.left, f);
                g = this.eb(e.right, f);
            }
            else {
                g = this.eb(e.left, f);
                h = this.eb(e.right, f);
            }
            var i = Math.max(i2.dateMinValue().getTime(), Math.min(i2.dateMaxValue().getTime(), i2.truncate(h)));
            return this.l9(i2.dateFromTicks(i));
        };
        TimeAxisBase.prototype.l9 = function (a) {
            if (this.lo == null || this.lx.count != this.lo.count) {
                return -1;
            }
            var b = new SortedListView$1(i2.Date_$type, this.lo, this.lx);
            var c = this.l8(a, b);
            if (c >= this.lx.count) {
                c = this.lx.count - 1;
            }
            if (c >= 0 && c < this.lx.count) {
                var d = this.lo.item(this.lx._inner[c]);
                if (d < a) {
                    c++;
                    if (c > this.lx.count - 1) {
                        c = this.lx.count - 1;
                    }
                }
                return c;
            }
            return 0;
        };
        TimeAxisBase.prototype.i$d = function (a) {
            if (this.lo == null) {
                return NaN;
            }
            var b = this.ln.item(a);
            var c = b.getTime();
            var d = c;
            return d;
        };
        TimeAxisBase.prototype.i$c = function (a) {
            var b = this;
            if (b.i$b == null) {
                return -1;
            }
            var c = new SortedListView$1(i2.Date_$type, this.lo, b.i$b);
            var ticks_ = a;
            var d = (new Date(ticks_));
            var e = this.l8(d, c);
            if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
                var diff1_ = d.getTime() - c.item(e - 1).getTime();
                var diff2_ = c.item(e).getTime() - d.getTime();
                var f = e - 1;
                var g = e;
                if (f < 0 && g >= 0) {
                    return g;
                }
                if (g > b.i$b.count - 1 && f < b.i$b.count) {
                    return f;
                }
                if (f < 0 && g < 0) {
                    return -1;
                }
                if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                    return -1;
                }
                var h = diff1_ / (diff1_ + diff2_);
                if (i2.isNaN_(h)) {
                    h = 0;
                }
                return f + h;
            }
            if (e >= 0 && e < b.i$b.count) {
                return e;
            }
            var i = this.jn();
            if (e == b.i$b.count && this.bh != null && this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, i)) < (this.js.right + 2)) {
                return e - 1;
            }
            if (e == -1 && this.bh != null && Math.abs(this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, i)) - this.js.left) < 2) {
                return 0;
            }
            return -1;
        };
        TimeAxisBase.prototype.l8 = function (a, b) {
            var c = this;
            if (this.lo == null || c.i$b == null) {
                return -1;
            }
            var d = -1;
            var e = i2.ArrayExtension.binarySearch$11(i2.Date_$type, b, function (f) {
                if (a < f) {
                    return -1;
                }
                if (a > f) {
                    return 1;
                }
                return 0;
            });
            if (e >= 0) {
                d = e;
            }
            else {
                d = ~e;
            }
            while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
                d--;
            }
            return d;
        };
        TimeAxisBase.prototype.i$f = function (a) {
            var b = this;
            if (b.i$b == null || this.lo == null || b.i$b.count != this.lo.count) {
                return -1;
            }
            var c = new SortedListView$1(i2.Date_$type, this.lo, b.i$b);
            var ticks_ = a;
            var d = (new Date(ticks_));
            var e = this.l8(d, c);
            var f = this.jn();
            if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
                var g = +d - +(c.item(e - 1));
                var h = +(c.item(e)) - +d;
                if (g < h) {
                    e = e - 1;
                }
            }
            if (e >= 0 && e < b.i$b.count) {
                return b.i$b._inner[e];
            }
            if (e == b.i$b.count && this.bh != null && this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, f)) < (this.js.right + 2)) {
                return e - 1;
            }
            if (e == -1 && this.bh != null && Math.abs(this.d8(a, new ScalerParams(0, this.bh.pg, this.js, this.cc, f)) - this.js.left) < 2) {
                return 0;
            }
            return -1;
        };
        TimeAxisBase.prototype.i$i = function () {
            this.lx = null;
            this.hp();
        };
        TimeAxisBase.prototype.get_ls = function () {
            return this.lr;
        };
        TimeAxisBase.prototype.set_ls = function (a) {
            this.lr = a;
        };
        Object.defineProperty(TimeAxisBase.prototype, "ls", {
            get: function () {
                return this.get_ls();
            },
            set: function (a) {
                this.set_ls(a);
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.prototype.hg = function (a) {
            _super.prototype.hg.call(this, a);
            this.dateTimeMemberPath = a;
        };
        TimeAxisBase.prototype.hj = function (a) {
            _super.prototype.hj.call(this, a);
            this.minimumValue = a;
        };
        TimeAxisBase.prototype.hi = function (a) {
            _super.prototype.hj.call(this, a);
            this.maximumValue = a;
        };
        TimeAxisBase.prototype.cx = function () {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            var a = this.actualMinimumValue.getTime();
            var b = this.actualMaximumValue.getTime();
            this.mk();
            var c = !this.lv() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
            var d = !this.lu() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
            var e = new AxisRangeChangedEventArgs(0, a, c, b, d);
            this.hl(e);
            return true;
        };
        TimeAxisBase.prototype.lv = function () {
            if (+(this.minimumValue) == +(i2.dateMinValue())) {
                return false;
            }
            return (this.minimumValue != null);
        };
        TimeAxisBase.prototype.lu = function () {
            if (+(this.maximumValue) == +(i2.dateMaxValue())) {
                return false;
            }
            return (this.maximumValue != null);
        };
        Object.defineProperty(TimeAxisBase.prototype, "actualMinimumValue", {
            get: function () {
                return this.lz;
            },
            set: function (a) {
                var b = +(this.lz) != +a;
                if (b) {
                    var c = this.lz;
                    this.lz = a;
                    this.hk("ActualMinimumValue", c, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.prototype.fl = function () {
            return this.actualMinimumValue;
        };
        Object.defineProperty(TimeAxisBase.prototype, "actualMaximumValue", {
            get: function () {
                return this.ly;
            },
            set: function (a) {
                var b = +(this.ly) != +a;
                if (b) {
                    var c = this.ly;
                    this.ly = a;
                    this.hk("ActualMaximumValue", c, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.prototype.fk = function () {
            return this.maximumValue;
        };
        TimeAxisBase.prototype.mm = function (a) {
            var e_1, _a;
            this.hr(a);
            if (this.j6 == null) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.l0(a);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        TimeAxisBase.prototype.he = function (a, b, c, d) {
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    var e = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.lo);
                        this.lo = null;
                        e.event = i2.delegateRemove(e.event, i2.runOn(this, this.mj));
                    }
                    var f = i2.typeCast(i2.IFastItemsSource_$type, d);
                    if (f != null) {
                        this.lx = null;
                        this.lo = this.lp(this.dateTimeMemberPath);
                        f.event = i2.delegateCombine(f.event, i2.runOn(this, this.mj));
                    }
                    this.mm(false);
                    break;
                case TimeAxisBase.$$p[0]:
                    if (this.j6 != null) {
                        this.j6.deregisterColumn(this.lo);
                        this.lo = this.lp(this.dateTimeMemberPath);
                        this.lx = null;
                    }
                    break;
                case TimeAxisBase.$$p[3]:
                    this.cv();
                    this.mm(false);
                    break;
                case TimeAxisBase.$$p[2]:
                    this.cv();
                    this.mm(false);
                    break;
                case "DateTimeColumn":
                    this.mk();
                    break;
            }
        };
        TimeAxisBase.prototype.mj = function (a, b) {
            this.lx = null;
        };
        TimeAxisBase.prototype.lp = function (a) {
            return TimeAxisBase.lq(a, this);
        };
        TimeAxisBase.lq = function (a, b) {
            if (a == null) {
                return b.j6.registerColumnDateTime(null, null, false);
            }
            var c = null;
            var d = SeriesViewer.b1(a, b.coercionMethods);
            c = d.a;
            return b.j6.registerColumnDateTime(a, c, b.expectFunctions);
        };
        TimeAxisBase.prototype.au = function () {
            if (this.cz) {
                return (i2.TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        };
        TimeAxisBase.prototype.get_a1 = function () {
            return 0;
        };
        Object.defineProperty(TimeAxisBase.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.a4.ay();
            var c = this.a4.a1();
            var d = this.a4.az();
            var e = this.a4.a0();
            var f = this.a4.e();
            var g = this.a4.f();
            var h = this.a4.g();
            this.h0();
            this.g0(b);
            this.g0(c);
            this.g0(d);
            this.g0(e);
            this.c5.clear();
            this.c6.clear();
            this.kd.clear();
            this.av.ac = this;
            var i = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var j = !i.isEmpty ? this.js : i2.Rect.empty;
            this.av.cx = i;
            this.av.cw = j;
            if (i.isEmpty || j.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0) {
                this.av.ab.clear();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            this.mk();
        };
        TimeAxisBase.prototype.get_b9 = function () {
            return true;
        };
        TimeAxisBase.prototype.startCursor = function () {
        };
        TimeAxisBase.prototype.resetCursor = function () {
        };
        TimeAxisBase.prototype.StartTimeCursor = function () {
            this.startCursor();
        };
        TimeAxisBase.prototype.ResetTimeCursor = function () {
            this.resetCursor();
        };
        TimeAxisBase.prototype.getCategorySize = function (a, b, c) {
            if (this.kq == 0) {
                return 0;
            }
            var d = this.jq(b, c);
            return d.width / (this.kq * a.width);
        };
        TimeAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
            return this.getCategorySize(b, c, d) * 0.5;
        };
        TimeAxisBase.prototype.ki = function (a, b, c) {
            var d = !i2.isNaN_(this.kf) ? i2.MathUtil.b(this.kf, 0, 1) : 0;
            var e = 1 - 0.5 * d;
            var f = this.getCategorySize(a, b, c) * e;
            return f;
        };
        TimeAxisBase.prototype.get_ch = function () {
            return true;
        };
        TimeAxisBase.prototype.mi = function (a, b) {
            return (0);
        };
        TimeAxisBase.prototype.preferredCategoryMode = function (a) {
            return this.b7 ? 0 : 1;
        };
        Object.defineProperty(TimeAxisBase.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        TimeAxisBase.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        TimeAxisBase.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        TimeAxisBase.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        TimeAxisBase.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(TimeAxisBase.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeAxisBase.prototype, "i$a", {
            get: function () {
                return this.b9;
            },
            enumerable: false,
            configurable: true
        });
        TimeAxisBase.$t = i2.markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
        TimeAxisBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, TimeAxisBase, 'hk', ['DateTimeMemberPath::mq', [2, null], 'IsDataPreSorted:lt:mr', [0, false], 'MaximumValue::ms', [3, null], 'MinimumValue::mt', [3, null]]);
        return TimeAxisBase;
    }(CategoryAxisBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors for displaying of gridlines, tickmarks, and labels on a time axis.
     */
    var TimeAxisDisplayType = /*@__PURE__*/ (function (TimeAxisDisplayType) {
        /**
         * Points occur at even intervals, even where data is not present at a given point.
         */
        TimeAxisDisplayType[TimeAxisDisplayType["Continuous"] = 0] = "Continuous";
        /**
         * Points occur when data is present, possibly at uneven intervals.
         */
        TimeAxisDisplayType[TimeAxisDisplayType["Discrete"] = 1] = "Discrete";
        return TimeAxisDisplayType;
    })({});
    /**
     * @hidden
     */
    var TimeAxisDisplayType_$type = i2.markEnum('TimeAxisDisplayType', 'Continuous,0|Discrete,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryDateTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryDateTimeXAxis, _super);
        function CategoryDateTimeXAxis() {
            var _this = _super.call(this) || this;
            _this.m0 = 0;
            _this.m1 = 0;
            _this.ab = CategoryDateTimeXAxis.$;
            _this.actualMinimumValue = (new Date());
            _this.actualMaximumValue = (new Date());
            return _this;
        }
        CategoryDateTimeXAxis.prototype.get_b8 = function () {
            return this.mv == 0;
        };
        CategoryDateTimeXAxis.prototype.a3 = function () {
            return new CategoryDateTimeXAxisView(this);
        };
        CategoryDateTimeXAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.mu = a;
        };
        Object.defineProperty(CategoryDateTimeXAxis.prototype, "m2", {
            get: function () {
                return this.m0;
            },
            set: function (a) {
                if (this.m2 != a) {
                    var b = this.m0;
                    this.m0 = a;
                    this.hk("ActualInterval", b, this.m2);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryDateTimeXAxis.prototype.ej = function () {
            return this.m2;
        };
        Object.defineProperty(CategoryDateTimeXAxis.prototype, "m6", {
            get: function () {
                return i2.typeGetValue(this.c(CategoryDateTimeXAxis.nh));
            },
            set: function (a) {
                this.h(CategoryDateTimeXAxis.nh, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryDateTimeXAxis.prototype, "m3", {
            get: function () {
                return this.m1;
            },
            set: function (a) {
                if (this.m3 != a) {
                    var b = this.m1;
                    this.m1 = a;
                    this.hk("ActualMinorInterval", b, this.m3);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryDateTimeXAxis.prototype.c1 = function (a, b, c) {
            var d = _super.prototype.c1.call(this, a, b, c);
            if (!d) {
                return false;
            }
            return +(this.actualMinimumValue) != +(this.actualMaximumValue);
        };
        CategoryDateTimeXAxis.prototype.dv = function () {
            return this.m2;
        };
        CategoryDateTimeXAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = !b.isEmpty ? this.js : i2.Rect.empty;
            var d = this.jn();
            var e = this.jm();
            var f = new ScalerParams(0, b, c, this.cc, d);
            if (this.lo == null && !this.lu() && !this.lv()) {
                return;
            }
            if (!b.isEmpty && !c.isEmpty && (this.mv != 1 || this.lo != null)) {
                var g = c.bottom;
                var h = g - c.top;
                if (this.ai != null) {
                    var i = i2.typeCast(NumericYAxis.$, this.ai);
                    if (i != null) {
                        var j = this.hv(g, h, b, c, d, c.top, c.bottom);
                        g = j.p0;
                        h = j.p1;
                    }
                }
                if (i2.isNaN_(g)) {
                    g = 0;
                }
                this.g8(this.a4.ay(), g, c, this.a4.e(), true);
                this.av.bc = h;
                var k = this.a4.a1();
                var l = this.a4.f();
                var m = this.a4.az();
                var n = this.a4.a0();
                var o = this.a4.g();
                if (this.mv == 1) {
                    var p = this.i$e(b, c, d, e);
                    var q = this.i$g(b, c, d, e);
                    if (p < 0 || q < 0) {
                        return;
                    }
                    var r = NaN;
                    for (var s = p; s <= q; s++) {
                        var t = this.lx == null ? s : this.lx._inner[s];
                        var u = this.d8(this.lo.item(t).getTime(), f);
                        if (u == r) {
                            continue;
                        }
                        r = u;
                        if (this.categoryMode == 2) {
                            u += this.cc ? -this.getGroupCenter(s, b, c, d) : this.getGroupCenter(s, b, c, d);
                        }
                        if (u < e.left || u > e.right) {
                            continue;
                        }
                        this.h1(m, u, c, l, false);
                        this.kd.add(u);
                        if (this.j6 != null && s < this.j6.count) {
                            var v = this.j6.item(t);
                            var w = _super.prototype.fi.call(this, v);
                            if (!i2.isNaN_(u) && !i2.isInfinity(u) && w != null) {
                                if ((typeof w === 'string') && i2.Base.equalsStatic(w, "")) {
                                }
                                else {
                                    this.c5.add1(w);
                                    this.c6.add(new LabelPosition(u));
                                }
                            }
                        }
                    }
                }
                else {
                    var x = this.eb(e.left, f);
                    var y = this.eb(e.right, f);
                    var z = Math.min(x, y);
                    var aa = Math.max(x, y);
                    var ab = new LinearNumericSnapper(0, z, aa, e.width, this.el());
                    var ac = this.ls ? this.mz() : ab.g;
                    this.nd(i2.truncate(ac));
                    var ad = i2.truncate(Math.floor((z - this.actualMinimumValue.getTime()) / ac));
                    var ae = i2.truncate(Math.ceil((aa - this.actualMinimumValue.getTime()) / ac));
                    var af = 0;
                    if (this.categoryMode == 2) {
                        af = this.getGroupCenter(0, b, c, d);
                        af = this.cc ? -af : af;
                    }
                    var ag = i2.truncate(Math.ceil(e.right));
                    var ah = i2.truncate(Math.floor(e.left));
                    var ai = this.d8(this.actualMinimumValue.getTime() + ad * ac, f) + af;
                    for (var aj = ad; aj <= ae; aj++) {
                        var ak = this.d8(this.actualMinimumValue.getTime() + (aj + 1) * ac, f) + af;
                        if (!i2.isNaN_(ai) && !i2.isInfinity(ai)) {
                            var al = i2.truncate(Math.round(ai));
                            if (al <= ag) {
                                if (aj % 2 == 0) {
                                    this.h2(k, ai, ak, c);
                                }
                                this.h1(m, ai, c, l, false);
                                this.kd.add(ai);
                                if (this.cs) {
                                    var am = this.m4();
                                    if (am > 0 && am < ac) {
                                        if (ac / am < 20) {
                                            var an = ai;
                                            var ao = Math.abs(this.d8(this.actualMinimumValue.getTime() + am, f) - this.d8(this.actualMinimumValue.getTime(), f));
                                            while (an + ao < ak) {
                                                if (Math.abs(an + ao - ak) < 0.0001) {
                                                    break;
                                                }
                                                an += ao;
                                                if (an > 0) {
                                                    this.h1(n, an, c, o, false);
                                                }
                                            }
                                            this.ne(am);
                                        }
                                    }
                                    else {
                                        for (var ap = 1; ap < ab.i; ++ap) {
                                            var aq = this.d8(this.actualMinimumValue.getTime() + aj * ac + (ap * ac) / ab.i, f) + af;
                                            this.h1(n, aq, c, o, false);
                                        }
                                        if (ab.i > 0) {
                                            this.ne(i2.truncate((ac / ab.i)));
                                        }
                                    }
                                }
                            }
                            if (al >= ah && al <= ag) {
                                var ar = this.actualMinimumValue.getTime() + aj * ac;
                                var ticks_ = i2.truncate(Math.floor(ar));
                                var as = (new Date(ticks_));
                                var at = this.fi(as);
                                if (at != null) {
                                    this.c5.add1(at);
                                    this.c6.add(new LabelPosition(ai));
                                }
                            }
                        }
                        ai = ak;
                    }
                }
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                        this.bh.jq();
                    }
                }
                this.av.a5 = this.c5;
                this.av.a6 = this.c6;
                this.ld();
            }
        };
        CategoryDateTimeXAxis.prototype.mz = function () {
            return this.m2;
        };
        CategoryDateTimeXAxis.prototype.m4 = function () {
            return this.m6;
        };
        CategoryDateTimeXAxis.prototype.nd = function (a) {
            this.m2 = a;
        };
        CategoryDateTimeXAxis.prototype.ne = function (a) {
            this.m3 = a;
        };
        CategoryDateTimeXAxis.prototype.mx = function () {
            return this.m5 != 0;
        };
        CategoryDateTimeXAxis.prototype.mw = function () {
            return this.m2 == 0;
        };
        CategoryDateTimeXAxis.prototype.my = function (a) {
            return this.lo == null ? i2.dateMinValue() : this.lo.item(a);
        };
        CategoryDateTimeXAxis.prototype.nc = function (a, b) {
            if (a > b || this.j6 == null || this.j6.count == 0) {
                return;
            }
            var c = (a.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            var d = (b.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            this.bh.pw = new i2.Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
        };
        CategoryDateTimeXAxis.prototype.he = function (a, b, c, d) {
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case CategoryDateTimeXAxis.$$p[0]:
                    this.ck = true;
                    this.av.ak = this.mv == 1;
                    this.hq(false);
                    break;
                case CategoryDateTimeXAxis.$$p[1]:
                    this.ck = true;
                    this.hq(false);
                    break;
            }
        };
        CategoryDateTimeXAxis.prototype.mk = function () {
            _super.prototype.mk.call(this);
            if (this.mx()) {
                this.m2 = this.m5;
                var a = this.bh != null ? this.bh.pg : i2.Rect.empty;
                var b = !a.isEmpty ? this.js : i2.Rect.empty;
                var c = Math.abs(this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
                this.ls = this.mw() || (this.mv == 1) || (1 * c / this.mz() > (b.width / a.width)) ? false : true;
            }
            else {
                this.ls = false;
            }
        };
        CategoryDateTimeXAxis.prototype.mi = function (a, b) {
            var c = b.getTime() - a.getTime();
            var timeOffset_ = i2.truncate(Math.round(i2.intDivide(c, this.kq) / 2));
            return timeOffset_ == 0 ? i2.timeSpanFromMilliseconds(1) : i2.timeSpanFromMilliseconds(timeOffset_);
        };
        CategoryDateTimeXAxis.prototype.get_b7 = function () {
            return true;
        };
        Object.defineProperty(CategoryDateTimeXAxis.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        CategoryDateTimeXAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        CategoryDateTimeXAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        CategoryDateTimeXAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        CategoryDateTimeXAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        CategoryDateTimeXAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(CategoryDateTimeXAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryDateTimeXAxis.prototype, "i$a", {
            get: function () {
                return this.b9;
            },
            enumerable: false,
            configurable: true
        });
        CategoryDateTimeXAxis.$t = i2.markType(CategoryDateTimeXAxis, 'CategoryDateTimeXAxis', TimeAxisBase.$);
        CategoryDateTimeXAxis.nh = i2.DependencyProperty.i("MinorInterval", i2.Number_$type, CategoryDateTimeXAxis.$, new i2.PropertyMetadata(2, 0, function (a, b) {
            (i2.typeCast(CategoryDateTimeXAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
            (i2.typeCast(CategoryDateTimeXAxis.$, a)).hq(false);
        }));
        CategoryDateTimeXAxis.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryDateTimeXAxis, 'hk', ['DisplayType:mv:nf', [TimeAxisDisplayType_$type, i2.enumGetBox(TimeAxisDisplayType_$type, 0)], 'Interval:m5:ng', [1, 0]]);
        return CategoryDateTimeXAxis;
    }(TimeAxisBase));
    /**
     * @hidden
     */
    var CategoryDateTimeXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryDateTimeXAxisView, _super);
        function CategoryDateTimeXAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        CategoryDateTimeXAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.e0 = AxisDefaults.f;
        };
        CategoryDateTimeXAxisView.prototype.o = function (a) {
            var b = this.n(i2.dateFromTicks(i2.truncate(a)));
            return b;
        };
        CategoryDateTimeXAxisView.$t = i2.markType(CategoryDateTimeXAxisView, 'CategoryDateTimeXAxisView', CategoryAxisBaseView.$);
        return CategoryDateTimeXAxisView;
    }(CategoryAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents an category-based horizontal X axis that uses a DateTime scale.
    *
    * Represents horizontal axis that uses a DateTime scale.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    var IgxTimeAxisBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTimeAxisBaseComponent, _super);
        function IgxTimeAxisBaseComponent() {
            var _this = _super.call(this) || this;
            _this._actualMinimumValueChange = null;
            _this._actualMaximumValueChange = null;
            return _this;
        }
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "dateTimeMemberPath", {
            /**
             * Gets or sets the DateTime mapping property for the axis.
            *
            * Use `dateTimeMemberPath` property for DateTime mapping with the axis.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-time-x-axis
            * 		dateTimeMemberPath="date"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let xAxis = new IgxTimeXAxisComponent();
            * xAxis.dataTimeMemberPath="date";
            * this.chart.axes.add(xAxis);
            * ```
            */
            get: function () {
                return this.i.dateTimeMemberPath;
            },
            set: function (v) {
                this.i.dateTimeMemberPath = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "isDataPreSorted", {
            /**
             * Gets or sets whether the data assigned to the date time axis should be considered pre-sorted by date/time.
            *
            * Use `isDataPreSorted` property to decide if the data assigned to the date time axis should be considered pre-sorted by date/time.
            */
            get: function () {
                return this.i.lt;
            },
            set: function (v) {
                this.i.lt = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "actualMinimumValue", {
            /**
             * Gets the coerced minimum value.
            *
            * Use `actualMinimumValue` to get the coerced maximum value.
            */
            get: function () {
                return this.i.actualMinimumValue;
            },
            set: function (v) {
                this.i.actualMinimumValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "actualMaximumValue", {
            /**
             * Gets the coerced maximum value.
            *
            * Use `actualMaximumValue` to get the  coerced maximum value
            */
            get: function () {
                return this.i.actualMaximumValue;
            },
            set: function (v) {
                this.i.actualMaximumValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "minimumValue", {
            /**
             * Gets or sets the axis MinimumValue.
            *
            * Use `minimumValue` property for axis minimum value.
            *
            * ```ts
            * this.timeXAxis.maximumValue="2019-12-26";
            * ```
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "maximumValue", {
            /**
             * Gets or sets the axis MaximumValue.
            *
            * Use `maximumValue` property for axis maximum value.
            *
            * ```ts
            * this.timeXAxis.maximumValue="2019-12-26";
            * ```
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "isDateTime", {
            /**
             * Checks if the axis is of date time axis type
            *
            * Use `isDateTime` property to Checks if the axis is of date time axis type.
            *
            * ```ts
            * const isDT = this.timeXAxis.isDateTime;
            * ```
            */
            get: function () {
                return this.i.b9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "isSorting", {
            /**
             * Checks if axis requires sorting of items
            *
            * Use `isSorting` property to Checks if axis requires sorting of items.
            *
            * ```ts
            * const isDT = this.timeXAxis.isDateTime;
            * ```
            */
            get: function () {
                return this.i.ch;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisBaseComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.fg(item, memberPathName);
            return (iv);
        };
        /**
         * Gets the index of the data item with the value nearest the given value.
        
        * @param unscaledValue  * The value to find a value close to.
        */
        IgxTimeAxisBaseComponent.prototype.getIndexClosestToUnscaledValue = function (unscaledValue) {
            var iv = this.i.i$f(unscaledValue);
            return (iv);
        };
        /**
         * Updates the axis when the data has been changed.
        
        */
        IgxTimeAxisBaseComponent.prototype.notifyDataChanged = function () {
            this.i.i$i();
        };
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "actualMinimumValueChange", {
            get: function () {
                var _this = this;
                if (this._actualMinimumValueChange == null) {
                    this._actualMinimumValueChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMinimumValue;
                        if (_this.beforeActualMinimumValueChange) {
                            _this.beforeActualMinimumValueChange(_this, ext);
                        }
                        _this._actualMinimumValueChange.emit(ext);
                    });
                }
                return this._actualMinimumValueChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "actualMaximumValueChange", {
            get: function () {
                var _this = this;
                if (this._actualMaximumValueChange == null) {
                    this._actualMaximumValueChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMaximumValue;
                        if (_this.beforeActualMaximumValueChange) {
                            _this.beforeActualMaximumValueChange(_this, ext);
                        }
                        _this._actualMaximumValueChange.emit(ext);
                    });
                }
                return this._actualMaximumValueChange;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeAxisBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTimeAxisBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTimeAxisBaseComponent, selector: "ng-component", inputs: { dateTimeMemberPath: "dateTimeMemberPath", isDataPreSorted: "isDataPreSorted", actualMinimumValue: "actualMinimumValue", actualMaximumValue: "actualMaximumValue", minimumValue: "minimumValue", maximumValue: "maximumValue" }, outputs: { actualMinimumValueChange: "actualMinimumValueChange", actualMaximumValueChange: "actualMaximumValueChange" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxTimeAxisBaseComponent;
    }(IgxCategoryAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { dateTimeMemberPath: [{
                    type: i0.Input
                }], isDataPreSorted: [{
                    type: i0.Input
                }], actualMinimumValue: [{
                    type: i0.Input
                }], actualMaximumValue: [{
                    type: i0.Input
                }], minimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }], actualMinimumValueChange: [{
                    type: i0.Output
                }], actualMaximumValueChange: [{
                    type: i0.Output
                }] } });

    /**
     * Represents a category-based horizontal X axis that uses a DateTime scale.
    *
    * `IgxCategoryDateTimeXAxisComponent` class represents a category-based horizontal X axis that uses a DateTime scale.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    var IgxCategoryDateTimeXAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryDateTimeXAxisComponent, _super);
        function IgxCategoryDateTimeXAxisComponent() {
            var _this = _super.call(this) || this;
            _this._actualIntervalChange = null;
            _this._actualMinorIntervalChange = null;
            return _this;
        }
        IgxCategoryDateTimeXAxisComponent.prototype.createImplementation = function () {
            return new CategoryDateTimeXAxis();
        };
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "isContinuous", {
            /**
             * Gets if the current axis is a continuous rather than a discrete scale
            */
            get: function () {
                return this.i.b8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "displayType", {
            /**
             * Gets or sets the axis display type.
             * Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points.
             * Discrete display type will not use a constant interval, but will align each label with its data point.
            *
            * `displayType` property is used for axis display type.
            *
            * Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points. Discrete display type will not use a constant interval, but will align each label with its data point.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-time-x-axis
            * 		dateTimeMemberPath="date"
            * 		displayType ="continuous"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.mv;
            },
            set: function (v) {
                this.i.mv = i2.ensureEnum(TimeAxisDisplayType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "interval", {
            /**
             * Gets or sets the X axis time interval.
            *
            * `interval` property is used to get/sets the frequency of displayed labels.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-time-x-axis
            * 		dateTimeMemberPath="date"
            * 		interval=2
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.m5;
            },
            set: function (v) {
                this.i.m5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "actualInterval", {
            /**
             * Gets the effective value for the current Interval.
            */
            get: function () {
                return this.i.m2;
            },
            set: function (v) {
                this.i.m2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "minorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines.
             * The set value is a factor that determines how the minor lines will be displayed.
            */
            get: function () {
                return this.i.m6;
            },
            set: function (v) {
                this.i.m6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "actualMinorInterval", {
            /**
             * Gets the effective value for the current MinorInterval.
            */
            get: function () {
                return this.i.m3;
            },
            set: function (v) {
                this.i.m3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "isCategoryDateTime", {
            /**
             * Gets if the current axis is of category date time axis type
            */
            get: function () {
                return this.i.b7;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryDateTimeXAxisComponent.prototype.scrollIntoView = function (minimum, maximum) {
            this.i.nc(minimum, maximum);
        };
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "actualIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualIntervalChange == null) {
                    this._actualIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualInterval;
                        if (_this.beforeActualIntervalChange) {
                            _this.beforeActualIntervalChange(_this, ext);
                        }
                        _this._actualIntervalChange.emit(ext);
                    });
                }
                return this._actualIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryDateTimeXAxisComponent.prototype, "actualMinorIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualMinorIntervalChange == null) {
                    this._actualMinorIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMinorInterval;
                        if (_this.beforeActualMinorIntervalChange) {
                            _this.beforeActualMinorIntervalChange(_this, ext);
                        }
                        _this._actualMinorIntervalChange.emit(ext);
                    });
                }
                return this._actualMinorIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryDateTimeXAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryDateTimeXAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryDateTimeXAxisComponent, selector: "igx-category-date-time-x-axis", inputs: { displayType: "displayType", interval: "interval", actualInterval: "actualInterval", minorInterval: "minorInterval", actualMinorInterval: "actualMinorInterval" }, outputs: { actualIntervalChange: "actualIntervalChange", actualMinorIntervalChange: "actualMinorIntervalChange" }, providers: [{ provide: IgxTimeAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryDateTimeXAxisComponent; }) }, { provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryDateTimeXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryDateTimeXAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryDateTimeXAxisComponent;
    }(IgxTimeAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-date-time-x-axis',
                        template: "",
                        providers: [{ provide: IgxTimeAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryDateTimeXAxisComponent; }) }, { provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryDateTimeXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryDateTimeXAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { displayType: [{
                    type: i0.Input
                }], interval: [{
                    type: i0.Input
                }], actualInterval: [{
                    type: i0.Input
                }], minorInterval: [{
                    type: i0.Input
                }], actualMinorInterval: [{
                    type: i0.Input
                }], actualIntervalChange: [{
                    type: i0.Output
                }], actualMinorIntervalChange: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryDateTimeXAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryDateTimeXAxisModule() {
        }
        IgxCategoryDateTimeXAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryDateTimeXAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisModule, declarations: [IgxCategoryDateTimeXAxisComponent], imports: [i1.CommonModule], exports: [IgxCategoryDateTimeXAxisComponent] });
        IgxCategoryDateTimeXAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisModule, imports: [[i1.CommonModule]] });
        return IgxCategoryDateTimeXAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryDateTimeXAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCategoryDateTimeXAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryDateTimeXAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryDateTimeXAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryDateTimeXAxisComponent", IgxCategoryDateTimeXAxisComponent);
            i2.TypeRegistrar.register("CategoryDateTimeXAxis", CategoryDateTimeXAxis.$type);
        }
        IgxCategoryDateTimeXAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryDateTimeXAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisDynamicModule, imports: [i1.CommonModule, IgxCategoryDateTimeXAxisModule], exports: [IgxCategoryDateTimeXAxisModule] });
        IgxCategoryDateTimeXAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisDynamicModule, imports: [[i1.CommonModule, IgxCategoryDateTimeXAxisModule], IgxCategoryDateTimeXAxisModule] });
        return IgxCategoryDateTimeXAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryDateTimeXAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryDateTimeXAxisModule],
                        exports: [IgxCategoryDateTimeXAxisModule],
                        entryComponents: [IgxCategoryDateTimeXAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent angle based axis for polar series.
    */
    var IgxNumericAngleAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxNumericAngleAxisComponent, _super);
        function IgxNumericAngleAxisComponent() {
            return _super.call(this) || this;
        }
        IgxNumericAngleAxisComponent.prototype.createImplementation = function () {
            return new NumericAngleAxis();
        };
        Object.defineProperty(IgxNumericAngleAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAngleAxisComponent.prototype, "isAngular", {
            /**
             * Gets if the current axis is of angular axis type
            */
            get: function () {
                return this.i.b4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericAngleAxisComponent.prototype, "startAngleOffset", {
            /**
             * Indicates the angle in degress that the chart's 0th angle should be offset.
            */
            get: function () {
                return this.i.md;
            },
            set: function (v) {
                this.i.md = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Gets the scaled angle value in radians based on the raw input.
        
        * @param unscaledAngle  * The unscaled angle.
        */
        IgxNumericAngleAxisComponent.prototype.getScaledAngle = function (unscaledAngle) {
            var iv = this.i.getScaledAngle(unscaledAngle);
            return (iv);
        };
        /**
         * Gets the raw axis value back from the angle that would be used on the chart.
        
        * @param scaledAngle  * The chart angle value.
        */
        IgxNumericAngleAxisComponent.prototype.getUnscaledAngle = function (scaledAngle) {
            var iv = this.i.getUnscaledAngle(scaledAngle);
            return (iv);
        };
        IgxNumericAngleAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxNumericAngleAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxNumericAngleAxisComponent, selector: "igx-numeric-angle-axis", inputs: { startAngleOffset: "startAngleOffset" }, providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericAngleAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxNumericAngleAxisComponent;
    }(IgxNumericAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-numeric-angle-axis',
                        template: "",
                        providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericAngleAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { startAngleOffset: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericAngleAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericAngleAxisModule() {
        }
        IgxNumericAngleAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericAngleAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisModule, declarations: [IgxNumericAngleAxisComponent], imports: [i1.CommonModule], exports: [IgxNumericAngleAxisComponent] });
        IgxNumericAngleAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisModule, imports: [[i1.CommonModule]] });
        return IgxNumericAngleAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxNumericAngleAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxNumericAngleAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericAngleAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericAngleAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxNumericAngleAxisComponent", IgxNumericAngleAxisComponent);
            i2.TypeRegistrar.register("NumericAngleAxis", NumericAngleAxis.$type);
        }
        IgxNumericAngleAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericAngleAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisDynamicModule, imports: [i1.CommonModule, IgxNumericAngleAxisModule], exports: [IgxNumericAngleAxisModule] });
        IgxNumericAngleAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisDynamicModule, imports: [[i1.CommonModule, IgxNumericAngleAxisModule], IgxNumericAngleAxisModule] });
        return IgxNumericAngleAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericAngleAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxNumericAngleAxisModule],
                        exports: [IgxNumericAngleAxisModule],
                        entryComponents: [IgxNumericAngleAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent radius axis for polar and radial series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="dataSource"   >
    *     <igx-category-angle-axis name="angleAxis" label="Department" />
    *     <igx-numeric-radius-axis name="radiusAxis" />
    *  </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series1.angleAxisName = "AngleAxis";
    * this.series1.valueAxisName = "numericYAxis";
    * ```
    */
    var IgxNumericRadiusAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxNumericRadiusAxisComponent, _super);
        function IgxNumericRadiusAxisComponent() {
            return _super.call(this) || this;
        }
        IgxNumericRadiusAxisComponent.prototype.createImplementation = function () {
            return new NumericRadiusAxis();
        };
        Object.defineProperty(IgxNumericRadiusAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericRadiusAxisComponent.prototype, "isRadial", {
            /**
             * Checks if the axis is of radial axis type
            *
            * ```ts
            * let isRadial: boolean = this.series.isRadial;
            * ```
            */
            get: function () {
                return this.i.cg;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericRadiusAxisComponent.prototype, "radiusExtentScale", {
            /**
             * Defines the percentage of the maximum radius extent to use as the maximum radius. Should be
             * a value between 0.0 and 1.0.
            */
            get: function () {
                return this.i.mk;
            },
            set: function (v) {
                this.i.mk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxNumericRadiusAxisComponent.prototype, "innerRadiusExtentScale", {
            /**
             * Defines the percentage of the maximum radius extent to leave blank at the center of the chart. Should be
             * a value between 0.0 and 1.0.
            */
            get: function () {
                return this.i.mj;
            },
            set: function (v) {
                this.i.mj = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Returns a world coordinates radius length (0 - 0.5) from a raw axis value.
        
        * @param unscaledValue  * The raw axis value.
        */
        IgxNumericRadiusAxisComponent.prototype.getScaledValue = function (unscaledValue) {
            var iv = this.i.mg(unscaledValue);
            return (iv);
        };
        /**
         * Returns a raw axis value from the world coordinates radius length provided.
        
        * @param scaledValue  * The scaled world coordinates radius length.
        *
        * Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
        */
        IgxNumericRadiusAxisComponent.prototype.getUnscaledValue = function (scaledValue) {
            var iv = this.i.mi(scaledValue);
            return (iv);
        };
        IgxNumericRadiusAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxNumericRadiusAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxNumericRadiusAxisComponent, selector: "igx-numeric-radius-axis", inputs: { radiusExtentScale: "radiusExtentScale", innerRadiusExtentScale: "innerRadiusExtentScale" }, providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericRadiusAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericRadiusAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxNumericRadiusAxisComponent;
    }(IgxNumericAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-numeric-radius-axis',
                        template: "",
                        providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericRadiusAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericRadiusAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusExtentScale: [{
                    type: i0.Input
                }], innerRadiusExtentScale: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericRadiusAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericRadiusAxisModule() {
        }
        IgxNumericRadiusAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericRadiusAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisModule, declarations: [IgxNumericRadiusAxisComponent], imports: [i1.CommonModule], exports: [IgxNumericRadiusAxisComponent] });
        IgxNumericRadiusAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisModule, imports: [[i1.CommonModule]] });
        return IgxNumericRadiusAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxNumericRadiusAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxNumericRadiusAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericRadiusAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericRadiusAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxNumericRadiusAxisComponent", IgxNumericRadiusAxisComponent);
            i2.TypeRegistrar.register("NumericRadiusAxis", NumericRadiusAxis.$type);
        }
        IgxNumericRadiusAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericRadiusAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisDynamicModule, imports: [i1.CommonModule, IgxNumericRadiusAxisModule], exports: [IgxNumericRadiusAxisModule] });
        IgxNumericRadiusAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisDynamicModule, imports: [[i1.CommonModule, IgxNumericRadiusAxisModule], IgxNumericRadiusAxisModule] });
        return IgxNumericRadiusAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericRadiusAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxNumericRadiusAxisModule],
                        exports: [IgxNumericRadiusAxisModule],
                        entryComponents: [IgxNumericRadiusAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITimeRangeSelectorAxis_$type = new i2.Type(null, 'ITimeRangeSelectorAxis');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Enum representing a unit of time.
     */
    var TimeAxisLabellingMode = /*@__PURE__*/ (function (TimeAxisLabellingMode) {
        /**
         * LabellingMode is decided automatically.
         */
        TimeAxisLabellingMode[TimeAxisLabellingMode["Auto"] = 0] = "Auto";
        /**
         * Labels are presented in a uniform format based on visible interval.
         */
        TimeAxisLabellingMode[TimeAxisLabellingMode["Normal"] = 1] = "Normal";
        /**
         * Labels are shortened by eliminating repeated elements compared to prior values.
         */
        TimeAxisLabellingMode[TimeAxisLabellingMode["Compressed"] = 2] = "Compressed";
        return TimeAxisLabellingMode;
    })({});
    /**
     * @hidden
     */
    var TimeAxisLabellingMode_$type = i2.markEnum('TimeAxisLabellingMode', 'Auto,0|Normal,1|Compressed,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisLabelFormatCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisLabelFormatCollection, _super);
        function TimeAxisLabelFormatCollection() {
            return _super.call(this, TimeAxisLabelFormat.$, 0) || this;
        }
        TimeAxisLabelFormatCollection.$t = i2.markType(TimeAxisLabelFormatCollection, 'TimeAxisLabelFormatCollection', i2.ObservableCollection$1.$.specialize(TimeAxisLabelFormat.$));
        return TimeAxisLabelFormatCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisBreakCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisBreakCollection, _super);
        function TimeAxisBreakCollection() {
            return _super.call(this, TimeAxisBreak.$, 0) || this;
        }
        TimeAxisBreakCollection.$t = i2.markType(TimeAxisBreakCollection, 'TimeAxisBreakCollection', i2.ObservableCollection$1.$.specialize(TimeAxisBreak.$));
        return TimeAxisBreakCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OrderedDictionary = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OrderedDictionary, _super);
        function OrderedDictionary() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        OrderedDictionary.$t = i2.markType(OrderedDictionary, 'OrderedDictionary');
        return OrderedDictionary;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OrderedDictionary$2 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OrderedDictionary$2, _super);
        function OrderedDictionary$2($tKey, $tValue) {
            var _this = _super.call(this) || this;
            _this.$tKey = null;
            _this.$tValue = null;
            _this.e = null;
            _this.f = null;
            _this.$tKey = $tKey;
            _this.$tValue = $tValue;
            _this.$type = _this.$type.specialize(_this.$tKey, _this.$tValue);
            _this.e = new i2.Dictionary$2(_this.$tKey, _this.$tValue, 0);
            _this.f = new i2.List$1(_this.$tKey, 0);
            return _this;
        }
        OrderedDictionary$2.prototype.item1 = function (a) {
            return this.f._inner[a];
        };
        OrderedDictionary$2.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                var c = this.f.indexOf(a);
                this.f._inner[c] = a;
                this.e.item(a, b);
                return b;
            }
            else {
                return this.e.item(a);
            }
        };
        OrderedDictionary$2.prototype.get_a = function () {
            return this.count;
        };
        Object.defineProperty(OrderedDictionary$2.prototype, "a", {
            get: function () {
                return this.get_a();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrderedDictionary$2.prototype, "count", {
            get: function () {
                return this.e.count;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrderedDictionary$2.prototype, "isReadOnly", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrderedDictionary$2.prototype, "keys", {
            get: function () {
                return this.f;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrderedDictionary$2.prototype, "values", {
            get: function () {
                return this.e.values;
            },
            enumerable: false,
            configurable: true
        });
        OrderedDictionary$2.prototype.add = function (a) {
            this.addItem(a.key, a.value);
        };
        OrderedDictionary$2.prototype.addItem = function (a, b) {
            this.e.addItem(a, b);
            this.f.add(a);
        };
        OrderedDictionary$2.prototype.clear = function () {
            this.e.clear();
            this.f.clear();
        };
        OrderedDictionary$2.prototype.contains = function (a) {
            return this.e.contains(a);
        };
        OrderedDictionary$2.prototype.containsKey = function (a) {
            return this.e.containsKey(a);
        };
        OrderedDictionary$2.prototype.copyTo = function (a, b) {
            this.e.copyTo(a, b);
        };
        OrderedDictionary$2.prototype.getEnumerator = function () {
            return new OrderedDictionaryEnumerator$2(this.$tKey, this.$tValue, this);
        };
        OrderedDictionary$2.prototype.remove = function (a) {
            return this.removeItem(a.key);
        };
        OrderedDictionary$2.prototype.removeItem = function (a) {
            return this.e.removeItem(a) && this.f.remove(a);
        };
        OrderedDictionary$2.prototype.tryGetValue = function (a, b) {
            if (this.e.containsKey(a)) {
                b = this.e.item(a);
                return {
                    ret: true,
                    p1: b
                };
            }
            b = i2.Type.getDefaultValue(this.$tValue);
            return {
                ret: false,
                p1: b
            };
        };
        OrderedDictionary$2.prototype.getEnumeratorObject = function () {
            return new OrderedDictionaryEnumerator$2(this.$tKey, this.$tValue, this);
        };
        OrderedDictionary$2.prototype.b = function (a) {
            return i2.getBoxIfEnum(this.$tKey, this.item1(a));
        };
        OrderedDictionary$2.prototype.c = function (a) {
            return this.item(a);
        };
        OrderedDictionary$2.$t = i2.markType(OrderedDictionary$2, 'OrderedDictionary$2', OrderedDictionary.$, [i2.IDictionary$2_$type.specialize(0, 1), i2.IDictionary_$type]);
        return OrderedDictionary$2;
    }(OrderedDictionary));
    /**
     * @hidden
     */
    var OrderedDictionaryEnumerator$2 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OrderedDictionaryEnumerator$2, _super);
        function OrderedDictionaryEnumerator$2($tKey, $tValue, a) {
            var _this = _super.call(this) || this;
            _this.$tKey = null;
            _this.$tValue = null;
            _this.b = 0;
            _this.a = null;
            _this.$tKey = $tKey;
            _this.$tValue = $tValue;
            _this.$type = _this.$type.specialize(_this.$tKey, _this.$tValue);
            _this.b = -1;
            _this.a = a;
            return _this;
        }
        Object.defineProperty(OrderedDictionaryEnumerator$2.prototype, "currentObject", {
            get: function () {
                return i2.getBoxIfEnum(this.$tValue, this.a.item(this.a.item1(this.b)));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrderedDictionaryEnumerator$2.prototype, "current", {
            get: function () {
                var a = this.a.item1(this.b);
                return new i2.KeyValuePair$2(this.$tKey, this.$tValue, 1, a, this.a.item(a));
            },
            enumerable: false,
            configurable: true
        });
        OrderedDictionaryEnumerator$2.prototype.moveNext = function () {
            this.b += 1;
            return this.b < this.a.count;
        };
        OrderedDictionaryEnumerator$2.prototype.reset = function () {
            this.b = -1;
        };
        OrderedDictionaryEnumerator$2.prototype.dispose = function () {
        };
        OrderedDictionaryEnumerator$2.$t = i2.markType(OrderedDictionaryEnumerator$2, 'OrderedDictionaryEnumerator$2', i2.Base.$, [i2.IEnumerator$1_$type.specialize(i2.KeyValuePair$2.$.specialize(0, 1)), i2.IEnumerator_$type]);
        return OrderedDictionaryEnumerator$2;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeAxisIntervalCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeAxisIntervalCollection, _super);
        function TimeAxisIntervalCollection() {
            return _super.call(this, TimeAxisInterval.$, 0) || this;
        }
        TimeAxisIntervalCollection.$t = i2.markType(TimeAxisIntervalCollection, 'TimeAxisIntervalCollection', i2.ObservableCollection$1.$.specialize(TimeAxisInterval.$));
        return TimeAxisIntervalCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TimeXAxis, _super);
        function TimeXAxis() {
            var _this = _super.call(this) || this;
            _this.nn = 0;
            _this.mx = null;
            _this.m6 = 0;
            _this.m4 = null;
            _this._omission = 0;
            _this.mv = null;
            _this.m2 = null;
            _this.np = null;
            _this.n2 = 0;
            _this.nf = i2.dateMaxValue();
            _this.nd = i2.dateMaxValue();
            _this.nc = i2.dateMaxValue();
            _this.ne = i2.dateMinValue();
            _this.mz = null;
            _this.n0 = 0;
            _this.visibleRangeChanged = null;
            _this.ab = TimeXAxis.$;
            _this.omission = (0);
            _this.nn = -2147483648;
            _this.mx = new TimeAxisBreakCollection();
            var a = _this.breaks;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.n5));
            _this.m2 = new TimeAxisIntervalCollection();
            var b = _this.intervals;
            b.collectionChanged = i2.delegateCombine(b.collectionChanged, i2.runOn(_this, _this.n6));
            _this.m4 = new TimeAxisLabelFormatCollection();
            var c = _this.labelFormats;
            c.collectionChanged = i2.delegateCombine(c.collectionChanged, i2.runOn(_this, _this.n7));
            _this.n2 = (0);
            return _this;
        }
        TimeXAxis.prototype.get_cf = function () {
            return this.breaks != null && this.breaks.count > 0;
        };
        TimeXAxis.prototype.d8 = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.nl(a, NumericScaler.ac, b.c, i2.Rect.empty);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.nl(a, b.e, b.d, b.c);
        };
        TimeXAxis.prototype.nl = function (a, b, c, d) {
            var e = new i2.KeyValuePair$2(TimeAxisBreak.$, i2.Number_$type);
            var f = this.nn != -2147483648 ? this.nn : 0;
            var g = this.mv != null ? this.mv.count : 0;
            while (f < g) {
                var h = this.mv.item1(f);
                if (h.d.getTime() <= a && h.c.getTime() >= a) {
                    return NaN;
                }
                if (h.c.getTime() <= a) {
                    e = new i2.KeyValuePair$2(TimeAxisBreak.$, i2.Number_$type, 1, h, this.mv.item(h));
                    f++;
                }
                else {
                    break;
                }
            }
            if (f > 0) {
                f -= 1;
            }
            if (this.nn != -2147483648) {
                this.nn = f;
            }
            var i;
            var j;
            if (e.key != null) {
                i = e.value;
                j = e.key.c;
            }
            else {
                i = 0;
                j = this.actualMinimumValue;
            }
            var fromPrecedingBreak_ = +(i2.dateFromTicks(i2.truncate(a))) - +j;
            var k = (fromPrecedingBreak_ / ((this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime()) - this.omission));
            var l = i + k;
            l -= b.left;
            l /= b.width;
            var m = c.left;
            var n = c.right;
            var o = c.width;
            if (this.categoryMode != 0) {
                var p = this.getCategorySize(b, c, d);
                m += p / 2;
                n -= p / 2;
                o -= p;
            }
            if (this.cc) {
                return n - o * l;
            }
            return m + o * l;
        };
        TimeXAxis.prototype.g5 = function (a, b, c, d) {
            this.nn = 0;
            for (var e = b; e < c; e++) {
                a.item(e, this.d8(a.item(e), d));
            }
            this.nn = -2147483648;
        };
        TimeXAxis.prototype.startCursor = function () {
            this.nn = 0;
        };
        TimeXAxis.prototype.resetCursor = function () {
            this.nn = -2147483648;
        };
        TimeXAxis.prototype.eb = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
                return c;
            }
            return this.nm(a, b.e, b.d, b.c);
        };
        TimeXAxis.prototype.nm = function (a, b, c, d) {
            var e_1, _a;
            var e = c.left;
            var f = c.width;
            if (this.categoryMode != 0) {
                var g = this.getCategorySize(b, c, d);
                e += g / 2;
                f -= g;
            }
            var h = b.left + b.width * (a - e) / f;
            if (this.cc) {
                h = 1 - h;
            }
            var i = new i2.KeyValuePair$2(TimeAxisBreak.$, i2.Number_$type);
            if (this.mv != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.mv)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var j = _c.value;
                        if (j.value >= h && j.value <= h) {
                            return j.key.d.getTime();
                        }
                        if (j.value < h && j.value > i.value) {
                            i = j;
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            var precedingBreakEnd_;
            var k;
            if (i.key != null) {
                k = i.value;
                precedingBreakEnd_ = i.key.c;
            }
            else {
                k = 0;
                precedingBreakEnd_ = this.actualMinimumValue;
            }
            var portionFromPrecedingBreak_ = h - k;
            var actualRange_ = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
            return (precedingBreakEnd_.getTime() + portionFromPrecedingBreak_ * actualRange_);
        };
        Object.defineProperty(TimeXAxis.prototype, "breaks", {
            get: function () {
                return this.mx;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeXAxis.prototype, "m7", {
            get: function () {
                return this.m6;
            },
            set: function (a) {
                var b = this.m7;
                if (a != b) {
                    this.m6 = a;
                    this.hk("LabellingMode", i2.enumGetBox(TimeAxisLabellingMode_$type, b), i2.enumGetBox(TimeAxisLabellingMode_$type, this.m7));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeXAxis.prototype, "labelFormats", {
            get: function () {
                return this.m4;
            },
            enumerable: false,
            configurable: true
        });
        TimeXAxis.prototype.he = function (a, b, c, d) {
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case "ActualMaximumValue":
                    this.n4();
                    break;
                case "DateTimeColumn":
                    this.n0 = this.ny();
                    break;
                case "LabellingMode":
                    this.hq(false);
                    break;
            }
        };
        TimeXAxis.prototype.h4 = function (a, b) {
            _super.prototype.h4.call(this, a, b);
            this.n3();
            this.mp();
        };
        TimeXAxis.prototype.h3 = function (a, b) {
            _super.prototype.h3.call(this, a, b);
            this.n3();
            this.mp();
        };
        TimeXAxis.prototype.cx = function () {
            var a = _super.prototype.cx.call(this);
            this.n3();
            return a;
        };
        Object.defineProperty(TimeXAxis.prototype, "omission", {
            get: function () {
                return this._omission;
            },
            set: function (a) {
                this._omission = a;
            },
            enumerable: false,
            configurable: true
        });
        TimeXAxis.prototype.n4 = function () {
            var e_2, _a;
            var a = this.na(this.breaks);
            var b = (0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b += (+(c.c) - +(c.d));
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            this.omission = b;
        };
        TimeXAxis.prototype.na = function (a) {
            var e_3, _a;
            var b = new i2.List$1(TimeAxisBreak.$, 0);
            if (a == null || +(this.actualMaximumValue) == +(i2.dateMaxValue())) {
                return b;
            }
            var _loop_1 = function (c) {
                if (c.c >= this_1.actualMinimumValue && c.d <= this_1.actualMaximumValue) {
                    b.add(c);
                }
                if (c.i != (0)) {
                    var d = +(c.c) - +(c.d);
                    var e_4 = i2.dateAdd(+(c.d), +(c.i));
                    var _loop_2 = function () {
                        var f = this_1.ng(e_4, d);
                        var g = ((function () {
                            var $ret = new TimeAxisBreak();
                            $ret.d = e_4;
                            $ret.c = f;
                            return $ret;
                        })());
                        if (g.c >= this_1.actualMinimumValue && g.d <= this_1.actualMaximumValue) {
                            b.add(g);
                        }
                        if (i2.dateSubtract(+(i2.dateMaxValue()), +(c.i)) < g.d) {
                            return "break";
                        }
                        e_4 = this_1.ng(g.d, c.i);
                    };
                    while (e_4 <= this_1.actualMaximumValue) {
                        var state_1 = _loop_2();
                        if (state_1 === "break")
                            break;
                    }
                }
            };
            var this_1 = this;
            try {
                for (var _b = tslib.__values(i2.fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    _loop_1(c);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return b;
        };
        TimeXAxis.prototype.ng = function (a, b) {
            var c = i2.dateFromTicks(a.getTime());
            c.setMilliseconds(c.getMilliseconds() + b);
            return c;
        };
        TimeXAxis.prototype.n3 = function () {
            var e_5, _a;
            this.mv = new OrderedDictionary$2(TimeAxisBreak.$, i2.Number_$type);
            if (+(this.actualMaximumValue) == +(i2.dateMaxValue()) || this.breaks == null || this.breaks.count == 0 || this.bh == null) {
                return;
            }
            var a = new i2.List$1(TimeAxisBreak.$, 1, this.na(this.breaks));
            a.aa(function (b, c) { return b.d < c.d ? -1 : b.d > c.d ? 1 : 0; });
            var b = this.bh.pg;
            var c = new ScalerParams(0, this.bh.pg, this.bh.pv, this.cc, this.bh.pk);
            var d = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
            var e = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    var g = i2.timeSpanTicks((+(f.d) - +(this.actualMinimumValue))) / i2.timeSpanTicks(d);
                    var h = i2.timeSpanTicks((+(f.c) - +(this.actualMinimumValue))) / i2.timeSpanTicks(d);
                    if (h < 0 || g - e > 1) {
                        continue;
                    }
                    this.mv.addItem(f, g - e);
                    e += (h - g);
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        };
        TimeXAxis.prototype.fw = function (a) {
            if (i2.isNaN_(a)) {
                return null;
            }
            var ticks_ = i2.truncate(a);
            var b = (new Date(ticks_));
            var c = this.fi(b);
            if (c == null) {
                return null;
            }
            return c.toString();
        };
        TimeXAxis.prototype.fi = function (a) {
            if (!(i2.typeCast(i2.Date_$type, a) !== null)) {
                return _super.prototype.fi.call(this, a);
            }
            var b = i2.dateMinValue();
            var c = false;
            if (this.np != null) {
                if (i2.typeCast(i2.Date_$type, this.np) !== null) {
                    b = this.np;
                    c = true;
                }
            }
            var d = TimeXAxis.no(a, c, b, this.m7, this.n2, this.labelFormats, this.e3);
            return d == null ? _super.prototype.fi.call(this, a) : d;
        };
        TimeXAxis.no = function (a, b, c, d, e, f, g) {
            var h = TimeXAxis.nt(a, b, c, d, e, f, g);
            return i2.dateToStringFormat(a, h, g);
        };
        TimeXAxis.nt = function (a, b, c, d, e, f, g) {
            var e_6, _a;
            var h = 0;
            if (b) {
                h = TimeXAxis.m8(a, c);
            }
            var i = null;
            var j;
            if (f == null || f.count == 0) {
                j = TimeXAxis.ns(e, h, d);
            }
            else {
                var k = Number.MAX_VALUE;
                var l = null;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var m = _c.value;
                        if (m.o < k) {
                            k = m.o;
                            l = m;
                        }
                        if (m.o > e) {
                            continue;
                        }
                        if (i == null || m.o > i.o) {
                            i = m;
                        }
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
                if (i == null) {
                    i = l;
                }
                if (i == null) {
                    return null;
                }
                switch (h) {
                    case 3:
                        if (i.h != null) {
                            j = i.h;
                        }
                        else if (i.j != null) {
                            j = i.j;
                        }
                        else if (i.l != null) {
                            j = i.l;
                        }
                        else {
                            j = i.e;
                        }
                        break;
                    case 2:
                        if (i.j != null) {
                            j = i.j;
                        }
                        else if (i.l != null) {
                            j = i.l;
                        }
                        else {
                            j = i.e;
                        }
                        break;
                    case 1:
                        if (i.l != null) {
                            j = i.l;
                        }
                        else {
                            j = i.e;
                        }
                        break;
                    default:
                        j = i.e;
                        break;
                }
            }
            return j;
        };
        TimeXAxis.m8 = function (a, b) {
            if (a.getFullYear() == b.getFullYear() && i2.dateGetMonth(a) == i2.dateGetMonth(b) && a.getDate() == b.getDate()) {
                return 3;
            }
            else if (a.getFullYear() == b.getFullYear() && i2.dateGetMonth(a) == i2.dateGetMonth(b)) {
                return 2;
            }
            else if (a.getFullYear() == b.getFullYear()) {
                return 1;
            }
            return 0;
        };
        TimeXAxis.prototype.get_ls = function () {
            return _super.prototype.get_ls.call(this) || (this.intervals != null && this.intervals.count > 0);
        };
        TimeXAxis.prototype.set_ls = function (a) {
            _super.prototype.set_ls.call(this, a);
        };
        Object.defineProperty(TimeXAxis.prototype, "intervals", {
            get: function () {
                return this.m2;
            },
            enumerable: false,
            configurable: true
        });
        TimeXAxis.prototype.nr = function (a, b) {
            return TimeXAxis.ns(this.n2, a, b);
        };
        TimeXAxis.ns = function (a, b, c) {
            if (c != 2) {
                b = 0;
            }
            a = Math.abs(a);
            if (a > i2.timeSpanInit3(1825, 0, 0, 0)) {
                return "yyyy";
            }
            if (a > i2.timeSpanInit3(365, 0, 0, 0)) {
                switch (b) {
                    case 3:
                    case 2:
                    case 1: return "MMM";
                }
                return "MMM yyyy";
            }
            ;
            if (a > i2.timeSpanInit3(4, 0, 0, 0)) {
                switch (b) {
                    case 3:
                    case 2: return "dd";
                }
                return "MMM dd";
            }
            ;
            if (a > i2.timeSpanInit3(1, 0, 0, 0)) {
                switch (b) {
                    case 3: return "hh:mmtt";
                    case 2: return "dd hh:mmtt";
                }
                return "MMM dd hh:mmtt";
            }
            ;
            if (a > i2.timeSpanInit1(0, 10, 0)) {
                return "hh:mm";
            }
            return "hh:mm:ss";
        };
        TimeXAxis.mw = function () {
            if (TimeXAxis.mu == null) {
                TimeXAxis.mu = ((function () {
                    var $ret = new OrderedDictionary$2(i2.Number_$type, TimeAxisInterval.$);
                    $ret.addItem((0), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 0;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromMilliseconds(1), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 1;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromSeconds(1), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 2;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromSeconds(30), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 2;
                        $ret.f = 30;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromMinutes(2), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 3;
                        $ret.f = 2;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromMinutes(5), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 3;
                        $ret.f = 5;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromHours(1), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 4;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(1), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 5;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(2), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 5;
                        $ret.f = 2;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(5), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 5;
                        $ret.f = 5;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(10), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 5;
                        $ret.f = 10;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(30), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 7;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(60), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 7;
                        $ret.f = 3;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(365), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 8;
                        $ret.f = 1;
                        return $ret;
                    })()));
                    $ret.addItem(i2.timeSpanFromDays(365 * 10), ((function () {
                        var $ret = new TimeAxisInterval();
                        $ret.b = 8;
                        $ret.f = 10;
                        return $ret;
                    })()));
                    return $ret;
                })());
            }
            return TimeXAxis.mu;
        };
        TimeXAxis.prototype.m0 = function () {
            var e_7, _a;
            if (this.cy && (this.ay == null || this.ay.angle == 0)) {
                var a = this.ek();
                var b = this.js.width;
                var c = i2.truncate(Math.floor(b / a));
                var d = Number.MAX_VALUE;
                var e = c == 0 ? d : i2.timeSpanFromTicks((i2.intDivide(i2.timeSpanTicks(this.n2), c)));
                var f = null;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(TimeXAxis.mw())), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var g = _c.value;
                        f = g.value;
                        if (g.key > e) {
                            break;
                        }
                    }
                }
                catch (e_7_1) {
                    e_7 = { error: e_7_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_7)
                            throw e_7.error;
                    }
                }
                var h = this.mz;
                if (h != f) {
                    this.hu();
                }
                this.mz = f;
                return f;
            }
            var i = this.n2;
            if (i == (0)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 1;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(365 * 100)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 10;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(365 * 5)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 1;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(365 * 2)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 7;
                    $ret.f = 3;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(150)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 7;
                    $ret.f = 1;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(60)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 10;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(30)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 5;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(20)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 2;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(4)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 1;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromDays(1)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 4;
                    $ret.f = 12;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromHours(6)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 4;
                    $ret.f = 1;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromMinutes(30)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 3;
                    $ret.f = 5;
                    return $ret;
                })());
            }
            if (i >= i2.timeSpanFromMinutes(10)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 3;
                    $ret.f = 2;
                    return $ret;
                })());
            }
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 2;
                $ret.f = 30;
                return $ret;
            })());
        };
        TimeXAxis.prototype.m1 = function () {
            var e_8, _a;
            if (this.intervals == null || this.intervals.count == 0) {
                return this.m0();
            }
            if (this.n2 == (0)) {
                return ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 1;
                    return $ret;
                })());
            }
            var a = null;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.intervals)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b.k > this.n2) {
                        continue;
                    }
                    if (a == null || b.k > a.k) {
                        a = b;
                    }
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            return a == null ? this.m0() : a;
        };
        TimeXAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = !b.isEmpty ? this.js : i2.Rect.empty;
            var d = this.jn();
            var e = this.jm();
            var f = new ScalerParams(0, b, c, this.cc, d);
            if (this.lo == null && !this.lu() && !this.lv()) {
                return;
            }
            if (!b.isEmpty && !c.isEmpty) {
                var g = c.bottom;
                var h = g - c.top;
                if (this.ai != null) {
                    var i = i2.typeCast(NumericYAxis.$, this.ai);
                    if (i != null) {
                        var j = this.hv(g, h, b, c, d, c.top, c.bottom);
                        g = j.p0;
                        h = j.p1;
                    }
                }
                if (i2.isNaN_(g)) {
                    g = 0;
                }
                this.g8(this.a4.ay(), g, c, this.a4.e(), true);
                this.av.bc = h;
                var k = i2.truncate(Math.ceil(e.right));
                var l = i2.truncate(Math.floor(e.left));
                var m = this.a4.a1();
                var n = this.a4.f();
                var o = this.a4.az();
                this.mp();
                var p = new i2.List$1(i2.Date_$type, 1, this.m9());
                var q = new i2.List$1(i2.Number_$type, 0);
                for (var r = 0; r < p.count; r++) {
                    q.add(p._inner[r].getTime());
                }
                this.g5(q, 0, q.count, f);
                this.np = null;
                for (var s = 0; s < p.count; s++) {
                    var t = p._inner[s];
                    var u = q._inner[s];
                    var v = i2.truncate(Math.round(u));
                    if (v <= k) {
                        if (s % 2 == 0) {
                            var w = s < q.count - 1 ? q._inner[s + 1] : e.right;
                            this.h2(m, u, w, c);
                        }
                        this.h1(o, u, c, n, false);
                        this.kd.add(u);
                    }
                    if (v >= l && v <= k) {
                        var x = this.fi(t);
                        this.np = t;
                        if (x != null) {
                            this.c5.add1(x);
                            this.c6.add(new LabelPosition(u));
                        }
                    }
                }
                this.np = null;
            }
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.jq();
                }
            }
            this.av.a5 = this.c5;
            this.av.a6 = this.c6;
            this.ld();
        };
        TimeXAxis.prototype.m9 = function () {
            var a = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var b = !a.isEmpty ? this.js : i2.Rect.empty;
            var c = this.jn();
            var d = this.jm();
            var e = new ScalerParams(0, a, b, this.cc, c);
            var f = this.m1();
            var g = this.ni;
            if (!this.lv() && f != null) {
                if (f.b == 7 && g.getDate() != 1) {
                    g = i2.dateAddMonths(g, 1);
                    g = i2.dateFromValues(g.getFullYear(), i2.dateGetMonth(g), 1, 0, 0, 0, 0);
                }
                else if (f.b == 5 && i2.dateGetTimeOfDay(g) != (0)) {
                    g = i2.dateAddDays(g, 1);
                    g = i2.dateFromValues(g.getFullYear(), i2.dateGetMonth(g), g.getDate(), 0, 0, 0, 0);
                }
                else if (f.b == 4 && g.getMinutes() != 0) {
                    g = i2.dateAddHours(g, 1);
                    g = i2.dateFromValues(g.getFullYear(), i2.dateGetMonth(g), g.getDate(), g.getHours(), 0, 0, 0);
                }
            }
            var h = new i2.List$1(i2.Date_$type, 0);
            var i = 0;
            var j = 10000;
            if (f.f == 0) {
                return h;
            }
            while (g <= this.visibleMaximum && i++ < j) {
                var k = this.nb(g);
                var l = g;
                if (k.key != null) {
                    l = f.d(k.key.c);
                }
                h.add(l);
                while (g <= l) {
                    g = f.c(g);
                }
            }
            return h;
        };
        TimeXAxis.prototype.nb = function (a) {
            var e_9, _a;
            if (this.mv == null) {
                return new i2.KeyValuePair$2(TimeAxisBreak.$, i2.Number_$type);
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.mv)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b.key.d <= a && b.key.c >= a) {
                        return b;
                    }
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            return new i2.KeyValuePair$2(TimeAxisBreak.$, i2.Number_$type);
        };
        Object.defineProperty(TimeXAxis.prototype, "visibleMinimum", {
            get: function () {
                return this.nf;
            },
            set: function (a) {
                this.nf = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeXAxis.prototype, "ni", {
            get: function () {
                return this.nd;
            },
            set: function (a) {
                this.nd = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeXAxis.prototype, "nh", {
            get: function () {
                return this.nc;
            },
            set: function (a) {
                this.nc = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeXAxis.prototype, "visibleMaximum", {
            get: function () {
                return this.ne;
            },
            set: function (a) {
                this.ne = a;
            },
            enumerable: false,
            configurable: true
        });
        TimeXAxis.prototype.mp = function () {
            _super.prototype.mp.call(this);
            if (this.bh == null || !i2.Extensions.b(this.bh.pv)) {
                return;
            }
            var a = new ScalerParams(0, this.bh.pg, this.bh.pv, this.cc, this.bh.pk);
            var b = this.jm();
            var c = b.left;
            var d = b.right;
            var e = b.left;
            var f = b.right;
            if (this.categoryMode != 0) {
                var g = this.getCategorySize(a.e, a.d, a.c);
                e += g / 2;
                f -= g / 2;
            }
            var h = i2.truncate(this.eb(c, a));
            var i = i2.truncate(this.eb(d, a));
            var j = i2.truncate(this.eb(e, a));
            var k = i2.truncate(this.eb(f, a));
            if (j < 0 || k < 0) {
                this.n2 = (0);
                return;
            }
            h = Math.min(i2.dateMaxValue().getTime(), h);
            i = Math.min(i2.dateMaxValue().getTime(), i);
            h = Math.max(i2.dateMinValue().getTime(), h);
            i = Math.max(i2.dateMinValue().getTime(), i);
            j = Math.min(i2.dateMaxValue().getTime(), j);
            k = Math.min(i2.dateMaxValue().getTime(), k);
            var l = i2.dateFromTicks(Math.min(h, i));
            var m = i2.dateFromTicks(Math.max(h, i));
            var n = i2.dateFromTicks(Math.min(j, k));
            var o = i2.dateFromTicks(Math.max(j, k));
            var p = +(this.visibleMinimum) != +n || +(this.visibleMaximum) != +o;
            this.visibleMinimum = n;
            this.visibleMaximum = o;
            this.ni = l;
            this.nh = m;
            if (p && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, i2.EventArgs.empty);
            }
            this.n2 = +(this.visibleMaximum) - +(this.visibleMinimum);
        };
        TimeXAxis.prototype.kk = function (a, b, c, d, e) {
            return 0;
        };
        TimeXAxis.prototype.i$f = function (a) {
            var b = this;
            if (b.i$b == null || b.i$b.count == 0) {
                return -1;
            }
            var c = new SortedListView$1(i2.Date_$type, this.lo, b.i$b);
            var ticks_ = a;
            var d = (new Date(ticks_));
            var e = this.l8(d, c);
            e = Math.max(0, Math.min(b.i$b.count - 1, e));
            var f = c.item(e);
            var g;
            var h;
            if (f < d) {
                g = e;
                h = g + 1;
            }
            else {
                h = e;
                g = e - 1;
            }
            if (g < 0) {
                return h;
            }
            if (h >= b.i$b.count) {
                return g;
            }
            var i = c.item(g);
            var j = c.item(h);
            var k = new ScalerParams(0, this.bh.pw, this.js, this.cc, this.bh.pk);
            this.startCursor();
            var l = this.d8(i.getTime(), k);
            var m = this.d8(a, k);
            var n = this.d8(j.getTime(), k);
            this.resetCursor();
            if (i < this.ni && j <= this.nh) {
                return this.lx._inner[h];
            }
            if (j > this.nh && i >= this.ni) {
                return this.lx._inner[g];
            }
            if (Math.abs(l - m) < Math.abs(n - m)) {
                return this.lx._inner[g];
            }
            else {
                return this.lx._inner[h];
            }
        };
        TimeXAxis.prototype.n5 = function (a, b) {
            var e_10, _a;
            this.n4();
            this.n3();
            if (this.av != null) {
                this.av.ak = this.breaks.count > 0;
            }
            this.hq(false);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.l0(false);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        };
        TimeXAxis.prototype.n7 = function (a, b) {
            this.hq(false);
        };
        TimeXAxis.prototype.n6 = function (a, b) {
            this.hq(false);
        };
        TimeXAxis.prototype.get_b7 = function () {
            return false;
        };
        TimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
            var c = +(this.actualMaximumValue) - +(this.actualMinimumValue);
            var d = i2.timeSpanTotalMilliseconds((+a - +(this.actualMinimumValue))) / i2.timeSpanTotalMilliseconds(c);
            var e = 1 - (i2.timeSpanTotalMilliseconds((+(this.actualMaximumValue) - +b)) / i2.timeSpanTotalMilliseconds(c));
            e = Math.min(1, e);
            return new i2.Rect(0, d, NaN, Math.max(0, e - d), NaN);
        };
        TimeXAxis.prototype.getCategorySize = function (a, b, c) {
            if (this.n2 != (0)) {
                var d = i2.timeSpanFromTicks(i2.truncate((i2.timeSpanTicks(this.n2) * (a.width / (this.bh != null ? this.bh.pg.width : 1)))));
                var e = i2.timeSpanTicks(d) / i2.timeSpanTicks(this.n0);
                var f = b.width / 4;
                return Math.min(f, b.width / (e + 1));
            }
            return _super.prototype.getCategorySize.call(this, a, b, c);
        };
        TimeXAxis.nz = function (a, b) {
            var c = Math.min(5, b);
            var d = a(0);
            var e = new i2.Dictionary$2(i2.Number_$type, i2.Number_$type, 0);
            var f = 0;
            var g = (0);
            for (var h = 0; h < c; h++) {
                var i = a(h);
                var j = +i - +d;
                if (!e.containsKey(j)) {
                    e.addItem(j, 0);
                }
                e.item(j, e.item(j) + 1);
                if (e.item(j) > f) {
                    f = e.item(j);
                    g = j;
                }
                d = i;
            }
            return g;
        };
        TimeXAxis.prototype.ny = function () {
            var _this = this;
            if (this.lo == null || this.lo.count < 2 || this.lx == null) {
                return (0);
            }
            return TimeXAxis.nz(function (a) { return _this.lo.item(_this.lx._inner[a]); }, this.lo.count);
        };
        TimeXAxis.prototype.ml = function () {
            _super.prototype.ml.call(this);
            this.n0 = this.ny();
        };
        TimeXAxis.nv = function (a) {
            if (a >= i2.timeSpanFromDays(1)) {
                return "D";
            }
            return "g";
        };
        TimeXAxis.prototype.itemLabelFormat = function () {
            return TimeXAxis.nv(this.n0);
        };
        TimeXAxis.prototype.l7 = function (a, b, c, d) {
            return this.l6(this.visibleMinimum);
        };
        TimeXAxis.prototype.ma = function (a, b, c, d) {
            return this.l9(this.visibleMaximum);
        };
        Object.defineProperty(TimeXAxis.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        TimeXAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        TimeXAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        TimeXAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        TimeXAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        TimeXAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(TimeXAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TimeXAxis.prototype, "i$a", {
            get: function () {
                return this.b9;
            },
            enumerable: false,
            configurable: true
        });
        TimeXAxis.$t = i2.markType(TimeXAxis, 'TimeXAxis', TimeAxisBase.$, [ITimeRangeSelectorAxis_$type]);
        TimeXAxis.mu = null;
        return TimeXAxis;
    }(TimeAxisBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OrdinalTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OrdinalTimeXAxis, _super);
        function OrdinalTimeXAxis() {
            var _this = _super.call(this) || this;
            _this.mk = i2.dateMaxValue();
            _this.mj = i2.dateMinValue();
            _this.mq = i2.dateMaxValue();
            _this.mp = i2.dateMinValue();
            _this.mm = i2.dateMaxValue();
            _this.ml = i2.dateMinValue();
            _this.m0 = null;
            _this.mz = null;
            _this.mf = 0;
            _this.mh = null;
            _this.md = null;
            _this.m9 = 0;
            _this.mo = i2.dateMinValue();
            _this.mn = i2.dateMaxValue();
            _this.visibleRangeChanged = null;
            i2.FastItemDateTimeColumn.o();
            _this.md = new TimeAxisLabelFormatCollection();
            var a = _this.me;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.nb));
            _this.l3 = 0;
            return _this;
        }
        OrdinalTimeXAxis.prototype.ea = function (a, b, c) {
            return this.d8(a, new ScalerParams(0, b, c, this.cc, this.jn()));
        };
        OrdinalTimeXAxis.prototype.d9 = function (a, b, c) {
            return this.d8(a, b);
        };
        OrdinalTimeXAxis.prototype.d8 = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.mx(a, NumericScaler.ac, b.c);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.mx(a, b.e, b.d);
        };
        OrdinalTimeXAxis.prototype.mx = function (a, b, c) {
            var d = this.l2;
            var e = this.l3;
            var f = this.l2 - this.l3;
            var g = f >= 1 ? (a - e) / (d - e) : f == 0 ? 0.5 : NaN;
            if (this.cd) {
                g = 1 - g;
            }
            return c.left + c.width * (g - b.left) / b.width;
        };
        OrdinalTimeXAxis.prototype.g4 = function (a, b, c, d, e) {
            var f;
            var g = e.e;
            var h = e.d;
            var i = e.c;
            var j = e.a;
            var k = !i.isEmpty;
            var l = i.left;
            var m = i.width;
            var n = g.left;
            var o = g.width;
            var p = h.left;
            var q = h.width;
            var r = 0;
            var s = 1;
            var t = this.l2;
            var u = this.l3;
            var v = this.l2 - this.l3;
            var w = this.ln(a);
            var x = w != null;
            for (var y = 0; y < b.count; y++) {
                var z = b.item(y);
                for (var aa = c; aa < d; aa++) {
                    f = x ? w[aa] : a.item(aa);
                    if (k) {
                        var ab = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ab = 1 - ab;
                        }
                        ab = l + m * (ab - r) / s;
                        var ac = (ab - p) / q;
                        ac = p + q * (ac - n) / o;
                        f[z] = ac;
                    }
                    else {
                        var ad = v >= 1 ? (f[z] - u) / (t - u) : v == 0 ? 0.5 : NaN;
                        if (j) {
                            ad = 1 - ad;
                        }
                        ad = p + q * (ad - n) / o;
                        f[z] = ad;
                    }
                }
            }
        };
        OrdinalTimeXAxis.prototype.g5 = function (a, b, c, d) {
            for (var e = b; e < c; e++) {
                a.item(e, this.d8(a.item(e), d));
            }
        };
        OrdinalTimeXAxis.prototype.ed = function (a, b, c) {
            return this.eb(a, new ScalerParams(0, b, this.js, this.cc, this.jn()));
        };
        OrdinalTimeXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
            return this.eb(a, new ScalerParams(0, b, this.js, this.cc, this.jn()));
        };
        OrdinalTimeXAxis.prototype.eb = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.my(c, NumericScaler.ac, b.c);
                return c;
            }
            return this.my(a, b.e, b.d);
        };
        OrdinalTimeXAxis.prototype.my = function (a, b, c) {
            var d = b.left + (a - c.left) * b.width / c.width;
            if (this.cd) {
                d = 1 - d;
            }
            return this.l3 + d * (this.l2 - this.l3);
        };
        OrdinalTimeXAxis.prototype.ec = function (a, b, c) {
            return this.eb(a, b);
        };
        OrdinalTimeXAxis.prototype.g6 = function (a, b, c, d) {
            for (var e = b; e < c; e++) {
                a.item(e, this.eb(a.item(e), d));
            }
        };
        OrdinalTimeXAxis.prototype.he = function (a, b, c, d) {
            _super.prototype.he.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    var e = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.mi);
                        this.mi = null;
                    }
                    if (this.j6 != null) {
                        this.mi = TimeAxisBase.lq(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeMemberPath":
                    if (this.j6 != null) {
                        this.j6.deregisterColumn(this.mi);
                        this.mi = TimeAxisBase.lq(this.dateTimeMemberPath, this);
                    }
                    break;
                case "DateTimeColumn":
                    this.cv();
                    this.m9 = this.m8();
                    break;
                case "MinimumValue":
                case "MaximumValue":
                    this.cv();
                    this.hp();
                    break;
                case "LabellingMode":
                    this.hp();
                    break;
            }
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMinimumValue", {
            get: function () {
                return this.mk;
            },
            set: function (a) {
                this.mk = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMaximumValue", {
            get: function () {
                return this.mj;
            },
            set: function (a) {
                this.mj = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMinimum", {
            get: function () {
                return this.mq;
            },
            set: function (a) {
                this.mq = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMaximum", {
            get: function () {
                return this.mp;
            },
            set: function (a) {
                this.mp = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "mu", {
            get: function () {
                return this.mm;
            },
            set: function (a) {
                this.mm = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "mt", {
            get: function () {
                return this.ml;
            },
            set: function (a) {
                this.ml = a;
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.prototype.nc = function () {
            if (this.mi == null || this.mi.count == 0 || this.mi.count < this.l3 - 1) {
                this.actualMinimumValue = i2.dateMinValue();
                this.actualMaximumValue = i2.dateMaxValue();
                return;
            }
            var a = Math.max(0, Math.min(this.l3, this.mi.count - 1));
            var b = Math.max(0, Math.min(this.l2, this.mi.count - 1));
            var c = +(this.actualMinimumValue) != +(this.mi.item(a)) || +(this.actualMaximumValue) != +(this.mi.item(b));
            if (c) {
                var d = this.actualMinimumValue;
                var e = this.actualMaximumValue;
                this.actualMinimumValue = this.mi.item(a);
                this.actualMaximumValue = this.mi.item(b);
                this.nd();
            }
        };
        OrdinalTimeXAxis.prototype.nd = function () {
            if (this.mi == null || this.mi.count == 0 || this.bh == null) {
                var a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
                this.visibleMinimum = this.actualMinimumValue;
                this.visibleMaximum = this.actualMaximumValue;
                this.mu = this.visibleMinimum;
                this.mt = this.visibleMaximum;
                if (a && this.visibleRangeChanged != null) {
                    this.visibleRangeChanged(this, i2.EventArgs.empty);
                }
                return;
            }
            var b = this.jm();
            var c = new ScalerParams(1, this.bh.pw, this.bh.pv, this.cc);
            c.c = this.jn();
            var d = this.eb(b.left, c);
            var e = this.eb(b.right, c);
            var f = i2.truncate(Math.floor(d));
            var g = i2.truncate(Math.ceil(e));
            var h = f >= 0 && f < this.mi.count ? this.mi.item(f) : this.actualMinimumValue;
            var i = g >= 0 && g < this.mi.count ? this.mi.item(g) : this.actualMaximumValue;
            var j = h;
            var k = i;
            if (d > f) {
                var l = f + 1;
                var m = l >= 0 && l < this.mi.count ? this.mi.item(l) : i;
                var n = i2.dateAdd(+h, +(i2.timeSpanFromMilliseconds(i2.timeSpanTotalMilliseconds((+m - +h)) * (d - f))));
                j = n;
            }
            if (e < g) {
                var o = g - 1;
                var p = o >= 0 && o < this.mi.count ? this.mi.item(o) : h;
                var q = i2.dateSubtract(+i, +(i2.timeSpanFromMilliseconds(i2.timeSpanTotalMilliseconds((+i - +p)) * (g - e))));
                k = q;
            }
            this.mu = j;
            this.mt = k;
            var r = +(this.visibleMinimum) != +h || +(this.visibleMaximum) != +i;
            this.visibleMinimum = h;
            this.visibleMaximum = i;
            if (r && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, i2.EventArgs.empty);
            }
        };
        OrdinalTimeXAxis.prototype.hr = function (a) {
            var b = TimeXAxis.nt(this.actualMinimumValue, false, this.actualMinimumValue, this.mg, this.m7, this.me, this.e3);
            if (b != this.m0 && this.cy) {
                this.hu();
            }
            this.m0 = b;
            _super.prototype.hr.call(this, a);
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "dateTimeMemberPath", {
            get: function () {
                return this.mz;
            },
            set: function (a) {
                var b = this.dateTimeMemberPath;
                if (a != b) {
                    this.mz = a;
                    this.hk("DateTimeMemberPath", b, this.dateTimeMemberPath);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "mg", {
            get: function () {
                return this.mf;
            },
            set: function (a) {
                var b = this.mg;
                if (a != b) {
                    this.mf = a;
                    this.hk("LabellingMode", i2.enumGetBox(TimeAxisLabellingMode_$type, b), i2.enumGetBox(TimeAxisLabellingMode_$type, this.mg));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "mi", {
            get: function () {
                return this.mh;
            },
            set: function (a) {
                if (this.mh != a) {
                    var b = this.mh;
                    this.mh = a;
                    this.hk("DateTimeColumn", b, this.mh);
                }
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.prototype.h4 = function (a, b) {
            _super.prototype.h4.call(this, a, b);
            this.nd();
        };
        OrdinalTimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
            if (this.mi == null) {
                return i2.Rect.empty;
            }
            var c = a > b;
            var d = c ? b : a;
            var e = c ? a : b;
            var f = -1;
            while (++f < this.mi.count && this.mi.item(f) < d) {
            }
            var g = this.mi.count;
            while (--g >= 0 && this.mi.item(g) > e) {
            }
            var h = new ScalerParams(0, new i2.Rect(0, 0, 0, 1, 1), new i2.Rect(0, 0, 0, 1, 1), this.cc, this.bh.pk);
            var i = this.d8(f, h);
            var j = this.d8(g + 1, h);
            return new i2.Rect(0, i, NaN, Math.max(0, j - i), NaN);
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "me", {
            get: function () {
                return this.md;
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.prototype.nb = function (a, b) {
            this.hq(false);
        };
        OrdinalTimeXAxis.prototype.hg = function (a) {
            _super.prototype.hg.call(this, a);
            this.dateTimeMemberPath = a;
        };
        OrdinalTimeXAxis.prototype.fi = function (a) {
            if (this.at != null) {
                return this.at(a);
            }
            if (this.ah != null) {
                return this.ah.i(a);
            }
            if (!(i2.typeCast(i2.Date_$type, a) !== null)) {
                return _super.prototype.fi.call(this, a);
            }
            var b = i2.dateMinValue();
            var c = false;
            if (this.l4 != null) {
                if (i2.typeCast(i2.Date_$type, this.l4) !== null) {
                    b = this.l4;
                    c = true;
                }
            }
            var d = TimeXAxis.no(a, c, b, this.mg, this.m7, this.me, this.e3);
            return d == null ? _super.prototype.fi.call(this, a) : d;
        };
        OrdinalTimeXAxis.prototype.fw = function (a) {
            var b = 0;
            if (this.categoryMode == 0) {
                b = i2.truncate(Math.round(a));
            }
            else {
                b = i2.truncate(Math.floor(a));
            }
            if (b < 0 || b > this.kr - 1) {
                return _super.prototype.fw.call(this, a);
            }
            var c = this.mi.item(b);
            var d = this.fi(c);
            if (d == null) {
                return null;
            }
            return d.toString();
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "na", {
            get: function () {
                return +(this.visibleMaximum) - +(this.visibleMinimum);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "m7", {
            get: function () {
                return +(this.mt) - +(this.mu);
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.prototype.lp = function () {
            return this.mi;
        };
        OrdinalTimeXAxis.prototype.h3 = function (a, b) {
            _super.prototype.h3.call(this, a, b);
            this.nd();
        };
        OrdinalTimeXAxis.prototype.lw = function (a, b) {
            var c = this.categoryMode == 0 ? 0 : 0.5;
            return _super.prototype.lw.call(this, a + c, b);
        };
        OrdinalTimeXAxis.prototype.lv = function (a, b, c, d) {
            return b;
        };
        OrdinalTimeXAxis.prototype.m8 = function () {
            var _this = this;
            if (this.mi == null || this.mi.count < 2) {
                return (0);
            }
            return TimeXAxis.nz(function (a) { return _this.mi.item(a); }, this.mi.count);
        };
        OrdinalTimeXAxis.prototype.itemLabelFormat = function () {
            return TimeXAxis.nv(this.m9);
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "minimumValue", {
            get: function () {
                return this.mo;
            },
            set: function (a) {
                var b = this.minimumValue;
                if (+a != +b) {
                    this.mo = a;
                    this.he(this, "MinimumValue", b, this.minimumValue);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(OrdinalTimeXAxis.prototype, "maximumValue", {
            get: function () {
                return this.mn;
            },
            set: function (a) {
                var b = this.maximumValue;
                if (+a != +b) {
                    this.mn = a;
                    this.he(this, "MaximumValue", b, this.maximumValue);
                }
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.prototype.cx = function () {
            if (+(this.minimumValue) == +(i2.dateMaxValue()) || +(this.maximumValue) == +(i2.dateMinValue())) {
                return _super.prototype.cx.call(this);
            }
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null || this.mi == null) {
                return false;
            }
            var a = this.l3;
            if (+(this.minimumValue) != +(i2.dateMinValue())) {
                var b = -1;
                while (b++ <= this.mi.count) {
                    if (this.mi.item(b) >= this.minimumValue) {
                        break;
                    }
                }
                a = b;
            }
            var c = this.categoryMode == 0 ? this.j6.count - 1 : this.j6.count;
            if (+(this.maximumValue) != +(i2.dateMaxValue())) {
                var d = this.j6.count;
                while (d-- > 0) {
                    if (this.mi.item(d) <= this.maximumValue) {
                        break;
                    }
                }
                c = d;
            }
            if (a != this.l3 || c != this.l2) {
                var e = new AxisRangeChangedEventArgs(0, this.l3, a, this.l2, c);
                this.l3 = a;
                this.l2 = c;
                this.hl(e);
                this.nc();
                this.k2();
                return true;
            }
            return false;
        };
        OrdinalTimeXAxis.prototype.lb = function (a) {
            _super.prototype.lb.call(this, a);
            this.cw(true);
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        OrdinalTimeXAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        OrdinalTimeXAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        OrdinalTimeXAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        OrdinalTimeXAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(OrdinalTimeXAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        OrdinalTimeXAxis.$t = i2.markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
        return OrdinalTimeXAxis;
    }(CategoryXAxis));

    var IgxTimeAxisLabelFormatCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTimeAxisLabelFormatCollection, _super);
        function IgxTimeAxisLabelFormatCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxTimeAxisLabelFormatComponent.$type) {
                IgxTimeAxisLabelFormatComponent.$type = i2.markType(IgxTimeAxisLabelFormatComponent, "IgxTimeAxisLabelFormatComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxTimeAxisLabelFormatCollection.prototype._createInnerColl = function () {
            if (!IgxTimeAxisLabelFormatComponent.$type) {
                IgxTimeAxisLabelFormatComponent.$type = i2.markType(IgxTimeAxisLabelFormatComponent, "IgxTimeAxisLabelFormatComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxTimeAxisLabelFormatComponent.$type, TimeAxisLabelFormat.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxTimeAxisLabelFormatComponent();
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxTimeAxisLabelFormatCollection;
    }(i2.IgCollection));

    /**
     * A horizontal axis that uses an ordinal DateTime scale.
     * On an ordinal time axis, datapoints are aligned according to their order in the ItemsSource, like a category axis.
    *
    * You can use the `IgxOrdinalTimeXAxisComponent` to display dates at equidistant.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-ordinal-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-ordinal-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxOrdinalTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    *
    * ```ts
    * this.series.xAxis = this.ordinalTimeXAxis;
    * this.series.yAxis = this.numericYAxis;
    * this.series.xAxisName = "xAxis";
    * this.series.yAxisName = "YAxis";
    * ```
    */
    var IgxOrdinalTimeXAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxOrdinalTimeXAxisComponent, _super);
        function IgxOrdinalTimeXAxisComponent() {
            var _this = _super.call(this) || this;
            _this._labelFormats = null;
            return _this;
        }
        IgxOrdinalTimeXAxisComponent.prototype.createImplementation = function () {
            return new OrdinalTimeXAxis();
        };
        Object.defineProperty(IgxOrdinalTimeXAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxOrdinalTimeXAxisComponent.prototype, "dateTimeMemberPath", {
            /**
             * Gets or sets the DateTime mapping property for the axis.
            */
            get: function () {
                return this.i.dateTimeMemberPath;
            },
            set: function (v) {
                this.i.dateTimeMemberPath = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxOrdinalTimeXAxisComponent.prototype, "labellingMode", {
            /**
             * Gets or sets the labelling mode to use when the automatic label formats are applied.
            */
            get: function () {
                return this.i.mg;
            },
            set: function (v) {
                this.i.mg = i2.ensureEnum(TimeAxisLabellingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxOrdinalTimeXAxisComponent.prototype, "labelFormats", {
            /**
             * A list of axis label formats to apply, which are selected according to the visible axis range.
             * The label format selected will be the one with the largest range smaller than the visible range of the axis.
            *
            * You can use the `labelFormats` for adjusting the labels depending on the range of the time shown by the chart.
            *
            * ```ts
            * let labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "hh:mm:ss";
            * labelFormat.range = 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "hh:mm";
            * labelFormat.range = 60 * 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "MMM-dd-yy";
            * labelFormat.range = 24 * 60 * 60 * 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "MMM yy";
            * labelFormat.range = 365.24 * 24 * 60 * 60 * 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * labelFormat = new TimeAxisLabelFormat();
            * labelFormat.format = "yyyy";
            * labelFormat.range = 5 * 365 * 24 * 60 * 60 * 1000;
            * this.xAxis.labelFormats.add(labelFormat);
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-ordinal-time-x-axis
            * 		[labelFormats]="labelFormats"
            * 		dateTimeMemberPath="time"
            * 		#xAxis>
            *     </igx-ordinal-time-x-axis>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                if (this._labelFormats === null) {
                    var coll = new IgxTimeAxisLabelFormatCollection();
                    var innerColl = this.i.me;
                    if (!innerColl) {
                        innerColl = new TimeAxisLabelFormatCollection();
                    }
                    this._labelFormats = coll._fromInner(innerColl);
                }
                return this._labelFormats;
            },
            set: function (v) {
                if (this._labelFormats !== null) {
                    this._labelFormats._setSyncTarget(null);
                    this._labelFormats = null;
                }
                var coll = new IgxTimeAxisLabelFormatCollection();
                this._labelFormats = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(TimeAxisLabelFormat.$type);
                var innerColl = this.i.me;
                if (!innerColl) {
                    innerColl = new TimeAxisLabelFormatCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._labelFormats._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxOrdinalTimeXAxisComponent.prototype, "minimumValue", {
            /**
             * Sets the minimum DateTime value to be displayed on this axis.
             * This property can be used to constrain the items displayed on the axis, within the range of DateTimes in the ItemsSource.  It will ignore any setting outside the actual range of data.
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxOrdinalTimeXAxisComponent.prototype, "maximumValue", {
            /**
             * Sets the maximum DateTime value to be displayed on this axis.
             * This property can be used to constrain the items displayed on the axis, within the range of DateTimes in the ItemsSource.  It will ignore any setting outside the actual range of data.
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxOrdinalTimeXAxisComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.labelFormats != null && this.labelFormats.findByName && this.labelFormats.findByName(name)) {
                return this.labelFormats.findByName(name);
            }
            return null;
        };
        IgxOrdinalTimeXAxisComponent.prototype.getValueLabel = function (value) {
            var iv = this.i.fw(value);
            return (iv);
        };
        IgxOrdinalTimeXAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxOrdinalTimeXAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxOrdinalTimeXAxisComponent, selector: "igx-ordinal-time-x-axis", inputs: { dateTimeMemberPath: "dateTimeMemberPath", labellingMode: "labellingMode", labelFormats: "labelFormats", minimumValue: "minimumValue", maximumValue: "maximumValue" }, providers: [{ provide: IgxCategoryXAxisComponent, useExisting: i0.forwardRef(function () { return IgxOrdinalTimeXAxisComponent; }) }, { provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxOrdinalTimeXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxOrdinalTimeXAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxOrdinalTimeXAxisComponent;
    }(IgxCategoryXAxisComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-ordinal-time-x-axis',
                        template: "",
                        providers: [{ provide: IgxCategoryXAxisComponent, useExisting: i0.forwardRef(function () { return IgxOrdinalTimeXAxisComponent; }) }, { provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxOrdinalTimeXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxOrdinalTimeXAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { dateTimeMemberPath: [{
                    type: i0.Input
                }], labellingMode: [{
                    type: i0.Input
                }], labelFormats: [{
                    type: i0.Input
                }], minimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOrdinalTimeXAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOrdinalTimeXAxisModule() {
        }
        IgxOrdinalTimeXAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOrdinalTimeXAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisModule, declarations: [IgxOrdinalTimeXAxisComponent], imports: [i1.CommonModule], exports: [IgxOrdinalTimeXAxisComponent] });
        IgxOrdinalTimeXAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisModule, imports: [[i1.CommonModule]] });
        return IgxOrdinalTimeXAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxOrdinalTimeXAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxOrdinalTimeXAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOrdinalTimeXAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOrdinalTimeXAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxOrdinalTimeXAxisComponent", IgxOrdinalTimeXAxisComponent);
            i2.TypeRegistrar.register("OrdinalTimeXAxis", OrdinalTimeXAxis.$type);
        }
        IgxOrdinalTimeXAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOrdinalTimeXAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisDynamicModule, imports: [i1.CommonModule, IgxOrdinalTimeXAxisModule], exports: [IgxOrdinalTimeXAxisModule] });
        IgxOrdinalTimeXAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisDynamicModule, imports: [[i1.CommonModule, IgxOrdinalTimeXAxisModule], IgxOrdinalTimeXAxisModule] });
        return IgxOrdinalTimeXAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOrdinalTimeXAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxOrdinalTimeXAxisModule],
                        exports: [IgxOrdinalTimeXAxisModule],
                        entryComponents: [IgxOrdinalTimeXAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentChangeAxisRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentChangeAxisRenderer, _super);
        function PercentChangeAxisRenderer(a) {
            return _super.call(this, a) || this;
        }
        PercentChangeAxisRenderer.prototype.w = function (a, b, c, d) {
            var e = _super.prototype.w.call(this, a, b, c, d);
            if (a.s == null) {
                e = e.toString() + "%";
            }
            return e;
        };
        PercentChangeAxisRenderer.$t = i2.markType(PercentChangeAxisRenderer, 'PercentChangeAxisRenderer', NumericAxisRenderer.$);
        return PercentChangeAxisRenderer;
    }(NumericAxisRenderer));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentChangeYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentChangeYAxis, _super);
        function PercentChangeYAxis() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PercentChangeYAxis.prototype.j9 = function () {
            return new VerticalPercentChangeScaler(this);
        };
        PercentChangeYAxis.prototype.j2 = function () {
            var e_1, _a;
            var a = 1.7976931348623157E+308;
            var b = -1.7976931348623157E+308;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c4())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = c.ap(this);
                    if (d == null) {
                        continue;
                    }
                    var e = c.f2();
                    if (i2.isNaN_(e) || e == 0) {
                        continue;
                    }
                    var f = d.b - e;
                    var g = e - d.c;
                    var h = Math.abs(f / e * 100);
                    var i = Math.abs(g / e * 100);
                    a = Math.min(a, -i);
                    b = Math.max(b, h);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return new AxisRange(a, b);
        };
        PercentChangeYAxis.prototype.j5 = function (a) {
            return new PercentChangeAxisRenderer(a);
        };
        PercentChangeYAxis.prototype.dt = function (a, b) {
            var c = ((a - b.b) / b.b) * 100;
            if (c < this.kv) {
                var d = ((this.kv / 100) * b.b) + b.b;
                return d;
            }
            if (c > this.ku) {
                var e = ((this.ku / 100) * b.b) + b.b;
                return e;
            }
            return a;
        };
        PercentChangeYAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        PercentChangeYAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        PercentChangeYAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        PercentChangeYAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        PercentChangeYAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(PercentChangeYAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        PercentChangeYAxis.$t = i2.markType(PercentChangeYAxis, 'PercentChangeYAxis', NumericYAxis.$);
        return PercentChangeYAxis;
    }(NumericYAxis));
    /**
     * @hidden
     */
    var VerticalPercentChangeScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalPercentChangeScaler, _super);
        function VerticalPercentChangeScaler(a) {
            var _this = _super.call(this) || this;
            _this.ad = null;
            _this.ad = a;
            return _this;
        }
        VerticalPercentChangeScaler.prototype.t = function (a, b, c, d, e) {
            var f = AutoRangeCalculator.a(this.ad, b, c, false, -1, d, e);
            d = f.p5;
            e = f.p6;
            return {
                p3: d,
                p4: e
            };
        };
        VerticalPercentChangeScaler.prototype.p = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.ae(a, NumericScaler.ac, b.c, b.b, b.a);
                c = (c - b.d.top) / b.d.height;
                c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
                return c;
            }
            return this.ae(a, b.e, b.d, b.b, b.a);
        };
        VerticalPercentChangeScaler.prototype.ae = function (a, b, c, d, e) {
            var f;
            if (i2.isNaN_(d)) {
                f = a;
            }
            else {
                var g = (a - d) / Math.abs(d) * 100;
                f = g;
            }
            var h = (f - this.o) / this.m;
            if (!e) {
                h = 1 - h;
            }
            return c.top + c.height * (h - b.top) / b.height;
        };
        VerticalPercentChangeScaler.prototype.q = function (a, b) {
            var c = b.b;
            var d = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            if (!b.a) {
                d = 1 - d;
            }
            var e = this.o + d * (this.m);
            var f;
            if (i2.isNaN_(c)) {
                f = e;
            }
            else {
                var g = ((e) * Math.abs(c) / 100) + c;
                f = g;
            }
            return f;
        };
        VerticalPercentChangeScaler.$t = i2.markType(VerticalPercentChangeScaler, 'VerticalPercentChangeScaler', NumericScaler.$);
        return VerticalPercentChangeScaler;
    }(NumericScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * A horizontal axis that uses a DateTime scale.
    *
    * You can use the `IgxPercentChangeYAxisComponent` show percentage values.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-percent-change-y-axis
    * 		#yAxis>
    *     </igx-percent-change-y-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let yAxis = new IgxPercentChangeYAxisComponent();
    * this.chart.axes.add(yAxis);
    * ```
    */
    var IgxPercentChangeYAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPercentChangeYAxisComponent, _super);
        function IgxPercentChangeYAxisComponent() {
            return _super.call(this) || this;
        }
        IgxPercentChangeYAxisComponent.prototype.createImplementation = function () {
            return new PercentChangeYAxis();
        };
        Object.defineProperty(IgxPercentChangeYAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPercentChangeYAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPercentChangeYAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPercentChangeYAxisComponent, selector: "igx-percent-change-y-axis", providers: [{ provide: IgxNumericYAxisComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPercentChangeYAxisComponent;
    }(IgxNumericYAxisComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-percent-change-y-axis',
                        template: "",
                        providers: [{ provide: IgxNumericYAxisComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPercentChangeYAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPercentChangeYAxisModule() {
        }
        IgxPercentChangeYAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPercentChangeYAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisModule, declarations: [IgxPercentChangeYAxisComponent], imports: [i1.CommonModule], exports: [IgxPercentChangeYAxisComponent] });
        IgxPercentChangeYAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisModule, imports: [[i1.CommonModule]] });
        return IgxPercentChangeYAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPercentChangeYAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxPercentChangeYAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPercentChangeYAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPercentChangeYAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPercentChangeYAxisComponent", IgxPercentChangeYAxisComponent);
            i2.TypeRegistrar.register("PercentChangeYAxis", PercentChangeYAxis.$type);
        }
        IgxPercentChangeYAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPercentChangeYAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisDynamicModule, imports: [i1.CommonModule, IgxPercentChangeYAxisModule], exports: [IgxPercentChangeYAxisModule] });
        IgxPercentChangeYAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisDynamicModule, imports: [[i1.CommonModule, IgxPercentChangeYAxisModule], IgxPercentChangeYAxisModule] });
        return IgxPercentChangeYAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentChangeYAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPercentChangeYAxisModule],
                        exports: [IgxPercentChangeYAxisModule],
                        entryComponents: [IgxPercentChangeYAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarAxes = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarAxes, _super);
        function PolarAxes(a, b) {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.a = null;
            _this.g = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            _this.b = a;
            _this.a = b;
            return _this;
        }
        PolarAxes.prototype.c = function (a, b, c, d, e) {
            var f = this.g.x + (b * e(a));
            return ViewportUtils.c(f, c, d);
        };
        PolarAxes.prototype.h = function (a, b, c, d, e, f, g, h, i, j) {
            var k = this.a.getScaledAngle1(a, e, f);
            var l = this.b.mh(b, g, h, i, j);
            var m = this.g.x;
            var n = this.g.y;
            var o = m + (l * Math.cos(k));
            var p = n + (l * Math.sin(k));
            o = d.left + d.width * (o - c.left) / c.width;
            p = d.top + d.height * (p - c.top) / c.height;
            return { $type: i2.Point_$type, x: o, y: p };
        };
        PolarAxes.prototype.e = function (a, b, c, d, e, f, g, h) {
            var i = Math.min(b != null ? b.count : 0, c != null ? c.count : 0);
            a.clear();
            var j;
            var k;
            var l = this.g.x;
            var m = this.g.y;
            var n;
            var o;
            var p = Math.min(this.a.kv, this.a.ku);
            var q = Math.max(this.a.kv, this.a.ku);
            var r = Math.min(this.b.ku, this.b.kv);
            var s = Math.max(this.b.ku, this.b.kv);
            var t = this.a.kl;
            var u = this.a.cc;
            var v = this.b.kl;
            var w = this.b.cc;
            var x = this.b.ma;
            var y = this.b.l9;
            for (var z = 0; z < i; z++) {
                if ((b.item(z) <= q && b.item(z) >= p && c.item(z) <= s && c.item(z) >= r) || (i2.isNaN_(b.item(z)) || i2.isNaN_(c.item(z)))) {
                    j = this.a.getScaledAngle1(b.item(z), t, u);
                    k = this.b.mh(c.item(z), v, w, x, y);
                    n = l + (k * f(z, j));
                    o = m + (k * g(z, j));
                    n = e.left + e.width * (n - d.left) / d.width;
                    o = e.top + e.height * (o - d.top) / d.height;
                    a.add({ $type: i2.Point_$type, x: n, y: o });
                }
                else {
                    a.add({ $type: i2.Point_$type, x: NaN, y: NaN });
                }
            }
        };
        PolarAxes.prototype.f = function (a, b, c, d, e, f) {
            var g = ViewportUtils.a(a, c, d);
            var h = ViewportUtils.e(b, c, d);
            var i = Math.sqrt(Math.pow(g - this.g.x, 2) + Math.pow(h - this.g.y, 2));
            var j = Math.acos((g - this.g.x) / i);
            if ((h - this.g.y) < 0) {
                j = (2 * Math.PI) - j;
            }
            e = this.a.getUnscaledAngle(j);
            f = this.b.mi(i);
            return {
                p4: e,
                p5: f
            };
        };
        PolarAxes.prototype.d = function (a, b, c, d, e) {
            var f = this.g.y + (b * e(a));
            return ViewportUtils.f(f, c, d);
        };
        PolarAxes.$t = i2.markType(PolarAxes, 'PolarAxes');
        return PolarAxes;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialAxes = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialAxes, _super);
        function RadialAxes(a, b) {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.a = null;
            _this.h = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            _this.b = a;
            _this.a = b;
            return _this;
        }
        RadialAxes.prototype.d = function (a, b, c, d) {
            var e = this.h.x + (b * Math.cos(a));
            return ViewportUtils.c(e, c, d);
        };
        RadialAxes.prototype.f = function (a, b, c, d, e, f, g) {
            var h = Math.min(b != null ? b.count : 0, c != null ? c.count : 0);
            var i = false;
            if (a.count == h) {
                i = true;
            }
            var j;
            var k;
            var l = this.h.x;
            var m = this.h.y;
            var n;
            var o;
            for (var p = 0; p < h; p++) {
                j = this.a.getScaledAngle(b.item(p));
                k = this.b.mg(c.item(p));
                n = l + (k * f(p, j));
                o = m + (k * g(p, j));
                n = e.left + e.width * (n - d.left) / d.width;
                o = e.top + e.height * (o - d.top) / d.height;
                if (!i) {
                    a.add({ $type: i2.Point_$type, x: n, y: o });
                }
                else {
                    a.item(p, { $type: i2.Point_$type, x: n, y: o });
                }
            }
        };
        RadialAxes.prototype.g = function (a, b, c, d, e, f) {
            var g = ViewportUtils.a(a, c, d);
            var h = ViewportUtils.e(b, c, d);
            var i = Math.sqrt(Math.pow(g - this.h.x, 2) + Math.pow(h - this.h.y, 2));
            var j = Math.acos((g - this.h.x) / i);
            if ((h - this.h.y) < 0) {
                j = (2 * Math.PI) - j;
            }
            e = this.a.getUnscaledAngle(j);
            f = this.b.mi(i);
            return {
                p4: e,
                p5: f
            };
        };
        RadialAxes.prototype.e = function (a, b, c, d) {
            var e = this.h.y + (b * Math.sin(a));
            return ViewportUtils.f(e, c, d);
        };
        RadialAxes.prototype.c = function (a) {
            var b = Math.sqrt(Math.pow(a.x - this.h.x, 2) + Math.pow(a.y - this.h.y, 2));
            var c = Math.acos((a.x - this.h.x) / b);
            if ((a.y - this.h.y) < 0) {
                c = (2 * Math.PI) - c;
            }
            return c;
        };
        RadialAxes.$t = i2.markType(RadialAxes, 'RadialAxes');
        return RadialAxes;
    }(i2.Base));

    var IgxTimeAxisIntervalCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTimeAxisIntervalCollection, _super);
        function IgxTimeAxisIntervalCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxTimeAxisIntervalComponent.$type) {
                IgxTimeAxisIntervalComponent.$type = i2.markType(IgxTimeAxisIntervalComponent, "IgxTimeAxisIntervalComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxTimeAxisIntervalCollection.prototype._createInnerColl = function () {
            if (!IgxTimeAxisIntervalComponent.$type) {
                IgxTimeAxisIntervalComponent.$type = i2.markType(IgxTimeAxisIntervalComponent, "IgxTimeAxisIntervalComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxTimeAxisIntervalComponent.$type, TimeAxisInterval.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxTimeAxisIntervalComponent();
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxTimeAxisIntervalCollection;
    }(i2.IgCollection));

    var IgxTimeAxisBreakCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTimeAxisBreakCollection, _super);
        function IgxTimeAxisBreakCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxTimeAxisBreakComponent.$type) {
                IgxTimeAxisBreakComponent.$type = i2.markType(IgxTimeAxisBreakComponent, "IgxTimeAxisBreakComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxTimeAxisBreakCollection.prototype._createInnerColl = function () {
            if (!IgxTimeAxisBreakComponent.$type) {
                IgxTimeAxisBreakComponent.$type = i2.markType(IgxTimeAxisBreakComponent, "IgxTimeAxisBreakComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxTimeAxisBreakComponent.$type, TimeAxisBreak.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxTimeAxisBreakComponent();
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxTimeAxisBreakCollection;
    }(i2.IgCollection));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisBreakModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisBreakModule() {
        }
        IgxTimeAxisBreakModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeAxisBreakModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakModule, declarations: [IgxTimeAxisBreakComponent], imports: [i1.CommonModule], exports: [IgxTimeAxisBreakComponent] });
        IgxTimeAxisBreakModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakModule, imports: [[i1.CommonModule]] });
        return IgxTimeAxisBreakModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTimeAxisBreakComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxTimeAxisBreakComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisBreakDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisBreakDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTimeAxisBreakComponent", IgxTimeAxisBreakComponent);
            i2.TypeRegistrar.register("TimeAxisBreak", TimeAxisBreak.$type);
            i2.TypeRegistrar.registerCons("IgxTimeAxisBreakCollection", IgxTimeAxisBreakCollection);
            i2.TypeRegistrar.register("TimeAxisBreakCollection", TimeAxisBreakCollection.$type);
        }
        IgxTimeAxisBreakDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeAxisBreakDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakDynamicModule, imports: [i1.CommonModule, IgxTimeAxisBreakModule], exports: [IgxTimeAxisBreakModule] });
        IgxTimeAxisBreakDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakDynamicModule, imports: [[i1.CommonModule, IgxTimeAxisBreakModule], IgxTimeAxisBreakModule] });
        return IgxTimeAxisBreakDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisBreakDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTimeAxisBreakModule],
                        exports: [IgxTimeAxisBreakModule],
                        entryComponents: [IgxTimeAxisBreakComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisIntervalModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisIntervalModule() {
        }
        IgxTimeAxisIntervalModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeAxisIntervalModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalModule, declarations: [IgxTimeAxisIntervalComponent], imports: [i1.CommonModule], exports: [IgxTimeAxisIntervalComponent] });
        IgxTimeAxisIntervalModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalModule, imports: [[i1.CommonModule]] });
        return IgxTimeAxisIntervalModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTimeAxisIntervalComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxTimeAxisIntervalComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisIntervalDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisIntervalDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTimeAxisIntervalComponent", IgxTimeAxisIntervalComponent);
            i2.TypeRegistrar.register("TimeAxisInterval", TimeAxisInterval.$type);
            i2.TypeRegistrar.registerCons("IgxTimeAxisIntervalCollection", IgxTimeAxisIntervalCollection);
            i2.TypeRegistrar.register("TimeAxisIntervalCollection", TimeAxisIntervalCollection.$type);
        }
        IgxTimeAxisIntervalDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeAxisIntervalDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalDynamicModule, imports: [i1.CommonModule, IgxTimeAxisIntervalModule], exports: [IgxTimeAxisIntervalModule] });
        IgxTimeAxisIntervalDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalDynamicModule, imports: [[i1.CommonModule, IgxTimeAxisIntervalModule], IgxTimeAxisIntervalModule] });
        return IgxTimeAxisIntervalDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisIntervalDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTimeAxisIntervalModule],
                        exports: [IgxTimeAxisIntervalModule],
                        entryComponents: [IgxTimeAxisIntervalComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisLabelFormatModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisLabelFormatModule() {
        }
        IgxTimeAxisLabelFormatModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeAxisLabelFormatModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatModule, declarations: [IgxTimeAxisLabelFormatComponent], imports: [i1.CommonModule], exports: [IgxTimeAxisLabelFormatComponent] });
        IgxTimeAxisLabelFormatModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatModule, imports: [[i1.CommonModule]] });
        return IgxTimeAxisLabelFormatModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTimeAxisLabelFormatComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxTimeAxisLabelFormatComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeAxisLabelFormatDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeAxisLabelFormatDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTimeAxisLabelFormatComponent", IgxTimeAxisLabelFormatComponent);
            i2.TypeRegistrar.register("TimeAxisLabelFormat", TimeAxisLabelFormat.$type);
            i2.TypeRegistrar.registerCons("IgxTimeAxisLabelFormatCollection", IgxTimeAxisLabelFormatCollection);
            i2.TypeRegistrar.register("TimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection.$type);
        }
        IgxTimeAxisLabelFormatDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeAxisLabelFormatDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatDynamicModule, imports: [i1.CommonModule, IgxTimeAxisLabelFormatModule], exports: [IgxTimeAxisLabelFormatModule] });
        IgxTimeAxisLabelFormatDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatDynamicModule, imports: [[i1.CommonModule, IgxTimeAxisLabelFormatModule], IgxTimeAxisLabelFormatModule] });
        return IgxTimeAxisLabelFormatDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeAxisLabelFormatDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTimeAxisLabelFormatModule],
                        exports: [IgxTimeAxisLabelFormatModule],
                        entryComponents: [IgxTimeAxisLabelFormatComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * A horizontal axis that uses a DateTime scale.
    *
    * The `IgxTimeXAxisComponent` is a horizontal axis that uses a DateTime scale.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    var IgxTimeXAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTimeXAxisComponent, _super);
        function IgxTimeXAxisComponent() {
            var _this = _super.call(this) || this;
            _this._breaks = null;
            _this._labelFormats = null;
            _this._intervals = null;
            return _this;
        }
        IgxTimeXAxisComponent.prototype.createImplementation = function () {
            return new TimeXAxis();
        };
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "isPiecewise", {
            get: function () {
                return this.i.cf;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "breaks", {
            /**
             * TimeAxisBreaks to apply to this axis, representing spans of time to omit, such as weekends.
            *
            * The `breaks` to apply to this axis, representing spans of time to omit, such as weekends.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-time-x-axis
            * 		dateTimeMemberPath="date"
            * 		#xAxis>
            *     </igx-time-x-axis>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let xAxis = new IgxTimeXAxisComponent();
            * xAxis.dataTimeMemberPath="date";
            * this.chart.axes.add(xAxis);
            * ```
            */
            get: function () {
                if (this._breaks === null) {
                    var coll = new IgxTimeAxisBreakCollection();
                    var innerColl = this.i.breaks;
                    if (!innerColl) {
                        innerColl = new TimeAxisBreakCollection();
                    }
                    this._breaks = coll._fromInner(innerColl);
                }
                return this._breaks;
            },
            set: function (v) {
                if (this._breaks !== null) {
                    this._breaks._setSyncTarget(null);
                    this._breaks = null;
                }
                var coll = new IgxTimeAxisBreakCollection();
                this._breaks = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(TimeAxisBreak.$type);
                var innerColl = this.i.breaks;
                if (!innerColl) {
                    innerColl = new TimeAxisBreakCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._breaks._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "labellingMode", {
            /**
             * Gets or sets the labelling mode to use when the automatic label formats are applied.
            */
            get: function () {
                return this.i.m7;
            },
            set: function (v) {
                this.i.m7 = i2.ensureEnum(TimeAxisLabellingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "labelFormats", {
            /**
             * A list of axis label formats to apply, which are selected according to the visible axis range.
             * The label format selected will be the one with the largest range smaller than the visible range of the axis.
            */
            get: function () {
                if (this._labelFormats === null) {
                    var coll = new IgxTimeAxisLabelFormatCollection();
                    var innerColl = this.i.labelFormats;
                    if (!innerColl) {
                        innerColl = new TimeAxisLabelFormatCollection();
                    }
                    this._labelFormats = coll._fromInner(innerColl);
                }
                return this._labelFormats;
            },
            set: function (v) {
                if (this._labelFormats !== null) {
                    this._labelFormats._setSyncTarget(null);
                    this._labelFormats = null;
                }
                var coll = new IgxTimeAxisLabelFormatCollection();
                this._labelFormats = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(TimeAxisLabelFormat.$type);
                var innerColl = this.i.labelFormats;
                if (!innerColl) {
                    innerColl = new TimeAxisLabelFormatCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._labelFormats._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "intervals", {
            /**
             * A list of axis label intervals to apply, which are selected according to the visible axis range.
             * The interval selected will be the one with the largest range smaller than the visible range of the axis.
            */
            get: function () {
                if (this._intervals === null) {
                    var coll = new IgxTimeAxisIntervalCollection();
                    var innerColl = this.i.intervals;
                    if (!innerColl) {
                        innerColl = new TimeAxisIntervalCollection();
                    }
                    this._intervals = coll._fromInner(innerColl);
                }
                return this._intervals;
            },
            set: function (v) {
                if (this._intervals !== null) {
                    this._intervals._setSyncTarget(null);
                    this._intervals = null;
                }
                var coll = new IgxTimeAxisIntervalCollection();
                this._intervals = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(TimeAxisInterval.$type);
                var innerColl = this.i.intervals;
                if (!innerColl) {
                    innerColl = new TimeAxisIntervalCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._intervals._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTimeXAxisComponent.prototype, "isCategoryDateTime", {
            /**
             * Gets if the current axis is of category date time axis type
            */
            get: function () {
                return this.i.b7;
            },
            enumerable: false,
            configurable: true
        });
        IgxTimeXAxisComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.breaks != null && this.breaks.findByName && this.breaks.findByName(name)) {
                return this.breaks.findByName(name);
            }
            if (this.labelFormats != null && this.labelFormats.findByName && this.labelFormats.findByName(name)) {
                return this.labelFormats.findByName(name);
            }
            if (this.intervals != null && this.intervals.findByName && this.intervals.findByName(name)) {
                return this.intervals.findByName(name);
            }
            return null;
        };
        IgxTimeXAxisComponent.prototype.getValueLabel = function (value) {
            var iv = this.i.fw(value);
            return (iv);
        };
        /**
         * Gets the index of the data item with the value nearest the given value.
        
        * @param unscaledValue  * The value to find a value close to.
        */
        IgxTimeXAxisComponent.prototype.getIndexClosestToUnscaledValue = function (unscaledValue) {
            var iv = this.i.i$f(unscaledValue);
            return (iv);
        };
        IgxTimeXAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTimeXAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTimeXAxisComponent, selector: "igx-time-x-axis", inputs: { breaks: "breaks", labellingMode: "labellingMode", labelFormats: "labelFormats", intervals: "intervals" }, providers: [{ provide: IgxTimeAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxTimeXAxisComponent; }) }, { provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxTimeXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxTimeXAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxTimeXAxisComponent;
    }(IgxTimeAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-time-x-axis',
                        template: "",
                        providers: [{ provide: IgxTimeAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxTimeXAxisComponent; }) }, { provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxTimeXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxTimeXAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { breaks: [{
                    type: i0.Input
                }], labellingMode: [{
                    type: i0.Input
                }], labelFormats: [{
                    type: i0.Input
                }], intervals: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeXAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeXAxisModule() {
        }
        IgxTimeXAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeXAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisModule, declarations: [IgxTimeXAxisComponent], imports: [i1.CommonModule, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule], exports: [IgxTimeXAxisComponent, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule] });
        IgxTimeXAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisModule, imports: [[i1.CommonModule, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule], IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule] });
        return IgxTimeXAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTimeXAxisComponent],
                        imports: [i1.CommonModule, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule],
                        exports: [IgxTimeXAxisComponent, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTimeXAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTimeXAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTimeXAxisComponent", IgxTimeXAxisComponent);
            i2.TypeRegistrar.register("TimeXAxis", TimeXAxis.$type);
        }
        IgxTimeXAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTimeXAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisDynamicModule, imports: [i1.CommonModule, IgxTimeXAxisModule], exports: [IgxTimeXAxisModule] });
        IgxTimeXAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisDynamicModule, imports: [[i1.CommonModule, IgxTimeXAxisModule], IgxTimeXAxisModule] });
        return IgxTimeXAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTimeXAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTimeXAxisModule],
                        exports: [IgxTimeXAxisModule],
                        entryComponents: [IgxTimeXAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TimeRepetitionLevel_$type = i2.markEnum('TimeRepetitionLevel', 'None,0|Year,1|Month,2|Day,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AngleRadiusPair = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AngleRadiusPair, _super);
        function AngleRadiusPair() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.a = 0;
            _this.b = 0;
            return _this;
        }
        AngleRadiusPair.$t = i2.markType(AngleRadiusPair, 'AngleRadiusPair');
        return AngleRadiusPair;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarLinePlanner = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarLinePlanner, _super);
        function PolarLinePlanner() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = false;
            _this.b = 0;
            _this.m = null;
            _this.n = null;
            _this.o = null;
            _this.p = null;
            _this.l = 0;
            _this.q = 0;
            _this.z = null;
            _this.aa = null;
            _this.a = null;
            _this.c = false;
            _this.d = false;
            _this.i = null;
            return _this;
        }
        Object.defineProperty(PolarLinePlanner.prototype, "ab", {
            get: function () {
                return this.z;
            },
            set: function (a) {
                this.z = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarLinePlanner.prototype, "ac", {
            get: function () {
                return this.aa;
            },
            set: function (a) {
                this.aa = a;
            },
            enumerable: false,
            configurable: true
        });
        PolarLinePlanner.prototype.g = function () {
            if (this.m == null || this.n == null || this.o == null || this.p == null || i2.Rect.l_op_Equality(this.ab, i2.Rect.empty) || i2.Rect.l_op_Equality(this.ac, i2.Rect.empty)) {
                return false;
            }
            return true;
        };
        PolarLinePlanner.prototype.k = function (a, b, c, d) {
            var e = a(d) - a(c);
            var f = b(d) - b(c);
            return e * e + f * f;
        };
        PolarLinePlanner.prototype.h = function (a) {
            var b = new i2.List$1(AngleRadiusPair.$, 0);
            var c = this.l * this.l;
            var d;
            if (a != null) {
                d = a;
            }
            else {
                var e = new i2.List$1(i2.Number_$type, 0);
                for (var f = 0; f < this.q; f++) {
                    e.add(f);
                }
                d = e;
            }
            var g = i2.getEnumerator(d);
            var h = true;
            h = g.moveNext();
            var i = 0;
            if (h) {
                i = g.current;
            }
            while (h) {
                var j = i;
                h = g.moveNext();
                i = g.current;
                while (h && this.k(this.o, this.p, j, i) < c) {
                    h = g.moveNext();
                    i = g.current;
                }
                var k = new AngleRadiusPair();
                k.c = j;
                if (!this.f) {
                    k.a = this.m(j);
                    k.b = this.n(j);
                }
                b.add(k);
            }
            return b;
        };
        PolarLinePlanner.prototype.v = function (a) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.h(a))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (i2.isNaN_(b.a) || i2.isInfinity(b.a) || i2.isNaN_(b.b) || i2.isInfinity(b.b)) {
                        this.s({ $type: i2.Point_$type, x: NaN, y: NaN });
                        continue;
                    }
                    this.s({ $type: i2.Point_$type, x: this.o(b.c), y: this.p(b.c) });
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        PolarLinePlanner.prototype.j = function () {
            return Math.pow(this.l / (Math.max(this.ab.width / this.ac.width, this.ab.height / this.ac.height)), 2);
        };
        PolarLinePlanner.prototype.r = function (a, b) {
            var c = 0.5 + b * Math.cos(a);
            var d = 0.5 + b * Math.sin(a);
            c = this.z.left + this.z.width * (c - this.aa.left) / this.aa.width;
            d = this.z.top + this.z.height * (d - this.aa.top) / this.aa.height;
            this.s({ $type: i2.Point_$type, x: c, y: d });
        };
        PolarLinePlanner.prototype.y = function (a) {
            var b = this.j();
            var c = this.h(a);
            var d = c.item(0).a;
            var e = c.item(0).b;
            var f = c.item(0).c;
            for (var g = 1; g < c.count; g++) {
                var h = c.item(g).a;
                var i = c.item(g).b;
                var j = c.item(g).c;
                if (i2.isNaN_(h) || i2.isInfinity(h) || i2.isNaN_(i) || i2.isInfinity(i)) {
                    this.s({ $type: i2.Point_$type, x: NaN, y: NaN });
                    if (this.b != 0) {
                        g++;
                        if (g < c.count) {
                            d = c.item(g).a;
                            e = c.item(g).b;
                        }
                    }
                    continue;
                }
                this.t(h, i, d, e, g, b, f > j);
                d = h;
                e = i;
                f = j;
            }
        };
        PolarLinePlanner.prototype.t = function (a, b, c, d, e, f, g) {
            var h = false;
            if ((a < c && !g) || (a > c && g)) {
                h = true;
                var i = a;
                a = c;
                c = i;
                i = b;
                b = d;
                d = i;
            }
            var j = i2.SpiralFlattener.a(c, d, a, b, f);
            if (h) {
                var k = new i2.List$1(i2.Number_$type, 2, j.count);
                for (var l = j.count - 1; l >= 0; l--) {
                    k.add(j._inner[l]);
                }
                j = k;
            }
            for (var m = 0; m < j.count; m++) {
                var n = j._inner[m];
                var o = c + n * (a - c);
                var p = d + n * (b - d);
                this.r(o, p);
            }
        };
        PolarLinePlanner.prototype.u = function (a) {
            var _this = this;
            var b = this.ab.top - 10;
            var c = this.ab.bottom + 10;
            var d = this.ab.left - 10;
            var e = this.ab.right + 10;
            if (this.a == null) {
                this.a = ((function () {
                    var $ret = new i2.Clipper(1, d, c, e, b, _this.d);
                    $ret.i = a;
                    return $ret;
                })());
            }
        };
        PolarLinePlanner.prototype.e = function (a) {
            return !i2.isNaN_(a.x) && !i2.isNaN_(a.y) && !i2.isInfinity(a.x) && !i2.isInfinity(a.y);
        };
        PolarLinePlanner.prototype.s = function (a) {
            if (this.b == 0 && !this.e(a)) {
                return;
            }
            if (this.c) {
                this.i.add(a);
            }
            else {
                this.a.j(a);
            }
        };
        PolarLinePlanner.prototype.w = function (a) {
            this.x(null, null);
        };
        PolarLinePlanner.prototype.x = function (a, b) {
            this.i = a;
            if (!this.g()) {
                return;
            }
            if (this.q > 1) {
                this.u(a);
                if (this.f) {
                    this.v(b);
                }
                else {
                    this.y(b);
                }
                this.a.i = null;
            }
        };
        PolarLinePlanner.$t = i2.markType(PolarLinePlanner, 'PolarLinePlanner');
        return PolarLinePlanner;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IOverlayProxy_$type = new i2.Type(null, 'IOverlayProxy');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OverlayProxy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OverlayProxy, _super);
        function OverlayProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        OverlayProxy.prototype.matchesType = function (a) {
            if (a.dk) {
                return true;
            }
            return false;
        };
        OverlayProxy.prototype.setCloseMemberPath = function (a, b) {
            a.ru = b;
        };
        OverlayProxy.prototype.setHighMemberPath = function (a, b) {
            a.rx = b;
        };
        OverlayProxy.prototype.setLowMemberPath = function (a, b) {
            a.r2 = b;
        };
        OverlayProxy.prototype.setMultiplier = function (a, b) {
            if (i2.getInstanceType(a).typeName == "BollingerBandsOverlay") {
                var s_ = a;
                var p_ = b;
                s_['multiplier'] = p_;
            }
        };
        OverlayProxy.prototype.setOpenMemberPath = function (a, b) {
            a.r6 = b;
        };
        OverlayProxy.prototype.setVolumeMemberPath = function (a, b) {
            a.sa = b;
        };
        OverlayProxy.prototype.setXAxis = function (a, b) {
            a.pq = b;
        };
        OverlayProxy.prototype.setYAxis = function (a, b) {
            a.qc = b;
        };
        OverlayProxy.$t = i2.markType(OverlayProxy, 'OverlayProxy', i2.Base.$, [IOverlayProxy_$type]);
        return OverlayProxy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOverlayProxyModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOverlayProxyModule() {
            i2.TypeRegistrar.register('OverlayProxy', OverlayProxy.$type);
        }
        IgxOverlayProxyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOverlayProxyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyModule, imports: [i1.CommonModule] });
        IgxOverlayProxyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyModule, imports: [[i1.CommonModule,
                ]] });
        return IgxOverlayProxyModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOverlayProxyDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOverlayProxyDynamicModule() {
            i2.TypeRegistrar.registerCons('OverlayProxy', OverlayProxy);
            i2.TypeRegistrar.register('OverlayProxy', OverlayProxy.$type);
        }
        IgxOverlayProxyDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOverlayProxyDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyDynamicModule, imports: [i1.CommonModule, IgxOverlayProxyModule], exports: [IgxOverlayProxyModule] });
        IgxOverlayProxyDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyDynamicModule, imports: [[i1.CommonModule, IgxOverlayProxyModule
                ], IgxOverlayProxyModule] });
        return IgxOverlayProxyDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlayProxyDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxOverlayProxyModule
                        ],
                        imports: [i1.CommonModule, IgxOverlayProxyModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IIndicatorProxy_$type = new i2.Type(null, 'IIndicatorProxy');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IShortPeriodLongPeriod_$type = new i2.Type(null, 'IShortPeriodLongPeriod');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialValueList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialValueList, _super);
        function FinancialValueList(a, b, c, d, e) {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.b = null;
            _this.a = null;
            _this.c = null;
            _this.e = null;
            _this.d = a;
            _this.b = b;
            _this.a = d;
            _this.c = c;
            _this.e = e;
            return _this;
        }
        FinancialValueList.prototype.indexOf = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.insert = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.removeAt = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                return b;
            }
            else {
                var b_1 = NaN;
                var c = NaN;
                var d = NaN;
                var e = NaN;
                var f = NaN;
                if (this.d != null && a >= 0 && a < this.d.count) {
                    b_1 = this.d.item(a);
                }
                if (this.b != null && a >= 0 && a < this.b.count) {
                    c = this.b.item(a);
                }
                if (this.c != null && a >= 0 && a < this.c.count) {
                    d = this.c.item(a);
                }
                if (this.a != null && a >= 0 && a < this.a.count) {
                    e = this.a.item(a);
                }
                if (this.e != null && a >= 0 && a < this.e.count) {
                    f = this.e.item(a);
                }
                var g = i2.isNaN_(b_1);
                var h = i2.isNaN_(c);
                var i = i2.isNaN_(d);
                var j = i2.isNaN_(e);
                var k = i2.isNaN_(f);
                if (!h && !i && !j) {
                    return (c + d + e) / 3;
                }
                if (!h && !i) {
                    return (c + d) / 2;
                }
                if (!g && !j) {
                    return (b_1 + e) / 2;
                }
                if (!g) {
                    return b_1;
                }
                if (!h) {
                    return c;
                }
                if (!i) {
                    return d;
                }
                if (!j) {
                    return e;
                }
                return NaN;
            }
        };
        FinancialValueList.prototype.add = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.clear = function () {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.contains = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.copyTo = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        Object.defineProperty(FinancialValueList.prototype, "count", {
            get: function () {
                var a = 0;
                var b = 0;
                var c = 0;
                var d = 0;
                var e = 0;
                if (this.d != null) {
                    a = this.d.count;
                }
                if (this.b != null) {
                    b = this.b.count;
                }
                if (this.c != null) {
                    c = this.c.count;
                }
                if (this.a != null) {
                    d = this.a.count;
                }
                if (this.e != null) {
                    e = this.e.count;
                }
                var f = 0;
                f = Math.max(f, a);
                f = Math.max(f, b);
                f = Math.max(f, c);
                f = Math.max(f, d);
                f = Math.max(f, e);
                return f;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialValueList.prototype, "isReadOnly", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        FinancialValueList.prototype.remove = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.getEnumerator = function () {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.prototype.getEnumeratorObject = function () {
            throw new i2.NotImplementedException(0);
        };
        FinancialValueList.$t = i2.markType(FinancialValueList, 'FinancialValueList', i2.Base.$, [i2.IList$1_$type.specialize(i2.Number_$type)]);
        return FinancialValueList;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalculatedColumn = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalculatedColumn, _super);
        function CalculatedColumn(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this._valuesProvider = null;
            _this.c = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = [];
                        for (var b = 1; b < _rest.length; b++) {
                            d[b - 1] = _rest[b];
                        }
                        _this._valuesProvider = c;
                        _this.c = new i2.List$1(i2.String_$type, 1, d);
                    }
                    break;
                case 1:
                    {
                        var d = _rest[0];
                        var e = _rest[1];
                        _this._valuesProvider = d;
                        _this.c = new i2.List$1(i2.String_$type, 1, e);
                    }
                    break;
            }
            return _this;
        }
        Object.defineProperty(CalculatedColumn.prototype, "basedOn", {
            get: function () {
                return this.c;
            },
            enumerable: false,
            configurable: true
        });
        CalculatedColumn.prototype.getEnumerator = function () {
            return i2.getEnumerator(this._valuesProvider);
        };
        CalculatedColumn.prototype.getEnumeratorObject = function () {
            return i2.getEnumerator(this._valuesProvider);
        };
        CalculatedColumn.$t = i2.markType(CalculatedColumn, 'CalculatedColumn', i2.Base.$, [i2.IEnumerable$1_$type.specialize(i2.Number_$type)]);
        return CalculatedColumn;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SupportingCalculation$1 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SupportingCalculation$1, _super);
        function SupportingCalculation$1($tCalculationStrategy, a) {
            var _rest = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                _rest[_i - 2] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.$tCalculationStrategy = null;
            _this.a = null;
            _this.d = null;
            _this.$tCalculationStrategy = $tCalculationStrategy;
            _this.$type = _this.$type.specialize(_this.$tCalculationStrategy);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        _this.a = c;
                        _this.d = new i2.List$1(i2.String_$type, 0);
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        _this.a = c;
                        _this.d = new i2.List$1(i2.String_$type, 1, d);
                    }
                    break;
            }
            return _this;
        }
        Object.defineProperty(SupportingCalculation$1.prototype, "b", {
            get: function () {
                return this.a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SupportingCalculation$1.prototype, "c", {
            get: function () {
                return this.d;
            },
            enumerable: false,
            configurable: true
        });
        SupportingCalculation$1.$t = i2.markType(SupportingCalculation$1, 'SupportingCalculation$1');
        return SupportingCalculation$1;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ColumnSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColumnSupportingCalculation, _super);
        function ColumnSupportingCalculation(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, i2.Delegate_$type, 0, c) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        _this = _super.call(this, i2.Delegate_$type, 1, c, d) || this;
                    }
                    break;
            }
            return _this;
        }
        ColumnSupportingCalculation.$t = i2.markType(ColumnSupportingCalculation, 'ColumnSupportingCalculation', SupportingCalculation$1.$.specialize(i2.Delegate_$type));
        return ColumnSupportingCalculation;
    }(SupportingCalculation$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialEventArgs, _super);
        function FinancialEventArgs(a, b, c, d, e) {
            var _this = _super.call(this) || this;
            _this._position = 0;
            _this._count = 0;
            _this._dataSource = null;
            _this._supportingCalculations = null;
            _this._basedOn = null;
            _this.position = a;
            _this.count = b;
            _this.dataSource = c;
            _this.supportingCalculations = d;
            if (c != null) {
                c.series = e;
            }
            return _this;
        }
        Object.defineProperty(FinancialEventArgs.prototype, "position", {
            get: function () {
                return this._position;
            },
            set: function (a) {
                this._position = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialEventArgs.prototype, "count", {
            get: function () {
                return this._count;
            },
            set: function (a) {
                this._count = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (a) {
                this._dataSource = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
            get: function () {
                return this._supportingCalculations;
            },
            set: function (a) {
                this._supportingCalculations = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
            get: function () {
                return this._basedOn;
            },
            set: function (a) {
                this._basedOn = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialEventArgs.$t = i2.markType(FinancialEventArgs, 'FinancialEventArgs', i2.EventArgs.$);
        return FinancialEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var FinancialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialBucketCalculator, _super);
        function FinancialBucketCalculator(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.c = 0;
            _this.d = 0;
            _this.b = 0;
            if (a == null) {
                throw new i2.ArgumentNullException(0, "view");
            }
            _this.a = a;
            _this.c = -1;
            _this.d = _this.d;
            _this.b = 0;
            return _this;
        }
        FinancialBucketCalculator.prototype.getBucket = function (a) {
            return null;
        };
        FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            return this.getBucket(a);
        };
        FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
            return NaN;
        };
        FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
            a = this.c;
            b = this.d;
            c = this.b;
            d = this.a.bz.gh;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        };
        FinancialBucketCalculator.prototype.e = function (a) {
            var b = this.a.bv;
            var c = this.a.bu;
            var d = this.a.bu;
            if (this.a.bz != null) {
                d = this.a.bz.getEffectiveViewport1(this.a);
            }
            if (b.isEmpty || c.isEmpty || this.a.bz.pq == null) {
                this.b = 0;
                return;
            }
            var e = (this.a.bz.pq != null) ? this.a.bz.pq.cc : false;
            var f = new ScalerParams(0, b, c, e, d);
            var g = this.a.bz.o7(this.a);
            var h = i2.typeCast(ISortingAxis_$type, this.a.bz.pq);
            if (h == null || h.i$b == null) {
                var i = Math.floor(this.a.bz.pq.eb(g.left, f));
                var j = Math.ceil(this.a.bz.pq.eb(g.right, f));
                if (this.a.bz.pq.cc) {
                    j = Math.ceil(this.a.bz.pq.eb(g.left, f));
                    i = Math.floor(this.a.bz.pq.eb(g.right, f));
                }
                var k = Math.floor((j - i + 1) * a / g.width);
                this.b = i2.truncate(Math.max(1, k));
                this.c = i2.truncate(Math.floor(i / this.b));
                this.d = i2.truncate(Math.ceil(j / this.b));
            }
            else {
                this.c = h.i$e(b, c, d, g);
                this.d = h.i$g(b, c, d, g);
                this.b = 1;
            }
        };
        FinancialBucketCalculator.prototype.cacheValues = function () {
        };
        FinancialBucketCalculator.prototype.unCacheValues = function () {
        };
        FinancialBucketCalculator.$t = i2.markType(FinancialBucketCalculator, 'FinancialBucketCalculator', i2.Base.$, [IBucketizer_$type]);
        return FinancialBucketCalculator;
    }(i2.Base));
    /**
     * @hidden
     */
    var FinancialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialSeries, _super);
        function FinancialSeries() {
            var _this = _super.call(this) || this;
            _this.qh = null;
            _this.qf = null;
            _this.qg = null;
            _this.qe = null;
            _this.qi = null;
            _this.qr = false;
            _this.assigningCategoryStyle = null;
            _this.pz = null;
            _this.q1 = new i2.Dictionary$2(i2.IFastItemColumn$1_$type.specialize(i2.Number_$type), i2.String_$type, 0);
            _this.q2 = new i2.Dictionary$2(i2.String_$type, i2.String_$type, 0);
            _this.qq = false;
            _this.qa = null;
            _this.pu = null;
            _this.pw = null;
            _this.ps = null;
            _this.p2 = null;
            _this.typical = null;
            _this.typicalBasedOn = null;
            _this.qp = false;
            _this.re = null;
            _this.rc = null;
            _this.rd = null;
            _this.rb = null;
            _this.rf = null;
            _this.pv = null;
            _this.pr = null;
            _this.px = 0;
            _this.qb = null;
            _this.qd = null;
            _this.pz = new CategorySeriesRenderManager();
            _this.qr = false;
            _this.p2 = new CategoryTransitionSourceFramePreparer();
            _this.pv = new CategoryFrame(3);
            _this.ab = FinancialSeries.$;
            _this.py = 0;
            return _this;
        }
        FinancialSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.p7 = a;
        };
        FinancialSeries.prototype.get_di = function () {
            return true;
        };
        FinancialSeries.prototype.ag = function () {
            return [this.pq, this.qc];
        };
        FinancialSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == FinancialSeries.$$p[6]) {
                return this.hl(a, b, this.r6);
            }
            if (c == FinancialSeries.$$p[1]) {
                return this.hl(a, b, this.rx);
            }
            if (c == FinancialSeries.$$p[4]) {
                return this.hl(a, b, this.r2);
            }
            if (c == FinancialSeries.$$p[0]) {
                return this.hl(a, b, this.ru);
            }
            if (c == FinancialSeries.$$p[8]) {
                return this.hl(a, b, this.sa);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        FinancialSeries.prototype.rq = function () {
            return 2;
        };
        FinancialSeries.prototype.ro = function () {
            return 4;
        };
        FinancialSeries.prototype.ah = function (a) {
            var b = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), this.o5(a), true);
            if (b == null) {
                return null;
            }
            var c = b[0];
            var d = b[1];
            var e = new Array(1);
            var f = new Array(2);
            var g = this.rq();
            f[0] = { $type: i2.Point_$type, x: c[0], y: c[g] };
            f[1] = { $type: i2.Point_$type, x: d[0], y: d[g] };
            e[0] = f;
            return e;
        };
        FinancialSeries.prototype.ai = function (a) {
            var b = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), this.o5(a), true);
            if (b == null) {
                return null;
            }
            var c = b[0];
            var d = b[1];
            var e = new Array(1);
            var f = new Array(2);
            f[0] = { $type: i2.Point_$type, x: c[0], y: c[1] };
            f[1] = { $type: i2.Point_$type, x: d[0], y: d[1] };
            e[0] = f;
            return e;
        };
        FinancialSeries.prototype.op = function () {
            return this.sw;
        };
        FinancialSeries.prototype.oq = function () {
            return this.sw;
        };
        FinancialSeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.pq = null;
            this.qc = null;
        };
        Object.defineProperty(FinancialSeries.prototype, "qm", {
            get: function () {
                return this.qh;
            },
            set: function (a) {
                if (this.qh != a) {
                    var b = this.qh;
                    this.qh = a;
                    this.raisePropertyChanged("OpenColumn", b, this.qh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialSeries.prototype, "qk", {
            get: function () {
                return this.qf;
            },
            set: function (a) {
                if (this.qf != a) {
                    var b = this.qf;
                    this.qf = a;
                    this.raisePropertyChanged("HighColumn", b, this.qf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialSeries.prototype, "ql", {
            get: function () {
                return this.qg;
            },
            set: function (a) {
                if (this.qg != a) {
                    var b = this.qg;
                    this.qg = a;
                    this.raisePropertyChanged("LowColumn", b, this.qg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialSeries.prototype, "qj", {
            get: function () {
                return this.qe;
            },
            set: function (a) {
                if (this.qe != a) {
                    var b = this.qe;
                    this.qe = a;
                    this.raisePropertyChanged("CloseColumn", b, this.qe);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialSeries.prototype, "qo", {
            get: function () {
                return this.qi;
            },
            set: function (a) {
                if (this.qi != a) {
                    var b = this.qi;
                    this.qi = a;
                    this.raisePropertyChanged("VolumeColumn", b, this.qi);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype.qy = function () {
            return (this.assigningCategoryStyle != null && this.qr) || this.bj != 1;
        };
        FinancialSeries.prototype.si = function (a) {
            if (this.assigningCategoryStyle != null && this.qr) {
                this.assigningCategoryStyle(this, a);
            }
        };
        FinancialSeries.prototype.sg = function (a, b, c, d, e, f) {
            var g = this.bj != 1;
            this.pz.a1(this.pz.b, d.ch, a, b, c, d, e, f, false);
            this.pz.ab(this.fj);
            var h = this.pz.aw;
            var i = null;
            var j = this.ch;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.si(h);
            this.pz.z(this, i, f, g, b < 0);
        };
        FinancialSeries.prototype.rg = function (a) {
            return this.fy(a, this.pq);
        };
        FinancialSeries.prototype.g6 = function (a, b) {
            return this.g7(a, b, this.pq, i2.runOn(this, this.rg), new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo));
        };
        FinancialSeries.prototype.g4 = function (a, b) {
            return this.g5(a, b, this.pq, i2.runOn(this, this.rg), new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo));
        };
        FinancialSeries.prototype.fu = function (a, b, c, d, e) {
            if (c == null) {
                return Number.POSITIVE_INFINITY;
            }
            var f = this.pq.kq;
            return this.fv(a, b, this.pq, d, e, f, i2.runOn(this, this.rg));
        };
        FinancialSeries.prototype.getOffsetValue = function () {
            return this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        FinancialSeries.prototype.getCategoryWidth = function () {
            return this.pq.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        FinancialSeries.prototype.o2 = function (a, b, c) {
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, null, null, null);
        };
        FinancialSeries.prototype.f8 = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(new FinancialValueList(this.qm, this.qk, this.ql, this.qj, this.qo), a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialSeries.prototype.f4 = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qk, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialSeries.prototype.f6 = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.ql, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialSeries.prototype.ri = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qj, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialSeries.prototype.rj = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qm, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialSeries.prototype.rk = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            return this.ga(this.qo, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialSeries.prototype.oy = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, i2.runOn(this, this.f4), function (d, e) { return _this.g7(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qk); }, function (d, e) { return _this.g5(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qk); });
        };
        FinancialSeries.prototype.o0 = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, i2.runOn(this, this.f6), function (d, e) { return _this.g7(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.ql); }, function (d, e) { return _this.g5(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.ql); });
        };
        FinancialSeries.prototype.sy = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, i2.runOn(this, this.rj), function (d, e) { return _this.g7(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qm); }, function (d, e) { return _this.g5(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qm); });
        };
        FinancialSeries.prototype.sx = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, i2.runOn(this, this.ri), function (d, e) { return _this.g7(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qj); }, function (d, e) { return _this.g5(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qj); });
        };
        FinancialSeries.prototype.sz = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.rh(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.qc, this.pq, i2.runOn(this, this.rk), function (d, e) { return _this.g7(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qo); }, function (d, e) { return _this.g5(d, e, _this.pq, i2.runOn(_this, _this.rg), _this.qo); });
        };
        FinancialSeries.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.pq != null) {
                this.pq.hq(false);
            }
            if (this.qc != null) {
                this.qc.hq(false);
            }
        };
        FinancialSeries.prototype.mn = function (a, b) {
            this.p7.bx.e(this.gh);
            this.l0(false);
        };
        FinancialSeries.prototype.mm = function (a, b) {
            if (this.eu && this.gn < 0.05) {
                this.ev = true;
            }
            this.p7.bx.e(this.gh);
            this.l0(false);
        };
        FinancialSeries.prototype.qn = function (a, b, c) {
            var d = this.ce(b);
            this.q1.addItem(d, b);
            this.q2.addItem(b, c);
            return d;
        };
        FinancialSeries.prototype.sf = function (a, b) {
            if (b == null) {
                return;
            }
            a.deregisterColumn(b);
            var c = this.q1.item(b);
            this.q2.removeItem(c);
            this.q1.removeItem(b);
        };
        FinancialSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "SyncLink":
                    if (this.b5 != null && this.ca != null) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        if (this.pq != null) {
                            this.pq.bx(this);
                        }
                        if (this.qc != null) {
                            this.qc.bx(this);
                        }
                    }
                    if (c == null && d != null) {
                        if (this.pq != null) {
                            this.pq.cn(this);
                        }
                        if (this.qc != null) {
                            this.qc.cn(this);
                        }
                    }
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                    break;
                case "FastItemsSource":
                    this.qq = true;
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        this.sf(i2.typeCast(i2.IFastItemsSource_$type, c), this.qm);
                        this.sf(i2.typeCast(i2.IFastItemsSource_$type, c), this.qk);
                        this.sf(i2.typeCast(i2.IFastItemsSource_$type, c), this.ql);
                        this.sf(i2.typeCast(i2.IFastItemsSource_$type, c), this.qj);
                        this.sf(i2.typeCast(i2.IFastItemsSource_$type, c), this.qo);
                        this.qm = null;
                        this.qk = null;
                        this.ql = null;
                        this.qj = null;
                        this.qo = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        if (i2.stringIsNullOrEmpty(this.r6) == false) {
                            this.qm = this.qn(i2.typeCast(i2.IFastItemsSource_$type, d), this.r6, "OpenColumn");
                        }
                        if (i2.stringIsNullOrEmpty(this.rx) == false) {
                            this.qk = this.qn(i2.typeCast(i2.IFastItemsSource_$type, d), this.rx, "HighColumn");
                        }
                        if (i2.stringIsNullOrEmpty(this.r2) == false) {
                            this.ql = this.qn(i2.typeCast(i2.IFastItemsSource_$type, d), this.r2, "LowColumn");
                        }
                        if (i2.stringIsNullOrEmpty(this.ru) == false) {
                            this.qj = this.qn(i2.typeCast(i2.IFastItemsSource_$type, d), this.ru, "CloseColumn");
                        }
                        if (i2.stringIsNullOrEmpty(this.sa) == false) {
                            this.qo = this.qn(i2.typeCast(i2.IFastItemsSource_$type, d), this.sa, "VolumeColumn");
                        }
                    }
                    this.qq = false;
                    if (this.qc != null && !this.qc.cv()) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[6]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qm);
                        this.qm = this.qn(this.ch, this.r6, "OpenColumn");
                    }
                    break;
                case "OpenColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[1]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qk);
                        this.qk = this.qn(this.ch, this.rx, "HighColumn");
                    }
                    break;
                case "HighColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[4]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.ql);
                        this.ql = this.qn(this.ch, this.r2, "LowColumn");
                    }
                    break;
                case "LowColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[0]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qj);
                        this.qj = this.qn(this.ch, this.ru, "CloseColumn");
                    }
                    break;
                case "CloseColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    this.sk();
                    break;
                case FinancialSeries.$$p[8]:
                    if (this.ch != null) {
                        this.sf(this.ch, this.qo);
                        this.qo = this.qn(this.ch, this.sa, "VolumeColumn");
                    }
                    break;
                case "VolumeColumn":
                    if (this.qc != null && !this.qc.cv() && !this.qq) {
                        this.p7.bx.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case FinancialSeries.$$p[9]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.p7.bx.e(this.gh);
                    this.l0(false);
                    this.k7();
                    this.qb = i2.typeCast(ITimeRangeSelectorAxis_$type, this.pq);
                    break;
                case FinancialSeries.$$p[10]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.p7.bx.e(this.gh);
                    if (this.qc != null) {
                        this.qc.cv();
                    }
                    {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.pw.c(this.gn, this.pu, this.ps);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.ps.v();
                        this.sj(this.ps, this.p7);
                        if (this.eu) {
                            this.eu = false;
                            this.ki();
                            this.cb.r = i2.truncate(this.gb());
                            this.cb.b = this.cc;
                        }
                    }
                    else {
                        this.sj(this.pw, this.p7);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case FinancialSeries.$$p[5]:
                    this.l0(false);
                    break;
                case "IsCustomCategoryStyleAllowed":
                    this.qr = this.qu();
                    this.l0(false);
                    break;
                case "CategoryMode":
                    if (this.pq != null) {
                        this.pq.le(true);
                    }
                    break;
            }
        };
        FinancialSeries.prototype.qt = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        FinancialSeries.prototype.qs = function (a) {
            if (i2.typeCast(CategoryXAxis.$, a) !== null || a.b9) {
                return true;
            }
            return false;
        };
        FinancialSeries.prototype.pj = function (a, b, c) {
            if (b < a || a < 0 || a > this.ch.count || b < 0 || b > this.ch.count || c == null) {
                return null;
            }
            var d = new Array((b - a) + 1);
            var e = c.ch;
            var f = null;
            if (e) {
                f = c.i$b;
            }
            for (var g = a; g <= b; g++) {
                var h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ch.item(g);
            }
            return d;
        };
        FinancialSeries.prototype.rn = function (a) {
            return a.bx.b;
        };
        FinancialSeries.prototype.rp = function (a) {
            return a.bx.c;
        };
        FinancialSeries.prototype.pi = function (a, b) {
            return this.pj(a, b, this.qc);
        };
        FinancialSeries.prototype.get_dr = function () {
            return true;
        };
        FinancialSeries.prototype.kf = function () {
            _super.prototype.kf.call(this);
            this.qa = null;
        };
        FinancialSeries.prototype.av = function (a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                var d = this.p9(a, b, this.qa);
                this.qa = d;
                return d;
            }
            else {
                var e = this.p8(a, b, this.qa);
                this.qa = e;
                return e;
            }
        };
        FinancialSeries.prototype.rr = function (a) {
            var b = this.pt();
            var c = this.bx.bu;
            var d = this.bx.bv;
            var e = this.pq;
            var f = 0;
            if (e.cj) {
                var g = (a.y - d.top) / d.height;
                f = g * c.height + c.top;
            }
            else {
                var h = (a.x - d.left) / d.width;
                f = h * c.width + c.left;
            }
            var i = b.f.count;
            var j = 0;
            for (j = 0; j < i; j++) {
                var k = b.f._inner[j];
                var l = null;
                if (j < i - 1) {
                    l = b.f._inner[j + 1];
                }
                if (k[0] <= f && l == null || l[0] >= f) {
                    if (l != null) {
                        if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                            return j;
                        }
                        else {
                            return j + 1;
                        }
                    }
                    else {
                        return j;
                    }
                }
            }
            return j;
        };
        FinancialSeries.prototype.p9 = function (a, b, c) {
            var d = this.ch.count;
            var e = this.p7.bx.c;
            var f = this.p7.bx.d;
            var g = this.p7.bx.b;
            var h = this.pq;
            var i = -1;
            var j = -1;
            if (h.ch) {
                var k = this.pt();
                var l = this.rr(b);
                i = l;
                j = l;
            }
            else {
                var m = this.g0(b);
                i = i2.truncate(Math.floor((i2.intDivide(m, g)))) * g;
                j = i + (g - 1);
            }
            if (c != null && c.h == i && c.g == j) {
                return c;
            }
            var n = new HighlightingInfo();
            n.b = this;
            n.h = i;
            n.g = j;
            return n;
        };
        FinancialSeries.prototype.p8 = function (a, b, c) {
            var d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        };
        FinancialSeries.prototype.qu = function () {
            return this.qw;
        };
        FinancialSeries.prototype.fw = function (a) {
            var b = this.bx.bv;
            var c = this.bx.bu;
            var d = -1;
            if (!b.isEmpty && !c.isEmpty && this.pq != null) {
                var e = this.getEffectiveViewport1(this.bx);
                var f = new ScalerParams(0, b, c, this.pq.cc, e);
                var g = this.o7(this.bx);
                var h = this.pq.eb(g.left, f);
                var i = this.pq.eb(g.right, f);
                var j = (a.x - b.left) / b.width;
                var k = h + (j * (i - h));
                if (this.pq.categoryMode != 0) {
                    k -= 0.5;
                }
                d = k;
            }
            return d;
        };
        FinancialSeries.prototype.g0 = function (a) {
            return i2.truncate(Math.round(this.fw(a)));
        };
        FinancialSeries.prototype.get_d3 = function () {
            return i2.typeCast(ISortingAxis_$type, this.pq) !== null;
        };
        FinancialSeries.prototype.ar = function () {
            return this.pq;
        };
        FinancialSeries.prototype.g2 = function (a) {
            var b = this.bx.bv;
            var c = this.bx.bu;
            var d = this.getEffectiveViewport1(this.bx);
            if (b.isEmpty || c.isEmpty) {
                return -1;
            }
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = new ScalerParams(0, b, c, this.pq.cc, d);
            var g = i2.typeCast(ISortingAxis_$type, this.pq);
            var h = this.o7(this.bx);
            var i = h.left;
            var j = h.right;
            var k = this.ox(a).x;
            var l = this.pq.eb(k, f);
            var m = this.pq.eb(i, f);
            var n = this.pq.eb(j, f);
            l = Math.max(m, Math.min(n, l));
            var o = g.i$f(l);
            return o;
        };
        FinancialSeries.prototype.hh = function (a) {
            var b = 0;
            if (i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                b = this.g2(a);
                if (b == -1) {
                    return null;
                }
            }
            else {
                b = this.g0(a);
            }
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        };
        FinancialSeries.prototype.pt = function () {
            var a = this.ps;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.pw;
            }
            return a;
        };
        FinancialSeries.prototype.rh = function (a, b, c) {
            if (this.pq == null) {
                return 0;
            }
            return this.pq.kj(a, b, c, this.g9);
        };
        FinancialSeries.prototype.ek = function () {
            return this.qx;
        };
        FinancialSeries.prototype.p0 = function () {
            return 11;
        };
        FinancialSeries.prototype.b6 = function () {
            return 3;
        };
        FinancialSeries.prototype.sj = function (a, b) {
            this.o6 = a.aa;
            b.au();
        };
        FinancialSeries.prototype.sh = function (a, b) {
            a.u();
        };
        FinancialSeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            var e = c;
            if (this.ch == null || this.ch.count == 0 || !c.o() || b.isEmpty || a.isEmpty || this.pq == null || this.qc == null || e.bx.b < 1 || this.pq.bh == null || this.qc.bh == null || this.qc.kv == this.qc.ku || this.pq.itemsSource == null || this.pq.kq < 1) {
                e.bx.b = 0;
                d = false;
            }
            return d;
        };
        FinancialSeries.prototype.getViewInfo = function (a, b) {
            b = this.bx.bv;
            a = this.bx.bu;
            return {
                p0: a,
                p1: b
            };
        };
        FinancialSeries.prototype.rl = function (a) {
            var b = 0;
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(this.bx);
            if (!c.isEmpty && !d.isEmpty && this.qc != null) {
                var f = new ScalerParams(0, c, d, this.qc.cc, e);
                f.b = this.f2();
                b = this.qc.d8(this.qc.k5, f);
            }
            return b;
        };
        FinancialSeries.prototype.ki = function () {
            _super.prototype.ki.call(this);
            this.pu.v();
            this.ps.v();
            this.pw.v();
        };
        FinancialSeries.prototype.l1 = function (a) {
            var _this = this;
            _super.prototype.l1.call(this, a);
            this.p7.bx.e(this.gh);
            if (this.ct(this.bx)) {
                return;
            }
            if (this.em) {
                if (this.cr()) {
                    this.sj(this.pw, this.p7);
                }
                else {
                    this.sj(this.ps, this.p7);
                }
                return;
            }
            if (this.ei(a)) {
                var b = this.pu;
                if (this.cr()) {
                    if (this.cb.g) {
                        this.cb.t();
                    }
                    this.pu = this.pw;
                    this.pw = b;
                }
                else {
                    this.pu = this.ps;
                    this.ps = b;
                }
                this.sh(this.ps, this.p7);
                if (this.ew) {
                    this.cb.w();
                    this.cb.r = i2.truncate(this.gc());
                    this.cb.b = this.cd != null ? this.cd : this.cc;
                    this.p2.p(this.pu, this.ps, this.isVertical, this.pq, this.qc, this.p1, this.p0(), this.b7, this.b6(), function () { return _this.rl(_this.p7); }, this.p7.bu);
                }
                this.kd();
                this.l8();
                if (this.ew) {
                    this.ev = false;
                    this.eu = true;
                }
            }
            else {
                this.sh(this.ps, this.p7);
                this.sj(this.ps, this.p7);
            }
        };
        FinancialSeries.prototype.qz = function (a) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    switch (b) {
                        case "HighColumn":
                            if (this.qk == null) {
                                return false;
                            }
                            break;
                        case "LowColumn":
                            if (this.ql == null) {
                                return false;
                            }
                            break;
                        case "OpenColumn":
                            if (this.qm == null) {
                                return false;
                            }
                            break;
                        case "CloseColumn":
                            if (this.qj == null) {
                                return false;
                            }
                            break;
                        case "VolumeColumn":
                            if (this.qo == null) {
                                return false;
                            }
                            break;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        Object.defineProperty(FinancialSeries.prototype, "q0", {
            get: function () {
                return this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null;
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype.qv = function () {
            return this.typical != null;
        };
        FinancialSeries.prototype.se = function (a) {
            this.typical(this, a);
        };
        Object.defineProperty(FinancialSeries.prototype, "q8", {
            get: function () {
                return this.q5();
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype._q5 = function () {
            var a, b, _a, _b, c, e_2_1, d, e, f, g, h;
            var e_2, _c;
            return tslib.__generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        a = false;
                        if (!this.qv())
                            return [3 /*break*/, 8];
                        b = this.p3(0, this.ch.count);
                        this.se(new FinancialEventArgs(0, this.ch.count, b, this.p4(b), this));
                        if (!(b.typicalColumn != null))
                            return [3 /*break*/, 8];
                        a = true;
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        _a = tslib.__values(i2.fromEnum(b.typicalColumn)), _b = _a.next();
                        _d.label = 2;
                    case 2:
                        if (!!_b.done)
                            return [3 /*break*/, 5];
                        c = _b.value;
                        return [4 /*yield*/, c];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_c = _a.return))
                                _c.call(_a);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                        return [7 /*endfinally*/];
                    case 8:
                        if (!!a)
                            return [3 /*break*/, 17];
                        if (!(this.q0 && this.pq.i$b != null))
                            return [3 /*break*/, 13];
                        d = this.ch.count;
                        e = this.pq.i$b;
                        f = 0;
                        _d.label = 9;
                    case 9:
                        if (!(f < d))
                            return [3 /*break*/, 12];
                        return [4 /*yield*/, (this.qk.item(e.item(f)) + this.ql.item(e.item(f)) + this.qj.item(e.item(f))) / 3];
                    case 10:
                        _d.sent();
                        _d.label = 11;
                    case 11:
                        ++f;
                        return [3 /*break*/, 9];
                    case 12: return [3 /*break*/, 17];
                    case 13:
                        g = this.ch.count;
                        h = 0;
                        _d.label = 14;
                    case 14:
                        if (!(h < g))
                            return [3 /*break*/, 17];
                        return [4 /*yield*/, (this.qk.item(h) + this.ql.item(h) + this.qj.item(h)) / 3];
                    case 15:
                        _d.sent();
                        _d.label = 16;
                    case 16:
                        ++h;
                        return [3 /*break*/, 14];
                    case 17: return [2 /*return*/];
                }
            });
        };
        FinancialSeries.prototype.q5 = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._q5(); });
        };
        Object.defineProperty(FinancialSeries.prototype, "q7", {
            get: function () {
                return this.q4();
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype._q4 = function () {
            var a, b, c, d, e;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.q0 && this.pq.i$b != null))
                            return [3 /*break*/, 7];
                        a = this.qk.count;
                        b = this.pq.i$b;
                        if (!(a > 0))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, this.rm(this.qk.item(b.item(0)) - this.ql.item(b.item(0)))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        c = 1;
                        _a.label = 3;
                    case 3:
                        if (!(c < a))
                            return [3 /*break*/, 6];
                        return [4 /*yield*/, Math.max(this.rm(this.qk.item(b.item(c)) - this.ql.item(b.item(c))), Math.max(this.rm(Math.abs(this.qk.item(b.item(c)) - this.qj.item(b.item(c - 1)))), this.rm(Math.abs(this.ql.item(b.item(c)) - this.qj.item(b.item(c - 1))))))];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        ++c;
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 13];
                    case 7:
                        d = this.qk.count;
                        if (!(d > 0))
                            return [3 /*break*/, 9];
                        return [4 /*yield*/, this.rm(this.qk.item(0) - this.ql.item(0))];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9:
                        e = 1;
                        _a.label = 10;
                    case 10:
                        if (!(e < d))
                            return [3 /*break*/, 13];
                        return [4 /*yield*/, Math.max(this.rm(this.qk.item(e) - this.ql.item(e)), Math.max(this.rm(Math.abs(this.qk.item(e) - this.qj.item(e - 1))), this.rm(Math.abs(this.ql.item(e) - this.qj.item(e - 1)))))];
                    case 11:
                        _a.sent();
                        _a.label = 12;
                    case 12:
                        ++e;
                        return [3 /*break*/, 10];
                    case 13: return [2 /*return*/];
                }
            });
        };
        FinancialSeries.prototype.q4 = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._q4(); });
        };
        Object.defineProperty(FinancialSeries.prototype, "q6", {
            get: function () {
                return this.q3();
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype._q3 = function () {
            var a, b, c, d, e;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.q0 && this.pq.i$b != null))
                            return [3 /*break*/, 7];
                        a = this.ql.count;
                        b = this.pq.i$b;
                        if (!(a > 0))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, this.rm(this.ql.item(b.item(0)))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        c = 1;
                        _a.label = 3;
                    case 3:
                        if (!(c < a))
                            return [3 /*break*/, 6];
                        return [4 /*yield*/, Math.min(this.rm(this.ql.item(b.item(c))), this.rm(this.qj.item(b.item(c - 1))))];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        c++;
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 13];
                    case 7:
                        d = this.ql.count;
                        if (!(d > 0))
                            return [3 /*break*/, 9];
                        return [4 /*yield*/, this.rm(this.ql.item(0))];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9:
                        e = 1;
                        _a.label = 10;
                    case 10:
                        if (!(e < d))
                            return [3 /*break*/, 13];
                        return [4 /*yield*/, Math.min(this.rm(this.ql.item(e)), this.rm(this.qj.item(e - 1)))];
                    case 11:
                        _a.sent();
                        _a.label = 12;
                    case 12:
                        e++;
                        return [3 /*break*/, 10];
                    case 13: return [2 /*return*/];
                }
            });
        };
        FinancialSeries.prototype.q3 = function () {
            var _this = this;
            return i2.toEnum(function () { return _this._q3(); });
        };
        FinancialSeries.prototype.ra = function (a) {
            if (a == null) {
                return null;
            }
            if (this.q0 && this.pq.i$b != null) {
                return new SafeSortedReadOnlyDoubleCollection(0, a, this.pq.i$b);
            }
            return new SafeReadOnlyDoubleCollection(0, a);
        };
        FinancialSeries.prototype.q9 = function () {
            var a = new i2.List$1(i2.String_$type, 0);
            a.add("HighColumn");
            a.add("LowColumn");
            a.add("CloseColumn");
            if (this.typicalBasedOn != null && this.ch != null && !this.qp) {
                this.qp = true;
                var b = this.p3(0, this.ch.count);
                this.qp = false;
                var c = new FinancialEventArgs(0, this.ch.count, b, this.p4(b), this);
                this.typicalBasedOn(this, c);
                if (c.basedOn != null && c.basedOn.count > 0) {
                    return c.basedOn;
                }
            }
            return a;
        };
        FinancialSeries.prototype.getOpenColumnAsArray = function () {
            if (this.qm == null) {
                return null;
            }
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.re != null) {
                    return this.re.asArray();
                }
                var a = new i2.List$1(i2.Number_$type, 2, this.qm.count);
                var b = this.pq.i$b;
                var c = this.qm.asArray();
                for (var d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.re = a;
                return this.re.asArray();
            }
            else {
                return this.qm.asArray();
            }
        };
        FinancialSeries.prototype.getHighColumnAsArray = function () {
            if (this.qk == null) {
                return null;
            }
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rc != null) {
                    return this.rc.asArray();
                }
                var a = new i2.List$1(i2.Number_$type, 2, this.qk.count);
                var b = this.pq.i$b;
                var c = this.qk.asArray();
                for (var d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rc = a;
                return this.rc.asArray();
            }
            else {
                return this.qk.asArray();
            }
        };
        FinancialSeries.prototype.getLowColumnAsArray = function () {
            if (this.ql == null) {
                return null;
            }
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rd != null) {
                    return this.rd.asArray();
                }
                var a = new i2.List$1(i2.Number_$type, 2, this.ql.count);
                var b = this.pq.i$b;
                var c = this.ql.asArray();
                for (var d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rd = a;
                return this.rd.asArray();
            }
            else {
                return this.ql.asArray();
            }
        };
        FinancialSeries.prototype.getCloseColumnAsArray = function () {
            if (this.qj == null) {
                return null;
            }
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rb != null) {
                    return this.rb.asArray();
                }
                var a = new i2.List$1(i2.Number_$type, 2, this.qj.count);
                var b = this.pq.i$b;
                var c = this.qj.asArray();
                for (var d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rb = a;
                return this.rb.asArray();
            }
            else {
                return this.qj.asArray();
            }
        };
        FinancialSeries.prototype.getVolumeColumnAsArray = function () {
            if (this.qo == null) {
                return null;
            }
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                if (this.rf != null) {
                    return this.rf.asArray();
                }
                var a = new i2.List$1(i2.Number_$type, 2, this.qo.count);
                var b = this.pq.i$b;
                var c = this.qo.asArray();
                for (var d = 0; d < b.count; d++) {
                    a.add(c[b._inner[d]]);
                }
                this.rf = a;
                return this.rf.asArray();
            }
            else {
                return this.qo.asArray();
            }
        };
        FinancialSeries.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            if (this.pq == null || !(i2.typeCast(ISortingAxis_$type, this.pq) !== null)) {
                return;
            }
            var e = this.pq.i$b;
            switch (a) {
                case 1:
                    for (var f = b; f < c; f++) {
                        var g = e._inner[f];
                        if (this.re != null) {
                            this.re.insert(f, this.qm.item(g));
                        }
                        if (this.rc != null) {
                            this.rc.insert(f, this.qk.item(g));
                        }
                        if (this.rd != null) {
                            this.rd.insert(f, this.ql.item(g));
                        }
                        if (this.rb != null) {
                            this.rb.insert(f, this.qj.item(g));
                        }
                        if (this.rf != null) {
                            this.rf.insert(f, this.qo.item(g));
                        }
                    }
                    break;
                case 0:
                    if (this.re != null) {
                        this.re.v(b, c);
                    }
                    if (this.rc != null) {
                        this.rc.v(b, c);
                    }
                    if (this.rd != null) {
                        this.rd.v(b, c);
                    }
                    if (this.rb != null) {
                        this.rb.v(b, c);
                    }
                    if (this.rf != null) {
                        this.rf.v(b, c);
                    }
                    break;
                case 4:
                    if (this.re != null) {
                        this.re = new i2.List$1(i2.Number_$type, 0);
                    }
                    if (this.rc != null) {
                        this.rc = new i2.List$1(i2.Number_$type, 0);
                    }
                    if (this.rd != null) {
                        this.rd = new i2.List$1(i2.Number_$type, 0);
                    }
                    if (this.rb != null) {
                        this.rb = new i2.List$1(i2.Number_$type, 0);
                    }
                    if (this.rf != null) {
                        this.rf = new i2.List$1(i2.Number_$type, 0);
                    }
                    break;
                case 3:
                case 2:
                    for (var h = b; h < c; h++) {
                        var i = e._inner[h];
                        if (this.re != null) {
                            this.re._inner[h] = this.qm.item(i);
                        }
                        if (this.rc != null) {
                            this.rc._inner[h] = this.qk.item(i);
                        }
                        if (this.rd != null) {
                            this.rd._inner[h] = this.ql.item(i);
                        }
                        if (this.rb != null) {
                            this.rb._inner[h] = this.qj.item(i);
                        }
                        if (this.rf != null) {
                            this.rf._inner[h] = this.qo.item(i);
                        }
                    }
                    break;
            }
            this.sk();
            this.mj();
        };
        FinancialSeries.prototype.p3 = function (a, b) {
            var _this = this;
            var c = this.ra(this.qm);
            var d = this.ra(this.qj);
            var e = this.ra(this.qk);
            var f = this.ra(this.ql);
            var g = this.ra(this.qo);
            var h = ((function () {
                var $ret = new FinancialCalculationDataSource();
                $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.q8), _this.q9());
                $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.q7), ((function () {
                    var $ret = new i2.List$1(i2.String_$type, 0);
                    $ret.add("HighColumn");
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.q6), ((function () {
                    var $ret = new i2.List$1(i2.String_$type, 0);
                    $ret.add("LowColumn");
                    $ret.add("CloseColumn");
                    return $ret;
                })()));
                $ret.openColumn = c;
                $ret.closeColumn = d;
                $ret.highColumn = e;
                $ret.lowColumn = f;
                $ret.volumeColumn = g;
                $ret.calculateFrom = a;
                $ret.calculateCount = b;
                $ret.minimumValue = NaN;
                $ret.maximumValue = NaN;
                $ret.count = _this.ch != null ? _this.ch.count : 0;
                return $ret;
            })());
            return h;
        };
        FinancialSeries.prototype.rm = function (a) {
            if (i2.isInfinity(a) || i2.isNaN_(a)) {
                return 0;
            }
            return a;
        };
        FinancialSeries.prototype.p4 = function (a) {
            var _this = this;
            return ((function () {
                var $ret = new FinancialCalculationSupportingCalculations();
                $ret.a = new ColumnSupportingCalculation(1, i2.TrendCalculators.b, new i2.List$1(i2.String_$type, 0));
                $ret.c = new ColumnSupportingCalculation(1, i2.TrendCalculators.e, new i2.List$1(i2.String_$type, 0));
                $ret.d = new ColumnSupportingCalculation(1, i2.TrendCalculators.f, new i2.List$1(i2.String_$type, 0));
                $ret.b = new ColumnSupportingCalculation(1, i2.TrendCalculators.d, new i2.List$1(i2.String_$type, 0));
                $ret.h = new DataSourceSupportingCalculation(1, function (b) { return i2.TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                    var $ret = new i2.List$1(i2.String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.f = new DataSourceSupportingCalculation(1, function (b) { return i2.TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                    var $ret = new i2.List$1(i2.String_$type, 0);
                    $ret.add("VolumeColumn");
                    return $ret;
                })()));
                $ret.g = new DataSourceSupportingCalculation(1, function (b) { return i2.TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
                $ret.e = new DataSourceSupportingCalculation(1, function (b) { return i2.TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
                $ret.k = Series.e8;
                $ret.j = Series.e7;
                $ret.i = i2.runOn(_this, _this.rm);
                return $ret;
            })());
        };
        Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
            get: function () {
                return this.pq;
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            var c = i2.typeCast(FinancialSeriesView.$, this.bw);
            this.bx.a2(b);
            c.bx.e(this.gh);
            if (this.ct(this.bw)) {
                return;
            }
            if (!this.en) {
                this.sh(this.pv, c);
            }
            this.en = false;
            this.sj(this.pv, c);
            this.et = false;
        };
        FinancialSeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            g.bx.e(this.gh);
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.pr == null) {
                this.pr = new CategoryFrame(3);
            }
            this.pr.u();
            this.sh(this.pr, g);
            this.sj(this.pr, g);
        };
        FinancialSeries.prototype.an = function (a) {
            if (this.pq == a) {
                return this.qc;
            }
            if (this.qc == a) {
                return this.pq;
            }
            return null;
        };
        FinancialSeries.prototype.preferredCategoryMode = function (a) {
            var b = i2.typeCast(IDateTimeAxis_$type, this.pq);
            return b != null ? b.preferredCategoryMode(this) : this.py;
        };
        Object.defineProperty(FinancialSeries.prototype, "py", {
            get: function () {
                return this.px;
            },
            set: function (a) {
                var b = this.py;
                if (a != b) {
                    this.px = a;
                    this.raisePropertyChanged("CategoryMode", i2.enumGetBox(CategoryMode_$type, b), i2.enumGetBox(CategoryMode_$type, this.py));
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialSeries.prototype.get_dx = function () {
            return true;
        };
        FinancialSeries.prototype.l5 = function (a, b) {
            _super.prototype.l5.call(this, a, b);
            this.sw = a;
        };
        FinancialSeries.prototype.sk = function () {
            this.fs = this.qj == null || this.qj.count == 0 ? NaN : this.qj.item(this.qj.count - 1);
        };
        FinancialSeries.prototype.hj = function (a) {
            if (this.qb != null && a != null) {
                if (this.qd == null || this.qd.propertyName != this.qb.dateTimeMemberPath) {
                    this.qd = new i2.FastReflectionHelper(false, this.qb.dateTimeMemberPath);
                }
                var b = this.qd.getPropertyValue(a);
                if (i2.typeCast(i2.Date_$type, b) !== null) {
                    return i2.dateToStringFormat(b, this.qb.itemLabelFormat());
                }
            }
            return _super.prototype.hj.call(this, a);
        };
        FinancialSeries.$t = i2.markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
        FinancialSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:ru:sl', [2, null], 'HighMemberPath:rx:sm', [2, null], 'IsCustomCategoryStyleAllowed:qw:sn', [0, false], 'IsTransitionInEnabled:qx:so', [0, false], 'LowMemberPath:r2:sp', [2, null], 'NegativeBrush:sw:sq', [i2.Brush.$, null], 'OpenMemberPath:r6:sr', [2, null], 'TransitionInMode:p1:ss', [CategoryTransitionInMode_$type, i2.enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:sa:st', [2, null], 'XAxis:pq:su', [CategoryAxisBase.$, null], 'YAxis:qc:sv', [NumericYAxis.$, null]]);
        return FinancialSeries;
    }(Series));
    /**
     * @hidden
     */
    var FinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialCalculationSupportingCalculations, _super);
        function FinancialCalculationSupportingCalculations() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.c = null;
            _this.d = null;
            _this.b = null;
            _this.h = null;
            _this.f = null;
            _this.g = null;
            _this.e = null;
            _this.k = null;
            _this.j = null;
            _this.i = null;
            return _this;
        }
        FinancialCalculationSupportingCalculations.$t = i2.markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
        return FinancialCalculationSupportingCalculations;
    }(i2.Base));
    /**
     * @hidden
     */
    var DataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DataSourceSupportingCalculation, _super);
        function DataSourceSupportingCalculation(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, i2.Delegate_$type, 0, c) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        _this = _super.call(this, i2.Delegate_$type, 1, c, d) || this;
                    }
                    break;
            }
            return _this;
        }
        DataSourceSupportingCalculation.$t = i2.markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(i2.Delegate_$type));
        return DataSourceSupportingCalculation;
    }(SupportingCalculation$1));
    /**
     * @hidden
     */
    var FinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialCalculationDataSource, _super);
        function FinancialCalculationDataSource() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._openColumn = null;
            _this._closeColumn = null;
            _this._highColumn = null;
            _this._lowColumn = null;
            _this._volumeColumn = null;
            _this._indicatorColumn = null;
            _this._typicalColumn = null;
            _this._trueRange = null;
            _this._trueLow = null;
            _this._period = 0;
            _this._shortPeriod = 0;
            _this._longPeriod = 0;
            _this._count = 0;
            _this._calculateFrom = 0;
            _this._calculateCount = 0;
            _this._multiplier = 0;
            _this._minimumValue = 0;
            _this._maximumValue = 0;
            _this._specifiesRange = false;
            _this._series = null;
            return _this;
        }
        Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
            get: function () {
                return this._openColumn;
            },
            set: function (a) {
                this._openColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
            get: function () {
                return this._closeColumn;
            },
            set: function (a) {
                this._closeColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
            get: function () {
                return this._highColumn;
            },
            set: function (a) {
                this._highColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
            get: function () {
                return this._lowColumn;
            },
            set: function (a) {
                this._lowColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
            get: function () {
                return this._volumeColumn;
            },
            set: function (a) {
                this._volumeColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
            get: function () {
                return this._indicatorColumn;
            },
            set: function (a) {
                this._indicatorColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
            get: function () {
                return this._typicalColumn;
            },
            set: function (a) {
                this._typicalColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
            get: function () {
                return this._trueRange;
            },
            set: function (a) {
                this._trueRange = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
            get: function () {
                return this._trueLow;
            },
            set: function (a) {
                this._trueLow = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
            get: function () {
                return this._period;
            },
            set: function (a) {
                this._period = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
            get: function () {
                return this._shortPeriod;
            },
            set: function (a) {
                this._shortPeriod = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
            get: function () {
                return this._longPeriod;
            },
            set: function (a) {
                this._longPeriod = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
            get: function () {
                return this._count;
            },
            set: function (a) {
                this._count = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
            get: function () {
                return this._calculateFrom;
            },
            set: function (a) {
                this._calculateFrom = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
            get: function () {
                return this._calculateCount;
            },
            set: function (a) {
                this._calculateCount = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
            get: function () {
                return this._multiplier;
            },
            set: function (a) {
                this._multiplier = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
            get: function () {
                return this._minimumValue;
            },
            set: function (a) {
                this._minimumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
            get: function () {
                return this._maximumValue;
            },
            set: function (a) {
                this._maximumValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
            get: function () {
                return this._specifiesRange;
            },
            set: function (a) {
                this._specifiesRange = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialCalculationDataSource.$t = i2.markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
        return FinancialCalculationDataSource;
    }(i2.Base));
    /**
     * @hidden
     */
    var FinancialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialSeriesView, _super);
        function FinancialSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.bz = null;
            _this.bx = null;
            _this.b1 = 0;
            _this.b1 = -1;
            _this.bz = a;
            _this.bx = _this.by();
            return _this;
        }
        FinancialSeriesView.prototype.b0 = function (a) {
            if (this.b1 != a.t) {
                return true;
            }
            return false;
        };
        FinancialSeriesView.prototype.b2 = function (a) {
            this.b1 = a.t;
        };
        FinancialSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
            }
        };
        FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.bz.pq.b9) {
                a += "<span>${itemLabel}</span><br/>";
            }
            else if (this.bz.pq.fj != null) {
                a += "<span>${item." + this.bz.pq.fj + "}</span><br/>";
            }
            a += "<span class='ui-priority-primary'";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            var c = new i2.SRProvider(this.w);
            var d = c.b1("financialSeries_Open");
            var e = c.b1("financialSeries_High");
            var f = c.b1("financialSeries_Low");
            var g = c.b1("financialSeries_Close");
            d = i2.stringIsNullOrEmpty(d) ? "Open" : d;
            e = i2.stringIsNullOrEmpty(e) ? "High" : e;
            f = i2.stringIsNullOrEmpty(f) ? "Low" : f;
            g = i2.stringIsNullOrEmpty(g) ? "Close" : g;
            a += ">" + this.bz.hp + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.bz.r6 + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.bz.rx + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.bz.r2 + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.bz.ru + "}</td></tr>";
            if (!i2.stringIsNullOrEmpty(this.bz.sa)) {
                var h = c.b1("financialSeries_Volume");
                h = i2.stringIsNullOrEmpty(h) ? "Volume" : h;
                a += "<tr><td>" + h + ":</td><td>" + "${item." + this.bz.sa + "}</td></tr>";
            }
            a += "</table></div>";
            return a;
        };
        FinancialSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 2;
            this.e.gl = 2;
        };
        FinancialSeriesView.$t = i2.markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
        return FinancialSeriesView;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available display types for financial indicators.
     */
    var IndicatorDisplayType = /*@__PURE__*/ (function (IndicatorDisplayType) {
        /**
         * Display indicator as a line chart.
         */
        IndicatorDisplayType[IndicatorDisplayType["Line"] = 0] = "Line";
        /**
         * Display indicator as an area chart.
         */
        IndicatorDisplayType[IndicatorDisplayType["Area"] = 1] = "Area";
        /**
         * Display indicator as a column chart.
         */
        IndicatorDisplayType[IndicatorDisplayType["Column"] = 2] = "Column";
        return IndicatorDisplayType;
    })({});
    /**
     * @hidden
     */
    var IndicatorDisplayType_$type = i2.markEnum('IndicatorDisplayType', 'Line,0|Area,1|Column,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DelegateClipper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DelegateClipper, _super);
        function DelegateClipper(a, b, c, d) {
            var e_1, _b, e_2, _c;
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.c = null;
            _this.d = null;
            var e = new i2.List$1(i2.Point_$type, 0);
            try {
                for (var _d = tslib.__values(i2.fromEnum(DelegateClipper.a(0, c))), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var f = _e.value;
                    e.add({ $type: i2.Point_$type, x: a(f), y: b(f) });
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_b = _d.return))
                        _b.call(_d);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            _this.b = new i2.List$1(i2.Point_$type, 0);
            _this.c = function (g) { return _this.b.count > g ? _this.b._inner[g].x : NaN; };
            _this.d = function (g) { return _this.b.count > g ? _this.b._inner[g].y : NaN; };
            d.i = _this.b;
            try {
                for (var _f = tslib.__values(i2.fromEnum(e)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var g = _g.value;
                    d.j(g);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_c = _f.return))
                        _c.call(_f);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            d.i = null;
            return _this;
        }
        Object.defineProperty(DelegateClipper.prototype, "e", {
            get: function () {
                return this.b.count;
            },
            enumerable: false,
            configurable: true
        });
        DelegateClipper._a = function (a, b) {
            var c;
            return tslib.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        c = a;
                        _b.label = 1;
                    case 1:
                        if (!(c < a + b))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, c];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        c++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        DelegateClipper.a = function (a, b) {
            return i2.toEnum(function () { return DelegateClipper._a(a, b); });
        };
        DelegateClipper.$t = i2.markType(DelegateClipper, 'DelegateClipper');
        return DelegateClipper;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IndicatorRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IndicatorRenderer, _super);
        function IndicatorRenderer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IndicatorRenderer.h = function (a, b, c, d) {
            var e_1, _c;
            var e = new i2.PathFigure();
            var f = IndicatorRenderer.b(a, b, c, d);
            var _loop_1 = function (g) {
                e._segments.add(((function () {
                    var $ret = new i2.LineSegment(1);
                    $ret.c = g;
                    return $ret;
                })()));
            };
            try {
                for (var _d = tslib.__values(i2.fromEnum(f)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var g = _e.value;
                    _loop_1(g);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_c = _d.return))
                        _c.call(_d);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            e._startPoint = e._segments._inner[0].c;
            return e;
        };
        IndicatorRenderer.g = function (a, b, c, d, e, f, g, h, i, j, k) {
            var l = g.ak.c;
            var m = h.ak.c;
            if (a > 1) {
                var n = new DelegateClipper(b, c, a, k);
                b = n.c;
                c = n.d;
                a = n.e;
            }
            if (i == 1) {
                var o = new i2.List$1(i2.Number_$type, 0);
                var p = l;
                var q = 0;
                o.add(0);
                for (var r = 0, s = 1; s < a; r = s++) {
                    var t = q;
                    var u = c(s) - c(r);
                    if (d && !i2.isNaN_(u)) {
                        t = Math.sign(u);
                    }
                    if (t != 0 && t != q) {
                        p.add(IndicatorRenderer.h(o, b, c, j));
                        q = t;
                        p = q == 1 ? m : l;
                        o.clear();
                        o.add(r);
                    }
                    o.add(s);
                }
                p.add(IndicatorRenderer.h(o, b, c, j));
            }
            else {
                var v = new i2.List$1(i2.Number_$type, 0);
                var w = l;
                var x = 0;
                v.add(0);
                for (var y = 0, z = 1; z < a; y = z++) {
                    var aa = x;
                    var ab = c(z) - c(y);
                    if (d && !i2.isNaN_(ab)) {
                        aa = Math.sign(ab);
                    }
                    if (aa != 0 && aa != x) {
                        if (v.count > 0) {
                            w.add(IndicatorRenderer.h(v, b, c, j));
                        }
                        x = aa;
                        w = x == 1 ? m : l;
                        v.clear();
                        v.add(y);
                    }
                    v.add(z);
                }
                if (v.count > 0) {
                    w.add(IndicatorRenderer.h(v, b, c, j));
                }
            }
        };
        IndicatorRenderer.e = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n) {
            var o = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 0);
            var p = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 0);
            var q = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 0);
            var r = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 0);
            if (a <= 1) {
                n = null;
            }
            k = Math.max(f.top, Math.min(f.bottom, k));
            if (l == 1) {
                var s = new i2.List$1(i2.Number_$type, 0);
                var t = o;
                var u = p;
                var v = 0;
                s.add(0);
                for (var w = 0, x = 1; x < a; w = x++) {
                    var y = v;
                    var z = c(x) - c(w);
                    if (d && !i2.isNaN_(z)) {
                        y = Math.sign(z);
                    }
                    if (y != 0 && y != v) {
                        if (s.count > 0) {
                            var aa = new i2.List$1(i2.Point_$type, 1, IndicatorRenderer.b(s, b, c, m));
                            var ab = new i2.List$1(i2.Point_$type, 1, aa);
                            ab.add({ $type: i2.Point_$type, x: aa._inner[aa.count - 1].x, y: k });
                            ab.add({ $type: i2.Point_$type, x: aa._inner[0].x, y: k });
                            t.add(aa);
                            u.add(ab);
                        }
                        v = y;
                        t = v == 1 ? q : o;
                        u = v == 1 ? r : p;
                        s.clear();
                        s.add(w);
                    }
                    s.add(x);
                }
                var ac = new i2.List$1(i2.Point_$type, 1, IndicatorRenderer.b(s, b, c, m));
                var ad = new i2.List$1(i2.Point_$type, 1, ac);
                ad.add({ $type: i2.Point_$type, x: ac._inner[ac.count - 1].x, y: k });
                ad.add({ $type: i2.Point_$type, x: ac._inner[0].x, y: k });
                t.add(ac);
                u.add(ad);
            }
            else {
                var ae = new i2.List$1(i2.Number_$type, 0);
                var af = o;
                var ag = p;
                var ah = 0;
                ae.add(0);
                for (var ai = 0, aj = 1; aj < a; ai = aj++) {
                    var ak = ah;
                    var al = c(aj) - c(ai);
                    if (d && !i2.isNaN_(al)) {
                        ak = Math.sign(al);
                    }
                    if (ak != 0 && ak != ah) {
                        if (ae.count > 0) {
                            var am = new i2.List$1(i2.Point_$type, 1, IndicatorRenderer.b(ae, b, c, m));
                            var an = new i2.List$1(i2.Point_$type, 1, am);
                            an.add({ $type: i2.Point_$type, x: am._inner[am.count - 1].x, y: k });
                            an.add({ $type: i2.Point_$type, x: am._inner[0].x, y: k });
                            af.add(am);
                            ag.add(an);
                        }
                        ah = ak;
                        af = ah == 1 ? q : o;
                        ag = ah == 1 ? r : p;
                        ae.clear();
                        ae.add(ai);
                    }
                    ae.add(aj);
                }
                var ao = new i2.List$1(i2.Point_$type, 1, IndicatorRenderer.b(ae, b, c, m));
                var ap = new i2.List$1(i2.Point_$type, 1, ao);
                ap.add({ $type: i2.Point_$type, x: ao._inner[ao.count - 1].x, y: k });
                ap.add({ $type: i2.Point_$type, x: ao._inner[0].x, y: k });
                af.add(ao);
                ag.add(ap);
            }
            if (n != null) {
                o = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 1, IndicatorRenderer.a(i2.List$1.$.specialize(i2.Point_$type), i2.List$1.$.specialize(i2.Point_$type), o, function (aq) { return IndicatorRenderer.c(n, aq, false); }));
                p = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 1, IndicatorRenderer.a(i2.List$1.$.specialize(i2.Point_$type), i2.List$1.$.specialize(i2.Point_$type), p, function (aq) { return IndicatorRenderer.c(n, aq, true); }));
                q = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 1, IndicatorRenderer.a(i2.List$1.$.specialize(i2.Point_$type), i2.List$1.$.specialize(i2.Point_$type), q, function (aq) { return IndicatorRenderer.c(n, aq, false); }));
                r = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 1, IndicatorRenderer.a(i2.List$1.$.specialize(i2.Point_$type), i2.List$1.$.specialize(i2.Point_$type), r, function (aq) { return IndicatorRenderer.c(n, aq, true); }));
            }
            var aq = g.ak.c;
            var ar = h.ak.c;
            var as = i.ak.c;
            var at = j.ak.c;
            IndicatorRenderer.d(aq, o);
            IndicatorRenderer.d(ar, p);
            IndicatorRenderer.d(as, q);
            IndicatorRenderer.d(at, r);
        };
        IndicatorRenderer.f = function (a, b, c, d, e, f, g, h, i) {
            var j = i2.typeCast(i2.GeometryGroup.$, h.ak);
            var k = i2.typeCast(i2.GeometryGroup.$, i.ak);
            var l = c;
            var m = b;
            var n = function (o) { return Math.max(e.left, Math.min(e.right, o)); };
            var o = function (p) { return Math.max(e.top, Math.min(e.bottom, p)); };
            b = function (p) { return n(m(p)); };
            c = function (p) { return o(l(p)); };
            f = o(f);
            for (var p = 0; p < a; ++p) {
                var q = g.item(p);
                q.d = { $type: i2.Point_$type, x: b(p), y: f };
                q.c = { $type: i2.Point_$type, x: b(p), y: c(p) };
                var r = false;
                if (p > 0) {
                    if (c(p) <= c(p - 1)) {
                        r = true;
                    }
                }
                else {
                    if (a > 1) {
                        if (c(p + 1) <= c(p)) {
                            r = true;
                        }
                    }
                }
                if (r) {
                    j.d.add(q);
                }
                else {
                    k.d.add(q);
                }
            }
            g.count = a;
        };
        IndicatorRenderer._b = function (a, b, c, d) {
            var e, f, g;
            return tslib.__generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        e = i2.Flattener.a(new i2.List$1(i2.Number_$type, 0), a, b, c, 0, a.count - 1, d);
                        f = 0;
                        _c.label = 1;
                    case 1:
                        if (!(f < e.count))
                            return [3 /*break*/, 4];
                        g = e.item(f);
                        return [4 /*yield*/, { $type: i2.Point_$type, x: b(g), y: c(g) }];
                    case 2:
                        _c.sent();
                        _c.label = 3;
                    case 3:
                        f++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        IndicatorRenderer.b = function (a, b, c, d) {
            return i2.toEnum(function () { return IndicatorRenderer._b(a, b, c, d); });
        };
        IndicatorRenderer.d = function (a, b) {
            var e_2, _c;
            var _loop_2 = function (c) {
                var e_3, _f;
                if (c.count == 0) {
                    return "continue";
                }
                var d = ((function () {
                    var $ret = new i2.PathFigure();
                    $ret.startPoint = c._inner[0];
                    return $ret;
                })());
                var _loop_3 = function (e) {
                    d._segments.add(((function () {
                        var $ret = new i2.LineSegment(1);
                        $ret.c = e;
                        return $ret;
                    })()));
                };
                try {
                    for (var _g = (e_3 = void 0, tslib.__values(i2.fromEnum(c))), _h = _g.next(); !_h.done; _h = _g.next()) {
                        var e = _h.value;
                        _loop_3(e);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_h && !_h.done && (_f = _g.return))
                            _f.call(_g);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                a.add(d);
            };
            try {
                for (var _d = tslib.__values(i2.fromEnum(b)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var c = _e.value;
                    _loop_2(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_c = _d.return))
                        _c.call(_d);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        IndicatorRenderer.c = function (a, b, c) {
            var d = a.f;
            a.f = c;
            var e = new i2.List$1(i2.Point_$type, 0);
            a.i = e;
            a.k(b, false);
            a.i = null;
            a.f = d;
            return e;
        };
        IndicatorRenderer._a = function ($tSource, $tResult, a, b) {
            var _c, _d, c, e_4_1;
            var e_4, _e;
            return tslib.__generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        _f.trys.push([0, 5, 6, 7]);
                        _c = tslib.__values(i2.fromEnum(a)), _d = _c.next();
                        _f.label = 1;
                    case 1:
                        if (!!_d.done)
                            return [3 /*break*/, 4];
                        c = _d.value;
                        return [4 /*yield*/, b(c)];
                    case 2:
                        _f.sent();
                        _f.label = 3;
                    case 3:
                        _d = _c.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_4_1 = _f.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_d && !_d.done && (_e = _c.return))
                                _e.call(_c);
                        }
                        finally {
                            if (e_4)
                                throw e_4.error;
                        }
                        return [7 /*endfinally*/];
                    case 7: return [2 /*return*/];
                }
            });
        };
        IndicatorRenderer.a = function ($tSource, $tResult, a, b) {
            return i2.toEnum(function () { return IndicatorRenderer._a($tSource, $tResult, a, b); });
        };
        IndicatorRenderer.$t = i2.markType(IndicatorRenderer, 'IndicatorRenderer');
        return IndicatorRenderer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialIndicator, _super);
        function FinancialIndicator() {
            var _this = _super.call(this) || this;
            _this._indicatorColumn = null;
            _this.s0 = null;
            _this.pu = new CategoryFrame(3);
            _this.pw = new CategoryFrame(3);
            _this.ps = new CategoryFrame(3);
            _this.indicatorColumn = new i2.List$1(i2.Number_$type, 0);
            _this.s0 = new AxisRange(-100, 100);
            return _this;
        }
        FinancialIndicator.prototype.get_dj = function () {
            return true;
        };
        FinancialIndicator.prototype.bu = function () {
            return new FinancialIndicatorView(this);
        };
        FinancialIndicator.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.s1 = a;
        };
        FinancialIndicator.prototype.te = function (a) {
            if (this.qc != null && !this.qc.cv()) {
                this.l0(true);
            }
        };
        FinancialIndicator.prototype.s6 = function (a, b, c) {
            if (i2.isNaN_(b.x) || i2.isNaN_(b.y)) {
                return false;
            }
            var d = this.qc;
            var e = 0;
            if (d != null) {
                e = d.en(d.k5);
            }
            if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
                return true;
            }
            return false;
        };
        FinancialIndicator.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        FinancialIndicator.prototype.pb = function (a) {
            if (this.pq == null || this.qc == null) {
                return i2.Rect.empty;
            }
            var b = this.ox(a);
            var c = this.bx.bv;
            var d = this.bx.bu;
            var e = this.getEffectiveViewport1(this.bx);
            var f = new ScalerParams(0, c, d, this.qc.cc, e);
            f.b = this.f2();
            var g = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), a, true);
            if (g == null) {
                return i2.Rect.empty;
            }
            var h = g[0];
            var i = g[1];
            var j = Math.abs(b.x - h[0]);
            var k = Math.abs(b.x - i[0]);
            var l = this.qc.d8(this.qc.k5, f);
            var m = 1;
            if (j < k) {
                var n = h[0] - 0.5 * m;
                var o = h[1];
                var p = l;
                return new i2.Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
            }
            else {
                var q = i[0] - 0.5 * m;
                var r = i[1];
                var s = l;
                return new i2.Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
            }
        };
        FinancialIndicator.prototype.ep = function (a, b) {
            var c = this.o2(this.o5(a), true, false);
            if (this.s3 == 1) {
                if (this.s6(a, c, b)) {
                    return true;
                }
            }
            if (this.s3 == 1 || this.s3 == 0) {
                if (this.eo(a, b)) {
                    return true;
                }
            }
            if (this.s3 == 2) {
                if (this.es(a, b)) {
                    return true;
                }
            }
            return false;
        };
        FinancialIndicator.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                this.pq.i$i();
            }
            if (this.s1.b7) {
                this.s1.b5.g$e(a, b, c, d);
            }
            if (d != null && this.q2.containsKey(d)) {
                var e = this.q2.tryGetValue(d, d);
                d = e.p1;
            }
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                a = 4;
                b = 0;
                c = this.ch.count;
            }
            switch (a) {
                case 3:
                    if (this.s5(b, c, d)) {
                        this.tg(b, c, d);
                        this.te(true);
                    }
                    break;
                case 2:
                    if (this.s5(b, this.ch.count - b, d)) {
                        this.tg(b, this.ch.count - b, d);
                        this.te(true);
                    }
                    break;
                case 1:
                    if (this.s5(b, this.ch.count - b, d)) {
                        var f = new Array(c);
                        for (var g = 0; g < c; g++) {
                            f[g] = 0;
                        }
                        this.indicatorColumn.s(b, f);
                        this.tg(b, this.ch.count - b, d);
                        this.te(true);
                    }
                    break;
                case 0:
                    if (this.s5(b, this.ch.count - b, d)) {
                        this.indicatorColumn.v(b, c);
                        this.tg(b, this.ch.count - b, d);
                        this.te(true);
                    }
                    break;
                case 4:
                    if (this.s5(b, this.ch.count - b, d)) {
                        this.indicatorColumn = new i2.List$1(i2.Number_$type, 2, this.ch.count);
                        var h = new Array(c);
                        for (var i = 0; i < c; i++) {
                            h[i] = 0;
                        }
                        this.indicatorColumn.s(0, h);
                        this.tg(b, this.ch.count - b, d);
                        this.te(true);
                    }
                    break;
            }
        };
        FinancialIndicator.prototype.get_s2 = function () {
            return 0;
        };
        Object.defineProperty(FinancialIndicator.prototype, "s2", {
            get: function () {
                return this.get_s2();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialIndicator.prototype, "tr", {
            get: function () {
                return this.c(FinancialIndicator.th);
            },
            set: function (a) {
                this.h(FinancialIndicator.th, a);
            },
            enumerable: false,
            configurable: true
        });
        FinancialIndicator.prototype.tb = function () {
            return -1;
        };
        Object.defineProperty(FinancialIndicator.prototype, "indicatorColumn", {
            get: function () {
                return this._indicatorColumn;
            },
            set: function (a) {
                this._indicatorColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialIndicator.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case "XAxis":
                    this.s1.cd();
                    break;
                case "TrendLineType":
                    var e = i2.EnumUtil.getEnumValue(i2.TrendLineType_$type, d);
                    if (e != 0) {
                        this.s1.b5 = CategoryTrendLineManagerFactory.a(this.s1.b5, this.pq, this.mr, this, this.ck);
                    }
                    break;
            }
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.s1.b7 && this.s1.b5.g$b(a, b, c, d)) {
                this.l0(false);
                var f = i2.typeCast(FinancialIndicatorView.$, this.bw);
                if (f != null && f.b7) {
                    f.b5.g$b(a, b, c, d);
                }
                this.k7();
            }
            switch (b) {
                case "FastItemsSource":
                    if (this.ch != null) {
                        this.indicatorColumn = new i2.List$1(i2.Number_$type, 2, this.ch.count);
                        var g = new Array(this.ch.count);
                        for (var h = 0; h < this.ch.count; h++) {
                            g[h] = 0;
                        }
                        this.indicatorColumn.s(0, g);
                        this.tg(0, this.ch.count, null);
                        if (this.qc != null && !this.qc.cv()) {
                            this.p7.bx.e(this.gh);
                            this.l0(false);
                        }
                    }
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case FinancialIndicator.$$p[0]:
                    this.kh(true, this.bx);
                    this.me();
                    this.l0(false);
                    this.k7();
                    break;
                case "OpenColumn":
                case "HighColumn":
                case "LowColumn":
                case "CloseColumn":
                case "VolumeColumn":
                    if (this.ch != null) {
                        if (this.indicatorColumn.count != this.ch.count) {
                            this.indicatorColumn = new i2.List$1(i2.Number_$type, 2, this.ch.count);
                            var i = new Array(this.ch.count);
                            for (var j = 0; j < this.ch.count; j++) {
                                i[j] = 0;
                            }
                            this.indicatorColumn.s(0, i);
                        }
                        if (this.s5(0, this.ch.count - 1, b)) {
                            this.tf();
                        }
                    }
                    break;
                case "XAxis":
                    if (this.pq != null && (i2.typeCast(ISortingAxis_$type, this.pq) !== null || i2.typeCast(ISortingAxis_$type, c) !== null)) {
                        this.tf();
                    }
                    break;
                case "YAxis":
                case FinancialIndicator.$$p[1]:
                    this.tf();
                    this.k7();
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
            }
        };
        FinancialIndicator.prototype.f8 = function (a, b, c) {
            if (this.indicatorColumn == null) {
                return _super.prototype.f8.call(this, a, b, c);
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            f.c = this.ca.pv;
            return this.ga(this.indicatorColumn, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        FinancialIndicator.prototype.g6 = function (a, b) {
            if (this.indicatorColumn == null) {
                return _super.prototype.g6.call(this, a, b);
            }
            return this.g7(a, b, this.pq, i2.runOn(this, this.rg), this.indicatorColumn);
        };
        FinancialIndicator.prototype.g4 = function (a, b) {
            if (this.indicatorColumn == null) {
                return _super.prototype.g4.call(this, a, b);
            }
            return this.g5(a, b, this.pq, i2.runOn(this, this.rg), this.indicatorColumn);
        };
        FinancialIndicator.prototype.get_e2 = function () {
            return true;
        };
        FinancialIndicator.prototype.s5 = function (a, b, c) {
            if (c == null) {
                return true;
            }
            if (this.s7(a, b).contains(c)) {
                return true;
            }
            return false;
        };
        FinancialIndicator.prototype.tg = function (a, b, c) {
            this.s4(a, b);
        };
        FinancialIndicator.prototype.ap = function (a) {
            if (this.ch == null) {
                return null;
            }
            if (a != null && a == this.qc) {
                return this.s0;
            }
            return null;
        };
        FinancialIndicator.prototype.eh = function (a) {
            var b = this.ch != null ? this.ch.indexOf(a) : -1;
            var c = this.bx.bv;
            c = c.copy();
            var d = this.bx.bu;
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = this.o9(this.bx);
            if (b >= 0 && i2.Rect.l_op_Inequality(c, null) && i2.Rect.l_op_Inequality(d, null)) {
                if (this.pq != null) {
                    var g = new ScalerParams(0, e, e, this.pq.cc, f);
                    var h = this.pq.d8(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.qc != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                    var i = new ScalerParams(0, e, e, this.qc.cc, f);
                    i.b = this.f2();
                    var j = this.qc.d8(this.indicatorColumn._inner[b], i);
                    if (j < c.top + 0.1 * c.height) {
                        j = j + 0.4 * c.height;
                    }
                    if (j > c.bottom - 0.1 * c.height) {
                        j = j - 0.4 * c.height;
                    }
                    c.y = j - 0.5 * c.height;
                }
                this.b5.ap(this.ca, c, true);
            }
            return b >= 0;
        };
        FinancialIndicator.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
                d = false;
            }
            return d;
        };
        FinancialIndicator.prototype.sh = function (a, b) {
            var _this = this;
            _super.prototype.sh.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.pq;
            var g = this.qc;
            var h = new ScalerParams(0, c, d, f.cc, e);
            var i = new ScalerParams(0, c, d, g.cc, e);
            i.b = this.f2();
            a.f.clear();
            a.m.clear();
            a.p.clear();
            var j = 0;
            var k = i2.typeCast(ISortingAxis_$type, this.pq);
            if (k != null && k.i$b.count != this.ch.count) {
                return;
            }
            j = this.rh(c, d, e);
            var l = this.tb();
            if (l == -1) {
                l = this.trendLinePeriod;
            }
            var m = i2.typeCast(FinancialIndicatorView.$, b);
            if (m.b7) {
                m.b5.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, function (n) { return _this.pq.d8(n, h); }, function (n) { return _this.qc.d8(n, i); }, ((function () {
                    var $ret = new TrendResolutionParams();
                    $ret.c = b.bx.b;
                    $ret.d = b.bx.c;
                    $ret.e = b.bx.d;
                    $ret.a = j;
                    $ret.b = _this.gh;
                    $ret.f = d;
                    $ret.g = c;
                    return $ret;
                })()));
            }
            var n = this.pq.eb(2, h) - this.pq.eb(1, h);
            for (var o = b.bx.c; o <= b.bx.d; ++o) {
                var p = void 0;
                if (k == null) {
                    p = b.bx.getBucket(o);
                }
                else {
                    var q = k.i$b._inner[o];
                    var r = k.i$d(q);
                    var s = this.indicatorColumn._inner[o];
                    var t = s;
                    var u = r;
                    while (o < b.bx.d) {
                        q = k.i$b._inner[o + 1];
                        u = k.i$d(q);
                        if (u - r > n) {
                            break;
                        }
                        o++;
                        var v = this.indicatorColumn._inner[o];
                        s = Math.min(s, v);
                        t = Math.max(t, v);
                    }
                    var w = NaN;
                    if (!i2.isNaN_(r)) {
                        w = this.pq.d8(r, h);
                    }
                    p = [w, s, t];
                }
                if (!i2.isNaN_(p[0])) {
                    if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                        p[0] = p[0] + j;
                    }
                    else {
                        p[0] = f.d8(p[0], h) + j;
                    }
                    p[1] = g.d8(p[1], i);
                    if (b.bx.b > 1 || k != null) {
                        p[2] = g.d8(p[2], i);
                    }
                    else {
                        p[2] = p[1];
                    }
                    a.f.add(p);
                }
            }
            return;
        };
        FinancialIndicator.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.b8(a);
            if (c.b7) {
                c.b5.g$d();
            }
        };
        FinancialIndicator.prototype.p0 = function () {
            switch (this.s3) {
                case 1: return 1;
                case 2: return 1;
                case 0: return 12;
            }
            return 1;
        };
        FinancialIndicator.prototype.sj = function (a, b) {
            _super.prototype.sj.call(this, a, b);
            var c = i2.typeCast(FinancialIndicatorView.$, b);
            var d = function (e) { return a.f._inner[e][0]; };
            var e = function (f) { return a.f._inner[f][1]; };
            if (c.b7) {
                c.b5.g$d();
                c.b5.g$g(a.p);
            }
            var f = b.bu;
            var g = this.getEffectiveViewport1(b);
            var h = 0;
            var i = this.of;
            var j = this.sw;
            if (b.b0(a)) {
                c.b8(false);
                if (a.f.count > 0) {
                    switch (this.s3) {
                        case 0:
                            var k = CategorySeries.qx(a.f, a.f.count - 1, f, b.bv, false);
                            c.cc(a.f.count, d, e, true, k);
                            break;
                        case 1:
                            if (this.qc != null) {
                                h = this.rl(b);
                            }
                            else {
                                h = 0.5 * (f.top + f.bottom);
                            }
                            var l = CategorySeries.qx(a.f, a.f.count - 1, f, b.bv, false);
                            c.ca(a.f.count, d, e, true, h, l);
                            break;
                        case 2:
                            h = this.rl(b);
                            c.cb(a.f.count, d, e, true, h);
                            break;
                        default: throw new i2.NotImplementedException(0);
                    }
                }
                b.b2(a);
            }
            var m = a.f;
            var n = this.ch.count;
            this.pz.a0(this, this.qy(), i2.runOn(this, this.pi), this.rn(b), this.rp(b));
            var o = false;
            var p = this.pz.b;
            if (p != null) {
                o = true;
            }
            this.pz.ak = i;
            this.pz.ag = i;
            if (o) {
                var q = new ScalerParams(0, b.bv, b.bu, this.pq.cc, g);
                this.pz.f = false;
                this.sg(m, -1, n, this.pq, q, b.q);
            }
            this.pz.ad(c.cu, true, false, true, false);
            this.pz.ad(c.cw, true, false, true, false);
            this.pz.ad(c.cv, false, true, false, false);
            c.cv._opacity = 0.8 * this.pz.j * this.fi;
            this.pz.ad(c.ct, true, false, false, false);
            this.pz.ak = j;
            this.pz.ag = j;
            if (o) {
                var r = new ScalerParams(0, b.bv, b.bu, this.pq.cc, g);
                this.pz.f = true;
                this.sg(m, -1, n, this.pq, r, b.q);
            }
            this.pz.ad(c.cq, true, false, true, false);
            this.pz.ad(c.cs, true, false, true, false);
            this.pz.ad(c.cr, false, true, false, false);
            c.cr._opacity = 0.8 * this.pz.j * this.fi;
            this.pz.ad(c.cp, true, false, false, false);
            c.ce();
        };
        FinancialIndicator.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            if (this.s1.b7) {
                this.s1.cf();
            }
        };
        FinancialIndicator.prototype.tf = function () {
            if (this.s1.b7) {
                this.s1.b5.g$i();
            }
            this.s4(0, this.indicatorColumn.count);
            if (this.qc != null && !this.qc.cv()) {
                this.l0(false);
            }
        };
        FinancialIndicator.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            this.a6.exportTrendlineData(this, a, this.s1.b5.g$j);
        };
        FinancialIndicator.prototype.a8 = function (a) {
            if (this.s3 == 1 || this.s3 == 2) {
                return 3;
            }
            else if (this.s3 == 0) {
                return 2;
            }
            return a;
        };
        FinancialIndicator.$t = i2.markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
        FinancialIndicator.th = i2.DependencyProperty.i("ActualTrendLineBrush", i2.Brush.$, FinancialIndicator.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
        FinancialIndicator.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:s3:ti', [IndicatorDisplayType_$type, i2.enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:s9:tj', [1, 0], 'TrendLineType::tp', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'TrendLineThickness::to', [1, 1.5], 'TrendLinePeriod::tn', [1, 7], 'TrendLineBrush::tk', [i2.Brush.$, null], 'TrendLineZIndex:ta:tq', [1, 1001], 'TrendLineDashArray:ts:tl', [i2.DoubleCollection.$], 'TrendLineDashCap:tt:tm', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)]]);
        return FinancialIndicator;
    }(FinancialSeries));
    /**
     * @hidden
     */
    var FinancialIndicatorBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialIndicatorBucketCalculator, _super);
        function FinancialIndicatorBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.f = null;
            _this.f = a;
            return _this;
        }
        FinancialIndicatorBucketCalculator.prototype.getBucket = function (a) {
            var b = a * this.b;
            var c = Math.min(b + this.b - 1, this.f.b3.indicatorColumn.count - 1);
            var d = NaN;
            var e = NaN;
            for (var f = b; f <= c; ++f) {
                var g = this.f.b3.indicatorColumn._inner[f];
                if (!i2.isNaN_(d)) {
                    if (!i2.isNaN_(g)) {
                        d = Math.min(d, g);
                        e = Math.max(e, g);
                    }
                }
                else {
                    d = g;
                    e = g;
                }
            }
            if (!i2.isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [NaN, NaN, NaN];
        };
        FinancialIndicatorBucketCalculator.$t = i2.markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
        return FinancialIndicatorBucketCalculator;
    }(FinancialBucketCalculator));
    /**
     * @hidden
     */
    var FinancialIndicatorView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialIndicatorView, _super);
        function FinancialIndicatorView(a) {
            var _this = _super.call(this, a) || this;
            _this.b3 = null;
            _this.b6 = null;
            _this.cu = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.cq = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.cv = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.cr = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.cw = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.cs = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.ct = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                return $ret;
            })());
            _this.cp = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                return $ret;
            })());
            _this.b4 = null;
            _this.cm = new i2.Path();
            _this.co = new i2.Path();
            _this.cn = new i2.Path();
            _this.cl = new i2.Path();
            _this.ci = new i2.Path();
            _this.ck = new i2.Path();
            _this.cj = new i2.Path();
            _this.ch = new i2.Path();
            _this.b3 = a;
            _this.b6 = ((function () {
                var $ret = new i2.Pool$1(i2.LineGeometry.$);
                $ret.create = i2.runOn(_this, _this.cg);
                $ret.destroy = i2.runOn(_this, _this.b9);
                return $ret;
            })());
            return _this;
        }
        FinancialIndicatorView.prototype.by = function () {
            return new FinancialIndicatorBucketCalculator(this);
        };
        FinancialIndicatorView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b3.sw = Defaults.ah;
                this.b3.s3 = this.b3.s2;
            }
        };
        FinancialIndicatorView.prototype.cg = function () {
            return new i2.LineGeometry();
        };
        FinancialIndicatorView.prototype.b9 = function (a) {
        };
        Object.defineProperty(FinancialIndicatorView.prototype, "b5", {
            get: function () {
                if (this.b4 == null) {
                    this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
                }
                return this.b4;
            },
            set: function (a) {
                this.b4 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialIndicatorView.prototype, "b7", {
            get: function () {
                return this.b4 != null;
            },
            enumerable: false,
            configurable: true
        });
        FinancialIndicatorView.prototype.b8 = function (a) {
            i2.Extensions.e(this.cu.ak);
            i2.Extensions.e(this.cv.ak);
            i2.Extensions.e(this.cw.ak);
            i2.Extensions.e(this.cq.ak);
            i2.Extensions.e(this.cr.ak);
            i2.Extensions.e(this.cs.ak);
            i2.Extensions.d(this.ct.ak);
            i2.Extensions.d(this.cp.ak);
            if (a) {
                this.b6.count = 0;
            }
            this.aq();
        };
        FinancialIndicatorView.prototype.ce = function () {
        };
        FinancialIndicatorView.prototype.cc = function (a, b, c, d, e) {
            IndicatorRenderer.g(a, b, c, d, this.bv, this.bu, this.cu, this.cq, this.bx.b, this.e.gh, e);
            this.aq();
        };
        FinancialIndicatorView.prototype.ca = function (a, b, c, d, e, f) {
            IndicatorRenderer.e(a, b, c, d, this.bv, this.bu, this.cu, this.cv, this.cq, this.cr, e, this.bx.b, this.e.gh, f);
            this.aq();
        };
        FinancialIndicatorView.prototype.cb = function (a, b, c, d, e) {
            IndicatorRenderer.f(a, b, c, d, this.bu, e, this.b6, this.ct, this.cp);
            this.aq();
        };
        FinancialIndicatorView.prototype.cf = function () {
            this.b3.tr = null;
            if (this.b3.trendLineBrush != null) {
                this.b3.tr = this.b3.trendLineBrush;
            }
            else {
                this.b3.tr = this.b3.of;
            }
        };
        FinancialIndicatorView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.cm.ak = this.cu.ak;
            this.co.ak = this.cw.ak;
            this.cn.ak = this.cv.ak;
            this.cl.ak = this.ct.ak;
            this.ci.ak = this.cq.ak;
            this.ck.ak = this.cs.ak;
            this.cj.ak = this.cr.ak;
            this.ch.ak = this.cp.ak;
            this.cm._stroke = a;
            this.co._stroke = a;
            this.cm.ac = this.e.fl + 3;
            this.co.ac = this.e.fl + 3;
            this.cn._fill = a;
            this.cn._opacity = 1;
            this.cl._stroke = a;
            this.cl.ac = this.e.fl + 3;
            this.ci._stroke = a;
            this.ck._stroke = a;
            this.ci.ac = this.e.fl + 3;
            this.ck.ac = this.e.fl + 3;
            this.cj._fill = a;
            this.cj._opacity = 1;
            this.ch._stroke = a;
            this.ch.ac = this.e.fl + 3;
        };
        FinancialIndicatorView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    if (this.b3.s3 == 2) {
                        a.s(this.cl);
                        a.s(this.ch);
                    }
                    else {
                        a.s(this.cn);
                        a.s(this.cm);
                        a.s(this.co);
                        a.s(this.cj);
                        a.s(this.ci);
                        a.s(this.ck);
                    }
                }
                else {
                    if (this.b3.s3 == 2) {
                        a.s(this.ct);
                        a.s(this.cp);
                    }
                    else {
                        a.s(this.cv);
                        a.s(this.cu);
                        a.s(this.cw);
                        a.s(this.cr);
                        a.s(this.cq);
                        a.s(this.cs);
                    }
                }
            }
        };
        FinancialIndicatorView.prototype.a5 = function (a, b) {
            if (a.d) {
                if (this.b3.trendLineType != 0 && !b) {
                    var c = this.b5.g$j;
                    c.ac = this.b3.trendLineThickness;
                    c._stroke = this.b3.tr;
                    c.ad = this.b3.tt;
                    c.ai = this.b3.ts;
                    a.u(c);
                }
            }
            _super.prototype.a5.call(this, a, b);
        };
        FinancialIndicatorView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.ct, "positiveColumnsShape", ["Positive", "Main"]);
            this.e.a6.exportPathData(a, this.cp, "negativeColumnsShape", ["Negative"]);
            this.e.a6.exportPathData(a, this.cu, "positive0", ["Positive", "Main"]);
            this.e.a6.exportPathData(a, this.cw, "positive1", ["Positive"]);
            this.e.a6.exportPathData(a, this.cv, "positive01", ["PositiveFill"]);
            this.e.a6.exportPathData(a, this.cq, "negative0", ["Negative", "Main"]);
            this.e.a6.exportPathData(a, this.cs, "negative1", ["Negative"]);
            this.e.a6.exportPathData(a, this.cr, "negative01", ["NegativeFill"]);
        };
        FinancialIndicatorView.prototype.cd = function () {
            if (this.b7) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
            }
        };
        FinancialIndicatorView.$t = i2.markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
        return FinancialIndicatorView;
    }(FinancialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StrategyBasedIndicator, _super);
        function StrategyBasedIndicator() {
            var _this = _super.call(this) || this;
            _this.t9();
            return _this;
        }
        StrategyBasedIndicator.prototype.t9 = function () {
            this.tu = this.tv;
            this.ab = this.t8;
        };
        StrategyBasedIndicator.prototype.t1 = function () {
            return -2147483648;
        };
        StrategyBasedIndicator.prototype.ua = function (a) {
        };
        StrategyBasedIndicator.prototype.t3 = function () {
            return -2147483648;
        };
        StrategyBasedIndicator.prototype.t0 = function () {
            return -2147483648;
        };
        StrategyBasedIndicator.ue = function (a, b, c) {
            var d = i2.DependencyProperty.i(c, i2.Number_$type, b, new i2.PropertyMetadata(2, a, function (e, f) { return (i2.typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
            StrategyBasedIndicator.ty.add(c);
            return d;
        };
        StrategyBasedIndicator.ud = function (a, b) {
            return StrategyBasedIndicator.ue(a, b, "Period");
        };
        StrategyBasedIndicator.ub = function (a, b) {
            return StrategyBasedIndicator.ue(a, b, "LongPeriod");
        };
        StrategyBasedIndicator.uf = function (a, b) {
            return StrategyBasedIndicator.ue(a, b, "ShortPeriod");
        };
        StrategyBasedIndicator.prototype.s7 = function (a, b) {
            var c = this.p3(a, b);
            var d = this.p4(c);
            return this.tu.b(c, d);
        };
        StrategyBasedIndicator.prototype.s4 = function (a, b) {
            var c = this.p3(a, b);
            if (b == 0) {
                return false;
            }
            if (!this.qz(this.s7(a, b))) {
                return false;
            }
            var d = this.p4(c);
            if (this.s0 != null) {
                c.minimumValue = this.s0.c;
                c.maximumValue = this.s0.b;
            }
            var e = this.tu.a(c, d);
            for (var f = 0; f < this.s9 && f < c.indicatorColumn.count; f++) {
                c.indicatorColumn.item(f, NaN);
            }
            if (this.qc != null && this.tx(c)) {
                this.qc.cv();
            }
            return e;
        };
        StrategyBasedIndicator.prototype.tx = function (a) {
            var e_1, _a;
            if (!i2.isNaN_(a.minimumValue) && !i2.isNaN_(a.maximumValue) && a.specifiesRange) {
                var b = this.s0;
                this.s0 = new AxisRange(a.minimumValue, a.maximumValue);
                return this.tw(b, this.s0);
            }
            var c = 1.7976931348623157E+308;
            var d = -1.7976931348623157E+308;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (!i2.isNaN_(e)) {
                        c = Math.min(c, e);
                        d = Math.max(d, e);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var f = this.s0;
            this.s0 = new AxisRange(c, d);
            return this.tw(f, this.s0);
        };
        StrategyBasedIndicator.prototype.tw = function (a, b) {
            if (a == null || b == null) {
                return true;
            }
            if (a.c != b.c) {
                return true;
            }
            if (a.b != b.b) {
                return true;
            }
            return false;
        };
        StrategyBasedIndicator.prototype.t2 = function (a) {
            if (a == -2147483648) {
                return 0;
            }
            if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
                a = this.indicatorColumn.count - 1;
            }
            if (a < 1) {
                return 1;
            }
            return a;
        };
        StrategyBasedIndicator.prototype.p3 = function (a, b) {
            var c = _super.prototype.p3.call(this, a, b);
            c.indicatorColumn = this.indicatorColumn;
            c.period = this.t2(this.t1());
            c.shortPeriod = this.t2(this.t3());
            c.longPeriod = this.t2(this.t0());
            c.multiplier = this.tz();
            return c;
        };
        StrategyBasedIndicator.prototype.tz = function () {
            return 1;
        };
        StrategyBasedIndicator.uc = function (a, b) {
            var c = i2.DependencyProperty.i("Multiplier", i2.Number_$type, b, new i2.PropertyMetadata(2, a, function (d, e) { return (i2.typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
            StrategyBasedIndicator.ty.add("Multiplier");
            return c;
        };
        StrategyBasedIndicator.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (StrategyBasedIndicator.ty.contains(b)) {
                if (this.qc != null && !this.qc.cv()) {
                    this.p7.bx.e(this.gh);
                    this.s4(0, this.indicatorColumn.count);
                    if (this.s1.b7) {
                        this.s1.b5.g$i();
                    }
                    this.l0(false);
                }
            }
        };
        StrategyBasedIndicator.$t = i2.markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
        StrategyBasedIndicator.ty = new i2.List$1(i2.String_$type, 0);
        return StrategyBasedIndicator;
    }(FinancialIndicator));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IndicatorProxy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IndicatorProxy, _super);
        function IndicatorProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IndicatorProxy.prototype.matchesType = function (a) {
            if (a.dj) {
                return true;
            }
            return false;
        };
        IndicatorProxy.prototype.setCloseMemberPath = function (a, b) {
            a.ru = b;
        };
        IndicatorProxy.prototype.setDisplayType = function (a, b) {
            a.s3 = b;
        };
        IndicatorProxy.prototype.setHighMemberPath = function (a, b) {
            a.rx = b;
        };
        IndicatorProxy.prototype.setLongPeriod = function (a, b) {
            if (i2.typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
                a.longPeriod = b;
            }
        };
        IndicatorProxy.prototype.setLowMemberPath = function (a, b) {
            a.r2 = b;
        };
        IndicatorProxy.prototype.setNegativeBrush = function (a, b) {
            a.sw = b;
        };
        IndicatorProxy.prototype.setOpenMemberPath = function (a, b) {
            a.r6 = b;
        };
        IndicatorProxy.prototype.setPeriodOverride = function (a, b) {
            if (i2.typeCast(StrategyBasedIndicator.$, a) !== null) {
                a.ua(b);
            }
        };
        IndicatorProxy.prototype.setShortPeriod = function (a, b) {
            if (i2.typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
                a.shortPeriod = b;
            }
        };
        IndicatorProxy.prototype.setSignalPeriod = function (a, b) {
            if (i2.getInstanceType(a).typeName == "MovingAverageConvergenceDivergenceIndicator") {
                var s_ = a;
                var p_ = b;
                s_['signalPeriod'] = p_;
            }
        };
        IndicatorProxy.prototype.setSmoothingPeriod = function (a, b) {
            if (i2.getInstanceType(a).typeName == "FullStochasticOscillatorIndicator") {
                var s_ = a;
                var p_ = b;
                s_['smoothingPeriod'] = p_;
            }
        };
        IndicatorProxy.prototype.setVolumeMemberPath = function (a, b) {
            a.sa = b;
        };
        IndicatorProxy.prototype.setXAxis = function (a, b) {
            a.pq = b;
        };
        IndicatorProxy.prototype.setYAxis = function (a, b) {
            a.qc = b;
        };
        IndicatorProxy.prototype.handleCustomIndicatorEvent = function (a, b) {
            if (i2.getInstanceType(a).typeName == "CustomIndicator") {
                var s_ = a;
                var p_ = b;
                s_['indicator'] = p_;
            }
        };
        IndicatorProxy.prototype.setMultiplier = function (a, b) {
            if (i2.getInstanceType(a).typeName == "BollingerBandWidthIndicator") {
                var s_ = a;
                var p_ = b;
                s_['multiplier'] = p_;
            }
        };
        IndicatorProxy.$t = i2.markType(IndicatorProxy, 'IndicatorProxy', i2.Base.$, [IIndicatorProxy_$type]);
        return IndicatorProxy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxIndicatorProxyModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxIndicatorProxyModule() {
            i2.TypeRegistrar.register('IndicatorProxy', IndicatorProxy.$type);
        }
        IgxIndicatorProxyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxIndicatorProxyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyModule, imports: [i1.CommonModule] });
        IgxIndicatorProxyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyModule, imports: [[i1.CommonModule,
                ]] });
        return IgxIndicatorProxyModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxIndicatorProxyDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxIndicatorProxyDynamicModule() {
            i2.TypeRegistrar.registerCons('IndicatorProxy', IndicatorProxy);
            i2.TypeRegistrar.register('IndicatorProxy', IndicatorProxy.$type);
        }
        IgxIndicatorProxyDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxIndicatorProxyDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyDynamicModule, imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxIndicatorProxyModule] });
        IgxIndicatorProxyDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyDynamicModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule
                ], IgxIndicatorProxyModule] });
        return IgxIndicatorProxyDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorProxyDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxIndicatorProxyModule
                        ],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents the data contract between a financial series and the
     * decoupled calculation responsibilities which implement its mathmatical logic.
     * The FinancialCalculationDataSource contract represents the subset
     * of data which needs to be provided in order to test or run a calculation,
     * and its intentionally a subset of the information available to the series,
     * in order to make calculation strategies more easily testable and usable in isolation to
     * the financial series container.
    */
    var IgxFinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialCalculationDataSource() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxFinancialCalculationDataSource.prototype.createImplementation = function () {
            return new FinancialCalculationDataSource();
        };
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialCalculationDataSource.prototype.onImplementationCreated = function () {
        };
        IgxFinancialCalculationDataSource.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "openColumn", {
            get: function () {
                return this.i.series.getOpenColumnAsArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "highColumn", {
            get: function () {
                return this.i.series.getHighColumnAsArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "lowColumn", {
            get: function () {
                return this.i.series.getLowColumnAsArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "closeColumn", {
            get: function () {
                return this.i.series.getCloseColumnAsArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "volumeColumn", {
            get: function () {
                return this.i.series.getVolumeColumnAsArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "indicatorColumn", {
            get: function () {
                return this.i.series.indicatorColumn.asArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "typicalColumn", {
            /**
         * An enumerable list of typical prices provided by the series to use
         * in calculations.
        */
            get: function () {
                if (this.i.typicalColumn == null) {
                    return null;
                }
                return this.i.typicalColumn.externalObject;
            },
            set: function (v) {
                v == null ? this.i.typicalColumn = null : this.i.typicalColumn = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "trueRange", {
            /**
             * And enumerable list of true range values provided by the series to use
             * in calculations.
            */
            get: function () {
                if (this.i.trueRange == null) {
                    return null;
                }
                return this.i.trueRange.externalObject;
            },
            set: function (v) {
                v == null ? this.i.trueRange = null : this.i.trueRange = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "trueLow", {
            /**
             * An enumerable list of true low values provided by the series to use
             * in calculations.
            */
            get: function () {
                if (this.i.trueLow == null) {
                    return null;
                }
                return this.i.trueLow.externalObject;
            },
            set: function (v) {
                v == null ? this.i.trueLow = null : this.i.trueLow = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "period", {
            /**
             * The period to use when calculating, if applicable.
            */
            get: function () {
                return this.i.period;
            },
            set: function (v) {
                this.i.period = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "shortPeriod", {
            /**
             * The short period to use when calculating, if applicable.
            */
            get: function () {
                return this.i.shortPeriod;
            },
            set: function (v) {
                this.i.shortPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "longPeriod", {
            /**
             * The long period to use when calculating, if applicable.
            */
            get: function () {
                return this.i.longPeriod;
            },
            set: function (v) {
                this.i.longPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "count", {
            /**
             * The count of the values in the series.
            */
            get: function () {
                return this.i.count;
            },
            set: function (v) {
                this.i.count = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "calculateFrom", {
            /**
             * The starting index from which to calculate
            */
            get: function () {
                return this.i.calculateFrom;
            },
            set: function (v) {
                this.i.calculateFrom = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "calculateCount", {
            /**
             * The number of items from the starting index from which to calculate
            */
            get: function () {
                return this.i.calculateCount;
            },
            set: function (v) {
                this.i.calculateCount = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "multiplier", {
            /**
             * If the calculation supports some sort of scaling factor,
             * this value will be used.
            */
            get: function () {
                return this.i.multiplier;
            },
            set: function (v) {
                this.i.multiplier = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "minimumValue", {
            /**
             * If the calculation determines the range of indicator values,
             * it will set the minimum and maximux properties.
             * This will contain the previous minimum value when the indicator
             * calculation is called again, in case this makes the update of the
             * value speedier.
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "maximumValue", {
            /**
             * If the calculation determines the range of indicator values,
             * it will set the minimum and maximux properties.
             * This will contain the previous minimum value when the indicator
             * calculation is called again, in case this makes the update of the
             * value speedier.
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationDataSource.prototype, "specifiesRange", {
            /**
             * The calculation strategy should set this to true if it
             * specifes the minimum and maximum value properties.
            */
            get: function () {
                return this.i.specifiesRange;
            },
            set: function (v) {
                this.i.specifiesRange = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialCalculationDataSource.prototype.findByName = function (name) {
            if (this.typicalColumn && this.typicalColumn.name && this.typicalColumn.name == name) {
                return this.typicalColumn;
            }
            if (this.trueRange && this.trueRange.name && this.trueRange.name == name) {
                return this.trueRange;
            }
            if (this.trueLow && this.trueLow.name && this.trueLow.name == name) {
                return this.trueLow;
            }
            return null;
        };
        return IgxFinancialCalculationDataSource;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a contract between the financial series and the calculation strategies
     * detailing the supporting calculation strategies that the financial series will
     * provide in order for the indicator calculations to be performed.
    */
    var IgxFinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialCalculationSupportingCalculations() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxFinancialCalculationSupportingCalculations.prototype.createImplementation = function () {
            return new FinancialCalculationSupportingCalculations();
        };
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialCalculationSupportingCalculations.prototype.onImplementationCreated = function () {
        };
        IgxFinancialCalculationSupportingCalculations.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "eMA", {
            /**
             * The strategy provided to calculate an exponential moving average for a collection.
            */
            get: function () {
                if (this.i.a == null) {
                    return null;
                }
                return this.i.a.externalObject;
            },
            set: function (v) {
                v == null ? this.i.a = null : this.i.a = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "sMA", {
            /**
             * The strategy provided to calculate a simple moving average for a collection.
            */
            get: function () {
                if (this.i.c == null) {
                    return null;
                }
                return this.i.c.externalObject;
            },
            set: function (v) {
                v == null ? this.i.c = null : this.i.c = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "sTDEV", {
            /**
             * The strategy provided to calculate a standard deviation for a collection.
            */
            get: function () {
                if (this.i.d == null) {
                    return null;
                }
                return this.i.d.externalObject;
            },
            set: function (v) {
                v == null ? this.i.d = null : this.i.d = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "movingSum", {
            /**
             * The strategy provided to calculate a moving sum for a collection.
            */
            get: function () {
                if (this.i.b == null) {
                    return null;
                }
                return this.i.b.externalObject;
            },
            set: function (v) {
                v == null ? this.i.b = null : this.i.b = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "shortVolumeOscillatorAverage", {
            /**
             * The strategy provided to calculate the short period moving average for volume oscillator indicators.
            */
            get: function () {
                if (this.i.h == null) {
                    return null;
                }
                return this.i.h.externalObject;
            },
            set: function (v) {
                v == null ? this.i.h = null : this.i.h = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "longVolumeOscillatorAverage", {
            /**
             * The strategy provided to calculate the long period moving average for volume oscillator indicators.
            */
            get: function () {
                if (this.i.f == null) {
                    return null;
                }
                return this.i.f.externalObject;
            },
            set: function (v) {
                v == null ? this.i.f = null : this.i.f = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "shortPriceOscillatorAverage", {
            /**
             * The strategy provided to calculate the short period moving average for price oscillator indicators.
            */
            get: function () {
                if (this.i.g == null) {
                    return null;
                }
                return this.i.g.externalObject;
            },
            set: function (v) {
                v == null ? this.i.g = null : this.i.g = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "longPriceOscillatorAverage", {
            /**
             * The strategy provided to calculate the long period moving average for price oscillator indicators.
            */
            get: function () {
                if (this.i.e == null) {
                    return null;
                }
                return this.i.e.externalObject;
            },
            set: function (v) {
                v == null ? this.i.e = null : this.i.e = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialCalculationSupportingCalculations.prototype, "makeSafe", {
            /**
             * The strategy provided to make doubles safe for plotting, by default will just make zero if the value
             * is invalid.
            */
            get: function () {
                return this.i.i;
            },
            set: function (v) {
                this.i.i = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialCalculationSupportingCalculations.prototype.findByName = function (name) {
            if (this.eMA && this.eMA.name && this.eMA.name == name) {
                return this.eMA;
            }
            if (this.sMA && this.sMA.name && this.sMA.name == name) {
                return this.sMA;
            }
            if (this.sTDEV && this.sTDEV.name && this.sTDEV.name == name) {
                return this.sTDEV;
            }
            if (this.movingSum && this.movingSum.name && this.movingSum.name == name) {
                return this.movingSum;
            }
            if (this.shortVolumeOscillatorAverage && this.shortVolumeOscillatorAverage.name && this.shortVolumeOscillatorAverage.name == name) {
                return this.shortVolumeOscillatorAverage;
            }
            if (this.longVolumeOscillatorAverage && this.longVolumeOscillatorAverage.name && this.longVolumeOscillatorAverage.name == name) {
                return this.longVolumeOscillatorAverage;
            }
            if (this.shortPriceOscillatorAverage && this.shortPriceOscillatorAverage.name && this.shortPriceOscillatorAverage.name == name) {
                return this.shortPriceOscillatorAverage;
            }
            if (this.longPriceOscillatorAverage && this.longPriceOscillatorAverage.name && this.longPriceOscillatorAverage.name == name) {
                return this.longPriceOscillatorAverage;
            }
            return null;
        };
        return IgxFinancialCalculationSupportingCalculations;
    }());

    /**
     * Parameterizes a financial calculation event.
    */
    var IgxFinancialEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialEventArgs() {
        }
        Object.defineProperty(IgxFinancialEventArgs.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxFinancialEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFinancialEventArgs.prototype, "basedOn", {
            get: function () {
                var ret = null;
                if (this.i.basedOn) {
                    ret = [];
                    for (var i = 0; i < this.i.basedOn.count; i++) {
                        ret.push(this.i.basedOn[i]);
                    }
                }
                return ret;
            },
            set: function (v) {
                if (!v) {
                    this.i.basedOn = null;
                    return;
                }
                var list = new i2.List$1(i2.String_$type, 0);
                for (var i = 0; i < v.length; i++) {
                    list.add(v[i]);
                }
                this.i.basedOn = list;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialEventArgs.prototype, "position", {
            /**
         * The beginning position that should be calculated from.
        */
            get: function () {
                return this.i.position;
            },
            set: function (v) {
                this.i.position = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialEventArgs.prototype, "count", {
            /**
             * The number of positions that should be calculated from the start.
            */
            get: function () {
                return this.i.count;
            },
            set: function (v) {
                this.i.count = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialEventArgs.prototype, "dataSource", {
            /**
             * The data to use for the calculation.
            */
            get: function () {
                if (this.i.dataSource == null) {
                    return null;
                }
                if (!this.i.dataSource.externalObject) {
                    var e = new IgxFinancialCalculationDataSource();
                    e._implementation = this.i.dataSource;
                    this.i.dataSource.externalObject = e;
                }
                return this.i.dataSource.externalObject;
            },
            set: function (v) {
                v == null ? this.i.dataSource = null : this.i.dataSource = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialEventArgs.prototype, "supportingCalculations", {
            /**
             * The supporting calculations to use in the calculation.
            */
            get: function () {
                if (this.i.supportingCalculations == null) {
                    return null;
                }
                if (!this.i.supportingCalculations.externalObject) {
                    var e = new IgxFinancialCalculationSupportingCalculations();
                    e._implementation = this.i.supportingCalculations;
                    this.i.supportingCalculations.externalObject = e;
                }
                return this.i.supportingCalculations.externalObject;
            },
            set: function (v) {
                v == null ? this.i.supportingCalculations = null : this.i.supportingCalculations = v.i;
            },
            enumerable: false,
            configurable: true
        });
        return IgxFinancialEventArgs;
    }());

    /**
     * Represents the base class for all financial indicator and overlay series.
    *
    * The `IgxFinancialSeriesComponent` represents the base class for all financial indicator and overlay series.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    var IgxFinancialSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialSeriesComponent, _super);
        function IgxFinancialSeriesComponent() {
            var _this = _super.call(this) || this;
            _this._assigningCategoryStyle = null;
            _this._typical = null;
            _this._typicalBasedOn = null;
            return _this;
        }
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "isFinancial", {
            /**
             * Gets whether the current series is a financial type series.
            */
            get: function () {
                return this.i.di;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "negativeBrush", {
            /**
             * Gets or sets the brush to use for negative portions of the series.
            *
            * The `negativeBrush` property is used to brush the negative portions of the series.
            *
            * ```ts
            * series.negativeBrush="red";
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            * 	  negativeBrush="red">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.sw);
            },
            set: function (v) {
                this.i.sw = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current FinancialSeries object.
            *
            * Use `xAxis` property to set effective x-axis for the current FinancialSeries object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                if (this.i.pq == null) {
                    return null;
                }
                if (!this.i.pq.externalObject) {
                    var e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.pq);
                    if (e) {
                        e._implementation = this.i.pq;
                    }
                    this.i.pq.externalObject = e;
                }
                return this.i.pq.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pq = null : this.i.pq = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current FinancialSeries object.
            *
            * Use `yAxis` property to set the effective y-axis for the current FinancialSeries object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                if (this.i.qc == null) {
                    return null;
                }
                if (!this.i.qc.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.qc);
                    if (e) {
                        e._implementation = this.i.qc;
                    }
                    this.i.qc.externalObject = e;
                }
                return this.i.qc.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qc = null : this.i.qc = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "openMemberPath", {
            /**
             * Gets or sets the open mapping property for the current series object.
            *
            * The `openMemberPath` property is used for open mapping of the current series object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.r6;
            },
            set: function (v) {
                this.i.r6 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "highMemberPath", {
            /**
             * Gets or sets the high mapping property for the current series object.
            *
            * Use `highMemberPath` propert for high mapping of the current series object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.rx;
            },
            set: function (v) {
                this.i.rx = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "lowMemberPath", {
            /**
             * Gets or sets the low mapping property for the current series object.
            *
            * The `lowMemberPath` is used for low mapping property of the current series object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.r2;
            },
            set: function (v) {
                this.i.r2 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "closeMemberPath", {
            /**
             * Gets or sets the close mapping property for the current series object.
            *
            * Use `closeMemberPath` property for the close mapping of the current series object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.ru;
            },
            set: function (v) {
                this.i.ru = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "volumeMemberPath", {
            /**
             * Gets or sets the volume mapping property for the current series object.
            *
            * The `volumeMemberPath` property is used for the volume mapping property of the current series object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxFinancialPriceSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.openMemberPath = "open";
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * series.closeMemberPath = "close";
            * series.volumeMemberPath="volume";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.sa;
            },
            set: function (v) {
                this.i.sa = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "isCustomCategoryStyleAllowed", {
            /**
             * Gets or sets whether this category series should allow custom style overrides of its individual visuals.
            *
            * The `isCustomCategoryStyleAllowed` property is used to check if the category series should allow custom style.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            * 	  isCustomCategoryStyleAllowed="True" />
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.isCustomCategoryStyleAllowed= true;
            * ```
            */
            get: function () {
                return this.i.qw;
            },
            set: function (v) {
                this.i.qw = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "transitionInMode", {
            /**
             * Gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
             * Note: Transitions are not currently supported for stacked series.
            *
            * The `transitionInMode` property is used to gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
            *
            * ```ts
            * series.transitionInMode =CategoryTransitionInMode.Auto;
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            * 	  transitionInMode= "Auto">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.p1;
            },
            set: function (v) {
                this.i.p1 = i2.ensureEnum(CategoryTransitionInMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "isTransitionInEnabled", {
            /**
             * Gets or sets whether the series should transition into the plot area when a new data source is assigned.
             * Note: Transitions are not currently supported for stacked series.
            *
            * The `isTransitionInEnabled` property is used to check if the series should transition into the plot area when a new data source is assigned.
            *
            * ```ts
            * series.isTransitionInEnabled= true;
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *   <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *         </igx-category-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            * 	  isTransitionInEnabled= "true">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.qx;
            },
            set: function (v) {
                this.i.qx = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "isNegativeColorSupported", {
            /**
             * Overridden by derived series classes to indicate when negative colors are supported or not.
            */
            get: function () {
                return this.i.dx;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxFinancialSeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxFinancialSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        *
        * The `getOffsetValue` method returns the offset value for this series if grouped on a category axis.
        *
        * ```ts
        * number offset= series.getOffsetValue();
        * ```
        */
        IgxFinancialSeriesComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        *
        * The `getCategoryWidth` method returns the width of the category grouping this series is in.
        *
        * ```ts
        * number width = series.getCategoryWidth();
        * ```
        */
        IgxFinancialSeriesComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f4(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f6(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesCloseValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.ri(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesOpenValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.rj(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesVolumeValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.rk(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.oy(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o0(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesOpenValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.sy(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesCloseValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.sx(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxFinancialSeriesComponent.prototype.getSeriesVolumeValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.sz(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        *
        * Use `canUseAsYAxis` method to determine if the object can be used as YAxis.
        *
        * ```ts
        *   boolean canY =series.canUseAsYAxis(yAxis);
        * ```
        */
        IgxFinancialSeriesComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.qt(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        *
        * Use `canUseAsXAxis` method to determine if the object can be used as XAxis.
        *
        * ```ts
        *   boolean canX =series.canUseAsXAxis(xAxis);
        * ```
        */
        IgxFinancialSeriesComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.qs(axis);
            return (iv);
        };
        /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        *
        * The `getExactItemIndex` method gets the precise item index, if possible, based on the closeness to the previous or next whole integer.
        *
        * If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        *
        * ```ts
        * number index = series.getExactItemIndex(world);
        * ```
        */
        IgxFinancialSeriesComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the index of the item that resides at the provided world coordinates.
        
        * @param world  * The world coordinates of the requested item.
        *
        * The `getItemIndex` method gets the index of the item that resides at the provided world coordinates.
        *
        * ```ts
        * number itemindex= series.getItemIndex(world);
        * ```
        */
        IgxFinancialSeriesComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        *
        * The `getItem` method gets the item that is the best match for the specified world coordinates.
        */
        IgxFinancialSeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        IgxFinancialSeriesComponent.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
            this.i.l5(i2.stringToBrush(negativeBrush), i2.stringToBrush(negativeOutline));
        };
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "assigningCategoryStyle", {
            /**
             * Event raised when Assigning Category Style
            *
            * The `AssigningCategoryStyle` event raised when assigning Category Style.
            *
            * ```ts
            * series.assigningCategoryStyle= this.chart_AssigningCategoryStyle;
            * chart_AssigningCategoryStyle(sender :any,args: AssigningCategoryStyleEventArgs )
            *   {
            *
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._assigningCategoryStyle == null) {
                    this._assigningCategoryStyle = new i0.EventEmitter();
                    this.i.assigningCategoryStyle = i2.delegateCombine(this.i.assigningCategoryStyle, function (o, e) {
                        var outerArgs = new IgxAssigningCategoryStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningCategoryStyle) {
                            _this.beforeAssigningCategoryStyle(_this, outerArgs);
                        }
                        _this._assigningCategoryStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningCategoryStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "typical", {
            /**
             * Handle this event in order to perform a custom typical price calculation.
            *
            * Use `Typical` event to perform a custom typical price calculation.
            *
            * ```ts
            * series.typical= this.chart_typical;
            *
            *   chart_typical(sender :any,args: FinancialEventArgs )
            *   {
            *
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._typical == null) {
                    this._typical = new i0.EventEmitter();
                    this.i.typical = i2.delegateCombine(this.i.typical, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFinancialEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeTypical) {
                                _this.beforeTypical(_this, outerArgs);
                            }
                            _this._typical.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._typical;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialSeriesComponent.prototype, "typicalBasedOn", {
            /**
             * Handle this event in order to specify which columns the Typical price calculation is based on.
            *
            * Use `TypicalBasedOn` event to specify which columns the Typical price calculation is based on.
            *
            * ```ts
            *    series.typicalBasedOn= this.chart_typicalBasedOn;
            *     chart_typicalBasedOn(sender :any,args: FinancialEventArgs )
            *   {
            *
            *   }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._typicalBasedOn == null) {
                    this._typicalBasedOn = new i0.EventEmitter();
                    this.i.typicalBasedOn = i2.delegateCombine(this.i.typicalBasedOn, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFinancialEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeTypicalBasedOn) {
                                _this.beforeTypicalBasedOn(_this, outerArgs);
                            }
                            _this._typicalBasedOn.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._typicalBasedOn;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialSeriesComponent, selector: "ng-component", inputs: { negativeBrush: "negativeBrush", xAxis: "xAxis", yAxis: "yAxis", openMemberPath: "openMemberPath", highMemberPath: "highMemberPath", lowMemberPath: "lowMemberPath", closeMemberPath: "closeMemberPath", volumeMemberPath: "volumeMemberPath", isCustomCategoryStyleAllowed: "isCustomCategoryStyleAllowed", transitionInMode: "transitionInMode", isTransitionInEnabled: "isTransitionInEnabled" }, outputs: { assigningCategoryStyle: "assigningCategoryStyle", typical: "typical", typicalBasedOn: "typicalBasedOn" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxFinancialSeriesComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { negativeBrush: [{
                    type: i0.Input
                }], xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }], openMemberPath: [{
                    type: i0.Input
                }], highMemberPath: [{
                    type: i0.Input
                }], lowMemberPath: [{
                    type: i0.Input
                }], closeMemberPath: [{
                    type: i0.Input
                }], volumeMemberPath: [{
                    type: i0.Input
                }], isCustomCategoryStyleAllowed: [{
                    type: i0.Input
                }], transitionInMode: [{
                    type: i0.Input
                }], isTransitionInEnabled: [{
                    type: i0.Input
                }], assigningCategoryStyle: [{
                    type: i0.Output
                }], typical: [{
                    type: i0.Output
                }], typicalBasedOn: [{
                    type: i0.Output
                }] } });

    /**
     * Represents the base functionality for a IgxDataChartComponent financial indicator series.
    *
    * The `IgxFinancialIndicatorComponent` class represents the base functionality for a IgxDataChartComponent financial indicator series.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    * <igx-mass-index-indicator
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"   >
    *     </igx-mass-index-indicator >
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxMassIndexIndicatorComponent();
    *    series.xAxis = this.xAxis;
    *    series.yAxis = this.yAxis;
    *    series.openMemberPath = "open";
    *    series.highMemberPath = "high";
    *    series.lowMemberPath = "low";
    *    series.closeMemberPath = "close";
    *    this.chart.series.add(series);
    *
    * ```
    */
    var IgxFinancialIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialIndicatorComponent, _super);
        function IgxFinancialIndicatorComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "isFinancialIndicator", {
            /**
             * Gets whether the series is financial indicator
            */
            get: function () {
                return this.i.dj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "displayType", {
            /**
             * Gets or sets the display for the current FinancialIndicator object.
            *
            * The `displayType` property is used to display the current FinancialIndicator object.
            *
            * ```ts
            * series.displayType= IndicatorDisplayType.Column;
            * ```
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data" >
            * <igx-ordinal-time-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            * <igx-mass-index-indicator
            * [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            * 	displayType="Column"   >
            *     </igx-mass-index-indicator >
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.s3;
            },
            set: function (v) {
                this.i.s3 = i2.ensureEnum(IndicatorDisplayType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "defaultDisplayType", {
            /**
             * Gets default display type for the current Financial Indicator
            */
            get: function () {
                return this.i.s2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "ignoreFirst", {
            /**
             * Gets or sets the number of values to hide at the beginning of the indicator.
            *
            * Use the `ignoreFirst` propert to hide the number of values at the beginning of the indicator.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data" >
            * <igx-ordinal-time-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            * <igx-mass-index-indicator
            * [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            * 	ignoreFirst="2" >
            *     </igx-mass-index-indicator >
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.ignoreFirst  = 2;
            * ```
            */
            get: function () {
                return this.i.s9;
            },
            set: function (v) {
                this.i.s9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the trend type for the current indicator series.
            *
            * Use `trendLineType` property to get the trend type for the current indicator series.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *    <igx-ordinal-time-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-ordinal-time-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-mass-index-indicator
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         openMemberPath="open"
            *         highMemberPath="high"
            *         lowMemberPath="low"
            *         closeMemberPath="close"
            * 		trendLineType="CubicFit">
            *     </igx-mass-index-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.trendLineType= TrendLineType.CubicFit;
            * ```
            */
            get: function () {
                return this.i.trendLineType;
            },
            set: function (v) {
                this.i.trendLineType = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the brush to use to draw the trend line.
            *
            * Use the `trendLineBrush` propert to draw the trend line.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data" >
            * <igx-ordinal-time-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            * <igx-mass-index-indicator
            * [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            * 	trendLineBrush="Red">
            *     </igx-mass-index-indicator >
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.trendLineBrush);
            },
            set: function (v) {
                this.i.trendLineBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "actualTrendLineBrush", {
            /**
             * Gets the effective TrendLineBrush for this indicator.
            *
            * Use the `actualTrendLineBrush` property to Gets the effective TrendLineBrush for the FinancialIndicator.
            */
            get: function () {
                return i2.brushToString(this.i.tr);
            },
            set: function (v) {
                this.i.tr = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the current indicator object's trend line.
            *
            * Use `trendLineThickness` property for the thickness of the current indicator object's trend line.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data" >
            * <igx-ordinal-time-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            * <igx-mass-index-indicator
            * [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            * 	trendLineThickness="2" >
            *     </igx-mass-index-indicator >
            * </igx-data-chart>
            * ```
            *
            * ```ts
            *  series.trendLineThickness=2 ;
            * ```
            */
            get: function () {
                return this.i.trendLineThickness;
            },
            set: function (v) {
                this.i.trendLineThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialIndicatorComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the trend line period for the current series.
             * The typical, and initial, value for trend line period is 7.
            *
            * Use `trendLinePeriod` property for the trend line period of the current series.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data" >
            * <igx-ordinal-time-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            * <igx-mass-index-indicator
            * [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            * 	trendLinePeriod="30" >
            *     </igx-mass-index-indicator >
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.trendLinePeriod  =30;
            * ```
            */
            get: function () {
                return this.i.trendLinePeriod;
            },
            set: function (v) {
                this.i.trendLinePeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        *
        * The `getSeriesValueBoundingBox` method returns the best available value bounding box within the series that has the best value match for the world position provided.
        */
        IgxFinancialIndicatorComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        IgxFinancialIndicatorComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxFinancialIndicatorComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxFinancialIndicatorComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        *
        * The `scrollIntoView` method scrolls the series to display the item for the specified data item.
        */
        IgxFinancialIndicatorComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        IgxFinancialIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialIndicatorComponent, selector: "ng-component", inputs: { displayType: "displayType", ignoreFirst: "ignoreFirst", trendLineType: "trendLineType", trendLineBrush: "trendLineBrush", actualTrendLineBrush: "actualTrendLineBrush", trendLineThickness: "trendLineThickness", trendLinePeriod: "trendLinePeriod" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxFinancialIndicatorComponent;
    }(IgxFinancialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { displayType: [{
                    type: i0.Input
                }], ignoreFirst: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], actualTrendLineBrush: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }] } });

    /**
     * A base class for indicator series with simple calculations that separates the calculation
     * responsibility from the other responsibilities of the financial series, this enables
     * easier unit testing and decoupling of individual calculation strategies.
     * A contract is defined between the financial series and these simple indicator calculations
     * detailing the data which the series agrees to provide the simple indicator calculations,
     * this contract is defined by FinancialCalculationDataSource. If more
     * complex interactions are needed between the indicator calculation and the series, the
     * indicators should instead derive from FinancialIndicator directly, or some
     * derivative other than StrategyBasedIndicator
    */
    var IgxStrategyBasedIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStrategyBasedIndicatorComponent, _super);
        function IgxStrategyBasedIndicatorComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxStrategyBasedIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxStrategyBasedIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStrategyBasedIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStrategyBasedIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStrategyBasedIndicatorComponent, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxStrategyBasedIndicatorComponent;
    }(IgxFinancialIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStrategyBasedIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IndicatorCalculationStrategy, _super);
        function IndicatorCalculationStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IndicatorCalculationStrategy.$t = i2.markType(IndicatorCalculationStrategy, 'IndicatorCalculationStrategy');
        return IndicatorCalculationStrategy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AbsoluteVolumeOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AbsoluteVolumeOscillatorIndicatorStrategy, _super);
        function AbsoluteVolumeOscillatorIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AbsoluteVolumeOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(b.h.c);
            c.o(b.f.c);
            return c;
        };
        AbsoluteVolumeOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var c = i2.getEnumerator(b.h.b(a));
            var d = i2.getEnumerator(b.f.b(a));
            var e = a.indicatorColumn;
            var f = 0;
            while (c.moveNext() && d.moveNext()) {
                var g = c.current - d.current;
                e.item(f, b.i(g));
                ++f;
            }
            return true;
        };
        AbsoluteVolumeOscillatorIndicatorStrategy.$t = i2.markType(AbsoluteVolumeOscillatorIndicatorStrategy, 'AbsoluteVolumeOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return AbsoluteVolumeOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AbsoluteVolumeOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AbsoluteVolumeOscillatorIndicator, _super);
        function AbsoluteVolumeOscillatorIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AbsoluteVolumeOscillatorIndicator.prototype.get_tv = function () {
            return new AbsoluteVolumeOscillatorIndicatorStrategy();
        };
        Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        AbsoluteVolumeOscillatorIndicator.prototype.get_t8 = function () {
            return AbsoluteVolumeOscillatorIndicator.$;
        };
        Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "shortPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(AbsoluteVolumeOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        AbsoluteVolumeOscillatorIndicator.prototype.t3 = function () {
            return this.shortPeriod;
        };
        Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "longPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.ug));
            },
            set: function (a) {
                this.h(AbsoluteVolumeOscillatorIndicator.ug, a);
            },
            enumerable: false,
            configurable: true
        });
        AbsoluteVolumeOscillatorIndicator.prototype.t0 = function () {
            return this.longPeriod;
        };
        AbsoluteVolumeOscillatorIndicator.$t = i2.markType(AbsoluteVolumeOscillatorIndicator, 'AbsoluteVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
        AbsoluteVolumeOscillatorIndicator.uh = StrategyBasedIndicator.uf(10, AbsoluteVolumeOscillatorIndicator.$);
        AbsoluteVolumeOscillatorIndicator.ug = StrategyBasedIndicator.ub(30, AbsoluteVolumeOscillatorIndicator.$);
        return AbsoluteVolumeOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Absolute Volume Oscillator indicator series.
     * Default required members: Volume
    *
    * You can use the `IgxAbsoluteVolumeOscillatorIndicatorComponent` to identify whether volume trands are increasing or decreasing.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-absolute-volume-oscillator-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-absolute-volume-oscillator-indicator>
    * </igx-data-chart>
    * ```
    */
    var IgxAbsoluteVolumeOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAbsoluteVolumeOscillatorIndicatorComponent, _super);
        function IgxAbsoluteVolumeOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxAbsoluteVolumeOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new AbsoluteVolumeOscillatorIndicator();
        };
        Object.defineProperty(IgxAbsoluteVolumeOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAbsoluteVolumeOscillatorIndicatorComponent.prototype, "shortPeriod", {
            /**
             * Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
             * The typical, and initial, value for short AVO periods is 10.
            *
            * You can use the `shortPeriod` to set the short moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-absolute-volume-oscillator-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		shortPeriod="10">
            *     </igx-absolute-volume-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shortPeriod = 10;
            * ```
            */
            get: function () {
                return this.i.shortPeriod;
            },
            set: function (v) {
                this.i.shortPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAbsoluteVolumeOscillatorIndicatorComponent.prototype, "longPeriod", {
            /**
             * Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
             * The typical, and initial, value for long AVO periods is 30.
            *
            * You can use the `longPeriod` to set the long moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-absolute-volume-oscillator-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		longPeriod="30">
            *     </igx-absolute-volume-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.longPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.longPeriod;
            },
            set: function (v) {
                this.i.longPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxAbsoluteVolumeOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAbsoluteVolumeOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAbsoluteVolumeOscillatorIndicatorComponent, selector: "igx-absolute-volume-oscillator-indicator", inputs: { shortPeriod: "shortPeriod", longPeriod: "longPeriod" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxAbsoluteVolumeOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-absolute-volume-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAbsoluteVolumeOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shortPeriod: [{
                    type: i0.Input
                }], longPeriod: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAbsoluteVolumeOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAbsoluteVolumeOscillatorIndicatorModule() {
        }
        IgxAbsoluteVolumeOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAbsoluteVolumeOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorModule, declarations: [IgxAbsoluteVolumeOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxAbsoluteVolumeOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxAbsoluteVolumeOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxAbsoluteVolumeOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxAbsoluteVolumeOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxAbsoluteVolumeOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAbsoluteVolumeOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAbsoluteVolumeOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxAbsoluteVolumeOscillatorIndicatorComponent", IgxAbsoluteVolumeOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("AbsoluteVolumeOscillatorIndicator", AbsoluteVolumeOscillatorIndicator.$type);
        }
        IgxAbsoluteVolumeOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAbsoluteVolumeOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule], exports: [IgxAbsoluteVolumeOscillatorIndicatorModule] });
        IgxAbsoluteVolumeOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule], IgxAbsoluteVolumeOscillatorIndicatorModule] });
        return IgxAbsoluteVolumeOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAbsoluteVolumeOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule],
                        exports: [IgxAbsoluteVolumeOscillatorIndicatorModule],
                        entryComponents: [IgxAbsoluteVolumeOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StreamingIndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StreamingIndicatorCalculationStrategy, _super);
        function StreamingIndicatorCalculationStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        StreamingIndicatorCalculationStrategy.$t = i2.markType(StreamingIndicatorCalculationStrategy, 'StreamingIndicatorCalculationStrategy', IndicatorCalculationStrategy.$);
        return StreamingIndicatorCalculationStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AccumulationDistributionIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AccumulationDistributionIndicatorStrategy, _super);
        function AccumulationDistributionIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AccumulationDistributionIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.add("LowColumn");
            c.add("HighColumn");
            c.add("VolumeColumn");
            return c;
        };
        AccumulationDistributionIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c(a, b))), _d = _b.next(); !_d.done; _d = _b.next()) {
                    var d = _d.value;
                    a.indicatorColumn.item(c, d);
                    c++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        AccumulationDistributionIndicatorStrategy.prototype._c = function (a, b) {
            var c, d, e, f, g, h, i, j, k, l, m, n, o, p;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = 0;
                        d = Number.POSITIVE_INFINITY;
                        e = Number.NEGATIVE_INFINITY;
                        f = a.indicatorColumn != null ? a.indicatorColumn.count : 0;
                        g = a.closeColumn != null ? a.closeColumn.count : 0;
                        h = a.highColumn != null ? a.highColumn.count : 0;
                        i = a.volumeColumn != null ? a.volumeColumn.count : 0;
                        j = Math.min(f, Math.min(g, Math.min(h, i)));
                        k = 0;
                        _a.label = 1;
                    case 1:
                        if (!(k < j))
                            return [3 /*break*/, 4];
                        l = a.closeColumn.item(k);
                        m = a.lowColumn.item(k);
                        n = a.highColumn.item(k);
                        o = a.volumeColumn.item(k);
                        p = ((l - m) - (n - l)) / (n - m);
                        c += b.i(p * o);
                        d = Math.min(d, c);
                        e = Math.max(e, c);
                        return [4 /*yield*/, c];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        ++k;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        AccumulationDistributionIndicatorStrategy.prototype.c = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._c(a, b); });
        };
        AccumulationDistributionIndicatorStrategy.$t = i2.markType(AccumulationDistributionIndicatorStrategy, 'AccumulationDistributionIndicatorStrategy', StreamingIndicatorCalculationStrategy.$);
        return AccumulationDistributionIndicatorStrategy;
    }(StreamingIndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AccumulationDistributionIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AccumulationDistributionIndicator, _super);
        function AccumulationDistributionIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AccumulationDistributionIndicator.prototype.get_tv = function () {
            return new AccumulationDistributionIndicatorStrategy();
        };
        Object.defineProperty(AccumulationDistributionIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        AccumulationDistributionIndicator.prototype.get_t8 = function () {
            return AccumulationDistributionIndicator.$;
        };
        Object.defineProperty(AccumulationDistributionIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        AccumulationDistributionIndicator.$t = i2.markType(AccumulationDistributionIndicator, 'AccumulationDistributionIndicator', StrategyBasedIndicator.$);
        return AccumulationDistributionIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Accumulation/Distribution indicator series.
     * Default required members: Close, Low, High, Volume
    *
    * You can use the `IgxAccumulationDistributionIndicatorComponent` to evaluate the suppy and demand of a stock, security, or index.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-accumulation-distribution-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-accumulation-distribution-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxAccumulationDistributionIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxAccumulationDistributionIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAccumulationDistributionIndicatorComponent, _super);
        function IgxAccumulationDistributionIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxAccumulationDistributionIndicatorComponent.prototype.createImplementation = function () {
            return new AccumulationDistributionIndicator();
        };
        Object.defineProperty(IgxAccumulationDistributionIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxAccumulationDistributionIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAccumulationDistributionIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAccumulationDistributionIndicatorComponent, selector: "igx-accumulation-distribution-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxAccumulationDistributionIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-accumulation-distribution-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAccumulationDistributionIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAccumulationDistributionIndicatorModule() {
        }
        IgxAccumulationDistributionIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAccumulationDistributionIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorModule, declarations: [IgxAccumulationDistributionIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxAccumulationDistributionIndicatorComponent, IgxIndicatorProxyModule] });
        IgxAccumulationDistributionIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxAccumulationDistributionIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxAccumulationDistributionIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxAccumulationDistributionIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAccumulationDistributionIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAccumulationDistributionIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxAccumulationDistributionIndicatorComponent", IgxAccumulationDistributionIndicatorComponent);
            i2.TypeRegistrar.register("AccumulationDistributionIndicator", AccumulationDistributionIndicator.$type);
        }
        IgxAccumulationDistributionIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAccumulationDistributionIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorDynamicModule, imports: [i1.CommonModule, IgxAccumulationDistributionIndicatorModule], exports: [IgxAccumulationDistributionIndicatorModule] });
        IgxAccumulationDistributionIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorDynamicModule, imports: [[i1.CommonModule, IgxAccumulationDistributionIndicatorModule], IgxAccumulationDistributionIndicatorModule] });
        return IgxAccumulationDistributionIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAccumulationDistributionIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxAccumulationDistributionIndicatorModule],
                        exports: [IgxAccumulationDistributionIndicatorModule],
                        entryComponents: [IgxAccumulationDistributionIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AverageDirectionalIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AverageDirectionalIndexIndicatorStrategy, _super);
        function AverageDirectionalIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AverageDirectionalIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("LowColumn");
            c.add("HighColumn");
            c.o(a.trueRange.basedOn);
            c.o(b.a.c);
            return c;
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.j = function (a, b, c) {
            return b.item(a) - b.item(a - 1);
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.i = function (a, b, c) {
            return c.item(a - 1) - c.item(a);
        };
        AverageDirectionalIndexIndicatorStrategy.prototype._h = function (a, b) {
            var c, d, e;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, 0];
                    case 1:
                        _a.sent();
                        c = 0;
                        d = 0;
                        e = 1;
                        _a.label = 2;
                    case 2:
                        if (!(e < a.count))
                            return [3 /*break*/, 7];
                        c = this.j(e, a, b);
                        d = this.i(e, a, b);
                        if (!(c > d && c > 0))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, c];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 4: return [4 /*yield*/, 0];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        e++;
                        return [3 /*break*/, 2];
                    case 7: return [2 /*return*/];
                }
            });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.h = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._h(a, b); });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype._f = function (a, b) {
            var c, d, e;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, 0];
                    case 1:
                        _a.sent();
                        c = 0;
                        d = 0;
                        e = 1;
                        _a.label = 2;
                    case 2:
                        if (!(e < a.count))
                            return [3 /*break*/, 7];
                        c = this.j(e, a, b);
                        d = this.i(e, a, b);
                        if (!(d > c && d > 0))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, d];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 4: return [4 /*yield*/, 0];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        e++;
                        return [3 /*break*/, 2];
                    case 7: return [2 /*return*/];
                }
            });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.f = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._f(a, b); });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype._g = function (a, b) {
            var c, d;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = i2.getEnumerator(b.a.b(this.h(a.highColumn, a.lowColumn), a.period));
                        d = i2.getEnumerator(b.a.b(a.trueRange, a.period));
                        _a.label = 1;
                    case 1:
                        if (!(c.moveNext() && d.moveNext()))
                            return [3 /*break*/, 3];
                        return [4 /*yield*/, b.i(c.current / d.current)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.g = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._g(a, b); });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype._e = function (a, b) {
            var c, d;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = i2.getEnumerator(b.a.b(this.f(a.highColumn, a.lowColumn), a.period));
                        d = i2.getEnumerator(b.a.b(a.trueRange, a.period));
                        _a.label = 1;
                    case 1:
                        if (!(c.moveNext() && d.moveNext()))
                            return [3 /*break*/, 3];
                        return [4 /*yield*/, b.i(c.current / d.current)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.e = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._e(a, b); });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype._d = function (a, b) {
            var c, d;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = i2.getEnumerator(this.g(a, b));
                        d = i2.getEnumerator(this.e(a, b));
                        c.moveNext();
                        d.moveNext();
                        _a.label = 1;
                    case 1:
                        if (!(c.moveNext() && d.moveNext()))
                            return [3 /*break*/, 3];
                        return [4 /*yield*/, Math.abs(b.i((c.current - d.current) / (c.current + d.current)))];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.d = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._d(a, b); });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype._c = function (a, b) {
            var c;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = i2.getEnumerator(b.a.b(this.d(a, b), a.period));
                        return [4 /*yield*/, 0];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (!c.moveNext())
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, c.current * 100];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 2];
                    case 4: return [2 /*return*/];
                }
            });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.c = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._c(a, b); });
        };
        AverageDirectionalIndexIndicatorStrategy.prototype.a = function (a, b) {
            var c = i2.getEnumerator(this.c(a, b));
            var d = a.indicatorColumn;
            for (var e = 0; e < d.count; e++) {
                if (c.moveNext()) {
                    d.item(e, c.current);
                }
            }
            return true;
        };
        AverageDirectionalIndexIndicatorStrategy.$t = i2.markType(AverageDirectionalIndexIndicatorStrategy, 'AverageDirectionalIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return AverageDirectionalIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AverageDirectionalIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AverageDirectionalIndexIndicator, _super);
        function AverageDirectionalIndexIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AverageDirectionalIndexIndicator.prototype.get_tv = function () {
            return new AverageDirectionalIndexIndicatorStrategy();
        };
        Object.defineProperty(AverageDirectionalIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        AverageDirectionalIndexIndicator.prototype.get_t8 = function () {
            return AverageDirectionalIndexIndicator.$;
        };
        Object.defineProperty(AverageDirectionalIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AverageDirectionalIndexIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(AverageDirectionalIndexIndicator.uh));
            },
            set: function (a) {
                this.h(AverageDirectionalIndexIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        AverageDirectionalIndexIndicator.prototype.t1 = function () {
            return this.ug;
        };
        AverageDirectionalIndexIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        AverageDirectionalIndexIndicator.$t = i2.markType(AverageDirectionalIndexIndicator, 'AverageDirectionalIndexIndicator', StrategyBasedIndicator.$);
        AverageDirectionalIndexIndicator.uh = StrategyBasedIndicator.ud(14, AverageDirectionalIndexIndicator.$);
        return AverageDirectionalIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Average Directional indicator series.
     * Default required members: High, Low, Close
    *
    * You can use the `IgxAverageDirectionalIndexIndicatorComponent` to measures trend strength without regard to trend direction.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-average-directional-index-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-average-directional-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxAverageDirectionalIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxAverageDirectionalIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAverageDirectionalIndexIndicatorComponent, _super);
        function IgxAverageDirectionalIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxAverageDirectionalIndexIndicatorComponent.prototype.createImplementation = function () {
            return new AverageDirectionalIndexIndicator();
        };
        Object.defineProperty(IgxAverageDirectionalIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAverageDirectionalIndexIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current AverageDirectionalIndexIndicator object.
             * The typical, and initial, value for AverageDirectionalIndexIndicator periods is 14.
            *
            * You can use the `period` to set the moving average.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-average-directional-index-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		period="14">
            *     </igx-average-directional-index-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 14;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxAverageDirectionalIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAverageDirectionalIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAverageDirectionalIndexIndicatorComponent, selector: "igx-average-directional-index-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxAverageDirectionalIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-average-directional-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAverageDirectionalIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAverageDirectionalIndexIndicatorModule() {
        }
        IgxAverageDirectionalIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAverageDirectionalIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorModule, declarations: [IgxAverageDirectionalIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxAverageDirectionalIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxAverageDirectionalIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxAverageDirectionalIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxAverageDirectionalIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxAverageDirectionalIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAverageDirectionalIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAverageDirectionalIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxAverageDirectionalIndexIndicatorComponent", IgxAverageDirectionalIndexIndicatorComponent);
            i2.TypeRegistrar.register("AverageDirectionalIndexIndicator", AverageDirectionalIndexIndicator.$type);
        }
        IgxAverageDirectionalIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAverageDirectionalIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxAverageDirectionalIndexIndicatorModule], exports: [IgxAverageDirectionalIndexIndicatorModule] });
        IgxAverageDirectionalIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxAverageDirectionalIndexIndicatorModule], IgxAverageDirectionalIndexIndicatorModule] });
        return IgxAverageDirectionalIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageDirectionalIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxAverageDirectionalIndexIndicatorModule],
                        exports: [IgxAverageDirectionalIndexIndicatorModule],
                        entryComponents: [IgxAverageDirectionalIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AverageTrueRangeIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AverageTrueRangeIndicatorStrategy, _super);
        function AverageTrueRangeIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AverageTrueRangeIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.trueRange.basedOn);
            c.o(b.a.c);
            return c;
        };
        AverageTrueRangeIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(b.a.b(a.trueRange, a.period))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    a.indicatorColumn.item(c, d);
                    ++c;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        AverageTrueRangeIndicatorStrategy.$t = i2.markType(AverageTrueRangeIndicatorStrategy, 'AverageTrueRangeIndicatorStrategy', IndicatorCalculationStrategy.$);
        return AverageTrueRangeIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AverageTrueRangeIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AverageTrueRangeIndicator, _super);
        function AverageTrueRangeIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AverageTrueRangeIndicator.prototype.get_tv = function () {
            return new AverageTrueRangeIndicatorStrategy();
        };
        Object.defineProperty(AverageTrueRangeIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        AverageTrueRangeIndicator.prototype.get_t8 = function () {
            return AverageTrueRangeIndicator.$;
        };
        Object.defineProperty(AverageTrueRangeIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AverageTrueRangeIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(AverageTrueRangeIndicator.uh));
            },
            set: function (a) {
                this.h(AverageTrueRangeIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        AverageTrueRangeIndicator.prototype.t1 = function () {
            return this.ug;
        };
        AverageTrueRangeIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        AverageTrueRangeIndicator.$t = i2.markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
        AverageTrueRangeIndicator.uh = StrategyBasedIndicator.ud(14, AverageTrueRangeIndicator.$);
        return AverageTrueRangeIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Average True Range indicator series.
     * Default required members: High, Low, Close
    *
    * You can use the `IgxAverageTrueRangeIndicatorComponent` to measures a security's degree of price movement or volatility within a given period of time.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-average-true-range-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-average-true-range-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxAverageTrueRangeIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxAverageTrueRangeIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAverageTrueRangeIndicatorComponent, _super);
        function IgxAverageTrueRangeIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxAverageTrueRangeIndicatorComponent.prototype.createImplementation = function () {
            return new AverageTrueRangeIndicator();
        };
        Object.defineProperty(IgxAverageTrueRangeIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAverageTrueRangeIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
             * The typical, and initial, value for AverageTrueRange periods is 14.
            *
            * You can use the `period` to set the moving average.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-average-true-range-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		period="14">
            *     </igx-average-true-range-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 14;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxAverageTrueRangeIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAverageTrueRangeIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAverageTrueRangeIndicatorComponent, selector: "igx-average-true-range-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxAverageTrueRangeIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-average-true-range-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAverageTrueRangeIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAverageTrueRangeIndicatorModule() {
        }
        IgxAverageTrueRangeIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAverageTrueRangeIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorModule, declarations: [IgxAverageTrueRangeIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxAverageTrueRangeIndicatorComponent, IgxIndicatorProxyModule] });
        IgxAverageTrueRangeIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxAverageTrueRangeIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxAverageTrueRangeIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxAverageTrueRangeIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAverageTrueRangeIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAverageTrueRangeIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxAverageTrueRangeIndicatorComponent", IgxAverageTrueRangeIndicatorComponent);
            i2.TypeRegistrar.register("AverageTrueRangeIndicator", AverageTrueRangeIndicator.$type);
        }
        IgxAverageTrueRangeIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAverageTrueRangeIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorDynamicModule, imports: [i1.CommonModule, IgxAverageTrueRangeIndicatorModule], exports: [IgxAverageTrueRangeIndicatorModule] });
        IgxAverageTrueRangeIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorDynamicModule, imports: [[i1.CommonModule, IgxAverageTrueRangeIndicatorModule], IgxAverageTrueRangeIndicatorModule] });
        return IgxAverageTrueRangeIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAverageTrueRangeIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxAverageTrueRangeIndicatorModule],
                        exports: [IgxAverageTrueRangeIndicatorModule],
                        entryComponents: [IgxAverageTrueRangeIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BollingerBandWidthIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BollingerBandWidthIndicatorStrategy, _super);
        function BollingerBandWidthIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BollingerBandWidthIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.typicalColumn.basedOn);
            c.o(b.c.c);
            c.o(b.d.c);
            return c;
        };
        BollingerBandWidthIndicatorStrategy.prototype.a = function (a, b) {
            var c = i2.getEnumerator(b.c.b(a.typicalColumn, a.period));
            var d = i2.getEnumerator(b.d.b(a.typicalColumn, a.period));
            var e = a.multiplier;
            var f = a.indicatorColumn;
            var g = 0;
            while (c.moveNext() && d.moveNext()) {
                var h = d.current * e;
                var i = c.current + h;
                var j = c.current - h;
                var k = c.current;
                var l = b.i((i - j) / k);
                f.item(g, l);
                g++;
            }
            return true;
        };
        BollingerBandWidthIndicatorStrategy.$t = i2.markType(BollingerBandWidthIndicatorStrategy, 'BollingerBandWidthIndicatorStrategy', IndicatorCalculationStrategy.$);
        return BollingerBandWidthIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BollingerBandWidthIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BollingerBandWidthIndicator, _super);
        function BollingerBandWidthIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BollingerBandWidthIndicator.prototype.get_tv = function () {
            return new BollingerBandWidthIndicatorStrategy();
        };
        Object.defineProperty(BollingerBandWidthIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        BollingerBandWidthIndicator.prototype.get_t8 = function () {
            return BollingerBandWidthIndicator.$;
        };
        Object.defineProperty(BollingerBandWidthIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BollingerBandWidthIndicator.prototype, "uh", {
            get: function () {
                return i2.typeGetValue(this.c(BollingerBandWidthIndicator.uk));
            },
            set: function (a) {
                this.h(BollingerBandWidthIndicator.uk, a);
            },
            enumerable: false,
            configurable: true
        });
        BollingerBandWidthIndicator.prototype.t1 = function () {
            return this.uh;
        };
        Object.defineProperty(BollingerBandWidthIndicator.prototype, "ug", {
            get: function () {
                return this.c(BollingerBandWidthIndicator.uj);
            },
            set: function (a) {
                this.h(BollingerBandWidthIndicator.uj, a);
            },
            enumerable: false,
            configurable: true
        });
        BollingerBandWidthIndicator.prototype.tz = function () {
            return this.ug;
        };
        BollingerBandWidthIndicator.$t = i2.markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
        BollingerBandWidthIndicator.uk = StrategyBasedIndicator.ud(20, BollingerBandWidthIndicator.$);
        BollingerBandWidthIndicator.uj = StrategyBasedIndicator.uc(2, BollingerBandWidthIndicator.$);
        return BollingerBandWidthIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Bollinger Bandwidth indicator series.
     * Represents the normalized width of the Bollinger bands for each provided value.
     * For more info see: BollingerBandsOverlay
     * Default required members: High, Low, Close
    *
    * You can use the `IgxBollingerBandWidthIndicatorComponent` to represents a IgxDataChartComponent Bollinger Bandwidth indicator series.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-bollinger-band-width-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-bollinger-band-width-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxBollingerBandWidthIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxBollingerBandWidthIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxBollingerBandWidthIndicatorComponent, _super);
        function IgxBollingerBandWidthIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxBollingerBandWidthIndicatorComponent.prototype.createImplementation = function () {
            return new BollingerBandWidthIndicator();
        };
        Object.defineProperty(IgxBollingerBandWidthIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBollingerBandWidthIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the Bollinger Band Width Indicator.
             * The typical, and initial, value for CCI periods is 20.
            *
            * You can use the `period` to set the moving average.
            *
            * ```html
            * <igx-data-chart
            * 	#chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-bollinger-band-width-indicator
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		period="14">
            *     </igx-bollinger-band-width-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 14;
            * ```
            */
            get: function () {
                return this.i.uh;
            },
            set: function (v) {
                this.i.uh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBollingerBandWidthIndicatorComponent.prototype, "multiplier", {
            /**
             * Gets or sets the multiplier for the Bollinger Band width.
             * The typical, and initial, value for Bollinger Band width multiplier is 2.
            *
            * Use the `multiplier` property for the Bollinger Band width. The typical, and initial, value for Bollinger Band width multiplier is 2.
            *
            * ```ts
            * this.series.multiplier = 14;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxBollingerBandWidthIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxBollingerBandWidthIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxBollingerBandWidthIndicatorComponent, selector: "igx-bollinger-band-width-indicator", inputs: { period: "period", multiplier: "multiplier" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxBollingerBandWidthIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-bollinger-band-width-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandWidthIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }], multiplier: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBollingerBandWidthIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBollingerBandWidthIndicatorModule() {
        }
        IgxBollingerBandWidthIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBollingerBandWidthIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorModule, declarations: [IgxBollingerBandWidthIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxBollingerBandWidthIndicatorComponent, IgxIndicatorProxyModule] });
        IgxBollingerBandWidthIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxBollingerBandWidthIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxBollingerBandWidthIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxBollingerBandWidthIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBollingerBandWidthIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBollingerBandWidthIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxBollingerBandWidthIndicatorComponent", IgxBollingerBandWidthIndicatorComponent);
            i2.TypeRegistrar.register("BollingerBandWidthIndicator", BollingerBandWidthIndicator.$type);
        }
        IgxBollingerBandWidthIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBollingerBandWidthIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorDynamicModule, imports: [i1.CommonModule, IgxBollingerBandWidthIndicatorModule], exports: [IgxBollingerBandWidthIndicatorModule] });
        IgxBollingerBandWidthIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorDynamicModule, imports: [[i1.CommonModule, IgxBollingerBandWidthIndicatorModule], IgxBollingerBandWidthIndicatorModule] });
        return IgxBollingerBandWidthIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandWidthIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxBollingerBandWidthIndicatorModule],
                        exports: [IgxBollingerBandWidthIndicatorModule],
                        entryComponents: [IgxBollingerBandWidthIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChaikinOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChaikinOscillatorIndicatorStrategy, _super);
        function ChaikinOscillatorIndicatorStrategy() {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.c = new AccumulationDistributionIndicatorStrategy();
            return _this;
        }
        ChaikinOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(this.c.b(a, b));
            c.o(b.a.c);
            return c;
        };
        ChaikinOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.indicatorColumn;
            var d = this.c.c(a, b);
            var e = i2.getEnumerator(b.a.b(d, a.shortPeriod));
            var f = i2.getEnumerator(b.a.b(d, a.longPeriod));
            var g = 0;
            while (e.moveNext() && f.moveNext()) {
                var h = e.current - f.current;
                c.item(g, h);
                g++;
            }
            return true;
        };
        ChaikinOscillatorIndicatorStrategy.$t = i2.markType(ChaikinOscillatorIndicatorStrategy, 'ChaikinOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return ChaikinOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChaikinOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChaikinOscillatorIndicator, _super);
        function ChaikinOscillatorIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ChaikinOscillatorIndicator.prototype.get_tv = function () {
            return new ChaikinOscillatorIndicatorStrategy();
        };
        Object.defineProperty(ChaikinOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        ChaikinOscillatorIndicator.prototype.get_t8 = function () {
            return ChaikinOscillatorIndicator.$;
        };
        Object.defineProperty(ChaikinOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChaikinOscillatorIndicator.prototype, "shortPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(ChaikinOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(ChaikinOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        ChaikinOscillatorIndicator.prototype.t3 = function () {
            return this.shortPeriod;
        };
        Object.defineProperty(ChaikinOscillatorIndicator.prototype, "longPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(ChaikinOscillatorIndicator.ug));
            },
            set: function (a) {
                this.h(ChaikinOscillatorIndicator.ug, a);
            },
            enumerable: false,
            configurable: true
        });
        ChaikinOscillatorIndicator.prototype.t0 = function () {
            return this.longPeriod;
        };
        ChaikinOscillatorIndicator.$t = i2.markType(ChaikinOscillatorIndicator, 'ChaikinOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
        ChaikinOscillatorIndicator.uh = StrategyBasedIndicator.uf(3, ChaikinOscillatorIndicator.$);
        ChaikinOscillatorIndicator.ug = StrategyBasedIndicator.ub(10, ChaikinOscillatorIndicator.$);
        return ChaikinOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents the IgxDataChartComponent Chaikin Oscillator indicator series.
     * Default required members: Close, Low, High, Volume
    *
    * `IgxChaikinOscillatorIndicatorComponent` class specify the series as Chaikin Oscillator Indicator series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *   <igx-chaikin-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    *     longPeriod="30">
    *   </igx-chaikin-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxChaikinOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxChaikinOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxChaikinOscillatorIndicatorComponent, _super);
        function IgxChaikinOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxChaikinOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new ChaikinOscillatorIndicator();
        };
        Object.defineProperty(IgxChaikinOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChaikinOscillatorIndicatorComponent.prototype, "shortPeriod", {
            /**
             * Gets or sets the short moving average period for the current ChaikinOscillatorIndicator object.
             * The typical, and initial, value for short CHO periods is 3.
            *
            * Set the `shortPeriod` property if you wish to change the short moving average period for the indicator.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *   <igx-category-x-axis #xAxis
            *     label="time">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-chaikin-oscillator-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            *     shortPeriod="5">
            *   </igx-chaikin-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shortPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.shortPeriod;
            },
            set: function (v) {
                this.i.shortPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChaikinOscillatorIndicatorComponent.prototype, "longPeriod", {
            /**
             * Gets or sets the long moving average period for the current ChaikinOscillatorIndicator object.
             * The typical, and initial, value for long CHO periods is 10.
            *
            * Set the `longPeriod` property if you wish to change the long moving average period for the indicator.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *   <igx-category-x-axis #xAxis
            *     label="time">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-chaikin-oscillator-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            *     longPeriod="30" >
            *   </igx-chaikin-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.longPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.longPeriod;
            },
            set: function (v) {
                this.i.longPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxChaikinOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxChaikinOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxChaikinOscillatorIndicatorComponent, selector: "igx-chaikin-oscillator-indicator", inputs: { shortPeriod: "shortPeriod", longPeriod: "longPeriod" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxChaikinOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-chaikin-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shortPeriod: [{
                    type: i0.Input
                }], longPeriod: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxChaikinOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxChaikinOscillatorIndicatorModule() {
        }
        IgxChaikinOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxChaikinOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorModule, declarations: [IgxChaikinOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxChaikinOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxChaikinOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxChaikinOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxChaikinOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxChaikinOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxChaikinOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxChaikinOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxChaikinOscillatorIndicatorComponent", IgxChaikinOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("ChaikinOscillatorIndicator", ChaikinOscillatorIndicator.$type);
        }
        IgxChaikinOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxChaikinOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxChaikinOscillatorIndicatorModule], exports: [IgxChaikinOscillatorIndicatorModule] });
        IgxChaikinOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxChaikinOscillatorIndicatorModule], IgxChaikinOscillatorIndicatorModule] });
        return IgxChaikinOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxChaikinOscillatorIndicatorModule],
                        exports: [IgxChaikinOscillatorIndicatorModule],
                        entryComponents: [IgxChaikinOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChaikinVolatilityIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChaikinVolatilityIndicatorStrategy, _super);
        function ChaikinVolatilityIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ChaikinVolatilityIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.o(b.a.c);
            return c;
        };
        ChaikinVolatilityIndicatorStrategy.prototype.a = function (a, b) {
            var c = b.j(function (d) { return a.highColumn.item(d) - a.lowColumn.item(d); }, a.count);
            var d = i2.getEnumerator(b.a.b(c, a.period));
            var e = a.indicatorColumn;
            var f = new Array(a.period);
            for (var g = 0; g < a.period; g++) {
                f[g] = 0;
            }
            var h = 0;
            while (d.moveNext()) {
                var i = h % a.period;
                var j = b.i((d.current - f[i]) / (f[i] * 100));
                if (h < a.period) {
                    e.item(h, 0);
                }
                else {
                    e.item(h, j);
                }
                f[i] = d.current;
                h++;
            }
            return true;
        };
        ChaikinVolatilityIndicatorStrategy.$t = i2.markType(ChaikinVolatilityIndicatorStrategy, 'ChaikinVolatilityIndicatorStrategy', IndicatorCalculationStrategy.$);
        return ChaikinVolatilityIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChaikinVolatilityIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChaikinVolatilityIndicator, _super);
        function ChaikinVolatilityIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ChaikinVolatilityIndicator.prototype.get_tv = function () {
            return new ChaikinVolatilityIndicatorStrategy();
        };
        Object.defineProperty(ChaikinVolatilityIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        ChaikinVolatilityIndicator.prototype.get_t8 = function () {
            return ChaikinVolatilityIndicator.$;
        };
        Object.defineProperty(ChaikinVolatilityIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChaikinVolatilityIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(ChaikinVolatilityIndicator.uh));
            },
            set: function (a) {
                this.h(ChaikinVolatilityIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        ChaikinVolatilityIndicator.prototype.t1 = function () {
            return this.ug;
        };
        ChaikinVolatilityIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        ChaikinVolatilityIndicator.$t = i2.markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
        ChaikinVolatilityIndicator.uh = StrategyBasedIndicator.ud(10, ChaikinVolatilityIndicator.$);
        return ChaikinVolatilityIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Chaikin Volatility indicator series.
     * The ChaikinVolatility indicator attempts to show volatility by displaying the spread between
     * the high and low values.
     * Default required members: High, Low
    *
    * `IgxChaikinVolatilityIndicatorComponent` class specify the series as Chaikin Volitility Indicator series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-chaikin-volatility-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"   >
    *   </igx-chaikin-volatility-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxChaikinVolatilityIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxChaikinVolatilityIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxChaikinVolatilityIndicatorComponent, _super);
        function IgxChaikinVolatilityIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxChaikinVolatilityIndicatorComponent.prototype.createImplementation = function () {
            return new ChaikinVolatilityIndicator();
        };
        Object.defineProperty(IgxChaikinVolatilityIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChaikinVolatilityIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current ChaikinVolatilityIndicator object.
             * The typical, and initial, value for ChaikinVolatilityIndicator periods is 10.
            *
            * Set the `period` property if you wish to change the moving average period for the indicator.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *   <igx-category-x-axis #xAxis
            *     label="time">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-chaikin-volatility-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            *     period="30">
            *   </igx-chaikin-volatility-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.longPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxChaikinVolatilityIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxChaikinVolatilityIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxChaikinVolatilityIndicatorComponent, selector: "igx-chaikin-volatility-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxChaikinVolatilityIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-chaikin-volatility-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxChaikinVolatilityIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxChaikinVolatilityIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxChaikinVolatilityIndicatorModule() {
        }
        IgxChaikinVolatilityIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxChaikinVolatilityIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorModule, declarations: [IgxChaikinVolatilityIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxChaikinVolatilityIndicatorComponent, IgxIndicatorProxyModule] });
        IgxChaikinVolatilityIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxChaikinVolatilityIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxChaikinVolatilityIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxChaikinVolatilityIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxChaikinVolatilityIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxChaikinVolatilityIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxChaikinVolatilityIndicatorComponent", IgxChaikinVolatilityIndicatorComponent);
            i2.TypeRegistrar.register("ChaikinVolatilityIndicator", ChaikinVolatilityIndicator.$type);
        }
        IgxChaikinVolatilityIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxChaikinVolatilityIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorDynamicModule, imports: [i1.CommonModule, IgxChaikinVolatilityIndicatorModule], exports: [IgxChaikinVolatilityIndicatorModule] });
        IgxChaikinVolatilityIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorDynamicModule, imports: [[i1.CommonModule, IgxChaikinVolatilityIndicatorModule], IgxChaikinVolatilityIndicatorModule] });
        return IgxChaikinVolatilityIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxChaikinVolatilityIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxChaikinVolatilityIndicatorModule],
                        exports: [IgxChaikinVolatilityIndicatorModule],
                        entryComponents: [IgxChaikinVolatilityIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CommodityChannelIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CommodityChannelIndexIndicatorStrategy, _super);
        function CommodityChannelIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommodityChannelIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.typicalColumn.basedOn);
            c.o(b.c.c);
            return c;
        };
        CommodityChannelIndexIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.period;
            var d = a.typicalColumn;
            var e = a.indicatorColumn;
            var f = i2.getEnumerator(b.c.b(d, c));
            var g = i2.getEnumerator(d);
            var h = new Array(c);
            for (var i = 0; i < c; i++) {
                h[i] = 0;
            }
            var j = 0;
            while (g.moveNext() && f.moveNext()) {
                h[j % c] = g.current;
                var k = 0;
                for (var l = 0; l < c; ++l) {
                    k += Math.abs(f.current - h[l]);
                }
                k /= c;
                e.item(j, b.i((g.current - f.current) / (0.015 * k)));
                ++j;
            }
            return true;
        };
        CommodityChannelIndexIndicatorStrategy.$t = i2.markType(CommodityChannelIndexIndicatorStrategy, 'CommodityChannelIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return CommodityChannelIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CommodityChannelIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CommodityChannelIndexIndicator, _super);
        function CommodityChannelIndexIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CommodityChannelIndexIndicator.prototype.get_tv = function () {
            return new CommodityChannelIndexIndicatorStrategy();
        };
        Object.defineProperty(CommodityChannelIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        CommodityChannelIndexIndicator.prototype.get_t8 = function () {
            return CommodityChannelIndexIndicator.$;
        };
        Object.defineProperty(CommodityChannelIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CommodityChannelIndexIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(CommodityChannelIndexIndicator.uh));
            },
            set: function (a) {
                this.h(CommodityChannelIndexIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        CommodityChannelIndexIndicator.prototype.t1 = function () {
            return this.ug;
        };
        CommodityChannelIndexIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        CommodityChannelIndexIndicator.$t = i2.markType(CommodityChannelIndexIndicator, 'CommodityChannelIndexIndicator', StrategyBasedIndicator.$);
        CommodityChannelIndexIndicator.uh = StrategyBasedIndicator.ud(20, CommodityChannelIndexIndicator.$);
        return CommodityChannelIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Commodity Channel Index indicator series.
     * Default required members: High, Low, Close
    *
    * `IgxCommodityChannelIndexIndicatorComponent` class specify the series as Commodity Channel Index Indicator series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-commodity-channel-index-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    *     longPeriod="30" >
    *   </igx-commodity-channel-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxCommodityChannelIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxCommodityChannelIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCommodityChannelIndexIndicatorComponent, _super);
        function IgxCommodityChannelIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxCommodityChannelIndexIndicatorComponent.prototype.createImplementation = function () {
            return new CommodityChannelIndexIndicator();
        };
        Object.defineProperty(IgxCommodityChannelIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCommodityChannelIndexIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current CCISeries object.
             * The typical, and initial, value for CCI periods is 20.
            *
            * ```html
            * <igx-data-chart [dataSource]="data">
            *   <igx-category-x-axis #xAxis
            *     label="time">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *   <igx-commodity-channel-index-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            *     volumeMemberPath="volume"
            *     period="30" >
            *   </igx-commodity-channel-index-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxCommodityChannelIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCommodityChannelIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCommodityChannelIndexIndicatorComponent, selector: "igx-commodity-channel-index-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCommodityChannelIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-commodity-channel-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCommodityChannelIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCommodityChannelIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCommodityChannelIndexIndicatorModule() {
        }
        IgxCommodityChannelIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCommodityChannelIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorModule, declarations: [IgxCommodityChannelIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxCommodityChannelIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxCommodityChannelIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxCommodityChannelIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCommodityChannelIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxCommodityChannelIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCommodityChannelIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCommodityChannelIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCommodityChannelIndexIndicatorComponent", IgxCommodityChannelIndexIndicatorComponent);
            i2.TypeRegistrar.register("CommodityChannelIndexIndicator", CommodityChannelIndexIndicator.$type);
        }
        IgxCommodityChannelIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCommodityChannelIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxCommodityChannelIndexIndicatorModule], exports: [IgxCommodityChannelIndexIndicatorModule] });
        IgxCommodityChannelIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxCommodityChannelIndexIndicatorModule], IgxCommodityChannelIndexIndicatorModule] });
        return IgxCommodityChannelIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCommodityChannelIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCommodityChannelIndexIndicatorModule],
                        exports: [IgxCommodityChannelIndexIndicatorModule],
                        entryComponents: [IgxCommodityChannelIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DetrendedPriceOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DetrendedPriceOscillatorIndicatorStrategy, _super);
        function DetrendedPriceOscillatorIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DetrendedPriceOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.o(b.c.c);
            return c;
        };
        DetrendedPriceOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.period;
            var d = a.closeColumn;
            var e = a.indicatorColumn;
            var f = i2.getEnumerator(b.c.b(d, c));
            var g = (i2.intDivide(c, 2)) + 1;
            var h = new Array(g);
            for (var i = 0; i < g; i++) {
                h[i] = 0;
            }
            for (var j = 1; j < Math.min(g + 1, e.count); ++j) {
                var k = j % g;
                e.item(j, 0);
                f.moveNext();
                h[k] = f.current;
            }
            for (var l = g + 1; l < e.count; l++) {
                var m = l % g;
                e.item(l, d.item(l) - h[m]);
                f.moveNext();
                h[m] = f.current;
            }
            return true;
        };
        DetrendedPriceOscillatorIndicatorStrategy.$t = i2.markType(DetrendedPriceOscillatorIndicatorStrategy, 'DetrendedPriceOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return DetrendedPriceOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DetrendedPriceOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DetrendedPriceOscillatorIndicator, _super);
        function DetrendedPriceOscillatorIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DetrendedPriceOscillatorIndicator.prototype.get_tv = function () {
            return new DetrendedPriceOscillatorIndicatorStrategy();
        };
        Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        DetrendedPriceOscillatorIndicator.prototype.get_t8 = function () {
            return DetrendedPriceOscillatorIndicator.$;
        };
        Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(DetrendedPriceOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(DetrendedPriceOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        DetrendedPriceOscillatorIndicator.prototype.t1 = function () {
            return this.ug;
        };
        DetrendedPriceOscillatorIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        DetrendedPriceOscillatorIndicator.$t = i2.markType(DetrendedPriceOscillatorIndicator, 'DetrendedPriceOscillatorIndicator', StrategyBasedIndicator.$);
        DetrendedPriceOscillatorIndicator.uh = StrategyBasedIndicator.ud(20, DetrendedPriceOscillatorIndicator.$);
        return DetrendedPriceOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
     * Default required members: Close
    *
    * The `IgxDetrendedPriceOscillatorIndicatorComponent` class represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-detrended-price-oscillator-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close">
    *     </igx-detrended-price-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxDetrendedPriceOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxDetrendedPriceOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxDetrendedPriceOscillatorIndicatorComponent, _super);
        function IgxDetrendedPriceOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxDetrendedPriceOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new DetrendedPriceOscillatorIndicator();
        };
        Object.defineProperty(IgxDetrendedPriceOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDetrendedPriceOscillatorIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current DetrendedPriceOscillatorIndicator object.
             * The typical, and initial, value for DPO periods is 20.
            *
            * You can use the `period` to set the current moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-detrended-price-oscillator-indicator
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         openMemberPath="open"
            *         highMemberPath="high"
            *         lowMemberPath="low"
            *         closeMemberPath="close"
            * 		period=30>
            *     </igx-detrended-price-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxDetrendedPriceOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxDetrendedPriceOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxDetrendedPriceOscillatorIndicatorComponent, selector: "igx-detrended-price-oscillator-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxDetrendedPriceOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-detrended-price-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDetrendedPriceOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDetrendedPriceOscillatorIndicatorModule() {
        }
        IgxDetrendedPriceOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDetrendedPriceOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorModule, declarations: [IgxDetrendedPriceOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxDetrendedPriceOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxDetrendedPriceOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxDetrendedPriceOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxDetrendedPriceOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxDetrendedPriceOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDetrendedPriceOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDetrendedPriceOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxDetrendedPriceOscillatorIndicatorComponent", IgxDetrendedPriceOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("DetrendedPriceOscillatorIndicator", DetrendedPriceOscillatorIndicator.$type);
        }
        IgxDetrendedPriceOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDetrendedPriceOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxDetrendedPriceOscillatorIndicatorModule], exports: [IgxDetrendedPriceOscillatorIndicatorModule] });
        IgxDetrendedPriceOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxDetrendedPriceOscillatorIndicatorModule], IgxDetrendedPriceOscillatorIndicatorModule] });
        return IgxDetrendedPriceOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDetrendedPriceOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxDetrendedPriceOscillatorIndicatorModule],
                        exports: [IgxDetrendedPriceOscillatorIndicatorModule],
                        entryComponents: [IgxDetrendedPriceOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var EaseOfMovementIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(EaseOfMovementIndicatorStrategy, _super);
        function EaseOfMovementIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        EaseOfMovementIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.add("VolumeColumn");
            return c;
        };
        EaseOfMovementIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.indicatorColumn;
            var d = a.highColumn;
            var e = a.lowColumn;
            var f = a.volumeColumn;
            var g = a.count;
            if (g > 0) {
                c.item(0, 0);
            }
            for (var h = 1; h < g; h++) {
                var i = (d.item(h) + e.item(h)) / 2;
                var j = (d.item(h - 1) + e.item(h - 1)) / 2;
                var k = i - j;
                var l = 10000;
                var m = b.i((f.item(h) / l) / (d.item(h) - e.item(h)));
                c.item(h, b.i(k / m));
            }
            return true;
        };
        EaseOfMovementIndicatorStrategy.$t = i2.markType(EaseOfMovementIndicatorStrategy, 'EaseOfMovementIndicatorStrategy', IndicatorCalculationStrategy.$);
        return EaseOfMovementIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var EaseOfMovementIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(EaseOfMovementIndicator, _super);
        function EaseOfMovementIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        EaseOfMovementIndicator.prototype.get_tv = function () {
            return new EaseOfMovementIndicatorStrategy();
        };
        Object.defineProperty(EaseOfMovementIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        EaseOfMovementIndicator.prototype.get_t8 = function () {
            return EaseOfMovementIndicator.$;
        };
        Object.defineProperty(EaseOfMovementIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        EaseOfMovementIndicator.$t = i2.markType(EaseOfMovementIndicator, 'EaseOfMovementIndicator', StrategyBasedIndicator.$);
        return EaseOfMovementIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Ease of Movement indicator series.
     * The ease of movement indicator by Richard W. Arms, Jr relates the price change of an asset to
     * its volume. Normally smoothed with a moving average.
     * Default required members: Low, High, Volume
    *
    * The ease of movment indicator is used to analyze relationships between a price changes and volume. One would usually plot this in a separate chart below the main price chart. It can be added to a chart like this:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis
    *     >
    *     </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-ease-of-movement-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="High"
    *     lowMemberPath="Low"
    *     volumeMemberPath="Volume">
    *     </igx-ease-of-movement-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxEaseOfMovementIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "High";
    * series.lowMemberPath = "Low";
    * series.volumeMemberPath = "Volume";
    * series.dataSource = this.data;
    * this.chart.series.add(series);
    * ```
    */
    var IgxEaseOfMovementIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxEaseOfMovementIndicatorComponent, _super);
        function IgxEaseOfMovementIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxEaseOfMovementIndicatorComponent.prototype.createImplementation = function () {
            return new EaseOfMovementIndicator();
        };
        Object.defineProperty(IgxEaseOfMovementIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxEaseOfMovementIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxEaseOfMovementIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxEaseOfMovementIndicatorComponent, selector: "igx-ease-of-movement-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxEaseOfMovementIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-ease-of-movement-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxEaseOfMovementIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxEaseOfMovementIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxEaseOfMovementIndicatorModule() {
        }
        IgxEaseOfMovementIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxEaseOfMovementIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorModule, declarations: [IgxEaseOfMovementIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxEaseOfMovementIndicatorComponent, IgxIndicatorProxyModule] });
        IgxEaseOfMovementIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxEaseOfMovementIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxEaseOfMovementIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxEaseOfMovementIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxEaseOfMovementIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxEaseOfMovementIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxEaseOfMovementIndicatorComponent", IgxEaseOfMovementIndicatorComponent);
            i2.TypeRegistrar.register("EaseOfMovementIndicator", EaseOfMovementIndicator.$type);
        }
        IgxEaseOfMovementIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxEaseOfMovementIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorDynamicModule, imports: [i1.CommonModule, IgxEaseOfMovementIndicatorModule], exports: [IgxEaseOfMovementIndicatorModule] });
        IgxEaseOfMovementIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorDynamicModule, imports: [[i1.CommonModule, IgxEaseOfMovementIndicatorModule], IgxEaseOfMovementIndicatorModule] });
        return IgxEaseOfMovementIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxEaseOfMovementIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxEaseOfMovementIndicatorModule],
                        exports: [IgxEaseOfMovementIndicatorModule],
                        entryComponents: [IgxEaseOfMovementIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentKCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentKCalculationStrategy, _super);
        function PercentKCalculationStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PercentKCalculationStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.add("CloseColumn");
            return c;
        };
        PercentKCalculationStrategy.prototype._c = function (a, b) {
            var c, d, e, f, g, h, i, j;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = a.period;
                        d = a.highColumn;
                        e = a.lowColumn;
                        f = 0;
                        _a.label = 1;
                    case 1:
                        if (!(f < a.count))
                            return [3 /*break*/, 4];
                        g = Math.min(c, f);
                        h = -1.7976931348623157E+308;
                        i = 1.7976931348623157E+308;
                        for (j = 0; j < g; j++) {
                            if (!i2.isNaN_(d.item(f - j))) {
                                h = Math.max(h, d.item(f - j));
                            }
                            if (!i2.isNaN_(e.item(f - j))) {
                                i = Math.min(i, e.item(f - j));
                            }
                        }
                        return [4 /*yield*/, b.i((a.closeColumn.item(f) - i) / (h - i) * 100)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        f++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        PercentKCalculationStrategy.prototype.c = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._c(a, b); });
        };
        PercentKCalculationStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c(a, b))), _d = _b.next(); !_d.done; _d = _b.next()) {
                    var d = _d.value;
                    a.indicatorColumn.item(c, d);
                    c++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        PercentKCalculationStrategy.$t = i2.markType(PercentKCalculationStrategy, 'PercentKCalculationStrategy', StreamingIndicatorCalculationStrategy.$);
        return PercentKCalculationStrategy;
    }(StreamingIndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FastStochasticOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FastStochasticOscillatorIndicatorStrategy, _super);
        function FastStochasticOscillatorIndicatorStrategy() {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.c = new PercentKCalculationStrategy();
            return _this;
        }
        FastStochasticOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(this.c.b(a, b));
            return c;
        };
        FastStochasticOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = this.c.c(a, b);
            var d = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    a.indicatorColumn.item(d, e);
                    d++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        FastStochasticOscillatorIndicatorStrategy.$t = i2.markType(FastStochasticOscillatorIndicatorStrategy, 'FastStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return FastStochasticOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FastStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FastStochasticOscillatorIndicator, _super);
        function FastStochasticOscillatorIndicator() {
            var _this = _super.call(this) || this;
            _this.trendLineBrush = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            _this.trendLineType = 10;
            _this.trendLinePeriod = 3;
            return _this;
        }
        FastStochasticOscillatorIndicator.prototype.get_tv = function () {
            return new FastStochasticOscillatorIndicatorStrategy();
        };
        Object.defineProperty(FastStochasticOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        FastStochasticOscillatorIndicator.prototype.get_t8 = function () {
            return FastStochasticOscillatorIndicator.$;
        };
        Object.defineProperty(FastStochasticOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FastStochasticOscillatorIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(FastStochasticOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(FastStochasticOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        FastStochasticOscillatorIndicator.prototype.t1 = function () {
            return this.ug;
        };
        FastStochasticOscillatorIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        FastStochasticOscillatorIndicator.$t = i2.markType(FastStochasticOscillatorIndicator, 'FastStochasticOscillatorIndicator', StrategyBasedIndicator.$);
        FastStochasticOscillatorIndicator.uh = StrategyBasedIndicator.ud(14, FastStochasticOscillatorIndicator.$);
        return FastStochasticOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Fast Stochastic Oscillator indicator series.
     * Default required members: High, Low, Close
    */
    var IgxFastStochasticOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFastStochasticOscillatorIndicatorComponent, _super);
        function IgxFastStochasticOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxFastStochasticOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new FastStochasticOscillatorIndicator();
        };
        Object.defineProperty(IgxFastStochasticOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFastStochasticOscillatorIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current FastStochasticOscillatorIndicator object.
             * The typical, and initial, value for FastStochasticOscillatorIndicator periods is 14.
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFastStochasticOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFastStochasticOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFastStochasticOscillatorIndicatorComponent, selector: "igx-fast-stochastic-oscillator-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFastStochasticOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-fast-stochastic-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFastStochasticOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFastStochasticOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFastStochasticOscillatorIndicatorModule() {
        }
        IgxFastStochasticOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFastStochasticOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorModule, declarations: [IgxFastStochasticOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxFastStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxFastStochasticOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxFastStochasticOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFastStochasticOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxFastStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFastStochasticOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFastStochasticOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxFastStochasticOscillatorIndicatorComponent", IgxFastStochasticOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("FastStochasticOscillatorIndicator", FastStochasticOscillatorIndicator.$type);
        }
        IgxFastStochasticOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFastStochasticOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxFastStochasticOscillatorIndicatorModule], exports: [IgxFastStochasticOscillatorIndicatorModule] });
        IgxFastStochasticOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxFastStochasticOscillatorIndicatorModule], IgxFastStochasticOscillatorIndicatorModule] });
        return IgxFastStochasticOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFastStochasticOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxFastStochasticOscillatorIndicatorModule],
                        exports: [IgxFastStochasticOscillatorIndicatorModule],
                        entryComponents: [IgxFastStochasticOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ForceIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ForceIndexIndicatorStrategy, _super);
        function ForceIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ForceIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.add("VolumeColumn");
            c.o(b.a.c);
            return c;
        };
        ForceIndexIndicatorStrategy.prototype._c = function (a) {
            var b, c, d, e, f;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        b = 0;
                        c = a.closeColumn;
                        d = a.volumeColumn;
                        e = a.indicatorColumn;
                        if (c != null && d != null) {
                            b = Math.min(c.count, d.count);
                        }
                        if (!(b > 0))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, 0];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        f = 1;
                        _a.label = 3;
                    case 3:
                        if (!(f < b))
                            return [3 /*break*/, 6];
                        return [4 /*yield*/, d.item(f) * (c.item(f) - c.item(f - 1))];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        ++f;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/];
                }
            });
        };
        ForceIndexIndicatorStrategy.prototype.c = function (a) {
            var _this = this;
            return i2.toEnum(function () { return _this._c(a); });
        };
        ForceIndexIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = this.c(a);
            var d = a.period;
            var e = a.indicatorColumn;
            if (d != 0 && !i2.isNaN_(d) && !i2.isInfinity(d)) {
                c = b.a.b(c, a.period);
            }
            var f = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _d = _b.next(); !_d.done; _d = _b.next()) {
                    var g = _d.value;
                    e.item(f, g);
                    ++f;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        ForceIndexIndicatorStrategy.$t = i2.markType(ForceIndexIndicatorStrategy, 'ForceIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return ForceIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ForceIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ForceIndexIndicator, _super);
        function ForceIndexIndicator() {
            return _super.call(this) || this;
        }
        ForceIndexIndicator.prototype.get_s2 = function () {
            return 1;
        };
        ForceIndexIndicator.prototype.get_tv = function () {
            return new ForceIndexIndicatorStrategy();
        };
        Object.defineProperty(ForceIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        ForceIndexIndicator.prototype.get_t8 = function () {
            return ForceIndexIndicator.$;
        };
        Object.defineProperty(ForceIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ForceIndexIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(ForceIndexIndicator.uh));
            },
            set: function (a) {
                this.h(ForceIndexIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        ForceIndexIndicator.prototype.t1 = function () {
            return this.ug;
        };
        ForceIndexIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        ForceIndexIndicator.$t = i2.markType(ForceIndexIndicator, 'ForceIndexIndicator', StrategyBasedIndicator.$);
        ForceIndexIndicator.uh = StrategyBasedIndicator.ud(0, ForceIndexIndicator.$);
        return ForceIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Force Index indicator series.
     * Default required members: Close, Volume
    *
    * The `IgxForceIndexIndicatorComponent` represents a IgxDataChartComponent Force Index indicator series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-force-index-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close">
    *     </igx-force-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxForceIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);;
    * ```
    */
    var IgxForceIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxForceIndexIndicatorComponent, _super);
        function IgxForceIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxForceIndexIndicatorComponent.prototype.createImplementation = function () {
            return new ForceIndexIndicator();
        };
        Object.defineProperty(IgxForceIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxForceIndexIndicatorComponent.prototype, "defaultDisplayType", {
            /**
             * Gets default display type for the current Financial Indicator
            */
            get: function () {
                return this.i.s2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxForceIndexIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
             * The typical, and initial, value for ForceIndiex periods is 0.
            *
            * You can use the `period` property to get the moving average period of the current FullStochasticOscillatorIndicator object
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-force-index-indicator
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         openMemberPath="open"
            *         highMemberPath="high"
            *         lowMemberPath="low"
            *         closeMemberPath="close"
            * 		period=30>
            *     </igx-force-index-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxForceIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxForceIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxForceIndexIndicatorComponent, selector: "igx-force-index-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxForceIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-force-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxForceIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxForceIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxForceIndexIndicatorModule() {
        }
        IgxForceIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxForceIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorModule, declarations: [IgxForceIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxForceIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxForceIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxForceIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxForceIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxForceIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxForceIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxForceIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxForceIndexIndicatorComponent", IgxForceIndexIndicatorComponent);
            i2.TypeRegistrar.register("ForceIndexIndicator", ForceIndexIndicator.$type);
        }
        IgxForceIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxForceIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxForceIndexIndicatorModule], exports: [IgxForceIndexIndicatorModule] });
        IgxForceIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxForceIndexIndicatorModule], IgxForceIndexIndicatorModule] });
        return IgxForceIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxForceIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxForceIndexIndicatorModule],
                        exports: [IgxForceIndexIndicatorModule],
                        entryComponents: [IgxForceIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FullStochasticOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FullStochasticOscillatorIndicatorStrategy, _super);
        function FullStochasticOscillatorIndicatorStrategy() {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.c = new PercentKCalculationStrategy();
            return _this;
        }
        FullStochasticOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(this.c.b(a, b));
            c.o(b.a.c);
            return c;
        };
        FullStochasticOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = this.c.c(a, b);
            var d = b.a.b(c, a.shortPeriod);
            var e = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a.indicatorColumn.item(e, f);
                    e++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        FullStochasticOscillatorIndicatorStrategy.$t = i2.markType(FullStochasticOscillatorIndicatorStrategy, 'FullStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return FullStochasticOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FullStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FullStochasticOscillatorIndicator, _super);
        function FullStochasticOscillatorIndicator() {
            var _this = _super.call(this) || this;
            _this.trendLineBrush = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            _this.trendLineType = 10;
            _this.trendLinePeriod = 3;
            return _this;
        }
        FullStochasticOscillatorIndicator.prototype.get_tv = function () {
            return new FullStochasticOscillatorIndicatorStrategy();
        };
        Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        FullStochasticOscillatorIndicator.prototype.get_t8 = function () {
            return FullStochasticOscillatorIndicator.$;
        };
        Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(FullStochasticOscillatorIndicator.ul));
            },
            set: function (a) {
                this.h(FullStochasticOscillatorIndicator.ul, a);
            },
            enumerable: false,
            configurable: true
        });
        FullStochasticOscillatorIndicator.prototype.t1 = function () {
            return this.ug;
        };
        FullStochasticOscillatorIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "smoothingPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(FullStochasticOscillatorIndicator.um));
            },
            set: function (a) {
                this.h(FullStochasticOscillatorIndicator.um, a);
            },
            enumerable: false,
            configurable: true
        });
        FullStochasticOscillatorIndicator.prototype.t3 = function () {
            return this.smoothingPeriod;
        };
        Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "ui", {
            get: function () {
                return i2.typeGetValue(this.c(FullStochasticOscillatorIndicator.un));
            },
            set: function (a) {
                this.h(FullStochasticOscillatorIndicator.un, a);
            },
            enumerable: false,
            configurable: true
        });
        FullStochasticOscillatorIndicator.prototype.t0 = function () {
            return this.ui;
        };
        FullStochasticOscillatorIndicator.prototype.tb = function () {
            return this.ui;
        };
        FullStochasticOscillatorIndicator.$t = i2.markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
        FullStochasticOscillatorIndicator.ul = StrategyBasedIndicator.ud(14, FullStochasticOscillatorIndicator.$);
        FullStochasticOscillatorIndicator.um = StrategyBasedIndicator.ue(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
        FullStochasticOscillatorIndicator.un = StrategyBasedIndicator.ue(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
        return FullStochasticOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
     * Default required members: High, Low, Close
    *
    * The `IgxFullStochasticOscillatorIndicatorComponent` class represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-full-stochastic-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close">
    * </gx-full-stochastic-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFullStochasticOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxFullStochasticOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFullStochasticOscillatorIndicatorComponent, _super);
        function IgxFullStochasticOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxFullStochasticOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new FullStochasticOscillatorIndicator();
        };
        Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current FullStochasticOscillatorIndicator object.
             * The typical, and initial, value for FullStochasticOscillatorIndicator periods is 14.
            *
            * You can use the `period` property for the moving average period of the current FullStochasticOscillatorIndicator object.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis
            *     >
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-full-stochastic-oscillator-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            * 	period=30>
            * </gx-full-stochastic-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "smoothingPeriod", {
            /**
             * Gets or sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
             * The typical, and initial, value for FullStochasticOscillatorIndicator SmoothingPeriod is 3.
            *
            * The `smoothingPeriod` property to fets/sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis
            *     >
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-full-stochastic-oscillator-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            * 	[smoothingPeriod]=30>
            * </gx-full-stochastic-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.smoothingPeriod=30;
            * ```
            */
            get: function () {
                return this.i.smoothingPeriod;
            },
            set: function (v) {
                this.i.smoothingPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "triggerPeriod", {
            /**
             * Gets or sets the moving average TriggerPeriod for the current FullStochasticOscillatorIndicator object.
             * The typical, and initial, value for FullStochasticOscillatorIndicator TriggerPeriod is 3.
            *
            * You can use the `period` to set the current moving average period.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis
            *     >
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-full-stochastic-oscillator-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            * 	[triggerPeriod]=30>
            * </gx-full-stochastic-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.triggerPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.ui;
            },
            set: function (v) {
                this.i.ui = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFullStochasticOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFullStochasticOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFullStochasticOscillatorIndicatorComponent, selector: "igx-full-stochastic-oscillator-indicator", inputs: { period: "period", smoothingPeriod: "smoothingPeriod", triggerPeriod: "triggerPeriod" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFullStochasticOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-full-stochastic-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }], smoothingPeriod: [{
                    type: i0.Input
                }], triggerPeriod: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFullStochasticOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFullStochasticOscillatorIndicatorModule() {
        }
        IgxFullStochasticOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFullStochasticOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorModule, declarations: [IgxFullStochasticOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxFullStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxFullStochasticOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxFullStochasticOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFullStochasticOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxFullStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFullStochasticOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFullStochasticOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxFullStochasticOscillatorIndicatorComponent", IgxFullStochasticOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("FullStochasticOscillatorIndicator", FullStochasticOscillatorIndicator.$type);
        }
        IgxFullStochasticOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFullStochasticOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxFullStochasticOscillatorIndicatorModule], exports: [IgxFullStochasticOscillatorIndicatorModule] });
        IgxFullStochasticOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxFullStochasticOscillatorIndicatorModule], IgxFullStochasticOscillatorIndicatorModule] });
        return IgxFullStochasticOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFullStochasticOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxFullStochasticOscillatorIndicatorModule],
                        exports: [IgxFullStochasticOscillatorIndicatorModule],
                        entryComponents: [IgxFullStochasticOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Financial indicator base class for doing calculating an itemwize indicator.
     * An itemwise indicator's individual values don't depend on any other values in the
     * collection so can always be independently recalculated. Also, because of this, the
     * base class handles all the looping logic and inheritors only need to provide the
     * actual calculation.
    */
    var IgxItemwiseStrategyBasedIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxItemwiseStrategyBasedIndicatorComponent, _super);
        function IgxItemwiseStrategyBasedIndicatorComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxItemwiseStrategyBasedIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxItemwiseStrategyBasedIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemwiseStrategyBasedIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxItemwiseStrategyBasedIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxItemwiseStrategyBasedIndicatorComponent, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxItemwiseStrategyBasedIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemwiseStrategyBasedIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemwiseStrategyCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemwiseStrategyCalculationStrategy, _super);
        function ItemwiseStrategyCalculationStrategy() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            return _this;
        }
        ItemwiseStrategyCalculationStrategy.prototype.b = function (a, b) {
            return this.c.b(a, b);
        };
        ItemwiseStrategyCalculationStrategy.prototype.a = function (a, b) {
            var c = true;
            for (var d = a.calculateFrom; d < a.calculateFrom + a.calculateCount; d++) {
                c = this.c.a(a, b, d);
                if (!c) {
                    return false;
                }
            }
            return c;
        };
        ItemwiseStrategyCalculationStrategy.$t = i2.markType(ItemwiseStrategyCalculationStrategy, 'ItemwiseStrategyCalculationStrategy', IndicatorCalculationStrategy.$);
        return ItemwiseStrategyCalculationStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemwiseStrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemwiseStrategyBasedIndicator, _super);
        function ItemwiseStrategyBasedIndicator() {
            return _super.call(this) || this;
        }
        ItemwiseStrategyBasedIndicator.prototype.get_tv = function () {
            return new ItemwiseStrategyCalculationStrategy();
        };
        Object.defineProperty(ItemwiseStrategyBasedIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        ItemwiseStrategyBasedIndicator.prototype.t9 = function () {
            _super.prototype.t9.call(this);
            this.ug = this.uh;
            this.tu.c = this.ug;
        };
        ItemwiseStrategyBasedIndicator.$t = i2.markType(ItemwiseStrategyBasedIndicator, 'ItemwiseStrategyBasedIndicator', StrategyBasedIndicator.$);
        return ItemwiseStrategyBasedIndicator;
    }(StrategyBasedIndicator));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemwiseIndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemwiseIndicatorCalculationStrategy, _super);
        function ItemwiseIndicatorCalculationStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ItemwiseIndicatorCalculationStrategy.$t = i2.markType(ItemwiseIndicatorCalculationStrategy, 'ItemwiseIndicatorCalculationStrategy');
        return ItemwiseIndicatorCalculationStrategy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarketFacilitationIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarketFacilitationIndexIndicatorStrategy, _super);
        function MarketFacilitationIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MarketFacilitationIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.add("VolumeColumn");
            return c;
        };
        MarketFacilitationIndexIndicatorStrategy.prototype.a = function (a, b, c) {
            a.indicatorColumn.item(c, b.i((a.highColumn.item(c) - a.lowColumn.item(c)) / a.volumeColumn.item(c)));
            return true;
        };
        MarketFacilitationIndexIndicatorStrategy.$t = i2.markType(MarketFacilitationIndexIndicatorStrategy, 'MarketFacilitationIndexIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
        return MarketFacilitationIndexIndicatorStrategy;
    }(ItemwiseIndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarketFacilitationIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarketFacilitationIndexIndicator, _super);
        function MarketFacilitationIndexIndicator() {
            return _super.call(this) || this;
        }
        MarketFacilitationIndexIndicator.prototype.get_s2 = function () {
            return 1;
        };
        MarketFacilitationIndexIndicator.prototype.get_uh = function () {
            return new MarketFacilitationIndexIndicatorStrategy();
        };
        Object.defineProperty(MarketFacilitationIndexIndicator.prototype, "uh", {
            get: function () {
                return this.get_uh();
            },
            enumerable: false,
            configurable: true
        });
        MarketFacilitationIndexIndicator.prototype.get_t8 = function () {
            return MarketFacilitationIndexIndicator.$;
        };
        Object.defineProperty(MarketFacilitationIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        MarketFacilitationIndexIndicator.$t = i2.markType(MarketFacilitationIndexIndicator, 'MarketFacilitationIndexIndicator', ItemwiseStrategyBasedIndicator.$);
        return MarketFacilitationIndexIndicator;
    }(ItemwiseStrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Market Facilitation Index indicator series.
     * The Market Facilitation Index (MFI) indicator is represented by
     * the difference of the high and the low for a bar divided by the volume.
     * Default required members: High, Low, Volume
    *
    * The Market Facilitation Index (MFI) indicator is represented by the difference of the high and the low for a bar divided by the volume.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-market-facilitation-index-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume">
    *     </igx-market-facilitation-index-indicator>
    * </igx-data-chart>
    * ```
    */
    var IgxMarketFacilitationIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMarketFacilitationIndexIndicatorComponent, _super);
        function IgxMarketFacilitationIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxMarketFacilitationIndexIndicatorComponent.prototype.createImplementation = function () {
            return new MarketFacilitationIndexIndicator();
        };
        Object.defineProperty(IgxMarketFacilitationIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMarketFacilitationIndexIndicatorComponent.prototype, "defaultDisplayType", {
            /**
             * Gets default display type for the current Financial Indicator
            */
            get: function () {
                return this.i.s2;
            },
            enumerable: false,
            configurable: true
        });
        IgxMarketFacilitationIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxMarketFacilitationIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxMarketFacilitationIndexIndicatorComponent, selector: "igx-market-facilitation-index-indicator", providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxMarketFacilitationIndexIndicatorComponent;
    }(IgxItemwiseStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-market-facilitation-index-indicator',
                        template: "",
                        providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMarketFacilitationIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMarketFacilitationIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMarketFacilitationIndexIndicatorModule() {
        }
        IgxMarketFacilitationIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMarketFacilitationIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorModule, declarations: [IgxMarketFacilitationIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxMarketFacilitationIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxMarketFacilitationIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxMarketFacilitationIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxMarketFacilitationIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxMarketFacilitationIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMarketFacilitationIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMarketFacilitationIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxMarketFacilitationIndexIndicatorComponent", IgxMarketFacilitationIndexIndicatorComponent);
            i2.TypeRegistrar.register("MarketFacilitationIndexIndicator", MarketFacilitationIndexIndicator.$type);
        }
        IgxMarketFacilitationIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMarketFacilitationIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxMarketFacilitationIndexIndicatorModule], exports: [IgxMarketFacilitationIndexIndicatorModule] });
        IgxMarketFacilitationIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxMarketFacilitationIndexIndicatorModule], IgxMarketFacilitationIndexIndicatorModule] });
        return IgxMarketFacilitationIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMarketFacilitationIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxMarketFacilitationIndexIndicatorModule],
                        exports: [IgxMarketFacilitationIndexIndicatorModule],
                        entryComponents: [IgxMarketFacilitationIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MassIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MassIndexIndicatorStrategy, _super);
        function MassIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MassIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.o(b.a.c);
            return c;
        };
        MassIndexIndicatorStrategy.prototype.c = function (a, b) {
            var c = new i2.List$1(i2.Number_$type, 0);
            for (var d = 0; d < (Math.min(a.count, b.count)); d++) {
                c.add(a.item(d) - b.item(d));
            }
            return c;
        };
        MassIndexIndicatorStrategy.prototype.a = function (a, b) {
            var c = 9;
            var d = a.highColumn;
            var e = a.lowColumn;
            var f = a.indicatorColumn;
            var g = i2.getEnumerator(b.a.b(this.c(d, e), c));
            var h = i2.getEnumerator(b.a.b(b.a.b(this.c(d, e), c), c));
            var i = new Array(c);
            for (var j = 0; j < c; j++) {
                i[j] = 0;
            }
            var k = 0;
            for (var l = 0; l < f.count; l++) {
                var m = l % c;
                k -= i[m];
                g.moveNext();
                h.moveNext();
                var n = b.i(g.current / h.current);
                k += n;
                f.item(l, k);
                i[m] = n;
            }
            return true;
        };
        MassIndexIndicatorStrategy.$t = i2.markType(MassIndexIndicatorStrategy, 'MassIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return MassIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MassIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MassIndexIndicator, _super);
        function MassIndexIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MassIndexIndicator.prototype.get_tv = function () {
            return new MassIndexIndicatorStrategy();
        };
        Object.defineProperty(MassIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        MassIndexIndicator.prototype.get_t8 = function () {
            return MassIndexIndicator.$;
        };
        Object.defineProperty(MassIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        MassIndexIndicator.$t = i2.markType(MassIndexIndicator, 'MassIndexIndicator', StrategyBasedIndicator.$);
        return MassIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Mass Index indicator series.
     * Default required members: High, Low
    *
    * Represents a Ignite UIDataChart Mass Index indicator series.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-mass-index-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume">
    *     </igx-mass-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxMassIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.volumeMemberPath= "volume";
    * this.chart.series.add(series);
    * ```
    */
    var IgxMassIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMassIndexIndicatorComponent, _super);
        function IgxMassIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxMassIndexIndicatorComponent.prototype.createImplementation = function () {
            return new MassIndexIndicator();
        };
        Object.defineProperty(IgxMassIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxMassIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxMassIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxMassIndexIndicatorComponent, selector: "igx-mass-index-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxMassIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-mass-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMassIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMassIndexIndicatorModule() {
        }
        IgxMassIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMassIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorModule, declarations: [IgxMassIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxMassIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxMassIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxMassIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxMassIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxMassIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMassIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMassIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxMassIndexIndicatorComponent", IgxMassIndexIndicatorComponent);
            i2.TypeRegistrar.register("MassIndexIndicator", MassIndexIndicator.$type);
        }
        IgxMassIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMassIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxMassIndexIndicatorModule], exports: [IgxMassIndexIndicatorModule] });
        IgxMassIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxMassIndexIndicatorModule], IgxMassIndexIndicatorModule] });
        return IgxMassIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMassIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxMassIndexIndicatorModule],
                        exports: [IgxMassIndexIndicatorModule],
                        entryComponents: [IgxMassIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MedianPriceIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MedianPriceIndicatorStrategy, _super);
        function MedianPriceIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MedianPriceIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            return c;
        };
        MedianPriceIndicatorStrategy.prototype.a = function (a, b, c) {
            a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c)) / 2);
            return true;
        };
        MedianPriceIndicatorStrategy.$t = i2.markType(MedianPriceIndicatorStrategy, 'MedianPriceIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
        return MedianPriceIndicatorStrategy;
    }(ItemwiseIndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MedianPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MedianPriceIndicator, _super);
        function MedianPriceIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MedianPriceIndicator.prototype.get_uh = function () {
            return new MedianPriceIndicatorStrategy();
        };
        Object.defineProperty(MedianPriceIndicator.prototype, "uh", {
            get: function () {
                return this.get_uh();
            },
            enumerable: false,
            configurable: true
        });
        MedianPriceIndicator.prototype.get_t8 = function () {
            return MedianPriceIndicator.$;
        };
        Object.defineProperty(MedianPriceIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        MedianPriceIndicator.$t = i2.markType(MedianPriceIndicator, 'MedianPriceIndicator', ItemwiseStrategyBasedIndicator.$);
        return MedianPriceIndicator;
    }(ItemwiseStrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Median Price indicator series.
     * Default required members: High, Low
    *
    * Represents a Ignite UIDataChart Median Price indicator series.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-median-price-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume">
    *     </igx-median-price-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxMedianPriceIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.volumeMemberPath= "volume";
    * this.chart.series.add(series);
    * ```
    */
    var IgxMedianPriceIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMedianPriceIndicatorComponent, _super);
        function IgxMedianPriceIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxMedianPriceIndicatorComponent.prototype.createImplementation = function () {
            return new MedianPriceIndicator();
        };
        Object.defineProperty(IgxMedianPriceIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxMedianPriceIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxMedianPriceIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxMedianPriceIndicatorComponent, selector: "igx-median-price-indicator", providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxMedianPriceIndicatorComponent;
    }(IgxItemwiseStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-median-price-indicator',
                        template: "",
                        providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMedianPriceIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMedianPriceIndicatorModule() {
        }
        IgxMedianPriceIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMedianPriceIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorModule, declarations: [IgxMedianPriceIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxMedianPriceIndicatorComponent, IgxIndicatorProxyModule] });
        IgxMedianPriceIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxMedianPriceIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxMedianPriceIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxMedianPriceIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMedianPriceIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMedianPriceIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxMedianPriceIndicatorComponent", IgxMedianPriceIndicatorComponent);
            i2.TypeRegistrar.register("MedianPriceIndicator", MedianPriceIndicator.$type);
        }
        IgxMedianPriceIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMedianPriceIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorDynamicModule, imports: [i1.CommonModule, IgxMedianPriceIndicatorModule], exports: [IgxMedianPriceIndicatorModule] });
        IgxMedianPriceIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorDynamicModule, imports: [[i1.CommonModule, IgxMedianPriceIndicatorModule], IgxMedianPriceIndicatorModule] });
        return IgxMedianPriceIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMedianPriceIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxMedianPriceIndicatorModule],
                        exports: [IgxMedianPriceIndicatorModule],
                        entryComponents: [IgxMedianPriceIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MoneyFlowIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MoneyFlowIndexIndicatorStrategy, _super);
        function MoneyFlowIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MoneyFlowIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.typicalColumn.basedOn);
            c.add("VolumeColumn");
            return c;
        };
        MoneyFlowIndexIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.typicalColumn.getEnumerator();
            var d = i2.getEnumerator(a.volumeColumn);
            var e = a.period;
            var f = 0;
            var g = new Array(e);
            for (f = 0; f < e; f++) {
                g[f] = 0;
            }
            var h = 0;
            var i = new Array(e);
            for (f = 0; f < e; f++) {
                i[f] = 0;
            }
            var j = 0;
            var k = 0;
            f = 0;
            while (c.moveNext() && d.moveNext()) {
                var l = f % e;
                var m = c.current * d.current;
                h -= g[l];
                j -= i[l];
                switch (Math.sign(m - k)) {
                    case -1:
                        g[l] = 0;
                        i[l] = m;
                        break;
                    case 0:
                        g[l] = 0;
                        i[l] = 0;
                        break;
                    case 1:
                        g[l] = m;
                        i[l] = 0;
                        break;
                }
                h += g[l];
                j += i[l];
                var n = b.i(100 * h / (h + j));
                a.indicatorColumn.item(f, n);
                k = m;
                ++f;
            }
            return true;
        };
        MoneyFlowIndexIndicatorStrategy.$t = i2.markType(MoneyFlowIndexIndicatorStrategy, 'MoneyFlowIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return MoneyFlowIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MoneyFlowIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MoneyFlowIndexIndicator, _super);
        function MoneyFlowIndexIndicator() {
            return _super.call(this) || this;
        }
        MoneyFlowIndexIndicator.prototype.get_s2 = function () {
            return 1;
        };
        MoneyFlowIndexIndicator.prototype.get_tv = function () {
            return new MoneyFlowIndexIndicatorStrategy();
        };
        Object.defineProperty(MoneyFlowIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        MoneyFlowIndexIndicator.prototype.get_t8 = function () {
            return MoneyFlowIndexIndicator.$;
        };
        Object.defineProperty(MoneyFlowIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MoneyFlowIndexIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(MoneyFlowIndexIndicator.uh));
            },
            set: function (a) {
                this.h(MoneyFlowIndexIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        MoneyFlowIndexIndicator.prototype.t1 = function () {
            return this.ug;
        };
        MoneyFlowIndexIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        MoneyFlowIndexIndicator.$t = i2.markType(MoneyFlowIndexIndicator, 'MoneyFlowIndexIndicator', StrategyBasedIndicator.$);
        MoneyFlowIndexIndicator.uh = StrategyBasedIndicator.ud(14, MoneyFlowIndexIndicator.$);
        return MoneyFlowIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Money Flow Index indicator series.
     * Default required members: Close, Low, High, Volume
    *
    * Represents a Ignite UIDataChart Money Flow Index indicator series.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-money-flow-index-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    * 		openMemberPath="open"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		volumeMemberPath="volume">
    *     </igx-money-flow-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxMoneyFlowIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath="open"
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath="close"
    * series.volumeMemberPath= "volume";
    * this.chart.series.add(series);
    * ```
    */
    var IgxMoneyFlowIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMoneyFlowIndexIndicatorComponent, _super);
        function IgxMoneyFlowIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxMoneyFlowIndexIndicatorComponent.prototype.createImplementation = function () {
            return new MoneyFlowIndexIndicator();
        };
        Object.defineProperty(IgxMoneyFlowIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMoneyFlowIndexIndicatorComponent.prototype, "defaultDisplayType", {
            /**
             * Gets default display type for the current Financial Indicator
            */
            get: function () {
                return this.i.s2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMoneyFlowIndexIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current MoneyFlowIndexIndicator object.
             * The typical, and initial, value for MoneyFlowIndexIndicator periods is 14.
            *
            * Gets or sets the moving average period for the current MoneyFlowIndexIndicator object.
            *
            * Example:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * 	<igx-money-flow-index-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            * 		openMemberPath="open"
            *         highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		volumeMemberPath="volume"
            * 		period="14">
            *     </igx-money-flow-index-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 14;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxMoneyFlowIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxMoneyFlowIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxMoneyFlowIndexIndicatorComponent, selector: "igx-money-flow-index-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxMoneyFlowIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-money-flow-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMoneyFlowIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMoneyFlowIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMoneyFlowIndexIndicatorModule() {
        }
        IgxMoneyFlowIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMoneyFlowIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorModule, declarations: [IgxMoneyFlowIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxMoneyFlowIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxMoneyFlowIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxMoneyFlowIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxMoneyFlowIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxMoneyFlowIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMoneyFlowIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMoneyFlowIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxMoneyFlowIndexIndicatorComponent", IgxMoneyFlowIndexIndicatorComponent);
            i2.TypeRegistrar.register("MoneyFlowIndexIndicator", MoneyFlowIndexIndicator.$type);
        }
        IgxMoneyFlowIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMoneyFlowIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxMoneyFlowIndexIndicatorModule], exports: [IgxMoneyFlowIndexIndicatorModule] });
        IgxMoneyFlowIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxMoneyFlowIndexIndicatorModule], IgxMoneyFlowIndexIndicatorModule] });
        return IgxMoneyFlowIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMoneyFlowIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxMoneyFlowIndexIndicatorModule],
                        exports: [IgxMoneyFlowIndexIndicatorModule],
                        entryComponents: [IgxMoneyFlowIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MovingAverageConvergenceDivergenceIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MovingAverageConvergenceDivergenceIndicatorStrategy, _super);
        function MovingAverageConvergenceDivergenceIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MovingAverageConvergenceDivergenceIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.typicalColumn.basedOn);
            c.o(b.a.c);
            return c;
        };
        MovingAverageConvergenceDivergenceIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.typicalColumn;
            var d = a.indicatorColumn;
            var e = a.shortPeriod;
            var f = a.longPeriod;
            var g = i2.getEnumerator(b.a.b(c, e));
            var h = i2.getEnumerator(b.a.b(c, f));
            var i = 0;
            while (g.moveNext() && h.moveNext()) {
                var j = b.i(g.current - h.current);
                d.item(i, j);
                i++;
            }
            return true;
        };
        MovingAverageConvergenceDivergenceIndicatorStrategy.$t = i2.markType(MovingAverageConvergenceDivergenceIndicatorStrategy, 'MovingAverageConvergenceDivergenceIndicatorStrategy', IndicatorCalculationStrategy.$);
        return MovingAverageConvergenceDivergenceIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MovingAverageConvergenceDivergenceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MovingAverageConvergenceDivergenceIndicator, _super);
        function MovingAverageConvergenceDivergenceIndicator() {
            var _this = _super.call(this) || this;
            _this.trendLineBrush = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            _this.trendLineType = 10;
            _this.trendLinePeriod = 9;
            return _this;
        }
        MovingAverageConvergenceDivergenceIndicator.prototype.get_s2 = function () {
            return 1;
        };
        MovingAverageConvergenceDivergenceIndicator.prototype.get_tv = function () {
            return new MovingAverageConvergenceDivergenceIndicatorStrategy();
        };
        Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        MovingAverageConvergenceDivergenceIndicator.prototype.get_t8 = function () {
            return MovingAverageConvergenceDivergenceIndicator.$;
        };
        Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "shortPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.uj));
            },
            set: function (a) {
                this.h(MovingAverageConvergenceDivergenceIndicator.uj, a);
            },
            enumerable: false,
            configurable: true
        });
        MovingAverageConvergenceDivergenceIndicator.prototype.t3 = function () {
            return this.shortPeriod;
        };
        Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "longPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.ui));
            },
            set: function (a) {
                this.h(MovingAverageConvergenceDivergenceIndicator.ui, a);
            },
            enumerable: false,
            configurable: true
        });
        MovingAverageConvergenceDivergenceIndicator.prototype.t0 = function () {
            return this.longPeriod;
        };
        Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "signalPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.uk));
            },
            set: function (a) {
                this.h(MovingAverageConvergenceDivergenceIndicator.uk, a);
            },
            enumerable: false,
            configurable: true
        });
        MovingAverageConvergenceDivergenceIndicator.prototype.tb = function () {
            return this.signalPeriod;
        };
        MovingAverageConvergenceDivergenceIndicator.$t = i2.markType(MovingAverageConvergenceDivergenceIndicator, 'MovingAverageConvergenceDivergenceIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
        MovingAverageConvergenceDivergenceIndicator.uj = StrategyBasedIndicator.uf(10, MovingAverageConvergenceDivergenceIndicator.$);
        MovingAverageConvergenceDivergenceIndicator.ui = StrategyBasedIndicator.ub(30, MovingAverageConvergenceDivergenceIndicator.$);
        MovingAverageConvergenceDivergenceIndicator.uk = StrategyBasedIndicator.ue(9, MovingAverageConvergenceDivergenceIndicator.$, "SignalPeriod");
        return MovingAverageConvergenceDivergenceIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Moving Average Convergence/Divergence (MACD) indicator series.
     * Default required members: High, Low, Close
    *
    * Represents a Ignite UIDataChart Moving Average Convergence/Divergence (MACD) indicator series.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-moving-average-convergence-divergence-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    * 		openMemberPath="open"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		volumeMemberPath="volume">
    *     </gx-moving-average-convergence-divergence-indicatorr>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxMovingAverageConvergenceDivergenceIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath="open"
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath="close"
    * series.volumeMemberPath= "volume";
    * this.chart.series.add(series);
    * ```
    */
    var IgxMovingAverageConvergenceDivergenceIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxMovingAverageConvergenceDivergenceIndicatorComponent, _super);
        function IgxMovingAverageConvergenceDivergenceIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype.createImplementation = function () {
            return new MovingAverageConvergenceDivergenceIndicator();
        };
        Object.defineProperty(IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "defaultDisplayType", {
            /**
             * Gets default display type for the current Financial Indicator
            */
            get: function () {
                return this.i.s2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "shortPeriod", {
            /**
             * Gets or sets the short moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
             * The typical, and initial, value for short MACD periods is 10.
            *
            * Gets or sets the short moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
            *
            * Example:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * 	<igx-moving-average-convergence-divergence-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            * 		openMemberPath="open"
            *         highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		volumeMemberPath="volume"
            * 		shortPeriod="10">
            *     </gx-moving-average-convergence-divergence-indicatorr>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.shortPeriod;
            },
            set: function (v) {
                this.i.shortPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "longPeriod", {
            /**
             * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
             * The typical, and initial, value for long MACD periods is 30.
            *
            * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
            *
            * Example:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * 	<igx-moving-average-convergence-divergence-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            * 		openMemberPath="open"
            *         highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		volumeMemberPath="volume"
            * 		longPeriod="30">
            *     </gx-moving-average-convergence-divergence-indicatorr>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.longPeriod="30" ;
            * ```
            */
            get: function () {
                return this.i.longPeriod;
            },
            set: function (v) {
                this.i.longPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "signalPeriod", {
            /**
             * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
             * The typical, and initial, value for long PVO periods is 30.
            *
            * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
            *
            * Example:
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * 	<igx-moving-average-convergence-divergence-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            * 		openMemberPath="open"
            *         highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		volumeMemberPath="volume"
            * 		signalPeriod="30">
            *     </gx-moving-average-convergence-divergence-indicatorr>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.signalPeriod;
            },
            set: function (v) {
                this.i.signalPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxMovingAverageConvergenceDivergenceIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxMovingAverageConvergenceDivergenceIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxMovingAverageConvergenceDivergenceIndicatorComponent, selector: "igx-moving-average-convergence-divergence-indicator", inputs: { shortPeriod: "shortPeriod", longPeriod: "longPeriod", signalPeriod: "signalPeriod" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxMovingAverageConvergenceDivergenceIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-moving-average-convergence-divergence-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxMovingAverageConvergenceDivergenceIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shortPeriod: [{
                    type: i0.Input
                }], longPeriod: [{
                    type: i0.Input
                }], signalPeriod: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMovingAverageConvergenceDivergenceIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMovingAverageConvergenceDivergenceIndicatorModule() {
        }
        IgxMovingAverageConvergenceDivergenceIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMovingAverageConvergenceDivergenceIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorModule, declarations: [IgxMovingAverageConvergenceDivergenceIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxMovingAverageConvergenceDivergenceIndicatorComponent, IgxIndicatorProxyModule] });
        IgxMovingAverageConvergenceDivergenceIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxMovingAverageConvergenceDivergenceIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxMovingAverageConvergenceDivergenceIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxMovingAverageConvergenceDivergenceIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxMovingAverageConvergenceDivergenceIndicatorComponent", IgxMovingAverageConvergenceDivergenceIndicatorComponent);
            i2.TypeRegistrar.register("MovingAverageConvergenceDivergenceIndicator", MovingAverageConvergenceDivergenceIndicator.$type);
        }
        IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule, imports: [i1.CommonModule, IgxMovingAverageConvergenceDivergenceIndicatorModule], exports: [IgxMovingAverageConvergenceDivergenceIndicatorModule] });
        IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule, imports: [[i1.CommonModule, IgxMovingAverageConvergenceDivergenceIndicatorModule], IgxMovingAverageConvergenceDivergenceIndicatorModule] });
        return IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxMovingAverageConvergenceDivergenceIndicatorModule],
                        exports: [IgxMovingAverageConvergenceDivergenceIndicatorModule],
                        entryComponents: [IgxMovingAverageConvergenceDivergenceIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NegativeVolumeIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NegativeVolumeIndexIndicatorStrategy, _super);
        function NegativeVolumeIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NegativeVolumeIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.add("VolumeColumn");
            return c;
        };
        NegativeVolumeIndexIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.closeColumn;
            var d = a.volumeColumn;
            var e = a.indicatorColumn;
            var f = 0;
            var g = 0;
            var h = 0;
            if (e.count > 0) {
                e.item(0, f);
            }
            for (var i = 1; i < e.count; i++) {
                if (d.item(i) < d.item(i - 1)) {
                    g = b.i((c.item(i) - c.item(i - 1)) / c.item(i - 1));
                    if (h != 0) {
                        f += g * h;
                    }
                    else {
                        f += g;
                    }
                }
                e.item(i, f);
                h = f;
            }
            return true;
        };
        NegativeVolumeIndexIndicatorStrategy.$t = i2.markType(NegativeVolumeIndexIndicatorStrategy, 'NegativeVolumeIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return NegativeVolumeIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NegativeVolumeIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NegativeVolumeIndexIndicator, _super);
        function NegativeVolumeIndexIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NegativeVolumeIndexIndicator.prototype.get_tv = function () {
            return new NegativeVolumeIndexIndicatorStrategy();
        };
        Object.defineProperty(NegativeVolumeIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        NegativeVolumeIndexIndicator.prototype.get_t8 = function () {
            return NegativeVolumeIndexIndicator.$;
        };
        Object.defineProperty(NegativeVolumeIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        NegativeVolumeIndexIndicator.$t = i2.markType(NegativeVolumeIndexIndicator, 'NegativeVolumeIndexIndicator', StrategyBasedIndicator.$);
        return NegativeVolumeIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Negative Volume Index indicator (NVI) series.
     * Default required members: Close, Volume
    *
    * The `IgxNegativeVolumeIndexIndicatorComponent` (NVI) is a finacial indicator frequently used in combination with the PositiveVolumeIndexIndicator. This calculation can be used to identify bull markets. These two indicators are based on the premise that smart money trades on low volume days and less informed or overly optimistic investors trade on high volume days.
    *
    * Using this indicator requires setting both the `CloseMemberPath` and `VolumeMemberPath`.
    *
    * ```html
    * <igx-data-chart
    *     width=500px
    *     height=500px
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *         dateTimeMemberPath="TimeStamp"
    *         #xAxis>
    *       </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *        #yAxis></igx-numeric-y-axis>
    *     <igx-negative-volume-index-indicator
    *        [xAxis]="xAxis"
    *        [yAxis]="yAxis"
    *        volumeMemberPath="volume"
    *        closeMemberPath="close">
    *     </igx-negative-volume-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxNegativeVolumeIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.closeMemberPath = "Close";
    * series.volumeMemberPath = "Volume";
    * series.dataSource = this.data;
    * this.chart.series.add(series);
    * ```
    */
    var IgxNegativeVolumeIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxNegativeVolumeIndexIndicatorComponent, _super);
        function IgxNegativeVolumeIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxNegativeVolumeIndexIndicatorComponent.prototype.createImplementation = function () {
            return new NegativeVolumeIndexIndicator();
        };
        Object.defineProperty(IgxNegativeVolumeIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxNegativeVolumeIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxNegativeVolumeIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxNegativeVolumeIndexIndicatorComponent, selector: "igx-negative-volume-index-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxNegativeVolumeIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-negative-volume-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxNegativeVolumeIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNegativeVolumeIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNegativeVolumeIndexIndicatorModule() {
        }
        IgxNegativeVolumeIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNegativeVolumeIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorModule, declarations: [IgxNegativeVolumeIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxNegativeVolumeIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxNegativeVolumeIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxNegativeVolumeIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxNegativeVolumeIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxNegativeVolumeIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNegativeVolumeIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNegativeVolumeIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxNegativeVolumeIndexIndicatorComponent", IgxNegativeVolumeIndexIndicatorComponent);
            i2.TypeRegistrar.register("NegativeVolumeIndexIndicator", NegativeVolumeIndexIndicator.$type);
        }
        IgxNegativeVolumeIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNegativeVolumeIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxNegativeVolumeIndexIndicatorModule], exports: [IgxNegativeVolumeIndexIndicatorModule] });
        IgxNegativeVolumeIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxNegativeVolumeIndexIndicatorModule], IgxNegativeVolumeIndexIndicatorModule] });
        return IgxNegativeVolumeIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNegativeVolumeIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxNegativeVolumeIndexIndicatorModule],
                        exports: [IgxNegativeVolumeIndexIndicatorModule],
                        entryComponents: [IgxNegativeVolumeIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OnBalanceVolumeIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OnBalanceVolumeIndicatorStrategy, _super);
        function OnBalanceVolumeIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        OnBalanceVolumeIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.add("VolumeColumn");
            return c;
        };
        OnBalanceVolumeIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.closeColumn;
            var d = a.volumeColumn;
            var e = a.indicatorColumn;
            var f = 0;
            if (c != null && d != null) {
                f = Math.min(c.count, d.count);
            }
            var g = 0;
            if (f > 0) {
                g = d.item(0);
                e.item(0, g);
            }
            for (var h = 1; h < f; ++h) {
                switch (Math.sign(c.item(h) - c.item(h - 1))) {
                    case -1:
                        g -= d.item(h);
                        break;
                    case 1:
                        g += d.item(h);
                        break;
                }
                e.item(h, g);
            }
            return true;
        };
        OnBalanceVolumeIndicatorStrategy.$t = i2.markType(OnBalanceVolumeIndicatorStrategy, 'OnBalanceVolumeIndicatorStrategy', IndicatorCalculationStrategy.$);
        return OnBalanceVolumeIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OnBalanceVolumeIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OnBalanceVolumeIndicator, _super);
        function OnBalanceVolumeIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        OnBalanceVolumeIndicator.prototype.get_tv = function () {
            return new OnBalanceVolumeIndicatorStrategy();
        };
        Object.defineProperty(OnBalanceVolumeIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        OnBalanceVolumeIndicator.prototype.get_t8 = function () {
            return OnBalanceVolumeIndicator.$;
        };
        Object.defineProperty(OnBalanceVolumeIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        OnBalanceVolumeIndicator.$t = i2.markType(OnBalanceVolumeIndicator, 'OnBalanceVolumeIndicator', StrategyBasedIndicator.$);
        return OnBalanceVolumeIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent On Balance Bolume indicator series.
     * Default required members: Close, Volume
    *
    * You can use the `IgxOnBalanceVolumeIndicatorComponent` to calculate a running total of sales volume for a stock.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-on-balance-volume-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-on-balance-volume-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxOnBalanceVolumeIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxOnBalanceVolumeIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxOnBalanceVolumeIndicatorComponent, _super);
        function IgxOnBalanceVolumeIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxOnBalanceVolumeIndicatorComponent.prototype.createImplementation = function () {
            return new OnBalanceVolumeIndicator();
        };
        Object.defineProperty(IgxOnBalanceVolumeIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxOnBalanceVolumeIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxOnBalanceVolumeIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxOnBalanceVolumeIndicatorComponent, selector: "igx-on-balance-volume-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxOnBalanceVolumeIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-on-balance-volume-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOnBalanceVolumeIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOnBalanceVolumeIndicatorModule() {
        }
        IgxOnBalanceVolumeIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOnBalanceVolumeIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorModule, declarations: [IgxOnBalanceVolumeIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxOnBalanceVolumeIndicatorComponent, IgxIndicatorProxyModule] });
        IgxOnBalanceVolumeIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxOnBalanceVolumeIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxOnBalanceVolumeIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxOnBalanceVolumeIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOnBalanceVolumeIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOnBalanceVolumeIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxOnBalanceVolumeIndicatorComponent", IgxOnBalanceVolumeIndicatorComponent);
            i2.TypeRegistrar.register("OnBalanceVolumeIndicator", OnBalanceVolumeIndicator.$type);
        }
        IgxOnBalanceVolumeIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOnBalanceVolumeIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorDynamicModule, imports: [i1.CommonModule, IgxOnBalanceVolumeIndicatorModule], exports: [IgxOnBalanceVolumeIndicatorModule] });
        IgxOnBalanceVolumeIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorDynamicModule, imports: [[i1.CommonModule, IgxOnBalanceVolumeIndicatorModule], IgxOnBalanceVolumeIndicatorModule] });
        return IgxOnBalanceVolumeIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOnBalanceVolumeIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxOnBalanceVolumeIndicatorModule],
                        exports: [IgxOnBalanceVolumeIndicatorModule],
                        entryComponents: [IgxOnBalanceVolumeIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentagePriceOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentagePriceOscillatorIndicatorStrategy, _super);
        function PercentagePriceOscillatorIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PercentagePriceOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(b.g.c);
            c.o(b.e.c);
            return c;
        };
        PercentagePriceOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.indicatorColumn;
            var d = i2.getEnumerator(b.g.b(a));
            var e = i2.getEnumerator(b.e.b(a));
            var f = 0;
            while (d.moveNext() && e.moveNext()) {
                var g = b.i(100 * (d.current - e.current) / e.current);
                c.item(f, g);
                ++f;
            }
            return true;
        };
        PercentagePriceOscillatorIndicatorStrategy.$t = i2.markType(PercentagePriceOscillatorIndicatorStrategy, 'PercentagePriceOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return PercentagePriceOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentagePriceOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentagePriceOscillatorIndicator, _super);
        function PercentagePriceOscillatorIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PercentagePriceOscillatorIndicator.prototype.get_tv = function () {
            return new PercentagePriceOscillatorIndicatorStrategy();
        };
        Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        PercentagePriceOscillatorIndicator.prototype.get_t8 = function () {
            return PercentagePriceOscillatorIndicator.$;
        };
        Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "shortPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(PercentagePriceOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(PercentagePriceOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        PercentagePriceOscillatorIndicator.prototype.t3 = function () {
            return this.shortPeriod;
        };
        Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "longPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(PercentagePriceOscillatorIndicator.ug));
            },
            set: function (a) {
                this.h(PercentagePriceOscillatorIndicator.ug, a);
            },
            enumerable: false,
            configurable: true
        });
        PercentagePriceOscillatorIndicator.prototype.t0 = function () {
            return this.longPeriod;
        };
        PercentagePriceOscillatorIndicator.$t = i2.markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
        PercentagePriceOscillatorIndicator.uh = StrategyBasedIndicator.uf(10, PercentagePriceOscillatorIndicator.$);
        PercentagePriceOscillatorIndicator.ug = StrategyBasedIndicator.ub(30, PercentagePriceOscillatorIndicator.$);
        return PercentagePriceOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent percentage price oscillator series.
     * Default required members: High, Low, Volume
    *
    * You can use the `IgxPercentagePriceOscillatorIndicatorComponent` to show the difference between two moving averages.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-percentage-price-oscillator-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-percentage-price-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxPercentagePriceOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxPercentagePriceOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPercentagePriceOscillatorIndicatorComponent, _super);
        function IgxPercentagePriceOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxPercentagePriceOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new PercentagePriceOscillatorIndicator();
        };
        Object.defineProperty(IgxPercentagePriceOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPercentagePriceOscillatorIndicatorComponent.prototype, "shortPeriod", {
            /**
             * Gets or sets the short moving average period for the current PercentagePriceOscillatorIndicator object.
             * The typical, and initial, value for short PPO periods is 10.
            *
            * You can use the `shortPeriod` to set the short moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-percentage-price-oscillator-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		shortPeriod="10">
            *     </igx-percentage-price-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shortPeriod = 10;
            * ```
            */
            get: function () {
                return this.i.shortPeriod;
            },
            set: function (v) {
                this.i.shortPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPercentagePriceOscillatorIndicatorComponent.prototype, "longPeriod", {
            /**
             * Gets or sets the long moving average period for the current PercentagePriceOscillatorIndicator object.
             * The typical, and initial, value for long PVO periods is 30.
            *
            * You can use the `longPeriod` to set the long moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-percentage-price-oscillator-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		longPeriod="30">
            *     </igx-percentage-price-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.longPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.longPeriod;
            },
            set: function (v) {
                this.i.longPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPercentagePriceOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPercentagePriceOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPercentagePriceOscillatorIndicatorComponent, selector: "igx-percentage-price-oscillator-indicator", inputs: { shortPeriod: "shortPeriod", longPeriod: "longPeriod" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPercentagePriceOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-percentage-price-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentagePriceOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shortPeriod: [{
                    type: i0.Input
                }], longPeriod: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPercentagePriceOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPercentagePriceOscillatorIndicatorModule() {
        }
        IgxPercentagePriceOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPercentagePriceOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorModule, declarations: [IgxPercentagePriceOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxPercentagePriceOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxPercentagePriceOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxPercentagePriceOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPercentagePriceOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxPercentagePriceOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPercentagePriceOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPercentagePriceOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPercentagePriceOscillatorIndicatorComponent", IgxPercentagePriceOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("PercentagePriceOscillatorIndicator", PercentagePriceOscillatorIndicator.$type);
        }
        IgxPercentagePriceOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPercentagePriceOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxPercentagePriceOscillatorIndicatorModule], exports: [IgxPercentagePriceOscillatorIndicatorModule] });
        IgxPercentagePriceOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxPercentagePriceOscillatorIndicatorModule], IgxPercentagePriceOscillatorIndicatorModule] });
        return IgxPercentagePriceOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentagePriceOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPercentagePriceOscillatorIndicatorModule],
                        exports: [IgxPercentagePriceOscillatorIndicatorModule],
                        entryComponents: [IgxPercentagePriceOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentageVolumeOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentageVolumeOscillatorIndicatorStrategy, _super);
        function PercentageVolumeOscillatorIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PercentageVolumeOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(b.h.c);
            c.o(b.f.c);
            return c;
        };
        PercentageVolumeOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var c = i2.getEnumerator(b.h.b(a));
            var d = i2.getEnumerator(b.f.b(a));
            var e = a.indicatorColumn;
            var f = 0;
            while (c.moveNext() && d.moveNext()) {
                var g = b.i(100 * (c.current - d.current) / d.current);
                e.item(f, g);
                ++f;
            }
            return true;
        };
        PercentageVolumeOscillatorIndicatorStrategy.$t = i2.markType(PercentageVolumeOscillatorIndicatorStrategy, 'PercentageVolumeOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return PercentageVolumeOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PercentageVolumeOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PercentageVolumeOscillatorIndicator, _super);
        function PercentageVolumeOscillatorIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PercentageVolumeOscillatorIndicator.prototype.get_tv = function () {
            return new PercentageVolumeOscillatorIndicatorStrategy();
        };
        Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        PercentageVolumeOscillatorIndicator.prototype.get_t8 = function () {
            return PercentageVolumeOscillatorIndicator.$;
        };
        Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "shortPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(PercentageVolumeOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(PercentageVolumeOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        PercentageVolumeOscillatorIndicator.prototype.t3 = function () {
            return this.shortPeriod;
        };
        Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "longPeriod", {
            get: function () {
                return i2.typeGetValue(this.c(PercentageVolumeOscillatorIndicator.ug));
            },
            set: function (a) {
                this.h(PercentageVolumeOscillatorIndicator.ug, a);
            },
            enumerable: false,
            configurable: true
        });
        PercentageVolumeOscillatorIndicator.prototype.t0 = function () {
            return this.longPeriod;
        };
        PercentageVolumeOscillatorIndicator.$t = i2.markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
        PercentageVolumeOscillatorIndicator.uh = StrategyBasedIndicator.uf(10, PercentageVolumeOscillatorIndicator.$);
        PercentageVolumeOscillatorIndicator.ug = StrategyBasedIndicator.ub(30, PercentageVolumeOscillatorIndicator.$);
        return PercentageVolumeOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Percentage Volume Oscillator (PVO) series.
     * Default required members: Volume
    *
    * You can use the `IgxPercentageVolumeOscillatorIndicatorComponent` to show the percentage difference volume.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-percentage-volume-oscillator-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-percentage-volume-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxPercentageVolumeOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxPercentageVolumeOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPercentageVolumeOscillatorIndicatorComponent, _super);
        function IgxPercentageVolumeOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxPercentageVolumeOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new PercentageVolumeOscillatorIndicator();
        };
        Object.defineProperty(IgxPercentageVolumeOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPercentageVolumeOscillatorIndicatorComponent.prototype, "shortPeriod", {
            /**
             * Gets or sets the short moving average period for the current PercentageVolumeOscillatorIndicator object.
             * The typical, and initial, value for short PVO periods is 10.
            *
            * You can use the `shortPeriod` to set the short moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-percentage-volume-oscillator-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		shortPeriod="10">
            *     </igx-percentage-volume-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.shortPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.shortPeriod;
            },
            set: function (v) {
                this.i.shortPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPercentageVolumeOscillatorIndicatorComponent.prototype, "longPeriod", {
            /**
             * Gets or sets the short moving average period for the current PercentageVolumeOscillatorIndicator object.
             * The typical, and initial, value for long PVO periods is 30.
            *
            * You can use the `longPeriod` to set the long moving average period.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-percentage-volume-oscillator-indicator
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		longPeriod="30">
            *     </igx-percentage-volume-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.longPeriod = 30;
            * ```
            */
            get: function () {
                return this.i.longPeriod;
            },
            set: function (v) {
                this.i.longPeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPercentageVolumeOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPercentageVolumeOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPercentageVolumeOscillatorIndicatorComponent, selector: "igx-percentage-volume-oscillator-indicator", inputs: { shortPeriod: "shortPeriod", longPeriod: "longPeriod" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPercentageVolumeOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-percentage-volume-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPercentageVolumeOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shortPeriod: [{
                    type: i0.Input
                }], longPeriod: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPercentageVolumeOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPercentageVolumeOscillatorIndicatorModule() {
        }
        IgxPercentageVolumeOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPercentageVolumeOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorModule, declarations: [IgxPercentageVolumeOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxPercentageVolumeOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxPercentageVolumeOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxPercentageVolumeOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPercentageVolumeOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxPercentageVolumeOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPercentageVolumeOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPercentageVolumeOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPercentageVolumeOscillatorIndicatorComponent", IgxPercentageVolumeOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("PercentageVolumeOscillatorIndicator", PercentageVolumeOscillatorIndicator.$type);
        }
        IgxPercentageVolumeOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPercentageVolumeOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxPercentageVolumeOscillatorIndicatorModule], exports: [IgxPercentageVolumeOscillatorIndicatorModule] });
        IgxPercentageVolumeOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxPercentageVolumeOscillatorIndicatorModule], IgxPercentageVolumeOscillatorIndicatorModule] });
        return IgxPercentageVolumeOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPercentageVolumeOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPercentageVolumeOscillatorIndicatorModule],
                        exports: [IgxPercentageVolumeOscillatorIndicatorModule],
                        entryComponents: [IgxPercentageVolumeOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PositiveVolumeIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PositiveVolumeIndexIndicatorStrategy, _super);
        function PositiveVolumeIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PositiveVolumeIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.add("VolumeColumn");
            return c;
        };
        PositiveVolumeIndexIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.closeColumn;
            var d = a.volumeColumn;
            var e = a.indicatorColumn;
            var f = 0;
            var g = 0;
            var h = 0;
            if (e.count > 0) {
                e.item(0, f);
            }
            for (var i = 1; i < e.count; i++) {
                if (d.item(i) > d.item(i - 1)) {
                    g = b.i((c.item(i) - c.item(i - 1)) / c.item(i - 1));
                    if (h != 0) {
                        f += g * h;
                    }
                    else {
                        f += g;
                    }
                }
                e.item(i, f);
                h = f;
            }
            return true;
        };
        PositiveVolumeIndexIndicatorStrategy.$t = i2.markType(PositiveVolumeIndexIndicatorStrategy, 'PositiveVolumeIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
        return PositiveVolumeIndexIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PositiveVolumeIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PositiveVolumeIndexIndicator, _super);
        function PositiveVolumeIndexIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PositiveVolumeIndexIndicator.prototype.get_tv = function () {
            return new PositiveVolumeIndexIndicatorStrategy();
        };
        Object.defineProperty(PositiveVolumeIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        PositiveVolumeIndexIndicator.prototype.get_t8 = function () {
            return PositiveVolumeIndexIndicator.$;
        };
        Object.defineProperty(PositiveVolumeIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        PositiveVolumeIndexIndicator.$t = i2.markType(PositiveVolumeIndexIndicator, 'PositiveVolumeIndexIndicator', StrategyBasedIndicator.$);
        return PositiveVolumeIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Positive Volume Index (PVI) indicator series.
     * Default required members: Close, Volume
    *
    * You can use the `IgxPositiveVolumeIndexIndicatorComponent` with the 'NegativeVolumeIndexIndicator' to identify bull markets.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-positive-volume-index-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-positive-volume-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxPositiveVolumeIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxPositiveVolumeIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPositiveVolumeIndexIndicatorComponent, _super);
        function IgxPositiveVolumeIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxPositiveVolumeIndexIndicatorComponent.prototype.createImplementation = function () {
            return new PositiveVolumeIndexIndicator();
        };
        Object.defineProperty(IgxPositiveVolumeIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPositiveVolumeIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPositiveVolumeIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPositiveVolumeIndexIndicatorComponent, selector: "igx-positive-volume-index-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPositiveVolumeIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-positive-volume-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPositiveVolumeIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPositiveVolumeIndexIndicatorModule() {
        }
        IgxPositiveVolumeIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPositiveVolumeIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorModule, declarations: [IgxPositiveVolumeIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxPositiveVolumeIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxPositiveVolumeIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxPositiveVolumeIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPositiveVolumeIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxPositiveVolumeIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPositiveVolumeIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPositiveVolumeIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPositiveVolumeIndexIndicatorComponent", IgxPositiveVolumeIndexIndicatorComponent);
            i2.TypeRegistrar.register("PositiveVolumeIndexIndicator", PositiveVolumeIndexIndicator.$type);
        }
        IgxPositiveVolumeIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPositiveVolumeIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxPositiveVolumeIndexIndicatorModule], exports: [IgxPositiveVolumeIndexIndicatorModule] });
        IgxPositiveVolumeIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxPositiveVolumeIndexIndicatorModule], IgxPositiveVolumeIndexIndicatorModule] });
        return IgxPositiveVolumeIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPositiveVolumeIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPositiveVolumeIndexIndicatorModule],
                        exports: [IgxPositiveVolumeIndexIndicatorModule],
                        entryComponents: [IgxPositiveVolumeIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PriceVolumeTrendIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PriceVolumeTrendIndicatorStrategy, _super);
        function PriceVolumeTrendIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PriceVolumeTrendIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("VolumeColumn");
            c.add("CloseColumn");
            return c;
        };
        PriceVolumeTrendIndicatorStrategy.prototype.a = function (a, b) {
            var c = 0;
            var d = a.indicatorColumn;
            var e = a.volumeColumn;
            var f = a.closeColumn;
            var g = a.count;
            if (g > 0) {
                d.item(0, c);
            }
            for (var h = 1; h < g; ++h) {
                c = c + b.i(e.item(h) * (f.item(h) - f.item(h - 1)) / f.item(h - 1));
                d.item(h, c);
            }
            return true;
        };
        PriceVolumeTrendIndicatorStrategy.$t = i2.markType(PriceVolumeTrendIndicatorStrategy, 'PriceVolumeTrendIndicatorStrategy', IndicatorCalculationStrategy.$);
        return PriceVolumeTrendIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PriceVolumeTrendIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PriceVolumeTrendIndicator, _super);
        function PriceVolumeTrendIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PriceVolumeTrendIndicator.prototype.get_tv = function () {
            return new PriceVolumeTrendIndicatorStrategy();
        };
        Object.defineProperty(PriceVolumeTrendIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        PriceVolumeTrendIndicator.prototype.get_t8 = function () {
            return PriceVolumeTrendIndicator.$;
        };
        Object.defineProperty(PriceVolumeTrendIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        PriceVolumeTrendIndicator.$t = i2.markType(PriceVolumeTrendIndicator, 'PriceVolumeTrendIndicator', StrategyBasedIndicator.$);
        return PriceVolumeTrendIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Price Volume Trend Indicator series.
     * Default required members: Volume, Close
    *
    * You can use the `IgxPriceVolumeTrendIndicatorComponent` to measure money flow by adding or subtracting a portion of the daily volume.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-price-volume-trend-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-price-volume-trend-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxPriceVolumeTrendIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxPriceVolumeTrendIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPriceVolumeTrendIndicatorComponent, _super);
        function IgxPriceVolumeTrendIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxPriceVolumeTrendIndicatorComponent.prototype.createImplementation = function () {
            return new PriceVolumeTrendIndicator();
        };
        Object.defineProperty(IgxPriceVolumeTrendIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPriceVolumeTrendIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPriceVolumeTrendIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPriceVolumeTrendIndicatorComponent, selector: "igx-price-volume-trend-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPriceVolumeTrendIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-price-volume-trend-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPriceVolumeTrendIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPriceVolumeTrendIndicatorModule() {
        }
        IgxPriceVolumeTrendIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPriceVolumeTrendIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorModule, declarations: [IgxPriceVolumeTrendIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxPriceVolumeTrendIndicatorComponent, IgxIndicatorProxyModule] });
        IgxPriceVolumeTrendIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxPriceVolumeTrendIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPriceVolumeTrendIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxPriceVolumeTrendIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPriceVolumeTrendIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPriceVolumeTrendIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPriceVolumeTrendIndicatorComponent", IgxPriceVolumeTrendIndicatorComponent);
            i2.TypeRegistrar.register("PriceVolumeTrendIndicator", PriceVolumeTrendIndicator.$type);
        }
        IgxPriceVolumeTrendIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPriceVolumeTrendIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorDynamicModule, imports: [i1.CommonModule, IgxPriceVolumeTrendIndicatorModule], exports: [IgxPriceVolumeTrendIndicatorModule] });
        IgxPriceVolumeTrendIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorDynamicModule, imports: [[i1.CommonModule, IgxPriceVolumeTrendIndicatorModule], IgxPriceVolumeTrendIndicatorModule] });
        return IgxPriceVolumeTrendIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceVolumeTrendIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPriceVolumeTrendIndicatorModule],
                        exports: [IgxPriceVolumeTrendIndicatorModule],
                        entryComponents: [IgxPriceVolumeTrendIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RateOfChangeAndMomentumIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RateOfChangeAndMomentumIndicatorStrategy, _super);
        function RateOfChangeAndMomentumIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RateOfChangeAndMomentumIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            return c;
        };
        RateOfChangeAndMomentumIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = a.closeColumn;
            var d = a.indicatorColumn;
            var e = a.period;
            var f = 0;
            var g = new Array(e);
            for (f = 0; f < e; f++) {
                g[f] = 0;
            }
            f = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    var i = f % e;
                    var j = b.i(100 * (h - g[i]) / g[i]);
                    d.item(f, j);
                    g[i] = h;
                    ++f;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        RateOfChangeAndMomentumIndicatorStrategy.$t = i2.markType(RateOfChangeAndMomentumIndicatorStrategy, 'RateOfChangeAndMomentumIndicatorStrategy', IndicatorCalculationStrategy.$);
        return RateOfChangeAndMomentumIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RateOfChangeAndMomentumIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RateOfChangeAndMomentumIndicator, _super);
        function RateOfChangeAndMomentumIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RateOfChangeAndMomentumIndicator.prototype.get_tv = function () {
            return new RateOfChangeAndMomentumIndicatorStrategy();
        };
        Object.defineProperty(RateOfChangeAndMomentumIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        RateOfChangeAndMomentumIndicator.prototype.get_t8 = function () {
            return RateOfChangeAndMomentumIndicator.$;
        };
        Object.defineProperty(RateOfChangeAndMomentumIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RateOfChangeAndMomentumIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(RateOfChangeAndMomentumIndicator.uh));
            },
            set: function (a) {
                this.h(RateOfChangeAndMomentumIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        RateOfChangeAndMomentumIndicator.prototype.t1 = function () {
            return this.ug;
        };
        RateOfChangeAndMomentumIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        RateOfChangeAndMomentumIndicator.$t = i2.markType(RateOfChangeAndMomentumIndicator, 'RateOfChangeAndMomentumIndicator', StrategyBasedIndicator.$);
        RateOfChangeAndMomentumIndicator.uh = StrategyBasedIndicator.ud(14, RateOfChangeAndMomentumIndicator.$);
        return RateOfChangeAndMomentumIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Rate of Change and Momentum indicator series.
     * Default required members: Close
    *
    * `IgxRateOfChangeAndMomentumIndicatorComponent` class represents a Rate of Change and Momentum indicator series for the IgxDataChartComponent.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-rate-of-change-and-momentum-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     >
    * </igx-rate-of-change-and-momentum-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxRateOfChangeAndMomentumIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxRateOfChangeAndMomentumIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRateOfChangeAndMomentumIndicatorComponent, _super);
        function IgxRateOfChangeAndMomentumIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxRateOfChangeAndMomentumIndicatorComponent.prototype.createImplementation = function () {
            return new RateOfChangeAndMomentumIndicator();
        };
        Object.defineProperty(IgxRateOfChangeAndMomentumIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRateOfChangeAndMomentumIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
             * The typical, and initial, value for AverageTrueRange periods is 14.
            *
            * You can use the `period` property for the current AverageTrueRangeSeries object.
            *
            * The typical, and initial, value for AverageTrueRange periods is 14.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis
            *     >
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-rate-of-change-and-momentum-indicator
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     openMemberPath="open"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     closeMemberPath="close"
            * 	period="30">
            * </igx-rate-of-change-and-momentum-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRateOfChangeAndMomentumIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRateOfChangeAndMomentumIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRateOfChangeAndMomentumIndicatorComponent, selector: "igx-rate-of-change-and-momentum-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRateOfChangeAndMomentumIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-rate-of-change-and-momentum-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRateOfChangeAndMomentumIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRateOfChangeAndMomentumIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRateOfChangeAndMomentumIndicatorModule() {
        }
        IgxRateOfChangeAndMomentumIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRateOfChangeAndMomentumIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorModule, declarations: [IgxRateOfChangeAndMomentumIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxRateOfChangeAndMomentumIndicatorComponent, IgxIndicatorProxyModule] });
        IgxRateOfChangeAndMomentumIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxRateOfChangeAndMomentumIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRateOfChangeAndMomentumIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxRateOfChangeAndMomentumIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRateOfChangeAndMomentumIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRateOfChangeAndMomentumIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRateOfChangeAndMomentumIndicatorComponent", IgxRateOfChangeAndMomentumIndicatorComponent);
            i2.TypeRegistrar.register("RateOfChangeAndMomentumIndicator", RateOfChangeAndMomentumIndicator.$type);
        }
        IgxRateOfChangeAndMomentumIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRateOfChangeAndMomentumIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorDynamicModule, imports: [i1.CommonModule, IgxRateOfChangeAndMomentumIndicatorModule], exports: [IgxRateOfChangeAndMomentumIndicatorModule] });
        IgxRateOfChangeAndMomentumIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorDynamicModule, imports: [[i1.CommonModule, IgxRateOfChangeAndMomentumIndicatorModule], IgxRateOfChangeAndMomentumIndicatorModule] });
        return IgxRateOfChangeAndMomentumIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRateOfChangeAndMomentumIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRateOfChangeAndMomentumIndicatorModule],
                        exports: [IgxRateOfChangeAndMomentumIndicatorModule],
                        entryComponents: [IgxRateOfChangeAndMomentumIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RelativeStrengthIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RelativeStrengthIndexIndicatorStrategy, _super);
        function RelativeStrengthIndexIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RelativeStrengthIndexIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            return c;
        };
        RelativeStrengthIndexIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c(a, b))), _d = _b.next(); !_d.done; _d = _b.next()) {
                    var d = _d.value;
                    a.indicatorColumn.item(c, d);
                    c++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        RelativeStrengthIndexIndicatorStrategy.prototype._c = function (a, b) {
            var c, d, e, f, g, h, i, j, k, l, m, n, o, p;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = a.period;
                        d = 2 / (c + 1);
                        e = 0;
                        f = 0;
                        g = a.indicatorColumn;
                        h = a.closeColumn;
                        if (!(g.count > 0))
                            return [3 /*break*/, 2];
                        return [4 /*yield*/, 0];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        i = 1;
                        _a.label = 3;
                    case 3:
                        if (!(i < Math.min(a.period, g.count)))
                            return [3 /*break*/, 6];
                        j = h.item(i) - h.item(i - 1);
                        k = j > 0 ? j : 0;
                        l = j > 0 ? 0 : -j;
                        e += k / (c - 1);
                        f += l / (c - 1);
                        return [4 /*yield*/, 0];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        ++i;
                        return [3 /*break*/, 3];
                    case 6:
                        m = a.period;
                        _a.label = 7;
                    case 7:
                        if (!(m < g.count))
                            return [3 /*break*/, 10];
                        n = h.item(m) - h.item(m - 1);
                        o = n > 0 ? n : 0;
                        p = n > 0 ? 0 : -n;
                        e = (e * (c - 1) + o) / c;
                        f = (f * (c - 1) + p) / c;
                        return [4 /*yield*/, b.i(e != 0 ? 100 * e / (e + f) : 0)];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9:
                        ++m;
                        return [3 /*break*/, 7];
                    case 10: return [2 /*return*/];
                }
            });
        };
        RelativeStrengthIndexIndicatorStrategy.prototype.c = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._c(a, b); });
        };
        RelativeStrengthIndexIndicatorStrategy.$t = i2.markType(RelativeStrengthIndexIndicatorStrategy, 'RelativeStrengthIndexIndicatorStrategy', StreamingIndicatorCalculationStrategy.$);
        return RelativeStrengthIndexIndicatorStrategy;
    }(StreamingIndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RelativeStrengthIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RelativeStrengthIndexIndicator, _super);
        function RelativeStrengthIndexIndicator() {
            return _super.call(this) || this;
        }
        RelativeStrengthIndexIndicator.prototype.get_s2 = function () {
            return 1;
        };
        RelativeStrengthIndexIndicator.prototype.get_tv = function () {
            return new RelativeStrengthIndexIndicatorStrategy();
        };
        Object.defineProperty(RelativeStrengthIndexIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        RelativeStrengthIndexIndicator.prototype.get_t8 = function () {
            return RelativeStrengthIndexIndicator.$;
        };
        Object.defineProperty(RelativeStrengthIndexIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RelativeStrengthIndexIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(RelativeStrengthIndexIndicator.uh));
            },
            set: function (a) {
                this.h(RelativeStrengthIndexIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        RelativeStrengthIndexIndicator.prototype.t1 = function () {
            return this.ug;
        };
        RelativeStrengthIndexIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        RelativeStrengthIndexIndicator.$t = i2.markType(RelativeStrengthIndexIndicator, 'RelativeStrengthIndexIndicator', StrategyBasedIndicator.$);
        RelativeStrengthIndexIndicator.uh = StrategyBasedIndicator.ud(14, RelativeStrengthIndexIndicator.$);
        return RelativeStrengthIndexIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Relative Strength Index indicator series.
     * Default required members: Close
    *
    * The `IgxRelativeStrengthIndexIndicatorComponent` class represents Relative Strength Index indicator series for the IgxDataChartComponent .
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-relative-strength-index-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume">
    *     </igx-relative-strength-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxRelativeStrengthIndexIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxRelativeStrengthIndexIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRelativeStrengthIndexIndicatorComponent, _super);
        function IgxRelativeStrengthIndexIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxRelativeStrengthIndexIndicatorComponent.prototype.createImplementation = function () {
            return new RelativeStrengthIndexIndicator();
        };
        Object.defineProperty(IgxRelativeStrengthIndexIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRelativeStrengthIndexIndicatorComponent.prototype, "defaultDisplayType", {
            /**
             * Gets default display type for the current Financial Indicator
            */
            get: function () {
                return this.i.s2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRelativeStrengthIndexIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current RelativeStrengthIndexIndicator object.
             * The typical, and initial, value for RSI periods is 14.
            *
            * You can use the `period` property for the current RelativeStrengthIndexIndicator object.
            *
            * ```html
            *  <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * 	<igx-relative-strength-index-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         highMemberPath="high"
            * 		lowMemberPath="low"
            * 		volumeMemberPath="volume"
            * 		period=30>
            *     </igx-relative-strength-index-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRelativeStrengthIndexIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRelativeStrengthIndexIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRelativeStrengthIndexIndicatorComponent, selector: "igx-relative-strength-index-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRelativeStrengthIndexIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-relative-strength-index-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRelativeStrengthIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRelativeStrengthIndexIndicatorModule() {
        }
        IgxRelativeStrengthIndexIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRelativeStrengthIndexIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorModule, declarations: [IgxRelativeStrengthIndexIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxRelativeStrengthIndexIndicatorComponent, IgxIndicatorProxyModule] });
        IgxRelativeStrengthIndexIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxRelativeStrengthIndexIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRelativeStrengthIndexIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxRelativeStrengthIndexIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRelativeStrengthIndexIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRelativeStrengthIndexIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRelativeStrengthIndexIndicatorComponent", IgxRelativeStrengthIndexIndicatorComponent);
            i2.TypeRegistrar.register("RelativeStrengthIndexIndicator", RelativeStrengthIndexIndicator.$type);
        }
        IgxRelativeStrengthIndexIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRelativeStrengthIndexIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorDynamicModule, imports: [i1.CommonModule, IgxRelativeStrengthIndexIndicatorModule], exports: [IgxRelativeStrengthIndexIndicatorModule] });
        IgxRelativeStrengthIndexIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorDynamicModule, imports: [[i1.CommonModule, IgxRelativeStrengthIndexIndicatorModule], IgxRelativeStrengthIndexIndicatorModule] });
        return IgxRelativeStrengthIndexIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRelativeStrengthIndexIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRelativeStrengthIndexIndicatorModule],
                        exports: [IgxRelativeStrengthIndexIndicatorModule],
                        entryComponents: [IgxRelativeStrengthIndexIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SlowStochasticOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SlowStochasticOscillatorIndicatorStrategy, _super);
        function SlowStochasticOscillatorIndicatorStrategy() {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.c = new PercentKCalculationStrategy();
            return _this;
        }
        SlowStochasticOscillatorIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(this.c.b(a, b));
            c.o(b.a.c);
            return c;
        };
        SlowStochasticOscillatorIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = this.c.c(a, b);
            var d = b.a.b(c, 3);
            var e = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a.indicatorColumn.item(e, f);
                    e++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        SlowStochasticOscillatorIndicatorStrategy.$t = i2.markType(SlowStochasticOscillatorIndicatorStrategy, 'SlowStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
        return SlowStochasticOscillatorIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SlowStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SlowStochasticOscillatorIndicator, _super);
        function SlowStochasticOscillatorIndicator() {
            var _this = _super.call(this) || this;
            _this.trendLineBrush = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            _this.trendLineType = 10;
            _this.trendLinePeriod = 3;
            return _this;
        }
        SlowStochasticOscillatorIndicator.prototype.get_tv = function () {
            return new SlowStochasticOscillatorIndicatorStrategy();
        };
        Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        SlowStochasticOscillatorIndicator.prototype.get_t8 = function () {
            return SlowStochasticOscillatorIndicator.$;
        };
        Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(SlowStochasticOscillatorIndicator.uh));
            },
            set: function (a) {
                this.h(SlowStochasticOscillatorIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        SlowStochasticOscillatorIndicator.prototype.t1 = function () {
            return this.ug;
        };
        SlowStochasticOscillatorIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        SlowStochasticOscillatorIndicator.$t = i2.markType(SlowStochasticOscillatorIndicator, 'SlowStochasticOscillatorIndicator', StrategyBasedIndicator.$);
        SlowStochasticOscillatorIndicator.uh = StrategyBasedIndicator.ud(14, SlowStochasticOscillatorIndicator.$);
        return SlowStochasticOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Slow Stochastic Oscillator indicator series.
     * Default required members: High, Low, Close
    *
    * `IgxSlowStochasticOscillatorIndicatorComponent` (SSO) displays the closing price relative to the high-low range over a given period of time. There are three types of Stochastic Oscillators: Fast, Slow, and Full. The Stochastic Oscillator is a momentum indicator that shows the relation of the current close price relative to the high/low range over a given time period using a scale of 0 to 100. It is based on the premise that prices will close near 100 in a rising market and closer to 0 in a declining market.
    *
    * The Fast Stochastic Oscillator Indicator is used to identify buying or selling divergences. The Slow Stochastic Oscillator uses a 3-day SMA and the Full Stochastic Oscillator is the Slow Stochastic Oscillator with time period.
    *
    * Using this indicator requires setting both the `HighMemberPath`, `LowMemberPath` and `VolumeMemberPath`.
    *
    * ```html
    * <igx-data-chart
    *     width=500px
    *     height=500px
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *         dateTimeMemberPath="TimeStamp"
    *         #xAxis>
    *       </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *        #yAxis></igx-numeric-y-axis>
    *     <igx-slow-stochastic-oscillator-indicator
    *        [xAxis]="xAxis"
    *        [yAxis]="yAxis"
    *        volumeMemberPath="Volume"
    *        highMemberPath="High"
    *        lowMemberPath="Low">
    *      </igx-slow-stochastic-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxSlowStochasticOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.volumeMemberPath = "Volume";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * this.chart.series.add(series);
    * ```
    */
    var IgxSlowStochasticOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSlowStochasticOscillatorIndicatorComponent, _super);
        function IgxSlowStochasticOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxSlowStochasticOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new SlowStochasticOscillatorIndicator();
        };
        Object.defineProperty(IgxSlowStochasticOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSlowStochasticOscillatorIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current SlowStochasticOscillatorIndicator object.
             * The typical, and initial, value for SlowStochasticOscillatorIndicator periods is 14.
            *
            * ```html
            * <igx-data-chart
            *     width=500px
            *     height=500px
            *     [dataSource]="data" >
            *     <igx-ordinal-time-x-axis
            *         dateTimeMemberPath="TimeStamp"
            *         #xAxis>
            *       </igx-ordinal-time-x-axis>
            *     <igx-numeric-y-axis
            *        #yAxis></igx-numeric-y-axis>
            *     <igx-slow-stochastic-oscillator-indicator
            *        [xAxis]="xAxis"
            *        [yAxis]="yAxis"
            *        closeMemberPath="Close"
            *        highMemberPath="High"
            *        lowMemberPath="Low"
            *        period=10>
            *      </igx-slow-stochastic-oscillator-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxSlowStochasticOscillatorIndicatorComponent();
            * series.period=10;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxSlowStochasticOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSlowStochasticOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSlowStochasticOscillatorIndicatorComponent, selector: "igx-slow-stochastic-oscillator-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSlowStochasticOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-slow-stochastic-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSlowStochasticOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSlowStochasticOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSlowStochasticOscillatorIndicatorModule() {
        }
        IgxSlowStochasticOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSlowStochasticOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorModule, declarations: [IgxSlowStochasticOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxSlowStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxSlowStochasticOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxSlowStochasticOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSlowStochasticOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxSlowStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSlowStochasticOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSlowStochasticOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxSlowStochasticOscillatorIndicatorComponent", IgxSlowStochasticOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("SlowStochasticOscillatorIndicator", SlowStochasticOscillatorIndicator.$type);
        }
        IgxSlowStochasticOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSlowStochasticOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxSlowStochasticOscillatorIndicatorModule], exports: [IgxSlowStochasticOscillatorIndicatorModule] });
        IgxSlowStochasticOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxSlowStochasticOscillatorIndicatorModule], IgxSlowStochasticOscillatorIndicatorModule] });
        return IgxSlowStochasticOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSlowStochasticOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxSlowStochasticOscillatorIndicatorModule],
                        exports: [IgxSlowStochasticOscillatorIndicatorModule],
                        entryComponents: [IgxSlowStochasticOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StandardDeviationIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StandardDeviationIndicatorStrategy, _super);
        function StandardDeviationIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        StandardDeviationIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.typicalColumn.basedOn);
            c.o(b.d.c);
            return c;
        };
        StandardDeviationIndicatorStrategy.prototype.a = function (a, b) {
            var c = i2.getEnumerator(b.d.b(a.typicalColumn, a.period));
            var d = a.indicatorColumn;
            var e = 0;
            while (c.moveNext()) {
                d.item(e, c.current);
                e++;
            }
            return true;
        };
        StandardDeviationIndicatorStrategy.$t = i2.markType(StandardDeviationIndicatorStrategy, 'StandardDeviationIndicatorStrategy', IndicatorCalculationStrategy.$);
        return StandardDeviationIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StandardDeviationIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StandardDeviationIndicator, _super);
        function StandardDeviationIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        StandardDeviationIndicator.prototype.get_tv = function () {
            return new StandardDeviationIndicatorStrategy();
        };
        Object.defineProperty(StandardDeviationIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        StandardDeviationIndicator.prototype.get_t8 = function () {
            return StandardDeviationIndicator.$;
        };
        Object.defineProperty(StandardDeviationIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StandardDeviationIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(StandardDeviationIndicator.uh));
            },
            set: function (a) {
                this.h(StandardDeviationIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        StandardDeviationIndicator.prototype.t1 = function () {
            return this.ug;
        };
        StandardDeviationIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        StandardDeviationIndicator.$t = i2.markType(StandardDeviationIndicator, 'StandardDeviationIndicator', StrategyBasedIndicator.$);
        StandardDeviationIndicator.uh = StrategyBasedIndicator.ud(20, StandardDeviationIndicator.$);
        return StandardDeviationIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Standard Deviation indicator series.
     * Default required members: High, Low, Close
    *
    * `IgxStandardDeviationIndicatorComponent` (SDI) measures statistical variation in stock prices or volatility. The difference between an individual security’s closing price and the average security closing price is called the dispersion. The larger the dispersion is the higher the standard deviation will be and therefore the volatility. The smaller the dispersion is (the difference between an individual closing price and the average price), the smaller the standard deviation and the lower the price volatility.
    *
    * Using this indicator requires setting both the `HighMemberPath`, `LowMemberPath` and `CloseMemberPath`.
    *
    * ```html
    *  <igx-data-chart
    *     width=500px
    *     height=500px
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *         dateTimeMemberPath="TimeStamp"
    *         #xAxis>
    *       </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *        #yAxis></igx-numeric-y-axis>
    *     <igx-standard-deviation-indicator
    *        [xAxis]="xAxis"
    *        [yAxis]="yAxis"
    *        closeMemberPath="Close"
    *        highMemberPath="High"
    *        lowMemberPath="Low">
    *      </igx-standard-deviation-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxStandardDeviatioIndicatorComponent();
    *    series.xAxis = this.xAxis;
    *    series.yAxis = this.yAxis;
    *    series.highMemberPath = "high";
    *    series.lowMemberPath = "low";
    *    series.closeMemberPath = "close";
    *    this.chart.series.add(series);
    *
    * ```
    */
    var IgxStandardDeviationIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStandardDeviationIndicatorComponent, _super);
        function IgxStandardDeviationIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxStandardDeviationIndicatorComponent.prototype.createImplementation = function () {
            return new StandardDeviationIndicator();
        };
        Object.defineProperty(IgxStandardDeviationIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStandardDeviationIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current StandardDeviationIndicator object.
             * The typical, and initial, value for STDEV periods is 20.
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxStandardDeviationIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStandardDeviationIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStandardDeviationIndicatorComponent, selector: "igx-standard-deviation-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStandardDeviationIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-standard-deviation-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStandardDeviationIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStandardDeviationIndicatorModule() {
        }
        IgxStandardDeviationIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStandardDeviationIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorModule, declarations: [IgxStandardDeviationIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxStandardDeviationIndicatorComponent, IgxIndicatorProxyModule] });
        IgxStandardDeviationIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxStandardDeviationIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStandardDeviationIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxStandardDeviationIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStandardDeviationIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStandardDeviationIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStandardDeviationIndicatorComponent", IgxStandardDeviationIndicatorComponent);
            i2.TypeRegistrar.register("StandardDeviationIndicator", StandardDeviationIndicator.$type);
        }
        IgxStandardDeviationIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStandardDeviationIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorDynamicModule, imports: [i1.CommonModule, IgxStandardDeviationIndicatorModule], exports: [IgxStandardDeviationIndicatorModule] });
        IgxStandardDeviationIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorDynamicModule, imports: [[i1.CommonModule, IgxStandardDeviationIndicatorModule], IgxStandardDeviationIndicatorModule] });
        return IgxStandardDeviationIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStandardDeviationIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStandardDeviationIndicatorModule],
                        exports: [IgxStandardDeviationIndicatorModule],
                        entryComponents: [IgxStandardDeviationIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StochRSIIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StochRSIIndicatorStrategy, _super);
        function StochRSIIndicatorStrategy() {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.c = new RelativeStrengthIndexIndicatorStrategy();
            return _this;
        }
        StochRSIIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(this.c.b(a, b));
            return c;
        };
        StochRSIIndicatorStrategy.prototype.a = function (a, b) {
            var c = i2.getEnumerator(this.c.c(a, b));
            var d = a.period;
            var e = 0;
            var f = new Array(d);
            for (e = 0; e < d; e++) {
                f[e] = 0;
            }
            e = 0;
            while (c.moveNext()) {
                var g = Math.min(d, e);
                var h = -1.7976931348623157E+308;
                var i = 1.7976931348623157E+308;
                var j = e % d;
                for (var k = 0; k < g; k++) {
                    if (!i2.isNaN_(f[g - k - 1])) {
                        h = Math.max(h, f[g - k - 1]);
                    }
                    if (!i2.isNaN_(f[g - k - 1])) {
                        i = Math.min(i, f[g - k - 1]);
                    }
                }
                f[j] = c.current;
                var l = b.i((c.current - i) / (h - i));
                a.indicatorColumn.item(e, l);
                e++;
            }
            return true;
        };
        StochRSIIndicatorStrategy.$t = i2.markType(StochRSIIndicatorStrategy, 'StochRSIIndicatorStrategy', IndicatorCalculationStrategy.$);
        return StochRSIIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StochRSIIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StochRSIIndicator, _super);
        function StochRSIIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        StochRSIIndicator.prototype.get_tv = function () {
            return new StochRSIIndicatorStrategy();
        };
        Object.defineProperty(StochRSIIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        StochRSIIndicator.prototype.get_t8 = function () {
            return StochRSIIndicator.$;
        };
        Object.defineProperty(StochRSIIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StochRSIIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(StochRSIIndicator.uh));
            },
            set: function (a) {
                this.h(StochRSIIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        StochRSIIndicator.prototype.t1 = function () {
            return this.ug;
        };
        StochRSIIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        StochRSIIndicator.$t = i2.markType(StochRSIIndicator, 'StochRSIIndicator', StrategyBasedIndicator.$);
        StochRSIIndicator.uh = StrategyBasedIndicator.ud(14, StochRSIIndicator.$);
        return StochRSIIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent StochRSI indicator series.
     * Default required members: Close
    *
    * `IgxStochRSIIndicatorComponent` or Stochastic Relative Strength IndexI Indicator (SRSI) measures when a security is overbought or oversold within a specified period of time. The values range from 0 to 1. The StochRSI Indicator is calculated by applying the Stochastic Oscillator formula to RelativeStrengthIndexIndicator (RSI) data.
    *
    * Using this indicator requires setting the `CloseMemberPath`.
    *
    * ```html
    * <igx-data-chart
    *     width=500px
    *     height=500px
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *         dateTimeMemberPath="TimeStamp"
    *         #xAxis>
    *       </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *        #yAxis></igx-numeric-y-axis>
    *     <igx-stoch-rsi-indicator
    *        [xAxis]="xAxis"
    *        [yAxis]="yAxis"
    *        closeMemberPath="Close">
    *      </igx-stoch-rsi-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxStochRSIIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxStochRSIIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStochRSIIndicatorComponent, _super);
        function IgxStochRSIIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxStochRSIIndicatorComponent.prototype.createImplementation = function () {
            return new StochRSIIndicator();
        };
        Object.defineProperty(IgxStochRSIIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStochRSIIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current StochRSIIndicator object.
             * The typical, and initial, value for StochRSI periods is 14.
            *
            * ```html
            * <igx-data-chart
            *     width=500px
            *     height=500px
            *     [dataSource]="data" >
            *     <igx-ordinal-time-x-axis
            *         dateTimeMemberPath="TimeStamp"
            *         #xAxis>
            *       </igx-ordinal-time-x-axis>
            *     <igx-numeric-y-axis
            *        #yAxis></igx-numeric-y-axis>
            *     <igx-stoch-rsi-indicator
            *        [xAxis]="xAxis"
            *        [yAxis]="yAxis"
            *        closeMemberPath="Close"
            *        period=10>
            *      </igx-stoch-rsi-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 10;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxStochRSIIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStochRSIIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStochRSIIndicatorComponent, selector: "igx-stoch-rsi-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStochRSIIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stoch-rsi-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStochRSIIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStochRSIIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStochRSIIndicatorModule() {
        }
        IgxStochRSIIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStochRSIIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorModule, declarations: [IgxStochRSIIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxStochRSIIndicatorComponent, IgxIndicatorProxyModule] });
        IgxStochRSIIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxStochRSIIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStochRSIIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxStochRSIIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStochRSIIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStochRSIIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStochRSIIndicatorComponent", IgxStochRSIIndicatorComponent);
            i2.TypeRegistrar.register("StochRSIIndicator", StochRSIIndicator.$type);
        }
        IgxStochRSIIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStochRSIIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorDynamicModule, imports: [i1.CommonModule, IgxStochRSIIndicatorModule], exports: [IgxStochRSIIndicatorModule] });
        IgxStochRSIIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorDynamicModule, imports: [[i1.CommonModule, IgxStochRSIIndicatorModule], IgxStochRSIIndicatorModule] });
        return IgxStochRSIIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStochRSIIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStochRSIIndicatorModule],
                        exports: [IgxStochRSIIndicatorModule],
                        entryComponents: [IgxStochRSIIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TRIXIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TRIXIndicatorStrategy, _super);
        function TRIXIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TRIXIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("CloseColumn");
            c.o(b.a.c);
            return c;
        };
        TRIXIndicatorStrategy.prototype.a = function (a, b) {
            var c = b.a.b(a.closeColumn, a.period);
            var d = b.a.b(c, a.period);
            var e = i2.getEnumerator(b.a.b(d, a.period));
            var f = a.indicatorColumn;
            if (f.count > 0) {
                f.item(0, 0);
            }
            var g = 1;
            e.moveNext();
            var h = e.current;
            while (e.moveNext()) {
                f.item(g, b.i((e.current - h) / h));
                h = e.current;
                g++;
            }
            return true;
        };
        TRIXIndicatorStrategy.$t = i2.markType(TRIXIndicatorStrategy, 'TRIXIndicatorStrategy', IndicatorCalculationStrategy.$);
        return TRIXIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TRIXIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TRIXIndicator, _super);
        function TRIXIndicator() {
            var _this = _super.call(this) || this;
            _this.s3 = 0;
            _this.trendLineBrush = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#565656";
                return $ret;
            })());
            _this.trendLineType = 9;
            _this.trendLinePeriod = 9;
            return _this;
        }
        TRIXIndicator.prototype.get_tv = function () {
            return new TRIXIndicatorStrategy();
        };
        Object.defineProperty(TRIXIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        TRIXIndicator.prototype.get_t8 = function () {
            return TRIXIndicator.$;
        };
        Object.defineProperty(TRIXIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TRIXIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(TRIXIndicator.uh));
            },
            set: function (a) {
                this.h(TRIXIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        TRIXIndicator.prototype.t1 = function () {
            return this.ug;
        };
        TRIXIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        TRIXIndicator.$t = i2.markType(TRIXIndicator, 'TRIXIndicator', StrategyBasedIndicator.$);
        TRIXIndicator.uh = StrategyBasedIndicator.ud(15, TRIXIndicator.$);
        return TRIXIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent TRIX indicator series.
     * Default required members: Close
    *
    * The `IgxTRIXIndicatorComponent` class specify the series as Trix Indicator series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-trix-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume">
    *     </igx-trix-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxTrixIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxTRIXIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTRIXIndicatorComponent, _super);
        function IgxTRIXIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxTRIXIndicatorComponent.prototype.createImplementation = function () {
            return new TRIXIndicator();
        };
        Object.defineProperty(IgxTRIXIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTRIXIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current TRIXIndicator object.
             * The typical, and initial, value for TRIX periods is 15.
            *
            * The `period` property is used for moving average period of the current TRIXIndicator object.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            * 	<igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            * 	<igx-trix-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         highMemberPath="high"
            * 		lowMemberPath="low"
            * 		volumeMemberPath="volume"
            * 		period="7">
            *     </igx-trix-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxTRIXIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTRIXIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTRIXIndicatorComponent, selector: "igx-trix-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxTRIXIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-trix-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTRIXIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTRIXIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTRIXIndicatorModule() {
        }
        IgxTRIXIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTRIXIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorModule, declarations: [IgxTRIXIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxTRIXIndicatorComponent, IgxIndicatorProxyModule] });
        IgxTRIXIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxTRIXIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTRIXIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxTRIXIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTRIXIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTRIXIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTRIXIndicatorComponent", IgxTRIXIndicatorComponent);
            i2.TypeRegistrar.register("TRIXIndicator", TRIXIndicator.$type);
        }
        IgxTRIXIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTRIXIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorDynamicModule, imports: [i1.CommonModule, IgxTRIXIndicatorModule], exports: [IgxTRIXIndicatorModule] });
        IgxTRIXIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorDynamicModule, imports: [[i1.CommonModule, IgxTRIXIndicatorModule], IgxTRIXIndicatorModule] });
        return IgxTRIXIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTRIXIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTRIXIndicatorModule],
                        exports: [IgxTRIXIndicatorModule],
                        entryComponents: [IgxTRIXIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TypicalPriceIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TypicalPriceIndicatorStrategy, _super);
        function TypicalPriceIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TypicalPriceIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.typicalColumn.basedOn);
            return c;
        };
        TypicalPriceIndicatorStrategy.prototype.a = function (a, b) {
            var e_1, _a;
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.typicalColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    a.indicatorColumn.item(c, d);
                    c++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return true;
        };
        TypicalPriceIndicatorStrategy.$t = i2.markType(TypicalPriceIndicatorStrategy, 'TypicalPriceIndicatorStrategy', IndicatorCalculationStrategy.$);
        return TypicalPriceIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TypicalPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TypicalPriceIndicator, _super);
        function TypicalPriceIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TypicalPriceIndicator.prototype.get_tv = function () {
            return new TypicalPriceIndicatorStrategy();
        };
        Object.defineProperty(TypicalPriceIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        TypicalPriceIndicator.prototype.get_t8 = function () {
            return TypicalPriceIndicator.$;
        };
        Object.defineProperty(TypicalPriceIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        TypicalPriceIndicator.$t = i2.markType(TypicalPriceIndicator, 'TypicalPriceIndicator', StrategyBasedIndicator.$);
        return TypicalPriceIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Typical Price indicator series.
     * The typical price indicator is represented as a arithmetic average
     * of the High, Low, and Close for a day.
     * Default required members: High, Low, Close
    *
    * The `IgxTypicalPriceIndicatorComponent` class represents a IgxDataChartComponent Typical Price indicator series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-typical-price-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume">
    *     </igx-typical-price-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxTypicalPriceIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxTypicalPriceIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTypicalPriceIndicatorComponent, _super);
        function IgxTypicalPriceIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxTypicalPriceIndicatorComponent.prototype.createImplementation = function () {
            return new TypicalPriceIndicator();
        };
        Object.defineProperty(IgxTypicalPriceIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxTypicalPriceIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTypicalPriceIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTypicalPriceIndicatorComponent, selector: "igx-typical-price-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxTypicalPriceIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-typical-price-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxTypicalPriceIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTypicalPriceIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTypicalPriceIndicatorModule() {
        }
        IgxTypicalPriceIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTypicalPriceIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorModule, declarations: [IgxTypicalPriceIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxTypicalPriceIndicatorComponent, IgxIndicatorProxyModule] });
        IgxTypicalPriceIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxTypicalPriceIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTypicalPriceIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxTypicalPriceIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTypicalPriceIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTypicalPriceIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTypicalPriceIndicatorComponent", IgxTypicalPriceIndicatorComponent);
            i2.TypeRegistrar.register("TypicalPriceIndicator", TypicalPriceIndicator.$type);
        }
        IgxTypicalPriceIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTypicalPriceIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorDynamicModule, imports: [i1.CommonModule, IgxTypicalPriceIndicatorModule], exports: [IgxTypicalPriceIndicatorModule] });
        IgxTypicalPriceIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorDynamicModule, imports: [[i1.CommonModule, IgxTypicalPriceIndicatorModule], IgxTypicalPriceIndicatorModule] });
        return IgxTypicalPriceIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTypicalPriceIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTypicalPriceIndicatorModule],
                        exports: [IgxTypicalPriceIndicatorModule],
                        entryComponents: [IgxTypicalPriceIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var UltimateOscillatorIndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(UltimateOscillatorIndicatorCalculationStrategy, _super);
        function UltimateOscillatorIndicatorCalculationStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        UltimateOscillatorIndicatorCalculationStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.o(a.trueLow.basedOn);
            c.add("CloseColumn");
            c.o(a.trueRange.basedOn);
            c.o(b.b.c);
            return c;
        };
        UltimateOscillatorIndicatorCalculationStrategy.prototype.c = function (a) {
            var b = 0;
            var c = new i2.List$1(i2.Number_$type, 0);
            var d = a.trueLow.getEnumerator();
            while (d.moveNext()) {
                c.add(a.closeColumn.item(b) - d.current);
                b++;
            }
            return c;
        };
        UltimateOscillatorIndicatorCalculationStrategy.prototype.a = function (a, b) {
            var c = this.c(a);
            var d = a.trueRange;
            var e = i2.getEnumerator(b.b.b(c, 7));
            var f = i2.getEnumerator(b.b.b(d, 7));
            var g = i2.getEnumerator(b.b.b(c, 14));
            var h = i2.getEnumerator(b.b.b(d, 14));
            var i = i2.getEnumerator(b.b.b(c, 28));
            var j = i2.getEnumerator(b.b.b(d, 28));
            var k = 0;
            while (e.moveNext() && f.moveNext() && g.moveNext() && h.moveNext() && i.moveNext() && j.moveNext()) {
                var l = b.i(4 * (e.current / f.current) + 2 * (g.current / h.current) + (i.current / j.current));
                var m = (l / (4 + 2 + 1)) * 100;
                a.indicatorColumn.item(k, m);
                k++;
            }
            return true;
        };
        UltimateOscillatorIndicatorCalculationStrategy.$t = i2.markType(UltimateOscillatorIndicatorCalculationStrategy, 'UltimateOscillatorIndicatorCalculationStrategy', IndicatorCalculationStrategy.$);
        return UltimateOscillatorIndicatorCalculationStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var UltimateOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(UltimateOscillatorIndicator, _super);
        function UltimateOscillatorIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        UltimateOscillatorIndicator.prototype.get_tv = function () {
            return new UltimateOscillatorIndicatorCalculationStrategy();
        };
        Object.defineProperty(UltimateOscillatorIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        UltimateOscillatorIndicator.prototype.get_t8 = function () {
            return UltimateOscillatorIndicator.$;
        };
        Object.defineProperty(UltimateOscillatorIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        UltimateOscillatorIndicator.$t = i2.markType(UltimateOscillatorIndicator, 'UltimateOscillatorIndicator', StrategyBasedIndicator.$);
        return UltimateOscillatorIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Ultimate Oscillator indicator series.
     * Default required members: High, Low, Close
    *
    * You can use the `IgxUltimateOscillatorIndicatorComponent` which represents a IgxDataChartComponent Ultimate Oscillator indicator series.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-ultimate-oscillator-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-ultimate-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxUltimateOscillatorIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxUltimateOscillatorIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxUltimateOscillatorIndicatorComponent, _super);
        function IgxUltimateOscillatorIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxUltimateOscillatorIndicatorComponent.prototype.createImplementation = function () {
            return new UltimateOscillatorIndicator();
        };
        Object.defineProperty(IgxUltimateOscillatorIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxUltimateOscillatorIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxUltimateOscillatorIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxUltimateOscillatorIndicatorComponent, selector: "igx-ultimate-oscillator-indicator", providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxUltimateOscillatorIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-ultimate-oscillator-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxUltimateOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxUltimateOscillatorIndicatorModule() {
        }
        IgxUltimateOscillatorIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxUltimateOscillatorIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorModule, declarations: [IgxUltimateOscillatorIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxUltimateOscillatorIndicatorComponent, IgxIndicatorProxyModule] });
        IgxUltimateOscillatorIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxUltimateOscillatorIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxUltimateOscillatorIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxUltimateOscillatorIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxUltimateOscillatorIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxUltimateOscillatorIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxUltimateOscillatorIndicatorComponent", IgxUltimateOscillatorIndicatorComponent);
            i2.TypeRegistrar.register("UltimateOscillatorIndicator", UltimateOscillatorIndicator.$type);
        }
        IgxUltimateOscillatorIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxUltimateOscillatorIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorDynamicModule, imports: [i1.CommonModule, IgxUltimateOscillatorIndicatorModule], exports: [IgxUltimateOscillatorIndicatorModule] });
        IgxUltimateOscillatorIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorDynamicModule, imports: [[i1.CommonModule, IgxUltimateOscillatorIndicatorModule], IgxUltimateOscillatorIndicatorModule] });
        return IgxUltimateOscillatorIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxUltimateOscillatorIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxUltimateOscillatorIndicatorModule],
                        exports: [IgxUltimateOscillatorIndicatorModule],
                        entryComponents: [IgxUltimateOscillatorIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var WeightedCloseIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WeightedCloseIndicatorStrategy, _super);
        function WeightedCloseIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        WeightedCloseIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.add("CloseColumn");
            return c;
        };
        WeightedCloseIndicatorStrategy.prototype.a = function (a, b, c) {
            a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c) + (a.closeColumn.item(c) * 2)) / 4);
            return true;
        };
        WeightedCloseIndicatorStrategy.$t = i2.markType(WeightedCloseIndicatorStrategy, 'WeightedCloseIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
        return WeightedCloseIndicatorStrategy;
    }(ItemwiseIndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var WeightedCloseIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WeightedCloseIndicator, _super);
        function WeightedCloseIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        WeightedCloseIndicator.prototype.get_uh = function () {
            return new WeightedCloseIndicatorStrategy();
        };
        Object.defineProperty(WeightedCloseIndicator.prototype, "uh", {
            get: function () {
                return this.get_uh();
            },
            enumerable: false,
            configurable: true
        });
        WeightedCloseIndicator.prototype.get_t8 = function () {
            return WeightedCloseIndicator.$;
        };
        Object.defineProperty(WeightedCloseIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        WeightedCloseIndicator.$t = i2.markType(WeightedCloseIndicator, 'WeightedCloseIndicator', ItemwiseStrategyBasedIndicator.$);
        return WeightedCloseIndicator;
    }(ItemwiseStrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Weigted Close indicator series.
     * The weighted close indicator shows an average of the high low and close
     * for a day but with the closing price counted twice in the average.
     * Default required members: High, Low, Close
    *
    * The `IgxWeightedCloseIndicatorComponent` is similar to the `IgxTypicalPriceIndicatorComponent` in that it represents an average of the high price, low price, and closing price for a day.
    * However, with the `IgxWeightedCloseIndicatorComponent`, more emphasis is placed on the closing price and it is included twice when calculating the arithmetic average.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-weighted-close-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close">
    *     </igx-weighted-close-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxWeightedCloseIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxWeightedCloseIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxWeightedCloseIndicatorComponent, _super);
        function IgxWeightedCloseIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxWeightedCloseIndicatorComponent.prototype.createImplementation = function () {
            return new WeightedCloseIndicator();
        };
        Object.defineProperty(IgxWeightedCloseIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxWeightedCloseIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxWeightedCloseIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxWeightedCloseIndicatorComponent, selector: "igx-weighted-close-indicator", providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxWeightedCloseIndicatorComponent;
    }(IgxItemwiseStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-weighted-close-indicator',
                        template: "",
                        providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWeightedCloseIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxWeightedCloseIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxWeightedCloseIndicatorModule() {
        }
        IgxWeightedCloseIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxWeightedCloseIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorModule, declarations: [IgxWeightedCloseIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxWeightedCloseIndicatorComponent, IgxIndicatorProxyModule] });
        IgxWeightedCloseIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxWeightedCloseIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxWeightedCloseIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxWeightedCloseIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxWeightedCloseIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxWeightedCloseIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxWeightedCloseIndicatorComponent", IgxWeightedCloseIndicatorComponent);
            i2.TypeRegistrar.register("WeightedCloseIndicator", WeightedCloseIndicator.$type);
        }
        IgxWeightedCloseIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxWeightedCloseIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorDynamicModule, imports: [i1.CommonModule, IgxWeightedCloseIndicatorModule], exports: [IgxWeightedCloseIndicatorModule] });
        IgxWeightedCloseIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorDynamicModule, imports: [[i1.CommonModule, IgxWeightedCloseIndicatorModule], IgxWeightedCloseIndicatorModule] });
        return IgxWeightedCloseIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWeightedCloseIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxWeightedCloseIndicatorModule],
                        exports: [IgxWeightedCloseIndicatorModule],
                        entryComponents: [IgxWeightedCloseIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var WilliamsPercentRIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WilliamsPercentRIndicatorStrategy, _super);
        function WilliamsPercentRIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        WilliamsPercentRIndicatorStrategy.prototype.b = function (a, b) {
            var c = new i2.List$1(i2.String_$type, 0);
            c.add("HighColumn");
            c.add("LowColumn");
            c.add("CloseColumn");
            return c;
        };
        WilliamsPercentRIndicatorStrategy.prototype.a = function (a, b) {
            var c = a.period;
            var d = a.highColumn;
            var e = a.lowColumn;
            for (var f = 0; f < a.count; f++) {
                var g = Math.min(c, f);
                var h = -1.7976931348623157E+308;
                var i = 1.7976931348623157E+308;
                for (var j = 0; j < g; j++) {
                    if (!i2.isNaN_(d.item(f - j))) {
                        h = Math.max(h, d.item(f - j));
                    }
                    if (!i2.isNaN_(e.item(f - j))) {
                        i = Math.min(i, e.item(f - j));
                    }
                }
                a.indicatorColumn.item(f, b.i((a.closeColumn.item(f) - h) / (h - i) * 100));
            }
            return true;
        };
        WilliamsPercentRIndicatorStrategy.$t = i2.markType(WilliamsPercentRIndicatorStrategy, 'WilliamsPercentRIndicatorStrategy', IndicatorCalculationStrategy.$);
        return WilliamsPercentRIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var WilliamsPercentRIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WilliamsPercentRIndicator, _super);
        function WilliamsPercentRIndicator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        WilliamsPercentRIndicator.prototype.get_tv = function () {
            return new WilliamsPercentRIndicatorStrategy();
        };
        Object.defineProperty(WilliamsPercentRIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        WilliamsPercentRIndicator.prototype.get_t8 = function () {
            return WilliamsPercentRIndicator.$;
        };
        Object.defineProperty(WilliamsPercentRIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(WilliamsPercentRIndicator.prototype, "ug", {
            get: function () {
                return i2.typeGetValue(this.c(WilliamsPercentRIndicator.uh));
            },
            set: function (a) {
                this.h(WilliamsPercentRIndicator.uh, a);
            },
            enumerable: false,
            configurable: true
        });
        WilliamsPercentRIndicator.prototype.t1 = function () {
            return this.ug;
        };
        WilliamsPercentRIndicator.prototype.ua = function (a) {
            this.ug = a;
        };
        WilliamsPercentRIndicator.$t = i2.markType(WilliamsPercentRIndicator, 'WilliamsPercentRIndicator', StrategyBasedIndicator.$);
        WilliamsPercentRIndicator.uh = StrategyBasedIndicator.ud(14, WilliamsPercentRIndicator.$);
        return WilliamsPercentRIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Williams %R indicator series.
     * Default required members: High, Low, Close
    *
    * The `IgxWilliamsPercentRIndicatorComponent` scale ranges from 0 to -100. It is useful for identifying overbought and oversold securities.
    * The `IgxWilliamsPercentRIndicatorComponent` is calculated by dividing the difference between the highest high for the period and the current close by the highest high minus the lowest low for the period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-williams-percent-r-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close">
    *     </igx-williams-percent-r-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxWilliamsPercentRIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxWilliamsPercentRIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxWilliamsPercentRIndicatorComponent, _super);
        function IgxWilliamsPercentRIndicatorComponent() {
            return _super.call(this) || this;
        }
        IgxWilliamsPercentRIndicatorComponent.prototype.createImplementation = function () {
            return new WilliamsPercentRIndicator();
        };
        Object.defineProperty(IgxWilliamsPercentRIndicatorComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxWilliamsPercentRIndicatorComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current StandardDeviationIndicator object.
             * The typical, and initial, value for Williams %R periods is 14.
            *
            * Gets or sets the `period` for the moving average period.
            *
            * The typical, and initial, value for Williams %R periods is 14.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis #xAxis
            *         label="label">
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-williams-percent-r-indicator
            *         #series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         openMemberPath="open"
            *         highMemberPath="high"
            *         lowMemberPath="low"
            *         closeMemberPath="close"
            *         period="30">
            *     </igx-williams-percent-r-indicator>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 30;
            * ```
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxWilliamsPercentRIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxWilliamsPercentRIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxWilliamsPercentRIndicatorComponent, selector: "igx-williams-percent-r-indicator", inputs: { period: "period" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxWilliamsPercentRIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-williams-percent-r-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxWilliamsPercentRIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxWilliamsPercentRIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxWilliamsPercentRIndicatorModule() {
        }
        IgxWilliamsPercentRIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxWilliamsPercentRIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorModule, declarations: [IgxWilliamsPercentRIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxWilliamsPercentRIndicatorComponent, IgxIndicatorProxyModule] });
        IgxWilliamsPercentRIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxWilliamsPercentRIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxWilliamsPercentRIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxWilliamsPercentRIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxWilliamsPercentRIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxWilliamsPercentRIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxWilliamsPercentRIndicatorComponent", IgxWilliamsPercentRIndicatorComponent);
            i2.TypeRegistrar.register("WilliamsPercentRIndicator", WilliamsPercentRIndicator.$type);
        }
        IgxWilliamsPercentRIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxWilliamsPercentRIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorDynamicModule, imports: [i1.CommonModule, IgxWilliamsPercentRIndicatorModule], exports: [IgxWilliamsPercentRIndicatorModule] });
        IgxWilliamsPercentRIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorDynamicModule, imports: [[i1.CommonModule, IgxWilliamsPercentRIndicatorModule], IgxWilliamsPercentRIndicatorModule] });
        return IgxWilliamsPercentRIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxWilliamsPercentRIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxWilliamsPercentRIndicatorModule],
                        exports: [IgxWilliamsPercentRIndicatorModule],
                        entryComponents: [IgxWilliamsPercentRIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CustomIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomIndicatorStrategy, _super);
        function CustomIndicatorStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CustomIndicatorStrategy.prototype.a = function (a, b) {
            return true;
        };
        CustomIndicatorStrategy.prototype.b = function (a, b) {
            return new i2.List$1(i2.String_$type, 0);
        };
        CustomIndicatorStrategy.$t = i2.markType(CustomIndicatorStrategy, 'CustomIndicatorStrategy', IndicatorCalculationStrategy.$);
        return CustomIndicatorStrategy;
    }(IndicatorCalculationStrategy));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CustomIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomIndicator, _super);
        function CustomIndicator() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.uh = null;
            _this.ug = null;
            return _this;
        }
        CustomIndicator.prototype.get_tv = function () {
            return new CustomIndicatorStrategy();
        };
        Object.defineProperty(CustomIndicator.prototype, "tv", {
            get: function () {
                return this.get_tv();
            },
            enumerable: false,
            configurable: true
        });
        CustomIndicator.prototype.get_t8 = function () {
            return CustomIndicator.$;
        };
        Object.defineProperty(CustomIndicator.prototype, "t8", {
            get: function () {
                return this.get_t8();
            },
            enumerable: false,
            configurable: true
        });
        CustomIndicator.prototype.s7 = function (a, b) {
            var e_1, _a;
            var c = this.p3(a, b);
            var d = this.p4(c);
            var e = new i2.List$1(i2.String_$type, 0);
            if (this.basedOnColumns != null) {
                var f = new FinancialEventArgs(c.calculateFrom, c.calculateCount, c, d, this);
                this.basedOnColumns(this, f);
                if (f.basedOn != null) {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(f.basedOn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var g = _c.value;
                            e.add(g);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
            }
            return e;
        };
        Object.defineProperty(CustomIndicator.prototype, "indicator", {
            get: function () {
                return this.uh;
            },
            set: function (a) {
                this.uh = a;
                this.tf();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CustomIndicator.prototype, "basedOnColumns", {
            get: function () {
                return this.ug;
            },
            set: function (a) {
                this.ug = a;
            },
            enumerable: false,
            configurable: true
        });
        CustomIndicator.prototype.s4 = function (a, b) {
            _super.prototype.s4.call(this, a, b);
            if (this.indicator != null) {
                var c = this.p3(a, b);
                if (b == 0) {
                    return false;
                }
                if (!this.qz(this.s7(a, b))) {
                    return false;
                }
                this.indicator(this, new FinancialEventArgs(a, b, c, this.p4(c), this));
                if (this.tx(c) && this.qc != null) {
                    this.qc.cv();
                }
                return true;
            }
            return false;
        };
        CustomIndicator.$t = i2.markType(CustomIndicator, 'CustomIndicator', StrategyBasedIndicator.$);
        return CustomIndicator;
    }(StrategyBasedIndicator));

    /**
     * Represents a IgxDataChartComponent Custom Indicator series.
     * The indicator value is calculated in the user specified Indicator event handler.
    *
    * `IgxCustomIndicatorComponent` class specify the series as Custom Indicator series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *   <igx-commodity-channel-index-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume" >
    *   </igx-commodity-channel-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxCustomIndicatorComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxCustomIndicatorComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCustomIndicatorComponent, _super);
        function IgxCustomIndicatorComponent() {
            var _this = _super.call(this) || this;
            _this._indicator = null;
            _this._basedOnColumns = null;
            return _this;
        }
        IgxCustomIndicatorComponent.prototype.createImplementation = function () {
            return new CustomIndicator();
        };
        Object.defineProperty(IgxCustomIndicatorComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomIndicatorComponent.prototype, "indicator", {
            /**
             * This event is raised when the indicator values need to be computed.
            */
            get: function () {
                var _this = this;
                if (this._indicator == null) {
                    this._indicator = new i0.EventEmitter();
                    this.i.indicator = i2.delegateCombine(this.i.indicator, function (o, e) {
                        var outerArgs = new IgxFinancialEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._indicator.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._indicator;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomIndicatorComponent.prototype, "basedOnColumns", {
            /**
             * This event is raised when the based on columns to be specified.
            */
            get: function () {
                var _this = this;
                if (this._basedOnColumns == null) {
                    this._basedOnColumns = new i0.EventEmitter();
                    this.i.basedOnColumns = i2.delegateCombine(this.i.indicator, function (o, e) {
                        var outerArgs = new IgxFinancialEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._basedOnColumns.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._indicator;
            },
            enumerable: false,
            configurable: true
        });
        IgxCustomIndicatorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCustomIndicatorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCustomIndicatorComponent, selector: "igx-custom-indicator", outputs: { indicator: "indicator", basedOnColumns: "basedOnColumns" }, providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCustomIndicatorComponent;
    }(IgxStrategyBasedIndicatorComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-custom-indicator',
                        template: "",
                        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxCustomIndicatorComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { indicator: [{
                    type: i0.Output
                }], basedOnColumns: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomIndicatorModule() {
        }
        IgxCustomIndicatorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomIndicatorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorModule, declarations: [IgxCustomIndicatorComponent], imports: [i1.CommonModule, IgxIndicatorProxyModule], exports: [IgxCustomIndicatorComponent, IgxIndicatorProxyModule] });
        IgxCustomIndicatorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorModule, imports: [[i1.CommonModule, IgxIndicatorProxyModule], IgxIndicatorProxyModule] });
        return IgxCustomIndicatorModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCustomIndicatorComponent],
                        imports: [i1.CommonModule, IgxIndicatorProxyModule],
                        exports: [IgxCustomIndicatorComponent, IgxIndicatorProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomIndicatorDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomIndicatorDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCustomIndicatorComponent", IgxCustomIndicatorComponent);
            i2.TypeRegistrar.register("CustomIndicator", CustomIndicator.$type);
        }
        IgxCustomIndicatorDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomIndicatorDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorDynamicModule, imports: [i1.CommonModule, IgxCustomIndicatorModule], exports: [IgxCustomIndicatorModule] });
        IgxCustomIndicatorDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorDynamicModule, imports: [[i1.CommonModule, IgxCustomIndicatorModule], IgxCustomIndicatorModule] });
        return IgxCustomIndicatorDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomIndicatorDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCustomIndicatorModule],
                        exports: [IgxCustomIndicatorModule],
                        entryComponents: [IgxCustomIndicatorComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxIndicatorsModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxIndicatorsModule() {
        }
        IgxIndicatorsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxIndicatorsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsModule, imports: [i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule,
                IgxAccumulationDistributionIndicatorModule,
                IgxAverageDirectionalIndexIndicatorModule,
                IgxAverageTrueRangeIndicatorModule,
                IgxBollingerBandWidthIndicatorModule,
                IgxChaikinOscillatorIndicatorModule,
                IgxChaikinVolatilityIndicatorModule,
                IgxCommodityChannelIndexIndicatorModule,
                IgxDetrendedPriceOscillatorIndicatorModule,
                IgxEaseOfMovementIndicatorModule,
                IgxFastStochasticOscillatorIndicatorModule,
                IgxForceIndexIndicatorModule,
                IgxFullStochasticOscillatorIndicatorModule,
                IgxMarketFacilitationIndexIndicatorModule,
                IgxMassIndexIndicatorModule,
                IgxMedianPriceIndicatorModule,
                IgxMoneyFlowIndexIndicatorModule,
                IgxMovingAverageConvergenceDivergenceIndicatorModule,
                IgxNegativeVolumeIndexIndicatorModule,
                IgxOnBalanceVolumeIndicatorModule,
                IgxPercentagePriceOscillatorIndicatorModule,
                IgxPercentageVolumeOscillatorIndicatorModule,
                IgxPositiveVolumeIndexIndicatorModule,
                IgxPriceVolumeTrendIndicatorModule,
                IgxRateOfChangeAndMomentumIndicatorModule,
                IgxRelativeStrengthIndexIndicatorModule,
                IgxSlowStochasticOscillatorIndicatorModule,
                IgxStandardDeviationIndicatorModule,
                IgxStochRSIIndicatorModule,
                IgxTRIXIndicatorModule,
                IgxTypicalPriceIndicatorModule,
                IgxUltimateOscillatorIndicatorModule,
                IgxWeightedCloseIndicatorModule,
                IgxWilliamsPercentRIndicatorModule,
                IgxCustomIndicatorModule], exports: [IgxAbsoluteVolumeOscillatorIndicatorModule,
                IgxAccumulationDistributionIndicatorModule,
                IgxAverageDirectionalIndexIndicatorModule,
                IgxAverageTrueRangeIndicatorModule,
                IgxBollingerBandWidthIndicatorModule,
                IgxChaikinOscillatorIndicatorModule,
                IgxChaikinVolatilityIndicatorModule,
                IgxCommodityChannelIndexIndicatorModule,
                IgxDetrendedPriceOscillatorIndicatorModule,
                IgxEaseOfMovementIndicatorModule,
                IgxFastStochasticOscillatorIndicatorModule,
                IgxForceIndexIndicatorModule,
                IgxFullStochasticOscillatorIndicatorModule,
                IgxMarketFacilitationIndexIndicatorModule,
                IgxMassIndexIndicatorModule,
                IgxMedianPriceIndicatorModule,
                IgxMoneyFlowIndexIndicatorModule,
                IgxMovingAverageConvergenceDivergenceIndicatorModule,
                IgxNegativeVolumeIndexIndicatorModule,
                IgxOnBalanceVolumeIndicatorModule,
                IgxPercentagePriceOscillatorIndicatorModule,
                IgxPercentageVolumeOscillatorIndicatorModule,
                IgxPositiveVolumeIndexIndicatorModule,
                IgxPriceVolumeTrendIndicatorModule,
                IgxRateOfChangeAndMomentumIndicatorModule,
                IgxRelativeStrengthIndexIndicatorModule,
                IgxSlowStochasticOscillatorIndicatorModule,
                IgxStandardDeviationIndicatorModule,
                IgxStochRSIIndicatorModule,
                IgxTRIXIndicatorModule,
                IgxTypicalPriceIndicatorModule,
                IgxUltimateOscillatorIndicatorModule,
                IgxWeightedCloseIndicatorModule,
                IgxWilliamsPercentRIndicatorModule,
                IgxCustomIndicatorModule] });
        IgxIndicatorsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsModule, imports: [[i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule,
                    IgxAccumulationDistributionIndicatorModule,
                    IgxAverageDirectionalIndexIndicatorModule,
                    IgxAverageTrueRangeIndicatorModule,
                    IgxBollingerBandWidthIndicatorModule,
                    IgxChaikinOscillatorIndicatorModule,
                    IgxChaikinVolatilityIndicatorModule,
                    IgxCommodityChannelIndexIndicatorModule,
                    IgxDetrendedPriceOscillatorIndicatorModule,
                    IgxEaseOfMovementIndicatorModule,
                    IgxFastStochasticOscillatorIndicatorModule,
                    IgxForceIndexIndicatorModule,
                    IgxFullStochasticOscillatorIndicatorModule,
                    IgxMarketFacilitationIndexIndicatorModule,
                    IgxMassIndexIndicatorModule,
                    IgxMedianPriceIndicatorModule,
                    IgxMoneyFlowIndexIndicatorModule,
                    IgxMovingAverageConvergenceDivergenceIndicatorModule,
                    IgxNegativeVolumeIndexIndicatorModule,
                    IgxOnBalanceVolumeIndicatorModule,
                    IgxPercentagePriceOscillatorIndicatorModule,
                    IgxPercentageVolumeOscillatorIndicatorModule,
                    IgxPositiveVolumeIndexIndicatorModule,
                    IgxPriceVolumeTrendIndicatorModule,
                    IgxRateOfChangeAndMomentumIndicatorModule,
                    IgxRelativeStrengthIndexIndicatorModule,
                    IgxSlowStochasticOscillatorIndicatorModule,
                    IgxStandardDeviationIndicatorModule,
                    IgxStochRSIIndicatorModule,
                    IgxTRIXIndicatorModule,
                    IgxTypicalPriceIndicatorModule,
                    IgxUltimateOscillatorIndicatorModule,
                    IgxWeightedCloseIndicatorModule,
                    IgxWilliamsPercentRIndicatorModule,
                    IgxCustomIndicatorModule
                ], IgxAbsoluteVolumeOscillatorIndicatorModule,
                IgxAccumulationDistributionIndicatorModule,
                IgxAverageDirectionalIndexIndicatorModule,
                IgxAverageTrueRangeIndicatorModule,
                IgxBollingerBandWidthIndicatorModule,
                IgxChaikinOscillatorIndicatorModule,
                IgxChaikinVolatilityIndicatorModule,
                IgxCommodityChannelIndexIndicatorModule,
                IgxDetrendedPriceOscillatorIndicatorModule,
                IgxEaseOfMovementIndicatorModule,
                IgxFastStochasticOscillatorIndicatorModule,
                IgxForceIndexIndicatorModule,
                IgxFullStochasticOscillatorIndicatorModule,
                IgxMarketFacilitationIndexIndicatorModule,
                IgxMassIndexIndicatorModule,
                IgxMedianPriceIndicatorModule,
                IgxMoneyFlowIndexIndicatorModule,
                IgxMovingAverageConvergenceDivergenceIndicatorModule,
                IgxNegativeVolumeIndexIndicatorModule,
                IgxOnBalanceVolumeIndicatorModule,
                IgxPercentagePriceOscillatorIndicatorModule,
                IgxPercentageVolumeOscillatorIndicatorModule,
                IgxPositiveVolumeIndexIndicatorModule,
                IgxPriceVolumeTrendIndicatorModule,
                IgxRateOfChangeAndMomentumIndicatorModule,
                IgxRelativeStrengthIndexIndicatorModule,
                IgxSlowStochasticOscillatorIndicatorModule,
                IgxStandardDeviationIndicatorModule,
                IgxStochRSIIndicatorModule,
                IgxTRIXIndicatorModule,
                IgxTypicalPriceIndicatorModule,
                IgxUltimateOscillatorIndicatorModule,
                IgxWeightedCloseIndicatorModule,
                IgxWilliamsPercentRIndicatorModule,
                IgxCustomIndicatorModule] });
        return IgxIndicatorsModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxAbsoluteVolumeOscillatorIndicatorModule,
                            IgxAccumulationDistributionIndicatorModule,
                            IgxAverageDirectionalIndexIndicatorModule,
                            IgxAverageTrueRangeIndicatorModule,
                            IgxBollingerBandWidthIndicatorModule,
                            IgxChaikinOscillatorIndicatorModule,
                            IgxChaikinVolatilityIndicatorModule,
                            IgxCommodityChannelIndexIndicatorModule,
                            IgxDetrendedPriceOscillatorIndicatorModule,
                            IgxEaseOfMovementIndicatorModule,
                            IgxFastStochasticOscillatorIndicatorModule,
                            IgxForceIndexIndicatorModule,
                            IgxFullStochasticOscillatorIndicatorModule,
                            IgxMarketFacilitationIndexIndicatorModule,
                            IgxMassIndexIndicatorModule,
                            IgxMedianPriceIndicatorModule,
                            IgxMoneyFlowIndexIndicatorModule,
                            IgxMovingAverageConvergenceDivergenceIndicatorModule,
                            IgxNegativeVolumeIndexIndicatorModule,
                            IgxOnBalanceVolumeIndicatorModule,
                            IgxPercentagePriceOscillatorIndicatorModule,
                            IgxPercentageVolumeOscillatorIndicatorModule,
                            IgxPositiveVolumeIndexIndicatorModule,
                            IgxPriceVolumeTrendIndicatorModule,
                            IgxRateOfChangeAndMomentumIndicatorModule,
                            IgxRelativeStrengthIndexIndicatorModule,
                            IgxSlowStochasticOscillatorIndicatorModule,
                            IgxStandardDeviationIndicatorModule,
                            IgxStochRSIIndicatorModule,
                            IgxTRIXIndicatorModule,
                            IgxTypicalPriceIndicatorModule,
                            IgxUltimateOscillatorIndicatorModule,
                            IgxWeightedCloseIndicatorModule,
                            IgxWilliamsPercentRIndicatorModule,
                            IgxCustomIndicatorModule
                        ],
                        imports: [i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule,
                            IgxAccumulationDistributionIndicatorModule,
                            IgxAverageDirectionalIndexIndicatorModule,
                            IgxAverageTrueRangeIndicatorModule,
                            IgxBollingerBandWidthIndicatorModule,
                            IgxChaikinOscillatorIndicatorModule,
                            IgxChaikinVolatilityIndicatorModule,
                            IgxCommodityChannelIndexIndicatorModule,
                            IgxDetrendedPriceOscillatorIndicatorModule,
                            IgxEaseOfMovementIndicatorModule,
                            IgxFastStochasticOscillatorIndicatorModule,
                            IgxForceIndexIndicatorModule,
                            IgxFullStochasticOscillatorIndicatorModule,
                            IgxMarketFacilitationIndexIndicatorModule,
                            IgxMassIndexIndicatorModule,
                            IgxMedianPriceIndicatorModule,
                            IgxMoneyFlowIndexIndicatorModule,
                            IgxMovingAverageConvergenceDivergenceIndicatorModule,
                            IgxNegativeVolumeIndexIndicatorModule,
                            IgxOnBalanceVolumeIndicatorModule,
                            IgxPercentagePriceOscillatorIndicatorModule,
                            IgxPercentageVolumeOscillatorIndicatorModule,
                            IgxPositiveVolumeIndexIndicatorModule,
                            IgxPriceVolumeTrendIndicatorModule,
                            IgxRateOfChangeAndMomentumIndicatorModule,
                            IgxRelativeStrengthIndexIndicatorModule,
                            IgxSlowStochasticOscillatorIndicatorModule,
                            IgxStandardDeviationIndicatorModule,
                            IgxStochRSIIndicatorModule,
                            IgxTRIXIndicatorModule,
                            IgxTypicalPriceIndicatorModule,
                            IgxUltimateOscillatorIndicatorModule,
                            IgxWeightedCloseIndicatorModule,
                            IgxWilliamsPercentRIndicatorModule,
                            IgxCustomIndicatorModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxIndicatorsDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxIndicatorsDynamicModule() {
        }
        IgxIndicatorsDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxIndicatorsDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsDynamicModule, imports: [i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
                IgxAccumulationDistributionIndicatorDynamicModule,
                IgxAverageDirectionalIndexIndicatorDynamicModule,
                IgxAverageTrueRangeIndicatorDynamicModule,
                IgxBollingerBandWidthIndicatorDynamicModule,
                IgxChaikinOscillatorIndicatorDynamicModule,
                IgxChaikinVolatilityIndicatorDynamicModule,
                IgxCommodityChannelIndexIndicatorDynamicModule,
                IgxDetrendedPriceOscillatorIndicatorDynamicModule,
                IgxEaseOfMovementIndicatorDynamicModule,
                IgxFastStochasticOscillatorIndicatorDynamicModule,
                IgxForceIndexIndicatorDynamicModule,
                IgxFullStochasticOscillatorIndicatorDynamicModule,
                IgxMarketFacilitationIndexIndicatorDynamicModule,
                IgxMassIndexIndicatorDynamicModule,
                IgxMedianPriceIndicatorDynamicModule,
                IgxMoneyFlowIndexIndicatorDynamicModule,
                IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
                IgxNegativeVolumeIndexIndicatorDynamicModule,
                IgxOnBalanceVolumeIndicatorDynamicModule,
                IgxPercentagePriceOscillatorIndicatorDynamicModule,
                IgxPercentageVolumeOscillatorIndicatorDynamicModule,
                IgxPositiveVolumeIndexIndicatorDynamicModule,
                IgxPriceVolumeTrendIndicatorDynamicModule,
                IgxRateOfChangeAndMomentumIndicatorDynamicModule,
                IgxRelativeStrengthIndexIndicatorDynamicModule,
                IgxSlowStochasticOscillatorIndicatorDynamicModule,
                IgxStandardDeviationIndicatorDynamicModule,
                IgxStochRSIIndicatorDynamicModule,
                IgxTRIXIndicatorDynamicModule,
                IgxTypicalPriceIndicatorDynamicModule,
                IgxUltimateOscillatorIndicatorDynamicModule,
                IgxWeightedCloseIndicatorDynamicModule,
                IgxWilliamsPercentRIndicatorDynamicModule,
                IgxCustomIndicatorDynamicModule,
                IgxIndicatorsModule], exports: [IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
                IgxAccumulationDistributionIndicatorDynamicModule,
                IgxAverageDirectionalIndexIndicatorDynamicModule,
                IgxAverageTrueRangeIndicatorDynamicModule,
                IgxBollingerBandWidthIndicatorDynamicModule,
                IgxChaikinOscillatorIndicatorDynamicModule,
                IgxChaikinVolatilityIndicatorDynamicModule,
                IgxCommodityChannelIndexIndicatorDynamicModule,
                IgxDetrendedPriceOscillatorIndicatorDynamicModule,
                IgxEaseOfMovementIndicatorDynamicModule,
                IgxFastStochasticOscillatorIndicatorDynamicModule,
                IgxForceIndexIndicatorDynamicModule,
                IgxFullStochasticOscillatorIndicatorDynamicModule,
                IgxMarketFacilitationIndexIndicatorDynamicModule,
                IgxMassIndexIndicatorDynamicModule,
                IgxMedianPriceIndicatorDynamicModule,
                IgxMoneyFlowIndexIndicatorDynamicModule,
                IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
                IgxNegativeVolumeIndexIndicatorDynamicModule,
                IgxOnBalanceVolumeIndicatorDynamicModule,
                IgxPercentagePriceOscillatorIndicatorDynamicModule,
                IgxPercentageVolumeOscillatorIndicatorDynamicModule,
                IgxPositiveVolumeIndexIndicatorDynamicModule,
                IgxPriceVolumeTrendIndicatorDynamicModule,
                IgxRateOfChangeAndMomentumIndicatorDynamicModule,
                IgxRelativeStrengthIndexIndicatorDynamicModule,
                IgxSlowStochasticOscillatorIndicatorDynamicModule,
                IgxStandardDeviationIndicatorDynamicModule,
                IgxStochRSIIndicatorDynamicModule,
                IgxTRIXIndicatorDynamicModule,
                IgxTypicalPriceIndicatorDynamicModule,
                IgxUltimateOscillatorIndicatorDynamicModule,
                IgxWeightedCloseIndicatorDynamicModule,
                IgxWilliamsPercentRIndicatorDynamicModule,
                IgxCustomIndicatorDynamicModule,
                IgxIndicatorsModule] });
        IgxIndicatorsDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsDynamicModule, imports: [[i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
                    IgxAccumulationDistributionIndicatorDynamicModule,
                    IgxAverageDirectionalIndexIndicatorDynamicModule,
                    IgxAverageTrueRangeIndicatorDynamicModule,
                    IgxBollingerBandWidthIndicatorDynamicModule,
                    IgxChaikinOscillatorIndicatorDynamicModule,
                    IgxChaikinVolatilityIndicatorDynamicModule,
                    IgxCommodityChannelIndexIndicatorDynamicModule,
                    IgxDetrendedPriceOscillatorIndicatorDynamicModule,
                    IgxEaseOfMovementIndicatorDynamicModule,
                    IgxFastStochasticOscillatorIndicatorDynamicModule,
                    IgxForceIndexIndicatorDynamicModule,
                    IgxFullStochasticOscillatorIndicatorDynamicModule,
                    IgxMarketFacilitationIndexIndicatorDynamicModule,
                    IgxMassIndexIndicatorDynamicModule,
                    IgxMedianPriceIndicatorDynamicModule,
                    IgxMoneyFlowIndexIndicatorDynamicModule,
                    IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
                    IgxNegativeVolumeIndexIndicatorDynamicModule,
                    IgxOnBalanceVolumeIndicatorDynamicModule,
                    IgxPercentagePriceOscillatorIndicatorDynamicModule,
                    IgxPercentageVolumeOscillatorIndicatorDynamicModule,
                    IgxPositiveVolumeIndexIndicatorDynamicModule,
                    IgxPriceVolumeTrendIndicatorDynamicModule,
                    IgxRateOfChangeAndMomentumIndicatorDynamicModule,
                    IgxRelativeStrengthIndexIndicatorDynamicModule,
                    IgxSlowStochasticOscillatorIndicatorDynamicModule,
                    IgxStandardDeviationIndicatorDynamicModule,
                    IgxStochRSIIndicatorDynamicModule,
                    IgxTRIXIndicatorDynamicModule,
                    IgxTypicalPriceIndicatorDynamicModule,
                    IgxUltimateOscillatorIndicatorDynamicModule,
                    IgxWeightedCloseIndicatorDynamicModule,
                    IgxWilliamsPercentRIndicatorDynamicModule,
                    IgxCustomIndicatorDynamicModule,
                    IgxIndicatorsModule
                ], IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
                IgxAccumulationDistributionIndicatorDynamicModule,
                IgxAverageDirectionalIndexIndicatorDynamicModule,
                IgxAverageTrueRangeIndicatorDynamicModule,
                IgxBollingerBandWidthIndicatorDynamicModule,
                IgxChaikinOscillatorIndicatorDynamicModule,
                IgxChaikinVolatilityIndicatorDynamicModule,
                IgxCommodityChannelIndexIndicatorDynamicModule,
                IgxDetrendedPriceOscillatorIndicatorDynamicModule,
                IgxEaseOfMovementIndicatorDynamicModule,
                IgxFastStochasticOscillatorIndicatorDynamicModule,
                IgxForceIndexIndicatorDynamicModule,
                IgxFullStochasticOscillatorIndicatorDynamicModule,
                IgxMarketFacilitationIndexIndicatorDynamicModule,
                IgxMassIndexIndicatorDynamicModule,
                IgxMedianPriceIndicatorDynamicModule,
                IgxMoneyFlowIndexIndicatorDynamicModule,
                IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
                IgxNegativeVolumeIndexIndicatorDynamicModule,
                IgxOnBalanceVolumeIndicatorDynamicModule,
                IgxPercentagePriceOscillatorIndicatorDynamicModule,
                IgxPercentageVolumeOscillatorIndicatorDynamicModule,
                IgxPositiveVolumeIndexIndicatorDynamicModule,
                IgxPriceVolumeTrendIndicatorDynamicModule,
                IgxRateOfChangeAndMomentumIndicatorDynamicModule,
                IgxRelativeStrengthIndexIndicatorDynamicModule,
                IgxSlowStochasticOscillatorIndicatorDynamicModule,
                IgxStandardDeviationIndicatorDynamicModule,
                IgxStochRSIIndicatorDynamicModule,
                IgxTRIXIndicatorDynamicModule,
                IgxTypicalPriceIndicatorDynamicModule,
                IgxUltimateOscillatorIndicatorDynamicModule,
                IgxWeightedCloseIndicatorDynamicModule,
                IgxWilliamsPercentRIndicatorDynamicModule,
                IgxCustomIndicatorDynamicModule,
                IgxIndicatorsModule] });
        return IgxIndicatorsDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxIndicatorsDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
                            IgxAccumulationDistributionIndicatorDynamicModule,
                            IgxAverageDirectionalIndexIndicatorDynamicModule,
                            IgxAverageTrueRangeIndicatorDynamicModule,
                            IgxBollingerBandWidthIndicatorDynamicModule,
                            IgxChaikinOscillatorIndicatorDynamicModule,
                            IgxChaikinVolatilityIndicatorDynamicModule,
                            IgxCommodityChannelIndexIndicatorDynamicModule,
                            IgxDetrendedPriceOscillatorIndicatorDynamicModule,
                            IgxEaseOfMovementIndicatorDynamicModule,
                            IgxFastStochasticOscillatorIndicatorDynamicModule,
                            IgxForceIndexIndicatorDynamicModule,
                            IgxFullStochasticOscillatorIndicatorDynamicModule,
                            IgxMarketFacilitationIndexIndicatorDynamicModule,
                            IgxMassIndexIndicatorDynamicModule,
                            IgxMedianPriceIndicatorDynamicModule,
                            IgxMoneyFlowIndexIndicatorDynamicModule,
                            IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
                            IgxNegativeVolumeIndexIndicatorDynamicModule,
                            IgxOnBalanceVolumeIndicatorDynamicModule,
                            IgxPercentagePriceOscillatorIndicatorDynamicModule,
                            IgxPercentageVolumeOscillatorIndicatorDynamicModule,
                            IgxPositiveVolumeIndexIndicatorDynamicModule,
                            IgxPriceVolumeTrendIndicatorDynamicModule,
                            IgxRateOfChangeAndMomentumIndicatorDynamicModule,
                            IgxRelativeStrengthIndexIndicatorDynamicModule,
                            IgxSlowStochasticOscillatorIndicatorDynamicModule,
                            IgxStandardDeviationIndicatorDynamicModule,
                            IgxStochRSIIndicatorDynamicModule,
                            IgxTRIXIndicatorDynamicModule,
                            IgxTypicalPriceIndicatorDynamicModule,
                            IgxUltimateOscillatorIndicatorDynamicModule,
                            IgxWeightedCloseIndicatorDynamicModule,
                            IgxWilliamsPercentRIndicatorDynamicModule,
                            IgxCustomIndicatorDynamicModule,
                            IgxIndicatorsModule
                        ],
                        imports: [i1.CommonModule, IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
                            IgxAccumulationDistributionIndicatorDynamicModule,
                            IgxAverageDirectionalIndexIndicatorDynamicModule,
                            IgxAverageTrueRangeIndicatorDynamicModule,
                            IgxBollingerBandWidthIndicatorDynamicModule,
                            IgxChaikinOscillatorIndicatorDynamicModule,
                            IgxChaikinVolatilityIndicatorDynamicModule,
                            IgxCommodityChannelIndexIndicatorDynamicModule,
                            IgxDetrendedPriceOscillatorIndicatorDynamicModule,
                            IgxEaseOfMovementIndicatorDynamicModule,
                            IgxFastStochasticOscillatorIndicatorDynamicModule,
                            IgxForceIndexIndicatorDynamicModule,
                            IgxFullStochasticOscillatorIndicatorDynamicModule,
                            IgxMarketFacilitationIndexIndicatorDynamicModule,
                            IgxMassIndexIndicatorDynamicModule,
                            IgxMedianPriceIndicatorDynamicModule,
                            IgxMoneyFlowIndexIndicatorDynamicModule,
                            IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
                            IgxNegativeVolumeIndexIndicatorDynamicModule,
                            IgxOnBalanceVolumeIndicatorDynamicModule,
                            IgxPercentagePriceOscillatorIndicatorDynamicModule,
                            IgxPercentageVolumeOscillatorIndicatorDynamicModule,
                            IgxPositiveVolumeIndexIndicatorDynamicModule,
                            IgxPriceVolumeTrendIndicatorDynamicModule,
                            IgxRateOfChangeAndMomentumIndicatorDynamicModule,
                            IgxRelativeStrengthIndexIndicatorDynamicModule,
                            IgxSlowStochasticOscillatorIndicatorDynamicModule,
                            IgxStandardDeviationIndicatorDynamicModule,
                            IgxStochRSIIndicatorDynamicModule,
                            IgxTRIXIndicatorDynamicModule,
                            IgxTypicalPriceIndicatorDynamicModule,
                            IgxUltimateOscillatorIndicatorDynamicModule,
                            IgxWeightedCloseIndicatorDynamicModule,
                            IgxWilliamsPercentRIndicatorDynamicModule,
                            IgxCustomIndicatorDynamicModule,
                            IgxIndicatorsModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /**
     * Represents the base functionality for a IgxDataChartComponent financial overlay series.
     * The difference between a FinancialIndicator and a FinancialOverlay is small.
     * Overlays are usually drawn against the same axes as the price, but they don't
     * have to be. Overlays mostly display multiple values, but not all of them, and so
     * so some indicators.
    *
    * The `IgxFinancialOverlayComponent` class represents the base functionality for a IgxDataChartComponent financial overlay series.
    *
    * ```html
    * <igx-data-chart
    * #chart
    * [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    * dateTimeMemberPath="TimeStamp"
    * #xAxis
    * >
    * </igx-ordinal-time-x-axis>
    * <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    * </igx-numeric-y-axis>
    * <igx-bollinger-bands-overlay
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume">
    * </igx-bollinger-bands-overlay>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxBollingerBandsOverlayComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    var IgxFinancialOverlayComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialOverlayComponent, _super);
        function IgxFinancialOverlayComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxFinancialOverlayComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialOverlayComponent.prototype, "isFinancialOverlay", {
            /**
             * Gets whether the series is financial overlay
            */
            get: function () {
                return this.i.dk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialOverlayComponent.prototype, "ignoreFirst", {
            /**
             * Gets or sets the number of values to hide at the beginning of the indicator.
            *
            * Use the `ignoreFirst` property to sets the number of values to hide at the beginning of the indicator.
            *
            * ```ts
            *  series.ignoreFirst=2;
            * ```
            *
            * ```html
            *    <igx-data-chart
            *    #chart
            *        [dataSource]="data" >
            *  <igx-category-x-axis
            *        label="label"
            *        #xAxis>
            *        </igx-category-x-axis>
            * <igx-numeric-y-axis
            *        minimumValue="0"
            *        #yAxis>
            * </igx-numeric-y-axis>
            * <igx-bollinger-bands-overlay
            *    [xAxis]="xAxis"
            *      [yAxis]="yAxis"
            *      openMemberPath="open"
            *      highMemberPath="high"
            *      lowMemberPath="low"
            *      closeMemberPath="close"
            *      volumeMemberPath="volume"
            * 	  ignoreFirst="2">
            * </igx-bollinger-bands-overlay>
            *  </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.s2;
            },
            set: function (v) {
                this.i.s2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        *
        * Use the `scrollIntoView` method to scrolls the series to display the item for the specified data item.
        */
        IgxFinancialOverlayComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        IgxFinancialOverlayComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialOverlayComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialOverlayComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialOverlayComponent, selector: "ng-component", inputs: { ignoreFirst: "ignoreFirst" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxFinancialOverlayComponent;
    }(IgxFinancialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialOverlayComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { ignoreFirst: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialOverlay, _super);
        function FinancialOverlay() {
            var _this = _super.call(this) || this;
            _this.s0 = false;
            _this.s0 = false;
            return _this;
        }
        FinancialOverlay.prototype.get_dk = function () {
            return true;
        };
        FinancialOverlay.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                this.pq.i$i();
            }
            this.p7.bx.e(this.gh);
            this.s1();
            if (this.qc != null) {
                this.qc.cv();
            }
            this.l0(true);
        };
        FinancialOverlay.prototype.get_e2 = function () {
            return true;
        };
        FinancialOverlay.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case "FastItemsSource":
                    this.s0 = false;
                    break;
                case FinancialOverlay.$$p[0]:
                    this.s0 = false;
                    this.l0(false);
                    this.k7();
                    break;
                case "XAxis":
                    this.s0 = false;
                    break;
            }
            _super.prototype.lm.call(this, a, b, c, d);
        };
        FinancialOverlay.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        FinancialOverlay.prototype.ep = function (a, b) {
            if (this.eo(a, b)) {
                return true;
            }
            return false;
        };
        FinancialOverlay.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        FinancialOverlay.prototype.eh = function (a) {
            var b = this.ch != null ? this.ch.indexOf(a) : -1;
            var c = this.bx.bv;
            c = c.copy();
            var d = this.bx.bu;
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = this.o9(this.bx);
            var g = new ScalerParams(0, e, e, this.pq.cc, f);
            var h = new ScalerParams(0, e, e, this.qc.cc, f);
            h.b = this.f2();
            if (b >= 0 && i2.Rect.l_op_Inequality(c, null) && i2.Rect.l_op_Inequality(d, null)) {
                if (this.pq != null) {
                    var i = this.pq.d8(b, g);
                    if (i < c.left + 0.1 * c.width) {
                        i = i + 0.4 * c.width;
                    }
                    if (i > c.right - 0.1 * c.width) {
                        i = i - 0.4 * c.width;
                    }
                    c.x = i - 0.5 * c.width;
                }
                if (this.qc != null && this.ql != null && this.qk != null && b < this.ql.count && b < this.qk.count) {
                    var j = this.qc.d8(this.ql.item(b), h);
                    var k = this.qc.d8(this.qk.item(b), h);
                    if (!i2.isNaN_(j) && !i2.isNaN_(k)) {
                        var l = Math.abs(j - k);
                        if (c.height < l) {
                            c.height = l;
                            c.y = Math.min(j, k);
                        }
                        else {
                            if (j < c.top + 0.1 * c.height) {
                                j = j + 0.4 * c.height;
                            }
                            if (j > c.bottom - 0.1 * c.height) {
                                j = j - 0.4 * c.height;
                            }
                            c.y = j - 0.5 * c.height;
                        }
                    }
                }
                this.b5.ap(this.ca, c, true);
            }
            return b >= 0;
        };
        FinancialOverlay.prototype.ap = function (a) {
            if (a != null && a == this.qc && this.ql != null && this.qk != null) {
                return new AxisRange(this.ql.minimum, this.qk.maximum);
            }
            return null;
        };
        FinancialOverlay.$t = i2.markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
        FinancialOverlay.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:s2:s4', [1, 0]]);
        return FinancialOverlay;
    }(FinancialSeries));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PriceChannelOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PriceChannelOverlay, _super);
        function PriceChannelOverlay() {
            var _this = _super.call(this) || this;
            _this.s7 = new i2.List$1(i2.Number_$type, 0);
            _this.s6 = new i2.List$1(i2.Number_$type, 0);
            _this.ab = PriceChannelOverlay.$;
            _this.pu = new CategoryFrame(3);
            _this.pw = new CategoryFrame(3);
            _this.ps = new CategoryFrame(3);
            return _this;
        }
        PriceChannelOverlay.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case "HighColumn":
                case "LowColumn":
                    this.s0 = false;
                    break;
            }
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case PriceChannelOverlay.$$p[0]:
                    this.s0 = false;
                    this.l0(false);
                    break;
            }
        };
        PriceChannelOverlay.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (this.qk == null || this.ql == null) {
                d = false;
            }
            return d;
        };
        PriceChannelOverlay.prototype.s1 = function () {
            this.s7.clear();
            this.s6.clear();
            var a = i2.truncate(i2.MathUtil.b(this.s8, 0, this.ch.count));
            var b = Math.min(this.qk.count, this.ql.count);
            var c = this.ra(this.qk);
            var d = this.ra(this.ql);
            for (var e = 0; e < b; e++) {
                var f = Math.min(a, e);
                var g = -1.7976931348623157E+308;
                var h = 1.7976931348623157E+308;
                for (var i = 0; i < f; i++) {
                    if (!i2.isNaN_(c.item(e - i))) {
                        g = Math.max(g, c.item(e - i));
                    }
                    if (!i2.isNaN_(d.item(e - i))) {
                        h = Math.min(h, d.item(e - i));
                    }
                }
                if (e == 0) {
                    h = d.item(0);
                    g = c.item(0);
                }
                this.s7.add(g);
                this.s6.add(h);
            }
            return true;
        };
        PriceChannelOverlay.prototype.sh = function (a, b) {
            _super.prototype.sh.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = new ScalerParams(0, c, d, this.pq.cc, e);
            var g = new ScalerParams(0, c, d, this.qc.cc, e);
            g.b = this.f2();
            var h = this.pq;
            var i = this.qc;
            a.f.clear();
            a.m.clear();
            a.p.clear();
            var j = 0;
            var k = i2.typeCast(ISortingAxis_$type, this.pq);
            if (k != null && k.i$b.count != this.ch.count) {
                return;
            }
            j = this.rh(c, d, e);
            if (!this.s0) {
                this.s0 = this.s1();
            }
            g.b = this.f2();
            var l = this.pq.eb(2, f) - this.pq.eb(1, f);
            for (var m = b.bx.c; m <= b.bx.d; ++m) {
                var n = void 0;
                if (k == null) {
                    n = b.bx.getBucket(m);
                }
                else {
                    var o = k.i$b._inner[m];
                    var p = k.i$d(o);
                    var q = this.s7._inner[m];
                    var r = this.s6._inner[m];
                    var s = q;
                    var t = r;
                    var u = p;
                    while (m < b.bx.d) {
                        o = k.i$b._inner[m + 1];
                        u = k.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s = Math.max(q, this.s7._inner[m]);
                        t = Math.min(r, this.s6._inner[m]);
                    }
                    if (!i2.isInfinity(t) && !i2.isInfinity(s)) {
                        var v = NaN;
                        if (!i2.isNaN_(p)) {
                            v = this.pq.d8(p, f);
                        }
                        n = [v, t, s];
                    }
                    else {
                        n = [NaN, NaN, NaN];
                    }
                }
                var w = Math.max(1, l);
                if (!i2.isNaN_(n[0]) && m * w >= this.s2) {
                    if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                        n[0] = n[0] + j;
                    }
                    else {
                        n[0] = h.d8(n[0], f) + j;
                    }
                    n[1] = i.d8(n[1], g);
                    n[2] = i.d8(n[2], g);
                    a.f.add(n);
                }
            }
        };
        PriceChannelOverlay.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (c != null) {
                c.b4();
            }
        };
        PriceChannelOverlay.prototype.sj = function (a, b) {
            _super.prototype.sj.call(this, a, b);
            var c = i2.typeCast(PriceChannelOverlayView.$, b);
            if (c == null) {
                return;
            }
            var d = this.getEffectiveViewport1(b);
            if (b.b0(a)) {
                c.b4();
                var e_1 = a.f.count;
                var f = function (g) { return a.f._inner[g][0]; };
                var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
                var h = function (i) { return a.f._inner[i][1]; };
                var i = function (j) { return a.f._inner[e_1 - 1 - j][2]; };
                c.b5(e_1, f, g, h, i);
                b.b2(a);
            }
            this.pz.a0(this, this.qy(), i2.runOn(this, this.pi), this.rn(b), this.rp(b));
            var j = false;
            var k = this.pz.b;
            var l = a.f;
            var m = this.ch.count;
            if (k != null) {
                j = true;
            }
            if (j) {
                var n = new ScalerParams(0, b.bv, b.bu, this.pq.cc, d);
                this.sg(l, -1, m, this.pq, n, b.q);
            }
            var o = c.cb;
            var p = c.cc;
            var q = c.b7;
            this.pz.ad(o, true, false, true, true);
            this.pz.ad(p, true, false, true, true);
            this.pz.ad(q, false, true, false, false);
            q._opacity = this.pz.j * this.fi;
        };
        PriceChannelOverlay.prototype.bu = function () {
            return new PriceChannelOverlayView(this);
        };
        PriceChannelOverlay.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.s5 = i2.typeCast(PriceChannelOverlayView.$, a);
        };
        PriceChannelOverlay.prototype.f8 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.ca.pg, this.bx.bu, this.pq.cc, d);
            var f = this.rh(this.ca.pg, this.bx.bu, d);
            return this.ga(new RangeValueList(this.s7, this.s6), a, this.pq, e, f, i2.runOn(this, this.rg), b, c);
        };
        PriceChannelOverlay.prototype.g4 = function (a, b) {
            if (this.s7 == null || this.s6 == null) {
                return _super.prototype.g4.call(this, a, b);
            }
            return this.g5(a, b, this.pq, i2.runOn(this, this.rg), new RangeValueList(this.s7, this.s6));
        };
        PriceChannelOverlay.prototype.g6 = function (a, b) {
            if (this.s7 == null || this.s6 == null) {
                return _super.prototype.g6.call(this, a, b);
            }
            return this.g7(a, b, this.pq, i2.runOn(this, this.rg), new RangeValueList(this.s7, this.s6));
        };
        PriceChannelOverlay.prototype.f2 = function () {
            return Series.f3(this.s6, null);
        };
        PriceChannelOverlay.$t = i2.markType(PriceChannelOverlay, 'PriceChannelOverlay', FinancialOverlay.$);
        PriceChannelOverlay.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PriceChannelOverlay, 'raisePropertyChanged', ['Period:s8:ta', [1, 14]]);
        return PriceChannelOverlay;
    }(FinancialOverlay));
    /**
     * @hidden
     */
    var PriceChannelBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PriceChannelBucketCalculator, _super);
        function PriceChannelBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.f = null;
            _this.f = a;
            return _this;
        }
        PriceChannelBucketCalculator.prototype.getBucket = function (a) {
            var b = a * this.b;
            var c = Math.min(b + this.b - 1, this.a.bz.ch.count - 1);
            if (b <= c) {
                var d = -1.7976931348623157E+308;
                var e = 1.7976931348623157E+308;
                var f = 0;
                for (var g = b; g <= c; ++g) {
                    if (!i2.isNaN_(this.f.b3.s7._inner[g]) && !i2.isNaN_(this.f.b3.s6._inner[g])) {
                        d = Math.max(d, this.f.b3.s7._inner[g]);
                        e = Math.min(e, this.f.b3.s6._inner[g]);
                        ++f;
                    }
                }
                if (f > 0 && e != 1.7976931348623157E+308 && d != -1.7976931348623157E+308) {
                    return [0.5 * (b + c), e, d];
                }
            }
            return [NaN, NaN, NaN];
        };
        PriceChannelBucketCalculator.$t = i2.markType(PriceChannelBucketCalculator, 'PriceChannelBucketCalculator', FinancialBucketCalculator.$);
        return PriceChannelBucketCalculator;
    }(FinancialBucketCalculator));
    /**
     * @hidden
     */
    var PriceChannelOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PriceChannelOverlayView, _super);
        function PriceChannelOverlayView(a) {
            var _this = _super.call(this, a) || this;
            _this.b8 = new i2.Polygon();
            _this.cd = new i2.Polyline();
            _this.ce = new i2.Polyline();
            _this.b3 = null;
            _this.b6 = new i2.Polygon();
            _this.b9 = new i2.Polyline();
            _this.ca = new i2.Polyline();
            _this.b3 = a;
            return _this;
        }
        Object.defineProperty(PriceChannelOverlayView.prototype, "b7", {
            get: function () {
                return this.b8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PriceChannelOverlayView.prototype, "cb", {
            get: function () {
                return this.cd;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PriceChannelOverlayView.prototype, "cc", {
            get: function () {
                return this.ce;
            },
            enumerable: false,
            configurable: true
        });
        PriceChannelOverlayView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
            }
        };
        PriceChannelOverlayView.prototype.by = function () {
            return new PriceChannelBucketCalculator(this);
        };
        PriceChannelOverlayView.prototype.b4 = function () {
            this.b8.ak.clear();
            this.cd.ak.clear();
            this.ce.ak.clear();
            this.aq();
        };
        PriceChannelOverlayView.prototype.b5 = function (a, b, c, d, e) {
            var e_2, _a, e_3, _b;
            try {
                for (var _c = tslib.__values(i2.fromEnum(i2.Flattener.d(a, b, d, this.e.gh))), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var f = _d.value;
                    this.b8.ak.add({ $type: i2.Point_$type, x: b(f), y: d(f) });
                    this.cd.ak.add({ $type: i2.Point_$type, x: b(f), y: d(f) });
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(i2.Flattener.d(a, c, e, this.e.gh))), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var g = _f.value;
                    this.b8.ak.add({ $type: i2.Point_$type, x: c(g), y: e(g) });
                    this.ce.ak.add({ $type: i2.Point_$type, x: c(g), y: e(g) });
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            this.aq();
        };
        PriceChannelOverlayView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.b6.ak = this.b8.ak;
            this.b9.ak = this.cd.ak;
            this.ca.ak = this.ce.ak;
            var a = this.bo();
            this.b6._fill = a;
            this.b6._opacity = 1;
            this.b9._stroke = a;
            this.b9.ac = this.e.fl + 3;
            this.ca._stroke = a;
            this.ca.ac = this.e.fl + 3;
        };
        PriceChannelOverlayView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.t(this.b6);
                    a.u(this.b9);
                    a.u(this.ca);
                }
                else {
                    a.t(this.b8);
                    a.u(this.cd);
                    a.u(this.ce);
                }
            }
        };
        PriceChannelOverlayView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPolygonData(a, this.b8, "fill", ["Fill"]);
            this.e.a6.exportPolylineData(a, this.cd, "bottom", ["Lower", "Main"]);
            this.e.a6.exportPolylineData(a, this.ce, "top", ["Upper"]);
        };
        PriceChannelOverlayView.$t = i2.markType(PriceChannelOverlayView, 'PriceChannelOverlayView', FinancialSeriesView.$);
        return PriceChannelOverlayView;
    }(FinancialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent Financial Price Channel Overlay series.
     * Default required members: High, Low
    *
    * You can use the `IgxPriceChannelOverlayComponent` to display price volatility.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-price-channel-overlay
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-price-channel-overlay>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxPriceChannelOverlayComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxPriceChannelOverlayComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPriceChannelOverlayComponent, _super);
        function IgxPriceChannelOverlayComponent() {
            return _super.call(this) || this;
        }
        IgxPriceChannelOverlayComponent.prototype.createImplementation = function () {
            return new PriceChannelOverlay();
        };
        Object.defineProperty(IgxPriceChannelOverlayComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPriceChannelOverlayComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current PriceChannelOverlay object.
             * The typical, and initial, value for Bollinger band periods is 14.
            *
            * You can use the `period` to set the moving average.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-price-channel-overlay
            * 		#series
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		period="14">
            *     </igx-price-channel-overlay>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 14;
            * ```
            */
            get: function () {
                return this.i.s8;
            },
            set: function (v) {
                this.i.s8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPriceChannelOverlayComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxPriceChannelOverlayComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxPriceChannelOverlayComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxPriceChannelOverlayComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPriceChannelOverlayComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPriceChannelOverlayComponent, selector: "igx-price-channel-overlay", inputs: { period: "period" }, providers: [{ provide: IgxFinancialOverlayComponent, useExisting: i0.forwardRef(function () { return IgxPriceChannelOverlayComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceChannelOverlayComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceChannelOverlayComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPriceChannelOverlayComponent;
    }(IgxFinancialOverlayComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-price-channel-overlay',
                        template: "",
                        providers: [{ provide: IgxFinancialOverlayComponent, useExisting: i0.forwardRef(function () { return IgxPriceChannelOverlayComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceChannelOverlayComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPriceChannelOverlayComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPriceChannelOverlayModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPriceChannelOverlayModule() {
        }
        IgxPriceChannelOverlayModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPriceChannelOverlayModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayModule, declarations: [IgxPriceChannelOverlayComponent], imports: [i1.CommonModule, IgxOverlayProxyModule], exports: [IgxPriceChannelOverlayComponent, IgxOverlayProxyModule] });
        IgxPriceChannelOverlayModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayModule, imports: [[i1.CommonModule, IgxOverlayProxyModule], IgxOverlayProxyModule] });
        return IgxPriceChannelOverlayModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPriceChannelOverlayComponent],
                        imports: [i1.CommonModule, IgxOverlayProxyModule],
                        exports: [IgxPriceChannelOverlayComponent, IgxOverlayProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPriceChannelOverlayDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPriceChannelOverlayDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPriceChannelOverlayComponent", IgxPriceChannelOverlayComponent);
            i2.TypeRegistrar.register("PriceChannelOverlay", PriceChannelOverlay.$type);
        }
        IgxPriceChannelOverlayDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPriceChannelOverlayDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayDynamicModule, imports: [i1.CommonModule, IgxPriceChannelOverlayModule], exports: [IgxPriceChannelOverlayModule] });
        IgxPriceChannelOverlayDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayDynamicModule, imports: [[i1.CommonModule, IgxPriceChannelOverlayModule], IgxPriceChannelOverlayModule] });
        return IgxPriceChannelOverlayDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPriceChannelOverlayDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPriceChannelOverlayModule],
                        exports: [IgxPriceChannelOverlayModule],
                        entryComponents: [IgxPriceChannelOverlayComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BollingerBandsOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BollingerBandsOverlay, _super);
        function BollingerBandsOverlay() {
            var _this = _super.call(this) || this;
            _this.s8 = 0;
            _this.s9 = 0;
            _this.s6 = new i2.List$1(i2.Number_$type, 0);
            _this.s7 = new i2.List$1(i2.Number_$type, 0);
            _this.ab = BollingerBandsOverlay.$;
            _this.pu = new CategoryFrame(4);
            _this.pw = new CategoryFrame(4);
            _this.ps = new CategoryFrame(4);
            return _this;
        }
        BollingerBandsOverlay.prototype.lm = function (a, b, c, d) {
            if (this.q9().contains(b)) {
                this.s0 = false;
            }
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case BollingerBandsOverlay.$$p[1]:
                    this.s0 = false;
                    this.l0(false);
                    break;
                case BollingerBandsOverlay.$$p[0]:
                    this.l0(false);
                    break;
            }
        };
        BollingerBandsOverlay.prototype.s1 = function () {
            this.s6.clear();
            this.s7.clear();
            var a = i2.getEnumerator(i2.TrendCalculators.e(new SafeEnumerable(this.q8), this.tb));
            var b = i2.getEnumerator(i2.TrendCalculators.f(new SafeEnumerable(this.q8), this.tb));
            this.s9 = 1.7976931348623157E+308;
            this.s8 = -1.7976931348623157E+308;
            var c = true;
            var d = true;
            var e = this.ta;
            while (c || d) {
                if (a.moveNext()) {
                    this.s6.add(a.current);
                }
                else {
                    c = false;
                }
                if (b.moveNext()) {
                    this.s7.add(b.current);
                }
                else {
                    d = false;
                }
                if (c && d) {
                    this.s9 = Math.min(this.s9, a.current - b.current * e);
                    this.s8 = Math.max(this.s8, a.current + b.current * e);
                }
            }
            return true;
        };
        BollingerBandsOverlay.prototype.ap = function (a) {
            if (this.s6 == null || this.s7 == null || a == null || this.ch == null || a != this.qc) {
                return null;
            }
            var b = new AxisRange(this.s9, this.s8);
            return b;
        };
        BollingerBandsOverlay.prototype.sh = function (a, b) {
            _super.prototype.sh.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.pq;
            var g = this.qc;
            var h = new ScalerParams(0, c, d, f.cc, e);
            var i = new ScalerParams(0, c, d, g.cc, e);
            a.f.clear();
            a.m.clear();
            a.p.clear();
            var j = i2.typeCast(ISortingAxis_$type, this.pq);
            if (j != null && j.i$b.count != this.ch.count) {
                return;
            }
            var k = 0;
            k = this.rh(c, d, e);
            if (!this.s0) {
                this.s0 = this.s1();
                if (this.qc != null) {
                    this.qc.cw(true);
                }
            }
            i.b = this.f2();
            var l = this.pq.eb(2, h) - this.pq.eb(1, h);
            for (var m = b.bx.c; m <= b.bx.d; ++m) {
                var n = void 0;
                if (j == null) {
                    n = b.bx.getBucket(m);
                }
                else {
                    var o = j.i$b._inner[m];
                    var p = j.i$d(o);
                    var q = this.s6._inner[m];
                    var r = this.s7._inner[m];
                    var s = q;
                    var t = r;
                    var u = p;
                    var v = 1;
                    while (m < b.bx.d) {
                        o = j.i$b._inner[m + 1];
                        u = j.i$d(o);
                        if (u - p > l) {
                            break;
                        }
                        m++;
                        s += this.s6._inner[m];
                        t += this.s7._inner[m];
                        v++;
                    }
                    s /= v;
                    t /= v;
                    var w = s - t * this.ta;
                    var x = s;
                    var y = s + t * this.ta;
                    var z = NaN;
                    if (!i2.isNaN_(p)) {
                        z = this.pq.d8(p, h);
                    }
                    n = [z, w, x, y];
                }
                var aa = Math.max(1, l);
                if (!i2.isNaN_(n[0]) && m * aa >= this.s2) {
                    if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                        n[0] = n[0] + k;
                    }
                    else {
                        n[0] = f.d8(n[0], h) + k;
                    }
                    n[1] = g.d8(n[1], i);
                    n[2] = g.d8(n[2], i);
                    n[3] = g.d8(n[3], i);
                    a.f.add(n);
                }
            }
        };
        BollingerBandsOverlay.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (c != null) {
                c.b4();
            }
        };
        BollingerBandsOverlay.prototype.f8 = function (a, b, c) {
            if (this.s6 == null) {
                return _super.prototype.f8.call(this, a, b, c);
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.rh(this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.pq.cc, d);
            f.c = this.ca.pv;
            return this.ga(this.s6, a, this.pq, f, e, i2.runOn(this, this.rg), b, c);
        };
        BollingerBandsOverlay.prototype.g6 = function (a, b) {
            if (this.s6 == null) {
                return _super.prototype.g6.call(this, a, b);
            }
            return this.g7(a, b, this.pq, i2.runOn(this, this.rg), this.s6);
        };
        BollingerBandsOverlay.prototype.g4 = function (a, b) {
            if (this.s6 == null) {
                return _super.prototype.g4.call(this, a, b);
            }
            return this.g5(a, b, this.pq, i2.runOn(this, this.rg), this.s6);
        };
        BollingerBandsOverlay.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (!this.qz(this.q9())) {
                d = false;
            }
            return d;
        };
        BollingerBandsOverlay.prototype.sj = function (a, b) {
            _super.prototype.sj.call(this, a, b);
            var c = i2.typeCast(BollingerBandsOverlayView.$, b);
            var d = this.getEffectiveViewport1(b);
            if (b.b0(a)) {
                c.b4();
                var e_1 = a.f.count;
                var f = function (g) { return a.f._inner[g][0]; };
                var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
                var h = function (i) { return a.f._inner[i][1]; };
                var i = function (j) { return a.f._inner[j][2]; };
                var j = function (k) { return a.f._inner[e_1 - 1 - k][3]; };
                c.b5(e_1, f, g, h, i, j);
                b.b2(a);
            }
            this.pz.a0(this, this.qy(), i2.runOn(this, this.pi), this.rn(b), this.rp(b));
            var k = false;
            var l = this.pz.b;
            var m = a.f;
            var n = this.ch.count;
            if (l != null) {
                k = true;
            }
            if (k) {
                var o = new ScalerParams(0, b.bv, b.bu, this.pq.cc, d);
                this.sg(m, -1, n, this.pq, o, b.q);
            }
            var p = c.cc;
            var q = c.cd;
            var r = c.ce;
            var s = c.b7;
            this.pz.ad(q, true, false, true, true);
            this.pz.an = null;
            this.pz.am = null;
            this.pz.ad(p, true, false, false, true);
            this.pz.ad(r, true, false, false, true);
            this.pz.ad(s, false, true, false, false);
            s._opacity = this.pz.j * this.fi;
        };
        BollingerBandsOverlay.prototype.bu = function () {
            return new BollingerBandsOverlayView(this);
        };
        BollingerBandsOverlay.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.s5 = i2.typeCast(BollingerBandsOverlayView.$, a);
        };
        BollingerBandsOverlay.prototype.rq = function () {
            return 3;
        };
        BollingerBandsOverlay.prototype.f2 = function () {
            return Series.f3(this.s6, null);
        };
        BollingerBandsOverlay.$t = i2.markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
        BollingerBandsOverlay.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:ta:te', [1, 2], 'Period:tb:tf', [1, 14]]);
        return BollingerBandsOverlay;
    }(FinancialOverlay));
    /**
     * @hidden
     */
    var BollingerBandsBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BollingerBandsBucketCalculator, _super);
        function BollingerBandsBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.f = null;
            _this.f = a;
            return _this;
        }
        BollingerBandsBucketCalculator.prototype.getBucket = function (a) {
            var b = a * this.b;
            var c = Math.min(b + this.b - 1, this.a.bz.ch.count - 1);
            if (b <= c) {
                var d = this.f.b3.ta;
                var e = 0;
                var f = 0;
                var g = 0;
                for (var h = b; h <= c; ++h) {
                    if (!i2.isNaN_(this.f.b3.s6._inner[h]) && !i2.isNaN_(this.f.b3.s7._inner[h])) {
                        e += this.f.b3.s6._inner[h];
                        f += this.f.b3.s7._inner[h];
                        ++g;
                    }
                }
                if (g > 0) {
                    e = e / g;
                    f = f / g;
                    return [0.5 * (b + c), e - f * d, e, e + f * d];
                }
            }
            return [NaN, NaN, NaN, NaN];
        };
        BollingerBandsBucketCalculator.$t = i2.markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
        return BollingerBandsBucketCalculator;
    }(FinancialBucketCalculator));
    /**
     * @hidden
     */
    var BollingerBandsOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BollingerBandsOverlayView, _super);
        function BollingerBandsOverlayView(a) {
            var _this = _super.call(this, a) || this;
            _this.b3 = null;
            _this.b8 = new i2.Polygon();
            _this.cf = new i2.Polyline();
            _this.cg = new i2.Polyline();
            _this.ch = new i2.Polyline();
            _this.b6 = new i2.Polygon();
            _this.b9 = new i2.Polyline();
            _this.ca = new i2.Polyline();
            _this.cb = new i2.Polyline();
            _this.b3 = a;
            return _this;
        }
        BollingerBandsOverlayView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
            }
        };
        BollingerBandsOverlayView.prototype.by = function () {
            return new BollingerBandsBucketCalculator(this);
        };
        BollingerBandsOverlayView.prototype.b5 = function (a, b, c, d, e, f) {
            var e_2, _a, e_3, _b, e_4, _c;
            try {
                for (var _d = tslib.__values(i2.fromEnum(i2.Flattener.d(a, b, d, this.e.gh))), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var g = _e.value;
                    this.b8.ak.add({ $type: i2.Point_$type, x: b(g), y: d(g) });
                    this.cf.ak.add({ $type: i2.Point_$type, x: b(g), y: d(g) });
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            try {
                for (var _f = tslib.__values(i2.fromEnum(i2.Flattener.d(a, b, e, this.e.gh))), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var h = _g.value;
                    this.cg.ak.add({ $type: i2.Point_$type, x: b(h), y: e(h) });
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            try {
                for (var _h = tslib.__values(i2.fromEnum(i2.Flattener.d(a, c, f, this.e.gh))), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var i = _j.value;
                    this.b8.ak.add({ $type: i2.Point_$type, x: c(i), y: f(i) });
                    this.ch.ak.add({ $type: i2.Point_$type, x: c(i), y: f(i) });
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            this.aq();
        };
        BollingerBandsOverlayView.prototype.b4 = function () {
            this.b8.ak.clear();
            this.cf.ak.clear();
            this.cg.ak.clear();
            this.ch.ak.clear();
            this.aq();
        };
        Object.defineProperty(BollingerBandsOverlayView.prototype, "b7", {
            get: function () {
                return this.b8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BollingerBandsOverlayView.prototype, "cc", {
            get: function () {
                return this.cf;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BollingerBandsOverlayView.prototype, "cd", {
            get: function () {
                return this.cg;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BollingerBandsOverlayView.prototype, "ce", {
            get: function () {
                return this.ch;
            },
            enumerable: false,
            configurable: true
        });
        BollingerBandsOverlayView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.b6.ak = this.b8.ak;
            this.b9.ak = this.cf.ak;
            this.ca.ak = this.cg.ak;
            this.cb.ak = this.ch.ak;
            var a = this.bo();
            this.b6._fill = a;
            this.b6._opacity = 1;
            this.b9._stroke = a;
            this.b9.ac = this.e.fl + 3;
            this.ca._stroke = a;
            this.ca.ac = this.e.fl + 3;
            this.cb._stroke = a;
            this.cb.ac = this.e.fl + 3;
        };
        BollingerBandsOverlayView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.t(this.b6);
                    a.u(this.b9);
                    a.u(this.ca);
                    a.u(this.cb);
                }
                else {
                    a.t(this.b8);
                    a.u(this.cf);
                    a.u(this.cg);
                    a.u(this.ch);
                }
            }
        };
        BollingerBandsOverlayView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPolygonData(a, this.b8, "FillShape", ["Fill"]);
            this.e.a6.exportPolylineData(a, this.cf, "BottomLine", ["Lower", "Main"]);
            this.e.a6.exportPolylineData(a, this.cg, "CentralLine", ["Central"]);
            this.e.a6.exportPolylineData(a, this.ch, "TopLine", ["Upper"]);
        };
        BollingerBandsOverlayView.$t = i2.markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
        return BollingerBandsOverlayView;
    }(FinancialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent Bollinger Bands financial overlay series.
     * Default required members: High, Low, Close
    *
    * You can use the `IgxBollingerBandsOverlayComponent` class represents a IgxDataChartComponent Bollinger Bands financial overlay series.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-bollinger-band-overlay
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close">
    *     </igx-bollinger-band-overlay>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxBollingerBandOverlayComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * this.chart.series.add(series);
    * ```
    */
    var IgxBollingerBandsOverlayComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxBollingerBandsOverlayComponent, _super);
        function IgxBollingerBandsOverlayComponent() {
            return _super.call(this) || this;
        }
        IgxBollingerBandsOverlayComponent.prototype.createImplementation = function () {
            return new BollingerBandsOverlay();
        };
        Object.defineProperty(IgxBollingerBandsOverlayComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBollingerBandsOverlayComponent.prototype, "period", {
            /**
             * Gets or sets the moving average period for the current BollingerBandOverlay object.
             * The typical, and initial, value for Bollinger band periods is 14.
            *
            * You can use the `period` property for moving average of the current BollingerBandOverlay object.
            *
            * ```html
            * <igx-data-chart
            * 	#chart
            *     [dataSource]="data" >
            *     <igx-category-x-axis
            * 		label="label"
            * 		#xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            * 		#yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-bollinger-band-overlay
            * 		[xAxis]="xAxis"
            * 		[yAxis]="yAxis"
            * 		openMemberPath="open"
            * 		highMemberPath="high"
            * 		lowMemberPath="low"
            * 		closeMemberPath="close"
            * 		period="7">
            *     </igx-bollinger-band-overlay>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.series.period = 7;
            * ```
            */
            get: function () {
                return this.i.tb;
            },
            set: function (v) {
                this.i.tb = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBollingerBandsOverlayComponent.prototype, "multiplier", {
            /**
             * Gets or sets the moving average period for the current BollingerBandOverlay object.
             * The typical, and initial, value for Bollinger band multipliers is 2.
            *
            * You can use the `IgxBollingerBandsOverlayComponent`
            */
            get: function () {
                return this.i.ta;
            },
            set: function (v) {
                this.i.ta = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxBollingerBandsOverlayComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxBollingerBandsOverlayComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxBollingerBandsOverlayComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxBollingerBandsOverlayComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxBollingerBandsOverlayComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxBollingerBandsOverlayComponent, selector: "igx-bollinger-bands-overlay", inputs: { period: "period", multiplier: "multiplier" }, providers: [{ provide: IgxFinancialOverlayComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandsOverlayComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandsOverlayComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandsOverlayComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxBollingerBandsOverlayComponent;
    }(IgxFinancialOverlayComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-bollinger-bands-overlay',
                        template: "",
                        providers: [{ provide: IgxFinancialOverlayComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandsOverlayComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandsOverlayComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBollingerBandsOverlayComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { period: [{
                    type: i0.Input
                }], multiplier: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBollingerBandsOverlayModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBollingerBandsOverlayModule() {
        }
        IgxBollingerBandsOverlayModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBollingerBandsOverlayModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayModule, declarations: [IgxBollingerBandsOverlayComponent], imports: [i1.CommonModule, IgxOverlayProxyModule], exports: [IgxBollingerBandsOverlayComponent, IgxOverlayProxyModule] });
        IgxBollingerBandsOverlayModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayModule, imports: [[i1.CommonModule, IgxOverlayProxyModule], IgxOverlayProxyModule] });
        return IgxBollingerBandsOverlayModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxBollingerBandsOverlayComponent],
                        imports: [i1.CommonModule, IgxOverlayProxyModule],
                        exports: [IgxBollingerBandsOverlayComponent, IgxOverlayProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBollingerBandsOverlayDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBollingerBandsOverlayDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxBollingerBandsOverlayComponent", IgxBollingerBandsOverlayComponent);
            i2.TypeRegistrar.register("BollingerBandsOverlay", BollingerBandsOverlay.$type);
        }
        IgxBollingerBandsOverlayDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBollingerBandsOverlayDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayDynamicModule, imports: [i1.CommonModule, IgxBollingerBandsOverlayModule], exports: [IgxBollingerBandsOverlayModule] });
        IgxBollingerBandsOverlayDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayDynamicModule, imports: [[i1.CommonModule, IgxBollingerBandsOverlayModule], IgxBollingerBandsOverlayModule] });
        return IgxBollingerBandsOverlayDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBollingerBandsOverlayDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxBollingerBandsOverlayModule],
                        exports: [IgxBollingerBandsOverlayModule],
                        entryComponents: [IgxBollingerBandsOverlayComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOverlaysModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOverlaysModule() {
        }
        IgxOverlaysModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOverlaysModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysModule, imports: [i1.CommonModule, IgxPriceChannelOverlayModule,
                IgxBollingerBandsOverlayModule], exports: [IgxPriceChannelOverlayModule,
                IgxBollingerBandsOverlayModule] });
        IgxOverlaysModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysModule, imports: [[i1.CommonModule, IgxPriceChannelOverlayModule,
                    IgxBollingerBandsOverlayModule
                ], IgxPriceChannelOverlayModule,
                IgxBollingerBandsOverlayModule] });
        return IgxOverlaysModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxPriceChannelOverlayModule,
                            IgxBollingerBandsOverlayModule
                        ],
                        imports: [i1.CommonModule, IgxPriceChannelOverlayModule,
                            IgxBollingerBandsOverlayModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxOverlaysDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxOverlaysDynamicModule() {
        }
        IgxOverlaysDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxOverlaysDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysDynamicModule, imports: [i1.CommonModule, IgxPriceChannelOverlayDynamicModule,
                IgxBollingerBandsOverlayDynamicModule,
                IgxOverlaysModule], exports: [IgxPriceChannelOverlayDynamicModule,
                IgxBollingerBandsOverlayDynamicModule,
                IgxOverlaysModule] });
        IgxOverlaysDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysDynamicModule, imports: [[i1.CommonModule, IgxPriceChannelOverlayDynamicModule,
                    IgxBollingerBandsOverlayDynamicModule,
                    IgxOverlaysModule
                ], IgxPriceChannelOverlayDynamicModule,
                IgxBollingerBandsOverlayDynamicModule,
                IgxOverlaysModule] });
        return IgxOverlaysDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxOverlaysDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxPriceChannelOverlayDynamicModule,
                            IgxBollingerBandsOverlayDynamicModule,
                            IgxOverlaysModule
                        ],
                        imports: [i1.CommonModule, IgxPriceChannelOverlayDynamicModule,
                            IgxBollingerBandsOverlayDynamicModule,
                            IgxOverlaysModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a column that is calculated based on the values of other columns.
    */
    var IgxCalculatedColumn = /** @class */ /*@__PURE__*/ (function () {
        function IgxCalculatedColumn() {
        }
        Object.defineProperty(IgxCalculatedColumn.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCalculatedColumn.prototype.onImplementationCreated = function () {
        };
        IgxCalculatedColumn.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        IgxCalculatedColumn.prototype[Symbol.iterator] = function () {
            return new i2.EnumeratorWrapper(this.i.getEnumerator());
        };
        IgxCalculatedColumn.prototype.findByName = function (name) {
            return null;
        };
        return IgxCalculatedColumn;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IFinancialPriceSeriesProxy_$type = new i2.Type(null, 'IFinancialPriceSeriesProxy');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialPriceSeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialPriceSeriesProxy, _super);
        function FinancialPriceSeriesProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FinancialPriceSeriesProxy.prototype.getCloseMemberPath = function (a) {
            return a.ru;
        };
        FinancialPriceSeriesProxy.prototype.getHighMemberPath = function (a) {
            return a.rx;
        };
        FinancialPriceSeriesProxy.prototype.getLowMemberPath = function (a) {
            return a.r2;
        };
        FinancialPriceSeriesProxy.prototype.getOpenMemberPath = function (a) {
            return a.r6;
        };
        FinancialPriceSeriesProxy.prototype.getVolumeMemberPath = function (a) {
            return a.sa;
        };
        FinancialPriceSeriesProxy.prototype.matchesType = function (a) {
            if (!a.di) {
                return false;
            }
            if (a.dj || a.dk) {
                return false;
            }
            return true;
        };
        FinancialPriceSeriesProxy.prototype.setCategoryMode = function (a, b) {
            a.py = b;
        };
        FinancialPriceSeriesProxy.prototype.setCloseMemberPath = function (a, b) {
            a.ru = b;
        };
        FinancialPriceSeriesProxy.prototype.setDisplayType = function (a, b) {
            a.s2 = b;
        };
        FinancialPriceSeriesProxy.prototype.setHighMemberPath = function (a, b) {
            a.rx = b;
        };
        FinancialPriceSeriesProxy.prototype.setLowMemberPath = function (a, b) {
            a.r2 = b;
        };
        FinancialPriceSeriesProxy.prototype.setOpenMemberPath = function (a, b) {
            a.r6 = b;
        };
        FinancialPriceSeriesProxy.prototype.setVolumeMemberPath = function (a, b) {
            a.sa = b;
        };
        FinancialPriceSeriesProxy.prototype.setXAxis = function (a, b) {
            a.pq = b;
        };
        FinancialPriceSeriesProxy.prototype.setYAxis = function (a, b) {
            a.qc = b;
        };
        FinancialPriceSeriesProxy.$t = i2.markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', i2.Base.$, [IFinancialPriceSeriesProxy_$type]);
        return FinancialPriceSeriesProxy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialPriceSeriesProxyModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialPriceSeriesProxyModule() {
            i2.TypeRegistrar.register('FinancialPriceSeriesProxy', FinancialPriceSeriesProxy.$type);
            i2.TypeRegistrar.register('FinancialEventArgs', FinancialEventArgs.$type);
            i2.TypeRegistrar.registerCons('igx-financial-event-args', IgxFinancialEventArgs);
        }
        IgxFinancialPriceSeriesProxyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialPriceSeriesProxyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyModule, imports: [i1.CommonModule] });
        IgxFinancialPriceSeriesProxyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyModule, imports: [[i1.CommonModule,
                ]] });
        return IgxFinancialPriceSeriesProxyModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialPriceSeriesProxyDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialPriceSeriesProxyDynamicModule() {
            i2.TypeRegistrar.register('FinancialPriceSeriesProxy', FinancialPriceSeriesProxy.$type);
            i2.TypeRegistrar.register('FinancialEventArgs', FinancialEventArgs.$type);
            i2.TypeRegistrar.registerCons('igx-financial-event-args', IgxFinancialEventArgs);
        }
        IgxFinancialPriceSeriesProxyDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialPriceSeriesProxyDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyDynamicModule, imports: [i1.CommonModule] });
        IgxFinancialPriceSeriesProxyDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyDynamicModule, imports: [[i1.CommonModule,
                ]] });
        return IgxFinancialPriceSeriesProxyDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesProxyDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialPriceBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialPriceBucketCalculator, _super);
        function FinancialPriceBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        FinancialPriceBucketCalculator.prototype.getBucket = function (a) {
            var b = a * this.b;
            var c = Math.min(b + this.b - 1, this.a.bz.ch.count - 1);
            if (b <= c && b >= 0 && c >= 0) {
                var d = this.a.bz.qm.item(b);
                var e = Number.NEGATIVE_INFINITY;
                var f = Number.POSITIVE_INFINITY;
                var g = this.a.bz.qj.item(c);
                for (var h = b; h <= c; ++h) {
                    e = Math.max(e, this.a.bz.qk.item(h));
                    f = Math.min(f, this.a.bz.ql.item(h));
                }
                f = Math.min(d, f);
                e = Math.max(g, e);
                return [0.5 * (b + c), d, e, f, g];
            }
            return [NaN, NaN, NaN, NaN, NaN];
        };
        FinancialPriceBucketCalculator.$t = i2.markType(FinancialPriceBucketCalculator, 'FinancialPriceBucketCalculator', FinancialBucketCalculator.$);
        return FinancialPriceBucketCalculator;
    }(FinancialBucketCalculator));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available display types of financial price series.
     */
    var PriceDisplayType = /*@__PURE__*/ (function (PriceDisplayType) {
        /**
         * Displays prices as a Japanese Candlestick.
         */
        PriceDisplayType[PriceDisplayType["Candlestick"] = 0] = "Candlestick";
        /**
         * Displays prices as an OHLC bar.
         */
        PriceDisplayType[PriceDisplayType["OHLC"] = 1] = "OHLC";
        return PriceDisplayType;
    })({});
    /**
     * @hidden
     */
    var PriceDisplayType_$type = i2.markEnum('PriceDisplayType', 'Candlestick,0|OHLC,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialPriceSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialPriceSeries, _super);
        function FinancialPriceSeries() {
            var _this = _super.call(this) || this;
            _this.ab = FinancialPriceSeries.$;
            _this.pu = new CategoryFrame(5);
            _this.pw = new CategoryFrame(5);
            _this.ps = new CategoryFrame(5);
            return _this;
        }
        FinancialPriceSeries.prototype.get_dl = function () {
            return true;
        };
        FinancialPriceSeries.prototype.bu = function () {
            return new FinancialPriceSeriesView(this);
        };
        FinancialPriceSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.s1 = a;
        };
        Object.defineProperty(FinancialPriceSeries.prototype, "tl", {
            get: function () {
                return this.c(FinancialPriceSeries.tb);
            },
            set: function (a) {
                this.h(FinancialPriceSeries.tb, a);
            },
            enumerable: false,
            configurable: true
        });
        FinancialPriceSeries.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            if (this.pq != null && i2.typeCast(ISortingAxis_$type, this.pq) !== null) {
                this.pq.i$i();
            }
            this.s1.bx.e(this.gh);
            if (this.s1.b7) {
                this.s1.b5.g$e(a, b, c, d);
            }
            if (this.qc != null) {
                this.qc.cv();
            }
            this.l0(true);
        };
        FinancialPriceSeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        FinancialPriceSeries.prototype.pb = function (a) {
            if (this.ps == null || this.ps.f.count == 0) {
                return i2.Rect.empty;
            }
            var b = this.ox(a);
            var c = this.bx.bv;
            var d = this.bx.bu;
            var e = this.getEffectiveViewport1(this.bx);
            var f = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), a, true);
            var g = f[0];
            var h = f[1];
            var i = Math.abs(b.x - g[0]);
            var j = Math.abs(b.x - h[0]);
            var k = this.s3(this.p7, e);
            k = Math.max(k, 3);
            var l = (k - 1) / 2;
            if (i < j) {
                var m = g[0] - l;
                var n = g[0];
                var o = g[0] + l;
                var p = g[1];
                var q = g[2];
                var r = g[3];
                var s = g[4];
                var t = Math.min(Math.min(Math.min(p, q), r), s);
                var u = Math.max(Math.max(Math.max(p, q), r), s);
                return new i2.Rect(0, m, t, Math.abs(o - m), u - t);
            }
            else {
                var v = h[0] - l;
                var w = h[0];
                var x = h[0] + l;
                var y = h[1];
                var z = h[2];
                var aa = h[3];
                var ab = h[4];
                var ac = Math.min(Math.min(Math.min(y, z), aa), ab);
                var ad = Math.max(Math.max(Math.max(y, z), aa), ab);
                return new i2.Rect(0, v, ac, Math.abs(x - v), ad - ac);
            }
        };
        FinancialPriceSeries.prototype.s0 = function (a, b) {
            var c = a[0] - b;
            var d = a[0];
            var e = a[0] + b;
            var f = a[1];
            var g = a[2];
            var h = a[3];
            var i = a[4];
            var j = Math.min(Math.min(Math.min(f, g), h), i);
            var k = Math.max(Math.max(Math.max(f, g), h), i);
            var l = Math.min(g, h);
            var m = Math.max(g, h);
            var n = Math.min(f, i);
            var o = Math.max(f, i);
            if (this.s2 == 1) {
                var p = new Array(3);
                var q = new i2.Rect(0, c, f, b, 0);
                var r = new i2.Rect(0, d, i, b, 0);
                var s = new i2.Rect(0, d, l, 0, m - l);
                p[0] = q;
                p[1] = r;
                p[2] = s;
                return p;
            }
            else {
                var t = new Array(2);
                var u = new i2.Rect(0, d, l, 0, m - l);
                var v = new i2.Rect(0, c, n, b * 2, o - n);
                t[0] = u;
                t[1] = v;
                return t;
            }
        };
        FinancialPriceSeries.prototype.ak = function (a) {
            var b = new i2.List$1(i2.Rect.$, 0);
            var c = this.ox(a);
            var d = this.bx.bv;
            var e = this.bx.bu;
            var f = this.getEffectiveViewport1(this.bx);
            var g = this.aj(this.pq, this.ps.f, this.rn(this.bx), this.rp(this.bx), a, true);
            var h = g[0];
            var i = g[1];
            var j = Math.abs(c.x - h[0]);
            var k = Math.abs(c.x - i[0]);
            var l = this.s3(this.p7, f);
            l = Math.max(l, 3);
            var m = (l - 1) / 2;
            if (j < k) {
                return this.s0(h, m);
            }
            else {
                return this.s0(i, m);
            }
        };
        FinancialPriceSeries.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            return false;
        };
        FinancialPriceSeries.prototype.es = function (a, b) {
            var c = this.pc(a);
            if (c.isEmpty) {
                return false;
            }
            var d = i2.RectUtil.r(c, (this.fl / 2) + this.fz(b));
            if (d.containsPoint(a)) {
                var e = this.al(a);
                if (e != null) {
                    for (var f = 0; f < e.length; f++) {
                        var g = e[f];
                        var h = i2.RectUtil.r(g, (this.fl / 2) + this.fz(b));
                        if (h.containsPoint(a)) {
                            return true;
                        }
                    }
                }
            }
            return false;
        };
        FinancialPriceSeries.prototype.lm = function (a, b, c, d) {
            switch (b) {
                case FinancialSeries.$$p[9]:
                    this.s1.cd();
                    if (this.ca != null) {
                        this.ca.jp();
                    }
                    break;
                case "TrendLineType":
                    var e = i2.EnumUtil.getEnumValue(i2.TrendLineType_$type, d);
                    if (e != 0) {
                        this.s1.b5 = CategoryTrendLineManagerFactory.a(this.s1.b5, this.pq, this.mr, this, this.ck);
                    }
                    break;
            }
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.s1.b7 && this.s1.b5 != null && this.s1.b5.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            switch (b) {
                case FinancialPriceSeries.$$p[0]:
                    if (this.mr != null) {
                        this.ta();
                        this.me();
                        this.ps.w();
                        this.sj(this.ps, this.s1);
                    }
                    this.k7();
                    break;
                case "ActualHighlightingMode":
                    this.l0(true);
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
                case FinancialSeries.$$p[5]:
                case FinancialPriceSeries.$$p[1]:
                    this.lj();
                    break;
            }
        };
        FinancialPriceSeries.prototype.ta = function () {
            this.s1.ch();
            if (this.bw != null) {
                this.bw.ch();
            }
        };
        FinancialPriceSeries.prototype.ap = function (a) {
            if (a != null && a == this.qc && this.ql != null && !i2.isNaN_(this.ql.minimum) && this.qk != null && !i2.isNaN_(this.qk.maximum)) {
                return new AxisRange(this.ql.minimum, this.qk.maximum);
            }
            return null;
        };
        FinancialPriceSeries.prototype.aq = function (a) {
            if (a.isEmpty && this.ca != null) {
                a = this.ca.pg;
            }
            if (this.ql == null || this.qk == null) {
                return null;
            }
            var b = this.o7(this.bx);
            var c = new ScalerParams(0, a, this.ca.pv, this.pq.cc, this.getEffectiveViewport());
            var d = (this.pq.eb(b.left, c));
            var e = (this.pq.eb(b.right, c));
            if (this.pq.cc) {
                var f = d;
                d = e;
                e = f;
            }
            var g = null;
            if (this.pq.ch) {
                g = this.pq;
                d = g.i$f(d);
                e = g.i$f(e);
            }
            else {
                d = Math.floor(d);
                e = Math.ceil(e);
            }
            d = Math.max(0, Math.min(this.ql.count - 1, d));
            e = Math.max(0, Math.min(this.ql.count - 1, e));
            var h = 1.7976931348623157E+308;
            var i = -1.7976931348623157E+308;
            for (var j = i2.truncate(d); j <= i2.truncate(e); j++) {
                var k = j;
                if (g != null) {
                    k = g.i$b._inner[j];
                }
                var l = this.ql.item(k);
                if (this.ql.mayContainUnknowns) {
                    if (i2.isInfinity(l) || i2.isNaN_(l)) {
                        continue;
                    }
                }
                var m = this.qk.item(k);
                if (this.qk.mayContainUnknowns) {
                    if (i2.isInfinity(m) || i2.isNaN_(m)) {
                        continue;
                    }
                }
                h = Math.min(h, l);
                i = Math.max(i, m);
            }
            var n = new AxisRange(h, i);
            n = this.ao(n, this.qc, a);
            return n;
        };
        FinancialPriceSeries.prototype.f2 = function () {
            return Series.f3(this.qm, i2.typeCast(ISortingAxis_$type, this.pq));
        };
        FinancialPriceSeries.prototype.eh = function (a) {
            var b = this.ch != null ? this.ch.indexOf(a) : -1;
            var c = this.bx.bv;
            c = c.copy();
            var d = this.bx.bu;
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = this.o9(this.bx);
            if (b >= 0 && i2.Rect.l_op_Inequality(c, null) && i2.Rect.l_op_Inequality(d, null)) {
                if (this.pq != null) {
                    var g = new ScalerParams(0, e, e, this.pq.cc, f);
                    var h = this.pq.d8(b, g);
                    if (h < c.left + 0.1 * c.width) {
                        h = h + 0.4 * c.width;
                    }
                    if (h > c.right - 0.1 * c.width) {
                        h = h - 0.4 * c.width;
                    }
                    c.x = h - 0.5 * c.width;
                }
                if (this.qc != null && this.ql != null && this.qk != null && b < this.ql.count && b < this.qk.count) {
                    var i = new ScalerParams(0, e, e, this.qc.cc, f);
                    i.b = this.f2();
                    var j = this.qc.d8(this.ql.item(b), i);
                    var k = this.qc.d8(this.qk.item(b), i);
                    if (!i2.isNaN_(j) && !i2.isNaN_(k)) {
                        var l = Math.abs(j - k);
                        if (c.height < l) {
                            c.height = l;
                            c.y = Math.min(j, k);
                        }
                        else {
                            if (j < c.top + 0.1 * c.height) {
                                j = j + 0.4 * c.height;
                            }
                            if (j > c.bottom - 0.1 * c.height) {
                                j = j - 0.4 * c.height;
                            }
                            c.y = j - 0.5 * c.height;
                        }
                    }
                }
                this.b5.ap(this.ca, c, true);
            }
            return b >= 0;
        };
        FinancialPriceSeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (this.qm == null || this.qj == null || this.qk == null || this.ql == null) {
                d = false;
            }
            return d;
        };
        FinancialPriceSeries.prototype.sh = function (a, b) {
            var e_1, _a;
            var _this = this;
            _super.prototype.sh.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.pq;
            var g = this.qc;
            var h = new ScalerParams(0, c, d, f.cc, e);
            var i = ((function () {
                var $ret = new ScalerParams(0, c, d, g.cc, e);
                $ret.b = _this.f2();
                return $ret;
            })());
            a.f.clear();
            a.m.clear();
            a.p.clear();
            var j = 0;
            var k = i2.typeCast(ISortingAxis_$type, this.pq);
            if (k != null && (k.i$b == null || k.i$b.count != this.ch.count)) {
                return;
            }
            j = this.rh(c, d, e);
            var l = i2.typeCast(FinancialPriceSeriesView.$, b);
            var m = this.gh;
            if (this.trendLineType != 0) {
                var n = new Array(this.ch.count);
                var o = 0;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.q8)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var p = _c.value;
                        n[o] = p;
                        o++;
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                if (this.s1.b7) {
                    this.s1.b5.prepareLineCore(a.p, this.trendLineType, i2.boxArray$1(n), this.trendLinePeriod, function (q) { return _this.pq.d8(q, h); }, function (q) { return _this.qc.d8(q, i); }, ((function () {
                        var $ret = new TrendResolutionParams();
                        $ret.c = b.bx.b;
                        $ret.d = b.bx.c;
                        $ret.e = b.bx.d;
                        $ret.a = j;
                        $ret.b = m;
                        $ret.f = d;
                        return $ret;
                    })()));
                }
            }
            var q = this.pq.eb(2, h) - this.pq.eb(1, h);
            for (var r = b.bx.c; r <= b.bx.d; ++r) {
                var s = void 0;
                if (k == null) {
                    s = b.bx.getBucket(r);
                }
                else {
                    var t = k.i$b._inner[r];
                    var u = k.i$d(t);
                    var v = this.qm.item(t);
                    var w = this.qk.item(t);
                    var x = this.ql.item(t);
                    var y = this.qj.item(t);
                    var z = v;
                    var aa = w;
                    var ab = x;
                    var ac = y;
                    var ad = u;
                    while (r < b.bx.d) {
                        t = k.i$b._inner[r + 1];
                        ad = k.i$d(t);
                        if (ad - u > q * m) {
                            break;
                        }
                        r++;
                        aa = Math.max(aa, this.qk.item(t));
                        ab = Math.min(ab, this.ql.item(t));
                        ac = this.qj.item(t);
                    }
                    var ae = NaN;
                    if (!i2.isNaN_(u)) {
                        ae = this.pq.d8(u, h);
                    }
                    s = [ae, z, aa, ab, ac];
                }
                if (!i2.isNaN_(s[0])) {
                    if (k != null) {
                        s[0] = s[0] + j;
                    }
                    else {
                        s[0] = f.d8(s[0], h) + j;
                    }
                    s[1] = g.d8(s[1], i);
                    s[2] = g.d8(s[2], i);
                    s[3] = g.d8(s[3], i);
                    s[4] = g.d8(s[4], i);
                    a.f.add(s);
                }
            }
            return;
        };
        FinancialPriceSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = i2.typeCast(FinancialPriceSeriesView.$, b);
            c.cb();
            if (a) {
                c.b6.count = 0;
            }
            if (c.b7 && c.b5 != null) {
                c.b5.g$d();
            }
        };
        FinancialPriceSeries.prototype.mm = function (a, b) {
            _super.prototype.mm.call(this, a, b);
            if (this.ca != null) {
                this.ca.jp();
            }
        };
        FinancialPriceSeries.prototype.pg = function () {
            if (this.pq != null && this.pq.categoryMode == 0) {
                var a = this.getEffectiveViewport1(this.bx);
                var b = this.s3(this.p7, a) / 2;
                return new i2.Thickness(1, b, 0, b, 0);
            }
            return _super.prototype.pg.call(this);
        };
        FinancialPriceSeries.prototype.get_cy = function () {
            return true;
        };
        FinancialPriceSeries.prototype.sj = function (a, b) {
            _super.prototype.sj.call(this, a, b);
            if (this.pq == null || this.qc == null) {
                return;
            }
            var c = false;
            if (b.b0(a)) {
                c = true;
                b.b2(a);
            }
            this.pz.a0(this, this.qy(), i2.runOn(this, this.pi), this.rn(b), this.rp(b));
            var d = false;
            var e = this.pz.b;
            if (e != null) {
                d = true;
            }
            var f = i2.typeCast(FinancialPriceSeriesView.$, b);
            f.ca();
            f.b8 = false;
            if (f.b7) {
                f.b5.g$d();
            }
            if (this.trendLineType != 0) {
                f.b5.g$g(a.p);
            }
            if (d) {
                this.s9(a, b, c);
            }
            else {
                f.b6.count = 0;
                this.s8(a, b);
            }
        };
        FinancialPriceSeries.prototype.f1 = function () {
            var a = this.getEffectiveViewport1(this.bx);
            return this.s3(this.p7, a);
        };
        FinancialPriceSeries.prototype.s9 = function (a, b, c) {
            var d = this.s2;
            var e = this.getEffectiveViewport1(b);
            var f = this.s3(b, e);
            var g = (f - 1) / 2;
            var h = i2.typeCast(FinancialPriceSeriesView.$, b);
            h.b8 = true;
            var i = a.f;
            var j = 0;
            var k = this.ch.count;
            var l = this.pq;
            var m = new ScalerParams(0, b.bv, b.bu, l.cc, e);
            var n = this.of;
            var o = this.sw;
            if (o == null) {
                o = n;
            }
            var p = this.oi;
            var q = this.tm;
            if (q == null) {
                q = p;
            }
            var _loop_1 = function (r) {
                var s = i._inner[r][0] - g;
                var t = i._inner[r][0];
                var u = i._inner[r][0] + g;
                var v = i._inner[r][1];
                var w = i._inner[r][2];
                var x = i._inner[r][3];
                var y = i._inner[r][4];
                if (i2.isNaN_(v) || i2.isNaN_(w) || i2.isNaN_(x) || i2.isNaN_(y)) {
                    return "continue";
                }
                var z = h.b6.item(j);
                j++;
                var aa = v < y;
                var ab = new i2.PathGeometry();
                if (c) {
                    switch (d) {
                        case 0:
                            if (aa) {
                                var ac = v;
                                v = y;
                                y = ac;
                            }
                            var ad = new i2.PathFigure();
                            ad._startPoint = { $type: i2.Point_$type, x: t, y: x };
                            ad._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: t, y: v };
                                return $ret;
                            })()));
                            var ae = new i2.PathFigure();
                            ae._startPoint = { $type: i2.Point_$type, x: s, y: y };
                            ae._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: u, y: y };
                                return $ret;
                            })()));
                            ae._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: u, y: v };
                                return $ret;
                            })()));
                            ae._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: s, y: v };
                                return $ret;
                            })()));
                            ae._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: s, y: y };
                                return $ret;
                            })()));
                            var af = new i2.PathFigure();
                            af._startPoint = { $type: i2.Point_$type, x: t, y: y };
                            af._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: t, y: w };
                                return $ret;
                            })()));
                            ab.c.add(ad);
                            ab.c.add(ae);
                            ab.c.add(af);
                            break;
                        case 1:
                            var ag = new i2.PathFigure();
                            ag._startPoint = { $type: i2.Point_$type, x: s, y: v };
                            ag._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: t, y: v };
                                return $ret;
                            })()));
                            var ah = new i2.PathFigure();
                            ah._startPoint = { $type: i2.Point_$type, x: t, y: x };
                            ah._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: t, y: w };
                                return $ret;
                            })()));
                            var ai = new i2.PathFigure();
                            ai._startPoint = { $type: i2.Point_$type, x: t, y: y };
                            ai._segments.add(((function () {
                                var $ret = new i2.LineSegment(1);
                                $ret.c = { $type: i2.Point_$type, x: u, y: y };
                                return $ret;
                            })()));
                            ab.c.add(ag);
                            ab.c.add(ah);
                            ab.c.add(ai);
                            break;
                    }
                }
                if (aa) {
                    this_1.pz.ak = o;
                    this_1.pz.ag = o;
                    this_1.pz.ah = q;
                    this_1.pz.al = q;
                    this_1.pz.f = true;
                }
                else {
                    this_1.pz.ak = n;
                    this_1.pz.ag = n;
                    this_1.pz.ah = p;
                    this_1.pz.al = p;
                    this_1.pz.f = false;
                }
                this_1.sg(i, r, k, l, m, b.q);
                if (d == 1) {
                    this_1.pz.ad(z, true, false, false, false);
                }
                else {
                    this_1.pz.ad(z, false, false, false, false);
                }
                if (c) {
                    z.ak = ab;
                }
            };
            var this_1 = this;
            for (var r = 0; r < i.count; ++r) {
                _loop_1(r);
            }
            h.b6.count = j;
            h.cc();
        };
        FinancialPriceSeries.prototype.s3 = function (a, b) {
            var c = this.pq.ki(a.bv, a.bu, b);
            c = Math.max(c, this.gh * 0.9);
            c = Math.max(c, 3);
            return c;
        };
        FinancialPriceSeries.prototype.s8 = function (a, b) {
            var c = this.s2;
            var d = this.getEffectiveViewport1(b);
            var e = this.s3(b, d);
            var f = (e - 1) / 2;
            var g = i2.typeCast(FinancialPriceSeriesView.$, b);
            var h = g.ck();
            var i = g.cj();
            var j = a.f;
            var _loop_2 = function (k) {
                var l = j._inner[k][0] - f;
                var m = j._inner[k][0];
                var n = j._inner[k][0] + f;
                var o = j._inner[k][1];
                var p = j._inner[k][2];
                var q = j._inner[k][3];
                var r = j._inner[k][4];
                if (i2.isNaN_(o) || i2.isNaN_(p) || i2.isNaN_(q) || i2.isNaN_(r)) {
                    return "continue";
                }
                var s = o < r;
                var t = s ? i : h;
                switch (c) {
                    case 0:
                        if (s) {
                            var u = o;
                            o = r;
                            r = u;
                        }
                        t.d.add(((function () {
                            var $ret = new i2.LineGeometry();
                            $ret.d = { $type: i2.Point_$type, x: m, y: q };
                            $ret.c = { $type: i2.Point_$type, x: m, y: o };
                            return $ret;
                        })()));
                        t.d.add(((function () {
                            var $ret = new i2.RectangleGeometry();
                            $ret.e = new i2.Rect(0, l, r, n - l, o - r);
                            return $ret;
                        })()));
                        t.d.add(((function () {
                            var $ret = new i2.LineGeometry();
                            $ret.d = { $type: i2.Point_$type, x: m, y: r };
                            $ret.c = { $type: i2.Point_$type, x: m, y: p };
                            return $ret;
                        })()));
                        break;
                    case 1:
                        t.d.add(((function () {
                            var $ret = new i2.LineGeometry();
                            $ret.d = { $type: i2.Point_$type, x: l, y: o };
                            $ret.c = { $type: i2.Point_$type, x: m, y: o };
                            return $ret;
                        })()));
                        t.d.add(((function () {
                            var $ret = new i2.LineGeometry();
                            $ret.d = { $type: i2.Point_$type, x: m, y: q };
                            $ret.c = { $type: i2.Point_$type, x: m, y: p };
                            return $ret;
                        })()));
                        t.d.add(((function () {
                            var $ret = new i2.LineGeometry();
                            $ret.d = { $type: i2.Point_$type, x: m, y: r };
                            $ret.c = { $type: i2.Point_$type, x: n, y: r };
                            return $ret;
                        })()));
                        break;
                }
            };
            for (var k = 0; k < j.count; ++k) {
                _loop_2(k);
            }
        };
        FinancialPriceSeries.prototype.hn = function (a, b) {
            if (this.s1.b7 && a == this.s1.b5.g$j) {
                return null;
            }
            return _super.prototype.hn.call(this, a, b);
        };
        FinancialPriceSeries.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            this.s1.ci();
        };
        FinancialPriceSeries.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            if (this.s1.b7) {
                this.a6.exportTrendlineData(this, a, this.s1.b5.g$j);
            }
        };
        FinancialPriceSeries.prototype.oq = function () {
            return this.tm;
        };
        FinancialPriceSeries.prototype.l5 = function (a, b) {
            _super.prototype.l5.call(this, a, b);
            this.tm = b;
        };
        FinancialPriceSeries.prototype.a8 = function (a) {
            if (this.s2 == 0) {
                return 3;
            }
            else if (this.s2 == 1) {
                return 2;
            }
            return a;
        };
        FinancialPriceSeries.$t = i2.markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
        FinancialPriceSeries.tb = i2.DependencyProperty.i("ActualTrendLineBrush", i2.Brush.$, FinancialPriceSeries.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
        FinancialPriceSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['DisplayType:s2:tc', [PriceDisplayType_$type, i2.enumGetBox(PriceDisplayType_$type, 0)], 'NegativeOutline:tm:td', [i2.Brush.$, null], 'TrendLineType::tj', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'TrendLineThickness::ti', [1, 1.5], 'TrendLinePeriod::th', [1, 7], 'TrendLineBrush::te', [i2.Brush.$, null], 'TrendLineZIndex:s5:tk', [1, 1001], 'TrendLineDashArray:tn:tf', [i2.DoubleCollection.$], 'TrendLineDashCap:to:tg', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)]]);
        return FinancialPriceSeries;
    }(FinancialSeries));
    /**
     * @hidden
     */
    var FinancialPriceSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialPriceSeriesView, _super);
        function FinancialPriceSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.b3 = null;
            _this.b6 = null;
            _this.b9 = null;
            _this.cn = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                return $ret;
            })());
            _this.cm = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.GeometryGroup();
                return $ret;
            })());
            _this.b4 = null;
            _this.cl = new i2.Path();
            _this.b8 = false;
            _this.b3 = a;
            _this.b9 = new i2.List$1(i2.Path.$, 0);
            _this.b6 = ((function () {
                var $ret = new i2.Pool$1(i2.Path.$);
                $ret.create = i2.runOn(_this, _this.co);
                $ret.activate = i2.runOn(_this, _this.ce);
                $ret.disactivate = i2.runOn(_this, _this.cg);
                $ret.destroy = i2.runOn(_this, _this.cf);
                return $ret;
            })());
            return _this;
        }
        FinancialPriceSeriesView.prototype.co = function () {
            var a = new i2.Path();
            this.b9.add(a);
            a._visibility = 1;
            return a;
        };
        FinancialPriceSeriesView.prototype.ce = function (a) {
            a._visibility = 0;
        };
        FinancialPriceSeriesView.prototype.cg = function (a) {
            a._visibility = 1;
        };
        FinancialPriceSeriesView.prototype.cf = function (a) {
            this.b9.remove(a);
        };
        FinancialPriceSeriesView.prototype.by = function () {
            return new FinancialPriceBucketCalculator(this);
        };
        FinancialPriceSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b3.s2 = Defaults.g;
                this.b3.sw = Defaults.ah;
                this.b3.tm = Defaults.ai;
                this.b3.gh = Defaults.k;
                this.b3.gm = Defaults.l;
                this.b3.oo = this.b3.oi;
            }
        };
        Object.defineProperty(FinancialPriceSeriesView.prototype, "b5", {
            get: function () {
                if (this.b4 == null) {
                    this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
                }
                return this.b4;
            },
            set: function (a) {
                this.b4 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialPriceSeriesView.prototype, "b7", {
            get: function () {
                return this.b4 != null;
            },
            enumerable: false,
            configurable: true
        });
        FinancialPriceSeriesView.prototype.ch = function () {
            if (this.b3.s2 == 1) {
                this.cn._stroke = this.e.of;
            }
            else {
                this.cn._stroke = this.e.oi;
            }
            if (this.b3.s2 == 1) {
                this.cm._stroke = this.bz.sw;
            }
            else {
                this.cm._stroke = this.b3.tm;
            }
        };
        FinancialPriceSeriesView.prototype.cb = function () {
            this.aq();
            this.b6.count = 0;
            this.ca();
        };
        FinancialPriceSeriesView.prototype.ca = function () {
            var a = i2.typeCast(i2.GeometryGroup.$, this.cn.ak);
            var b = i2.typeCast(i2.GeometryGroup.$, this.cm.ak);
            i2.Extensions.d(a);
            i2.Extensions.d(b);
        };
        FinancialPriceSeriesView.prototype.ck = function () {
            this.aq();
            return i2.typeCast(i2.GeometryGroup.$, this.cn.ak);
        };
        FinancialPriceSeriesView.prototype.cj = function () {
            this.aq();
            return i2.typeCast(i2.GeometryGroup.$, this.cm.ak);
        };
        FinancialPriceSeriesView.prototype.ci = function () {
            this.b3.tl = null;
            if (this.b3.trendLineBrush != null) {
                this.b3.tl = this.b3.trendLineBrush;
            }
            else {
                this.b3.tl = this.b3.of;
            }
        };
        FinancialPriceSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
            this.cn.ac = this.e.fl;
            this.cn.ai = this.e.os;
            this.cn.ad = this.e.ot;
            if (this.b3.s2 == 1) {
                this.cn._stroke = this.e.of;
            }
            else {
                this.cn._stroke = this.e.oi;
                this.cn._fill = this.e.of;
            }
            this.cm.ac = this.e.fl;
            this.cm.ai = this.e.os;
            this.cm.ad = this.e.ot;
            if (this.b3.s2 == 1) {
                this.cm._stroke = this.bz.sw;
            }
            else {
                this.cm._stroke = this.b3.tm;
                this.cm._fill = this.bz.sw;
            }
        };
        FinancialPriceSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.cn.ac = this.e.fl + 3;
            if (this.b3.s2 == 1) {
                this.cn._stroke = a;
            }
            else {
                this.cn._stroke = a;
                this.cn._fill = a;
            }
            this.cm.ac = this.e.fl + 3;
            if (this.b3.s2 == 1) {
                this.cm._stroke = a;
            }
            else {
                this.cm._stroke = a;
                this.cm._fill = a;
            }
        };
        FinancialPriceSeriesView.prototype.ac = function (a) {
            return this.b9._inner[a];
        };
        FinancialPriceSeriesView.prototype.ab = function (a) {
            var b = this.b9._inner[a];
            this.cl._visibility = b._visibility;
            this.cl.ak = b.ak;
            var c = this.bp(a);
            this.cl._fill = c;
            this.cl._stroke = c;
            this.cl.ac = this.e.fl + 3;
            return this.cl;
        };
        FinancialPriceSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (this.b8) {
                    for (var c = 0; c < this.b9.count; c++) {
                        var d = this.aa(c, b);
                        if (d._visibility == 0) {
                            a.s(d);
                        }
                    }
                }
                else {
                    a.s(this.cn);
                    a.s(this.cm);
                }
            }
        };
        FinancialPriceSeriesView.prototype.a5 = function (a, b) {
            if (a.d) {
                if (this.b3.trendLineType != 0 && !b) {
                    var c = this.b5.g$j;
                    c.ac = this.b3.trendLineThickness;
                    c._stroke = this.b3.tl;
                    c.ai = this.b3.tn;
                    c.ad = this.b3.to;
                    a.u(c);
                }
            }
            _super.prototype.a5.call(this, a, b);
        };
        FinancialPriceSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            if (this.b3.qy()) {
                for (var b = 0; b < this.b9.count; b++) {
                    var c = this.b9._inner[b];
                    if (c._fill == this.b3.sw) {
                        this.e.a6.exportPathData(a, c, "negativePathShape" + b, ["Negative"]);
                    }
                    else {
                        this.e.a6.exportPathData(a, c, "positivePathShape" + b, ["Positive", "Main"]);
                    }
                }
            }
            else {
                this.e.a6.exportPathData(a, this.cn, "positivePathShape", ["Positive", "Main"]);
                this.e.a6.exportPathData(a, this.cm, "negativePathShape", ["Negative"]);
            }
        };
        FinancialPriceSeriesView.prototype.cc = function () {
            this.aq();
        };
        FinancialPriceSeriesView.prototype.cd = function () {
            if (this.b7) {
                this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.ar(), this.e.mr, this.e, this.e.ck);
            }
        };
        FinancialPriceSeriesView.$t = i2.markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);
        return FinancialPriceSeriesView;
    }(FinancialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent financial price series that renders as Candlestick or OHLC representations.
     * Default required members: Open, Low, High, Close
    *
    * The `IgxFinancialPriceSeriesComponent` class represents a IgxDataChartComponent financial price series that renders as Candlestick or OHLC representations.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *       >
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    *    series.xAxis = this.xAxis;
    *    series.yAxis = this.yAxis;
    *    series.openMemberPath = "open";
    *    series.highMemberPath = "high";
    *    series.lowMemberPath = "low";
    *    series.closeMemberPath = "close";
    *    series.volumeMemberPath="volume";
    *    this.chart.series.add(series);
    * ```
    */
    var IgxFinancialPriceSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialPriceSeriesComponent, _super);
        function IgxFinancialPriceSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxFinancialPriceSeriesComponent.prototype.createImplementation = function () {
            return new FinancialPriceSeries();
        };
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "isFinancialSeries", {
            /**
             * Gets whether the series has financial OHLC/candlestick visuals
            */
            get: function () {
                return this.i.dl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the trend type for the current financial series.
            *
            * Use the `trendLineType` property for the trend type of the current financial series.
            *
            * ```ts
            * series.trendLineType= "CubicFit";
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *  <igx-ordinal-time-x-axis
            *     dateTimeMemberPath="TimeStamp"
            *     #xAxis >
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            *       trendLineType="CubicFit">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.trendLineType;
            },
            set: function (v) {
                this.i.trendLineType = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the brush to use to draw the trend line.
            *
            * Use the `trendLineBrush` property to brush the the trend line.
            *
            * ```ts
            * series.trendLineBrush="red";
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *  <igx-ordinal-time-x-axis
            *     dateTimeMemberPath="TimeStamp"
            *     #xAxis >
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            *      trendLineBrush="red" >
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.trendLineBrush);
            },
            set: function (v) {
                this.i.trendLineBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "actualTrendLineBrush", {
            /**
             * Gets the effective TrendLineBrush for this FinancialPriceSeries.
            *
            * Use the `actualTrendLineBrush` property to Gets the effective TrendLineBrush for the FinancialIndicator.
            */
            get: function () {
                return i2.brushToString(this.i.tl);
            },
            set: function (v) {
                this.i.tl = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the current FinancialPriceSeries object's trend line.
            *
            * Use the `trendLineThickness` property for the thickness of the current FinancialPriceSeries object's trend line.
            *
            * ```ts
            * series.trendLineThickness=5;
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *  <igx-ordinal-time-x-axis
            *     dateTimeMemberPath="TimeStamp"
            *     #xAxis >
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            *       trendLineThickness="3">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.trendLineThickness;
            },
            set: function (v) {
                this.i.trendLineThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the trend line period for the current series.
             * The typical, and initial, value for trend line period is 7.
            *
            * Use the `trendLinePeriod` property for the periodo the the current series.
            *
            * ```ts
            * series.trendLinePeriod= 7;
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *  <igx-ordinal-time-x-axis
            *     dateTimeMemberPath="TimeStamp"
            *     #xAxis >
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            *       trendLinePeriod="7">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.trendLinePeriod;
            },
            set: function (v) {
                this.i.trendLinePeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "displayType", {
            /**
             * Gets or sets the display type for the current FinancialPriceSeries object.
            *
            * Use the `displayType` property for the display type of the current FinancialPriceSeries object.
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *  <igx-ordinal-time-x-axis
            *     dateTimeMemberPath="TimeStamp"
            *     #xAxis >
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            *       displayType="Candlestick">
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.displayType=PriceDisplayType.Candlestick;
            * ```
            */
            get: function () {
                return this.i.s2;
            },
            set: function (v) {
                this.i.s2 = i2.ensureEnum(PriceDisplayType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialPriceSeriesComponent.prototype, "negativeOutline", {
            /**
             * Brush to use for outlining negative elements in the series.
            *
            * Use the `negativeOutline` property to brush the outline negative elements in the series.
            *
            * ```ts
            * series.negativeOutline="red";
            * ```
            *
            * ```html
            *  <igx-data-chart
            *     #chart
            *         [dataSource]="data" >
            *  <igx-ordinal-time-x-axis
            *     dateTimeMemberPath="TimeStamp"
            *     #xAxis >
            *     </igx-ordinal-time-x-axis>
            *  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            * </igx-numeric-y-axis>
            * <igx-financial-price-series
            *     [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       openMemberPath="open"
            *       highMemberPath="high"
            *       lowMemberPath="low"
            *       closeMemberPath="close"
            *       volumeMemberPath="volume"
            *       negativeOutline="Red" >
            * </igx-financial-price-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.tm);
            },
            set: function (v) {
                this.i.tm = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        *
        * The `getSeriesValueBoundingBox` method return the best available value bounding box within the series that has the best value match for the world position provided.
        */
        IgxFinancialPriceSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The categorySeries is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        *
        * The `scrollIntoView` methos scrolls the series to display the item for the specified data item.
        */
        IgxFinancialPriceSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        *
        * The `getItemSpan` method is used For a category plotted series, returns the current width of the items within the categories.
        *
        * This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned
        */
        IgxFinancialPriceSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxFinancialPriceSeriesComponent.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
            this.i.l5(i2.stringToBrush(negativeBrush), i2.stringToBrush(negativeOutline));
        };
        IgxFinancialPriceSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialPriceSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialPriceSeriesComponent, selector: "igx-financial-price-series", inputs: { trendLineType: "trendLineType", trendLineBrush: "trendLineBrush", actualTrendLineBrush: "actualTrendLineBrush", trendLineThickness: "trendLineThickness", trendLinePeriod: "trendLinePeriod", displayType: "displayType", negativeOutline: "negativeOutline" }, providers: [{ provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFinancialPriceSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFinancialPriceSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFinancialPriceSeriesComponent;
    }(IgxFinancialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-financial-price-series',
                        template: "",
                        providers: [{ provide: IgxFinancialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFinancialPriceSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxFinancialPriceSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { trendLineType: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], actualTrendLineBrush: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], displayType: [{
                    type: i0.Input
                }], negativeOutline: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialPriceSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialPriceSeriesModule() {
        }
        IgxFinancialPriceSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialPriceSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesModule, declarations: [IgxFinancialPriceSeriesComponent], imports: [i1.CommonModule, IgxFinancialPriceSeriesProxyModule], exports: [IgxFinancialPriceSeriesComponent, IgxFinancialPriceSeriesProxyModule] });
        IgxFinancialPriceSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesModule, imports: [[i1.CommonModule, IgxFinancialPriceSeriesProxyModule], IgxFinancialPriceSeriesProxyModule] });
        return IgxFinancialPriceSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFinancialPriceSeriesComponent],
                        imports: [i1.CommonModule, IgxFinancialPriceSeriesProxyModule],
                        exports: [IgxFinancialPriceSeriesComponent, IgxFinancialPriceSeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialPriceSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialPriceSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxFinancialPriceSeriesComponent", IgxFinancialPriceSeriesComponent);
            i2.TypeRegistrar.register("FinancialPriceSeries", FinancialPriceSeries.$type);
        }
        IgxFinancialPriceSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialPriceSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesDynamicModule, imports: [i1.CommonModule, IgxFinancialPriceSeriesModule], exports: [IgxFinancialPriceSeriesModule] });
        IgxFinancialPriceSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesDynamicModule, imports: [[i1.CommonModule, IgxFinancialPriceSeriesModule], IgxFinancialPriceSeriesModule] });
        return IgxFinancialPriceSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialPriceSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxFinancialPriceSeriesModule],
                        exports: [IgxFinancialPriceSeriesModule],
                        entryComponents: [IgxFinancialPriceSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Represents a calculation strategy that takes in a column of values
     * and returns a resulting column of values.
    */
    var IgxColumnSupportingCalculation = /** @class */ /*@__PURE__*/ (function () {
        function IgxColumnSupportingCalculation() {
        }
        Object.defineProperty(IgxColumnSupportingCalculation.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxColumnSupportingCalculation.prototype.onImplementationCreated = function () {
        };
        IgxColumnSupportingCalculation.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        IgxColumnSupportingCalculation.prototype.findByName = function (name) {
            return null;
        };
        return IgxColumnSupportingCalculation;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a calculation strategy that uses the calculation data source
     * to product a column of values.
    *
    * `IgxDataSourceSupportingCalculation` class Represents a calculation strategy that uses the calculation data source to product a column of values.
    *
    *     DataSourceSupportingCalculation SC = new DataSourceSupportingCalculation();
    */
    var IgxDataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataSourceSupportingCalculation() {
        }
        Object.defineProperty(IgxDataSourceSupportingCalculation.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxDataSourceSupportingCalculation.prototype.onImplementationCreated = function () {
        };
        IgxDataSourceSupportingCalculation.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        IgxDataSourceSupportingCalculation.prototype.findByName = function (name) {
            return null;
        };
        return IgxDataSourceSupportingCalculation;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IndicatorPane = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IndicatorPane, _super);
        function IndicatorPane() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.d = null;
            _this.a = null;
            return _this;
        }
        IndicatorPane.prototype.h = function (a) {
            this.c = a;
            if (this.c == null) {
                return;
            }
            this.d = this.c.createElement("div");
            this.d.setStyleProperty("height", "100%");
            this.d.setStyleProperty("width", "100%");
            this.d.setStyleProperty("display", "grid");
            this.d.setStyleProperty("display", "-ms-grid");
            this.d.setStyleProperty("-ms-grid-columns", "100%");
            this.c.append(this.d);
            this.i();
        };
        IndicatorPane.prototype.i = function () {
            if (this.d == null) {
                return;
            }
            this.d.removeChildren();
            if (this.b == null) {
                return;
            }
            var a = "";
            for (var b = 0; b < this.b.count; b++) {
                var c = this.b._inner[b];
                var d = this.c.createElement("div");
                d.setStyleProperty("grid-row", (b + 1).toString());
                d.setStyleProperty("grid-column", (1).toString());
                d.setStyleProperty("-ms-grid-row", (b + 1).toString());
                d.setStyleProperty("-ms-grid-column", (1).toString());
                this.d.append(d);
                var e = this.c.getSubRenderer(d);
                c.provideContainer(e);
                a += " 1fr";
            }
            a = a.trim();
            this.d.setStyleProperty("-ms-grid-rows", a);
        };
        Object.defineProperty(IndicatorPane.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.b;
                if (a != b) {
                    this.a = a;
                    this.g("IndicatorCharts", b, this.b);
                }
            },
            enumerable: false,
            configurable: true
        });
        IndicatorPane.prototype.g = function (a, b, c) {
            switch (a) {
                case "IndicatorCharts":
                    this.i();
                    break;
            }
        };
        IndicatorPane.prototype.f = function () {
            var e_1, _a;
            if (this.b == null || this.c == null) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.notifyContainerResized();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        IndicatorPane.$t = i2.markType(IndicatorPane, 'IndicatorPane');
        return IndicatorPane;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available series types to display in the volume pane.
     */
    var FinancialChartVolumeType = /*@__PURE__*/ (function (FinancialChartVolumeType) {
        /**
         * Do not display the volume pane.
         */
        FinancialChartVolumeType[FinancialChartVolumeType["None"] = 0] = "None";
        /**
         * Display column series in the volume pane.
         */
        FinancialChartVolumeType[FinancialChartVolumeType["Column"] = 1] = "Column";
        /**
         * Display line series in the volume pane.
         */
        FinancialChartVolumeType[FinancialChartVolumeType["Line"] = 2] = "Line";
        /**
         * Display area series in the volume pane.
         */
        FinancialChartVolumeType[FinancialChartVolumeType["Area"] = 3] = "Area";
        return FinancialChartVolumeType;
    })({});
    /**
     * @hidden
     */
    var FinancialChartVolumeType_$type = i2.markEnum('FinancialChartVolumeType', 'None,0|Column,1|Line,2|Area,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available X axis types in the Financial Chart.
     */
    var FinancialChartXAxisMode = /*@__PURE__*/ (function (FinancialChartXAxisMode) {
        /**
         * An ordinal scale with time labels.
         * Items on an ordinal scale are consecutive and equidistant.
         */
        FinancialChartXAxisMode[FinancialChartXAxisMode["Ordinal"] = 0] = "Ordinal";
        /**
         * A time scale.
         * Items on a time scale are positioned according to their time values.
         */
        FinancialChartXAxisMode[FinancialChartXAxisMode["Time"] = 1] = "Time";
        return FinancialChartXAxisMode;
    })({});
    /**
     * @hidden
     */
    var FinancialChartXAxisMode_$type = i2.markEnum('FinancialChartXAxisMode', 'Ordinal,0|Time,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available Y axis types in the Financial Chart.
     */
    var FinancialChartYAxisMode = /*@__PURE__*/ (function (FinancialChartYAxisMode) {
        /**
         * A linear or logarithmic numeric scale.
         */
        FinancialChartYAxisMode[FinancialChartYAxisMode["Numeric"] = 0] = "Numeric";
        /**
         * A numeric scale where all values are scaled proportionally to a reference value.
         */
        FinancialChartYAxisMode[FinancialChartYAxisMode["PercentChange"] = 1] = "PercentChange";
        return FinancialChartYAxisMode;
    })({});
    /**
     * @hidden
     */
    var FinancialChartYAxisMode_$type = i2.markEnum('FinancialChartYAxisMode', 'Numeric,0|PercentChange,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available price series types to display in the main chart.
     */
    var FinancialChartType = /*@__PURE__*/ (function (FinancialChartType) {
        /**
         * Automatically determine the price series type to display in the main chart.
         */
        FinancialChartType[FinancialChartType["Auto"] = 0] = "Auto";
        /**
         * Display financial bar series in the main chart.
         */
        FinancialChartType[FinancialChartType["Bar"] = 1] = "Bar";
        /**
         * Display candlestick series in the main chart.
         */
        FinancialChartType[FinancialChartType["Candle"] = 2] = "Candle";
        /**
         * Display column series in the main chart.
         */
        FinancialChartType[FinancialChartType["Column"] = 3] = "Column";
        /**
         * Display line series in the main chart.
         */
        FinancialChartType[FinancialChartType["Line"] = 4] = "Line";
        return FinancialChartType;
    })({});
    /**
     * @hidden
     */
    var FinancialChartType_$type = i2.markEnum('FinancialChartType', 'Auto,0|Bar,1|Candle,2|Column,3|Line,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the available series types to display in the zoom slider pane.
     */
    var FinancialChartZoomSliderType = /*@__PURE__*/ (function (FinancialChartZoomSliderType) {
        /**
         * Do not display the zoom slider pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["None"] = 0] = "None";
        /**
         * In the zoom slider pane, match the series type in the price pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["Auto"] = 1] = "Auto";
        /**
         * Display financial bar series in the zoom slider pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["Bar"] = 2] = "Bar";
        /**
         * Display candle series in the zoom slider pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["Candle"] = 3] = "Candle";
        /**
         * Display column series in the zoom slider pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["Column"] = 4] = "Column";
        /**
         * Display line series in the zoom slider pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["Line"] = 5] = "Line";
        /**
         * Display an area series in the zoom slider pane.
         */
        FinancialChartZoomSliderType[FinancialChartZoomSliderType["Area"] = 6] = "Area";
        return FinancialChartZoomSliderType;
    })({});
    /**
     * @hidden
     */
    var FinancialChartZoomSliderType_$type = i2.markEnum('FinancialChartZoomSliderType', 'None,0|Auto,1|Bar,2|Candle,3|Column,4|Line,5|Area,6');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * An enum representing the time range presets on a financial chart range selector.
     */
    var FinancialChartRangeSelectorOption = /*@__PURE__*/ (function (FinancialChartRangeSelectorOption) {
        /**
         * Include a preset button for one month in the range selector.
         */
        FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["OneMonth"] = 0] = "OneMonth";
        /**
         * Include a preset button for three months in the range selector.
         */
        FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["ThreeMonths"] = 1] = "ThreeMonths";
        /**
         * Include a preset button for six months in the range selector.
         */
        FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["SixMonths"] = 2] = "SixMonths";
        /**
         * Include a preset button for year-to-date in the range selector.
         */
        FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["YearToDate"] = 3] = "YearToDate";
        /**
         * Include a preset button for one year in the range selector.
         */
        FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["OneYear"] = 4] = "OneYear";
        /**
         * Include a preset button for all data in the range selector.
         */
        FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["All"] = 5] = "All";
        return FinancialChartRangeSelectorOption;
    })({});
    /**
     * @hidden
     */
    var FinancialChartRangeSelectorOption_$type = i2.markEnum('FinancialChartRangeSelectorOption', 'OneMonth,0|ThreeMonths,1|SixMonths,2|YearToDate,3|OneYear,4|All,5');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartRangeSelectorOptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartRangeSelectorOptionCollection, _super);
        function FinancialChartRangeSelectorOptionCollection(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        _this = _super.call(this, FinancialChartRangeSelectorOption_$type, 0) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, FinancialChartRangeSelectorOption_$type, 1, c) || this;
                    }
                    break;
            }
            return _this;
        }
        FinancialChartRangeSelectorOptionCollection.$t = i2.markType(FinancialChartRangeSelectorOptionCollection, 'FinancialChartRangeSelectorOptionCollection', i2.ObservableCollection$1.$.specialize(FinancialChartRangeSelectorOption_$type));
        return FinancialChartRangeSelectorOptionCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TemplatedHtmlControl = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TemplatedHtmlControl, _super);
        function TemplatedHtmlControl(a, b, c) {
            var _this = _super.call(this) || this;
            _this.j = null;
            _this.i = null;
            _this.e = null;
            _this.d = null;
            _this.i = TemplatedHtmlControl.h(b, a, c);
            _this.j = a;
            return _this;
        }
        TemplatedHtmlControl.f = function (a, b) {
            for (var c = 0; c < a.getChildCount(); c++) {
                var d = a.getChildAt(c);
                if (d.getNativeElement() != null) {
                    var ele_ = d.getNativeElement();
                    if (b.toUpperCase() == (ele_.nodeName).toUpperCase()) {
                        return d;
                    }
                    var e = TemplatedHtmlControl.f(d, b);
                    if (e != null) {
                        return e;
                    }
                }
            }
            return null;
        };
        TemplatedHtmlControl.a = function (a, b) {
            var c = new i2.List$1(i2.DomWrapper_$type, 0);
            for (var d = 0; d < a.getChildCount(); d++) {
                var e = a.getChildAt(d);
                if (e.getNativeElement() != null) {
                    var ele_ = e.getNativeElement();
                    if (b.toUpperCase() == (ele_.nodeName).toUpperCase()) {
                        c.add(e);
                    }
                    var f = TemplatedHtmlControl.a(e, b);
                    if (f != null) {
                        c.o(f);
                    }
                }
            }
            return c;
        };
        TemplatedHtmlControl.h = function (a, b, c) {
            return a;
        };
        Object.defineProperty(TemplatedHtmlControl.prototype, "g", {
            get: function () {
                if (this.e == null && this.d != null) {
                    return this.d.rootWrapper;
                }
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        TemplatedHtmlControl.prototype.l = function (a) {
            if (a == null) {
                if (this.g != null) {
                    this.g.remove();
                }
                return;
            }
            this.d = a;
        };
        TemplatedHtmlControl.c = function (a) {
            return null;
        };
        TemplatedHtmlControl.n = function (a, b, c, d) {
            TemplatedHtmlControl.m(a, d.b1(b), c);
        };
        TemplatedHtmlControl.m = function (a, b, c) {
            if (c == null) {
                return;
            }
            var d = c.querySelector(a);
            if (d == null) {
                return;
            }
            d.setText(b);
        };
        TemplatedHtmlControl.prototype.b = function () {
            if (this.d == null || this.d.rootWrapper == null) {
                return NaN;
            }
            var a = this.d.rootWrapper.getOffset();
            return this.d.rootWrapper.width() + (a == null ? 0 : a.left);
        };
        TemplatedHtmlControl.prototype.k = function () {
            if (this.d == null || this.d.rootWrapper == null) {
                return;
            }
            this.d.rootWrapper.hide();
        };
        TemplatedHtmlControl.$t = i2.markType(TemplatedHtmlControl, 'TemplatedHtmlControl');
        return TemplatedHtmlControl;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartContext, _super);
        function FinancialChartContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._vm = null;
            _this._template = null;
            _this._container = null;
            _this._toolbarContainer = null;
            _this._legendContainer = null;
            _this._indicatorsContainer = null;
            _this._volumeContainer = null;
            _this._zoomContainer = null;
            return _this;
        }
        Object.defineProperty(FinancialChartContext.prototype, "vm", {
            get: function () {
                return this._vm;
            },
            set: function (a) {
                this._vm = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "template", {
            get: function () {
                return this._template;
            },
            set: function (a) {
                this._template = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "container", {
            get: function () {
                return this._container;
            },
            set: function (a) {
                this._container = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "toolbarContainer", {
            get: function () {
                return this._toolbarContainer;
            },
            set: function (a) {
                this._toolbarContainer = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "legendContainer", {
            get: function () {
                return this._legendContainer;
            },
            set: function (a) {
                this._legendContainer = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "indicatorsContainer", {
            get: function () {
                return this._indicatorsContainer;
            },
            set: function (a) {
                this._indicatorsContainer = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "volumeContainer", {
            get: function () {
                return this._volumeContainer;
            },
            set: function (a) {
                this._volumeContainer = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartContext.prototype, "zoomContainer", {
            get: function () {
                return this._zoomContainer;
            },
            set: function (a) {
                this._zoomContainer = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartContext.$t = i2.markType(FinancialChartContext, 'FinancialChartContext');
        return FinancialChartContext;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartToolbarContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartToolbarContext, _super);
        function FinancialChartToolbarContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._vm = null;
            _this._template = null;
            _this._container = null;
            return _this;
        }
        Object.defineProperty(FinancialChartToolbarContext.prototype, "vm", {
            get: function () {
                return this._vm;
            },
            set: function (a) {
                this._vm = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbarContext.prototype, "template", {
            get: function () {
                return this._template;
            },
            set: function (a) {
                this._template = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbarContext.prototype, "container", {
            get: function () {
                return this._container;
            },
            set: function (a) {
                this._container = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbarContext.$t = i2.markType(FinancialChartToolbarContext, 'FinancialChartToolbarContext');
        return FinancialChartToolbarContext;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartViewModel, _super);
        function FinancialChartViewModel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._toolbar = null;
            return _this;
        }
        Object.defineProperty(FinancialChartViewModel.prototype, "toolbar", {
            get: function () {
                return this._toolbar;
            },
            set: function (a) {
                this._toolbar = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartViewModel.$t = i2.markType(FinancialChartViewModel, 'FinancialChartViewModel');
        return FinancialChartViewModel;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartToolbarViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartToolbarViewModel, _super);
        function FinancialChartToolbarViewModel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._financialChartRangeSelector = null;
            _this._financialChartTypePicker = null;
            _this._financialChartIndicatorMenu = null;
            _this._isIndicatorMenuVisible = false;
            return _this;
        }
        Object.defineProperty(FinancialChartToolbarViewModel.prototype, "financialChartRangeSelector", {
            get: function () {
                return this._financialChartRangeSelector;
            },
            set: function (a) {
                this._financialChartRangeSelector = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbarViewModel.prototype, "financialChartTypePicker", {
            get: function () {
                return this._financialChartTypePicker;
            },
            set: function (a) {
                this._financialChartTypePicker = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbarViewModel.prototype, "financialChartIndicatorMenu", {
            get: function () {
                return this._financialChartIndicatorMenu;
            },
            set: function (a) {
                this._financialChartIndicatorMenu = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbarViewModel.prototype, "isIndicatorMenuVisible", {
            get: function () {
                return this._isIndicatorMenuVisible;
            },
            set: function (a) {
                this._isIndicatorMenuVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbarViewModel.$t = i2.markType(FinancialChartToolbarViewModel, 'FinancialChartToolbarViewModel');
        return FinancialChartToolbarViewModel;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of marker than can be displayed by default by series with markers.
     */
    var FinancialOverlayType = /*@__PURE__*/ (function (FinancialOverlayType) {
        /**
         * Bollinger bands overlay.
         */
        FinancialOverlayType[FinancialOverlayType["BollingerBands"] = 0] = "BollingerBands";
        /**
         * Price channel overlay.
         */
        FinancialOverlayType[FinancialOverlayType["PriceChannel"] = 1] = "PriceChannel";
        return FinancialOverlayType;
    })({});
    /**
     * @hidden
     */
    var FinancialOverlayType_$type = i2.markEnum('FinancialOverlayType', 'BollingerBands,0|PriceChannel,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of marker than can be displayed by default by series with markers.
     */
    var FinancialIndicatorType = /*@__PURE__*/ (function (FinancialIndicatorType) {
        /**
         * Absolute volume oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["AbsoluteVolumeOscillator"] = 0] = "AbsoluteVolumeOscillator";
        /**
         * Accumulation distribution indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["AccumulationDistribution"] = 1] = "AccumulationDistribution";
        /**
         * Average directional index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["AverageDirectionalIndex"] = 2] = "AverageDirectionalIndex";
        /**
         * Average true range indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["AverageTrueRange"] = 3] = "AverageTrueRange";
        /**
         * Bollinger band width indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["BollingerBandWidth"] = 4] = "BollingerBandWidth";
        /**
         * Chaikin oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["ChaikinOscillator"] = 5] = "ChaikinOscillator";
        /**
         * Chaikin volatility indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["ChaikinVolatility"] = 6] = "ChaikinVolatility";
        /**
         * Commodity channel index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["CommodityChannelIndex"] = 7] = "CommodityChannelIndex";
        /**
         * Detrended price oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["DetrendedPriceOscillator"] = 8] = "DetrendedPriceOscillator";
        /**
         * Ease of movement indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["EaseOfMovement"] = 9] = "EaseOfMovement";
        /**
         * Fast stochastic oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["FastStochasticOscillator"] = 10] = "FastStochasticOscillator";
        /**
         * Force index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["ForceIndex"] = 11] = "ForceIndex";
        /**
         * Full stochastic oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["FullStochasticOscillator"] = 12] = "FullStochasticOscillator";
        /**
         * Market facilitation index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["MarketFacilitationIndex"] = 13] = "MarketFacilitationIndex";
        /**
         * Mass index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["MassIndex"] = 14] = "MassIndex";
        /**
         * Median price indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["MedianPrice"] = 15] = "MedianPrice";
        /**
         * Money flow index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["MoneyFlowIndex"] = 16] = "MoneyFlowIndex";
        /**
         * Moving average convergence divergence (MACD) indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["MovingAverageConvergenceDivergence"] = 17] = "MovingAverageConvergenceDivergence";
        /**
         * Negative volume index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["NegativeVolumeIndex"] = 18] = "NegativeVolumeIndex";
        /**
         * On balance volume indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["OnBalanceVolume"] = 19] = "OnBalanceVolume";
        /**
         * Percentage price oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["PercentagePriceOscillator"] = 20] = "PercentagePriceOscillator";
        /**
         * Percentage volume oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["PercentageVolumeOscillator"] = 21] = "PercentageVolumeOscillator";
        /**
         * Positive volume index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["PositiveVolumeIndex"] = 22] = "PositiveVolumeIndex";
        /**
         * Price volume trend indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["PriceVolumeTrend"] = 23] = "PriceVolumeTrend";
        /**
         * Rate of change and momentum indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["RateOfChangeAndMomentum"] = 24] = "RateOfChangeAndMomentum";
        /**
         * Relative strength index indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["RelativeStrengthIndex"] = 25] = "RelativeStrengthIndex";
        /**
         * Slow stochastic oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["SlowStochasticOscillator"] = 26] = "SlowStochasticOscillator";
        /**
         * Standard deviation indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["StandardDeviation"] = 27] = "StandardDeviation";
        /**
         * StochRSI indicator.
         * Stochastic Relative Strength Index.
         */
        FinancialIndicatorType[FinancialIndicatorType["StochRSI"] = 28] = "StochRSI";
        /**
         * TRIX indicator.
         * TRIple eXponential.
         */
        FinancialIndicatorType[FinancialIndicatorType["TRIX"] = 29] = "TRIX";
        /**
         * Typical price indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["TypicalPrice"] = 30] = "TypicalPrice";
        /**
         * Ultimate oscillator indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["UltimateOscillator"] = 31] = "UltimateOscillator";
        /**
         * Weighted close indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["WeightedClose"] = 32] = "WeightedClose";
        /**
         * Williams %R indicator.
         */
        FinancialIndicatorType[FinancialIndicatorType["WilliamsPercentR"] = 33] = "WilliamsPercentR";
        return FinancialIndicatorType;
    })({});
    /**
     * @hidden
     */
    var FinancialIndicatorType_$type = i2.markEnum('FinancialIndicatorType', 'AbsoluteVolumeOscillator,0|AccumulationDistribution,1|AverageDirectionalIndex,2|AverageTrueRange,3|BollingerBandWidth,4|ChaikinOscillator,5|ChaikinVolatility,6|CommodityChannelIndex,7|DetrendedPriceOscillator,8|EaseOfMovement,9|FastStochasticOscillator,10|ForceIndex,11|FullStochasticOscillator,12|MarketFacilitationIndex,13|MassIndex,14|MedianPrice,15|MoneyFlowIndex,16|MovingAverageConvergenceDivergence,17|NegativeVolumeIndex,18|OnBalanceVolume,19|PercentagePriceOscillator,20|PercentageVolumeOscillator,21|PositiveVolumeIndex,22|PriceVolumeTrend,23|RateOfChangeAndMomentum,24|RelativeStrengthIndex,25|SlowStochasticOscillator,26|StandardDeviation,27|StochRSI,28|TRIX,29|TypicalPrice,30|UltimateOscillator,31|WeightedClose,32|WilliamsPercentR,33');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartRangeSelectorVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartRangeSelectorVisualData, _super);
        function FinancialChartRangeSelectorVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._visibility = null;
            _this._buttonVisibilities = null;
            _this._buttonLabels = null;
            _this._buttonsChecked = null;
            _this._buttonLefts = null;
            _this._buttonTops = null;
            _this._buttonWidths = null;
            _this._buttonHeights = null;
            _this._left = 0;
            _this._top = 0;
            _this._width = 0;
            _this._height = 0;
            return _this;
        }
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "visibility", {
            get: function () {
                return this._visibility;
            },
            set: function (a) {
                this._visibility = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonVisibilities", {
            get: function () {
                return this._buttonVisibilities;
            },
            set: function (a) {
                this._buttonVisibilities = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonLabels", {
            get: function () {
                return this._buttonLabels;
            },
            set: function (a) {
                this._buttonLabels = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonsChecked", {
            get: function () {
                return this._buttonsChecked;
            },
            set: function (a) {
                this._buttonsChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonLefts", {
            get: function () {
                return this._buttonLefts;
            },
            set: function (a) {
                this._buttonLefts = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonTops", {
            get: function () {
                return this._buttonTops;
            },
            set: function (a) {
                this._buttonTops = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonWidths", {
            get: function () {
                return this._buttonWidths;
            },
            set: function (a) {
                this._buttonWidths = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonHeights", {
            get: function () {
                return this._buttonHeights;
            },
            set: function (a) {
                this._buttonHeights = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "left", {
            get: function () {
                return this._left;
            },
            set: function (a) {
                this._left = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "top", {
            get: function () {
                return this._top;
            },
            set: function (a) {
                this._top = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (a) {
                this._width = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelectorVisualData.prototype.serialize = function () {
            return FinancialChartVisualData.y(["buttonLabels", "buttonsChecked", "buttonLefts", "buttonTops", "buttonWidths", "buttonHeights", "left", "top", "width", "height"], [this.buttonLabels, this.buttonsChecked, this.buttonLefts, this.buttonTops, this.buttonWidths, this.buttonHeights, this.left, this.top, this.width, this.height]);
        };
        FinancialChartRangeSelectorVisualData.$t = i2.markType(FinancialChartRangeSelectorVisualData, 'FinancialChartRangeSelectorVisualData');
        return FinancialChartRangeSelectorVisualData;
    }(i2.Base));
    /**
     * @hidden
     */
    var FinancialChartEnumPickerVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartEnumPickerVisualData, _super);
        function FinancialChartEnumPickerVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.g = null;
            _this.d = 0;
            _this.e = 0;
            _this.f = 0;
            _this.c = 0;
            _this.b = false;
            return _this;
        }
        FinancialChartEnumPickerVisualData.prototype.h = function () {
            return FinancialChartVisualData.y(["items", "selectedItem", "left", "top", "width", "height", "isVisible"], [this.a, this.g, this.d, this.e, this.f, this.c, this.b]);
        };
        FinancialChartEnumPickerVisualData.$t = i2.markType(FinancialChartEnumPickerVisualData, 'FinancialChartEnumPickerVisualData');
        return FinancialChartEnumPickerVisualData;
    }(i2.Base));
    /**
     * @hidden
     */
    var FinancialChartToolbarVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartToolbarVisualData, _super);
        function FinancialChartToolbarVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._chartTypePicker = null;
            _this._rangeSelector = null;
            return _this;
        }
        Object.defineProperty(FinancialChartToolbarVisualData.prototype, "chartTypePicker", {
            get: function () {
                return this._chartTypePicker;
            },
            set: function (a) {
                this._chartTypePicker = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbarVisualData.prototype, "rangeSelector", {
            get: function () {
                return this._rangeSelector;
            },
            set: function (a) {
                this._rangeSelector = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbarVisualData.prototype.serialize = function () {
            return FinancialChartVisualData.y(["chartTypePicker", "rangeSelector"], [this.chartTypePicker == null ? null : this.chartTypePicker.h(), this.rangeSelector == null ? null : this.rangeSelector.serialize()]);
        };
        FinancialChartToolbarVisualData.$t = i2.markType(FinancialChartToolbarVisualData, 'FinancialChartToolbarVisualData');
        return FinancialChartToolbarVisualData;
    }(i2.Base));
    /**
     * @hidden
     */
    var FinancialChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartVisualData, _super);
        function FinancialChartVisualData() {
            var _this = _super.call(this) || this;
            _this._mainChart = null;
            _this._volumeChart = null;
            _this._indicatorCharts = null;
            _this._toolbar = null;
            _this._zoomChart = null;
            _this._mainChartLeft = 0;
            _this._mainChartTop = 0;
            _this._volumeChartLeft = 0;
            _this._volumeChartTop = 0;
            _this._indicatorChartLefts = null;
            _this._indicatorChartTops = null;
            _this._zoomChartLeft = 0;
            _this._zoomChartTop = 0;
            _this._toolbarLeft = 0;
            _this._toolbarTop = 0;
            _this._toolbarWidth = 0;
            _this._toolbarHeight = 0;
            _this._legendLeft = 0;
            _this._legendTop = 0;
            _this._legendWidth = 0;
            _this._legendHeight = 0;
            _this._legend = null;
            _this.mainChartLeft = NaN;
            _this.mainChartTop = NaN;
            _this.volumeChartLeft = NaN;
            _this.volumeChartTop = NaN;
            _this.zoomChartLeft = NaN;
            _this.zoomChartTop = NaN;
            _this.indicatorChartLefts = new i2.List$1(i2.Number_$type, 0);
            _this.indicatorChartTops = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        Object.defineProperty(FinancialChartVisualData.prototype, "mainChart", {
            get: function () {
                return this._mainChart;
            },
            set: function (a) {
                this._mainChart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "volumeChart", {
            get: function () {
                return this._volumeChart;
            },
            set: function (a) {
                this._volumeChart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "indicatorCharts", {
            get: function () {
                return this._indicatorCharts;
            },
            set: function (a) {
                this._indicatorCharts = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "toolbar", {
            get: function () {
                return this._toolbar;
            },
            set: function (a) {
                this._toolbar = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "zoomChart", {
            get: function () {
                return this._zoomChart;
            },
            set: function (a) {
                this._zoomChart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "mainChartLeft", {
            get: function () {
                return this._mainChartLeft;
            },
            set: function (a) {
                this._mainChartLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "mainChartTop", {
            get: function () {
                return this._mainChartTop;
            },
            set: function (a) {
                this._mainChartTop = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "volumeChartLeft", {
            get: function () {
                return this._volumeChartLeft;
            },
            set: function (a) {
                this._volumeChartLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "volumeChartTop", {
            get: function () {
                return this._volumeChartTop;
            },
            set: function (a) {
                this._volumeChartTop = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "indicatorChartLefts", {
            get: function () {
                return this._indicatorChartLefts;
            },
            set: function (a) {
                this._indicatorChartLefts = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "indicatorChartTops", {
            get: function () {
                return this._indicatorChartTops;
            },
            set: function (a) {
                this._indicatorChartTops = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "zoomChartLeft", {
            get: function () {
                return this._zoomChartLeft;
            },
            set: function (a) {
                this._zoomChartLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "zoomChartTop", {
            get: function () {
                return this._zoomChartTop;
            },
            set: function (a) {
                this._zoomChartTop = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "toolbarLeft", {
            get: function () {
                return this._toolbarLeft;
            },
            set: function (a) {
                this._toolbarLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "toolbarTop", {
            get: function () {
                return this._toolbarTop;
            },
            set: function (a) {
                this._toolbarTop = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "toolbarWidth", {
            get: function () {
                return this._toolbarWidth;
            },
            set: function (a) {
                this._toolbarWidth = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "toolbarHeight", {
            get: function () {
                return this._toolbarHeight;
            },
            set: function (a) {
                this._toolbarHeight = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "legendLeft", {
            get: function () {
                return this._legendLeft;
            },
            set: function (a) {
                this._legendLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "legendTop", {
            get: function () {
                return this._legendTop;
            },
            set: function (a) {
                this._legendTop = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "legendWidth", {
            get: function () {
                return this._legendWidth;
            },
            set: function (a) {
                this._legendWidth = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "legendHeight", {
            get: function () {
                return this._legendHeight;
            },
            set: function (a) {
                this._legendHeight = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartVisualData.prototype, "legend", {
            get: function () {
                return this._legend;
            },
            set: function (a) {
                this._legend = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartVisualData.prototype.ab = function (a) {
            if (a != null) {
                var chart_ = a;
                chart_.scaleByViewport();
            }
        };
        FinancialChartVisualData.prototype.scaleByViewport = function () {
            this.ab(this.mainChart);
            this.ab(this.volumeChart);
            if (this.indicatorCharts != null) {
                for (var a = 0; a < this.indicatorCharts.count; a++) {
                    this.ab(this.indicatorCharts._inner[a]);
                }
            }
            this.ab(this.zoomChart);
        };
        FinancialChartVisualData.prototype.w = function (a) {
            if (a != null) {
                var chart_ = a;
                return (chart_.serialize());
            }
            return null;
        };
        FinancialChartVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.volumeChart != null) {
                a.u("volumeChart: " + this.w(this.volumeChart) + ",");
            }
            if (this.zoomChart != null) {
                a.u("zoomChart: " + this.w(this.zoomChart) + ",");
            }
            if (this.indicatorCharts != null) {
                a.u("indicatorCharts: [");
                for (var b = 0; b < this.indicatorCharts.count; b++) {
                    if (b > 0) {
                        a.u(",");
                    }
                    a.l(this.w(this.indicatorCharts._inner[b]));
                }
                a.t();
                a.u("],");
            }
            if (this.toolbar != null) {
                a.u("toolbar: " + this.toolbar.serialize() + ",");
            }
            if (this.mainChart != null) {
                a.u("mainChart: " + this.w(this.mainChart) + ",");
            }
            a.u("mainChartLeft: " + this.mainChartLeft.toString() + ",");
            a.u("mainChartTop: " + this.mainChartTop.toString() + ",");
            a.u("volumeChartLeft: " + this.volumeChartLeft.toString() + ",");
            a.u("volumeChartTop: " + this.volumeChartTop.toString() + ",");
            a.u("zoomChartLeft: " + this.zoomChartLeft.toString() + ",");
            a.u("zoomChartTop: " + this.zoomChartTop.toString() + ",");
            a.u("toolbarLeft: " + this.toolbarLeft.toString() + ",");
            a.u("toolbarTop: " + this.toolbarTop.toString() + ",");
            a.u("toolbarWidth: " + this.toolbarWidth.toString() + ",");
            a.u("toolbarHeight: " + this.toolbarHeight.toString() + ",");
            a.u("indicatorChartLefts: [");
            for (var c = 0; c < this.indicatorChartLefts.count; c++) {
                if (c > 0) {
                    a.u(",");
                }
                a.k(this.indicatorChartLefts._inner[c]);
            }
            a.t();
            a.u("],");
            a.u("indicatorChartTops: [");
            for (var d = 0; d < this.indicatorChartTops.count; d++) {
                if (d > 0) {
                    a.u(",");
                }
                a.k(this.indicatorChartTops._inner[d]);
            }
            a.t();
            a.u("],");
            a.u(i2.stringFormat("legendLeft: {0},", this.legendLeft));
            a.u(i2.stringFormat("legendTop: {0},", this.legendTop));
            a.u(i2.stringFormat("legendWidth: {0},", this.legendWidth));
            a.u(i2.stringFormat("legendHeight: {0},", this.legendHeight));
            var e;
            if (this.legend != null) {
                e = (this.legend.serialize());
            }
            else {
                e = "null";
            }
            a.u(i2.stringFormat("legend: {0}", e));
            a.u("}");
            return a.toString();
        };
        FinancialChartVisualData.y = function (a, b) {
            var c = new i2.StringBuilder(0);
            c.u("{");
            for (var d = 0; d < a.length; d++) {
                c.l(a[d] + ": " + FinancialChartVisualData.aa(b[d]));
                if (d < a.length - 1) {
                    c.l(", ");
                }
                c.t();
            }
            c.l("}");
            return c.toString();
        };
        FinancialChartVisualData.aa = function (a) {
            if (a == null) {
                return "null";
            }
            if (typeof a === 'string' && !i2.stringStartsWith(a, "{")) {
                return "\"" + a + "\"";
            }
            if (i2.typeCast(i2.IList_$type, a) !== null) {
                return FinancialChartVisualData.z(a);
            }
            if (i2.typeCast(i2.Array_$type, a) !== null) {
                return FinancialChartVisualData.z(i2.boxArray$1(a));
            }
            return a.toString();
        };
        FinancialChartVisualData.z = function (a) {
            var e_1, _a;
            if (a == null) {
                return "null";
            }
            var b = new i2.StringBuilder(0);
            b.l("[");
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    b.l(FinancialChartVisualData.aa(d));
                    if (++c < a.count) {
                        b.l(", ");
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            b.l("]");
            return b.toString();
        };
        FinancialChartVisualData.$t = i2.markType(FinancialChartVisualData, 'FinancialChartVisualData');
        return FinancialChartVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartCustomIndicatorArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartCustomIndicatorArgs, _super);
        function FinancialChartCustomIndicatorArgs(a, b, c) {
            var _this = _super.call(this) || this;
            _this._indicatorInfo = null;
            _this._series = null;
            _this._index = 0;
            _this.index = c;
            _this.indicatorInfo = a;
            _this.series = b;
            return _this;
        }
        Object.defineProperty(FinancialChartCustomIndicatorArgs.prototype, "indicatorInfo", {
            get: function () {
                return this._indicatorInfo;
            },
            set: function (a) {
                this._indicatorInfo = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartCustomIndicatorArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartCustomIndicatorArgs.prototype, "index", {
            get: function () {
                return this._index;
            },
            set: function (a) {
                this._index = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartCustomIndicatorArgs.$t = i2.markType(FinancialChartCustomIndicatorArgs, 'FinancialChartCustomIndicatorArgs', i2.EventArgs.$);
        return FinancialChartCustomIndicatorArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartDropDownControl = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartDropDownControl, _super);
        function FinancialChartDropDownControl(a, b, c) {
            var _this = _super.call(this, a, b, c) || this;
            _this.selectionChanged = null;
            _this.o = null;
            _this.p = null;
            return _this;
        }
        FinancialChartDropDownControl.prototype.v = function () {
            if (this.selectionChanged != null) {
                this.selectionChanged(this, i2.EventArgs.empty);
            }
        };
        FinancialChartDropDownControl.prototype.l = function (a) {
            _super.prototype.l.call(this, a);
            this.o.f(this.d, this.p, this.s, this.t);
        };
        FinancialChartDropDownControl.prototype.get_q = function () {
            return false;
        };
        Object.defineProperty(FinancialChartDropDownControl.prototype, "q", {
            get: function () {
                return this.get_q();
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartDropDownControl.prototype.u = function (a) {
            if (this.p.isOpen) {
                var b = a.target;
                var c = b.matches(this.s + " *");
                var d = c || (this.q && b.matches(this.t + " *"));
                if (!d) {
                    this.p.isOpen = false;
                    this.p.updateUI();
                }
            }
        };
        FinancialChartDropDownControl.$t = i2.markType(FinancialChartDropDownControl, 'FinancialChartDropDownControl', TemplatedHtmlControl.$);
        return FinancialChartDropDownControl;
    }(TemplatedHtmlControl));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartDropDownControlViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartDropDownControlViewModel, _super);
        function FinancialChartDropDownControlViewModel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._onSelectionChanged = null;
            _this._isOpen = false;
            _this._notifyChanged = null;
            _this.a = null;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(FinancialChartDropDownControlViewModel.prototype, "onSelectionChanged", {
            get: function () {
                return this._onSelectionChanged;
            },
            set: function (a) {
                this._onSelectionChanged = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartDropDownControlViewModel.prototype, "isOpen", {
            get: function () {
                return this._isOpen;
            },
            set: function (a) {
                this._isOpen = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartDropDownControlViewModel.prototype, "notifyChanged", {
            get: function () {
                return this._notifyChanged;
            },
            set: function (a) {
                this._notifyChanged = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartDropDownControlViewModel.prototype.updateUI = function () {
            if (this.notifyChanged != null) {
                this.notifyChanged();
            }
        };
        FinancialChartDropDownControlViewModel.prototype.onButtonPressed = function () {
            this.isOpen = !this.isOpen;
            this.updateUI();
        };
        FinancialChartDropDownControlViewModel.prototype.handleDropDownClick = function (a) {
            if (this.b != null) {
                this.b(a);
            }
        };
        FinancialChartDropDownControlViewModel.$t = i2.markType(FinancialChartDropDownControlViewModel, 'FinancialChartDropDownControlViewModel');
        return FinancialChartDropDownControlViewModel;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartTypePickerViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartTypePickerViewModel, _super);
        function FinancialChartTypePickerViewModel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._chartType = 0;
            return _this;
        }
        Object.defineProperty(FinancialChartTypePickerViewModel.prototype, "chartType", {
            get: function () {
                return this._chartType;
            },
            set: function (a) {
                this._chartType = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartTypePickerViewModel.prototype, "chartTypeString", {
            get: function () {
                return i2.EnumUtil.getName(FinancialChartType_$type, this.chartType);
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartTypePickerViewModel.$t = i2.markType(FinancialChartTypePickerViewModel, 'FinancialChartTypePickerViewModel', FinancialChartDropDownControlViewModel.$);
        return FinancialChartTypePickerViewModel;
    }(FinancialChartDropDownControlViewModel));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartDropDownControlView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartDropDownControlView, _super);
        function FinancialChartDropDownControlView() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = false;
            _this.c = false;
            _this.d = null;
            _this.e = null;
            _this.a = null;
            return _this;
        }
        FinancialChartDropDownControlView.prototype.i = function (a) {
            if (!this.b && !this.c) {
                this.g();
            }
            this.b = false;
            this.c = false;
        };
        FinancialChartDropDownControlView.prototype.h = function (a) {
            this.b = true;
        };
        FinancialChartDropDownControlView.prototype.k = function (a) {
        };
        FinancialChartDropDownControlView.prototype.j = function (a) {
            this.c = true;
            this.k(a.target);
        };
        FinancialChartDropDownControlView.prototype.f = function (a, b, c, d) {
            this.a = b;
            this.a.a = new i2.SRProvider(a);
        };
        FinancialChartDropDownControlView.prototype.g = function () {
            this.a.isOpen = false;
            this.a.updateUI();
        };
        FinancialChartDropDownControlView.$t = i2.markType(FinancialChartDropDownControlView, 'FinancialChartDropDownControlView');
        return FinancialChartDropDownControlView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartTypePickerView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartTypePickerView, _super);
        function FinancialChartTypePickerView() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(FinancialChartTypePickerView.prototype, "l", {
            get: function () {
                return this.a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartTypePickerView.prototype.k = function (a) {
            _super.prototype.k.call(this, a);
            var b = a;
            var c = b.parentNode;
            for (var d = 0; d < c.children.length; d++) {
                var e = c.children.item(d);
                if (e != b) {
                    e.classList.remove("checked");
                }
            }
            var f = b.getAttribute("data-value");
            if (i2.stringIsNullOrEmpty(f)) {
                return;
            }
            var g = i2.EnumUtil.parse(FinancialChartType_$type, f, true);
            this.l.chartType = i2.EnumUtil.getEnumValue(FinancialChartType_$type, g);
            this.g();
            this.a.onSelectionChanged();
        };
        FinancialChartTypePickerView.$t = i2.markType(FinancialChartTypePickerView, 'FinancialChartTypePickerView', FinancialChartDropDownControlView.$);
        return FinancialChartTypePickerView;
    }(FinancialChartDropDownControlView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartTypePicker = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartTypePicker, _super);
        function FinancialChartTypePicker(a) {
            var _this = _super.call(this, "financialChartTypePicker", a, FinancialChartTypePicker.z) || this;
            _this.o = new FinancialChartTypePickerView();
            _this.p = new FinancialChartTypePickerViewModel();
            _this.p.onSelectionChanged = i2.runOn(_this, _this.v);
            _this.p.b = i2.runOn(_this.o, _this.o.j);
            _this.o.a = _this.p;
            return _this;
        }
        Object.defineProperty(FinancialChartTypePicker.prototype, "w", {
            get: function () {
                return this.y.chartType;
            },
            set: function (a) {
                this.y.chartType = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartTypePicker.prototype, "x", {
            get: function () {
                return this.o;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartTypePicker.prototype, "y", {
            get: function () {
                return this.p;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartTypePicker.prototype.get_s = function () {
            return ".financialChartTypePickerDropDownButton";
        };
        Object.defineProperty(FinancialChartTypePicker.prototype, "s", {
            get: function () {
                return this.get_s();
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartTypePicker.prototype.get_t = function () {
            return ".financialChartTypePickerDropDownMenu";
        };
        Object.defineProperty(FinancialChartTypePicker.prototype, "t", {
            get: function () {
                return this.get_t();
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartTypePicker.$t = i2.markType(FinancialChartTypePicker, 'FinancialChartTypePicker', FinancialChartDropDownControl.$);
        FinancialChartTypePicker.z = "<button class='financialChartTypePickerDropDownButton' data-value='Auto'>\r\n\t\t<span class='ui-icon ui-icon-changeable'></span>\r\n\t\t<span class='ui-icon-toolbar-dd'></span>\r\n\t</button>\r\n\r\n\t<div class='financialChartTypePickerDropDownMenu'>\r\n\t\t<ul>\r\n\t\t\t<li class='financialChartListItem' data-value='Auto'>\r\n\t\t\t<span class='ui-icon ui-icon-chartAuto'></span>\r\n\t\t\t<span>Auto</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Bar'>\r\n\t\t\t\t<span class='ui-icon ui-icon-BarIcon'></span>\r\n\t\t\t\t<span>Bar</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Line'>\r\n\t\t\t\t<span class='ui-icon ui-icon-LineIcon'></span>\r\n\t\t\t\t<span>Line</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Candle'>\r\n\t\t\t\t<span class='ui-icon ui-icon-CandleIcon'></span>\r\n\t\t\t\t<span>Candle</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Column'>\r\n\t\t\t\t<span class='ui-icon ui-icon-ColumnIcon'></span>\r\n\t\t\t\t<span>Column</span>\r\n\t\t\t</li>\r\n\t\t</ul>\r\n\t</div>";
        return FinancialChartTypePicker;
    }(FinancialChartDropDownControl));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartIndicatorMenuViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartIndicatorMenuViewModel, _super);
        function FinancialChartIndicatorMenuViewModel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.j = null;
            _this.k = null;
            _this.l = 0;
            _this.i = 0;
            _this.m = "Indicator";
            _this.n = "Standalone Indicators";
            _this.o = "Overlays";
            _this.p = "Trendlines";
            _this.q = "Volumes";
            _this.r = "Absolute Volume Oscillator";
            _this.s = "Accumulation Distribution";
            _this.t = "Average Directional Index";
            _this.u = "Average True Range";
            _this.v = "Bollinger Band Width";
            _this.w = "Chaikin Oscillator";
            _this.x = "Chaikin Volatility";
            _this.y = "Commodity Channel Index";
            _this.z = "Detrended Price Oscillator";
            _this.aa = "Ease Of Movement";
            _this.ab = "Fast Stochastic Oscillator";
            _this.ac = "Force Index";
            _this.ad = "Full Stochastic Oscillator";
            _this.ae = "Market Facilitation Index";
            _this.af = "Mass Index";
            _this.ag = "Median Price";
            _this.ah = "Money Flow Index";
            _this.ai = "MACD";
            _this.aj = "Negative Volume Index";
            _this.ak = "On Balance Volume";
            _this.al = "Percentage Price Oscillator";
            _this.am = "Percentage Volume Oscillator";
            _this.an = "Positive Volume Index";
            _this.ao = "Price Volume Trend";
            _this.ap = "ROC";
            _this.aq = "RSI";
            _this.ar = "Slow Stochastic Oscillator";
            _this.as = "Standard Deviation";
            _this.at = "Stoch RSI";
            _this.au = "TRIX";
            _this.av = "Typical Price";
            _this.aw = "Ultimate Oscillator";
            _this.ax = "Weighted Closez";
            _this.ay = "Williams %R";
            _this.az = "Bollinger Bands";
            _this.a0 = "Price Channel";
            _this.a1 = "Cubic Fit";
            _this.a2 = "Cumulative Average";
            _this.a3 = "Exponential Average";
            _this.a4 = "Exponential Fit";
            _this.a5 = "Linear Fit";
            _this.a6 = "Logarithmic Fit";
            _this.a7 = "Modified Average";
            _this.a8 = "PowerLaw Fit";
            _this.a9 = "Quadratic Fit";
            _this.ba = "Quartic Fit";
            _this.bb = "Quintic Fit";
            _this.bc = "Simple Average";
            _this.bd = "Weighted Average";
            _this.be = "Area";
            _this.bf = "Column";
            _this.bg = "Line";
            return _this;
        }
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorMenu_Header", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.t) ? this.a.t : this.m;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Overlay_BollingerBands", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a6) ? this.a.a6 : this.az;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Overlay_PriceChannel", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a7) ? this.a.a7 : this.a0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorMenu_IndicatorsCategoryHeader", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.u) ? this.a.u : this.n;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorMenu_OverlaysCategoryHeader", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.v) ? this.a.v : this.o;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorMenu_TrendlinesCategoryHeader", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.w) ? this.a.w : this.p;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorMenu_VolumeCategoryHeader", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.x) ? this.a.x : this.q;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.y) ? this.a.y : this.r;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_AccumulationDistribution", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.z) ? this.a.z : this.s;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.aa) ? this.a.aa : this.t;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_AverageTrueRange", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ab) ? this.a.ab : this.u;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_BollingerBandWidth", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ac) ? this.a.ac : this.v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_ChaikinOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ad) ? this.a.ad : this.w;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_ChaikinVolatility", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ae) ? this.a.ae : this.x;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_CommodityChannelIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.af) ? this.a.af : this.y;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ag) ? this.a.ag : this.z;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_EaseOfMovement", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ah) ? this.a.ah : this.aa;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_FastStochasticOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ai) ? this.a.ai : this.ab;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_ForceIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.aj) ? this.a.aj : this.ac;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_FullStochasticOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ak) ? this.a.ak : this.ad;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.al) ? this.a.al : this.ae;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_MassIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.am) ? this.a.am : this.af;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_MedianPrice", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.an) ? this.a.an : this.ag;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_MoneyFlowIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ao) ? this.a.ao : this.ah;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ap) ? this.a.ap : this.ai;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.aq) ? this.a.aq : this.aj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_OnBalanceVolume", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ar) ? this.a.ar : this.ak;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.as) ? this.a.as : this.al;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.at) ? this.a.at : this.am;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.au) ? this.a.au : this.an;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_PriceVolumeTrend", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.av) ? this.a.av : this.ao;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.aw) ? this.a.aw : this.ap;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ax) ? this.a.ax : this.aq;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ay) ? this.a.ay : this.ar;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_StandardDeviation", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.az) ? this.a.az : this.as;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_StochRSI", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a0) ? this.a.a0 : this.at;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_TRIX", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a1) ? this.a.a1 : this.au;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_TypicalPrice", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a2) ? this.a.a2 : this.av;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_UltimateOscillator", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a3) ? this.a.a3 : this.aw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_WeightedClose", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a4) ? this.a.a4 : this.ax;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Indicator_WilliamsPercentR", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a5) ? this.a.a5 : this.ay;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_CubicFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a8) ? this.a.a8 : this.a1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_CumulativeAverage", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.a9) ? this.a.a9 : this.a2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_ExponentialAverage", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.ba) ? this.a.ba : this.a3;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_ExponentialFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bb) ? this.a.bb : this.a4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_LinearFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bc) ? this.a.bc : this.a5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_LogarithmicFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bd) ? this.a.bd : this.a6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_ModifiedAverage", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.be) ? this.a.be : this.a7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_PowerLawFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bf) ? this.a.bf : this.a8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_QuadraticFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bg) ? this.a.bg : this.a9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_QuarticFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bh) ? this.a.bh : this.ba;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_QuinticFit", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bi) ? this.a.bi : this.bb;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_SimpleAverage", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bj) ? this.a.bj : this.bc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_TrendLine_WeightedAverage", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bk) ? this.a.bk : this.bd;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Volume_Area", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bl) ? this.a.bl : this.be;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Volume_Column", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bm) ? this.a.bm : this.bf;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuViewModel.prototype, "financialChart_IndicatorsMenu_Volume_Line", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.a.bn) ? this.a.bn : this.bg;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuViewModel.$t = i2.markType(FinancialChartIndicatorMenuViewModel, 'FinancialChartIndicatorMenuViewModel', FinancialChartDropDownControlViewModel.$);
        return FinancialChartIndicatorMenuViewModel;
    }(FinancialChartDropDownControlViewModel));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialIndicatorTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialIndicatorTypeCollection, _super);
        function FinancialIndicatorTypeCollection(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        _this = _super.call(this, FinancialIndicatorType_$type, 0) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, FinancialIndicatorType_$type, 1, c) || this;
                    }
                    break;
            }
            return _this;
        }
        FinancialIndicatorTypeCollection.$t = i2.markType(FinancialIndicatorTypeCollection, 'FinancialIndicatorTypeCollection', i2.ObservableCollection$1.$.specialize(FinancialIndicatorType_$type));
        return FinancialIndicatorTypeCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialOverlayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialOverlayTypeCollection, _super);
        function FinancialOverlayTypeCollection(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        _this = _super.call(this, FinancialOverlayType_$type, 0) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, FinancialOverlayType_$type, 1, c) || this;
                    }
                    break;
            }
            return _this;
        }
        FinancialOverlayTypeCollection.$t = i2.markType(FinancialOverlayTypeCollection, 'FinancialOverlayTypeCollection', i2.ObservableCollection$1.$.specialize(FinancialOverlayType_$type));
        return FinancialOverlayTypeCollection;
    }(i2.ObservableCollection$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartIndicatorMenuView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartIndicatorMenuView, _super);
        function FinancialChartIndicatorMenuView() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FinancialChartIndicatorMenuView.prototype.f = function (a, b, c, d) {
            _super.prototype.f.call(this, a, b, c, d);
        };
        FinancialChartIndicatorMenuView.prototype.k = function (a) {
            _super.prototype.k.call(this, a);
            var b = a;
            if (b.tagName != "LI") {
                return;
            }
            var c = b.parentNode.parentNode;
            var d;
            var e = false;
            switch (c.getAttribute("data-value")) {
                case "FinancialOverlayType":
                    d = FinancialOverlayType_$type;
                    e = false;
                    break;
                case "TrendLineType":
                    d = i2.TrendLineType_$type;
                    e = true;
                    break;
                case "FinancialChartVolumeType":
                    d = FinancialChartVolumeType_$type;
                    e = true;
                    break;
                default:
                case "FinancialIndicatorType":
                    d = FinancialIndicatorType_$type;
                    e = false;
                    break;
            }
            var f = b.classList.toggle("checked");
            var g = b.parentNode;
            if (e) {
                for (var h = 0; h < g.children.length; h++) {
                    var i = g.children.item(h);
                    if (i != b) {
                        i.classList.remove("checked");
                    }
                }
                var j = f ? b.getAttribute("data-value") : "None";
                if (i2.stringIsNullOrEmpty(j)) {
                    return;
                }
                var k = i2.EnumUtil.parse(d, j, true);
                if (d == FinancialChartVolumeType_$type) {
                    this.l.i = i2.EnumUtil.getEnumValue(FinancialChartVolumeType_$type, k);
                }
                else {
                    this.l.l = i2.EnumUtil.getEnumValue(i2.TrendLineType_$type, k);
                }
            }
            else {
                if (d == FinancialIndicatorType_$type) {
                    this.l.j = new FinancialIndicatorTypeCollection(0);
                    ;
                }
                else {
                    this.l.k = new FinancialOverlayTypeCollection(0);
                }
                for (var l = 0; l < g.children.length; l++) {
                    var m = g.children.item(l);
                    if (m.classList.contains("checked")) {
                        var n = m.getAttribute("data-value");
                        if (i2.stringIsNullOrEmpty(n)) {
                            continue;
                        }
                        var o = i2.EnumUtil.parse(d, n, true);
                        if (d == FinancialIndicatorType_$type) {
                            var p = i2.EnumUtil.getEnumValue(FinancialIndicatorType_$type, o);
                            this.l.j.add(p);
                        }
                        else {
                            var q = i2.EnumUtil.getEnumValue(FinancialOverlayType_$type, o);
                            this.l.k.add(q);
                        }
                    }
                }
            }
            this.a.onSelectionChanged();
        };
        Object.defineProperty(FinancialChartIndicatorMenuView.prototype, "l", {
            get: function () {
                return this.a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuView.$t = i2.markType(FinancialChartIndicatorMenuView, 'FinancialChartIndicatorMenuView', FinancialChartDropDownControlView.$);
        return FinancialChartIndicatorMenuView;
    }(FinancialChartDropDownControlView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartIndicatorMenu = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartIndicatorMenu, _super);
        function FinancialChartIndicatorMenu(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = [null];
                        {
                            var e = c[0];
                            _this = _super.call(this, "financialChartIndicatorMenu", e, "") || this;
                            _this.o = new FinancialChartIndicatorMenuView();
                            _this.p = new FinancialChartIndicatorMenuViewModel();
                            _this.p.onSelectionChanged = i2.runOn(_this, _this.v);
                            _this.p.b = i2.runOn(_this.o, _this.o.j);
                            _this.o.a = _this.p;
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, "financialChartIndicatorMenu", c, "") || this;
                        _this.o = new FinancialChartIndicatorMenuView();
                        _this.p = new FinancialChartIndicatorMenuViewModel();
                        _this.p.onSelectionChanged = i2.runOn(_this, _this.v);
                        _this.p.b = i2.runOn(_this.o, _this.o.j);
                        _this.o.a = _this.p;
                    }
                    break;
            }
            return _this;
        }
        FinancialChartIndicatorMenu.prototype.get_s = function () {
            return ".financialChartIndicatorMenuDropDownButton";
        };
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "s", {
            get: function () {
                return this.get_s();
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenu.prototype.get_t = function () {
            return ".financialChartIndicatorMenuDropDownMenu";
        };
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "t", {
            get: function () {
                return this.get_t();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "y", {
            get: function () {
                return this.w.j;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "z", {
            get: function () {
                return this.w.k;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "aa", {
            get: function () {
                return this.w.l;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "x", {
            get: function () {
                return this.w.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenu.prototype, "w", {
            get: function () {
                return this.p;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenu.prototype.get_q = function () {
            return true;
        };
        FinancialChartIndicatorMenu.$t = i2.markType(FinancialChartIndicatorMenu, 'FinancialChartIndicatorMenu', FinancialChartDropDownControl.$);
        return FinancialChartIndicatorMenu;
    }(FinancialChartDropDownControl));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartIndicatorMenuContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartIndicatorMenuContext, _super);
        function FinancialChartIndicatorMenuContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._vm = null;
            _this._template = null;
            return _this;
        }
        Object.defineProperty(FinancialChartIndicatorMenuContext.prototype, "vm", {
            get: function () {
                return this._vm;
            },
            set: function (a) {
                this._vm = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartIndicatorMenuContext.prototype, "template", {
            get: function () {
                return this._template;
            },
            set: function (a) {
                this._template = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuContext.$t = i2.markType(FinancialChartIndicatorMenuContext, 'FinancialChartIndicatorMenuContext');
        return FinancialChartIndicatorMenuContext;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartTypePickerContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartTypePickerContext, _super);
        function FinancialChartTypePickerContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._vm = null;
            _this._template = null;
            return _this;
        }
        Object.defineProperty(FinancialChartTypePickerContext.prototype, "vm", {
            get: function () {
                return this._vm;
            },
            set: function (a) {
                this._vm = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartTypePickerContext.prototype, "template", {
            get: function () {
                return this._template;
            },
            set: function (a) {
                this._template = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartTypePickerContext.$t = i2.markType(FinancialChartTypePickerContext, 'FinancialChartTypePickerContext');
        return FinancialChartTypePickerContext;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartRangeSelectorContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartRangeSelectorContext, _super);
        function FinancialChartRangeSelectorContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._vm = null;
            _this._template = null;
            return _this;
        }
        Object.defineProperty(FinancialChartRangeSelectorContext.prototype, "vm", {
            get: function () {
                return this._vm;
            },
            set: function (a) {
                this._vm = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorContext.prototype, "template", {
            get: function () {
                return this._template;
            },
            set: function (a) {
                this._template = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelectorContext.$t = i2.markType(FinancialChartRangeSelectorContext, 'FinancialChartRangeSelectorContext');
        return FinancialChartRangeSelectorContext;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartRangeSelectorViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartRangeSelectorViewModel, _super);
        function FinancialChartRangeSelectorViewModel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this._notifyChanged = null;
            _this._options = null;
            _this.u = i2.dateMaxValue();
            _this.t = i2.dateMinValue();
            _this._oneMonthChecked = false;
            _this._threeMonthsChecked = false;
            _this._sixMonthsChecked = false;
            _this._yearToDateChecked = false;
            _this._oneYearChecked = false;
            _this._allChecked = false;
            _this._oneMonthVisible = false;
            _this._threeMonthsVisible = false;
            _this._sixMonthsVisible = false;
            _this._yearToDateVisible = false;
            _this._oneYearVisible = false;
            _this._allVisible = false;
            _this.s = i2.dateMinValue();
            _this.r = i2.dateMaxValue();
            _this._onRangeChanged = null;
            return _this;
        }
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "notifyChanged", {
            get: function () {
                return this._notifyChanged;
            },
            set: function (a) {
                this._notifyChanged = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "options", {
            get: function () {
                return this._options;
            },
            set: function (a) {
                this._options = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "selectionStart", {
            get: function () {
                return this.u;
            },
            set: function (a) {
                this.u = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "selectionEnd", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                this.t = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneMonthChecked", {
            get: function () {
                return this._oneMonthChecked;
            },
            set: function (a) {
                this._oneMonthChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "threeMonthsChecked", {
            get: function () {
                return this._threeMonthsChecked;
            },
            set: function (a) {
                this._threeMonthsChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "sixMonthsChecked", {
            get: function () {
                return this._sixMonthsChecked;
            },
            set: function (a) {
                this._sixMonthsChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "yearToDateChecked", {
            get: function () {
                return this._yearToDateChecked;
            },
            set: function (a) {
                this._yearToDateChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneYearChecked", {
            get: function () {
                return this._oneYearChecked;
            },
            set: function (a) {
                this._oneYearChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "allChecked", {
            get: function () {
                return this._allChecked;
            },
            set: function (a) {
                this._allChecked = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneMonthVisible", {
            get: function () {
                return this._oneMonthVisible;
            },
            set: function (a) {
                this._oneMonthVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "threeMonthsVisible", {
            get: function () {
                return this._threeMonthsVisible;
            },
            set: function (a) {
                this._threeMonthsVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "sixMonthsVisible", {
            get: function () {
                return this._sixMonthsVisible;
            },
            set: function (a) {
                this._sixMonthsVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "yearToDateVisible", {
            get: function () {
                return this._yearToDateVisible;
            },
            set: function (a) {
                this._yearToDateVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneYearVisible", {
            get: function () {
                return this._oneYearVisible;
            },
            set: function (a) {
                this._oneYearVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "allVisible", {
            get: function () {
                return this._allVisible;
            },
            set: function (a) {
                this._allVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelectorViewModel.prototype.ao = function () {
            if (this.options == null) {
                return;
            }
            this.oneMonthVisible = this.options.contains(0);
            this.threeMonthsVisible = this.options.contains(1);
            this.sixMonthsVisible = this.options.contains(2);
            this.yearToDateVisible = this.options.contains(3);
            this.oneYearVisible = this.options.contains(4);
            this.allVisible = this.options.contains(5);
        };
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_OneMonth", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bq) ? this.b.bq : "1M";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_ThreeMonths", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bt) ? this.b.bt : "3M";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_SixMonths", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bs) ? this.b.bs : "6M";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_YearToDate", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bv) ? this.b.bv : "YTD";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_OneYear", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.br) ? this.b.br : "1Y";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_All", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bo) ? this.b.bo : "ALL";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_From", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bp) ? this.b.bp : "From";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "financialChart_RangeSelector_To", {
            get: function () {
                return !i2.stringIsNullOrWhiteSpace(this.b.bu) ? this.b.bu : "To";
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "rangeStart", {
            get: function () {
                return this.s;
            },
            set: function (a) {
                this.s = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "rangeEnd", {
            get: function () {
                return this.r;
            },
            set: function (a) {
                this.r = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelectorViewModel.prototype.onPropertiesChanged = function () {
            var a = false;
            var b = +(this.selectionEnd) == +(this.rangeEnd);
            if (this.allChecked != ((+(this.selectionStart) == +(this.rangeStart)) && b)) {
                this.allChecked = (+(this.selectionStart) == +(this.rangeStart)) && b;
                a = true;
            }
            if (this.oneYearChecked != ((+(this.selectionStart) == +(this.oneYearFromEnd)) && b)) {
                this.oneYearChecked = (+(this.selectionStart) == +(this.oneYearFromEnd)) && b;
                a = true;
            }
            if (this.yearToDateChecked != ((+(this.selectionStart) == +(this.firstDayOfEndYear)) && b)) {
                this.yearToDateChecked = (+(this.selectionStart) == +(this.firstDayOfEndYear)) && b;
                a = true;
            }
            if (this.sixMonthsChecked != ((+(this.selectionStart) == +(this.sixMonthsFromEnd)) && b)) {
                this.sixMonthsChecked = (+(this.selectionStart) == +(this.sixMonthsFromEnd)) && b;
                a = true;
            }
            if (this.threeMonthsChecked != ((+(this.selectionStart) == +(this.threeMonthsFromEnd)) && b)) {
                this.threeMonthsChecked = (+(this.selectionStart) == +(this.threeMonthsFromEnd)) && b;
                a = true;
            }
            if (this.oneMonthChecked != ((+(this.selectionStart) == +(this.oneMonthFromEnd)) && b)) {
                this.oneMonthChecked = (+(this.selectionStart) == +(this.oneMonthFromEnd)) && b;
                a = true;
            }
            if (a) {
                if (this.notifyChanged != null) {
                    this.notifyChanged();
                }
            }
            return a;
        };
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneYearFromEnd", {
            get: function () {
                return i2.dateAddYears(this.rangeEnd, -1);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "firstDayOfEndYear", {
            get: function () {
                return i2.dateFromValues(this.rangeEnd.getFullYear(), 1, 1, 0, 0, 0, 0);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "sixMonthsFromEnd", {
            get: function () {
                return i2.dateAddMonths(this.rangeEnd, -6);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "threeMonthsFromEnd", {
            get: function () {
                return i2.dateAddMonths(this.rangeEnd, -3);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneMonthFromEnd", {
            get: function () {
                return i2.dateAddMonths(this.rangeEnd, -1);
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelectorViewModel.prototype.changeSelection = function (a) {
            this.allChecked = false;
            this.oneMonthChecked = false;
            this.threeMonthsChecked = false;
            this.sixMonthsChecked = false;
            this.yearToDateChecked = false;
            this.oneYearChecked = false;
            if (a == "1m") {
                this.oneMonthChecked = true;
            }
            else if (a == "3m") {
                this.threeMonthsChecked = true;
            }
            else if (a == "6m") {
                this.sixMonthsChecked = true;
            }
            else if (a == "YTD") {
                this.yearToDateChecked = true;
            }
            else if (a == "1y") {
                this.oneYearChecked = true;
            }
            else if (a == "all") {
                this.allChecked = true;
            }
            this.onRadioButtonChanged();
        };
        FinancialChartRangeSelectorViewModel.prototype.onRadioButtonChanged = function () {
            var a = i2.dateFromTicks(this.selectionStart.getTime());
            var b = i2.dateFromTicks(this.selectionEnd.getTime());
            this.selectionEnd = this.rangeEnd;
            if (this.oneMonthChecked) {
                this.selectionStart = this.oneMonthFromEnd;
            }
            if (this.threeMonthsChecked) {
                this.selectionStart = this.threeMonthsFromEnd;
            }
            if (this.sixMonthsChecked) {
                this.selectionStart = this.sixMonthsFromEnd;
            }
            if (this.yearToDateChecked) {
                this.selectionStart = this.firstDayOfEndYear;
            }
            if (this.oneYearChecked) {
                this.selectionStart = this.oneYearFromEnd;
            }
            if (this.allChecked) {
                this.selectionStart = this.rangeStart;
            }
            if (+(this.selectionStart) != +a || +(this.selectionEnd) != +b) {
                this.onRangeChanged();
                if (this.notifyChanged != null) {
                    this.notifyChanged();
                }
            }
        };
        Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "onRangeChanged", {
            get: function () {
                return this._onRangeChanged;
            },
            set: function (a) {
                this._onRangeChanged = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelectorViewModel.$t = i2.markType(FinancialChartRangeSelectorViewModel, 'FinancialChartRangeSelectorViewModel');
        return FinancialChartRangeSelectorViewModel;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartRangeSelectorView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartRangeSelectorView, _super);
        function FinancialChartRangeSelectorView() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.e = null;
            return _this;
        }
        FinancialChartRangeSelectorView.prototype.f = function (a, b) {
            var c = new i2.SRProvider(a);
            this.e = c;
            this.c.b = this.e;
        };
        FinancialChartRangeSelectorView.prototype.h = function (a, b, c) {
            TemplatedHtmlControl.n(".rangeSelector" + b + " span", "FinancialChart_RangeSelector_" + b, a, c);
        };
        FinancialChartRangeSelectorView.prototype.g = function (a) {
        };
        FinancialChartRangeSelectorView.prototype.d = function (a) {
            var b = new i2.List$1(i2.String_$type, 0);
            var c = new i2.List$1(i2.Boolean_$type, 0);
            var d = new i2.List$1(i2.Number_$type, 0);
            var e = new i2.List$1(i2.Number_$type, 0);
            var f = new i2.List$1(i2.Boolean_$type, 0);
            var g = new i2.List$1(i2.Number_$type, 0);
            var h = new i2.List$1(i2.Number_$type, 0);
            var k = this.a(a);
            for (var j = 0; j < k.length; j++) {
                var i = k[j];
                var l = i.parent() != null ? i.parent().getText() : "not found";
                l = l != null ? l.trim() : null;
                b.add(l);
                c.add1(i.getProperty("checked"));
                d.add(i.getOffset().left);
                e.add(i.getOffset().top);
                var m = i.parent().getNativeElement();
                var n = m.offsetParent != null;
                g.add(m.offsetWidth);
                h.add(m.offsetHeight);
                f.add(n);
            }
            ;
            return ((function () {
                var $ret = new FinancialChartRangeSelectorVisualData();
                $ret.buttonLabels = b.toArray();
                $ret.buttonsChecked = c.toArray();
                $ret.buttonLefts = d.toArray();
                $ret.buttonTops = e.toArray();
                $ret.buttonVisibilities = f.toArray();
                $ret.buttonWidths = g.toArray();
                $ret.buttonHeights = h.toArray();
                $ret.visibility = a.getStyleProperty("visibility");
                $ret.left = parseFloat(a.getStyleProperty("offsetLeft"));
                $ret.top = parseFloat(a.getStyleProperty("offsetTop"));
                $ret.width = parseFloat(a.getStyleProperty("offsetWidth"));
                $ret.height = parseFloat(a.getStyleProperty("offsetHeight"));
                return $ret;
            })());
        };
        FinancialChartRangeSelectorView.prototype.b = function (a) {
            return 5;
        };
        FinancialChartRangeSelectorView.prototype.i = function (a) {
        };
        FinancialChartRangeSelectorView.prototype.a = function (a) {
            return TemplatedHtmlControl.a(a, "input").toArray();
        };
        FinancialChartRangeSelectorView.$t = i2.markType(FinancialChartRangeSelectorView, 'FinancialChartRangeSelectorView');
        return FinancialChartRangeSelectorView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChart, _super);
        function FinancialChart() {
            var _this = _super.call(this) || this;
            _this.un = null;
            _this.w7 = null;
            _this.w5 = null;
            _this.w2 = null;
            _this.w4 = null;
            _this.w6 = null;
            _this.w3 = null;
            _this.tt = null;
            _this.xp = null;
            _this.xq = null;
            _this.xm = null;
            _this.xr = null;
            _this.xs = null;
            _this.xn = null;
            _this.xo = null;
            _this.vb = null;
            _this.wh = 40;
            _this.uh = null;
            _this.uf = null;
            _this.uj = null;
            _this.uo = null;
            _this.x0 = null;
            _this.u7 = null;
            _this.vv = false;
            _this.vu = false;
            _this.v0 = false;
            _this.vh = false;
            _this.xd = 10;
            _this.wj = NaN;
            _this.wl = NaN;
            _this.wk = NaN;
            _this.wm = 0;
            _this.tz = 0;
            _this.t2 = 0;
            _this.t4 = 0;
            _this.ve = true;
            _this.tv = 0;
            _this.vf = false;
            _this.t9 = null;
            _this.ub = null;
            _this.v2 = null;
            _this.vg = true;
            _this.u8 = null;
            _this.t6 = 1;
            _this.sx = null;
            _this.sy = null;
            _this.sz = null;
            _this.s0 = null;
            _this.s2 = null;
            _this.s1 = null;
            _this.sw = null;
            _this.sv = null;
            _this.wi = 1;
            _this.wg = 1;
            _this.wf = 2;
            _this.we = 1;
            _this.ul = null;
            _this.w9 = -2147483648;
            _this.wd = 2;
            _this.xc = 3;
            _this.xa = 10;
            _this.w8 = 30;
            _this.xb = 9;
            _this.tq = null;
            _this.tr = null;
            _this.tm = null;
            _this.applyCustomIndicators = null;
            _this.abm = null;
            _this.wn = 1;
            _this.vd = false;
            _this.ud = null;
            _this.wa = i2.dateMinValue();
            _this.v9 = i2.dateMaxValue();
            _this.v7 = null;
            _this.i4();
            _this.v7 = new i2.ObservableCollection$1(i2.Base.$, 0);
            if (_this.xAxisBreaks != null) {
                var a = _this.xAxisBreaks;
                a.collectionChanged = i2.delegateCombine(a.collectionChanged, function (a, b) { return _this.abb(); });
            }
            _this.aaw();
            return _this;
        }
        FinancialChart.prototype.j8 = function (a, b, c) {
            _super.prototype.j8.call(this, a, b, c);
            switch (a) {
                case "ToolbarTemplate":
                case "RangeSelectorTemplate":
                    this.tu = new FinancialChartToolbar(this, this.xx);
                    break;
                case "Toolbar":
                    var d = b;
                    if (d != null) {
                        d.chartTypeChanged = i2.delegateRemove(d.chartTypeChanged, i2.runOn(this, this.aak));
                        d.trendLineTypeChanged = i2.delegateRemove(d.trendLineTypeChanged, i2.runOn(this, this.aan));
                        d.volumeTypeChanged = i2.delegateRemove(d.volumeTypeChanged, i2.runOn(this, this.aao));
                        d.l(null);
                    }
                    if (this.tu != null) {
                        this.tu.ac = this.t1;
                        this.tu.ai = this.bm;
                        this.tu.y = this.tw;
                        this.tu.al = this.vs;
                        if (this.w4 != null) {
                            this.tu.l(this.w4);
                        }
                        var e = this.tu;
                        e.chartTypeChanged = i2.delegateCombine(e.chartTypeChanged, i2.runOn(this, this.aak));
                        ;
                        var f = this.tu;
                        f.trendLineTypeChanged = i2.delegateCombine(f.trendLineTypeChanged, i2.runOn(this, this.aan));
                        var g = this.tu;
                        g.volumeTypeChanged = i2.delegateCombine(g.volumeTypeChanged, i2.runOn(this, this.aao));
                    }
                    break;
                case "ChartType":
                    if (this.tu != null) {
                        this.tu.y = this.tw;
                    }
                    break;
                case "VolumeType":
                    if (this.tu != null) {
                        this.tu.ac = this.t1;
                    }
                    break;
                case "TrendLineType":
                    if (this.tu != null) {
                        this.tu.ai = this.bm;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.tu == null) {
                        break;
                    }
                    this.tu.al = this.vs;
                    this.setGridRows();
                    break;
            }
        };
        FinancialChart.prototype.aao = function (a, b) {
            this.t1 = this.tu.ac;
        };
        FinancialChart.prototype.aan = function (a, b) {
            this.bm = this.tu.ai;
        };
        FinancialChart.prototype.aak = function (a, b) {
            this.tw = this.tu.y;
        };
        FinancialChart.prototype.aaw = function () {
            this.un = new IndicatorPane();
            this.ue = i2.TypeRegistrar.create("FinancialLegend");
        };
        FinancialChart.prototype.provideGrid = function (a) {
            this.w7 = a;
            this.abh();
            this.setGridRows();
            if (this.tu != null) {
                this.tu.bg(a);
            }
        };
        FinancialChart.prototype.onDocumentClick = function (a) {
            if (this.tu != null) {
                this.tu.bl(a);
            }
        };
        FinancialChart.prototype.getContext = function () {
            var a = this.tu.v();
            var b = new FinancialChartContext();
            b.vm = new FinancialChartViewModel();
            b.vm.toolbar = a;
            b.container = this.fd;
            b.toolbarContainer = this.w4;
            b.legendContainer = this.w3;
            b.indicatorsContainer = this.w2;
            b.volumeContainer = this.w5;
            b.zoomContainer = this.w6;
            return b;
        };
        FinancialChart.prototype.provideContainer = function (a) {
            var b = a;
            if (b != null) {
                var c = "financialChartMainGrid";
                var d = b.createElement("div");
                d.setStyleProperty("width", "100%");
                d.setStyleProperty("height", "100%");
                if (this.tu == null) {
                    this.tu = new FinancialChartToolbar(this, this.xx);
                }
                this.tu.w.isIndicatorMenuVisible = this.vj && this.vk;
                this.w4 = b.getSubRenderer(d);
                this.tu.l(this.w4);
                var e = b.createElement("div");
                e.setStyleProperty("width", "100%");
                e.setStyleProperty("height", "100%");
                var f = b.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                this.w3 = b.getSubRenderer(f);
                var g = b.createElement("div");
                g.setStyleProperty("width", "100%");
                g.setStyleProperty("height", "100%");
                this.w2 = b.getSubRenderer(g);
                var h = b.createElement("div");
                h.setStyleProperty("width", "100%");
                h.setStyleProperty("height", "100%");
                this.w5 = b.getSubRenderer(h);
                var i = b.createElement("div");
                i.setStyleProperty("width", "100%");
                i.setStyleProperty("height", "100%");
                this.w6 = b.getSubRenderer(i);
                a = b.getSubRenderer(e);
            }
            else {
                this.w4 = null;
                if (this.tu != null) {
                    this.tu.l(null);
                }
                if (this.vc != null) {
                    this.vc.provideContainer(null);
                    this.vc = null;
                }
                if (this.ue != null) {
                    this.ue.provideContainer(null);
                }
            }
            _super.prototype.provideContainer.call(this, a);
            if (b != null) {
                if (this.volumeChart != null) {
                    this.volumeChart.provideContainer(this.w5);
                }
                if (this.un != null) {
                    this.un.h(this.w2);
                }
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.provideContainer(this.w6);
                    if (a != null) {
                        this.z4();
                    }
                    else {
                        this.vc = null;
                    }
                }
                if (this.ue != null) {
                    this.ue.provideContainer(this.w3);
                }
                this.setGridRows();
            }
        };
        FinancialChart.prototype.aa7 = function (a, b, c) {
            if (a != null) {
                a.provideContainer(null);
            }
            if (b != null) {
                b.provideContainer(c);
            }
            this.setGridRows();
        };
        FinancialChart.prototype.abl = function (a, b) {
            this.aa7(a, b, this.w6);
            if (b == null) {
                return;
            }
            this.z4();
        };
        FinancialChart.prototype.z4 = function () {
            var _this = this;
            if (this.w6 == null) {
                return;
            }
            if (this.vc != null) {
                this.vc.provideContainer(null);
            }
            this.vc = i2.TypeRegistrar.create("ZoomSlider");
            this.vc.provideContainer(this.w6);
            var a = this.vc;
            a.windowRectChanged = i2.delegateCombine(a.windowRectChanged, function (a, b) {
                if (_this.dataChart != null) {
                    _this.dataChart.pw = new i2.Rect(0, _this.vc.windowRect.left, _this.dataChart.pg.top, _this.vc.windowRect.width, _this.dataChart.pg.height);
                }
            });
            this.z5();
        };
        FinancialChart.prototype.abj = function (a, b) {
            this.aa7(a, b, this.w5);
        };
        FinancialChart.prototype.setGridRows = function () {
            if (this.w7 == null) {
                return;
            }
            var a = new Array(6);
            a[0] = (this.vs ? this.wt : 0) + "px";
            a[1] = this.vo ? "min-content" : "0px";
            a[2] = "auto";
            a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
            a[4] = this.volumeChart == null ? "0px" : "100px";
            a[5] = this.zoomSliderChart == null ? "0px" : "100px";
            if (this.vc != null) {
                if (a[5] == "0px") {
                    this.vc.hide();
                }
                else {
                    this.vc.show();
                }
            }
            this.w7.setStyleProperty("-ms-grid-rows", i2.stringReplace(i2.stringJoin.apply(void 0, tslib.__spreadArray([" "], tslib.__read(a))), "auto", "1fr"));
            this.w7.setStyleProperty("grid-template-rows", i2.stringJoin.apply(void 0, tslib.__spreadArray([" "], tslib.__read(a))));
            if (this.fd == null) {
                return;
            }
            if (this.dataChart != null) {
                this.dataChart.notifyContainerResized();
            }
            if (this.un != null) {
                this.un.f();
            }
            if (this.volumeChart != null) {
                this.volumeChart.notifyContainerResized();
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.notifyContainerResized();
            }
            if (this.vc != null) {
                this.vc.notifySizeChanged();
            }
        };
        FinancialChart.prototype.jl = function () {
            var e_1, _a;
            _super.prototype.jl.call(this);
            this.l9 = 1;
            this.ro = 0;
            this.n6 = 0;
            this.si = null;
            this.sb = AxisDefaults.g;
            this.nq = AxisDefaults.e;
            this.np = AxisDefaults.f;
            this.sc = AxisDefaults.j;
            this.r8 = null;
            this.abn = AxisDefaults.h;
            this.w1 = AxisDefaults.b;
            this.cg = true;
            this.ce = true;
            this.cf = false;
            this.aa = 0;
            this.ea = Defaults.j;
            this.lg = Defaults.ae;
            this.lb = Defaults.af;
            this.lc = Defaults.ag;
            this.ej = NaN;
            this.eb = 30;
            this.cn = true;
            this.ct = false;
            if (this.dataChart != null) {
                var a = this.dataChart.cf.j.e();
                this.s5 = a.d;
                this.s6 = a.e;
                this.s4 = a.d;
                this.abn = this.dataChart.s1;
            }
            var b = new i2.BrushCollection();
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#8BDC5C";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#8961A9";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#6DB1FF";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#82E9D9";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#EA3C63";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#735656";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#F8CE4F";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#A8A8B7";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#E051A9";
                return $ret;
            })()));
            b.add(((function () {
                var $ret = new i2.Brush();
                $ret.fill = "#FF903B";
                return $ret;
            })()));
            var c = new i2.BrushCollection();
            try {
                for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    c.add(i2.BrushUtil.m(d, 0.3));
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.s7 = c;
            this.s8 = b;
        };
        FinancialChart.prototype.aa3 = function () {
            if (this.un != null) {
                this.un.b = null;
                this.un.b = this.indicatorCharts;
            }
            this.setGridRows();
        };
        FinancialChart.prototype.aa4 = function () {
            this.setGridRows();
        };
        FinancialChart.prototype.abd = function () {
            this.aa3();
        };
        FinancialChart.prototype.z3 = function () {
            if (this.vc == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
                return;
            }
            var a = this.fd.rootWrapper.width();
            var b = this.dataChart.pv.left + this.dataChart.pv.width;
            var c = this.dataChart.pv.left;
            var d = a - b;
            this.vc.startInset = c - this.vc.trackStartInset;
            this.vc.endInset = d - this.vc.trackEndInset;
            if (this.vc.endInset < 0) {
                var e = this.vc.endInset;
                this.vc.endInset = 0;
                this.dataChart.ft += (e * -1);
            }
            if (this.vc.startInset < 0) {
                var f = this.vc.startInset;
                this.vc.startInset = 0;
                this.dataChart.fq += (f * -1);
            }
            this.zoomSliderChart.fq = c;
            this.zoomSliderChart.ft = d;
            this.zoomSliderChart.fm = this.vc.barExtent;
        };
        FinancialChart.prototype.aau = function () {
            this.z3();
        };
        FinancialChart.prototype.ji = function (a) {
            _super.prototype.ji.call(this, a);
            if (a != null) {
                a.fl = 0;
            }
        };
        FinancialChart.prototype.abo = function (a) {
            return a.o9();
        };
        FinancialChart.prototype.abr = function () {
            return this.w3 == null ? null : this.abq(this.w3.rootWrapper);
        };
        FinancialChart.prototype.abp = function (a) {
            if (a == null || a.d == null) {
                return null;
            }
            return this.abq(a.d.rootWrapper);
        };
        FinancialChart.prototype.abq = function (a) {
            if (a == null) {
                return null;
            }
            var b = a.getOffset();
            return new i2.Rect(0, b.left, b.top, a.width(), a.height());
        };
        FinancialChart.prototype.wo = function () {
            if (this.w7 == null) {
                return NaN;
            }
            var a = this.w7.getOffset();
            return this.w7.width() + (a == null ? 0 : a.left);
        };
        FinancialChart.prototype.jt = function (source_, a, b) {
            _super.prototype.jt.call(this, source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.jw(source_, a, b);
            }
        };
        FinancialChart.prototype.ju = function (source_, a, b) {
            _super.prototype.ju.call(this, source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.jx(source_, a, b);
            }
        };
        FinancialChart.prototype.js = function (source_) {
            _super.prototype.js.call(this, source_);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.jt(source_);
            }
        };
        FinancialChart.prototype.jw = function (source_, a, b, c) {
            _super.prototype.jw.call(this, source_, a, b, c);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.jy(source_, a, b, c);
            }
        };
        FinancialChart.prototype.jo = function (a, b) {
            _super.prototype.jo.call(this, a, b);
            if (this.vp(a)) {
                a.toolTip = null;
            }
        };
        Object.defineProperty(FinancialChart.prototype, "tu", {
            get: function () {
                return this.tt;
            },
            set: function (a) {
                var b = this.tu;
                if (a != b) {
                    this.tt = a;
                    this.j6("Toolbar", b, this.tu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xw", {
            get: function () {
                return this.xp;
            },
            set: function (a) {
                var b = this.xw;
                if (a != b) {
                    this.xp = a;
                    this.j6("RangeSelectorTemplate", b, this.xw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xx", {
            get: function () {
                return this.xq;
            },
            set: function (a) {
                var b = this.xx;
                if (a != b) {
                    this.xq = a;
                    this.j6("ToolbarTemplate", b, this.xx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xt", {
            get: function () {
                return this.xm;
            },
            set: function (a) {
                var b = this.xt;
                if (a != b) {
                    this.xm = a;
                    this.j6("ChartTypePickerTemplate", b, this.xt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xy", {
            get: function () {
                return this.xr;
            },
            set: function (a) {
                var b = this.xy;
                if (a != b) {
                    this.xr = a;
                    this.j6("TrendLineTypePickerTemplate", b, this.xy);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xz", {
            get: function () {
                return this.xs;
            },
            set: function (a) {
                var b = this.xz;
                if (a != b) {
                    this.xs = a;
                    this.j6("VolumeTypePickerTemplate", b, this.xz);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xu", {
            get: function () {
                return this.xn;
            },
            set: function (a) {
                var b = this.xu;
                if (a != b) {
                    this.xn = a;
                    this.j6("IndicatorMenuTemplate", b, this.xu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xv", {
            get: function () {
                return this.xo;
            },
            set: function (a) {
                var b = this.xv;
                if (a != b) {
                    this.xo = a;
                    this.j6("OverlayPickerTemplate", b, this.xv);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vc", {
            get: function () {
                return this.vb;
            },
            set: function (a) {
                var b = this.vc;
                if (a != b) {
                    this.vb = a;
                    this.j6("ZoomSlider", b, this.vc);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.get_eb = function () {
            return _super.prototype.get_eb.call(this);
        };
        FinancialChart.prototype.set_eb = function (a) {
            _super.prototype.set_eb.call(this, a);
        };
        FinancialChart.prototype.get_cn = function () {
            return _super.prototype.get_cn.call(this);
        };
        FinancialChart.prototype.set_cn = function (a) {
            _super.prototype.set_cn.call(this, a);
        };
        Object.defineProperty(FinancialChart.prototype, "wt", {
            get: function () {
                return this.wh;
            },
            set: function (a) {
                var b = this.wt;
                if (a != b) {
                    this.wh = a;
                    this.j6("ToolbarHeight", b, this.wt);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.ly = function () {
            return this.xAxis;
        };
        FinancialChart.prototype.lz = function () {
            return this.yAxis;
        };
        FinancialChart.prototype.onAttachedToUI = function () {
            _super.prototype.onAttachedToUI.call(this);
            if (this.vc != null) {
                this.vc.onAttachedToUI();
            }
        };
        FinancialChart.prototype.onDetachedFromUI = function () {
            _super.prototype.onDetachedFromUI.call(this);
            if (this.vc != null) {
                this.vc.onDetachedFromUI();
            }
        };
        FinancialChart.prototype.ab = function (a) {
            return 20;
        };
        FinancialChart.prototype.get_c5 = function () {
            return ((function () {
                var $ret = new i2.List$1(i2.DataSeriesType_$type, 0);
                $ret.add(20);
                return $ret;
            })());
        };
        Object.defineProperty(FinancialChart.prototype, "c5", {
            get: function () {
                return this.get_c5();
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.get_c4 = function () {
            return ((function () {
                var $ret = new i2.List$1(i2.IDataSeriesAdapterRule_$type, 0);
                $ret.add(new i2.SimpleFinancialPriceSeriesRule());
                $ret.add(new i2.SubCollectionsRule());
                return $ret;
            })());
        };
        Object.defineProperty(FinancialChart.prototype, "c4", {
            get: function () {
                return this.get_c4();
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.tg = function (a) {
            return this.th(a);
        };
        FinancialChart.prototype.uu = function (a) {
            return this.uv(a);
        };
        FinancialChart.prototype.tf = function (a) {
            var b = this.tg(0);
            b.name = a;
            return b;
        };
        FinancialChart.prototype.i1 = function () {
            this.xAxis = this.tf("xAxis");
            this.yAxis = this.uu(0);
            this.yAxis.name = "yAxis";
            this.volumeAxis = this.uu(0);
            this.volumeAxis.name = "volumeAxis";
            this.volumeXAxis = this.tf("volumeXAxis");
            this.v4 = new i2.List$1(NumericYAxis.$, 0);
            this.v6 = new i2.List$1(CategoryAxisBase.$, 0);
            this.indicatorAxis = this.uu(0);
            this.indicatorAxis.name = "indicatorAxis";
            this.indicatorXAxis = this.tf("indicatorXAxis_0");
            this.v4.add(this.indicatorAxis);
            this.v6.add(this.indicatorXAxis);
            if (this.xAxis.ay == null) {
                this.xAxis.ay = new AxisLabelSettings();
            }
            if (this.yAxis.ay == null) {
                this.yAxis.ay = new AxisLabelSettings();
            }
            if (this.volumeAxis.ay == null) {
                this.volumeAxis.ay = new AxisLabelSettings();
            }
            if (this.volumeXAxis.ay == null) {
                this.volumeAxis.ay = new AxisLabelSettings();
            }
            if (this.indicatorAxis.ay == null) {
                this.indicatorAxis.ay = new AxisLabelSettings();
            }
            if (this.indicatorXAxis.ay == null) {
                this.indicatorXAxis.ay = new AxisLabelSettings();
            }
            this.zoomSliderAxis = this.uu(0);
            this.zoomSliderAxis.name = "zoomSliderAxis";
            this.zoomSliderXAxis = this.tf("zoomSliderXAxis");
            if (this.zoomSliderAxis.ay == null) {
                this.zoomSliderAxis.ay = new AxisLabelSettings();
            }
            if (this.zoomSliderXAxis.ay == null) {
                this.zoomSliderXAxis.ay = new AxisLabelSettings();
            }
        };
        FinancialChart.prototype.iz = function (a, b) {
            var c = i2.typeCast(MarkerSeries.$, a);
            if (c != null) {
                c.pr = this.a3(a, b);
            }
        };
        FinancialChart.prototype.a2 = function (a) {
            if (a != null) {
                return 1;
            }
            return _super.prototype.a2.call(this, a);
        };
        FinancialChart.prototype.kn = function (a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.kk = true;
                this.yAxis.k7 = 10;
            }
        };
        FinancialChart.prototype.kq = function () {
            this.yAxis.kk = this.vx;
            this.yAxis.k7 = this.xl;
        };
        FinancialChart.prototype.ty = function (a) {
            var b;
            if (this.tw == 0) {
                if (a == null || a.index > 0 || i2.stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                    b = 4;
                }
                else {
                    b = 2;
                }
            }
            else {
                b = this.tw;
            }
            b = this.tx(b);
            return b;
        };
        FinancialChart.prototype.tx = function (a) {
            if ((a == 1 || a == 2)) {
                if (i2.TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (i2.TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (i2.TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        };
        FinancialChart.prototype.t7 = function (a) {
            if ((a == 2 || a == 3)) {
                if (i2.TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 5;
            }
            if (a == 5) {
                if (i2.TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 6;
            }
            if (a == 6) {
                if (i2.TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (i2.TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        };
        FinancialChart.prototype.t0 = function (a) {
            if (a == 2) {
                if (i2.TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (i2.TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 1;
            }
            if (a == 1) {
                if (i2.TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        };
        FinancialChart.prototype.x8 = function (a) {
            var b = a.getMemberPathFor(14);
            if (i2.stringIsNullOrEmpty(b)) {
                b = a.getMemberPathFor(11);
            }
            return b;
        };
        FinancialChart.prototype.th = function (axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createXAxis(axisType_).i);
            }
            else {
                var a = void 0;
                switch (axisType_) {
                    case 0:
                        if (i2.TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = i2.TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else if (i2.TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = i2.TypeRegistrar.create("TimeXAxis");
                        }
                        else {
                            throw new i2.BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (i2.TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = i2.TypeRegistrar.create("TimeXAxis");
                        }
                        else if (i2.TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = i2.TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else {
                            throw new i2.BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        };
        FinancialChart.prototype.uv = function (axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createYAxis(axisType_).i);
            }
            else {
                var a = void 0;
                switch (axisType_) {
                    case 0:
                        if (i2.TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = i2.TypeRegistrar.create("NumericYAxis");
                        }
                        else if (i2.TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = i2.TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else {
                            throw new i2.BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (i2.TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = i2.TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else if (i2.TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = i2.TypeRegistrar.create("NumericYAxis");
                        }
                        else {
                            throw new i2.BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        };
        FinancialChart.prototype.u1 = function () {
            return this.bc(1);
        };
        FinancialChart.prototype.u2 = function () {
            return this.bc(0);
        };
        FinancialChart.prototype.u0 = function () {
            return this.bc(2);
        };
        FinancialChart.prototype.u3 = function () {
            return this.bc(20);
        };
        Object.defineProperty(FinancialChart.prototype, "vi", {
            get: function () {
                return (i2.TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ui", {
            get: function () {
                if (i2.TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                    return i2.TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
                }
                else {
                    throw new i2.BaseError(1, "horizontal series module is not loaded, but is required.");
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vl", {
            get: function () {
                return (i2.TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ug", {
            get: function () {
                if (i2.TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                    return i2.TypeRegistrar.create("FinancialPriceSeriesProxy");
                }
                else {
                    throw new i2.BaseError(1, "financial series module is not loaded, but is required.");
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vj", {
            get: function () {
                return (i2.TypeRegistrar.isRegistered("IndicatorProxy"));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "uk", {
            get: function () {
                if (i2.TypeRegistrar.isRegistered("IndicatorProxy")) {
                    return i2.TypeRegistrar.create("IndicatorProxy");
                }
                else {
                    throw new i2.BaseError(1, "financial series module is not loaded, but is required.");
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vk", {
            get: function () {
                return (i2.TypeRegistrar.isRegistered("OverlayProxy"));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "up", {
            get: function () {
                if (i2.TypeRegistrar.isRegistered("OverlayProxy")) {
                    return i2.TypeRegistrar.create("OverlayProxy");
                }
                else {
                    throw new i2.BaseError(1, "overlay series module is not loaded, but is required.");
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.bb = function (a, b) {
            var c = this.x8(a);
            switch (this.ty(a)) {
                case 3:
                    var d = this.u1();
                    this.ui.setValueMemberPath(d, c);
                    this.ui.setXAxis(d, this.xAxis);
                    this.ui.setYAxis(d, this.yAxis);
                    this.ui.setCategoryMode(d, 1);
                    return d;
                case 4:
                    var e = this.u2();
                    this.ui.setValueMemberPath(e, c);
                    this.ui.setXAxis(e, this.xAxis);
                    this.ui.setYAxis(e, this.yAxis);
                    this.ui.setCategoryMode(e, 1);
                    return e;
                default:
                case 1:
                case 2:
                    var f = this.u3();
                    this.ug.setOpenMemberPath(f, a.getMemberPathFor(11));
                    this.ug.setHighMemberPath(f, a.getMemberPathFor(12));
                    this.ug.setLowMemberPath(f, a.getMemberPathFor(13));
                    this.ug.setCloseMemberPath(f, a.getMemberPathFor(14));
                    this.ug.setVolumeMemberPath(f, a.getMemberPathFor(15));
                    this.ug.setXAxis(f, this.xAxis);
                    this.ug.setYAxis(f, this.yAxis);
                    this.ug.setDisplayType(f, this.tw == 1 ? 1 : 0);
                    this.ug.setCategoryMode(f, 1);
                    return f;
            }
        };
        FinancialChart.prototype.kp = function () {
            _super.prototype.kp.call(this);
            this.aas(this.xAxis);
            this.abf(false);
            if (this.t1 != 0 && this.volumeChart != null) {
                this.aay();
            }
            this.aas(this.volumeXAxis);
            this.aas(this.indicatorXAxis);
            this.abc();
            this.abe();
            if (this.t8 != 0) {
                this.aaz();
                this.aas(this.zoomSliderXAxis);
            }
        };
        FinancialChart.prototype.ra = function (a, b) {
            var e_2, _a;
            _super.prototype.ra.call(this, a, b);
            a(this.volumeXAxis);
            if (this.v6 != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.v6)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
            var d = true;
            switch (b) {
                case "XAxisMajorStroke":
                case "XAxisMajorStrokeThickness":
                    d = false;
                    break;
            }
            if (d) {
                a(this.zoomSliderXAxis);
            }
        };
        FinancialChart.prototype.rf = function (a, b) {
            var e_3, _a;
            _super.prototype.rf.call(this, a, b);
            if (b) {
                a(this.volumeAxis);
                if (this.v4 != null) {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.v4)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var c = _c.value;
                            a(c);
                        }
                    }
                    catch (e_3_1) {
                        e_3 = { error: e_3_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_3)
                                throw e_3.error;
                        }
                    }
                }
                a(this.zoomSliderAxis);
            }
        };
        FinancialChart.prototype.rd = function (a) {
            _super.prototype.rd.call(this, a);
            this.q4(this.volumeXAxis, a);
            this.q4(this.indicatorXAxis, a);
            this.q4(this.zoomSliderXAxis, a);
        };
        FinancialChart.prototype.ri = function (a) {
            _super.prototype.ri.call(this, a);
            this.q4(this.volumeAxis, a);
            this.q4(this.indicatorAxis, a);
            this.q4(this.zoomSliderAxis, a);
        };
        FinancialChart.prototype.rg = function (a) {
            _super.prototype.rg.call(this, a);
            this.q3(this.volumeAxis, a);
            this.q3(this.indicatorAxis, a);
            this.q3(this.zoomSliderAxis, a);
        };
        FinancialChart.prototype.rb = function (a) {
            _super.prototype.rb.call(this, a);
            this.q3(this.volumeXAxis, a);
            this.q3(this.indicatorXAxis, a);
            this.q3(this.zoomSliderXAxis, a);
        };
        FinancialChart.prototype.jh = function (a) {
            var _this = this;
            _super.prototype.jh.call(this, a);
            if (a == null) {
                return;
            }
            if (a == this.zoomSliderChart) {
                a.qi = a.ql = false;
                a.legend = null;
                if (this.dataChart != null) {
                    a.ag = this.dataChart.ag;
                    a.aj = this.dataChart.aj;
                }
            }
            else {
                SyncManager.d(a, ((function () {
                    var $ret = new SyncSettings();
                    $ret.syncChannel = _this.y3();
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })()));
                SyncManager.c(a);
            }
            a.b3 = 2;
        };
        FinancialChart.prototype.y3 = function () {
            if (this.x0 == null) {
                FinancialChart.xk++;
                this.x0 = FinancialChart.xk.toString();
            }
            return this.x0;
        };
        FinancialChart.prototype.aae = function (a, b) {
            this.z0();
            this.aau();
        };
        FinancialChart.prototype.z0 = function () {
            var e_4, _a;
            if (this.yAxis.b3()) {
                return;
            }
            var a = this.yAxis.av.a9;
            if (this.t1 != 0) {
                a = Math.max(a, this.volumeAxis.av.a9);
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.v4)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    a = Math.max(a, b.av.a9);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            this.z1(a);
        };
        FinancialChart.prototype.z1 = function (a) {
            var e_5, _a;
            if (this.yAxis.b3()) {
                return;
            }
            this.yAxis.eg = this.volumeAxis.eg = a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.v4)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.eg = a;
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            this.zoomSliderAxis.eg = this.yAxis.eg;
        };
        FinancialChart.prototype.z6 = function (a) {
            if (this.indicatorCharts == null) {
                return;
            }
            for (var b = 0; b < this.indicatorCharts.count; b++) {
                var c = this.indicatorCharts._inner[b];
                for (var d = 0; d < c.series.count; d++) {
                    var e = c.series._inner[d];
                    if (!(this.vn(e))) {
                        continue;
                    }
                    a(c.series._inner[d], b);
                }
            }
        };
        FinancialChart.prototype.z9 = function (a) {
            if (this.volumeChart == null) {
                return;
            }
            for (var b = 0; b < this.volumeChart.series.count; b++) {
                var c = this.volumeChart.series._inner[b];
                if (c.c6) {
                    continue;
                }
                a(this.volumeChart.series._inner[b], b);
            }
        };
        FinancialChart.prototype.z7 = function (a) {
            if (this.dataChart == null) {
                return;
            }
            for (var b = 0; b < this.dataChart.series.count; b++) {
                var c = this.dataChart.series._inner[b];
                if (!this.vp(c)) {
                    continue;
                }
                a(c, b);
            }
        };
        FinancialChart.prototype.z8 = function (a, b) {
            if (this.dataChart == null) {
                return;
            }
            for (var c = 0; c < this.dataChart.series.count; c++) {
                var d = this.dataChart.series._inner[c];
                if (this.vp(d)) {
                    continue;
                }
                var e = this.xe(d, c);
                a(d, e);
            }
            if (b) {
                this.aaa(a);
            }
        };
        FinancialChart.prototype.aaa = function (a) {
            if (this.zoomSliderChart == null) {
                return;
            }
            for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
                var c = this.zoomSliderChart.series._inner[b];
                if (c.c6) {
                    continue;
                }
                a(this.zoomSliderChart.series._inner[b], b);
            }
        };
        FinancialChart.prototype.xe = function (a, b) {
            if (a.b8 != this.dataChart) {
                return b;
            }
            var c = this.ac == null || this.ac.dataSeries == null ? 0 : this.ac.dataSeries.count;
            var d = this.uc == null ? 0 : this.uc.count;
            return b - (c * d);
        };
        FinancialChart.prototype.i7 = function (a) {
            _super.prototype.i7.call(this, a);
            this.z9(a);
            this.z6(a);
            this.aaa(a);
        };
        Object.defineProperty(FinancialChart.prototype, "volumeChart", {
            get: function () {
                return this.u7;
            },
            set: function (a) {
                var b = this.volumeChart;
                if (a != b) {
                    this.u7 = a;
                    this.j6("VolumeChart", b, this.volumeChart);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.aay = function () {
            if (this.dataChart == null) {
                return;
            }
            this.volumeChart.series.clear();
            var a = new i2.List$1(Series.$, 0);
            var b = -1;
            for (var c = 0; c < this.dataChart.series.count; c++) {
                var d = this.dataChart.series._inner[c];
                if (this.vp(d) || d.c6) {
                    continue;
                }
                b++;
                var e = void 0;
                var f = this.t1;
                f = this.t0(f);
                switch (f) {
                    case 2:
                        e = this.u2();
                        break;
                    case 3:
                        e = this.u0();
                        break;
                    default:
                    case 1:
                        e = this.u1();
                        break;
                }
                this.ui.setCategoryMode(e, 1);
                e.name = "volumeSeries_" + b;
                e.itemsSource = d.itemsSource;
                this.ui.setXAxis(e, this.volumeXAxis);
                this.ui.setYAxis(e, this.volumeAxis);
                this.ui.setValueMemberPath(e, this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > b ? this.ac.dataSeries._inner[b].getMemberPathFor(15) : null);
                e.hp = d.hp + " Volume";
                e.oj = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s9, b);
                e.oo = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.ta, b);
                e.gm = this.wu;
                a.add(e);
            }
            var g = this.c1("volume", false);
            if (g != null) {
                a.o(g);
            }
            for (var h = 0; h < a.count; h++) {
                var i = a._inner[h];
                this.volumeChart.series.add(i);
                this.jm(i, h);
            }
        };
        FinancialChart.prototype.vm = function (a) {
            if (!this.vi) {
                return false;
            }
            return this.ui.matchesType(a);
        };
        FinancialChart.prototype.vq = function (a) {
            if (!this.vl) {
                return false;
            }
            return this.ug.matchesType(a);
        };
        FinancialChart.prototype.vn = function (a) {
            if (!this.vj) {
                return false;
            }
            return this.uk.matchesType(a);
        };
        FinancialChart.prototype.vp = function (a) {
            if (!this.vk) {
                return false;
            }
            return this.up.matchesType(a);
        };
        FinancialChart.prototype.aax = function () {
            if (this.dataChart == null) {
                return;
            }
            var a = 0;
            var b = this.ua == null ? 0 : this.ua.count;
            var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            var d = b + c;
            for (var e = 0; e < d; e++) {
                var f = new i2.List$1(Series.$, 0);
                var g = this.indicatorCharts._inner[e];
                var h = e >= b;
                var i = h ? this.customIndicatorNames._inner[e - b] : i2.EnumUtil.getName(FinancialIndicatorType_$type, this.ua._inner[e]);
                var j = -1;
                for (var k = 0; k < this.dataChart.series.count; k++) {
                    var l = this.dataChart.series._inner[k];
                    if (this.vp(l) || l.c6) {
                        continue;
                    }
                    j++;
                    var m = void 0;
                    if (h) {
                        var n = this.u4("Custom");
                        this.uk.handleCustomIndicatorEvent(n, i2.runOn(this, this.aac));
                        m = n;
                    }
                    else {
                        m = this.u6(this.ua._inner[e]);
                    }
                    if (m == null) {
                        continue;
                    }
                    m.name = "indicator_" + a++;
                    this.uk.setXAxis(m, this.v6._inner[e]);
                    this.uk.setYAxis(m, this.v4._inner[e]);
                    m.itemsSource = l.itemsSource;
                    this.uk.setOpenMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(11));
                    this.uk.setHighMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(12));
                    this.uk.setLowMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(13));
                    this.uk.setCloseMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(14));
                    this.uk.setVolumeMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(15));
                    m.hp = l.hp + " " + i;
                    m.oj = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s3, e);
                    m.gm = this.wq;
                    if (this.vn(m)) {
                        this.uk.setNegativeBrush(m, i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s4, e));
                        this.uk.setDisplayType(m, i2.ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.um, e));
                    }
                    if (this.xg != -2147483648 && this.vn(m)) {
                        this.uk.setPeriodOverride(m, this.xg);
                    }
                    if (this.vn(m)) {
                        this.uk.setSmoothingPeriod(m, this.xj);
                    }
                    if (this.vn(m)) {
                        this.uk.setSignalPeriod(m, this.xi);
                    }
                    if (this.vn(m)) {
                        this.uk.setShortPeriod(m, this.xh);
                        this.uk.setLongPeriod(m, this.xf);
                    }
                    this.jm(m, e);
                    f.add(m);
                }
                var o = this.c1(i, false);
                for (var p = 0; p < f.count; p++) {
                    var q = f._inner[p];
                    g.series.add(q);
                }
                if (o != null) {
                    for (var r = 0; r < o.count; r++) {
                        var s = o._inner[r];
                        g.series.add(s);
                        this.jm(s, r);
                    }
                }
            }
        };
        FinancialChart.prototype.u4 = function (indicatorName_) {
            return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
        };
        FinancialChart.prototype.u6 = function (a) {
            return this.u4(i2.EnumUtil.getName(FinancialIndicatorType_$type, a));
        };
        FinancialChart.prototype.abf = function (a) {
            if (this.tu == null) {
                return;
            }
            var b = this.xAxis;
            if (b.actualMinimumValue > b.actualMaximumValue) {
                return;
            }
            this.tu.as = b.actualMinimumValue;
            this.tu.ar = b.actualMaximumValue;
            if (a) {
                this.tu.au = b.visibleMinimum;
                this.tu.at = b.visibleMaximum;
            }
            this.tu.bn();
        };
        FinancialChart.prototype.fe = function () {
            var e_6, _a, e_7, _b;
            var _this = this;
            var a = ((function () {
                var $ret = new FinancialChartVisualData();
                $ret.mainChart = _super.prototype.fe.call(_this);
                $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.rm();
                $ret.toolbar = _this.tu == null ? null : _this.tu.aj();
                $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.rm();
                return $ret;
            })());
            if (this.indicatorCharts != null) {
                a.indicatorCharts = new i2.List$1(i2.Base.$, 0);
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        a.indicatorCharts.add1(b.rm());
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
            }
            if (this.dataChart != null) {
                a.mainChartLeft = this.abo(this.dataChart).x;
                a.mainChartTop = this.abo(this.dataChart).y;
            }
            if (this.volumeChart != null) {
                a.volumeChartLeft = this.abo(this.volumeChart).x;
                a.volumeChartTop = this.abo(this.volumeChart).y;
            }
            if (this.zoomSliderChart != null) {
                a.zoomChartLeft = this.abo(this.zoomSliderChart).x;
                a.zoomChartTop = this.abo(this.zoomSliderChart).y;
            }
            if (this.tu != null) {
                var c = this.abp(this.tu);
                a.toolbarLeft = c.left;
                a.toolbarTop = c.top;
                a.toolbarWidth = c.width;
                a.toolbarHeight = c.height;
            }
            if (this.indicatorCharts != null) {
                a.indicatorChartLefts = new i2.List$1(i2.Number_$type, 0);
                a.indicatorChartTops = new i2.List$1(i2.Number_$type, 0);
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var d = _f.value;
                        a.indicatorChartLefts.add(this.abo(d).x);
                        a.indicatorChartTops.add(this.abo(d).y);
                    }
                }
                catch (e_7_1) {
                    e_7 = { error: e_7_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_7)
                            throw e_7.error;
                    }
                }
            }
            var e = this.abr();
            a.legendLeft = e.left;
            a.legendTop = e.top;
            a.legendWidth = e.width;
            a.legendHeight = e.height;
            a.legend = this.ue == null ? null : this.ue.exportVisualData();
            return a;
        };
        FinancialChart.prototype.x5 = function () {
            var a = this.fe();
            a.scaleByViewport();
            return a.serialize();
        };
        FinancialChart.prototype.u5 = function (overlayName_) {
            return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
        };
        FinancialChart.prototype.abe = function () {
            var e_8, _a, e_9, _b;
            if (this.dataChart == null) {
                return;
            }
            var a = new i2.List$1(Series.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    if (this.vp(b)) {
                        a.add(b);
                    }
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    this.dataChart.series.remove(c);
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            if (this.uc == null) {
                return;
            }
            var d = new i2.List$1(Series.$, 0);
            var e = -1;
            for (var f = 0; f < this.dataChart.series.count; f++) {
                var g = this.dataChart.series._inner[f];
                if (this.vp(g) || g.c6) {
                    continue;
                }
                e++;
                for (var h = 0; h < this.uc.count; h++) {
                    var i = this.uc._inner[h];
                    var j = void 0;
                    switch (i) {
                        case 1:
                            j = this.u5(i2.EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                        default:
                        case 0:
                            j = this.u5(i2.EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                    }
                    j.name = g.name + "_" + i2.EnumUtil.getName(FinancialOverlayType_$type, i);
                    this.up.setXAxis(j, this.xAxis);
                    this.up.setYAxis(j, this.yAxis);
                    j.itemsSource = g.itemsSource;
                    var k = e * this.uc.count + h;
                    j.oj = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s7, k);
                    j.oo = i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s8, k);
                    j.gm = this.ws;
                    j.hp = g.hp + " " + i2.EnumUtil.getName(FinancialOverlayType_$type, i);
                    var l = g;
                    if (l == null) {
                        continue;
                    }
                    var m = this.ac.dataSeries._inner[e];
                    this.up.setOpenMemberPath(j, m.getMemberPathFor(11));
                    this.up.setHighMemberPath(j, m.getMemberPathFor(12));
                    this.up.setLowMemberPath(j, m.getMemberPathFor(13));
                    this.up.setCloseMemberPath(j, m.getMemberPathFor(14));
                    this.up.setVolumeMemberPath(j, m.getMemberPathFor(15));
                    d.add(j);
                }
            }
            var n = new Array(this.dataChart.series.count);
            this.dataChart.series.copyTo(n, 0);
            this.dataChart.skipDataCleanup = true;
            this.dataChart.series.clear();
            this.dataChart.skipDataCleanup = false;
            for (var o = 0; o < n.length; o++) {
                n[o].g9 = -1;
            }
            d.o(n);
            for (var p = 0; p < d.count; p++) {
                var q = d._inner[p];
                this.dataChart.series.add(q);
                this.jm(q, p);
            }
        };
        FinancialChart.prototype.abc = function () {
            var e_10, _a;
            if (this.vv) {
                return;
            }
            this.vv = true;
            if (this.indicatorCharts != null) {
                var a = this.indicatorCharts;
                this.indicatorCharts = null;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        this.aat(b);
                    }
                }
                catch (e_10_1) {
                    e_10 = { error: e_10_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_10)
                            throw e_10.error;
                    }
                }
            }
            if ((this.ua == null || this.ua.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
                this.indicatorCharts = null;
                if (this.v4 != null) {
                    this.v4.clear();
                }
                if (this.v6 != null) {
                    this.v6.clear();
                }
                this.aa3();
                this.abd();
                this.vv = false;
                return;
            }
            if (this.indicatorCharts == null) {
                this.indicatorCharts = new i2.List$1(XamDataChart.$, 0);
            }
            this.indicatorCharts.clear();
            this.v4.clear();
            this.v6.clear();
            var c = this.ua == null ? 0 : this.ua.count;
            var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            var e = c + d;
            for (var f = 0; f < e; f++) {
                var g = new XamDataChart();
                this.indicatorCharts.add(g);
                this.aar(g);
                var h = f >= c;
                if (h) {
                    g.ie = this.customIndicatorNames._inner[f - c];
                }
                else {
                    g.ie = this.x7(this.ua._inner[f]);
                }
                if (this.indicatorAxis != null) {
                    var i = void 0;
                    var j = void 0;
                    if (f == 0) {
                        i = this.indicatorAxis;
                        j = this.indicatorXAxis;
                    }
                    else {
                        i = new NumericYAxis();
                        if (!this.indicatorXAxis.b9) {
                            j = this.tg(0);
                        }
                        else {
                            j = this.tg(1);
                        }
                    }
                    j.name = "indicatorXAxis_" + f;
                    i.name = "indicatorAxis_" + f;
                    g.axes.add(i);
                    g.axes.add(j);
                    this.v4.add(i);
                    this.v6.add(j);
                    if (this.cb) {
                        this.q7(i);
                    }
                    if (this.cb) {
                        this.q5(j);
                    }
                }
            }
            this.aax();
            this.aa3();
            if (this.tu != null) {
                this.tu.ae = this.ua;
            }
            this.z2();
            this.abd();
            this.vv = false;
        };
        FinancialChart.prototype.je = function () {
            var e_11, _a, e_12, _b;
            _super.prototype.je.call(this);
            this.q5(this.xAxis);
            this.q5(this.volumeXAxis);
            if (this.v6 != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.v6)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var a = _d.value;
                        this.q5(a);
                    }
                }
                catch (e_11_1) {
                    e_11 = { error: e_11_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_11)
                            throw e_11.error;
                    }
                }
            }
            this.q7(this.yAxis);
            this.q7(this.volumeAxis);
            if (this.v4 != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.v4)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var b = _f.value;
                        this.q7(b);
                    }
                }
                catch (e_12_1) {
                    e_12 = { error: e_12_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_12)
                            throw e_12.error;
                    }
                }
            }
            this.q5(this.zoomSliderXAxis);
            this.q7(this.zoomSliderAxis);
        };
        FinancialChart.prototype.get_cs = function () {
            return !this.vt;
        };
        Object.defineProperty(FinancialChart.prototype, "vz", {
            get: function () {
                return (this.externalObject._dynamicContent);
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.abk = function (a, b) {
            this.aa6(a, b);
            this.z2();
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
            }
            this.aaz();
            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
            this.aa4();
            this.abl(a, b);
        };
        FinancialChart.prototype.aaz = function () {
            if (this.dataChart == null || this.zoomSliderChart == null) {
                return;
            }
            this.zoomSliderChart.series.clear();
            var a = new i2.List$1(Series.$, 0);
            for (var b = 0; b < this.dataChart.series.count; b++) {
                var c = this.dataChart.series._inner[b];
                if (this.vp(c) || c.c6) {
                    continue;
                }
                var d = void 0;
                var e = this.t8;
                e = this.t7(e);
                var f = this.xe(c, b);
                if (e == 1) {
                    switch (this.ty(this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > f ? this.ac.dataSeries._inner[f] : null)) {
                        case 1:
                            e = 2;
                            break;
                        case 2:
                            e = 3;
                            break;
                        case 3:
                            e = 4;
                            break;
                        case 4:
                            e = 5;
                            break;
                    }
                }
                switch (e) {
                    case 2:
                        d = this.u3();
                        this.ug.setDisplayType(d, 1);
                        break;
                    case 3:
                        d = this.u3();
                        this.ug.setDisplayType(d, 0);
                        break;
                    case 5:
                        d = this.u2();
                        break;
                    case 6:
                        d = this.u0();
                        break;
                    default:
                    case 4:
                        d = this.u1();
                        break;
                }
                var g = this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > f ? this.ac.dataSeries._inner[f] : null;
                if (d.da && !d.di) {
                    this.ui.setCategoryMode(d, 1);
                    this.ui.setXAxis(d, this.zoomSliderXAxis);
                    this.ui.setYAxis(d, this.zoomSliderAxis);
                    this.ui.setValueMemberPath(d, g == null ? null : this.x8(g));
                }
                else if (d.di) {
                    this.ug.setCategoryMode(d, 1);
                    this.ug.setXAxis(d, this.zoomSliderXAxis);
                    this.ug.setYAxis(d, this.zoomSliderAxis);
                    if (g != null) {
                        this.ug.setOpenMemberPath(d, g.getMemberPathFor(11));
                        this.ug.setHighMemberPath(d, g.getMemberPathFor(12));
                        this.ug.setLowMemberPath(d, g.getMemberPathFor(13));
                        this.ug.setCloseMemberPath(d, g.getMemberPathFor(14));
                        this.ug.setVolumeMemberPath(d, g.getMemberPathFor(15));
                    }
                }
                d.name = "zoomSliderSeries_" + f;
                d.itemsSource = c.itemsSource;
                d.hp = c.hp;
                d.gm = this.ep;
                a.add(d);
            }
            for (var h = 0; h < a.count; h++) {
                var i = a._inner[h];
                this.zoomSliderChart.series.add(i);
                this.jm(i, h);
            }
        };
        FinancialChart.prototype.j1 = function (a, b, c) {
            var e_13, _a;
            _super.prototype.j1.call(this, a, b, c);
            if (a == null || !b) {
                return;
            }
            var d = true;
            var e = true;
            switch (c) {
                case "Brushes":
                case "Outlines":
                    d = e = false;
                    break;
            }
            if (this.indicatorCharts != null && d) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var f = _c.value;
                        a(f);
                    }
                }
                catch (e_13_1) {
                    e_13 = { error: e_13_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_13)
                            throw e_13.error;
                    }
                }
            }
            if (this.volumeChart != null && e) {
                a(this.volumeChart);
            }
            if (this.zoomSliderChart != null) {
                a(this.zoomSliderChart);
            }
        };
        FinancialChart.prototype.aac = function (a, b) {
            var c = b;
            var d = a;
            var e = -1;
            if (this.indicatorCharts != null) {
                e = this.indicatorCharts.indexOf(d.b8);
            }
            e -= this.ua == null ? 0 : this.ua.count;
            if (this.applyCustomIndicators != null) {
                this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
            }
        };
        FinancialChart.prototype.aa8 = function (a, b, c) {
            if (a != null) {
                if (b != null) {
                    a.axes.remove(b);
                }
                a.axes.add(c);
            }
            if (this.cb) {
                this.q5(c);
            }
        };
        Object.defineProperty(FinancialChart.prototype, "vy", {
            get: function () {
                return i2.TypeRegistrar.isRegistered("IgxZoomSliderComponent");
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.aad = function (a, b) {
            this.abc();
        };
        FinancialChart.prototype.vr = function (a, b) {
            if (b <= (0)) {
                return false;
            }
            switch (a) {
                case 5: return true;
                case 4:
                case 3: return b >= i2.timeSpanFromDays(365);
                case 2: return b >= i2.timeSpanFromDays(180);
                case 1: return b >= i2.timeSpanFromDays(90);
                case 0: return b >= i2.timeSpanFromDays(30);
            }
            return false;
        };
        FinancialChart.prototype.aa2 = function () {
            var e_14, _a;
            var a = this.ts != null ? this.ts : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
            var b = new FinancialChartRangeSelectorOptionCollection(0);
            var c = this.xAxis;
            var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (this.vr(e, d)) {
                        b.add(e);
                    }
                }
            }
            catch (e_14_1) {
                e_14 = { error: e_14_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_14)
                        throw e_14.error;
                }
            }
            this.tr = b;
            if (this.tu != null) {
                this.tu.u = this.tr;
            }
        };
        FinancialChart.prototype.aah = function (a, b) {
            this.aa2();
        };
        FinancialChart.prototype.aam = function (a, b) {
            this.uc = this.tu.ag;
        };
        FinancialChart.prototype.aal = function (a, b) {
            this.ua = this.tu.ae;
        };
        FinancialChart.prototype.aaf = function (a, b) {
            this.abc();
        };
        FinancialChart.prototype.aag = function (a, b) {
            this.abe();
        };
        FinancialChart.prototype.aaq = function (a, b) {
            var c = a;
            if (c.bf == null) {
                return;
            }
            if (this.vt) {
                this.aa1(c.bf);
            }
        };
        FinancialChart.prototype.aat = function (a) {
            SyncManager.e(a);
            a.axes.clear();
            a.series.clear();
            a.gridAreaRectChanged = i2.delegateRemove(a.gridAreaRectChanged, i2.runOn(this, this.aae));
            a.provideContainer(null);
            if (this.volumeChart == null && this.indicatorCharts == null) {
                this.yAxis.eg = this.volumeAxis.eg = this.indicatorAxis.eg = 0;
                this.xAxis.ay.visibility = this.st;
            }
        };
        FinancialChart.prototype.aar = function (a) {
            var b = a != this.zoomSliderChart;
            if (b) {
                if (this.dataChart != null) {
                    a.pw = new i2.Rect(0, this.dataChart.pg.x, a.pw.y, this.dataChart.pg.width, a.pw.height);
                }
                var c = ((function () {
                    var $ret = new SyncSettings();
                    $ret.syncChannel = "one";
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })());
                SyncManager.d(a, c);
                SyncManager.c(a);
            }
            a.gridAreaRectChanged = i2.delegateCombine(a.gridAreaRectChanged, i2.runOn(this, this.aae));
            this.jg(a);
        };
        FinancialChart.prototype.z2 = function () {
            if (this.indicatorCharts != null || this.volumeChart != null) {
                this.q3(this.xAxis, function (a) { return a.visibility = 1; });
            }
            var _loop_1 = function (a) {
                var b = this_1.v6._inner[a];
                var c = a < this_1.v6.count - 1 || this_1.volumeChart != null;
                this_1.q3(b, function (d) { return d.visibility = c ? 1 : 0; });
            };
            var this_1 = this;
            for (var a = 0; a < this.v6.count; a++) {
                _loop_1(a);
            }
        };
        FinancialChart.prototype.aa6 = function (a, b) {
            if (a != null) {
                this.aat(a);
            }
            if (b != null) {
                this.aar(b);
            }
        };
        FinancialChart.prototype.abi = function (a, b) {
            this.aa6(a, b);
            this.z2();
            if (this.volumeChart != null) {
                if (this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.volumeChart.axes.add(this.volumeXAxis);
                }
                this.aay();
                this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
            }
            this.abj(a, b);
        };
        FinancialChart.prototype.aai = function (a, b) {
            this.abg();
        };
        FinancialChart.prototype.abg = function () {
            if (this.tu == null || +(this.tu.au) == +(i2.dateMaxValue()) || +(this.tu.at) == +(i2.dateMinValue()) || this.dataChart == null) {
                return;
            }
            var a = this.xAxis;
            var b = a.getWindowRectForSelection(this.tu.au, this.tu.at);
            if (b.width == 0 || i2.isNaN_(b.width) || i2.isInfinity(b.width)) {
                return;
            }
            this.vu = true;
            this.dataChart.pw = new i2.Rect(0, b.left, this.dataChart.pw.top, b.width, this.dataChart.pw.height);
            if (this.vc != null) {
                this.vc.windowRect = this.dataChart.pg;
            }
            if (this.vt) {
                this.aa1(this.dataChart);
            }
            this.vu = false;
        };
        FinancialChart.prototype.aap = function (a, b) {
            this.aa2();
            this.abf(!this.vu);
        };
        FinancialChart.prototype.aab = function (a, b) {
            var _this = this;
            if (!this.vu) {
                if (this.vt) {
                    this.aa1(a);
                }
                var c = false;
                var d = this.kb(function () { return _this.abf(true); }, c);
                c = d.p1;
                if (this.vc != null) {
                    this.vc.windowRect = this.dataChart.pg;
                }
            }
        };
        FinancialChart.prototype.aba = function (a, b, c, d) {
            var e_15, _a;
            if (a == null || b == null) {
                return;
            }
            if (c != -1) {
                this.vu = true;
                a.pw = new i2.Rect(0, d, a.pg.top, c, a.pg.height);
                this.vu = false;
            }
            var e = 1.7976931348623157E+308;
            var f = -1.7976931348623157E+308;
            var g = new i2.Rect(0, 0, 0, 1, 1);
            var h = new ScalerParams(0, g, g, this.yAxis.cc, a.pk);
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var i = _c.value;
                    h.b = i.f2();
                    var j = i.aq(a.pg);
                    var k = j == null || j.c == 1.7976931348623157E+308 || i2.isNaN_(j.c);
                    if (k) {
                        continue;
                    }
                    var l = b.d8(j.c, h);
                    var m = b.d8(j.b, h);
                    f = Math.max(f, l);
                    e = Math.min(e, m);
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
            var n = a.pg.width;
            if (c != -1) {
                n = c;
            }
            var o = a.pg.left;
            if (d != -1) {
                o = d;
            }
            if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || i2.isNaN_(e) || i2.isNaN_(f)) {
                return;
            }
            this.vu = true;
            var p = new i2.Rect(0, o, e, n, f - e);
            a.pw = p;
            this.vu = false;
        };
        FinancialChart.prototype.aa9 = function (a) {
            if (a == null) {
                return;
            }
            if (a == this.dataChart) {
                this.aba(this.dataChart, this.yAxis, -1, -1);
                if (this.volumeChart != null) {
                    this.aba(this.volumeChart, this.volumeAxis, this.dataChart.pg.width, this.dataChart.pg.left);
                }
            }
            else if (a == this.volumeChart) {
                this.aba(this.volumeChart, this.volumeAxis, -1, -1);
                this.aba(this.dataChart, this.yAxis, this.volumeChart.pg.width, this.volumeChart.pg.left);
            }
        };
        FinancialChart.prototype.aa1 = function (a) {
            var _this = this;
            this.ka(function () { return _this.aa9(a); });
        };
        FinancialChart.prototype.aaj = function (a, b) {
            if (this.vt) {
                this.aa1(a);
            }
        };
        FinancialChart.prototype.abh = function () {
            if (!this.vz) {
                return;
            }
            this.z5();
            if (this.t8 == 0) {
                this.zoomSliderChart = null;
            }
            else if (this.zoomSliderChart == null) {
                this.zoomSliderChart = ((function () {
                    var $ret = new XamDataChart();
                    $ret.name = "ZoomSliderChart";
                    return $ret;
                })());
            }
            else {
                this.aaz();
            }
        };
        FinancialChart.prototype.z5 = function () {
            var container_ = this.w6.rootWrapper.getNativeElement();
            var containerParent_ = container_.parentElement;
            if (this.vc != null && containerParent_ != null && !this.v0) {
                this.v0 = true;
                if (i2.TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                    var z_ = this.vc;
                    var f_ = this.externalObject;
                    var sliderComponent_ = i2.TypeRegistrar.get("IgxZoomSliderComponent");
                    var sliderInstance_ = i2.TypeRegistrar.create("IgxZoomSliderComponent");
                    sliderInstance_._implementation = z_;
                    sliderComponent_._staticStyling(container_, sliderInstance_, f_);
                }
            }
        };
        FinancialChart.prototype.abb = function () {
            var _this = this;
            if (this.t3 != 1) {
                return;
            }
            this.q9(function (a) {
                var e_16, _a;
                var b;
                b = a.breaks;
                b.clear();
                if (_this.xAxisBreaks == null) {
                    return;
                }
                try {
                    for (var _b = tslib.__values(i2.fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        b.add(c);
                    }
                }
                catch (e_16_1) {
                    e_16 = { error: e_16_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_16)
                            throw e_16.error;
                    }
                }
            });
        };
        FinancialChart.prototype.ku = function (a, b, c) {
            _super.prototype.ku.call(this, a, b, c);
            if (this.ac.dataSeries.count > 0) {
                if (this.t3 == 1 && i2.stringIsNullOrEmpty(this.gb)) {
                    this.ak.setXMemberPath(a, c.getMemberPathFor(17));
                }
                if (i2.stringIsNullOrEmpty(this.gd)) {
                    this.ak.setYMemberPath(a, this.x8(c));
                }
                if (i2.stringIsNullOrEmpty(this.f7)) {
                    this.ak.setLabelMemberPath(a, this.x8(c));
                }
                if (i2.stringIsNullOrEmpty(this.f4)) {
                    this.ak.setContentMemberPath(a, this.x8(c));
                }
            }
        };
        FinancialChart.prototype.x7 = function (a) {
            switch (a) {
                case 0: return "Absolute Volume Oscillator";
                case 1: return "Accumulation/Distribution Indicator";
                case 2: return "Average Directional Index";
                case 3: return "Average True Range Indicator";
                case 4: return "Bollinger Bandwidth";
                case 5: return "Chaikin Oscillator";
                case 6: return "Chaikin Volatility Indicator";
                case 7: return "Commodity Channel Index";
                case 8: return "Detrended Price Oscillator";
                case 9: return "Ease of Movement Indicator";
                case 10: return "Fast Stochastic Oscillator";
                case 11: return "Force Index Indicator";
                case 12: return "Full Stochastic Oscillator";
                case 13: return "Market Facilitation Index";
                case 14: return "Mass Index Indicator";
                case 15: return "Median Price Indicator";
                case 16: return "Money Flow Index";
                case 17: return "MACD Indicator";
                case 18: return "Negative Volume Index";
                case 19: return "On Balance Volume Indicator";
                case 20: return "Percentage Price Oscillator";
                case 21: return "Percentage Volume Oscillator";
                case 22: return "Positive Volume Index";
                case 23: return "Price Volume Trend";
                case 24: return "ROC - Rate of Change Indicator";
                case 25: return "RSI - Relative Strength Index";
                case 26: return "Slow Stochastic Oscillator";
                case 27: return "Standard Deviation Indicator";
                case 28: return "Stoch RSI";
                case 29: return "TRIX Indicator";
                case 30: return "Typical Price Indicator";
                case 31: return "Ultimate Oscillator";
                case 32: return "Weighted Close Indicator";
                case 33: return "Williams %R Indicator";
                default: return "Unknown";
            }
        };
        FinancialChart.prototype.q5 = function (a) {
            var e_17, _a;
            _super.prototype.q5.call(this, a);
            var b = a;
            this.aas(b);
            if (a.bf != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        if (this.vm(c)) {
                            this.ui.setXAxis(c, b);
                        }
                        else if (this.vq(c)) {
                            this.ug.setXAxis(c, b);
                        }
                        else if (this.vn(c)) {
                            this.uk.setXAxis(c, b);
                        }
                        else if (this.vp(c)) {
                            this.up.setXAxis(c, b);
                        }
                    }
                }
                catch (e_17_1) {
                    e_17 = { error: e_17_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_17)
                            throw e_17.error;
                    }
                }
            }
            var d = a == this.zoomSliderXAxis;
            if (d) {
                a.jb = this.abn;
                a.ef = this.w1;
                this.q3(a, function (e) { return e.visibility = 1; });
            }
            var e = a;
            e.minimumValue = this.wc;
            e.maximumValue = this.wb;
        };
        FinancialChart.prototype.q7 = function (a) {
            var e_18, _a;
            _super.prototype.q7.call(this, a);
            if (a.bf != null && a == this.yAxis) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        if (this.vm(b)) {
                            this.ui.setYAxis(b, this.yAxis);
                        }
                        else if (this.vq(b)) {
                            this.ug.setYAxis(b, this.yAxis);
                        }
                        else if (this.vn(b)) {
                            this.uk.setYAxis(b, this.yAxis);
                        }
                        else if (this.vp(b)) {
                            this.up.setYAxis(b, this.yAxis);
                        }
                    }
                }
                catch (e_18_1) {
                    e_18 = { error: e_18_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_18)
                            throw e_18.error;
                    }
                }
            }
            a.kf = this.vw;
            a.k3 = this.wz;
            a.k2 = this.wy;
            if (a == this.yAxis) {
                a.kz = this.wx;
            }
            var c = a == this.zoomSliderAxis;
            if (c) {
                this.q3(a, function (d) { return d.visibility = 1; });
            }
        };
        FinancialChart.prototype.aas = function (a) {
            a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
            a.fj = XYChart.os(a, this.ac.dataSeries);
            if (this.ac.dataSeries.count > 0) {
                var b = this.ac.dataSeries._inner[0].getMemberPathFor(17);
                a.hg(b);
            }
        };
        FinancialChart.prototype.jm = function (a, b) {
            _super.prototype.jm.call(this, a, b);
            if (a == null) {
                return;
            }
            var c = this.zoomSliderChart == a.b8;
            var d = this.dataChart != null && this.dataChart.series.contains(a);
            if ((d || c) && a.dx) {
                a.l5(this.s5 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s5, b) : null, this.s6 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s6, b) : null);
            }
            var e = this.vn(a);
            if (this.vp(a)) {
                a.oj = this.s7 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s7, b) : null;
                a.oo = this.s8 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s8, b) : null;
                a.gm = this.ws;
            }
            else if (e) {
                a.oj = this.s3 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.s3, b) : null;
                a.gm = this.wq;
            }
            else if (!a.c6 && (d || c)) {
                a.oj = this.n != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.n, b) : null;
                a.oo = this.r != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, this.r, b) : null;
            }
            var f = this.volumeChart != null && this.volumeChart == a.b8;
            if (f) {
                a.gm = this.wu;
            }
            a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.vo ? this.ue : null;
        };
        FinancialChart.prototype.j6 = function (a, b, c) {
            var e_19, _a, e_20, _b;
            var _this = this;
            _super.prototype.j6.call(this, a, b, c);
            switch (a) {
                case "YAxisIsLogarithmic":
                    this.yAxis.kk = this.vx;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.kk = this.vx;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.kk = this.vx;
                    }
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.k7 = this.xl;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.k7 = this.xl;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.k7 = this.xl;
                    }
                    break;
                case "VolumeType":
                    var d = i2.EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                    if (this.t1 == 0) {
                        this.volumeChart = null;
                    }
                    else if (this.volumeChart == null) {
                        this.volumeChart = ((function () {
                            var $ret = new XamDataChart();
                            $ret.name = "VolumeChart";
                            return $ret;
                        })());
                    }
                    else {
                        this.aay();
                    }
                    break;
                case "VolumeChart":
                    this.abi(i2.typeCast(XamDataChart.$, b), i2.typeCast(XamDataChart.$, c));
                    break;
                case "DataChart":
                    if (i2.typeCast(XamDataChart.$, b) !== null) {
                        var e = b;
                        e.gridAreaRectChanged = i2.delegateRemove(e.gridAreaRectChanged, i2.runOn(this, this.aae));
                        e.actualWindowRectChanged = i2.delegateRemove(e.actualWindowRectChanged, i2.runOn(this, this.aab));
                        e.seriesDataUpdated = i2.delegateRemove(e.seriesDataUpdated, i2.runOn(this, this.aaj));
                    }
                    if (this.dataChart != null) {
                        var f = this.dataChart;
                        f.gridAreaRectChanged = i2.delegateCombine(f.gridAreaRectChanged, i2.runOn(this, this.aae));
                        var g = this.dataChart;
                        g.actualWindowRectChanged = i2.delegateCombine(g.actualWindowRectChanged, i2.runOn(this, this.aab));
                        var h = this.dataChart;
                        h.seriesDataUpdated = i2.delegateCombine(h.seriesDataUpdated, i2.runOn(this, this.aaj));
                    }
                    this.abh();
                    break;
                case "XAxisMode":
                    this.xAxis = this.tg(this.t3);
                    this.xAxis.name = "xAxis";
                    this.volumeXAxis = this.tg(this.t3);
                    this.volumeXAxis.name = "volumeXAxis";
                    this.indicatorXAxis = this.tg(this.t3);
                    this.indicatorXAxis.name = "indicatorXAxis_0";
                    this.zoomSliderXAxis = this.tg(this.t3);
                    this.zoomSliderXAxis.name = "zoomSliderXAxis";
                    this.q3(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                    this.z2();
                    if (this.t3 == 1) {
                        this.abb();
                    }
                    break;
                case "YAxisMode":
                    this.yAxis = this.uu(this.t5);
                    this.yAxis.name = "yAxis";
                    this.zoomSliderAxis = this.uu(this.t5);
                    this.zoomSliderAxis.name = "zoomSliderAxis";
                    this.volumeAxis = this.uu(this.t5);
                    this.volumeAxis.name = "volumeAxis";
                    break;
                case "Toolbar":
                    var i = i2.typeCast(FinancialChartToolbar.$, b);
                    if (i != null) {
                        i.rangeChanged = i2.delegateRemove(i.rangeChanged, i2.runOn(this, this.aai));
                        i.indicatorTypesChanged = i2.delegateRemove(i.indicatorTypesChanged, i2.runOn(this, this.aal));
                        i.overlayTypesChanged = i2.delegateRemove(i.overlayTypesChanged, i2.runOn(this, this.aam));
                    }
                    if (this.tu != null) {
                        this.tu.ae = this.ua;
                        this.tu.ag = this.uc;
                        this.tu.u = this.tr;
                        this.abf(true);
                        var j = this.tu;
                        j.rangeChanged = i2.delegateCombine(j.rangeChanged, i2.runOn(this, this.aai));
                        var k = this.tu;
                        k.indicatorTypesChanged = i2.delegateCombine(k.indicatorTypesChanged, i2.runOn(this, this.aal));
                        var l = this.tu;
                        l.overlayTypesChanged = i2.delegateCombine(l.overlayTypesChanged, i2.runOn(this, this.aam));
                    }
                    break;
                case "XAxis":
                    var m = i2.typeCast(CategoryAxisBase.$, b);
                    if (m != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(m);
                        }
                    }
                    var n = i2.typeCast(ITimeRangeSelectorAxis_$type, b);
                    if (n != null) {
                        n.visibleRangeChanged = i2.delegateRemove(n.visibleRangeChanged, i2.runOn(this, this.aap));
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.xAxis);
                    }
                    if (this.cb) {
                        this.q5(this.xAxis);
                        this.i5();
                    }
                    this.abf(false);
                    this.abg();
                    this.aa2();
                    var o = this.xAxis;
                    o.visibleRangeChanged = i2.delegateCombine(o.visibleRangeChanged, i2.runOn(this, this.aap));
                    break;
                case "ChartType":
                    this.kp();
                    break;
                case "VolumeXAxis":
                    this.aa8(this.volumeChart, i2.typeCast(Axis.$, b), this.volumeXAxis);
                    break;
                case "ZoomSliderXAxis":
                    this.aa8(this.zoomSliderChart, i2.typeCast(Axis.$, b), this.zoomSliderXAxis);
                    break;
                case "IndicatorXAxis":
                    this.abc();
                    break;
                case "YAxis":
                    var p = i2.typeCast(NumericYAxis.$, b);
                    if (p != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(p);
                        }
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.yAxis);
                    }
                    if (this.cb) {
                        this.q7(this.yAxis);
                        this.q7(this.yAxis);
                    }
                    var q = this.yAxis;
                    q.rangeChanged = i2.delegateCombine(q.rangeChanged, i2.runOn(this, this.aaq));
                    break;
                case "VolumeAxis":
                    var r = i2.typeCast(Axis.$, b);
                    if (this.volumeChart != null && r != null) {
                        this.volumeChart.axes.remove(r);
                    }
                    if (this.volumeChart != null && this.volumeAxis != null) {
                        this.volumeChart.axes.add(this.volumeAxis);
                        this.aay();
                    }
                    if (this.cb) {
                        this.q7(this.volumeAxis);
                    }
                    var s = this.volumeAxis;
                    s.rangeChanged = i2.delegateCombine(s.rangeChanged, i2.runOn(this, this.aaq));
                    break;
                case "IndicatorAxis":
                    if (this.indicatorCharts != null) {
                        for (var t = 0; t < this.indicatorCharts.count; t++) {
                            var u = this.indicatorCharts._inner[t];
                            var v = new i2.List$1(Axis.$, 0);
                            try {
                                for (var _c = (e_19 = void 0, tslib.__values(i2.fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                    var w = _d.value;
                                    if (i2.typeCast(NumericYAxis.$, w) !== null) {
                                        v.add(w);
                                    }
                                }
                            }
                            catch (e_19_1) {
                                e_19 = { error: e_19_1 };
                            }
                            finally {
                                try {
                                    if (_d && !_d.done && (_a = _c.return))
                                        _a.call(_c);
                                }
                                finally {
                                    if (e_19)
                                        throw e_19.error;
                                }
                            }
                            try {
                                for (var _e = (e_20 = void 0, tslib.__values(i2.fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                    var x = _f.value;
                                    u.axes.remove(x);
                                }
                            }
                            catch (e_20_1) {
                                e_20 = { error: e_20_1 };
                            }
                            finally {
                                try {
                                    if (_f && !_f.done && (_b = _e.return))
                                        _b.call(_e);
                                }
                                finally {
                                    if (e_20)
                                        throw e_20.error;
                                }
                            }
                            var y = null;
                            if (t == 0) {
                                y = this.indicatorAxis;
                            }
                            else if (this.t5 == 1) {
                                y = this.uu(this.t5);
                            }
                            else if (i2.typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                                y = new NumericYAxis();
                            }
                            if (y != null) {
                                u.axes.add(y);
                            }
                            if (this.cb) {
                                this.q7(y);
                            }
                        }
                    }
                    break;
                case "IsWindowSyncedToVisibleRange":
                    if (this.dataChart != null) {
                        this.dataChart.ql = this.ct && this.cs;
                    }
                    if (this.volumeChart != null) {
                        this.volumeChart.ql = this.ct && this.cs;
                    }
                    if (this.vt) {
                        this.aa9(this.dataChart);
                    }
                    else {
                        this.volumeChart.rk = 1;
                    }
                    break;
                case "IndicatorTypes":
                    var z = i2.typeCast(i2.ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                    if (z != null) {
                        z.collectionChanged = i2.delegateRemove(z.collectionChanged, i2.runOn(this, this.aaf));
                    }
                    var aa = i2.typeCast(i2.ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                    if (aa != null) {
                        aa.collectionChanged = i2.delegateCombine(aa.collectionChanged, i2.runOn(this, this.aaf));
                    }
                    this.abc();
                    break;
                case "OverlayTypes":
                    var ab = i2.typeCast(i2.ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                    if (ab != null) {
                        ab.collectionChanged = i2.delegateRemove(ab.collectionChanged, i2.runOn(this, this.aag));
                    }
                    var ac = i2.typeCast(i2.ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                    if (ac != null) {
                        ac.collectionChanged = i2.delegateCombine(ac.collectionChanged, i2.runOn(this, this.aag));
                    }
                    this.abe();
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.re(function (ad) { return ad.kf = _this.vw; });
                    break;
                case "YAxisMinimumValue":
                    this.rf(function (ad) { return ad.k3 = _this.wz; }, false);
                    break;
                case "YAxisMaximumValue":
                    this.rf(function (ad) { return ad.k2 = _this.wy; }, false);
                    break;
                case "YAxisInterval":
                    this.rf(function (ad) { return ad.kz = _this.wx; }, false);
                    break;
                case "Thickness":
                case "ZoomSliderType":
                    this.abh();
                    break;
                case "ZoomSliderChart":
                    if (!this.vy) {
                        return;
                    }
                    this.abk(i2.typeCast(XamDataChart.$, b), i2.typeCast(XamDataChart.$, c));
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.z8(function (ad, ae) {
                        if (ad.dx) {
                            ad.l5(_this.s5 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s5, ae) : null, _this.s6 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s6, ae) : null);
                        }
                    }, true);
                    break;
                case "OverlayBrushes":
                    this.z7(function (ad, ae) { return ad.oj = _this.s7 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s7, ae) : null; });
                    break;
                case "OverlayOutlines":
                    this.z7(function (ad, ae) { return ad.oo = _this.s8 != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s8, ae) : null; });
                    break;
                case "OverlayThickness":
                    this.z7(function (ad, ae) { return ad.gm = _this.ws; });
                    break;
                case "OverlayMultiplier":
                    this.z7(function (ad, ae) { return _this.up.setMultiplier(ad, _this.wr); });
                    break;
                case "VolumeBrushes":
                    this.z9(function (ad, ae) { return ad.oj = i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s9, ae); });
                    break;
                case "VolumeOutlines":
                    this.z9(function (ad, ae) { return ad.oo = i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.ta, ae); });
                    break;
                case "VolumeThickness":
                    this.z9(function (ad, ae) { return ad.gm = _this.wu; });
                    break;
                case "IndicatorNegativeBrushes":
                    this.z6(function (ad, ae) { return _this.uk.setNegativeBrush(ad, i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s4, ae)); });
                    break;
                case "IndicatorBrushes":
                    this.z6(function (ad, ae) { return ad.oj = i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.s3, ae); });
                    break;
                case "IndicatorThickness":
                    this.z6(function (ad, ae) { return ad.gm = _this.wq; });
                    break;
                case "IndicatorDisplayTypes":
                    this.z6(function (ad, ae) { return _this.uk.setDisplayType(ad, i2.ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.um, ae)); });
                    break;
                case "IndicatorPeriod":
                    this.z6(function (ad, ae) {
                        if (_this.xg == -2147483648) {
                            return;
                        }
                        _this.uk.setPeriodOverride(ad, _this.xg);
                    });
                    break;
                case "IndicatorMultiplier":
                    this.z6(function (ad, ae) { return _this.uk.setMultiplier(ad, _this.wp); });
                    break;
                case "IndicatorSmoothingPeriod":
                    this.z6(function (ad, ae) { return _this.uk.setSmoothingPeriod(ad, _this.xj); });
                    break;
                case "IndicatorShortPeriod":
                    this.z6(function (ad, ae) { return _this.uk.setShortPeriod(ad, _this.xh); });
                    break;
                case "IndicatorLongPeriod":
                    this.z6(function (ad, ae) { return _this.uk.setLongPeriod(ad, _this.xf); });
                    break;
                case "IndicatorSignalPeriod":
                    this.z6(function (ad, ae) { return _this.uk.setSignalPeriod(ad, _this.xi); });
                    break;
                case "RangeSelectorOptions":
                    var ad = i2.typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                    if (ad != null) {
                        ad.collectionChanged = i2.delegateRemove(ad.collectionChanged, i2.runOn(this, this.aah));
                    }
                    if (this.ts != null) {
                        var ae = this.ts;
                        ae.collectionChanged = i2.delegateCombine(ae.collectionChanged, i2.runOn(this, this.aah));
                    }
                    this.aa2();
                    break;
                case "CustomIndicatorNames":
                    var af = i2.typeCast(i2.ObservableCollection$1.$.specialize(i2.String_$type), b);
                    if (af != null) {
                        af.collectionChanged = i2.delegateRemove(af.collectionChanged, i2.runOn(this, this.aad));
                    }
                    if (this.customIndicatorNames != null) {
                        var ag = this.customIndicatorNames;
                        ag.collectionChanged = i2.delegateCombine(ag.collectionChanged, i2.runOn(this, this.aad));
                    }
                    this.abc();
                    break;
                case "Legend":
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.legend = null;
                    }
                    break;
                case "Brushes":
                    this.z8(function (ah, ai) { return ah.oj = _this.n != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.n, ai) : null; }, true);
                    break;
                case "Outlines":
                    this.z8(function (ah, ai) { return ah.oo = _this.r != null ? i2.ArrayExtension.getModulus$1(i2.Brush.$, _this.r, ai) : null; }, true);
                    break;
                case "XAxisLabelVisibility":
                    if (this.st == 0 && this.zoomSliderXAxis != null) {
                        this.q3(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                    }
                    this.z2();
                    break;
                case "YAxisLabelVisibility":
                    if (this.su != 0 || this.zoomSliderAxis == null) {
                        break;
                    }
                    this.q3(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                    break;
                case "ZoomSliderXAxisMajorStroke":
                    this.zoomSliderXAxis.jb = this.abn;
                    break;
                case "ZoomSliderXAxisMajorStrokeThickness":
                    this.zoomSliderXAxis.ef = this.w1;
                    break;
                case "FinancialChartLegend":
                case "IsLegendVisible":
                    var ah_1 = this.vo && this.legend == null;
                    {
                        var ai = function (aj, ak) {
                            if (aj.isUsableInLegend) {
                                aj.legend = ah_1 ? _this.ue : null;
                            }
                        };
                        this.z8(ai, false);
                        this.z7(ai);
                    }
                    break;
                case "ZoomSliderAxis":
                    var aj = i2.typeCast(Axis.$, b);
                    if (aj != null && this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.remove(aj);
                    }
                    if (this.zoomSliderAxis != null) {
                        if (this.zoomSliderChart != null) {
                            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                            this.aaz();
                            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                        }
                        if (this.cb) {
                            this.q7(this.zoomSliderAxis);
                        }
                        this.q3(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                    }
                    break;
                case "XAxisMinimumValue":
                    this.q9(function (ak) {
                        var al = i2.typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.minimumValue = _this.wc;
                        }
                    });
                    break;
                case "XAxisMaximumValue":
                    this.q9(function (ak) {
                        var al = i2.typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.maximumValue = _this.wb;
                        }
                    });
                    break;
            }
        };
        FinancialChart.prototype.get_ai = function () {
            return 1;
        };
        Object.defineProperty(FinancialChart.prototype, "ai", {
            get: function () {
                return this.get_ai();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vx", {
            get: function () {
                return this.vh;
            },
            set: function (a) {
                var b = this.vx;
                if (a != b) {
                    this.vh = a;
                    this.j6("YAxisIsLogarithmic", b, this.vx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xl", {
            get: function () {
                return this.xd;
            },
            set: function (a) {
                var b = this.xl;
                if (a != b) {
                    this.xd = a;
                    this.j6("YAxisLogarithmBase", b, this.xl);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wx", {
            get: function () {
                return this.wj;
            },
            set: function (a) {
                var b = this.wx;
                if (a != b) {
                    this.wj = a;
                    this.j6("YAxisInterval", b, this.wx);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wz", {
            get: function () {
                return this.wl;
            },
            set: function (a) {
                var b = this.wz;
                if (a != b) {
                    this.wl = a;
                    this.j6("YAxisMinimumValue", b, this.wz);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wy", {
            get: function () {
                return this.wk;
            },
            set: function (a) {
                var b = this.wy;
                if (a != b) {
                    this.wk = a;
                    this.j6("YAxisMaximumValue", b, this.wy);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "w0", {
            get: function () {
                return this.wm;
            },
            set: function (a) {
                var b = this.w0;
                if (a != b) {
                    this.wm = a;
                    this.j6("YAxisMinorInterval", b, this.w0);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ww", {
            get: function () {
                return this.yAxis.kv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wv", {
            get: function () {
                return this.yAxis.ku;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "t1", {
            get: function () {
                return this.tz;
            },
            set: function (a) {
                var b = this.t1;
                if (a != b) {
                    this.tz = a;
                    this.j6("VolumeType", i2.enumGetBox(FinancialChartVolumeType_$type, b), i2.enumGetBox(FinancialChartVolumeType_$type, this.t1));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "t3", {
            get: function () {
                return this.t2;
            },
            set: function (a) {
                var b = this.t3;
                if (a != b) {
                    this.t2 = a;
                    this.j6("XAxisMode", i2.enumGetBox(FinancialChartXAxisMode_$type, b), i2.enumGetBox(FinancialChartXAxisMode_$type, this.t3));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "t5", {
            get: function () {
                return this.t4;
            },
            set: function (a) {
                var b = this.t5;
                if (a != b) {
                    this.t4 = a;
                    this.j6("YAxisMode", i2.enumGetBox(FinancialChartYAxisMode_$type, b), i2.enumGetBox(FinancialChartYAxisMode_$type, this.t5));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vs", {
            get: function () {
                return this.ve;
            },
            set: function (a) {
                var b = this.vs;
                if (a != b) {
                    this.ve = a;
                    this.j6("IsToolbarVisible", b, this.vs);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "tw", {
            get: function () {
                return this.tv;
            },
            set: function (a) {
                var b = this.tw;
                if (a != b) {
                    this.tv = a;
                    this.j6("ChartType", i2.enumGetBox(FinancialChartType_$type, b), i2.enumGetBox(FinancialChartType_$type, this.tw));
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.get_ro = function () {
            return _super.prototype.get_ro.call(this);
        };
        FinancialChart.prototype.set_ro = function (a) {
            _super.prototype.set_ro.call(this, a);
        };
        Object.defineProperty(FinancialChart.prototype, "vt", {
            get: function () {
                return this.vf;
            },
            set: function (a) {
                var b = this.vt;
                if (a != b) {
                    this.vf = a;
                    this.j6("IsWindowSyncedToVisibleRange", b, this.vt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ua", {
            get: function () {
                return this.t9;
            },
            set: function (a) {
                var b = this.ua;
                if (a != b) {
                    this.t9 = a;
                    this.j6("IndicatorTypes", b, this.ua);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "uc", {
            get: function () {
                return this.ub;
            },
            set: function (a) {
                var b = this.uc;
                if (a != b) {
                    this.ub = a;
                    this.j6("OverlayTypes", b, this.uc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
            get: function () {
                return this.v2;
            },
            set: function (a) {
                var b = this.indicatorCharts;
                if (a != b) {
                    this.v2 = a;
                    this.j6("IndicatorCharts", b, this.indicatorCharts);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vw", {
            get: function () {
                return this.vg;
            },
            set: function (a) {
                var b = this.vw;
                if (a != b) {
                    this.vg = a;
                    this.j6("YAxisAbbreviateLargeNumbers", b, this.vw);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.get_ej = function () {
            return _super.prototype.get_ej.call(this);
        };
        FinancialChart.prototype.set_ej = function (a) {
            _super.prototype.set_ej.call(this, a);
        };
        Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
            get: function () {
                return this.u8;
            },
            set: function (a) {
                var b = this.zoomSliderChart;
                if (a != b) {
                    this.u8 = a;
                    this.j6("ZoomSliderChart", b, this.zoomSliderChart);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
            get: function () {
                return this.ut;
            },
            set: function (a) {
                var b = this.zoomSliderAxis;
                if (a != b) {
                    this.ut = a;
                    this.j6("ZoomSliderAxis", b, this.zoomSliderAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
            get: function () {
                return this.te;
            },
            set: function (a) {
                var b = this.zoomSliderXAxis;
                if (a != b) {
                    this.te = a;
                    this.j6("ZoomSliderXAxis", b, this.zoomSliderXAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "t8", {
            get: function () {
                return this.t6;
            },
            set: function (a) {
                var b = this.t8;
                if (a != b) {
                    this.t6 = a;
                    this.j6("ZoomSliderType", i2.enumGetBox(FinancialChartZoomSliderType_$type, b), i2.enumGetBox(FinancialChartZoomSliderType_$type, this.t8));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s5", {
            get: function () {
                return this.sx;
            },
            set: function (a) {
                var b = this.s5;
                if (a != b) {
                    this.sx = a;
                    this.j6("NegativeBrushes", b, this.s5);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s6", {
            get: function () {
                return this.sy;
            },
            set: function (a) {
                var b = this.s6;
                if (a != b) {
                    this.sy = a;
                    this.j6("NegativeOutlines", b, this.s6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s7", {
            get: function () {
                return this.sz;
            },
            set: function (a) {
                var b = this.s7;
                if (a != b) {
                    this.sz = a;
                    this.j6("OverlayBrushes", b, this.s7);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s8", {
            get: function () {
                return this.s0;
            },
            set: function (a) {
                var b = this.s8;
                if (a != b) {
                    this.s0 = a;
                    this.j6("OverlayOutlines", b, this.s8);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ta", {
            get: function () {
                return this.s2;
            },
            set: function (a) {
                var b = this.ta;
                if (a != b) {
                    this.s2 = a;
                    this.j6("VolumeOutlines", b, this.ta);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s9", {
            get: function () {
                return this.s1;
            },
            set: function (a) {
                var b = this.s9;
                if (a != b) {
                    this.s1 = a;
                    this.j6("VolumeBrushes", b, this.s9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s4", {
            get: function () {
                return this.sw;
            },
            set: function (a) {
                var b = this.s4;
                if (a != b) {
                    this.sw = a;
                    this.j6("IndicatorNegativeBrushes", b, this.s4);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "s3", {
            get: function () {
                return this.sv;
            },
            set: function (a) {
                var b = this.s3;
                if (a != b) {
                    this.sv = a;
                    this.j6("IndicatorBrushes", b, this.s3);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wu", {
            get: function () {
                return this.wi;
            },
            set: function (a) {
                var b = this.wu;
                if (a != b) {
                    this.wi = a;
                    this.j6("VolumeThickness", b, this.wu);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ws", {
            get: function () {
                return this.wg;
            },
            set: function (a) {
                var b = this.ws;
                if (a != b) {
                    this.wg = a;
                    this.j6("OverlayThickness", b, this.ws);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wr", {
            get: function () {
                return this.wf;
            },
            set: function (a) {
                var b = this.wr;
                if (a != b) {
                    this.wf = a;
                    this.j6("OverlayMultiplier", b, this.wr);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wq", {
            get: function () {
                return this.we;
            },
            set: function (a) {
                var b = this.wq;
                if (a != b) {
                    this.we = a;
                    this.j6("IndicatorThickness", b, this.wq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "um", {
            get: function () {
                return this.ul;
            },
            set: function (a) {
                var b = this.um;
                if (a != b) {
                    this.ul = a;
                    this.j6("IndicatorDisplayTypes", b, this.um);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xg", {
            get: function () {
                return this.w9;
            },
            set: function (a) {
                var b = this.xg;
                if (a != b) {
                    this.w9 = a;
                    this.j6("IndicatorPeriod", b, this.xg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wp", {
            get: function () {
                return this.wd;
            },
            set: function (a) {
                var b = this.wp;
                if (a != b) {
                    this.wd = a;
                    this.j6("IndicatorMultiplier", b, this.wp);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xj", {
            get: function () {
                return this.xc;
            },
            set: function (a) {
                var b = this.xj;
                if (a != b) {
                    this.xc = a;
                    this.j6("IndicatorSmoothingPeriod", b, this.xj);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xh", {
            get: function () {
                return this.xa;
            },
            set: function (a) {
                var b = this.xh;
                if (a != b) {
                    this.xa = a;
                    this.j6("IndicatorShortPeriod", b, this.xh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xf", {
            get: function () {
                return this.w8;
            },
            set: function (a) {
                var b = this.xf;
                if (a != b) {
                    this.w8 = a;
                    this.j6("IndicatorLongPeriod", b, this.xf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xi", {
            get: function () {
                return this.xb;
            },
            set: function (a) {
                var b = this.xi;
                if (a != b) {
                    this.xb = a;
                    this.j6("IndicatorSignalPeriod", b, this.xi);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ts", {
            get: function () {
                return this.tq;
            },
            set: function (a) {
                var b = this.ts;
                if (a != b) {
                    this.tq = a;
                    this.j6("RangeSelectorOptions", b, this.ts);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
            get: function () {
                return this.tm;
            },
            set: function (a) {
                var b = this.tm;
                if (a != b) {
                    this.tm = a;
                    this.j6("CustomIndicatorNames", b, this.customIndicatorNames);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.prototype.get_ct = function () {
            return _super.prototype.get_ct.call(this);
        };
        FinancialChart.prototype.set_ct = function (a) {
            _super.prototype.set_ct.call(this, a);
        };
        Object.defineProperty(FinancialChart.prototype, "abn", {
            get: function () {
                return this.abm;
            },
            set: function (a) {
                var b = this.abn;
                if (a != b) {
                    this.abm = a;
                    this.j6("ZoomSliderXAxisMajorStroke", b, this.abn);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "w1", {
            get: function () {
                return this.wn;
            },
            set: function (a) {
                var b = this.w1;
                if (a != b) {
                    this.wn = a;
                    this.j6("ZoomSliderXAxisMajorStrokeThickness", b, this.w1);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "vo", {
            get: function () {
                return this.vd;
            },
            set: function (a) {
                var b = this.vo;
                if (a != b) {
                    this.vd = a;
                    this.j6("IsLegendVisible", b, this.vo);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "ue", {
            get: function () {
                return this.ud;
            },
            set: function (a) {
                var b = this.ue;
                if (a != b) {
                    this.ud = a;
                    this.j6("FinancialChartLegend", b, this.ue);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xAxis", {
            get: function () {
                return this.td;
            },
            set: function (a) {
                var b = this.xAxis;
                if (a != b) {
                    this.td = a;
                    this.j6("XAxis", b, this.xAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "yAxis", {
            get: function () {
                return this.us;
            },
            set: function (a) {
                var b = this.yAxis;
                if (a != b) {
                    this.us = a;
                    this.j6("YAxis", b, this.yAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
            get: function () {
                return this.ur;
            },
            set: function (a) {
                var b = this.volumeAxis;
                if (a != b) {
                    this.ur = a;
                    this.j6("VolumeAxis", b, this.volumeAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
            get: function () {
                return this.tc;
            },
            set: function (a) {
                var b = this.volumeXAxis;
                if (a != b) {
                    this.tc = a;
                    this.j6("VolumeXAxis", b, this.volumeXAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
            get: function () {
                return this.uq;
            },
            set: function (a) {
                var b = this.indicatorAxis;
                if (a != b) {
                    this.uq = a;
                    this.j6("IndicatorAxis", b, this.indicatorAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
            get: function () {
                return this.tb;
            },
            set: function (a) {
                var b = this.indicatorXAxis;
                if (a != b) {
                    this.tb = a;
                    this.j6("IndicatorXAxis", b, this.indicatorXAxis);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "v4", {
            get: function () {
                return this.v1;
            },
            set: function (a) {
                var b = this.v4;
                if (a != b) {
                    this.v1 = a;
                    this.j6("IndicatorAxes", b, this.v4);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "v6", {
            get: function () {
                return this.v3;
            },
            set: function (a) {
                var b = this.v6;
                if (a != b) {
                    this.v3 = a;
                    this.j6("IndicatorXAxes", b, this.v6);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wc", {
            get: function () {
                return this.wa;
            },
            set: function (a) {
                var b = this.wc;
                if (+a != +b) {
                    this.wa = a;
                    this.j6("XAxisMinimumValue", b, this.wc);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "wb", {
            get: function () {
                return this.v9;
            },
            set: function (a) {
                var b = this.wb;
                if (+a != +b) {
                    this.v9 = a;
                    this.j6("XAxisMaximumValue", b, this.wb);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
            get: function () {
                return this.v7;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChart.$t = i2.markType(FinancialChart, 'FinancialChart', XYChart.$);
        FinancialChart.xk = 0;
        return FinancialChart;
    }(XYChart));
    /**
     * @hidden
     */
    var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartToolbar, _super);
        function FinancialChartToolbar(a, b) {
            var _this = _super.call(this, "financialChartToolbar", b, "") || this;
            _this.o = null;
            _this.r = null;
            _this.z = null;
            _this.p = null;
            _this.w = null;
            _this.aq = i2.dateMaxValue();
            _this.ap = i2.dateMinValue();
            _this.ao = i2.dateMaxValue();
            _this.an = i2.dateMinValue();
            _this.rangeChanged = null;
            _this.chartTypeChanged = null;
            _this.trendLineTypeChanged = null;
            _this.volumeTypeChanged = null;
            _this.indicatorTypesChanged = null;
            _this.overlayTypesChanged = null;
            _this.x = 0;
            _this.ah = 0;
            _this.ab = 0;
            _this.ad = null;
            _this.af = null;
            _this.t = null;
            _this.ak = false;
            _this.o = a;
            _this.w = new FinancialChartToolbarViewModel();
            _this.s = new FinancialChartRangeSelector(a != null ? a.xw : null);
            _this.aa = new FinancialChartTypePicker(a != null ? a.xt : null);
            _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.xu : null);
            return _this;
        }
        FinancialChartToolbar.prototype.bg = function (a) {
            var b = a.querySelectorAll(".financialChartToolbarArea");
            if (b != null && b.length > 0) {
                this.g = b[0];
                if (!this.al) {
                    this.g.hide();
                }
            }
            var c = a.querySelectorAll(".financialChartIndicatorMenu");
            if (c != null && c.length > 0) {
                this.q.g = c[0];
            }
            var d = a.querySelectorAll(".financialChartRangeSelector");
            if (d != null && d.length > 0) {
                this.s.g = d[0];
            }
            var e = a.querySelectorAll(".financialChartTypePicker");
            if (e != null && e.length > 0) {
                this.aa.g = e[0];
            }
        };
        FinancialChartToolbar.prototype.bl = function (a) {
            this.q.u(a);
            this.aa.u(a);
        };
        Object.defineProperty(FinancialChartToolbar.prototype, "s", {
            get: function () {
                return this.r;
            },
            set: function (a) {
                var b = this.s;
                if (a != b) {
                    this.r = a;
                    this.bm("RangeSelector", b, this.s);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
            get: function () {
                return this.z;
            },
            set: function (a) {
                var b = this.aa;
                if (a != b) {
                    this.z = a;
                    this.bm("ChartTypePicker", b, this.aa);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "q", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                var b = this.q;
                if (a != b) {
                    this.p = a;
                    this.bm("IndicatorMenu", b, this.q);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbar.prototype.bm = function (a, b, c) {
            switch (a) {
                case "RangeStart":
                    if (this.s != null) {
                        this.s.t = this.as;
                    }
                    break;
                case "RangeEnd":
                    if (this.s != null) {
                        this.s.s = this.ar;
                    }
                    break;
                case "SelectionStart":
                    if (this.s != null) {
                        this.s.v = this.au;
                    }
                    break;
                case "SelectionEnd":
                    if (this.s != null) {
                        this.s.u = this.at;
                    }
                    break;
                case "RangeSelector":
                    var d = b;
                    if (d != null) {
                        d.rangeChanged = i2.delegateRemove(d.rangeChanged, i2.runOn(this, this.bj));
                    }
                    if (this.s != null) {
                        this.s.t = this.as;
                        this.s.s = this.ar;
                        this.s.o = this.u;
                        this.s.v = this.au;
                        this.s.u = this.at;
                        var e = this.s;
                        e.rangeChanged = i2.delegateCombine(e.rangeChanged, i2.runOn(this, this.bj));
                    }
                    break;
                case "ChartTypePicker":
                    var f = b;
                    if (f != null) {
                        f.selectionChanged = i2.delegateRemove(f.selectionChanged, i2.runOn(this, this.bi));
                    }
                    if (this.aa != null) {
                        this.aa.w = this.y;
                        var g = this.aa;
                        g.selectionChanged = i2.delegateCombine(g.selectionChanged, i2.runOn(this, this.bi));
                    }
                    break;
                case "ChartType":
                    if (this.aa != null) {
                        this.aa.w = this.y;
                    }
                    break;
                case "RangeSelectorOptions":
                    if (this.s != null) {
                        this.s.o = this.u;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.g == null) {
                        break;
                    }
                    if (this.al) {
                        this.g.show();
                    }
                    else {
                        this.g.hide();
                    }
                    break;
                case "IndicatorMenu":
                    var h = i2.typeCast(FinancialChartIndicatorMenu.$, b);
                    if (h != null) {
                        h.selectionChanged = i2.delegateRemove(h.selectionChanged, i2.runOn(this, this.bh));
                    }
                    if (this.q != null) {
                        var i = this.q;
                        i.selectionChanged = i2.delegateCombine(i.selectionChanged, i2.runOn(this, this.bh));
                    }
                    break;
                case "IndicatorTypes":
                    if (this.indicatorTypesChanged != null) {
                        this.indicatorTypesChanged(this, i2.EventArgs.empty);
                    }
                    break;
                case "OverlayTypes":
                    if (this.overlayTypesChanged != null) {
                        this.overlayTypesChanged(this, i2.EventArgs.empty);
                    }
                    break;
                case "TrendLineType":
                    if (this.trendLineTypeChanged != null) {
                        this.trendLineTypeChanged(this, i2.EventArgs.empty);
                    }
                    break;
                case "VolumeType":
                    if (this.volumeTypeChanged != null) {
                        this.volumeTypeChanged(this, i2.EventArgs.empty);
                    }
                    break;
            }
        };
        FinancialChartToolbar.prototype.bh = function (a, b) {
            this.ag = this.q.z;
            this.ae = this.q.y;
            this.ai = this.q.aa;
            this.ac = this.q.x;
        };
        FinancialChartToolbar.prototype.bi = function (a, b) {
            this.y = this.aa.w;
            if (this.chartTypeChanged != null) {
                this.chartTypeChanged(this, b);
            }
        };
        FinancialChartToolbar.prototype.bj = function (a, b) {
            this.au = this.s.v;
            this.at = this.s.u;
            if (this.rangeChanged != null) {
                this.rangeChanged(this, b);
            }
        };
        FinancialChartToolbar.prototype.v = function () {
            var _this = this;
            var a = new FinancialChartToolbarContext();
            a.container = this.d;
            a.vm = this.w;
            a.vm.financialChartIndicatorMenu = ((function () {
                var $ret = new FinancialChartIndicatorMenuContext();
                $ret.vm = _this.q.p;
                return $ret;
            })());
            a.vm.financialChartTypePicker = ((function () {
                var $ret = new FinancialChartTypePickerContext();
                $ret.vm = _this.aa.p;
                return $ret;
            })());
            a.vm.financialChartRangeSelector = ((function () {
                var $ret = new FinancialChartRangeSelectorContext();
                $ret.vm = _this.s.q;
                return $ret;
            })());
            return a;
        };
        FinancialChartToolbar.prototype.l = function (a) {
            _super.prototype.l.call(this, a);
            if (a == null) {
                return;
            }
            this.s.l(a);
            this.aa.l(a);
            this.q.l(a);
            this.bk();
        };
        FinancialChartToolbar.prototype.bk = function () {
        };
        Object.defineProperty(FinancialChartToolbar.prototype, "au", {
            get: function () {
                return this.aq;
            },
            set: function (a) {
                var b = this.au;
                if (+a != +b) {
                    this.aq = a;
                    this.bm("SelectionStart", b, this.au);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "at", {
            get: function () {
                return this.ap;
            },
            set: function (a) {
                var b = this.at;
                if (+a != +b) {
                    this.ap = a;
                    this.bm("SelectionEnd", b, this.at);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "as", {
            get: function () {
                return this.ao;
            },
            set: function (a) {
                var b = this.as;
                if (+a != +b) {
                    this.ao = a;
                    this.bm("RangeStart", b, this.as);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
            get: function () {
                return this.an;
            },
            set: function (a) {
                var b = this.ar;
                if (+a != +b) {
                    this.an = a;
                    this.bm("RangeEnd", b, this.ar);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbar.prototype.bn = function () {
            if (this.s != null) {
                this.s.ab();
            }
        };
        Object.defineProperty(FinancialChartToolbar.prototype, "y", {
            get: function () {
                return this.x;
            },
            set: function (a) {
                var b = this.y;
                if (a != b) {
                    this.x = a;
                    this.bm("ChartType", i2.enumGetBox(FinancialChartType_$type, b), i2.enumGetBox(FinancialChartType_$type, this.y));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
            get: function () {
                return this.ah;
            },
            set: function (a) {
                var b = this.ai;
                if (a != b) {
                    this.ah = a;
                    this.bm("TrendLineType", i2.enumGetBox(i2.TrendLineType_$type, b), i2.enumGetBox(i2.TrendLineType_$type, this.ai));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
            get: function () {
                return this.ab;
            },
            set: function (a) {
                var b = this.ac;
                if (a != b) {
                    this.ab = a;
                    this.bm("VolumeType", i2.enumGetBox(FinancialChartVolumeType_$type, b), i2.enumGetBox(FinancialChartVolumeType_$type, this.ac));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
            get: function () {
                return this.ad;
            },
            set: function (a) {
                var b = this.ae;
                if (!FinancialChartToolbar.am(b, a)) {
                    this.ad = a;
                    this.bm("IndicatorTypes", b, this.ae);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
            get: function () {
                return this.af;
            },
            set: function (a) {
                var b = this.ag;
                if (!FinancialChartToolbar.am(b, a)) {
                    this.af = a;
                    this.bm("OverlayTypes", b, this.ag);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbar.am = function (a, b) {
            var e_21, _a;
            if (a == b) {
                return true;
            }
            if ((a == null && b != null) || (a != null && b == null)) {
                return false;
            }
            if (a.count != b.count) {
                return false;
            }
            try {
                for (var _b = tslib.__values(i2.fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (!b.contains(c)) {
                        return false;
                    }
                }
            }
            catch (e_21_1) {
                e_21 = { error: e_21_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_21)
                        throw e_21.error;
                }
            }
            return true;
        };
        FinancialChartToolbar.prototype.aj = function () {
            var _this = this;
            return ((function () {
                var $ret = new FinancialChartToolbarVisualData();
                $ret.rangeSelector = _this.s == null ? null : _this.s.r();
                return $ret;
            })());
        };
        Object.defineProperty(FinancialChartToolbar.prototype, "u", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                var b = this.u;
                if (a != b) {
                    this.t = a;
                    this.bm("RangeSelectorOptions", b, this.u);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartToolbar.prototype, "al", {
            get: function () {
                return this.ak;
            },
            set: function (a) {
                var b = this.al;
                if (a != b) {
                    this.ak = a;
                    this.bm("IsToolbarVisible", b, this.al);
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartToolbar.$t = i2.markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
        return FinancialChartToolbar;
    }(TemplatedHtmlControl));
    /**
     * @hidden
     */
    var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartRangeSelector, _super);
        function FinancialChartRangeSelector(a) {
            var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
            _this.q = null;
            _this.rangeChanged = null;
            _this.p = null;
            _this.p = new FinancialChartRangeSelectorView();
            _this.q = new FinancialChartRangeSelectorViewModel();
            _this.q.onRangeChanged = i2.runOn(_this, _this.z);
            _this.p.c = _this.q;
            return _this;
        }
        Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
            get: function () {
                return this.q.selectionStart;
            },
            set: function (a) {
                this.q.selectionStart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
            get: function () {
                return this.q.selectionEnd;
            },
            set: function (a) {
                this.q.selectionEnd = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
            get: function () {
                return this.q.rangeStart;
            },
            set: function (a) {
                this.q.rangeStart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
            get: function () {
                return this.q.rangeEnd;
            },
            set: function (a) {
                this.q.rangeEnd = a;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelector.prototype.ab = function () {
            if (this.q.onPropertiesChanged()) {
                this.p.g(this.q);
            }
        };
        FinancialChartRangeSelector.prototype.l = function (a) {
            _super.prototype.l.call(this, a);
            this.p.f(this.d, this.q);
        };
        FinancialChartRangeSelector.prototype.z = function () {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, i2.EventArgs.empty);
            }
        };
        FinancialChartRangeSelector.prototype.r = function () {
            return this.p.d(this.g);
        };
        Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
            get: function () {
                return this.q.options;
            },
            set: function (a) {
                var b = !FinancialChartToolbar.am(this.q.options, a);
                if (b) {
                    this.q.options = a;
                    this.aa();
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartRangeSelector.prototype.aa = function () {
            if (this.q != null) {
                this.q.ao();
            }
            if (this.p != null) {
                this.p.i(this.o);
            }
        };
        FinancialChartRangeSelector.$t = i2.markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
        FinancialChartRangeSelector.x = 0;
        return FinancialChartRangeSelector;
    }(TemplatedHtmlControl));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialChartDefaultTemplatesComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialChartDefaultTemplatesComponent(_changeDetectorRef) {
            this._changeDetectorRef = _changeDetectorRef;
            this.onContentReady = new i0.EventEmitter();
        }
        IgxFinancialChartDefaultTemplatesComponent.prototype.getSelection = function (ele) {
            var ret = [];
            for (var i = 0; i < ele.options.length; i++) {
                if (ele.options[i].selected) {
                    ret.push(ele.options[i].value);
                }
            }
            return ret;
        };
        IgxFinancialChartDefaultTemplatesComponent.register = function () {
            i2.TypeRegistrar.registerCons("IgxFinancialChartDefaultTemplatesComponent", IgxFinancialChartDefaultTemplatesComponent);
        };
        IgxFinancialChartDefaultTemplatesComponent.prototype.ngAfterContentInit = function () {
            this.onContentReady.emit({});
        };
        IgxFinancialChartDefaultTemplatesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartDefaultTemplatesComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialChartDefaultTemplatesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialChartDefaultTemplatesComponent, selector: "igx-financial-chart-default-templates", outputs: { onContentReady: "onContentReady" }, viewQueries: [{ propertyName: "financialChartRangeSelectorTemplate", first: true, predicate: ["financialChartRangeSelectorTemplate"], descendants: true, static: true }, { propertyName: "financialChartTypePickerTemplate", first: true, predicate: ["financialChartTypePickerTemplate"], descendants: true, static: true }, { propertyName: "financialChartIndicatorMenuTemplate", first: true, predicate: ["financialChartIndicatorMenuTemplate"], descendants: true, static: true }, { propertyName: "financialChartToolbarTemplate", first: true, predicate: ["financialChartToolbarTemplate"], descendants: true, static: true }], ngImport: i0, template: "\n    <ng-template #financialChartRangeSelectorTemplate let-vm=\"vm\">\n        <div class='financialChartRangeSelector'>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorOneMonth' *ngIf=\"vm.oneMonthVisible\">\n\t\t    \t<input type='radio' value='1m' [checked]=\"vm.oneMonthChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_OneMonth}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorThreeMonths' *ngIf=\"vm.threeMonthsVisible\">\n\t\t    \t<input type='radio' value='3m' [checked]=\"vm.threeMonthsChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_ThreeMonths}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorSixMonths' *ngIf=\"vm.sixMonthsVisible\">\n\t\t    \t<input type='radio' value='6m' [checked]=\"vm.sixMonthsChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_SixMonths}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorYTD' *ngIf=\"vm.yearToDateVisible\">\n\t\t    \t<input type='radio' value='YTD' [checked]=\"vm.yearToDateChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_YearToDate}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorOneYear' *ngIf=\"vm.oneYearVisible\">\n\t\t    \t<input type='radio' value='1y' [checked]=\"vm.oneYearChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_OneYear}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorAll' *ngIf=\"vm.allVisible\">\n\t\t    \t<input type='radio' value='all' [checked]=\"vm.allChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_All}}</span>\n\t\t    </label>\n\t    </div>\n    </ng-template>\n\n    <ng-template #financialChartTypePickerTemplate let-vm=\"vm\">\n        <button class='financialChartTypePickerDropDownButton' (click)=\"vm.onButtonPressed()\" [attr.data-value]=\"vm.chartTypeString\">\n\t    \t<span class='ui-icon ui-icon-changeable'></span>\n\t    \t<span class='ui-icon-toolbar-dd'></span>\n\t    </button>\n\n\t    <div class='financialChartTypePickerDropDownMenu' [style.display]=\"vm.isOpen ? 'block' : 'none'\"\n            (click)=\"vm.handleDropDownClick($event)\">\n\t    \t<ul>\n\t    \t\t<li class='financialChartListItem' data-value='Auto'>\n\t    \t\t    <span class='ui-icon ui-icon-chartAuto'></span>\n\t    \t\t    <span>Auto</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Bar'>\n\t    \t\t\t<span class='ui-icon ui-icon-BarIcon'></span>\n\t    \t\t\t<span>Bar</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Line'>\n\t    \t\t\t<span class='ui-icon ui-icon-LineIcon'></span>\n\t    \t\t\t<span>Line</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Candle'>\n\t    \t\t\t<span class='ui-icon ui-icon-CandleIcon'></span>\n\t    \t\t\t<span>Candle</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Column'>\n\t    \t\t\t<span class='ui-icon ui-icon-ColumnIcon'></span>\n\t    \t\t\t<span>Column</span>\n\t    \t\t</li>\n\t    \t</ul>\n\t    </div>\n    </ng-template>\n\n    <ng-template #financialChartIndicatorMenuTemplate let-vm=\"vm\">\n        <button class='financialChartIndicatorMenuDropDownButton' (click)=\"vm.onButtonPressed()\">\n\t    \t<div class='ui-ChartButtonWrapper'>\n\t    \t\t<span class='ui-icon ui-icon-IndicatorsIcon'></span>\n\t    \t\t<span class='financialChartIndicatorMenuLabel'>{{vm.financialChart_IndicatorMenu_Header}}</span>\n\t    \t\t<span class='ui-icon-toolbar-dd'></span>\n\t    \t</div>\n        </button>\n\n\t    <div class='financialChartIndicatorMenuDropDownMenu' [style.display]=\"vm.isOpen ? 'block' : 'none'\" (click)=\"vm.handleDropDownClick($event)\">\n\t    \t<ul class='financialChartIndicatorMenuDropDownMenuList'>\n\t\t\t<li data-value='FinancialOverlayType'>\n\t\t\t\t<span>{{vm.financialChart_IndicatorMenu_OverlaysCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='BollingerBands'>{{vm.financialChart_IndicatorsMenu_Overlay_BollingerBands}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PriceChannel'>{{vm.financialChart_IndicatorsMenu_Overlay_PriceChannel}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t\t<li data-value='TrendLineType'>\n\t\t\t\t<span>{{vm.financialChart_IndicatorMenu_TrendlinesCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='LinearFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_LinearFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='QuadraticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuadraticFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='CubicFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_CubicFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='QuarticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuarticFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='QuinticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuinticFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='LogarithmicFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_LogarithmicFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ExponentialFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_ExponentialFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PowerLawFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_PowerLawFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='SimpleAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_SimpleAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ExponentialAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_ExponentialAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ModifiedAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_ModifiedAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='CumulativeAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_CumulativeAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='WeightedAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_WeightedAverage}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t\t<li data-value='FinancialChartVolumeType'><span>{{vm.financialChart_IndicatorMenu_VolumeCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='Column'>{{vm.financialChart_IndicatorsMenu_Volume_Column}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='Line'>{{vm.financialChart_IndicatorsMenu_Volume_Line}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='Area'>{{vm.financialChart_IndicatorsMenu_Volume_Area}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t\t<li data-value='FinancialIndicatorType'><span>{{vm.financialChart_IndicatorMenu_IndicatorsCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AbsoluteVolumeOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AccumulationDistribution'>{{vm.financialChart_IndicatorsMenu_Indicator_AccumulationDistribution}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AverageDirectionalIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AverageTrueRange'>{{vm.financialChart_IndicatorsMenu_Indicator_AverageTrueRange}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='BollingerBandWidth'>{{vm.financialChart_IndicatorsMenu_Indicator_BollingerBandWidth}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ChaikinOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_ChaikinOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ChaikinVolatility'>{{vm.financialChart_IndicatorsMenu_Indicator_ChaikinVolatility}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='CommodityChannelIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_CommodityChannelIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='DetrendedPriceOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='EaseOfMovement'>{{vm.financialChart_IndicatorsMenu_Indicator_EaseOfMovement}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='FastStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_FastStochasticOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ForceIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_ForceIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='FullStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_FullStochasticOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MarketFacilitationIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MassIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MassIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MedianPrice'>{{vm.financialChart_IndicatorsMenu_Indicator_MedianPrice}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MoneyFlowIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MoneyFlowIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MovingAverageConvergenceDivergence'>{{vm.financialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='NegativeVolumeIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='OnBalanceVolume'>{{vm.financialChart_IndicatorsMenu_Indicator_OnBalanceVolume}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PercentagePriceOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PercentageVolumeOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PositiveVolumeIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PriceVolumeTrend'>{{vm.financialChart_IndicatorsMenu_Indicator_PriceVolumeTrend}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='RateOfChangeAndMomentum'>{{vm.financialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='RelativeStrengthIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='SlowStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='StandardDeviation'>{{vm.financialChart_IndicatorsMenu_Indicator_StandardDeviation}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='StochRSI'>{{vm.financialChart_IndicatorsMenu_Indicator_StochRSI}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='TRIX'>{{vm.financialChart_IndicatorsMenu_Indicator_TRIX}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='TypicalPrice'>{{vm.financialChart_IndicatorsMenu_Indicator_TypicalPrice}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='UltimateOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_UltimateOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='WeightedClose'>{{vm.financialChart_IndicatorsMenu_Indicator_WeightedClose}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='WilliamsPercentR'>{{vm.financialChart_IndicatorsMenu_Indicator_WilliamsPercentR}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t</ul>\n\t    </div>\n    </ng-template>\n\n    <ng-template #financialChartToolbarTemplate let-vm=\"vm\">\n        <ng-template #defaultTemplate>\n            <div></div>\n        </ng-template>\n\n        <div class='financialChartToolbar'>\n            <div class='financialChartToolbar'>\n                <div class='financialChartIndicatorMenu' *ngIf='vm.isIndicatorMenuVisible'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartIndicatorMenu.template ? vm.financialChartIndicatorMenu.template : defaultTemplate; context: vm.financialChartIndicatorMenu\">\n                    </ng-container>\n                </div>\n                <div class='financialChartRangeSelector'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartRangeSelector.template ? vm.financialChartRangeSelector.template : defaultTemplate; context: vm.financialChartRangeSelector\">\n                    </ng-container>\n                </div>\n                <div class='financialChartTypePicker'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartTypePicker.template ? vm.financialChartTypePicker.template : defaultTemplate; context: vm.financialChartTypePicker\">\n                    </ng-container>\n                </div>\n            </div>\n        </div>\n    </ng-template>\n  ", isInline: true, styles: ["\n.ui-financialchart-container {\n    font-family: \"Segoe UI\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-font-family, \"Segoe UI\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-font-size, 12px);\n    border-width: 0;\n    -webkit-tap-highlight-color: rgba(0,0,0,0);\n    -webkit-tap-highlight-color: var(--financial-highlight-color, rgba(0,0,0,0));\n}\n\n.ui-financialchart-mainChart {\n    margin-left: 15px;\n    margin-left: var(--financial-pane-margin-left, 15px);\n}\n\n.ui-financialchart-volumeChart {\n    margin-left: 15px;\n    margin-left: var(--financial-pane-margin-left, 15px);\n}\n\n.financialChartMainGrid {\n    height: 100%;\n    width: 100%;\n    display: grid;\n    display: -ms-grid;\n    -ms-grid-columns: 100%;\n}\n\n.financialChartPrice {\n    grid-row: 3;\n    -ms-grid-row: 3;\n    margin-top: 10px;\n    margin-top: var(--financial-pane-margin-top, 10px);\n}\n.financialChartPrice, .financialChartPrice > div {\n    min-height: 100px;\n}\n.financialChartIndicators {\n    grid-row: 4;\n    -ms-grid-row: 4;\n}\n.financialChartVolume {\n    grid-row: 5;\n    -ms-grid-row: 5;\n}\n.financialChartZoomSlider {\n    grid-row: 6;\n    -ms-grid-row: 6;\n}\n\n/*\n/////////////////////\n*/\n/* Toolbar styles */\n/*\n/////////////////////\n*/\n\n.financialChartToolbar {\n    display: grid;\n    display: -ms-grid;\n    grid-row: 1;\n    -ms-grid-rows: 100%;\n    -ms-grid-row: 1;\n    -ms-grid-columns: 100%;\n    font-family: \"Verdana\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-font-family, \"Verdana\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-font-size, 12px);\n}\n\n/* scrollbar styles */\n.financialChartToolbar ::-webkit-scrollbar\n{\n    width: 14px;\n    width: var(--financial-toolbar-scrollbar-width, 14px);\n    background-color: #eee;\n    background-color: var(--financial-toolbar-scrollbar-background, #eee);\n}\n.financialChartToolbar ::-webkit-scrollbar-track\n{\n    border-radius: 1px;\n    border-radius: var(--financial-toolbar-scrollbar-track-radius, 1px);\n    background-color: #eee;\n    background-color: var(--financial-toolbar-scrollbar-track-background, #eee);\n    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);\n    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-track-shadow-radius, 6px) var(--financial-toolbar-scrollbar-track-shadow-color, rgba(0,0,0,0.3));\n}\n.financialChartToolbar ::-webkit-scrollbar-thumb\n{\n    border-radius: 1px;\n    border-radius: var(--financial-toolbar-scrollbar-thumb-radius, 1px);\n    background-color: #838383;\n    background-color: var(--financial-toolbar-scrollbar-thumb-background, #838383);\n    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,.3);\n    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-thumb-shadow-radius, 6px) var(--financial-toolbar-scrollbar-thumb-shadow-color, rgba(0,0,0,0.3));\n}\n\n.financialChartToolbar .financialChartToolbar {\n    display: flex;\n    display: -ms-flexbox;\n    align-items: center;\n    border: 1px solid #dadada;\n    border: var(--financial-toolbar-border-thickness, 1px) solid var(--financial-toolbar-border-color, #dadada);\n    color: black;\n    color: var(--financial-toolbar-text-color, black);\n    max-height: 45px;\n    max-height: var(--financial-toolbar-max-height, 45px);\n    background: #eeeeee;\n    background: var(--financial-toolbar-background, #eeeeee);\n}\n\n.financialChartToolbar,\n.financialChartToolbar button {\n    font: 400 13px \"Segoe UI\", Arial, sans-serif!important;\n    font: var(--financial-toolbar-range-button-font, 400 13px \"Segoe UI\", Arial, sans-serif!important);\n}\n\n.financialChartRangeSelector {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    text-transform: uppercase;\n    height: 100%;\n}\n\n.financialChartRangeSelector input {\n    display: none;\n}\n\n.financialChartRangeSelectorLabel {\n    cursor: pointer;\n    height: 100%;\n}\n.financialChartRangeSelectorLabel:hover .financialChartRangeSelectorLabelSpan {\n    color: #4897AA;\n    color: var(--financial-toolbar-range-button-hover-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-range-button-hover-background, transparent);\n}\n\n.financialChartRangeSelectorLabel input:checked + span {\n    color: #444444;\n    color: var(--financial-toolbar-range-button-check-color, #444444);\n    background-color: #dadada;\n    background-color: var(--financial-toolbar-range-button-check-background, #dadada);\n}\n\n.financialChartRangeSelectorLabelSpan {\n    height: 100%;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    padding: 10px;\n    padding: var(--financial-toolbar-range-button-padding, 10px);\n    box-sizing: border-box;\n}\n\n.financialChartRangeSelectorLastOption {\n    border: none;\n    padding-right: 0;\n    padding-right: var(--financial-toolbar-range-button-padding-right, 0px);\n}\n\n.financialChartIndicatorMenu,\n.financialChartTypePicker {\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.financialChartTypePicker {\n    margin-left: auto;\n    height: 100%;\n    border-left: 1px solid #dadada;\n    border-left: var(--financial-toolbar-border-thickness, 1px) solid\n                 var(--financial-toolbar-border-color, #dadada);\n}\n\n.financialChartIndicatorMenu {\n    height: 100%;\n    padding:0 10px;\n    border-right: 1px solid #dadada;\n    border-right: var(--financial-toolbar-border-thickness, 1px) solid\n                  var(--financial-toolbar-border-color, #dadada);\n}\n\n.financialChartIndicatorMenuDropDownMenu,\n.financialChartTypePickerDropDownMenu {\n    background: #fff;\n    background: var(--financial-toolbar-dropdown-background-color, #fff);\n    color: black;\n    color: var(--financial-toolbar-dropdown-text-color, black);\n    display: flex;\n    flex-direction: column;\n    z-index: 1;\n    position: absolute;\n    top: calc(100% + 1px);\n    top: calc(100% + var(--financial-toolbar-dropdown-top-offset, 1px));\n    box-shadow: 0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22);\n    box-shadow: var(--financial-toolbar-dropdown-shadow,  0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22));\n    white-space: nowrap;\n    font-family: \"Verdana\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-dropdown-font-family, \"Verdana\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-dropdown-font-size, 12px);\n}\n\n.financialChartIndicatorMenuDropDownMenu {\n    left: 0;\n    min-width: 100px;\n    min-width: var(--financial-toolbar-dropdown-min-width, 100px);\n    height: 300px;\n    height: var(--financial-toolbar-dropdown-height, 300px);\n    overflow: auto;\n}\n\n.financialChartTypePickerDropDownMenu {\n    right: 0;\n}\n\n.financialChartListItem {\n    cursor: pointer;\n    cursor: var(--financial-toolbar-dropdown-item-cursor, pointer);\n}\n\n.financialChartListItem:hover,\n.financialChartListItem:focus {\n    color: #4897AA;\n    color: var(--financial-toolbar-dropdown-item-hover-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-dropdown-item-hover-background, transparent);\n}\n\n.financialChartListItem span {\n    position: relative;\n    /* TODO: figure out why we need z-index here */\n    z-index: -1;\n}\n\n.financialChartTypePickerDropDownMenu .financialChartListItem {\n    display: flex;\n    align-items: center;\n    justify-content: flex-start;\n}\n.financialChartTypePickerDropDownMenu .ui-icon {\n    margin-right: 5px;\n    margin-right: var(--financial-toolbar-icon-margin-right, 5px);\n}\n\n.financialChartIndicatorMenuDropDownButton,\n.financialChartTypePickerDropDownButton {\n    background-color: transparent;\n    background-color: var(--financial-toolbar-indicators-background-color, transparent);\n    border: none;\n    outline: none;\n    cursor: pointer;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n}\n\n.financialChartIndicatorMenuDropDownMenuList {\n    font-weight: bold;\n}\n\n.financialChartIndicatorMenuDropDownMenu li.checked,\n.financialChartTypePickerDropDownMenu li.checked {\n    color: #4897AA;\n    color: var(--financial-toolbar-dropdown-item-check-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-dropdown-item-check-background, transparent);\n}\n\n.financialChartIndicatorMenuDropDownMenu ul,\n.financialChartTypePickerDropDownMenu ul {\n    list-style-type: none;\n    margin: 0;\n    padding: 8px;\n}\n\n.financialChartIndicatorMenuDropDownMenu ul ul,\n.financialChartTypePickerDropDownMenu ul ul {\n    padding-left: 15px;\n    padding-left: var(--financial-toolbar-dropdown-list-padding-left, 15px);\n    font-weight: normal;\n}\n\n.financialChartIndicatorMenuDropDownMenu ul li,\n.financialChartTypePickerDropDownMenu ul li {\n    padding-top: 4px;\n    padding-top: var(--financial-toolbar-dropdown-list-padding-top, 4px);\n    position: relative;\n}\n\n.financialChartIndicatorMenuDropDownMenu li.checked:before{\n    margin-left: -15px;\n    margin-left:  var(--financial-toolbar-dropdown-list-margin-left, -15px);\n    margin-right: 5px;\n    margin-right: var(--financial-toolbar-dropdown-list-margin-right, 5px);\n    content: \"\\2713\";\n    position: absolute;\n}\n\n.financialChartLegend {\n    grid-row: 2;\n    -ms-grid-row: 2;\n}\n\n.ui-ChartButtonWrapper {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.financialChartTypePickerDropDownButton .ui-icon-triangle-1-s,\n.ui-ChartButtonWrapper .ui-icon-triangle-1-s {\n    font-size: 10px;\n    font-size: var(--financial-toolbar-icon-font-size, 10px);\n}\n\n.financialChartTypePickerDropDownButton {\n    background-color: transparent;\n    background-color: var(--financial-toolbar-chart-picker-background, transparent);\n    height: 100%;\n    padding: 0 10px;\n    padding: var(--financial-toolbar-chart-picker-padding, 0 10px);\n}\n\n.financialChartIndicatorMenuLabel {\n    margin: 0 5px;\n    margin: var(--financial-toolbar-indicators-label-margin, 0 5px);\n    color: inherit;\n    color: var(--financial-toolbar-indicators-label-normal-color, inherit);\n}\n\n/* Icon styles if no theme is included */\n.financialChartToolbar .ui-icon {\n    color: #888888;\n    color: var(--financial-toolbar-icon-color, #888888);\n    width: 16px;\n    width: var(--financial-toolbar-icon-width, 16px);\n    height: 16px;\n    height: var(--financial-toolbar-icon-height, 16px);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    text-indent: -99999px;\n    overflow: hidden;\n    position: relative;\n}\n.financialChartToolbar .ui-icon:before {\n    display: block;\n    height: 1em;\n    left: 50%;\n    line-height: 1;\n    margin-left: -0.5em;\n    margin-top: -0.5em;\n    position: absolute;\n    text-indent: 0;\n    top: 50%;\n    width: 1em;\n}\n\n.ui-icon-IndicatorsIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-indicators-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .ui-icon-IndicatorsIcon:before,\n.financialChartIndicatorMenuDropDownButton:focus .ui-icon-IndicatorsIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-indicators-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .financialChartIndicatorMenuLabel,\n.financialChartIndicatorMenuDropDownButton:focus .financialChartIndicatorMenuLabel {\n    color: #4897AA;\n    color: var(--financial-toolbar-indicators-label-hover-color, #4897AA);\n}\n\n.ui-icon-toolbar-dd {\n    position: relative;\n    width: 16px;\n    width: var(--financial-toolbar-dropdown-icon-width, 16px);\n    height: 16px;\n    height: var(--financial-toolbar-dropdown-icon-height, 16px);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n}\n\n.ui-icon-toolbar-dd:before {\n    content: '';\n    position: absolute;\n    width: 0;\n    height: 0;\n    border-style: solid;\n    border-width: 5px 4px 0 4px;\n    border-color: #666 transparent transparent transparent;\n    border-color: var(--financial-toolbar-dropdown-icon-normal-color, #666) transparent transparent transparent;\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .ui-icon-toolbar-dd:before,\n.financialChartIndicatorMenuDropDownButton:focus .ui-icon-toolbar-dd:before,\n.financialChartTypePickerDropDownButton:hover .ui-icon-toolbar-dd:before,\n.financialChartTypePickerDropDownButton:focus .ui-icon-toolbar-dd:before {\n    content: '';\n    border-color: #4897AA transparent transparent transparent;\n    border-color: var(--financial-toolbar-dropdown-icon-hover-color, #4897AA) transparent transparent transparent;\n}\n\n.financialChartListItem[data-value='Auto'] {\n    padding-bottom: 5px;\n    padding-bottom: var(--financial-toolbar-dropdown-border-bottom-padding, 5px);\n    border-bottom: 1px solid #ddd;\n    border-bottom: 1px solid var(--financial-toolbar-dropdown-border-bottom-color, #ddd);\n    margin-bottom: 3px;\n    margin-bottom: var(--financial-toolbar-dropdown-border-bottom-margin, 3px);\n}\n\n.financialChartTypePickerDropDownButton[data-value=\"Auto\"] .ui-icon-chartAuto:before,\n.financialChartListItem[data-value='Auto'] .ui-icon-changeable:before,\n.financialChartListItem[data-value='Auto'] .ui-icon-chartAuto:before,\n.financialChartTypePickerDropDownButton[data-value=\"Auto\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-auto-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Auto']:hover .ui-icon-chartAuto:before,\n.financialChartListItem[data-value='Auto']:focus .ui-icon-chartAuto:before,\n.financialChartTypePickerDropDownButton[data-value='Auto']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Auto']:focus .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-auto-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Bar'] .ui-icon-BarIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Bar\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-bar-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Bar']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Bar']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Bar\"]:hover .ui-icon-BarIcon:before,\n.financialChartListItem[data-value=\"Bar\"]:focus .ui-icon-BarIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-bar-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Line'] .ui-icon-LineIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Line\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-line-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Line']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Line']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Line\"]:hover .ui-icon-LineIcon:before,\n.financialChartListItem[data-value=\"Line\"]:focus .ui-icon-LineIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-line-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Candle'] .ui-icon-CandleIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Candle\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-candle-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Candle']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Candle']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Candle\"]:hover .ui-icon-CandleIcon:before,\n.financialChartListItem[data-value=\"Candle\"]:focus .ui-icon-CandleIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-candle-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Column'] .ui-icon-ColumnIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Column\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-column-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Column']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Column']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Column\"]:hover .ui-icon-ColumnIcon:before,\n.financialChartListItem[data-value=\"Column\"]:focus .ui-icon-ColumnIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-column-hover-icon,\n        url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFinancialChartDefaultTemplatesComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartDefaultTemplatesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-financial-chart-default-templates',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: "\n    <ng-template #financialChartRangeSelectorTemplate let-vm=\"vm\">\n        <div class='financialChartRangeSelector'>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorOneMonth' *ngIf=\"vm.oneMonthVisible\">\n\t\t    \t<input type='radio' value='1m' [checked]=\"vm.oneMonthChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_OneMonth}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorThreeMonths' *ngIf=\"vm.threeMonthsVisible\">\n\t\t    \t<input type='radio' value='3m' [checked]=\"vm.threeMonthsChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_ThreeMonths}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorSixMonths' *ngIf=\"vm.sixMonthsVisible\">\n\t\t    \t<input type='radio' value='6m' [checked]=\"vm.sixMonthsChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_SixMonths}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorYTD' *ngIf=\"vm.yearToDateVisible\">\n\t\t    \t<input type='radio' value='YTD' [checked]=\"vm.yearToDateChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_YearToDate}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorOneYear' *ngIf=\"vm.oneYearVisible\">\n\t\t    \t<input type='radio' value='1y' [checked]=\"vm.oneYearChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_OneYear}}</span>\n\t\t    </label>\n\t\t    <label class='financialChartRangeSelectorLabel rangeSelectorAll' *ngIf=\"vm.allVisible\">\n\t\t    \t<input type='radio' value='all' [checked]=\"vm.allChecked\" (change)=\"vm.changeSelection($event.target.value)\">\n\t\t    \t<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_All}}</span>\n\t\t    </label>\n\t    </div>\n    </ng-template>\n\n    <ng-template #financialChartTypePickerTemplate let-vm=\"vm\">\n        <button class='financialChartTypePickerDropDownButton' (click)=\"vm.onButtonPressed()\" [attr.data-value]=\"vm.chartTypeString\">\n\t    \t<span class='ui-icon ui-icon-changeable'></span>\n\t    \t<span class='ui-icon-toolbar-dd'></span>\n\t    </button>\n\n\t    <div class='financialChartTypePickerDropDownMenu' [style.display]=\"vm.isOpen ? 'block' : 'none'\"\n            (click)=\"vm.handleDropDownClick($event)\">\n\t    \t<ul>\n\t    \t\t<li class='financialChartListItem' data-value='Auto'>\n\t    \t\t    <span class='ui-icon ui-icon-chartAuto'></span>\n\t    \t\t    <span>Auto</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Bar'>\n\t    \t\t\t<span class='ui-icon ui-icon-BarIcon'></span>\n\t    \t\t\t<span>Bar</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Line'>\n\t    \t\t\t<span class='ui-icon ui-icon-LineIcon'></span>\n\t    \t\t\t<span>Line</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Candle'>\n\t    \t\t\t<span class='ui-icon ui-icon-CandleIcon'></span>\n\t    \t\t\t<span>Candle</span>\n\t    \t\t</li>\n\t    \t\t<li class='financialChartListItem' data-value='Column'>\n\t    \t\t\t<span class='ui-icon ui-icon-ColumnIcon'></span>\n\t    \t\t\t<span>Column</span>\n\t    \t\t</li>\n\t    \t</ul>\n\t    </div>\n    </ng-template>\n\n    <ng-template #financialChartIndicatorMenuTemplate let-vm=\"vm\">\n        <button class='financialChartIndicatorMenuDropDownButton' (click)=\"vm.onButtonPressed()\">\n\t    \t<div class='ui-ChartButtonWrapper'>\n\t    \t\t<span class='ui-icon ui-icon-IndicatorsIcon'></span>\n\t    \t\t<span class='financialChartIndicatorMenuLabel'>{{vm.financialChart_IndicatorMenu_Header}}</span>\n\t    \t\t<span class='ui-icon-toolbar-dd'></span>\n\t    \t</div>\n        </button>\n\n\t    <div class='financialChartIndicatorMenuDropDownMenu' [style.display]=\"vm.isOpen ? 'block' : 'none'\" (click)=\"vm.handleDropDownClick($event)\">\n\t    \t<ul class='financialChartIndicatorMenuDropDownMenuList'>\n\t\t\t<li data-value='FinancialOverlayType'>\n\t\t\t\t<span>{{vm.financialChart_IndicatorMenu_OverlaysCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='BollingerBands'>{{vm.financialChart_IndicatorsMenu_Overlay_BollingerBands}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PriceChannel'>{{vm.financialChart_IndicatorsMenu_Overlay_PriceChannel}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t\t<li data-value='TrendLineType'>\n\t\t\t\t<span>{{vm.financialChart_IndicatorMenu_TrendlinesCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='LinearFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_LinearFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='QuadraticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuadraticFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='CubicFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_CubicFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='QuarticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuarticFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='QuinticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuinticFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='LogarithmicFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_LogarithmicFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ExponentialFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_ExponentialFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PowerLawFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_PowerLawFit}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='SimpleAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_SimpleAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ExponentialAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_ExponentialAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ModifiedAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_ModifiedAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='CumulativeAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_CumulativeAverage}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='WeightedAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_WeightedAverage}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t\t<li data-value='FinancialChartVolumeType'><span>{{vm.financialChart_IndicatorMenu_VolumeCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='Column'>{{vm.financialChart_IndicatorsMenu_Volume_Column}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='Line'>{{vm.financialChart_IndicatorsMenu_Volume_Line}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='Area'>{{vm.financialChart_IndicatorsMenu_Volume_Area}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t\t<li data-value='FinancialIndicatorType'><span>{{vm.financialChart_IndicatorMenu_IndicatorsCategoryHeader}}</span>\n\t\t\t\t<ul>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AbsoluteVolumeOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AccumulationDistribution'>{{vm.financialChart_IndicatorsMenu_Indicator_AccumulationDistribution}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AverageDirectionalIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='AverageTrueRange'>{{vm.financialChart_IndicatorsMenu_Indicator_AverageTrueRange}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='BollingerBandWidth'>{{vm.financialChart_IndicatorsMenu_Indicator_BollingerBandWidth}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ChaikinOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_ChaikinOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ChaikinVolatility'>{{vm.financialChart_IndicatorsMenu_Indicator_ChaikinVolatility}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='CommodityChannelIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_CommodityChannelIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='DetrendedPriceOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='EaseOfMovement'>{{vm.financialChart_IndicatorsMenu_Indicator_EaseOfMovement}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='FastStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_FastStochasticOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='ForceIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_ForceIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='FullStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_FullStochasticOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MarketFacilitationIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MassIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MassIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MedianPrice'>{{vm.financialChart_IndicatorsMenu_Indicator_MedianPrice}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MoneyFlowIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MoneyFlowIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='MovingAverageConvergenceDivergence'>{{vm.financialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='NegativeVolumeIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='OnBalanceVolume'>{{vm.financialChart_IndicatorsMenu_Indicator_OnBalanceVolume}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PercentagePriceOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PercentageVolumeOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PositiveVolumeIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='PriceVolumeTrend'>{{vm.financialChart_IndicatorsMenu_Indicator_PriceVolumeTrend}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='RateOfChangeAndMomentum'>{{vm.financialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='RelativeStrengthIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='SlowStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='StandardDeviation'>{{vm.financialChart_IndicatorsMenu_Indicator_StandardDeviation}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='StochRSI'>{{vm.financialChart_IndicatorsMenu_Indicator_StochRSI}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='TRIX'>{{vm.financialChart_IndicatorsMenu_Indicator_TRIX}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='TypicalPrice'>{{vm.financialChart_IndicatorsMenu_Indicator_TypicalPrice}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='UltimateOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_UltimateOscillator}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='WeightedClose'>{{vm.financialChart_IndicatorsMenu_Indicator_WeightedClose}}</li>\n\t\t\t\t\t<li class='financialChartListItem' data-value='WilliamsPercentR'>{{vm.financialChart_IndicatorsMenu_Indicator_WilliamsPercentR}}</li>\n\t\t\t\t</ul>\n\t\t\t</li>\n\t\t</ul>\n\t    </div>\n    </ng-template>\n\n    <ng-template #financialChartToolbarTemplate let-vm=\"vm\">\n        <ng-template #defaultTemplate>\n            <div></div>\n        </ng-template>\n\n        <div class='financialChartToolbar'>\n            <div class='financialChartToolbar'>\n                <div class='financialChartIndicatorMenu' *ngIf='vm.isIndicatorMenuVisible'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartIndicatorMenu.template ? vm.financialChartIndicatorMenu.template : defaultTemplate; context: vm.financialChartIndicatorMenu\">\n                    </ng-container>\n                </div>\n                <div class='financialChartRangeSelector'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartRangeSelector.template ? vm.financialChartRangeSelector.template : defaultTemplate; context: vm.financialChartRangeSelector\">\n                    </ng-container>\n                </div>\n                <div class='financialChartTypePicker'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartTypePicker.template ? vm.financialChartTypePicker.template : defaultTemplate; context: vm.financialChartTypePicker\">\n                    </ng-container>\n                </div>\n            </div>\n        </div>\n    </ng-template>\n  ",
                        styles: ["\n.ui-financialchart-container {\n    font-family: \"Segoe UI\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-font-family, \"Segoe UI\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-font-size, 12px);\n    border-width: 0;\n    -webkit-tap-highlight-color: rgba(0,0,0,0);\n    -webkit-tap-highlight-color: var(--financial-highlight-color, rgba(0,0,0,0));\n}\n\n.ui-financialchart-mainChart {\n    margin-left: 15px;\n    margin-left: var(--financial-pane-margin-left, 15px);\n}\n\n.ui-financialchart-volumeChart {\n    margin-left: 15px;\n    margin-left: var(--financial-pane-margin-left, 15px);\n}\n\n.financialChartMainGrid {\n    height: 100%;\n    width: 100%;\n    display: grid;\n    display: -ms-grid;\n    -ms-grid-columns: 100%;\n}\n\n.financialChartPrice {\n    grid-row: 3;\n    -ms-grid-row: 3;\n    margin-top: 10px;\n    margin-top: var(--financial-pane-margin-top, 10px);\n}\n.financialChartPrice, .financialChartPrice > div {\n    min-height: 100px;\n}\n.financialChartIndicators {\n    grid-row: 4;\n    -ms-grid-row: 4;\n}\n.financialChartVolume {\n    grid-row: 5;\n    -ms-grid-row: 5;\n}\n.financialChartZoomSlider {\n    grid-row: 6;\n    -ms-grid-row: 6;\n}\n\n/*\n/////////////////////\n*/\n/* Toolbar styles */\n/*\n/////////////////////\n*/\n\n.financialChartToolbar {\n    display: grid;\n    display: -ms-grid;\n    grid-row: 1;\n    -ms-grid-rows: 100%;\n    -ms-grid-row: 1;\n    -ms-grid-columns: 100%;\n    font-family: \"Verdana\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-font-family, \"Verdana\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-font-size, 12px);\n}\n\n/* scrollbar styles */\n.financialChartToolbar ::-webkit-scrollbar\n{\n    width: 14px;\n    width: var(--financial-toolbar-scrollbar-width, 14px);\n    background-color: #eee;\n    background-color: var(--financial-toolbar-scrollbar-background, #eee);\n}\n.financialChartToolbar ::-webkit-scrollbar-track\n{\n    border-radius: 1px;\n    border-radius: var(--financial-toolbar-scrollbar-track-radius, 1px);\n    background-color: #eee;\n    background-color: var(--financial-toolbar-scrollbar-track-background, #eee);\n    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);\n    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-track-shadow-radius, 6px) var(--financial-toolbar-scrollbar-track-shadow-color, rgba(0,0,0,0.3));\n}\n.financialChartToolbar ::-webkit-scrollbar-thumb\n{\n    border-radius: 1px;\n    border-radius: var(--financial-toolbar-scrollbar-thumb-radius, 1px);\n    background-color: #838383;\n    background-color: var(--financial-toolbar-scrollbar-thumb-background, #838383);\n    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,.3);\n    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-thumb-shadow-radius, 6px) var(--financial-toolbar-scrollbar-thumb-shadow-color, rgba(0,0,0,0.3));\n}\n\n.financialChartToolbar .financialChartToolbar {\n    display: flex;\n    display: -ms-flexbox;\n    align-items: center;\n    border: 1px solid #dadada;\n    border: var(--financial-toolbar-border-thickness, 1px) solid var(--financial-toolbar-border-color, #dadada);\n    color: black;\n    color: var(--financial-toolbar-text-color, black);\n    max-height: 45px;\n    max-height: var(--financial-toolbar-max-height, 45px);\n    background: #eeeeee;\n    background: var(--financial-toolbar-background, #eeeeee);\n}\n\n.financialChartToolbar,\n.financialChartToolbar button {\n    font: 400 13px \"Segoe UI\", Arial, sans-serif!important;\n    font: var(--financial-toolbar-range-button-font, 400 13px \"Segoe UI\", Arial, sans-serif!important);\n}\n\n.financialChartRangeSelector {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    text-transform: uppercase;\n    height: 100%;\n}\n\n.financialChartRangeSelector input {\n    display: none;\n}\n\n.financialChartRangeSelectorLabel {\n    cursor: pointer;\n    height: 100%;\n}\n.financialChartRangeSelectorLabel:hover .financialChartRangeSelectorLabelSpan {\n    color: #4897AA;\n    color: var(--financial-toolbar-range-button-hover-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-range-button-hover-background, transparent);\n}\n\n.financialChartRangeSelectorLabel input:checked + span {\n    color: #444444;\n    color: var(--financial-toolbar-range-button-check-color, #444444);\n    background-color: #dadada;\n    background-color: var(--financial-toolbar-range-button-check-background, #dadada);\n}\n\n.financialChartRangeSelectorLabelSpan {\n    height: 100%;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    padding: 10px;\n    padding: var(--financial-toolbar-range-button-padding, 10px);\n    box-sizing: border-box;\n}\n\n.financialChartRangeSelectorLastOption {\n    border: none;\n    padding-right: 0;\n    padding-right: var(--financial-toolbar-range-button-padding-right, 0px);\n}\n\n.financialChartIndicatorMenu,\n.financialChartTypePicker {\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.financialChartTypePicker {\n    margin-left: auto;\n    height: 100%;\n    border-left: 1px solid #dadada;\n    border-left: var(--financial-toolbar-border-thickness, 1px) solid\n                 var(--financial-toolbar-border-color, #dadada);\n}\n\n.financialChartIndicatorMenu {\n    height: 100%;\n    padding:0 10px;\n    border-right: 1px solid #dadada;\n    border-right: var(--financial-toolbar-border-thickness, 1px) solid\n                  var(--financial-toolbar-border-color, #dadada);\n}\n\n.financialChartIndicatorMenuDropDownMenu,\n.financialChartTypePickerDropDownMenu {\n    background: #fff;\n    background: var(--financial-toolbar-dropdown-background-color, #fff);\n    color: black;\n    color: var(--financial-toolbar-dropdown-text-color, black);\n    display: flex;\n    flex-direction: column;\n    z-index: 1;\n    position: absolute;\n    top: calc(100% + 1px);\n    top: calc(100% + var(--financial-toolbar-dropdown-top-offset, 1px));\n    box-shadow: 0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22);\n    box-shadow: var(--financial-toolbar-dropdown-shadow,  0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22));\n    white-space: nowrap;\n    font-family: \"Verdana\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-dropdown-font-family, \"Verdana\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-dropdown-font-size, 12px);\n}\n\n.financialChartIndicatorMenuDropDownMenu {\n    left: 0;\n    min-width: 100px;\n    min-width: var(--financial-toolbar-dropdown-min-width, 100px);\n    height: 300px;\n    height: var(--financial-toolbar-dropdown-height, 300px);\n    overflow: auto;\n}\n\n.financialChartTypePickerDropDownMenu {\n    right: 0;\n}\n\n.financialChartListItem {\n    cursor: pointer;\n    cursor: var(--financial-toolbar-dropdown-item-cursor, pointer);\n}\n\n.financialChartListItem:hover,\n.financialChartListItem:focus {\n    color: #4897AA;\n    color: var(--financial-toolbar-dropdown-item-hover-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-dropdown-item-hover-background, transparent);\n}\n\n.financialChartListItem span {\n    position: relative;\n    /* TODO: figure out why we need z-index here */\n    z-index: -1;\n}\n\n.financialChartTypePickerDropDownMenu .financialChartListItem {\n    display: flex;\n    align-items: center;\n    justify-content: flex-start;\n}\n.financialChartTypePickerDropDownMenu .ui-icon {\n    margin-right: 5px;\n    margin-right: var(--financial-toolbar-icon-margin-right, 5px);\n}\n\n.financialChartIndicatorMenuDropDownButton,\n.financialChartTypePickerDropDownButton {\n    background-color: transparent;\n    background-color: var(--financial-toolbar-indicators-background-color, transparent);\n    border: none;\n    outline: none;\n    cursor: pointer;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n}\n\n.financialChartIndicatorMenuDropDownMenuList {\n    font-weight: bold;\n}\n\n.financialChartIndicatorMenuDropDownMenu li.checked,\n.financialChartTypePickerDropDownMenu li.checked {\n    color: #4897AA;\n    color: var(--financial-toolbar-dropdown-item-check-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-dropdown-item-check-background, transparent);\n}\n\n.financialChartIndicatorMenuDropDownMenu ul,\n.financialChartTypePickerDropDownMenu ul {\n    list-style-type: none;\n    margin: 0;\n    padding: 8px;\n}\n\n.financialChartIndicatorMenuDropDownMenu ul ul,\n.financialChartTypePickerDropDownMenu ul ul {\n    padding-left: 15px;\n    padding-left: var(--financial-toolbar-dropdown-list-padding-left, 15px);\n    font-weight: normal;\n}\n\n.financialChartIndicatorMenuDropDownMenu ul li,\n.financialChartTypePickerDropDownMenu ul li {\n    padding-top: 4px;\n    padding-top: var(--financial-toolbar-dropdown-list-padding-top, 4px);\n    position: relative;\n}\n\n.financialChartIndicatorMenuDropDownMenu li.checked:before{\n    margin-left: -15px;\n    margin-left:  var(--financial-toolbar-dropdown-list-margin-left, -15px);\n    margin-right: 5px;\n    margin-right: var(--financial-toolbar-dropdown-list-margin-right, 5px);\n    content: \"\\2713\";\n    position: absolute;\n}\n\n.financialChartLegend {\n    grid-row: 2;\n    -ms-grid-row: 2;\n}\n\n.ui-ChartButtonWrapper {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.financialChartTypePickerDropDownButton .ui-icon-triangle-1-s,\n.ui-ChartButtonWrapper .ui-icon-triangle-1-s {\n    font-size: 10px;\n    font-size: var(--financial-toolbar-icon-font-size, 10px);\n}\n\n.financialChartTypePickerDropDownButton {\n    background-color: transparent;\n    background-color: var(--financial-toolbar-chart-picker-background, transparent);\n    height: 100%;\n    padding: 0 10px;\n    padding: var(--financial-toolbar-chart-picker-padding, 0 10px);\n}\n\n.financialChartIndicatorMenuLabel {\n    margin: 0 5px;\n    margin: var(--financial-toolbar-indicators-label-margin, 0 5px);\n    color: inherit;\n    color: var(--financial-toolbar-indicators-label-normal-color, inherit);\n}\n\n/* Icon styles if no theme is included */\n.financialChartToolbar .ui-icon {\n    color: #888888;\n    color: var(--financial-toolbar-icon-color, #888888);\n    width: 16px;\n    width: var(--financial-toolbar-icon-width, 16px);\n    height: 16px;\n    height: var(--financial-toolbar-icon-height, 16px);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    text-indent: -99999px;\n    overflow: hidden;\n    position: relative;\n}\n.financialChartToolbar .ui-icon:before {\n    display: block;\n    height: 1em;\n    left: 50%;\n    line-height: 1;\n    margin-left: -0.5em;\n    margin-top: -0.5em;\n    position: absolute;\n    text-indent: 0;\n    top: 50%;\n    width: 1em;\n}\n\n.ui-icon-IndicatorsIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-indicators-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .ui-icon-IndicatorsIcon:before,\n.financialChartIndicatorMenuDropDownButton:focus .ui-icon-IndicatorsIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-indicators-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .financialChartIndicatorMenuLabel,\n.financialChartIndicatorMenuDropDownButton:focus .financialChartIndicatorMenuLabel {\n    color: #4897AA;\n    color: var(--financial-toolbar-indicators-label-hover-color, #4897AA);\n}\n\n.ui-icon-toolbar-dd {\n    position: relative;\n    width: 16px;\n    width: var(--financial-toolbar-dropdown-icon-width, 16px);\n    height: 16px;\n    height: var(--financial-toolbar-dropdown-icon-height, 16px);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n}\n\n.ui-icon-toolbar-dd:before {\n    content: '';\n    position: absolute;\n    width: 0;\n    height: 0;\n    border-style: solid;\n    border-width: 5px 4px 0 4px;\n    border-color: #666 transparent transparent transparent;\n    border-color: var(--financial-toolbar-dropdown-icon-normal-color, #666) transparent transparent transparent;\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .ui-icon-toolbar-dd:before,\n.financialChartIndicatorMenuDropDownButton:focus .ui-icon-toolbar-dd:before,\n.financialChartTypePickerDropDownButton:hover .ui-icon-toolbar-dd:before,\n.financialChartTypePickerDropDownButton:focus .ui-icon-toolbar-dd:before {\n    content: '';\n    border-color: #4897AA transparent transparent transparent;\n    border-color: var(--financial-toolbar-dropdown-icon-hover-color, #4897AA) transparent transparent transparent;\n}\n\n.financialChartListItem[data-value='Auto'] {\n    padding-bottom: 5px;\n    padding-bottom: var(--financial-toolbar-dropdown-border-bottom-padding, 5px);\n    border-bottom: 1px solid #ddd;\n    border-bottom: 1px solid var(--financial-toolbar-dropdown-border-bottom-color, #ddd);\n    margin-bottom: 3px;\n    margin-bottom: var(--financial-toolbar-dropdown-border-bottom-margin, 3px);\n}\n\n.financialChartTypePickerDropDownButton[data-value=\"Auto\"] .ui-icon-chartAuto:before,\n.financialChartListItem[data-value='Auto'] .ui-icon-changeable:before,\n.financialChartListItem[data-value='Auto'] .ui-icon-chartAuto:before,\n.financialChartTypePickerDropDownButton[data-value=\"Auto\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-auto-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Auto']:hover .ui-icon-chartAuto:before,\n.financialChartListItem[data-value='Auto']:focus .ui-icon-chartAuto:before,\n.financialChartTypePickerDropDownButton[data-value='Auto']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Auto']:focus .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-auto-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Bar'] .ui-icon-BarIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Bar\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-bar-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Bar']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Bar']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Bar\"]:hover .ui-icon-BarIcon:before,\n.financialChartListItem[data-value=\"Bar\"]:focus .ui-icon-BarIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-bar-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Line'] .ui-icon-LineIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Line\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-line-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Line']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Line']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Line\"]:hover .ui-icon-LineIcon:before,\n.financialChartListItem[data-value=\"Line\"]:focus .ui-icon-LineIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-line-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Candle'] .ui-icon-CandleIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Candle\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-candle-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Candle']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Candle']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Candle\"]:hover .ui-icon-CandleIcon:before,\n.financialChartListItem[data-value=\"Candle\"]:focus .ui-icon-CandleIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-candle-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Column'] .ui-icon-ColumnIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Column\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-column-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Column']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Column']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Column\"]:hover .ui-icon-ColumnIcon:before,\n.financialChartListItem[data-value=\"Column\"]:focus .ui-icon-ColumnIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-column-hover-icon,\n        url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { financialChartRangeSelectorTemplate: [{
                    type: i0.ViewChild,
                    args: ["financialChartRangeSelectorTemplate", { static: true }]
                }], financialChartTypePickerTemplate: [{
                    type: i0.ViewChild,
                    args: ["financialChartTypePickerTemplate", { static: true }]
                }], financialChartIndicatorMenuTemplate: [{
                    type: i0.ViewChild,
                    args: ["financialChartIndicatorMenuTemplate", { static: true }]
                }], financialChartToolbarTemplate: [{
                    type: i0.ViewChild,
                    args: ["financialChartToolbarTemplate", { static: true }]
                }], onContentReady: [{
                    type: i0.Output
                }] } });

    var IgxFinancialIndicatorTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialIndicatorTypeCollection, _super);
        function IgxFinancialIndicatorTypeCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxFinancialIndicatorTypeCollection.prototype._ensureOuter = function (item) {
            return i2.ensureEnum(FinancialIndicatorType_$type, item);
        };
        IgxFinancialIndicatorTypeCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(FinancialIndicatorType_$type, FinancialIndicatorType_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxFinancialIndicatorTypeCollection;
    }(i2.IgCollection));

    var IgxFinancialOverlayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialOverlayTypeCollection, _super);
        function IgxFinancialOverlayTypeCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxFinancialOverlayTypeCollection.prototype._ensureOuter = function (item) {
            return i2.ensureEnum(FinancialOverlayType_$type, item);
        };
        IgxFinancialOverlayTypeCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(FinancialOverlayType_$type, FinancialOverlayType_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxFinancialOverlayTypeCollection;
    }(i2.IgCollection));

    var IgxIndicatorDisplayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxIndicatorDisplayTypeCollection, _super);
        function IgxIndicatorDisplayTypeCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxIndicatorDisplayTypeCollection.prototype._ensureOuter = function (item) {
            return i2.ensureEnum(IndicatorDisplayType_$type, item);
        };
        IgxIndicatorDisplayTypeCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(IndicatorDisplayType_$type, IndicatorDisplayType_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxIndicatorDisplayTypeCollection;
    }(i2.IgCollection));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IndicatorDisplayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IndicatorDisplayTypeCollection, _super);
        function IndicatorDisplayTypeCollection() {
            return _super.call(this, IndicatorDisplayType_$type, 0) || this;
        }
        IndicatorDisplayTypeCollection.$t = i2.markType(IndicatorDisplayTypeCollection, 'IndicatorDisplayTypeCollection', i2.ObservableCollection$1.$.specialize(IndicatorDisplayType_$type));
        return IndicatorDisplayTypeCollection;
    }(i2.ObservableCollection$1));

    var IgxFinancialChartRangeSelectorOptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialChartRangeSelectorOptionCollection, _super);
        function IgxFinancialChartRangeSelectorOptionCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxFinancialChartRangeSelectorOptionCollection.prototype._ensureOuter = function (item) {
            return i2.ensureEnum(FinancialChartRangeSelectorOption_$type, item);
        };
        IgxFinancialChartRangeSelectorOptionCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(FinancialChartRangeSelectorOption_$type, FinancialChartRangeSelectorOption_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxFinancialChartRangeSelectorOptionCollection;
    }(i2.IgCollection));

    /**
     * Event arguments for the Financial Chart's custom indicator event.
    */
    var IgxFinancialChartCustomIndicatorArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialChartCustomIndicatorArgs() {
        }
        Object.defineProperty(IgxFinancialChartCustomIndicatorArgs.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialChartCustomIndicatorArgs.prototype.onImplementationCreated = function () {
        };
        IgxFinancialChartCustomIndicatorArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFinancialChartCustomIndicatorArgs.prototype, "indicatorInfo", {
            get: function () {
                if (!this.i.indicatorInfo) {
                    return null;
                }
                if (!this.i.indicatorInfo.externalObject && i2.TypeRegistrar.isRegistered("igx-financial-event-args")) {
                    var e = i2.TypeRegistrar.create("igx-financial-event-args");
                    e._implementation = this.i.indicatorInfo;
                    this.i.indicatorInfo.externalObject = e;
                }
                if (this.i.indicatorInfo.externalObject) {
                    return this.i.indicatorInfo.externalObject;
                }
                return null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartCustomIndicatorArgs.prototype, "series", {
            /**
         * The Series in context.
        */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartCustomIndicatorArgs.prototype, "index", {
            /**
             * An integer representing the position of the associated custom indicator in its host.
            */
            get: function () {
                return this.i.index;
            },
            set: function (v) {
                this.i.index = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxFinancialChartCustomIndicatorArgs;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CustomIndicatorNameCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomIndicatorNameCollection, _super);
        function CustomIndicatorNameCollection(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        _this = _super.call(this, i2.String_$type, 0) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, i2.String_$type, 1, c) || this;
                    }
                    break;
            }
            return _this;
        }
        CustomIndicatorNameCollection.$t = i2.markType(CustomIndicatorNameCollection, 'CustomIndicatorNameCollection', i2.ObservableCollection$1.$.specialize(i2.String_$type));
        return CustomIndicatorNameCollection;
    }(i2.ObservableCollection$1));

    var IgxCustomIndicatorNameCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCustomIndicatorNameCollection, _super);
        function IgxCustomIndicatorNameCollection(list) {
            var _this = _super.call(this) || this;
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxCustomIndicatorNameCollection.prototype._createInnerColl = function () {
            var coll = new i2.SyncableObservableCollection$2(i2.String_$type, i2.String_$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext;
            };
            coll.createFrom = function (int) {
                return int;
            };
            return coll;
        };
        return IgxCustomIndicatorNameCollection;
    }(i2.IgCollection));

    /**
     * Represents a chart with an ordinal X-axis and a numeric Y-axis.
    *
    * **Ignite UI for Angular Financial Chart** - [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/FinancialChart.html)
    *
    * The Ignite UI Financial Chart is a lightweight, highly performant chart. It can be easily configured to display category data using an extremely simple and intuitive API. It offers multiple ways for the user to visualize data, including several display modes for price and volume, and many financial indicators.
    *
    * ```html
    * <igx-financial-chart [dataSource]="data"
    * 					 width="850px" height="600px">
    * </igx-financial-chart>
    * ```
    */
    var IgxFinancialChartComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialChartComponent, _super);
        function IgxFinancialChartComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = _super.call(this) || this;
            _this.renderer = renderer;
            _this._elRef = _elRef;
            _this.ngZone = ngZone;
            _this.injector = injector;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this._wrapper = null;
            _this._dataSource = null;
            _this._defaultTooltips = null;
            _this._xAxisBreaks = null;
            _this._indicatorTypes = null;
            _this._overlayTypes = null;
            _this._indicatorDisplayTypes = null;
            _this._rangeSelectorOptions = null;
            _this._customIndicatorNames = null;
            _this._applyCustomIndicators = null;
            _this._zoneRunner = function (act) { return ngZone.run(act); };
            _this.container = renderer.createElement("div");
            renderer.appendChild(_elRef.element.nativeElement, _this.container);
            renderer.setStyle(_this.container, "display", "block");
            renderer.setStyle(_this.container, "width", "100%");
            renderer.setStyle(_this.container, "height", "100%");
            var root;
            root = _this.container;
            if (_this.container != null) {
                root = _this.container;
            }
            var ren = new i2.AngularRenderer(root, _this.renderer, window.document, _this.ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            var chart = _this.i;
            _this._chart = chart;
            if (chart.xAxis) {
                _this.rewrapAxis(chart.xAxis);
            }
            if (chart.yAxis) {
                _this.rewrapAxis(chart.yAxis);
            }
            if (chart.volumeAxis) {
                _this.rewrapAxis(chart.volumeAxis);
            }
            if (chart.volumeXAxis) {
                _this.rewrapAxis(chart.volumeXAxis);
            }
            if (chart.indicatorAxis) {
                _this.rewrapAxis(chart.indicatorAxis);
            }
            if (chart.indicatorXAxis) {
                _this.rewrapAxis(chart.indicatorXAxis);
            }
            if (chart.zoomSliderAxis) {
                _this.rewrapAxis(chart.zoomSliderAxis);
            }
            if (chart.zoomSliderXAxis) {
                _this.rewrapAxis(chart.zoomSliderXAxis);
            }
            chart.provideContainer(ren);
            _this.bindData();
            chart.notifyResized();
            ren.addSizeWatcher(function () {
                _this._checkToolbarSize();
                _this._chart.notifyResized();
            });
            // supports angular themes or custom properties set in CSS 
            _this._styling(_elRef.element.nativeElement, _this);
            return _this;
        }
        Object.defineProperty(IgxFinancialChartComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialChartComponent.prototype._checkToolbarSize = function () {
            if (this._toolbarElement) {
                var start = this._toolbarElement.nativeElement;
                if (start.children.length == 1) {
                    start = start.children[0];
                }
                var toolbarRoot = start.querySelector(".financialChartToolbar");
                var rootRect = toolbarRoot.getBoundingClientRect();
                var hideRemaining = false;
                for (var i = 0; i < toolbarRoot.children.length; i++) {
                    var child = toolbarRoot.children[i];
                    if (child.nodeType == Node.ELEMENT_NODE) {
                        if (!hideRemaining) {
                            child.style.display = "";
                        }
                        var childRect = child.getBoundingClientRect();
                        if (hideRemaining ||
                            childRect.left + childRect.width >
                                rootRect.left + rootRect.width) {
                            child.style.display = "none";
                            hideRemaining = true;
                        }
                        else {
                            child.style.display = "";
                        }
                    }
                }
            }
        };
        IgxFinancialChartComponent.prototype.ngOnDestroy = function () {
            this._chart.destroy();
            this._wrapper.destroy();
        };
        IgxFinancialChartComponent.prototype.onDocumentClick = function (ev) {
            this._chart.onDocumentClick(ev);
        };
        IgxFinancialChartComponent.prototype.rewrapAxis = function (axis) {
            var axisName = axis.$type.name;
            var componentName = "Igx" + axisName + "Component";
            if (i2.TypeRegistrar.isRegistered(componentName)) {
                var x = i2.TypeRegistrar.create(componentName);
                x._implementation = axis;
                axis.externalObject = x;
            }
            else {
                throw new Error("Axis type not loaded: " + componentName);
            }
        };
        IgxFinancialChartComponent.prototype.createImplementation = function () {
            return new FinancialChart();
        };
        Object.defineProperty(IgxFinancialChartComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialChartComponent.prototype.createSeriesComponent = function (type) {
            if (i2.TypeRegistrar.isRegistered(type)) {
                var s = i2.TypeRegistrar.create(type);
                s.owner = this;
                return s;
            }
            else {
                //we shouldn't get here, hopefully.
                throw Error("series type not loaded: " + type);
            }
        };
        IgxFinancialChartComponent.prototype.createIndicator = function (typeName) {
            return this.createSeriesComponent("Igx" + typeName + "Component");
        };
        IgxFinancialChartComponent.prototype.createOverlay = function (typeName) {
            return this.createSeriesComponent("Igx" + typeName + "Component");
        };
        IgxFinancialChartComponent.prototype.createSeries = function (type) {
            switch (type) {
                case i2.DataSeriesType.Area:
                    return this.createSeriesComponent('IgxAreaSeriesComponent');
                case i2.DataSeriesType.Column:
                    return this.createSeriesComponent('IgxColumnSeriesComponent');
                case i2.DataSeriesType.Line:
                    return this.createSeriesComponent('IgxLineSeriesComponent');
                case i2.DataSeriesType.FinancialPrice:
                    return this.createSeriesComponent('IgxFinancialPriceSeriesComponent');
                case i2.DataSeriesType.ItemToolTipLayer:
                    return this.createSeriesComponent('IgxItemToolTipLayerComponent');
                case i2.DataSeriesType.CategoryToolTipLayer:
                    return this.createSeriesComponent('IgxCategoryToolTipLayerComponent');
                case i2.DataSeriesType.CrosshairLayer:
                    return this.createSeriesComponent('IgxCrosshairLayerComponent');
                case i2.DataSeriesType.FinalValueLayer:
                    return this.createSeriesComponent('IgxFinalValueLayerComponent');
                case i2.DataSeriesType.CalloutLayer:
                    return this.createSeriesComponent('IgxCalloutLayerComponent');
                default:
                    return this.createSeriesComponent('IgxColumnSeriesComponent');
            }
        };
        IgxFinancialChartComponent.prototype.createXAxis = function (type) {
            switch (type) {
                case FinancialChartXAxisMode.Ordinal:
                    if (i2.TypeRegistrar.isRegistered("IgxOrdinalTimeXAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxOrdinalTimeXAxisComponent");
                    }
                    else if (i2.TypeRegistrar.isRegistered("IgxTimeXAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxTimeXAxisComponent");
                    }
                    else {
                        throw new Error("not valid axes components loaded");
                    }
                case FinancialChartXAxisMode.Time:
                    if (i2.TypeRegistrar.isRegistered("IgxTimeXAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxTimeXAxisComponent");
                    }
                    else if (i2.TypeRegistrar.isRegistered("IgxOrdinalTimeXAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxOrdinalTimeXAxisComponent");
                    }
                    else {
                        throw new Error("not valid axes components loaded");
                    }
            }
        };
        IgxFinancialChartComponent.prototype.createYAxis = function (type) {
            switch (type) {
                case FinancialChartYAxisMode.Numeric:
                    if (i2.TypeRegistrar.isRegistered("IgxNumericYAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxNumericYAxisComponent");
                    }
                    else if (i2.TypeRegistrar.isRegistered("IgxPercentChangeYAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxPercentChangeYAxisComponent");
                    }
                    else {
                        throw new Error("not valid axes components loaded");
                    }
                case FinancialChartYAxisMode.PercentChange:
                    if (i2.TypeRegistrar.isRegistered("IgxPercentChangeYAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxPercentChangeYAxisComponent");
                    }
                    else if (i2.TypeRegistrar.isRegistered("IgxNumericYAxisComponent")) {
                        return i2.TypeRegistrar.create("IgxNumericYAxisComponent");
                    }
                    else {
                        throw new Error("not valid axes components loaded");
                    }
            }
        };
        IgxFinancialChartComponent.prototype.createTimeAxisBreakCollection = function () {
            return i2.TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection") ? i2.TypeRegistrar.create("IgxTimeAxisBreakCollection") : null;
        };
        Object.defineProperty(IgxFinancialChartComponent.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.bindData();
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialChartComponent.prototype.bindData = function () {
            if (this._chart != null && this._chart !== undefined) {
                this._chart.itemsSource = this._dataSource;
            }
        };
        IgxFinancialChartComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (i2.TypeRegistrar.isRegistered("IgxDataChartDefaultTooltipsComponent")) {
                var c = i2.TypeRegistrar.get("IgxDataChartDefaultTooltipsComponent");
                var cf = this.componentFactoryResolver.resolveComponentFactory(c);
                //let cr = cf.create(this.injector);
                var cr_1 = this._dynamicContent.createComponent(cf);
                this._defaultTooltips = cr_1;
                cr_1.instance.onContentReady.subscribe(function () {
                    _this._onDefaultTooltipsReady(cr_1);
                });
                this.container.appendChild(cr_1.location.nativeElement);
            }
            var context = this._chart.getContext();
            var toolbarContext = context.vm.toolbar;
            toolbarContext.vm.financialChartIndicatorMenu.template = this.indicatorMenuTemplate ? this.indicatorMenuTemplate : this._defaultTemplates.financialChartIndicatorMenuTemplate;
            toolbarContext.vm.financialChartIndicatorMenu.vm.notifyChanged = function () { toolbarArea.context = toolbarContext; };
            toolbarContext.vm.financialChartTypePicker.template = this.chartTypePickerTemplate ? this.chartTypePickerTemplate : this._defaultTemplates.financialChartTypePickerTemplate;
            toolbarContext.vm.financialChartTypePicker.vm.notifyChanged = function () { toolbarArea.context = toolbarContext; };
            toolbarContext.vm.financialChartRangeSelector.template = this.rangeSelectorTemplate ? this.rangeSelectorTemplate : this._defaultTemplates.financialChartRangeSelectorTemplate;
            toolbarContext.vm.financialChartRangeSelector.vm.notifyChanged = function () { toolbarArea.context = toolbarContext; };
            toolbarContext.template = this.toolbarTemplate ? this.toolbarTemplate : this._defaultTemplates.financialChartToolbarTemplate;
            var toolContainer = toolbarContext.container.rootWrapper.getNativeElement();
            var toolbarArea = this._templates.toArray()[0];
            var mainArea = this._templates.toArray()[1];
            toolbarArea.context = toolbarContext;
            toolbarArea.template = toolbarContext.template;
            var ele = this._toolbarElement.nativeElement;
            ele.style.width = "100%";
            ele.style.height = "100%";
            if (ele.parentElement != null) {
                ele.parentElement.removeChild(ele);
            }
            toolContainer.appendChild(ele);
            this.renderer.setStyle(ele, "display", "");
            var legendContainer = context.legendContainer.rootWrapper.getNativeElement();
            var mainContainer = context.container.rootWrapper.getNativeElement();
            var indicatorContainer = context.indicatorsContainer.rootWrapper.getNativeElement();
            var volumeContainer = context.volumeContainer.rootWrapper.getNativeElement();
            var zoomSliderContainer = context.zoomContainer.rootWrapper.getNativeElement();
            var main = mainArea.viewContainer.element.nativeElement;
            var templateMain = main.querySelector(".financialChartPrice");
            var templateToolbar = main.querySelector(".financialChartToolbar");
            var templateLegend = main.querySelector(".financialChartLegend");
            var templateIndicator = main.querySelector(".financialChartIndicators");
            var templateVolume = main.querySelector(".financialChartVolume");
            var templateZoomSlider = main.querySelector(".financialChartZoomSlider");
            var grid = main.querySelector(".financialChartMainGrid");
            var gridWrapper = new i2.AngularWrapper(grid, this.renderer, this.ngZone);
            templateMain.appendChild(mainContainer);
            templateToolbar.appendChild(toolContainer);
            templateLegend.appendChild(legendContainer);
            templateIndicator.appendChild(indicatorContainer);
            templateVolume.appendChild(volumeContainer);
            templateZoomSlider.appendChild(zoomSliderContainer);
            this._mainElement.nativeElement.parentElement.removeChild(this._mainElement.nativeElement);
            this.container.appendChild(this._mainElement.nativeElement);
            this._chart.provideGrid(gridWrapper);
            this._checkToolbarSize();
        };
        IgxFinancialChartComponent.prototype._createZoomSlider = function (hostEle, onReady) {
            if (!i2.TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                //shouldn't happen.
                throw new Error("zoom slider component isn't loaded");
            }
            var t = i2.TypeRegistrar.get("IgxZoomSliderComponent");
            var cf = this.componentFactoryResolver.resolveComponentFactory(t);
            var cr = this._dynamicContent.createComponent(cf);
            var ele = cr.location.nativeElement;
            ele.style.width = "100%";
            ele.style.height = "100%";
            cr.instance.width = "100%";
            cr.instance.height = "100%";
            if (ele.parentElement !== null) {
                ele.parentElement.removeChild(ele);
            }
            hostEle.appendChild(ele);
            onReady(cr.instance);
        };
        IgxFinancialChartComponent.prototype.createTooltip = function () {
            if (!i2.TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
                return null;
            }
            var t = i2.TypeRegistrar.get("IgxTooltipContainerComponent");
            var cf = this.componentFactoryResolver.resolveComponentFactory(t);
            //let cr = cf.create(this.injector);
            var cr = this._dynamicContent.createComponent(cf);
            var ele = cr.location.nativeElement;
            var self = this;
            ele.updateToolTip = function (c, isSubContent) {
                if (c.externalObject) {
                    c = c.externalObject;
                }
                else {
                    var ext = new i2.IgxDataContext();
                    ext._implementation = c;
                    c = ext;
                }
                if (!isSubContent) {
                    if (ele.parentElement != self.container) {
                        if (ele.parentElement != null) {
                            ele.parentElement.removeChild(ele);
                        }
                        self.container.appendChild(ele);
                    }
                }
                else {
                    c.isSubContent = true;
                }
                cr.instance.context = c;
                ele.style.display = "block";
                return true;
            };
            ele.hideToolTip = function () {
                ele.style.display = "none";
            };
            ele.style.display = "none";
            return cr;
        };
        IgxFinancialChartComponent.prototype._ensureTooltipCreated = function (series) {
            var _this = this;
            series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
                var wrapper = new i2.AngularWrapper(ele, _this.renderer, _this.ngZone);
                wrapper.updateToolTip = ele.updateToolTip;
                wrapper.hideToolTip = ele.hideToolTip;
                return wrapper;
            });
        };
        // private _createXAxis(): any {
        //     let x = new IgxCategoryXAxisComponent();
        //     return x.i;
        // }
        // private _createYAxis(): any {
        //     let y = new IgxNumericYAxisComponent();
        //     return y.i;
        // }
        IgxFinancialChartComponent.prototype._ensureDefaultTooltip = function (series) {
            if (this._defaultTooltips == null) {
                return;
            }
            this._defaultTooltips.instance["ensureDefaultTooltip"](series);
        };
        IgxFinancialChartComponent.prototype._onDefaultTooltipsReady = function (cr) {
            if (this.i.dataChart) {
                var currSeries = this.i.dataChart.series;
                for (var i = 0; i < currSeries.count; i++) {
                    if (currSeries.item(i).externalObject.showDefaultTooltip) {
                        this._ensureDefaultTooltip(currSeries.item(i).externalObject);
                    }
                }
            }
        };
        IgxFinancialChartComponent.prototype.onImplementationCreated = function () {
            _super.prototype.onImplementationCreated.call(this);
        };
        Object.defineProperty(IgxFinancialChartComponent.prototype, "xAxisBreaks", {
            /**
             * TimeAxisBreaks to apply to this chart when in time axis mode, representing spans of time to omit, such as weekends.
            */
            get: function () {
                if (this._xAxisBreaks === null) {
                    if (!i2.TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection")) {
                        return null;
                    }
                    var coll = i2.TypeRegistrar.create("IgxTimeAxisBreakCollection");
                    var innerColl = this.i.xAxisBreaks;
                    if (!innerColl) {
                        innerColl = i2.TypeRegistrar.create("TimeAxisBreakCollection");
                    }
                    this._xAxisBreaks = coll._fromInner(innerColl);
                }
                return this._xAxisBreaks;
            },
            set: function (v) {
                if (this._xAxisBreaks !== null) {
                    this._xAxisBreaks._setSyncTarget(null);
                    this._xAxisBreaks = null;
                }
                if (!i2.TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection")) {
                    return;
                }
                var coll = i2.TypeRegistrar.create("IgxTimeAxisBreakCollection");
                var t = i2.TypeRegistrar.get("TimeAxisBreak");
                this._xAxisBreaks = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(t.$type);
                var innerColl = this.i.xAxisBreaks;
                if (!innerColl) {
                    innerColl = i2.TypeRegistrar.create("TimeAxisBreakCollection");
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._xAxisBreaks._setSyncTarget(syncColl);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "leftMargin", {
            get: function () {
                return this.i.eb;
            },
            set: function (v) {
                this.i.eb = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "isHorizontalZoomEnabled", {
            get: function () {
                return this.i.cn;
            },
            set: function (v) {
                this.i.cn = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "toolbarHeight", {
            get: function () {
                return this.i.wt;
            },
            set: function (v) {
                this.i.wt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "domainType", {
            /**
             * Gets domain type of this chart
            */
            get: function () {
                return this.i.ai;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisIsLogarithmic", {
            /**
             * Gets or sets whether the Y-axis should use a logarithmic scale instead of a linear one.
             * Since log(-1) is imaginary and log(0) is undefined, it is recommended to enable this property only when the Y-axis minimum is greater than zero.
            */
            get: function () {
                return this.i.vx;
            },
            set: function (v) {
                this.i.vx = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisLogarithmBase", {
            /**
             * Gets or sets the base value to use in the log function when mapping the position of data items along the Y-axis.
             * This property is effective only when YAxisIsLogarithmic is true.
            */
            get: function () {
                return this.i.xl;
            },
            set: function (v) {
                this.i.xl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisInterval", {
            /**
             * Gets or sets the distance between each label and grid line along the Y-axis.
            *
            * The `yAxisInterval` determines how often to show a label, tickmark, and/or gridline along the y-axis.  Set this property to a number less than the numeric range of the y-axis.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     yAxisInterval="10">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.wx;
            },
            set: function (v) {
                this.i.wx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisMinimumValue", {
            /**
             * Gets or sets the data value corresponding to the minimum value of the Y-axis.
            *
            * The `yAxisMinimumValue` determines starting value of labels, tickmarks, and gridlines on the y-axis.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     yAxisMinimumValue="10">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.wz;
            },
            set: function (v) {
                this.i.wz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisMaximumValue", {
            /**
             * Gets or sets the data value corresponding to the maximum value of the Y-axis.
            *
            * The `yAxisMaximumValue` determines ending value of labels, tickmarks, and gridlines on the y-axis.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     yAxisMaximumValue="100">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.wy;
            },
            set: function (v) {
                this.i.wy = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisMinorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines along the Y-axis.
            *
            * The `yAxisMinorInterval` determines how often to show minor gridline along the y-axis.  Set this property to a number less than the `yAxisInterval` and the numeric range of the y-axis.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     yAxisMinorInterval="5">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.w0;
            },
            set: function (v) {
                this.i.w0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisActualMinimum", {
            /**
             * Gets the current minimum value for the Y-axis.
            */
            get: function () {
                return this.i.ww;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisActualMaximum", {
            /**
             * Gets the current maximum value for the Y-axis.
            */
            get: function () {
                return this.i.wv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "volumeType", {
            /**
             * The type of series to display in the volume pane.
            *
            * Use the `volumeType` property to set a type of all series that will be rendered in the volume pane, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     volumeType="Column">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.t1;
            },
            set: function (v) {
                this.i.t1 = i2.ensureEnum(FinancialChartVolumeType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "xAxisMode", {
            /**
             * The scaling mode of the X-axis.
            *
            * Use the `xAxisMode` property to plot data items without any breaks in data range (Ordinal mode) or with breaks in data range (Time mode) such as weekends/holidays. Note that the Ordinal axis mode is less expensive to use in the financial chart than the Time axis mode.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     xAxisMode="Time">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.t3;
            },
            set: function (v) {
                this.i.t3 = i2.ensureEnum(FinancialChartXAxisMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisMode", {
            /**
             * The scaling mode of the Y-axis.
            *
            * Use the `yAxisMode` property to plot data items using their actual values (Numeric) or using percent changes from the first data point (PercentChange), e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     yAxisMode="PercentChange">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.t5;
            },
            set: function (v) {
                this.i.t5 = i2.ensureEnum(FinancialChartYAxisMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "isToolbarVisible", {
            /**
             * A boolean property controlling the visibility of the toolbar.
            */
            get: function () {
                return this.i.vs;
            },
            set: function (v) {
                this.i.vs = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "chartType", {
            /**
             * The type of price series to display in the main chart.
            *
            * Use the `chartType` property to set a type of series that will be used to render prices in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     chartType="Candle">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.tw;
            },
            set: function (v) {
                this.i.tw = i2.ensureEnum(FinancialChartType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisLabelHorizontalAlignment", {
            /**
             * Gets or sets Horizontal alignment of Y-axis labels.
            */
            get: function () {
                return this.i.ro;
            },
            set: function (v) {
                this.i.ro = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "isWindowSyncedToVisibleRange", {
            /**
             * A boolean indicating whether the chart should automatically zoom in vertically on the currently visible range of data.
             * When this property is set to true, panning and zooming along the X-axis will result in a corresponding zoom on the Y-axis, so that the visible range of data fills the zoom window as fully as possible.
            */
            get: function () {
                return this.i.vt;
            },
            set: function (v) {
                this.i.vt = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorTypes", {
            /**
             * A collection indicating what financial indicator types to display on the Financial Chart.
            *
            * Use the `indicatorTypes` property to set types of indicators that will be rendered below the price pane in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="MoneyFlowIndex, AverageTrueRange">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                if (this._indicatorTypes === null) {
                    var coll = new IgxFinancialIndicatorTypeCollection();
                    var innerColl = this.i.ua;
                    if (!innerColl) {
                        innerColl = new FinancialIndicatorTypeCollection(0);
                    }
                    this._indicatorTypes = coll._fromInner(innerColl);
                    this.i.ua = innerColl;
                }
                return this._indicatorTypes;
            },
            set: function (v) {
                if (this._indicatorTypes !== null) {
                    this._indicatorTypes._setSyncTarget(null);
                    this._indicatorTypes = null;
                }
                var coll = new IgxFinancialIndicatorTypeCollection();
                this._indicatorTypes = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(FinancialIndicatorType_$type);
                var innerColl = this.i.ua;
                if (!innerColl) {
                    innerColl = new FinancialIndicatorTypeCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._indicatorTypes._setSyncTarget(syncColl);
                this.i.ua = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "overlayTypes", {
            /**
             * A collection indicating what financial overlay types to display on the Financial Chart.
            *
            * Use the `overlayTypes` property to set types of overlays that will be rendered behind price series in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     overlayTypes="BollingerBands">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                if (this._overlayTypes === null) {
                    var coll = new IgxFinancialOverlayTypeCollection();
                    var innerColl = this.i.uc;
                    if (!innerColl) {
                        innerColl = new FinancialOverlayTypeCollection(0);
                    }
                    this._overlayTypes = coll._fromInner(innerColl);
                    this.i.uc = innerColl;
                }
                return this._overlayTypes;
            },
            set: function (v) {
                if (this._overlayTypes !== null) {
                    this._overlayTypes._setSyncTarget(null);
                    this._overlayTypes = null;
                }
                var coll = new IgxFinancialOverlayTypeCollection();
                this._overlayTypes = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(FinancialOverlayType_$type);
                var innerColl = this.i.uc;
                if (!innerColl) {
                    innerColl = new FinancialOverlayTypeCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._overlayTypes._setSyncTarget(syncColl);
                this.i.uc = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "yAxisAbbreviateLargeNumbers", {
            /**
             * Gets or sets whether the large numbers on the Y-axis labels are abbreviated.
            */
            get: function () {
                return this.i.vw;
            },
            set: function (v) {
                this.i.vw = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "resolution", {
            /**
             * Gets or sets the rendering resolution for all series in this chart.
             * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
            */
            get: function () {
                return this.i.ej;
            },
            set: function (v) {
                this.i.ej = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "zoomSliderType", {
            /**
             * Gets or sets type of series to display in the zoom slider pane.
            *
            * Use the `zoomSliderType` property to set a type of all series that will be rendered in the zoom pane, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     zoomSliderType="Candle">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.t8;
            },
            set: function (v) {
                this.i.t8 = i2.ensureEnum(FinancialChartZoomSliderType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "negativeBrushes", {
            /**
             * Gets or sets the palette used for coloring negative items of Waterfall chart type.
            *
            * Use the `negativeBrushes` property to set a collection of brushes that will be used to render fill area of negative elements in the price pane, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     negativeBrushes="Red, Orange">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s5);
            },
            set: function (v) {
                this.i.s5 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "negativeOutlines", {
            /**
             * Brushes to use for drawing negative elements, when using a chart type with contextual coloring, such as Waterfall.
            *
            * Use the `negativeOutlines` property to set a collection of brushes that will be used to render outline of negative elements in the price pane, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     negativeOutlines="Red, Orange">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s6);
            },
            set: function (v) {
                this.i.s6 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "overlayBrushes", {
            /**
             * Brushes to use for filling financial overlays.
            *
            * Use the `overlayBrushes` property to set a collection of brushes that will be used to render fill area of overlays in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     overlayTypes="BollingerBands"
            *     overlayBrushes="Green">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s7);
            },
            set: function (v) {
                this.i.s7 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "overlayOutlines", {
            /**
             * Brushes to use for outlining financial overlays.
            *
            * Use the `overlayOutlines` property to set a collection of brushes that will be used to render outlines of overlays in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     overlayTypes="BollingerBands"
            *     overlayOutlines="Green">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s8);
            },
            set: function (v) {
                this.i.s8 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "volumeOutlines", {
            /**
             * Brushes to use for outlining volume series in the volume pane.
            *
            * Use the `volumeOutlines` property to set a collection of brushes that will be used to render outline of multiple series in the volume pane of the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     volumeOutlines="Green, Blue">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ta);
            },
            set: function (v) {
                this.i.ta = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "volumeBrushes", {
            /**
             * Brushes to use for filling volume series in the volume pane.
            *
            * Use the `volumeBrushes` property to set a collection of brushes that will be used to render fill area of multiple series in the volume pane of the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     volumeBrushes="Green, Blue">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s9);
            },
            set: function (v) {
                this.i.s9 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorNegativeBrushes", {
            /**
             * Brushes to use for negative elements in financial indicators.
            *
            * Use the `indicatorNegativeBrushes` property to set a collection of brushes that will be used to render negative elements of indicators in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
            *     indicatorNegativeBrushes="Red, Orange">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s4);
            },
            set: function (v) {
                this.i.s4 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorBrushes", {
            /**
             * Brushes to use for financial indicators.
            *
            * Use the `indicatorBrushes` property to set a collection of brushes that will be used to render positive elements of indicators in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
            *     indicatorBrushes="Green, Blue">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return i2.fromBrushCollection(this.i.s3);
            },
            set: function (v) {
                this.i.s3 = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "volumeThickness", {
            /**
             * The outline thickness of volume series in the volume pane.
            *
            * Use the `volumeThickness` property to set a number that will be used to render outline thickness of all series in the volume pane, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     volumeThickness="2.5">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.wu;
            },
            set: function (v) {
                this.i.wu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "overlayThickness", {
            /**
             * The outline thickness of financial overlays.
            *
            * Use the `overlayThickness` property to set a number that will be used to render outline thickness of all overlays in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     overlayTypes="BollingerBands"
            *     overlayThickness="2.5">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.ws;
            },
            set: function (v) {
                this.i.ws = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "overlayMultiplier", {
            /**
             * The multiplier of financial overlay, e.g. BollingerBands overlay.
            */
            get: function () {
                return this.i.wr;
            },
            set: function (v) {
                this.i.wr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorThickness", {
            /**
             * The outline or stroke thickness of financial indicators.
            *
            * Use the `indicatorThickness` property to set a number that will be used to render outline thickness of all indicators in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
            *     indicatorThickness="2.5">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.wq;
            },
            set: function (v) {
                this.i.wq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorDisplayTypes", {
            /**
             * The display types of financial indicators.
            *
            * Use the `indicatorDisplayTypes` property to set display types that will determine whether render all indicators as area, lines, or columns in the Financial Chart control, e.g.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
            *     indicatorDisplayTypes="Line, Line">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                if (this._indicatorDisplayTypes === null) {
                    var coll = new IgxIndicatorDisplayTypeCollection();
                    var innerColl = this.i.um;
                    if (!innerColl) {
                        innerColl = new IndicatorDisplayTypeCollection();
                    }
                    this._indicatorDisplayTypes = coll._fromInner(innerColl);
                    this.i.um = innerColl;
                }
                return this._indicatorDisplayTypes;
            },
            set: function (v) {
                if (this._indicatorDisplayTypes !== null) {
                    this._indicatorDisplayTypes._setSyncTarget(null);
                    this._indicatorDisplayTypes = null;
                }
                var coll = new IgxIndicatorDisplayTypeCollection();
                this._indicatorDisplayTypes = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(IndicatorDisplayType_$type);
                var innerColl = this.i.um;
                if (!innerColl) {
                    innerColl = new IndicatorDisplayTypeCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._indicatorDisplayTypes._setSyncTarget(syncColl);
                this.i.um = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorPeriod", {
            /**
             * The period of financial indicators, where applicable.
            *
            * The `indicatorPeriod` property applies to only the `BollingerBands` overlay as well as to these indicators types: `AverageDirectionalIndex`, `AverageTrueRange`, `BollingerBandWidth`, `ChaikinVolatility`, `CommodityChannelIndex`, `DetrendedPriceOscillator`, `FastStochasticOscillator`, `ForceIndex`, `FullStochasticOscillator`, `MoneyFlowIndex`, `IgxPriceChannelOverlayComponent`, `RateOfChangeAndMomentum`, `RelativeStrengthIndex`, `SlowStochasticOscillator`, `StandardDeviation`, `StochRSI`, `TRIX`, `WilliamsPercentR`
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="AverageTrueRange"
            *     indicatorPeriod="8">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.xg;
            },
            set: function (v) {
                this.i.xg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorMultiplier", {
            /**
             * The multiplier of financial indicators, e.g. BollingerBandWidth indicator.
            *
            * The `indicatorMultiplier` property applies to only to BollingerBandWidth indicator type.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="BollingerBandWidth"
            *     indicatorMultiplier="8">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.wp;
            },
            set: function (v) {
                this.i.wp = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorSmoothingPeriod", {
            /**
             * The smoothing period of financial indicators, where applicable.
            *
            * The `indicatorSmoothingPeriod` property applies to only to `FullStochasticOscillator` indicator type.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="FullStochasticOscillator"
            *     indicatorSmoothingPeriod="8">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.xj;
            },
            set: function (v) {
                this.i.xj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorShortPeriod", {
            /**
             * The short period of financial indicators, where applicable.
            *
            * The `indicatorShortPeriod` property applies only to these indicator types:
            *
            * -   AbsoluteVolumeOscillator,
            * -   ChaikinOscillator,
            * -   MovingAverageConvergenceDivergence,
            * -   PercentagePriceOscillator,
            * -   PercentageVolumeOscillator,
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="ChaikinOscillator"
            *     indicatorShortPeriod="8">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.xh;
            },
            set: function (v) {
                this.i.xh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorLongPeriod", {
            /**
             * The long period of financial indicators, where applicable.
            *
            * The `indicatorLongPeriod` property applies only to these indicator types:
            *
            * -   AbsoluteVolumeOscillator,
            * -   ChaikinOscillator,
            * -   MovingAverageConvergenceDivergence,
            * -   PercentagePriceOscillator,
            * -   PercentageVolumeOscillator,
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="ChaikinOscillator"
            *     indicatorLongPeriod="8">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.xf;
            },
            set: function (v) {
                this.i.xf = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "indicatorSignalPeriod", {
            /**
             * The signal period of financial indicators, where applicable.
            *
            * The `indicatorSignalPeriod` property applies to only to MovingAverageConvergenceDivergence indicator type.
            *
            * ```html
            * <igx-financial-chart
            *     [dataSource]="data"
            *     indicatorTypes="MovingAverageConvergenceDivergence"
            *     indicatorSignalPeriod="8">
            * </igx-financial-chart>
            * ```
            */
            get: function () {
                return this.i.xi;
            },
            set: function (v) {
                this.i.xi = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "rangeSelectorOptions", {
            /**
             * A FinancialChartRangeSelectorOptionCollection containing the available range selector options on the toolbar.
            */
            get: function () {
                if (this._rangeSelectorOptions === null) {
                    var coll = new IgxFinancialChartRangeSelectorOptionCollection();
                    var innerColl = this.i.ts;
                    if (!innerColl) {
                        innerColl = new FinancialChartRangeSelectorOptionCollection(0);
                    }
                    this._rangeSelectorOptions = coll._fromInner(innerColl);
                    this.i.ts = innerColl;
                }
                return this._rangeSelectorOptions;
            },
            set: function (v) {
                if (this._rangeSelectorOptions !== null) {
                    this._rangeSelectorOptions._setSyncTarget(null);
                    this._rangeSelectorOptions = null;
                }
                var coll = new IgxFinancialChartRangeSelectorOptionCollection();
                this._rangeSelectorOptions = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(FinancialChartRangeSelectorOption_$type);
                var innerColl = this.i.ts;
                if (!innerColl) {
                    innerColl = new FinancialChartRangeSelectorOptionCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._rangeSelectorOptions._setSyncTarget(syncColl);
                this.i.ts = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "customIndicatorNames", {
            /**
             * The names of custom indicators to add to the chart.
             * When CustomIndicatorNames is set, the ApplyCustomIndicators event will be raised for each custom indicator name.
            */
            get: function () {
                if (this._customIndicatorNames === null) {
                    var coll = new IgxCustomIndicatorNameCollection();
                    var innerColl = this.i.customIndicatorNames;
                    if (!innerColl) {
                        innerColl = new CustomIndicatorNameCollection(0);
                    }
                    this._customIndicatorNames = coll._fromInner(innerColl);
                    this.i.customIndicatorNames = innerColl;
                }
                return this._customIndicatorNames;
            },
            set: function (v) {
                if (this._customIndicatorNames !== null) {
                    this._customIndicatorNames._setSyncTarget(null);
                    this._customIndicatorNames = null;
                }
                var coll = new IgxCustomIndicatorNameCollection();
                this._customIndicatorNames = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.String_$type);
                var innerColl = this.i.customIndicatorNames;
                if (!innerColl) {
                    innerColl = new CustomIndicatorNameCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._customIndicatorNames._setSyncTarget(syncColl);
                this.i.customIndicatorNames = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "isVerticalZoomEnabled", {
            get: function () {
                return this.i.ct;
            },
            set: function (v) {
                this.i.ct = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "zoomSliderXAxisMajorStroke", {
            /**
             * Gets or sets stroke brush of major gridlines on x-axis of the zoom slider pane
            */
            get: function () {
                return i2.brushToString(this.i.abn);
            },
            set: function (v) {
                this.i.abn = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "zoomSliderXAxisMajorStrokeThickness", {
            /**
             * Gets or sets thickness of major gridlines on x-axis of the zoom slider pane
            */
            get: function () {
                return this.i.w1;
            },
            set: function (v) {
                this.i.w1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "isLegendVisible", {
            /**
             * Gets or sets weather or not a legend is visible between toolbar and chart's plot area
            */
            get: function () {
                return this.i.vo;
            },
            set: function (v) {
                this.i.vo = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "xAxisMinimumValue", {
            /**
             * Gets or sets minimum value on x-axis
            */
            get: function () {
                return this.i.wc;
            },
            set: function (v) {
                this.i.wc = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialChartComponent.prototype, "xAxisMaximumValue", {
            /**
             * Gets or sets maximum value on x-axis
            */
            get: function () {
                return this.i.wb;
            },
            set: function (v) {
                this.i.wb = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialChartComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.indicatorTypes != null && this.indicatorTypes.findByName && this.indicatorTypes.findByName(name)) {
                return this.indicatorTypes.findByName(name);
            }
            if (this.overlayTypes != null && this.overlayTypes.findByName && this.overlayTypes.findByName(name)) {
                return this.overlayTypes.findByName(name);
            }
            if (this.indicatorDisplayTypes != null && this.indicatorDisplayTypes.findByName && this.indicatorDisplayTypes.findByName(name)) {
                return this.indicatorDisplayTypes.findByName(name);
            }
            if (this.rangeSelectorOptions != null && this.rangeSelectorOptions.findByName && this.rangeSelectorOptions.findByName(name)) {
                return this.rangeSelectorOptions.findByName(name);
            }
            if (this.xAxisBreaks != null && this.xAxisBreaks.findByName && this.xAxisBreaks.findByName(name)) {
                return this.xAxisBreaks.findByName(name);
            }
            return null;
        };
        /**
     * Called by the UI framework to provide a UI container for rendering this control.

    * @param container  * The UI container element.
    */
        IgxFinancialChartComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        IgxFinancialChartComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.jt(source_, index, newItem);
        };
        IgxFinancialChartComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.ju(source_, index, oldItem);
        };
        IgxFinancialChartComponent.prototype.notifyClearItems = function (source_) {
            this.i.js(source_);
        };
        IgxFinancialChartComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.jw(source_, index, oldItem, newItem);
        };
        /**
         * Returns visuals as a serialized string.
        
        */
        IgxFinancialChartComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.x5();
            return (iv);
        };
        Object.defineProperty(IgxFinancialChartComponent.prototype, "applyCustomIndicators", {
            /**
             * Event raised by the chart when custom indicator data is needed from the application.
             * During series rendering, event will be raised once for each value in the CustomIndicatorNames collection.
            */
            get: function () {
                var _this = this;
                if (this._applyCustomIndicators == null) {
                    this._applyCustomIndicators = new i0.EventEmitter();
                    this.i.applyCustomIndicators = i2.delegateCombine(this.i.applyCustomIndicators, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFinancialChartCustomIndicatorArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeApplyCustomIndicators) {
                                _this.beforeApplyCustomIndicators(_this, outerArgs);
                            }
                            _this._applyCustomIndicators.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._applyCustomIndicators;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialChartComponent, selector: "igx-financial-chart", inputs: { height: "height", width: "width", rangeSelectorTemplate: "rangeSelectorTemplate", chartTypePickerTemplate: "chartTypePickerTemplate", indicatorMenuTemplate: "indicatorMenuTemplate", toolbarTemplate: "toolbarTemplate", chartTemplate: "chartTemplate", dataSource: "dataSource", xAxisBreaks: "xAxisBreaks", leftMargin: "leftMargin", isHorizontalZoomEnabled: "isHorizontalZoomEnabled", toolbarHeight: "toolbarHeight", yAxisIsLogarithmic: "yAxisIsLogarithmic", yAxisLogarithmBase: "yAxisLogarithmBase", yAxisInterval: "yAxisInterval", yAxisMinimumValue: "yAxisMinimumValue", yAxisMaximumValue: "yAxisMaximumValue", yAxisMinorInterval: "yAxisMinorInterval", volumeType: "volumeType", xAxisMode: "xAxisMode", yAxisMode: "yAxisMode", isToolbarVisible: "isToolbarVisible", chartType: "chartType", yAxisLabelHorizontalAlignment: "yAxisLabelHorizontalAlignment", isWindowSyncedToVisibleRange: "isWindowSyncedToVisibleRange", indicatorTypes: "indicatorTypes", overlayTypes: "overlayTypes", yAxisAbbreviateLargeNumbers: "yAxisAbbreviateLargeNumbers", resolution: "resolution", zoomSliderType: "zoomSliderType", negativeBrushes: "negativeBrushes", negativeOutlines: "negativeOutlines", overlayBrushes: "overlayBrushes", overlayOutlines: "overlayOutlines", volumeOutlines: "volumeOutlines", volumeBrushes: "volumeBrushes", indicatorNegativeBrushes: "indicatorNegativeBrushes", indicatorBrushes: "indicatorBrushes", volumeThickness: "volumeThickness", overlayThickness: "overlayThickness", overlayMultiplier: "overlayMultiplier", indicatorThickness: "indicatorThickness", indicatorDisplayTypes: "indicatorDisplayTypes", indicatorPeriod: "indicatorPeriod", indicatorMultiplier: "indicatorMultiplier", indicatorSmoothingPeriod: "indicatorSmoothingPeriod", indicatorShortPeriod: "indicatorShortPeriod", indicatorLongPeriod: "indicatorLongPeriod", indicatorSignalPeriod: "indicatorSignalPeriod", rangeSelectorOptions: "rangeSelectorOptions", customIndicatorNames: "customIndicatorNames", isVerticalZoomEnabled: "isVerticalZoomEnabled", zoomSliderXAxisMajorStroke: "zoomSliderXAxisMajorStroke", zoomSliderXAxisMajorStrokeThickness: "zoomSliderXAxisMajorStrokeThickness", isLegendVisible: "isLegendVisible", xAxisMinimumValue: "xAxisMinimumValue", xAxisMaximumValue: "xAxisMaximumValue" }, outputs: { applyCustomIndicators: "applyCustomIndicators" }, host: { listeners: { "document:click": "onDocumentClick($event)" }, classAttribute: "ig-financial-chart igx-financial-chart" }, providers: [], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }, { propertyName: "_defaultTemplates", first: true, predicate: IgxFinancialChartDefaultTemplatesComponent, descendants: true, static: true }, { propertyName: "_toolbarElement", first: true, predicate: ["toolbarContent"], descendants: true, read: i0.ElementRef, static: true }, { propertyName: "_mainElement", first: true, predicate: ["mainContent"], descendants: true, read: i0.ElementRef, static: true }, { propertyName: "_templates", predicate: i2.IgxTemplateContentComponent, descendants: true }], usesInheritance: true, ngImport: i0, template: "\n    <ng-template #financialChartTemplate>\n        <div class='financialChartMainGrid'>\n\t\t    <div class='financialChartToolbar'></div>\n            <div class='financialChartLegend'></div>\n\t\t    <div class='financialChartPrice'></div>\n\t\t    <div class='financialChartIndicators'></div>\n\t\t    <div class='financialChartVolume'></div>\n\t\t    <div class='financialChartZoomSlider'></div>\n\t    </div>\n    </ng-template>\n\n    <ng-container #dynamicContent></ng-container>\n    <igx-financial-chart-default-templates #defaultTemplates></igx-financial-chart-default-templates>\n    <igx-template-content #toolbarContent style=\"display: none\"></igx-template-content>\n\t<igx-template-content\n\t\tstyle=\"width: 100%; height: 100%\"\n\t\t#mainContent [template]=\"chartTemplate ? chartTemplate : financialChartTemplate\"></igx-template-content>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n        .financialChartToolbar {\n            grid-row: 1;\n            -ms-grid-row: 1;\n        }\n        .financialChartPrice {\n            grid-row: 3;\n            -ms-grid-row: 3;\n        }\n        .financialChartPrice, .financialChartPrice > div {\n            min-height: 100px;\n        }\n        .financialChartIndicators {\n            grid-row: 4;\n            -ms-grid-row: 4;\n        }\n        .financialChartVolume {\n            grid-row: 5;\n            -ms-grid-row: 5;\n        }\n        .financialChartZoomSlider {\n            grid-row: 6;\n            -ms-grid-row: 6;\n        }\n\t\t.financialChartMainGrid {\n\t\t\theight: 100%;\n\t\t\twidth: 100%;\n\t\t\tdisplay: grid;\n\t\t\tdisplay: -ms-grid;\n\t\t\t-ms-grid-columns: 100%;\n\t\t}\n        .financialChartLegend {\n\t        grid-row: 2;\n\t        -ms-grid-row: 2;\n        }\n\t"], components: [{ type: IgxFinancialChartDefaultTemplatesComponent, selector: "igx-financial-chart-default-templates", outputs: ["onContentReady"] }, { type: i2.IgxTemplateContentComponent, selector: "igx-template-content", inputs: ["template", "context"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFinancialChartComponent;
    }(IgxXYChartComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-financial-chart',
                        template: "\n    <ng-template #financialChartTemplate>\n        <div class='financialChartMainGrid'>\n\t\t    <div class='financialChartToolbar'></div>\n            <div class='financialChartLegend'></div>\n\t\t    <div class='financialChartPrice'></div>\n\t\t    <div class='financialChartIndicators'></div>\n\t\t    <div class='financialChartVolume'></div>\n\t\t    <div class='financialChartZoomSlider'></div>\n\t    </div>\n    </ng-template>\n\n    <ng-container #dynamicContent></ng-container>\n    <igx-financial-chart-default-templates #defaultTemplates></igx-financial-chart-default-templates>\n    <igx-template-content #toolbarContent style=\"display: none\"></igx-template-content>\n\t<igx-template-content\n\t\tstyle=\"width: 100%; height: 100%\"\n\t\t#mainContent [template]=\"chartTemplate ? chartTemplate : financialChartTemplate\"></igx-template-content>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n        .financialChartToolbar {\n            grid-row: 1;\n            -ms-grid-row: 1;\n        }\n        .financialChartPrice {\n            grid-row: 3;\n            -ms-grid-row: 3;\n        }\n        .financialChartPrice, .financialChartPrice > div {\n            min-height: 100px;\n        }\n        .financialChartIndicators {\n            grid-row: 4;\n            -ms-grid-row: 4;\n        }\n        .financialChartVolume {\n            grid-row: 5;\n            -ms-grid-row: 5;\n        }\n        .financialChartZoomSlider {\n            grid-row: 6;\n            -ms-grid-row: 6;\n        }\n\t\t.financialChartMainGrid {\n\t\t\theight: 100%;\n\t\t\twidth: 100%;\n\t\t\tdisplay: grid;\n\t\t\tdisplay: -ms-grid;\n\t\t\t-ms-grid-columns: 100%;\n\t\t}\n        .financialChartLegend {\n\t        grid-row: 2;\n\t        -ms-grid-row: 2;\n        }\n\t"],
                        host: {
                            '(document:click)': 'onDocumentClick($event)',
                            class: "ig-financial-chart igx-financial-chart"
                        }
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], _defaultTemplates: [{
                    type: i0.ViewChild,
                    args: [IgxFinancialChartDefaultTemplatesComponent, { static: true }]
                }], _templates: [{
                    type: i0.ViewChildren,
                    args: [i2.IgxTemplateContentComponent]
                }], _toolbarElement: [{
                    type: i0.ViewChild,
                    args: ['toolbarContent', { read: i0.ElementRef, static: true }]
                }], _mainElement: [{
                    type: i0.ViewChild,
                    args: ['mainContent', { read: i0.ElementRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], rangeSelectorTemplate: [{
                    type: i0.Input
                }], chartTypePickerTemplate: [{
                    type: i0.Input
                }], indicatorMenuTemplate: [{
                    type: i0.Input
                }], toolbarTemplate: [{
                    type: i0.Input
                }], chartTemplate: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], xAxisBreaks: [{
                    type: i0.Input
                }], leftMargin: [{
                    type: i0.Input
                }], isHorizontalZoomEnabled: [{
                    type: i0.Input
                }], toolbarHeight: [{
                    type: i0.Input
                }], yAxisIsLogarithmic: [{
                    type: i0.Input
                }], yAxisLogarithmBase: [{
                    type: i0.Input
                }], yAxisInterval: [{
                    type: i0.Input
                }], yAxisMinimumValue: [{
                    type: i0.Input
                }], yAxisMaximumValue: [{
                    type: i0.Input
                }], yAxisMinorInterval: [{
                    type: i0.Input
                }], volumeType: [{
                    type: i0.Input
                }], xAxisMode: [{
                    type: i0.Input
                }], yAxisMode: [{
                    type: i0.Input
                }], isToolbarVisible: [{
                    type: i0.Input
                }], chartType: [{
                    type: i0.Input
                }], yAxisLabelHorizontalAlignment: [{
                    type: i0.Input
                }], isWindowSyncedToVisibleRange: [{
                    type: i0.Input
                }], indicatorTypes: [{
                    type: i0.Input
                }], overlayTypes: [{
                    type: i0.Input
                }], yAxisAbbreviateLargeNumbers: [{
                    type: i0.Input
                }], resolution: [{
                    type: i0.Input
                }], zoomSliderType: [{
                    type: i0.Input
                }], negativeBrushes: [{
                    type: i0.Input
                }], negativeOutlines: [{
                    type: i0.Input
                }], overlayBrushes: [{
                    type: i0.Input
                }], overlayOutlines: [{
                    type: i0.Input
                }], volumeOutlines: [{
                    type: i0.Input
                }], volumeBrushes: [{
                    type: i0.Input
                }], indicatorNegativeBrushes: [{
                    type: i0.Input
                }], indicatorBrushes: [{
                    type: i0.Input
                }], volumeThickness: [{
                    type: i0.Input
                }], overlayThickness: [{
                    type: i0.Input
                }], overlayMultiplier: [{
                    type: i0.Input
                }], indicatorThickness: [{
                    type: i0.Input
                }], indicatorDisplayTypes: [{
                    type: i0.Input
                }], indicatorPeriod: [{
                    type: i0.Input
                }], indicatorMultiplier: [{
                    type: i0.Input
                }], indicatorSmoothingPeriod: [{
                    type: i0.Input
                }], indicatorShortPeriod: [{
                    type: i0.Input
                }], indicatorLongPeriod: [{
                    type: i0.Input
                }], indicatorSignalPeriod: [{
                    type: i0.Input
                }], rangeSelectorOptions: [{
                    type: i0.Input
                }], customIndicatorNames: [{
                    type: i0.Input
                }], isVerticalZoomEnabled: [{
                    type: i0.Input
                }], zoomSliderXAxisMajorStroke: [{
                    type: i0.Input
                }], zoomSliderXAxisMajorStrokeThickness: [{
                    type: i0.Input
                }], isLegendVisible: [{
                    type: i0.Input
                }], xAxisMinimumValue: [{
                    type: i0.Input
                }], xAxisMaximumValue: [{
                    type: i0.Input
                }], applyCustomIndicators: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialChartCoreModule() {
        }
        IgxFinancialChartCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialChartCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreModule, declarations: [IgxFinancialChartComponent,
                IgxFinancialChartDefaultTemplatesComponent], imports: [i1.CommonModule, i2.IgxTemplateContentModule], exports: [IgxFinancialChartComponent,
                IgxFinancialChartDefaultTemplatesComponent,
                i2.IgxTemplateContentModule] });
        IgxFinancialChartCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreModule, imports: [[i1.CommonModule, i2.IgxTemplateContentModule
                ], i2.IgxTemplateContentModule] });
        return IgxFinancialChartCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFinancialChartComponent,
                            IgxFinancialChartDefaultTemplatesComponent],
                        exports: [IgxFinancialChartComponent,
                            IgxFinancialChartDefaultTemplatesComponent,
                            i2.IgxTemplateContentModule
                        ],
                        imports: [i1.CommonModule, i2.IgxTemplateContentModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialChartCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialChartCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxFinancialChartComponent', IgxFinancialChartComponent);
            i2.TypeRegistrar.registerCons('IgxFinancialChartDefaultTemplatesComponent', IgxFinancialChartDefaultTemplatesComponent);
        }
        IgxFinancialChartCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialChartCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreDynamicModule, imports: [i1.CommonModule, i2.IgxTemplateContentDynamicModule,
                IgxFinancialChartCoreModule], exports: [i2.IgxTemplateContentDynamicModule,
                IgxFinancialChartCoreModule] });
        IgxFinancialChartCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreDynamicModule, imports: [[i1.CommonModule, i2.IgxTemplateContentDynamicModule,
                    IgxFinancialChartCoreModule
                ], i2.IgxTemplateContentDynamicModule,
                IgxFinancialChartCoreModule] });
        return IgxFinancialChartCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxTemplateContentDynamicModule,
                            IgxFinancialChartCoreModule
                        ],
                        imports: [i1.CommonModule, i2.IgxTemplateContentDynamicModule,
                            IgxFinancialChartCoreModule
                        ],
                        entryComponents: [IgxFinancialChartComponent,
                            IgxFinancialChartDefaultTemplatesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var ZoomSliderOrientation = /*@__PURE__*/ (function (ZoomSliderOrientation) {
        ZoomSliderOrientation[ZoomSliderOrientation["Horizontal"] = 0] = "Horizontal";
        ZoomSliderOrientation[ZoomSliderOrientation["Vertical"] = 1] = "Vertical";
        return ZoomSliderOrientation;
    })({});
    /**
     * @hidden
     */
    var ZoomSliderOrientation_$type = i2.markEnum('ZoomSliderOrientation', 'Horizontal,0|Vertical,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ZoomSliderResolvingAxisValueEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ZoomSliderResolvingAxisValueEventArgs, _super);
        function ZoomSliderResolvingAxisValueEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._position = 0;
            _this._value = null;
            return _this;
        }
        Object.defineProperty(ZoomSliderResolvingAxisValueEventArgs.prototype, "position", {
            get: function () {
                return this._position;
            },
            set: function (a) {
                this._position = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSliderResolvingAxisValueEventArgs.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (a) {
                this._value = a;
            },
            enumerable: false,
            configurable: true
        });
        ZoomSliderResolvingAxisValueEventArgs.$t = i2.markType(ZoomSliderResolvingAxisValueEventArgs, 'ZoomSliderResolvingAxisValueEventArgs');
        return ZoomSliderResolvingAxisValueEventArgs;
    }(i2.Base));

    var IgxZoomSliderResolvingAxisValueEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxZoomSliderResolvingAxisValueEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxZoomSliderResolvingAxisValueEventArgs.prototype.createImplementation = function () {
            return new ZoomSliderResolvingAxisValueEventArgs();
        };
        Object.defineProperty(IgxZoomSliderResolvingAxisValueEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxZoomSliderResolvingAxisValueEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxZoomSliderResolvingAxisValueEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxZoomSliderResolvingAxisValueEventArgs.prototype, "position", {
            get: function () {
                return this.i.position;
            },
            set: function (v) {
                this.i.position = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderResolvingAxisValueEventArgs.prototype, "value", {
            get: function () {
                return this.i.value;
            },
            set: function (v) {
                this.i.value = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxZoomSliderResolvingAxisValueEventArgs;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrackThumbVisual_$type = new i2.Type(null, 'ITrackThumbVisual');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultTrackThumbVisual = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultTrackThumbVisual, _super);
        function DefaultTrackThumbVisual() {
            var _this = _super.call(this) || this;
            _this._translateX = 0;
            _this._translateY = 0;
            _this.c = -1;
            _this.a = 0;
            _this.b = -1;
            _this._thumbBox = null;
            _this._thumbRidges = null;
            _this._allPaths = null;
            _this.thumbBox = new i2.Path();
            _this.thumbRidges = new i2.Path();
            _this.allPaths = new i2.List$1(i2.Path.$, 0);
            _this.allPaths.add(_this.thumbBox);
            _this.allPaths.add(_this.thumbRidges);
            _this.width = _this.getTrackThumbDefaultWidth();
            _this.height = _this.getTrackThumbDefaultHeight();
            _this.thumbBox._stroke = _this.getThumbBoxDefaultStroke();
            _this.thumbBox.ac = _this.getThumbBoxDefaultStrokeThickness();
            _this.thumbBox._fill = _this.getThumbBoxDefaultBrush();
            _this.thumbRidges._stroke = _this.getThumbRidgesDefaultStroke();
            _this.thumbRidges.ac = 1;
            return _this;
        }
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "translateX", {
            get: function () {
                return this._translateX;
            },
            set: function (a) {
                this._translateX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "translateY", {
            get: function () {
                return this._translateY;
            },
            set: function (a) {
                this._translateY = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackThumbVisual.prototype.getTrackThumbDefaultWidth = function () {
            return 10;
        };
        DefaultTrackThumbVisual.prototype.getTrackThumbDefaultHeight = function () {
            return 22;
        };
        DefaultTrackThumbVisual.prototype.getThumbBoxDefaultStroke = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 185, 185, 185);
                return $ret;
            })());
        };
        DefaultTrackThumbVisual.prototype.getThumbBoxDefaultStrokeThickness = function () {
            return 1;
        };
        DefaultTrackThumbVisual.prototype.getThumbBoxDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 249, 249, 249);
                return $ret;
            })());
        };
        DefaultTrackThumbVisual.prototype.getThumbRidgesDefaultStroke = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 119, 119, 119);
                return $ret;
            })());
        };
        DefaultTrackThumbVisual.prototype.e = function () {
            if (this.orientation == 0) {
                var a = new i2.PathGeometry();
                var b = new i2.PathFigure();
                var c = new i2.LineSegment(1);
                b._isClosed = false;
                b._isFilled = false;
                b._startPoint = { $type: i2.Point_$type, x: -1.5, y: -4 };
                c.c = { $type: i2.Point_$type, x: -1.5, y: 4 };
                b._segments.add(c);
                a.c.add(b);
                var d = new i2.PathFigure();
                var e = new i2.LineSegment(1);
                d._isClosed = false;
                d._isFilled = false;
                d._startPoint = { $type: i2.Point_$type, x: 1.5, y: -4 };
                e.c = { $type: i2.Point_$type, x: 1.5, y: 4 };
                d._segments.add(e);
                a.c.add(d);
                this.thumbRidges.ak = a;
            }
            else {
                var f = new i2.PathGeometry();
                var g = new i2.PathFigure();
                var h = new i2.LineSegment(1);
                g._isClosed = false;
                g._isFilled = false;
                g._startPoint = { $type: i2.Point_$type, x: -4, y: -1.5 };
                h.c = { $type: i2.Point_$type, x: 4, y: -1.5 };
                g._segments.add(h);
                f.c.add(g);
                var i = new i2.PathFigure();
                var j = new i2.LineSegment(1);
                i._isClosed = false;
                i._isFilled = false;
                i._startPoint = { $type: i2.Point_$type, x: -4, y: 1.5 };
                j.c = { $type: i2.Point_$type, x: 4, y: 1.5 };
                i._segments.add(j);
                f.c.add(i);
                this.thumbRidges.ak = f;
            }
        };
        DefaultTrackThumbVisual.prototype.d = function () {
            var a = new i2.PathGeometry();
            var b = new i2.PathFigure();
            var c = new i2.PolyLineSegment();
            b._isClosed = true;
            b._isFilled = true;
            b._startPoint = { $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 };
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / 2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 });
            b._segments.add(c);
            a.c.add(b);
            this.thumbBox.ak = a;
        };
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "width", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackThumbVisual.prototype.f = function () {
            if (this.width > 0 && this.height > 0) {
                this.d();
                this.e();
            }
        };
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "orientation", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (this.a != b) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "height", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                if (this.b != b) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "thumbBox", {
            get: function () {
                return this._thumbBox;
            },
            set: function (a) {
                this._thumbBox = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "thumbRidges", {
            get: function () {
                return this._thumbRidges;
            },
            set: function (a) {
                this._thumbRidges = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbVisual.prototype, "allPaths", {
            get: function () {
                return this._allPaths;
            },
            set: function (a) {
                this._allPaths = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackThumbVisual.$t = i2.markType(DefaultTrackThumbVisual, 'DefaultTrackThumbVisual', i2.Base.$, [ITrackThumbVisual_$type]);
        return DefaultTrackThumbVisual;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrackRangeVisual_$type = new i2.Type(null, 'ITrackRangeVisual');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultTrackRangeVisual = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultTrackRangeVisual, _super);
        function DefaultTrackRangeVisual() {
            var _this = _super.call(this) || this;
            _this._translateX = 0;
            _this._translateY = 0;
            _this.a = 0;
            _this.c = -1;
            _this.b = -1;
            _this._thumbBox = null;
            _this._thumbRidges = null;
            _this._allPaths = null;
            _this.thumbBox = new i2.Path();
            _this.thumbRidges = new i2.Path();
            _this.allPaths = new i2.List$1(i2.Path.$, 0);
            _this.allPaths.add(_this.thumbBox);
            _this.allPaths.add(_this.thumbRidges);
            _this.thumbBox._stroke = _this.getThumbBoxDefaultStroke();
            _this.thumbBox.ac = 1;
            _this.thumbBox._fill = _this.getThumbBoxDefaultBrush();
            _this.thumbRidges._stroke = _this.getThumbRidgesDefaultStroke();
            _this.thumbRidges.ac = 1;
            return _this;
        }
        DefaultTrackRangeVisual.prototype.getThumbBoxDefaultStroke = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 185, 185, 185);
                return $ret;
            })());
        };
        DefaultTrackRangeVisual.prototype.getThumbBoxDefaultStrokeThickness = function () {
            return 1;
        };
        DefaultTrackRangeVisual.prototype.getThumbBoxDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 249, 249, 249);
                return $ret;
            })());
        };
        DefaultTrackRangeVisual.prototype.getThumbRidgesDefaultStroke = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 119, 119, 119);
                return $ret;
            })());
        };
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "translateX", {
            get: function () {
                return this._translateX;
            },
            set: function (a) {
                this._translateX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "translateY", {
            get: function () {
                return this._translateY;
            },
            set: function (a) {
                this._translateY = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackRangeVisual.prototype.e = function () {
            if (this.orientation == 0) {
                var a = new i2.PathGeometry();
                var b = new i2.PathFigure();
                var c = new i2.LineSegment(1);
                b._isClosed = false;
                b._isFilled = false;
                b._startPoint = { $type: i2.Point_$type, x: -3, y: (this.height / -2) * 0.5 };
                c.c = { $type: i2.Point_$type, x: -3, y: (this.height / 2) * 0.5 };
                b._segments.add(c);
                a.c.add(b);
                var d = new i2.PathFigure();
                var e = new i2.LineSegment(1);
                d._isClosed = false;
                d._isFilled = false;
                d._startPoint = { $type: i2.Point_$type, x: 0, y: (this.height / -2) * 0.5 };
                e.c = { $type: i2.Point_$type, x: 0, y: (this.height / 2) * 0.5 };
                d._segments.add(e);
                a.c.add(d);
                var f = new i2.PathFigure();
                var g = new i2.LineSegment(1);
                f._isClosed = false;
                f._isFilled = false;
                f._startPoint = { $type: i2.Point_$type, x: 3, y: (this.height / -2) * 0.5 };
                g.c = { $type: i2.Point_$type, x: 3, y: (this.height / 2) * 0.5 };
                f._segments.add(g);
                a.c.add(f);
                this.thumbRidges.ak = a;
            }
            else {
                var h = new i2.PathGeometry();
                var i = new i2.PathFigure();
                var j = new i2.LineSegment(1);
                i._isClosed = false;
                i._isFilled = false;
                i._startPoint = { $type: i2.Point_$type, x: (this.width / -2) * 0.5, y: -3 };
                j.c = { $type: i2.Point_$type, x: (this.width / 2) * 0.5, y: -3 };
                i._segments.add(j);
                h.c.add(i);
                var k = new i2.PathFigure();
                var l = new i2.LineSegment(1);
                k._isClosed = false;
                k._isFilled = false;
                k._startPoint = { $type: i2.Point_$type, x: (this.width / -2) * 0.5, y: 0 };
                l.c = { $type: i2.Point_$type, x: (this.width / 2) * 0.5, y: 0 };
                k._segments.add(l);
                h.c.add(k);
                var m = new i2.PathFigure();
                var n = new i2.LineSegment(1);
                m._isClosed = false;
                m._isFilled = false;
                i._startPoint = { $type: i2.Point_$type, x: (this.width / -2) * 0.5, y: 3 };
                j.c = { $type: i2.Point_$type, x: (this.width / 2) * 0.5, y: 3 };
                m._segments.add(n);
                h.c.add(m);
                this.thumbRidges.ak = h;
            }
        };
        DefaultTrackRangeVisual.prototype.d = function () {
            var a = new i2.PathGeometry();
            var b = new i2.PathFigure();
            var c = new i2.PolyLineSegment();
            b._isClosed = true;
            b._isFilled = true;
            b._startPoint = { $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 };
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / 2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 });
            b._segments.add(c);
            a.c.add(b);
            this.thumbBox.ak = a;
        };
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "orientation", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (this.a != b) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "width", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackRangeVisual.prototype.f = function () {
            if (this.width > 0 && this.height > 0) {
                this.d();
                this.e();
            }
        };
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "height", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                if (this.b != b) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "thumbBox", {
            get: function () {
                return this._thumbBox;
            },
            set: function (a) {
                this._thumbBox = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "thumbRidges", {
            get: function () {
                return this._thumbRidges;
            },
            set: function (a) {
                this._thumbRidges = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackRangeVisual.prototype, "allPaths", {
            get: function () {
                return this._allPaths;
            },
            set: function (a) {
                this._allPaths = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackRangeVisual.$t = i2.markType(DefaultTrackRangeVisual, 'DefaultTrackRangeVisual', i2.Base.$, [ITrackRangeVisual_$type]);
        return DefaultTrackRangeVisual;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrackBarVisual_$type = new i2.Type(null, 'ITrackBarVisual');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultTrackBarVisual = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultTrackBarVisual, _super);
        function DefaultTrackBarVisual() {
            var _this = _super.call(this) || this;
            _this._translateX = 0;
            _this._translateY = 0;
            _this.b = -1;
            _this.a = -1;
            _this._barBox = null;
            _this._allPaths = null;
            _this.barBox = new i2.Path();
            _this.allPaths = new i2.List$1(i2.Path.$, 0);
            _this.allPaths.add(_this.barBox);
            _this.barBox._fill = _this.getBarBoxDefaultBrush();
            return _this;
        }
        Object.defineProperty(DefaultTrackBarVisual.prototype, "translateX", {
            get: function () {
                return this._translateX;
            },
            set: function (a) {
                this._translateX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackBarVisual.prototype, "translateY", {
            get: function () {
                return this._translateY;
            },
            set: function (a) {
                this._translateY = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackBarVisual.prototype.getBarBoxDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 218, 218, 218);
                return $ret;
            })());
        };
        DefaultTrackBarVisual.prototype.getBarBoxDefaultOutline = function () {
            return null;
        };
        DefaultTrackBarVisual.prototype.getBarBoxDefaultStrokeThickness = function () {
            return 0;
        };
        DefaultTrackBarVisual.prototype.c = function () {
            var a = new i2.PathGeometry();
            var b = new i2.PathFigure();
            var c = new i2.PolyLineSegment();
            b._isClosed = true;
            b._isFilled = true;
            b._startPoint = { $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 };
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / 2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 });
            b._segments.add(c);
            a.c.add(b);
            this.barBox.ak = a;
        };
        Object.defineProperty(DefaultTrackBarVisual.prototype, "width", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                if (b != this.b) {
                    this.d();
                }
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackBarVisual.prototype.d = function () {
            if (this.width > 0 && this.height > 0) {
                this.c();
            }
        };
        Object.defineProperty(DefaultTrackBarVisual.prototype, "height", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (this.a != b) {
                    this.d();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackBarVisual.prototype, "barBox", {
            get: function () {
                return this._barBox;
            },
            set: function (a) {
                this._barBox = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackBarVisual.prototype, "allPaths", {
            get: function () {
                return this._allPaths;
            },
            set: function (a) {
                this._allPaths = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackBarVisual.$t = i2.markType(DefaultTrackBarVisual, 'DefaultTrackBarVisual', i2.Base.$, [ITrackBarVisual_$type]);
        return DefaultTrackBarVisual;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrackShadeVisual_$type = new i2.Type(null, 'ITrackShadeVisual');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultTrackShadeVisual = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultTrackShadeVisual, _super);
        function DefaultTrackShadeVisual() {
            var _this = _super.call(this) || this;
            _this._translateX = 0;
            _this._translateY = 0;
            _this.a = 0;
            _this.c = -1;
            _this.b = -1;
            _this._shadeBox = null;
            _this._shadeOutline = null;
            _this._allPaths = null;
            _this.shadeBox = new i2.Path();
            _this.shadeOutline = new i2.Path();
            _this.allPaths = new i2.List$1(i2.Path.$, 0);
            _this.allPaths.add(_this.shadeBox);
            _this.allPaths.add(_this.shadeOutline);
            _this.shadeBox._fill = _this.getShadeBoxDefaultBrush();
            _this.shadeOutline._stroke = _this.getShadeOutlineDefaultBrush();
            _this.shadeOutline.ac = _this.getShadeOutlineDefaultStrokeThickness();
            return _this;
        }
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "translateX", {
            get: function () {
                return this._translateX;
            },
            set: function (a) {
                this._translateX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "translateY", {
            get: function () {
                return this._translateY;
            },
            set: function (a) {
                this._translateY = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackShadeVisual.prototype.getShadeBoxDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(128, 255, 255, 255);
                return $ret;
            })());
        };
        DefaultTrackShadeVisual.prototype.getShadeOutlineDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 185, 185, 185);
                return $ret;
            })());
        };
        DefaultTrackShadeVisual.prototype.getShadeOutlineDefaultStrokeThickness = function () {
            return 1;
        };
        DefaultTrackShadeVisual.prototype.d = function () {
            var a = new i2.PathGeometry();
            var b = new i2.PathFigure();
            var c = new i2.PolyLineSegment();
            b._isClosed = true;
            b._isFilled = true;
            b._startPoint = { $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 };
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / 2 });
            c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 });
            b._segments.add(c);
            a.c.add(b);
            this.shadeBox.ak = a;
        };
        DefaultTrackShadeVisual.prototype.e = function () {
            var a = new i2.PathGeometry();
            var b = new i2.PathFigure();
            var c = new i2.PolyLineSegment();
            b._isClosed = false;
            b._isFilled = false;
            switch (this.orientation) {
                case 0:
                    b._startPoint = { $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 };
                    c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 });
                    c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / 2 });
                    break;
                case 1:
                    b._startPoint = { $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 };
                    c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 });
                    c._points.add({ $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 });
                    break;
                case 2:
                    b._startPoint = { $type: i2.Point_$type, x: this.width / 2, y: this.height / 2 };
                    c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 });
                    c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 });
                    break;
                case 3:
                    b._startPoint = { $type: i2.Point_$type, x: this.width / 2, y: this.height / -2 };
                    c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / -2 });
                    c._points.add({ $type: i2.Point_$type, x: this.width / -2, y: this.height / 2 });
                    break;
            }
            b._segments.add(c);
            a.c.add(b);
            this.shadeOutline.ak = a;
        };
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "orientation", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (b != this.a) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "width", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackShadeVisual.prototype.f = function () {
            if (this.width > 0 && this.height > 0) {
                this.d();
                this.e();
            }
        };
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "height", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                if (this.b != b) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "shadeBox", {
            get: function () {
                return this._shadeBox;
            },
            set: function (a) {
                this._shadeBox = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "shadeOutline", {
            get: function () {
                return this._shadeOutline;
            },
            set: function (a) {
                this._shadeOutline = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackShadeVisual.prototype, "allPaths", {
            get: function () {
                return this._allPaths;
            },
            set: function (a) {
                this._allPaths = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackShadeVisual.$t = i2.markType(DefaultTrackShadeVisual, 'DefaultTrackShadeVisual', i2.Base.$, [ITrackShadeVisual_$type]);
        return DefaultTrackShadeVisual;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrackThumbCalloutVisual_$type = new i2.Type(null, 'ITrackThumbCalloutVisual');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultTrackThumbCalloutVisual = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultTrackThumbCalloutVisual, _super);
        function DefaultTrackThumbCalloutVisual() {
            var _this = _super.call(this) || this;
            _this._translateX = 0;
            _this._translateY = 0;
            _this._textTranslateX = 0;
            _this._textTranslateY = 0;
            _this.c = -1;
            _this.b = -1;
            _this.a = false;
            _this._calloutBox = null;
            _this._calloutText = null;
            _this._allPaths = null;
            _this.calloutBox = new i2.Path();
            _this.calloutBox._visibility = 1;
            _this.calloutText = new i2.TextBlock();
            _this.calloutText._visibility = 1;
            _this.allPaths = new i2.List$1(i2.Path.$, 0);
            _this.allPaths.add(_this.calloutBox);
            _this.height = 22;
            _this.width = 10;
            _this.calloutBox._stroke = _this.getCalloutBoxDefaultStroke();
            _this.calloutBox.ac = _this.getCalloutBoxDefaultStrokeThickness();
            _this.calloutBox._fill = _this.getCalloutBoxDefaultBrush();
            _this.calloutText.am = _this.getCalloutTextDefaultBrush();
            _this.calloutText.ak = "";
            return _this;
        }
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "translateX", {
            get: function () {
                return this._translateX;
            },
            set: function (a) {
                this._translateX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "translateY", {
            get: function () {
                return this._translateY;
            },
            set: function (a) {
                this._translateY = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "textTranslateX", {
            get: function () {
                return this._textTranslateX;
            },
            set: function (a) {
                this._textTranslateX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "textTranslateY", {
            get: function () {
                return this._textTranslateY;
            },
            set: function (a) {
                this._textTranslateY = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackThumbCalloutVisual.prototype.getCalloutBoxDefaultStroke = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 185, 185, 185);
                return $ret;
            })());
        };
        DefaultTrackThumbCalloutVisual.prototype.getCalloutBoxDefaultStrokeThickness = function () {
            return 1;
        };
        DefaultTrackThumbCalloutVisual.prototype.getCalloutBoxDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(200, 255, 255, 255);
                return $ret;
            })());
        };
        DefaultTrackThumbCalloutVisual.prototype.getCalloutTextDefaultBrush = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.color = i2.Color.u(255, 185, 185, 185);
                return $ret;
            })());
        };
        DefaultTrackThumbCalloutVisual.prototype.e = function () {
        };
        DefaultTrackThumbCalloutVisual.prototype.d = function () {
            var a = new i2.PathGeometry();
            var b = new i2.PathFigure();
            var c = new i2.PolyLineSegment();
            b._isClosed = true;
            b._isFilled = true;
            b._startPoint = { $type: i2.Point_$type, x: 0, y: 0 };
            c._points.add({ $type: i2.Point_$type, x: this.width, y: 0 });
            c._points.add({ $type: i2.Point_$type, x: this.width, y: this.height });
            c._points.add({ $type: i2.Point_$type, x: 0, y: this.height });
            b._segments.add(c);
            a.c.add(b);
            this.calloutBox.ak = a;
        };
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "width", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackThumbCalloutVisual.prototype.f = function () {
            if (this.width > 0 && this.height > 0) {
                this.e();
                this.d();
            }
        };
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "height", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                var b = this.b;
                this.b = a;
                if (this.b != b) {
                    this.f();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "isVisible", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (this.a != b) {
                    this.calloutBox._visibility = this.a ? 0 : 1;
                    this.calloutText._visibility = this.a ? 0 : 1;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "calloutBox", {
            get: function () {
                return this._calloutBox;
            },
            set: function (a) {
                this._calloutBox = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "calloutText", {
            get: function () {
                return this._calloutText;
            },
            set: function (a) {
                this._calloutText = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "allPaths", {
            get: function () {
                return this._allPaths;
            },
            set: function (a) {
                this._allPaths = a;
            },
            enumerable: false,
            configurable: true
        });
        DefaultTrackThumbCalloutVisual.$t = i2.markType(DefaultTrackThumbCalloutVisual, 'DefaultTrackThumbCalloutVisual', i2.Base.$, [ITrackThumbCalloutVisual_$type]);
        return DefaultTrackThumbCalloutVisual;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITrackOwner_$type = new i2.Type(null, 'ITrackOwner');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var ThumbRangePosition = /*@__PURE__*/ (function (ThumbRangePosition) {
        ThumbRangePosition[ThumbRangePosition["PinnedLower"] = 0] = "PinnedLower";
        ThumbRangePosition[ThumbRangePosition["PinnedHigher"] = 1] = "PinnedHigher";
        return ThumbRangePosition;
    })({});
    /**
     * @hidden
     */
    var ThumbRangePosition_$type = i2.markEnum('ThumbRangePosition', 'PinnedLower,0|PinnedHigher,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrackThumbRange = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrackThumbRange, _super);
        function TrackThumbRange() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.i = 0;
            _this.j = 0;
            _this.h = 0;
            _this.g = 1;
            _this.d = null;
            _this.c = null;
            _this.a = null;
            _this.propertyChanged = null;
            return _this;
        }
        TrackThumbRange.prototype.t = function (a, b, c) {
            this.u(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        TrackThumbRange.prototype.u = function (a, b, c) {
            this.s();
        };
        TrackThumbRange.prototype.s = function () {
            if (this.b == null) {
                return;
            }
            this.b.trackDirty();
        };
        Object.defineProperty(TrackThumbRange.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (b != this.a) {
                    this.t("Owner", b, this.a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumbRange.prototype, "n", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                var b = this.i;
                this.i = a;
                if (b != this.i) {
                    this.t("Position", b, this.i);
                }
            },
            enumerable: false,
            configurable: true
        });
        TrackThumbRange.prototype.o = function (a) {
            if (a > 0 && this.n + (this.r / 2) + a > 1) {
                a = 1 - (this.n + (this.r / 2));
            }
            if (a < 0 && (this.n - (this.r / 2)) + a < 0) {
                a = (this.n - (this.r / 2)) * -1;
            }
            this.f.i += a;
            this.e.i += a;
            this.n += a;
            return a;
        };
        TrackThumbRange.prototype.p = function (a) {
            a = this.k(a);
            var b = this.n - this.r / 2;
            this.r += a;
            this.n = b + this.r / 2;
            return a;
        };
        TrackThumbRange.prototype.k = function (a) {
            if (a < 0) {
                var b = this.r + a;
                if (b < this.m) {
                    b = this.m;
                    a = (b - this.r);
                }
            }
            if (a > 0) {
                var c = this.r + a;
                if (c > this.l) {
                    c = this.l;
                    a = (c - this.r);
                }
            }
            return a;
        };
        TrackThumbRange.prototype.q = function (a) {
            a = -1 * this.k(a * -1);
            var b = this.n + this.r / 2;
            this.r -= a;
            this.n = b - this.r / 2;
            return a;
        };
        Object.defineProperty(TrackThumbRange.prototype, "r", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                var b = this.j;
                this.j = a;
                if (b != this.j) {
                    this.t("Width", b, this.j);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumbRange.prototype, "m", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.h;
                this.h = a;
                if (b != this.h) {
                    this.t("MinWidth", b, this.h);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumbRange.prototype, "l", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                var b = this.g;
                this.g = a;
                if (b != this.g) {
                    this.t("MaxWidth", b, this.g);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumbRange.prototype, "f", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                var b = this.d;
                this.d = a;
                if (b != this.d) {
                    this.t("LowerThumb", b, this.d);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumbRange.prototype, "e", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.t("HigherThumb", b, this.c);
                }
            },
            enumerable: false,
            configurable: true
        });
        TrackThumbRange.$t = i2.markType(TrackThumbRange, 'TrackThumbRange', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return TrackThumbRange;
    }(i2.Base));
    /**
     * @hidden
     */
    var TrackThumb = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrackThumb, _super);
        function TrackThumb() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.g = 0;
            _this.h = 0;
            _this.c = 1;
            _this.e = null;
            _this.a = null;
            _this.propertyChanged = null;
            return _this;
        }
        Object.defineProperty(TrackThumb.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (b != this.a) {
                    this.m("Owner", b, this.a);
                }
            },
            enumerable: false,
            configurable: true
        });
        TrackThumb.prototype.m = function (a, b, c) {
            this.n(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        TrackThumb.prototype.n = function (a, b, c) {
            this.l();
        };
        TrackThumb.prototype.j = function (a) {
            if (this.i + a > 1) {
                a = 1 - this.i;
            }
            if (this.i + a < 0) {
                a = -this.i;
            }
            if (this.f != null) {
                if (this.d == 0) {
                    a = this.f.q(a);
                }
                else {
                    a = this.f.p(a);
                }
            }
            this.i += a;
            return a;
        };
        TrackThumb.prototype.l = function () {
            if (this.b == null) {
                return;
            }
            this.b.trackDirty();
        };
        Object.defineProperty(TrackThumb.prototype, "i", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                var b = this.g;
                this.g = a;
                if (b != this.g) {
                    this.m("Position", b, this.g);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumb.prototype, "k", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.h;
                this.h = a;
                if (b != this.h) {
                    this.m("Width", b, this.h);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumb.prototype, "d", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.m("RangePosition", i2.enumGetBox(ThumbRangePosition_$type, b), i2.enumGetBox(ThumbRangePosition_$type, this.c));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TrackThumb.prototype, "f", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                var b = this.e;
                this.e = a;
                if (b != this.e) {
                    this.m("Range", b, this.e);
                }
            },
            enumerable: false,
            configurable: true
        });
        TrackThumb.$t = i2.markType(TrackThumb, 'TrackThumb', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return TrackThumb;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ZoomSliderView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ZoomSliderView, _super);
        function ZoomSliderView(a) {
            var _this = _super.call(this) || this;
            _this.q = false;
            _this.i = null;
            _this.h = null;
            _this.c = null;
            _this.b = null;
            _this.e = null;
            _this.d = null;
            _this.g = null;
            _this.f = null;
            _this.j = null;
            _this.u = null;
            _this.v = null;
            _this.o = null;
            _this.t = 0;
            _this.r = false;
            _this.x = 0;
            _this.w = 0;
            _this.m = null;
            _this.a = null;
            _this.l = null;
            _this.y = -1;
            _this.s = 10;
            _this.k = 0;
            _this.z = -1;
            _this.p = true;
            _this.j = a;
            _this.i = new DefaultTrackThumbVisual();
            _this.h = new DefaultTrackThumbVisual();
            _this.c = new DefaultTrackRangeVisual();
            _this.b = new DefaultTrackBarVisual();
            _this.e = new DefaultTrackShadeVisual();
            _this.d = new DefaultTrackShadeVisual();
            _this.g = new DefaultTrackThumbCalloutVisual();
            _this.f = new DefaultTrackThumbCalloutVisual();
            _this.m = _this.n();
            _this.an();
            return _this;
        }
        ZoomSliderView.prototype.ar = function () {
            this.p = true;
            this.an();
            if (this.a != null) {
                this.a.aq(this.u.rootWrapper, "");
            }
            if (this.z == -1) {
                this.z = this.u.setTimeout(i2.runOn(this, this.al), 200);
            }
        };
        ZoomSliderView.prototype.as = function () {
            this.p = false;
            if (this.a != null) {
                this.a.bc(this.u.rootWrapper, "");
            }
            if (this.z != -1) {
                window.clearTimeout(this.z);
                this.z = -1;
            }
        };
        ZoomSliderView.prototype.ao = function () {
            if (!this.q) {
                if (this.u != null) {
                    this.q = true;
                    this.u.setTimeout(i2.runOn(this, this.a2), 0);
                }
            }
        };
        ZoomSliderView.prototype.aj = function () {
            this.a2();
        };
        ZoomSliderView.prototype.a2 = function () {
            if (!this.q) {
                return;
            }
            this.q = false;
            this.j.d6();
            this.aw();
        };
        ZoomSliderView.prototype.aw = function () {
            if (this.o == null) {
                return;
            }
            var a = this.j.fj.width;
            var b = this.j.fj.height;
            var c = Math.round(a * this.t);
            var d = Math.round(b * this.t);
            if (this.x != c || this.w != d) {
                this.v.setAttribute("width", c.toString());
                this.v.setAttribute("height", d.toString());
                this.v.setStyleProperty("width", a.toString() + "px");
                this.v.setStyleProperty("height", b.toString() + "px");
                this.x = i2.truncate(Math.round(c));
                this.w = i2.truncate(Math.round(d));
            }
            if (this.o.d && this.t != 1) {
                this.o.z();
                this.o.aa(this.t, this.t);
            }
            this.o.k(this.j.fj.left, this.j.fj.top, this.j.fj.width, this.j.fj.height);
            this.a0(this.i.allPaths, this.i.translateX, this.i.translateY);
            this.a0(this.h.allPaths, this.h.translateX, this.h.translateY);
            this.a0(this.c.allPaths, this.c.translateX, this.c.translateY);
            this.a0(this.b.allPaths, this.b.translateX, this.b.translateY);
            this.a0(this.e.allPaths, this.e.translateX, this.e.translateY);
            this.a0(this.d.allPaths, this.d.translateX, this.d.translateY);
            this.a0(this.g.allPaths, this.g.translateX, this.g.translateY);
            this.a0(this.f.allPaths, this.f.translateX, this.f.translateY);
            this.a1(this.g.calloutText, this.g.textTranslateX, this.g.textTranslateY);
            this.a1(this.f.calloutText, this.f.textTranslateX, this.f.textTranslateY);
            this.ax(this.b.allPaths);
            this.ax(this.c.allPaths);
            this.ax(this.e.allPaths);
            this.ax(this.d.allPaths);
            this.ax(this.i.allPaths);
            this.ax(this.h.allPaths);
            this.ax(this.g.allPaths);
            this.ax(this.f.allPaths);
            this.ay(this.g.calloutText);
            this.ay(this.f.calloutText);
            if (this.o.d && this.t != 1) {
                this.o.y();
            }
        };
        ZoomSliderView.prototype.ay = function (a) {
            if (a.j != null) {
                this.o.z();
            }
            this.o.j(a.j);
            this.o.w(a);
            if (a.j != null) {
                this.o.y();
            }
        };
        ZoomSliderView.prototype.ax = function (a) {
            for (var b = 0; b < a.count; b++) {
                var c = a.item(b);
                if (c.j != null) {
                    this.o.z();
                }
                this.o.j(c.j);
                this.o.s(c);
                if (c.j != null) {
                    this.o.y();
                }
            }
        };
        ZoomSliderView.prototype.a1 = function (a, b, c) {
            if (a.j == null) {
                a.j = new i2.TranslateTransform();
            }
            var d = a.j;
            d.j = b;
            d.k = c;
        };
        ZoomSliderView.prototype.a0 = function (a, b, c) {
            for (var d = 0; d < a.count; d++) {
                var e = a.item(d);
                if (e.j == null) {
                    e.j = new i2.TranslateTransform();
                }
                var f = e.j;
                f.j = b;
                f.k = c;
            }
        };
        ZoomSliderView.prototype.an = function () {
            var a = this.j.bi;
            var b = this.j.a4;
            if (!i2.isNaN_(a) && a != 0) {
                return;
            }
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
                this.j.a4 = window.devicePixelRatio;
            }
        };
        ZoomSliderView.prototype.au = function (a) {
            var _this = this;
            if (a == null) {
                var b = this.u;
                this.v = null;
                this.u = null;
                this.o = null;
                this.ab();
                if (this.z != -1) {
                    if (b != null) {
                        b.clearTimeout(this.z);
                    }
                    else {
                        window.clearTimeout(this.z);
                    }
                    this.z = -1;
                }
                return;
            }
            this.t = (i2.isNaN_(this.j.bi) ? this.j.a4 : this.j.bi);
            var c = a;
            this.u = c;
            this.j.l.u(this.u);
            this.u.rootWrapper.addClass("ui-zoomslider-container");
            var d = this.t;
            var e = Math.round(c.rootWrapper.width());
            var f = Math.round(c.rootWrapper.height());
            var g = e * d;
            var h = f * d;
            this.u.rootWrapper.setStyleProperty("position", "relative");
            var i = this.u.createElement("canvas");
            i.setStyleProperty("position", "absolute");
            this.u.append(i);
            this.x = i2.truncate(Math.round(g));
            this.w = i2.truncate(Math.round(h));
            i.setAttribute("width", g.toString());
            i.setAttribute("height", h.toString());
            i.setStyleProperty("width", e.toString() + "px");
            i.setStyleProperty("height", f.toString() + "px");
            this.v = i;
            var j = this.u.get2DCanvasContext(this.v);
            this.o = new i2.RenderingContext(new i2.CanvasViewRenderer(), j);
            this.o.ac(this.m);
            this.ab();
            this.a = new i2.CanvasGestureDOMEventProxy(this.u.rootWrapper, this.u, false);
            this.a.bg = this.j.fj;
            var k = this.a;
            k.onContactStarted = i2.delegateCombine(k.onContactStarted, i2.runOn(this, this.ai));
            var l = this.a;
            l.onContactMoved = i2.delegateCombine(l.onContactMoved, i2.runOn(this, this.ah));
            var m = this.a;
            m.onContactCompleted = i2.delegateCombine(m.onContactCompleted, i2.runOn(this, this.ag));
            this.a.al = function (n) { return _this.j.fh.containsPoint(n); };
            this.j.de(0, 0, e, f);
            this.s = i2.FontUtil.getCurrentFontHeight(this.u, this.m);
            this.j.trackDirty();
            this.z = this.u.setTimeout(i2.runOn(this, this.al), 200);
        };
        ZoomSliderView.prototype.ag = function (a, b) {
            this.j.c8(a, b);
        };
        ZoomSliderView.prototype.ah = function (a, b) {
            this.j.c9(a);
        };
        ZoomSliderView.prototype.ai = function (a, b) {
            this.j.ae(a, b);
        };
        ZoomSliderView.prototype.ab = function () {
            if (this.a != null) {
                var a = this.a;
                a.onContactStarted = i2.delegateRemove(a.onContactStarted, i2.runOn(this, this.ai));
                var b = this.a;
                b.onContactMoved = i2.delegateRemove(b.onContactMoved, i2.runOn(this, this.ah));
                var c = this.a;
                c.onContactCompleted = i2.delegateRemove(c.onContactCompleted, i2.runOn(this, this.ag));
                this.a.al = null;
                this.a.ar();
            }
        };
        ZoomSliderView.prototype.av = function () {
        };
        ZoomSliderView.prototype.ap = function () {
            this.aq(true);
        };
        ZoomSliderView.prototype.aq = function (a) {
            if (this.u == null || this.u.rootWrapper == null) {
                return;
            }
            this.an();
            var b = Math.round(this.u.rootWrapper.width());
            var c = Math.round(this.u.rootWrapper.height());
            var d = b != this.j.fj.width || c != this.j.fj.height;
            if (a || d) {
                this.j.de(0, 0, b, c);
                if (this.a != null) {
                    this.a.bg = this.j.fj;
                }
            }
        };
        ZoomSliderView.prototype.ak = function () {
        };
        ZoomSliderView.prototype.n = function () {
            return ((function () {
                var $ret = new i2.FontInfo();
                $ret.n = "Verdana";
                $ret.d = 10;
                return $ret;
            })());
        };
        ZoomSliderView.prototype.a3 = function (a, b, c) {
            if (a.ak != b) {
                a.ak = b;
            }
            if (this.l != c) {
                this.l = c;
                this.m = this.l;
                this.s = i2.FontUtil.getCurrentFontHeight(this.u, this.m);
                this.o.ac(this.l);
                this.j.trackDirty();
            }
        };
        ZoomSliderView.prototype.ad = function () {
            if (this.k != 3) {
                this.k = 3;
                this.u.rootWrapper.setStyleProperty("cursor", "move");
            }
        };
        ZoomSliderView.prototype.af = function () {
            if (this.k != 2) {
                this.k = 2;
                this.u.rootWrapper.setStyleProperty("cursor", "ns-resize");
            }
        };
        ZoomSliderView.prototype.ac = function () {
            if (this.k != 0) {
                this.k = 0;
                this.u.rootWrapper.setStyleProperty("cursor", "inherit");
            }
        };
        ZoomSliderView.prototype.ae = function () {
            if (this.k != 1) {
                this.k = 1;
                this.u.rootWrapper.setStyleProperty("cursor", "ew-resize");
            }
        };
        ZoomSliderView.prototype.a4 = function (a) {
            var b = this.s;
            var c = this.o.f(a.ak);
            return new i2.Size(1, c, b);
        };
        ZoomSliderView.prototype.at = function () {
            this.t = this.j.a4;
            this.ao();
        };
        ZoomSliderView.prototype.az = function () {
            if (this.u == null || this.u.rootWrapper == null) {
                return;
            }
            this.u.rootWrapper.show();
        };
        ZoomSliderView.prototype.am = function () {
            if (this.u == null || this.u.rootWrapper == null) {
                return;
            }
            this.u.rootWrapper.hide();
        };
        ZoomSliderView.prototype.al = function () {
            this.z = -1;
            if (this.u == null) {
                return;
            }
            if (!this.p) {
                return;
            }
            this.aq(false);
            this.z = this.u.setTimeout(i2.runOn(this, this.al), 200);
        };
        ZoomSliderView.$t = i2.markType(ZoomSliderView, 'ZoomSliderView');
        return ZoomSliderView;
    }(i2.Base));
    /**
     * @hidden
     */
    var ZoomSlider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ZoomSlider, _super);
        function ZoomSlider() {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.a = null;
            _this.c = null;
            _this.g = null;
            _this.propertyChanged = null;
            _this.bk = 500;
            _this.ax = 1;
            _this.az = NaN;
            _this.ag = 1;
            _this.resolvingAxisValue = null;
            _this.fg = new i2.Rect(0, 0, 0, 1, 1);
            _this.w = false;
            _this.af = false;
            _this.windowRectChanged = null;
            _this.i = 0;
            _this.h = 0;
            _this.ff = null;
            _this.fe = null;
            _this.fk = new i2.Thickness(1, 5, 5, 5, 5);
            _this.fj = null;
            _this.fh = null;
            _this.fi = null;
            _this.ay = 1E-05;
            _this.a1 = 0;
            _this.al = 0;
            _this.a3 = 5;
            _this.a2 = 5;
            _this.ah = 16;
            _this.d = 0;
            _this.en = null;
            _this.av = 1;
            _this.ap = 1;
            _this.ef = null;
            _this.eo = null;
            _this.eg = null;
            _this.ep = null;
            _this.eh = null;
            _this.aw = 10;
            _this.aq = 10;
            _this.au = 22;
            _this.ao = 22;
            _this.el = null;
            _this.em = null;
            _this.at = 1;
            _this.ed = null;
            _this.ee = null;
            _this.an = 1;
            _this.d8 = null;
            _this.d9 = null;
            _this.ai = 0;
            _this.eq = null;
            _this.er = null;
            _this.a0 = 1;
            _this.es = null;
            _this.ei = null;
            _this.ek = null;
            _this.ej = null;
            _this.as = 1;
            _this.ea = null;
            _this.ec = null;
            _this.eb = null;
            _this.am = 1;
            _this.q = false;
            _this.m = null;
            _this.o = null;
            _this.k = null;
            _this.ak = 0;
            _this.aj = 0;
            _this.ar = 0;
            _this.p = false;
            _this.h = 6;
            _this.fj = i2.Rect.empty;
            _this.fh = i2.Rect.empty;
            _this.fi = i2.Rect.empty;
            _this.g = new ZoomSliderView(_this);
            _this.m = _this.g.n();
            _this.b = new TrackThumb();
            _this.b.d = 0;
            _this.a = new TrackThumb();
            _this.a.d = 1;
            _this.c = new TrackThumbRange();
            _this.c.f = _this.b;
            _this.c.e = _this.a;
            _this.b.i = 0;
            _this.a.i = 1;
            _this.c.r = 1;
            _this.c.n = 0.5;
            _this.c.m = 0;
            _this.c.l = 1;
            _this.b.f = _this.c;
            _this.a.f = _this.c;
            _this.c.f = _this.b;
            _this.c.e = _this.a;
            _this.b.b = _this;
            _this.a.b = _this;
            _this.c.b = _this;
            _this.k = new i2.DoubleAnimator(0, 1, _this.bl);
            var a = _this.k;
            a.propertyChanged = i2.delegateCombine(a.propertyChanged, i2.runOn(_this, _this.cx));
            _this.k.b = i2.EasingFunctions.exponentialEase;
            return _this;
        }
        ZoomSlider.prototype.onDetachedFromUI = function () {
            this.g.as();
        };
        ZoomSlider.prototype.onAttachedToUI = function () {
            this.g.ar();
        };
        Object.defineProperty(ZoomSlider.prototype, "bl", {
            get: function () {
                return this.bk;
            },
            set: function (a) {
                var b = this.bk;
                this.bk = a;
                if (b != this.bk) {
                    this.dc("PanTransitionDuration", b, this.bk);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "bg", {
            get: function () {
                return this.ax;
            },
            set: function (a) {
                var b = this.ax;
                this.ax = a;
                if (b != this.ax) {
                    this.dc("MaxZoomWidth", b, this.ax);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "bi", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                var b = this.az;
                this.az = a;
                if (b != this.az) {
                    this.dc("PixelScalingRatio", b, this.az);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "a4", {
            get: function () {
                return this.ag;
            },
            set: function (a) {
                var b = this.ag;
                this.ag = a;
                if (b != this.ag) {
                    this.dc("ActualPixelScalingRatio", b, this.ag);
                }
            },
            enumerable: false,
            configurable: true
        });
        ZoomSlider.prototype.de = function (a, b, c, d) {
            this.fj = new i2.Rect(0, a, b, c, d);
            if (this.e == 0) {
                var e = Math.max(0, this.fj.width - (this.startInset + this.endInset));
                this.fh = new i2.Rect(0, this.fj.left + this.startInset, this.fj.top, e, this.fj.height);
                var f = Math.max(0, this.fh.width - (this.trackStartInset + this.trackEndInset));
                this.fi = new i2.Rect(0, this.fh.left + this.trackStartInset, this.fh.top, f, Math.max(0, this.fh.height - this.barExtent));
            }
            else {
                this.fh = new i2.Rect(0, this.fj.left, this.fj.top + this.startInset, this.fj.width, this.fj.height - (this.startInset + this.endInset));
                this.fi = new i2.Rect(0, this.fh.left, this.fh.top + this.trackStartInset, this.fh.width - this.barExtent, this.fh.height - (this.trackStartInset + this.trackEndInset));
            }
            this.trackDirty();
        };
        ZoomSlider.prototype.d6 = function () {
            if (!this.p) {
                return;
            }
            this.p = false;
            var a = this.g.i;
            var b = this.g.h;
            var c = this.g.c;
            var d = this.g.b;
            var e = this.g.e;
            var f = this.g.d;
            if (this.ab) {
                var g = this.bn();
                var h = this.bm();
                this.ds(g, this.b);
                this.dr(h, this.b.i);
                this.ds(h, this.a);
                this.dr(h, this.a.i);
            }
            else {
                this.d5(a, this.b);
                this.d5(b, this.a);
            }
            if (this.z) {
            }
            else {
                this.d3(c, this.c);
            }
            if (this.y) {
            }
            else {
                this.dp(d);
            }
            if (this.aa) {
            }
            else {
                this.dz(e);
                this.du(f);
            }
            this.d7();
        };
        Object.defineProperty(ZoomSlider.prototype, "windowRect", {
            get: function () {
                return this.fg;
            },
            set: function (a) {
                var b = this.fg;
                this.fg = a;
                if (i2.Rect.l_op_Inequality(b, this.fg)) {
                    this.dc("WindowRect", b, this.fg);
                }
            },
            enumerable: false,
            configurable: true
        });
        ZoomSlider.prototype.d7 = function () {
            var a = this.windowRect.width;
            var b = this.windowRect.height;
            var c = this.windowRect.left;
            var d = this.windowRect.top;
            var e = c;
            var f = d;
            var g = a;
            var h = b;
            if (this.e == 0) {
                e = this.b.i;
                g = this.c.r;
            }
            else {
                f = this.b.i;
                h = this.c.r;
            }
            if (e != c || f != d || g != a || h != b) {
                this.w = true;
                var i = this.windowRect;
                this.windowRect = new i2.Rect(0, e, f, g, h);
                this.dg(i, this.windowRect);
                this.w = false;
            }
        };
        ZoomSlider.prototype.dg = function (a, b) {
            if (this.af) {
                return;
            }
            if (this.windowRectChanged != null) {
                this.windowRectChanged(this, new i2.RectChangedEventArgs(a, b));
            }
        };
        ZoomSlider.prototype.c8 = function (a, b) {
            if (this.h != 6) {
                this.g.av();
            }
            this.i = this.j(a, b);
            this.h = 6;
            this.c0();
            this.c1();
        };
        ZoomSlider.prototype.c1 = function () {
            this.g.g.isVisible = false;
            this.g.ao();
        };
        ZoomSlider.prototype.c0 = function () {
            this.g.f.isVisible = false;
            this.g.ao();
        };
        ZoomSlider.prototype.da = function (a, b) {
            this.i = this.j(a, false);
        };
        ZoomSlider.prototype.ae = function (a, b) {
            this.i = this.j(a, b);
            if (this.i == 6) {
                return false;
            }
            this.cy();
            if (this.ac(this.i)) {
                this.dm(a, this.i);
                this.g.ak();
                return true;
            }
            if (this.x(this.i)) {
                return this.ad(a, this.i);
            }
            return false;
        };
        ZoomSlider.prototype.ad = function (a, b) {
            switch (b) {
                case 5:
                case 2:
                case 3:
                    this.di(a);
                    return true;
            }
            return false;
        };
        ZoomSlider.prototype.di = function (a) {
            var b;
            if (this.e == 0) {
                b = (a.x - this.fi.left) / this.fi.width;
            }
            else {
                b = (a.y - this.fi.top) / this.fi.height;
            }
            if (b < 0 || b > 1) {
                return;
            }
            if (b + (this.c.r / 2) > 1) {
                b = 1 - (this.c.r / 2);
            }
            if (b - (this.c.r / 2) < 0) {
                b = (this.c.r / 2);
            }
            if (this.bl > 0) {
                this.dn(b);
            }
            else {
                this.c.n = b;
            }
        };
        ZoomSlider.prototype.dm = function (a, b) {
            this.h = b;
            this.ff = a;
            this.fe = a;
        };
        ZoomSlider.prototype.ac = function (a) {
            switch (a) {
                case 0:
                case 1:
                case 4: return true;
            }
            return false;
        };
        ZoomSlider.prototype.x = function (a) {
            switch (a) {
                case 5:
                case 2:
                case 3: return true;
            }
            return false;
        };
        ZoomSlider.prototype.c9 = function (a) {
            this.i = this.j(a, false);
            if (this.h != 6) {
                if (this.e == 0) {
                    this.c4(a);
                }
                else {
                    this.dd(a);
                }
            }
            else {
                this.c2();
            }
        };
        ZoomSlider.prototype.c2 = function () {
            if (this.i == 4) {
                this.g.ad();
            }
            else if (this.i == 0 || this.i == 1) {
                if (this.e == 1) {
                    this.g.af();
                }
                else {
                    this.g.ae();
                }
            }
            else {
                this.g.ac();
            }
        };
        ZoomSlider.prototype.dd = function (a) {
            var b = a.y - this.fe.y;
            b = b / this.fi.height;
            this.fe = a;
            switch (this.h) {
                case 0:
                    this.b.j(b);
                    this.d1(this.b);
                    this.c3();
                    break;
                case 1:
                    this.a.j(b);
                    this.dw(this.a);
                    this.c3();
                    break;
                case 4:
                    this.c.o(b);
                    this.d1(this.b);
                    this.dw(this.a);
                    this.c3();
                    break;
            }
        };
        ZoomSlider.prototype.dw = function (a) {
            var b;
            var c;
            if (this.e == 0) {
                b = a.i;
                c = a.i * this.fi.width + this.fi.left;
                if (this.q) {
                    var d_1 = b;
                    if (this.resolvingAxisValue != null) {
                        var e = ((function () {
                            var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                            $ret.position = b;
                            $ret.value = d_1;
                            return $ret;
                        })());
                        this.resolvingAxisValue(this, e);
                        d_1 = e.value;
                    }
                    this.dk(c, this.fi.top, d_1);
                }
            }
            else {
                b = a.i;
                c = a.i * this.fi.height + this.fi.top;
                if (this.q) {
                    var f_1 = b;
                    if (this.resolvingAxisValue != null) {
                        var g = ((function () {
                            var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                            $ret.position = b;
                            $ret.value = f_1;
                            return $ret;
                        })());
                        this.resolvingAxisValue(this, g);
                        f_1 = g.value;
                    }
                    this.dk(c, this.fi.top, f_1);
                }
            }
        };
        ZoomSlider.prototype.dk = function (a, b, c) {
            var d = this.g.f;
            d.isVisible = true;
            var e = "";
            if (c != null) {
                e = c.toString();
            }
            this.g.a3(d.calloutText, e, this.n());
            var f = this.g.a4(d.calloutText);
            var g = this.fl();
            f = new i2.Size(1, f.width + g.c + g.d, f.height + g.e + g.b);
            var h = this.a.i * this.fi.width + this.fi.left;
            var i = this.b.i * this.fi.width + this.fi.left;
            var j = 0;
            var k = 0;
            if ((this.fj.right - h) <= f.width) {
                j = h - f.width;
            }
            else {
                j = h;
            }
            if (j < i) {
                k = this.fi.top;
            }
            else {
                k = this.fi.bottom - f.height;
            }
            d.width = f.width;
            d.height = f.height;
            d.translateX = j;
            d.translateY = k;
            d.textTranslateX = j + g.c;
            d.textTranslateY = k + g.e;
        };
        ZoomSlider.prototype.d1 = function (a) {
            var b;
            var c;
            if (this.e == 0) {
                b = a.i;
                c = a.i * this.fi.width + this.fi.left;
                if (this.q) {
                    var d_2 = b;
                    if (this.resolvingAxisValue != null) {
                        var e = ((function () {
                            var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                            $ret.position = b;
                            $ret.value = d_2;
                            return $ret;
                        })());
                        this.resolvingAxisValue(this, e);
                        d_2 = e.value;
                    }
                    this.dl(c, this.fi.top, d_2);
                }
            }
            else {
                b = a.i;
                c = a.i * this.fi.height + this.fi.top;
                if (this.q) {
                    var f_2 = b;
                    if (this.resolvingAxisValue != null) {
                        var g = ((function () {
                            var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                            $ret.position = b;
                            $ret.value = f_2;
                            return $ret;
                        })());
                        this.resolvingAxisValue(this, g);
                        f_2 = g.value;
                    }
                    this.dl(c, this.fi.top, f_2);
                }
            }
        };
        ZoomSlider.prototype.fl = function () {
            return this.fk;
        };
        ZoomSlider.prototype.dl = function (a, b, c) {
            var d = this.g.g;
            d.isVisible = true;
            var e = "";
            if (c != null) {
                e = c.toString();
            }
            this.g.a3(d.calloutText, e, this.n());
            var f = this.g.a4(d.calloutText);
            var g = this.fl();
            f = new i2.Size(1, f.width + g.c + g.d, f.height + g.e + g.b);
            var h = this.b.i * this.fi.width + this.fi.left;
            var i = this.a.i * this.fi.width + this.fi.left;
            var j = 0;
            var k = 0;
            if (h >= f.width) {
                j = h - f.width;
            }
            else {
                j = h;
            }
            if (j > i) {
                k = this.fi.top;
            }
            else {
                k = this.fi.bottom - f.height;
            }
            d.width = f.width;
            d.height = f.height;
            d.translateX = j;
            d.translateY = k;
            d.textTranslateX = j + g.c;
            d.textTranslateY = k + g.e;
        };
        ZoomSlider.prototype.n = function () {
            if (this.o != null) {
                return this.o;
            }
            return this.m;
        };
        ZoomSlider.prototype.c4 = function (a) {
            var b = a.x - this.fe.x;
            this.fe = a;
            b = b / this.fi.width;
            switch (this.h) {
                case 0:
                    this.b.j(b);
                    this.d1(this.b);
                    this.c3();
                    break;
                case 1:
                    this.a.j(b);
                    this.dw(this.a);
                    this.c3();
                    break;
                case 4:
                    this.c.o(b);
                    this.d1(this.b);
                    this.dw(this.a);
                    this.c3();
                    break;
            }
        };
        ZoomSlider.prototype.c6 = function (a) {
            this.i = this.j(a, false);
        };
        ZoomSlider.prototype.c7 = function (a) {
            this.i = this.j(a, false);
        };
        ZoomSlider.prototype.j = function (a, b) {
            if (this.v(a, this.b, this.g.i, b)) {
                return 0;
            }
            if (this.v(a, this.a, this.g.h, b)) {
                return 1;
            }
            if (this.u(a, this.c, this.g.c)) {
                return 4;
            }
            if (this.t(a, this.b)) {
                return 2;
            }
            if (this.s(a, this.a)) {
                return 3;
            }
            if (this.r(a)) {
                return 5;
            }
            return 6;
        };
        ZoomSlider.prototype.r = function (a) {
            if (this.e == 0) {
                if (a.y > this.fi.bottom && a.x >= this.fi.left && a.x <= this.fi.right && a.y <= this.fh.bottom) {
                    return true;
                }
            }
            else {
                if (a.x > this.fi.right && a.y >= this.fi.top && a.y <= this.fi.bottom && a.x <= this.fh.right) {
                    return true;
                }
            }
            return false;
        };
        ZoomSlider.prototype.u = function (a, b, c) {
            if (this.e == 0) {
                var d = (b.n) * this.fi.width + this.fi.left;
                var e = d - c.width / 2;
                var f = d + c.width / 2;
                if (a.y >= this.fh.top && a.y <= this.fh.bottom && a.x >= e && a.x <= f) {
                    return true;
                }
            }
            else {
                var g = (b.n) * this.fi.height + this.fi.top;
                var h = g - c.height / 2;
                var i = g + c.height / 2;
                if (a.x >= this.fh.left && a.x <= this.fh.right && a.y >= h && a.y <= i) {
                    return true;
                }
            }
            return false;
        };
        ZoomSlider.prototype.t = function (a, b) {
            if (this.e == 0) {
                var c = b.i * this.fi.width + this.fi.left;
                if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.x <= c && a.y <= this.fi.bottom) {
                    return true;
                }
            }
            else {
                var d = b.i * this.fi.height + this.fi.top;
                if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.y <= d && a.x <= this.fi.right) {
                    return true;
                }
            }
            return false;
        };
        ZoomSlider.prototype.s = function (a, b) {
            if (this.e == 0) {
                var c = b.i * this.fi.width + this.fi.left;
                if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.x >= c && a.y <= this.fi.bottom) {
                    return true;
                }
            }
            else {
                var d = b.i * this.fi.height + this.fi.top;
                if (a.y >= this.fh.top && a.y <= this.fh.bottom && a.x >= this.fh.left && a.x <= this.fh.right && a.y >= d && a.x <= this.fi.right) {
                    return true;
                }
            }
            return false;
        };
        ZoomSlider.prototype.v = function (a, b, c, d) {
            var e = 40;
            if (this.e == 0) {
                var f = b.i * this.fi.width + this.fi.left;
                var g = this.fi.top + this.fi.height / 2;
                var h = new i2.Rect(0, f - c.width / 2, g - c.height / 2, c.width, c.height);
                if (d) {
                    if (h.width < e) {
                        h.inflate((e - h.width) / 2, 0);
                    }
                    if (h.height < e) {
                        h.inflate(0, (e - h.height) / 2);
                    }
                }
                if (h.containsPoint(a)) {
                    return true;
                }
            }
            else {
                var i = b.i * this.fi.height + this.fi.top;
                var j = this.fi.left + this.fi.width / 2;
                var k = new i2.Rect(0, j - c.width / 2, i - c.height / 2, c.width, c.height);
                if (d) {
                    if (k.width < e) {
                        k.inflate((e - k.width) / 2, 0);
                    }
                    if (k.height < e) {
                        k.inflate(0, (e - k.height) / 2);
                    }
                }
                if (k.containsPoint(a)) {
                    return true;
                }
            }
            return false;
        };
        ZoomSlider.prototype.d3 = function (a, b) {
            if (this.e == 0) {
                a.orientation = this.e;
                a.width = Math.max(15, this.fi.width * b.r);
                a.height = this.barExtent;
                a.translateX = (this.fi.left + this.fi.width * b.n);
                a.translateY = this.fi.bottom + this.barExtent / 2;
            }
            else {
                a.orientation = this.e;
                a.height = Math.max(15, this.fi.height * b.r);
                a.width = this.barExtent;
                a.translateY = (this.fi.top + this.fi.height * b.n);
                a.translateX = this.fi.right + this.barExtent / 2;
            }
        };
        ZoomSlider.prototype.du = function (a) {
            var b = this.a.i;
            if (this.e == 0) {
                var c = this.fi.left + b * this.fi.width;
                a.height = this.fi.height;
                a.translateX = c + (this.fh.right - c) / 2;
                a.translateY = this.fi.top + this.fi.height / 2;
                a.width = (this.fh.right - c);
                a.orientation = 1;
            }
            else {
                var d = this.fi.top + b * this.fi.height;
                a.width = this.fi.width;
                a.translateY = d + (this.fh.bottom - d) / 2;
                a.translateX = this.fh.left + this.fi.width / 2;
                a.height = (this.fh.bottom - d);
                a.orientation = 3;
            }
        };
        ZoomSlider.prototype.dz = function (a) {
            var b = this.b.i;
            if (this.e == 0) {
                var c = this.fi.left + b * this.fi.width;
                a.height = this.fi.height;
                a.translateX = c - (c - this.fh.left) / 2;
                a.translateY = this.fi.top + this.fi.height / 2;
                a.width = c - this.fh.left;
                a.orientation = 0;
            }
            else {
                var d = this.fi.top + b * this.fi.height;
                a.width = this.fi.width;
                a.translateY = d - (d - this.fh.top) / 2;
                a.translateX = this.fh.left + this.fi.width / 2;
                a.height = d - this.fh.top;
                a.orientation = 2;
            }
        };
        ZoomSlider.prototype.dp = function (a) {
            if (this.e == 0) {
                a.height = this.barExtent;
                a.width = this.fi.width;
                a.translateX = this.fi.left + this.fi.width / 2;
                a.translateY = this.fh.bottom - this.barExtent / 2;
            }
            else {
                a.width = this.barExtent;
                a.height = this.fi.height;
                a.translateY = this.fi.top + this.fi.height / 2;
                a.translateX = this.fh.right - this.barExtent / 2;
            }
        };
        ZoomSlider.prototype.d5 = function (a, b) {
            if (this.e == 0) {
                a.orientation = this.e;
                a.translateX = this.fi.left + this.fi.width * b.i;
                a.translateY = this.fi.top + this.fi.height / 2;
            }
            else {
                a.orientation = this.e;
                a.translateY = this.fi.top + this.fi.height * b.i;
                a.translateX = this.fi.left + this.fi.width / 2;
            }
        };
        ZoomSlider.prototype.ds = function (a, b) {
        };
        ZoomSlider.prototype.dr = function (a, b) {
        };
        ZoomSlider.prototype.bm = function () {
            throw new i2.NotImplementedException(0);
        };
        ZoomSlider.prototype.bn = function () {
            throw new i2.NotImplementedException(0);
        };
        Object.defineProperty(ZoomSlider.prototype, "bh", {
            get: function () {
                return this.ay;
            },
            set: function (a) {
                var b = this.ay;
                this.ay = a;
                if (b != this.ay) {
                    this.dc("MinZoomWidth", b, this.ay);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "startInset", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                var b = this.a1;
                this.a1 = a;
                if (b != this.a1) {
                    this.dc("StartInset", b, this.a1);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "endInset", {
            get: function () {
                return this.al;
            },
            set: function (a) {
                var b = this.al;
                this.al = a;
                if (b != this.al) {
                    this.dc("EndInset", b, this.al);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "trackStartInset", {
            get: function () {
                return this.a3;
            },
            set: function (a) {
                var b = this.a3;
                this.a3 = a;
                if (b != this.a3) {
                    this.dc("TrackStartInset", b, this.a3);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "trackEndInset", {
            get: function () {
                return this.a2;
            },
            set: function (a) {
                var b = this.a2;
                this.a2 = a;
                if (b != this.a2) {
                    this.dc("TrackEndInset", b, this.a2);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "barExtent", {
            get: function () {
                return this.ah;
            },
            set: function (a) {
                var b = this.ah;
                this.ah = a;
                if (b != this.ah) {
                    this.dc("BarExtent", b, this.ah);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                var b = this.d;
                this.d = a;
                if (b != this.d) {
                    this.dc("Orientation", i2.enumGetBox(ZoomSliderOrientation_$type, b), i2.enumGetBox(ZoomSliderOrientation_$type, this.d));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e8", {
            get: function () {
                return this.en;
            },
            set: function (a) {
                var b = this.en;
                this.en = a;
                if (b != this.en) {
                    this.dc("LowerThumbBrush", b, this.en);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "be", {
            get: function () {
                return this.av;
            },
            set: function (a) {
                var b = this.av;
                this.av = a;
                if (b != this.av) {
                    this.dc("LowerThumbStrokeThickness", b, this.av);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "a9", {
            get: function () {
                return this.ap;
            },
            set: function (a) {
                var b = this.ap;
                this.ap = a;
                if (b != this.ap) {
                    this.dc("HigherThumbStrokeThickness", b, this.ap);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e0", {
            get: function () {
                return this.ef;
            },
            set: function (a) {
                var b = this.ef;
                this.ef = a;
                if (b != this.ef) {
                    this.dc("HigherThumbBrush", b, this.ef);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e9", {
            get: function () {
                return this.eo;
            },
            set: function (a) {
                var b = this.eo;
                this.eo = a;
                if (b != this.eo) {
                    this.dc("LowerThumbOutline", b, this.eo);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e1", {
            get: function () {
                return this.eg;
            },
            set: function (a) {
                var b = this.eg;
                this.eg = a;
                if (b != this.eg) {
                    this.dc("HigherThumbOutline", b, this.eg);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "fa", {
            get: function () {
                return this.ep;
            },
            set: function (a) {
                var b = this.ep;
                this.ep = a;
                if (b != this.ep) {
                    this.dc("LowerThumbRidgesBrush", b, this.ep);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e2", {
            get: function () {
                return this.eh;
            },
            set: function (a) {
                var b = this.eh;
                this.eh = a;
                if (b != this.eh) {
                    this.dc("HigherThumbRidgesBrush", b, this.eh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "bf", {
            get: function () {
                return this.aw;
            },
            set: function (a) {
                var b = this.aw;
                this.aw = a;
                if (b != this.aw) {
                    this.dc("LowerThumbWidth", b, this.aw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ba", {
            get: function () {
                return this.aq;
            },
            set: function (a) {
                var b = this.aq;
                this.aq = a;
                if (b != this.aq) {
                    this.dc("HigherThumbWidth", b, this.aq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "bd", {
            get: function () {
                return this.au;
            },
            set: function (a) {
                var b = this.au;
                this.au = a;
                if (b != this.au) {
                    this.dc("LowerThumbHeight", b, this.au);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "a8", {
            get: function () {
                return this.ao;
            },
            set: function (a) {
                var b = this.ao;
                this.ao = a;
                if (b != this.ao) {
                    this.dc("HigherThumbHeight", b, this.ao);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e6", {
            get: function () {
                return this.el;
            },
            set: function (a) {
                var b = this.el;
                this.el = a;
                if (b != this.el) {
                    this.dc("LowerShadeBrush", b, this.el);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e7", {
            get: function () {
                return this.em;
            },
            set: function (a) {
                var b = this.em;
                this.em = a;
                if (b != this.em) {
                    this.dc("LowerShadeOutline", b, this.em);
                }
            },
            enumerable: false,
            configurable: true
        });
        ZoomSlider.prototype.destroy = function () {
            this.provideContainer(null);
        };
        Object.defineProperty(ZoomSlider.prototype, "bc", {
            get: function () {
                return this.at;
            },
            set: function (a) {
                var b = this.at;
                this.at = a;
                if (b != this.at) {
                    this.dc("LowerShadeStrokeThickness", b, this.at);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ey", {
            get: function () {
                return this.ed;
            },
            set: function (a) {
                var b = this.ed;
                this.ed = a;
                if (b != this.ed) {
                    this.dc("HigherShadeBrush", b, this.ed);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ez", {
            get: function () {
                return this.ee;
            },
            set: function (a) {
                var b = this.ee;
                this.ee = a;
                if (b != this.ee) {
                    this.dc("HigherShadeOutline", b, this.ee);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "a7", {
            get: function () {
                return this.an;
            },
            set: function (a) {
                var b = this.an;
                this.an = a;
                if (b != this.an) {
                    this.dc("HigherShadeStrokeThickness", b, this.an);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "et", {
            get: function () {
                return this.d8;
            },
            set: function (a) {
                var b = this.d8;
                this.d8 = a;
                if (b != this.d8) {
                    this.dc("BarBrush", b, this.d8);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "eu", {
            get: function () {
                return this.d9;
            },
            set: function (a) {
                var b = this.d9;
                this.d9 = a;
                if (b != this.d9) {
                    this.dc("BarOutline", b, this.d9);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "a5", {
            get: function () {
                return this.ai;
            },
            set: function (a) {
                var b = this.ai;
                this.ai = a;
                if (b != this.ai) {
                    this.dc("BarStrokeThickness", b, this.ai);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "fb", {
            get: function () {
                return this.eq;
            },
            set: function (a) {
                var b = this.eq;
                this.eq = a;
                if (b != this.eq) {
                    this.dc("RangeThumbBrush", b, this.eq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "fc", {
            get: function () {
                return this.er;
            },
            set: function (a) {
                var b = this.er;
                this.er = a;
                if (b != this.er) {
                    this.dc("RangeThumbOutline", b, this.er);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "bj", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                var b = this.a0;
                this.a0 = a;
                if (b != this.a0) {
                    this.dc("RangeThumbStrokeThickness", b, this.a0);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "fd", {
            get: function () {
                return this.es;
            },
            set: function (a) {
                var b = this.es;
                this.es = a;
                if (b != this.es) {
                    this.dc("RangeThumbRidgesBrush", b, this.es);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e3", {
            get: function () {
                return this.ei;
            },
            set: function (a) {
                var b = this.ei;
                this.ei = a;
                if (b != this.ei) {
                    this.dc("LowerCalloutBrush", b, this.ei);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e5", {
            get: function () {
                return this.ek;
            },
            set: function (a) {
                var b = this.ek;
                this.ek = a;
                if (b != this.ek) {
                    this.dc("LowerCalloutTextColor", b, this.ek);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "e4", {
            get: function () {
                return this.ej;
            },
            set: function (a) {
                var b = this.ej;
                this.ej = a;
                if (b != this.ej) {
                    this.dc("LowerCalloutOutline", b, this.ej);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "bb", {
            get: function () {
                return this.as;
            },
            set: function (a) {
                var b = this.as;
                this.as = a;
                if (b != this.as) {
                    this.dc("LowerCalloutStrokeThickness", b, this.as);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ev", {
            get: function () {
                return this.ea;
            },
            set: function (a) {
                var b = this.ea;
                this.ea = a;
                if (b != this.ea) {
                    this.dc("HigherCalloutBrush", b, this.ea);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ex", {
            get: function () {
                return this.ec;
            },
            set: function (a) {
                var b = this.ec;
                this.ec = a;
                if (b != this.ec) {
                    this.dc("HigherCalloutTextColor", b, this.ec);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ew", {
            get: function () {
                return this.eb;
            },
            set: function (a) {
                var b = this.eb;
                this.eb = a;
                if (b != this.eb) {
                    this.dc("HigherCalloutOutline", b, this.eb);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "a6", {
            get: function () {
                return this.am;
            },
            set: function (a) {
                var b = this.am;
                this.am = a;
                if (b != this.am) {
                    this.dc("HigherCalloutStrokeThickness", b, this.am);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "ab", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "z", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "y", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ZoomSlider.prototype, "aa", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        ZoomSlider.prototype.dc = function (a, b, c) {
            this.dj(a, b, c);
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
        };
        ZoomSlider.prototype.dj = function (a, b, c) {
            switch (a) {
                case "PixelScalingRatio":
                    this.a4 = this.bi;
                    break;
                case "ActualPixelScalingRatio":
                    if (this.g != null) {
                        this.g.at();
                    }
                    break;
                case "Orientation":
                    this.db();
                    this.trackDirty();
                    break;
                case "TrackStartInset":
                case "TrackEndInset":
                case "StartInset":
                case "EndInset":
                    this.c5();
                    this.trackDirty();
                    break;
                case "MaxZoomWidth":
                case "MinZoomWidth":
                    this.dh();
                    this.trackDirty();
                    break;
                case "WindowRect":
                    if (!this.w) {
                        this.af = true;
                        this.df();
                        this.trackDirty();
                        this.c3();
                        this.af = false;
                    }
                    break;
                case "LowerThumbBrush":
                case "LowerThumbOutline":
                case "LowerThumbRidgesBrush":
                case "LowerThumbStrokeThickness":
                    this.d2();
                    this.g.ao();
                    break;
                case "LowerThumbWidth":
                case "LowerThumbHeight":
                    this.g.i.width = this.bf;
                    this.g.i.height = this.bd;
                    this.trackDirty();
                    break;
                case "HigherThumbBrush":
                case "HigherThumbOutline":
                case "HigherThumbRidgesBrush":
                case "HigherThumbStrokeThickness":
                    this.dx();
                    this.g.ao();
                    break;
                case "HigherThumbWidth":
                case "HigherThumbHeight":
                    this.g.i.width = this.bf;
                    this.g.i.height = this.bd;
                    this.trackDirty();
                    break;
                case "LowerShadeBrush":
                case "LowerShadeOutline":
                case "LowerShadeStrokeThickness":
                    this.d0();
                    this.g.ao();
                    break;
                case "HigherShadeBrush":
                case "HigherShadeOutline":
                case "HigherShadeStrokeThickness":
                    this.dv();
                    this.g.ao();
                    break;
                case "RangeThumbBrush":
                case "RangeThumbOutline":
                case "RangeThumbRidgesBrush":
                case "RangeThumbStrokeThickness":
                    this.d4();
                    this.g.ao();
                    break;
                case "BarBrush":
                case "BarOutline":
                case "BarStrokeThickness":
                    this.dq();
                    this.g.ao();
                    break;
                case "LowerCalloutBrush":
                case "LowerCalloutOutline":
                case "LowerCalloutTextColor":
                case "LowerCalloutStrokeThickness":
                    this.dy();
                    this.g.ao();
                    break;
                case "HigherCalloutBrush":
                case "HigherCalloutOutline":
                case "HigherCalloutTextColor":
                case "HigherCalloutStrokeThickness":
                    this.dt();
                    this.g.ao();
                    break;
            }
        };
        ZoomSlider.prototype.dq = function () {
            var a = this.g.b;
            if (this.et == null) {
                a.barBox._fill = a.getBarBoxDefaultBrush();
            }
            else {
                a.barBox._fill = this.et;
            }
            if (this.eu == null) {
                a.barBox._stroke = a.getBarBoxDefaultOutline();
            }
            else {
                a.barBox._stroke = this.eu;
            }
            if (this.a5 == NaN) {
                a.barBox.ac = a.getBarBoxDefaultStrokeThickness();
            }
            else {
                a.barBox.ac = this.a5;
            }
        };
        ZoomSlider.prototype.dy = function () {
            var a = this.g.g;
            if (this.e3 == null) {
                a.calloutBox._fill = a.getCalloutBoxDefaultBrush();
            }
            else {
                a.calloutBox._fill = this.e3;
            }
            if (this.e4 == null) {
                a.calloutBox._stroke = a.getCalloutBoxDefaultStroke();
            }
            else {
                a.calloutBox._stroke = this.e4;
            }
            if (this.e5 == null) {
                a.calloutText.am = a.getCalloutTextDefaultBrush();
            }
            else {
                a.calloutText.am = this.e5;
            }
            if (this.bb == NaN) {
                a.calloutBox.ac = a.getCalloutBoxDefaultStrokeThickness();
            }
            else {
                a.calloutBox.ac = this.bb;
            }
        };
        ZoomSlider.prototype.dt = function () {
            var a = this.g.f;
            if (this.ev == null) {
                a.calloutBox._fill = a.getCalloutBoxDefaultBrush();
            }
            else {
                a.calloutBox._fill = this.ev;
            }
            if (this.ew == null) {
                a.calloutBox._stroke = a.getCalloutBoxDefaultStroke();
            }
            else {
                a.calloutBox._stroke = this.ew;
            }
            if (this.ex == null) {
                a.calloutText.am = a.getCalloutTextDefaultBrush();
            }
            else {
                a.calloutText.am = this.ex;
            }
            if (this.a6 == NaN) {
                a.calloutBox.ac = a.getCalloutBoxDefaultStrokeThickness();
            }
            else {
                a.calloutBox.ac = this.a6;
            }
        };
        ZoomSlider.prototype.d2 = function () {
            var a = this.g.i;
            if (this.e8 == null) {
                a.thumbBox._fill = a.getThumbBoxDefaultBrush();
            }
            else {
                a.thumbBox._fill = this.e8;
            }
            if (this.e9 == null) {
                a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
            }
            else {
                a.thumbBox._stroke = this.e9;
            }
            if (this.fa == null) {
                a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
            }
            else {
                a.thumbRidges._stroke = this.fa;
            }
            if (this.be == NaN) {
                a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
            }
            else {
                a.thumbBox.ac = this.be;
            }
        };
        ZoomSlider.prototype.d4 = function () {
            var a = this.g.c;
            if (this.fb == null) {
                a.thumbBox._fill = a.getThumbBoxDefaultBrush();
            }
            else {
                a.thumbBox._fill = this.fb;
            }
            if (this.fc == null) {
                a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
            }
            else {
                a.thumbBox._stroke = this.fc;
            }
            if (this.fd == null) {
                a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
            }
            else {
                a.thumbRidges._stroke = this.fd;
            }
            if (this.bj == NaN) {
                a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
            }
            else {
                a.thumbBox.ac = this.bj;
            }
        };
        ZoomSlider.prototype.d0 = function () {
            var a = this.g.e;
            if (this.e6 == null) {
                a.shadeBox._fill = a.getShadeBoxDefaultBrush();
            }
            else {
                a.shadeBox._fill = this.e6;
            }
            if (this.e7 == null) {
                a.shadeOutline._stroke = a.getShadeOutlineDefaultBrush();
            }
            else {
                a.shadeOutline._stroke = this.e7;
            }
            if (this.bc == NaN) {
                a.shadeOutline.ac = a.getShadeOutlineDefaultStrokeThickness();
            }
            else {
                a.shadeOutline.ac = this.bc;
            }
        };
        ZoomSlider.prototype.dv = function () {
            var a = this.g.d;
            if (this.ey == null) {
                a.shadeBox._fill = a.getShadeBoxDefaultBrush();
            }
            else {
                a.shadeBox._fill = this.ey;
            }
            if (this.ez == null) {
                a.shadeOutline._stroke = a.getShadeOutlineDefaultBrush();
            }
            else {
                a.shadeOutline._stroke = this.ez;
            }
            if (this.a7 == NaN) {
                a.shadeOutline.ac = a.getShadeOutlineDefaultStrokeThickness();
            }
            else {
                a.shadeOutline.ac = this.a7;
            }
        };
        ZoomSlider.prototype.dx = function () {
            var a = this.g.h;
            if (this.e0 == null) {
                a.thumbBox._fill = a.getThumbBoxDefaultBrush();
            }
            else {
                a.thumbBox._fill = this.e0;
            }
            if (this.e1 == null) {
                a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
            }
            else {
                a.thumbBox._stroke = this.e1;
            }
            if (this.e2 == null) {
                a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
            }
            else {
                a.thumbRidges._stroke = this.e2;
            }
            if (this.a9 == NaN) {
                a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
            }
            else {
                a.thumbBox.ac = this.a9;
            }
        };
        ZoomSlider.prototype.df = function () {
            if (this.w) {
                return;
            }
            if (this.e == 0) {
                this.b.i = this.windowRect.left;
                this.a.i = this.windowRect.right;
                this.c.r = this.windowRect.width;
                this.c.n = this.windowRect.left + this.windowRect.width / 2;
            }
            else {
                this.b.i = this.windowRect.top;
                this.a.i = this.windowRect.bottom;
                this.c.r = this.windowRect.height;
                this.c.n = this.windowRect.top + this.windowRect.height / 2;
            }
        };
        ZoomSlider.prototype.dh = function () {
            this.c.m = this.bh;
            this.c.l = this.bg;
        };
        ZoomSlider.prototype.c5 = function () {
            if (this.fj.isEmpty) {
                return;
            }
            this.de(this.fj.left, this.fj.top, this.fj.width, this.fj.height);
        };
        ZoomSlider.prototype.db = function () {
            if (this.e == 0) {
                this.g.i.width = this.bf;
                this.g.i.height = this.bd;
                this.g.h.width = this.ba;
                this.g.h.height = this.a8;
            }
            else {
                this.g.i.height = this.bf;
                this.g.i.width = this.bd;
                this.g.h.height = this.ba;
                this.g.h.width = this.a8;
            }
            if (this.fj.isEmpty) {
                return;
            }
            this.de(this.fj.left, this.fj.top, this.fj.width, this.fj.height);
        };
        ZoomSlider.prototype.provideContainer = function (a) {
            this.g.au(a);
        };
        ZoomSlider.prototype.notifySizeChanged = function () {
            this.g.ap();
        };
        Object.defineProperty(ZoomSlider.prototype, "l", {
            get: function () {
                return this.k;
            },
            enumerable: false,
            configurable: true
        });
        ZoomSlider.prototype.dn = function (a) {
            this.ak = a;
            this.aj = this.c.n;
            this.ar = this.aj;
            this.k.v();
        };
        ZoomSlider.prototype.cy = function () {
            if (this.k.f()) {
                this.k.w();
            }
        };
        ZoomSlider.prototype.cx = function (a, b) {
            var c = this.k.o;
            var d = this.aj + c * (this.ak - this.aj);
            var e = d - this.ar;
            this.ar = d;
            this.c.o(e);
            if (this.k.f()) {
                this.d1(this.b);
                this.dw(this.a);
                this.c3();
            }
            else {
                this.c1();
                this.c0();
            }
        };
        ZoomSlider.prototype.c3 = function () {
            this.g.aj();
        };
        ZoomSlider.prototype.trackDirty = function () {
            this.p = true;
            if (this.g == null) {
                return;
            }
            this.g.ao();
        };
        ZoomSlider.prototype.show = function () {
            if (this.g != null) {
                this.g.az();
            }
        };
        ZoomSlider.prototype.hide = function () {
            if (this.g != null) {
                this.g.am();
            }
        };
        ZoomSlider.$t = i2.markType(ZoomSlider, 'ZoomSlider', i2.Base.$, [ITrackOwner_$type, i2.INotifyPropertyChanged_$type, i2.IZoomSlider_$type]);
        return ZoomSlider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    var ZoomSliderStylingDefaults = {};
    var IgxZoomSliderComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxZoomSliderComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = this;
            this.renderer = renderer;
            this._elRef = _elRef;
            this.ngZone = ngZone;
            this.injector = injector;
            this.componentFactoryResolver = componentFactoryResolver;
            this._wrapper = null;
            this._root = null;
            this._implementation = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._resolvingAxisValue = null;
            this._windowRectChanged = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            if (renderer) {
                this.container = renderer.createElement("div");
                renderer.appendChild(_elRef.element.nativeElement, this.container);
                renderer.setStyle(this.container, "display", "block");
                renderer.setStyle(this.container, "width", "100%");
                renderer.setStyle(this.container, "height", "100%");
            }
            var root;
            root = this.container;
            if (this.container != null) {
                root = this.container;
            }
            if (root && root.nativeElement) {
                root = root.nativeElement;
            }
            this._root = root;
            var zoomSlider = this.i;
            this._zoomSlider = zoomSlider;
            if (renderer) {
                var ren = new i2.AngularRenderer(root, this.renderer, window.document, this.ngZone, true, ZoomSliderStylingDefaults);
                this._wrapper = ren;
                zoomSlider.provideContainer(ren);
                zoomSlider.notifySizeChanged();
                ren.addSizeWatcher(function () {
                    _this._zoomSlider.notifySizeChanged();
                });
            }
        }
        Object.defineProperty(IgxZoomSliderComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._zoomSlider.notifySizeChanged();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._zoomSlider.notifySizeChanged();
            },
            enumerable: false,
            configurable: true
        });
        // supports angular themes or custom properties set in CSS
        IgxZoomSliderComponent.prototype.updateStyle = function () {
            this._styling(this._root, this);
        };
        IgxZoomSliderComponent.prototype.ngOnDestroy = function () {
            this._zoomSlider.destroy();
            this._wrapper.destroy();
        };
        IgxZoomSliderComponent.prototype.ngAfterContentInit = function () {
            this.updateStyle();
        };
        IgxZoomSliderComponent.prototype.createImplementation = function () {
            return new ZoomSlider();
        };
        Object.defineProperty(IgxZoomSliderComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxZoomSliderComponent._staticStyling = function (container, component, parent) {
            var genericPrefix = "";
            var typeName = (component.i ? component.i : component).$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("ZoomSlider");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = (component.i ? component.i : component).$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, component, genericPrefix + "-", new Set(), false, additionalPrefixes);
        };
        Object.defineProperty(IgxZoomSliderComponent.prototype, "panTransitionDuration", {
            get: function () {
                return this.i.bl;
            },
            set: function (v) {
                this.i.bl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "maxZoomWidth", {
            get: function () {
                return this.i.bg;
            },
            set: function (v) {
                this.i.bg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.bi;
            },
            set: function (v) {
                this.i.bi = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "actualPixelScalingRatio", {
            get: function () {
                return this.i.a4;
            },
            set: function (v) {
                this.i.a4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "windowRect", {
            get: function () {
                return i2.fromRect(this.i.windowRect);
            },
            set: function (v) {
                this.i.windowRect = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "minZoomWidth", {
            get: function () {
                return this.i.bh;
            },
            set: function (v) {
                this.i.bh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "startInset", {
            get: function () {
                return this.i.startInset;
            },
            set: function (v) {
                this.i.startInset = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "endInset", {
            get: function () {
                return this.i.endInset;
            },
            set: function (v) {
                this.i.endInset = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "trackStartInset", {
            get: function () {
                return this.i.trackStartInset;
            },
            set: function (v) {
                this.i.trackStartInset = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "trackEndInset", {
            get: function () {
                return this.i.trackEndInset;
            },
            set: function (v) {
                this.i.trackEndInset = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "barExtent", {
            get: function () {
                return this.i.barExtent;
            },
            set: function (v) {
                this.i.barExtent = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "orientation", {
            get: function () {
                return this.i.e;
            },
            set: function (v) {
                this.i.e = i2.ensureEnum(ZoomSliderOrientation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbBrush", {
            get: function () {
                return i2.brushToString(this.i.e8);
            },
            set: function (v) {
                this.i.e8 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbStrokeThickness", {
            get: function () {
                return this.i.be;
            },
            set: function (v) {
                this.i.be = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbStrokeThickness", {
            get: function () {
                return this.i.a9;
            },
            set: function (v) {
                this.i.a9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbBrush", {
            get: function () {
                return i2.brushToString(this.i.e0);
            },
            set: function (v) {
                this.i.e0 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbOutline", {
            get: function () {
                return i2.brushToString(this.i.e9);
            },
            set: function (v) {
                this.i.e9 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbOutline", {
            get: function () {
                return i2.brushToString(this.i.e1);
            },
            set: function (v) {
                this.i.e1 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbRidgesBrush", {
            get: function () {
                return i2.brushToString(this.i.fa);
            },
            set: function (v) {
                this.i.fa = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbRidgesBrush", {
            get: function () {
                return i2.brushToString(this.i.e2);
            },
            set: function (v) {
                this.i.e2 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbWidth", {
            get: function () {
                return this.i.bf;
            },
            set: function (v) {
                this.i.bf = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbWidth", {
            get: function () {
                return this.i.ba;
            },
            set: function (v) {
                this.i.ba = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbHeight", {
            get: function () {
                return this.i.bd;
            },
            set: function (v) {
                this.i.bd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbHeight", {
            get: function () {
                return this.i.a8;
            },
            set: function (v) {
                this.i.a8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerShadeBrush", {
            get: function () {
                return i2.brushToString(this.i.e6);
            },
            set: function (v) {
                this.i.e6 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerShadeOutline", {
            get: function () {
                return i2.brushToString(this.i.e7);
            },
            set: function (v) {
                this.i.e7 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerShadeStrokeThickness", {
            get: function () {
                return this.i.bc;
            },
            set: function (v) {
                this.i.bc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherShadeBrush", {
            get: function () {
                return i2.brushToString(this.i.ey);
            },
            set: function (v) {
                this.i.ey = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherShadeOutline", {
            get: function () {
                return i2.brushToString(this.i.ez);
            },
            set: function (v) {
                this.i.ez = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherShadeStrokeThickness", {
            get: function () {
                return this.i.a7;
            },
            set: function (v) {
                this.i.a7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "barBrush", {
            get: function () {
                return i2.brushToString(this.i.et);
            },
            set: function (v) {
                this.i.et = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "barOutline", {
            get: function () {
                return i2.brushToString(this.i.eu);
            },
            set: function (v) {
                this.i.eu = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "barStrokeThickness", {
            get: function () {
                return this.i.a5;
            },
            set: function (v) {
                this.i.a5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbBrush", {
            get: function () {
                return i2.brushToString(this.i.fb);
            },
            set: function (v) {
                this.i.fb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbOutline", {
            get: function () {
                return i2.brushToString(this.i.fc);
            },
            set: function (v) {
                this.i.fc = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbStrokeThickness", {
            get: function () {
                return this.i.bj;
            },
            set: function (v) {
                this.i.bj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbRidgesBrush", {
            get: function () {
                return i2.brushToString(this.i.fd);
            },
            set: function (v) {
                this.i.fd = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutBrush", {
            get: function () {
                return i2.brushToString(this.i.e3);
            },
            set: function (v) {
                this.i.e3 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutTextColor", {
            get: function () {
                return i2.brushToString(this.i.e5);
            },
            set: function (v) {
                this.i.e5 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutOutline", {
            get: function () {
                return i2.brushToString(this.i.e4);
            },
            set: function (v) {
                this.i.e4 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutStrokeThickness", {
            get: function () {
                return this.i.bb;
            },
            set: function (v) {
                this.i.bb = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutBrush", {
            get: function () {
                return i2.brushToString(this.i.ev);
            },
            set: function (v) {
                this.i.ev = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutTextColor", {
            get: function () {
                return i2.brushToString(this.i.ex);
            },
            set: function (v) {
                this.i.ex = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutOutline", {
            get: function () {
                return i2.brushToString(this.i.ew);
            },
            set: function (v) {
                this.i.ew = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutStrokeThickness", {
            get: function () {
                return this.i.a6;
            },
            set: function (v) {
                this.i.a6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomThumbProvided", {
            get: function () {
                return this.i.ab;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomRangeThumbProvided", {
            get: function () {
                return this.i.z;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomBarProvided", {
            get: function () {
                return this.i.y;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomShadeProvided", {
            get: function () {
                return this.i.aa;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "areThumbCalloutsEnabled", {
            get: function () {
                return this.i.q;
            },
            set: function (v) {
                this.i.q = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "thumbCalloutTextStyle", {
            get: function () {
                if (this.i.o == null) {
                    return null;
                }
                return this.i.o.fontString;
            },
            set: function (v) {
                var fi = new i2.FontInfo();
                fi.fontString = v;
                this.i.o = fi;
            },
            enumerable: false,
            configurable: true
        });
        IgxZoomSliderComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxZoomSliderComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxZoomSliderComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxZoomSliderComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("ZoomSliderComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxZoomSliderComponent.prototype.onDetachedFromUI = function () {
            this.i.onDetachedFromUI();
        };
        IgxZoomSliderComponent.prototype.onAttachedToUI = function () {
            this.i.onAttachedToUI();
        };
        /**
         * Release any resources held by the ZoomSlider.
        
        */
        IgxZoomSliderComponent.prototype.destroy = function () {
            this.i.destroy();
        };
        /**
         * Called by the UI framework to provide a UI container for rendering this control.
        
        * @param container  * The UI container element.
        */
        IgxZoomSliderComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        IgxZoomSliderComponent.prototype.flush = function () {
            this.i.c3();
        };
        IgxZoomSliderComponent.prototype.trackDirty = function () {
            this.i.trackDirty();
        };
        /**
         * Shows the ZoomSlider.
        
        */
        IgxZoomSliderComponent.prototype.show = function () {
            this.i.show();
        };
        /**
         * Hides the ZoomSlider.
        
        */
        IgxZoomSliderComponent.prototype.hide = function () {
            this.i.hide();
        };
        Object.defineProperty(IgxZoomSliderComponent.prototype, "resolvingAxisValue", {
            get: function () {
                var _this = this;
                if (this._resolvingAxisValue == null) {
                    this._resolvingAxisValue = new i0.EventEmitter();
                    this.i.resolvingAxisValue = i2.delegateCombine(this.i.resolvingAxisValue, function (o, e) {
                        var outerArgs = new IgxZoomSliderResolvingAxisValueEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeResolvingAxisValue) {
                            _this.beforeResolvingAxisValue(_this, outerArgs);
                        }
                        _this._resolvingAxisValue.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._resolvingAxisValue;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxZoomSliderComponent.prototype, "windowRectChanged", {
            /**
             * Occurs just after the current ZoomSlider's window rectangle is changed.
            */
            get: function () {
                var _this = this;
                if (this._windowRectChanged == null) {
                    this._windowRectChanged = new i0.EventEmitter();
                    this.i.windowRectChanged = i2.delegateCombine(this.i.windowRectChanged, function (o, e) {
                        var outerArgs = new i2.IgxRectChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeWindowRectChanged) {
                            _this.beforeWindowRectChanged(_this, outerArgs);
                        }
                        _this._windowRectChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._windowRectChanged;
            },
            enumerable: false,
            configurable: true
        });
        IgxZoomSliderComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxZoomSliderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxZoomSliderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxZoomSliderComponent, selector: "igx-zoom-slider", inputs: { height: "height", width: "width", panTransitionDuration: "panTransitionDuration", maxZoomWidth: "maxZoomWidth", pixelScalingRatio: "pixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio", windowRect: "windowRect", minZoomWidth: "minZoomWidth", startInset: "startInset", endInset: "endInset", trackStartInset: "trackStartInset", trackEndInset: "trackEndInset", barExtent: "barExtent", orientation: "orientation", lowerThumbBrush: "lowerThumbBrush", lowerThumbStrokeThickness: "lowerThumbStrokeThickness", higherThumbStrokeThickness: "higherThumbStrokeThickness", higherThumbBrush: "higherThumbBrush", lowerThumbOutline: "lowerThumbOutline", higherThumbOutline: "higherThumbOutline", lowerThumbRidgesBrush: "lowerThumbRidgesBrush", higherThumbRidgesBrush: "higherThumbRidgesBrush", lowerThumbWidth: "lowerThumbWidth", higherThumbWidth: "higherThumbWidth", lowerThumbHeight: "lowerThumbHeight", higherThumbHeight: "higherThumbHeight", lowerShadeBrush: "lowerShadeBrush", lowerShadeOutline: "lowerShadeOutline", lowerShadeStrokeThickness: "lowerShadeStrokeThickness", higherShadeBrush: "higherShadeBrush", higherShadeOutline: "higherShadeOutline", higherShadeStrokeThickness: "higherShadeStrokeThickness", barBrush: "barBrush", barOutline: "barOutline", barStrokeThickness: "barStrokeThickness", rangeThumbBrush: "rangeThumbBrush", rangeThumbOutline: "rangeThumbOutline", rangeThumbStrokeThickness: "rangeThumbStrokeThickness", rangeThumbRidgesBrush: "rangeThumbRidgesBrush", lowerCalloutBrush: "lowerCalloutBrush", lowerCalloutTextColor: "lowerCalloutTextColor", lowerCalloutOutline: "lowerCalloutOutline", lowerCalloutStrokeThickness: "lowerCalloutStrokeThickness", higherCalloutBrush: "higherCalloutBrush", higherCalloutTextColor: "higherCalloutTextColor", higherCalloutOutline: "higherCalloutOutline", higherCalloutStrokeThickness: "higherCalloutStrokeThickness", areThumbCalloutsEnabled: "areThumbCalloutsEnabled", thumbCalloutTextStyle: "thumbCalloutTextStyle" }, outputs: { resolvingAxisValue: "resolvingAxisValue", windowRectChanged: "windowRectChanged" }, host: { classAttribute: "ig-zoom-slider igx-zoom-slider" }, providers: [], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], ngImport: i0, template: "", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxZoomSliderComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-zoom-slider',
                        template: "",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-zoom-slider igx-zoom-slider' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], panTransitionDuration: [{
                    type: i0.Input
                }], maxZoomWidth: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], actualPixelScalingRatio: [{
                    type: i0.Input
                }], windowRect: [{
                    type: i0.Input
                }], minZoomWidth: [{
                    type: i0.Input
                }], startInset: [{
                    type: i0.Input
                }], endInset: [{
                    type: i0.Input
                }], trackStartInset: [{
                    type: i0.Input
                }], trackEndInset: [{
                    type: i0.Input
                }], barExtent: [{
                    type: i0.Input
                }], orientation: [{
                    type: i0.Input
                }], lowerThumbBrush: [{
                    type: i0.Input
                }], lowerThumbStrokeThickness: [{
                    type: i0.Input
                }], higherThumbStrokeThickness: [{
                    type: i0.Input
                }], higherThumbBrush: [{
                    type: i0.Input
                }], lowerThumbOutline: [{
                    type: i0.Input
                }], higherThumbOutline: [{
                    type: i0.Input
                }], lowerThumbRidgesBrush: [{
                    type: i0.Input
                }], higherThumbRidgesBrush: [{
                    type: i0.Input
                }], lowerThumbWidth: [{
                    type: i0.Input
                }], higherThumbWidth: [{
                    type: i0.Input
                }], lowerThumbHeight: [{
                    type: i0.Input
                }], higherThumbHeight: [{
                    type: i0.Input
                }], lowerShadeBrush: [{
                    type: i0.Input
                }], lowerShadeOutline: [{
                    type: i0.Input
                }], lowerShadeStrokeThickness: [{
                    type: i0.Input
                }], higherShadeBrush: [{
                    type: i0.Input
                }], higherShadeOutline: [{
                    type: i0.Input
                }], higherShadeStrokeThickness: [{
                    type: i0.Input
                }], barBrush: [{
                    type: i0.Input
                }], barOutline: [{
                    type: i0.Input
                }], barStrokeThickness: [{
                    type: i0.Input
                }], rangeThumbBrush: [{
                    type: i0.Input
                }], rangeThumbOutline: [{
                    type: i0.Input
                }], rangeThumbStrokeThickness: [{
                    type: i0.Input
                }], rangeThumbRidgesBrush: [{
                    type: i0.Input
                }], lowerCalloutBrush: [{
                    type: i0.Input
                }], lowerCalloutTextColor: [{
                    type: i0.Input
                }], lowerCalloutOutline: [{
                    type: i0.Input
                }], lowerCalloutStrokeThickness: [{
                    type: i0.Input
                }], higherCalloutBrush: [{
                    type: i0.Input
                }], higherCalloutTextColor: [{
                    type: i0.Input
                }], higherCalloutOutline: [{
                    type: i0.Input
                }], higherCalloutStrokeThickness: [{
                    type: i0.Input
                }], areThumbCalloutsEnabled: [{
                    type: i0.Input
                }], thumbCalloutTextStyle: [{
                    type: i0.Input
                }], resolvingAxisValue: [{
                    type: i0.Output
                }], windowRectChanged: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxZoomSliderModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxZoomSliderModule() {
            i2.TypeRegistrar.registerCons('IgxZoomSliderComponent', IgxZoomSliderComponent);
            i2.TypeRegistrar.register('ZoomSlider', ZoomSlider.$type);
        }
        IgxZoomSliderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxZoomSliderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderModule, declarations: [IgxZoomSliderComponent], imports: [i1.CommonModule], exports: [IgxZoomSliderComponent] });
        IgxZoomSliderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderModule, imports: [[i1.CommonModule,
                ]] });
        return IgxZoomSliderModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxZoomSliderComponent],
                        exports: [IgxZoomSliderComponent
                        ],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxZoomSliderDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxZoomSliderDynamicModule() {
            i2.TypeRegistrar.registerCons('ZoomSlider', ZoomSlider);
            i2.TypeRegistrar.registerCons('IgxZoomSliderComponent', IgxZoomSliderComponent);
            i2.TypeRegistrar.register('ZoomSlider', ZoomSlider.$type);
        }
        IgxZoomSliderDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxZoomSliderDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderDynamicModule, imports: [i1.CommonModule, IgxZoomSliderModule], exports: [IgxZoomSliderModule] });
        IgxZoomSliderDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderDynamicModule, imports: [[i1.CommonModule, IgxZoomSliderModule
                ], IgxZoomSliderModule] });
        return IgxZoomSliderDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxZoomSliderDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxZoomSliderModule
                        ],
                        imports: [i1.CommonModule, IgxZoomSliderModule
                        ],
                        entryComponents: [IgxZoomSliderComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    //some of the build tools don't like styles not being an array literal for Angular
    //export const LegendBaseStyles: string[] = [`
    //`];
    /**
     * Represents the base class for a legend in IgxDataChartComponent.
    */
    var IgxLegendBaseComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxLegendBaseComponent() {
            this._zoneRunner = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
        }
        Object.defineProperty(IgxLegendBaseComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxLegendBaseComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxLegendBaseComponent.prototype, "isItemwise", {
            /**
         * Gets if the legend is item-wise.
        */
            get: function () {
                return this.i.isItemwise;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendBaseComponent.prototype, "isFinancial", {
            /**
             * Gets if the legend is a financial legend.
            */
            get: function () {
                return this.i.isFinancial;
            },
            enumerable: false,
            configurable: true
        });
        IgxLegendBaseComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxLegendBaseComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxLegendBaseComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxLegendBaseComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("LegendBaseComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Returns the legend visuals expressed as a serialized string.

    */
        IgxLegendBaseComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.exportSerializedVisualData();
            return (iv);
        };
        return IgxLegendBaseComponent;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendMouseButtonEventArgs, _super);
        function LegendMouseButtonEventArgs(a, b, c, d, e) {
            var _this = _super.call(this) || this;
            _this._originalEvent = null;
            _this._item = null;
            _this._series = null;
            _this._chart = null;
            _this._legendItem = null;
            _this.chart = a;
            _this.series = b;
            _this.item = c;
            _this.originalEvent = d;
            _this.legendItem = e;
            return _this;
        }
        LegendMouseButtonEventArgs.prototype.toString = function () {
            return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
        };
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "originalEvent", {
            get: function () {
                return this._originalEvent;
            },
            set: function (a) {
                this._originalEvent = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "handled", {
            get: function () {
                return this.originalEvent.handled;
            },
            set: function (a) {
                this.originalEvent.handled = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendMouseButtonEventArgs.prototype.getPosition = function (a) {
            return this.originalEvent.getPosition(a);
        };
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "originalSource", {
            get: function () {
                return this.originalEvent.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "d", {
            get: function () {
                return i2.typeCast(i2.ILegendSeriesInternal_$type, this.series);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "chart", {
            get: function () {
                return this._chart;
            },
            set: function (a) {
                this._chart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseButtonEventArgs.prototype, "legendItem", {
            get: function () {
                return this._legendItem;
            },
            set: function (a) {
                this._legendItem = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendMouseButtonEventArgs.$t = i2.markType(LegendMouseButtonEventArgs, 'LegendMouseButtonEventArgs', i2.EventArgs.$);
        return LegendMouseButtonEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendMouseEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendMouseEventArgs, _super);
        function LegendMouseEventArgs(a, b, c, d, e) {
            var _this = _super.call(this) || this;
            _this._originalEvent = null;
            _this._item = null;
            _this._series = null;
            _this._chart = null;
            _this._legendItem = null;
            _this.chart = a;
            _this.series = b;
            _this.item = c;
            _this.originalEvent = d;
            _this.legendItem = e;
            return _this;
        }
        LegendMouseEventArgs.prototype.toString = function () {
            return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
        };
        Object.defineProperty(LegendMouseEventArgs.prototype, "originalEvent", {
            get: function () {
                return this._originalEvent;
            },
            set: function (a) {
                this._originalEvent = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendMouseEventArgs.prototype.getPosition = function (a) {
            return this.originalEvent.getPosition(a);
        };
        Object.defineProperty(LegendMouseEventArgs.prototype, "originalSource", {
            get: function () {
                return this.originalEvent.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseEventArgs.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseEventArgs.prototype, "d", {
            get: function () {
                return i2.typeCast(i2.ILegendSeriesInternal_$type, this.series);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseEventArgs.prototype, "chart", {
            get: function () {
                return this._chart;
            },
            set: function (a) {
                this._chart = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendMouseEventArgs.prototype, "legendItem", {
            get: function () {
                return this._legendItem;
            },
            set: function (a) {
                this._legendItem = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendMouseEventArgs.$t = i2.markType(LegendMouseEventArgs, 'LegendMouseEventArgs', i2.EventArgs.$);
        return LegendMouseEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendItemVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendItemVisualData, _super);
        function LegendItemVisualData() {
            var _this = _super.call(this) || this;
            _this._label = null;
            _this._labelBounds = null;
            _this._appearance = null;
            _this._labelAppearance = null;
            _this._bounds = null;
            _this._badgeBounds = null;
            _this.labelBounds = i2.RectData.empty;
            _this.appearance = new i2.PrimitiveAppearanceData();
            return _this;
        }
        Object.defineProperty(LegendItemVisualData.prototype, "label", {
            get: function () {
                return this._label;
            },
            set: function (a) {
                this._label = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendItemVisualData.prototype, "labelBounds", {
            get: function () {
                return this._labelBounds;
            },
            set: function (a) {
                this._labelBounds = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendItemVisualData.prototype, "appearance", {
            get: function () {
                return this._appearance;
            },
            set: function (a) {
                this._appearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendItemVisualData.prototype, "labelAppearance", {
            get: function () {
                return this._labelAppearance;
            },
            set: function (a) {
                this._labelAppearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendItemVisualData.prototype, "bounds", {
            get: function () {
                return this._bounds;
            },
            set: function (a) {
                this._bounds = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendItemVisualData.prototype, "badgeBounds", {
            get: function () {
                return this._badgeBounds;
            },
            set: function (a) {
                this._badgeBounds = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendItemVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.label != null) {
                a.u("label: \"" + this.label + "\", ");
            }
            if (this.appearance != null) {
                a.u("appearance: " + this.appearance.serialize() + ", ");
            }
            if (this.labelAppearance != null) {
                a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
            }
            var b = function (c) { return c != null ? "{ left: " + c.left + ", top: " + c.top + ", width: " + c.width + ", height: " + c.height + "}" : "null"; };
            a.u("bounds: " + b(this.bounds) + ", ");
            a.u("badgeBounds: " + b(this.badgeBounds) + ", ");
            a.u("labelBounds: " + b(this.labelBounds));
            a.u("}");
            return a.toString();
        };
        LegendItemVisualData.$t = i2.markType(LegendItemVisualData, 'LegendItemVisualData');
        return LegendItemVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendVisualDataList, _super);
        function LegendVisualDataList() {
            return _super.call(this, LegendItemVisualData.$, 0) || this;
        }
        LegendVisualDataList.$t = i2.markType(LegendVisualDataList, 'LegendVisualDataList', i2.List$1.$.specialize(LegendItemVisualData.$));
        return LegendVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendVisualData, _super);
        function LegendVisualData() {
            var _this = _super.call(this) || this;
            _this._items = null;
            _this._viewport = null;
            _this._width = 0;
            _this._height = 0;
            _this.items = new LegendVisualDataList();
            return _this;
        }
        Object.defineProperty(LegendVisualData.prototype, "items", {
            get: function () {
                return this._items;
            },
            set: function (a) {
                this._items = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendVisualData.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (a) {
                this._width = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendVisualData.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("width: " + this.width + ",");
            a.u("height: " + this.height + ",");
            a.u("items: [");
            for (var b = 0; b < this.items.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.items._inner[b].serialize());
            }
            a.u("],");
            a.u("}");
            return a.toString();
        };
        LegendVisualData.$t = i2.markType(LegendVisualData, 'LegendVisualData');
        return LegendVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendBaseViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendBaseViewManager, _super);
        function LegendBaseViewManager(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.l = null;
            _this.g = null;
            _this.d = false;
            _this.f = null;
            _this.m = null;
            _this.c = null;
            _this.a = a;
            _this.f = new i2.Dictionary$2(i2.Base.$, i2.DomWrapper_$type, 0);
            return _this;
        }
        LegendBaseViewManager.prototype.p = function () {
            var a = i2.LegendItemHelper.b;
            if (window.devicePixelRatio != undefined && (i2.isNaN_(a) || window.devicePixelRatio != a)) {
                i2.LegendItemHelper.b = window.devicePixelRatio;
                this.a.al();
            }
        };
        LegendBaseViewManager.prototype.u = function () {
        };
        LegendBaseViewManager.prototype.s = function () {
            this.p();
        };
        LegendBaseViewManager.prototype.t = function (a) {
            if (a == null) {
                this.l = null;
                this.g = null;
                return;
            }
            this.g = a;
            this.l = this.i();
            this.l.addClass(this.a.s);
            this.g.append(this.l);
        };
        LegendBaseViewManager.prototype.i = function () {
            return this.g.createElement("table");
        };
        LegendBaseViewManager.prototype.h = function () {
            var a = this.g.createElement("tr");
            a.addClass(this.a.t);
            var b = this.a.k;
            if (b) {
                a.setStyleProperty("display", "block");
                a.setStyleProperty("float", "left");
                a.setStyleProperty("margin", "0px");
                a.setStyleProperty("margin-right", "8px");
            }
            return a;
        };
        LegendBaseViewManager.prototype.j = function (a) {
            return this.k(a, this.l);
        };
        LegendBaseViewManager.prototype.k = function (a, b) {
            var c = i2.typeCast(i2.ContentControl.$, a);
            var d = this.h();
            if (c != null) {
                var e = i2.typeCast(i2.ILegendContext_$type, c.content);
                if (e != null && c.ah != null) {
                    var f = new i2.DataTemplatePassInfo();
                    f.context = d;
                    f.passID = "LegendItem";
                    var g = new i2.DataTemplateMeasureInfo();
                    g.passInfo = f;
                    g.width = NaN;
                    g.height = NaN;
                    g.data = e;
                    g.context = d;
                    var h = new i2.DataTemplateRenderInfo();
                    h.passInfo = f;
                    if (c.ah.measure != null) {
                        c.ah.measure(g);
                    }
                    h.context = this.g.getSubRenderer(d);
                    h.availableWidth = g.width;
                    h.availableHeight = g.height;
                    h.data = e;
                    h.xPosition = 0;
                    h.yPosition = 0;
                    c.ah.render(h);
                    var i = d.findByClass(".ui-legend-item-badge");
                    for (var j = 0; j < i.length; j++) {
                        i[j].removeClass("ui-legend-item-badge").addClass(this.a.r);
                    }
                    i = d.findByClass(".ui-legend-item-text");
                    for (var k = 0; k < i.length; k++) {
                        if (this.a.k) {
                            i[k].setStyleProperty("white-space", "nowrap");
                        }
                        i[k].removeClass("ui-legend-item-text").addClass(this.a.u);
                    }
                }
            }
            return d;
        };
        LegendBaseViewManager.prototype.o = function (a, b) {
            var c = this.k(a, this.l);
            c.listen("mouseup", i2.runOn(this.a, this.a.ae));
            c.listen("mousedown", i2.runOn(this.a, this.a.ab));
            c.listen("mouseleave", i2.runOn(this.a, this.a.ac));
            c.listen("mousemove", i2.runOn(this.a, this.a.ad));
            this.f.addItem(a, c);
            if ((this.l.getChildCount() == 0) || (b >= this.l.getChildCount())) {
                this.l.append(c);
            }
            else {
                var d = this.l.getChildAt(b);
                d.before(c);
            }
        };
        LegendBaseViewManager.prototype.w = function (a) {
        };
        LegendBaseViewManager.prototype.x = function (a) {
            var _this = this;
            var b;
            if (((function () { var c = _this.f.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                b.unlistenAll();
                b.remove();
                this.f.removeItem(a);
            }
        };
        LegendBaseViewManager.prototype.n = function (visual_) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair_ = _c.value;
                    if (pair_.value.getNativeElement() === visual_) {
                        return pair_.key;
                    }
                    ;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return null;
        };
        LegendBaseViewManager.prototype.e = function (a) {
            var e_2, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.f.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    var c = i2.typeCast(i2.ContentControl.$, b);
                    if (c != null && c.content != null) {
                        var d = i2.typeCast(i2.ILegendContext_$type, c.content);
                        if (d != null && d.itemLabel == a.itemLabel && d.legendLabel == a.legendLabel && d.series == a.series && d.itemBrush == a.itemBrush) {
                            return true;
                        }
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            return false;
        };
        LegendBaseViewManager.prototype.b = function (a) {
            var b = this.g.rootWrapper.width();
            var c = this.g.rootWrapper.height();
            this.l.remove();
            var d = this.g.createElement("div");
            d.setStyleProperty("position", "relative");
            this.m = this.g.createElement("<canvas style=\"position : absolute; top : 0; left : 0\" />");
            this.m.setStyleProperty("position", "absolute");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            this.g.append(d);
            d.append(this.m);
            this.c = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.g.get2DCanvasContext(this.m));
            this.m.setAttribute("width", b.toString());
            this.m.setAttribute("height", c.toString());
            return this.c;
        };
        LegendBaseViewManager.prototype.ab = function () {
            return new i2.Size(1, this.g.rootWrapper.width(), Math.max(10, this.g.rootWrapper.height() - 15));
        };
        LegendBaseViewManager.prototype.y = function (a, b, c, d) {
            var e_3, _a;
            var e = a.g();
            e.beginPath();
            e.moveTo(b.ak._inner[0].x, b.ak._inner[0].y);
            for (var f = 1; f < b.ak.count; f++) {
                e.lineTo(b.ak._inner[f].x, b.ak._inner[f].y);
            }
            e.lineTo(b.ak._inner[0].x, b.ak._inner[0].y);
            var g = e.createLinearGradient(d.left, d.top, d.left, d.top + d.height);
            try {
                for (var _b = tslib.__values(i2.fromEnum(c.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    g.addColorStop(h.a, h.b._fill);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            e.fillStyle = g;
            e.fill();
        };
        LegendBaseViewManager.prototype.q = function () {
        };
        LegendBaseViewManager.prototype.r = function () {
        };
        LegendBaseViewManager.prototype.v = function (a) {
            var b = this.l == null ? 0 : this.l.getChildCount();
            for (var c = 0; c < b; c++) {
                var d = this.l.getChildAt(c);
                d.setStyleProperty("display", a ? "block" : "");
                d.setStyleProperty("float", a ? "left" : "");
                d.setStyleProperty("margin", a ? "0px" : "");
                d.setStyleProperty("margin-right", a ? "8px" : "");
                d.getChildAt(1).setStyleProperty("white-space", a ? "nowrap" : "");
            }
        };
        LegendBaseViewManager.prototype.z = function (a) {
            this.l.setStyleProperty("color", a);
        };
        LegendBaseViewManager.prototype.aa = function (a) {
            var b = i2.FontUtil.getFontInfoFromString(this.g, a);
            this.l.setStyleProperty("font-family", b.n);
            this.l.setStyleProperty("font-size", b.d + "px");
            this.l.setStyleProperty("font-style", b.q);
        };
        LegendBaseViewManager.$t = i2.markType(LegendBaseViewManager, 'LegendBaseViewManager');
        return LegendBaseViewManager;
    }(i2.Base));
    /**
     * @hidden
     */
    var LegendBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendBase, _super);
        function LegendBase() {
            var _this = _super.call(this) || this;
            _this.ak = null;
            _this.at = null;
            _this._seriesOwner = null;
            _this._chartOwner = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.legendItemMouseLeftButtonDown = null;
            _this.legendItemMouseLeftButtonUp = null;
            _this.legendItemMouseEnter = null;
            _this.legendItemMouseLeave = null;
            _this.legendItemMouseMove = null;
            var a = _this.aj();
            _this.a8(a);
            a.ak();
            _this.at = new i2.ObservableCollection$1(i2.UIElement.$, 0);
            _this.aw = "ig-chart-legend-items-list";
            _this.ax = "ig-chart-legend-item";
            _this.av = "ig-chart-legend-item-badge";
            _this.ay = "ig-chart-legend-item-text";
            return _this;
        }
        LegendBase.prototype.onDetachedFromUI = function () {
            this.ak.aj();
        };
        LegendBase.prototype.onAttachedToUI = function () {
            this.ak.ah();
        };
        LegendBase.prototype.aj = function () {
            return new LegendBaseView(this);
        };
        LegendBase.prototype.a8 = function (a) {
            this.ak = a;
        };
        LegendBase.prototype.addChildInOrder = function (a, b) {
        };
        LegendBase.prototype.a0 = function (a, b) {
        };
        Object.defineProperty(LegendBase.prototype, "seriesOwner", {
            get: function () {
                return this._seriesOwner;
            },
            set: function (a) {
                this._seriesOwner = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendBase.prototype, "chartOwner", {
            get: function () {
                return this._chartOwner;
            },
            set: function (a) {
                this._chartOwner = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendBase.prototype.get_isItemwise = function () {
            return false;
        };
        Object.defineProperty(LegendBase.prototype, "isItemwise", {
            get: function () {
                return this.get_isItemwise();
            },
            enumerable: false,
            configurable: true
        });
        LegendBase.prototype.get_isScale = function () {
            return false;
        };
        Object.defineProperty(LegendBase.prototype, "isScale", {
            get: function () {
                return this.get_isScale();
            },
            enumerable: false,
            configurable: true
        });
        LegendBase.prototype.clearLegendItemsForSeries = function (a) {
            var e_4, _a, e_5, _b;
            if (a == null || this.at == null || this.at.count == 0) {
                return;
            }
            var b = new i2.ObservableCollection$1(i2.UIElement.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.at)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    var d = i2.typeCast(i2.ContentControl.$, c);
                    if (d != null && d.content != null) {
                        var e = i2.typeCast(i2.ILegendContext_$type, d.content);
                        if (e != null && e.series == a) {
                            b.add(c);
                        }
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var f = _f.value;
                    this.at.remove(f);
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        };
        LegendBase.prototype.containsChild = function (a) {
            return this.at.contains(a);
        };
        LegendBase.prototype.removeChild = function (a) {
            this.at.remove(a);
        };
        Object.defineProperty(LegendBase.prototype, "ai", {
            get: function () {
                if (this.seriesOwner != null) {
                    return this.seriesOwner;
                }
                else {
                    return this.chartOwner;
                }
            },
            enumerable: false,
            configurable: true
        });
        LegendBase.prototype.a9 = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        LegendBase.prototype.a5 = function (a) {
            if (this.legendItemMouseLeftButtonDown != null) {
                this.legendItemMouseLeftButtonDown(this, a);
            }
            if (a.d != null) {
                a.d.onLegendItemPointerDown(a.item);
            }
        };
        LegendBase.prototype.a6 = function (a) {
            if (this.legendItemMouseLeftButtonUp != null) {
                this.legendItemMouseLeftButtonUp(this, a);
            }
            if (a.d != null) {
                a.d.onLegendItemPointerUp(a.item);
            }
        };
        LegendBase.prototype.a3 = function (a) {
            if (this.legendItemMouseEnter != null) {
                this.legendItemMouseEnter(this, a);
            }
            if (a.d != null) {
                a.d.onLegendItemEnter(a.item);
            }
        };
        LegendBase.prototype.a4 = function (a) {
            if (this.legendItemMouseLeave != null) {
                this.legendItemMouseLeave(this, a);
            }
            if (a.d != null) {
                a.d.onLegendItemLeave(a.item);
            }
        };
        LegendBase.prototype.a7 = function (a) {
            if (this.legendItemMouseMove != null) {
                this.legendItemMouseMove(this, a);
            }
            if (a.d != null) {
                a.d.onLegendItemOver(a.item);
            }
        };
        LegendBase.prototype.provideContainer = function (a) {
            this.ak.ai(a);
        };
        Object.defineProperty(LegendBase.prototype, "aw", {
            get: function () {
                return this.ak.s;
            },
            set: function (a) {
                this.ak.s = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendBase.prototype, "ax", {
            get: function () {
                return this.ak.t;
            },
            set: function (a) {
                this.ak.t = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendBase.prototype, "av", {
            get: function () {
                return this.ak.r;
            },
            set: function (a) {
                this.ak.r = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendBase.prototype, "ay", {
            get: function () {
                return this.ak.u;
            },
            set: function (a) {
                this.ak.u = a;
            },
            enumerable: false,
            configurable: true
        });
        LegendBase.prototype.exportVisualData = function () {
            return this.ak.f();
        };
        LegendBase.prototype.exportSerializedVisualData = function () {
            var a = this.exportVisualData();
            return a.serialize();
        };
        LegendBase.prototype.get_isFinancial = function () {
            return false;
        };
        Object.defineProperty(LegendBase.prototype, "isFinancial", {
            get: function () {
                return this.get_isFinancial();
            },
            enumerable: false,
            configurable: true
        });
        LegendBase.$t = i2.markType(LegendBase, 'LegendBase', i2.ContentControl.$, [i2.INotifyPropertyChanged_$type, i2.IChartLegend_$type]);
        return LegendBase;
    }(i2.ContentControl));
    /**
     * @hidden
     */
    var LegendBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendBaseView, _super);
        function LegendBaseView(a) {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.b = null;
            _this.s = null;
            _this.t = null;
            _this.r = null;
            _this.u = null;
            _this.l = false;
            _this.i = false;
            _this.p = null;
            _this.q = null;
            _this.b = a;
            _this.c = new LegendBaseViewManager(_this);
            _this.c.p();
            return _this;
        }
        LegendBaseView.prototype.aj = function () {
            this.c.u();
        };
        LegendBaseView.prototype.ah = function () {
            this.c.s();
        };
        LegendBaseView.prototype.ak = function () {
        };
        LegendBaseView.prototype.get_j = function () {
            return false;
        };
        Object.defineProperty(LegendBaseView.prototype, "j", {
            get: function () {
                return this.get_j();
            },
            enumerable: false,
            configurable: true
        });
        LegendBaseView.prototype.d = function (a) {
            var b;
            var c;
            var d;
            var e = this.aa(a, b, c, d);
            b = e.p1;
            c = e.p2;
            d = e.p3;
            var f = new i2.MouseButtonEventArgs();
            var g = new LegendMouseButtonEventArgs(b, c, d, f, a);
            return g;
        };
        LegendBaseView.prototype.e = function (a) {
            var b;
            var c;
            var d;
            var e = this.aa(a, b, c, d);
            b = e.p1;
            c = e.p2;
            d = e.p3;
            var f = new i2.MouseEventArgs();
            var g = new LegendMouseEventArgs(b, c, d, f, a);
            return g;
        };
        LegendBaseView.prototype.aa = function (a, b, c, d) {
            b = this.b.ai;
            c = null;
            d = null;
            if (a != null) {
                var e = i2.typeCast(i2.ContentControl.$, a);
                if (e != null && e.content != null && i2.typeCast(i2.ILegendContext_$type, e.content) !== null) {
                    var f = i2.typeCast(i2.ILegendContext_$type, e.content);
                    c = i2.typeCast(i2.ILegendSeries_$type, f.series);
                    if (c != null) {
                        b = c.container;
                    }
                    d = f.item;
                }
            }
            return {
                p1: b,
                p2: c,
                p3: d
            };
        };
        LegendBaseView.prototype.z = function () {
        };
        LegendBaseView.prototype.m = function () {
            return true;
        };
        LegendBaseView.prototype.y = function (a) {
        };
        LegendBaseView.prototype.am = function (a) {
        };
        LegendBaseView.prototype.ai = function (a) {
            this.c.t(a);
        };
        LegendBaseView.prototype.an = function (a) {
            this.c.x(a);
        };
        LegendBaseView.prototype.x = function (a) {
            var b = this.b.at.indexOf(a);
            this.c.o(a, b);
        };
        LegendBaseView.prototype.af = function () {
            this.c.q();
        };
        LegendBaseView.prototype.ag = function () {
            this.c.r();
        };
        Object.defineProperty(LegendBaseView.prototype, "k", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                this.i = a;
                this.c.v(this.i);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendBaseView.prototype, "v", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                this.p = a;
                this.c.z(this.p);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LegendBaseView.prototype, "w", {
            get: function () {
                return this.q;
            },
            set: function (a) {
                this.q = a;
                this.c.aa(this.q);
            },
            enumerable: false,
            configurable: true
        });
        LegendBaseView.prototype.al = function () {
            this.c.p();
        };
        LegendBaseView.prototype.n = function (e_) {
            var ev_ = e_.originalEvent;
            return ev_.currentTarget;
        };
        LegendBaseView.prototype.o = function (e_) {
            return this.c.n(this.n(e_));
        };
        LegendBaseView.prototype.ad = function (a) {
            if (!this.l) {
                this.b.a3(this.e(this.o(a)));
            }
            this.l = true;
        };
        LegendBaseView.prototype.ac = function (a) {
            if (this.l) {
                this.b.a4(this.e(this.o(a)));
            }
            this.l = false;
        };
        LegendBaseView.prototype.ab = function (a) {
            this.b.a5(this.d(this.o(a)));
        };
        LegendBaseView.prototype.ae = function (a) {
            this.b.a6(this.d(this.o(a)));
        };
        LegendBaseView.prototype.h = function (a) {
            var b = a.querySelectorAll("span *");
            var c = i2.Rect.empty;
            for (var e = 0; e < b.length; e++) {
                var d = b[e];
                if (i2.stringIsNullOrEmpty(d.getText())) {
                    continue;
                }
                var f = new i2.Rect(0, d.getOffset().left, d.getOffset().top, d.width(), d.height());
                f.union(c);
                c = f;
            }
            return i2.RectData.b(c);
        };
        LegendBaseView.prototype.g = function (a) {
            var b = a.querySelectorAll("canvas");
            var c = b.length > 0 ? b[0] : null;
            return c != null ? new i2.RectData(c.getOffset().left, c.getOffset().top, c.width(), c.height()) : null;
        };
        LegendBaseView.prototype.a = function (a) {
            if (this.b == null || this.b.at == null || this.b.at.count <= a) {
                return null;
            }
            var b = this.b.at._inner[a];
            if (b == null) {
                return null;
            }
            var c = b.content;
            if (c == null) {
                return null;
            }
            var d = c.actualItemBrush != null ? c.actualItemBrush : c.itemBrush;
            return i2.AppearanceHelper.b(d);
        };
        LegendBaseView.prototype.f = function () {
            var a = new LegendVisualData();
            var b = this.c.l;
            var c = b.getChildCount();
            for (var d = 0; d < c; d++) {
                var e = new LegendItemVisualData();
                var f = b.getChildAt(d);
                e.label = f.getText();
                e.label = e.label != null ? e.label.trim() : null;
                e.bounds = new i2.RectData(f.getOffset().left, f.getOffset().top, f.width(), f.height());
                e.labelBounds = this.h(f);
                e.badgeBounds = this.g(f);
                a.items.add(e);
            }
            for (var g = 0; g < this.b.at.count; g++) {
                a.items._inner[g].appearance.fill = this.a(g);
            }
            return a;
        };
        LegendBaseView.$t = i2.markType(LegendBaseView, 'LegendBaseView');
        return LegendBaseView;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendItemInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendItemInfo, _super);
        function LegendItemInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.c = null;
            _this.a = null;
            _this.b = null;
            return _this;
        }
        LegendItemInfo.$t = i2.markType(LegendItemInfo, 'LegendItemInfo');
        return LegendItemInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Legend = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Legend, _super);
        function Legend() {
            var _this = _super.call(this) || this;
            _this.ab = Legend.$;
            var a = _this.at;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, function (a, b) {
                var e_1, _a, e_2, _b;
                if (b.oldItems != null) {
                    try {
                        for (var _c = tslib.__values(i2.fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var c = _d.value;
                            _this.bc.an(c);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
                if (b.newItems != null) {
                    try {
                        for (var _e = tslib.__values(i2.fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var d = _f.value;
                            _this.bc.x(d);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                }
            });
            return _this;
        }
        Legend.prototype.aj = function () {
            return new LegendView(this);
        };
        Legend.prototype.a8 = function (a) {
            _super.prototype.a8.call(this, a);
            this.bc = a;
        };
        Legend.prototype.bd = function (a) {
            return a.resolveLegendIndex();
        };
        Legend.prototype.bf = function (a) {
            return this.be(a);
        };
        Legend.prototype.addChildInOrder = function (a, b) {
            var e_3, _a;
            if (b.isStacked) {
                return;
            }
            if (!b.isUsableInLegend) {
                return;
            }
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.at)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    var e = void 0;
                    var f = void 0;
                    var g = void 0;
                    var h = this.ak.aa(d, e, f, g);
                    e = h.p1;
                    f = h.p2;
                    g = h.p3;
                    if (b.container != null && e != null && (this.bf(b.container) < this.bf(e) || (this.bf(b.container) == -1 && this.bf(e) == -1 && i2.Base.getHashCodeStatic(b.container) < i2.Base.getHashCodeStatic(e)))) {
                        break;
                    }
                    if (b.container != null && e != null && b.container == e && f != null) {
                        var i = this.bd(b);
                        var j = this.bd(f);
                        var k = this.bf(b);
                        var l = this.bf(f);
                        if (f.isVertical && !f.isStacked) {
                            if (l == -1 && k == -1) {
                                c = 0;
                                break;
                            }
                            if (k < l || l == -1) {
                                break;
                            }
                        }
                        if (i <= j) {
                            break;
                        }
                    }
                    c++;
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            this.at.insert(c, a);
            var m = new LegendItemInfo();
            m.c = a;
            m.a = b;
            var n = i2.typeCast(i2.ContentControl.$, a);
            if (n != null && n.content != null) {
                var o = i2.typeCast(i2.ILegendContext_$type, n.content);
                if (o != null) {
                    m.b = o;
                    m.d = o.itemLabel;
                }
            }
        };
        Object.defineProperty(Legend.prototype, "bb", {
            get: function () {
                return this.ak.k ? 0 : 1;
            },
            set: function (a) {
                this.ak.k = a == 0;
            },
            enumerable: false,
            configurable: true
        });
        Legend.prototype.be = function (a) {
            return -1;
        };
        Object.defineProperty(Legend.prototype, "bh", {
            get: function () {
                return this.ak.v;
            },
            set: function (a) {
                this.ak.v = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Legend.prototype, "bi", {
            get: function () {
                return this.ak.w;
            },
            set: function (a) {
                this.ak.w = a;
            },
            enumerable: false,
            configurable: true
        });
        Legend.$t = i2.markType(Legend, 'Legend', LegendBase.$);
        return Legend;
    }(LegendBase));
    /**
     * @hidden
     */
    var LegendView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendView, _super);
        function LegendView(a) {
            var _this = _super.call(this, a) || this;
            _this.ao = null;
            _this.ao = a;
            return _this;
        }
        LegendView.prototype.ak = function () {
            _super.prototype.ak.call(this);
        };
        LegendView.$t = i2.markType(LegendView, 'LegendView', LegendBaseView.$);
        return LegendView;
    }(LegendBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a legend that displays information about each series, most often used in financial charting.
    */
    var IgxFinancialLegendComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFinancialLegendComponent, _super);
        function IgxFinancialLegendComponent(renderer, elRef, ngZone) {
            var _this = _super.call(this) || this;
            _this.renderer = renderer;
            _this.elRef = elRef;
            _this.ngZone = ngZone;
            _this._zoneRunner = function (act) { return _this.ngZone.run(act); };
            _this.container = renderer.createElement("div");
            renderer.appendChild(elRef.nativeElement, _this.container);
            var root;
            root = _this.container;
            if (_this.container != null) {
                root = _this.container;
            }
            var ren = new i2.AngularRenderer(root, _this.renderer, window.document, _this.ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            _this.i.provideContainer(ren);
            return _this;
        }
        IgxFinancialLegendComponent.prototype.ngOnDestroy = function () {
            this._wrapper.destroy();
            this.i.provideContainer(null);
        };
        IgxFinancialLegendComponent.prototype.createImplementation = function () {
            return new Legend();
        };
        Object.defineProperty(IgxFinancialLegendComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFinancialLegendComponent.prototype, "isFinancial", {
            /**
         * Gets if the legend is a financial legend.
        */
            get: function () {
                return this.i.isFinancial;
            },
            enumerable: false,
            configurable: true
        });
        IgxFinancialLegendComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
        IgxFinancialLegendComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFinancialLegendComponent, selector: "igx-financial-legend", host: { classAttribute: "ig-financial-legend igx-financial-legend" }, providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxFinancialLegendComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, styles: [":host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFinancialLegendComponent;
    }(IgxLegendBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-financial-legend',
                        template: "",
                        providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxFinancialLegendComponent; }) }],
                        host: { 'class': 'ig-financial-legend igx-financial-legend' },
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        styles: [":host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: i0.NgZone }]; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LegendTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LegendTemplates, _super);
        function LegendTemplates() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LegendTemplates.af = function (a) {
            var b = a.am();
            switch (b) {
                case 3: return LegendTemplates.y;
                case 4: return LegendTemplates.aa;
                case 0: return LegendTemplates.z;
                case 8: return LegendTemplates.ae;
                case 9: return LegendTemplates.ac;
                case 5: return LegendTemplates.ah;
                case 1:
                case 2: return LegendTemplates.ad;
                case 6:
                case 7: return LegendTemplates.ab;
            }
            return LegendTemplates.ah;
        };
        LegendTemplates.a = function (a) {
            return new i2.RenderingContext(new i2.CanvasViewRenderer(), a.context);
        };
        LegendTemplates.v = function (a) {
            var b = i2.typeCast(Series.$, a.series);
            if (b == null || b.a7 == 0) {
                a.thickness = Defaults.v;
            }
            else {
                a.thickness = b.fl;
            }
            if (b == null) {
                a.actualItemBrush = a.itemBrush;
            }
            else {
                a.actualItemBrush = b.og;
            }
            if (b == null) {
                a.outline = a.actualItemBrush;
            }
            else {
                a.outline = b.oh;
            }
        };
        LegendTemplates.b = function (a, b) {
            return a;
        };
        LegendTemplates.c = function (a, b) {
            return a;
        };
        LegendTemplates.u = function (a, b, c, d, e, f, g, h) {
            var i = i2.DeviceUtils.g(Defaults.w - 2);
            var j = i2.DeviceUtils.g(Defaults.u - 2);
            e = e + 1;
            f = f + 1;
            var k = LegendTemplates.c(f, j);
            var l = LegendTemplates.c(h, j);
            var m = LegendTemplates.b(e, i);
            var n = LegendTemplates.b(g, i);
            var o = ((function () {
                var $ret = new i2.PathFigure();
                $ret.isClosed = true;
                $ret.isFilled = true;
                return $ret;
            })());
            o._startPoint = { $type: i2.Point_$type, x: m, y: l };
            o._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: m, y: l }));
            o._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: n, y: l }));
            o._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: n, y: k }));
            o._segments.add(new i2.LineSegment(0, { $type: i2.Point_$type, x: m, y: k }));
            var p = new i2.PathGeometry();
            p.c.add(o);
            var q = new i2.Path();
            q.ak = p;
            q.ac = b;
            q._stroke = c;
            q._fill = d;
            var r = LegendTemplates.a(a);
            r.s(q);
        };
        LegendTemplates.s = function (a) {
            var b = a.data;
            var c = b.series;
            LegendTemplates.v(b);
            var d = i2.DeviceUtils.g(Defaults.w);
            var e = i2.DeviceUtils.g(Defaults.u);
            var f = new i2.Line();
            f.ak = 0;
            f.am = e / 2;
            f.al = d;
            f.an = e / 2;
            f._stroke = b.actualItemBrush;
            if (c.a7 == 0) {
                f.ac = Defaults.v;
            }
            else {
                f.ac = c.fl;
            }
            var g = LegendTemplates.a(a);
            g.r(f);
        };
        LegendTemplates.r = function (a, b, c) {
            var d = a.data;
            LegendTemplates.v(d);
            var e = i2.DeviceUtils.g(Defaults.w);
            var f = i2.DeviceUtils.g(Defaults.u);
            var g = e / 2;
            var h = f / 2;
            var i = new i2.EllipseGeometry();
            i.e = { $type: i2.Point_$type, x: LegendTemplates.b(g, e), y: LegendTemplates.c(h, f) };
            i.c = g - 1;
            i.d = h - 1;
            var j = new i2.Path();
            j.ak = i;
            j.ac = d.thickness;
            j._stroke = d.outline;
            j._fill = d.actualItemBrush;
            var k = LegendTemplates.a(a);
            k.s(j);
        };
        LegendTemplates.t = function (a, b) {
            if (b === void 0) {
                b = 0;
            }
            var c = a.data;
            var d = i2.DeviceUtils.g(Defaults.w - b);
            var e = i2.DeviceUtils.g(Defaults.u - b);
            var f = new i2.DataTemplateMeasureInfo();
            f.passInfo = a.passInfo;
            f.width = d;
            f.height = e;
            f.data = a.data;
            f.context = a.context;
            f.renderContext = a.renderContext;
            var g = c.actualItemBrush;
            var h = c.itemBrush;
            var i = c.series;
            var j = i.mv();
            c.actualItemBrush = i.om();
            c.outline = i.on();
            if (i.a7 == 1) {
                c.thickness = i.ft();
            }
            else {
                c.thickness = Defaults.ab;
            }
            if (j != null && j.measure != null && j.render != null) {
                var k = new i2.DataTemplateRenderInfo();
                k.passInfo = a.passInfo;
                k.availableWidth = f.width;
                k.availableHeight = f.height;
                k.xPosition = (a.availableWidth / 2);
                k.yPosition = (a.availableHeight / 2);
                k.data = a.data;
                k.context = a.context;
                k.renderContext = a.renderContext;
                j.render(k);
            }
            c.itemBrush = h;
            c.actualItemBrush = g;
        };
        LegendTemplates.j = function (a) {
            var b = a.data;
            LegendTemplates.v(b);
            LegendTemplates.r(a, Defaults.w, Defaults.u);
        };
        LegendTemplates.n = function (a) {
            var b = a.data;
            var c = b.series;
            LegendTemplates.s(a);
            if (c.a7 == 1) {
                LegendTemplates.t(a, Defaults.t);
            }
        };
        LegendTemplates.o = function (a) {
            LegendTemplates.t(a, 2);
        };
        LegendTemplates.q = function (a) {
            var b = a.data;
            LegendTemplates.v(b);
            LegendTemplates.u(a, b.thickness, b.outline, b.actualItemBrush, 0, 0, Defaults.w, Defaults.u);
        };
        LegendTemplates.p = function (a) {
            var b = a.data;
            var c = b.series;
            LegendTemplates.v(b);
            if (c.a7 == 0) {
                var d = Defaults.v;
                var e = b.actualItemBrush;
                var f = c.oh;
                var g = Defaults.w;
                var h = Defaults.u;
                LegendTemplates.u(a, d, f, e, 0, 0, g, h);
            }
            else {
                var i = Defaults.v;
                var j = b.actualItemBrush;
                var k = c.op();
                var l = Defaults.w / 2;
                var m = Defaults.w;
                var n = Defaults.u;
                LegendTemplates.u(a, i, j, j, 0, 0, l, n);
                LegendTemplates.u(a, i, k, k, l, 0, m, n);
            }
        };
        LegendTemplates.i = function (a) {
            var b = a.data;
            LegendTemplates.v(b);
            var c = 0;
            var d = Defaults.w;
            var e = (Defaults.u * 0.25);
            var f = (Defaults.u * 0.75);
            LegendTemplates.u(a, b.thickness, b.outline, b.actualItemBrush, c, e, d, f);
        };
        LegendTemplates.l = function (a) {
            var b = a.data;
            LegendTemplates.v(b);
            var c = (Defaults.w * 0.25);
            var d = (Defaults.w * 0.75);
            var e = Defaults.u;
            var f = 0;
            LegendTemplates.u(a, b.thickness, b.outline, b.actualItemBrush, c, f, d, e);
        };
        LegendTemplates.m = function (a) {
            var b = a.data;
            var c = i2.BrushUtil.g(0, 0, 0, 0);
            var d = i2.BrushUtil.g(0, 0, 0, 0);
            LegendTemplates.u(a, Defaults.v, c, d, 0, 0, Defaults.w, Defaults.u);
        };
        LegendTemplates.k = function (a) {
        };
        LegendTemplates.g = function (a) {
            var b = a.data;
            var c = b.series;
            var d = c.legendItemBadgeTemplate;
            if (d == null) {
                d = LegendTemplates.af(c);
            }
            var e = c.hp;
            if (e == null) {
                e = "Series Title";
            }
            i2.LegendItemHelper.d(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo, c.a0 != null && c.a0.isFinancial, c.fs, c.gg);
        };
        LegendTemplates.resolveLegendItemTemplate = function (a) {
            switch (a) {
                case 0: return LegendTemplates.w;
                case 1: return LegendTemplates.x;
            }
            return LegendTemplates.w;
        };
        LegendTemplates.e = function (a) {
            var b = a.data;
            var c = b.series;
            var d = c.legendItemBadgeTemplate;
            if (d == null) {
                d = LegendTemplates.af(c);
            }
            var e = b.itemLabel;
            if (e == null) {
                e = "Series Item";
            }
            i2.LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
        };
        LegendTemplates.f = function (a) {
        };
        LegendTemplates.d = function (a) {
        };
        LegendTemplates.h = function (a) {
        };
        LegendTemplates.$t = i2.markType(LegendTemplates, 'LegendTemplates');
        LegendTemplates.z = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.j;
            return $ret;
        })());
        LegendTemplates.ae = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.o;
            return $ret;
        })());
        LegendTemplates.ad = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.n;
            return $ret;
        })());
        LegendTemplates.ah = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.q;
            return $ret;
        })());
        LegendTemplates.ab = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.p;
            return $ret;
        })());
        LegendTemplates.y = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.i;
            return $ret;
        })());
        LegendTemplates.aa = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.l;
            return $ret;
        })());
        LegendTemplates.ac = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.m;
            return $ret;
        })());
        LegendTemplates.w = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.f;
            $ret.render = LegendTemplates.g;
            return $ret;
        })());
        LegendTemplates.x = ((function () {
            var $ret = new i2.DataTemplate();
            $ret.measure = LegendTemplates.d;
            $ret.render = LegendTemplates.e;
            return $ret;
        })());
        return LegendTemplates;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialLegendViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialLegendViewManager, _super);
        function FinancialLegendViewManager(a) {
            return _super.call(this, a) || this;
        }
        FinancialLegendViewManager.prototype.i = function () {
            if (this.g == null) {
                return null;
            }
            var a = this.g.createElement("div");
            return a;
        };
        FinancialLegendViewManager.prototype.h = function () {
            if (this.g == null) {
                return null;
            }
            var a = this.g.createElement("span");
            a.setStyleProperty("display", "inline-block");
            a.setStyleProperty("padding", "5px 2px 5px 2px");
            a.setStyleProperty("margin", "2px");
            return a;
        };
        FinancialLegendViewManager.$t = i2.markType(FinancialLegendViewManager, 'FinancialLegendViewManager', LegendBaseViewManager.$);
        return FinancialLegendViewManager;
    }(LegendBaseViewManager));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialLegend = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialLegend, _super);
        function FinancialLegend() {
            var _this = _super.call(this) || this;
            _this.ab = FinancialLegend.$;
            var a = _this.at;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, function (a, b) {
                var e_1, _a, e_2, _b;
                if (b.oldItems != null) {
                    try {
                        for (var _c = tslib.__values(i2.fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var c = _d.value;
                            _this.bb.an(c);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
                if (b.newItems != null) {
                    try {
                        for (var _e = tslib.__values(i2.fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var d = _f.value;
                            _this.bb.x(d);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                }
            });
            return _this;
        }
        FinancialLegend.prototype.aj = function () {
            return new FinancialLegendView(this);
        };
        Object.defineProperty(FinancialLegend.prototype, "bb", {
            get: function () {
                return this.ak;
            },
            enumerable: false,
            configurable: true
        });
        FinancialLegend.prototype.addChildInOrder = function (a, b) {
            this.at.add(a);
        };
        FinancialLegend.prototype.get_isFinancial = function () {
            return true;
        };
        FinancialLegend.$t = i2.markType(FinancialLegend, 'FinancialLegend', LegendBase.$);
        return FinancialLegend;
    }(LegendBase));
    /**
     * @hidden
     */
    var FinancialLegendView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialLegendView, _super);
        function FinancialLegendView(a) {
            var _this = _super.call(this, a) || this;
            _this.c = new FinancialLegendViewManager(_this);
            return _this;
        }
        FinancialLegendView.$t = i2.markType(FinancialLegendView, 'FinancialLegendView', LegendBaseView.$);
        return FinancialLegendView;
    }(LegendBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialLegendModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialLegendModule() {
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
            i2.TypeRegistrar.register('FinancialLegend', FinancialLegend.$type);
        }
        IgxFinancialLegendModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialLegendModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendModule, declarations: [IgxFinancialLegendComponent], imports: [i1.CommonModule], exports: [IgxFinancialLegendComponent] });
        IgxFinancialLegendModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendModule, imports: [[i1.CommonModule,
                ]] });
        return IgxFinancialLegendModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFinancialLegendComponent],
                        exports: [IgxFinancialLegendComponent
                        ],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialLegendDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialLegendDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxFinancialLegendComponent', IgxFinancialLegendComponent);
            i2.TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
            i2.TypeRegistrar.registerCons('FinancialLegend', FinancialLegend);
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
            i2.TypeRegistrar.register('FinancialLegend', FinancialLegend.$type);
        }
        IgxFinancialLegendDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialLegendDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendDynamicModule, imports: [i1.CommonModule, IgxFinancialLegendModule], exports: [IgxFinancialLegendModule] });
        IgxFinancialLegendDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendDynamicModule, imports: [[i1.CommonModule, IgxFinancialLegendModule
                ], IgxFinancialLegendModule] });
        return IgxFinancialLegendDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialLegendDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFinancialLegendModule
                        ],
                        imports: [i1.CommonModule, IgxFinancialLegendModule
                        ],
                        entryComponents: [IgxFinancialLegendComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialChartModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialChartModule() {
        }
        IgxFinancialChartModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialChartModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartModule, imports: [i1.CommonModule, IgxFinancialChartCoreModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxCategoryXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxPercentChangeYAxisDynamicModule,
                IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartCategoryTrendLineModule,
                IgxIndicatorsDynamicModule,
                IgxOverlaysDynamicModule,
                IgxZoomSliderDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorModule,
                IgxDataChartInteractivityModule,
                IgxDataChartAnnotationModule,
                IgxFinancialLegendModule], exports: [IgxFinancialChartCoreModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxCategoryXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxPercentChangeYAxisDynamicModule,
                IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartCategoryTrendLineModule,
                IgxIndicatorsDynamicModule,
                IgxOverlaysDynamicModule,
                IgxZoomSliderDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorModule,
                IgxDataChartInteractivityModule,
                IgxDataChartAnnotationModule,
                IgxFinancialLegendModule] });
        IgxFinancialChartModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartModule, imports: [[i1.CommonModule, IgxFinancialChartCoreModule,
                    IgxLineSeriesDynamicModule,
                    IgxAreaSeriesDynamicModule,
                    IgxColumnSeriesDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxTimeXAxisDynamicModule,
                    IgxTimeAxisBreakDynamicModule,
                    IgxTimeAxisIntervalDynamicModule,
                    IgxTimeAxisLabelFormatDynamicModule,
                    IgxCategoryXAxisDynamicModule,
                    IgxOrdinalTimeXAxisDynamicModule,
                    IgxPercentChangeYAxisDynamicModule,
                    IgxFinancialPriceSeriesDynamicModule,
                    IgxDataChartCategoryTrendLineModule,
                    IgxIndicatorsDynamicModule,
                    IgxOverlaysDynamicModule,
                    IgxZoomSliderDynamicModule,
                    IgxCrosshairLayerDynamicModule,
                    IgxCalloutLayerDynamicModule,
                    IgxItemToolTipLayerDynamicModule,
                    IgxCategoryToolTipLayerDynamicModule,
                    IgxCategoryHighlightLayerDynamicModule,
                    IgxCategoryItemHighlightLayerDynamicModule,
                    IgxFinalValueLayerDynamicModule,
                    IgxNumberAbbreviatorModule,
                    IgxDataChartInteractivityModule,
                    IgxDataChartAnnotationModule,
                    IgxFinancialLegendModule
                ], IgxFinancialChartCoreModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxCategoryXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxPercentChangeYAxisDynamicModule,
                IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartCategoryTrendLineModule,
                IgxIndicatorsDynamicModule,
                IgxOverlaysDynamicModule,
                IgxZoomSliderDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorModule,
                IgxDataChartInteractivityModule,
                IgxDataChartAnnotationModule,
                IgxFinancialLegendModule] });
        return IgxFinancialChartModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFinancialChartCoreModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxTimeXAxisDynamicModule,
                            IgxTimeAxisBreakDynamicModule,
                            IgxTimeAxisIntervalDynamicModule,
                            IgxTimeAxisLabelFormatDynamicModule,
                            IgxCategoryXAxisDynamicModule,
                            IgxOrdinalTimeXAxisDynamicModule,
                            IgxPercentChangeYAxisDynamicModule,
                            IgxFinancialPriceSeriesDynamicModule,
                            IgxDataChartCategoryTrendLineModule,
                            IgxIndicatorsDynamicModule,
                            IgxOverlaysDynamicModule,
                            IgxZoomSliderDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorModule,
                            IgxDataChartInteractivityModule,
                            IgxDataChartAnnotationModule,
                            IgxFinancialLegendModule
                        ],
                        imports: [i1.CommonModule, IgxFinancialChartCoreModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxTimeXAxisDynamicModule,
                            IgxTimeAxisBreakDynamicModule,
                            IgxTimeAxisIntervalDynamicModule,
                            IgxTimeAxisLabelFormatDynamicModule,
                            IgxCategoryXAxisDynamicModule,
                            IgxOrdinalTimeXAxisDynamicModule,
                            IgxPercentChangeYAxisDynamicModule,
                            IgxFinancialPriceSeriesDynamicModule,
                            IgxDataChartCategoryTrendLineModule,
                            IgxIndicatorsDynamicModule,
                            IgxOverlaysDynamicModule,
                            IgxZoomSliderDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorModule,
                            IgxDataChartInteractivityModule,
                            IgxDataChartAnnotationModule,
                            IgxFinancialLegendModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFinancialChartDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFinancialChartDynamicModule() {
        }
        IgxFinancialChartDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFinancialChartDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartDynamicModule, imports: [i1.CommonModule, IgxFinancialChartCoreDynamicModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxCategoryXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxPercentChangeYAxisDynamicModule,
                IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartCategoryTrendLineDynamicModule,
                IgxIndicatorsDynamicModule,
                IgxOverlaysDynamicModule,
                IgxZoomSliderDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxDataChartAnnotationDynamicModule,
                IgxFinancialLegendDynamicModule,
                IgxFinancialChartModule], exports: [IgxFinancialChartCoreDynamicModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxCategoryXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxPercentChangeYAxisDynamicModule,
                IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartCategoryTrendLineDynamicModule,
                IgxIndicatorsDynamicModule,
                IgxOverlaysDynamicModule,
                IgxZoomSliderDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxDataChartAnnotationDynamicModule,
                IgxFinancialLegendDynamicModule,
                IgxFinancialChartModule] });
        IgxFinancialChartDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartDynamicModule, imports: [[i1.CommonModule, IgxFinancialChartCoreDynamicModule,
                    IgxLineSeriesDynamicModule,
                    IgxAreaSeriesDynamicModule,
                    IgxColumnSeriesDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxTimeXAxisDynamicModule,
                    IgxTimeAxisBreakDynamicModule,
                    IgxTimeAxisIntervalDynamicModule,
                    IgxTimeAxisLabelFormatDynamicModule,
                    IgxCategoryXAxisDynamicModule,
                    IgxOrdinalTimeXAxisDynamicModule,
                    IgxPercentChangeYAxisDynamicModule,
                    IgxFinancialPriceSeriesDynamicModule,
                    IgxDataChartCategoryTrendLineDynamicModule,
                    IgxIndicatorsDynamicModule,
                    IgxOverlaysDynamicModule,
                    IgxZoomSliderDynamicModule,
                    IgxCrosshairLayerDynamicModule,
                    IgxCalloutLayerDynamicModule,
                    IgxItemToolTipLayerDynamicModule,
                    IgxCategoryToolTipLayerDynamicModule,
                    IgxCategoryHighlightLayerDynamicModule,
                    IgxCategoryItemHighlightLayerDynamicModule,
                    IgxFinalValueLayerDynamicModule,
                    IgxNumberAbbreviatorDynamicModule,
                    IgxDataChartInteractivityDynamicModule,
                    IgxDataChartAnnotationDynamicModule,
                    IgxFinancialLegendDynamicModule,
                    IgxFinancialChartModule
                ], IgxFinancialChartCoreDynamicModule,
                IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxCategoryXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxPercentChangeYAxisDynamicModule,
                IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartCategoryTrendLineDynamicModule,
                IgxIndicatorsDynamicModule,
                IgxOverlaysDynamicModule,
                IgxZoomSliderDynamicModule,
                IgxCrosshairLayerDynamicModule,
                IgxCalloutLayerDynamicModule,
                IgxItemToolTipLayerDynamicModule,
                IgxCategoryToolTipLayerDynamicModule,
                IgxCategoryHighlightLayerDynamicModule,
                IgxCategoryItemHighlightLayerDynamicModule,
                IgxFinalValueLayerDynamicModule,
                IgxNumberAbbreviatorDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxDataChartAnnotationDynamicModule,
                IgxFinancialLegendDynamicModule,
                IgxFinancialChartModule] });
        return IgxFinancialChartDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFinancialChartDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFinancialChartCoreDynamicModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxTimeXAxisDynamicModule,
                            IgxTimeAxisBreakDynamicModule,
                            IgxTimeAxisIntervalDynamicModule,
                            IgxTimeAxisLabelFormatDynamicModule,
                            IgxCategoryXAxisDynamicModule,
                            IgxOrdinalTimeXAxisDynamicModule,
                            IgxPercentChangeYAxisDynamicModule,
                            IgxFinancialPriceSeriesDynamicModule,
                            IgxDataChartCategoryTrendLineDynamicModule,
                            IgxIndicatorsDynamicModule,
                            IgxOverlaysDynamicModule,
                            IgxZoomSliderDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxDataChartAnnotationDynamicModule,
                            IgxFinancialLegendDynamicModule,
                            IgxFinancialChartModule
                        ],
                        imports: [i1.CommonModule, IgxFinancialChartCoreDynamicModule,
                            IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxTimeXAxisDynamicModule,
                            IgxTimeAxisBreakDynamicModule,
                            IgxTimeAxisIntervalDynamicModule,
                            IgxTimeAxisLabelFormatDynamicModule,
                            IgxCategoryXAxisDynamicModule,
                            IgxOrdinalTimeXAxisDynamicModule,
                            IgxPercentChangeYAxisDynamicModule,
                            IgxFinancialPriceSeriesDynamicModule,
                            IgxDataChartCategoryTrendLineDynamicModule,
                            IgxIndicatorsDynamicModule,
                            IgxOverlaysDynamicModule,
                            IgxZoomSliderDynamicModule,
                            IgxCrosshairLayerDynamicModule,
                            IgxCalloutLayerDynamicModule,
                            IgxItemToolTipLayerDynamicModule,
                            IgxCategoryToolTipLayerDynamicModule,
                            IgxCategoryHighlightLayerDynamicModule,
                            IgxCategoryItemHighlightLayerDynamicModule,
                            IgxFinalValueLayerDynamicModule,
                            IgxNumberAbbreviatorDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxDataChartAnnotationDynamicModule,
                            IgxFinancialLegendDynamicModule,
                            IgxFinancialChartModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ITimeXAxis_$type = new i2.Type(null, 'ITimeXAxis');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TemplatePicker = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TemplatePicker, _super);
        function TemplatePicker() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TemplatePicker.a = function (a, b) {
            if (a != null) {
                return a;
            }
            return a;
        };
        TemplatePicker.$t = i2.markType(TemplatePicker, 'TemplatePicker');
        return TemplatePicker;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartIndicatorMenuItem = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartIndicatorMenuItem, _super);
        function FinancialChartIndicatorMenuItem() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.c = 0;
            _this.f = null;
            _this.g = null;
            _this.a = false;
            _this.propertyChanged = null;
            return _this;
        }
        Object.defineProperty(FinancialChartIndicatorMenuItem.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.b;
                if (a != b) {
                    this.a = a;
                    if (this.propertyChanged != null) {
                        this.propertyChanged(this, new i2.PropertyChangedEventArgs("IsChecked"));
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuItem.$t = i2.markType(FinancialChartIndicatorMenuItem, 'FinancialChartIndicatorMenuItem', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return FinancialChartIndicatorMenuItem;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartIndicatorMenuItems = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartIndicatorMenuItems, _super);
        function FinancialChartIndicatorMenuItems(a) {
            var _this = _super.call(this, FinancialChartIndicatorMenuItem.$, 0) || this;
            _this.ak = null;
            _this.ac = null;
            _this.ad = null;
            _this.ae = null;
            _this.af = null;
            _this.ak = a;
            _this.am(FinancialOverlayType_$type, _this.al("FinancialChart_IndicatorMenu_OverlaysCategoryHeader", "Overlays"));
            _this.am(i2.TrendLineType_$type, _this.al("FinancialChart_IndicatorMenu_TrendlinesCategoryHeader", "Trendlines"));
            _this.am(FinancialChartVolumeType_$type, _this.al("FinancialChart_IndicatorMenu_VolumeCategoryHeader", "Volume"));
            _this.am(FinancialIndicatorType_$type, _this.al("FinancialChart_IndicatorMenu_IndicatorsCategoryHeader", "Standalone Indicators"));
            return _this;
        }
        FinancialChartIndicatorMenuItems.prototype.al = function (a, b) {
            var c = this.ak.b1(a);
            return i2.stringIsNullOrEmpty(c) ? b : c;
        };
        FinancialChartIndicatorMenuItems.prototype.am = function ($t, a) {
            this.add(((function () {
                var $ret = new FinancialChartIndicatorMenuItem();
                $ret.d = a;
                $ret.f = a;
                return $ret;
            })()));
            this.an($t);
        };
        FinancialChartIndicatorMenuItems.prototype.an = function ($t) {
            var e_1, _a;
            var a = new i2.List$1(i2.Base.$, 0);
            var b = new i2.Dictionary$2(i2.Base.$, i2.String_$type, 0);
            var c = new i2.Dictionary$2(i2.Base.$, i2.Type.$, 0);
            var d = function (e) {
                for (var f = 0; f < e.a; f++) {
                    var g = i2.typeGetValue(e.b(f));
                    a.add1(g);
                    var h = e.c(g);
                    b.addItem(g, h);
                    c.addItem(g, $t);
                }
            };
            if ($t == FinancialOverlayType_$type) {
                d(this.ah);
            }
            else if ($t == i2.TrendLineType_$type) {
                d(this.ai);
            }
            else if ($t == FinancialIndicatorType_$type) {
                d(this.ag);
            }
            else if ($t == FinancialChartVolumeType_$type) {
                d(this.aj);
            }
            else {
                var e = i2.EnumUtil.getNames($t);
                var f = i2.EnumUtil.getValues($t);
                for (var g = 0; g < f.length; g++) {
                    var h = void 0;
                    var i = void 0;
                    h = f[g];
                    i = e[g];
                    i = i.charAt(0).toUpperCase() + i.substr(1);
                    if (i == "None") {
                        continue;
                    }
                    a.add1(h);
                    b.addItem(h, i);
                    c.addItem(h, $t);
                }
            }
            var _loop_1 = function (j) {
                this_1.add(((function () {
                    var $ret = new FinancialChartIndicatorMenuItem();
                    $ret.d = j;
                    $ret.f = b.containsKey(j) ? b.item(j) : j.toString();
                    $ret.c = 1;
                    $ret.g = c.containsKey(j) ? c.item(j) : null;
                    return $ret;
                })()));
            };
            var this_1 = this;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var j = _c.value;
                    _loop_1(j);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "ag", {
            get: function () {
                if (this.ac == null) {
                    this.ao();
                }
                return this.ac;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuItems.prototype.ao = function () {
            var _this = this;
            this.ac = ((function () {
                var $ret = new OrderedDictionary$2(FinancialIndicatorType_$type, i2.String_$type);
                $ret.addItem(0, _this.al("FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator", "Absolute Volume Oscillator"));
                $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution", "Accumulation Distribution"));
                $ret.addItem(2, _this.al("FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex", "Average Directional Index"));
                $ret.addItem(3, _this.al("FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange", "Average True Range"));
                $ret.addItem(4, _this.al("FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth", "Bollinger Band Width"));
                $ret.addItem(5, _this.al("FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator", "Chaikin Oscillator"));
                $ret.addItem(6, _this.al("FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility", "Chaikin Volatility"));
                $ret.addItem(7, _this.al("FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex", "Commodity Channel Index"));
                $ret.addItem(8, _this.al("FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator", "Detrended Price Oscillator"));
                $ret.addItem(9, _this.al("FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement", "Ease Of Movement"));
                $ret.addItem(10, _this.al("FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator", "Fast Stochastic Oscillator"));
                $ret.addItem(11, _this.al("FinancialChart_IndicatorsMenu_Indicator_ForceIndex", "Force Index"));
                $ret.addItem(12, _this.al("FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator", "Full Stochastic Oscillator"));
                $ret.addItem(13, _this.al("FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex", "Market Facilitation Index"));
                $ret.addItem(14, _this.al("FinancialChart_IndicatorsMenu_Indicator_MassIndex", "Mass Index"));
                $ret.addItem(15, _this.al("FinancialChart_IndicatorsMenu_Indicator_MedianPrice", "Median Price"));
                $ret.addItem(16, _this.al("FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex", "Money Flow Index"));
                $ret.addItem(17, _this.al("FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence", "MACD"));
                $ret.addItem(18, _this.al("FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex", "Negative Volume Index"));
                $ret.addItem(19, _this.al("FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume", "On Balance Volume"));
                $ret.addItem(20, _this.al("FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator", "Percentage Price Oscillator"));
                $ret.addItem(21, _this.al("FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator", "Percentage Volume Oscillator"));
                $ret.addItem(22, _this.al("FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex", "Positive Volume Index"));
                $ret.addItem(23, _this.al("FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend", "Price Volume Trend"));
                $ret.addItem(24, _this.al("FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum", "ROC"));
                $ret.addItem(25, _this.al("FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex", "RSI"));
                $ret.addItem(26, _this.al("FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator", "Slow Stochastic Oscillator"));
                $ret.addItem(27, _this.al("FinancialChart_IndicatorsMenu_Indicator_StandardDeviation", "Standard Deviation"));
                $ret.addItem(28, _this.al("FinancialChart_IndicatorsMenu_Indicator_StochRSI", "Stoch RSI"));
                $ret.addItem(29, _this.al("FinancialChart_IndicatorsMenu_Indicator_TRIX", "TRIX"));
                $ret.addItem(30, _this.al("FinancialChart_IndicatorsMenu_Indicator_TypicalPrice", "Typical Price"));
                $ret.addItem(31, _this.al("FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator", "Ultimate Oscillator"));
                $ret.addItem(32, _this.al("FinancialChart_IndicatorsMenu_Indicator_WeightedClose", "Weighted Close"));
                $ret.addItem(33, _this.al("FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR", "Williams %R"));
                return $ret;
            })());
        };
        Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "ah", {
            get: function () {
                if (this.ad == null) {
                    this.ap();
                }
                return this.ad;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuItems.prototype.ap = function () {
            var _this = this;
            this.ad = ((function () {
                var $ret = new OrderedDictionary$2(FinancialOverlayType_$type, i2.String_$type);
                $ret.addItem(0, _this.al("FinancialChart_IndicatorsMenu_Overlay_BollingerBands", "Bollinger Bands"));
                $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_Overlay_PriceChannel", "Price Channel"));
                return $ret;
            })());
        };
        Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "ai", {
            get: function () {
                if (this.ae == null) {
                    this.aq();
                }
                return this.ae;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuItems.prototype.aq = function () {
            var _this = this;
            this.ae = ((function () {
                var $ret = new OrderedDictionary$2(i2.TrendLineType_$type, i2.String_$type);
                $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_TrendLine_LinearFit", "Linear Fit"));
                $ret.addItem(2, _this.al("FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit", "Quadratic Fit"));
                $ret.addItem(3, _this.al("FinancialChart_IndicatorsMenu_TrendLine_CubicFit", "Cubic Fit"));
                $ret.addItem(4, _this.al("FinancialChart_IndicatorsMenu_TrendLine_QuarticFit", "Quartic Fit"));
                $ret.addItem(5, _this.al("FinancialChart_IndicatorsMenu_TrendLine_QuinticFit", "Quintic Fit"));
                $ret.addItem(6, _this.al("FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit", "Logarithmic Fit"));
                $ret.addItem(7, _this.al("FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit", "Exponential Fit"));
                $ret.addItem(8, _this.al("FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit", "Power LawFit"));
                $ret.addItem(9, _this.al("FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage", "Simple Average"));
                $ret.addItem(10, _this.al("FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage", "Exponential Average"));
                $ret.addItem(11, _this.al("FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage", "Modified Average"));
                $ret.addItem(12, _this.al("FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage", "Cumulative Average"));
                $ret.addItem(13, _this.al("FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage", "Weighted Average"));
                return $ret;
            })());
        };
        Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "aj", {
            get: function () {
                if (this.af == null) {
                    this.ar();
                }
                return this.af;
            },
            enumerable: false,
            configurable: true
        });
        FinancialChartIndicatorMenuItems.prototype.ar = function () {
            var _this = this;
            this.af = ((function () {
                var $ret = new OrderedDictionary$2(FinancialChartVolumeType_$type, i2.String_$type);
                $ret.addItem(3, _this.al("FinancialChart_IndicatorsMenu_Volume_Area", "Area"));
                $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_Volume_Column", "Column"));
                $ret.addItem(2, _this.al("FinancialChart_IndicatorsMenu_Volume_Line", "Line"));
                return $ret;
            })());
        };
        FinancialChartIndicatorMenuItems.$t = i2.markType(FinancialChartIndicatorMenuItems, 'FinancialChartIndicatorMenuItems', i2.List$1.$.specialize(FinancialChartIndicatorMenuItem.$));
        return FinancialChartIndicatorMenuItems;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FinancialChartEnumCollectionPickerVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FinancialChartEnumCollectionPickerVisualData, _super);
        function FinancialChartEnumCollectionPickerVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.k = 0;
            _this.l = 0;
            _this.m = 0;
            _this.j = 0;
            _this.f = 0;
            _this.g = 0;
            _this.h = 0;
            _this.e = 0;
            _this.n = 0;
            _this.i = 0;
            _this.d = false;
            _this.c = false;
            return _this;
        }
        FinancialChartEnumCollectionPickerVisualData.prototype.o = function () {
            return FinancialChartVisualData.y(["items", "selectedItems", "pickerLeft", "pickerTop", "pickerWidth", "pickerHeight", "buttonLeft", "buttonTop", "buttonWidth", "buttonHeight", "width", "height", "isVisible", "isPickerVisible"], [this.a, this.b, this.k, this.l, this.m, this.j, this.f, this.g, this.h, this.e, this.n, this.i, this.d, this.c]);
        };
        FinancialChartEnumCollectionPickerVisualData.$t = i2.markType(FinancialChartEnumCollectionPickerVisualData, 'FinancialChartEnumCollectionPickerVisualData');
        return FinancialChartEnumCollectionPickerVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IOuterLabelWidthDecider_$type = new i2.Type(null, 'IOuterLabelWidthDecider');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IFunnelLabelSizeDecider_$type = new i2.Type(null, 'IFunnelLabelSizeDecider');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ServiceProvider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ServiceProvider, _super);
        function ServiceProvider() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = i2.DictionaryUtil.dictionaryCreate();
            return _this;
        }
        ServiceProvider.prototype.c = function (a, b) {
            this.a.set(a, b);
        };
        ServiceProvider.prototype.b = function (a) {
            return this.a.get(a);
        };
        ServiceProvider.$t = i2.markType(ServiceProvider, 'ServiceProvider');
        return ServiceProvider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Message = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Message, _super);
        function Message() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Message.prototype.toString = function () {
            return i2.getInstanceType(this).toString();
        };
        Message.$t = i2.markType(Message, 'Message');
        return Message;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MessageChannel = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MessageChannel, _super);
        function MessageChannel() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = new i2.Queue$1(Message.$);
            _this.messageSent = null;
            _this.a = null;
            return _this;
        }
        MessageChannel.prototype.i = function (a) {
            if (this.messageSent != null) {
                this.messageSent(a);
            }
            else {
                this.c.g(a);
            }
        };
        MessageChannel.prototype.e = function (a) {
            this.messageSent = i2.delegateCombine(this.messageSent, a);
            while (this.c.count > 0) {
                var b = this.c.b();
                this.messageSent(b);
            }
        };
        MessageChannel.prototype.h = function (a) {
            this.messageSent = i2.delegateRemove(this.messageSent, a);
        };
        MessageChannel.prototype.f = function (a) {
            this.a = a;
            this.e(i2.runOn(this, this.j));
        };
        MessageChannel.prototype.g = function () {
            if (this.a == null) {
                return;
            }
            this.h(i2.runOn(this, this.j));
            this.a = null;
        };
        MessageChannel.prototype.j = function (a) {
            if (this.a != null) {
                this.a.i(a);
            }
        };
        MessageChannel.prototype.toString = function () {
            return "MessageQueue";
        };
        MessageChannel.$t = i2.markType(MessageChannel, 'MessageChannel');
        return MessageChannel;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var InteractionMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(InteractionMessage, _super);
        function InteractionMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InteractionMessage.$t = i2.markType(InteractionMessage, 'InteractionMessage', Message.$);
        return InteractionMessage;
    }(Message));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseLeaveMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MouseLeaveMessage, _super);
        function MouseLeaveMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(MouseLeaveMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        MouseLeaveMessage.prototype.toString = function () {
            return "MouseLeaveMessage[" + this.c.toString() + "]";
        };
        MouseLeaveMessage.$t = i2.markType(MouseLeaveMessage, 'MouseLeaveMessage', InteractionMessage.$);
        return MouseLeaveMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseMoveMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MouseMoveMessage, _super);
        function MouseMoveMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(MouseMoveMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        MouseMoveMessage.prototype.toString = function () {
            return "MouseMoveMessage[" + this.c.toString() + "]";
        };
        MouseMoveMessage.$t = i2.markType(MouseMoveMessage, 'MouseMoveMessage', InteractionMessage.$);
        return MouseMoveMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseButtonAction_$type = i2.markEnum('MouseButtonAction', 'Up,0|Down,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseButtonType_$type = i2.markEnum('MouseButtonType', 'Left,0|Right,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseButtonMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MouseButtonMessage, _super);
        function MouseButtonMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.d = 0;
            _this.g = null;
            _this.f = 0;
            return _this;
        }
        Object.defineProperty(MouseButtonMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MouseButtonMessage.prototype, "e", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MouseButtonMessage.prototype, "h", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        MouseButtonMessage.prototype.toString = function () {
            return "MouseButtonMessage[" + i2.EnumUtil.getName(MouseButtonAction_$type, this.c) + ", " + i2.EnumUtil.getName(MouseButtonType_$type, this.e) + ", " + this.h.toString() + "]";
        };
        MouseButtonMessage.$t = i2.markType(MouseButtonMessage, 'MouseButtonMessage', InteractionMessage.$);
        return MouseButtonMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RenderingMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RenderingMessage, _super);
        function RenderingMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.b = false;
            return _this;
        }
        Object.defineProperty(RenderingMessage.prototype, "e", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RenderingMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        RenderingMessage.$t = i2.markType(RenderingMessage, 'RenderingMessage', Message.$);
        return RenderingMessage;
    }(Message));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SetAreaSizeMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SetAreaSizeMessage, _super);
        function SetAreaSizeMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = false;
            _this.j = 0;
            _this.g = false;
            _this.k = 0;
            return _this;
        }
        Object.defineProperty(SetAreaSizeMessage.prototype, "h", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SetAreaSizeMessage.prototype, "l", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                this.j = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SetAreaSizeMessage.prototype, "i", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SetAreaSizeMessage.prototype, "m", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                this.k = a;
            },
            enumerable: false,
            configurable: true
        });
        SetAreaSizeMessage.prototype.toString = function () {
            return "SetAreaSizeMessage[" + this.h.toString() + ", " + this.l.toString() + ", " + this.i.toString() + ", " + this.m.toString() + "]";
        };
        SetAreaSizeMessage.$t = i2.markType(SetAreaSizeMessage, 'SetAreaSizeMessage', RenderingMessage.$);
        return SetAreaSizeMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RenderSliceMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RenderSliceMessage, _super);
        function RenderSliceMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.h = 1;
            return _this;
        }
        Object.defineProperty(RenderSliceMessage.prototype, "g", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        RenderSliceMessage.prototype.toString = function () {
            return "RenderSliceMessage[" + this.g.toString() + "]";
        };
        RenderSliceMessage.$t = i2.markType(RenderSliceMessage, 'RenderSliceMessage', RenderingMessage.$);
        return RenderSliceMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RenderOuterLabelMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RenderOuterLabelMessage, _super);
        function RenderOuterLabelMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.i = null;
            _this.k = null;
            _this.g = 0;
            _this.f = null;
            return _this;
        }
        Object.defineProperty(RenderOuterLabelMessage.prototype, "j", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                this.i = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RenderOuterLabelMessage.prototype, "l", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                this.k = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RenderOuterLabelMessage.prototype, "h", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        RenderOuterLabelMessage.prototype.toString = function () {
            return "RenderOuterLabelMessage[" + this.j.toString() + ", " + this.l.toString() + ", " + this.h.toString() + "]";
        };
        RenderOuterLabelMessage.$t = i2.markType(RenderOuterLabelMessage, 'RenderOuterLabelMessage', RenderingMessage.$);
        return RenderOuterLabelMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PointList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointList, _super);
        function PointList() {
            return _super.call(this, i2.Point_$type, 0) || this;
        }
        PointList.$t = i2.markType(PointList, 'PointList', i2.List$1.$.specialize(i2.Point_$type));
        return PointList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceAppearance = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceAppearance, _super);
        function SliceAppearance() {
            var _this = _super.call(this) || this;
            _this.l = 0;
            _this.k = 0;
            _this.ak = null;
            _this.al = null;
            _this.a = null;
            _this.b = null;
            _this.at = null;
            _this.am = null;
            _this.aj = null;
            _this.ai = null;
            _this.az = null;
            _this.z = null;
            _this.ac = null;
            _this.t = null;
            _this.ah = null;
            _this.g = false;
            _this.u = null;
            _this.r = 0;
            _this.av = i2.Rect.empty;
            _this.aw = i2.Rect.empty;
            _this.aa = null;
            _this.ab = null;
            _this.a1 = 0;
            _this.h = false;
            _this.q = 0;
            _this.m = 1;
            _this.ai = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.aj = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.al = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.am = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.ak = { $type: i2.Point_$type, x: 0, y: 0 };
            return _this;
        }
        Object.defineProperty(SliceAppearance.prototype, "o", {
            get: function () {
                return this.l;
            },
            set: function (a) {
                this.l = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "n", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                this.k = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "aq", {
            get: function () {
                return this.ak;
            },
            set: function (a) {
                this.ak = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ar", {
            get: function () {
                return this.al;
            },
            set: function (a) {
                this.al = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "c", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "e", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "au", {
            get: function () {
                return this.at;
            },
            set: function (a) {
                this.at = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceAppearance.prototype.y = function () {
        };
        SliceAppearance.prototype.x = function () {
            var e_1, _a, e_2, _b;
            var a = new i2.PointCollection(0);
            if (this.e != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.e)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var b = _d.value;
                        a.add(b);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            else {
                a.add(this.ar);
                a.add(this.as);
            }
            if (this.c != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        a.add(c);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                if (this.e != null && this.e.count > 0) {
                    a.add(this.e._inner[0]);
                }
            }
            else {
                a.add(this.ap);
                a.add(this.ao);
                a.add(this.ar);
            }
            var d = 0, e = Math.min(i2.intDivide(a.count, 2), 5);
            if (e > 1) {
                var f = a._inner[0];
                var g = 0, h = f.x, i = f.y;
                while (++d < e && g < 2) {
                    f = a._inner[d];
                    g = Math.abs(f.x - h) + Math.abs(f.y - i);
                    if (g > 1) {
                        a.add({ $type: i2.Point_$type, x: f.x, y: f.y });
                    }
                }
            }
            this.au = a;
        };
        Object.defineProperty(SliceAppearance.prototype, "as", {
            get: function () {
                return this.am;
            },
            set: function (a) {
                this.am = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ap", {
            get: function () {
                return this.aj;
            },
            set: function (a) {
                this.aj = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ao", {
            get: function () {
                return this.ai;
            },
            set: function (a) {
                this.ai = a;
                this.y();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "a0", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                this.az = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ad", {
            get: function () {
                return this.z;
            },
            set: function (a) {
                this.z = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ag", {
            get: function () {
                return this.ac;
            },
            set: function (a) {
                this.ac = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "v", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                this.t = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "an", {
            get: function () {
                return this.ah;
            },
            set: function (a) {
                this.ah = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "i", {
            get: function () {
                return this.g && this.t != null;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "item", {
            get: function () {
                return this.u;
            },
            set: function (a) {
                this.u = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "s", {
            get: function () {
                return this.r;
            },
            set: function (a) {
                this.r = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ax", {
            get: function () {
                return this.av;
            },
            set: function (a) {
                this.av = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ay", {
            get: function () {
                return this.aw;
            },
            set: function (a) {
                this.aw = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "ae", {
            get: function () {
                return this.aa;
            },
            set: function (a) {
                this.aa = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "af", {
            get: function () {
                return this.ab;
            },
            set: function (a) {
                this.ab = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "a2", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                this.a1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "j", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                this.h = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceAppearance.prototype, "p", {
            get: function () {
                return this.m;
            },
            set: function (a) {
                this.m = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceAppearance.f = function (a, b, c, d, e) {
            if (a == null) {
                a = new SliceAppearance();
            }
            a.ad = c.ad;
            a.i = c.i;
            a.v = c.v;
            if (b.i && c.i) {
                a.an = { $type: i2.Point_$type, x: (b.an.x * e) + (c.an.x * d), y: (b.an.y * e) + (c.an.y * d) };
            }
            else if (c.i) {
                a.an = { $type: i2.Point_$type, x: c.an.x * d, y: c.an.y * d };
            }
            a.ao = { $type: i2.Point_$type, x: (b.ao.x * e) + (c.ao.x * d), y: (b.ao.y * e) + (c.ao.y * d) };
            a.ap = { $type: i2.Point_$type, x: (b.ap.x * e) + (c.ap.x * d), y: (b.ap.y * e) + (c.ap.y * d) };
            a.ar = { $type: i2.Point_$type, x: (b.ar.x * e) + (c.ar.x * d), y: (b.ar.y * e) + (c.ar.y * d) };
            a.as = { $type: i2.Point_$type, x: (b.as.x * e) + (c.as.x * d), y: (b.as.y * e) + (c.as.y * d) };
            a.aq = { $type: i2.Point_$type, x: (b.aq.x * e) + (c.aq.x * d), y: (b.aq.y * e) + (c.aq.y * d) };
            if (c.c != null) {
                var f = b.c;
                if (f == null) {
                    f = new PointList();
                    f.add(b.ar);
                    f.add(b.ao);
                }
                a.c = SliceAppearance.d(a.c, f, c.c, d, e);
            }
            else {
                a.c = null;
            }
            if (c.e != null) {
                var g = b.e;
                if (g == null) {
                    g = new PointList();
                    g.add(b.ap);
                    g.add(b.as);
                }
                a.e = SliceAppearance.d(a.e, g, c.e, d, e);
            }
            else {
                a.e = null;
            }
            a.ag = c.ag;
            a.a0 = c.a0;
            a.item = c.item;
            a.s = c.s;
            a.x();
            return a;
        };
        SliceAppearance.d = function (a, b, c, d, e) {
            if (a == null) {
                a = new PointList();
            }
            if (b == null) {
                b = new PointList();
            }
            var f = b.count;
            var g = c.count;
            var h = Math.max(f, g);
            if (a.count < h) {
                a.s(a.count, new Array(h - a.count));
            }
            if (a.count > h) {
                a.v(h, a.count - h);
            }
            for (var i = 0; i < Math.min(f, g); ++i) {
                a._inner[i] = { $type: i2.Point_$type, x: (b._inner[i].x * e) + (c._inner[i].x * d), y: (b._inner[i].y * e) + (c._inner[i].y * d) };
            }
            if (f < g) {
                var j = f > 0 ? b._inner[f - 1] : { $type: i2.Point_$type, x: 0, y: 0 };
                for (var k = f; k < g; ++k) {
                    a._inner[k] = { $type: i2.Point_$type, x: (j.x * e) + (c._inner[k].x * d), y: (j.y * e) + (c._inner[k].y * d) };
                }
            }
            if (f > g) {
                var l = g > 0 ? c._inner[g - 1] : { $type: i2.Point_$type, x: 0, y: 0 };
                for (var m = g; m < f; ++m) {
                    a._inner[m] = { $type: i2.Point_$type, x: (b._inner[m].x * e) + (l.x * d), y: (b._inner[m].y * e) + (l.y * d) };
                }
            }
            return a;
        };
        SliceAppearance.$t = i2.markType(SliceAppearance, 'SliceAppearance');
        return SliceAppearance;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelSliceVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelSliceVisualData, _super);
        function FunnelSliceVisualData() {
            var _this = _super.call(this) || this;
            _this._isSelected = false;
            _this._index = 0;
            _this._top = 0;
            _this._bottom = 0;
            _this._sliceCenterPoint = null;
            _this._upperRight = null;
            _this._lowerRight = null;
            _this._upperLeft = null;
            _this._lowerLeft = null;
            _this._height = 0;
            _this._upperWidth = 0;
            _this._lowerWidth = 0;
            _this._innerLabel = null;
            _this._outerLabel = null;
            _this._sliceBorderBrush = null;
            _this._sliceBorderThickness = 0;
            _this._appearance = null;
            _this._innerLabelAppearance = null;
            _this._outerLabelAppearance = null;
            _this._slicePoints = null;
            _this._innerLabelPosition = null;
            _this._outerLabelPosition = null;
            _this._outerLabelBounds = null;
            _this._innerLabelBounds = null;
            _this._isVisibile = false;
            _this.appearance = new i2.PrimitiveAppearanceData();
            _this.slicePoints = new Array(0);
            _this.innerLabelAppearance = new i2.LabelAppearanceData();
            _this.outerLabelBounds = i2.RectData.b(i2.Rect.empty);
            _this.innerLabelBounds = i2.RectData.b(i2.Rect.empty);
            return _this;
        }
        Object.defineProperty(FunnelSliceVisualData.prototype, "isSelected", {
            get: function () {
                return this._isSelected;
            },
            set: function (a) {
                this._isSelected = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "index", {
            get: function () {
                return this._index;
            },
            set: function (a) {
                this._index = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "top", {
            get: function () {
                return this._top;
            },
            set: function (a) {
                this._top = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "bottom", {
            get: function () {
                return this._bottom;
            },
            set: function (a) {
                this._bottom = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "sliceCenterPoint", {
            get: function () {
                return this._sliceCenterPoint;
            },
            set: function (a) {
                this._sliceCenterPoint = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "upperRight", {
            get: function () {
                return this._upperRight;
            },
            set: function (a) {
                this._upperRight = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "lowerRight", {
            get: function () {
                return this._lowerRight;
            },
            set: function (a) {
                this._lowerRight = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "upperLeft", {
            get: function () {
                return this._upperLeft;
            },
            set: function (a) {
                this._upperLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "lowerLeft", {
            get: function () {
                return this._lowerLeft;
            },
            set: function (a) {
                this._lowerLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "upperWidth", {
            get: function () {
                return this._upperWidth;
            },
            set: function (a) {
                this._upperWidth = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "lowerWidth", {
            get: function () {
                return this._lowerWidth;
            },
            set: function (a) {
                this._lowerWidth = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "innerLabel", {
            get: function () {
                return this._innerLabel;
            },
            set: function (a) {
                this._innerLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "outerLabel", {
            get: function () {
                return this._outerLabel;
            },
            set: function (a) {
                this._outerLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "sliceBorderBrush", {
            get: function () {
                return this._sliceBorderBrush;
            },
            set: function (a) {
                this._sliceBorderBrush = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "sliceBorderThickness", {
            get: function () {
                return this._sliceBorderThickness;
            },
            set: function (a) {
                this._sliceBorderThickness = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "appearance", {
            get: function () {
                return this._appearance;
            },
            set: function (a) {
                this._appearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "innerLabelAppearance", {
            get: function () {
                return this._innerLabelAppearance;
            },
            set: function (a) {
                this._innerLabelAppearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "outerLabelAppearance", {
            get: function () {
                return this._outerLabelAppearance;
            },
            set: function (a) {
                this._outerLabelAppearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "slicePoints", {
            get: function () {
                return this._slicePoints;
            },
            set: function (a) {
                this._slicePoints = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "innerLabelPosition", {
            get: function () {
                return this._innerLabelPosition;
            },
            set: function (a) {
                this._innerLabelPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "outerLabelPosition", {
            get: function () {
                return this._outerLabelPosition;
            },
            set: function (a) {
                this._outerLabelPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "outerLabelBounds", {
            get: function () {
                return this._outerLabelBounds;
            },
            set: function (a) {
                this._outerLabelBounds = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "innerLabelBounds", {
            get: function () {
                return this._innerLabelBounds;
            },
            set: function (a) {
                this._innerLabelBounds = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceVisualData.prototype, "isVisibile", {
            get: function () {
                return this._isVisibile;
            },
            set: function (a) {
                this._isVisibile = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelSliceVisualData.prototype.scaleByViewport = function (a) {
            if (this.outerLabelBounds != null) {
                var b = (this.outerLabelBounds.left - a.left) / a.width;
                var c = ((this.outerLabelBounds.left + this.outerLabelBounds.width) - a.left) / a.width;
                var d = (this.outerLabelBounds.top - a.top) / a.height;
                var e = ((this.outerLabelBounds.top + this.outerLabelBounds.height) - a.top) / a.height;
                this.outerLabelBounds = new i2.RectData(b, d, c - b, e - d);
            }
            if (this.outerLabelPosition != null) {
                var f = (this.outerLabelPosition.x - a.left) / a.width;
                var g = (this.outerLabelPosition.y - a.top) / a.height;
                this.outerLabelPosition = new i2.PointData(f, g);
            }
            if (this.innerLabelBounds != null) {
                var h = (this.innerLabelBounds.left - a.left) / a.width;
                var i = ((this.innerLabelBounds.left + this.innerLabelBounds.width) - a.left) / a.width;
                var j = (this.innerLabelBounds.top - a.top) / a.height;
                var k = ((this.innerLabelBounds.top + this.innerLabelBounds.height) - a.top) / a.height;
                this.innerLabelBounds = new i2.RectData(h, j, i - h, k - j);
            }
            if (this.innerLabelPosition != null) {
                var l = (this.innerLabelPosition.x - a.left) / a.width;
                var m = (this.innerLabelPosition.y - a.top) / a.height;
                this.innerLabelPosition = new i2.PointData(l, m);
            }
            var n = new Array(this.slicePoints.length);
            var o = 0;
            var r = this.slicePoints;
            for (var q = 0; q < r.length; q++) {
                var p = r[q];
                var s = (p.x - a.left) / a.width;
                var t = (p.y - a.top) / a.height;
                n[o] = new i2.PointData(s, t);
                o++;
            }
            this.slicePoints = n;
        };
        FunnelSliceVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("index: " + this.index + ", ");
            if (this.innerLabel != null) {
                a.u("innerLabel: \"" + this.innerLabel + "\", ");
            }
            if (this.outerLabel != null) {
                a.u("outerLabel: \"" + this.innerLabel + "\", ");
            }
            if (this.appearance != null) {
                a.u("appearance: " + this.appearance.serialize() + ", ");
            }
            if (this.innerLabelAppearance != null) {
                a.u("innerLabelAppearance: " + this.innerLabelAppearance.serialize() + ", ");
            }
            if (this.outerLabelAppearance != null) {
                a.u("outerLabelAppearance: " + this.outerLabelAppearance.serialize() + ", ");
            }
            if (this.slicePoints != null) {
                a.u("slicePoints: [");
                for (var b = 0; b < this.slicePoints.length; b++) {
                    a.u("{ x: " + this.slicePoints[b].x + ", y: " + this.slicePoints[b].y + " }");
                    if (b < this.slicePoints.length - 1) {
                        a.l(",");
                    }
                }
                a.u("], ");
            }
            if (this.innerLabelBounds != null) {
                a.u("innerLabelBounds: { left: " + this.innerLabelBounds.left + ", top: " + this.innerLabelBounds.top + ", width: " + this.innerLabelBounds.width + ", height: " + this.innerLabelBounds.height + "}, ");
            }
            if (this.outerLabelBounds != null) {
                a.u("outerLabelBounds: { left: " + this.outerLabelBounds.left + ", top: " + this.outerLabelBounds.top + ", width: " + this.outerLabelBounds.width + ", height: " + this.outerLabelBounds.height + "}, ");
            }
            if (this.innerLabelPosition != null) {
                a.u("innerLabelPosition: { x: " + this.innerLabelPosition.x + ", y: " + this.innerLabelPosition.y + "}, ");
            }
            if (this.outerLabelPosition != null) {
                a.u("outerLabelPosition: { x: " + this.outerLabelPosition.x + ", y: " + this.outerLabelPosition.y + "}, ");
            }
            a.u("isSelected: " + (this.isSelected ? "true" : "false"));
            a.u("}");
            return a.toString();
        };
        FunnelSliceVisualData.$t = i2.markType(FunnelSliceVisualData, 'FunnelSliceVisualData');
        return FunnelSliceVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceInfo, _super);
        function SliceInfo() {
            var _this = _super.call(this) || this;
            _this.k = null;
            _this.m = null;
            _this.i = 0;
            _this.f = false;
            _this.a = null;
            _this.e = false;
            _this.b = new SliceAppearance();
            _this.n = { $type: i2.Point_$type, x: 0, y: 0 };
            return _this;
        }
        Object.defineProperty(SliceInfo.prototype, "l", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                this.k = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceInfo.prototype, "n", {
            get: function () {
                return this.m;
            },
            set: function (a) {
                this.m = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceInfo.prototype, "j", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                this.i = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceInfo.prototype, "h", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceInfo.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceInfo.prototype, "g", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceInfo.c = function (a, b, c, d, e) {
            if (a == null) {
                a = new SliceInfo();
            }
            a.g = c.g;
            a.h = c.h;
            a.j = c.j;
            a.l = c.l;
            a.n = { $type: i2.Point_$type, x: (b.n.x * e) + (c.n.x * d), y: (b.n.y * e) + (c.n.y * d) };
            a.b = SliceAppearance.f(a.b, b.b, c.b, d, e);
            return a;
        };
        SliceInfo.prototype.d = function () {
            var a = new FunnelSliceVisualData();
            a.appearance = new i2.PrimitiveAppearanceData();
            a.appearance.fill = i2.AppearanceHelper.b(this.b.ad);
            a.appearance.stroke = i2.AppearanceHelper.b(this.b.ag);
            a.appearance.opacity = this.b.p;
            a.appearance.canvasLeft = this.b.aq.x;
            a.appearance.canvasTop = this.b.aq.y;
            a.height = this.b.ao.y - this.b.ar.y;
            a.upperWidth = this.b.as.x - this.b.ar.x;
            a.lowerWidth = this.b.ap.x - this.b.ao.x;
            a.isSelected = this.b.j;
            a.top = this.b.o;
            a.bottom = this.b.n;
            a.index = this.j;
            a.height = this.b.n - this.b.o;
            a.sliceBorderBrush = i2.AppearanceHelper.a(this.b.ag);
            if (this.b.v == null) {
                a.innerLabel = i2.stringEmpty();
            }
            else {
                a.innerLabel = this.b.v.toString();
            }
            if (this.l == null) {
                a.outerLabel = i2.stringEmpty();
            }
            else {
                a.outerLabel = this.l.toString();
            }
            a.upperLeft = i2.PointData.b(this.b.ar);
            a.upperRight = i2.PointData.b(this.b.as);
            a.lowerLeft = i2.PointData.b(this.b.ao);
            a.lowerRight = i2.PointData.b(this.b.ap);
            var b = new Array(this.b.au.count);
            for (var c = 0; c < this.b.au.count; c++) {
                b[c] = new i2.PointData(this.b.au._inner[c].x, this.b.au._inner[c].y);
            }
            a.slicePoints = b;
            a.innerLabelPosition = i2.PointData.b(this.a.an);
            a.outerLabelPosition = i2.PointData.b(this.m);
            a.outerLabelBounds = i2.RectData.b(this.b.ay);
            a.innerLabelBounds = i2.RectData.b(this.b.ax);
            a.isVisibile = this.b.a2 == 0;
            a.innerLabelAppearance = new i2.LabelAppearanceData();
            a.innerLabelAppearance.labelBrush = i2.AppearanceHelper.b(this.b.ae);
            a.innerLabelAppearance.text = a.innerLabel;
            a.innerLabelAppearance.visibility = this.b.i;
            a.outerLabelAppearance = new i2.LabelAppearanceData();
            a.outerLabelAppearance.labelBrush = i2.AppearanceHelper.b(this.b.af);
            a.outerLabelAppearance.text = a.outerLabel;
            a.outerLabelAppearance.visibility = this.g;
            return a;
        };
        SliceInfo.$t = i2.markType(SliceInfo, 'SliceInfo');
        return SliceInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TooltipValueChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TooltipValueChangedMessage, _super);
        function TooltipValueChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            return _this;
        }
        Object.defineProperty(TooltipValueChangedMessage.prototype, "g", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        TooltipValueChangedMessage.prototype.toString = function () {
            return "TooltipValueChangedMessage[" + this.g.toString() + "]";
        };
        TooltipValueChangedMessage.$t = i2.markType(TooltipValueChangedMessage, 'TooltipValueChangedMessage', RenderingMessage.$);
        return TooltipValueChangedMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TooltipUpdateMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TooltipUpdateMessage, _super);
        function TooltipUpdateMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.h = null;
            _this.f = null;
            return _this;
        }
        Object.defineProperty(TooltipUpdateMessage.prototype, "i", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                this.h = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TooltipUpdateMessage.prototype, "g", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        TooltipUpdateMessage.prototype.toString = function () {
            return "TooltipUpdateMessage[" + this.i.toString() + ", " + this.g.toString() + "]";
        };
        TooltipUpdateMessage.$t = i2.markType(TooltipUpdateMessage, 'TooltipUpdateMessage', RenderingMessage.$);
        return TooltipUpdateMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelDataContext, _super);
        function FunnelDataContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.a = 0;
            return _this;
        }
        Object.defineProperty(FunnelDataContext.prototype, "item", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelDataContext.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelDataContext.$t = i2.markType(FunnelDataContext, 'FunnelDataContext');
        return FunnelDataContext;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ConfigurationMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ConfigurationMessage, _super);
        function ConfigurationMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ConfigurationMessage.$t = i2.markType(ConfigurationMessage, 'ConfigurationMessage', Message.$);
        return ConfigurationMessage;
    }(Message));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PropertyChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PropertyChangedMessage, _super);
        function PropertyChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.c = null;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(PropertyChangedMessage.prototype, "g", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PropertyChangedMessage.prototype, "e", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PropertyChangedMessage.prototype, "d", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        PropertyChangedMessage.prototype.toString = function () {
            var a = "null";
            var b = "null";
            if (this.e != null) {
                a = this.e.toString();
            }
            if (this.d != null) {
                b = this.d.toString();
            }
            return "PropertyChangedMessage[" + this.g.toString() + ", " + a + ", " + b + "]";
        };
        PropertyChangedMessage.$t = i2.markType(PropertyChangedMessage, 'PropertyChangedMessage', ConfigurationMessage.$);
        return PropertyChangedMessage;
    }(ConfigurationMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MessageHandler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MessageHandler, _super);
        function MessageHandler() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = new i2.Dictionary$2(i2.Type.$, i2.Delegate_$type, 0);
            return _this;
        }
        MessageHandler.prototype.b = function (a, b) {
            this.a.addItem(a, b);
        };
        MessageHandler.prototype.c = function (a) {
            var _this = this;
            var b;
            if (((function () { var c = _this.a.tryGetValue(i2.getInstanceType(a), b); b = c.p1; return c.ret; })())) {
                b(a);
            }
        };
        MessageHandler.$t = i2.markType(MessageHandler, 'MessageHandler');
        return MessageHandler;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ClearMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ClearMessage, _super);
        function ClearMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ClearMessage.$t = i2.markType(ClearMessage, 'ClearMessage', RenderingMessage.$);
        return ClearMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ClearTooltipMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ClearTooltipMessage, _super);
        function ClearTooltipMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ClearTooltipMessage.$t = i2.markType(ClearTooltipMessage, 'ClearTooltipMessage', RenderingMessage.$);
        return ClearTooltipMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ContainerSizeChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContainerSizeChangedMessage, _super);
        function ContainerSizeChangedMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ContainerSizeChangedMessage.$t = i2.markType(ContainerSizeChangedMessage, 'ContainerSizeChangedMessage', InteractionMessage.$);
        return ContainerSizeChangedMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ViewportChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ViewportChangedMessage, _super);
        function ViewportChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.b = 0;
            return _this;
        }
        Object.defineProperty(ViewportChangedMessage.prototype, "e", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ViewportChangedMessage.prototype, "d", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        ViewportChangedMessage.prototype.toString = function () {
            return "ViewportChangedMessage[" + this.e.toString() + ", " + this.d.toString() + "]";
        };
        ViewportChangedMessage.$t = i2.markType(ViewportChangedMessage, 'ViewportChangedMessage', InteractionMessage.$);
        return ViewportChangedMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ViewPropertyChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ViewPropertyChangedMessage, _super);
        function ViewPropertyChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.c = null;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(ViewPropertyChangedMessage.prototype, "g", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ViewPropertyChangedMessage.prototype, "e", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ViewPropertyChangedMessage.prototype, "d", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        ViewPropertyChangedMessage.prototype.toString = function () {
            return "ViewPropertyChangedMessage[" + this.g.toString() + ", " + this.e.toString() + ", " + this.d.toString() + "]";
        };
        ViewPropertyChangedMessage.$t = i2.markType(ViewPropertyChangedMessage, 'ViewPropertyChangedMessage', InteractionMessage.$);
        return ViewPropertyChangedMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ObjectColumn = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ObjectColumn, _super);
        function ObjectColumn() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            return _this;
        }
        ObjectColumn.prototype.b = function (a) {
            this.a = a;
        };
        ObjectColumn.$t = i2.markType(ObjectColumn, 'ObjectColumn');
        return ObjectColumn;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceInfoList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceInfoList, _super);
        function SliceInfoList() {
            return _super.call(this, SliceInfo.$, 0) || this;
        }
        SliceInfoList.prototype.ae = function () {
            this.aa(function (a, b) {
                if (a.j < b.j) {
                    return -1;
                }
                if (a.j > b.j) {
                    return 1;
                }
                return 0;
            });
        };
        SliceInfoList.prototype.af = function () {
            this.aa(function (a, b) {
                if (a.b.aq.y < b.b.aq.y) {
                    return -1;
                }
                if (a.b.aq.y > b.b.aq.y) {
                    return 1;
                }
                return 0;
            });
        };
        SliceInfoList.prototype.ad = function (a) {
            this.af();
            var b = this.ac(function (c) {
                if (a < (c.b.ar.y + c.b.aq.y)) {
                    return -1;
                }
                if (a > (c.b.ao.y + c.b.aq.y)) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            if (b >= 0) {
                b = (this._inner[b]).j;
            }
            else {
                b = -1;
            }
            this.ae();
            if (b >= 0) {
                return b;
            }
            return -1;
        };
        SliceInfoList.prototype.ac = function (a) {
            var b = 0;
            var c = this.count - 1;
            while (b <= c) {
                var d = (b + ((c - b) >> 1));
                var e = a(this._inner[d]);
                if (e < 0) {
                    c = d - 1;
                }
                else if (e > 0) {
                    b = d + 1;
                }
                else {
                    return d;
                }
            }
            return ~b;
        };
        SliceInfoList.$t = i2.markType(SliceInfoList, 'SliceInfoList', i2.List$1.$.specialize(SliceInfo.$));
        return SliceInfoList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BezierPoint = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BezierPoint, _super);
        function BezierPoint() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.a = 0;
            _this.b = 0;
            return _this;
        }
        BezierPoint.$t = i2.markType(BezierPoint, 'BezierPoint');
        return BezierPoint;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BezierOp = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BezierOp, _super);
        function BezierOp() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.a = 0;
            return _this;
        }
        BezierOp.$t = i2.markType(BezierOp, 'BezierOp');
        return BezierOp;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Bezier = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Bezier, _super);
        function Bezier(a, b, c, d, e, f) {
            var _this = _super.call(this) || this;
            _this.h = 0;
            _this.m = null;
            _this.n = null;
            _this.o = null;
            _this.p = null;
            _this.i = 1.7976931348623157E+308;
            _this.d = false;
            _this.e = null;
            _this.f = null;
            _this.g = new i2.Stack$1(BezierOp.$);
            _this.m = a;
            _this.n = b;
            _this.o = c;
            _this.p = d;
            _this.h = e;
            _this.i = f;
            _this.d = _this.c();
            return _this;
        }
        Object.defineProperty(Bezier.prototype, "j", {
            get: function () {
                return this.h;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Bezier.prototype, "q", {
            get: function () {
                return this.m;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Bezier.prototype, "r", {
            get: function () {
                return this.n;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Bezier.prototype, "s", {
            get: function () {
                return this.o;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Bezier.prototype, "t", {
            get: function () {
                return this.p;
            },
            enumerable: false,
            configurable: true
        });
        Bezier.prototype.a = function (a) {
            var b = 1 - a;
            var c = b * b;
            var d = c * b;
            var e = a * a;
            var f = e * a;
            var g = { $type: i2.Point_$type, x: d * this.m.x + 3 * c * a * this.n.x + 3 * b * e * this.o.x + f * this.p.x, y: d * this.m.y + 3 * c * a * this.n.y + 3 * b * e * this.o.y + f * this.p.y };
            var h = new BezierPoint();
            h.c = g;
            h.a = a;
            return h;
        };
        Bezier.prototype.c = function () {
            var e_1, _a;
            this.e = new i2.List$1(BezierPoint.$, 0);
            this.f = new i2.List$1(BezierPoint.$, 0);
            var a = new BezierOp();
            a.b = 0;
            a.a = 1;
            this.g.g();
            this.g.h(a);
            var b = 0;
            while (this.g.f > 0) {
                var c = this.g.e();
                var d = this.a(c.b);
                var e = this.a(c.a);
                var f = (e.c.x - d.c.x) * (e.c.x - d.c.x) + (e.c.y - d.c.y) * (e.c.y - d.c.y);
                if (f < this.h) {
                    d.b = b++;
                    e.b = b++;
                    this.e.add(d);
                    this.e.add(e);
                    if (d.c.x > this.i || e.c.x > this.i) {
                        return false;
                    }
                }
                else {
                    var g = (c.b + c.a) / 2;
                    var h = new BezierOp();
                    h.b = c.b;
                    h.a = g;
                    var i = new BezierOp();
                    i.b = g;
                    i.a = c.a;
                    this.g.h(i);
                    this.g.h(h);
                }
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var j = _c.value;
                    this.f.add(j);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.l();
            return true;
        };
        Bezier.prototype.l = function () {
            this.f.aa(function (a, b) { return i2.CompareUtil.compareToObject(a.c.y, b.c.y); });
        };
        Bezier.prototype.b = function (a) {
            var b = this.k(function (c) {
                if (a < c.c.y) {
                    return -1;
                }
                if (a > c.c.y) {
                    return 1;
                }
                return 0;
            });
            if (b < 0) {
                b = ~b;
            }
            if (b < 0) {
                b = 0;
            }
            if (b > this.f.count - 1) {
                b = this.f.count - 1;
            }
            var c = 100000001;
            var d = 100000000;
            var e = 100000002;
            d = Math.abs(this.f._inner[b].c.y - a);
            if (b - 1 >= 0) {
                c = Math.abs(this.f._inner[b - 1].c.y - a);
            }
            if (b + 1 < this.f.count) {
                e = Math.abs(this.f._inner[b + 1].c.y - a);
            }
            if (d <= c && d <= e) {
                return this.f._inner[b];
            }
            if (c <= d && c <= e && b - 1 > 0) {
                return this.f._inner[b - 1];
            }
            if (e <= c && e <= d && b + 1 < this.f.count) {
                return this.f._inner[b + 1];
            }
            return this.f._inner[b];
        };
        Bezier.prototype.k = function (a) {
            var b = 0;
            var c = this.f.count - 1;
            while (b <= c) {
                var d = (b + ((c - b) >> 1));
                var e = a(this.f._inner[d]);
                if (e < 0) {
                    c = d - 1;
                }
                else if (e > 0) {
                    b = d + 1;
                }
                else {
                    return d;
                }
            }
            return ~b;
        };
        Bezier.$t = i2.markType(Bezier, 'Bezier');
        return Bezier;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DoubleColumn = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DoubleColumn, _super);
        function DoubleColumn() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            return _this;
        }
        DoubleColumn.prototype.b = function (a) {
            this.a = a;
        };
        DoubleColumn.$t = i2.markType(DoubleColumn, 'DoubleColumn');
        return DoubleColumn;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types of alignment used by the outer labels of the funnel chart.
     */
    var OuterLabelAlignment = /*@__PURE__*/ (function (OuterLabelAlignment) {
        /**
         * The labels will be displayed to the left of the chart.
         */
        OuterLabelAlignment[OuterLabelAlignment["Left"] = 0] = "Left";
        /**
         * The labels will be displayed to the right of the chart.
         */
        OuterLabelAlignment[OuterLabelAlignment["Right"] = 1] = "Right";
        return OuterLabelAlignment;
    })({});
    /**
     * @hidden
     */
    var OuterLabelAlignment_$type = i2.markEnum('OuterLabelAlignment', 'Left,0|Right,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors for displaying height of the funnel slices.
     */
    var FunnelSliceDisplay = /*@__PURE__*/ (function (FunnelSliceDisplay) {
        /**
         * The slice heights should be uniform.
         */
        FunnelSliceDisplay[FunnelSliceDisplay["Uniform"] = 0] = "Uniform";
        /**
         * The slice heights should be weighted by value.
         */
        FunnelSliceDisplay[FunnelSliceDisplay["Weighted"] = 1] = "Weighted";
        return FunnelSliceDisplay;
    })({});
    /**
     * @hidden
     */
    var FunnelSliceDisplay_$type = i2.markEnum('FunnelSliceDisplay', 'Uniform,0|Weighted,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IItemProvider_$type = new i2.Type(null, 'IItemProvider');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceSelectionManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceSelectionManager, _super);
        function SliceSelectionManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.e = new i2.Dictionary$2(i2.Number_$type, i2.Base.$, 0);
            return _this;
        }
        SliceSelectionManager.prototype.k = function (a, b) {
            if (this.e.containsKey(a)) {
                this.e.removeItem(a);
            }
            else {
                this.e.item(a, b);
            }
        };
        SliceSelectionManager.prototype.c = function (a) {
            return this.e.containsKey(a);
        };
        SliceSelectionManager.prototype.b = function () {
            return this.e.count > 0;
        };
        SliceSelectionManager.prototype.d = function (a) {
            return !this.c(a) && this.b();
        };
        SliceSelectionManager.prototype.g = function (a, b) {
            switch (a.c) {
                case 3: break;
                case 1:
                    this.j(a.g, a.f);
                    break;
                case 0:
                    this.h(a.g, a.f);
                    break;
                case 2:
                    for (var c = 0; c < a.f; c++) {
                        if (this.e.containsKey(c)) {
                            this.e.item(c, b.a.item(c));
                        }
                    }
                    break;
                case 4:
                    this.f();
                    break;
            }
        };
        SliceSelectionManager.prototype.h = function (a, b) {
            var e_1, _a, e_2, _b;
            var c = new i2.List$1(i2.Number_$type, 0);
            var d = new i2.List$1(i2.Base.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.e.keys)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    if (e >= a) {
                        c.add(e);
                        d.add1(this.e.item(e));
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var f = 0;
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var g = _f.value;
                    this.e.removeItem(g);
                    if (g - b > a) {
                        this.e.item(g - b, d._inner[f]);
                    }
                    f++;
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        SliceSelectionManager.prototype.j = function (a, b) {
            var e_3, _a, e_4, _b;
            var c = new i2.List$1(i2.Number_$type, 0);
            var d = new i2.List$1(i2.Base.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.e.keys)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    if (e >= a) {
                        c.add(e);
                        d.add1(this.e.item(e));
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            var f = 0;
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var g = _f.value;
                    this.e.removeItem(g);
                    this.e.item(g + b, d._inner[f]);
                    f++;
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        };
        SliceSelectionManager.prototype.f = function () {
            this.e.clear();
        };
        SliceSelectionManager.prototype.a = function () {
            var e_5, _a;
            var a = new Array(this.e.count);
            var b = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.e.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a[b] = c;
                    b++;
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            return a;
        };
        SliceSelectionManager.prototype.i = function (a, b) {
            this.f();
            for (var d = 0; d < a.length; d++) {
                var c = a[d];
                this.k(c, b.a.item(c));
            }
        };
        SliceSelectionManager.$t = i2.markType(SliceSelectionManager, 'SliceSelectionManager');
        return SliceSelectionManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelFrame, _super);
        function FunnelFrame() {
            var _this = _super.call(this) || this;
            _this.c = false;
            _this.e = false;
            _this.d = false;
            _this.a = null;
            _this.i = 0;
            _this.b = new SliceInfoList();
            return _this;
        }
        Object.defineProperty(FunnelFrame.prototype, "f", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelFrame.prototype, "h", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelFrame.prototype, "g", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelFrame.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelFrame.prototype, "j", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                this.i = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelFrame.k = function (a, b, c, d) {
            var e = 1 - d;
            a.f = c.f;
            a.g = c.g;
            a.h = c.h;
            a.j = (b.j * e) + (c.j * d);
            var f = b.b.count;
            var g = c.b.count;
            var h = Math.max(f, g);
            if (a.b.count < h) {
                a.b.s(a.b.count, new Array(h - a.b.count));
            }
            if (a.b.count > h) {
                a.b.v(h, a.b.count - h);
            }
            for (var i = 0; i < Math.min(f, g); ++i) {
                a.b._inner[i] = SliceInfo.c(a.b._inner[i], b.b._inner[i], c.b._inner[i], d, e);
            }
            if (f < g) {
                var j = f > 0 ? b.b._inner[f - 1] : new SliceInfo();
                for (var k = f; k < g; ++k) {
                    a.b._inner[k] = SliceInfo.c(a.b._inner[k], j, c.b._inner[k], d, e);
                }
            }
            if (f > g) {
                var l = g > 0 ? c.b._inner[g - 1] : new SliceInfo();
                for (var m = g; m < f; ++m) {
                    a.b._inner[m] = SliceInfo.c(a.b._inner[m], b.b._inner[m], l, d, e);
                }
            }
        };
        FunnelFrame.$t = i2.markType(FunnelFrame, 'FunnelFrame');
        return FunnelFrame;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available actions that can cause an ItemsSource event.
     */
    var ItemsSourceAction = /*@__PURE__*/ (function (ItemsSourceAction) {
        /**
         * One or more rows were removed from the data source.
         */
        ItemsSourceAction[ItemsSourceAction["Remove"] = 0] = "Remove";
        /**
         * One or more rows were added to the data source.
         */
        ItemsSourceAction[ItemsSourceAction["Insert"] = 1] = "Insert";
        /**
         * One or more rows were replaced in the data source.
         */
        ItemsSourceAction[ItemsSourceAction["Replace"] = 2] = "Replace";
        /**
         * An item property value changed in the data source.
         */
        ItemsSourceAction[ItemsSourceAction["Change"] = 3] = "Change";
        /**
         * The entire data source contents were reset.
         */
        ItemsSourceAction[ItemsSourceAction["Reset"] = 4] = "Reset";
        return ItemsSourceAction;
    })({});
    /**
     * @hidden
     */
    var ItemsSourceAction_$type = i2.markEnum('ItemsSourceAction', 'Remove,0|Insert,1|Replace,2|Change,3|Reset,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DataUpdatedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DataUpdatedMessage, _super);
        function DataUpdatedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.e = 0;
            _this.d = 0;
            _this.h = null;
            return _this;
        }
        Object.defineProperty(DataUpdatedMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataUpdatedMessage.prototype, "g", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataUpdatedMessage.prototype, "f", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataUpdatedMessage.prototype, "i", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                this.h = a;
            },
            enumerable: false,
            configurable: true
        });
        DataUpdatedMessage.prototype.toString = function () {
            return "DataUpdatedMessage[" + i2.EnumUtil.getName(ItemsSourceAction_$type, this.c) + "," + this.g.toString() + ", " + this.f.toString() + ", " + this.i.toString() + "]";
        };
        DataUpdatedMessage.$t = i2.markType(DataUpdatedMessage, 'DataUpdatedMessage', ConfigurationMessage.$);
        return DataUpdatedMessage;
    }(ConfigurationMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var UserSelectedItemsChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(UserSelectedItemsChangedMessage, _super);
        function UserSelectedItemsChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(UserSelectedItemsChangedMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        UserSelectedItemsChangedMessage.prototype.toString = function () {
            var a = "UserSelectedItemsChanged[";
            var d = this.c;
            for (var c = 0; c < d.length; c++) {
                var b = d[c];
                a += b.toString();
            }
            a += "]";
            return a;
        };
        UserSelectedItemsChangedMessage.$t = i2.markType(UserSelectedItemsChangedMessage, 'UserSelectedItemsChangedMessage', ConfigurationMessage.$);
        return UserSelectedItemsChangedMessage;
    }(ConfigurationMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LabelSizeChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LabelSizeChangedMessage, _super);
        function LabelSizeChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.d = new i2.Size();
            _this.e = new i2.Size();
            _this.b = false;
            return _this;
        }
        LabelSizeChangedMessage.$t = i2.markType(LabelSizeChangedMessage, 'LabelSizeChangedMessage', InteractionMessage.$);
        return LabelSizeChangedMessage;
    }(InteractionMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FrameRenderCompleteMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FrameRenderCompleteMessage, _super);
        function FrameRenderCompleteMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FrameRenderCompleteMessage.$t = i2.markType(FrameRenderCompleteMessage, 'FrameRenderCompleteMessage', RenderingMessage.$);
        return FrameRenderCompleteMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IntColumn = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IntColumn, _super);
        function IntColumn() {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        IntColumn.prototype.b = function (a) {
            for (var b = 0; b < a; b++) {
                this.a.add(b);
            }
        };
        IntColumn.prototype.c = function (a) {
            this.a.aa(function (b, c) { return a(b, c); });
        };
        IntColumn.prototype.getEnumeratorObject = function () {
            return this.a.getEnumerator();
        };
        IntColumn.$t = i2.markType(IntColumn, 'IntColumn', i2.Base.$, [i2.IEnumerable_$type]);
        return IntColumn;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelSliceDataContext, _super);
        function FunnelSliceDataContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._itemOutline = null;
            return _this;
        }
        Object.defineProperty(FunnelSliceDataContext.prototype, "itemOutline", {
            get: function () {
                return this._itemOutline;
            },
            set: function (a) {
                this._itemOutline = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelSliceDataContext.prototype.flatten = function () {
            var ret_ = _super.prototype.flatten.call(this);
            var itemOutline_ = this.itemOutline;
            ret_.itemOutline = itemOutline_;
            return ret_;
        };
        FunnelSliceDataContext.$t = i2.markType(FunnelSliceDataContext, 'FunnelSliceDataContext', i2.DataContext.$);
        return FunnelSliceDataContext;
    }(i2.DataContext));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ModelUpdateMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ModelUpdateMessage, _super);
        function ModelUpdateMessage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ModelUpdateMessage.$t = i2.markType(ModelUpdateMessage, 'ModelUpdateMessage', Message.$);
        return ModelUpdateMessage;
    }(Message));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceClickedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceClickedMessage, _super);
        function SliceClickedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.d = null;
            _this.f = null;
            return _this;
        }
        Object.defineProperty(SliceClickedMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceClickedMessage.prototype, "item", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceClickedMessage.prototype.toString = function () {
            return "SliceClickedMessage[" + this.c.toString() + ", " + this.item.toString() + "]";
        };
        SliceClickedMessage.$t = i2.markType(SliceClickedMessage, 'SliceClickedMessage', ModelUpdateMessage.$);
        return SliceClickedMessage;
    }(ModelUpdateMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SelectedItemsChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SelectedItemsChangedMessage, _super);
        function SelectedItemsChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(SelectedItemsChangedMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        SelectedItemsChangedMessage.prototype.toString = function () {
            var a = "SelectedItemsChangedMessage[";
            var d = this.c;
            for (var c = 0; c < d.length; c++) {
                var b = d[c];
                a += b.toString();
            }
            a += "]";
            return a;
        };
        SelectedItemsChangedMessage.$t = i2.markType(SelectedItemsChangedMessage, 'SelectedItemsChangedMessage', ModelUpdateMessage.$);
        return SelectedItemsChangedMessage;
    }(ModelUpdateMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceMouseMessageType_$type = i2.markEnum('SliceMouseMessageType', 'Exited,0|Entered,1|Hovered,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceMouseMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceMouseMessage, _super);
        function SliceMouseMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = 0;
            _this.f = null;
            _this.b = 0;
            _this.h = null;
            return _this;
        }
        Object.defineProperty(SliceMouseMessage.prototype, "e", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceMouseMessage.prototype, "item", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SliceMouseMessage.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        SliceMouseMessage.prototype.toString = function () {
            return "SliceMouseMessage[" + this.e.toString() + ", " + this.item.toString() + ", " + i2.EnumUtil.getName(SliceMouseMessageType_$type, this.c) + "]";
        };
        SliceMouseMessage.$t = i2.markType(SliceMouseMessage, 'SliceMouseMessage', ModelUpdateMessage.$);
        return SliceMouseMessage;
    }(ModelUpdateMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelLegendTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelLegendTemplates, _super);
        function FunnelLegendTemplates() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FunnelLegendTemplates.c = function (a) {
            var b = a.data;
            var c = b.series;
            var d = c.legendItemBadgeTemplate;
            var e = b.itemLabel;
            if (e == null) {
                e = "Funnel Item";
            }
            i2.LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
        };
        FunnelLegendTemplates.b = function (a) {
            var b = a.data;
            var c = a.context;
            if (b.itemBrush != null) {
                b.actualItemBrush = b.itemBrush;
            }
            var d = new i2.RenderingContext(new i2.CanvasViewRenderer(), c);
            var e = b.thickness;
            if (i2.isNaN_(e)) {
                e = 1;
            }
            var f = new i2.Rectangle();
            f.width = a.availableWidth - (e * 2) - 2;
            f.height = a.availableHeight - (e * 2);
            f.n = e + 1;
            f.o = e;
            f.ac = e;
            f._fill = b.actualItemBrush;
            f._stroke = b.outline;
            d.v(f);
        };
        FunnelLegendTemplates.a = function (a) {
        };
        FunnelLegendTemplates.d = function (a) {
        };
        FunnelLegendTemplates.$t = i2.markType(FunnelLegendTemplates, 'FunnelLegendTemplates');
        return FunnelLegendTemplates;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelSliceClickedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelSliceClickedEventArgs, _super);
        function FunnelSliceClickedEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.f = null;
            _this.d = null;
            return _this;
        }
        Object.defineProperty(FunnelSliceClickedEventArgs.prototype, "index", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceClickedEventArgs.prototype, "bounds", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceClickedEventArgs.prototype, "item", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelSliceClickedEventArgs.$t = i2.markType(FunnelSliceClickedEventArgs, 'FunnelSliceClickedEventArgs', i2.EventArgs.$);
        return FunnelSliceClickedEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelSliceEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelSliceEventArgs, _super);
        function FunnelSliceEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.f = null;
            _this.d = null;
            return _this;
        }
        Object.defineProperty(FunnelSliceEventArgs.prototype, "index", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceEventArgs.prototype, "bounds", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelSliceEventArgs.prototype, "item", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelSliceEventArgs.$t = i2.markType(FunnelSliceEventArgs, 'FunnelSliceEventArgs', i2.EventArgs.$);
        return FunnelSliceEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelSliceVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelSliceVisualDataList, _super);
        function FunnelSliceVisualDataList() {
            return _super.call(this, FunnelSliceVisualData.$, 0) || this;
        }
        FunnelSliceVisualDataList.$t = i2.markType(FunnelSliceVisualDataList, 'FunnelSliceVisualDataList', i2.List$1.$.specialize(FunnelSliceVisualData.$));
        return FunnelSliceVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FunnelChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FunnelChartVisualData, _super);
        function FunnelChartVisualData() {
            var _this = _super.call(this) || this;
            _this._slices = null;
            _this._name = null;
            _this._viewport = null;
            _this._isInverted = false;
            _this._backgroundColor = null;
            _this._foregroundColor = null;
            _this._opacity = 0;
            _this._borderBrush = null;
            _this._selectedItems = null;
            _this._dipScalingRatio = 0;
            _this.dipScalingRatio = 1;
            _this.slices = new FunnelSliceVisualDataList();
            return _this;
        }
        Object.defineProperty(FunnelChartVisualData.prototype, "slices", {
            get: function () {
                return this._slices;
            },
            set: function (a) {
                this._slices = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "isInverted", {
            get: function () {
                return this._isInverted;
            },
            set: function (a) {
                this._isInverted = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "backgroundColor", {
            get: function () {
                return this._backgroundColor;
            },
            set: function (a) {
                this._backgroundColor = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "foregroundColor", {
            get: function () {
                return this._foregroundColor;
            },
            set: function (a) {
                this._foregroundColor = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "opacity", {
            get: function () {
                return this._opacity;
            },
            set: function (a) {
                this._opacity = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "borderBrush", {
            get: function () {
                return this._borderBrush;
            },
            set: function (a) {
                this._borderBrush = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "selectedItems", {
            get: function () {
                return this._selectedItems;
            },
            set: function (a) {
                this._selectedItems = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FunnelChartVisualData.prototype, "dipScalingRatio", {
            get: function () {
                return this._dipScalingRatio;
            },
            set: function (a) {
                this._dipScalingRatio = a;
            },
            enumerable: false,
            configurable: true
        });
        FunnelChartVisualData.prototype.scaleByViewport = function () {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.slices)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.scaleByViewport(this.viewport);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        FunnelChartVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.name != null) {
                a.u("name: \"" + this.name + "\", ");
            }
            else {
                a.u("name: \"\", ");
            }
            if (this.slices != null && this.slices.count > 0) {
                a.u("slices: [");
                for (var b = 0; b < this.slices.count; b++) {
                    var c = this.slices._inner[b].serialize();
                    a.l(c);
                    if (b < this.slices.count - 1) {
                        a.u(", ");
                    }
                }
                a.u("],");
            }
            a.u("viewport: {");
            a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
            a.u("},");
            a.l("dipScalingRatio: " + this.dipScalingRatio.toString());
            a.u("}");
            return a.toString();
        };
        FunnelChartVisualData.$t = i2.markType(FunnelChartVisualData, 'FunnelChartVisualData');
        return FunnelChartVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var XamFunnelView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamFunnelView, _super);
        function XamFunnelView() {
            var _this = _super.call(this) || this;
            _this.g = null;
            _this.h = null;
            _this.f = null;
            _this.bg = null;
            _this.ad = null;
            _this.ae = null;
            _this.ah = null;
            _this.ai = null;
            _this.ag = null;
            _this.af = null;
            _this.o = null;
            _this.q = null;
            _this.r = null;
            _this.p = null;
            _this.j = null;
            _this.be = null;
            _this.bf = null;
            _this.k = null;
            _this.l = null;
            _this.x = -1;
            _this.y = -1;
            _this.z = -1;
            _this.u = 0;
            _this.v = 0;
            _this.aj = null;
            _this.c = null;
            _this.e = null;
            _this.t = 1;
            _this.w = NaN;
            _this.t = 1;
            _this.w = NaN;
            _this.f = new MessageChannel();
            _this.a9();
            _this.a8();
            var a = _this.g = new MessageHandler();
            a.b(ClearMessage.$, i2.runOn(_this, _this.ap));
            a.b(RenderSliceMessage.$, i2.runOn(_this, _this.a6));
            a.b(RenderOuterLabelMessage.$, i2.runOn(_this, _this.a5));
            a.b(SetAreaSizeMessage.$, i2.runOn(_this, _this.ba));
            a.b(TooltipValueChangedMessage.$, i2.runOn(_this, _this.bc));
            a.b(TooltipUpdateMessage.$, i2.runOn(_this, _this.bb));
            a.b(ClearTooltipMessage.$, i2.runOn(_this, _this.ar));
            a.b(PropertyChangedMessage.$, i2.runOn(_this, _this.a3));
            a.b(ContainerSizeChangedMessage.$, function (b) { return _this.as(); });
            _this.as();
            return _this;
        }
        Object.defineProperty(XamFunnelView.prototype, "i", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.h;
                this.h = a;
                this.a1(b, this.h);
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelView.prototype.am = function (a) {
            this.f.i(new MouseLeaveMessage());
        };
        XamFunnelView.prototype.an = function (a, b, c) {
            var d = new MouseMoveMessage();
            d.c = a;
            this.f.i(d);
        };
        XamFunnelView.prototype.al = function (a) {
            var b = new MouseButtonMessage();
            b.h = a;
            b.c = 1;
            b.e = this.j.ai ? 1 : 0;
            b.f = this.j.bd;
            this.f.i(b);
        };
        XamFunnelView.prototype.ao = function (a) {
            var b = new MouseButtonMessage();
            b.h = a;
            b.c = 0;
            b.e = this.j.ai ? 1 : 0;
            b.f = this.j.bd;
            this.f.i(b);
        };
        XamFunnelView.prototype.ap = function (a) {
            var b = this.bg;
            if (i2.Rect.l_op_Equality(b, null)) {
                return;
            }
            var c = b.left, d = b.top, e = b.width, f = b.height;
            this.aq(this.q, c, d, e, f);
            this.aq(this.o, c, d, e, f);
            this.aq(this.p, c, d, e, f);
            this.aq(this.r, c, d, e, f);
        };
        XamFunnelView.prototype.aq = function (a, b, c, d, e) {
            if (a != null) {
                if (a.d && this.t != 1) {
                    a.z();
                    a.aa(this.t, this.t);
                }
                a.k(b, c, d, e);
                if (a.d && this.t != 1) {
                    a.y();
                }
            }
        };
        XamFunnelView.prototype.ba = function (a) {
            var b = a.m;
            var c = a.e;
            if (c == "LeftPanel") {
                this.u = b;
            }
            if (c == "RightPanel") {
                this.v = b;
            }
        };
        XamFunnelView.prototype.a6 = function (a) {
            var b = a.g;
            var c = this.q;
            if (c.d && this.t != 1) {
                c.z();
                c.aa(this.t, this.t);
            }
            var d = new i2.Polygon();
            var e = new i2.PointCollection(0);
            for (var f = 0; f < b.au.count; f++) {
                var g = b.au._inner[f];
                e.add({ $type: i2.Point_$type, x: g.x + this.u + b.aq.x, y: g.y + b.aq.y });
            }
            d.ak = e;
            d.ac = a.h;
            d._opacity = b.p;
            d._fill = b.ad;
            d._stroke = a.h < 1 ? b.ad : b.ag;
            if (b.a0 != null) {
                c.i(d, b.a0);
                b.ad = d._fill;
                b.ag = d._stroke;
                b.q = d.ac;
                b.p = d._opacity;
            }
            c.t(d);
            b.q = d.ac;
            if (b.i) {
                var h = new i2.TextBlock();
                if (this.bf == null) {
                    this.bf = new i2.Brush();
                    this.bf._fill = this.ak("ui-funnel-slice", "color", -1);
                }
                h.am = this.bf;
                c.ac(this.m());
                var i = b.v.toString();
                var j = c.f(i);
                var k = this.ab();
                h.ak = i;
                h.o = b.an.y + b.aq.y - (k / 2);
                h.n = b.an.x + this.u + b.aq.x - (j / 2);
                b.ax = new i2.Rect(0, h.n, h.o, j, k);
                b.a2 = h._visibility;
                c.w(h);
            }
            if (c.d && this.t != 1) {
                c.y();
            }
        };
        XamFunnelView.prototype.a5 = function (a) {
            var b = 0;
            if (this.v > 0) {
                b = this.bg.width - this.v;
            }
            var c = a;
            var d = this.p;
            if (d.d && this.t != 1) {
                d.z();
                d.aa(this.t, this.t);
            }
            var e = new i2.TextBlock();
            e.ak = c.j.toString();
            d.ac(this.n());
            if (this.be == null) {
                this.be = new i2.Brush();
                this.be._fill = this.ad.rootWrapper.getStyleProperty("color");
            }
            e.am = this.be;
            var f = this.ac();
            var g = c.l.y - f / 2;
            var h = d.f(e.ak);
            e.n = b;
            e.o = g;
            c.f.b.ay = new i2.Rect(0, b, g, h, f);
            d.w(e);
            if (d.d && this.t != 1) {
                d.y();
            }
        };
        XamFunnelView.prototype.az = function () {
            if (this.j != null) {
                this.j.bc(this.ae, "");
            }
        };
        XamFunnelView.prototype.ax = function (a) {
            this.av(a);
            if (this.j != null) {
                this.j.aq(this.ae, "");
            }
        };
        XamFunnelView.prototype.bc = function (a) {
            this.aj = a.g;
        };
        XamFunnelView.prototype.bb = function (a) {
            this.at(a);
        };
        XamFunnelView.prototype.ar = function (a) {
            this.at(null);
        };
        XamFunnelView.prototype.at = function (a) {
            var x_ = 0, y_ = 0;
            var t_ = null, v_ = null, i_ = this.ad;
            {
                if (a != null) {
                    t_ = this.aj;
                    x_ = a.i.x + 6;
                    y_ = a.i.y + 6;
                    v_ = a.g.item;
                }
                var ren_ = this.ad;
                var dc_ = null;
                if (a != null) {
                    dc_ = a.g;
                }
                if (dc_ == null) {
                    dc_ = new FunnelDataContext();
                }
                dc_.item = v_;
                var tt_ = this.aj;
                if (tt_ != null) {
                    if (v_ != null) {
                        tt_.updateToolTip(dc_);
                        tt_.setRawPosition(x_, y_);
                    }
                    else {
                        tt_.hideToolTip();
                    }
                }
            }
        };
        XamFunnelView.prototype.a3 = function (a) {
            var b = a;
            var c = b.g;
            switch (c) {
                case "Container":
                    this.ay(b.d);
                    break;
                case "TextStyle":
                    this.l = i2.FontUtil.toFontInfo(this.ad, b.d.toString());
                    break;
                case "OuterLabelTextStyle":
                    this.k = i2.FontUtil.toFontInfo(this.ad, b.d.toString());
                    break;
                case "ActualPixelScalingRatio":
                    if (i2.isNaN_(this.w) || this.w == 0) {
                        this.t = b.d;
                    }
                    break;
                case "OuterLabelTextColor":
                    this.be = i2.typeCast(i2.Brush.$, b.d);
                    break;
                case "LabelTextColor":
                    this.bf = i2.typeCast(i2.Brush.$, b.d);
                    break;
            }
        };
        XamFunnelView.prototype.a4 = function (a) {
            if (this.ad != null) {
                this.ad.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        };
        XamFunnelView.prototype.ay = function (a) {
            if (a == null) {
                if (this.j != null) {
                    this.j.ar();
                }
                this.ad = null;
                this.ae = this.ah = this.ag = this.ai = null;
                this.o = this.q = this.p = this.r = null;
                this.j = null;
                return;
            }
            var b = a;
            var c = this.ad = b;
            c.rootWrapper.setStyleProperty("position", "relative");
            for (var d = 0; d < 4; d++) {
                var e = this.ad.createElement("canvas");
                e.setStyleProperty("position", "absolute");
                c.append(e);
                var f = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ad.get2DCanvasContext(e));
                if (d == 0) {
                    this.ae = e;
                    this.o = f;
                }
                if (d == 1) {
                    this.ah = e;
                    this.q = f;
                }
                if (d == 2) {
                    this.ag = e;
                    this.p = f;
                }
                if (d == 3) {
                    this.ai = e;
                    this.r = f;
                }
            }
            this.af = this.ad.createElement("span");
            this.af.setStyleProperty("position", "absolute");
            this.af.setStyleProperty("display", "none");
            c.append(this.af);
            this.j = new i2.DOMEventProxy(this.ai, this.ad, false);
            var g = this.j;
            g.onMouseOver = i2.delegateCombine(g.onMouseOver, i2.runOn(this, this.an));
            var h = this.j;
            h.onMouseLeave = i2.delegateCombine(h.onMouseLeave, i2.runOn(this, this.am));
            var i = this.j;
            i.onMouseDown = i2.delegateCombine(i.onMouseDown, i2.runOn(this, this.al));
            var j = this.j;
            j.onMouseUp = i2.delegateCombine(j.onMouseUp, i2.runOn(this, this.ao));
            this.as();
        };
        XamFunnelView.prototype.aa = function () {
            var a = this.ak("ui-funnel-slice", "border-top-width", -1);
            return (a == null) ? -1 : parseInt(a);
        };
        XamFunnelView.prototype.m = function () {
            var a = this.l;
            if (a == null) {
                this.l = i2.FontUtil.getFontForClass(this.ad, "ui-funnel-slice");
                a = this.l;
            }
            return a;
        };
        XamFunnelView.prototype.n = function () {
            var a = this.k;
            if (a == null) {
                this.k = a = i2.FontUtil.getFont(this.ad);
            }
            return a;
        };
        XamFunnelView.prototype.ab = function () {
            var a = this.z;
            if (a < 0) {
                var b = this.l;
                a = i2.FontUtil.getCurrentFontHeight(this.ad, b);
                this.z = a;
            }
            return a;
        };
        XamFunnelView.prototype.ac = function () {
            var a = this.y;
            if (a < 0) {
                var b = this.k;
                a = i2.FontUtil.getCurrentFontHeight(this.ad, b);
                this.y = a;
            }
            return a;
        };
        XamFunnelView.prototype.d = function (a) {
            if (this.c != null) {
                return a ? this.c : this.e;
            }
            var b = i2.BrushUtil.e("chart", this.ad, this.c, this.e);
            this.c = b.p2;
            this.e = b.p3;
            return a ? this.c : this.e;
        };
        XamFunnelView.prototype.ak = function (a, b, c) {
            var d = this.af;
            if (d == null) {
                return null;
            }
            d.addClass(a);
            var e = d.getStyleProperty(b);
            if (e == null || e.length == 0 || e == "null" || e == "transparent") {
                e = null;
            }
            if (c >= 0) {
                var f = new i2.Brush();
                if (e != null && e.length != i2.stringReplace(e, "(0, 0, 0, 0", "").length) {
                    e = null;
                }
                f._fill = e == null ? XamFunnelView.a[c % XamFunnelView.a.length] : e;
                this.c.item(c, f);
                var g = null;
                if (e != null) {
                    g = d.getStyleProperty("border-top-color");
                    if (g == null || g.length == 0 || g == "null" || g == "transparent") {
                        g = e;
                    }
                }
                f = new i2.Brush();
                f._fill = (g == null) ? XamFunnelView.b[c % XamFunnelView.b.length] : g;
                this.e.item(c, f);
            }
            d.removeClass(a);
            return e;
        };
        XamFunnelView.prototype.a7 = function (a, b, c) {
            var d = new PropertyChangedMessage();
            d.g = a;
            d.e = b;
            d.d = c;
            this.f.i(d);
        };
        XamFunnelView.prototype.av = function (a) {
            var b = a.bs;
            var c = a.bn;
            if (!i2.isNaN_(b) && b != 0) {
                return;
            }
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
                a.bn = window.devicePixelRatio;
            }
        };
        XamFunnelView.prototype.aw = function (a) {
            this.g.c(a);
        };
        XamFunnelView.prototype.a1 = function (a, b) {
            if (a != null) {
                var c = i2.typeCast(MessageChannel.$, a.b("RenderingMessages"));
                if (c != null) {
                    c.h(i2.runOn(this, this.aw));
                }
                this.f.g();
            }
            if (b != null) {
                var d = i2.typeCast(MessageChannel.$, b.b("RenderingMessages"));
                if (d != null) {
                    d.e(i2.runOn(this, this.aw));
                }
                var e = i2.typeCast(MessageChannel.$, b.b("InteractionMessages"));
                this.f.f(e);
            }
        };
        XamFunnelView.prototype.bd = function (a, b, c, d, e) {
            a.setAttribute("width", b.toString());
            a.setAttribute("height", c.toString());
            a.setStyleProperty("width", d.toString() + "px");
            a.setStyleProperty("height", e.toString() + "px");
        };
        XamFunnelView.prototype.as = function () {
            if (this.ad == null) {
                return;
            }
            var a = this.ad.rootWrapper.width();
            var b = this.ad.rootWrapper.height();
            this.bg = new i2.Rect(0, 0, 0, a, b);
            if (this.j != null) {
                this.j.bg = this.bg;
            }
            this.bd(this.ae, a * this.t, b * this.t, a, b);
            this.bd(this.ah, a * this.t, b * this.t, a, b);
            this.bd(this.ag, a * this.t, b * this.t, a, b);
            this.bd(this.ai, a * this.t, b * this.t, a, b);
            var c = new ViewportChangedMessage();
            c.e = a;
            c.d = b;
            this.f.i(c);
        };
        XamFunnelView.prototype.a0 = function () {
            this.as();
        };
        XamFunnelView.prototype.a9 = function () {
            var a = new ViewPropertyChangedMessage();
            a.g = "OuterLabelWidthDecider";
            a.e = null;
            a.d = i2.typeCast(IOuterLabelWidthDecider_$type, this);
            this.f.i(a);
        };
        XamFunnelView.prototype.a8 = function () {
            var a = new ViewPropertyChangedMessage();
            a.g = "FunnelLabelSizeDecider";
            a.e = null;
            a.d = i2.typeCast(IFunnelLabelSizeDecider_$type, this);
            this.f.i(a);
        };
        XamFunnelView.prototype.decideWidth = function (a) {
            var e_1, _a;
            var b = a == null ? null : a.a;
            if (b == null) {
                return 0;
            }
            var c = 0;
            this.p.ac(this.n());
            try {
                for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (d != null) {
                        c = Math.max(this.p.f(d.toString()), c);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return c;
        };
        XamFunnelView.prototype.decideLabelSize = function (a, b) {
            var c = 0;
            if (a.b.i) {
                this.p.ac(this.m());
                c = this.p.f(a.b.v.toString());
            }
            return new i2.Size(1, c, b ? this.ab() : this.ac());
        };
        XamFunnelView.prototype.s = function (a, f_) {
            if (f_ == null) {
                return true;
            }
            var b = a.a;
            var c_ = this.ad;
            c_ = c_ ? c_.data('igFunnelChart') : null;
            if (b == null || c_ == null) {
                return false;
            }
            var i_ = b.count;
            var c = new Array(i_);
            while (i_-- > 0) {
                var v_ = b.item(i_);
                c[i_] = f_(v_, i_, c_);
            }
            a.b(c);
            return true;
        };
        XamFunnelView.prototype.au = function () {
        };
        XamFunnelView.prototype.a2 = function () {
        };
        XamFunnelView.$t = i2.markType(XamFunnelView, 'XamFunnelView', i2.Base.$, [IOuterLabelWidthDecider_$type, IFunnelLabelSizeDecider_$type]);
        XamFunnelView.a = ["#7000ff", "#70ff00", "#00f0f0", "#ff0070", "#ff00ff"];
        XamFunnelView.b = ["#7000dd", "#70dd00", "#00d0d0", "#dd0070", "#dd00dd"];
        return XamFunnelView;
    }(i2.Base));
    /**
     * @hidden
     */
    var XamFunnelController = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamFunnelController, _super);
        function XamFunnelController() {
            var _this = _super.call(this) || this;
            _this.bp = null;
            _this.ag = null;
            _this.at = null;
            _this.cf = null;
            _this.cg = null;
            _this.cb = null;
            _this.cc = null;
            _this.bb = false;
            _this.bg = false;
            _this.au = null;
            _this.aj = null;
            _this.z = null;
            _this.al = null;
            _this.ao = null;
            _this.ap = null;
            _this.cl = null;
            _this.ci = null;
            _this.ch = null;
            _this.a4 = false;
            _this.bv = 0;
            _this.bu = 0;
            _this.w = null;
            _this.v = null;
            _this.t = null;
            _this.p = null;
            _this.a0 = false;
            _this.a3 = false;
            _this.bt = 0;
            _this.a2 = false;
            _this.bq = 0;
            _this.a = null;
            _this.b = null;
            _this.ad = 0;
            _this.m = 0;
            _this.ax = false;
            _this.bs = 0;
            _this.a5 = false;
            _this.dv = null;
            _this.du = null;
            _this.aw = false;
            _this.b5 = 0;
            _this.b6 = 0;
            _this.r = null;
            _this.ab = null;
            _this.ah = null;
            _this.g = null;
            _this.e = null;
            _this.f = null;
            _this.d0 = null;
            _this.d1 = null;
            _this.a7 = false;
            _this.a1 = false;
            _this.a6 = false;
            _this.az = false;
            _this.ck = null;
            _this.cj = null;
            _this.br = -1;
            _this.ay = false;
            _this.l = null;
            _this.o = null;
            _this.dp = null;
            _this.dn = null;
            _this.dz = null;
            _this.av = new i2.DoubleAnimator(0, 1, 2000);
            var a = _this.av;
            a.propertyChanged = i2.delegateCombine(a.propertyChanged, i2.runOn(_this, _this.cz));
            _this.k = new FunnelFrame();
            _this.j = new FunnelFrame();
            _this.h = new FunnelFrame();
            _this.ai = new SliceSelectionManager();
            _this.am = new DoubleColumn();
            _this.ar = new ObjectColumn();
            _this.as = new ObjectColumn();
            _this.y = new MessageChannel();
            _this.x = new MessageChannel();
            _this.aa = new MessageHandler();
            _this.aa.b(PropertyChangedMessage.$, i2.runOn(_this, _this.de));
            _this.aa.b(DataUpdatedMessage.$, i2.runOn(_this, _this.cv));
            _this.aa.b(ViewportChangedMessage.$, i2.runOn(_this, _this.dl));
            _this.aa.b(ViewPropertyChangedMessage.$, i2.runOn(_this, _this.dm));
            _this.aa.b(MouseMoveMessage.$, i2.runOn(_this, _this.c5));
            _this.aa.b(MouseButtonMessage.$, i2.runOn(_this, _this.c3));
            _this.aa.b(MouseLeaveMessage.$, i2.runOn(_this, _this.c4));
            _this.aa.b(UserSelectedItemsChangedMessage.$, i2.runOn(_this, _this.dk));
            _this.aa.b(LabelSizeChangedMessage.$, i2.runOn(_this, _this.c1));
            _this.aa.b(ContainerSizeChangedMessage.$, function (b) { return _this.y.i(b); });
            _this.bp = function (b, c) {
                _this.bj = true;
                _this.df();
            };
            return _this;
        }
        XamFunnelController.prototype.cz = function (a, b) {
            this.b2 = this.av.o;
            if (this.b2 == 1) {
                this.a9 = false;
                this.cw(this.h);
            }
            if (this.a9) {
                var c = 1 - this.b2;
                FunnelFrame.k(this.j, this.k, this.h, this.b2);
                this.cw(this.j);
            }
        };
        Object.defineProperty(XamFunnelController.prototype, "av", {
            get: function () {
                return this.au;
            },
            set: function (a) {
                this.au = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ak", {
            get: function () {
                return this.aj;
            },
            set: function (a) {
                this.aj = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "aa", {
            get: function () {
                return this.z;
            },
            set: function (a) {
                this.z = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "am", {
            get: function () {
                return this.al;
            },
            set: function (a) {
                this.al = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ar", {
            get: function () {
                if (!this.bb && this.at != null) {
                    this.bb = this.at.s(this.ao, this.cb);
                }
                return this.ao;
            },
            set: function (a) {
                this.ao = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "as", {
            get: function () {
                if (!this.bg && this.at != null) {
                    this.bg = this.at.s(this.ap, this.cc);
                }
                return this.ap;
            },
            set: function (a) {
                this.ap = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "cq", {
            get: function () {
                return this.cl;
            },
            set: function (a) {
                this.cl = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "cn", {
            get: function () {
                return this.ci;
            },
            set: function (a) {
                this.ci = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "cm", {
            get: function () {
                return this.ch;
            },
            set: function (a) {
                this.ch = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bj", {
            get: function () {
                return this.a4;
            },
            set: function (a) {
                this.a4 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "b4", {
            get: function () {
                return this.bv;
            },
            set: function (a) {
                this.bv = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "b3", {
            get: function () {
                return this.bu;
            },
            set: function (a) {
                this.bu = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "y", {
            get: function () {
                return this.w;
            },
            set: function (a) {
                this.w = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "x", {
            get: function () {
                return this.v;
            },
            set: function (a) {
                this.v = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "u", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                this.t = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "q", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                this.p = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bc", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                this.a0 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bh", {
            get: function () {
                return this.a3;
            },
            set: function (a) {
                this.a3 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "b2", {
            get: function () {
                return this.bt;
            },
            set: function (a) {
                this.bt = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "be", {
            get: function () {
                return this.a2;
            },
            set: function (a) {
                this.a2 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bw", {
            get: function () {
                return this.bq;
            },
            set: function (a) {
                this.bq = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "c", {
            get: function () {
                if ((this.a == null || this.a.count < 1) && this.at != null) {
                    this.a = this.at.d(true);
                }
                return this.a;
            },
            set: function (a) {
                this.a = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "d", {
            get: function () {
                if ((this.b == null || this.b.count < 1) && this.at != null) {
                    this.b = this.at.d(false);
                }
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ae", {
            get: function () {
                return this.ad;
            },
            set: function (a) {
                this.ad = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "n", {
            get: function () {
                return this.m;
            },
            set: function (a) {
                this.m = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "a9", {
            get: function () {
                return this.ax;
            },
            set: function (a) {
                this.ax = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "b1", {
            get: function () {
                return this.bs;
            },
            set: function (a) {
                this.bs = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bm", {
            get: function () {
                return this.a5;
            },
            set: function (a) {
                this.a5 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "dy", {
            get: function () {
                return this.dv;
            },
            set: function (a) {
                this.dv = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "dx", {
            get: function () {
                return this.du;
            },
            set: function (a) {
                this.du = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "a8", {
            get: function () {
                return this.aw;
            },
            set: function (a) {
                this.aw = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "b9", {
            get: function () {
                return this.b5;
            },
            set: function (a) {
                this.b5 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ca", {
            get: function () {
                return this.b6;
            },
            set: function (a) {
                this.b6 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "s", {
            get: function () {
                return this.r;
            },
            set: function (a) {
                this.r = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ac", {
            get: function () {
                return this.ab;
            },
            set: function (a) {
                var b = this.ab;
                this.ab = a;
                this.c7(b, this.ab);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ai", {
            get: function () {
                return this.ah;
            },
            set: function (a) {
                this.ah = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "k", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "h", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "j", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "d3", {
            get: function () {
                return this.d0;
            },
            set: function (a) {
                this.d0 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "d4", {
            get: function () {
                return this.d1;
            },
            set: function (a) {
                this.d1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bo", {
            get: function () {
                return this.a7;
            },
            set: function (a) {
                this.a7 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bd", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                this.a1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bn", {
            get: function () {
                return this.a6;
            },
            set: function (a) {
                this.a6 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "ba", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                this.az = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "cp", {
            get: function () {
                return this.ck;
            },
            set: function (a) {
                this.ck = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "co", {
            get: function () {
                return this.cj;
            },
            set: function (a) {
                this.cj = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "bz", {
            get: function () {
                var a = this.br;
                if (a < 0 && this.at != null) {
                    this.br = this.at.aa();
                    a = this.br;
                }
                return a < 0 ? 1 : a;
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelController.prototype.c7 = function (a, b) {
            if (a != null) {
                var c = i2.typeCast(MessageChannel.$, a.b("ConfigurationMessages"));
                if (c != null) {
                    c.h(i2.runOn(this, this.c2));
                }
                c = i2.typeCast(MessageChannel.$, a.b("InteractionMessages"));
                if (c != null) {
                    c.h(i2.runOn(this, this.c2));
                }
                this.y.g();
                this.x.g();
            }
            if (b != null) {
                var d = i2.typeCast(MessageChannel.$, b.b("ConfigurationMessages"));
                if (d != null) {
                    d.e(i2.runOn(this, this.c2));
                }
                d = i2.typeCast(MessageChannel.$, b.b("InteractionMessages"));
                if (d != null) {
                    d.e(i2.runOn(this, this.c2));
                }
                var e = i2.typeCast(MessageChannel.$, b.b("RenderingMessages"));
                this.y.f(e);
                var f = i2.typeCast(MessageChannel.$, b.b("ModelUpdateMessages"));
                this.x.f(f);
            }
            this.bj = true;
        };
        XamFunnelController.prototype.c2 = function (a) {
            this.aa.c(a);
            var b = i2.typeCast(RenderingMessage.$, a);
            if (b != null) {
                this.bj = b.c;
            }
            this.df();
        };
        XamFunnelController.prototype.bl = function () {
            return this.b3 >= 0 && this.b4 >= 0;
        };
        XamFunnelController.prototype.bf = function () {
            return this.am != null && this.am.a != null && this.am.a.count > 0 && this.u != null && this.q != null && this.c != null && this.c.count > 0 && this.d != null && this.d.count > 0 && this.bl();
        };
        XamFunnelController.prototype.df = function () {
            if (!this.bj) {
                return;
            }
            if (!this.bf()) {
                this.cu();
                return;
            }
            this.bj = false;
            var a = this.u.decideWidth(this.aq());
            if (a > this.b4) {
                a = 0;
            }
            if (!this.bh) {
                a = 0;
            }
            var b = this.b4 - a;
            var c = a > 0;
            var d = this.bc;
            var e = b >= 0;
            if (e || c) {
                this.dc(e, c, d, b, a);
            }
        };
        XamFunnelController.prototype.cu = function () {
            if (this.bk() && this.b2 > 0) {
                this.av.w();
            }
            this.dh("LeftLabels");
            this.dh("RightLabels");
            this.dh("SliceArea");
            this.ct();
            this.h.b.clear();
            this.j.b.clear();
            this.k.b.clear();
        };
        XamFunnelController.prototype.ct = function () {
            var a = new FrameRenderCompleteMessage();
            this.y.i(a);
        };
        XamFunnelController.prototype.dc = function (a, b, c, d, e) {
            if (this.a9) {
                var f = this.k;
                this.k = this.j;
                this.j = f;
            }
            else {
                var g = this.k;
                this.k = this.h;
                this.h = g;
            }
            this.dd(this.h, a, b, c, d, e);
            this.av.w();
            this.b2 = 0;
            if (this.bk()) {
                FunnelFrame.k(this.j, this.k, this.h, this.b2);
                this.cw(this.j);
                this.a9 = true;
                this.av.v();
            }
            else {
                this.cw(this.h);
            }
        };
        XamFunnelController.prototype.b0 = function (a) {
            if (i2.isNaN_(a)) {
                return 0;
            }
            return Math.abs(a);
        };
        XamFunnelController.prototype.dd = function (a, b, c, d, e, f) {
            var e_2, _a, e_3, _b;
            var g = e / 2;
            this.ay = this.bm;
            if (this.ay) {
                this.c0(e, g);
            }
            else {
                this.ak = null;
            }
            var h = this.n == 1;
            var i = this.an();
            var j = 0;
            try {
                for (var _c = tslib.__values(i2.fromEnum(i.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var k = _d.value;
                    j += this.b0(this.am.a.item(k));
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            if (j == 0) {
                h = false;
            }
            var l = this.b3 / i.a.count;
            var m = 0;
            var n = 0;
            n = this.bz / 2;
            a.j = f;
            a.f = d;
            a.h = c;
            a.g = this.ae == 0;
            a.b = new SliceInfoList();
            var o = 0;
            try {
                for (var _e = tslib.__values(i2.fromEnum(i.a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var p = _f.value;
                    var q = void 0;
                    if (h) {
                        q = (this.b0(this.am.a.item(p)) / j) * this.b3;
                    }
                    else {
                        q = l;
                    }
                    var r = this.by(e, m + n);
                    var s = m + q;
                    var t = this.by(e, s - n);
                    var u = r / 2;
                    var v = t / 2;
                    var w = new SliceInfo();
                    var x = w.b;
                    x.o = m;
                    x.n = s;
                    var y = new i2.Rect(4);
                    var z = new i2.Rect(4);
                    var aa = 0;
                    if (v > u) {
                        aa = g - v;
                    }
                    else {
                        aa = g - u;
                    }
                    var ab = m;
                    x.ad = this.ds(p);
                    x.ag = this.dt(p);
                    x.a0 = this.d2(p);
                    x.j = this.ai.c(p);
                    if (b) {
                        w.h = true;
                        x.ar = { $type: i2.Point_$type, x: g - u - aa + n, y: m - ab + n };
                        x.as = { $type: i2.Point_$type, x: g + u - aa - n, y: m - ab + n };
                        x.ao = { $type: i2.Point_$type, x: g - v - aa + n, y: s - ab - n };
                        x.ap = { $type: i2.Point_$type, x: g + v - aa - n, y: s - ab - n };
                        if (this.ay) {
                            this.cr(x, m + n, s - n, g, aa - n, ab);
                        }
                        x.x();
                    }
                    if (d) {
                        x.i = true;
                        x.an = { $type: i2.Point_$type, x: g - aa, y: (m + s) / 2 - ab };
                        x.v = this.cd(p);
                        var ac = this.q.decideLabelSize(w, true);
                        if (ac.width > e) {
                            x.i = false;
                        }
                        if (ac.height > q) {
                            x.i = false;
                        }
                        y.height = ac.height;
                        y.width = ac.width;
                        y.x = x.an.x;
                        y.y = x.an.y;
                        x.ax = y;
                    }
                    else {
                        x.i = false;
                        x.v = this.cd(p);
                    }
                    if (d || b) {
                        x.aq = { $type: i2.Point_$type, x: aa, y: ab };
                        x.item = this.am.a.item(p);
                        x.s = p;
                    }
                    if (c) {
                        w.g = true;
                        w.n = { $type: i2.Point_$type, x: 0, y: (m + s) / 2 };
                        w.l = this.ce(p);
                        var ad = this.q.decideLabelSize(w, false);
                        if (ad.height > q) {
                            w.g = false;
                        }
                        z.height = ad.height;
                        z.width = ad.width;
                        y.x = w.n.x;
                        y.y = w.n.y;
                        x.ay = z;
                    }
                    else {
                        w.g = false;
                        w.l = this.ce(p);
                    }
                    w.j = p;
                    a.b.add(w);
                    m += q;
                    o++;
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            if ((this.ar != null && this.ar.a != null && this.ar.a.count > 0) || (this.as != null && this.as.a != null && this.as.a.count > 0)) {
                this.dg(a);
            }
            a.b.ae();
        };
        XamFunnelController.prototype.cr = function (a, b, c, d, e, f) {
            var g = this.ak.b(b);
            var h = this.ak.b(c);
            var i = new PointList();
            var j = new PointList();
            var k = g.b;
            var l = h.b;
            for (var m = k; m <= l; m++) {
                i.add({ $type: i2.Point_$type, x: this.ak.e._inner[m].c.x - e, y: this.ak.e._inner[m].c.y - f });
            }
            e += this.bz;
            for (var n = l; n >= k; n--) {
                var o = this.ak.e._inner[n].c;
                j.add({ $type: i2.Point_$type, x: d + d - o.x - e, y: o.y - f });
            }
            a.c = i;
            a.e = j;
        };
        XamFunnelController.prototype.bi = function (a, b) {
            if (a.x != b.x || a.y != b.y) {
                return true;
            }
            return false;
        };
        XamFunnelController.prototype.c0 = function (a, b) {
            var c;
            var d;
            var e = 0, f = this.b3;
            e = this.bz / 2;
            f -= e;
            if (this.bd) {
                c = { $type: i2.Point_$type, x: b - (a * this.bw / 2), y: e };
                d = { $type: i2.Point_$type, x: b - (a / 2), y: f };
            }
            else {
                c = { $type: i2.Point_$type, x: b - (a / 2), y: e };
                d = { $type: i2.Point_$type, x: b - (a * this.bw / 2), y: f };
            }
            var g = this.dy.y < this.dx.y ? this.dy : this.dx;
            var h = this.dx.y > this.dy.y ? this.dx : this.dy;
            if (g.y < 0) {
                g.y = 0;
            }
            if (h.y > 1) {
                h.y = 1;
            }
            if (this.bd) {
                var i = h.x;
                h.x = g.x;
                g.x = i;
                i = g.y;
                g.y = 1 - h.y;
                h.y = 1 - i;
            }
            var j = { $type: i2.Point_$type, x: a * g.x, y: this.b3 * g.y };
            var k = { $type: i2.Point_$type, x: a * h.x, y: this.b3 * h.y };
            if (this.ak == null || this.bi(c, this.ak.q) || this.bi(j, this.ak.r) || this.bi(k, this.ak.s) || this.bi(d, this.ak.t)) {
                this.ak = new Bezier(c, j, k, d, 2, b);
            }
            if (this.ak == null) {
                this.ay = false;
            }
            else {
                this.ay = this.ak.d;
            }
        };
        XamFunnelController.prototype.ce = function (a) {
            var b = this.as;
            var c = b == null ? null : b.a;
            return c == null || a >= c.count ? null : c.item(a);
        };
        XamFunnelController.prototype.cd = function (a) {
            var b = this.ar;
            var c = b == null ? null : b.a;
            return c == null || a >= c.count ? null : c.item(a);
        };
        XamFunnelController.prototype.d2 = function (a) {
            if (this.ai.c(a)) {
                return this.d3;
            }
            if (this.ai.d(a) && this.bo) {
                return this.d4;
            }
            return null;
        };
        XamFunnelController.prototype.dt = function (a) {
            return this.d.item(a % this.d.count);
        };
        XamFunnelController.prototype.ds = function (a) {
            return this.c.item(a % this.c.count);
        };
        XamFunnelController.prototype.by = function (a, b) {
            var c = a * this.bw;
            if (this.ay) {
                var d = this.ak.b(b).c.x;
                return ((a / 2) - d) * 2;
            }
            else {
                if (this.bd) {
                    return a - ((a - c) * ((this.b3 - b) / this.b3));
                }
                else {
                    return a - ((a - c) * (b / this.b3));
                }
            }
        };
        XamFunnelController.prototype.an = function () {
            var _this = this;
            var a = new IntColumn();
            a.b(this.am.a.count);
            a.c(function (b, c) {
                if (_this.am.a.item(b) < _this.am.a.item(c)) {
                    return _this.bd ? -1 : 1;
                }
                if (_this.am.a.item(b) > _this.am.a.item(c)) {
                    return _this.bd ? 1 : -1;
                }
                return 0;
            });
            return a;
        };
        XamFunnelController.prototype.cw = function (a) {
            this.cx(a);
        };
        XamFunnelController.prototype.cy = function () {
            if (this.l != null) {
                this.cx(this.l);
            }
        };
        XamFunnelController.prototype.cx = function (a) {
            var e_4, _a, e_5, _b;
            this.dh("LeftLabels");
            this.dh("RightLabels");
            this.dh("SliceArea");
            if (a.g) {
                this.di("LeftPanel", a.j);
                this.di("RightPanel", 0);
            }
            else {
                this.di("LeftPanel", 0);
                this.di("RightPanel", a.j);
            }
            this.ag = a.b;
            try {
                for (var _c = tslib.__values(i2.fromEnum(a.b)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    if (b.h) {
                        var c = new RenderSliceMessage();
                        c.e = "SliceArea";
                        c.g = b.b;
                        c.h = this.bz;
                        this.y.i(c);
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(a.b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    if (d.g) {
                        var e = new RenderOuterLabelMessage();
                        if (a.g) {
                            e.e = "LeftLabels";
                        }
                        else {
                            e.e = "RightLabels";
                        }
                        e.j = d.l;
                        e.l = d.n;
                        e.h = a.j;
                        e.f = d;
                        this.y.i(e);
                    }
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            var f = new FrameRenderCompleteMessage();
            this.y.i(f);
        };
        XamFunnelController.prototype.di = function (a, b) {
            var c = new SetAreaSizeMessage();
            c.e = a;
            c.i = true;
            c.m = b;
            this.y.i(c);
        };
        XamFunnelController.prototype.bk = function () {
            return this.b1 > 0;
        };
        XamFunnelController.prototype.dh = function (a) {
            var b = new ClearMessage();
            b.e = a;
            this.y.i(b);
        };
        XamFunnelController.prototype.aq = function () {
            return this.as;
        };
        XamFunnelController.prototype.cv = function (a) {
            this.bj = true;
        };
        XamFunnelController.prototype.b7 = function (a) {
            return i2.Convert.toInt32(a);
        };
        XamFunnelController.prototype.de = function (a) {
            var b = a;
            var c = b.d;
            switch (b.g) {
                case "TextStyle":
                    this.cp = c != null ? c.toString() : "";
                    var d = new PropertyChangedMessage();
                    d.g = b.g;
                    d.e = b.e;
                    d.d = c;
                    this.y.i(d);
                    this.bj = true;
                    break;
                case "OuterLabelTextStyle":
                    this.co = c != null ? c.toString() : "";
                    var e = new PropertyChangedMessage();
                    e.g = b.g;
                    e.e = b.e;
                    e.d = c;
                    this.y.i(e);
                    this.bj = true;
                    break;
                case "ValueColumn":
                    this.am.b(c);
                    this.bj = true;
                    break;
                case "InnerLabelColumn":
                    this.bb = false;
                    this.cf = c;
                    this.ar.b(c);
                    this.bj = true;
                    break;
                case "InnerLabelVisibility":
                    this.bc = c;
                    this.bj = true;
                    break;
                case "OuterLabelVisibility":
                    this.bh = c;
                    this.bj = true;
                    break;
                case "OuterLabelColumn":
                    this.bg = false;
                    this.cg = c;
                    this.as.b(c);
                    this.bj = true;
                    break;
                case "ValueMemberPath":
                    this.cq = i2.typeCast(i2.String_$type, c);
                    break;
                case "OuterLabelMemberPath":
                    this.cn = i2.typeCast(i2.String_$type, c);
                    break;
                case "InnerLabelMemberPath":
                    this.cm = i2.typeCast(i2.String_$type, c);
                    break;
                case "BottomEdgeWidth":
                    this.bw = c;
                    if (this.bw > 1) {
                        this.bw = 1;
                    }
                    if (this.bw < 0.001) {
                        this.bw = 0.001;
                    }
                    this.bj = true;
                    break;
                case "Brushes":
                    if (b.e != null) {
                        var f = b.e;
                        f.collectionChanged = i2.delegateRemove(f.collectionChanged, this.bp);
                    }
                    if (c != null) {
                        var g = c;
                        g.collectionChanged = i2.delegateCombine(g.collectionChanged, this.bp);
                    }
                    this.c = i2.typeCast(i2.BrushCollection.$, c);
                    this.bj = true;
                    break;
                case "Outlines":
                    this.d = i2.typeCast(i2.BrushCollection.$, c);
                    this.bj = true;
                    break;
                case "OuterLabelAlignment":
                    this.ae = i2.EnumUtil.getEnumValue(OuterLabelAlignment_$type, c);
                    this.bj = true;
                    break;
                case "FunnelSliceDisplay":
                    this.n = i2.EnumUtil.getEnumValue(FunnelSliceDisplay_$type, c);
                    this.bj = true;
                    break;
                case "FormatInnerLabel":
                    this.ar.b(this.cf);
                    this.bb = false;
                    this.cb = c;
                    this.bj = true;
                    break;
                case "FormatOuterLabel":
                    this.as.b(this.cg);
                    this.cc = c;
                    this.bg = false;
                    this.bj = true;
                    break;
                case "IsInverted":
                    this.bd = c;
                    this.bj = true;
                    break;
                case "TransitionDuration":
                    this.av.r = this.b7(c);
                    this.b1 = this.av.r;
                    break;
                case "AllowSliceSelection":
                    this.a8 = c;
                    break;
                case "SelectedSliceStyle":
                    this.d3 = c;
                    this.bj = true;
                    break;
                case "UnselectedSliceStyle":
                    this.d4 = c;
                    this.bj = true;
                    break;
                case "UseUnselectedStyle":
                    this.bo = c;
                    this.bj = true;
                    break;
                case "UseBezierCurve":
                    this.bm = c;
                    this.bj = true;
                    break;
                case "UpperBezierControlPoint":
                    this.dy = c;
                    this.bj = true;
                    break;
                case "LowerBezierControlPoint":
                    this.dx = c;
                    this.bj = true;
                    break;
                case "ItemProvider":
                    this.s = c;
                    break;
                case "ToolTip":
                    var h = new TooltipValueChangedMessage();
                    if (c != null) {
                        this.ba = true;
                    }
                    else {
                        this.ba = false;
                        var i = new ClearTooltipMessage();
                        this.y.i(i);
                    }
                    h.g = c;
                    this.y.i(h);
                    break;
                case "Legend":
                    this.c6(c);
                    this.bj = true;
                    break;
                case "LegendItemTemplate":
                    this.dr = c;
                    this.bj = true;
                    break;
                case "LegendItemBadgeTemplate":
                    this.dq = c;
                    this.bj = true;
                    break;
                case "UseOuterLabelsForLegend":
                    this.bn = c;
                    this.bj = true;
                    break;
                case "OutlineThickness":
                    this.br = c;
                    this.bj = true;
                    this.y.i(b);
                    break;
                case "Container":
                case "PixelScalingRatio":
                case "ActualPixelScalingRatio":
                case "OuterLabelTextColor":
                case "LabelTextColor":
                    if (b.g == "Container") {
                        var j = b.d;
                        this.av.u(j);
                    }
                    var k = new PropertyChangedMessage();
                    k.g = b.g;
                    k.e = b.e;
                    k.d = c;
                    this.y.i(k);
                    break;
            }
        };
        Object.defineProperty(XamFunnelController.prototype, "dr", {
            get: function () {
                return this.dp;
            },
            set: function (a) {
                this.dp = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelController.prototype, "dq", {
            get: function () {
                return this.dn;
            },
            set: function (a) {
                this.dn = a;
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelController.prototype.c6 = function (a) {
            if (this.o != null) {
                this.o.clearLegendItemsForSeries(this.ac.b("Model"));
            }
            this.o = a;
        };
        XamFunnelController.prototype.dg = function (a) {
            var e_6, _a;
            var _this = this;
            var b = new i2.List$1(i2.UIElement.$, 0);
            var _loop_1 = function (c) {
                var d = new i2.ContentControl();
                var e = "";
                if (c.b.v != null) {
                    if (this_1.bn && c.l != null) {
                        e = c.l.toString();
                    }
                    else {
                        e = c.b.v.toString();
                    }
                }
                else if (c.l != null) {
                    e = c.l.toString();
                }
                var f = null;
                var g = null;
                if (f == null && c.b.ad != null) {
                    f = c.b.ad;
                }
                if (g == null && c.b.ag != null) {
                    g = c.b.ag;
                }
                var h = null;
                if (this_1.s != null) {
                    h = this_1.s.getItem(c.b.s);
                }
                d.content = ((function () {
                    var $ret = new FunnelSliceDataContext();
                    $ret.series = _this.ac.b("Model");
                    $ret.item = h;
                    $ret.itemBrush = f;
                    $ret.itemLabel = e;
                    $ret.thickness = _this.bz;
                    $ret.outline = g;
                    $ret.itemOutline = g;
                    return $ret;
                })());
                d.ah = this_1.dr;
                b.add(d);
            };
            var this_1 = this;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    _loop_1(c);
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            if (this.o != null) {
                if (this.o.isItemwise) {
                    var i = this.o;
                    i.createItemwiseLegendItems(b, this.ac.b("Model"));
                }
            }
        };
        XamFunnelController.prototype.dm = function (a) {
            var b = a;
            switch (b.g) {
                case "OuterLabelWidthDecider":
                    this.u = i2.typeCast(IOuterLabelWidthDecider_$type, b.d);
                    this.bj = true;
                    break;
                case "FunnelLabelSizeDecider":
                    this.q = i2.typeCast(IFunnelLabelSizeDecider_$type, b.d);
                    this.bj = true;
                    break;
            }
        };
        XamFunnelController.prototype.dl = function (a) {
            var b = a;
            this.b4 = b.e;
            this.b3 = b.d;
            this.bj = true;
        };
        XamFunnelController.prototype.c3 = function (a) {
            var b = a;
            if (b.e == 1) {
                return;
            }
            if (b.c == 1) {
                this.ca = this.b9;
            }
            else if (b.c == 0) {
                var c = this.ca;
                this.ca = -1;
                if (b.f == 0) {
                }
                else if (b.f != 2) {
                    return;
                }
                if (c == this.b9) {
                    this.c8(c);
                }
            }
        };
        XamFunnelController.prototype.c8 = function (a) {
            if (a < 0 || a > this.am.a.count - 1) {
                return;
            }
            if (this.a8) {
                this.ai.k(a, this.am.a.item(a));
                var b = this.ai.a();
                var c = new SelectedItemsChangedMessage();
                c.c = b;
                this.x.i(c);
                this.bj = true;
            }
            var d = new SliceClickedMessage();
            d.c = a;
            d.item = this.am.a.item(a);
            d.f = this.dz;
            this.x.i(d);
        };
        XamFunnelController.prototype.da = function (a) {
            if (this.am != null && a >= 0 && a < this.am.a.count) {
                var b = new SliceMouseMessage();
                b.e = a;
                b.item = this.am.a.item(a);
                b.c = 0;
                b.h = this.dz;
                this.x.i(b);
            }
        };
        XamFunnelController.prototype.db = function (a) {
            if (this.am != null && a >= 0 && a < this.am.a.count) {
                var b = new SliceMouseMessage();
                b.e = a;
                b.item = this.am.a.item(a);
                b.c = 2;
                b.h = this.dz;
                this.x.i(b);
            }
        };
        XamFunnelController.prototype.c9 = function (a) {
            if (this.am != null && a >= 0 && a < this.am.a.count) {
                var b = new SliceMouseMessage();
                b.e = a;
                b.item = this.am.a.item(a);
                b.c = 1;
                b.h = this.dz;
                this.x.i(b);
            }
        };
        XamFunnelController.prototype.c5 = function (a) {
            var b = a;
            var c = this.b9;
            this.b9 = this.b8(b.c);
            if (c != this.b9) {
                if (c != -1) {
                    this.da(c);
                }
                if (this.b9 != -1) {
                    this.c9(this.b9);
                }
            }
            else {
                if (this.b9 != -1) {
                    this.db(this.b9);
                }
            }
            if (this.ba) {
                this.dj(b.c);
            }
        };
        XamFunnelController.prototype.c4 = function (a) {
            var b = this.b9;
            this.b9 = -1;
            if (b != -1) {
                this.da(b);
            }
            var c = new ClearTooltipMessage();
            this.y.i(c);
        };
        XamFunnelController.prototype.dj = function (a) {
            var b = new FunnelDataContext();
            if (this.s != null && this.b9 >= 0 && this.b9 < this.s.count) {
                b.item = this.s.getItem(this.b9);
            }
            b.b = this.b9;
            if (b.b < 0) {
                var c = new ClearTooltipMessage();
                this.y.i(c);
                return;
            }
            var d = new TooltipUpdateMessage();
            d.g = b;
            d.i = this.dw(a, b);
            this.y.i(d);
        };
        XamFunnelController.prototype.dw = function (a, b) {
            var c = { $type: i2.Point_$type, x: a.x + 10, y: a.y + 10 };
            return c;
        };
        XamFunnelController.prototype.b8 = function (a) {
            if (!this.bf()) {
                return -1;
            }
            var b = a.y;
            var c = a.x;
            var d = this.i();
            if (d.g) {
                c -= d.j;
            }
            var e = this.af(b);
            if (e == null) {
                return -1;
            }
            var f = this.bx();
            var g = this.by(f, b);
            var h = g / 2;
            var i = f / 2;
            var j = new i2.Rect(0, e.b.ar.x, e.b.ar.y, Math.max(e.b.ap.x - e.b.ar.x, 0), Math.max(e.b.ap.y - e.b.ar.y, 0));
            if (c >= (i - h) && c <= (i + h)) {
                this.dz = j;
                return e.j;
            }
            else {
                return -1;
            }
        };
        XamFunnelController.prototype.bx = function () {
            var a = this.i();
            return this.b4 - a.j;
        };
        XamFunnelController.prototype.af = function (a) {
            var b = this.i();
            var c = b.b.ad(a);
            if (c >= 0 && c < b.b.count) {
                return b.b._inner[c];
            }
            return null;
        };
        XamFunnelController.prototype.i = function () {
            var a = null;
            if (this.a9) {
                a = this.j;
            }
            else {
                a = this.h;
            }
            return a;
        };
        XamFunnelController.prototype.dk = function (a) {
            var b = a;
            this.ai.i(b.c, this.am);
            this.bj = true;
        };
        XamFunnelController.prototype.c1 = function (a) {
            this.cs(a);
        };
        XamFunnelController.prototype.cs = function (a) {
            var b = this.i();
            if (a.c == -1) {
                this.bj = true;
            }
            else {
                var c = b.b._inner[a.c];
                if (a.b) {
                    if (a.d.width > b.j) {
                        this.bj = true;
                    }
                    if (a.d.height != a.e.height) {
                        this.bj = true;
                    }
                    if (a.d.height > c.b.ap.y - c.b.as.y) {
                        this.bj = true;
                    }
                }
                else {
                    if (a.d.height > c.b.ap.y - c.b.as.y) {
                        this.bj = true;
                    }
                }
            }
        };
        XamFunnelController.$t = i2.markType(XamFunnelController, 'XamFunnelController');
        return XamFunnelController;
    }(i2.Base));
    /**
     * @hidden
     */
    var XamFunnelChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamFunnelChart, _super);
        function XamFunnelChart() {
            var _this = _super.call(this) || this;
            _this.aq = null;
            _this.as = null;
            _this.ap = null;
            _this.ax = null;
            _this.bt = null;
            _this.a2 = null;
            _this.a0 = null;
            _this.a1 = null;
            _this.bu = null;
            _this.bv = null;
            _this.bk = new i2.ObservableCollection$1(i2.Base.$, 0);
            _this.bh = new i2.Dictionary$2(i2.Base.$, i2.Base.$, 0);
            _this.b2 = null;
            _this.b1 = null;
            _this.sliceClicked = null;
            _this.sliceEnter = null;
            _this.sliceLeave = null;
            _this.sliceHover = null;
            _this.bz = null;
            _this.bm = NaN;
            _this.bl = 1;
            _this.eq = null;
            _this.er = null;
            _this.bl = 1;
            _this.bm = NaN;
            var a = _this.bk;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.ds));
            _this.ar = new MessageHandler();
            _this.ar.b(SliceClickedMessage.$, i2.runOn(_this, _this.dw));
            _this.ar.b(SliceMouseMessage.$, i2.runOn(_this, _this.dx));
            _this.ar.b(SelectedItemsChangedMessage.$, i2.runOn(_this, _this.dt));
            _this.ap = new MessageChannel();
            _this.bt = function (b, c) { return _this.db(c.action, c.position, c.count, c.propertyName); };
            _this.du();
            _this.ab = XamFunnelChart.$;
            _this.ax = new XamFunnelConnector(new XamFunnelView(), _this);
            _this.legendItemTemplate = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = FunnelLegendTemplates.c;
                $ret.measure = FunnelLegendTemplates.a;
                return $ret;
            })());
            _this.legendItemBadgeTemplate = ((function () {
                var $ret = new i2.DataTemplate();
                $ret.render = FunnelLegendTemplates.b;
                $ret.measure = FunnelLegendTemplates.d;
                return $ret;
            })());
            return _this;
        }
        XamFunnelChart.prototype.destroy = function () {
            this.provideContainer(null);
        };
        Object.defineProperty(XamFunnelChart.prototype, "ar", {
            get: function () {
                return this.aq;
            },
            set: function (a) {
                this.aq = a;
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelChart.prototype.du = function () {
            this.dp(XamFunnelChart.$$p[1], 0, this.bo);
            this.dp(XamFunnelChart.$$p[6], i2.enumGetBox(i2.Visibility_$type, this.ey), i2.enumGetBox(i2.Visibility_$type, this.ey));
            this.dp(XamFunnelChart.$$p[13], i2.enumGetBox(OuterLabelAlignment_$type, this.au), i2.enumGetBox(OuterLabelAlignment_$type, this.au));
            this.dp(XamFunnelChart.$$p[4], i2.enumGetBox(FunnelSliceDisplay_$type, this.ak), i2.enumGetBox(FunnelSliceDisplay_$type, this.ak));
            this.dp(XamFunnelChart.$$p[22], this.ev, this.ev);
            this.dp(XamFunnelChart.$$p[12], this.eu, this.eu);
            this.dv();
        };
        XamFunnelChart.prototype.dv = function () {
            var a = new PropertyChangedMessage();
            a.g = "ItemProvider";
            a.e = null;
            a.d = this;
            this.ap.i(a);
        };
        Object.defineProperty(XamFunnelChart.prototype, "at", {
            get: function () {
                return this.as;
            },
            set: function (a) {
                var b = this.as;
                this.as = a;
                this.dq(b, this.as);
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelChart.prototype.dq = function (a, b) {
            if (a != null) {
                var c = i2.typeCast(MessageChannel.$, a.b("ModelUpdateMessages"));
                if (c != null) {
                    c.h(i2.runOn(this, this.df));
                }
                this.ap.g();
            }
            if (b != null) {
                var d = i2.typeCast(MessageChannel.$, b.b("ModelUpdateMessages"));
                if (d != null) {
                    d.e(i2.runOn(this, this.df));
                }
                var e = i2.typeCast(MessageChannel.$, b.b("ConfigurationMessages"));
                this.ap.f(e);
            }
        };
        XamFunnelChart.prototype.df = function (a) {
            this.ar.c(a);
        };
        XamFunnelChart.prototype.db = function (a, b, c, d) {
            var e = ((function () {
                var $ret = new DataUpdatedMessage();
                $ret.g = b;
                $ret.f = c;
                $ret.i = d;
                return $ret;
            })());
            switch (a) {
                case 3:
                    e.c = 3;
                    break;
                case 1:
                    e.c = 1;
                    break;
                case 0:
                    e.c = 0;
                    break;
                case 2:
                    e.c = 2;
                    break;
                case 4:
                    e.c = 4;
                    break;
            }
            this.dp("ValueColumn", this.a7, this.a7);
            this.dp("InnerLabelColumn", this.a3, this.a3);
            this.dp("OuterLabelColumn", this.a4, this.a4);
            this.ap.i(e);
        };
        Object.defineProperty(XamFunnelChart.prototype, "a7", {
            get: function () {
                return this.a2;
            },
            set: function (a) {
                if (this.a2 != a) {
                    var b = this.a2;
                    this.a2 = a;
                    this.dp("ValueColumn", b, this.a2);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "a3", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                if (this.a0 != a) {
                    var b = this.a0;
                    this.a0 = a;
                    this.dp("InnerLabelColumn", b, this.a3);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "a4", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                if (this.a1 != a) {
                    var b = this.a1;
                    this.a1 = a;
                    this.dp("OuterLabelColumn", b, this.a4);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "bw", {
            get: function () {
                return this.bu;
            },
            set: function (a) {
                var b = this.bu;
                this.bu = a;
                this.dp("FormatInnerLabel", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "bx", {
            get: function () {
                return this.bv;
            },
            set: function (a) {
                var b = this.bv;
                this.bv = a;
                this.dp("FormatOuterLabel", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "bj", {
            get: function () {
                return this.bk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "cz", {
            get: function () {
                return this.b2;
            },
            set: function (a) {
                var b = this.b2;
                this.b2 = a;
                this.dp("TextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "cr", {
            get: function () {
                return this.b1;
            },
            set: function (a) {
                var b = this.b1;
                this.b1 = a;
                this.dp("OuterLabelTextStyle", b, a);
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelChart.prototype.onDetachedFromUI = function () {
            this.ax.e.az();
        };
        XamFunnelChart.prototype.onAttachedToUI = function () {
            this.ax.e.ax(this);
        };
        XamFunnelChart.prototype.dp = function (a, b, c) {
            if (this.ba(a, b, c) || this.a9(a, b, c) || this.bc(a, b, c) || this.bb(a, b, c)) {
                return;
            }
            if (a == "PixelScalingRatio") {
                if (i2.isNaN_(i2.DeviceUtils.a(this.bs))) {
                    this.bn = 1;
                }
                else {
                    this.bn = i2.DeviceUtils.a(this.bs);
                }
            }
            this.ap.i(((function () {
                var $ret = new PropertyChangedMessage();
                $ret.g = a;
                $ret.e = b;
                $ret.d = c;
                return $ret;
            })()));
        };
        XamFunnelChart.prototype.a9 = function (a, b, c) {
            if (a == XamFunnelChart.$$p[2] || a == XamFunnelChart.$$p[16]) {
                this.ap.i(((function () {
                    var $ret = new PropertyChangedMessage();
                    $ret.g = a;
                    $ret.e = b == null ? null : b;
                    $ret.d = c == null ? null : c;
                    return $ret;
                })()));
                return true;
            }
            return false;
        };
        XamFunnelChart.prototype.ba = function (a, b, c) {
            var _this = this;
            if (a == XamFunnelChart.$$p[8]) {
                if (b != null) {
                    this.az = null;
                }
                if (c != null) {
                    this.bj.clear();
                    this.az = ((function () {
                        var $ret = new i2.FastItemsSource();
                        $ret.e = _this.itemsSource;
                        return $ret;
                    })());
                }
                return true;
            }
            else if (a == XamFunnelChart.$$p[3]) {
                if (b != null) {
                    var d = b;
                    d.event = i2.delegateRemove(d.event, this.bt);
                }
                if (c != null) {
                    var e = c;
                    e.event = i2.delegateCombine(e.event, this.bt);
                }
                this.dd(a, b, c);
                return true;
            }
            else if (a == XamFunnelChart.$$p[26] || a == XamFunnelChart.$$p[5] || a == XamFunnelChart.$$p[14]) {
                this.dd(a, b, c);
                return false;
            }
            return false;
        };
        XamFunnelChart.prototype.a5 = function (a, b) {
            return a.registerColumn(b, null, false);
        };
        XamFunnelChart.prototype.a6 = function (a, b) {
            return a.registerColumnObject(b, null, false);
        };
        XamFunnelChart.prototype.dd = function (a, b, c) {
            if (this.az == null) {
                var d = i2.typeCast(i2.FastItemsSource.$, b);
                if (d != null) {
                    if (this.a7 != null) {
                        d.deregisterColumn(this.a7);
                    }
                    if (this.a3 != null) {
                        d.deregisterColumn(this.a3);
                    }
                    if (this.a4 != null) {
                        d.deregisterColumn(this.a4);
                    }
                    this.a7 = null;
                    this.a3 = null;
                    this.a4 = null;
                }
                return;
            }
            if (b != null && typeof b === 'string') {
                switch (a) {
                    case XamFunnelChart.$$p[26]:
                        this.az.deregisterColumn(this.a7);
                        this.a7 = null;
                        break;
                    case XamFunnelChart.$$p[5]:
                        this.az.deregisterColumn(this.a3);
                        this.a3 = null;
                        break;
                    case XamFunnelChart.$$p[14]:
                        this.az.deregisterColumn(this.a4);
                        this.a4 = null;
                        break;
                }
            }
            if (c != null && i2.typeCast(i2.FastItemsSource.$, c) !== null) {
                if (this.c9 != null) {
                    this.a7 = this.a5(c, this.c9);
                }
                if (this.cd != null) {
                    this.a3 = this.a6(c, this.cd);
                }
                if (this.co != null) {
                    this.a4 = this.a6(c, this.co);
                }
            }
            if (c != null && typeof c === 'string') {
                switch (a) {
                    case XamFunnelChart.$$p[26]:
                        this.a7 = this.a5(this.az, this.c9);
                        break;
                    case XamFunnelChart.$$p[5]:
                        this.a3 = this.a6(this.az, this.cd);
                        break;
                    case XamFunnelChart.$$p[14]:
                        this.a4 = this.a6(this.az, this.co);
                        break;
                }
            }
        };
        XamFunnelChart.prototype.bc = function (a, b, c) {
            if (a == XamFunnelChart.$$p[6] || a == XamFunnelChart.$$p[15]) {
                var d_1 = i2.EnumUtil.getEnumValue(i2.Visibility_$type, b) == 0;
                var e_7 = i2.EnumUtil.getEnumValue(i2.Visibility_$type, c) == 0;
                this.ap.i(((function () {
                    var $ret = new PropertyChangedMessage();
                    $ret.g = a;
                    $ret.d = e_7;
                    $ret.e = d_1;
                    return $ret;
                })()));
                return true;
            }
            return false;
        };
        XamFunnelChart.prototype.bb = function (a, b, c) {
            if (a == XamFunnelChart.$$p[20]) {
                var d = new PropertyChangedMessage();
                d.g = a;
                if (b != null) {
                    d.e = b;
                }
                if (c != null) {
                    d.d = c;
                }
                this.ap.i(d);
                return true;
            }
            return false;
        };
        XamFunnelChart.prototype.dw = function (a) {
            var b = a;
            if (this.sliceClicked != null) {
                var c = new FunnelSliceClickedEventArgs();
                c.index = b.c;
                c.bounds = b.f;
                if (this.az.count > b.c && b.c >= 0) {
                    c.item = this.az.item(b.c);
                }
                this.sliceClicked(this, c);
            }
        };
        XamFunnelChart.prototype.dx = function (a) {
            var b = a;
            switch (b.c) {
                case 1:
                    {
                        if (this.sliceEnter != null) {
                            var c = new FunnelSliceEventArgs();
                            c.index = b.e;
                            c.bounds = b.h;
                            if (this.az.count > b.e && b.e >= 0) {
                                c.item = this.az.item(b.e);
                            }
                            this.sliceEnter(this, c);
                        }
                        break;
                    }
                case 0:
                    {
                        if (this.sliceLeave != null) {
                            var d = new FunnelSliceEventArgs();
                            d.index = b.e;
                            d.bounds = b.h;
                            if (this.az.count > b.e && b.e >= 0) {
                                d.item = this.az.item(b.e);
                            }
                            this.sliceLeave(this, d);
                        }
                        break;
                    }
                case 2:
                    {
                        if (this.sliceHover != null) {
                            var e = new FunnelSliceEventArgs();
                            e.index = b.e;
                            e.bounds = b.h;
                            if (this.az.count > b.e && b.e >= 0) {
                                e.item = this.az.item(b.e);
                            }
                            this.sliceHover(this, e);
                        }
                        break;
                    }
            }
        };
        XamFunnelChart.prototype.dt = function (a) {
        };
        XamFunnelChart.prototype.ds = function (a, b) {
        };
        XamFunnelChart.prototype.de = function (a, b, c, d) {
            var e_8, _a, e_9, _b, e_10, _c;
            var e = new i2.List$1(i2.Base.$, 0);
            try {
                for (var _d = tslib.__values(i2.fromEnum(a)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var f = _e.value;
                    if (!d.containsKey(f)) {
                        e.add1(f);
                    }
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            try {
                for (var _f = tslib.__values(i2.fromEnum(e)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var g = _g.value;
                    a.remove(g);
                    b.removeItem(g);
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            try {
                for (var _h = tslib.__values(i2.fromEnum(c)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var h = _j.value;
                    if (!b.containsKey(h)) {
                        a.add(h);
                        b.addItem(h, h);
                    }
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        };
        XamFunnelChart.prototype.getItem = function (a) {
            return this.az.item(a);
        };
        Object.defineProperty(XamFunnelChart.prototype, "count", {
            get: function () {
                return this.az != null ? this.az.count : 0;
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelChart.prototype.provideContainer = function (a) {
            var b = this.bz;
            this.bz = a;
            this.dp("Container", b, this.bz);
        };
        XamFunnelChart.prototype.notifyResized = function () {
            this.ax.g();
            this.ap.i(new ContainerSizeChangedMessage());
        };
        XamFunnelChart.prototype.dl = function (source_, a, b, c) {
            this.dh(source_, new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        XamFunnelChart.prototype.dg = function (source_) {
            this.dh(source_, new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        XamFunnelChart.prototype.di = function (source_, a, b) {
            this.dh(source_, new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        XamFunnelChart.prototype.dj = function (source_, a, b) {
            this.dh(source_, new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        XamFunnelChart.prototype.dh = function (s_, a) {
            if (s_.dataView && s_.dataSource) {
                s_ = s_.dataView();
            }
            ;
            if (s_ == this.itemsSource) {
                var b = this.az;
                if (b != null) {
                    b.handleCollectionChanged(a);
                }
            }
        };
        XamFunnelChart.prototype.ay = function () {
            var a = this.ax;
            return a == null ? null : a.c;
        };
        XamFunnelChart.prototype.av = function () {
            var a = this.ay();
            return a == null ? null : a.ai;
        };
        Object.defineProperty(XamFunnelChart.prototype, "ag", {
            get: function () {
                var a = this.av();
                return a == null ? null : a.a();
            },
            set: function (a) {
                var b = this.av();
                if (b == null) {
                    return;
                }
                var c = this.ay();
                b.f();
                var d = a == null ? 0 : a.length;
                while (d-- > 0) {
                    b.k(a[d], c.am.a.item(a[d]));
                }
                c.bj = true;
                c.df();
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelChart.prototype.dy = function (a) {
            var b = this.av();
            if (b == null) {
                return;
            }
            var c = this.ay();
            var d = c.am.a.item(a);
            if (d != null) {
                c.ai.k(a, d);
                c.bj = true;
                c.df();
            }
        };
        XamFunnelChart.prototype.aw = function () {
            var a = new FunnelChartVisualData();
            var b = this.ax.c.ag;
            if (b != null) {
                for (var c = 0; c < b.count; c++) {
                    var d = b._inner[c].d();
                    a.slices.add(d);
                }
            }
            a.opacity = this._opacity;
            a.isInverted = this.bd;
            a.selectedItems = this.bj;
            a.name = this.name;
            a.viewport = new i2.RectData(0, 0, this.ax.c.b4, this.ax.c.b3);
            return a;
        };
        XamFunnelChart.prototype.b7 = function () {
            var a = this.aw();
            a.scaleByViewport();
            return a.serialize();
        };
        XamFunnelChart.prototype.resolveLegendIndex = function () {
            return -1;
        };
        XamFunnelChart.prototype.forSubItems = function (a) {
        };
        Object.defineProperty(XamFunnelChart.prototype, "bs", {
            get: function () {
                return this.bm;
            },
            set: function (a) {
                if (i2.isNaN_(a) || a == 0) {
                    return;
                }
                var b = this.bm;
                this.bm = a;
                this.dp("PixelScalingRatio", b, this.bm);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "bn", {
            get: function () {
                return this.bl;
            },
            set: function (a) {
                var b = this.bl;
                this.bl = a;
                if (this.bl != b) {
                    this.dp("ActualPixelScalingRatio", b, this.bl);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "container", {
            get: function () {
                return this;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "isStacked", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "isVertical", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "isUsableInLegend", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "hasSubItems", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "hasMarkers", {
            get: function () {
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "es", {
            get: function () {
                return this.eq;
            },
            set: function (a) {
                var b = this.es;
                if (a != b) {
                    this.eq = a;
                    this.dp("OuterLabelTextColor", b, this.es);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelChart.prototype, "et", {
            get: function () {
                return this.er;
            },
            set: function (a) {
                var b = this.et;
                if (a != b) {
                    this.er = a;
                    this.dp("LabelTextColor", b, this.et);
                }
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelChart.$t = i2.markType(XamFunnelChart, 'XamFunnelChart', i2.Control.$, [IItemProvider_$type, i2.ILegendOwner_$type, i2.ILegendTemplateProvider_$type, i2.ILegendSeries_$type]);
        XamFunnelChart.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, XamFunnelChart, 'dp', ['AllowSliceSelection:a8:dz', [0, false], 'BottomEdgeWidth:bo:d0', [1, 0.35], 'Brushes:ah:d1', [i2.BrushCollection.$, null], 'FastItemsSource:az:d2', [i2.FastItemsSource.$], 'FunnelSliceDisplay:ak:d3', [FunnelSliceDisplay_$type, i2.enumGetBox(FunnelSliceDisplay_$type, 0)], 'InnerLabelMemberPath:cd:d4', [2, null], 'InnerLabelVisibility:ey:d5', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'IsInverted:bd:d6', [0, false], 'ItemsSource::d7', [i2.IEnumerable_$type, null], 'LegendItemBadgeTemplate::d8', [i2.DataTemplate.$, null], 'LegendItemTemplate::d9', [i2.DataTemplate.$, null], 'Legend::ea', [i2.IChartLegend_$type, null], 'LowerBezierControlPoint:eu:eb', [i2.Point_$type, { $type: i2.Point_$type, x: 0.5, y: 1 }], 'OuterLabelAlignment:au:ec', [OuterLabelAlignment_$type, i2.enumGetBox(OuterLabelAlignment_$type, 0)], 'OuterLabelMemberPath:co:ed', [2, null], 'OuterLabelVisibility:ez:ee', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'Outlines:ai:ef', [i2.BrushCollection.$, null], 'OutlineThickness:bq:eg', [1, -1], 'SelectedSliceStyle:ew:eh', [i2.Style.$, null], 'ToolTip:b0:ei', [4, null], 'TransitionDuration:by:ej', [1, 0], 'UnselectedSliceStyle:ex:ek', [i2.Style.$, null], 'UpperBezierControlPoint:ev:el', [i2.Point_$type, { $type: i2.Point_$type, x: 0.5, y: 0 }], 'UseBezierCurve:be:em', [0, false], 'UseOuterLabelsForLegend:bf:en', [0, false], 'UseUnselectedStyle:bg:eo', [0, false], 'ValueMemberPath:c9:ep', [2, null]]);
        return XamFunnelChart;
    }(i2.Control));
    /**
     * @hidden
     */
    var XamFunnelConnector = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamFunnelConnector, _super);
        function XamFunnelConnector(a, b) {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.b = null;
            _this.a = null;
            var c = new ServiceProvider();
            c.c("ConfigurationMessages", new MessageChannel());
            c.c("RenderingMessages", new MessageChannel());
            c.c("InteractionMessages", new MessageChannel());
            c.c("ModelUpdateMessages", new MessageChannel());
            a.av(b);
            var d = new XamFunnelController();
            d.at = a;
            d.ac = c;
            a.i = c;
            _this.b = d;
            _this.d = a;
            b.at = c;
            _this.a = b;
            c.c("Model", _this.a);
            return _this;
        }
        Object.defineProperty(XamFunnelConnector.prototype, "e", {
            get: function () {
                return this.d;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelConnector.prototype, "c", {
            get: function () {
                return this.b;
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelConnector.prototype.g = function () {
            this.c.at.av(this.a);
        };
        XamFunnelConnector.prototype.h = function (a) {
            this.d = a;
            var b = this.b.ac;
            this.b.ac = null;
            this.b.ac = b;
            this.d.i = b;
        };
        XamFunnelConnector.prototype.f = function () {
            if (this.d != null) {
                this.d.i = null;
            }
        };
        XamFunnelConnector.$t = i2.markType(XamFunnelConnector, 'XamFunnelConnector');
        return XamFunnelConnector;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Information about the clicked slice.
    */
    var IgxFunnelSliceClickedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelSliceClickedEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxFunnelSliceClickedEventArgs.prototype.createImplementation = function () {
            return new FunnelSliceClickedEventArgs();
        };
        Object.defineProperty(IgxFunnelSliceClickedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelSliceClickedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxFunnelSliceClickedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFunnelSliceClickedEventArgs.prototype, "index", {
            /**
             * The index of the clicked slice.
            */
            get: function () {
                return this.i.index;
            },
            set: function (v) {
                this.i.index = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelSliceClickedEventArgs.prototype, "bounds", {
            /**
             * The bounds of the slice.
            */
            get: function () {
                return i2.fromRect(this.i.bounds);
            },
            set: function (v) {
                this.i.bounds = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelSliceClickedEventArgs.prototype, "item", {
            /**
             * The data item for the clicked slice.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxFunnelSliceClickedEventArgs;
    }());

    /**
     * Information about the clicked slice.
    */
    var IgxFunnelSliceEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelSliceEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxFunnelSliceEventArgs.prototype.createImplementation = function () {
            return new FunnelSliceEventArgs();
        };
        Object.defineProperty(IgxFunnelSliceEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelSliceEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxFunnelSliceEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFunnelSliceEventArgs.prototype, "index", {
            /**
             * The index of the slice.
            */
            get: function () {
                return this.i.index;
            },
            set: function (v) {
                this.i.index = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelSliceEventArgs.prototype, "bounds", {
            /**
             * The bounds of the slice.
            */
            get: function () {
                return i2.fromRect(this.i.bounds);
            },
            set: function (v) {
                this.i.bounds = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelSliceEventArgs.prototype, "item", {
            /**
             * The data item for the clicked slice.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxFunnelSliceEventArgs;
    }());

    /**
     * Represents a funnel chart.
    */
    var IgxFunnelChartComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelChartComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = this;
            this.renderer = renderer;
            this._elRef = _elRef;
            this.ngZone = ngZone;
            this.injector = injector;
            this.componentFactoryResolver = componentFactoryResolver;
            this._root = null;
            this._dataSource = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._sliceClicked = null;
            this._sliceEnter = null;
            this._sliceLeave = null;
            this._sliceHover = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._zoneRunner = function (act) { return ngZone.run(act); };
            this.container = renderer.createElement("div");
            this._implementation = this.createImplementation();
            renderer.appendChild(_elRef.element.nativeElement, this.container);
            renderer.setStyle(this.container, "display", "block");
            renderer.setStyle(this.container, "width", "100%");
            renderer.setStyle(this.container, "height", "100%");
            var root;
            root = this.container;
            if (this.container != null) {
                root = this.container;
            }
            this._root = root;
            var ren = new i2.AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
            this._wrapper = ren;
            var chart = this.i;
            this._chart = chart;
            chart.provideContainer(ren);
            this.bindData();
            chart.notifyResized();
            ren.addSizeWatcher(function () {
                _this._chart.notifyResized();
            });
        }
        Object.defineProperty(IgxFunnelChartComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._chart.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype.ngAfterContentInit = function () {
            this._styling(this._root, this);
            this.i.notifyResized();
        };
        IgxFunnelChartComponent.prototype.ngOnDestroy = function () {
            this._chart.destroy();
            this._wrapper.destroy();
        };
        IgxFunnelChartComponent.prototype.createImplementation = function () {
            return new XamFunnelChart();
        };
        IgxFunnelChartComponent.prototype.createSeriesComponent = function (type) {
            if (i2.TypeRegistrar.isRegistered(type)) {
                var s = i2.TypeRegistrar.create(type);
                s.owner = this;
                s._provideRenderer(this.renderer);
                return s;
            }
            else {
                //we shouldn't get here, hopefully.
                throw Error("series type not loaded: " + type);
            }
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.bindData();
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype.bindData = function () {
            if (this._chart != null && this._chart !== undefined) {
                this._chart.itemsSource = this._dataSource;
            }
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "legend", {
            /**
             * Gets or sets the legend used for the current chart.
            */
            get: function () {
                if (this.i.legend != null)
                    return this.i.legend.externalObject;
            },
            set: function (v) {
                if (v != undefined && v != null)
                    this.i.legend = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "valueMemberPath", {
            /**
         * Gets or sets the value member path for the funnel chart.
        */
            get: function () {
                return this.i.c9;
            },
            set: function (v) {
                this.i.c9 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "brushes", {
            /**
             * Gets or sets the palette of brushes to use for coloring the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ah);
            },
            set: function (v) {
                this.i.ah = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outlines", {
            /**
             * Gets or sets the palette of brushes to use for outlines on the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ai);
            },
            set: function (v) {
                this.i.ai = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "bottomEdgeWidth", {
            /**
             * Gets or sets the percentage (from near 0 to 1) of space the bottom edge of the funnel should take.
            */
            get: function () {
                return this.i.bo;
            },
            set: function (v) {
                this.i.bo = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "innerLabelMemberPath", {
            /**
             * Gets or sets the InnerLabel mapping property for the current series object.
            */
            get: function () {
                return this.i.cd;
            },
            set: function (v) {
                this.i.cd = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outerLabelMemberPath", {
            /**
             * Gets or sets the OuterLabel mapping property for the current series object.
            */
            get: function () {
                return this.i.co;
            },
            set: function (v) {
                this.i.co = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "innerLabelVisibility", {
            /**
             * Gets or sets whether the inner labels are visible.
            */
            get: function () {
                return this.i.ey;
            },
            set: function (v) {
                this.i.ey = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outerLabelVisibility", {
            /**
             * Gets or sets whether the outer labels are visible.
            */
            get: function () {
                return this.i.ez;
            },
            set: function (v) {
                this.i.ez = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outerLabelAlignment", {
            /**
             * Gets or sets which side of the chart the outer labels should appear.
            */
            get: function () {
                return this.i.au;
            },
            set: function (v) {
                this.i.au = i2.ensureEnum(OuterLabelAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "funnelSliceDisplay", {
            /**
             * Gets or sets how the heights of the funnel slices should be configured.
            */
            get: function () {
                return this.i.ak;
            },
            set: function (v) {
                this.i.ak = i2.ensureEnum(FunnelSliceDisplay_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "formatInnerLabel", {
            /**
             * Gets or sets the formatter function for inner labels. Function should return string and it takes 3 parameters: 1st-value of item to format, 2nd-index of item within data, 3rd-reference to the funnel chart.
            */
            get: function () {
                return this.i.bw;
            },
            set: function (v) {
                this.i.bw = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "formatOuterLabel", {
            /**
             * Gets or sets the formatter function for outer labels. Function should return string and it takes 3 parameters: 1st-value of item to format, 2nd-index of item within data, 3rd-reference to the funnel chart.
            */
            get: function () {
                return this.i.bx;
            },
            set: function (v) {
                this.i.bx = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "transitionDuration", {
            /**
             * Gets or sets how long the animations should take to run.
            */
            get: function () {
                return this.i.by;
            },
            set: function (v) {
                this.i.by = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "isInverted", {
            /**
             * Gets or sets if the funnel should be rendered inverted.
            */
            get: function () {
                return this.i.bd;
            },
            set: function (v) {
                this.i.bd = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "useBezierCurve", {
            /**
             * Gets or sets whether to use a Bezier curve to define the funnel.
            */
            get: function () {
                return this.i.be;
            },
            set: function (v) {
                this.i.be = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "allowSliceSelection", {
            /**
             * Gets or sets whether to allow slices to be selected.
            */
            get: function () {
                return this.i.a8;
            },
            set: function (v) {
                this.i.a8 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "useUnselectedStyle", {
            /**
             * Gets or sets whether to use the unselected style on unselected slices.
            */
            get: function () {
                return this.i.bg;
            },
            set: function (v) {
                this.i.bg = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "selectedSliceFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.ew ? this.i.ew.fill : null;
            },
            set: function (v) {
                this.ensureSelectedSliceStyle();
                this.i.ew.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "selectedSliceStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.ew ? this.i.ew.stroke : null;
            },
            set: function (v) {
                this.ensureSelectedSliceStyle();
                this.i.ew.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "selectedSliceStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.ew ? this.i.ew.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureSelectedSliceStyle();
                this.i.ew.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "selectedSliceOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.ew ? this.i.ew.opacity : NaN;
            },
            set: function (v) {
                this.ensureSelectedSliceStyle();
                this.i.ew.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype.ensureSelectedSliceStyle = function () {
            if (this.i.ew) {
                return;
            }
            this.i.ew = new i2.Style();
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "unselectedSliceFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.ex ? this.i.ex.fill : null;
            },
            set: function (v) {
                this.ensureUnselectedSliceStyle();
                this.i.ex.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "unselectedSliceStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.ex ? this.i.ex.stroke : null;
            },
            set: function (v) {
                this.ensureUnselectedSliceStyle();
                this.i.ex.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "unselectedSliceStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.ex ? this.i.ex.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureUnselectedSliceStyle();
                this.i.ex.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "unselectedSliceOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.ex ? this.i.ex.opacity : NaN;
            },
            set: function (v) {
                this.ensureUnselectedSliceStyle();
                this.i.ex.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype.ensureUnselectedSliceStyle = function () {
            if (this.i.ex) {
                return;
            }
            this.i.ex = new i2.Style();
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "legendItemBadgeTemplate", {
            /**
             * Gets or sets the LegendItemBadgeTemplate to use for the legend items.
            */
            get: function () {
                return this.i.legendItemBadgeTemplate;
            },
            set: function (v) {
                this.i.legendItemBadgeTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "useOuterLabelsForLegend", {
            /**
             * Gets or sets whether to use the outer labels to identify the legend items.
            */
            get: function () {
                return this.i.bf;
            },
            set: function (v) {
                this.i.bf = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "textStyle", {
            /**
             * Gets or sets the text style for inner labels
            */
            get: function () {
                return this.i.cz;
            },
            set: function (v) {
                this.i.cz = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outerLabelTextStyle", {
            /**
             * Gets or sets the text style for outer labels
            */
            get: function () {
                return this.i.cr;
            },
            set: function (v) {
                this.i.cr = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outlineThickness", {
            /**
             * Gets or sets the thickness of outline around slices.
            */
            get: function () {
                return this.i.bq;
            },
            set: function (v) {
                this.i.bq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.bs;
            },
            set: function (v) {
                this.i.bs = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "outerLabelTextColor", {
            /**
             * Gets or sets the brush used for the outer labels.
            */
            get: function () {
                return i2.brushToString(this.i.es);
            },
            set: function (v) {
                this.i.es = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "textColor", {
            /**
             * Gets or sets the brush used for the inner labels.
            */
            get: function () {
                return i2.brushToString(this.i.et);
            },
            set: function (v) {
                this.i.et = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxFunnelChartComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("FunnelChartComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Provides container for funnel chart

    */
        IgxFunnelChartComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        /**
         * Notifies the controller and view about a size change.
        
        */
        IgxFunnelChartComponent.prototype.notifyResized = function () {
            this.i.notifyResized();
        };
        IgxFunnelChartComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.dl(source_, index, oldItem, newItem);
        };
        /**
         * Manually notifies the chart's data source that the data it has bound to has been cleared and needs to be re-examined.
         * This should not be called if the data that the chart is bound to is already observable.
        
        */
        IgxFunnelChartComponent.prototype.notifyClearItems = function (source_) {
            this.i.dg(source_);
        };
        IgxFunnelChartComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.di(source_, index, newItem);
        };
        IgxFunnelChartComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.dj(source_, index, oldItem);
        };
        /**
         * Toggle selection of item at index.
        
        */
        IgxFunnelChartComponent.prototype.toggleSelection = function (index) {
            this.i.dy(index);
        };
        /**
         * Exports and serializes the chart visuals.
        
        */
        IgxFunnelChartComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.b7();
            return (iv);
        };
        Object.defineProperty(IgxFunnelChartComponent.prototype, "sliceClicked", {
            /**
             * Event which is raised when a slice is clicked.
             * Function takes first argument null and second argument ui.
             * Use ui.owner to obtain reference to igFunnelChart.
             * Use ui.index to obtain index of clicked slice.
             * Use ui.item to obtain reference to clicked slice item.
             * Use ui.selected to check if slice became selected.
            */
            get: function () {
                var _this = this;
                if (this._sliceClicked == null) {
                    this._sliceClicked = new i0.EventEmitter();
                    this.i.sliceClicked = i2.delegateCombine(this.i.sliceClicked, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFunnelSliceClickedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceClicked) {
                                _this.beforeSliceClicked(_this, outerArgs);
                            }
                            _this._sliceClicked.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceClicked;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "sliceEnter", {
            /**
             * Raised when a funnel slice is entered.
            */
            get: function () {
                var _this = this;
                if (this._sliceEnter == null) {
                    this._sliceEnter = new i0.EventEmitter();
                    this.i.sliceEnter = i2.delegateCombine(this.i.sliceEnter, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFunnelSliceEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceEnter) {
                                _this.beforeSliceEnter(_this, outerArgs);
                            }
                            _this._sliceEnter.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceEnter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "sliceLeave", {
            /**
             * Raised when a funnel slice is left.
            */
            get: function () {
                var _this = this;
                if (this._sliceLeave == null) {
                    this._sliceLeave = new i0.EventEmitter();
                    this.i.sliceLeave = i2.delegateCombine(this.i.sliceLeave, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFunnelSliceEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceLeave) {
                                _this.beforeSliceLeave(_this, outerArgs);
                            }
                            _this._sliceLeave.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceLeave;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelChartComponent.prototype, "sliceHover", {
            /**
             * Raised when a funnel slice is hovered.
            */
            get: function () {
                var _this = this;
                if (this._sliceHover == null) {
                    this._sliceHover = new i0.EventEmitter();
                    this.i.sliceHover = i2.delegateCombine(this.i.sliceHover, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxFunnelSliceEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceHover) {
                                _this.beforeSliceHover(_this, outerArgs);
                            }
                            _this._sliceHover.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceHover;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelChartComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxFunnelChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxFunnelChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFunnelChartComponent, selector: "igx-funnel-chart", inputs: { height: "height", width: "width", dataSource: "dataSource", legend: "legend", valueMemberPath: "valueMemberPath", brushes: "brushes", outlines: "outlines", bottomEdgeWidth: "bottomEdgeWidth", innerLabelMemberPath: "innerLabelMemberPath", outerLabelMemberPath: "outerLabelMemberPath", innerLabelVisibility: "innerLabelVisibility", outerLabelVisibility: "outerLabelVisibility", outerLabelAlignment: "outerLabelAlignment", funnelSliceDisplay: "funnelSliceDisplay", formatInnerLabel: "formatInnerLabel", formatOuterLabel: "formatOuterLabel", transitionDuration: "transitionDuration", isInverted: "isInverted", useBezierCurve: "useBezierCurve", allowSliceSelection: "allowSliceSelection", useUnselectedStyle: "useUnselectedStyle", selectedSliceFill: "selectedSliceFill", selectedSliceStroke: "selectedSliceStroke", selectedSliceStrokeThickness: "selectedSliceStrokeThickness", selectedSliceOpacity: "selectedSliceOpacity", unselectedSliceFill: "unselectedSliceFill", unselectedSliceStroke: "unselectedSliceStroke", unselectedSliceStrokeThickness: "unselectedSliceStrokeThickness", unselectedSliceOpacity: "unselectedSliceOpacity", legendItemBadgeTemplate: "legendItemBadgeTemplate", useOuterLabelsForLegend: "useOuterLabelsForLegend", textStyle: "textStyle", outerLabelTextStyle: "outerLabelTextStyle", outlineThickness: "outlineThickness", pixelScalingRatio: "pixelScalingRatio", outerLabelTextColor: "outerLabelTextColor", textColor: "textColor" }, outputs: { sliceClicked: "sliceClicked", sliceEnter: "sliceEnter", sliceLeave: "sliceLeave", sliceHover: "sliceHover" }, host: { classAttribute: "ig-funnel-chart igx-funnel-chart" }, providers: [], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], ngImport: i0, template: "<ng-container #dynamicContent></ng-container>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxFunnelChartComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-funnel-chart',
                        template: "<ng-container #dynamicContent></ng-container>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-funnel-chart igx-funnel-chart' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], legend: [{
                    type: i0.Input
                }], valueMemberPath: [{
                    type: i0.Input
                }], brushes: [{
                    type: i0.Input
                }], outlines: [{
                    type: i0.Input
                }], bottomEdgeWidth: [{
                    type: i0.Input
                }], innerLabelMemberPath: [{
                    type: i0.Input
                }], outerLabelMemberPath: [{
                    type: i0.Input
                }], innerLabelVisibility: [{
                    type: i0.Input
                }], outerLabelVisibility: [{
                    type: i0.Input
                }], outerLabelAlignment: [{
                    type: i0.Input
                }], funnelSliceDisplay: [{
                    type: i0.Input
                }], formatInnerLabel: [{
                    type: i0.Input
                }], formatOuterLabel: [{
                    type: i0.Input
                }], transitionDuration: [{
                    type: i0.Input
                }], isInverted: [{
                    type: i0.Input
                }], useBezierCurve: [{
                    type: i0.Input
                }], allowSliceSelection: [{
                    type: i0.Input
                }], useUnselectedStyle: [{
                    type: i0.Input
                }], selectedSliceFill: [{
                    type: i0.Input
                }], selectedSliceStroke: [{
                    type: i0.Input
                }], selectedSliceStrokeThickness: [{
                    type: i0.Input
                }], selectedSliceOpacity: [{
                    type: i0.Input
                }], unselectedSliceFill: [{
                    type: i0.Input
                }], unselectedSliceStroke: [{
                    type: i0.Input
                }], unselectedSliceStrokeThickness: [{
                    type: i0.Input
                }], unselectedSliceOpacity: [{
                    type: i0.Input
                }], legendItemBadgeTemplate: [{
                    type: i0.Input
                }], useOuterLabelsForLegend: [{
                    type: i0.Input
                }], textStyle: [{
                    type: i0.Input
                }], outerLabelTextStyle: [{
                    type: i0.Input
                }], outlineThickness: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], outerLabelTextColor: [{
                    type: i0.Input
                }], textColor: [{
                    type: i0.Input
                }], sliceClicked: [{
                    type: i0.Output
                }], sliceEnter: [{
                    type: i0.Output
                }], sliceLeave: [{
                    type: i0.Output
                }], sliceHover: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFunnelChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelChartCoreModule() {
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxFunnelChartCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFunnelChartCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreModule, declarations: [IgxFunnelChartComponent], imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule], exports: [i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule,
                IgxFunnelChartComponent] });
        IgxFunnelChartCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                    i2.IgxDateTimeFormatSpecifierModule
                ], i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule] });
        return IgxFunnelChartCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxFunnelChartComponent],
                        exports: [i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule,
                            IgxFunnelChartComponent
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFunnelChartCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelChartCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxFunnelChartComponent', IgxFunnelChartComponent);
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxFunnelChartCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFunnelChartCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreDynamicModule, imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxFunnelChartCoreModule], exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxFunnelChartCoreModule] });
        IgxFunnelChartCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreDynamicModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                    i2.IgxDateTimeFormatSpecifierDynamicModule,
                    IgxFunnelChartCoreModule
                ], i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxFunnelChartCoreModule] });
        return IgxFunnelChartCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxFunnelChartCoreModule
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxFunnelChartCoreModule
                        ],
                        entryComponents: [IgxFunnelChartComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFunnelChartModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelChartModule() {
        }
        IgxFunnelChartModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFunnelChartModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartModule, imports: [i1.CommonModule, IgxFunnelChartCoreModule,
                IgxDataChartInteractivityModule], exports: [IgxFunnelChartCoreModule,
                IgxDataChartInteractivityModule] });
        IgxFunnelChartModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartModule, imports: [[i1.CommonModule, IgxFunnelChartCoreModule,
                    IgxDataChartInteractivityModule
                ], IgxFunnelChartCoreModule,
                IgxDataChartInteractivityModule] });
        return IgxFunnelChartModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFunnelChartCoreModule,
                            IgxDataChartInteractivityModule
                        ],
                        imports: [i1.CommonModule, IgxFunnelChartCoreModule,
                            IgxDataChartInteractivityModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxFunnelChartDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelChartDynamicModule() {
        }
        IgxFunnelChartDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxFunnelChartDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartDynamicModule, imports: [i1.CommonModule, IgxFunnelChartCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxFunnelChartModule], exports: [IgxFunnelChartCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxFunnelChartModule] });
        IgxFunnelChartDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartDynamicModule, imports: [[i1.CommonModule, IgxFunnelChartCoreDynamicModule,
                    IgxDataChartInteractivityDynamicModule,
                    IgxFunnelChartModule
                ], IgxFunnelChartCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxFunnelChartModule] });
        return IgxFunnelChartDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFunnelChartDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFunnelChartCoreDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxFunnelChartModule
                        ],
                        imports: [i1.CommonModule, IgxFunnelChartCoreDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxFunnelChartModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /**
     * Represents the funnel slice data currently in context.
    */
    var IgxFunnelSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFunnelSliceDataContext, _super);
        function IgxFunnelSliceDataContext() {
            return _super.call(this) || this;
        }
        IgxFunnelSliceDataContext.prototype.createImplementation = function () {
            return new FunnelSliceDataContext();
        };
        Object.defineProperty(IgxFunnelSliceDataContext.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelSliceDataContext.prototype, "itemOutline", {
            /**
             * Gets or sets the Outline to use to color the item.
            */
            get: function () {
                return i2.brushToString(this.i.itemOutline);
            },
            set: function (v) {
                this.i.itemOutline = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxFunnelSliceDataContext;
    }(i2.IgxDataContext));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents contextual data for the funnel chart.
    */
    var IgxFunnelDataContext = /** @class */ /*@__PURE__*/ (function () {
        function IgxFunnelDataContext() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxFunnelDataContext.prototype.createImplementation = function () {
            return new FunnelDataContext();
        };
        Object.defineProperty(IgxFunnelDataContext.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelDataContext.prototype.onImplementationCreated = function () {
        };
        IgxFunnelDataContext.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxFunnelDataContext.prototype, "item", {
            /**
             * The data item that is in context.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFunnelDataContext.prototype, "index", {
            /**
             * The index of the data item that is in context.
            */
            get: function () {
                return this.i.b;
            },
            set: function (v) {
                this.i.b = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxFunnelDataContext.prototype.findByName = function (name) {
            return null;
        };
        return IgxFunnelDataContext;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var XamFunnelSlice = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamFunnelSlice, _super);
        function XamFunnelSlice() {
            var _this = _super.call(this) || this;
            _this.ax = null;
            _this.ai = null;
            _this.ab = XamFunnelSlice.$;
            _this.g(XamFunnelSlice.ar, new i2.Binding(1, XamFunnelSlice.$$p[0]));
            _this.g(XamFunnelSlice.as, new i2.Binding(1, XamFunnelSlice.$$p[1]));
            return _this;
        }
        Object.defineProperty(XamFunnelSlice.prototype, "aj", {
            get: function () {
                return this.c(XamFunnelSlice.aw);
            },
            set: function (a) {
                this.h(XamFunnelSlice.aw, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelSlice.prototype, "ay", {
            get: function () {
                return this.c(XamFunnelSlice.ar);
            },
            set: function (a) {
                this.h(XamFunnelSlice.ar, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelSlice.prototype, "az", {
            get: function () {
                return this.c(XamFunnelSlice.as);
            },
            set: function (a) {
                this.h(XamFunnelSlice.as, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamFunnelSlice.prototype, "a2", {
            get: function () {
                return i2.EnumUtil.getEnumValue(i2.Visibility_$type, this.c(XamFunnelSlice.au));
            },
            set: function (a) {
                this.h(XamFunnelSlice.au, i2.enumGetBox(i2.Visibility_$type, a));
            },
            enumerable: false,
            configurable: true
        });
        XamFunnelSlice.prototype.aq = function (a, b, c) {
            var d;
            switch (a) {
                case "Fill":
                    d = new i2.Binding(1, XamFunnelSlice.$$p[0]);
                    if (c != null) {
                        d.d = this;
                    }
                    this.g(XamFunnelSlice.ar, d);
                    break;
                case "Outline":
                    d = new i2.Binding(1, XamFunnelSlice.$$p[1]);
                    if (c != null) {
                        d.d = this;
                    }
                    this.g(XamFunnelSlice.as, d);
                    break;
            }
        };
        XamFunnelSlice.$t = i2.markType(XamFunnelSlice, 'XamFunnelSlice', i2.ContentControl.$);
        XamFunnelSlice.aw = i2.DependencyProperty.i("StrokeThickness", i2.Number_$type, XamFunnelSlice.$, new i2.PropertyMetadata(2, 1, function (a, b) {
        }));
        XamFunnelSlice.ar = i2.DependencyProperty.i("ActualFill", i2.Brush.$, XamFunnelSlice.$, new i2.PropertyMetadata(1, null));
        XamFunnelSlice.as = i2.DependencyProperty.i("ActualOutline", i2.Brush.$, XamFunnelSlice.$, new i2.PropertyMetadata(1, null));
        XamFunnelSlice.au = i2.DependencyProperty.i("LabelVisibility", i2.Visibility_$type, XamFunnelSlice.$, new i2.PropertyMetadata(2, i2.enumGetBox(i2.Visibility_$type, 0), function (a, b) {
        }));
        XamFunnelSlice.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, XamFunnelSlice, 'aq', ['Fill:a0:at', [i2.Brush.$, null], 'Outline:a1:av', [i2.Brush.$, null]]);
        return XamFunnelSlice;
    }(i2.ContentControl));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TemplateChangedMessage = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TemplateChangedMessage, _super);
        function TemplateChangedMessage() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.h = null;
            return _this;
        }
        Object.defineProperty(TemplateChangedMessage.prototype, "g", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TemplateChangedMessage.prototype, "i", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                this.h = a;
            },
            enumerable: false,
            configurable: true
        });
        TemplateChangedMessage.prototype.toString = function () {
            return "TemplateChangedMessage[" + this.g.toString() + ", " + this.i.toString() + "]";
        };
        TemplateChangedMessage.$t = i2.markType(TemplateChangedMessage, 'TemplateChangedMessage', RenderingMessage.$);
        return TemplateChangedMessage;
    }(RenderingMessage));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StringColumn = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StringColumn, _super);
        function StringColumn() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            return _this;
        }
        StringColumn.prototype.b = function (a) {
            this.a = a;
        };
        StringColumn.$t = i2.markType(StringColumn, 'StringColumn');
        return StringColumn;
    }(i2.Base));

    /**
     * Provides data for IgxDataChartComponent mouse button related events.
    */
    var IgxPlotAreaMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxPlotAreaMouseButtonEventArgs() {
        }
        Object.defineProperty(IgxPlotAreaMouseButtonEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPlotAreaMouseButtonEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxPlotAreaMouseButtonEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxPlotAreaMouseButtonEventArgs.prototype, "chartPosition", {
            get: function () {
                return i2.fromPoint(this.i.chartPosition);
            },
            set: function (v) {
                this.i.chartPosition = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPlotAreaMouseButtonEventArgs.prototype, "plotAreaPosition", {
            get: function () {
                return i2.fromPoint(this.i.plotAreaPosition);
            },
            set: function (v) {
                this.i.plotAreaPosition = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPlotAreaMouseButtonEventArgs.prototype, "manipulationOccurred", {
            get: function () {
                return this.i.manipulationOccurred;
            },
            set: function (v) {
                this.i.manipulationOccurred = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPlotAreaMouseButtonEventArgs.prototype, "viewer", {
            /**
             * Gets the Chart associated with the current event.
            */
            get: function () {
                if (this.i.viewer == null) {
                    return null;
                }
                return this.i.viewer.externalObject;
            },
            set: function (v) {
                v == null ? this.i.viewer = null : this.i.viewer = v.i;
            },
            enumerable: false,
            configurable: true
        });
        return IgxPlotAreaMouseButtonEventArgs;
    }());

    /**
     * Provides data for IgxDataChartComponent mouse button related events.
    */
    var IgxPlotAreaMouseEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxPlotAreaMouseEventArgs() {
        }
        Object.defineProperty(IgxPlotAreaMouseEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPlotAreaMouseEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxPlotAreaMouseEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxPlotAreaMouseEventArgs.prototype, "chartPosition", {
            get: function () {
                return i2.fromPoint(this.i.chartPosition);
            },
            set: function (v) {
                this.i.chartPosition = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPlotAreaMouseEventArgs.prototype, "plotAreaPosition", {
            get: function () {
                return i2.fromPoint(this.i.plotAreaPosition);
            },
            set: function (v) {
                this.i.plotAreaPosition = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPlotAreaMouseEventArgs.prototype, "isDuringManipulation", {
            get: function () {
                return this.i.isDuringManipulation;
            },
            set: function (v) {
                this.i.isDuringManipulation = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPlotAreaMouseEventArgs.prototype, "viewer", {
            /**
             * Gets the Chart associated with the current event.
            */
            get: function () {
                if (this.i.viewer == null) {
                    return null;
                }
                return this.i.viewer.externalObject;
            },
            set: function (v) {
                v == null ? this.i.viewer = null : this.i.viewer = v.i;
            },
            enumerable: false,
            configurable: true
        });
        return IgxPlotAreaMouseEventArgs;
    }());

    /**
     * Provides data for IgxDataChartComponent mouse button related events.
    */
    var IgxChartCursorEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxChartCursorEventArgs() {
        }
        Object.defineProperty(IgxChartCursorEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxChartCursorEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxChartCursorEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxChartCursorEventArgs.prototype, "item", {
            /**
             * Gets the ItemsSource item associated with the current event.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChartCursorEventArgs.prototype, "series", {
            /**
             * Gets the series associated with the current event.
            */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChartCursorEventArgs.prototype, "seriesViewer", {
            /**
             * Gets the Chart associated with the current event.
            */
            get: function () {
                if (this.i.seriesViewer == null) {
                    return null;
                }
                return this.i.seriesViewer.externalObject;
            },
            set: function (v) {
                v == null ? this.i.seriesViewer = null : this.i.seriesViewer = v.i;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Provides a human readable expresion of the event arguments.
        
        */
        IgxChartCursorEventArgs.prototype.toString = function () {
            var iv = this.i.toString();
            return (iv);
        };
        return IgxChartCursorEventArgs;
    }());

    /**
     * Provides data for IgxDataChartComponent mouse button related events.
    *
    * `DataChartMouseButtonEventHandler` class represents the method that will handle IgxDataChartComponent mouse button related events.
    *
    * ```html
    *  <igx-data-chart  #chart
    *       [dataSource]="data"
    * 	  (seriesMouseLeftButtonDown)="chart_seriesMouseLeftButtonDown()">
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis
    *         >
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    *       </igx-numeric-y-axis>
    *
    *       <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *       </igx-column-series>
    *     </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.seriesMouseLeftButtonDown.subscribe(this.chart_seriesMouseLeftButtonDown);
    * chart_seriesMouseLeftButtonDown(sender :any,args: DataChartMouseButtonEventArgs )
    *   {
    *   }
    * ```
    */
    var IgxDataChartMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartMouseButtonEventArgs() {
        }
        Object.defineProperty(IgxDataChartMouseButtonEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxDataChartMouseButtonEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxDataChartMouseButtonEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxDataChartMouseButtonEventArgs.prototype, "handled", {
            /**
             * Gets or sets a value that indicates the present state of the event handling for a routed
             * event as it travels the route.
             * ChartMouseButton events are not routed events; setting this property effects the underlying
             * MouseButtonEvent.
            *
            * Use the `handled` property to indicates the present state of the event handling for a routed event.
            */
            get: function () {
                return this.i.handled;
            },
            set: function (v) {
                this.i.handled = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartMouseButtonEventArgs.prototype, "originalSource", {
            /**
             * Gets a reference to the object that raised the event.
            *
            * Use the `originalSource` property for the raised object event.
            *
            * ```ts
            * args.originalSource;
            * ```
            */
            get: function () {
                return this.i.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartMouseButtonEventArgs.prototype, "item", {
            /**
             * Gets the ItemsSource item associated with the current event.
            *
            * Use the `item` property to get the ItemsSource item associated with the current event.
            *
            * ```ts
            * var item1= args.item;
            * ```
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartMouseButtonEventArgs.prototype, "series", {
            /**
             * Gets the series associated with the current event.
            *
            * Use the `series` property for the associated current event.
            *
            * ```ts
            *  var DataSeries= args.series;
            * ```
            */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartMouseButtonEventArgs.prototype, "chart", {
            /**
             * Gets the Chart associated with the current event.
            *
            * Use the `chart` property to get the chart associated with the current event.
            *
            * ```ts
            * var dataChart=  args.chart;
            * ```
            */
            get: function () {
                if (this.i.chart == null) {
                    return null;
                }
                return this.i.chart.externalObject;
            },
            set: function (v) {
                v == null ? this.i.chart = null : this.i.chart = v.i;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Provides a human readable description of the mouse button event.
        
        *
        * Use the `toString` property to provides a human readable discription.
        *
        * ```ts
        *   var item= args.item.label.toString();
        * ```
        */
        IgxDataChartMouseButtonEventArgs.prototype.toString = function () {
            var iv = this.i.toString();
            return (iv);
        };
        /**
         * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
         * against the origin of a supplied UIElement.
        
        * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
         * and connected to the object tree. To specify the object relative to the overall the engine
         * coordinate system, use a relativeTo value of null.
        *
        * To get mouse X and Y position.
        *
        * ```ts
        *    var args.getPosition;
        * ```
        */
        IgxDataChartMouseButtonEventArgs.prototype.getPosition = function (relativeTo) {
            var iv = this.i.getPosition(relativeTo);
            return i2.fromPoint(iv);
        };
        return IgxDataChartMouseButtonEventArgs;
    }());

    /**
     * Provides data for IgxDataChartComponent mouse button related events.
    */
    var IgxChartMouseEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxChartMouseEventArgs() {
        }
        Object.defineProperty(IgxChartMouseEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxChartMouseEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxChartMouseEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxChartMouseEventArgs.prototype, "originalSource", {
            /**
             * Gets a reference to the object that raised the event.
            */
            get: function () {
                return this.i.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChartMouseEventArgs.prototype, "item", {
            /**
             * Gets the ItemsSource item associated with the current event.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChartMouseEventArgs.prototype, "series", {
            /**
             * Gets the series associated with the current event.
            */
            get: function () {
                if (this.i.series == null) {
                    return null;
                }
                if (!this.i.series.externalObject) {
                    var e = IgxSeriesComponent._createFromInternal(this.i.series);
                    if (e) {
                        e._implementation = this.i.series;
                    }
                    this.i.series.externalObject = e;
                }
                return this.i.series.externalObject;
            },
            set: function (v) {
                v == null ? this.i.series = null : this.i.series = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxChartMouseEventArgs.prototype, "chart", {
            /**
             * Gets the Chart associated with the current event.
            */
            get: function () {
                if (this.i.chart == null) {
                    return null;
                }
                return this.i.chart.externalObject;
            },
            set: function (v) {
                v == null ? this.i.chart = null : this.i.chart = v.i;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Provides a human readable description of the mouse button event.
        
        */
        IgxChartMouseEventArgs.prototype.toString = function () {
            var iv = this.i.toString();
            return (iv);
        };
        /**
         * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
         * against the origin of a supplied UIElement.
        
        * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
         * and connected to the object tree. To specify the object relative to the overall the engine
         * coordinate system, use a relativeTo value of null.
        */
        IgxChartMouseEventArgs.prototype.getPosition = function (relativeTo) {
            var iv = this.i.getPosition(relativeTo);
            return i2.fromPoint(iv);
        };
        return IgxChartMouseEventArgs;
    }());

    var IgxSeriesViewerManipulationEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxSeriesViewerManipulationEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxSeriesViewerManipulationEventArgs.prototype.createImplementation = function () {
            return new SeriesViewerManipulationEventArgs();
        };
        Object.defineProperty(IgxSeriesViewerManipulationEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesViewerManipulationEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxSeriesViewerManipulationEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxSeriesViewerManipulationEventArgs.prototype, "isZoomPan", {
            get: function () {
                return this.i.isZoomPan;
            },
            set: function (v) {
                this.i.isZoomPan = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerManipulationEventArgs.prototype, "isDragZoom", {
            get: function () {
                return this.i.isDragZoom;
            },
            set: function (v) {
                this.i.isDragZoom = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxSeriesViewerManipulationEventArgs;
    }());

    var IgxRefreshCompletedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxRefreshCompletedEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxRefreshCompletedEventArgs.prototype.createImplementation = function () {
            return new RefreshCompletedEventArgs();
        };
        Object.defineProperty(IgxRefreshCompletedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxRefreshCompletedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxRefreshCompletedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        return IgxRefreshCompletedEventArgs;
    }());

    /**
     * Represents a control for viewing series objects.
    */
    var IgxSeriesViewerComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxSeriesViewerComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._plotAreaMouseLeftButtonDown = null;
            this._plotAreaMouseLeftButtonUp = null;
            this._plotAreaClicked = null;
            this._plotAreaMouseEnter = null;
            this._plotAreaMouseLeave = null;
            this._plotAreaMouseOver = null;
            this._seriesCursorMouseMove = null;
            this._seriesMouseLeftButtonDown = null;
            this._seriesMouseLeftButtonUp = null;
            this._seriesMouseMove = null;
            this._seriesMouseEnter = null;
            this._seriesMouseLeave = null;
            this._viewerManipulationStarting = null;
            this._viewerManipulationEnding = null;
            this._windowRectChanged = null;
            this._sizeChanged = null;
            this._actualWindowRectChanged = null;
            this._gridAreaRectChanged = null;
            this._refreshCompleted = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxSeriesViewerComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxSeriesViewerComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxSeriesViewerComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxSeriesViewerComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "brushes", {
            /**
             * Gets or sets the palette of brushes used for fill of plotted series.
             * These brushes are automatically assigned to series based on the index of series.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ag);
            },
            set: function (v) {
                this.i.ag = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "outlines", {
            /**
             * Gets or sets the palette of brushes used for outlines of plotted series.
             * These outlines are automatically assigned to series based on the index of series.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.aj);
            },
            set: function (v) {
                this.i.aj = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "markerBrushes", {
            /**
             * Gets or sets the palette of brushes used for fill of marker series.
             * These brushes are automatically assigned to markers based on the index of series.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ah);
            },
            set: function (v) {
                this.i.ah = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "markerOutlines", {
            /**
             * Gets or sets the palette of brushes used for outlines of plotted markers.
             * These outlines are automatically assigned to markers based on the index of series.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ai);
            },
            set: function (v) {
                this.i.ai = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "markerAutomaticBehavior", {
            /**
             * Gets or sets the marker mode used for assigning a marker type to series when the marker type is automatic.
            */
            get: function () {
                return this.i.a9;
            },
            set: function (v) {
                this.i.a9 = i2.ensureEnum(MarkerAutomaticBehavior_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "crosshairPoint", {
            /**
             * Gets or sets the cross hair point (in world coordinates)
             * Either or both of the crosshair point's X and Y may be set to double.NaN, in which
             * case the relevant crosshair line is hidden.
            *
            * The `crosshairPoint` property is used to gets/sets the cross hair point (in world coordinates).
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     crosshairVisibility="visible"
            *     crosshairPoint={x:.8,y:.2}>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.crosshairPoint = {x:.8,y:.2};
            * ```
            */
            get: function () {
                return i2.fromPoint(this.i.o8);
            },
            set: function (v) {
                this.i.o8 = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "animateSeriesWhenAxisRangeChanges", {
            /**
             * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
            *
            * `animateSeriesWhenAxisRangeChanges` is a Boolean property to override the default behavior in which series do not animate if an axis range changes.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     animateSeriesWhenAxisRangeChanges=true>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionDuration=1000>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.animateSeriesWhenAxisRangeChanges = true;
            * ```
            */
            get: function () {
                return this.i.da;
            },
            set: function (v) {
                this.i.da = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "isWindowSyncedToVisibleRange", {
            /**
             * Gets or sets whether to sync the vertical aspect of the window with the contained series content. This is only supported for a subset of the available series.
            */
            get: function () {
                return this.i.d2;
            },
            set: function (v) {
                this.i.d2 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "shouldSimulateHoverMoveCrosshairPoint", {
            /**
             * Gets or sets whether calling SimulateHover should shift the crosshair point.
            */
            get: function () {
                return this.i.ej;
            },
            set: function (v) {
                this.i.ej = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingMode", {
            /**
             * Gets or sets the highlighting mode to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
            */
            get: function () {
                return this.i.bq;
            },
            set: function (v) {
                this.i.bq = i2.ensureEnum(SeriesHighlightingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingBehavior", {
            /**
             * Gets or sets the highlighting Behavior to use for the series in the component, when supported. This takes precedence over the series level IsHightlightingEnabled.
            */
            get: function () {
                return this.i.bo;
            },
            set: function (v) {
                this.i.bo = i2.ensureEnum(SeriesHighlightingBehavior_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "legendHighlightingMode", {
            /**
             * Gets or sets the highlighting mode to use for the legend linked to the component, when supported.
            */
            get: function () {
                return this.i.a6;
            },
            set: function (v) {
                this.i.a6 = i2.ensureEnum(LegendHighlightingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "legendItemBadgeShape", {
            /**
             * Gets or sets type of legend badges representing all series displayed in a legend linked to this component
             * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on a series
            */
            get: function () {
                return this.i.a8;
            },
            set: function (v) {
                this.i.a8 = i2.ensureEnum(LegendItemBadgeShape_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "legendItemBadgeMode", {
            /**
             * Gets or sets the mode of legend badges representing all series in this chart.
             * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on a series
            */
            get: function () {
                return this.i.a7;
            },
            set: function (v) {
                this.i.a7 = i2.ensureEnum(LegendItemBadgeMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewportRect", {
            /**
             * Gets the viewport rectangle associated with the SeriesViewer, the physical dimensions of the plot area.
            *
            * ```ts
            * let viewPortRect: IgxRect = this.chart.viewportRect;
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.pv);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "effectiveViewport", {
            /**
             * Gets the EffectiveViewport rectangle, representing the effective viewport area after margins have been subtracted.
            *
            *  ``ts
            * let viewport: IgxRect = this.chart.effectiveViewport;
            *
            * ```
            *
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.pk);
            },
            set: function (v) {
                this.i.pk = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "contentViewport", {
            /**
             * Represents the subset area within the viewport into which content should be mapped.
             * This is the projection of the current EffectiveViewport into the viewport at current zoom level.
            *
            * ```ts
            * let contentViewport: IgxRect = this.chart.contentViewport;
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.pj);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRect", {
            /**
             * A rectangle representing the portion of the SeriesViewer currently in view.
             * A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
            *
            * You can set the `windowRect` to zoom in on an area of interest in the chart.
            *
            * ```ts
            * this.chart.windowRect = {left:0, top:1, width: .5, height: .5};
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.pw);
            },
            set: function (v) {
                this.i.pw = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "useTiledZooming", {
            /**
             * Gets or sets whether the series viewer should use cached tiles during zooms rather than the default live content.
            */
            get: function () {
                return this.i.er;
            },
            set: function (v) {
                this.i.er = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "preferHigherResolutionTiles", {
            /**
             * Gets or sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality.
            */
            get: function () {
                return this.i.ef;
            },
            set: function (v) {
                this.i.ef = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "zoomTileCacheSize", {
            /**
             * Gets or sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode.
            */
            get: function () {
                return this.i.ge;
            },
            set: function (v) {
                this.i.ge = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingTransitionDuration", {
            /**
             * Gets or sets the duration the highlighting/de-highlighting effects.
            *
            * The `highlightingTransitionDuration` property is used to set the time for highlighting transition in milliseconds .
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            * 	HighlightingTransitionDuration=500 >
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value" >
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * chart.HighlightingTransitionDuration=500;
            * ```
            */
            get: function () {
                return this.i.gd;
            },
            set: function (v) {
                this.i.gd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "isPagePanningAllowed", {
            /**
             * Gets or sets the whether the series viewer can allow the page to pan if a control pan is not possible in the requested direction.
            */
            get: function () {
                return this.i.dy;
            },
            set: function (v) {
                this.i.dy = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "contentHitTestMode", {
            /**
             * Determines the method of hit testing used when mousing over elements in the chart.
            *
            * ```ts
            * this.chart.contentHitTestMode = ChartHitTestMode.Computational;
            * ```
            */
            get: function () {
                return this.i.at;
            },
            set: function (v) {
                this.i.at = i2.ensureEnum(ChartHitTestMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualContentHitTestMode", {
            /**
             * Resolved method of hit testing used when the pointer is over elements in the chart.
            *
            * ```ts
            * let actualContentHitTestMode: ChartHitTestMode  =this.chart.actualContentHitTestMode;
            * ```
            */
            get: function () {
                return this.i.as;
            },
            set: function (v) {
                this.i.as = i2.ensureEnum(ChartHitTestMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "isSurfaceInteractionDisabled", {
            /**
             * Gets or sets whether all surface interactions with the plot area should be disabled.
            *
            * The `isSurfaceInteractionDisabled` property is used to enable/disable interactions with the plot surface.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isSurfaceInteractionDisabled=true>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * chart.isSurfaceInteractionDisabled=true;
            * ```
            */
            get: function () {
                return this.i.dz;
            },
            set: function (v) {
                this.i.dz = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "isMap", {
            /**
             * Indicates if this SeriesViewer is a map.
            */
            get: function () {
                return this.i.dx;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowResponse", {
            /**
             * The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
            *
            * The `windowResponse` property is used to set the response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.
            * The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isHorizontalZoomEnabled=true
            *     windowResponse="deferred">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.windowResponse="deferred";
            * ```
            */
            get: function () {
                return this.i.bw;
            },
            set: function (v) {
                this.i.bw = i2.ensureEnum(WindowResponse_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectMinWidth", {
            /**
             * Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
             * Decrease this value if you want to allow for further zooming into the viewer.
             * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
            *
            * The `windowRectMinWidth` property is used to set or get the minimum width that the window rect is allowed to reach before being clamped.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isHorizontalZoomEnabled=true
            *     windowRectMinWidth=.2>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.WindowRectMinWidth=".2";
            * ```
            */
            get: function () {
                return this.i.f5;
            },
            set: function (v) {
                this.i.f5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "crosshairVisibility", {
            /**
             * Gets or sets the current SeriesViewer's crosshair visibility override.
            *
            * The `crosshairVisibility` property is used to gets or sets the current Chart's crosshair visibility override. Note: setting this property does not affect the mobile browser version of the chart.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     crosshairVisibility="visible">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.crosshairVisibility = Visibility.Visible;
            * ```
            */
            get: function () {
                return this.i.p0;
            },
            set: function (v) {
                this.i.p0 = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "zoomCoercionMode", {
            /**
             * Gets or sets zoom is contrained to within the axes. Setting this to false is a preview feature at the present time.
            */
            get: function () {
                return this.i.b0;
            },
            set: function (v) {
                this.i.b0 = i2.ensureEnum(ZoomCoercionMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaBackground", {
            /**
             * Gets or sets the brush used as the background for the current SeriesViewer object's plot area.
            *
            * `plotAreaBackground` property set the background brush to the current Chart object's plot area.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     plotAreaBackground="#F0F8FF">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.plotAreaBackground="#F0F8FF";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.o1);
            },
            set: function (v) {
                this.i.o1 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "defaultInteraction", {
            /**
             * Gets or sets the DefaultInteraction property.
             * The default interaction state defines the SeriesViewer's response to mouse events.
            *
            * The default interaction state defines the chart's response to mouse events.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isHorizontalZoomEnabled=true
            *     defaultInteraction="dragPan">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.defaultInteraction = InteractionState.DragPan;
            * ```
            */
            get: function () {
                return this.i.b3;
            },
            set: function (v) {
                this.i.b3 = i2.ensureEnum(i2.InteractionState_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "rightButtonDefaultInteraction", {
            /**
             * Gets or sets the RightButtonDefaultInteraction property.
             * The default interaction state defines the SeriesViewer's response to right button mouse events.
            */
            get: function () {
                return this.i.b5;
            },
            set: function (v) {
                this.i.b5 = i2.ensureEnum(i2.InteractionState_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "dragModifier", {
            /**
             * Gets or sets the current SeriesViewer's DragModifier property.
            *
            * `dragModifier` is useful to enable zooming when zooming is not the default interaction.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isHorizontalZoomEnabled=true
            *     defaultInteraction="dragPan"
            *     dragModifier="alt">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.dragModifier = ModifierKeys.Alt;
            * ```
            */
            get: function () {
                return this.i.on;
            },
            set: function (v) {
                this.i.on = i2.ensureEnum(i2.ModifierKeys_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "panModifier", {
            /**
             * Gets or sets the current SeriesViewer's PanModifier property.
            *
            * `panModifier` is useful to enable panning when panning is not the default interaction.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isHorizontalZoomEnabled=true
            *     defaultInteraction="dragZoom"
            *     panModifier="alt">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.panModifier = ModifierKeys.Alt;
            * ```
            */
            get: function () {
                return this.i.oo;
            },
            set: function (v) {
                this.i.oo = i2.ensureEnum(i2.ModifierKeys_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "previewRect", {
            /**
             * Gets or sets the preview rectangle.
             * The preview rectangle may be set to Rect.Empty, in which case the visible preview
             * strokePath is hidden.
            *
            * `previewRect` can be used to highlight an area of importance.
            *
            * ```ts
            * this.chart.previewRect = {left:0,top:0,height:.5,width:.5};
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.pq);
            },
            set: function (v) {
                this.i.pq = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowPositionHorizontal", {
            /**
             * A number between 0 and 1 determining the position of the horizontal scroll.
             * This property is effectively a shortcut to the X position of the WindowRect property.
            *
            * ```ts
            * this.chart.windowPositionHorizontal = .2;
            * ```
            */
            get: function () {
                return this.i.f3;
            },
            set: function (v) {
                this.i.f3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowPositionVertical", {
            /**
             * A number between 0 and 1 determining the position of the vertical scroll.
             * This property is effectively a shortcut to the Y position of the WindowRect property.
            *
            * ```ts
            * this.chart.windowPositionVertical = .2;
            * ```
            */
            get: function () {
                return this.i.f4;
            },
            set: function (v) {
                this.i.f4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "chartTitle", {
            /**
             * Text to display above the plot area.
            *
            * The `chartTitle` property is used to set the title to display for the component.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.title="Items Sold";
            * ```
            */
            get: function () {
                return this.i.ie;
            },
            set: function (v) {
                this.i.ie = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleHorizontalAlignment", {
            /**
             * Gets or sets the TitleHorizontalAlignment property.
            *
            * The `subtitleHorizontalAlignment` property is used to set horizontal alignment for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="date of sale: 1/1/2018"
            *     titleHorizontalAlignment="left"
            *     subtitleHorizontalAlignment="left">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.titleHorizontalAlignment="left";
            * ```
            */
            get: function () {
                return this.i.om;
            },
            set: function (v) {
                this.i.om = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleHorizontalAlignment", {
            /**
             * Gets or sets the SubtitleHorizontalAlignment property.
            *
            * The `subtitleBottomMargin` property is used to set the horizontal alignment for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="Date of Sale: 1/1/2018"
            *     titleHorizontalAlignment="left"
            *     subtitleHorizontalAlignment="left">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleHorizontalAlignment="left";
            * ```
            */
            get: function () {
                return this.i.ol;
            },
            set: function (v) {
                this.i.ol = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTextStyle", {
            /**
             * Font settings for the title.
            */
            get: function () {
                return this.i.im;
            },
            set: function (v) {
                this.i.im = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTextStyle", {
            /**
             * Font settings for the subtitle.
            */
            get: function () {
                return this.i.h9;
            },
            set: function (v) {
                this.i.h9 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTextColor", {
            /**
             * Gets or sets the Color used for the Title Text.
            *
            * The `titleTextColor` property is used to set the title brush.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="date of sale: 1/1/2018"
            *     titleTextColor="blue">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.titleTextColor="blue" ;
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.o6);
            },
            set: function (v) {
                this.i.o6 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTextColor", {
            /**
             * Gets or sets the Color used for the Subtitle Text.
            *
            * The `subtitleTextColor` property is used to set the color for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="Date of Sale: 1/1/2018"
            *     subtitleTextColor="blue">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleTextColor="blue";
            * ```
            */
            get: function () {
                return i2.brushToString(this.i.o5);
            },
            set: function (v) {
                this.i.o5 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTopMargin", {
            /**
             * Margin applied above the title.
            *
            * The `titleTopMargin` property is used to set the top margin for the title.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     titleLeftMarging=10
            *     titleTopMargin=10
            *     titleRightMargin=10
            *     titleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.titleTopMargin=10;
            * ```
            */
            get: function () {
                return this.i.f1;
            },
            set: function (v) {
                this.i.f1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleLeftMargin", {
            /**
             * Margin applied to the left of the title.
            *
            * The `titleLeftMarging` property is used to set the left margin for the title.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     titleLeftMarging=10
            *     titleTopMargin=10
            *     titleRightMargin=10
            *     titleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.titleLeftMarging=10;
            * ```
            */
            get: function () {
                return this.i.fz;
            },
            set: function (v) {
                this.i.fz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleRightMargin", {
            /**
             * Margin applied to the right of the title.
            *
            * The `titleRightMargin` property is used to set the right margin for the title.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     titleLeftMarging=10
            *     titleTopMargin=10
            *     titleRightMargin=10
            *     titleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.titleRightMargin=10;
            * ```
            */
            get: function () {
                return this.i.f0;
            },
            set: function (v) {
                this.i.f0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleBottomMargin", {
            /**
             * Margin applied below the title.
            *
            * The `titleBottomMargin` property is used to set the bottom margin for the title.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     titleLeftMarging=10
            *     titleTopMargin=10
            *     titleRightMargin=10
            *     titleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.titleBottomMargin=20;
            * ```
            */
            get: function () {
                return this.i.fy;
            },
            set: function (v) {
                this.i.fy = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTopMargin", {
            /**
             * Margin applied above the subtitle.
            *
            * The `subtitleTopMargin` property is used to set the top margin for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="date of sale: 1/1/2018"
            *     subtitleLeftMarging=10
            *     subtitleTopMargin=10
            *     subtitleRightMargin=10
            *     subtitleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleTopMargin =10;
            * ```
            */
            get: function () {
                return this.i.fx;
            },
            set: function (v) {
                this.i.fx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleLeftMargin", {
            /**
             * Margin applied to the left of the subtitle.
            *
            * The `subtitleLeftMarging` property is used to set the left margin for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="date of sale: 1/1/2018"
            *     subtitleLeftMarging=10
            *     subtitleTopMargin=10
            *     subtitleRightMargin=10
            *     subtitleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleLeftMarging=10;
            * ```
            */
            get: function () {
                return this.i.fv;
            },
            set: function (v) {
                this.i.fv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleRightMargin", {
            /**
             * Margin applied to the right of the subtitle.
            *
            * The `subTitleRightMargin` property is used to set the right margin for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="date of sale: 1/1/2018"
            *     subtitleLeftMarging=10
            *     subtitleTopMargin=10
            *     subTitleRightMargin=10
            *     subtitleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleLeftMarging=10;
            * ```
            */
            get: function () {
                return this.i.fw;
            },
            set: function (v) {
                this.i.fw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleBottomMargin", {
            /**
             * Margin applied below the subtitle.
            *
            * The `subtitleBottomMargin` property is used to set the bottom margin for the subtitle.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="date of sale: 1/1/2018"
            *     subtitleLeftMarging=10
            *     subtitleTopMargin=10
            *     subtitleRightMargin=10
            *     subtitleBottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitleBottomMargin = 20;
            * ```
            */
            get: function () {
                return this.i.fu;
            },
            set: function (v) {
                this.i.fu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitle", {
            /**
             * Gets or sets the Subtitle property.
             * The Title property defines the Subtitle of the chart
            *
            * The `subtitle` property is used to display subtitle for the component.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     title="Items Sold"
            *     subtitle="Date of Sale: 1/1/2018">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.subtitle="Date of Sale: 1/1/2018";
            * ```
            */
            get: function () {
                return this.i.h2;
            },
            set: function (v) {
                this.i.h2 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "topMargin", {
            /**
             * Sets or gets the top margin to use around the chart content.
            *
            * The `topMargin` property is used to set the top margin.
            *
            * ```html
            *  <igx-data-chart
            *     [dataSource]="data"
            *     leftMargin=20
            *     rightMargin=20
            *     topMargin=30
            *     bottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.topMargin=30;
            * ```
            */
            get: function () {
                return this.i.f2;
            },
            set: function (v) {
                this.i.f2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "leftMargin", {
            /**
             * Sets or gets the left margin to use around the chart content.
            *
            * The `leftMargin` property is used to set the left margin.
            *
            * ```html
            *  <igx-data-chart
            *     [dataSource]="data"
            *     leftMargin=20
            *     rightMargin=20
            *     topMargin=30
            *     bottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            *  this.chart.leftMargin = 20;
            * ```
            */
            get: function () {
                return this.i.fq;
            },
            set: function (v) {
                this.i.fq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "rightMargin", {
            /**
             * Sets or gets the right margin to use around the chart content.
            *
            * The `rightMargin` property is used to set the left margin around the chart content in the canvas.
            *
            * ```html
            *  <igx-data-chart
            *     [dataSource]="data"
            *     leftMargin=20
            *     rightMargin=20
            *     topMargin=30
            *     bottomMargin=20>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.rightMargin=20;
            * ```
            */
            get: function () {
                return this.i.ft;
            },
            set: function (v) {
                this.i.ft = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "bottomMargin", {
            /**
             * Sets or gets the bottom margin to use around the chart content.
            *
            * The `bottomMargin` property is used to gets/set the bottom margin around the chart content in the canvas.
            *
            * ```ts
            * this.chart.bottomMargin = 50;
            * ```
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     bottomMargin=50>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.fm;
            },
            set: function (v) {
                this.i.fm = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "autoMarginWidth", {
            /**
             * Sets or gets the automatic width to add when automatically adding margins to the chart.
            *
            * The `autoMarginWidth` propertry is used find the automatic width to add when automatically adding margins to the chart.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     autoMarginWidth=50>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.autoMarginWidth = 50;
            * ```
            */
            get: function () {
                return this.i.fl;
            },
            set: function (v) {
                this.i.fl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "autoMarginHeight", {
            /**
             * Sets or gets the automatic height to add when automatically adding margins to the chart.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     autoMarginHeight=50>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            *  this.chart.autoMarginHeight = 50;
            * ```
            */
            get: function () {
                return this.i.fk;
            },
            set: function (v) {
                this.i.fk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "isAntiAliasingEnabledDuringInteraction", {
            /**
             * Gets or sets the IsAntiAliasingEnabledDuringInteraction property.
            */
            get: function () {
                return this.i.dn;
            },
            set: function (v) {
                this.i.dn = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.fr;
            },
            set: function (v) {
                this.i.fr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "interactionPixelScalingRatio", {
            /**
             * Method of pixel scaling to use during end user interaction with the chart.
            */
            get: function () {
                return this.i.fp;
            },
            set: function (v) {
                this.i.fp = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualPixelScalingRatio", {
            /**
             * Gets the resolved pixel scaling ratio.
            *
            * A higher scaling ratio will produce crisper visuals at the expense of memory. Lower values will cause the control to appear blurry
            *
            * ```ts
            * let actualPixelScalingRatio: number = this.chart.actualPixelScalingRatio;
            * ```
            */
            get: function () {
                return this.i.fh;
            },
            set: function (v) {
                this.i.fh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualInteractionPixelScalingRatio", {
            /**
             * Resolved method of pixel scaling to use during end user interaction with the chart.
            *
            * ```ts
            * let actualInteractionPixelScalingRatio: number = this.chart.actualInteractionPixelScalingRatio;
            * ```
            */
            get: function () {
                return this.i.fg;
            },
            set: function (v) {
                this.i.fg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRect", {
            /**
             * Gets the actual value of the window rectangle, which represents the current zoom level.
            *
            * ```ts
            * let actualWindowRect: IgxRect = this.chart.actualWindowRect;
            * ``
            * ```
            */
            get: function () {
                return i2.fromRect(this.i.pg);
            },
            set: function (v) {
                this.i.pg = i2.toRect(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowPositionHorizontal", {
            /**
             * A number between 0 and 1 determining the position of the horizontal scroll.
             * This property is effectively a shortcut to the Left of the ActualWindowRect property.
            *
            * ```ts
            * let actualWindowPositionHorizontal: number = this.chart.actualWindowPositionHorizontal;
            * ```
            */
            get: function () {
                return this.i.fi;
            },
            set: function (v) {
                this.i.fi = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowPositionVertical", {
            /**
             * A number between 0 and 1 determining the position of the vertical scroll.
             * This property is effectively a shortcut to the Top of the ActualWindowRect property.
            *
            * ```ts
            * let actualWindowPositionVertical: number = this.chart.actualWindowPositionVertical;
            * ``
            * ```
            */
            get: function () {
                return this.i.fj;
            },
            set: function (v) {
                this.i.fj = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesViewerComponent.prototype.findByName = function (name) {
            if (this.series != null && this.series.findByName && this.series.findByName(name)) {
                return this.series.findByName(name);
            }
            if (this.legend && this.legend.name && this.legend.name == name) {
                return this.legend;
            }
            return null;
        };
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesViewerComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxSeriesViewerComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("SeriesViewerComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
         * Hides the active main tooltip, if displayed.
        
        *
        * ```ts
        * this.chart.hideToolTip();
        * ```
        */
        IgxSeriesViewerComponent.prototype.hideToolTip = function () {
            this.i.jk();
        };
        IgxSeriesViewerComponent.prototype.simulateHover = function (point) {
            this.i.mb(i2.toPoint(point));
        };
        /**
         * Manually starts a tiled zoom if one isn't already running.
        
        */
        IgxSeriesViewerComponent.prototype.startTiledZoomingIfNecessary = function () {
            this.i.md();
        };
        /**
         * Manually ends a tiled zoom if one is running.
        
        */
        IgxSeriesViewerComponent.prototype.endTiledZoomingIfRunning = function () {
            this.i.je();
        };
        /**
         * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
        
        */
        IgxSeriesViewerComponent.prototype.clearTileZoomCache = function () {
            this.i.i8();
        };
        /**
         * Resets the zoom level to default.
        
        */
        IgxSeriesViewerComponent.prototype.resetZoom = function () {
            this.i.l5();
        };
        IgxSeriesViewerComponent.prototype.cancelManipulation = function () {
            this.i.i6();
        };
        /**
         * Gets actual window scale for horizontal dimension of the control
        
        *
        * ```ts
        * let actualWindowScaleHorizontal: number = chart.getActualWindowScaleHorizontal();
        * ```
        */
        IgxSeriesViewerComponent.prototype.getActualWindowScaleHorizontal = function () {
            var iv = this.i.fn();
            return (iv);
        };
        /**
         * Gets actual window scale for vertical dimension of the control
        
        *
        * ```ts
        * let actualWindowScaleVertical: number = chart.getActualWindowScaleVertical();
        * ```
        */
        IgxSeriesViewerComponent.prototype.getActualWindowScaleVertical = function () {
            var iv = this.i.fo();
            return (iv);
        };
        /**
         * Notification from the containing object that the container has been resized.
        
        */
        IgxSeriesViewerComponent.prototype.notifyContainerResized = function () {
            this.i.notifyContainerResized();
        };
        /**
         * Attaches the given series to the chart.
        
        * @param s  * The series to attach to the chart.
        */
        IgxSeriesViewerComponent.prototype.attachSeries = function (s) {
            this.i.i4((s == null ? null : s.i));
        };
        IgxSeriesViewerComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.jy(source_, index, oldItem, newItem);
        };
        /**
         * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
        
        * @param source_  * The data source which was cleared or reset.
        *
        * ```ts
        * this.chart.notifyClearItems(this.data);
        * ```
        */
        IgxSeriesViewerComponent.prototype.notifyClearItems = function (source_) {
            this.i.jt(source_);
        };
        IgxSeriesViewerComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.jw(source_, index, newItem);
        };
        IgxSeriesViewerComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.jx(source_, index, oldItem);
        };
        /**
         * Release any resources held by the control.
        
        */
        IgxSeriesViewerComponent.prototype.destroy = function () {
            this.i.destroy();
        };
        IgxSeriesViewerComponent.prototype.getCurrentActualWindowRect = function () {
            var iv = this.i.pm();
            return i2.fromRect(iv);
        };
        IgxSeriesViewerComponent.prototype.renderToImage = function (width, height) {
            var iv = this.i.gg(width, height);
            return (iv);
        };
        /**
         * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the SeriesViewer.
        
        *
        * ```ts
        * this.chart.flush();
        * ```
        */
        IgxSeriesViewerComponent.prototype.flush = function () {
            this.i.flush();
        };
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseLeftButtonDown", {
            /**
             * Occurs when the left mouse button is pressed while the mouse pointer is over the plot area.
            */
            get: function () {
                var _this = this;
                if (this._plotAreaMouseLeftButtonDown == null) {
                    this._plotAreaMouseLeftButtonDown = new i0.EventEmitter();
                    this.i.plotAreaMouseLeftButtonDown = i2.delegateCombine(this.i.plotAreaMouseLeftButtonDown, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePlotAreaMouseLeftButtonDown) {
                                _this.beforePlotAreaMouseLeftButtonDown(_this, outerArgs);
                            }
                            _this._plotAreaMouseLeftButtonDown.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._plotAreaMouseLeftButtonDown;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseLeftButtonUp", {
            /**
             * Occurs when the left mouse button is pressed while the mouse pointer is over the plot area.
            */
            get: function () {
                var _this = this;
                if (this._plotAreaMouseLeftButtonUp == null) {
                    this._plotAreaMouseLeftButtonUp = new i0.EventEmitter();
                    this.i.plotAreaMouseLeftButtonUp = i2.delegateCombine(this.i.plotAreaMouseLeftButtonUp, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePlotAreaMouseLeftButtonUp) {
                                _this.beforePlotAreaMouseLeftButtonUp(_this, outerArgs);
                            }
                            _this._plotAreaMouseLeftButtonUp.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._plotAreaMouseLeftButtonUp;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaClicked", {
            /**
             * Occurs when the left mouse button is clicked while the mouse pointer is over the plot area.
            */
            get: function () {
                var _this = this;
                if (this._plotAreaClicked == null) {
                    this._plotAreaClicked = new i0.EventEmitter();
                    this.i.plotAreaClicked = i2.delegateCombine(this.i.plotAreaClicked, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePlotAreaClicked) {
                                _this.beforePlotAreaClicked(_this, outerArgs);
                            }
                            _this._plotAreaClicked.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._plotAreaClicked;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseEnter", {
            /**
             * Occurs when the pointer enters the plot area.
            */
            get: function () {
                var _this = this;
                if (this._plotAreaMouseEnter == null) {
                    this._plotAreaMouseEnter = new i0.EventEmitter();
                    this.i.plotAreaMouseEnter = i2.delegateCombine(this.i.plotAreaMouseEnter, function (o, e) {
                        var outerArgs = new IgxPlotAreaMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePlotAreaMouseEnter) {
                            _this.beforePlotAreaMouseEnter(_this, outerArgs);
                        }
                        _this._plotAreaMouseEnter.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._plotAreaMouseEnter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseLeave", {
            /**
             * Occurs when the pointer exits the plot area.
            */
            get: function () {
                var _this = this;
                if (this._plotAreaMouseLeave == null) {
                    this._plotAreaMouseLeave = new i0.EventEmitter();
                    this.i.plotAreaMouseLeave = i2.delegateCombine(this.i.plotAreaMouseLeave, function (o, e) {
                        var outerArgs = new IgxPlotAreaMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePlotAreaMouseLeave) {
                            _this.beforePlotAreaMouseLeave(_this, outerArgs);
                        }
                        _this._plotAreaMouseLeave.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._plotAreaMouseLeave;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaMouseOver", {
            /**
             * Occurs when the pointer if over the plot area.
            */
            get: function () {
                var _this = this;
                if (this._plotAreaMouseOver == null) {
                    this._plotAreaMouseOver = new i0.EventEmitter();
                    this.i.plotAreaMouseOver = i2.delegateCombine(this.i.plotAreaMouseOver, function (o, e) {
                        var outerArgs = new IgxPlotAreaMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePlotAreaMouseOver) {
                            _this.beforePlotAreaMouseOver(_this, outerArgs);
                        }
                        _this._plotAreaMouseOver.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._plotAreaMouseOver;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesCursorMouseMove", {
            /**
             * Occurs when the cursors are moved over a series in this SeriesViewer.
            */
            get: function () {
                var _this = this;
                if (this._seriesCursorMouseMove == null) {
                    this._seriesCursorMouseMove = new i0.EventEmitter();
                    this.i.seriesCursorMouseMove = i2.delegateCombine(this.i.seriesCursorMouseMove, function (o, e) {
                        var outerArgs = new IgxChartCursorEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesCursorMouseMove) {
                            _this.beforeSeriesCursorMouseMove(_this, outerArgs);
                        }
                        _this._seriesCursorMouseMove.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._seriesCursorMouseMove;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonDown", {
            /**
             * Occurs when the left mouse button is pressed while the mouse pointer is over a Series.
            *
            * The `SeriesMouseLeftButtonDown` event occurs when the left mouse button is pressed while the mouse pointer is over an element of this chart.
            *
            * &lt;-- position: content member-->
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     (seriesMouseLeftButtonDown)="onSeriesMouseLeftButtonDown($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * public onSeriesMouseLeftButtonDown(event: {sender: any, args: DataChartMouseButtonEventArgs})
            * {
            *     var item = event.args.item;
            * }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesMouseLeftButtonDown == null) {
                    this._seriesMouseLeftButtonDown = new i0.EventEmitter();
                    this.i.seriesMouseLeftButtonDown = i2.delegateCombine(this.i.seriesMouseLeftButtonDown, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxDataChartMouseButtonEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesMouseLeftButtonDown) {
                                _this.beforeSeriesMouseLeftButtonDown(_this, outerArgs);
                            }
                            _this._seriesMouseLeftButtonDown.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesMouseLeftButtonDown;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonUp", {
            /**
             * Occurs when the left mouse button is released while the mouse pointer is over a Series.
            *
            * The `SeriesMouseLeftButtonUp` event occurs when the left mouse button is released while the mouse pointer is over an element of this chart.
            *
            * &lt;-- position: content member-->
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     (seriesMouseLeftButtonUp)="onSeriesMouseLeftButtonUp($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * &lt;-- position: content member-->
            *
            * ```ts
            * public onSeriesMouseLeftButtonUp(event: {sender: any, args: DataChartMouseButtonEventArgs})
            * {
            *     var item = event.args.item;
            * }
            * ```
            *
            * ```ts
            * public onSeriesMouseLeftButtonUp =(event: any, args: DataChartMouseButtonEventArgs )
            * {
            *
            * }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesMouseLeftButtonUp == null) {
                    this._seriesMouseLeftButtonUp = new i0.EventEmitter();
                    this.i.seriesMouseLeftButtonUp = i2.delegateCombine(this.i.seriesMouseLeftButtonUp, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxDataChartMouseButtonEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesMouseLeftButtonUp) {
                                _this.beforeSeriesMouseLeftButtonUp(_this, outerArgs);
                            }
                            _this._seriesMouseLeftButtonUp.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesMouseLeftButtonUp;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseMove", {
            /**
             * Occurs when the mouse pointer moves while over a Series.
            *
            * The `SeriesMouseMove` event occurs when the left mouse pointer moves while over an element of this chart.
            *
            * &lt;-- position: content member-->
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     (seriesMouseMove)="onSeriesMouseMove($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * &lt;-- position: content member-->
            *
            * ```ts
            * public onSeriesMouseMove(event: {sender: any, args: ChartMouseEventArgs})
            * {
            *     var item = event.args.item;
            * }
            * ```
            *
            * ```ts
            * public onSeriesMouseMove =( event: any, args: ChartMouseEventArgs) => {
            *                  }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesMouseMove == null) {
                    this._seriesMouseMove = new i0.EventEmitter();
                    this.i.seriesMouseMove = i2.delegateCombine(this.i.seriesMouseMove, function (o, e) {
                        var outerArgs = new IgxChartMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSeriesMouseMove) {
                            _this.beforeSeriesMouseMove(_this, outerArgs);
                        }
                        _this._seriesMouseMove.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._seriesMouseMove;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseEnter", {
            /**
             * Occurs when the mouse pointer enters a Series.
            *
            * The `SeriesMouseEnter` event occurs when the left mouse pointer enters an element of this chart.
            *
            * &lt;-- position: content member-->
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     (seriesMouseEnter)="onSeriesMouseEnter($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * public onSeriesMouseEnter(event: {sender: any, args: ChartMouseEventArgs})
            * {
            *     var item = event.args.item;
            * }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesMouseEnter == null) {
                    this._seriesMouseEnter = new i0.EventEmitter();
                    this.i.seriesMouseEnter = i2.delegateCombine(this.i.seriesMouseEnter, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxChartMouseEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesMouseEnter) {
                                _this.beforeSeriesMouseEnter(_this, outerArgs);
                            }
                            _this._seriesMouseEnter.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesMouseEnter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeave", {
            /**
             * Occurs when the mouse pointer leaves a Series.
            *
            * The `SeriesMouseLeave` event occurs when the left mouse pointer leaves an element of this chart.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     (seriesMouseLeave)="onSeriesMouseLeave($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * public onSeriesMouseLeave(event: {sender: any, args: ChartMouseEventArgs})
            * {
            *     var item = event.args.item;
            * }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._seriesMouseLeave == null) {
                    this._seriesMouseLeave = new i0.EventEmitter();
                    this.i.seriesMouseLeave = i2.delegateCombine(this.i.seriesMouseLeave, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxChartMouseEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesMouseLeave) {
                                _this.beforeSeriesMouseLeave(_this, outerArgs);
                            }
                            _this._seriesMouseLeave.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesMouseLeave;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewerManipulationStarting", {
            /**
             * Raised when an ongoing manipulation of the series viewer is started.
            */
            get: function () {
                var _this = this;
                if (this._viewerManipulationStarting == null) {
                    this._viewerManipulationStarting = new i0.EventEmitter();
                    this.i.viewerManipulationStarting = i2.delegateCombine(this.i.viewerManipulationStarting, function (o, e) {
                        var outerArgs = new IgxSeriesViewerManipulationEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeViewerManipulationStarting) {
                            _this.beforeViewerManipulationStarting(_this, outerArgs);
                        }
                        _this._viewerManipulationStarting.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._viewerManipulationStarting;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewerManipulationEnding", {
            /**
             * Raised when an ongoing manipulation of the series viewer is ended.
            */
            get: function () {
                var _this = this;
                if (this._viewerManipulationEnding == null) {
                    this._viewerManipulationEnding = new i0.EventEmitter();
                    this.i.viewerManipulationEnding = i2.delegateCombine(this.i.viewerManipulationEnding, function (o, e) {
                        var outerArgs = new IgxSeriesViewerManipulationEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeViewerManipulationEnding) {
                            _this.beforeViewerManipulationEnding(_this, outerArgs);
                        }
                        _this._viewerManipulationEnding.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._viewerManipulationEnding;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectChanged", {
            /**
             * Occurs just after the current SeriesViewer's window rectangle is changed.
            *
            * &lt;-- position: content member-->
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     isHorizontalZoomEnabled=true
            *     (windowRectChanged)="onWindowRectChanged($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * &lt;-- position: content member-->
            *
            * ```ts
            * public onWindowRectChanged(event: {sender: any, args: RectChangedEventArgs})
            * {
            *     let newRect: IgxRect = event.args.newRect;
            * }
            * ```
            *
            * ```ts
            * public onWindowRectChanged =( s:any, e: RectChangedEventArgs) => {
            *
            *        }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._windowRectChanged == null) {
                    this._windowRectChanged = new i0.EventEmitter();
                    this.i.windowRectChanged = i2.delegateCombine(this.i.windowRectChanged, function (o, e) {
                        var outerArgs = new i2.IgxRectChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeWindowRectChanged) {
                            _this.beforeWindowRectChanged(_this, outerArgs);
                        }
                        _this._windowRectChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._windowRectChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "sizeChanged", {
            /**
             * Occurs after the size of the series viewer changes.
            *
            * &lt;-- position: content member-->
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     (sizeChanged)="onSizeChanged($event)">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            * &lt;-- position: content member-->
            *
            * ```ts
            * public onSizeChanged(event: {sender: any, args: RectChangedEventArgs})
            * {
            *     let newRect: IgxRect = event.args.newRect;
            * }
            * ```
            *
            * ```ts
            * public onSizeChanged =(event: any, args: RectChangedEventArgs}){
            *
            * }
            * ```
            */
            get: function () {
                var _this = this;
                if (this._sizeChanged == null) {
                    this._sizeChanged = new i0.EventEmitter();
                    this.i.sizeChanged = i2.delegateCombine(this.i.sizeChanged, function (o, e) {
                        var outerArgs = new i2.IgxRectChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeSizeChanged) {
                            _this.beforeSizeChanged(_this, outerArgs);
                        }
                        _this._sizeChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._sizeChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRectChanged", {
            /**
             * Raised when the actual window rectangle of the SeriesViewer changes.
            */
            get: function () {
                var _this = this;
                if (this._actualWindowRectChanged == null) {
                    this._actualWindowRectChanged = new i0.EventEmitter();
                    this.i.actualWindowRectChanged = i2.delegateCombine(this.i.actualWindowRectChanged, function (o, e) {
                        var outerArgs = new i2.IgxRectChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeActualWindowRectChanged) {
                            _this.beforeActualWindowRectChanged(_this, outerArgs);
                        }
                        _this._actualWindowRectChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._actualWindowRectChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "gridAreaRectChanged", {
            /**
             * Occurs just after the current SeriesViewer's grid area rectangle is changed.
             * The grid area may change as the result of the SeriesViewer being resized, or
             * of an axis being added or changing size, possibly in another SeriesViewer.
            */
            get: function () {
                var _this = this;
                if (this._gridAreaRectChanged == null) {
                    this._gridAreaRectChanged = new i0.EventEmitter();
                    this.i.gridAreaRectChanged = i2.delegateCombine(this.i.gridAreaRectChanged, function (o, e) {
                        var outerArgs = new i2.IgxRectChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeGridAreaRectChanged) {
                            _this.beforeGridAreaRectChanged(_this, outerArgs);
                        }
                        _this._gridAreaRectChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._gridAreaRectChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSeriesViewerComponent.prototype, "refreshCompleted", {
            /**
             * Raised when the SeriesViewer's processing for an update has completed.
            */
            get: function () {
                var _this = this;
                if (this._refreshCompleted == null) {
                    this._refreshCompleted = new i0.EventEmitter();
                    this.i.refreshCompleted = i2.delegateCombine(this.i.refreshCompleted, function (o, e) {
                        var outerArgs = new IgxRefreshCompletedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeRefreshCompleted) {
                            _this.beforeRefreshCompleted(_this, outerArgs);
                        }
                        _this._refreshCompleted.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._refreshCompleted;
            },
            enumerable: false,
            configurable: true
        });
        IgxSeriesViewerComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxSeriesViewerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSeriesViewerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSeriesViewerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSeriesViewerComponent, selector: "ng-component", inputs: { brushes: "brushes", outlines: "outlines", markerBrushes: "markerBrushes", markerOutlines: "markerOutlines", markerAutomaticBehavior: "markerAutomaticBehavior", crosshairPoint: "crosshairPoint", animateSeriesWhenAxisRangeChanges: "animateSeriesWhenAxisRangeChanges", isWindowSyncedToVisibleRange: "isWindowSyncedToVisibleRange", shouldSimulateHoverMoveCrosshairPoint: "shouldSimulateHoverMoveCrosshairPoint", highlightingMode: "highlightingMode", highlightingBehavior: "highlightingBehavior", legendHighlightingMode: "legendHighlightingMode", legendItemBadgeShape: "legendItemBadgeShape", legendItemBadgeMode: "legendItemBadgeMode", effectiveViewport: "effectiveViewport", windowRect: "windowRect", useTiledZooming: "useTiledZooming", preferHigherResolutionTiles: "preferHigherResolutionTiles", zoomTileCacheSize: "zoomTileCacheSize", highlightingTransitionDuration: "highlightingTransitionDuration", isPagePanningAllowed: "isPagePanningAllowed", contentHitTestMode: "contentHitTestMode", actualContentHitTestMode: "actualContentHitTestMode", isSurfaceInteractionDisabled: "isSurfaceInteractionDisabled", windowResponse: "windowResponse", windowRectMinWidth: "windowRectMinWidth", crosshairVisibility: "crosshairVisibility", zoomCoercionMode: "zoomCoercionMode", plotAreaBackground: "plotAreaBackground", defaultInteraction: "defaultInteraction", rightButtonDefaultInteraction: "rightButtonDefaultInteraction", dragModifier: "dragModifier", panModifier: "panModifier", previewRect: "previewRect", windowPositionHorizontal: "windowPositionHorizontal", windowPositionVertical: "windowPositionVertical", chartTitle: "chartTitle", titleHorizontalAlignment: "titleHorizontalAlignment", subtitleHorizontalAlignment: "subtitleHorizontalAlignment", titleTextStyle: "titleTextStyle", subtitleTextStyle: "subtitleTextStyle", titleTextColor: "titleTextColor", subtitleTextColor: "subtitleTextColor", titleTopMargin: "titleTopMargin", titleLeftMargin: "titleLeftMargin", titleRightMargin: "titleRightMargin", titleBottomMargin: "titleBottomMargin", subtitleTopMargin: "subtitleTopMargin", subtitleLeftMargin: "subtitleLeftMargin", subtitleRightMargin: "subtitleRightMargin", subtitleBottomMargin: "subtitleBottomMargin", subtitle: "subtitle", topMargin: "topMargin", leftMargin: "leftMargin", rightMargin: "rightMargin", bottomMargin: "bottomMargin", autoMarginWidth: "autoMarginWidth", autoMarginHeight: "autoMarginHeight", isAntiAliasingEnabledDuringInteraction: "isAntiAliasingEnabledDuringInteraction", pixelScalingRatio: "pixelScalingRatio", interactionPixelScalingRatio: "interactionPixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio", actualInteractionPixelScalingRatio: "actualInteractionPixelScalingRatio", actualWindowRect: "actualWindowRect", actualWindowPositionHorizontal: "actualWindowPositionHorizontal", actualWindowPositionVertical: "actualWindowPositionVertical" }, outputs: { plotAreaMouseLeftButtonDown: "plotAreaMouseLeftButtonDown", plotAreaMouseLeftButtonUp: "plotAreaMouseLeftButtonUp", plotAreaClicked: "plotAreaClicked", plotAreaMouseEnter: "plotAreaMouseEnter", plotAreaMouseLeave: "plotAreaMouseLeave", plotAreaMouseOver: "plotAreaMouseOver", seriesCursorMouseMove: "seriesCursorMouseMove", seriesMouseLeftButtonDown: "seriesMouseLeftButtonDown", seriesMouseLeftButtonUp: "seriesMouseLeftButtonUp", seriesMouseMove: "seriesMouseMove", seriesMouseEnter: "seriesMouseEnter", seriesMouseLeave: "seriesMouseLeave", viewerManipulationStarting: "viewerManipulationStarting", viewerManipulationEnding: "viewerManipulationEnding", windowRectChanged: "windowRectChanged", sizeChanged: "sizeChanged", actualWindowRectChanged: "actualWindowRectChanged", gridAreaRectChanged: "gridAreaRectChanged", refreshCompleted: "refreshCompleted" }, ngImport: i0, template: "", isInline: true });
        return IgxSeriesViewerComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSeriesViewerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { brushes: [{
                    type: i0.Input
                }], outlines: [{
                    type: i0.Input
                }], markerBrushes: [{
                    type: i0.Input
                }], markerOutlines: [{
                    type: i0.Input
                }], markerAutomaticBehavior: [{
                    type: i0.Input
                }], crosshairPoint: [{
                    type: i0.Input
                }], animateSeriesWhenAxisRangeChanges: [{
                    type: i0.Input
                }], isWindowSyncedToVisibleRange: [{
                    type: i0.Input
                }], shouldSimulateHoverMoveCrosshairPoint: [{
                    type: i0.Input
                }], highlightingMode: [{
                    type: i0.Input
                }], highlightingBehavior: [{
                    type: i0.Input
                }], legendHighlightingMode: [{
                    type: i0.Input
                }], legendItemBadgeShape: [{
                    type: i0.Input
                }], legendItemBadgeMode: [{
                    type: i0.Input
                }], effectiveViewport: [{
                    type: i0.Input
                }], windowRect: [{
                    type: i0.Input
                }], useTiledZooming: [{
                    type: i0.Input
                }], preferHigherResolutionTiles: [{
                    type: i0.Input
                }], zoomTileCacheSize: [{
                    type: i0.Input
                }], highlightingTransitionDuration: [{
                    type: i0.Input
                }], isPagePanningAllowed: [{
                    type: i0.Input
                }], contentHitTestMode: [{
                    type: i0.Input
                }], actualContentHitTestMode: [{
                    type: i0.Input
                }], isSurfaceInteractionDisabled: [{
                    type: i0.Input
                }], windowResponse: [{
                    type: i0.Input
                }], windowRectMinWidth: [{
                    type: i0.Input
                }], crosshairVisibility: [{
                    type: i0.Input
                }], zoomCoercionMode: [{
                    type: i0.Input
                }], plotAreaBackground: [{
                    type: i0.Input
                }], defaultInteraction: [{
                    type: i0.Input
                }], rightButtonDefaultInteraction: [{
                    type: i0.Input
                }], dragModifier: [{
                    type: i0.Input
                }], panModifier: [{
                    type: i0.Input
                }], previewRect: [{
                    type: i0.Input
                }], windowPositionHorizontal: [{
                    type: i0.Input
                }], windowPositionVertical: [{
                    type: i0.Input
                }], chartTitle: [{
                    type: i0.Input
                }], titleHorizontalAlignment: [{
                    type: i0.Input
                }], subtitleHorizontalAlignment: [{
                    type: i0.Input
                }], titleTextStyle: [{
                    type: i0.Input
                }], subtitleTextStyle: [{
                    type: i0.Input
                }], titleTextColor: [{
                    type: i0.Input
                }], subtitleTextColor: [{
                    type: i0.Input
                }], titleTopMargin: [{
                    type: i0.Input
                }], titleLeftMargin: [{
                    type: i0.Input
                }], titleRightMargin: [{
                    type: i0.Input
                }], titleBottomMargin: [{
                    type: i0.Input
                }], subtitleTopMargin: [{
                    type: i0.Input
                }], subtitleLeftMargin: [{
                    type: i0.Input
                }], subtitleRightMargin: [{
                    type: i0.Input
                }], subtitleBottomMargin: [{
                    type: i0.Input
                }], subtitle: [{
                    type: i0.Input
                }], topMargin: [{
                    type: i0.Input
                }], leftMargin: [{
                    type: i0.Input
                }], rightMargin: [{
                    type: i0.Input
                }], bottomMargin: [{
                    type: i0.Input
                }], autoMarginWidth: [{
                    type: i0.Input
                }], autoMarginHeight: [{
                    type: i0.Input
                }], isAntiAliasingEnabledDuringInteraction: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], interactionPixelScalingRatio: [{
                    type: i0.Input
                }], actualPixelScalingRatio: [{
                    type: i0.Input
                }], actualInteractionPixelScalingRatio: [{
                    type: i0.Input
                }], actualWindowRect: [{
                    type: i0.Input
                }], actualWindowPositionHorizontal: [{
                    type: i0.Input
                }], actualWindowPositionVertical: [{
                    type: i0.Input
                }], plotAreaMouseLeftButtonDown: [{
                    type: i0.Output
                }], plotAreaMouseLeftButtonUp: [{
                    type: i0.Output
                }], plotAreaClicked: [{
                    type: i0.Output
                }], plotAreaMouseEnter: [{
                    type: i0.Output
                }], plotAreaMouseLeave: [{
                    type: i0.Output
                }], plotAreaMouseOver: [{
                    type: i0.Output
                }], seriesCursorMouseMove: [{
                    type: i0.Output
                }], seriesMouseLeftButtonDown: [{
                    type: i0.Output
                }], seriesMouseLeftButtonUp: [{
                    type: i0.Output
                }], seriesMouseMove: [{
                    type: i0.Output
                }], seriesMouseEnter: [{
                    type: i0.Output
                }], seriesMouseLeave: [{
                    type: i0.Output
                }], viewerManipulationStarting: [{
                    type: i0.Output
                }], viewerManipulationEnding: [{
                    type: i0.Output
                }], windowRectChanged: [{
                    type: i0.Output
                }], sizeChanged: [{
                    type: i0.Output
                }], actualWindowRectChanged: [{
                    type: i0.Output
                }], gridAreaRectChanged: [{
                    type: i0.Output
                }], refreshCompleted: [{
                    type: i0.Output
                }] } });

    var IgxSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSeriesCollection, _super);
        function IgxSeriesCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxSeriesComponent.$type) {
                IgxSeriesComponent.$type = i2.markType(IgxSeriesComponent, "IgxSeriesComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxSeriesCollection.prototype._createInnerColl = function () {
            if (!IgxSeriesComponent.$type) {
                IgxSeriesComponent.$type = i2.markType(IgxSeriesComponent, "IgxSeriesComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxSeriesComponent.$type, Series.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = IgxSeriesComponent._createFromInternal(int);
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxSeriesCollection;
    }(i2.IgCollection));

    var IgxAxisCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAxisCollection, _super);
        function IgxAxisCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxAxisComponent.$type) {
                IgxAxisComponent.$type = i2.markType(IgxAxisComponent, "IgxAxisComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxAxisCollection.prototype._createInnerColl = function () {
            if (!IgxAxisComponent.$type) {
                IgxAxisComponent.$type = i2.markType(IgxAxisComponent, "IgxAxisComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxAxisComponent.$type, Axis.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = IgxAxisComponent._createFromInternal(int);
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxAxisCollection;
    }(i2.IgCollection));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a chart area containing axes, series, an optional legend and other hosted content.
    */
    var IgxDataChartComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxDataChartComponent, _super);
        function IgxDataChartComponent(_renderer, _elRef, _ngZone, _componentFactoryResolver, _injector) {
            var _this = _super.call(this) || this;
            _this._renderer = _renderer;
            _this._elRef = _elRef;
            _this._ngZone = _ngZone;
            _this._componentFactoryResolver = _componentFactoryResolver;
            _this._injector = _injector;
            /**
             * The series actually present in the chart. Do not directly modify this array.
             * This array's contents can be modified by causing Angular to reproject the child content.
             * Or adding and removing series from the manual series collection on the series property.
             */
            _this.actualSeries = [];
            /**
             * The axes actually present in the chart. Do not directly modify this array.
             * This array's contents can be modified by causing Angular to reproject the child content.
             * Or adding and removing axes from the manual axes collection on the axes property.
             */
            _this.actualAxes = [];
            _this._series = null;
            _this._axes = null;
            _this._root = null;
            _this._dataSource = null;
            _this._axesAdapter = null;
            _this._seriesAdapter = null;
            _this._defaultTooltips = null;
            _this._zoneRunner = function (act) { return _this._ngZone.run(act); };
            _this._container = _renderer.createElement("div");
            _renderer.appendChild(_elRef.element.nativeElement, _this._container);
            _renderer.setStyle(_this._container, "display", "block");
            _renderer.setStyle(_this._container, "width", "100%");
            _renderer.setStyle(_this._container, "height", "100%");
            var root;
            root = _this._container;
            if (_this._container.nativeElement != null) {
                root = _this._container.nativeElement;
            }
            _this._root = root;
            var ren = new i2.AngularRenderer(root, _this._renderer, window.document, _this._ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            var chart = _this.i;
            _this._chart = chart;
            _this._axesAdapter = new i2.CollectionAdapter([], _this.i.axes, _this.actualAxes, function (c) { return c.i; }, function (i) {
                i._provideRenderer(_this._wrapper);
                i.provideData(_this._dataSource);
                if (_this._container && _this._container.parentElement) {
                    i._styling(_this._root, _this, _this);
                }
            }, function (i) { i._provideRenderer(null); i.provideData(null); });
            _this._seriesAdapter = new i2.CollectionAdapter([], _this.i.series, _this.actualSeries, function (c) { return c.i; }, function (i) {
                i.owner = _this;
                i._provideRenderer(_this._dataSource);
                i.provideData(_this._dataSource);
                if (_this._container && _this._container.parentElement) {
                    i._styling(_this._root, _this, _this);
                }
                i.bindAxes(_this.actualAxes);
                _this._ensureDefaultTooltip(i);
                _this._ensureTooltipCreated(i);
            }, function (i) { i._provideRenderer(null); i.provideData(null); });
            chart.provideContainer(ren);
            ren.addSizeWatcher(function () {
                _this._chart.notifyContainerResized();
            });
            return _this;
        }
        Object.defineProperty(IgxDataChartComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this._renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._chart.notifyContainerResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this._renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._chart.notifyContainerResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "legend", {
            /**
             * Gets or sets the legend used for the current chart.
            */
            get: function () {
                if (this.i.legend != null)
                    return this.i.legend.externalObject;
            },
            set: function (v) {
                if (v != undefined && v != null)
                    this.i.legend = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "series", {
            /**
             * A collection or manually added series for the chart.
            */
            get: function () {
                var _this = this;
                if (this._series === null) {
                    var coll = new IgxSeriesCollection();
                    var inner = coll._innerColl;
                    inner.addListener(function (sender, e) {
                        switch (e.action) {
                            case i2.NotifyCollectionChangedAction.Add:
                                _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Remove:
                                _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                                break;
                            case i2.NotifyCollectionChangedAction.Replace:
                                _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                                _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Reset:
                                _this._seriesAdapter.clearManualItems();
                                break;
                        }
                    });
                    this._series = coll;
                }
                return this._series;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "axes", {
            /**
             * A collection or manually added axes for the chart.
            */
            get: function () {
                var _this = this;
                if (this._axes === null) {
                    var coll = new IgxAxisCollection();
                    var inner = coll._innerColl;
                    inner.addListener(function (sender, e) {
                        switch (e.action) {
                            case i2.NotifyCollectionChangedAction.Add:
                                _this._axesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Remove:
                                _this._axesAdapter.removeManualItemAt(e.oldStartingIndex);
                                break;
                            case i2.NotifyCollectionChangedAction.Replace:
                                _this._axesAdapter.removeManualItemAt(e.oldStartingIndex);
                                _this._axesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Reset:
                                _this._axesAdapter.clearManualItems();
                                break;
                        }
                    });
                    this._axes = coll;
                }
                return this._axes;
            },
            enumerable: false,
            configurable: true
        });
        IgxDataChartComponent.prototype.ngOnDestroy = function () {
            this._chart.destroy();
            this._wrapper.destroy();
        };
        IgxDataChartComponent.prototype.createImplementation = function () {
            return new XamDataChart();
        };
        Object.defineProperty(IgxDataChartComponent.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.bindData();
            },
            enumerable: false,
            configurable: true
        });
        IgxDataChartComponent.prototype.bindData = function () {
            //console.log("binding data: " + this._dataSource);
            if (this.actualAxes && this.actualAxes.length > 0) {
                var currAxes = this.actualAxes;
                for (var i = 0; i < currAxes.length; i++) {
                    currAxes[i].provideData(this._dataSource);
                }
            }
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    currSeries[i].provideData(this._dataSource);
                }
            }
        };
        IgxDataChartComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (i2.TypeRegistrar.isRegistered("IgxDataChartDefaultTooltipsComponent")) {
                var c = i2.TypeRegistrar.get("IgxDataChartDefaultTooltipsComponent");
                var cf = this._componentFactoryResolver.resolveComponentFactory(c);
                var cr_1 = this._dynamicContent.createComponent(cf);
                //let cr = cf.create(this._injector);
                this._defaultTooltips = cr_1;
                cr_1.instance.onContentReady.subscribe(function () {
                    _this._onDefaultTooltipsReady(cr_1);
                });
                //this._container.appendChild(cr.location.nativeElement);
            }
            this._axesAdapter.updateQuery(this.contentAxes);
            this._seriesAdapter.updateQuery(this.contentSeries);
            if (this.actualAxes && this.actualAxes.length > 0) {
                var currAxes = this.actualAxes;
                for (var i = 0; i < currAxes.length; i++) {
                    currAxes[i].provideData(this._dataSource);
                }
            }
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    currSeries[i].provideData(this._dataSource);
                }
            }
            this._styling(this._root, this);
            this.i.notifyContainerResized();
        };
        IgxDataChartComponent.prototype._ensureTooltipCreated = function (series) {
            var _this = this;
            series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
                var wrapper = new i2.AngularWrapper(ele, _this._renderer, _this._ngZone);
                wrapper.updateToolTip = ele.updateToolTip;
                wrapper.hideToolTip = ele.hideToolTip;
                return wrapper;
            });
        };
        IgxDataChartComponent.prototype._ensureDefaultTooltip = function (series) {
            if (this._defaultTooltips == null) {
                return;
            }
            this._defaultTooltips.instance["ensureDefaultTooltip"](series);
        };
        IgxDataChartComponent.prototype._onDefaultTooltipsReady = function (cr) {
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    if (currSeries[i].showDefaultTooltip) {
                        this._ensureDefaultTooltip(currSeries[i]);
                    }
                }
            }
        };
        IgxDataChartComponent.prototype.createTooltip = function () {
            if (!i2.TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
                return null;
            }
            var t = i2.TypeRegistrar.get("IgxTooltipContainerComponent");
            var cf = this._componentFactoryResolver.resolveComponentFactory(t);
            //let cr = cf.create(this._injector);
            var cr = this._dynamicContent.createComponent(cf);
            var ele = cr.location.nativeElement;
            var self = this;
            ele.updateToolTip = function (c, isSubContent) {
                if (c.externalObject) {
                    c = c.externalObject;
                }
                else {
                    var ext = new i2.IgxDataContext();
                    ext._implementation = c;
                    c = ext;
                }
                if (!isSubContent) {
                    if (ele.parentElement != self._container) {
                        if (ele.parentElement != null) {
                            ele.parentElement.removeChild(ele);
                        }
                        self._container.appendChild(ele);
                    }
                }
                else {
                    c.isSubContent = true;
                }
                cr.instance.context = c;
                ele.style.display = "block";
                return true;
            };
            ele.hideToolTip = function () {
                ele.style.display = "none";
            };
            ele.style.display = "none";
            return cr;
        };
        Object.defineProperty(IgxDataChartComponent.prototype, "syncChannel", {
            /**
             * Gets or sets the channel with which to synchronize.
            *
            * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
            */
            get: function () {
                return this.i.syncChannel;
            },
            set: function (v) {
                var newLink = null;
                if (v && v.length > 0) {
                    newLink = SyncLinkManager.instance().getLink(v);
                }
                var oldLink = this.i.actualSyncLink;
                if (oldLink) {
                    SyncLinkManager.instance().releaseLink(oldLink);
                }
                if (newLink) {
                    this.i.actualSyncLink = newLink;
                }
                else {
                    this.i.actualSyncLink = new SyncLink();
                }
                this.i.syncChannel = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "synchronizeVertically", {
            /**
             * Gets or sets the bool used to display the window preview shadow.
            *
            * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
            */
            get: function () {
                return this.i.syncSettings ? this.i.syncSettings.synchronizeVertically : false;
            },
            set: function (v) {
                this.i.syncSettings.synchronizeVertically = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "synchronizeHorizontally", {
            /**
             * Gets or sets the bool used to display the window preview shadow.
            *
            * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
            */
            get: function () {
                return this.i.syncSettings ? this.i.syncSettings.synchronizeHorizontally : false;
            },
            set: function (v) {
                this.i.syncSettings.synchronizeHorizontally = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "i", {
            /**
                                     * @hidden
                                     */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "isSquare", {
            /**
         * Gets or sets whether to use a square aspect ratio for the chart. This is locked to true for polar and radial charts.
        *
        * Set `isSquare` to true to constrain the chart to a square, using the minimum of its height and width.
        *
        * ```html
        * <igx-data-chart [dataSource]="data"
        *     isSquare="true"
        *     width="800px"
        *     height="400px">
        *   <igx-category-x-axis #xAxis
        *     label="label">
        *   </igx-category-x-axis>
        *   <igx-numeric-y-axis #yAxis
        *     majorStroke="green">
        *   </igx-numeric-y-axis>
        *
        *   <igx-column-series
        *     [xAxis]="xAxis"
        *     [yAxis]="yAxis"
        *     valueMemberPath="value">
        *   </igx-column-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        *  this.chart.isSquare="True";
        * ```
        */
            get: function () {
                return this.i.qk;
            },
            set: function (v) {
                this.i.qk = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "windowScaleHorizontal", {
            /**
             * A number between 0 and 1 determining the scale of the horizontal zoom.
             * This property is effectively a shortcut to the Width of the WindowRect property.
            *
            * To programmatically change the horizontal zoom level, set `windowScaleHorizontal` to a value between 0 and 1.
            *
            * ```html
            * <igx-data-chart [dataSource]="data"
            *     windowScaleHorizontal="0.75">
            *   <igx-category-x-axis #xAxis
            *     label="label">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.windowScaleHorizontal="0.75";
            * ```
            */
            get: function () {
                return this.i.rj;
            },
            set: function (v) {
                this.i.rj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "windowScaleVertical", {
            /**
             * A number between 0 and 1 determining the scale of the vertical zoom.
             * This property is effectively a shortcut to the Height of the WindowRect property.
            *
            * To programmatically change the vertical zoom level, set `windowScaleVertical` to a value between 0 and 1.
            *
            * ```html
            * <igx-data-chart [dataSource]="data"
            *     windowScaleVertical="0.75">
            *   <igx-category-x-axis #xAxis
            *     label="label">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.windowScaleVertical="0.75";
            * ```
            */
            get: function () {
                return this.i.rk;
            },
            set: function (v) {
                this.i.rk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "actualWindowScaleHorizontal", {
            /**
             * A number between 0 and 1 determining the scale of the horizontal zoom.
             * This property is effectively a shortcut to the Width of the ActualWindowRect property.
            */
            get: function () {
                return this.i.q7;
            },
            set: function (v) {
                this.i.q7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "actualWindowScaleVertical", {
            /**
             * A number between 0 and 1 determining the scale of the vertical zoom.
             * This property is effectively a shortcut to the Height of the ActualWindowRect property.
            */
            get: function () {
                return this.i.q8;
            },
            set: function (v) {
                this.i.q8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "isHorizontalZoomEnabled", {
            /**
             * Gets or sets horizontal zoomability of the current control
            *
            * Set `isHorizontalZoomEnabled` to enable or disable horizontal zooming.
            *
            * ```html
            * <igx-data-chart [dataSource]="data"
            *     isHorizontalZoomEnabled="true">
            *   <igx-category-x-axis #xAxis
            *     label="label">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.IsHorizontalZoomEnabled= true;
            * ```
            */
            get: function () {
                return this.i.qi;
            },
            set: function (v) {
                this.i.qi = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "isVerticalZoomEnabled", {
            /**
             * Gets or sets vertical zoomability of the current control
            *
            * Set `isVerticalZoomEnabled` to enable or disable vertical zooming.
            *
            * ```html
            * <igx-data-chart [dataSource]="data"
            *     isVerticalZoomEnabled="true">
            *   <igx-category-x-axis #xAxis
            *     label="label">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis>
            *   </igx-numeric-y-axis>
            *
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * this.chart.isVerticalZoomEnabled="True";
            * ```
            */
            get: function () {
                return this.i.ql;
            },
            set: function (v) {
                this.i.ql = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "gridMode", {
            /**
             * Gets or sets how grid lines are rendered in relation to series.
            *
            *  Try setting the `gridMode` property to bring your grid lines in front of the data series.
            *
            * ```html
            * <igx-data-chart [dataSource]="data"
            *     gridMode="beforeSeries">
            *   <igx-category-x-axis #xAxis
            *     label="label">
            *   </igx-category-x-axis>
            *   <igx-numeric-y-axis #yAxis
            *     majorStroke="green">
            *   </igx-numeric-y-axis>
            *
            *   <igx-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     valueMemberPath="value">
            *   </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                return this.i.p6;
            },
            set: function (v) {
                this.i.p6 = i2.ensureEnum(GridMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "alignsGridLinesToPixels", {
            /**
             * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
            */
            get: function () {
                return this.i.qe;
            },
            set: function (v) {
                this.i.qe = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "autoExpandMarginMaximumValue", {
            /**
             * Gets or sets the maximum amount the series viewer should auto expand margins to accomodate the initial horizontal axis labels.
            */
            get: function () {
                return this.i.ra;
            },
            set: function (v) {
                this.i.ra = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "autoExpandMarginExtraPadding", {
            /**
             * Gets or sets the extra amount the series viewer should auto expand margins to accomodate the initial horizontal axis labels.
            */
            get: function () {
                return this.i.q9;
            },
            set: function (v) {
                this.i.q9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "shouldAutoExpandMarginForInitialLabels", {
            /**
             * Gets or sets a whether the series viewer should auto expand margins to accomodate the initial horizontal axis labels.
            */
            get: function () {
                return this.i.qn;
            },
            set: function (v) {
                this.i.qn = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "defaultAxisStroke", {
            /**
             * Gets or sets the DefaultAxisStroke property.
             * The DefaultAxisStroke property defines the brush which is used by the axes when no Axis.Stroke is set.
            */
            get: function () {
                return i2.brushToString(this.i.s3);
            },
            set: function (v) {
                this.i.s3 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "defaultAxisMajorStroke", {
            /**
             * Gets or sets the DefaultAxisMajorStroke property.
             * The DefaultAxisMajorStroke property defines the brush which is used by the axes when no Axis.MajorStroke is set.
            */
            get: function () {
                return i2.brushToString(this.i.s1);
            },
            set: function (v) {
                this.i.s1 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "defaultAxisMinorStroke", {
            /**
             * Gets or sets the DefaultAxisMinorStroke property.
             * The DefaultAxisMinorStroke property defines the brush which is used by the axes when no Axis.MinorStroke is set.
            */
            get: function () {
                return i2.brushToString(this.i.s2);
            },
            set: function (v) {
                this.i.s2 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "actualPlotAreaMarginLeft", {
            /**
             * Gets the actual resolved left plot area margin;
            */
            get: function () {
                return this.i.q4;
            },
            set: function (v) {
                this.i.q4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "actualPlotAreaMarginTop", {
            /**
             * Gets the actual resolved top plot area margin;
            */
            get: function () {
                return this.i.q6;
            },
            set: function (v) {
                this.i.q6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "actualPlotAreaMarginRight", {
            /**
             * Gets the actual resolved right plot area margin;
            */
            get: function () {
                return this.i.q5;
            },
            set: function (v) {
                this.i.q5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "actualPlotAreaMarginBottom", {
            /**
             * Gets the actual resolved bottom plot area margin;
            */
            get: function () {
                return this.i.q3;
            },
            set: function (v) {
                this.i.q3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "computedPlotAreaMarginMode", {
            /**
             * Gets or sets mode to use for automatically calculating the plot area margin.
            */
            get: function () {
                return this.i.p4;
            },
            set: function (v) {
                this.i.p4 = i2.ensureEnum(ComputedPlotAreaMarginMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "plotAreaMarginLeft", {
            /**
             * Margin applied to the left of the plot area.
            */
            get: function () {
                return this.i.rg;
            },
            set: function (v) {
                this.i.rg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "plotAreaMarginTop", {
            /**
             * Margin applied above the plot area.
            */
            get: function () {
                return this.i.ri;
            },
            set: function (v) {
                this.i.ri = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "plotAreaMarginRight", {
            /**
             * Margin applied to the right of the plot area.
            */
            get: function () {
                return this.i.rh;
            },
            set: function (v) {
                this.i.rh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxDataChartComponent.prototype, "plotAreaMarginBottom", {
            /**
             * Margin applied below the plot area.
            */
            get: function () {
                return this.i.rf;
            },
            set: function (v) {
                this.i.rf = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxDataChartComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.axes != null && this.axes.findByName && this.axes.findByName(name)) {
                return this.axes.findByName(name);
            }
            return null;
        };
        IgxDataChartComponent.prototype.refreshComputedPlotAreaMargin = function () {
            this.i.si();
        };
        IgxDataChartComponent.prototype.recalculateMarginAutoExpansion = function () {
            this.i.sh();
        };
        /**
         * Notifies the chart that the CSS styles in effect have been updated.
        
        */
        IgxDataChartComponent.prototype.styleUpdated = function () {
            this.i.sj();
        };
        /**
         * Export serialized visual data.
        
        */
        IgxDataChartComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.r0();
            return (iv);
        };
        IgxDataChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.ComponentFactoryResolver }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
        IgxDataChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxDataChartComponent, selector: "igx-data-chart", inputs: { height: "height", width: "width", legend: "legend", dataSource: "dataSource", syncChannel: "syncChannel", synchronizeVertically: "synchronizeVertically", synchronizeHorizontally: "synchronizeHorizontally", isSquare: "isSquare", windowScaleHorizontal: "windowScaleHorizontal", windowScaleVertical: "windowScaleVertical", actualWindowScaleHorizontal: "actualWindowScaleHorizontal", actualWindowScaleVertical: "actualWindowScaleVertical", isHorizontalZoomEnabled: "isHorizontalZoomEnabled", isVerticalZoomEnabled: "isVerticalZoomEnabled", gridMode: "gridMode", alignsGridLinesToPixels: "alignsGridLinesToPixels", autoExpandMarginMaximumValue: "autoExpandMarginMaximumValue", autoExpandMarginExtraPadding: "autoExpandMarginExtraPadding", shouldAutoExpandMarginForInitialLabels: "shouldAutoExpandMarginForInitialLabels", defaultAxisStroke: "defaultAxisStroke", defaultAxisMajorStroke: "defaultAxisMajorStroke", defaultAxisMinorStroke: "defaultAxisMinorStroke", actualPlotAreaMarginLeft: "actualPlotAreaMarginLeft", actualPlotAreaMarginTop: "actualPlotAreaMarginTop", actualPlotAreaMarginRight: "actualPlotAreaMarginRight", actualPlotAreaMarginBottom: "actualPlotAreaMarginBottom", computedPlotAreaMarginMode: "computedPlotAreaMarginMode", plotAreaMarginLeft: "plotAreaMarginLeft", plotAreaMarginTop: "plotAreaMarginTop", plotAreaMarginRight: "plotAreaMarginRight", plotAreaMarginBottom: "plotAreaMarginBottom" }, host: { classAttribute: "igx-data-chart ig-data-chart" }, providers: [{ provide: IgxSeriesViewerComponent, useExisting: i0.forwardRef(function () { return IgxDataChartComponent; }) }], queries: [{ propertyName: "contentAxes", predicate: IgxAxisComponent }, { propertyName: "contentSeries", predicate: IgxSeriesComponent }], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], usesInheritance: true, ngImport: i0, template: "<ng-container #dynamicContent></ng-container>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxDataChartComponent;
    }(IgxSeriesViewerComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-data-chart',
                        template: "<ng-container #dynamicContent></ng-container>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [{ provide: IgxSeriesViewerComponent, useExisting: i0.forwardRef(function () { return IgxDataChartComponent; }) }],
                        host: { 'class': 'igx-data-chart ig-data-chart' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.ComponentFactoryResolver }, { type: i0.Injector }]; }, propDecorators: { contentAxes: [{
                    type: i0.ContentChildren,
                    args: [IgxAxisComponent]
                }], contentSeries: [{
                    type: i0.ContentChildren,
                    args: [IgxSeriesComponent]
                }], _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], legend: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], syncChannel: [{
                    type: i0.Input
                }], synchronizeVertically: [{
                    type: i0.Input
                }], synchronizeHorizontally: [{
                    type: i0.Input
                }], isSquare: [{
                    type: i0.Input
                }], windowScaleHorizontal: [{
                    type: i0.Input
                }], windowScaleVertical: [{
                    type: i0.Input
                }], actualWindowScaleHorizontal: [{
                    type: i0.Input
                }], actualWindowScaleVertical: [{
                    type: i0.Input
                }], isHorizontalZoomEnabled: [{
                    type: i0.Input
                }], isVerticalZoomEnabled: [{
                    type: i0.Input
                }], gridMode: [{
                    type: i0.Input
                }], alignsGridLinesToPixels: [{
                    type: i0.Input
                }], autoExpandMarginMaximumValue: [{
                    type: i0.Input
                }], autoExpandMarginExtraPadding: [{
                    type: i0.Input
                }], shouldAutoExpandMarginForInitialLabels: [{
                    type: i0.Input
                }], defaultAxisStroke: [{
                    type: i0.Input
                }], defaultAxisMajorStroke: [{
                    type: i0.Input
                }], defaultAxisMinorStroke: [{
                    type: i0.Input
                }], actualPlotAreaMarginLeft: [{
                    type: i0.Input
                }], actualPlotAreaMarginTop: [{
                    type: i0.Input
                }], actualPlotAreaMarginRight: [{
                    type: i0.Input
                }], actualPlotAreaMarginBottom: [{
                    type: i0.Input
                }], computedPlotAreaMarginMode: [{
                    type: i0.Input
                }], plotAreaMarginLeft: [{
                    type: i0.Input
                }], plotAreaMarginTop: [{
                    type: i0.Input
                }], plotAreaMarginRight: [{
                    type: i0.Input
                }], plotAreaMarginBottom: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHorizontalRangeCategorySeriesProxy_$type = new i2.Type(null, 'IHorizontalRangeCategorySeriesProxy');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IHasHighLowValueCategory_$type = new i2.Type(null, 'IHasHighLowValueCategory');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultHighLowValueProvider = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultHighLowValueProvider, _super);
        function DefaultHighLowValueProvider() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(DefaultHighLowValueProvider.prototype, "highColumn", {
            get: function () {
                return new i2.FastItemColumn(null, null, null, false);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DefaultHighLowValueProvider.prototype, "lowColumn", {
            get: function () {
                return new i2.FastItemColumn(null, null, null, false);
            },
            enumerable: false,
            configurable: true
        });
        DefaultHighLowValueProvider.$t = i2.markType(DefaultHighLowValueProvider, 'DefaultHighLowValueProvider', i2.Base.$, [IHasHighLowValueCategory_$type]);
        return DefaultHighLowValueProvider;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HighLowValuesHolder = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighLowValuesHolder, _super);
        function HighLowValuesHolder() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.g = null;
            return _this;
        }
        HighLowValuesHolder.prototype.get_e = function () {
            if (this.f == null || this.g == null) {
                return 0;
            }
            return Math.min(this.f.count, this.g.count);
        };
        Object.defineProperty(HighLowValuesHolder.prototype, "e", {
            get: function () {
                return this.get_e();
            },
            enumerable: false,
            configurable: true
        });
        HighLowValuesHolder.$t = i2.markType(HighLowValuesHolder, 'HighLowValuesHolder', ValuesHolder.$);
        return HighLowValuesHolder;
    }(ValuesHolder));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RangeCategoryFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeCategoryFramePreparer, _super);
        function RangeCategoryFramePreparer(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = [c, i2.typeCast(ISupportsMarkers_$type, c), i2.typeCast(IProvidesViewport_$type, c), i2.typeCast(ISupportsErrorBars_$type, c), i2.typeCast(IBucketizer_$type, c)];
                        {
                            var f = d[0];
                            var g = d[1];
                            var h = d[2];
                            var i = d[3];
                            var j = d[4];
                            _this = _super.call(this, 1, f, g, h, i, j) || this;
                            _this.aa = null;
                            _this.ab = null;
                            _this.aa = new DefaultCategoryTrendlineHost();
                            if (i2.typeCast(IHasCategoryTrendline_$type, f) !== null) {
                                _this.aa = i2.typeCast(IHasCategoryTrendline_$type, f);
                            }
                            _this.ab = new DefaultHighLowValueProvider();
                            if (i2.typeCast(IHasHighLowValueCategory_$type, f) !== null) {
                                _this.ab = i2.typeCast(IHasHighLowValueCategory_$type, f);
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        _this = _super.call(this, 1, c, d, e, f, g) || this;
                        _this.aa = null;
                        _this.ab = null;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        if (i2.typeCast(IHasCategoryTrendline_$type, c) !== null) {
                            _this.aa = i2.typeCast(IHasCategoryTrendline_$type, c);
                        }
                        _this.ab = new DefaultHighLowValueProvider();
                        if (i2.typeCast(IHasHighLowValueCategory_$type, c) !== null) {
                            _this.ab = i2.typeCast(IHasHighLowValueCategory_$type, c);
                        }
                    }
                    break;
            }
            return _this;
        }
        RangeCategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
            var g = b[0];
            var h = b[1];
            var i = b[2];
            if (!i2.isNaN_(g) && !i2.isNaN_(h) && !i2.isNaN_(i)) {
                a.m.add({ $type: i2.Point_$type, x: g, y: (h + i) / 2 });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        };
        RangeCategoryFramePreparer.prototype.z = function (a, b, c, d) {
            var e = a;
            var f = e.f;
            var g = e.g;
            var h = f.item(b);
            var i = g.item(b);
            var j = Math.max(h, i);
            var k = Math.min(h, i);
            if (c) {
                e.c = k;
                e.d = j;
            }
            else {
                e.b = j;
                e.a = k;
            }
        };
        RangeCategoryFramePreparer.prototype.u = function (a, b, c) {
            var d = a;
            var e = d.f;
            var f = d.g;
            var g = e.item(b);
            var h = f.item(b);
            if (!i2.isNaN_(g)) {
                d.b = Math.max(d.b, g);
                d.a = Math.min(d.a, g);
            }
            if (!i2.isNaN_(h)) {
                d.b = Math.max(d.b, h);
                d.a = Math.min(d.a, h);
            }
        };
        RangeCategoryFramePreparer.prototype.e = function (a, b) {
            var c = b;
            return [a, c.a, c.b];
        };
        RangeCategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
            if (d) {
                b[0] = b[0] + c;
            }
            else {
                b[0] = a.b.j$b(b[0], e) + c;
            }
            b[1] = a.c.j$b(b[1], f);
            b[2] = a.c.j$b(b[2], f);
        };
        RangeCategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
            _super.prototype.y.call(this, a, b, c, d, e, f, g);
            var h = a.h;
            var i = a.a.f.count;
            var j = a.a.f;
            var k = this.q;
            var l = k.count;
            var m = new i2.List$1(i2.Number_$type, 0);
            if (!c) {
                m.add(0);
            }
            var n = new i2.List$1(i2.Number_$type, 0);
            n.add(1);
            n.add(2);
            a.b.j$d(j, m, 0, i, d);
            a.c.j$d(j, n, 0, i, e);
            for (var o = 0; o < i; o++) {
                j._inner[o][0] = j._inner[o][0] + b;
            }
            if (g) {
                a.b.j$d(k, m, 0, l, d);
                a.c.j$d(k, n, 0, l, e);
                for (var p = 0; p < l; p++) {
                    k._inner[p][0] = k._inner[p][0] + b;
                }
            }
        };
        RangeCategoryFramePreparer.prototype.j = function (a) {
            var b = new HighLowValuesHolder();
            b.f = this.ab.highColumn;
            b.g = this.ab.lowColumn;
            return b;
        };
        RangeCategoryFramePreparer.$t = i2.markType(RangeCategoryFramePreparer, 'RangeCategoryFramePreparer', CategoryFramePreparerBase.$);
        return RangeCategoryFramePreparer;
    }(CategoryFramePreparerBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RangeCategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeCategoryBucketCalculator, _super);
        function RangeCategoryBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.j = null;
            _this.l = 0;
            _this.k = 0;
            _this.i = null;
            _this.h = null;
            _this.j = a;
            return _this;
        }
        RangeCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            var b = false;
            var c = this.i;
            var d = this.h;
            var e = this.l;
            var f = this.k;
            var g = Math.min(e, f);
            var h = a * this.d;
            var i = Math.min(h + this.d - 1, g - 1);
            var j = 1.7976931348623157E+308;
            var k = -1.7976931348623157E+308;
            var l = true;
            var m = 0;
            var n = 0;
            var o;
            var p;
            if (h <= i) {
                for (var q = h; q <= i; ++q) {
                    m = c[q];
                    n = d[q];
                    if (m < n) {
                        o = m;
                        p = n;
                    }
                    else {
                        p = m;
                        o = n;
                    }
                    if (!l) {
                        j = j < o ? j : o;
                        k = k > o ? k : o;
                        j = j < p ? j : p;
                        k = k > p ? k : p;
                    }
                    else {
                        j = Math.min(j, o);
                        k = Math.max(k, o);
                        k = Math.max(k, p);
                        j = Math.min(j, p);
                        l = false;
                    }
                }
            }
            if (b && n < m) {
                var r = j;
                j = k;
                k = r;
            }
            if (!l) {
                var s = new Array(3);
                s[0] = 0.5 * (h + i);
                s[1] = j;
                s[2] = k;
                return s;
            }
            var t = new Array(3);
            t[0] = NaN;
            t[1] = NaN;
            t[2] = NaN;
            return t;
        };
        RangeCategoryBucketCalculator.prototype.getBucket = function (a) {
            var b = false;
            var c = this.i;
            var d = this.h;
            var e = this.l;
            var f = this.k;
            var g = Math.min(e, f);
            var h = a * this.d;
            var i = Math.min(h + this.d - 1, g - 1);
            var j = NaN;
            var k = NaN;
            var l = true;
            var m = 0;
            var n = 0;
            var o;
            var p;
            if (h <= i) {
                for (var q = h; q <= i; ++q) {
                    m = c[q];
                    n = d[q];
                    if (m < n) {
                        o = m;
                        p = n;
                    }
                    else {
                        p = m;
                        o = n;
                    }
                    if (!l) {
                        if (!i2.isNaN_(o)) {
                            j = j < o ? j : o;
                            k = k > o ? k : o;
                        }
                        if (!i2.isNaN_(p)) {
                            j = j < p ? j : p;
                            k = k > p ? k : p;
                        }
                    }
                    else {
                        if (!i2.isNaN_(o)) {
                            if (i2.isNaN_(j)) {
                                j = o;
                            }
                            else {
                                j = Math.min(j, o);
                            }
                            if (!i2.isNaN_(k)) {
                                k = Math.max(k, o);
                            }
                        }
                        if (!i2.isNaN_(p)) {
                            if (i2.isNaN_(k)) {
                                k = p;
                            }
                            else {
                                k = Math.max(k, p);
                            }
                            if (!i2.isNaN_(j)) {
                                j = Math.min(j, p);
                            }
                        }
                        if (!i2.isNaN_(j) && !i2.isNaN_(k)) {
                            l = false;
                        }
                    }
                }
            }
            if (n < m && b) {
                var r = j;
                j = k;
                k = r;
            }
            if (!l) {
                var s = new Array(3);
                s[0] = 0.5 * (h + i);
                s[1] = j;
                s[2] = k;
                return s;
            }
            var t = new Array(3);
            t[0] = NaN;
            t[1] = NaN;
            t[2] = NaN;
            return t;
        };
        RangeCategoryBucketCalculator.prototype.cacheValues = function () {
            this.l = this.j.c0.lowColumn.count;
            this.k = this.j.c0.highColumn.count;
            this.i = this.j.c0.lowColumn.asArray();
            this.h = this.j.c0.highColumn.asArray();
        };
        RangeCategoryBucketCalculator.prototype.unCacheValues = function () {
            this.i = null;
            this.h = null;
        };
        RangeCategoryBucketCalculator.$t = i2.markType(RangeCategoryBucketCalculator, 'RangeCategoryBucketCalculator', CategoryBucketCalculator.$);
        return RangeCategoryBucketCalculator;
    }(CategoryBucketCalculator));
    /**
     * @hidden
     */
    var RangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeCategorySeries, _super);
        function RangeCategorySeries() {
            var _this = _super.call(this) || this;
            _this._RangeFramePreparer = null;
            _this.sw = null;
            _this.sv = null;
            _this.ss = null;
            _this.RangeFramePreparer = new RangeCategoryFramePreparer(1, _this, _this.su, _this, _this, _this.su.cr);
            return _this;
        }
        RangeCategorySeries.prototype.bu = function () {
            return new RangeCategorySeriesView(this);
        };
        RangeCategorySeries.prototype.getHostReferenceValue = function () {
            return this.f2();
        };
        RangeCategorySeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.su = a;
        };
        Object.defineProperty(RangeCategorySeries.prototype, "RangeFramePreparer", {
            get: function () {
                return this._RangeFramePreparer;
            },
            set: function (a) {
                this._RangeFramePreparer = a;
            },
            enumerable: false,
            configurable: true
        });
        RangeCategorySeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == RangeCategorySeries.$$p[0]) {
                return this.hl(a, b, this.s0);
            }
            if (c == RangeCategorySeries.$$p[0]) {
                return this.hl(a, b, this.s0);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(RangeCategorySeries.prototype, "lowColumn", {
            get: function () {
                return this.sw;
            },
            set: function (a) {
                if (this.sw != a) {
                    var b = this.sw;
                    this.sw = a;
                    this.raisePropertyChanged("LowColumn", b, this.sw);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeCategorySeries.prototype, "highColumn", {
            get: function () {
                return this.sv;
            },
            set: function (a) {
                if (this.sv != a) {
                    var b = this.sv;
                    this.sv = a;
                    this.raisePropertyChanged("HighColumn", b, this.sv);
                }
            },
            enumerable: false,
            configurable: true
        });
        RangeCategorySeries.prototype.rd = function () {
            return 11;
        };
        RangeCategorySeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            b.b3 = true;
            CategoryMarkerManager.e(this, a.m, b.cu, this.pv);
            this.sf(b, a);
        };
        RangeCategorySeries.prototype.s5 = function (a, b, c, d, e, f) {
            this.su.c1(a, b, c, d, e, f);
        };
        RangeCategorySeries.prototype.aq = function (a) {
            if (a.isEmpty && this.ca != null) {
                a = this.ca.pg;
            }
            var b = this.q2();
            if (this.lowColumn == null || this.highColumn == null) {
                return null;
            }
            var c = this.o7(this.bx);
            var d = new ScalerParams(0, a, this.ca.pv, b.cc, this.getEffectiveViewport());
            var e = (b.eb(c.left, d));
            var f = (b.eb(c.right, d));
            if (b.cc) {
                var g = e;
                e = f;
                f = g;
            }
            var h = null;
            if (b.ch) {
                h = b;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            e = Math.max(0, Math.min(this.lowColumn.count - 1, e));
            f = Math.max(0, Math.min(this.lowColumn.count - 1, f));
            var i = 1.7976931348623157E+308;
            var j = -1.7976931348623157E+308;
            for (var k = i2.truncate(e); k <= i2.truncate(f); k++) {
                var l = k;
                if (h != null) {
                    l = h.i$b._inner[k];
                }
                var m = this.lowColumn.item(l);
                if (this.lowColumn.mayContainUnknowns) {
                    if (i2.isInfinity(m) || i2.isNaN_(m)) {
                        continue;
                    }
                }
                var n = this.highColumn.item(l);
                if (this.highColumn.mayContainUnknowns) {
                    if (i2.isInfinity(n) || i2.isNaN_(n)) {
                        continue;
                    }
                }
                i = Math.min(i, m);
                j = Math.max(j, n);
            }
            var o = new AxisRange(i, j);
            var p = this.rn();
            o = this.ao(o, p, a);
            return o;
        };
        RangeCategorySeries.prototype.eh = function (a) {
            var b = new i2.Rect(0, 0, 0, 1, 1);
            var c = this.bx != null ? this.bx.bv : i2.Rect.empty;
            c = c.copy();
            var d = this.bx != null ? this.bx.bu : i2.Rect.empty;
            var e = !c.isEmpty && !d.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            var f = this.fetchXAxis();
            var g = this.fetchYAxis();
            var h = this.o9(this.bx);
            var i;
            if (f != null) {
                var j = new ScalerParams(0, b, b, f.cc, h);
                i = f.d8(e, j);
            }
            else {
                i = NaN;
            }
            var k = f != null ? this.RangeFramePreparer.r(i2.typeCast(ICategoryScaler_$type, f), b, b, h) : 0;
            i += k;
            if (e >= 0 && i2.Rect.l_op_Inequality(c, null) && i2.Rect.l_op_Inequality(d, null)) {
                if (!i2.isNaN_(i)) {
                    if (i < c.left + 0.1 * c.width) {
                        i = i + 0.4 * c.width;
                    }
                    if (i > c.right - 0.1 * c.width) {
                        i = i - 0.4 * c.width;
                    }
                    c.x = i - 0.5 * c.width;
                }
                if (g != null && this.highColumn != null && e < this.highColumn.count) {
                    var l = new ScalerParams(0, b, b, g.cc, h);
                    l.b = this.f2();
                    var m = g.d8(this.highColumn.item(e), l);
                    var n = g.d8(this.lowColumn.item(e), l);
                    if (!i2.isNaN_(m) && !i2.isNaN_(n)) {
                        var o = Math.abs(n - m);
                        if (c.height < o) {
                            c.height = o;
                            c.y = Math.min(n, m);
                        }
                        else {
                            if (n < c.top + 0.1 * c.height) {
                                n = n + 0.4 * c.height;
                            }
                            if (n > c.bottom - 0.1 * c.height) {
                                n = n - 0.4 * c.height;
                            }
                            c.y = n - 0.5 * c.height;
                        }
                    }
                }
                if (this.b5 != null) {
                    this.b5.ap(this.ca, c, true);
                }
            }
            return e >= 0;
        };
        RangeCategorySeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.lowColumn);
                        c.deregisterColumn(this.highColumn);
                        this.lowColumn = null;
                        this.highColumn = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.lowColumn = this.ce(this.s3);
                        this.highColumn = this.ce(this.s0);
                    }
                    if (!this.rx()) {
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case RangeCategorySeries.$$p[1]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.lowColumn);
                        this.lowColumn = this.ce(this.s3);
                    }
                    break;
                case "LowColumn":
                    if (!this.rx()) {
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case RangeCategorySeries.$$p[0]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.highColumn);
                        this.highColumn = this.ce(this.s0);
                    }
                    break;
                case "HighColumn":
                    if (!this.rx()) {
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
            }
        };
        RangeCategorySeries.prototype.ap = function (a) {
            if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                var b = Math.min(this.lowColumn.count, this.highColumn.count);
                return new AxisRange(0, b - 1);
            }
            if (a == this.fetchYAxis()) {
                var c = Math.min(this.lowColumn.minimum, this.highColumn.minimum);
                var d = Math.max(this.lowColumn.maximum, this.highColumn.maximum);
                return new AxisRange(Math.min(c, d), Math.max(c, d));
            }
            return null;
        };
        RangeCategorySeries.prototype.kk = function (a, b, c, d) {
            if (this.fetchXAxis() != null && i2.typeCast(ISortingAxis_$type, this.fetchXAxis()) !== null) {
                this.fetchXAxis().i$i();
            }
            var e = this.fetchXAxis();
            switch (a) {
                case 3:
                    if (d == this.s3 || d == this.s0) {
                        if (e != null) {
                            e.cv();
                        }
                        if (!this.rx()) {
                            this.l0(true);
                        }
                    }
                    break;
                case 1:
                    if (e != null) {
                        e.cv();
                    }
                    this.rc.cr.g(this.gh);
                    if (!this.rx()) {
                        this.l0(true);
                    }
                    break;
                case 0:
                    if (e != null) {
                        e.cv();
                    }
                    this.rc.cr.g(this.gh);
                    if (!this.rx()) {
                        this.l0(true);
                    }
                    break;
                case 2:
                    if (e != null) {
                        e.cv();
                    }
                    if (this.s3 != null && this.s0 != null && this.rc.cr.d > 0 && !this.rx()) {
                        this.l0(true);
                    }
                    break;
                case 4:
                    if (e != null) {
                        e.cv();
                    }
                    this.rc.cr.g(this.gh);
                    if (!this.rx()) {
                        this.l0(true);
                    }
                    break;
            }
        };
        RangeCategorySeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
                d = false;
            }
            return d;
        };
        RangeCategorySeries.prototype.si = function (a, b) {
            _super.prototype.si.call(this, a, b);
            this.RangeFramePreparer.d(a, b);
        };
        Object.defineProperty(RangeCategorySeries.prototype, "currentCategoryMode", {
            get: function () {
                return this.preferredCategoryMode(i2.typeCast(CategoryAxisBase.$, this.fetchXAxis()));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeCategorySeries.prototype, "scaler", {
            get: function () {
                return i2.typeCast(ICategoryScaler_$type, this.fetchXAxis());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeCategorySeries.prototype, "yScaler", {
            get: function () {
                return i2.typeCast(IScaler_$type, this.fetchYAxis());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeCategorySeries.prototype, "bucketizer", {
            get: function () {
                return this.rc.cr;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeCategorySeries.prototype, "currentMode2Index", {
            get: function () {
                return this.r6();
            },
            enumerable: false,
            configurable: true
        });
        RangeCategorySeries.prototype.provideCollisionDetector = function () {
            return new CollisionAvoider();
        };
        Object.defineProperty(RangeCategorySeries.prototype, "mayContainUnknowns", {
            get: function () {
                return this.lowColumn == null || this.lowColumn.mayContainUnknowns || this.highColumn == null || this.highColumn.mayContainUnknowns;
            },
            enumerable: false,
            configurable: true
        });
        RangeCategorySeries.prototype.l2 = function (a, b) {
            var c = this.et;
            _super.prototype.l2.call(this, a, b);
            if (!c) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            var d = new RangeCategoryFramePreparer(1, this, i2.typeCast(ISupportsMarkers_$type, this.bw), this.ca.cf.o, this, this.bw.cr);
            if (!this.en) {
                this.q6 = new CategoryFrame(3);
                this.q6.u();
                d.d(this.q6, this.bw);
            }
            this.en = false;
            this.sl(this.q6, this.bw);
            this.et = false;
        };
        RangeCategorySeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            g.cr.g(this.gh);
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            var h = new RangeCategoryFramePreparer(1, this, i2.typeCast(ISupportsMarkers_$type, f), f, this, f.cr);
            if (this.ss == null) {
                this.ss = new CategoryFrame(3);
            }
            this.ss.u();
            h.d(this.ss, g);
            this.sl(this.ss, g);
        };
        RangeCategorySeries.prototype.f2 = function () {
            return Series.f3(this.lowColumn, i2.typeCast(ISortingAxis_$type, this.fetchXAxis()));
        };
        Object.defineProperty(RangeCategorySeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        RangeCategorySeries.$t = i2.markType(RangeCategorySeries, 'RangeCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasHighLowValueCategory_$type]);
        RangeCategorySeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RangeCategorySeries, 'raisePropertyChanged', ['HighMemberPath:s0:s6', [2, null], 'LowMemberPath:s3:s7', [2, null]]);
        return RangeCategorySeries;
    }(CategorySeries));
    /**
     * @hidden
     */
    var RangeCategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeCategorySeriesView, _super);
        function RangeCategorySeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c0 = a;
            return _this;
        }
        RangeCategorySeriesView.prototype.c1 = function (a, b, c, d, e, f) {
            a.ak.clear();
            b.ak.clear();
            c.ak.clear();
            var g = i2.FastFlattener.b(d, e, true, f, this.e.gh);
            var h = i2.FastFlattener.b(d, e, false, f, this.e.gh);
            var i = g.count;
            var j = h.count;
            var k;
            var l;
            var m;
            var n;
            for (var o = 0; o < i; o++) {
                k = g.item(o);
                l = e._inner[k];
                m = l[0];
                n = l[1];
                a.ak.add({ $type: i2.Point_$type, x: m, y: n });
                b.ak.add({ $type: i2.Point_$type, x: m, y: n });
            }
            var p;
            var q;
            for (var r = 0; r < j; r++) {
                k = h.item(r);
                l = e._inner[k];
                if (f) {
                    p = l[0];
                    q = l[2];
                }
                else {
                    p = l[2];
                    q = l[3];
                }
                c.ak.add({ $type: i2.Point_$type, x: p, y: q });
                b.ak.add({ $type: i2.Point_$type, x: p, y: q });
            }
            a.ab = a.ak.count > 0;
            b.ab = b.ak.count > 0;
            c.ab = c.ak.count > 0;
        };
        RangeCategorySeriesView.prototype.cs = function () {
            return new RangeCategoryBucketCalculator(this);
        };
        RangeCategorySeriesView.$t = i2.markType(RangeCategorySeriesView, 'RangeCategorySeriesView', CategorySeriesView.$);
        return RangeCategorySeriesView;
    }(CategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalRangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalRangeCategorySeries, _super);
        function HorizontalRangeCategorySeries() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
            return this.xAxis;
        };
        HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
            return this.yAxis;
        };
        HorizontalRangeCategorySeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.xAxis = null;
            this.yAxis = null;
        };
        HorizontalRangeCategorySeries.prototype.ah = function (a) {
            var b = this.aj(this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), this.o5(a), true);
            if (b == null) {
                return null;
            }
            var c = b[0];
            var d = b[1];
            var e = new Array(1);
            var f = new Array(2);
            f[0] = { $type: i2.Point_$type, x: c[0], y: c[2] };
            f[1] = { $type: i2.Point_$type, x: d[0], y: d[2] };
            e[0] = f;
            return e;
        };
        HorizontalRangeCategorySeries.prototype.ai = function (a) {
            var b = this.aj(this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), this.o5(a), true);
            if (b == null) {
                return null;
            }
            var c = b[0];
            var d = b[1];
            var e = new Array(1);
            var f = new Array(2);
            f[0] = { $type: i2.Point_$type, x: c[0], y: c[1] };
            f[1] = { $type: i2.Point_$type, x: d[0], y: d[1] };
            e[0] = f;
            return e;
        };
        HorizontalRangeCategorySeries.prototype.get_d5 = function () {
            return true;
        };
        HorizontalRangeCategorySeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
            return this.RangeFramePreparer.r(this.xAxis, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
            return this.xAxis.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        HorizontalRangeCategorySeries.prototype.g4 = function (a, b) {
            return this.g5(a, b, this.xAxis, i2.runOn(this, this.r1), new RangeValueList(this.highColumn, this.lowColumn));
        };
        HorizontalRangeCategorySeries.prototype.g6 = function (a, b) {
            return this.g7(a, b, this.xAxis, i2.runOn(this, this.r1), new RangeValueList(this.highColumn, this.lowColumn));
        };
        HorizontalRangeCategorySeries.prototype.fu = function (a, b, c, d, e) {
            if (c == null) {
                return Number.POSITIVE_INFINITY;
            }
            var f = this.xAxis.kq;
            return this.fv(a, b, this.xAxis, d, e, f, i2.runOn(this, this.r1));
        };
        HorizontalRangeCategorySeries.prototype.f8 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.ca.pg, this.bx.bu, this.xAxis.cc, d);
            var f = this.RangeFramePreparer.r(this.xAxis, this.ca.pg, this.bx.bu, d);
            return this.ga(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, i2.runOn(this, this.r1), b, c);
        };
        HorizontalRangeCategorySeries.prototype.f6 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.ca.pg, this.bx.bu, this.xAxis.cc, d);
            var f = this.RangeFramePreparer.r(this.xAxis, this.ca.pg, this.bx.bu, d);
            return this.ga(this.lowColumn, a, this.xAxis, e, f, i2.runOn(this, this.r1), b, c);
        };
        HorizontalRangeCategorySeries.prototype.f4 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.ca.pg, this.bx.bu, this.xAxis.cc, d);
            var f = this.RangeFramePreparer.r(this.xAxis, this.ca.pg, this.bx.bu, d);
            return this.ga(this.highColumn, a, this.xAxis, e, f, i2.runOn(this, this.r1), b, c);
        };
        HorizontalRangeCategorySeries.prototype.oy = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.yAxis, this.xAxis, i2.runOn(this, this.f4), function (d, e) { return _this.g7(d, e, _this.xAxis, i2.runOn(_this, _this.r1), _this.highColumn); }, function (d, e) { return _this.g5(d, e, _this.xAxis, i2.runOn(_this, _this.r1), _this.highColumn); });
        };
        HorizontalRangeCategorySeries.prototype.o0 = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.yAxis, this.xAxis, i2.runOn(this, this.f6), function (d, e) { return _this.g7(d, e, _this.xAxis, i2.runOn(_this, _this.r1), _this.lowColumn); }, function (d, e) { return _this.g5(d, e, _this.xAxis, i2.runOn(_this, _this.r1), _this.lowColumn); });
        };
        HorizontalRangeCategorySeries.prototype.o2 = function (a, b, c) {
            return this.o4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.yAxis, this.xAxis, null, null, null);
        };
        HorizontalRangeCategorySeries.prototype.rx = function () {
            return this.yAxis != null && this.yAxis.cv();
        };
        HorizontalRangeCategorySeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case HorizontalRangeCategorySeries.$$p[0]:
                    this.kl(i2.typeCast(Axis.$, c));
                    this.lr(i2.typeCast(Axis.$, d));
                    this.rc.cr.g(this.gh);
                    this.l0(false);
                    this.k7();
                    break;
                case HorizontalRangeCategorySeries.$$p[1]:
                    this.kl(i2.typeCast(Axis.$, c));
                    this.lr(i2.typeCast(Axis.$, d));
                    this.rc.cr.g(this.gh);
                    this.rx();
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        HorizontalRangeCategorySeries.prototype.tb = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        HorizontalRangeCategorySeries.prototype.ta = function (a) {
            if (i2.typeCast(CategoryXAxis.$, a) !== null || a.b9) {
                return true;
            }
            return false;
        };
        Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        HorizontalRangeCategorySeries.$t = i2.markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
        HorizontalRangeCategorySeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::te', [CategoryAxisBase.$, null], 'YAxis::tf', [NumericYAxis.$, null]]);
        return HorizontalRangeCategorySeries;
    }(RangeCategorySeries));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalRangeCategorySeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalRangeCategorySeriesProxy, _super);
        function HorizontalRangeCategorySeriesProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalRangeCategorySeriesProxy.prototype.matchesType = function (a) {
            return i2.typeCast(HorizontalRangeCategorySeries.$, a) !== null;
        };
        HorizontalRangeCategorySeriesProxy.prototype.setHighMemberPath = function (a, b) {
            a.s0 = b;
        };
        HorizontalRangeCategorySeriesProxy.prototype.setLowMemberPath = function (a, b) {
            a.s3 = b;
        };
        HorizontalRangeCategorySeriesProxy.prototype.setXAxis = function (a, b) {
            a.xAxis = b;
        };
        HorizontalRangeCategorySeriesProxy.prototype.setYAxis = function (a, b) {
            a.yAxis = b;
        };
        HorizontalRangeCategorySeriesProxy.$t = i2.markType(HorizontalRangeCategorySeriesProxy, 'HorizontalRangeCategorySeriesProxy', i2.Base.$, [IHorizontalRangeCategorySeriesProxy_$type]);
        return HorizontalRangeCategorySeriesProxy;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHorizontalRangeCategorySeriesProxyModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHorizontalRangeCategorySeriesProxyModule() {
            i2.TypeRegistrar.register('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy.$type);
        }
        IgxHorizontalRangeCategorySeriesProxyModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHorizontalRangeCategorySeriesProxyModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyModule, imports: [i1.CommonModule] });
        IgxHorizontalRangeCategorySeriesProxyModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyModule, imports: [[i1.CommonModule,
                ]] });
        return IgxHorizontalRangeCategorySeriesProxyModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Represents the base class for all IgxDataChartComponent ranged category/value series.
    *
    * The `IgxRangeCategorySeriesComponent` represents the base class for all IgxDataChartComponent ranged category/value series.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-range-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="high"
    *     lowMemberPath="low">
    * </igx-range-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxRangeColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * this.chart.series.add(series);
    * ```
    */
    var IgxRangeCategorySeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRangeCategorySeriesComponent, _super);
        function IgxRangeCategorySeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxRangeCategorySeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeCategorySeriesComponent.prototype, "lowMemberPath", {
            /**
             * Gets or sets the value mapping property for the current series object.
            *
            * The `lowMemberPath` is used for low mapping property of the current series object.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-range-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     highMemberPath="high"
            *     lowMemberPath="low">
            * </igx-range-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxRangeColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.highMemberPath = "high";
            * series.lowMemberPath = "low";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                return this.i.s3;
            },
            set: function (v) {
                this.i.s3 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeCategorySeriesComponent.prototype, "highMemberPath", {
            /**
             * Gets or sets the value mapping property for the current series object.
            *
            * Use `highMemberPath` propert for high mapping of the current series object.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-range-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     highMemberPath="high"
            *     lowMemberPath="low">
            * </igx-range-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.highMemberPath = "high";
            * ```
            */
            get: function () {
                return this.i.s0;
            },
            set: function (v) {
                this.i.s0 = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxRangeCategorySeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        *
        * `scrollIntoView` method Scrolls the series to display the item for the specified data item.
        */
        IgxRangeCategorySeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        IgxRangeCategorySeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeCategorySeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRangeCategorySeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRangeCategorySeriesComponent, selector: "ng-component", inputs: { lowMemberPath: "lowMemberPath", highMemberPath: "highMemberPath" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxRangeCategorySeriesComponent;
    }(IgxCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeCategorySeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { lowMemberPath: [{
                    type: i0.Input
                }], highMemberPath: [{
                    type: i0.Input
                }] } });

    /**
     * Base class for ranged category series with a category X-axis and a numeric Y-axis.
    *
    * Instantiate HorizontalAnchoredCategorySeries
    *
    * ```html
    *  <igx-data-chart
    *       [dataSource]="data"  >
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *           >
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    var IgxHorizontalRangeCategorySeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxHorizontalRangeCategorySeriesComponent, _super);
        function IgxHorizontalRangeCategorySeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current CategorySeries object.
            *
            * Instantiate xAxis
            *
            * <!-- Angular -->
            *
            * ```html
            *  <igx-data-chart
            *       [dataSource]="data"  >
            * 	  <igx-category-x-axis
            *         label="label"
            *         #xAxis
            *         >
            *       </igx-category-x-axis>
            * 	 <igx-column-series
            *     ...
            *         [xAxis]="xAxis"
            *     ...
            *           >
            *       </igx-column-series>
            * </igx-data-chart>
            * ```
            */
            get: function () {
                if (this.i.xAxis == null) {
                    return null;
                }
                if (!this.i.xAxis.externalObject) {
                    var e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.xAxis);
                    if (e) {
                        e._implementation = this.i.xAxis;
                    }
                    this.i.xAxis.externalObject = e;
                }
                return this.i.xAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current CategorySeries object.
            *
            * Instantiate yAxis
            *
            * <!-- Angular -->
            *
            * ```js
            *  <igx-data-chart
            *       [dataSource]="data"  >
            * 	  <igx-numeric-y-axis
            *         minimumValue="0"
            *         #yAxis>
            *       </igx-numeric-y-axis>
            * 	 <igx-column-series
            *     ...
            *         [yAxis]="yAxis"
            *     ...
            *           >
            *       </igx-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * let series = new IgxColumnSeriesComponent();
            * series.xAxis = this.xAxis;
            * series.yAxis = this.yAxis;
            * series.valueMemberPath="value";
            * this.chart.series.add(series);
            * ```
            */
            get: function () {
                if (this.i.yAxis == null) {
                    return null;
                }
                if (!this.i.yAxis.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
                    if (e) {
                        e._implementation = this.i.yAxis;
                    }
                    this.i.yAxis.externalObject = e;
                }
                return this.i.yAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "isRange", {
            /**
             * Checks if this series is a range series
            *
            * You can use the `isRange` to get the current series is a range type series.
            *
            * <!-- Angular JS -->
            *
            * ```ts
            *   var r = this.series.isRange;
            * ```
            */
            get: function () {
                return this.i.d5;
            },
            enumerable: false,
            configurable: true
        });
        IgxHorizontalRangeCategorySeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        *
        * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
        *
        * <!-- Angular JS -->
        *
        *       var g = series.getOffsetValue();
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        IgxHorizontalRangeCategorySeriesComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        *
        * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        IgxHorizontalRangeCategorySeriesComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f6(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f4(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.oy(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o0(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
        */
        IgxHorizontalRangeCategorySeriesComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.tb(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        */
        IgxHorizontalRangeCategorySeriesComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.ta(axis);
            return (iv);
        };
        IgxHorizontalRangeCategorySeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxHorizontalRangeCategorySeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxHorizontalRangeCategorySeriesComponent, selector: "ng-component", inputs: { xAxis: "xAxis", yAxis: "yAxis" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxHorizontalRangeCategorySeriesComponent;
    }(IgxRangeCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RangeAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeAreaSeries, _super);
        function RangeAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = RangeAreaSeries.$;
            return _this;
        }
        RangeAreaSeries.prototype.bu = function () {
            return new RangeAreaSeriesView(this);
        };
        RangeAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.tg = a;
        };
        RangeAreaSeries.prototype.get_c8 = function () {
            return true;
        };
        RangeAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        RangeAreaSeries.prototype.th = function (a, b, c, d) {
            if (i2.isNaN_(b.x) || i2.isNaN_(b.y)) {
                return false;
            }
            if (i2.isNaN_(c.x) || i2.isNaN_(c.y)) {
                return false;
            }
            if ((a.y <= b.y && a.y >= c.y)) {
                return true;
            }
            return false;
        };
        RangeAreaSeries.prototype.ep = function (a, b) {
            if (this.eo(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        RangeAreaSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        RangeAreaSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.c3();
        };
        RangeAreaSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = a.f.count;
            var d = new i2.List$1(i2.Array_$type, 2, c);
            for (var e = 0; e < c; e++) {
                var f = a.f._inner[e];
                var g = new Array(4);
                g[0] = f[0];
                g[1] = f[1];
                var h = a.f._inner[a.f.count - 1 - e];
                g[2] = h[0];
                g[3] = h[2];
                d.add(g);
            }
            var i = i2.typeCast(RangeAreaSeriesView.$, b);
            var j = this.getEffectiveViewport1(i);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var k = false;
            var l = this.rb.b;
            if (l != null) {
                k = true;
            }
            if (k) {
                var m = new ScalerParams(0, b.bv, b.bu, this.xAxis.cc, j);
                this.sh(d, -1, this.lowColumn.count, this.xAxis, m, b.q);
            }
            var n = i.dc;
            var o = i.dd;
            var p = i.c7;
            this.rb.ad(n, true, false, true, true);
            this.rb.ad(o, true, false, true, true);
            this.rb.ad(p, false, true, false, false);
            if (b.cv(a)) {
                i.c4(a.f.count, d, false);
                b.cy(a);
            }
            i.c7._opacity = this.rb.j * this.fi;
        };
        Object.defineProperty(RangeAreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        RangeAreaSeries.$t = i2.markType(RangeAreaSeries, 'RangeAreaSeries', HorizontalRangeCategorySeries.$);
        return RangeAreaSeries;
    }(HorizontalRangeCategorySeries));
    /**
     * @hidden
     */
    var RangeAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeAreaSeriesView, _super);
        function RangeAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c2 = null;
            _this.da = new i2.Polyline();
            _this.c6 = new i2.Polygon();
            _this.db = new i2.Polyline();
            _this.c9 = new i2.Polyline();
            _this.c8 = new i2.Polyline();
            _this.c5 = new i2.Polygon();
            _this.c2 = a;
            return _this;
        }
        RangeAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c2.pr = 1;
            }
        };
        Object.defineProperty(RangeAreaSeriesView.prototype, "dc", {
            get: function () {
                return this.da;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeAreaSeriesView.prototype, "c7", {
            get: function () {
                return this.c6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RangeAreaSeriesView.prototype, "dd", {
            get: function () {
                return this.db;
            },
            enumerable: false,
            configurable: true
        });
        RangeAreaSeriesView.prototype.c3 = function () {
            this.c6.ak.clear();
            this.da.ak.clear();
            this.db.ak.clear();
        };
        RangeAreaSeriesView.prototype.c4 = function (a, b, c) {
            this.c1(this.da, this.c6, this.db, a, b, c);
            this.aq();
        };
        RangeAreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.c8.ak = this.da.ak;
            this.c9.ak = this.db.ak;
            this.c5.ak = this.c6.ak;
            var a = this.bo();
            this.c8._stroke = a;
            this.c8.ac = this.e.fl + 3;
            this.c9._stroke = a;
            this.c9.ac = this.e.fl + 3;
            this.c5._fill = a;
            this.c5._opacity = 1;
        };
        RangeAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.t(this.c5);
                    a.u(this.c8);
                    a.u(this.c9);
                }
                else {
                    a.t(this.c6);
                    a.u(this.da);
                    a.u(this.db);
                }
            }
        };
        RangeAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPolylineData(a, this.da, "lowerShape", ["Lower"]);
            this.e.a6.exportPolylineData(a, this.db, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPolygonData(a, this.c6, "fillShape", ["Fill"]);
        };
        RangeAreaSeriesView.$t = i2.markType(RangeAreaSeriesView, 'RangeAreaSeriesView', RangeCategorySeriesView.$);
        return RangeAreaSeriesView;
    }(RangeCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent range area series.
    *
    * The `IgxRangeAreaSeriesComponent` class represents the range area series of the IgxDataChartComponent.
    *
    * ```html
    * <igx-data-chart
    * [dataSource]="data">
    * <igx-category-x-axis
    * 	label="label"
    * 	#xAxis>
    * </igx-category-x-axis>
    * <igx-numeric-y-axis
    * 	#yAxis>
    * </igx-numeric-y-axis>
    *     <igx-range-area-series
    *       [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       highMemberPath="high"
    *       lowMemberPath="low">
    *   </igx-range-area-series>
    *     </igx-data-chart>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series: IgxRangeAreaSeriesComponent = new IgxRangeAreaSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "High";
    * series.lowMemberPath = "Low";
    * this.chart.series.add(series);
    * ```
    */
    var IgxRangeAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRangeAreaSeriesComponent, _super);
        function IgxRangeAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxRangeAreaSeriesComponent.prototype.createImplementation = function () {
            return new RangeAreaSeries();
        };
        Object.defineProperty(IgxRangeAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeAreaSeriesComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            *
            * Use the `isAreaOrLine` property to check if the current series shows an area or line shape.
            *
            * ```ts
            * var x= series.isAreaOrLine;
            * ```
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        IgxRangeAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRangeAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRangeAreaSeriesComponent, selector: "igx-range-area-series", providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRangeAreaSeriesComponent;
    }(IgxHorizontalRangeCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-range-area-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRangeAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRangeAreaSeriesModule() {
        }
        IgxRangeAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRangeAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesModule, declarations: [IgxRangeAreaSeriesComponent], imports: [i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule], exports: [IgxRangeAreaSeriesComponent, IgxHorizontalRangeCategorySeriesProxyModule] });
        IgxRangeAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesModule, imports: [[i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule], IgxHorizontalRangeCategorySeriesProxyModule] });
        return IgxRangeAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRangeAreaSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule],
                        exports: [IgxRangeAreaSeriesComponent, IgxHorizontalRangeCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRangeAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRangeAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRangeAreaSeriesComponent", IgxRangeAreaSeriesComponent);
            i2.TypeRegistrar.register("RangeAreaSeries", RangeAreaSeries.$type);
        }
        IgxRangeAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRangeAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxRangeAreaSeriesModule], exports: [IgxRangeAreaSeriesModule] });
        IgxRangeAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxRangeAreaSeriesModule], IgxRangeAreaSeriesModule] });
        return IgxRangeAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRangeAreaSeriesModule],
                        exports: [IgxRangeAreaSeriesModule],
                        entryComponents: [IgxRangeAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RangeColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeColumnSeries, _super);
        function RangeColumnSeries() {
            var _this = _super.call(this) || this;
            _this.ab = RangeColumnSeries.$;
            return _this;
        }
        RangeColumnSeries.prototype.get_db = function () {
            return true;
        };
        RangeColumnSeries.prototype.get_dw = function () {
            return true;
        };
        RangeColumnSeries.prototype.bu = function () {
            return new RangeColumnSeriesView(this);
        };
        RangeColumnSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.tg = a;
        };
        RangeColumnSeries.prototype.get_cy = function () {
            return true;
        };
        RangeColumnSeries.prototype.preferredCategoryMode = function (a) {
            return 2;
        };
        RangeColumnSeries.prototype.pb = function (a) {
            if (this.xAxis == null || this.yAxis == null) {
                return i2.Rect.empty;
            }
            var b = this.ox(a);
            var c = this.bx.bv;
            var d = this.bx.bu;
            var e = this.getEffectiveViewport1(this.bx);
            var f = new ScalerParams(0, c, d, this.yAxis.cc, e);
            f.b = this.f2();
            var g = this.aj(this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), a, true);
            if (g == null) {
                return i2.Rect.empty;
            }
            var h = g[0];
            var i = g[1];
            var j = Math.abs(b.x - h[0]);
            var k = Math.abs(b.x - i[0]);
            var l = this.xAxis.ki(c, d, e);
            if (j < k) {
                var m = h[0] - 0.5 * l;
                var n = h[1];
                var o = h[2];
                return new i2.Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
            }
            else {
                var p = i[0] - 0.5 * l;
                var q = i[1];
                var r = i[2];
                return new i2.Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
            }
        };
        RangeColumnSeries.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        RangeColumnSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a && c.c3 != null) {
                c.c3.count = 0;
            }
        };
        RangeColumnSeries.prototype.f1 = function () {
            return this.xAxis.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        RangeColumnSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = i2.typeCast(RangeColumnSeriesView.$, b);
            var d = a.f;
            var e = b.bv;
            var f = b.bu;
            var g = this.getEffectiveViewport1(b);
            var h = this.xAxis.ki(e, f, g);
            if (i2.isNaN_(h) || i2.isInfinity(h)) {
                c.c3.count = 0;
                return;
            }
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            this.rb.r = this.th;
            this.rb.s = this.ti;
            this.rb.k = this.th;
            this.rb.l = this.ti;
            var i = false;
            var j = this.rb.b;
            if (j != null) {
                i = true;
            }
            var k = this.xAxis.ch;
            var l = this.lowColumn.count;
            var m = this.xAxis;
            var n = new ScalerParams(0, e, f, this.xAxis.cc, g);
            var o = 0;
            for (var p = 0; p < d.count; ++p) {
                var q = d._inner[p][0] - 0.5 * h;
                var r = Math.min(d._inner[p][1], d._inner[p][2]);
                var s = Math.max(d._inner[p][1], d._inner[p][2]);
                var t = Math.abs(s - r);
                if (i2.isInfinity(t)) {
                    continue;
                }
                var u = c.c3.item(o);
                o++;
                u.width = h;
                u.height = t;
                if (i) {
                    this.sh(d, p, l, m, n, b.q);
                }
                this.rb.ad(u, false, false, false, false);
                u.am = this.rb.k;
                u.an = this.rb.l;
                c.c8(u, q, r);
            }
            c.c3.count = o;
            b.cy(a);
        };
        Object.defineProperty(RangeColumnSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        RangeColumnSeries.$t = i2.markType(RangeColumnSeries, 'RangeColumnSeries', HorizontalRangeCategorySeries.$);
        RangeColumnSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RangeColumnSeries, 'raisePropertyChanged', ['RadiusX:th:tl', [1, 0], 'RadiusY:ti:tm', [1, 0]]);
        return RangeColumnSeries;
    }(HorizontalRangeCategorySeries));
    /**
     * @hidden
     */
    var RangeColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RangeColumnSeriesView, _super);
        function RangeColumnSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c2 = null;
            _this.c3 = null;
            _this.c4 = null;
            _this.c9 = new i2.Rectangle();
            _this.c2 = a;
            _this.c3 = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.da);
                $ret.activate = i2.runOn(_this, _this.c5);
                $ret.disactivate = i2.runOn(_this, _this.c7);
                $ret.destroy = i2.runOn(_this, _this.c6);
                return $ret;
            })());
            return _this;
        }
        RangeColumnSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.c4 = new i2.List$1(i2.Rectangle.$, 0);
            if (!this.q) {
                this.c2.pr = Defaults.c;
                this.c2.gh = Defaults.h;
                this.c2.gm = Defaults.i;
            }
        };
        RangeColumnSeriesView.prototype.da = function () {
            var a = new i2.Rectangle();
            this.c4.add(a);
            a._visibility = 1;
            return a;
        };
        RangeColumnSeriesView.prototype.c5 = function (a) {
            a._visibility = 0;
        };
        RangeColumnSeriesView.prototype.c7 = function (a) {
            a._visibility = 1;
        };
        RangeColumnSeriesView.prototype.c6 = function (a) {
            this.c4.remove(a);
        };
        RangeColumnSeriesView.prototype.c8 = function (a, b, c) {
            if (!this.isDirty) {
                this.aq();
            }
            a.o = c;
            a.n = b;
        };
        RangeColumnSeriesView.prototype.ac = function (a) {
            return this.c4._inner[a];
        };
        RangeColumnSeriesView.prototype.ab = function (a) {
            var b = this.c4._inner[a];
            this.c9._visibility = b._visibility;
            this.c9.n = b.n;
            this.c9.o = b.o;
            this.c9.width = b.width;
            this.c9.height = b.height;
            var c = this.bp(a);
            this.c9._fill = c;
            this.c9._stroke = c;
            this.c9.ac = this.e.fl + 3;
            return this.c9;
        };
        RangeColumnSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.c4.count; c++) {
                    var d = this.aa(c, b);
                    this.bd(d, c, b);
                    a.v(d);
                }
            }
        };
        RangeColumnSeriesView.prototype.al = function (a) {
            var e_1, _a, e_2, _b;
            _super.prototype.al.call(this, a);
            var b = 0;
            var c = new i2.List$1(i2.Rectangle.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.c3.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    c.add(d);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            c.aa(function (e, f) {
                if (e.n < f.n) {
                    return -1;
                }
                else if (e.n > f.n) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    this.e.a6.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            b++;
        };
        RangeColumnSeriesView.$t = i2.markType(RangeColumnSeriesView, 'RangeColumnSeriesView', RangeCategorySeriesView.$);
        return RangeColumnSeriesView;
    }(RangeCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent range column series.
    *
    * The `IgxRangeColumnSeriesComponent` class represents range column series of the IgxDataChartComponent.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-range-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="high"
    *     lowMemberPath="low">
    * </igx-range-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxRangeColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * this.chart.series.add(series);
    * ```
    */
    var IgxRangeColumnSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRangeColumnSeriesComponent, _super);
        function IgxRangeColumnSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxRangeColumnSeriesComponent.prototype.createImplementation = function () {
            return new RangeColumnSeries();
        };
        Object.defineProperty(IgxRangeColumnSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeColumnSeriesComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeColumnSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeColumnSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            *
            * Use the `radiusX` property to round the corners of the column.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data"
            *     >
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis
            *     >
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-range-column-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     radiusX="10">
            * </igx-range-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.radiusX=10;
            * ```
            */
            get: function () {
                return this.i.th;
            },
            set: function (v) {
                this.i.th = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRangeColumnSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            *
            * Use the `radiusY` property for the y-radius of the ellipse that is used to round the corners of the column.
            *
            * ```html
            * <igx-data-chart  #chart
            *     [dataSource]="data"
            *     >
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis
            *     >
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     minimumValue="0"
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-range-column-series
            *
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     highMemberPath="high"
            *     lowMemberPath="low"
            *     radiusY= "10">
            * </igx-range-column-series>
            * </igx-data-chart>
            * ```
            *
            * ```ts
            * series.radiusY=10;
            * ```
            */
            get: function () {
                return this.i.ti;
            },
            set: function (v) {
                this.i.ti = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        *
        * The `getSeriesValueBoundingBox` method return the best available value of the bounding box within the series.
        *
        * ```ts
        * series.getSeriesValueBoundingBox(world :IgxPoint) : IgxRect
        * ```
        */
        IgxRangeColumnSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        *
        * The `getItemSpan` method returns the current width of the items within the categories.
        *
        * ```ts
        * var x =series.getItemSpan();
        * ```
        */
        IgxRangeColumnSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxRangeColumnSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRangeColumnSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRangeColumnSeriesComponent, selector: "igx-range-column-series", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRangeColumnSeriesComponent;
    }(IgxHorizontalRangeCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-range-column-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxRangeCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRangeColumnSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRangeColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRangeColumnSeriesModule() {
        }
        IgxRangeColumnSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRangeColumnSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesModule, declarations: [IgxRangeColumnSeriesComponent], imports: [i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule], exports: [IgxRangeColumnSeriesComponent, IgxHorizontalRangeCategorySeriesProxyModule] });
        IgxRangeColumnSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesModule, imports: [[i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule], IgxHorizontalRangeCategorySeriesProxyModule] });
        return IgxRangeColumnSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRangeColumnSeriesComponent],
                        imports: [i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule],
                        exports: [IgxRangeColumnSeriesComponent, IgxHorizontalRangeCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRangeColumnSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRangeColumnSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRangeColumnSeriesComponent", IgxRangeColumnSeriesComponent);
            i2.TypeRegistrar.register("RangeColumnSeries", RangeColumnSeries.$type);
        }
        IgxRangeColumnSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRangeColumnSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesDynamicModule, imports: [i1.CommonModule, IgxRangeColumnSeriesModule], exports: [IgxRangeColumnSeriesModule] });
        IgxRangeColumnSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesDynamicModule, imports: [[i1.CommonModule, IgxRangeColumnSeriesModule], IgxRangeColumnSeriesModule] });
        return IgxRangeColumnSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRangeColumnSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRangeColumnSeriesModule],
                        exports: [IgxRangeColumnSeriesModule],
                        entryComponents: [IgxRangeColumnSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCoreModule() {
            i2.TypeRegistrar.register('XamDataChart', XamDataChart.$type);
        }
        IgxDataChartCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreModule, declarations: [IgxDataChartComponent], imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule], exports: [i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule,
                IgxDataChartComponent] });
        IgxDataChartCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                    i2.IgxDateTimeFormatSpecifierModule
                ], i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule] });
        return IgxDataChartCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxDataChartComponent],
                        exports: [i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule,
                            IgxDataChartComponent
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxDataChartComponent', IgxDataChartComponent);
            i2.TypeRegistrar.registerCons('XamDataChart', XamDataChart);
            i2.TypeRegistrar.register('XamDataChart', XamDataChart.$type);
        }
        IgxDataChartCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreDynamicModule, imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxDataChartCoreModule], exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxDataChartCoreModule] });
        IgxDataChartCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreDynamicModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                    i2.IgxDateTimeFormatSpecifierDynamicModule,
                    IgxDataChartCoreModule
                ], i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxDataChartCoreModule] });
        return IgxDataChartCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: [IgxDataChartComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCategoryCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCategoryCoreModule() {
        }
        IgxDataChartCategoryCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCategoryCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreModule, imports: [i1.CommonModule, IgxCategoryXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule], exports: [IgxCategoryXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartCategoryCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreModule, imports: [[i1.CommonModule, IgxCategoryXAxisModule,
                    IgxNumericYAxisModule,
                    IgxDataChartCoreModule
                ], IgxCategoryXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartCategoryCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCategoryCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCategoryCoreDynamicModule() {
        }
        IgxDataChartCategoryCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCategoryCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreDynamicModule, imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartCategoryCoreModule], exports: [IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartCategoryCoreModule] });
        IgxDataChartCategoryCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreDynamicModule, imports: [[i1.CommonModule, IgxCategoryXAxisDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartCategoryCoreModule
                ], IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartCategoryCoreModule] });
        return IgxDataChartCategoryCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartCategoryCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartCategoryCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCategoryModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCategoryModule() {
        }
        IgxDataChartCategoryModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCategoryModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryModule, imports: [i1.CommonModule, IgxLineSeriesModule,
                IgxAreaSeriesModule,
                IgxColumnSeriesModule,
                IgxSplineSeriesModule,
                IgxSplineAreaSeriesModule,
                IgxStepLineSeriesModule,
                IgxStepAreaSeriesModule,
                IgxPointSeriesModule,
                IgxWaterfallSeriesModule,
                IgxRangeAreaSeriesModule,
                IgxRangeColumnSeriesModule,
                IgxDataChartCategoryCoreModule], exports: [IgxLineSeriesModule,
                IgxAreaSeriesModule,
                IgxColumnSeriesModule,
                IgxSplineSeriesModule,
                IgxSplineAreaSeriesModule,
                IgxStepLineSeriesModule,
                IgxStepAreaSeriesModule,
                IgxPointSeriesModule,
                IgxWaterfallSeriesModule,
                IgxRangeAreaSeriesModule,
                IgxRangeColumnSeriesModule,
                IgxDataChartCategoryCoreModule] });
        IgxDataChartCategoryModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryModule, imports: [[i1.CommonModule, IgxLineSeriesModule,
                    IgxAreaSeriesModule,
                    IgxColumnSeriesModule,
                    IgxSplineSeriesModule,
                    IgxSplineAreaSeriesModule,
                    IgxStepLineSeriesModule,
                    IgxStepAreaSeriesModule,
                    IgxPointSeriesModule,
                    IgxWaterfallSeriesModule,
                    IgxRangeAreaSeriesModule,
                    IgxRangeColumnSeriesModule,
                    IgxDataChartCategoryCoreModule
                ], IgxLineSeriesModule,
                IgxAreaSeriesModule,
                IgxColumnSeriesModule,
                IgxSplineSeriesModule,
                IgxSplineAreaSeriesModule,
                IgxStepLineSeriesModule,
                IgxStepAreaSeriesModule,
                IgxPointSeriesModule,
                IgxWaterfallSeriesModule,
                IgxRangeAreaSeriesModule,
                IgxRangeColumnSeriesModule,
                IgxDataChartCategoryCoreModule] });
        return IgxDataChartCategoryModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxLineSeriesModule,
                            IgxAreaSeriesModule,
                            IgxColumnSeriesModule,
                            IgxSplineSeriesModule,
                            IgxSplineAreaSeriesModule,
                            IgxStepLineSeriesModule,
                            IgxStepAreaSeriesModule,
                            IgxPointSeriesModule,
                            IgxWaterfallSeriesModule,
                            IgxRangeAreaSeriesModule,
                            IgxRangeColumnSeriesModule,
                            IgxDataChartCategoryCoreModule
                        ],
                        imports: [i1.CommonModule, IgxLineSeriesModule,
                            IgxAreaSeriesModule,
                            IgxColumnSeriesModule,
                            IgxSplineSeriesModule,
                            IgxSplineAreaSeriesModule,
                            IgxStepLineSeriesModule,
                            IgxStepAreaSeriesModule,
                            IgxPointSeriesModule,
                            IgxWaterfallSeriesModule,
                            IgxRangeAreaSeriesModule,
                            IgxRangeColumnSeriesModule,
                            IgxDataChartCategoryCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartCategoryDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartCategoryDynamicModule() {
        }
        IgxDataChartCategoryDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartCategoryDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryDynamicModule, imports: [i1.CommonModule, IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxRangeAreaSeriesDynamicModule,
                IgxRangeColumnSeriesDynamicModule,
                IgxDataChartCategoryCoreDynamicModule,
                IgxDataChartCategoryModule], exports: [IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxRangeAreaSeriesDynamicModule,
                IgxRangeColumnSeriesDynamicModule,
                IgxDataChartCategoryCoreDynamicModule,
                IgxDataChartCategoryModule] });
        IgxDataChartCategoryDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryDynamicModule, imports: [[i1.CommonModule, IgxLineSeriesDynamicModule,
                    IgxAreaSeriesDynamicModule,
                    IgxColumnSeriesDynamicModule,
                    IgxSplineSeriesDynamicModule,
                    IgxSplineAreaSeriesDynamicModule,
                    IgxStepLineSeriesDynamicModule,
                    IgxStepAreaSeriesDynamicModule,
                    IgxPointSeriesDynamicModule,
                    IgxWaterfallSeriesDynamicModule,
                    IgxRangeAreaSeriesDynamicModule,
                    IgxRangeColumnSeriesDynamicModule,
                    IgxDataChartCategoryCoreDynamicModule,
                    IgxDataChartCategoryModule
                ], IgxLineSeriesDynamicModule,
                IgxAreaSeriesDynamicModule,
                IgxColumnSeriesDynamicModule,
                IgxSplineSeriesDynamicModule,
                IgxSplineAreaSeriesDynamicModule,
                IgxStepLineSeriesDynamicModule,
                IgxStepAreaSeriesDynamicModule,
                IgxPointSeriesDynamicModule,
                IgxWaterfallSeriesDynamicModule,
                IgxRangeAreaSeriesDynamicModule,
                IgxRangeColumnSeriesDynamicModule,
                IgxDataChartCategoryCoreDynamicModule,
                IgxDataChartCategoryModule] });
        return IgxDataChartCategoryDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartCategoryDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxSplineSeriesDynamicModule,
                            IgxSplineAreaSeriesDynamicModule,
                            IgxStepLineSeriesDynamicModule,
                            IgxStepAreaSeriesDynamicModule,
                            IgxPointSeriesDynamicModule,
                            IgxWaterfallSeriesDynamicModule,
                            IgxRangeAreaSeriesDynamicModule,
                            IgxRangeColumnSeriesDynamicModule,
                            IgxDataChartCategoryCoreDynamicModule,
                            IgxDataChartCategoryModule
                        ],
                        imports: [i1.CommonModule, IgxLineSeriesDynamicModule,
                            IgxAreaSeriesDynamicModule,
                            IgxColumnSeriesDynamicModule,
                            IgxSplineSeriesDynamicModule,
                            IgxSplineAreaSeriesDynamicModule,
                            IgxStepLineSeriesDynamicModule,
                            IgxStepAreaSeriesDynamicModule,
                            IgxPointSeriesDynamicModule,
                            IgxWaterfallSeriesDynamicModule,
                            IgxRangeAreaSeriesDynamicModule,
                            IgxRangeColumnSeriesDynamicModule,
                            IgxDataChartCategoryCoreDynamicModule,
                            IgxDataChartCategoryModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartPolarCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartPolarCoreModule() {
        }
        IgxDataChartPolarCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartPolarCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreModule, imports: [i1.CommonModule, IgxNumericAngleAxisModule,
                IgxNumericRadiusAxisModule,
                IgxDataChartCoreModule], exports: [IgxNumericAngleAxisModule,
                IgxNumericRadiusAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartPolarCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreModule, imports: [[i1.CommonModule, IgxNumericAngleAxisModule,
                    IgxNumericRadiusAxisModule,
                    IgxDataChartCoreModule
                ], IgxNumericAngleAxisModule,
                IgxNumericRadiusAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartPolarCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericAngleAxisModule,
                            IgxNumericRadiusAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericAngleAxisModule,
                            IgxNumericRadiusAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartPolarCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartPolarCoreDynamicModule() {
        }
        IgxDataChartPolarCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartPolarCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreDynamicModule, imports: [i1.CommonModule, IgxNumericAngleAxisDynamicModule,
                IgxNumericRadiusAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartPolarCoreModule], exports: [IgxNumericAngleAxisDynamicModule,
                IgxNumericRadiusAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartPolarCoreModule] });
        IgxDataChartPolarCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreDynamicModule, imports: [[i1.CommonModule, IgxNumericAngleAxisDynamicModule,
                    IgxNumericRadiusAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartPolarCoreModule
                ], IgxNumericAngleAxisDynamicModule,
                IgxNumericRadiusAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartPolarCoreModule] });
        return IgxDataChartPolarCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericAngleAxisDynamicModule,
                            IgxNumericRadiusAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartPolarCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericAngleAxisDynamicModule,
                            IgxNumericRadiusAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartPolarCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available modes for searching for items in the scatter series.
     */
    var ScatterItemSearchMode = /*@__PURE__*/ (function (ScatterItemSearchMode) {
        /**
         * Search mode is automatically determined by the component.
         */
        ScatterItemSearchMode[ScatterItemSearchMode["Auto"] = 0] = "Auto";
        /**
         * When searching for a point, the closest visible point is selected.
         */
        ScatterItemSearchMode[ScatterItemSearchMode["ClosestVisiblePoint"] = 1] = "ClosestVisiblePoint";
        /**
         * When searching for a point, the closest point is selected, whether visible or not.
         * The search is skipped in performance critical scenarios if the number of points is over ClosestPointMaxSearchCount
         */
        ScatterItemSearchMode[ScatterItemSearchMode["ClosestPoint"] = 2] = "ClosestPoint";
        /**
         * When searching for a point, the closest visible point along the closest visible line is used.
         * The search is skipped if the visible line points are over ClosestPointMaxSearch.
         */
        ScatterItemSearchMode[ScatterItemSearchMode["ClosestVisiblePointOnClosestLine"] = 3] = "ClosestVisiblePointOnClosestLine";
        /**
         * When searching for a point, the closest point along the closest line is used.
         * The search is skipped if the line points are over ClosestPointMaxSearch.
         */
        ScatterItemSearchMode[ScatterItemSearchMode["ClosestPointOnClosestLine"] = 4] = "ClosestPointOnClosestLine";
        /**
         * No points will be searched for the in the scatter series.
         */
        ScatterItemSearchMode[ScatterItemSearchMode["None"] = 5] = "None";
        return ScatterItemSearchMode;
    })({});
    /**
     * @hidden
     */
    var ScatterItemSearchMode_$type = i2.markEnum('ScatterItemSearchMode', 'Auto,0|ClosestVisiblePoint,1|ClosestPoint,2|ClosestVisiblePointOnClosestLine,3|ClosestPointOnClosestLine,4|None,5');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningPolarStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningPolarStyleEventArgs, _super);
        function AssigningPolarStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningPolarStyleEventArgs.$t = i2.markType(AssigningPolarStyleEventArgs, 'AssigningPolarStyleEventArgs', AssigningSeriesShapeStyleEventArgsBase.$);
        return AssigningPolarStyleEventArgs;
    }(AssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningPolarStyleEvent
    */
    var IgxAssigningPolarStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningPolarStyleEventArgs, _super);
        function IgxAssigningPolarStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningPolarStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningPolarStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningPolarStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningPolarStyleEventArgs;
    }(IgxAssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
    */
    var IgxAssigningPolarStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningPolarStyleEventArgsBase, _super);
        function IgxAssigningPolarStyleEventArgsBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAssigningPolarStyleEventArgsBase.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningPolarStyleEventArgsBase;
    }(IgxAssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningPolarStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningPolarStyleEventArgsBase, _super);
        function AssigningPolarStyleEventArgsBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningPolarStyleEventArgsBase.$t = i2.markType(AssigningPolarStyleEventArgsBase, 'AssigningPolarStyleEventArgsBase', AssigningSeriesStyleEventArgsBase.$);
        return AssigningPolarStyleEventArgsBase;
    }(AssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningPolarMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningPolarMarkerStyleEventArgs, _super);
        function AssigningPolarMarkerStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningPolarMarkerStyleEventArgs.$t = i2.markType(AssigningPolarMarkerStyleEventArgs, 'AssigningPolarMarkerStyleEventArgs', AssigningPolarStyleEventArgsBase.$);
        return AssigningPolarMarkerStyleEventArgs;
    }(AssigningPolarStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningPolarStyleEvent
    */
    var IgxAssigningPolarMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningPolarMarkerStyleEventArgs, _super);
        function IgxAssigningPolarMarkerStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningPolarMarkerStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningPolarMarkerStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningPolarMarkerStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningPolarMarkerStyleEventArgs;
    }(IgxAssigningPolarStyleEventArgsBase));

    /**
     * Represents the base class from which all IgxDataChartComponent polar series are derived.
    */
    var IgxPolarBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarBaseComponent, _super);
        function IgxPolarBaseComponent() {
            var _this = _super.call(this) || this;
            _this._assigningPolarStyle = null;
            _this._assigningPolarMarkerStyle = null;
            return _this;
        }
        Object.defineProperty(IgxPolarBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "isPolar", {
            /**
             * Checks if this series is a polar series
            */
            get: function () {
                return this.i.d0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "angleMemberPath", {
            /**
             * Gets or sets the path to use to find the angle values for the series.
            */
            get: function () {
                return this.i.so;
            },
            set: function (v) {
                this.i.so = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "radiusMemberPath", {
            /**
             * Gets or sets the path to use to get the radius values for the series.
            */
            get: function () {
                return this.i.sy;
            },
            set: function (v) {
                this.i.sy = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "angleAxis", {
            /**
             * Gets the effective angle axis for the current series object.
            */
            get: function () {
                if (this.i.q8 == null) {
                    return null;
                }
                if (!this.i.q8.externalObject) {
                    var e = IgxNumericAngleAxisComponent._createFromInternal(this.i.q8);
                    if (e) {
                        e._implementation = this.i.q8;
                    }
                    this.i.q8.externalObject = e;
                }
                return this.i.q8.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q8 = null : this.i.q8 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "radiusAxis", {
            /**
             * Gets the effective radius axis for the current series object.
            */
            get: function () {
                if (this.i.q9 == null) {
                    return null;
                }
                if (!this.i.q9.externalObject) {
                    var e = IgxNumericRadiusAxisComponent._createFromInternal(this.i.q9);
                    if (e) {
                        e._implementation = this.i.q9;
                    }
                    this.i.q9.externalObject = e;
                }
                return this.i.q9.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q9 = null : this.i.q9 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "useCartesianInterpolation", {
            /**
             * Gets or sets whether Cartesian Interpolation should be used rather than Archimedian
             * spiral based interpolation.
            */
            get: function () {
                return this.i.r8;
            },
            set: function (v) {
                this.i.r8 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "maximumMarkers", {
            /**
             * Gets or sets the maximum number of markers displayed by the current series.
             * If more than the specified number of markers are visible, the polar series will automatically
             * choose a representative set.
            */
            get: function () {
                return this.i.si;
            },
            set: function (v) {
                this.i.si = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the trend type for the current series object.
            */
            get: function () {
                return this.i.rq;
            },
            set: function (v) {
                this.i.rq = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the brush that specifies how the current series
             * object's trend line is drawn.
            */
            get: function () {
                return i2.brushToString(this.i.tx);
            },
            set: function (v) {
                this.i.tx = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "actualTrendLineBrush", {
            /**
             * Gets the effective TrendLineBrush for this series.
            */
            get: function () {
                return i2.brushToString(this.i.tw);
            },
            set: function (v) {
                this.i.tw = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the current series object's trend line.
            */
            get: function () {
                return this.i.sg;
            },
            set: function (v) {
                this.i.sg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the moving average period for the current series object.
            */
            get: function () {
                return this.i.sj;
            },
            set: function (v) {
                this.i.sj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "trendLineZIndex", {
            /**
             * Sets or Gets the Trendline Z index.
            */
            get: function () {
                return this.i.sk;
            },
            set: function (v) {
                this.i.sk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "clipSeriesToBounds", {
            /**
             * Gets or sets whether to clip the series to the bounds.
             * Setting this to true can effect performance.
            */
            get: function () {
                return this.i.rz;
            },
            set: function (v) {
                this.i.rz = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "actualItemSearchMode", {
            get: function () {
                return this.i.rm;
            },
            set: function (v) {
                this.i.rm = i2.ensureEnum(ScatterItemSearchMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "itemSearchMode", {
            /**
             * Gets or sets the mode the series will use to find the closest point to the cursor.
            */
            get: function () {
                return this.i.ro;
            },
            set: function (v) {
                this.i.ro = i2.ensureEnum(ScatterItemSearchMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "itemSearchThreshold", {
            /**
             * Gets or sets the threshold to use when searching for items using ItemSearchMode.
            */
            get: function () {
                return this.i.sh;
            },
            set: function (v) {
                this.i.sh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "isCustomPolarStyleAllowed", {
            /**
             * Gets or sets whether this Polar series should allow custom style overrides of its individual visuals.
            */
            get: function () {
                return this.i.r2;
            },
            set: function (v) {
                this.i.r2 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "isCustomPolarMarkerStyleAllowed", {
            /**
             * Gets or sets whether this Polar series should allow custom style overrides of its individual marker visuals.
            */
            get: function () {
                return this.i.r1;
            },
            set: function (v) {
                this.i.r1 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.angleAxis && this.angleAxis.name && this.angleAxis.name == name) {
                return this.angleAxis;
            }
            if (this.radiusAxis && this.radiusAxis.name && this.radiusAxis.name == name) {
                return this.radiusAxis;
            }
            return null;
        };
        IgxPolarBaseComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.angleAxis && this.angleAxis._styling) {
                this.angleAxis._styling(container, component, this);
            }
            if (this.radiusAxis && this.radiusAxis._styling) {
                this.radiusAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Scrolls the requested item into view, if possible.
        
        * @param item  * The item to scroll into view.
        */
        IgxPolarBaseComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxPolarBaseComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the index of the item that resides at the provided world coordinates.
        
        * @param world  * The world coordinates of the requested item.
        */
        IgxPolarBaseComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        IgxPolarBaseComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        IgxPolarBaseComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxPolarBaseComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Determine if object can be used as RadiusAxis
        
        * @param axis  * The object to check
        */
        IgxPolarBaseComponent.prototype.canUseAsRadiusAxis = function (axis) {
            var iv = this.i.ry(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as AngleAxis
        
        * @param axis  * The object to check
        */
        IgxPolarBaseComponent.prototype.canUseAsAngleAxis = function (axis) {
            var iv = this.i.rx(axis);
            return (iv);
        };
        Object.defineProperty(IgxPolarBaseComponent.prototype, "assigningPolarStyle", {
            /**
             * Event raised when Assigning Category Style
            */
            get: function () {
                var _this = this;
                if (this._assigningPolarStyle == null) {
                    this._assigningPolarStyle = new i0.EventEmitter();
                    this.i.assigningPolarStyle = i2.delegateCombine(this.i.assigningPolarStyle, function (o, e) {
                        var outerArgs = new IgxAssigningPolarStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningPolarStyle) {
                            _this.beforeAssigningPolarStyle(_this, outerArgs);
                        }
                        _this._assigningPolarStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningPolarStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarBaseComponent.prototype, "assigningPolarMarkerStyle", {
            /**
             * Event raised when Assigning Polar Marker Style
            */
            get: function () {
                var _this = this;
                if (this._assigningPolarMarkerStyle == null) {
                    this._assigningPolarMarkerStyle = new i0.EventEmitter();
                    this.i.assigningPolarMarkerStyle = i2.delegateCombine(this.i.assigningPolarMarkerStyle, function (o, e) {
                        var outerArgs = new IgxAssigningPolarMarkerStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningPolarMarkerStyle) {
                            _this.beforeAssigningPolarMarkerStyle(_this, outerArgs);
                        }
                        _this._assigningPolarMarkerStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningPolarMarkerStyle;
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarBaseComponent, selector: "ng-component", inputs: { angleMemberPath: "angleMemberPath", radiusMemberPath: "radiusMemberPath", angleAxis: "angleAxis", radiusAxis: "radiusAxis", useCartesianInterpolation: "useCartesianInterpolation", maximumMarkers: "maximumMarkers", trendLineType: "trendLineType", trendLineBrush: "trendLineBrush", actualTrendLineBrush: "actualTrendLineBrush", trendLineThickness: "trendLineThickness", trendLinePeriod: "trendLinePeriod", trendLineZIndex: "trendLineZIndex", clipSeriesToBounds: "clipSeriesToBounds", actualItemSearchMode: "actualItemSearchMode", itemSearchMode: "itemSearchMode", itemSearchThreshold: "itemSearchThreshold", isCustomPolarStyleAllowed: "isCustomPolarStyleAllowed", isCustomPolarMarkerStyleAllowed: "isCustomPolarMarkerStyleAllowed" }, outputs: { assigningPolarStyle: "assigningPolarStyle", assigningPolarMarkerStyle: "assigningPolarMarkerStyle" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxPolarBaseComponent;
    }(IgxMarkerSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { angleMemberPath: [{
                    type: i0.Input
                }], radiusMemberPath: [{
                    type: i0.Input
                }], angleAxis: [{
                    type: i0.Input
                }], radiusAxis: [{
                    type: i0.Input
                }], useCartesianInterpolation: [{
                    type: i0.Input
                }], maximumMarkers: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], actualTrendLineBrush: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], trendLineZIndex: [{
                    type: i0.Input
                }], clipSeriesToBounds: [{
                    type: i0.Input
                }], actualItemSearchMode: [{
                    type: i0.Input
                }], itemSearchMode: [{
                    type: i0.Input
                }], itemSearchThreshold: [{
                    type: i0.Input
                }], isCustomPolarStyleAllowed: [{
                    type: i0.Input
                }], isCustomPolarMarkerStyleAllowed: [{
                    type: i0.Input
                }], assigningPolarStyle: [{
                    type: i0.Output
                }], assigningPolarMarkerStyle: [{
                    type: i0.Output
                }] } });

    /**
     * Represents the base class from which all IgxDataChartComponent polar line series are derived.
    */
    var IgxPolarLineSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarLineSeriesBaseComponent, _super);
        function IgxPolarLineSeriesBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxPolarLineSeriesBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarLineSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarLineSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarLineSeriesBaseComponent, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxPolarLineSeriesBaseComponent;
    }(IgxPolarBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarAxisInfoCache = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarAxisInfoCache, _super);
        function PolarAxisInfoCache(a, b, c) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = null;
            _this.e = false;
            _this.g = false;
            _this.d = false;
            _this.f = false;
            _this.c = null;
            _this.i = 0;
            _this.h = 0;
            _this.a = a;
            _this.b = b;
            _this.e = _this.a.kl;
            _this.d = _this.a.cc;
            _this.g = _this.b.kl;
            _this.f = _this.b.cc;
            _this.i = _this.b.ma;
            _this.h = _this.b.l9;
            _this.c = c;
            return _this;
        }
        PolarAxisInfoCache.$t = i2.markType(PolarAxisInfoCache, 'PolarAxisInfoCache');
        return PolarAxisInfoCache;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesRenderer$2 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesRenderer$2, _super);
        function SeriesRenderer$2($tFrame, $tView, a) {
            var _rest = [];
            for (var _i = 3; _i < arguments.length; _i++) {
                _rest[_i - 3] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.$tFrame = null;
            _this.$tView = null;
            _this.c = null;
            _this.d = null;
            _this.a = null;
            _this.e = null;
            _this.f = null;
            _this.b = null;
            _this.$tFrame = $tFrame;
            _this.$tView = $tView;
            _this.$type = _this.$type.specialize(_this.$tFrame, _this.$tView);
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        _this.c = c;
                        _this.d = d;
                        _this.a = function (h) {
                        };
                        _this.f = e;
                        _this.e = f;
                        _this.b = g;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        var h = _rest[5];
                        _this.c = c;
                        _this.d = d;
                        _this.a = h;
                        _this.f = e;
                        _this.e = f;
                        _this.b = g;
                    }
                    break;
            }
            return _this;
        }
        SeriesRenderer$2.prototype.g = function (a, b, c, d, e) {
            var f = 0;
            f = a.c;
            if (a.a && f > 0 && !a.b) {
                var g = b;
                if (this.f()) {
                    this.b();
                    b = d;
                    d = g;
                }
                else {
                    b = c;
                    c = g;
                }
                this.a(c);
                this.c(c, e);
                this.e();
            }
            else {
                if (!a.b) {
                    this.a(c);
                    this.c(c, e);
                }
                this.d(c, e);
            }
            return {
                p1: b,
                p2: c,
                p3: d
            };
        };
        SeriesRenderer$2.$t = i2.markType(SeriesRenderer$2, 'SeriesRenderer$2');
        return SeriesRenderer$2;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var OwnedPoint = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(OwnedPoint, _super);
        function OwnedPoint() {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.a = null;
            _this.b = null;
            _this.b = { $type: i2.Point_$type, x: 0, y: 0 };
            return _this;
        }
        OwnedPoint.$t = i2.markType(OwnedPoint, 'OwnedPoint');
        return OwnedPoint;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterFrameBase$1 = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterFrameBase$1, _super);
        function ScatterFrameBase$1($t) {
            var _this = _super.call(this) || this;
            _this.$t = null;
            _this.f = null;
            _this.o = null;
            _this.j = null;
            _this.g = null;
            _this.m = null;
            _this.n = null;
            _this.h = null;
            _this.l = null;
            _this.i = null;
            _this.k = null;
            _this.$t = $t;
            _this.$type = _this.$type.specialize(_this.$t);
            _this.m = new i2.List$1(i2.Point_$type, 0);
            _this.g = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 0);
            _this.j = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 0);
            _this.n = new i2.List$1(i2.Point_$type, 0);
            _this.h = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 0);
            _this.l = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 0);
            _this.i = new i2.Dictionary$2(i2.Base.$, i2.Array_$type, 0);
            _this.k = new i2.Dictionary$2(i2.Base.$, i2.Array_$type, 0);
            _this.o = function (a, b, c) { return a; };
            _this.f = new DictInterpolator$3(i2.Base.$, OwnedPoint.$, ScatterFrameBase$1.$.specialize(_this.$t), i2.runOn(_this, _this.s), function (a) { return a.a; }, function (a) { return !i2.isNaN_(a.c.x) && !i2.isNaN_(a.c.y); }, function () { return new OwnedPoint(); });
            return _this;
        }
        ScatterFrameBase$1.prototype.c = function (a, b, c) {
            var d = b;
            var e = c;
            if (d == null || e == null) {
                return;
            }
            this.f.f(this.g, a, d.g, e.g, d, e);
            Frame.a(this.m, a, d.m, e.m);
            this.f.f(this.j, a, d.j, e.j, d, e);
            this.f.f(this.h, a, d.h, e.h, d, e);
            this.f.f(this.l, a, d.l, e.l, d, e);
            this.p(this.j, a, d, e);
            Frame.a(this.n, a, d.n, e.n);
            this.i = e.i;
            this.k = e.k;
            this.r(a, d, e);
        };
        ScatterFrameBase$1.prototype.r = function (a, b, c) {
        };
        ScatterFrameBase$1.prototype.p = function (a, b, c, d) {
            var e_1, _a;
            var _loop_1 = function (e) {
                if (a.containsKey(e.a)) {
                    return "continue";
                }
                var f;
                if (!((function () { var g = d.g.tryGetValue(e.a, f); f = g.p1; return g.ret; })()) || (f.b.x == e.b.x && f.b.y == e.b.y)) {
                    return "continue";
                }
                var g = new OwnedPoint();
                this_1.s(g, b, e, f, c, d);
                if (i2.isNaN_(g.c.x) || i2.isNaN_(g.c.y)) {
                    return "continue";
                }
                a.addItem(g.a, g);
            };
            var this_1 = this;
            try {
                for (var _b = tslib.__values(i2.fromEnum(c.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    _loop_1(e);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        ScatterFrameBase$1.prototype.q = function (a, b, c, d) {
            if (c != null) {
                a.b = { $type: i2.Point_$type, x: c.b.x, y: c.b.y };
            }
            else if (d != null) {
                a.b = { $type: i2.Point_$type, x: d.b.x, y: d.b.y };
            }
        };
        ScatterFrameBase$1.prototype.s = function (a, b, c, d, e, f) {
            var g;
            var h;
            if (c == null) {
                if (d != null) {
                    var i_1;
                    if (((function () { var j = e.g.tryGetValue(d.a, i_1); i_1 = j.p1; return j.ret; })())) {
                        g = i_1;
                    }
                    else {
                        g = this.o(d, e, f);
                    }
                }
                else {
                    a.c = { $type: i2.Point_$type, x: NaN, y: NaN };
                    return;
                }
            }
            else {
                g = c;
                if (a.a == null) {
                    a.a = c.a;
                }
            }
            if (d == null) {
                if (c != null) {
                    var j_1;
                    if (((function () { var k = f.g.tryGetValue(c.a, j_1); j_1 = k.p1; return k.ret; })())) {
                        h = j_1;
                    }
                    else {
                        a.c = { $type: i2.Point_$type, x: NaN, y: NaN };
                        return;
                    }
                }
                else {
                    a.c = { $type: i2.Point_$type, x: NaN, y: NaN };
                    return;
                }
            }
            else {
                h = d;
                if (a.a == null) {
                    a.a = d.a;
                }
            }
            this.q(a, b, g, h);
            if (i2.isNaN_(g.c.x) || i2.isNaN_(g.c.y)) {
                g = h;
            }
            this.t(a, b, g, h);
        };
        ScatterFrameBase$1.prototype.t = function (a, b, c, d) {
            var e = 1 - b;
            a.c = { $type: i2.Point_$type, x: c.c.x * e + d.c.x * b, y: c.c.y * e + d.c.y * b };
        };
        ScatterFrameBase$1.$t = i2.markType(ScatterFrameBase$1, 'ScatterFrameBase$1', Frame.$);
        return ScatterFrameBase$1;
    }(Frame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarFrame, _super);
        function PolarFrame() {
            var _this = _super.call(this, PolarFrame.$) || this;
            _this.w = null;
            _this.v = false;
            _this.x = null;
            _this.w = new i2.List$1(i2.Point_$type, 0);
            _this.v = true;
            return _this;
        }
        PolarFrame.prototype.r = function (a, b, c) {
            var d = i2.typeCast(PolarFrame.$, b);
            var e = i2.typeCast(PolarFrame.$, c);
            if (d == null || e == null) {
                return;
            }
            Frame.a(this.w, a, d.w, e.w);
        };
        PolarFrame.prototype.q = function (a, b, c, d) {
            if (this.v) {
                _super.prototype.q.call(this, a, b, c, d);
            }
            else {
                _super.prototype.q.call(this, a, b, c, d);
                if (c != null && d != null && (c.b.x != d.b.x || c.b.y != d.b.y)) {
                    var e = 1 - b;
                    a.b = { $type: i2.Point_$type, x: c.b.x * e + d.b.x * b, y: c.b.y * e + d.b.y * b };
                }
            }
        };
        PolarFrame.prototype.u = function (a) {
            return !i2.isNaN_(a.x) && !i2.isNaN_(a.y) && !i2.isInfinity(a.x) && !i2.isInfinity(a.y);
        };
        PolarFrame.prototype.t = function (a, b, c, d) {
            if (this.v) {
                _super.prototype.t.call(this, a, b, c, d);
            }
            else {
                if (c != null && d != null && (c.c.x != d.c.x || c.c.y != d.c.y) && this.u(a.b)) {
                    a.c = this.x(a.b);
                }
                else {
                    _super.prototype.t.call(this, a, b, c, d);
                }
            }
        };
        PolarFrame.$t = i2.markType(PolarFrame, 'PolarFrame', ScatterFrameBase$1.$.specialize(-1)).initSelfReferences();
        return PolarFrame;
    }(ScatterFrameBase$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesRenderingArguments = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesRenderingArguments, _super);
        function SeriesRenderingArguments(a, b, c, d, e) {
            var _this = _super.call(this) || this;
            _this.e = null;
            _this.f = null;
            _this.c = 0;
            _this.a = false;
            _this.d = null;
            _this.b = false;
            _this.c = a.ha;
            _this.d = a;
            _this.e = b;
            _this.f = c;
            _this.a = d;
            _this.b = e;
            return _this;
        }
        SeriesRenderingArguments.$t = i2.markType(SeriesRenderingArguments, 'SeriesRenderingArguments');
        return SeriesRenderingArguments;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarTrendLineManager, _super);
        function PolarTrendLineManager() {
            var _this = _super.call(this, i2.Point_$type) || this;
            _this.i = false;
            _this.h = 0;
            _this.k = 0;
            _this.j = 0;
            _this.l = null;
            _this.m = null;
            return _this;
        }
        PolarTrendLineManager.prototype.get_g$a = function () {
            return 2;
        };
        Object.defineProperty(PolarTrendLineManager.prototype, "g$a", {
            get: function () {
                return this.get_g$a();
            },
            enumerable: false,
            configurable: true
        });
        PolarTrendLineManager.prototype.n = function (a, b, c, d, e, f, g, h, i, j, k) {
            var e_1, _a;
            var l = j;
            var m = k;
            var n = new i2.List$1(i2.Point_$type, 0);
            if (!h.g.isEmpty && !h.f.isEmpty) {
                var o_1 = c;
                var p_1 = d;
                var q = 0;
                if (o_1 != null) {
                    q = o_1.count;
                }
                if (p_1 != null) {
                    q = Math.min(q, p_1.count);
                }
                if (b == 0) {
                    this.a = null;
                    this.d.clear();
                    return;
                }
                if (this.c(b)) {
                    this.d.clear();
                    this.a = TrendFitCalculator.a(n, b, h, this.a, q, function (r) { return o_1.item(r); }, function (r) { return p_1.item(r); }, f, g, l, m);
                }
                if (this.b(b)) {
                    this.a = null;
                    TrendAverageCalculator.c(b, this.d, c, d, e);
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var r = _c.value;
                            var s = f(r.x);
                            var t = g(r.y);
                            if (!i2.isNaN_(s) && !i2.isNaN_(t)) {
                                n.add({ $type: i2.Point_$type, x: s, y: t });
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
                if (n.count > 0) {
                    this.f(n, h, a, i);
                }
            }
        };
        PolarTrendLineManager.prototype.f = function (a, b, c, d) {
            var _this = this;
            if (d != null) {
                d.i = c;
            }
            var e = ((function () {
                var $ret = new PolarLinePlanner();
                $ret.m = function (f) { return a.item(f).x; };
                $ret.n = function (f) { return a.item(f).y; };
                $ret.a = d;
                $ret.q = a.count;
                $ret.l = b.b;
                $ret.o = function (f) { return _this.l(a.item(f).x, a.item(f).y); };
                $ret.p = function (f) { return _this.m(a.item(f).x, a.item(f).y); };
                $ret.f = _this.i;
                $ret.b = _this.h;
                $ret.ab = b.f;
                $ret.ac = b.g;
                return $ret;
            })());
            e.x(null, null);
        };
        PolarTrendLineManager.$t = i2.markType(PolarTrendLineManager, 'PolarTrendLineManager', TrendLineManagerBase$1.$.specialize(i2.Point_$type));
        return PolarTrendLineManager;
    }(TrendLineManagerBase$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerManagerBucket = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerManagerBucket, _super);
        function MarkerManagerBucket() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.c = null;
            return _this;
        }
        Object.defineProperty(MarkerManagerBucket.prototype, "d", {
            get: function () {
                if (this.b == null) {
                    this.b = new i2.List$1(i2.Number_$type, 0);
                }
                return this.b;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerManagerBucket.prototype, "e", {
            get: function () {
                if (this.c == null) {
                    this.c = new i2.List$1(i2.Number_$type, 0);
                }
                return this.c;
            },
            enumerable: false,
            configurable: true
        });
        MarkerManagerBucket.prototype.f = function (a) {
            if (this.e.count > 0) {
                var b = this.e._inner[this.e.count - 1];
                this.e.removeAt(this.e.count - 1);
                a = true;
                return {
                    ret: b,
                    p0: a
                };
            }
            var c = this.d._inner[this.d.count - 1];
            this.d.removeAt(this.d.count - 1);
            a = false;
            return {
                ret: c,
                p0: a
            };
        };
        Object.defineProperty(MarkerManagerBucket.prototype, "a", {
            get: function () {
                return this.d.count == 0 && this.e.count == 0;
            },
            enumerable: false,
            configurable: true
        });
        MarkerManagerBucket.$t = i2.markType(MarkerManagerBucket, 'MarkerManagerBucket');
        return MarkerManagerBucket;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerManagerBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerManagerBase, _super);
        function MarkerManagerBase(a, b, c, d, e) {
            var _this = _super.call(this) || this;
            _this.f = null;
            _this.h = null;
            _this.a = null;
            _this.g = null;
            _this.e = null;
            _this.h = a;
            _this.g = b;
            _this.a = c;
            _this.f = d;
            _this.e = e;
            return _this;
        }
        MarkerManagerBase.prototype.d = function (a, b) {
            var e_1, _a;
            var c = new i2.List$1(i2.Number_$type, 0);
            var d = new i2.List$1(i2.Number_$type, 0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (a.item(e).e.count > 0) {
                        c.add(e);
                    }
                    else {
                        d.add(e);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var f = new i2.List$1(i2.Number_$type, 0);
            f.o(c);
            f.o(d);
            return f;
        };
        MarkerManagerBase.prototype.k = function (a, b, c, d) {
            var e_2, _a;
            while (a > 0) {
                if (a < c.count) {
                    if (!MarkerManagerBase.b) {
                        var e = c;
                        i2.ArrayExtension.shuffle$1(i2.Number_$type, e);
                    }
                    c = this.d(b, c);
                    var f = a;
                    var _loop_1 = function (g) {
                        var h = g;
                        var i = b.item(c._inner[h]);
                        var j;
                        var k = ((function () { var l = i.f(j); j = l.p0; return l.ret; })());
                        d.add(k);
                        a--;
                        if (i.a) {
                            b.removeItem(c._inner[h]);
                        }
                    };
                    for (var g = 0; g < f; g++) {
                        _loop_1(g);
                    }
                }
                else {
                    var _loop_2 = function (l) {
                        var m = b.item(l);
                        var n;
                        var o = ((function () { var p = m.f(n); n = p.p0; return p.ret; })());
                        d.add(o);
                        a--;
                        if (m.a) {
                            b.removeItem(l);
                        }
                    };
                    try {
                        for (var _b = (e_2 = void 0, tslib.__values(i2.fromEnum(c))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var l = _c.value;
                            _loop_2(l);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    c = new i2.List$1(i2.Number_$type, 1, b.keys);
                }
            }
        };
        MarkerManagerBase.prototype.i = function (a, b, c, d) {
            var e = b.left;
            var f = b.right;
            var g = b.top;
            var h = b.bottom;
            if (!a.isEmpty && !b.isEmpty) {
                for (var i = 0; i < c.count; ++i) {
                    var j = c.item(i).x;
                    if (i2.isNaN_(j)) {
                        continue;
                    }
                    var k = c.item(i).y;
                    if (i2.isNaN_(k)) {
                        continue;
                    }
                    if (j < e || j > f) {
                        continue;
                    }
                    if (k < g || k > h) {
                        continue;
                    }
                    d.add(i);
                }
            }
        };
        MarkerManagerBase.prototype.c = function (a, b, c, d) {
            var e_3, _a, e_4, _b;
            var e = new Array(d.count);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.e())), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var f = _d.value;
                    if (f != -1) {
                        e[f] = true;
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            var g = i2.truncate(Math.floor(a.width / c));
            var h = new i2.Dictionary$2(i2.Number_$type, MarkerManagerBucket.$, 0);
            var _loop_3 = function (i) {
                var j = d.item(i).x;
                var k = d.item(i).y;
                var l = i2.truncate(Math.floor(k / c));
                var m = i2.truncate(Math.floor(j / c));
                var n = (l * g) + m;
                var o;
                if (!((function () { var p = h.tryGetValue(n, o); o = p.p1; return p.ret; })())) {
                    o = new MarkerManagerBucket();
                    h.addItem(n, o);
                }
                if (e[i]) {
                    o.e.add(i);
                }
                else {
                    o.d.add(i);
                }
            };
            try {
                for (var _e = tslib.__values(i2.fromEnum(b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var i = _f.value;
                    _loop_3(i);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            return h;
        };
        MarkerManagerBase.$t = i2.markType(MarkerManagerBase, 'MarkerManagerBase');
        MarkerManagerBase.b = false;
        return MarkerManagerBase;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumericMarkerManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericMarkerManager, _super);
        function NumericMarkerManager(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        var h = [c, d, e, f, g, function () { return 0; }];
                        {
                            var j = h[0];
                            var k = h[1];
                            var l = h[2];
                            var m = h[3];
                            var n = h[4];
                            var o = h[5];
                            _this = _super.call(this, j, k, l, m, n) || this;
                            _this.n = false;
                            _this.p = null;
                            _this.o = null;
                            _this.q = null;
                            _this.m = null;
                            _this.n = false;
                            _this.p = function (p) { return ({ $type: i2.Point_$type, x: 0, y: 0 }); };
                            _this.o = o;
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        var h = _rest[5];
                        _this = _super.call(this, c, d, e, f, g) || this;
                        _this.n = false;
                        _this.p = null;
                        _this.o = null;
                        _this.q = null;
                        _this.m = null;
                        _this.n = false;
                        _this.p = function (i) { return ({ $type: i2.Point_$type, x: 0, y: 0 }); };
                        _this.o = h;
                    }
                    break;
            }
            return _this;
        }
        NumericMarkerManager.prototype.l = function (a, b, c, d, e) {
            var f = this.f();
            a.clear();
            var g = new i2.List$1(i2.Number_$type, 0);
            b = Math.max(0, b);
            var h = null;
            this.i(c, d, i2.boxArray$1(f), g);
            if (b >= g.count) {
                h = g;
            }
            else {
                h = new i2.List$1(i2.Number_$type, 0);
                var i = Math.max(8, e);
                var j = this.c(d, g, i, i2.boxArray$1(f));
                var k = new i2.List$1(i2.Number_$type, 1, j.keys);
                if (MarkerManagerBase.b) {
                    k.y();
                }
                this.k(b, j, k, h);
            }
            this.r(a, f, h);
        };
        NumericMarkerManager.prototype.r = function (a, b, c) {
            for (var d = 0; d < c.count; ++d) {
                var e = c._inner[d];
                var f = b[e];
                var g = this.g(e);
                var h = this.h(g);
                h.ak = e;
                if (h.content != null) {
                    h.content.item = g;
                }
                var i = new OwnedPoint();
                if (this.n) {
                    i.b = this.p(e);
                }
                i.a = g;
                i.c = { $type: i2.Point_$type, x: f.x, y: f.y };
                if (!a.containsKey(g)) {
                    a.addItem(g, i);
                }
            }
        };
        NumericMarkerManager.prototype.j = function (a, b) {
            var e_1, _a;
            var c = a.keys;
            if (MarkerManagerBase.b) {
                var d = new i2.List$1(i2.Base.$, 1, a.keys);
                d.aa(function (e, f) {
                    var g = a.item(e);
                    var h = a.item(f);
                    var i = Math.pow(g.c.x, 2) + Math.pow(g.c.y, 2);
                    var j = Math.pow(h.c.x, 2) + Math.pow(h.c.y, 2);
                    return i2.CompareUtil.compareToObject(i, j);
                });
                c = d;
            }
            var e = null;
            var f = null;
            switch (this.o()) {
                case 0: break;
                case 1:
                    e = ((function () {
                        var $ret = new i2.SmartPlacer();
                        $ret.c = 0.3;
                        $ret.b = 0;
                        return $ret;
                    })());
                    f = new i2.SmartPlaceableWrapper$1(Marker.$);
                    f.f = true;
                    break;
                case 2:
                    e = ((function () {
                        var $ret = new i2.SmartPlacer();
                        $ret.c = 0.6;
                        $ret.b = 2;
                        return $ret;
                    })());
                    f = new i2.SmartPlaceableWrapper$1(Marker.$);
                    f.f = true;
                    break;
                case 3:
                    e = ((function () {
                        var $ret = new i2.SmartPlacer();
                        $ret.c = 0.3;
                        $ret.b = 0;
                        return $ret;
                    })());
                    f = new i2.SmartPlaceableWrapper$1(Marker.$);
                    break;
                case 4:
                    e = ((function () {
                        var $ret = new i2.SmartPlacer();
                        $ret.c = 0.6;
                        $ret.b = 2;
                        return $ret;
                    })());
                    f = new i2.SmartPlaceableWrapper$1(Marker.$);
                    break;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    var h = a.item(g);
                    var i = this.h(h.a);
                    if (e != null && f != null) {
                        f.d = i;
                        f.j = this.q(i);
                        f.i = h.c;
                        e.d(f);
                        if (f.opacity == 0) {
                            f.smartPosition = f.smartPosition;
                        }
                        h.c = f.g;
                    }
                    else {
                        i._opacity = 1;
                        i._visibility = 0;
                    }
                    this.s(i, h, b);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.a(a);
        };
        NumericMarkerManager.prototype.s = function (a, b, c) {
            a.n = b.c.x;
            a.o = b.c.y;
        };
        NumericMarkerManager.$t = i2.markType(NumericMarkerManager, 'NumericMarkerManager', MarkerManagerBase.$);
        return NumericMarkerManager;
    }(MarkerManagerBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarBase, _super);
        function PolarBase() {
            var _this = _super.call(this) || this;
            _this.rd = null;
            _this.qz = null;
            _this.rb = null;
            _this.t3 = null;
            _this.t2 = null;
            _this.rp = null;
            _this.rr = null;
            _this.rs = null;
            _this.rh = new PolarFrame();
            _this.rj = new PolarFrame();
            _this.rf = new PolarFrame();
            _this.ra = null;
            _this.r9 = null;
            _this.rl = 1;
            _this.rw = false;
            _this.rv = false;
            _this.q6 = null;
            _this.q7 = null;
            _this.assigningPolarStyle = null;
            _this.assigningPolarMarkerStyle = null;
            _this.rk = null;
            _this.ri = null;
            _this.re = null;
            _this.rk = new PolarSeriesRenderManager();
            _this.rm = _this.rn();
            _this.ri = new PolarFrame();
            _this.rj.x = i2.runOn(_this, _this.t1);
            _this.rh.x = i2.runOn(_this, _this.t1);
            _this.rf.x = i2.runOn(_this, _this.t1);
            _this.rp = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, i2.runOn(_this, _this.s8), i2.runOn(_this, _this.tc), i2.runOn(_this, _this.cr), i2.runOn(_this, _this.l8), i2.runOn(_this, _this.s3));
            return _this;
        }
        PolarBase.prototype.bu = function () {
            return new PolarBaseView(this);
        };
        PolarBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.rc = a;
        };
        PolarBase.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.q8 = null;
            this.q9 = null;
        };
        PolarBase.prototype.get_d0 = function () {
            return true;
        };
        PolarBase.prototype.cx = function (a, b, c) {
            var _this = this;
            if (!this.hasMarkers) {
                return false;
            }
            var d = this.q8;
            var e = new ScalerParams(1, this.ca.pg, this.pf, d.cc);
            e.c = this.getEffectiveViewport1(this.bx);
            var f = this.q9;
            var g = new ScalerParams(1, this.ca.pg, this.pf, f.cc);
            g.c = this.getEffectiveViewport1(this.bx);
            a.clear();
            this.pq.cf(function (h) {
                if (h._visibility == 0) {
                    var i = new SeriesPointOfInterest();
                    var j = h.n;
                    var k = h.o;
                    if (j < _this.pf.left || j > _this.pf.right || k < _this.pf.top || k > _this.pf.bottom) {
                        return;
                    }
                    var l = void 0;
                    var m = void 0;
                    var n = _this.ra.f(j, k, _this.bx.bv, _this.bx.bu, l, m);
                    l = n.p4;
                    m = n.p5;
                    i.b = l;
                    i.c = m;
                    i.a = h.content;
                    a.add(i);
                }
            });
            return true;
        };
        PolarBase.prototype.s3 = function () {
            if (this.cb.g) {
                this.cb.t();
            }
        };
        PolarBase.prototype.s5 = function () {
            this.ra.e(this.rd.w, this.rt, this.ru, this.t3, this.t2, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
        };
        Object.defineProperty(PolarBase.prototype, "rt", {
            get: function () {
                return this.rr;
            },
            set: function (a) {
                if (this.rr != a) {
                    var b = this.rt;
                    this.rr = a;
                    this.raisePropertyChanged("AngleColumn", b, this.rt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarBase.prototype, "ru", {
            get: function () {
                return this.rs;
            },
            set: function (a) {
                if (this.rs != a) {
                    var b = this.ru;
                    this.rs = a;
                    this.raisePropertyChanged("RadiusColumn", b, this.ru);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarBase.prototype, "tw", {
            get: function () {
                return this.c(PolarBase.td);
            },
            set: function (a) {
                this.h(PolarBase.td, a);
            },
            enumerable: false,
            configurable: true
        });
        PolarBase.prototype.rg = function () {
            var a = this.rf;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.rj;
            }
            return a;
        };
        PolarBase.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.q9 != null) {
                this.q9.hq(false);
            }
            if (this.q8 != null) {
                this.q8.hq(false);
            }
        };
        PolarBase.prototype.kk = function (a, b, c, d) {
            var e = false;
            this.rc.cv.g$e(a, b, c, d);
            if (this.q8 != null && !this.q8.cv()) {
                e = true;
            }
            if (this.q9 != null && !this.q9.cv()) {
                e = true;
            }
            if (e) {
                this.l0(true);
            }
        };
        PolarBase.prototype.mm = function (a, b) {
            this.l0(false);
        };
        PolarBase.prototype.mn = function (a, b) {
            this.l0(false);
        };
        PolarBase.prototype.e3 = function (a, b, c) {
            var d = true;
            if (!_super.prototype.e3.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.q8 == null || this.q9 == null || this.rt == null || this.ru == null || this.rt.count == 0 || this.ru.count == 0 || this.ch == null || this.ch.count != this.rt.count || this.ch.count != this.ru.count || this.ra == null || this.q8.bh == null || this.q9.bh == null || this.q8.kv == this.q8.ku || this.q9.kv == this.q9.ku) {
                d = false;
            }
            return d;
        };
        PolarBase.prototype.l1 = function (a) {
            var b;
            var c;
            var d = this.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            if (!this.e3(c, b, this.bx)) {
                this.kh(true, this.bx);
                return;
            }
            this.t3 = b;
            this.t2 = c;
            this.rb = new PolarAxisInfoCache(this.q8, this.q9, this.ch);
            var e = new SeriesRenderingArguments(this, c, b, a, this.em);
            var f = this.rp.g(e, this.rh, this.rf, this.rj, this.rc);
            this.rh = f.p1;
            this.rf = f.p2;
            this.rj = f.p3;
        };
        PolarBase.prototype.t1 = function (a) {
            var b = this.ra.h(a.x, a.y, this.t3, this.t2, this.rb.e, this.rb.d, this.rb.g, this.rb.f, this.rb.i, this.rb.h);
            return b;
        };
        PolarBase.prototype.ap = function (a) {
            if (a != null && a == this.q8 && this.rt != null) {
                return new AxisRange(this.rt.minimum, this.rt.maximum);
            }
            if (a != null && a == this.q9 && this.ru != null) {
                return new AxisRange(this.ru.minimum, this.ru.maximum);
            }
            return null;
        };
        PolarBase.prototype.eh = function (a) {
            var b = this.bx.bv;
            b = b.copy();
            var c = this.bx.bu;
            var d = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            if (this.q8 == null || this.rt == null || this.q9 == null || this.ru == null) {
                return false;
            }
            if (d < 0 || d > this.rt.count - 1 || d > this.ru.count - 1) {
                return false;
            }
            var e = this.q8.getScaledAngle(this.rt.item(d));
            var f = this.q9.mg(this.ru.item(d));
            var g = 0.5 + (Math.cos(e) * f);
            var h = 0.5 + (Math.sin(e) * f);
            if (!i2.isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!i2.isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.b5 != null) {
                this.b5.ap(this.ca, b, true);
            }
            return d >= 0;
        };
        PolarBase.prototype.hh = function (a) {
            var b = this.g0(a);
            if (this.ch != null && b >= 0 && b < this.ch.count) {
                return this.ch.item(b);
            }
            return null;
        };
        PolarBase.prototype.g0 = function (a) {
            var b = i2.truncate(Math.round(this.fw(a)));
            return b;
        };
        PolarBase.prototype.fw = function (a) {
            switch (this.rm) {
                case 1: return this.sd(a);
                case 3: return this.se(a);
                case 2: return this.sb(a);
                case 4: return this.sc(a);
            }
            return -1;
        };
        PolarBase.prototype.sc = function (a) {
            return this.sf(a, false);
        };
        PolarBase.prototype.sb = function (a) {
            var b = this.ox(a);
            var c = b.x;
            var d = b.y;
            if (this.ch == null || this.q8 == null || this.q9 == null || this.rt == null || this.ru == null) {
                return -1;
            }
            if (this.ch.count > this.sh) {
                return -1;
            }
            this.r0();
            var e = this.r9;
            var f = 1.7976931348623157E+308;
            var g = -1;
            for (var h = 0; h < this.rt.count; h++) {
                var i = e._inner[h].x;
                var j = e._inner[h].y;
                var k = (c - i) * (c - i) + (d - j) * (d - j);
                if (k < f) {
                    f = k;
                    g = h;
                }
            }
            return g;
        };
        PolarBase.prototype.r0 = function () {
            var a = this.rf;
            if (this.cr()) {
                a = this.rj;
            }
            if (a == null || a.w.count == 0) {
                return false;
            }
            this.r9 = a.w;
            return true;
        };
        PolarBase.prototype.sf = function (a, b) {
            if (!this.r3) {
                return -1;
            }
            var c = { $type: i2.Point_$type, x: 0, y: 0 };
            var d = true;
            var e = this.rf;
            if (this.cr()) {
                e = this.rj;
            }
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.ch.count > this.sh) {
                return -1;
            }
            this.r0();
            var f = this.r9;
            var g = this.ox(a);
            var h = 1.7976931348623157E+308;
            var i = -1;
            for (var j = 0; j < f.count; j++) {
                var k = f._inner[j];
                if (j > 0) {
                    if (i2.isNaN_(k.x) || i2.isNaN_(k.y) || i2.isNaN_(c.x) || i2.isNaN_(c.y)) {
                        c = k;
                        continue;
                    }
                    if (!b || e.j.containsKey(this.ch.item(j)) || e.j.containsKey(this.ch.item(j - 1))) {
                        var l = i2.GeometryUtil.d(g, c, k);
                        if (l < h) {
                            h = l;
                            i = j;
                        }
                    }
                }
                c = k;
            }
            if (i >= 0) {
                var m = f._inner[i];
                var n = f._inner[i - 1];
                if (!b || (e.j.containsKey(this.ch.item(i)) && e.j.containsKey(this.ch.item(i - 1)))) {
                    var o = i2.GeometryUtil.h(g, n, m);
                    return (i - 1) + o;
                }
                else if (e.j.containsKey(this.ch.item(i))) {
                    return i;
                }
                else {
                    return i - 1;
                }
            }
            return -1;
        };
        PolarBase.prototype.se = function (a) {
            return this.sf(a, true);
        };
        PolarBase.prototype.sd = function (a) {
            var _this = this;
            var b = null;
            var c = 1.7976931348623157E+308;
            var d = this.ox(a);
            var e = d.x;
            var f = d.y;
            if (this.rc.cw.e > this.sh) {
                return -1;
            }
            this.rc.cz(function (g) {
                if (g._visibility == 0) {
                    var h = _this.rc.cp(g);
                    var i = h.left + h.width / 2;
                    var j = h.top + h.height / 2;
                    var k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        };
        PolarBase.prototype.o2 = function (a, b, c) {
            var _this = this;
            if (this.q8 == null || this.q9 == null || this.rt == null || this.ru == null) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            var d = this.bx.bv;
            var e = this.bx.bu;
            var f = this.getEffectiveViewport();
            var g = new ScalerParams(0, d, e, this.q8.cc, f);
            var h = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.q9.cc, f);
                $ret.b = _this.f2();
                return $ret;
            })());
            if (b) {
                var i = this.fw(a);
                if (i == -1) {
                    return { $type: i2.Point_$type, x: NaN, y: NaN };
                }
                var j = i2.truncate(Math.floor(i));
                var k = i2.truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.ch.count - 1) {
                    k = this.ch.count - 1;
                }
                if (j > this.ch.count - 1) {
                    j = this.ch.count - 1;
                }
                if (k == j) {
                    return this.ra.h(this.rt.item(j), this.ru.item(j), d, e, this.rb.e, this.rb.d, this.rb.g, this.rb.f, this.rb.i, this.rb.h);
                }
                var l = i - Math.floor(i);
                var m = this.ra.h(this.rt.item(j), this.ru.item(j), d, e, this.rb.e, this.rb.d, this.rb.g, this.rb.f, this.rb.i, this.rb.h);
                var n = this.ra.h(this.rt.item(k), this.ru.item(k), d, e, this.rb.e, this.rb.d, this.rb.g, this.rb.f, this.rb.i, this.rb.h);
                var o = m.x;
                var p = m.y;
                var q = n.x;
                var r = n.y;
                var s = q - o;
                var t = r - p;
                return { $type: i2.Point_$type, x: o + s * l, y: p + t * l };
            }
            else {
                var u = this.g0(a);
                if (u == -1) {
                    return { $type: i2.Point_$type, x: NaN, y: NaN };
                }
                return this.ra.h(this.rt.item(u), this.ru.item(u), d, e, this.rb.e, this.rb.d, this.rb.g, this.rb.f, this.rb.i, this.rb.h);
            }
        };
        PolarBase.prototype.ag = function () {
            return [this.q8, this.q9];
        };
        PolarBase.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == PolarBase.$$p[1]) {
                return this.hl(a, b, this.so);
            }
            if (c == PolarBase.$$p[9]) {
                return this.hl(a, b, this.sy);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        PolarBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.rc.cv.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            switch (b) {
                case "FastItemsSource":
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.rt);
                        c.deregisterColumn(this.ru);
                        this.rt = null;
                        this.ru = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.rt = this.ce(this.so);
                        this.ru = this.ce(this.sy);
                    }
                    if ((this.q9 != null && !this.q9.cv()) || (this.q8 != null && !this.q8.cv())) {
                        this.l0(false);
                    }
                    break;
                case PolarBase.$$p[0]:
                    if (this.q8 != null && this.q9 != null) {
                        this.ra = new PolarAxes(this.q9, this.q8);
                    }
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if (this.q8 != null && !this.q8.cv()) {
                        this.l0(false);
                    }
                    else if (c != null && d == null) {
                        this.kh(true, this.bx);
                    }
                    break;
                case PolarBase.$$p[8]:
                    if (this.q8 != null && this.q9 != null) {
                        this.ra = new PolarAxes(this.q9, this.q8);
                    }
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if (this.q9 != null && !this.q9.cv()) {
                        this.l0(false);
                    }
                    else if (c != null && d == null) {
                        this.kh(true, this.bx);
                    }
                    if (this.q8 != null && !this.q8.cv()) {
                        this.q8.hm();
                    }
                    break;
                case PolarBase.$$p[1]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.rt);
                        this.rt = this.ce(this.so);
                    }
                    break;
                case "AngleColumn":
                    this.rc.cv.g$i();
                    if (this.q8 != null && !this.q8.cv()) {
                        this.l0(false);
                    }
                    break;
                case PolarBase.$$p[9]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.ru);
                        this.ru = this.ce(this.sy);
                    }
                    break;
                case "RadiusColumn":
                    this.rc.cv.g$i();
                    if (this.q9 != null && !this.q9.cv()) {
                        this.l0(false);
                    }
                    break;
                case PolarBase.$$p[10]:
                    this.l0(false);
                    this.k7();
                    break;
                case PolarBase.$$p[7]:
                    this.l0(false);
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.rb = new PolarAxisInfoCache(this.q8, this.q9, this.ch);
                    this.t3 = this.bx.bv;
                    this.t2 = this.bx.bu;
                    this.rj.v = this.r8;
                    this.rj.c(this.gn, this.rh, this.rf);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.tc(this.rf, this.rc);
                    }
                    else {
                        this.tc(this.rj, this.rc);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case PolarBase.$$p[2]:
                    this.l0(false);
                    this.k7();
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
                case PolarBase.$$p[4]:
                    this.rw = this.r5();
                    this.l0(false);
                    break;
                case PolarBase.$$p[3]:
                    this.rv = this.r4();
                    this.l0(false);
                    break;
                case PolarBase.$$p[5]:
                    this.rm = this.rn();
                    break;
            }
        };
        Object.defineProperty(PolarBase.prototype, "rm", {
            get: function () {
                return this.rl;
            },
            set: function (a) {
                var b = this.rl;
                this.rl = a;
                if (b != this.rl) {
                    this.raisePropertyChanged("ActualItemSearchMode", i2.enumGetBox(ScatterItemSearchMode_$type, b), i2.enumGetBox(ScatterItemSearchMode_$type, this.rl));
                }
            },
            enumerable: false,
            configurable: true
        });
        PolarBase.prototype.rn = function () {
            if (this.ro != 0) {
                return this.ro;
            }
            return this.r3 ? 4 : 1;
        };
        PolarBase.prototype.get_r3 = function () {
            return false;
        };
        Object.defineProperty(PolarBase.prototype, "r3", {
            get: function () {
                return this.get_r3();
            },
            enumerable: false,
            configurable: true
        });
        PolarBase.prototype.r5 = function () {
            return this.r2;
        };
        PolarBase.prototype.r4 = function () {
            return this.r1;
        };
        PolarBase.prototype.ry = function (a) {
            if (i2.typeCast(NumericRadiusAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        PolarBase.prototype.rx = function (a) {
            if (i2.typeCast(NumericAngleAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        PolarBase.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a) {
                c.cw.clear();
            }
            c.cv.g$d();
        };
        PolarBase.prototype.q0 = function (a, b) {
            var c = a.top - 10;
            var d = a.bottom + 10;
            var e = a.left - 10;
            var f = a.right + 10;
            var g = ((function () {
                var $ret = new i2.Clipper(1, e, d, f, c, false);
                $ret.i = b;
                return $ret;
            })());
            return g;
        };
        PolarBase.prototype.s2 = function (a, b, c, d) {
            a.g = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 1, b);
            var e = this.ch;
            var _loop_1 = function (f) {
                var g = a.w._inner[f];
                if (!i2.isInfinity(g.x) && !i2.isInfinity(g.y)) {
                    var h_1 = { $type: i2.Point_$type, x: this_1.rt.item(f), y: this_1.ru.item(f) };
                    var i_1 = { $type: i2.Point_$type, x: g.x, y: g.y };
                    a.g.addItem(e.item(f), ((function () {
                        var $ret = new OwnedPoint();
                        $ret.a = e.item(f);
                        $ret.b = h_1;
                        $ret.c = i_1;
                        return $ret;
                    })()));
                }
            };
            var this_1 = this;
            for (var f = 0; f < b; f++) {
                _loop_1(f);
            }
        };
        PolarBase.prototype.s8 = function (a, b) {
            var _this = this;
            var c = b.bv;
            var d = b.bu;
            a.j.clear();
            a.n.clear();
            var e = Math.min(this.rt != null ? this.rt.count : 0, this.ru != null ? this.ru.count : 0);
            if (e < 1) {
                return;
            }
            this.rb = new PolarAxisInfoCache(this.q8, this.q9, this.ch);
            this.rd = a;
            this.t2 = d;
            this.t3 = c;
            b.ct.l(a.j, this.si, c, d, this.gh);
            if (e <= this.si) {
                this.s2(a, e, c, d);
            }
            var f = this.q0(d, a.n);
            var g = Math.min(this.q8.kv, this.q8.ku);
            var h = Math.max(this.q8.ku, this.q8.kv);
            b.cv.i = this.r8;
            b.cv.h = 0;
            b.cv.k = this.q9.ma;
            b.cv.j = this.q9.l9;
            b.cv.l = function (i, j) { return _this.ra.c(i, j, c, d, Math.cos); };
            b.cv.m = function (i, j) { return _this.ra.d(i, j, c, d, Math.sin); };
            var i = new i2.List$1(i2.Number_$type, 0);
            for (var j = 0; j < this.rt.count; j++) {
                if (this.rt.item(j) >= g && this.rt.item(j) <= h) {
                    i.add(this.rt.item(j));
                }
            }
            var k = this.ru;
            if (i.count != this.rt.count) {
                k = new i2.List$1(i2.Number_$type, 0);
                for (var l = 0; l < this.rt.count; l++) {
                    if (this.rt.item(l) >= g && this.rt.item(l) <= h) {
                        k.add(this.ru.item(l));
                    }
                }
            }
            b.cv.n(a.n, this.rq, i, k, this.sj, i2.runOn(this.q8, this.q8.getScaledAngle), i2.runOn(this.q9, this.q9.mg), ((function () {
                var $ret = new TrendResolutionParams();
                $ret.b = _this.gh;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()), f, g, h);
        };
        PolarBase.prototype.get_dr = function () {
            return true;
        };
        PolarBase.prototype.q4 = function (a, b, c) {
            return null;
        };
        PolarBase.prototype.q5 = function (a, b, c) {
            var d = this.rg();
            var e = this.rc.by(this.ox(b));
            var f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ch.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            var g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            g.e = true;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        };
        PolarBase.prototype.q3 = function (a, b, c) {
            var d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        };
        PolarBase.prototype.av = function (a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                var d = this.q4(a, b, this.q6);
                this.q6 = d;
                return d;
            }
            else {
                var e = this.q3(a, b, this.q6);
                this.q6 = e;
                return e;
            }
        };
        PolarBase.prototype.aw = function (a, b, c) {
            if (this.d9(this.bj) && !c) {
                var d = this.q5(a, b, this.q7);
                this.q7 = d;
                return d;
            }
            else {
                var e = this.q3(a, b, this.q7);
                e.e = true;
                this.q7 = e;
                return e;
            }
        };
        PolarBase.prototype.r7 = function () {
            return (this.assigningPolarStyle != null && this.rw) || (this.bj != 1);
        };
        PolarBase.prototype.r6 = function () {
            return (this.assigningPolarMarkerStyle != null && this.rv) || (this.bj != 1);
        };
        PolarBase.prototype.tc = function (a, b) {
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.o7(b);
            this.rb = new PolarAxisInfoCache(this.q8, this.q9, this.ch);
            if (this.pt()) {
                b.ct.j(a.j, this.pv);
                if (this.r6()) {
                    this.s4(b, a);
                }
            }
            b.cm();
            var g = this.q0(d, b.cv.g$j.ak);
            b.cv.g$h(a.n, g);
            this.s1(d, c, e, f, b);
        };
        PolarBase.prototype.qx = function (a, b) {
            return this.qy(a, b);
        };
        PolarBase.prototype.qy = function (a, b) {
            if (b < a || a < 0 || a > this.rt.count || b < 0 || b > this.rt.count) {
                return null;
            }
            var c = new Array((b - a) + 1);
            for (var d = a; d <= b; d++) {
                var e = d;
                c[d - a] = this.ch.item(d);
            }
            return c;
        };
        PolarBase.prototype.s4 = function (a, b) {
            var _this = this;
            a.b3 = true;
            this.rk.aw(this, this.r6(), i2.runOn(this, this.qx));
            var c = this.rk.d;
            var d = c != null;
            var e = this.getEffectiveViewport1(a);
            var f = this.ch == null ? 0 : this.ch.count;
            this.rc.cf(function (g) {
                if (g._visibility == 0) {
                    var h = g.ak;
                    var i = g.content;
                    if (i == null) {
                        i = new i2.DataContext();
                        g.content = i;
                    }
                    if (d) {
                        _this.s6(h, f, a.q);
                    }
                    _this.rk.ac(g, i);
                }
            });
        };
        PolarBase.prototype.s7 = function (a, b, c) {
            var d = this.bj != 1;
            this.rk.ay(this.rk.b, a, b, false);
            this.rk.ab(this.fj);
            var e = this.rk.av;
            var f = null;
            var g = this.ch;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, false);
                e.b = f;
            }
            e.f = c;
            this.ta(e);
            this.rk.z(this, f, c, d, a < 0);
        };
        PolarBase.prototype.s6 = function (a, b, c) {
            var d = this.bj != 1;
            this.rk.ay(this.rk.d, a, b, true);
            this.rk.aa(this.fj);
            var e = this.rk.au;
            var f = null;
            var g = this.ch;
            var h = null;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    h = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.s9(e);
            this.rk.y(this, f, c, d, e.l, this.ca.a3.sumHighlightingProgress);
        };
        PolarBase.prototype.ta = function (a) {
            if (this.assigningPolarStyle != null && this.rw) {
                this.assigningPolarStyle(this, a);
            }
        };
        PolarBase.prototype.s9 = function (a) {
            if (this.assigningPolarMarkerStyle != null && this.rv) {
                this.assigningPolarMarkerStyle(this, a);
            }
        };
        PolarBase.prototype.s1 = function (a, b, c, d, e) {
            e.cy(a, b, c, d);
        };
        PolarBase.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            this.rc.c1();
        };
        PolarBase.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            var c = this.bw;
            if (!this.en) {
                this.ri = new PolarFrame();
                this.s8(this.ri, c);
            }
            this.en = false;
            this.tc(this.ri, c);
            this.et = false;
        };
        PolarBase.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.re == null) {
                this.re = new PolarFrame();
            }
            this.s8(this.re, g);
            this.tc(this.re, g);
        };
        PolarBase.prototype.tb = function (a, b) {
            var e_1, _a, e_2, _b;
            var c = new i2.List$1(i2.Base.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    if (!a.containsKey(d)) {
                        c.add1(d);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    b.h(e);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        PolarBase.prototype.qw = function (a, b, c) {
            this.s5();
            return this.rd.w.toArray();
        };
        PolarBase.prototype.sa = function (a) {
            var e_3, _a;
            var b = new i2.List$1(i2.Number_$type, 0);
            var c = this.ch;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.rc.cw.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    b.add(c.indexOf(d));
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return b;
        };
        PolarBase.prototype.t0 = function (a) {
            return { $type: i2.Point_$type, x: this.rt.item(a), y: this.ru.item(a) };
        };
        PolarBase.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            this.a6.exportTrendlineData(this, a, this.rc.cv.g$j);
        };
        PolarBase.$t = i2.markType(PolarBase, 'PolarBase', MarkerSeries.$);
        PolarBase.td = i2.DependencyProperty.i("ActualTrendLineBrush", i2.Brush.$, PolarBase.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
        PolarBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:q8:te', [NumericAngleAxis.$, null], 'AngleMemberPath:so:tf', [2], 'ClipSeriesToBounds:rz:tg', [0, false], 'IsCustomPolarMarkerStyleAllowed:r1:th', [0, false], 'IsCustomPolarStyleAllowed:r2:ti', [0, false], 'ItemSearchMode:ro:tj', [ScatterItemSearchMode_$type, i2.enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sh:tk', [1, 10000], 'MaximumMarkers:si:tl', [1, 400], 'RadiusAxis:q9:tm', [NumericRadiusAxis.$, null], 'RadiusMemberPath:sy:tn', [2], 'UseCartesianInterpolation:r8:tv', [0, true], 'TrendLineType:rq:tt', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'TrendLineThickness:sg:ts', [1, 1.5], 'TrendLinePeriod:sj:tr', [1, 7], 'TrendLineZIndex:sk:tu', [1, 1], 'TrendLineBrush:tx:to', [i2.Brush.$, null], 'TrendLineDashArray:ty:tp', [i2.DoubleCollection.$], 'TrendLineDashCap:tz:tq', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)]]);
        return PolarBase;
    }(MarkerSeries));
    /**
     * @hidden
     */
    var PolarSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarSeriesRenderManager, _super);
        function PolarSeriesRenderManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.au = null;
            _this.av = null;
            return _this;
        }
        PolarSeriesRenderManager.prototype.c = function () {
            this.au = new AssigningPolarMarkerStyleEventArgs();
            return this.au;
        };
        PolarSeriesRenderManager.prototype.a = function () {
            this.av = new AssigningPolarStyleEventArgs();
            return this.av;
        };
        PolarSeriesRenderManager.prototype.aw = function (a, b, c) {
            this.w(a, b, c);
        };
        PolarSeriesRenderManager.prototype.ax = function (a, b, c) {
            this.x(a, b, c);
        };
        PolarSeriesRenderManager.prototype.ay = function (a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        };
        PolarSeriesRenderManager.$t = i2.markType(PolarSeriesRenderManager, 'PolarSeriesRenderManager', SeriesRenderManager.$);
        return PolarSeriesRenderManager;
    }(SeriesRenderManager));
    /**
     * @hidden
     */
    var PolarBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarBaseView, _super);
        function PolarBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.cu = null;
            _this.ct = null;
            _this.cv = null;
            _this.cw = null;
            _this.cu = a;
            _this.cw = new i2.HashPool$2(i2.Base.$, Marker.$);
            _this.ch(_this.cw);
            _this.cv = new PolarTrendLineManager();
            return _this;
        }
        PolarBaseView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.ct = this.cs();
            if (!this.q) {
                this.cu.si = 1000;
                this.b1.pr = Defaults.e;
            }
        };
        PolarBaseView.prototype.cz = function (a) {
            this.cw.g(a);
        };
        PolarBaseView.prototype.cs = function () {
            var _this = this;
            var a = new NumericMarkerManager(0, function (b) { return _this.cw.item(b); }, function (b) { return _this.cu.rb.c.item(b); }, i2.runOn(this, this.c0), i2.runOn(this, this.cr), i2.runOn(this, this.cx));
            a.n = true;
            a.p = i2.runOn(this.cu, this.cu.t0);
            return a;
        };
        PolarBaseView.prototype.c0 = function (a) {
            this.cu.tb(a, this.cw);
        };
        PolarBaseView.prototype.cr = function () {
            return this.cu.qw(this.cw, this.bv, this.bu);
        };
        PolarBaseView.prototype.cx = function () {
            return this.cu.sa(this.cw);
        };
        PolarBaseView.prototype.cy = function (a, b, c, d) {
            if (this.cu.rz) {
                var e = new i2.GeometryGroup();
                this.cu.q9.mo(e, a, b, c, d);
            }
            else {
            }
        };
        PolarBaseView.prototype.c1 = function () {
            if (this.cu.tx != null) {
                this.cu.tw = this.cu.tx;
            }
            else {
                this.cu.tw = this.cu.of;
            }
        };
        PolarBaseView.prototype.cf = function (a) {
            this.cw.f(a);
        };
        PolarBaseView.prototype.a5 = function (a, b) {
            if (a.d) {
                if (this.cu.rq != 0 && !b) {
                    var c = this.cv.g$j;
                    c.ac = this.cu.sg;
                    c._stroke = this.cu.tw;
                    c.ad = this.cu.tz;
                    c.ai = this.cu.ty;
                    a.u(c);
                }
            }
            _super.prototype.a5.call(this, a, b);
        };
        PolarBaseView.prototype.c2 = function () {
            return i2.Rect.empty;
        };
        PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cu.so + "}" + "</span><br/><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cu.hp + ": </span><span class='ui-priority-primary'>" + "${item." + this.cu.sy + "}</span></div>";
            return a;
        };
        PolarBaseView.$t = i2.markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
        return PolarBaseView;
    }(MarkerSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NaNSegmenter = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NaNSegmenter, _super);
        function NaNSegmenter() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NaNSegmenter.c = function (a, b) {
            var c = new i2.List$1(i2.IList$1_$type.specialize(i2.Point_$type), 0);
            var d = i2.getEnumerator(a);
            var e = new i2.List$1(i2.Point_$type, 0);
            var f = true;
            while (d.moveNext()) {
                if (NaNSegmenter.a(d.current)) {
                    if (!f && b == 1) {
                        f = true;
                        var g = e;
                        e = new i2.List$1(i2.Point_$type, 0);
                        c.add(new i2.ReadOnlyCollection$1(i2.Point_$type, 1, g));
                    }
                }
                else {
                    f = false;
                    e.add(d.current);
                }
            }
            c.add(new i2.ReadOnlyCollection$1(i2.Point_$type, 1, e));
            return c;
        };
        NaNSegmenter.a = function (a) {
            return (i2.isNaN_(a.x) || i2.isNaN_(a.y) || i2.isInfinity(a.x) || i2.isInfinity(a.y));
        };
        NaNSegmenter.b = function (a) {
            return !NaNSegmenter.a(a);
        };
        NaNSegmenter.$t = i2.markType(NaNSegmenter, 'NaNSegmenter');
        return NaNSegmenter;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PathRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PathRenderer, _super);
        function PathRenderer(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        _this.b = 1;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        _this.a = c;
                    }
                    break;
            }
            return _this;
        }
        PathRenderer.prototype.d = function (a, b, c) {
            var e_1, _a;
            var d = NaNSegmenter.c(b, this.b);
            var e = this.c(d, c);
            var f = new i2.PathGeometry();
            try {
                for (var _b = tslib.__values(i2.fromEnum(e)), _d = _b.next(); !_d.done; _d = _b.next()) {
                    var g = _d.value;
                    f.c.add(g);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            a.ak = f;
        };
        PathRenderer.prototype._c = function (a, b) {
            var c, d, e, f, g;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = 0;
                        _a.label = 1;
                    case 1:
                        if (!(c < a.count))
                            return [3 /*break*/, 4];
                        d = a.item(c);
                        if (!(d.count >= 2))
                            return [3 /*break*/, 3];
                        e = new i2.PathFigure();
                        f = d.item(0);
                        e._startPoint = f;
                        g = this.e(d, b);
                        e._segments.add(g);
                        return [4 /*yield*/, e];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        c++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        PathRenderer.prototype.c = function (a, b) {
            var _this = this;
            return i2.toEnum(function () { return _this._c(a, b); });
        };
        PathRenderer.prototype.e = function (a, b) {
            var c = new i2.PolyLineSegment();
            if (this.a == null) {
                for (var d = 1; d < a.count; d++) {
                    var e = a.item(d);
                    c._points.add(e);
                }
            }
            else {
                var f = this.a.flatten(a, b);
                for (var g = 1; g < f.count; g++) {
                    var h = f.item(g);
                    c._points.add(h);
                }
            }
            return c;
        };
        PathRenderer.$t = i2.markType(PathRenderer, 'PathRenderer');
        return PathRenderer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IFlattener_$type = new i2.Type(null, 'IFlattener');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DefaultFlattener = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DefaultFlattener, _super);
        function DefaultFlattener() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DefaultFlattener.prototype.a = function (a, b, c, d, e, f) {
            var g = new i2.List$1(i2.Number_$type, 0);
            var h = d;
            var i = e;
            var j = i - h + 1;
            while (j > 0) {
                if (j <= 512) {
                    i2.Flattener.c(g, b, c, h, i, f);
                    h = i + 1;
                }
                else {
                    var k = h + 512 - 1;
                    i2.Flattener.c(g, b, c, h, k, f);
                    h = k + 1;
                }
                j = i - h + 1;
            }
            return g;
        };
        DefaultFlattener.prototype.d = function (a, b, c, d, e) {
            var f = new i2.List$1(i2.Number_$type, 0);
            var g = c;
            var h = d;
            var i = h - g + 1;
            while (i > 0) {
                if (i <= 512) {
                    i2.FastFlattener.e(f, a, b, g, h, e);
                    g = h + 1;
                }
                else {
                    var j = g + 512 - 1;
                    i2.FastFlattener.e(f, a, b, g, j, e);
                    g = j + 1;
                }
                i = h - g + 1;
            }
            return f;
        };
        DefaultFlattener.prototype.flatten = function (a, b) {
            var _this = this;
            var c = function (d) { return _this.f(a, d); };
            var d = function (e) { return _this.g(a, e); };
            return this.b(a, b, c, d);
        };
        DefaultFlattener.prototype.c = function (a, b, c, d) {
            return this.e(a, b, c, d);
        };
        DefaultFlattener.prototype.b = function (a, b, c, d) {
            var e = this.a(new i2.List$1(i2.Number_$type, 0), c, d, 0, a.count - 1, b);
            var f = new i2.RearrangedList$1(i2.Point_$type, a, e);
            return f;
        };
        DefaultFlattener.prototype.e = function (a, b, c, d) {
            var e = this.d(a, b, 0, c - 1, d);
            var f = new i2.List$1(i2.Point_$type, 0);
            for (var g = 0; g < e.count; g++) {
                f.add({ $type: i2.Point_$type, x: a[e._inner[g]], y: b[e._inner[g]] });
            }
            return f;
        };
        DefaultFlattener.prototype.f = function (a, b) {
            return a.item(b).x;
        };
        DefaultFlattener.prototype.g = function (a, b) {
            return a.item(b).y;
        };
        DefaultFlattener.$t = i2.markType(DefaultFlattener, 'DefaultFlattener', i2.Base.$, [IFlattener_$type]);
        return DefaultFlattener;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarLineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarLineSeriesBase, _super);
        function PolarLineSeriesBase() {
            var _this = _super.call(this) || this;
            _this.t4 = null;
            _this.t6 = null;
            _this.t5 = null;
            _this.t4 = new PathRenderer(1, new DefaultFlattener());
            _this.t6 = new PathRenderer(0);
            return _this;
        }
        PolarLineSeriesBase.prototype.get_r3 = function () {
            return true;
        };
        PolarLineSeriesBase.prototype.bu = function () {
            return new PolarLineSeriesBaseView(this);
        };
        PolarLineSeriesBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t7 = a;
        };
        PolarLineSeriesBase.prototype.t8 = function () {
            return 1;
        };
        PolarLineSeriesBase.prototype.get_ub = function () {
            return false;
        };
        Object.defineProperty(PolarLineSeriesBase.prototype, "ub", {
            get: function () {
                return this.get_ub();
            },
            enumerable: false,
            configurable: true
        });
        PolarLineSeriesBase.prototype.get_ud = function () {
            return false;
        };
        Object.defineProperty(PolarLineSeriesBase.prototype, "ud", {
            get: function () {
                return this.get_ud();
            },
            enumerable: false,
            configurable: true
        });
        PolarLineSeriesBase.prototype.s8 = function (a, b) {
            var _this = this;
            _super.prototype.s8.call(this, a, b);
            a.m.clear();
            var c = b.bv;
            var d = b.bu;
            var e = this.rt != null ? this.rt.count : 0;
            var f = this.ru != null ? this.ru.count : 0;
            var g = Math.min(e, f);
            var h = ((function () {
                var $ret = new PolarLinePlanner();
                $ret.m = function (i) { return _this.rb.a.getScaledAngle1(_this.rt.item(i), _this.rb.e, _this.rb.d); };
                $ret.q = g;
                $ret.n = function (i) { return _this.q9.mh(_this.ru.item(i), _this.rb.g, _this.rb.f, _this.rb.i, _this.rb.h); };
                $ret.l = _this.gh;
                $ret.f = _this.r8;
                $ret.b = _this.t8();
                $ret.o = function (i) { return _this.ue(a, i); };
                $ret.p = function (i) { return _this.uf(a, i); };
                $ret.ab = d;
                $ret.ac = c;
                $ret.d = _this.ud;
                $ret.c = _this.ub;
                return $ret;
            })());
            var i = new i2.List$1(i2.Number_$type, 0);
            for (var j = 0; j < g; j++) {
                if (this.uc(j)) {
                    i.add(j);
                }
            }
            if (this.ud && i.count > 0) {
                i.add(i._inner[0]);
            }
            h.x(a.m, i);
        };
        PolarLineSeriesBase.prototype.ue = function (a, b) {
            return a.w._inner[b].x;
        };
        PolarLineSeriesBase.prototype.uf = function (a, b) {
            return a.w._inner[b].y;
        };
        PolarLineSeriesBase.prototype.ua = function () {
            return !this.t9();
        };
        PolarLineSeriesBase.prototype.t9 = function () {
            var a = this.ca.pg;
            return !a.containsPoint({ $type: i2.Point_$type, x: 0.5, y: 0.5 });
        };
        PolarLineSeriesBase.prototype.uc = function (a) {
            return (this.rt.item(a) >= this.rb.a.kv && this.rt.item(a) <= this.rb.a.ku && this.ru.item(a) >= this.rb.b.kv && this.ru.item(a) <= this.rb.b.ku) || (i2.isNaN_(this.rt.item(a)) || i2.isNaN_(this.ru.item(a)));
        };
        PolarLineSeriesBase.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            this.ug(b);
        };
        PolarLineSeriesBase.prototype.tc = function (a, b) {
            _super.prototype.tc.call(this, a, b);
            if (this.r8) {
                this.t5 = this.t4;
            }
            else {
                this.t5 = this.t6;
            }
            this.t5.b = this.t8();
            this.ug(b);
            this.uh(a, b);
        };
        PolarLineSeriesBase.$t = i2.markType(PolarLineSeriesBase, 'PolarLineSeriesBase', PolarBase.$);
        return PolarLineSeriesBase;
    }(PolarBase));
    /**
     * @hidden
     */
    var PolarLineSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarLineSeriesBaseView, _super);
        function PolarLineSeriesBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.c3 = null;
            _this.c3 = a;
            return _this;
        }
        PolarLineSeriesBaseView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        PolarLineSeriesBaseView.$t = i2.markType(PolarLineSeriesBaseView, 'PolarLineSeriesBaseView', PolarBaseView.$);
        return PolarLineSeriesBaseView;
    }(PolarBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarAreaSeries, _super);
        function PolarAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = PolarAreaSeries.$;
            return _this;
        }
        PolarAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        PolarAreaSeries.prototype.bu = function () {
            return new PolarAreaSeriesView(this);
        };
        PolarAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ui = a;
        };
        PolarAreaSeries.prototype.ug = function (a) {
            var b = a;
            b.c5();
        };
        PolarAreaSeries.prototype.uh = function (a, b) {
            if (a.m.count > 0) {
                var c = a.m._inner[0];
                var d = a.m._inner[a.m.count - 1];
                var e = c.x == d.x && c.y == d.y;
                if (!e) {
                    a.m.add(a.m._inner[0]);
                }
            }
            var f = b;
            f.c6(a.m, this.gh);
            this.rk.ax(this, this.r7(), i2.runOn(this, this.qx));
            var g = false;
            var h = this.rk.b;
            if (h != null) {
                g = true;
            }
            if (g) {
                this.s7(-1, this.rt.count, b.q);
            }
            var i = f.dc;
            var j = f.db;
            this.rk.ad(i, true, false, true, true);
            this.rk.ad(j, false, true, false, false);
            j._opacity = this.rk.j * this.fi;
        };
        PolarAreaSeries.prototype.get_ud = function () {
            return true;
        };
        PolarAreaSeries.prototype.t8 = function () {
            return this.uj;
        };
        PolarAreaSeries.$t = i2.markType(PolarAreaSeries, 'PolarAreaSeries', PolarLineSeriesBase.$);
        PolarAreaSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PolarAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:uj:ul', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return PolarAreaSeries;
    }(PolarLineSeriesBase));
    /**
     * @hidden
     */
    var PolarAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarAreaSeriesView, _super);
        function PolarAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c4 = null;
            _this.da = new i2.Path();
            _this.c9 = new i2.Path();
            _this.c8 = new i2.Path();
            _this.c7 = new i2.Path();
            _this.c4 = a;
            return _this;
        }
        PolarAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c4.pr = Defaults.e;
            }
        };
        Object.defineProperty(PolarAreaSeriesView.prototype, "db", {
            get: function () {
                return this.c9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarAreaSeriesView.prototype, "dc", {
            get: function () {
                return this.da;
            },
            enumerable: false,
            configurable: true
        });
        PolarAreaSeriesView.prototype.c5 = function () {
            this.c9.ak = null;
            this.da.ak = null;
            this.c7.ak = null;
            this.c8.ak = null;
            this.aq();
        };
        PolarAreaSeriesView.prototype.c6 = function (a, b) {
            var c = new i2.List$1(i2.Point_$type, 1, a);
            this.c4.t5.d(this.da, c, b);
            this.c4.t5.d(this.c9, c, b);
            this.aq();
        };
        PolarAreaSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        PolarAreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.c8.ak = this.da.ak;
            this.c7.ak = this.c9.ak;
            this.c8._stroke = a;
            this.c8.ac = this.e.fl + 3;
            this.c7._fill = a;
            this.c7._opacity = 1;
        };
        PolarAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c7);
                    a.s(this.c8);
                }
                else {
                    a.s(this.c9);
                    a.s(this.da);
                }
            }
        };
        PolarAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.da, "polarShape", ["Main"]);
            this.e.a6.exportPathData(a, this.c9, "fillShape", ["Fill"]);
        };
        PolarAreaSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 5;
            this.e.gl = 5;
        };
        PolarAreaSeriesView.$t = i2.markType(PolarAreaSeriesView, 'PolarAreaSeriesView', PolarLineSeriesBaseView.$);
        return PolarAreaSeriesView;
    }(PolarLineSeriesBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent polar area series.
    */
    var IgxPolarAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarAreaSeriesComponent, _super);
        function IgxPolarAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxPolarAreaSeriesComponent.prototype.createImplementation = function () {
            return new PolarAreaSeries();
        };
        Object.defineProperty(IgxPolarAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarAreaSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarAreaSeriesComponent, selector: "igx-polar-area-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPolarAreaSeriesComponent;
    }(IgxPolarLineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-polar-area-series',
                        template: "",
                        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarAreaSeriesModule() {
        }
        IgxPolarAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesModule, declarations: [IgxPolarAreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxPolarAreaSeriesComponent] });
        IgxPolarAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxPolarAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPolarAreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxPolarAreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPolarAreaSeriesComponent", IgxPolarAreaSeriesComponent);
            i2.TypeRegistrar.register("PolarAreaSeries", PolarAreaSeries.$type);
        }
        IgxPolarAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxPolarAreaSeriesModule], exports: [IgxPolarAreaSeriesModule] });
        IgxPolarAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxPolarAreaSeriesModule], IgxPolarAreaSeriesModule] });
        return IgxPolarAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPolarAreaSeriesModule],
                        exports: [IgxPolarAreaSeriesModule],
                        entryComponents: [IgxPolarAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarLineSeries, _super);
        function PolarLineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = PolarLineSeries.$;
            return _this;
        }
        PolarLineSeries.prototype.get_dv = function () {
            return true;
        };
        PolarLineSeries.prototype.bu = function () {
            return new PolarLineSeriesView(this);
        };
        PolarLineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ui = a;
        };
        PolarLineSeries.prototype.ug = function (a) {
            var b = a;
            b.c5();
        };
        PolarLineSeries.prototype.uh = function (a, b) {
            var c = b;
            c.c6(a.m, this.gh);
            this.rk.ax(this, this.r7(), i2.runOn(this, this.qx));
            var d = false;
            var e = this.rk.b;
            if (e != null) {
                d = true;
            }
            if (d) {
                this.s7(-1, this.rt.count, b.q);
            }
            this.rk.ad(b.c8, true, false, true, false);
        };
        PolarLineSeries.prototype.t8 = function () {
            return this.uj;
        };
        PolarLineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case PolarLineSeries.$$p[0]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        PolarLineSeries.$t = i2.markType(PolarLineSeries, 'PolarLineSeries', PolarLineSeriesBase.$);
        PolarLineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PolarLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:uj:ul', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return PolarLineSeries;
    }(PolarLineSeriesBase));
    /**
     * @hidden
     */
    var PolarLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarLineSeriesView, _super);
        function PolarLineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c4 = null;
            _this.c8 = new i2.Path();
            _this.c7 = new i2.Path();
            _this.c4 = a;
            return _this;
        }
        PolarLineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
        };
        PolarLineSeriesView.prototype.c5 = function () {
            this.c8.ak = null;
            this.c7.ak = null;
            this.aq();
        };
        PolarLineSeriesView.prototype.c6 = function (a, b) {
            this.c4.t5.d(this.c8, a, b);
            this.aq();
        };
        PolarLineSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        PolarLineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.c7.ak = this.c8.ak;
            this.c7._stroke = a;
            this.c7.ac = this.e.fl + 3;
        };
        PolarLineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c7);
                }
                else {
                    a.s(this.c8);
                }
            }
        };
        PolarLineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.c8, "polarShape", ["Main"]);
        };
        PolarLineSeriesView.$t = i2.markType(PolarLineSeriesView, 'PolarLineSeriesView', PolarLineSeriesBaseView.$);
        return PolarLineSeriesView;
    }(PolarLineSeriesBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent polar line series.
    */
    var IgxPolarLineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarLineSeriesComponent, _super);
        function IgxPolarLineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxPolarLineSeriesComponent.prototype.createImplementation = function () {
            return new PolarLineSeries();
        };
        Object.defineProperty(IgxPolarLineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarLineSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarLineSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarLineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarLineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarLineSeriesComponent, selector: "igx-polar-line-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPolarLineSeriesComponent;
    }(IgxPolarLineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-polar-line-series',
                        template: "",
                        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarLineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarLineSeriesModule() {
        }
        IgxPolarLineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarLineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesModule, declarations: [IgxPolarLineSeriesComponent], imports: [i1.CommonModule], exports: [IgxPolarLineSeriesComponent] });
        IgxPolarLineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxPolarLineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPolarLineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxPolarLineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarLineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarLineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPolarLineSeriesComponent", IgxPolarLineSeriesComponent);
            i2.TypeRegistrar.register("PolarLineSeries", PolarLineSeries.$type);
        }
        IgxPolarLineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarLineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesDynamicModule, imports: [i1.CommonModule, IgxPolarLineSeriesModule], exports: [IgxPolarLineSeriesModule] });
        IgxPolarLineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesDynamicModule, imports: [[i1.CommonModule, IgxPolarLineSeriesModule], IgxPolarLineSeriesModule] });
        return IgxPolarLineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarLineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPolarLineSeriesModule],
                        exports: [IgxPolarLineSeriesModule],
                        entryComponents: [IgxPolarLineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarScatterSeries, _super);
        function PolarScatterSeries() {
            var _this = _super.call(this) || this;
            _this.ab = PolarScatterSeries.$;
            return _this;
        }
        PolarScatterSeries.prototype.get_c0 = function () {
            return true;
        };
        PolarScatterSeries.prototype.bu = function () {
            return new PolarScatterSeriesView(this);
        };
        PolarScatterSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t4 = a;
        };
        PolarScatterSeries.prototype.gi = function () {
            return 0.7;
        };
        PolarScatterSeries.prototype.pl = function () {
            if (this.pk == 0) {
                return 2;
            }
            return _super.prototype.pl.call(this);
        };
        PolarScatterSeries.$t = i2.markType(PolarScatterSeries, 'PolarScatterSeries', PolarBase.$);
        return PolarScatterSeries;
    }(PolarBase));
    /**
     * @hidden
     */
    var PolarScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarScatterSeriesView, _super);
        function PolarScatterSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c3 = null;
            _this.c3 = a;
            return _this;
        }
        PolarScatterSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c3.pr = Defaults.e;
            }
        };
        PolarScatterSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 2;
            this.e.gl = 2;
            this.e.e1 = false;
        };
        PolarScatterSeriesView.$t = i2.markType(PolarScatterSeriesView, 'PolarScatterSeriesView', PolarBaseView.$);
        return PolarScatterSeriesView;
    }(PolarBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent polar scatter series.
    */
    var IgxPolarScatterSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarScatterSeriesComponent, _super);
        function IgxPolarScatterSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxPolarScatterSeriesComponent.prototype.createImplementation = function () {
            return new PolarScatterSeries();
        };
        Object.defineProperty(IgxPolarScatterSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarScatterSeriesComponent.prototype, "hasOnlyMarkers", {
            /**
             * Gets whether the series has only marker as visuals
            */
            get: function () {
                return this.i.c0;
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarScatterSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarScatterSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarScatterSeriesComponent, selector: "igx-polar-scatter-series", providers: [{ provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPolarScatterSeriesComponent;
    }(IgxPolarBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-polar-scatter-series',
                        template: "",
                        providers: [{ provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarScatterSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarScatterSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarScatterSeriesModule() {
        }
        IgxPolarScatterSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarScatterSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesModule, declarations: [IgxPolarScatterSeriesComponent], imports: [i1.CommonModule], exports: [IgxPolarScatterSeriesComponent] });
        IgxPolarScatterSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesModule, imports: [[i1.CommonModule]] });
        return IgxPolarScatterSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPolarScatterSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxPolarScatterSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarScatterSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarScatterSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPolarScatterSeriesComponent", IgxPolarScatterSeriesComponent);
            i2.TypeRegistrar.register("PolarScatterSeries", PolarScatterSeries.$type);
        }
        IgxPolarScatterSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarScatterSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesDynamicModule, imports: [i1.CommonModule, IgxPolarScatterSeriesModule], exports: [IgxPolarScatterSeriesModule] });
        IgxPolarScatterSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesDynamicModule, imports: [[i1.CommonModule, IgxPolarScatterSeriesModule], IgxPolarScatterSeriesModule] });
        return IgxPolarScatterSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarScatterSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPolarScatterSeriesModule],
                        exports: [IgxPolarScatterSeriesModule],
                        entryComponents: [IgxPolarScatterSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarSplineSeries, _super);
        function PolarSplineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = PolarSplineSeries.$;
            return _this;
        }
        PolarSplineSeries.prototype.get_ea = function () {
            return true;
        };
        PolarSplineSeries.prototype.bu = function () {
            return new PolarSplineSeriesView(this);
        };
        PolarSplineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ui = a;
        };
        PolarSplineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case PolarSplineSeries.$$p[0]:
                    this.l0(false);
                    break;
            }
        };
        PolarSplineSeries.prototype.ug = function (a) {
            var b = a;
            b.c5();
        };
        PolarSplineSeries.prototype.uh = function (a, b) {
            this.ug(b);
            var c = b;
            c.c6(a.m, this.uj);
            this.rk.ax(this, this.r7(), i2.runOn(this, this.qx));
            var d = false;
            var e = this.rk.b;
            if (e != null) {
                d = true;
            }
            if (d) {
                this.s7(-1, this.rt.count, b.q);
            }
            this.rk.ad(b.c8, true, false, true, false);
        };
        PolarSplineSeries.$t = i2.markType(PolarSplineSeries, 'PolarSplineSeries', PolarLineSeriesBase.$);
        PolarSplineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PolarSplineSeries, 'raisePropertyChanged', ['Stiffness:uj:ul', [1, 0.5]]);
        return PolarSplineSeries;
    }(PolarLineSeriesBase));
    /**
     * @hidden
     */
    var PolarSplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarSplineSeriesView, _super);
        function PolarSplineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c4 = null;
            _this.c8 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.c7 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.c4 = a;
            return _this;
        }
        PolarSplineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
            var a = new i2.PathGeometry();
            a.c.add(((function () {
                var $ret = new i2.PathFigure();
                return $ret;
            })()));
            this.c8.ak = a;
        };
        PolarSplineSeriesView.prototype.c5 = function () {
            i2.Extensions.e(this.c8.ak);
            i2.Extensions.e(this.c7.ak);
            this.aq();
        };
        PolarSplineSeriesView.prototype.c6 = function (a, b) {
            this.c8.ak.c = i2.Numeric.h(a.count, function (c) { return a._inner[c].x; }, function (c) { return a._inner[c].y; }, b);
            this.aq();
        };
        PolarSplineSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        PolarSplineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.c7.ak = this.c8.ak;
            this.c7._stroke = a;
            this.c7.ac = this.e.fl + 3;
        };
        PolarSplineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c7);
                }
                else {
                    a.s(this.c8);
                }
            }
        };
        PolarSplineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.c8, "polarShape", ["Main"]);
        };
        PolarSplineSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        PolarSplineSeriesView.$t = i2.markType(PolarSplineSeriesView, 'PolarSplineSeriesView', PolarLineSeriesBaseView.$);
        return PolarSplineSeriesView;
    }(PolarLineSeriesBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent polar spline series.
    */
    var IgxPolarSplineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarSplineSeriesComponent, _super);
        function IgxPolarSplineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxPolarSplineSeriesComponent.prototype.createImplementation = function () {
            return new PolarSplineSeries();
        };
        Object.defineProperty(IgxPolarSplineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarSplineSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarSplineSeriesComponent.prototype, "stiffness", {
            /**
             * Gets or sets the Stiffness property.
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarSplineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarSplineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarSplineSeriesComponent, selector: "igx-polar-spline-series", inputs: { stiffness: "stiffness" }, providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPolarSplineSeriesComponent;
    }(IgxPolarLineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-polar-spline-series',
                        template: "",
                        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { stiffness: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarSplineSeriesModule() {
        }
        IgxPolarSplineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarSplineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesModule, declarations: [IgxPolarSplineSeriesComponent], imports: [i1.CommonModule], exports: [IgxPolarSplineSeriesComponent] });
        IgxPolarSplineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxPolarSplineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPolarSplineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxPolarSplineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarSplineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarSplineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPolarSplineSeriesComponent", IgxPolarSplineSeriesComponent);
            i2.TypeRegistrar.register("PolarSplineSeries", PolarSplineSeries.$type);
        }
        IgxPolarSplineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarSplineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesDynamicModule, imports: [i1.CommonModule, IgxPolarSplineSeriesModule], exports: [IgxPolarSplineSeriesModule] });
        IgxPolarSplineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesDynamicModule, imports: [[i1.CommonModule, IgxPolarSplineSeriesModule], IgxPolarSplineSeriesModule] });
        return IgxPolarSplineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPolarSplineSeriesModule],
                        exports: [IgxPolarSplineSeriesModule],
                        entryComponents: [IgxPolarSplineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolarSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarSplineAreaSeries, _super);
        function PolarSplineAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = PolarSplineAreaSeries.$;
            return _this;
        }
        PolarSplineAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        PolarSplineAreaSeries.prototype.get_ea = function () {
            return true;
        };
        PolarSplineAreaSeries.prototype.bu = function () {
            return new PolarSplineAreaSeriesView(this);
        };
        PolarSplineAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.ui = a;
        };
        PolarSplineAreaSeries.prototype.ug = function (a) {
            var b = a;
            b.c5();
        };
        PolarSplineAreaSeries.prototype.uh = function (a, b) {
            this.ug(b);
            if (a.m.count < 1) {
                return;
            }
            var c = b;
            c.c6(a.m, this.uj);
            this.rk.ax(this, this.r7(), i2.runOn(this, this.qx));
            var d = false;
            var e = this.rk.b;
            if (e != null) {
                d = true;
            }
            if (d) {
                this.s7(-1, this.rt.count, b.q);
            }
            var f = c.dc;
            var g = c.db;
            this.rk.ad(f, true, false, true, true);
            this.rk.ad(g, false, true, false, false);
            g._opacity = this.rk.j * this.fi;
        };
        PolarSplineAreaSeries.prototype.get_ud = function () {
            return true;
        };
        PolarSplineAreaSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case PolarSplineAreaSeries.$$p[0]:
                    this.l0(false);
                    break;
            }
        };
        PolarSplineAreaSeries.$t = i2.markType(PolarSplineAreaSeries, 'PolarSplineAreaSeries', PolarLineSeriesBase.$);
        PolarSplineAreaSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, PolarSplineAreaSeries, 'raisePropertyChanged', ['Stiffness:uj:ul', [1, 0.5]]);
        return PolarSplineAreaSeries;
    }(PolarLineSeriesBase));
    /**
     * @hidden
     */
    var PolarSplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolarSplineAreaSeriesView, _super);
        function PolarSplineAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c4 = null;
            _this.da = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.c9 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.c8 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.c7 = ((function () {
                var $ret = new i2.Path();
                $ret.ak = new i2.PathGeometry();
                return $ret;
            })());
            _this.c4 = a;
            return _this;
        }
        PolarSplineAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c4.pr = Defaults.e;
            }
        };
        Object.defineProperty(PolarSplineAreaSeriesView.prototype, "db", {
            get: function () {
                return this.c9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PolarSplineAreaSeriesView.prototype, "dc", {
            get: function () {
                return this.da;
            },
            enumerable: false,
            configurable: true
        });
        PolarSplineAreaSeriesView.prototype.c5 = function () {
            i2.Extensions.e(this.c9.ak);
            i2.Extensions.e(this.da.ak);
            i2.Extensions.e(this.c7.ak);
            i2.Extensions.e(this.c8.ak);
            this.aq();
        };
        PolarSplineAreaSeriesView.prototype.c6 = function (a, b) {
            this.da.ak.c = i2.Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
            this.c9.ak.c = i2.Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
            this.aq();
        };
        PolarSplineAreaSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        PolarSplineAreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.c7.ak = this.c9.ak;
            this.c8.ak = this.da.ak;
            this.c7._fill = a;
            this.c7._opacity = 1;
            this.c8._stroke = a;
            this.c8.ac = this.e.fl + 3;
        };
        PolarSplineAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c7);
                    a.s(this.c8);
                }
                else {
                    a.s(this.c9);
                    a.s(this.da);
                }
            }
        };
        PolarSplineAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.da, "polarShape", ["Main"]);
            this.e.a6.exportPathData(a, this.c9, "fillShape", ["Fill"]);
        };
        PolarSplineAreaSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 5;
            this.e.gl = 5;
        };
        PolarSplineAreaSeriesView.$t = i2.markType(PolarSplineAreaSeriesView, 'PolarSplineAreaSeriesView', PolarLineSeriesBaseView.$);
        return PolarSplineAreaSeriesView;
    }(PolarLineSeriesBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent polar spline area series.
    */
    var IgxPolarSplineAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPolarSplineAreaSeriesComponent, _super);
        function IgxPolarSplineAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxPolarSplineAreaSeriesComponent.prototype.createImplementation = function () {
            return new PolarSplineAreaSeries();
        };
        Object.defineProperty(IgxPolarSplineAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarSplineAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarSplineAreaSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPolarSplineAreaSeriesComponent.prototype, "stiffness", {
            /**
             * Gets or sets the Stiffness property.
            */
            get: function () {
                return this.i.uj;
            },
            set: function (v) {
                this.i.uj = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPolarSplineAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPolarSplineAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPolarSplineAreaSeriesComponent, selector: "igx-polar-spline-area-series", inputs: { stiffness: "stiffness" }, providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPolarSplineAreaSeriesComponent;
    }(IgxPolarLineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-polar-spline-area-series',
                        template: "",
                        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxPolarSplineAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { stiffness: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarSplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarSplineAreaSeriesModule() {
        }
        IgxPolarSplineAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarSplineAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesModule, declarations: [IgxPolarSplineAreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxPolarSplineAreaSeriesComponent] });
        IgxPolarSplineAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxPolarSplineAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPolarSplineAreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxPolarSplineAreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPolarSplineAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPolarSplineAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxPolarSplineAreaSeriesComponent", IgxPolarSplineAreaSeriesComponent);
            i2.TypeRegistrar.register("PolarSplineAreaSeries", PolarSplineAreaSeries.$type);
        }
        IgxPolarSplineAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPolarSplineAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxPolarSplineAreaSeriesModule], exports: [IgxPolarSplineAreaSeriesModule] });
        IgxPolarSplineAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxPolarSplineAreaSeriesModule], IgxPolarSplineAreaSeriesModule] });
        return IgxPolarSplineAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPolarSplineAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxPolarSplineAreaSeriesModule],
                        exports: [IgxPolarSplineAreaSeriesModule],
                        entryComponents: [IgxPolarSplineAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartPolarModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartPolarModule() {
        }
        IgxDataChartPolarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartPolarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarModule, imports: [i1.CommonModule, IgxPolarAreaSeriesModule,
                IgxPolarLineSeriesModule,
                IgxPolarScatterSeriesModule,
                IgxPolarSplineSeriesModule,
                IgxPolarSplineAreaSeriesModule,
                IgxDataChartPolarCoreModule], exports: [IgxPolarAreaSeriesModule,
                IgxPolarLineSeriesModule,
                IgxPolarScatterSeriesModule,
                IgxPolarSplineSeriesModule,
                IgxPolarSplineAreaSeriesModule,
                IgxDataChartPolarCoreModule] });
        IgxDataChartPolarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarModule, imports: [[i1.CommonModule, IgxPolarAreaSeriesModule,
                    IgxPolarLineSeriesModule,
                    IgxPolarScatterSeriesModule,
                    IgxPolarSplineSeriesModule,
                    IgxPolarSplineAreaSeriesModule,
                    IgxDataChartPolarCoreModule
                ], IgxPolarAreaSeriesModule,
                IgxPolarLineSeriesModule,
                IgxPolarScatterSeriesModule,
                IgxPolarSplineSeriesModule,
                IgxPolarSplineAreaSeriesModule,
                IgxDataChartPolarCoreModule] });
        return IgxDataChartPolarModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxPolarAreaSeriesModule,
                            IgxPolarLineSeriesModule,
                            IgxPolarScatterSeriesModule,
                            IgxPolarSplineSeriesModule,
                            IgxPolarSplineAreaSeriesModule,
                            IgxDataChartPolarCoreModule
                        ],
                        imports: [i1.CommonModule, IgxPolarAreaSeriesModule,
                            IgxPolarLineSeriesModule,
                            IgxPolarScatterSeriesModule,
                            IgxPolarSplineSeriesModule,
                            IgxPolarSplineAreaSeriesModule,
                            IgxDataChartPolarCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartPolarDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartPolarDynamicModule() {
        }
        IgxDataChartPolarDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartPolarDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarDynamicModule, imports: [i1.CommonModule, IgxPolarAreaSeriesDynamicModule,
                IgxPolarLineSeriesDynamicModule,
                IgxPolarScatterSeriesDynamicModule,
                IgxPolarSplineSeriesDynamicModule,
                IgxPolarSplineAreaSeriesDynamicModule,
                IgxDataChartPolarCoreDynamicModule,
                IgxDataChartPolarModule], exports: [IgxPolarAreaSeriesDynamicModule,
                IgxPolarLineSeriesDynamicModule,
                IgxPolarScatterSeriesDynamicModule,
                IgxPolarSplineSeriesDynamicModule,
                IgxPolarSplineAreaSeriesDynamicModule,
                IgxDataChartPolarCoreDynamicModule,
                IgxDataChartPolarModule] });
        IgxDataChartPolarDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarDynamicModule, imports: [[i1.CommonModule, IgxPolarAreaSeriesDynamicModule,
                    IgxPolarLineSeriesDynamicModule,
                    IgxPolarScatterSeriesDynamicModule,
                    IgxPolarSplineSeriesDynamicModule,
                    IgxPolarSplineAreaSeriesDynamicModule,
                    IgxDataChartPolarCoreDynamicModule,
                    IgxDataChartPolarModule
                ], IgxPolarAreaSeriesDynamicModule,
                IgxPolarLineSeriesDynamicModule,
                IgxPolarScatterSeriesDynamicModule,
                IgxPolarSplineSeriesDynamicModule,
                IgxPolarSplineAreaSeriesDynamicModule,
                IgxDataChartPolarCoreDynamicModule,
                IgxDataChartPolarModule] });
        return IgxDataChartPolarDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartPolarDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxPolarAreaSeriesDynamicModule,
                            IgxPolarLineSeriesDynamicModule,
                            IgxPolarScatterSeriesDynamicModule,
                            IgxPolarSplineSeriesDynamicModule,
                            IgxPolarSplineAreaSeriesDynamicModule,
                            IgxDataChartPolarCoreDynamicModule,
                            IgxDataChartPolarModule
                        ],
                        imports: [i1.CommonModule, IgxPolarAreaSeriesDynamicModule,
                            IgxPolarLineSeriesDynamicModule,
                            IgxPolarScatterSeriesDynamicModule,
                            IgxPolarSplineSeriesDynamicModule,
                            IgxPolarSplineAreaSeriesDynamicModule,
                            IgxDataChartPolarCoreDynamicModule,
                            IgxDataChartPolarModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartRadialCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartRadialCoreModule() {
        }
        IgxDataChartRadialCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartRadialCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreModule, imports: [i1.CommonModule, IgxCategoryAngleAxisModule,
                IgxNumericRadiusAxisModule,
                IgxDataChartCoreModule], exports: [IgxCategoryAngleAxisModule,
                IgxNumericRadiusAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartRadialCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreModule, imports: [[i1.CommonModule, IgxCategoryAngleAxisModule,
                    IgxNumericRadiusAxisModule,
                    IgxDataChartCoreModule
                ], IgxCategoryAngleAxisModule,
                IgxNumericRadiusAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartRadialCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryAngleAxisModule,
                            IgxNumericRadiusAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryAngleAxisModule,
                            IgxNumericRadiusAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartRadialCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartRadialCoreDynamicModule() {
        }
        IgxDataChartRadialCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartRadialCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreDynamicModule, imports: [i1.CommonModule, IgxCategoryAngleAxisDynamicModule,
                IgxNumericRadiusAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartRadialCoreModule], exports: [IgxCategoryAngleAxisDynamicModule,
                IgxNumericRadiusAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartRadialCoreModule] });
        IgxDataChartRadialCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreDynamicModule, imports: [[i1.CommonModule, IgxCategoryAngleAxisDynamicModule,
                    IgxNumericRadiusAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartRadialCoreModule
                ], IgxCategoryAngleAxisDynamicModule,
                IgxNumericRadiusAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartRadialCoreModule] });
        return IgxDataChartRadialCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryAngleAxisDynamicModule,
                            IgxNumericRadiusAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartRadialCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryAngleAxisDynamicModule,
                            IgxNumericRadiusAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartRadialCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningRadialStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningRadialStyleEventArgs, _super);
        function AssigningRadialStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningRadialStyleEventArgs.$t = i2.markType(AssigningRadialStyleEventArgs, 'AssigningRadialStyleEventArgs', AssigningSeriesShapeStyleEventArgsBase.$);
        return AssigningRadialStyleEventArgs;
    }(AssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningRadialStyleEvent
    */
    var IgxAssigningRadialStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningRadialStyleEventArgs, _super);
        function IgxAssigningRadialStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningRadialStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningRadialStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningRadialStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningRadialStyleEventArgs;
    }(IgxAssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
    */
    var IgxAssigningRadialStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningRadialStyleEventArgsBase, _super);
        function IgxAssigningRadialStyleEventArgsBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAssigningRadialStyleEventArgsBase.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningRadialStyleEventArgsBase;
    }(IgxAssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningRadialStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningRadialStyleEventArgsBase, _super);
        function AssigningRadialStyleEventArgsBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningRadialStyleEventArgsBase.$t = i2.markType(AssigningRadialStyleEventArgsBase, 'AssigningRadialStyleEventArgsBase', AssigningSeriesStyleEventArgsBase.$);
        return AssigningRadialStyleEventArgsBase;
    }(AssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningRadialMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningRadialMarkerStyleEventArgs, _super);
        function AssigningRadialMarkerStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningRadialMarkerStyleEventArgs.$t = i2.markType(AssigningRadialMarkerStyleEventArgs, 'AssigningRadialMarkerStyleEventArgs', AssigningRadialStyleEventArgsBase.$);
        return AssigningRadialMarkerStyleEventArgs;
    }(AssigningRadialStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningRadialStyleEvent
    */
    var IgxAssigningRadialMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningRadialMarkerStyleEventArgs, _super);
        function IgxAssigningRadialMarkerStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningRadialMarkerStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningRadialMarkerStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningRadialMarkerStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningRadialMarkerStyleEventArgs;
    }(IgxAssigningRadialStyleEventArgsBase));

    /**
     * Represents the base class for all IgxDataChartComponent radial series
    */
    var IgxRadialBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRadialBaseComponent, _super);
        function IgxRadialBaseComponent() {
            var _this = _super.call(this) || this;
            _this._assigningRadialStyle = null;
            _this._assigningRadialMarkerStyle = null;
            return _this;
        }
        Object.defineProperty(IgxRadialBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "isRadial", {
            /**
             * Checks if this series is a radial series
            */
            get: function () {
                return this.i.d4;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "isCustomRadialStyleAllowed", {
            /**
             * Gets or sets whether this Radial series should allow custom style overrides of its individual visuals.
            */
            get: function () {
                return this.i.rl;
            },
            set: function (v) {
                this.i.rl = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "isCustomRadialMarkerStyleAllowed", {
            /**
             * Gets or sets whether this Radial series should allow custom style overrides of its individual marker visuals.
            */
            get: function () {
                return this.i.rk;
            },
            set: function (v) {
                this.i.rk = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "angleAxis", {
            /**
             * Gets the effective angle axis for the current series object.
            */
            get: function () {
                if (this.i.qz == null) {
                    return null;
                }
                if (!this.i.qz.externalObject) {
                    var e = IgxCategoryAngleAxisComponent._createFromInternal(this.i.qz);
                    if (e) {
                        e._implementation = this.i.qz;
                    }
                    this.i.qz.externalObject = e;
                }
                return this.i.qz.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.qz = null : this.i.qz = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "valueAxis", {
            /**
             * Gets the effective value axis for the current series object.
            */
            get: function () {
                if (this.i.q6 == null) {
                    return null;
                }
                if (!this.i.q6.externalObject) {
                    var e = IgxNumericRadiusAxisComponent._createFromInternal(this.i.q6);
                    if (e) {
                        e._implementation = this.i.q6;
                    }
                    this.i.q6.externalObject = e;
                }
                return this.i.q6.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q6 = null : this.i.q6 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "clipSeriesToBounds", {
            /**
             * Gets or sets whether to clip the series to the bounds.
             * Setting this property to true will decrease chart performance.
            */
            get: function () {
                return this.i.rj;
            },
            set: function (v) {
                this.i.rj = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxRadialBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.angleAxis && this.angleAxis.name && this.angleAxis.name == name) {
                return this.angleAxis;
            }
            if (this.valueAxis && this.valueAxis.name && this.valueAxis.name == name) {
                return this.valueAxis;
            }
            return null;
        };
        IgxRadialBaseComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.angleAxis && this.angleAxis._styling) {
                this.angleAxis._styling(container, component, this);
            }
            if (this.valueAxis && this.valueAxis._styling) {
                this.valueAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Determine if object can be used as ValueAxis
        
        * @param axis  * The object to check
        */
        IgxRadialBaseComponent.prototype.canUseAsValueAxis = function (axis) {
            var iv = this.i.ri(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as AngleAxis
        
        * @param axis  * The object to check
        */
        IgxRadialBaseComponent.prototype.canUseAsAngleAxis = function (axis) {
            var iv = this.i.rh(axis);
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxRadialBaseComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the angle to the provided world position from the center of the radial series.
        
        * @param world  * The world position to get the angle for
        */
        IgxRadialBaseComponent.prototype.getAngleFromWorld = function (world) {
            var iv = this.i.rq(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
        IgxRadialBaseComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        /**
         * Get the index of the item near the provided world coordinates.
        
        * @param world  * The world coordinates for which to getch the item index.
        */
        IgxRadialBaseComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Scrolls the specified item into the view.
        
        * @param item  * The item to scroll into view.
        */
        IgxRadialBaseComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
        IgxRadialBaseComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        */
        IgxRadialBaseComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        Object.defineProperty(IgxRadialBaseComponent.prototype, "assigningRadialStyle", {
            /**
             * Event raised when Assigning Category Style
            */
            get: function () {
                var _this = this;
                if (this._assigningRadialStyle == null) {
                    this._assigningRadialStyle = new i0.EventEmitter();
                    this.i.assigningRadialStyle = i2.delegateCombine(this.i.assigningRadialStyle, function (o, e) {
                        var outerArgs = new IgxAssigningRadialStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningRadialStyle) {
                            _this.beforeAssigningRadialStyle(_this, outerArgs);
                        }
                        _this._assigningRadialStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningRadialStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialBaseComponent.prototype, "assigningRadialMarkerStyle", {
            /**
             * Event raised when Assigning Radial Marker Style
            */
            get: function () {
                var _this = this;
                if (this._assigningRadialMarkerStyle == null) {
                    this._assigningRadialMarkerStyle = new i0.EventEmitter();
                    this.i.assigningRadialMarkerStyle = i2.delegateCombine(this.i.assigningRadialMarkerStyle, function (o, e) {
                        var outerArgs = new IgxAssigningRadialMarkerStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningRadialMarkerStyle) {
                            _this.beforeAssigningRadialMarkerStyle(_this, outerArgs);
                        }
                        _this._assigningRadialMarkerStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningRadialMarkerStyle;
            },
            enumerable: false,
            configurable: true
        });
        IgxRadialBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRadialBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRadialBaseComponent, selector: "ng-component", inputs: { isCustomRadialStyleAllowed: "isCustomRadialStyleAllowed", isCustomRadialMarkerStyleAllowed: "isCustomRadialMarkerStyleAllowed", angleAxis: "angleAxis", valueAxis: "valueAxis", clipSeriesToBounds: "clipSeriesToBounds" }, outputs: { assigningRadialStyle: "assigningRadialStyle", assigningRadialMarkerStyle: "assigningRadialMarkerStyle" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxRadialBaseComponent;
    }(IgxMarkerSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { isCustomRadialStyleAllowed: [{
                    type: i0.Input
                }], isCustomRadialMarkerStyleAllowed: [{
                    type: i0.Input
                }], angleAxis: [{
                    type: i0.Input
                }], valueAxis: [{
                    type: i0.Input
                }], clipSeriesToBounds: [{
                    type: i0.Input
                }], assigningRadialStyle: [{
                    type: i0.Output
                }], assigningRadialMarkerStyle: [{
                    type: i0.Output
                }] } });

    /**
     * Represents the base class for all IgxDataChartComponent anchored radial category series.
    */
    var IgxAnchoredRadialSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAnchoredRadialSeriesComponent, _super);
        function IgxAnchoredRadialSeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "valueMemberPath", {
            /**
             * Gets or sets the item path that provides the values for the current series.
            */
            get: function () {
                return this.i.su;
            },
            set: function (v) {
                this.i.su = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the trend type for the current series object.
            */
            get: function () {
                return this.i.sg;
            },
            set: function (v) {
                this.i.sg = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the brush that specifies how to the current series
             * object's Trend line is drawn.
            */
            get: function () {
                return i2.brushToString(this.i.tb);
            },
            set: function (v) {
                this.i.tb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "actualTrendLineBrush", {
            /**
             * Gets the effective TrendLineBrush for this series.
            */
            get: function () {
                return i2.brushToString(this.i.ta);
            },
            set: function (v) {
                this.i.ta = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the current series object's trend line.
            */
            get: function () {
                return this.i.sq;
            },
            set: function (v) {
                this.i.sq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the trend line period for the current series.
             * The typical, and initial, value for bollinger band periods is 20.
            */
            get: function () {
                return this.i.sr;
            },
            set: function (v) {
                this.i.sr = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAnchoredRadialSeriesComponent.prototype, "trendLineZIndex", {
            /**
             * Sets or Gets the Z index of the trendline.
            */
            get: function () {
                return this.i.ss;
            },
            set: function (v) {
                this.i.ss = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxAnchoredRadialSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        IgxAnchoredRadialSeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxAnchoredRadialSeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxAnchoredRadialSeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxAnchoredRadialSeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
        IgxAnchoredRadialSeriesComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        */
        IgxAnchoredRadialSeriesComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        /**
         * Scrolls the specified item into the view.
        
        * @param item  * The item to scroll into view.
        */
        IgxAnchoredRadialSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        IgxAnchoredRadialSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnchoredRadialSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAnchoredRadialSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAnchoredRadialSeriesComponent, selector: "ng-component", inputs: { valueMemberPath: "valueMemberPath", trendLineType: "trendLineType", trendLineBrush: "trendLineBrush", actualTrendLineBrush: "actualTrendLineBrush", trendLineThickness: "trendLineThickness", trendLinePeriod: "trendLinePeriod", trendLineZIndex: "trendLineZIndex" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxAnchoredRadialSeriesComponent;
    }(IgxRadialBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAnchoredRadialSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { valueMemberPath: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], actualTrendLineBrush: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], trendLineZIndex: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialFrame, _super);
        function RadialFrame(a) {
            return _super.call(this, a) || this;
        }
        RadialFrame.$t = i2.markType(RadialFrame, 'RadialFrame', CategoryFrame.$);
        return RadialFrame;
    }(CategoryFrame));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialSeriesRenderManager, _super);
        function RadialSeriesRenderManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.ax = 0;
            _this.ay = 0;
            _this.av = null;
            _this.aw = null;
            return _this;
        }
        RadialSeriesRenderManager.prototype.c = function () {
            this.av = new AssigningRadialMarkerStyleEventArgs();
            return this.av;
        };
        RadialSeriesRenderManager.prototype.a = function () {
            this.aw = new AssigningRadialStyleEventArgs();
            return this.aw;
        };
        RadialSeriesRenderManager.prototype.az = function (a, b, c, d, e) {
            this.ax = d;
            this.ay = e;
            this.w(a, b, c);
        };
        RadialSeriesRenderManager.prototype.a0 = function (a, b, c, d, e) {
            this.ax = d;
            this.ay = e;
            this.x(a, b, c);
        };
        RadialSeriesRenderManager.prototype.au = function (a, b) {
            var c = this.ax;
            var d = Math.min(b * c, a - 1);
            var e = Math.min(d + c - 1, a - 1);
            var f = new Array(2);
            f[0] = Math.min(d + this.ay * c, a - 1);
            f[1] = Math.min(e + this.ay * c, a - 1);
            return f;
        };
        RadialSeriesRenderManager.prototype.a1 = function (a, b, c, d, e, f, g, h, i) {
            if (d == -1) {
                {
                    a.c = false;
                    a.o = 0;
                    a.n = e - 1;
                }
            }
            else {
                {
                    if (i) {
                        a.o = d;
                        a.n = d;
                    }
                    else {
                        var j = this.au(e, d);
                        a.c = false;
                        a.o = j[0];
                        a.n = j[1];
                    }
                }
            }
        };
        RadialSeriesRenderManager.$t = i2.markType(RadialSeriesRenderManager, 'RadialSeriesRenderManager', SeriesRenderManager.$);
        return RadialSeriesRenderManager;
    }(SeriesRenderManager));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialBucketCalculator, _super);
        function RadialBucketCalculator(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.c = 0;
            _this.d = 0;
            _this.b = 0;
            _this.a = a;
            return _this;
        }
        RadialBucketCalculator.prototype.getBucket = function (a) {
            throw new i2.NotImplementedException(0);
        };
        RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            return this.getBucket(a);
        };
        RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
            return NaN;
        };
        RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
            a = this.c;
            b = this.d;
            c = this.b;
            d = this.a.cr.gh;
            return {
                p0: a,
                p1: b,
                p2: c,
                p3: d
            };
        };
        RadialBucketCalculator.prototype.e = function (a) {
            var b = this.a.bv;
            var c = this.a.bu;
            var d = this.a.cr.qz;
            if (b.isEmpty || c.isEmpty || d == null || this.a.cr.ch == null || this.a.cr.ch.count == 0) {
                this.b = 0;
                return;
            }
            var e = Math.floor(d.l4(c, b));
            var f = Math.ceil(d.l3(c, b));
            if (d.cc) {
                f = Math.ceil(d.l4(c, b));
                e = Math.floor(d.l3(c, b));
            }
            if (f < e) {
                f = d.kq + f;
            }
            var g = this.a.cr.q6;
            var h = g != null ? g.ma : 0.75;
            var i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
            var j = Math.floor((f - e + 1) * a / i);
            this.b = i2.truncate(Math.max(1, j));
            this.c = i2.truncate(Math.max(0, Math.floor(e / this.b) - 1));
            this.d = i2.truncate(Math.ceil(f / this.b));
        };
        RadialBucketCalculator.prototype.cacheValues = function () {
        };
        RadialBucketCalculator.prototype.unCacheValues = function () {
        };
        RadialBucketCalculator.$t = i2.markType(RadialBucketCalculator, 'RadialBucketCalculator', i2.Base.$, [IBucketizer_$type]);
        return RadialBucketCalculator;
    }(i2.Base));
    /**
     * @hidden
     */
    var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialBase, _super);
        function RadialBase() {
            var _this = _super.call(this) || this;
            _this.rd = null;
            _this.re = null;
            _this.rg = false;
            _this.rf = false;
            _this.q4 = null;
            _this.q5 = null;
            _this.assigningRadialStyle = null;
            _this.assigningRadialMarkerStyle = null;
            _this.rb = new RadialFrame(3);
            _this.rc = new RadialFrame(3);
            _this.q9 = new RadialFrame(3);
            _this.q7 = null;
            _this.rd = new RadialSeriesRenderManager();
            _this.re = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, i2.runOn(_this, _this.r1), i2.runOn(_this, _this.r4), i2.runOn(_this, _this.cr), i2.runOn(_this, _this.l8), i2.runOn(_this, _this.r0), function (a) { return _this.q8.cs.e(_this.gh); });
            return _this;
        }
        RadialBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.q8 = a;
        };
        RadialBase.prototype.r0 = function () {
            if (this.cb.g) {
                this.cb.t();
            }
        };
        Object.defineProperty(RadialBase.prototype, "categoryAxis", {
            get: function () {
                return this.qz;
            },
            enumerable: false,
            configurable: true
        });
        RadialBase.prototype.ar = function () {
            return this.qz;
        };
        RadialBase.prototype.qw = function (a, b) {
            return null;
        };
        RadialBase.prototype.cx = function (a, b, c) {
            var _this = this;
            if (!this.hasMarkers) {
                return false;
            }
            var d = this.qz;
            var e = new ScalerParams(1, this.ca.pg, this.pf, d.cc);
            e.c = this.getEffectiveViewport1(this.bx);
            var f = this.q6;
            var g = new ScalerParams(1, this.ca.pg, this.pf, f.cc);
            g.c = this.getEffectiveViewport1(this.bx);
            a.clear();
            this.pq.cf(function (h) {
                if (h._visibility == 0) {
                    var i = new SeriesPointOfInterest();
                    var j = h.n;
                    var k = h.o;
                    if (j < _this.pf.left || j > _this.pf.right || k < _this.pf.top || k > _this.pf.bottom) {
                        return;
                    }
                    var l = void 0;
                    var m = void 0;
                    var n = _this.q7.g(j, k, _this.bx.bv, _this.bx.bu, l, m);
                    l = n.p4;
                    m = n.p5;
                    i.b = l;
                    i.c = m;
                    if (b) {
                        i.d = _this.rv(i.c, c);
                    }
                    else {
                        i.d = d.fw(h.ak);
                    }
                    i.a = h.content;
                    a.add(i);
                }
            });
            return true;
        };
        RadialBase.prototype.rv = function (a, b) {
            if (b >= 0) {
                return i2.round10N(a, b).toString();
            }
            else {
                return a.toString();
            }
        };
        RadialBase.prototype.get_d4 = function () {
            return true;
        };
        RadialBase.prototype.get_dr = function () {
            return true;
        };
        RadialBase.prototype.q1 = function (a, b, c) {
            var d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        };
        RadialBase.prototype.q2 = function (a, b, c) {
            var d = this.q8.cs.c;
            var e = this.q8.cs.d;
            var f = this.q8.cs.b;
            var g = this.ra();
            var h = this.ch.count;
            var i = this.qz;
            var j = -1;
            var k = -1;
            var l = this.g0(b);
            j = i2.truncate(Math.floor((i2.intDivide(l, f)))) * f;
            k = j + (f - 1);
            if (c != null && c.h == j && c.g == k) {
                return c;
            }
            var m = new HighlightingInfo();
            m.b = this;
            m.h = j;
            m.g = k;
            return m;
        };
        RadialBase.prototype.q3 = function (a, b, c) {
            var d = this.q8.cs.c;
            var e = this.q8.cs.d;
            var f = this.q8.cs.b;
            var g = this.ra();
            var h = this.ch.count;
            var i = this.qz;
            var j = -1;
            var k = -1;
            var l = this.g0(b);
            j = i2.truncate(Math.floor((i2.intDivide(l, f)))) * f;
            k = j + (f - 1);
            if (c != null && c.h == j && c.g == k) {
                return c;
            }
            var m = new HighlightingInfo();
            m.e = true;
            m.b = this;
            m.h = j;
            m.g = k;
            return m;
        };
        RadialBase.prototype.av = function (a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                var d = this.q2(a, b, this.q4);
                this.q4 = d;
                return d;
            }
            else {
                var e = this.q1(a, b, this.q4);
                this.q4 = e;
                return e;
            }
        };
        RadialBase.prototype.aw = function (a, b, c) {
            if (this.d9(this.bj) && !c) {
                var d = this.q3(a, b, this.q5);
                this.q5 = d;
                return d;
            }
            else {
                var e = this.q1(a, b, this.q5);
                e.e = true;
                this.q5 = e;
                return e;
            }
        };
        RadialBase.prototype.rp = function () {
            return (this.assigningRadialStyle != null && this.rg) || (this.bj != 1);
        };
        RadialBase.prototype.ro = function () {
            return (this.assigningRadialMarkerStyle != null && this.rf) || (this.bj != 1);
        };
        RadialBase.prototype.r3 = function (a) {
            if (this.assigningRadialStyle != null && this.rg) {
                this.assigningRadialStyle(this, a);
            }
        };
        RadialBase.prototype.r2 = function (a) {
            if (this.assigningRadialMarkerStyle != null && this.rf) {
                this.assigningRadialMarkerStyle(this, a);
            }
        };
        RadialBase.prototype.rr = function (a) {
            return a.cs.b;
        };
        RadialBase.prototype.rs = function (a) {
            return a.cs.c;
        };
        RadialBase.prototype.ag = function () {
            return [this.qz, this.q6];
        };
        RadialBase.prototype.mn = function (a, b) {
            this.q8.cs.e(this.gh);
            this.l0(false);
        };
        RadialBase.prototype.mm = function (a, b) {
            this.q8.cs.e(this.gh);
            this.l0(false);
        };
        RadialBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (c != null && d == null) {
                        if (this.qz != null) {
                            this.qz.bx(this);
                        }
                        if (this.q6 != null) {
                            this.q6.bx(this);
                        }
                    }
                    if (c == null && d != null) {
                        if (this.qz != null) {
                            this.qz.cn(this);
                        }
                        if (this.q6 != null) {
                            this.q6.cn(this);
                        }
                    }
                    this.q8.cs.e(this.gh);
                    this.l0(false);
                    break;
                case RadialBase.$$p[0]:
                    if (this.qz != null && this.q6 != null) {
                        this.q7 = new RadialAxes(this.q6, this.qz);
                    }
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.q8.cs.e(this.gh);
                    this.l0(false);
                    break;
                case RadialBase.$$p[4]:
                    if (this.qz != null && this.q6 != null) {
                        this.q7 = new RadialAxes(this.q6, this.qz);
                    }
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.q8.cs.e(this.gh);
                    if (this.q6 == null || !this.q6.cv()) {
                        this.l0(false);
                    }
                    break;
                case "SyncLink":
                    if (this.b5 != null && this.ca != null) {
                        this.q8.cs.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case "TransitionProgress":
                    this.rc.c(this.gn, this.rb, this.q9);
                    if (this.ct(this.bx)) {
                        return;
                    }
                    if (this.gn == 1) {
                        this.r4(this.q9, this.q8);
                    }
                    else {
                        this.r4(this.rc, this.q8);
                    }
                    if (this.ca != null) {
                        this.ca.ln(this);
                    }
                    break;
                case RadialBase.$$p[1]:
                    this.l0(false);
                    this.k7();
                    break;
                case "VisibilityProxy":
                    if (i2.EnumUtil.getEnumValue(i2.Visibility_$type, c) != 0 && i2.EnumUtil.getEnumValue(i2.Visibility_$type, d) == 0) {
                        this.q8.cs.e(this.gh);
                    }
                    break;
                case RadialBase.$$p[3]:
                    this.rg = this.rn();
                    this.l0(false);
                    break;
                case RadialBase.$$p[2]:
                    this.rf = this.rm();
                    this.l0(false);
                    break;
            }
        };
        RadialBase.prototype.rn = function () {
            return this.rl;
        };
        RadialBase.prototype.rm = function () {
            return this.rk;
        };
        RadialBase.prototype.ri = function (a) {
            if (i2.typeCast(NumericRadiusAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        RadialBase.prototype.rh = function (a) {
            if (i2.typeCast(CategoryAngleAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        RadialBase.prototype.hh = function (a) {
            var b = this.g0(a);
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        };
        RadialBase.prototype.rq = function (a) {
            var b = this.bx.bv;
            var c = this.bx.bu;
            if (this.qz != null && !b.isEmpty && !c.isEmpty && this.q7 != null) {
                var d = this.q7.c(a);
                if (d < 0) {
                    d += Math.PI * 2;
                }
                if (d > Math.PI * 2) {
                    d -= Math.PI * 2;
                }
                return d;
            }
            return NaN;
        };
        RadialBase.prototype.fw = function (a) {
            var b = this.bx.bv;
            var c = this.bx.bu;
            var d = -1;
            if (this.qz != null && !b.isEmpty && !c.isEmpty && this.q7 != null) {
                var e = this.q7.c(a);
                if (e < 0) {
                    e += Math.PI * 2;
                }
                if (e > Math.PI * 2) {
                    e -= Math.PI * 2;
                }
                var f = this.qz.getUnscaledAngle(e);
                if (this.qz.categoryMode != 0) {
                    f -= 0.5;
                }
                d = f;
            }
            return d;
        };
        RadialBase.prototype.g0 = function (a) {
            var b = i2.truncate(Math.round(this.fw(a)));
            if (this.ch != null && b == this.ch.count) {
                b = 0;
            }
            return b;
        };
        RadialBase.prototype.eh = function (a) {
            return false;
        };
        RadialBase.prototype.ra = function () {
            var a = this.q9;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.rc;
            }
            return a;
        };
        RadialBase.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.qz != null) {
                this.qz.hq(false);
            }
            if (this.q6 != null) {
                this.q6.hq(false);
            }
        };
        RadialBase.prototype.e3 = function (a, b, c) {
            var d = true;
            var e = c;
            if (!_super.prototype.e3.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.qz == null || this.qz.itemsSource == null || this.q6 == null || this.q7 == null || this.ch == null || this.qz.bh == null || this.q6.bh == null || this.q6.kv == this.q6.ku) {
                e.cs.b = 0;
                d = false;
            }
            return d;
        };
        RadialBase.prototype.l1 = function (a) {
            var b;
            var c;
            var d = this.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            if (!this.e3(c, b, this.bx)) {
                this.kh(true, this.bx);
                return;
            }
            var e = new SeriesRenderingArguments(this, c, b, a, this.em);
            var f = this.re.g(e, this.rb, this.q9, this.rc, this.q8);
            this.rb = f.p1;
            this.q9 = f.p2;
            this.rc = f.p3;
        };
        RadialBase.prototype.rt = function () {
            var e_1, _a;
            var a = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b == this) {
                        return a;
                    }
                    var c = i2.typeCast(RadialBase.$, b);
                    if (c != null && c.qz == this.qz && c.preferredCategoryMode(c.qz) == 2) {
                        a++;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return -1;
        };
        RadialBase.$t = i2.markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
        RadialBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:qz:r5', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:rj:r6', [0, false], 'IsCustomRadialMarkerStyleAllowed:rk:r7', [0, false], 'IsCustomRadialStyleAllowed:rl:r8', [0, false], 'ValueAxis:q6:r9', [NumericRadiusAxis.$, null]]);
        return RadialBase;
    }(MarkerSeries));
    /**
     * @hidden
     */
    var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialBaseView, _super);
        function RadialBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.cs = null;
            _this.cr = null;
            _this.ct = null;
            _this.cu = 0;
            _this.cv = null;
            _this.cr = a;
            _this.ct = new i2.Pool$1(Marker.$);
            _this.ci(_this.ct);
            return _this;
        }
        RadialBaseView.prototype.cf = function (a) {
            this.ct.c(a);
        };
        RadialBaseView.$t = i2.markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
        return RadialBaseView;
    }(MarkerSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialTrendLineManager, _super);
        function RadialTrendLineManager() {
            var _this = _super.call(this, i2.Number_$type) || this;
            _this.i = 0;
            _this.h = 0;
            _this.j = null;
            _this.k = null;
            return _this;
        }
        RadialTrendLineManager.prototype.get_g$a = function () {
            return 3;
        };
        Object.defineProperty(RadialTrendLineManager.prototype, "g$a", {
            get: function () {
                return this.get_g$a();
            },
            enumerable: false,
            configurable: true
        });
        RadialTrendLineManager.prototype.l = function (a, b, c, d, e, f, g, h) {
            var i = g.d * g.c;
            var j = g.e * g.c;
            var k = new i2.List$1(i2.Point_$type, 0);
            if (!g.g.isEmpty && !g.f.isEmpty) {
                if (b == 0) {
                    this.a = null;
                    this.d.clear();
                    return;
                }
                if (this.c(b)) {
                    this.d.clear();
                    this.a = TrendFitCalculator.a(k, b, g, this.a, c.count, function (l) { return (l + 1); }, function (l) { return c.item(l); }, function (l) { return e(l - 1); }, f, i + 1, j + 1);
                }
                if (this.b(b)) {
                    this.a = null;
                    TrendAverageCalculator.b(b, this.d, c, d);
                    for (var l = g.d; l <= g.e; l += 1) {
                        var m = (l % c.count) * g.c;
                        if (m >= 0 && m < this.d.count) {
                            var n = e(m);
                            var o = f(this.d._inner[m]);
                            if (!i2.isNaN_(n) && !i2.isNaN_(o)) {
                                k.add({ $type: i2.Point_$type, x: n + g.a, y: o });
                            }
                        }
                    }
                }
                if (k.count > 0) {
                    this.f(k, g, a, h);
                }
            }
        };
        RadialTrendLineManager.prototype.e = function (a, b, c) {
            this.f(a, b, c, null);
        };
        RadialTrendLineManager.prototype.f = function (a, b, c, d) {
            var _this = this;
            if (d != null) {
                d.i = c;
            }
            var e = ((function () {
                var $ret = new PolarLinePlanner();
                $ret.m = function (f) { return a.item(f).x; };
                $ret.n = function (f) { return a.item(f).y; };
                $ret.a = d;
                $ret.q = a.count;
                $ret.l = b.b;
                $ret.o = function (f) { return _this.j(a.item(f).x, a.item(f).y); };
                $ret.p = function (f) { return _this.k(a.item(f).x, a.item(f).y); };
                $ret.f = true;
                $ret.ab = b.f;
                $ret.ac = b.g;
                return $ret;
            })());
            e.x(null, null);
        };
        RadialTrendLineManager.$t = i2.markType(RadialTrendLineManager, 'RadialTrendLineManager', TrendLineManagerBase$1.$.specialize(i2.Number_$type));
        return RadialTrendLineManager;
    }(TrendLineManagerBase$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredRadialBucketCalculator, _super);
        function AnchoredRadialBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.f = null;
            _this.f = a;
            return _this;
        }
        AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
            var b = this.f.cw.si;
            var c = Math.min(a * this.b, b.count - 1);
            var d = Math.min(c + this.b - 1, b.count - 1);
            var e = NaN;
            var f = NaN;
            for (var g = c; g <= d; ++g) {
                var h = b.item(g);
                if (!i2.isNaN_(e)) {
                    if (!i2.isNaN_(h)) {
                        e = Math.min(e, h);
                        f = Math.max(f, h);
                    }
                }
                else {
                    e = h;
                    f = h;
                }
            }
            if (!i2.isNaN_(e)) {
                return [0.5 * (c + d), e, f];
            }
            return [0.5 * (c + d), NaN, NaN];
        };
        AnchoredRadialBucketCalculator.$t = i2.markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
        return AnchoredRadialBucketCalculator;
    }(RadialBucketCalculator));
    /**
     * @hidden
     */
    var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredRadialSeries, _super);
        function AnchoredRadialSeries() {
            var _this = _super.call(this) || this;
            _this.sd = null;
            _this.sh = null;
            _this.te = { $type: i2.Point_$type, x: 0, y: 0 };
            _this.sf = null;
            _this.se = null;
            _this.sf = new RadialFrame(3);
            _this.sd = new CategoryLineRasterizer();
            return _this;
        }
        AnchoredRadialSeries.prototype.bu = function () {
            return new AnchoredRadialSeriesView(this);
        };
        AnchoredRadialSeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.qz = null;
            this.q6 = null;
        };
        AnchoredRadialSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == AnchoredRadialSeries.$$p[0]) {
                return this.hl(a, b, this.su);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        AnchoredRadialSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.sc = a;
        };
        AnchoredRadialSeries.prototype.g6 = function (a, b) {
            return this.g7(a, b, this.qz, null, this.si);
        };
        AnchoredRadialSeries.prototype.g4 = function (a, b) {
            return this.g5(a, b, this.qz, null, this.si);
        };
        AnchoredRadialSeries.prototype.fu = function (a, b, c, d, e) {
            if (this.si == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.fv(a, b, this.qz, d, e, this.si.count, null);
        };
        AnchoredRadialSeries.prototype.f8 = function (a, b, c) {
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.sn(this.qz, this.bx.bv, this.bx.bu, d);
            var f = new ScalerParams(0, this.bx.bv, this.bx.bu, this.qz.cc, d);
            f.c = this.ca.pv;
            return this.ga(this.si, a, this.qz, f, e, null, b, c);
        };
        AnchoredRadialSeries.prototype.o2 = function (a, b, c) {
            if (this.q6 == null || this.qz == null || this.bx == null || this.bx.bv.isEmpty || this.bx.bu.isEmpty) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.bx.bv, this.bx.bu, this.q6.cc, d);
            e.c = this.getEffectiveViewport1(this.bx);
            var f = this.f8(a, b, c);
            f = this.q6.d8(f, e);
            var g = this.q7.c(a);
            if (!b && this.qz != null) {
                var h = this.g6(a, c);
                var i = this.g4(a, c);
                var j = this.sn(this.qz, this.bx.bv, this.bx.bu, d);
                var k = new ScalerParams(0, this.bx.bv, this.bx.bu, this.qz.cc, d);
                k.c = this.ca.pv;
                var l = this.fu(a, h, this.qz, k, j);
                var m = this.fu(a, i, this.qz, k, j);
                if (m <= l) {
                    g = this.qz.d8(i, k) + j;
                }
                else {
                    g = this.qz.d8(h, k) + j;
                }
            }
            var n = this.q7.d(g, f, this.bx.bv, this.bx.bu);
            var o = this.q7.e(g, f, this.bx.bv, this.bx.bu);
            return { $type: i2.Point_$type, x: n, y: o };
        };
        Object.defineProperty(AnchoredRadialSeries.prototype, "si", {
            get: function () {
                return this.sh;
            },
            set: function (a) {
                if (this.sh != a) {
                    var b = this.sh;
                    this.sh = a;
                    this.raisePropertyChanged("ValueColumn", b, this.sh);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AnchoredRadialSeries.prototype, "ta", {
            get: function () {
                return this.c(AnchoredRadialSeries.s1);
            },
            set: function (a) {
                this.h(AnchoredRadialSeries.s1, a);
            },
            enumerable: false,
            configurable: true
        });
        AnchoredRadialSeries.prototype.ap = function (a) {
            if (a != null && a == this.qz && this.si != null && this.si.count > 0) {
                return new AxisRange(0, this.si.count - 1);
            }
            if (a != null && a == this.q6 && this.si != null && this.si.count > 0) {
                return new AxisRange(this.si.minimum, this.si.maximum);
            }
            return null;
        };
        AnchoredRadialSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.sc.cx.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            var e = i2.typeCast(NumericAxisBase.$, this.q6);
            switch (b) {
                case "FastItemsSource":
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) !== null) {
                        c.deregisterColumn(this.si);
                        this.si = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) !== null) {
                        this.si = this.ce(this.su);
                        this.sc.cs.e(this.gh);
                    }
                    if (e != null && !e.cv()) {
                        this.sc.cs.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case AnchoredRadialSeries.$$p[0]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.si);
                        this.si = this.ce(this.su);
                    }
                    break;
                case "ValueColumn":
                    if (e != null && !e.cv()) {
                        this.sc.cs.e(this.gh);
                        this.l0(false);
                    }
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
            }
        };
        AnchoredRadialSeries.prototype.kk = function (a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.sc.cs.e(this.gh);
                    break;
            }
            this.sc.cx.g$e(a, b, c, d);
            switch (a) {
                case 4:
                    if (this.q6 != null && !this.q6.cv()) {
                        this.l0(true);
                    }
                    break;
                case 1:
                    if (this.q6 != null && !this.q6.cv()) {
                        this.l0(true);
                    }
                    break;
                case 0:
                    if (this.q6 != null && !this.q6.cv()) {
                        this.l0(true);
                    }
                    break;
                case 2:
                    if (this.su != null && this.sc.cs.b > 0 && this.q6 != null && !this.q6.cv()) {
                        this.l0(true);
                    }
                    break;
                case 3:
                    if (d == this.su) {
                        if (this.q6 != null && !this.q6.cv()) {
                            this.l0(true);
                        }
                    }
                    break;
            }
        };
        AnchoredRadialSeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            var e = c;
            if (this.ch == null || this.ch.count == 0 || this.qz == null || this.si == null || this.qz.kq == 0 || this.q6 == null || i2.isInfinity(this.q6.kv) || i2.isInfinity(this.q6.ku) || e.cs.b < 1) {
                d = false;
            }
            return d;
        };
        AnchoredRadialSeries.prototype.getOffsetValue = function () {
            return this.sn(this.qz, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        AnchoredRadialSeries.prototype.getCategoryWidth = function () {
            return this.qz.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        AnchoredRadialSeries.prototype.get_sl = function () {
            return false;
        };
        Object.defineProperty(AnchoredRadialSeries.prototype, "sl", {
            get: function () {
                return this.get_sl();
            },
            enumerable: false,
            configurable: true
        });
        AnchoredRadialSeries.prototype.sn = function (a, b, c, d) {
            var e = 0;
            var f = this.preferredCategoryMode(a);
            if (f == 0 && a.categoryMode != 0) {
                f = 1;
            }
            switch (f) {
                case 0:
                    e = 0;
                    break;
                case 1:
                    e = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    e = a.getGroupCenter(this.rt(), b, c, d);
                    break;
            }
            if (a.cc) {
                e = -e;
            }
            return e;
        };
        AnchoredRadialSeries.prototype.r1 = function (a, b) {
            var _this = this;
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.qz;
            var g = this.q6;
            var h = g.kv;
            var i = g.ku;
            a.f.clear();
            a.m.clear();
            a.p.clear();
            var j = this.pt();
            var k = 0;
            var l = b;
            var m = new CollisionAvoider();
            var n = 0;
            var o = b.cs.d;
            n = this.sn(f, c, d, e);
            l.cx.i = this.q6.ma;
            l.cx.h = this.q6.l9;
            l.cx.j = function (p, q) { return _this.so(p, q, c, d); };
            l.cx.k = function (p, q) { return _this.sp(p, q, c, d); };
            var p = ((function () {
                var $ret = new i2.Clipper(0, d, false);
                $ret.i = a.p;
                return $ret;
            })());
            var q = ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = b.cs.b;
                $ret.d = b.cs.c;
                $ret.e = o;
                $ret.a = n;
                $ret.b = _this.gh;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })());
            l.cx.l(a.p, this.sg, this.si, this.sr, function (r) { return _this.qz.getScaledAngle(r); }, function (r) { return _this.q6.mg(r); }, q, p);
            var r = true;
            if (this.sm(b)) {
                o--;
            }
            for (var s = b.cs.c; s <= o; ++s) {
                var t = s;
                if (t * b.cs.b >= this.qz.kq) {
                    t -= i2.intDivide((this.qz.kq), b.cs.b);
                }
                var u = b.cs.getBucket(t);
                if (!i2.isNaN_(u[0])) {
                    u[0] = f.getScaledAngle(u[0]) + n;
                    if (u[1] < h || u[1] > i) {
                        continue;
                    }
                    u[1] = g.mg(u[1]);
                    if (b.cs.b > 1) {
                        if (u[2] < h || u[2] > i) {
                            continue;
                        }
                        u[2] = g.mg(u[2]);
                    }
                    else {
                        u[2] = u[1];
                    }
                    if ((i2.isNaN_(u[1]) || i2.isNaN_(u[2])) && r && this.sl && this.sk()) {
                        o++;
                    }
                    else {
                        r = false;
                    }
                    a.f.add(u);
                    if (j) {
                        var v = Math.min(t * b.cs.b, this.ch.count - 1);
                        var w = this.q7.d(u[0], u[1], c, d);
                        var x = this.q7.e(u[0], u[1], c, d);
                        var y = new i2.Rect(0, w - 5, x - 5, 11, 11);
                        if (!i2.isNaN_(w) && !i2.isNaN_(x) && !i2.isInfinity(w) && !i2.isInfinity(x) && m.tryAdd(y)) {
                            a.m.add({ $type: i2.Point_$type, x: w, y: x });
                            var z = b.ct.item(k);
                            z.al = t;
                            z.ak = v;
                            z.content.item = this.ch.item(v);
                            ++k;
                        }
                    }
                }
                else {
                    if (r && this.sl && this.sk()) {
                        o++;
                    }
                }
            }
            b.ct.count = k;
            return;
        };
        AnchoredRadialSeries.prototype.so = function (a, b, c, d) {
            return this.q7.d(a, b, c, d);
        };
        AnchoredRadialSeries.prototype.sp = function (a, b, c, d) {
            return this.q7.e(a, b, c, d);
        };
        AnchoredRadialSeries.prototype.sm = function (a) {
            var b = a;
            return !this.sl && b.cs.c == 0 && b.cs.d == this.qz.kq;
        };
        AnchoredRadialSeries.prototype.sb = function (a, b, c) {
            var d = null;
            var e = c.bv;
            var f = c.bu;
            if (b > -1 && !e.isEmpty && !f.isEmpty) {
                var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
                var h = f.bottom + 10;
                var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
                var j = f.top - 10;
                d = new i2.Clipper(1, g, h, i, j, false);
            }
            return d;
        };
        AnchoredRadialSeries.prototype.s0 = function (a, b, c, d, e) {
            if (a.count > 0 && d.count > 0) {
                if (!e || this.sj()) {
                    a.add(this.te);
                    a.add(a._inner[0]);
                    d.add(this.te);
                    d.add(d._inner[0]);
                }
            }
        };
        AnchoredRadialSeries.prototype.sk = function () {
            return !this.sj();
        };
        AnchoredRadialSeries.prototype.sj = function () {
            var a = this.bx.bv;
            return !a.containsPoint({ $type: i2.Point_$type, x: 0.5, y: 0.5 });
        };
        AnchoredRadialSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a) {
                c.ct.clear();
            }
            c.cx.g$d();
        };
        AnchoredRadialSeries.prototype.r4 = function (a, b) {
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.o7(b);
            var g = b;
            g.cx.g$g(a.p);
            CategoryMarkerManager.e(this, a.m, g.ct, this.pv);
            this.sx(b, a);
            g.cm();
            this.sw(d, c, e, f, g);
        };
        AnchoredRadialSeries.prototype.sa = function (a, b, c) {
            if (b < a || a < 0 || a > this.si.count || b < 0 || b > this.si.count || c == null) {
                return null;
            }
            var d = new Array((b - a) + 1);
            var e = c.ch;
            var f = null;
            if (e) {
                f = c.i$b;
            }
            for (var g = a; g <= b; g++) {
                var h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ch.item(g);
            }
            return d;
        };
        AnchoredRadialSeries.prototype.sy = function (a, b, c, d, e, f) {
            var g = this.bj != 1;
            this.rd.a1(this.rd.d, d.ch, a, b, c, d, e, f, true);
            this.rd.aa(this.fj);
            var h = this.rd.av;
            var i = null;
            var j = this.ch;
            var k = null;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    k = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                }
                h.b = i;
            }
            h.f = f;
            this.r2(h);
            this.rd.y(this, i, f, g, h.m, this.ca.a3.totalHighlightingProgress);
        };
        AnchoredRadialSeries.prototype.sz = function (a, b, c, d, e, f) {
            var g = this.bj != 1;
            this.rd.a1(this.rd.b, d.ch, a, b, c, d, e, f, false);
            this.rd.ab(this.fj);
            var h = this.rd.aw;
            var i = null;
            var j = this.ch;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.r3(h);
            this.rd.z(this, i, f, g, b < 0);
        };
        AnchoredRadialSeries.prototype.sx = function (a, b) {
            a.b3 = true;
            this.rd.az(this, this.ro(), i2.runOn(this, this.qw), this.rr(a), this.rs(a));
            var c = this.rd.d;
            var d = c != null;
            var e = this.qz;
            if (e == null) {
                return;
            }
            var f = this.getEffectiveViewport1(a);
            var g = new ScalerParams(0, a.bv, a.bu, e.cc, f);
            var h = this.ch == null ? 0 : this.ch.count;
            var i = a;
            var j = b.f;
            var k = i.cs.c;
            var l = i.cs.d;
            var m = i.cs.b;
            var n = k * m;
            for (var o = 0; o < a.ct.count; o++) {
                var p = a.ct.item(o);
                var q = p.content;
                if (d) {
                    var r = p.al;
                    this.sy(j, r, h, e, g, a.q);
                }
                this.rd.ac(p, q);
            }
        };
        AnchoredRadialSeries.prototype.sw = function (a, b, c, d, e) {
            e.cy(a, b, c, d);
        };
        AnchoredRadialSeries.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            this.sc.cz();
        };
        AnchoredRadialSeries.prototype.hn = function (a, b) {
            if (a == this.sc.cx.g$j) {
                return null;
            }
            return _super.prototype.hn.call(this, a, b);
        };
        AnchoredRadialSeries.prototype.eh = function (a) {
            var b = this.bx.bv;
            b = b.copy();
            var c = this.bx.bu;
            var d = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            if (this.qz == null || this.si == null || this.q6 == null) {
                return false;
            }
            if (d < 0 || d > this.si.count - 1) {
                return false;
            }
            var e = this.qz.getScaledAngle(d);
            var f = this.q6.mg(this.si.item(d));
            if (i2.isNaN_(f)) {
                f = (this.q6.l9 + this.q6.ma) / 2;
            }
            var g = 0.5 + (Math.cos(e) * f);
            var h = 0.5 + (Math.sin(e) * f);
            if (!i2.isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!i2.isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.b5 != null) {
                this.b5.ap(this.ca, b, true);
            }
            return d >= 0;
        };
        AnchoredRadialSeries.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            var c = i2.typeCast(AnchoredRadialSeriesView.$, this.bw);
            c.cs.e(this.gh);
            if (this.ct(this.bw)) {
                return;
            }
            if (!this.en) {
                this.sf = new RadialFrame(3);
                this.r1(this.sf, c);
            }
            this.en = false;
            this.r4(this.sf, c);
            this.et = false;
        };
        AnchoredRadialSeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            g.cs.e(this.gh);
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.se == null) {
                this.se = new RadialFrame(3);
            }
            this.se.u();
            this.r1(this.se, g);
            this.r4(this.se, g);
        };
        AnchoredRadialSeries.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            this.a6.exportTrendlineData(this, a, this.sc.cx.g$j);
        };
        AnchoredRadialSeries.$t = i2.markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
        AnchoredRadialSeries.s1 = i2.DependencyProperty.i("ActualTrendLineBrush", i2.Brush.$, AnchoredRadialSeries.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
        AnchoredRadialSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:su:s9', [2, null], 'TrendLineType:sg:s7', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'TrendLineThickness:sq:s6', [1, 1.5], 'TrendLinePeriod:sr:s5', [1, 7], 'TrendLineZIndex:ss:s8', [1, 1], 'TrendLineBrush:tb:s2', [i2.Brush.$, null], 'TrendLineDashArray:tc:s3', [i2.DoubleCollection.$], 'TrendLineDashCap:td:s4', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)]]);
        return AnchoredRadialSeries;
    }(RadialBase));
    /**
     * @hidden
     */
    var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AnchoredRadialSeriesView, _super);
        function AnchoredRadialSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.cw = null;
            _this.cx = null;
            _this.cs = new AnchoredRadialBucketCalculator(_this);
            _this.cw = a;
            _this.cx = new RadialTrendLineManager();
            return _this;
        }
        AnchoredRadialSeriesView.prototype.cy = function (a, b, c, d) {
        };
        AnchoredRadialSeriesView.prototype.cz = function () {
            this.cw.ta = null;
            if (this.cw.tb != null) {
                this.cw.ta = this.cw.tb;
            }
            else {
                this.cw.ta = this.cw.of;
            }
        };
        AnchoredRadialSeriesView.prototype.a5 = function (a, b) {
            if (a.d) {
                if (!b) {
                }
                if (this.cw.sg != 0 && !b) {
                    var c = this.cx.g$j;
                    c.ac = this.cw.sq;
                    c._stroke = this.cw.ta;
                    c.ai = this.cw.tc;
                    c.ad = this.cw.td;
                    a.u(c);
                }
            }
            _super.prototype.a5.call(this, a, b);
        };
        AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.cw.qz.fj != null) {
                a += "<span>${item." + this.cw.qz.fj + "}</span><br/>";
            }
            a += "<span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.hp + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.su + "}</span></div>";
            return a;
        };
        AnchoredRadialSeriesView.$t = i2.markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
        return AnchoredRadialSeriesView;
    }(RadialBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialAreaSeries, _super);
        function RadialAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = RadialAreaSeries.$;
            return _this;
        }
        RadialAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        RadialAreaSeries.prototype.bu = function () {
            return new RadialAreaSeriesView(this);
        };
        RadialAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.tf = a;
        };
        RadialAreaSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        RadialAreaSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            this.tf.c1();
        };
        RadialAreaSeries.prototype.r4 = function (a, b) {
            _super.prototype.r4.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = b;
            if (b.o() && !c.isEmpty && !d.isEmpty && this.qz != null && this.q6 != null) {
                var f = a.f;
                var g = f.count;
                var h = new i2.List$1(i2.Array_$type, 2, g);
                var i = 0;
                for (var j = 0; j < g; j++) {
                    var k = new Array(4);
                    h.add(k);
                    k[0] = this.q7.d(a.f._inner[j][0], a.f._inner[j][1], c, d);
                    k[1] = this.q7.e(a.f._inner[j][0], a.f._inner[j][1], c, d);
                    k[2] = this.q7.d(a.f._inner[j][0], a.f._inner[j][2], c, d);
                    var l = a.f._inner[j][2];
                    k[3] = this.q7.e(a.f._inner[j][0], l, c, d);
                    if (l > i) {
                        i = l;
                    }
                }
                var m = ViewportUtils.c(0.5, c, d);
                var n = ViewportUtils.f(0.5, c, d);
                this.te = { $type: i2.Point_$type, x: m, y: n };
                var o = this.getEffectiveViewport1(e);
                this.rd.a0(this, this.rp(), i2.runOn(this, this.qw), this.rr(b), this.rs(b));
                var p = false;
                var q = this.rd.b;
                if (q != null) {
                    p = true;
                }
                if (p) {
                    var r = new ScalerParams(0, b.bv, b.bu, this.qz.cc, o);
                    this.sz(f, -1, this.si.count, this.qz, r, b.q);
                }
                var s = e.c9;
                var t = e.da;
                var u = e.c7;
                var v = e.c8;
                this.rd.ad(s, true, false, true, true);
                this.rd.ad(t, true, false, true, true);
                this.rd.ad(u, false, true, false, false);
                this.rd.ad(v, false, true, false, false);
                e.c2(a.f.count, h, false, this.tf.cs.b, this.gh, i2.runOn(this, this.s0), this.tg);
                u._opacity = this.rd.j * this.fi;
                v._opacity = 0.5 * this.rd.j * this.fi;
            }
        };
        RadialAreaSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case RadialAreaSeries.$$p[0]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        RadialAreaSeries.prototype.get_sl = function () {
            return true;
        };
        RadialAreaSeries.$t = i2.markType(RadialAreaSeries, 'RadialAreaSeries', AnchoredRadialSeries.$);
        RadialAreaSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RadialAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:tg:ti', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return RadialAreaSeries;
    }(AnchoredRadialSeries));
    /**
     * @hidden
     */
    var RadialAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialAreaSeriesView, _super);
        function RadialAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c7 = new i2.Path();
            _this.c9 = new i2.Path();
            _this.c8 = new i2.Path();
            _this.da = new i2.Path();
            _this.c3 = new i2.Path();
            _this.c5 = new i2.Path();
            _this.c4 = new i2.Path();
            _this.c6 = new i2.Path();
            _this.c0 = a;
            return _this;
        }
        RadialAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        RadialAreaSeriesView.prototype.c1 = function () {
            this.c7.ak = null;
            this.c9.ak = null;
            this.c8.ak = null;
            this.da.ak = null;
            this.c3.ak = null;
            this.c5.ak = null;
            this.c4.ak = null;
            this.c6.ak = null;
            this.aq();
        };
        RadialAreaSeriesView.prototype.c2 = function (a, b, c, d, e, f, g) {
            this.cw.sd.i(this.c7, this.c9, this.c8, this.da, a, b, c, d, e, f, g);
            this.aq();
        };
        RadialAreaSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        RadialAreaSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.c5.ak = this.c9.ak;
            this.c6.ak = this.da.ak;
            this.c3.ak = this.c7.ak;
            this.c4.ak = this.c8.ak;
            this.c5._stroke = a;
            this.c5.ac = this.e.fl + 3;
            this.c6._stroke = a;
            this.c6.ac = this.e.fl + 3;
            this.c3._fill = a;
            this.c3._opacity = 1;
            this.c4._fill = a;
            this.c4._opacity = 1;
        };
        RadialAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c3);
                    a.s(this.c4);
                    a.s(this.c5);
                    a.s(this.c6);
                }
                else {
                    a.s(this.c7);
                    a.s(this.c8);
                    a.s(this.c9);
                    a.s(this.da);
                }
            }
        };
        RadialAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.c9, "lowerShape", ["Lower"]);
            this.e.a6.exportPathData(a, this.da, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPathData(a, this.c8, "translucentShape", ["Translucent"]);
            this.e.a6.exportPathData(a, this.c7, "fillShape", ["Fill"]);
        };
        RadialAreaSeriesView.$t = i2.markType(RadialAreaSeriesView, 'RadialAreaSeriesView', AnchoredRadialSeriesView.$);
        return RadialAreaSeriesView;
    }(AnchoredRadialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent radial area series.
    */
    var IgxRadialAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRadialAreaSeriesComponent, _super);
        function IgxRadialAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxRadialAreaSeriesComponent.prototype.createImplementation = function () {
            return new RadialAreaSeries();
        };
        Object.defineProperty(IgxRadialAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialAreaSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
            get: function () {
                return this.i.tg;
            },
            set: function (v) {
                this.i.tg = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxRadialAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRadialAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRadialAreaSeriesComponent, selector: "igx-radial-area-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRadialAreaSeriesComponent;
    }(IgxAnchoredRadialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-radial-area-series',
                        template: "",
                        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialAreaSeriesModule() {
        }
        IgxRadialAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesModule, declarations: [IgxRadialAreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxRadialAreaSeriesComponent] });
        IgxRadialAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxRadialAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRadialAreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxRadialAreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRadialAreaSeriesComponent", IgxRadialAreaSeriesComponent);
            i2.TypeRegistrar.register("RadialAreaSeries", RadialAreaSeries.$type);
        }
        IgxRadialAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxRadialAreaSeriesModule], exports: [IgxRadialAreaSeriesModule] });
        IgxRadialAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxRadialAreaSeriesModule], IgxRadialAreaSeriesModule] });
        return IgxRadialAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRadialAreaSeriesModule],
                        exports: [IgxRadialAreaSeriesModule],
                        entryComponents: [IgxRadialAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialColumnSeries, _super);
        function RadialColumnSeries() {
            var _this = _super.call(this) || this;
            _this.ab = RadialColumnSeries.$;
            return _this;
        }
        RadialColumnSeries.prototype.get_db = function () {
            return true;
        };
        RadialColumnSeries.prototype.get_dw = function () {
            return true;
        };
        RadialColumnSeries.prototype.bu = function () {
            return new RadialColumnSeriesView(this);
        };
        RadialColumnSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.tf = a;
        };
        RadialColumnSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        RadialColumnSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case RadialColumnSeries.$$p[0]:
                case RadialColumnSeries.$$p[1]:
                    this.lj();
                    break;
            }
        };
        RadialColumnSeries.prototype.preferredCategoryMode = function (a) {
            return a != null && a == this.qz ? 2 : 0;
        };
        RadialColumnSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a) {
                c.c1.count = 0;
            }
        };
        RadialColumnSeries.prototype.get_cy = function () {
            return true;
        };
        RadialColumnSeries.prototype.f1 = function () {
            return this.qz.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        RadialColumnSeries.prototype.r4 = function (a, b) {
            _super.prototype.r4.call(this, a, b);
            var c = a.f;
            var d = b.bv;
            var e = b.bu;
            var f = this.getEffectiveViewport1(b);
            var g = this.o7(b);
            var h = this.q6.j7(e, d, f, g);
            var i = b;
            var j = this.q6;
            var k = Math.max(0, 0.5 * j.l9);
            k = Math.max(k, h.minLength * 0.9);
            var l = ViewportUtils.d(k, d, e);
            var m = this.qz.ki(d, e, f);
            var n = Math.max(0.1 * this.q6.ma, k);
            var o = this.q7.d(0, n, d, e);
            var p = this.q7.e(0, n, d, e);
            var q = this.q7.d(m, n, d, e);
            var r = this.q7.e(m, n, d, e);
            var s = Math.sqrt((o - q) * (o - q) + (p - r) * (p - r));
            var t = { $type: i2.Point_$type, x: ViewportUtils.c(0.5, d, e), y: ViewportUtils.f(0.5, d, e) };
            var u = this.si.count;
            this.rd.a0(this, this.rp(), i2.runOn(this, this.qw), this.rr(b), this.rs(b));
            this.rd.r = this.tg;
            this.rd.s = this.th;
            this.rd.k = this.tg;
            this.rd.l = this.th;
            var v = false;
            var w = this.rd.b;
            if (w != null) {
                v = true;
            }
            var x = this.qz;
            var y = new ScalerParams(1, b.bv, b.bu, x.cc);
            y.c = this.getEffectiveViewport();
            for (var z = 0; z < c.count; ++z) {
                var aa = Math.min(a.f._inner[z][2], h.maxLength * 1.1);
                var ab = this.q7.d(a.f._inner[z][0], aa, d, e);
                var ac = this.q7.e(a.f._inner[z][0], aa, d, e);
                var ad = Math.sqrt((ab - t.x) * (ab - t.x) + (ac - t.y) * (ac - t.y));
                var ae = ad;
                var af = l;
                if (v) {
                    this.sz(c, z, u, x, y, b.q);
                }
                var ag = this.rd.k;
                var ah = this.rd.l;
                var ai = a.f._inner[z][0] - (Math.PI / 2);
                var aj = i.c1.item(z);
                var ak = 0 - (s / 2);
                var al = (s / 2);
                var am = Math.max(af, ae);
                var an = Math.min(af, ae);
                var ao = Math.cos(ai);
                var ap = Math.sin(ai);
                var aq = { $type: i2.Point_$type, x: t.x + (ak * ao - am * ap), y: t.y + (ak * ap + am * ao) };
                var ar = { $type: i2.Point_$type, x: t.x + (al * ao - am * ap), y: t.y + (al * ap + am * ao) };
                var as = { $type: i2.Point_$type, x: t.x + (al * ao - an * ap), y: t.y + (al * ap + an * ao) };
                var at = { $type: i2.Point_$type, x: t.x + (ak * ao - an * ap), y: t.y + (ak * ap + an * ao) };
                var au = new i2.PathGeometry();
                var av = new i2.PathFigure();
                av._startPoint = aq;
                av._isClosed = true;
                var aw = new i2.PolyLineSegment();
                aw._points.add(ar);
                aw._points.add(as);
                aw._points.add(at);
                av._segments.add(aw);
                au.c.add(av);
                aj.ak = au;
                this.rd.ad(aj, false, false, false, false);
            }
            i.c1.count = c.count;
            this.tf.c6();
        };
        RadialColumnSeries.$t = i2.markType(RadialColumnSeries, 'RadialColumnSeries', AnchoredRadialSeries.$);
        RadialColumnSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RadialColumnSeries, 'raisePropertyChanged', ['RadiusX:tg:tk', [1, 0], 'RadiusY:th:tl', [1, 0]]);
        return RadialColumnSeries;
    }(AnchoredRadialSeries));
    /**
     * @hidden
     */
    var RadialColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialColumnSeriesView, _super);
        function RadialColumnSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c1 = null;
            _this.c2 = null;
            _this.c8 = new i2.Path();
            _this.c0 = a;
            _this.c1 = ((function () {
                var $ret = new i2.Pool$1(i2.Path.$);
                $ret.create = i2.runOn(_this, _this.c9);
                $ret.activate = i2.runOn(_this, _this.c3);
                $ret.disactivate = i2.runOn(_this, _this.c5);
                $ret.destroy = i2.runOn(_this, _this.c4);
                return $ret;
            })());
            return _this;
        }
        RadialColumnSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.c2 = new i2.List$1(i2.Path.$, 0);
            if (!this.q) {
                this.cr.pr = Defaults.c;
                this.cr.gh = Defaults.h;
                this.cr.gm = Defaults.i;
            }
        };
        RadialColumnSeriesView.prototype.c9 = function () {
            var a = new i2.Path();
            this.c2.add(a);
            a._visibility = 1;
            return a;
        };
        RadialColumnSeriesView.prototype.c3 = function (a) {
            a._visibility = 0;
        };
        RadialColumnSeriesView.prototype.c5 = function (a) {
            a._visibility = 1;
        };
        RadialColumnSeriesView.prototype.c4 = function (a) {
            this.c2.remove(a);
        };
        RadialColumnSeriesView.prototype.c7 = function (a, b, c, d, e, f) {
            this.aq();
        };
        RadialColumnSeriesView.prototype.be = function (a, b) {
            _super.prototype.be.call(this, a, b);
            var c = a;
        };
        RadialColumnSeriesView.prototype.bf = function (a, b) {
            _super.prototype.bf.call(this, a, b);
            var c = a;
        };
        RadialColumnSeriesView.prototype.ac = function (a) {
            return this.c2._inner[a];
        };
        RadialColumnSeriesView.prototype.ab = function (a) {
            var b = this.c2._inner[a];
            this.c8._visibility = b._visibility;
            this.c8.ak = b.ak;
            var c = this.bp(a);
            this.c8._fill = c;
            this.c8._stroke = c;
            this.c8.ac = this.e.fl + 3;
            return this.c8;
        };
        RadialColumnSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.c2.count; c++) {
                    var d = this.aa(c, b);
                    this.bd(d, c, b);
                    a.s(d);
                }
            }
        };
        RadialColumnSeriesView.prototype.al = function (a) {
            var e_1, _a;
            _super.prototype.al.call(this, a);
            var b = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c1.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    this.e.a6.exportPathData(a, c, "column" + b, ["Main", "Fill"]);
                    b++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        RadialColumnSeriesView.prototype.c6 = function () {
            this.aq();
        };
        RadialColumnSeriesView.$t = i2.markType(RadialColumnSeriesView, 'RadialColumnSeriesView', AnchoredRadialSeriesView.$);
        return RadialColumnSeriesView;
    }(AnchoredRadialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent radial column series.
     * Compare values across categories by using radial rectangles.
    */
    var IgxRadialColumnSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRadialColumnSeriesComponent, _super);
        function IgxRadialColumnSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxRadialColumnSeriesComponent.prototype.createImplementation = function () {
            return new RadialColumnSeries();
        };
        Object.defineProperty(IgxRadialColumnSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialColumnSeriesComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialColumnSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialColumnSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.tg;
            },
            set: function (v) {
                this.i.tg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialColumnSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.th;
            },
            set: function (v) {
                this.i.th = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * When overridden in a derived class, is invoked whenever application code or internal processes
         * call ApplyTemplate.
        
        */
        IgxRadialColumnSeriesComponent.prototype.onApplyTemplate = function () {
            this.i.ac();
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxRadialColumnSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxRadialColumnSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRadialColumnSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRadialColumnSeriesComponent, selector: "igx-radial-column-series", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRadialColumnSeriesComponent;
    }(IgxAnchoredRadialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-radial-column-series',
                        template: "",
                        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialColumnSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialColumnSeriesModule() {
        }
        IgxRadialColumnSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialColumnSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesModule, declarations: [IgxRadialColumnSeriesComponent], imports: [i1.CommonModule], exports: [IgxRadialColumnSeriesComponent] });
        IgxRadialColumnSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesModule, imports: [[i1.CommonModule]] });
        return IgxRadialColumnSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRadialColumnSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxRadialColumnSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialColumnSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialColumnSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRadialColumnSeriesComponent", IgxRadialColumnSeriesComponent);
            i2.TypeRegistrar.register("RadialColumnSeries", RadialColumnSeries.$type);
        }
        IgxRadialColumnSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialColumnSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesDynamicModule, imports: [i1.CommonModule, IgxRadialColumnSeriesModule], exports: [IgxRadialColumnSeriesModule] });
        IgxRadialColumnSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesDynamicModule, imports: [[i1.CommonModule, IgxRadialColumnSeriesModule], IgxRadialColumnSeriesModule] });
        return IgxRadialColumnSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialColumnSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRadialColumnSeriesModule],
                        exports: [IgxRadialColumnSeriesModule],
                        entryComponents: [IgxRadialColumnSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialLineSeries, _super);
        function RadialLineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = RadialLineSeries.$;
            return _this;
        }
        RadialLineSeries.prototype.get_dv = function () {
            return true;
        };
        RadialLineSeries.prototype.bu = function () {
            return new RadialLineSeriesView(this);
        };
        RadialLineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.tf = a;
        };
        RadialLineSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
        };
        RadialLineSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        RadialLineSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.c1();
        };
        RadialLineSeries.prototype.r4 = function (a, b) {
            _super.prototype.r4.call(this, a, b);
            var c = b.bv;
            var d = b.bu;
            var e = a.f;
            var f = e.count;
            var g = new i2.List$1(i2.Array_$type, 2, f);
            var h = 0;
            for (var i = 0; i < f; i++) {
                var j = new Array(4);
                g.add(j);
                j[0] = this.q7.d(a.f._inner[i][0], a.f._inner[i][1], c, d);
                j[1] = this.q7.e(a.f._inner[i][0], a.f._inner[i][1], c, d);
                j[2] = this.q7.d(a.f._inner[i][0], a.f._inner[i][2], c, d);
                var k = a.f._inner[i][2];
                j[3] = this.q7.e(a.f._inner[i][0], k, c, d);
                if (k > h) {
                    h = k;
                }
            }
            var l = this.getEffectiveViewport1(b);
            this.rd.a0(this, this.rp(), i2.runOn(this, this.qw), this.rr(b), this.rs(b));
            var m = false;
            var n = this.rd.b;
            if (n != null) {
                m = true;
            }
            if (m) {
                var o = new ScalerParams(0, b.bv, b.bu, this.qz.cc, l);
                this.sz(e, -1, this.si.count, this.qz, o, b.q);
            }
            var p = b;
            var q = p.da;
            var r = p.db;
            var s = p.c9;
            this.rd.ad(q, true, false, true, false);
            this.rd.ad(r, true, false, true, false);
            this.rd.ad(s, false, true, false, false);
            s._opacity = 0.75 * this.rd.j;
            p.c2(f, g, false, this.tg, this.sb(g, f - 1, b), p.cs.b, this.gh);
        };
        RadialLineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case RadialLineSeries.$$p[0]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        RadialLineSeries.prototype.get_sl = function () {
            return true;
        };
        RadialLineSeries.$t = i2.markType(RadialLineSeries, 'RadialLineSeries', AnchoredRadialSeries.$);
        RadialLineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RadialLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:tg:ti', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return RadialLineSeries;
    }(AnchoredRadialSeries));
    /**
     * @hidden
     */
    var RadialLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialLineSeriesView, _super);
        function RadialLineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c7 = new i2.Path();
            _this.c6 = new i2.Path();
            _this.c8 = new i2.Path();
            _this.c4 = new i2.Path();
            _this.c3 = new i2.Path();
            _this.c5 = new i2.Path();
            _this.c0 = a;
            return _this;
        }
        RadialLineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
        };
        Object.defineProperty(RadialLineSeriesView.prototype, "da", {
            get: function () {
                return this.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialLineSeriesView.prototype, "db", {
            get: function () {
                return this.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RadialLineSeriesView.prototype, "c9", {
            get: function () {
                return this.c6;
            },
            enumerable: false,
            configurable: true
        });
        RadialLineSeriesView.prototype.c1 = function () {
            this.c7.ak = null;
            this.c6.ak = null;
            this.c8.ak = null;
            this.c4.ak = null;
            this.c3.ak = null;
            this.c5.ak = null;
            this.aq();
        };
        RadialLineSeriesView.prototype.c2 = function (a, b, c, d, e, f, g) {
            this.cw.sd.m(this.c7, this.c6, this.c8, a, b, c, d, e, f, g);
            this.aq();
        };
        RadialLineSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        RadialLineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.c3.ak = this.c6.ak;
            this.c4.ak = this.c7.ak;
            this.c5.ak = this.c8.ak;
            this.c4._stroke = a;
            this.c4.ac = this.e.fl + 3;
            this.c5._stroke = a;
            this.c5.ac = this.e.fl + 3;
            this.c3._fill = a;
            this.c3._opacity = 1;
        };
        RadialLineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.c3);
                    a.s(this.c4);
                    a.s(this.c5);
                }
                else {
                    a.s(this.c6);
                    a.s(this.c7);
                    a.s(this.c8);
                }
            }
        };
        RadialLineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.c7, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.c8, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.c6, "translucentShape", ["Translucent"]);
        };
        RadialLineSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        RadialLineSeriesView.$t = i2.markType(RadialLineSeriesView, 'RadialLineSeriesView', AnchoredRadialSeriesView.$);
        return RadialLineSeriesView;
    }(AnchoredRadialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent radial line series.
    */
    var IgxRadialLineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRadialLineSeriesComponent, _super);
        function IgxRadialLineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxRadialLineSeriesComponent.prototype.createImplementation = function () {
            return new RadialLineSeries();
        };
        Object.defineProperty(IgxRadialLineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialLineSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialLineSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
            get: function () {
                return this.i.tg;
            },
            set: function (v) {
                this.i.tg = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * When overridden in a derived class, is invoked whenever application code or internal processes
         * call ApplyTemplate.
        
        */
        IgxRadialLineSeriesComponent.prototype.onApplyTemplate = function () {
            this.i.ac();
        };
        IgxRadialLineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRadialLineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRadialLineSeriesComponent, selector: "igx-radial-line-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRadialLineSeriesComponent;
    }(IgxAnchoredRadialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-radial-line-series',
                        template: "",
                        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialLineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialLineSeriesModule() {
        }
        IgxRadialLineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialLineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesModule, declarations: [IgxRadialLineSeriesComponent], imports: [i1.CommonModule], exports: [IgxRadialLineSeriesComponent] });
        IgxRadialLineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxRadialLineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRadialLineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxRadialLineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialLineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialLineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRadialLineSeriesComponent", IgxRadialLineSeriesComponent);
            i2.TypeRegistrar.register("RadialLineSeries", RadialLineSeries.$type);
        }
        IgxRadialLineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialLineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesDynamicModule, imports: [i1.CommonModule, IgxRadialLineSeriesModule], exports: [IgxRadialLineSeriesModule] });
        IgxRadialLineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesDynamicModule, imports: [[i1.CommonModule, IgxRadialLineSeriesModule], IgxRadialLineSeriesModule] });
        return IgxRadialLineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialLineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRadialLineSeriesModule],
                        exports: [IgxRadialLineSeriesModule],
                        entryComponents: [IgxRadialLineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SliceCoords = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceCoords, _super);
        function SliceCoords() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.f = null;
            _this.h = null;
            _this.j = null;
            _this.e = null;
            _this.g = null;
            _this.i = null;
            _this.k = null;
            _this.c = false;
            _this.n = new i2.Size();
            _this.m = new i2.Size();
            _this.l = new i2.Size();
            return _this;
        }
        SliceCoords.b = function (a, b, c, d, e, f, g) {
            var h = Math.min(c, d);
            var i = Math.max(c, d);
            var j = Math.cos(h);
            var k = Math.sin(h);
            var l = Math.max(0, e);
            var m = f;
            var n = g.x + j * l;
            var o = g.y + k * l;
            var p = g.x + j * m;
            var q = g.y + k * m;
            var r = Math.cos(i);
            var s = Math.sin(i);
            var t = g.x + r * l;
            var u = g.y + s * l;
            var v = g.x + r * m;
            var w = g.y + s * m;
            n = ViewportUtils.c(n, a, b);
            o = ViewportUtils.f(o, a, b);
            p = ViewportUtils.c(p, a, b);
            q = ViewportUtils.f(q, a, b);
            t = ViewportUtils.c(t, a, b);
            u = ViewportUtils.f(u, a, b);
            v = ViewportUtils.c(v, a, b);
            w = ViewportUtils.f(w, a, b);
            var x = { $type: i2.Point_$type, x: n, y: o };
            var y = { $type: i2.Point_$type, x: p, y: q };
            var z = { $type: i2.Point_$type, x: v, y: w };
            var aa = { $type: i2.Point_$type, x: t, y: u };
            var ab = ViewportUtils.d(m, a, b);
            var ac = ViewportUtils.g(m, a, b);
            var ad = ViewportUtils.d(l, a, b);
            var ae = ViewportUtils.g(l, a, b);
            return ((function () {
                var $ret = new SliceCoords();
                $ret.d = x;
                $ret.f = y;
                $ret.h = z;
                $ret.j = aa;
                $ret.c = ((i - h) > Math.PI);
                $ret.n = new i2.Size(1, ab, ac);
                $ret.m = new i2.Size(1, ad, ae);
                return $ret;
            })());
        };
        SliceCoords.a = function (a, b, c, d, e, f, g, h, i) {
            var j = ViewportUtils.b(i, a, b);
            var k = f - e;
            if (k < 0) {
                return null;
            }
            if (ViewportUtils.d(k, a, b) < 2) {
                return null;
            }
            if (j * 2 > k) {
                j = k / 2;
                i = ViewportUtils.d(j, a, b);
            }
            var l = ViewportUtils.b(h, a, b);
            var m = l / (f - j);
            var n = Math.atan(m);
            if (n * 2 > Math.abs(d - c)) {
                n = Math.abs(d - c) / 2;
                h = ViewportUtils.d(Math.tan(n) * (f - j), a, b);
            }
            var o = SliceCoords.b(a, b, c + n, d - n, e, f, g);
            var p = SliceCoords.b(a, b, c, d, e + (j * (e / f)), f - j, g);
            o.g = o.f;
            o.k = o.j;
            o.e = p.d;
            o.f = p.f;
            o.i = p.h;
            o.j = p.j;
            o.l = new i2.Size(1, h, i);
            return o;
        };
        SliceCoords.$t = i2.markType(SliceCoords, 'SliceCoords');
        return SliceCoords;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RadialPieSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialPieSeries, _super);
        function RadialPieSeries() {
            var _this = _super.call(this) || this;
            _this.ab = RadialPieSeries.$;
            return _this;
        }
        RadialPieSeries.prototype.get_dy = function () {
            return true;
        };
        RadialPieSeries.prototype.get_dw = function () {
            return true;
        };
        RadialPieSeries.prototype.bu = function () {
            return new RadialPieSeriesView(this);
        };
        RadialPieSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.tf = a;
        };
        RadialPieSeries.prototype.preferredCategoryMode = function (a) {
            return a != null && a == this.qz ? 2 : 0;
        };
        RadialPieSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a && c.c1 != null) {
                c.c1.count = 0;
            }
        };
        RadialPieSeries.prototype.f1 = function () {
            return this.qz.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        RadialPieSeries.prototype.get_cy = function () {
            return true;
        };
        RadialPieSeries.prototype.r4 = function (a, b) {
            _super.prototype.r4.call(this, a, b);
            var c = b;
            var d = b.bv;
            var e = b.bu;
            var f = this.getEffectiveViewport1(b);
            var g = this.o7(b);
            var h = this.q6.j7(e, d, f, g);
            var i = a.f;
            var j = this.q6;
            var k = Math.max(0, 0.5 * j.l9);
            var l = k;
            l = Math.max(l, h.minLength);
            var m = this.qz.ki(d, e, f);
            var n = { $type: i2.Point_$type, x: 0.5, y: 0.5 };
            var o = this.tg;
            var p = this.th;
            var q = (o > 0 && p > 0);
            var r = this.si.count;
            this.rd.a0(this, this.rp(), i2.runOn(this, this.qw), this.rr(b), this.rs(b));
            this.rd.r = this.tg;
            this.rd.s = this.th;
            this.rd.k = this.tg;
            this.rd.l = this.th;
            var s = false;
            var t = this.rd.b;
            if (t != null) {
                s = true;
            }
            var u = this.qz;
            var v = new ScalerParams(1, b.bv, b.bu, u.cc);
            v.c = this.getEffectiveViewport();
            var w = 0;
            for (var x = 0; x < i.count; ++x) {
                var y = c.c1.item(x);
                var z = i._inner[x][0];
                var aa = Math.min(i._inner[x][2], h.maxLength);
                if (s) {
                    this.sz(i, x, r, u, v, b.q);
                }
                var ab = this.rd.k;
                var ac = this.rd.l;
                q = (ab > 0 && ac > 0);
                var ad = null;
                if (q) {
                    ad = this.tm(d, e, z - (m * 0.5), z + (m * 0.5), l, aa, n, ab, ac);
                }
                else {
                    ad = this.tn(d, e, z - (m * 0.5), z + (m * 0.5), l, aa, n);
                }
                y.ak = ad;
                this.rd.ad(y, false, false, false, false);
                var ae = i._inner[x][2];
                if (ae > w) {
                    w = ae;
                }
            }
            c.cu = ViewportUtils.d(w, d, e);
            c.cv = { $type: i2.Point_$type, x: ViewportUtils.c(n.x, d, e), y: ViewportUtils.f(n.y, d, e) };
            c.c1.count = i.count;
            c.c6();
        };
        RadialPieSeries.prototype.tn = function (a, b, c, d, e, f, g) {
            var h = SliceCoords.b(a, b, c, d, e, f, g);
            var i = new i2.PathFigure();
            i._startPoint = h.d;
            i._isClosed = true;
            i._segments.add(((function () {
                var $ret = new i2.LineSegment(1);
                $ret.c = h.f;
                return $ret;
            })()));
            i._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = h.h;
                $ret.f = h.n;
                $ret.d = 1;
                $ret.b = h.c;
                return $ret;
            })()));
            i._segments.add(((function () {
                var $ret = new i2.LineSegment(1);
                $ret.c = h.j;
                return $ret;
            })()));
            i._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = h.d;
                $ret.f = h.m;
                $ret.d = 0;
                $ret.b = h.c;
                return $ret;
            })()));
            var j = new i2.PathGeometry();
            j.c.add(i);
            return j;
        };
        RadialPieSeries.prototype.tm = function (a, b, c, d, e, f, g, h, i) {
            var j = SliceCoords.a(a, b, c, d, e, f, g, h, i);
            if (j == null) {
                return this.tn(a, b, c, d, e, f, g);
            }
            var k = new i2.PathFigure();
            k._startPoint = j.d;
            k._isClosed = true;
            var l = ((c + ((d - c) * 0.5)) * 180 / Math.PI) + 90;
            var m = new i2.Size(1, j.l.width * (e / f), j.l.height * (e / f));
            k._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = j.e;
                $ret.f = m;
                $ret.c = l;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.LineSegment(1);
                $ret.c = j.f;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = j.g;
                $ret.f = j.l;
                $ret.c = l;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = j.h;
                $ret.f = j.n;
                $ret.d = 1;
                $ret.b = j.c;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = j.i;
                $ret.f = j.l;
                $ret.c = l;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.LineSegment(1);
                $ret.c = j.j;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = j.k;
                $ret.f = m;
                $ret.c = l;
                $ret.d = 1;
                $ret.b = false;
                return $ret;
            })()));
            k._segments.add(((function () {
                var $ret = new i2.ArcSegment();
                $ret.e = j.d;
                $ret.f = j.m;
                $ret.d = 0;
                $ret.b = j.c;
                return $ret;
            })()));
            var n = new i2.PathGeometry();
            n.c.add(k);
            return n;
        };
        RadialPieSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case RadialPieSeries.$$p[0]:
                case RadialPieSeries.$$p[1]:
                    this.lj();
                    break;
            }
        };
        RadialPieSeries.$t = i2.markType(RadialPieSeries, 'RadialPieSeries', AnchoredRadialSeries.$);
        RadialPieSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, RadialPieSeries, 'raisePropertyChanged', ['RadiusX:tg:tk', [1, 2], 'RadiusY:th:tl', [1, 2]]);
        return RadialPieSeries;
    }(AnchoredRadialSeries));
    /**
     * @hidden
     */
    var RadialPieSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RadialPieSeriesView, _super);
        function RadialPieSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c1 = null;
            _this.c2 = null;
            _this.c7 = new i2.Path();
            _this.c0 = a;
            _this.c1 = ((function () {
                var $ret = new i2.Pool$1(i2.Path.$);
                $ret.create = i2.runOn(_this, _this.c8);
                $ret.activate = i2.runOn(_this, _this.c3);
                $ret.disactivate = i2.runOn(_this, _this.c5);
                $ret.destroy = i2.runOn(_this, _this.c4);
                return $ret;
            })());
            return _this;
        }
        RadialPieSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.c2 = new i2.List$1(i2.Path.$, 0);
            if (!this.q) {
                this.cr.pr = Defaults.c;
                this.cr.gh = Defaults.h;
                this.cr.gm = Defaults.i;
            }
        };
        RadialPieSeriesView.prototype.c8 = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new i2.Path();
                $ret.dataContext = ((function () {
                    var $ret = new i2.DataContext();
                    $ret.series = _this.e;
                    return $ret;
                })());
                return $ret;
            })());
            this.c2.add(a);
            a._visibility = 1;
            return a;
        };
        RadialPieSeriesView.prototype.c3 = function (a) {
            a._visibility = 0;
        };
        RadialPieSeriesView.prototype.c5 = function (a) {
            a._visibility = 1;
        };
        RadialPieSeriesView.prototype.c4 = function (a) {
            this.c2.remove(a);
        };
        RadialPieSeriesView.prototype.be = function (a, b) {
            _super.prototype.be.call(this, a, b);
            var c = a;
        };
        RadialPieSeriesView.prototype.ac = function (a) {
            return this.c2._inner[a];
        };
        RadialPieSeriesView.prototype.ab = function (a) {
            var b = this.c2._inner[a];
            this.c7._visibility = b._visibility;
            this.c7.ak = b.ak;
            var c = this.bp(a);
            this.c7._fill = c;
            this.c7._stroke = c;
            this.c7.ac = this.e.fl;
            return this.c7;
        };
        RadialPieSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.c2.count; c++) {
                    var d = this.aa(c, b);
                    a.s(d);
                }
            }
        };
        RadialPieSeriesView.prototype.c6 = function () {
            this.aq();
        };
        RadialPieSeriesView.prototype.al = function (a) {
            var e_1, _a;
            _super.prototype.al.call(this, a);
            var b = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c1.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    this.e.a6.exportPathData(a, c, "slice" + b, ["Main", "Fill"]);
                    b++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        RadialPieSeriesView.$t = i2.markType(RadialPieSeriesView, 'RadialPieSeriesView', AnchoredRadialSeriesView.$);
        return RadialPieSeriesView;
    }(AnchoredRadialSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent radial pie series.
     * Compare values across categories by using radial pie slices.
    */
    var IgxRadialPieSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxRadialPieSeriesComponent, _super);
        function IgxRadialPieSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxRadialPieSeriesComponent.prototype.createImplementation = function () {
            return new RadialPieSeries();
        };
        Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "isPie", {
            /**
             * Gets whether the current series shows a pie shape.
            */
            get: function () {
                return this.i.dy;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.tg;
            },
            set: function (v) {
                this.i.tg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.th;
            },
            set: function (v) {
                this.i.th = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxRadialPieSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxRadialPieSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxRadialPieSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxRadialPieSeriesComponent, selector: "igx-radial-pie-series", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxRadialPieSeriesComponent;
    }(IgxAnchoredRadialSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-radial-pie-series',
                        template: "",
                        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxRadialPieSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialPieSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialPieSeriesModule() {
        }
        IgxRadialPieSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialPieSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesModule, declarations: [IgxRadialPieSeriesComponent], imports: [i1.CommonModule], exports: [IgxRadialPieSeriesComponent] });
        IgxRadialPieSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesModule, imports: [[i1.CommonModule]] });
        return IgxRadialPieSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxRadialPieSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxRadialPieSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxRadialPieSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxRadialPieSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxRadialPieSeriesComponent", IgxRadialPieSeriesComponent);
            i2.TypeRegistrar.register("RadialPieSeries", RadialPieSeries.$type);
        }
        IgxRadialPieSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxRadialPieSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesDynamicModule, imports: [i1.CommonModule, IgxRadialPieSeriesModule], exports: [IgxRadialPieSeriesModule] });
        IgxRadialPieSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesDynamicModule, imports: [[i1.CommonModule, IgxRadialPieSeriesModule], IgxRadialPieSeriesModule] });
        return IgxRadialPieSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxRadialPieSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxRadialPieSeriesModule],
                        exports: [IgxRadialPieSeriesModule],
                        entryComponents: [IgxRadialPieSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartRadialModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartRadialModule() {
        }
        IgxDataChartRadialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartRadialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialModule, imports: [i1.CommonModule, IgxRadialAreaSeriesModule,
                IgxRadialColumnSeriesModule,
                IgxRadialLineSeriesModule,
                IgxRadialPieSeriesModule,
                IgxDataChartRadialCoreModule], exports: [IgxRadialAreaSeriesModule,
                IgxRadialColumnSeriesModule,
                IgxRadialLineSeriesModule,
                IgxRadialPieSeriesModule,
                IgxDataChartRadialCoreModule] });
        IgxDataChartRadialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialModule, imports: [[i1.CommonModule, IgxRadialAreaSeriesModule,
                    IgxRadialColumnSeriesModule,
                    IgxRadialLineSeriesModule,
                    IgxRadialPieSeriesModule,
                    IgxDataChartRadialCoreModule
                ], IgxRadialAreaSeriesModule,
                IgxRadialColumnSeriesModule,
                IgxRadialLineSeriesModule,
                IgxRadialPieSeriesModule,
                IgxDataChartRadialCoreModule] });
        return IgxDataChartRadialModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxRadialAreaSeriesModule,
                            IgxRadialColumnSeriesModule,
                            IgxRadialLineSeriesModule,
                            IgxRadialPieSeriesModule,
                            IgxDataChartRadialCoreModule
                        ],
                        imports: [i1.CommonModule, IgxRadialAreaSeriesModule,
                            IgxRadialColumnSeriesModule,
                            IgxRadialLineSeriesModule,
                            IgxRadialPieSeriesModule,
                            IgxDataChartRadialCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartRadialDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartRadialDynamicModule() {
        }
        IgxDataChartRadialDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartRadialDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialDynamicModule, imports: [i1.CommonModule, IgxRadialAreaSeriesDynamicModule,
                IgxRadialColumnSeriesDynamicModule,
                IgxRadialLineSeriesDynamicModule,
                IgxRadialPieSeriesDynamicModule,
                IgxDataChartRadialCoreDynamicModule,
                IgxDataChartRadialModule], exports: [IgxRadialAreaSeriesDynamicModule,
                IgxRadialColumnSeriesDynamicModule,
                IgxRadialLineSeriesDynamicModule,
                IgxRadialPieSeriesDynamicModule,
                IgxDataChartRadialCoreDynamicModule,
                IgxDataChartRadialModule] });
        IgxDataChartRadialDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialDynamicModule, imports: [[i1.CommonModule, IgxRadialAreaSeriesDynamicModule,
                    IgxRadialColumnSeriesDynamicModule,
                    IgxRadialLineSeriesDynamicModule,
                    IgxRadialPieSeriesDynamicModule,
                    IgxDataChartRadialCoreDynamicModule,
                    IgxDataChartRadialModule
                ], IgxRadialAreaSeriesDynamicModule,
                IgxRadialColumnSeriesDynamicModule,
                IgxRadialLineSeriesDynamicModule,
                IgxRadialPieSeriesDynamicModule,
                IgxDataChartRadialCoreDynamicModule,
                IgxDataChartRadialModule] });
        return IgxDataChartRadialDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartRadialDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxRadialAreaSeriesDynamicModule,
                            IgxRadialColumnSeriesDynamicModule,
                            IgxRadialLineSeriesDynamicModule,
                            IgxRadialPieSeriesDynamicModule,
                            IgxDataChartRadialCoreDynamicModule,
                            IgxDataChartRadialModule
                        ],
                        imports: [i1.CommonModule, IgxRadialAreaSeriesDynamicModule,
                            IgxRadialColumnSeriesDynamicModule,
                            IgxRadialLineSeriesDynamicModule,
                            IgxRadialPieSeriesDynamicModule,
                            IgxDataChartRadialCoreDynamicModule,
                            IgxDataChartRadialModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalLogarithmicScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalLogarithmicScaler, _super);
        function HorizontalLogarithmicScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalLogarithmicScaler.prototype.q = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.ag(c, NumericScaler.ac, b.c, b.a);
                return c;
            }
            return this.ag(a, b.e, b.d, b.a);
        };
        HorizontalLogarithmicScaler.prototype.p = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.af(a, NumericScaler.ac, b.c, b.a);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.af(a, b.e, b.d, b.a);
        };
        HorizontalLogarithmicScaler.prototype.ag = function (a, b, c, d) {
            var e = b.left + b.width * (a - c.left) / c.width;
            if (d) {
                e = 1 - e;
            }
            return Math.exp(e * (this.ad - this.ae) + this.ae);
        };
        HorizontalLogarithmicScaler.prototype.af = function (a, b, c, d) {
            if (i2.isNaN_(a)) {
                return NaN;
            }
            var e = 0;
            if (a <= 0) {
                e = (Math.log(this.o) - this.ae) / (this.ad - this.ae);
            }
            else {
                e = (Math.log(a) - this.ae) / (this.ad - this.ae);
            }
            if (d) {
                e = 1 - e;
            }
            return c.left + c.width * (e - b.left) / b.width;
        };
        HorizontalLogarithmicScaler.$t = i2.markType(HorizontalLogarithmicScaler, 'HorizontalLogarithmicScaler', LogarithmicScaler.$);
        return HorizontalLogarithmicScaler;
    }(LogarithmicScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalLinearScaler, _super);
        function HorizontalLinearScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalLinearScaler.prototype.q = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
                c = (c * b.d.width) + b.d.left;
                c = this.ae(c, NumericScaler.ac, b.c, b.a);
                return c;
            }
            return this.ae(a, b.e, b.d, b.a);
        };
        HorizontalLinearScaler.prototype.p = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.ad(a, NumericScaler.ac, b.c, b.a);
                c = (c - b.d.left) / b.d.width;
                c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
                return c;
            }
            return this.ad(a, b.e, b.d, b.a);
        };
        HorizontalLinearScaler.prototype.v = function (a, b, c, d) {
            var e;
            var f = d.e;
            var g = d.d;
            var h = d.c;
            var i = d.a;
            var j = !h.isEmpty;
            var k = this.m;
            var l = this.o;
            var m = h.left;
            var n = h.width;
            var o = f.left;
            var p = f.width;
            var q = g.left;
            var r = g.width;
            var s = 0;
            var t = 1;
            var u = i2.ArrayAccessHelper.b(a);
            var v = false;
            if (u != null) {
                v = true;
            }
            for (var w = b; w < c; w++) {
                if (v) {
                    e = u[w];
                }
                else {
                    e = a.item(w);
                }
                if (j) {
                    var x = (e - l) / (k);
                    if (i) {
                        x = 1 - x;
                    }
                    x = m + n * (x - s) / t;
                    var y = (x - q) / r;
                    y = q + r * (y - o) / p;
                    if (v) {
                        u[w] = y;
                    }
                    else {
                        a.item(w, y);
                    }
                }
                else {
                    var z = (e - l) / (k);
                    if (i) {
                        z = 1 - z;
                    }
                    z = q + r * (z - o) / p;
                    if (v) {
                        u[w] = z;
                    }
                    else {
                        a.item(w, z);
                    }
                }
            }
        };
        HorizontalLinearScaler.prototype.ae = function (a, b, c, d) {
            var e = b.left + b.width * (a - c.left) / c.width;
            if (d) {
                e = 1 - e;
            }
            return this.o + e * (this.m);
        };
        HorizontalLinearScaler.prototype.ad = function (a, b, c, d) {
            var e = (a - this.o) / (this.m);
            if (d) {
                e = 1 - e;
            }
            return c.left + c.width * (e - b.left) / b.width;
        };
        HorizontalLinearScaler.$t = i2.markType(HorizontalLinearScaler, 'HorizontalLinearScaler', LinearScaler.$);
        return HorizontalLinearScaler;
    }(LinearScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FastHorizontalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FastHorizontalLinearScaler, _super);
        function FastHorizontalLinearScaler() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FastHorizontalLinearScaler.prototype.u = function (a, b, c, d, e) {
            var f;
            var g = e.e;
            var h = e.d;
            var i = e.c;
            var j = e.a;
            var k = !i.isEmpty;
            var l = this.m;
            var m = this.o;
            var n = i.left;
            var o = i.width;
            var p = g.left;
            var q = g.width;
            var r = h.left;
            var s = h.width;
            var t = 0;
            var u = 1;
            var v = i2.ArrayAccessHelper.a(a);
            var w = false;
            if (v != null) {
                w = true;
            }
            var x;
            for (var y = 0; y < b.count; y++) {
                x = b.item(y);
                for (var z = c; z < d; z++) {
                    if (w) {
                        f = v[z];
                    }
                    else {
                        f = a.item(z);
                    }
                    if (k) {
                        var aa = (f[x] - m) / (l);
                        if (j) {
                            aa = 1 - aa;
                        }
                        aa = n + o * (aa - t) / u;
                        var ab = (aa - r) / s;
                        ab = r + s * (ab - p) / q;
                        f[x] = ab;
                    }
                    else {
                        var ac = (f[x] - m) / (l);
                        if (j) {
                            ac = 1 - ac;
                        }
                        ac = r + s * (ac - p) / q;
                        f[x] = ac;
                    }
                }
            }
        };
        FastHorizontalLinearScaler.$t = i2.markType(FastHorizontalLinearScaler, 'FastHorizontalLinearScaler', HorizontalLinearScaler.$);
        return FastHorizontalLinearScaler;
    }(HorizontalLinearScaler));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumericXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericXAxis, _super);
        function NumericXAxis() {
            var _this = _super.call(this) || this;
            _this.ab = NumericXAxis.$;
            _this.j6 = _this.j4();
            return _this;
        }
        NumericXAxis.prototype.a3 = function () {
            return new NumericXAxisView(this);
        };
        NumericXAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.mm = a;
        };
        NumericXAxis.prototype.au = function () {
            if (this.cz) {
                return (i2.TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
            }
            else {
                return new HorizontalAxisLabelPanel();
            }
        };
        NumericXAxis.prototype.j4 = function () {
            var _this = this;
            var a = _super.prototype.j4.call(this);
            a.b.c = function (b) {
                if ((_this.ay == null || _this.ay.visibility == 0) && _this.ai != null) {
                    _this.av.bc = b;
                    if (_this.ay != null && (_this.ay.location == 4 || _this.ay.location == 5)) {
                        _this.bh.jq();
                    }
                }
            };
            a.k = function (b, c, d) { return _this.h1(c, d, b.z, b.b, false); };
            a.l = function (b, c, d, e) { return _this.h2(c, d, e, b.z); };
            a.m = function (b, c) {
                var d = b.y;
                var e = new ScalerParams(0, b.aa, b.z, _this.cd, d);
                return _this.d8(c, e);
            };
            a.q = function (b, c) { return true; };
            a.j = function (b) { return _this.g8(b.t, b.n, b.z, b.a, true); };
            a.e = function (b) {
                b.n = b.z.bottom;
                if (_this.ai != null && _this.ai.bh != null) {
                    var c = b.n;
                    var d = b.r;
                    var e = _this.hv(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                    c = e.p0;
                    d = e.p1;
                    b.n = c;
                    b.r = d;
                }
            };
            a.p = function (b, c, d) {
                var e = Math.round(c);
                return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
            };
            return a;
        };
        NumericXAxis.prototype.d8 = function (a, b) {
            if (this.l5 != null) {
                return this.l5.p(a, b);
            }
            return this.l4.p(a, b);
        };
        NumericXAxis.prototype.eb = function (a, b) {
            if (this.l5 != null) {
                return this.l5.q(a, b);
            }
            return this.l4.q(a, b);
        };
        NumericXAxis.prototype.g5 = function (a, b, c, d) {
            if (this.l5 != null) {
                this.l5.v(a, b, c, d);
                return;
            }
            this.l4.v(a, b, c, d);
        };
        NumericXAxis.prototype.g4 = function (a, b, c, d, e) {
            if (this.l5 != null) {
                this.l5.u(a, b, c, d, e);
                return;
            }
            this.l4.u(a, b, c, d, e);
        };
        NumericXAxis.prototype.g6 = function (a, b, c, d) {
            if (this.l5 != null) {
                this.l5.j(a, b, c, d);
                return;
            }
            this.l4.j(a, b, c, d);
        };
        NumericXAxis.prototype.mn = function (a, b) {
            if (this.bh == null || a == NaN || b == NaN) {
                return;
            }
            var c = this.ma(a, this);
            var d = this.ma(b, this);
            if (c == NaN || d == NaN) {
                return;
            }
            this.bh.pw = new i2.Rect(0, c, this.bh.pw.y, d - c, this.bh.pw.height);
        };
        NumericXAxis.prototype.j7 = function (a, b, c, d) {
            var e = d;
            var f = _super.prototype.j7.call(this, a, b, c, d);
            var g = new ScalerParams(0, b, a, this.cc, c);
            var h = NaN;
            var i = NaN;
            if (!this.cc && b.right == 1) {
                i = this.ku;
            }
            else if (this.cc && b.left == 0) {
                h = this.ku;
            }
            if (i2.isNaN_(h)) {
                h = this.eb(e.left, g);
            }
            if (i2.isNaN_(i)) {
                i = this.eb(e.right, g);
            }
            var j = Math.min(h, i);
            var k = Math.max(h, i);
            this.ky = j;
            this.kx = k;
            f.k.add(((function () {
                var $ret = new RangeInfo();
                $ret.d = j;
                $ret.c = k;
                $ret.b = e.width;
                return $ret;
            })()));
            return f;
        };
        NumericXAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = !b.isEmpty ? this.js : i2.Rect.empty;
            var d = this.jn();
            var e = this.jm();
            var f = this.j6.c(a, c, b, d, e);
            if (f != null) {
                this.kt = f.f.m;
                this.kw = f.f.l;
            }
        };
        NumericXAxis.prototype.h3 = function (a, b) {
            _super.prototype.h3.call(this, a, b);
            if (b.height != a.height) {
                this.cv();
            }
        };
        NumericXAxis.prototype.get_a1 = function () {
            return 0;
        };
        Object.defineProperty(NumericXAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        NumericXAxis.prototype.j9 = function () {
            if (this.kk) {
                return new HorizontalLogarithmicScaler();
            }
            switch (this.l3) {
                case 0: return new FastHorizontalLinearScaler();
                case 1: return new HorizontalLogarithmicScaler();
            }
            return null;
        };
        NumericXAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        NumericXAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        NumericXAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        NumericXAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        NumericXAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(NumericXAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        NumericXAxis.$t = i2.markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
        return NumericXAxis;
    }(StraightNumericAxisBase));
    /**
     * @hidden
     */
    var NumericXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumericXAxisView, _super);
        function NumericXAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bi = null;
            _this.bi = a;
            return _this;
        }
        NumericXAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.jb = AxisDefaults.h;
        };
        NumericXAxisView.$t = i2.markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
        return NumericXAxisView;
    }(StraightNumericAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent numeric X axis.
    *
    * The `IgxNumericXAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the X-axis. The location of labels varies according to the value in a data column that is mapped using the `XMemberPath` property of Scatter Series or `ValueMemberPath` property of Bar Series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-numeric-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		crossingAxis= "xAxis"
    * 		crossingValue= 700
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    var IgxNumericXAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxNumericXAxisComponent, _super);
        function IgxNumericXAxisComponent() {
            return _super.call(this) || this;
        }
        IgxNumericXAxisComponent.prototype.createImplementation = function () {
            return new NumericXAxis();
        };
        Object.defineProperty(IgxNumericXAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxNumericXAxisComponent.prototype.scrollRangeIntoView = function (minimum, maximum) {
            this.i.mn(minimum, maximum);
        };
        IgxNumericXAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxNumericXAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxNumericXAxisComponent, selector: "igx-numeric-x-axis", providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericXAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericXAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxNumericXAxisComponent;
    }(IgxStraightNumericAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-numeric-x-axis',
                        template: "",
                        providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericXAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxNumericXAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxNumericXAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericXAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericXAxisModule() {
        }
        IgxNumericXAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericXAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisModule, declarations: [IgxNumericXAxisComponent], imports: [i1.CommonModule], exports: [IgxNumericXAxisComponent] });
        IgxNumericXAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisModule, imports: [[i1.CommonModule]] });
        return IgxNumericXAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxNumericXAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxNumericXAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxNumericXAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxNumericXAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxNumericXAxisComponent", IgxNumericXAxisComponent);
            i2.TypeRegistrar.register("NumericXAxis", NumericXAxis.$type);
        }
        IgxNumericXAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxNumericXAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisDynamicModule, imports: [i1.CommonModule, IgxNumericXAxisModule], exports: [IgxNumericXAxisModule] });
        IgxNumericXAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisDynamicModule, imports: [[i1.CommonModule, IgxNumericXAxisModule], IgxNumericXAxisModule] });
        return IgxNumericXAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxNumericXAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxNumericXAxisModule],
                        exports: [IgxNumericXAxisModule],
                        entryComponents: [IgxNumericXAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartScatterCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartScatterCoreModule() {
        }
        IgxDataChartScatterCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartScatterCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreModule, imports: [i1.CommonModule, IgxNumericXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule], exports: [IgxNumericXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartScatterCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreModule, imports: [[i1.CommonModule, IgxNumericXAxisModule,
                    IgxNumericYAxisModule,
                    IgxDataChartCoreModule
                ], IgxNumericXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartScatterCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartScatterCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartScatterCoreDynamicModule() {
        }
        IgxDataChartScatterCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartScatterCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreDynamicModule, imports: [i1.CommonModule, IgxNumericXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartScatterCoreModule], exports: [IgxNumericXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartScatterCoreModule] });
        IgxDataChartScatterCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreDynamicModule, imports: [[i1.CommonModule, IgxNumericXAxisDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartScatterCoreModule
                ], IgxNumericXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartScatterCoreModule] });
        return IgxDataChartScatterCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartScatterCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartScatterCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISupportsSizeScale_$type = new i2.Type(null, 'ISupportsSizeScale');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SizeScale = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SizeScale, _super);
        function SizeScale() {
            var _this = _super.call(this) || this;
            _this._globalMinimum = 0;
            _this._globalMaximum = 0;
            _this.l = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.globalMinimum = NaN;
            _this.globalMaximum = NaN;
            _this.l = new i2.List$1(Series.$, 0);
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.y(a, b.propertyName, b.oldValue, b.newValue); });
            return _this;
        }
        Object.defineProperty(SizeScale.prototype, "globalMinimum", {
            get: function () {
                return this._globalMinimum;
            },
            set: function (a) {
                this._globalMinimum = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SizeScale.prototype, "globalMaximum", {
            get: function () {
                return this._globalMaximum;
            },
            set: function (a) {
                this._globalMaximum = a;
            },
            enumerable: false,
            configurable: true
        });
        SizeScale.prototype.getCurrentGlobalMinimum = function () {
            return this.globalMinimum;
        };
        SizeScale.prototype.getCurrentGlobalMaximum = function () {
            return this.globalMaximum;
        };
        SizeScale.prototype.x = function () {
            var e_1, _a;
            if (i2.isNaN_(this.globalMinimum) || i2.isNaN_(this.globalMaximum)) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.l)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var a = _c.value;
                        if (i2.typeCast(ISupportsSizeScale_$type, a) !== null) {
                            a.updateSizeScaleGlobals();
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        SizeScale.prototype.ab = function (a, b) {
            if (!i2.isNaN_(a) && !i2.isInfinity(a)) {
                if (i2.isNaN_(this.globalMinimum)) {
                    this.globalMinimum = a;
                }
                else {
                    this.globalMinimum = Math.min(a, this.globalMinimum);
                }
            }
            if (!i2.isNaN_(b) && !i2.isInfinity(b)) {
                if (i2.isNaN_(this.globalMaximum)) {
                    this.globalMaximum = b;
                }
                else {
                    this.globalMaximum = Math.max(b, this.globalMaximum);
                }
            }
        };
        SizeScale.prototype.aa = function () {
            this.globalMinimum = NaN;
            this.globalMaximum = NaN;
        };
        SizeScale.prototype.z = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        SizeScale.prototype.y = function (a, b, c, d) {
            var e_2, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.l)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    e.l0(false);
                    if (e.ca != null) {
                        e.k7();
                        e.k6();
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        SizeScale.$t = i2.markType(SizeScale, 'SizeScale', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type]);
        SizeScale.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, SizeScale, 'z', ['IsLogarithmic', [0, false], 'LogarithmBase', [1, 10], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);
        return SizeScale;
    }(i2.DependencyObject));

    /**
     * Represents a scale that is used determine an object's size.
    */
    var IgxSizeScaleComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxSizeScaleComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._propertyUpdated = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxSizeScaleComponent.prototype.createImplementation = function () {
            return new SizeScale();
        };
        IgxSizeScaleComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxSizeScaleComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxSizeScaleComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxSizeScaleComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxSizeScaleComponent.prototype, "globalMinimum", {
            /**
             * Gets or sets global minimum value that will be mapped to MinumumValue of this scale
            */
            get: function () {
                return this.i.globalMinimum;
            },
            set: function (v) {
                this.i.globalMinimum = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSizeScaleComponent.prototype, "globalMaximum", {
            /**
             * Gets or sets global maximum value that will be mapped to MaxumumValue of this scale
            */
            get: function () {
                return this.i.globalMaximum;
            },
            set: function (v) {
                this.i.globalMaximum = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSizeScaleComponent.prototype, "minimumValue", {
            /**
             * Gets or sets the minimum size (in pixels) for this scale.
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSizeScaleComponent.prototype, "maximumValue", {
            /**
             * Gets or sets the maximum size (in pixels) for this scale.
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSizeScaleComponent.prototype, "isLogarithmic", {
            /**
             * Gets or sets whether the scale is logarithmic.
            */
            get: function () {
                return this.i.isLogarithmic;
            },
            set: function (v) {
                this.i.isLogarithmic = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSizeScaleComponent.prototype, "logarithmBase", {
            /**
             * Gets or sets the logarithm base for this scale.
            */
            get: function () {
                return this.i.logarithmBase;
            },
            set: function (v) {
                this.i.logarithmBase = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxSizeScaleComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxSizeScaleComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxSizeScaleComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxSizeScaleComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("SizeScaleComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxSizeScaleComponent.prototype.getCurrentGlobalMinimum = function () {
            var iv = this.i.getCurrentGlobalMinimum();
            return (iv);
        };
        IgxSizeScaleComponent.prototype.getCurrentGlobalMaximum = function () {
            var iv = this.i.getCurrentGlobalMaximum();
            return (iv);
        };
        Object.defineProperty(IgxSizeScaleComponent.prototype, "propertyUpdated", {
            /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
            get: function () {
                var _this = this;
                if (this._propertyUpdated == null) {
                    this._propertyUpdated = new i0.EventEmitter();
                    this.i.propertyUpdated = i2.delegateCombine(this.i.propertyUpdated, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new i2.IgxPropertyUpdatedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePropertyUpdated) {
                                _this.beforePropertyUpdated(_this, outerArgs);
                            }
                            _this._propertyUpdated.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._propertyUpdated;
            },
            enumerable: false,
            configurable: true
        });
        IgxSizeScaleComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxSizeScaleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSizeScaleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSizeScaleComponent, selector: "igx-size-scale", inputs: { globalMinimum: "globalMinimum", globalMaximum: "globalMaximum", minimumValue: "minimumValue", maximumValue: "maximumValue", isLogarithmic: "isLogarithmic", logarithmBase: "logarithmBase" }, outputs: { propertyUpdated: "propertyUpdated" }, providers: [], ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSizeScaleComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-size-scale',
                        template: "",
                        providers: [],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { globalMinimum: [{
                    type: i0.Input
                }], globalMaximum: [{
                    type: i0.Input
                }], minimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }], isLogarithmic: [{
                    type: i0.Input
                }], logarithmBase: [{
                    type: i0.Input
                }], propertyUpdated: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSizeScaleModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSizeScaleModule() {
        }
        IgxSizeScaleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSizeScaleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleModule, declarations: [IgxSizeScaleComponent], imports: [i1.CommonModule], exports: [IgxSizeScaleComponent] });
        IgxSizeScaleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleModule, imports: [[i1.CommonModule]] });
        return IgxSizeScaleModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSizeScaleComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxSizeScaleComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSizeScaleDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSizeScaleDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxSizeScaleComponent", IgxSizeScaleComponent);
            i2.TypeRegistrar.register("SizeScale", SizeScale.$type);
        }
        IgxSizeScaleDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSizeScaleDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleDynamicModule, imports: [i1.CommonModule, IgxSizeScaleModule], exports: [IgxSizeScaleModule] });
        IgxSizeScaleDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleDynamicModule, imports: [[i1.CommonModule, IgxSizeScaleModule], IgxSizeScaleModule] });
        return IgxSizeScaleDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSizeScaleDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxSizeScaleModule],
                        exports: [IgxSizeScaleModule],
                        entryComponents: [IgxSizeScaleComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISupportsFillScale_$type = new i2.Type(null, 'ISupportsFillScale');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BrushScale, _super);
        function BrushScale() {
            var _this = _super.call(this) || this;
            _this.j = null;
            _this.o = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.q = 0;
            _this.p = 0;
            _this.o = new i2.List$1(Series.$, 0);
            _this.brushes = new i2.BrushCollection();
            var a = _this.brushes;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.r));
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (b, c) { return _this.u(b, c.propertyName, c.oldValue, c.newValue); });
            return _this;
        }
        BrushScale.prototype.r = function (a, b) {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.o)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.l0(false);
                    c.k0();
                    c.k7();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        };
        BrushScale.prototype.s = function () {
            var e_2, _a;
            if (i2.isNaN_(this.q) || i2.isNaN_(this.p)) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.o)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var a = _c.value;
                        if (i2.typeCast(ISupportsFillScale_$type, a) !== null) {
                            a.updateFillScaleGlobals();
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        };
        Object.defineProperty(BrushScale.prototype, "brushes", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                var b = this.j;
                if (this.j != null) {
                    var c = this.j;
                    c.collectionChanged = i2.delegateRemove(c.collectionChanged, i2.runOn(this, this.r));
                }
                this.j = a;
                if (this.j != null) {
                    var d = this.j;
                    d.collectionChanged = i2.delegateCombine(d.collectionChanged, i2.runOn(this, this.r));
                }
                this.notifySeries();
            },
            enumerable: false,
            configurable: true
        });
        BrushScale.prototype.registerSeries = function (a) {
            var b = this.o.contains(a);
            if (!b) {
                this.o.add(a);
            }
        };
        BrushScale.prototype.unregisterSeries = function (a) {
            var b = this.o.contains(a);
            if (b) {
                this.o.remove(a);
            }
        };
        BrushScale.prototype.getBrush = function (a) {
            if (this.brushes == null || a < 0 || a >= this.brushes.count) {
                return null;
            }
            return this.brushes.item(a);
        };
        BrushScale.prototype.get_isReady = function () {
            return true;
        };
        Object.defineProperty(BrushScale.prototype, "isReady", {
            get: function () {
                return this.get_isReady();
            },
            enumerable: false,
            configurable: true
        });
        BrushScale.prototype.ab = function (a) {
            if (this.brushes == null || this.brushes.count == 0 || a < 0) {
                return null;
            }
            return i2.BrushCollectionUtil.b(this.brushes, a);
        };
        BrushScale.prototype.v = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        BrushScale.prototype.u = function (a, b, c, d) {
            this.notifySeries();
        };
        BrushScale.prototype.notifySeries = function () {
            var e_3, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.o)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.k2();
                    a.l0(false);
                    a.k0();
                    a.k7();
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
        };
        BrushScale.prototype.z = function (a, b) {
            if (!i2.isNaN_(a) && !i2.isInfinity(a)) {
                if (i2.isNaN_(this.q)) {
                    this.q = a;
                }
                else {
                    this.q = Math.min(a, this.q);
                }
            }
            if (!i2.isNaN_(b) && !i2.isInfinity(b)) {
                if (i2.isNaN_(this.p)) {
                    this.p = b;
                }
                else {
                    this.p = Math.max(b, this.p);
                }
            }
        };
        BrushScale.prototype.x = function () {
            this.q = NaN;
            this.p = NaN;
        };
        BrushScale.prototype.get_isBrushScale = function () {
            return true;
        };
        Object.defineProperty(BrushScale.prototype, "isBrushScale", {
            get: function () {
                return this.get_isBrushScale();
            },
            enumerable: false,
            configurable: true
        });
        BrushScale.$t = i2.markType(BrushScale, 'BrushScale', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type]);
        return BrushScale;
    }(i2.DependencyObject));

    /**
     * Represents a base class for brush scales.
    */
    var IgxBrushScaleComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxBrushScaleComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._propertyUpdated = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxBrushScaleComponent.prototype.createImplementation = function () {
            return new BrushScale();
        };
        IgxBrushScaleComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxBrushScaleComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxBrushScaleComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxBrushScaleComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxBrushScaleComponent.prototype, "brushes", {
            /**
             * Gets the brushes collection used by this scale.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.brushes);
            },
            set: function (v) {
                this.i.brushes = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBrushScaleComponent.prototype, "isReady", {
            /**
             * Gets the status of the scale
            */
            get: function () {
                return this.i.isReady;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBrushScaleComponent.prototype, "isBrushScale", {
            /**
             * Checks if this item is a BrushScale
            */
            get: function () {
                return this.i.isBrushScale;
            },
            enumerable: false,
            configurable: true
        });
        IgxBrushScaleComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxBrushScaleComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxBrushScaleComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxBrushScaleComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("BrushScaleComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
         * Registers a series with the scale. Under normal circumstances you should not need to call this manually.
        
        * @param series  * The series to register with the scale.
        */
        IgxBrushScaleComponent.prototype.registerSeries = function (series) {
            this.i.registerSeries((series == null ? null : series.i));
        };
        /**
         * Unregisters a series with the scale. Under normal circumstances you should not need to call this manually.
        
        * @param series  * The series to unregister from the scale.
        */
        IgxBrushScaleComponent.prototype.unregisterSeries = function (series) {
            this.i.unregisterSeries((series == null ? null : series.i));
        };
        /**
         * Gets a brush from the brushes collection by index.
        
        */
        IgxBrushScaleComponent.prototype.getBrush = function (index) {
            var iv = this.i.getBrush(index);
            return i2.brushToString(iv);
        };
        /**
         * Notify attached series about changes to this scale
        
        */
        IgxBrushScaleComponent.prototype.notifySeries = function () {
            this.i.notifySeries();
        };
        Object.defineProperty(IgxBrushScaleComponent.prototype, "propertyUpdated", {
            /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
            get: function () {
                var _this = this;
                if (this._propertyUpdated == null) {
                    this._propertyUpdated = new i0.EventEmitter();
                    this.i.propertyUpdated = i2.delegateCombine(this.i.propertyUpdated, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new i2.IgxPropertyUpdatedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePropertyUpdated) {
                                _this.beforePropertyUpdated(_this, outerArgs);
                            }
                            _this._propertyUpdated.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._propertyUpdated;
            },
            enumerable: false,
            configurable: true
        });
        IgxBrushScaleComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxBrushScaleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxBrushScaleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxBrushScaleComponent, selector: "igx-brush-scale", inputs: { brushes: "brushes" }, outputs: { propertyUpdated: "propertyUpdated" }, providers: [], ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxBrushScaleComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-brush-scale',
                        template: "",
                        providers: [],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { brushes: [{
                    type: i0.Input
                }], propertyUpdated: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ValueBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ValueBrushScale, _super);
        function ValueBrushScale() {
            var _this = _super.call(this) || this;
            _this.ac = false;
            _this.ag = 10;
            return _this;
        }
        ValueBrushScale.prototype.getBrushByIndex = function (a, b) {
            if (b == null || this.brushes == null || this.brushes.count == 0 || a < 0 || a >= b.count) {
                return null;
            }
            if (b.count == 0) {
                return this.brushes.item(0);
            }
            var c = i2.isNaN_(this.minimumValue) || i2.isInfinity(this.minimumValue) ? b.minimum : this.minimumValue;
            var d = i2.isNaN_(this.maximumValue) || i2.isInfinity(this.maximumValue) ? b.maximum : this.maximumValue;
            var e = b.item(a);
            if (c == d) {
                return e == c ? this.brushes.item(0) : null;
            }
            return this.au(c, d, e);
        };
        ValueBrushScale.prototype.getBrushByValue = function (a, b) {
            if (b == null || this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (b.count <= 1) {
                return this.brushes.item(0);
            }
            var c = i2.isNaN_(this.minimumValue) || i2.isInfinity(this.minimumValue) ? b.minimum : this.minimumValue;
            var d = i2.isNaN_(this.maximumValue) || i2.isInfinity(this.maximumValue) ? b.maximum : this.maximumValue;
            if (a < c) {
                return null;
            }
            if (a > d) {
                return null;
            }
            return this.au(c, d, a);
        };
        ValueBrushScale.prototype.getBrushByRange = function (a, b, c) {
            if (this.brushes == null || this.brushes.count == 0 || i2.isNaN_(a)) {
                return null;
            }
            if (this.brushes.count == 1) {
                return this.brushes.item(0);
            }
            var d = i2.isNaN_(this.minimumValue) || i2.isInfinity(this.minimumValue) ? b : this.minimumValue;
            var e = i2.isNaN_(this.maximumValue) || i2.isInfinity(this.maximumValue) ? c : this.maximumValue;
            if (i2.isNaN_(d) || a < d) {
                return null;
            }
            if (i2.isNaN_(e) || a > e) {
                return null;
            }
            return this.au(d, e, a);
        };
        ValueBrushScale.prototype.au = function (a, b, c) {
            if (this.ac && this.ag > 0) {
                var d = i2.logBase(a, this.ag);
                var e = i2.logBase(b, this.ag);
                var f = i2.logBase(c, this.ag);
                return this.at(d, e, f);
            }
            return this.at(a, b, c);
        };
        ValueBrushScale.prototype.at = function (a, b, c) {
            if (c < a || c > b) {
                return null;
            }
            var d = (c - a) / (b - a);
            var e = d * (this.brushes.count - 1);
            return this.ab(e);
        };
        ValueBrushScale.prototype.get_isReady = function () {
            return this.brushes != null && this.brushes.count > 0;
        };
        ValueBrushScale.prototype.u = function (a, b, c, d) {
            switch (b) {
                case ValueBrushScale.$$p[1]:
                    this.ag = i2.typeGetValue(d);
                    break;
                case ValueBrushScale.$$p[0]:
                    this.ac = d;
                    break;
            }
            _super.prototype.u.call(this, a, b, c, d);
        };
        ValueBrushScale.$t = i2.markType(ValueBrushScale, 'ValueBrushScale', BrushScale.$);
        ValueBrushScale.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ValueBrushScale, 'v', ['IsLogarithmic', [0, false], 'LogarithmBase', [1, 10], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);
        return ValueBrushScale;
    }(BrushScale));

    /**
     * Represents a brush scale that uses value-based brush selection.
    */
    var IgxValueBrushScaleComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxValueBrushScaleComponent, _super);
        function IgxValueBrushScaleComponent() {
            return _super.call(this) || this;
        }
        IgxValueBrushScaleComponent.prototype.createImplementation = function () {
            return new ValueBrushScale();
        };
        Object.defineProperty(IgxValueBrushScaleComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueBrushScaleComponent.prototype, "minimumValue", {
            /**
             * Gets or sets the minimum value for this scale.
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueBrushScaleComponent.prototype, "maximumValue", {
            /**
             * Gets or sets the maximum value for this scale.
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueBrushScaleComponent.prototype, "isLogarithmic", {
            /**
             * Gets or sets whether the scale is logarithmic.
            */
            get: function () {
                return this.i.isLogarithmic;
            },
            set: function (v) {
                this.i.isLogarithmic = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueBrushScaleComponent.prototype, "logarithmBase", {
            /**
             * Gets or sets the logarithm base for this scale.
            */
            get: function () {
                return this.i.logarithmBase;
            },
            set: function (v) {
                this.i.logarithmBase = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxValueBrushScaleComponent.prototype, "isReady", {
            /**
             * Checks if the value brush scale is ready for usage in the chart
            */
            get: function () {
                return this.i.isReady;
            },
            enumerable: false,
            configurable: true
        });
        IgxValueBrushScaleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxValueBrushScaleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxValueBrushScaleComponent, selector: "igx-value-brush-scale", inputs: { minimumValue: "minimumValue", maximumValue: "maximumValue", isLogarithmic: "isLogarithmic", logarithmBase: "logarithmBase" }, providers: [{ provide: IgxBrushScaleComponent, useExisting: i0.forwardRef(function () { return IgxValueBrushScaleComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxValueBrushScaleComponent;
    }(IgxBrushScaleComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-value-brush-scale',
                        template: "",
                        providers: [{ provide: IgxBrushScaleComponent, useExisting: i0.forwardRef(function () { return IgxValueBrushScaleComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { minimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }], isLogarithmic: [{
                    type: i0.Input
                }], logarithmBase: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxValueBrushScaleModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxValueBrushScaleModule() {
        }
        IgxValueBrushScaleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxValueBrushScaleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleModule, declarations: [IgxValueBrushScaleComponent], imports: [i1.CommonModule], exports: [IgxValueBrushScaleComponent] });
        IgxValueBrushScaleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleModule, imports: [[i1.CommonModule]] });
        return IgxValueBrushScaleModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxValueBrushScaleComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxValueBrushScaleComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxValueBrushScaleDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxValueBrushScaleDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxValueBrushScaleComponent", IgxValueBrushScaleComponent);
            i2.TypeRegistrar.register("ValueBrushScale", ValueBrushScale.$type);
        }
        IgxValueBrushScaleDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxValueBrushScaleDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleDynamicModule, imports: [i1.CommonModule, IgxValueBrushScaleModule], exports: [IgxValueBrushScaleModule] });
        IgxValueBrushScaleDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleDynamicModule, imports: [[i1.CommonModule, IgxValueBrushScaleModule], IgxValueBrushScaleModule] });
        return IgxValueBrushScaleDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxValueBrushScaleDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxValueBrushScaleModule],
                        exports: [IgxValueBrushScaleModule],
                        entryComponents: [IgxValueBrushScaleComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available modes of interpolation on a color scale.
     */
    var ColorScaleInterpolationMode = /*@__PURE__*/ (function (ColorScaleInterpolationMode) {
        /**
         * Select one of the colors in the palette.
         */
        ColorScaleInterpolationMode[ColorScaleInterpolationMode["Select"] = 0] = "Select";
        /**
         * Interpolate between colors in the palette using RGB interpolation.
         */
        ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateRGB"] = 1] = "InterpolateRGB";
        /**
         * Interpolate between colors in the palette using HSV interpolation.
         */
        ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateHSV"] = 2] = "InterpolateHSV";
        return ColorScaleInterpolationMode;
    })({});
    /**
     * @hidden
     */
    var ColorScaleInterpolationMode_$type = i2.markEnum('ColorScaleInterpolationMode', 'Select,0|InterpolateRGB,1|InterpolateHSV,2');

    /**
     * Base class for classes which provide colors corresponding to numeric values within a known list of numeric values.
    */
    var IgxColorScaleComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxColorScaleComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._propertyUpdated = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxColorScaleComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxColorScaleComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxColorScaleComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxColorScaleComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxColorScaleComponent.prototype.onImplementationCreated = function () {
        };
        IgxColorScaleComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxColorScaleComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxColorScaleComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxColorScaleComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("ColorScaleComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        Object.defineProperty(IgxColorScaleComponent.prototype, "propertyUpdated", {
            /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
            get: function () {
                var _this = this;
                if (this._propertyUpdated == null) {
                    this._propertyUpdated = new i0.EventEmitter();
                    this.i.propertyUpdated = i2.delegateCombine(this.i.propertyUpdated, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new i2.IgxPropertyUpdatedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePropertyUpdated) {
                                _this.beforePropertyUpdated(_this, outerArgs);
                            }
                            _this._propertyUpdated.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._propertyUpdated;
            },
            enumerable: false,
            configurable: true
        });
        IgxColorScaleComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxColorScaleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColorScaleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxColorScaleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxColorScaleComponent, selector: "ng-component", outputs: { propertyUpdated: "propertyUpdated" }, ngImport: i0, template: "", isInline: true });
        return IgxColorScaleComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColorScaleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { propertyUpdated: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColorScale, _super);
        function ColorScale() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            return _this;
        }
        ColorScale.prototype.l = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        ColorScale.prototype.k = function (a, b, c, d) {
        };
        ColorScale.$t = i2.markType(ColorScale, 'ColorScale', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type]);
        return ColorScale;
    }(i2.DependencyObject));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CustomPaletteColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomPaletteColorScale, _super);
        function CustomPaletteColorScale() {
            var _this = _super.call(this) || this;
            _this.p = null;
            _this.ag = new i2.Color();
            _this.u = NaN;
            _this.t = NaN;
            _this.s = true;
            _this.r = true;
            _this.n = 0;
            _this.ag = i2.Color.u(0, 0, 0, 0);
            _this.p = new i2.ObservableColorCollection();
            var a = _this.p;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, i2.runOn(_this, _this.ab));
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (b, c) { return _this.k(b, c.propertyName, c.oldValue, c.newValue); });
            return _this;
        }
        Object.defineProperty(CustomPaletteColorScale.prototype, "palette", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                var b = this.p;
                if (this.p != null) {
                    var c = this.p;
                    c.collectionChanged = i2.delegateRemove(c.collectionChanged, i2.runOn(this, this.ab));
                }
                this.p = a;
                if (this.p != null) {
                    var d = this.p;
                    d.collectionChanged = i2.delegateCombine(d.collectionChanged, i2.runOn(this, this.ab));
                }
                this.l("Palette", b, this.palette);
            },
            enumerable: false,
            configurable: true
        });
        CustomPaletteColorScale.prototype.ab = function (a, b) {
            this.l("Palette", this.palette, this.palette);
        };
        CustomPaletteColorScale.prototype.k = function (a, b, c, d) {
            _super.prototype.k.call(this, a, b, c, d);
            switch (b) {
                case CustomPaletteColorScale.$$p[2]:
                    this.u = this.minimumValue;
                    this.s = i2.isNaN_(this.u);
                    break;
                case CustomPaletteColorScale.$$p[1]:
                    this.t = this.maximumValue;
                    this.r = i2.isNaN_(this.t);
                    break;
                case CustomPaletteColorScale.$$p[0]:
                    this.n = this.interpolationMode;
                    break;
            }
        };
        CustomPaletteColorScale.prototype.getColor = function (a, b, c, d) {
            if (((this.p == null) || (this.p.count == 0)) || d == null) {
                return this.ag;
            }
            var e = this.s ? b : this.u;
            var f = this.r ? c : this.t;
            var g = (a - e) / (f - e);
            if (i2.isNaN_(g) || g < 0 || g > 1) {
                return this.ag;
            }
            var h = g * (this.p.count - 1);
            if (this.n == 2 || this.n == 1) {
                var i = Math.floor(h);
                var j = Math.ceil(h);
                var k = this.p._inner[i2.truncate(i)];
                var l = this.p._inner[i2.truncate(j)];
                var m = h - i;
                var n = this.n == 2 ? 1 : 0;
                return i2.ColorUtil.u(k, m, l, n);
            }
            else {
                var o = i2.truncate(Math.round(h));
                return this.p._inner[o];
            }
        };
        CustomPaletteColorScale.prototype.providePalette = function (a) {
            var b = new i2.ObservableColorCollection();
            var _loop_1 = function (d) {
                var c = a[d];
                var e = ((function () {
                    var $ret = new i2.Color();
                    $ret.colorString = c;
                    return $ret;
                })());
                b.add(e);
            };
            for (var d = 0; d < a.length; d++) {
                _loop_1(d);
            }
            this.palette = b;
        };
        CustomPaletteColorScale.$t = i2.markType(CustomPaletteColorScale, 'CustomPaletteColorScale', ColorScale.$);
        CustomPaletteColorScale.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CustomPaletteColorScale, 'l', ['InterpolationMode', [ColorScaleInterpolationMode_$type, i2.enumGetBox(ColorScaleInterpolationMode_$type, 0)], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);
        return CustomPaletteColorScale;
    }(ColorScale));

    /**
     * ColorScale class for selecting a color from a given palette, or interpolating between adjacent colors in that palette.
    */
    var IgxCustomPaletteColorScaleComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCustomPaletteColorScaleComponent, _super);
        function IgxCustomPaletteColorScaleComponent() {
            return _super.call(this) || this;
        }
        IgxCustomPaletteColorScaleComponent.prototype.createImplementation = function () {
            return new CustomPaletteColorScale();
        };
        Object.defineProperty(IgxCustomPaletteColorScaleComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomPaletteColorScaleComponent.prototype, "minimumValue", {
            /**
             * The lowest value to assign a color.  Any given value less than this value will be made Transparent.
            */
            get: function () {
                return this.i.minimumValue;
            },
            set: function (v) {
                this.i.minimumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomPaletteColorScaleComponent.prototype, "maximumValue", {
            /**
             * The highest value to assign a color.  Any given value greater than this value will be made Transparent.
            */
            get: function () {
                return this.i.maximumValue;
            },
            set: function (v) {
                this.i.maximumValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomPaletteColorScaleComponent.prototype, "palette", {
            /**
             * A list of colors to select from or interpolate between.
            */
            get: function () {
                return i2.fromColorCollection(this.i.palette);
            },
            set: function (v) {
                this.i.palette = i2.toColorCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomPaletteColorScaleComponent.prototype, "interpolationMode", {
            /**
             * The approach to use when getting a color from the palette.
            */
            get: function () {
                return this.i.interpolationMode;
            },
            set: function (v) {
                this.i.interpolationMode = i2.ensureEnum(ColorScaleInterpolationMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxCustomPaletteColorScaleComponent.prototype.providePalette = function (colors) {
            this.i.providePalette(colors);
        };
        IgxCustomPaletteColorScaleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCustomPaletteColorScaleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCustomPaletteColorScaleComponent, selector: "igx-custom-palette-color-scale", inputs: { minimumValue: "minimumValue", maximumValue: "maximumValue", palette: "palette", interpolationMode: "interpolationMode" }, providers: [{ provide: IgxColorScaleComponent, useExisting: i0.forwardRef(function () { return IgxCustomPaletteColorScaleComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCustomPaletteColorScaleComponent;
    }(IgxColorScaleComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-custom-palette-color-scale',
                        template: "",
                        providers: [{ provide: IgxColorScaleComponent, useExisting: i0.forwardRef(function () { return IgxCustomPaletteColorScaleComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { minimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }], palette: [{
                    type: i0.Input
                }], interpolationMode: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomPaletteColorScaleModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomPaletteColorScaleModule() {
        }
        IgxCustomPaletteColorScaleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomPaletteColorScaleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleModule, declarations: [IgxCustomPaletteColorScaleComponent], imports: [i1.CommonModule], exports: [IgxCustomPaletteColorScaleComponent] });
        IgxCustomPaletteColorScaleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleModule, imports: [[i1.CommonModule]] });
        return IgxCustomPaletteColorScaleModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCustomPaletteColorScaleComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCustomPaletteColorScaleComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomPaletteColorScaleDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomPaletteColorScaleDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCustomPaletteColorScaleComponent", IgxCustomPaletteColorScaleComponent);
            i2.TypeRegistrar.register("CustomPaletteColorScale", CustomPaletteColorScale.$type);
        }
        IgxCustomPaletteColorScaleDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomPaletteColorScaleDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleDynamicModule, imports: [i1.CommonModule, IgxCustomPaletteColorScaleModule], exports: [IgxCustomPaletteColorScaleModule] });
        IgxCustomPaletteColorScaleDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleDynamicModule, imports: [[i1.CommonModule, IgxCustomPaletteColorScaleModule], IgxCustomPaletteColorScaleModule] });
        return IgxCustomPaletteColorScaleDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteColorScaleDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCustomPaletteColorScaleModule],
                        exports: [IgxCustomPaletteColorScaleModule],
                        entryComponents: [IgxCustomPaletteColorScaleComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBrushScaleModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBrushScaleModule() {
        }
        IgxBrushScaleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBrushScaleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleModule, declarations: [IgxBrushScaleComponent], imports: [i1.CommonModule], exports: [IgxBrushScaleComponent] });
        IgxBrushScaleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleModule, imports: [[i1.CommonModule]] });
        return IgxBrushScaleModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxBrushScaleComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxBrushScaleComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors of selecting a brush from a brush collection.
     */
    var BrushSelectionMode = /*@__PURE__*/ (function (BrushSelectionMode) {
        /**
         * alternates between brushes sequentially.
         */
        BrushSelectionMode[BrushSelectionMode["Select"] = 0] = "Select";
        /**
         * Uses index-based interpolation.
         */
        BrushSelectionMode[BrushSelectionMode["Interpolate"] = 1] = "Interpolate";
        return BrushSelectionMode;
    })({});
    /**
     * @hidden
     */
    var BrushSelectionMode_$type = i2.markEnum('BrushSelectionMode', 'Select,0|Interpolate,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterAxisInfoCache = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterAxisInfoCache, _super);
        function ScatterAxisInfoCache() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.d = false;
            _this.e = false;
            _this.c = null;
            return _this;
        }
        ScatterAxisInfoCache.$t = i2.markType(ScatterAxisInfoCache, 'ScatterAxisInfoCache');
        return ScatterAxisInfoCache;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available methods of collision avoidance of series' markers.
     */
    var CollisionAvoidanceType = /*@__PURE__*/ (function (CollisionAvoidanceType) {
        /**
         * Collision avoidance is disabled.
         */
        CollisionAvoidanceType[CollisionAvoidanceType["None"] = 0] = "None";
        /**
         * Items colliding with other items will be hidden from view.
         */
        CollisionAvoidanceType[CollisionAvoidanceType["Omit"] = 1] = "Omit";
        /**
         * Items colliding with other items will be partially hidden from view by reducing their opacity.
         */
        CollisionAvoidanceType[CollisionAvoidanceType["Fade"] = 2] = "Fade";
        /**
         * Items colliding with other items will be either hidden from view or moved to new positions.
         */
        CollisionAvoidanceType[CollisionAvoidanceType["OmitAndShift"] = 3] = "OmitAndShift";
        /**
         * Items colliding with other items will be either partially hidden from view by reducing their opacity, or moved to new positions, or a combination of both.
         */
        CollisionAvoidanceType[CollisionAvoidanceType["FadeAndShift"] = 4] = "FadeAndShift";
        return CollisionAvoidanceType;
    })({});
    /**
     * @hidden
     */
    var CollisionAvoidanceType_$type = i2.markEnum('CollisionAvoidanceType', 'None,0|Omit,1|Fade,2|OmitAndShift,3|FadeAndShift,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ErrorBarSettingsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ErrorBarSettingsBase, _super);
        function ErrorBarSettingsBase() {
            var _this = _super.call(this) || this;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.n = new i2.Style();
            return _this;
        }
        ErrorBarSettingsBase.prototype.l = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        ErrorBarSettingsBase.$t = i2.markType(ErrorBarSettingsBase, 'ErrorBarSettingsBase', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type]);
        ErrorBarSettingsBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ErrorBarSettingsBase, 'l', ['DefaultErrorBarStyle:n:m', [i2.Style.$, null]]);
        return ErrorBarSettingsBase;
    }(i2.DependencyObject));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available types for enabling error bars
     */
    var EnableErrorBars = /*@__PURE__*/ (function (EnableErrorBars) {
        /**
         * No error bars are enabled
         */
        EnableErrorBars[EnableErrorBars["None"] = 0] = "None";
        /**
         * Both error bars are enabled
         */
        EnableErrorBars[EnableErrorBars["Both"] = 1] = "Both";
        /**
         * Positive error bars are enabled
         */
        EnableErrorBars[EnableErrorBars["Positive"] = 2] = "Positive";
        /**
         * Negative error bars are enabled
         */
        EnableErrorBars[EnableErrorBars["Negative"] = 3] = "Negative";
        return EnableErrorBars;
    })({});
    /**
     * @hidden
     */
    var EnableErrorBars_$type = i2.markEnum('EnableErrorBars', 'None,0|Both,1|Positive,2|Negative,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterErrorBarSettings = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterErrorBarSettings, _super);
        function ScatterErrorBarSettings() {
            var _this = _super.call(this) || this;
            _this.q = null;
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, i2.runOn(_this, _this.ap));
            return _this;
        }
        Object.defineProperty(ScatterErrorBarSettings.prototype, "r", {
            get: function () {
                return this.q;
            },
            set: function (a) {
                this.q = a;
            },
            enumerable: false,
            configurable: true
        });
        ScatterErrorBarSettings.prototype.ap = function (a, b) {
            switch (b.propertyName) {
                case ScatterErrorBarSettings.$$p[2]:
                case ScatterErrorBarSettings.$$p[8]:
                    var c = i2.typeCast(i2.IErrorBarCalculator_$type, b.oldValue);
                    if (c != null) {
                        c.changed = i2.delegateRemove(c.changed, i2.runOn(this, this.ao));
                    }
                    if (this.r != null) {
                        this.r.l0(false);
                        if (this.r.ca != null) {
                            this.r.k7();
                        }
                    }
                    var d = i2.typeCast(i2.IErrorBarCalculator_$type, b.newValue);
                    if (d != null) {
                        d.changed = i2.delegateCombine(d.changed, i2.runOn(this, this.ao));
                    }
                    break;
                case ScatterErrorBarSettings.$$p[0]:
                case ScatterErrorBarSettings.$$p[1]:
                case ScatterErrorBarSettings.$$p[3]:
                case ScatterErrorBarSettings.$$p[4]:
                case ScatterErrorBarSettings.$$p[5]:
                case ScatterErrorBarSettings.$$p[6]:
                case ScatterErrorBarSettings.$$p[7]:
                case ScatterErrorBarSettings.$$p[9]:
                case ScatterErrorBarSettings.$$p[10]:
                case ScatterErrorBarSettings.$$p[11]:
                case ScatterErrorBarSettings.$$p[12]:
                case ScatterErrorBarSettings.$$p[13]:
                    if (this.r != null) {
                        this.r.l0(false);
                        if (this.r.ca != null) {
                            this.r.k7();
                        }
                    }
                    break;
            }
        };
        ScatterErrorBarSettings.prototype.ao = function (a, b) {
            var c = i2.typeCast(i2.IErrorBarCalculator_$type, a);
            if (c != null) {
                c.changed = i2.delegateRemove(c.changed, i2.runOn(this, this.ao));
                if (this.r != null) {
                    this.r.l0(false);
                }
                c.changed = i2.delegateCombine(c.changed, i2.runOn(this, this.ao));
            }
        };
        ScatterErrorBarSettings.$t = i2.markType(ScatterErrorBarSettings, 'ScatterErrorBarSettings', ErrorBarSettingsBase.$);
        ScatterErrorBarSettings.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterErrorBarSettings, 'l', ['EnableErrorBarsHorizontal:o:aq', [EnableErrorBars_$type, i2.enumGetBox(EnableErrorBars_$type, 0)], 'EnableErrorBarsVertical:p:ar', [EnableErrorBars_$type, i2.enumGetBox(EnableErrorBars_$type, 0)], 'HorizontalCalculator:u:as', [i2.IErrorBarCalculator_$type, null], 'HorizontalCalculatorReference:s:at', [i2.ErrorBarCalculatorReference_$type, i2.enumGetBox(i2.ErrorBarCalculatorReference_$type, 0)], 'HorizontalErrorBarCapLength:y:au', [1, 6], 'HorizontalErrorBarStyle:a6:av', [i2.Style.$, null], 'HorizontalStroke:a4:aw', [i2.Brush.$, null], 'HorizontalStrokeThickness:w:ax', [1, 1], 'VerticalCalculator:v:ay', [i2.IErrorBarCalculator_$type, null], 'VerticalCalculatorReference:t:az', [i2.ErrorBarCalculatorReference_$type, i2.enumGetBox(i2.ErrorBarCalculatorReference_$type, 1)], 'VerticalErrorBarCapLength:z:a0', [1, 6], 'VerticalErrorBarStyle:a7:a1', [i2.Style.$, null], 'VerticalStroke:a5:a2', [i2.Brush.$, null], 'VerticalStrokeThickness:x:a3', [1, 1]]);
        return ScatterErrorBarSettings;
    }(ErrorBarSettingsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterFrame, _super);
        function ScatterFrame() {
            var _this = _super.call(this, ScatterFrame.$) || this;
            _this.u = null;
            _this.u = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 0);
            return _this;
        }
        ScatterFrame.prototype.r = function (a, b, c) {
            _super.prototype.r.call(this, a, b, c);
            var d = i2.typeCast(ScatterFrame.$, b);
            var e = i2.typeCast(ScatterFrame.$, c);
            if (d == null || e == null) {
                return;
            }
            this.f.f(this.u, a, d.u, e.u, d, e);
        };
        ScatterFrame.$t = i2.markType(ScatterFrame, 'ScatterFrame', ScatterFrameBase$1.$.specialize(-1)).initSelfReferences();
        return ScatterFrame;
    }(ScatterFrameBase$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterTrendLineManager, _super);
        function ScatterTrendLineManager() {
            return _super.call(this, i2.Point_$type) || this;
        }
        ScatterTrendLineManager.prototype.get_g$a = function () {
            return 4;
        };
        Object.defineProperty(ScatterTrendLineManager.prototype, "g$a", {
            get: function () {
                return this.get_g$a();
            },
            enumerable: false,
            configurable: true
        });
        ScatterTrendLineManager.prototype.h = function (a, b, c, d, e, f, g, h, i, j, k) {
            var e_1, _a;
            var l = j;
            var m = k;
            var n = new i2.List$1(i2.Point_$type, 0);
            var o = 0;
            if (c != null) {
                o = c.count;
            }
            if (d != null) {
                o = Math.min(o, d.count);
            }
            if (!h.g.isEmpty && !h.f.isEmpty) {
                if (b == 0) {
                    this.a = null;
                    this.d.clear();
                }
                else if (this.c(b)) {
                    this.d.clear();
                    this.a = TrendFitCalculator.a(n, b, h, this.a, o, function (p) { return c.item(p); }, function (p) { return d.item(p); }, f, g, l, m);
                }
                else if (this.b(b)) {
                    this.a = null;
                    this.d.clear();
                    TrendAverageCalculator.c(b, this.d, c, d, e);
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var p = _c.value;
                            var q = f(p.x);
                            var r = g(p.y);
                            if (!i2.isNaN_(q) && !i2.isNaN_(r)) {
                                n.add({ $type: i2.Point_$type, x: q, y: r });
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
                this.f(n, h, a, i);
            }
        };
        ScatterTrendLineManager.$t = i2.markType(ScatterTrendLineManager, 'ScatterTrendLineManager', TrendLineManagerBase$1.$.specialize(i2.Point_$type));
        return ScatterTrendLineManager;
    }(TrendLineManagerBase$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningScatterStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningScatterStyleEventArgs, _super);
        function AssigningScatterStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningScatterStyleEventArgs.$t = i2.markType(AssigningScatterStyleEventArgs, 'AssigningScatterStyleEventArgs', AssigningSeriesShapeStyleEventArgsBase.$);
        return AssigningScatterStyleEventArgs;
    }(AssigningSeriesShapeStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningScatterStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningScatterStyleEventArgsBase, _super);
        function AssigningScatterStyleEventArgsBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningScatterStyleEventArgsBase.$t = i2.markType(AssigningScatterStyleEventArgsBase, 'AssigningScatterStyleEventArgsBase', AssigningSeriesStyleEventArgsBase.$);
        return AssigningScatterStyleEventArgsBase;
    }(AssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningScatterMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningScatterMarkerStyleEventArgs, _super);
        function AssigningScatterMarkerStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningScatterMarkerStyleEventArgs.$t = i2.markType(AssigningScatterMarkerStyleEventArgs, 'AssigningScatterMarkerStyleEventArgs', AssigningScatterStyleEventArgsBase.$);
        return AssigningScatterMarkerStyleEventArgs;
    }(AssigningScatterStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ErrorBarsHelper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ErrorBarsHelper, _super);
        function ErrorBarsHelper(a, b) {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.a = null;
            _this.b = a;
            _this.a = b;
            return _this;
        }
        ErrorBarsHelper.prototype.c = function (a) {
            var b = a.getCalculatorType();
            if (b == 1 || b == 2) {
                return false;
            }
            else {
                return true;
            }
        };
        ErrorBarsHelper.prototype.i = function (a, b) {
            if (a.hasConstantPosition()) {
                b = a.getPosition();
            }
            return {
                p1: b
            };
        };
        ErrorBarsHelper.prototype.k = function (a, b, c, d, e) {
            var f;
            var g;
            var h;
            var i = this.a.getViewInfo(g, f);
            g = i.p0;
            f = i.p1;
            h = this.a.getEffectiveViewport();
            var j = new ScalerParams(0, f, g, c.cc, h);
            var k = c.d8(a, j);
            var l = b.getIndependentValue();
            d = Math.abs(Math.round(c.d8(a + l, j) - k));
            e = Math.abs(Math.round(c.d8(a - l, j) - k));
            return {
                p3: d,
                p4: e
            };
        };
        ErrorBarsHelper.prototype.j = function (a, b, c, d, e) {
            var f;
            var g;
            var h = this.a.getViewInfo(g, f);
            g = h.p0;
            f = h.p1;
            var i = new ScalerParams(1, f, g, c.cc);
            var j = c.eb(a, i);
            var k = b.getIndependentValue();
            d = Math.abs(Math.round(c.d8(j + k, i) - a));
            e = Math.abs(Math.round(c.d8(j - k, i) - a));
            return {
                p3: d,
                p4: e
            };
        };
        ErrorBarsHelper.prototype.g = function (a, b, c, d, e) {
            var f;
            var g;
            var h = this.a.getViewInfo(g, f);
            g = h.p0;
            f = h.p1;
            var i = new ScalerParams(1, f, g, c.cc);
            var j = c.eb(a, i);
            var k = b.getDependentValue(j);
            d = Math.abs(Math.round(c.d8(j + k, i) - a));
            e = Math.abs(Math.round(c.d8(j - k, i) - a));
            return {
                p3: d,
                p4: e
            };
        };
        ErrorBarsHelper.prototype.f = function (a, b, c, d, e, f) {
            var g;
            var h;
            var i = this.a.getViewInfo(h, g);
            h = i.p0;
            g = i.p1;
            var j = new ScalerParams(1, g, h, c.cc);
            var k = new ScalerParams(1, g, h, d.cc);
            var l = c.eb(a, j);
            var m = b.getDependentValue(l);
            e = Math.abs(Math.round(c.d8(l + m, k) - a));
            f = Math.abs(Math.round(c.d8(l - m, k) - a));
            return {
                p4: e,
                p5: f
            };
        };
        ErrorBarsHelper.prototype.h = function (a, b, c, d, e) {
            var f;
            var g;
            var h = this.a.getViewInfo(g, f);
            g = h.p0;
            f = h.p1;
            var i = new ScalerParams(1, f, g, c.cc);
            var j = c.eb(a, i);
            d = Math.abs(Math.round(c.d8(j + b, i) - a));
            e = Math.abs(Math.round(c.d8(j - b, i) - a));
            return {
                p3: d,
                p4: e
            };
        };
        ErrorBarsHelper.prototype.e = function (a, b, c, d) {
        };
        ErrorBarsHelper.prototype.d = function (a, b, c, d) {
        };
        ErrorBarsHelper.prototype.l = function (a, b, c, d) {
            var e = i2.PointUtil.create();
            if (a.getCalculatorType() == 3) {
                var f = void 0;
                var g = void 0;
                var h = void 0;
                var i = this.a.getViewInfo(g, f);
                g = i.p0;
                f = i.p1;
                h = this.a.getEffectiveViewport();
                var j = new ScalerParams(0, f, g, b.cc, h);
                e.x = Math.round(b.d8(d, j));
                e.y = Math.round(c.y);
            }
            else {
                e.x = Math.round(c.x);
                e.y = Math.round(c.y);
            }
            return e;
        };
        ErrorBarsHelper.prototype.m = function (a, b, c, d) {
            var e = i2.PointUtil.create();
            if (a.getCalculatorType() == 3) {
                var f = void 0;
                var g = void 0;
                var h = void 0;
                var i = this.a.getViewInfo(g, f);
                g = i.p0;
                f = i.p1;
                h = this.a.getEffectiveViewport();
                var j = new ScalerParams(0, f, g, b.cc, h);
                e.x = Math.round(c.x);
                e.y = Math.round(b.d8(d, j));
            }
            else {
                e.x = Math.round(c.x);
                e.y = Math.round(c.y);
            }
            return e;
        };
        ErrorBarsHelper.$t = i2.markType(ErrorBarsHelper, 'ErrorBarsHelper');
        return ErrorBarsHelper;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterBase, _super);
        function ScatterBase() {
            var _this = _super.call(this) || this;
            _this.rb = null;
            _this.rp = null;
            _this.rq = null;
            _this.t2 = null;
            _this.t3 = null;
            _this.rk = 1;
            _this.qw = null;
            _this.qx = null;
            _this.rh = null;
            _this.rj = null;
            _this.rf = null;
            _this.ru = false;
            _this.rt = false;
            _this.q7 = null;
            _this.q8 = null;
            _this.assigningScatterStyle = null;
            _this.assigningScatterMarkerStyle = null;
            _this.ro = null;
            _this.ri = null;
            _this.re = null;
            _this.rl = _this.rm();
            _this.ro = new ScatterSeriesRenderManager();
            _this.ri = new ScatterFrame();
            _this.t3 = i2.Rect.empty;
            _this.t2 = i2.Rect.empty;
            return _this;
        }
        ScatterBase.prototype.bu = function () {
            return new ScatterBaseView(this);
        };
        ScatterBase.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.xAxis = null;
            this.yAxis = null;
        };
        ScatterBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.rc = a;
        };
        ScatterBase.prototype.get_d6 = function () {
            return true;
        };
        ScatterBase.prototype.ag = function () {
            return [this.xAxis, this.yAxis];
        };
        ScatterBase.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == ScatterBase.$$p[8]) {
                return this.hl(a, b, this.so);
            }
            if (c == ScatterBase.$$p[10]) {
                return this.hl(a, b, this.ss);
            }
            return null;
        };
        ScatterBase.prototype.cx = function (a, b, c) {
            var _this = this;
            if (!this.hasMarkers) {
                return false;
            }
            var d = this.xAxis;
            var e = new ScalerParams(1, this.ca.pg, this.pf, d.cc);
            e.c = this.getEffectiveViewport1(this.bx);
            var f = this.yAxis;
            var g = new ScalerParams(1, this.ca.pg, this.pf, f.cc);
            g.c = this.getEffectiveViewport1(this.bx);
            a.clear();
            this.pq.cf(function (h) {
                if (h._visibility == 0) {
                    var i = new SeriesPointOfInterest();
                    var j = h.n;
                    var k = h.o;
                    if (j < _this.pf.left || j > _this.pf.right || k < _this.pf.top || k > _this.pf.bottom) {
                        return;
                    }
                    i.b = d.eb(j, e);
                    i.c = f.eb(k, g);
                    i.a = h.content;
                    a.add(i);
                }
            });
            return true;
        };
        ScatterBase.prototype.bo = function () {
            if (this.bp == 0) {
                if (this.sc <= 2000) {
                    return 1;
                }
                else {
                    return _super.prototype.bo.call(this);
                }
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        ScatterBase.prototype.pd = function (a) {
            if (!this.hasMarkers || !this.pt()) {
                return i2.Rect.empty;
            }
            var b = this.pq.by(this.ox(a));
            if (b != null) {
                return this.pq.cp(b);
            }
            return i2.Rect.empty;
        };
        ScatterBase.prototype.ep = function (a, b) {
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        Object.defineProperty(ScatterBase.prototype, "rr", {
            get: function () {
                return this.rp;
            },
            set: function (a) {
                if (this.rp != a) {
                    var b = this.rr;
                    this.rp = a;
                    this.raisePropertyChanged("XColumn", b, this.rr);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterBase.prototype, "rs", {
            get: function () {
                return this.rq;
            },
            set: function (a) {
                if (this.rq != a) {
                    var b = this.rs;
                    this.rq = a;
                    this.raisePropertyChanged("YColumn", b, this.rs);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterBase.prototype, "tz", {
            get: function () {
                return this.c(ScatterBase.tg);
            },
            set: function (a) {
                this.h(ScatterBase.tg, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterBase.prototype, "GetErrorBarsXAxis", {
            get: function () {
                return this.xAxis;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterBase.prototype, "GetErrorBarsYAxis", {
            get: function () {
                return this.yAxis;
            },
            enumerable: false,
            configurable: true
        });
        ScatterBase.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.xAxis != null) {
                this.xAxis.hq(false);
            }
            if (this.yAxis != null) {
                this.yAxis.hq(false);
            }
        };
        ScatterBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.rc.cx.g$b(a, b, c, d)) {
                this.l0(false);
                this.k7();
            }
            switch (b) {
                case "FastItemsSource":
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.rr);
                        c.deregisterColumn(this.rs);
                        this.rr = null;
                        this.rs = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.rr = this.ce(this.so);
                        this.rs = this.ce(this.ss);
                    }
                    if ((this.yAxis != null && !this.yAxis.cv()) || (this.xAxis != null && !this.xAxis.cv())) {
                        this.l0(false);
                    }
                    break;
                case ScatterBase.$$p[7]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if ((this.xAxis != null && !this.xAxis.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ScatterBase.$$p[9]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if ((this.yAxis != null && !this.yAxis.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ScatterBase.$$p[8]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.rr);
                        this.rr = this.ce(this.so);
                    }
                    break;
                case "XColumn":
                    this.rc.cx.g$i();
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(false);
                    }
                    break;
                case ScatterBase.$$p[10]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.rs);
                        this.rs = this.ce(this.ss);
                    }
                    break;
                case "YColumn":
                    this.rc.cx.g$i();
                    if (this.yAxis != null && !this.yAxis.cv()) {
                        this.l0(false);
                    }
                    break;
                case ScatterBase.$$p[5]:
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterBase.$$p[6]:
                    this.l0(false);
                    this.k7();
                    break;
                case "TransitionProgress":
                    this.rj.c(this.gn, this.rh, this.rf);
                    this.su();
                    try {
                        if (this.ct(this.bx)) {
                            return;
                        }
                        if ((Math.round(this.gn * 100000) / 100000) == 1) {
                            this.te(this.rf, this.rc);
                        }
                        else {
                            this.te(this.rj, this.rc);
                        }
                        if (this.ca != null) {
                            this.ca.ln(this);
                        }
                    }
                    finally {
                        this.tf();
                    }
                    break;
                case "TrendLineBrush":
                    this.md();
                    break;
                case ScatterBase.$$p[0]:
                    if (this.rd != null) {
                        this.rd.r = this;
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "TrendLineType":
                    this.k7();
                    break;
                case ScatterBase.$$p[2]:
                    this.ru = this.r2();
                    this.l0(false);
                    break;
                case ScatterBase.$$p[1]:
                    this.rt = this.r1();
                    this.l0(false);
                    break;
                case ScatterBase.$$p[3]:
                    this.rl = this.rm();
                    break;
            }
        };
        ScatterBase.prototype.r2 = function () {
            return this.ry;
        };
        ScatterBase.prototype.r1 = function () {
            return this.rx;
        };
        ScatterBase.prototype.rw = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        ScatterBase.prototype.rv = function (a) {
            if (i2.typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        ScatterBase.prototype.tf = function () {
            this.t2 = i2.Rect.empty;
            this.t3 = i2.Rect.empty;
        };
        ScatterBase.prototype.su = function () {
            var a = this.getViewInfo(this.t2, this.t3);
            this.t2 = a.p0;
            this.t3 = a.p1;
        };
        ScatterBase.prototype.r0 = function (a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.so == a || this.ss == a) {
                return true;
            }
            return false;
        };
        ScatterBase.prototype.kk = function (a, b, c, d) {
            var e = false;
            if (!this.r0(d, a)) {
                return;
            }
            this.rc.cx.g$e(a, b, c, d);
            if (this.xAxis != null && !this.xAxis.cv()) {
                e = true;
            }
            if (this.yAxis != null && !this.yAxis.cv()) {
                e = true;
            }
            if (e) {
                this.l0(true);
            }
        };
        ScatterBase.prototype.s6 = function (a) {
            this.s7(a, null);
        };
        ScatterBase.prototype.s7 = function (a, b) {
            var e_1, _a, e_2, _b;
            var c = this.rr != null ? this.rr.count : 0;
            var d = this.rs != null ? this.rs.count : 0;
            var e = Math.min(c, d);
            if (e <= this.sc) {
                a.m.clear();
                var f = new i2.List$1(OwnedPoint.$, 0);
                try {
                    for (var _c = tslib.__values(i2.fromEnum(a.u.values)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var g = _d.value;
                        f.add(g);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                var h_1 = this.ch;
                f.aa(function (i, j) {
                    var k = h_1.indexOf(i.a);
                    var l = h_1.indexOf(j.a);
                    if (k < l) {
                        return -1;
                    }
                    if (k > l) {
                        return 1;
                    }
                    return 0;
                });
                if (b != null) {
                    b.i = a.m;
                }
                try {
                    for (var _e = tslib.__values(i2.fromEnum(f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var i = _f.value;
                        if (h_1.indexOf(i.a) >= 0) {
                            if (b != null) {
                                b.j(i.c);
                            }
                            else {
                                a.m.add({ $type: i2.Point_$type, x: i.c.x, y: i.c.y });
                            }
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        };
        ScatterBase.prototype.ap = function (a) {
            if (a != null && a == this.xAxis && this.rr != null) {
                return new AxisRange(this.rr.minimum, this.rr.maximum);
            }
            if (a != null && a == this.yAxis && this.rs != null) {
                return new AxisRange(this.rs.minimum, this.rs.maximum);
            }
            return null;
        };
        ScatterBase.prototype.hh = function (a) {
            var b = this.g0(a);
            if (this.ch != null && b >= 0 && b < this.ch.count) {
                return this.ch.item(b);
            }
            return null;
        };
        Object.defineProperty(ScatterBase.prototype, "rl", {
            get: function () {
                return this.rk;
            },
            set: function (a) {
                var b = this.rk;
                this.rk = a;
                if (b != this.rk) {
                    this.raisePropertyChanged("ActualItemSearchMode", i2.enumGetBox(ScatterItemSearchMode_$type, b), i2.enumGetBox(ScatterItemSearchMode_$type, this.rk));
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterBase.prototype.rm = function () {
            if (this.rn != 0) {
                return this.rn;
            }
            return this.rz ? 4 : 1;
        };
        ScatterBase.prototype.g0 = function (a) {
            var b = i2.truncate(Math.round(this.fw(a)));
            return b;
        };
        ScatterBase.prototype.fw = function (a) {
            switch (this.rl) {
                case 1: return this.r8(a);
                case 3: return this.r9(a);
                case 2: return this.r6(a);
                case 4: return this.r7(a);
            }
            return -1;
        };
        ScatterBase.prototype.r7 = function (a) {
            return this.sa(a, false);
        };
        ScatterBase.prototype.r6 = function (a) {
            var b = this.ox(a);
            var c = b.x;
            var d = b.y;
            if (this.ch == null || this.xAxis == null || this.yAxis == null || this.rr == null || this.rs == null) {
                return -1;
            }
            if (this.ch.count > this.sb) {
                return -1;
            }
            this.sx();
            var e = this.qw;
            var f = this.qx;
            if (e == null || f == null) {
                return -1;
            }
            var g = 1.7976931348623157E+308;
            var h = -1;
            for (var i = 0; i < this.rr.count; i++) {
                var j = e[i];
                var k = f[i];
                var l = (c - j) * (c - j) + (d - k) * (d - k);
                if (l < g) {
                    g = l;
                    h = i;
                }
            }
            return h;
        };
        ScatterBase.prototype.sx = function () {
            var _this = this;
            var a = this.bx.bv;
            var b = this.bx.bu;
            var c = this.getEffectiveViewport();
            if (this.rb == null) {
                return;
            }
            var d = new ScalerParams(0, a, b, this.rb.d, c);
            var e = ((function () {
                var $ret = new ScalerParams(0, a, b, _this.rb.e, c);
                $ret.b = _this.f2();
                return $ret;
            })());
            if (this.qw == null || this.qx == null) {
                var f = i2.arrayShallowClone(this.rr.asArray());
                var g = i2.arrayShallowClone(this.rs.asArray());
                this.xAxis.g5(i2.boxArray$1(f), 0, f.length, d);
                this.yAxis.g5(i2.boxArray$1(g), 0, g.length, e);
                this.qw = f;
                this.qx = g;
            }
        };
        ScatterBase.prototype.get_rz = function () {
            return false;
        };
        Object.defineProperty(ScatterBase.prototype, "rz", {
            get: function () {
                return this.get_rz();
            },
            enumerable: false,
            configurable: true
        });
        ScatterBase.prototype.sa = function (a, b) {
            if (!this.rz) {
                return -1;
            }
            var c = { $type: i2.Point_$type, x: 0, y: 0 };
            var d = true;
            var e = this.rg();
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.ch == null || this.ch.count > this.sb) {
                return -1;
            }
            this.sx();
            var f = this.qw;
            var g = this.qx;
            if (f == null || g == null) {
                return -1;
            }
            var h = this.ox(a);
            var i = 1.7976931348623157E+308;
            var j = -1;
            for (var k = 0; k < this.qw.length; k++) {
                var l = { $type: i2.Point_$type, x: this.qw[k], y: this.qx[k] };
                if (k > 0) {
                    if (!b || e.j.containsKey(this.ch.item(k)) || e.j.containsKey(this.ch.item(k - 1))) {
                        var m = i2.GeometryUtil.d(h, c, l);
                        if (m < i) {
                            i = m;
                            j = k;
                        }
                    }
                }
                c = l;
            }
            if (j >= 0) {
                var n = { $type: i2.Point_$type, x: this.qw[j], y: this.qx[j] };
                var o = { $type: i2.Point_$type, x: this.qw[j - 1], y: this.qx[j - 1] };
                if (!b || (e.j.containsKey(this.ch.item(j)) && e.j.containsKey(this.ch.item(j - 1)))) {
                    var p = i2.GeometryUtil.h(h, o, n);
                    return (j - 1) + p;
                }
                else if (e.j.containsKey(this.ch.item(j))) {
                    return j;
                }
                else {
                    return j - 1;
                }
            }
            return -1;
        };
        ScatterBase.prototype.r9 = function (a) {
            return this.sa(a, true);
        };
        ScatterBase.prototype.r8 = function (a) {
            var _this = this;
            var b = null;
            var c = 1.7976931348623157E+308;
            var d = this.ox(a);
            var e = d.x;
            var f = d.y;
            if (this.rc.cy.e > this.sb) {
                return -1;
            }
            this.rc.c5(function (g) {
                if (g._visibility == 0) {
                    var h = _this.rc.cp(g);
                    var i = h.left + h.width / 2;
                    var j = h.top + h.height / 2;
                    var k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        };
        ScatterBase.prototype.o2 = function (a, b, c) {
            var _this = this;
            if (this.xAxis == null || this.yAxis == null || this.rr == null || this.rs == null) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            var d = this.bx.bv;
            var e = this.bx.bu;
            var f = this.getEffectiveViewport();
            var g = new ScalerParams(0, d, e, this.xAxis.cc, f);
            var h = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.yAxis.cc, f);
                $ret.b = _this.f2();
                return $ret;
            })());
            if (b) {
                var i = this.fw(a);
                if (i == -1) {
                    return { $type: i2.Point_$type, x: NaN, y: NaN };
                }
                var j = i2.truncate(Math.floor(i));
                var k = i2.truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.ch.count - 1) {
                    k = this.ch.count - 1;
                }
                if (j > this.ch.count - 1) {
                    j = this.ch.count - 1;
                }
                if (k == j) {
                    var l = this.xAxis.d8(this.rr.item(j), g);
                    var m = this.yAxis.d8(this.rs.item(j), h);
                    return { $type: i2.Point_$type, x: l, y: m };
                }
                var n = i - Math.floor(i);
                var o = this.xAxis.d8(this.rr.item(j), g);
                var p = this.yAxis.d8(this.rs.item(j), h);
                var q = this.xAxis.d8(this.rr.item(k), g);
                var r = this.yAxis.d8(this.rs.item(k), h);
                var s = q - o;
                var t = r - p;
                return { $type: i2.Point_$type, x: o + s * n, y: p + t * n };
            }
            else {
                var u = this.g0(a);
                if (u == -1) {
                    return { $type: i2.Point_$type, x: NaN, y: NaN };
                }
                var v = this.xAxis.d8(this.rr.item(u), g);
                var w = this.yAxis.d8(this.rs.item(u), h);
                return { $type: i2.Point_$type, x: v, y: w };
            }
        };
        ScatterBase.prototype.eh = function (a) {
            var _this = this;
            var b = this.ca != null ? this.ca.pg : i2.Rect.empty;
            b = b.copy();
            var c = this.ca != null ? this.ca.pv : i2.Rect.empty;
            var d = new i2.Rect(0, 0, 0, 1, 1);
            var e = this.o9(this.bx);
            var f = new ScalerParams(0, d, d, this.xAxis.cc, e);
            var g = ((function () {
                var $ret = new ScalerParams(0, d, d, _this.yAxis.cc, e);
                $ret.b = _this.f2();
                return $ret;
            })());
            var h = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            var i = this.xAxis != null && this.rr != null && h < this.rr.count ? this.xAxis.d8(this.rr.item(h), f) : NaN;
            var j = this.yAxis != null && this.rs != null && h < this.rs.count ? this.yAxis.d8(this.rs.item(h), g) : NaN;
            if (!i2.isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!i2.isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b5 != null) {
                this.b5.ap(this.ca, b, true);
            }
            return h >= 0;
        };
        ScatterBase.prototype.mm = function (a, b) {
            this.l0(false);
        };
        ScatterBase.prototype.mn = function (a, b) {
            this.l0(false);
        };
        ScatterBase.prototype.rg = function () {
            var a = this.rf;
            if (this.cr()) {
                if (this.cb.g) {
                    this.cb.t();
                }
                a = this.rj;
            }
            return a;
        };
        ScatterBase.prototype.sv = function (a, b, c, d, e) {
            var _this = this;
            b.g = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 1, c);
            var f = this.getEffectiveViewport1(a);
            var g = this.ch;
            var h;
            var i;
            var j = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.rb.d, f);
                $ret.c = _this.getEffectiveViewport1(a);
                return $ret;
            })());
            var k = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.rb.e, f);
                $ret.c = _this.getEffectiveViewport1(a);
                $ret.b = _this.f2();
                return $ret;
            })());
            var l = false;
            var m = 0;
            if (this.ca != null) {
                if (this.ca.ei()) {
                    var n = this.ca.i1(d, j);
                    l = n.c;
                    m = n.d;
                }
            }
            var _loop_1 = function (o) {
                h = this_1.rr.item(o);
                i = this_1.rs.item(o);
                var p = { $type: i2.Point_$type, x: this_1.rb.a.d8(h, j), y: this_1.rb.b.d8(i, k) };
                if (l) {
                    if (p.x < e.left || p.x > e.right) {
                        if (p.x + m >= e.left && p.x + m <= e.right) {
                            p = { $type: i2.Point_$type, x: p.x + m, y: i };
                        }
                    }
                }
                if (!i2.isInfinity(p.x) && !i2.isInfinity(p.y)) {
                    var q_1 = g.item(o);
                    if (!b.g.containsKey(q_1)) {
                        var r_1 = { $type: i2.Point_$type, x: h, y: i };
                        var s_1 = { $type: i2.Point_$type, x: p.x, y: p.y };
                        b.g.addItem(q_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = q_1;
                            $ret.b = r_1;
                            $ret.c = s_1;
                            return $ret;
                        })()));
                    }
                }
            };
            var this_1 = this;
            for (var o = 0; o < c; o++) {
                _loop_1(o);
            }
        };
        ScatterBase.prototype.s3 = function (a, b) {
            var _this = this;
            this.qw = null;
            this.qx = null;
            a.j.clear();
            a.n.clear();
            a.h.clear();
            a.l.clear();
            a.i.clear();
            a.k.clear();
            var c = Math.min(this.rr != null ? this.rr.count : 0, this.rs != null ? this.rs.count : 0);
            var d = b.bv;
            var e = b.bu;
            var f = this.getEffectiveViewport1(b);
            var g = new ScalerParams(0, d, e, this.xAxis.cc, f);
            g.c = this.getEffectiveViewport1(b);
            var h = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.yAxis.cc, f);
                $ret.b = _this.f2();
                return $ret;
            })());
            h.c = this.getEffectiveViewport1(b);
            if (c < 1) {
                return;
            }
            this.rb = ((function () {
                var $ret = new ScatterAxisInfoCache();
                $ret.a = _this.xAxis;
                $ret.b = _this.yAxis;
                $ret.d = _this.xAxis.cc;
                $ret.e = _this.yAxis.cc;
                $ret.c = _this.ch;
                return $ret;
            })());
            var i = b;
            if (c <= this.sc) {
                this.sv(i, a, c, d, e);
            }
            if (this.pt()) {
                b.cv.l(a.j, this.sc, d, e, this.gh);
            }
            var j = ((function () {
                var $ret = new i2.Clipper(0, e, false);
                $ret.i = a.n;
                return $ret;
            })());
            var k = this.o7(b);
            var l = this.xAxis.eb(k.left, g);
            var m = this.xAxis.eb(k.right, g);
            b.cx.h(a.n, this.trendLineType, this.rr, this.rs, this.trendLinePeriod, function (n) { return _this.xAxis.d8(n, g); }, function (n) { return _this.yAxis.d8(n, h); }, ((function () {
                var $ret = new TrendResolutionParams();
                $ret.b = _this.gh;
                $ret.f = e;
                $ret.g = d;
                return $ret;
            })()), j, l, m);
            this.s1(a, b);
        };
        ScatterBase.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.c4(a);
        };
        ScatterBase.prototype.get_dr = function () {
            return true;
        };
        ScatterBase.prototype.q5 = function (a, b, c) {
            return null;
        };
        ScatterBase.prototype.q6 = function (a, b, c) {
            var d = this.rg();
            var e = this.rc.by(this.ox(b));
            var f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ch.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            var g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            g.e = true;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        };
        ScatterBase.prototype.pg = function () {
            if (this.pr != 1 && this.pr != 13) {
                var a = this.pq.cq();
                var b = (a.width / 2) + (this.pw / 2);
                var c = (a.height / 2) + (this.pw / 2);
                return new i2.Thickness(1, b, c, b, c);
            }
            return new i2.Thickness(1, 0, 0, 0, 0);
        };
        ScatterBase.prototype.q4 = function (a, b, c) {
            var d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        };
        ScatterBase.prototype.av = function (a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                var d = this.q5(a, b, this.q7);
                this.q7 = d;
                return d;
            }
            else {
                var e = this.q4(a, b, this.q7);
                this.q7 = e;
                return e;
            }
        };
        ScatterBase.prototype.aw = function (a, b, c) {
            if (this.d9(this.bj) && !c) {
                var d = this.q6(a, b, this.q8);
                this.q8 = d;
                return d;
            }
            else {
                var e = this.q4(a, b, this.q8);
                e.e = true;
                this.q8 = e;
                return e;
            }
        };
        ScatterBase.prototype.r4 = function () {
            return (this.assigningScatterStyle != null && this.ru) || (this.bj != 1);
        };
        ScatterBase.prototype.r3 = function () {
            return (this.assigningScatterMarkerStyle != null && this.rt) || (this.bj != 1);
        };
        ScatterBase.prototype.te = function (a, b) {
            var _this = this;
            var c = b.bu;
            this.rb = ((function () {
                var $ret = new ScatterAxisInfoCache();
                $ret.a = _this.xAxis;
                $ret.b = _this.yAxis;
                $ret.d = _this.xAxis.cc;
                $ret.e = _this.yAxis.cc;
                return $ret;
            })());
            if (this.pt()) {
                b.cv.j(a.j, this.pv);
                if (this.r3()) {
                    this.sw(b, a);
                }
            }
            b.cm();
            var d = ((function () {
                var $ret = new i2.Clipper(1, NaN, c.bottom, NaN, c.top, false);
                $ret.i = b.cx.g$j.ak;
                return $ret;
            })());
            b.cx.g$h(a.n, d);
            this.tb(a, b);
        };
        ScatterBase.prototype.qz = function (a, b) {
            return this.q0(a, b);
        };
        ScatterBase.prototype.q0 = function (a, b) {
            if (b < a || a < 0 || a > this.rr.count || b < 0 || b > this.rr.count) {
                return null;
            }
            var c = new Array((b - a) + 1);
            for (var d = a; d <= b; d++) {
                var e = d;
                c[d - a] = this.ch.item(d);
            }
            return c;
        };
        ScatterBase.prototype.sw = function (a, b) {
            var _this = this;
            a.b3 = true;
            this.ro.aw(this, this.r3(), i2.runOn(this, this.qz));
            var c = this.ro.d;
            var d = c != null;
            var e = this.getEffectiveViewport1(a);
            var f = this.ch == null ? 0 : this.ch.count;
            this.rc.cf(function (g) {
                if (g._visibility == 0) {
                    var h = g.ak;
                    var i = g.content;
                    if (i == null) {
                        i = new i2.DataContext();
                        g.content = i;
                    }
                    if (d) {
                        _this.sy(h, f, a.q);
                    }
                    _this.ro.ac(g, i);
                }
            });
        };
        ScatterBase.prototype.sz = function (a, b, c) {
            var d = this.bj != 1;
            this.ro.ay(this.ro.b, a, b, false);
            this.ro.ab(this.fj);
            var e = this.ro.av;
            var f = null;
            var g = this.ch;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, false);
                e.b = f;
            }
            e.f = c;
            this.s9(e);
            this.ro.z(this, f, c, d, a < 0);
        };
        ScatterBase.prototype.sy = function (a, b, c) {
            var d = this.bj != 1;
            this.ro.ay(this.ro.d, a, b, true);
            this.ro.aa(this.fj);
            var e = this.ro.au;
            var f = null;
            var g = this.ch;
            var h = null;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    h = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.s8(e);
            this.ro.y(this, f, c, d, e.m, this.ca.a3.totalHighlightingProgress);
        };
        ScatterBase.prototype.s9 = function (a) {
            if (this.assigningScatterStyle != null && this.ru) {
                this.assigningScatterStyle(this, a);
            }
        };
        ScatterBase.prototype.s8 = function (a) {
            if (this.assigningScatterMarkerStyle != null && this.rt) {
                this.assigningScatterMarkerStyle(this, a);
            }
        };
        ScatterBase.prototype.s1 = function (a, b) {
            var e_3, _a;
            var c = new ErrorBarsHelper(this, b);
            if (this.rd == null) {
                return;
            }
            var d = this.rd.u;
            var e = this.rd.v;
            var f = 0;
            var g = 0;
            var h = 0;
            var i = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var j = _c.value;
                    var k = a.j.item(j);
                    if (d != null) {
                        switch (d.getCalculatorType()) {
                            case 1:
                                var l = this.s4(k, c, d, h, i, true);
                                h = l.p3;
                                i = l.p4;
                                break;
                            case 0:
                                var m = this.s2(k, c, d, h, i, true);
                                h = m.p3;
                                i = m.p4;
                                break;
                            case 2:
                                var n = this.s0(k, c, d, j, h, i, true);
                                h = n.p4;
                                i = n.p5;
                                break;
                            case 3:
                                var o = this.s5(c, d, f, h, i, true);
                                f = o.p2;
                                h = o.p3;
                                i = o.p4;
                                break;
                            case 4:
                                var p = this.s2(k, c, d, h, i, true);
                                h = p.p3;
                                i = p.p4;
                                break;
                        }
                        ;
                        var q = new OwnedPoint();
                        q.c = c.l(d, this.rb.a, k.c, f);
                        q.a = k.a;
                        a.h.addItem(j, q);
                        a.i.addItem(j, [h, i]);
                    }
                    if (e != null) {
                        switch (e.getCalculatorType()) {
                            case 1:
                                var r = this.s4(k, c, e, h, i, false);
                                h = r.p3;
                                i = r.p4;
                                break;
                            case 0:
                                var s = this.s2(k, c, e, h, i, false);
                                h = s.p3;
                                i = s.p4;
                                break;
                            case 2:
                                var t = this.s0(k, c, e, j, h, i, false);
                                h = t.p4;
                                i = t.p5;
                                break;
                            case 3:
                                var u = this.s5(c, e, g, h, i, false);
                                g = u.p2;
                                h = u.p3;
                                i = u.p4;
                                break;
                            case 4:
                                var v = this.s2(k, c, e, h, i, false);
                                h = v.p3;
                                i = v.p4;
                                break;
                        }
                        ;
                        var w = new OwnedPoint();
                        w.c = c.m(e, this.rb.b, k.c, g);
                        w.a = k.a;
                        a.l.addItem(j, w);
                        a.k.addItem(j, [h, i]);
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
        };
        ScatterBase.prototype.s4 = function (a, b, c, d, e, f) {
            if (f) {
                var g = void 0;
                var h = void 0, i = void 0;
                i = this.rb.a;
                if (this.rd.s == 0) {
                    g = a.c.x;
                    h = this.rb.a;
                }
                else {
                    g = a.c.y;
                    h = this.rb.b;
                }
                var j = b.f(g, c, h, i, d, e);
                d = j.p4;
                e = j.p5;
            }
            else {
                var k = void 0;
                var l = void 0, m = void 0;
                m = this.rb.b;
                if (this.rd.t == 0) {
                    k = a.c.x;
                    l = this.rb.a;
                }
                else {
                    k = a.c.y;
                    l = this.rb.b;
                }
                var n = b.f(k, c, l, m, d, e);
                d = n.p4;
                e = n.p5;
            }
            return {
                p3: d,
                p4: e
            };
        };
        ScatterBase.prototype.s2 = function (a, b, c, d, e, f) {
            if (f) {
                var g = b.j(a.c.x, c, this.rb.a, d, e);
                d = g.p3;
                e = g.p4;
            }
            else {
                var h = b.j(a.c.y, c, this.rb.b, d, e);
                d = h.p3;
                e = h.p4;
            }
            return {
                p3: d,
                p4: e
            };
        };
        ScatterBase.prototype.s0 = function (a, b, c, d, e, f, g) {
            var h = c.getItemColumn();
            var i = this.ch.indexOf(d);
            if (h != null && i < h.count) {
                var j = h.item(i);
                if (g) {
                    var k = b.h(a.c.x, j, this.rb.a, e, f);
                    e = k.p3;
                    f = k.p4;
                }
                else {
                    var l = b.h(a.c.y, j, this.rb.b, e, f);
                    e = l.p3;
                    f = l.p4;
                }
            }
            else {
                e = NaN;
                f = NaN;
            }
            return {
                p4: e,
                p5: f
            };
        };
        ScatterBase.prototype.s5 = function (a, b, c, d, e, f) {
            var g = a.i(b, c);
            c = g.p1;
            if (f) {
                var h = a.k(c, b, this.rb.a, d, e);
                d = h.p3;
                e = h.p4;
            }
            else {
                var i = a.k(c, b, this.rb.b, d, e);
                d = i.p3;
                e = i.p4;
            }
            return {
                p2: c,
                p3: d,
                p4: e
            };
        };
        ScatterBase.prototype.tb = function (a, b) {
            if (!b.o() || this.rd == null) {
                b.c6();
                return;
            }
            this.tc(a, b);
            this.td(a, b);
        };
        ScatterBase.prototype.tc = function (a, b) {
            var e_4, _a;
            b.c2();
            var c = new ErrorBarsHelper(this, b);
            var d = new i2.PathGeometry();
            var e = this.rd.u;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (e != null && a.i.containsKey(f)) {
                        var g = a.i.item(f)[0];
                        var h = a.i.item(f)[1];
                        if (!i2.isNaN_(g) && !i2.isNaN_(h)) {
                            var i = a.h.item(f).c;
                            if (this.rd.o == 1 || this.rd.o == 2) {
                                c.d(d, i, g, true);
                            }
                            if (this.rd.o == 1 || this.rd.o == 3) {
                                c.d(d, i, h, false);
                            }
                        }
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            b.c7(d);
        };
        ScatterBase.prototype.td = function (a, b) {
            var e_5, _a;
            b.c3();
            var c = new ErrorBarsHelper(this, b);
            var d = new i2.PathGeometry();
            var e = this.rd.v;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (e != null && a.k.containsKey(f)) {
                        var g = a.k.item(f)[0];
                        var h = a.k.item(f)[1];
                        if (!i2.isNaN_(g) && !i2.isNaN_(h)) {
                            var i = a.l.item(f).c;
                            if (this.rd.p == 1 || this.rd.p == 2) {
                                c.e(d, i, g, true);
                            }
                            if (this.rd.p == 1 || this.rd.p == 3) {
                                c.e(d, i, h, false);
                            }
                        }
                    }
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        };
        ScatterBase.prototype.e3 = function (a, b, c) {
            var d = true;
            if (!_super.prototype.e3.call(this, a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.rr == null || this.rs == null || this.rr.count == 0 || this.rs.count == 0 || this.ch == null || this.ch.count != this.rr.count || this.ch.count != this.rs.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.kv == this.xAxis.ku || this.yAxis.kv == this.yAxis.ku) {
                d = false;
            }
            return d;
        };
        ScatterBase.prototype.getViewInfo = function (a, b) {
            if (!this.t2.isEmpty && !this.t3.isEmpty) {
                a = this.t2;
                b = this.t3;
                return {
                    p0: a,
                    p1: b
                };
            }
            a = this.bx.bu;
            b = this.bx.bv;
            return {
                p0: a,
                p1: b
            };
        };
        ScatterBase.prototype.l1 = function (a) {
            this.su();
            try {
                if (this.ct(this.bx)) {
                    return;
                }
                if (this.ch != null && this.ch.count > this.sc) {
                    a = false;
                }
                if (this.ei(a) && !this.em) {
                    var b = this.rh;
                    if (this.cr()) {
                        if (this.cb.g) {
                            this.cb.t();
                        }
                        this.rh = this.rj;
                        this.rj = b;
                    }
                    else {
                        this.rh = this.rf;
                        this.rf = b;
                    }
                    this.s3(this.rf, this.rc);
                    this.l8();
                }
                else {
                    if (!this.em) {
                        this.s3(this.rf, this.rc);
                    }
                    this.te(this.rf, this.rc);
                }
            }
            finally {
                this.tf();
            }
        };
        ScatterBase.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            this.rc.da();
        };
        ScatterBase.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            var c = i2.typeCast(ScatterBaseView.$, this.bw);
            if (!this.en) {
                this.ri = new ScatterFrame();
                this.s3(this.ri, c);
            }
            this.en = false;
            this.te(this.ri, c);
            this.et = false;
        };
        ScatterBase.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.re == null) {
                this.re = new ScatterFrame();
            }
            this.s3(this.re, g);
            this.te(this.re, g);
        };
        ScatterBase.prototype.ta = function (a, b) {
            var e_6, _a, e_7, _b;
            var c = new i2.List$1(i2.Base.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    if (!a.containsKey(d)) {
                        c.add1(d);
                    }
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    b.h(e);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        };
        ScatterBase.prototype.qy = function (a, b, c, d, e) {
            var _this = this;
            if (c == null || c.length != this.rb.c.count) {
                c = new Array(this.rb.c.count);
                for (var f = 0; f < this.rb.c.count; f++) {
                    c[f] = i2.PointUtil.create();
                }
            }
            var g = this.getEffectiveViewport1(a);
            var h = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.xAxis.cc, g);
                $ret.c = _this.getEffectiveViewport1(a);
                return $ret;
            })());
            var i = ((function () {
                var $ret = new ScalerParams(0, d, e, _this.yAxis.cc, g);
                $ret.c = _this.getEffectiveViewport1(a);
                $ret.b = _this.f2();
                return $ret;
            })());
            var j = this.o7(a);
            var k = this.rb.a.eb(j.left, h);
            var l = this.rb.a.eb(j.right, h);
            var m = this.rb.b.eb(j.bottom, i);
            var n = this.rb.b.eb(j.top, i);
            if (this.rb.d) {
                var o = k;
                k = l;
                l = o;
            }
            if (this.rb.e) {
                var p = m;
                m = n;
                n = p;
            }
            var q = this.rb;
            var r = q.a;
            var s = q.b;
            var t;
            var u;
            var v = this.rr;
            var w = this.rs;
            var x = false;
            var y = 0;
            var z = 0;
            if (this.ca != null) {
                if (this.ca.ei()) {
                    var aa = this.ca.i1(d, h);
                    x = aa.c;
                    y = aa.d;
                    z = r.eb(0 + y, h);
                    var ab = r.eb(0, h);
                    z -= ab;
                }
            }
            for (var ac = 0; ac < this.rb.c.count; ac++) {
                t = v.item(ac);
                u = w.item(ac);
                if (x) {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.d8(t, h);
                        c[ac].y = s.d8(u, i);
                    }
                    else {
                        if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                            c[ac].x = r.d8(t, h) + y;
                            c[ac].y = s.d8(u, i);
                        }
                        else {
                            c[ac].x = NaN;
                            c[ac].y = NaN;
                        }
                    }
                }
                else {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.d8(t, h);
                        c[ac].y = s.d8(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            return c;
        };
        ScatterBase.prototype.r5 = function (a, b) {
            var e_8, _a;
            if (b == null) {
                b = new i2.List$1(i2.Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            var c = 0;
            var d = this.ch;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    b.add(d.indexOf(e));
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            return b;
        };
        ScatterBase.prototype.kr = function (a) {
            _super.prototype.kr.call(this, a);
            this.a6.exportTrendlineData(this, a, this.rc.cx.g$j);
        };
        ScatterBase.prototype.f2 = function () {
            return Series.f3(this.rs, null);
        };
        ScatterBase.$t = i2.markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
        ScatterBase.tg = i2.DependencyProperty.i("ActualTrendLineBrush", i2.Brush.$, ScatterBase.$, new i2.PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
        ScatterBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:rd:th', [ScatterErrorBarSettings.$, null], 'IsCustomScatterMarkerStyleAllowed:rx:ti', [0, false], 'IsCustomScatterStyleAllowed:ry:tj', [0, false], 'ItemSearchMode:rn:tk', [ScatterItemSearchMode_$type, i2.enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sb:tl', [1, 10000], 'MarkerCollisionAvoidance:q3:tm', [CollisionAvoidanceType_$type, i2.enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:sc:tn', [1, 400], 'XAxis::tv', [NumericXAxis.$, null], 'XMemberPath:so:tw', [2, null], 'YAxis::tx', [NumericYAxis.$, null], 'YMemberPath:ss:ty', [2, null], 'TrendLineType::tt', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'TrendLineThickness::ts', [1, 1.5], 'TrendLinePeriod::tr', [1, 7], 'TrendLineBrush::to', [i2.Brush.$, null], 'TrendLineZIndex:sd:tu', [1, 1001], 'TrendLineDashArray:t0:tp', [i2.DoubleCollection.$], 'TrendLineDashCap:t1:tq', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)]]);
        return ScatterBase;
    }(MarkerSeries));
    /**
     * @hidden
     */
    var ScatterSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterSeriesRenderManager, _super);
        function ScatterSeriesRenderManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.au = null;
            _this.av = null;
            return _this;
        }
        ScatterSeriesRenderManager.prototype.c = function () {
            this.au = new AssigningScatterMarkerStyleEventArgs();
            return this.au;
        };
        ScatterSeriesRenderManager.prototype.a = function () {
            this.av = new AssigningScatterStyleEventArgs();
            return this.av;
        };
        ScatterSeriesRenderManager.prototype.aw = function (a, b, c) {
            this.w(a, b, c);
        };
        ScatterSeriesRenderManager.prototype.ax = function (a, b, c) {
            this.x(a, b, c);
        };
        ScatterSeriesRenderManager.prototype.ay = function (a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        };
        ScatterSeriesRenderManager.$t = i2.markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
        return ScatterSeriesRenderManager;
    }(SeriesRenderManager));
    /**
     * @hidden
     */
    var ScatterBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterBaseView, _super);
        function ScatterBaseView(a) {
            var _this = _super.call(this, a) || this;
            _this.cv = null;
            _this.ct = null;
            _this.cw = null;
            _this.c1 = null;
            _this.dc = null;
            _this.dd = null;
            _this.cx = null;
            _this.db = null;
            _this.cy = null;
            _this.cw = a;
            _this.cy = new i2.HashPool$2(i2.Base.$, Marker.$);
            _this.ch(_this.cy);
            _this.cx = new ScatterTrendLineManager();
            return _this;
        }
        ScatterBaseView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.cv = this.cu();
            this.dc = new i2.Path();
            this.dd = new i2.Path();
            if (!this.q) {
                this.cw.sc = 2000;
            }
        };
        ScatterBaseView.prototype.de = function (a) {
            if (this.db == null) {
                this.db = new i2.DataTemplateMeasureInfo();
                this.db.context = this.k.g();
            }
            this.db.width = a.width;
            this.db.height = a.height;
            this.db.data = a.content;
            var b = a.ah;
            if (b.measure != null) {
                b.measure(this.db);
            }
            return new i2.Size(1, this.db.width, this.db.height);
        };
        ScatterBaseView.prototype.cu = function () {
            var _this = this;
            var a = new NumericMarkerManager(1, function (b) { return _this.cy.item(b); }, function (b) { return _this.cw.rb.c.item(b); }, i2.runOn(this, this.c9), i2.runOn(this, this.cr), i2.runOn(this, this.cz), function () { return _this.cw.q3; });
            a.q = i2.runOn(this, this.de);
            return a;
        };
        ScatterBaseView.prototype.c9 = function (a) {
            this.cw.ta(a, this.cy);
        };
        ScatterBaseView.prototype.c0 = function () {
            return this.b4;
        };
        ScatterBaseView.prototype.cs = function () {
            return this.ct;
        };
        ScatterBaseView.prototype.cr = function () {
            this.ct = this.cw.qy(this, this.cy, this.ct, this.bv, this.bu);
            return this.ct;
        };
        ScatterBaseView.prototype.cz = function () {
            this.c1 = this.cw.r5(this.cy, this.c1);
            return this.c1;
        };
        ScatterBaseView.prototype.c2 = function () {
        };
        ScatterBaseView.prototype.c7 = function (a) {
        };
        ScatterBaseView.prototype.c3 = function () {
        };
        ScatterBaseView.prototype.c8 = function (a) {
        };
        ScatterBaseView.prototype.da = function () {
            if (this.cw.trendLineBrush != null) {
                this.cw.tz = this.cw.trendLineBrush;
            }
            else {
                this.cw.tz = this.cw.of;
            }
        };
        ScatterBaseView.prototype.cf = function (a) {
            this.cy.f(a);
        };
        ScatterBaseView.prototype.c5 = function (a) {
            this.cy.g(a);
        };
        ScatterBaseView.prototype.c6 = function () {
        };
        ScatterBaseView.prototype.a5 = function (a, b) {
            _super.prototype.a5.call(this, a, b);
            if (a.d) {
                if (this.cw.trendLineType != 0 && !b) {
                    var c = this.cx.g$j;
                    c.ac = this.cw.trendLineThickness;
                    c._stroke = this.cw.tz;
                    c.ai = this.cw.t0;
                    c.ad = this.cw.t1;
                    a.u(c);
                }
            }
        };
        ScatterBaseView.prototype.c4 = function (a) {
            if (a) {
                this.c6();
                this.cy.clear();
            }
            this.cx.g$d();
            this.aq();
        };
        ScatterBaseView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.hp + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cw.so + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cw.ss + "}</span></div>";
            return a;
        };
        ScatterBaseView.$t = i2.markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
        return ScatterBaseView;
    }(MarkerSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ActualRange = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ActualRange, _super);
        function ActualRange() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.a = 0;
            return _this;
        }
        ActualRange.$t = i2.markType(ActualRange, 'ActualRange');
        return ActualRange;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BubbleMarkerManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BubbleMarkerManager, _super);
        function BubbleMarkerManager(a, b, c, d, e) {
            var _this = _super.call(this, a, b, c, d, e) || this;
            _this.m = null;
            _this.o = null;
            _this.n = null;
            _this.o = new i2.List$1(i2.Number_$type, 0);
            _this.n = new i2.List$1(Marker.$, 0);
            return _this;
        }
        BubbleMarkerManager.prototype.l = function (a, b, c, d, e) {
            var f = this.f();
            a.clear();
            this.o.clear();
            this.n.clear();
            var g = new i2.List$1(i2.Number_$type, 0);
            b = Math.max(0, b);
            var h = null;
            this.i(c, d, i2.boxArray$1(f), g);
            if (b >= g.count) {
                h = g;
            }
            else {
                h = new i2.List$1(i2.Number_$type, 0);
                var i = Math.max(8, e);
                var j = this.c(d, g, i, i2.boxArray$1(f));
                var k = new i2.List$1(i2.Number_$type, 1, j.keys);
                if (MarkerManagerBase.b) {
                    k.y();
                }
                this.k(b, j, k, h);
            }
            for (var l = 0; l < h.count; ++l) {
                var m = f[h._inner[l]].x;
                var n = f[h._inner[l]].y;
                var o = this.m.item(h._inner[l]);
                this.o.add(o);
                var p = this.h(this.g(h._inner[l]));
                p.content.item = this.g(h._inner[l]);
                p.ak = h._inner[l];
                var q = new OwnedPoint();
                q.a = p.content.item;
                q.c = { $type: i2.Point_$type, x: m, y: n };
                if (!a.containsKey(q.a)) {
                    a.addItem(q.a, q);
                    this.n.add(p);
                }
            }
        };
        BubbleMarkerManager.prototype.j = function (a, b) {
            var e_1, _a;
            var c = a.keys;
            if (MarkerManagerBase.b) {
                var d = new i2.List$1(i2.Base.$, 1, a.keys);
                d.aa(function (e, f) {
                    var g = a.item(e);
                    var h = a.item(f);
                    var i = Math.pow(g.c.x, 2) + Math.pow(g.c.y, 2);
                    var j = Math.pow(h.c.x, 2) + Math.pow(h.c.y, 2);
                    return i2.CompareUtil.compareToObject(i, j);
                });
                c = d;
            }
            var e = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    var g = a.item(f);
                    var h = this.h(g.a);
                    h.s = e;
                    h.n = g.c.x;
                    h.o = g.c.y;
                    e++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.a(a);
        };
        BubbleMarkerManager.$t = i2.markType(BubbleMarkerManager, 'BubbleMarkerManager', MarkerManagerBase.$);
        return BubbleMarkerManager;
    }(MarkerManagerBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BubbleSeries, _super);
        function BubbleSeries() {
            var _this = _super.call(this) || this;
            _this.vk = null;
            _this.vj = null;
            _this.uj = null;
            _this.ub = null;
            _this.ua = null;
            _this.t9 = null;
            _this.ab = BubbleSeries.$;
            _this.rh = new ScatterFrame();
            _this.rj = new ScatterFrame();
            _this.rf = new ScatterFrame();
            return _this;
        }
        BubbleSeries.prototype.get_c0 = function () {
            return true;
        };
        BubbleSeries.prototype.bu = function () {
            return new BubbleSeriesView(this);
        };
        BubbleSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t7 = a;
        };
        BubbleSeries.prototype.gi = function () {
            return 0.7;
        };
        BubbleSeries.prototype.pl = function () {
            if (this.pk == 0) {
                return 2;
            }
            return _super.prototype.pl.call(this);
        };
        BubbleSeries.prototype.isAttachedTo = function (a) {
            return this.a0 == a;
        };
        BubbleSeries.prototype.cz = function () {
            return true;
        };
        BubbleSeries.prototype.kt = function (a) {
            _super.prototype.kt.call(this, a);
            if (this.ue != null && this.uj != null && this.uj.count > 0) {
                for (var b = 0; b < this.uj.count; b++) {
                    a(this.uj._inner[b]);
                }
            }
        };
        Object.defineProperty(BubbleSeries.prototype, "ud", {
            get: function () {
                return this.uf;
            },
            enumerable: false,
            configurable: true
        });
        BubbleSeries.prototype.vi = function (a) {
            var b = i2.typeCast(CustomPaletteBrushScale.$, this.t6);
            var c = i2.typeCast(ValueBrushScale.$, this.t6);
            var d = this.t6;
            if (b != null && this.ch != null) {
                return b.getBrush1(a, this.ch.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.uc);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        };
        Object.defineProperty(BubbleSeries.prototype, "legendReady", {
            get: function () {
                return this.uf != null && this.uf.count != 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
            get: function () {
                var a = this.t5(this.t8).b;
                return (Math.round(a * 1000) / 1000).toString();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
            get: function () {
                var a = this.t5(this.t8).a;
                return (Math.round(a * 1000) / 1000).toString();
            },
            enumerable: false,
            configurable: true
        });
        BubbleSeries.prototype.forScaleColors = function (a) {
            for (var b = 0; b < this.uf.count; b++) {
                if (this.t6 == null || !this.t6.isReady) {
                    return false;
                }
                var c = NaN;
                if (this.uc != null) {
                    c = (this.uc.item(b) - this.uc.minimum) / (this.uc.maximum - this.uc.minimum);
                }
                var d = (this.uf.item(b) - this.uf.minimum) / (this.uf.maximum - this.uf.minimum);
                if (i2.isNaN_(c)) {
                    c = 0;
                }
                if (i2.isNaN_(d)) {
                    d = c;
                }
                var e = this.qr;
                var f = this.vi(b);
                var g = f != null ? f : e;
                a(g, d);
            }
            return true;
        };
        BubbleSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == BubbleSeries.$$p[3]) {
                return this.hl(a, b, this.uu);
            }
            if (c == BubbleSeries.$$p[7]) {
                return this.hl(a, b, this.u0);
            }
            if (c == ScatterBase.$$p[8]) {
                return this.hl(a, b, this.so);
            }
            if (c == ScatterBase.$$p[10]) {
                return this.hl(a, b, this.ss);
            }
            if (c == BubbleSeries.$$p[0]) {
                return this.hl(a, b, this.up);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(BubbleSeries.prototype, "uf", {
            get: function () {
                return this.ub;
            },
            set: function (a) {
                if (this.ub != a) {
                    var b = this.uf;
                    this.ub = a;
                    this.raisePropertyChanged("RadiusColumn", b, this.uf);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BubbleSeries.prototype, "ue", {
            get: function () {
                return this.ua;
            },
            set: function (a) {
                if (this.ua != a) {
                    var b = this.ue;
                    this.ua = a;
                    this.raisePropertyChanged("LabelColumn", b, this.ue);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BubbleSeries.prototype, "uc", {
            get: function () {
                return this.t9;
            },
            set: function (a) {
                if (this.t9 != a) {
                    var b = this.uc;
                    this.t9 = a;
                    this.raisePropertyChanged("FillColumn", b, this.uc);
                }
            },
            enumerable: false,
            configurable: true
        });
        BubbleSeries.prototype.sv = function (a, b, c, d, e) {
            if (c <= this.sc) {
                b.g = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 1, c);
            }
            var f = this.sc;
            var g = this.ch;
            var h;
            var i;
            var j = this.getEffectiveViewport1(a);
            var k = new ScalerParams(0, d, e, this.rb.d, j);
            var l = new ScalerParams(0, d, e, this.rb.e, j);
            var m = false;
            var n = 0;
            if (this.ca != null) {
                if (this.ca.ei()) {
                    var o = this.ca.i1(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            var _loop_1 = function (p) {
                h = this_1.rr.item(p);
                i = this_1.rs.item(p);
                var q = { $type: i2.Point_$type, x: this_1.rb.a.d8(h, k), y: this_1.rb.b.d8(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: i2.Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!i2.isInfinity(q.x) && !i2.isInfinity(q.y)) {
                    var r_1 = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r_1)) {
                            var s_1 = { $type: i2.Point_$type, x: h, y: i };
                            b.g.addItem(r_1, ((function () {
                                var $ret = new OwnedPoint();
                                $ret.a = r_1;
                                $ret.b = s_1;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            };
            var this_1 = this;
            for (var p = 0; p < c; p++) {
                _loop_1(p);
            }
        };
        BubbleSeries.prototype.s3 = function (a, b) {
            var c = i2.typeCast(BubbleSeriesView.$, b);
            var d = c.cv;
            d.m = this.uf;
            _super.prototype.s3.call(this, a, b);
            var e = Math.min(this.rr != null ? this.rr.count : 0, this.rs != null ? this.rs.count : 0);
            if (e < 1) {
                return;
            }
            c.dh();
            c.di();
        };
        BubbleSeries.prototype.u5 = function () {
            if (this.ca == null) {
                return;
            }
            if (this.a0 == null) {
                return;
            }
            if (this.a0.isItemwise) {
                var a = this.a0;
                this.a0.clearLegendItemsForSeries(this);
                this.u4();
                a.renderItemwiseContent(this);
            }
            if (this.a0.isScale) {
                var b = this.a0;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        };
        BubbleSeries.uk = function (a, b, c, d, e) {
            if (e <= a || i2.isNaN_(e) || i2.isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            var f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        };
        BubbleSeries.ul = function (a, b, c, d, logBase_, e) {
            var f = i2.logBase(e, logBase_);
            var g = i2.logBase(a, logBase_);
            var h = i2.logBase(b, logBase_);
            return BubbleSeries.uk(g, h, c, d, f);
        };
        BubbleSeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (this.uf == null || this.ch == null || this.uf.count == 0 || this.ch.count != this.uf.count) {
                d = false;
            }
            return d;
        };
        BubbleSeries.prototype.r0 = function (a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.so == a || this.ss == a || this.u0 == a) {
                return true;
            }
            return false;
        };
        BubbleSeries.prototype.u4 = function () {
            var _this = this;
            var a = i2.typeCast(i2.IChartLegend_$type, this.a0);
            if (a == null || this.ch == null) {
                return;
            }
            this.uj = new i2.List$1(i2.UIElement.$, 0);
            var b = i2.typeCast(CustomPaletteBrushScale.$, this.t6);
            var c = i2.typeCast(ValueBrushScale.$, this.t6);
            var d = this.t6;
            var e = this.t4();
            var f = e.b;
            var g = e.a;
            var h = this.ch;
            var _loop_2 = function (i) {
                var j = null;
                if (c != null && this_2.uc != null) {
                    var k = this_2.uc.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                var l = new i2.ContentControl();
                var m = this_2.ue != null && this_2.ue.item(i) != null ? this_2.ue.item(i).toString() : "";
                l.content = ((function () {
                    var $ret = new i2.DataContext();
                    $ret.series = _this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    return $ret;
                })());
                var n = this_2.mt;
                if (n == null) {
                    n = this_2.bx.bl(this_2.b2);
                }
                l.ah = n;
                this_2.uj.add(l);
            };
            var this_2 = this;
            for (var i = 0; i < h.count; i++) {
                _loop_2(i);
            }
        };
        BubbleSeries.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            if (this.t8 != null) {
                this.t8.aa();
            }
            if (this.t6 != null) {
                this.t6.x();
            }
            this.u5();
        };
        BubbleSeries.prototype.k0 = function () {
            _super.prototype.k0.call(this);
            this.u5();
        };
        BubbleSeries.prototype.k6 = function () {
            _super.prototype.k6.call(this);
            this.u5();
        };
        BubbleSeries.prototype.lm = function (a, b, c, d) {
            var e_1, _a;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    if (this.t8 != null) {
                        this.t8.aa();
                    }
                    if (this.t6 != null) {
                        this.t6.x();
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.uf);
                        c.deregisterColumn(this.uc);
                        c.deregisterColumn(this.ue);
                        this.uf = null;
                        this.uc = null;
                        this.ue = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.uf = this.ce(this.u0);
                        if (!i2.stringIsNullOrEmpty(this.up)) {
                            this.uc = this.ce(this.up);
                        }
                        this.ue = this.cg(this.uu);
                    }
                    this.l0(false);
                    this.u5();
                    break;
                case BubbleSeries.$$p[7]:
                    if (this.t8 != null) {
                        this.t8.aa();
                    }
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.uf);
                        this.uf = this.ce(this.u0);
                        this.u5();
                    }
                    break;
                case "RadiusColumn":
                    if (this.t8 != null) {
                        this.t8.aa();
                    }
                    this.rc.cx.g$i();
                    this.l0(false);
                    this.k8();
                    break;
                case BubbleSeries.$$p[8]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case BubbleSeries.$$p[9]:
                    this.l0(false);
                    this.k7();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.u5();
                    break;
                case BubbleSeries.$$p[1]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.l0(false);
                    this.u5();
                    this.k7();
                    break;
                case BubbleSeries.$$p[2]:
                case BubbleSeries.$$p[6]:
                case BubbleSeries.$$p[5]:
                case BubbleSeries.$$p[4]:
                    this.l0(false);
                    this.u5();
                    this.k7();
                    break;
                case "FillColumn":
                    this.l0(false);
                    this.k7();
                    break;
                case BubbleSeries.$$p[0]:
                    if (this.t6 != null) {
                        this.t6.x();
                    }
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.uc);
                        this.uc = this.ce(this.up);
                        this.u5();
                    }
                    break;
                case BubbleSeries.$$p[3]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.ue);
                        this.ue = this.cg(this.uu);
                        this.u5();
                    }
                    break;
                case "ActualLegend":
                    var e = i2.typeCast(i2.IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        var f = i2.typeCast(i2.IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        var g = i2.typeCast(i2.IChartScaleLegend_$type, e);
                        var h = true;
                        var i = null;
                        if (this.ca != null) {
                            try {
                                for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    var j = _c.value;
                                    if (j.legend == g) {
                                        i = j;
                                        h = false;
                                    }
                                }
                            }
                            catch (e_1_1) {
                                e_1 = { error: e_1_1 };
                            }
                            finally {
                                try {
                                    if (_c && !_c.done && (_a = _b.return))
                                        _a.call(_b);
                                }
                                finally {
                                    if (e_1)
                                        throw e_1.error;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(i2.typeCast(i2.IScaleLegendSeries_$type, i));
                        }
                    }
                    this.u5();
                    break;
                case "SeriesViewer":
                    this.u5();
                    break;
            }
        };
        BubbleSeries.prototype.updateSizeScaleGlobals = function () {
            var a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.uf != null) {
                a.b = this.uf.minimum;
                a.a = this.uf.maximum;
            }
            if (this.t8 != null) {
                this.t8.ab(a.b, a.a);
            }
        };
        BubbleSeries.prototype.updateFillScaleGlobals = function () {
            var a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.uc != null) {
                a.b = this.uc.minimum;
                a.a = this.uc.maximum;
            }
            if (this.t6 != null) {
                this.t6.z(a.b, a.a);
            }
        };
        BubbleSeries.prototype.t5 = function (a) {
            var b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.uf != null) {
                b.b = this.uf.minimum;
                b.a = this.uf.maximum;
            }
            if (a != null) {
                a.x();
                if (this.ui) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        };
        BubbleSeries.prototype.t4 = function () {
            var a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.uc != null) {
                a.b = this.uc.minimum;
                a.a = this.uc.maximum;
            }
            var b = i2.typeCast(ValueBrushScale.$, this.t6);
            if (b != null) {
                b.s();
                if (this.ug && this.t6.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        };
        BubbleSeries.prototype.u7 = function (a, b, c, d) {
            var e = c.width;
            if (!this.bx.bu.isEmpty) {
                e = this.bx.bu.width;
            }
            else if (this.ca != null && !this.ca.pv.isEmpty) {
                e = this.ca.pv.width;
            }
            var f = i2.DeviceUtils.c(e);
            var g = this.t8 || ((function () {
                var $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (g != null) {
                var h = g.minimumValue;
                var i = g.maximumValue;
                var j = g.logarithmBase;
                var k = this.t5(g);
                var l = k.b;
                var m = k.a;
                if (g.isLogarithmic) {
                    for (var n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.ul(l, m, h, i, j, b._inner[n]);
                    }
                }
                else {
                    for (var o = 0; o < b.count; o++) {
                        b._inner[o] = BubbleSeries.uk(l, m, h, i, b._inner[o]);
                    }
                }
            }
            var p = 1;
            p = i2.DeviceUtils.d();
            var q = this.t8 == null;
            if (d) {
                var r = c.width / e;
                for (var s = 0; s < b.count; s++) {
                    if (q) {
                        b._inner[s] = b._inner[s] / p;
                    }
                    b._inner[s] = b._inner[s] * r;
                }
            }
            for (var t = 0; t < a.count; t++) {
                var u = a._inner[t];
                if (q && !d) {
                    u.width = Math.max(0, b._inner[t] / p);
                    u.height = Math.max(0, b._inner[t] / p);
                }
                else {
                    u.width = Math.max(0, b._inner[t]);
                    u.height = Math.max(0, b._inner[t]);
                }
            }
        };
        BubbleSeries.prototype.u6 = function (a) {
            var b = i2.typeCast(BubbleSeriesView.$, this.bw);
            this.t7.b3 = false;
            if (b != null) {
                b.b3 = false;
            }
            var c = i2.typeCast(CustomPaletteBrushScale.$, this.t6);
            var d = i2.typeCast(ValueBrushScale.$, this.t6);
            var e = this.t6;
            var f = this.t4();
            var g = f.b;
            var h = f.a;
            var i = this.t6 == null || !this.t6.isReady || (d != null && this.up == null);
            if (i) {
                this.t7.dg();
                if (b != null) {
                    b.dg();
                }
                return;
            }
            this.t7.b3 = true;
            if (b != null) {
                b.b3 = true;
            }
            var j = a.count;
            var k = this.ch;
            for (var l = 0; l < j; l++) {
                var m = a._inner[l];
                var n = i2.typeCast(i2.DataContext.$, m.content);
                if (n != null) {
                    var o = null;
                    var p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.uc != null) {
                        var q = this.uc.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.qt == null) {
                            o = this.qr;
                        }
                        else {
                            o = this.qt;
                        }
                    }
                    var r = null;
                    if (this.qu == null) {
                        r = this.qs;
                    }
                    else {
                        r = this.qu;
                    }
                    if (this.uh && o != null) {
                        r = o;
                    }
                    if (r != null && !i2.isNaN_(this.un)) {
                        r = i2.BrushUtil.l(r, this.un);
                    }
                    if (o != null && !i2.isNaN_(this.um)) {
                        o = i2.BrushUtil.l(o, this.um);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        };
        Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
            get: function () {
                return this.qr;
            },
            enumerable: false,
            configurable: true
        });
        BubbleSeries.$t = i2.markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [i2.IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
        BubbleSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberPath:up:u8', [2], 'FillScale:t6:u9', [BrushScale.$], 'FillScaleUseGlobalValues:ug:va', [0, false], 'LabelMemberPath:uu:vb', [2], 'MarkerBrushBrightness:um:vc', [1, NaN], 'MarkerOutlineBrightness:un:vd', [1, NaN], 'MarkerOutlineUsesFillScale:uh:ve', [0, false], 'RadiusMemberPath:u0:vf', [2, null], 'RadiusScale:t8:vg', [SizeScale.$], 'RadiusScaleUseGlobalValues:ui:vh', [0, false]]);
        return BubbleSeries;
    }(ScatterBase));
    /**
     * @hidden
     */
    var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomPaletteBrushScale, _super);
        function CustomPaletteBrushScale() {
            return _super.call(this) || this;
        }
        CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return _super.prototype.getBrush.call(this, a % this.brushes.count);
            }
            var c = BubbleSeries.uk(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        };
        CustomPaletteBrushScale.prototype.get_isReady = function () {
            return this.brushes != null && this.brushes.count > 0;
        };
        CustomPaletteBrushScale.$t = i2.markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
        CustomPaletteBrushScale.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, i2.enumGetBox(BrushSelectionMode_$type, 0)]]);
        return CustomPaletteBrushScale;
    }(BrushScale));
    /**
     * @hidden
     */
    var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BubbleSeriesView, _super);
        function BubbleSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.df = null;
            _this.df = a;
            _this.cx = new ScatterTrendLineManager();
            return _this;
        }
        BubbleSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
        };
        BubbleSeriesView.prototype.cu = function () {
            var _this = this;
            return new BubbleMarkerManager(function (a) { return _this.cy.item(a); }, function (a) { return _this.cw.rb.c.item(a); }, i2.runOn(this, this.c9), i2.runOn(this, this.cr), i2.runOn(this, this.cz));
        };
        BubbleSeriesView.prototype.dh = function () {
            var a = this.cv;
            this.df.u7(a.n, a.o, this.bu, this == this.e.bw);
            this.aq();
        };
        BubbleSeriesView.prototype.di = function () {
            var a = this.cv;
            this.df.u6(a.n);
        };
        BubbleSeriesView.prototype.dg = function () {
            var e_2, _a;
            var a = this.cv;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    var c = i2.typeCast(i2.DataContext.$, b.content);
                    if (c != null) {
                        c.itemBrush = null;
                        c.outline = null;
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.df.hp + "</span><br/><span>" + "(${item." + this.df.so + "}, ${item." + this.df.ss + "})</span>";
            if (!i2.stringIsNullOrEmpty(this.df.u0)) {
                a += "<span>, Radius: ${item." + this.df.u0 + "}</span>";
            }
            a += "</div>";
            return a;
        };
        BubbleSeriesView.$t = i2.markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
        return BubbleSeriesView;
    }(ScatterBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a brush scale that uses index-based brush selection mode.
    */
    var IgxCustomPaletteBrushScaleComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCustomPaletteBrushScaleComponent, _super);
        function IgxCustomPaletteBrushScaleComponent() {
            return _super.call(this) || this;
        }
        IgxCustomPaletteBrushScaleComponent.prototype.createImplementation = function () {
            return new CustomPaletteBrushScale();
        };
        Object.defineProperty(IgxCustomPaletteBrushScaleComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomPaletteBrushScaleComponent.prototype, "brushSelectionMode", {
            /**
             * Gets or sets the brush selection mode.
            */
            get: function () {
                return this.i.brushSelectionMode;
            },
            set: function (v) {
                this.i.brushSelectionMode = i2.ensureEnum(BrushSelectionMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomPaletteBrushScaleComponent.prototype, "isReady", {
            /**
             * Checks if this scale is ready for useage with a series
            */
            get: function () {
                return this.i.isReady;
            },
            enumerable: false,
            configurable: true
        });
        IgxCustomPaletteBrushScaleComponent.prototype.getBrush1 = function (index, total) {
            var iv = this.i.getBrush1(index, total);
            return i2.brushToString(iv);
        };
        IgxCustomPaletteBrushScaleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCustomPaletteBrushScaleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCustomPaletteBrushScaleComponent, selector: "igx-custom-palette-brush-scale", inputs: { brushSelectionMode: "brushSelectionMode" }, providers: [{ provide: IgxBrushScaleComponent, useExisting: i0.forwardRef(function () { return IgxCustomPaletteBrushScaleComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCustomPaletteBrushScaleComponent;
    }(IgxBrushScaleComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-custom-palette-brush-scale',
                        template: "",
                        providers: [{ provide: IgxBrushScaleComponent, useExisting: i0.forwardRef(function () { return IgxCustomPaletteBrushScaleComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { brushSelectionMode: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomPaletteBrushScaleModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomPaletteBrushScaleModule() {
        }
        IgxCustomPaletteBrushScaleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomPaletteBrushScaleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleModule, declarations: [IgxCustomPaletteBrushScaleComponent], imports: [i1.CommonModule], exports: [IgxCustomPaletteBrushScaleComponent] });
        IgxCustomPaletteBrushScaleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleModule, imports: [[i1.CommonModule]] });
        return IgxCustomPaletteBrushScaleModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCustomPaletteBrushScaleComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCustomPaletteBrushScaleComponent],
                        entryComponents: []
                    }]
            }] });

    /**
     * Represents event arguments class for the AssigningScatterStyleEvent
    */
    var IgxAssigningScatterStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningScatterStyleEventArgs, _super);
        function IgxAssigningScatterStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningScatterStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningScatterStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningScatterStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningScatterStyleEventArgs;
    }(IgxAssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
    */
    var IgxAssigningScatterStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningScatterStyleEventArgsBase, _super);
        function IgxAssigningScatterStyleEventArgsBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAssigningScatterStyleEventArgsBase.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningScatterStyleEventArgsBase;
    }(IgxAssigningSeriesStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningScatterStyleEvent
    */
    var IgxAssigningScatterMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningScatterMarkerStyleEventArgs, _super);
        function IgxAssigningScatterMarkerStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningScatterMarkerStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningScatterMarkerStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningScatterMarkerStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningScatterMarkerStyleEventArgs;
    }(IgxAssigningScatterStyleEventArgsBase));

    /**
     * Represents the base class for all IgxDataChartComponent scatter series
    */
    var IgxScatterBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterBaseComponent, _super);
        function IgxScatterBaseComponent() {
            var _this = _super.call(this) || this;
            _this._assigningScatterStyle = null;
            _this._assigningScatterMarkerStyle = null;
            return _this;
        }
        Object.defineProperty(IgxScatterBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "isScatter", {
            /**
             * Checks if this series is a scatter series
            */
            get: function () {
                return this.i.d6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current object.
            */
            get: function () {
                if (this.i.xAxis == null) {
                    return null;
                }
                if (!this.i.xAxis.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.xAxis);
                    if (e) {
                        e._implementation = this.i.xAxis;
                    }
                    this.i.xAxis.externalObject = e;
                }
                return this.i.xAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current object.
            */
            get: function () {
                if (this.i.yAxis == null) {
                    return null;
                }
                if (!this.i.yAxis.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
                    if (e) {
                        e._implementation = this.i.yAxis;
                    }
                    this.i.yAxis.externalObject = e;
                }
                return this.i.yAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "xMemberPath", {
            /**
             * Gets or sets the value mapping property for the current series object.
            */
            get: function () {
                return this.i.so;
            },
            set: function (v) {
                this.i.so = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "yMemberPath", {
            /**
             * Gets or sets the value mapping property for the current series object.
            */
            get: function () {
                return this.i.ss;
            },
            set: function (v) {
                this.i.ss = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the trend type for the current scatter series.
            */
            get: function () {
                return this.i.trendLineType;
            },
            set: function (v) {
                this.i.trendLineType = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the brush to use to draw the trend line.
            */
            get: function () {
                return i2.brushToString(this.i.trendLineBrush);
            },
            set: function (v) {
                this.i.trendLineBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "actualTrendLineBrush", {
            /**
             * Gets the effective TrendLineBrush for this series.
            */
            get: function () {
                return i2.brushToString(this.i.tz);
            },
            set: function (v) {
                this.i.tz = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the current scatter series object's trend line.
            */
            get: function () {
                return this.i.trendLineThickness;
            },
            set: function (v) {
                this.i.trendLineThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the moving average period for the current scatter series object.
             * The typical, and initial, value for trend line period is 7.
            */
            get: function () {
                return this.i.trendLinePeriod;
            },
            set: function (v) {
                this.i.trendLinePeriod = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "markerCollisionAvoidance", {
            /**
             * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
            */
            get: function () {
                return this.i.q3;
            },
            set: function (v) {
                this.i.q3 = i2.ensureEnum(CollisionAvoidanceType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "trendLineZIndex", {
            /**
             * Gets or sets the Z-Index of the trend line.  Values greater than 1000 will result in the trend line being rendered in front of the series data.
            */
            get: function () {
                return this.i.sd;
            },
            set: function (v) {
                this.i.sd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "maximumMarkers", {
            /**
             * Gets or sets the maximum number of markerItems displayed by the current series.
             * If more than the specified number of markerItems are visible, the series will automatically
             * choose a representative set.
            */
            get: function () {
                return this.i.sc;
            },
            set: function (v) {
                this.i.sc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "itemSearchMode", {
            /**
             * Gets or sets the mode the series will use to find the closest point to the cursor.
            */
            get: function () {
                return this.i.rn;
            },
            set: function (v) {
                this.i.rn = i2.ensureEnum(ScatterItemSearchMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "itemSearchThreshold", {
            /**
             * Gets or sets the threshold to use when searching for items using ItemSearchMode.
            */
            get: function () {
                return this.i.sb;
            },
            set: function (v) {
                this.i.sb = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "actualItemSearchMode", {
            get: function () {
                return this.i.rl;
            },
            set: function (v) {
                this.i.rl = i2.ensureEnum(ScatterItemSearchMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "isCustomScatterStyleAllowed", {
            /**
             * Gets or sets whether this Scatter series should allow custom style overrides of its individual visuals.
            */
            get: function () {
                return this.i.ry;
            },
            set: function (v) {
                this.i.ry = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "isCustomScatterMarkerStyleAllowed", {
            /**
             * Gets or sets whether this Scatter series should allow custom style overrides of its individual marker visuals.
            */
            get: function () {
                return this.i.rx;
            },
            set: function (v) {
                this.i.rx = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxScatterBaseComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxScatterBaseComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
        IgxScatterBaseComponent.prototype.getSeriesValueMarkerBoundingBox = function (world) {
            var iv = this.i.pd(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxScatterBaseComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.rw(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxScatterBaseComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.rv(axis);
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxScatterBaseComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the index of the item that resides at the provided world coordinates.
        
        * @param world  * The world coordinates of the requested item.
        */
        IgxScatterBaseComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        IgxScatterBaseComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        IgxScatterBaseComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        */
        IgxScatterBaseComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        Object.defineProperty(IgxScatterBaseComponent.prototype, "assigningScatterStyle", {
            /**
             * Event raised when Assigning Category Style
            */
            get: function () {
                var _this = this;
                if (this._assigningScatterStyle == null) {
                    this._assigningScatterStyle = new i0.EventEmitter();
                    this.i.assigningScatterStyle = i2.delegateCombine(this.i.assigningScatterStyle, function (o, e) {
                        var outerArgs = new IgxAssigningScatterStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningScatterStyle) {
                            _this.beforeAssigningScatterStyle(_this, outerArgs);
                        }
                        _this._assigningScatterStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningScatterStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterBaseComponent.prototype, "assigningScatterMarkerStyle", {
            /**
             * Event raised when Assigning Scatter Marker Style
            */
            get: function () {
                var _this = this;
                if (this._assigningScatterMarkerStyle == null) {
                    this._assigningScatterMarkerStyle = new i0.EventEmitter();
                    this.i.assigningScatterMarkerStyle = i2.delegateCombine(this.i.assigningScatterMarkerStyle, function (o, e) {
                        var outerArgs = new IgxAssigningScatterMarkerStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningScatterMarkerStyle) {
                            _this.beforeAssigningScatterMarkerStyle(_this, outerArgs);
                        }
                        _this._assigningScatterMarkerStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningScatterMarkerStyle;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterBaseComponent, selector: "ng-component", inputs: { xAxis: "xAxis", yAxis: "yAxis", xMemberPath: "xMemberPath", yMemberPath: "yMemberPath", trendLineType: "trendLineType", trendLineBrush: "trendLineBrush", actualTrendLineBrush: "actualTrendLineBrush", trendLineThickness: "trendLineThickness", trendLinePeriod: "trendLinePeriod", markerCollisionAvoidance: "markerCollisionAvoidance", trendLineZIndex: "trendLineZIndex", maximumMarkers: "maximumMarkers", itemSearchMode: "itemSearchMode", itemSearchThreshold: "itemSearchThreshold", actualItemSearchMode: "actualItemSearchMode", isCustomScatterStyleAllowed: "isCustomScatterStyleAllowed", isCustomScatterMarkerStyleAllowed: "isCustomScatterMarkerStyleAllowed" }, outputs: { assigningScatterStyle: "assigningScatterStyle", assigningScatterMarkerStyle: "assigningScatterMarkerStyle" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxScatterBaseComponent;
    }(IgxMarkerSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }], xMemberPath: [{
                    type: i0.Input
                }], yMemberPath: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], actualTrendLineBrush: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], markerCollisionAvoidance: [{
                    type: i0.Input
                }], trendLineZIndex: [{
                    type: i0.Input
                }], maximumMarkers: [{
                    type: i0.Input
                }], itemSearchMode: [{
                    type: i0.Input
                }], itemSearchThreshold: [{
                    type: i0.Input
                }], actualItemSearchMode: [{
                    type: i0.Input
                }], isCustomScatterStyleAllowed: [{
                    type: i0.Input
                }], isCustomScatterMarkerStyleAllowed: [{
                    type: i0.Input
                }], assigningScatterStyle: [{
                    type: i0.Output
                }], assigningScatterMarkerStyle: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent bubble series.
    */
    var IgxBubbleSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxBubbleSeriesComponent, _super);
        function IgxBubbleSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxBubbleSeriesComponent.prototype.createImplementation = function () {
            return new BubbleSeries();
        };
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "hasOnlyMarkers", {
            /**
             * Gets whether the series has only marker as visuals
            */
            get: function () {
                return this.i.c0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "radiusMemberPath", {
            /**
             * Gets or sets the radius mapping property for the current series object.
            */
            get: function () {
                return this.i.u0;
            },
            set: function (v) {
                this.i.u0 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "radiusScale", {
            /**
             * Gets or sets the radius size scale for the bubbles.
            */
            get: function () {
                if (this.i.t8 == null) {
                    return null;
                }
                if (!this.i.t8.externalObject) {
                    var e = IgxSizeScaleComponent._createFromInternal(this.i.t8);
                    if (e) {
                        e._implementation = this.i.t8;
                    }
                    this.i.t8.externalObject = e;
                }
                return this.i.t8.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.t8 = null : this.i.t8 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "labelMemberPath", {
            /**
             * Gets or sets the Label mapping property for the current series object.
            */
            get: function () {
                return this.i.uu;
            },
            set: function (v) {
                this.i.uu = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "fillMemberPath", {
            /**
             * Gets or sets the fill mapping property for the current series object.
            */
            get: function () {
                return this.i.up;
            },
            set: function (v) {
                this.i.up = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "fillScale", {
            /**
             * Gets or sets the brush scale for the fill brush of markers.
            */
            get: function () {
                if (this.i.t6 == null) {
                    return null;
                }
                if (!this.i.t6.externalObject) {
                    var e = IgxBrushScaleComponent._createFromInternal(this.i.t6);
                    if (e) {
                        e._implementation = this.i.t6;
                    }
                    this.i.t6.externalObject = e;
                }
                return this.i.t6.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.t6 = null : this.i.t6 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "fillScaleUseGlobalValues", {
            /**
             * Gets or sets whether or not the FillScale uses global min/max values of FillMemberPath from multiple series.
             * This setting applies only if multiple series are using the same FillScale.
            */
            get: function () {
                return this.i.ug;
            },
            set: function (v) {
                this.i.ug = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "markerOutlineUsesFillScale", {
            /**
             * Gets or sets whether or not the marker outline should use FillScale like the marker fill does.
             * This setting applies only if the current series has a FillScale set and it overrides MarkerOutline setting.
            */
            get: function () {
                return this.i.uh;
            },
            set: function (v) {
                this.i.uh = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "markerOutlineBrightness", {
            /**
             * Gets or sets brightness of the marker outline. Using negative value will change marker outline to darker color and positive value will change marker outline to brighter color
             * Note you can use any values between minimum value of -1 (darkest outline) and maximum value of 1 (brightest outline)
            */
            get: function () {
                return this.i.un;
            },
            set: function (v) {
                this.i.un = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "markerBrushBrightness", {
            /**
             * Gets or sets brightness of the marker fill. Using negative value will change marker fill to darker color and positive value will change marker fill to brighter color
             * Note you can use any values between minimum value of -1 (darkest fill) and maximum value of 1 (brightest fill)
            */
            get: function () {
                return this.i.um;
            },
            set: function (v) {
                this.i.um = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBubbleSeriesComponent.prototype, "radiusScaleUseGlobalValues", {
            /**
             * Gets or sets the whether or not the RadiusScale uses global values of RadiusMemberPath from multiple series.
             * This setting applies only if multiple series are using the same RadiusScale.
            */
            get: function () {
                return this.i.ui;
            },
            set: function (v) {
                this.i.ui = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxBubbleSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.radiusScale && this.radiusScale.name && this.radiusScale.name == name) {
                return this.radiusScale;
            }
            if (this.fillScale && this.fillScale.name && this.fillScale.name == name) {
                return this.fillScale;
            }
            return null;
        };
        IgxBubbleSeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.radiusScale && this.radiusScale._styling) {
                this.radiusScale._styling(container, component, this);
            }
            if (this.fillScale && this.fillScale._styling) {
                this.fillScale._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxBubbleSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        IgxBubbleSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxBubbleSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxBubbleSeriesComponent, selector: "igx-bubble-series", inputs: { radiusMemberPath: "radiusMemberPath", radiusScale: "radiusScale", labelMemberPath: "labelMemberPath", fillMemberPath: "fillMemberPath", fillScale: "fillScale", fillScaleUseGlobalValues: "fillScaleUseGlobalValues", markerOutlineUsesFillScale: "markerOutlineUsesFillScale", markerOutlineBrightness: "markerOutlineBrightness", markerBrushBrightness: "markerBrushBrightness", radiusScaleUseGlobalValues: "radiusScaleUseGlobalValues" }, providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBubbleSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxBubbleSeriesComponent;
    }(IgxScatterBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-bubble-series',
                        template: "",
                        providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBubbleSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusMemberPath: [{
                    type: i0.Input
                }], radiusScale: [{
                    type: i0.Input
                }], labelMemberPath: [{
                    type: i0.Input
                }], fillMemberPath: [{
                    type: i0.Input
                }], fillScale: [{
                    type: i0.Input
                }], fillScaleUseGlobalValues: [{
                    type: i0.Input
                }], markerOutlineUsesFillScale: [{
                    type: i0.Input
                }], markerOutlineBrightness: [{
                    type: i0.Input
                }], markerBrushBrightness: [{
                    type: i0.Input
                }], radiusScaleUseGlobalValues: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBubbleSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBubbleSeriesModule() {
        }
        IgxBubbleSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBubbleSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesModule, declarations: [IgxBubbleSeriesComponent], imports: [i1.CommonModule, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule], exports: [IgxBubbleSeriesComponent, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule] });
        IgxBubbleSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesModule, imports: [[i1.CommonModule, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule], IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule] });
        return IgxBubbleSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxBubbleSeriesComponent],
                        imports: [i1.CommonModule, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule],
                        exports: [IgxBubbleSeriesComponent, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBubbleSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBubbleSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxBubbleSeriesComponent", IgxBubbleSeriesComponent);
            i2.TypeRegistrar.register("BubbleSeries", BubbleSeries.$type);
        }
        IgxBubbleSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBubbleSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesDynamicModule, imports: [i1.CommonModule, IgxBubbleSeriesModule], exports: [IgxBubbleSeriesModule] });
        IgxBubbleSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesDynamicModule, imports: [[i1.CommonModule, IgxBubbleSeriesModule], IgxBubbleSeriesModule] });
        return IgxBubbleSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBubbleSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxBubbleSeriesModule],
                        exports: [IgxBubbleSeriesModule],
                        entryComponents: [IgxBubbleSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterSeries, _super);
        function ScatterSeries() {
            var _this = _super.call(this) || this;
            _this.ab = ScatterSeries.$;
            _this.rh = new ScatterFrame();
            _this.rj = new ScatterFrame();
            _this.rf = new ScatterFrame();
            return _this;
        }
        ScatterSeries.prototype.get_c0 = function () {
            return true;
        };
        ScatterSeries.prototype.bu = function () {
            return new ScatterSeriesView(this);
        };
        ScatterSeries.prototype.gi = function () {
            return 0.7;
        };
        ScatterSeries.prototype.pl = function () {
            if (this.pk == 0) {
                return 2;
            }
            return _super.prototype.pl.call(this);
        };
        ScatterSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t4 = a;
        };
        ScatterSeries.$t = i2.markType(ScatterSeries, 'ScatterSeries', ScatterBase.$);
        return ScatterSeries;
    }(ScatterBase));
    /**
     * @hidden
     */
    var ScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterSeriesView, _super);
        function ScatterSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.df = null;
            _this.df = a;
            return _this;
        }
        ScatterSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b1.pr = Defaults.e;
            }
        };
        ScatterSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 2;
            this.e.gl = 2;
            this.e.e1 = false;
        };
        ScatterSeriesView.$t = i2.markType(ScatterSeriesView, 'ScatterSeriesView', ScatterBaseView.$);
        return ScatterSeriesView;
    }(ScatterBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent scatter series
    */
    var IgxScatterSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterSeriesComponent, _super);
        function IgxScatterSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterSeriesComponent.prototype.createImplementation = function () {
            return new ScatterSeries();
        };
        Object.defineProperty(IgxScatterSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterSeriesComponent.prototype, "hasOnlyMarkers", {
            /**
             * Gets whether the series has only marker as visuals
            */
            get: function () {
                return this.i.c0;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterSeriesComponent, selector: "igx-scatter-series", providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterSeriesComponent;
    }(IgxScatterBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-series',
                        template: "",
                        providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterSeriesModule() {
        }
        IgxScatterSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesModule, declarations: [IgxScatterSeriesComponent], imports: [i1.CommonModule], exports: [IgxScatterSeriesComponent] });
        IgxScatterSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesModule, imports: [[i1.CommonModule]] });
        return IgxScatterSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxScatterSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterSeriesComponent", IgxScatterSeriesComponent);
            i2.TypeRegistrar.register("ScatterSeries", ScatterSeries.$type);
        }
        IgxScatterSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterSeriesModule], exports: [IgxScatterSeriesModule] });
        IgxScatterSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterSeriesModule], IgxScatterSeriesModule] });
        return IgxScatterSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterSeriesModule],
                        exports: [IgxScatterSeriesModule],
                        entryComponents: [IgxScatterSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterLineSeriesView, _super);
        function ScatterLineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.dg = new i2.Path();
            _this.df = new i2.Path();
            return _this;
        }
        ScatterLineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.e.gh = Defaults.x;
                this.b1.pr = Defaults.e;
            }
        };
        ScatterLineSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        ScatterLineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.df.ak = this.dg.ak;
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
        };
        ScatterLineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.df);
                }
                else {
                    a.s(this.dg);
                }
            }
        };
        ScatterLineSeriesView.prototype.c4 = function (a) {
            _super.prototype.c4.call(this, a);
            this.dg.ak = null;
            this.df.ak = null;
        };
        ScatterLineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dg, "shape", ["Main"]);
        };
        ScatterLineSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        ScatterLineSeriesView.$t = i2.markType(ScatterLineSeriesView, 'ScatterLineSeriesView', ScatterBaseView.$);
        return ScatterLineSeriesView;
    }(ScatterBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterLineSeries, _super);
        function ScatterLineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = ScatterLineSeries.$;
            _this.rh = new ScatterFrame();
            _this.rj = new ScatterFrame();
            _this.rf = new ScatterFrame();
            var a = function (b, c, d) {
                var e = _this.ch.indexOf(b.a);
                if (e == -1 || e == 0) {
                    return b;
                }
                var f = _this.ch.item(e - 1);
                var g;
                if (!((function () { var h = c.g.tryGetValue(f, g); g = h.p1; return h.ret; })())) {
                    return b;
                }
                return g;
            };
            _this.rh.o = a;
            _this.rj.o = a;
            _this.rf.o = a;
            return _this;
        }
        ScatterLineSeries.prototype.get_dv = function () {
            return true;
        };
        ScatterLineSeries.prototype.bu = function () {
            return new ScatterLineSeriesView(this);
        };
        ScatterLineSeries.prototype.ep = function (a, b) {
            if (this.pu(a, b)) {
                return true;
            }
            if (this.t5(a, b)) {
                return true;
            }
            return false;
        };
        ScatterLineSeries.prototype.t5 = function (a, b) {
            var c = this.bx;
            var d = c.dg;
            return this.eq(a, b, d.ak);
        };
        ScatterLineSeries.prototype.s3 = function (a, b) {
            var _this = this;
            _super.prototype.s3.call(this, a, b);
            a.m.clear();
            a.u.clear();
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.gh * this.gh;
            var g = 0;
            if (this.rr != null) {
                g = this.rr.count;
            }
            if (this.rs != null) {
                g = Math.min(this.rs.count, g);
            }
            var h = new ScalerParams(0, c, d, this.rb.d, e);
            var i = ((function () {
                var $ret = new ScalerParams(0, c, d, _this.rb.e, e);
                $ret.b = _this.f2();
                return $ret;
            })());
            var j = i2.arrayShallowClone(this.rr.asArray());
            var k = i2.arrayShallowClone(this.rs.asArray());
            this.xAxis.g5(i2.boxArray$1(j), 0, j.length, h);
            this.yAxis.g5(i2.boxArray$1(k), 0, k.length, i);
            var l = d.top - 10;
            var m = d.bottom + 10;
            var n = d.left - 10;
            var o = d.right + 10;
            var p = ((function () {
                var $ret = new i2.Clipper(1, n, m, o, l, false);
                $ret.i = a.m;
                return $ret;
            })());
            for (var q = 0; q < g;) {
                var r = q;
                ++q;
                if (g > this.sc) {
                    while (q < g) {
                        var s = j[q] - j[r];
                        var t = k[q] - k[r];
                        var u = s * s + t * t;
                        if (u >= f) {
                            break;
                        }
                        ++q;
                    }
                    p.j(this.uc(j, k, r, q - 1));
                }
                else {
                    var v = new OwnedPoint();
                    v.c = { $type: i2.Point_$type, x: j[r], y: k[r] };
                    v.a = this.ch.item(r);
                    if (!a.u.containsKey(v.a)) {
                        a.u.addItem(v.a, v);
                    }
                }
            }
            if (g > this.sc) {
                p.i = null;
            }
        };
        ScatterLineSeries.prototype.uc = function (a, b, c, d) {
            if (c == d) {
                return { $type: i2.Point_$type, x: a[c], y: b[c] };
            }
            var e = 0;
            var f = 0;
            var g = (d - c + 1);
            for (var h = c; h <= d; ++h) {
                e += a[h];
                f += b[h];
            }
            return { $type: i2.Point_$type, x: e / g, y: f / g };
        };
        ScatterLineSeries.prototype.get_rz = function () {
            return true;
        };
        ScatterLineSeries.prototype.te = function (a, b) {
            b.c4(false);
            _super.prototype.te.call(this, a, b);
            var c = this.getEffectiveViewport1(b);
            var d = new i2.Rect(0, b.bu.left, b.bu.top, b.bu.width, b.bu.height);
            d = i2.RectUtil.t(d, this.fl, this.fl);
            this.s7(a, new i2.Clipper(0, d, false));
            var e = i2.typeCast(ScatterLineSeriesView.$, b);
            this.ro.ax(this, this.r4(), i2.runOn(this, this.qz));
            var f = false;
            var g = this.ro.b;
            if (g != null) {
                f = true;
            }
            if (f) {
                this.sz(-1, this.rr.count, b.q);
            }
            this.ro.ad(e.dg, true, false, true, false);
            this.ua(e.dg, a.m.count, function (h) { return a.m._inner[h].x; }, function (h) { return a.m._inner[h].y; }, this.t4, this.gh);
        };
        ScatterLineSeries.prototype.ua = function (a, b, c, d, e, f) {
            var g = new i2.PathGeometry();
            a.ak = g;
            g.c = new i2.PathFigureCollection();
            var h = new i2.List$1(i2.PolyLineSegment.$, 0);
            var i = 0;
            for (var j = 0; j < b; j++) {
                if (i2.isNaN_(c(j)) || i2.isNaN_(d(j))) {
                    var k = j - i;
                    if (k > 0) {
                        if (e == 1 || h.count == 0) {
                            var l = new i2.PolyLineSegment();
                            h.add(l);
                        }
                        this.t9(h._inner[h.count - 1]._points, i, j - 1, c, d, f);
                    }
                    i = j + 1;
                }
            }
            if (e == 1 || h.count == 0) {
                var m = new i2.PolyLineSegment();
                h.add(m);
            }
            this.t9(h._inner[h.count - 1]._points, i, b - 1, c, d, f);
            var _loop_1 = function (n) {
                var o = h._inner[n];
                if (o._points.count > 0) {
                    var p = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.startPoint = o._points._inner[0];
                        return $ret;
                    })());
                    p._segments.add(o);
                    g.c.add(p);
                }
            };
            for (var n = 0; n < h.count; n++) {
                _loop_1(n);
            }
        };
        ScatterLineSeries.prototype.t6 = function (a, b, c, d, e, f) {
            var g = new i2.List$1(i2.Number_$type, 0);
            var h = d;
            var i = e;
            var j = i - h + 1;
            while (j > 0) {
                if (j <= 512) {
                    i2.Flattener.c(g, b, c, h, i, f);
                    h = i + 1;
                }
                else {
                    var k = h + 512 - 1;
                    i2.Flattener.c(g, b, c, h, k, f);
                    h = k + 1;
                }
                j = i - h + 1;
            }
            return g;
        };
        ScatterLineSeries.prototype.t9 = function (a, b, c, d, e, f) {
            if (c > -1) {
                var g = this.gh;
                var h = this.t6(new i2.List$1(i2.Number_$type, 0), d, e, b, c, g);
                var i = void 0;
                for (var j = 0; j < h.count; j++) {
                    i = h.item(j);
                    a.add({ $type: i2.Point_$type, x: d(i), y: e(i) });
                }
            }
        };
        ScatterLineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case ScatterLineSeries.$$p[0]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        ScatterLineSeries.$t = i2.markType(ScatterLineSeries, 'ScatterLineSeries', ScatterBase.$);
        ScatterLineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:t4:ub', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)]]);
        return ScatterLineSeries;
    }(ScatterBase));

    /**
     * Represents a IgxDataChartComponent scatter line series
    */
    var IgxScatterLineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterLineSeriesComponent, _super);
        function IgxScatterLineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterLineSeriesComponent.prototype.createImplementation = function () {
            return new ScatterLineSeries();
        };
        Object.defineProperty(IgxScatterLineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterLineSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterLineSeriesComponent.prototype, "unknownValuePlotting", {
            /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
            get: function () {
                return this.i.t4;
            },
            set: function (v) {
                this.i.t4 = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterLineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterLineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterLineSeriesComponent, selector: "igx-scatter-line-series", inputs: { unknownValuePlotting: "unknownValuePlotting" }, providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterLineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterLineSeriesComponent;
    }(IgxScatterBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-line-series',
                        template: "",
                        providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterLineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { unknownValuePlotting: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterLineSeriesModule() {
        }
        IgxScatterLineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterLineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesModule, declarations: [IgxScatterLineSeriesComponent], imports: [i1.CommonModule], exports: [IgxScatterLineSeriesComponent] });
        IgxScatterLineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxScatterLineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterLineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxScatterLineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterLineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterLineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterLineSeriesComponent", IgxScatterLineSeriesComponent);
            i2.TypeRegistrar.register("ScatterLineSeries", ScatterLineSeries.$type);
        }
        IgxScatterLineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterLineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterLineSeriesModule], exports: [IgxScatterLineSeriesModule] });
        IgxScatterLineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterLineSeriesModule], IgxScatterLineSeriesModule] });
        return IgxScatterLineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterLineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterLineSeriesModule],
                        exports: [IgxScatterLineSeriesModule],
                        entryComponents: [IgxScatterLineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterSplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterSplineSeriesView, _super);
        function ScatterSplineSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.dg = new i2.Path();
            _this.df = new i2.Path();
            return _this;
        }
        ScatterSplineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.e.gh = Defaults.x;
                this.b1.pr = Defaults.e;
            }
        };
        ScatterSplineSeriesView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        ScatterSplineSeriesView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            this.df.ak = this.dg.ak;
            var a = this.bo();
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
        };
        ScatterSplineSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.df);
                }
                else {
                    a.s(this.dg);
                }
            }
        };
        ScatterSplineSeriesView.prototype.c4 = function (a) {
            _super.prototype.c4.call(this, a);
            this.dg.ak = null;
            this.df.ak = null;
        };
        ScatterSplineSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dg, "shape", ["Main"]);
        };
        ScatterSplineSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 3;
            this.e.gk = 1;
            this.e.gl = 4;
            this.e.e1 = false;
        };
        ScatterSplineSeriesView.$t = i2.markType(ScatterSplineSeriesView, 'ScatterSplineSeriesView', ScatterBaseView.$);
        return ScatterSplineSeriesView;
    }(ScatterBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterSplineSeries, _super);
        function ScatterSplineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = ScatterSplineSeries.$;
            _this.rh = new ScatterFrame();
            _this.rj = new ScatterFrame();
            _this.rf = new ScatterFrame();
            return _this;
        }
        ScatterSplineSeries.prototype.get_ea = function () {
            return true;
        };
        ScatterSplineSeries.prototype.bu = function () {
            return new ScatterSplineSeriesView(this);
        };
        ScatterSplineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case ScatterSplineSeries.$$p[0]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        ScatterSplineSeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 2;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        ScatterSplineSeries.prototype.s3 = function (a, b) {
            var _this = this;
            _super.prototype.s3.call(this, a, b);
            a.m.clear();
            a.u.clear();
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = this.gh * this.gh;
            var g = Math.min(this.rr != null ? this.rr.count : 0, this.rs != null ? this.rs.count : 0);
            var h = new ScalerParams(0, c, d, this.rb.d, e);
            var i = ((function () {
                var $ret = new ScalerParams(0, c, d, _this.rb.e, e);
                $ret.b = _this.f2();
                return $ret;
            })());
            var j = function (k) { return _this.rb.a.d8(_this.rr.item(k), h); };
            var k = function (l) { return _this.rb.b.d8(_this.rs.item(l), i); };
            var l = ((function () {
                var $ret = new i2.Clipper(0, d, false);
                $ret.i = a.m;
                return $ret;
            })());
            for (var m = 0; m < g;) {
                var n = m;
                ++m;
                while (m < g && this.t4(j, k, n, m) < f) {
                    ++m;
                }
                if (g > this.sc) {
                    l.j(this.t8(j, k, n, m - 1));
                }
                else {
                    var o = new OwnedPoint();
                    o.c = { $type: i2.Point_$type, x: j(n), y: k(n) };
                    o.a = this.ch.item(n);
                    if (!a.u.containsKey(o.a)) {
                        a.u.addItem(o.a, o);
                    }
                }
            }
            if (g > this.sc) {
                l.i = null;
            }
        };
        ScatterSplineSeries.prototype.t8 = function (a, b, c, d) {
            if (c == d) {
                return { $type: i2.Point_$type, x: a(c), y: b(c) };
            }
            var e = 0;
            var f = 0;
            var g = (d - c + 1);
            for (var h = c; h <= d; ++h) {
                e += a(h);
                f += b(h);
            }
            return { $type: i2.Point_$type, x: e / g, y: f / g };
        };
        ScatterSplineSeries.prototype.t4 = function (a, b, c, d) {
            var e = a(d) - a(c);
            var f = b(d) - b(c);
            return e * e + f * f;
        };
        ScatterSplineSeries.prototype.get_rz = function () {
            return true;
        };
        ScatterSplineSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = i2.typeCast(ScatterSplineSeriesView.$, b);
            c.c4(false);
        };
        ScatterSplineSeries.prototype.te = function (a, b) {
            this.kh(false, b);
            _super.prototype.te.call(this, a, b);
            this.s6(a);
            var c = i2.typeCast(ScatterSplineSeriesView.$, b);
            var d = c.dg;
            this.ro.ax(this, this.r4(), i2.runOn(this, this.qz));
            var e = false;
            var f = this.ro.b;
            if (f != null) {
                e = true;
            }
            if (e) {
                this.sz(-1, this.rr.count, b.q);
            }
            this.ro.ad(d, true, false, true, false);
            c.dg.ak = new i2.PathGeometry();
            c.dg.ak.c = i2.Numeric.h(a.m.count, function (g) { return a.m._inner[g].x; }, function (g) { return a.m._inner[g].y; }, this.t5);
        };
        ScatterSplineSeries.$t = i2.markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
        ScatterSplineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:t5:t7', [1, 0.5]]);
        return ScatterSplineSeries;
    }(ScatterBase));

    /**
     * Represents a IgxDataChartComponent scatter spline series
    */
    var IgxScatterSplineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterSplineSeriesComponent, _super);
        function IgxScatterSplineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterSplineSeriesComponent.prototype.createImplementation = function () {
            return new ScatterSplineSeries();
        };
        Object.defineProperty(IgxScatterSplineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterSplineSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterSplineSeriesComponent.prototype, "stiffness", {
            /**
             * Gets or sets the Stiffness property.
            */
            get: function () {
                return this.i.t5;
            },
            set: function (v) {
                this.i.t5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterSplineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterSplineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterSplineSeriesComponent, selector: "igx-scatter-spline-series", inputs: { stiffness: "stiffness" }, providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterSplineSeriesComponent;
    }(IgxScatterBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-spline-series',
                        template: "",
                        providers: [{ provide: IgxScatterBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { stiffness: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterSplineSeriesModule() {
        }
        IgxScatterSplineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterSplineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesModule, declarations: [IgxScatterSplineSeriesComponent], imports: [i1.CommonModule], exports: [IgxScatterSplineSeriesComponent] });
        IgxScatterSplineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxScatterSplineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterSplineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxScatterSplineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterSplineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterSplineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterSplineSeriesComponent", IgxScatterSplineSeriesComponent);
            i2.TypeRegistrar.register("ScatterSplineSeries", ScatterSplineSeries.$type);
        }
        IgxScatterSplineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterSplineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterSplineSeriesModule], exports: [IgxScatterSplineSeriesModule] });
        IgxScatterSplineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterSplineSeriesModule], IgxScatterSplineSeriesModule] });
        return IgxScatterSplineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterSplineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterSplineSeriesModule],
                        exports: [IgxScatterSplineSeriesModule],
                        entryComponents: [IgxScatterSplineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Provides information about the progressive load progress of the HighDensityScatterSeries.
    */
    var IgxProgressiveLoadStatusEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxProgressiveLoadStatusEventArgs() {
        }
        Object.defineProperty(IgxProgressiveLoadStatusEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxProgressiveLoadStatusEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxProgressiveLoadStatusEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxProgressiveLoadStatusEventArgs.prototype, "currentStatus", {
            /**
             * The current status from 0 to 100 of the progressive load.
            */
            get: function () {
                return this.i.currentStatus;
            },
            set: function (v) {
                this.i.currentStatus = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxProgressiveLoadStatusEventArgs;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var KDTreeNode2D = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(KDTreeNode2D, _super);
        function KDTreeNode2D() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.g = false;
            _this.f = false;
            _this.h = 0;
            _this.b = null;
            _this.c = null;
            _this.d = null;
            _this.a = null;
            _this.e = null;
            return _this;
        }
        KDTreeNode2D.$t = i2.markType(KDTreeNode2D, 'KDTreeNode2D');
        return KDTreeNode2D;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var KDTreeThunk = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(KDTreeThunk, _super);
        function KDTreeThunk() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.e = 0;
            _this.b = 0;
            _this.c = 0;
            _this.d = 0;
            _this.a = null;
            return _this;
        }
        KDTreeThunk.$t = i2.markType(KDTreeThunk, 'KDTreeThunk');
        return KDTreeThunk;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var KNearestResult = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(KNearestResult, _super);
        function KNearestResult() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.e = 0;
            _this.b = false;
            _this.c = 0;
            _this.d = 0;
            _this.a = null;
            return _this;
        }
        KNearestResult.$t = i2.markType(KNearestResult, 'KNearestResult');
        return KNearestResult;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SearchData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SearchData, _super);
        function SearchData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = false;
            _this.d = 0;
            _this.b = 0;
            _this.e = 0;
            _this.c = 0;
            return _this;
        }
        SearchData.$t = i2.markType(SearchData, 'SearchData');
        return SearchData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var KDTree2D = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(KDTree2D, _super);
        function KDTree2D(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.h = null;
            _this.g = null;
            _this.k = 0;
            _this.o = {};
            _this.progressiveThunkCompleted = null;
            _this.e = false;
            _this.q = new i2.Random(0);
            _this.d = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        _this.d = _this.c(c, 0, c.length - 1, 0, d);
                    }
                    break;
                case 1: break;
            }
            return _this;
        }
        Object.defineProperty(KDTree2D.prototype, "p", {
            get: function () {
                return this.o;
            },
            enumerable: false,
            configurable: true
        });
        KDTree2D.b = function (a, b) {
            var c = new KDTree2D(1);
            c.d = new KDTreeNode2D();
            c.d.g = true;
            c.a = a;
            c.h = new i2.Stack$1(KDTreeThunk.$);
            c.g = new i2.List$1(KDTreeThunk.$, 0);
            var d = new KDTreeThunk();
            d.e = 0;
            d.b = a.length - 1;
            d.c = 0;
            d.d = b;
            d.a = c.d;
            c.h.h(d);
            return c;
        };
        KDTree2D.prototype.f = function (a) {
            if (this.h.f == 0 && this.g.count == 0) {
                this.a = null;
                return false;
            }
            if (this.h.f == 0 && this.g.count > 0) {
                return true;
            }
            this.k = this.h.d().c;
            while (this.h.f > 0 && this.h.d().c == this.k) {
                this.g.add(this.h.e());
            }
            if (a != null) {
                a.setTimeout(i2.runOn(this, this.y), 0);
            }
            else {
                window.setTimeout(i2.runOn(this, this.y), 0);
            }
            return true;
        };
        KDTree2D.prototype.s = function () {
            this.e = true;
        };
        KDTree2D.prototype.y = function () {
            var a;
            for (var b = 0; b < this.g.count; b++) {
                if (this.e || this.a == null) {
                    return;
                }
                if (this.a.length == 0) {
                    continue;
                }
                a = this.g._inner[b];
                this.v(a.a, this.a, a.e, a.b, a.c, a.d);
            }
            this.g.clear();
            if (this.progressiveThunkCompleted != null) {
                this.progressiveThunkCompleted(this, new i2.EventArgs());
            }
        };
        KDTree2D.prototype.v = function (a, b, c, d, e, f) {
            a.g = false;
            a.f = (e % 2) == 0;
            a.h = (d - c);
            if (c == d) {
                a.b = b[c];
                return;
            }
            if (c > d) {
                a.g = true;
                return;
            }
            if ((d - c) + 1 <= f) {
                a.b = b[c];
                a.a = new Array((d - c) + 1);
                var g = 0;
                for (var h = c; h <= d; h++) {
                    a.a[g++] = b[h];
                }
                return;
            }
            var i = Math.max(i2.intDivide((d - c), 2), 1);
            var j = this.m(b, c, d, a.f, i);
            a.b = b[j];
            if (c <= j - 1) {
                a.c = ((function () {
                    var $ret = new KDTreeNode2D();
                    $ret.g = true;
                    return $ret;
                })());
                a.c.h = ((j - 1) - c) + 1;
                this.h.h(((function () {
                    var $ret = new KDTreeThunk();
                    $ret.e = c;
                    $ret.b = j - 1;
                    $ret.c = e + 1;
                    $ret.d = f;
                    $ret.a = a.c;
                    return $ret;
                })()));
            }
            else {
                a.c = null;
            }
            if (j + 1 <= d) {
                a.d = ((function () {
                    var $ret = new KDTreeNode2D();
                    $ret.g = true;
                    return $ret;
                })());
                a.d.h = (d - (j + 1)) + 1;
                this.h.h(((function () {
                    var $ret = new KDTreeThunk();
                    $ret.e = j + 1;
                    $ret.b = d;
                    $ret.c = e + 1;
                    $ret.d = f;
                    $ret.a = a.d;
                    return $ret;
                })()));
            }
            else {
                a.d = null;
            }
        };
        KDTree2D.prototype.c = function (a, b, c, d, e) {
            var f = new KDTreeNode2D();
            f.f = (d % 2) == 0;
            f.h = (c - b);
            if (b == c) {
                f.b = a[b];
                return f;
            }
            if (b > c) {
                return null;
            }
            if ((c - b) + 1 <= e) {
                f.b = a[b];
                f.a = new Array(c - b + 1);
                var g = 0;
                for (var h = b; h <= c; h++) {
                    f.a[g++] = a[h];
                }
                return f;
            }
            var i = Math.max(i2.intDivide((c - b), 2), 1);
            var j = this.m(a, b, c, f.f, i);
            f.b = a[j];
            f.c = this.c(a, b, j - 1, d + 1, e);
            f.d = this.c(a, j + 1, c, d + 1, e);
            return f;
        };
        KDTree2D.prototype.l = function (a, b, c, d, e) {
            var f = b ? a[e].a : a[e].b;
            var g = a[e];
            a[e] = a[d];
            a[d] = g;
            var h = c;
            for (var i = c; i < d; i++) {
                var j = void 0;
                if (b) {
                    j = a[i].a;
                }
                else {
                    j = a[i].b;
                }
                if (j <= f) {
                    g = a[h];
                    a[h] = a[i];
                    a[i] = g;
                    h++;
                }
            }
            g = a[d];
            a[d] = a[h];
            a[h] = g;
            return h;
        };
        KDTree2D.prototype.m = function (a, b, c, d, e) {
            if (b == c) {
                return b;
            }
            var f = this.q.next2(b, c);
            var g = this.l(a, d, b, c, f);
            var h = g - b + 1;
            if (h == e) {
                return g;
            }
            else if (e < h) {
                return this.m(a, b, g - 1, d, e);
            }
            else {
                return this.m(a, g + 1, c, d, e - h);
            }
        };
        KDTree2D.prototype.w = function (a, b, c, d) {
            this.x(a, b, c, d, this.d);
        };
        KDTree2D.prototype.x = function (a, b, c, d, e) {
            if (e == null || e.g) {
                return;
            }
            if (e.c == null && e.d == null) {
                this.r(a, b, c, e, e.b, true, 0, d);
                if (a.a) {
                    return;
                }
                if (e.a != null && e.a.length > 0) {
                    for (var f = 0; f < e.a.length; f++) {
                        this.r(a, b, c, e, e.a[f], false, f, d);
                        if (a.a) {
                            return;
                        }
                    }
                }
                return;
            }
            this.r(a, b, c, e, e.b, true, 0, d);
            if (a.a) {
                return;
            }
            if (e.f) {
                if (b <= e.b.a) {
                    this.x(a, b, c, d, e.c);
                    if (a.a) {
                        return;
                    }
                    if (this.i(b, c, e.b.a, c) < a.c) {
                        this.x(a, b, c, d, e.d);
                    }
                    if (a.a) {
                        return;
                    }
                }
                else {
                    this.x(a, b, c, d, e.d);
                    if (a.a) {
                        return;
                    }
                    if (this.i(b, c, e.b.a, c) < a.c) {
                        this.x(a, b, c, d, e.c);
                    }
                    if (a.a) {
                        return;
                    }
                }
            }
            else {
                if (c <= e.b.b) {
                    this.x(a, b, c, d, e.c);
                    if (a.a) {
                        return;
                    }
                    if (this.i(b, c, b, e.b.b) < a.c) {
                        this.x(a, b, c, d, e.d);
                    }
                    if (a.a) {
                        return;
                    }
                }
                else {
                    this.x(a, b, c, d, e.d);
                    if (a.a) {
                        return;
                    }
                    if (this.i(b, c, b, e.b.b) < a.c) {
                        this.x(a, b, c, d, e.c);
                    }
                    if (a.a) {
                        return;
                    }
                }
            }
        };
        KDTree2D.prototype.r = function (a, b, c, d, e, f, g, h) {
            if (a.a) {
                return;
            }
            if (a.e > a.f) {
                a.a = true;
                return;
            }
            if (a.b.count < h) {
                if (i2.isNaN_(a.d)) {
                    a.d = this.i(b, c, e.a, e.b);
                    a.c = a.d;
                    a.g = 0;
                }
                a.b.add(((function () {
                    var $ret = new KNearestResult();
                    $ret.b = f;
                    $ret.e = g;
                    $ret.a = d;
                    $ret.c = e.a;
                    $ret.d = e.b;
                    return $ret;
                })()));
                a.e++;
                var i = this.i(b, c, e.a, e.b);
                if (i < a.d) {
                    a.d = i;
                }
                if (i > a.c) {
                    a.c = i;
                    a.g = a.b.count - 1;
                }
                return;
            }
            var j = 0;
            if (j < a.c) {
                if (j < a.d) {
                    a.d = j;
                }
                a.b._inner[a.g] = ((function () {
                    var $ret = new KNearestResult();
                    $ret.b = f;
                    $ret.e = g;
                    $ret.a = d;
                    $ret.c = e.a;
                    $ret.d = e.b;
                    return $ret;
                })());
                var k = 0;
                var l = 0;
                for (var m = 0; m < a.b.count; m++) {
                    var n = this.i(b, c, a.b._inner[m].c, a.b._inner[m].d);
                    if (n > k) {
                        k = n;
                        l = m;
                    }
                }
                a.e++;
            }
        };
        KDTree2D.prototype.i = function (a, b, c, d) {
            return (a - c) * (a - c) + (b - d) * (b - d);
        };
        KDTree2D.prototype.t = function (a, b, c, d, e, f) {
            this.u(a, this.d, b, c, d, e, f, false, 0);
        };
        KDTree2D.prototype.u = function (a, b, c, d, e, f, g, h, i) {
            if (b == null) {
                return;
            }
            var j = b.e;
            if (i > c.g || ((g - f) < c.f && (e - d) < c.e)) {
                if (b.e == null) {
                    b.e = new SearchData();
                }
                j = b.e;
                j.a = true;
                j.d = d;
                j.b = e;
                j.e = f;
                j.c = g;
                a.add(b);
                return;
            }
            if (j != null) {
                j.a = false;
            }
            if (b.c == null && b.d == null) {
                a.add(b);
                return;
            }
            var k;
            var l;
            var m;
            var n;
            var o;
            var p;
            var q;
            var r;
            if (b.f) {
                k = d;
                l = b.b.a;
                m = f;
                n = g;
                o = b.b.a;
                p = e;
                q = f;
                r = g;
            }
            else {
                k = d;
                l = e;
                m = f;
                n = b.b.b;
                o = d;
                p = e;
                q = b.b.b;
                r = g;
            }
            if (h) {
                a.add(b);
                this.u(a, b.c, c, k, l, m, n, true, i + 1);
                this.u(a, b.d, c, o, p, q, r, true, i + 1);
            }
            else {
                var s = false;
                if (k >= c.c && l <= c.a && m >= c.d && n <= c.b) {
                    s = true;
                    a.add(b);
                    this.u(a, b.c, c, k, l, m, n, true, i + 1);
                }
                else if (!(c.c > l || c.a < k || c.d > n || c.b < m)) {
                    s = true;
                    a.add(b);
                    this.u(a, b.c, c, k, l, m, n, false, i + 1);
                }
                if (o >= c.c && p <= c.a && q >= c.d && r <= c.b) {
                    if (!s) {
                        a.add(b);
                    }
                    this.u(a, b.d, c, o, p, q, r, true, i + 1);
                }
                else if (!(c.c > p || c.a < o || c.d > r || c.b < q)) {
                    if (!s) {
                        a.add(b);
                    }
                    this.u(a, b.d, c, o, p, q, r, false, i + 1);
                }
            }
        };
        KDTree2D.prototype.z = function () {
            this.n(this.d);
        };
        KDTree2D.prototype.n = function (a) {
            if (a == null) {
                return 0;
            }
            if (this.n(a.c) + this.n(a.d) != a.h) {
                var b = 0;
            }
            return a.h + 1;
        };
        KDTree2D.$t = i2.markType(KDTree2D, 'KDTree2D');
        return KDTree2D;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var KDPointData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(KDPointData, _super);
        function KDPointData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = 0;
            _this.b = 0;
            _this.c = 0;
            return _this;
        }
        KDPointData.$t = i2.markType(KDPointData, 'KDPointData');
        return KDPointData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ProgressiveLoadStatusEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ProgressiveLoadStatusEventArgs, _super);
        function ProgressiveLoadStatusEventArgs(a) {
            var _this = _super.call(this) || this;
            _this._currentStatus = 0;
            _this.currentStatus = a;
            return _this;
        }
        Object.defineProperty(ProgressiveLoadStatusEventArgs.prototype, "currentStatus", {
            get: function () {
                return this._currentStatus;
            },
            set: function (a) {
                this._currentStatus = a;
            },
            enumerable: false,
            configurable: true
        });
        ProgressiveLoadStatusEventArgs.$t = i2.markType(ProgressiveLoadStatusEventArgs, 'ProgressiveLoadStatusEventArgs', i2.EventArgs.$);
        return ProgressiveLoadStatusEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SearchArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SearchArgs, _super);
        function SearchArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.d = 0;
            _this.a = 0;
            _this.b = 0;
            _this.e = 0;
            _this.f = 0;
            _this.g = 0;
            return _this;
        }
        SearchArgs.$t = i2.markType(SearchArgs, 'SearchArgs');
        return SearchArgs;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighDensityScatterSeries, _super);
        function HighDensityScatterSeries() {
            var _this = _super.call(this) || this;
            _this.pv = null;
            _this.px = null;
            _this.q6 = 0;
            _this.pz = false;
            _this.ql = Defaults.aq.o;
            _this.qk = Defaults.aq.n;
            _this.qj = Defaults.aq.m;
            _this.qi = Defaults.aq.l;
            _this.qh = Defaults.ap.o;
            _this.qg = Defaults.ap.n;
            _this.qf = Defaults.ap.m;
            _this.qe = Defaults.ap.l;
            _this.pn = null;
            _this.ps = null;
            _this.pt = null;
            _this.po = null;
            _this.pq = null;
            _this.p1 = false;
            _this.q7 = 0;
            _this.q9 = 0;
            _this.q3 = 0;
            _this.q2 = 0;
            _this.progressiveLoadStatusChanged = null;
            _this.p6 = null;
            _this.qc = 0;
            _this.qb = 0;
            _this.qd = 0;
            _this.qs = 0;
            _this.qq = 0;
            _this.qr = 0;
            _this.qt = 0;
            _this.qv = 0;
            _this.qx = 0;
            _this.qw = 0;
            _this.qu = 0;
            _this.p8 = 0;
            _this.p9 = 0;
            _this.qa = 0;
            _this.p7 = 0;
            _this.q5 = 0;
            _this.q4 = 0;
            _this.pk = null;
            _this.q8 = 0;
            _this.p0 = false;
            _this._itemIndexes = null;
            _this.pl = null;
            _this.pi = null;
            _this.pu = null;
            _this.ab = HighDensityScatterSeries.$;
            _this.ef = false;
            return _this;
        }
        HighDensityScatterSeries.prototype.get_dz = function () {
            return true;
        };
        HighDensityScatterSeries.prototype.get_d6 = function () {
            return true;
        };
        Object.defineProperty(HighDensityScatterSeries.prototype, "pw", {
            get: function () {
                return this.pv;
            },
            set: function (a) {
                if (this.pv != a) {
                    var b = this.pw;
                    this.pv = a;
                    this.raisePropertyChanged("XColumn", b, this.pw);
                }
            },
            enumerable: false,
            configurable: true
        });
        HighDensityScatterSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == HighDensityScatterSeries.$$p[8]) {
                return this.hl(a, b, this.ro);
            }
            if (c == HighDensityScatterSeries.$$p[10]) {
                return this.hl(a, b, this.rs);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(HighDensityScatterSeries.prototype, "py", {
            get: function () {
                return this.px;
            },
            set: function (a) {
                if (this.px != a) {
                    var b = this.py;
                    this.px = a;
                    this.raisePropertyChanged("YColumn", b, this.py);
                }
            },
            enumerable: false,
            configurable: true
        });
        HighDensityScatterSeries.prototype.r7 = function () {
            if (this.pn == null) {
                return;
            }
            this.pn.s();
            var a = this.pn;
            a.progressiveThunkCompleted = i2.delegateRemove(a.progressiveThunkCompleted, i2.runOn(this, this.ru));
            this.pn = null;
        };
        HighDensityScatterSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (this.ca != null) {
                        var e = this.getEffectiveViewport1(this.bx);
                        this.p0 = !e.isEmpty;
                    }
                    break;
                case "FastItemsSource":
                    this.r7();
                    if (i2.typeCast(i2.IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.pw);
                        c.deregisterColumn(this.py);
                        this.pw = null;
                        this.py = null;
                    }
                    if (i2.typeCast(i2.IFastItemsSource_$type, d) != null) {
                        this.pw = this.ce(this.ro);
                        this.py = this.ce(this.rs);
                    }
                    if ((this.pr != null && !this.pr.cv()) || (this.pp != null && !this.pp.cv())) {
                        this.l0(false);
                    }
                    this.k8();
                    break;
                case HighDensityScatterSeries.$$p[7]:
                    var f = this.po;
                    this.po = this.pp;
                    this.r7();
                    if (f != null) {
                        f.rangeChanged = i2.delegateRemove(f.rangeChanged, i2.runOn(this, this.rx));
                    }
                    if (this.po != null) {
                        var g = this.po;
                        g.rangeChanged = i2.delegateCombine(g.rangeChanged, i2.runOn(this, this.rx));
                    }
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if ((this.pp != null && !this.pp.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    break;
                case HighDensityScatterSeries.$$p[9]:
                    var h = this.pq;
                    this.pq = this.pr;
                    this.r7();
                    if (h != null) {
                        h.rangeChanged = i2.delegateRemove(h.rangeChanged, i2.runOn(this, this.rx));
                    }
                    if (this.pq != null) {
                        var i = this.pq;
                        i.rangeChanged = i2.delegateCombine(i.rangeChanged, i2.runOn(this, this.rx));
                    }
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if ((this.pr != null && !this.pr.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    break;
                case "MouseOverEnabled":
                    this.p1 = this.ef;
                    this.l0(false);
                    break;
                case HighDensityScatterSeries.$$p[8]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.pw);
                        this.pw = this.ce(this.ro);
                    }
                    break;
                case "XColumn":
                    this.r7();
                    if (this.pp != null && !this.pp.cv()) {
                        this.l0(false);
                    }
                    this.k8();
                    break;
                case HighDensityScatterSeries.$$p[10]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.py);
                        this.py = this.ce(this.rs);
                    }
                    break;
                case "YColumn":
                    this.r7();
                    if (this.pr != null && !this.pr.cv()) {
                        this.l0(false);
                    }
                    this.k8();
                    break;
                case HighDensityScatterSeries.$$p[6]:
                    this.r7();
                    this.l0(false);
                    this.k7();
                    break;
                case HighDensityScatterSeries.$$p[3]:
                    this.l0(false);
                    this.k7();
                    break;
                case HighDensityScatterSeries.$$p[1]:
                    this.l0(false);
                    this.k7();
                    break;
                case HighDensityScatterSeries.$$p[0]:
                case HighDensityScatterSeries.$$p[2]:
                    if (!this.pm.b1(this.sm, this.sl)) {
                        return;
                    }
                    this.r1();
                    this.l0(false);
                    this.k7();
                    break;
                case HighDensityScatterSeries.$$p[4]:
                    this.q6 = Math.max(i2.typeGetValue(d) - 1, 0);
                    this.pz = this.q6 > 0;
                    this.l0(false);
                    this.k7();
                    break;
                case HighDensityScatterSeries.$$p[5]:
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        HighDensityScatterSeries.prototype.r1 = function () {
            this.qi = this.sm.l;
            this.ql = this.sm.o;
            this.qk = this.sm.n;
            this.qj = this.sm.m;
            this.qe = this.sl.l;
            this.qh = this.sl.o;
            this.qg = this.sl.n;
            this.qf = this.sl.m;
            this.oo = i2.BrushUtil.g(i2.truncate(this.qi), i2.truncate(this.ql), i2.truncate(this.qk), i2.truncate(this.qj));
            this.oj = i2.BrushUtil.g(i2.truncate(this.qe), i2.truncate(this.qh), i2.truncate(this.qg), i2.truncate(this.qf));
        };
        HighDensityScatterSeries.prototype.p3 = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        HighDensityScatterSeries.prototype.p2 = function (a) {
            if (i2.typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        HighDensityScatterSeries.prototype.rx = function (a, b) {
            this.r7();
            this.l0(false);
        };
        Object.defineProperty(HighDensityScatterSeries.prototype, "qp", {
            get: function () {
                return this.qh - this.ql;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighDensityScatterSeries.prototype, "qo", {
            get: function () {
                return this.qg - this.qk;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighDensityScatterSeries.prototype, "qn", {
            get: function () {
                return this.qf - this.qj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HighDensityScatterSeries.prototype, "qm", {
            get: function () {
                return this.qe - this.qi;
            },
            enumerable: false,
            configurable: true
        });
        HighDensityScatterSeries.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            if (this.pr == null || this.pp == null || this.pp.bh == null || this.pr.bh == null || this.py == null || this.pw == null || this.py.count < 1 || this.pw.count < 1 || this.py.count != this.pw.count || this.pp.kv == this.pp.ku || this.pr.kv == this.pr.ku || this.pf.isEmpty) {
                d = false;
            }
            return d;
        };
        Object.defineProperty(HighDensityScatterSeries.prototype, "rd", {
            get: function () {
                return this.q7;
            },
            set: function (a) {
                var b = this.q7;
                this.q7 = a;
                this.raisePropertyChanged("ProgressiveStatus", b, this.q7);
            },
            enumerable: false,
            configurable: true
        });
        HighDensityScatterSeries.prototype.l1 = function (a) {
            _super.prototype.l1.call(this, a);
            this.rz(a, this.bx);
        };
        HighDensityScatterSeries.prototype.rz = function (a, b) {
            if (this.ct(b)) {
                return;
            }
            if (this.pn == null && !this.p5) {
                var c = new i2.List$1(KDPointData.$, 2, this.pw.count);
                var d = this.pp;
                var e = this.pr;
                var f = new i2.Rect(0, 0, 0, 1, 1);
                var g = new i2.Rect(0, 0, 0, 1, 1);
                var h = new ScalerParams(1, f, g, d.cc);
                var i = new ScalerParams(1, f, g, e.cc);
                var j_1;
                var k_1;
                var _loop_1 = function (l) {
                    j_1 = d.d8(this_1.pw.item(l), h);
                    k_1 = e.d8(this_1.py.item(l), i);
                    if (!i2.isNaN_(j_1) && !i2.isNaN_(k_1) && !i2.isInfinity(j_1) && !i2.isInfinity(k_1)) {
                        c.add(((function () {
                            var $ret = new KDPointData();
                            $ret.a = j_1;
                            $ret.b = k_1;
                            $ret.c = l;
                            return $ret;
                        })()));
                    }
                };
                var this_1 = this;
                for (var l = 0; l < this.pw.count; l++) {
                    _loop_1(l);
                }
                if (this.p4) {
                    this.q2 = 1;
                    this.q3 = i2.truncate(i2.logBase(c.count, 2)) + 3;
                    this.rd = i2.truncate(((this.q2 / this.q3) * 100));
                    if (this.progressiveLoadStatusChanged != null) {
                        this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rd));
                    }
                    this.pn = KDTree2D.b(c.toArray(), 1);
                    var m = this.pn;
                    m.progressiveThunkCompleted = i2.delegateCombine(m.progressiveThunkCompleted, i2.runOn(this, this.ru));
                    if (!this.pn.f(this.gw)) {
                        var n = this.pn;
                        n.progressiveThunkCompleted = i2.delegateRemove(n.progressiveThunkCompleted, i2.runOn(this, this.ru));
                    }
                    this.k7();
                }
                else {
                    var o = i2.dateNow();
                    this.pn = new KDTree2D(0, c.toArray(), 1);
                    var p = i2.dateNow();
                }
            }
            if (this.p4 && !this.p5) {
                this.r0(b);
            }
            else {
                this.r2(b);
            }
        };
        HighDensityScatterSeries.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            this.r7();
            var e = false;
            if (this.pp != null && !this.pp.cv()) {
                e = true;
            }
            if (this.pr != null && !this.pr.cv()) {
                e = true;
            }
            if (e) {
                this.l0(false);
            }
            this.k8();
        };
        HighDensityScatterSeries.prototype.rw = function (a) {
            var b = a;
            var c = this.q5 * this.q4;
            if (this.p1) {
                if (this._itemIndexes == null || this._itemIndexes.length != c) {
                    this._itemIndexes = new Array(c);
                    for (var d = 0; d < c; d++) {
                        this._itemIndexes[d] = 0;
                    }
                }
                else {
                    for (var e = 0; e < c; e++) {
                        this._itemIndexes[e] = 0;
                    }
                }
            }
        };
        HighDensityScatterSeries.prototype.r2 = function (a) {
            var b;
            var c;
            var d = null;
            if (a.q) {
                d = this._itemIndexes;
            }
            var e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            var f = a;
            var g = this.getEffectiveViewport1(a);
            this.ps = new ScalerParams(0, b, c, this.po.cc, g);
            this.pt = new ScalerParams(0, b, c, this.pq.cc, g);
            this.rv(a);
            this.rw(a);
            var h = this.q5 * this.q4;
            if (this.pl == null || this.pl.length != h) {
                this.pl = new Array(h);
                this.pi = new Array(h);
            }
            var i = this.pl.length;
            var j = this.pl;
            var k = this.pi;
            for (var l = 0; l < i; l++) {
                j[l] = 0;
                k[l] = 0;
            }
            this.q9 = i2.truncate(Math.round(this.gh));
            this.pk = f.by();
            var m = this.pk.length;
            var n = this.pk;
            for (var o = 0; o < m; o++) {
                n[o] = 0;
            }
            var p = this.q0;
            var q = this.qz;
            if (i2.isNaN_(p) || i2.isInfinity(p)) {
                p = 0;
            }
            if (i2.isNaN_(q) || i2.isInfinity(q)) {
                q = 50;
            }
            this.qc = Math.min(p, q);
            this.qb = Math.max(p, q);
            if (this.qc < 0) {
                this.qc = 0;
            }
            if (this.qb < 0) {
                this.qb = 0;
            }
            this.qd = this.qb - this.qc;
            if (this.p5) {
                this.ry(a);
            }
            else {
                this.r9(a);
            }
            f.b9();
            if (a.q) {
                this._itemIndexes = d;
                this.pm.ca();
            }
        };
        HighDensityScatterSeries.prototype.r0 = function (a) {
            if (this.pn == null) {
                return;
            }
            this.r2(a);
        };
        HighDensityScatterSeries.prototype.ru = function (a, b) {
            var _this = this;
            this.pm.b8(function () {
                if (_this.q2 < _this.q3 - 1) {
                    _this.q2++;
                }
                _this.rd = i2.truncate(((_this.q2 / _this.q3) * 100));
                if (_this.progressiveLoadStatusChanged != null) {
                    _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.rd));
                }
                _this.r0(_this.bx);
                _this.k7();
                if (_this.pn != null) {
                    if (!_this.pn.f(_this.gw)) {
                        var c = _this.pn;
                        c.progressiveThunkCompleted = i2.delegateRemove(c.progressiveThunkCompleted, i2.runOn(_this, _this.ru));
                        _this.rd = 100;
                        if (_this.progressiveLoadStatusChanged != null) {
                            _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.rd));
                        }
                    }
                }
            });
        };
        HighDensityScatterSeries.prototype.ry = function (a) {
            var b = i2.arrayShallowClone(this.pw.asArray());
            this.pp.g5(i2.boxArray$1(b), 0, b.length, this.ps);
            var c = i2.arrayShallowClone(this.py.asArray());
            this.q8 = 0;
            var d = this.q6;
            var e = this.pz;
            var f = this.pl.length;
            this.pr.g5(i2.boxArray$1(c), 0, c.length, this.pt);
            var g = 255 << 24 | i2.truncate(this.ql) << 16 | i2.truncate(this.qk) << 8 | i2.truncate(this.qj);
            for (var h = 0; h < b.length; h++) {
                var i = i2.truncate(b[h]);
                var j = i2.truncate(c[h]);
                i = i2.truncate(Math.floor(i));
                j = i2.truncate(Math.floor(j));
                if (i < 0 || i >= this.q5 || j < 0 || j >= this.q4) {
                    continue;
                }
                if (e) {
                    var k = i - d;
                    var l = i + d;
                    l = l > (this.q5 - 1) ? (this.q5 - 1) : l;
                    k = k < 0 ? 0 : k;
                    var m = j + d;
                    var n = j - d;
                    for (var o = k; o <= l; o++) {
                        for (var p = n; p <= m; p++) {
                            var q = (p * this.q5) + o;
                            if (q < 0 || q > f - 1) {
                                continue;
                            }
                            this.pl[q] = this.pl[q] + 1;
                            this.pi[q] = 1;
                            this.q8++;
                            if (this.p1) {
                                this._itemIndexes[q] = h + 1;
                            }
                        }
                    }
                }
                else {
                    var r = (j * this.q5) + i;
                    this.pl[r] = this.pl[r] + 1;
                    this.pi[r] = 1;
                    this.q8++;
                    if (this.p1) {
                        this._itemIndexes[r] = h + 1;
                    }
                }
            }
            this.r3();
        };
        HighDensityScatterSeries.prototype.r9 = function (a) {
            var b;
            var c;
            var d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.pn == null) {
                return;
            }
            if (this.p6 == null) {
                this.p6 = new i2.List$1(KDTreeNode2D.$, 2, i2.truncate(Math.round(b.width * b.height)));
            }
            else {
                this.p6.clear();
            }
            var e = c.left;
            var f = c.right;
            var g = c.top;
            var h = c.bottom;
            this.qw = c.top;
            this.qu = c.height;
            this.qv = c.left;
            this.qx = c.width;
            this.qs = b.top;
            this.qq = b.height;
            this.qr = b.left;
            this.qt = b.width;
            var i = this.getEffectiveViewport1(a);
            this.p8 = (i.left - this.qr) / this.qt;
            this.p9 = (i.top - this.qs) / this.qq;
            var j = (i.right - this.qr) / this.qt;
            this.qa = j - this.p8;
            var k = (i.bottom - this.qs) / this.qq;
            this.p7 = k - this.p9;
            if (this.p0) {
                e = (e - this.p8) / this.qa;
                f = (f - this.p8) / this.qa;
                g = (g - this.p9) / this.p7;
                h = (h - this.p9) / this.p7;
            }
            var l = this.gh / b.width * c.width;
            var m = this.gh / b.height * c.height;
            var n = Math.min(l, m);
            var o = ((function () {
                var $ret = new SearchArgs();
                $ret.c = e;
                $ret.a = f;
                $ret.d = g;
                $ret.b = h;
                $ret.e = l;
                $ret.f = m;
                $ret.g = 0x7FFFFFFF;
                return $ret;
            })());
            this.pn.t(this.p6, o, 0, 1, 0, 1);
            var p;
            this.q8 = 0;
            for (var q = 0; q < this.p6.count; q++) {
                p = this.p6._inner[q];
                this.r4(p);
            }
            this.r3();
        };
        HighDensityScatterSeries.prototype.r4 = function (a) {
            if (a.g) {
                return;
            }
            var b = a.e != null && a.e.a;
            var c = a.a == null ? 0 : a.a.length;
            var d = (a.h - c) + 1;
            if (b && d > 0) {
            }
            else {
                d = 1;
            }
            this.r6(a.b, d, b, a.e);
            if (c > 0 && !b) {
                var e = void 0;
                for (var f = 0; f < c; f++) {
                    e = a.a[f];
                    this.r6(e, d, false, a.e);
                }
            }
            if (a.e != null) {
                a.e.a = false;
            }
        };
        HighDensityScatterSeries.prototype.eh = function (a) {
            var b = this.ca != null ? this.ca.pg : i2.Rect.empty;
            var c = this.ca != null ? this.ca.pv : i2.Rect.empty;
            var d = new i2.Rect(0, 0, 0, 1, 1);
            var e = this.o9(this.bx);
            var f = new ScalerParams(0, d, d, this.pp.cc, e);
            var g = new ScalerParams(0, d, d, this.pr.cc, e);
            var h = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            var i = this.pp != null && this.pw != null && h < this.pw.count ? this.pp.d8(this.pw.item(h), f) : NaN;
            var j = this.pr != null && this.py != null && h < this.py.count ? this.pr.d8(this.py.item(h), g) : NaN;
            if (!i2.isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!i2.isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b5 != null) {
                this.b5.ap(this.ca, b, true);
            }
            return h >= 0;
        };
        HighDensityScatterSeries.prototype.r6 = function (a, b, c, d) {
            var e = this.rb(b);
            var f = a.c;
            var g = this.q6;
            if (c) {
                var h = d.d;
                var i = d.b;
                var j = d.e;
                var k = d.c;
                if (this.p0) {
                    h = this.p8 + this.qa * h;
                    i = this.p8 + this.qa * i;
                    j = this.p9 + this.p7 * j;
                    k = this.p9 + this.p7 * k;
                }
                var l = i2.truncate((this.qr + this.qt * (h - this.qv) / this.qx));
                var m = i2.truncate((this.qr + this.qt * (i - this.qv) / this.qx));
                var n = i2.truncate((this.qs + this.qq * (j - this.qw) / this.qu));
                var o = i2.truncate((this.qs + this.qq * (k - this.qw) / this.qu));
                l = i2.truncate(Math.floor(l));
                m = i2.truncate(Math.floor(m));
                n = i2.truncate(Math.floor(n));
                o = i2.truncate(Math.floor(o));
                if (this.pz) {
                    l -= g;
                    m += g;
                    n -= g;
                    o += g;
                }
                var p = ((m - l) + 1) * ((o - n) + 1);
                var q = b / p;
                var r = q;
                for (var s = l; s <= m; s++) {
                    for (var t = n; t <= o; t++) {
                        this.r5(f, s, t, q, r);
                    }
                }
            }
            else {
                var u = a.a;
                var v = a.b;
                if (this.p0) {
                    u = this.p8 + this.qa * u;
                    v = this.p9 + this.p7 * v;
                }
                var w = i2.truncate((this.qr + this.qt * (u - this.qv) / this.qx));
                var x = i2.truncate((this.qs + this.qq * (v - this.qw) / this.qu));
                w = i2.truncate(Math.floor(w));
                x = i2.truncate(Math.floor(x));
                if (this.pz) {
                    var y = w - g;
                    var z = w + g;
                    var aa = x + g;
                    var ab = x - g;
                    var ac = ((z - y) + 1) * ((aa - ab) + 1);
                    var ad = b / ac;
                    var ae = ad;
                    for (var af = y; af <= z; af++) {
                        for (var ag = ab; ag <= aa; ag++) {
                            this.r5(f, af, ag, ad, ae);
                        }
                    }
                }
                else {
                    this.r5(f, w, x, b, 1);
                }
            }
        };
        HighDensityScatterSeries.prototype.ra = function (a, b) {
            return i2.truncate((Math.floor(255 * b))) << 24 | i2.truncate(Math.floor(b * (this.ql + a * this.qp))) << 16 | i2.truncate(Math.floor(b * (this.qk + a * this.qo))) << 8 | i2.truncate(Math.floor(b * (this.qj + a * this.qn)));
        };
        HighDensityScatterSeries.prototype.rb = function (a) {
            return 255 << 24 | i2.truncate(Math.floor((this.ql + a * this.qp))) << 16 | i2.truncate(Math.floor((this.qk + a * this.qo))) << 8 | i2.truncate(Math.floor((this.qj + a * this.qn)));
        };
        HighDensityScatterSeries.prototype.qy = function (a) {
            return (a >> 24 & 255) / 255;
        };
        HighDensityScatterSeries.prototype.r5 = function (a, b, c, d, e) {
            if (b < 0 || b >= this.q5 || c < 0 || c >= this.q4) {
                return;
            }
            var f = (c * this.q5) + b;
            this.pl[f] = this.pl[f] + d;
            this.pi[f] = this.pi[f] + e;
            if (this.p1) {
                this._itemIndexes[f] = a + 1;
            }
            this.q8 += i2.truncate(d);
        };
        HighDensityScatterSeries.prototype.r3 = function () {
            var a = 0;
            var b = 0;
            var c = this.qd;
            var d = this.qc;
            var e = this.qb;
            var f = this.pl.length;
            var g = this.pl;
            var h = this.pi;
            var i = this.pk;
            var j = NaN;
            var k = NaN;
            var l = 0;
            var m = 0;
            for (var n = 0; n < f; n++) {
                a = g[n];
                if (a != 0) {
                    b = h[n];
                    if (a >= e) {
                        a = 1;
                    }
                    else if (a <= d) {
                        a = 0;
                    }
                    else {
                        a = (a - d) / (c);
                    }
                    if (b > 1) {
                        b = 1;
                    }
                    if (b < 0.2) {
                        b = 0.2;
                    }
                    if (j != a || k != b) {
                        l = this.ra(a, b);
                        j = a;
                        k = b;
                    }
                    i[m] = l >> 16 & 255;
                    i[m + 1] = l >> 8 & 255;
                    i[m + 2] = l & 255;
                    i[m + 3] = l >> 24 & 255;
                }
                m += 4;
            }
        };
        HighDensityScatterSeries.prototype.rv = function (a) {
            var b = a;
            b.b6();
        };
        HighDensityScatterSeries.prototype.bu = function () {
            return new HighDensityScatterSeriesView(this);
        };
        HighDensityScatterSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.pm = a;
        };
        HighDensityScatterSeries.prototype.ap = function (a) {
            if (a != null && a == this.pp && this.pw != null) {
                return new AxisRange(this.pw.minimum, this.pw.maximum);
            }
            if (a != null && a == this.pr && this.py != null) {
                return new AxisRange(this.py.minimum, this.py.maximum);
            }
            return null;
        };
        HighDensityScatterSeries.prototype.mm = function (a, b) {
            if (this.ca != null) {
                var c = this.getEffectiveViewport1(this.bx);
                this.p0 = !c.isEmpty;
            }
            this.l0(false);
        };
        HighDensityScatterSeries.prototype.mn = function (a, b) {
            this.l0(false);
        };
        HighDensityScatterSeries.prototype.hh = function (a) {
            if (!this.p1 || this._itemIndexes == null || this.ca == null || this.ch == null || this._itemIndexes.length != (this.q5 * this.q4)) {
                return null;
            }
            var b = this.ca.pg;
            var c = (a.x - b.left) / b.width;
            var d = (a.y - b.top) / b.height;
            var e = i2.truncate(Math.round(this.pf.left + (this.pf.width * c)));
            var f = i2.truncate(Math.round(this.pf.top + (this.pf.height * d)));
            var g = this.re(e, f);
            if (g < 0 || g > this._itemIndexes.length - 1) {
                return null;
            }
            var h = this._itemIndexes[g] - 1;
            if (h < 0 || h > this.ch.count) {
                return null;
            }
            return this.ch.item(h);
        };
        HighDensityScatterSeries.prototype.re = function (a, b) {
            var c = (this.q5 * b) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            var d = 1;
            c = (this.q5 * (b - d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b + d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b - d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b + d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b - d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.q5 * (b + d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            return 0;
        };
        HighDensityScatterSeries.prototype.r8 = function (a, b, c) {
            this.pk = a;
            this.q5 = b;
            this.q4 = c;
        };
        HighDensityScatterSeries.prototype.get_ex = function () {
            return true;
        };
        HighDensityScatterSeries.prototype.set_ex = function (a) {
            _super.prototype.set_ex.call(this, a);
        };
        HighDensityScatterSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            this.pm.b7();
            if (this.bw != null) {
                this.bw.b7();
            }
            this.k7();
        };
        HighDensityScatterSeries.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
            if (!this.et) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            var c = i2.typeCast(HighDensityScatterSeriesView.$, this.bw);
            var d = new ScatterFrame();
            this.rz(false, c);
            this.et = false;
        };
        HighDensityScatterSeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            f.a1(c);
            if (this.ct(g)) {
                return;
            }
            if (this.pu == null) {
                this.pu = new ScatterFrame();
            }
            this.rz(false, f);
        };
        HighDensityScatterSeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.pp = null;
            this.pr = null;
        };
        HighDensityScatterSeries.$t = i2.markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
        HighDensityScatterSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:sl:sa', [i2.Color.$, Defaults.ap], 'HeatMaximum:qz:sb', [1, 50], 'HeatMinimumColor:sm:sc', [i2.Color.$, Defaults.aq], 'HeatMinimum:q0:sd', [1, 0], 'PointExtent:rc:se', [1, 1], 'ProgressiveLoad:p4:sf', [0, true], 'UseBruteForce:p5:sg', [0, false], 'XAxis:pp:sh', [NumericXAxis.$, null], 'XMemberPath:ro:si', [2, null], 'YAxis:pr:sj', [NumericYAxis.$, null], 'YMemberPath:rs:sk', [2, null]]);
        return HighDensityScatterSeries;
    }(Series));
    /**
     * @hidden
     */
    var HighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HighDensityScatterSeriesView, _super);
        function HighDensityScatterSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.bz = null;
            _this.bx = null;
            _this.b5 = 0;
            _this.b4 = 0;
            _this.b2 = null;
            _this.b3 = null;
            _this.b0 = null;
            _this.bz = a;
            return _this;
        }
        HighDensityScatterSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.bz.gh = Defaults.q;
                this.bz.sm = Defaults.aq;
                this.bz.sl = Defaults.ap;
                this.bz.oj = Defaults.al;
                this.bz.oo = Defaults.ak;
            }
        };
        HighDensityScatterSeriesView.prototype.ca = function () {
            this.bz.r8(this.bx, this.b5, this.b4);
        };
        HighDensityScatterSeriesView.prototype.b6 = function () {
            if (this.b2 == null) {
                this.b2 = this.e.gw.createElement("canvas");
                var a = this.e.gw.get2DCanvasContext(this.b2);
                this.b0 = new i2.RenderingContext(new i2.CanvasViewRenderer(), a);
            }
            var b;
            if (this.p) {
                b = this.bu;
            }
            else {
                b = this.e.ca.pl();
            }
            var c = i2.truncate(Math.round(b.left));
            var d = i2.truncate(Math.round(b.top));
            var e = i2.truncate(Math.round(b.width));
            var f = i2.truncate(Math.round(b.height));
            var g = this.b5;
            var h = this.b4;
            this.b5 = e;
            this.b4 = f;
            if (g != this.b5 || h != this.b4 || this.bx == null) {
                this.b2.setAttribute("width", e.toString());
                this.b2.setAttribute("height", f.toString());
                this.b3 = this.b0.g().getImageData(0, 0, e, f);
                var imageDataArray_ = this.b3.data;
                this.bx = imageDataArray_;
            }
            this.bz.r8(this.bx, this.b5, this.b4);
        };
        HighDensityScatterSeriesView.prototype.by = function () {
            return this.bx;
        };
        HighDensityScatterSeriesView.prototype.b9 = function () {
            var a = i2.truncate(Math.round(this.bu.left));
            var b = i2.truncate(Math.round(this.bu.left));
            var c = i2.truncate(Math.round(this.bu.width));
            var d = i2.truncate(Math.round(this.bu.height));
            this.b0.g().putImageData(this.b3, 0, 0);
            this.aq();
        };
        HighDensityScatterSeriesView.prototype.b8 = function (a) {
            if (this.e.gw != null) {
                this.e.gw.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        };
        HighDensityScatterSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (b) {
                if (!this.bz.ef) {
                    return;
                }
                var c = new i2.Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
                return;
            }
            if (this.b2 == null) {
                return;
            }
            var d = i2.truncate(Math.round(this.bu.left));
            var e = i2.truncate(Math.round(this.bu.top));
            var f = i2.truncate(Math.round(this.bu.width));
            var g = i2.truncate(Math.round(this.bu.height));
            this.k.n(this.b2.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
        };
        HighDensityScatterSeriesView.prototype.b1 = function (a, b) {
            return i2.Color.e(i2.toNullable(i2.Color.$, a), i2.toNullable(i2.Color.$, null)) && i2.Color.e(i2.toNullable(i2.Color.$, b), i2.toNullable(i2.Color.$, null));
        };
        HighDensityScatterSeriesView.prototype.b7 = function () {
            if (this.bx != null) {
                for (var a = 0; a < this.bx.length; a++) {
                    this.bx[a] = 0;
                }
                this.b9();
            }
        };
        HighDensityScatterSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            if (this.bx == null) {
                this.e.a6.exportSeriesPixelsData(a, null, this.b5, this.b4);
                return;
            }
            var b = new Array(i2.intDivide(this.bx.length, 4));
            var c;
            for (var d = 0; d < i2.intDivide(this.bx.length, 4); d++) {
                c = d * 4;
                b[d] = this.bx[c + 3] << 24 | this.bx[c] << 16 | this.bx[c + 1] << 8 | this.bx[c + 2];
            }
            this.e.a6.exportSeriesPixelsData(a, b, this.b5, this.b4);
        };
        HighDensityScatterSeriesView.$t = i2.markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
        return HighDensityScatterSeriesView;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent series where a high volume of scatter points can be displayed.
    */
    var IgxHighDensityScatterSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxHighDensityScatterSeriesComponent, _super);
        function IgxHighDensityScatterSeriesComponent() {
            var _this = _super.call(this) || this;
            _this._progressiveLoadStatusChanged = null;
            return _this;
        }
        IgxHighDensityScatterSeriesComponent.prototype.createImplementation = function () {
            return new HighDensityScatterSeries();
        };
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "isPixel", {
            /**
             * Gets whether the current series shows pixels.
            */
            get: function () {
                return this.i.dz;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "isScatter", {
            /**
             * Checks if this series is a scatter series
            */
            get: function () {
                return this.i.d6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current object.
            */
            get: function () {
                if (this.i.pp == null) {
                    return null;
                }
                if (!this.i.pp.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.pp);
                    if (e) {
                        e._implementation = this.i.pp;
                    }
                    this.i.pp.externalObject = e;
                }
                return this.i.pp.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pp = null : this.i.pp = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current object.
            */
            get: function () {
                if (this.i.pr == null) {
                    return null;
                }
                if (!this.i.pr.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.pr);
                    if (e) {
                        e._implementation = this.i.pr;
                    }
                    this.i.pr.externalObject = e;
                }
                return this.i.pr.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pr = null : this.i.pr = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "xMemberPath", {
            /**
             * Gets or sets the x value mapping property for the current series object.
            */
            get: function () {
                return this.i.ro;
            },
            set: function (v) {
                this.i.ro = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "yMemberPath", {
            /**
             * Gets or sets the y value mapping property for the current series object.
            */
            get: function () {
                return this.i.rs;
            },
            set: function (v) {
                this.i.rs = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "useBruteForce", {
            /**
             * Gets or sets the whether to use use brute force mode.
            */
            get: function () {
                return this.i.p5;
            },
            set: function (v) {
                this.i.p5 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "progressiveLoad", {
            /**
             * Gets or sets the whether to progressively load the data into the chart.
            */
            get: function () {
                return this.i.p4;
            },
            set: function (v) {
                this.i.p4 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "heatMinimum", {
            /**
             * Gets or sets the density value that maps to the minimum heat color.
            */
            get: function () {
                return this.i.q0;
            },
            set: function (v) {
                this.i.q0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "heatMaximum", {
            /**
             * Gets or sets the value that maps to the maximum heat color.
            */
            get: function () {
                return this.i.qz;
            },
            set: function (v) {
                this.i.qz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "heatMinimumColor", {
            /**
             * Gets or sets the color to use for the minimum end of the scale.
            */
            get: function () {
                return i2.colorToString(this.i.sm);
            },
            set: function (v) {
                this.i.sm = i2.stringToColor(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "heatMaximumColor", {
            /**
             * Gets or sets the color to use for the maximum end of the scale.
            */
            get: function () {
                return i2.colorToString(this.i.sl);
            },
            set: function (v) {
                this.i.sl = i2.stringToColor(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "pointExtent", {
            /**
             * Gets or sets the the pixel extent of the square data points that are rendered.
            */
            get: function () {
                return this.i.rc;
            },
            set: function (v) {
                this.i.rc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "progressiveStatus", {
            /**
             * Represents the current status of the progressive load of the series. It will range from 0 to 100, where 100 is fully loaded.
            */
            get: function () {
                return this.i.rd;
            },
            set: function (v) {
                this.i.rd = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxHighDensityScatterSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxHighDensityScatterSeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxHighDensityScatterSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxHighDensityScatterSeriesComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.p3(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxHighDensityScatterSeriesComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.p2(axis);
            return (iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        */
        IgxHighDensityScatterSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxHighDensityScatterSeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        Object.defineProperty(IgxHighDensityScatterSeriesComponent.prototype, "progressiveLoadStatusChanged", {
            /**
             * Raised when the progressive loading state of the series has changed.
            */
            get: function () {
                var _this = this;
                if (this._progressiveLoadStatusChanged == null) {
                    this._progressiveLoadStatusChanged = new i0.EventEmitter();
                    this.i.progressiveLoadStatusChanged = i2.delegateCombine(this.i.progressiveLoadStatusChanged, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxProgressiveLoadStatusEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeProgressiveLoadStatusChanged) {
                                _this.beforeProgressiveLoadStatusChanged(_this, outerArgs);
                            }
                            _this._progressiveLoadStatusChanged.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._progressiveLoadStatusChanged;
            },
            enumerable: false,
            configurable: true
        });
        IgxHighDensityScatterSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxHighDensityScatterSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxHighDensityScatterSeriesComponent, selector: "igx-high-density-scatter-series", inputs: { xAxis: "xAxis", yAxis: "yAxis", xMemberPath: "xMemberPath", yMemberPath: "yMemberPath", useBruteForce: "useBruteForce", progressiveLoad: "progressiveLoad", heatMinimum: "heatMinimum", heatMaximum: "heatMaximum", heatMinimumColor: "heatMinimumColor", heatMaximumColor: "heatMaximumColor", pointExtent: "pointExtent", progressiveStatus: "progressiveStatus" }, outputs: { progressiveLoadStatusChanged: "progressiveLoadStatusChanged" }, providers: [{ provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxHighDensityScatterSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxHighDensityScatterSeriesComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-high-density-scatter-series',
                        template: "",
                        providers: [{ provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxHighDensityScatterSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }], xMemberPath: [{
                    type: i0.Input
                }], yMemberPath: [{
                    type: i0.Input
                }], useBruteForce: [{
                    type: i0.Input
                }], progressiveLoad: [{
                    type: i0.Input
                }], heatMinimum: [{
                    type: i0.Input
                }], heatMaximum: [{
                    type: i0.Input
                }], heatMinimumColor: [{
                    type: i0.Input
                }], heatMaximumColor: [{
                    type: i0.Input
                }], pointExtent: [{
                    type: i0.Input
                }], progressiveStatus: [{
                    type: i0.Input
                }], progressiveLoadStatusChanged: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHighDensityScatterSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHighDensityScatterSeriesModule() {
        }
        IgxHighDensityScatterSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHighDensityScatterSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesModule, declarations: [IgxHighDensityScatterSeriesComponent], imports: [i1.CommonModule], exports: [IgxHighDensityScatterSeriesComponent] });
        IgxHighDensityScatterSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesModule, imports: [[i1.CommonModule]] });
        return IgxHighDensityScatterSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxHighDensityScatterSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxHighDensityScatterSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHighDensityScatterSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHighDensityScatterSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxHighDensityScatterSeriesComponent", IgxHighDensityScatterSeriesComponent);
            i2.TypeRegistrar.register("HighDensityScatterSeries", HighDensityScatterSeries.$type);
        }
        IgxHighDensityScatterSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHighDensityScatterSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesDynamicModule, imports: [i1.CommonModule, IgxHighDensityScatterSeriesModule], exports: [IgxHighDensityScatterSeriesModule] });
        IgxHighDensityScatterSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesDynamicModule, imports: [[i1.CommonModule, IgxHighDensityScatterSeriesModule], IgxHighDensityScatterSeriesModule] });
        return IgxHighDensityScatterSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHighDensityScatterSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxHighDensityScatterSeriesModule],
                        exports: [IgxHighDensityScatterSeriesModule],
                        entryComponents: [IgxHighDensityScatterSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartScatterModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartScatterModule() {
        }
        IgxDataChartScatterModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartScatterModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterModule, imports: [i1.CommonModule, IgxSizeScaleModule,
                IgxValueBrushScaleModule,
                IgxCustomPaletteColorScaleModule,
                IgxBubbleSeriesModule,
                IgxScatterSeriesModule,
                IgxScatterLineSeriesModule,
                IgxScatterSplineSeriesModule,
                IgxHighDensityScatterSeriesModule,
                IgxDataChartScatterCoreModule], exports: [IgxSizeScaleModule,
                IgxValueBrushScaleModule,
                IgxCustomPaletteColorScaleModule,
                IgxBubbleSeriesModule,
                IgxScatterSeriesModule,
                IgxScatterLineSeriesModule,
                IgxScatterSplineSeriesModule,
                IgxHighDensityScatterSeriesModule,
                IgxDataChartScatterCoreModule] });
        IgxDataChartScatterModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterModule, imports: [[i1.CommonModule, IgxSizeScaleModule,
                    IgxValueBrushScaleModule,
                    IgxCustomPaletteColorScaleModule,
                    IgxBubbleSeriesModule,
                    IgxScatterSeriesModule,
                    IgxScatterLineSeriesModule,
                    IgxScatterSplineSeriesModule,
                    IgxHighDensityScatterSeriesModule,
                    IgxDataChartScatterCoreModule
                ], IgxSizeScaleModule,
                IgxValueBrushScaleModule,
                IgxCustomPaletteColorScaleModule,
                IgxBubbleSeriesModule,
                IgxScatterSeriesModule,
                IgxScatterLineSeriesModule,
                IgxScatterSplineSeriesModule,
                IgxHighDensityScatterSeriesModule,
                IgxDataChartScatterCoreModule] });
        return IgxDataChartScatterModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxSizeScaleModule,
                            IgxValueBrushScaleModule,
                            IgxCustomPaletteColorScaleModule,
                            IgxBubbleSeriesModule,
                            IgxScatterSeriesModule,
                            IgxScatterLineSeriesModule,
                            IgxScatterSplineSeriesModule,
                            IgxHighDensityScatterSeriesModule,
                            IgxDataChartScatterCoreModule
                        ],
                        imports: [i1.CommonModule, IgxSizeScaleModule,
                            IgxValueBrushScaleModule,
                            IgxCustomPaletteColorScaleModule,
                            IgxBubbleSeriesModule,
                            IgxScatterSeriesModule,
                            IgxScatterLineSeriesModule,
                            IgxScatterSplineSeriesModule,
                            IgxHighDensityScatterSeriesModule,
                            IgxDataChartScatterCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartScatterDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartScatterDynamicModule() {
        }
        IgxDataChartScatterDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartScatterDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterDynamicModule, imports: [i1.CommonModule, IgxSizeScaleDynamicModule,
                IgxValueBrushScaleDynamicModule,
                IgxCustomPaletteColorScaleDynamicModule,
                IgxBubbleSeriesDynamicModule,
                IgxScatterSeriesDynamicModule,
                IgxScatterLineSeriesDynamicModule,
                IgxScatterSplineSeriesDynamicModule,
                IgxHighDensityScatterSeriesDynamicModule,
                IgxDataChartScatterCoreDynamicModule,
                IgxDataChartScatterModule], exports: [IgxSizeScaleDynamicModule,
                IgxValueBrushScaleDynamicModule,
                IgxCustomPaletteColorScaleDynamicModule,
                IgxBubbleSeriesDynamicModule,
                IgxScatterSeriesDynamicModule,
                IgxScatterLineSeriesDynamicModule,
                IgxScatterSplineSeriesDynamicModule,
                IgxHighDensityScatterSeriesDynamicModule,
                IgxDataChartScatterCoreDynamicModule,
                IgxDataChartScatterModule] });
        IgxDataChartScatterDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterDynamicModule, imports: [[i1.CommonModule, IgxSizeScaleDynamicModule,
                    IgxValueBrushScaleDynamicModule,
                    IgxCustomPaletteColorScaleDynamicModule,
                    IgxBubbleSeriesDynamicModule,
                    IgxScatterSeriesDynamicModule,
                    IgxScatterLineSeriesDynamicModule,
                    IgxScatterSplineSeriesDynamicModule,
                    IgxHighDensityScatterSeriesDynamicModule,
                    IgxDataChartScatterCoreDynamicModule,
                    IgxDataChartScatterModule
                ], IgxSizeScaleDynamicModule,
                IgxValueBrushScaleDynamicModule,
                IgxCustomPaletteColorScaleDynamicModule,
                IgxBubbleSeriesDynamicModule,
                IgxScatterSeriesDynamicModule,
                IgxScatterLineSeriesDynamicModule,
                IgxScatterSplineSeriesDynamicModule,
                IgxHighDensityScatterSeriesDynamicModule,
                IgxDataChartScatterCoreDynamicModule,
                IgxDataChartScatterModule] });
        return IgxDataChartScatterDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartScatterDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxSizeScaleDynamicModule,
                            IgxValueBrushScaleDynamicModule,
                            IgxCustomPaletteColorScaleDynamicModule,
                            IgxBubbleSeriesDynamicModule,
                            IgxScatterSeriesDynamicModule,
                            IgxScatterLineSeriesDynamicModule,
                            IgxScatterSplineSeriesDynamicModule,
                            IgxHighDensityScatterSeriesDynamicModule,
                            IgxDataChartScatterCoreDynamicModule,
                            IgxDataChartScatterModule
                        ],
                        imports: [i1.CommonModule, IgxSizeScaleDynamicModule,
                            IgxValueBrushScaleDynamicModule,
                            IgxCustomPaletteColorScaleDynamicModule,
                            IgxBubbleSeriesDynamicModule,
                            IgxScatterSeriesDynamicModule,
                            IgxScatterLineSeriesDynamicModule,
                            IgxScatterSplineSeriesDynamicModule,
                            IgxHighDensityScatterSeriesDynamicModule,
                            IgxDataChartScatterCoreDynamicModule,
                            IgxDataChartScatterModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartShapeCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartShapeCoreModule() {
        }
        IgxDataChartShapeCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartShapeCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreModule, imports: [i1.CommonModule, IgxNumericXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule], exports: [IgxNumericXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartShapeCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreModule, imports: [[i1.CommonModule, IgxNumericXAxisModule,
                    IgxNumericYAxisModule,
                    IgxDataChartCoreModule
                ], IgxNumericXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartShapeCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartShapeCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartShapeCoreDynamicModule() {
        }
        IgxDataChartShapeCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartShapeCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreDynamicModule, imports: [i1.CommonModule, IgxNumericXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartShapeCoreModule], exports: [IgxNumericXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartShapeCoreModule] });
        IgxDataChartShapeCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreDynamicModule, imports: [[i1.CommonModule, IgxNumericXAxisDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartShapeCoreModule
                ], IgxNumericXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartShapeCoreModule] });
        return IgxDataChartShapeCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartShapeCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartShapeCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /**
     * Base class for series which triangulate XY data prior to rendering.
    */
    var IgxScatterTriangulationSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterTriangulationSeriesComponent, _super);
        function IgxScatterTriangulationSeriesComponent() {
            var _this = _super.call(this) || this;
            _this._triangulationStatusChanged = null;
            return _this;
        }
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "xMemberPath", {
            /**
             * The name of the property from which to extract the X-coordinate for each item in the ItemsSource.
            */
            get: function () {
                return this.i.qg;
            },
            set: function (v) {
                this.i.qg = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "yMemberPath", {
            /**
             * The name of the property from which to extract the Y-coordinate for each item in the ItemsSource.
            */
            get: function () {
                return this.i.qk;
            },
            set: function (v) {
                this.i.qk = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "xAxis", {
            /**
             * The X-Axis for this series.
            */
            get: function () {
                if (this.i.pi == null) {
                    return null;
                }
                if (!this.i.pi.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.pi);
                    if (e) {
                        e._implementation = this.i.pi;
                    }
                    this.i.pi.externalObject = e;
                }
                return this.i.pi.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pi = null : this.i.pi = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "yAxis", {
            /**
             * The Y-Axis for this series.
            */
            get: function () {
                if (this.i.pj == null) {
                    return null;
                }
                if (!this.i.pj.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.pj);
                    if (e) {
                        e._implementation = this.i.pj;
                    }
                    this.i.pj.externalObject = e;
                }
                return this.i.pj.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pj = null : this.i.pj = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "trianglesSource", {
            /**
             * The source of triangulation data.
             * This property is optional.  If it is left as null, the triangulation will be created based on the items in the ItemsSource.  Triangulation is a demanding operation, so the runtime performance will be better when specifying a TriangulationSource, especially when a large number of data items are present.
            */
            get: function () {
                return this.i.trianglesSource;
            },
            set: function (v) {
                this.i.trianglesSource = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "triangleVertexMemberPath1", {
            /**
             * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the first vertex point in the ItemsSource.
            */
            get: function () {
                return this.i.p8;
            },
            set: function (v) {
                this.i.p8 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "triangleVertexMemberPath2", {
            /**
             * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the second vertex point in the ItemsSource.
            */
            get: function () {
                return this.i.qa;
            },
            set: function (v) {
                this.i.qa = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "triangleVertexMemberPath3", {
            /**
             * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the third vertex point in the ItemsSource.
            */
            get: function () {
                return this.i.qc;
            },
            set: function (v) {
                this.i.qc = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "isShape", {
            /**
             * Gets whether or not this series is a shape series
            */
            get: function () {
                return this.i.d7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterTriangulationSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxScatterTriangulationSeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxScatterTriangulationSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxScatterTriangulationSeriesComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.p0(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxScatterTriangulationSeriesComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.pz(axis);
            return (iv);
        };
        Object.defineProperty(IgxScatterTriangulationSeriesComponent.prototype, "triangulationStatusChanged", {
            /**
             * Raised when the status of an ongoing Triangulation has changed.
            */
            get: function () {
                var _this = this;
                if (this._triangulationStatusChanged == null) {
                    this._triangulationStatusChanged = new i0.EventEmitter();
                    this.i.triangulationStatusChanged = i2.delegateCombine(this.i.triangulationStatusChanged, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new i2.IgxTriangulationStatusEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeTriangulationStatusChanged) {
                                _this.beforeTriangulationStatusChanged(_this, outerArgs);
                            }
                            _this._triangulationStatusChanged.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._triangulationStatusChanged;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterTriangulationSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterTriangulationSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterTriangulationSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterTriangulationSeriesComponent, selector: "ng-component", inputs: { xMemberPath: "xMemberPath", yMemberPath: "yMemberPath", xAxis: "xAxis", yAxis: "yAxis", trianglesSource: "trianglesSource", triangleVertexMemberPath1: "triangleVertexMemberPath1", triangleVertexMemberPath2: "triangleVertexMemberPath2", triangleVertexMemberPath3: "triangleVertexMemberPath3" }, outputs: { triangulationStatusChanged: "triangulationStatusChanged" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxScatterTriangulationSeriesComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterTriangulationSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xMemberPath: [{
                    type: i0.Input
                }], yMemberPath: [{
                    type: i0.Input
                }], xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }], trianglesSource: [{
                    type: i0.Input
                }], triangleVertexMemberPath1: [{
                    type: i0.Input
                }], triangleVertexMemberPath2: [{
                    type: i0.Input
                }], triangleVertexMemberPath3: [{
                    type: i0.Input
                }], triangulationStatusChanged: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterTriangulationSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterTriangulationSeries, _super);
        function ScatterTriangulationSeries() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.pp = null;
            _this.pq = null;
            _this.py = false;
            _this.pl = null;
            _this.triangulationStatusChanged = null;
            _this.p1 = null;
            _this.pm = null;
            _this.pn = null;
            _this.po = null;
            return _this;
        }
        ScatterTriangulationSeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.pi = null;
            this.pj = null;
        };
        ScatterTriangulationSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == ScatterTriangulationSeries.$$p[6]) {
                return this.hl(a, b, this.qg);
            }
            if (c == ScatterTriangulationSeries.$$p[8]) {
                return this.hl(a, b, this.qk);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(ScatterTriangulationSeries.prototype, "pv", {
            get: function () {
                return this.pp;
            },
            set: function (a) {
                var b = this.pv != a;
                if (b) {
                    var c = this.pv;
                    this.pp = a;
                    this.raisePropertyChanged("XColumn", c, this.pv);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterTriangulationSeries.prototype, "pw", {
            get: function () {
                return this.pq;
            },
            set: function (a) {
                var b = this.pw != a;
                if (b) {
                    var c = this.pw;
                    this.pq = a;
                    this.raisePropertyChanged("YColumn", c, this.pw);
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterTriangulationSeries.prototype.l1 = function (a) {
            var b = this.ch != null && this.px == null && this.p1 == null && this.pv != null && this.pw != null && this.pv.count >= 3 && this.pw.count >= 3 && !this.py;
            if (b) {
                this.qo();
                this.py = true;
            }
        };
        ScatterTriangulationSeries.prototype.qo = function () {
            this.pl = new i2.Triangulator(this.ch.count, this.pv, this.pw);
            var a = this.pl;
            a.triangulationStatusChanged = i2.delegateCombine(a.triangulationStatusChanged, i2.runOn(this, this.qp));
            this.pl.y();
        };
        ScatterTriangulationSeries.prototype.qm = function () {
            if (this.pl == null) {
                return;
            }
            this.pl.r();
            var a = this.pl;
            a.triangulationStatusChanged = i2.delegateRemove(a.triangulationStatusChanged, i2.runOn(this, this.qp));
            this.pl = null;
        };
        ScatterTriangulationSeries.prototype.qp = function (a, b) {
            var _this = this;
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, new i2.TriangulationStatusEventArgs(b.currentStatus));
            }
            if (b.currentStatus >= 100) {
                if (this.pl == null) {
                    return;
                }
                var c = this.pl;
                c.triangulationStatusChanged = i2.delegateRemove(c.triangulationStatusChanged, i2.runOn(this, this.qp));
                this.p1 = this.pl.n();
                this.pl = null;
                var d = ((function () {
                    var $ret = new i2.FastItemsSource();
                    $ret.e = _this.p1;
                    return $ret;
                })());
                this.ps = this.pr(d, "v1");
                this.pt = this.pr(d, "v2");
                this.pu = this.pr(d, "v3");
                this.l0(false);
            }
        };
        ScatterTriangulationSeries.prototype.pr = function (a, b) {
            if (b == null) {
                return a.registerColumnInt(null, null, false);
            }
            var c = null;
            var d = SeriesViewer.b1(b, this.coercionMethods);
            c = d.a;
            return a.registerColumnInt(b, c, this.expectFunctions);
        };
        ScatterTriangulationSeries.prototype.lm = function (a, b, c, d) {
            var _this = this;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    var e = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.pv);
                        e.deregisterColumn(this.pw);
                        this.pv = null;
                        this.pw = null;
                    }
                    this.qn();
                    var f = i2.typeCast(i2.IFastItemsSource_$type, d);
                    if (f != null) {
                        this.pv = this.ce(this.qg);
                        this.pw = this.ce(this.qk);
                    }
                    this.l0(false);
                    break;
                case ScatterTriangulationSeries.$$p[6]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.pv);
                        this.pv = this.ce(this.qg);
                    }
                    this.qn();
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[8]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.pw);
                        this.pw = this.ce(this.qk);
                    }
                    this.qn();
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[5]:
                    if (c != null) {
                        (i2.typeCast(Axis.$, c)).bx(this);
                    }
                    if (d != null) {
                        (i2.typeCast(Axis.$, d)).cn(this);
                    }
                    if ((this.pi != null && !this.pi.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[7]:
                    if (c != null) {
                        (i2.typeCast(Axis.$, c)).bx(this);
                    }
                    if (d != null) {
                        (i2.typeCast(Axis.$, d)).cn(this);
                    }
                    if ((this.pj != null && !this.pj.cv()) || (d == null && c != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[1]:
                    if (this.trianglesSource != null) {
                        this.qm();
                        this.px = ((function () {
                            var $ret = new i2.FastItemsSource();
                            $ret.e = _this.trianglesSource;
                            return $ret;
                        })());
                    }
                    else {
                        this.px = null;
                    }
                    break;
                case ScatterTriangulationSeries.$$p[0]:
                    var g = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (g != null) {
                        g.deregisterColumn(this.ps);
                        g.deregisterColumn(this.pt);
                        g.deregisterColumn(this.pu);
                        this.ps = null;
                        this.pt = null;
                        this.pu = null;
                    }
                    var h = i2.typeCast(i2.IFastItemsSource_$type, d);
                    if (h != null) {
                        this.ps = this.pr(h, this.p8);
                        this.pt = this.pr(h, this.qa);
                        this.pu = this.pr(h, this.qc);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[2]:
                    if (this.px != null) {
                        this.px.deregisterColumn(this.ps);
                        this.ps = this.pr(this.px, this.p8);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[3]:
                    if (this.px != null) {
                        this.px.deregisterColumn(this.pt);
                        this.pt = this.pr(this.px, this.qa);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterTriangulationSeries.$$p[4]:
                    if (this.px != null) {
                        this.px.deregisterColumn(this.pu);
                        this.pu = this.pr(this.px, this.qc);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "XColumn":
                    if (this.pi != null) {
                        this.pi.cv();
                    }
                    break;
                case "YColumn":
                    if (this.pj != null) {
                        this.pj.cv();
                    }
                    break;
            }
        };
        ScatterTriangulationSeries.prototype.p0 = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        ScatterTriangulationSeries.prototype.pz = function (a) {
            if (i2.typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        ScatterTriangulationSeries.prototype.e3 = function (a, b, c) {
            return _super.prototype.e3.call(this, a, b, c) && this.ch != null && this.pi != null && this.pj != null && this.pi.bh != null && this.pj.bh != null && a.width > 0 && a.height > 0 && this.ps != null && this.ps.count > 0 && this.pt != null && this.pt.count > 0 && this.pu != null && this.pu.count > 0 && this.pv != null && this.pv.count > 0 && this.pw != null && this.pw.count > 0;
        };
        ScatterTriangulationSeries.prototype.qn = function () {
            if (this.trianglesSource == null) {
                this.p1 = null;
                this.ps = null;
                this.pt = null;
                this.pu = null;
                this.py = false;
            }
        };
        ScatterTriangulationSeries.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.pi != null) {
                this.pi.hp();
            }
            if (this.pj != null) {
                this.pj.hp();
            }
        };
        ScatterTriangulationSeries.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            this.qn();
            this.l0(false);
        };
        ScatterTriangulationSeries.prototype.ap = function (a) {
            if (a != null && a == this.pi && this.pv != null) {
                return new AxisRange(this.pv.minimum, this.pv.maximum);
            }
            if (a != null && a == this.pj && this.pw != null) {
                return new AxisRange(this.pw.minimum, this.pw.maximum);
            }
            return null;
        };
        ScatterTriangulationSeries.prototype.mn = function (a, b) {
            this.l0(false);
        };
        ScatterTriangulationSeries.prototype.mm = function (a, b) {
            this.l0(false);
        };
        Object.defineProperty(ScatterTriangulationSeries.prototype, "ps", {
            get: function () {
                return this.pm;
            },
            set: function (a) {
                var b = this.ps != a;
                if (b) {
                    var c = this.ps;
                    this.pm = a;
                    this.raisePropertyChanged("TriangleVertexColumn1", c, this.ps);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterTriangulationSeries.prototype, "pt", {
            get: function () {
                return this.pn;
            },
            set: function (a) {
                var b = this.pt != a;
                if (b) {
                    var c = this.pt;
                    this.pn = a;
                    this.raisePropertyChanged("TriangleVertexColumn2", c, this.pt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScatterTriangulationSeries.prototype, "pu", {
            get: function () {
                return this.po;
            },
            set: function (a) {
                var b = this.pu != a;
                if (b) {
                    var c = this.pu;
                    this.po = a;
                    this.raisePropertyChanged("TriangleVertexColumn3", c, this.pu);
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterTriangulationSeries.prototype.get_d7 = function () {
            return true;
        };
        ScatterTriangulationSeries.prototype.get_dw = function () {
            return true;
        };
        ScatterTriangulationSeries.$t = i2.markType(ScatterTriangulationSeries, 'ScatterTriangulationSeries', Series.$);
        ScatterTriangulationSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterTriangulationSeries, 'raisePropertyChanged', ['FastTrianglesSource:px:qq', [i2.IFastItemsSource_$type, null], 'TrianglesSource::qr', [i2.IEnumerable_$type, null], 'TriangleVertexMemberPath1:p8:qs', [2, null], 'TriangleVertexMemberPath2:qa:qt', [2, null], 'TriangleVertexMemberPath3:qc:qu', [2, null], 'XAxis:pi:qv', [NumericXAxis.$, null], 'XMemberPath:qg:qw', [2, null], 'YAxis:pj:qx', [NumericYAxis.$, null], 'YMemberPath:qk:qy', [2, null]]);
        return ScatterTriangulationSeries;
    }(Series));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TriangleRasterizer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TriangleRasterizer, _super);
        function TriangleRasterizer(a, b, c, d, e, f, g) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.k = 0;
            _this.j = 0;
            _this.g = 0;
            _this.f = 0;
            _this.b = null;
            _this.d = null;
            if (a == null || b == null || e == null) {
                throw new i2.BaseError(0);
            }
            _this.a = a;
            _this.c = b;
            _this.e = e;
            _this.m = f;
            _this.l = g;
            _this.g = c;
            _this.f = d;
            return _this;
        }
        Object.defineProperty(TriangleRasterizer.prototype, "m", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                this.k = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TriangleRasterizer.prototype, "l", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                this.j = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TriangleRasterizer.prototype, "i", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TriangleRasterizer.prototype, "h", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TriangleRasterizer.prototype, "c", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TriangleRasterizer.prototype, "e", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        TriangleRasterizer.prototype.p = function (a, b, c, d, e, f, g, h) {
            var i = this.k;
            var j = this.j;
            var k;
            var l;
            if (d.y > e.y) {
                k = d;
                d = e;
                e = k;
                l = g;
                g = h;
                h = l;
            }
            if (c.y > e.y) {
                k = c;
                c = e;
                e = k;
                l = f;
                f = h;
                h = l;
            }
            if (c.y > d.y) {
                k = c;
                c = d;
                d = k;
                l = f;
                f = g;
                g = l;
            }
            var m = i2.truncate(Math.round(c.y));
            var n = i2.truncate(Math.round(d.y));
            var o = i2.truncate(Math.round(e.y));
            if (o == m) {
                return;
            }
            if (i2.isNaN_(f) || i2.isNaN_(g) || i2.isNaN_(h)) {
                return;
            }
            var p = (d.x - c.x) * (e.y - c.y) - (e.x - c.x) * (d.y - c.y) >= 0;
            var q = Math.max(0, m);
            var r = Math.min(j - 1, n);
            for (var s = q; s < r; ++s) {
                var t = (s - m) / (n - m);
                var u = c.x + t * (d.x - c.x);
                var v = f + t * (g - f);
                var w = (s - m) / (o - m);
                var x = c.x + w * (e.x - c.x);
                var y = f + w * (h - f);
                if (p) {
                    this.o(a, b, s, i2.truncate(Math.floor(x)), i2.truncate(Math.ceil(u)), y, v);
                }
                else {
                    this.o(a, b, s, i2.truncate(Math.floor(u)), i2.truncate(Math.ceil(x)), v, y);
                }
            }
            {
                var z = Math.min(j - 1, Math.max(0, n));
                var aa = Math.min(j - 1, o);
                var ab = 0;
                var ac = d.x + ab * (e.x - d.x);
                var ad = g + ab * (h - g);
                var ae = z;
                var af = (o - m);
                var ag = (ae - m) / af;
                var ah = c.x + ag * (e.x - c.x);
                var ai = f + ag * (h - f);
                do {
                    if (p) {
                        this.o(a, b, ae, i2.truncate(Math.floor(ah)), i2.truncate(Math.ceil(ac)), ai, ad);
                    }
                    else {
                        this.o(a, b, ae, i2.truncate(Math.floor(ac)), i2.truncate(Math.ceil(ah)), ad, ai);
                    }
                    ++ae;
                    ab = (ae - n) / (o - n);
                    ac = d.x + ab * (e.x - d.x);
                    ad = g + ab * (h - g);
                    ag = (ae - m) / af;
                    ah = c.x + ag * (e.x - c.x);
                    ai = f + ag * (h - f);
                } while (ae < aa);
            }
        };
        TriangleRasterizer.prototype.o = function (a, b, c, d, e, f, g) {
            var h = this.k;
            var i = d > 0 ? d : 0;
            var j = e < h - 1 ? e : h - 1;
            var k = c * h * 4 + (i * 4);
            var l = g - f;
            var m = 1 / (e - d);
            var n = this.d;
            var o = this.g;
            var p = this.f;
            var q = c * h;
            for (var r = i; r <= j; r++) {
                var s = f + l * (r - d) * m;
                var color_ = this.b.getColor(s, o, p, n);
                this.a[k] = (color_._r);
                this.a[k + 1] = (color_._g);
                this.a[k + 2] = (color_._b);
                this.a[k + 3] = (color_._a);
                b[q + r] = a + 1;
                k += 4;
            }
        };
        TriangleRasterizer.prototype.n = function () {
        };
        TriangleRasterizer.$t = i2.markType(TriangleRasterizer, 'TriangleRasterizer');
        return TriangleRasterizer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterAreaSeries, _super);
        function ScatterAreaSeries() {
            var _this = _super.call(this) || this;
            _this.q1 = null;
            _this.q6 = null;
            _this.qz = null;
            _this.q0 = null;
            i2.FastItemIntColumn.m();
            _this.ab = ScatterAreaSeries.$;
            return _this;
        }
        ScatterAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        Object.defineProperty(ScatterAreaSeries.prototype, "q3", {
            get: function () {
                return this.q1;
            },
            set: function (a) {
                var b = this.q1 != a;
                if (b) {
                    var c = this.q1;
                    if (this.q1 != null) {
                        var d = this.q1;
                        d.propertyChanged = i2.delegateRemove(d.propertyChanged, i2.runOn(this, this.rg));
                    }
                    this.q1 = a;
                    if (this.q1 != null) {
                        var e = this.q1;
                        e.propertyChanged = i2.delegateCombine(e.propertyChanged, i2.runOn(this, this.rg));
                    }
                    this.raisePropertyChanged("ColorScale", c, this.q1);
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterAreaSeries.prototype.rg = function (a, b) {
            this.ri();
            this.l0(false);
        };
        ScatterAreaSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == ScatterAreaSeries.$$p[1]) {
                return this.hl(a, b, this.rb);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        Object.defineProperty(ScatterAreaSeries.prototype, "q7", {
            get: function () {
                return this.q6;
            },
            set: function (a) {
                var b = this.q7 != a;
                if (b) {
                    var c = this.q7;
                    this.q6 = a;
                    this.raisePropertyChanged("ColorColumn", c, this.q7);
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterAreaSeries.prototype.get_ex = function () {
            return true;
        };
        ScatterAreaSeries.prototype.set_ex = function (a) {
            _super.prototype.set_ex.call(this, a);
        };
        ScatterAreaSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    var e = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.q7);
                        this.q7 = null;
                    }
                    var f = i2.typeCast(i2.IFastItemsSource_$type, d);
                    if (f != null) {
                        this.q7 = this.ce(this.rb);
                    }
                    this.l0(false);
                    break;
                case ScatterAreaSeries.$$p[1]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q7);
                        this.q7 = this.ce(this.rb);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "ColorScale":
                    this.ri();
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        ScatterAreaSeries.prototype.l1 = function (a) {
            _super.prototype.l1.call(this, a);
            this.rh(this.bx);
        };
        ScatterAreaSeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            f.a1(c);
            if (this.ct(f)) {
                return;
            }
            this.rh(f);
        };
        ScatterAreaSeries.prototype.rh = function (a) {
            if (this.ct(a)) {
                return;
            }
            var b;
            var c;
            var d = a.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            var e = a;
            var f = null;
            var g = null;
            var h = this.pi;
            var i = this.pj;
            var j = this.getEffectiveViewport1(a);
            var k = new ScalerParams(1, b, c, h.cc);
            k.c = j;
            var l = new ScalerParams(1, b, c, i.cc);
            l.c = j;
            g = this.q5(a, k, l);
            if (g != null) {
                e.b8(g);
            }
            else {
                e.cb(f);
            }
        };
        ScatterAreaSeries.prototype.re = function (a) {
            var b;
            var c;
            var d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            var e = i2.truncate(Math.round(b.width)) * i2.truncate(Math.round(b.height));
            var f = a.b0;
            if (f == null || f.length != e) {
                f = new Array(e);
                for (var g = 0; g < e; g++) {
                    f[g] = 0;
                }
            }
            else {
                for (var h = 0; h < e; h++) {
                    f[h] = 0;
                }
            }
            a.b0 = f;
        };
        ScatterAreaSeries.prototype.hh = function (a) {
            var b = i2.truncate(Math.round(this.pf.width));
            var c = i2.truncate(Math.round(this.pf.height));
            var d = this.bx.b0;
            if (d == null || d.length != (b * c) || this.ps == null || this.ps.count < 1 || this.pt == null || this.pt.count < 1 || this.pu == null || this.pu.count < 1) {
                return null;
            }
            var e = this.ca.pw;
            var f = (a.x - e.left) / e.width;
            var g = (a.y - e.top) / e.height;
            var h = i2.truncate(Math.round(b * f));
            var i = i2.truncate(Math.round(c * g));
            var j = (b * i) + h;
            if (j < 0 || j > d.length - 1) {
                return null;
            }
            var k = d[j] - 1;
            if (k < 0 || k > this.ps.count) {
                return null;
            }
            var l = this.qz.length;
            var m = this.ps.item(k);
            var n = this.pt.item(k);
            var o = this.pu.item(k);
            if ((m >= l) || (n >= l) || (o >= l)) {
                return null;
            }
            var p = (this.qz[m] - this.pf.left) / this.pf.width;
            var q = (this.q0[m] - this.pf.top) / this.pf.height;
            var r = (this.qz[n] - this.pf.left) / this.pf.width;
            var s = (this.q0[n] - this.pf.top) / this.pf.height;
            var t = (this.qz[o] - this.pf.left) / this.pf.width;
            var u = (this.q0[o] - this.pf.top) / this.pf.height;
            var v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
            var w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
            var x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
            if (v < w && v < x) {
                return this.ch.item(m);
            }
            if (w < v && w < x) {
                return this.ch.item(n);
            }
            if (x < v && x < w) {
                return this.ch.item(o);
            }
            return this.ch.item(m);
        };
        ScatterAreaSeries.prototype.q5 = function (a, b, c) {
            var d;
            var e;
            var f = a.getViewInfo(e, d);
            e = f.p0;
            d = f.p1;
            e = new i2.Rect(0, 0, 0, e.width, e.height);
            b = new ScalerParams(0, b.e, e, b.a, b.c);
            c = new ScalerParams(0, c.e, e, c.a, c.c);
            c.b = this.f2();
            var g = a;
            var h = this.pi;
            var i = this.pj;
            var j = this.ps.count;
            var k;
            var xArr_ = this.pv.asArray();
            k = (xArr_.slice(0));
            var l;
            var yArr_ = this.pw.asArray();
            l = (yArr_.slice(0));
            var m = this.q7.asArray();
            var n = this.ps.asArray();
            var o = this.pt.asArray();
            var p = this.pu.asArray();
            this.qz = k;
            this.q0 = l;
            h.g5(i2.boxArray$1(k), 0, k.length, b);
            i.g5(i2.boxArray$1(l), 0, l.length, c);
            var q = this.q2;
            var r = g.b2(b.d, q, this.q7);
            var s = e.top;
            var t = e.left;
            var u = e.right;
            var v = e.bottom;
            var w;
            var x;
            var y;
            var z;
            this.re(g);
            var aa = g.b0;
            var ab = k.length;
            for (var ac = 0; ac < j; ac++) {
                var ad = n[ac];
                var ae = o[ac];
                var af = p[ac];
                if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                    continue;
                }
                var ag = k[ad];
                var ah = l[ad];
                var ai = { $type: i2.Point_$type, x: ag, y: ah };
                var aj = k[ae];
                var ak = l[ae];
                var al = { $type: i2.Point_$type, x: aj, y: ak };
                var am = k[af];
                var an = l[af];
                var ao = { $type: i2.Point_$type, x: am, y: an };
                w = al.y < ao.y ? al.y : ao.y;
                w = ai.y < w ? ai.y : w;
                x = al.y > ao.y ? al.y : ao.y;
                x = ai.y > x ? ai.y : x;
                y = al.x < ao.x ? al.x : ao.x;
                y = ai.x < y ? ai.x : y;
                z = al.x > ao.x ? al.x : ao.x;
                z = ai.x > z ? ai.x : z;
                if (w < v && x > s && y < u && z > t) {
                    var ap = m[ad];
                    var aq = m[ae];
                    var ar = m[af];
                    r.p(ac, aa, ai, al, ao, ap, aq, ar);
                }
            }
            return r;
        };
        ScatterAreaSeries.prototype.q8 = function () {
            var a = new i2.Color();
            var b = this.of;
            if (b == null) {
                a = i2.ColorUtil.r("#000000");
            }
            else {
                a = i2.ColorUtil.q(b);
            }
            var c = new i2.ObservableColorCollection();
            c.add(i2.ColorUtil.v(a, -0.5));
            c.add(a);
            return c;
        };
        ScatterAreaSeries.prototype.ri = function () {
            var _this = this;
            var a = this.q3;
            if (a == null) {
                a = ((function () {
                    var $ret = new CustomPaletteColorScale();
                    $ret.palette = _this.q8();
                    $ret.interpolationMode = 2;
                    return $ret;
                })());
            }
            else if (i2.typeCast(CustomPaletteColorScale.$, a) !== null) {
                var b = a;
                if (b.palette == null || b.palette.count == 0) {
                    b.palette = this.q8();
                }
                a = b;
            }
            var c = new i2.ObservableColorCollection();
            if (i2.typeCast(CustomPaletteColorScale.$, a) !== null) {
                c = a.palette;
            }
            else {
                c = this.q8();
            }
            this.q2 = a;
        };
        ScatterAreaSeries.prototype.md = function () {
            _super.prototype.md.call(this);
            this.ri();
        };
        ScatterAreaSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.b7();
        };
        ScatterAreaSeries.prototype.bu = function () {
            return new ScatterAreaSeriesView(this);
        };
        ScatterAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.q4 = i2.typeCast(ScatterAreaSeriesView.$, a);
        };
        ScatterAreaSeries.prototype.rf = function (a) {
            if (this.q4 != null) {
                this.q4.b6(a);
            }
        };
        ScatterAreaSeries.$t = i2.markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
        ScatterAreaSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:q2:rj', [ColorScale.$, null], 'ColorMemberPath:rb:rk', [2, null]]);
        return ScatterAreaSeries;
    }(ScatterTriangulationSeries));
    /**
     * @hidden
     */
    var ScatterAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterAreaSeriesView, _super);
        function ScatterAreaSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.b1 = null;
            _this.bx = null;
            _this.b5 = null;
            _this.b4 = null;
            _this.b3 = null;
            _this.b1 = a;
            return _this;
        }
        Object.defineProperty(ScatterAreaSeriesView.prototype, "b0", {
            get: function () {
                return this.bx;
            },
            set: function (a) {
                this.bx = a;
            },
            enumerable: false,
            configurable: true
        });
        ScatterAreaSeriesView.prototype.ca = function (a, b) {
        };
        ScatterAreaSeriesView.prototype.b6 = function (a) {
        };
        ScatterAreaSeriesView.prototype.by = function () {
            return this.bz(true);
        };
        ScatterAreaSeriesView.prototype.bz = function (a) {
            this.b9();
            var b = i2.truncate(Math.round(this.bu.left));
            var c = i2.truncate(Math.round(this.bu.left));
            var d = i2.truncate(Math.round(this.bu.width));
            var e = i2.truncate(Math.round(this.bu.height));
            var f = d.toString();
            var g = e.toString();
            if (this.b4.getAttribute("width") != f) {
                this.b4.setAttribute("width", d.toString());
            }
            if (this.b4.getAttribute("height") != g) {
                this.b4.setAttribute("height", e.toString());
            }
            var h = this.b3.g();
            if (a) {
                h.clearRect(0, 0, d, e);
            }
            this.b5 = h.getImageData(0, 0, d, e);
            var imageDataArray_ = this.b5.data;
            return imageDataArray_;
        };
        ScatterAreaSeriesView.prototype.b9 = function () {
            if (this.b4 == null) {
                this.b4 = this.e.gw.createElement("canvas");
                var a = this.e.gw.get2DCanvasContext(this.b4);
                this.b3 = new i2.RenderingContext(new i2.CanvasViewRenderer(), a);
            }
        };
        ScatterAreaSeriesView.prototype.b2 = function (a, b, c) {
            var d = i2.truncate(Math.round(this.bu.left));
            var e = i2.truncate(Math.round(this.bu.left));
            var f = i2.truncate(Math.round(this.bu.width));
            var g = i2.truncate(Math.round(this.bu.height));
            return new TriangleRasterizer(this.by(), b, c.minimum, c.maximum, c, f, g);
        };
        ScatterAreaSeriesView.prototype.b8 = function (a) {
            this.cb(null);
        };
        ScatterAreaSeriesView.prototype.b7 = function () {
            if (this.b3 != null) {
                this.b3.k(this.bu.left, this.bu.top, this.bu.width, this.bu.height);
            }
            this.aq();
        };
        ScatterAreaSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (this.b4 == null) {
                return;
            }
            if (b) {
                var c = new i2.Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
            }
            else {
                var d = i2.truncate(Math.round(this.bu.left));
                var e = i2.truncate(Math.round(this.bu.top));
                var f = i2.truncate(Math.round(this.bu.width));
                var g = i2.truncate(Math.round(this.bu.height));
                a.m(this.b4.getNativeElement(), 1, d, e, f, g);
            }
        };
        ScatterAreaSeriesView.prototype.cb = function (a) {
            var b = i2.truncate(Math.round(this.bu.left));
            var c = i2.truncate(Math.round(this.bu.left));
            var d = i2.truncate(Math.round(this.bu.width));
            var e = i2.truncate(Math.round(this.bu.height));
            this.b9();
            this.b3.g().putImageData(this.b5, 0, 0);
            this.aq();
        };
        ScatterAreaSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            var b = i2.truncate(Math.round(this.bu.width));
            var c = i2.truncate(Math.round(this.bu.height));
            var d = this.bz(false);
            if (d == null || d.length == 0) {
                this.e.a6.exportSeriesPixelsData(a, null, b, c);
                return;
            }
            var e = new Array(i2.intDivide(d.length, 4));
            var f;
            for (var g = 0; g < i2.intDivide(d.length, 4); g++) {
                f = g * 4;
                e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
            }
            this.e.a6.exportSeriesPixelsData(a, e, b, c);
        };
        ScatterAreaSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b1.hp + "</span><br/><span>" + "(${item." + this.b1.qg + "}, ${item." + this.b1.qk + "})</span>";
            if (!i2.stringIsNullOrEmpty(this.b1.rb)) {
                a += "<span>, Value: ${item." + this.b1.rb + "}</span>";
            }
            a += "</div>";
            return a;
        };
        ScatterAreaSeriesView.$t = i2.markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
        return ScatterAreaSeriesView;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Series class which draws a colored 2D surface based on a triangulation of XY data with numeric values assigned to each point.
    */
    var IgxScatterAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterAreaSeriesComponent, _super);
        function IgxScatterAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterAreaSeriesComponent.prototype.createImplementation = function () {
            return new ScatterAreaSeries();
        };
        Object.defineProperty(IgxScatterAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterAreaSeriesComponent.prototype, "colorScale", {
            /**
             * Gets or sets ColorScale used to resolve the color values of points in the series.
            */
            get: function () {
                if (this.i.q3 == null) {
                    return null;
                }
                if (!this.i.q3.externalObject) {
                    var e = IgxColorScaleComponent._createFromInternal(this.i.q3);
                    if (e) {
                        e._implementation = this.i.q3;
                    }
                    this.i.q3.externalObject = e;
                }
                return this.i.q3.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q3 = null : this.i.q3 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterAreaSeriesComponent.prototype, "colorMemberPath", {
            /**
             * Gets or sets the name of the property on each data item containing a numeric value which can be converted to a color by the ColorScale.
            */
            get: function () {
                return this.i.rb;
            },
            set: function (v) {
                this.i.rb = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterAreaSeriesComponent.prototype, "actualColorScale", {
            /**
             * Gets actual color scale that is set on ColorScale property or default ColorScale
            */
            get: function () {
                if (this.i.q2 == null) {
                    return null;
                }
                if (!this.i.q2.externalObject) {
                    var e = IgxColorScaleComponent._createFromInternal(this.i.q2);
                    if (e) {
                        e._implementation = this.i.q2;
                    }
                    this.i.q2.externalObject = e;
                }
                return this.i.q2.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q2 = null : this.i.q2 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterAreaSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.colorScale && this.colorScale.name && this.colorScale.name == name) {
                return this.colorScale;
            }
            if (this.actualColorScale && this.actualColorScale.name && this.actualColorScale.name == name) {
                return this.actualColorScale;
            }
            return null;
        };
        IgxScatterAreaSeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.colorScale && this.colorScale._styling) {
                this.colorScale._styling(container, component, this);
            }
            if (this.actualColorScale && this.actualColorScale._styling) {
                this.actualColorScale._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxScatterAreaSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxScatterAreaSeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Updates ActualColorScale properties when the ColorScale property has changed
        
        */
        IgxScatterAreaSeriesComponent.prototype.updateActualColorScale = function () {
            this.i.ri();
        };
        /**
         * Attaches an image to the view of this series
        
        */
        IgxScatterAreaSeriesComponent.prototype.attachImage = function (image) {
            this.i.rf(image);
        };
        IgxScatterAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterAreaSeriesComponent, selector: "igx-scatter-area-series", inputs: { colorScale: "colorScale", colorMemberPath: "colorMemberPath", actualColorScale: "actualColorScale" }, providers: [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterAreaSeriesComponent;
    }(IgxScatterTriangulationSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-area-series',
                        template: "",
                        providers: [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { colorScale: [{
                    type: i0.Input
                }], colorMemberPath: [{
                    type: i0.Input
                }], actualColorScale: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterAreaSeriesModule() {
        }
        IgxScatterAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesModule, declarations: [IgxScatterAreaSeriesComponent], imports: [i1.CommonModule, IgxCustomPaletteColorScaleModule], exports: [IgxScatterAreaSeriesComponent, IgxCustomPaletteColorScaleModule] });
        IgxScatterAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesModule, imports: [[i1.CommonModule, IgxCustomPaletteColorScaleModule], IgxCustomPaletteColorScaleModule] });
        return IgxScatterAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterAreaSeriesComponent],
                        imports: [i1.CommonModule, IgxCustomPaletteColorScaleModule],
                        exports: [IgxScatterAreaSeriesComponent, IgxCustomPaletteColorScaleModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterAreaSeriesComponent", IgxScatterAreaSeriesComponent);
            i2.TypeRegistrar.register("ScatterAreaSeries", ScatterAreaSeries.$type);
        }
        IgxScatterAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterAreaSeriesModule], exports: [IgxScatterAreaSeriesModule] });
        IgxScatterAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterAreaSeriesModule], IgxScatterAreaSeriesModule] });
        return IgxScatterAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterAreaSeriesModule],
                        exports: [IgxScatterAreaSeriesModule],
                        entryComponents: [IgxScatterAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Class used to determine the numeric values of contour lines, given a larger list of numeric values.
    */
    var IgxContourValueResolverComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxContourValueResolverComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxContourValueResolverComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxContourValueResolverComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxContourValueResolverComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxContourValueResolverComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxContourValueResolverComponent.prototype.onImplementationCreated = function () {
        };
        IgxContourValueResolverComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxContourValueResolverComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxContourValueResolverComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxContourValueResolverComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("ContourValueResolverComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxContourValueResolverComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxContourValueResolverComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxContourValueResolverComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxContourValueResolverComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxContourValueResolverComponent, selector: "ng-component", ngImport: i0, template: "", isInline: true });
        return IgxContourValueResolverComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxContourValueResolverComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContourValueResolver, _super);
        function ContourValueResolver() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.updated = null;
            return _this;
        }
        ContourValueResolver.prototype.l = function (a, b, c) {
            if (this.updated != null) {
                this.updated(this, i2.EventArgs.empty);
            }
        };
        ContourValueResolver.$t = i2.markType(ContourValueResolver, 'ContourValueResolver', i2.DependencyObject.$);
        return ContourValueResolver;
    }(i2.DependencyObject));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var LinearContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LinearContourValueResolver, _super);
        function LinearContourValueResolver() {
            return _super.call(this) || this;
        }
        LinearContourValueResolver.prototype._j = function (a) {
            var b;
            return tslib.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        b = 0;
                        _a.label = 1;
                    case 1:
                        if (!(b < this.valueCount))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, a.minimum + (a.maximum - a.minimum) * (b + 1) / (this.valueCount + 1)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        b++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        };
        LinearContourValueResolver.prototype.j = function (a) {
            var _this = this;
            return i2.toEnum(function () { return _this._j(a); });
        };
        LinearContourValueResolver.$t = i2.markType(LinearContourValueResolver, 'LinearContourValueResolver', ContourValueResolver.$);
        LinearContourValueResolver.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, LinearContourValueResolver, 'l', ['ValueCount::o', [1, 10]]);
        return LinearContourValueResolver;
    }(ContourValueResolver));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolylineBuilder = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolylineBuilder, _super);
        function PolylineBuilder() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = new i2.Dictionary$2(i2.Number_$type, i2.List$1.$.specialize(i2.Number_$type), 0);
            _this.b = new i2.Dictionary$2(i2.Number_$type, i2.List$1.$.specialize(i2.Number_$type), 0);
            return _this;
        }
        PolylineBuilder.prototype.e = function () {
            this.a.clear();
            this.b.clear();
        };
        PolylineBuilder.prototype.c = function () {
            var e_1, _a;
            var a = new i2.List$1(i2.List$1.$.specialize(i2.Number_$type), 0);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.a.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    a.add(b);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return a;
        };
        PolylineBuilder.prototype.d = function (a, b) {
            var c = null;
            var d = null;
            var e = this.b.tryGetValue(a, c);
            c = e.p1;
            var f = this.a.tryGetValue(b, d);
            d = f.p1;
            if (c == null && d == null) {
                var g = new i2.List$1(i2.Number_$type, 0);
                g.add(a);
                g.add(b);
                this.a.addItem(a, g);
                this.b.addItem(b, g);
            }
            if (c == null && d != null) {
                this.a.removeItem(b);
                d.insert(0, a);
                this.a.addItem(a, d);
            }
            if (c != null && d == null) {
                this.b.removeItem(a);
                c.add(b);
                this.b.addItem(b, c);
            }
            if (c != null && d != null) {
                if (c == d) {
                    c.add(b);
                    this.b.removeItem(a);
                }
                else {
                    this.a.removeItem(d._inner[0]);
                    this.b.removeItem(d._inner[d.count - 1]);
                    this.b.removeItem(c._inner[c.count - 1]);
                    c.o(d);
                    this.b.addItem(c._inner[c.count - 1], c);
                }
            }
        };
        PolylineBuilder.$t = i2.markType(PolylineBuilder, 'PolylineBuilder');
        return PolylineBuilder;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ContourBuilder = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContourBuilder, _super);
        function ContourBuilder() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = new i2.Dictionary$2(i2.Number_$type, i2.Number_$type, 0);
            _this.i = new i2.List$1(i2.Number_$type, 0);
            _this.j = new i2.List$1(i2.Number_$type, 0);
            return _this;
        }
        ContourBuilder.prototype.e = function () {
            _super.prototype.e.call(this);
            this.f.clear();
            this.i.clear();
            this.j.clear();
        };
        Object.defineProperty(ContourBuilder.prototype, "g", {
            get: function () {
                return this.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ContourBuilder.prototype, "h", {
            get: function () {
                return this.j;
            },
            enumerable: false,
            configurable: true
        });
        ContourBuilder.prototype.k = function (a, b, c, d, e, f, g, h, i) {
            var _this = this;
            var j = Math.min(a, e) + 0x100000000 * Math.max(a, e);
            var k = -1;
            if (!((function () { var l = _this.f.tryGetValue(j, k); k = l.p1; return l.ret; })())) {
                k = this.i.count;
                var l = (i - d) / (h - d);
                this.f.addItem(j, k);
                this.i.add((b + l * (f - b)));
                this.j.add((c + l * (g - c)));
            }
            return k;
        };
        ContourBuilder.$t = i2.markType(ContourBuilder, 'ContourBuilder', PolylineBuilder.$);
        return ContourBuilder;
    }(PolylineBuilder));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterContourSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterContourSeries, _super);
        function ScatterContourSeries() {
            var _this = _super.call(this) || this;
            _this.q4 = null;
            _this.qz = null;
            i2.FastItemIntColumn.m();
            _this.ab = ScatterContourSeries.$;
            _this.q0 = new LinearContourValueResolver();
            return _this;
        }
        ScatterContourSeries.prototype.get_du = function () {
            return true;
        };
        ScatterContourSeries.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == ScatterContourSeries.$$p[2]) {
                return this.hl(a, b, this.q9);
            }
            return _super.prototype.hk.call(this, a, b);
        };
        ScatterContourSeries.prototype.bu = function () {
            this.q1 = new ScatterContourSeriesView(this);
            return this.q1;
        };
        Object.defineProperty(ScatterContourSeries.prototype, "q5", {
            get: function () {
                return this.q4;
            },
            set: function (a) {
                var b = this.q5 != a;
                if (b) {
                    var c = this.q5;
                    this.q4 = a;
                    this.raisePropertyChanged("ValueColumn", c, this.q5);
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterContourSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    var e = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.q5);
                        this.q5 = null;
                    }
                    var f = i2.typeCast(i2.IFastItemsSource_$type, d);
                    if (f != null) {
                        this.q5 = this.ce(this.q9);
                    }
                    this.l0(false);
                    break;
                case ScatterContourSeries.$$p[2]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.q5);
                        this.q5 = this.ce(this.q9);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case "ValueResolver":
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterContourSeries.$$p[1]:
                    var g = c;
                    var h = d;
                    if (g != null) {
                        g.unregisterSeries(this);
                    }
                    if (h != null) {
                        h.registerSeries(this);
                    }
                    this.rd();
                    this.l0(false);
                    this.k7();
                    break;
                case "ActualBrush":
                    this.rd();
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        ScatterContourSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            if (a) {
                b.b3(a);
            }
        };
        ScatterContourSeries.prototype.l1 = function (a) {
            _super.prototype.l1.call(this, a);
            this.rc(this.bx);
        };
        ScatterContourSeries.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            f.a1(c);
            if (this.ct(f)) {
                return;
            }
            this.rc(f);
        };
        ScatterContourSeries.prototype.rc = function (a) {
            var e_1, _a;
            if (this.ct(a)) {
                return;
            }
            var b;
            var c;
            var d = a;
            var e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            var f = new ScalerParams(1, b, c, this.pi.cc);
            f.c = this.getEffectiveViewport1(a);
            var g = new ScalerParams(1, b, c, this.pj.cc);
            g.c = this.getEffectiveViewport1(a);
            var h = this.pi;
            var i = this.pj;
            var j = this.ps.count;
            var k;
            var xArr_ = this.pv.asArray();
            k = (xArr_.slice(0));
            var l;
            var yArr_ = this.pw.asArray();
            l = (yArr_.slice(0));
            var m = this.q5.asArray();
            var n = this.ps.asArray();
            var o = this.pt.asArray();
            var p = this.pu.asArray();
            var q = this.q0.j(this.q5);
            var r = new i2.List$1(i2.Number_$type, 1, q).toArray();
            h.g5(i2.boxArray$1(k), 0, k.length, f);
            i.g5(i2.boxArray$1(l), 0, l.length, g);
            var s = r.length;
            var t = new Array(s);
            for (var u = 0; u < s; ++u) {
                t[u] = new ContourBuilder();
            }
            var v = c.top;
            var w = c.left;
            var x = c.right;
            var y = c.bottom;
            var z;
            var aa;
            var ab;
            var ac;
            var ad = k.length;
            for (var ae = 0; ae < j; ae++) {
                var af = n[ae];
                var ag = o[ae];
                var ah = p[ae];
                if ((af >= ad) || (ag >= ad) || (ah >= ad) || (af < 0) || (ag < 0) || (ah < 0)) {
                    continue;
                }
                var ai = k[af];
                var aj = l[af];
                var ak = { $type: i2.Point_$type, x: ai, y: aj };
                var al = k[ag];
                var am = l[ag];
                var an = { $type: i2.Point_$type, x: al, y: am };
                var ao = k[ah];
                var ap = l[ah];
                var aq = { $type: i2.Point_$type, x: ao, y: ap };
                z = an.y < aq.y ? an.y : aq.y;
                z = ak.y < z ? ak.y : z;
                aa = an.y > aq.y ? an.y : aq.y;
                aa = ak.y > aa ? ak.y : aa;
                ab = an.x < aq.x ? an.x : aq.x;
                ab = ak.x < ab ? ak.x : ab;
                ac = an.x > aq.x ? an.x : aq.x;
                ac = ak.x > ac ? ak.x : ac;
                if (z < y && aa > v && ab < x && ac > w) {
                    var ar = m[af];
                    var as = m[ag];
                    var at = m[ah];
                    if (i2.isNaN_(ar) || i2.isNaN_(as) || i2.isNaN_(at)) {
                        continue;
                    }
                    for (var au = 0; au < s; au++) {
                        var av = r[au];
                        var aw = t[au];
                        switch ((ar < av ? 1 : 0) | (as < av ? 2 : 0) | (at < av ? 4 : 0)) {
                            case 0: break;
                            case 1:
                                aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                                break;
                            case 2:
                                aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                                break;
                            case 3:
                                aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                                break;
                            case 4:
                                aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                                break;
                            case 5:
                                aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                                break;
                            case 6:
                                aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                                break;
                            case 7: break;
                        }
                    }
                }
            }
            var ax = new i2.Clipper(0, i2.RectUtil.r(c, 2), false);
            var ay = new i2.List$1(i2.List$1.$.specialize(i2.List$1.$.specialize(i2.Point_$type)), 0);
            for (var az = 0; az < s; ++az) {
                var a0 = t[az];
                var a1 = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 0);
                var a2 = a0.c();
                for (var a3 = 0; a3 < a2.count; a3++) {
                    var a4 = a2._inner[a3];
                    var a5 = new i2.List$1(i2.Point_$type, 0);
                    ax.i = a5;
                    try {
                        for (var _b = (e_1 = void 0, tslib.__values(i2.fromEnum(a4))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var a6 = _c.value;
                            ax.j({ $type: i2.Point_$type, x: a0.g.item(a6), y: a0.h.item(a6) });
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                    ax.i = null;
                    a1.add(a5);
                }
                ay.add(a1);
            }
            d.b2(ay, r);
        };
        ScatterContourSeries.prototype.md = function () {
            _super.prototype.md.call(this);
            this.rd();
        };
        ScatterContourSeries.prototype.rd = function () {
            var e_2, _a;
            var a = this.of;
            if (a == null) {
                a = this.oj;
            }
            if (a == null) {
                a = i2.BrushUtil.g(255, 255, 255, 255);
            }
            var b = new ValueBrushScale();
            b.brushes = new i2.BrushCollection();
            if (this.q3 == null || this.q3.brushes == null || this.q3.brushes.count == 0) {
                b.brushes.add(i2.BrushUtil.l(a, -0.5));
                b.brushes.add(a);
            }
            else {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.q3.brushes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        b.brushes.add(c);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
            if (this.q3 != null) {
                if (!i2.isNaN_(this.q3.minimumValue)) {
                    b.minimumValue = this.q3.minimumValue;
                }
                if (!i2.isNaN_(this.q3.maximumValue)) {
                    b.maximumValue = this.q3.maximumValue;
                }
                b.logarithmBase = this.q3.logarithmBase;
                b.isLogarithmic = this.q3.isLogarithmic;
            }
            this.q2 = b;
        };
        Object.defineProperty(ScatterContourSeries.prototype, "q0", {
            get: function () {
                return this.qz;
            },
            set: function (a) {
                var b = a != this.q0;
                if (b) {
                    if (this.qz != null) {
                        var c = this.qz;
                        c.updated = i2.delegateRemove(c.updated, i2.runOn(this, this.re));
                    }
                    var d = this.qz;
                    this.qz = a;
                    if (this.qz != null) {
                        var e = this.qz;
                        e.updated = i2.delegateCombine(e.updated, i2.runOn(this, this.re));
                    }
                    this.raisePropertyChanged("ValueResolver", d, a);
                    this.l0(false);
                }
            },
            enumerable: false,
            configurable: true
        });
        ScatterContourSeries.prototype.re = function (a, b) {
            this.l0(false);
        };
        ScatterContourSeries.prototype.e3 = function (a, b, c) {
            return _super.prototype.e3.call(this, a, b, c) && this.q0 != null && this.pv != null && this.pw != null && this.ps != null && this.pt != null && this.pu != null && this.pv.count > 0 && this.pw.count > 0 && this.ps.count > 0 && this.pt.count > 0 && this.pu.count > 0;
        };
        ScatterContourSeries.prototype.at = function (a, b) {
            var c = this.q1.b7(a, b);
            if (c != null) {
                return c.dataContext;
            }
            return null;
        };
        ScatterContourSeries.$t = i2.markType(ScatterContourSeries, 'ScatterContourSeries', ScatterTriangulationSeries.$);
        ScatterContourSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterContourSeries, 'raisePropertyChanged', ['ActualFillScale:q2:rf', [ValueBrushScale.$, null], 'FillScale:q3:rg', [ValueBrushScale.$, null], 'ValueMemberPath:q9:rh', [2, null]]);
        return ScatterContourSeries;
    }(ScatterTriangulationSeries));
    /**
     * @hidden
     */
    var ScatterContourSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterContourSeriesView, _super);
        function ScatterContourSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.bz = null;
            _this.by = null;
            _this.b1 = null;
            _this.b0 = new i2.List$1(i2.Brush.$, 0);
            _this.bx = null;
            _this.b1 = new i2.List$1(i2.Path.$, 0);
            _this.by = a;
            _this.bz = ((function () {
                var $ret = new i2.Pool$1(i2.Path.$);
                $ret.create = i2.runOn(_this, _this.b8);
                $ret.destroy = i2.runOn(_this, _this.b6);
                $ret.activate = i2.runOn(_this, _this.b4);
                $ret.disactivate = i2.runOn(_this, _this.b5);
                return $ret;
            })());
            return _this;
        }
        ScatterContourSeriesView.prototype.b8 = function () {
            var _this = this;
            var a = new i2.Path();
            a.dataContext = ((function () {
                var $ret = new i2.DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
            this.b1.add(a);
            return a;
        };
        ScatterContourSeriesView.prototype.b4 = function (a) {
            a._visibility = 0;
        };
        ScatterContourSeriesView.prototype.b5 = function (a) {
            a._visibility = 1;
        };
        ScatterContourSeriesView.prototype.b6 = function (a) {
            this.b1.remove(a);
        };
        ScatterContourSeriesView.prototype.b2 = function (a, b) {
            var c = 0;
            this.bx = b;
            this.b0.clear();
            var d = this.by.q2;
            for (var e = 0; e < b.length; e++) {
                var f = b[e];
                var g = a._inner[c];
                var h = new i2.PathGeometry();
                var _loop_1 = function (i) {
                    var j = g._inner[i];
                    if (j.count == 0) {
                        return "continue";
                    }
                    var k = i2.PointCollectionUtil.f(j);
                    var l = ((function () {
                        var $ret = new i2.PathFigure();
                        $ret.isClosed = false;
                        $ret.isFilled = false;
                        $ret.startPoint = k._inner[0];
                        return $ret;
                    })());
                    l._segments.add(((function () {
                        var $ret = new i2.PolyLineSegment();
                        $ret.points = k;
                        return $ret;
                    })()));
                    h.c.add(l);
                };
                for (var i = 0; i < g.count; i++) {
                    _loop_1(i);
                }
                this.bz.item(c).ak = h;
                if (this.bz.item(c).dataContext != null) {
                    this.bz.item(c).dataContext.item = f;
                }
                if (d != null) {
                    var m = d.getBrushByValue(f, this.by.q5);
                    if (m == null) {
                        m = this.e.of;
                    }
                    this.b0.add(m);
                }
                else {
                    this.b0.add(this.e.of);
                }
                c++;
            }
            this.bz.count = c;
            this.aq();
        };
        ScatterContourSeriesView.prototype.be = function (a, b) {
            _super.prototype.be.call(this, a, b);
            var c = a;
            c._stroke = this.b0._inner[b];
            c.ac = this.e.fl;
            if (c.y != null) {
                this.k.i(c, c.y);
            }
        };
        ScatterContourSeriesView.prototype.bf = function (a, b) {
            _super.prototype.bf.call(this, a, b);
            var c = a;
            var d = this.bp(b);
            c._stroke = d;
            c.ac = this.e.fl + 3;
        };
        ScatterContourSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            for (var c = 0; c < this.b1.count; c++) {
                var d = this.b1._inner[c];
                if (d._visibility != 1) {
                    this.bd(d, c, b);
                    a.s(d);
                }
            }
        };
        ScatterContourSeriesView.prototype.b3 = function (a) {
            this.bz.count = 0;
            this.aq();
        };
        ScatterContourSeriesView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            var b = new i2.List$1(i2.Tuple$2.$.specialize(i2.Number_$type, i2.Path.$), 0);
            if (this.bx != null) {
                for (var c = 0; c < this.bz.count; c++) {
                    b.add(new i2.Tuple$2(i2.Number_$type, i2.Path.$, this.bx[c], this.bz.item(c)));
                }
            }
            b.aa(function (d, e) {
                if (d.c < e.c) {
                    return -1;
                }
                else if (d.c > e.c) {
                    return 1;
                }
                return 0;
            });
            for (var d = 0; d < b.count; d++) {
                var e = i2.typeCast(i2.Path.$, b._inner[d].d);
                if (e._visibility != 1) {
                    this.e.a6.exportPathData(a, e, "contour" + d, ["Main "]);
                }
            }
        };
        ScatterContourSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.by.hp + "</span><br/>";
            if (!i2.stringIsNullOrEmpty(this.by.q9)) {
                a += "<span>Value: ${item}</span>";
            }
            a += "</div>";
            return a;
        };
        ScatterContourSeriesView.prototype.b7 = function (a, b) {
            for (var c = 0; c < this.b1.count; c++) {
                var d = this.b1._inner[c];
                var e = i2.typeCast(i2.PathGeometry.$, d.ak);
                if (e != null) {
                    for (var f = 0; f < e.c.count; f++) {
                        var g = e.c._inner[f];
                        var h = e.c._inner[f]._startPoint;
                        for (var i = 0; i < g._segments.count; i++) {
                            var j = i2.typeCast(i2.PolyLineSegment.$, g._segments._inner[i]);
                            if (j != null) {
                                var k = this.by.fl / 2 + this.by.fz(b);
                                if (j._points.count > 0 && i2.GeometryUtil.b(a, h, j._points, k)) {
                                    return d;
                                }
                            }
                        }
                    }
                }
            }
            return null;
        };
        ScatterContourSeriesView.$t = i2.markType(ScatterContourSeriesView, 'ScatterContourSeriesView', SeriesView.$);
        return ScatterContourSeriesView;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Series class for rendering isarithmic contours based on a triangulation of X+Y+Value points in the ItemsSource.
    */
    var IgxScatterContourSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterContourSeriesComponent, _super);
        function IgxScatterContourSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterContourSeriesComponent.prototype.createImplementation = function () {
            return new ScatterContourSeries();
        };
        Object.defineProperty(IgxScatterContourSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterContourSeriesComponent.prototype, "isLineContour", {
            /**
             * Gets whether the current series shows a line contour shape.
            */
            get: function () {
                return this.i.du;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterContourSeriesComponent.prototype, "valueMemberPath", {
            /**
             * Gets or set the name of the property from which to retrieve the numeric values from the ItemsSource items.
            */
            get: function () {
                return this.i.q9;
            },
            set: function (v) {
                this.i.q9 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterContourSeriesComponent.prototype, "fillScale", {
            /**
             * Gets or sets the ValueBrushScale to use when determining Brushes for each contour line, based on the values found in ValueMemberPath.
            */
            get: function () {
                if (this.i.q3 == null) {
                    return null;
                }
                if (!this.i.q3.externalObject) {
                    var e = IgxValueBrushScaleComponent._createFromInternal(this.i.q3);
                    if (e) {
                        e._implementation = this.i.q3;
                    }
                    this.i.q3.externalObject = e;
                }
                return this.i.q3.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q3 = null : this.i.q3 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterContourSeriesComponent.prototype, "actualFillScale", {
            /**
             * Gets actual fill scale that is set on the FillScale property or default FillScale
            */
            get: function () {
                if (this.i.q2 == null) {
                    return null;
                }
                if (!this.i.q2.externalObject) {
                    var e = IgxValueBrushScaleComponent._createFromInternal(this.i.q2);
                    if (e) {
                        e._implementation = this.i.q2;
                    }
                    this.i.q2.externalObject = e;
                }
                return this.i.q2.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q2 = null : this.i.q2 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterContourSeriesComponent.prototype, "valueResolver", {
            /**
             * Gets or set the ContourValueResolver used to determine the numeric values of contours.
            */
            get: function () {
                if (this.i.q0 == null) {
                    return null;
                }
                if (!this.i.q0.externalObject) {
                    var e = IgxContourValueResolverComponent._createFromInternal(this.i.q0);
                    if (e) {
                        e._implementation = this.i.q0;
                    }
                    this.i.q0.externalObject = e;
                }
                return this.i.q0.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.q0 = null : this.i.q0 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterContourSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.fillScale && this.fillScale.name && this.fillScale.name == name) {
                return this.fillScale;
            }
            if (this.actualFillScale && this.actualFillScale.name && this.actualFillScale.name == name) {
                return this.actualFillScale;
            }
            if (this.valueResolver && this.valueResolver.name && this.valueResolver.name == name) {
                return this.valueResolver;
            }
            return null;
        };
        IgxScatterContourSeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.fillScale && this.fillScale._styling) {
                this.fillScale._styling(container, component, this);
            }
            if (this.actualFillScale && this.actualFillScale._styling) {
                this.actualFillScale._styling(container, component, this);
            }
            if (this.valueResolver && this.valueResolver._styling) {
                this.valueResolver._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxScatterContourSeriesComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        IgxScatterContourSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterContourSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterContourSeriesComponent, selector: "igx-scatter-contour-series", inputs: { valueMemberPath: "valueMemberPath", fillScale: "fillScale", actualFillScale: "actualFillScale", valueResolver: "valueResolver" }, providers: [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterContourSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterContourSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterContourSeriesComponent;
    }(IgxScatterTriangulationSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-contour-series',
                        template: "",
                        providers: [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterContourSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterContourSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { valueMemberPath: [{
                    type: i0.Input
                }], fillScale: [{
                    type: i0.Input
                }], actualFillScale: [{
                    type: i0.Input
                }], valueResolver: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterContourSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterContourSeriesModule() {
        }
        IgxScatterContourSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterContourSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesModule, declarations: [IgxScatterContourSeriesComponent], imports: [i1.CommonModule], exports: [IgxScatterContourSeriesComponent] });
        IgxScatterContourSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesModule, imports: [[i1.CommonModule]] });
        return IgxScatterContourSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterContourSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxScatterContourSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterContourSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterContourSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterContourSeriesComponent", IgxScatterContourSeriesComponent);
            i2.TypeRegistrar.register("ScatterContourSeries", ScatterContourSeries.$type);
        }
        IgxScatterContourSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterContourSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterContourSeriesModule], exports: [IgxScatterContourSeriesModule] });
        IgxScatterContourSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterContourSeriesModule], IgxScatterContourSeriesModule] });
        return IgxScatterContourSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterContourSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterContourSeriesModule],
                        exports: [IgxScatterContourSeriesModule],
                        entryComponents: [IgxScatterContourSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available modes for searching for items in the shape series.
     */
    var ShapeItemSearchMode = /*@__PURE__*/ (function (ShapeItemSearchMode) {
        /**
         * Search mode is automatically determined by the component.
         */
        ShapeItemSearchMode[ShapeItemSearchMode["Auto"] = 0] = "Auto";
        /**
         * When searching for a shape, the shape with the closest bounding box is selected.
         */
        ShapeItemSearchMode[ShapeItemSearchMode["ClosestBoundingBox"] = 1] = "ClosestBoundingBox";
        /**
         * When searching for a shape, the shape with a border closest to the target point is selected.
         * The search is skipped in performance critical scenarios if the number of bounds is over ItemSearchThreshold, or if the number of points in a shape is over ItemSearchPointsThreshold.
         */
        ShapeItemSearchMode[ShapeItemSearchMode["ClosestShape"] = 2] = "ClosestShape";
        /**
         * When searching for a shape, the closest point along the closest shape is used.
         * The search is skipped in performance critical scenarios if the number of bounds is over ItemSearchThreshold, or if the number of points in a shape is over ItemSearchPointsThreshold.
         */
        ShapeItemSearchMode[ShapeItemSearchMode["ClosestPointOnClosestShape"] = 3] = "ClosestPointOnClosestShape";
        /**
         * No shapes will be searched for the in the shape series.
         */
        ShapeItemSearchMode[ShapeItemSearchMode["None"] = 4] = "None";
        return ShapeItemSearchMode;
    })({});
    /**
     * @hidden
     */
    var ShapeItemSearchMode_$type = i2.markEnum('ShapeItemSearchMode', 'Auto,0|ClosestBoundingBox,1|ClosestShape,2|ClosestPointOnClosestShape,3|None,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningShapeStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningShapeStyleEventArgs, _super);
        function AssigningShapeStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningShapeStyleEventArgs.$t = i2.markType(AssigningShapeStyleEventArgs, 'AssigningShapeStyleEventArgs', AssigningSeriesShapeStyleEventArgsBase.$);
        return AssigningShapeStyleEventArgs;
    }(AssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningShapeStyleEvent
    */
    var IgxAssigningShapeStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningShapeStyleEventArgs, _super);
        function IgxAssigningShapeStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningShapeStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningShapeStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningShapeStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningShapeStyleEventArgs;
    }(IgxAssigningSeriesShapeStyleEventArgsBase));

    /**
     * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
    */
    var IgxAssigningShapeStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningShapeStyleEventArgsBase, _super);
        function IgxAssigningShapeStyleEventArgsBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxAssigningShapeStyleEventArgsBase.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningShapeStyleEventArgsBase;
    }(IgxAssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningShapeStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningShapeStyleEventArgsBase, _super);
        function AssigningShapeStyleEventArgsBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningShapeStyleEventArgsBase.$t = i2.markType(AssigningShapeStyleEventArgsBase, 'AssigningShapeStyleEventArgsBase', AssigningSeriesStyleEventArgsBase.$);
        return AssigningShapeStyleEventArgsBase;
    }(AssigningSeriesStyleEventArgsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AssigningShapeMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AssigningShapeMarkerStyleEventArgs, _super);
        function AssigningShapeMarkerStyleEventArgs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AssigningShapeMarkerStyleEventArgs.$t = i2.markType(AssigningShapeMarkerStyleEventArgs, 'AssigningShapeMarkerStyleEventArgs', AssigningShapeStyleEventArgsBase.$);
        return AssigningShapeMarkerStyleEventArgs;
    }(AssigningShapeStyleEventArgsBase));

    /**
     * Represents event arguments class for the AssigningShapeStyleEvent
    */
    var IgxAssigningShapeMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAssigningShapeMarkerStyleEventArgs, _super);
        function IgxAssigningShapeMarkerStyleEventArgs() {
            return _super.call(this) || this;
        }
        IgxAssigningShapeMarkerStyleEventArgs.prototype.createImplementation = function () {
            return new AssigningShapeMarkerStyleEventArgs();
        };
        Object.defineProperty(IgxAssigningShapeMarkerStyleEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        return IgxAssigningShapeMarkerStyleEventArgs;
    }(IgxAssigningShapeStyleEventArgsBase));

    var IgxStyleShapeEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxStyleShapeEventArgs() {
        }
        Object.defineProperty(IgxStyleShapeEventArgs.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxStyleShapeEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxStyleShapeEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxStyleShapeEventArgs.prototype, "item", {
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStyleShapeEventArgs.prototype, "shapeFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.shapeStyle ? this.i.shapeStyle.fill : null;
            },
            set: function (v) {
                this.ensureShapeStyle();
                this.i.shapeStyle.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStyleShapeEventArgs.prototype, "shapeStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.shapeStyle ? this.i.shapeStyle.stroke : null;
            },
            set: function (v) {
                this.ensureShapeStyle();
                this.i.shapeStyle.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStyleShapeEventArgs.prototype, "shapeStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.shapeStyle ? this.i.shapeStyle.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureShapeStyle();
                this.i.shapeStyle.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStyleShapeEventArgs.prototype, "shapeOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.shapeStyle ? this.i.shapeStyle.opacity : NaN;
            },
            set: function (v) {
                this.ensureShapeStyle();
                this.i.shapeStyle.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxStyleShapeEventArgs.prototype.ensureShapeStyle = function () {
            if (this.i.shapeStyle) {
                return;
            }
            this.i.shapeStyle = new i2.Style();
        };
        return IgxStyleShapeEventArgs;
    }());

    /**
     * Series class for rendering polygons.
    */
    var IgxShapeSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxShapeSeriesBaseComponent, _super);
        function IgxShapeSeriesBaseComponent() {
            var _this = _super.call(this) || this;
            _this._assigningShapeStyle = null;
            _this._assigningShapeMarkerStyle = null;
            _this._styleShape = null;
            return _this;
        }
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "isCustomShapeStyleAllowed", {
            /**
             * Gets or sets whether this Shape series should allow custom style overrides of its individual visuals.
            */
            get: function () {
                return this.i.qj;
            },
            set: function (v) {
                this.i.qj = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "isCustomShapeMarkerStyleAllowed", {
            /**
             * Gets or sets whether this Shape series should allow custom style overrides of its individual marker visuals.
            */
            get: function () {
                return this.i.qi;
            },
            set: function (v) {
                this.i.qi = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "actualItemSearchMode", {
            get: function () {
                return this.i.p3;
            },
            set: function (v) {
                this.i.p3 = i2.ensureEnum(ShapeItemSearchMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "itemSearchMode", {
            /**
             * Gets or sets the mode the series will use to find the closest point to the cursor.
            */
            get: function () {
                return this.i.p5;
            },
            set: function (v) {
                this.i.p5 = i2.ensureEnum(ShapeItemSearchMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "itemSearchThreshold", {
            /**
             * Gets or sets the threshold to use when searching for items using ItemSearchMode.
            */
            get: function () {
                return this.i.q1;
            },
            set: function (v) {
                this.i.q1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "itemSearchPointsThreshold", {
            /**
             * Gets or sets the points threshold to use when searching for items using ItemSearchMode.
            */
            get: function () {
                return this.i.q0;
            },
            set: function (v) {
                this.i.q0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "shapeMemberPath", {
            /**
             * The name of the property on ItemsSource items which, for each shape, contains a list of points to be converted to a polygon.
             * To be consistent with the Shapefile technical description, it is expected that each list of points is defined as an IEnumerable of IEnumerable of Point, or in other words, a list of lists of points.
            */
            get: function () {
                return this.i.rb;
            },
            set: function (v) {
                this.i.rb = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current ScatterBase object.
            */
            get: function () {
                if (this.i.pz == null) {
                    return null;
                }
                if (!this.i.pz.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.pz);
                    if (e) {
                        e._implementation = this.i.pz;
                    }
                    this.i.pz.externalObject = e;
                }
                return this.i.pz.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.pz = null : this.i.pz = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current ScatterBase object.
            */
            get: function () {
                if (this.i.p1 == null) {
                    return null;
                }
                if (!this.i.p1.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.p1);
                    if (e) {
                        e._implementation = this.i.p1;
                    }
                    this.i.p1.externalObject = e;
                }
                return this.i.p1.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.p1 = null : this.i.p1 = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "shapeFilterResolution", {
            /**
             * The resolution at which to filter out shapes in the series.  For example, if the ShapeFilterResolution is set to 3, then elements with a bounding rectangle smaller than 3 X 3 pixels will be filtered out.
             * In the case of ScatterPolylineSeries, the resolution is compared to either dimension, rather than both.  In other words, a polyline will not be filtered if its height or its width exceeds the value of this property.  Whereas with a ShapeSeries, both the height and the width must exceed the value of this property.
            */
            get: function () {
                return this.i.qx;
            },
            set: function (v) {
                this.i.qx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "isShape", {
            /**
             * Gets whether or not this series is a shape series
            */
            get: function () {
                return this.i.d7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        IgxShapeSeriesBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxShapeSeriesBaseComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        IgxShapeSeriesBaseComponent.prototype.getItemValue = function (item, memberPathName) {
            var iv = this.i.hk(item, memberPathName);
            return (iv);
        };
        IgxShapeSeriesBaseComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        IgxShapeSeriesBaseComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxShapeSeriesBaseComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxShapeSeriesBaseComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.qe(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxShapeSeriesBaseComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.qd(axis);
            return (iv);
        };
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "assigningShapeStyle", {
            /**
             * Event raised when Assigning Shape Style. Note, if using this event, or highlighting, its best to avoid use of ShapeStyle/StyleShape/ShapeStyleSelector.
            */
            get: function () {
                var _this = this;
                if (this._assigningShapeStyle == null) {
                    this._assigningShapeStyle = new i0.EventEmitter();
                    this.i.assigningShapeStyle = i2.delegateCombine(this.i.assigningShapeStyle, function (o, e) {
                        var outerArgs = new IgxAssigningShapeStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningShapeStyle) {
                            _this.beforeAssigningShapeStyle(_this, outerArgs);
                        }
                        _this._assigningShapeStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningShapeStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "assigningShapeMarkerStyle", {
            /**
             * Event raised when Assigning Shape Marker Style
            */
            get: function () {
                var _this = this;
                if (this._assigningShapeMarkerStyle == null) {
                    this._assigningShapeMarkerStyle = new i0.EventEmitter();
                    this.i.assigningShapeMarkerStyle = i2.delegateCombine(this.i.assigningShapeMarkerStyle, function (o, e) {
                        var outerArgs = new IgxAssigningShapeMarkerStyleEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeAssigningShapeMarkerStyle) {
                            _this.beforeAssigningShapeMarkerStyle(_this, outerArgs);
                        }
                        _this._assigningShapeMarkerStyle.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._assigningShapeMarkerStyle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxShapeSeriesBaseComponent.prototype, "styleShape", {
            /**
             * Raised when tile's image URI should be provided
            */
            get: function () {
                var _this = this;
                if (this._styleShape == null) {
                    this._styleShape = new i0.EventEmitter();
                    this.i.styleShape = i2.delegateCombine(this.i.styleShape, function (o, e) {
                        var outerArgs = new IgxStyleShapeEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeStyleShape) {
                            _this.beforeStyleShape(_this, outerArgs);
                        }
                        _this._styleShape.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._styleShape;
            },
            enumerable: false,
            configurable: true
        });
        IgxShapeSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxShapeSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxShapeSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxShapeSeriesBaseComponent, selector: "ng-component", inputs: { isCustomShapeStyleAllowed: "isCustomShapeStyleAllowed", isCustomShapeMarkerStyleAllowed: "isCustomShapeMarkerStyleAllowed", actualItemSearchMode: "actualItemSearchMode", itemSearchMode: "itemSearchMode", itemSearchThreshold: "itemSearchThreshold", itemSearchPointsThreshold: "itemSearchPointsThreshold", shapeMemberPath: "shapeMemberPath", xAxis: "xAxis", yAxis: "yAxis", shapeFilterResolution: "shapeFilterResolution" }, outputs: { assigningShapeStyle: "assigningShapeStyle", assigningShapeMarkerStyle: "assigningShapeMarkerStyle", styleShape: "styleShape" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxShapeSeriesBaseComponent;
    }(IgxSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxShapeSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { isCustomShapeStyleAllowed: [{
                    type: i0.Input
                }], isCustomShapeMarkerStyleAllowed: [{
                    type: i0.Input
                }], actualItemSearchMode: [{
                    type: i0.Input
                }], itemSearchMode: [{
                    type: i0.Input
                }], itemSearchThreshold: [{
                    type: i0.Input
                }], itemSearchPointsThreshold: [{
                    type: i0.Input
                }], shapeMemberPath: [{
                    type: i0.Input
                }], xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }], shapeFilterResolution: [{
                    type: i0.Input
                }], assigningShapeStyle: [{
                    type: i0.Output
                }], assigningShapeMarkerStyle: [{
                    type: i0.Output
                }], styleShape: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StyleShapeEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StyleShapeEventArgs, _super);
        function StyleShapeEventArgs(a, b, c) {
            var _this = _super.call(this) || this;
            _this._item = null;
            _this._container = null;
            _this._shapeStyle = null;
            _this.item = a;
            _this.container = b;
            _this.shapeStyle = c;
            return _this;
        }
        Object.defineProperty(StyleShapeEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StyleShapeEventArgs.prototype, "container", {
            get: function () {
                return this._container;
            },
            set: function (a) {
                this._container = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StyleShapeEventArgs.prototype, "shapeStyle", {
            get: function () {
                return this._shapeStyle;
            },
            set: function (a) {
                this._shapeStyle = a;
            },
            enumerable: false,
            configurable: true
        });
        StyleShapeEventArgs.prototype.d = function () {
            return this.shapeStyle;
        };
        StyleShapeEventArgs.$t = i2.markType(StyleShapeEventArgs, 'StyleShapeEventArgs', i2.EventArgs.$);
        return StyleShapeEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ShapeHitRegion = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ShapeHitRegion, _super);
        function ShapeHitRegion() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.a = null;
            _this.b = 0;
            _this.c = null;
            return _this;
        }
        ShapeHitRegion.$t = i2.markType(ShapeHitRegion, 'ShapeHitRegion');
        return ShapeHitRegion;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var FlattenedShape = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FlattenedShape, _super);
        function FlattenedShape() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.c = null;
            return _this;
        }
        FlattenedShape.$t = i2.markType(FlattenedShape, 'FlattenedShape');
        return FlattenedShape;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ShapeSeriesBase, _super);
        function ShapeSeriesBase() {
            var _this = _super.call(this) || this;
            _this.qb = false;
            _this.qa = false;
            _this.pw = null;
            _this.px = null;
            _this.p2 = 1;
            _this.pm = null;
            _this.pn = null;
            _this.assigningShapeStyle = null;
            _this.assigningShapeMarkerStyle = null;
            _this.p6 = null;
            _this.p8 = null;
            _this.py = null;
            _this.p0 = null;
            _this.qv = 0;
            _this.qr = null;
            _this.pj = null;
            _this.pl = null;
            _this.pk = null;
            _this.pi = null;
            _this.r2 = null;
            _this.qy = 0;
            _this.styleShape = null;
            _this.p6 = new ShapeSeriesRenderManager();
            i2.FastItemObjectColumn.m();
            _this.qy = _this.qx;
            _this.r2 = i2.Rect.empty;
            return _this;
        }
        ShapeSeriesBase.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.pz = null;
            this.p1 = null;
        };
        ShapeSeriesBase.prototype.ag = function () {
            return [this.pz, this.p1];
        };
        ShapeSeriesBase.prototype.hk = function (a, b) {
            var c = this.ja(b);
            if (c == ShapeSeriesBase.$$p[6]) {
                return this.hl(a, b, this.rb);
            }
            return null;
        };
        ShapeSeriesBase.prototype.get_dr = function () {
            return true;
        };
        ShapeSeriesBase.prototype.get_cy = function () {
            return true;
        };
        ShapeSeriesBase.prototype.pu = function (a, b, c) {
            var d = this.ox(b);
            var e = this.p7.cz(d, false);
            var f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ch.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else if (e.dataContext != null) {
                f = e.dataContext.c;
            }
            if (f == -1) {
                return null;
            }
            var g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        };
        ShapeSeriesBase.prototype.pv = function (a, b, c) {
            var d = this.p7.b1(this.ox(b));
            var e = -1;
            if (d == null) {
                if (a != null) {
                    e = this.ch.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                e = d.ak;
            }
            if (e == -1) {
                return null;
            }
            var f = new HighlightingInfo();
            f.b = this;
            f.h = e;
            f.g = e;
            f.d = false;
            f.e = true;
            if (c != null && c.h == f.h && c.g == f.g) {
                return c;
            }
            return f;
        };
        Object.defineProperty(ShapeSeriesBase.prototype, "p3", {
            get: function () {
                return this.p2;
            },
            set: function (a) {
                var b = this.p2;
                this.p2 = a;
                if (b != this.p2) {
                    this.raisePropertyChanged("ActualItemSearchMode", i2.enumGetBox(ShapeItemSearchMode_$type, b), i2.enumGetBox(ShapeItemSearchMode_$type, this.p2));
                }
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesBase.prototype.p4 = function () {
            if (this.p5 != 0) {
                return this.p5;
            }
            return 1;
        };
        ShapeSeriesBase.prototype.fw = function (a) {
            switch (this.p3) {
                case 1: return this.rh(a).c;
                case 2: return this.qw(a);
                case 3: return this.qw(a);
            }
            return -1;
        };
        ShapeSeriesBase.prototype.rh = function (a) {
            var b = this.ox(a);
            var c = { $type: i2.Point_$type, x: NaN, y: NaN };
            var d = this.p7.cb;
            if (d == null) {
                return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, -1, c);
            }
            var e = this.p7.b2(b, false, !this.qc);
            if (e != null) {
                c = i2.RectUtil.l(e.d);
                return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, e.b, c);
            }
            var f = b.x;
            var g = b.y;
            if (this.ch == null || this.pz == null || this.p1 == null || this.qr == null) {
                return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, -1, c);
            }
            if (this.ch.count > this.q1) {
                return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, -1, c);
            }
            var h = 1.7976931348623157E+308;
            var i = -1;
            for (var j = 0; j < d.count; j++) {
                var k = d._inner[j].d;
                var l = i2.RectUtil.g(k, b);
                if (l < h) {
                    h = l;
                    i = d._inner[j].b;
                    c = i2.RectUtil.l(d._inner[j].d);
                }
            }
            return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, i, c);
        };
        ShapeSeriesBase.prototype.rg = function (a) {
            var b = this.ox(a);
            var c = b.x;
            var d = b.y;
            var e = { $type: i2.Point_$type, x: NaN, y: NaN };
            if (this.ch == null || this.pz == null || this.p1 == null || this.qr == null) {
                return new i2.Tuple$3(i2.Number_$type, i2.Point_$type, i2.Point_$type, -1, e, e);
            }
            if (this.ch.count > this.q1) {
                return new i2.Tuple$3(i2.Number_$type, i2.Point_$type, i2.Point_$type, -1, e, e);
            }
            var f = 1.7976931348623157E+308;
            var g = this.p7.cb;
            if (g == null) {
                return new i2.Tuple$3(i2.Number_$type, i2.Point_$type, i2.Point_$type, -1, e, e);
            }
            var h = this.p7.b2(b, false, !this.qc);
            if (h != null) {
                var i = i2.RectUtil.l(h.d);
                var j = this.rf(b, h.a, this.qc);
                return new i2.Tuple$3(i2.Number_$type, i2.Point_$type, i2.Point_$type, h.b, j.d, i);
            }
            for (var k = 0; k < g.count; k++) {
                var l = g._inner[k].d;
                var m = i2.RectUtil.g(l, b);
                var n = (l.width * l.width) + (l.height * l.height) + m;
                if (n <= f) {
                    f = n;
                }
            }
            var o = 1.7976931348623157E+308;
            var p = -1;
            for (var q = 0; q < g.count; q++) {
                var r = g._inner[q].d;
                var s = i2.RectUtil.g(r, b);
                if (s < f) {
                    var t = this.rf(b, g._inner[q].a, this.qc);
                    if (t.c < o) {
                        o = t.c;
                        e = t.d;
                        p = q;
                    }
                }
            }
            if (p >= 0) {
                return new i2.Tuple$3(i2.Number_$type, i2.Point_$type, i2.Point_$type, g._inner[p].b, e, i2.RectUtil.l(g._inner[p].d));
            }
            return new i2.Tuple$3(i2.Number_$type, i2.Point_$type, i2.Point_$type, -1, e, e);
        };
        ShapeSeriesBase.prototype.get_qc = function () {
            return true;
        };
        Object.defineProperty(ShapeSeriesBase.prototype, "qc", {
            get: function () {
                return this.get_qc();
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesBase.prototype.rf = function (a, b, c) {
            var d = { $type: i2.Point_$type, x: NaN, y: NaN };
            var e = 1.7976931348623157E+308;
            var f = { $type: i2.Point_$type, x: NaN, y: NaN };
            var g = false;
            var h = -1;
            for (var i = 0; i < b.count; i++) {
                var j = b._inner[i];
                if (i >= 1) {
                    var k = i2.GeometryUtil.d(a, d, j);
                    if (k < e) {
                        e = k;
                        g = true;
                        h = i;
                    }
                }
                d = j;
            }
            if (c) {
                var l = b._inner[0];
                var m = i2.GeometryUtil.d(a, d, l);
                if (m < e) {
                    e = m;
                    var n = i2.GeometryUtil.h(a, d, l);
                    f = { $type: i2.Point_$type, x: d.x + (l.x - d.x) * n, y: d.y + (l.y - d.y) * n };
                    return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, e, f);
                }
            }
            if (g) {
                var o = b._inner[h - 1];
                var p = b._inner[h];
                var q = i2.GeometryUtil.h(a, o, p);
                f = { $type: i2.Point_$type, x: o.x + (p.x - o.x) * q, y: o.y + (p.y - o.y) * q };
            }
            return new i2.Tuple$2(i2.Number_$type, i2.Point_$type, e, f);
        };
        ShapeSeriesBase.prototype.qw = function (a) {
            return this.rg(a).c;
        };
        ShapeSeriesBase.prototype.o2 = function (a, b, c) {
            if (this.pz == null || this.p1 == null || this.qr == null) {
                return { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            switch (this.p3) {
                case 1:
                    var d = this.rh(a);
                    return d.d;
                case 2:
                    var e = this.rg(a);
                    return e.e;
                case 3:
                    var f = this.rg(a);
                    return f.d;
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        ShapeSeriesBase.prototype.hh = function (a) {
            var b = this.g0(a);
            if (this.ch != null && b >= 0 && b < this.ch.count) {
                return this.ch.item(b);
            }
            return null;
        };
        ShapeSeriesBase.prototype.pt = function (a, b, c) {
            var d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ch.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        };
        ShapeSeriesBase.prototype.av = function (a, b, c) {
            if (this.cy && this.d9(this.bj) && !c) {
                var d = this.pu(a, b, this.pw);
                this.pw = d;
                return d;
            }
            else {
                var e = this.pt(a, b, this.pw);
                this.pw = e;
                return e;
            }
        };
        ShapeSeriesBase.prototype.aw = function (a, b, c) {
            if (this.d9(this.bj) && !c) {
                var d = this.pv(a, b, this.px);
                this.px = d;
                return d;
            }
            else {
                var e = this.pt(a, b, this.px);
                e.e = true;
                this.px = e;
                return e;
            }
        };
        ShapeSeriesBase.prototype.qp = function () {
            return (this.assigningShapeStyle != null && this.qb) || (this.bj != 1);
        };
        ShapeSeriesBase.prototype.qo = function () {
            return (this.assigningShapeMarkerStyle != null && this.qa) || (this.bj != 1);
        };
        Object.defineProperty(ShapeSeriesBase.prototype, "p9", {
            get: function () {
                return this.p8;
            },
            set: function (a) {
                var b = this.p9 != a;
                if (b) {
                    var c = this.p9;
                    this.p8 = a;
                    this.raisePropertyChanged("ShapeColumn", c, this.p9);
                }
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesBase.prototype.qg = function (array_) {
            var a = (Array.isArray(array_));
            return a;
        };
        ShapeSeriesBase.qk = function (a) {
            if (a == null) {
                return true;
            }
            var val_ = a;
            return (val_ == undefined);
        };
        ShapeSeriesBase.prototype.convertToListList = function (a) {
            if (a == null) {
                return null;
            }
            var b = new i2.List$1(i2.List$1.$.specialize(i2.Point_$type), 0);
            var c;
            var curr_;
            var d;
            var e;
            var f = false;
            var g = false;
            for (var h = 0; h < a.length; h++) {
                c = a[h];
                if (c == null) {
                    continue;
                }
                var i = new i2.List$1(i2.Point_$type, 0);
                for (var j = 0; j < c.length; j++) {
                    curr_ = c[j];
                    if (f) {
                        d = (curr_.X);
                        e = (curr_.Y);
                    }
                    else {
                        d = (curr_.x);
                        e = (curr_.y);
                    }
                    if (!g) {
                        if ((i2.isNaN_(d) || ShapeSeriesBase.qk(d)) && (i2.isNaN_(e) || ShapeSeriesBase.qk(e))) {
                            d = (curr_.X);
                            e = (curr_.Y);
                            if (!i2.isNaN_(d) && !ShapeSeriesBase.qk(d) && !i2.isNaN_(e) && !ShapeSeriesBase.qk(e)) {
                                g = true;
                                f = true;
                            }
                        }
                        else {
                            g = true;
                        }
                    }
                    i.add({ $type: i2.Point_$type, x: d, y: e });
                }
                b.add(i);
            }
            return b;
        };
        ShapeSeriesBase.prototype.cg = function (a) {
            if (this.ch != null && this.qg(this.itemsSource) && a != null && a.split('!').length != 2) {
                if (this.coercionMethods == null) {
                    this.coercionMethods = {};
                }
                var methods_ = this.coercionMethods;
                methods_.convertToListList = this.convertToListList;
                a += "!convertToListList";
            }
            return _super.prototype.cg.call(this, a);
        };
        ShapeSeriesBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            var e = false;
            var f = false;
            switch (b) {
                case ShapeSeriesBase.$$p[2]:
                    this.p3 = this.p4();
                    break;
                case "FastItemsSource":
                    var g = i2.typeCast(i2.IFastItemsSource_$type, c);
                    if (g != null) {
                        g.deregisterColumn(this.p9);
                        this.p9 = null;
                    }
                    var h = i2.typeCast(i2.IFastItemsSource_$type, d);
                    if (h != null) {
                        this.p9 = this.cg(this.rb);
                    }
                    e = this.pz != null && !this.pz.cv();
                    f = this.p1 != null && !this.p1.cv();
                    if (e || f) {
                        this.l0(false);
                    }
                    break;
                case ShapeSeriesBase.$$p[6]:
                    if (this.ch != null) {
                        this.ch.deregisterColumn(this.p9);
                        this.p9 = this.cg(this.rb);
                    }
                    break;
                case "ShapeColumn":
                    this.rq();
                    e = this.pz != null && !this.pz.cv();
                    f = this.p1 != null && !this.p1.cv();
                    if (e || f) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case ShapeSeriesBase.$$p[7]:
                case ShapeSeriesBase.$$p[8]:
                    this.py = this.pz;
                    this.p0 = this.p1;
                    var i = c;
                    var j = d;
                    this.rr(i);
                    this.rj(j);
                    if ((j != null && !j.cv()) || (j == null && i != null)) {
                        this.l0(false);
                    }
                    this.k7();
                    break;
                case "Resolution":
                    this.qv = this.gh;
                    this.k7();
                    break;
                case "ActualBrush":
                    this.l0(false);
                    break;
                case ShapeSeriesBase.$$p[5]:
                    this.qy = this.qx;
                    this.l0(false);
                    this.k7();
                    break;
                case "ActualThickness":
                    this.l0(false);
                    this.k7();
                    break;
                case ShapeSeriesBase.$$p[1]:
                    this.qb = this.qn();
                    this.l0(false);
                    break;
                case ShapeSeriesBase.$$p[0]:
                    this.qa = this.qm();
                    this.l0(false);
                    break;
            }
        };
        ShapeSeriesBase.prototype.qn = function () {
            return this.qj;
        };
        ShapeSeriesBase.prototype.qm = function () {
            return this.qi;
        };
        ShapeSeriesBase.prototype.qe = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        ShapeSeriesBase.prototype.qd = function (a) {
            if (i2.typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        ShapeSeriesBase.prototype.rq = function () {
            this.qr = null;
            if (this.p9 == null) {
                return;
            }
            this.qr = new i2.List$1(i2.Rect.$, 2, this.p9.count);
            for (var a = 0; a < this.p9.count; a++) {
                this.qr.add(i2.PointCollectionUtil.j(this.p9.item(a)));
            }
        };
        ShapeSeriesBase.prototype.r3 = function (a) {
            if (i2.typeCast(i2.IEnumerable$1_$type.specialize(i2.IEnumerable$1_$type.specialize(i2.Point_$type)), a) !== null) {
                return i2.PointCollectionUtil.h(a);
            }
            else if (i2.typeCast(i2.IEnumerable$1_$type.specialize(i2.Point_$type), a) !== null) {
                return i2.PointCollectionUtil.g(a);
            }
            return i2.Rect.empty;
        };
        ShapeSeriesBase.prototype.qt = function (a, b, c, d, e, f, g) {
            var e_1, _a;
            return this.qu(a, b, c, d, e, f, g);
            if (i2.typeCast(i2.List$1.$.specialize(i2.List$1.$.specialize(i2.Point_$type)), c) !== null) {
                return this.qu(a, b, c, d, e, f, g);
            }
            else if (i2.typeCast(i2.IEnumerable$1_$type.specialize(i2.IEnumerable$1_$type.specialize(i2.Point_$type)), c) !== null) {
                var h = c;
                var i = new i2.List$1(FlattenedShape.$, 0);
                var j = null;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var k = _c.value;
                        j = this.ps(a, b, i2.PointCollectionUtil.b(k), d, e, f, g);
                        if (j == null) {
                            continue;
                        }
                        i.add(j);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                return i;
            }
            else if (i2.typeCast(i2.IEnumerable$1_$type.specialize(i2.Point_$type), c) !== null) {
                var l = c;
                var m = this.ps(a, b, i2.PointCollectionUtil.b(l), d, e, f, g);
                var n = new i2.List$1(FlattenedShape.$, 0);
                if (m != null) {
                    n.add(m);
                }
                return n;
            }
            else {
                throw new i2.InvalidOperationException(1, "Unrecognized data in ShapeColumn");
            }
        };
        ShapeSeriesBase.prototype.get_qh = function () {
            return true;
        };
        Object.defineProperty(ShapeSeriesBase.prototype, "qh", {
            get: function () {
                return this.get_qh();
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesBase.prototype.qq = function () {
            return false;
        };
        ShapeSeriesBase.prototype.l1 = function (a) {
            this.rp(this.bx);
        };
        ShapeSeriesBase.prototype.lz = function (a, b, c, d, e) {
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            f.a1(c);
            if (this.ct(f)) {
                return;
            }
            this.rp(f);
        };
        ShapeSeriesBase.prototype.rp = function (a) {
            var _this = this;
            if (this.ct(a)) {
                return;
            }
            var b;
            var c;
            var d = a;
            var e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            if (c.width < 1 || c.height < 1 || this.p9 == null) {
                return;
            }
            var f = this.pz;
            var g = this.p1;
            var h = this.getEffectiveViewport1(a);
            var i = new ScalerParams(1, b, c, f.cc);
            i.c = h;
            var j = new ScalerParams(1, b, c, g.cc);
            j.c = h;
            if (!this.em) {
                d.cr();
                var k = new i2.Rect(0, 0, 0, 0, 0);
                var l = void 0;
                var m = void 0;
                var n = void 0;
                var o = void 0;
                var p = this.p9.count;
                if (this.pl == null || this.pl.length != p) {
                    this.pl = new Array(p);
                    this.pj = new Array(p);
                    this.pk = new Array(p);
                    this.pi = new Array(p);
                }
                var q = this.pl;
                var r = this.pj;
                var s = this.pk;
                var t = this.pi;
                var u = void 0;
                for (var v = 0; v < p; v++) {
                    u = this.qr._inner[v];
                    q[v] = u.top;
                    r[v] = u.left;
                    s[v] = u.right;
                    t[v] = u.bottom;
                }
                this.py.g5(i2.boxArray$1(r), 0, r.length, i);
                this.py.g5(i2.boxArray$1(s), 0, s.length, i);
                this.p0.g5(i2.boxArray$1(q), 0, q.length, j);
                this.p0.g5(i2.boxArray$1(t), 0, t.length, j);
                d.cs(r, q, s, t);
                var w = this.p9;
                var x = this.ch;
                this.rs(d);
                var y = c.left;
                var z = c.right;
                var aa = c.top;
                var ab = c.bottom;
                var ac = null;
                if (this.r2.isEmpty) {
                    ac = null;
                }
                else {
                    ac = new i2.Clipper(1, this.r2.left, this.r2.bottom, this.r2.right, this.r2.top, this.qh);
                }
                var ad = this.qq();
                if (ad) {
                    d.b9.clear();
                }
                var ae = false;
                var af = true;
                var ag = 0;
                if (this.ca != null) {
                    if (this.ca.ei()) {
                        var ah = this.ca.i1(b, i);
                        ae = ah.c;
                        ag = ah.d;
                    }
                }
                var ai = void 0;
                for (var aj = 0; aj < p; aj++) {
                    n = r[aj];
                    l = q[aj];
                    m = t[aj];
                    o = s[aj];
                    k.x = Math.min(n, o);
                    k.y = Math.min(l, m);
                    k.width = Math.max(n, o) - k.x;
                    k.height = Math.max(l, m) - k.y;
                    if (k.intersectsWith(c)) {
                        if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                            ai = ac;
                        }
                        else {
                            ai = null;
                        }
                        var ak = this.qt(a, ai, w.item(aj), i, j, 0, ag);
                        if (ad) {
                            ShapeSeriesBase.ro(d, aj, ak);
                        }
                        d.cf(aj, x.item(aj), k, ak);
                    }
                    else if (ae) {
                        k.x = k.x + ag;
                        if (k.intersectsWith(c)) {
                            if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                                ai = ac;
                            }
                            else {
                                ai = null;
                            }
                            var al = this.qt(a, ai, w.item(aj), i, j, ag, ag);
                            if (ad) {
                                ShapeSeriesBase.ro(d, aj, al);
                            }
                            d.cf(aj, x.item(aj), k, al);
                        }
                    }
                }
                d.cq();
            }
            var am = this.qp();
            this.p6.ax(this, this.qp(), i2.runOn(this, this.po));
            var an = false;
            var ao = this.p6.b;
            if (ao != null) {
                an = true;
            }
            var ap = a.q;
            var aq = this.d8;
            var ar = d.b7;
            d.cm(function (as) {
                var at = as.dataContext != null ? as.dataContext.item : null;
                var au = as.dataContext != null ? as.dataContext.c : -1;
                d.cj(as, at, am);
                if (an) {
                    _this.rl(as, aq, au, _this.p9.count, ap, ar);
                }
                else {
                    if (ar) {
                        {
                            _this.p6.az(as, _this.fj, ar);
                        }
                    }
                }
                {
                    _this.p6.ad(as, false, false, false, false);
                }
            });
        };
        ShapeSeriesBase.prototype.rl = function (a, b, c, d, e, f) {
            var g = this.bj != 1;
            this.p6.ay(this.p6.b, c, d, false);
            {
                this.p6.az(a, this.fj, f);
            }
            var h = this.p6.av;
            var i = null;
            var j = this.ch;
            if (g && this.ca != null) {
                i = this.ca.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = e;
            this.rn(h);
            this.p6.z(this, i, e, g, false);
        };
        ShapeSeriesBase.prototype.rk = function (a, b, c) {
            var d = this.bj != 1;
            this.p6.ay(this.p6.d, a, b, true);
            this.p6.aa(this.fj);
            var e = this.p6.au;
            var f = null;
            var g = this.ch;
            var h = null;
            if (d && this.ca != null) {
                f = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.ca.a3.isCrossSeriesHighlight(this)) {
                    h = this.ca.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.rm(e);
            this.p6.y(this, f, c, d, e.l, this.ca.a3.sumHighlightingProgress);
        };
        ShapeSeriesBase.prototype.rn = function (a) {
            if (this.assigningShapeStyle != null && this.qb) {
                this.assigningShapeStyle(this, a);
            }
        };
        ShapeSeriesBase.prototype.rm = function (a) {
            if (this.assigningShapeMarkerStyle != null && this.qa) {
                this.assigningShapeMarkerStyle(this, a);
            }
        };
        ShapeSeriesBase.prototype.po = function (a, b) {
            return this.pp(a, b);
        };
        ShapeSeriesBase.prototype.pp = function (a, b) {
            if (b < a || a < 0 || a > this.p9.count || b < 0 || b > this.p9.count) {
                return null;
            }
            var c = new Array((b - a) + 1);
            for (var d = a; d <= b; d++) {
                var e = d;
                c[d - a] = this.ch.item(d);
            }
            return c;
        };
        ShapeSeriesBase.ro = function (a, b, c) {
            var d = 0;
            var e = null;
            for (var f = 0; f < c.count; f++) {
                var g = c._inner[f];
                var h = g.b.width * g.b.height;
                if (h > d) {
                    d = h;
                    e = g;
                }
            }
            a.b9.addItem(b, e);
        };
        ShapeSeriesBase.prototype.ky = function () {
            _super.prototype.ky.call(this);
            if (this.pz != null) {
                this.pz.hp();
            }
            if (this.p1 != null) {
                this.p1.hp();
            }
        };
        ShapeSeriesBase.prototype.mn = function (a, b) {
            this.l0(false);
        };
        ShapeSeriesBase.prototype.mm = function (a, b) {
            this.l0(false);
        };
        ShapeSeriesBase.prototype.kk = function (a, b, c, d) {
            _super.prototype.kk.call(this, a, b, c, d);
            switch (a) {
                case 3:
                    if (d == this.rb) {
                        this.qr._inner[b] = this.r3(this.p9.item(b));
                    }
                    break;
                case 1:
                    for (var e = b; e < b + c; e++) {
                        this.qr.insert(e, this.r3(this.p9.item(e)));
                    }
                    break;
                case 0:
                    this.qr.v(b, c);
                    break;
                case 2:
                    for (var f = b; f < b + c; f++) {
                        this.qr._inner[f] = this.r3(this.p9.item(f));
                    }
                    break;
                case 4:
                    this.rq();
                    break;
            }
            this.l0(false);
        };
        ShapeSeriesBase.prototype.e3 = function (a, b, c) {
            var d = true;
            if (!_super.prototype.e3.call(this, a, b, c) || (this.ql && this.p9 == null) || b.isEmpty || a.isEmpty || this.pz == null || this.p1 == null || this.pz.bh == null || this.p1.bh == null || this.pz.kv == this.pz.ku || this.p1.kv == this.p1.ku || this.p9 == null || this.p9.count == 0 || this.qr == null || this.qr.count == 0 || this.qr.count != this.p9.count) {
                d = false;
            }
            return d;
        };
        ShapeSeriesBase.prototype.get_ql = function () {
            return true;
        };
        Object.defineProperty(ShapeSeriesBase.prototype, "ql", {
            get: function () {
                return this.get_ql();
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.p7 = i2.typeCast(ShapeSeriesViewBase.$, a);
        };
        ShapeSeriesBase.prototype.qu = function (a, b, c, d, e, f, g) {
            var h = new i2.List$1(FlattenedShape.$, 0);
            var i;
            var j = c.count;
            for (var k = 0; k < j; k++) {
                i = c._inner[k];
                var l = this.ps(a, b, i, d, e, f, g);
                if (l == null) {
                    continue;
                }
                h.add(l);
            }
            return h;
        };
        ShapeSeriesBase.prototype.ps = function (a, b, c, d, e, f, g) {
            var h = this.ri(c, d, e);
            var i = h.c;
            var j = h.d;
            var k = i.length;
            var l = 1.7976931348623157E+308;
            var m = 1.7976931348623157E+308;
            var n = -1.7976931348623157E+308;
            var o = -1.7976931348623157E+308;
            var p;
            var q;
            if (f != 0) {
                for (var r = 0; r < k; r++) {
                    i[r] = i[r] + f;
                }
            }
            for (var s = 0; s < k; s++) {
                p = i[s];
                q = j[s];
                l = p < l ? p : l;
                m = q < m ? q : m;
                n = p > n ? p : n;
                o = q > o ? q : o;
            }
            var t = !(l > this.r2.right || n < this.r2.left || m > this.r2.bottom || o < this.r2.top);
            if (!t && f == 0 && g != 0) {
                if (g != 0) {
                    for (var u = 0; u < k; u++) {
                        i[u] = i[u] + g;
                    }
                }
                for (var v = 0; v < k; v++) {
                    p = i[v];
                    q = j[v];
                    l = p < l ? p : l;
                    m = q < m ? q : m;
                    n = p > n ? p : n;
                    o = q > o ? q : o;
                }
                t = !(l > this.r2.right || n < this.r2.left || m > this.r2.bottom || o < this.r2.top);
            }
            if (!t) {
                return null;
            }
            var w = b != null && (l < this.r2.left || m < this.r2.top || n > this.r2.right || o > this.r2.bottom);
            var x = new i2.Rect(0, l, m, n - l, o - m);
            if (!a.b8(x)) {
                return null;
            }
            l = l < this.r2.left ? this.r2.left : l;
            n = n > this.r2.right ? this.r2.right : n;
            m = m < this.r2.top ? this.r2.top : m;
            o = o > this.r2.bottom ? this.r2.bottom : o;
            var y = i2.PolySimplification.b(h, this.gh);
            var z = new DefaultFlattener().c(h.c, h.d, y, this.qv);
            var aa = z.count;
            if (w) {
                var ab = new i2.List$1(i2.Point_$type, 0);
                b.i = ab;
                for (var ac = 0; ac < aa; ac++) {
                    b.j(z._inner[ac]);
                }
                b.i = null;
                z = ab;
            }
            if (z == null || z.count == 0) {
                return null;
            }
            var ad = new FlattenedShape();
            ad.a = z;
            ad.b = new i2.Rect(0, l, m, n - l, o - m);
            ad.c = x;
            return ad;
        };
        ShapeSeriesBase.prototype.ri = function (a, b, c) {
            var d = this.py;
            var e = this.p0;
            var f = a.count;
            var g = new Array(f);
            var h = new Array(f);
            for (var i = 0; i < f; i++) {
                g[i] = a._inner[i].x;
                h[i] = a._inner[i].y;
            }
            d.g5(i2.boxArray$1(g), 0, g.length, b);
            e.g5(i2.boxArray$1(h), 0, h.length, c);
            return new i2.Tuple$2(i2.Array_$type, i2.Array_$type, g, h);
        };
        ShapeSeriesBase.prototype.rs = function (a) {
            a.cx();
        };
        ShapeSeriesBase.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.ck();
        };
        ShapeSeriesBase.prototype.rj = function (a) {
            if (a != null) {
                a.cn(this);
            }
        };
        ShapeSeriesBase.prototype.rr = function (a) {
            if (a != null) {
                a.bx(this);
            }
        };
        ShapeSeriesBase.prototype.at = function (a, b) {
            var c = this.p7.cz(a, b);
            var d = null;
            if (c != null) {
                d = c.dataContext;
            }
            if (d != null) {
                return d;
            }
            return _super.prototype.at.call(this, a, b);
        };
        ShapeSeriesBase.prototype.q2 = function (a) {
            return this.ch.item(a);
        };
        ShapeSeriesBase.prototype.get_ex = function () {
            return true;
        };
        ShapeSeriesBase.prototype.set_ex = function (a) {
            _super.prototype.set_ex.call(this, a);
        };
        ShapeSeriesBase.prototype.ap = function (a) {
            var e_2, _a, e_3, _b;
            if (i2.typeCast(NumericXAxis.$, a) !== null && this.qr != null) {
                var b = 1.7976931348623157E+308;
                var c = -1.7976931348623157E+308;
                try {
                    for (var _c = tslib.__values(i2.fromEnum(this.qr)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var d = _d.value;
                        b = Math.min(b, d.left);
                        c = Math.max(c, d.right);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                return new AxisRange(b, c);
            }
            if (i2.typeCast(NumericYAxis.$, a) !== null && this.qr != null) {
                var e = 1.7976931348623157E+308;
                var f = -1.7976931348623157E+308;
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.qr)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var g = _f.value;
                        e = Math.min(e, g.top);
                        f = Math.max(f, g.bottom);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                return new AxisRange(e, f);
            }
            return null;
        };
        ShapeSeriesBase.prototype.get_d7 = function () {
            return true;
        };
        ShapeSeriesBase.prototype.get_dw = function () {
            return true;
        };
        Object.defineProperty(ShapeSeriesBase.prototype, "qf", {
            get: function () {
                return this.styleShape != null;
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesBase.prototype.r4 = function (a, b, c) {
            if (this.styleShape != null) {
                if (this.p7.c6 != null && c == this.p7.c6) {
                    c = new i2.Style();
                    var d = this.p7.c6;
                    c.fill = d.fill;
                    c.opacity = d.opacity;
                    c.stroke = d.stroke;
                    c.strokeThickness = d.strokeThickness;
                }
                else {
                    if (c != null) {
                        var e = new i2.Style();
                        e.fill = c.fill;
                        e.opacity = c.opacity;
                        e.stroke = c.stroke;
                        e.strokeThickness = c.strokeThickness;
                        c = e;
                    }
                    else {
                        c = new i2.Style();
                    }
                }
                var f = new StyleShapeEventArgs(a, b, c);
                this.styleShape(this, f);
                return f.d();
            }
            return c;
        };
        ShapeSeriesBase.$t = i2.markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$);
        ShapeSeriesBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['IsCustomShapeMarkerStyleAllowed:qi:rt', [0, false], 'IsCustomShapeStyleAllowed:qj:ru', [0, false], 'ItemSearchMode:p5:rv', [ShapeItemSearchMode_$type, i2.enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:q0:rw', [1, 10000], 'ItemSearchThreshold:q1:rx', [1, 10000], 'ShapeFilterResolution:qx:ry', [1, 2], 'ShapeMemberPath:rb:rz', [2, null], 'XAxis:pz:r0', [NumericXAxis.$, null], 'YAxis:p1:r1', [NumericYAxis.$, null]]);
        return ShapeSeriesBase;
    }(Series));
    /**
     * @hidden
     */
    var ShapeSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ShapeSeriesRenderManager, _super);
        function ShapeSeriesRenderManager() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.au = null;
            _this.av = null;
            return _this;
        }
        ShapeSeriesRenderManager.prototype.c = function () {
            this.au = new AssigningShapeMarkerStyleEventArgs();
            return this.au;
        };
        ShapeSeriesRenderManager.prototype.a = function () {
            this.av = new AssigningShapeStyleEventArgs();
            return this.av;
        };
        ShapeSeriesRenderManager.prototype.az = function (a, b, c) {
            this.ag = this.ak;
            this.ah = this.al;
            this.m = this.t;
            this.am = this.an;
            this.ao = this.ar;
            this.k = this.r;
            this.l = this.s;
            this.j = this.q;
            if (c) {
                if (a._fill != null) {
                    this.ag = a._fill;
                }
                if (a._stroke != null) {
                    this.ah = a._stroke;
                }
                if (!i2.isNaN_(a.ac) && (a.y == null || !i2.isNaN_(a.y.strokeThickness))) {
                    this.m = a.ac;
                }
            }
            var d = this.b;
            if (d != null) {
                d.p = this.ag;
                d.q = this.ah;
                d.t = this.m;
                d.u = this.am;
                d.v = this.ao;
                d.r = this.k;
                d.s = this.l;
                d.k = this.j;
                d.e = this.f;
                d.i = b;
                d.d = false;
            }
        };
        ShapeSeriesRenderManager.prototype.aw = function (a, b, c) {
            this.w(a, b, c);
        };
        ShapeSeriesRenderManager.prototype.ax = function (a, b, c) {
            this.x(a, b, c);
        };
        ShapeSeriesRenderManager.prototype.ay = function (a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        };
        ShapeSeriesRenderManager.$t = i2.markType(ShapeSeriesRenderManager, 'ShapeSeriesRenderManager', SeriesRenderManager.$);
        return ShapeSeriesRenderManager;
    }(SeriesRenderManager));
    /**
     * @hidden
     */
    var ShapeSeriesViewBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ShapeSeriesViewBase, _super);
        function ShapeSeriesViewBase(a) {
            var _this = _super.call(this, a) || this;
            _this.b9 = null;
            _this.b3 = null;
            _this.ca = new i2.List$1(ShapeHitRegion.$, 0);
            _this.ce = 0;
            _this.cd = null;
            _this.b6 = null;
            _this.c4 = new i2.Path();
            _this.b4 = null;
            _this.c5 = null;
            _this.by = null;
            _this.b0 = null;
            _this.bz = null;
            _this.bx = null;
            _this.b3 = a;
            _this.b6 = _this.b5();
            _this.cd = new i2.List$1(i2.Path.$, 0);
            _this.b9 = new i2.Dictionary$2(i2.Number_$type, FlattenedShape.$, 0);
            return _this;
        }
        ShapeSeriesViewBase.prototype.b1 = function (a) {
            return null;
        };
        Object.defineProperty(ShapeSeriesViewBase.prototype, "cb", {
            get: function () {
                return this.ca;
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesViewBase.prototype.b5 = function () {
            var _this = this;
            return ((function () {
                var $ret = new i2.Pool$1(i2.FrameworkElement.$);
                $ret.create = i2.runOn(_this, _this.cy);
                $ret.activate = i2.runOn(_this, _this.cn);
                $ret.disactivate = i2.runOn(_this, _this.co);
                $ret.destroy = i2.runOn(_this, _this.cp);
                return $ret;
            })());
        };
        ShapeSeriesViewBase.prototype.b8 = function (a) {
            return a.width >= this.b3.qy && a.height >= this.b3.qy;
        };
        ShapeSeriesViewBase.cc = function (a) {
            var b = new i2.List$1(i2.PointCollection.$, 0);
            var c;
            var d = a.count;
            for (var e = 0; e < d; e++) {
                c = a._inner[e];
                var f = new i2.PointCollection(1, c.a);
                b.add(f);
            }
            return b;
        };
        Object.defineProperty(ShapeSeriesViewBase.prototype, "b7", {
            get: function () {
                return this.c5 != null || this.b4 != null || this.b3.qf;
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesViewBase.prototype.cf = function (a, b, c, d) {
            if (d != null && d.count > 0) {
                var e = ShapeSeriesViewBase.cc(d);
                c.intersect(this.bu);
                if (!this.b8(c)) {
                }
                else {
                    var f = this.c2(a, e);
                    if (f != null) {
                        var g = this.c1(this.ce, b);
                        for (var h = 0; h < d.count; h++) {
                            var i = new ShapeHitRegion();
                            i.d = d._inner[h].b;
                            i.a = d._inner[h].a;
                            i.b = a;
                            i.c = g;
                            this.ca.add(i);
                        }
                        this.ch(g, f);
                        this.ce = this.ce + 1;
                    }
                }
            }
        };
        ShapeSeriesViewBase.prototype.c1 = function (a, b) {
            var c = this.b6.item(this.ce);
            if (c.dataContext != null) {
                c.dataContext.item = b;
                c.dataContext.c = a;
            }
            return c;
        };
        ShapeSeriesViewBase.ci = function (a, b, c) {
            if (b._fill == null) {
                b._fill = a.e.of;
            }
            if (b._stroke == null) {
                b._stroke = a.e.oi;
            }
            if (b.y == null) {
                b.ac = a.e.fl;
            }
        };
        ShapeSeriesViewBase.prototype.cm = function (a) {
            for (var b = 0; b < this.b6.a.count; b++) {
                var c = this.b6.a._inner[b];
                a(c);
            }
        };
        ShapeSeriesViewBase.prototype.cj = function (a, b, c) {
            if (a == null) {
                return;
            }
            this.cl(a, c);
            var d = false;
            if (this.b4 != null) {
                var e = this.b4.selectStyle(b, a);
                if (e != null) {
                    d = true;
                }
                if (a.y != e) {
                    a.y = e;
                    this.k.i(a, a.y);
                }
            }
            if (!d) {
                if (a.y != this.c5) {
                    a.y = this.c5;
                    this.k.i(a, a.y);
                }
            }
            var f = this.b3.r4(b, a, a.y);
            if (a.y != f) {
                a.y = f;
                this.k.i(a, a.y);
            }
        };
        ShapeSeriesViewBase.prototype.cl = function (a, b) {
        };
        ShapeSeriesViewBase.prototype.cg = function (a, b) {
            var c = i2.truncate(Math.floor(a.left));
            var d = i2.truncate(Math.ceil(a.right));
            var e = i2.truncate(Math.floor(a.top));
            var f = i2.truncate(Math.ceil(a.bottom));
            for (var g = c; g < d; g++) {
                for (var h = e; h < f; h++) {
                    this.cu(g, h, b);
                }
            }
        };
        ShapeSeriesViewBase.prototype.cu = function (a, b, c) {
        };
        ShapeSeriesViewBase.prototype.cr = function () {
            this.ce = 0;
        };
        ShapeSeriesViewBase.prototype.cq = function () {
            this.b6.count = this.ce;
            this.aq();
        };
        ShapeSeriesViewBase.prototype.ct = function (a, b) {
        };
        ShapeSeriesViewBase.prototype.ck = function () {
            this.b6.count = 0;
            this.aq();
        };
        ShapeSeriesViewBase.prototype.cy = function () {
            var a = this.b3;
            var b = ((function () {
                var $ret = new i2.Path();
                $ret.dataContext = ((function () {
                    var $ret = new i2.DataContext();
                    $ret.series = a;
                    return $ret;
                })());
                return $ret;
            })());
            this.cd.add(b);
            return b;
        };
        ShapeSeriesViewBase.prototype.cn = function (a) {
            a._visibility = 0;
        };
        ShapeSeriesViewBase.prototype.co = function (a) {
            a.dataContext.item = null;
            a._visibility = 1;
        };
        ShapeSeriesViewBase.prototype.cp = function (a) {
            this.cd.remove(a);
        };
        ShapeSeriesViewBase.prototype.c3 = function (a, b, c) {
            if (b == null) {
                return null;
            }
            var d = new i2.PathGeometry();
            var e;
            var f = b.count;
            for (var g = 0; g < f; g++) {
                e = b._inner[g];
                if (e.count < 1) {
                    continue;
                }
                var h = new i2.PolyLineSegment();
                h._points = e;
                var i = new i2.PathFigure();
                i._isFilled = c;
                i._isClosed = c;
                i._startPoint = e._inner[0];
                i._segments.add(h);
                d.c.add(i);
            }
            return d;
        };
        ShapeSeriesViewBase.prototype.ac = function (a) {
            return this.cd._inner[a];
        };
        ShapeSeriesViewBase.prototype.ab = function (a) {
            var b = this.cd._inner[a];
            this.c4._visibility = b._visibility;
            this.c4.ak = b.ak;
            var c = this.bp(a);
            this.c4._fill = c;
            this.c4._stroke = c;
            this.c4.ac = this.e.fl + 3;
            return this.c4;
        };
        ShapeSeriesViewBase.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            for (var c = 0; c < this.cd.count; c++) {
                var d = this.aa(c, b);
                if (d._visibility != 1) {
                    a.s(d);
                }
            }
        };
        Object.defineProperty(ShapeSeriesViewBase.prototype, "c6", {
            get: function () {
                return this.c5;
            },
            enumerable: false,
            configurable: true
        });
        ShapeSeriesViewBase.prototype.cw = function (a) {
            this.b4 = a;
        };
        ShapeSeriesViewBase.prototype.cv = function (a) {
            this.c5 = a;
        };
        ShapeSeriesViewBase.prototype.cz = function (a, b) {
            return this.c0(a, b, false);
        };
        ShapeSeriesViewBase.prototype.c0 = function (a, b, c) {
            var d = this.b2(a, b, c);
            if (d == null) {
                return null;
            }
            return d.c;
        };
        ShapeSeriesViewBase.prototype.b2 = function (a, b, c) {
            if (this.ca.count == 0) {
                return null;
            }
            var d = a.x;
            var e = a.y;
            var f = this.ca.count;
            var g = this.ca;
            var h = null;
            for (var i = 0; i < f; i++) {
                h = g._inner[i];
                if (h.a == null || h.a.count == 0) {
                    continue;
                }
                if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                    if (c) {
                        var j = this.b3.fl / 2 + this.b3.fz(b);
                        if (i2.GeometryUtil.b(a, h.a._inner[0], h.a, j)) {
                            return h;
                        }
                    }
                    else {
                        if (i2.PolygonUtil.a(h.a, a)) {
                            return h;
                        }
                    }
                }
            }
            return null;
        };
        ShapeSeriesViewBase.prototype.cs = function (a, b, c, d) {
            this.by = a;
            this.b0 = b;
            this.bz = c;
            this.bx = d;
            this.ca.clear();
        };
        ShapeSeriesViewBase.prototype.cx = function () {
            var _this = this;
            var a = this.bu;
            var b = ((function () {
                var $ret = new i2.Path();
                $ret.y = _this.c5;
                return $ret;
            })());
            b.ac = 1;
            if (this.k != null) {
                this.k.i(b, b.y);
            }
            this.b3.r2 = i2.RectUtil.r(a, b.ac);
        };
        ShapeSeriesViewBase.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            if (this.b6.a == null) {
                return;
            }
            for (var b = 0; b < this.b6.a.count; b++) {
                var c = i2.typeCast(i2.Path.$, this.b6.a._inner[b]);
                if (c._visibility != 1) {
                    this.e.a6.exportPathData(a, c, "shape" + b, ["Main "]);
                }
            }
        };
        ShapeSeriesViewBase.$t = i2.markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);
        return ShapeSeriesViewBase;
    }(SeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ShapeAxisInfoCache = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ShapeAxisInfoCache, _super);
        function ShapeAxisInfoCache() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.b = null;
            _this.e = false;
            _this.f = false;
            _this.d = null;
            _this.c = null;
            return _this;
        }
        ShapeAxisInfoCache.$t = i2.markType(ShapeAxisInfoCache, 'ShapeAxisInfoCache');
        return ShapeAxisInfoCache;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StyleSelector = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StyleSelector, _super);
        function StyleSelector() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        StyleSelector.prototype.selectStyle = function (a, b) {
            return null;
        };
        StyleSelector.$t = i2.markType(StyleSelector, 'StyleSelector');
        return StyleSelector;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerVisualData, _super);
        function MarkerVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._x = 0;
            _this._y = 0;
            _this._index = 0;
            _this._markerAppearance = null;
            _this._markerType = null;
            _this._contentTemplate = null;
            _this._isVisible = false;
            _this._bounds = null;
            return _this;
        }
        Object.defineProperty(MarkerVisualData.prototype, "x", {
            get: function () {
                return this._x;
            },
            set: function (a) {
                this._x = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerVisualData.prototype, "y", {
            get: function () {
                return this._y;
            },
            set: function (a) {
                this._y = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerVisualData.prototype, "index", {
            get: function () {
                return this._index;
            },
            set: function (a) {
                this._index = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerVisualData.prototype, "markerAppearance", {
            get: function () {
                return this._markerAppearance;
            },
            set: function (a) {
                this._markerAppearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerVisualData.prototype, "markerType", {
            get: function () {
                return this._markerType;
            },
            set: function (a) {
                this._markerType = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerVisualData.prototype, "contentTemplate", {
            get: function () {
                return this._contentTemplate;
            },
            set: function (a) {
                this._contentTemplate = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MarkerVisualData.prototype, "isVisible", {
            get: function () {
                return this._isVisible;
            },
            set: function (a) {
                this._isVisible = a;
            },
            enumerable: false,
            configurable: true
        });
        MarkerVisualData.prototype.serialize = function () {
            var a = "{ x: " + this.x + ", y: " + this.y + ", index: " + this.index + ", markerAppearance: " + (this.markerAppearance != null ? this.markerAppearance.serialize() : "null") + ", markerType: \"" + this.markerType + "\", isVisible: " + (this.isVisible ? "true" : "false");
            if (this.bounds != null) {
                a += (", " + "bounds: { left: " + this.bounds.left + ", top:" + this.bounds.top + ", width:" + this.bounds.width + ", height: " + this.bounds.height + "}");
            }
            a += " }";
            return a;
        };
        MarkerVisualData.prototype.i = function (a) {
            this.x = (this.x - a.left) / a.width;
            this.y = (this.y - a.top) / a.height;
            if (this.bounds != null) {
                var b = (this.bounds.left - a.left) / a.width;
                var c = (this.bounds.top - a.top) / a.height;
                var d = ((this.bounds.left + this.bounds.width) - a.left) / a.width;
                var e = ((this.bounds.top + this.bounds.height) - a.top) / a.height;
                this.bounds = new i2.RectData(b, c, d - b, e - c);
            }
        };
        Object.defineProperty(MarkerVisualData.prototype, "bounds", {
            get: function () {
                return this._bounds;
            },
            set: function (a) {
                this._bounds = a;
            },
            enumerable: false,
            configurable: true
        });
        MarkerVisualData.$t = i2.markType(MarkerVisualData, 'MarkerVisualData');
        return MarkerVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterPolygonSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterPolygonSeries, _super);
        function ScatterPolygonSeries() {
            var _this = _super.call(this) || this;
            _this.sj = null;
            _this.sg = new ScalerParams(1, ScatterPolygonSeries.tp, ScatterPolygonSeries.tp, false);
            _this.sh = new ScalerParams(1, ScatterPolygonSeries.tp, ScatterPolygonSeries.tp, false);
            _this.s5 = null;
            _this.sb = 1;
            _this.r7 = 1;
            _this.ab = ScatterPolygonSeries.$;
            return _this;
        }
        ScatterPolygonSeries.prototype.get_d1 = function () {
            return true;
        };
        ScatterPolygonSeries.prototype.get_dw = function () {
            return true;
        };
        ScatterPolygonSeries.prototype.qq = function () {
            return this.sl();
        };
        ScatterPolygonSeries.prototype.rp = function (a) {
            var _this = this;
            var b = a;
            b.cv(this.tr);
            b.cw(this.sk);
            _super.prototype.rp.call(this, a);
            if (this.ct(a)) {
                return;
            }
            var c, d;
            var e = a.getViewInfo(c, d);
            c = e.p0;
            d = e.p1;
            var f = this.getEffectiveViewport1(a);
            this.sg = new ScalerParams(1, d, c, this.pz.cc);
            this.sg.c = f;
            this.sh = new ScalerParams(1, d, c, this.p1.cc);
            this.sh.c = f;
            if (c.width < 1 || c.height < 1) {
                return;
            }
            this.sj = ((function () {
                var $ret = new ShapeAxisInfoCache();
                $ret.a = _this.pz;
                $ret.b = _this.p1;
                $ret.e = _this.pz.cc;
                $ret.f = _this.p1.cc;
                $ret.d = _this.ch;
                $ret.c = _this.p9;
                return $ret;
            })());
            if (this.sl()) {
                var g = new i2.Dictionary$2(i2.Base.$, OwnedPoint.$, 0);
                b.dd.l(g, 400, d, c, this.gh);
                b.dd.j(g, false);
                if (this.qo()) {
                    this.s2(a);
                }
            }
        };
        ScatterPolygonSeries.prototype.s2 = function (a) {
            var _this = this;
            a.dh = true;
            this.p6.aw(this, this.qo(), i2.runOn(this, this.po));
            var b = this.p6.d;
            var c = b != null;
            var d = this.getEffectiveViewport1(a);
            var e = this.ch == null ? 0 : this.ch.count;
            a.dt(function (f) {
                if (f._visibility == 0) {
                    var g = f.ak;
                    var h = f.content;
                    if (h == null) {
                        h = new i2.DataContext();
                        f.content = h;
                    }
                    if (c) {
                        _this.rk(g, e, a.q);
                    }
                    _this.p6.ac(f, h);
                }
            });
        };
        ScatterPolygonSeries.prototype.sl = function () {
            return this.s5 != null && ((this.sf != 1 && this.sf != 0) || this.s6 != null);
        };
        ScatterPolygonSeries.prototype.bu = function () {
            return new ScatterPolygonSeriesView(this);
        };
        ScatterPolygonSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.si = a;
        };
        ScatterPolygonSeries.prototype.get_hasMarkers = function () {
            return true;
        };
        ScatterPolygonSeries.prototype.om = function () {
            return this.tl;
        };
        ScatterPolygonSeries.prototype.on = function () {
            return this.tm;
        };
        ScatterPolygonSeries.prototype.mv = function () {
            return this.s4;
        };
        ScatterPolygonSeries.prototype.ft = function () {
            return this.sn;
        };
        Object.defineProperty(ScatterPolygonSeries.prototype, "sc", {
            get: function () {
                return this.sb;
            },
            set: function (a) {
                this.sb = a;
            },
            enumerable: false,
            configurable: true
        });
        ScatterPolygonSeries.prototype.se = function () {
            if (this.sd == 0) {
                return 1;
            }
            return this.sd;
        };
        ScatterPolygonSeries.prototype.mh = function (a) {
            _super.prototype.mh.call(this, a);
            this.sd = a;
        };
        Object.defineProperty(ScatterPolygonSeries.prototype, "r8", {
            get: function () {
                return this.r7;
            },
            set: function (a) {
                this.r7 = a;
            },
            enumerable: false,
            configurable: true
        });
        ScatterPolygonSeries.prototype.sa = function () {
            if (this.r9 == 0) {
                return 2;
            }
            return this.r9;
        };
        ScatterPolygonSeries.prototype.mg = function (a) {
            _super.prototype.mg.call(this, a);
            this.r9 = a;
        };
        ScatterPolygonSeries.prototype.mi = function (a) {
            _super.prototype.mi.call(this, a);
            this.sn = a;
        };
        ScatterPolygonSeries.prototype.md = function () {
            _super.prototype.md.call(this);
            if (this.g9 < 0) {
                return;
            }
            if (this.s6 != null) {
                this.si.ds();
                this.si.dp();
            }
            else {
                var a = MarkerSeries.ps(this, this.sf);
                var b = MarkerSeries.p0(a);
                if (b == null) {
                    this.s4 = MarkerSeries.qe;
                }
                else {
                    this.si.dl(b);
                }
            }
            if (this.tn != null && this.sf != 13) {
                this.si.dq();
                this.si.dm();
            }
            else {
                if (this.sf == 13) {
                    this.tl = this.bx.bq();
                }
                else {
                    if (this.r8 != 2) {
                        if (this.ca != null) {
                            var c = this.ca.oy(this.g9);
                            if (!i2.isNaN_(this.fk) && this.fk != 1) {
                                c = i2.BrushUtil.o(c, this.fk);
                            }
                            this.tl = c;
                        }
                        else {
                            this.tl = null;
                        }
                    }
                }
            }
            if (this.to != null) {
                this.si.dr();
                this.si.dn();
            }
            else {
                if (this.sf == 13) {
                    this.tm = this.bx.bq();
                }
                else {
                    if (this.sd == 2) {
                        this.tm = this.tl;
                    }
                    else {
                        this.tm = this.ca == null ? null : this.ca.oz(this.g9);
                    }
                }
            }
            if (this.r8 == 2 && this.tn == null && this.sf != 13) {
                if (this.tm != null) {
                    var d = this.tm;
                    if (!i2.isNaN_(this.fk) && this.fk != 1) {
                        d = i2.BrushUtil.o(d, this.fk);
                    }
                    this.tl = d;
                }
                else {
                    this.tl = null;
                }
            }
        };
        ScatterPolygonSeries.prototype.lc = function () {
            _super.prototype.lc.call(this);
            this.sc = this.se();
            this.r8 = this.sa();
        };
        ScatterPolygonSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case ScatterPolygonSeries.$$p[3]:
                case ScatterPolygonSeries.$$p[11]:
                case ScatterPolygonSeries.$$p[7]:
                case ScatterPolygonSeries.$$p[9]:
                case ScatterPolygonSeries.$$p[10]:
                    this.md();
                    this.lj();
                    break;
                case ScatterPolygonSeries.$$p[6]:
                    this.sc = this.se();
                    this.md();
                    this.lj();
                    break;
                case ScatterPolygonSeries.$$p[5]:
                    this.r8 = this.sa();
                    this.md();
                    this.lj();
                    break;
                case ScatterPolygonSeries.$$p[2]:
                    this.s5 = d;
                    if (c == MarkerSeries.qe || d == MarkerSeries.qe || (c == null || d != null)) {
                        this.si.du();
                        this.l0(false);
                    }
                    this.bx.bj();
                    if (this.toolTip != null && this.dt) {
                        this.a4.a$aj(this, this.toolTip);
                    }
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterPolygonSeries.$$p[12]:
                    this.si.cv(this.tr);
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterPolygonSeries.$$p[13]:
                    this.si.cw(this.sk);
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterPolygonSeries.$$p[4]:
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterPolygonSeries.$$p[0]:
                case ScatterPolygonSeries.$$p[1]:
                    if (this.sl()) {
                        this.l0(false);
                    }
                    break;
            }
        };
        ScatterPolygonSeries.prototype.at = function (a, b) {
            var c = this.si.b1(a);
            var d = null;
            if (c != null) {
                d = c.content;
            }
            if (d != null) {
                return d;
            }
            return _super.prototype.at.call(this, a, b);
        };
        ScatterPolygonSeries.prototype.s3 = function (a, b) {
            var e_1, _a, e_2, _b;
            var c = new i2.List$1(i2.Base.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    if (!a.containsKey(d)) {
                        c.add1(d);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    b.h(e);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        ScatterPolygonSeries.prototype.cx = function (a, b, c) {
            var _this = this;
            if (!this.hasMarkers) {
                return false;
            }
            var d = this.pz;
            var e = new ScalerParams(1, this.ca.pg, this.pf, d.cc);
            e.c = this.getEffectiveViewport1(this.bx);
            var f = this.p1;
            var g = new ScalerParams(1, this.ca.pg, this.pf, f.cc);
            g.c = this.getEffectiveViewport1(this.bx);
            a.clear();
            this.si.dt(function (h) {
                if (h._visibility == 0) {
                    var i = new SeriesPointOfInterest();
                    var j = h.n;
                    var k = h.o;
                    if (j < _this.pf.left || j > _this.pf.right || k < _this.pf.top || k > _this.pf.bottom) {
                        return;
                    }
                    i.b = d.eb(j, e);
                    i.c = f.eb(k, g);
                    i.a = h.content;
                    a.add(i);
                }
            });
            return true;
        };
        ScatterPolygonSeries.prototype.r5 = function (a, b, c, d, e) {
            var _this = this;
            if (c == null || c.length != this.sj.d.count) {
                c = new Array(this.sj.d.count);
                for (var f = 0; f < this.sj.d.count; f++) {
                    c[f] = i2.PointUtil.create();
                }
            }
            var g = ((function () {
                var $ret = new ScalerParams(1, d, e, _this.pz.cc);
                $ret.c = _this.getEffectiveViewport1(a);
                return $ret;
            })());
            var h = ((function () {
                var $ret = new ScalerParams(1, d, e, _this.p1.cc);
                $ret.c = _this.getEffectiveViewport1(a);
                return $ret;
            })());
            var i = this.o7(a);
            var j = this.sj.a.eb(i.left, g);
            var k = this.sj.a.eb(i.right, g);
            var l = this.sj.b.eb(i.bottom, h);
            var m = this.sj.b.eb(i.top, h);
            if (this.sj.e) {
                var n = j;
                j = k;
                k = n;
            }
            if (this.sj.f) {
                var o = l;
                l = m;
                m = o;
            }
            var p = this.sj;
            var q = p.a;
            var r = p.b;
            var s;
            var t;
            var u = g.d.left;
            var v = g.d.right;
            var w = h.d.top;
            var x = h.d.bottom;
            for (var y = 0; y < this.sj.d.count; y++) {
                s = 0;
                t = 0;
                var z = null;
                var aa = a.b9.tryGetValue(y, z);
                z = aa.p1;
                if (z == null) {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
                else {
                    var ab = z.c;
                    var ac = i2.RectUtil.l(ab);
                    s = ac.x;
                    t = ac.y;
                    if (s >= u && s <= v && t >= w && t <= x) {
                        c[y].x = s;
                        c[y].y = t;
                    }
                    else {
                        c[y].x = NaN;
                        c[y].y = NaN;
                    }
                }
            }
            return c;
        };
        ScatterPolygonSeries.prototype.sm = function (a, b) {
            var e_3, _a;
            if (b == null) {
                b = new i2.List$1(i2.Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            var c = 0;
            var d = this.ch;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    b.add(d.indexOf(e));
                    c++;
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return b;
        };
        ScatterPolygonSeries.$t = i2.markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
        ScatterPolygonSeries.tp = new i2.Rect(0, 0, 0, 1, 1);
        ScatterPolygonSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:tl:s7', [i2.Brush.$], 'ActualMarkerOutline:tm:s8', [i2.Brush.$], 'ActualMarkerTemplate:s4:s9', [i2.DataTemplate.$, null], 'MarkerBrush:tn:ta', [i2.Brush.$], 'MarkerCollisionAvoidance:r6:tb', [CollisionAvoidanceType_$type, i2.enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:r9:tc', [MarkerFillMode_$type, i2.enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:sd:td', [MarkerOutlineMode_$type, i2.enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:to:te', [i2.Brush.$], 'MarkerStyle:tq:tf', [i2.Style.$], 'MarkerTemplate:s6:tg', [i2.DataTemplate.$, null], 'MarkerThickness:sn:th', [1, i2.DeviceUtils.g(2)], 'MarkerType:sf:ti', [MarkerType_$type, i2.enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:tr:tj', [i2.Style.$, null], 'ShapeStyleSelector:sk:tk', [StyleSelector.$, null]]);
        return ScatterPolygonSeries;
    }(ShapeSeriesBase));
    /**
     * @hidden
     */
    var ScatterPolygonSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterPolygonSeriesView, _super);
        function ScatterPolygonSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.dh = false;
            _this.c8 = null;
            _this.dj = null;
            _this.de = null;
            _this.dc = null;
            _this.dg = false;
            _this.df = null;
            _this.dk = null;
            _this.c9 = new Marker();
            _this.d1 = null;
            _this.c9 = new Marker();
            _this.c9.content = new i2.DataContext();
            _this.de = a;
            _this.df = new i2.HashPool$2(i2.Base.$, Marker.$);
            _this.dk = new i2.List$1(Marker.$, 0);
            _this.dv(_this.df);
            _this.dc = new NumericMarkerManager(1, function (b) { return _this.df.item(b); }, function (b) { return _this.de.sj.d.item(b); }, i2.runOn(_this, _this.dz), i2.runOn(_this, _this.c7), i2.runOn(_this, _this.di), function () { return _this.de.r6; });
            _this.dc.q = i2.runOn(_this, _this.d2);
            return _this;
        }
        ScatterPolygonSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.de.to = Defaults.am;
                this.de.gm = Defaults.z;
                this.de.sn = Defaults.y;
                this.de.sf = Defaults.f;
                this.de.r9 = Defaults.b;
            }
        };
        Object.defineProperty(ScatterPolygonSeriesView.prototype, "dd", {
            get: function () {
                return this.dc;
            },
            enumerable: false,
            configurable: true
        });
        ScatterPolygonSeriesView.prototype.dz = function (a) {
            this.de.s3(a, this.df);
        };
        ScatterPolygonSeriesView.prototype.c7 = function () {
            this.c8 = this.de.r5(this, this.df, this.c8, this.bv, this.bu);
            return this.c8;
        };
        ScatterPolygonSeriesView.prototype.di = function () {
            this.dj = this.de.sm(this.df, this.dj);
            return this.dj;
        };
        ScatterPolygonSeriesView.prototype.c2 = function (a, b) {
            return this.c3(a, b, true);
        };
        ScatterPolygonSeriesView.prototype.cj = function (a, b, c) {
            _super.prototype.cj.call(this, a, b, c);
            ShapeSeriesViewBase.ci(this, a, b);
        };
        ScatterPolygonSeriesView.prototype.ch = function (a, b) {
            var c = a;
            if (c == null) {
                return;
            }
            c.ak = b;
        };
        ScatterPolygonSeriesView.prototype.dt = function (a) {
            this.df.f(a);
        };
        ScatterPolygonSeriesView.prototype.dv = function (a) {
            a.create = i2.runOn(this, this.db);
            a.destroy = i2.runOn(this, this.dx);
            a.activate = i2.runOn(this, this.dw);
            a.disactivate = i2.runOn(this, this.dy);
        };
        ScatterPolygonSeriesView.prototype.db = function () {
            var _this = this;
            var a = new Marker();
            if (!this.dg) {
                a.content = ((function () {
                    var $ret = new i2.DataContext();
                    $ret.series = _this.e;
                    return $ret;
                })());
            }
            a.ah = this.e.s4;
            this.dk.add(a);
            return a;
        };
        ScatterPolygonSeriesView.prototype.b1 = function (a) {
            var b = this.da(a, 0);
            if (b == null) {
                b = this.da(a, 3);
            }
            return b;
        };
        ScatterPolygonSeriesView.prototype.da = function (a, b) {
            var c;
            var d;
            var e;
            var f;
            for (var g = this.dk.count - 1; g >= 0; g--) {
                var h = this.dk._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        };
        ScatterPolygonSeriesView.prototype.dx = function (a) {
            a.content = null;
            this.dk.remove(a);
        };
        ScatterPolygonSeriesView.prototype.dw = function (a) {
            a._visibility = 0;
        };
        ScatterPolygonSeriesView.prototype.dy = function (a) {
            if (a.content != null) {
                (i2.typeCast(i2.DataContext.$, a.content)).item = null;
            }
            a._visibility = 1;
        };
        ScatterPolygonSeriesView.prototype.d0 = function (a) {
            this.dg = a;
        };
        ScatterPolygonSeriesView.prototype.bh = function (a, b) {
            _super.prototype.bh.call(this, a, b);
            if (!this.dh) {
                var c = a;
                var d = c.content;
                if (d != null) {
                    if (this.de.tl != null) {
                        d.actualItemBrush = this.de.tl;
                    }
                    else {
                        d.actualItemBrush = this.b3.of;
                    }
                    if (this.de.tl != null) {
                        d.outline = this.de.tm;
                    }
                    else {
                        d.outline = this.b3.oi;
                    }
                    d.thickness = this.de.sn;
                }
            }
        };
        ScatterPolygonSeriesView.prototype.bi = function (a, b) {
            _super.prototype.bi.call(this, a, b);
            var c = a;
            this.c9._visibility = c._visibility;
            this.c9.ah = c.ah;
            this.c9.width = c.width;
            this.c9.height = c.height;
            this.c9.m = c.m;
            this.c9.l = c.l;
            this.c9.n = c.n;
            this.c9.o = c.o;
            var d = this.bp(b);
            var e = this.c9.content;
            var f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.de.sn + 3;
            }
        };
        ScatterPolygonSeriesView.prototype.a5 = function (a, b) {
            _super.prototype.a5.call(this, a, b);
            var c = new i2.DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.g();
            c.viewportTop = this.bu.top;
            c.viewportLeft = this.bu.left;
            c.viewportWidth = this.bu.width;
            c.viewportHeight = this.bu.height;
            c.passID = "Markers";
            var d = new i2.DataTemplateRenderInfo();
            d.passInfo = c;
            d.isHitTestRender = b;
            var e = new i2.DataTemplateMeasureInfo();
            e.passInfo = c;
            var f = false;
            var g = a.g();
            e.context = g;
            d.context = g;
            var h = 0;
            var i = 0;
            if (this.de.s4 != null && this.de.s4.passStarting != null) {
                this.de.s4.passStarting(c);
            }
            for (var j = 0; j < this.dk.count; j++) {
                var k = this.dk._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bg(k, j, b);
                if (b) {
                    k = this.c9;
                }
                if (!f) {
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    var l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!i2.isNaN_(k.width) && !i2.isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!i2.isNaN_(k.height) && !i2.isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.p(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.de.s4 != null && this.de.s4.passCompleted != null) {
                this.de.s4.passCompleted(c);
            }
        };
        ScatterPolygonSeriesView.prototype.ds = function () {
            this.de.s4 = null;
        };
        ScatterPolygonSeriesView.prototype.dp = function () {
            this.de.s4 = null;
            this.de.s4 = this.de.s6;
        };
        ScatterPolygonSeriesView.prototype.dq = function () {
            this.de.tl = null;
        };
        ScatterPolygonSeriesView.prototype.dm = function () {
            this.de.tl = null;
            if (!i2.isNaN_(this.e.fk) && this.e.fk != 1) {
                var a = i2.BrushUtil.o(this.de.tn, this.e.fk);
                this.de.tl = a;
            }
            else {
                this.de.tl = this.de.tn;
            }
        };
        ScatterPolygonSeriesView.prototype.dr = function () {
            this.de.tm = null;
        };
        ScatterPolygonSeriesView.prototype.dn = function () {
            this.de.tm = null;
            this.de.tm = this.de.to;
        };
        ScatterPolygonSeriesView.prototype.dl = function (a) {
            switch (a) {
                case "CircleMarkerTemplate":
                    this.de.s4 = this.de.ca.mu;
                    break;
                case "TriangleMarkerTemplate":
                    this.de.s4 = this.de.ca.m3;
                    break;
                case "PyramidMarkerTemplate":
                    this.de.s4 = this.de.ca.m0;
                    break;
                case "SquareMarkerTemplate":
                    this.de.s4 = this.de.ca.m1;
                    break;
                case "DiamondMarkerTemplate":
                    this.de.s4 = this.de.ca.mv;
                    break;
                case "PentagonMarkerTemplate":
                    this.de.s4 = this.de.ca.my;
                    break;
                case "HexagonMarkerTemplate":
                    this.de.s4 = this.de.ca.mw;
                    break;
                case "TetragramMarkerTemplate":
                    this.de.s4 = this.de.ca.my;
                    break;
                case "PentagramMarkerTemplate":
                    this.de.s4 = this.de.ca.mz;
                    break;
                case "HexagramMarkerTemplate":
                    this.de.s4 = this.de.ca.mx;
                    break;
            }
        };
        ScatterPolygonSeriesView.prototype.du = function () {
            var e_4, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.dk)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.ah = this.de.s4;
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            this.aq();
        };
        ScatterPolygonSeriesView.prototype.d2 = function (a) {
            if (this.d1 == null) {
                this.d1 = new i2.DataTemplateMeasureInfo();
                this.d1.context = this.k.g();
            }
            this.d1.width = a.width;
            this.d1.height = a.height;
            this.d1.data = a.content;
            var b = a.ah;
            if (b.measure != null) {
                b.measure(this.d1);
            }
            return new i2.Size(1, this.d1.width, this.d1.height);
        };
        ScatterPolygonSeriesView.prototype.al = function (a) {
            var e_5, _a;
            var b = a;
            _super.prototype.al.call(this, b);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.df.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = this.df.item(c);
                    if (d._visibility != 1) {
                        var e = i2.typeCast(ScatterPolygonSeries.$, this.e);
                        var f = this.e.a6.getMarkerVisualData(e, d, e.s4);
                        b.markerShapes.add(i2.typeCast(MarkerVisualData.$, f));
                    }
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        };
        ScatterPolygonSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.de.hp + "</span><br/>";
            a += "</div>";
            return a;
        };
        ScatterPolygonSeriesView.$t = i2.markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
        return ScatterPolygonSeriesView;
    }(ShapeSeriesViewBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Series class which renders polygons as Paths based on lists of points in the ItemsSource.
    */
    var IgxScatterPolygonSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterPolygonSeriesComponent, _super);
        function IgxScatterPolygonSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterPolygonSeriesComponent.prototype.createImplementation = function () {
            return new ScatterPolygonSeries();
        };
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "isPolygon", {
            /**
             * Gets whether the current series shows a polygon shape.
            */
            get: function () {
                return this.i.d1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "hasMarkers", {
            /**
             * Returns whether the current series supports visual markers.
            */
            get: function () {
                return this.i.hasMarkers;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "shapeStyle", {
            /**
             * The default style to apply to all Shapes in the series.
            */
            get: function () {
                if (this.i.tr == null) {
                    return null;
                }
                if (!this.i.tr.externalObject) {
                    var e = new i2.IgxStyle();
                    e._implementation = this.i.tr;
                    this.i.tr.externalObject = e;
                }
                return this.i.tr.externalObject;
            },
            set: function (v) {
                v == null ? this.i.tr = null : this.i.tr = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerType", {
            /**
             * Gets or sets the marker type for the current series object.
             * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
            */
            get: function () {
                return this.i.sf;
            },
            set: function (v) {
                this.i.sf = i2.ensureEnum(MarkerType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerTemplate", {
            /**
             * Gets or sets the MarkerTemplate for the current series object.
            */
            get: function () {
                return this.i.s6;
            },
            set: function (v) {
                this.i.s6 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerThickness", {
            /**
             * Gets or sets thickness of the marker outline
            */
            get: function () {
                return this.i.sn;
            },
            set: function (v) {
                this.i.sn = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "actualMarkerTemplate", {
            /**
             * Gets the effective marker template for the current series object.
            */
            get: function () {
                return this.i.s4;
            },
            set: function (v) {
                this.i.s4 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerBrush", {
            /**
             * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
            */
            get: function () {
                return i2.brushToString(this.i.tn);
            },
            set: function (v) {
                this.i.tn = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "actualMarkerBrush", {
            /**
             * Gets the effective marker brush for the current series object.
            */
            get: function () {
                return i2.brushToString(this.i.tl);
            },
            set: function (v) {
                this.i.tl = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerOutline", {
            /**
             * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
            */
            get: function () {
                return i2.brushToString(this.i.to);
            },
            set: function (v) {
                this.i.to = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "actualMarkerOutline", {
            /**
             * Gets the effective marker outline for the current series object.
            */
            get: function () {
                return i2.brushToString(this.i.tm);
            },
            set: function (v) {
                this.i.tm = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerCollisionAvoidance", {
            /**
             * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
            */
            get: function () {
                return this.i.r6;
            },
            set: function (v) {
                this.i.r6 = i2.ensureEnum(CollisionAvoidanceType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerOutlineMode", {
            /**
             * Gets or sets whether the marker outline is based on the marker brush of the series rather than the marker outlines collection.
            */
            get: function () {
                return this.i.sd;
            },
            set: function (v) {
                this.i.sd = i2.ensureEnum(MarkerOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolygonSeriesComponent.prototype, "markerFillMode", {
            /**
             * Gets or sets whether the marker fill is based on the marker outline of the series rather than the marker brushes collection.
            */
            get: function () {
                return this.i.r9;
            },
            set: function (v) {
                this.i.r9 = i2.ensureEnum(MarkerFillMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterPolygonSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.shapeStyle && this.shapeStyle.name && this.shapeStyle.name == name) {
                return this.shapeStyle;
            }
            return null;
        };
        IgxScatterPolygonSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterPolygonSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterPolygonSeriesComponent, selector: "igx-scatter-polygon-series", inputs: { shapeStyle: "shapeStyle", markerType: "markerType", markerTemplate: "markerTemplate", markerThickness: "markerThickness", actualMarkerTemplate: "actualMarkerTemplate", markerBrush: "markerBrush", actualMarkerBrush: "actualMarkerBrush", markerOutline: "markerOutline", actualMarkerOutline: "actualMarkerOutline", markerCollisionAvoidance: "markerCollisionAvoidance", markerOutlineMode: "markerOutlineMode", markerFillMode: "markerFillMode" }, providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolygonSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolygonSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterPolygonSeriesComponent;
    }(IgxShapeSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-polygon-series',
                        template: "",
                        providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolygonSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolygonSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shapeStyle: [{
                    type: i0.Input
                }], markerType: [{
                    type: i0.Input
                }], markerTemplate: [{
                    type: i0.Input
                }], markerThickness: [{
                    type: i0.Input
                }], actualMarkerTemplate: [{
                    type: i0.Input
                }], markerBrush: [{
                    type: i0.Input
                }], actualMarkerBrush: [{
                    type: i0.Input
                }], markerOutline: [{
                    type: i0.Input
                }], actualMarkerOutline: [{
                    type: i0.Input
                }], markerCollisionAvoidance: [{
                    type: i0.Input
                }], markerOutlineMode: [{
                    type: i0.Input
                }], markerFillMode: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterPolygonSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterPolygonSeriesModule() {
        }
        IgxScatterPolygonSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterPolygonSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesModule, declarations: [IgxScatterPolygonSeriesComponent], imports: [i1.CommonModule], exports: [IgxScatterPolygonSeriesComponent] });
        IgxScatterPolygonSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesModule, imports: [[i1.CommonModule]] });
        return IgxScatterPolygonSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterPolygonSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxScatterPolygonSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterPolygonSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterPolygonSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterPolygonSeriesComponent", IgxScatterPolygonSeriesComponent);
            i2.TypeRegistrar.register("ScatterPolygonSeries", ScatterPolygonSeries.$type);
        }
        IgxScatterPolygonSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterPolygonSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterPolygonSeriesModule], exports: [IgxScatterPolygonSeriesModule] });
        IgxScatterPolygonSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterPolygonSeriesModule], IgxScatterPolygonSeriesModule] });
        return IgxScatterPolygonSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolygonSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterPolygonSeriesModule],
                        exports: [IgxScatterPolygonSeriesModule],
                        entryComponents: [IgxScatterPolygonSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScatterPolylineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterPolylineSeries, _super);
        function ScatterPolylineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = ScatterPolylineSeries.$;
            return _this;
        }
        ScatterPolylineSeries.prototype.get_d2 = function () {
            return true;
        };
        ScatterPolylineSeries.prototype.bu = function () {
            return new ScatterPolylineSeriesView(this);
        };
        ScatterPolylineSeries.prototype.get_qc = function () {
            return false;
        };
        ScatterPolylineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.r5 = a;
        };
        ScatterPolylineSeries.prototype.get_qh = function () {
            return false;
        };
        ScatterPolylineSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case ScatterPolylineSeries.$$p[0]:
                    this.r5.cv(this.sb);
                    this.l0(false);
                    this.k7();
                    break;
                case ScatterPolylineSeries.$$p[1]:
                    this.r5.cw(this.r6);
                    this.l0(false);
                    this.k7();
                    break;
            }
        };
        ScatterPolylineSeries.prototype.rp = function (a) {
            var b = a;
            b.cv(this.sb);
            b.cw(this.r6);
            _super.prototype.rp.call(this, a);
        };
        ScatterPolylineSeries.prototype.at = function (a, b) {
            var c = this.r5.c0(a, b, true);
            if (c != null) {
                return c.dataContext;
            }
            return _super.prototype.at.call(this, a, b);
        };
        ScatterPolylineSeries.$t = i2.markType(ScatterPolylineSeries, 'ScatterPolylineSeries', ShapeSeriesBase.$);
        ScatterPolylineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ScatterPolylineSeries, 'raisePropertyChanged', ['ShapeStyle:sb:r9', [i2.Style.$, null], 'ShapeStyleSelector:r6:sa', [StyleSelector.$, null]]);
        return ScatterPolylineSeries;
    }(ShapeSeriesBase));
    /**
     * @hidden
     */
    var ScatterPolylineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScatterPolylineSeriesView, _super);
        function ScatterPolylineSeriesView(a) {
            return _super.call(this, a) || this;
        }
        ScatterPolylineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.b3.gm = Defaults.aa;
            }
        };
        ScatterPolylineSeriesView.prototype.c2 = function (a, b) {
            return this.c3(a, b, false);
        };
        ScatterPolylineSeriesView.prototype.cj = function (a, b, c) {
            _super.prototype.cj.call(this, a, b, c);
            ShapeSeriesViewBase.ci(this, a, b);
        };
        ScatterPolylineSeriesView.prototype.ch = function (a, b) {
            var c = i2.typeCast(i2.Path.$, a);
            if (c == null) {
                return;
            }
            c.ak = b;
        };
        ScatterPolylineSeriesView.prototype.ac = function (a) {
            var b = _super.prototype.ac.call(this, a);
            b._fill = null;
            return b;
        };
        ScatterPolylineSeriesView.prototype.ab = function (a) {
            var b = _super.prototype.ab.call(this, a);
            b._fill = null;
            return b;
        };
        ScatterPolylineSeriesView.prototype.b8 = function (a) {
            return a.width >= this.b3.qy || a.height >= this.b3.qy;
        };
        ScatterPolylineSeriesView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'><span";
            var b = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b3.hp + "</span><br/>";
            a += "</div>";
            return a;
        };
        ScatterPolylineSeriesView.$t = i2.markType(ScatterPolylineSeriesView, 'ScatterPolylineSeriesView', ShapeSeriesViewBase.$);
        return ScatterPolylineSeriesView;
    }(ShapeSeriesViewBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
    */
    var IgxScatterPolylineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScatterPolylineSeriesComponent, _super);
        function IgxScatterPolylineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxScatterPolylineSeriesComponent.prototype.createImplementation = function () {
            return new ScatterPolylineSeries();
        };
        Object.defineProperty(IgxScatterPolylineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolylineSeriesComponent.prototype, "isPolyline", {
            /**
             * Gets whether the current series shows a polyline shape.
            */
            get: function () {
                return this.i.d2;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxScatterPolylineSeriesComponent.prototype, "shapeStyle", {
            /**
             * The default style to apply to all Shapes in the series.
            */
            get: function () {
                if (this.i.sb == null) {
                    return null;
                }
                if (!this.i.sb.externalObject) {
                    var e = new i2.IgxStyle();
                    e._implementation = this.i.sb;
                    this.i.sb.externalObject = e;
                }
                return this.i.sb.externalObject;
            },
            set: function (v) {
                v == null ? this.i.sb = null : this.i.sb = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxScatterPolylineSeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.shapeStyle && this.shapeStyle.name && this.shapeStyle.name == name) {
                return this.shapeStyle;
            }
            return null;
        };
        IgxScatterPolylineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScatterPolylineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScatterPolylineSeriesComponent, selector: "igx-scatter-polyline-series", inputs: { shapeStyle: "shapeStyle" }, providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScatterPolylineSeriesComponent;
    }(IgxShapeSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scatter-polyline-series',
                        template: "",
                        providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { shapeStyle: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterPolylineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterPolylineSeriesModule() {
        }
        IgxScatterPolylineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterPolylineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesModule, declarations: [IgxScatterPolylineSeriesComponent], imports: [i1.CommonModule], exports: [IgxScatterPolylineSeriesComponent] });
        IgxScatterPolylineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxScatterPolylineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScatterPolylineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxScatterPolylineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScatterPolylineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScatterPolylineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxScatterPolylineSeriesComponent", IgxScatterPolylineSeriesComponent);
            i2.TypeRegistrar.register("ScatterPolylineSeries", ScatterPolylineSeries.$type);
        }
        IgxScatterPolylineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScatterPolylineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesDynamicModule, imports: [i1.CommonModule, IgxScatterPolylineSeriesModule], exports: [IgxScatterPolylineSeriesModule] });
        IgxScatterPolylineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesDynamicModule, imports: [[i1.CommonModule, IgxScatterPolylineSeriesModule], IgxScatterPolylineSeriesModule] });
        return IgxScatterPolylineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScatterPolylineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxScatterPolylineSeriesModule],
                        exports: [IgxScatterPolylineSeriesModule],
                        entryComponents: [IgxScatterPolylineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartShapeModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartShapeModule() {
        }
        IgxDataChartShapeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartShapeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeModule, imports: [i1.CommonModule, IgxScatterAreaSeriesModule,
                IgxScatterContourSeriesModule,
                IgxScatterPolygonSeriesModule,
                IgxScatterPolylineSeriesModule,
                IgxDataChartShapeCoreModule], exports: [IgxScatterAreaSeriesModule,
                IgxScatterContourSeriesModule,
                IgxScatterPolygonSeriesModule,
                IgxScatterPolylineSeriesModule,
                IgxDataChartShapeCoreModule] });
        IgxDataChartShapeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeModule, imports: [[i1.CommonModule, IgxScatterAreaSeriesModule,
                    IgxScatterContourSeriesModule,
                    IgxScatterPolygonSeriesModule,
                    IgxScatterPolylineSeriesModule,
                    IgxDataChartShapeCoreModule
                ], IgxScatterAreaSeriesModule,
                IgxScatterContourSeriesModule,
                IgxScatterPolygonSeriesModule,
                IgxScatterPolylineSeriesModule,
                IgxDataChartShapeCoreModule] });
        return IgxDataChartShapeModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxScatterAreaSeriesModule,
                            IgxScatterContourSeriesModule,
                            IgxScatterPolygonSeriesModule,
                            IgxScatterPolylineSeriesModule,
                            IgxDataChartShapeCoreModule
                        ],
                        imports: [i1.CommonModule, IgxScatterAreaSeriesModule,
                            IgxScatterContourSeriesModule,
                            IgxScatterPolygonSeriesModule,
                            IgxScatterPolylineSeriesModule,
                            IgxDataChartShapeCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartShapeDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartShapeDynamicModule() {
        }
        IgxDataChartShapeDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartShapeDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeDynamicModule, imports: [i1.CommonModule, IgxScatterAreaSeriesDynamicModule,
                IgxScatterContourSeriesDynamicModule,
                IgxScatterPolygonSeriesDynamicModule,
                IgxScatterPolylineSeriesDynamicModule,
                IgxDataChartShapeCoreDynamicModule,
                IgxDataChartShapeModule], exports: [IgxScatterAreaSeriesDynamicModule,
                IgxScatterContourSeriesDynamicModule,
                IgxScatterPolygonSeriesDynamicModule,
                IgxScatterPolylineSeriesDynamicModule,
                IgxDataChartShapeCoreDynamicModule,
                IgxDataChartShapeModule] });
        IgxDataChartShapeDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeDynamicModule, imports: [[i1.CommonModule, IgxScatterAreaSeriesDynamicModule,
                    IgxScatterContourSeriesDynamicModule,
                    IgxScatterPolygonSeriesDynamicModule,
                    IgxScatterPolylineSeriesDynamicModule,
                    IgxDataChartShapeCoreDynamicModule,
                    IgxDataChartShapeModule
                ], IgxScatterAreaSeriesDynamicModule,
                IgxScatterContourSeriesDynamicModule,
                IgxScatterPolygonSeriesDynamicModule,
                IgxScatterPolylineSeriesDynamicModule,
                IgxDataChartShapeCoreDynamicModule,
                IgxDataChartShapeModule] });
        return IgxDataChartShapeDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartShapeDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxScatterAreaSeriesDynamicModule,
                            IgxScatterContourSeriesDynamicModule,
                            IgxScatterPolygonSeriesDynamicModule,
                            IgxScatterPolylineSeriesDynamicModule,
                            IgxDataChartShapeCoreDynamicModule,
                            IgxDataChartShapeModule
                        ],
                        imports: [i1.CommonModule, IgxScatterAreaSeriesDynamicModule,
                            IgxScatterContourSeriesDynamicModule,
                            IgxScatterPolygonSeriesDynamicModule,
                            IgxScatterPolylineSeriesDynamicModule,
                            IgxDataChartShapeCoreDynamicModule,
                            IgxDataChartShapeModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryYAxis, _super);
        function CategoryYAxis() {
            var _this = _super.call(this) || this;
            _this.lq = 0;
            _this.lr = 0;
            _this.ly = 1;
            _this.lx = 1;
            _this.kd = new i2.List$1(i2.Number_$type, 0);
            _this.ab = CategoryYAxis.$;
            return _this;
        }
        CategoryYAxis.prototype.a3 = function () {
            return new CategoryYAxisView(this);
        };
        CategoryYAxis.prototype.ha = function (a) {
            _super.prototype.ha.call(this, a);
            this.lo = a;
        };
        CategoryYAxis.prototype.get_cj = function () {
            return true;
        };
        CategoryYAxis.prototype.d7 = function () {
            return this.js.height;
        };
        CategoryYAxis.prototype.ll = function (a, b, c) {
            return this.lm(a, b, c, true);
        };
        CategoryYAxis.prototype.ln = function (a) {
            if (i2.typeCast(i2.List$1.$.specialize(i2.Array_$type), a) !== null) {
                return a.asArray();
            }
            return null;
        };
        CategoryYAxis.prototype.g4 = function (a, b, c, d, e) {
            var f;
            var g = e.e;
            var h = e.d;
            var i = e.c;
            var j = e.a;
            var k = !i.isEmpty;
            var l = this.categoryMode == 0 ? this.kq - 1 : this.kq;
            if (l < 0) {
                l = 0;
            }
            var m = i.top;
            var n = i.height;
            var o = g.top;
            var p = g.height;
            var q = h.top;
            var r = h.height;
            var s = 0;
            var t = 1;
            var u = this.ln(a);
            var v = false;
            if (u != null) {
                v = true;
            }
            var w;
            for (var x = 0; x < b.count; x++) {
                w = b.item(x);
                for (var y = c; y < d; y++) {
                    if (v) {
                        f = u[y];
                    }
                    else {
                        f = a.item(y);
                    }
                    if (k) {
                        var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (!j) {
                            z = 1 - z;
                        }
                        z = m + n * (z - s) / t;
                        var aa = (z - e.d.top) / e.d.height;
                        aa = e.d.top + e.d.height * (aa - e.e.top) / e.e.height;
                        f[w] = aa;
                    }
                    else {
                        var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                        if (!j) {
                            ab = 1 - ab;
                        }
                        ab = q + r * (ab - o) / p;
                        f[w] = ab;
                    }
                }
            }
        };
        Object.defineProperty(CategoryYAxis.prototype, "lv", {
            get: function () {
                return this.c(CategoryYAxis.l7);
            },
            set: function (a) {
                this.h(CategoryYAxis.l7, a);
            },
            enumerable: false,
            configurable: true
        });
        CategoryYAxis.prototype.lp = function () {
            return !i2.isNaN_(this.lv);
        };
        Object.defineProperty(CategoryYAxis.prototype, "ls", {
            get: function () {
                return this.lq;
            },
            set: function (a) {
                if (this.ls != a) {
                    var b = this.lq;
                    this.lq = a;
                    this.hk("ActualInterval", b, this.ls);
                }
            },
            enumerable: false,
            configurable: true
        });
        CategoryYAxis.prototype.ej = function () {
            return this.ls;
        };
        Object.defineProperty(CategoryYAxis.prototype, "lw", {
            get: function () {
                return this.c(CategoryYAxis.l8);
            },
            set: function (a) {
                this.h(CategoryYAxis.l8, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryYAxis.prototype, "lt", {
            get: function () {
                return this.lr;
            },
            set: function (a) {
                if (this.lt != a) {
                    var b = this.lr;
                    this.lr = a;
                    this.hk("ActualMinorInterval", b, this.lt);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryYAxis.prototype, "l0", {
            get: function () {
                return this.ly;
            },
            set: function (a) {
                this.ly = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryYAxis.prototype, "lz", {
            get: function () {
                return this.lx;
            },
            set: function (a) {
                this.lx = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryYAxis.prototype.d8 = function (a, b) {
            if (!b.c.isEmpty) {
                var c = this.lu(a, NumericScaler.ac, b.c);
                c = (c - b.d.top) / b.d.height;
                c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
                return c;
            }
            return this.lu(a, b.e, b.d);
        };
        CategoryYAxis.prototype.lu = function (a, b, c) {
            var d = this.categoryMode == 0 ? this.kq - 1 : this.kq;
            if (d < 0) {
                d = 0;
            }
            var e = d >= 1 ? (a) / (d) : d == 0 ? 0.5 : NaN;
            if (!this.cd) {
                e = 1 - e;
            }
            return c.top + c.height * (e - b.top) / b.height;
        };
        CategoryYAxis.prototype.eb = function (a, b) {
            if (!b.c.isEmpty) {
                var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
                c = (c * b.d.height) + b.d.top;
                c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
                return c;
            }
            return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
        };
        CategoryYAxis.prototype.ec = function (a, b, c) {
            if (!b.c.isEmpty) {
                var d = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
                d = (d * b.d.height) + b.d.top;
                d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
                return d;
            }
            return this.getUnscaledValue3(a, b.e, b.d, c);
        };
        CategoryYAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
            var e = b.top + (a - c.top) * b.height / c.height;
            if (!this.cd) {
                e = 1 - e;
            }
            var f = d == 0 ? this.kq - 1 : this.kq;
            if (f < 0) {
                f = 0;
            }
            return e * f;
        };
        CategoryYAxis.prototype.l6 = function (a, b) {
            if (a == NaN || b == NaN || this.j6 == null || this.j6.count == 0) {
                return;
            }
            var c = a / this.j6.count;
            var d = b / this.j6.count;
            this.bh.pw = new i2.Rect(0, this.bh.pw.x, 1 - d, this.bh.pw.width, d - c);
        };
        CategoryYAxis.prototype.au = function () {
            return new VerticalAxisLabelPanel();
        };
        CategoryYAxis.prototype.dv = function () {
            return this.lv;
        };
        CategoryYAxis.prototype.getCategorySize = function (a, b, c) {
            var d = this.jq(b, c);
            return d.height / (this.kq * a.height);
        };
        CategoryYAxis.prototype.ki = function (a, b, c) {
            var d = 0;
            if (!i2.isNaN_(this.kf)) {
                d = i2.MathUtil.b(this.kf, 0, 1);
            }
            var e = 0;
            if (!i2.isNaN_(this.km)) {
                e = Math.min(this.km, 1);
            }
            var f = 1 - 0.5 * d;
            var g = this.getCategorySize(a, b, c) * f / (this.ks - (this.ks - 1) * e);
            return g;
        };
        CategoryYAxis.prototype.getGroupCenter = function (a, b, c, d) {
            var e = 0.5;
            if (this.ks > 1) {
                var f = 0;
                if (!i2.isNaN_(this.kf)) {
                    f = i2.MathUtil.b(this.kf, 0, 1);
                }
                var g = 0;
                if (!i2.isNaN_(this.km)) {
                    g = Math.min(this.km, 1);
                }
                var h = 1 - 0.5 * f;
                var i = h / (this.ks - (this.ks - 1) * g);
                var j = (h - i) / (this.ks - 1);
                e = 0.25 * f + 0.5 * i + a * j;
            }
            return this.getCategorySize(b, c, d) * e;
        };
        CategoryYAxis.prototype.l5 = function (a) {
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            b = b.copy();
            var c = this.js;
            var d = new i2.Rect(0, 0, 0, 1, 1);
            var e = this.jp();
            var f = new ScalerParams(0, d, d, this.cc, e);
            var g = !b.isEmpty && !c.isEmpty && this.j6 != null ? this.j6.indexOf(a) : -1;
            var h = g > -1 ? this.d8(g, f) : NaN;
            if (!i2.isNaN_(h) && this.bh.d0) {
                if (!i2.isNaN_(h)) {
                    if (h < b.top + 0.1 * b.height) {
                        h = h + 0.4 * b.height;
                        b.y = h - 0.5 * b.height;
                    }
                    if (h > b.bottom - 0.1 * b.height) {
                        h = h - 0.4 * b.height;
                        b.y = h - 0.5 * b.height;
                    }
                }
                this.bh.mt(b, false, true);
            }
        };
        CategoryYAxis.prototype.cx = function () {
            if (this.ck && this.cy) {
                this.bb = this.ba();
            }
            if (this.j6 == null) {
                return false;
            }
            var a = this.j6.count;
            if (a != this.lz) {
                var b = new AxisRangeChangedEventArgs(0, 1, 1, this.lz, a);
                this.lz = a;
                this.hl(b);
                return true;
            }
            return false;
        };
        CategoryYAxis.prototype.j9 = function (a) {
            if (a == null) {
                return false;
            }
            var b = this.bd();
            if (b == null) {
                return false;
            }
            return b.synchronizeVertically;
        };
        CategoryYAxis.prototype.hr = function (a) {
            _super.prototype.hr.call(this, a);
            var b = this.bh != null ? this.bh.pg : i2.Rect.empty;
            var c = this.js;
            var d = this.jn();
            var e = this.jm();
            var f = new ScalerParams(0, b, c, this.cc, d);
            var g = this.a4.ay();
            var h = this.a4.a1();
            var i = this.a4.az();
            var j = this.a4.a0();
            var k = this.a4.e();
            var l = this.a4.f();
            var m = this.a4.g();
            this.h0();
            this.g0(g);
            this.g0(h);
            this.g0(i);
            this.g0(j);
            this.c5.clear();
            this.c6.clear();
            this.kd.clear();
            this.a4.at(this, b, c);
            if (b.isEmpty || c.isEmpty) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
            }
            if (this.bq.count == 0 && this.bp.count == 0) {
                this.a4.y();
            }
            if (this.ay != null) {
                this.ay.registerAxis(this);
            }
            if (this.itemsSource == null || this.j6 == null || this.j6.count == 0) {
                this.bq.count = 0;
                this.bp.count = 0;
                this.bo.count = 0;
                this.a4.y();
                return;
            }
            if (!b.isEmpty && !c.isEmpty) {
                var n = this.eb(e.top, f);
                var o = this.eb(e.bottom, f);
                if (!this.cc) {
                    n = Math.ceil(n);
                    o = Math.floor(o);
                }
                else {
                    n = Math.floor(n);
                    o = Math.ceil(o);
                }
                var p = c.left;
                var q = 0;
                if (this.ai != null) {
                    var r = i2.typeCast(NumericXAxis.$, this.ai);
                    if (r != null) {
                        var s = this.hv(p, q, b, c, d, c.left, c.right);
                        p = s.p0;
                        q = s.p1;
                    }
                }
                this.h1(g, p, c, k, true);
                this.a4.ao(q);
                var t = Math.min(n, o);
                var u = Math.max(n, o);
                var v = new LinearCategorySnapper(1, t, u, e.height, this.lv, this.categoryMode, this.el());
                var w = v.g;
                while (!this.lp() && w < 10 && this.ct(w, b, c, d)) {
                    w--;
                }
                if (v.g != w) {
                    v = new LinearCategorySnapper(1, t, u, e.height, w, this.categoryMode, this.el());
                }
                var x = Math.floor((t - 0) / v.g);
                var y = Math.ceil((u - 0) / v.g);
                if (!i2.isNaN_(x) && !i2.isNaN_(y)) {
                    var z = i2.truncate(x);
                    var aa = i2.truncate(y);
                    var ab = this.d8(0 + z * v.g, f);
                    var ac = Math.abs(this.d8(v.g, f) - this.d8(0, f));
                    this.av.br = this.d8(v.g, f);
                    for (var ad = z; ad <= aa; ++ad) {
                        var ae = this.d8(0 + (ad + 1) * v.g, f);
                        if (ab <= e.bottom) {
                            if (ad % 2 == 0) {
                                this.g9(h, ab, ae, c);
                            }
                            this.g8(i, ab, c, l, false);
                            this.kd.add(ab);
                        }
                        if (this.categoryMode != 0 && this.ks != 0 && this.cs) {
                            if (this.lw > 0 && this.lw < v.g) {
                                var af = ac * this.lw;
                                if (!this.cc) {
                                    var ag = ab;
                                    while (ag - af > ae) {
                                        ag -= af;
                                        if (Math.abs(ag - ae) < 0.0001) {
                                            break;
                                        }
                                        this.g8(j, ag, c, m, false);
                                    }
                                }
                                else {
                                    var ah = ab;
                                    while (ah + af < ae) {
                                        ah += af;
                                        if (Math.abs(ah - ae) < 0.0001) {
                                            break;
                                        }
                                        this.g8(j, ah, c, m, false);
                                    }
                                }
                                this.lt = this.lw;
                            }
                            else {
                                for (var ai = 0; ai < i2.truncate(v.g); ai++) {
                                    for (var aj = 0; aj < this.ks; aj++) {
                                        var ak = this.getGroupCenter(aj, b, c, d);
                                        if (!this.cc) {
                                            ak = -ak;
                                        }
                                        var al = this.d8(ai + ad * v.g, f) + ak;
                                        this.g8(j, al, c, m, false);
                                    }
                                }
                                this.lt = 0.5;
                            }
                        }
                        var am = ab;
                        if (this.categoryMode != 0) {
                            var an = this.d8(ad * v.g + 1, f);
                            am = (ab + an) / 2;
                        }
                        if (am <= e.bottom && am >= e.top) {
                            var ao = 0;
                            if (v.g >= 1) {
                                ao = ad * i2.truncate(Math.floor(v.g));
                            }
                            else {
                                if ((ad * v.g) * 2 % 2 == 0) {
                                    ao = i2.truncate(Math.floor(ad * v.g));
                                }
                                else {
                                    ao = -1;
                                }
                            }
                            if (this.j6 != null && ao < this.j6.count && ao >= 0) {
                                var ap = this.j6.item(ao);
                                var aq = this.fi(ap);
                                if (!i2.isNaN_(am) && !i2.isInfinity(am) && aq != null) {
                                    if ((typeof aq === 'string') && i2.Base.equalsStatic(aq, "")) {
                                    }
                                    else {
                                        this.c5.add1(aq);
                                        this.c6.add(new LabelPosition(am));
                                    }
                                }
                            }
                        }
                        ab = ae;
                    }
                }
                this.ls = v.g;
                if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                    if (this.ay != null && (this.ay.location == 6 || this.ay.location == 7)) {
                        this.bh.jq();
                    }
                }
                this.a4.au(this.c5, this.c6);
                this.ld();
            }
        };
        CategoryYAxis.prototype.get_a1 = function () {
            return 1;
        };
        Object.defineProperty(CategoryYAxis.prototype, "a1", {
            get: function () {
                return this.get_a1();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CategoryYAxis.prototype, "isVertical", {
            get: function () {
                return this.cj;
            },
            enumerable: false,
            configurable: true
        });
        CategoryYAxis.prototype.j$c = function (a, b) {
            return this.eb.apply(this, arguments);
        };
        CategoryYAxis.prototype.j$b = function (a, b) {
            return this.d8.apply(this, arguments);
        };
        CategoryYAxis.prototype.j$d = function (a, b, c, d, e) {
            this.g4.apply(this, arguments);
        };
        CategoryYAxis.prototype.j$e = function (a, b, c, d) {
            this.g5.apply(this, arguments);
        };
        CategoryYAxis.prototype.j$f = function (a, b, c, d) {
            this.g6.apply(this, arguments);
        };
        Object.defineProperty(CategoryYAxis.prototype, "j$a", {
            get: function () {
                return this.cc;
            },
            enumerable: false,
            configurable: true
        });
        CategoryYAxis.$t = i2.markType(CategoryYAxis, 'CategoryYAxis', CategoryAxisBase.$);
        CategoryYAxis.l7 = i2.DependencyProperty.i("Interval", i2.Number_$type, CategoryYAxis.$, new i2.PropertyMetadata(2, NaN, function (a, b) {
            a.hk("Interval", b.oldValue, b.newValue);
            a.hq(false);
        }));
        CategoryYAxis.l8 = i2.DependencyProperty.i("MinorInterval", i2.Number_$type, CategoryYAxis.$, new i2.PropertyMetadata(2, NaN, function (a, b) {
            (i2.typeCast(CategoryYAxis.$, a)).hk("MinorInterval", b.oldValue, b.newValue);
            (i2.typeCast(CategoryYAxis.$, a)).hq(false);
        }));
        return CategoryYAxis;
    }(CategoryAxisBase));
    /**
     * @hidden
     */
    var CategoryYAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryYAxisView, _super);
        function CategoryYAxisView(a) {
            var _this = _super.call(this, a) || this;
            _this.bg = null;
            _this.bg = a;
            return _this;
        }
        CategoryYAxisView.prototype.ag = function () {
            _super.prototype.ag.call(this);
            this.a.e0 = AxisDefaults.f;
        };
        CategoryYAxisView.$t = i2.markType(CategoryYAxisView, 'CategoryYAxisView', CategoryAxisBaseView.$);
        return CategoryYAxisView;
    }(CategoryAxisBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent category Y axis.
    */
    var IgxCategoryYAxisComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCategoryYAxisComponent, _super);
        function IgxCategoryYAxisComponent() {
            var _this = _super.call(this) || this;
            _this._actualIntervalChange = null;
            _this._actualMinorIntervalChange = null;
            return _this;
        }
        IgxCategoryYAxisComponent.prototype.createImplementation = function () {
            return new CategoryYAxis();
        };
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "isVertical", {
            /**
             * Gets if the current axis is a vertical axis.
            */
            get: function () {
                return this.i.cj;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "interval", {
            /**
             * Gets or sets the frequency of displayed labels.
             * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
            */
            get: function () {
                return this.i.lv;
            },
            set: function (v) {
                this.i.lv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "actualInterval", {
            /**
             * Gets the effective value for the current Interval.
            */
            get: function () {
                return this.i.ls;
            },
            set: function (v) {
                this.i.ls = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "minorInterval", {
            /**
             * Gets or sets the frequency of displayed minor lines.
             * The set value is a factor that determines how the minor lines will be displayed.
            */
            get: function () {
                return this.i.lw;
            },
            set: function (v) {
                this.i.lw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "actualMinorInterval", {
            /**
             * Gets the effective value for the current MinorInterval.
            */
            get: function () {
                return this.i.lt;
            },
            set: function (v) {
                this.i.lt = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryYAxisComponent.prototype.getCategoryBoundingBox = function (point, useInterpolation, singularWidth) {
            var iv = this.i.ll(i2.toPoint(point), useInterpolation, singularWidth);
            return i2.fromRect(iv);
        };
        IgxCategoryYAxisComponent.prototype.scrollRangeIntoView = function (minimum, maximum) {
            this.i.l6(minimum, maximum);
        };
        /**
         * Scrolls the specified item into view.
        
        * @param item  * Data item to scroll into view
        */
        IgxCategoryYAxisComponent.prototype.scrollIntoView = function (item) {
            this.i.l5(item);
        };
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "actualIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualIntervalChange == null) {
                    this._actualIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualInterval;
                        if (_this.beforeActualIntervalChange) {
                            _this.beforeActualIntervalChange(_this, ext);
                        }
                        _this._actualIntervalChange.emit(ext);
                    });
                }
                return this._actualIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCategoryYAxisComponent.prototype, "actualMinorIntervalChange", {
            get: function () {
                var _this = this;
                if (this._actualMinorIntervalChange == null) {
                    this._actualMinorIntervalChange = new i0.EventEmitter();
                    this.i.propertyChanged = i2.delegateCombine(this.i.propertyChanged, function (o, e) {
                        var iv = e;
                        var ext = _this.actualMinorInterval;
                        if (_this.beforeActualMinorIntervalChange) {
                            _this.beforeActualMinorIntervalChange(_this, ext);
                        }
                        _this._actualMinorIntervalChange.emit(ext);
                    });
                }
                return this._actualMinorIntervalChange;
            },
            enumerable: false,
            configurable: true
        });
        IgxCategoryYAxisComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCategoryYAxisComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCategoryYAxisComponent, selector: "igx-category-y-axis", inputs: { interval: "interval", actualInterval: "actualInterval", minorInterval: "minorInterval", actualMinorInterval: "actualMinorInterval" }, outputs: { actualIntervalChange: "actualIntervalChange", actualMinorIntervalChange: "actualMinorIntervalChange" }, providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryYAxisComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCategoryYAxisComponent;
    }(IgxCategoryAxisBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-category-y-axis',
                        template: "",
                        providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: i0.forwardRef(function () { return IgxCategoryYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: i0.forwardRef(function () { return IgxCategoryYAxisComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { interval: [{
                    type: i0.Input
                }], actualInterval: [{
                    type: i0.Input
                }], minorInterval: [{
                    type: i0.Input
                }], actualMinorInterval: [{
                    type: i0.Input
                }], actualIntervalChange: [{
                    type: i0.Output
                }], actualMinorIntervalChange: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryYAxisModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryYAxisModule() {
        }
        IgxCategoryYAxisModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryYAxisModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisModule, declarations: [IgxCategoryYAxisComponent], imports: [i1.CommonModule], exports: [IgxCategoryYAxisComponent] });
        IgxCategoryYAxisModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisModule, imports: [[i1.CommonModule]] });
        return IgxCategoryYAxisModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCategoryYAxisComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCategoryYAxisComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCategoryYAxisDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCategoryYAxisDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCategoryYAxisComponent", IgxCategoryYAxisComponent);
            i2.TypeRegistrar.register("CategoryYAxis", CategoryYAxis.$type);
        }
        IgxCategoryYAxisDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCategoryYAxisDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisDynamicModule, imports: [i1.CommonModule, IgxCategoryYAxisModule], exports: [IgxCategoryYAxisModule] });
        IgxCategoryYAxisDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisDynamicModule, imports: [[i1.CommonModule, IgxCategoryYAxisModule], IgxCategoryYAxisModule] });
        return IgxCategoryYAxisDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCategoryYAxisDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCategoryYAxisModule],
                        exports: [IgxCategoryYAxisModule],
                        entryComponents: [IgxCategoryYAxisComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartVerticalCategoryCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartVerticalCategoryCoreModule() {
        }
        IgxDataChartVerticalCategoryCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartVerticalCategoryCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreModule, imports: [i1.CommonModule, IgxNumericXAxisModule,
                IgxCategoryYAxisModule,
                IgxDataChartCoreModule], exports: [IgxNumericXAxisModule,
                IgxCategoryYAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartVerticalCategoryCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreModule, imports: [[i1.CommonModule, IgxNumericXAxisModule,
                    IgxCategoryYAxisModule,
                    IgxDataChartCoreModule
                ], IgxNumericXAxisModule,
                IgxCategoryYAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartVerticalCategoryCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericXAxisModule,
                            IgxCategoryYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericXAxisModule,
                            IgxCategoryYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartVerticalCategoryCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartVerticalCategoryCoreDynamicModule() {
        }
        IgxDataChartVerticalCategoryCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartVerticalCategoryCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreDynamicModule, imports: [i1.CommonModule, IgxNumericXAxisDynamicModule,
                IgxCategoryYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartVerticalCategoryCoreModule], exports: [IgxNumericXAxisDynamicModule,
                IgxCategoryYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartVerticalCategoryCoreModule] });
        IgxDataChartVerticalCategoryCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreDynamicModule, imports: [[i1.CommonModule, IgxNumericXAxisDynamicModule,
                    IgxCategoryYAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartVerticalCategoryCoreModule
                ], IgxNumericXAxisDynamicModule,
                IgxCategoryYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartVerticalCategoryCoreModule] });
        return IgxDataChartVerticalCategoryCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxNumericXAxisDynamicModule,
                            IgxCategoryYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartVerticalCategoryCoreModule
                        ],
                        imports: [i1.CommonModule, IgxNumericXAxisDynamicModule,
                            IgxCategoryYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartVerticalCategoryCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /**
     * Represents a vertically laid out category based series.
    */
    var IgxVerticalAnchoredCategorySeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxVerticalAnchoredCategorySeriesComponent, _super);
        function IgxVerticalAnchoredCategorySeriesComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxVerticalAnchoredCategorySeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxVerticalAnchoredCategorySeriesComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current CategorySeries object.
            */
            get: function () {
                if (this.i.xAxis == null) {
                    return null;
                }
                if (!this.i.xAxis.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.xAxis);
                    if (e) {
                        e._implementation = this.i.xAxis;
                    }
                    this.i.xAxis.externalObject = e;
                }
                return this.i.xAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxVerticalAnchoredCategorySeriesComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current CategorySeries object.
            */
            get: function () {
                if (this.i.yAxis == null) {
                    return null;
                }
                if (!this.i.yAxis.externalObject) {
                    var e = IgxCategoryYAxisComponent._createFromInternal(this.i.yAxis);
                    if (e) {
                        e._implementation = this.i.yAxis;
                    }
                    this.i.yAxis.externalObject = e;
                }
                return this.i.yAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxVerticalAnchoredCategorySeriesComponent.prototype, "isVertical", {
            /**
             * Gets whether or not the current series is vertical series
            */
            get: function () {
                return this.i.isVertical;
            },
            enumerable: false,
            configurable: true
        });
        IgxVerticalAnchoredCategorySeriesComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxVerticalAnchoredCategorySeriesComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g4(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.g6(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getSeriesValueMarkerBoundingBox = function (world) {
            var iv = this.i.pd(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.f8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the index of the item that resides at the provided world coordinates.
        
        * @param world  * The world coordinates of the requested item.
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.t1(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxVerticalAnchoredCategorySeriesComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.t0(axis);
            return (iv);
        };
        IgxVerticalAnchoredCategorySeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxVerticalAnchoredCategorySeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxVerticalAnchoredCategorySeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxVerticalAnchoredCategorySeriesComponent, selector: "ng-component", inputs: { xAxis: "xAxis", yAxis: "yAxis" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxVerticalAnchoredCategorySeriesComponent;
    }(IgxAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxVerticalAnchoredCategorySeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VerticalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalAnchoredCategorySeries, _super);
        function VerticalAnchoredCategorySeries() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.tx = null;
            return _this;
        }
        VerticalAnchoredCategorySeries.prototype.ke = function () {
            _super.prototype.ke.call(this);
            this.xAxis = null;
            this.yAxis = null;
        };
        Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "ty", {
            get: function () {
                var _this = this;
                if (this.tx == null) {
                    this.tx = i2.DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.ck.n; });
                }
                return this.tx;
            },
            enumerable: false,
            configurable: true
        });
        VerticalAnchoredCategorySeries.prototype.get_isVertical = function () {
            return true;
        };
        VerticalAnchoredCategorySeries.prototype.q2 = function () {
            return this.yAxis;
        };
        VerticalAnchoredCategorySeries.prototype.rn = function () {
            return this.xAxis;
        };
        VerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
            return this.q8.r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        VerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
            return this.yAxis.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        VerticalAnchoredCategorySeries.prototype.g4 = function (a, b) {
            return this.g5(a, b, this.q2(), i2.runOn(this, this.r1), this.valueColumn);
        };
        VerticalAnchoredCategorySeries.prototype.g6 = function (a, b) {
            return this.g7(a, b, this.q2(), i2.runOn(this, this.r1), this.valueColumn);
        };
        VerticalAnchoredCategorySeries.prototype.fu = function (a, b, c, d, e) {
            if (this.valueColumn == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.fv(a, b, this.yAxis, d, e, this.valueColumn.count, i2.runOn(this, this.r1));
        };
        VerticalAnchoredCategorySeries.prototype.bo = function () {
            if (this.bp == 0) {
                return 1;
            }
            else {
                return _super.prototype.bo.call(this);
            }
        };
        VerticalAnchoredCategorySeries.prototype.pd = function (a) {
            if (!this.hasMarkers || !this.pt()) {
                return i2.Rect.empty;
            }
            return this.ty.e$b(this, this.q3.m, a, i2.runOn(this, this.t6));
        };
        VerticalAnchoredCategorySeries.prototype.t6 = function (a) {
            return this.sv.c9(a);
        };
        VerticalAnchoredCategorySeries.prototype.ep = function (a, b) {
            if (this.eo(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        VerticalAnchoredCategorySeries.prototype.f8 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = this.q2();
            var f = new ScalerParams(0, this.ca.pg, this.bx.bu, e.cc, d);
            var g = this.q8.r(e, this.ca.pg, this.bx.bu, d);
            return this.ga(this.valueColumn, a, e, f, g, i2.runOn(this, this.r1), b, c);
        };
        VerticalAnchoredCategorySeries.prototype.o2 = function (a, b, c) {
            var d = this.q2();
            return this.o4(a, b, c, this.q8.r(d, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.rn(), d, null, null, null);
        };
        VerticalAnchoredCategorySeries.prototype.fetchXAxis = function () {
            return this.xAxis;
        };
        VerticalAnchoredCategorySeries.prototype.fetchYAxis = function () {
            return this.yAxis;
        };
        VerticalAnchoredCategorySeries.prototype.te = function (a) {
            this.xAxis = i2.typeCast(NumericXAxis.$, a);
        };
        VerticalAnchoredCategorySeries.prototype.tf = function (a) {
            this.yAxis = i2.typeCast(CategoryYAxis.$, a);
        };
        VerticalAnchoredCategorySeries.prototype.rx = function () {
            return this.xAxis != null && this.xAxis.cv();
        };
        VerticalAnchoredCategorySeries.prototype.qw = function (a, b) {
            return this.ss(a, b, this.yAxis);
        };
        VerticalAnchoredCategorySeries.prototype.fw = function (a) {
            return this.ty.e$a(this, a);
        };
        VerticalAnchoredCategorySeries.prototype.r1 = function (a) {
            return this.fy(a, this.q2());
        };
        VerticalAnchoredCategorySeries.prototype.g0 = function (a) {
            return i2.truncate(Math.round(this.fw(a)));
        };
        VerticalAnchoredCategorySeries.prototype.hh = function (a) {
            var b = this.g0(a);
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        };
        VerticalAnchoredCategorySeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case VerticalAnchoredCategorySeries.$$p[0]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                        this.k7();
                    }
                    break;
                case VerticalAnchoredCategorySeries.$$p[1]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.rc.cr.g(this.gh);
                        this.rx();
                        this.l0(false);
                        this.k7();
                    }
                    break;
                case "TrendLineType":
                    var e = i2.EnumUtil.getEnumValue(i2.TrendLineType_$type, d);
                    if (e != 0) {
                        this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.yAxis, this.mr, this, this.ck);
                    }
                    break;
            }
        };
        VerticalAnchoredCategorySeries.prototype.t1 = function (a) {
            if (i2.typeCast(CategoryYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        VerticalAnchoredCategorySeries.prototype.t0 = function (a) {
            if (i2.typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        VerticalAnchoredCategorySeries.$t = i2.markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
        VerticalAnchoredCategorySeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::t4', [NumericXAxis.$, null], 'YAxis::t5', [CategoryYAxis.$, null]]);
        return VerticalAnchoredCategorySeries;
    }(AnchoredCategorySeries));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IBarSeries_$type = new i2.Type(null, 'IBarSeries');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BarFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarFramePreparer, _super);
        function BarFramePreparer(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        var d = [c, i2.typeCast(ISupportsMarkers_$type, c), i2.typeCast(IProvidesViewport_$type, c), i2.typeCast(ISupportsErrorBars_$type, c), i2.typeCast(IBucketizer_$type, c)];
                        {
                            var f = d[0];
                            var g = d[1];
                            var h = d[2];
                            var i = d[3];
                            var j = d[4];
                            _this = _super.call(this, 1, f, g, h, i, j) || this;
                            _this.ac = new DefaultCategoryTrendlineHost();
                            if (i2.typeCast(IHasCategoryTrendline_$type, f) !== null) {
                                _this.ac = i2.typeCast(IHasCategoryTrendline_$type, f);
                            }
                            _this.ad = new DefaultSingleValueProvider();
                            if (i2.typeCast(IHasSingleValueCategory_$type, f) !== null) {
                                _this.ad = i2.typeCast(IHasSingleValueCategory_$type, f);
                            }
                        }
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        _this = _super.call(this, 1, c, d, e, f, g) || this;
                        _this.ac = new DefaultCategoryTrendlineHost();
                        if (i2.typeCast(IHasCategoryTrendline_$type, c) !== null) {
                            _this.ac = i2.typeCast(IHasCategoryTrendline_$type, c);
                        }
                        _this.ad = new DefaultSingleValueProvider();
                        if (i2.typeCast(IHasSingleValueCategory_$type, c) !== null) {
                            _this.ad = i2.typeCast(IHasSingleValueCategory_$type, c);
                        }
                    }
                    break;
            }
            return _this;
        }
        BarFramePreparer.prototype.l = function (a, b, c, d, e, f) {
            var g = b[1];
            var h = b[0];
            var i = new i2.Rect(0, g - 5, h - 5, 11, 11);
            if (!i2.isNaN_(g) && !i2.isNaN_(h) && !i2.isInfinity(g) && !i2.isInfinity(h) && c.tryAdd(i)) {
                a.m.add({ $type: i2.Point_$type, x: g, y: h });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        };
        BarFramePreparer.prototype.w = function (a, b, c) {
            if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
                return;
            }
            var d = a.k;
            var e = new ScalerParams(0, a.m, a.l, a.b.j$a, d);
            var f = new ScalerParams(0, a.m, a.l, a.c.j$a, d);
            var g = b.f;
            if (a.d != null && a.d.i$b != null) {
                g = new SafeSortedReadOnlyDoubleCollection(0, g, a.d.i$b);
            }
            var h = ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = a.h;
                $ret.d = a.i;
                $ret.e = a.j;
                $ret.a = c;
                $ret.b = a.g;
                $ret.f = a.l;
                return $ret;
            })());
            if (this.ac.trendLineType != 0) {
                this.ac.trendlinePreparer.prepareLineCore(a.a.p, this.ac.trendLineType, g, this.ac.trendLinePeriod, function (i) { return a.c.j$b(i, f); }, function (i) { return a.b.j$b(i, e); }, h);
            }
        };
        BarFramePreparer.$t = i2.markType(BarFramePreparer, 'BarFramePreparer', CategoryFramePreparer.$);
        return BarFramePreparer;
    }(CategoryFramePreparer));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BarTrendFitCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarTrendFitCalculator, _super);
        function BarTrendFitCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BarTrendFitCalculator.a = function (a, b, c, d, e, f, g, h, i, j, k) {
            if (d == null) {
                switch (b) {
                    case 1:
                        d = i2.LeastSquaresFit.k(e, g, f);
                        break;
                    case 2:
                        d = i2.LeastSquaresFit.o(e, g, f);
                        break;
                    case 3:
                        d = i2.LeastSquaresFit.i(e, g, f);
                        break;
                    case 4:
                        d = i2.LeastSquaresFit.p(e, g, f);
                        break;
                    case 5:
                        d = i2.LeastSquaresFit.q(e, g, f);
                        break;
                    case 7:
                        d = i2.LeastSquaresFit.j(e, g, f);
                        break;
                    case 6:
                        d = i2.LeastSquaresFit.l(e, g, f);
                        break;
                    case 8:
                        d = i2.LeastSquaresFit.n(e, g, f);
                        break;
                    default: throw new i2.NotImplementedException(0);
                }
            }
            if (d == null) {
                return null;
            }
            for (var l = 0; l < c.f.height; l += 2) {
                var m = l / (c.f.height - 1);
                var n = j + m * (k - j);
                var o = NaN;
                switch (b) {
                    case 1:
                        o = i2.LeastSquaresFit.ad(d, n);
                        break;
                    case 2:
                        o = i2.LeastSquaresFit.ah(d, n);
                        break;
                    case 3:
                        o = i2.LeastSquaresFit.ab(d, n);
                        break;
                    case 4:
                        o = i2.LeastSquaresFit.ai(d, n);
                        break;
                    case 5:
                        o = i2.LeastSquaresFit.aj(d, n);
                        break;
                    case 7:
                        o = i2.LeastSquaresFit.ac(d, n);
                        break;
                    case 6:
                        o = i2.LeastSquaresFit.ae(d, n);
                        break;
                    case 8:
                        o = i2.LeastSquaresFit.ag(d, n);
                        break;
                    default: throw new i2.NotImplementedException(0);
                }
                o = h(o);
                n = i(n);
                if (!i2.isNaN_(o) && !i2.isInfinity(o)) {
                    a.add({ $type: i2.Point_$type, x: o, y: n + c.a });
                }
            }
            return d;
        };
        BarTrendFitCalculator.$t = i2.markType(BarTrendFitCalculator, 'BarTrendFitCalculator');
        return BarTrendFitCalculator;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BarTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarTrendLineManager, _super);
        function BarTrendLineManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BarTrendLineManager.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
            var h = g.d * g.c;
            var i = g.e * g.c;
            var j = new i2.List$1(i2.Point_$type, 0);
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = BarTrendFitCalculator.a(j, b, g, this.a, c.count, function (k) { return c.item(k); }, function (k) { return k + 1; }, e, function (k) { return f(k - 1); }, h + 1, i + 1);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.b(b, this.d, c, d);
                for (var k = g.d; k <= g.e; k += 1) {
                    var l = k * g.c;
                    if (l >= 0 && l < this.d.count) {
                        var m = e(this.d._inner[l]);
                        var n = f(l);
                        j.add({ $type: i2.Point_$type, x: m, y: n + g.a });
                    }
                }
            }
            this.e(j, g, a);
        };
        BarTrendLineManager.$t = i2.markType(BarTrendLineManager, 'BarTrendLineManager', CategoryTrendLineManager.$);
        return BarTrendLineManager;
    }(CategoryTrendLineManager));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarSeries, _super);
        function BarSeries() {
            var _this = _super.call(this) || this;
            _this.ab = BarSeries.$;
            _this.q8 = new BarFramePreparer(1, _this, _this.t7, _this, _this, _this.t7.cr);
            return _this;
        }
        BarSeries.prototype.get_c9 = function () {
            return true;
        };
        BarSeries.prototype.get_dw = function () {
            return true;
        };
        BarSeries.prototype.bu = function () {
            return new BarSeriesView(this);
        };
        BarSeries.prototype.rd = function () {
            return 1;
        };
        BarSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t7 = a;
        };
        BarSeries.prototype.get_cy = function () {
            return true;
        };
        BarSeries.prototype.pb = function (a) {
            if (this.xAxis == null || this.yAxis == null || this.q3.f.count == 0) {
                return i2.Rect.empty;
            }
            var b = this.bx.bv;
            var c = this.bx.bu;
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, b, c, this.xAxis.cc, d);
            var f = this.ox(a);
            var g = this.g6(a, true);
            var h = this.g4(a, true);
            var i = i2.truncate(Math.floor(g / this.r3(this.bx)));
            var j = i2.truncate(Math.floor(h / this.r3(this.bx)));
            var k = i - this.r4(this.bx);
            var l = j - this.r4(this.bx);
            if (k < 0) {
                k = 0;
            }
            if (k > this.q3.f.count - 1) {
                k = this.q3.f.count - 1;
            }
            if (l < 0) {
                l = 0;
            }
            if (l > this.q3.f.count - 1) {
                l = this.q3.f.count - 1;
            }
            var m = this.q3.f._inner[k];
            var n = this.q3.f._inner[l];
            var o = Math.abs(f.y - m[0]);
            var p = Math.abs(f.y - n[0]);
            var q = this.s4(this.rc);
            var r = this.yAxis.ki(b, c, d);
            if (o < p) {
                var s = m[0] - 0.5 * r;
                var t = m[1];
                var u = q;
                return new i2.Rect(0, Math.min(u, t), s, Math.max(u, t) - Math.min(u, t), r);
            }
            else {
                var v = n[0] - 0.5 * r;
                var w = n[1];
                var x = q;
                return new i2.Rect(0, Math.min(x, w), v, Math.max(x, w) - Math.min(x, w), r);
            }
        };
        BarSeries.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        BarSeries.prototype.q9 = function (a) {
            var b = i2.typeCast(CategorySeriesView.$, a);
            if (b != null && b.q) {
                if (b.p) {
                    return new BarFramePreparer(1, this, i2.typeCast(ISupportsMarkers_$type, b), b, this, b.cr);
                }
                else {
                    return new BarFramePreparer(1, this, i2.typeCast(ISupportsMarkers_$type, b), this.ca.cf.o, this, b.cr);
                }
            }
            else {
                return this.q8;
            }
        };
        BarSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
        };
        BarSeries.prototype.preferredCategoryMode = function (a) {
            return 2;
        };
        BarSeries.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = i2.typeCast(BarSeriesView.$, b);
            if (a && c != null && c.db != null) {
                c.db.count = 0;
            }
        };
        BarSeries.prototype.r6 = function () {
            var e_1, _a;
            var a = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b == this) {
                        return a;
                    }
                    var c = i2.typeCast(IBarSeries_$type, b);
                    if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                        a++;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return -1;
        };
        BarSeries.prototype.s4 = function (a) {
            var b = 0;
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(a);
            if (!c.isEmpty && !d.isEmpty && this.xAxis != null) {
                var f = new ScalerParams(0, c, d, this.xAxis.cc, e);
                b = this.xAxis.d8(this.xAxis.k5, f);
            }
            return b;
        };
        BarSeries.prototype.ap = function (a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.yAxis) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.xAxis) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        };
        BarSeries.prototype.eh = function (a) {
            var b = this.bx.bv;
            b = b.copy();
            var c = this.bx.bu;
            var d = new i2.Rect(0, 0, 0, 1, 1);
            var e = !b.isEmpty && !c.isEmpty && this.ch != null ? this.ch.indexOf(a) : -1;
            var f = this.o9(this.bx);
            var g = new ScalerParams(0, d, d, this.xAxis.cc, f);
            var h = new ScalerParams(0, d, d, this.yAxis.cc, f);
            var i = this.yAxis != null ? this.yAxis.d8(e, h) : NaN;
            var j = this.yAxis != null ? this.q8.r(this.yAxis, d, d, f) : 0;
            i += j;
            var k = this.xAxis != null && this.valueColumn != null && e < this.valueColumn.count ? this.xAxis.d8(this.valueColumn.item(e), g) : NaN;
            if (!i2.isNaN_(k)) {
                if (k < b.left + 0.1 * b.width) {
                    k = k + 0.4 * b.width;
                    b.x = k - 0.5 * b.width;
                }
                if (k > b.right - 0.1 * b.width) {
                    k = k - 0.4 * b.width;
                    b.x = k - 0.5 * b.width;
                }
            }
            if (!i2.isNaN_(i)) {
                if (i < b.top + 0.1 * b.height) {
                    i = i + 0.4 * b.height;
                    b.y = i - 0.5 * b.height;
                }
                if (i > b.bottom - 0.1 * b.height) {
                    i = i - 0.4 * b.height;
                    b.y = i - 0.5 * b.height;
                }
            }
            if (this.b5 != null) {
                this.b5.ap(this.ca, b, true);
            }
            return e >= 0;
        };
        BarSeries.prototype.f1 = function () {
            return this.yAxis.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        BarSeries.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = a.f;
            if (!b.o()) {
                return;
            }
            var d = b.bv;
            var e = b.bu;
            var f = this.getEffectiveViewport1(b);
            var g = new ScalerParams(0, d, e, this.xAxis.cc, f);
            var h = this.yAxis;
            var i = new ScalerParams(0, d, e, this.yAxis.cc, f);
            var j = this.xAxis;
            var k = j.d8(j.k5, g);
            var l = this.yAxis.ki(d, e, f);
            var m = i2.typeCast(BarSeriesView.$, b);
            if (i2.isNaN_(l) || i2.isInfinity(l) || i2.isNaN_(k)) {
                m.db.count = 0;
                return;
            }
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            this.rb.r = this.t8;
            this.rb.s = this.t9;
            this.rb.k = this.t8;
            this.rb.l = this.t9;
            var n = false;
            var o = this.rb.b;
            if (o != null) {
                n = true;
            }
            var p = this.xAxis.ch;
            var q = this.valueColumn.count;
            for (var r = 0; r < c.count; ++r) {
                var s = c._inner[r][0] - 0.5 * l;
                var t = c._inner[r][1];
                var u = k;
                u = Math.max(u, -100);
                t = Math.min(t, e.right + 100);
                var v = m.db.item(r);
                v.height = l;
                v.width = Math.abs(t - u);
                if (n) {
                    this.sh(c, r, q, h, i, b.q);
                }
                this.rb.ad(v, false, false, false, false);
                v.am = this.rb.k;
                v.an = this.rb.l;
                m.dg(v, Math.min(t, u), s);
            }
            m.db.count = c.count;
            b.cy(a);
        };
        BarSeries.prototype.kk = function (a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.sv.cr.g(this.gh);
                    break;
            }
            if (this.sv.c3) {
                this.sv.c2.g$e(a, b, c, d);
            }
            switch (a) {
                case 4:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
                case 1:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
                case 0:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
                case 2:
                    if (this.tb != null && this.sv.cr.d > 0) {
                        this.l0(true);
                    }
                    break;
                case 3:
                    if (d == this.tb) {
                        if (this.xAxis != null && !this.xAxis.cv()) {
                            this.l0(true);
                        }
                    }
                    break;
            }
        };
        BarSeries.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case VerticalAnchoredCategorySeries.$$p[0]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    this.sv.cr.g(this.gh);
                    if (this.xAxis != null && this.xAxis.cv()) {
                        this.l0(false);
                    }
                    break;
                case VerticalAnchoredCategorySeries.$$p[1]:
                    if (c != null) {
                        c.bx(this);
                    }
                    if (d != null) {
                        d.cn(this);
                    }
                    if (this.sv.c3) {
                        this.sv.c2 = CategoryTrendLineManagerFactory.a(this.sv.c2, this.yAxis, this.mr, this, this.ck);
                    }
                    this.sv.cr.g(this.gh);
                    this.l0(false);
                    break;
                case "FastItemsSource":
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.sv.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case "ValueColumn":
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.sv.cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        this.kl(this.xAxis);
                        this.kl(this.yAxis);
                    }
                    if (c == null && d != null) {
                        this.lr(this.xAxis);
                        this.lr(this.yAxis);
                    }
                    this.sv.cr.g(this.gh);
                    this.l0(false);
                    break;
            }
        };
        BarSeries.prototype.getPreferredCategoryMode = function () {
            return this.preferredCategoryMode(this.yAxis);
        };
        Object.defineProperty(BarSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        BarSeries.$t = i2.markType(BarSeries, 'BarSeries', VerticalAnchoredCategorySeries.$, [IBarSeries_$type]);
        BarSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, BarSeries, 'raisePropertyChanged', ['RadiusX:t8:uc', [1, 0], 'RadiusY:t9:ud', [1, 0]]);
        return BarSeries;
    }(VerticalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var BarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarBucketCalculator, _super);
        function BarBucketCalculator(a) {
            var _this = _super.call(this, a) || this;
            _this.i = null;
            _this.h = null;
            _this.j = 0;
            _this.i = a;
            return _this;
        }
        BarBucketCalculator.prototype.g = function (a) {
            var b = this.c.bv;
            var c = this.c.bu;
            var d = this.c.ct.ch;
            if (b.isEmpty || c.isEmpty || this.i.da.yAxis == null || d == null || d.count == 0) {
                this.d = 0;
                return;
            }
            var e = i2.typeCast(BarSeries.$, this.c.ct);
            var f = e.o7(this.c);
            var g = e.getEffectiveViewport1(this.c);
            var h = new ScalerParams(0, b, c, e.yAxis.cc, g);
            var i = Math.floor(e.yAxis.ec(f.top, h, 0));
            var j = Math.ceil(e.yAxis.ec(f.bottom, h, 0));
            if (!e.yAxis.cc) {
                j = Math.ceil(e.yAxis.ec(f.top, h, 0));
                i = Math.floor(e.yAxis.ec(f.bottom, h, 0));
            }
            var k = Math.floor((j - i + 1) * a / f.height);
            this.d = i2.truncate(Math.max(1, k));
            this.e = i2.truncate(Math.max(0, Math.floor(i / this.d) - 1));
            this.f = i2.truncate(Math.ceil(j / this.d));
        };
        BarBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            var b = this.h;
            var c = this.j;
            var d = a * this.d;
            var e = d + this.d - 1;
            var f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            var g = 1.7976931348623157E+308;
            var h = -1.7976931348623157E+308;
            var i = true;
            for (var j = d; j <= e; ++j) {
                var k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                Math.max(h, k);
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        };
        BarBucketCalculator.prototype.getBucket = function (a) {
            var b = this.h;
            var c = this.j;
            var d = a * this.d;
            var e = d + this.d - 1;
            var f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            var g = NaN;
            var h = NaN;
            for (var i = d; i <= e; ++i) {
                var j = b[i];
                if (!i2.isNaN_(g)) {
                    if (!i2.isNaN_(j)) {
                        g = Math.min(g, j);
                        h = Math.max(h, j);
                    }
                }
                else {
                    g = j;
                    h = j;
                }
            }
            if (!i2.isNaN_(g)) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        };
        BarBucketCalculator.prototype.cacheValues = function () {
            this.j = this.i.da.valueColumn.count;
            this.h = this.i.da.valueColumn.asArray();
        };
        BarBucketCalculator.prototype.unCacheValues = function () {
            this.h = null;
        };
        BarBucketCalculator.$t = i2.markType(BarBucketCalculator, 'BarBucketCalculator', CategoryBucketCalculator.$);
        return BarBucketCalculator;
    }(CategoryBucketCalculator));
    /**
     * @hidden
     */
    var BarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarSeriesView, _super);
        function BarSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.db = null;
            _this.dc = null;
            _this.dh = new i2.Rectangle();
            _this.da = a;
            _this.db = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.di);
                $ret.activate = i2.runOn(_this, _this.dd);
                $ret.disactivate = i2.runOn(_this, _this.df);
                $ret.destroy = i2.runOn(_this, _this.de);
                return $ret;
            })());
            _this.c2 = new BarTrendLineManager();
            return _this;
        }
        BarSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            this.dc = new i2.List$1(i2.Rectangle.$, 0);
            if (!this.q) {
                this.da.pr = Defaults.c;
                this.da.gh = Defaults.h;
                this.da.gm = Defaults.i;
            }
        };
        BarSeriesView.prototype.di = function () {
            var a = new i2.Rectangle();
            this.dc.add(a);
            a._visibility = 1;
            return a;
        };
        BarSeriesView.prototype.dd = function (a) {
            a._visibility = 0;
        };
        BarSeriesView.prototype.df = function (a) {
            a._visibility = 1;
        };
        BarSeriesView.prototype.de = function (a) {
            this.dc.remove(a);
        };
        BarSeriesView.prototype.dg = function (a, b, c) {
            if (!this.isDirty) {
                this.aq();
            }
            a.o = c;
            a.n = b;
        };
        BarSeriesView.prototype.cs = function () {
            return new BarBucketCalculator(this);
        };
        BarSeriesView.prototype.bf = function (a, b) {
            _super.prototype.bf.call(this, a, b);
            var c = a;
            var d = this.bp(b);
            c._fill = d;
            c._stroke = d;
            c.ac = this.e.fl;
        };
        BarSeriesView.prototype.ac = function (a) {
            return this.dc._inner[a];
        };
        BarSeriesView.prototype.ab = function (a) {
            var b = this.dc._inner[a];
            this.dh.n = b.n;
            this.dh.o = b.o;
            this.dh.width = b.width;
            this.dh.height = b.height;
            var c = this.bp(a);
            this.dh._fill = c;
            this.dh._stroke = c;
            this.dh.ac = this.e.fl + 3;
            return this.dh;
        };
        BarSeriesView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.dc.count; c++) {
                    var d = this.aa(c, b);
                    this.bd(d, c, b);
                    a.v(d);
                }
            }
        };
        BarSeriesView.prototype.al = function (a) {
            var e_2, _a, e_3, _b;
            _super.prototype.al.call(this, a);
            var b = 0;
            var c = new i2.List$1(i2.Rectangle.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.db.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    c.add(d);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            c.aa(function (e, f) {
                if (e.o > f.o) {
                    return -1;
                }
                else if (e.o < f.o) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    this.e.a6.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            b++;
        };
        BarSeriesView.prototype.af = function () {
            var a = new i2.Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.or = a;
            this.e.gj = 5;
            this.e.gk = 5;
            this.e.gl = -5;
        };
        BarSeriesView.$t = i2.markType(BarSeriesView, 'BarSeriesView', AnchoredCategorySeriesView.$);
        return BarSeriesView;
    }(AnchoredCategorySeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent bar series.
    */
    var IgxBarSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxBarSeriesComponent, _super);
        function IgxBarSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxBarSeriesComponent.prototype.createImplementation = function () {
            return new BarSeries();
        };
        Object.defineProperty(IgxBarSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarSeriesComponent.prototype, "isBar", {
            /**
             * Gets whether the current series shows a bar shape.
            */
            get: function () {
                return this.i.c9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
            */
            get: function () {
                return this.i.t8;
            },
            set: function (v) {
                this.i.t8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
            */
            get: function () {
                return this.i.t9;
            },
            set: function (v) {
                this.i.t9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
        IgxBarSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        */
        IgxBarSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxBarSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxBarSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxBarSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxBarSeriesComponent, selector: "igx-bar-series", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxVerticalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxBarSeriesComponent;
    }(IgxVerticalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-bar-series',
                        template: "",
                        providers: [{ provide: IgxVerticalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBarSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBarSeriesModule() {
        }
        IgxBarSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBarSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesModule, declarations: [IgxBarSeriesComponent], imports: [i1.CommonModule], exports: [IgxBarSeriesComponent] });
        IgxBarSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesModule, imports: [[i1.CommonModule]] });
        return IgxBarSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxBarSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxBarSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBarSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBarSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxBarSeriesComponent", IgxBarSeriesComponent);
            i2.TypeRegistrar.register("BarSeries", BarSeries.$type);
        }
        IgxBarSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBarSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesDynamicModule, imports: [i1.CommonModule, IgxBarSeriesModule], exports: [IgxBarSeriesModule] });
        IgxBarSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesDynamicModule, imports: [[i1.CommonModule, IgxBarSeriesModule], IgxBarSeriesModule] });
        return IgxBarSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxBarSeriesModule],
                        exports: [IgxBarSeriesModule],
                        entryComponents: [IgxBarSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartVerticalCategoryModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartVerticalCategoryModule() {
        }
        IgxDataChartVerticalCategoryModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartVerticalCategoryModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryModule, imports: [i1.CommonModule, IgxBarSeriesModule,
                IgxDataChartVerticalCategoryCoreModule], exports: [IgxBarSeriesModule,
                IgxDataChartVerticalCategoryCoreModule] });
        IgxDataChartVerticalCategoryModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryModule, imports: [[i1.CommonModule, IgxBarSeriesModule,
                    IgxDataChartVerticalCategoryCoreModule
                ], IgxBarSeriesModule,
                IgxDataChartVerticalCategoryCoreModule] });
        return IgxDataChartVerticalCategoryModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxBarSeriesModule,
                            IgxDataChartVerticalCategoryCoreModule
                        ],
                        imports: [i1.CommonModule, IgxBarSeriesModule,
                            IgxDataChartVerticalCategoryCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartVerticalCategoryDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartVerticalCategoryDynamicModule() {
        }
        IgxDataChartVerticalCategoryDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartVerticalCategoryDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryDynamicModule, imports: [i1.CommonModule, IgxBarSeriesDynamicModule,
                IgxDataChartVerticalCategoryCoreDynamicModule,
                IgxDataChartVerticalCategoryModule], exports: [IgxBarSeriesDynamicModule,
                IgxDataChartVerticalCategoryCoreDynamicModule,
                IgxDataChartVerticalCategoryModule] });
        IgxDataChartVerticalCategoryDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryDynamicModule, imports: [[i1.CommonModule, IgxBarSeriesDynamicModule,
                    IgxDataChartVerticalCategoryCoreDynamicModule,
                    IgxDataChartVerticalCategoryModule
                ], IgxBarSeriesDynamicModule,
                IgxDataChartVerticalCategoryCoreDynamicModule,
                IgxDataChartVerticalCategoryModule] });
        return IgxDataChartVerticalCategoryDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVerticalCategoryDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxBarSeriesDynamicModule,
                            IgxDataChartVerticalCategoryCoreDynamicModule,
                            IgxDataChartVerticalCategoryModule
                        ],
                        imports: [i1.CommonModule, IgxBarSeriesDynamicModule,
                            IgxDataChartVerticalCategoryCoreDynamicModule,
                            IgxDataChartVerticalCategoryModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var IStacked100Series_$type = new i2.Type(null, 'IStacked100Series');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StackedSeriesCreatedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesCreatedEventArgs, _super);
        function StackedSeriesCreatedEventArgs(a) {
            var _this = _super.call(this) || this;
            _this.c = null;
            _this.c = a;
            return _this;
        }
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "brush", {
            get: function () {
                return this.c.hx;
            },
            set: function (a) {
                this.c.hx = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemTemplate", {
            get: function () {
                return this.c.fj;
            },
            set: function (a) {
                this.c.fj = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemBadgeTemplate", {
            get: function () {
                return this.c.fi;
            },
            set: function (a) {
                this.c.fi = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemVisibility", {
            get: function () {
                return this.c.iw;
            },
            set: function (a) {
                this.c.iw = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "outline", {
            get: function () {
                return this.c.h1;
            },
            set: function (a) {
                this.c.h1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "dashArray", {
            get: function () {
                return this.c.h6;
            },
            set: function (a) {
                this.c.h6 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "dashCap", {
            get: function () {
                return this.c.ia;
            },
            set: function (a) {
                this.c.ia = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "index", {
            get: function () {
                return this.c.br;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "thickness", {
            get: function () {
                return this.c.bl;
            },
            set: function (a) {
                this.c.bl = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "title", {
            get: function () {
                return this.c.bv;
            },
            set: function (a) {
                this.c.bv = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerBrush", {
            get: function () {
                return this.c.hy;
            },
            set: function (a) {
                this.c.hy = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerOutline", {
            get: function () {
                return this.c.hz;
            },
            set: function (a) {
                this.c.hz = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerStyle", {
            get: function () {
                return this.c.it;
            },
            set: function (a) {
                this.c.it = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerTemplate", {
            get: function () {
                return this.c.fk;
            },
            set: function (a) {
                this.c.fk = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerType", {
            get: function () {
                return this.c.r;
            },
            set: function (a) {
                this.c.r = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerThickness", {
            get: function () {
                return this.c.be;
            },
            set: function (a) {
                this.c.be = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "startCap", {
            get: function () {
                return this.c.h9;
            },
            set: function (a) {
                this.c.ic = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "endCap", {
            get: function () {
                return this.c.h8;
            },
            set: function (a) {
                this.c.ib = a;
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesCreatedEventArgs.$t = i2.markType(StackedSeriesCreatedEventArgs, 'StackedSeriesCreatedEventArgs', i2.EventArgs.$);
        return StackedSeriesCreatedEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var FragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FragmentBase, _super);
        function FragmentBase() {
            var _this = _super.call(this) || this;
            _this.ug = null;
            _this._logicalSeriesLink = null;
            _this.ui = null;
            _this.ug = new CategoryLineRasterizer();
            return _this;
        }
        Object.defineProperty(FragmentBase.prototype, "logicalSeriesLink", {
            get: function () {
                return this._logicalSeriesLink;
            },
            set: function (a) {
                this._logicalSeriesLink = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FragmentBase.prototype, "parentSeries", {
            get: function () {
                return this.ui;
            },
            set: function (a) {
                this.ui = a;
            },
            enumerable: false,
            configurable: true
        });
        FragmentBase.prototype.get_dh = function () {
            return false;
        };
        FragmentBase.prototype.get_dn = function () {
            return true;
        };
        FragmentBase.prototype.i9 = function () {
            if (this.logicalSeriesLink != null) {
                return this.logicalSeriesLink.dk;
            }
            return null;
        };
        FragmentBase.prototype.gz = function () {
            var a = this.parentSeries;
            if (a.g9 == -1 || a.s0 == null || a.s0.f.indexOf(this) == -1) {
                return -1;
            }
            return a.s0.f.indexOf(this);
        };
        FragmentBase.prototype.g3 = function () {
            var a = this.parentSeries;
            if (a.g9 == -1 || a.series.count == 0 || a.series.indexOf(this.logicalSeriesLink) == -1) {
                return -1;
            }
            return a.series.indexOf(this.logicalSeriesLink);
        };
        FragmentBase.prototype.resolveLegendIndex = function () {
            var a = this.parentSeries;
            if (a.s4) {
                return -1 + a.g9 + a.sw.count - a.s0.f.indexOf(this);
            }
            return _super.prototype.resolveLegendIndex.call(this);
        };
        FragmentBase.prototype.be = function () {
            return this.parentSeries;
        };
        FragmentBase.prototype.q2 = function () {
            if (this.parentSeries == null) {
                return null;
            }
            return this.parentSeries.fetchXAxis();
        };
        FragmentBase.prototype.uf = function () {
            if (this.parentSeries == null) {
                return this.q8;
            }
            return this.parentSeries.q8;
        };
        FragmentBase.prototype.rn = function () {
            if (this.parentSeries == null) {
                return null;
            }
            return this.parentSeries.fetchYAxis();
        };
        FragmentBase.prototype.uk = function (a, b, c, d, e, f, g, h) {
            var i = c[0];
            var j = c[1];
            var k = new i2.Rect(0, i - 5, j - 5, 11, 11);
            if (!i2.isNaN_(i) && !i2.isNaN_(j) && !i2.isInfinity(i) && !i2.isInfinity(j) && d.tryAdd(k)) {
                b.m.add({ $type: i2.Point_$type, x: i, y: j });
                a.updateMarkerTemplate(g, f, h);
                return true;
            }
            return false;
        };
        FragmentBase.prototype.si = function (a, b) {
            a.u();
            if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null) {
                return;
            }
            if (this.logicalSeriesLink.aq.count == 0 || this.logicalSeriesLink.ap.count == 0) {
                return;
            }
            this.q9(b).d(a, b);
        };
        FragmentBase.prototype.o2 = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.uf().r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.rn(), this.q2(), i2.runOn(this, this.ul), function (d, e) { return _this.g7(d, e, _this.q2(), i2.runOn(_this, _this.r1), _this.valueColumn != null ? new FragmentBaseValueList(_this) : null); }, function (d, e) { return _this.g5(d, e, _this.q2(), i2.runOn(_this, _this.r1), _this.valueColumn != null ? new FragmentBaseValueList(_this) : null); });
        };
        FragmentBase.prototype.ag = function () {
            return [this.q2(), this.rn()];
        };
        FragmentBase.prototype.ul = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.ca.pg, this.bx.bu, this.q2().cc, d);
            var f = this.q8.r(this.q2(), this.ca.pg, this.bx.bu, d);
            return this.ga(this.valueColumn != null ? new FragmentBaseValueList(this) : null, a, this.q2(), e, f, i2.runOn(this, this.r1), b, c);
        };
        FragmentBase.prototype.un = function (a, b, c) {
            var d = this.s4(c);
            var e = d;
            var f = this.logicalSeriesLink.aj;
            var g = f ? this.parentSeries.s0.e : this.parentSeries.s0.d;
            var h = g.indexOf(this);
            if (a.count == 0) {
                return;
            }
            if (h == -1) {
                return;
            }
            var i = false;
            for (var j = h; j >= 0; j--) {
                if (i) {
                    break;
                }
                if (j == 0) {
                    a.add({ $type: i2.Point_$type, x: a._inner[a.count - 1].x, y: e });
                    a.add({ $type: i2.Point_$type, x: a._inner[0].x, y: e });
                    break;
                }
                var k = i2.typeCast(FragmentBase.$, g._inner[j - 1]);
                if (k != null && k.ug != null && k.ug.o.count > 0 && this.bx != null && k.e3(this.bx.bu, this.bx.bv, this.bx)) {
                    i = true;
                    for (var l = k.ug.o.count - 1; l >= 0; l--) {
                        a.add(k.ug.o._inner[l]);
                    }
                }
            }
        };
        FragmentBase.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            var e = i2.typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
            var f = this.parentSeries.fetchYAxis();
            if (this.parentSeries == null || e == null || e.itemsSource == null || f == null || this.parentSeries.ch == null || e.bh == null || f.bh == null) {
                d = false;
            }
            if (this.valueColumn == null) {
                return false;
            }
            if (i2.isInfinity(this.valueColumn.minimum) && i2.isInfinity(this.valueColumn.maximum)) {
                d = false;
            }
            if (i2.isNaN_(this.valueColumn.minimum) && i2.isNaN_(this.valueColumn.maximum)) {
                d = false;
            }
            return d;
        };
        FragmentBase.prototype.s4 = function (a) {
            var b = 0;
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(a);
            var f = new ScalerParams(0, c, d, this.yAxis.cc, e);
            f.b = this.f2();
            if (!c.isEmpty && !d.isEmpty && this.yAxis != null) {
                b = this.yAxis.d8(0, f);
            }
            return b;
        };
        FragmentBase.prototype.ap = function (a) {
            return null;
        };
        FragmentBase.prototype.um = function () {
            if (this.parentSeries == null) {
                return -1;
            }
            var a = this.parentSeries.g9;
            var b = 0;
            var c = 1;
            if (this.parentSeries.s4) {
                b = this.parentSeries.sw.count - 1;
                c = -1;
            }
            for (var d = b; this.parentSeries.s4 ? d >= 0 : d < this.parentSeries.sw.count; d += c) {
                var e = this.parentSeries.sw._inner[d];
                if (e.visualSeriesLink == this) {
                    return a;
                }
                if (this.parentSeries.a0 == null || e.iv != 0 || e.iu != 0) {
                    continue;
                }
                a++;
            }
            return -1;
        };
        FragmentBase.prototype.uo = function (a) {
            if (a == null) {
            }
        };
        FragmentBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.parentSeries == null) {
                return;
            }
            var e = i2.typeCast(NumericAxisBase.$, this.parentSeries.fetchYAxis());
            if (e == null) {
                return;
            }
            switch (b) {
                case "ValueColumn":
                    if (this.sv.c3) {
                        this.sv.c2.g$i();
                    }
                    if (e != null && !e.cv()) {
                        this.parentSeries.sv().cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
                case "ActualBrush":
                    if (this.logicalSeriesLink != null) {
                        this.logicalSeriesLink.hs = this.of;
                    }
                    break;
            }
        };
        FragmentBase.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
        };
        Object.defineProperty(FragmentBase.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        FragmentBase.$t = i2.markType(FragmentBase, 'FragmentBase', HorizontalAnchoredCategorySeries.$);
        return FragmentBase;
    }(HorizontalAnchoredCategorySeries));
    /**
     * @hidden
     */
    var AreaFragment = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AreaFragment, _super);
        function AreaFragment() {
            var _this = _super.call(this) || this;
            _this.ab = AreaFragment.$;
            return _this;
        }
        AreaFragment.prototype.bu = function () {
            return new AreaFragmentView(this);
        };
        AreaFragment.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.up = a;
        };
        AreaFragment.prototype.get_c8 = function () {
            return true;
        };
        AreaFragment.prototype.get_c7 = function () {
            return true;
        };
        AreaFragment.prototype.ur = function (a, b) {
            var c = this.up.dg.ak;
            if (this.er(a, c)) {
                return true;
            }
            var d = this.up.dh.ak;
            if (this.er(a, d)) {
                return true;
            }
            return false;
        };
        AreaFragment.prototype.ep = function (a, b) {
            if (this.uq(a, b)) {
                return true;
            }
            if (this.ur(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        AreaFragment.prototype.uq = function (a, b) {
            var c = this.up.di.ak;
            if (this.eq(a, b, c)) {
                return true;
            }
            var d = this.up.dj.ak;
            if (this.eq(a, b, d)) {
                return true;
            }
            return false;
        };
        AreaFragment.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        AreaFragment.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.db();
        };
        AreaFragment.prototype.sl = function (a, b) {
            var _this = this;
            _super.prototype.sl.call(this, a, b);
            this.ug.a = i2.typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
            var c = i2.typeCast(AreaFragmentView.$, b);
            var d = a.f;
            var e = this.getEffectiveViewport1(c);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var f = false;
            var g = this.rb.b;
            if (g != null) {
                f = true;
            }
            if (f) {
                var h = new ScalerParams(0, b.bv, b.bu, this.tw.cc, e);
                this.sh(d, -1, this.valueColumn.count, this.tw, h, b.q);
            }
            this.rb.ad(c.di, true, false, true, true);
            this.rb.ad(c.dj, true, false, true, true);
            this.rb.ad(c.dg, false, true, false, false);
            this.rb.ad(c.dh, false, true, false, false);
            var i = c.cr.d;
            this.ug.i(c.dg, c.di, c.dh, c.dj, a.f.count, a.f, true, i, this.gh, function (j, k, l, m, n) { return _this.un(j, a.f, b); }, 0);
            c.dg._opacity = this.rb.j * this.fi;
            c.dh._opacity = 0.5 * this.rb.j * this.fi;
        };
        AreaFragment.prototype.ma = function () {
            var a = (i2.typeCast(XamDataChart.$, this.ca));
            if (a != null) {
                this.fi = i2.isNaN_(this.fq) ? this.parentSeries.fi : this.fq;
            }
        };
        Object.defineProperty(AreaFragment.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        AreaFragment.$t = i2.markType(AreaFragment, 'AreaFragment', FragmentBase.$);
        return AreaFragment;
    }(FragmentBase));
    /**
     * @hidden
     */
    var ColumnFragment = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColumnFragment, _super);
        function ColumnFragment() {
            var _this = _super.call(this) || this;
            _this.ab = ColumnFragment.$;
            return _this;
        }
        ColumnFragment.prototype.get_db = function () {
            return true;
        };
        ColumnFragment.prototype.get_dw = function () {
            return true;
        };
        ColumnFragment.prototype.bu = function () {
            return new ColumnFragmentView(this);
        };
        ColumnFragment.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.uq = a;
        };
        Object.defineProperty(ColumnFragment.prototype, "fragmentXAxis", {
            get: function () {
                return this.parentSeries != null ? i2.typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis()) : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ColumnFragment.prototype, "fragmentYAxis", {
            get: function () {
                return this.parentSeries != null ? i2.typeCast(NumericYAxis.$, this.parentSeries.fetchYAxis()) : null;
            },
            enumerable: false,
            configurable: true
        });
        ColumnFragment.prototype.preferredCategoryMode = function (a) {
            return 2;
        };
        ColumnFragment.prototype.q2 = function () {
            return this.fragmentXAxis;
        };
        ColumnFragment.prototype.rn = function () {
            return this.fragmentYAxis;
        };
        ColumnFragment.prototype.get_cy = function () {
            return true;
        };
        ColumnFragment.prototype.fetchXAxis = function () {
            return null;
        };
        ColumnFragment.prototype.fetchYAxis = function () {
            return null;
        };
        ColumnFragment.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            if (a && c.db != null) {
                this.q3.m.clear();
                c.db.count = 0;
            }
        };
        ColumnFragment.prototype.ap = function (a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        };
        ColumnFragment.prototype.e3 = function (a, b, c) {
            if (this.parentSeries == null) {
                return false;
            }
            return this.parentSeries.s5(this, a, b, this.us(c));
        };
        ColumnFragment.prototype.e0 = function () {
            return true;
        };
        ColumnFragment.prototype.r3 = function (a) {
            if (this.parentSeries != null) {
                return this.parentSeries.r3(this.parentSeries.bx);
            }
            return _super.prototype.r3.call(this, a);
        };
        ColumnFragment.prototype.r4 = function (a) {
            if (this.parentSeries != null) {
                return this.parentSeries.r4(this.parentSeries.bx);
            }
            return _super.prototype.r3.call(this, a);
        };
        ColumnFragment.prototype.r5 = function (a) {
            if (this.parentSeries != null) {
                return this.parentSeries.r5(this.parentSeries.bx);
            }
            return _super.prototype.r5.call(this, a);
        };
        ColumnFragment.prototype.pb = function (a) {
            if (this.q2() == null || this.fragmentYAxis == null) {
                return i2.Rect.empty;
            }
            var b = this.ox(a);
            var c = this.bx.bv;
            var d = this.bx.bu;
            var e = this.getEffectiveViewport1(this.bx);
            var f = new ScalerParams(0, c, d, this.fragmentYAxis.cc, e);
            var g = this.aj(this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), a, true);
            if (g == null) {
                return i2.Rect.empty;
            }
            var h = g[0];
            var i = g[1];
            var j = Math.abs(b.x - h[0]);
            var k = Math.abs(b.x - i[0]);
            var l = this.q2().ki(c, d, e);
            if (j < k) {
                var m = h[0] - 0.5 * l;
                var n = h[1];
                var o = h[2];
                return new i2.Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
            }
            else {
                var p = i[0] - 0.5 * l;
                var q = i[1];
                var r = i[2];
                return new i2.Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
            }
        };
        ColumnFragment.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        ColumnFragment.prototype.es = function (a, b) {
            var c = this.pc(a);
            if (c.isEmpty) {
                return false;
            }
            var d = this.uz(c, this.fz(b));
            return d.containsPoint(a);
        };
        ColumnFragment.prototype.uz = function (a, b) {
            var c = a.left + a.width / 2;
            var d = a.top + a.height / 2;
            var e = c - ((a.width / 2) + b);
            var f = d - (a.height / 2);
            var g = a.height;
            var h = a.width + b * 2;
            return new i2.Rect(0, e, f, h, g);
        };
        ColumnFragment.prototype.hn = function (a, b) {
            var c = i2.typeCast(i2.FrameworkElement.$, a);
            var d = c != null ? i2.typeCast(i2.DataContext.$, c.dataContext) : null;
            var e = d != null ? d.item : null;
            if (e == null) {
                var f = this.bx.bu;
                var g = this.ca != null ? this.ca.pg : i2.Rect.empty;
                var h = { $type: i2.Point_$type, x: g.left + g.width * (b.x - f.left) / f.width, y: g.top + g.height * (b.y - f.top) / f.height };
                e = this.hh(h);
            }
            return e;
        };
        ColumnFragment.prototype.hh = function (a) {
            var b = 0;
            if (i2.typeCast(ISortingAxis_$type, this.q2()) !== null) {
                b = this.g2(a);
                if (b == -1) {
                    return null;
                }
            }
            else {
                b = this.g0(a);
            }
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        };
        ColumnFragment.prototype.g2 = function (a) {
            var b = this.bx.bv;
            var c = this.bx.bu;
            var d = this.getEffectiveViewport1(this.bx);
            if (b.isEmpty || c.isEmpty) {
                return -1;
            }
            var e = this.q2();
            var f = new ScalerParams(0, b, c, e.cc, d);
            var g = i2.typeCast(ISortingAxis_$type, this.fragmentXAxis);
            var h = this.o7(this.bx);
            var i = e.eb(h.left, f);
            var j = e.eb(h.right, f);
            var k = (a.x - b.left) / b.width;
            var l = i + ((j - i) * k);
            if (i2.truncate(l) <= i2.dateMinValue().getTime() || i2.truncate(l) >= i2.dateMaxValue().getTime()) {
                return -1;
            }
            var m = g.i$f(l);
            return m;
        };
        ColumnFragment.prototype.g0 = function (a) {
            if (this.parentSeries == null) {
                return -1;
            }
            return this.parentSeries.tb(a);
        };
        ColumnFragment.prototype.uk = function (a, b, c, d, e, f, g, h) {
            var i = 0;
            var j = c[0];
            var k = e < i ? c[2] : c[1];
            var l = new i2.Rect(0, j - 5, k - 5, 11, 11);
            if (!i2.isNaN_(j) && !i2.isNaN_(k) && !i2.isInfinity(j) && !i2.isInfinity(k) && d.tryAdd(l)) {
                b.m.add({ $type: i2.Point_$type, x: j, y: k });
                a.updateMarkerTemplate(g, f, h);
                return true;
            }
            return false;
        };
        ColumnFragment.prototype.us = function (a) {
            if (a.p) {
                return this.parentSeries.a4.a$h.item(a.ad);
            }
            else if (a == this.bw) {
                return this.parentSeries.bw;
            }
            else {
                return this.parentSeries.rc;
            }
        };
        ColumnFragment.prototype.lz = function (a, b, c, d, e) {
            this.a4.a$t(this, a, b, d, e);
            var f = this.a4.a$h.item(d);
            var g = f;
            f.a1(c);
            var h = this.us(f);
            h.cr.g(this.gh);
            if (this.ct(g)) {
                return;
            }
            if (this.sw == null) {
                this.sw = new CategoryFrame(3);
            }
            this.sw.u();
            this.si(this.sw, g);
            this.sl(this.sw, g);
        };
        ColumnFragment.prototype.si = function (a, b) {
            a.u();
            if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null || this.logicalSeriesLink.ap.count == 0 || this.logicalSeriesLink.aq.count == 0) {
                return;
            }
            var c;
            if (b.p) {
                c = this.parentSeries.su;
            }
            else if (b == this.bw) {
                c = this.parentSeries.q6;
            }
            else {
                c = this.parentSeries.q3;
            }
            var d = i2.typeCast(CategorySeriesView.$, this.us(b));
            a.f.clear();
            a.m.clear();
            var e = d.cr.e;
            var f = d.cr.f;
            var g = this.parentSeries.q8.h.yScaler;
            var h = i2.typeCast(ISortingAxis_$type, this.parentSeries.q8.h.scaler);
            var i = i2.typeCast(NumericAxisBase.$, g) !== null && g.kl;
            var j = i2.typeCast(StackedBucketCalculator.$, d.cr);
            var k = d.cr.d;
            var l = 0;
            for (var m = e; m <= f; m++) {
                var n = m * k;
                if (this._visibility != 0) {
                    break;
                }
                if (m >= this.valueColumn.count || m >= c.f.count + e) {
                    continue;
                }
                var o = this.valueColumn.item(m);
                var p = !i || (i && o > 0);
                var q = void 0;
                if (h == null) {
                    q = j.getBucket1(this, m, m, b.bv, b.bu, c);
                }
                else {
                    q = j.getBucket1(this, m, h.i$b._inner[m], b.bv, b.bu, c);
                }
                a.f.add(q);
                if (p) {
                    if (this.uk(b, a, q, this.q8.h.provideCollisionDetector(), o, n, l, a.f.count - 1)) {
                        l++;
                    }
                }
            }
            b.cu.count = l;
        };
        ColumnFragment.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            if (this.parentSeries == null) {
                return;
            }
            this.parentSeries.tk(this, a, b);
            CategoryMarkerManager.e(this, a.m, b.cu, this.pv);
        };
        ColumnFragment.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
        };
        Object.defineProperty(ColumnFragment.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        ColumnFragment.$t = i2.markType(ColumnFragment, 'ColumnFragment', FragmentBase.$);
        ColumnFragment.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, ColumnFragment, 'raisePropertyChanged', ['RadiusX:ut:ux', [1, 0], 'RadiusY:uu:uy', [1, 0]]);
        return ColumnFragment;
    }(FragmentBase));
    /**
     * @hidden
     */
    var BarFragment = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BarFragment, _super);
        function BarFragment() {
            var _this = _super.call(this) || this;
            _this.ab = BarFragment.$;
            return _this;
        }
        BarFragment.prototype.get_c9 = function () {
            return true;
        };
        BarFragment.prototype.get_dw = function () {
            return true;
        };
        BarFragment.prototype.get_db = function () {
            return false;
        };
        Object.defineProperty(BarFragment.prototype, "barFragmentXAxis", {
            get: function () {
                return this.parentSeries != null ? this.parentSeries.xAxis : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BarFragment.prototype, "barFragmentYAxis", {
            get: function () {
                return this.parentSeries != null ? this.parentSeries.yAxis : null;
            },
            enumerable: false,
            configurable: true
        });
        BarFragment.prototype.q2 = function () {
            if (this.parentSeries == null) {
                return null;
            }
            return this.parentSeries.fetchYAxis();
        };
        BarFragment.prototype.get_isVertical = function () {
            return true;
        };
        BarFragment.prototype.fw = function (a) {
            var b = this.ca != null ? this.ca.pg : i2.Rect.empty;
            var c = this.bx.bu;
            var d = this.o7(this.bx);
            var e = this.getEffectiveViewport1(this.bx);
            var f = this.q2();
            var g = -1;
            if (f != null && !b.isEmpty && !c.isEmpty) {
                var h = new ScalerParams(0, b, c, f.cc, e);
                var i = f.eb(d.top, h);
                var j = f.eb(d.bottom, h);
                var k = (a.y - b.top) / b.height;
                var l = i + (k * (j - i));
                if (f.categoryMode != 0) {
                    l -= 0.5;
                }
                g = l;
            }
            return g;
        };
        BarFragment.prototype.rn = function () {
            if (this.parentSeries == null) {
                return null;
            }
            return this.parentSeries.rn();
        };
        BarFragment.prototype.uz = function (a, b) {
            var c = a.left + a.width / 2;
            var d = a.top + a.height / 2;
            var e = c - (a.width / 2);
            var f = d - ((a.height / 2) + b);
            var g = a.height + b * 2;
            var h = a.width;
            return new i2.Rect(0, e, f, h, g);
        };
        BarFragment.prototype.pb = function (a) {
            if (this.q2() == null) {
                return i2.Rect.empty;
            }
            var b = this.ox(a);
            var c = this.bx.bv;
            var d = this.bx.bu;
            var e = this.getEffectiveViewport1(this.bx);
            var f = this.q2();
            var g = new ScalerParams(0, c, d, f.cc, e);
            var h = this.aj(this.q2(), this.q3.f, this.r3(this.bx), this.r4(this.bx), a, true);
            if (h == null) {
                return i2.Rect.empty;
            }
            var i = h[0];
            var j = h[1];
            var k = Math.abs(b.y - i[0]);
            var l = Math.abs(b.y - j[0]);
            var m = f.ki(c, d, e);
            if (k < l) {
                var n = i[0] - 0.5 * m;
                var o = i[2];
                var p = i[1];
                return new i2.Rect(0, o, n, Math.max(p, o) - Math.min(p, o), m);
            }
            else {
                var q = j[0] - 0.5 * m;
                var r = j[2];
                var s = j[1];
                return new i2.Rect(0, r, q, Math.max(s, r) - Math.min(s, r), m);
            }
        };
        BarFragment.prototype.ep = function (a, b) {
            if (this.es(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        BarFragment.prototype.uk = function (a, b, c, d, e, f, g, h) {
            var i = c[0];
            var j = e < 0 ? c[2] : c[1];
            var k = new i2.Rect(0, j - 5, i - 5, 11, 11);
            if (!i2.isNaN_(j) && !i2.isNaN_(i) && !i2.isInfinity(j) && !i2.isInfinity(i) && d.tryAdd(k)) {
                b.m.add({ $type: i2.Point_$type, x: j, y: i });
                a.updateMarkerTemplate(g, f, h);
                return true;
            }
            return false;
        };
        BarFragment.prototype.hh = function (a) {
            var b = 0;
            if (i2.typeCast(ISortingAxis_$type, this.barFragmentYAxis) !== null) {
                b = this.g2(a);
                if (b == -1) {
                    return null;
                }
            }
            else {
                b = this.g0(a);
            }
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        };
        BarFragment.prototype.g2 = function (a) {
            var b = this.bx.bv;
            var c = this.bx.bu;
            if (b.isEmpty || c.isEmpty) {
                return -1;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, b, c, this.barFragmentYAxis.cc, d);
            var f = i2.typeCast(ISortingAxis_$type, this.barFragmentYAxis);
            var g = this.o7(this.bx);
            var h = this.barFragmentYAxis.eb(g.top, e);
            var i = this.barFragmentYAxis.eb(g.bottom, e);
            var j = (a.y - b.top) / b.height;
            var k = h + ((i - h) * j);
            if (i2.truncate(k) <= i2.dateMinValue().getTime() || i2.truncate(k) >= i2.dateMaxValue().getTime()) {
                return -1;
            }
            var l = f.i$f(k);
            return l;
        };
        BarFragment.prototype.s4 = function (a) {
            var b = 0;
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(a);
            var f = new ScalerParams(0, c, d, this.barFragmentXAxis.cc, e);
            if (!c.isEmpty && !d.isEmpty && this.barFragmentXAxis != null) {
                b = this.barFragmentXAxis.d8(0, f);
            }
            return b;
        };
        BarFragment.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            if (this.parentSeries == null || this.barFragmentXAxis == null) {
                return;
            }
            var e = this.barFragmentXAxis;
            switch (b) {
                case "ValueColumn":
                    if (this.sv.c3) {
                        this.sv.c2.g$i();
                    }
                    if (e != null && !e.cv()) {
                        this.parentSeries.sv().cr.g(this.gh);
                        this.l0(false);
                    }
                    break;
            }
        };
        Object.defineProperty(BarFragment.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        BarFragment.$t = i2.markType(BarFragment, 'BarFragment', ColumnFragment.$);
        return BarFragment;
    }(ColumnFragment));
    /**
     * @hidden
     */
    var AreaFragmentBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AreaFragmentBucketCalculator, _super);
        function AreaFragmentBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        AreaFragmentBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            return this.getBucket(a);
        };
        AreaFragmentBucketCalculator.prototype.getBucket = function (a) {
            var b = Math.min(a * this.d, this.i.c0.valueColumn.count - 1);
            var c = Math.min(b + this.d - 1, this.i.c0.valueColumn.count - 1);
            var d = NaN;
            var e = NaN;
            var f = this.i.c0;
            var g = f.parentSeries;
            var h = i2.typeCast(IStacked100Series_$type, g) !== null;
            var i = this.i.c0.valueColumn;
            var j = g.ss;
            var k = g.st;
            var l = f.logicalSeriesLink.aq;
            var m = f.logicalSeriesLink.ap;
            for (var n = b; n <= c; ++n) {
                var o = i.item(n);
                if (i2.isNaN_(o) || i2.isInfinity(o)) {
                    o = 0;
                }
                var p = Math.abs(k[n]) + j[n];
                if (h) {
                    if (p == 0) {
                        o = 0;
                    }
                    else if (o < 0) {
                        o = (l._inner[n] + o) / p * 100;
                    }
                    else {
                        o = (m._inner[n] + o) / p * 100;
                    }
                }
                else {
                    o = o < 0 ? l._inner[n] + o : m._inner[n] + o;
                }
                if (!i2.isNaN_(d)) {
                    if (!i2.isNaN_(o)) {
                        d = Math.min(d, o);
                        e = Math.max(e, o);
                    }
                }
                else {
                    d = o;
                    e = o;
                }
            }
            if (!i2.isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [0.5 * (b + c), NaN, NaN];
        };
        AreaFragmentBucketCalculator.$t = i2.markType(AreaFragmentBucketCalculator, 'AreaFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
        return AreaFragmentBucketCalculator;
    }(AnchoredCategoryBucketCalculator));
    /**
     * @hidden
     */
    var LineFragmentBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LineFragmentBucketCalculator, _super);
        function LineFragmentBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        LineFragmentBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
            return this.getBucket(a);
        };
        LineFragmentBucketCalculator.prototype.getBucket = function (a) {
            var b = Math.min(a * this.d, this.i.c0.valueColumn.count - 1);
            var c = Math.min(b + this.d - 1, this.i.c0.valueColumn.count - 1);
            var d = NaN;
            var e = NaN;
            var f = i2.typeCast(FragmentBase.$, this.i.c0);
            var g = f.parentSeries;
            for (var h = b; h <= c; ++h) {
                var i = this.i.c0.valueColumn.item(h);
                var j = Math.abs(g.st[h]) + g.ss[h];
                if (i2.isNaN_(i) || i2.isInfinity(i)) {
                    i = 0;
                }
                if (i2.typeCast(IStacked100Series_$type, g) !== null) {
                    if (j == 0) {
                        i = 0;
                    }
                    else if (i < 0) {
                        i = (f.logicalSeriesLink.aq._inner[h] + i) / j * 100;
                    }
                    else {
                        i = (f.logicalSeriesLink.ap._inner[h] + i) / j * 100;
                    }
                }
                else {
                    i = i < 0 ? f.logicalSeriesLink.aq._inner[h] + i : f.logicalSeriesLink.ap._inner[h] + i;
                }
                if (!i2.isNaN_(d)) {
                    if (!i2.isNaN_(i)) {
                        d = Math.min(d, i);
                        e = Math.max(e, i);
                    }
                }
                else {
                    d = i;
                    e = i;
                }
            }
            if (!i2.isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [0.5 * (b + c), NaN, NaN];
        };
        LineFragmentBucketCalculator.$t = i2.markType(LineFragmentBucketCalculator, 'LineFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
        return LineFragmentBucketCalculator;
    }(AnchoredCategoryBucketCalculator));
    /**
     * @hidden
     */
    var SplineFragmentBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineFragmentBucketCalculator, _super);
        function SplineFragmentBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        SplineFragmentBucketCalculator.prototype.getBucket = function (a) {
            var b = Math.min(a * this.d, this.i.c0.valueColumn.count - 1);
            var c = Math.min(b + this.d - 1, this.i.c0.valueColumn.count - 1);
            var d = NaN;
            var e = NaN;
            var f = i2.typeCast(SplineFragmentBase.$, this.i.c0);
            var g = f.parentSeries;
            for (var h = b; h <= c; ++h) {
                var i = this.i.c0.valueColumn.item(h);
                var j = Math.abs(g.st[h]) + g.ss[h];
                if (i2.isNaN_(i) || i2.isInfinity(i)) {
                    i = 0;
                }
                if (i2.typeCast(IStacked100Series_$type, g) !== null) {
                    if (j == 0) {
                        i = 0;
                    }
                    else if (i < 0) {
                        i = (f.logicalSeriesLink.aq._inner[h] + i) / j * 100;
                    }
                    else {
                        i = (f.logicalSeriesLink.ap._inner[h] + i) / j * 100;
                    }
                }
                else {
                    i = i < 0 ? f.logicalSeriesLink.aq._inner[h] + i : f.logicalSeriesLink.ap._inner[h] + i;
                }
                if (!i2.isNaN_(d)) {
                    if (!i2.isNaN_(i)) {
                        d = Math.min(d, i);
                        e = Math.max(e, i);
                    }
                }
                else {
                    d = i;
                    e = i;
                }
            }
            if (!i2.isNaN_(d)) {
                return [0.5 * (b + c), d, e];
            }
            return [0.5 * (b + c), NaN, NaN];
        };
        SplineFragmentBucketCalculator.$t = i2.markType(SplineFragmentBucketCalculator, 'SplineFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
        return SplineFragmentBucketCalculator;
    }(AnchoredCategoryBucketCalculator));
    /**
     * @hidden
     */
    var StackedBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedBucketCalculator, _super);
        function StackedBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        StackedBucketCalculator.prototype.getBucket = function (a) {
            var b = i2.typeCast(StackedSeriesBase.$, this.c.ct);
            var c = Math.min(b.st != null ? b.st.length : 0, b.ss != null ? b.ss.length : 0);
            var d = Math.min(a * this.d, c - 1);
            var e = Math.min(d + this.d - 1, c - 1);
            var f = NaN;
            var g = NaN;
            for (var h = d; h <= e; ++h) {
                var i = Math.min(b.st[h], b.ss[h]);
                var j = Math.max(b.st[h], b.ss[h]);
                if (!i2.isNaN_(f)) {
                    if (!i2.isNaN_(i)) {
                        f = Math.min(f, i);
                        g = Math.max(g, i);
                    }
                    if (!i2.isNaN_(j)) {
                        f = Math.min(f, j);
                        g = Math.max(g, j);
                    }
                }
                else {
                    f = i;
                    g = j;
                }
            }
            if (!i2.isNaN_(f) && !i2.isNaN_(g)) {
                return [0.5 * (d + e), f, g];
            }
            return [NaN, NaN, NaN];
        };
        StackedBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
            return null;
        };
        StackedBucketCalculator.$t = i2.markType(StackedBucketCalculator, 'StackedBucketCalculator', CategoryBucketCalculator.$);
        return StackedBucketCalculator;
    }(CategoryBucketCalculator));
    /**
     * @hidden
     */
    var StackedBarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedBarBucketCalculator, _super);
        function StackedBarBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        StackedBarBucketCalculator.prototype.g = function (a) {
            var b = this.c.bv;
            var c = this.c.bu;
            var d = i2.typeCast(StackedBarSeries.$, this.c.ct);
            var e = this.c.ct.ch;
            if (b.isEmpty || c.isEmpty || d.yAxis == null || e == null || e.count == 0) {
                this.d = 0;
                return;
            }
            var f = d.getEffectiveViewport1(this.c);
            var g = new ScalerParams(0, b, c, d.yAxis.cc, f);
            var h = d.o7(this.c);
            var i = Math.floor(d.yAxis.ec(h.top, g, 0));
            var j = Math.ceil(d.yAxis.ec(h.bottom, g, 0));
            if (!d.yAxis.cc) {
                j = Math.ceil(d.yAxis.ec(h.top, g, 0));
                i = Math.floor(d.yAxis.ec(h.bottom, g, 0));
            }
            var k = Math.floor((j - i + 1) * a / h.height);
            this.d = i2.truncate(Math.max(1, k));
            this.e = i2.truncate(Math.max(0, Math.floor(i / this.d) - 1));
            this.f = i2.truncate(Math.ceil(j / this.d));
        };
        StackedBarBucketCalculator.prototype.getBucket = function (a) {
            return _super.prototype.getBucket.call(this, a);
        };
        StackedBarBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
            var g = [NaN, NaN, NaN];
            var h = i2.typeCast(BarFragment.$, a);
            if (h == null || h.logicalSeriesLink == null) {
                return g;
            }
            var i = i2.typeCast(StackedBarSeries.$, this.c.ct);
            var j = a.valueColumn.item(c);
            var k = 0;
            var l = NaN;
            var m = NaN;
            var n = Number.NEGATIVE_INFINITY;
            var o = Number.POSITIVE_INFINITY;
            var p = i.getEffectiveViewport1(this.c);
            var q = Math.min(i.st != null ? i.st.length : 0, i.ss != null ? i.ss.length : 0);
            var r = c * this.d;
            var s = Math.min(r + this.d - 1, q - 1);
            for (var t = r; t <= s; ++t) {
                j = a.valueColumn.item(t);
                if (j < k) {
                    o = Math.min(o, h.logicalSeriesLink.aq._inner[t] + j);
                    n = Math.max(n, h.logicalSeriesLink.aq._inner[t]);
                }
                else {
                    o = Math.min(o, h.logicalSeriesLink.ap._inner[t]);
                    n = Math.max(n, h.logicalSeriesLink.ap._inner[t] + j);
                }
                if (!i2.isNaN_(l)) {
                    if (!i2.isNaN_(o)) {
                        l = Math.min(l, o);
                        m = Math.max(m, o);
                    }
                    if (!i2.isNaN_(n)) {
                        l = Math.min(l, n);
                        m = Math.max(m, n);
                    }
                }
                else {
                    l = o;
                    m = n;
                }
            }
            var u = new ScalerParams(0, d, e, i.xAxis.cc, p);
            g = [f.f._inner[b - this.e][0], i.xAxis.d8(m, u), i.xAxis.d8(l, u)];
            return g;
        };
        StackedBarBucketCalculator.$t = i2.markType(StackedBarBucketCalculator, 'StackedBarBucketCalculator', StackedBucketCalculator.$);
        return StackedBarBucketCalculator;
    }(StackedBucketCalculator));
    /**
     * @hidden
     */
    var StackedColumnBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedColumnBucketCalculator, _super);
        function StackedColumnBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        StackedColumnBucketCalculator.prototype.getBucket = function (a) {
            return _super.prototype.getBucket.call(this, a);
        };
        StackedColumnBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
            var g = [NaN, NaN, NaN];
            var h = i2.typeCast(ColumnFragment.$, a);
            if (h == null || h.logicalSeriesLink == null) {
                return g;
            }
            var i = i2.typeCast(StackedColumnSeries.$, this.c.ct);
            var j = a.valueColumn.item(c);
            var k = 0;
            var l = NaN;
            var m = NaN;
            var n = Number.NEGATIVE_INFINITY;
            var o = Number.POSITIVE_INFINITY;
            var p = i.getEffectiveViewport1(this.c);
            var q = Math.min(i.st != null ? i.st.length : 0, i.ss != null ? i.ss.length : 0);
            var r = c * this.d;
            var s = Math.min(r + this.d - 1, q - 1);
            for (var t = r; t <= s; ++t) {
                j = a.valueColumn.item(t);
                if (j < k) {
                    o = Math.min(o, h.logicalSeriesLink.aq._inner[t] + j);
                    n = Math.max(n, h.logicalSeriesLink.aq._inner[t]);
                }
                else {
                    o = Math.min(o, h.logicalSeriesLink.ap._inner[t]);
                    n = Math.max(n, h.logicalSeriesLink.ap._inner[t] + j);
                }
                if (!i2.isNaN_(l)) {
                    if (!i2.isNaN_(o)) {
                        l = Math.min(l, o);
                        m = Math.max(m, o);
                    }
                    if (!i2.isNaN_(n)) {
                        l = Math.min(l, n);
                        m = Math.max(m, n);
                    }
                }
                else {
                    l = o;
                    m = n;
                }
            }
            var u = new ScalerParams(0, d, e, i.yAxis.cc, p);
            g = [f.f._inner[b - this.e][0], i.yAxis.d8(m, u), i.yAxis.d8(l, u)];
            return g;
        };
        StackedColumnBucketCalculator.$t = i2.markType(StackedColumnBucketCalculator, 'StackedColumnBucketCalculator', StackedBucketCalculator.$);
        return StackedColumnBucketCalculator;
    }(StackedBucketCalculator));
    /**
     * @hidden
     */
    var FragmentBaseValueList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(FragmentBaseValueList, _super);
        function FragmentBaseValueList(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = a;
            return _this;
        }
        FragmentBaseValueList.prototype.indexOf = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.insert = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.removeAt = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                throw new i2.NotImplementedException(0);
                return b;
            }
            else {
                var b_1 = false;
                if (this.a.parentSeries != null) {
                    b_1 = this.a.parentSeries.s3;
                }
                var c = this.a.parentSeries;
                if (c == null) {
                    return NaN;
                }
                if (c.st == null || c.ss == null || c.st.length == 0 || c.ss.length == 0) {
                    return NaN;
                }
                var d = this.a.valueColumn.item(a);
                var e = Math.abs(c.st[a]) + c.ss[a];
                var f = this.a.logicalSeriesLink.ap;
                var g = this.a.logicalSeriesLink.aq;
                if (i2.isNaN_(d) || i2.isInfinity(d)) {
                    d = 0;
                }
                if (b_1) {
                    if (e == 0) {
                        d = 0;
                    }
                    else if (d < 0) {
                        d = (g._inner[a] + d) / e * 100;
                    }
                    else {
                        d = (f._inner[a] + d) / e * 100;
                    }
                }
                else {
                    d = d < 0 ? g._inner[a] + d : f._inner[a] + d;
                }
                return d;
            }
        };
        FragmentBaseValueList.prototype.add = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.clear = function () {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.contains = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.copyTo = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        Object.defineProperty(FragmentBaseValueList.prototype, "count", {
            get: function () {
                return this.a.valueColumn.count;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(FragmentBaseValueList.prototype, "isReadOnly", {
            get: function () {
                throw new i2.NotImplementedException(0);
            },
            enumerable: false,
            configurable: true
        });
        FragmentBaseValueList.prototype.remove = function (a) {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.getEnumerator = function () {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.prototype.getEnumeratorObject = function () {
            throw new i2.NotImplementedException(0);
        };
        FragmentBaseValueList.$t = i2.markType(FragmentBaseValueList, 'FragmentBaseValueList', i2.Base.$, [i2.IList$1_$type.specialize(i2.Number_$type)]);
        return FragmentBaseValueList;
    }(i2.Base));
    /**
     * @hidden
     */
    var LineFragment = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LineFragment, _super);
        function LineFragment() {
            var _this = _super.call(this) || this;
            _this.ab = LineFragment.$;
            return _this;
        }
        LineFragment.prototype.get_dv = function () {
            return true;
        };
        LineFragment.prototype.bu = function () {
            return new LineFragmentView(this);
        };
        LineFragment.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.up = a;
        };
        LineFragment.prototype.ur = function (a, b) {
            var c = this.up.df.ak;
            if (this.er(a, c)) {
                return true;
            }
            return false;
        };
        LineFragment.prototype.get_c8 = function () {
            return true;
        };
        LineFragment.prototype.ep = function (a, b) {
            if (this.uq(a, b)) {
                return true;
            }
            if (this.ur(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        LineFragment.prototype.uq = function (a, b) {
            var c = this.up.dg.ak;
            if (this.eq(a, b, c)) {
                return true;
            }
            var d = this.up.dh.ak;
            if (this.eq(a, b, d)) {
                return true;
            }
            return false;
        };
        LineFragment.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        LineFragment.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.db();
        };
        LineFragment.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            var c = function (d) { return a.f._inner[d][0]; };
            var d = function (e) { return a.f._inner[e][1]; };
            var e = function (f) { return a.f._inner[f][0]; };
            var f = function (g) { return a.f._inner[g][2]; };
            this.ug.a = i2.typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
            var g = b.cr.d;
            var h = i2.typeCast(LineFragmentView.$, b);
            var i = this.getEffectiveViewport1(b);
            var j = a.f;
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var k = false;
            var l = this.rb.b;
            if (l != null) {
                k = true;
            }
            if (k) {
                var m = new ScalerParams(0, b.bv, b.bu, this.tw.cc, i);
                this.sh(j, -1, this.valueColumn.count, this.tw, m, b.q);
            }
            this.rb.ad(h.dg, true, false, true, false);
            this.rb.ad(h.dh, true, false, true, false);
            this.rb.ad(h.df, false, true, false, false);
            h.df._opacity = 0.75 * this.rb.j;
            this.ug.m(h.dg, h.df, h.dh, a.f.count, a.f, true, 0, this.st(a.f, a.f.count - 1, b.bu, b.bv), g, this.gh);
        };
        Object.defineProperty(LineFragment.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        LineFragment.$t = i2.markType(LineFragment, 'LineFragment', FragmentBase.$);
        return LineFragment;
    }(FragmentBase));
    /**
     * @hidden
     */
    var SplineFragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineFragmentBase, _super);
        function SplineFragmentBase() {
            var _this = _super.call(this) || this;
            _this._logicalSeriesLink = null;
            _this.uz = null;
            _this.u1 = null;
            _this.uz = new CategoryLineRasterizer();
            return _this;
        }
        Object.defineProperty(SplineFragmentBase.prototype, "logicalSeriesLink", {
            get: function () {
                return this._logicalSeriesLink;
            },
            set: function (a) {
                this._logicalSeriesLink = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineFragmentBase.prototype, "parentSeries", {
            get: function () {
                return this.u1;
            },
            set: function (a) {
                this.u1 = a;
            },
            enumerable: false,
            configurable: true
        });
        SplineFragmentBase.prototype.get_dh = function () {
            return false;
        };
        SplineFragmentBase.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        SplineFragmentBase.prototype.get_dn = function () {
            return true;
        };
        SplineFragmentBase.prototype.i9 = function () {
            if (this.logicalSeriesLink != null) {
                return this.logicalSeriesLink.dk;
            }
            return null;
        };
        SplineFragmentBase.prototype.o2 = function (a, b, c) {
            var _this = this;
            return this.o4(a, b, c, this.q8.r(this.q2(), this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx)), this.rn(), this.q2(), i2.runOn(this, this.u3), function (d, e) { return _this.g7(d, e, _this.q2(), i2.runOn(_this, _this.r1), new SplineFragmentBaseValueList(_this)); }, function (d, e) { return _this.g5(d, e, _this.q2(), i2.runOn(_this, _this.r1), new SplineFragmentBaseValueList(_this)); });
        };
        SplineFragmentBase.prototype.ag = function () {
            return [this.q2(), this.rn()];
        };
        SplineFragmentBase.prototype.u3 = function (a, b, c) {
            if (this.ca == null) {
                return NaN;
            }
            var d = this.getEffectiveViewport1(this.bx);
            var e = new ScalerParams(0, this.ca.pg, this.bx.bu, this.q2().cc, d);
            var f = this.q8.r(this.q2(), this.ca.pg, this.bx.bu, d);
            return this.ga(new SplineFragmentBaseValueList(this), a, this.q2(), e, f, i2.runOn(this, this.r1), b, c);
        };
        SplineFragmentBase.prototype.gz = function () {
            var a = this.parentSeries;
            if (a.g9 == -1 || a.s0 == null || a.s0.f.indexOf(this) == -1) {
                return -1;
            }
            return a.s0.f.indexOf(this);
        };
        SplineFragmentBase.prototype.resolveLegendIndex = function () {
            var a = this.parentSeries;
            if (a.s4) {
                return -1 + a.g9 + a.sw.count - a.s0.f.indexOf(this);
            }
            return _super.prototype.resolveLegendIndex.call(this);
        };
        SplineFragmentBase.prototype.g3 = function () {
            var a = this.parentSeries;
            if (a.g9 == -1 || a.series.count == 0 || a.series.indexOf(this.logicalSeriesLink) == -1) {
                return -1;
            }
            return a.series.indexOf(this.logicalSeriesLink);
        };
        SplineFragmentBase.prototype.be = function () {
            return this.parentSeries;
        };
        SplineFragmentBase.prototype.ul = function (a, b, c, d, e, f, g) {
            var h = b[0];
            var i = b[1];
            var j = new i2.Rect(0, h - 5, i - 5, 11, 11);
            if (!i2.isNaN_(h) && !i2.isNaN_(i) && !i2.isInfinity(h) && !i2.isInfinity(i) && c.tryAdd(j)) {
                a.m.add({ $type: i2.Point_$type, x: h, y: i });
                var k = f.cu.item(e);
                k.content.item = this.ch.item(d);
                k.al = g;
                return true;
            }
            return false;
        };
        SplineFragmentBase.prototype.e3 = function (a, b, c) {
            var d = _super.prototype.e3.call(this, a, b, c);
            var e = i2.typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
            var f = this.parentSeries.fetchYAxis();
            if (this.parentSeries == null || e == null || e.itemsSource == null || f == null || this.parentSeries.ch == null || e.bh == null || f.bh == null) {
                d = false;
            }
            if (this.valueColumn == null) {
                return false;
            }
            if (i2.isInfinity(this.valueColumn.minimum) && i2.isInfinity(this.valueColumn.maximum)) {
                d = false;
            }
            if (i2.isNaN_(this.valueColumn.minimum) && i2.isNaN_(this.valueColumn.maximum)) {
                d = false;
            }
            return d;
        };
        SplineFragmentBase.prototype.ap = function (a) {
            return null;
        };
        SplineFragmentBase.prototype.u4 = function (a, b, c, d, e, f) {
            var _this = this;
            var g = i2.typeCast(ISortingAxis_$type, d);
            if (g == null) {
                return;
            }
            var h = this.getEffectiveViewport1(f);
            var i = new ScalerParams(0, b, c, d.cc, h);
            var j = new ScalerParams(0, b, c, e.cc, h);
            var k = d.eb(2, i) - d.eb(1, i);
            var l = this.pt();
            var m = 0;
            var n = this.up(d, b, c, h);
            var o = function (p) { return Math.abs(_this.parentSeries.st[p]) + _this.parentSeries.ss[p]; };
            var p = function (q) { return q; };
            var q = function (r) {
                var s = g.i$b._inner[r];
                if (i2.typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                    return _this.valueColumn.item(s) < 0 ? (_this.logicalSeriesLink.aq._inner[s] + _this.valueColumn.item(s)) / o(s) * 100 : (_this.logicalSeriesLink.ap._inner[s] + _this.valueColumn.item(s)) / o(s) * 100;
                }
                else {
                    return _this.valueColumn.item(s) < 0 ? _this.logicalSeriesLink.aq._inner[s] + _this.valueColumn.item(s) : _this.logicalSeriesLink.ap._inner[s] + _this.valueColumn.item(s);
                }
            };
            var r = this.rc.cr.f;
            var s = this.rc.cr.e;
            var t = i2.truncate(Math.ceil(c.width / (r - s)));
            var u = new CollisionAvoider();
            var v = this.rc.cr.d;
            if (v <= 0 || (s <= 0 && r <= 0)) {
                this.rc.cu.count = m;
                return;
            }
            var w = 0;
            for (var x = s; x < r + 1; ++x) {
                var y = null;
                var z = x * v;
                if (g != null && g.i$b != null && z >= 0 && z < g.i$b.count) {
                    z = g.i$b._inner[z];
                }
                if (x >= (this.valueColumn.count - 1)) {
                    if (l && this.ul(a, a.f._inner[a.f.count - 1], u, Math.min(z, this.ch.count - 1), m, f, w - 1)) {
                        ++m;
                    }
                    break;
                }
                var aa = p(x);
                var ab = q(x);
                var ac = p(x + 1);
                var ad = q(x + 1);
                var ae = ac - aa;
                var af = this.uh[x];
                var ag = this.uh[x + 1];
                var ah = g.i$d(g.i$b._inner[x]);
                var ai = d.d8(ah, i) + n;
                var aj = e.d8(ab, j);
                a.f.add([ai, aj, aj]);
                w++;
                for (var ak = 1; ak < t; ++ak) {
                    var al = ak / t;
                    var am = aa + ae * al;
                    var an = (ac - am) / ae;
                    var ao = (am - aa) / ae;
                    var ap = an * ab + ao * ad + ((an * an * an - an) * af + (ao * ao * ao - ao) * ag) * (ae * ae) / 6;
                    var aq = g.i$d(g.i$b._inner[x]);
                    var ar = g.i$d(g.i$b._inner[x + 1]);
                    if (aq == ar && ab == ad) {
                        break;
                    }
                    var as = aq + (ar - aq) * al;
                    am = d.d8(as, i) + n;
                    ap = e.d8(ap, j);
                    a.f.add([am, ap, ap]);
                    w++;
                }
                if (l) {
                    y = [ai, aj, aj];
                }
                if (l && this.ul(a, y, u, Math.min(z, this.ch.count - 1), m, f, w - 1)) {
                    ++m;
                }
            }
            this.rc.cu.count = m;
        };
        SplineFragmentBase.prototype.si = function (a, b) {
            var _this = this;
            a.u();
            if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null) {
                return;
            }
            if (this.logicalSeriesLink.aq.count == 0 || this.logicalSeriesLink.ap.count == 0) {
                return;
            }
            if (this.rc.cr.d == 0) {
                return;
            }
            _super.prototype.si.call(this, a, b);
            if (a.f.count <= 1) {
                return;
            }
            var c = b.bv;
            var d = b.bu;
            var e = this.getEffectiveViewport1(b);
            var f = i2.typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
            var g = i2.typeCast(NumericYAxis.$, this.parentSeries.fetchYAxis());
            var h = new ScalerParams(0, c, d, f.cc, e);
            var i = new ScalerParams(0, c, d, g.cc, e);
            a.f.clear();
            a.m.clear();
            var j = this.pt();
            var k = 0;
            var l;
            var m;
            if (b.p) {
                l = this.parentSeries.su;
                m = this.parentSeries.a4.a$h.item(b.ad);
            }
            else if (b == this.bw) {
                l = this.parentSeries.q6;
                m = i2.typeCast(CategorySeriesView.$, this.parentSeries.bw);
            }
            else {
                l = this.parentSeries.q3;
                m = this.parentSeries.rc;
            }
            var n = m.cr.d;
            var o = i2.typeCast(ISortingAxis_$type, f);
            if (o != null && o.i$b.count != this.ch.count) {
                return;
            }
            var p = this.preferredCategoryMode(f);
            if (p == 0 && f.categoryMode != 0) {
                p = 1;
            }
            var q = 0;
            switch (p) {
                case 0:
                    q = 0;
                    break;
                case 1:
                    q = 0.5 * f.getCategorySize(c, d, e);
                    break;
                case 2:
                    var r = this.g9;
                    q = f.getGroupCenter(this.g9, c, d, e);
                    break;
            }
            if (f.cc) {
                q = -q;
            }
            var s = function (t) { return Math.abs(_this.parentSeries.st[t]) + _this.parentSeries.ss[t]; };
            var t = function (u) { return u; };
            var u = function (v) {
                var w = _this.valueColumn.item(v);
                if (i2.isNaN_(w) || i2.isInfinity(w)) {
                    w = 0;
                }
                if (i2.typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                    if (s(v) == 0) {
                        return 0;
                    }
                    return w < 0 ? (_this.logicalSeriesLink.aq._inner[v] + w) / s(v) * 100 : (_this.logicalSeriesLink.ap._inner[v] + w) / s(v) * 100;
                }
                return w < 0 ? _this.logicalSeriesLink.aq._inner[v] + w : _this.logicalSeriesLink.ap._inner[v] + w;
            };
            var v = b.cr.d;
            this.uu(b);
            var w = m.cr.e;
            var x = m.cr.f;
            var y = i2.truncate(Math.ceil(d.width / (x - w)));
            var z = new CollisionAvoider();
            if (o != null) {
                this.u4(a, c, d, f, g, b);
                return;
            }
            var aa = 0;
            var ab = 0;
            for (var ac = w; ac < x + 1; ++ac) {
                if (ac >= this.valueColumn.count) {
                    break;
                }
                var ad = null;
                if (v == 1) {
                    if (ac >= (this.valueColumn.count - 1)) {
                        if (j && a.f.count > 0 && this.ul(a, a.f._inner[a.f.count - 1], z, Math.min(ac * v, this.ch.count - 1), k, b, aa - 1)) {
                            ++k;
                        }
                        break;
                    }
                    var ae = t(ac);
                    var af = t(ac + 1);
                    var ag = u(ac);
                    var ah = u(ac + 1);
                    var ai = af - ae;
                    var aj = this.uh[ac];
                    var ak = this.uh[ac + 1];
                    var al = f.d8(ae, h) + q;
                    var am = g.d8(ag, i);
                    a.f.add([al, am, am]);
                    aa++;
                    ab = aa;
                    for (var an = 1; an < y; ++an) {
                        var ao = ae + ai * an / y;
                        var ap = (af - ao) / ai;
                        var aq = (ao - ae) / ai;
                        var ar = ap * ag + aq * ah + ((ap * ap * ap - ap) * aj + (aq * aq * aq - aq) * ak) * (ai * ai) / 6;
                        ao = f.d8(ao, h) + q;
                        ar = g.d8(ar, i);
                        a.f.add([ao, ar, ar]);
                        aa++;
                    }
                    if (j) {
                        ad = [al, am, am];
                    }
                }
                else {
                    ad = b.cr.getBucket(ac);
                    if (!i2.isNaN_(ad[0])) {
                        ad[0] = f.d8(ad[0], h) + q;
                        ad[1] = g.d8(ad[1], i);
                        ad[2] = g.d8(ad[2], i);
                        a.f.add(ad);
                        aa++;
                        ab = aa;
                    }
                }
                if (j && this.ul(a, ad, z, Math.min(ac * v, this.ch.count - 1), k, b, ab - 1)) {
                    ++k;
                }
            }
            b.cu.count = k;
        };
        SplineFragmentBase.prototype.uf = function (a) {
            var _this = this;
            var b = function (c) { return Math.abs(_this.parentSeries.st[c]) + _this.parentSeries.ss[c]; };
            var c = function (d) { return d; };
            var d = function (e) {
                var f = _this.valueColumn.item(e);
                if (i2.isNaN_(f) || i2.isInfinity(f)) {
                    f = 0;
                }
                if (i2.typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                    if (b(e) == 0) {
                        return 0;
                    }
                    return f < 0 ? (_this.logicalSeriesLink.aq._inner[e] + f) / b(e) * 100 : (_this.logicalSeriesLink.ap._inner[e] + f) / b(e) * 100;
                }
                return f < 0 ? _this.logicalSeriesLink.aq._inner[e] + f : _this.logicalSeriesLink.ap._inner[e] + f;
            };
            var e = new i2.List$1(i2.Array_$type, 0);
            var f = a.bv;
            var g = a.bu;
            var h = i2.typeCast(ISortingAxis_$type, this.tw);
            var i = 0;
            var j = 0;
            var k = 0;
            var l = this.gh;
            var m = this.o7(this.bx);
            var n = this.tw;
            var o = this.getEffectiveViewport1(a);
            if (h == null || h.i$b == null) {
                var p = new ScalerParams(0, f, g, n.cc, o);
                var q = 0;
                var r = n.kr - 1;
                var s = Math.floor((r - q + 1) * l / m.width);
                i = i2.truncate(Math.max(1, s));
                j = i2.truncate(Math.max(0, Math.floor(q / i) - 1));
                k = i2.truncate(Math.ceil(r / i));
            }
            else {
                j = 0;
                k = n.kr - 1;
                i = 1;
            }
            var t = i2.truncate(Math.ceil(g.width / (k - j)));
            var u = new CollisionAvoider();
            if (h != null) {
                return this.ug(a);
            }
            var v = 0;
            var w = 0;
            for (var x = j; x < k + 1; ++x) {
                if (x >= this.valueColumn.count) {
                    break;
                }
                var y = null;
                if (i == 1) {
                    if (x >= (this.valueColumn.count - 1)) {
                        break;
                    }
                    var z = c(x);
                    var aa = c(x + 1);
                    var ab = d(x);
                    var ac = d(x + 1);
                    var ad = aa - z;
                    var ae = this.uh[x];
                    var af = this.uh[x + 1];
                    e.add([ab, ab]);
                    for (var ag = 1; ag < t; ++ag) {
                        var ah = z + ad * ag / t;
                        var ai = (aa - ah) / ad;
                        var aj = (ah - z) / ad;
                        var ak = ai * ab + aj * ac + ((ai * ai * ai - ai) * ae + (aj * aj * aj - aj) * af) * (ad * ad) / 6;
                        e.add([ak, ak]);
                    }
                }
                else {
                    y = a.cr.getBucket(x);
                    if (!i2.isNaN_(y[0])) {
                        e.add([y[0], y[1]]);
                    }
                }
            }
            return e.toArray();
        };
        SplineFragmentBase.prototype.ug = function (a) {
            var _this = this;
            var b = new i2.List$1(i2.Array_$type, 0);
            var c = a.bv;
            var d = a.bu;
            var e = this.tw;
            var f = i2.typeCast(ISortingAxis_$type, e);
            if (f == null) {
                return null;
            }
            var g = this.getEffectiveViewport1(a);
            var h = this.pt();
            var i = 0;
            var j = function (k) { return Math.abs(_this.parentSeries.st[k]) + _this.parentSeries.ss[k]; };
            var k = function (l) { return l; };
            var l = function (m) {
                var n = f.i$b._inner[m];
                if (i2.typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                    return _this.valueColumn.item(n) < 0 ? (_this.logicalSeriesLink.aq._inner[n] + _this.valueColumn.item(n)) / j(n) * 100 : (_this.logicalSeriesLink.ap._inner[n] + _this.valueColumn.item(n)) / j(n) * 100;
                }
                else {
                    return _this.valueColumn.item(n) < 0 ? _this.logicalSeriesLink.aq._inner[n] + _this.valueColumn.item(n) : _this.logicalSeriesLink.ap._inner[n] + _this.valueColumn.item(n);
                }
            };
            var m = 0;
            var n = 0;
            var o = 0;
            var p = this.gh;
            var q = this.o7(this.bx);
            if (f == null || f.i$b == null) {
                var r = 0;
                var s = e.kr - 1;
                var t = Math.floor((s - r + 1) * p / q.width);
                m = i2.truncate(Math.max(1, t));
                n = i2.truncate(Math.max(0, Math.floor(r / m) - 1));
                o = i2.truncate(Math.ceil(s / m));
            }
            else {
                n = 0;
                o = e.kr - 1;
                m = 1;
            }
            if (m <= 0 || (n <= 0 && o <= 0)) {
                this.rc.cu.count = i;
                return null;
            }
            var u = i2.truncate(Math.ceil(d.width / (o - n)));
            var v = new CollisionAvoider();
            var w = 0;
            for (var x = n; x < o + 1; ++x) {
                var y = null;
                if (x >= (this.valueColumn.count - 1)) {
                    break;
                }
                var z = k(x);
                var aa = l(x);
                var ab = k(x + 1);
                var ac = l(x + 1);
                var ad = ab - z;
                var ae = this.uh[x];
                var af = this.uh[x + 1];
                b.add([aa, aa]);
                for (var ag = 1; ag < u; ++ag) {
                    var ah = ag / u;
                    var ai = z + ad * ah;
                    var aj = (ab - ai) / ad;
                    var ak = (ai - z) / ad;
                    var al = aj * aa + ak * ac + ((aj * aj * aj - aj) * ae + (ak * ak * ak - ak) * af) * (ad * ad) / 6;
                    b.add([al, al]);
                }
            }
            return b.toArray();
        };
        SplineFragmentBase.prototype.uu = function (a) {
            var _this = this;
            _super.prototype.uu.call(this, a);
            var b = function (c) { return Math.abs(_this.parentSeries.st[c]) + _this.parentSeries.ss[c]; };
            var c = function (d) { return d; };
            var d = function (e) {
                var f = _this.valueColumn.item(e);
                if (i2.isNaN_(f) || i2.isInfinity(f)) {
                    f = 0;
                }
                if (i2.typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                    if (b(e) == 0) {
                        return 0;
                    }
                    return f < 0 ? (_this.logicalSeriesLink.aq._inner[e] + f) / b(e) * 100 : (_this.logicalSeriesLink.ap._inner[e] + f) / b(e) * 100;
                }
                return f < 0 ? _this.logicalSeriesLink.aq._inner[e] + f : _this.logicalSeriesLink.ap._inner[e] + f;
            };
            var e = this.tw;
            var f = this.uj == 0 ? NaN : 0;
            if (e != null && i2.typeCast(ISortingAxis_$type, e) !== null && e.i$b != null) {
                var g_1 = new SafeSortedReadOnlyDoubleCollection(0, this.valueColumn, e.i$b);
                d = function (h) { return g_1.item(h); };
            }
            this.uh = i2.Numeric.c(this.valueColumn.count, c, d, f, f);
            if (this.uk) {
                var h = -1.7976931348623157E+308;
                var i = 1.7976931348623157E+308;
                var j = this.uf(a);
                if (j == null) {
                    return;
                }
                for (var k = 0; k < j.length; k++) {
                    if (i2.isNaN_(j[k][0]) || i2.isNaN_(j[k][1])) {
                        continue;
                    }
                    if (j[k][1] > h) {
                        h = j[k][1];
                    }
                    if (j[k][0] < i) {
                        i = j[k][0];
                    }
                }
                this.ur = i;
                this.uq = h;
            }
        };
        SplineFragmentBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "ActualBrush":
                    if (this.logicalSeriesLink != null) {
                        this.logicalSeriesLink.hs = this.of;
                    }
                    break;
            }
        };
        Object.defineProperty(SplineFragmentBase.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        SplineFragmentBase.$t = i2.markType(SplineFragmentBase, 'SplineFragmentBase', SplineSeriesBase.$);
        return SplineFragmentBase;
    }(SplineSeriesBase));
    /**
     * @hidden
     */
    var SplineAreaFragment = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineAreaFragment, _super);
        function SplineAreaFragment() {
            var _this = _super.call(this) || this;
            _this.u9 = null;
            _this.ab = SplineAreaFragment.$;
            return _this;
        }
        SplineAreaFragment.prototype.bu = function () {
            return new SplineAreaFragmentView(this);
        };
        SplineAreaFragment.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.u5 = i2.typeCast(SplineAreaFragmentView.$, a);
        };
        SplineAreaFragment.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        SplineAreaFragment.prototype.get_c8 = function () {
            return true;
        };
        SplineAreaFragment.prototype.get_c7 = function () {
            return true;
        };
        SplineAreaFragment.prototype.get_ea = function () {
            return true;
        };
        SplineAreaFragment.prototype.u7 = function (a, b) {
            var c = this.u5.dh.ak;
            if (this.er(a, c)) {
                return true;
            }
            var d = this.u5.di.ak;
            if (this.er(a, d)) {
                return true;
            }
            return false;
        };
        SplineAreaFragment.prototype.ep = function (a, b) {
            if (this.u6(a, b)) {
                return true;
            }
            if (this.u7(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        SplineAreaFragment.prototype.u6 = function (a, b) {
            var c = this.u5.dj.ak;
            if (this.eq(a, b, c)) {
                return true;
            }
            var d = this.u5.dk.ak;
            if (this.eq(a, b, d)) {
                return true;
            }
            return false;
        };
        SplineAreaFragment.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.dc();
        };
        SplineAreaFragment.prototype.sl = function (a, b) {
            var _this = this;
            _super.prototype.sl.call(this, a, b);
            this.uz.a = i2.typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
            var c = a.f;
            var d = this.getEffectiveViewport1(b);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var e = false;
            var f = this.rb.b;
            if (f != null) {
                e = true;
            }
            if (e) {
                var g = new ScalerParams(0, b.bv, b.bu, this.tw.cc, d);
                this.sh(c, -1, this.valueColumn.count, this.tw, g, b.q);
            }
            var h = i2.typeCast(SplineAreaFragmentView.$, b);
            var i = b.cr.d;
            this.rb.ad(h.dj, true, false, true, true);
            this.rb.ad(h.dk, true, false, true, true);
            this.rb.ad(h.dh, false, true, false, false);
            this.rb.ad(h.di, false, true, false, false);
            h.dh._opacity = this.rb.j * this.fi;
            h.di._opacity = 0.5 * this.rb.j * this.fi;
            this.uz.i(h.dh, h.dj, h.di, h.dk, a.f.count, a.f, true, i, this.gh, function (j, k, l, m, n) { return _this.u8(j, a.f, b); }, 1);
        };
        SplineAreaFragment.prototype.l2 = function (a, b) {
            _super.prototype.l2.call(this, a, b);
        };
        SplineAreaFragment.prototype.u8 = function (a, b, c) {
            var d = this.s4(c);
            var e = d;
            var f = this.logicalSeriesLink.aj;
            var g = f ? this.parentSeries.s0.e : this.parentSeries.s0.d;
            var h = g.indexOf(this);
            if (a.count == 0) {
                return;
            }
            if (h == -1) {
                return;
            }
            var i = false;
            for (var j = h; j >= 0; j--) {
                if (i) {
                    break;
                }
                if (j == 0) {
                    a.add({ $type: i2.Point_$type, x: a._inner[a.count - 1].x, y: e });
                    a.add({ $type: i2.Point_$type, x: a._inner[0].x, y: e });
                    break;
                }
                var k = i2.typeCast(SplineFragmentBase.$, g._inner[j - 1]);
                if (k != null && k.uz != null && k.uz.o.count > 0 && this.bx != null && k.e3(this.bx.bu, this.bx.bv, this.bx)) {
                    i = true;
                    for (var l = k.uz.o.count - 1; l >= 0; l--) {
                        a.add(k.uz.o._inner[l]);
                    }
                }
            }
        };
        SplineAreaFragment.prototype.s4 = function (a) {
            var b = 0;
            var c = a.bv;
            var d = a.bu;
            var e = this.getEffectiveViewport1(a);
            var f = new ScalerParams(0, c, d, this.yAxis.cc, e);
            if (!c.isEmpty && !d.isEmpty && this.yAxis != null) {
                b = this.yAxis.d8(0, f);
            }
            return b;
        };
        SplineAreaFragment.prototype.ma = function () {
            var a = (i2.typeCast(XamDataChart.$, this.ca));
            if (a != null) {
                this.fi = i2.isNaN_(this.fq) ? this.parentSeries.fi : this.fq;
            }
        };
        Object.defineProperty(SplineAreaFragment.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        SplineAreaFragment.$t = i2.markType(SplineAreaFragment, 'SplineAreaFragment', SplineFragmentBase.$);
        return SplineAreaFragment;
    }(SplineFragmentBase));
    /**
     * @hidden
     */
    var SplineFragment = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineFragment, _super);
        function SplineFragment() {
            var _this = _super.call(this) || this;
            _this.ab = SplineFragment.$;
            return _this;
        }
        SplineFragment.prototype.get_ea = function () {
            return true;
        };
        SplineFragment.prototype.bu = function () {
            return new SplineFragmentView(this);
        };
        SplineFragment.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.u5 = a;
        };
        SplineFragment.prototype.u7 = function (a, b) {
            var c = this.u5.dg.ak;
            if (this.er(a, c)) {
                return true;
            }
            return false;
        };
        SplineFragment.prototype.get_c8 = function () {
            return true;
        };
        SplineFragment.prototype.ep = function (a, b) {
            if (this.u6(a, b)) {
                return true;
            }
            if (this.u7(a, b)) {
                return true;
            }
            if (this.pu(a, b)) {
                return true;
            }
            return false;
        };
        SplineFragment.prototype.u6 = function (a, b) {
            var c = this.u5.dh.ak;
            if (this.eq(a, b, c)) {
                return true;
            }
            var d = this.u5.di.ak;
            if (this.eq(a, b, d)) {
                return true;
            }
            return false;
        };
        SplineFragment.prototype.kh = function (a, b) {
            _super.prototype.kh.call(this, a, b);
            var c = b;
            c.dc();
        };
        SplineFragment.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            this.uz.a = i2.typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
            var c = i2.typeCast(SplineFragmentView.$, b);
            var d = a.f;
            var e = this.getEffectiveViewport1(b);
            this.rb.a0(this, this.rv(), i2.runOn(this, this.qw), this.r3(b), this.r4(b));
            var f = false;
            var g = this.rb.b;
            if (g != null) {
                f = true;
            }
            if (f) {
                var h = new ScalerParams(0, b.bv, b.bu, this.tw.cc, e);
                this.sh(d, -1, this.valueColumn.count, this.tw, h, b.q);
            }
            this.rb.ad(c.dh, true, false, true, false);
            this.rb.ad(c.di, true, false, true, false);
            this.rb.ad(c.dg, false, true, false, false);
            c.dg._opacity = 0.75 * this.rb.j;
            var i = c.cr.d;
            this.uz.m(c.dh, c.dg, c.di, a.f.count, a.f, true, 1, this.st(a.f, a.f.count - 1, b.bu, b.bv), i, this.gh);
        };
        Object.defineProperty(SplineFragment.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        SplineFragment.$t = i2.markType(SplineFragment, 'SplineFragment', SplineFragmentBase.$);
        return SplineFragment;
    }(SplineFragmentBase));
    /**
     * @hidden
     */
    var SplineFragmentBaseValueList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineFragmentBaseValueList, _super);
        function SplineFragmentBaseValueList(a) {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = a;
            return _this;
        }
        SplineFragmentBaseValueList.prototype.indexOf = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.insert = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.removeAt = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.item = function (a, b) {
            if (arguments.length === 2) {
                throw new i2.NotImplementedException(0);
                return b;
            }
            else {
                var b_2 = false;
                if (this.a.parentSeries != null) {
                    b_2 = this.a.parentSeries.s3;
                }
                var c = this.a.parentSeries;
                if (c == null) {
                    return NaN;
                }
                var d = this.a.valueColumn.item(a);
                var e = Math.abs(c.st[a]) + c.ss[a];
                var f = this.a.logicalSeriesLink.ap;
                var g = this.a.logicalSeriesLink.aq;
                if (i2.isNaN_(d) || i2.isInfinity(d)) {
                    d = 0;
                }
                if (b_2) {
                    if (e == 0) {
                        d = 0;
                    }
                    else if (d < 0) {
                        d = (g._inner[a] + d) / e * 100;
                    }
                    else {
                        d = (f._inner[a] + d) / e * 100;
                    }
                }
                else {
                    d = d < 0 ? g._inner[a] + d : f._inner[a] + d;
                }
                return d;
            }
        };
        SplineFragmentBaseValueList.prototype.add = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.clear = function () {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.contains = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.copyTo = function (a, b) {
            throw new i2.NotImplementedException(0);
        };
        Object.defineProperty(SplineFragmentBaseValueList.prototype, "count", {
            get: function () {
                return this.a.valueColumn.count;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SplineFragmentBaseValueList.prototype, "isReadOnly", {
            get: function () {
                throw new i2.NotImplementedException(0);
            },
            enumerable: false,
            configurable: true
        });
        SplineFragmentBaseValueList.prototype.remove = function (a) {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.getEnumerator = function () {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.prototype.getEnumeratorObject = function () {
            throw new i2.NotImplementedException(0);
        };
        SplineFragmentBaseValueList.$t = i2.markType(SplineFragmentBaseValueList, 'SplineFragmentBaseValueList', i2.Base.$, [i2.IList$1_$type.specialize(i2.Number_$type)]);
        return SplineFragmentBaseValueList;
    }(i2.Base));
    /**
     * @hidden
     */
    var StackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesBase, _super);
        function StackedSeriesBase() {
            var _this = _super.call(this) || this;
            _this._series = null;
            _this.seriesCreated = null;
            _this.ta = 0;
            _this.s9 = 0;
            _this.ss = null;
            _this.st = null;
            _this.s0 = null;
            _this.sx = null;
            _this.s6 = new i2.Dictionary$2(i2.String_$type, i2.Boolean_$type, 0);
            _this.su = null;
            _this.series = new StackedSeriesCollection();
            var a = _this.series;
            a.collectionResetting = i2.delegateCombine(a.collectionResetting, i2.runOn(_this, _this.tm));
            var b = _this.series;
            b.collectionChanged = i2.delegateCombine(b.collectionChanged, i2.runOn(_this, _this.tl));
            _this.q8 = new StackedSeriesFramePreparer(1, _this, _this.s1, _this, _this, _this.s1.cr);
            _this.s0 = new StackedSeriesManager(_this);
            _this.sx = new StackedSeriesCollection();
            var c = _this.sx;
            c.collectionChanged = i2.delegateCombine(c.collectionChanged, i2.runOn(_this, _this.tl));
            var d = _this.sx;
            d.collectionResetting = i2.delegateCombine(d.collectionResetting, i2.runOn(_this, _this.tg));
            return _this;
        }
        StackedSeriesBase.prototype.k2 = function () {
            var e_1, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.ey();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            _super.prototype.k2.call(this);
        };
        StackedSeriesBase.prototype.get_dr = function () {
            return false;
        };
        StackedSeriesBase.prototype.getHostReferenceValue = function () {
            return this.f2();
        };
        StackedSeriesBase.prototype.bu = function () {
            return new StackedSeriesView(this);
        };
        StackedSeriesBase.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.s1 = a;
        };
        StackedSeriesBase.prototype.li = function (a, b) {
            var e_2, _a;
            _super.prototype.li.call(this, a, b);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.visualSeriesLink.bx.bu = b;
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        };
        Object.defineProperty(StackedSeriesBase.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesBase.prototype.g8 = function () {
            if (this.series == null) {
                return -1;
            }
            return this.series.count;
        };
        StackedSeriesBase.prototype.ku = function (a) {
            for (var b = 0; b < this.s0.f.count; b++) {
                var c = this.s0.f._inner[b];
                if (!a(c)) {
                    break;
                }
            }
        };
        StackedSeriesBase.prototype.get_isStacked = function () {
            return true;
        };
        Object.defineProperty(StackedSeriesBase.prototype, "sw", {
            get: function () {
                return this.s2 ? this.sx : this.series;
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesBase.prototype.tg = function (a, b) {
            var e_3, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.sx)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.s0 != null && this.s0.c.contains(c)) {
                        c.parentSeries = null;
                        this.s0.c.remove(c);
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
        };
        StackedSeriesBase.prototype.tm = function (a, b) {
            var e_4, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.s0 != null && this.s0.c.contains(c)) {
                        c.parentSeries = null;
                        this.s0.c.remove(c);
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        };
        StackedSeriesBase.prototype.tl = function (a, b) {
            var e_5, _a, e_6, _b;
            if (b.oldItems != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        if (this.s0 != null && this.s0.c.contains(c)) {
                            c.parentSeries = null;
                            this.s0.c.remove(c);
                        }
                    }
                }
                catch (e_5_1) {
                    e_5 = { error: e_5_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_5)
                            throw e_5.error;
                    }
                }
            }
            if (b.newItems != null) {
                var d = b.newStartingIndex;
                try {
                    for (var _e = tslib.__values(i2.fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var e = _f.value;
                        if (this.s0 != null && !this.s0.c.contains(e)) {
                            e.parentSeries = this;
                            e.ej();
                            e.e5();
                            e.e6();
                            e.fd();
                            e.e7();
                            e.e8();
                            e.ee();
                            e.ef();
                            e.ei();
                            e.eg();
                            e.eh();
                            e.ek();
                            e.ep();
                            e.eq();
                            e.er();
                            e.ew();
                            e.ey();
                            e.es();
                            e.eu();
                            e.ev();
                            e.ew();
                            e.ex();
                            e.ez();
                            e.e0();
                            e.e1();
                            e.ed();
                            e.e3();
                            e.e4();
                            e.e9();
                            e.fa();
                            e.fb();
                            e.et();
                            e.e2();
                            e.fc();
                            e.fe();
                            if (!this.s2) {
                                this.s0.c.insert(d, e);
                                d++;
                            }
                        }
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
            }
            if (!this.s2) {
                this.tn();
            }
        };
        StackedSeriesBase.prototype.l7 = function (a) {
            this.b8.cf.c5(a, true, false);
        };
        StackedSeriesBase.prototype.q9 = function (a) {
            if (a != null && a.q) {
                if (a.p) {
                    return new StackedSeriesFramePreparer(1, i2.typeCast(IIsCategoryBased_$type, this), i2.typeCast(ISupportsMarkers_$type, a), a, this, a.cr);
                }
                else {
                    var b = i2.typeCast(CategorySeriesView.$, this.bw);
                    return new StackedSeriesFramePreparer(1, this, i2.typeCast(ISupportsMarkers_$type, b), this.ca.cf.o, this, b.cr);
                }
            }
            else {
                return this.q8;
            }
        };
        StackedSeriesBase.prototype.si = function (a, b) {
            a.u();
            this.tj();
            this.q9(b).d(a, b);
        };
        StackedSeriesBase.prototype.kh = function (a, b) {
            var e_7, _a;
            _super.prototype.kh.call(this, a, b);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (c.visualSeriesLink != null) {
                        c.visualSeriesLink.kh(a, c.visualSeriesLink.bx);
                    }
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        };
        StackedSeriesBase.prototype.th = function () {
            this.tj();
        };
        StackedSeriesBase.prototype.tn = function () {
            var a = this.fetchXAxis();
            if (a != null) {
                a.cw(true);
            }
            var b = this.fetchYAxis();
            if (b != null) {
                b.cw(true);
            }
        };
        StackedSeriesBase.prototype.get_s3 = function () {
            return false;
        };
        Object.defineProperty(StackedSeriesBase.prototype, "s3", {
            get: function () {
                return this.get_s3();
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesBase.prototype.eh = function (a) {
            var b = this.ch != null ? this.ch.indexOf(a) : -1;
            var c = this.ca != null ? this.ca.pg : i2.Rect.empty;
            c = c.copy();
            var d = this.bx.bu;
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = this.o9(this.bx);
            if (b >= 0 && i2.Rect.l_op_Inequality(c, null) && i2.Rect.l_op_Inequality(d, null)) {
                var g = this.fetchXAxis();
                if (g != null) {
                    var h = new ScalerParams(0, e, e, g.cc, f);
                    var i = g.d8(b, h);
                    if (i < c.left + 0.1 * c.width) {
                        i = i + 0.4 * c.width;
                    }
                    if (i > c.right - 0.1 * c.width) {
                        i = i - 0.4 * c.width;
                    }
                    c.x = i - 0.5 * c.width;
                }
                var j = this.fetchYAxis();
                if (j != null && this.ss != null && b < this.ss.length) {
                    var k = new ScalerParams(0, e, e, j.cc, f);
                    var l = j.d8(this.ss[b], k);
                    var m = j.d8(this.st[b], k);
                    if (!i2.isNaN_(l) && !i2.isNaN_(m)) {
                        var n = Math.abs(m - l);
                        if (c.height < n) {
                            c.height = n;
                            c.y = Math.min(m, l);
                        }
                        else {
                            if (m < c.top + 0.1 * c.height) {
                                m = m + 0.4 * c.height;
                            }
                            if (m > c.bottom - 0.1 * c.height) {
                                m = m - 0.4 * c.height;
                            }
                            c.y = m - 0.5 * c.height;
                        }
                    }
                }
                this.b5.ap(this.ca, c, true);
            }
            return b >= 0;
        };
        StackedSeriesBase.prototype.ap = function (a) {
            if (this.st == null || this.st.length == 0 || this.ss == null || this.ss.length == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                var b = Math.min(this.st.length, this.ss.length);
                return new AxisRange(0, b - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedSeriesBase.prototype.pt = function () {
            return false;
        };
        StackedSeriesBase.prototype.kk = function (a, b, c, d) {
            this.tj();
            this.rx();
            this.l0(false);
        };
        StackedSeriesBase.prototype.sv = function () {
            return this.s1;
        };
        StackedSeriesBase.prototype.s7 = function () {
            var a = 0;
            var b = this.bx.bv;
            var c = this.bx.bu;
            var d = this.getEffectiveViewport1(this.bx);
            var e = i2.typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!b.isEmpty && !c.isEmpty && e != null) {
                var f = new ScalerParams(0, b, c, e.cc, d);
                a = e.d8(e.k5, f);
            }
            return a;
        };
        StackedSeriesBase.prototype.s8 = function () {
            var a = i2.typeCast(NumericYAxis.$, this.fetchYAxis());
            if (a != null) {
                return a.k5;
            }
            return 0;
        };
        StackedSeriesBase.prototype.tc = function (a) {
            return this.g9 < 0 || this.sw == null || this.sw.count == 0 ? -1 : this.g9 + this.sw.indexOf(a);
        };
        StackedSeriesBase.prototype.tb = function (a) {
            var b = this.ca != null ? this.ca.pg : i2.Rect.empty;
            var c = this.bx.bu;
            var d = this.getEffectiveViewport1(this.bx);
            var e = i2.typeCast(CategoryAxisBase.$, this.fetchXAxis());
            var f = -1;
            if (e != null && !b.isEmpty && !c.isEmpty) {
                var g = new ScalerParams(0, b, c, e.cc, d);
                var h = this.o7(this.bx);
                var i = e.eb(h.left, g);
                var j = e.eb(h.right, g);
                var k = (a.x - b.left) / b.width;
                var l = i + (k * (j - i));
                if (e.categoryMode != 0) {
                    l -= 0.5;
                }
                var m = i2.truncate(Math.round(l));
                f = m;
            }
            return f;
        };
        StackedSeriesBase.prototype.s5 = function (a, b, c, d) {
            var e = true;
            var f = i2.typeCast(CategoryAxisBase.$, this.fetchXAxis());
            var g = i2.typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!d.o() || c.isEmpty || b.isEmpty || f == null || f.itemsSource == null || g == null || this.ch == null || f.bh == null || g.bh == null || g.kv == g.ku) {
                e = false;
            }
            var h = d;
            var i = h.cr.d;
            if (a.valueColumn == null || a.valueColumn.count == 0 || i < 1 || a._visibility != 0) {
                e = false;
            }
            return e;
        };
        StackedSeriesBase.prototype.ti = function () {
            var e_8, _a;
            if (this.ca == null || this.s0 == null) {
                return;
            }
            if (!this.s2) {
                this.sx.clear();
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var a = _c.value;
                        if (!this.s0.c.contains(a)) {
                            this.s0.c.add(a);
                        }
                    }
                }
                catch (e_8_1) {
                    e_8 = { error: e_8_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_8)
                            throw e_8.error;
                    }
                }
                this.tn();
                return;
            }
        };
        StackedSeriesBase.prototype.sl = function (a, b) {
            _super.prototype.sl.call(this, a, b);
            this.s0.h();
        };
        StackedSeriesBase.prototype.tk = function (a, b, c) {
        };
        StackedSeriesBase.prototype.tj = function () {
            var e_9, _a;
            if (this.ch == null) {
                return;
            }
            var a = this.ch.count;
            this.ss = new Array(a);
            this.st = new Array(a);
            for (var b = 0; b < a; b++) {
                this.ss[b] = 0;
                this.st[b] = 0;
            }
            this.ta = Number.POSITIVE_INFINITY;
            this.s9 = Number.NEGATIVE_INFINITY;
            var c = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (d.itemsSource != null && d.visualSeriesLink == null) {
                        continue;
                    }
                    if (d.itemsSource != null) {
                        d.x = d.visualSeriesLink.valueColumn;
                    }
                    if (d.itemsSource == null) {
                        this.ch.deregisterColumn(d.x);
                        d.x = this.ce(d.d4);
                    }
                    if (d.visualSeriesLink != null && d.itemsSource == null) {
                        d.visualSeriesLink.s3 = true;
                        d.visualSeriesLink.valueColumn = d.x;
                        d.visualSeriesLink.s3 = false;
                    }
                    d.aj = true;
                    if (d.x != null) {
                        d.ap.clear();
                        d.aq.clear();
                        for (var e = 0; e < d.x.count; e++) {
                            var f = d.x.item(e);
                            if (f < c) {
                                d.ap.add(c);
                                d.aq.add(this.st[e]);
                                this.st[e] = this.st[e] + f;
                                if (d.aj) {
                                    d.aj = false;
                                }
                            }
                            else if (f >= c) {
                                d.ap.add(this.ss[e]);
                                d.aq.add(c);
                                this.ss[e] = this.ss[e] + f;
                            }
                            else if (i2.isNaN_(f) || i2.isInfinity(f)) {
                                d.ap.add(this.ss[e]);
                                d.aq.add(this.st[e]);
                            }
                        }
                    }
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            for (var g = 0; g < a; g++) {
                this.ta = Math.min(this.ta, this.st[g]);
                this.s9 = Math.max(this.s9, this.ss[g]);
            }
        };
        StackedSeriesBase.prototype.lm = function (a, b, c, d) {
            var e_10, _a, e_11, _b, e_12, _c, e_13, _d, e_14, _e, e_15, _f, e_16, _g, e_17, _h, e_18, _j, e_19, _k, e_20, _l, e_21, _m, e_22, _o, e_23, _p, e_24, _q, e_25, _r, e_26, _s, e_27, _t, e_28, _u, e_29, _v, e_30, _w, e_31, _x, e_32, _y, e_33, _z, e_34, _0, e_35, _1, e_36, _2, e_37, _3, e_38, _4, e_39, _5, e_40, _6, e_41, _7, e_42, _8, e_43, _9, e_44, _10, e_45, _11;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (c != null && d == null) {
                        this.kl(this.fetchXAxis());
                        this.kl(this.fetchYAxis());
                    }
                    if (c == null && d != null) {
                        this.lr(this.fetchXAxis());
                        this.lr(this.fetchYAxis());
                    }
                    if (this.sw != null) {
                        try {
                            for (var _12 = tslib.__values(i2.fromEnum(this.sw)), _13 = _12.next(); !_13.done; _13 = _12.next()) {
                                var e = _13.value;
                                e.w = this.ca;
                            }
                        }
                        catch (e_10_1) {
                            e_10 = { error: e_10_1 };
                        }
                        finally {
                            try {
                                if (_13 && !_13.done && (_a = _12.return))
                                    _a.call(_12);
                            }
                            finally {
                                if (e_10)
                                    throw e_10.error;
                            }
                        }
                        this.l0(false);
                    }
                    break;
                case "ItemsSource":
                    if (this.sw != null) {
                        try {
                            for (var _14 = tslib.__values(i2.fromEnum(this.sw)), _15 = _14.next(); !_15.done; _15 = _14.next()) {
                                var f = _15.value;
                                if (f.itemsSource == null) {
                                    if (f.visualSeriesLink != null) {
                                        f.visualSeriesLink.itemsSource = d;
                                    }
                                }
                            }
                        }
                        catch (e_11_1) {
                            e_11 = { error: e_11_1 };
                        }
                        finally {
                            try {
                                if (_15 && !_15.done && (_b = _14.return))
                                    _b.call(_14);
                            }
                            finally {
                                if (e_11)
                                    throw e_11.error;
                            }
                        }
                    }
                    break;
                case "FastItemsSource":
                    if (this.s2) {
                        this.ti();
                    }
                    if (!this.rx()) {
                        this.s1.cr.g(this.gh);
                    }
                    this.l0(false);
                    break;
                case StackedSeriesBase.$$p[0]:
                    this.ti();
                    break;
                case StackedSeriesBase.$$p[1]:
                    if (this.ca != null) {
                        this.ca.km(this.s0.f);
                    }
                    break;
                case StackedSeriesBase.$$p[2]:
                    try {
                        for (var _16 = tslib.__values(i2.fromEnum(this.sw)), _17 = _16.next(); !_17.done; _17 = _16.next()) {
                            var g = _17.value;
                            g.fe();
                        }
                    }
                    catch (e_12_1) {
                        e_12 = { error: e_12_1 };
                    }
                    finally {
                        try {
                            if (_17 && !_17.done && (_c = _16.return))
                                _c.call(_16);
                        }
                        finally {
                            if (e_12)
                                throw e_12.error;
                        }
                    }
                    break;
                case "Brush":
                    try {
                        for (var _18 = tslib.__values(i2.fromEnum(this.sw)), _19 = _18.next(); !_19.done; _19 = _18.next()) {
                            var h = _19.value;
                            h.ee();
                        }
                    }
                    catch (e_13_1) {
                        e_13 = { error: e_13_1 };
                    }
                    finally {
                        try {
                            if (_19 && !_19.done && (_d = _18.return))
                                _d.call(_18);
                        }
                        finally {
                            if (e_13)
                                throw e_13.error;
                        }
                    }
                    break;
                case "DashArray":
                    try {
                        for (var _20 = tslib.__values(i2.fromEnum(this.sw)), _21 = _20.next(); !_21.done; _21 = _20.next()) {
                            var i = _21.value;
                            i.ef();
                        }
                    }
                    catch (e_14_1) {
                        e_14 = { error: e_14_1 };
                    }
                    finally {
                        try {
                            if (_21 && !_21.done && (_e = _20.return))
                                _e.call(_20);
                        }
                        finally {
                            if (e_14)
                                throw e_14.error;
                        }
                    }
                    break;
                case "HighlightingFadeOpacity":
                    try {
                        for (var _22 = tslib.__values(i2.fromEnum(this.sw)), _23 = _22.next(); !_23.done; _23 = _22.next()) {
                            var j = _23.value;
                            j.ei();
                        }
                    }
                    catch (e_15_1) {
                        e_15 = { error: e_15_1 };
                    }
                    finally {
                        try {
                            if (_23 && !_23.done && (_f = _22.return))
                                _f.call(_22);
                        }
                        finally {
                            if (e_15)
                                throw e_15.error;
                        }
                    }
                    break;
                case "DashCap":
                    try {
                        for (var _24 = tslib.__values(i2.fromEnum(this.sw)), _25 = _24.next(); !_25.done; _25 = _24.next()) {
                            var k = _25.value;
                            k.eg();
                        }
                    }
                    catch (e_16_1) {
                        e_16 = { error: e_16_1 };
                    }
                    finally {
                        try {
                            if (_25 && !_25.done && (_g = _24.return))
                                _g.call(_24);
                        }
                        finally {
                            if (e_16)
                                throw e_16.error;
                        }
                    }
                    break;
                case "IsDropShadowEnabled":
                    try {
                        for (var _26 = tslib.__values(i2.fromEnum(this.sw)), _27 = _26.next(); !_27.done; _27 = _26.next()) {
                            var l = _27.value;
                            l.ej();
                        }
                    }
                    catch (e_17_1) {
                        e_17 = { error: e_17_1 };
                    }
                    finally {
                        try {
                            if (_27 && !_27.done && (_h = _26.return))
                                _h.call(_26);
                        }
                        finally {
                            if (e_17)
                                throw e_17.error;
                        }
                    }
                    break;
                case "ShadowBlur":
                    try {
                        for (var _28 = tslib.__values(i2.fromEnum(this.sw)), _29 = _28.next(); !_29.done; _29 = _28.next()) {
                            var m = _29.value;
                            m.e5();
                        }
                    }
                    catch (e_18_1) {
                        e_18 = { error: e_18_1 };
                    }
                    finally {
                        try {
                            if (_29 && !_29.done && (_j = _28.return))
                                _j.call(_28);
                        }
                        finally {
                            if (e_18)
                                throw e_18.error;
                        }
                    }
                    break;
                case "ShadowColor":
                    try {
                        for (var _30 = tslib.__values(i2.fromEnum(this.sw)), _31 = _30.next(); !_31.done; _31 = _30.next()) {
                            var n = _31.value;
                            n.e6();
                        }
                    }
                    catch (e_19_1) {
                        e_19 = { error: e_19_1 };
                    }
                    finally {
                        try {
                            if (_31 && !_31.done && (_k = _30.return))
                                _k.call(_30);
                        }
                        finally {
                            if (e_19)
                                throw e_19.error;
                        }
                    }
                    break;
                case "UseSingleShadow":
                    try {
                        for (var _32 = tslib.__values(i2.fromEnum(this.sw)), _33 = _32.next(); !_33.done; _33 = _32.next()) {
                            var o = _33.value;
                            o.fd();
                        }
                    }
                    catch (e_20_1) {
                        e_20 = { error: e_20_1 };
                    }
                    finally {
                        try {
                            if (_33 && !_33.done && (_l = _32.return))
                                _l.call(_32);
                        }
                        finally {
                            if (e_20)
                                throw e_20.error;
                        }
                    }
                    break;
                case "ShadowOffsetX":
                    try {
                        for (var _34 = tslib.__values(i2.fromEnum(this.sw)), _35 = _34.next(); !_35.done; _35 = _34.next()) {
                            var p = _35.value;
                            p.e7();
                        }
                    }
                    catch (e_21_1) {
                        e_21 = { error: e_21_1 };
                    }
                    finally {
                        try {
                            if (_35 && !_35.done && (_m = _34.return))
                                _m.call(_34);
                        }
                        finally {
                            if (e_21)
                                throw e_21.error;
                        }
                    }
                    break;
                case "ShadowOffsetY":
                    try {
                        for (var _36 = tslib.__values(i2.fromEnum(this.sw)), _37 = _36.next(); !_37.done; _37 = _36.next()) {
                            var q = _37.value;
                            q.e8();
                        }
                    }
                    catch (e_22_1) {
                        e_22 = { error: e_22_1 };
                    }
                    finally {
                        try {
                            if (_37 && !_37.done && (_o = _36.return))
                                _o.call(_36);
                        }
                        finally {
                            if (e_22)
                                throw e_22.error;
                        }
                    }
                    break;
                case "EndCap":
                    try {
                        for (var _38 = tslib.__values(i2.fromEnum(this.sw)), _39 = _38.next(); !_39.done; _39 = _38.next()) {
                            var r = _39.value;
                            r.eh();
                        }
                    }
                    catch (e_23_1) {
                        e_23 = { error: e_23_1 };
                    }
                    finally {
                        try {
                            if (_39 && !_39.done && (_p = _38.return))
                                _p.call(_38);
                        }
                        finally {
                            if (e_23)
                                throw e_23.error;
                        }
                    }
                    break;
                case "IsHitTestVisible":
                    try {
                        for (var _40 = tslib.__values(i2.fromEnum(this.sw)), _41 = _40.next(); !_41.done; _41 = _40.next()) {
                            var s = _41.value;
                            s.ek();
                        }
                    }
                    catch (e_24_1) {
                        e_24 = { error: e_24_1 };
                    }
                    finally {
                        try {
                            if (_41 && !_41.done && (_q = _40.return))
                                _q.call(_40);
                        }
                        finally {
                            if (e_24)
                                throw e_24.error;
                        }
                    }
                    break;
                case "LegendItemBadgeTemplate":
                    try {
                        for (var _42 = tslib.__values(i2.fromEnum(this.sw)), _43 = _42.next(); !_43.done; _43 = _42.next()) {
                            var t = _43.value;
                            t.ep();
                        }
                    }
                    catch (e_25_1) {
                        e_25 = { error: e_25_1 };
                    }
                    finally {
                        try {
                            if (_43 && !_43.done && (_r = _42.return))
                                _r.call(_42);
                        }
                        finally {
                            if (e_25)
                                throw e_25.error;
                        }
                    }
                    break;
                case "LegendItemTemplate":
                    try {
                        for (var _44 = tslib.__values(i2.fromEnum(this.sw)), _45 = _44.next(); !_45.done; _45 = _44.next()) {
                            var u = _45.value;
                            u.eq();
                        }
                    }
                    catch (e_26_1) {
                        e_26 = { error: e_26_1 };
                    }
                    finally {
                        try {
                            if (_45 && !_45.done && (_s = _44.return))
                                _s.call(_44);
                        }
                        finally {
                            if (e_26)
                                throw e_26.error;
                        }
                    }
                    break;
                case "LegendItemVisibility":
                    try {
                        for (var _46 = tslib.__values(i2.fromEnum(this.sw)), _47 = _46.next(); !_47.done; _47 = _46.next()) {
                            var v = _47.value;
                            v.er();
                        }
                    }
                    catch (e_27_1) {
                        e_27 = { error: e_27_1 };
                    }
                    finally {
                        try {
                            if (_47 && !_47.done && (_t = _46.return))
                                _t.call(_46);
                        }
                        finally {
                            if (e_27)
                                throw e_27.error;
                        }
                    }
                    break;
                case "LegendItemBadgeShape":
                    try {
                        for (var _48 = tslib.__values(i2.fromEnum(this.sw)), _49 = _48.next(); !_49.done; _49 = _48.next()) {
                            var w = _49.value;
                            w.eo();
                        }
                    }
                    catch (e_28_1) {
                        e_28 = { error: e_28_1 };
                    }
                    finally {
                        try {
                            if (_49 && !_49.done && (_u = _48.return))
                                _u.call(_48);
                        }
                        finally {
                            if (e_28)
                                throw e_28.error;
                        }
                    }
                    break;
                case "LegendItemBadgeMode":
                    try {
                        for (var _50 = tslib.__values(i2.fromEnum(this.sw)), _51 = _50.next(); !_51.done; _51 = _50.next()) {
                            var x = _51.value;
                            x.en();
                        }
                    }
                    catch (e_29_1) {
                        e_29 = { error: e_29_1 };
                    }
                    finally {
                        try {
                            if (_51 && !_51.done && (_v = _50.return))
                                _v.call(_50);
                        }
                        finally {
                            if (e_29)
                                throw e_29.error;
                        }
                    }
                    break;
                case "MarkerTemplate":
                    try {
                        for (var _52 = tslib.__values(i2.fromEnum(this.sw)), _53 = _52.next(); !_53.done; _53 = _52.next()) {
                            var y = _53.value;
                            y.ew();
                        }
                    }
                    catch (e_30_1) {
                        e_30 = { error: e_30_1 };
                    }
                    finally {
                        try {
                            if (_53 && !_53.done && (_w = _52.return))
                                _w.call(_52);
                        }
                        finally {
                            if (e_30)
                                throw e_30.error;
                        }
                    }
                    break;
                case "MarkerType":
                    try {
                        for (var _54 = tslib.__values(i2.fromEnum(this.sw)), _55 = _54.next(); !_55.done; _55 = _54.next()) {
                            var z = _55.value;
                            z.ey();
                        }
                    }
                    catch (e_31_1) {
                        e_31 = { error: e_31_1 };
                    }
                    finally {
                        try {
                            if (_55 && !_55.done && (_x = _54.return))
                                _x.call(_54);
                        }
                        finally {
                            if (e_31)
                                throw e_31.error;
                        }
                    }
                    break;
                case "MarkerThickness":
                    try {
                        for (var _56 = tslib.__values(i2.fromEnum(this.sw)), _57 = _56.next(); !_57.done; _57 = _56.next()) {
                            var aa = _57.value;
                            aa.ex();
                        }
                    }
                    catch (e_32_1) {
                        e_32 = { error: e_32_1 };
                    }
                    finally {
                        try {
                            if (_57 && !_57.done && (_y = _56.return))
                                _y.call(_56);
                        }
                        finally {
                            if (e_32)
                                throw e_32.error;
                        }
                    }
                    break;
                case "MarkerBrush":
                    try {
                        for (var _58 = tslib.__values(i2.fromEnum(this.sw)), _59 = _58.next(); !_59.done; _59 = _58.next()) {
                            var ab = _59.value;
                            ab.es();
                        }
                    }
                    catch (e_33_1) {
                        e_33 = { error: e_33_1 };
                    }
                    finally {
                        try {
                            if (_59 && !_59.done && (_z = _58.return))
                                _z.call(_58);
                        }
                        finally {
                            if (e_33)
                                throw e_33.error;
                        }
                    }
                    break;
                case "MarkerOutline":
                    try {
                        for (var _60 = tslib.__values(i2.fromEnum(this.sw)), _61 = _60.next(); !_61.done; _61 = _60.next()) {
                            var ac = _61.value;
                            ac.eu();
                        }
                    }
                    catch (e_34_1) {
                        e_34 = { error: e_34_1 };
                    }
                    finally {
                        try {
                            if (_61 && !_61.done && (_0 = _60.return))
                                _0.call(_60);
                        }
                        finally {
                            if (e_34)
                                throw e_34.error;
                        }
                    }
                    break;
                case "MarkerStyle":
                    try {
                        for (var _62 = tslib.__values(i2.fromEnum(this.sw)), _63 = _62.next(); !_63.done; _63 = _62.next()) {
                            var ad = _63.value;
                            ad.ev();
                        }
                    }
                    catch (e_35_1) {
                        e_35 = { error: e_35_1 };
                    }
                    finally {
                        try {
                            if (_63 && !_63.done && (_1 = _62.return))
                                _1.call(_62);
                        }
                        finally {
                            if (e_35)
                                throw e_35.error;
                        }
                    }
                    break;
                case "Opacity":
                    try {
                        for (var _64 = tslib.__values(i2.fromEnum(this.sw)), _65 = _64.next(); !_65.done; _65 = _64.next()) {
                            var ae = _65.value;
                            ae.ez();
                        }
                    }
                    catch (e_36_1) {
                        e_36 = { error: e_36_1 };
                    }
                    finally {
                        try {
                            if (_65 && !_65.done && (_2 = _64.return))
                                _2.call(_64);
                        }
                        finally {
                            if (e_36)
                                throw e_36.error;
                        }
                    }
                    break;
                case "OpacityMask":
                    try {
                        for (var _66 = tslib.__values(i2.fromEnum(this.sw)), _67 = _66.next(); !_67.done; _67 = _66.next()) {
                            var af = _67.value;
                            af.e0();
                        }
                    }
                    catch (e_37_1) {
                        e_37 = { error: e_37_1 };
                    }
                    finally {
                        try {
                            if (_67 && !_67.done && (_3 = _66.return))
                                _3.call(_66);
                        }
                        finally {
                            if (e_37)
                                throw e_37.error;
                        }
                    }
                    break;
                case "AreaFillOpacity":
                    try {
                        for (var _68 = tslib.__values(i2.fromEnum(this.sw)), _69 = _68.next(); !_69.done; _69 = _68.next()) {
                            var ag = _69.value;
                            ag.ed();
                        }
                    }
                    catch (e_38_1) {
                        e_38 = { error: e_38_1 };
                    }
                    finally {
                        try {
                            if (_69 && !_69.done && (_4 = _68.return))
                                _4.call(_68);
                        }
                        finally {
                            if (e_38)
                                throw e_38.error;
                        }
                    }
                    break;
                case "Outline":
                    try {
                        for (var _70 = tslib.__values(i2.fromEnum(this.sw)), _71 = _70.next(); !_71.done; _71 = _70.next()) {
                            var ah = _71.value;
                            ah.e1();
                        }
                    }
                    catch (e_39_1) {
                        e_39 = { error: e_39_1 };
                    }
                    finally {
                        try {
                            if (_71 && !_71.done && (_5 = _70.return))
                                _5.call(_70);
                        }
                        finally {
                            if (e_39)
                                throw e_39.error;
                        }
                    }
                    break;
                case "StartCap":
                    try {
                        for (var _72 = tslib.__values(i2.fromEnum(this.sw)), _73 = _72.next(); !_73.done; _73 = _72.next()) {
                            var ai = _73.value;
                            ai.e9();
                        }
                    }
                    catch (e_40_1) {
                        e_40 = { error: e_40_1 };
                    }
                    finally {
                        try {
                            if (_73 && !_73.done && (_6 = _72.return))
                                _6.call(_72);
                        }
                        finally {
                            if (e_40)
                                throw e_40.error;
                        }
                    }
                    break;
                case "OutlineMode":
                    try {
                        for (var _74 = tslib.__values(i2.fromEnum(this.sw)), _75 = _74.next(); !_75.done; _75 = _74.next()) {
                            var aj = _75.value;
                            aj.e2();
                        }
                    }
                    catch (e_41_1) {
                        e_41 = { error: e_41_1 };
                    }
                    finally {
                        try {
                            if (_75 && !_75.done && (_7 = _74.return))
                                _7.call(_74);
                        }
                        finally {
                            if (e_41)
                                throw e_41.error;
                        }
                    }
                    break;
                case "MarkerFillOpacity":
                    try {
                        for (var _76 = tslib.__values(i2.fromEnum(this.sw)), _77 = _76.next(); !_77.done; _77 = _76.next()) {
                            var ak = _77.value;
                            ak.et();
                        }
                    }
                    catch (e_42_1) {
                        e_42 = { error: e_42_1 };
                    }
                    finally {
                        try {
                            if (_77 && !_77.done && (_8 = _76.return))
                                _8.call(_76);
                        }
                        finally {
                            if (e_42)
                                throw e_42.error;
                        }
                    }
                    break;
                case "Thickness":
                    try {
                        for (var _78 = tslib.__values(i2.fromEnum(this.sw)), _79 = _78.next(); !_79.done; _79 = _78.next()) {
                            var al = _79.value;
                            al.fa();
                        }
                    }
                    catch (e_43_1) {
                        e_43 = { error: e_43_1 };
                    }
                    finally {
                        try {
                            if (_79 && !_79.done && (_9 = _78.return))
                                _9.call(_78);
                        }
                        finally {
                            if (e_43)
                                throw e_43.error;
                        }
                    }
                    break;
                case "ToolTip":
                    try {
                        for (var _80 = tslib.__values(i2.fromEnum(this.sw)), _81 = _80.next(); !_81.done; _81 = _80.next()) {
                            var am = _81.value;
                            am.fb();
                        }
                    }
                    catch (e_44_1) {
                        e_44 = { error: e_44_1 };
                    }
                    finally {
                        try {
                            if (_81 && !_81.done && (_10 = _80.return))
                                _10.call(_80);
                        }
                        finally {
                            if (e_44)
                                throw e_44.error;
                        }
                    }
                    break;
                case "UseLightweightMarkers":
                    try {
                        for (var _82 = tslib.__values(i2.fromEnum(this.sw)), _83 = _82.next(); !_83.done; _83 = _82.next()) {
                            var an = _83.value;
                            an.fc();
                        }
                    }
                    catch (e_45_1) {
                        e_45 = { error: e_45_1 };
                    }
                    finally {
                        try {
                            if (_83 && !_83.done && (_11 = _82.return))
                                _11.call(_82);
                        }
                        finally {
                            if (e_45)
                                throw e_45.error;
                        }
                    }
                    break;
            }
        };
        Object.defineProperty(StackedSeriesBase.prototype, "currentCategoryMode", {
            get: function () {
                return this.preferredCategoryMode(i2.typeCast(CategoryAxisBase.$, this.q2()));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesBase.prototype, "scaler", {
            get: function () {
                return i2.typeCast(ICategoryScaler_$type, this.q2());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesBase.prototype, "yScaler", {
            get: function () {
                return i2.typeCast(IScaler_$type, this.rn());
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesBase.prototype, "bucketizer", {
            get: function () {
                return this.rc.cr;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesBase.prototype, "currentMode2Index", {
            get: function () {
                return this.r6();
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesBase.prototype.provideCollisionDetector = function () {
            return new CollisionAvoider();
        };
        StackedSeriesBase.prototype.ek = function () {
            return false;
        };
        StackedSeriesBase.prototype.get_dh = function () {
            return false;
        };
        StackedSeriesBase.prototype.l2 = function (a, b) {
            var e_46, _a;
            var c = this.et;
            _super.prototype.l2.call(this, a, b);
            if (!c) {
                this.bx.a2(b);
                return;
            }
            this.bx.a2(b);
            if (this.ct(this.bw)) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    d.visualSeriesLink.l2(a, b);
                }
            }
            catch (e_46_1) {
                e_46 = { error: e_46_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_46)
                        throw e_46.error;
                }
            }
            this.et = false;
        };
        StackedSeriesBase.prototype.lz = function (a, b, c, d, e) {
            var e_47, _a;
            _super.prototype.lz.call(this, a, b, c, d, e);
            var f = this.a4.a$h.item(d);
            f.cr.g(this.gh);
            f.a1(c);
            if (this.ct(f)) {
                return;
            }
            if (this.su == null) {
                this.su = new CategoryFrame(3);
            }
            this.su.u();
            this.tj();
            this.q9(f).d(this.su, f);
            this.sl(this.su, f);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    g.visualSeriesLink.lz(a, b, c, d, e);
                }
            }
            catch (e_47_1) {
                e_47 = { error: e_47_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_47)
                        throw e_47.error;
                }
            }
        };
        StackedSeriesBase.prototype.hg = function () {
            var e_48, _a;
            var a = this.a6.exportStackedVisualData(this, this.pf);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    var c = this.a6.createFragmentVisualData(this, this.pf, i2.getInstanceType(b).typeName, b.dk);
                    b.visualSeriesLink.bx.al(c);
                    this.a6.addSubSeriesVisualData(a, c);
                }
            }
            catch (e_48_1) {
                e_48 = { error: e_48_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_48)
                        throw e_48.error;
                }
            }
            this.kr(a);
            this.bx.al(a);
            return a;
        };
        Object.defineProperty(StackedSeriesBase.prototype, "mayContainUnknowns", {
            get: function () {
                return true;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesBase.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesBase.$t = i2.markType(StackedSeriesBase, 'StackedSeriesBase', CategorySeries.$, [IIsCategoryBased_$type]);
        StackedSeriesBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StackedSeriesBase, 'raisePropertyChanged', ['AutoGenerateSeries:s2:to', [0, false], 'ReverseLegendOrder:s4:tp', [0, false], 'SeriesVisibility:tr:tq', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)]]);
        return StackedSeriesBase;
    }(CategorySeries));
    /**
     * @hidden
     */
    var HorizontalStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalStackedSeriesBase, _super);
        function HorizontalStackedSeriesBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        HorizontalStackedSeriesBase.prototype.getOffsetValue = function () {
            return this.q8.r(this.xAxis, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        HorizontalStackedSeriesBase.prototype.getCategoryWidth = function () {
            return this.xAxis.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        HorizontalStackedSeriesBase.prototype.fetchXAxis = function () {
            return this.xAxis;
        };
        HorizontalStackedSeriesBase.prototype.fetchYAxis = function () {
            return this.yAxis;
        };
        HorizontalStackedSeriesBase.prototype.ag = function () {
            return [this.fetchXAxis(), this.fetchYAxis()];
        };
        HorizontalStackedSeriesBase.prototype.rx = function () {
            return this.yAxis != null && this.yAxis.cv();
        };
        HorizontalStackedSeriesBase.prototype.ma = function () {
            var e_49, _a;
            var a = (i2.typeCast(XamDataChart.$, this.ca));
            if (a != null) {
                this.fi = i2.isNaN_(this.fq) ? a.p9.fk : this.fq;
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        b.ed();
                    }
                }
                catch (e_49_1) {
                    e_49 = { error: e_49_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_49)
                            throw e_49.error;
                    }
                }
            }
        };
        HorizontalStackedSeriesBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case HorizontalStackedSeriesBase.$$p[0]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                        this.k7();
                    }
                    break;
                case HorizontalStackedSeriesBase.$$p[1]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.rc.cr.g(this.gh);
                        this.rx();
                        this.l0(false);
                        this.k7();
                    }
                    break;
            }
        };
        HorizontalStackedSeriesBase.prototype.tv = function (a) {
            if (i2.typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        HorizontalStackedSeriesBase.prototype.tu = function (a) {
            if (i2.typeCast(CategoryXAxis.$, a) !== null || a.b9) {
                return true;
            }
            return false;
        };
        Object.defineProperty(HorizontalStackedSeriesBase.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        HorizontalStackedSeriesBase.$t = i2.markType(HorizontalStackedSeriesBase, 'HorizontalStackedSeriesBase', StackedSeriesBase.$);
        HorizontalStackedSeriesBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, HorizontalStackedSeriesBase, 'raisePropertyChanged', ['XAxis::ty', [CategoryAxisBase.$, null], 'YAxis::tz', [NumericYAxis.$, null]]);
        return HorizontalStackedSeriesBase;
    }(StackedSeriesBase));
    /**
     * @hidden
     */
    var StackedAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedAreaSeries, _super);
        function StackedAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = StackedAreaSeries.$;
            return _this;
        }
        StackedAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        StackedAreaSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        StackedAreaSeries.prototype.bu = function () {
            return new StackedAreaSeriesView(this);
        };
        StackedAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t0 = a;
        };
        StackedAreaSeries.prototype.ap = function (a) {
            if (this.itemsSource == null) {
                return null;
            }
            if (a == this.xAxis) {
                return new AxisRange(0, this.ch.count - 1);
            }
            if (a == this.yAxis) {
                this.tj();
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedAreaSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        Object.defineProperty(StackedAreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedAreaSeries.$t = i2.markType(StackedAreaSeries, 'StackedAreaSeries', HorizontalStackedSeriesBase.$);
        return StackedAreaSeries;
    }(HorizontalStackedSeriesBase));
    /**
     * @hidden
     */
    var VerticalStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalStackedSeriesBase, _super);
        function VerticalStackedSeriesBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VerticalStackedSeriesBase.prototype.q2 = function () {
            return this.yAxis;
        };
        VerticalStackedSeriesBase.prototype.rn = function () {
            return this.xAxis;
        };
        VerticalStackedSeriesBase.prototype.getOffsetValue = function () {
            return this.q8.r(this.yAxis, this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        VerticalStackedSeriesBase.prototype.getCategoryWidth = function () {
            return this.yAxis.getCategorySize(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        VerticalStackedSeriesBase.prototype.get_isVertical = function () {
            return true;
        };
        VerticalStackedSeriesBase.prototype.fetchXAxis = function () {
            return this.xAxis;
        };
        VerticalStackedSeriesBase.prototype.fetchYAxis = function () {
            return this.yAxis;
        };
        VerticalStackedSeriesBase.prototype.rx = function () {
            return this.xAxis != null && this.xAxis.cv();
        };
        VerticalStackedSeriesBase.prototype.lm = function (a, b, c, d) {
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case VerticalStackedSeriesBase.$$p[0]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.rc.cr.g(this.gh);
                        this.l0(false);
                        this.k7();
                    }
                    break;
                case VerticalStackedSeriesBase.$$p[1]:
                    if (c != d) {
                        this.kl(i2.typeCast(Axis.$, c));
                        this.lr(i2.typeCast(Axis.$, d));
                        this.rc.cr.g(this.gh);
                        this.rx();
                        this.l0(false);
                        this.k7();
                    }
                    break;
            }
        };
        VerticalStackedSeriesBase.prototype.tv = function (a) {
            if (i2.typeCast(CategoryYAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        VerticalStackedSeriesBase.prototype.tu = function (a) {
            if (i2.typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        };
        Object.defineProperty(VerticalStackedSeriesBase.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        VerticalStackedSeriesBase.$t = i2.markType(VerticalStackedSeriesBase, 'VerticalStackedSeriesBase', StackedSeriesBase.$);
        VerticalStackedSeriesBase.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, VerticalStackedSeriesBase, 'raisePropertyChanged', ['XAxis::ty', [NumericXAxis.$, null], 'YAxis::tz', [CategoryYAxis.$, null]]);
        return VerticalStackedSeriesBase;
    }(StackedSeriesBase));
    /**
     * @hidden
     */
    var StackedBarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedBarSeries, _super);
        function StackedBarSeries() {
            var _this = _super.call(this) || this;
            _this.ab = StackedBarSeries.$;
            return _this;
        }
        StackedBarSeries.prototype.get_c9 = function () {
            return true;
        };
        StackedBarSeries.prototype.get_dw = function () {
            return true;
        };
        StackedBarSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        StackedBarSeries.prototype.bu = function () {
            return new StackedBarSeriesView(this);
        };
        StackedBarSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t0 = a;
        };
        StackedBarSeries.prototype.sv = function () {
            return this.t0;
        };
        StackedBarSeries.prototype.preferredCategoryMode = function (a) {
            return 2;
        };
        StackedBarSeries.prototype.r6 = function () {
            var e_50, _a;
            var a = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.ca.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b == this) {
                        return a;
                    }
                    var c = i2.typeCast(IBarSeries_$type, b);
                    if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                        a++;
                    }
                }
            }
            catch (e_50_1) {
                e_50 = { error: e_50_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_50)
                        throw e_50.error;
                }
            }
            return -1;
        };
        StackedBarSeries.prototype.s7 = function () {
            var a = 0;
            var b = this.ca != null ? this.ca.pg : i2.Rect.empty;
            var c = this.bx.bu;
            if (!b.isEmpty && !c.isEmpty && this.xAxis != null) {
                var d = this.getEffectiveViewport1(this.bx);
                var e = new ScalerParams(0, b, c, this.xAxis.cc, d);
                a = this.xAxis.d8(this.xAxis.k5, e);
            }
            return a;
        };
        StackedBarSeries.prototype.s8 = function () {
            if (this.xAxis != null) {
                return this.xAxis.k5;
            }
            return 0;
        };
        StackedBarSeries.prototype.ap = function (a) {
            if (this.itemsSource == null) {
                return null;
            }
            if (a == this.yAxis) {
                return new AxisRange(0, this.ch.count - 1);
            }
            if (a == this.xAxis) {
                this.tj();
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedBarSeries.prototype.eh = function (a) {
            var b = this.ch != null ? this.ch.indexOf(a) : -1;
            var c = this.ca != null ? this.ca.pg : i2.Rect.empty;
            c = c.copy();
            var d = this.bx.bu;
            var e = new i2.Rect(0, 0, 0, 1, 1);
            var f = this.o9(this.bx);
            var g = new ScalerParams(0, e, e, this.xAxis.cc, f);
            var h = new ScalerParams(0, e, e, this.yAxis.cc, f);
            if (b >= 0 && i2.Rect.l_op_Inequality(c, null) && i2.Rect.l_op_Inequality(d, null)) {
                if (this.yAxis != null) {
                    var i = this.yAxis.d8(b, h);
                    if (i < c.top + 0.1 * c.height) {
                        i = i + 0.4 * c.height;
                    }
                    if (i > c.bottom - 0.1 * c.height) {
                        i = i - 0.4 * c.height;
                    }
                    c.y = i - 0.5 * c.height;
                }
                if (this.xAxis != null && this.ss != null && b < this.ss.length) {
                    var j = this.xAxis.d8(this.ss[b], g);
                    var k = this.xAxis.d8(this.st[b], g);
                    if (!i2.isNaN_(j) && !i2.isNaN_(k)) {
                        var l = Math.abs(k - j);
                        if (c.width < l) {
                            c.width = l;
                            c.x = Math.min(k, j);
                        }
                        else {
                            if (k < c.left + 0.1 * c.width) {
                                k = k + 0.4 * c.width;
                            }
                            if (k > c.right - 0.1 * c.width) {
                                k = k - 0.4 * c.width;
                            }
                            c.x = k - 0.5 * c.width;
                        }
                    }
                }
                this.b5.ap(this.ca, c, true);
            }
            return b >= 0;
        };
        StackedBarSeries.prototype.e3 = function (a, b, c) {
            var d = true;
            var e = c;
            if (!c.o() || b.isEmpty || a.isEmpty || this.yAxis == null || this.yAxis.itemsSource == null || this.xAxis == null || this.ch == null || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.kv == this.xAxis.ku) {
                e.cr.d = 0;
                d = false;
            }
            return d;
        };
        StackedBarSeries.prototype.kk = function (a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.rc.cr.g(this.gh);
                    break;
            }
            switch (a) {
                case 4:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
                case 1:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
                case 0:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
                case 2:
                    if (this.rc.cr.d > 0) {
                        this.l0(true);
                    }
                    break;
                case 3:
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.l0(true);
                    }
                    break;
            }
        };
        StackedBarSeries.prototype.g0 = function (a) {
            var b = this.ca != null ? this.ca.pg : i2.Rect.empty;
            var c = this.bx.bu;
            var d = this.getEffectiveViewport1(this.bx);
            var e = -1;
            if (this.yAxis != null && !b.isEmpty && !c.isEmpty) {
                var f = new ScalerParams(0, b, c, this.yAxis.cc, d);
                var g = this.o7(this.bx);
                var h = this.yAxis.eb(g.top, f);
                var i = this.yAxis.eb(g.bottom, f);
                var j = (a.y - b.top) / b.height;
                var k = h + (j * (i - h));
                if (this.yAxis.categoryMode != 0) {
                    k -= 0.5;
                }
                var l = i2.truncate(Math.round(k));
                e = l;
            }
            return e;
        };
        StackedBarSeries.prototype.hh = function (a) {
            var b = this.g0(a);
            return b >= 0 && this.ch != null && b < this.ch.count ? this.ch.item(b) : null;
        };
        StackedBarSeries.prototype.tn = function () {
            if (this.xAxis != null) {
                this.xAxis.cw(true);
            }
            if (this.yAxis != null) {
                this.yAxis.cw(true);
            }
        };
        StackedBarSeries.prototype.tb = function (a) {
            return this.g0(a);
        };
        StackedBarSeries.prototype.s5 = function (a, b, c, d) {
            var e = true;
            if (!d.o() || c.isEmpty || b.isEmpty || this.yAxis == null || this.yAxis.itemsSource == null || this.xAxis == null || this.ch == null || this.xAxis.bh == null || this.yAxis.bh == null) {
                e = false;
            }
            var f = d;
            if (a.valueColumn == null || a.valueColumn.count == 0 || f.cr.d < 1) {
                e = false;
            }
            return e;
        };
        StackedBarSeries.prototype.f1 = function () {
            return this.yAxis.ki(this.bx.bv, this.bx.bu, this.getEffectiveViewport1(this.bx));
        };
        StackedBarSeries.prototype.tk = function (a, b, c) {
            var e_51, _a;
            var d = i2.typeCast(BarFragment.$, a);
            var e = i2.typeCast(ColumnFragmentView.$, c);
            if (!this.e3(c.bu, c.bv, c) || d == null || e == null) {
                return;
            }
            var f = this.yAxis.ki(c.bv, c.bu, this.getEffectiveViewport1(c));
            if (i2.isNaN_(f) || i2.isInfinity(f)) {
                d.uq.db.count = 0;
                return;
            }
            var g = 0;
            d.rb.a0(d, d.rv(), function (h, i) { return d.qw(h, i); }, d.r3(c), d.r4(c));
            d.rb.r = d.ut;
            d.rb.s = d.uu;
            d.rb.k = d.ut;
            d.rb.l = d.uu;
            var h = d.valueColumn.count;
            var i = c.bv;
            var j = c.bu;
            var k = this.getEffectiveViewport1(c);
            var l = false;
            var m = d.rb.b;
            if (m != null) {
                l = true;
            }
            var n = b.f;
            var o = d.q2();
            var p = new ScalerParams(0, i, j, o.cc, k);
            var q = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(b.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var r = _c.value;
                    if (i2.isInfinity(r[0]) || i2.isNaN_(r[0]) || i2.isInfinity(r[1]) || i2.isInfinity(r[2]) || i2.isNaN_(r[1]) || i2.isNaN_(r[2])) {
                        q++;
                        continue;
                    }
                    var s = r[0] - 0.5 * f;
                    var t = r[1];
                    var u = r[2];
                    u = Math.max(u, -100);
                    t = Math.min(t, c.bu.right + 100);
                    var v = e.db.item(g);
                    v.height = f;
                    v.width = Math.abs(t - u);
                    if (l) {
                        d.sh(n, q, h, o, p, c.q);
                    }
                    d.rb.ad(v, false, false, false, false);
                    v.am = d.rb.k;
                    v.an = d.rb.l;
                    e.di(v, Math.min(t, u), s);
                    g++;
                    q++;
                }
            }
            catch (e_51_1) {
                e_51 = { error: e_51_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_51)
                        throw e_51.error;
                }
            }
            e.db.count = g;
        };
        StackedBarSeries.prototype.lm = function (a, b, c, d) {
            var e_52, _a;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case StackedBarSeries.$$p[0]:
                case StackedBarSeries.$$p[1]:
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var e = _c.value;
                            e.e3();
                            e.e4();
                        }
                    }
                    catch (e_52_1) {
                        e_52 = { error: e_52_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_52)
                                throw e_52.error;
                        }
                    }
                    this.l0(false);
                    break;
                case "SyncLink":
                    if (this.xAxis != null) {
                        this.xAxis.cv();
                    }
                    break;
                case "FastItemsSource":
                    if (this.xAxis != null && !this.xAxis.cv()) {
                        this.t0.cr.g(this.gh);
                    }
                    this.l0(false);
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        this.kl(this.xAxis);
                        this.kl(this.yAxis);
                    }
                    if (c == null && d != null) {
                        this.lr(this.xAxis);
                        this.lr(this.yAxis);
                    }
                    this.t0.cr.g(this.gh);
                    this.l0(false);
                    if (this.xAxis != null) {
                        this.xAxis.cv();
                    }
                    break;
            }
        };
        StackedBarSeries.prototype.getPreferredCategoryMode = function () {
            return this.preferredCategoryMode(this.yAxis);
        };
        Object.defineProperty(StackedBarSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedBarSeries.$t = i2.markType(StackedBarSeries, 'StackedBarSeries', VerticalStackedSeriesBase.$, [IBarSeries_$type]);
        StackedBarSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StackedBarSeries, 'raisePropertyChanged', ['RadiusX:t1:t5', [1, 0], 'RadiusY:t2:t6', [1, 0]]);
        return StackedBarSeries;
    }(VerticalStackedSeriesBase));
    /**
     * @hidden
     */
    var StackedColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedColumnSeries, _super);
        function StackedColumnSeries() {
            var _this = _super.call(this) || this;
            _this.ab = StackedColumnSeries.$;
            return _this;
        }
        StackedColumnSeries.prototype.get_db = function () {
            return true;
        };
        StackedColumnSeries.prototype.get_dw = function () {
            return true;
        };
        StackedColumnSeries.prototype.bu = function () {
            return new StackedColumnSeriesView(this);
        };
        StackedColumnSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t0 = a;
        };
        StackedColumnSeries.prototype.sv = function () {
            return this.t0;
        };
        StackedColumnSeries.prototype.preferredCategoryMode = function (a) {
            return 2;
        };
        StackedColumnSeries.prototype.ap = function (a) {
            if (this.itemsSource == null) {
                return null;
            }
            if (a == this.xAxis) {
                return new AxisRange(0, this.ch.count - 1);
            }
            if (a == this.yAxis) {
                this.tj();
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedColumnSeries.prototype.f1 = function () {
            var a = this.getEffectiveViewport1(this.bx);
            return this.xAxis.ki(this.bx.bv, this.bx.bu, a);
        };
        StackedColumnSeries.prototype.tk = function (a, b, c) {
            var e_53, _a;
            var d = i2.typeCast(ColumnFragment.$, a);
            var e = i2.typeCast(ColumnFragmentView.$, c);
            if (!this.e3(c.bu, c.bv, c) || d == null || e == null) {
                return;
            }
            if (d == null) {
                return;
            }
            var f = this.getEffectiveViewport1(c);
            var g = this.xAxis.ki(c.bv, c.bu, f);
            if (i2.isNaN_(g) || i2.isInfinity(g)) {
                d.uq.db.count = 0;
                return;
            }
            var h = 0;
            d.rb.a0(d, d.rv(), function (i, j) { return d.qw(i, j); }, d.r3(c), d.r4(c));
            d.rb.r = d.ut;
            d.rb.s = d.uu;
            d.rb.k = d.ut;
            d.rb.l = d.uu;
            var i = c.bv;
            var j = c.bu;
            var k = this.getEffectiveViewport1(c);
            var l = false;
            var m = d.rb.b;
            if (m != null) {
                l = true;
            }
            var n = b.f;
            var o = d.q2();
            var p = new ScalerParams(0, i, j, o.cc, k);
            var q = d.valueColumn.count;
            var r = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(b.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var s = _c.value;
                    if (i2.isInfinity(s[0]) || i2.isNaN_(s[0]) || i2.isInfinity(s[1]) || i2.isInfinity(s[2]) || i2.isNaN_(s[1]) || i2.isNaN_(s[2])) {
                        r++;
                        continue;
                    }
                    var t = s[0] - 0.5 * g;
                    var u = s[1];
                    var v = s[2];
                    u = Math.max(u, -100);
                    v = Math.min(v, c.bu.bottom + 100);
                    var w = e.db.item(h);
                    w.width = g;
                    w.height = Math.abs(v - u);
                    if (l) {
                        d.sh(n, r, q, o, p, c.q);
                    }
                    d.rb.ad(w, false, false, false, false);
                    w.am = d.rb.k;
                    w.an = d.rb.l;
                    e.di(w, t, Math.min(v, u));
                    h++;
                    r++;
                }
            }
            catch (e_53_1) {
                e_53 = { error: e_53_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_53)
                        throw e_53.error;
                }
            }
            e.db.count = h;
        };
        StackedColumnSeries.prototype.lm = function (a, b, c, d) {
            var e_54, _a;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case StackedColumnSeries.$$p[0]:
                case StackedColumnSeries.$$p[1]:
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var e = _c.value;
                            e.e3();
                            e.e4();
                        }
                    }
                    catch (e_54_1) {
                        e_54 = { error: e_54_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_54)
                                throw e_54.error;
                        }
                    }
                    this.l0(false);
                    break;
                case "SyncLink":
                    if (this.yAxis != null) {
                        this.yAxis.cv();
                    }
                    break;
                case "SeriesViewer":
                    if (this.yAxis != null) {
                        this.yAxis.cv();
                    }
                    break;
            }
        };
        Object.defineProperty(StackedColumnSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedColumnSeries.$t = i2.markType(StackedColumnSeries, 'StackedColumnSeries', HorizontalStackedSeriesBase.$);
        StackedColumnSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StackedColumnSeries, 'raisePropertyChanged', ['RadiusX:t1:t5', [1, 0], 'RadiusY:t2:t6', [1, 0]]);
        return StackedColumnSeries;
    }(HorizontalStackedSeriesBase));
    /**
     * @hidden
     */
    var StackedSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSplineAreaSeries, _super);
        function StackedSplineAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = StackedSplineAreaSeries.$;
            return _this;
        }
        StackedSplineAreaSeries.prototype.get_c7 = function () {
            return true;
        };
        StackedSplineAreaSeries.prototype.get_ea = function () {
            return true;
        };
        StackedSplineAreaSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        StackedSplineAreaSeries.prototype.bu = function () {
            return new StackedSplineAreaSeriesView(this);
        };
        StackedSplineAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t0 = a;
        };
        StackedSplineAreaSeries.prototype.ap = function (a) {
            if (this.itemsSource == null) {
                return null;
            }
            if (a == this.xAxis) {
                return new AxisRange(0, this.ch.count - 1);
            }
            if (a == this.yAxis) {
                this.tj();
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedSplineAreaSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        StackedSplineAreaSeries.prototype.lm = function (a, b, c, d) {
            var e_55, _a;
            _super.prototype.lm.call(this, a, b, c, d);
            switch (b) {
                case StackedSplineAreaSeries.$$p[0]:
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(this.sw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var e = _c.value;
                            e.el();
                        }
                    }
                    catch (e_55_1) {
                        e_55 = { error: e_55_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_55)
                                throw e_55.error;
                        }
                    }
                    break;
            }
        };
        Object.defineProperty(StackedSplineAreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedSplineAreaSeries.$t = i2.markType(StackedSplineAreaSeries, 'StackedSplineAreaSeries', HorizontalStackedSeriesBase.$);
        StackedSplineAreaSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StackedSplineAreaSeries, 'raisePropertyChanged', ['IsSplineShapePartOfRange:t1:t3', [0, false]]);
        return StackedSplineAreaSeries;
    }(HorizontalStackedSeriesBase));
    /**
     * @hidden
     */
    var StackedSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSplineSeries, _super);
        function StackedSplineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = StackedSplineSeries.$;
            return _this;
        }
        StackedSplineSeries.prototype.get_ea = function () {
            return true;
        };
        StackedSplineSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        StackedSplineSeries.prototype.bu = function () {
            return new StackedSplineSeriesView(this);
        };
        StackedSplineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t0 = a;
        };
        StackedSplineSeries.prototype.ap = function (a) {
            if (this.itemsSource == null) {
                return null;
            }
            if (a == this.xAxis) {
                return new AxisRange(0, this.ch.count - 1);
            }
            if (a == this.yAxis) {
                this.tj();
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedSplineSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        Object.defineProperty(StackedSplineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedSplineSeries.$t = i2.markType(StackedSplineSeries, 'StackedSplineSeries', HorizontalStackedSeriesBase.$);
        StackedSplineSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StackedSplineSeries, 'raisePropertyChanged', ['IsSplineShapePartOfRange:t1:t3', [0, false]]);
        return StackedSplineSeries;
    }(HorizontalStackedSeriesBase));
    /**
     * @hidden
     */
    var StackedFragmentSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedFragmentSeries, _super);
        function StackedFragmentSeries() {
            var _this = _super.call(this) || this;
            _this.y = false;
            _this.z = false;
            _this._parentSeries = null;
            _this.br = 0;
            _this.w = null;
            _this.x = null;
            _this._visualSeriesLink = null;
            _this.ap = null;
            _this.aq = null;
            _this.ao = null;
            _this.aj = false;
            _this.bm = null;
            _this.propertyChanged = null;
            _this.propertyUpdated = null;
            _this.ap = new i2.List$1(i2.Number_$type, 0);
            _this.aq = new i2.List$1(i2.Number_$type, 0);
            _this.ao = new i2.List$1(i2.Array_$type, 0);
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, function (a, b) { return _this.d9(a, b.propertyName, b.oldValue, b.newValue); });
            return _this;
        }
        Object.defineProperty(StackedFragmentSeries.prototype, "parentSeries", {
            get: function () {
                return this._parentSeries;
            },
            set: function (a) {
                this._parentSeries = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedFragmentSeries.prototype, "visualSeriesLink", {
            get: function () {
                return this._visualSeriesLink;
            },
            set: function (a) {
                this._visualSeriesLink = a;
            },
            enumerable: false,
            configurable: true
        });
        StackedFragmentSeries.prototype.bn = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.g0(a);
            }
            return -1;
        };
        StackedFragmentSeries.prototype.bt = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.hh(a);
            }
            return null;
        };
        StackedFragmentSeries.prototype.bq = function (a, b) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.g6(a, b);
            }
            return -1;
        };
        StackedFragmentSeries.prototype.bp = function (a, b) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.g4(a, b);
            }
            return -1;
        };
        StackedFragmentSeries.prototype.ba = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f8(a, b, c);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.ij = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.o2(a, b, c);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.io = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.pb(a);
            }
            return i2.Rect.empty;
        };
        StackedFragmentSeries.prototype.j = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.ak(a);
            }
            return null;
        };
        StackedFragmentSeries.prototype.ip = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.pc(a);
            }
            return i2.Rect.empty;
        };
        StackedFragmentSeries.prototype.k = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.al(a);
            }
            return null;
        };
        StackedFragmentSeries.prototype.iq = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.pd(a);
            }
            return i2.Rect.empty;
        };
        StackedFragmentSeries.prototype.ir = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.pe(a);
            }
            return i2.Rect.empty;
        };
        StackedFragmentSeries.prototype.a6 = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f4(a, b, c);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.ie = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.oy(a, b, c);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.a8 = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f6(a, b, c);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.ih = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.o0(a, b, c);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.ik = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.o3(a, b, c);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.bb = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f9(a, b, c);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.ig = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.oz(a, b, c);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.a7 = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f5(a, b, c);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.ii = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.o1(a, b, c);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.a9 = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f7(a, b, c);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.bo = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.g1(a);
            }
            return -1;
        };
        StackedFragmentSeries.prototype.a5 = function () {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.f1();
            }
            return 0;
        };
        StackedFragmentSeries.prototype.a4 = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.fx(a);
            }
            return NaN;
        };
        StackedFragmentSeries.prototype.bu = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.hi(a);
            }
            return null;
        };
        StackedFragmentSeries.prototype.af = function (a, b, c) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.cx(a, b, c);
            }
            return false;
        };
        StackedFragmentSeries.prototype.il = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.o5(a);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.id = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.ox(a);
            }
            return { $type: i2.Point_$type, x: NaN, y: NaN };
        };
        StackedFragmentSeries.prototype.ak = function (a) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.eh(a);
            }
            return false;
        };
        StackedFragmentSeries.prototype.im = function () {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.getEffectiveViewport();
            }
            return i2.Rect.empty;
        };
        StackedFragmentSeries.prototype.d8 = function () {
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.k9();
            }
        };
        StackedFragmentSeries.prototype.ec = function (a) {
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.l7(a);
            }
        };
        StackedFragmentSeries.prototype.al = function (a, b) {
            if (this.visualSeriesLink != null) {
                return this.visualSeriesLink.ep(a, b);
            }
            return false;
        };
        StackedFragmentSeries.prototype.d7 = function (a) {
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.kz(a);
            }
        };
        StackedFragmentSeries.prototype.provideRenderer = function (a) {
            this.bm = a;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.provideRenderer(a);
            }
        };
        StackedFragmentSeries.prototype.fe = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.iv = this.parentSeries._visibility != 0 ? 1 : this.ix;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink._visibility = this.iv;
            }
        };
        StackedFragmentSeries.prototype.ew = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.fh = this.fk != null ? this.fk : this.parentSeries.qd;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.qd = this.fh;
            }
        };
        StackedFragmentSeries.prototype.ey = function () {
            if (this.parentSeries == null) {
                return;
            }
            var a = this.r == 0 || this.r == 2;
            this.q = 0;
            this.q = a ? this.parentSeries.pr : this.r;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.pr = this.q;
            }
        };
        StackedFragmentSeries.prototype.ee = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.h2 = this.hx != null ? this.hx : this.parentSeries.oj;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.oj = this.h2;
            }
        };
        StackedFragmentSeries.prototype.ef = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.h5 = this.h6 != null ? this.h6 : this.parentSeries.os;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.os = this.h5;
            }
        };
        StackedFragmentSeries.prototype.ei = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.at = !i2.isNaN_(this.bc) ? this.bc : this.parentSeries.gd;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.gd = this.at;
            }
        };
        StackedFragmentSeries.prototype.e2 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.t = this.u != 0 ? this.u : this.parentSeries.bs;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.bs = this.t;
            }
        };
        StackedFragmentSeries.prototype.et = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.au = !i2.isNaN_(this.bd) ? this.bd : this.parentSeries.ge;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.ge = this.au;
            }
        };
        StackedFragmentSeries.prototype.eg = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.h7 = this.ia;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.ot = this.h7;
            }
        };
        StackedFragmentSeries.prototype.ej = function () {
            if (this.parentSeries == null) {
                return;
            }
            if (!this.y) {
                this.aa = this.parentSeries.dg;
            }
            else {
                this.aa = this.ag;
            }
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.dg = this.aa;
            }
        };
        StackedFragmentSeries.prototype.e5 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.az = !i2.isNaN_(this.bi) ? this.bi : this.parentSeries.gj;
            if (this.visualSeriesLink != null && !i2.isNaN_(this.az)) {
                this.visualSeriesLink.gj = this.az;
            }
        };
        StackedFragmentSeries.prototype.e6 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.h3 = i2.Color.e(i2.toNullable(i2.Color.$, this.h4), i2.toNullable(i2.Color.$, null)) ? this.h4 : this.parentSeries.or;
            if (this.visualSeriesLink != null && i2.Color.e(i2.toNullable(i2.Color.$, this.h3), i2.toNullable(i2.Color.$, null))) {
                this.visualSeriesLink.or = this.h3;
            }
        };
        StackedFragmentSeries.prototype.fd = function () {
            if (this.parentSeries == null) {
                return;
            }
            if (!this.z) {
                this.ae = this.parentSeries.e1;
            }
            else {
                this.ae = this.an;
            }
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.e1 = this.ae;
            }
        };
        StackedFragmentSeries.prototype.e7 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.a0 = !i2.isNaN_(this.bj) ? this.bj : this.parentSeries.gk;
            if (this.visualSeriesLink != null && !i2.isNaN_(this.a0)) {
                this.visualSeriesLink.gk = this.a0;
            }
        };
        StackedFragmentSeries.prototype.e8 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.a1 = !i2.isNaN_(this.bk) ? this.bk : this.parentSeries.gl;
            if (this.visualSeriesLink != null && !i2.isNaN_(this.a1)) {
                this.visualSeriesLink.gl = this.a1;
            }
        };
        StackedFragmentSeries.prototype.eh = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.h8 = this.ib;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.ou = this.h8;
            }
        };
        StackedFragmentSeries.prototype.ek = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.ab = this.ah;
        };
        StackedFragmentSeries.prototype.ep = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.ff = this.fi != null ? this.fi : this.parentSeries.legendItemBadgeTemplate;
            if (this.visualSeriesLink != null) {
                if (this.ff != null) {
                    this.visualSeriesLink.legendItemBadgeTemplate = this.ff;
                }
                else {
                    this.visualSeriesLink.legendItemBadgeTemplate = null;
                }
            }
        };
        StackedFragmentSeries.prototype.eq = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.fg = this.fj != null ? this.fj : this.parentSeries.legendItemTemplate;
            if (this.visualSeriesLink != null) {
                if (this.fg != null) {
                    this.visualSeriesLink.legendItemTemplate = this.fg;
                }
                else {
                    this.visualSeriesLink.legendItemTemplate = null;
                }
            }
        };
        StackedFragmentSeries.prototype.er = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.iu = this.parentSeries.ph != 0 ? 1 : this.iw;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.ph = this.iu;
            }
        };
        StackedFragmentSeries.prototype.eo = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.o = this.p != 0 ? this.p : this.parentSeries.a9;
            if (this.visualSeriesLink != null) {
                if (this.o != 0) {
                    this.visualSeriesLink.a9 = this.o;
                }
                else {
                    this.visualSeriesLink.a9 = 0;
                }
            }
        };
        StackedFragmentSeries.prototype.en = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.m = this.n != 0 ? this.n : this.parentSeries.a7;
            if (this.visualSeriesLink != null) {
                if (this.m != 0) {
                    this.visualSeriesLink.a7 = this.m;
                }
                else {
                    this.visualSeriesLink.a7 = 0;
                }
            }
        };
        StackedFragmentSeries.prototype.es = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.ht = this.hy != null ? this.hy : this.parentSeries.qt;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.qt = this.ht;
            }
        };
        StackedFragmentSeries.prototype.eu = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.hu = this.hz != null ? this.hz : this.parentSeries.qu;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.qu = this.hu;
            }
        };
        StackedFragmentSeries.prototype.ev = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.is = this.it != null ? this.it : this.parentSeries.qv;
            if (this.visualSeriesLink != null) {
                if (this.is != null) {
                    this.visualSeriesLink.qv = this.is;
                }
                else {
                    this.visualSeriesLink.qv = null;
                }
            }
        };
        StackedFragmentSeries.prototype.ez = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.aw = !i2.isNaN_(this.bf) ? this.bf : this.parentSeries._opacity;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink._opacity = this.aw;
            }
        };
        StackedFragmentSeries.prototype.e0 = function () {
        };
        StackedFragmentSeries.prototype.e1 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.hw = this.h1 != null ? this.h1 : this.parentSeries.oo;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.oo = this.hw;
            }
        };
        StackedFragmentSeries.prototype.em = function () {
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.itemsSource = this.itemsSource;
            }
        };
        StackedFragmentSeries.prototype.ed = function () {
            if (this.parentSeries == null) {
                return;
            }
            var a = NaN;
            if (this.parentSeries.isStacked && this.parentSeries.c7 && !this.parentSeries.ea) {
                a = this.parentSeries.fi;
            }
            if (this.parentSeries.isStacked && this.parentSeries.c7 && this.parentSeries.ea) {
                a = this.parentSeries.fi;
            }
            this.as = !i2.isNaN_(this.a3) ? this.a3 : a;
            if (this.visualSeriesLink != null) {
                if (i2.typeCast(AreaFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.fq = this.as;
                }
                if (i2.typeCast(SplineAreaFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.fq = this.as;
                }
            }
        };
        StackedFragmentSeries.prototype.el = function () {
            if (this.parentSeries == null) {
                return;
            }
            var a = false;
            if (this.parentSeries.isStacked && this.parentSeries.ea && this.parentSeries.c7) {
                a = this.parentSeries.t1;
            }
            if (this.parentSeries.isStacked && this.parentSeries.c9) {
                a = this.parentSeries.t1;
            }
            this.ac = a;
            if (this.visualSeriesLink != null) {
                if (i2.typeCast(SplineFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.uk = this.ac;
                }
                if (i2.typeCast(SplineAreaFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.uk = this.ac;
                }
            }
        };
        StackedFragmentSeries.prototype.e3 = function () {
            if (this.parentSeries == null) {
                return;
            }
            var a = NaN;
            if (this.parentSeries.isStacked && this.parentSeries.db) {
                a = this.parentSeries.t1;
            }
            if (this.parentSeries.isStacked && this.parentSeries.c9) {
                a = this.parentSeries.t1;
            }
            this.ax = !i2.isNaN_(a) ? a : this.bg;
            if (this.visualSeriesLink != null) {
                if (i2.typeCast(ColumnFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.ut = this.ax;
                }
                if (i2.typeCast(BarFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.ut = this.ax;
                }
            }
        };
        StackedFragmentSeries.prototype.e4 = function () {
            if (this.parentSeries == null) {
                return;
            }
            var a = NaN;
            if (this.parentSeries.isStacked && this.parentSeries.db) {
                a = this.parentSeries.t2;
            }
            if (this.parentSeries.isStacked && this.parentSeries.c9) {
                a = this.parentSeries.t2;
            }
            this.ay = !i2.isNaN_(a) ? a : this.bh;
            if (this.visualSeriesLink != null) {
                if (i2.typeCast(ColumnFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.uu = this.ay;
                }
                if (i2.typeCast(BarFragment.$, this.visualSeriesLink) !== null) {
                    this.visualSeriesLink.uu = this.ay;
                }
            }
        };
        StackedFragmentSeries.prototype.e9 = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.h9 = this.ic;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.ov = this.h9;
            }
        };
        StackedFragmentSeries.prototype.fa = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.a2 = !i2.isNaN_(this.bl) ? this.bl : this.parentSeries.gm;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.gm = this.a2;
            }
        };
        StackedFragmentSeries.prototype.ex = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.av = !i2.isNaN_(this.be) ? this.be : this.parentSeries.pw;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.pw = this.av;
            }
        };
        StackedFragmentSeries.prototype.fb = function () {
            if (this.parentSeries == null) {
                return;
            }
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.toolTip = this.bw;
            }
        };
        StackedFragmentSeries.prototype.fc = function () {
            if (this.parentSeries == null) {
                return;
            }
            this.ad = this.am;
            if (this.visualSeriesLink != null) {
                this.visualSeriesLink.pv = this.ad;
            }
        };
        StackedFragmentSeries.prototype.eb = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            if (this.propertyUpdated != null) {
                this.propertyUpdated(this, new i2.PropertyUpdatedEventArgs(a, b, c));
            }
        };
        StackedFragmentSeries.prototype.d9 = function (a, b, c, d) {
            if (this.parentSeries == null) {
                return;
            }
            switch (b) {
                case StackedFragmentSeries.$$p[73]:
                    if (this.parentSeries == null || this.visualSeriesLink == null) {
                        return;
                    }
                    this.visualSeriesLink.hp = d;
                    break;
                case StackedFragmentSeries.$$p[78]:
                    this.fe();
                    break;
                case StackedFragmentSeries.$$p[38]:
                    this.ee();
                    break;
                case StackedFragmentSeries.$$p[39]:
                    this.ef();
                    break;
                case StackedFragmentSeries.$$p[40]:
                    this.eg();
                    break;
                case StackedFragmentSeries.$$p[43]:
                    this.y = true;
                    this.ej();
                    break;
                case StackedFragmentSeries.$$p[67]:
                    this.e5();
                    break;
                case StackedFragmentSeries.$$p[68]:
                    this.e6();
                    break;
                case StackedFragmentSeries.$$p[76]:
                    this.y = true;
                    this.fd();
                    break;
                case StackedFragmentSeries.$$p[69]:
                    this.e7();
                    break;
                case StackedFragmentSeries.$$p[70]:
                    this.e8();
                    break;
                case StackedFragmentSeries.$$p[41]:
                    this.eh();
                    break;
                case StackedFragmentSeries.$$p[44]:
                    this.ek();
                    break;
                case StackedFragmentSeries.$$p[56]:
                    this.ew();
                    break;
                case StackedFragmentSeries.$$p[58]:
                    this.ey();
                    break;
                case StackedFragmentSeries.$$p[49]:
                    this.ep();
                    break;
                case StackedFragmentSeries.$$p[50]:
                    this.eq();
                    break;
                case StackedFragmentSeries.$$p[51]:
                    this.er();
                    break;
                case StackedFragmentSeries.$$p[48]:
                    this.eo();
                    break;
                case StackedFragmentSeries.$$p[47]:
                    this.en();
                    break;
                case StackedFragmentSeries.$$p[52]:
                    this.es();
                    break;
                case StackedFragmentSeries.$$p[54]:
                    this.eu();
                    break;
                case StackedFragmentSeries.$$p[55]:
                    this.ev();
                    break;
                case StackedFragmentSeries.$$p[57]:
                    this.ex();
                    break;
                case StackedFragmentSeries.$$p[61]:
                    this.ez();
                    break;
                case StackedFragmentSeries.$$p[60]:
                    this.e0();
                    break;
                case StackedFragmentSeries.$$p[46]:
                    this.em();
                    break;
                case StackedFragmentSeries.$$p[63]:
                    this.e1();
                    break;
                case StackedFragmentSeries.$$p[62]:
                    this.e2();
                    break;
                case StackedFragmentSeries.$$p[53]:
                    this.et();
                    break;
                case StackedFragmentSeries.$$p[37]:
                    this.ed();
                    break;
                case StackedFragmentSeries.$$p[65]:
                    this.e3();
                    break;
                case StackedFragmentSeries.$$p[66]:
                    this.e4();
                    break;
                case StackedFragmentSeries.$$p[45]:
                    this.el();
                    break;
                case StackedFragmentSeries.$$p[71]:
                    this.e9();
                    break;
                case StackedFragmentSeries.$$p[72]:
                    this.fa();
                    break;
                case StackedFragmentSeries.$$p[74]:
                    this.fb();
                    break;
                case StackedFragmentSeries.$$p[75]:
                    this.fc();
                    break;
            }
            this.parentSeries.l0(false);
        };
        StackedFragmentSeries.$t = i2.markType(StackedFragmentSeries, 'StackedFragmentSeries', i2.DependencyObject.$, [i2.INotifyPropertyChanged_$type]);
        StackedFragmentSeries.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, StackedFragmentSeries, 'eb', ['ActualAreaFillOpacity:as:fl', [1, 1], 'ActualBrush:hs:fm', [i2.Brush.$], 'ActualDashArray:h5:fn', [i2.DoubleCollection.$], 'ActualDashCap:h7:fo', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)], 'ActualEndCap:h8:fp', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 2)], 'ActualHighlightingFadeOpacity:at:fq', [1, NaN], 'ActualIsDropShadowEnabled:aa:fr', [0, false], 'ActualIsHitTestVisible:ab:fs', [0, true], 'ActualIsSplineShapePartOfRange:ac:ft', [0, false], 'ActualLegendItemBadgeMode:m:fu', [LegendItemBadgeMode_$type], 'ActualLegendItemBadgeShape:o:fv', [LegendItemBadgeShape_$type], 'ActualLegendItemBadgeTemplate:ff:fw', [i2.DataTemplate.$], 'ActualLegendItemTemplate:fg:fx', [i2.DataTemplate.$], 'ActualLegendItemVisibility:iu:fy', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'ActualMarkerBrush:ht:fz', [i2.Brush.$], 'ActualMarkerFillOpacity:au:f0', [1, NaN], 'ActualMarkerOutline:hu:f1', [i2.Brush.$], 'ActualMarkerStyle:is:f2', [i2.Style.$], 'ActualMarkerTemplate:fh:f3', [i2.DataTemplate.$], 'ActualMarkerThickness:av:f4', [1, 1], 'ActualMarkerType:q:f5', [MarkerType_$type, i2.enumGetBox(MarkerType_$type, 1)], 'ActualOpacityMask:hv:f6', [i2.Brush.$], 'ActualOpacity:aw:f7', [1, 1], 'ActualOutlineMode:t:f8', [SeriesOutlineMode_$type, i2.enumGetBox(SeriesOutlineMode_$type, 0)], 'ActualOutline:hw:f9', [i2.Brush.$], 'ActualRadiusX:ax:ga', [1, 0], 'ActualRadiusY:ay:gb', [1, 0], 'ActualShadowBlur:az:gc', [1, NaN], 'ActualShadowColor:h3:gd', [i2.Color.$], 'ActualShadowOffsetX:a0:ge', [1, NaN], 'ActualShadowOffsetY:a1:gf', [1, NaN], 'ActualStartCap:h9:gg', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 2)], 'ActualThickness:a2:gh', [1, 1], 'ActualToolTip:bs:gi', [4], 'ActualUseLightweightMarkers:ad:gj', [0, false], 'ActualUseSingleShadow:ae:gk', [0, true], 'ActualVisibility:iv:gl', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'AreaFillOpacity:a3:gm', [1, NaN], 'Brush:hx:gn', [i2.Brush.$], 'DashArray:h6:go', [i2.DoubleCollection.$], 'DashCap:ia:gp', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 0)], 'EndCap:ib:gq', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 2)], 'HighlightingFadeOpacity:bc:gr', [1, NaN], 'IsDropShadowEnabled:ag:gs', [0], 'IsHitTestVisible:ah:gt', [0, true], 'IsSplineShapePartOfRange:ai:gu', [0, false], 'ItemsSource::gv', [i2.IEnumerable_$type, null], 'LegendItemBadgeMode:n:gw', [LegendItemBadgeMode_$type, i2.enumGetBox(LegendItemBadgeMode_$type, 0)], 'LegendItemBadgeShape:p:gx', [LegendItemBadgeShape_$type, i2.enumGetBox(LegendItemBadgeShape_$type, 0)], 'LegendItemBadgeTemplate:fi:gy', [i2.DataTemplate.$, null], 'LegendItemTemplate:fj:gz', [i2.DataTemplate.$, null], 'LegendItemVisibility:iw:g0', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)], 'MarkerBrush:hy:g1', [i2.Brush.$], 'MarkerFillOpacity:bd:g2', [1, NaN], 'MarkerOutline:hz:g3', [i2.Brush.$], 'MarkerStyle:it:g4', [i2.Style.$], 'MarkerTemplate:fk:g5', [i2.DataTemplate.$, null], 'MarkerThickness:be:g6', [1, 1.5], 'MarkerType:r:g7', [MarkerType_$type, i2.enumGetBox(MarkerType_$type, 1)], 'Name:dk:g8', [2], 'OpacityMask:h0:g9', [i2.Brush.$], 'Opacity:bf:ha', [1, 1], 'OutlineMode:u:hb', [SeriesOutlineMode_$type, i2.enumGetBox(SeriesOutlineMode_$type, 0)], 'Outline:h1:hc', [i2.Brush.$, null], 'ParentOrLocalBrush:h2:hd', [i2.Brush.$], 'RadiusX:bg:he', [1, 0], 'RadiusY:bh:hf', [1, 0], 'ShadowBlur:bi:hg', [1, NaN], 'ShadowColor:h4:hh', [i2.Color.$], 'ShadowOffsetX:bj:hi', [1, NaN], 'ShadowOffsetY:bk:hj', [1, NaN], 'StartCap:ic:hk', [i2.PenLineCap_$type, i2.enumGetBox(i2.PenLineCap_$type, 2)], 'Thickness:bl:hl', [1, 1.5], 'Title:bv:hm', [4, "Series Title"], 'ToolTip:bw:hn', [4, null], 'UseLightweightMarkers:am:ho', [0, false], 'UseSingleShadow:an:hp', [0], 'ValueMemberPath:d4:hq', [2, null], 'Visibility:ix:hr', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 0)]]);
        return StackedFragmentSeries;
    }(i2.DependencyObject));
    /**
     * @hidden
     */
    var StackedSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesCollection, _super);
        function StackedSeriesCollection() {
            var _this = _super.call(this, StackedFragmentSeries.$, 0) || this;
            _this.collectionResetting = null;
            return _this;
        }
        StackedSeriesCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        StackedSeriesCollection.$t = i2.markType(StackedSeriesCollection, 'StackedSeriesCollection', i2.ObservableCollection$1.$.specialize(StackedFragmentSeries.$));
        return StackedSeriesCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var StackedSeriesFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesFramePreparer, _super);
        function StackedSeriesFramePreparer(a) {
            var _rest = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                _rest[_i - 1] = arguments[_i];
            }
            var _this = this;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        var c = _rest[0];
                        _this = _super.call(this, 0, c) || this;
                    }
                    break;
                case 1:
                    {
                        var c = _rest[0];
                        var d = _rest[1];
                        var e = _rest[2];
                        var f = _rest[3];
                        var g = _rest[4];
                        _this = _super.call(this, 1, c, d, e, f, g) || this;
                    }
                    break;
            }
            return _this;
        }
        StackedSeriesFramePreparer.prototype.j = function (a) {
            var b = new SingleValuesHolder();
            if (i2.typeCast(StackedColumnSeries.$, this.h) !== null || i2.typeCast(StackedBarSeries.$, this.h) !== null) {
                var c = i2.typeCast(StackedSeriesBase.$, this.h);
                if (c.sw.count > 0) {
                    b.f = c.sw._inner[0].x;
                }
                return b;
            }
            var d = this.ad.valueColumn;
            b.f = d;
            return b;
        };
        StackedSeriesFramePreparer.prototype.t = function (a, b, c, d, e) {
            var _this = this;
            var f = 0;
            var g = false;
            var h;
            var i = a.d != null;
            var j = this.h.provideCollisionDetector();
            var k = a.f;
            var l = a.k;
            var m = this.h.mayContainUnknowns;
            var n = new ScalerParams(0, a.m, a.l, a.b.j$a, l);
            var o = new ScalerParams(0, a.m, a.l, a.c.j$a, l);
            o.b = this.h.getHostReferenceValue();
            var p = (a.b.j$c(2, n) - a.b.j$c(1, n));
            var q = a.m;
            var r = a.l;
            var s = i2.typeCast(NumericAxisBase.$, a.c) !== null && a.c.kl;
            var _loop_1 = function (t) {
                var u = void 0;
                if (a.d == null) {
                    if (!m) {
                        u = this_1.g.getBucketWithoutUnknowns(t);
                    }
                    else {
                        u = this_1.g.getBucket(t);
                    }
                }
                else {
                    u = ((function () { var v = _this.f(a, t, b, p, g, h, c); t = v.p1; g = v.p4; h = v.p5; return v.ret; })());
                }
                var v = !s || (s && u[1] > 0);
                var w = u[0];
                if (!i2.isNaN_(u[0])) {
                    this_1.x(a, u, c, i, n, o);
                    a.a.f.add(u);
                    var x = t * a.h;
                    var y = x;
                    if (a.d != null && a.d.i$b != null && x >= 0 && x < a.d.i$b.count) {
                        x = a.d.i$b._inner[x];
                    }
                    var z = u;
                    if (k && x < b.e) {
                        z = new Array(u.length);
                        z[0] = w;
                        this_1.z(b, x, true, a.e);
                        z[1] = b.c;
                        z[2] = b.d;
                        this_1.x(a, z, c, i, n, o);
                    }
                    if (d && v && this_1.l(a.a, z, j, Math.min(x, b.e - 1), f, a.a.f.count - 1)) {
                        ++f;
                    }
                }
                out_t_1 = t;
            };
            var this_1 = this, out_t_1;
            for (var t = a.i; t <= a.j; ++t) {
                _loop_1(t);
                t = out_t_1;
            }
            return f;
        };
        StackedSeriesFramePreparer.prototype.l = function (a, b, c, d, e, f) {
            var g = b[0];
            var h = b[1];
            if (i2.typeCast(IBarSeries_$type, this.c) !== null) {
                h = b[0];
                g = b[1];
            }
            var i = new i2.Rect(0, g - 5, h - 5, 11, 11);
            if (!i2.isNaN_(g) && !i2.isNaN_(h) && !i2.isInfinity(g) && !i2.isInfinity(h) && c.tryAdd(i)) {
                a.m.add({ $type: i2.Point_$type, x: g, y: h });
                this.c.updateMarkerTemplate(e, d, f);
                return true;
            }
            return false;
        };
        StackedSeriesFramePreparer.$t = i2.markType(StackedSeriesFramePreparer, 'StackedSeriesFramePreparer', CategoryFramePreparer.$);
        return StackedSeriesFramePreparer;
    }(CategoryFramePreparer));
    /**
     * @hidden
     */
    var AreaFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AreaFragmentView, _super);
        function AreaFragmentView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.dg = new i2.Path();
            _this.di = new i2.Path();
            _this.dh = new i2.Path();
            _this.dj = new i2.Path();
            _this.dc = new i2.Path();
            _this.de = new i2.Path();
            _this.dd = new i2.Path();
            _this.df = new i2.Path();
            _this.da = a;
            return _this;
        }
        AreaFragmentView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
            }
        };
        AreaFragmentView.prototype.db = function () {
            this.dg.ak = null;
            this.dh.ak = null;
            this.di.ak = null;
            this.dj.ak = null;
            this.dc.ak = null;
            this.dd.ak = null;
            this.de.ak = null;
            this.df.ak = null;
        };
        AreaFragmentView.prototype.cs = function () {
            return new AreaFragmentBucketCalculator(this);
        };
        AreaFragmentView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        AreaFragmentView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.dc.ak = this.dg.ak;
            this.dd.ak = this.dh.ak;
            this.de.ak = this.di.ak;
            this.df.ak = this.dj.ak;
            this.dc._fill = a;
            this.dd._fill = a;
            this.dc._opacity = 1;
            this.dd._opacity = 1;
            this.de._stroke = a;
            this.de.ac = this.e.fl + 3;
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
        };
        AreaFragmentView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.dc);
                    a.s(this.dd);
                    a.s(this.de);
                    a.s(this.df);
                }
                else {
                    a.s(this.dg);
                    a.s(this.dh);
                    a.s(this.di);
                    a.s(this.dj);
                }
            }
        };
        AreaFragmentView.prototype.get_index = function () {
            var a = this.da.parentSeries;
            var b = a.series.count;
            var c = a.series.indexOf(this.da.logicalSeriesLink);
            var d = (b - 1) - c;
            var e = a.bx.index;
            return e + d;
        };
        AreaFragmentView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.di, "lowerShape", ["Lower"]);
            this.e.a6.exportPathData(a, this.dj, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPathData(a, this.dh, "translucentShape", ["Translucent"]);
            this.e.a6.exportPathData(a, this.dg, "fillShape", ["Fill"]);
        };
        AreaFragmentView.$t = i2.markType(AreaFragmentView, 'AreaFragmentView', AnchoredCategorySeriesView.$);
        return AreaFragmentView;
    }(AnchoredCategorySeriesView));
    /**
     * @hidden
     */
    var ColumnFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColumnFragmentView, _super);
        function ColumnFragmentView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.de = null;
            _this.db = null;
            _this.dc = null;
            _this.dd = null;
            _this.dj = new i2.Rectangle();
            _this.da = a;
            _this.dc = new i2.List$1(i2.Number_$type, 0);
            _this.dd = new i2.List$1(i2.Number_$type, 0);
            _this.db = ((function () {
                var $ret = new i2.Pool$1(i2.Rectangle.$);
                $ret.create = i2.runOn(_this, _this.dk);
                $ret.activate = i2.runOn(_this, _this.df);
                $ret.disactivate = i2.runOn(_this, _this.dh);
                $ret.destroy = i2.runOn(_this, _this.dg);
                return $ret;
            })());
            _this.de = new i2.List$1(i2.Rectangle.$, 0);
            return _this;
        }
        ColumnFragmentView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
            }
        };
        ColumnFragmentView.prototype.dk = function () {
            var _this = this;
            var a = ((function () {
                var $ret = new i2.Rectangle();
                $ret.dataContext = ((function () {
                    var $ret = new i2.DataContext();
                    $ret.series = _this.e;
                    return $ret;
                })());
                return $ret;
            })());
            this.de.add(a);
            a._visibility = 1;
            return a;
        };
        ColumnFragmentView.prototype.df = function (a) {
            a._visibility = 0;
        };
        ColumnFragmentView.prototype.dh = function (a) {
            a._visibility = 1;
        };
        ColumnFragmentView.prototype.dg = function (a) {
            this.de.remove(a);
        };
        ColumnFragmentView.prototype.be = function (a, b) {
            _super.prototype.be.call(this, a, b);
            var c = a;
        };
        ColumnFragmentView.prototype.di = function (a, b, c) {
            var d = false;
            if (a.o != c) {
                d = true;
                a.o = c;
            }
            if (a.n != b) {
                d = true;
                a.n = b;
            }
            if (d) {
                this.aq();
            }
        };
        ColumnFragmentView.prototype.bf = function (a, b) {
            _super.prototype.bf.call(this, a, b);
        };
        ColumnFragmentView.prototype.ac = function (a) {
            return this.de._inner[a];
        };
        ColumnFragmentView.prototype.ab = function (a) {
            var b = this.de._inner[a];
            this.dj._visibility = b._visibility;
            this.dj.n = b.n;
            this.dj.o = b.o;
            this.dj.width = b.width;
            this.dj.height = b.height;
            var c = this.bp(a);
            this.dj._fill = c;
            this.dj._stroke = c;
            this.dj.ac = this.e.fl + 3;
            return this.dj;
        };
        ColumnFragmentView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                for (var c = 0; c < this.de.count; c++) {
                    var d = this.aa(c, b);
                    this.bd(d, c, b);
                    a.v(d);
                }
            }
        };
        ColumnFragmentView.prototype.get_index = function () {
            var a = this.da.parentSeries;
            var b = a.series.count;
            var c = a.series.indexOf(this.da.logicalSeriesLink);
            var d = (b - 1) - c;
            var e = a.bx.index;
            return e + d;
        };
        ColumnFragmentView.prototype.al = function (a) {
            var e_56, _a, e_57, _b;
            _super.prototype.al.call(this, a);
            var b = 0;
            var c = new i2.List$1(i2.Rectangle.$, 0);
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.db.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    c.add(d);
                }
            }
            catch (e_56_1) {
                e_56 = { error: e_56_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_56)
                        throw e_56.error;
                }
            }
            c.aa(function (e, f) {
                if (e.n < f.n) {
                    return -1;
                }
                else if (e.n > f.n) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    this.e.a6.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
                }
            }
            catch (e_57_1) {
                e_57 = { error: e_57_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_57)
                        throw e_57.error;
                }
            }
            b++;
        };
        ColumnFragmentView.prototype.getDefaultTooltipTemplate = function () {
            var a = "<div class='ui-chart-default-tooltip-content'>";
            var b = null;
            if (this.da.q2().b6) {
                b = this.da.fragmentXAxis;
            }
            else if (this.da.fragmentYAxis.b6) {
                b = this.da.fragmentYAxis;
            }
            if (b.b9) {
                var c = b;
                a += "<span>${item." + c.dateTimeMemberPath + "}</span><br/>";
            }
            if (b != null && b.fj != null) {
                a += "<span>${item." + b.fj + "}</span><br/>";
            }
            a += "<span";
            var d = this.e.a4.a$r(this.e);
            if (!i2.stringIsNullOrEmpty(d)) {
                a += " style='color:" + d + "'";
            }
            a += ">" + this.da.hp + ": </span><span class='ui-priority-primary'>" + "${item." + this.da.tb + "}</span></div>";
            return a;
        };
        ColumnFragmentView.$t = i2.markType(ColumnFragmentView, 'ColumnFragmentView', AnchoredCategorySeriesView.$);
        return ColumnFragmentView;
    }(AnchoredCategorySeriesView));
    /**
     * @hidden
     */
    var LineFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(LineFragmentView, _super);
        function LineFragmentView(a) {
            var _this = _super.call(this, a) || this;
            _this.da = null;
            _this.dg = new i2.Path();
            _this.df = new i2.Path();
            _this.dh = new i2.Path();
            _this.dd = new i2.Path();
            _this.dc = new i2.Path();
            _this.de = new i2.Path();
            _this.da = a;
            return _this;
        }
        LineFragmentView.prototype.db = function () {
            this.df.ak = null;
            this.dg.ak = null;
            this.dh.ak = null;
            this.dc.ak = null;
            this.dd.ak = null;
            this.de.ak = null;
        };
        LineFragmentView.prototype.cs = function () {
            return new LineFragmentBucketCalculator(this);
        };
        LineFragmentView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        LineFragmentView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.dc.ak = this.df.ak;
            this.dd.ak = this.dg.ak;
            this.de.ak = this.dh.ak;
            this.dd._stroke = a;
            this.dd.ac = this.e.fl + 3;
            this.de._stroke = a;
            this.de.ac = this.e.fl + 3;
            this.dc._fill = a;
            this.dc._opacity = 1;
        };
        LineFragmentView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.dc);
                    a.s(this.dd);
                    a.s(this.de);
                }
                else {
                    a.s(this.df);
                    a.s(this.dg);
                    a.s(this.dh);
                }
            }
        };
        LineFragmentView.prototype.get_index = function () {
            var a = this.da.parentSeries;
            var b = a.series.count;
            var c = a.series.indexOf(this.da.logicalSeriesLink);
            var d = (b - 1) - c;
            var e = a.bx.index;
            return e + d;
        };
        LineFragmentView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dg, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.dh, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
        };
        LineFragmentView.$t = i2.markType(LineFragmentView, 'LineFragmentView', AnchoredCategorySeriesView.$);
        return LineFragmentView;
    }(AnchoredCategorySeriesView));
    /**
     * @hidden
     */
    var SplineAreaFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineAreaFragmentView, _super);
        function SplineAreaFragmentView(a) {
            var _this = _super.call(this, a) || this;
            _this.db = null;
            _this.dh = new i2.Path();
            _this.dj = new i2.Path();
            _this.di = new i2.Path();
            _this.dk = new i2.Path();
            _this.dd = new i2.Path();
            _this.df = new i2.Path();
            _this.de = new i2.Path();
            _this.dg = new i2.Path();
            _this.db = a;
            return _this;
        }
        SplineAreaFragmentView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
            }
        };
        SplineAreaFragmentView.prototype.dc = function () {
            this.dh.ak = null;
            this.di.ak = null;
            this.dj.ak = null;
            this.dk.ak = null;
            this.dd.ak = null;
            this.de.ak = null;
            this.df.ak = null;
            this.dg.ak = null;
        };
        SplineAreaFragmentView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        SplineAreaFragmentView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.dd.ak = this.dh.ak;
            this.de.ak = this.di.ak;
            this.df.ak = this.dj.ak;
            this.dg.ak = this.dk.ak;
            this.dd._fill = a;
            this.de._fill = a;
            this.de._opacity = 1;
            this.dd._opacity = 1;
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
            this.dg._stroke = a;
            this.dg.ac = this.e.fl + 3;
        };
        SplineAreaFragmentView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.dd);
                    a.s(this.de);
                    a.s(this.df);
                    a.s(this.dg);
                }
                else {
                    a.s(this.dh);
                    a.s(this.di);
                    a.s(this.dj);
                    a.s(this.dk);
                }
            }
        };
        SplineAreaFragmentView.prototype.get_index = function () {
            var a = this.db.parentSeries;
            var b = a.series.count;
            var c = a.series.indexOf(this.db.logicalSeriesLink);
            var d = (b - 1) - c;
            var e = a.bx.index;
            return e + d;
        };
        SplineAreaFragmentView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dj, "lowerShape", ["Lower"]);
            this.e.a6.exportPathData(a, this.dk, "upperShape", ["Upper", "Main"]);
            this.e.a6.exportPathData(a, this.di, "translucentShape", ["Translucent"]);
            this.e.a6.exportPathData(a, this.dh, "fillShape", ["Fill"]);
        };
        SplineAreaFragmentView.$t = i2.markType(SplineAreaFragmentView, 'SplineAreaFragmentView', SplineSeriesBaseView.$);
        return SplineAreaFragmentView;
    }(SplineSeriesBaseView));
    /**
     * @hidden
     */
    var SplineFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SplineFragmentView, _super);
        function SplineFragmentView(a) {
            var _this = _super.call(this, a) || this;
            _this.db = null;
            _this.dh = new i2.Path();
            _this.dg = new i2.Path();
            _this.di = new i2.Path();
            _this.de = new i2.Path();
            _this.dd = new i2.Path();
            _this.df = new i2.Path();
            _this.db = a;
            return _this;
        }
        SplineFragmentView.prototype.cs = function () {
            return new SplineFragmentBucketCalculator(this);
        };
        SplineFragmentView.prototype.dc = function () {
            this.dg.ak = null;
            this.dh.ak = null;
            this.di.ak = null;
            this.dd.ak = null;
            this.de.ak = null;
            this.df.ak = null;
        };
        SplineFragmentView.prototype.bb = function () {
            _super.prototype.bb.call(this);
        };
        SplineFragmentView.prototype.bc = function () {
            _super.prototype.bc.call(this);
            var a = this.bo();
            this.dd.ak = this.dg.ak;
            this.de.ak = this.dh.ak;
            this.df.ak = this.di.ak;
            this.de._stroke = a;
            this.de.ac = this.e.fl + 3;
            this.df._stroke = a;
            this.df.ac = this.e.fl + 3;
            this.dd._fill = a;
            this.dd._opacity = 0.75;
        };
        SplineFragmentView.prototype.a6 = function (a, b) {
            _super.prototype.a6.call(this, a, b);
            if (a.d) {
                if (b) {
                    a.s(this.dd);
                    a.s(this.de);
                    a.s(this.df);
                }
                else {
                    a.s(this.dg);
                    a.s(this.dh);
                    a.s(this.di);
                }
            }
        };
        SplineFragmentView.prototype.get_index = function () {
            var a = this.db.parentSeries;
            var b = a.series.count;
            var c = a.series.indexOf(this.db.logicalSeriesLink);
            var d = (b - 1) - c;
            var e = a.bx.index;
            return e + d;
        };
        SplineFragmentView.prototype.al = function (a) {
            _super.prototype.al.call(this, a);
            this.e.a6.exportPathData(a, this.dh, "lowerShape", ["Lower", "Main"]);
            this.e.a6.exportPathData(a, this.di, "upperShape", ["Upper"]);
            this.e.a6.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
        };
        SplineFragmentView.$t = i2.markType(SplineFragmentView, 'SplineFragmentView', SplineSeriesBaseView.$);
        return SplineFragmentView;
    }(SplineSeriesBaseView));
    /**
     * @hidden
     */
    var StackedSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesView, _super);
        function StackedSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c0 = null;
            _this.c1 = new i2.Canvas();
            _this.c3 = new i2.Panel();
            _this.c0 = a;
            return _this;
        }
        Object.defineProperty(StackedSeriesView.prototype, "c2", {
            get: function () {
                return this.c1;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StackedSeriesView.prototype, "c4", {
            get: function () {
                return this.c3;
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesView.prototype.cs = function () {
            return new StackedBucketCalculator(this);
        };
        StackedSeriesView.prototype.ap = function () {
            _super.prototype.ap.call(this);
            for (var a = 0; a < this.c0.s0.f.count; a++) {
                this.c0.s0.f._inner[a].bx.ap();
            }
        };
        StackedSeriesView.prototype.ar = function (a, b) {
            var e_58, _a;
            _super.prototype.ar.call(this, a, b);
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.c0.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.visualSeriesLink.bx.ar(a, b);
                }
            }
            catch (e_58_1) {
                e_58 = { error: e_58_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_58)
                        throw e_58.error;
                }
            }
        };
        StackedSeriesView.prototype.af = function () {
            var a = "rgba(95,95,95,0.5)";
            var b = true;
            var c = 5, d = 5, e = 5;
            var f = this.e;
            if ((f.isStacked && f.c7) || (f.isStacked && f.ea && f.c7)) {
                d = 1;
                e = -3;
            }
            else if ((f.isStacked && f.dv) || (f.isStacked && f.ea)) {
                c = 3;
                d = 1;
                e = 4;
                b = false;
            }
            else if ((f.isStacked && f.db)) {
                d = 5;
                e = 0;
            }
            var g = new i2.Color();
            g.colorString = a;
            f.or = g;
            f.gj = c;
            f.gk = d;
            f.gl = e;
            f.e1 = b;
        };
        StackedSeriesView.$t = i2.markType(StackedSeriesView, 'StackedSeriesView', CategorySeriesView.$);
        return StackedSeriesView;
    }(CategorySeriesView));
    /**
     * @hidden
     */
    var StackedBarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedBarSeriesView, _super);
        function StackedBarSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c5 = null;
            _this.c5 = a;
            return _this;
        }
        StackedBarSeriesView.prototype.cs = function () {
            return new StackedBarBucketCalculator(this);
        };
        StackedBarSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.c;
                this.c0.gh = Defaults.h;
                this.c0.gm = Defaults.i;
            }
        };
        StackedBarSeriesView.$t = i2.markType(StackedBarSeriesView, 'StackedBarSeriesView', StackedSeriesView.$);
        return StackedBarSeriesView;
    }(StackedSeriesView));
    /**
     * @hidden
     */
    var StackedColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedColumnSeriesView, _super);
        function StackedColumnSeriesView(a) {
            return _super.call(this, a) || this;
        }
        StackedColumnSeriesView.prototype.cs = function () {
            return new StackedColumnBucketCalculator(this);
        };
        StackedColumnSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.c;
                this.c0.gh = Defaults.h;
                this.c0.gm = Defaults.i;
            }
        };
        StackedColumnSeriesView.$t = i2.markType(StackedColumnSeriesView, 'StackedColumnSeriesView', StackedSeriesView.$);
        return StackedColumnSeriesView;
    }(StackedSeriesView));
    /**
     * @hidden
     */
    var StackedAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedAreaSeriesView, _super);
        function StackedAreaSeriesView(a) {
            return _super.call(this, a) || this;
        }
        StackedAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        StackedAreaSeriesView.$t = i2.markType(StackedAreaSeriesView, 'StackedAreaSeriesView', StackedSeriesView.$);
        return StackedAreaSeriesView;
    }(StackedSeriesView));
    /**
     * @hidden
     */
    var StackedSplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSplineAreaSeriesView, _super);
        function StackedSplineAreaSeriesView(a) {
            return _super.call(this, a) || this;
        }
        StackedSplineAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        StackedSplineAreaSeriesView.$t = i2.markType(StackedSplineAreaSeriesView, 'StackedSplineAreaSeriesView', StackedSeriesView.$);
        return StackedSplineAreaSeriesView;
    }(StackedSeriesView));
    /**
     * @hidden
     */
    var StackedSplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSplineSeriesView, _super);
        function StackedSplineSeriesView(a) {
            return _super.call(this, a) || this;
        }
        StackedSplineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        StackedSplineSeriesView.$t = i2.markType(StackedSplineSeriesView, 'StackedSplineSeriesView', StackedSeriesView.$);
        return StackedSplineSeriesView;
    }(StackedSeriesView));
    /**
     * @hidden
     */
    var StackedSeriesManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesManager, _super);
        function StackedSeriesManager(a) {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.f = null;
            _this.c = null;
            _this.e = null;
            _this.d = null;
            _this.j = null;
            _this.k = null;
            if (a == null) {
                return _this;
            }
            _this.b = a;
            _this.f = new i2.ObservableCollection$1(AnchoredCategorySeries.$, 0);
            _this.c = new StackedSeriesCollection();
            _this.e = new i2.ObservableCollection$1(AnchoredCategorySeries.$, 0);
            _this.d = new i2.ObservableCollection$1(AnchoredCategorySeries.$, 0);
            _this.j = _this.b.s1.c2;
            _this.k = _this.b.s1.c4;
            var b = _this.c;
            b.collectionChanged = i2.delegateCombine(b.collectionChanged, function (b, c) {
                var e_59, _a, e_60, _b;
                if (c.oldItems != null) {
                    try {
                        for (var _c = tslib.__values(i2.fromEn(c.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var d = _d.value;
                            if (_this.f.contains(d.visualSeriesLink)) {
                                _this.f.remove(d.visualSeriesLink);
                            }
                        }
                    }
                    catch (e_59_1) {
                        e_59 = { error: e_59_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_59)
                                throw e_59.error;
                        }
                    }
                }
                if (c.newItems != null) {
                    var e = c.newStartingIndex;
                    try {
                        for (var _e = tslib.__values(i2.fromEn(c.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var f = _f.value;
                            var g = _this.a(f);
                            _this.f.insert(e, g);
                            e++;
                        }
                    }
                    catch (e_60_1) {
                        e_60 = { error: e_60_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_60)
                                throw e_60.error;
                        }
                    }
                }
            });
            var c = _this.f;
            c.collectionChanged = i2.delegateCombine(c.collectionChanged, function (c, d) {
                var e_61, _a, e_62, _b;
                if (d.oldItems != null) {
                    try {
                        for (var _c = tslib.__values(i2.fromEn(d.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var e = _d.value;
                            e.kh(true, e.bx);
                            e.ca = null;
                            e.b5 = null;
                            e.itemsSource = null;
                            e.legend = null;
                            if (_this.k != null && _this.k.ab.contains(e)) {
                                _this.k.ab.remove(e);
                            }
                            if (_this.b.ca != null) {
                                _this.b.ca.l1(e);
                            }
                        }
                    }
                    catch (e_61_1) {
                        e_61 = { error: e_61_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_61)
                                throw e_61.error;
                        }
                    }
                }
                if (d.newItems != null) {
                    try {
                        for (var _e = tslib.__values(i2.fromEn(d.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var f = _f.value;
                            f.ca = _this.b.ca;
                            f.b5 = _this.b.b5;
                            if (!_this.k.ab.contains(f)) {
                                _this.k.ab.add(f);
                            }
                            if (_this.b.ca != null) {
                                _this.b.ca.i4(f);
                            }
                        }
                    }
                    catch (e_62_1) {
                        e_62 = { error: e_62_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_62)
                                throw e_62.error;
                        }
                    }
                }
                _this.b.l0(false);
            });
            return _this;
        }
        StackedSeriesManager.prototype.a = function (a) {
            if (this.b.isStacked && this.b.dv) {
                var b = new LineFragment();
                b.provideRenderer(a.bm);
                b.parentSeries = this.b;
                a.visualSeriesLink = b;
                b.logicalSeriesLink = a;
                b.bx.bu = this.b.bx.bu;
                this.i(b, a);
                this.g(b);
                return b;
            }
            if (this.b.isStacked && this.b.db) {
                var c = new ColumnFragment();
                c.provideRenderer(a.bm);
                c.parentSeries = this.b;
                a.visualSeriesLink = c;
                c.logicalSeriesLink = a;
                c.bx.bu = this.b.bx.bu;
                this.i(c, a);
                this.g(c);
                return c;
            }
            if (this.b.isStacked && this.b.c9) {
                var d = new BarFragment();
                d.provideRenderer(a.bm);
                d.parentSeries = i2.typeCast(StackedBarSeries.$, this.b);
                a.visualSeriesLink = d;
                d.logicalSeriesLink = a;
                d.bx.bu = this.b.bx.bu;
                this.i(d, a);
                this.g(d);
                return d;
            }
            if (this.b.isStacked && this.b.c7 && !this.b.ea) {
                var e = new AreaFragment();
                e.provideRenderer(a.bm);
                e.parentSeries = this.b;
                a.visualSeriesLink = e;
                e.logicalSeriesLink = a;
                e.bx.bu = this.b.bx.bu;
                this.i(e, a);
                this.g(e);
                return e;
            }
            if (this.b.isStacked && this.b.ea && !this.b.c7) {
                var f = new SplineFragment();
                f.provideRenderer(a.bm);
                f.parentSeries = this.b;
                a.visualSeriesLink = f;
                f.logicalSeriesLink = a;
                f.bx.bu = this.b.bx.bu;
                this.i(f, a);
                this.g(f);
                return f;
            }
            if (this.b.isStacked && this.b.ea && this.b.c7) {
                var g = new SplineAreaFragment();
                g.provideRenderer(a.bm);
                g.parentSeries = this.b;
                a.visualSeriesLink = g;
                g.logicalSeriesLink = a;
                g.bx.bu = this.b.bx.bu;
                this.i(g, a);
                this.g(g);
                return g;
            }
            return null;
        };
        StackedSeriesManager.prototype.i = function (a, b) {
            a.oj = b.h2;
            a.os = b.h5;
            a.ot = b.h7;
            a.ou = b.h8;
            if (b.itemsSource == null) {
                a.itemsSource = this.b.itemsSource;
            }
            else {
                a.itemsSource = b.itemsSource;
            }
            a.legend = this.b.a0;
            a.legendItemTemplate = b.fg;
            a.ph = b.iu;
            a.qt = b.ht;
            a.qu = b.hu;
            a.qv = b.is;
            a.qd = b.fh;
            a.pr = b.q;
            a.pw = b.av;
            a.gf = this.b.gf;
            a._opacity = b.bf;
            a.gd = b.at;
            a.oo = b.hw;
            a.gh = this.b.gh;
            a.ov = b.h9;
            a.gm = b.a2;
            a.hp = b.bv;
            a.pv = b.ad;
            a.tb = b.d4;
            a._visibility = b.iv;
            a.ge = b.au;
            a.bs = b.t;
            var c = i2.typeCast(AreaFragment.$, a);
            if (c != null) {
                c.fi = b.as;
            }
            var d = i2.typeCast(SplineAreaFragment.$, a);
            if (d != null) {
                d.fi = b.as;
            }
            var e = i2.typeCast(ColumnFragment.$, a);
            if (e != null) {
                e.ut = b.ax;
                e.uu = b.ay;
            }
            var f = i2.typeCast(BarFragment.$, a);
            if (f != null) {
                f.ut = b.ax;
                f.uu = b.ay;
            }
            a.toolTip = b.bw;
            a.dg = b.aa;
            a.e1 = b.ae;
            b.e5();
            b.e6();
            b.e7();
            b.e8();
        };
        StackedSeriesManager.prototype.h = function () {
            var e_63, _a;
            this.e.clear();
            this.d.clear();
            var a = 0;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.et = true;
                    b.g9 = this.b.tc(this.c._inner[a]);
                    b.b5 = this.b.b5;
                    b.ca = this.b.ca;
                    if (this.c._inner[a].aj) {
                        this.e.add(b);
                    }
                    else {
                        this.d.add(b);
                    }
                    if ((this.b.isStacked && this.b.dv) || (this.b.isStacked && this.b.c7) || (this.b.isStacked && this.b.ea)) {
                        b.te(this.b.fetchXAxis());
                        b.tf(this.b.fetchYAxis());
                    }
                    b.l0(false);
                    a++;
                }
            }
            catch (e_63_1) {
                e_63 = { error: e_63_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_63)
                        throw e_63.error;
                }
            }
        };
        StackedSeriesManager.prototype.g = function (a) {
            var fragment_ = a;
            fragment_.externalObject = i2.TypeRegistrar.createFromInternal(fragment_, i2.PlatformConstants.Prefix, i2.PlatformConstants.Postfix);
            fragment_.externalObject._implementation = fragment_;
        };
        StackedSeriesManager.$t = i2.markType(StackedSeriesManager, 'StackedSeriesManager');
        return StackedSeriesManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a non-visual child of StackedSeriesBase.
    */
    var IgxStackedFragmentSeriesComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedFragmentSeriesComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._propertyUpdated = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxStackedFragmentSeriesComponent.prototype.createImplementation = function () {
            return new StackedFragmentSeries();
        };
        IgxStackedFragmentSeriesComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxStackedFragmentSeriesComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxStackedFragmentSeriesComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "dataSource", {
            /**
             * Gets or sets the ItemsSource property for the current series object. Normally you will want to provide data to the parent series instead.
             * But if you have data as individual columns, it can be assigned here. The data must be aligned and have the same number of items for each fragment.
            */
            get: function () {
                return this.i.itemsSource;
            },
            set: function (v) {
                this.i.itemsSource = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "brush", {
            /**
             * Gets or sets the brush of the stacked fragment.
            */
            get: function () {
                return i2.brushToString(this.i.hx);
            },
            set: function (v) {
                this.i.hx = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualBrush", {
            /**
             * Gets the actual brush used by the series.
            */
            get: function () {
                return i2.brushToString(this.i.hs);
            },
            set: function (v) {
                this.i.hs = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "isDropShadowEnabled", {
            /**
             * Gets or sets whether drop shadow should be enabled for this series.
            */
            get: function () {
                return this.i.ag;
            },
            set: function (v) {
                this.i.ag = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualIsDropShadowEnabled", {
            /**
             * Gets whether drop shadow is actually enabled for this series.
            */
            get: function () {
                return this.i.aa;
            },
            set: function (v) {
                this.i.aa = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "shadowBlur", {
            /**
             * Gets or sets the shadow blur.
             * This property is ignored when StackedFragmentSeries.UseSingleShadow is set to true.
            */
            get: function () {
                return this.i.bi;
            },
            set: function (v) {
                this.i.bi = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualShadowBlur", {
            /**
             * Gets the actual shadow blur used by the series.
            */
            get: function () {
                return this.i.az;
            },
            set: function (v) {
                this.i.az = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "shadowColor", {
            /**
             * Gets or sets the drop shadow color.
            */
            get: function () {
                return i2.colorToString(this.i.h4);
            },
            set: function (v) {
                this.i.h4 = i2.stringToColor(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualShadowColor", {
            /**
             * Gets actual the drop shadow color used by the series.
            */
            get: function () {
                return i2.colorToString(this.i.h3);
            },
            set: function (v) {
                this.i.h3 = i2.stringToColor(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "useSingleShadow", {
            /**
             * Gets or sets whether drop shadow is applied to the whole StackedFragmentSeries visual or to each of the individual shapes forming the StackedFragmentSeries.
             * When this property is set to true, no StackedFragmentSeries.ShadowBlur is applied.
            */
            get: function () {
                return this.i.an;
            },
            set: function (v) {
                this.i.an = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualUseSingleShadow", {
            /**
             * Gets whether drop shadow is actually applied to the whole StackedFragmentSeries visual or to each of the individual shapes forming the StackedFragmentSeries.
            */
            get: function () {
                return this.i.ae;
            },
            set: function (v) {
                this.i.ae = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "shadowOffsetX", {
            /**
             * Gets or sets the drop shadow x-offset.
            */
            get: function () {
                return this.i.bj;
            },
            set: function (v) {
                this.i.bj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualShadowOffsetX", {
            /**
             * Gets the actual drop shadow x-offset applied to the series.
            */
            get: function () {
                return this.i.a0;
            },
            set: function (v) {
                this.i.a0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "shadowOffsetY", {
            /**
             * Gets or sets the drop shadow y-offset.
            */
            get: function () {
                return this.i.bk;
            },
            set: function (v) {
                this.i.bk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualShadowOffsetY", {
            /**
             * Gets the actual drop shadow y-offset applied to the series.
            */
            get: function () {
                return this.i.a1;
            },
            set: function (v) {
                this.i.a1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "legendItemBadgeTemplate", {
            /**
             * Gets or sets the LegendItemBadgeTemplate property.
             * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
             * the series object itself.
            */
            get: function () {
                return this.i.fi;
            },
            set: function (v) {
                this.i.fi = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemBadgeTemplate", {
            /**
             * Gets the actual legend item badge template used by the series.
            */
            get: function () {
                return this.i.ff;
            },
            set: function (v) {
                this.i.ff = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "legendItemTemplate", {
            /**
             * Gets or sets the LegendItemTemplate property.
             * The legend item control content is created according to the LegendItemTemplate on-demand by
             * the series object itself.
            */
            get: function () {
                return this.i.fj;
            },
            set: function (v) {
                this.i.fj = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemTemplate", {
            /**
             * Gets the actual legend item template used by the series.
            */
            get: function () {
                return this.i.fg;
            },
            set: function (v) {
                this.i.fg = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "legendItemVisibility", {
            /**
             * Gets or sets the legend item visibility for the current series object.
            */
            get: function () {
                return this.i.iw;
            },
            set: function (v) {
                this.i.iw = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemVisibility", {
            /**
             * Gets the actual visibility of the legend items in the series.
            */
            get: function () {
                return this.i.iu;
            },
            set: function (v) {
                this.i.iu = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "legendItemBadgeShape", {
            /**
             * Gets or sets the type of legend badge representing the current series in a legend.
             * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on the series
            */
            get: function () {
                return this.i.p;
            },
            set: function (v) {
                this.i.p = i2.ensureEnum(LegendItemBadgeShape_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "legendItemBadgeMode", {
            /**
             * Gets or sets the mode of legend badge representing the current series in a legend.
             * This property will be ignored when the LegendItemTemplate or LegendItemBadgeTemplate property is set on the series
            */
            get: function () {
                return this.i.n;
            },
            set: function (v) {
                this.i.n = i2.ensureEnum(LegendItemBadgeMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemBadgeShape", {
            /**
             * Gets the actual LegendItemBadgeShape of the series.
            */
            get: function () {
                return this.i.o;
            },
            set: function (v) {
                this.i.o = i2.ensureEnum(LegendItemBadgeShape_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemBadgeMode", {
            /**
             * Gets the actual LegendItemBadgeMode of the series.
            */
            get: function () {
                return this.i.m;
            },
            set: function (v) {
                this.i.m = i2.ensureEnum(LegendItemBadgeMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "markerBrush", {
            /**
             * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
            */
            get: function () {
                return i2.brushToString(this.i.hy);
            },
            set: function (v) {
                this.i.hy = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualMarkerBrush", {
            /**
             * Gets the actual marker brush of the series.
            */
            get: function () {
                return i2.brushToString(this.i.ht);
            },
            set: function (v) {
                this.i.ht = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "markerOutline", {
            /**
             * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
            */
            get: function () {
                return i2.brushToString(this.i.hz);
            },
            set: function (v) {
                this.i.hz = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualMarkerOutline", {
            /**
             * Gets the actual marker outline of the series.
            */
            get: function () {
                return i2.brushToString(this.i.hu);
            },
            set: function (v) {
                this.i.hu = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "markerTemplate", {
            /**
             * Gets or sets the MarkerTemplate for the current series object.
            */
            get: function () {
                return this.i.fk;
            },
            set: function (v) {
                this.i.fk = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualMarkerTemplate", {
            /**
             * Gets the actual marker template used by the series.
            */
            get: function () {
                return this.i.fh;
            },
            set: function (v) {
                this.i.fh = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "markerType", {
            /**
             * Gets or sets the marker type for the current series object.
             * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
            */
            get: function () {
                return this.i.r;
            },
            set: function (v) {
                this.i.r = i2.ensureEnum(MarkerType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualMarkerType", {
            /**
             * Gets the actual marker type set used in the series.
            */
            get: function () {
                return this.i.q;
            },
            set: function (v) {
                this.i.q = i2.ensureEnum(MarkerType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "name", {
            /**
             * Gets or sets the Name of the stacked fragment.
            */
            get: function () {
                return this.i.dk;
            },
            set: function (v) {
                this.i.dk = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "opacity", {
            /**
             * Gets or sets the Opacity of the stacked fragment.
            */
            get: function () {
                return this.i.bf;
            },
            set: function (v) {
                this.i.bf = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualOpacity", {
            /**
             * Gets the series opacity.
            */
            get: function () {
                return this.i.aw;
            },
            set: function (v) {
                this.i.aw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "outline", {
            /**
             * Gets or sets the brush to use for the outline of the series.
             * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
            */
            get: function () {
                return i2.brushToString(this.i.h1);
            },
            set: function (v) {
                this.i.h1 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualOutline", {
            /**
             * Gets the series outline.
            */
            get: function () {
                return i2.brushToString(this.i.hw);
            },
            set: function (v) {
                this.i.hw = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "areaFillOpacity", {
            /**
             * Gets or sets the AreaFillOpacity of the stacked fragment. This property only applies for area-like series.
            */
            get: function () {
                return this.i.a3;
            },
            set: function (v) {
                this.i.a3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualAreaFillOpacity", {
            /**
             * Gets the series ActualAreaFillOpacity.  This property only applies for area-like series.
            */
            get: function () {
                return this.i.as;
            },
            set: function (v) {
                this.i.as = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "markerFillOpacity", {
            /**
             * Gets or sets the opacity to use for the marker fills.
            */
            get: function () {
                return this.i.bd;
            },
            set: function (v) {
                this.i.bd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualMarkerFillOpacity", {
            /**
             * Gets the actual opacity to use for hte marker fills.
            */
            get: function () {
                return this.i.au;
            },
            set: function (v) {
                this.i.au = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "outlineMode", {
            /**
             * Gets or sets the outline mode to use for the fragment.
            */
            get: function () {
                return this.i.u;
            },
            set: function (v) {
                this.i.u = i2.ensureEnum(SeriesOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualOutlineMode", {
            /**
             * Gets the actual outline mode to use for the fragment.
            */
            get: function () {
                return this.i.t;
            },
            set: function (v) {
                this.i.t = i2.ensureEnum(SeriesOutlineMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "highlightingFadeOpacity", {
            /**
             * Gets or sets the target opacity to fade to for fade style highlighting.
            */
            get: function () {
                return this.i.bc;
            },
            set: function (v) {
                this.i.bc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualHighlightingFadeOpacity", {
            /**
             * Gets the actual target opacity to fade to for fade style highlighting.
            */
            get: function () {
                return this.i.at;
            },
            set: function (v) {
                this.i.at = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column. This only applies to Bar and Column series.
            */
            get: function () {
                return this.i.bg;
            },
            set: function (v) {
                this.i.bg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualRadiusX", {
            /**
             * Gets the actual corner radius of the series
            */
            get: function () {
                return this.i.ax;
            },
            set: function (v) {
                this.i.ax = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualIsSplineShapePartOfRange", {
            /**
             * Gets whether the spline part is considered to be part of the range
            */
            get: function () {
                return this.i.ac;
            },
            set: function (v) {
                this.i.ac = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "isSplineShapePartOfRange", {
            /**
             * Gets or sets whether to include the spline shape in the axis range requested of the axis.
            */
            get: function () {
                return this.i.ai;
            },
            set: function (v) {
                this.i.ai = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column. This only applies to Bar and Column series.
            */
            get: function () {
                return this.i.bh;
            },
            set: function (v) {
                this.i.bh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualRadiusY", {
            /**
             * Gets the actual corner radius of the series
            */
            get: function () {
                return this.i.ay;
            },
            set: function (v) {
                this.i.ay = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "thickness", {
            /**
             * Gets or sets the width of the current series object's line thickness.
            */
            get: function () {
                return this.i.bl;
            },
            set: function (v) {
                this.i.bl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualThickness", {
            /**
             * Gets or sets the thickness of this stacked fragment.
            */
            get: function () {
                return this.i.a2;
            },
            set: function (v) {
                this.i.a2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "markerThickness", {
            /**
             * Gets or sets the width of the current series object's marker thickness.
            */
            get: function () {
                return this.i.be;
            },
            set: function (v) {
                this.i.be = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualMarkerThickness", {
            /**
             * Gets actual marker thickness of this stacked fragment.
            */
            get: function () {
                return this.i.av;
            },
            set: function (v) {
                this.i.av = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "title", {
            /**
             * Gets or sets the Title property.
             * The legend item control is created according to the Title on-demand by
             * the series object itself.
            */
            get: function () {
                return this.i.bv;
            },
            set: function (v) {
                this.i.bv = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "valueMemberPath", {
            /**
             * Gets or sets the value mapping property for the current series object.
            */
            get: function () {
                return this.i.d4;
            },
            set: function (v) {
                this.i.d4 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "visibility", {
            /**
             * Gets or sets the Visibility of the stacked fragment.
            */
            get: function () {
                return this.i.ix;
            },
            set: function (v) {
                this.i.ix = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "actualVisibility", {
            /**
             * Gets the actual visibility of the stacked fragment.
            */
            get: function () {
                return this.i.iv;
            },
            set: function (v) {
                this.i.iv = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "parentOrLocalBrush", {
            /**
             * Gets the resolved brush used between the local series and the parent series.
            */
            get: function () {
                return i2.brushToString(this.i.h2);
            },
            set: function (v) {
                this.i.h2 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedFragmentSeriesComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedFragmentSeriesComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxStackedFragmentSeriesComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("StackedFragmentSeriesComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
         * Gets the item item index associated with the specified world position
        
        */
        IgxStackedFragmentSeriesComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.bn(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxStackedFragmentSeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.bt(i2.toPoint(world));
            return (iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.bq(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
            var iv = this.i.bp(i2.toPoint(world), skipUnknowns);
            return (iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.ba(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.ij(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
        IgxStackedFragmentSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.io(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
        IgxStackedFragmentSeriesComponent.prototype.getSeriesValueMarkerBoundingBox = function (world) {
            var iv = this.i.iq(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.a6(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.ie(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.a8(i2.toPoint(world), useInterpolation, skipUnknowns);
            return (iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.ih(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesValuePositionFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
            var iv = this.i.ik(i2.toPoint(mouse), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxStackedFragmentSeriesComponent.prototype.getSeriesValueFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
            var iv = this.i.bb(i2.toPoint(mouse), useInterpolation, skipUnknowns);
            return (iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxStackedFragmentSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.a5();
            return (iv);
        };
        /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        */
        IgxStackedFragmentSeriesComponent.prototype.toWorldPosition = function (seriesPoint) {
            var iv = this.i.il(i2.toPoint(seriesPoint));
            return i2.fromPoint(iv);
        };
        /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        */
        IgxStackedFragmentSeriesComponent.prototype.fromWorldPosition = function (world) {
            var iv = this.i.id(i2.toPoint(world));
            return i2.fromPoint(iv);
        };
        /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
        IgxStackedFragmentSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.ak(item);
            return (iv);
        };
        /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
        IgxStackedFragmentSeriesComponent.prototype.getEffectiveViewport = function () {
            var iv = this.i.im();
            return i2.fromRect(iv);
        };
        /**
         * Notifies the series that a visual property has changed, requiring a visual update.
        
        */
        IgxStackedFragmentSeriesComponent.prototype.notifyVisualPropertiesChanged = function () {
            this.i.d8();
        };
        /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        */
        IgxStackedFragmentSeriesComponent.prototype.simulateHover = function (point) {
            this.i.ec(i2.toPoint(point));
        };
        /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        */
        IgxStackedFragmentSeriesComponent.prototype.moveCursorPoint = function (point) {
            this.i.d7(i2.toPoint(point));
        };
        Object.defineProperty(IgxStackedFragmentSeriesComponent.prototype, "propertyUpdated", {
            /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
            get: function () {
                var _this = this;
                if (this._propertyUpdated == null) {
                    this._propertyUpdated = new i0.EventEmitter();
                    this.i.propertyUpdated = i2.delegateCombine(this.i.propertyUpdated, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new i2.IgxPropertyUpdatedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforePropertyUpdated) {
                                _this.beforePropertyUpdated(_this, outerArgs);
                            }
                            _this._propertyUpdated.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._propertyUpdated;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedFragmentSeriesComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxStackedFragmentSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedFragmentSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedFragmentSeriesComponent, selector: "igx-stacked-fragment-series", inputs: { dataSource: "dataSource", brush: "brush", actualBrush: "actualBrush", isDropShadowEnabled: "isDropShadowEnabled", actualIsDropShadowEnabled: "actualIsDropShadowEnabled", shadowBlur: "shadowBlur", actualShadowBlur: "actualShadowBlur", shadowColor: "shadowColor", actualShadowColor: "actualShadowColor", useSingleShadow: "useSingleShadow", actualUseSingleShadow: "actualUseSingleShadow", shadowOffsetX: "shadowOffsetX", actualShadowOffsetX: "actualShadowOffsetX", shadowOffsetY: "shadowOffsetY", actualShadowOffsetY: "actualShadowOffsetY", legendItemBadgeTemplate: "legendItemBadgeTemplate", actualLegendItemBadgeTemplate: "actualLegendItemBadgeTemplate", legendItemTemplate: "legendItemTemplate", actualLegendItemTemplate: "actualLegendItemTemplate", legendItemVisibility: "legendItemVisibility", actualLegendItemVisibility: "actualLegendItemVisibility", legendItemBadgeShape: "legendItemBadgeShape", legendItemBadgeMode: "legendItemBadgeMode", actualLegendItemBadgeShape: "actualLegendItemBadgeShape", actualLegendItemBadgeMode: "actualLegendItemBadgeMode", markerBrush: "markerBrush", actualMarkerBrush: "actualMarkerBrush", markerOutline: "markerOutline", actualMarkerOutline: "actualMarkerOutline", markerTemplate: "markerTemplate", actualMarkerTemplate: "actualMarkerTemplate", markerType: "markerType", actualMarkerType: "actualMarkerType", name: "name", opacity: "opacity", actualOpacity: "actualOpacity", outline: "outline", actualOutline: "actualOutline", areaFillOpacity: "areaFillOpacity", actualAreaFillOpacity: "actualAreaFillOpacity", markerFillOpacity: "markerFillOpacity", actualMarkerFillOpacity: "actualMarkerFillOpacity", outlineMode: "outlineMode", actualOutlineMode: "actualOutlineMode", highlightingFadeOpacity: "highlightingFadeOpacity", actualHighlightingFadeOpacity: "actualHighlightingFadeOpacity", radiusX: "radiusX", actualRadiusX: "actualRadiusX", actualIsSplineShapePartOfRange: "actualIsSplineShapePartOfRange", isSplineShapePartOfRange: "isSplineShapePartOfRange", radiusY: "radiusY", actualRadiusY: "actualRadiusY", thickness: "thickness", actualThickness: "actualThickness", markerThickness: "markerThickness", actualMarkerThickness: "actualMarkerThickness", title: "title", valueMemberPath: "valueMemberPath", visibility: "visibility", actualVisibility: "actualVisibility", parentOrLocalBrush: "parentOrLocalBrush" }, outputs: { propertyUpdated: "propertyUpdated" }, providers: [], ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedFragmentSeriesComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-fragment-series',
                        template: "",
                        providers: [],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { dataSource: [{
                    type: i0.Input
                }], brush: [{
                    type: i0.Input
                }], actualBrush: [{
                    type: i0.Input
                }], isDropShadowEnabled: [{
                    type: i0.Input
                }], actualIsDropShadowEnabled: [{
                    type: i0.Input
                }], shadowBlur: [{
                    type: i0.Input
                }], actualShadowBlur: [{
                    type: i0.Input
                }], shadowColor: [{
                    type: i0.Input
                }], actualShadowColor: [{
                    type: i0.Input
                }], useSingleShadow: [{
                    type: i0.Input
                }], actualUseSingleShadow: [{
                    type: i0.Input
                }], shadowOffsetX: [{
                    type: i0.Input
                }], actualShadowOffsetX: [{
                    type: i0.Input
                }], shadowOffsetY: [{
                    type: i0.Input
                }], actualShadowOffsetY: [{
                    type: i0.Input
                }], legendItemBadgeTemplate: [{
                    type: i0.Input
                }], actualLegendItemBadgeTemplate: [{
                    type: i0.Input
                }], legendItemTemplate: [{
                    type: i0.Input
                }], actualLegendItemTemplate: [{
                    type: i0.Input
                }], legendItemVisibility: [{
                    type: i0.Input
                }], actualLegendItemVisibility: [{
                    type: i0.Input
                }], legendItemBadgeShape: [{
                    type: i0.Input
                }], legendItemBadgeMode: [{
                    type: i0.Input
                }], actualLegendItemBadgeShape: [{
                    type: i0.Input
                }], actualLegendItemBadgeMode: [{
                    type: i0.Input
                }], markerBrush: [{
                    type: i0.Input
                }], actualMarkerBrush: [{
                    type: i0.Input
                }], markerOutline: [{
                    type: i0.Input
                }], actualMarkerOutline: [{
                    type: i0.Input
                }], markerTemplate: [{
                    type: i0.Input
                }], actualMarkerTemplate: [{
                    type: i0.Input
                }], markerType: [{
                    type: i0.Input
                }], actualMarkerType: [{
                    type: i0.Input
                }], name: [{
                    type: i0.Input
                }], opacity: [{
                    type: i0.Input
                }], actualOpacity: [{
                    type: i0.Input
                }], outline: [{
                    type: i0.Input
                }], actualOutline: [{
                    type: i0.Input
                }], areaFillOpacity: [{
                    type: i0.Input
                }], actualAreaFillOpacity: [{
                    type: i0.Input
                }], markerFillOpacity: [{
                    type: i0.Input
                }], actualMarkerFillOpacity: [{
                    type: i0.Input
                }], outlineMode: [{
                    type: i0.Input
                }], actualOutlineMode: [{
                    type: i0.Input
                }], highlightingFadeOpacity: [{
                    type: i0.Input
                }], actualHighlightingFadeOpacity: [{
                    type: i0.Input
                }], radiusX: [{
                    type: i0.Input
                }], actualRadiusX: [{
                    type: i0.Input
                }], actualIsSplineShapePartOfRange: [{
                    type: i0.Input
                }], isSplineShapePartOfRange: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }], actualRadiusY: [{
                    type: i0.Input
                }], thickness: [{
                    type: i0.Input
                }], actualThickness: [{
                    type: i0.Input
                }], markerThickness: [{
                    type: i0.Input
                }], actualMarkerThickness: [{
                    type: i0.Input
                }], title: [{
                    type: i0.Input
                }], valueMemberPath: [{
                    type: i0.Input
                }], visibility: [{
                    type: i0.Input
                }], actualVisibility: [{
                    type: i0.Input
                }], parentOrLocalBrush: [{
                    type: i0.Input
                }], propertyUpdated: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedFragmentSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedFragmentSeriesModule() {
        }
        IgxStackedFragmentSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedFragmentSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesModule, declarations: [IgxStackedFragmentSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedFragmentSeriesComponent] });
        IgxStackedFragmentSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedFragmentSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedFragmentSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedFragmentSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedFragmentSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedFragmentSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedFragmentSeriesComponent", IgxStackedFragmentSeriesComponent);
            i2.TypeRegistrar.register("StackedFragmentSeries", StackedFragmentSeries.$type);
        }
        IgxStackedFragmentSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedFragmentSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedFragmentSeriesModule], exports: [IgxStackedFragmentSeriesModule] });
        IgxStackedFragmentSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedFragmentSeriesModule], IgxStackedFragmentSeriesModule] });
        return IgxStackedFragmentSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedFragmentSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedFragmentSeriesModule],
                        exports: [IgxStackedFragmentSeriesModule],
                        entryComponents: [IgxStackedFragmentSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Provides data for IgxDataChartComponent stacked series.
    */
    var IgxStackedSeriesCreatedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedSeriesCreatedEventArgs() {
        }
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedSeriesCreatedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxStackedSeriesCreatedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "brush", {
            /**
             * Gets or sets the series brush.
            */
            get: function () {
                return i2.brushToString(this.i.brush);
            },
            set: function (v) {
                this.i.brush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "legendItemTemplate", {
            /**
             * Gets or sets the series legend item template.
            */
            get: function () {
                return this.i.legendItemTemplate;
            },
            set: function (v) {
                this.i.legendItemTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "legendItemBadgeTemplate", {
            /**
             * Gets or sets the series legend item badge templae.
            */
            get: function () {
                return this.i.legendItemBadgeTemplate;
            },
            set: function (v) {
                this.i.legendItemBadgeTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "legendItemVisibility", {
            /**
             * Gets or sets the visibility of the series legend.
            */
            get: function () {
                return this.i.legendItemVisibility;
            },
            set: function (v) {
                this.i.legendItemVisibility = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "outline", {
            /**
             * Gets or sets the series outline brush.
            */
            get: function () {
                return i2.brushToString(this.i.outline);
            },
            set: function (v) {
                this.i.outline = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "index", {
            /**
             * Gets the index of the series.
            */
            get: function () {
                return this.i.index;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "thickness", {
            /**
             * Gets or sets the series outline thickness.
            */
            get: function () {
                return this.i.thickness;
            },
            set: function (v) {
                this.i.thickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "title", {
            /**
             * Gets or sets the series title.
            */
            get: function () {
                return this.i.title;
            },
            set: function (v) {
                this.i.title = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "markerBrush", {
            /**
             * Gets or sets the series marker brush.
            */
            get: function () {
                return i2.brushToString(this.i.markerBrush);
            },
            set: function (v) {
                this.i.markerBrush = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "markerOutline", {
            /**
             * Gets or sets the series marker outline.
            */
            get: function () {
                return i2.brushToString(this.i.markerOutline);
            },
            set: function (v) {
                this.i.markerOutline = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "markerStyle", {
            /**
             * Gets or sets the series marker style.
            */
            get: function () {
                if (this.i.markerStyle == null) {
                    return null;
                }
                if (!this.i.markerStyle.externalObject) {
                    var e = new i2.IgxStyle();
                    e._implementation = this.i.markerStyle;
                    this.i.markerStyle.externalObject = e;
                }
                return this.i.markerStyle.externalObject;
            },
            set: function (v) {
                v == null ? this.i.markerStyle = null : this.i.markerStyle = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "markerTemplate", {
            /**
             * Gets or sets the series marker template.
            */
            get: function () {
                return this.i.markerTemplate;
            },
            set: function (v) {
                this.i.markerTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "markerType", {
            /**
             * Gets or sets the series marker type.
            */
            get: function () {
                return this.i.markerType;
            },
            set: function (v) {
                this.i.markerType = i2.ensureEnum(MarkerType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesCreatedEventArgs.prototype, "markerThickness", {
            /**
             * Gets or sets the series marker thickness.
            */
            get: function () {
                return this.i.markerThickness;
            },
            set: function (v) {
                this.i.markerThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxStackedSeriesCreatedEventArgs;
    }());

    var IgxStackedSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedSeriesCollection, _super);
        function IgxStackedSeriesCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxStackedFragmentSeriesComponent.$type) {
                IgxStackedFragmentSeriesComponent.$type = i2.markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxStackedSeriesCollection.prototype._createInnerColl = function () {
            if (!IgxStackedFragmentSeriesComponent.$type) {
                IgxStackedFragmentSeriesComponent.$type = i2.markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxStackedFragmentSeriesComponent.$type, StackedFragmentSeries.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxStackedFragmentSeriesComponent();
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxStackedSeriesCollection;
    }(i2.IgCollection));

    /**
     * Represents a base class for stacked series.
    */
    var IgxStackedSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedSeriesBaseComponent, _super);
        function IgxStackedSeriesBaseComponent() {
            var _this = _super.call(this) || this;
            _this._seriesAdapter = null;
            /**
             * The series actually present in the chart. Do not directly modify this array.
             * This array's contents can be modified by causing Angular to reproject the child content.
             * Or adding and removing series from the manual series collection on the series property.
             */
            _this.actualSeries = [];
            _this._series = null;
            _this._seriesCreated = null;
            //=============================
            _this._seriesAdapter = new i2.CollectionAdapter([], _this.i.series, _this.actualSeries, function (c) { return c.i; }, function (i) {
                i.owner = _this;
                //(<any>i)._provideRenderer(this._dataSource);
                //i.provideData(this._dataSource);
                //this._ensureDefaultTooltip(i);
                //this._ensureTooltipCreated(i);
            }, function (i) {
                //(<any>i)._provideRenderer(null);
                //i.provideData(null); 
            });
            return _this;
            //=============================
        }
        IgxStackedSeriesBaseComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxStackedSeriesBaseComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        //=============================
        IgxStackedSeriesBaseComponent.prototype.ngAfterContentInit = function () {
            this._seriesAdapter.updateQuery(this.fragments);
        };
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "series", {
            /**
             * A collection or manually added series for the chart.
            */
            get: function () {
                var _this = this;
                if (this._series === null) {
                    var coll = new IgxStackedSeriesCollection();
                    var inner = coll._innerColl;
                    inner.addListener(function (sender, e) {
                        switch (e.action) {
                            case i2.NotifyCollectionChangedAction.Add:
                                _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Remove:
                                _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                                break;
                            case i2.NotifyCollectionChangedAction.Replace:
                                _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                                _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Reset:
                                _this._seriesAdapter.clearManualItems();
                                break;
                        }
                    });
                    this._series = coll;
                }
                return this._series;
            },
            enumerable: false,
            configurable: true
        });
        //=============================
        IgxStackedSeriesBaseComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "autoGenerateSeries", {
            /**
         * Gets or sets whether series should be automatically generated. Reqiures the use of GroupBy as the ItemsSource.
        */
            get: function () {
                return this.i.s2;
            },
            set: function (v) {
                this.i.s2 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "reverseLegendOrder", {
            /**
             * Gets or sets whether the order of the fragment series should be reversed in the legend.
            */
            get: function () {
                return this.i.s4;
            },
            set: function (v) {
                this.i.s4 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "isStacked", {
            /**
             * Checks if this series is a stacked series
            */
            get: function () {
                return this.i.isStacked;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedSeriesBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.series != null && this.series.findByName && this.series.findByName(name)) {
                return this.series.findByName(name);
            }
            return null;
        };
        /**
     * Called to notify about changes to indexed-based properties, e.g. Brushes, Outlines, MarkerBrushes, MarkerOutlines and refresh series

    */
        IgxStackedSeriesBaseComponent.prototype.notifyIndexedPropertiesChanged = function () {
            this.i.k2();
        };
        /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        */
        IgxStackedSeriesBaseComponent.prototype.simulateHover = function (point) {
            this.i.l7(i2.toPoint(point));
        };
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        */
        IgxStackedSeriesBaseComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        Object.defineProperty(IgxStackedSeriesBaseComponent.prototype, "seriesCreated", {
            /**
             * Event raised when a new fragment series is automatically generated.
            */
            get: function () {
                var _this = this;
                if (this._seriesCreated == null) {
                    this._seriesCreated = new i0.EventEmitter();
                    this.i.seriesCreated = i2.delegateCombine(this.i.seriesCreated, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxStackedSeriesCreatedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSeriesCreated) {
                                _this.beforeSeriesCreated(_this, outerArgs);
                            }
                            _this._seriesCreated.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._seriesCreated;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedSeriesBaseComponent, selector: "ng-component", inputs: { autoGenerateSeries: "autoGenerateSeries", reverseLegendOrder: "reverseLegendOrder" }, outputs: { seriesCreated: "seriesCreated" }, queries: [{ propertyName: "fragments", predicate: IgxStackedFragmentSeriesComponent }], usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxStackedSeriesBaseComponent;
    }(IgxCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { fragments: [{
                    type: i0.ContentChildren,
                    args: [IgxStackedFragmentSeriesComponent]
                }], autoGenerateSeries: [{
                    type: i0.Input
                }], reverseLegendOrder: [{
                    type: i0.Input
                }], seriesCreated: [{
                    type: i0.Output
                }] } });

    /**
     * Base class for stacked series with a category x-axis and a numeric y-axis.
    */
    var IgxHorizontalStackedSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxHorizontalStackedSeriesBaseComponent, _super);
        function IgxHorizontalStackedSeriesBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxHorizontalStackedSeriesBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalStackedSeriesBaseComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for this series.
            */
            get: function () {
                if (this.i.xAxis == null) {
                    return null;
                }
                if (!this.i.xAxis.externalObject) {
                    var e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.xAxis);
                    if (e) {
                        e._implementation = this.i.xAxis;
                    }
                    this.i.xAxis.externalObject = e;
                }
                return this.i.xAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxHorizontalStackedSeriesBaseComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for this series.
            */
            get: function () {
                if (this.i.yAxis == null) {
                    return null;
                }
                if (!this.i.yAxis.externalObject) {
                    var e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
                    if (e) {
                        e._implementation = this.i.yAxis;
                    }
                    this.i.yAxis.externalObject = e;
                }
                return this.i.yAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxHorizontalStackedSeriesBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxHorizontalStackedSeriesBaseComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
        IgxHorizontalStackedSeriesBaseComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        */
        IgxHorizontalStackedSeriesBaseComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxHorizontalStackedSeriesBaseComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.tv(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxHorizontalStackedSeriesBaseComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.tu(axis);
            return (iv);
        };
        IgxHorizontalStackedSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalStackedSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxHorizontalStackedSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxHorizontalStackedSeriesBaseComponent, selector: "ng-component", inputs: { xAxis: "xAxis", yAxis: "yAxis" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxHorizontalStackedSeriesBaseComponent;
    }(IgxStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalStackedSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked area series.
    */
    var IgxStackedAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedAreaSeriesComponent, _super);
        function IgxStackedAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStackedAreaSeriesComponent.prototype.createImplementation = function () {
            return new StackedAreaSeries();
        };
        Object.defineProperty(IgxStackedAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedAreaSeriesComponent, selector: "igx-stacked-area-series", providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedAreaSeriesComponent;
    }(IgxHorizontalStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-area-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100DataPreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100DataPreparer, _super);
        function Stacked100DataPreparer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Stacked100DataPreparer.a = function (a) {
            if (a.ch == null) {
                return;
            }
            var b = Number.POSITIVE_INFINITY;
            var c = Number.NEGATIVE_INFINITY;
            for (var d = 0; d < a.ch.count; d++) {
                var e = Math.abs(a.st[d]) + a.ss[d];
                if (e == 0) {
                    b = Math.min(b, 0);
                    c = Math.max(c, 0);
                    continue;
                }
                b = Math.min(b, a.st[d] / e * 100);
                c = Math.max(c, a.ss[d] / e * 100);
            }
            a.ta = b;
            a.s9 = c;
        };
        Stacked100DataPreparer.$t = i2.markType(Stacked100DataPreparer, 'Stacked100DataPreparer');
        return Stacked100DataPreparer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100AreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100AreaSeries, _super);
        function Stacked100AreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = Stacked100AreaSeries.$;
            return _this;
        }
        Stacked100AreaSeries.prototype.get_s3 = function () {
            return true;
        };
        Stacked100AreaSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        Stacked100AreaSeries.prototype.bu = function () {
            return new Stacked100AreaSeriesView(this);
        };
        Stacked100AreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t1 = a;
        };
        Stacked100AreaSeries.prototype.tj = function () {
            _super.prototype.tj.call(this);
            Stacked100DataPreparer.a(this);
        };
        Object.defineProperty(Stacked100AreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        Stacked100AreaSeries.$t = i2.markType(Stacked100AreaSeries, 'Stacked100AreaSeries', StackedAreaSeries.$, [IStacked100Series_$type]);
        return Stacked100AreaSeries;
    }(StackedAreaSeries));
    /**
     * @hidden
     */
    var Stacked100AreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100AreaSeriesView, _super);
        function Stacked100AreaSeriesView(a) {
            return _super.call(this, a) || this;
        }
        Stacked100AreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        Stacked100AreaSeriesView.$t = i2.markType(Stacked100AreaSeriesView, 'Stacked100AreaSeriesView', StackedAreaSeriesView.$);
        return Stacked100AreaSeriesView;
    }(StackedAreaSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a stacked area series, where values are presented as percentages of the total.
    */
    var IgxStacked100AreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStacked100AreaSeriesComponent, _super);
        function IgxStacked100AreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStacked100AreaSeriesComponent.prototype.createImplementation = function () {
            return new Stacked100AreaSeries();
        };
        Object.defineProperty(IgxStacked100AreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStacked100AreaSeriesComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStacked100AreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStacked100AreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100AreaSeriesComponent, selector: "igx-stacked-100-area-series", providers: [{ provide: IgxStackedAreaSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStacked100AreaSeriesComponent;
    }(IgxStackedAreaSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-100-area-series',
                        template: "",
                        providers: [{ provide: IgxStackedAreaSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100AreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100AreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100AreaSeriesModule() {
        }
        IgxStacked100AreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100AreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesModule, declarations: [IgxStacked100AreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxStacked100AreaSeriesComponent] });
        IgxStacked100AreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStacked100AreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStacked100AreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStacked100AreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100AreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100AreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStacked100AreaSeriesComponent", IgxStacked100AreaSeriesComponent);
            i2.TypeRegistrar.register("Stacked100AreaSeries", Stacked100AreaSeries.$type);
        }
        IgxStacked100AreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100AreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesDynamicModule, imports: [i1.CommonModule, IgxStacked100AreaSeriesModule], exports: [IgxStacked100AreaSeriesModule] });
        IgxStacked100AreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxStacked100AreaSeriesModule], IgxStacked100AreaSeriesModule] });
        return IgxStacked100AreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100AreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStacked100AreaSeriesModule],
                        exports: [IgxStacked100AreaSeriesModule],
                        entryComponents: [IgxStacked100AreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Base class for stacked series with a numeric x-axis and a category y-axis.
    */
    var IgxVerticalStackedSeriesBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxVerticalStackedSeriesBaseComponent, _super);
        function IgxVerticalStackedSeriesBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxVerticalStackedSeriesBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxVerticalStackedSeriesBaseComponent.prototype, "xAxis", {
            /**
             * Gets or sets the effective x-axis for the current CategorySeries object.
            */
            get: function () {
                if (this.i.xAxis == null) {
                    return null;
                }
                if (!this.i.xAxis.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.xAxis);
                    if (e) {
                        e._implementation = this.i.xAxis;
                    }
                    this.i.xAxis.externalObject = e;
                }
                return this.i.xAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxVerticalStackedSeriesBaseComponent.prototype, "yAxis", {
            /**
             * Gets or sets the effective y-axis for the current CategorySeries object.
            */
            get: function () {
                if (this.i.yAxis == null) {
                    return null;
                }
                if (!this.i.yAxis.externalObject) {
                    var e = IgxCategoryYAxisComponent._createFromInternal(this.i.yAxis);
                    if (e) {
                        e._implementation = this.i.yAxis;
                    }
                    this.i.yAxis.externalObject = e;
                }
                return this.i.yAxis.externalObject;
            },
            set: function (v) {
                if (v != null && this._stylingContainer && v._styling)
                    v._styling(this._stylingContainer, this, this);
                v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxVerticalStackedSeriesBaseComponent.prototype, "isVertical", {
            /**
             * Gets whether or not the current series is vertical series
            */
            get: function () {
                return this.i.isVertical;
            },
            enumerable: false,
            configurable: true
        });
        IgxVerticalStackedSeriesBaseComponent.prototype.findByName = function (name) {
            var baseResult = _super.prototype.findByName.call(this, name);
            if (baseResult) {
                return baseResult;
            }
            if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
                return this.xAxis;
            }
            if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
                return this.yAxis;
            }
            return null;
        };
        IgxVerticalStackedSeriesBaseComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
        IgxVerticalStackedSeriesBaseComponent.prototype.getOffsetValue = function () {
            var iv = this.i.getOffsetValue();
            return (iv);
        };
        /**
         * Returns the width of the category grouping this series is in.
        
        */
        IgxVerticalStackedSeriesBaseComponent.prototype.getCategoryWidth = function () {
            var iv = this.i.getCategoryWidth();
            return (iv);
        };
        /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
        IgxVerticalStackedSeriesBaseComponent.prototype.canUseAsYAxis = function (axis) {
            var iv = this.i.tv(axis);
            return (iv);
        };
        /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
        IgxVerticalStackedSeriesBaseComponent.prototype.canUseAsXAxis = function (axis) {
            var iv = this.i.tu(axis);
            return (iv);
        };
        IgxVerticalStackedSeriesBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxVerticalStackedSeriesBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxVerticalStackedSeriesBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxVerticalStackedSeriesBaseComponent, selector: "ng-component", inputs: { xAxis: "xAxis", yAxis: "yAxis" }, usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxVerticalStackedSeriesBaseComponent;
    }(IgxStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxVerticalStackedSeriesBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { xAxis: [{
                    type: i0.Input
                }], yAxis: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked bar series.
    */
    var IgxStackedBarSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedBarSeriesComponent, _super);
        function IgxStackedBarSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStackedBarSeriesComponent.prototype.createImplementation = function () {
            return new StackedBarSeries();
        };
        Object.defineProperty(IgxStackedBarSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedBarSeriesComponent.prototype, "isBar", {
            /**
             * Gets whether the current series shows a bar shape.
            */
            get: function () {
                return this.i.c9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedBarSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedBarSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
            */
            get: function () {
                return this.i.t1;
            },
            set: function (v) {
                this.i.t1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedBarSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
            */
            get: function () {
                return this.i.t2;
            },
            set: function (v) {
                this.i.t2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        */
        IgxStackedBarSeriesComponent.prototype.scrollIntoView = function (item) {
            var iv = this.i.eh(item);
            return (iv);
        };
        /**
         * Gets the index of the item that resides at the provided world coordinates.
        
        * @param world  * The world coordinates of the requested item.
        */
        IgxStackedBarSeriesComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxStackedBarSeriesComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxStackedBarSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxStackedBarSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedBarSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedBarSeriesComponent, selector: "igx-stacked-bar-series", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxVerticalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedBarSeriesComponent;
    }(IgxVerticalStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-bar-series',
                        template: "",
                        providers: [{ provide: IgxVerticalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedBarSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100BarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100BarBucketCalculator, _super);
        function Stacked100BarBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        Stacked100BarBucketCalculator.prototype.getBucket = function (a) {
            return _super.prototype.getBucket.call(this, a);
        };
        Stacked100BarBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
            var g = i2.typeCast(StackedBarSeries.$, this.c.ct);
            var h = [NaN, NaN, NaN];
            var i = i2.typeCast(BarFragment.$, a);
            if (i == null || i.logicalSeriesLink == null) {
                return h;
            }
            var j = a.valueColumn.item(c);
            var k = 0;
            var l = 0;
            var m = NaN;
            var n = NaN;
            var o = Number.NEGATIVE_INFINITY;
            var p = Number.POSITIVE_INFINITY;
            var q = g.getEffectiveViewport1(this.c);
            var r = Math.min(g.st != null ? g.st.length : 0, g.ss != null ? g.ss.length : 0);
            var s = c * this.d;
            var t = Math.min(s + this.d - 1, r - 1);
            for (var u = s; u <= t; ++u) {
                j = a.valueColumn.item(u);
                k = Math.abs(g.st[u]) + g.ss[u];
                if (j < l) {
                    p = Math.min(p, (i.logicalSeriesLink.aq._inner[u] + j) / k * 100);
                    o = Math.max(o, i.logicalSeriesLink.aq._inner[u] / k * 100);
                }
                else {
                    p = Math.min(p, i.logicalSeriesLink.ap._inner[u] / k * 100);
                    o = Math.max(o, (i.logicalSeriesLink.ap._inner[u] + j) / k * 100);
                }
                if (!i2.isNaN_(m)) {
                    if (!i2.isNaN_(p)) {
                        m = Math.min(m, p);
                        n = Math.max(n, p);
                    }
                    if (!i2.isNaN_(o)) {
                        m = Math.min(m, o);
                        n = Math.max(n, o);
                    }
                }
                else {
                    m = p;
                    n = o;
                }
            }
            var v = new ScalerParams(0, d, e, g.xAxis.cc, q);
            h = [f.f._inner[b - this.e][0], g.xAxis.d8(n, v), g.xAxis.d8(m, v)];
            return h;
        };
        Stacked100BarBucketCalculator.$t = i2.markType(Stacked100BarBucketCalculator, 'Stacked100BarBucketCalculator', StackedBarBucketCalculator.$);
        return Stacked100BarBucketCalculator;
    }(StackedBarBucketCalculator));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100BarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100BarSeries, _super);
        function Stacked100BarSeries() {
            var _this = _super.call(this) || this;
            _this.ab = Stacked100BarSeries.$;
            return _this;
        }
        Stacked100BarSeries.prototype.get_s3 = function () {
            return true;
        };
        Stacked100BarSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        Stacked100BarSeries.prototype.bu = function () {
            return new Stacked100BarSeriesView(this);
        };
        Stacked100BarSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t7 = a;
        };
        Stacked100BarSeries.prototype.sv = function () {
            return this.t7;
        };
        Stacked100BarSeries.prototype.tj = function () {
            _super.prototype.tj.call(this);
            Stacked100DataPreparer.a(this);
        };
        Object.defineProperty(Stacked100BarSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        Stacked100BarSeries.$t = i2.markType(Stacked100BarSeries, 'Stacked100BarSeries', StackedBarSeries.$, [IStacked100Series_$type]);
        return Stacked100BarSeries;
    }(StackedBarSeries));
    /**
     * @hidden
     */
    var Stacked100BarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100BarSeriesView, _super);
        function Stacked100BarSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c6 = null;
            _this.c6 = a;
            return _this;
        }
        Stacked100BarSeriesView.prototype.cs = function () {
            return new Stacked100BarBucketCalculator(this);
        };
        Stacked100BarSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.c;
                this.c0.gh = Defaults.h;
                this.c0.gm = Defaults.i;
            }
        };
        Stacked100BarSeriesView.$t = i2.markType(Stacked100BarSeriesView, 'Stacked100BarSeriesView', StackedBarSeriesView.$);
        return Stacked100BarSeriesView;
    }(StackedBarSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked100 bar series.
    */
    var IgxStacked100BarSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStacked100BarSeriesComponent, _super);
        function IgxStacked100BarSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStacked100BarSeriesComponent.prototype.createImplementation = function () {
            return new Stacked100BarSeries();
        };
        Object.defineProperty(IgxStacked100BarSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStacked100BarSeriesComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStacked100BarSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStacked100BarSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100BarSeriesComponent, selector: "igx-stacked-100-bar-series", providers: [{ provide: IgxStackedBarSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxVerticalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStacked100BarSeriesComponent;
    }(IgxStackedBarSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-100-bar-series',
                        template: "",
                        providers: [{ provide: IgxStackedBarSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxVerticalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100BarSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100BarSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100BarSeriesModule() {
        }
        IgxStacked100BarSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100BarSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesModule, declarations: [IgxStacked100BarSeriesComponent], imports: [i1.CommonModule], exports: [IgxStacked100BarSeriesComponent] });
        IgxStacked100BarSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStacked100BarSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStacked100BarSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStacked100BarSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100BarSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100BarSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStacked100BarSeriesComponent", IgxStacked100BarSeriesComponent);
            i2.TypeRegistrar.register("Stacked100BarSeries", Stacked100BarSeries.$type);
        }
        IgxStacked100BarSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100BarSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesDynamicModule, imports: [i1.CommonModule, IgxStacked100BarSeriesModule], exports: [IgxStacked100BarSeriesModule] });
        IgxStacked100BarSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesDynamicModule, imports: [[i1.CommonModule, IgxStacked100BarSeriesModule], IgxStacked100BarSeriesModule] });
        return IgxStacked100BarSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100BarSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStacked100BarSeriesModule],
                        exports: [IgxStacked100BarSeriesModule],
                        entryComponents: [IgxStacked100BarSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked column series.
    */
    var IgxStackedColumnSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedColumnSeriesComponent, _super);
        function IgxStackedColumnSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStackedColumnSeriesComponent.prototype.createImplementation = function () {
            return new StackedColumnSeries();
        };
        Object.defineProperty(IgxStackedColumnSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedColumnSeriesComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedColumnSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedColumnSeriesComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.t1;
            },
            set: function (v) {
                this.i.t1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedColumnSeriesComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.t2;
            },
            set: function (v) {
                this.i.t2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
        IgxStackedColumnSeriesComponent.prototype.getItemSpan = function () {
            var iv = this.i.f1();
            return (iv);
        };
        IgxStackedColumnSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedColumnSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedColumnSeriesComponent, selector: "igx-stacked-column-series", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedColumnSeriesComponent;
    }(IgxHorizontalStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-column-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedColumnSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100ColumnBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100ColumnBucketCalculator, _super);
        function Stacked100ColumnBucketCalculator(a) {
            return _super.call(this, a) || this;
        }
        Stacked100ColumnBucketCalculator.prototype.getBucket = function (a) {
            return _super.prototype.getBucket.call(this, a);
        };
        Stacked100ColumnBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
            var g = i2.typeCast(StackedSeriesBase.$, this.c.ct);
            var h = [NaN, NaN, NaN];
            var i = i2.typeCast(ColumnFragment.$, a);
            if (i == null || i.logicalSeriesLink == null) {
                return h;
            }
            var j = g.getEffectiveViewport1(this.c);
            var k = a.valueColumn.item(c);
            var l = 0;
            var m = NaN;
            var n = NaN;
            var o = Number.NEGATIVE_INFINITY;
            var p = Number.POSITIVE_INFINITY;
            var q = 0;
            var r = Math.min(g.st != null ? g.st.length : 0, g.ss != null ? g.ss.length : 0);
            var s = c * this.d;
            var t = Math.min(s + this.d - 1, r - 1);
            for (var u = s; u <= t; ++u) {
                k = a.valueColumn.item(u);
                q = Math.abs(g.st[u]) + g.ss[u];
                if (k < l) {
                    p = Math.min(p, (i.logicalSeriesLink.aq._inner[u] + k) / q * 100);
                    o = Math.max(o, i.logicalSeriesLink.aq._inner[u] / q * 100);
                }
                else {
                    p = Math.min(p, i.logicalSeriesLink.ap._inner[u] / q * 100);
                    o = Math.max(o, (i.logicalSeriesLink.ap._inner[u] + k) / q * 100);
                }
                if (!i2.isNaN_(m)) {
                    if (!i2.isNaN_(p)) {
                        m = Math.min(m, p);
                        n = Math.max(n, p);
                    }
                    if (!i2.isNaN_(o)) {
                        m = Math.min(m, o);
                        n = Math.max(n, o);
                    }
                }
                else {
                    m = p;
                    n = o;
                }
            }
            var v = new ScalerParams(0, d, e, i.fragmentYAxis.cc, j);
            h = [f.f._inner[b - this.e][0], i.fragmentYAxis.d8(n, v), i.fragmentYAxis.d8(m, v)];
            return h;
        };
        Stacked100ColumnBucketCalculator.$t = i2.markType(Stacked100ColumnBucketCalculator, 'Stacked100ColumnBucketCalculator', StackedColumnBucketCalculator.$);
        return Stacked100ColumnBucketCalculator;
    }(StackedColumnBucketCalculator));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100ColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100ColumnSeries, _super);
        function Stacked100ColumnSeries() {
            var _this = _super.call(this) || this;
            _this.ab = Stacked100ColumnSeries.$;
            return _this;
        }
        Stacked100ColumnSeries.prototype.get_s3 = function () {
            return true;
        };
        Stacked100ColumnSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        Stacked100ColumnSeries.prototype.bu = function () {
            return new Stacked100ColumnSeriesView(this);
        };
        Stacked100ColumnSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t7 = a;
        };
        Stacked100ColumnSeries.prototype.sv = function () {
            return this.t7;
        };
        Stacked100ColumnSeries.prototype.tj = function () {
            _super.prototype.tj.call(this);
            Stacked100DataPreparer.a(this);
        };
        Object.defineProperty(Stacked100ColumnSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        Stacked100ColumnSeries.$t = i2.markType(Stacked100ColumnSeries, 'Stacked100ColumnSeries', StackedColumnSeries.$, [IStacked100Series_$type]);
        return Stacked100ColumnSeries;
    }(StackedColumnSeries));
    /**
     * @hidden
     */
    var Stacked100ColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100ColumnSeriesView, _super);
        function Stacked100ColumnSeriesView(a) {
            var _this = _super.call(this, a) || this;
            _this.c5 = null;
            _this.c5 = a;
            return _this;
        }
        Stacked100ColumnSeriesView.prototype.cs = function () {
            return new Stacked100ColumnBucketCalculator(this);
        };
        Stacked100ColumnSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.c;
                this.c0.gh = Defaults.h;
                this.c0.gm = Defaults.i;
            }
        };
        Stacked100ColumnSeriesView.$t = i2.markType(Stacked100ColumnSeriesView, 'Stacked100ColumnSeriesView', StackedColumnSeriesView.$);
        return Stacked100ColumnSeriesView;
    }(StackedColumnSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked100 column series.
    */
    var IgxStacked100ColumnSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStacked100ColumnSeriesComponent, _super);
        function IgxStacked100ColumnSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStacked100ColumnSeriesComponent.prototype.createImplementation = function () {
            return new Stacked100ColumnSeries();
        };
        Object.defineProperty(IgxStacked100ColumnSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStacked100ColumnSeriesComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStacked100ColumnSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStacked100ColumnSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100ColumnSeriesComponent, selector: "igx-stacked-100-column-series", providers: [{ provide: IgxStackedColumnSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStacked100ColumnSeriesComponent;
    }(IgxStackedColumnSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-100-column-series',
                        template: "",
                        providers: [{ provide: IgxStackedColumnSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100ColumnSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100ColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100ColumnSeriesModule() {
        }
        IgxStacked100ColumnSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100ColumnSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesModule, declarations: [IgxStacked100ColumnSeriesComponent], imports: [i1.CommonModule], exports: [IgxStacked100ColumnSeriesComponent] });
        IgxStacked100ColumnSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStacked100ColumnSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStacked100ColumnSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStacked100ColumnSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100ColumnSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100ColumnSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStacked100ColumnSeriesComponent", IgxStacked100ColumnSeriesComponent);
            i2.TypeRegistrar.register("Stacked100ColumnSeries", Stacked100ColumnSeries.$type);
        }
        IgxStacked100ColumnSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100ColumnSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesDynamicModule, imports: [i1.CommonModule, IgxStacked100ColumnSeriesModule], exports: [IgxStacked100ColumnSeriesModule] });
        IgxStacked100ColumnSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesDynamicModule, imports: [[i1.CommonModule, IgxStacked100ColumnSeriesModule], IgxStacked100ColumnSeriesModule] });
        return IgxStacked100ColumnSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100ColumnSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStacked100ColumnSeriesModule],
                        exports: [IgxStacked100ColumnSeriesModule],
                        entryComponents: [IgxStacked100ColumnSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StackedLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedLineSeries, _super);
        function StackedLineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = StackedLineSeries.$;
            return _this;
        }
        StackedLineSeries.prototype.get_dv = function () {
            return true;
        };
        StackedLineSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        StackedLineSeries.prototype.bu = function () {
            return new StackedLineSeriesView(this);
        };
        StackedLineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t0 = a;
        };
        StackedLineSeries.prototype.ap = function (a) {
            if (this.itemsSource == null) {
                return null;
            }
            if (a == this.xAxis) {
                return new AxisRange(0, this.ch.count - 1);
            }
            if (a == this.yAxis) {
                this.tj();
                return new AxisRange(this.ta, this.s9);
            }
            return null;
        };
        StackedLineSeries.prototype.preferredCategoryMode = function (a) {
            return 0;
        };
        Object.defineProperty(StackedLineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        StackedLineSeries.$t = i2.markType(StackedLineSeries, 'StackedLineSeries', HorizontalStackedSeriesBase.$);
        return StackedLineSeries;
    }(HorizontalStackedSeriesBase));
    /**
     * @hidden
     */
    var StackedLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedLineSeriesView, _super);
        function StackedLineSeriesView(a) {
            return _super.call(this, a) || this;
        }
        StackedLineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        StackedLineSeriesView.$t = i2.markType(StackedLineSeriesView, 'StackedLineSeriesView', StackedSeriesView.$);
        return StackedLineSeriesView;
    }(StackedSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a stacked series, where the points in each series are connected with a line.
    */
    var IgxStackedLineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedLineSeriesComponent, _super);
        function IgxStackedLineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStackedLineSeriesComponent.prototype.createImplementation = function () {
            return new StackedLineSeries();
        };
        Object.defineProperty(IgxStackedLineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedLineSeriesComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedLineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedLineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedLineSeriesComponent, selector: "igx-stacked-line-series", providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedLineSeriesComponent;
    }(IgxHorizontalStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-line-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedLineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100LineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100LineSeries, _super);
        function Stacked100LineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = Stacked100LineSeries.$;
            return _this;
        }
        Stacked100LineSeries.prototype.bu = function () {
            return new Stacked100LineSeriesView(this);
        };
        Stacked100LineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t1 = a;
        };
        Stacked100LineSeries.prototype.get_s3 = function () {
            return true;
        };
        Stacked100LineSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        Stacked100LineSeries.prototype.tj = function () {
            _super.prototype.tj.call(this);
            Stacked100DataPreparer.a(this);
        };
        Object.defineProperty(Stacked100LineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        Stacked100LineSeries.$t = i2.markType(Stacked100LineSeries, 'Stacked100LineSeries', StackedLineSeries.$, [IStacked100Series_$type]);
        return Stacked100LineSeries;
    }(StackedLineSeries));
    /**
     * @hidden
     */
    var Stacked100LineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100LineSeriesView, _super);
        function Stacked100LineSeriesView(a) {
            return _super.call(this, a) || this;
        }
        Stacked100LineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        Stacked100LineSeriesView.$t = i2.markType(Stacked100LineSeriesView, 'Stacked100LineSeriesView', StackedSeriesView.$);
        return Stacked100LineSeriesView;
    }(StackedSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked100 line series.
    */
    var IgxStacked100LineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStacked100LineSeriesComponent, _super);
        function IgxStacked100LineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStacked100LineSeriesComponent.prototype.createImplementation = function () {
            return new Stacked100LineSeries();
        };
        Object.defineProperty(IgxStacked100LineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStacked100LineSeriesComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStacked100LineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStacked100LineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100LineSeriesComponent, selector: "igx-stacked-100-line-series", providers: [{ provide: IgxStackedLineSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStacked100LineSeriesComponent;
    }(IgxStackedLineSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-100-line-series',
                        template: "",
                        providers: [{ provide: IgxStackedLineSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100LineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100LineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100LineSeriesModule() {
        }
        IgxStacked100LineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100LineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesModule, declarations: [IgxStacked100LineSeriesComponent], imports: [i1.CommonModule], exports: [IgxStacked100LineSeriesComponent] });
        IgxStacked100LineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStacked100LineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStacked100LineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStacked100LineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100LineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100LineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStacked100LineSeriesComponent", IgxStacked100LineSeriesComponent);
            i2.TypeRegistrar.register("Stacked100LineSeries", Stacked100LineSeries.$type);
        }
        IgxStacked100LineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100LineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesDynamicModule, imports: [i1.CommonModule, IgxStacked100LineSeriesModule], exports: [IgxStacked100LineSeriesModule] });
        IgxStacked100LineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesDynamicModule, imports: [[i1.CommonModule, IgxStacked100LineSeriesModule], IgxStacked100LineSeriesModule] });
        return IgxStacked100LineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100LineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStacked100LineSeriesModule],
                        exports: [IgxStacked100LineSeriesModule],
                        entryComponents: [IgxStacked100LineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked spline series.
    */
    var IgxStackedSplineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedSplineSeriesComponent, _super);
        function IgxStackedSplineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStackedSplineSeriesComponent.prototype.createImplementation = function () {
            return new StackedSplineSeries();
        };
        Object.defineProperty(IgxStackedSplineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSplineSeriesComponent.prototype, "isSplineShapePartOfRange", {
            /**
             * Gets or sets whether to include the spline shape in the axis range requested of the axis.
            */
            get: function () {
                return this.i.t1;
            },
            set: function (v) {
                this.i.t1 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSplineSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedSplineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedSplineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedSplineSeriesComponent, selector: "igx-stacked-spline-series", inputs: { isSplineShapePartOfRange: "isSplineShapePartOfRange" }, providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedSplineSeriesComponent;
    }(IgxHorizontalStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-spline-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { isSplineShapePartOfRange: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100SplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100SplineSeries, _super);
        function Stacked100SplineSeries() {
            var _this = _super.call(this) || this;
            _this.ab = Stacked100SplineSeries.$;
            return _this;
        }
        Stacked100SplineSeries.prototype.bu = function () {
            return new Stacked100SplineSeriesView(this);
        };
        Stacked100SplineSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t4 = a;
        };
        Stacked100SplineSeries.prototype.get_s3 = function () {
            return true;
        };
        Stacked100SplineSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        Stacked100SplineSeries.prototype.tj = function () {
            _super.prototype.tj.call(this);
            Stacked100DataPreparer.a(this);
        };
        Object.defineProperty(Stacked100SplineSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        Stacked100SplineSeries.$t = i2.markType(Stacked100SplineSeries, 'Stacked100SplineSeries', StackedSplineSeries.$, [IStacked100Series_$type]);
        return Stacked100SplineSeries;
    }(StackedSplineSeries));
    /**
     * @hidden
     */
    var Stacked100SplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100SplineSeriesView, _super);
        function Stacked100SplineSeriesView(a) {
            return _super.call(this, a) || this;
        }
        Stacked100SplineSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        Stacked100SplineSeriesView.$t = i2.markType(Stacked100SplineSeriesView, 'Stacked100SplineSeriesView', StackedSplineSeriesView.$);
        return Stacked100SplineSeriesView;
    }(StackedSplineSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked100 spline series.
    */
    var IgxStacked100SplineSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStacked100SplineSeriesComponent, _super);
        function IgxStacked100SplineSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStacked100SplineSeriesComponent.prototype.createImplementation = function () {
            return new Stacked100SplineSeries();
        };
        Object.defineProperty(IgxStacked100SplineSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStacked100SplineSeriesComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStacked100SplineSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStacked100SplineSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100SplineSeriesComponent, selector: "igx-stacked-100-spline-series", providers: [{ provide: IgxStackedSplineSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStacked100SplineSeriesComponent;
    }(IgxStackedSplineSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-100-spline-series',
                        template: "",
                        providers: [{ provide: IgxStackedSplineSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100SplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100SplineSeriesModule() {
        }
        IgxStacked100SplineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100SplineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesModule, declarations: [IgxStacked100SplineSeriesComponent], imports: [i1.CommonModule], exports: [IgxStacked100SplineSeriesComponent] });
        IgxStacked100SplineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStacked100SplineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStacked100SplineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStacked100SplineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100SplineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100SplineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStacked100SplineSeriesComponent", IgxStacked100SplineSeriesComponent);
            i2.TypeRegistrar.register("Stacked100SplineSeries", Stacked100SplineSeries.$type);
        }
        IgxStacked100SplineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100SplineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesDynamicModule, imports: [i1.CommonModule, IgxStacked100SplineSeriesModule], exports: [IgxStacked100SplineSeriesModule] });
        IgxStacked100SplineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesDynamicModule, imports: [[i1.CommonModule, IgxStacked100SplineSeriesModule], IgxStacked100SplineSeriesModule] });
        return IgxStacked100SplineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStacked100SplineSeriesModule],
                        exports: [IgxStacked100SplineSeriesModule],
                        entryComponents: [IgxStacked100SplineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked spline area series.
    */
    var IgxStackedSplineAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStackedSplineAreaSeriesComponent, _super);
        function IgxStackedSplineAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStackedSplineAreaSeriesComponent.prototype.createImplementation = function () {
            return new StackedSplineAreaSeries();
        };
        Object.defineProperty(IgxStackedSplineAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSplineAreaSeriesComponent.prototype, "isSplineShapePartOfRange", {
            /**
             * Gets or sets whether to include the spline shape in the axis range requested of the axis.
            */
            get: function () {
                return this.i.t1;
            },
            set: function (v) {
                this.i.t1 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSplineAreaSeriesComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStackedSplineAreaSeriesComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        IgxStackedSplineAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStackedSplineAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStackedSplineAreaSeriesComponent, selector: "igx-stacked-spline-area-series", inputs: { isSplineShapePartOfRange: "isSplineShapePartOfRange" }, providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStackedSplineAreaSeriesComponent;
    }(IgxHorizontalStackedSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-spline-area-series',
                        template: "",
                        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStackedSplineAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { isSplineShapePartOfRange: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Stacked100SplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100SplineAreaSeries, _super);
        function Stacked100SplineAreaSeries() {
            var _this = _super.call(this) || this;
            _this.ab = Stacked100SplineAreaSeries.$;
            return _this;
        }
        Stacked100SplineAreaSeries.prototype.bu = function () {
            return new Stacked100SplineAreaSeriesView(this);
        };
        Stacked100SplineAreaSeries.prototype.lh = function (a) {
            _super.prototype.lh.call(this, a);
            this.t4 = a;
        };
        Stacked100SplineAreaSeries.prototype.get_s3 = function () {
            return true;
        };
        Stacked100SplineAreaSeries.prototype.ac = function () {
            _super.prototype.ac.call(this);
            this.l0(false);
        };
        Stacked100SplineAreaSeries.prototype.tj = function () {
            _super.prototype.tj.call(this);
            Stacked100DataPreparer.a(this);
        };
        Object.defineProperty(Stacked100SplineAreaSeries.prototype, "useHighMarkerFidelity", {
            get: function () {
                return this.ry;
            },
            enumerable: false,
            configurable: true
        });
        Stacked100SplineAreaSeries.$t = i2.markType(Stacked100SplineAreaSeries, 'Stacked100SplineAreaSeries', StackedSplineAreaSeries.$, [IStacked100Series_$type]);
        return Stacked100SplineAreaSeries;
    }(StackedSplineAreaSeries));
    /**
     * @hidden
     */
    var Stacked100SplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Stacked100SplineAreaSeriesView, _super);
        function Stacked100SplineAreaSeriesView(a) {
            return _super.call(this, a) || this;
        }
        Stacked100SplineAreaSeriesView.prototype.as = function () {
            _super.prototype.as.call(this);
            if (!this.q) {
                this.c0.pr = Defaults.e;
            }
        };
        Stacked100SplineAreaSeriesView.$t = i2.markType(Stacked100SplineAreaSeriesView, 'Stacked100SplineAreaSeriesView', StackedSplineAreaSeriesView.$);
        return Stacked100SplineAreaSeriesView;
    }(StackedSplineAreaSeriesView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a IgxDataChartComponent stacked100 spline area series.
    */
    var IgxStacked100SplineAreaSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxStacked100SplineAreaSeriesComponent, _super);
        function IgxStacked100SplineAreaSeriesComponent() {
            return _super.call(this) || this;
        }
        IgxStacked100SplineAreaSeriesComponent.prototype.createImplementation = function () {
            return new Stacked100SplineAreaSeries();
        };
        Object.defineProperty(IgxStacked100SplineAreaSeriesComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxStacked100SplineAreaSeriesComponent.prototype, "isPercentBased", {
            get: function () {
                return this.i.s3;
            },
            enumerable: false,
            configurable: true
        });
        IgxStacked100SplineAreaSeriesComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxStacked100SplineAreaSeriesComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxStacked100SplineAreaSeriesComponent, selector: "igx-stacked-100-spline-area-series", providers: [{ provide: IgxStackedSplineAreaSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxStacked100SplineAreaSeriesComponent;
    }(IgxStackedSplineAreaSeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-stacked-100-spline-area-series',
                        template: "",
                        providers: [{ provide: IgxStackedSplineAreaSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxStackedSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxStacked100SplineAreaSeriesComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100SplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100SplineAreaSeriesModule() {
        }
        IgxStacked100SplineAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100SplineAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesModule, declarations: [IgxStacked100SplineAreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxStacked100SplineAreaSeriesComponent] });
        IgxStacked100SplineAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStacked100SplineAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStacked100SplineAreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStacked100SplineAreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStacked100SplineAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStacked100SplineAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStacked100SplineAreaSeriesComponent", IgxStacked100SplineAreaSeriesComponent);
            i2.TypeRegistrar.register("Stacked100SplineAreaSeries", Stacked100SplineAreaSeries.$type);
        }
        IgxStacked100SplineAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStacked100SplineAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxStacked100SplineAreaSeriesModule], exports: [IgxStacked100SplineAreaSeriesModule] });
        IgxStacked100SplineAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxStacked100SplineAreaSeriesModule], IgxStacked100SplineAreaSeriesModule] });
        return IgxStacked100SplineAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStacked100SplineAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStacked100SplineAreaSeriesModule],
                        exports: [IgxStacked100SplineAreaSeriesModule],
                        entryComponents: [IgxStacked100SplineAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedAreaSeriesModule() {
        }
        IgxStackedAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesModule, declarations: [IgxStackedAreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedAreaSeriesComponent] });
        IgxStackedAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedAreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedAreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedAreaSeriesComponent", IgxStackedAreaSeriesComponent);
            i2.TypeRegistrar.register("StackedAreaSeries", StackedAreaSeries.$type);
        }
        IgxStackedAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedAreaSeriesModule], exports: [IgxStackedAreaSeriesModule] });
        IgxStackedAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedAreaSeriesModule], IgxStackedAreaSeriesModule] });
        return IgxStackedAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedAreaSeriesModule],
                        exports: [IgxStackedAreaSeriesModule],
                        entryComponents: [IgxStackedAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedBarSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedBarSeriesModule() {
        }
        IgxStackedBarSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedBarSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesModule, declarations: [IgxStackedBarSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedBarSeriesComponent] });
        IgxStackedBarSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedBarSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedBarSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedBarSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedBarSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedBarSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedBarSeriesComponent", IgxStackedBarSeriesComponent);
            i2.TypeRegistrar.register("StackedBarSeries", StackedBarSeries.$type);
        }
        IgxStackedBarSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedBarSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedBarSeriesModule], exports: [IgxStackedBarSeriesModule] });
        IgxStackedBarSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedBarSeriesModule], IgxStackedBarSeriesModule] });
        return IgxStackedBarSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedBarSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedBarSeriesModule],
                        exports: [IgxStackedBarSeriesModule],
                        entryComponents: [IgxStackedBarSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedColumnSeriesModule() {
        }
        IgxStackedColumnSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedColumnSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesModule, declarations: [IgxStackedColumnSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedColumnSeriesComponent] });
        IgxStackedColumnSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedColumnSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedColumnSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedColumnSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedColumnSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedColumnSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedColumnSeriesComponent", IgxStackedColumnSeriesComponent);
            i2.TypeRegistrar.register("StackedColumnSeries", StackedColumnSeries.$type);
        }
        IgxStackedColumnSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedColumnSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedColumnSeriesModule], exports: [IgxStackedColumnSeriesModule] });
        IgxStackedColumnSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedColumnSeriesModule], IgxStackedColumnSeriesModule] });
        return IgxStackedColumnSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedColumnSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedColumnSeriesModule],
                        exports: [IgxStackedColumnSeriesModule],
                        entryComponents: [IgxStackedColumnSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedLineSeriesModule() {
        }
        IgxStackedLineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedLineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesModule, declarations: [IgxStackedLineSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedLineSeriesComponent] });
        IgxStackedLineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedLineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedLineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedLineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedLineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedLineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedLineSeriesComponent", IgxStackedLineSeriesComponent);
            i2.TypeRegistrar.register("StackedLineSeries", StackedLineSeries.$type);
        }
        IgxStackedLineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedLineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedLineSeriesModule], exports: [IgxStackedLineSeriesModule] });
        IgxStackedLineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedLineSeriesModule], IgxStackedLineSeriesModule] });
        return IgxStackedLineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedLineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedLineSeriesModule],
                        exports: [IgxStackedLineSeriesModule],
                        entryComponents: [IgxStackedLineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedSplineSeriesModule() {
        }
        IgxStackedSplineSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedSplineSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesModule, declarations: [IgxStackedSplineSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedSplineSeriesComponent] });
        IgxStackedSplineSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedSplineSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedSplineSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedSplineSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedSplineSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedSplineSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedSplineSeriesComponent", IgxStackedSplineSeriesComponent);
            i2.TypeRegistrar.register("StackedSplineSeries", StackedSplineSeries.$type);
        }
        IgxStackedSplineSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedSplineSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedSplineSeriesModule], exports: [IgxStackedSplineSeriesModule] });
        IgxStackedSplineSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedSplineSeriesModule], IgxStackedSplineSeriesModule] });
        return IgxStackedSplineSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedSplineSeriesModule],
                        exports: [IgxStackedSplineSeriesModule],
                        entryComponents: [IgxStackedSplineSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedSplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedSplineAreaSeriesModule() {
        }
        IgxStackedSplineAreaSeriesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedSplineAreaSeriesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesModule, declarations: [IgxStackedSplineAreaSeriesComponent], imports: [i1.CommonModule], exports: [IgxStackedSplineAreaSeriesComponent] });
        IgxStackedSplineAreaSeriesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesModule, imports: [[i1.CommonModule]] });
        return IgxStackedSplineAreaSeriesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxStackedSplineAreaSeriesComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxStackedSplineAreaSeriesComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxStackedSplineAreaSeriesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxStackedSplineAreaSeriesDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxStackedSplineAreaSeriesComponent", IgxStackedSplineAreaSeriesComponent);
            i2.TypeRegistrar.register("StackedSplineAreaSeries", StackedSplineAreaSeries.$type);
        }
        IgxStackedSplineAreaSeriesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxStackedSplineAreaSeriesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesDynamicModule, imports: [i1.CommonModule, IgxStackedSplineAreaSeriesModule], exports: [IgxStackedSplineAreaSeriesModule] });
        IgxStackedSplineAreaSeriesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesDynamicModule, imports: [[i1.CommonModule, IgxStackedSplineAreaSeriesModule], IgxStackedSplineAreaSeriesModule] });
        return IgxStackedSplineAreaSeriesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxStackedSplineAreaSeriesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxStackedSplineAreaSeriesModule],
                        exports: [IgxStackedSplineAreaSeriesModule],
                        entryComponents: [IgxStackedSplineAreaSeriesComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Represents one part of a stacked series.
    */
    var IgxFragmentBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxFragmentBaseComponent, _super);
        function IgxFragmentBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxFragmentBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxFragmentBaseComponent.prototype, "isFragment", {
            /**
             * Gets whether the current series is a stack fragment.
            */
            get: function () {
                return this.i.dn;
            },
            enumerable: false,
            configurable: true
        });
        IgxFragmentBaseComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxFragmentBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFragmentBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxFragmentBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxFragmentBaseComponent, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxFragmentBaseComponent;
    }(IgxHorizontalAnchoredCategorySeriesComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxFragmentBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents one part of a StackedAreaSeries.
    */
    var IgxAreaFragmentComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxAreaFragmentComponent, _super);
        function IgxAreaFragmentComponent() {
            return _super.call(this) || this;
        }
        IgxAreaFragmentComponent.prototype.createImplementation = function () {
            return new AreaFragment();
        };
        Object.defineProperty(IgxAreaFragmentComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAreaFragmentComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxAreaFragmentComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        IgxAreaFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxAreaFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxAreaFragmentComponent, selector: "igx-area-fragment", providers: [{ provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxAreaFragmentComponent;
    }(IgxFragmentBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-area-fragment',
                        template: "",
                        providers: [{ provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxAreaFragmentComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAreaFragmentModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAreaFragmentModule() {
        }
        IgxAreaFragmentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAreaFragmentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentModule, declarations: [IgxAreaFragmentComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxAreaFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxAreaFragmentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxAreaFragmentModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxAreaFragmentComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxAreaFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxAreaFragmentDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxAreaFragmentDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxAreaFragmentComponent", IgxAreaFragmentComponent);
            i2.TypeRegistrar.register("AreaFragment", AreaFragment.$type);
        }
        IgxAreaFragmentDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxAreaFragmentDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentDynamicModule, imports: [i1.CommonModule, IgxAreaFragmentModule], exports: [IgxAreaFragmentModule] });
        IgxAreaFragmentDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentDynamicModule, imports: [[i1.CommonModule, IgxAreaFragmentModule], IgxAreaFragmentModule] });
        return IgxAreaFragmentDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxAreaFragmentDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxAreaFragmentModule],
                        exports: [IgxAreaFragmentModule],
                        entryComponents: [IgxAreaFragmentComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Represents one part of a StackedColumnSeries.
    */
    var IgxColumnFragmentComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxColumnFragmentComponent, _super);
        function IgxColumnFragmentComponent() {
            return _super.call(this) || this;
        }
        IgxColumnFragmentComponent.prototype.createImplementation = function () {
            return new ColumnFragment();
        };
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "radiusX", {
            /**
             * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.ut;
            },
            set: function (v) {
                this.i.ut = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "radiusY", {
            /**
             * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
            */
            get: function () {
                return this.i.uu;
            },
            set: function (v) {
                this.i.uu = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "fragmentXAxis", {
            /**
             * Gets or sets the effective x-axis for this series.
            */
            get: function () {
                if (this.i.fragmentXAxis == null) {
                    return null;
                }
                if (!this.i.fragmentXAxis.externalObject) {
                    var e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.fragmentXAxis);
                    if (e) {
                        e._implementation = this.i.fragmentXAxis;
                    }
                    this.i.fragmentXAxis.externalObject = e;
                }
                return this.i.fragmentXAxis.externalObject;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxColumnFragmentComponent.prototype, "fragmentYAxis", {
            /**
             * Gets or sets the effective y-axis for this series.
            */
            get: function () {
                if (this.i.fragmentYAxis == null) {
                    return null;
                }
                if (!this.i.fragmentYAxis.externalObject) {
                    var e = IgxNumericAxisBaseComponent._createFromInternal(this.i.fragmentYAxis);
                    if (e) {
                        e._implementation = this.i.fragmentYAxis;
                    }
                    this.i.fragmentYAxis.externalObject = e;
                }
                return this.i.fragmentYAxis.externalObject;
            },
            enumerable: false,
            configurable: true
        });
        IgxColumnFragmentComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.fragmentXAxis && this.fragmentXAxis._styling) {
                this.fragmentXAxis._styling(container, component, this);
            }
            if (this.fragmentYAxis && this.fragmentYAxis._styling) {
                this.fragmentYAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
        IgxColumnFragmentComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxColumnFragmentComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        /**
         * Gets the index of the item that resides at the provided world coordinates.
        
        * @param world  * The world coordinates of the requested item.
        */
        IgxColumnFragmentComponent.prototype.getItemIndex = function (world) {
            var iv = this.i.g0(i2.toPoint(world));
            return (iv);
        };
        IgxColumnFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxColumnFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxColumnFragmentComponent, selector: "igx-column-fragment", inputs: { radiusX: "radiusX", radiusY: "radiusY" }, providers: [{ provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxColumnFragmentComponent;
    }(IgxFragmentBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-column-fragment',
                        template: "",
                        providers: [{ provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxColumnFragmentComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { radiusX: [{
                    type: i0.Input
                }], radiusY: [{
                    type: i0.Input
                }] } });

    /**
     * Represents one part of a StackedBarSeries.
    */
    var IgxBarFragmentComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxBarFragmentComponent, _super);
        function IgxBarFragmentComponent() {
            return _super.call(this) || this;
        }
        IgxBarFragmentComponent.prototype.createImplementation = function () {
            return new BarFragment();
        };
        Object.defineProperty(IgxBarFragmentComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarFragmentComponent.prototype, "isBar", {
            /**
             * Gets whether the current series shows a bar shape.
            */
            get: function () {
                return this.i.c9;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarFragmentComponent.prototype, "isMarkerlessDisplayPreferred", {
            /**
             * Overridden by derived series classes to indicate when marker-less display is preferred or not.
            */
            get: function () {
                return this.i.dw;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarFragmentComponent.prototype, "isColumn", {
            /**
             * Gets whether the current series shows a column shape.
            */
            get: function () {
                return this.i.db;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarFragmentComponent.prototype, "barFragmentXAxis", {
            /**
             * The X-Axis for this BarFragment.
            */
            get: function () {
                if (this.i.barFragmentXAxis == null) {
                    return null;
                }
                if (!this.i.barFragmentXAxis.externalObject) {
                    var e = IgxNumericXAxisComponent._createFromInternal(this.i.barFragmentXAxis);
                    if (e) {
                        e._implementation = this.i.barFragmentXAxis;
                    }
                    this.i.barFragmentXAxis.externalObject = e;
                }
                return this.i.barFragmentXAxis.externalObject;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarFragmentComponent.prototype, "barFragmentYAxis", {
            /**
             * The Y-Axis for this BarFragment.
            */
            get: function () {
                if (this.i.barFragmentYAxis == null) {
                    return null;
                }
                if (!this.i.barFragmentYAxis.externalObject) {
                    var e = IgxCategoryYAxisComponent._createFromInternal(this.i.barFragmentYAxis);
                    if (e) {
                        e._implementation = this.i.barFragmentYAxis;
                    }
                    this.i.barFragmentYAxis.externalObject = e;
                }
                return this.i.barFragmentYAxis.externalObject;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxBarFragmentComponent.prototype, "isVertical", {
            get: function () {
                return this.i.isVertical;
            },
            enumerable: false,
            configurable: true
        });
        IgxBarFragmentComponent.prototype._styling = function (container, component, parent) {
            _super.prototype._styling.call(this, container, component, parent);
            this._inStyling = true;
            if (this.barFragmentXAxis && this.barFragmentXAxis._styling) {
                this.barFragmentXAxis._styling(container, component, this);
            }
            if (this.barFragmentYAxis && this.barFragmentYAxis._styling) {
                this.barFragmentYAxis._styling(container, component, this);
            }
            this._inStyling = false;
        };
        /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
        IgxBarFragmentComponent.prototype.getExactItemIndex = function (world) {
            var iv = this.i.fw(i2.toPoint(world));
            return (iv);
        };
        /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
        IgxBarFragmentComponent.prototype.getSeriesValueBoundingBox = function (world) {
            var iv = this.i.pb(i2.toPoint(world));
            return i2.fromRect(iv);
        };
        /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
        IgxBarFragmentComponent.prototype.getItem = function (world) {
            var iv = this.i.hh(i2.toPoint(world));
            return (iv);
        };
        IgxBarFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxBarFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxBarFragmentComponent, selector: "igx-bar-fragment", providers: [{ provide: IgxColumnFragmentComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxBarFragmentComponent;
    }(IgxColumnFragmentComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-bar-fragment',
                        template: "",
                        providers: [{ provide: IgxColumnFragmentComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxBarFragmentComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBarFragmentModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBarFragmentModule() {
        }
        IgxBarFragmentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBarFragmentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentModule, declarations: [IgxBarFragmentComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxBarFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxBarFragmentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxBarFragmentModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxBarFragmentComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxBarFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBarFragmentDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBarFragmentDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxBarFragmentComponent", IgxBarFragmentComponent);
            i2.TypeRegistrar.register("BarFragment", BarFragment.$type);
        }
        IgxBarFragmentDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBarFragmentDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentDynamicModule, imports: [i1.CommonModule, IgxBarFragmentModule], exports: [IgxBarFragmentModule] });
        IgxBarFragmentDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentDynamicModule, imports: [[i1.CommonModule, IgxBarFragmentModule], IgxBarFragmentModule] });
        return IgxBarFragmentDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBarFragmentDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxBarFragmentModule],
                        exports: [IgxBarFragmentModule],
                        entryComponents: [IgxBarFragmentComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxColumnFragmentModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxColumnFragmentModule() {
        }
        IgxColumnFragmentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxColumnFragmentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentModule, declarations: [IgxColumnFragmentComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxColumnFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxColumnFragmentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxColumnFragmentModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxColumnFragmentComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxColumnFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxColumnFragmentDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxColumnFragmentDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxColumnFragmentComponent", IgxColumnFragmentComponent);
            i2.TypeRegistrar.register("ColumnFragment", ColumnFragment.$type);
        }
        IgxColumnFragmentDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxColumnFragmentDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentDynamicModule, imports: [i1.CommonModule, IgxColumnFragmentModule], exports: [IgxColumnFragmentModule] });
        IgxColumnFragmentDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentDynamicModule, imports: [[i1.CommonModule, IgxColumnFragmentModule], IgxColumnFragmentModule] });
        return IgxColumnFragmentDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxColumnFragmentDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxColumnFragmentModule],
                        exports: [IgxColumnFragmentModule],
                        entryComponents: [IgxColumnFragmentComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents one part of a StackedLineSeries.
    */
    var IgxLineFragmentComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxLineFragmentComponent, _super);
        function IgxLineFragmentComponent() {
            return _super.call(this) || this;
        }
        IgxLineFragmentComponent.prototype.createImplementation = function () {
            return new LineFragment();
        };
        Object.defineProperty(IgxLineFragmentComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLineFragmentComponent.prototype, "isLineOnly", {
            /**
             * Gets whether the current series shows only line shapes.
            */
            get: function () {
                return this.i.dv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLineFragmentComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        IgxLineFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxLineFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxLineFragmentComponent, selector: "igx-line-fragment", providers: [{ provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxLineFragmentComponent;
    }(IgxFragmentBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-line-fragment',
                        template: "",
                        providers: [{ provide: IgxFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxLineFragmentComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLineFragmentModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLineFragmentModule() {
        }
        IgxLineFragmentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLineFragmentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentModule, declarations: [IgxLineFragmentComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxLineFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxLineFragmentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxLineFragmentModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxLineFragmentComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxLineFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLineFragmentDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLineFragmentDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxLineFragmentComponent", IgxLineFragmentComponent);
            i2.TypeRegistrar.register("LineFragment", LineFragment.$type);
        }
        IgxLineFragmentDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLineFragmentDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentDynamicModule, imports: [i1.CommonModule, IgxLineFragmentModule], exports: [IgxLineFragmentModule] });
        IgxLineFragmentDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentDynamicModule, imports: [[i1.CommonModule, IgxLineFragmentModule], IgxLineFragmentModule] });
        return IgxLineFragmentDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLineFragmentDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxLineFragmentModule],
                        exports: [IgxLineFragmentModule],
                        entryComponents: [IgxLineFragmentComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Represents one part in a StackedSplineSeries or StackedSplineAreaSeries.
    */
    var IgxSplineFragmentBaseComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSplineFragmentBaseComponent, _super);
        function IgxSplineFragmentBaseComponent() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxSplineFragmentBaseComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineFragmentBaseComponent.prototype, "isFragment", {
            /**
             * Gets whether the current series is a stack fragment.
            */
            get: function () {
                return this.i.dn;
            },
            enumerable: false,
            configurable: true
        });
        IgxSplineFragmentBaseComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
            var iv = this.i.o2(i2.toPoint(world), useInterpolation, skipUnknowns);
            return i2.fromPoint(iv);
        };
        IgxSplineFragmentBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSplineFragmentBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSplineFragmentBaseComponent, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "", isInline: true });
        return IgxSplineFragmentBaseComponent;
    }(IgxSplineSeriesBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents one part of a StackedSplineSeries.
    */
    var IgxSplineFragmentComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSplineFragmentComponent, _super);
        function IgxSplineFragmentComponent() {
            return _super.call(this) || this;
        }
        IgxSplineFragmentComponent.prototype.createImplementation = function () {
            return new SplineFragment();
        };
        Object.defineProperty(IgxSplineFragmentComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineFragmentComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineFragmentComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        IgxSplineFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSplineFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSplineFragmentComponent, selector: "igx-spline-fragment", providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSplineFragmentComponent;
    }(IgxSplineFragmentBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-spline-fragment',
                        template: "",
                        providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineFragmentComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineFragmentModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineFragmentModule() {
        }
        IgxSplineFragmentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineFragmentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentModule, declarations: [IgxSplineFragmentComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxSplineFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxSplineFragmentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxSplineFragmentModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSplineFragmentComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxSplineFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineFragmentDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineFragmentDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxSplineFragmentComponent", IgxSplineFragmentComponent);
            i2.TypeRegistrar.register("SplineFragment", SplineFragment.$type);
        }
        IgxSplineFragmentDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineFragmentDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentDynamicModule, imports: [i1.CommonModule, IgxSplineFragmentModule], exports: [IgxSplineFragmentModule] });
        IgxSplineFragmentDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentDynamicModule, imports: [[i1.CommonModule, IgxSplineFragmentModule], IgxSplineFragmentModule] });
        return IgxSplineFragmentDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineFragmentDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxSplineFragmentModule],
                        exports: [IgxSplineFragmentModule],
                        entryComponents: [IgxSplineFragmentComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents one part of a StackedSplineAreaSeries.
    */
    var IgxSplineAreaFragmentComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSplineAreaFragmentComponent, _super);
        function IgxSplineAreaFragmentComponent() {
            return _super.call(this) || this;
        }
        IgxSplineAreaFragmentComponent.prototype.createImplementation = function () {
            return new SplineAreaFragment();
        };
        Object.defineProperty(IgxSplineAreaFragmentComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineAreaFragmentComponent.prototype, "isAreaOrLine", {
            /**
             * Gets whether the current series shows an area or line shape.
            */
            get: function () {
                return this.i.c8;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineAreaFragmentComponent.prototype, "isArea", {
            /**
             * Gets whether the current series shows an area shape.
            */
            get: function () {
                return this.i.c7;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSplineAreaFragmentComponent.prototype, "isSpline", {
            /**
             * Gets whether the current series shows a spline shape.
            */
            get: function () {
                return this.i.ea;
            },
            enumerable: false,
            configurable: true
        });
        IgxSplineAreaFragmentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxSplineAreaFragmentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSplineAreaFragmentComponent, selector: "igx-spline-area-fragment", providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSplineAreaFragmentComponent;
    }(IgxSplineFragmentBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-spline-area-fragment',
                        template: "",
                        providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxSplineSeriesBaseComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }, { provide: IgxSeriesComponent, useExisting: i0.forwardRef(function () { return IgxSplineAreaFragmentComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineAreaFragmentModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineAreaFragmentModule() {
        }
        IgxSplineAreaFragmentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineAreaFragmentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentModule, declarations: [IgxSplineAreaFragmentComponent], imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], exports: [IgxSplineAreaFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule] });
        IgxSplineAreaFragmentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentModule, imports: [[i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule], IgxHorizontalAnchoredCategorySeriesProxyModule] });
        return IgxSplineAreaFragmentModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSplineAreaFragmentComponent],
                        imports: [i1.CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        exports: [IgxSplineAreaFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSplineAreaFragmentDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSplineAreaFragmentDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxSplineAreaFragmentComponent", IgxSplineAreaFragmentComponent);
            i2.TypeRegistrar.register("SplineAreaFragment", SplineAreaFragment.$type);
        }
        IgxSplineAreaFragmentDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSplineAreaFragmentDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentDynamicModule, imports: [i1.CommonModule, IgxSplineAreaFragmentModule], exports: [IgxSplineAreaFragmentModule] });
        IgxSplineAreaFragmentDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentDynamicModule, imports: [[i1.CommonModule, IgxSplineAreaFragmentModule], IgxSplineAreaFragmentModule] });
        return IgxSplineAreaFragmentDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSplineAreaFragmentDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxSplineAreaFragmentModule],
                        exports: [IgxSplineAreaFragmentModule],
                        entryComponents: [IgxSplineAreaFragmentComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartStackedModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartStackedModule() {
        }
        IgxDataChartStackedModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartStackedModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedModule, imports: [i1.CommonModule, IgxStackedFragmentSeriesModule,
                IgxStacked100AreaSeriesModule,
                IgxStacked100BarSeriesModule,
                IgxStacked100ColumnSeriesModule,
                IgxStacked100LineSeriesModule,
                IgxStacked100SplineSeriesModule,
                IgxStacked100SplineAreaSeriesModule,
                IgxStackedAreaSeriesModule,
                IgxStackedBarSeriesModule,
                IgxStackedColumnSeriesModule,
                IgxStackedLineSeriesModule,
                IgxStackedSplineSeriesModule,
                IgxStackedSplineAreaSeriesModule,
                IgxAreaFragmentDynamicModule,
                IgxBarFragmentDynamicModule,
                IgxColumnFragmentDynamicModule,
                IgxLineFragmentDynamicModule,
                IgxSplineFragmentDynamicModule,
                IgxSplineAreaFragmentDynamicModule,
                IgxDataChartCategoryCoreModule,
                IgxDataChartVerticalCategoryCoreModule], exports: [IgxStackedFragmentSeriesModule,
                IgxStacked100AreaSeriesModule,
                IgxStacked100BarSeriesModule,
                IgxStacked100ColumnSeriesModule,
                IgxStacked100LineSeriesModule,
                IgxStacked100SplineSeriesModule,
                IgxStacked100SplineAreaSeriesModule,
                IgxStackedAreaSeriesModule,
                IgxStackedBarSeriesModule,
                IgxStackedColumnSeriesModule,
                IgxStackedLineSeriesModule,
                IgxStackedSplineSeriesModule,
                IgxStackedSplineAreaSeriesModule,
                IgxAreaFragmentDynamicModule,
                IgxBarFragmentDynamicModule,
                IgxColumnFragmentDynamicModule,
                IgxLineFragmentDynamicModule,
                IgxSplineFragmentDynamicModule,
                IgxSplineAreaFragmentDynamicModule,
                IgxDataChartCategoryCoreModule,
                IgxDataChartVerticalCategoryCoreModule] });
        IgxDataChartStackedModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedModule, imports: [[i1.CommonModule, IgxStackedFragmentSeriesModule,
                    IgxStacked100AreaSeriesModule,
                    IgxStacked100BarSeriesModule,
                    IgxStacked100ColumnSeriesModule,
                    IgxStacked100LineSeriesModule,
                    IgxStacked100SplineSeriesModule,
                    IgxStacked100SplineAreaSeriesModule,
                    IgxStackedAreaSeriesModule,
                    IgxStackedBarSeriesModule,
                    IgxStackedColumnSeriesModule,
                    IgxStackedLineSeriesModule,
                    IgxStackedSplineSeriesModule,
                    IgxStackedSplineAreaSeriesModule,
                    IgxAreaFragmentDynamicModule,
                    IgxBarFragmentDynamicModule,
                    IgxColumnFragmentDynamicModule,
                    IgxLineFragmentDynamicModule,
                    IgxSplineFragmentDynamicModule,
                    IgxSplineAreaFragmentDynamicModule,
                    IgxDataChartCategoryCoreModule,
                    IgxDataChartVerticalCategoryCoreModule
                ], IgxStackedFragmentSeriesModule,
                IgxStacked100AreaSeriesModule,
                IgxStacked100BarSeriesModule,
                IgxStacked100ColumnSeriesModule,
                IgxStacked100LineSeriesModule,
                IgxStacked100SplineSeriesModule,
                IgxStacked100SplineAreaSeriesModule,
                IgxStackedAreaSeriesModule,
                IgxStackedBarSeriesModule,
                IgxStackedColumnSeriesModule,
                IgxStackedLineSeriesModule,
                IgxStackedSplineSeriesModule,
                IgxStackedSplineAreaSeriesModule,
                IgxAreaFragmentDynamicModule,
                IgxBarFragmentDynamicModule,
                IgxColumnFragmentDynamicModule,
                IgxLineFragmentDynamicModule,
                IgxSplineFragmentDynamicModule,
                IgxSplineAreaFragmentDynamicModule,
                IgxDataChartCategoryCoreModule,
                IgxDataChartVerticalCategoryCoreModule] });
        return IgxDataChartStackedModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxStackedFragmentSeriesModule,
                            IgxStacked100AreaSeriesModule,
                            IgxStacked100BarSeriesModule,
                            IgxStacked100ColumnSeriesModule,
                            IgxStacked100LineSeriesModule,
                            IgxStacked100SplineSeriesModule,
                            IgxStacked100SplineAreaSeriesModule,
                            IgxStackedAreaSeriesModule,
                            IgxStackedBarSeriesModule,
                            IgxStackedColumnSeriesModule,
                            IgxStackedLineSeriesModule,
                            IgxStackedSplineSeriesModule,
                            IgxStackedSplineAreaSeriesModule,
                            IgxAreaFragmentDynamicModule,
                            IgxBarFragmentDynamicModule,
                            IgxColumnFragmentDynamicModule,
                            IgxLineFragmentDynamicModule,
                            IgxSplineFragmentDynamicModule,
                            IgxSplineAreaFragmentDynamicModule,
                            IgxDataChartCategoryCoreModule,
                            IgxDataChartVerticalCategoryCoreModule
                        ],
                        imports: [i1.CommonModule, IgxStackedFragmentSeriesModule,
                            IgxStacked100AreaSeriesModule,
                            IgxStacked100BarSeriesModule,
                            IgxStacked100ColumnSeriesModule,
                            IgxStacked100LineSeriesModule,
                            IgxStacked100SplineSeriesModule,
                            IgxStacked100SplineAreaSeriesModule,
                            IgxStackedAreaSeriesModule,
                            IgxStackedBarSeriesModule,
                            IgxStackedColumnSeriesModule,
                            IgxStackedLineSeriesModule,
                            IgxStackedSplineSeriesModule,
                            IgxStackedSplineAreaSeriesModule,
                            IgxAreaFragmentDynamicModule,
                            IgxBarFragmentDynamicModule,
                            IgxColumnFragmentDynamicModule,
                            IgxLineFragmentDynamicModule,
                            IgxSplineFragmentDynamicModule,
                            IgxSplineAreaFragmentDynamicModule,
                            IgxDataChartCategoryCoreModule,
                            IgxDataChartVerticalCategoryCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartStackedDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartStackedDynamicModule() {
        }
        IgxDataChartStackedDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartStackedDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedDynamicModule, imports: [i1.CommonModule, IgxStackedFragmentSeriesDynamicModule,
                IgxStacked100AreaSeriesDynamicModule,
                IgxStacked100BarSeriesDynamicModule,
                IgxStacked100ColumnSeriesDynamicModule,
                IgxStacked100LineSeriesDynamicModule,
                IgxStacked100SplineSeriesDynamicModule,
                IgxStacked100SplineAreaSeriesDynamicModule,
                IgxStackedAreaSeriesDynamicModule,
                IgxStackedBarSeriesDynamicModule,
                IgxStackedColumnSeriesDynamicModule,
                IgxStackedLineSeriesDynamicModule,
                IgxStackedSplineSeriesDynamicModule,
                IgxStackedSplineAreaSeriesDynamicModule,
                IgxAreaFragmentDynamicModule,
                IgxBarFragmentDynamicModule,
                IgxColumnFragmentDynamicModule,
                IgxLineFragmentDynamicModule,
                IgxSplineFragmentDynamicModule,
                IgxSplineAreaFragmentDynamicModule,
                IgxDataChartCategoryCoreDynamicModule,
                IgxDataChartVerticalCategoryCoreDynamicModule,
                IgxDataChartStackedModule], exports: [IgxStackedFragmentSeriesDynamicModule,
                IgxStacked100AreaSeriesDynamicModule,
                IgxStacked100BarSeriesDynamicModule,
                IgxStacked100ColumnSeriesDynamicModule,
                IgxStacked100LineSeriesDynamicModule,
                IgxStacked100SplineSeriesDynamicModule,
                IgxStacked100SplineAreaSeriesDynamicModule,
                IgxStackedAreaSeriesDynamicModule,
                IgxStackedBarSeriesDynamicModule,
                IgxStackedColumnSeriesDynamicModule,
                IgxStackedLineSeriesDynamicModule,
                IgxStackedSplineSeriesDynamicModule,
                IgxStackedSplineAreaSeriesDynamicModule,
                IgxAreaFragmentDynamicModule,
                IgxBarFragmentDynamicModule,
                IgxColumnFragmentDynamicModule,
                IgxLineFragmentDynamicModule,
                IgxSplineFragmentDynamicModule,
                IgxSplineAreaFragmentDynamicModule,
                IgxDataChartCategoryCoreDynamicModule,
                IgxDataChartVerticalCategoryCoreDynamicModule,
                IgxDataChartStackedModule] });
        IgxDataChartStackedDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedDynamicModule, imports: [[i1.CommonModule, IgxStackedFragmentSeriesDynamicModule,
                    IgxStacked100AreaSeriesDynamicModule,
                    IgxStacked100BarSeriesDynamicModule,
                    IgxStacked100ColumnSeriesDynamicModule,
                    IgxStacked100LineSeriesDynamicModule,
                    IgxStacked100SplineSeriesDynamicModule,
                    IgxStacked100SplineAreaSeriesDynamicModule,
                    IgxStackedAreaSeriesDynamicModule,
                    IgxStackedBarSeriesDynamicModule,
                    IgxStackedColumnSeriesDynamicModule,
                    IgxStackedLineSeriesDynamicModule,
                    IgxStackedSplineSeriesDynamicModule,
                    IgxStackedSplineAreaSeriesDynamicModule,
                    IgxAreaFragmentDynamicModule,
                    IgxBarFragmentDynamicModule,
                    IgxColumnFragmentDynamicModule,
                    IgxLineFragmentDynamicModule,
                    IgxSplineFragmentDynamicModule,
                    IgxSplineAreaFragmentDynamicModule,
                    IgxDataChartCategoryCoreDynamicModule,
                    IgxDataChartVerticalCategoryCoreDynamicModule,
                    IgxDataChartStackedModule
                ], IgxStackedFragmentSeriesDynamicModule,
                IgxStacked100AreaSeriesDynamicModule,
                IgxStacked100BarSeriesDynamicModule,
                IgxStacked100ColumnSeriesDynamicModule,
                IgxStacked100LineSeriesDynamicModule,
                IgxStacked100SplineSeriesDynamicModule,
                IgxStacked100SplineAreaSeriesDynamicModule,
                IgxStackedAreaSeriesDynamicModule,
                IgxStackedBarSeriesDynamicModule,
                IgxStackedColumnSeriesDynamicModule,
                IgxStackedLineSeriesDynamicModule,
                IgxStackedSplineSeriesDynamicModule,
                IgxStackedSplineAreaSeriesDynamicModule,
                IgxAreaFragmentDynamicModule,
                IgxBarFragmentDynamicModule,
                IgxColumnFragmentDynamicModule,
                IgxLineFragmentDynamicModule,
                IgxSplineFragmentDynamicModule,
                IgxSplineAreaFragmentDynamicModule,
                IgxDataChartCategoryCoreDynamicModule,
                IgxDataChartVerticalCategoryCoreDynamicModule,
                IgxDataChartStackedModule] });
        return IgxDataChartStackedDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartStackedDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxStackedFragmentSeriesDynamicModule,
                            IgxStacked100AreaSeriesDynamicModule,
                            IgxStacked100BarSeriesDynamicModule,
                            IgxStacked100ColumnSeriesDynamicModule,
                            IgxStacked100LineSeriesDynamicModule,
                            IgxStacked100SplineSeriesDynamicModule,
                            IgxStacked100SplineAreaSeriesDynamicModule,
                            IgxStackedAreaSeriesDynamicModule,
                            IgxStackedBarSeriesDynamicModule,
                            IgxStackedColumnSeriesDynamicModule,
                            IgxStackedLineSeriesDynamicModule,
                            IgxStackedSplineSeriesDynamicModule,
                            IgxStackedSplineAreaSeriesDynamicModule,
                            IgxAreaFragmentDynamicModule,
                            IgxBarFragmentDynamicModule,
                            IgxColumnFragmentDynamicModule,
                            IgxLineFragmentDynamicModule,
                            IgxSplineFragmentDynamicModule,
                            IgxSplineAreaFragmentDynamicModule,
                            IgxDataChartCategoryCoreDynamicModule,
                            IgxDataChartVerticalCategoryCoreDynamicModule,
                            IgxDataChartStackedModule
                        ],
                        imports: [i1.CommonModule, IgxStackedFragmentSeriesDynamicModule,
                            IgxStacked100AreaSeriesDynamicModule,
                            IgxStacked100BarSeriesDynamicModule,
                            IgxStacked100ColumnSeriesDynamicModule,
                            IgxStacked100LineSeriesDynamicModule,
                            IgxStacked100SplineSeriesDynamicModule,
                            IgxStacked100SplineAreaSeriesDynamicModule,
                            IgxStackedAreaSeriesDynamicModule,
                            IgxStackedBarSeriesDynamicModule,
                            IgxStackedColumnSeriesDynamicModule,
                            IgxStackedLineSeriesDynamicModule,
                            IgxStackedSplineSeriesDynamicModule,
                            IgxStackedSplineAreaSeriesDynamicModule,
                            IgxAreaFragmentDynamicModule,
                            IgxBarFragmentDynamicModule,
                            IgxColumnFragmentDynamicModule,
                            IgxLineFragmentDynamicModule,
                            IgxSplineFragmentDynamicModule,
                            IgxSplineAreaFragmentDynamicModule,
                            IgxDataChartCategoryCoreDynamicModule,
                            IgxDataChartVerticalCategoryCoreDynamicModule,
                            IgxDataChartStackedModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialCoreModule() {
        }
        IgxDataChartFinancialCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreModule, imports: [i1.CommonModule, IgxCategoryXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule], exports: [IgxCategoryXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartFinancialCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreModule, imports: [[i1.CommonModule, IgxCategoryXAxisModule,
                    IgxNumericYAxisModule,
                    IgxDataChartCoreModule
                ], IgxCategoryXAxisModule,
                IgxNumericYAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartFinancialCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryXAxisModule,
                            IgxNumericYAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialCoreDynamicModule() {
        }
        IgxDataChartFinancialCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreDynamicModule, imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartFinancialCoreModule], exports: [IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartFinancialCoreModule] });
        IgxDataChartFinancialCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreDynamicModule, imports: [[i1.CommonModule, IgxCategoryXAxisDynamicModule,
                    IgxNumericYAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartFinancialCoreModule
                ], IgxCategoryXAxisDynamicModule,
                IgxNumericYAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartFinancialCoreModule] });
        return IgxDataChartFinancialCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryXAxisDynamicModule,
                            IgxNumericYAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialModule() {
        }
        IgxDataChartFinancialModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialModule, imports: [i1.CommonModule, IgxFinancialPriceSeriesModule,
                IgxDataChartFinancialCoreModule], exports: [IgxFinancialPriceSeriesModule,
                IgxDataChartFinancialCoreModule] });
        IgxDataChartFinancialModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialModule, imports: [[i1.CommonModule, IgxFinancialPriceSeriesModule,
                    IgxDataChartFinancialCoreModule
                ], IgxFinancialPriceSeriesModule,
                IgxDataChartFinancialCoreModule] });
        return IgxDataChartFinancialModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFinancialPriceSeriesModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        imports: [i1.CommonModule, IgxFinancialPriceSeriesModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialDynamicModule() {
        }
        IgxDataChartFinancialDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialDynamicModule, imports: [i1.CommonModule, IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialModule], exports: [IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialModule] });
        IgxDataChartFinancialDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialDynamicModule, imports: [[i1.CommonModule, IgxFinancialPriceSeriesDynamicModule,
                    IgxDataChartFinancialCoreDynamicModule,
                    IgxDataChartFinancialModule
                ], IgxFinancialPriceSeriesDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialModule] });
        return IgxDataChartFinancialDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxFinancialPriceSeriesDynamicModule,
                            IgxDataChartFinancialCoreDynamicModule,
                            IgxDataChartFinancialModule
                        ],
                        imports: [i1.CommonModule, IgxFinancialPriceSeriesDynamicModule,
                            IgxDataChartFinancialCoreDynamicModule,
                            IgxDataChartFinancialModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartExtendedAxesModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartExtendedAxesModule() {
        }
        IgxDataChartExtendedAxesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartExtendedAxesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesModule, imports: [i1.CommonModule, IgxCategoryDateTimeXAxisModule,
                IgxTimeAxisBreakModule,
                IgxTimeAxisIntervalModule,
                IgxTimeAxisLabelFormatModule,
                IgxTimeXAxisModule,
                IgxOrdinalTimeXAxisModule,
                IgxDataChartCoreModule], exports: [IgxCategoryDateTimeXAxisModule,
                IgxTimeAxisBreakModule,
                IgxTimeAxisIntervalModule,
                IgxTimeAxisLabelFormatModule,
                IgxTimeXAxisModule,
                IgxOrdinalTimeXAxisModule,
                IgxDataChartCoreModule] });
        IgxDataChartExtendedAxesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesModule, imports: [[i1.CommonModule, IgxCategoryDateTimeXAxisModule,
                    IgxTimeAxisBreakModule,
                    IgxTimeAxisIntervalModule,
                    IgxTimeAxisLabelFormatModule,
                    IgxTimeXAxisModule,
                    IgxOrdinalTimeXAxisModule,
                    IgxDataChartCoreModule
                ], IgxCategoryDateTimeXAxisModule,
                IgxTimeAxisBreakModule,
                IgxTimeAxisIntervalModule,
                IgxTimeAxisLabelFormatModule,
                IgxTimeXAxisModule,
                IgxOrdinalTimeXAxisModule,
                IgxDataChartCoreModule] });
        return IgxDataChartExtendedAxesModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryDateTimeXAxisModule,
                            IgxTimeAxisBreakModule,
                            IgxTimeAxisIntervalModule,
                            IgxTimeAxisLabelFormatModule,
                            IgxTimeXAxisModule,
                            IgxOrdinalTimeXAxisModule,
                            IgxDataChartCoreModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryDateTimeXAxisModule,
                            IgxTimeAxisBreakModule,
                            IgxTimeAxisIntervalModule,
                            IgxTimeAxisLabelFormatModule,
                            IgxTimeXAxisModule,
                            IgxOrdinalTimeXAxisModule,
                            IgxDataChartCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartExtendedAxesDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartExtendedAxesDynamicModule() {
        }
        IgxDataChartExtendedAxesDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartExtendedAxesDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesDynamicModule, imports: [i1.CommonModule, IgxCategoryDateTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartExtendedAxesModule], exports: [IgxCategoryDateTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartExtendedAxesModule] });
        IgxDataChartExtendedAxesDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesDynamicModule, imports: [[i1.CommonModule, IgxCategoryDateTimeXAxisDynamicModule,
                    IgxTimeAxisBreakDynamicModule,
                    IgxTimeAxisIntervalDynamicModule,
                    IgxTimeAxisLabelFormatDynamicModule,
                    IgxTimeXAxisDynamicModule,
                    IgxOrdinalTimeXAxisDynamicModule,
                    IgxDataChartCoreDynamicModule,
                    IgxDataChartExtendedAxesModule
                ], IgxCategoryDateTimeXAxisDynamicModule,
                IgxTimeAxisBreakDynamicModule,
                IgxTimeAxisIntervalDynamicModule,
                IgxTimeAxisLabelFormatDynamicModule,
                IgxTimeXAxisDynamicModule,
                IgxOrdinalTimeXAxisDynamicModule,
                IgxDataChartCoreDynamicModule,
                IgxDataChartExtendedAxesModule] });
        return IgxDataChartExtendedAxesDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartExtendedAxesDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxCategoryDateTimeXAxisDynamicModule,
                            IgxTimeAxisBreakDynamicModule,
                            IgxTimeAxisIntervalDynamicModule,
                            IgxTimeAxisLabelFormatDynamicModule,
                            IgxTimeXAxisDynamicModule,
                            IgxOrdinalTimeXAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartExtendedAxesModule
                        ],
                        imports: [i1.CommonModule, IgxCategoryDateTimeXAxisDynamicModule,
                            IgxTimeAxisBreakDynamicModule,
                            IgxTimeAxisIntervalDynamicModule,
                            IgxTimeAxisLabelFormatDynamicModule,
                            IgxTimeXAxisDynamicModule,
                            IgxOrdinalTimeXAxisDynamicModule,
                            IgxDataChartCoreDynamicModule,
                            IgxDataChartExtendedAxesModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialIndicatorsModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialIndicatorsModule() {
        }
        IgxDataChartFinancialIndicatorsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialIndicatorsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsModule, imports: [i1.CommonModule, IgxIndicatorsModule,
                IgxDataChartFinancialCoreModule], exports: [IgxIndicatorsModule,
                IgxDataChartFinancialCoreModule] });
        IgxDataChartFinancialIndicatorsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsModule, imports: [[i1.CommonModule, IgxIndicatorsModule,
                    IgxDataChartFinancialCoreModule
                ], IgxIndicatorsModule,
                IgxDataChartFinancialCoreModule] });
        return IgxDataChartFinancialIndicatorsModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxIndicatorsModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        imports: [i1.CommonModule, IgxIndicatorsModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialIndicatorsDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialIndicatorsDynamicModule() {
        }
        IgxDataChartFinancialIndicatorsDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialIndicatorsDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsDynamicModule, imports: [i1.CommonModule, IgxIndicatorsDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialIndicatorsModule], exports: [IgxIndicatorsDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialIndicatorsModule] });
        IgxDataChartFinancialIndicatorsDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsDynamicModule, imports: [[i1.CommonModule, IgxIndicatorsDynamicModule,
                    IgxDataChartFinancialCoreDynamicModule,
                    IgxDataChartFinancialIndicatorsModule
                ], IgxIndicatorsDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialIndicatorsModule] });
        return IgxDataChartFinancialIndicatorsDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialIndicatorsDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxIndicatorsDynamicModule,
                            IgxDataChartFinancialCoreDynamicModule,
                            IgxDataChartFinancialIndicatorsModule
                        ],
                        imports: [i1.CommonModule, IgxIndicatorsDynamicModule,
                            IgxDataChartFinancialCoreDynamicModule,
                            IgxDataChartFinancialIndicatorsModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialOverlaysModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialOverlaysModule() {
        }
        IgxDataChartFinancialOverlaysModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialOverlaysModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysModule, imports: [i1.CommonModule, IgxOverlaysModule,
                IgxDataChartFinancialCoreModule], exports: [IgxOverlaysModule,
                IgxDataChartFinancialCoreModule] });
        IgxDataChartFinancialOverlaysModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysModule, imports: [[i1.CommonModule, IgxOverlaysModule,
                    IgxDataChartFinancialCoreModule
                ], IgxOverlaysModule,
                IgxDataChartFinancialCoreModule] });
        return IgxDataChartFinancialOverlaysModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxOverlaysModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        imports: [i1.CommonModule, IgxOverlaysModule,
                            IgxDataChartFinancialCoreModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartFinancialOverlaysDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartFinancialOverlaysDynamicModule() {
        }
        IgxDataChartFinancialOverlaysDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartFinancialOverlaysDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysDynamicModule, imports: [i1.CommonModule, IgxOverlaysDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialOverlaysModule], exports: [IgxOverlaysDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialOverlaysModule] });
        IgxDataChartFinancialOverlaysDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysDynamicModule, imports: [[i1.CommonModule, IgxOverlaysDynamicModule,
                    IgxDataChartFinancialCoreDynamicModule,
                    IgxDataChartFinancialOverlaysModule
                ], IgxOverlaysDynamicModule,
                IgxDataChartFinancialCoreDynamicModule,
                IgxDataChartFinancialOverlaysModule] });
        return IgxDataChartFinancialOverlaysDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartFinancialOverlaysDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxOverlaysDynamicModule,
                            IgxDataChartFinancialCoreDynamicModule,
                            IgxDataChartFinancialOverlaysModule
                        ],
                        imports: [i1.CommonModule, IgxOverlaysDynamicModule,
                            IgxDataChartFinancialCoreDynamicModule,
                            IgxDataChartFinancialOverlaysModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisLabelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelVisualData, _super);
        function AxisLabelVisualData() {
            var _this = _super.call(this) || this;
            _this._labelValue = null;
            _this._labelPosition = 0;
            _this._position = null;
            _this._panelPosition = null;
            _this._appearance = null;
            _this._size = null;
            _this.position = new i2.PointData(NaN, NaN);
            _this.size = new i2.SizeData(NaN, NaN);
            _this.panelPosition = new i2.PointData(NaN, NaN);
            return _this;
        }
        Object.defineProperty(AxisLabelVisualData.prototype, "labelValue", {
            get: function () {
                return this._labelValue;
            },
            set: function (a) {
                this._labelValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelVisualData.prototype, "labelPosition", {
            get: function () {
                return this._labelPosition;
            },
            set: function (a) {
                this._labelPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelVisualData.prototype, "position", {
            get: function () {
                return this._position;
            },
            set: function (a) {
                this._position = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelVisualData.prototype, "panelPosition", {
            get: function () {
                return this._panelPosition;
            },
            set: function (a) {
                this._panelPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelVisualData.prototype, "appearance", {
            get: function () {
                return this._appearance;
            },
            set: function (a) {
                this._appearance = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisLabelVisualData.prototype, "size", {
            get: function () {
                return this._size;
            },
            set: function (a) {
                this._size = a;
            },
            enumerable: false,
            configurable: true
        });
        AxisLabelVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("position: " + "{ x: " + this.position.x + ", y: " + this.position.y + "},");
            a.u("size: " + "{ width: " + this.size.width + ", height: " + this.size.height + "},");
            a.u("labelPosition: " + this.labelPosition + ",");
            a.u("appearance: " + (this.appearance != null ? this.appearance.serialize() : "null"));
            a.u("}");
            return a.toString();
        };
        AxisLabelVisualData.prototype.h = function (a, b) {
            if (b) {
                this.labelPosition = (this.labelPosition - a.left) / a.width;
            }
            else {
                this.labelPosition = (this.labelPosition - a.top) / a.height;
            }
            var c = (this.position.x - a.left) / a.width;
            var d = (this.position.y - a.top) / a.height;
            this.position = new i2.PointData(c, d);
            var e = (this.size.width) / a.width;
            var f = (this.size.height) / a.height;
            this.size = new i2.SizeData(e, f);
        };
        AxisLabelVisualData.$t = i2.markType(AxisLabelVisualData, 'AxisLabelVisualData');
        return AxisLabelVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisLabelVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelVisualDataList, _super);
        function AxisLabelVisualDataList() {
            return _super.call(this, AxisLabelVisualData.$, 0) || this;
        }
        AxisLabelVisualDataList.$t = i2.markType(AxisLabelVisualDataList, 'AxisLabelVisualDataList', i2.List$1.$.specialize(AxisLabelVisualData.$));
        return AxisLabelVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChartTitleVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartTitleVisualData, _super);
        function ChartTitleVisualData() {
            var _this = _super.call(this) || this;
            _this._viewport = null;
            _this._textPlotArea = null;
            _this._appearance = null;
            _this.appearance = new i2.LabelAppearanceData();
            return _this;
        }
        Object.defineProperty(ChartTitleVisualData.prototype, "width", {
            get: function () {
                return this.viewport.width;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartTitleVisualData.prototype, "height", {
            get: function () {
                return this.viewport.height;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartTitleVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartTitleVisualData.prototype, "textPlotArea", {
            get: function () {
                return this._textPlotArea;
            },
            set: function (a) {
                this._textPlotArea = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartTitleVisualData.prototype, "appearance", {
            get: function () {
                return this._appearance;
            },
            set: function (a) {
                this._appearance = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartTitleVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("viewport: " + this.viewport.serialize() + ", ");
            a.u("textPlotArea: " + this.textPlotArea.serialize() + ", ");
            a.u("appearance: " + this.appearance.serialize());
            a.u("}");
            return a.toString();
        };
        ChartTitleVisualData.prototype.h = function (a) {
            var b = (this.textPlotArea.left - a.left) / a.width;
            var c = (this.textPlotArea.top - a.top) / a.height;
            var d = this.textPlotArea.width / a.width;
            var e = this.textPlotArea.height / a.height;
            this.textPlotArea = new i2.RectData(b, c, d, e);
        };
        ChartTitleVisualData.prototype.g = function () {
            var a = (this.textPlotArea.left - this.viewport.left) / this.viewport.width;
            var b = (this.textPlotArea.top - this.viewport.top) / this.viewport.height;
            var c = this.textPlotArea.width / this.viewport.width;
            var d = this.textPlotArea.height / this.viewport.height;
            this.textPlotArea = new i2.RectData(a, b, c, d);
        };
        ChartTitleVisualData.prototype.j = function (a) {
            var b = this.textPlotArea.left * a.width;
            var c = this.textPlotArea.top * a.height;
            var d = this.textPlotArea.width * a.width;
            var e = this.textPlotArea.height * a.height;
            this.textPlotArea = new i2.RectData(b, c, d, e);
        };
        ChartTitleVisualData.prototype.i = function () {
            var a = this.textPlotArea.left * this.viewport.width;
            var b = this.textPlotArea.top * this.viewport.height;
            var c = this.textPlotArea.width * this.viewport.width;
            var d = this.textPlotArea.height * this.viewport.height;
            this.textPlotArea = new i2.RectData(a, b, c, d);
        };
        ChartTitleVisualData.$t = i2.markType(ChartTitleVisualData, 'ChartTitleVisualData');
        return ChartTitleVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisVisualData, _super);
        function AxisVisualData() {
            var _this = _super.call(this) || this;
            _this._name = null;
            _this._type = null;
            _this._viewport = null;
            _this._tickMarksLength = 0;
            _this._tickMarks = null;
            _this._labels = null;
            _this._axisLine = null;
            _this._majorLines = null;
            _this._minorLines = null;
            _this._strips = null;
            _this._labelsPlotArea = null;
            _this._labelsViewport = null;
            _this._title = null;
            _this._annotationBackings = null;
            _this.tickMarksLength = 0;
            _this.labels = new AxisLabelVisualDataList();
            _this.title = new ChartTitleVisualData();
            return _this;
        }
        Object.defineProperty(AxisVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (a) {
                this._type = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "tickMarksLength", {
            get: function () {
                return this._tickMarksLength;
            },
            set: function (a) {
                this._tickMarksLength = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "tickMarks", {
            get: function () {
                return this._tickMarks;
            },
            set: function (a) {
                this._tickMarks = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "labels", {
            get: function () {
                return this._labels;
            },
            set: function (a) {
                this._labels = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "axisLine", {
            get: function () {
                return this._axisLine;
            },
            set: function (a) {
                this._axisLine = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "majorLines", {
            get: function () {
                return this._majorLines;
            },
            set: function (a) {
                this._majorLines = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "minorLines", {
            get: function () {
                return this._minorLines;
            },
            set: function (a) {
                this._minorLines = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "strips", {
            get: function () {
                return this._strips;
            },
            set: function (a) {
                this._strips = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "labelsPlotArea", {
            get: function () {
                return this._labelsPlotArea;
            },
            set: function (a) {
                this._labelsPlotArea = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "labelsViewport", {
            get: function () {
                return this._labelsViewport;
            },
            set: function (a) {
                this._labelsViewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "title", {
            get: function () {
                return this._title;
            },
            set: function (a) {
                this._title = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AxisVisualData.prototype, "annotationBackings", {
            get: function () {
                return this._annotationBackings;
            },
            set: function (a) {
                this._annotationBackings = a;
            },
            enumerable: false,
            configurable: true
        });
        AxisVisualData.prototype.p = function () {
            var e_1, _a, e_2, _b;
            var a = true;
            if (i2.Base.equalsStatic(this.type, "NumericYAxis") || i2.Base.equalsStatic(this.type, "CategoryYAxis") || i2.Base.equalsStatic(this.type, "PercentChangeYAxis")) {
                a = false;
            }
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.labels)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.h(this.labelsViewport, a);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.tickMarks.scaleByViewport(this.labelsViewport);
            this.axisLine.scaleByViewport(this.labelsViewport);
            if (this.title != null) {
                this.title.h(this.labelsViewport);
            }
            this.majorLines.scaleByViewport(this.viewport);
            this.minorLines.scaleByViewport(this.viewport);
            this.strips.scaleByViewport(this.viewport);
            if (this.annotationBackings != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEnum(this.annotationBackings)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var c = _f.value;
                        c.scaleByViewport(this.labelsViewport);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        };
        AxisVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.name != null) {
                a.u("name: \"" + this.name + "\",");
            }
            a.u("type: \"" + this.type + "\", ");
            a.u("tickMarksLength: \"" + this.tickMarksLength.toString() + "\", ");
            a.u("viewport: " + this.viewport.serialize() + ", ");
            a.u("labelsViewport: " + this.labelsViewport.serialize() + ", ");
            if (this.labelsPlotArea != null) {
                a.u("labelsPlotArea: " + this.labelsPlotArea.serialize() + ", ");
            }
            a.u("labels: [");
            for (var b = 0; b < this.labels.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.labels._inner[b].serialize());
            }
            a.u("],");
            if (this.title != null) {
                a.u("title: " + ((this.title != null) ? this.title.serialize() : "null") + ", ");
            }
            a.u("axisLine: " + ((this.axisLine != null) ? this.axisLine.serialize() : "null") + ", ");
            a.u("tickMarks: " + ((this.tickMarks != null) ? this.tickMarks.serialize() : "null") + ", ");
            if (this.annotationBackings != null) {
                a.u("annotationBackings: [");
                for (var c = 0; c < this.annotationBackings.count; c++) {
                    if (c != 0) {
                        a.l(", ");
                    }
                    a.l(this.annotationBackings._inner[c].serialize());
                }
                a.u("],");
            }
            if (this.axisLine != null) {
                a.u("majorLines: " + ((this.majorLines != null) ? this.majorLines.serialize() : "null") + ", ");
                a.u("minorLines: " + ((this.minorLines != null) ? this.minorLines.serialize() : "null") + ", ");
                a.u("strips: " + ((this.strips != null) ? this.strips.serialize() : "null"));
            }
            a.u("}");
            return a.toString();
        };
        AxisVisualData.$t = i2.markType(AxisVisualData, 'AxisVisualData');
        return AxisVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisVisualDataList, _super);
        function AxisVisualDataList() {
            return _super.call(this, AxisVisualData.$, 0) || this;
        }
        AxisVisualDataList.$t = i2.markType(AxisVisualDataList, 'AxisVisualDataList', i2.List$1.$.specialize(AxisVisualData.$));
        return AxisVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PointerTooltipVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointerTooltipVisualData, _super);
        function PointerTooltipVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._boxShape = null;
            _this._pointerFillShape = null;
            _this._pointerOutlineShape = null;
            _this._offsetX = 0;
            _this._offsetY = 0;
            _this._categoryNames = null;
            _this._viewport = null;
            return _this;
        }
        Object.defineProperty(PointerTooltipVisualData.prototype, "boxShape", {
            get: function () {
                return this._boxShape;
            },
            set: function (a) {
                this._boxShape = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PointerTooltipVisualData.prototype, "pointerFillShape", {
            get: function () {
                return this._pointerFillShape;
            },
            set: function (a) {
                this._pointerFillShape = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PointerTooltipVisualData.prototype, "pointerOutlineShape", {
            get: function () {
                return this._pointerOutlineShape;
            },
            set: function (a) {
                this._pointerOutlineShape = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PointerTooltipVisualData.prototype, "offsetX", {
            get: function () {
                return this._offsetX;
            },
            set: function (a) {
                this._offsetX = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PointerTooltipVisualData.prototype, "offsetY", {
            get: function () {
                return this._offsetY;
            },
            set: function (a) {
                this._offsetY = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PointerTooltipVisualData.prototype, "categoryNames", {
            get: function () {
                return this._categoryNames;
            },
            set: function (a) {
                this._categoryNames = a;
            },
            enumerable: false,
            configurable: true
        });
        PointerTooltipVisualData.prototype.serialize = function () {
            var e_1, _a;
            var a = "";
            if (this.categoryNames != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.categoryNames)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        a += "\"" + b + "\",";
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                if (a != "") {
                    a = a.substr(0, a.length - 1);
                }
            }
            var c = new i2.StringBuilder(0);
            c.u("{");
            c.u("offsetX: " + this.offsetX + ", ");
            c.u("offsetY: " + this.offsetY + ", ");
            c.u("boxShape: " + this.boxShape.serialize() + ", ");
            c.u("pointerFillShape: " + this.pointerFillShape.serialize() + ", ");
            c.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}, ");
            c.u("pointerOutlineShape: " + this.pointerOutlineShape.serialize() + ", ");
            c.u("categoryNames: [" + a + "]");
            c.u("}");
            return c.toString();
        };
        PointerTooltipVisualData.prototype.scaleByViewport = function (a) {
            this.boxShape.scaleByViewport(this.viewport);
            this.pointerFillShape.scaleByViewport(this.viewport);
            this.pointerOutlineShape.scaleByViewport(this.viewport);
            this.offsetX = (this.offsetX - a.left) / a.width;
            this.offsetY = (this.offsetY - a.top) / a.height;
        };
        Object.defineProperty(PointerTooltipVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        PointerTooltipVisualData.$t = i2.markType(PointerTooltipVisualData, 'PointerTooltipVisualData');
        return PointerTooltipVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PointerTooltipVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PointerTooltipVisualDataList, _super);
        function PointerTooltipVisualDataList() {
            return _super.call(this, PointerTooltipVisualData.$, 0) || this;
        }
        PointerTooltipVisualDataList.$t = i2.markType(PointerTooltipVisualDataList, 'PointerTooltipVisualDataList', i2.List$1.$.specialize(PointerTooltipVisualData.$));
        return PointerTooltipVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerVisualDataList, _super);
        function MarkerVisualDataList() {
            return _super.call(this, MarkerVisualData.$, 0) || this;
        }
        MarkerVisualDataList.$t = i2.markType(MarkerVisualDataList, 'MarkerVisualDataList', i2.List$1.$.specialize(MarkerVisualData.$));
        return MarkerVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutVisualData, _super);
        function CalloutVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._background = null;
            _this._text = null;
            _this._line = null;
            _this._left = 0;
            _this._top = 0;
            _this._marginLeft = 0;
            _this._marginTop = 0;
            return _this;
        }
        Object.defineProperty(CalloutVisualData.prototype, "background", {
            get: function () {
                return this._background;
            },
            set: function (a) {
                this._background = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutVisualData.prototype, "text", {
            get: function () {
                return this._text;
            },
            set: function (a) {
                this._text = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutVisualData.prototype, "line", {
            get: function () {
                return this._line;
            },
            set: function (a) {
                this._line = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutVisualData.prototype, "left", {
            get: function () {
                return this._left;
            },
            set: function (a) {
                this._left = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutVisualData.prototype, "top", {
            get: function () {
                return this._top;
            },
            set: function (a) {
                this._top = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutVisualData.prototype, "marginLeft", {
            get: function () {
                return this._marginLeft;
            },
            set: function (a) {
                this._marginLeft = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CalloutVisualData.prototype, "marginTop", {
            get: function () {
                return this._marginTop;
            },
            set: function (a) {
                this._marginTop = a;
            },
            enumerable: false,
            configurable: true
        });
        CalloutVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("left: " + this.left.toString() + ",");
            a.u("top: " + this.top.toString() + ",");
            a.u("marginLeft: " + this.marginLeft.toString() + ",");
            a.u("marginTop: " + this.marginTop.toString() + ",");
            a.u("background: " + this.background.serialize() + ",");
            a.u("text: " + this.text.serialize() + ",");
            a.u("line: " + this.line.serialize());
            a.u("}");
            return a.toString();
        };
        CalloutVisualData.prototype.scaleByViewport = function (a) {
            this.left = (this.left - a.left) / a.width;
            this.top = (this.top - a.top) / a.height;
            this.marginLeft = this.marginLeft / a.width;
            this.marginTop = this.marginTop / a.height;
            this.background.scaleByViewport(a);
            this.line.scaleByViewport(a);
        };
        CalloutVisualData.$t = i2.markType(CalloutVisualData, 'CalloutVisualData');
        return CalloutVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CalloutVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CalloutVisualDataList, _super);
        function CalloutVisualDataList() {
            return _super.call(this, CalloutVisualData.$, 0) || this;
        }
        CalloutVisualDataList.$t = i2.markType(CalloutVisualDataList, 'CalloutVisualDataList', i2.List$1.$.specialize(CalloutVisualData.$));
        return CalloutVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesVisualData, _super);
        function SeriesVisualData() {
            var _this = _super.call(this) || this;
            _this._name = null;
            _this._type = null;
            _this._viewport = null;
            _this._opacity = 0;
            _this._shapes = null;
            _this._pointerTooltips = null;
            _this._markerShapes = null;
            _this._calloutShapes = null;
            _this._pixels = null;
            _this._pixelWidth = 0;
            _this._pixelHeight = 0;
            _this.shapes = new i2.PrimitiveVisualDataList();
            _this.markerShapes = new MarkerVisualDataList();
            _this.pointerTooltips = new PointerTooltipVisualDataList();
            _this.calloutShapes = new CalloutVisualDataList();
            return _this;
        }
        Object.defineProperty(SeriesVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (a) {
                this._type = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "opacity", {
            get: function () {
                return this._opacity;
            },
            set: function (a) {
                this._opacity = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "shapes", {
            get: function () {
                return this._shapes;
            },
            set: function (a) {
                this._shapes = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "pointerTooltips", {
            get: function () {
                return this._pointerTooltips;
            },
            set: function (a) {
                this._pointerTooltips = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "markerShapes", {
            get: function () {
                return this._markerShapes;
            },
            set: function (a) {
                this._markerShapes = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "calloutShapes", {
            get: function () {
                return this._calloutShapes;
            },
            set: function (a) {
                this._calloutShapes = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "pixels", {
            get: function () {
                return this._pixels;
            },
            set: function (a) {
                this._pixels = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "pixelWidth", {
            get: function () {
                return this._pixelWidth;
            },
            set: function (a) {
                this._pixelWidth = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesVisualData.prototype, "pixelHeight", {
            get: function () {
                return this._pixelHeight;
            },
            set: function (a) {
                this._pixelHeight = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesVisualData.prototype.m = function () {
            var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.shapes)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var a = _f.value;
                    a.scaleByViewport(this.viewport);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_a = _e.return))
                        _a.call(_e);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _g = tslib.__values(i2.fromEnum(this.markerShapes)), _h = _g.next(); !_h.done; _h = _g.next()) {
                    var b = _h.value;
                    b.i(this.viewport);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_h && !_h.done && (_b = _g.return))
                        _b.call(_g);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            try {
                for (var _j = tslib.__values(i2.fromEnum(this.pointerTooltips)), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var c = _k.value;
                    c.scaleByViewport(this.viewport);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_k && !_k.done && (_c = _j.return))
                        _c.call(_j);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            try {
                for (var _l = tslib.__values(i2.fromEnum(this.calloutShapes)), _m = _l.next(); !_m.done; _m = _l.next()) {
                    var d = _m.value;
                    d.scaleByViewport(this.viewport);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_m && !_m.done && (_d = _l.return))
                        _d.call(_l);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        };
        SeriesVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.name != null) {
                a.u("name: \"" + this.name + "\",");
            }
            a.u("type: \"" + this.type + "\", ");
            a.u("opacity: " + this.opacity + ", ");
            a.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}, ");
            a.u("shapes: [");
            for (var b = 0; b < this.shapes.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.shapes._inner[b].serialize());
            }
            a.u("],");
            a.u("pointerTooltips: [");
            for (var c = 0; c < this.pointerTooltips.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.pointerTooltips._inner[c].serialize());
            }
            a.u("],");
            if (this.calloutShapes != null && this.calloutShapes.count > 0) {
                a.u("calloutshapes: [");
                for (var d = 0; d < this.calloutShapes.count; d++) {
                    if (d != 0) {
                        a.l(", ");
                    }
                    a.l(this.calloutShapes._inner[d].serialize());
                }
                a.u("],");
            }
            a.u("markerShapes: [");
            for (var e = 0; e < this.markerShapes.count; e++) {
                if (e != 0) {
                    a.l(", ");
                }
                a.l(this.markerShapes._inner[e].serialize());
            }
            a.u("]");
            this.n(a);
            if (this.pixels != null) {
                a.u(", pixels: [");
                for (var f = 0; f < this.pixels.length; f++) {
                    if (f != 0) {
                        a.l(", ");
                    }
                    a.l(this.pixels[f].toString());
                }
                a.u("], ");
                a.u("pixelWidth: " + this.pixelWidth + ", ");
            }
            a.u("}");
            return a.toString();
        };
        SeriesVisualData.prototype.n = function (a) {
        };
        SeriesVisualData.$t = i2.markType(SeriesVisualData, 'SeriesVisualData');
        return SeriesVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesVisualDataList, _super);
        function SeriesVisualDataList() {
            return _super.call(this, SeriesVisualData.$, 0) || this;
        }
        SeriesVisualDataList.$t = i2.markType(SeriesVisualDataList, 'SeriesVisualDataList', i2.List$1.$.specialize(SeriesVisualData.$));
        return SeriesVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartVisualData, _super);
        function ChartVisualData() {
            var _this = _super.call(this) || this;
            _this._axes = null;
            _this._series = null;
            _this._title = null;
            _this._subtitle = null;
            _this._width = 0;
            _this._height = 0;
            _this._contentArea = null;
            _this._centralArea = null;
            _this._plotArea = null;
            _this._name = null;
            _this._isViewportScaled = false;
            _this._dipScalingRatio = 0;
            _this.dipScalingRatio = 1;
            _this.axes = new AxisVisualDataList();
            _this.series = new SeriesVisualDataList();
            return _this;
        }
        Object.defineProperty(ChartVisualData.prototype, "axes", {
            get: function () {
                return this._axes;
            },
            set: function (a) {
                this._axes = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "series", {
            get: function () {
                return this._series;
            },
            set: function (a) {
                this._series = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "title", {
            get: function () {
                return this._title;
            },
            set: function (a) {
                this._title = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "subtitle", {
            get: function () {
                return this._subtitle;
            },
            set: function (a) {
                this._subtitle = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (a) {
                this._width = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (a) {
                this._height = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "contentArea", {
            get: function () {
                return this._contentArea;
            },
            set: function (a) {
                this._contentArea = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "centralArea", {
            get: function () {
                return this._centralArea;
            },
            set: function (a) {
                this._centralArea = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "plotArea", {
            get: function () {
                return this._plotArea;
            },
            set: function (a) {
                this._plotArea = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartVisualData.prototype, "isViewportScaled", {
            get: function () {
                return this._isViewportScaled;
            },
            set: function (a) {
                this._isViewportScaled = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartVisualData.prototype.scaleByViewport = function () {
            var e_1, _a, e_2, _b;
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    a.p();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    b.m();
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            if (this.title != null) {
                this.title.g();
            }
            if (this.subtitle != null) {
                this.subtitle.g();
            }
        };
        ChartVisualData.prototype.getBounds = function () {
            return new i2.RectData(0, 0, this.width, this.height);
        };
        ChartVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            if (this.name != null) {
                a.u("name: '" + this.name + "',");
            }
            a.u("width: " + this.width + ",");
            a.u("height: " + this.height + ",");
            a.u("plotArea: { left: " + this.plotArea.left + ", top: " + this.plotArea.top + ", width: " + this.plotArea.width + ", height: " + this.plotArea.height + "}, ");
            a.u("contentArea: { left: " + this.contentArea.left + ", top: " + this.contentArea.top + ", width: " + this.contentArea.width + ", height: " + this.contentArea.height + "}, ");
            a.u("centralArea: { left: " + this.centralArea.left + ", top: " + this.centralArea.top + ", width: " + this.centralArea.width + ", height: " + this.centralArea.height + "}, ");
            a.u("isViewportScaled: " + (this.isViewportScaled ? "true" : "false") + ", ");
            a.u("axes: [");
            for (var b = 0; b < this.axes.count; b++) {
                if (b != 0) {
                    a.l(", ");
                }
                a.l(this.axes._inner[b].serialize());
            }
            a.u("],");
            a.u("series: [");
            for (var c = 0; c < this.series.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.series._inner[c].serialize());
            }
            a.u("]");
            if (this.title != null) {
                a.u(", title: " + this.title.serialize());
            }
            if (this.subtitle != null) {
                a.u(", subtitle: " + this.subtitle.serialize());
            }
            a.l(", dipScalingRatio: " + this.dipScalingRatio.toString());
            a.u("}");
            return a.toString();
        };
        ChartVisualData.prototype.getSerializedSeriesPoints = function (a, b, c) {
            var d = new i2.List$1(i2.List$1.$.specialize(i2.PointData.$), 0);
            for (var e = 0; e < this.series.count; e++) {
                if (this.series._inner[e].name == a) {
                    var f = this.series._inner[e].shapes.containingTag(b);
                    for (var g = 0; g < f.count; g++) {
                        var h = f._inner[e];
                        h.getPointsOverride(d, c);
                    }
                }
            }
            var i = new i2.StringBuilder(0);
            i.u("[");
            for (var j = 0; j < d.count; j++) {
                var k = d._inner[j];
                i.u("[");
                for (var l = 0; l < k.count; l++) {
                    if (l != 0) {
                        i.l(", ");
                    }
                    i.l("{ x: " + k._inner[l].x + ", y: " + k._inner[l].y + "}");
                }
                i.u("]");
            }
            i.u("]");
            return i.toString();
        };
        Object.defineProperty(ChartVisualData.prototype, "dipScalingRatio", {
            get: function () {
                return this._dipScalingRatio;
            },
            set: function (a) {
                this._dipScalingRatio = a;
            },
            enumerable: false,
            configurable: true
        });
        ChartVisualData.$t = i2.markType(ChartVisualData, 'ChartVisualData');
        return ChartVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VisualExportHelper = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VisualExportHelper, _super);
        function VisualExportHelper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VisualExportHelper.a = function (a) {
            var e_1, _a;
            var b = { $type: i2.Point_$type, x: a.n, y: a.o };
            var c = new i2.Rect(0, b.x, b.y, a.m, a.l);
            var d = a.j;
            if (d == null) {
                return c;
            }
            var e = 0;
            var f = 0;
            var g = 0;
            var h = null;
            if (i2.typeCast(i2.RotateTransform.$, d) !== null) {
                h = i2.typeCast(i2.RotateTransform.$, d);
                e = h.j;
            }
            else if (i2.typeCast(i2.TransformGroup.$, d) !== null) {
                var i = i2.typeCast(i2.TransformGroup.$, d);
                try {
                    for (var _b = tslib.__values(i2.fromEnum(i.j)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var j = _c.value;
                        if (i2.typeCast(i2.RotateTransform.$, j) !== null) {
                            h = i2.typeCast(i2.RotateTransform.$, j);
                            e = h.j;
                        }
                        if (i2.typeCast(i2.TranslateTransform.$, j) !== null) {
                            var k = i2.typeCast(i2.TranslateTransform.$, j);
                            f = k.j;
                            g = k.k;
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            if (h != null) {
                c = i2.RectUtil.x(c, h.k, h.l, e);
            }
            c.x = c.x + f;
            c.y = c.y + g;
            return c;
        };
        VisualExportHelper.$t = i2.markType(VisualExportHelper, 'VisualExportHelper');
        return VisualExportHelper;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DataChartVisualDataManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DataChartVisualDataManager, _super);
        function DataChartVisualDataManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DataChartVisualDataManager.prototype.exportVisualData = function (a) {
            var b = new ChartVisualData();
            for (var c = 0; c < a.axes.count; c++) {
                var d = a.axes._inner[c].ff();
                b.axes.add1(d);
            }
            for (var e = 0; e < a.series.count; e++) {
                var f = a.series._inner[e].hg();
                b.series.add1(f);
            }
            b.name = a.name;
            this.b(a, b);
            this.c(a, b);
            return b;
        };
        DataChartVisualDataManager.prototype.c = function (a, b) {
            var c = a.cf;
            b.width = c.a8;
            b.height = c.a7;
            b.contentArea = i2.RectData.b(c.e9());
            b.centralArea = new i2.RectData(c.a4, 0, c.a8 - (c.a4 + c.a5), c.a7 - (c.a6 + c.a3));
            b.plotArea = i2.RectData.b(a.pv);
        };
        DataChartVisualDataManager.prototype.d = function (a, b) {
            var c = VisualExportHelper.a(a);
            return c;
        };
        DataChartVisualDataManager.prototype.b = function (a, b) {
            var c = a.cf;
            var d = null;
            b.title = null;
            b.subtitle = null;
            var e = c.fh();
            var f = 0;
            var g = 0;
            if (c.et != null) {
                d = c.v();
                var h = this.a(c, c.et, d);
                var i = { $type: i2.Point_$type, x: 0, y: 0 };
                g = c.et.l + e.b + e.e;
                var j = new ChartTitleVisualData();
                var k = c.e9();
                j.viewport = new i2.RectData(k.left, k.top, k.width, g);
                j.textPlotArea = i2.RectData.b(this.d(c.et, a));
                j.textPlotArea = new i2.RectData(c.et.n, c.et.o, c.et.m, c.et.l);
                f = j.height;
                j.appearance = i2.AppearanceHelper.c(c.et, h);
                var l = c.fh();
                j.appearance.marginTop = l.e;
                j.appearance.marginLeft = l.c;
                j.appearance.marginRight = l.d;
                j.appearance.marginBottom = l.b;
                var m = c.ev();
                j.appearance.horizontalAlignment = i2.EnumUtil.getName(i2.HorizontalAlignment_$type, m);
                b.title = j;
            }
            if (c.es != null) {
                d = c.u();
                var n = this.a(c, c.es, d);
                var o = { $type: i2.Point_$type, x: 0, y: f };
                var p = c.fg();
                var q = c.es.l + p.b + p.e;
                var r = new ChartTitleVisualData();
                var s = c.e9();
                r.viewport = new i2.RectData(s.left, s.top + g, s.width, q);
                r.textPlotArea = i2.RectData.b(this.d(c.es, a));
                r.appearance = i2.AppearanceHelper.c(c.es, n);
                var t = c.fg();
                r.appearance.marginTop = t.e;
                r.appearance.marginLeft = t.c;
                r.appearance.marginRight = t.d;
                r.appearance.marginBottom = t.b;
                var u = c.eu();
                r.appearance.horizontalAlignment = i2.EnumUtil.getName(i2.HorizontalAlignment_$type, u);
                b.subtitle = r;
            }
        };
        DataChartVisualDataManager.prototype.a = function (a, b, c) {
            return i2.FontUtil.getFontInfo(a.j.ae, b, c);
        };
        DataChartVisualDataManager.$t = i2.markType(DataChartVisualDataManager, 'DataChartVisualDataManager', i2.Base.$, [IDataChartVisualDataManager_$type]);
        return DataChartVisualDataManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisVisualDataManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisVisualDataManager, _super);
        function AxisVisualDataManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AxisVisualDataManager.prototype.c = function (a) {
            return a;
        };
        AxisVisualDataManager.prototype.d = function (a, b) {
            var c = VisualExportHelper.a(b);
            return c;
        };
        AxisVisualDataManager.prototype.a = function (a, b, c, d) {
            var e = new ChartTitleVisualData();
            var f = a.a4;
            var g = f.a6();
            e.viewport = i2.RectData.b(g);
            var h = this.d(a, d);
            e.textPlotArea = i2.RectData.b(h);
            var i = d._visibility == 0 && d.x != null;
            var j = a.av.ae.d();
            var k = f.bd(d);
            var l = this.b(a, d, j);
            var m = i2.AppearanceHelper.c(d, l);
            m.marginLeft = k.c;
            m.marginRight = k.d;
            m.marginTop = k.e;
            m.marginBottom = k.b;
            m.fontStretch = "Normal";
            m.textWrapping = "Wrap";
            m.visibility = i;
            if (a.be != null) {
                m.horizontalAlignment = i2.EnumUtil.getName(i2.HorizontalAlignment_$type, a.be.horizontalAlignment);
                m.verticalAlignment = i2.EnumUtil.getName(i2.VerticalAlignment_$type, a.be.verticalAlignment);
                m.textPosition = i2.EnumUtil.getName(AxisTitlePosition_$type, a.be.position);
            }
            else {
                m.horizontalAlignment = i2.EnumUtil.getName(i2.HorizontalAlignment_$type, (0));
                m.verticalAlignment = i2.EnumUtil.getName(i2.VerticalAlignment_$type, (1));
                m.textPosition = i2.EnumUtil.getName(AxisTitlePosition_$type, (0));
            }
            e.appearance = m;
            return e;
        };
        AxisVisualDataManager.prototype.exportVisualData = function (a) {
            var b = new AxisVisualData();
            b.viewport = i2.RectData.b(a.js);
            b.labelsViewport = i2.RectData.b(a.a4.a6());
            b.type = this.c(i2.getInstanceType(a).typeName);
            b.name = a.name;
            var c = new i2.PathVisualData(1, "axisLine", a.a4.a7);
            b.axisLine = c;
            b.tickMarks = new i2.PathVisualData(1, "tickMarks", a.av.ae.av);
            if (!a.av.ab.contains(a.av.ae.av)) {
                b.tickMarks.data.clear();
            }
            b.minorLines = new i2.PathVisualData(1, "minorLines", a.a4.a9);
            b.majorLines = new i2.PathVisualData(1, "majorLines", a.a4.a8);
            b.strips = new i2.PathVisualData(1, "strips", a.a4.ba);
            if (a.gp != null) {
                var d = this.a(a, a.bh, b.type, a.h6);
                b.title = d;
            }
            else {
                b.title = null;
            }
            var e = a.bh.getFontInfo();
            if (a.ay != null && a.ay.textStyle != null) {
                e = a.ay.g(a.bh.cf.j.ae);
            }
            var f, g, h, i;
            var j = a.av.ae.av.ak.d;
            if (1 < j.count) {
                for (var k = 1; k < j.count; k++) {
                    var l = j._inner[k];
                    var m = j._inner[k - 1];
                    f = l.d.x - l.c.x;
                    g = l.d.y - l.c.y;
                    h = m.d.x - m.c.x;
                    i = m.d.y - m.c.y;
                    if (1 == k) {
                        b.tickMarksLength = Math.sqrt(Math.pow(f, 2) + Math.pow(g, 2));
                    }
                }
            }
            var n = a.av.a6;
            var o = a.av.ae.g();
            if (n.count > 0) {
                var _loop_1 = function (p) {
                    var e_1, _a;
                    var q = a.av.a6._inner[p];
                    var r = a.av.a5._inner[p];
                    var s = ((function () {
                        var $ret = new AxisLabelVisualData();
                        $ret.labelPosition = q.c;
                        $ret.labelValue = r;
                        $ret.panelPosition = i2.PointData.b(a.a4.a3());
                        return $ret;
                    })());
                    var t = new i2.List$1(i2.TextBlock.$, 0);
                    try {
                        for (var _b = (e_1 = void 0, tslib.__values(i2.fromEnum(o))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var u = _c.value;
                            t.add(u);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                    if (p < t.count) {
                        var v = this_1.b(a, t._inner[p], e);
                        s.appearance = i2.AppearanceHelper.c(t._inner[p], v);
                        s.position = i2.PointData.b(a.a4.a2(t._inner[p]));
                        s.size = i2.SizeData.b(new i2.Size(1, t._inner[p].m, t._inner[p].l));
                    }
                    b.labels.add(s);
                };
                var this_1 = this;
                for (var p = 0; p < n.count; p++) {
                    _loop_1(p);
                }
            }
            var w = null;
            if (a.bo.a.count > 0) {
                for (var x = 0; x < a.bo.a.count; x++) {
                    if (w == null) {
                        w = new i2.List$1(i2.RectangleVisualData.$, 0);
                    }
                    var y = new i2.RectangleVisualData(1, "annotationBacking_" + x, a.bo.item(x));
                    y.appearance.canvasLeft = a.bo.item(x).n;
                    y.appearance.canvasTop = a.bo.item(x).o;
                    w.add(y);
                }
            }
            b.annotationBackings = w;
            return b;
        };
        AxisVisualDataManager.prototype.b = function (a, b, c) {
            return i2.FontUtil.getFontInfo(a.bh.cf.j.ae, b, c);
        };
        AxisVisualDataManager.$t = i2.markType(AxisVisualDataManager, 'AxisVisualDataManager', i2.Base.$, [IAxisVisualDataManager_$type]);
        return AxisVisualDataManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var StackedSeriesVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StackedSeriesVisualData, _super);
        function StackedSeriesVisualData() {
            var _this = _super.call(this) || this;
            _this._fragmentSeries = null;
            _this.fragmentSeries = new SeriesVisualDataList();
            return _this;
        }
        Object.defineProperty(StackedSeriesVisualData.prototype, "fragmentSeries", {
            get: function () {
                return this._fragmentSeries;
            },
            set: function (a) {
                this._fragmentSeries = a;
            },
            enumerable: false,
            configurable: true
        });
        StackedSeriesVisualData.prototype.m = function () {
            _super.prototype.m.call(this);
            for (var a = 0; a < this.fragmentSeries.count; a++) {
                this.fragmentSeries._inner[a].m();
            }
        };
        StackedSeriesVisualData.prototype.n = function (a) {
            _super.prototype.n.call(this, a);
            if (this.fragmentSeries != null && this.fragmentSeries.count > 0) {
                a.u(",");
                a.u("fragmentSeries: [");
                for (var b = 0; b < this.fragmentSeries.count; b++) {
                    if (b > 0) {
                        a.u(",");
                    }
                    a.l(this.fragmentSeries._inner[b].serialize());
                }
                a.u("]");
            }
        };
        StackedSeriesVisualData.$t = i2.markType(StackedSeriesVisualData, 'StackedSeriesVisualData', SeriesVisualData.$);
        return StackedSeriesVisualData;
    }(SeriesVisualData));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesVisualDataManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesVisualDataManager, _super);
        function SeriesVisualDataManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SeriesVisualDataManager.prototype.addSubSeriesVisualData = function (a, b) {
            var c = a;
            var d = b;
            c.fragmentSeries.add(d);
        };
        SeriesVisualDataManager.prototype.copyVisualData = function (a, b) {
            var e_1, _a, e_2, _b;
            var c = a;
            var d = b;
            try {
                for (var _c = tslib.__values(i2.fromEnum(d.shapes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    c.shapes.add(e);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(d.markerShapes)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var f = _f.value;
                    c.markerShapes.add(f);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            c.pixels = d.pixels;
            c.pixelWidth = d.pixelWidth;
        };
        SeriesVisualDataManager.prototype.createFragmentVisualData = function (a, b, c, d) {
            var e = new SeriesVisualData();
            e.viewport = i2.RectData.b(b);
            e.type = c;
            e.name = d;
            return e;
        };
        SeriesVisualDataManager.prototype.exportMarkerVisualData = function (a, b) {
            var _this = this;
            var c = b;
            a.pq.cf(function (d) {
                var e = _this.getMarkerVisualData(a, d, a.qc);
                c.markerShapes.add(i2.typeCast(MarkerVisualData.$, e));
            });
        };
        SeriesVisualDataManager.prototype.getMarkerVisualData = function (a, b, c) {
            var d = new MarkerVisualData();
            var e = new i2.PrimitiveAppearanceData();
            d.x = b.n;
            d.y = b.o;
            d.bounds = new i2.RectData(b.n - (b.m / 2), b.o - (b.l / 2), b.m, b.l);
            e.fill = i2.ColorData.a_1(i2.Color.u(0, 0, 0, 0));
            e.stroke = i2.ColorData.a_1(i2.Color.u(0, 0, 0, 0));
            d.index = -1;
            d.contentTemplate = b.ah;
            if (b.content != null && i2.typeCast(i2.DataContext.$, b.content) !== null && b._visibility == 0) {
                var f = b.content;
                e.fill = i2.AppearanceHelper.b(f.actualItemBrush);
                e.fillExtended = i2.AppearanceHelper.a(f.actualItemBrush);
                e.stroke = i2.AppearanceHelper.b(f.outline);
                e.strokeExtended = i2.AppearanceHelper.a(f.outline);
                e.strokeThickness = a.ft();
                if (f.item != null) {
                    d.index = a.ch.indexOf(f.item);
                }
            }
            e.isVisible = b._visibility == 0;
            d.isVisible = b._visibility == 0;
            d.markerAppearance = e;
            d.markerType = this.a(a, c);
            return d;
        };
        SeriesVisualDataManager.prototype.a = function (a, b) {
            if (b == a.ca.mu) {
                return "Circle";
            }
            else if (b == a.ca.mv) {
                return "Diamond";
            }
            else if (b == a.ca.mw) {
                return "Hexagon";
            }
            else if (b == a.ca.mx) {
                return "Hexagram";
            }
            else if (b == a.ca.my) {
                return "Pentagon";
            }
            else if (b == a.ca.mz) {
                return "Pentagram";
            }
            else if (b == a.ca.m0) {
                return "Pyramid";
            }
            else if (b == a.ca.m1) {
                return "Square";
            }
            else if (b == a.ca.m2) {
                return "Tetragram";
            }
            else if (b == a.ca.m3) {
                return "Triangle";
            }
            else {
                return "None";
            }
        };
        SeriesVisualDataManager.prototype.exportMarkerVisualDataFromMarker = function (a, b, c) {
            var d = b;
            var e = new MarkerVisualData();
            var f = new i2.PrimitiveAppearanceData();
            e.x = c.n;
            e.y = c.o;
            e.bounds = new i2.RectData(c.n - (c.m / 2), c.o - (c.l / 2), c.m, c.l);
            e.index = -1;
            e.contentTemplate = c.ah;
            if (i2.typeCast(i2.DataContext.$, c.content) !== null) {
                var g = c.content;
                f.fill = i2.AppearanceHelper.b(g.actualItemBrush);
                f.stroke = i2.AppearanceHelper.b(g.outline);
            }
            e.isVisible = c._visibility == 0;
            e.markerAppearance = f;
            if (c.ah == a.ca.mu) {
                e.markerType = "Circle";
            }
            else if (c.ah == a.ca.mv) {
                e.markerType = "Diamond";
            }
            else if (c.ah == a.ca.mw) {
                e.markerType = "Hexagon";
            }
            else if (c.ah == a.ca.mx) {
                e.markerType = "Hexagram";
            }
            else if (c.ah == a.ca.my) {
                e.markerType = "Pentagon";
            }
            else if (c.ah == a.ca.mz) {
                e.markerType = "Pentagram";
            }
            else if (c.ah == a.ca.m0) {
                e.markerType = "Pyramid";
            }
            else if (c.ah == a.ca.m1) {
                e.markerType = "Square";
            }
            else if (c.ah == a.ca.m2) {
                e.markerType = "Tetragram";
            }
            else if (c.ah == a.ca.m3) {
                e.markerType = "Triangle";
            }
            else {
                e.markerType = "None";
            }
            d.markerShapes.add(e);
        };
        SeriesVisualDataManager.prototype.exportPathData = function (a, b, c, d) {
            var e = a;
            var f = new i2.PathVisualData(1, c, b);
            if (d != null) {
                for (var g = 0; g < d.length; g++) {
                    f.tags.add(d[g]);
                }
            }
            e.shapes.add(f);
        };
        SeriesVisualDataManager.prototype.exportPolygonData = function (a, b, c, d) {
            var e = a;
            var f = new i2.PolygonVisualData(1, c, b);
            if (d != null) {
                for (var g = 0; g < d.length; g++) {
                    f.tags.add(d[g]);
                }
            }
            e.shapes.add(f);
        };
        SeriesVisualDataManager.prototype.exportPolylineData = function (a, b, c, d) {
            var e = a;
            var f = new i2.PolyLineVisualData(1, c, b);
            if (d != null) {
                for (var g = 0; g < d.length; g++) {
                    f.tags.add(d[g]);
                }
            }
            e.shapes.add(f);
        };
        SeriesVisualDataManager.prototype.exportRectangleData = function (a, b, c, d) {
            var e = a;
            var f = new i2.RectangleVisualData(1, c, b);
            if (d != null) {
                for (var g = 0; g < d.length; g++) {
                    f.tags.add(d[g]);
                }
            }
            e.shapes.add(f);
        };
        SeriesVisualDataManager.prototype.exportStackedVisualData = function (a, b) {
            var c = new StackedSeriesVisualData();
            c.viewport = i2.RectData.b(b);
            c.type = i2.getInstanceType(a).typeName;
            c.name = a.name;
            return c;
        };
        SeriesVisualDataManager.prototype.exportTrendlineData = function (a, b, c) {
            var d = b;
            var e = new i2.PolyLineVisualData(1, "trendLine", c);
            e.tags.add("Trend");
            d.shapes.add(e);
        };
        SeriesVisualDataManager.prototype.exportVisualData = function (a, b) {
            var c = new SeriesVisualData();
            c.viewport = i2.RectData.b(b);
            c.type = this.b(i2.getInstanceType(a).typeName);
            c.name = a.name;
            c.opacity = a._opacity;
            return c;
        };
        SeriesVisualDataManager.prototype.exportSeriesPixelsData = function (a, b, c, d) {
            var e = a;
            e.pixels = b;
            e.pixelWidth = c;
            e.pixelHeight = d;
        };
        SeriesVisualDataManager.prototype.b = function (a) {
            return a;
        };
        SeriesVisualDataManager.prototype.addPointerTooltipData = function (a, b, c, d, e) {
            if (b == null) {
                return;
            }
            var f = a;
            var g = b;
            g.offsetX = c;
            g.offsetY = d;
            g.categoryNames = e;
            f.pointerTooltips.add(g);
        };
        SeriesVisualDataManager.prototype.exportPointerTooltipData = function (a, b, c, d) {
            var e = new PointerTooltipVisualData();
            e.pointerFillShape = new i2.PolygonVisualData(1, "fillShape", a);
            e.pointerOutlineShape = new i2.PolyLineVisualData(1, "outlineShape", b);
            e.boxShape = new i2.RectangleVisualData(1, "boxShape", c);
            e.viewport = i2.RectData.b(d);
            return e;
        };
        SeriesVisualDataManager.prototype.exportCalloutData = function (a, b, c, d, e, f, g, h, i, j, k) {
            var l = new CalloutVisualData();
            l.left = a;
            l.top = b;
            l.marginLeft = c;
            l.marginTop = d;
            l.background = new i2.RectangleVisualData(1, "calloutBackground", f);
            l.text = i2.AppearanceHelper.c(g, h);
            l.line = new i2.LineVisualData(1, "calloutLeaderLine", i);
            e.calloutShapes.add(l);
        };
        SeriesVisualDataManager.$t = i2.markType(SeriesVisualDataManager, 'SeriesVisualDataManager', i2.Base.$, [ISeriesVisualDataManager_$type]);
        return SeriesVisualDataManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VisualDataFactoryManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VisualDataFactoryManager, _super);
        function VisualDataFactoryManager() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VisualDataFactoryManager.register = function () {
            if (!VisualDataFactoryManager.a) {
                i2.DVContainer.instance.registerFactory(IDataChartVisualDataManager_$type, function () { return new DataChartVisualDataManager(); });
                i2.DVContainer.instance.registerFactory(IAxisVisualDataManager_$type, function () { return new AxisVisualDataManager(); });
                i2.DVContainer.instance.registerFactory(ISeriesVisualDataManager_$type, function () { return new SeriesVisualDataManager(); });
                VisualDataFactoryManager.a = true;
            }
        };
        VisualDataFactoryManager.$t = i2.markType(VisualDataFactoryManager, 'VisualDataFactoryManager');
        VisualDataFactoryManager.a = false;
        return VisualDataFactoryManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartVisualDataModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartVisualDataModule() {
            i2.TypeRegistrar.register('VisualDataFactoryManager', VisualDataFactoryManager.$type);
            VisualDataFactoryManager.register();
        }
        IgxDataChartVisualDataModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartVisualDataModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataModule, imports: [i1.CommonModule] });
        IgxDataChartVisualDataModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataModule, imports: [[i1.CommonModule,
                ]] });
        return IgxDataChartVisualDataModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxDataChartVisualDataDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxDataChartVisualDataDynamicModule() {
            i2.TypeRegistrar.register('VisualDataFactoryManager', VisualDataFactoryManager.$type);
            VisualDataFactoryManager.register();
        }
        IgxDataChartVisualDataDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxDataChartVisualDataDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataDynamicModule, imports: [i1.CommonModule, IgxDataChartVisualDataModule], exports: [IgxDataChartVisualDataModule] });
        IgxDataChartVisualDataDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataDynamicModule, imports: [[i1.CommonModule, IgxDataChartVisualDataModule
                ], IgxDataChartVisualDataModule] });
        return IgxDataChartVisualDataDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxDataChartVisualDataDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxDataChartVisualDataModule
                        ],
                        imports: [i1.CommonModule, IgxDataChartVisualDataModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISeriesViewerWidgetOptions_$type = new i2.Type(null, 'ISeriesViewerWidgetOptions');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ISeriesViewerWidget_$type = new i2.Type(null, 'ISeriesViewerWidget');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Enumeration of options for the usage of the surface.
     */
    var ViewerSurfaceUsage = /*@__PURE__*/ (function (ViewerSurfaceUsage) {
        /**
         * Normal surface usage.
         */
        ViewerSurfaceUsage[ViewerSurfaceUsage["Normal"] = 0] = "Normal";
        /**
         * Minimal surface usage.
         */
        ViewerSurfaceUsage[ViewerSurfaceUsage["Minimal"] = 1] = "Minimal";
        return ViewerSurfaceUsage;
    })({});
    /**
     * @hidden
     */
    var ViewerSurfaceUsage_$type = i2.markEnum('ViewerSurfaceUsage', 'Normal,0|Minimal,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DataSourceManager = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DataSourceManager, _super);
        function DataSourceManager() {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.c = null;
            _this.b = null;
            _this.a = null;
            _this.d = new i2.Dictionary$2(i2.Base.$, i2.Base.$, 0);
            _this.c = new i2.Dictionary$2(i2.Base.$, i2.Base.$, 0);
            _this.b = new i2.Dictionary$2(i2.Base.$, i2.Number_$type, 0);
            _this.a = new i2.Dictionary$2(i2.String_$type, i2.Base.$, 0);
            return _this;
        }
        DataSourceManager.prototype.e = function (target_, dataSource_) {
            if (this.d.containsKey(target_)) {
                this.f(target_);
            }
            this.d.addItem(target_, dataSource_);
            var arr_ = dataSource_.dataView();
            if (this.c.containsKey(arr_)) {
                this.c.removeItem(arr_);
            }
            this.c.addItem(arr_, dataSource_);
            var a = (dataSource_.id);
            if (this.a.containsKey(a)) {
                this.a.removeItem(a);
            }
            this.a.addItem(a, dataSource_);
            if (!this.b.containsKey(dataSource_)) {
                this.b.addItem(dataSource_, 1);
            }
            else {
                this.b.item(dataSource_, this.b.item(dataSource_) + 1);
            }
            target_.itemsSource(arr_);
        };
        DataSourceManager.prototype.f = function (target_) {
            var curr_ = target_.itemsSource();
            this.d.removeItem(target_);
            if (!this.c.containsKey(curr_)) {
                return;
            }
            var ds_ = this.c.item(curr_);
            this.b.item(ds_, this.b.item(ds_) - 1);
            if (this.b.item(ds_) == 0) {
                this.b.removeItem(ds_);
                this.c.removeItem(curr_);
                var a = (ds_.id);
                this.a.removeItem(a);
            }
        };
        DataSourceManager.$t = i2.markType(DataSourceManager, 'DataSourceManager');
        return DataSourceManager;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SeriesViewerSurfaceViewer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SeriesViewerSurfaceViewer, _super);
        function SeriesViewerSurfaceViewer(a, b) {
            var _this = _super.call(this) || this;
            _this.m = null;
            _this.o = false;
            _this.k = null;
            _this.x = null;
            _this.n = true;
            _this.q = null;
            _this.j = 0;
            _this.propertyChanged = null;
            if (a == null || b == null) {
                throw new i2.ArgumentNullException(0, "model");
            }
            _this.l = a;
            var c = _this.l;
            c.windowRectChanged = i2.delegateCombine(c.windowRectChanged, i2.runOn(_this, _this.u));
            _this.m = b;
            _this.x = new i2.Canvas();
            _this.w();
            return _this;
        }
        SeriesViewerSurfaceViewer.prototype.u = function (a, b) {
            var c = this.o;
            this.o = true;
            this.zoomLevel = 1 - Math.min(b.newRect.height, b.newRect.width);
            this.o = c;
        };
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "l", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                if (this.k != null) {
                    var b = i2.typeCast(i2.INotifyPropertyChanged_$type, this.k);
                    if (b != null) {
                        b.propertyChanged = i2.delegateRemove(b.propertyChanged, i2.runOn(this, this.t));
                    }
                }
                this.k = a;
                if (this.k != null) {
                    var c = i2.typeCast(i2.INotifyPropertyChanged_$type, this.k);
                    if (c != null) {
                        c.propertyChanged = i2.delegateCombine(c.propertyChanged, i2.runOn(this, this.t));
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerSurfaceViewer.prototype.t = function (a, b) {
            if (b.propertyName == "DefaultInteraction") {
                this.j = this.l.b3;
                this.v(b.propertyName, i2.enumGetBox(i2.InteractionState_$type, this.defaultInteraction), i2.enumGetBox(i2.InteractionState_$type, this.defaultInteraction));
            }
        };
        SeriesViewerSurfaceViewer.prototype.zoomTo100 = function () {
            this.l.pw = XamDataChart.ps;
        };
        SeriesViewerSurfaceViewer.prototype.scaleToFit = function () {
            this.l.pw = XamDataChart.ps;
        };
        SeriesViewerSurfaceViewer.prototype.renderPreview = function () {
            if (!this.isDirty) {
                return;
            }
            var a = new RenderSurface();
            a.a = this.m.n.viewThumbnailContext;
            if (a.a != null && a.a.d) {
                var b = this.m.n.viewThumbnailSize;
                this.m.b8(b.width, b.height, a);
            }
            this.isDirty = false;
        };
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "worldRect", {
            get: function () {
                return XamDataChart.ps;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "viewportRect", {
            get: function () {
                return this.l.pv;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "minimumZoomLevel", {
            get: function () {
                return 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "maximumZoomLevel", {
            get: function () {
                if (this.l.f5 == 0.0001) {
                    return 0.9;
                }
                else {
                    return 1 - this.l.f5;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "isDirty", {
            get: function () {
                return this.n;
            },
            set: function (a) {
                this.n = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "isIsoScaled", {
            get: function () {
                if (this.k == null) {
                    return false;
                }
                return this.k.dw;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerSurfaceViewer.prototype.v = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            switch (a) {
                case SeriesViewerSurfaceViewer.$$p[0]:
                    if (c - this.minimumZoomLevel < -1E-05) {
                        this.zoomLevel = this.minimumZoomLevel;
                        return;
                    }
                    if (c - this.maximumZoomLevel > 0.0001) {
                        this.zoomLevel = this.maximumZoomLevel;
                        return;
                    }
                    var d = this.l != null && this.l.b8 != null && this.l.b8.updatingSliderRanges;
                    if (!this.o && !d) {
                        var e = 1 - this.zoomLevel;
                        var f = i2.RectUtil.l(this.l.pg);
                        var g = new i2.Rect(0, f.x - e / 2, f.y - e / 2, e, e);
                        this.l.pw = SeriesViewerSurfaceViewer.z(this.l.pw, g, this.l.d4(), this.l.d5(), this.worldRect);
                    }
                    this.w();
                    if (this.l.b8 != null) {
                        this.l.b8.pushZoomLevel(this.zoomLevel);
                    }
                    break;
            }
        };
        SeriesViewerSurfaceViewer.prototype.w = function () {
            var a = Math.round(100 * (1 / (1 - this.zoomLevel)));
            if (a <= 1000) {
                this.zoomLevelDisplayText = a.toString();
            }
            else {
                this.zoomLevelDisplayText = "> 1000";
            }
        };
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "zoomLevelDisplayText", {
            get: function () {
                return this.q;
            },
            set: function (a) {
                var b = this.zoomLevelDisplayText != a;
                if (b) {
                    var c = this.zoomLevelDisplayText;
                    this.q = a;
                    this.v("ZoomLevelDisplayText", c, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "defaultInteraction", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                this.j = a;
                this.l.b3 = a;
            },
            enumerable: false,
            configurable: true
        });
        SeriesViewerSurfaceViewer.z = function (a, b, c, d, e) {
            var f, g, h, i;
            if (c) {
                f = b.left;
                h = b.width;
            }
            else {
                f = a.left;
                h = a.width;
            }
            if (d) {
                g = b.top;
                i = b.height;
            }
            else {
                g = a.top;
                i = a.height;
            }
            var j = f + h;
            var k = g + i;
            var l = Math.max(0, e.left - f);
            var m = Math.max(0, j - e.right);
            var n = Math.max(0, e.top - g);
            var o = Math.max(0, k - e.bottom);
            f += l - m;
            g += n - o;
            var p = new i2.Rect(0, f, g, h, i);
            p.intersect(e);
            return p;
        };
        SeriesViewerSurfaceViewer.$t = i2.markType(SeriesViewerSurfaceViewer, 'SeriesViewerSurfaceViewer', i2.DependencyObject.$, [i2.IOverviewPlusDetailControl_$type, i2.INotifyPropertyChanged_$type]);
        SeriesViewerSurfaceViewer.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, SeriesViewerSurfaceViewer, 'v', ['ZoomLevel::y', [1, 0]]);
        return SeriesViewerSurfaceViewer;
    }(i2.DependencyObject));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Enumeration that determines whether the axis extent measures in pixels or percentage.
     */
    var AxisExtentType = /*@__PURE__*/ (function (AxisExtentType) {
        /**
         * Axis extent measured in pixels
         */
        AxisExtentType[AxisExtentType["Pixel"] = 0] = "Pixel";
        /**
         * Axis extent measured as a percentage of the chart's size
         */
        AxisExtentType[AxisExtentType["Percent"] = 1] = "Percent";
        return AxisExtentType;
    })({});
    /**
     * @hidden
     */
    var AxisExtentType_$type = i2.markEnum('AxisExtentType', 'Pixel,0|Percent,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisLabelInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisLabelInfo, _super);
        function AxisLabelInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.a = 0;
            return _this;
        }
        AxisLabelInfo.$t = i2.markType(AxisLabelInfo, 'AxisLabelInfo');
        return AxisLabelInfo;
    }(i2.Base));

    /**
     * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
    *
    * Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
    */
    var IgxScalerParams = /** @class */ /*@__PURE__*/ (function () {
        function IgxScalerParams() {
        }
        Object.defineProperty(IgxScalerParams.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxScalerParams.prototype.onImplementationCreated = function () {
        };
        IgxScalerParams.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxScalerParams.prototype, "referenceValue", {
            /**
             * The series reference value.
             * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
            */
            get: function () {
                return this.i.b;
            },
            set: function (v) {
                this.i.b = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxScalerParams.prototype.findByName = function (name) {
            return null;
        };
        return IgxScalerParams;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available behaviors for series highlighting depending on distance of mouse on hover operation.
     */
    var HighlightingMode = /*@__PURE__*/ (function (HighlightingMode) {
        /**
         * Specifies the highlight starts on closest element of series
         */
        HighlightingMode[HighlightingMode["Closest"] = 0] = "Closest";
        /**
         * Specifies the highlight starts when directly over element of series
         */
        HighlightingMode[HighlightingMode["DirectlyOver"] = 1] = "DirectlyOver";
        return HighlightingMode;
    })({});
    /**
     * @hidden
     */
    var HighlightingMode_$type = i2.markEnum('HighlightingMode', 'Closest,0|DirectlyOver,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SyncSettingsConverter = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SyncSettingsConverter, _super);
        function SyncSettingsConverter() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SyncSettingsConverter.$t = i2.markType(SyncSettingsConverter, 'SyncSettingsConverter');
        return SyncSettingsConverter;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendLineManagerType_$type = i2.markEnum('TrendLineManagerType', 'Category,0|Sorting,1|Polar,2|Radial,3|Scatter,4');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendLineManagerNames = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrendLineManagerNames, _super);
        function TrendLineManagerNames() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TrendLineManagerNames.$t = i2.markType(TrendLineManagerNames, 'TrendLineManagerNames');
        return TrendLineManagerNames;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes available orientations for an axis.
     */
    var AxisOrientation = /*@__PURE__*/ (function (AxisOrientation) {
        /**
         * Specifies a horizontal axis.
         */
        AxisOrientation[AxisOrientation["Horizontal"] = 0] = "Horizontal";
        /**
         * Specifies a vertical axis.
         */
        AxisOrientation[AxisOrientation["Vertical"] = 1] = "Vertical";
        /**
         * Specifies an angular axis used by the polar series.
         */
        AxisOrientation[AxisOrientation["Angular"] = 2] = "Angular";
        /**
         * Specifies a radial axis used by radial series.
         */
        AxisOrientation[AxisOrientation["Radial"] = 3] = "Radial";
        return AxisOrientation;
    })({});
    /**
     * @hidden
     */
    var AxisOrientation_$type = i2.markEnum('AxisOrientation', 'Horizontal,0|Vertical,1|Angular,2|Radial,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CategoryErrorBarSettings = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CategoryErrorBarSettings, _super);
        function CategoryErrorBarSettings() {
            var _this = _super.call(this) || this;
            _this.p = null;
            _this.propertyUpdated = i2.delegateCombine(_this.propertyUpdated, i2.runOn(_this, _this.ab));
            return _this;
        }
        Object.defineProperty(CategoryErrorBarSettings.prototype, "q", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                this.p = a;
            },
            enumerable: false,
            configurable: true
        });
        CategoryErrorBarSettings.prototype.ab = function (a, b) {
            switch (b.propertyName) {
                case CategoryErrorBarSettings.$$p[0]:
                    var c = i2.typeCast(i2.IErrorBarCalculator_$type, b.oldValue);
                    if (c != null) {
                        c.changed = i2.delegateRemove(c.changed, i2.runOn(this, this.aa));
                    }
                    if (this.q != null) {
                        this.q.l0(false);
                        if (this.q.ca != null) {
                            this.q.k7();
                        }
                    }
                    var d = i2.typeCast(i2.IErrorBarCalculator_$type, b.newValue);
                    if (d != null) {
                        d.changed = i2.delegateCombine(d.changed, i2.runOn(this, this.aa));
                    }
                    break;
                case CategoryErrorBarSettings.$$p[1]:
                case CategoryErrorBarSettings.$$p[2]:
                case CategoryErrorBarSettings.$$p[3]:
                case CategoryErrorBarSettings.$$p[4]:
                case CategoryErrorBarSettings.$$p[5]:
                    if (this.q != null) {
                        this.q.l0(false);
                        if (this.q.ca != null) {
                            this.q.k7();
                        }
                    }
                    break;
            }
        };
        CategoryErrorBarSettings.prototype.aa = function (a, b) {
            var c = i2.typeCast(i2.IErrorBarCalculator_$type, a);
            if (c != null) {
                c.changed = i2.delegateRemove(c.changed, i2.runOn(this, this.aa));
                if (this.q != null) {
                    this.q.l0(false);
                }
                c.changed = i2.delegateCombine(c.changed, i2.runOn(this, this.aa));
            }
        };
        CategoryErrorBarSettings.$t = i2.markType(CategoryErrorBarSettings, 'CategoryErrorBarSettings', ErrorBarSettingsBase.$);
        CategoryErrorBarSettings.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, CategoryErrorBarSettings, 'l', ['Calculator:r:ac', [i2.IErrorBarCalculator_$type, null], 'EnableErrorBars:o:ad', [EnableErrorBars_$type, i2.enumGetBox(EnableErrorBars_$type, 0)], 'ErrorBarCapLength:t:ae', [1, 6], 'ErrorBarStyle:aj:af', [i2.Style.$, null], 'Stroke:ai:ag', [i2.Brush.$, null], 'StrokeThickness:s:ah', [1, 1]]);
        return CategoryErrorBarSettings;
    }(ErrorBarSettingsBase));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Describes actual shape of legend badge that represents a series in a legend
     */
    var ActualLegendItemBadgeShape = /*@__PURE__*/ (function (ActualLegendItemBadgeShape) {
        /**
         * Specifies a circle shape in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["CircleShape"] = 0] = "CircleShape";
        /**
         * Specifies a thin line with overlaid marker in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["LineWithMarker"] = 1] = "LineWithMarker";
        /**
         * Specifies a thin line without overlaid marker in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["LineMarkerless"] = 2] = "LineMarkerless";
        /**
         * Specifies a thick horizontal bar shape in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["BarShape"] = 3] = "BarShape";
        /**
         * Specifies a thick vertical column shape in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["ColumnShape"] = 4] = "ColumnShape";
        /**
         * Specifies standard square shape in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["SquareShape"] = 5] = "SquareShape";
        /**
         * Specifies financial square shape in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["SquareFinancial"] = 6] = "SquareFinancial";
        /**
         * Specifies indicator square shape in a legend
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["SquareIndicator"] = 7] = "SquareIndicator";
        /**
         * Specifies marker shape in a legend as long as the series supports markers
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["MarkerShape"] = 8] = "MarkerShape";
        /**
         * Specifies hidden shape without any adjustment to the series title
         */
        ActualLegendItemBadgeShape[ActualLegendItemBadgeShape["HiddenShape"] = 9] = "HiddenShape";
        return ActualLegendItemBadgeShape;
    })({});
    /**
     * @hidden
     */
    var ActualLegendItemBadgeShape_$type = i2.markEnum('ActualLegendItemBadgeShape', 'CircleShape,0|LineWithMarker,1|LineMarkerless,2|BarShape,3|ColumnShape,4|SquareShape,5|SquareFinancial,6|SquareIndicator,7|MarkerShape,8|HiddenShape,9');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Used to indicate the orientation of the legend
     */
    var LegendOrientation = /*@__PURE__*/ (function (LegendOrientation) {
        /**
         */
        LegendOrientation[LegendOrientation["Horizontal"] = 0] = "Horizontal";
        /**
         */
        LegendOrientation[LegendOrientation["Vertical"] = 1] = "Vertical";
        return LegendOrientation;
    })({});
    /**
     * @hidden
     */
    var LegendOrientation_$type = i2.markEnum('LegendOrientation', 'Horizontal,0|Vertical,1');

    /**
     * Represents a legend in a IgxDataChartComponent control.
    *
    * The `IgxLegendComponent` helps end-user identify visuals of chart series with contextual information related to the data plotted in the chart control.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data"
    * 	 [legend]="legend">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    *  <igx-legend #legend></igx-legend>
    * ```
    *
    * ```ts
    * public legend : IgxLegendComponent;
    * ```
    */
    var IgxLegendComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxLegendComponent, _super);
        function IgxLegendComponent(renderer, elRef, ngZone) {
            var _this = _super.call(this) || this;
            _this.renderer = renderer;
            _this.elRef = elRef;
            _this.ngZone = ngZone;
            _this._zoneRunner = function (act) { return _this.ngZone.run(act); };
            _this.container = renderer.createElement("div");
            renderer.appendChild(elRef.nativeElement, _this.container);
            var root;
            root = _this.container;
            if (_this.container != null) {
                root = _this.container;
            }
            var ren = new i2.AngularRenderer(root, _this.renderer, window.document, _this.ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            _this.i.provideContainer(ren);
            return _this;
        }
        IgxLegendComponent.prototype.ngOnDestroy = function () {
            this._wrapper.destroy();
            this.i.provideContainer(null);
        };
        IgxLegendComponent.prototype.createImplementation = function () {
            return new Legend();
        };
        Object.defineProperty(IgxLegendComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendComponent.prototype, "orientation", {
            /**
         * Gets or sets the current Legend object's orientation.
        */
            get: function () {
                return this.i.bb;
            },
            set: function (v) {
                this.i.bb = i2.ensureEnum(LegendOrientation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendComponent.prototype, "textColor", {
            /**
             * Gets or sets color of text
            */
            get: function () {
                return this.i.bh;
            },
            set: function (v) {
                this.i.bh = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendComponent.prototype, "textStyle", {
            /**
             * Gets or sets style of text.
            */
            get: function () {
                return this.i.bi;
            },
            set: function (v) {
                this.i.bi = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxLegendComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
        IgxLegendComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxLegendComponent, selector: "igx-legend", inputs: { orientation: "orientation", textColor: "textColor", textStyle: "textStyle" }, host: { classAttribute: "ig-legend igx-legend" }, providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxLegendComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, styles: [":host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxLegendComponent;
    }(IgxLegendBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-legend',
                        template: "",
                        providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxLegendComponent; }) }],
                        host: { 'class': 'ig-legend igx-legend' },
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        styles: [":host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: i0.NgZone }]; }, propDecorators: { orientation: [{
                    type: i0.Input
                }], textColor: [{
                    type: i0.Input
                }], textStyle: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLegendModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLegendModule() {
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        }
        IgxLegendModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLegendModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendModule, declarations: [IgxLegendComponent], imports: [i1.CommonModule], exports: [IgxLegendComponent] });
        IgxLegendModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendModule, imports: [[i1.CommonModule,
                ]] });
        return IgxLegendModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxLegendComponent],
                        exports: [IgxLegendComponent
                        ],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLegendDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLegendDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxLegendComponent', IgxLegendComponent);
            i2.TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        }
        IgxLegendDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLegendDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendDynamicModule, imports: [i1.CommonModule, IgxLegendModule], exports: [IgxLegendModule] });
        IgxLegendDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendDynamicModule, imports: [[i1.CommonModule, IgxLegendModule
                ], IgxLegendModule] });
        return IgxLegendDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLegendDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxLegendModule
                        ],
                        imports: [i1.CommonModule, IgxLegendModule
                        ],
                        entryComponents: [IgxLegendComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ItemLegend = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemLegend, _super);
        function ItemLegend() {
            var _this = _super.call(this) || this;
            _this.bb = null;
            _this.bd = null;
            _this.ab = ItemLegend.$;
            _this.bb = _this.ak;
            var a = _this.at;
            a.collectionChanged = i2.delegateCombine(a.collectionChanged, function (a, b) {
                var e_1, _a, e_2, _b;
                if (b.oldItems != null) {
                    try {
                        for (var _c = tslib.__values(i2.fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var c = _d.value;
                            _this.bb.an(c);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
                if (b.newItems != null) {
                    try {
                        for (var _e = tslib.__values(i2.fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var d = _f.value;
                            _this.bb.x(d);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                }
            });
            return _this;
        }
        ItemLegend.prototype.aj = function () {
            return new ItemLegendView(this);
        };
        ItemLegend.prototype.a8 = function (a) {
            _super.prototype.a8.call(this, a);
            this.bb = a;
        };
        ItemLegend.prototype.addChildInOrder = function (a, b) {
            if (!this.ak.m()) {
                return;
            }
            this.bi(b);
        };
        ItemLegend.prototype.get_isItemwise = function () {
            return true;
        };
        ItemLegend.prototype.createItemwiseLegendItems = function (a, b) {
            this.a0(a, b);
        };
        ItemLegend.prototype.a0 = function (a, b) {
            var e_3, _a;
            this.ak.af();
            this.clearLegendItemsForSeries(b);
            if (b == null || a == null || a.count == 0) {
                return;
            }
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = i2.typeCast(i2.ContentControl.$, c);
                    if (d != null && d.content != null) {
                        var e = i2.typeCast(i2.ILegendContext_$type, d.content);
                        if (e != null && !this.be(e)) {
                            this.at.add(c);
                            var f = new LegendItemInfo();
                            f.b = e;
                            f.c = c;
                            f.a = b;
                            if (e.legendLabel != null) {
                                f.d = e.legendLabel;
                            }
                            else {
                                f.d = e.itemLabel;
                            }
                        }
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            this.ak.ag();
        };
        ItemLegend.prototype.createLegendItemsInsert = function (a, b) {
            this.bh(a, b);
        };
        ItemLegend.prototype.bh = function (a, b) {
            var e_4, _a;
            this.ak.af();
            try {
                var c = this.bf(b);
                if (b == null || a == null || a.count == 0) {
                    return;
                }
                try {
                    for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        var e = i2.typeCast(i2.ContentControl.$, d);
                        if (e != null && e.content != null) {
                            var f = i2.typeCast(i2.ILegendContext_$type, e.content);
                            if (f != null && !this.be(f)) {
                                this.at.insert(c, d);
                                c++;
                                var g = new LegendItemInfo();
                                g.b = f;
                                g.c = d;
                                g.a = b;
                                g.d = f.legendLabel != null ? f.legendLabel.toString() : f.itemLabel;
                            }
                        }
                    }
                }
                catch (e_4_1) {
                    e_4 = { error: e_4_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_4)
                            throw e_4.error;
                    }
                }
            }
            finally {
                this.ak.ag();
            }
        };
        ItemLegend.prototype.renderItemwiseContent = function (a) {
            this.bi(a);
        };
        ItemLegend.prototype.bi = function (a) {
            var _this = this;
            this.clearLegendItemsForSeries(a);
            if (a.hasSubItems) {
                a.forSubItems(function (b) {
                    var c = i2.typeCast(i2.ContentControl.$, b);
                    if (c != null && c.content != null) {
                        var d = i2.typeCast(i2.ILegendContext_$type, c.content);
                        if (d != null && !_this.be(d)) {
                            _this.at.add(b);
                            var e = new LegendItemInfo();
                            e.b = d;
                            e.c = b;
                            e.a = a;
                            e.d = d.itemLabel;
                        }
                    }
                });
            }
        };
        ItemLegend.prototype.bf = function (a) {
            var e_5, _a, e_6, _b;
            if (a == null || this.at == null || this.at.count == 0) {
                return 0;
            }
            var b = new i2.ObservableCollection$1(i2.UIElement.$, 0);
            var c = -1;
            var d = 0;
            try {
                for (var _c = tslib.__values(i2.fromEnum(this.at)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    var f = i2.typeCast(i2.ContentControl.$, e);
                    if (f != null && f.content != null) {
                        var g = i2.typeCast(i2.ILegendContext_$type, f.content);
                        if (g != null && g.series == a) {
                            if (c == -1) {
                                c = d;
                            }
                            b.add(e);
                        }
                    }
                    d++;
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var h = _f.value;
                    this.at.remove(h);
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            if (c == -1) {
                return this.at.count;
            }
            return c;
        };
        ItemLegend.prototype.be = function (a) {
            return this.bb.ap(a);
        };
        Object.defineProperty(ItemLegend.prototype, "bc", {
            get: function () {
                return this.ak.k ? 0 : 1;
            },
            set: function (a) {
                this.ak.k = a == 0;
            },
            enumerable: false,
            configurable: true
        });
        ItemLegend.$t = i2.markType(ItemLegend, 'ItemLegend', LegendBase.$, [i2.IChartItemLegend_$type]);
        return ItemLegend;
    }(LegendBase));
    /**
     * @hidden
     */
    var ItemLegendView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ItemLegendView, _super);
        function ItemLegendView(a) {
            var _this = _super.call(this, a) || this;
            _this.ao = null;
            _this.ao = a;
            return _this;
        }
        ItemLegendView.prototype.ak = function () {
            _super.prototype.ak.call(this);
        };
        ItemLegendView.prototype.get_j = function () {
            return true;
        };
        ItemLegendView.prototype.ap = function (a) {
            return this.c.e(a);
        };
        ItemLegendView.prototype.f = function () {
            var a = new LegendVisualData();
            var b = this.c.g.rootWrapper;
            b = b.getChildAt(0);
            var c = b.getChildCount();
            for (var d = 0; d < c; d++) {
                var e = new LegendItemVisualData();
                var f = b.getChildAt(d);
                e.label = f.getText();
                e.label = e.label != null ? e.label.trim() : null;
                e.bounds = new i2.RectData(f.getOffset().left, f.getOffset().top, f.width(), f.height());
                e.labelBounds = this.h(f);
                e.badgeBounds = this.g(f);
                a.items.add(e);
            }
            for (var g = 0; g < c; g++) {
                a.items._inner[g].appearance.fill = this.a(g);
            }
            return a;
        };
        ItemLegendView.$t = i2.markType(ItemLegendView, 'ItemLegendView', LegendBaseView.$);
        return ItemLegendView;
    }(LegendBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a legend that displays an item for each point in the series.
    *
    * You can use the `IgxItemLegendComponent` to display a legend item for each data member bound to the `IgxBubbleSeriesComponent`
    */
    var IgxItemLegendComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxItemLegendComponent, _super);
        function IgxItemLegendComponent(renderer, elRef, ngZone) {
            var _this = _super.call(this) || this;
            _this.renderer = renderer;
            _this.elRef = elRef;
            _this.ngZone = ngZone;
            _this._zoneRunner = function (act) { return _this.ngZone.run(act); };
            _this.container = renderer.createElement("div");
            renderer.appendChild(elRef.nativeElement, _this.container);
            var root;
            root = _this.container;
            if (_this.container != null) {
                root = _this.container;
            }
            var ren = new i2.AngularRenderer(root, _this.renderer, window.document, _this.ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            _this.i.provideContainer(ren);
            return _this;
        }
        IgxItemLegendComponent.prototype.ngOnDestroy = function () {
            this._wrapper.destroy();
            this.i.provideContainer(null);
        };
        IgxItemLegendComponent.prototype.createImplementation = function () {
            return new ItemLegend();
        };
        Object.defineProperty(IgxItemLegendComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxItemLegendComponent.prototype.createItemwiseLegendItems = function (legendItems, series) {
            this.i.createItemwiseLegendItems(legendItems, series);
        };
        IgxItemLegendComponent.prototype.exportVisualData = function () {
            return this.i.exportVisualData();
        };
        IgxItemLegendComponent.prototype.exportSerializedVisualData = function () {
            return this.i.exportSerializedVisualData();
        };
        Object.defineProperty(IgxItemLegendComponent.prototype, "isItemwise", {
            /**
         * Gets whether or not this legend supports itemwise visuals
        */
            get: function () {
                return this.i.isItemwise;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxItemLegendComponent.prototype, "orientation", {
            /**
             * Gets or sets the current Legend object's orientation.
            */
            get: function () {
                return this.i.bc;
            },
            set: function (v) {
                this.i.bc = i2.ensureEnum(LegendOrientation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxItemLegendComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
        IgxItemLegendComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxItemLegendComponent, selector: "igx-item-legend", inputs: { orientation: "orientation" }, host: { classAttribute: "ig-item-legend igx-item-legend" }, providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxItemLegendComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, styles: [":host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxItemLegendComponent;
    }(IgxLegendBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-item-legend',
                        template: "",
                        host: { 'class': 'ig-item-legend igx-item-legend' },
                        providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxItemLegendComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        styles: [":host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: i0.NgZone }]; }, propDecorators: { orientation: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxItemLegendModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxItemLegendModule() {
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        }
        IgxItemLegendModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxItemLegendModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendModule, declarations: [IgxItemLegendComponent], imports: [i1.CommonModule], exports: [IgxItemLegendComponent] });
        IgxItemLegendModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendModule, imports: [[i1.CommonModule,
                ]] });
        return IgxItemLegendModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxItemLegendComponent],
                        exports: [IgxItemLegendComponent
                        ],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxItemLegendDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxItemLegendDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxItemLegendComponent', IgxItemLegendComponent);
            i2.TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        }
        IgxItemLegendDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxItemLegendDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendDynamicModule, imports: [i1.CommonModule, IgxItemLegendModule], exports: [IgxItemLegendModule] });
        IgxItemLegendDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendDynamicModule, imports: [[i1.CommonModule, IgxItemLegendModule
                ], IgxItemLegendModule] });
        return IgxItemLegendDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxItemLegendDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxItemLegendModule
                        ],
                        imports: [i1.CommonModule, IgxItemLegendModule
                        ],
                        entryComponents: [IgxItemLegendComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var GradientStopData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(GradientStopData, _super);
        function GradientStopData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = 0;
            _this.b = null;
            return _this;
        }
        GradientStopData.$t = i2.markType(GradientStopData, 'GradientStopData');
        return GradientStopData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var GradientData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(GradientData, _super);
        function GradientData() {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.a = new i2.List$1(GradientStopData.$, 0);
            return _this;
        }
        GradientData.prototype.b = function () {
            this.a.aa(function (a, b) { return i2.Base.compareSimple(a.a, b.a); });
        };
        GradientData.$t = i2.markType(GradientData, 'GradientData');
        return GradientData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ScaleLegend = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScaleLegend, _super);
        function ScaleLegend() {
            var _this = _super.call(this) || this;
            _this.bd = null;
            _this.bf = 0;
            _this.be = 0;
            _this.bb = null;
            _this.ab = ScaleLegend.$;
            return _this;
        }
        ScaleLegend.prototype.aj = function () {
            return new ScaleLegendView(this);
        };
        ScaleLegend.prototype.a8 = function (a) {
            _super.prototype.a8.call(this, a);
            this.bd = a;
        };
        Object.defineProperty(ScaleLegend.prototype, "legendScaleElement", {
            get: function () {
                return this.bd.ba;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScaleLegend.prototype, "minText", {
            get: function () {
                return this.bd.a6;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScaleLegend.prototype, "maxText", {
            get: function () {
                return this.bd.a5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ScaleLegend.prototype, "bc", {
            get: function () {
                return this.bb;
            },
            set: function (a) {
                this.bb = a;
            },
            enumerable: false,
            configurable: true
        });
        ScaleLegend.prototype.bi = function () {
            this.bd.a2();
        };
        ScaleLegend.prototype.restoreOriginalState = function () {
            this.bi();
        };
        ScaleLegend.prototype.bl = function (a) {
            if (a == null) {
                return this.bd.a9();
            }
            return i2.ColorUtil.t(a);
        };
        ScaleLegend.prototype.bg = function (a) {
            this.bc = a;
            this.bh();
        };
        ScaleLegend.prototype.initializeLegend = function (a) {
            this.bg(a);
        };
        ScaleLegend.prototype.get_isScale = function () {
            return true;
        };
        ScaleLegend.prototype.bh = function () {
            var _this = this;
            if (this.legendScaleElement == null || this.bc == null || !this.bc.legendReady) {
                return;
            }
            if (this.bc == null || !this.bc.isAttachedTo(this)) {
                return;
            }
            var a = false;
            var b = i2.typeCast(i2.Shape.$, this.legendScaleElement);
            if (b != null) {
                var c_1 = this.bd.aw();
                if (!this.bc.forScaleColors(function (d, e) { return _this.bd.ay(c_1, _this.bl(d), e); })) {
                    a = true;
                }
                this.bd.a3(b, a, c_1);
            }
            if (this.minText != null) {
                this.minText.ak = this.bc.minScaleText;
            }
            if (this.maxText != null) {
                this.maxText.ak = this.bc.maxScaleText;
            }
        };
        ScaleLegend.$t = i2.markType(ScaleLegend, 'ScaleLegend', LegendBase.$, [i2.IChartScaleLegend_$type]);
        return ScaleLegend;
    }(LegendBase));
    /**
     * @hidden
     */
    var ScaleLegendView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ScaleLegendView, _super);
        function ScaleLegendView(a) {
            var _this = _super.call(this, a) || this;
            _this.ap = null;
            _this.ba = null;
            _this.a6 = null;
            _this.a5 = null;
            _this.ao = null;
            _this.aq = null;
            _this.bb = new i2.Size();
            _this.ar = false;
            _this.as = 0;
            _this.a8 = null;
            _this.a7 = null;
            _this.ap = a;
            _this.a6 = new i2.TextBlock();
            _this.a5 = new i2.TextBlock();
            _this.ba = new i2.Polygon();
            return _this;
        }
        ScaleLegendView.prototype.a2 = function () {
        };
        ScaleLegendView.prototype.z = function () {
        };
        ScaleLegendView.prototype.a9 = function () {
            return i2.Color.u(0, 0, 0, 0);
        };
        ScaleLegendView.prototype.aw = function () {
            return new GradientData();
        };
        ScaleLegendView.prototype.ay = function (a, b, c) {
            var d = a;
            d.a.add(((function () {
                var $ret = new GradientStopData();
                $ret.b = ((function () {
                    var $ret = new i2.Brush();
                    $ret.color = b;
                    return $ret;
                })());
                $ret.a = c;
                return $ret;
            })()));
        };
        ScaleLegendView.prototype.a3 = function (a, b, c) {
            if (b) {
                this.a7 = this.ap.bc.actualMarkerBrush;
                this.ao = null;
            }
            else {
                this.a7 = null;
                this.ao = c;
                this.ao.b();
            }
            this.az();
        };
        ScaleLegendView.prototype.ai = function (a) {
            _super.prototype.ai.call(this, a);
            this.aq = this.c.b(a);
            this.bb = this.c.ab();
            this.az();
        };
        ScaleLegendView.prototype.az = function () {
            if (!this.ar) {
                this.ar = true;
                if (this.c.g != null) {
                    this.c.g.setTimeout(i2.runOn(this, this.a4), 0);
                }
                else {
                    window.setTimeout(i2.runOn(this, this.a4), 0);
                }
            }
        };
        ScaleLegendView.prototype.a4 = function () {
            if (this.ar) {
                this.ar = false;
                this.a1();
            }
        };
        ScaleLegendView.prototype.a1 = function () {
            if (this.aq == null) {
                return;
            }
            this.a0();
        };
        ScaleLegendView.prototype.au = function (a) {
            var b = i2.typeCast(i2.TextBlock.$, a);
            if (b != null && b.ak != null) {
                return this.aq.e(b) + 0;
            }
            return 0;
        };
        ScaleLegendView.prototype.at = function (a) {
            return this.as + 0;
        };
        ScaleLegendView.prototype.a0 = function () {
            if (this.ap.bc == null || this.ap.bc.container == null || (this.ao == null && this.a7 == null)) {
                return;
            }
            if (this.aq.d) {
                var a = i2.typeCast(i2.IInternalLegendOwner_$type, this.ap.bc.container);
                this.aq.ac(a.getFontInfo());
                this.as = a.getFontHeight();
                this.a8 = a.getFontBrush();
                var b = this.au(this.a6);
                var c = this.au(this.a5);
                var d = Math.max(b, c) + 4;
                if (d >= this.bb.width) {
                    d = 0;
                }
                var e = this.bb.width - d;
                var f = 2;
                var g = 2;
                e = e - 4;
                var h = this.bb.height - 4;
                var i = f + e + 4;
                var j = g;
                var k = h;
                var l = { $type: i2.Point_$type, x: f + (3 / 5) * e, y: g };
                var m = { $type: i2.Point_$type, x: f + (5 / 5) * e, y: g };
                var n = { $type: i2.Point_$type, x: f + (5 / 5) * e, y: h };
                var o = { $type: i2.Point_$type, x: f, y: h };
                var p = this.ba;
                p.ak.clear();
                p.ak.add(l);
                p.ak.add(m);
                p.ak.add(n);
                p.ak.add(o);
                this.a6.n = i;
                this.a6.o = j;
                this.a6.am = this.a8;
                this.a5.n = i;
                this.a5.o = j + k - (this.at(this.a6));
                this.a5.am = this.a8;
                this.aq.k(0, 0, this.bb.width, this.bb.height);
                if (this.ao == null && this.a7 != null) {
                    p._fill = this.a7;
                    this.aq.t(p);
                }
                else {
                    this.c.y(this.aq, p, this.ao, new i2.Rect(0, g, f, e, h));
                }
                if (d > 0) {
                    this.aq.w(this.a6);
                    this.aq.w(this.a5);
                }
            }
        };
        ScaleLegendView.prototype.al = function () {
            _super.prototype.al.call(this);
        };
        ScaleLegendView.$t = i2.markType(ScaleLegendView, 'ScaleLegendView', LegendBaseView.$);
        return ScaleLegendView;
    }(LegendBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a legend that indicates the size and the color scale for a collection of series.
    */
    var IgxScaleLegendComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxScaleLegendComponent, _super);
        function IgxScaleLegendComponent() {
            return _super.call(this) || this;
        }
        IgxScaleLegendComponent.prototype.createImplementation = function () {
            return new ScaleLegend();
        };
        Object.defineProperty(IgxScaleLegendComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxScaleLegendComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxScaleLegendComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxScaleLegendComponent, selector: "igx-scale-legend", providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxScaleLegendComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxScaleLegendComponent;
    }(IgxLegendBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-scale-legend',
                        template: "",
                        providers: [{ provide: IgxLegendBaseComponent, useExisting: i0.forwardRef(function () { return IgxScaleLegendComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScaleLegendModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScaleLegendModule() {
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        }
        IgxScaleLegendModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScaleLegendModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendModule, declarations: [IgxScaleLegendComponent], imports: [i1.CommonModule], exports: [IgxScaleLegendComponent] });
        IgxScaleLegendModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendModule, imports: [[i1.CommonModule,
                ]] });
        return IgxScaleLegendModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxScaleLegendComponent],
                        exports: [IgxScaleLegendComponent
                        ],
                        imports: [i1.CommonModule,
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxScaleLegendDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxScaleLegendDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxScaleLegendComponent', IgxScaleLegendComponent);
            i2.TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
            i2.TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        }
        IgxScaleLegendDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxScaleLegendDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendDynamicModule, imports: [i1.CommonModule, IgxScaleLegendModule], exports: [IgxScaleLegendModule] });
        IgxScaleLegendDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendDynamicModule, imports: [[i1.CommonModule, IgxScaleLegendModule
                ], IgxScaleLegendModule] });
        return IgxScaleLegendDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxScaleLegendDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxScaleLegendModule
                        ],
                        imports: [i1.CommonModule, IgxScaleLegendModule
                        ],
                        entryComponents: [IgxScaleLegendComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * Provides data for legend mouse button related events.
    */
    var IgxLegendMouseEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxLegendMouseEventArgs() {
        }
        Object.defineProperty(IgxLegendMouseEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxLegendMouseEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxLegendMouseEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxLegendMouseEventArgs.prototype, "originalSource", {
            /**
             * Gets a reference to the object that raised the event.
            */
            get: function () {
                return this.i.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseEventArgs.prototype, "item", {
            /**
             * Gets the ItemsSource item associated with the current event.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseEventArgs.prototype, "series", {
            /**
             * Gets the series associated with the current event.
            */
            get: function () {
                return this.i.series;
            },
            set: function (v) {
                this.i.series = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseEventArgs.prototype, "chart", {
            /**
             * Gets the Chart associated with the current event.
            */
            get: function () {
                return this.i.chart;
            },
            set: function (v) {
                this.i.chart = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseEventArgs.prototype, "legendItem", {
            /**
             * The legend item in context.
            */
            get: function () {
                return this.i.legendItem;
            },
            set: function (v) {
                this.i.legendItem = v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Provides a human readable description of the mouse button event.
        
        */
        IgxLegendMouseEventArgs.prototype.toString = function () {
            var iv = this.i.toString();
            return (iv);
        };
        return IgxLegendMouseEventArgs;
    }());

    /**
     * Provides data for legend mouse button related events.
    */
    var IgxLegendMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxLegendMouseButtonEventArgs() {
        }
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxLegendMouseButtonEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxLegendMouseButtonEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "handled", {
            /**
             * Gets or sets a value that indicates the present state of the event handling for a routed
             * event as it travels the route.
             * ChartMouseButton events are not routed events; setting this property effects the underlying
             * MouseButtonEvent.
            */
            get: function () {
                return this.i.handled;
            },
            set: function (v) {
                this.i.handled = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "originalSource", {
            /**
             * Gets a reference to the object that raised the event.
            */
            get: function () {
                return this.i.originalSource;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "item", {
            /**
             * Gets the ItemsSource item associated with the current event.
            */
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "series", {
            /**
             * Gets the series associated with the current event.
            */
            get: function () {
                return this.i.series;
            },
            set: function (v) {
                this.i.series = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "chart", {
            /**
             * Gets the Chart associated with the current event.
            */
            get: function () {
                return this.i.chart;
            },
            set: function (v) {
                this.i.chart = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLegendMouseButtonEventArgs.prototype, "legendItem", {
            /**
             * The legend item that was the target of the mouse event.
            */
            get: function () {
                return this.i.legendItem;
            },
            set: function (v) {
                this.i.legendItem = v;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Provides a human readable description of the mouse button event.
        
        */
        IgxLegendMouseButtonEventArgs.prototype.toString = function () {
            var iv = this.i.toString();
            return (iv);
        };
        return IgxLegendMouseButtonEventArgs;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Contains PieChart label click event data.
    */
    var IgxLabelClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxLabelClickEventArgs() {
        }
        Object.defineProperty(IgxLabelClickEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxLabelClickEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxLabelClickEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxLabelClickEventArgs.prototype, "item", {
            /**
             * Gets the slice data context.
            */
            get: function () {
                return this.i.item;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLabelClickEventArgs.prototype, "allowSliceClick", {
            /**
             * Gets and sets whether or not the owning pie chart should fire its SliceClick event
            */
            get: function () {
                return this.i.allowSliceClick;
            },
            set: function (v) {
                this.i.allowSliceClick = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxLabelClickEventArgs;
    }());

    /**
     * Provides data for the SelectedItemChanged event.
    */
    var IgxSelectedItemChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxSelectedItemChangedEventArgs() {
        }
        Object.defineProperty(IgxSelectedItemChangedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxSelectedItemChangedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxSelectedItemChangedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxSelectedItemChangedEventArgs.prototype, "oldItem", {
            /**
             * The previously selected item.
            */
            get: function () {
                return this.i.oldItem;
            },
            set: function (v) {
                this.i.oldItem = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSelectedItemChangedEventArgs.prototype, "newItem", {
            /**
             * The newly selected item.
            */
            get: function () {
                return this.i.newItem;
            },
            set: function (v) {
                this.i.newItem = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxSelectedItemChangedEventArgs;
    }());

    /**
     * Provides data for the SelectedItemChanging event.
    */
    var IgxSelectedItemChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSelectedItemChangingEventArgs, _super);
        function IgxSelectedItemChangingEventArgs() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxSelectedItemChangingEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSelectedItemChangingEventArgs.prototype, "cancel", {
            /**
             * Set this to true in order to stop the SelectedItem from changing.
            */
            get: function () {
                return this.i.cancel;
            },
            set: function (v) {
                this.i.cancel = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxSelectedItemChangingEventArgs;
    }(IgxSelectedItemChangedEventArgs));

    /**
     * Provides data for the SelectedItemsChanged event.
    */
    var IgxSelectedItemsChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxSelectedItemsChangedEventArgs() {
            this._oldItems = null;
            this._newItems = null;
            this._currentItems = null;
        }
        Object.defineProperty(IgxSelectedItemsChangedEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxSelectedItemsChangedEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxSelectedItemsChangedEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxSelectedItemsChangedEventArgs.prototype, "oldItems", {
            /**
             * A list of the previously selected items.
            */
            get: function () {
                if (this._oldItems === null) {
                    var coll = new i2.IgxObjectCollection();
                    var innerColl = this.i.oldItems;
                    if (!innerColl) {
                        innerColl = new i2.ObjectCollection(0);
                    }
                    this._oldItems = coll._fromInner(innerColl);
                    this.i.oldItems = innerColl;
                }
                return this._oldItems;
            },
            set: function (v) {
                if (this._oldItems !== null) {
                    this._oldItems._setSyncTarget(null);
                    this._oldItems = null;
                }
                var coll = new i2.IgxObjectCollection();
                this._oldItems = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Base.$type);
                var innerColl = this.i.oldItems;
                if (!innerColl) {
                    innerColl = new i2.ObjectCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._oldItems._setSyncTarget(syncColl);
                this.i.oldItems = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSelectedItemsChangedEventArgs.prototype, "newItems", {
            /**
             * A list of the items being selected.
            */
            get: function () {
                if (this._newItems === null) {
                    var coll = new i2.IgxObjectCollection();
                    var innerColl = this.i.newItems;
                    if (!innerColl) {
                        innerColl = new i2.ObjectCollection(0);
                    }
                    this._newItems = coll._fromInner(innerColl);
                    this.i.newItems = innerColl;
                }
                return this._newItems;
            },
            set: function (v) {
                if (this._newItems !== null) {
                    this._newItems._setSyncTarget(null);
                    this._newItems = null;
                }
                var coll = new i2.IgxObjectCollection();
                this._newItems = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Base.$type);
                var innerColl = this.i.newItems;
                if (!innerColl) {
                    innerColl = new i2.ObjectCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._newItems._setSyncTarget(syncColl);
                this.i.newItems = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSelectedItemsChangedEventArgs.prototype, "currentItems", {
            /**
             * A list of the current items selected.
            */
            get: function () {
                if (this._currentItems === null) {
                    var coll = new i2.IgxObjectCollection();
                    var innerColl = this.i.currentItems;
                    if (!innerColl) {
                        innerColl = new i2.ObjectCollection(0);
                    }
                    this._currentItems = coll._fromInner(innerColl);
                    this.i.currentItems = innerColl;
                }
                return this._currentItems;
            },
            set: function (v) {
                if (this._currentItems !== null) {
                    this._currentItems._setSyncTarget(null);
                    this._currentItems = null;
                }
                var coll = new i2.IgxObjectCollection();
                this._currentItems = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Base.$type);
                var innerColl = this.i.currentItems;
                if (!innerColl) {
                    innerColl = new i2.ObjectCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._currentItems._setSyncTarget(syncColl);
                this.i.currentItems = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        return IgxSelectedItemsChangedEventArgs;
    }());

    /**
     * Provides data for the SelectedItemsChanging event.
    */
    var IgxSelectedItemsChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxSelectedItemsChangingEventArgs, _super);
        function IgxSelectedItemsChangingEventArgs() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IgxSelectedItemsChangingEventArgs.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSelectedItemsChangingEventArgs.prototype, "cancel", {
            /**
             * Set this to true in order to stop the SelectedItems collection from changing.
            */
            get: function () {
                return this.i.cancel;
            },
            set: function (v) {
                this.i.cancel = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        return IgxSelectedItemsChangingEventArgs;
    }(IgxSelectedItemsChangedEventArgs));

    /**
     * Contains PieChart click event data.
    */
    var IgxSliceEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxSliceEventArgs() {
        }
        Object.defineProperty(IgxSliceEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxSliceEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxSliceEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxSliceEventArgs.prototype, "isSelected", {
            /**
             * Gets or sets whether the slice is selected.
            */
            get: function () {
                return this.i.isSelected;
            },
            set: function (v) {
                this.i.isSelected = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "isExploded", {
            /**
             * Gets or sets whether the slice is exploded.
            */
            get: function () {
                return this.i.isExploded;
            },
            set: function (v) {
                this.i.isExploded = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "isOthersSlice", {
            /**
             * Gets whether the current slice is part of the others slice.
            */
            get: function () {
                return this.i.isOthersSlice;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "index", {
            /**
             * Gets the index of the slice that was clicked.
            */
            get: function () {
                return this.i.index;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "origin", {
            /**
             * Gets the origin location of the slice.
            */
            get: function () {
                return i2.fromPoint(this.i.origin);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "radius", {
            /**
             * Gets the radius of the slice.
            */
            get: function () {
                return this.i.radius;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "bounds", {
            /**
             * Gets the bounds of the slice.
            */
            get: function () {
                return i2.fromRect(this.i.bounds);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "startAngle", {
            /**
             * Gets the start angle of the slice.
            */
            get: function () {
                return this.i.startAngle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "endAngle", {
            /**
             * Gets the end angle of the slice.
            */
            get: function () {
                return this.i.endAngle;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "fill", {
            /**
             * Gets the fill color of the slice.
            */
            get: function () {
                return i2.brushToString(this.i.fill);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "outline", {
            /**
             * Gets the outline color of the slice.
            */
            get: function () {
                return i2.brushToString(this.i.outline);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "dataContext", {
            /**
             * Gets the slice data context.
            */
            get: function () {
                return this.i.dataContext;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSliceEventArgs.prototype, "originalEvent", {
            /**
             * Holds a reference to the original event that triggered slice click.
            */
            get: function () {
                return this.i.originalEvent;
            },
            set: function (v) {
                this.i.originalEvent = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxSliceEventArgs;
    }());

    /**
     * Represents the base class for the pie chart.
    */
    var IgxPieChartBaseComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxPieChartBaseComponent() {
            this._explodedSlices = null;
            this._selectedItems = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._labelClick = null;
            this._selectedItemChanging = null;
            this._selectedItemsChanging = null;
            this._selectedItemChanged = null;
            this._selectedItemsChanged = null;
            this._sliceClick = null;
            this._sliceEnter = null;
            this._sliceLeave = null;
            this._sliceHover = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxPieChartBaseComponent.prototype.createImplementation = function () {
            return null;
        };
        IgxPieChartBaseComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxPieChartBaseComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxPieChartBaseComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "innerExtent", {
            /**
             * Gets or sets the amount of space between the center and the start of the arc. This property should be set between 0 and 1.
             * If InnerExtent is set to a value greater than 1, it will be interpreted as a percentage, effectively divided by 100.
            */
            get: function () {
                return this.i.c7;
            },
            set: function (v) {
                this.i.c7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "valueMemberPath", {
            /**
             * Gets or Sets the property name that contains the values.
            */
            get: function () {
                return this.i.fq;
            },
            set: function (v) {
                this.i.fq = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelMemberPath", {
            /**
             * Gets or sets the property name that contains the labels.
            */
            get: function () {
                return this.i.ef;
            },
            set: function (v) {
                this.i.ef = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendLabelMemberPath", {
            /**
             * Gets or sets the property name that contains the legend labels.
            */
            get: function () {
                return this.i.eu;
            },
            set: function (v) {
                this.i.eu = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelsPosition", {
            /**
             * Gets or sets the position of chart labels.
            */
            get: function () {
                return this.i.az;
            },
            set: function (v) {
                this.i.az = i2.ensureEnum(LabelsPosition_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelOuterColor", {
            /**
             * Gets or sets the color for labels rendered outside of the pie chart.
            */
            get: function () {
                return i2.brushToString(this.i.iu);
            },
            set: function (v) {
                this.i.iu = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelInnerColor", {
            /**
             * Gets or sets the color for labels rendered inside of the pie chart.
            */
            get: function () {
                return i2.brushToString(this.i.it);
            },
            set: function (v) {
                this.i.it = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "actualLabelOuterColor", {
            /**
             * Gets the actual color for labels rendered outside of the pie chart.
            */
            get: function () {
                return i2.brushToString(this.i.is);
            },
            set: function (v) {
                this.i.is = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "actualLabelInnerColor", {
            /**
             * Gets the actual color for labels rendered inside of the pie chart.
            */
            get: function () {
                return i2.brushToString(this.i.ir);
            },
            set: function (v) {
                this.i.ir = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "leaderLineVisibility", {
            /**
             * Gets or sets whether the leader lines are visible.
            */
            get: function () {
                return this.i.i7;
            },
            set: function (v) {
                this.i.i7 = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "leaderLineType", {
            /**
             * Gets or sets what type of leader lines will be used for the outside end labels.
            */
            get: function () {
                return this.i.a0;
            },
            set: function (v) {
                this.i.a0 = i2.ensureEnum(LeaderLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "leaderLineMargin", {
            /**
             * Gets or sets the margin between a label and the end of its leader line. The default is 6 pixels.
            */
            get: function () {
                return this.i.c9;
            },
            set: function (v) {
                this.i.c9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "toolTip", {
            /**
             * Gets or sets the ToolTip for the chart.
            */
            get: function () {
                return this.i.dn;
            },
            set: function (v) {
                this.i.dn = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryThreshold", {
            /**
             * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
            */
            get: function () {
                return this.i.da;
            },
            set: function (v) {
                this.i.da = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryType", {
            /**
             * Gets or sets whether to use numeric or percent-based threshold value.
            */
            get: function () {
                return this.i.a1;
            },
            set: function (v) {
                this.i.a1 = i2.ensureEnum(OthersCategoryType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryText", {
            /**
             * Gets or sets the label of the Others slice.
            */
            get: function () {
                return this.i.e1;
            },
            set: function (v) {
                this.i.e1 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "explodedRadius", {
            /**
             * Determines how much the exploded slice is offset from the center. Value between 0 and 1.
            */
            get: function () {
                return this.i.c2;
            },
            set: function (v) {
                this.i.c2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "radiusFactor", {
            /**
             * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
            */
            get: function () {
                return this.i.dd;
            },
            set: function (v) {
                this.i.dd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "allowSliceSelection", {
            /**
             * Gets or sets whether the slices can be selected.
            */
            get: function () {
                return this.i.b7;
            },
            set: function (v) {
                this.i.b7 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "allowSliceExplosion", {
            /**
             * Gets or sets whether the slices can be exploded.
            */
            get: function () {
                return this.i.b6;
            },
            set: function (v) {
                this.i.b6 = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "explodedSlices", {
            /**
             * Gets or sets the collection of exploded slice indices.
            */
            get: function () {
                if (this._explodedSlices === null) {
                    var coll = new IgxIndexCollection();
                    var innerColl = this.i.explodedSlices;
                    if (!innerColl) {
                        innerColl = new IndexCollection();
                    }
                    this._explodedSlices = coll._fromInner(innerColl);
                    this.i.explodedSlices = innerColl;
                }
                return this._explodedSlices;
            },
            set: function (v) {
                if (this._explodedSlices !== null) {
                    this._explodedSlices._setSyncTarget(null);
                    this._explodedSlices = null;
                }
                var coll = new IgxIndexCollection();
                this._explodedSlices = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Number_$type);
                var innerColl = this.i.explodedSlices;
                if (!innerColl) {
                    innerColl = new IndexCollection();
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._explodedSlices._setSyncTarget(syncColl);
                this.i.explodedSlices = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelExtent", {
            /**
             * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
            */
            get: function () {
                return this.i.c8;
            },
            set: function (v) {
                this.i.c8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "startAngle", {
            /**
             * Gets or sets the starting angle of the chart.
             * The default zero value is equivalent to 3 o'clock.
            */
            get: function () {
                return this.i.df;
            },
            set: function (v) {
                this.i.df = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "sweepDirection", {
            /**
             * Gets or sets the rotational direction of the chart.
            */
            get: function () {
                return this.i.iw;
            },
            set: function (v) {
                this.i.iw = i2.ensureEnum(i2.SweepDirection_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.i4 ? this.i.i4.fill : null;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.i4.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.i4 ? this.i.i4.stroke : null;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.i4.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.i4 ? this.i.i4.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.i4.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.i4 ? this.i.i4.opacity : NaN;
            },
            set: function (v) {
                this.ensureOthersCategoryStyle();
                this.i.i4.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartBaseComponent.prototype.ensureOthersCategoryStyle = function () {
            if (this.i.i4) {
                return;
            }
            this.i.i4 = new i2.Style();
        };
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedSliceFill", {
            /**
             * Gets or sets the fill brush.
            */
            get: function () {
                return this.i.i5 ? this.i.i5.fill : null;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.i5.fill = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedSliceStroke", {
            /**
             * Gets or sets the stroke brush.
            */
            get: function () {
                return this.i.i5 ? this.i.i5.stroke : null;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.i5.stroke = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedSliceStrokeThickness", {
            /**
             * Gets or sets the stroke thickness.
            */
            get: function () {
                return this.i.i5 ? this.i.i5.strokeThickness : NaN;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.i5.strokeThickness = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedSliceOpacity", {
            /**
             * Gets or sets the opacity.
            */
            get: function () {
                return this.i.i5 ? this.i.i5.opacity : NaN;
            },
            set: function (v) {
                this.ensureSelectedStyle();
                this.i.i5.opacity = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartBaseComponent.prototype.ensureSelectedStyle = function () {
            if (this.i.i5) {
                return;
            }
            this.i.i5 = new i2.Style();
        };
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "brushes", {
            /**
             * Gets or sets the palette of brushes to use for coloring the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.am);
            },
            set: function (v) {
                this.i.am = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "actualBrushes", {
            /**
             * Gets the actual palette of brushes to use for coloring the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.ak);
            },
            set: function (v) {
                this.i.ak = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "outlines", {
            /**
             * Gets or sets the palette of brushes to use for outlines on the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.an);
            },
            set: function (v) {
                this.i.an = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "actualOutlines", {
            /**
             * Gets the actual palette of brushes to use for outlines on the slices.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.al);
            },
            set: function (v) {
                this.i.al = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.eb;
            },
            set: function (v) {
                this.i.eb = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LabelFormat string.
            */
            get: function () {
                return this.i.ag;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ag = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersLabelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.e5;
            },
            set: function (v) {
                this.i.e5 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the OthersLabelFormat string.
            */
            get: function () {
                return this.i.aj;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.aj = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendLabelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.er;
            },
            set: function (v) {
                this.i.er = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LegendLabelFormat string.
            */
            get: function () {
                return this.i.ah;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ah = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendOthersLabelFormat", {
            /**
             * Gets or sets the label format string to use for the label.
            */
            get: function () {
                return this.i.ew;
            },
            set: function (v) {
                this.i.ew = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendOthersLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the LegendOthersLabelFormat string.
            */
            get: function () {
                return this.i.ai;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ai = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendItemTemplate", {
            /**
             * Gets or sets the LegendItemTemplate property.
             * The legend item control content is created according to the LegendItemTemplate on-demand by
             * the chart object itself.
            */
            get: function () {
                return this.i.legendItemTemplate;
            },
            set: function (v) {
                this.i.legendItemTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendItemBadgeTemplate", {
            /**
             * Gets or sets the LegendItemBadgeTemplate property.
             * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
             * the chart object itself.
            */
            get: function () {
                return this.i.legendItemBadgeTemplate;
            },
            set: function (v) {
                this.i.legendItemBadgeTemplate = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "isSurfaceInteractionDisabled", {
            /**
             * Gets or sets whether all surface interactions with the plot area should be disabled.
            */
            get: function () {
                return this.i.cc;
            },
            set: function (v) {
                this.i.cc = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "shouldDisplayMockData", {
            /**
             * Gets or sets whether the pie chart should display mock data when data isn't present.
            */
            get: function () {
                return this.i.ce;
            },
            set: function (v) {
                this.i.ce = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "shouldUseSkeletonStyleForMockData", {
            /**
             * Gets or sets whether the pie chart should use a skeleton style for mock data.
            */
            get: function () {
                return this.i.cf;
            },
            set: function (v) {
                this.i.cf = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "formatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
            */
            get: function () {
                return this.i.a4;
            },
            set: function (v) {
                this.i.a4 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "formatLegendLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
            */
            get: function () {
                return this.i.a5;
            },
            set: function (v) {
                this.i.a5 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.dc;
            },
            set: function (v) {
                this.i.dc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "actualPixelScalingRatio", {
            /**
             * Resolved pixel scaling ratio. Unless explicitly overridden by the PieChartBase.PixelScalingRatio property,
             * this one returns the default ratio enforced by device. High resolution devices will initialize this property
             * to a higher value.
            */
            get: function () {
                return this.i.cz;
            },
            set: function (v) {
                this.i.cz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectionMode", {
            /**
             * Gets or sets which mode to use for selecting slices.
            */
            get: function () {
                return this.i.bi;
            },
            set: function (v) {
                this.i.bi = i2.ensureEnum(SliceSelectionMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItem", {
            /**
             * Gets or sets the currently selected data item.  If a different data item is provided the pie chart
             * will select the slice associated with the new item.
            */
            get: function () {
                return this.i.selectedItem;
            },
            set: function (v) {
                this.i.selectedItem = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItems", {
            /**
             * Gets the currently selected data items.  Adding or removing data items from this collection will
             * select or deselect the slices associated with those items.
            */
            get: function () {
                if (this._selectedItems === null) {
                    var coll = new i2.IgxObjectCollection();
                    var innerColl = this.i.selectedItems;
                    if (!innerColl) {
                        innerColl = new i2.ObjectCollection(0);
                    }
                    this._selectedItems = coll._fromInner(innerColl);
                    this.i.selectedItems = innerColl;
                }
                return this._selectedItems;
            },
            set: function (v) {
                if (this._selectedItems !== null) {
                    this._selectedItems._setSyncTarget(null);
                    this._selectedItems = null;
                }
                var coll = new i2.IgxObjectCollection();
                this._selectedItems = coll._fromOuter(v);
                var syncColl = new i2.SyncableObservableCollection$1(i2.Base.$type);
                var innerColl = this.i.selectedItems;
                if (!innerColl) {
                    innerColl = new i2.ObjectCollection(0);
                }
                syncColl._inner = innerColl;
                syncColl.clear();
                this._selectedItems._setSyncTarget(syncColl);
                this.i.selectedItems = innerColl;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "textStyle", {
            /**
             * Manually overrides the style to use for the labels.
            */
            get: function () {
                return this.i.fl;
            },
            set: function (v) {
                this.i.fl = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartBaseComponent.prototype.findByName = function (name) {
            if (this.legend && this.legend.name && this.legend.name == name) {
                return this.legend;
            }
            if (this.labelFormatSpecifiers != null && i2.arrayFindByName(this.labelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.labelFormatSpecifiers, name);
            }
            if (this.othersLabelFormatSpecifiers != null && i2.arrayFindByName(this.othersLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.othersLabelFormatSpecifiers, name);
            }
            if (this.legendLabelFormatSpecifiers != null && i2.arrayFindByName(this.legendLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.legendLabelFormatSpecifiers, name);
            }
            if (this.legendOthersLabelFormatSpecifiers != null && i2.arrayFindByName(this.legendOthersLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.legendOthersLabelFormatSpecifiers, name);
            }
            return null;
        };
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartBaseComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxPieChartBaseComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("PieChartBaseComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
         * Returns the chart visuals expressed as a serialized string.
        
        */
        IgxPieChartBaseComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.d1();
            return (iv);
        };
        /**
         * Simulates a mouse click action at the specified point.
        
        * @param point  * The point to click at.
        */
        IgxPieChartBaseComponent.prototype.simulateLeftClick = function (point) {
            this.i.g0(i2.toPoint(point));
        };
        /**
         * Invoked by the containing object to provide reference to the container.
        
        * @param container  * Reference to the container.
        */
        IgxPieChartBaseComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        /**
         * Notification from the containing object that the container has been resized.
        
        */
        IgxPieChartBaseComponent.prototype.notifyContainerResized = function () {
            this.i.notifyContainerResized();
        };
        /**
         * Invoked when the instance is being destroyed.
        
        */
        IgxPieChartBaseComponent.prototype.destroy = function () {
            this.i.destroy();
        };
        /**
         * Use to force the pie chart to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the pie chart needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the pie chart.
        
        */
        IgxPieChartBaseComponent.prototype.flush = function () {
            this.i.fv();
        };
        IgxPieChartBaseComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.f4(source_, index, oldItem, newItem);
        };
        /**
         * Manually notifies the pie chart's data source that the data it has bound to has been cleared and needs to be re-examined.
         * This should not be called if the data that the pie chart is bound to is already observable.
        
        * @param source_  * The data source.
        */
        IgxPieChartBaseComponent.prototype.notifyClearItems = function (source_) {
            this.i.f0(source_);
        };
        IgxPieChartBaseComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.f2(source_, index, newItem);
        };
        IgxPieChartBaseComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.f3(source_, index, oldItem);
        };
        /**
         * Assigns data source for the items.
        
        * @param source_  * Array of the data source items.
        */
        IgxPieChartBaseComponent.prototype.setWidgetLevelDataSource = function (source_) {
            this.i.gz(source_);
        };
        /**
         * Resets items data source.
        
        */
        IgxPieChartBaseComponent.prototype.removeWidgetLevelDataSource = function () {
            this.i.gq();
        };
        /**
         * Invoked when style is updated.
        
        */
        IgxPieChartBaseComponent.prototype.styleUpdated = function () {
            this.i.g4();
        };
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelClick", {
            /**
             * Raised when the slice's label is clicked.
            */
            get: function () {
                var _this = this;
                if (this._labelClick == null) {
                    this._labelClick = new i0.EventEmitter();
                    this.i.labelClick = i2.delegateCombine(this.i.labelClick, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxLabelClickEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeLabelClick) {
                                _this.beforeLabelClick(_this, outerArgs);
                            }
                            _this._labelClick.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._labelClick;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemChanging", {
            /**
             * Raised when the SelectedItem property is changing.  This event is cancelable.
            */
            get: function () {
                var _this = this;
                if (this._selectedItemChanging == null) {
                    this._selectedItemChanging = new i0.EventEmitter();
                    this.i.selectedItemChanging = i2.delegateCombine(this.i.selectedItemChanging, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSelectedItemChangingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSelectedItemChanging) {
                                _this.beforeSelectedItemChanging(_this, outerArgs);
                            }
                            _this._selectedItemChanging.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._selectedItemChanging;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemsChanging", {
            /**
             * Raised when the SelectedItems collection is changing.  This event is cancelable.
            */
            get: function () {
                var _this = this;
                if (this._selectedItemsChanging == null) {
                    this._selectedItemsChanging = new i0.EventEmitter();
                    this.i.selectedItemsChanging = i2.delegateCombine(this.i.selectedItemsChanging, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSelectedItemsChangingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSelectedItemsChanging) {
                                _this.beforeSelectedItemsChanging(_this, outerArgs);
                            }
                            _this._selectedItemsChanging.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._selectedItemsChanging;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemChanged", {
            /**
             * Raised when the SelectedItem property has changed.
            */
            get: function () {
                var _this = this;
                if (this._selectedItemChanged == null) {
                    this._selectedItemChanged = new i0.EventEmitter();
                    this.i.selectedItemChanged = i2.delegateCombine(this.i.selectedItemChanged, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSelectedItemChangedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSelectedItemChanged) {
                                _this.beforeSelectedItemChanged(_this, outerArgs);
                            }
                            _this._selectedItemChanged.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._selectedItemChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemsChanged", {
            /**
             * Raised when the SelectedItems collection has changed.
            */
            get: function () {
                var _this = this;
                if (this._selectedItemsChanged == null) {
                    this._selectedItemsChanged = new i0.EventEmitter();
                    this.i.selectedItemsChanged = i2.delegateCombine(this.i.selectedItemsChanged, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSelectedItemsChangedEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSelectedItemsChanged) {
                                _this.beforeSelectedItemsChanged(_this, outerArgs);
                            }
                            _this._selectedItemsChanged.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._selectedItemsChanged;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "sliceClick", {
            /**
             * Raised when the slice is clicked.
            */
            get: function () {
                var _this = this;
                if (this._sliceClick == null) {
                    this._sliceClick = new i0.EventEmitter();
                    this.i.sliceClick = i2.delegateCombine(this.i.sliceClick, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSliceClickEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceClick) {
                                _this.beforeSliceClick(_this, outerArgs);
                            }
                            _this._sliceClick.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceClick;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "sliceEnter", {
            /**
             * Raised when a slice is entered by the pointer.
            */
            get: function () {
                var _this = this;
                if (this._sliceEnter == null) {
                    this._sliceEnter = new i0.EventEmitter();
                    this.i.sliceEnter = i2.delegateCombine(this.i.sliceEnter, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSliceEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceEnter) {
                                _this.beforeSliceEnter(_this, outerArgs);
                            }
                            _this._sliceEnter.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceEnter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "sliceLeave", {
            /**
             * Raised when a slice is left by the pointer;
            */
            get: function () {
                var _this = this;
                if (this._sliceLeave == null) {
                    this._sliceLeave = new i0.EventEmitter();
                    this.i.sliceLeave = i2.delegateCombine(this.i.sliceLeave, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSliceEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceLeave) {
                                _this.beforeSliceLeave(_this, outerArgs);
                            }
                            _this._sliceLeave.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceLeave;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartBaseComponent.prototype, "sliceHover", {
            /**
             * Raised when a pointer moves over a slice.
            */
            get: function () {
                var _this = this;
                if (this._sliceHover == null) {
                    this._sliceHover = new i0.EventEmitter();
                    this.i.sliceHover = i2.delegateCombine(this.i.sliceHover, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxSliceEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeSliceHover) {
                                _this.beforeSliceHover(_this, outerArgs);
                            }
                            _this._sliceHover.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._sliceHover;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartBaseComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxPieChartBaseComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartBaseComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxPieChartBaseComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPieChartBaseComponent, selector: "ng-component", inputs: { innerExtent: "innerExtent", valueMemberPath: "valueMemberPath", labelMemberPath: "labelMemberPath", legendLabelMemberPath: "legendLabelMemberPath", labelsPosition: "labelsPosition", labelOuterColor: "labelOuterColor", labelInnerColor: "labelInnerColor", actualLabelOuterColor: "actualLabelOuterColor", actualLabelInnerColor: "actualLabelInnerColor", leaderLineVisibility: "leaderLineVisibility", leaderLineType: "leaderLineType", leaderLineMargin: "leaderLineMargin", toolTip: "toolTip", othersCategoryThreshold: "othersCategoryThreshold", othersCategoryType: "othersCategoryType", othersCategoryText: "othersCategoryText", explodedRadius: "explodedRadius", radiusFactor: "radiusFactor", allowSliceSelection: "allowSliceSelection", allowSliceExplosion: "allowSliceExplosion", explodedSlices: "explodedSlices", labelExtent: "labelExtent", startAngle: "startAngle", sweepDirection: "sweepDirection", othersCategoryFill: "othersCategoryFill", othersCategoryStroke: "othersCategoryStroke", othersCategoryStrokeThickness: "othersCategoryStrokeThickness", othersCategoryOpacity: "othersCategoryOpacity", selectedSliceFill: "selectedSliceFill", selectedSliceStroke: "selectedSliceStroke", selectedSliceStrokeThickness: "selectedSliceStrokeThickness", selectedSliceOpacity: "selectedSliceOpacity", brushes: "brushes", actualBrushes: "actualBrushes", outlines: "outlines", actualOutlines: "actualOutlines", labelFormat: "labelFormat", labelFormatSpecifiers: "labelFormatSpecifiers", othersLabelFormat: "othersLabelFormat", othersLabelFormatSpecifiers: "othersLabelFormatSpecifiers", legendLabelFormat: "legendLabelFormat", legendLabelFormatSpecifiers: "legendLabelFormatSpecifiers", legendOthersLabelFormat: "legendOthersLabelFormat", legendOthersLabelFormatSpecifiers: "legendOthersLabelFormatSpecifiers", legendItemTemplate: "legendItemTemplate", legendItemBadgeTemplate: "legendItemBadgeTemplate", isSurfaceInteractionDisabled: "isSurfaceInteractionDisabled", shouldDisplayMockData: "shouldDisplayMockData", shouldUseSkeletonStyleForMockData: "shouldUseSkeletonStyleForMockData", formatLabel: "formatLabel", formatLegendLabel: "formatLegendLabel", pixelScalingRatio: "pixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio", selectionMode: "selectionMode", selectedItem: "selectedItem", selectedItems: "selectedItems", textStyle: "textStyle" }, outputs: { labelClick: "labelClick", selectedItemChanging: "selectedItemChanging", selectedItemsChanging: "selectedItemsChanging", selectedItemChanged: "selectedItemChanged", selectedItemsChanged: "selectedItemsChanged", sliceClick: "sliceClick", sliceEnter: "sliceEnter", sliceLeave: "sliceLeave", sliceHover: "sliceHover" }, ngImport: i0, template: "", isInline: true });
        return IgxPieChartBaseComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartBaseComponent, decorators: [{
                type: i0.Component,
                args: [{
                        template: "",
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { innerExtent: [{
                    type: i0.Input
                }], valueMemberPath: [{
                    type: i0.Input
                }], labelMemberPath: [{
                    type: i0.Input
                }], legendLabelMemberPath: [{
                    type: i0.Input
                }], labelsPosition: [{
                    type: i0.Input
                }], labelOuterColor: [{
                    type: i0.Input
                }], labelInnerColor: [{
                    type: i0.Input
                }], actualLabelOuterColor: [{
                    type: i0.Input
                }], actualLabelInnerColor: [{
                    type: i0.Input
                }], leaderLineVisibility: [{
                    type: i0.Input
                }], leaderLineType: [{
                    type: i0.Input
                }], leaderLineMargin: [{
                    type: i0.Input
                }], toolTip: [{
                    type: i0.Input
                }], othersCategoryThreshold: [{
                    type: i0.Input
                }], othersCategoryType: [{
                    type: i0.Input
                }], othersCategoryText: [{
                    type: i0.Input
                }], explodedRadius: [{
                    type: i0.Input
                }], radiusFactor: [{
                    type: i0.Input
                }], allowSliceSelection: [{
                    type: i0.Input
                }], allowSliceExplosion: [{
                    type: i0.Input
                }], explodedSlices: [{
                    type: i0.Input
                }], labelExtent: [{
                    type: i0.Input
                }], startAngle: [{
                    type: i0.Input
                }], sweepDirection: [{
                    type: i0.Input
                }], othersCategoryFill: [{
                    type: i0.Input
                }], othersCategoryStroke: [{
                    type: i0.Input
                }], othersCategoryStrokeThickness: [{
                    type: i0.Input
                }], othersCategoryOpacity: [{
                    type: i0.Input
                }], selectedSliceFill: [{
                    type: i0.Input
                }], selectedSliceStroke: [{
                    type: i0.Input
                }], selectedSliceStrokeThickness: [{
                    type: i0.Input
                }], selectedSliceOpacity: [{
                    type: i0.Input
                }], brushes: [{
                    type: i0.Input
                }], actualBrushes: [{
                    type: i0.Input
                }], outlines: [{
                    type: i0.Input
                }], actualOutlines: [{
                    type: i0.Input
                }], labelFormat: [{
                    type: i0.Input
                }], labelFormatSpecifiers: [{
                    type: i0.Input
                }], othersLabelFormat: [{
                    type: i0.Input
                }], othersLabelFormatSpecifiers: [{
                    type: i0.Input
                }], legendLabelFormat: [{
                    type: i0.Input
                }], legendLabelFormatSpecifiers: [{
                    type: i0.Input
                }], legendOthersLabelFormat: [{
                    type: i0.Input
                }], legendOthersLabelFormatSpecifiers: [{
                    type: i0.Input
                }], legendItemTemplate: [{
                    type: i0.Input
                }], legendItemBadgeTemplate: [{
                    type: i0.Input
                }], isSurfaceInteractionDisabled: [{
                    type: i0.Input
                }], shouldDisplayMockData: [{
                    type: i0.Input
                }], shouldUseSkeletonStyleForMockData: [{
                    type: i0.Input
                }], formatLabel: [{
                    type: i0.Input
                }], formatLegendLabel: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], actualPixelScalingRatio: [{
                    type: i0.Input
                }], selectionMode: [{
                    type: i0.Input
                }], selectedItem: [{
                    type: i0.Input
                }], selectedItems: [{
                    type: i0.Input
                }], textStyle: [{
                    type: i0.Input
                }], labelClick: [{
                    type: i0.Output
                }], selectedItemChanging: [{
                    type: i0.Output
                }], selectedItemsChanging: [{
                    type: i0.Output
                }], selectedItemChanged: [{
                    type: i0.Output
                }], selectedItemsChanged: [{
                    type: i0.Output
                }], sliceClick: [{
                    type: i0.Output
                }], sliceEnter: [{
                    type: i0.Output
                }], sliceLeave: [{
                    type: i0.Output
                }], sliceHover: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var XamPieChart = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamPieChart, _super);
        function XamPieChart() {
            var _this = _super.call(this) || this;
            _this.i8 = null;
            _this.ab = XamPieChart.$;
            return _this;
        }
        XamPieChart.prototype.a2 = function () {
            return new XamPieChartView(this);
        };
        XamPieChart.prototype.gj = function (a) {
            _super.prototype.gj.call(this, a);
            this.i8 = a;
        };
        XamPieChart.$t = i2.markType(XamPieChart, 'XamPieChart', PieChartBase.$);
        return XamPieChart;
    }(PieChartBase));
    /**
     * @hidden
     */
    var XamPieChartView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamPieChartView, _super);
        function XamPieChartView(a) {
            var _this = _super.call(this, a) || this;
            _this.b4 = null;
            _this.b4 = a;
            return _this;
        }
        XamPieChartView.$t = i2.markType(XamPieChartView, 'XamPieChartView', PieChartBaseView.$);
        return XamPieChartView;
    }(PieChartBaseView));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents Infragistics IgxPieChartComponent control.
    */
    var IgxPieChartComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxPieChartComponent, _super);
        function IgxPieChartComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = _super.call(this) || this;
            _this.renderer = renderer;
            _this._elRef = _elRef;
            _this.ngZone = ngZone;
            _this.injector = injector;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this._root = null;
            _this._dataSource = null;
            if (_this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
            }
            _this._zoneRunner = function (act) { return ngZone.run(act); };
            _this.container = renderer.createElement("div");
            renderer.appendChild(_elRef.element.nativeElement, _this.container);
            renderer.setStyle(_this.container, "display", "block");
            renderer.setStyle(_this.container, "width", "100%");
            renderer.setStyle(_this.container, "height", "100%");
            var root;
            root = _this.container;
            if (_this.container != null) {
                root = _this.container;
            }
            _this._root = root;
            var ren = new i2.AngularRenderer(root, _this.renderer, window.document, _this.ngZone, true, DataChartStylingDefaults);
            _this._wrapper = ren;
            var chart = _this.i;
            _this._chart = chart;
            chart.provideContainer(ren);
            _this.bindData();
            chart.notifyContainerResized();
            ren.addSizeWatcher(function () {
                _this._chart.notifyContainerResized();
            });
            return _this;
        }
        Object.defineProperty(IgxPieChartComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._chart.notifyContainerResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxPieChartComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._chart.notifyContainerResized();
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartComponent.prototype.ngAfterContentInit = function () {
            this._styling(this._root, this);
            this.i.notifyContainerResized();
        };
        IgxPieChartComponent.prototype.ngOnDestroy = function () {
            this._chart.destroy();
            this._wrapper.destroy();
        };
        IgxPieChartComponent.prototype.createImplementation = function () {
            return new XamPieChart();
        };
        Object.defineProperty(IgxPieChartComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartComponent.prototype.createSeriesComponent = function (type) {
            if (i2.TypeRegistrar.isRegistered(type)) {
                var s = i2.TypeRegistrar.create(type);
                s.owner = this;
                s._provideRenderer(this.renderer);
                return s;
            }
            else {
                //we shouldn't get here, hopefully.
                throw Error("series type not loaded: " + type);
            }
        };
        Object.defineProperty(IgxPieChartComponent.prototype, "dataSource", {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.bindData();
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartComponent.prototype.bindData = function () {
            if (this._chart != null && this._chart !== undefined) {
                this._chart.itemsSource = this._dataSource;
            }
        };
        Object.defineProperty(IgxPieChartComponent.prototype, "legend", {
            /**
             * Gets or sets the legend used for the current chart.
            */
            get: function () {
                if (this.i.legend != null)
                    return this.i.legend.externalObject;
            },
            set: function (v) {
                if (v != undefined && v != null)
                    this.i.legend = v.i;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieChartComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxPieChartComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxPieChartComponent, selector: "igx-pie-chart", inputs: { height: "height", width: "width", dataSource: "dataSource", legend: "legend" }, host: { classAttribute: "ig-pie-chart igx-pie-chart" }, providers: [], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], usesInheritance: true, ngImport: i0, template: "<ng-container #dynamicContent></ng-container>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxPieChartComponent;
    }(IgxPieChartBaseComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-pie-chart',
                        template: "<ng-container #dynamicContent></ng-container>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-pie-chart igx-pie-chart' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], legend: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPieChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPieChartCoreModule() {
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxPieChartCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPieChartCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreModule, declarations: [IgxPieChartComponent], imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule], exports: [i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule,
                IgxPieChartComponent] });
        IgxPieChartCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                    i2.IgxDateTimeFormatSpecifierModule
                ], i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule] });
        return IgxPieChartCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxPieChartComponent],
                        exports: [i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule,
                            IgxPieChartComponent
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPieChartCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPieChartCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxPieChartComponent', IgxPieChartComponent);
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxPieChartCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPieChartCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreDynamicModule, imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxPieChartCoreModule], exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxPieChartCoreModule] });
        IgxPieChartCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreDynamicModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                    i2.IgxDateTimeFormatSpecifierDynamicModule,
                    IgxPieChartCoreModule
                ], i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxPieChartCoreModule] });
        return IgxPieChartCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxPieChartCoreModule
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxPieChartCoreModule
                        ],
                        entryComponents: [IgxPieChartComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPieChartModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPieChartModule() {
        }
        IgxPieChartModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPieChartModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartModule, imports: [i1.CommonModule, IgxPieChartCoreModule,
                IgxDataChartInteractivityModule], exports: [IgxPieChartCoreModule,
                IgxDataChartInteractivityModule] });
        IgxPieChartModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartModule, imports: [[i1.CommonModule, IgxPieChartCoreModule,
                    IgxDataChartInteractivityModule
                ], IgxPieChartCoreModule,
                IgxDataChartInteractivityModule] });
        return IgxPieChartModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxPieChartCoreModule,
                            IgxDataChartInteractivityModule
                        ],
                        imports: [i1.CommonModule, IgxPieChartCoreModule,
                            IgxDataChartInteractivityModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxPieChartDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxPieChartDynamicModule() {
        }
        IgxPieChartDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxPieChartDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartDynamicModule, imports: [i1.CommonModule, IgxPieChartCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxPieChartModule], exports: [IgxPieChartCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxPieChartModule] });
        IgxPieChartDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartDynamicModule, imports: [[i1.CommonModule, IgxPieChartCoreDynamicModule,
                    IgxDataChartInteractivityDynamicModule,
                    IgxPieChartModule
                ], IgxPieChartCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxPieChartModule] });
        return IgxPieChartDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxPieChartDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxPieChartCoreDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxPieChartModule
                        ],
                        imports: [i1.CommonModule, IgxPieChartCoreDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxPieChartModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents the selected data contained inside the Others slice.
    */
    var IgxPieSliceOthersContext = /** @class */ /*@__PURE__*/ (function () {
        function IgxPieSliceOthersContext() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxPieSliceOthersContext.prototype.createImplementation = function () {
            return new PieSliceOthersContext();
        };
        Object.defineProperty(IgxPieSliceOthersContext.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxPieSliceOthersContext.prototype.onImplementationCreated = function () {
        };
        IgxPieSliceOthersContext.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        /**
         * The underlying data contained by the Others pie slice.
        */
        IgxPieSliceOthersContext.prototype.findByName = function (name) {
            return null;
        };
        return IgxPieSliceOthersContext;
    }());

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxHorizontalRangeCategorySeriesProxyDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxHorizontalRangeCategorySeriesProxyDynamicModule() {
            i2.TypeRegistrar.registerCons('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy);
            i2.TypeRegistrar.register('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy.$type);
        }
        IgxHorizontalRangeCategorySeriesProxyDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxHorizontalRangeCategorySeriesProxyDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyDynamicModule, imports: [i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule], exports: [IgxHorizontalRangeCategorySeriesProxyModule] });
        IgxHorizontalRangeCategorySeriesProxyDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyDynamicModule, imports: [[i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule
                ], IgxHorizontalRangeCategorySeriesProxyModule] });
        return IgxHorizontalRangeCategorySeriesProxyDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxHorizontalRangeCategorySeriesProxyDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxHorizontalRangeCategorySeriesProxyModule
                        ],
                        imports: [i1.CommonModule, IgxHorizontalRangeCategorySeriesProxyModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseMoveThunk = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MouseMoveThunk, _super);
        function MouseMoveThunk() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.c = null;
            _this.b = 0;
            _this.a = null;
            return _this;
        }
        MouseMoveThunk.$t = i2.markType(MouseMoveThunk, 'MouseMoveThunk');
        return MouseMoveThunk;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var KNearestResults = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(KNearestResults, _super);
        function KNearestResults() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.e = 0;
            _this.f = 0;
            _this.b = null;
            _this.a = false;
            _this.d = 0;
            _this.c = 0;
            _this.g = 0;
            return _this;
        }
        KNearestResults.$t = i2.markType(KNearestResults, 'KNearestResults');
        return KNearestResults;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxBrushScaleDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxBrushScaleDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxBrushScaleComponent", IgxBrushScaleComponent);
            i2.TypeRegistrar.register("BrushScale", BrushScale.$type);
        }
        IgxBrushScaleDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxBrushScaleDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleDynamicModule, imports: [i1.CommonModule, IgxBrushScaleModule], exports: [IgxBrushScaleModule] });
        IgxBrushScaleDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleDynamicModule, imports: [[i1.CommonModule, IgxBrushScaleModule], IgxBrushScaleModule] });
        return IgxBrushScaleDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxBrushScaleDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxBrushScaleModule],
                        exports: [IgxBrushScaleModule],
                        entryComponents: [IgxBrushScaleComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomPaletteBrushScaleDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomPaletteBrushScaleDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCustomPaletteBrushScaleComponent", IgxCustomPaletteBrushScaleComponent);
            i2.TypeRegistrar.register("CustomPaletteBrushScale", CustomPaletteBrushScale.$type);
        }
        IgxCustomPaletteBrushScaleDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomPaletteBrushScaleDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleDynamicModule, imports: [i1.CommonModule, IgxCustomPaletteBrushScaleModule], exports: [IgxCustomPaletteBrushScaleModule] });
        IgxCustomPaletteBrushScaleDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleDynamicModule, imports: [[i1.CommonModule, IgxCustomPaletteBrushScaleModule], IgxCustomPaletteBrushScaleModule] });
        return IgxCustomPaletteBrushScaleDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomPaletteBrushScaleDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCustomPaletteBrushScaleModule],
                        exports: [IgxCustomPaletteBrushScaleModule],
                        entryComponents: [IgxCustomPaletteBrushScaleComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CustomContourValueResolverEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomContourValueResolverEventArgs, _super);
        function CustomContourValueResolverEventArgs(a) {
            var _this = _super.call(this) || this;
            _this._valueColumn = null;
            _this._contourValuesEnumerable = null;
            _this.b = null;
            _this.valueColumn = a;
            return _this;
        }
        Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "valueColumn", {
            get: function () {
                return this._valueColumn;
            },
            set: function (a) {
                this._valueColumn = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "contourValuesEnumerable", {
            get: function () {
                return this._contourValuesEnumerable;
            },
            set: function (a) {
                this._contourValuesEnumerable = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "values", {
            get: function () {
                if (this.valueColumn == null) {
                    return [];
                }
                return this.valueColumn.asArray();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "contourValues", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                if (a == null) {
                    this.contourValuesEnumerable = null;
                }
                else {
                    this.contourValuesEnumerable = a;
                }
            },
            enumerable: false,
            configurable: true
        });
        CustomContourValueResolverEventArgs.$t = i2.markType(CustomContourValueResolverEventArgs, 'CustomContourValueResolverEventArgs', i2.EventArgs.$);
        return CustomContourValueResolverEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var CustomContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(CustomContourValueResolver, _super);
        function CustomContourValueResolver() {
            var _this = _super.call(this) || this;
            _this.getCustomContourValues = null;
            return _this;
        }
        CustomContourValueResolver.prototype.j = function (a) {
            var b = new CustomContourValueResolverEventArgs(a);
            this.n(b);
            if (b.contourValuesEnumerable != null) {
                return b.contourValuesEnumerable;
            }
            return [];
        };
        CustomContourValueResolver.prototype.n = function (a) {
            if (this.getCustomContourValues != null) {
                this.getCustomContourValues(this, a);
            }
        };
        CustomContourValueResolver.$t = i2.markType(CustomContourValueResolver, 'CustomContourValueResolver', ContourValueResolver.$);
        return CustomContourValueResolver;
    }(ContourValueResolver));

    /**
     * Provides data for GetCustomContourValues event.
    */
    var IgxCustomContourValueResolverEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomContourValueResolverEventArgs() {
        }
        Object.defineProperty(IgxCustomContourValueResolverEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxCustomContourValueResolverEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxCustomContourValueResolverEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxCustomContourValueResolverEventArgs.prototype, "values", {
            get: function () {
                return this.i.values;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomContourValueResolverEventArgs.prototype, "contourValues", {
            get: function () {
                return this.i.contourValues;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.contourValues = v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxCustomContourValueResolverEventArgs;
    }());

    /**
     * ContourValueResolver class which fires an event to resolve the contour values.
    */
    var IgxCustomContourValueResolverComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxCustomContourValueResolverComponent, _super);
        function IgxCustomContourValueResolverComponent() {
            var _this = _super.call(this) || this;
            _this._getCustomContourValues = null;
            return _this;
        }
        IgxCustomContourValueResolverComponent.prototype.createImplementation = function () {
            return new CustomContourValueResolver();
        };
        Object.defineProperty(IgxCustomContourValueResolverComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxCustomContourValueResolverComponent.prototype, "getCustomContourValues", {
            /**
             * Event raised when retrieving the contour values.
            */
            get: function () {
                var _this = this;
                if (this._getCustomContourValues == null) {
                    this._getCustomContourValues = new i0.EventEmitter();
                    this.i.getCustomContourValues = i2.delegateCombine(this.i.getCustomContourValues, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxCustomContourValueResolverEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeGetCustomContourValues) {
                                _this.beforeGetCustomContourValues(_this, outerArgs);
                            }
                            _this._getCustomContourValues.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._getCustomContourValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxCustomContourValueResolverComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxCustomContourValueResolverComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxCustomContourValueResolverComponent, selector: "igx-custom-contour-value-resolver", outputs: { getCustomContourValues: "getCustomContourValues" }, providers: [{ provide: IgxContourValueResolverComponent, useExisting: i0.forwardRef(function () { return IgxCustomContourValueResolverComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxCustomContourValueResolverComponent;
    }(IgxContourValueResolverComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-custom-contour-value-resolver',
                        template: "",
                        providers: [{ provide: IgxContourValueResolverComponent, useExisting: i0.forwardRef(function () { return IgxCustomContourValueResolverComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { getCustomContourValues: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomContourValueResolverModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomContourValueResolverModule() {
        }
        IgxCustomContourValueResolverModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomContourValueResolverModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverModule, declarations: [IgxCustomContourValueResolverComponent], imports: [i1.CommonModule], exports: [IgxCustomContourValueResolverComponent] });
        IgxCustomContourValueResolverModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverModule, imports: [[i1.CommonModule]] });
        return IgxCustomContourValueResolverModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxCustomContourValueResolverComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxCustomContourValueResolverComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxCustomContourValueResolverDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxCustomContourValueResolverDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxCustomContourValueResolverComponent", IgxCustomContourValueResolverComponent);
            i2.TypeRegistrar.register("CustomContourValueResolver", CustomContourValueResolver.$type);
        }
        IgxCustomContourValueResolverDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxCustomContourValueResolverDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverDynamicModule, imports: [i1.CommonModule, IgxCustomContourValueResolverModule], exports: [IgxCustomContourValueResolverModule] });
        IgxCustomContourValueResolverDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverDynamicModule, imports: [[i1.CommonModule, IgxCustomContourValueResolverModule], IgxCustomContourValueResolverModule] });
        return IgxCustomContourValueResolverDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxCustomContourValueResolverDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxCustomContourValueResolverModule],
                        exports: [IgxCustomContourValueResolverModule],
                        entryComponents: [IgxCustomContourValueResolverComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /**
     * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
    */
    var IgxLinearContourValueResolverComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxLinearContourValueResolverComponent, _super);
        function IgxLinearContourValueResolverComponent() {
            return _super.call(this) || this;
        }
        IgxLinearContourValueResolverComponent.prototype.createImplementation = function () {
            return new LinearContourValueResolver();
        };
        Object.defineProperty(IgxLinearContourValueResolverComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxLinearContourValueResolverComponent.prototype, "valueCount", {
            /**
             * Gets or sets how many contour values to return.
            */
            get: function () {
                return this.i.valueCount;
            },
            set: function (v) {
                this.i.valueCount = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxLinearContourValueResolverComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxLinearContourValueResolverComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxLinearContourValueResolverComponent, selector: "igx-linear-contour-value-resolver", inputs: { valueCount: "valueCount" }, providers: [{ provide: IgxContourValueResolverComponent, useExisting: i0.forwardRef(function () { return IgxLinearContourValueResolverComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxLinearContourValueResolverComponent;
    }(IgxContourValueResolverComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-linear-contour-value-resolver',
                        template: "",
                        providers: [{ provide: IgxContourValueResolverComponent, useExisting: i0.forwardRef(function () { return IgxLinearContourValueResolverComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { valueCount: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLinearContourValueResolverModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLinearContourValueResolverModule() {
        }
        IgxLinearContourValueResolverModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLinearContourValueResolverModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverModule, declarations: [IgxLinearContourValueResolverComponent], imports: [i1.CommonModule], exports: [IgxLinearContourValueResolverComponent] });
        IgxLinearContourValueResolverModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverModule, imports: [[i1.CommonModule]] });
        return IgxLinearContourValueResolverModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxLinearContourValueResolverComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxLinearContourValueResolverComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxLinearContourValueResolverDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxLinearContourValueResolverDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxLinearContourValueResolverComponent", IgxLinearContourValueResolverComponent);
            i2.TypeRegistrar.register("LinearContourValueResolver", LinearContourValueResolver.$type);
        }
        IgxLinearContourValueResolverDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxLinearContourValueResolverDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverDynamicModule, imports: [i1.CommonModule, IgxLinearContourValueResolverModule], exports: [IgxLinearContourValueResolverModule] });
        IgxLinearContourValueResolverDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverDynamicModule, imports: [[i1.CommonModule, IgxLinearContourValueResolverModule], IgxLinearContourValueResolverModule] });
        return IgxLinearContourValueResolverDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxLinearContourValueResolverDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxLinearContourValueResolverModule],
                        exports: [IgxLinearContourValueResolverModule],
                        entryComponents: [IgxLinearContourValueResolverComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TriangleRasterizer_PointAndValue = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TriangleRasterizer_PointAndValue, _super);
        function TriangleRasterizer_PointAndValue() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.a = 0;
            return _this;
        }
        TriangleRasterizer_PointAndValue.$t = i2.markType(TriangleRasterizer_PointAndValue, 'TriangleRasterizer_PointAndValue');
        return TriangleRasterizer_PointAndValue;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ChartTitleVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ChartTitleVisualDataList, _super);
        function ChartTitleVisualDataList() {
            return _super.call(this, ChartTitleVisualData.$, 0) || this;
        }
        ChartTitleVisualDataList.$t = i2.markType(ChartTitleVisualDataList, 'ChartTitleVisualDataList', i2.List$1.$.specialize(ChartTitleVisualData.$));
        return ChartTitleVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VisualDataSerializer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VisualDataSerializer, _super);
        function VisualDataSerializer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        VisualDataSerializer.a = function (a) {
            var b = "{ left: " + a.left + ", top: " + a.top + ", width: " + a.width + ", height: " + a.height + " }";
            return b;
        };
        VisualDataSerializer.$t = i2.markType(VisualDataSerializer, 'VisualDataSerializer');
        return VisualDataSerializer;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapVisualData, _super);
        function TreemapVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._nodes = null;
            _this._name = null;
            _this._viewport = null;
            return _this;
        }
        Object.defineProperty(TreemapVisualData.prototype, "nodes", {
            get: function () {
                return this._nodes;
            },
            set: function (a) {
                this._nodes = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        TreemapVisualData.prototype.scaleByViewport = function () {
            var e_1, _a;
            if (this.nodes != null) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.nodes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var a = _c.value;
                        a.e(this.viewport);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        TreemapVisualData.prototype.serialize = function () {
            var e_2, _a;
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (this.nodes != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                var c = true;
                a.l("Nodes: [");
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.nodes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        if (c) {
                            c = false;
                        }
                        else {
                            a.l(", ");
                        }
                        a.u(d.d());
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                a.u("]");
            }
            if (this.name != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("name: '");
                a.l(this.name);
                a.u("'");
            }
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("viewport: {");
            a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
            a.u("}");
            a.u("}");
            return a.toString();
        };
        Object.defineProperty(TreemapVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        TreemapVisualData.$t = i2.markType(TreemapVisualData, 'TreemapVisualData');
        return TreemapVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapVisual = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapVisual, _super);
        function TreemapVisual() {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.i = null;
            _this.l = null;
            _this.j = null;
            _this.n = null;
            _this.o = null;
            _this.g = null;
            _this.k = null;
            _this.m = null;
            _this.t = 0;
            _this.c = null;
            _this.f = 0;
            _this.b = false;
            _this.e = 0;
            _this.d = 0;
            _this.q = 0;
            _this.s = 0;
            _this.r = 0;
            _this.h = 0;
            _this.p = 0;
            _this.c = new i2.List$1(i2.Base.$, 0);
            return _this;
        }
        TreemapVisual.$t = i2.markType(TreemapVisual, 'TreemapVisual');
        return TreemapVisual;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapNodeVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeVisualData, _super);
        function TreemapNodeVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.b = null;
            _this.a = null;
            return _this;
        }
        TreemapNodeVisualData.prototype.e = function (a) {
            if (this.c != null) {
                this.c.scaleByViewport(a);
            }
            if (this.b != null) {
                this.b.scaleByViewport(a);
            }
            if (this.a != null) {
                this.a.scaleByViewport(a);
            }
        };
        TreemapNodeVisualData.prototype.d = function () {
            var a = new i2.StringBuilder(0);
            var b = true;
            a.u("{");
            if (this.c != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("nodeRect: ");
                a.l(this.c.serialize());
            }
            if (this.b != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("headerRect: ");
                a.l(this.b.serialize());
            }
            if (this.a != null) {
                if (b) {
                    b = false;
                }
                else {
                    a.l(", ");
                }
                a.l("label: ");
                a.l(this.a.serialize());
            }
            a.u("");
            a.u("}");
            return a.toString();
        };
        TreemapNodeVisualData.$t = i2.markType(TreemapNodeVisualData, 'TreemapNodeVisualData');
        return TreemapNodeVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapLabelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapLabelVisualData, _super);
        function TreemapLabelVisualData() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._labelValue = null;
            _this._labelSize = null;
            _this._labelPosition = null;
            _this._appearance = null;
            return _this;
        }
        Object.defineProperty(TreemapLabelVisualData.prototype, "labelValue", {
            get: function () {
                return this._labelValue;
            },
            set: function (a) {
                this._labelValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapLabelVisualData.prototype, "labelSize", {
            get: function () {
                return this._labelSize;
            },
            set: function (a) {
                this._labelSize = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapLabelVisualData.prototype, "labelPosition", {
            get: function () {
                return this._labelPosition;
            },
            set: function (a) {
                this._labelPosition = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapLabelVisualData.prototype, "appearance", {
            get: function () {
                return this._appearance;
            },
            set: function (a) {
                this._appearance = a;
            },
            enumerable: false,
            configurable: true
        });
        TreemapLabelVisualData.prototype.scaleByViewport = function (a) {
            this.labelPosition = new i2.PointData((this.labelPosition.x - a.left) / a.width, (this.labelPosition.y - a.top) / a.height);
            this.labelSize = new i2.SizeData((this.labelSize.width) / a.width, (this.labelSize.height) / a.height);
        };
        TreemapLabelVisualData.prototype.serialize = function () {
            return "{ labelValue: '" + this.labelValue + "', labelSize: { width: " + this.labelSize.width + ", height: " + this.labelSize.height + "}, labelPosition: { x: " + this.labelPosition.x + ", y: " + this.labelPosition.y + "}, appearance: " + this.appearance.serialize() + "}";
        };
        TreemapLabelVisualData.$t = i2.markType(TreemapLabelVisualData, 'TreemapLabelVisualData');
        return TreemapLabelVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapOrientation = /*@__PURE__*/ (function (TreemapOrientation) {
        TreemapOrientation[TreemapOrientation["Horizontal"] = 0] = "Horizontal";
        TreemapOrientation[TreemapOrientation["Vertical"] = 1] = "Vertical";
        return TreemapOrientation;
    })({});
    /**
     * @hidden
     */
    var TreemapOrientation_$type = i2.markEnum('TreemapOrientation', 'Horizontal,0|Vertical,1');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AreaInfo = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AreaInfo, _super);
        function AreaInfo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.a = 0;
            return _this;
        }
        AreaInfo.$t = i2.markType(AreaInfo, 'AreaInfo');
        return AreaInfo;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapFillScaleMode = /*@__PURE__*/ (function (TreemapFillScaleMode) {
        TreemapFillScaleMode[TreemapFillScaleMode["Sum"] = 0] = "Sum";
        TreemapFillScaleMode[TreemapFillScaleMode["GlobalSum"] = 1] = "GlobalSum";
        TreemapFillScaleMode[TreemapFillScaleMode["Value"] = 2] = "Value";
        TreemapFillScaleMode[TreemapFillScaleMode["GlobalValue"] = 3] = "GlobalValue";
        return TreemapFillScaleMode;
    })({});
    /**
     * @hidden
     */
    var TreemapFillScaleMode_$type = i2.markEnum('TreemapFillScaleMode', 'Sum,0|GlobalSum,1|Value,2|GlobalValue,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapLabelVerticalFitMode = /*@__PURE__*/ (function (TreemapLabelVerticalFitMode) {
        TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Auto"] = 0] = "Auto";
        TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Show"] = 1] = "Show";
        TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Hide"] = 2] = "Hide";
        return TreemapLabelVerticalFitMode;
    })({});
    /**
     * @hidden
     */
    var TreemapLabelVerticalFitMode_$type = i2.markEnum('TreemapLabelVerticalFitMode', 'Auto,0|Show,1|Hide,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapLabelHorizontalFitMode = /*@__PURE__*/ (function (TreemapLabelHorizontalFitMode) {
        TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Auto"] = 0] = "Auto";
        TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Ellipsis"] = 1] = "Ellipsis";
        TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Hide"] = 2] = "Hide";
        return TreemapLabelHorizontalFitMode;
    })({});
    /**
     * @hidden
     */
    var TreemapLabelHorizontalFitMode_$type = i2.markEnum('TreemapLabelHorizontalFitMode', 'Auto,0|Ellipsis,1|Hide,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapHeaderDisplayMode = /*@__PURE__*/ (function (TreemapHeaderDisplayMode) {
        TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Auto"] = 0] = "Auto";
        TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Header"] = 1] = "Header";
        TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Overlay"] = 2] = "Overlay";
        return TreemapHeaderDisplayMode;
    })({});
    /**
     * @hidden
     */
    var TreemapHeaderDisplayMode_$type = i2.markEnum('TreemapHeaderDisplayMode', 'Auto,0|Header,1|Overlay,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapLayoutType = /*@__PURE__*/ (function (TreemapLayoutType) {
        TreemapLayoutType[TreemapLayoutType["Squarified"] = 0] = "Squarified";
        TreemapLayoutType[TreemapLayoutType["SliceAndDice"] = 1] = "SliceAndDice";
        TreemapLayoutType[TreemapLayoutType["Stripped"] = 2] = "Stripped";
        return TreemapLayoutType;
    })({});
    /**
     * @hidden
     */
    var TreemapLayoutType_$type = i2.markEnum('TreemapLayoutType', 'Squarified,0|SliceAndDice,1|Stripped,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapNodeVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeVisualDataList, _super);
        function TreemapNodeVisualDataList() {
            return _super.call(this, TreemapNodeVisualData.$, 0) || this;
        }
        TreemapNodeVisualDataList.$t = i2.markType(TreemapNodeVisualDataList, 'TreemapNodeVisualDataList', i2.List$1.$.specialize(TreemapNodeVisualData.$));
        return TreemapNodeVisualDataList;
    }(i2.List$1));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapValueMappingMode = /*@__PURE__*/ (function (TreemapValueMappingMode) {
        TreemapValueMappingMode[TreemapValueMappingMode["Sum"] = 0] = "Sum";
        TreemapValueMappingMode[TreemapValueMappingMode["Value"] = 1] = "Value";
        TreemapValueMappingMode[TreemapValueMappingMode["CustomValue"] = 2] = "CustomValue";
        return TreemapValueMappingMode;
    })({});
    /**
     * @hidden
     */
    var TreemapValueMappingMode_$type = i2.markEnum('TreemapValueMappingMode', 'Sum,0|Value,1|CustomValue,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapNodePointerEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodePointerEventArgs, _super);
        function TreemapNodePointerEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._value = 0;
            _this._sum = 0;
            _this._customValue = null;
            _this._item = null;
            _this._parentItem = null;
            _this._position = null;
            _this._isRightButton = false;
            _this._isHandled = false;
            _this._isOverHeader = false;
            _this._label = null;
            _this._parentValue = 0;
            _this._parentLabel = null;
            _this._parentSum = 0;
            return _this;
        }
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (a) {
                this._value = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "sum", {
            get: function () {
                return this._sum;
            },
            set: function (a) {
                this._sum = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "customValue", {
            get: function () {
                return this._customValue;
            },
            set: function (a) {
                this._customValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentItem", {
            get: function () {
                return this._parentItem;
            },
            set: function (a) {
                this._parentItem = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "position", {
            get: function () {
                return this._position;
            },
            set: function (a) {
                this._position = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isRightButton", {
            get: function () {
                return this._isRightButton;
            },
            set: function (a) {
                this._isRightButton = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isHandled", {
            get: function () {
                return this._isHandled;
            },
            set: function (a) {
                this._isHandled = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isOverHeader", {
            get: function () {
                return this._isOverHeader;
            },
            set: function (a) {
                this._isOverHeader = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "label", {
            get: function () {
                return this._label;
            },
            set: function (a) {
                this._label = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentValue", {
            get: function () {
                return this._parentValue;
            },
            set: function (a) {
                this._parentValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentLabel", {
            get: function () {
                return this._parentLabel;
            },
            set: function (a) {
                this._parentLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentSum", {
            get: function () {
                return this._parentSum;
            },
            set: function (a) {
                this._parentSum = a;
            },
            enumerable: false,
            configurable: true
        });
        TreemapNodePointerEventArgs.$t = i2.markType(TreemapNodePointerEventArgs, 'TreemapNodePointerEventArgs', i2.EventArgs.$);
        return TreemapNodePointerEventArgs;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var TreemapNodeStyleMappingTargetType = /*@__PURE__*/ (function (TreemapNodeStyleMappingTargetType) {
        TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["All"] = 0] = "All";
        TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["Parent"] = 1] = "Parent";
        TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["Child"] = 2] = "Child";
        return TreemapNodeStyleMappingTargetType;
    })({});
    /**
     * @hidden
     */
    var TreemapNodeStyleMappingTargetType_$type = i2.markEnum('TreemapNodeStyleMappingTargetType', 'All,0|Parent,1|Child,2');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TreemapView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapView, _super);
        function TreemapView() {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.a = null;
            _this.m = false;
            _this.ac = null;
            _this.j = null;
            _this.aa = null;
            _this.q = 0;
            _this.p = 0;
            _this.e = null;
            _this.ab = null;
            _this.t = 1;
            _this.z = null;
            _this.c = null;
            _this.r = 0;
            _this.s = 0;
            _this.a1 = null;
            _this.g = ((function () {
                var $ret = new i2.FontInfo();
                $ret.n = "Verdana";
                $ret.d = i2.DeviceUtils.f(13);
                return $ret;
            })());
            _this.f = ((function () {
                var $ret = new i2.FontInfo();
                $ret.n = "Verdana";
                $ret.d = i2.DeviceUtils.f(13);
                return $ret;
            })());
            _this.o = null;
            _this.k = null;
            _this.a2 = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgba(0,0,0, 0.0)";
                return $ret;
            })());
            _this.d = ((function () {
                var $ret = new i2.FontInfo();
                $ret.n = "Verdana";
                $ret.d = i2.DeviceUtils.f(13);
                return $ret;
            })());
            _this.l = true;
            _this.b = new TreemapViewRenderer();
            _this.b.j = ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "white";
                return $ret;
            })());
            return _this;
        }
        TreemapView.prototype.au = function () {
        };
        TreemapView.prototype.ay = function () {
            this.ax();
        };
        TreemapView.prototype.az = function () {
            if (!this.m) {
                this.m = true;
                if (this.aa != null) {
                    this.aa.setTimeout(i2.runOn(this, this.ad), 0);
                }
                else {
                    window.setTimeout(i2.runOn(this, this.ad), 0);
                }
            }
        };
        TreemapView.prototype.ad = function () {
            if (this.m) {
                this.m = false;
                this.a.hf();
            }
        };
        TreemapView.prototype.n = function () {
            return true;
        };
        TreemapView.prototype.av = function () {
            this.t = this.a.cp;
            this.az();
        };
        TreemapView.prototype.ar = function (a) {
            if (a == null) {
                this.ac = null;
                this.aa = null;
                this.j = null;
                if (this.z != null) {
                    window.removeEventListener("resize", this.z, false);
                    this.z = null;
                }
                this.ae();
                return;
            }
            this.aa = a;
            this.ab = a;
            var b = this.ab.rootWrapper.width();
            var c = this.ab.rootWrapper.height();
            this.ao();
            this.t = (i2.isNaN_(this.a.di) ? this.a.cp : this.a.di);
            var d = this.t;
            var e = Math.round(a.rootWrapper.width());
            var f = Math.round(a.rootWrapper.height());
            var g = e * d;
            var h = f * d;
            this.aa.rootWrapper.setStyleProperty("position", "relative");
            var i = a.createElement("canvas");
            i.setStyleProperty("position", "absolute");
            this.aa.rootWrapper.append(i);
            this.q = b;
            this.p = c;
            i.setAttribute("width", g.toString());
            i.setAttribute("height", h.toString());
            i.setStyleProperty("width", e.toString() + "px");
            i.setStyleProperty("height", f.toString() + "px");
            this.k = i.listen("contextmenu", function (j) { return j.preventDefault(); });
            this.a.ip = new i2.Rect(0, 0, 0, e, f);
            this.ac = i;
            var j = this.aa.get2DCanvasContext(this.ac);
            this.j = new i2.RenderingContext(new i2.CanvasViewRenderer(), j);
            this.an();
            this.a0();
            this.j.ac(this.e);
            this.ax();
            this.c = new i2.CanvasGestureDOMEventProxy(this.ac, this.aa, true);
            this.c.al = function (k) { return true; };
            this.c.bg = this.a.ip;
            var k = this.c;
            k.onMouseOver = i2.delegateCombine(k.onMouseOver, i2.runOn(this, this.aj));
            var l = this.c;
            l.onMouseUp = i2.delegateCombine(l.onMouseUp, i2.runOn(this, this.ak));
            var m = this.c;
            m.onMouseDown = i2.delegateCombine(m.onMouseDown, i2.runOn(this, this.ag));
            var n = this.c;
            n.onMouseEnter = i2.delegateCombine(n.onMouseEnter, i2.runOn(this, this.ah));
            var o = this.c;
            o.onMouseLeave = i2.delegateCombine(o.onMouseLeave, i2.runOn(this, this.ai));
        };
        TreemapView.prototype.ai = function (a) {
            this.a.g4(a);
        };
        TreemapView.prototype.al = function (a) {
            this.b.e(a, this.o, this);
        };
        TreemapView.prototype.ah = function (a) {
            this.a.g3(a);
        };
        TreemapView.prototype.ao = function () {
            var _this = this;
            if (this.z == null) {
                this.z = function (a) {
                    var b = _this.a.di;
                    var c = _this.a.cp;
                    if (!i2.isNaN_(b) && b != 0) {
                        return;
                    }
                    if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
                        _this.a.cp = window.devicePixelRatio;
                    }
                };
                var e_ = this.z;
                window.addEventListener("resize", e_, false);
            }
            this.z(null);
        };
        TreemapView.prototype.ae = function () {
            if (this.k != null) {
                this.k();
                this.k = null;
            }
            if (this.c != null) {
                var a = this.c;
                a.onMouseOver = i2.delegateRemove(a.onMouseOver, i2.runOn(this, this.aj));
                var b = this.c;
                b.onMouseUp = i2.delegateRemove(b.onMouseUp, i2.runOn(this, this.ak));
                var c = this.c;
                c.onMouseDown = i2.delegateRemove(c.onMouseDown, i2.runOn(this, this.ag));
                var d = this.c;
                d.onMouseEnter = i2.delegateRemove(d.onMouseEnter, i2.runOn(this, this.ah));
                var e = this.c;
                e.onMouseLeave = i2.delegateRemove(e.onMouseLeave, i2.runOn(this, this.ai));
                this.c.al = null;
                this.c.ar();
            }
        };
        TreemapView.prototype.ag = function (a) {
            if (this.c.ai) {
                this.a.g8(a);
            }
            else {
                this.a.g2(a);
            }
        };
        TreemapView.prototype.ak = function (a) {
            if (this.c.ai) {
                this.a.g9(a);
            }
            else {
                this.a.g6(a);
            }
        };
        TreemapView.prototype.aj = function (a, b, c) {
            this.a.g5(a);
        };
        TreemapView.prototype.an = function () {
        };
        TreemapView.prototype.i = function () {
            return this.b.b;
        };
        TreemapView.prototype.a0 = function () {
            this.e = i2.FontUtil.getFont(this.aa);
            if (this.f != null) {
                this.r = this.u(this.f);
            }
            else {
                this.r = this.u(this.e);
            }
            if (this.g != null) {
                this.s = this.u(this.g);
            }
            else {
                this.s = this.u(this.e);
            }
            this.a1 = new i2.Brush();
            this.a1._fill = this.aa.rootWrapper.getStyleProperty("color");
            if (this.j != null) {
                this.j.ac(this.e);
            }
        };
        TreemapView.prototype.ap = function () {
            var a = this.ab.rootWrapper.width();
            var b = this.ab.rootWrapper.height();
            this.a.ip = new i2.Rect(0, 0, 0, a, b);
            this.ao();
        };
        TreemapView.prototype.am = function () {
            if (this.m) {
                this.ad();
            }
        };
        TreemapView.prototype.ax = function () {
            if (this.j == null) {
                return;
            }
            var a = this.a.ip.width;
            var b = this.a.ip.height;
            var c = Math.round(a * this.t);
            var d = Math.round(b * this.t);
            if (this.q != c || this.p != d) {
                this.ac.setAttribute("width", c.toString());
                this.ac.setAttribute("height", d.toString());
                this.ac.setStyleProperty("width", a.toString() + "px");
                this.ac.setStyleProperty("height", b.toString() + "px");
                this.q = i2.truncate(Math.round(c));
                this.p = i2.truncate(Math.round(d));
            }
            if (this.j.d && this.t != 1) {
                this.j.z();
                this.j.aa(this.t, this.t);
            }
            this.b.f(this.j, this.a.ip, this.o, this.r);
            if (this.j.d && this.t != 1) {
                this.j.y();
            }
        };
        TreemapView.prototype.at = function (a) {
            this.g = a;
            if (this.g != null) {
                this.s = this.u(this.g);
            }
            else {
                this.s = this.u(this.e);
            }
        };
        TreemapView.prototype.aw = function (a) {
            this.f = a;
            if (this.f != null) {
                this.r = this.u(this.f);
            }
            else {
                this.r = this.u(this.e);
            }
            if (this.g != null) {
                this.s = this.u(this.g);
            }
            else {
                this.s = this.u(this.e);
            }
        };
        TreemapView.prototype.af = function (a) {
            this.o = a;
            this.ax();
        };
        TreemapView.prototype.y = function (a) {
            if (a != null) {
                if (this.f != null) {
                    this.j.ac(this.f);
                }
                else {
                    this.j.ac(this.d);
                }
                return this.j.f(a);
            }
            return 0;
        };
        TreemapView.prototype.w = function (a) {
            if (a != null) {
                if (this.g != null) {
                    this.j.ac(this.g);
                }
                else {
                    this.j.ac(this.d);
                }
                return this.j.f(a);
            }
            return 0;
        };
        TreemapView.prototype.u = function (a) {
            return i2.FontUtil.getCurrentFontHeight(this.aa, a);
        };
        TreemapView.prototype.x = function (a) {
            return this.r;
        };
        TreemapView.prototype.v = function (a) {
            return this.s;
        };
        TreemapView.prototype.a4 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgb(220,220,220)";
                return $ret;
            })());
        };
        TreemapView.prototype.a6 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgb(240, 240, 240)";
                return $ret;
            })());
        };
        TreemapView.prototype.a5 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgb(102, 102, 102)";
                return $ret;
            })());
        };
        TreemapView.prototype.bc = function () {
            return this.a2;
        };
        TreemapView.prototype.a8 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "black";
                return $ret;
            })());
        };
        TreemapView.prototype.a7 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgb(240,240,240)";
                return $ret;
            })());
        };
        TreemapView.prototype.bb = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgb(240, 240, 240)";
                return $ret;
            })());
        };
        TreemapView.prototype.a3 = function () {
            return ((function () {
                var $ret = new i2.Brush();
                $ret.fill = "rgb(102, 102, 102)";
                return $ret;
            })());
        };
        TreemapView.prototype.h = function () {
            return this.d;
        };
        TreemapView.prototype.a9 = function () {
            return i2.BrushUtil.g(153, 25, 25, 25);
        };
        TreemapView.prototype.ba = function () {
            return i2.BrushUtil.g(153, 45, 45, 45);
        };
        TreemapView.prototype.aq = function () {
            this.l = true;
            this.ao();
            if (this.c != null) {
                this.c.aq(this.aa.rootWrapper, "");
            }
        };
        TreemapView.prototype.as = function () {
            this.l = false;
            if (this.c != null) {
                this.c.bc(this.aa.rootWrapper, "");
            }
        };
        TreemapView.$t = i2.markType(TreemapView, 'TreemapView');
        return TreemapView;
    }(i2.Base));
    /**
     * @hidden
     */
    var TreemapViewRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapViewRenderer, _super);
        function TreemapViewRenderer() {
            var _this = _super.call(this) || this;
            _this.b = null;
            _this.c = null;
            _this.j = null;
            _this.c = new i2.List$1(TreemapVisual.$, 0);
            _this.b = ((function () {
                var $ret = new i2.Pool$1(TreemapVisual.$);
                $ret.create = i2.runOn(_this, _this.a);
                $ret.activate = i2.runOn(_this, _this.g);
                $ret.disactivate = i2.runOn(_this, _this.i);
                $ret.destroy = i2.runOn(_this, _this.h);
                return $ret;
            })());
            return _this;
        }
        TreemapViewRenderer.prototype.a = function () {
            var a = new TreemapVisual();
            this.c.add(a);
            return a;
        };
        TreemapViewRenderer.prototype.g = function (a) {
            a.t = 0;
        };
        TreemapViewRenderer.prototype.i = function (a) {
            a.t = 1;
        };
        TreemapViewRenderer.prototype.h = function (a) {
            this.c.remove(a);
        };
        TreemapViewRenderer.prototype.d = function (a) {
            if (a.c.count != 3) {
                a.c.add1(new i2.Rectangle());
                a.c.add1(new i2.Rectangle());
                a.c.add1(new i2.TextBlock());
            }
        };
        TreemapViewRenderer.prototype.f = function (a, b, c, d) {
            a.k(b.left, b.top, b.width, b.height);
            if (c != null) {
                for (var e = 0; e < c.count; e++) {
                    var f = c._inner[e];
                    this.d(f);
                    var g = f.c._inner[0];
                    var h = f.c._inner[1];
                    var i = f.c._inner[2];
                    g._fill = f.i;
                    g._stroke = f.l;
                    g.ac = f.f;
                    g.width = f.m.width;
                    g.height = f.m.height;
                    g.n = f.m.left;
                    g.o = f.m.top;
                    a.ac(f.a);
                    var j = a.f(f.g);
                    if (f.b) {
                        i.ak = f.g;
                        switch (f.h) {
                            case 0:
                                i.n = f.m.left + f.o.c;
                                break;
                            case 1:
                            case 3:
                                i.n = f.m.left + f.m.width / 2 - f.e / 2;
                                break;
                            case 2:
                                i.n = Math.max(f.m.left + f.o.c, f.m.right - (j + f.o.d));
                                break;
                        }
                        switch (f.p) {
                            case 0:
                                i.o = f.m.top + f.o.e;
                                break;
                            case 1:
                            case 3:
                                i.o = f.m.top + f.m.height / 2 - f.d / 2;
                                break;
                            case 2:
                                i.o = Math.max(f.m.top + f.o.e, f.m.bottom - (d + f.o.b));
                                break;
                        }
                        i.am = f.k;
                    }
                    else {
                        h._fill = f.j;
                        h._stroke = f.l;
                        h.ac = f.f;
                        h.width = f.m.width;
                        h.height = f.d;
                        h.n = f.m.left;
                        h.o = f.m.top;
                        if (f.s == 0) {
                            h.width = j + f.n.c + f.n.d;
                        }
                        i.n = f.m.left + f.n.c;
                        i.o = f.m.top + f.n.e;
                        i.ak = f.g;
                        i.am = f.k;
                    }
                    a.v(g);
                    if (f.s != 0) {
                        if (!f.b) {
                            a.v(h);
                        }
                    }
                    a.z();
                    a.ae(f.m);
                    if (f.s == 0) {
                        if (!f.b) {
                            a.v(h);
                        }
                    }
                    a.w(i);
                    a.y();
                }
            }
        };
        TreemapViewRenderer.prototype.e = function (a, b, c) {
            if (b != null) {
                for (var d = 0; d < b.count; d++) {
                    var e = b._inner[d];
                    this.d(e);
                    var f = e.c._inner[0];
                    var g = e.c._inner[1];
                    var h = e.c._inner[2];
                    var i = new TreemapNodeVisualData();
                    i.c = new i2.RectangleVisualData(1, "NodePath", f);
                    i.b = new i2.RectangleVisualData(1, "HeaderRect", g);
                    var j = new TreemapLabelVisualData();
                    j.labelPosition = new i2.PointData(h.n, h.o);
                    if (e.b) {
                        j.labelSize = new i2.SizeData(c.y(h.ak), c.x(h.ak));
                    }
                    else {
                        j.labelSize = new i2.SizeData(c.w(h.ak), c.v(h.ak));
                    }
                    j.labelValue = h.ak;
                    j.appearance = i2.AppearanceHelper.c(h, e.a);
                    i.a = j;
                    a.nodes.add(i);
                }
            }
        };
        TreemapViewRenderer.$t = i2.markType(TreemapViewRenderer, 'TreemapViewRenderer');
        return TreemapViewRenderer;
    }(i2.Base));
    /**
     * @hidden
     */
    var TreemapLayoutCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapLayoutCalculator, _super);
        function TreemapLayoutCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TreemapLayoutCalculator.c = function (a, b, c, d) {
            var e = a.e();
            var f = d.f;
            var g = f * f / (b.width * b.height);
            if (e / c < g) {
                return true;
            }
            return false;
        };
        TreemapLayoutCalculator.a = function (a, b, c, d, e) {
            for (var f = 0; f < c.count; f++) {
                var g = c._inner[f];
                if (!a.contains(g)) {
                    return false;
                }
            }
            return true;
        };
        TreemapLayoutCalculator.b = function (a, b) {
            if (a.width < b.f || a.height < b.f) {
                return true;
            }
            return false;
        };
        TreemapLayoutCalculator.prototype.h = function (a, b, c) {
            return a.o(b);
        };
        TreemapLayoutCalculator.prototype.i = function (a, b, c) {
            var d = a.o(b);
            if (d.isEmpty) {
                return d;
            }
            if (b.b != null && b.b.count > 0) {
                var e = c.i;
                var f = e.c + e.d;
                var g = e.e + e.b;
                var h = a.b(b);
                if (!h) {
                    return d;
                }
                var i = new i2.Rect(0, d.left - e.c, d.top - e.e, d.width + f, d.height + g);
                return i;
            }
            else {
                return d;
            }
        };
        TreemapLayoutCalculator.prototype.g = function (a, b, c, d) {
            if (b.b != null && b.b.count > 0) {
                var e = d.i;
                var f = e.c + e.d;
                var g = e.e + e.b;
                if (c.width < f || c.height < g) {
                    a.m(b, c);
                    return;
                }
                var h = new i2.Rect(0, c.left + e.c, c.top + e.e, c.width - f, c.height - g);
                a.m(b, h);
                a.n(b, true);
            }
            else {
                a.m(b, c);
            }
        };
        TreemapLayoutCalculator.prototype.f = function (a, b, c, d, e, f) {
            var e_1, _a;
            if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
                while (d > 0) {
                    var g = 0;
                    try {
                        for (var _b = (e_1 = void 0, tslib.__values(i2.fromEnum(c))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var h = _c.value;
                            if (a.contains(h)) {
                                continue;
                            }
                            if (d > 0) {
                                var i = (d > 1) ? 1 : d;
                                var j = this.i(b, h, f);
                                if (j.isEmpty) {
                                    continue;
                                }
                                this.g(b, h, new i2.Rect(0, j.x + g, j.y, j.width + i, j.height), f);
                                d -= i;
                                g += i;
                            }
                            else {
                                var k = this.i(b, h, f);
                                if (k.isEmpty) {
                                    continue;
                                }
                                this.g(b, h, new i2.Rect(0, k.x + g, k.y, k.width, k.height), f);
                            }
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                }
            }
        };
        TreemapLayoutCalculator.prototype.e = function (a, b, c, d, e, f) {
            var e_2, _a;
            if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
                while (d > 0) {
                    var g = 0;
                    try {
                        for (var _b = (e_2 = void 0, tslib.__values(i2.fromEnum(c))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var h = _c.value;
                            if (a.contains(h)) {
                                continue;
                            }
                            if (d > 0) {
                                var i = (d > 1) ? 1 : d;
                                var j = this.i(b, h, f);
                                if (j.isEmpty) {
                                    continue;
                                }
                                this.g(b, h, new i2.Rect(0, j.x, j.y + g, j.width, j.height + i), f);
                                d -= i;
                                g += i;
                            }
                            else {
                                var k = this.i(b, h, f);
                                if (k.isEmpty) {
                                    continue;
                                }
                                this.g(b, h, new i2.Rect(0, k.x, k.y + g, k.width, k.height), f);
                            }
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                }
            }
        };
        TreemapLayoutCalculator.$t = i2.markType(TreemapLayoutCalculator, 'TreemapLayoutCalculator');
        return TreemapLayoutCalculator;
    }(i2.Base));
    /**
     * @hidden
     */
    var StrippedCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(StrippedCalculator, _super);
        function StrippedCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        StrippedCalculator.prototype.d = function (a, b) {
            a.g();
            this.o(a, b.b.a, b.h, b, 0);
        };
        StrippedCalculator.prototype.q = function (a, b, c) {
            return c.j;
        };
        StrippedCalculator.prototype.o = function (a, b, c, d, e) {
            var e_3, _a;
            if (d.g >= 0 && e > d.g) {
                return;
            }
            if (b == d.c) {
                d.d = true;
                this.g(a, b, c, d);
                var f = new i2.Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
                c = f;
            }
            if (!d.d) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(b.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var g = _c.value;
                        this.o(a, g, c, d, e + 1);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                return;
            }
            var h = this.q(b, c, d);
            var i = h.c + h.d;
            var j = h.e + h.b;
            var k = new i2.Rect(0, c.left, c.top, c.width, c.height);
            var l = d.a;
            if (i >= k.width || j >= k.height) {
                return;
            }
            k.x = k.x + h.c;
            k.width = k.width - i;
            k.y = k.y + h.e;
            k.height = k.height - j;
            var m = new i2.HashSet$1(TreemapTreeNode.$, 0);
            StrippedCalculator.p(m, d, b.b, k);
            var n = 0;
            for (var o = 0; o < b.b.count; o++) {
                var p = b.b._inner[o];
                if (!m.contains(p)) {
                    n += p.e();
                }
            }
            var q = n;
            var r = (k.width * k.height) / q;
            var s = l == 0 ? k.width : k.height;
            var t = new i2.List$1(TreemapTreeNode.$, 0);
            var u = new i2.List$1(TreemapTreeNode.$, 0);
            for (var v = 0; v < b.b.count; v++) {
                var w = b.b._inner[v];
                if (m.contains(w) || i2.isNaN_(w.e())) {
                    continue;
                }
                var x = StrippedCalculator.j(u, s, r);
                u.add(w);
                var y = StrippedCalculator.j(u, s, r);
                if (x < y) {
                    if (t.count > 0) {
                        var z = this.m(m, a, d, t, r, k, l, false);
                        k = z.p5;
                    }
                    u.removeAt(u.count - 1);
                    t.o(u);
                    u.clear();
                    u.add(w);
                }
            }
            var aa = StrippedCalculator.j(t, s, r);
            var ab = StrippedCalculator.j(u, s, r);
            var ac = new i2.List$1(TreemapTreeNode.$, 0);
            ac.o(t);
            ac.o(u);
            var ad = StrippedCalculator.j(ac, s, r);
            if (ad < (aa + ab) / 2 || k.height < d.f * 2) {
                var ae = this.m(m, a, d, ac, r, k, l, true);
                k = ae.p5;
            }
            else {
                var af = this.m(m, a, d, t, r, k, l, false);
                k = af.p5;
                var ag = this.m(m, a, d, u, r, k, l, true);
                k = ag.p5;
            }
            for (var ah = 0; ah < b.b.count; ah++) {
                var ai = b.b._inner[ah];
                if (m.contains(ai)) {
                    continue;
                }
                var aj = this.h(a, ai, d);
                if (aj.isEmpty) {
                    continue;
                }
                var ak = new i2.Rect(0, aj.left, aj.top + d.e, aj.width, Math.max(aj.height - d.e, 0));
                this.o(a, ai, ak, d, e + 1);
            }
            if (b == d.c) {
                d.d = false;
            }
        };
        StrippedCalculator.prototype.m = function (a, b, c, d, e, f, g, h) {
            if (d.count == 0) {
                return {
                    p5: f
                };
            }
            if (g == 0) {
                var i = this.l(a, b, c, d, e, f, h);
                f = i.p5;
            }
            else {
                var j = this.n(a, b, c, d, e, f, h);
                f = j.p5;
            }
            return {
                p5: f
            };
        };
        StrippedCalculator.prototype.l = function (a, b, c, d, e, f, g) {
            var h = StrippedCalculator.k(d);
            if (h <= 0) {
                return {
                    p5: f
                };
            }
            var i = f.width;
            var j = (h * e) / i;
            var k = f.x;
            var l = 0;
            for (var m = 0; m < d.count; ++m) {
                var n = d._inner[m];
                var o = Math.floor((n.e() / h) * i);
                var p = new i2.Rect(0, k, f.y, o, j);
                if (TreemapLayoutCalculator.b(p, c)) {
                    a.add_1(n);
                }
                else {
                    l = p.right;
                    this.g(b, n, p, c);
                }
                if (a.contains(n)) {
                    h -= n.e();
                }
                else {
                    k += o;
                }
            }
            this.f(a, b, d, f.right - k, f, c);
            f.y = f.y + j;
            if (f.height < j) {
                f.height = 0;
            }
            else {
                f.height = f.height - j;
            }
            d.clear();
            return {
                p5: f
            };
        };
        StrippedCalculator.prototype.n = function (a, b, c, d, e, f, g) {
            var h = StrippedCalculator.k(d);
            if (h <= 0) {
                return {
                    p5: f
                };
            }
            var i = f.height;
            var j = (h * e) / i;
            var k = f.y;
            var l = 0;
            for (var m = 0; m < d.count; ++m) {
                var n = d._inner[m];
                var o = Math.floor((n.e() / h) * i);
                var p = new i2.Rect(0, f.x, k, j, o);
                if (TreemapLayoutCalculator.b(p, c)) {
                    a.add_1(n);
                }
                else {
                    l = p.bottom;
                    this.g(b, n, p, c);
                }
                if (a.contains(n)) {
                    h -= n.e();
                }
                else {
                    k += o;
                }
            }
            this.e(a, b, d, f.bottom - k, f, c);
            f.x = f.x + j;
            if (f.width < j) {
                f.width = 0;
            }
            else {
                f.width = f.width - j;
            }
            d.clear();
            return {
                p5: f
            };
        };
        StrippedCalculator.j = function (a, b, c) {
            if (a.count == 0) {
                return 1.7976931348623157E+308;
            }
            var d = StrippedCalculator.k(a);
            var e = (d * c) / b;
            var f = 0;
            for (var g = 0; g < a.count; g++) {
                var h = a._inner[g];
                var i = (h.e() / d) * b;
                f += Math.max(i / e, e / i);
            }
            f /= a.count;
            return f;
        };
        StrippedCalculator.k = function (a) {
            var b = 0;
            for (var c = 0; c < a.count; c++) {
                var d = a._inner[c];
                b += d.e();
            }
            return b;
        };
        StrippedCalculator.p = function (a, b, c, d) {
            var e = 0;
            for (var f = 0; f < c.count; f++) {
                var g = c._inner[f];
            }
            var h = e;
            var i = b.f * b.f / (d.width * d.height);
            for (var j = 0; j < c.count; j++) {
                var k = c._inner[j];
                if (k.e() / h < i) {
                    a.add_1(k);
                }
            }
        };
        StrippedCalculator.$t = i2.markType(StrippedCalculator, 'StrippedCalculator', TreemapLayoutCalculator.$);
        return StrippedCalculator;
    }(TreemapLayoutCalculator));
    /**
     * @hidden
     */
    var SliceAndDiceCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SliceAndDiceCalculator, _super);
        function SliceAndDiceCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SliceAndDiceCalculator.prototype.d = function (a, b) {
            a.g();
            this.m(a, b.b.a, b.h, b, 0);
        };
        SliceAndDiceCalculator.prototype.o = function (a, b, c) {
            return c.j;
        };
        SliceAndDiceCalculator.prototype.m = function (a, b, c, d, e) {
            var e_4, _a;
            if (d.g >= 0 && e > d.g) {
                return;
            }
            if (b == d.c) {
                d.d = true;
                this.g(a, b, c, d);
                var f = new i2.Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
                c = f;
            }
            if (!d.d) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(b.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var g = _c.value;
                        this.m(a, g, c, d, e + 1);
                    }
                }
                catch (e_4_1) {
                    e_4 = { error: e_4_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_4)
                            throw e_4.error;
                    }
                }
                return;
            }
            var h = this.o(b, c, d);
            var i = SliceAndDiceCalculator.j(b, d, e);
            var j = h.c + h.d;
            var k = h.e + h.b;
            var l = new i2.Rect(0, c.left, c.top, c.width, c.height);
            if (j >= l.width || k >= l.height) {
                return;
            }
            l.x = l.x + h.c;
            l.width = l.width - j;
            l.y = l.y + h.e;
            l.height = l.height - k;
            var m = new i2.Size(1, l.width, l.height);
            var n = l.left;
            var o = l.top;
            var p = new i2.HashSet$1(TreemapTreeNode.$, 0);
            var q = SliceAndDiceCalculator.k(b.b, b, d, m, p);
            if (q) {
                SliceAndDiceCalculator.n(b.b, b, d, m, p);
            }
            var r = 0;
            for (var s = 0; s < b.b.count; s++) {
                var t = b.b._inner[s];
                if (!p.contains(t)) {
                    r += t.e();
                }
            }
            var u = (i == 0) ? m.height : m.width;
            var v = new i2.Rect(4);
            for (var w = 0; w < b.b.count; w++) {
                var x = b.b._inner[w];
                if (p.contains(x) || i2.isNaN_(x.e())) {
                    continue;
                }
                if (r <= 0 || u <= 0) {
                    break;
                }
                var y = x.e() / r;
                v.x = n;
                v.y = o;
                if (i == 0) {
                    v.width = m.width;
                    v.height = Math.round(u * y);
                }
                else {
                    v.width = Math.round(u * y);
                    v.height = m.height;
                }
                this.g(a, x, new i2.Rect(0, v.left, v.top, v.width, v.height), d);
                if (i == 0) {
                    o += v.height;
                    u -= v.height;
                }
                else {
                    n += v.width;
                    u -= v.width;
                }
                r -= x.e();
                var z = this.h(a, x, d);
                if (z.isEmpty) {
                    continue;
                }
                var aa = new i2.Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
                this.m(a, x, aa, d, e + 1);
            }
            if (b == d.c) {
                d.d = false;
            }
        };
        SliceAndDiceCalculator.j = function (a, b, c) {
            var d = 0;
            if (b.a == 0) {
                d = (c % 2 == 0) ? 0 : 1;
            }
            else {
                d = (c % 2 == 0) ? 1 : 0;
            }
            return d;
        };
        SliceAndDiceCalculator.k = function (a, b, c, d, e) {
            var f = true;
            var g = b.e();
            var h = Math.min(d.width, d.height);
            for (var i = 0; i < a.count; i++) {
                var j = a._inner[i];
                if (Math.round(j.e() / g * h) < c.f) {
                    if (!e.contains(j)) {
                        e.add_1(j);
                    }
                }
                else {
                    f = false;
                }
            }
            return f;
        };
        SliceAndDiceCalculator.n = function (a, b, c, d, e) {
            var f = new i2.List$1(TreemapTreeNode.$, 0);
            f.o(a);
            f.aa(function (g, h) {
                if (g.e() > h.e()) {
                    return 1;
                }
                else if (g.e() < h.e()) {
                    return -1;
                }
                return 0;
            });
            var g = 0;
            var h = Math.min(d.width, d.height);
            for (var i = 0; i < f.count; i++) {
                var j = f._inner[i];
                if (i2.isNaN_(j.e())) {
                    continue;
                }
                g += j.e();
                if (j.e() / g * h < c.f) {
                    break;
                }
                else {
                    if (e.contains(j)) {
                        e.remove(j);
                    }
                }
            }
        };
        SliceAndDiceCalculator.$t = i2.markType(SliceAndDiceCalculator, 'SliceAndDiceCalculator', TreemapLayoutCalculator.$);
        SliceAndDiceCalculator.l = null;
        return SliceAndDiceCalculator;
    }(TreemapLayoutCalculator));
    /**
     * @hidden
     */
    var TreemapLayoutSettings = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapLayoutSettings, _super);
        function TreemapLayoutSettings() {
            var _this = _super.call(this) || this;
            _this.a = 0;
            _this.h = null;
            _this.b = null;
            _this.j = null;
            _this.i = null;
            _this.e = 0;
            _this.f = 0;
            _this.g = 0;
            _this.c = null;
            _this.d = false;
            _this.g = -1;
            _this.d = false;
            return _this;
        }
        TreemapLayoutSettings.$t = i2.markType(TreemapLayoutSettings, 'TreemapLayoutSettings');
        return TreemapLayoutSettings;
    }(i2.Base));
    /**
     * @hidden
     */
    var SquarifiedCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SquarifiedCalculator, _super);
        function SquarifiedCalculator() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SquarifiedCalculator.prototype.n = function (a, b, c, d, e) {
            var e_5, _a, e_6, _b, e_7, _c;
            if (d.g >= 0 && e > d.g) {
                return;
            }
            if (b == d.c) {
                d.d = true;
                this.g(a, b, c, d);
                var f = new i2.Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
                c = f;
            }
            if (!d.d) {
                try {
                    for (var _d = tslib.__values(i2.fromEnum(b.b)), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var g = _e.value;
                        this.n(a, g, c, d, e + 1);
                    }
                }
                catch (e_5_1) {
                    e_5 = { error: e_5_1 };
                }
                finally {
                    try {
                        if (_e && !_e.done && (_a = _d.return))
                            _a.call(_d);
                    }
                    finally {
                        if (e_5)
                            throw e_5.error;
                    }
                }
                return;
            }
            var h = this.o(b, c, d);
            var i = new i2.Rect(0, c.left, c.top, c.width, c.height);
            var j = h.c + h.d;
            var k = h.e + h.b;
            if (j >= i.width || k >= i.height) {
                return;
            }
            i.x = i.x + h.c;
            i.width = i.width - j;
            i.y = i.y + h.e;
            i.height = i.height - k;
            var l = i.left;
            var m = i.top;
            var n = new i2.List$1(TreemapTreeNode.$, 0);
            var o = b.e();
            var p = new i2.Rect(0, i.left, i.top, i.width, i.height);
            var q = (i.width * i.height) / o;
            var r = new i2.List$1(TreemapTreeNode.$, 1, b.b);
            r.aa(function (s, t) {
                if (t.e() < s.e()) {
                    return -1;
                }
                if (t.e() > s.e()) {
                    return 1;
                }
                return 0;
            });
            var s = new AreaInfo();
            s.b = i;
            s.a = o;
            var t = new i2.HashSet$1(TreemapTreeNode.$, 0);
            try {
                for (var _f = tslib.__values(i2.fromEnum(r)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var u = _g.value;
                    if (TreemapLayoutCalculator.c(u, p, o, d) || i2.isNaN_(u.e())) {
                        t.add_1(u);
                        continue;
                    }
                    var v = Math.min(i.width, i.height);
                    var w = SquarifiedCalculator.j(n, v, q);
                    n.add(u);
                    var x = SquarifiedCalculator.j(n, v, q);
                    if (w <= x) {
                        n.removeAt(n.count - 1);
                        this.l(t, a, n, s, d);
                        i = s.b;
                        n.add(u);
                    }
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            this.l(t, a, n, s, d);
            i = s.b;
            try {
                for (var _h = tslib.__values(i2.fromEnum(b.b)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var y = _j.value;
                    if (t.contains(y)) {
                        continue;
                    }
                    var z = this.h(a, y, d);
                    if (z.isEmpty) {
                        continue;
                    }
                    var aa = new i2.Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
                    this.n(a, y, aa, d, e + 1);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            if (b == d.c) {
                d.d = false;
            }
        };
        SquarifiedCalculator.prototype.o = function (a, b, c) {
            return c.j;
        };
        SquarifiedCalculator.j = function (a, b, c) {
            var e_8, _a;
            if (a.count == 0) {
                return 1.7976931348623157E+308;
            }
            var d = 0;
            var e = 1.7976931348623157E+308;
            var f = -1.7976931348623157E+308;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    var h = g.e() * c;
                    if (e > h) {
                        e = h;
                    }
                    if (f < h) {
                        f = h;
                    }
                    d += h;
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            var i = (b * b * f) / (d * d);
            var j = (d * d) / (b * b * e);
            return Math.max(i, j);
        };
        SquarifiedCalculator.prototype.l = function (a, b, c, d, e) {
            if (c.count < 1) {
                return;
            }
            var f = 0;
            for (var g = 0; g < c.count; ++g) {
                f += c._inner[g].e();
            }
            if (f <= 0) {
                return;
            }
            if (d.b.width > d.b.height) {
                this.k(a, b, c, f, d, e);
            }
            else {
                this.m(a, b, c, f, d, e);
            }
        };
        SquarifiedCalculator.prototype.m = function (a, b, c, d, e, f) {
            var g = e.b;
            var h = e.a;
            var i = Math.round((d / h) * g.height);
            var j = g.x;
            for (var k = 0; k < c.count; ++k) {
                var l = c._inner[k];
                if (g.right < j) {
                    a.add_1(l);
                    continue;
                }
                var m = Math.floor((l.e() / d) * g.width);
                var n = new i2.Rect(0, j, g.y, m, i);
                if (TreemapLayoutCalculator.b(n, f)) {
                    a.add_1(l);
                    continue;
                }
                this.g(b, l, n, f);
                j += n.width;
            }
            this.f(a, b, c, g.right - j, g, f);
            g.y = g.y + i;
            if (g.height < i) {
                g.height = 0;
            }
            else {
                g.height = g.height - i;
            }
            h -= d;
            e.a = h;
            e.b = g;
            c.clear();
        };
        SquarifiedCalculator.prototype.k = function (a, b, c, d, e, f) {
            var g = e.b;
            var h = e.a;
            var i = Math.round((d / h) * g.width);
            var j = g.y;
            for (var k = 0; k < c.count; ++k) {
                var l = c._inner[k];
                if (g.bottom < j) {
                    a.add_1(l);
                    continue;
                }
                var m = Math.floor((l.e() / d) * g.height);
                var n = new i2.Rect(0, g.x, j, i, m);
                if (TreemapLayoutCalculator.b(n, f)) {
                    a.add_1(l);
                    continue;
                }
                this.g(b, l, n, f);
                j += n.height;
            }
            this.e(a, b, c, g.bottom - j, g, f);
            g.x = g.x + i;
            if (g.width < i) {
                g.width = 0;
            }
            else {
                g.width = g.width - i;
            }
            h -= d;
            e.a = h;
            e.b = g;
            c.clear();
        };
        SquarifiedCalculator.prototype.d = function (a, b) {
            a.g();
            this.n(a, b.b.a, b.h, b, 0);
        };
        SquarifiedCalculator.$t = i2.markType(SquarifiedCalculator, 'SquarifiedCalculator', TreemapLayoutCalculator.$);
        return SquarifiedCalculator;
    }(TreemapLayoutCalculator));
    /**
     * @hidden
     */
    var TreemapTreeData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapTreeData, _super);
        function TreemapTreeData() {
            var _this = _super.call(this) || this;
            _this.a = null;
            _this.b = null;
            _this.d = null;
            _this.c = null;
            _this.b = new i2.Dictionary$2(i2.String_$type, TreemapTreeNode.$, 0);
            _this.d = new i2.List$1(i2.String_$type, 0);
            _this.c = new i2.Dictionary$2(i2.String_$type, i2.List$1.$.specialize(TreemapTreeNode.$), 0);
            _this.a = new TreemapTreeNode();
            return _this;
        }
        TreemapTreeData.prototype.e = function (a) {
            var e_9, _a;
            var _this = this;
            this.b.addItem(a.i, a);
            this.d.add(a.i);
            if (a.k == null) {
                this.a.b.add(a);
            }
            else if (this.b.containsKey(a.k)) {
                this.b.item(a.k).b.add(a);
            }
            else {
                var b_1;
                if (!((function () { var c = _this.c.tryGetValue(a.k, b_1); b_1 = c.p1; return c.ret; })())) {
                    b_1 = new i2.List$1(TreemapTreeNode.$, 0);
                    this.c.item(a.k, b_1);
                }
                b_1.add(a);
            }
            if (this.c.containsKey(a.i)) {
                try {
                    for (var _b = tslib.__values(i2.fromEnum(this.c.item(a.i))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a.b.add(c);
                    }
                }
                catch (e_9_1) {
                    e_9 = { error: e_9_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_9)
                            throw e_9.error;
                    }
                }
                this.c.removeItem(a.i);
            }
        };
        TreemapTreeData.prototype.g = function (a) {
            if (i2.isNaN_(a.f)) {
                if (a.b.count > 0) {
                    a.d = 0;
                }
                for (var b = 0; b < a.b.count; b++) {
                    var c = a.b._inner[b];
                    this.g(c);
                    if (i2.isNaN_(c.f)) {
                        a.d = a.d + c.d;
                    }
                    else {
                        a.d = a.d + c.f;
                    }
                }
            }
        };
        TreemapTreeData.prototype.f = function () {
            this.g(this.a);
        };
        TreemapTreeData.$t = i2.markType(TreemapTreeData, 'TreemapTreeData');
        return TreemapTreeData;
    }(i2.Base));
    /**
     * @hidden
     */
    var TreemapTreeNode = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapTreeNode, _super);
        function TreemapTreeNode() {
            var _this = _super.call(this) || this;
            _this.i = null;
            _this.k = null;
            _this.b = null;
            _this.c = null;
            _this.f = 0;
            _this.g = null;
            _this.d = 0;
            _this.j = null;
            _this.h = null;
            _this.a = false;
            _this.b = new i2.List$1(TreemapTreeNode.$, 0);
            _this.f = NaN;
            _this.g = null;
            _this.c = new i2.List$1(TreemapNodeStyleMapping.$, 0);
            _this.d = 0;
            return _this;
        }
        TreemapTreeNode.prototype.e = function () {
            if (i2.isNaN_(this.f)) {
                return this.d;
            }
            return this.f;
        };
        TreemapTreeNode.$t = i2.markType(TreemapTreeNode, 'TreemapTreeNode');
        return TreemapTreeNode;
    }(i2.Base));
    /**
     * @hidden
     */
    var Treemap = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Treemap, _super);
        function Treemap() {
            var _this = _super.call(this) || this;
            _this.g = null;
            _this.f = null;
            _this.e = null;
            _this.ba = false;
            _this.an = null;
            _this.im = null;
            _this.ap = null;
            _this.ea = null;
            _this.d9 = "Root";
            _this.d4 = " : ";
            _this.d8 = null;
            _this.d7 = null;
            _this.d5 = null;
            _this.d6 = null;
            _this.bq = null;
            _this.a = new i2.BrushCollection();
            _this.ae = new TreemapNodeStyleMappingCollection();
            _this.c = 0;
            _this.bb = false;
            _this.dw = 10;
            _this.bx = NaN;
            _this.bw = NaN;
            _this.n = 0;
            _this.k = 0;
            _this.hy = null;
            _this.hs = null;
            _this.hq = null;
            _this.hx = null;
            _this.hv = null;
            _this.hr = null;
            _this.hz = null;
            _this.hp = null;
            _this.hu = null;
            _this.ht = null;
            _this.at = null;
            _this.as = null;
            _this.h = 0;
            _this.b0 = i2.DeviceUtils.g(5);
            _this.b2 = i2.DeviceUtils.g(3);
            _this.b1 = i2.DeviceUtils.g(5);
            _this.bz = i2.DeviceUtils.g(3);
            _this.ca = i2.DeviceUtils.g(10);
            _this.cc = i2.DeviceUtils.g(10);
            _this.cb = i2.DeviceUtils.g(10);
            _this.b9 = i2.DeviceUtils.g(10);
            _this.b5 = i2.DeviceUtils.g(5);
            _this.b7 = i2.DeviceUtils.g(3);
            _this.b6 = i2.DeviceUtils.g(5);
            _this.b4 = i2.DeviceUtils.g(3);
            _this.cf = i2.DeviceUtils.g(0);
            _this.cj = i2.DeviceUtils.g(0);
            _this.ch = i2.DeviceUtils.g(0);
            _this.cd = i2.DeviceUtils.g(0);
            _this.cg = i2.DeviceUtils.g(3);
            _this.ck = i2.DeviceUtils.g(3);
            _this.ci = i2.DeviceUtils.g(3);
            _this.ce = i2.DeviceUtils.g(3);
            _this.hm = 1;
            _this.iq = 1;
            _this.by = NaN;
            _this.hw = null;
            _this.cm = NaN;
            _this.ah = 0;
            _this.r = 0;
            _this.b8 = i2.DeviceUtils.g(3);
            _this.dx = 500;
            _this.cn = 0;
            _this.dv = null;
            _this.aq = null;
            _this.a1 = null;
            _this.ax = null;
            _this.a0 = null;
            _this.ay = null;
            _this.az = null;
            _this.cl = NaN;
            _this.bt = 1;
            _this.b3 = NaN;
            _this.bs = 0.5;
            _this.a9 = false;
            _this.bf = false;
            _this.bi = false;
            _this.be = false;
            _this.aj = null;
            _this.q = null;
            _this.bu = NaN;
            _this.bv = i2.DeviceUtils.g(1);
            _this.propertyChanged = null;
            _this.w = null;
            _this.t = null;
            _this.d2 = null;
            _this.am = null;
            _this.al = null;
            _this.il = null;
            _this.nodeStyling = null;
            _this.nodePointerOver = null;
            _this.nodePointerEnter = null;
            _this.nodePointerLeave = null;
            _this.nodePointerPressed = null;
            _this.nodePointerReleased = null;
            var a = new TreemapView();
            a.a = _this;
            _this.q = new SquarifiedCalculator();
            _this.an = a;
            _this.an.au();
            _this.dv = function (b, c) { return _this.go(c.action, c.position, c.count, c.propertyName); };
            _this.im = i2.Rect.empty;
            _this.g = new TreemapFrame();
            _this.f = new TreemapFrame();
            _this.e = new TreemapFrame();
            _this.bf = true;
            _this.ap = new i2.DoubleAnimator(0, 1, _this.d1);
            _this.ap.b = i2.EasingFunctions.cubicEase;
            var b = _this.ap;
            b.propertyChanged = i2.delegateCombine(b.propertyChanged, i2.runOn(_this, _this.gn));
            var c = _this.ae;
            c.collectionChanged = i2.delegateCombine(c.collectionChanged, i2.runOn(_this, _this.gl));
            var d = _this.ae;
            d.collectionResetting = i2.delegateCombine(d.collectionResetting, i2.runOn(_this, _this.gm));
            return _this;
        }
        Treemap.prototype.gm = function (a, b) {
            var e_10, _a;
            try {
                for (var _b = tslib.__values(i2.fromEnum(this.styleMappings)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    c.propertyChanged = i2.delegateRemove(c.propertyChanged, i2.runOn(this, this.hi));
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
            this.bf = true;
            this.bi = true;
            this.an.az();
        };
        Treemap.prototype.gl = function (a, b) {
            var e_11, _a, e_12, _b;
            if (b.oldItems != null) {
                try {
                    for (var _c = tslib.__values(i2.fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        var d = c;
                        if (d != null) {
                            d.propertyChanged = i2.delegateRemove(d.propertyChanged, i2.runOn(this, this.hi));
                        }
                    }
                }
                catch (e_11_1) {
                    e_11 = { error: e_11_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_11)
                            throw e_11.error;
                    }
                }
            }
            if (b.newItems != null) {
                try {
                    for (var _e = tslib.__values(i2.fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var e = _f.value;
                        var f = e;
                        if (f != null) {
                            f.propertyChanged = i2.delegateCombine(f.propertyChanged, i2.runOn(this, this.hi));
                        }
                    }
                }
                catch (e_12_1) {
                    e_12 = { error: e_12_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_12)
                            throw e_12.error;
                    }
                }
            }
            this.bf = true;
            this.bi = true;
            this.an.az();
        };
        Treemap.prototype.hi = function (a, b) {
            this.bf = true;
            this.bi = true;
            this.an.az();
        };
        Treemap.prototype.go = function (a, b, c, d) {
            this.aj = null;
            this.bf = true;
            this.be = true;
            this.bi = true;
            this.an.az();
        };
        Treemap.prototype.notifySizeChanged = function () {
            this.an.ap();
        };
        Treemap.prototype.destroy = function () {
            this.provideContainer(null);
        };
        Treemap.prototype.ao = function () {
            var a = new TreemapVisualData();
            a.viewport = new i2.RectData(this.ip.left, this.ip.top, this.ip.width, this.ip.height);
            a.nodes = new TreemapNodeVisualDataList();
            this.an.al(a);
            return a;
        };
        Treemap.prototype.ej = function () {
            var a = this.ao();
            a.scaleByViewport();
            return a.serialize();
        };
        Treemap.prototype.g7 = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            this.hc(a, b, c);
        };
        Treemap.prototype.hc = function (a, b, c) {
            var _this = this;
            switch (a) {
                case "FocusItem":
                    this.g1();
                    break;
                case "LayoutType":
                    {
                        switch (i2.EnumUtil.getEnumValue(TreemapLayoutType_$type, c)) {
                            case 0:
                                this.q = new SquarifiedCalculator();
                                break;
                            case 1:
                                this.q = new SliceAndDiceCalculator();
                                break;
                            case 2:
                                this.q = new StrippedCalculator();
                                break;
                        }
                        this.bf = true;
                        this.an.az();
                    }
                    break;
                case "BreadcrumbSequence":
                    this.bf = true;
                    this.an.az();
                    break;
                case "RootTitle":
                    this.bf = true;
                    this.an.az();
                    break;
                case "ValueMemberPath":
                    if (this.ar != null) {
                        this.ar.deregisterColumn(this.a8);
                        this.a8 = this.a6(this.gi);
                        this.aj = null;
                    }
                    this.bf = true;
                    this.be = true;
                    this.an.az();
                    break;
                case "CustomValueMemberPath":
                    if (this.ar != null) {
                        this.ar.deregisterColumn(this.a2);
                        this.a2 = this.a7(this.eg);
                        this.aj = null;
                    }
                    this.bf = true;
                    this.be = true;
                    this.an.az();
                    break;
                case "IdMemberPath":
                    if (this.ar != null) {
                        this.ar.deregisterColumn(this.a3);
                        this.a3 = this.a7(this.e5);
                        this.aj = null;
                    }
                    this.bf = true;
                    this.be = true;
                    this.an.az();
                    break;
                case "LabelMemberPath":
                    if (this.ar != null) {
                        this.ar.deregisterColumn(this.a4);
                        this.a4 = this.a7(this.ff);
                        this.aj = null;
                    }
                    this.bf = true;
                    this.be = true;
                    this.an.az();
                    break;
                case "ParentIdMemberPath":
                    if (this.ar != null) {
                        this.ar.deregisterColumn(this.a5);
                        this.a5 = this.a7(this.fw);
                        this.aj = null;
                    }
                    this.bf = true;
                    this.be = true;
                    this.an.az();
                    break;
                case "ItemsSource":
                    this.ar = ((function () {
                        var $ret = new i2.FastItemsSource();
                        $ret.e = _this.dataSource;
                        return $ret;
                    })());
                    break;
                case "HeaderLabelLeftMargin":
                case "HeaderLabelTopMargin":
                case "HeaderLabelRightMargin":
                case "HeaderLabelBottomMargin":
                case "LabelLeftMargin":
                case "LabelTopMargin":
                case "LabelRightMargin":
                case "LabelBottomMargin":
                case "ParentNodeLeftMargin":
                case "ParentNodeTopMargin":
                case "ParentNodeRightMargin":
                case "ParentNodeBottomMargin":
                case "ParentNodeLeftPadding":
                case "ParentNodeTopPadding":
                case "ParentNodeRightPadding":
                case "ParentNodeBottomPadding":
                case "HeaderTextColor":
                case "HeaderHoverTextColor":
                case "OverlayHeaderHoverBackground":
                case "HeaderHoverBackground":
                case "StrokeThickness":
                case "Outline":
                case "FillBrushes":
                case "IsFillScaleLogarithmic":
                case "FillScaleMinimumValue":
                case "FillScaleMaximumValue":
                case "HeaderBackground":
                case "OverlayHeaderBackground":
                case "HeaderHeight":
                case "FillScaleLogarithmBase":
                case "FillScaleMode":
                case "MinimumDisplaySize":
                case "LayoutOrientation":
                case "LabelHorizontalAlignment":
                case "LabelVerticalAlignment":
                case "HeaderDisplayMode":
                case "LabelHorizontalFitMode":
                case "LabelVerticalFitMode":
                    this.bf = true;
                    this.an.az();
                    break;
                case "TextStyle":
                    this.an.aw(this.aw);
                    this.bf = true;
                    this.an.az();
                    break;
                case "HeaderTextStyle":
                    this.an.at(this.au);
                    this.bf = true;
                    this.an.az();
                    break;
                case "PixelScalingRatio":
                    if (!i2.isNaN_(c)) {
                        this.cp = c;
                    }
                    break;
                case "ActualPixelScalingRatio":
                    if (i2.isNaN_(this.c0)) {
                        this.co = this.cp / 2;
                    }
                    if (this.an != null) {
                        this.an.av();
                    }
                    break;
                case "InteractionPixelScalingRatio":
                    if (!i2.isNaN_(c)) {
                        this.co = c;
                    }
                    break;
                case "ActualInteractionPixelScalingRatio":
                    if (this.an != null) {
                        this.an.av();
                    }
                    break;
                case "TransitionProgress":
                    if (this.du >= 1) {
                        this.ap.w();
                        this.an.av();
                        var d = this.f;
                        this.f = this.g;
                        this.g = d;
                        this.hb();
                        this.he(this.f);
                        this.an.ay();
                        this.an.az();
                        return;
                    }
                    this.e.h(this.du, this.g, this.f);
                    this.he(this.e);
                    this.an.ay();
                    break;
                case "Viewport":
                    this.bf = true;
                    this.an.az();
                    break;
                case "FastItemsSource":
                    var e = b;
                    var f = c;
                    if (b != null) {
                        e.event = i2.delegateRemove(e.event, this.dv);
                        this.a9 = false;
                        e.deregisterColumn(this.a8);
                        e.deregisterColumn(this.a3);
                        e.deregisterColumn(this.a5);
                        e.deregisterColumn(this.a4);
                        e.deregisterColumn(this.a2);
                        this.a8 = null;
                        this.a3 = null;
                        this.a5 = null;
                        this.a4 = null;
                        this.aj = null;
                    }
                    if (c != null) {
                        f.event = i2.delegateCombine(f.event, this.dv);
                        this.a9 = true;
                        this.a8 = this.a6(this.gi);
                        this.a3 = this.a7(this.e5);
                        this.a5 = this.a7(this.fw);
                        this.a4 = this.a7(this.ff);
                        this.a2 = this.a7(this.eg);
                    }
                    this.bf = true;
                    this.be = true;
                    this.an.az();
                    break;
                case "TransitionDuration":
                    this.ap.r = this.d1;
                    break;
            }
        };
        Treemap.prototype.g1 = function () {
            if (this.ba) {
                return;
            }
            if (this.aj == null) {
                return;
            }
            if (this.d3 == null) {
                this.al = null;
                this.bf = true;
                this.an.az();
                return;
            }
            for (var a = 0; a < this.aj.d.count; a++) {
                var b = this.aj.b.item(this.aj.d._inner[a]);
                if (b.h == this.d3) {
                    this.al = b;
                    this.bf = true;
                    this.an.az();
                    break;
                }
            }
        };
        Object.defineProperty(Treemap.prototype, "ip", {
            get: function () {
                return this.im;
            },
            set: function (a) {
                var b = this.im;
                this.im = a;
                if (!b.equals1(this.im)) {
                    this.g7("Viewport", b, this.im);
                }
            },
            enumerable: false,
            configurable: true
        });
        Treemap.prototype.gn = function (a, b) {
            this.du = this.ap.o;
        };
        Object.defineProperty(Treemap.prototype, "gi", {
            get: function () {
                return this.ea;
            },
            set: function (a) {
                var b = this.ea;
                this.ea = a;
                if (b != this.ea) {
                    this.hc("ValueMemberPath", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "f8", {
            get: function () {
                return this.d9;
            },
            set: function (a) {
                var b = this.d9;
                this.d9 = a;
                if (b != this.d9) {
                    this.hc("RootTitle", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ed", {
            get: function () {
                return this.d4;
            },
            set: function (a) {
                var b = this.d4;
                this.d4 = a;
                if (b != this.d9) {
                    this.hc("BreadcrumbSequence", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "fw", {
            get: function () {
                return this.d8;
            },
            set: function (a) {
                var b = this.d8;
                this.d8 = a;
                if (b != this.d8) {
                    this.g7("ParentIdMemberPath", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ff", {
            get: function () {
                return this.d7;
            },
            set: function (a) {
                var b = this.d7;
                this.d7 = a;
                if (b != this.d7) {
                    this.g7("LabelMemberPath", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "eg", {
            get: function () {
                return this.d5;
            },
            set: function (a) {
                var b = this.d5;
                this.d5 = a;
                if (b != this.d5) {
                    this.g7("CustomValueMemberPath", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "e5", {
            get: function () {
                return this.d6;
            },
            set: function (a) {
                var b = this.d6;
                this.d6 = a;
                if (b != this.d6) {
                    this.g7("IdMemberPath", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dataSource", {
            get: function () {
                return this.bq;
            },
            set: function (a) {
                var b = this.bq;
                this.bq = a;
                if (b != this.bq) {
                    this.g7("ItemsSource", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "b", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                var b = this.a;
                this.a = a;
                if (b != this.a) {
                    this.g7("FillBrushes", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "styleMappings", {
            get: function () {
                return this.ae;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "d", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                var b = this.c;
                this.c = a;
                if (b != this.c) {
                    this.g7("FillScaleMode", i2.enumGetBox(TreemapFillScaleMode_$type, b), i2.enumGetBox(TreemapFillScaleMode_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "bg", {
            get: function () {
                return this.bb;
            },
            set: function (a) {
                var b = this.bb;
                this.bb = a;
                if (b != this.bb) {
                    this.g7("IsFillScaleLogarithmic", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dy", {
            get: function () {
                return this.dw;
            },
            set: function (a) {
                var b = this.dw;
                this.dw = a;
                if (b != this.dw) {
                    this.g7("FillScaleLogarithmBase", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ct", {
            get: function () {
                return this.bx;
            },
            set: function (a) {
                var b = this.bx;
                this.bx = a;
                if (b != this.bx) {
                    this.g7("FillScaleMinimumValue", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cs", {
            get: function () {
                return this.bw;
            },
            set: function (a) {
                var b = this.bw;
                this.bw = a;
                if (b != this.bw) {
                    this.g7("FillScaleMaximumValue", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "p", {
            get: function () {
                return this.n;
            },
            set: function (a) {
                var b = this.n;
                this.n = a;
                if (b != this.n) {
                    this.g7("LabelVerticalFitMode", i2.enumGetBox(TreemapLabelVerticalFitMode_$type, b), i2.enumGetBox(TreemapLabelVerticalFitMode_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "o", {
            get: function () {
                return this.p == 0 ? 1 : this.p;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "m", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                var b = this.k;
                this.k = a;
                if (b != this.k) {
                    this.g7("LabelHorizontalFitMode", i2.enumGetBox(TreemapLabelHorizontalFitMode_$type, b), i2.enumGetBox(TreemapLabelHorizontalFitMode_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "l", {
            get: function () {
                return this.m == 0 ? 1 : this.m;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h9", {
            get: function () {
                return this.hy;
            },
            set: function (a) {
                var b = this.hy;
                this.hy = a;
                if (b != this.hy) {
                    this.g7("OverlayHeaderHoverBackground", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h3", {
            get: function () {
                return this.hs;
            },
            set: function (a) {
                var b = this.hs;
                this.hs = a;
                if (b != this.hs) {
                    this.g7("HeaderHoverBackground", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h1", {
            get: function () {
                return this.hq;
            },
            set: function (a) {
                var b = this.hq;
                this.hq = a;
                if (b != this.hq) {
                    this.g7("HeaderBackground", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h8", {
            get: function () {
                return this.hx;
            },
            set: function (a) {
                var b = this.hx;
                this.hx = a;
                if (b != this.hx) {
                    this.g7("OverlayHeaderBackground", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h6", {
            get: function () {
                return this.hv;
            },
            set: function (a) {
                var b = this.hv;
                this.hv = a;
                if (b != this.hv) {
                    this.g7("HeaderTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h2", {
            get: function () {
                return this.hr;
            },
            set: function (a) {
                var b = this.hr;
                this.hr = a;
                if (b != this.hr) {
                    this.g7("HeaderDarkTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ik", {
            get: function () {
                return this.hz;
            },
            set: function (a) {
                var b = this.hz;
                this.hz = a;
                if (b != this.hz) {
                    this.g7("TextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h0", {
            get: function () {
                return this.hp;
            },
            set: function (a) {
                var b = this.hp;
                this.hp = a;
                if (b != this.hp) {
                    this.g7("DarkTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h5", {
            get: function () {
                return this.hu;
            },
            set: function (a) {
                var b = this.hu;
                this.hu = a;
                if (b != this.hu) {
                    this.g7("HeaderHoverTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h4", {
            get: function () {
                return this.ht;
            },
            set: function (a) {
                var b = this.ht;
                this.ht = a;
                if (b != this.ht) {
                    this.g7("HeaderHoverDarkTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "aw", {
            get: function () {
                return this.at;
            },
            set: function (a) {
                var b = this.at;
                this.at = a;
                if (b != this.at) {
                    this.g7("TextStyle", b, this.at);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "au", {
            get: function () {
                return this.as;
            },
            set: function (a) {
                var b = this.as;
                this.as = a;
                if (b != this.as) {
                    this.g7("HeaderTextStyle", b, this.as);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "j", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.h;
                this.h = a;
                if (b != this.h) {
                    this.g7("HeaderDisplayMode", i2.enumGetBox(TreemapHeaderDisplayMode_$type, b), i2.enumGetBox(TreemapHeaderDisplayMode_$type, this.h));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "i", {
            get: function () {
                return this.j == 0 ? 1 : this.j;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cx", {
            get: function () {
                return this.b0;
            },
            set: function (a) {
                var b = this.b0;
                this.b0 = a;
                if (b != this.b0) {
                    this.g7("HeaderLabelLeftMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cz", {
            get: function () {
                return this.b2;
            },
            set: function (a) {
                var b = this.b2;
                this.b2 = a;
                if (b != this.b2) {
                    this.g7("HeaderLabelTopMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cy", {
            get: function () {
                return this.b1;
            },
            set: function (a) {
                var b = this.b1;
                this.b1 = a;
                if (b != this.b1) {
                    this.g7("HeaderLabelRightMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cw", {
            get: function () {
                return this.bz;
            },
            set: function (a) {
                var b = this.bz;
                this.bz = a;
                if (b != this.bz) {
                    this.g7("HeaderLabelBottomMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c7", {
            get: function () {
                return this.ca;
            },
            set: function (a) {
                var b = this.ca;
                this.ca = a;
                if (b != this.ca) {
                    this.g7("OverlayHeaderLabelLeftMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c9", {
            get: function () {
                return this.cc;
            },
            set: function (a) {
                var b = this.cc;
                this.cc = a;
                if (b != this.cc) {
                    this.g7("OverlayHeaderLabelTopMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c8", {
            get: function () {
                return this.cb;
            },
            set: function (a) {
                var b = this.cb;
                this.cb = a;
                if (b != this.cb) {
                    this.g7("OverlayHeaderLabelRightMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c6", {
            get: function () {
                return this.b9;
            },
            set: function (a) {
                var b = this.b9;
                this.b9 = a;
                if (b != this.b9) {
                    this.g7("OverlayHeaderLabelBottomMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c2", {
            get: function () {
                return this.b5;
            },
            set: function (a) {
                var b = this.b5;
                this.b5 = a;
                if (b != this.b5) {
                    this.g7("LabelLeftMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c4", {
            get: function () {
                return this.b7;
            },
            set: function (a) {
                var b = this.b7;
                this.b7 = a;
                if (b != this.b7) {
                    this.g7("LabelTopMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c3", {
            get: function () {
                return this.b6;
            },
            set: function (a) {
                var b = this.b6;
                this.b6 = a;
                if (b != this.b6) {
                    this.g7("LabelRightMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c1", {
            get: function () {
                return this.b4;
            },
            set: function (a) {
                var b = this.b4;
                this.b4 = a;
                if (b != this.b4) {
                    this.g7("LabelBottomMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dc", {
            get: function () {
                return this.cf;
            },
            set: function (a) {
                var b = this.cf;
                this.cf = a;
                if (b != this.cf) {
                    this.g7("ParentNodeLeftMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dg", {
            get: function () {
                return this.cj;
            },
            set: function (a) {
                var b = this.cj;
                this.cj = a;
                if (b != this.cj) {
                    this.g7("ParentNodeTopMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "de", {
            get: function () {
                return this.ch;
            },
            set: function (a) {
                var b = this.ch;
                this.ch = a;
                if (b != this.ch) {
                    this.g7("ParentNodeRightMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "da", {
            get: function () {
                return this.cd;
            },
            set: function (a) {
                var b = this.cd;
                this.cd = a;
                if (b != this.cd) {
                    this.g7("ParentNodeBottomMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dd", {
            get: function () {
                return this.cg;
            },
            set: function (a) {
                var b = this.cg;
                this.cg = a;
                if (b != this.cg) {
                    this.g7("ParentNodeLeftPadding", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dh", {
            get: function () {
                return this.ck;
            },
            set: function (a) {
                var b = this.ck;
                this.ck = a;
                if (b != this.ck) {
                    this.g7("ParentNodeTopPadding", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "df", {
            get: function () {
                return this.ci;
            },
            set: function (a) {
                var b = this.ci;
                this.ci = a;
                if (b != this.ci) {
                    this.g7("ParentNodeRightPadding", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "db", {
            get: function () {
                return this.ce;
            },
            set: function (a) {
                var b = this.ce;
                this.ce = a;
                if (b != this.ce) {
                    this.g7("ParentNodeBottomPadding", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "hn", {
            get: function () {
                return this.hm;
            },
            set: function (a) {
                var b = this.hm;
                this.hm = a;
                if (b != this.hm) {
                    this.g7("LabelHorizontalAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ir", {
            get: function () {
                return this.iq;
            },
            set: function (a) {
                var b = this.iq;
                this.iq = a;
                if (b != this.iq) {
                    this.g7("LabelVerticalAlignment", i2.enumGetBox(i2.VerticalAlignment_$type, b), i2.enumGetBox(i2.VerticalAlignment_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cv", {
            get: function () {
                return this.by;
            },
            set: function (a) {
                var b = this.by;
                this.by = a;
                if (b != this.by) {
                    this.g7("HeaderHeight", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "h7", {
            get: function () {
                return this.hw;
            },
            set: function (a) {
                var b = this.hw;
                this.hw = a;
                if (b != this.hw) {
                    this.g7("Outline", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "dt", {
            get: function () {
                return this.cm;
            },
            set: function (a) {
                var b = this.cm;
                this.cm = a;
                if (b != this.cm) {
                    this.g7("StrokeThickness", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ai", {
            get: function () {
                return this.ah;
            },
            set: function (a) {
                var b = this.ah;
                this.ah = a;
                if (b != this.ah) {
                    this.g7("LayoutOrientation", i2.enumGetBox(TreemapOrientation_$type, b), i2.enumGetBox(TreemapOrientation_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "s", {
            get: function () {
                return this.r;
            },
            set: function (a) {
                var b = this.r;
                this.r = a;
                if (b != this.r) {
                    this.g7("LayoutType", i2.enumGetBox(TreemapLayoutType_$type, b), i2.enumGetBox(TreemapLayoutType_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c5", {
            get: function () {
                return this.b8;
            },
            set: function (a) {
                var b = this.b8;
                this.b8 = a;
                if (b != this.b8) {
                    this.g7("MinimumDisplaySize", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "d1", {
            get: function () {
                return this.dx;
            },
            set: function (a) {
                var b = this.dx;
                this.dx = a;
                if (b != this.dx) {
                    this.g7("TransitionDuration", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "du", {
            get: function () {
                return this.cn;
            },
            set: function (a) {
                var b = this.cn;
                this.cn = a;
                if (b != this.cn) {
                    this.g7("TransitionProgress", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "ar", {
            get: function () {
                return this.aq;
            },
            set: function (a) {
                var b = this.aq;
                this.aq = a;
                if (b != this.aq) {
                    this.g7("FastItemsSource", b, this.aq);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "a8", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                this.a1 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "a2", {
            get: function () {
                return this.ax;
            },
            set: function (a) {
                this.ax = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "a5", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                this.a0 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "a3", {
            get: function () {
                return this.ay;
            },
            set: function (a) {
                this.ay = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "a4", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                this.az = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "di", {
            get: function () {
                return this.cl;
            },
            set: function (a) {
                var b = this.cl;
                this.cl = a;
                if (b != this.cl) {
                    this.g7("PixelScalingRatio", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "cp", {
            get: function () {
                return this.bt;
            },
            set: function (a) {
                var b = this.bt;
                this.bt = a;
                if (b != this.bt) {
                    this.g7("ActualPixelScalingRatio", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "c0", {
            get: function () {
                return this.b3;
            },
            set: function (a) {
                var b = this.b3;
                this.b3 = a;
                if (b != this.b3) {
                    this.g7("InteractionPixelScalingRatio", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Treemap.prototype, "co", {
            get: function () {
                return this.bs;
            },
            set: function (a) {
                var b = this.bs;
                this.bs = a;
                if (b != this.bs) {
                    this.g7("ActualInteractionPixelScalingRatio", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Treemap.prototype.a6 = function (a) {
            var b = null;
            return this.ar.registerColumn(a, b, false);
        };
        Treemap.prototype.a7 = function (a) {
            var b = null;
            return this.ar.registerColumnObject(a, b, false);
        };
        Treemap.prototype.gt = function () {
            this.bf = true;
            this.an.az();
        };
        Object.defineProperty(Treemap.prototype, "bc", {
            get: function () {
                return this.ap.f();
            },
            enumerable: false,
            configurable: true
        });
        Treemap.prototype.ak = function () {
            var a = new TreemapTreeData();
            if (this.a8 == null || (this.a4 == null && this.a3 == null)) {
                return null;
            }
            for (var b = 0; b < this.ar.count; b++) {
                var c = null;
                if (this.a2 != null && this.a2.count > b) {
                    c = this.a2.item(b);
                }
                var d = this.a8.item(b);
                var e = null;
                var f = "";
                if (this.a4 != null) {
                    f = this.a4.item(b) != null ? this.a4.item(b).toString() : "";
                }
                if (this.a3 != null) {
                    if (this.a3.item(b) == null) {
                        continue;
                    }
                    e = i2.stringReplace(this.a3.item(b).toString(), " ", "_");
                }
                if (e == null) {
                    e = i2.stringReplace(f, " ", "_");
                    if (i2.stringIsNullOrEmpty(e)) {
                        continue;
                    }
                }
                var g = null;
                if (this.a5 != null) {
                    g = this.a5.item(b) != null ? i2.stringReplace(this.a5.item(b).toString(), " ", "_") : null;
                }
                var h = new TreemapTreeNode();
                h.i = e;
                h.k = g;
                h.h = this.ar.item(b);
                h.f = d;
                h.g = c;
                h.j = f;
                a.e(h);
            }
            a.f();
            return a;
        };
        Treemap.prototype.hb = function () {
            if (this.aj == null) {
                this.aj = this.ak();
                if (this.aj == null) {
                    return;
                }
                this.g1();
            }
            if (this.bi) {
                this.bi = false;
                for (var a = 0; a < this.aj.d.count; a++) {
                    var b = this.aj.b.item(this.aj.d._inner[a]);
                    b.c.clear();
                    for (var c = 0; c < this.styleMappings.count; c++) {
                        if (this.bd(this.styleMappings._inner[c], b)) {
                            b.c.add(this.styleMappings._inner[c]);
                        }
                    }
                }
            }
            if (!this.an.n()) {
                return;
            }
            var d = new TreemapLayoutSettings();
            d.b = this.aj;
            if (this.al != null && !this.aj.b.containsKey(this.al.i)) {
                this.al = null;
                this.hj(null);
            }
            else {
                if (this.al != null) {
                    var e = this.aj.b.item(this.al.i);
                    if (e != this.al) {
                        this.al = e;
                        this.hj(this.al);
                    }
                }
            }
            d.h = this.ip;
            d.c = this.al;
            d.f = this.c5;
            d.a = this.ai;
            var f = this.i;
            var g = this.dk();
            var h = this.dm();
            var i = this.dl();
            var j = this.dj();
            var k = this.dp();
            var l = this.dr();
            var m = this.dq();
            var n = this.dn();
            var o = this.ho();
            var p = this.is();
            var q = this.an.v("M");
            var r = this.an.x("M");
            var s = q + h + j;
            var t = r + l + n;
            d.j = new i2.Thickness(1, this.dd, this.dh, this.df, this.db);
            d.i = new i2.Thickness(1, this.dc, this.dg, this.de, this.da);
            if (!i2.isNaN_(this.cv)) {
                s = this.cv;
            }
            d.e = s;
            if (f == 2) {
                d.e = 0;
            }
            d.d = this.al == null;
            this.q.d(this.f, d);
            var u = 1.7976931348623157E+308;
            var v = -1.7976931348623157E+308;
            if (this.d == 1 || this.d == 3) {
                for (var w = 0; w < this.aj.d.count; w++) {
                    var x = 0;
                    if (this.d == 1) {
                        x = this.aj.b.item(this.aj.d._inner[w]).e();
                    }
                    else {
                        x = this.aj.b.item(this.aj.d._inner[w]).f;
                    }
                    if (!i2.isNaN_(x)) {
                        u = Math.min(x, u);
                        v = Math.max(x, v);
                    }
                }
            }
            else {
                for (var y = 0; y < this.f.e.count; y++) {
                    var z = 0;
                    if (this.d == 0) {
                        z = this.aj.b.item(this.f.e._inner[y]).e();
                    }
                    else {
                        z = this.aj.b.item(this.f.e._inner[y]).f;
                    }
                    if (!i2.isNaN_(z)) {
                        u = Math.min(z, u);
                        v = Math.max(z, v);
                    }
                }
            }
            for (var aa = 0; aa < this.f.e.count; aa++) {
                var ab = this.f.e._inner[aa];
                var ac = this.aj.b.item(ab);
                var ad = this.ia(ac, u, v);
                var ae = this.ig(ac);
                var af = this.ib(ac);
                var ag = this.ds(ac);
                var ah = this.f7(this.f, ac, g, i, k, m, s, t);
                var ai = this.ie(ac, ad, af);
                var aj = this.av(ac);
                var ak = 0;
                if (this.bh(ac)) {
                    ak = this.an.w(ah);
                }
                else {
                    ak = this.an.y(ah);
                }
                var al = 0;
                if (this.bh(ac)) {
                    al = s;
                }
                else {
                    al = this.an.x(ah);
                }
                this.f.l(ac, ah, ad, ae, af, ai, ag, f, ak, al, g, h, i, j, k, l, m, n, o, p);
                if (ac.c.count > 0) {
                    for (var am = 0; am < ac.c.count; am++) {
                        var an = ac.b != null && ac.b.count > 0;
                        if (ac.c._inner[am].bf == 2 && an) {
                            continue;
                        }
                        this.f.f(ac, ac.c._inner[am], i2.runOn(this, this.ie));
                    }
                }
                if (this.nodeStyling != null) {
                    var ao = new TreemapNodeStylingEventArgs();
                    ao.item = ac.h;
                    if (ac.k != null) {
                        if (this.aj.b.containsKey(ac.k)) {
                            var ap = this.aj.b.item(ac.k);
                            ao.parentItem = ap.h;
                            ao.parentLabel = ap.j;
                            ao.parentSum = ap.e();
                            ao.parentValue = ap.f;
                        }
                    }
                    ao.sum = ac.e();
                    ao.value = ac.f;
                    ao.label = ac.j;
                    ao.customValue = ac.g;
                    if (ac.b != null && ac.b.count > 0) {
                        ao.isParent = true;
                    }
                    ao.style = new TreemapNodeStyle();
                    this.nodeStyling(this, ao);
                    this.f.f(ac, ao.style, i2.runOn(this, this.ie));
                }
            }
        };
        Treemap.prototype.bh = function (a) {
            return a.b != null && a.b.count > 0;
        };
        Treemap.prototype.dn = function () {
            return this.c1;
        };
        Treemap.prototype.dq = function () {
            return this.c3;
        };
        Treemap.prototype.dr = function () {
            return this.c4;
        };
        Treemap.prototype.dp = function () {
            return this.c2;
        };
        Treemap.prototype.ho = function () {
            return this.hn;
        };
        Treemap.prototype.is = function () {
            return this.ir;
        };
        Treemap.prototype.dj = function () {
            if (this.i == 2) {
                return this.c6;
            }
            return this.cw;
        };
        Treemap.prototype.dl = function () {
            if (this.i == 2) {
                return this.c8;
            }
            return this.cy;
        };
        Treemap.prototype.dm = function () {
            if (this.i == 2) {
                return this.c9;
            }
            return this.cz;
        };
        Treemap.prototype.dk = function () {
            if (this.i == 2) {
                return this.c6;
            }
            return this.cx;
        };
        Treemap.prototype.gg = function (a, b, c, d, e) {
            var f = b.length;
            var g = b;
            var h = ("\u2026");
            if (i2.isNaN_(this.bu)) {
                if (this.bh(a)) {
                    this.bu = this.an.w(h);
                }
                else {
                    this.bu = this.an.y(h);
                }
            }
            if (c <= (this.bu + d + e)) {
                if (this.l == 2) {
                    return "";
                }
                return h;
            }
            var i = 0;
            if (this.bh(a)) {
                i = this.an.w(b);
            }
            else {
                i = this.an.y(b);
            }
            if (i + d + e <= c) {
                return b;
            }
            var j = c / (i + d + e);
            var k = i2.truncate(Math.ceil(f * j));
            var l = b.substr(0, k) + h;
            var m = 0;
            if (this.bh(a)) {
                m = this.an.w(l);
            }
            else {
                m = this.an.y(l);
            }
            if ((m + d + e) > c) {
                f = k;
            }
            else {
                k = k + 1;
                l = b.substr(0, k) + h;
                if (this.bh(a)) {
                    m = this.an.w(l);
                }
                else {
                    m = this.an.y(l);
                }
                if ((m + d + e) > c) {
                    f = k;
                }
            }
            while ((i + d + e) > c && f > 0) {
                f--;
                b = b.substr(0, f) + h;
                if (this.l == 2) {
                    return "";
                }
                if (this.bh(a)) {
                    i = this.an.w(b);
                }
                else {
                    i = this.an.y(b);
                }
            }
            return b;
        };
        Treemap.prototype.f7 = function (a, b, c, d, e, f, g, h) {
            if (b == null) {
                if (this.ed != null && this.f8 != null && !i2.stringIsNullOrEmpty(this.f8)) {
                    return this.f8 + this.ed;
                }
                return "";
            }
            var i = a.o(b);
            var j = i.width;
            var k = i.height;
            var l = b.j;
            if (this.al != null && this.al == b && this.ed != null) {
                var m = null;
                var n = b;
                while (n.k != null) {
                    if (this.aj.b.containsKey(n.k)) {
                        m = this.aj.b.item(n.k);
                        if (m.j != null) {
                            l = m.j + this.ed + l;
                        }
                        n = m;
                    }
                }
                if (this.f8 != null && !i2.stringIsNullOrEmpty(this.f8)) {
                    l = this.f8 + this.ed + l;
                }
            }
            var o = 0;
            var p = 0;
            if (a.c(b.i)) {
                var q = a.a(b.i);
                if (b.b.count > 0) {
                    o = c;
                    p = d;
                    if (this.o == 2) {
                        if (k < g) {
                            return "";
                        }
                    }
                }
                else {
                    o = e;
                    p = f;
                    if (this.o == 2) {
                        if (k < h) {
                            return "";
                        }
                    }
                }
            }
            return this.gg(b, l, j, o, p);
        };
        Treemap.prototype.ds = function (a) {
            if (!i2.isNaN_(this.dt)) {
                return this.dt;
            }
            return this.bv;
        };
        Treemap.prototype.ib = function (a) {
            if (this.i == 2) {
                return this.ih(a);
            }
            if (a == this.am) {
                return this.ic(a);
            }
            if (this.h1 != null) {
                return this.h1;
            }
            return this.an.a4();
        };
        Treemap.prototype.ih = function (a) {
            if (a == this.am) {
                return this.ii(a);
            }
            if (this.h8 != null) {
                return this.h8;
            }
            return this.an.a9();
        };
        Treemap.prototype.ie = function (a, b, c) {
            if (a.b.count > 0) {
                if (a == this.am) {
                    return this.id(a, c);
                }
                var d = this.an.a5();
                var e = this.an.a6();
                if (this.h6 != null) {
                    e = this.h6;
                }
                if (this.h2 != null) {
                    d = this.h2;
                }
                return i2.BrushUtil.i(c, d, e);
            }
            else {
                var f = this.an.a3();
                var g = this.an.bb();
                if (this.ik != null) {
                    g = this.ik;
                }
                if (this.h0 != null) {
                    f = this.h0;
                }
                return i2.BrushUtil.i(b, f, g);
            }
        };
        Treemap.prototype.av = function (a) {
            if (a.b.count > 0) {
                if (this.au != null) {
                    return this.au;
                }
                return this.an.h();
            }
            else {
                if (this.aw != null) {
                    return this.aw;
                }
                return this.an.h();
            }
        };
        Treemap.prototype.onDetachedFromUI = function () {
            this.an.as();
        };
        Treemap.prototype.onAttachedToUI = function () {
            this.an.aq();
        };
        Treemap.prototype.ic = function (a) {
            if (this.h3 != null) {
                return this.h3;
            }
            return this.an.a7();
        };
        Treemap.prototype.ii = function (a) {
            if (this.h9 != null) {
                return this.h9;
            }
            return this.an.ba();
        };
        Treemap.prototype.id = function (a, b) {
            var c = this.an.a5();
            var d = this.an.a6();
            if (this.h6 != null) {
                d = this.h6;
            }
            if (this.h2 != null) {
                c = this.h2;
            }
            if (this.h5 != null) {
                d = this.h5;
            }
            if (this.h4 != null) {
                c = this.h4;
            }
            return i2.BrushUtil.i(b, c, d);
        };
        Treemap.prototype.ig = function (a) {
            if (this.h7 != null) {
                return this.h7;
            }
            return this.an.a8();
        };
        Treemap.prototype.ia = function (a, b, c) {
            if (this.b == null || this.b.count == 0) {
                return this.ij(a);
            }
            var d = this.cu(a);
            if (i2.isNaN_(d)) {
                return this.ij(a);
            }
            var e = 0;
            if (this.bg && this.dy > 0) {
                if (d > 0) {
                    e = (i2.logBase(d, this.dy) - i2.logBase(b, this.dy)) / (i2.logBase(c, this.dy) - i2.logBase(b, this.dy));
                }
                else {
                    return this.ij(a);
                }
            }
            else {
                e = (d - b) / (c - b);
            }
            e = e * (this.b.count - 1);
            return i2.BrushCollectionUtil.b(this.b, e);
        };
        Treemap.prototype.cu = function (a) {
            switch (this.d) {
                case 0:
                case 1: return a.e();
                case 2:
                case 3: return a.f;
            }
            return a.e();
        };
        Treemap.prototype.ij = function (a) {
            return this.an.a4();
        };
        Treemap.prototype.he = function (a) {
            var b = new i2.List$1(TreemapVisual.$, 0);
            var c = this.an.i();
            var d = 0;
            if (this.i == 2) {
                d = this.d0(a, false, d, c, function (e) { return true; }, b);
                d = this.d0(a, true, d, c, function (e) { return e.e.b != null && e.e.b.count > 0; }, b);
            }
            else {
                d = this.d0(a, false, d, c, function (e) { return true; }, b);
            }
            c.count = d;
            this.an.af(b);
        };
        Treemap.prototype.d0 = function (a, b, c, d, e, f) {
            for (var g = 0; g < a.e.count; g++) {
                var h = a.e._inner[g];
                var i = a.a(h);
                if (!e(i)) {
                    continue;
                }
                var j = d.item(c);
                if (i.y.isEmpty || (i.y.width == 0 && i.y.height == 0)) {
                    j.t = 1;
                    continue;
                }
                c++;
                f.add(j);
                var k = i.e.b.count == 0;
                var l = !k && i.a == 2;
                j.a = this.av(i.e);
                j.i = i.u;
                j.l = i.x;
                j.j = i.v;
                j.n = new i2.Thickness(1, i.i, i.k, i.j, i.h);
                j.o = new i2.Thickness(1, i.n, i.p, i.o, i.m);
                j.k = i.w;
                j.g = i.s;
                j.f = i.q;
                j.t = 0;
                j.m = this.io(i.y, i.q);
                j.b = k;
                j.q = !k && !l ? 0 : 1;
                j.s = !k && l ? 0 : 1;
                j.r = k ? 0 : 1;
                j.e = i.l;
                j.d = i.g;
                j.h = i.t;
                j.p = i.z;
                if (!b && !k && l) {
                    j.s = 1;
                }
                if (b && !k && l) {
                    j.i = null;
                    j.l = null;
                }
            }
            return c;
        };
        Treemap.prototype.io = function (a, b) {
            var c = this.cq(Math.floor(a.left), b);
            var d = this.cq(Math.floor(a.right), b);
            var e = this.cq(Math.floor(a.top), b);
            var f = this.cq(Math.floor(a.bottom), b);
            return new i2.Rect(0, c, e, d - c, f - e);
        };
        Treemap.prototype.cq = function (a, b) {
            var c = a;
            if (b > 0) {
                var d = b % 2;
                if (d == 0 || d == 1) {
                    var e = 1;
                    c = Math.floor(a);
                    if (c + 0.5 < a) {
                        e = -1;
                        c = Math.ceil(a);
                    }
                    if (d == 1) {
                        c += 0.5 * e;
                    }
                }
            }
            return c;
        };
        Treemap.prototype.bm = function () {
            return !this.ip.isEmpty && this.an.n();
        };
        Treemap.prototype.hf = function () {
            if (!this.bm()) {
                return;
            }
            if (this.bf) {
                var a = this.g;
                if (this.bc) {
                    if (this.ap.g) {
                        this.ap.t();
                    }
                    this.g = this.e;
                    this.e = a;
                }
                else {
                    this.g = this.f;
                    this.f = a;
                }
            }
            else if (this.bc) {
                this.e.h(this.du, this.g, this.f);
                this.he(this.e);
            }
            if (this.bf) {
                this.hb();
            }
            if (this.bf && this.bn) {
                this.hh();
                this.e.h(this.du, this.g, this.f);
                this.he(this.e);
            }
            else {
                if (this.bf) {
                    this.he(this.f);
                }
            }
            this.bf = false;
            this.an.ay();
        };
        Treemap.prototype.bd = function (a, b) {
            var c = null;
            switch (a.bh) {
                case 1:
                    c = b.f;
                    break;
                case 0:
                    c = b.e();
                    break;
                case 2:
                    c = b.g;
                    break;
            }
            if (this.bj(c)) {
                var d = this.cr(c);
                if (a.bn != null) {
                    if (this.bj(a.bn)) {
                        var e = this.cr(a.bn);
                        if (i2.isNaN_(e) && i2.isNaN_(d)) {
                            return true;
                        }
                        if (d == e) {
                            return true;
                        }
                    }
                }
                else if (!i2.isNaN_(a.bl) || !i2.isNaN_(a.bk)) {
                    var f = a.bl;
                    var g = a.bk;
                    if (d >= f && d <= g) {
                        return true;
                    }
                }
            }
            else if (this.bl(c)) {
                if (a.bn != null) {
                    if (this.bl(a.bn)) {
                        var h = (a.bn);
                        if (i2.Base.equalsStatic(h, c)) {
                            return true;
                        }
                    }
                }
            }
            else {
                if (i2.Base.equalsStatic(c, a.bn)) {
                    return true;
                }
            }
            return false;
        };
        Treemap.prototype.bl = function (a) {
            return typeof a === 'string';
        };
        Treemap.prototype.cr = function (a) {
            if (typeof a === 'number') {
                return a;
            }
            if (typeof a === 'number') {
                return i2.typeGetValue(a);
            }
            if (typeof a === 'number') {
                return i2.typeGetValue(a);
            }
            if (typeof a === 'number') {
                return i2.typeGetValue(a);
            }
            if (typeof a === 'number') {
                return a;
            }
            if (typeof a === 'number') {
                return i2.typeGetValue(a);
            }
            if (typeof a === 'number') {
                return a;
            }
            return NaN;
        };
        Treemap.prototype.bj = function (a) {
            if (typeof a === 'number') {
                return true;
            }
            if (typeof a === 'number') {
                return true;
            }
            if (typeof a === 'number') {
                return true;
            }
            if (typeof a === 'number') {
                return true;
            }
            if (typeof a === 'number') {
                return true;
            }
            if (typeof a === 'number') {
                return true;
            }
            if (typeof a === 'number') {
                return true;
            }
            return false;
        };
        Treemap.prototype.u = function (a) {
            var e_13, _a;
            var _this = this;
            var b = this.f;
            if (this.bc) {
                b = this.e;
            }
            var c = new i2.List$1(TreemapNodeFrame.$, 0);
            for (var d = 0; d < b.e.count; d++) {
                var e = b.e._inner[d];
                var f = b.a(e);
                if (a.x >= f.y.left && a.x <= f.y.right && a.y >= f.y.top && a.y <= f.y.bottom) {
                    c.add(f);
                }
            }
            c.aa(function (g, h) {
                var i = _this.dz(h);
                var j = _this.dz(g);
                if (i > j) {
                    return 1;
                }
                else if (j > i) {
                    return -1;
                }
                return 0;
            });
            try {
                for (var _b = tslib.__values(i2.fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    if (g.e.b.count > 0) {
                        return g;
                    }
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
            return null;
        };
        Treemap.prototype.dz = function (a) {
            var b = a.e;
            var c = 0;
            while (b.k != null) {
                if (this.aj == null) {
                    break;
                }
                if (this.aj.b.containsKey(b.k)) {
                    c++;
                    b = this.aj.b.item(b.k);
                }
                else {
                    break;
                }
            }
            return c;
        };
        Treemap.prototype.v = function (a) {
            var e_14, _a, e_15, _b;
            var _this = this;
            var b = this.f;
            if (this.bc) {
                b = this.e;
            }
            var c = new i2.List$1(TreemapNodeFrame.$, 0);
            for (var d = 0; d < b.e.count; d++) {
                var e = b.e._inner[d];
                var f = b.a(e);
                if (a.x >= f.y.left && a.x <= f.y.right && a.y >= f.y.top && a.y <= f.y.bottom) {
                    c.add(f);
                }
            }
            c.aa(function (g, h) {
                var i = _this.dz(h);
                var j = _this.dz(g);
                if (i > j) {
                    return 1;
                }
                else if (j > i) {
                    return -1;
                }
                return 0;
            });
            if (this.i == 2) {
                try {
                    for (var _c = tslib.__values(i2.fromEnum(c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var g = _d.value;
                        if (g.e.b.count > 0) {
                            if (this.bk(a, g)) {
                                return g;
                            }
                        }
                    }
                }
                catch (e_14_1) {
                    e_14 = { error: e_14_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_14)
                            throw e_14.error;
                    }
                }
            }
            try {
                for (var _e = tslib.__values(i2.fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var h = _f.value;
                    return h;
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
            return null;
        };
        Treemap.prototype.hh = function () {
            this.cn = 0;
            this.ap.w();
            this.ap.v();
            this.an.av();
        };
        Object.defineProperty(Treemap.prototype, "bn", {
            get: function () {
                return this.d1 > 0;
            },
            enumerable: false,
            configurable: true
        });
        Treemap.prototype.provideContainer = function (a) {
            this.an.ar(a);
            this.ap.u(a);
        };
        Treemap.prototype.gr = function () {
            this.an.am();
        };
        Object.defineProperty(Treemap.prototype, "x", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                var b = this.t;
                this.t = a;
                if (b != a) {
                    this.gs(b);
                    this.gq(a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Treemap.prototype.gq = function (a) {
            if (a != null) {
                if (this.nodePointerEnter != null) {
                    this.nodePointerEnter(this, this.y(a));
                }
            }
        };
        Treemap.prototype.gs = function (a) {
            if (a != null) {
                if (this.nodePointerLeave != null) {
                    this.nodePointerLeave(this, this.y(a));
                }
            }
        };
        Treemap.prototype.y = function (a) {
            var b = new TreemapNodePointerEventArgs();
            if (a != null) {
                b.customValue = a.e.g;
                b.item = a.e.h;
                b.position = this.il;
                b.sum = a.e.e();
                b.value = a.e.f;
                b.label = a.e.j;
                b.isOverHeader = this.bk(this.il, a);
                if (a.e.k != null && this.aj != null && this.aj.b.containsKey(a.e.k)) {
                    var c = this.aj.b.item(a.e.k);
                    b.parentItem = c.h;
                    b.parentSum = c.e();
                    b.parentValue = c.f;
                    b.parentLabel = c.j;
                }
            }
            b.isRightButton = false;
            return b;
        };
        Object.defineProperty(Treemap.prototype, "d3", {
            get: function () {
                return this.d2;
            },
            set: function (a) {
                var b = this.d2;
                this.d2 = a;
                if (b != this.d2) {
                    this.g7("FocusItem", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Treemap.prototype.g2 = function (a) {
            this.hl(a);
            if (this.nodePointerPressed != null && this.x != null) {
                var b = this.y(this.x);
                this.nodePointerPressed(this, b);
            }
        };
        Treemap.prototype.g6 = function (a) {
            this.hl(a);
            var b = false;
            if (this.nodePointerReleased != null && this.x != null) {
                var c = this.y(this.x);
                this.nodePointerReleased(this, c);
                b = c.isHandled;
            }
            if (!b) {
                if (this.w != null) {
                    if (this.w.e == this.al && this.bk(a, this.w)) {
                        this.al = null;
                        this.bf = true;
                        this.an.az();
                        this.hj(null);
                        return;
                    }
                    this.al = this.w.e;
                    this.hj(this.w.e);
                    this.bf = true;
                    this.an.az();
                }
                else {
                    this.al = null;
                    this.bf = true;
                    this.hj(null);
                    this.an.az();
                }
            }
        };
        Treemap.prototype.hj = function (a) {
            try {
                this.ba = true;
                if (a == null) {
                    this.d3 = null;
                }
                else {
                    this.d3 = a.h;
                }
                this.ba = false;
            }
            finally {
                this.ba = false;
            }
        };
        Treemap.prototype.bk = function (a, b) {
            var c = this.f;
            if (this.bc) {
                c = this.e;
            }
            if (b == null) {
                return false;
            }
            var d = b;
            if (a.x >= d.y.left && a.x <= d.y.right && a.y >= d.y.top && a.y <= d.y.bottom) {
                if (a.y - d.y.top <= d.g) {
                    return true;
                }
            }
            return false;
        };
        Treemap.prototype.gx = function (source_, a, b, c) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.bo(source_)) {
                return;
            }
            var d = this.ar;
            if (d == null) {
                return;
            }
            d.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(2, 2, c, b, a));
        };
        Treemap.prototype.gu = function (source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.bo(source_)) {
                return;
            }
            var a = this.ar;
            a.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(0, 4));
        };
        Treemap.prototype.bo = function (a) {
            return Treemap.bp(a, this.dataSource);
        };
        Treemap.bp = function (a, b) {
            return a == b;
        };
        Treemap.prototype.gv = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.bo(source_)) {
                return;
            }
            var c = this.ar;
            if (c == null) {
                return;
            }
            c.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 0, b, a));
        };
        Treemap.prototype.gw = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (!this.bo(source_)) {
                return;
            }
            var c = this.ar;
            if (c == null) {
                return;
            }
            c.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 1, b, a));
        };
        Treemap.prototype.g3 = function (a) {
            this.hl(a);
        };
        Treemap.prototype.g4 = function (a) {
            this.hl(a);
            this.w = null;
            this.x = null;
            if (!this.bc) {
                this.bf = true;
                this.an.az();
            }
        };
        Treemap.prototype.hl = function (a) {
            this.il = { $type: i2.Point_$type, x: a.x, y: a.y };
            this.w = this.u(a);
            this.x = this.v(a);
            this.hk(a);
        };
        Treemap.prototype.hg = function (a) {
            this.g5(a);
        };
        Treemap.prototype.g5 = function (a) {
            this.hl(a);
            if (this.x != null) {
                if (this.nodePointerOver != null) {
                    this.nodePointerOver(this, this.y(this.x));
                }
            }
        };
        Treemap.prototype.hk = function (a) {
            if (!this.bc) {
                if (this.bk(a, this.w)) {
                    var b = this.am;
                    this.am = this.w.e;
                    if (this.am != b) {
                        this.bf = true;
                        this.an.az();
                    }
                }
                else {
                    var c = this.am;
                    this.am = null;
                    if (this.am != c) {
                        this.bf = true;
                        this.an.az();
                    }
                }
            }
        };
        Treemap.prototype.g8 = function (a) {
            this.hl(a);
            if (this.nodePointerPressed != null && this.x != null) {
                var b = this.y(this.x);
                b.isRightButton = true;
                this.nodePointerPressed(this, b);
            }
        };
        Treemap.prototype.g9 = function (a) {
            this.hl(a);
            var b = false;
            if (this.nodePointerReleased != null && this.x != null) {
                var c = this.y(this.x);
                c.isRightButton = true;
                this.nodePointerReleased(this, c);
                b = c.isHandled;
            }
            if (!b) {
                this.w = null;
                this.al = null;
                this.hj(null);
                this.bf = true;
                this.an.az();
            }
        };
        Treemap.prototype.ha = function (a) {
            this.bf = true;
            this.an.az();
        };
        Treemap.$t = i2.markType(Treemap, 'Treemap', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return Treemap;
    }(i2.Base));
    /**
     * @hidden
     */
    var TreemapNodeStyle = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeStyle, _super);
        function TreemapNodeStyle() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = null;
            _this.c = new i2.HashSet$1(i2.String_$type, 0);
            _this.a0 = null;
            _this.az = null;
            _this.a2 = null;
            _this.x = null;
            _this.a4 = null;
            _this.a1 = null;
            _this.f = i2.DeviceUtils.g(5);
            _this.h = i2.DeviceUtils.g(3);
            _this.g = i2.DeviceUtils.g(5);
            _this.e = i2.DeviceUtils.g(3);
            _this.j = i2.DeviceUtils.g(5);
            _this.l = i2.DeviceUtils.g(3);
            _this.k = i2.DeviceUtils.g(5);
            _this.i = i2.DeviceUtils.g(3);
            _this.d = NaN;
            _this.aw = 1;
            _this.bc = 1;
            _this.ay = null;
            _this.a3 = null;
            _this.m = NaN;
            _this.propertyChanged = null;
            return _this;
        }
        TreemapNodeStyle.prototype.au = function (a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new i2.PropertyChangedEventArgs(a));
            }
            this.av(a, b, c);
        };
        TreemapNodeStyle.prototype.at = function () {
            this.c.clear();
        };
        TreemapNodeStyle.prototype.b = function (a) {
            return this.c.contains(a);
        };
        TreemapNodeStyle.prototype.av = function (a, b, c) {
            if (!this.c.contains(a)) {
                this.c.add_1(a);
            }
            if (this.a != null) {
                this.a.ha(this);
            }
        };
        Object.defineProperty(TreemapNodeStyle.prototype, "a7", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                var b = this.a0;
                this.a0 = a;
                if (b != this.a0) {
                    this.au("HeaderHoverBackground", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "a6", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                var b = this.az;
                this.az = a;
                if (b != this.az) {
                    this.au("HeaderBackground", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "a9", {
            get: function () {
                return this.a2;
            },
            set: function (a) {
                var b = this.a2;
                this.a2 = a;
                if (b != this.a2) {
                    this.au("HeaderTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "ai", {
            get: function () {
                return this.x;
            },
            set: function (a) {
                var b = this.x;
                this.x = a;
                if (b != this.x) {
                    this.au("Label", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "bb", {
            get: function () {
                return this.a4;
            },
            set: function (a) {
                var b = this.a4;
                this.a4 = a;
                if (b != this.a4) {
                    this.au("TextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "a8", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                var b = this.a1;
                this.a1 = a;
                if (b != this.a1) {
                    this.au("HeaderHoverTextColor", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "p", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                var b = this.f;
                this.f = a;
                if (b != this.f) {
                    this.au("HeaderLabelLeftMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "r", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                var b = this.h;
                this.h = a;
                if (b != this.h) {
                    this.au("HeaderLabelTopMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "q", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                var b = this.g;
                this.g = a;
                if (b != this.g) {
                    this.au("HeaderLabelRightMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "o", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                var b = this.e;
                this.e = a;
                if (b != this.e) {
                    this.au("HeaderLabelBottomMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "t", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                var b = this.j;
                this.j = a;
                if (b != this.j) {
                    this.au("LabelLeftMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "v", {
            get: function () {
                return this.l;
            },
            set: function (a) {
                var b = this.l;
                this.l = a;
                if (b != this.l) {
                    this.au("LabelTopMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "u", {
            get: function () {
                return this.k;
            },
            set: function (a) {
                var b = this.k;
                this.k = a;
                if (b != this.k) {
                    this.au("LabelRightMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "s", {
            get: function () {
                return this.i;
            },
            set: function (a) {
                var b = this.i;
                this.i = a;
                if (b != this.i) {
                    this.au("LabelBottomMargin", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "n", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                var b = this.d;
                this.d = a;
                if (b != this.d) {
                    this.au("HeaderHeight", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "ax", {
            get: function () {
                return this.aw;
            },
            set: function (a) {
                var b = this.aw;
                this.aw = a;
                if (b != this.aw) {
                    this.au("LabelHorizontalAlignment", i2.enumGetBox(i2.HorizontalAlignment_$type, b), i2.enumGetBox(i2.HorizontalAlignment_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "bd", {
            get: function () {
                return this.bc;
            },
            set: function (a) {
                var b = this.bc;
                this.bc = a;
                if (b != this.bc) {
                    this.au("LabelVerticalAlignment", i2.enumGetBox(i2.VerticalAlignment_$type, b), i2.enumGetBox(i2.VerticalAlignment_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "a5", {
            get: function () {
                return this.ay;
            },
            set: function (a) {
                var b = this.ay;
                this.ay = a;
                if (b != this.ay) {
                    this.au("Fill", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "ba", {
            get: function () {
                return this.a3;
            },
            set: function (a) {
                var b = this.a3;
                this.a3 = a;
                if (b != this.a3) {
                    this.au("Outline", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyle.prototype, "w", {
            get: function () {
                return this.m;
            },
            set: function (a) {
                var b = this.m;
                this.m = a;
                if (b != this.m) {
                    this.au("StrokeThickness", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        TreemapNodeStyle.$t = i2.markType(TreemapNodeStyle, 'TreemapNodeStyle', i2.Base.$, [i2.INotifyPropertyChanged_$type]);
        return TreemapNodeStyle;
    }(i2.Base));
    /**
     * @hidden
     */
    var TreemapNodeStyleMapping = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeStyleMapping, _super);
        function TreemapNodeStyleMapping() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.be = 0;
            _this.bo = null;
            _this.bj = NaN;
            _this.bi = NaN;
            _this.bm = null;
            _this.bg = 1;
            return _this;
        }
        Object.defineProperty(TreemapNodeStyleMapping.prototype, "bf", {
            get: function () {
                return this.be;
            },
            set: function (a) {
                var b = this.be;
                this.be = a;
                if (b != this.be) {
                    this.au("TargetType", i2.enumGetBox(TreemapNodeStyleMappingTargetType_$type, b), i2.enumGetBox(TreemapNodeStyleMappingTargetType_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyleMapping.prototype, "bs", {
            get: function () {
                return this.bo;
            },
            set: function (a) {
                var b = this.bo;
                this.bo = a;
                if (b != this.bo) {
                    this.au("Name", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyleMapping.prototype, "bl", {
            get: function () {
                return this.bj;
            },
            set: function (a) {
                var b = this.bj;
                this.bj = a;
                if (b != this.bj) {
                    this.au("MinimumValue", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyleMapping.prototype, "bk", {
            get: function () {
                return this.bi;
            },
            set: function (a) {
                var b = this.bi;
                this.bi = a;
                if (b != this.bi) {
                    this.au("MaximumValue", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyleMapping.prototype, "bn", {
            get: function () {
                return this.bm;
            },
            set: function (a) {
                var b = this.bm;
                this.bm = a;
                if (b != this.bm) {
                    this.au("Value", b, a);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStyleMapping.prototype, "bh", {
            get: function () {
                return this.bg;
            },
            set: function (a) {
                var b = this.bg;
                this.bg = a;
                if (b != this.bg) {
                    this.au("MappingMode", i2.enumGetBox(TreemapValueMappingMode_$type, b), i2.enumGetBox(TreemapValueMappingMode_$type, a));
                }
            },
            enumerable: false,
            configurable: true
        });
        TreemapNodeStyleMapping.$t = i2.markType(TreemapNodeStyleMapping, 'TreemapNodeStyleMapping', TreemapNodeStyle.$);
        return TreemapNodeStyleMapping;
    }(TreemapNodeStyle));
    /**
     * @hidden
     */
    var TreemapNodeStyleMappingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeStyleMappingCollection, _super);
        function TreemapNodeStyleMappingCollection() {
            var _this = _super.call(this, TreemapNodeStyleMapping.$, 0) || this;
            _this.collectionResetting = null;
            return _this;
        }
        TreemapNodeStyleMappingCollection.prototype.p = function () {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            _super.prototype.p.call(this);
        };
        TreemapNodeStyleMappingCollection.$t = i2.markType(TreemapNodeStyleMappingCollection, 'TreemapNodeStyleMappingCollection', i2.ObservableCollection$1.$.specialize(TreemapNodeStyleMapping.$));
        return TreemapNodeStyleMappingCollection;
    }(i2.ObservableCollection$1));
    /**
     * @hidden
     */
    var TreemapNodeStylingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeStylingEventArgs, _super);
        function TreemapNodeStylingEventArgs() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._value = 0;
            _this._sum = 0;
            _this._customValue = null;
            _this._item = null;
            _this._parentItem = null;
            _this._label = null;
            _this._parentValue = 0;
            _this._parentLabel = null;
            _this._parentSum = 0;
            _this._isParent = false;
            _this._style = null;
            return _this;
        }
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (a) {
                this._value = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "sum", {
            get: function () {
                return this._sum;
            },
            set: function (a) {
                this._sum = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "customValue", {
            get: function () {
                return this._customValue;
            },
            set: function (a) {
                this._customValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "item", {
            get: function () {
                return this._item;
            },
            set: function (a) {
                this._item = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentItem", {
            get: function () {
                return this._parentItem;
            },
            set: function (a) {
                this._parentItem = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "label", {
            get: function () {
                return this._label;
            },
            set: function (a) {
                this._label = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentValue", {
            get: function () {
                return this._parentValue;
            },
            set: function (a) {
                this._parentValue = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentLabel", {
            get: function () {
                return this._parentLabel;
            },
            set: function (a) {
                this._parentLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentSum", {
            get: function () {
                return this._parentSum;
            },
            set: function (a) {
                this._parentSum = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "isParent", {
            get: function () {
                return this._isParent;
            },
            set: function (a) {
                this._isParent = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "style", {
            get: function () {
                return this._style;
            },
            set: function (a) {
                this._style = a;
            },
            enumerable: false,
            configurable: true
        });
        TreemapNodeStylingEventArgs.$t = i2.markType(TreemapNodeStylingEventArgs, 'TreemapNodeStylingEventArgs', i2.EventArgs.$);
        return TreemapNodeStylingEventArgs;
    }(i2.EventArgs));
    /**
     * @hidden
     */
    var TreemapFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapFrame, _super);
        function TreemapFrame() {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.e = null;
            _this.e = new i2.List$1(i2.String_$type, 0);
            _this.d = new i2.Dictionary$2(i2.String_$type, TreemapNodeFrame.$, 0);
            return _this;
        }
        TreemapFrame.prototype.h = function (a, b, c) {
            this.g();
            this.k(a, b, c);
            this.j(a, b, c);
            this.i(a, b, c);
        };
        TreemapFrame.prototype.i = function (a, b, c) {
            for (var d = 0; d < b.e.count; d++) {
                var e = b.e._inner[d];
                if (c.d.containsKey(e)) {
                    var f = TreemapNodeFrame.b(a, b.d.item(e), c.d.item(e));
                    this.d.addItem(f.r, f);
                    this.e.add(f.r);
                }
            }
        };
        TreemapFrame.prototype.j = function (a, b, c) {
            for (var d = 0; d < c.e.count; d++) {
                var e = c.e._inner[d];
                if (!b.d.containsKey(e)) {
                    var f = TreemapNodeFrame.c(a, c.d.item(e));
                    this.d.addItem(f.r, f);
                    this.e.add(f.r);
                }
            }
        };
        TreemapFrame.prototype.k = function (a, b, c) {
            for (var d = 0; d < b.e.count; d++) {
                var e = b.e._inner[d];
                if (!c.d.containsKey(e)) {
                    var f = TreemapNodeFrame.d(a, b.d.item(e));
                    this.d.addItem(f.r, f);
                    this.e.add(f.r);
                }
            }
        };
        TreemapFrame.prototype.m = function (a, b) {
            var _this = this;
            var c;
            if (!((function () { var d = _this.d.tryGetValue(a.i, c); c = d.p1; return d.ret; })())) {
                c = new TreemapNodeFrame();
                c.r = a.i;
                c.e = a;
                this.d.item(c.r, c);
                this.e.add(c.r);
            }
            c.y = b;
        };
        TreemapFrame.prototype.n = function (a, b) {
            this.d.item(a.i).f = b;
        };
        TreemapFrame.prototype.b = function (a) {
            if (!this.d.containsKey(a.i)) {
                return false;
            }
            return this.d.item(a.i).f;
        };
        TreemapFrame.prototype.o = function (a) {
            var _this = this;
            var b;
            if (!((function () { var c = _this.d.tryGetValue(a.i, b); b = c.p1; return c.ret; })())) {
                return i2.Rect.empty;
            }
            return b.y;
        };
        TreemapFrame.prototype.l = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t) {
            var _this = this;
            var u;
            if (!((function () { var v = _this.d.tryGetValue(a.i, u); u = v.p1; return v.ret; })())) {
                return;
            }
            u.s = b;
            u.u = c;
            u.x = d;
            u.q = g;
            u.v = e;
            u.a = h;
            u.l = i;
            u.g = j;
            u.w = f;
            u.i = k;
            u.k = l;
            u.j = m;
            u.h = n;
            u.n = o;
            u.p = p;
            u.o = q;
            u.m = r;
            u.t = s;
            u.z = t;
        };
        TreemapFrame.prototype.g = function () {
            this.e.clear();
            this.d.clear();
        };
        TreemapFrame.prototype.c = function (a) {
            return this.d.containsKey(a);
        };
        TreemapFrame.prototype.a = function (a) {
            return this.d.item(a);
        };
        TreemapFrame.prototype.f = function (a, b, c) {
            var _this = this;
            var d;
            if (!((function () { var e = _this.d.tryGetValue(a.i, d); d = e.p1; return e.ret; })())) {
                return;
            }
            var e = a.b != null && a.b.count > 0;
            if (b.b("Label")) {
                d.s = b.ai;
            }
            if (b.b("Fill")) {
                d.u = b.a5;
            }
            if (b.b("LabelHorizontalAlignment")) {
                d.t = b.ax;
            }
            if (b.b("Outline")) {
                d.x = b.ba;
            }
            if (b.b("StrokeThickness")) {
                d.q = b.w;
            }
            if (b.b("HeaderBackground")) {
                d.v = b.a6;
            }
            if (e) {
                if (b.b("HeaderTextColor")) {
                    d.w = b.a9;
                }
                else if (b.b("Fill") || b.b("HeaderBackground")) {
                    d.w = c(a, d.u, d.v);
                }
            }
            else {
                if (b.b("TextColor")) {
                    d.w = b.bb;
                }
                else if (b.b("Fill") || b.b("HeaderBackground")) {
                    d.w = c(a, d.u, d.v);
                }
            }
            if (b.b("HeaderLabelLeftMargin")) {
                d.i = b.p;
            }
            if (b.b("HeaderLabelTopMargin")) {
                d.k = b.r;
            }
            if (b.b("HeaderLabelRightMargin")) {
                d.j = b.q;
            }
            if (b.b("HeaderLabelBottomMargin")) {
                d.h = b.o;
            }
            if (b.b("LabelLeftMargin")) {
                d.n = b.t;
            }
            if (b.b("LabelTopMargin")) {
                d.p = b.v;
            }
            if (b.b("LabelRightMargin")) {
                d.o = b.u;
            }
            if (b.b("LabelBottomMargin")) {
                d.m = b.s;
            }
        };
        TreemapFrame.$t = i2.markType(TreemapFrame, 'TreemapFrame');
        return TreemapFrame;
    }(i2.Base));
    /**
     * @hidden
     */
    var TreemapNodeFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TreemapNodeFrame, _super);
        function TreemapNodeFrame() {
            var _this = _super.call(this) || this;
            _this.y = null;
            _this.e = null;
            _this.r = null;
            _this.s = null;
            _this.u = null;
            _this.x = null;
            _this.q = 0;
            _this.i = 0;
            _this.k = 0;
            _this.j = 0;
            _this.h = 0;
            _this.n = 0;
            _this.p = 0;
            _this.o = 0;
            _this.m = 0;
            _this.w = null;
            _this.v = null;
            _this.a = 0;
            _this.l = 0;
            _this.g = 0;
            _this.t = 0;
            _this.z = 0;
            _this.f = false;
            _this.y = i2.Rect.empty;
            return _this;
        }
        TreemapNodeFrame.b = function (a, b, c) {
            var d = new TreemapNodeFrame();
            d.e = c.e;
            d.r = c.r;
            d.s = c.s;
            var e = c.y;
            if (e.isEmpty) {
                e = new i2.Rect(0, 0, 0, 0, 0);
            }
            var f = b.y;
            if (f.isEmpty) {
                f = new i2.Rect(0, 0, 0, 0, 0);
            }
            d.y = new i2.Rect(0, f.left + (e.left - f.left) * a, f.top + (e.top - f.top) * a, f.width + (e.width - f.width) * a, f.height + (e.height - f.height) * a);
            d.u = i2.BrushUtil.k(b.u, a, c.u, 0);
            d.x = i2.BrushUtil.k(b.x, a, c.x, 0);
            d.v = i2.BrushUtil.k(b.v, a, c.v, 0);
            d.w = i2.BrushUtil.k(b.w, a, c.w, 0);
            d.q = b.q + (c.q - b.q) * a;
            d.i = b.i + (c.i - b.i) * a;
            d.k = b.k + (c.k - b.k) * a;
            d.j = b.j + (c.j - b.j) * a;
            d.h = b.h + (c.h - b.h) * a;
            d.n = b.n + (c.n - b.n) * a;
            d.p = b.p + (c.p - b.p) * a;
            d.o = b.o + (c.o - b.o) * a;
            d.m = b.m + (c.m - b.m) * a;
            d.l = b.l + (c.l - b.l) * a;
            d.g = b.g + (c.g - b.g) * a;
            d.t = a < 0.5 ? b.t : c.t;
            d.z = a < 0.5 ? b.z : c.z;
            d.a = a < 0.5 ? b.a : c.a;
            return d;
        };
        TreemapNodeFrame.d = function (a, b) {
            var c = new i2.Rect(0, 0, 0, 0, 0);
            var d = new TreemapNodeFrame();
            d.e = b.e;
            d.s = b.s;
            d.r = b.r;
            var e = b.y;
            if (e.isEmpty) {
                e = new i2.Rect(0, 0, 0, 0, 0);
            }
            d.y = new i2.Rect(0, e.left + (c.left - e.left) * a, e.top + (c.top - e.top) * a, e.width + (c.width - e.width) * a, e.height + (c.height - e.height) * a);
            d.u = i2.BrushUtil.k(b.u, a, null, 0);
            d.x = i2.BrushUtil.k(b.x, a, null, 0);
            d.v = i2.BrushUtil.k(b.v, a, null, 0);
            d.w = i2.BrushUtil.k(b.w, a, null, 0);
            d.q = b.q + (0 - b.q) * a;
            d.i = b.i + (0 - b.i) * a;
            d.k = b.k + (0 - b.k) * a;
            d.j = b.j + (0 - b.j) * a;
            d.h = b.h + (0 - b.h) * a;
            d.n = b.n + (0 - b.n) * a;
            d.p = b.p + (0 - b.p) * a;
            d.o = b.o + (0 - b.o) * a;
            d.m = b.m + (0 - b.m) * a;
            d.l = b.l + (0 - b.l) * a;
            d.g = b.g + (0 - b.g) * a;
            d.t = b.t;
            d.z = b.z;
            d.a = b.a;
            return d;
        };
        TreemapNodeFrame.c = function (a, b) {
            var c = new i2.Rect(0, 0, 0, 0, 0);
            var d = new TreemapNodeFrame();
            d.e = b.e;
            d.s = b.s;
            d.r = b.r;
            var e = b.y;
            if (e.isEmpty) {
                e = new i2.Rect(0, 0, 0, 0, 0);
            }
            d.y = new i2.Rect(0, c.left + (e.left - c.left) * a, c.top + (e.top - c.top) * a, c.width + (e.width - c.width) * a, c.height + (e.height - c.height) * a);
            d.u = i2.BrushUtil.k(null, a, b.u, 0);
            d.x = i2.BrushUtil.k(null, a, b.x, 0);
            d.v = i2.BrushUtil.k(null, a, b.v, 0);
            d.w = i2.BrushUtil.k(null, a, b.w, 0);
            d.q = 0 + (b.q - 0) * a;
            d.i = 0 + (b.i - 0) * a;
            d.k = 0 + (b.k - 0) * a;
            d.j = 0 + (b.j - 0) * a;
            d.h = 0 + (b.h - 0) * a;
            d.n = 0 + (b.n - 0) * a;
            d.p = 0 + (b.p - 0) * a;
            d.o = 0 + (b.o - 0) * a;
            d.m = 0 + (b.m - 0) * a;
            d.l = 0 + (b.l - 0) * a;
            d.g = 0 + (b.g - 0) * a;
            d.t = b.t;
            d.z = b.z;
            d.a = b.a;
            return d;
        };
        TreemapNodeFrame.$t = i2.markType(TreemapNodeFrame, 'TreemapNodeFrame');
        return TreemapNodeFrame;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a style to apply to a treemap node.
    */
    var IgxTreemapNodeStyleComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodeStyleComponent() {
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxTreemapNodeStyleComponent.prototype.createImplementation = function () {
            return new TreemapNodeStyle();
        };
        IgxTreemapNodeStyleComponent.prototype.ngOnInit = function () {
        };
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxTreemapNodeStyleComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        IgxTreemapNodeStyleComponent.prototype.onImplementationCreated = function () {
        };
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerHoverBackground", {
            /**
             * Gets or sets the background to use for the header when it is hovered.
            */
            get: function () {
                return i2.brushToString(this.i.a7);
            },
            set: function (v) {
                this.i.a7 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerBackground", {
            /**
             * Gets or sets the background to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.a6);
            },
            set: function (v) {
                this.i.a6 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerTextColor", {
            /**
             * Gets or sets the text color to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.a9);
            },
            set: function (v) {
                this.i.a9 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "label", {
            /**
             * Gets or sets the label to use for the node.
            */
            get: function () {
                return this.i.ai;
            },
            set: function (v) {
                this.i.ai = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "textColor", {
            /**
             * Gets or sets the text color to use for the nodes.
            */
            get: function () {
                return i2.brushToString(this.i.bb);
            },
            set: function (v) {
                this.i.bb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerHoverTextColor", {
            /**
             * Gets or sets the text color to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.a8);
            },
            set: function (v) {
                this.i.a8 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerLabelLeftMargin", {
            /**
             * Gets or sets the left margin to use for the header.
            */
            get: function () {
                return this.i.p;
            },
            set: function (v) {
                this.i.p = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerLabelTopMargin", {
            /**
             * Gets or sets the top margin to use for the header.
            */
            get: function () {
                return this.i.r;
            },
            set: function (v) {
                this.i.r = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerLabelRightMargin", {
            /**
             * Gets or sets the right margin to use for the header.
            */
            get: function () {
                return this.i.q;
            },
            set: function (v) {
                this.i.q = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerLabelBottomMargin", {
            /**
             * Gets or sets the bottom margin to use for the labels.
            */
            get: function () {
                return this.i.o;
            },
            set: function (v) {
                this.i.o = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "labelLeftMargin", {
            /**
             * Gets or sets the left margin to use for the labels.
            */
            get: function () {
                return this.i.t;
            },
            set: function (v) {
                this.i.t = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "labelTopMargin", {
            /**
             * Gets or sets the top margin to use for the labels.
            */
            get: function () {
                return this.i.v;
            },
            set: function (v) {
                this.i.v = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "labelRightMargin", {
            /**
             * Gets or sets the right margin to use for the labels.
            */
            get: function () {
                return this.i.u;
            },
            set: function (v) {
                this.i.u = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "labelBottomMargin", {
            /**
             * Gets or sets the bottom margin to use for the labels.
            */
            get: function () {
                return this.i.s;
            },
            set: function (v) {
                this.i.s = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "headerHeight", {
            /**
             * Gets or sets the height to use for the header.
            */
            get: function () {
                return this.i.n;
            },
            set: function (v) {
                this.i.n = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "labelHorizontalAlignment", {
            /**
             * Gets or sets the horizontal alignment to use for the node labels.
            */
            get: function () {
                return this.i.ax;
            },
            set: function (v) {
                this.i.ax = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "labelVerticalAlignment", {
            /**
             * Gets or sets the vertical alignment to use for the node labels.
            */
            get: function () {
                return this.i.bd;
            },
            set: function (v) {
                this.i.bd = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "fill", {
            /**
             * Gets or sets the fill color to use for the nodes.
            */
            get: function () {
                return i2.brushToString(this.i.a5);
            },
            set: function (v) {
                this.i.a5 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "outline", {
            /**
             * Gets or sets the outline to use for the nodes.
            */
            get: function () {
                return i2.brushToString(this.i.ba);
            },
            set: function (v) {
                this.i.ba = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "strokeThickness", {
            /**
             * Gets or sets the stroke thickness to use for the node outline.
            */
            get: function () {
                return this.i.w;
            },
            set: function (v) {
                this.i.w = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapNodeStyleComponent.prototype.findByName = function (name) {
            return null;
        };
        Object.defineProperty(IgxTreemapNodeStyleComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapNodeStyleComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxTreemapNodeStyleComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("TreemapNodeStyleComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxTreemapNodeStyleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTreemapNodeStyleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTreemapNodeStyleComponent, selector: "igx-treemap-node-style", inputs: { headerHoverBackground: "headerHoverBackground", headerBackground: "headerBackground", headerTextColor: "headerTextColor", label: "label", textColor: "textColor", headerHoverTextColor: "headerHoverTextColor", headerLabelLeftMargin: "headerLabelLeftMargin", headerLabelTopMargin: "headerLabelTopMargin", headerLabelRightMargin: "headerLabelRightMargin", headerLabelBottomMargin: "headerLabelBottomMargin", labelLeftMargin: "labelLeftMargin", labelTopMargin: "labelTopMargin", labelRightMargin: "labelRightMargin", labelBottomMargin: "labelBottomMargin", headerHeight: "headerHeight", labelHorizontalAlignment: "labelHorizontalAlignment", labelVerticalAlignment: "labelVerticalAlignment", fill: "fill", outline: "outline", strokeThickness: "strokeThickness" }, providers: [], ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxTreemapNodeStyleComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-treemap-node-style',
                        template: "",
                        providers: [],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { headerHoverBackground: [{
                    type: i0.Input
                }], headerBackground: [{
                    type: i0.Input
                }], headerTextColor: [{
                    type: i0.Input
                }], label: [{
                    type: i0.Input
                }], textColor: [{
                    type: i0.Input
                }], headerHoverTextColor: [{
                    type: i0.Input
                }], headerLabelLeftMargin: [{
                    type: i0.Input
                }], headerLabelTopMargin: [{
                    type: i0.Input
                }], headerLabelRightMargin: [{
                    type: i0.Input
                }], headerLabelBottomMargin: [{
                    type: i0.Input
                }], labelLeftMargin: [{
                    type: i0.Input
                }], labelTopMargin: [{
                    type: i0.Input
                }], labelRightMargin: [{
                    type: i0.Input
                }], labelBottomMargin: [{
                    type: i0.Input
                }], headerHeight: [{
                    type: i0.Input
                }], labelHorizontalAlignment: [{
                    type: i0.Input
                }], labelVerticalAlignment: [{
                    type: i0.Input
                }], fill: [{
                    type: i0.Input
                }], outline: [{
                    type: i0.Input
                }], strokeThickness: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /**
     * Represents a style to apply to a set of nodes in the treemap.
    */
    var IgxTreemapNodeStyleMappingComponent = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTreemapNodeStyleMappingComponent, _super);
        function IgxTreemapNodeStyleMappingComponent() {
            return _super.call(this) || this;
        }
        IgxTreemapNodeStyleMappingComponent.prototype.createImplementation = function () {
            return new TreemapNodeStyleMapping();
        };
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "i", {
            /**
                                         * @hidden
                                         */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "targetType", {
            /**
             * Gets or sets the unique name of the mapping.
            */
            get: function () {
                return this.i.bf;
            },
            set: function (v) {
                this.i.bf = i2.ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "name", {
            /**
             * Gets or sets the unique name of the mapping.
            */
            get: function () {
                return this.i.bs;
            },
            set: function (v) {
                this.i.bs = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "minimumValue", {
            /**
             * Gets or sets the minimum value to which the mapping applies.
            */
            get: function () {
                return this.i.bl;
            },
            set: function (v) {
                this.i.bl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "maximumValue", {
            /**
             * Gets or sets the maximum value to which the mapping applies.
            */
            get: function () {
                return this.i.bk;
            },
            set: function (v) {
                this.i.bk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "value", {
            /**
             * Gets or sets the value to which the mapping applies.
            */
            get: function () {
                return this.i.bn;
            },
            set: function (v) {
                this.i.bn = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStyleMappingComponent.prototype, "mappingMode", {
            /**
             * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
            */
            get: function () {
                return this.i.bh;
            },
            set: function (v) {
                this.i.bh = i2.ensureEnum(TreemapValueMappingMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapNodeStyleMappingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
        IgxTreemapNodeStyleMappingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTreemapNodeStyleMappingComponent, selector: "igx-treemap-node-style-mapping", inputs: { targetType: "targetType", name: "name", minimumValue: "minimumValue", maximumValue: "maximumValue", value: "value", mappingMode: "mappingMode" }, providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: i0.forwardRef(function () { return IgxTreemapNodeStyleMappingComponent; }) }], usesInheritance: true, ngImport: i0, template: "", isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxTreemapNodeStyleMappingComponent;
    }(IgxTreemapNodeStyleComponent));
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-treemap-node-style-mapping',
                        template: "",
                        providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: i0.forwardRef(function () { return IgxTreemapNodeStyleMappingComponent; }) }],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { targetType: [{
                    type: i0.Input
                }], name: [{
                    type: i0.Input
                }], minimumValue: [{
                    type: i0.Input
                }], maximumValue: [{
                    type: i0.Input
                }], value: [{
                    type: i0.Input
                }], mappingMode: [{
                    type: i0.Input
                }] } });

    var IgxTreemapNodeStyleMappingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(IgxTreemapNodeStyleMappingCollection, _super);
        function IgxTreemapNodeStyleMappingCollection(list) {
            var _this = _super.call(this) || this;
            if (!IgxTreemapNodeStyleMappingComponent.$type) {
                IgxTreemapNodeStyleMappingComponent.$type = i2.markType(IgxTreemapNodeStyleMappingComponent, "IgxTreemapNodeStyleMappingComponent");
            }
            if (list) {
                for (var i = 0; i < list.length; i++) {
                    _this.add(list[i]);
                }
            }
            return _this;
        }
        IgxTreemapNodeStyleMappingCollection.prototype._createInnerColl = function () {
            if (!IgxTreemapNodeStyleMappingComponent.$type) {
                IgxTreemapNodeStyleMappingComponent.$type = i2.markType(IgxTreemapNodeStyleMappingComponent, "IgxTreemapNodeStyleMappingComponent");
            }
            var coll = new i2.SyncableObservableCollection$2(IgxTreemapNodeStyleMappingComponent.$type, TreemapNodeStyleMapping.$type, 0);
            coll.compare = function (ext, int) {
                var comp = ext;
                if (comp._implementation) {
                    comp = comp._implementation;
                }
                if (comp.equals) {
                    return comp.equals(int);
                }
                return comp === int;
            };
            coll.createTo = function (ext) {
                return ext._implementation;
            };
            coll.createFrom = function (int) {
                var ext = int.externalObject;
                if (!ext) {
                    ext = new IgxTreemapNodeStyleMappingComponent();
                    if (ext) {
                        ext._implementation = int;
                    }
                }
                return ext;
            };
            return coll;
        };
        return IgxTreemapNodeStyleMappingCollection;
    }(i2.IgCollection));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    var IgxTreemapNodeStylingEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodeStylingEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxTreemapNodeStylingEventArgs.prototype.createImplementation = function () {
            return new TreemapNodeStylingEventArgs();
        };
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapNodeStylingEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxTreemapNodeStylingEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "value", {
            get: function () {
                return this.i.value;
            },
            set: function (v) {
                this.i.value = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "sum", {
            get: function () {
                return this.i.sum;
            },
            set: function (v) {
                this.i.sum = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "customValue", {
            get: function () {
                return this.i.customValue;
            },
            set: function (v) {
                this.i.customValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "item", {
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "parentItem", {
            get: function () {
                return this.i.parentItem;
            },
            set: function (v) {
                this.i.parentItem = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "label", {
            get: function () {
                return this.i.label;
            },
            set: function (v) {
                this.i.label = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "parentValue", {
            get: function () {
                return this.i.parentValue;
            },
            set: function (v) {
                this.i.parentValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "parentLabel", {
            get: function () {
                return this.i.parentLabel;
            },
            set: function (v) {
                this.i.parentLabel = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "parentSum", {
            get: function () {
                return this.i.parentSum;
            },
            set: function (v) {
                this.i.parentSum = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "isParent", {
            get: function () {
                return this.i.isParent;
            },
            set: function (v) {
                this.i.isParent = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodeStylingEventArgs.prototype, "style", {
            get: function () {
                if (this.i.style == null) {
                    return null;
                }
                if (!this.i.style.externalObject) {
                    var e = IgxTreemapNodeStyleComponent._createFromInternal(this.i.style);
                    if (e) {
                        e._implementation = this.i.style;
                    }
                    this.i.style.externalObject = e;
                }
                return this.i.style.externalObject;
            },
            set: function (v) {
                v == null ? this.i.style = null : this.i.style = v.i;
            },
            enumerable: false,
            configurable: true
        });
        return IgxTreemapNodeStylingEventArgs;
    }());

    var IgxTreemapNodePointerEventArgs = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodePointerEventArgs() {
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        }
        IgxTreemapNodePointerEventArgs.prototype.createImplementation = function () {
            return new TreemapNodePointerEventArgs();
        };
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapNodePointerEventArgs.prototype.onImplementationCreated = function () {
        };
        IgxTreemapNodePointerEventArgs.prototype._provideImplementation = function (i) {
            this._implementation = i;
            this._implementation.externalObject = this;
            this.onImplementationCreated();
        };
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "value", {
            get: function () {
                return this.i.value;
            },
            set: function (v) {
                this.i.value = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "sum", {
            get: function () {
                return this.i.sum;
            },
            set: function (v) {
                this.i.sum = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "customValue", {
            get: function () {
                return this.i.customValue;
            },
            set: function (v) {
                this.i.customValue = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "item", {
            get: function () {
                return this.i.item;
            },
            set: function (v) {
                this.i.item = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "parentItem", {
            get: function () {
                return this.i.parentItem;
            },
            set: function (v) {
                this.i.parentItem = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "position", {
            get: function () {
                return i2.fromPoint(this.i.position);
            },
            set: function (v) {
                this.i.position = i2.toPoint(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "isRightButton", {
            get: function () {
                return this.i.isRightButton;
            },
            set: function (v) {
                this.i.isRightButton = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "isHandled", {
            get: function () {
                return this.i.isHandled;
            },
            set: function (v) {
                this.i.isHandled = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "isOverHeader", {
            get: function () {
                return this.i.isOverHeader;
            },
            set: function (v) {
                this.i.isOverHeader = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "label", {
            get: function () {
                return this.i.label;
            },
            set: function (v) {
                this.i.label = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "parentValue", {
            get: function () {
                return this.i.parentValue;
            },
            set: function (v) {
                this.i.parentValue = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "parentLabel", {
            get: function () {
                return this.i.parentLabel;
            },
            set: function (v) {
                this.i.parentLabel = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapNodePointerEventArgs.prototype, "parentSum", {
            get: function () {
                return this.i.parentSum;
            },
            set: function (v) {
                this.i.parentSum = +v;
            },
            enumerable: false,
            configurable: true
        });
        return IgxTreemapNodePointerEventArgs;
    }());

    var IgxTreemapComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapComponent(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
            var _this = this;
            this.renderer = renderer;
            this._elRef = _elRef;
            this.ngZone = ngZone;
            this.injector = injector;
            this.componentFactoryResolver = componentFactoryResolver;
            /**
            * The style mappings actually present in the chart. Do not directly modify this array.
            * This array's contents can be modified by causing Angular to reproject the child content.
            * Or adding and removing stye mappings from the manual style mapping collection on the styleMappings property.
            */
            this.actualStyleMappings = [];
            this._styleMappings = null;
            this._styleMappingsAdapter = null;
            this._wrapper = null;
            this._root = null;
            this._implementation = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._nodeStyling = null;
            this._nodePointerOver = null;
            this._nodePointerEnter = null;
            this._nodePointerLeave = null;
            this._nodePointerPressed = null;
            this._nodePointerReleased = null;
            this._zoneRunner = null;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            if (renderer) {
                this.container = renderer.createElement("div");
                renderer.appendChild(_elRef.element.nativeElement, this.container);
                renderer.setStyle(this.container, "display", "block");
                renderer.setStyle(this.container, "width", "100%");
                renderer.setStyle(this.container, "height", "100%");
            }
            var root;
            root = this.container;
            if (this.container != null) {
                root = this.container;
            }
            if (root && root.nativeElement) {
                root = root.nativeElement;
            }
            this._root = root;
            var treemap = this.i;
            this._treeMap = treemap;
            this._styleMappingsAdapter = new i2.CollectionAdapter([], this.i.styleMappings, this.actualStyleMappings, function (c) { return c.i; }, function (i) {
                if (_this._root && _this._root.parentElement) {
                    i._styling(_this._root, _this, _this);
                }
            }, function (i) { });
            if (renderer) {
                var ren = new i2.AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
                this._wrapper = ren;
                treemap.provideContainer(ren);
                treemap.notifySizeChanged();
                ren.addSizeWatcher(function () {
                    _this._treeMap.notifySizeChanged();
                });
            }
        }
        Object.defineProperty(IgxTreemapComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._treeMap.notifySizeChanged();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._treeMap.notifySizeChanged();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "styleMappings", {
            /**
             * A collection or manually added axes for the chart.
            */
            get: function () {
                var _this = this;
                if (this._styleMappings === null) {
                    var coll = new IgxTreemapNodeStyleMappingCollection();
                    var inner = coll._innerColl;
                    inner.addListener(function (sender, e) {
                        switch (e.action) {
                            case i2.NotifyCollectionChangedAction.Add:
                                _this._styleMappingsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Remove:
                                _this._styleMappingsAdapter.removeManualItemAt(e.oldStartingIndex);
                                break;
                            case i2.NotifyCollectionChangedAction.Replace:
                                _this._styleMappingsAdapter.removeManualItemAt(e.oldStartingIndex);
                                _this._styleMappingsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                                break;
                            case i2.NotifyCollectionChangedAction.Reset:
                                _this._styleMappingsAdapter.clearManualItems();
                                break;
                        }
                    });
                    this._styleMappings = coll;
                }
                return this._styleMappings;
            },
            enumerable: false,
            configurable: true
        });
        // supports angular themes or custom properties set in CSS
        IgxTreemapComponent.prototype.updateStyle = function () {
            this._styling(this._root, this);
        };
        IgxTreemapComponent.prototype.ngOnDestroy = function () {
            this._treeMap.destroy();
            this._wrapper.destroy();
        };
        IgxTreemapComponent.prototype.ngAfterContentInit = function () {
            this._styleMappingsAdapter.updateQuery(this.contentStyleMappings);
            this._styling(this._root, this);
            if (this.actualStyleMappings && this.actualStyleMappings.length > 0) {
                var currStyleMapping = this.actualStyleMappings;
                for (var i = 0; i < currStyleMapping.length; i++) {
                    currStyleMapping[i]._styling(this._root, this, this);
                }
            }
            this.i.notifySizeChanged();
            this.updateStyle();
        };
        IgxTreemapComponent.prototype.createImplementation = function () {
            return new Treemap();
        };
        Object.defineProperty(IgxTreemapComponent.prototype, "i", {
            get: function () {
                return this._implementation;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "valueMemberPath", {
            /**
         * Gets or sets path to use to get the values from the items.
        */
            get: function () {
                return this.i.gi;
            },
            set: function (v) {
                this.i.gi = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "rootTitle", {
            /**
             * Gets or sets the root title to use for breadcrumbs.
            */
            get: function () {
                return this.i.f8;
            },
            set: function (v) {
                this.i.f8 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "breadcrumbSequence", {
            /**
             * Gets or sets the root title to use for breadcrumbs.
            */
            get: function () {
                return this.i.ed;
            },
            set: function (v) {
                this.i.ed = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentIdMemberPath", {
            /**
             * Gets or sets the path to use to get the Parent of the items.
            */
            get: function () {
                return this.i.fw;
            },
            set: function (v) {
                this.i.fw = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelMemberPath", {
            /**
             * Gets or sets the path to use to get the Label of the items.
            */
            get: function () {
                return this.i.ff;
            },
            set: function (v) {
                this.i.ff = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "customValueMemberPath", {
            /**
             * Gets or sets the path to use to get the custom value of the items.
            */
            get: function () {
                return this.i.eg;
            },
            set: function (v) {
                this.i.eg = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "idMemberPath", {
            /**
             * Gets or sets the path to use to get the id of the items.
            */
            get: function () {
                return this.i.e5;
            },
            set: function (v) {
                this.i.e5 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "dataSource", {
            /**
             * Gets or sets the (possibly hierarchical) data to assign to the TreeMap.
            */
            get: function () {
                return this.i.dataSource;
            },
            set: function (v) {
                this.i.dataSource = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "fillBrushes", {
            /**
             * Gets or sets brushes to use for the fill scale.
            */
            get: function () {
                return i2.fromBrushCollection(this.i.b);
            },
            set: function (v) {
                this.i.b = i2.toBrushCollection(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "fillScaleMode", {
            /**
             * Gets or sets mode to use for the fill scale.
            */
            get: function () {
                return this.i.d;
            },
            set: function (v) {
                this.i.d = i2.ensureEnum(TreemapFillScaleMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "isFillScaleLogarithmic", {
            /**
             * Gets or sets whether the fill scale is logarithmic.
            */
            get: function () {
                return this.i.bg;
            },
            set: function (v) {
                this.i.bg = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "fillScaleLogarithmBase", {
            /**
             * Gets or sets the logarithm base to use if the fill scale is logarithmic.
            */
            get: function () {
                return this.i.dy;
            },
            set: function (v) {
                this.i.dy = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "fillScaleMinimumValue", {
            /**
             * Gets or sets the minimum value to use for the fill scale.
            */
            get: function () {
                return this.i.ct;
            },
            set: function (v) {
                this.i.ct = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "fillScaleMaximumValue", {
            /**
             * Gets or sets the maximum value to use for the fill scale.
            */
            get: function () {
                return this.i.cs;
            },
            set: function (v) {
                this.i.cs = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelVerticalFitMode", {
            /**
             * Gets or sets the vertical fit mode to use for the node labels.
            */
            get: function () {
                return this.i.p;
            },
            set: function (v) {
                this.i.p = i2.ensureEnum(TreemapLabelVerticalFitMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelHorizontalFitMode", {
            /**
             * Gets or sets the horizontal fit mode to use for the node labels.
            */
            get: function () {
                return this.i.m;
            },
            set: function (v) {
                this.i.m = i2.ensureEnum(TreemapLabelHorizontalFitMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "overlayHeaderHoverBackground", {
            /**
             * Gets or sets the background to use for the overlay header when it is hovered.
            */
            get: function () {
                return i2.brushToString(this.i.h9);
            },
            set: function (v) {
                this.i.h9 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerHoverBackground", {
            /**
             * Gets or sets the background to use for the header when it is hovered.
            */
            get: function () {
                return i2.brushToString(this.i.h3);
            },
            set: function (v) {
                this.i.h3 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerBackground", {
            /**
             * Gets or sets the background to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.h1);
            },
            set: function (v) {
                this.i.h1 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "overlayHeaderBackground", {
            /**
             * Gets or sets the background to use for the overlay header.
            */
            get: function () {
                return i2.brushToString(this.i.h8);
            },
            set: function (v) {
                this.i.h8 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerTextColor", {
            /**
             * Gets or sets the text color to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.h6);
            },
            set: function (v) {
                this.i.h6 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerDarkTextColor", {
            /**
             * Gets or sets the dark text color to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.h2);
            },
            set: function (v) {
                this.i.h2 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "textColor", {
            /**
             * Gets or sets the text color to use for the nodes.
            */
            get: function () {
                return i2.brushToString(this.i.ik);
            },
            set: function (v) {
                this.i.ik = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "darkTextColor", {
            /**
             * Gets or sets the dark text color to use for the nodes.
            */
            get: function () {
                return i2.brushToString(this.i.h0);
            },
            set: function (v) {
                this.i.h0 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerHoverTextColor", {
            /**
             * Gets or sets the text color to use for the header.
            */
            get: function () {
                return i2.brushToString(this.i.h5);
            },
            set: function (v) {
                this.i.h5 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerHoverDarkTextColor", {
            /**
             * Gets or sets the dark text color to use for the header when hovered.
            */
            get: function () {
                return i2.brushToString(this.i.h4);
            },
            set: function (v) {
                this.i.h4 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "textStyle", {
            /**
             * Gets or sets the font to use for content nodes
            */
            get: function () {
                if (this.i.aw == null) {
                    return null;
                }
                return this.i.aw.fontString;
            },
            set: function (v) {
                var fi = new i2.FontInfo();
                fi.fontString = v;
                this.i.aw = fi;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerTextStyle", {
            /**
             * Gets or sets the font to use for header nodes
            */
            get: function () {
                if (this.i.au == null) {
                    return null;
                }
                return this.i.au.fontString;
            },
            set: function (v) {
                var fi = new i2.FontInfo();
                fi.fontString = v;
                this.i.au = fi;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerDisplayMode", {
            /**
             * Gets or sets the font to use for header nodes
            */
            get: function () {
                return this.i.j;
            },
            set: function (v) {
                this.i.j = i2.ensureEnum(TreemapHeaderDisplayMode_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerLabelLeftMargin", {
            /**
             * Gets or sets the left margin to use for the header.
            */
            get: function () {
                return this.i.cx;
            },
            set: function (v) {
                this.i.cx = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerLabelTopMargin", {
            /**
             * Gets or sets the top margin to use for the header.
            */
            get: function () {
                return this.i.cz;
            },
            set: function (v) {
                this.i.cz = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerLabelRightMargin", {
            /**
             * Gets or sets the right margin to use for the header.
            */
            get: function () {
                return this.i.cy;
            },
            set: function (v) {
                this.i.cy = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerLabelBottomMargin", {
            /**
             * Gets or sets the bottom margin to use for the header.
            */
            get: function () {
                return this.i.cw;
            },
            set: function (v) {
                this.i.cw = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "overlayHeaderLabelLeftMargin", {
            /**
             * Gets or sets the left margin to use for the overlay header.
            */
            get: function () {
                return this.i.c7;
            },
            set: function (v) {
                this.i.c7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "overlayHeaderLabelTopMargin", {
            /**
             * Gets or sets the top margin to use for the overlay header.
            */
            get: function () {
                return this.i.c9;
            },
            set: function (v) {
                this.i.c9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "overlayHeaderLabelRightMargin", {
            /**
             * Gets or sets the right margin to use for the overlay header.
            */
            get: function () {
                return this.i.c8;
            },
            set: function (v) {
                this.i.c8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "overlayHeaderLabelBottomMargin", {
            /**
             * Gets or sets the bottom margin to use for the overlay header.
            */
            get: function () {
                return this.i.c6;
            },
            set: function (v) {
                this.i.c6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelLeftMargin", {
            /**
             * Gets or sets the left margin to use for the labels.
            */
            get: function () {
                return this.i.c2;
            },
            set: function (v) {
                this.i.c2 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelTopMargin", {
            /**
             * Gets or sets the top margin to use for the labels.
            */
            get: function () {
                return this.i.c4;
            },
            set: function (v) {
                this.i.c4 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelRightMargin", {
            /**
             * Gets or sets the right margin to use for the labels.
            */
            get: function () {
                return this.i.c3;
            },
            set: function (v) {
                this.i.c3 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelBottomMargin", {
            /**
             * Gets or sets the bottom margin to use for the labels.
            */
            get: function () {
                return this.i.c1;
            },
            set: function (v) {
                this.i.c1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeLeftMargin", {
            /**
             * Gets or sets the left margin to use for the parent nodes.
            */
            get: function () {
                return this.i.dc;
            },
            set: function (v) {
                this.i.dc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeTopMargin", {
            /**
             * Gets or sets the top margin to use for the parent nodes.
            */
            get: function () {
                return this.i.dg;
            },
            set: function (v) {
                this.i.dg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeRightMargin", {
            /**
             * Gets or sets the right margin to use for the parent nodes.
            */
            get: function () {
                return this.i.de;
            },
            set: function (v) {
                this.i.de = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeBottomMargin", {
            /**
             * Gets or sets the bottom margin to use for the parent nodes.
            */
            get: function () {
                return this.i.da;
            },
            set: function (v) {
                this.i.da = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeLeftPadding", {
            /**
             * Gets or sets the left padding to use for the parent nodes.
            */
            get: function () {
                return this.i.dd;
            },
            set: function (v) {
                this.i.dd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeTopPadding", {
            /**
             * Gets or sets the top padding to use for the parent nodes.
            */
            get: function () {
                return this.i.dh;
            },
            set: function (v) {
                this.i.dh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeRightPadding", {
            /**
             * Gets or sets the right padding to use for the parent nodes.
            */
            get: function () {
                return this.i.df;
            },
            set: function (v) {
                this.i.df = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "parentNodeBottomPadding", {
            /**
             * Gets or sets the bottom padding to use for the parent nodes.
            */
            get: function () {
                return this.i.db;
            },
            set: function (v) {
                this.i.db = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelHorizontalAlignment", {
            /**
             * Gets or sets the horizontal alignment to use for the node labels.
            */
            get: function () {
                return this.i.hn;
            },
            set: function (v) {
                this.i.hn = i2.ensureEnum(i2.HorizontalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "labelVerticalAlignment", {
            /**
             * Gets or sets the vertical alignment to use for the node labels.
            */
            get: function () {
                return this.i.ir;
            },
            set: function (v) {
                this.i.ir = i2.ensureEnum(i2.VerticalAlignment_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "headerHeight", {
            /**
             * Gets or sets the height to use for the header.
            */
            get: function () {
                return this.i.cv;
            },
            set: function (v) {
                this.i.cv = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "outline", {
            /**
             * Gets or sets the outline to use for the nodes.
            */
            get: function () {
                return i2.brushToString(this.i.h7);
            },
            set: function (v) {
                this.i.h7 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "strokeThickness", {
            /**
             * Gets or sets the stroke thickness to use for the node outline.
            */
            get: function () {
                return this.i.dt;
            },
            set: function (v) {
                this.i.dt = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "layoutOrientation", {
            /**
             * Gets or sets the orientation to use for the stripped and slice and dice layout types.
            */
            get: function () {
                return this.i.ai;
            },
            set: function (v) {
                this.i.ai = i2.ensureEnum(TreemapOrientation_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "layoutType", {
            /**
             * Gets or sets the type of layout to use for the nodes.
            */
            get: function () {
                return this.i.s;
            },
            set: function (v) {
                this.i.s = i2.ensureEnum(TreemapLayoutType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "minimumDisplaySize", {
            /**
             * Gets or sets the minimum size (width or height) to display a node.
            */
            get: function () {
                return this.i.c5;
            },
            set: function (v) {
                this.i.c5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "transitionDuration", {
            /**
             * Gets or sets the number of milliseconds over which changes to the gauge should be animated.
            */
            get: function () {
                return this.i.d1;
            },
            set: function (v) {
                this.i.d1 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.di;
            },
            set: function (v) {
                this.i.di = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "actualPixelScalingRatio", {
            get: function () {
                return this.i.cp;
            },
            set: function (v) {
                this.i.cp = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "interactionPixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control while it is animating.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.c0;
            },
            set: function (v) {
                this.i.c0 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "actualInteractionPixelScalingRatio", {
            /**
             * Gets or sets the resolved scaling value used to affect the pixel density of the control while it is animating.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.co;
            },
            set: function (v) {
                this.i.co = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "animating", {
            get: function () {
                return this.i.bc;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "focusItem", {
            /**
             * Gets or sets the item to drill to in the treemap.
            */
            get: function () {
                return this.i.d3;
            },
            set: function (v) {
                this.i.d3 = v;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapComponent.prototype.findByName = function (name) {
            if (this.styleMappings != null && this.styleMappings.findByName && this.styleMappings.findByName(name)) {
                return this.styleMappings.findByName(name);
            }
            return null;
        };
        Object.defineProperty(IgxTreemapComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxTreemapComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("TreemapComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        IgxTreemapComponent.prototype.notifySizeChanged = function () {
            this.i.notifySizeChanged();
        };
        /**
         * Returns visuals as a serialized string.
        
        */
        IgxTreemapComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.ej();
            return (iv);
        };
        IgxTreemapComponent.prototype.markDirty = function () {
            this.i.gt();
        };
        IgxTreemapComponent.prototype.onDetachedFromUI = function () {
            this.i.onDetachedFromUI();
        };
        IgxTreemapComponent.prototype.onAttachedToUI = function () {
            this.i.onAttachedToUI();
        };
        IgxTreemapComponent.prototype.flush = function () {
            this.i.gr();
        };
        IgxTreemapComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.gx(source_, index, oldItem, newItem);
        };
        /**
         * Manually notifies the treemap's data source that the data it has bound to has been cleared and needs to be re-examined.
         * This should not be called if the data that the pie chart is bound to is already observable.
        
        * @param source_  * The data source.
        */
        IgxTreemapComponent.prototype.notifyClearItems = function (source_) {
            this.i.gu(source_);
        };
        IgxTreemapComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.gv(source_, index, newItem);
        };
        IgxTreemapComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.gw(source_, index, oldItem);
        };
        IgxTreemapComponent.prototype.simulateHover = function (point) {
            this.i.hg(i2.toPoint(point));
        };
        Object.defineProperty(IgxTreemapComponent.prototype, "nodeStyling", {
            /**
             * Fired when a node is being styled. Provides an opportunity to customize node styling.
            */
            get: function () {
                var _this = this;
                if (this._nodeStyling == null) {
                    this._nodeStyling = new i0.EventEmitter();
                    this.i.nodeStyling = i2.delegateCombine(this.i.nodeStyling, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxTreemapNodeStylingEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeNodeStyling) {
                                _this.beforeNodeStyling(_this, outerArgs);
                            }
                            _this._nodeStyling.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._nodeStyling;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "nodePointerOver", {
            /**
             * Fired with the pointer is moving over a node.
            */
            get: function () {
                var _this = this;
                if (this._nodePointerOver == null) {
                    this._nodePointerOver = new i0.EventEmitter();
                    this.i.nodePointerOver = i2.delegateCombine(this.i.nodePointerOver, function (o, e) {
                        var outerArgs = new IgxTreemapNodePointerEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeNodePointerOver) {
                            _this.beforeNodePointerOver(_this, outerArgs);
                        }
                        _this._nodePointerOver.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._nodePointerOver;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "nodePointerEnter", {
            /**
             * Fired when the pointer enters a node.
            */
            get: function () {
                var _this = this;
                if (this._nodePointerEnter == null) {
                    this._nodePointerEnter = new i0.EventEmitter();
                    this.i.nodePointerEnter = i2.delegateCombine(this.i.nodePointerEnter, function (o, e) {
                        var outerArgs = new IgxTreemapNodePointerEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeNodePointerEnter) {
                            _this.beforeNodePointerEnter(_this, outerArgs);
                        }
                        _this._nodePointerEnter.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._nodePointerEnter;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "nodePointerLeave", {
            /**
             * Fired when the pointer leaved a node.
            */
            get: function () {
                var _this = this;
                if (this._nodePointerLeave == null) {
                    this._nodePointerLeave = new i0.EventEmitter();
                    this.i.nodePointerLeave = i2.delegateCombine(this.i.nodePointerLeave, function (o, e) {
                        var outerArgs = new IgxTreemapNodePointerEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforeNodePointerLeave) {
                            _this.beforeNodePointerLeave(_this, outerArgs);
                        }
                        _this._nodePointerLeave.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                }
                return this._nodePointerLeave;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "nodePointerPressed", {
            /**
             * Fired when the pointer is pressed on a node.
            */
            get: function () {
                var _this = this;
                if (this._nodePointerPressed == null) {
                    this._nodePointerPressed = new i0.EventEmitter();
                    this.i.nodePointerPressed = i2.delegateCombine(this.i.nodePointerPressed, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxTreemapNodePointerEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeNodePointerPressed) {
                                _this.beforeNodePointerPressed(_this, outerArgs);
                            }
                            _this._nodePointerPressed.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._nodePointerPressed;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxTreemapComponent.prototype, "nodePointerReleased", {
            /**
             * Fired when the pointer is released on a node.
            */
            get: function () {
                var _this = this;
                if (this._nodePointerReleased == null) {
                    this._nodePointerReleased = new i0.EventEmitter();
                    this.i.nodePointerReleased = i2.delegateCombine(this.i.nodePointerReleased, function (o, e) {
                        _this._runInZone(function () {
                            var outerArgs = new IgxTreemapNodePointerEventArgs();
                            outerArgs._provideImplementation(e);
                            if (_this.beforeNodePointerReleased) {
                                _this.beforeNodePointerReleased(_this, outerArgs);
                            }
                            _this._nodePointerReleased.emit({
                                sender: _this,
                                args: outerArgs
                            });
                        });
                    });
                }
                return this._nodePointerReleased;
            },
            enumerable: false,
            configurable: true
        });
        IgxTreemapComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        IgxTreemapComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.Injector }, { token: i0.ComponentFactoryResolver }], target: i0.ɵɵFactoryTarget.Component });
        IgxTreemapComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxTreemapComponent, selector: "igx-treemap", inputs: { height: "height", width: "width", valueMemberPath: "valueMemberPath", rootTitle: "rootTitle", breadcrumbSequence: "breadcrumbSequence", parentIdMemberPath: "parentIdMemberPath", labelMemberPath: "labelMemberPath", customValueMemberPath: "customValueMemberPath", idMemberPath: "idMemberPath", dataSource: "dataSource", fillBrushes: "fillBrushes", fillScaleMode: "fillScaleMode", isFillScaleLogarithmic: "isFillScaleLogarithmic", fillScaleLogarithmBase: "fillScaleLogarithmBase", fillScaleMinimumValue: "fillScaleMinimumValue", fillScaleMaximumValue: "fillScaleMaximumValue", labelVerticalFitMode: "labelVerticalFitMode", labelHorizontalFitMode: "labelHorizontalFitMode", overlayHeaderHoverBackground: "overlayHeaderHoverBackground", headerHoverBackground: "headerHoverBackground", headerBackground: "headerBackground", overlayHeaderBackground: "overlayHeaderBackground", headerTextColor: "headerTextColor", headerDarkTextColor: "headerDarkTextColor", textColor: "textColor", darkTextColor: "darkTextColor", headerHoverTextColor: "headerHoverTextColor", headerHoverDarkTextColor: "headerHoverDarkTextColor", textStyle: "textStyle", headerTextStyle: "headerTextStyle", headerDisplayMode: "headerDisplayMode", headerLabelLeftMargin: "headerLabelLeftMargin", headerLabelTopMargin: "headerLabelTopMargin", headerLabelRightMargin: "headerLabelRightMargin", headerLabelBottomMargin: "headerLabelBottomMargin", overlayHeaderLabelLeftMargin: "overlayHeaderLabelLeftMargin", overlayHeaderLabelTopMargin: "overlayHeaderLabelTopMargin", overlayHeaderLabelRightMargin: "overlayHeaderLabelRightMargin", overlayHeaderLabelBottomMargin: "overlayHeaderLabelBottomMargin", labelLeftMargin: "labelLeftMargin", labelTopMargin: "labelTopMargin", labelRightMargin: "labelRightMargin", labelBottomMargin: "labelBottomMargin", parentNodeLeftMargin: "parentNodeLeftMargin", parentNodeTopMargin: "parentNodeTopMargin", parentNodeRightMargin: "parentNodeRightMargin", parentNodeBottomMargin: "parentNodeBottomMargin", parentNodeLeftPadding: "parentNodeLeftPadding", parentNodeTopPadding: "parentNodeTopPadding", parentNodeRightPadding: "parentNodeRightPadding", parentNodeBottomPadding: "parentNodeBottomPadding", labelHorizontalAlignment: "labelHorizontalAlignment", labelVerticalAlignment: "labelVerticalAlignment", headerHeight: "headerHeight", outline: "outline", strokeThickness: "strokeThickness", layoutOrientation: "layoutOrientation", layoutType: "layoutType", minimumDisplaySize: "minimumDisplaySize", transitionDuration: "transitionDuration", pixelScalingRatio: "pixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio", interactionPixelScalingRatio: "interactionPixelScalingRatio", actualInteractionPixelScalingRatio: "actualInteractionPixelScalingRatio", focusItem: "focusItem" }, outputs: { nodeStyling: "nodeStyling", nodePointerOver: "nodePointerOver", nodePointerEnter: "nodePointerEnter", nodePointerLeave: "nodePointerLeave", nodePointerPressed: "nodePointerPressed", nodePointerReleased: "nodePointerReleased" }, host: { classAttribute: "ig-treemap igx-treemap" }, providers: [], queries: [{ propertyName: "contentStyleMappings", predicate: IgxTreemapNodeStyleMappingComponent }], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], ngImport: i0, template: "", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxTreemapComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-treemap',
                        template: "",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-treemap igx-treemap' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.Injector }, { type: i0.ComponentFactoryResolver }]; }, propDecorators: { height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], contentStyleMappings: [{
                    type: i0.ContentChildren,
                    args: [IgxTreemapNodeStyleMappingComponent]
                }], valueMemberPath: [{
                    type: i0.Input
                }], rootTitle: [{
                    type: i0.Input
                }], breadcrumbSequence: [{
                    type: i0.Input
                }], parentIdMemberPath: [{
                    type: i0.Input
                }], labelMemberPath: [{
                    type: i0.Input
                }], customValueMemberPath: [{
                    type: i0.Input
                }], idMemberPath: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], fillBrushes: [{
                    type: i0.Input
                }], fillScaleMode: [{
                    type: i0.Input
                }], isFillScaleLogarithmic: [{
                    type: i0.Input
                }], fillScaleLogarithmBase: [{
                    type: i0.Input
                }], fillScaleMinimumValue: [{
                    type: i0.Input
                }], fillScaleMaximumValue: [{
                    type: i0.Input
                }], labelVerticalFitMode: [{
                    type: i0.Input
                }], labelHorizontalFitMode: [{
                    type: i0.Input
                }], overlayHeaderHoverBackground: [{
                    type: i0.Input
                }], headerHoverBackground: [{
                    type: i0.Input
                }], headerBackground: [{
                    type: i0.Input
                }], overlayHeaderBackground: [{
                    type: i0.Input
                }], headerTextColor: [{
                    type: i0.Input
                }], headerDarkTextColor: [{
                    type: i0.Input
                }], textColor: [{
                    type: i0.Input
                }], darkTextColor: [{
                    type: i0.Input
                }], headerHoverTextColor: [{
                    type: i0.Input
                }], headerHoverDarkTextColor: [{
                    type: i0.Input
                }], textStyle: [{
                    type: i0.Input
                }], headerTextStyle: [{
                    type: i0.Input
                }], headerDisplayMode: [{
                    type: i0.Input
                }], headerLabelLeftMargin: [{
                    type: i0.Input
                }], headerLabelTopMargin: [{
                    type: i0.Input
                }], headerLabelRightMargin: [{
                    type: i0.Input
                }], headerLabelBottomMargin: [{
                    type: i0.Input
                }], overlayHeaderLabelLeftMargin: [{
                    type: i0.Input
                }], overlayHeaderLabelTopMargin: [{
                    type: i0.Input
                }], overlayHeaderLabelRightMargin: [{
                    type: i0.Input
                }], overlayHeaderLabelBottomMargin: [{
                    type: i0.Input
                }], labelLeftMargin: [{
                    type: i0.Input
                }], labelTopMargin: [{
                    type: i0.Input
                }], labelRightMargin: [{
                    type: i0.Input
                }], labelBottomMargin: [{
                    type: i0.Input
                }], parentNodeLeftMargin: [{
                    type: i0.Input
                }], parentNodeTopMargin: [{
                    type: i0.Input
                }], parentNodeRightMargin: [{
                    type: i0.Input
                }], parentNodeBottomMargin: [{
                    type: i0.Input
                }], parentNodeLeftPadding: [{
                    type: i0.Input
                }], parentNodeTopPadding: [{
                    type: i0.Input
                }], parentNodeRightPadding: [{
                    type: i0.Input
                }], parentNodeBottomPadding: [{
                    type: i0.Input
                }], labelHorizontalAlignment: [{
                    type: i0.Input
                }], labelVerticalAlignment: [{
                    type: i0.Input
                }], headerHeight: [{
                    type: i0.Input
                }], outline: [{
                    type: i0.Input
                }], strokeThickness: [{
                    type: i0.Input
                }], layoutOrientation: [{
                    type: i0.Input
                }], layoutType: [{
                    type: i0.Input
                }], minimumDisplaySize: [{
                    type: i0.Input
                }], transitionDuration: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], actualPixelScalingRatio: [{
                    type: i0.Input
                }], interactionPixelScalingRatio: [{
                    type: i0.Input
                }], actualInteractionPixelScalingRatio: [{
                    type: i0.Input
                }], focusItem: [{
                    type: i0.Input
                }], nodeStyling: [{
                    type: i0.Output
                }], nodePointerOver: [{
                    type: i0.Output
                }], nodePointerEnter: [{
                    type: i0.Output
                }], nodePointerLeave: [{
                    type: i0.Output
                }], nodePointerPressed: [{
                    type: i0.Output
                }], nodePointerReleased: [{
                    type: i0.Output
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTreemapNodeStyleModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodeStyleModule() {
        }
        IgxTreemapNodeStyleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTreemapNodeStyleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleModule, declarations: [IgxTreemapNodeStyleComponent], imports: [i1.CommonModule], exports: [IgxTreemapNodeStyleComponent] });
        IgxTreemapNodeStyleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleModule, imports: [[i1.CommonModule]] });
        return IgxTreemapNodeStyleModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTreemapNodeStyleComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxTreemapNodeStyleComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTreemapNodeStyleDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodeStyleDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTreemapNodeStyleComponent", IgxTreemapNodeStyleComponent);
            i2.TypeRegistrar.register("TreemapNodeStyle", TreemapNodeStyle.$type);
        }
        IgxTreemapNodeStyleDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTreemapNodeStyleDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleDynamicModule, imports: [i1.CommonModule, IgxTreemapNodeStyleModule], exports: [IgxTreemapNodeStyleModule] });
        IgxTreemapNodeStyleDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleDynamicModule, imports: [[i1.CommonModule, IgxTreemapNodeStyleModule], IgxTreemapNodeStyleModule] });
        return IgxTreemapNodeStyleDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTreemapNodeStyleModule],
                        exports: [IgxTreemapNodeStyleModule],
                        entryComponents: [IgxTreemapNodeStyleComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTreemapNodeStyleMappingModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodeStyleMappingModule() {
        }
        IgxTreemapNodeStyleMappingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTreemapNodeStyleMappingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingModule, declarations: [IgxTreemapNodeStyleMappingComponent], imports: [i1.CommonModule], exports: [IgxTreemapNodeStyleMappingComponent] });
        IgxTreemapNodeStyleMappingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingModule, imports: [[i1.CommonModule]] });
        return IgxTreemapNodeStyleMappingModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTreemapNodeStyleMappingComponent],
                        imports: [i1.CommonModule],
                        exports: [IgxTreemapNodeStyleMappingComponent],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTreemapNodeStyleMappingDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapNodeStyleMappingDynamicModule() {
            i2.TypeRegistrar.registerCons("IgxTreemapNodeStyleMappingComponent", IgxTreemapNodeStyleMappingComponent);
            i2.TypeRegistrar.register("TreemapNodeStyleMapping", TreemapNodeStyleMapping.$type);
        }
        IgxTreemapNodeStyleMappingDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTreemapNodeStyleMappingDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingDynamicModule, imports: [i1.CommonModule, IgxTreemapNodeStyleMappingModule], exports: [IgxTreemapNodeStyleMappingModule] });
        IgxTreemapNodeStyleMappingDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingDynamicModule, imports: [[i1.CommonModule, IgxTreemapNodeStyleMappingModule], IgxTreemapNodeStyleMappingModule] });
        return IgxTreemapNodeStyleMappingDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapNodeStyleMappingDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [i1.CommonModule, IgxTreemapNodeStyleMappingModule],
                        exports: [IgxTreemapNodeStyleMappingModule],
                        entryComponents: [IgxTreemapNodeStyleMappingComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTreemapModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapModule() {
            i2.TypeRegistrar.registerCons('IgxTreemapComponent', IgxTreemapComponent);
            i2.TypeRegistrar.register('Treemap', Treemap.$type);
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxTreemapModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTreemapModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapModule, declarations: [IgxTreemapComponent], imports: [i1.CommonModule, IgxTreemapNodeStyleDynamicModule,
                IgxTreemapNodeStyleMappingModule], exports: [IgxTreemapComponent,
                IgxTreemapNodeStyleDynamicModule,
                IgxTreemapNodeStyleMappingModule] });
        IgxTreemapModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapModule, imports: [[i1.CommonModule, IgxTreemapNodeStyleDynamicModule,
                    IgxTreemapNodeStyleMappingModule
                ], IgxTreemapNodeStyleDynamicModule,
                IgxTreemapNodeStyleMappingModule] });
        return IgxTreemapModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxTreemapComponent],
                        exports: [IgxTreemapComponent,
                            IgxTreemapNodeStyleDynamicModule,
                            IgxTreemapNodeStyleMappingModule
                        ],
                        imports: [i1.CommonModule, IgxTreemapNodeStyleDynamicModule,
                            IgxTreemapNodeStyleMappingModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxTreemapDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxTreemapDynamicModule() {
            i2.TypeRegistrar.registerCons('Treemap', Treemap);
            i2.TypeRegistrar.registerCons('IgxTreemapComponent', IgxTreemapComponent);
            i2.TypeRegistrar.register('Treemap', Treemap.$type);
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxTreemapDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxTreemapDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapDynamicModule, imports: [i1.CommonModule, IgxTreemapNodeStyleDynamicModule,
                IgxTreemapNodeStyleMappingDynamicModule,
                IgxTreemapModule], exports: [IgxTreemapNodeStyleDynamicModule,
                IgxTreemapNodeStyleMappingDynamicModule,
                IgxTreemapModule] });
        IgxTreemapDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapDynamicModule, imports: [[i1.CommonModule, IgxTreemapNodeStyleDynamicModule,
                    IgxTreemapNodeStyleMappingDynamicModule,
                    IgxTreemapModule
                ], IgxTreemapNodeStyleDynamicModule,
                IgxTreemapNodeStyleMappingDynamicModule,
                IgxTreemapModule] });
        return IgxTreemapDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxTreemapDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxTreemapNodeStyleDynamicModule,
                            IgxTreemapNodeStyleMappingDynamicModule,
                            IgxTreemapModule
                        ],
                        imports: [i1.CommonModule, IgxTreemapNodeStyleDynamicModule,
                            IgxTreemapNodeStyleMappingDynamicModule,
                            IgxTreemapModule
                        ],
                        entryComponents: [IgxTreemapComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ServiceProvider_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ServiceProvider_Spark, _super);
        function ServiceProvider_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = i2.DictionaryUtil.dictionaryCreate();
            return _this;
        }
        ServiceProvider_Spark.prototype.addService = function (a, b) {
            this.a.set(a, b);
        };
        ServiceProvider_Spark.prototype.getService = function (a) {
            return this.a.get(a);
        };
        ServiceProvider_Spark.$t = i2.markType(ServiceProvider_Spark, 'ServiceProvider_Spark');
        return ServiceProvider_Spark;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var Message_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(Message_Spark, _super);
        function Message_Spark() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Message_Spark.prototype.toString = function () {
            return i2.getInstanceType(this).toString();
        };
        Message_Spark.$t = i2.markType(Message_Spark, 'Message_Spark');
        return Message_Spark;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MessageChannel_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MessageChannel_Spark, _super);
        function MessageChannel_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = new i2.Queue$1(Message_Spark.$);
            _this.messageSent = null;
            _this.a = null;
            return _this;
        }
        MessageChannel_Spark.prototype.sendMessage = function (a) {
            if (this.messageSent != null) {
                this.messageSent(a);
            }
            else {
                this.c.g(a);
            }
        };
        MessageChannel_Spark.prototype.attachTarget = function (a) {
            this.messageSent = i2.delegateCombine(this.messageSent, a);
            while (this.c.count > 0) {
                var b = this.c.b();
                this.messageSent(b);
            }
        };
        MessageChannel_Spark.prototype.detachTarget = function (a) {
            this.messageSent = i2.delegateRemove(this.messageSent, a);
        };
        MessageChannel_Spark.prototype.connectTo = function (a) {
            this.a = a;
            this.attachTarget(i2.runOn(this, this.sendToNext));
        };
        MessageChannel_Spark.prototype.detachFromNext = function () {
            if (this.a == null) {
                return;
            }
            this.detachTarget(i2.runOn(this, this.sendToNext));
            this.a = null;
        };
        MessageChannel_Spark.prototype.sendToNext = function (a) {
            if (this.a != null) {
                this.a.sendMessage(a);
            }
        };
        MessageChannel_Spark.prototype.toString = function () {
            return "MessageQueue";
        };
        MessageChannel_Spark.$t = i2.markType(MessageChannel_Spark, 'MessageChannel_Spark');
        return MessageChannel_Spark;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var RenderingMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(RenderingMessage_Spark, _super);
        function RenderingMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            return _this;
        }
        RenderingMessage_Spark.$t = i2.markType(RenderingMessage_Spark, 'RenderingMessage_Spark', Message_Spark.$);
        return RenderingMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var AxisRenderMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(AxisRenderMessage_Spark, _super);
        function AxisRenderMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = false;
            return _this;
        }
        AxisRenderMessage_Spark.$t = i2.markType(AxisRenderMessage_Spark, 'AxisRenderMessage_Spark', RenderingMessage_Spark.$);
        return AxisRenderMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ContainerResizedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContainerResizedMessage_Spark, _super);
        function ContainerResizedMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.g = 0;
            _this.d = 0;
            _this.f = 0;
            _this.e = 0;
            _this.h = null;
            _this.i = null;
            _this.j = null;
            _this.k = null;
            _this.b = null;
            _this.c = null;
            return _this;
        }
        ContainerResizedMessage_Spark.$t = i2.markType(ContainerResizedMessage_Spark, 'ContainerResizedMessage_Spark', Message_Spark.$);
        return ContainerResizedMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var InteractionMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(InteractionMessage_Spark, _super);
        function InteractionMessage_Spark() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        InteractionMessage_Spark.$t = i2.markType(InteractionMessage_Spark, 'InteractionMessage_Spark', Message_Spark.$);
        return InteractionMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ViewportChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ViewportChangedMessage_Spark, _super);
        function ViewportChangedMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = 0;
            _this.c = 0;
            _this.e = 0;
            _this.b = 0;
            return _this;
        }
        Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newTop", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newLeft", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newWidth", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newHeight", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        ViewportChangedMessage_Spark.prototype.toString = function () {
            return "ViewportChangedMessage[" + this.newTop.toString() + ", " + this.newLeft.toString() + ", " + this.newWidth.toString() + ", " + this.newHeight.toString() + "]";
        };
        ViewportChangedMessage_Spark.$t = i2.markType(ViewportChangedMessage_Spark, 'ViewportChangedMessage_Spark', InteractionMessage_Spark.$);
        return ViewportChangedMessage_Spark;
    }(InteractionMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PixelRatioMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PixelRatioMessage_Spark, _super);
        function PixelRatioMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            return _this;
        }
        PixelRatioMessage_Spark.$t = i2.markType(PixelRatioMessage_Spark, 'PixelRatioMessage_Spark', Message_Spark.$);
        return PixelRatioMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SparklineAxisVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparklineAxisVisualData, _super);
        function SparklineAxisVisualData() {
            var _this = _super.call(this) || this;
            _this._name = null;
            _this._minLabel = null;
            _this._maxLabel = null;
            _this._axisLine = null;
            return _this;
        }
        Object.defineProperty(SparklineAxisVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineAxisVisualData.prototype, "minLabel", {
            get: function () {
                return this._minLabel;
            },
            set: function (a) {
                this._minLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineAxisVisualData.prototype, "maxLabel", {
            get: function () {
                return this._maxLabel;
            },
            set: function (a) {
                this._maxLabel = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineAxisVisualData.prototype, "axisLine", {
            get: function () {
                return this._axisLine;
            },
            set: function (a) {
                this._axisLine = a;
            },
            enumerable: false,
            configurable: true
        });
        SparklineAxisVisualData.prototype.scaleByViewport = function (a) {
        };
        SparklineAxisVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("name: \"" + this.name + "\"");
            if (this.minLabel != null) {
                a.u(",");
                a.l("minLabel: " + this.minLabel.serialize());
            }
            if (this.maxLabel != null) {
                a.u(",");
                a.l("maxLabel: " + this.maxLabel.serialize());
            }
            if (this.axisLine != null) {
                a.u(",");
                a.l("axisLine: " + this.axisLine.serialize());
            }
            a.u("");
            a.u("}");
            return a.toString();
        };
        SparklineAxisVisualData.$t = i2.markType(SparklineAxisVisualData, 'SparklineAxisVisualData');
        return SparklineAxisVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ClearMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ClearMessage_Spark, _super);
        function ClearMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = false;
            return _this;
        }
        ClearMessage_Spark.$t = i2.markType(ClearMessage_Spark, 'ClearMessage_Spark', RenderingMessage_Spark.$);
        return ClearMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PolygonMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PolygonMessage_Spark, _super);
        function PolygonMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            return _this;
        }
        Object.defineProperty(PolygonMessage_Spark.prototype, "points", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        PolygonMessage_Spark.$t = i2.markType(PolygonMessage_Spark, 'PolygonMessage_Spark', RenderingMessage_Spark.$);
        return PolygonMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ColumnMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ColumnMessage_Spark, _super);
        function ColumnMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.g = null;
            _this.k = null;
            _this.l = null;
            _this.f = null;
            _this.e = null;
            _this.i = 0;
            _this.h = 0;
            _this.j = 0;
            _this.c = 0;
            return _this;
        }
        ColumnMessage_Spark.$t = i2.markType(ColumnMessage_Spark, 'ColumnMessage_Spark', RenderingMessage_Spark.$);
        return ColumnMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var WinLossColumnMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(WinLossColumnMessage_Spark, _super);
        function WinLossColumnMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.d = null;
            _this.g = null;
            _this.k = null;
            _this.l = null;
            _this.f = null;
            _this.e = null;
            _this.i = 0;
            _this.h = 0;
            _this.j = 0;
            _this.c = 0;
            return _this;
        }
        WinLossColumnMessage_Spark.$t = i2.markType(WinLossColumnMessage_Spark, 'WinLossColumnMessage_Spark', RenderingMessage_Spark.$);
        return WinLossColumnMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MarkerMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MarkerMessage_Spark, _super);
        function MarkerMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.e = null;
            _this.f = null;
            _this.m = null;
            _this.n = null;
            _this.d = null;
            _this.c = null;
            _this.k = 0;
            _this.g = 0;
            _this.i = 0;
            _this.h = 0;
            _this.j = 0;
            _this.l = 0;
            return _this;
        }
        MarkerMessage_Spark.$t = i2.markType(MarkerMessage_Spark, 'MarkerMessage_Spark', RenderingMessage_Spark.$);
        return MarkerMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NormalRangeMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NormalRangeMessage_Spark, _super);
        function NormalRangeMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.g = 0;
            _this.h = 0;
            _this.f = 0;
            _this.e = 0;
            _this.c = false;
            return _this;
        }
        Object.defineProperty(NormalRangeMessage_Spark.prototype, "k", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NormalRangeMessage_Spark.prototype, "l", {
            get: function () {
                return this.h;
            },
            set: function (a) {
                this.h = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NormalRangeMessage_Spark.prototype, "j", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NormalRangeMessage_Spark.prototype, "i", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NormalRangeMessage_Spark.prototype, "d", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        NormalRangeMessage_Spark.$t = i2.markType(NormalRangeMessage_Spark, 'NormalRangeMessage_Spark', RenderingMessage_Spark.$);
        return NormalRangeMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrendLineMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TrendLineMessage_Spark, _super);
        function TrendLineMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            return _this;
        }
        Object.defineProperty(TrendLineMessage_Spark.prototype, "points", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        TrendLineMessage_Spark.$t = i2.markType(TrendLineMessage_Spark, 'TrendLineMessage_Spark', RenderingMessage_Spark.$);
        return TrendLineMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TooltipMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(TooltipMessage_Spark, _super);
        function TooltipMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.d = 0;
            _this.g = null;
            return _this;
        }
        Object.defineProperty(TooltipMessage_Spark.prototype, "xOffset", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TooltipMessage_Spark.prototype, "yOffset", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(TooltipMessage_Spark.prototype, "context", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        TooltipMessage_Spark.$t = i2.markType(TooltipMessage_Spark, 'TooltipMessage_Spark', RenderingMessage_Spark.$);
        return TooltipMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ToooltipTemplateMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ToooltipTemplateMessage_Spark, _super);
        function ToooltipTemplateMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            return _this;
        }
        Object.defineProperty(ToooltipTemplateMessage_Spark.prototype, "template", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        ToooltipTemplateMessage_Spark.$t = i2.markType(ToooltipTemplateMessage_Spark, 'ToooltipTemplateMessage_Spark', RenderingMessage_Spark.$);
        return ToooltipTemplateMessage_Spark;
    }(RenderingMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ContainerMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContainerMessage_Spark, _super);
        function ContainerMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            return _this;
        }
        ContainerMessage_Spark.$t = i2.markType(ContainerMessage_Spark, 'ContainerMessage_Spark', Message_Spark.$);
        return ContainerMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var BrushChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(BrushChangedMessage_Spark, _super);
        function BrushChangedMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = null;
            _this.b = null;
            return _this;
        }
        BrushChangedMessage_Spark.$t = i2.markType(BrushChangedMessage_Spark, 'BrushChangedMessage_Spark', Message_Spark.$);
        return BrushChangedMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var VisibilityMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VisibilityMessage_Spark, _super);
        function VisibilityMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.b = null;
            return _this;
        }
        VisibilityMessage_Spark.$t = i2.markType(VisibilityMessage_Spark, 'VisibilityMessage_Spark', Message_Spark.$);
        return VisibilityMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var NumberChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(NumberChangedMessage_Spark, _super);
        function NumberChangedMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = 0;
            _this.c = null;
            return _this;
        }
        NumberChangedMessage_Spark.$t = i2.markType(NumberChangedMessage_Spark, 'NumberChangedMessage_Spark', Message_Spark.$);
        return NumberChangedMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ContainerSizeChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ContainerSizeChangedMessage_Spark, _super);
        function ContainerSizeChangedMessage_Spark() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ContainerSizeChangedMessage_Spark.$t = i2.markType(ContainerSizeChangedMessage_Spark, 'ContainerSizeChangedMessage_Spark', InteractionMessage_Spark.$);
        return ContainerSizeChangedMessage_Spark;
    }(InteractionMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseMoveMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MouseMoveMessage_Spark, _super);
        function MouseMoveMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(MouseMoveMessage_Spark.prototype, "position", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        MouseMoveMessage_Spark.$t = i2.markType(MouseMoveMessage_Spark, 'MouseMoveMessage_Spark', InteractionMessage_Spark.$);
        return MouseMoveMessage_Spark;
    }(InteractionMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MouseLeaveMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MouseLeaveMessage_Spark, _super);
        function MouseLeaveMessage_Spark() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MouseLeaveMessage_Spark.$t = i2.markType(MouseLeaveMessage_Spark, 'MouseLeaveMessage_Spark', InteractionMessage_Spark.$);
        return MouseLeaveMessage_Spark;
    }(InteractionMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SparklineToolTipContext = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparklineToolTipContext, _super);
        function SparklineToolTipContext() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._high = 0;
            _this._low = 0;
            _this._first = 0;
            _this._last = 0;
            return _this;
        }
        Object.defineProperty(SparklineToolTipContext.prototype, "high", {
            get: function () {
                return this._high;
            },
            set: function (a) {
                this._high = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineToolTipContext.prototype, "low", {
            get: function () {
                return this._low;
            },
            set: function (a) {
                this._low = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineToolTipContext.prototype, "first", {
            get: function () {
                return this._first;
            },
            set: function (a) {
                this._first = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineToolTipContext.prototype, "last", {
            get: function () {
                return this._last;
            },
            set: function (a) {
                this._last = a;
            },
            enumerable: false,
            configurable: true
        });
        SparklineToolTipContext.$t = i2.markType(SparklineToolTipContext, 'SparklineToolTipContext', i2.EventArgs.$);
        return SparklineToolTipContext;
    }(i2.EventArgs));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SparklineVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparklineVisualData, _super);
        function SparklineVisualData() {
            var _this = _super.call(this) || this;
            _this._name = null;
            _this._horizontalAxis = null;
            _this._verticalAxis = null;
            _this._sparkPath = null;
            _this._negativeSparkPath = null;
            _this._trendLinePath = null;
            _this._rangePath = null;
            _this._markersPath = null;
            _this._negativeMarkersPath = null;
            _this._lowMarkersPath = null;
            _this._highMarkersPath = null;
            _this._firstMarkerPath = null;
            _this._lastMarkerPath = null;
            _this._viewport = null;
            _this._marginViewport = null;
            return _this;
        }
        Object.defineProperty(SparklineVisualData.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (a) {
                this._name = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "horizontalAxis", {
            get: function () {
                return this._horizontalAxis;
            },
            set: function (a) {
                this._horizontalAxis = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "verticalAxis", {
            get: function () {
                return this._verticalAxis;
            },
            set: function (a) {
                this._verticalAxis = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "sparkPath", {
            get: function () {
                return this._sparkPath;
            },
            set: function (a) {
                this._sparkPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "negativeSparkPath", {
            get: function () {
                return this._negativeSparkPath;
            },
            set: function (a) {
                this._negativeSparkPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "trendLinePath", {
            get: function () {
                return this._trendLinePath;
            },
            set: function (a) {
                this._trendLinePath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "rangePath", {
            get: function () {
                return this._rangePath;
            },
            set: function (a) {
                this._rangePath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "markersPath", {
            get: function () {
                return this._markersPath;
            },
            set: function (a) {
                this._markersPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "negativeMarkersPath", {
            get: function () {
                return this._negativeMarkersPath;
            },
            set: function (a) {
                this._negativeMarkersPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "lowMarkersPath", {
            get: function () {
                return this._lowMarkersPath;
            },
            set: function (a) {
                this._lowMarkersPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "highMarkersPath", {
            get: function () {
                return this._highMarkersPath;
            },
            set: function (a) {
                this._highMarkersPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "firstMarkerPath", {
            get: function () {
                return this._firstMarkerPath;
            },
            set: function (a) {
                this._firstMarkerPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "lastMarkerPath", {
            get: function () {
                return this._lastMarkerPath;
            },
            set: function (a) {
                this._lastMarkerPath = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "viewport", {
            get: function () {
                return this._viewport;
            },
            set: function (a) {
                this._viewport = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineVisualData.prototype, "marginViewport", {
            get: function () {
                return this._marginViewport;
            },
            set: function (a) {
                this._marginViewport = a;
            },
            enumerable: false,
            configurable: true
        });
        SparklineVisualData.prototype.scaleByViewport = function () {
            this.horizontalAxis.scaleByViewport(this.viewport);
            this.verticalAxis.scaleByViewport(this.viewport);
            if (this.sparkPath != null) {
                this.sparkPath.scaleByViewport(this.marginViewport);
            }
            if (this.negativeSparkPath != null) {
                this.negativeSparkPath.scaleByViewport(this.marginViewport);
            }
            if (this.trendLinePath != null) {
                this.trendLinePath.scaleByViewport(this.marginViewport);
            }
            if (this.rangePath != null) {
                this.rangePath.scaleByViewport(this.marginViewport);
            }
            if (this.markersPath != null) {
                this.markersPath.scaleByViewport(this.marginViewport);
            }
            if (this.negativeMarkersPath != null) {
                this.negativeMarkersPath.scaleByViewport(this.marginViewport);
            }
            if (this.lowMarkersPath != null) {
                this.lowMarkersPath.scaleByViewport(this.marginViewport);
            }
            if (this.highMarkersPath != null) {
                this.highMarkersPath.scaleByViewport(this.marginViewport);
            }
            if (this.firstMarkerPath != null) {
                this.firstMarkerPath.scaleByViewport(this.marginViewport);
            }
            if (this.lastMarkerPath != null) {
                this.lastMarkerPath.scaleByViewport(this.marginViewport);
            }
        };
        SparklineVisualData.prototype.serialize = function () {
            var a = new i2.StringBuilder(0);
            a.u("{");
            a.u("name: \"" + this.name + "\"");
            if (this.horizontalAxis != null) {
                a.u(",");
                a.l("horizontalAxis: " + this.horizontalAxis.serialize());
            }
            if (this.horizontalAxis != null) {
                a.u(",");
                a.l("verticalAxis: " + this.verticalAxis.serialize());
            }
            if (this.sparkPath != null) {
                a.u(",");
                a.l("sparkPath: " + this.sparkPath.serialize());
            }
            if (this.negativeSparkPath != null) {
                a.u(",");
                a.l("negativeSparkPath: " + this.negativeSparkPath.serialize());
            }
            if (this.trendLinePath != null) {
                a.u(",");
                a.l("trendLinePath: " + this.trendLinePath.serialize());
            }
            if (this.rangePath != null) {
                a.u(",");
                a.l("rangePath: " + this.rangePath.serialize());
            }
            if (this.markersPath != null) {
                a.u(",");
                a.l("markersPath: " + this.markersPath.serialize());
            }
            if (this.negativeMarkersPath != null) {
                a.u(",");
                a.l("negativeMarkersPath: " + this.negativeMarkersPath.serialize());
            }
            if (this.lowMarkersPath != null) {
                a.u(",");
                a.l("lowMarkersPath: " + this.lowMarkersPath.serialize());
            }
            if (this.highMarkersPath != null) {
                a.u(",");
                a.l("highMarkersPath: " + this.highMarkersPath.serialize());
            }
            if (this.firstMarkerPath != null) {
                a.u(",");
                a.l("firstMarkerPath: " + this.firstMarkerPath.serialize());
            }
            if (this.lastMarkerPath != null) {
                a.u(",");
                a.l("lastMarkerPath: " + this.lastMarkerPath.serialize());
            }
            if (this.viewport != null) {
                a.l(",");
                a.l("viewPort:" + this.viewport.serialize());
            }
            if (this.marginViewport != null) {
                a.l(",");
                a.l("marginViewPort:" + this.marginViewport.serialize());
            }
            a.u("");
            a.u("}");
            return a.toString();
        };
        SparklineVisualData.$t = i2.markType(SparklineVisualData, 'SparklineVisualData');
        return SparklineVisualData;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Represents the type of sparkline
     */
    var SparklineDisplayType = /*@__PURE__*/ (function (SparklineDisplayType) {
        /**
         * Display the sparkline as a line.
         */
        SparklineDisplayType[SparklineDisplayType["Line"] = 0] = "Line";
        /**
         * Display the sparkline as a filled polygon.
         */
        SparklineDisplayType[SparklineDisplayType["Area"] = 1] = "Area";
        /**
         * Display the sparkline as a set of columns.
         */
        SparklineDisplayType[SparklineDisplayType["Column"] = 2] = "Column";
        /**
         * Display the sparkline as a set of columns on a boolean scale.
         */
        SparklineDisplayType[SparklineDisplayType["WinLoss"] = 3] = "WinLoss";
        return SparklineDisplayType;
    })({});
    /**
     * @hidden
     */
    var SparklineDisplayType_$type = i2.markEnum('SparklineDisplayType', 'Line,0|Area,1|Column,2|WinLoss,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SparkFrame = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparkFrame, _super);
        function SparkFrame() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = new i2.List$1(i2.Array_$type, 0);
            _this.f = new i2.List$1(i2.Point_$type, 0);
            _this.d = new i2.List$1(i2.Point_$type, 0);
            _this.e = new i2.List$1(i2.Point_$type, 0);
            _this.c = new i2.List$1(i2.Point_$type, 0);
            _this.b = new i2.List$1(i2.Point_$type, 0);
            _this.m = null;
            _this.n = null;
            return _this;
        }
        Object.defineProperty(SparkFrame.prototype, "g", {
            get: function () {
                return this.a;
            },
            set: function (a) {
                this.a = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparkFrame.prototype, "l", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparkFrame.prototype, "j", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparkFrame.prototype, "k", {
            get: function () {
                return this.e;
            },
            set: function (a) {
                this.e = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparkFrame.prototype, "i", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparkFrame.prototype, "h", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        SparkFrame.$t = i2.markType(SparkFrame, 'SparkFrame');
        return SparkFrame;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ConfigurationMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(ConfigurationMessage_Spark, _super);
        function ConfigurationMessage_Spark() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ConfigurationMessage_Spark.$t = i2.markType(ConfigurationMessage_Spark, 'ConfigurationMessage_Spark', Message_Spark.$);
        return ConfigurationMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var PropertyChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(PropertyChangedMessage_Spark, _super);
        function PropertyChangedMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.f = null;
            _this.c = null;
            _this.b = null;
            return _this;
        }
        Object.defineProperty(PropertyChangedMessage_Spark.prototype, "propertyName", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PropertyChangedMessage_Spark.prototype, "oldValue", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PropertyChangedMessage_Spark.prototype, "newValue", {
            get: function () {
                return this.b;
            },
            set: function (a) {
                this.b = a;
            },
            enumerable: false,
            configurable: true
        });
        PropertyChangedMessage_Spark.prototype.toString = function () {
            var a = "null";
            var b = "null";
            if (this.oldValue != null) {
                a = this.oldValue.toString();
            }
            if (this.newValue != null) {
                b = this.newValue.toString();
            }
            return "PropertyChangedMessage[" + this.propertyName + ", " + a + ", " + b + "]";
        };
        PropertyChangedMessage_Spark.$t = i2.markType(PropertyChangedMessage_Spark, 'PropertyChangedMessage_Spark', ConfigurationMessage_Spark.$);
        return PropertyChangedMessage_Spark;
    }(ConfigurationMessage_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var DataChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(DataChangedMessage_Spark, _super);
        function DataChangedMessage_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.c = 0;
            _this.e = null;
            _this.d = null;
            _this.b = 0;
            return _this;
        }
        DataChangedMessage_Spark.$t = i2.markType(DataChangedMessage_Spark, 'DataChangedMessage_Spark', Message_Spark.$);
        return DataChangedMessage_Spark;
    }(Message_Spark));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var HorizontalAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(HorizontalAxisView, _super);
        function HorizontalAxisView(a) {
            var _this = _super.call(this) || this;
            _this.j = null;
            _this.w = null;
            _this.m = null;
            _this.l = null;
            _this.s = 0;
            _this.v = 0;
            _this.u = 0;
            _this.k = null;
            _this.r = -1;
            _this.ag = null;
            _this.af = null;
            _this.ah = null;
            _this.a = ["border-top-width", "border-top-color", "color"];
            _this.n = false;
            _this.q = 1;
            _this.g = null;
            _this.o = new i2.Dictionary$2(i2.Type.$, i2.Delegate_$type, 0);
            _this.d = null;
            _this.c = null;
            _this.p.item(AxisRenderMessage_Spark.$, function (b) { return _this.ac(i2.typeCast(AxisRenderMessage_Spark.$, b)); });
            _this.p.item(ContainerResizedMessage_Spark.$, function (b) { return _this.y(i2.typeCast(ContainerResizedMessage_Spark.$, b)); });
            _this.p.item(ViewportChangedMessage_Spark.$, function (b) { return _this.ae(i2.typeCast(ViewportChangedMessage_Spark.$, b)); });
            _this.p.item(PixelRatioMessage_Spark.$, function (b) { return _this.ab(i2.typeCast(PixelRatioMessage_Spark.$, b)); });
            _this.j = a;
            return _this;
        }
        HorizontalAxisView.prototype.b = function () {
            if (!this.n) {
                this.n = true;
                this.k.a("ui-sparkline-axis-x", this.a);
            }
            return this.a;
        };
        HorizontalAxisView.prototype.t = function () {
            var a = this.r;
            if (a >= 0) {
                return a;
            }
            var b = this.b()[0];
            if (b != null) {
                a = parseInt(b);
            }
            this.r = a = (a < 1) ? 1 : a;
            return a;
        };
        Object.defineProperty(HorizontalAxisView.prototype, "h", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                var b = this.g;
                this.g = a;
                this.k = a.getService("View");
                this.aa(b, this.g);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HorizontalAxisView.prototype, "p", {
            get: function () {
                return this.o;
            },
            set: function (a) {
                this.o = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HorizontalAxisView.prototype, "f", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(HorizontalAxisView.prototype, "e", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        HorizontalAxisView.prototype.z = function (a) {
            var _this = this;
            var b;
            if (((function () { var c = _this.p.tryGetValue(i2.getInstanceType(a), b); b = c.p1; return c.ret; })())) {
                b(a);
            }
        };
        HorizontalAxisView.prototype.aa = function (a, b) {
            if (a != null) {
                this.f.detachTarget(i2.runOn(this, this.z));
            }
            if (b != null) {
                this.f = b.getService("RenderingMessages");
                this.e = b.getService("InteractionMessages");
                this.f.attachTarget(i2.runOn(this, this.z));
            }
        };
        HorizontalAxisView.prototype.y = function (a) {
            this.w = a.j;
            this.m = a.b;
            this.l = this.k.o("ui-sparkline-axis-x");
            if (this.l == null) {
                this.l = i2.FontUtil.getFont(a.h);
            }
            if (this.m != null) {
                this.m.ac(this.l);
            }
            this.s = i2.FontUtil.getCurrentFontHeight(a.h, this.l);
            if (this.j != null && this.j.fm != 1) {
                a.d = a.d - this.s;
                a.e = this.t();
            }
        };
        HorizontalAxisView.prototype.ae = function (a) {
            this.v = this.w.width();
            this.u = this.s + this.t();
        };
        HorizontalAxisView.prototype.ac = function (a) {
            this.ad(a.c);
        };
        HorizontalAxisView.prototype.ad = function (a) {
            this.ah = null;
            var b = (!a || this.j == null) ? null : this.m;
            if (b == null || !b.d) {
                return;
            }
            b.k(0, 0, this.v, this.u);
            if (this.l != null) {
                b.ac(this.l);
            }
            if (this.q != 1) {
                b.z();
                b.aa(this.q, this.q);
            }
            var c = this.t(), d = c / 2;
            var e = this.j.av == null || this.j.av.count == 0;
            if (e) {
                this.u = 0;
            }
            var f = e ? null : this.x(this.j.av.item(0));
            var g = f == null ? "" : f.toString();
            this.ag = new i2.TextBlock();
            this.ag.ak = g;
            this.ag.n = 2;
            this.af = new i2.TextBlock();
            var h = e ? null : this.x(this.j.av.item(this.j.av.count - 1));
            this.af.ak = g = h == null ? "" : h.toString();
            this.af.o = this.ag.o = c;
            this.af.n = this.v - b.f(g) - 4;
            var i = this.j.fb;
            var j = i == null ? null : i._fill;
            var k = new i2.Color();
            var l = true;
            if (i != null) {
                l = false;
                k = i.color;
            }
            i = new i2.Brush();
            if (l) {
                i._fill = (this.a[2] == null) ? "#000000" : this.a[2];
            }
            else {
                i.color = k;
            }
            this.ag.am = this.af.am = i;
            b.w(this.ag);
            b.w(this.af);
            if (c < 0.5) {
                return;
            }
            i = new i2.Brush();
            if (j == null) {
                j = this.a[1];
            }
            i._fill = (j == null) ? "#000000" : j;
            this.ah = new i2.Line();
            this.ah.ak = 0;
            this.ah.al = this.w.width();
            this.ah.am = d;
            this.ah.an = d;
            this.ah._stroke = i;
            this.ah.ac = c;
            b.r(this.ah);
            if (this.q != 1) {
                b.y();
            }
        };
        HorizontalAxisView.prototype.x = function (dataItem_) {
            var a = null;
            if (this.j.ai != null) {
                a = this.j.ai.i(dataItem_);
            }
            if (this.j.ax()) {
                a = this.j.c1(dataItem_);
            }
            if (a != null) {
                return a;
            }
            var label_ = this.j.br;
            return (typeof dataItem_ != 'undefined') ? dataItem_ : '';
            ;
        };
        HorizontalAxisView.prototype.i = function () {
            var a = new SparklineAxisVisualData();
            if (this.ah != null) {
                a.axisLine = new i2.LineVisualData(1, "HorizontalAxisLine", this.ah);
                a.axisLine.appearance.isVisible = this.w.height() > 0;
            }
            var b = this.l;
            if (this.ag != null) {
                a.minLabel = i2.AppearanceHelper.c(this.ag, this.l);
            }
            if (this.af != null) {
                a.maxLabel = i2.AppearanceHelper.c(this.af, this.l);
            }
            return a;
        };
        HorizontalAxisView.prototype.ab = function (a) {
            this.q = a.b;
        };
        HorizontalAxisView.$t = i2.markType(HorizontalAxisView, 'HorizontalAxisView');
        return HorizontalAxisView;
    }(i2.Base));
    /**
     * @hidden
     */
    var VerticalAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(VerticalAxisView, _super);
        function VerticalAxisView(a) {
            var _this = _super.call(this) || this;
            _this.ad = null;
            _this.ac = null;
            _this.al = null;
            _this.ak = null;
            _this.am = null;
            _this.w = -1;
            _this.u = -1;
            _this.j = null;
            _this.aa = null;
            _this.m = null;
            _this.l = null;
            _this.t = 0;
            _this.v = 0;
            _this.z = 0;
            _this.y = 0;
            _this.k = null;
            _this.s = -1;
            _this.a = ["border-top-width", "border-top-color", "color", "text-align"];
            _this.n = false;
            _this.g = null;
            _this.p = new i2.Dictionary$2(i2.Type.$, i2.Delegate_$type, 0);
            _this.d = null;
            _this.c = null;
            _this.r = 1;
            _this.q.item(AxisRenderMessage_Spark.$, function (b) { return _this.ai(i2.typeCast(AxisRenderMessage_Spark.$, b)); });
            _this.q.item(ContainerResizedMessage_Spark.$, function (b) { return _this.ae(i2.typeCast(ContainerResizedMessage_Spark.$, b)); });
            _this.q.item(ViewportChangedMessage_Spark.$, function (b) { return _this.aj(i2.typeCast(ViewportChangedMessage_Spark.$, b)); });
            _this.q.item(PixelRatioMessage_Spark.$, function (b) { return _this.ah(i2.typeCast(PixelRatioMessage_Spark.$, b)); });
            _this.j = a;
            return _this;
        }
        VerticalAxisView.prototype.b = function () {
            if (!this.n) {
                this.n = true;
                this.k.a("ui-sparkline-axis-y", this.a);
            }
            return this.a;
        };
        VerticalAxisView.prototype.x = function () {
            var a = this.s;
            if (a >= 0) {
                return a;
            }
            var b = this.b()[0];
            if (b != null) {
                a = parseInt(b);
            }
            this.s = a = (a < 1) ? 1 : a;
            return a;
        };
        Object.defineProperty(VerticalAxisView.prototype, "h", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                var b = this.g;
                this.g = a;
                this.k = a.getService("View");
                this.ag(b, this.g);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(VerticalAxisView.prototype, "q", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                this.p = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(VerticalAxisView.prototype, "f", {
            get: function () {
                return this.d;
            },
            set: function (a) {
                this.d = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(VerticalAxisView.prototype, "e", {
            get: function () {
                return this.c;
            },
            set: function (a) {
                this.c = a;
            },
            enumerable: false,
            configurable: true
        });
        VerticalAxisView.prototype.af = function (a) {
            var _this = this;
            var b;
            if (((function () { var c = _this.q.tryGetValue(i2.getInstanceType(a), b); b = c.p1; return c.ret; })())) {
                b(a);
            }
        };
        VerticalAxisView.prototype.ag = function (a, b) {
            if (a != null) {
                this.f.detachTarget(i2.runOn(this, this.af));
            }
            if (b != null) {
                this.f = b.getService("RenderingMessages");
                this.e = b.getService("InteractionMessages");
                this.f.attachTarget(i2.runOn(this, this.af));
            }
        };
        VerticalAxisView.prototype.ae = function (a) {
            this.aa = a.k;
            this.m = a.c;
            this.l = this.k.o("ui-sparkline-axis-y");
            if (this.l == null) {
                this.l = i2.FontUtil.getFont(a.h);
            }
            if (this.m != null) {
                this.m.ac(this.l);
            }
            this.t = i2.FontUtil.getCurrentFontHeight(a.h, this.l);
            if (this.j != null && this.j.ft != 1) {
                this.o(false);
                a.g = a.g - this.v;
                a.f = this.x();
            }
        };
        VerticalAxisView.prototype.aj = function (a) {
            this.z = this.v + this.x();
            this.y = this.aa.height();
        };
        VerticalAxisView.prototype.ai = function (a) {
            if (this.o(a.c)) {
                var b = new ClearMessage_Spark();
                b.c = true;
                this.f.sendMessage(b);
            }
        };
        VerticalAxisView.prototype.o = function (a) {
            this.am = null;
            if (this.j == null || this.m == null || !this.m.d || (a && this.ak == null)) {
                return false;
            }
            var b = this.m;
            if (a) {
                b.k(0, 0, this.z, this.y);
            }
            var c = false;
            if (b != null && this.l != null) {
                b.ac(this.l);
            }
            if (!a) {
                this.al = new i2.TextBlock();
                this.ak = new i2.TextBlock();
                var d = this.ab(this.j.a4);
                this.al.ak = this.ad = d == null ? "" : d.toString();
                var e = this.ab(this.j.a3);
                this.ak.ak = this.ac = e == null ? "" : e.toString();
                if (b != null) {
                    this.w = b.f(this.ad) + 3;
                    if (this.w > this.v) {
                        c = true;
                        this.v = this.w;
                    }
                    this.u = b.f(this.ac) + 3;
                    if (this.u > this.v) {
                        c = true;
                        this.v = this.u;
                    }
                }
                if (!c) {
                    var f = Math.max(this.w, this.u);
                    if (f < this.v) {
                        this.v = f;
                        c = true;
                    }
                }
                if (c) {
                    this.z = this.v;
                }
            }
            else if (b != null) {
                if (this.r != 1) {
                    b.z();
                    b.aa(this.r, this.r);
                }
                var g = this.j.fj;
                var h = 1;
                var i = g == null ? null : g._fill;
                var j = this.b()[3];
                if (j == "left") {
                    h = 0;
                }
                else if (j == "center") {
                    h = 0.5;
                }
                this.ak.o = 2;
                this.ak.n = (this.v - this.u) * h + 1;
                this.al.n = (this.v - this.w) * h + 1;
                this.al.o = this.y - this.t - 2;
                var k = new i2.Color();
                var l = true;
                if (g != null) {
                    k = g.color;
                    l = false;
                }
                g = new i2.Brush();
                if (l) {
                    g._fill = (this.a[2] == null) ? "#000000" : this.a[2];
                }
                else {
                    g.color = k;
                }
                this.al.am = this.ak.am = g;
                b.w(this.al);
                b.w(this.ak);
                var m = this.x(), n = m / 2;
                if (m >= 0.5) {
                    g = new i2.Brush();
                    if (i == null) {
                        i = this.a[1];
                    }
                    g._fill = (i == null) ? "#000000" : i;
                    this.am = new i2.Line();
                    this.am.ak = this.z - n;
                    this.am.al = this.z - n;
                    this.am.am = 0;
                    this.am.an = this.y;
                    this.am._stroke = g;
                    this.am.ac = m;
                    b.r(this.am);
                }
                if (this.r != 1) {
                    b.y();
                }
            }
            return c;
        };
        VerticalAxisView.prototype.ab = function (dataItem_) {
            var a = null;
            if (this.j.aj != null) {
                a = this.j.aj.i(dataItem_);
            }
            if (this.j.ax()) {
                a = this.j.c1(dataItem_);
            }
            if (a != null) {
                return a;
            }
            var label_ = this.j.bt;
            return (typeof dataItem_ != 'undefined') ? dataItem_ : '';
            ;
        };
        VerticalAxisView.prototype.i = function () {
            var a = new SparklineAxisVisualData();
            if (this.am != null) {
                a.axisLine = new i2.LineVisualData(1, "VerticalAxisLine", this.am);
                a.axisLine.appearance.isVisible = this.aa.width() > 0;
            }
            if (this.al != null) {
                a.minLabel = i2.AppearanceHelper.c(this.al, this.l);
            }
            if (this.ak != null) {
                a.maxLabel = i2.AppearanceHelper.c(this.ak, this.l);
            }
            return a;
        };
        VerticalAxisView.prototype.ah = function (a) {
            this.r = a.b;
        };
        VerticalAxisView.$t = i2.markType(VerticalAxisView, 'VerticalAxisView');
        return VerticalAxisView;
    }(i2.Base));
    /**
     * @hidden
     */
    var XamSparklineView = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamSparklineView, _super);
        function XamSparklineView() {
            var _this = _super.call(this) || this;
            _this.bn = null;
            _this.bm = null;
            _this.ae = null;
            _this.af = null;
            _this.ag = null;
            _this.ah = null;
            _this.p = null;
            _this.q = null;
            _this.r = null;
            _this.n = null;
            _this.u = false;
            _this.b = new Array(6);
            _this.y = -1;
            _this.bw = new i2.Path();
            _this.bu = new i2.Path();
            _this.bx = new i2.Path();
            _this.bv = new i2.Path();
            _this.bs = new i2.Path();
            _this.bt = new i2.Path();
            _this.br = new i2.Path();
            _this.bp = new i2.Path();
            _this.bo = new i2.Path();
            _this.bq = new i2.Path();
            _this.j = null;
            _this.f = null;
            _this.g = null;
            _this.v = new i2.Dictionary$2(i2.Type.$, i2.Delegate_$type, 0);
            _this.l = null;
            _this.s = false;
            _this.ai = null;
            _this.e = null;
            _this.d = null;
            _this.c = null;
            _this.t = false;
            _this.x = 1;
            _this.bs._visibility = 1;
            _this.bt._visibility = 1;
            _this.br._visibility = 1;
            _this.bp._visibility = 1;
            _this.bo._visibility = 1;
            _this.bq._visibility = 1;
            _this.bv._visibility = 1;
            var a = _this.w;
            a.item(ClearMessage_Spark.$, function (b) { return _this.aj(i2.typeCast(ClearMessage_Spark.$, b)); });
            a.item(PolygonMessage_Spark.$, function (b) { return _this.bc(i2.typeCast(PolygonMessage_Spark.$, b)); });
            a.item(ColumnMessage_Spark.$, function (b) { return _this.a5(i2.typeCast(ColumnMessage_Spark.$, b)); });
            a.item(WinLossColumnMessage_Spark.$, function (b) { return _this.bj(i2.typeCast(WinLossColumnMessage_Spark.$, b)); });
            a.item(MarkerMessage_Spark.$, function (b) { return _this.a8(i2.typeCast(MarkerMessage_Spark.$, b)); });
            a.item(NormalRangeMessage_Spark.$, function (b) { return _this.bd(i2.typeCast(NormalRangeMessage_Spark.$, b)); });
            a.item(TrendLineMessage_Spark.$, function (b) { return _this.bg(i2.typeCast(TrendLineMessage_Spark.$, b)); });
            a.item(TooltipMessage_Spark.$, function (b) { return _this.be(i2.typeCast(TooltipMessage_Spark.$, b)); });
            a.item(ToooltipTemplateMessage_Spark.$, function (b) { return _this.bf(i2.typeCast(ToooltipTemplateMessage_Spark.$, b)); });
            a.item(ContainerMessage_Spark.$, function (b) { return _this.ak(i2.typeCast(ContainerMessage_Spark.$, b)); });
            a.item(PixelRatioMessage_Spark.$, function (b) { return _this.aw(i2.typeCast(PixelRatioMessage_Spark.$, b)); });
            a.item(BrushChangedMessage_Spark.$, function (b) { return _this.a3(i2.typeCast(BrushChangedMessage_Spark.$, b)); });
            a.item(ContainerResizedMessage_Spark.$, function (b) { return _this.at(); });
            a.item(VisibilityMessage_Spark.$, function (b) { return _this.bi(i2.typeCast(VisibilityMessage_Spark.$, b)); });
            a.item(NumberChangedMessage_Spark.$, function (b) { return _this.bb(i2.typeCast(NumberChangedMessage_Spark.$, b)); });
            a.item(ContainerSizeChangedMessage_Spark.$, function (b) { return _this.at(); });
            _this.d = new i2.CanvasRenderScheduler();
            _this.c = new i2.CanvasRenderScheduler();
            _this.d.l(_this);
            _this.c.l(_this);
            return _this;
        }
        XamSparklineView.prototype.aw = function (a) {
            this.x = a.b;
        };
        Object.defineProperty(XamSparklineView.prototype, "k", {
            get: function () {
                return this.j;
            },
            set: function (a) {
                var b = this.j;
                this.j = a;
                this.av(b, this.j);
                this.l = null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparklineView.prototype, "h", {
            get: function () {
                return this.f;
            },
            set: function (a) {
                this.f = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparklineView.prototype, "i", {
            get: function () {
                return this.g;
            },
            set: function (a) {
                this.g = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparklineView.prototype, "w", {
            get: function () {
                return this.v;
            },
            set: function (a) {
                this.v = a;
            },
            enumerable: false,
            configurable: true
        });
        XamSparklineView.prototype.av = function (a, b) {
            if (a != null) {
                this.i.detachTarget(i2.runOn(this, this.ar));
                this.h = null;
            }
            if (b != null) {
                this.i = b.getService("RenderingMessages");
                this.h = b.getService("InteractionMessages");
                this.i.attachTarget(i2.runOn(this, this.ar));
                this.a2(this.h);
            }
        };
        XamSparklineView.prototype.a2 = function (a) {
            this.h = a;
        };
        XamSparklineView.prototype.ar = function (a) {
            var _this = this;
            var b;
            if (((function () { var c = _this.w.tryGetValue(i2.getInstanceType(a), b); b = c.p1; return c.ret; })())) {
                b(a);
            }
        };
        Object.defineProperty(XamSparklineView.prototype, "m", {
            get: function () {
                if (this.l == null) {
                    this.l = this.k.getService("Controller");
                }
                return this.l;
            },
            enumerable: false,
            configurable: true
        });
        XamSparklineView.prototype.a1 = function (a, b, c) {
            var d = new MouseMoveMessage_Spark();
            d.position = a;
            this.h.sendMessage(d);
        };
        XamSparklineView.prototype.a0 = function (a) {
            var b = new MouseLeaveMessage_Spark();
            this.h.sendMessage(b);
        };
        XamSparklineView.prototype.a3 = function (a) {
            this.a4(a.b, a.c, null, -1, -1);
        };
        XamSparklineView.prototype.a4 = function (a, b, c, d, e) {
            var f = null;
            var g = true, h = true;
            switch (a) {
                case "sparkpath":
                case XamSparkline.$$p[0]:
                    f = this.bw;
                    break;
                case "negativesparkpath":
                case XamSparkline.$$p[29]:
                    f = this.bu;
                    break;
                case "markers":
                case XamSparkline.$$p[24]:
                    f = this.bs;
                    break;
                case "firstmarker":
                case XamSparkline.$$p[3]:
                    f = this.bo;
                    break;
                case "lastmarker":
                case XamSparkline.$$p[17]:
                    f = this.bq;
                    break;
                case "highmarker":
                case XamSparkline.$$p[7]:
                    f = this.bp;
                    break;
                case "lowmarker":
                case XamSparkline.$$p[21]:
                    f = this.br;
                    break;
                case "negativemarkers":
                case XamSparkline.$$p[30]:
                    f = this.bt;
                    break;
                case "trendline":
                case XamSparkline.$$p[38]:
                    f = this.bx;
                    h = false;
                    break;
                case "range":
                case XamSparkline.$$p[33]:
                    f = this.bv;
                    g = false;
                    break;
            }
            if (f == null) {
                return;
            }
            if (b == null && c != null) {
                b = new i2.Brush();
                b._fill = c;
            }
            if (b != null) {
                if (h && (c == null || f._fill == null)) {
                    f._fill = b;
                }
                if (g && (c == null || f._stroke == null)) {
                    f._stroke = b;
                }
            }
            if (d > 0 && d < 1) {
                f._opacity = d;
            }
            if (e > 0 && (c == null || f.ac <= 0)) {
                f.ac = e;
            }
            this.aq();
        };
        XamSparklineView.prototype.bi = function (a) {
            switch (a.b) {
                case XamSparkline.$$p[26]:
                    this.bs._visibility = a.c;
                    break;
                case XamSparkline.$$p[5]:
                    this.bo._visibility = a.c;
                    break;
                case XamSparkline.$$p[19]:
                    this.bq._visibility = a.c;
                    break;
                case XamSparkline.$$p[9]:
                    this.bp._visibility = a.c;
                    break;
                case XamSparkline.$$p[23]:
                    this.br._visibility = a.c;
                    break;
                case XamSparkline.$$p[32]:
                    this.bt._visibility = a.c;
                    break;
                case XamSparkline.$$p[36]:
                    this.bv._visibility = a.c;
                    break;
                case XamSparkline.$$p[37]:
                    this.u = a.c == 0;
                    break;
            }
            this.aq();
        };
        XamSparklineView.prototype.bb = function (a) {
            var b = a.b;
            if (b <= 0) {
                return;
            }
            switch (a.c) {
                case XamSparkline.$$p[20]:
                    this.bw.ac = this.bu.ac = b;
                    break;
                case XamSparkline.$$p[40]:
                    this.bx.ac = b;
                    break;
            }
            this.aq();
        };
        XamSparklineView.prototype.ak = function (a) {
            if (a.b == null) {
                if (this.n != null) {
                    this.n.ar();
                    var b = this.n;
                    b.onMouseLeave = i2.delegateRemove(b.onMouseLeave, i2.runOn(this, this.a0));
                    var c = this.n;
                    c.onMouseOver = i2.delegateRemove(c.onMouseOver, i2.runOn(this, this.a1));
                    this.n = null;
                }
                this.ae = null;
                this.af = null;
                this.ag = null;
                this.ah = null;
                this.p = this.q = this.r = null;
                this.d.j(null);
                return;
            }
            var d = a.b;
            this.d.j(d);
            this.ae = d;
            this.ae.rootWrapper.setStyleProperty("position", "relative");
            this.af = this.ae.createElement("canvas");
            this.af.setStyleProperty("position", "absolute");
            this.ag = this.ae.createElement("canvas");
            this.ag.setStyleProperty("position", "absolute");
            this.ah = this.ae.createElement("canvas");
            this.ah.setStyleProperty("position", "absolute");
            this.ae.append(this.af);
            this.ae.append(this.ag);
            this.ae.append(this.ah);
            this.p = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.af));
            this.q = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
            this.r = new i2.RenderingContext(new i2.CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ah));
            this.n = new i2.CanvasGestureDOMEventProxy(this.af, this.ae, false);
            var e = this.n;
            e.onMouseLeave = i2.delegateCombine(e.onMouseLeave, i2.runOn(this, this.a0));
            var f = this.n;
            f.onMouseOver = i2.delegateCombine(f.onMouseOver, i2.runOn(this, this.a1));
            this.n.am = function (g) { return false; };
            this.ao();
            this.at();
        };
        XamSparklineView.prototype.ao = function () {
            var a = ["sparkpath", "negativesparkpath", "trendline", "markers", "firstmarker", "lastmarker", "highmarker", "lowmarker", "negativemarkers", "range"];
            var b = ["#8bdc5c", "#ee5879", "#565656", "#8b5bb1", "#f8a15f", "#ee5879", "#6db1ff", "#f7d262", "#ee5879", "#66666666"];
            for (var c = 0; c < 10; c++) {
                var d = a[c];
                var e = ["background-color", "opacity", "border-top-width"];
                this.a("ui-sparkline-" + d, e);
                var f = XamSparklineView.ad(e[2], (c < 3) ? (c < 2 ? 2 : 1.5) : -1);
                if (c > 2 && c < 9) {
                    this.b[c - 3] = f;
                }
                this.a4(d, null, (e[0] == null) ? b[c] : e[0], XamSparklineView.ad(e[1], -1), c < 3 ? f : -1);
            }
        };
        XamSparklineView.ad = function (v_, a) {
            var d_ = (v_ == null || v_.length < 1) ? null : parseFloat(v_);
            return (d_ == null || d_.toString() == "NaN") ? a : d_;
        };
        XamSparklineView.prototype.a = function (a, b) {
            this.ae.startCSSQuery();
            for (var c = 0; c < b.length; c++) {
                b[c] = this.ae.getCssDefaultPropertyValue(a, b[c]);
            }
            this.ae.endCSSQuery();
            return b;
        };
        XamSparklineView.prototype.at = function () {
            if (this.ae == null || this.s) {
                return;
            }
            this.s = true;
            this.ap(this.m.q);
            var a = this.ae.rootWrapper.width(), b = this.ae.rootWrapper.height();
            var c, d, e;
            c = this.af;
            d = this.ag;
            e = this.ah;
            var f = new ContainerResizedMessage_Spark();
            f.g = a;
            f.d = b;
            f.b = this.q;
            f.h = this.ae;
            f.c = this.r;
            f.f = 0;
            f.e = 0;
            f.j = d;
            f.i = c;
            f.k = e;
            this.i.sendMessage(f);
            var g = f.e, h = f.f, i = f.g - h, j = f.d - g;
            var k = i, l = a - i, m = j, n = b - j;
            c.setStyleProperty("width", k.toString() + "px");
            c.setStyleProperty("height", m.toString() + "px");
            c.setAttribute("width", (k * this.x).toString());
            c.setAttribute("height", (m * this.x).toString());
            c.setStyleProperty("marginLeft", l + "px");
            k = (i + h);
            this.az(d, k, n, k * this.x, n * this.x);
            d.setStyleProperty("marginTop", m + "px");
            d.setStyleProperty("marginLeft", (a - i - h).toString() + "px");
            this.az(e, l, m, l * this.x, m * this.x);
            this.bn = new i2.Rect(0, 0, 0, i, j);
            if (this.n != null) {
                this.n.bg = this.bn;
            }
            this.bh();
            var o = new ViewportChangedMessage_Spark();
            o.newLeft = this.bn.left;
            o.newTop = this.bn.top;
            o.newHeight = this.bn.height;
            o.newWidth = this.bn.width;
            this.i.sendMessage(o);
            this.s = false;
        };
        XamSparklineView.prototype.al = function (a) {
            if (a) {
                this.y = -1;
            }
            else if (this.y < 0) {
                this.bh();
            }
        };
        XamSparklineView.prototype.bh = function () {
            var a = this.bn.left;
            var b = this.bn.width;
            var c = this.bn.height;
            var d = this.ab(true);
            var e = new i2.Rect(0, a + d, d, b - d * 2, c - d * 2);
            var f = new ViewportChangedMessage_Spark();
            f.newLeft = e.left;
            f.newTop = e.top;
            f.newHeight = e.height;
            f.newWidth = e.width;
            this.bm = e;
            this.h.sendMessage(f);
        };
        XamSparklineView.prototype.aj = function (a) {
            if (i2.Rect.l_op_Equality(this.bn, null)) {
                return;
            }
            switch (a.b) {
                case 2:
                    this.bs.ak = null;
                    this.bo.ak = null;
                    this.bq.ak = null;
                    this.bp.ak = null;
                    this.br.ak = null;
                    this.bt.ak = null;
                    break;
                case 8:
                    this.bv.ak = null;
                    break;
                case 1:
                    this.bw.ak = null;
                    this.bu.ak = null;
                    break;
                case 4:
                    this.am(null);
                    break;
                case 16:
                    this.bx.ak = null;
                    break;
            }
            if (a.c) {
                this.at();
            }
        };
        XamSparklineView.prototype.ab = function (a) {
            if (a) {
                this.y = -1;
            }
            var b = this.y;
            if (b >= 0) {
                return b;
            }
            b = 0;
            var c = this.m.q;
            if (c.fp == 0) {
                b = this.ac(b, c.bd, 0);
            }
            if (c.fk == 0) {
                b = this.ac(b, c.a6, 1);
            }
            if (c.fn == 0) {
                b = this.ac(b, c.a8, 2);
            }
            if (c.fl == 0) {
                b = this.ac(b, c.a7, 3);
            }
            if (c.fo == 0) {
                b = this.ac(b, c.bc, 4);
            }
            if (c.fq == 0) {
                b = this.ac(b, c.bi, 5);
            }
            this.y = b;
            return b;
        };
        XamSparklineView.prototype.ac = function (a, b, c) {
            if (b >= 0) {
                return b > a ? b : a;
            }
            return this.b[c] > a ? this.b[c] : a;
        };
        XamSparklineView.prototype.a8 = function (a) {
            this.a9(this.bs, a.e, a.k, 0);
            this.a9(this.bt, a.f, a.l, 5);
            this.a9(this.br, a.d, a.j, 4);
            this.a9(this.bp, a.c, a.h, 3);
            this.ba(this.bo, a.m, a.g, 1);
            this.ba(this.bq, a.n, a.i, 2);
            this.aq();
        };
        XamSparklineView.prototype.ba = function (a, b, c, d) {
            var e = ((function () {
                var $ret = new i2.List$1(i2.Point_$type, 0);
                $ret.add(b);
                return $ret;
            })());
            this.a9(a, e, c, d);
        };
        XamSparklineView.prototype.a9 = function (a, b, c, d) {
            if (c < 0) {
                c = this.b[d];
            }
            a.ak = this.bl(b, c < 0.1 ? i2.DeviceUtils.g(3) : c);
            if (this.m.q.aq != 3) {
                var e = new i2.TranslateTransform();
                e.j = this.m.o.d;
                a.j = e;
            }
            else {
                a.j = null;
            }
        };
        XamSparklineView.prototype.bl = function (a, b) {
            var e_1, _a;
            var c = new i2.GeometryGroup();
            c.c = 1;
            var d = this.bn.right;
            var e = this.bn.bottom;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if ((!f)) {
                        continue;
                    }
                    if (f.x < 0 || f.y < 0 || f.x > d || f.y > e) {
                        continue;
                    }
                    var g = new i2.EllipseGeometry();
                    g.c = b;
                    g.d = b;
                    g.e = f;
                    c.d.add(g);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return c;
        };
        XamSparklineView.prototype.bc = function (a) {
            var e_2, _a;
            var b = new i2.PathGeometry();
            var c = this.m.q.aq == 1;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a.points)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    var e = d.length;
                    if (e == 0) {
                        continue;
                    }
                    var f = new i2.PathFigure();
                    f._isClosed = f._isFilled = c;
                    f._startPoint = d[0];
                    for (var g = 1; g < e; g++) {
                        var h = new i2.LineSegment(1);
                        h.c = d[g];
                        f._segments.add(h);
                    }
                    b.c.add(f);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            this.bw.ak = b;
            this.aq();
        };
        XamSparklineView.prototype.bk = function (a, b) {
            var e_3, _a;
            var c = i2.typeCast(WinLossColumnMessage_Spark.$, b);
            var d = i2.typeCast(ColumnMessage_Spark.$, b);
            var e = new i2.GeometryGroup();
            var f = c != null ? c.i : d.i;
            var g = c != null ? c.h : d.h;
            var h = f * 0.1;
            try {
                for (var _b = tslib.__values(i2.fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var i = _c.value;
                    var j = f * 2 - h * 2;
                    var k = Math.abs(g - i.y);
                    var l = i.x + h;
                    var m = (i.y > g ? g : i.y);
                    var n = new i2.RectangleGeometry();
                    n.e = new i2.Rect(0, l, m, j, k);
                    e.d.add(n);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return e;
        };
        XamSparklineView.prototype.a5 = function (a) {
            this.a6(this.bw, a.d, a);
            this.a6(this.bu, a.g, a);
            this.aq();
        };
        XamSparklineView.prototype.a7 = function (a, b, c) {
            var d = ((function () {
                var $ret = new i2.List$1(i2.Point_$type, 0);
                $ret.add(b);
                return $ret;
            })());
            this.a6(a, d, c);
        };
        XamSparklineView.prototype.a6 = function (a, b, c) {
            a.ak = this.bk(b, c);
        };
        XamSparklineView.prototype.bj = function (a) {
            this.a6(this.bw, a.d, a);
            this.a6(this.bu, a.g, a);
            this.aq();
        };
        XamSparklineView.prototype.bd = function (a) {
            var b = new i2.RectangleGeometry();
            b.e = new i2.Rect(0, a.k, a.l, a.j, a.i);
            this.bv.ak = b;
            this.aq();
        };
        XamSparklineView.prototype.bg = function (a) {
            if (a.points.length == 0) {
                return;
            }
            var b = new i2.PathGeometry();
            var c = new i2.PathFigure();
            c._isClosed = c._isFilled = false;
            c._startPoint = a.points[0];
            var d = a.points.length;
            for (var e = 1; e < d; e++) {
                var f = new i2.LineSegment(1);
                f.c = a.points[e];
                c._segments.add(f);
            }
            b.c.add(c);
            this.bx.ak = b;
            this.aq();
        };
        XamSparklineView.prototype.bf = function (a) {
            this.ai = a.template;
        };
        XamSparklineView.prototype.be = function (a) {
            if (!this.u) {
                this.am(null);
                return;
            }
            var b = i2.truncate(Math.round(a.xOffset - 10));
            var c = i2.truncate(Math.round(a.yOffset - 10));
            b = i2.truncate(Math.round(b * this.x));
            c = i2.truncate(Math.round(c * this.x));
            var d = this.p.a(b, c);
            if (d[3] > 0) {
                this.am(a);
            }
            else {
                this.am(null);
            }
        };
        XamSparklineView.prototype.am = function (a) {
            var x_ = 0, y_ = 0;
            var v_ = null, t_ = null, i_ = this.ae;
            {
                if (a != null) {
                    t_ = this.ai;
                    x_ = a.xOffset + 6;
                    y_ = a.yOffset + 6;
                    var b = a.context;
                    var f_ = b.first, l_ = b.last, o_ = b.low, h_ = b.high;
                    v_ = { First: f_, Last: l_, Low: o_, High: h_ };
                }
                var ren_ = this.ae;
                if (this.e == null) {
                    this.e = new i2.DataContext();
                }
                var dc_ = this.e;
                dc_.item = v_;
                dc_.series = this;
                var tt_ = this.ai;
                if (tt_ != null) {
                    if (v_ != null) {
                        tt_.updateToolTip(dc_);
                        tt_.setRawPosition(x_, y_);
                    }
                    else {
                        tt_.hideToolTip();
                    }
                }
            }
        };
        Object.defineProperty(XamSparklineView.prototype, "isDirty", {
            get: function () {
                return this.t;
            },
            set: function (a) {
                this.t = a;
            },
            enumerable: false,
            configurable: true
        });
        XamSparklineView.prototype.aq = function () {
            if (!this.isDirty) {
                this.isDirty = true;
                this.d.o(this.p, null);
                this.c.o(this.q, this.r);
            }
        };
        XamSparklineView.prototype.undirty = function (a) {
            this.t = false;
            this.ax();
        };
        Object.defineProperty(XamSparklineView.prototype, "index", {
            get: function () {
                return 10;
            },
            enumerable: false,
            configurable: true
        });
        XamSparklineView.prototype.ay = function (a, b) {
            b.s(a);
        };
        XamSparklineView.prototype.ax = function () {
            var a = this.p;
            if (a != null && a.d) {
                if (this.x != 1) {
                    a.z();
                    a.aa(this.x, this.x);
                }
                a.k(this.bn.left, this.bn.top, this.bn.width, this.bn.height);
                a.s(this.bw);
                a.s(this.bu);
                this.ay(this.bs, a);
                this.ay(this.bt, a);
                this.ay(this.bp, a);
                this.ay(this.br, a);
                this.ay(this.bo, a);
                this.ay(this.bq, a);
                a.s(this.bv);
                a.s(this.bx);
                if (this.x != 1) {
                    a.y();
                }
            }
            var b = new AxisRenderMessage_Spark();
            b.c = true;
            this.i.sendMessage(b);
            this.postRender();
        };
        XamSparklineView.prototype.postRender = function () {
        };
        XamSparklineView.prototype.an = function (a) {
            a.viewport = new i2.RectData(this.bn.left, this.bn.top, this.bn.width, this.bn.height);
            a.marginViewport = new i2.RectData(this.bm.left, this.bm.top, this.bm.width, this.bm.height);
            a.sparkPath = new i2.PathVisualData(1, "SparkPath", this.bw);
            a.negativeSparkPath = new i2.PathVisualData(1, "NegativeSparkPath", this.bu);
            a.trendLinePath = new i2.PathVisualData(1, "TrendLinePath", this.bx);
            a.rangePath = new i2.PathVisualData(1, "RangePath", this.bv);
            a.markersPath = new i2.PathVisualData(1, "MarkersPath", this.bs);
            a.negativeMarkersPath = new i2.PathVisualData(1, "NegativeMarkersPath", this.bt);
            a.lowMarkersPath = new i2.PathVisualData(1, "LowMarkersPath", this.br);
            a.highMarkersPath = new i2.PathVisualData(1, "HighMarkersPath", this.bp);
            a.firstMarkerPath = new i2.PathVisualData(1, "FirstMarkerPath", this.bo);
            a.lastMarkerPath = new i2.PathVisualData(1, "LastMarkerPath", this.bq);
        };
        XamSparklineView.prototype.preRender = function () {
        };
        XamSparklineView.prototype.isValid = function () {
            return true;
        };
        XamSparklineView.prototype.o = function (a) {
            return i2.FontUtil.getFontForClass(this.ae, a);
        };
        XamSparklineView.prototype.az = function (a, b, c, d, e) {
            a.setStyleProperty("width", b + "px");
            a.setStyleProperty("height", c + "px");
            a.setAttribute("width", d.toString());
            a.setAttribute("height", e.toString());
        };
        XamSparklineView.prototype.ap = function (a) {
            var b = a.bl;
            var c = a.a5;
            if (!i2.isNaN_(b) && b != 0) {
                return;
            }
            if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
                a.a5 = window.devicePixelRatio;
            }
        };
        XamSparklineView.prototype.au = function () {
            if (this.n != null) {
                this.n.bc(this.af, "");
            }
        };
        XamSparklineView.prototype.as = function () {
            this.ap(this.l.q);
            if (this.n != null) {
                this.n.aq(this.af, "");
            }
        };
        XamSparklineView.$t = i2.markType(XamSparklineView, 'XamSparklineView', i2.Base.$, [i2.ISchedulableRender_$type]);
        return XamSparklineView;
    }(i2.Base));
    /**
     * @hidden
     */
    var SparkFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparkFramePreparer, _super);
        function SparkFramePreparer() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.b = null;
            _this.d = 0;
            _this.c = 0;
            return _this;
        }
        SparkFramePreparer.prototype.e = function (a) {
            var e_4, _a;
            var _this = this;
            this.b.r.al(false);
            a.g.clear();
            a.l.clear();
            a.j.clear();
            a.k.clear();
            a.i.clear();
            a.h.clear();
            var b = this.b.t;
            if (b == null) {
                return;
            }
            var c = b.count;
            var d = this.b.a3.top;
            var e = this.b.a3.left;
            var f = this.b.a3.width;
            var g = this.b.a3.height;
            var h = this.b.a3.bottom;
            var i = Math.floor((c + 1) / f);
            var j = i2.truncate(Math.max(1, i));
            var k = 0;
            var l = i2.truncate(Math.ceil(1 * c / j));
            var m = 0;
            var n = new i2.List$1(i2.Number_$type, 0);
            var o = this.b.q.ar;
            var p = this.b.q.aq;
            var q = this.b.q.bq;
            var r = o != 0 && q >= 1;
            var s = null;
            var t = null;
            if (p == 1 || p == 0) {
                this.d = 0;
            }
            else {
                if (l == 0) {
                    this.d = 0;
                }
                else {
                    this.d = f / l / 2;
                }
            }
            if (r) {
                var u = function (v) { return v + 1; };
                var v = function (w) { return b.item(w); };
                var w = function (x) { return _this.b.y(x); };
                var x = function (y) { return _this.b.z(y); };
                switch (this.b.q.ar) {
                    case 9:
                        s = i2.TrendCalculators.e(b, q);
                        break;
                    case 10:
                        s = i2.TrendCalculators.b(b, q);
                        break;
                    case 11:
                        s = i2.TrendCalculators.c(b, q);
                        break;
                    case 12:
                        s = i2.TrendCalculators.a(b);
                        break;
                    case 13:
                        s = i2.TrendCalculators.g(b, q);
                        break;
                    case 1:
                        t = i2.LeastSquaresFit.k(c, u, v);
                        break;
                    case 2:
                        t = i2.LeastSquaresFit.o(c, u, v);
                        break;
                    case 3:
                        t = i2.LeastSquaresFit.i(c, u, v);
                        break;
                    case 4:
                        t = i2.LeastSquaresFit.p(c, u, v);
                        break;
                    case 5:
                        t = i2.LeastSquaresFit.q(c, u, v);
                        break;
                    case 7:
                        t = i2.LeastSquaresFit.j(c, u, v);
                        break;
                    case 6:
                        t = i2.LeastSquaresFit.l(c, u, v);
                        break;
                    case 8:
                        t = i2.LeastSquaresFit.n(c, u, v);
                        break;
                }
                if (s != null) {
                    try {
                        for (var _b = tslib.__values(i2.fromEnum(s)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var y = _c.value;
                            n.add(y);
                        }
                    }
                    catch (e_4_1) {
                        e_4 = { error: e_4_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_4)
                                throw e_4.error;
                        }
                    }
                }
                if (t != null) {
                    var z = k * j;
                    var aa = l * j;
                    if (p == 1 || p == 0) {
                        aa = aa - 1;
                    }
                    var ab = 0 + this.d;
                    var ac = f - this.d;
                    var ad = 0;
                    if (this.d != 0) {
                        ad = 0.5;
                    }
                    for (var ae = ab; ae <= ac; ae += 2) {
                        var af = ae / (f - 1);
                        var ag = z + af * (aa - z);
                        var ah = NaN;
                        switch (o) {
                            case 1:
                                ah = i2.LeastSquaresFit.ad(t, ag - ad);
                                break;
                            case 2:
                                ah = i2.LeastSquaresFit.ah(t, ag - ad);
                                break;
                            case 3:
                                ah = i2.LeastSquaresFit.ab(t, ag - ad);
                                break;
                            case 4:
                                ah = i2.LeastSquaresFit.ai(t, ag - ad);
                                break;
                            case 5:
                                ah = i2.LeastSquaresFit.aj(t, ag - ad);
                                break;
                            case 7:
                                ah = i2.LeastSquaresFit.ac(t, ag - ad);
                                break;
                            case 6:
                                ah = i2.LeastSquaresFit.ae(t, ag - ad);
                                break;
                            case 8:
                                ah = i2.LeastSquaresFit.ag(t, ag - ad);
                                break;
                        }
                        ag = w(ag);
                        ah = x(ah);
                        if (!i2.isNaN_(ah) && !i2.isInfinity(ah)) {
                            a.l.add({ $type: i2.Point_$type, x: ag, y: ah });
                        }
                    }
                }
            }
            var ai = this.b.t.minimum;
            var aj = this.b.t.maximum;
            var ak = this.b.q.a4;
            var al = this.b.q.a3;
            this.c = h - (m - ak) / (al - ak) * g;
            if (this.c < 0) {
                this.c = 0;
            }
            else if (this.c > h) {
                this.c = h;
            }
            var am = this.c;
            var an;
            for (var ao = k; ao < l; ao++) {
                var ap = this.a(ao, j, c);
                var aq = ap[1];
                var ar = ap[2];
                this.f(ap, c, this.b.a3, ak, al);
                an = ap[1];
                if (ap[2] < am) {
                    an = ap[2];
                }
                a.g.add(ap);
                if (!i2.isNaN_(ap[0]) && !i2.isNaN_(ap[1])) {
                    a.j.add({ $type: i2.Point_$type, x: ap[0], y: an });
                }
                if (r && s != null) {
                    var as = ao * j;
                    var at = h - (((n._inner[as] - ai) / (aj - ai)) * g);
                    a.l.add({ $type: i2.Point_$type, x: ap[0] + this.d, y: at });
                }
                if (aq < m) {
                    a.k.add({ $type: i2.Point_$type, x: ap[0], y: ap[1] });
                }
                if (ai == aq) {
                    a.i.add({ $type: i2.Point_$type, x: ap[0], y: ap[1] });
                }
                if (aj == ar) {
                    a.h.add({ $type: i2.Point_$type, x: ap[0], y: ap[2] });
                }
            }
            if (a.j.count == 0) {
                a.m = a.n = { $type: i2.Point_$type, x: NaN, y: NaN };
            }
            else {
                a.m = a.j._inner[0];
                a.n = a.j._inner[a.j.count - 1];
            }
        };
        SparkFramePreparer.prototype.a = function (a, b, c) {
            var d = Math.min(a * b, c - 1);
            var e = Math.min(d + b - 1, c - 1);
            var f = true;
            var g = 0;
            var h = 0;
            for (var i = d; i <= e; ++i) {
                var j = this.b.t.item(i);
                if (f) {
                    f = false;
                    g = j;
                    h = j;
                }
                else {
                    g = Math.min(g, j);
                    h = Math.max(h, j);
                }
            }
            var k = [0, 0, 0];
            k[0] = (0.5 * (d + e));
            k[1] = g;
            k[2] = h;
            return k;
        };
        SparkFramePreparer.prototype.f = function (a, b, c, d, e) {
            var f = c.left;
            var g = c.top;
            var h = c.width;
            var i = c.height;
            if (this.b.q.aq == 1 || this.b.q.aq == 0) {
                b--;
            }
            if (b < 0) {
                b = 0;
            }
            var j = b > 0 ? a[0] / b : b == 0 ? 0.5 : NaN;
            a[0] = f + j * h;
            if (this.b.q.aq == 3) {
                if (a[1] > 0) {
                    a[1] = g;
                    a[2] = g;
                }
                else if (a[1] < 0) {
                    a[1] = g + i;
                    a[2] = g + i;
                }
                else {
                    a[1] = g + (1 - ((a[1] - d) / (e - d))) * i;
                    a[2] = g + (1 - ((a[2] - d) / (e - d))) * i;
                }
            }
            else {
                a[1] = g + (1 - ((a[1] - d) / (e - d))) * i;
                a[2] = g + (1 - ((a[2] - d) / (e - d))) * i;
            }
        };
        SparkFramePreparer.$t = i2.markType(SparkFramePreparer, 'SparkFramePreparer');
        return SparkFramePreparer;
    }(i2.Base));
    /**
     * @hidden
     */
    var SparklineConnector = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparklineConnector, _super);
        function SparklineConnector(a, b) {
            var _this = _super.call(this) || this;
            _this.d = null;
            _this.b = null;
            _this.e = null;
            _this.a = null;
            _this.c = null;
            _this.e = b;
            if (a == null) {
                return _this;
            }
            _this.d = i2.typeCast(XamSparkline.$, a);
            _this.a = _this.d.ak;
            _this.c = _this.d.at;
            b.ap(_this.d);
            var c = new ServiceProvider_Spark();
            c.addService("ConfigurationMessages", new MessageChannel_Spark());
            c.addService("RenderingMessages", new MessageChannel_Spark());
            c.addService("InteractionMessages", new MessageChannel_Spark());
            c.addService("Model", _this.d);
            c.addService("View", _this.e);
            c.addService("HorizontalAxis", _this.a);
            c.addService("VerticalAxis", _this.c);
            _this.d.ao = c;
            _this.e.k = c;
            _this.a.h = c;
            _this.c.h = c;
            _this.b = new SparklineController(c);
            c.addService("Controller", _this.b);
            return _this;
        }
        SparklineConnector.$t = i2.markType(SparklineConnector, 'SparklineConnector');
        return SparklineConnector;
    }(i2.Base));
    /**
     * @hidden
     */
    var SparklineController = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(SparklineController, _super);
        function SparklineController(a) {
            var _this = _super.call(this) || this;
            _this.k = null;
            _this.m = null;
            _this.l = null;
            _this.p = null;
            _this.r = null;
            _this.t = null;
            _this.s = null;
            _this.o = new SparkFramePreparer();
            _this.n = new SparkFrame();
            _this.a3 = i2.Rect.empty;
            _this.aa = null;
            _this.k = a.getService("ConfigurationMessages");
            _this.m = a.getService("RenderingMessages");
            _this.l = a.getService("InteractionMessages");
            _this.aa = function (b, c) { return _this.ah(c.action, c.position, c.count, c.propertyName); };
            _this.q = a.getService("Model");
            _this.r = a.getService("View");
            _this.k.attachTarget(i2.runOn(_this, _this.ag));
            _this.l.attachTarget(i2.runOn(_this, _this.aj));
            return _this;
        }
        Object.defineProperty(SparklineController.prototype, "q", {
            get: function () {
                return this.p;
            },
            set: function (a) {
                var b = this.p != a;
                if (b) {
                    this.p = a;
                    this.an(i2.runOn(this, this.aw));
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineController.prototype, "x", {
            get: function () {
                return this.q != null ? this.q.itemsSource : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineController.prototype, "u", {
            get: function () {
                return this.c(SparklineController.a2);
            },
            set: function (a) {
                this.h(SparklineController.a2, a);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineController.prototype, "ad", {
            get: function () {
                return this.q != null ? this.q.c9 : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineController.prototype, "ac", {
            get: function () {
                return this.q != null ? this.q.ce : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SparklineController.prototype, "ab", {
            get: function () {
                return this.q != null ? this.q.toolTip : null;
            },
            enumerable: false,
            configurable: true
        });
        SparklineController.prototype.y = function (a) {
            var b = this.t.count;
            if (this.q.aq == 1 || this.q.aq == 0) {
                b--;
            }
            if (b < 0) {
                b = 0;
            }
            var c = b > 0 ? a / b : b == 0 ? 0.5 : NaN;
            c = this.a3.left + (c) * this.a3.width;
            return c;
        };
        SparklineController.prototype.z = function (a) {
            var b = ((a - this.q.a4) / (this.q.a3 - this.q.a4));
            b = (1 - b);
            b = this.a3.top + (b) * this.a3.height;
            return b;
        };
        SparklineController.prototype.w = function () {
            return !this.a3.isEmpty && this.a3.width > 0 && this.a3.height > 0 && this.q != null && this.q.a4 != this.q.a3;
        };
        SparklineController.prototype.v = function (a) {
            if (a.oldValue != a.newValue) {
                return true;
            }
            return false;
        };
        SparklineController.prototype.av = function (a, b) {
            var _this = this;
            if (this.aa == null) {
                this.aa = function (c, d) { return _this.ah(d.action, d.position, d.count, d.propertyName); };
            }
            var c = i2.typeCast(i2.FastItemsSource.$, a);
            if (c != null) {
                c.event = i2.delegateRemove(c.event, this.aa);
            }
            var d = i2.typeCast(i2.FastItemsSource.$, b);
            if (d != null) {
                d.event = i2.delegateCombine(d.event, this.aa);
            }
        };
        SparklineController.prototype.ay = function () {
            if (this.q != null) {
                if (this.t == null) {
                    this.q.a4 = this.q.a3 = NaN;
                }
                else {
                    if (i2.isNaN_(this.q.bh)) {
                        this.q.a4 = this.t.minimum;
                    }
                    else {
                        this.q.a4 = this.q.bh;
                    }
                    if (i2.isNaN_(this.q.bg)) {
                        this.q.a3 = this.t.maximum;
                    }
                    else {
                        this.q.a3 = this.q.bg;
                    }
                    if (this.q.a4 == this.q.a3) {
                        if (!i2.isNaN_(this.q.bg) && i2.isNaN_(this.q.bh)) {
                            this.q.a4 = this.q.a3 - 1;
                        }
                        else if (i2.isNaN_(this.q.bg) && !i2.isNaN_(this.q.bh)) {
                            this.q.a3 = this.q.a4 + 1;
                        }
                        else {
                            if (Math.floor(this.q.a4) < this.q.a4) {
                                this.q.a4 = Math.floor(this.q.a4);
                            }
                            else {
                                this.q.a4 = Math.floor(this.q.a4) - 1;
                            }
                            if (Math.ceil(this.q.a3) > this.q.a3) {
                                this.q.a3 = Math.ceil(this.q.a3);
                            }
                            else {
                                this.q.a3 = Math.ceil(this.q.a3) + 1;
                            }
                        }
                    }
                }
            }
        };
        SparklineController.prototype.a0 = function () {
            if (this.u != null) {
                this.u.deregisterColumn(this.t);
                this.t = this.u.registerColumn(this.ad, null, false);
            }
            else {
                this.t = null;
            }
        };
        SparklineController.prototype.ax = function () {
            if (this.u != null) {
                this.u.deregisterColumn(this.s);
                this.s = this.u.registerColumnObject(this.ac, null, false);
                this.q.av = this.s;
            }
            else {
                this.q.av = this.s = null;
            }
        };
        SparklineController.prototype.au = function () {
            var a = new AxisRenderMessage_Spark();
            this.m.sendMessage(a);
        };
        SparklineController.prototype.an = function (a) {
            a();
        };
        SparklineController.prototype.aw = function () {
            this.u = this.getFastItemsSource(this.x);
            this.a0();
            this.ax();
            this.ay();
            this.au();
        };
        SparklineController.prototype.ah = function (a, b, c, d) {
            this.a0();
            this.ax();
            this.ay();
            this.au();
            this.an(i2.runOn(this, this.ao));
        };
        SparklineController.prototype.az = function () {
            var a = new ToooltipTemplateMessage_Spark();
            a.template = this.ab;
            this.m.sendMessage(a);
        };
        SparklineController.prototype.ag = function (a) {
            if (i2.typeCast(PropertyChangedMessage_Spark.$, a) !== null) {
                this.am(a);
            }
            else if (i2.typeCast(ContainerSizeChangedMessage_Spark.$, a) !== null) {
                this.m.sendMessage(a);
            }
            else if (i2.typeCast(DataChangedMessage_Spark.$, a) !== null) {
                this.ai(a);
            }
        };
        SparklineController.prototype.ai = function (a) {
            var b = this.u;
            if (b == null) {
                return;
            }
            switch (a.b) {
                case 2:
                    b.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(2, 2, a.d, a.e, a.c));
                    break;
                case 0:
                    b.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 0, a.d, a.c));
                    break;
                case 1:
                    b.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(1, 1, a.e, a.c));
                    break;
                case 4:
                    b.handleCollectionChanged(new i2.NotifyCollectionChangedEventArgs(0, 4));
                    break;
            }
            this.an(i2.runOn(this, this.aw));
        };
        SparklineController.prototype.aj = function (a) {
            var b = a;
            if (i2.typeCast(ViewportChangedMessage_Spark.$, b) !== null) {
                this.a1(b);
            }
            else if (i2.typeCast(MouseLeaveMessage_Spark.$, b) !== null) {
                this.ak(b);
            }
            else if (i2.typeCast(MouseMoveMessage_Spark.$, b) !== null) {
                this.al(b);
            }
            else if (i2.typeCast(ContainerSizeChangedMessage_Spark.$, b) !== null) {
                this.m.sendMessage(a);
            }
        };
        SparklineController.prototype.am = function (a) {
            switch (a.propertyName) {
                case XamSparkline.$$p[15]:
                    this.an(i2.runOn(this, this.aw));
                    break;
                case XamSparkline.$$p[43]:
                    this.an(i2.runOn(this, this.aw));
                    break;
                case XamSparkline.$$p[16]:
                    this.an(i2.runOn(this, this.aw));
                    break;
                case "ToolTip":
                    this.az();
                    break;
                case XamSparkline.$$p[28]:
                case XamSparkline.$$p[27]:
                    this.ay();
                    this.au();
                    break;
                case XamSparkline.$$p[11]:
                case XamSparkline.$$p[45]:
                    this.au();
                    break;
                case XamSparkline.$$p[0]:
                case XamSparkline.$$p[29]:
                case XamSparkline.$$p[24]:
                case XamSparkline.$$p[3]:
                case XamSparkline.$$p[17]:
                case XamSparkline.$$p[7]:
                case XamSparkline.$$p[21]:
                case XamSparkline.$$p[30]:
                case XamSparkline.$$p[38]:
                case XamSparkline.$$p[33]:
                    var b = new BrushChangedMessage_Spark();
                    b.c = i2.typeCast(i2.Brush.$, a.newValue);
                    b.b = a.propertyName;
                    this.m.sendMessage(b);
                    break;
                case XamSparkline.$$p[26]:
                case XamSparkline.$$p[5]:
                case XamSparkline.$$p[19]:
                case XamSparkline.$$p[9]:
                case XamSparkline.$$p[23]:
                case XamSparkline.$$p[32]:
                case XamSparkline.$$p[36]:
                case XamSparkline.$$p[37]:
                    var c = new VisibilityMessage_Spark();
                    c.c = i2.EnumUtil.getEnumValue(i2.Visibility_$type, a.newValue);
                    c.b = a.propertyName;
                    this.m.sendMessage(c);
                    this.r.al(true);
                    break;
                case XamSparkline.$$p[25]:
                case XamSparkline.$$p[4]:
                case XamSparkline.$$p[18]:
                case XamSparkline.$$p[8]:
                case XamSparkline.$$p[22]:
                case XamSparkline.$$p[31]:
                    this.r.al(true);
                    break;
                case XamSparkline.$$p[20]:
                case XamSparkline.$$p[40]:
                    var d = new NumberChangedMessage_Spark();
                    d.b = a.newValue;
                    d.c = a.propertyName;
                    this.m.sendMessage(d);
                    break;
                case XamSparkline.$$p[10]:
                case XamSparkline.$$p[44]:
                case XamSparkline.$$p[12]:
                case XamSparkline.$$p[46]:
                    this.at();
                    break;
                case "Container":
                    var e = new ContainerMessage_Spark();
                    e.b = a.newValue;
                    this.m.sendMessage(e);
                    break;
                case "ActualPixelScalingRatio":
                    {
                        var f = new PixelRatioMessage_Spark();
                        f.b = a.newValue;
                        this.m.sendMessage(f);
                    }
                    break;
                case XamSparkline.$$p[13]:
                case XamSparkline.$$p[14]:
                    if (this.q.ca != null) {
                        this.q.ai = new i2.BindingFormatter();
                        this.q.ai.j = this.q.ca;
                        this.q.ai.d = this.q.ag;
                    }
                    else {
                        this.q.ai = null;
                    }
                    this.au();
                    break;
                case XamSparkline.$$p[47]:
                case XamSparkline.$$p[48]:
                    if (this.q.df != null) {
                        this.q.aj = new i2.BindingFormatter();
                        this.q.aj.j = this.q.df;
                        this.q.aj.d = this.q.ah;
                    }
                    else {
                        this.q.aj = null;
                    }
                    this.au();
                    break;
            }
            if (this.v(a)) {
                this.an(i2.runOn(this, this.ao));
            }
        };
        SparklineController.prototype.at = function () {
            var a = new ClearMessage_Spark();
            a.c = true;
            this.m.sendMessage(a);
        };
        SparklineController.prototype.a1 = function (a) {
            this.a3 = new i2.Rect(0, a.newLeft, a.newTop, a.newWidth, a.newHeight);
            this.an(i2.runOn(this, this.ao));
        };
        SparklineController.prototype.al = function (a) {
            var b = new ClearMessage_Spark();
            b.b = 4;
            this.m.sendMessage(b);
            var c = new TooltipMessage_Spark();
            c.b = 4;
            c.xOffset = a.position.x + 10;
            c.yOffset = a.position.y + 10;
            if (this.t != null && this.t.count > 0) {
                var d = new SparklineToolTipContext();
                d.high = this.t.maximum;
                d.low = this.t.minimum;
                d.first = this.t.item(0);
                d.last = this.t.item(this.t.count - 1);
                c.context = d;
            }
            this.m.sendMessage(c);
        };
        SparklineController.prototype.ak = function (a) {
            var b = new ClearMessage_Spark();
            b.b = 4;
            this.m.sendMessage(b);
        };
        SparklineController.prototype.af = function (a) {
            var b = new ClearMessage_Spark();
            b.b = a;
            this.m.sendMessage(b);
        };
        SparklineController.prototype.ae = function () {
            this.af(1);
            this.af(2);
            this.af(16);
            this.af(8);
        };
        SparklineController.prototype.ao = function () {
            this.ae();
            if (!this.w()) {
                return;
            }
            this.o.b = this;
            this.o.e(this.n);
            switch (this.q.aq) {
                case 2:
                    this.ap();
                    break;
                case 3:
                    this.as();
                    break;
                case 0:
                case 1:
                    this.ar();
                    break;
            }
            var a = new NormalRangeMessage_Spark();
            a.k = this.a3.left;
            a.l = Math.max(this.a3.top, Math.min(this.a3.bottom, this.z(this.q.bj)));
            a.j = this.a3.width;
            var b = Math.max(this.a3.top, Math.min(this.a3.bottom, this.z(this.q.bk)));
            a.i = Math.abs(b - a.l);
            a.l = Math.min(a.l, b);
            a.d = this.q.aw;
            this.m.sendMessage(a);
            var c = new TrendLineMessage_Spark();
            c.points = this.n.l.toArray();
            this.m.sendMessage(c);
        };
        SparklineController.prototype.ap = function () {
            var a = new ColumnMessage_Spark();
            a.d = this.n.j;
            a.g = this.n.k;
            a.f = this.n.i;
            a.e = this.n.h;
            a.k = this.n.m;
            a.l = this.n.n;
            a.j = this.n.g.count;
            a.h = this.o.c;
            a.i = this.o.d;
            a.c = this.q.aq;
            this.m.sendMessage(a);
            this.aq();
        };
        SparklineController.prototype.as = function () {
            var a = new WinLossColumnMessage_Spark();
            a.d = this.n.j;
            a.g = this.n.k;
            a.f = this.n.i;
            a.e = this.n.h;
            a.k = this.n.m;
            a.l = this.n.n;
            a.j = this.n.g.count;
            a.h = this.o.c;
            a.i = this.o.d;
            a.c = this.q.aq;
            this.m.sendMessage(a);
        };
        SparklineController.prototype.ar = function () {
            var e_5, _a, e_6, _b, e_7, _c;
            if (this.n.g.count == 0) {
                return;
            }
            var a = new i2.List$1(i2.List$1.$.specialize(i2.Array_$type), 0);
            var b = new i2.List$1(i2.Array_$type, 0);
            var c = true;
            try {
                for (var _d = tslib.__values(i2.fromEnum(this.n.g)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var d = _e.value;
                    if (i2.isNaN_(d[1]) || i2.isInfinity(d[1])) {
                        if (!c) {
                            a.add(b);
                        }
                        c = true;
                        continue;
                    }
                    if (c) {
                        b = new i2.List$1(i2.Array_$type, 0);
                        c = false;
                    }
                    b.add(d);
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            if (!c) {
                a.add(b);
            }
            var e = new PolygonMessage_Spark();
            e.points = new i2.List$1(i2.Array_$type, 0);
            if (this.q.as == 0) {
                var f = new i2.List$1(i2.Array_$type, 0);
                try {
                    for (var _f = tslib.__values(i2.fromEnum(a)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var g = _g.value;
                        f.o(g);
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_g && !_g.done && (_b = _f.return))
                            _b.call(_f);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
                var h = this.j(f);
                e.points.add(h);
            }
            else {
                try {
                    for (var _h = tslib.__values(i2.fromEnum(a)), _j = _h.next(); !_j.done; _j = _h.next()) {
                        var i = _j.value;
                        var j = this.j(i);
                        e.points.add(j);
                    }
                }
                catch (e_7_1) {
                    e_7 = { error: e_7_1 };
                }
                finally {
                    try {
                        if (_j && !_j.done && (_c = _h.return))
                            _c.call(_h);
                    }
                    finally {
                        if (e_7)
                            throw e_7.error;
                    }
                }
            }
            this.m.sendMessage(e);
            this.aq();
        };
        SparklineController.prototype.j = function (a) {
            var e_8, _a, e_9, _b;
            var b = this.o.c;
            var c = new i2.List$1(i2.Point_$type, 0);
            var d;
            var e = this.q.aq == 1;
            try {
                for (var _c = tslib.__values(i2.fromEnum(a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var f = _d.value;
                    d = f[1];
                    if (e) {
                        if (f[2] <= b) {
                            d = f[2];
                        }
                    }
                    c.add({ $type: i2.Point_$type, x: f[0], y: d });
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
            if (this.q.aq == 0) {
                var g = new i2.List$1(i2.Point_$type, 0);
                try {
                    for (var _e = tslib.__values(i2.fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var h = _f.value;
                        g.add({ $type: i2.Point_$type, x: h[0], y: h[2] });
                    }
                }
                catch (e_9_1) {
                    e_9 = { error: e_9_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_9)
                            throw e_9.error;
                    }
                }
                g.w();
                c.o(g);
            }
            if (this.q.aq == 1 && c.count > 0) {
                var i = c._inner[0];
                var j = c._inner[c.count - 1];
                c.add({ $type: i2.Point_$type, x: j.x, y: this.o.c });
                c.add({ $type: i2.Point_$type, x: i.x, y: this.o.c });
            }
            return c.toArray();
        };
        SparklineController.prototype.aq = function () {
            var a = new MarkerMessage_Spark();
            a.e = this.n.j;
            a.f = this.n.k;
            a.d = this.n.i;
            a.c = this.n.h;
            a.m = this.n.m;
            a.n = this.n.n;
            a.k = this.q.bd;
            a.g = this.q.a6;
            a.i = this.q.a8;
            a.h = this.q.a7;
            a.j = this.q.bc;
            a.l = this.q.bi;
            this.m.sendMessage(a);
        };
        SparklineController.prototype.getFastItemsSource = function (a) {
            var b = null;
            if (this.x != null) {
                var c = null;
                b = new i2.FastItemsSource();
                b.e = this.x;
                c = new i2.FastItemsSourceReference(b);
                c.b++;
                b = c.a;
            }
            return b;
        };
        SparklineController.prototype.releaseFastItemsSource = function (a) {
            if (a != null) {
                var b = null;
                --b.b;
            }
            return null;
        };
        SparklineController.$t = i2.markType(SparklineController, 'SparklineController', i2.DependencyObject.$, [i2.IFastItemsSourceProvider_$type]);
        SparklineController.a2 = i2.DependencyProperty.i("FastItemsSource", i2.IFastItemsSource_$type, SparklineController.$, new i2.PropertyMetadata(1, function (a, b) { return (i2.typeCast(SparklineController.$, a)).av(b.oldValue, b.newValue); }));
        return SparklineController;
    }(i2.DependencyObject));
    /**
     * @hidden
     */
    var XamSparkline = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(XamSparkline, _super);
        function XamSparkline() {
            var _this = _super.call(this) || this;
            _this.ap = null;
            _this.ai = null;
            _this.aj = null;
            _this.an = null;
            _this.al = new MessageChannel_Spark();
            _this.a0 = NaN;
            _this.az = NaN;
            _this.av = null;
            _this.ak = null;
            _this.at = null;
            _this.a2 = NaN;
            _this.a1 = 1;
            _this.ab = XamSparkline.$;
            _this.at = new VerticalAxisView(_this);
            _this.ak = new HorizontalAxisView(_this);
            _this.ap = new SparklineConnector(_this, new XamSparklineView());
            return _this;
        }
        Object.defineProperty(XamSparkline.prototype, "toolTip", {
            get: function () {
                return this.c(XamSparkline.ev);
            },
            set: function (a) {
                this.h(XamSparkline.ev, a);
                this.fs = a == null || a.toString().length == 0 ? 1 : 0;
            },
            enumerable: false,
            configurable: true
        });
        XamSparkline.prototype.ax = function () {
            return this.bp != null;
        };
        XamSparkline.prototype.c1 = function (a) {
            return this.bp(a);
        };
        Object.defineProperty(XamSparkline.prototype, "ao", {
            get: function () {
                return this.an;
            },
            set: function (a) {
                var b = this.an;
                this.an = a;
                this.ds(b, this.an);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparkline.prototype, "am", {
            get: function () {
                return this.al;
            },
            set: function (a) {
                this.al = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparkline.prototype, "a4", {
            get: function () {
                return this.a0;
            },
            set: function (a) {
                this.a0 = a;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparkline.prototype, "a3", {
            get: function () {
                return this.az;
            },
            set: function (a) {
                this.az = a;
            },
            enumerable: false,
            configurable: true
        });
        XamSparkline.prototype.ds = function (a, b) {
            if (a != null) {
                this.am.detachFromNext();
            }
            if (b != null) {
                this.am.connectTo(b.getService("ConfigurationMessages"));
            }
        };
        XamSparkline.prototype.onDetachedFromUI = function () {
            this.ap.e.au();
        };
        XamSparkline.prototype.onAttachedToUI = function () {
            this.ap.e.as();
        };
        XamSparkline.prototype.dr = function (a, b, c) {
            if (a == "PixelScalingRatio") {
                if (!i2.isNaN_(i2.DeviceUtils.a(this.bl))) {
                    this.a5 = i2.DeviceUtils.a(this.bl);
                }
            }
            this.am.sendMessage(((function () {
                var $ret = new PropertyChangedMessage_Spark();
                $ret.propertyName = a;
                $ret.oldValue = b;
                $ret.newValue = c;
                return $ret;
            })()));
        };
        XamSparkline.prototype.destroy = function () {
            this.am.sendMessage(((function () {
                var $ret = new PropertyChangedMessage_Spark();
                $ret.propertyName = "Container";
                $ret.newValue = null;
                return $ret;
            })()));
        };
        XamSparkline.prototype.provideContainer = function (a) {
            this.am.sendMessage(((function () {
                var $ret = new PropertyChangedMessage_Spark();
                $ret.propertyName = "Container";
                $ret.newValue = a;
                return $ret;
            })()));
        };
        XamSparkline.prototype.notifyResized = function () {
            this.am.sendMessage(new ContainerSizeChangedMessage_Spark());
        };
        XamSparkline.prototype.dn = function (source_, a, b, c) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (source_ != this.itemsSource) {
                return;
            }
            this.am.sendMessage(((function () {
                var $ret = new DataChangedMessage_Spark();
                $ret.b = 2;
                $ret.e = b;
                $ret.d = c;
                $ret.c = a;
                return $ret;
            })()));
        };
        XamSparkline.prototype.dj = function (source_) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (source_ != this.itemsSource) {
                return;
            }
            this.am.sendMessage(((function () {
                var $ret = new DataChangedMessage_Spark();
                $ret.b = 4;
                return $ret;
            })()));
        };
        XamSparkline.prototype.dk = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (source_ != this.itemsSource) {
                return;
            }
            this.am.sendMessage(((function () {
                var $ret = new DataChangedMessage_Spark();
                $ret.b = 0;
                $ret.d = b;
                $ret.c = a;
                return $ret;
            })()));
        };
        XamSparkline.prototype.dl = function (source_, a, b) {
            if (source_.dataView && source_.dataSource) {
                source_ = source_.dataView();
            }
            ;
            if (source_ != this.itemsSource) {
                return;
            }
            this.am.sendMessage(((function () {
                var $ret = new DataChangedMessage_Spark();
                $ret.b = 1;
                $ret.e = b;
                $ret.c = a;
                return $ret;
            })()));
        };
        XamSparkline.prototype.au = function () {
            var a = new SparklineVisualData();
            a.name = "SparklineVisualData";
            a.horizontalAxis = this.ak.i();
            a.verticalAxis = this.at.i();
            this.ap.e.an(a);
            return a;
        };
        XamSparkline.prototype.by = function () {
            var a = this.au();
            a.scaleByViewport();
            return a.serialize();
        };
        Object.defineProperty(XamSparkline.prototype, "bl", {
            get: function () {
                return this.a2;
            },
            set: function (a) {
                var b = this.a2;
                this.a2 = a;
                this.dr("PixelScalingRatio", b, this.a2);
                if (this.a2 != b) {
                    this.dr("PixelScalingRatio", b, this.a2);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(XamSparkline.prototype, "a5", {
            get: function () {
                return this.a1;
            },
            set: function (a) {
                var b = this.a1;
                this.a1 = a;
                if (this.a1 != b) {
                    this.dr("ActualPixelScalingRatio", b, this.a1);
                }
            },
            enumerable: false,
            configurable: true
        });
        XamSparkline.$t = i2.markType(XamSparkline, 'XamSparkline', i2.Control.$);
        XamSparkline.bf = -1;
        XamSparkline.bb = -1;
        XamSparkline.ev = i2.DependencyProperty.i("ToolTip", i2.Base.$, XamSparkline.$, new i2.PropertyMetadata(2, null, function (a, b) { return (i2.typeCast(XamSparkline.$, a)).dr("ToolTip", b.oldValue, b.newValue); }));
        XamSparkline.bo = -1;
        XamSparkline.$$p = i2.markDep(i2.DependencyProperty, i2.PropertyMetadata, XamSparkline, 'dr', ['Brush:e8:du', [i2.Brush.$, null], 'DisplayNormalRangeInFront:aw:dv', [0, true], 'DisplayType:aq:dw', [SparklineDisplayType_$type, i2.enumGetBox(SparklineDisplayType_$type, 0)], 'FirstMarkerBrush:e9:dx', [i2.Brush.$, null], 'FirstMarkerSize:a6:dy', [1, XamSparkline.bf], 'FirstMarkerVisibility:fk:dz', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'FormatLabel:bp:d0', [i2.Delegate_$type], 'HighMarkerBrush:fa:d1', [i2.Brush.$, null], 'HighMarkerSize:a7:d2', [1, XamSparkline.bf], 'HighMarkerVisibility:fl:d3', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'HorizontalAxisBrush:fb:d4', [i2.Brush.$, null], 'HorizontalAxisLabel:br:d5', [4, "{0}"], 'HorizontalAxisVisibility:fm:d6', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'HorizontalLabelFormat:ca:d7', [2, null], 'HorizontalLabelFormatSpecifiers:ag:d8', [i2.Array_$type, null], 'ItemsSource::d9', [i2.IEnumerable_$type, null], 'LabelMemberPath:ce:ea', [2, null], 'LastMarkerBrush:fc:eb', [i2.Brush.$, null], 'LastMarkerSize:a8:ec', [1, XamSparkline.bf], 'LastMarkerVisibility:fn:ed', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'LineThickness:a9:ee', [1, XamSparkline.bb], 'LowMarkerBrush:fd:ef', [i2.Brush.$, null], 'LowMarkerSize:bc:eg', [1, XamSparkline.bf], 'LowMarkerVisibility:fo:eh', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'MarkerBrush:fe:ei', [i2.Brush.$, null], 'MarkerSize:bd:ej', [1, XamSparkline.bf], 'MarkerVisibility:fp:ek', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'Maximum:bg:el', [1, NaN], 'Minimum:bh:em', [1, NaN], 'NegativeBrush:ff:en', [i2.Brush.$, null], 'NegativeMarkerBrush:fg:eo', [i2.Brush.$, null], 'NegativeMarkerSize:bi:ep', [1, XamSparkline.bf], 'NegativeMarkerVisibility:fq:eq', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'NormalRangeFill:fh:er', [i2.Brush.$, null], 'NormalRangeMaximum:bj:es', [1, 0], 'NormalRangeMinimum:bk:et', [1, 0], 'NormalRangeVisibility:fr:eu', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'ToolTipVisibility:fs:ew', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'TrendLineBrush:fi:ex', [i2.Brush.$, null], 'TrendLinePeriod:bq:ey', [1, 7], 'TrendLineThickness:bm:ez', [1, XamSparkline.bo], 'TrendLineType:ar:e0', [i2.TrendLineType_$type, i2.enumGetBox(i2.TrendLineType_$type, 0)], 'UnknownValuePlotting:as:e1', [i2.UnknownValuePlotting_$type, i2.enumGetBox(i2.UnknownValuePlotting_$type, 1)], 'ValueMemberPath:c9:e2', [2, null], 'VerticalAxisBrush:fj:e3', [i2.Brush.$, null], 'VerticalAxisLabel:bt:e4', [4, "{0:n}"], 'VerticalAxisVisibility:ft:e5', [i2.Visibility_$type, i2.enumGetBox(i2.Visibility_$type, 1)], 'VerticalLabelFormat:df:e6', [2, null], 'VerticalLabelFormatSpecifiers:ah:e7', [i2.Array_$type, null]]);
        return XamSparkline;
    }(i2.Control));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    var defaultFont$1 = "Verdana, \"Segoe UI\", Arial, \"Myriad Pro\", sans-serif";
    var SparklineStylingDefaults = {
        //"ui-lineargauge-backing": {
        //    "background-color": "#ffffff",
        //    "border-color": "#ffffff"
        //},
        "ui-sparkline-axis": {
            "border-color": "#989ea3",
            "background-color": "#989ea3",
            "font-family": defaultFont$1,
            "font-style": "normal",
            "font-weight": "normal",
            "font-size": "13px",
            "color": "#666666",
            "font-variant": "",
            "line-height": ""
        },
        "ui-sparkline-axis-x": {
            "border-color": "#989ea3",
            "background-color": "#989ea3",
            "font-family": defaultFont$1,
            "font-style": "normal",
            "font-weight": "normal",
            "font-size": "13px",
            "color": "#666666",
            "font-variant": "",
            "line-height": ""
        },
        "ui-sparkline-axis-y": {
            "border-color": "#989ea3",
            "background-color": "#989ea3",
            "font-family": defaultFont$1,
            "font-style": "normal",
            "font-weight": "normal",
            "font-size": "13px",
            "color": "#666666",
            "font-variant": "",
            "line-height": ""
        },
        //.ui-chart-tooltip
        //{
        //    -moz-box-shadow: 0 0 2px rgba(0,0,0,0.6);
        //    -webkit-box-shadow: 0 0 2px rgba(0,0,0,0.6);
        //    box-shadow: 0 0 2px rgba(0,0,0,0.6);
        //    padding: 5px 8px;
        //    font-size: 12px;
        //    font-family:"Segoe UI", Arial, sans-serif;
        //}
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    };

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * Represents a sparkline chart.
    */
    var IgxSparklineComponent = /** @class */ /*@__PURE__*/ (function () {
        function IgxSparklineComponent(_renderer, _elRef, _ngZone, _componentFactoryResolver, _injector) {
            //super();
            var _this = this;
            this._renderer = _renderer;
            this._elRef = _elRef;
            this._ngZone = _ngZone;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._injector = _injector;
            this._dataSource = null;
            this._root = null;
            this._zoneRunner = null;
            this._tooltipTemplate = null;
            this._tooltipContent = null;
            this._defaultTooltips = null;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            if (this._styling) {
                i2.NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._zoneRunner = function (act) { return _this._ngZone.run(act); };
            this._implementation = this.createImplementation();
            this._container = _renderer.createElement("div");
            _renderer.appendChild(_elRef.element.nativeElement, this._container);
            _renderer.setStyle(this._container, "display", "block");
            _renderer.setStyle(this._container, "width", "100%");
            _renderer.setStyle(this._container, "height", "100%");
            var root;
            root = this._container;
            if (this._container.nativeElement != null) {
                root = this._container.nativeElement;
            }
            this._root = root;
            var ren = new i2.AngularRenderer(root, this._renderer, window.document, this._ngZone, true, SparklineStylingDefaults);
            this._wrapper = ren;
            var sparkline = this.i;
            this._sparkline = sparkline;
            sparkline.provideContainer(ren);
            ren.addSizeWatcher(function () {
                _this._sparkline.notifyResized();
            });
        }
        Object.defineProperty(IgxSparklineComponent.prototype, "height", {
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this._renderer.setStyle(this._elRef.element.nativeElement, "height", value);
                this._sparkline.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "width", {
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this._renderer.setStyle(this._elRef.element.nativeElement, "width", value);
                this._sparkline.notifyResized();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "dataSource", {
            get: function () {
                if (this._dataSource != null) {
                    return this._dataSource;
                }
                return this.i.itemsSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.i.itemsSource = this._dataSource;
                //console.log("setting axis data source: " + value)
            },
            enumerable: false,
            configurable: true
        });
        IgxSparklineComponent.prototype.ngOnDestroy = function () {
            this._sparkline.destroy();
            this._wrapper.destroy();
        };
        IgxSparklineComponent.prototype.createImplementation = function () {
            return new XamSparkline();
        };
        IgxSparklineComponent.prototype.ngAfterContentInit = function () {
            this._styling(this._root, this);
            this.i.notifyResized();
        };
        IgxSparklineComponent.prototype._runInZone = function (act) {
            if (this._zoneRunner != null) {
                this._zoneRunner(act);
            }
            else {
                act();
            }
        };
        Object.defineProperty(IgxSparklineComponent.prototype, "tooltipTemplate", {
            get: function () {
                return this._tooltipTemplate;
            },
            set: function (value) {
                this._tooltipTemplate = value;
                if (value == null) {
                    if (this._tooltipContent !== null) {
                        this._tooltipContent.destroy();
                        this._tooltipContent = null;
                    }
                }
                if (this._tooltipContent != null) {
                    this._tooltipContent.instance.template = this._tooltipTemplate;
                }
                else {
                    this._ensureTooltipCreated();
                }
            },
            enumerable: false,
            configurable: true
        });
        IgxSparklineComponent.prototype._ensureTooltipCreated = function () {
            if (this.i.toolTip == null) {
                var tooltip = this.createTooltip();
                if (tooltip == null) {
                    return;
                }
                this._tooltipContent = tooltip;
                tooltip.instance.template = this._tooltipTemplate;
                this.i.toolTip = this.createWrapper(tooltip.location.nativeElement);
            }
        };
        IgxSparklineComponent.prototype.createWrapper = function (ele) {
            var wrapper = new i2.AngularWrapper(ele, this._renderer, this._ngZone);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            return wrapper;
        };
        IgxSparklineComponent.prototype._ensureDefaultTooltip = function () {
            if (this._defaultTooltips == null) {
                return;
            }
            this._defaultTooltips.instance["ensureDefaultTooltip"](this);
        };
        IgxSparklineComponent.prototype._onDefaultTooltipsReady = function (cr) {
            this._ensureDefaultTooltip();
        };
        IgxSparklineComponent.prototype.createTooltip = function () {
            if (!i2.TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
                return null;
            }
            var t = i2.TypeRegistrar.get("IgxTooltipContainerComponent");
            var cf = this._componentFactoryResolver.resolveComponentFactory(t);
            var cr = this._dynamicContent.createComponent(cf);
            var ele = cr.location.nativeElement;
            var self = this;
            ele.updateToolTip = function (c) {
                if (c.externalObject) {
                    c = c.externalObject;
                }
                else {
                    var ext = new i2.IgxDataContext();
                    ext._implementation = c;
                    c = ext;
                }
                if (ele.parentElement != self._container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.appendChild(ele);
                }
                cr.instance.context = c;
                ele.style.display = "block";
                return true;
            };
            ele.hideToolTip = function () {
                ele.style.display = "none";
            };
            ele.style.display = "none";
            return cr;
        };
        Object.defineProperty(IgxSparklineComponent.prototype, "i", {
            /**
             * @hidden
             */
            get: function () {
                return this._implementation;
            } /**
                                         * @hidden
                                         */,
            enumerable: false,
            configurable: true
        });
        IgxSparklineComponent._createFromInternal = function (internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            var name = internal.$type.name;
            var externalName = "Igx" + name + "Component";
            if (!i2.TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return i2.TypeRegistrar.create(externalName);
        };
        Object.defineProperty(IgxSparklineComponent.prototype, "brush", {
            /**
         * Gets or sets the sparkline brush.
        */
            get: function () {
                return i2.brushToString(this.i.e8);
            },
            set: function (v) {
                this.i.e8 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "negativeBrush", {
            /**
             * Gets or sets the negative brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.ff);
            },
            set: function (v) {
                this.i.ff = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "markerBrush", {
            /**
             * Gets or sets the marker brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fe);
            },
            set: function (v) {
                this.i.fe = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "negativeMarkerBrush", {
            /**
             * Gets or sets the negative marker brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fg);
            },
            set: function (v) {
                this.i.fg = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "firstMarkerBrush", {
            /**
             * Gets or sets the first marker brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.e9);
            },
            set: function (v) {
                this.i.e9 = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lastMarkerBrush", {
            /**
             * Gets or sets the last marker brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fc);
            },
            set: function (v) {
                this.i.fc = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "highMarkerBrush", {
            /**
             * Gets or sets the high marker brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fa);
            },
            set: function (v) {
                this.i.fa = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lowMarkerBrush", {
            /**
             * Gets or sets the low marker brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fd);
            },
            set: function (v) {
                this.i.fd = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "trendLineBrush", {
            /**
             * Gets or sets the trendline brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fi);
            },
            set: function (v) {
                this.i.fi = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "horizontalAxisBrush", {
            /**
             * Gets or sets the horizontal axis line brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fb);
            },
            set: function (v) {
                this.i.fb = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "verticalAxisBrush", {
            /**
             * Gets or sets the vertical axis line brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fj);
            },
            set: function (v) {
                this.i.fj = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "normalRangeFill", {
            /**
             * Gets or sets the normal range brush of the sparkline.
            */
            get: function () {
                return i2.brushToString(this.i.fh);
            },
            set: function (v) {
                this.i.fh = i2.stringToBrush(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "horizontalAxisVisibility", {
            /**
             * Gets or sets the display state of the horizontal axis.
            */
            get: function () {
                return this.i.fm;
            },
            set: function (v) {
                this.i.fm = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "verticalAxisVisibility", {
            /**
             * Gets or sets the display state of the vertical axis.
            */
            get: function () {
                return this.i.ft;
            },
            set: function (v) {
                this.i.ft = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "markerVisibility", {
            /**
             * Gets or sets the marker visibility of the sparkline.
            */
            get: function () {
                return this.i.fp;
            },
            set: function (v) {
                this.i.fp = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "negativeMarkerVisibility", {
            /**
             * Gets or sets the negative marker visibility of the sparkline.
            */
            get: function () {
                return this.i.fq;
            },
            set: function (v) {
                this.i.fq = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "firstMarkerVisibility", {
            /**
             * Gets or sets the first marker visibility of the sparkline.
            */
            get: function () {
                return this.i.fk;
            },
            set: function (v) {
                this.i.fk = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lastMarkerVisibility", {
            /**
             * Gets or sets the last marker visibility of the sparkline.
            */
            get: function () {
                return this.i.fn;
            },
            set: function (v) {
                this.i.fn = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lowMarkerVisibility", {
            /**
             * Gets or sets the low marker visibility of the sparkline.
            */
            get: function () {
                return this.i.fo;
            },
            set: function (v) {
                this.i.fo = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "highMarkerVisibility", {
            /**
             * Gets or sets the high marker visibility of the sparkline.
            */
            get: function () {
                return this.i.fl;
            },
            set: function (v) {
                this.i.fl = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "normalRangeVisibility", {
            /**
             * Gets or sets the normal range visibility of the sparkline.
            */
            get: function () {
                return this.i.fr;
            },
            set: function (v) {
                this.i.fr = i2.ensureEnum(i2.Visibility_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "displayNormalRangeInFront", {
            /**
             * Gets or sets the position of the normal range on the sparkline.
            */
            get: function () {
                return this.i.aw;
            },
            set: function (v) {
                this.i.aw = i2.ensureBool(v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "markerSize", {
            /**
             * Gets or sets the marker size of the sparkline.
            */
            get: function () {
                return this.i.bd;
            },
            set: function (v) {
                this.i.bd = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "firstMarkerSize", {
            /**
             * Gets or sets the first marker size of the sparkline.
            */
            get: function () {
                return this.i.a6;
            },
            set: function (v) {
                this.i.a6 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lastMarkerSize", {
            /**
             * Gets or sets the last marker size of the sparkline.
            */
            get: function () {
                return this.i.a8;
            },
            set: function (v) {
                this.i.a8 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "highMarkerSize", {
            /**
             * Gets or sets the high marker size of the sparkline.
            */
            get: function () {
                return this.i.a7;
            },
            set: function (v) {
                this.i.a7 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lowMarkerSize", {
            /**
             * Gets or sets the low marker size of the sparkline.
            */
            get: function () {
                return this.i.bc;
            },
            set: function (v) {
                this.i.bc = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "negativeMarkerSize", {
            /**
             * Gets or sets the negative marker size of the sparkline.
            */
            get: function () {
                return this.i.bi;
            },
            set: function (v) {
                this.i.bi = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "lineThickness", {
            /**
             * Gets or sets the line thickness of the sparkline.
            */
            get: function () {
                return this.i.a9;
            },
            set: function (v) {
                this.i.a9 = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "minimum", {
            /**
             * Gets or sets the minimum value of the y axis.
            */
            get: function () {
                return this.i.bh;
            },
            set: function (v) {
                this.i.bh = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "maximum", {
            /**
             * Gets or sets the maximum value of the y axis.
            */
            get: function () {
                return this.i.bg;
            },
            set: function (v) {
                this.i.bg = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "valueMemberPath", {
            /**
             * Gets or sets the string path to the value column.
            */
            get: function () {
                return this.i.c9;
            },
            set: function (v) {
                this.i.c9 = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "labelMemberPath", {
            /**
             * String identifier of a column or property name to get labels from on each item in the data source.  These labels will be retrieved from the first and last item, and displayed by the horizontal axis.
            */
            get: function () {
                return this.i.ce;
            },
            set: function (v) {
                this.i.ce = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "trendLineType", {
            /**
             * Gets or sets the type of trendline used by the sparkline.
            */
            get: function () {
                return this.i.ar;
            },
            set: function (v) {
                this.i.ar = i2.ensureEnum(i2.TrendLineType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "trendLinePeriod", {
            /**
             * Gets or sets the trendline period used by the sparkline.
            */
            get: function () {
                return this.i.bq;
            },
            set: function (v) {
                this.i.bq = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "trendLineThickness", {
            /**
             * Gets or sets the thickness of the sparkline's trendline.
            */
            get: function () {
                return this.i.bm;
            },
            set: function (v) {
                this.i.bm = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "normalRangeMinimum", {
            /**
             * Gets or sets the minimum value of the normal range.
            */
            get: function () {
                return this.i.bk;
            },
            set: function (v) {
                this.i.bk = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "normalRangeMaximum", {
            /**
             * Gets or sets the maximum value of the normal range.
            */
            get: function () {
                return this.i.bj;
            },
            set: function (v) {
                this.i.bj = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "displayType", {
            /**
             * Gets or sets the display type of the sparkline.
            */
            get: function () {
                return this.i.aq;
            },
            set: function (v) {
                this.i.aq = i2.ensureEnum(SparklineDisplayType_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "unknownValuePlotting", {
            /**
             * Gets or sets the way null values are interpreted.
            */
            get: function () {
                return this.i.as;
            },
            set: function (v) {
                this.i.as = i2.ensureEnum(i2.UnknownValuePlotting_$type, v);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "verticalAxisLabel", {
            /**
             * The value or content to display on the vertical axis.
             * This can be set to a formatted string, such as "{0:n}", or it can be set to a DataTemplate.
            */
            get: function () {
                return this.i.bt;
            },
            set: function (v) {
                this.i.bt = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "horizontalAxisLabel", {
            /**
             * The value or content to display on the horizontal axis.
             * This can be set to a formatted string, such as "{0}", or it can be set to a DataTemplate.
            */
            get: function () {
                return this.i.br;
            },
            set: function (v) {
                this.i.br = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "formatLabel", {
            /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
            */
            get: function () {
                return this.i.bp;
            },
            set: function (v) {
                this.i.bp = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "horizontalLabelFormat", {
            /**
             * Gets or sets the label composite format used when creating label values.
            */
            get: function () {
                return this.i.ca;
            },
            set: function (v) {
                this.i.ca = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "horizontalLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the HorizontalLabelFormat string.
            */
            get: function () {
                return this.i.ag;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ag = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "verticalLabelFormat", {
            /**
             * Gets or sets the label composite format used when creating label values.
            */
            get: function () {
                return this.i.df;
            },
            set: function (v) {
                this.i.df = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "verticalLabelFormatSpecifiers", {
            /**
             * Gets or sets the format specifiers to use with the VerticalLabelFormat string.
            */
            get: function () {
                return this.i.ah;
            },
            set: function (v) {
                if (v && !Array.isArray(v) && typeof (v) == "string") {
                    var re = /\s*(?:,|\s|$)\s*/gm;
                    v = v.split(re);
                }
                this.i.ah = v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "pixelScalingRatio", {
            /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.bl;
            },
            set: function (v) {
                this.i.bl = +v;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(IgxSparklineComponent.prototype, "actualPixelScalingRatio", {
            /**
             * Gets the actual scaling value used by the component to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
            get: function () {
                return this.i.a5;
            },
            set: function (v) {
                this.i.a5 = +v;
            },
            enumerable: false,
            configurable: true
        });
        IgxSparklineComponent.prototype.findByName = function (name) {
            if (this.horizontalLabelFormatSpecifiers != null && i2.arrayFindByName(this.horizontalLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.horizontalLabelFormatSpecifiers, name);
            }
            if (this.verticalLabelFormatSpecifiers != null && i2.arrayFindByName(this.verticalLabelFormatSpecifiers, name)) {
                return i2.arrayFindByName(this.verticalLabelFormatSpecifiers, name);
            }
            return null;
        };
        Object.defineProperty(IgxSparklineComponent.prototype, "hasUserValues", {
            get: function () {
                return this._hasUserValues;
            },
            enumerable: false,
            configurable: true
        });
        IgxSparklineComponent.prototype.__m = function (propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        };
        IgxSparklineComponent.prototype._styling = function (container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            var genericPrefix = "";
            var typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = i2.toSpinal("SparklineComponent");
            var additionalPrefixes = [];
            var prefix = i2.toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            var b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                var basePrefix = i2.toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                var parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                var parentPrefix = i2.toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            i2.initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        };
        /**
     * Provides a container to the sparkline control.

    * @param container  * The container.
    */
        IgxSparklineComponent.prototype.provideContainer = function (container) {
            this.i.provideContainer(container);
        };
        /**
         * Notify that the control has resized.
        
        */
        IgxSparklineComponent.prototype.notifyResized = function () {
            this.i.notifyResized();
        };
        IgxSparklineComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
            this.i.dn(source_, index, oldItem, newItem);
        };
        /**
         * Used to manually notify the IgxSparklineComponent that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
        
        * @param source_  * The data source which was cleared or reset.
        */
        IgxSparklineComponent.prototype.notifyClearItems = function (source_) {
            this.i.dj(source_);
        };
        IgxSparklineComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
            this.i.dk(source_, index, newItem);
        };
        IgxSparklineComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
            this.i.dl(source_, index, oldItem);
        };
        /**
         * Returns the sparkline visuals expressed as a SparklineVisualData object.
        
        */
        IgxSparklineComponent.prototype.exportVisualData = function () {
            var iv = this.i.au();
            return (iv);
        };
        /**
         * Returns visuals as a serialized string.
        
        */
        IgxSparklineComponent.prototype.exportSerializedVisualData = function () {
            var iv = this.i.by();
            return (iv);
        };
        IgxSparklineComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineComponent, deps: [{ token: i0.Renderer2 }, { token: i0.ViewContainerRef }, { token: i0.NgZone }, { token: i0.ComponentFactoryResolver }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
        IgxSparklineComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.13", type: IgxSparklineComponent, selector: "igx-sparkline", inputs: { height: "height", width: "width", dataSource: "dataSource", tooltipTemplate: "tooltipTemplate", brush: "brush", negativeBrush: "negativeBrush", markerBrush: "markerBrush", negativeMarkerBrush: "negativeMarkerBrush", firstMarkerBrush: "firstMarkerBrush", lastMarkerBrush: "lastMarkerBrush", highMarkerBrush: "highMarkerBrush", lowMarkerBrush: "lowMarkerBrush", trendLineBrush: "trendLineBrush", horizontalAxisBrush: "horizontalAxisBrush", verticalAxisBrush: "verticalAxisBrush", normalRangeFill: "normalRangeFill", horizontalAxisVisibility: "horizontalAxisVisibility", verticalAxisVisibility: "verticalAxisVisibility", markerVisibility: "markerVisibility", negativeMarkerVisibility: "negativeMarkerVisibility", firstMarkerVisibility: "firstMarkerVisibility", lastMarkerVisibility: "lastMarkerVisibility", lowMarkerVisibility: "lowMarkerVisibility", highMarkerVisibility: "highMarkerVisibility", normalRangeVisibility: "normalRangeVisibility", displayNormalRangeInFront: "displayNormalRangeInFront", markerSize: "markerSize", firstMarkerSize: "firstMarkerSize", lastMarkerSize: "lastMarkerSize", highMarkerSize: "highMarkerSize", lowMarkerSize: "lowMarkerSize", negativeMarkerSize: "negativeMarkerSize", lineThickness: "lineThickness", minimum: "minimum", maximum: "maximum", valueMemberPath: "valueMemberPath", labelMemberPath: "labelMemberPath", trendLineType: "trendLineType", trendLinePeriod: "trendLinePeriod", trendLineThickness: "trendLineThickness", normalRangeMinimum: "normalRangeMinimum", normalRangeMaximum: "normalRangeMaximum", displayType: "displayType", unknownValuePlotting: "unknownValuePlotting", verticalAxisLabel: "verticalAxisLabel", horizontalAxisLabel: "horizontalAxisLabel", formatLabel: "formatLabel", horizontalLabelFormat: "horizontalLabelFormat", horizontalLabelFormatSpecifiers: "horizontalLabelFormatSpecifiers", verticalLabelFormat: "verticalLabelFormat", verticalLabelFormatSpecifiers: "verticalLabelFormatSpecifiers", pixelScalingRatio: "pixelScalingRatio", actualPixelScalingRatio: "actualPixelScalingRatio" }, host: { classAttribute: "ig-sparkline igx-sparkline" }, providers: [], viewQueries: [{ propertyName: "_dynamicContent", first: true, predicate: ["dynamicContent"], descendants: true, read: i0.ViewContainerRef, static: true }], ngImport: i0, template: "<ng-container #dynamicContent></ng-container>", isInline: true, styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
        return IgxSparklineComponent;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'igx-sparkline',
                        template: "<ng-container #dynamicContent></ng-container>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        providers: [],
                        host: { 'class': 'ig-sparkline igx-sparkline' },
                        styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                    }]
            }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ViewContainerRef }, { type: i0.NgZone }, { type: i0.ComponentFactoryResolver }, { type: i0.Injector }]; }, propDecorators: { _dynamicContent: [{
                    type: i0.ViewChild,
                    args: ["dynamicContent", { read: i0.ViewContainerRef, static: true }]
                }], height: [{
                    type: i0.Input
                }], width: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], tooltipTemplate: [{
                    type: i0.Input
                }], brush: [{
                    type: i0.Input
                }], negativeBrush: [{
                    type: i0.Input
                }], markerBrush: [{
                    type: i0.Input
                }], negativeMarkerBrush: [{
                    type: i0.Input
                }], firstMarkerBrush: [{
                    type: i0.Input
                }], lastMarkerBrush: [{
                    type: i0.Input
                }], highMarkerBrush: [{
                    type: i0.Input
                }], lowMarkerBrush: [{
                    type: i0.Input
                }], trendLineBrush: [{
                    type: i0.Input
                }], horizontalAxisBrush: [{
                    type: i0.Input
                }], verticalAxisBrush: [{
                    type: i0.Input
                }], normalRangeFill: [{
                    type: i0.Input
                }], horizontalAxisVisibility: [{
                    type: i0.Input
                }], verticalAxisVisibility: [{
                    type: i0.Input
                }], markerVisibility: [{
                    type: i0.Input
                }], negativeMarkerVisibility: [{
                    type: i0.Input
                }], firstMarkerVisibility: [{
                    type: i0.Input
                }], lastMarkerVisibility: [{
                    type: i0.Input
                }], lowMarkerVisibility: [{
                    type: i0.Input
                }], highMarkerVisibility: [{
                    type: i0.Input
                }], normalRangeVisibility: [{
                    type: i0.Input
                }], displayNormalRangeInFront: [{
                    type: i0.Input
                }], markerSize: [{
                    type: i0.Input
                }], firstMarkerSize: [{
                    type: i0.Input
                }], lastMarkerSize: [{
                    type: i0.Input
                }], highMarkerSize: [{
                    type: i0.Input
                }], lowMarkerSize: [{
                    type: i0.Input
                }], negativeMarkerSize: [{
                    type: i0.Input
                }], lineThickness: [{
                    type: i0.Input
                }], minimum: [{
                    type: i0.Input
                }], maximum: [{
                    type: i0.Input
                }], valueMemberPath: [{
                    type: i0.Input
                }], labelMemberPath: [{
                    type: i0.Input
                }], trendLineType: [{
                    type: i0.Input
                }], trendLinePeriod: [{
                    type: i0.Input
                }], trendLineThickness: [{
                    type: i0.Input
                }], normalRangeMinimum: [{
                    type: i0.Input
                }], normalRangeMaximum: [{
                    type: i0.Input
                }], displayType: [{
                    type: i0.Input
                }], unknownValuePlotting: [{
                    type: i0.Input
                }], verticalAxisLabel: [{
                    type: i0.Input
                }], horizontalAxisLabel: [{
                    type: i0.Input
                }], formatLabel: [{
                    type: i0.Input
                }], horizontalLabelFormat: [{
                    type: i0.Input
                }], horizontalLabelFormatSpecifiers: [{
                    type: i0.Input
                }], verticalLabelFormat: [{
                    type: i0.Input
                }], verticalLabelFormatSpecifiers: [{
                    type: i0.Input
                }], pixelScalingRatio: [{
                    type: i0.Input
                }], actualPixelScalingRatio: [{
                    type: i0.Input
                }] } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSparklineCoreModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSparklineCoreModule() {
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxSparklineCoreModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSparklineCoreModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreModule, declarations: [IgxSparklineComponent], imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule], exports: [IgxSparklineComponent,
                i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule] });
        IgxSparklineCoreModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                    i2.IgxDateTimeFormatSpecifierModule
                ], i2.IgxNumberFormatSpecifierModule,
                i2.IgxDateTimeFormatSpecifierModule] });
        return IgxSparklineCoreModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [IgxSparklineComponent],
                        exports: [IgxSparklineComponent,
                            i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierModule,
                            i2.IgxDateTimeFormatSpecifierModule
                        ],
                        entryComponents: []
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSparklineCoreDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSparklineCoreDynamicModule() {
            i2.TypeRegistrar.registerCons('IgxSparklineComponent', IgxSparklineComponent);
            i2.TypeRegistrar.register('FastItemObjectColumn', i2.FastItemObjectColumn.$type);
        }
        IgxSparklineCoreDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSparklineCoreDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreDynamicModule, imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxSparklineCoreModule], exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxSparklineCoreModule] });
        IgxSparklineCoreDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreDynamicModule, imports: [[i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                    i2.IgxDateTimeFormatSpecifierDynamicModule,
                    IgxSparklineCoreModule
                ], i2.IgxNumberFormatSpecifierDynamicModule,
                i2.IgxDateTimeFormatSpecifierDynamicModule,
                IgxSparklineCoreModule] });
        return IgxSparklineCoreDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineCoreDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxSparklineCoreModule
                        ],
                        imports: [i1.CommonModule, i2.IgxNumberFormatSpecifierDynamicModule,
                            i2.IgxDateTimeFormatSpecifierDynamicModule,
                            IgxSparklineCoreModule
                        ],
                        entryComponents: [IgxSparklineComponent]
                    }]
            }], ctorParameters: function () { return []; } });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSparklineModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSparklineModule() {
        }
        IgxSparklineModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSparklineModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineModule, imports: [i1.CommonModule, IgxSparklineCoreModule,
                IgxDataChartInteractivityModule], exports: [IgxSparklineCoreModule,
                IgxDataChartInteractivityModule] });
        IgxSparklineModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineModule, imports: [[i1.CommonModule, IgxSparklineCoreModule,
                    IgxDataChartInteractivityModule
                ], IgxSparklineCoreModule,
                IgxDataChartInteractivityModule] });
        return IgxSparklineModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxSparklineCoreModule,
                            IgxDataChartInteractivityModule
                        ],
                        imports: [i1.CommonModule, IgxSparklineCoreModule,
                            IgxDataChartInteractivityModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    var IgxSparklineDynamicModule = /** @class */ /*@__PURE__*/ (function () {
        function IgxSparklineDynamicModule() {
        }
        IgxSparklineDynamicModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineDynamicModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
        IgxSparklineDynamicModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineDynamicModule, imports: [i1.CommonModule, IgxSparklineCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxSparklineModule], exports: [IgxSparklineCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxSparklineModule] });
        IgxSparklineDynamicModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineDynamicModule, imports: [[i1.CommonModule, IgxSparklineCoreDynamicModule,
                    IgxDataChartInteractivityDynamicModule,
                    IgxSparklineModule
                ], IgxSparklineCoreDynamicModule,
                IgxDataChartInteractivityDynamicModule,
                IgxSparklineModule] });
        return IgxSparklineDynamicModule;
    }());
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.13", ngImport: i0, type: IgxSparklineDynamicModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        exports: [IgxSparklineCoreDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxSparklineModule
                        ],
                        imports: [i1.CommonModule, IgxSparklineCoreDynamicModule,
                            IgxDataChartInteractivityDynamicModule,
                            IgxSparklineModule
                        ],
                        entryComponents: []
                    }]
            }] });

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var SparkLayerType_$type = i2.markEnum('SparkLayerType', 'SparkLayer,1|MarkerLayer,2|ToolTipLayer,4|RangeLayer,8|TrendLayer,16');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var MessageHandler_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
        tslib.__extends(MessageHandler_Spark, _super);
        function MessageHandler_Spark() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.a = i2.DictionaryUtil.dictionaryCreate();
            return _this;
        }
        MessageHandler_Spark.prototype.addHandler = function (a, b) {
            this.a.set(a.typeName, b);
        };
        MessageHandler_Spark.prototype.messageReceived = function (a) {
            var b;
            var c = i2.getInstanceType(a).typeName;
            if (this.a.has(c)) {
                b = this.a.get(c);
                b(a);
            }
        };
        MessageHandler_Spark.$t = i2.markType(MessageHandler_Spark, 'MessageHandler_Spark');
        return MessageHandler_Spark;
    }(i2.Base));

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ZoomSliderCursor_$type = i2.markEnum('ZoomSliderCursor', 'Default,0|LeftRight,1|UpDown,2|Move,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var TrackShadeOrientation_$type = i2.markEnum('TrackShadeOrientation', 'HorizontalLower,0|HorizontalHigher,1|VerticalLower,2|VerticalHigher,3');

    /*
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
    */
    /**
     * @hidden
     */
    var ZoomSliderVisualArea_$type = i2.markEnum('ZoomSliderVisualArea', 'LowerThumb,0|HigherThumb,1|LowerShade,2|HigherShade,3|RangeThumb,4|Bar,5|None,6');

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AbsoluteVolumeOscillatorIndicator = AbsoluteVolumeOscillatorIndicator;
    exports.AbsoluteVolumeOscillatorIndicatorStrategy = AbsoluteVolumeOscillatorIndicatorStrategy;
    exports.AccumulationDistributionIndicator = AccumulationDistributionIndicator;
    exports.AccumulationDistributionIndicatorStrategy = AccumulationDistributionIndicatorStrategy;
    exports.ActualLegendItemBadgeShape = ActualLegendItemBadgeShape;
    exports.ActualLegendItemBadgeShape_$type = ActualLegendItemBadgeShape_$type;
    exports.ActualRange = ActualRange;
    exports.AnchoredCategoryBucketCalculator = AnchoredCategoryBucketCalculator;
    exports.AnchoredCategorySeries = AnchoredCategorySeries;
    exports.AnchoredCategorySeriesInteractionManager = AnchoredCategorySeriesInteractionManager;
    exports.AnchoredCategorySeriesView = AnchoredCategorySeriesView;
    exports.AnchoredRadialBucketCalculator = AnchoredRadialBucketCalculator;
    exports.AnchoredRadialSeries = AnchoredRadialSeries;
    exports.AnchoredRadialSeriesView = AnchoredRadialSeriesView;
    exports.AngleAxisLabelPanel = AngleAxisLabelPanel;
    exports.AngleAxisLabelPanelView = AngleAxisLabelPanelView;
    exports.AngleRadiusPair = AngleRadiusPair;
    exports.AnnotationFactoryManager = AnnotationFactoryManager;
    exports.AnnotationInfoProvider = AnnotationInfoProvider;
    exports.AnnotationLayer = AnnotationLayer;
    exports.AnnotationLayerProxy = AnnotationLayerProxy;
    exports.AnnotationLayerView = AnnotationLayerView;
    exports.Arc = Arc;
    exports.ArcItem = ArcItem;
    exports.ArcView = ArcView;
    exports.ArcVisualData = ArcVisualData;
    exports.ArcVisualDataList = ArcVisualDataList;
    exports.AreaFragment = AreaFragment;
    exports.AreaFragmentBucketCalculator = AreaFragmentBucketCalculator;
    exports.AreaFragmentView = AreaFragmentView;
    exports.AreaInfo = AreaInfo;
    exports.AreaSeries = AreaSeries;
    exports.AreaSeriesView = AreaSeriesView;
    exports.AssigningCategoryMarkerStyleEventArgs = AssigningCategoryMarkerStyleEventArgs;
    exports.AssigningCategoryStyleEventArgs = AssigningCategoryStyleEventArgs;
    exports.AssigningCategoryStyleEventArgsBase = AssigningCategoryStyleEventArgsBase;
    exports.AssigningPolarMarkerStyleEventArgs = AssigningPolarMarkerStyleEventArgs;
    exports.AssigningPolarStyleEventArgs = AssigningPolarStyleEventArgs;
    exports.AssigningPolarStyleEventArgsBase = AssigningPolarStyleEventArgsBase;
    exports.AssigningRadialMarkerStyleEventArgs = AssigningRadialMarkerStyleEventArgs;
    exports.AssigningRadialStyleEventArgs = AssigningRadialStyleEventArgs;
    exports.AssigningRadialStyleEventArgsBase = AssigningRadialStyleEventArgsBase;
    exports.AssigningScatterMarkerStyleEventArgs = AssigningScatterMarkerStyleEventArgs;
    exports.AssigningScatterStyleEventArgs = AssigningScatterStyleEventArgs;
    exports.AssigningScatterStyleEventArgsBase = AssigningScatterStyleEventArgsBase;
    exports.AssigningSeriesShapeStyleEventArgsBase = AssigningSeriesShapeStyleEventArgsBase;
    exports.AssigningSeriesStyleEventArgsBase = AssigningSeriesStyleEventArgsBase;
    exports.AssigningShapeMarkerStyleEventArgs = AssigningShapeMarkerStyleEventArgs;
    exports.AssigningShapeStyleEventArgs = AssigningShapeStyleEventArgs;
    exports.AssigningShapeStyleEventArgsBase = AssigningShapeStyleEventArgsBase;
    exports.AutoRangeCalculator = AutoRangeCalculator;
    exports.AverageDirectionalIndexIndicator = AverageDirectionalIndexIndicator;
    exports.AverageDirectionalIndexIndicatorStrategy = AverageDirectionalIndexIndicatorStrategy;
    exports.AverageTrueRangeIndicator = AverageTrueRangeIndicator;
    exports.AverageTrueRangeIndicatorStrategy = AverageTrueRangeIndicatorStrategy;
    exports.Axis = Axis;
    exports.AxisAnnotation = AxisAnnotation;
    exports.AxisAnnotationFrame = AxisAnnotationFrame;
    exports.AxisAnnotationFrameManager = AxisAnnotationFrameManager;
    exports.AxisAnnotationManager = AxisAnnotationManager;
    exports.AxisCollection = AxisCollection;
    exports.AxisComponentsForView = AxisComponentsForView;
    exports.AxisComponentsFromView = AxisComponentsFromView;
    exports.AxisDefaults = AxisDefaults;
    exports.AxisExtentType = AxisExtentType;
    exports.AxisExtentType_$type = AxisExtentType_$type;
    exports.AxisLabelInfo = AxisLabelInfo;
    exports.AxisLabelManager = AxisLabelManager;
    exports.AxisLabelPanelBase = AxisLabelPanelBase;
    exports.AxisLabelPanelBaseView = AxisLabelPanelBaseView;
    exports.AxisLabelSettings = AxisLabelSettings;
    exports.AxisLabelVisualData = AxisLabelVisualData;
    exports.AxisLabelVisualDataList = AxisLabelVisualDataList;
    exports.AxisLabelsLocation = AxisLabelsLocation;
    exports.AxisLabelsLocation_$type = AxisLabelsLocation_$type;
    exports.AxisOrientation = AxisOrientation;
    exports.AxisOrientation_$type = AxisOrientation_$type;
    exports.AxisRange = AxisRange;
    exports.AxisRangeChangedEventArgs = AxisRangeChangedEventArgs;
    exports.AxisRenderMessage_Spark = AxisRenderMessage_Spark;
    exports.AxisRendererBase = AxisRendererBase;
    exports.AxisRenderingParametersBase = AxisRenderingParametersBase;
    exports.AxisTitlePosition = AxisTitlePosition;
    exports.AxisTitlePosition_$type = AxisTitlePosition_$type;
    exports.AxisView = AxisView;
    exports.AxisVisualData = AxisVisualData;
    exports.AxisVisualDataList = AxisVisualDataList;
    exports.AxisVisualDataManager = AxisVisualDataManager;
    exports.BarBucketCalculator = BarBucketCalculator;
    exports.BarFragment = BarFragment;
    exports.BarFramePreparer = BarFramePreparer;
    exports.BarSeries = BarSeries;
    exports.BarSeriesView = BarSeriesView;
    exports.BarTrendFitCalculator = BarTrendFitCalculator;
    exports.BarTrendLineManager = BarTrendLineManager;
    exports.Bezier = Bezier;
    exports.BezierOp = BezierOp;
    exports.BezierPoint = BezierPoint;
    exports.BollingerBandWidthIndicator = BollingerBandWidthIndicator;
    exports.BollingerBandWidthIndicatorStrategy = BollingerBandWidthIndicatorStrategy;
    exports.BollingerBandsBucketCalculator = BollingerBandsBucketCalculator;
    exports.BollingerBandsOverlay = BollingerBandsOverlay;
    exports.BollingerBandsOverlayView = BollingerBandsOverlayView;
    exports.BrushChangedMessage_Spark = BrushChangedMessage_Spark;
    exports.BrushScale = BrushScale;
    exports.BrushSelectionMode = BrushSelectionMode;
    exports.BrushSelectionMode_$type = BrushSelectionMode_$type;
    exports.BubbleMarkerManager = BubbleMarkerManager;
    exports.BubbleSeries = BubbleSeries;
    exports.BubbleSeriesView = BubbleSeriesView;
    exports.CalculatedColumn = CalculatedColumn;
    exports.CalloutAnnotation = CalloutAnnotation;
    exports.CalloutAnnotationCollection = CalloutAnnotationCollection;
    exports.CalloutAnnotationWrapper = CalloutAnnotationWrapper;
    exports.CalloutCollisionMode = CalloutCollisionMode;
    exports.CalloutCollisionMode_$type = CalloutCollisionMode_$type;
    exports.CalloutContentUpdatingEventArgs = CalloutContentUpdatingEventArgs;
    exports.CalloutKey = CalloutKey;
    exports.CalloutLabelUpdatingEventArgs = CalloutLabelUpdatingEventArgs;
    exports.CalloutLayer = CalloutLayer;
    exports.CalloutLayerFrame = CalloutLayerFrame;
    exports.CalloutLayerView = CalloutLayerView;
    exports.CalloutSeriesSelectingEventArgs = CalloutSeriesSelectingEventArgs;
    exports.CalloutStyleUpdatingEventArgs = CalloutStyleUpdatingEventArgs;
    exports.CalloutView = CalloutView;
    exports.CalloutViewHelper = CalloutViewHelper;
    exports.CalloutVisualData = CalloutVisualData;
    exports.CalloutVisualDataList = CalloutVisualDataList;
    exports.CategoryAngleAxis = CategoryAngleAxis;
    exports.CategoryAngleAxisView = CategoryAngleAxisView;
    exports.CategoryAxisBase = CategoryAxisBase;
    exports.CategoryAxisBaseView = CategoryAxisBaseView;
    exports.CategoryAxisRenderer = CategoryAxisRenderer;
    exports.CategoryAxisRenderingParameters = CategoryAxisRenderingParameters;
    exports.CategoryBucketCalculator = CategoryBucketCalculator;
    exports.CategoryChart = CategoryChart;
    exports.CategoryChartMockDataGenerator = CategoryChartMockDataGenerator;
    exports.CategoryChartMockDataItem = CategoryChartMockDataItem;
    exports.CategoryChartType = CategoryChartType;
    exports.CategoryChartType_$type = CategoryChartType_$type;
    exports.CategoryDateTimeXAxis = CategoryDateTimeXAxis;
    exports.CategoryDateTimeXAxisView = CategoryDateTimeXAxisView;
    exports.CategoryErrorBarSettings = CategoryErrorBarSettings;
    exports.CategoryFrame = CategoryFrame;
    exports.CategoryFramePreparer = CategoryFramePreparer;
    exports.CategoryFramePreparerBase = CategoryFramePreparerBase;
    exports.CategoryHighlightFrameRect = CategoryHighlightFrameRect;
    exports.CategoryHighlightLayer = CategoryHighlightLayer;
    exports.CategoryHighlightLayerFrame = CategoryHighlightLayerFrame;
    exports.CategoryHighlightLayerView = CategoryHighlightLayerView;
    exports.CategoryItemHighlightLayer = CategoryItemHighlightLayer;
    exports.CategoryItemHighlightLayerFrame = CategoryItemHighlightLayerFrame;
    exports.CategoryItemHighlightLayerView = CategoryItemHighlightLayerView;
    exports.CategoryItemHighlightType = CategoryItemHighlightType;
    exports.CategoryItemHighlightType_$type = CategoryItemHighlightType_$type;
    exports.CategoryLineRasterizer = CategoryLineRasterizer;
    exports.CategoryMarkerManager = CategoryMarkerManager;
    exports.CategoryMode_$type = CategoryMode_$type;
    exports.CategorySeries = CategorySeries;
    exports.CategorySeriesInteractionManager = CategorySeriesInteractionManager;
    exports.CategorySeriesMarkerCollisionAvoidance = CategorySeriesMarkerCollisionAvoidance;
    exports.CategorySeriesMarkerCollisionAvoidance_$type = CategorySeriesMarkerCollisionAvoidance_$type;
    exports.CategorySeriesRenderManager = CategorySeriesRenderManager;
    exports.CategorySeriesView = CategorySeriesView;
    exports.CategoryTickmarkValues = CategoryTickmarkValues;
    exports.CategoryToolTipCollisionInfo = CategoryToolTipCollisionInfo;
    exports.CategoryToolTipLayer = CategoryToolTipLayer;
    exports.CategoryToolTipLayerFrame = CategoryToolTipLayerFrame;
    exports.CategoryToolTipLayerView = CategoryToolTipLayerView;
    exports.CategoryTooltipLayerPosition = CategoryTooltipLayerPosition;
    exports.CategoryTooltipLayerPosition_$type = CategoryTooltipLayerPosition_$type;
    exports.CategoryTooltipSeriesInfo = CategoryTooltipSeriesInfo;
    exports.CategoryTransitionInMode = CategoryTransitionInMode;
    exports.CategoryTransitionInMode_$type = CategoryTransitionInMode_$type;
    exports.CategoryTransitionSourceFramePreparer = CategoryTransitionSourceFramePreparer;
    exports.CategoryTrendLineManager = CategoryTrendLineManager;
    exports.CategoryTrendLineManagerBase = CategoryTrendLineManagerBase;
    exports.CategoryTrendLineManagerFactory = CategoryTrendLineManagerFactory;
    exports.CategoryXAxis = CategoryXAxis;
    exports.CategoryXAxisView = CategoryXAxisView;
    exports.CategoryYAxis = CategoryYAxis;
    exports.CategoryYAxisView = CategoryYAxisView;
    exports.ChaikinOscillatorIndicator = ChaikinOscillatorIndicator;
    exports.ChaikinOscillatorIndicatorStrategy = ChaikinOscillatorIndicatorStrategy;
    exports.ChaikinVolatilityIndicator = ChaikinVolatilityIndicator;
    exports.ChaikinVolatilityIndicatorStrategy = ChaikinVolatilityIndicatorStrategy;
    exports.ChartAxisRangeChangedEventArgs = ChartAxisRangeChangedEventArgs;
    exports.ChartCollection = ChartCollection;
    exports.ChartContentManager = ChartContentManager;
    exports.ChartContentType_$type = ChartContentType_$type;
    exports.ChartCursorEventArgs = ChartCursorEventArgs;
    exports.ChartHitTestMode = ChartHitTestMode;
    exports.ChartHitTestMode_$type = ChartHitTestMode_$type;
    exports.ChartMouseEventArgs = ChartMouseEventArgs;
    exports.ChartSeriesEventArgs = ChartSeriesEventArgs;
    exports.ChartTitleVisualData = ChartTitleVisualData;
    exports.ChartTitleVisualDataList = ChartTitleVisualDataList;
    exports.ChartVisualData = ChartVisualData;
    exports.ClearMessage = ClearMessage;
    exports.ClearMessage_Spark = ClearMessage_Spark;
    exports.ClearTooltipMessage = ClearTooltipMessage;
    exports.CoercionInfo = CoercionInfo;
    exports.CollisionAvoidanceType = CollisionAvoidanceType;
    exports.CollisionAvoidanceType_$type = CollisionAvoidanceType_$type;
    exports.CollisionAvoider = CollisionAvoider;
    exports.ColorScale = ColorScale;
    exports.ColorScaleInterpolationMode = ColorScaleInterpolationMode;
    exports.ColorScaleInterpolationMode_$type = ColorScaleInterpolationMode_$type;
    exports.ColumnFragment = ColumnFragment;
    exports.ColumnFragmentView = ColumnFragmentView;
    exports.ColumnMessage_Spark = ColumnMessage_Spark;
    exports.ColumnSeries = ColumnSeries;
    exports.ColumnSeriesView = ColumnSeriesView;
    exports.ColumnSupportingCalculation = ColumnSupportingCalculation;
    exports.CommodityChannelIndexIndicator = CommodityChannelIndexIndicator;
    exports.CommodityChannelIndexIndicatorStrategy = CommodityChannelIndexIndicatorStrategy;
    exports.ComputedPlotAreaMarginMode = ComputedPlotAreaMarginMode;
    exports.ComputedPlotAreaMarginMode_$type = ComputedPlotAreaMarginMode_$type;
    exports.ConfigurationMessage = ConfigurationMessage;
    exports.ConfigurationMessage_Spark = ConfigurationMessage_Spark;
    exports.ConsolidatedItemHitTestBehavior = ConsolidatedItemHitTestBehavior;
    exports.ConsolidatedItemHitTestBehavior_$type = ConsolidatedItemHitTestBehavior_$type;
    exports.ConsolidatedItemsPosition = ConsolidatedItemsPosition;
    exports.ConsolidatedItemsPosition_$type = ConsolidatedItemsPosition_$type;
    exports.ContainerMessage_Spark = ContainerMessage_Spark;
    exports.ContainerResizedMessage_Spark = ContainerResizedMessage_Spark;
    exports.ContainerSizeChangedMessage = ContainerSizeChangedMessage;
    exports.ContainerSizeChangedMessage_Spark = ContainerSizeChangedMessage_Spark;
    exports.ContentInfo = ContentInfo;
    exports.ContourBuilder = ContourBuilder;
    exports.ContourValueResolver = ContourValueResolver;
    exports.CrosshairLayer = CrosshairLayer;
    exports.CrosshairLayerFrame = CrosshairLayerFrame;
    exports.CrosshairLayerView = CrosshairLayerView;
    exports.CrosshairsDisplayMode = CrosshairsDisplayMode;
    exports.CrosshairsDisplayMode_$type = CrosshairsDisplayMode_$type;
    exports.CustomContourValueResolver = CustomContourValueResolver;
    exports.CustomContourValueResolverEventArgs = CustomContourValueResolverEventArgs;
    exports.CustomIndicator = CustomIndicator;
    exports.CustomIndicatorNameCollection = CustomIndicatorNameCollection;
    exports.CustomIndicatorStrategy = CustomIndicatorStrategy;
    exports.CustomPaletteBrushScale = CustomPaletteBrushScale;
    exports.CustomPaletteColorScale = CustomPaletteColorScale;
    exports.DataChangedMessage_Spark = DataChangedMessage_Spark;
    exports.DataChartMouseButtonEventArgs = DataChartMouseButtonEventArgs;
    exports.DataChartStylingDefaults = DataChartStylingDefaults;
    exports.DataChartVisualDataManager = DataChartVisualDataManager;
    exports.DataSourceManager = DataSourceManager;
    exports.DataSourceSupportingCalculation = DataSourceSupportingCalculation;
    exports.DataUpdatedMessage = DataUpdatedMessage;
    exports.DefaultCategoryTrendlineHost = DefaultCategoryTrendlineHost;
    exports.DefaultCategoryTrendlinePreparer = DefaultCategoryTrendlinePreparer;
    exports.DefaultFlattener = DefaultFlattener;
    exports.DefaultHighLowValueProvider = DefaultHighLowValueProvider;
    exports.DefaultPaletteInfo = DefaultPaletteInfo;
    exports.DefaultProvidesViewport = DefaultProvidesViewport;
    exports.DefaultSingleValueProvider = DefaultSingleValueProvider;
    exports.DefaultSupportsErrorBars = DefaultSupportsErrorBars;
    exports.DefaultSupportsMarkers = DefaultSupportsMarkers;
    exports.DefaultTrackBarVisual = DefaultTrackBarVisual;
    exports.DefaultTrackRangeVisual = DefaultTrackRangeVisual;
    exports.DefaultTrackShadeVisual = DefaultTrackShadeVisual;
    exports.DefaultTrackThumbCalloutVisual = DefaultTrackThumbCalloutVisual;
    exports.DefaultTrackThumbVisual = DefaultTrackThumbVisual;
    exports.Defaults = Defaults;
    exports.DelegateClipper = DelegateClipper;
    exports.DetrendedPriceOscillatorIndicator = DetrendedPriceOscillatorIndicator;
    exports.DetrendedPriceOscillatorIndicatorStrategy = DetrendedPriceOscillatorIndicatorStrategy;
    exports.DictInterpolator$3 = DictInterpolator$3;
    exports.DomainChart = DomainChart;
    exports.DomainChartSeriesPointerEventArgs = DomainChartSeriesPointerEventArgs;
    exports.DomainType = DomainType;
    exports.DomainType_$type = DomainType_$type;
    exports.DoubleColumn = DoubleColumn;
    exports.DoughnutChartLabelVisualData = DoughnutChartLabelVisualData;
    exports.DoughnutChartVisualData = DoughnutChartVisualData;
    exports.EaseOfMovementIndicator = EaseOfMovementIndicator;
    exports.EaseOfMovementIndicatorStrategy = EaseOfMovementIndicatorStrategy;
    exports.EnableErrorBars = EnableErrorBars;
    exports.EnableErrorBars_$type = EnableErrorBars_$type;
    exports.ErrorBarSettingsBase = ErrorBarSettingsBase;
    exports.ErrorBarsHelper = ErrorBarsHelper;
    exports.FastHorizontalLinearScaler = FastHorizontalLinearScaler;
    exports.FastStochasticOscillatorIndicator = FastStochasticOscillatorIndicator;
    exports.FastStochasticOscillatorIndicatorStrategy = FastStochasticOscillatorIndicatorStrategy;
    exports.FastVerticalLinearScaler = FastVerticalLinearScaler;
    exports.FinalValueLayer = FinalValueLayer;
    exports.FinalValueLayerFrame = FinalValueLayerFrame;
    exports.FinalValueLayerView = FinalValueLayerView;
    exports.FinalValueSelectionMode = FinalValueSelectionMode;
    exports.FinalValueSelectionMode_$type = FinalValueSelectionMode_$type;
    exports.FinancialBucketCalculator = FinancialBucketCalculator;
    exports.FinancialCalculationDataSource = FinancialCalculationDataSource;
    exports.FinancialCalculationSupportingCalculations = FinancialCalculationSupportingCalculations;
    exports.FinancialChart = FinancialChart;
    exports.FinancialChartContext = FinancialChartContext;
    exports.FinancialChartCustomIndicatorArgs = FinancialChartCustomIndicatorArgs;
    exports.FinancialChartDropDownControl = FinancialChartDropDownControl;
    exports.FinancialChartDropDownControlView = FinancialChartDropDownControlView;
    exports.FinancialChartDropDownControlViewModel = FinancialChartDropDownControlViewModel;
    exports.FinancialChartEnumCollectionPickerVisualData = FinancialChartEnumCollectionPickerVisualData;
    exports.FinancialChartEnumPickerVisualData = FinancialChartEnumPickerVisualData;
    exports.FinancialChartIndicatorMenu = FinancialChartIndicatorMenu;
    exports.FinancialChartIndicatorMenuContext = FinancialChartIndicatorMenuContext;
    exports.FinancialChartIndicatorMenuItem = FinancialChartIndicatorMenuItem;
    exports.FinancialChartIndicatorMenuItems = FinancialChartIndicatorMenuItems;
    exports.FinancialChartIndicatorMenuView = FinancialChartIndicatorMenuView;
    exports.FinancialChartIndicatorMenuViewModel = FinancialChartIndicatorMenuViewModel;
    exports.FinancialChartRangeSelector = FinancialChartRangeSelector;
    exports.FinancialChartRangeSelectorContext = FinancialChartRangeSelectorContext;
    exports.FinancialChartRangeSelectorOption = FinancialChartRangeSelectorOption;
    exports.FinancialChartRangeSelectorOptionCollection = FinancialChartRangeSelectorOptionCollection;
    exports.FinancialChartRangeSelectorOption_$type = FinancialChartRangeSelectorOption_$type;
    exports.FinancialChartRangeSelectorView = FinancialChartRangeSelectorView;
    exports.FinancialChartRangeSelectorViewModel = FinancialChartRangeSelectorViewModel;
    exports.FinancialChartRangeSelectorVisualData = FinancialChartRangeSelectorVisualData;
    exports.FinancialChartToolbar = FinancialChartToolbar;
    exports.FinancialChartToolbarContext = FinancialChartToolbarContext;
    exports.FinancialChartToolbarViewModel = FinancialChartToolbarViewModel;
    exports.FinancialChartToolbarVisualData = FinancialChartToolbarVisualData;
    exports.FinancialChartType = FinancialChartType;
    exports.FinancialChartTypePicker = FinancialChartTypePicker;
    exports.FinancialChartTypePickerContext = FinancialChartTypePickerContext;
    exports.FinancialChartTypePickerView = FinancialChartTypePickerView;
    exports.FinancialChartTypePickerViewModel = FinancialChartTypePickerViewModel;
    exports.FinancialChartType_$type = FinancialChartType_$type;
    exports.FinancialChartViewModel = FinancialChartViewModel;
    exports.FinancialChartVisualData = FinancialChartVisualData;
    exports.FinancialChartVolumeType = FinancialChartVolumeType;
    exports.FinancialChartVolumeType_$type = FinancialChartVolumeType_$type;
    exports.FinancialChartXAxisMode = FinancialChartXAxisMode;
    exports.FinancialChartXAxisMode_$type = FinancialChartXAxisMode_$type;
    exports.FinancialChartYAxisMode = FinancialChartYAxisMode;
    exports.FinancialChartYAxisMode_$type = FinancialChartYAxisMode_$type;
    exports.FinancialChartZoomSliderType = FinancialChartZoomSliderType;
    exports.FinancialChartZoomSliderType_$type = FinancialChartZoomSliderType_$type;
    exports.FinancialEventArgs = FinancialEventArgs;
    exports.FinancialIndicator = FinancialIndicator;
    exports.FinancialIndicatorBucketCalculator = FinancialIndicatorBucketCalculator;
    exports.FinancialIndicatorType = FinancialIndicatorType;
    exports.FinancialIndicatorTypeCollection = FinancialIndicatorTypeCollection;
    exports.FinancialIndicatorType_$type = FinancialIndicatorType_$type;
    exports.FinancialIndicatorView = FinancialIndicatorView;
    exports.FinancialLegend = FinancialLegend;
    exports.FinancialLegendView = FinancialLegendView;
    exports.FinancialLegendViewManager = FinancialLegendViewManager;
    exports.FinancialOverlay = FinancialOverlay;
    exports.FinancialOverlayType = FinancialOverlayType;
    exports.FinancialOverlayTypeCollection = FinancialOverlayTypeCollection;
    exports.FinancialOverlayType_$type = FinancialOverlayType_$type;
    exports.FinancialPriceBucketCalculator = FinancialPriceBucketCalculator;
    exports.FinancialPriceSeries = FinancialPriceSeries;
    exports.FinancialPriceSeriesProxy = FinancialPriceSeriesProxy;
    exports.FinancialPriceSeriesView = FinancialPriceSeriesView;
    exports.FinancialSeries = FinancialSeries;
    exports.FinancialSeriesView = FinancialSeriesView;
    exports.FinancialValueList = FinancialValueList;
    exports.FlattenedShape = FlattenedShape;
    exports.ForceIndexIndicator = ForceIndexIndicator;
    exports.ForceIndexIndicatorStrategy = ForceIndexIndicatorStrategy;
    exports.FragmentBase = FragmentBase;
    exports.FragmentBaseValueList = FragmentBaseValueList;
    exports.Frame = Frame;
    exports.FrameExtended = FrameExtended;
    exports.FramePreparer = FramePreparer;
    exports.FrameRenderCompleteMessage = FrameRenderCompleteMessage;
    exports.FullStochasticOscillatorIndicator = FullStochasticOscillatorIndicator;
    exports.FullStochasticOscillatorIndicatorStrategy = FullStochasticOscillatorIndicatorStrategy;
    exports.FunnelChartVisualData = FunnelChartVisualData;
    exports.FunnelDataContext = FunnelDataContext;
    exports.FunnelFrame = FunnelFrame;
    exports.FunnelLegendTemplates = FunnelLegendTemplates;
    exports.FunnelSliceClickedEventArgs = FunnelSliceClickedEventArgs;
    exports.FunnelSliceDataContext = FunnelSliceDataContext;
    exports.FunnelSliceDisplay = FunnelSliceDisplay;
    exports.FunnelSliceDisplay_$type = FunnelSliceDisplay_$type;
    exports.FunnelSliceEventArgs = FunnelSliceEventArgs;
    exports.FunnelSliceVisualData = FunnelSliceVisualData;
    exports.FunnelSliceVisualDataList = FunnelSliceVisualDataList;
    exports.GradientData = GradientData;
    exports.GradientStopData = GradientStopData;
    exports.GridMode = GridMode;
    exports.GridMode_$type = GridMode_$type;
    exports.HierarchicalRingSeries = HierarchicalRingSeries;
    exports.HighDensityScatterSeries = HighDensityScatterSeries;
    exports.HighDensityScatterSeriesView = HighDensityScatterSeriesView;
    exports.HighLowValuesHolder = HighLowValuesHolder;
    exports.HighlightingData = HighlightingData;
    exports.HighlightingInfo = HighlightingInfo;
    exports.HighlightingInfoComparer = HighlightingInfoComparer;
    exports.HighlightingManager = HighlightingManager;
    exports.HighlightingMode = HighlightingMode;
    exports.HighlightingMode_$type = HighlightingMode_$type;
    exports.HighlightingState = HighlightingState;
    exports.HighlightingState_$type = HighlightingState_$type;
    exports.HoleDimensionsChangedEventArgs = HoleDimensionsChangedEventArgs;
    exports.HorizontalAnchoredCategorySeries = HorizontalAnchoredCategorySeries;
    exports.HorizontalAnchoredCategorySeriesInteractionManager = HorizontalAnchoredCategorySeriesInteractionManager;
    exports.HorizontalAnchoredCategorySeriesProxy = HorizontalAnchoredCategorySeriesProxy;
    exports.HorizontalAxisLabelPanel = HorizontalAxisLabelPanel;
    exports.HorizontalAxisLabelPanelBase = HorizontalAxisLabelPanelBase;
    exports.HorizontalAxisLabelPanelBaseView = HorizontalAxisLabelPanelBaseView;
    exports.HorizontalAxisView = HorizontalAxisView;
    exports.HorizontalLinearScaler = HorizontalLinearScaler;
    exports.HorizontalLogarithmicScaler = HorizontalLogarithmicScaler;
    exports.HorizontalRangeCategorySeries = HorizontalRangeCategorySeries;
    exports.HorizontalRangeCategorySeriesProxy = HorizontalRangeCategorySeriesProxy;
    exports.HorizontalStackedSeriesBase = HorizontalStackedSeriesBase;
    exports.IAnchoredCategorySeriesInteractionManager_$type = IAnchoredCategorySeriesInteractionManager_$type;
    exports.IAngleScaler_$type = IAngleScaler_$type;
    exports.IAnnotationInfoProvider_$type = IAnnotationInfoProvider_$type;
    exports.IAnnotationLayerProxy_$type = IAnnotationLayerProxy_$type;
    exports.IAxisAnnotationManager_$type = IAxisAnnotationManager_$type;
    exports.IAxisAnnotation_$type = IAxisAnnotation_$type;
    exports.IAxisVisualDataManager_$type = IAxisVisualDataManager_$type;
    exports.IBarSeries_$type = IBarSeries_$type;
    exports.IBucketizer_$type = IBucketizer_$type;
    exports.ICategoryScaler_$type = ICategoryScaler_$type;
    exports.ICategorySeriesInteractionManager_$type = ICategorySeriesInteractionManager_$type;
    exports.IDataChartVisualDataManager_$type = IDataChartVisualDataManager_$type;
    exports.IDateTimeAxis_$type = IDateTimeAxis_$type;
    exports.IDetectsCollisions_$type = IDetectsCollisions_$type;
    exports.IDomainChartWidget_$type = IDomainChartWidget_$type;
    exports.IFinancialPriceSeriesProxy_$type = IFinancialPriceSeriesProxy_$type;
    exports.IFlattener_$type = IFlattener_$type;
    exports.IFunnelLabelSizeDecider_$type = IFunnelLabelSizeDecider_$type;
    exports.IHasCategoryAxis_$type = IHasCategoryAxis_$type;
    exports.IHasCategoryModePreference_$type = IHasCategoryModePreference_$type;
    exports.IHasCategoryTrendline_$type = IHasCategoryTrendline_$type;
    exports.IHasHighLowValueCategory_$type = IHasHighLowValueCategory_$type;
    exports.IHasSingleValueCategory_$type = IHasSingleValueCategory_$type;
    exports.IHasTrendline_$type = IHasTrendline_$type;
    exports.IHighlightingManager_$type = IHighlightingManager_$type;
    exports.IHorizontalAnchoredCategorySeriesInteractionManager_$type = IHorizontalAnchoredCategorySeriesInteractionManager_$type;
    exports.IHorizontalAnchoredCategorySeriesProxy_$type = IHorizontalAnchoredCategorySeriesProxy_$type;
    exports.IHorizontalRangeCategorySeriesProxy_$type = IHorizontalRangeCategorySeriesProxy_$type;
    exports.IIndicatorProxy_$type = IIndicatorProxy_$type;
    exports.IIsCategoryBased_$type = IIsCategoryBased_$type;
    exports.IItemProvider_$type = IItemProvider_$type;
    exports.INumberAbbreviator_$type = INumberAbbreviator_$type;
    exports.IOuterLabelWidthDecider_$type = IOuterLabelWidthDecider_$type;
    exports.IOverlayProxy_$type = IOverlayProxy_$type;
    exports.IPolarRadialRenderingParameters_$type = IPolarRadialRenderingParameters_$type;
    exports.IPreparesCategoryTrendline_$type = IPreparesCategoryTrendline_$type;
    exports.IProvidesViewport_$type = IProvidesViewport_$type;
    exports.IScaler_$type = IScaler_$type;
    exports.ISeriesInteractionManager_$type = ISeriesInteractionManager_$type;
    exports.ISeriesViewerInteractionManager_$type = ISeriesViewerInteractionManager_$type;
    exports.ISeriesViewerWidgetOptions_$type = ISeriesViewerWidgetOptions_$type;
    exports.ISeriesViewerWidget_$type = ISeriesViewerWidget_$type;
    exports.ISeriesVisualDataManager_$type = ISeriesVisualDataManager_$type;
    exports.IShortPeriodLongPeriod_$type = IShortPeriodLongPeriod_$type;
    exports.ISortingAxis_$type = ISortingAxis_$type;
    exports.IStacked100Series_$type = IStacked100Series_$type;
    exports.ISupportsErrorBars_$type = ISupportsErrorBars_$type;
    exports.ISupportsFillScale_$type = ISupportsFillScale_$type;
    exports.ISupportsMarkers_$type = ISupportsMarkers_$type;
    exports.ISupportsSizeScale_$type = ISupportsSizeScale_$type;
    exports.ITileZoomTileInfo_$type = ITileZoomTileInfo_$type;
    exports.ITileZoomTile_$type = ITileZoomTile_$type;
    exports.ITimeRangeSelectorAxis_$type = ITimeRangeSelectorAxis_$type;
    exports.ITimeXAxis_$type = ITimeXAxis_$type;
    exports.ITrackBarVisual_$type = ITrackBarVisual_$type;
    exports.ITrackOwner_$type = ITrackOwner_$type;
    exports.ITrackRangeVisual_$type = ITrackRangeVisual_$type;
    exports.ITrackShadeVisual_$type = ITrackShadeVisual_$type;
    exports.ITrackThumbCalloutVisual_$type = ITrackThumbCalloutVisual_$type;
    exports.ITrackThumbVisual_$type = ITrackThumbVisual_$type;
    exports.ITrendLineManager_$type = ITrendLineManager_$type;
    exports.ITrendLineSeries_$type = ITrendLineSeries_$type;
    exports.IVerticalAnchoredCategorySeriesInteractionManager_$type = IVerticalAnchoredCategorySeriesInteractionManager_$type;
    exports.IgQueue$1 = IgQueue$1;
    exports.IgxAbsoluteVolumeOscillatorIndicatorComponent = IgxAbsoluteVolumeOscillatorIndicatorComponent;
    exports.IgxAbsoluteVolumeOscillatorIndicatorDynamicModule = IgxAbsoluteVolumeOscillatorIndicatorDynamicModule;
    exports.IgxAbsoluteVolumeOscillatorIndicatorModule = IgxAbsoluteVolumeOscillatorIndicatorModule;
    exports.IgxAccumulationDistributionIndicatorComponent = IgxAccumulationDistributionIndicatorComponent;
    exports.IgxAccumulationDistributionIndicatorDynamicModule = IgxAccumulationDistributionIndicatorDynamicModule;
    exports.IgxAccumulationDistributionIndicatorModule = IgxAccumulationDistributionIndicatorModule;
    exports.IgxAnchoredCategorySeriesComponent = IgxAnchoredCategorySeriesComponent;
    exports.IgxAnchoredRadialSeriesComponent = IgxAnchoredRadialSeriesComponent;
    exports.IgxAnnotationLayerComponent = IgxAnnotationLayerComponent;
    exports.IgxAnnotationLayerProxyDynamicModule = IgxAnnotationLayerProxyDynamicModule;
    exports.IgxAnnotationLayerProxyModule = IgxAnnotationLayerProxyModule;
    exports.IgxAreaFragmentComponent = IgxAreaFragmentComponent;
    exports.IgxAreaFragmentDynamicModule = IgxAreaFragmentDynamicModule;
    exports.IgxAreaFragmentModule = IgxAreaFragmentModule;
    exports.IgxAreaSeriesComponent = IgxAreaSeriesComponent;
    exports.IgxAreaSeriesDynamicModule = IgxAreaSeriesDynamicModule;
    exports.IgxAreaSeriesModule = IgxAreaSeriesModule;
    exports.IgxAssigningCategoryMarkerStyleEventArgs = IgxAssigningCategoryMarkerStyleEventArgs;
    exports.IgxAssigningCategoryStyleEventArgs = IgxAssigningCategoryStyleEventArgs;
    exports.IgxAssigningCategoryStyleEventArgsBase = IgxAssigningCategoryStyleEventArgsBase;
    exports.IgxAssigningPolarMarkerStyleEventArgs = IgxAssigningPolarMarkerStyleEventArgs;
    exports.IgxAssigningPolarStyleEventArgs = IgxAssigningPolarStyleEventArgs;
    exports.IgxAssigningPolarStyleEventArgsBase = IgxAssigningPolarStyleEventArgsBase;
    exports.IgxAssigningRadialMarkerStyleEventArgs = IgxAssigningRadialMarkerStyleEventArgs;
    exports.IgxAssigningRadialStyleEventArgs = IgxAssigningRadialStyleEventArgs;
    exports.IgxAssigningRadialStyleEventArgsBase = IgxAssigningRadialStyleEventArgsBase;
    exports.IgxAssigningScatterMarkerStyleEventArgs = IgxAssigningScatterMarkerStyleEventArgs;
    exports.IgxAssigningScatterStyleEventArgs = IgxAssigningScatterStyleEventArgs;
    exports.IgxAssigningScatterStyleEventArgsBase = IgxAssigningScatterStyleEventArgsBase;
    exports.IgxAssigningSeriesShapeStyleEventArgsBase = IgxAssigningSeriesShapeStyleEventArgsBase;
    exports.IgxAssigningSeriesStyleEventArgsBase = IgxAssigningSeriesStyleEventArgsBase;
    exports.IgxAssigningShapeMarkerStyleEventArgs = IgxAssigningShapeMarkerStyleEventArgs;
    exports.IgxAssigningShapeStyleEventArgs = IgxAssigningShapeStyleEventArgs;
    exports.IgxAssigningShapeStyleEventArgsBase = IgxAssigningShapeStyleEventArgsBase;
    exports.IgxAverageDirectionalIndexIndicatorComponent = IgxAverageDirectionalIndexIndicatorComponent;
    exports.IgxAverageDirectionalIndexIndicatorDynamicModule = IgxAverageDirectionalIndexIndicatorDynamicModule;
    exports.IgxAverageDirectionalIndexIndicatorModule = IgxAverageDirectionalIndexIndicatorModule;
    exports.IgxAverageTrueRangeIndicatorComponent = IgxAverageTrueRangeIndicatorComponent;
    exports.IgxAverageTrueRangeIndicatorDynamicModule = IgxAverageTrueRangeIndicatorDynamicModule;
    exports.IgxAverageTrueRangeIndicatorModule = IgxAverageTrueRangeIndicatorModule;
    exports.IgxAxisAnnotation = IgxAxisAnnotation;
    exports.IgxAxisAnnotationCollection = IgxAxisAnnotationCollection;
    exports.IgxAxisCollection = IgxAxisCollection;
    exports.IgxAxisComponent = IgxAxisComponent;
    exports.IgxAxisRangeChangedEventArgs = IgxAxisRangeChangedEventArgs;
    exports.IgxBarFragmentComponent = IgxBarFragmentComponent;
    exports.IgxBarFragmentDynamicModule = IgxBarFragmentDynamicModule;
    exports.IgxBarFragmentModule = IgxBarFragmentModule;
    exports.IgxBarSeriesComponent = IgxBarSeriesComponent;
    exports.IgxBarSeriesDynamicModule = IgxBarSeriesDynamicModule;
    exports.IgxBarSeriesModule = IgxBarSeriesModule;
    exports.IgxBollingerBandWidthIndicatorComponent = IgxBollingerBandWidthIndicatorComponent;
    exports.IgxBollingerBandWidthIndicatorDynamicModule = IgxBollingerBandWidthIndicatorDynamicModule;
    exports.IgxBollingerBandWidthIndicatorModule = IgxBollingerBandWidthIndicatorModule;
    exports.IgxBollingerBandsOverlayComponent = IgxBollingerBandsOverlayComponent;
    exports.IgxBollingerBandsOverlayDynamicModule = IgxBollingerBandsOverlayDynamicModule;
    exports.IgxBollingerBandsOverlayModule = IgxBollingerBandsOverlayModule;
    exports.IgxBrushScaleComponent = IgxBrushScaleComponent;
    exports.IgxBrushScaleDynamicModule = IgxBrushScaleDynamicModule;
    exports.IgxBrushScaleModule = IgxBrushScaleModule;
    exports.IgxBubbleSeriesComponent = IgxBubbleSeriesComponent;
    exports.IgxBubbleSeriesDynamicModule = IgxBubbleSeriesDynamicModule;
    exports.IgxBubbleSeriesModule = IgxBubbleSeriesModule;
    exports.IgxCalculatedColumn = IgxCalculatedColumn;
    exports.IgxCalloutAnnotation = IgxCalloutAnnotation;
    exports.IgxCalloutAnnotationCollection = IgxCalloutAnnotationCollection;
    exports.IgxCalloutContentUpdatingEventArgs = IgxCalloutContentUpdatingEventArgs;
    exports.IgxCalloutLabelUpdatingEventArgs = IgxCalloutLabelUpdatingEventArgs;
    exports.IgxCalloutLayerComponent = IgxCalloutLayerComponent;
    exports.IgxCalloutLayerDynamicModule = IgxCalloutLayerDynamicModule;
    exports.IgxCalloutLayerModule = IgxCalloutLayerModule;
    exports.IgxCalloutSeriesSelectingEventArgs = IgxCalloutSeriesSelectingEventArgs;
    exports.IgxCalloutStyleUpdatingEventArgs = IgxCalloutStyleUpdatingEventArgs;
    exports.IgxCategoryAngleAxisComponent = IgxCategoryAngleAxisComponent;
    exports.IgxCategoryAngleAxisDynamicModule = IgxCategoryAngleAxisDynamicModule;
    exports.IgxCategoryAngleAxisModule = IgxCategoryAngleAxisModule;
    exports.IgxCategoryAxisBaseComponent = IgxCategoryAxisBaseComponent;
    exports.IgxCategoryChartComponent = IgxCategoryChartComponent;
    exports.IgxCategoryChartCoreDynamicModule = IgxCategoryChartCoreDynamicModule;
    exports.IgxCategoryChartCoreModule = IgxCategoryChartCoreModule;
    exports.IgxCategoryChartDynamicModule = IgxCategoryChartDynamicModule;
    exports.IgxCategoryChartModule = IgxCategoryChartModule;
    exports.IgxCategoryDateTimeXAxisComponent = IgxCategoryDateTimeXAxisComponent;
    exports.IgxCategoryDateTimeXAxisDynamicModule = IgxCategoryDateTimeXAxisDynamicModule;
    exports.IgxCategoryDateTimeXAxisModule = IgxCategoryDateTimeXAxisModule;
    exports.IgxCategoryHighlightLayerComponent = IgxCategoryHighlightLayerComponent;
    exports.IgxCategoryHighlightLayerDynamicModule = IgxCategoryHighlightLayerDynamicModule;
    exports.IgxCategoryHighlightLayerModule = IgxCategoryHighlightLayerModule;
    exports.IgxCategoryItemHighlightLayerComponent = IgxCategoryItemHighlightLayerComponent;
    exports.IgxCategoryItemHighlightLayerDynamicModule = IgxCategoryItemHighlightLayerDynamicModule;
    exports.IgxCategoryItemHighlightLayerModule = IgxCategoryItemHighlightLayerModule;
    exports.IgxCategorySeriesComponent = IgxCategorySeriesComponent;
    exports.IgxCategoryToolTipLayerComponent = IgxCategoryToolTipLayerComponent;
    exports.IgxCategoryToolTipLayerDynamicModule = IgxCategoryToolTipLayerDynamicModule;
    exports.IgxCategoryToolTipLayerModule = IgxCategoryToolTipLayerModule;
    exports.IgxCategoryXAxisComponent = IgxCategoryXAxisComponent;
    exports.IgxCategoryXAxisDynamicModule = IgxCategoryXAxisDynamicModule;
    exports.IgxCategoryXAxisModule = IgxCategoryXAxisModule;
    exports.IgxCategoryYAxisComponent = IgxCategoryYAxisComponent;
    exports.IgxCategoryYAxisDynamicModule = IgxCategoryYAxisDynamicModule;
    exports.IgxCategoryYAxisModule = IgxCategoryYAxisModule;
    exports.IgxChaikinOscillatorIndicatorComponent = IgxChaikinOscillatorIndicatorComponent;
    exports.IgxChaikinOscillatorIndicatorDynamicModule = IgxChaikinOscillatorIndicatorDynamicModule;
    exports.IgxChaikinOscillatorIndicatorModule = IgxChaikinOscillatorIndicatorModule;
    exports.IgxChaikinVolatilityIndicatorComponent = IgxChaikinVolatilityIndicatorComponent;
    exports.IgxChaikinVolatilityIndicatorDynamicModule = IgxChaikinVolatilityIndicatorDynamicModule;
    exports.IgxChaikinVolatilityIndicatorModule = IgxChaikinVolatilityIndicatorModule;
    exports.IgxChartCursorEventArgs = IgxChartCursorEventArgs;
    exports.IgxChartMouseEventArgs = IgxChartMouseEventArgs;
    exports.IgxChartSeriesEventArgs = IgxChartSeriesEventArgs;
    exports.IgxColorScaleComponent = IgxColorScaleComponent;
    exports.IgxColumnFragmentComponent = IgxColumnFragmentComponent;
    exports.IgxColumnFragmentDynamicModule = IgxColumnFragmentDynamicModule;
    exports.IgxColumnFragmentModule = IgxColumnFragmentModule;
    exports.IgxColumnSeriesComponent = IgxColumnSeriesComponent;
    exports.IgxColumnSeriesDynamicModule = IgxColumnSeriesDynamicModule;
    exports.IgxColumnSeriesModule = IgxColumnSeriesModule;
    exports.IgxColumnSupportingCalculation = IgxColumnSupportingCalculation;
    exports.IgxCommodityChannelIndexIndicatorComponent = IgxCommodityChannelIndexIndicatorComponent;
    exports.IgxCommodityChannelIndexIndicatorDynamicModule = IgxCommodityChannelIndexIndicatorDynamicModule;
    exports.IgxCommodityChannelIndexIndicatorModule = IgxCommodityChannelIndexIndicatorModule;
    exports.IgxContourValueResolverComponent = IgxContourValueResolverComponent;
    exports.IgxCrosshairLayerComponent = IgxCrosshairLayerComponent;
    exports.IgxCrosshairLayerDynamicModule = IgxCrosshairLayerDynamicModule;
    exports.IgxCrosshairLayerModule = IgxCrosshairLayerModule;
    exports.IgxCustomContourValueResolverComponent = IgxCustomContourValueResolverComponent;
    exports.IgxCustomContourValueResolverDynamicModule = IgxCustomContourValueResolverDynamicModule;
    exports.IgxCustomContourValueResolverEventArgs = IgxCustomContourValueResolverEventArgs;
    exports.IgxCustomContourValueResolverModule = IgxCustomContourValueResolverModule;
    exports.IgxCustomIndicatorComponent = IgxCustomIndicatorComponent;
    exports.IgxCustomIndicatorDynamicModule = IgxCustomIndicatorDynamicModule;
    exports.IgxCustomIndicatorModule = IgxCustomIndicatorModule;
    exports.IgxCustomIndicatorNameCollection = IgxCustomIndicatorNameCollection;
    exports.IgxCustomPaletteBrushScaleComponent = IgxCustomPaletteBrushScaleComponent;
    exports.IgxCustomPaletteBrushScaleDynamicModule = IgxCustomPaletteBrushScaleDynamicModule;
    exports.IgxCustomPaletteBrushScaleModule = IgxCustomPaletteBrushScaleModule;
    exports.IgxCustomPaletteColorScaleComponent = IgxCustomPaletteColorScaleComponent;
    exports.IgxCustomPaletteColorScaleDynamicModule = IgxCustomPaletteColorScaleDynamicModule;
    exports.IgxCustomPaletteColorScaleModule = IgxCustomPaletteColorScaleModule;
    exports.IgxDataChartAnnotationDynamicModule = IgxDataChartAnnotationDynamicModule;
    exports.IgxDataChartAnnotationModule = IgxDataChartAnnotationModule;
    exports.IgxDataChartCategoryCoreDynamicModule = IgxDataChartCategoryCoreDynamicModule;
    exports.IgxDataChartCategoryCoreModule = IgxDataChartCategoryCoreModule;
    exports.IgxDataChartCategoryDynamicModule = IgxDataChartCategoryDynamicModule;
    exports.IgxDataChartCategoryModule = IgxDataChartCategoryModule;
    exports.IgxDataChartCategoryTrendLineDynamicModule = IgxDataChartCategoryTrendLineDynamicModule;
    exports.IgxDataChartCategoryTrendLineModule = IgxDataChartCategoryTrendLineModule;
    exports.IgxDataChartComponent = IgxDataChartComponent;
    exports.IgxDataChartCoreDynamicModule = IgxDataChartCoreDynamicModule;
    exports.IgxDataChartCoreModule = IgxDataChartCoreModule;
    exports.IgxDataChartDefaultTooltipsComponent = IgxDataChartDefaultTooltipsComponent;
    exports.IgxDataChartExtendedAxesDynamicModule = IgxDataChartExtendedAxesDynamicModule;
    exports.IgxDataChartExtendedAxesModule = IgxDataChartExtendedAxesModule;
    exports.IgxDataChartFinancialCoreDynamicModule = IgxDataChartFinancialCoreDynamicModule;
    exports.IgxDataChartFinancialCoreModule = IgxDataChartFinancialCoreModule;
    exports.IgxDataChartFinancialDynamicModule = IgxDataChartFinancialDynamicModule;
    exports.IgxDataChartFinancialIndicatorsDynamicModule = IgxDataChartFinancialIndicatorsDynamicModule;
    exports.IgxDataChartFinancialIndicatorsModule = IgxDataChartFinancialIndicatorsModule;
    exports.IgxDataChartFinancialModule = IgxDataChartFinancialModule;
    exports.IgxDataChartFinancialOverlaysDynamicModule = IgxDataChartFinancialOverlaysDynamicModule;
    exports.IgxDataChartFinancialOverlaysModule = IgxDataChartFinancialOverlaysModule;
    exports.IgxDataChartInteractivityDynamicModule = IgxDataChartInteractivityDynamicModule;
    exports.IgxDataChartInteractivityModule = IgxDataChartInteractivityModule;
    exports.IgxDataChartMouseButtonEventArgs = IgxDataChartMouseButtonEventArgs;
    exports.IgxDataChartPolarCoreDynamicModule = IgxDataChartPolarCoreDynamicModule;
    exports.IgxDataChartPolarCoreModule = IgxDataChartPolarCoreModule;
    exports.IgxDataChartPolarDynamicModule = IgxDataChartPolarDynamicModule;
    exports.IgxDataChartPolarModule = IgxDataChartPolarModule;
    exports.IgxDataChartRadialCoreDynamicModule = IgxDataChartRadialCoreDynamicModule;
    exports.IgxDataChartRadialCoreModule = IgxDataChartRadialCoreModule;
    exports.IgxDataChartRadialDynamicModule = IgxDataChartRadialDynamicModule;
    exports.IgxDataChartRadialModule = IgxDataChartRadialModule;
    exports.IgxDataChartScatterCoreDynamicModule = IgxDataChartScatterCoreDynamicModule;
    exports.IgxDataChartScatterCoreModule = IgxDataChartScatterCoreModule;
    exports.IgxDataChartScatterDynamicModule = IgxDataChartScatterDynamicModule;
    exports.IgxDataChartScatterModule = IgxDataChartScatterModule;
    exports.IgxDataChartShapeCoreDynamicModule = IgxDataChartShapeCoreDynamicModule;
    exports.IgxDataChartShapeCoreModule = IgxDataChartShapeCoreModule;
    exports.IgxDataChartShapeDynamicModule = IgxDataChartShapeDynamicModule;
    exports.IgxDataChartShapeModule = IgxDataChartShapeModule;
    exports.IgxDataChartStackedDynamicModule = IgxDataChartStackedDynamicModule;
    exports.IgxDataChartStackedModule = IgxDataChartStackedModule;
    exports.IgxDataChartVerticalCategoryCoreDynamicModule = IgxDataChartVerticalCategoryCoreDynamicModule;
    exports.IgxDataChartVerticalCategoryCoreModule = IgxDataChartVerticalCategoryCoreModule;
    exports.IgxDataChartVerticalCategoryDynamicModule = IgxDataChartVerticalCategoryDynamicModule;
    exports.IgxDataChartVerticalCategoryModule = IgxDataChartVerticalCategoryModule;
    exports.IgxDataChartVisualDataDynamicModule = IgxDataChartVisualDataDynamicModule;
    exports.IgxDataChartVisualDataModule = IgxDataChartVisualDataModule;
    exports.IgxDataSourceSupportingCalculation = IgxDataSourceSupportingCalculation;
    exports.IgxDetrendedPriceOscillatorIndicatorComponent = IgxDetrendedPriceOscillatorIndicatorComponent;
    exports.IgxDetrendedPriceOscillatorIndicatorDynamicModule = IgxDetrendedPriceOscillatorIndicatorDynamicModule;
    exports.IgxDetrendedPriceOscillatorIndicatorModule = IgxDetrendedPriceOscillatorIndicatorModule;
    exports.IgxDomainChartComponent = IgxDomainChartComponent;
    exports.IgxDomainChartSeriesPointerEventArgs = IgxDomainChartSeriesPointerEventArgs;
    exports.IgxDoughnutChartComponent = IgxDoughnutChartComponent;
    exports.IgxDoughnutChartCoreDynamicModule = IgxDoughnutChartCoreDynamicModule;
    exports.IgxDoughnutChartCoreModule = IgxDoughnutChartCoreModule;
    exports.IgxDoughnutChartDefaultTooltipsComponent = IgxDoughnutChartDefaultTooltipsComponent;
    exports.IgxDoughnutChartDynamicModule = IgxDoughnutChartDynamicModule;
    exports.IgxDoughnutChartInteractivityDynamicModule = IgxDoughnutChartInteractivityDynamicModule;
    exports.IgxDoughnutChartInteractivityModule = IgxDoughnutChartInteractivityModule;
    exports.IgxDoughnutChartModule = IgxDoughnutChartModule;
    exports.IgxEaseOfMovementIndicatorComponent = IgxEaseOfMovementIndicatorComponent;
    exports.IgxEaseOfMovementIndicatorDynamicModule = IgxEaseOfMovementIndicatorDynamicModule;
    exports.IgxEaseOfMovementIndicatorModule = IgxEaseOfMovementIndicatorModule;
    exports.IgxFastStochasticOscillatorIndicatorComponent = IgxFastStochasticOscillatorIndicatorComponent;
    exports.IgxFastStochasticOscillatorIndicatorDynamicModule = IgxFastStochasticOscillatorIndicatorDynamicModule;
    exports.IgxFastStochasticOscillatorIndicatorModule = IgxFastStochasticOscillatorIndicatorModule;
    exports.IgxFinalValueLayerComponent = IgxFinalValueLayerComponent;
    exports.IgxFinalValueLayerDynamicModule = IgxFinalValueLayerDynamicModule;
    exports.IgxFinalValueLayerModule = IgxFinalValueLayerModule;
    exports.IgxFinancialCalculationDataSource = IgxFinancialCalculationDataSource;
    exports.IgxFinancialCalculationSupportingCalculations = IgxFinancialCalculationSupportingCalculations;
    exports.IgxFinancialChartComponent = IgxFinancialChartComponent;
    exports.IgxFinancialChartCoreDynamicModule = IgxFinancialChartCoreDynamicModule;
    exports.IgxFinancialChartCoreModule = IgxFinancialChartCoreModule;
    exports.IgxFinancialChartCustomIndicatorArgs = IgxFinancialChartCustomIndicatorArgs;
    exports.IgxFinancialChartDefaultTemplatesComponent = IgxFinancialChartDefaultTemplatesComponent;
    exports.IgxFinancialChartDynamicModule = IgxFinancialChartDynamicModule;
    exports.IgxFinancialChartModule = IgxFinancialChartModule;
    exports.IgxFinancialChartRangeSelectorOptionCollection = IgxFinancialChartRangeSelectorOptionCollection;
    exports.IgxFinancialEventArgs = IgxFinancialEventArgs;
    exports.IgxFinancialIndicatorComponent = IgxFinancialIndicatorComponent;
    exports.IgxFinancialIndicatorTypeCollection = IgxFinancialIndicatorTypeCollection;
    exports.IgxFinancialLegendComponent = IgxFinancialLegendComponent;
    exports.IgxFinancialLegendDynamicModule = IgxFinancialLegendDynamicModule;
    exports.IgxFinancialLegendModule = IgxFinancialLegendModule;
    exports.IgxFinancialOverlayComponent = IgxFinancialOverlayComponent;
    exports.IgxFinancialOverlayTypeCollection = IgxFinancialOverlayTypeCollection;
    exports.IgxFinancialPriceSeriesComponent = IgxFinancialPriceSeriesComponent;
    exports.IgxFinancialPriceSeriesDynamicModule = IgxFinancialPriceSeriesDynamicModule;
    exports.IgxFinancialPriceSeriesModule = IgxFinancialPriceSeriesModule;
    exports.IgxFinancialPriceSeriesProxyDynamicModule = IgxFinancialPriceSeriesProxyDynamicModule;
    exports.IgxFinancialPriceSeriesProxyModule = IgxFinancialPriceSeriesProxyModule;
    exports.IgxFinancialSeriesComponent = IgxFinancialSeriesComponent;
    exports.IgxForceIndexIndicatorComponent = IgxForceIndexIndicatorComponent;
    exports.IgxForceIndexIndicatorDynamicModule = IgxForceIndexIndicatorDynamicModule;
    exports.IgxForceIndexIndicatorModule = IgxForceIndexIndicatorModule;
    exports.IgxFragmentBaseComponent = IgxFragmentBaseComponent;
    exports.IgxFullStochasticOscillatorIndicatorComponent = IgxFullStochasticOscillatorIndicatorComponent;
    exports.IgxFullStochasticOscillatorIndicatorDynamicModule = IgxFullStochasticOscillatorIndicatorDynamicModule;
    exports.IgxFullStochasticOscillatorIndicatorModule = IgxFullStochasticOscillatorIndicatorModule;
    exports.IgxFunnelChartComponent = IgxFunnelChartComponent;
    exports.IgxFunnelChartCoreDynamicModule = IgxFunnelChartCoreDynamicModule;
    exports.IgxFunnelChartCoreModule = IgxFunnelChartCoreModule;
    exports.IgxFunnelChartDynamicModule = IgxFunnelChartDynamicModule;
    exports.IgxFunnelChartModule = IgxFunnelChartModule;
    exports.IgxFunnelDataContext = IgxFunnelDataContext;
    exports.IgxFunnelSliceClickedEventArgs = IgxFunnelSliceClickedEventArgs;
    exports.IgxFunnelSliceDataContext = IgxFunnelSliceDataContext;
    exports.IgxFunnelSliceEventArgs = IgxFunnelSliceEventArgs;
    exports.IgxHierarchicalRingSeriesComponent = IgxHierarchicalRingSeriesComponent;
    exports.IgxHierarchicalRingSeriesDynamicModule = IgxHierarchicalRingSeriesDynamicModule;
    exports.IgxHierarchicalRingSeriesModule = IgxHierarchicalRingSeriesModule;
    exports.IgxHighDensityScatterSeriesComponent = IgxHighDensityScatterSeriesComponent;
    exports.IgxHighDensityScatterSeriesDynamicModule = IgxHighDensityScatterSeriesDynamicModule;
    exports.IgxHighDensityScatterSeriesModule = IgxHighDensityScatterSeriesModule;
    exports.IgxHighlightingInfo = IgxHighlightingInfo;
    exports.IgxHoleDimensionsChangedEventArgs = IgxHoleDimensionsChangedEventArgs;
    exports.IgxHorizontalAnchoredCategorySeriesComponent = IgxHorizontalAnchoredCategorySeriesComponent;
    exports.IgxHorizontalAnchoredCategorySeriesProxyDynamicModule = IgxHorizontalAnchoredCategorySeriesProxyDynamicModule;
    exports.IgxHorizontalAnchoredCategorySeriesProxyModule = IgxHorizontalAnchoredCategorySeriesProxyModule;
    exports.IgxHorizontalRangeCategorySeriesComponent = IgxHorizontalRangeCategorySeriesComponent;
    exports.IgxHorizontalRangeCategorySeriesProxyDynamicModule = IgxHorizontalRangeCategorySeriesProxyDynamicModule;
    exports.IgxHorizontalRangeCategorySeriesProxyModule = IgxHorizontalRangeCategorySeriesProxyModule;
    exports.IgxHorizontalStackedSeriesBaseComponent = IgxHorizontalStackedSeriesBaseComponent;
    exports.IgxIndexCollection = IgxIndexCollection;
    exports.IgxIndicatorDisplayTypeCollection = IgxIndicatorDisplayTypeCollection;
    exports.IgxIndicatorProxyDynamicModule = IgxIndicatorProxyDynamicModule;
    exports.IgxIndicatorProxyModule = IgxIndicatorProxyModule;
    exports.IgxIndicatorsDynamicModule = IgxIndicatorsDynamicModule;
    exports.IgxIndicatorsModule = IgxIndicatorsModule;
    exports.IgxItemLegendComponent = IgxItemLegendComponent;
    exports.IgxItemLegendDynamicModule = IgxItemLegendDynamicModule;
    exports.IgxItemLegendModule = IgxItemLegendModule;
    exports.IgxItemToolTipLayerComponent = IgxItemToolTipLayerComponent;
    exports.IgxItemToolTipLayerDynamicModule = IgxItemToolTipLayerDynamicModule;
    exports.IgxItemToolTipLayerModule = IgxItemToolTipLayerModule;
    exports.IgxItemwiseStrategyBasedIndicatorComponent = IgxItemwiseStrategyBasedIndicatorComponent;
    exports.IgxLabelClickEventArgs = IgxLabelClickEventArgs;
    exports.IgxLegendBaseComponent = IgxLegendBaseComponent;
    exports.IgxLegendComponent = IgxLegendComponent;
    exports.IgxLegendDynamicModule = IgxLegendDynamicModule;
    exports.IgxLegendModule = IgxLegendModule;
    exports.IgxLegendMouseButtonEventArgs = IgxLegendMouseButtonEventArgs;
    exports.IgxLegendMouseEventArgs = IgxLegendMouseEventArgs;
    exports.IgxLineFragmentComponent = IgxLineFragmentComponent;
    exports.IgxLineFragmentDynamicModule = IgxLineFragmentDynamicModule;
    exports.IgxLineFragmentModule = IgxLineFragmentModule;
    exports.IgxLineSeriesComponent = IgxLineSeriesComponent;
    exports.IgxLineSeriesDynamicModule = IgxLineSeriesDynamicModule;
    exports.IgxLineSeriesModule = IgxLineSeriesModule;
    exports.IgxLinearContourValueResolverComponent = IgxLinearContourValueResolverComponent;
    exports.IgxLinearContourValueResolverDynamicModule = IgxLinearContourValueResolverDynamicModule;
    exports.IgxLinearContourValueResolverModule = IgxLinearContourValueResolverModule;
    exports.IgxMarkerSeriesComponent = IgxMarkerSeriesComponent;
    exports.IgxMarkerTypeCollection = IgxMarkerTypeCollection;
    exports.IgxMarketFacilitationIndexIndicatorComponent = IgxMarketFacilitationIndexIndicatorComponent;
    exports.IgxMarketFacilitationIndexIndicatorDynamicModule = IgxMarketFacilitationIndexIndicatorDynamicModule;
    exports.IgxMarketFacilitationIndexIndicatorModule = IgxMarketFacilitationIndexIndicatorModule;
    exports.IgxMassIndexIndicatorComponent = IgxMassIndexIndicatorComponent;
    exports.IgxMassIndexIndicatorDynamicModule = IgxMassIndexIndicatorDynamicModule;
    exports.IgxMassIndexIndicatorModule = IgxMassIndexIndicatorModule;
    exports.IgxMedianPriceIndicatorComponent = IgxMedianPriceIndicatorComponent;
    exports.IgxMedianPriceIndicatorDynamicModule = IgxMedianPriceIndicatorDynamicModule;
    exports.IgxMedianPriceIndicatorModule = IgxMedianPriceIndicatorModule;
    exports.IgxMoneyFlowIndexIndicatorComponent = IgxMoneyFlowIndexIndicatorComponent;
    exports.IgxMoneyFlowIndexIndicatorDynamicModule = IgxMoneyFlowIndexIndicatorDynamicModule;
    exports.IgxMoneyFlowIndexIndicatorModule = IgxMoneyFlowIndexIndicatorModule;
    exports.IgxMovingAverageConvergenceDivergenceIndicatorComponent = IgxMovingAverageConvergenceDivergenceIndicatorComponent;
    exports.IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule = IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule;
    exports.IgxMovingAverageConvergenceDivergenceIndicatorModule = IgxMovingAverageConvergenceDivergenceIndicatorModule;
    exports.IgxNegativeVolumeIndexIndicatorComponent = IgxNegativeVolumeIndexIndicatorComponent;
    exports.IgxNegativeVolumeIndexIndicatorDynamicModule = IgxNegativeVolumeIndexIndicatorDynamicModule;
    exports.IgxNegativeVolumeIndexIndicatorModule = IgxNegativeVolumeIndexIndicatorModule;
    exports.IgxNumberAbbreviatorDynamicModule = IgxNumberAbbreviatorDynamicModule;
    exports.IgxNumberAbbreviatorModule = IgxNumberAbbreviatorModule;
    exports.IgxNumericAngleAxisComponent = IgxNumericAngleAxisComponent;
    exports.IgxNumericAngleAxisDynamicModule = IgxNumericAngleAxisDynamicModule;
    exports.IgxNumericAngleAxisModule = IgxNumericAngleAxisModule;
    exports.IgxNumericAxisBaseComponent = IgxNumericAxisBaseComponent;
    exports.IgxNumericRadiusAxisComponent = IgxNumericRadiusAxisComponent;
    exports.IgxNumericRadiusAxisDynamicModule = IgxNumericRadiusAxisDynamicModule;
    exports.IgxNumericRadiusAxisModule = IgxNumericRadiusAxisModule;
    exports.IgxNumericXAxisComponent = IgxNumericXAxisComponent;
    exports.IgxNumericXAxisDynamicModule = IgxNumericXAxisDynamicModule;
    exports.IgxNumericXAxisModule = IgxNumericXAxisModule;
    exports.IgxNumericYAxisComponent = IgxNumericYAxisComponent;
    exports.IgxNumericYAxisDynamicModule = IgxNumericYAxisDynamicModule;
    exports.IgxNumericYAxisModule = IgxNumericYAxisModule;
    exports.IgxOnBalanceVolumeIndicatorComponent = IgxOnBalanceVolumeIndicatorComponent;
    exports.IgxOnBalanceVolumeIndicatorDynamicModule = IgxOnBalanceVolumeIndicatorDynamicModule;
    exports.IgxOnBalanceVolumeIndicatorModule = IgxOnBalanceVolumeIndicatorModule;
    exports.IgxOrdinalTimeXAxisComponent = IgxOrdinalTimeXAxisComponent;
    exports.IgxOrdinalTimeXAxisDynamicModule = IgxOrdinalTimeXAxisDynamicModule;
    exports.IgxOrdinalTimeXAxisModule = IgxOrdinalTimeXAxisModule;
    exports.IgxOverlayProxyDynamicModule = IgxOverlayProxyDynamicModule;
    exports.IgxOverlayProxyModule = IgxOverlayProxyModule;
    exports.IgxOverlaysDynamicModule = IgxOverlaysDynamicModule;
    exports.IgxOverlaysModule = IgxOverlaysModule;
    exports.IgxPercentChangeYAxisComponent = IgxPercentChangeYAxisComponent;
    exports.IgxPercentChangeYAxisDynamicModule = IgxPercentChangeYAxisDynamicModule;
    exports.IgxPercentChangeYAxisModule = IgxPercentChangeYAxisModule;
    exports.IgxPercentagePriceOscillatorIndicatorComponent = IgxPercentagePriceOscillatorIndicatorComponent;
    exports.IgxPercentagePriceOscillatorIndicatorDynamicModule = IgxPercentagePriceOscillatorIndicatorDynamicModule;
    exports.IgxPercentagePriceOscillatorIndicatorModule = IgxPercentagePriceOscillatorIndicatorModule;
    exports.IgxPercentageVolumeOscillatorIndicatorComponent = IgxPercentageVolumeOscillatorIndicatorComponent;
    exports.IgxPercentageVolumeOscillatorIndicatorDynamicModule = IgxPercentageVolumeOscillatorIndicatorDynamicModule;
    exports.IgxPercentageVolumeOscillatorIndicatorModule = IgxPercentageVolumeOscillatorIndicatorModule;
    exports.IgxPieChartBaseComponent = IgxPieChartBaseComponent;
    exports.IgxPieChartComponent = IgxPieChartComponent;
    exports.IgxPieChartCoreDynamicModule = IgxPieChartCoreDynamicModule;
    exports.IgxPieChartCoreModule = IgxPieChartCoreModule;
    exports.IgxPieChartDynamicModule = IgxPieChartDynamicModule;
    exports.IgxPieChartModule = IgxPieChartModule;
    exports.IgxPieSliceDataContext = IgxPieSliceDataContext;
    exports.IgxPieSliceOthersContext = IgxPieSliceOthersContext;
    exports.IgxPlotAreaMouseButtonEventArgs = IgxPlotAreaMouseButtonEventArgs;
    exports.IgxPlotAreaMouseEventArgs = IgxPlotAreaMouseEventArgs;
    exports.IgxPointSeriesComponent = IgxPointSeriesComponent;
    exports.IgxPointSeriesDynamicModule = IgxPointSeriesDynamicModule;
    exports.IgxPointSeriesModule = IgxPointSeriesModule;
    exports.IgxPolarAreaSeriesComponent = IgxPolarAreaSeriesComponent;
    exports.IgxPolarAreaSeriesDynamicModule = IgxPolarAreaSeriesDynamicModule;
    exports.IgxPolarAreaSeriesModule = IgxPolarAreaSeriesModule;
    exports.IgxPolarBaseComponent = IgxPolarBaseComponent;
    exports.IgxPolarLineSeriesBaseComponent = IgxPolarLineSeriesBaseComponent;
    exports.IgxPolarLineSeriesComponent = IgxPolarLineSeriesComponent;
    exports.IgxPolarLineSeriesDynamicModule = IgxPolarLineSeriesDynamicModule;
    exports.IgxPolarLineSeriesModule = IgxPolarLineSeriesModule;
    exports.IgxPolarScatterSeriesComponent = IgxPolarScatterSeriesComponent;
    exports.IgxPolarScatterSeriesDynamicModule = IgxPolarScatterSeriesDynamicModule;
    exports.IgxPolarScatterSeriesModule = IgxPolarScatterSeriesModule;
    exports.IgxPolarSplineAreaSeriesComponent = IgxPolarSplineAreaSeriesComponent;
    exports.IgxPolarSplineAreaSeriesDynamicModule = IgxPolarSplineAreaSeriesDynamicModule;
    exports.IgxPolarSplineAreaSeriesModule = IgxPolarSplineAreaSeriesModule;
    exports.IgxPolarSplineSeriesComponent = IgxPolarSplineSeriesComponent;
    exports.IgxPolarSplineSeriesDynamicModule = IgxPolarSplineSeriesDynamicModule;
    exports.IgxPolarSplineSeriesModule = IgxPolarSplineSeriesModule;
    exports.IgxPositiveVolumeIndexIndicatorComponent = IgxPositiveVolumeIndexIndicatorComponent;
    exports.IgxPositiveVolumeIndexIndicatorDynamicModule = IgxPositiveVolumeIndexIndicatorDynamicModule;
    exports.IgxPositiveVolumeIndexIndicatorModule = IgxPositiveVolumeIndexIndicatorModule;
    exports.IgxPriceChannelOverlayComponent = IgxPriceChannelOverlayComponent;
    exports.IgxPriceChannelOverlayDynamicModule = IgxPriceChannelOverlayDynamicModule;
    exports.IgxPriceChannelOverlayModule = IgxPriceChannelOverlayModule;
    exports.IgxPriceVolumeTrendIndicatorComponent = IgxPriceVolumeTrendIndicatorComponent;
    exports.IgxPriceVolumeTrendIndicatorDynamicModule = IgxPriceVolumeTrendIndicatorDynamicModule;
    exports.IgxPriceVolumeTrendIndicatorModule = IgxPriceVolumeTrendIndicatorModule;
    exports.IgxProgressiveLoadStatusEventArgs = IgxProgressiveLoadStatusEventArgs;
    exports.IgxRadialAreaSeriesComponent = IgxRadialAreaSeriesComponent;
    exports.IgxRadialAreaSeriesDynamicModule = IgxRadialAreaSeriesDynamicModule;
    exports.IgxRadialAreaSeriesModule = IgxRadialAreaSeriesModule;
    exports.IgxRadialBaseComponent = IgxRadialBaseComponent;
    exports.IgxRadialColumnSeriesComponent = IgxRadialColumnSeriesComponent;
    exports.IgxRadialColumnSeriesDynamicModule = IgxRadialColumnSeriesDynamicModule;
    exports.IgxRadialColumnSeriesModule = IgxRadialColumnSeriesModule;
    exports.IgxRadialLineSeriesComponent = IgxRadialLineSeriesComponent;
    exports.IgxRadialLineSeriesDynamicModule = IgxRadialLineSeriesDynamicModule;
    exports.IgxRadialLineSeriesModule = IgxRadialLineSeriesModule;
    exports.IgxRadialPieSeriesComponent = IgxRadialPieSeriesComponent;
    exports.IgxRadialPieSeriesDynamicModule = IgxRadialPieSeriesDynamicModule;
    exports.IgxRadialPieSeriesModule = IgxRadialPieSeriesModule;
    exports.IgxRangeAreaSeriesComponent = IgxRangeAreaSeriesComponent;
    exports.IgxRangeAreaSeriesDynamicModule = IgxRangeAreaSeriesDynamicModule;
    exports.IgxRangeAreaSeriesModule = IgxRangeAreaSeriesModule;
    exports.IgxRangeCategorySeriesComponent = IgxRangeCategorySeriesComponent;
    exports.IgxRangeColumnSeriesComponent = IgxRangeColumnSeriesComponent;
    exports.IgxRangeColumnSeriesDynamicModule = IgxRangeColumnSeriesDynamicModule;
    exports.IgxRangeColumnSeriesModule = IgxRangeColumnSeriesModule;
    exports.IgxRateOfChangeAndMomentumIndicatorComponent = IgxRateOfChangeAndMomentumIndicatorComponent;
    exports.IgxRateOfChangeAndMomentumIndicatorDynamicModule = IgxRateOfChangeAndMomentumIndicatorDynamicModule;
    exports.IgxRateOfChangeAndMomentumIndicatorModule = IgxRateOfChangeAndMomentumIndicatorModule;
    exports.IgxRefreshCompletedEventArgs = IgxRefreshCompletedEventArgs;
    exports.IgxRelativeStrengthIndexIndicatorComponent = IgxRelativeStrengthIndexIndicatorComponent;
    exports.IgxRelativeStrengthIndexIndicatorDynamicModule = IgxRelativeStrengthIndexIndicatorDynamicModule;
    exports.IgxRelativeStrengthIndexIndicatorModule = IgxRelativeStrengthIndexIndicatorModule;
    exports.IgxRenderRequestedEventArgs = IgxRenderRequestedEventArgs;
    exports.IgxRing = IgxRing;
    exports.IgxRingSeriesBaseComponent = IgxRingSeriesBaseComponent;
    exports.IgxRingSeriesCollection = IgxRingSeriesCollection;
    exports.IgxRingSeriesComponent = IgxRingSeriesComponent;
    exports.IgxRingSeriesDynamicModule = IgxRingSeriesDynamicModule;
    exports.IgxRingSeriesModule = IgxRingSeriesModule;
    exports.IgxScaleLegendComponent = IgxScaleLegendComponent;
    exports.IgxScaleLegendDynamicModule = IgxScaleLegendDynamicModule;
    exports.IgxScaleLegendModule = IgxScaleLegendModule;
    exports.IgxScalerParams = IgxScalerParams;
    exports.IgxScatterAreaSeriesComponent = IgxScatterAreaSeriesComponent;
    exports.IgxScatterAreaSeriesDynamicModule = IgxScatterAreaSeriesDynamicModule;
    exports.IgxScatterAreaSeriesModule = IgxScatterAreaSeriesModule;
    exports.IgxScatterBaseComponent = IgxScatterBaseComponent;
    exports.IgxScatterContourSeriesComponent = IgxScatterContourSeriesComponent;
    exports.IgxScatterContourSeriesDynamicModule = IgxScatterContourSeriesDynamicModule;
    exports.IgxScatterContourSeriesModule = IgxScatterContourSeriesModule;
    exports.IgxScatterLineSeriesComponent = IgxScatterLineSeriesComponent;
    exports.IgxScatterLineSeriesDynamicModule = IgxScatterLineSeriesDynamicModule;
    exports.IgxScatterLineSeriesModule = IgxScatterLineSeriesModule;
    exports.IgxScatterPolygonSeriesComponent = IgxScatterPolygonSeriesComponent;
    exports.IgxScatterPolygonSeriesDynamicModule = IgxScatterPolygonSeriesDynamicModule;
    exports.IgxScatterPolygonSeriesModule = IgxScatterPolygonSeriesModule;
    exports.IgxScatterPolylineSeriesComponent = IgxScatterPolylineSeriesComponent;
    exports.IgxScatterPolylineSeriesDynamicModule = IgxScatterPolylineSeriesDynamicModule;
    exports.IgxScatterPolylineSeriesModule = IgxScatterPolylineSeriesModule;
    exports.IgxScatterSeriesComponent = IgxScatterSeriesComponent;
    exports.IgxScatterSeriesDynamicModule = IgxScatterSeriesDynamicModule;
    exports.IgxScatterSeriesModule = IgxScatterSeriesModule;
    exports.IgxScatterSplineSeriesComponent = IgxScatterSplineSeriesComponent;
    exports.IgxScatterSplineSeriesDynamicModule = IgxScatterSplineSeriesDynamicModule;
    exports.IgxScatterSplineSeriesModule = IgxScatterSplineSeriesModule;
    exports.IgxScatterTriangulationSeriesComponent = IgxScatterTriangulationSeriesComponent;
    exports.IgxSelectedItemChangedEventArgs = IgxSelectedItemChangedEventArgs;
    exports.IgxSelectedItemChangingEventArgs = IgxSelectedItemChangingEventArgs;
    exports.IgxSelectedItemsChangedEventArgs = IgxSelectedItemsChangedEventArgs;
    exports.IgxSelectedItemsChangingEventArgs = IgxSelectedItemsChangingEventArgs;
    exports.IgxSeriesCollection = IgxSeriesCollection;
    exports.IgxSeriesComponent = IgxSeriesComponent;
    exports.IgxSeriesComponent_PROVIDERS = IgxSeriesComponent_PROVIDERS;
    exports.IgxSeriesViewerComponent = IgxSeriesViewerComponent;
    exports.IgxSeriesViewerManipulationEventArgs = IgxSeriesViewerManipulationEventArgs;
    exports.IgxShapeSeriesBaseComponent = IgxShapeSeriesBaseComponent;
    exports.IgxSizeScaleComponent = IgxSizeScaleComponent;
    exports.IgxSizeScaleDynamicModule = IgxSizeScaleDynamicModule;
    exports.IgxSizeScaleModule = IgxSizeScaleModule;
    exports.IgxSliceClickEventArgs = IgxSliceClickEventArgs;
    exports.IgxSliceEventArgs = IgxSliceEventArgs;
    exports.IgxSlowStochasticOscillatorIndicatorComponent = IgxSlowStochasticOscillatorIndicatorComponent;
    exports.IgxSlowStochasticOscillatorIndicatorDynamicModule = IgxSlowStochasticOscillatorIndicatorDynamicModule;
    exports.IgxSlowStochasticOscillatorIndicatorModule = IgxSlowStochasticOscillatorIndicatorModule;
    exports.IgxSparklineComponent = IgxSparklineComponent;
    exports.IgxSparklineCoreDynamicModule = IgxSparklineCoreDynamicModule;
    exports.IgxSparklineCoreModule = IgxSparklineCoreModule;
    exports.IgxSparklineDynamicModule = IgxSparklineDynamicModule;
    exports.IgxSparklineModule = IgxSparklineModule;
    exports.IgxSplineAreaFragmentComponent = IgxSplineAreaFragmentComponent;
    exports.IgxSplineAreaFragmentDynamicModule = IgxSplineAreaFragmentDynamicModule;
    exports.IgxSplineAreaFragmentModule = IgxSplineAreaFragmentModule;
    exports.IgxSplineAreaSeriesComponent = IgxSplineAreaSeriesComponent;
    exports.IgxSplineAreaSeriesDynamicModule = IgxSplineAreaSeriesDynamicModule;
    exports.IgxSplineAreaSeriesModule = IgxSplineAreaSeriesModule;
    exports.IgxSplineFragmentBaseComponent = IgxSplineFragmentBaseComponent;
    exports.IgxSplineFragmentComponent = IgxSplineFragmentComponent;
    exports.IgxSplineFragmentDynamicModule = IgxSplineFragmentDynamicModule;
    exports.IgxSplineFragmentModule = IgxSplineFragmentModule;
    exports.IgxSplineSeriesBaseComponent = IgxSplineSeriesBaseComponent;
    exports.IgxSplineSeriesComponent = IgxSplineSeriesComponent;
    exports.IgxSplineSeriesDynamicModule = IgxSplineSeriesDynamicModule;
    exports.IgxSplineSeriesModule = IgxSplineSeriesModule;
    exports.IgxStacked100AreaSeriesComponent = IgxStacked100AreaSeriesComponent;
    exports.IgxStacked100AreaSeriesDynamicModule = IgxStacked100AreaSeriesDynamicModule;
    exports.IgxStacked100AreaSeriesModule = IgxStacked100AreaSeriesModule;
    exports.IgxStacked100BarSeriesComponent = IgxStacked100BarSeriesComponent;
    exports.IgxStacked100BarSeriesDynamicModule = IgxStacked100BarSeriesDynamicModule;
    exports.IgxStacked100BarSeriesModule = IgxStacked100BarSeriesModule;
    exports.IgxStacked100ColumnSeriesComponent = IgxStacked100ColumnSeriesComponent;
    exports.IgxStacked100ColumnSeriesDynamicModule = IgxStacked100ColumnSeriesDynamicModule;
    exports.IgxStacked100ColumnSeriesModule = IgxStacked100ColumnSeriesModule;
    exports.IgxStacked100LineSeriesComponent = IgxStacked100LineSeriesComponent;
    exports.IgxStacked100LineSeriesDynamicModule = IgxStacked100LineSeriesDynamicModule;
    exports.IgxStacked100LineSeriesModule = IgxStacked100LineSeriesModule;
    exports.IgxStacked100SplineAreaSeriesComponent = IgxStacked100SplineAreaSeriesComponent;
    exports.IgxStacked100SplineAreaSeriesDynamicModule = IgxStacked100SplineAreaSeriesDynamicModule;
    exports.IgxStacked100SplineAreaSeriesModule = IgxStacked100SplineAreaSeriesModule;
    exports.IgxStacked100SplineSeriesComponent = IgxStacked100SplineSeriesComponent;
    exports.IgxStacked100SplineSeriesDynamicModule = IgxStacked100SplineSeriesDynamicModule;
    exports.IgxStacked100SplineSeriesModule = IgxStacked100SplineSeriesModule;
    exports.IgxStackedAreaSeriesComponent = IgxStackedAreaSeriesComponent;
    exports.IgxStackedAreaSeriesDynamicModule = IgxStackedAreaSeriesDynamicModule;
    exports.IgxStackedAreaSeriesModule = IgxStackedAreaSeriesModule;
    exports.IgxStackedBarSeriesComponent = IgxStackedBarSeriesComponent;
    exports.IgxStackedBarSeriesDynamicModule = IgxStackedBarSeriesDynamicModule;
    exports.IgxStackedBarSeriesModule = IgxStackedBarSeriesModule;
    exports.IgxStackedColumnSeriesComponent = IgxStackedColumnSeriesComponent;
    exports.IgxStackedColumnSeriesDynamicModule = IgxStackedColumnSeriesDynamicModule;
    exports.IgxStackedColumnSeriesModule = IgxStackedColumnSeriesModule;
    exports.IgxStackedFragmentSeriesComponent = IgxStackedFragmentSeriesComponent;
    exports.IgxStackedFragmentSeriesDynamicModule = IgxStackedFragmentSeriesDynamicModule;
    exports.IgxStackedFragmentSeriesModule = IgxStackedFragmentSeriesModule;
    exports.IgxStackedLineSeriesComponent = IgxStackedLineSeriesComponent;
    exports.IgxStackedLineSeriesDynamicModule = IgxStackedLineSeriesDynamicModule;
    exports.IgxStackedLineSeriesModule = IgxStackedLineSeriesModule;
    exports.IgxStackedSeriesBaseComponent = IgxStackedSeriesBaseComponent;
    exports.IgxStackedSeriesCollection = IgxStackedSeriesCollection;
    exports.IgxStackedSeriesCreatedEventArgs = IgxStackedSeriesCreatedEventArgs;
    exports.IgxStackedSplineAreaSeriesComponent = IgxStackedSplineAreaSeriesComponent;
    exports.IgxStackedSplineAreaSeriesDynamicModule = IgxStackedSplineAreaSeriesDynamicModule;
    exports.IgxStackedSplineAreaSeriesModule = IgxStackedSplineAreaSeriesModule;
    exports.IgxStackedSplineSeriesComponent = IgxStackedSplineSeriesComponent;
    exports.IgxStackedSplineSeriesDynamicModule = IgxStackedSplineSeriesDynamicModule;
    exports.IgxStackedSplineSeriesModule = IgxStackedSplineSeriesModule;
    exports.IgxStandardDeviationIndicatorComponent = IgxStandardDeviationIndicatorComponent;
    exports.IgxStandardDeviationIndicatorDynamicModule = IgxStandardDeviationIndicatorDynamicModule;
    exports.IgxStandardDeviationIndicatorModule = IgxStandardDeviationIndicatorModule;
    exports.IgxStepAreaSeriesComponent = IgxStepAreaSeriesComponent;
    exports.IgxStepAreaSeriesDynamicModule = IgxStepAreaSeriesDynamicModule;
    exports.IgxStepAreaSeriesModule = IgxStepAreaSeriesModule;
    exports.IgxStepLineSeriesComponent = IgxStepLineSeriesComponent;
    exports.IgxStepLineSeriesDynamicModule = IgxStepLineSeriesDynamicModule;
    exports.IgxStepLineSeriesModule = IgxStepLineSeriesModule;
    exports.IgxStochRSIIndicatorComponent = IgxStochRSIIndicatorComponent;
    exports.IgxStochRSIIndicatorDynamicModule = IgxStochRSIIndicatorDynamicModule;
    exports.IgxStochRSIIndicatorModule = IgxStochRSIIndicatorModule;
    exports.IgxStraightNumericAxisBaseComponent = IgxStraightNumericAxisBaseComponent;
    exports.IgxStrategyBasedIndicatorComponent = IgxStrategyBasedIndicatorComponent;
    exports.IgxStyleShapeEventArgs = IgxStyleShapeEventArgs;
    exports.IgxTRIXIndicatorComponent = IgxTRIXIndicatorComponent;
    exports.IgxTRIXIndicatorDynamicModule = IgxTRIXIndicatorDynamicModule;
    exports.IgxTRIXIndicatorModule = IgxTRIXIndicatorModule;
    exports.IgxTimeAxisBaseComponent = IgxTimeAxisBaseComponent;
    exports.IgxTimeAxisBreakCollection = IgxTimeAxisBreakCollection;
    exports.IgxTimeAxisBreakComponent = IgxTimeAxisBreakComponent;
    exports.IgxTimeAxisBreakDynamicModule = IgxTimeAxisBreakDynamicModule;
    exports.IgxTimeAxisBreakModule = IgxTimeAxisBreakModule;
    exports.IgxTimeAxisIntervalCollection = IgxTimeAxisIntervalCollection;
    exports.IgxTimeAxisIntervalComponent = IgxTimeAxisIntervalComponent;
    exports.IgxTimeAxisIntervalDynamicModule = IgxTimeAxisIntervalDynamicModule;
    exports.IgxTimeAxisIntervalModule = IgxTimeAxisIntervalModule;
    exports.IgxTimeAxisLabelFormatCollection = IgxTimeAxisLabelFormatCollection;
    exports.IgxTimeAxisLabelFormatComponent = IgxTimeAxisLabelFormatComponent;
    exports.IgxTimeAxisLabelFormatDynamicModule = IgxTimeAxisLabelFormatDynamicModule;
    exports.IgxTimeAxisLabelFormatModule = IgxTimeAxisLabelFormatModule;
    exports.IgxTimeXAxisComponent = IgxTimeXAxisComponent;
    exports.IgxTimeXAxisDynamicModule = IgxTimeXAxisDynamicModule;
    exports.IgxTimeXAxisModule = IgxTimeXAxisModule;
    exports.IgxTreemapComponent = IgxTreemapComponent;
    exports.IgxTreemapDynamicModule = IgxTreemapDynamicModule;
    exports.IgxTreemapModule = IgxTreemapModule;
    exports.IgxTreemapNodePointerEventArgs = IgxTreemapNodePointerEventArgs;
    exports.IgxTreemapNodeStyleComponent = IgxTreemapNodeStyleComponent;
    exports.IgxTreemapNodeStyleDynamicModule = IgxTreemapNodeStyleDynamicModule;
    exports.IgxTreemapNodeStyleMappingCollection = IgxTreemapNodeStyleMappingCollection;
    exports.IgxTreemapNodeStyleMappingComponent = IgxTreemapNodeStyleMappingComponent;
    exports.IgxTreemapNodeStyleMappingDynamicModule = IgxTreemapNodeStyleMappingDynamicModule;
    exports.IgxTreemapNodeStyleMappingModule = IgxTreemapNodeStyleMappingModule;
    exports.IgxTreemapNodeStyleModule = IgxTreemapNodeStyleModule;
    exports.IgxTreemapNodeStylingEventArgs = IgxTreemapNodeStylingEventArgs;
    exports.IgxTypicalPriceIndicatorComponent = IgxTypicalPriceIndicatorComponent;
    exports.IgxTypicalPriceIndicatorDynamicModule = IgxTypicalPriceIndicatorDynamicModule;
    exports.IgxTypicalPriceIndicatorModule = IgxTypicalPriceIndicatorModule;
    exports.IgxUltimateOscillatorIndicatorComponent = IgxUltimateOscillatorIndicatorComponent;
    exports.IgxUltimateOscillatorIndicatorDynamicModule = IgxUltimateOscillatorIndicatorDynamicModule;
    exports.IgxUltimateOscillatorIndicatorModule = IgxUltimateOscillatorIndicatorModule;
    exports.IgxValueBrushScaleComponent = IgxValueBrushScaleComponent;
    exports.IgxValueBrushScaleDynamicModule = IgxValueBrushScaleDynamicModule;
    exports.IgxValueBrushScaleModule = IgxValueBrushScaleModule;
    exports.IgxValueOverlayComponent = IgxValueOverlayComponent;
    exports.IgxValueOverlayDynamicModule = IgxValueOverlayDynamicModule;
    exports.IgxValueOverlayModule = IgxValueOverlayModule;
    exports.IgxVerticalAnchoredCategorySeriesComponent = IgxVerticalAnchoredCategorySeriesComponent;
    exports.IgxVerticalStackedSeriesBaseComponent = IgxVerticalStackedSeriesBaseComponent;
    exports.IgxWaterfallSeriesComponent = IgxWaterfallSeriesComponent;
    exports.IgxWaterfallSeriesDynamicModule = IgxWaterfallSeriesDynamicModule;
    exports.IgxWaterfallSeriesModule = IgxWaterfallSeriesModule;
    exports.IgxWeightedCloseIndicatorComponent = IgxWeightedCloseIndicatorComponent;
    exports.IgxWeightedCloseIndicatorDynamicModule = IgxWeightedCloseIndicatorDynamicModule;
    exports.IgxWeightedCloseIndicatorModule = IgxWeightedCloseIndicatorModule;
    exports.IgxWilliamsPercentRIndicatorComponent = IgxWilliamsPercentRIndicatorComponent;
    exports.IgxWilliamsPercentRIndicatorDynamicModule = IgxWilliamsPercentRIndicatorDynamicModule;
    exports.IgxWilliamsPercentRIndicatorModule = IgxWilliamsPercentRIndicatorModule;
    exports.IgxXYChartComponent = IgxXYChartComponent;
    exports.IgxZoomSliderComponent = IgxZoomSliderComponent;
    exports.IgxZoomSliderDynamicModule = IgxZoomSliderDynamicModule;
    exports.IgxZoomSliderModule = IgxZoomSliderModule;
    exports.IgxZoomSliderResolvingAxisValueEventArgs = IgxZoomSliderResolvingAxisValueEventArgs;
    exports.IndexCollection = IndexCollection;
    exports.IndicatorCalculationStrategy = IndicatorCalculationStrategy;
    exports.IndicatorDisplayType = IndicatorDisplayType;
    exports.IndicatorDisplayTypeCollection = IndicatorDisplayTypeCollection;
    exports.IndicatorDisplayType_$type = IndicatorDisplayType_$type;
    exports.IndicatorPane = IndicatorPane;
    exports.IndicatorProxy = IndicatorProxy;
    exports.IndicatorRenderer = IndicatorRenderer;
    exports.IntColumn = IntColumn;
    exports.InteractionMessage = InteractionMessage;
    exports.InteractionMessage_Spark = InteractionMessage_Spark;
    exports.InteractivityFactoryManager = InteractivityFactoryManager;
    exports.ItemHighlightFrameRect = ItemHighlightFrameRect;
    exports.ItemLegend = ItemLegend;
    exports.ItemLegendView = ItemLegendView;
    exports.ItemToolTipLayer = ItemToolTipLayer;
    exports.ItemToolTipLayerView = ItemToolTipLayerView;
    exports.ItemTooltipCollisionInfo = ItemTooltipCollisionInfo;
    exports.ItemTooltipLayerFrame = ItemTooltipLayerFrame;
    exports.ItemsSourceAction = ItemsSourceAction;
    exports.ItemsSourceAction_$type = ItemsSourceAction_$type;
    exports.ItemwiseIndicatorCalculationStrategy = ItemwiseIndicatorCalculationStrategy;
    exports.ItemwiseStrategyBasedIndicator = ItemwiseStrategyBasedIndicator;
    exports.ItemwiseStrategyCalculationStrategy = ItemwiseStrategyCalculationStrategy;
    exports.KDPointData = KDPointData;
    exports.KDTree2D = KDTree2D;
    exports.KDTreeNode2D = KDTreeNode2D;
    exports.KDTreeThunk = KDTreeThunk;
    exports.KNearestResult = KNearestResult;
    exports.KNearestResults = KNearestResults;
    exports.LabelClickEventArgs = LabelClickEventArgs;
    exports.LabelFontHeuristics = LabelFontHeuristics;
    exports.LabelPanelArranger = LabelPanelArranger;
    exports.LabelPanelsArrangeState = LabelPanelsArrangeState;
    exports.LabelPosition = LabelPosition;
    exports.LabelSizeChangedMessage = LabelSizeChangedMessage;
    exports.LabelsPosition = LabelsPosition;
    exports.LabelsPosition_$type = LabelsPosition_$type;
    exports.LeaderLineType = LeaderLineType;
    exports.LeaderLineType_$type = LeaderLineType_$type;
    exports.Legend = Legend;
    exports.LegendBase = LegendBase;
    exports.LegendBaseView = LegendBaseView;
    exports.LegendBaseViewManager = LegendBaseViewManager;
    exports.LegendHighlightingMode = LegendHighlightingMode;
    exports.LegendHighlightingMode_$type = LegendHighlightingMode_$type;
    exports.LegendItemBadgeMode = LegendItemBadgeMode;
    exports.LegendItemBadgeMode_$type = LegendItemBadgeMode_$type;
    exports.LegendItemBadgeShape = LegendItemBadgeShape;
    exports.LegendItemBadgeShape_$type = LegendItemBadgeShape_$type;
    exports.LegendItemInfo = LegendItemInfo;
    exports.LegendItemVisualData = LegendItemVisualData;
    exports.LegendMouseButtonEventArgs = LegendMouseButtonEventArgs;
    exports.LegendMouseEventArgs = LegendMouseEventArgs;
    exports.LegendOrientation = LegendOrientation;
    exports.LegendOrientation_$type = LegendOrientation_$type;
    exports.LegendTemplates = LegendTemplates;
    exports.LegendView = LegendView;
    exports.LegendVisualData = LegendVisualData;
    exports.LegendVisualDataList = LegendVisualDataList;
    exports.LineFragment = LineFragment;
    exports.LineFragmentBucketCalculator = LineFragmentBucketCalculator;
    exports.LineFragmentView = LineFragmentView;
    exports.LineSeries = LineSeries;
    exports.LineSeriesView = LineSeriesView;
    exports.LinearCategorySnapper = LinearCategorySnapper;
    exports.LinearContourValueResolver = LinearContourValueResolver;
    exports.LinearNumericSnapper = LinearNumericSnapper;
    exports.LinearScaler = LinearScaler;
    exports.LinearTickmarkValues = LinearTickmarkValues;
    exports.LogarithmicNumericSnapper = LogarithmicNumericSnapper;
    exports.LogarithmicScaler = LogarithmicScaler;
    exports.LogarithmicTickmarkValues = LogarithmicTickmarkValues;
    exports.Marker = Marker;
    exports.MarkerAutomaticBehavior = MarkerAutomaticBehavior;
    exports.MarkerAutomaticBehavior_$type = MarkerAutomaticBehavior_$type;
    exports.MarkerFillMode = MarkerFillMode;
    exports.MarkerFillMode_$type = MarkerFillMode_$type;
    exports.MarkerManagerBase = MarkerManagerBase;
    exports.MarkerManagerBucket = MarkerManagerBucket;
    exports.MarkerMessage_Spark = MarkerMessage_Spark;
    exports.MarkerOutlineMode = MarkerOutlineMode;
    exports.MarkerOutlineMode_$type = MarkerOutlineMode_$type;
    exports.MarkerSeries = MarkerSeries;
    exports.MarkerSeriesView = MarkerSeriesView;
    exports.MarkerTemplates = MarkerTemplates;
    exports.MarkerType = MarkerType;
    exports.MarkerTypeCollection = MarkerTypeCollection;
    exports.MarkerType_$type = MarkerType_$type;
    exports.MarkerVisualData = MarkerVisualData;
    exports.MarkerVisualDataList = MarkerVisualDataList;
    exports.MarketFacilitationIndexIndicator = MarketFacilitationIndexIndicator;
    exports.MarketFacilitationIndexIndicatorStrategy = MarketFacilitationIndexIndicatorStrategy;
    exports.MassIndexIndicator = MassIndexIndicator;
    exports.MassIndexIndicatorStrategy = MassIndexIndicatorStrategy;
    exports.MedianPriceIndicator = MedianPriceIndicator;
    exports.MedianPriceIndicatorStrategy = MedianPriceIndicatorStrategy;
    exports.Message = Message;
    exports.MessageChannel = MessageChannel;
    exports.MessageChannel_Spark = MessageChannel_Spark;
    exports.MessageHandler = MessageHandler;
    exports.MessageHandler_Spark = MessageHandler_Spark;
    exports.Message_Spark = Message_Spark;
    exports.ModelUpdateMessage = ModelUpdateMessage;
    exports.MoneyFlowIndexIndicator = MoneyFlowIndexIndicator;
    exports.MoneyFlowIndexIndicatorStrategy = MoneyFlowIndexIndicatorStrategy;
    exports.MouseButtonAction_$type = MouseButtonAction_$type;
    exports.MouseButtonMessage = MouseButtonMessage;
    exports.MouseButtonType_$type = MouseButtonType_$type;
    exports.MouseLeaveMessage = MouseLeaveMessage;
    exports.MouseLeaveMessage_Spark = MouseLeaveMessage_Spark;
    exports.MouseMoveMessage = MouseMoveMessage;
    exports.MouseMoveMessage_Spark = MouseMoveMessage_Spark;
    exports.MouseMoveThunk = MouseMoveThunk;
    exports.MovingAverageConvergenceDivergenceIndicator = MovingAverageConvergenceDivergenceIndicator;
    exports.MovingAverageConvergenceDivergenceIndicatorStrategy = MovingAverageConvergenceDivergenceIndicatorStrategy;
    exports.NaNSegmenter = NaNSegmenter;
    exports.NegativeVolumeIndexIndicator = NegativeVolumeIndexIndicator;
    exports.NegativeVolumeIndexIndicatorStrategy = NegativeVolumeIndexIndicatorStrategy;
    exports.Node = Node$1;
    exports.NonCollisionAvoider = NonCollisionAvoider;
    exports.NormalRangeMessage_Spark = NormalRangeMessage_Spark;
    exports.NumberAbbreviator = NumberAbbreviator;
    exports.NumberAbbreviatorFactory = NumberAbbreviatorFactory;
    exports.NumberChangedMessage_Spark = NumberChangedMessage_Spark;
    exports.NumericAngleAxis = NumericAngleAxis;
    exports.NumericAngleAxisView = NumericAngleAxisView;
    exports.NumericAxisBase = NumericAxisBase;
    exports.NumericAxisBaseView = NumericAxisBaseView;
    exports.NumericAxisRenderer = NumericAxisRenderer;
    exports.NumericAxisRenderingParameters = NumericAxisRenderingParameters;
    exports.NumericMarkerManager = NumericMarkerManager;
    exports.NumericRadiusAxis = NumericRadiusAxis;
    exports.NumericRadiusAxisView = NumericRadiusAxisView;
    exports.NumericScaleMode = NumericScaleMode;
    exports.NumericScaleMode_$type = NumericScaleMode_$type;
    exports.NumericScaler = NumericScaler;
    exports.NumericXAxis = NumericXAxis;
    exports.NumericXAxisView = NumericXAxisView;
    exports.NumericYAxis = NumericYAxis;
    exports.NumericYAxisView = NumericYAxisView;
    exports.ObjectColumn = ObjectColumn;
    exports.OnBalanceVolumeIndicator = OnBalanceVolumeIndicator;
    exports.OnBalanceVolumeIndicatorStrategy = OnBalanceVolumeIndicatorStrategy;
    exports.OrderedDictionary = OrderedDictionary;
    exports.OrderedDictionary$2 = OrderedDictionary$2;
    exports.OrderedDictionaryEnumerator$2 = OrderedDictionaryEnumerator$2;
    exports.OrdinalTimeXAxis = OrdinalTimeXAxis;
    exports.OthersCategoryType = OthersCategoryType;
    exports.OthersCategoryType_$type = OthersCategoryType_$type;
    exports.OuterLabelAlignment = OuterLabelAlignment;
    exports.OuterLabelAlignment_$type = OuterLabelAlignment_$type;
    exports.OverlayProxy = OverlayProxy;
    exports.OverviewPlusDetailViewportHost = OverviewPlusDetailViewportHost;
    exports.OwnedPoint = OwnedPoint;
    exports.PathRenderer = PathRenderer;
    exports.PathRenderingInfo = PathRenderingInfo;
    exports.PercentChangeAxisRenderer = PercentChangeAxisRenderer;
    exports.PercentChangeYAxis = PercentChangeYAxis;
    exports.PercentKCalculationStrategy = PercentKCalculationStrategy;
    exports.PercentagePriceOscillatorIndicator = PercentagePriceOscillatorIndicator;
    exports.PercentagePriceOscillatorIndicatorStrategy = PercentagePriceOscillatorIndicatorStrategy;
    exports.PercentageVolumeOscillatorIndicator = PercentageVolumeOscillatorIndicator;
    exports.PercentageVolumeOscillatorIndicatorStrategy = PercentageVolumeOscillatorIndicatorStrategy;
    exports.PieChartBase = PieChartBase;
    exports.PieChartBaseView = PieChartBaseView;
    exports.PieChartMockDataGenerator = PieChartMockDataGenerator;
    exports.PieChartMockDataItem = PieChartMockDataItem;
    exports.PieChartSliceSelector = PieChartSliceSelector;
    exports.PieChartStyleInfo = PieChartStyleInfo;
    exports.PieChartViewManager = PieChartViewManager;
    exports.PieChartVisualData = PieChartVisualData;
    exports.PieLabel = PieLabel;
    exports.PieLegendTemplates = PieLegendTemplates;
    exports.PieSliceDataContext = PieSliceDataContext;
    exports.PieSliceOthersContext = PieSliceOthersContext;
    exports.PieSliceVisualData = PieSliceVisualData;
    exports.PieSliceVisualDataList = PieSliceVisualDataList;
    exports.PixelRatioMessage_Spark = PixelRatioMessage_Spark;
    exports.PlotAreaMouseButtonEventArgs = PlotAreaMouseButtonEventArgs;
    exports.PlotAreaMouseEventArgs = PlotAreaMouseEventArgs;
    exports.PointList = PointList;
    exports.PointSeries = PointSeries;
    exports.PointSeriesView = PointSeriesView;
    exports.PointerTooltip = PointerTooltip;
    exports.PointerTooltipPointerLocation = PointerTooltipPointerLocation;
    exports.PointerTooltipPointerLocation_$type = PointerTooltipPointerLocation_$type;
    exports.PointerTooltipStyle = PointerTooltipStyle;
    exports.PointerTooltipView = PointerTooltipView;
    exports.PointerTooltipVisualData = PointerTooltipVisualData;
    exports.PointerTooltipVisualDataList = PointerTooltipVisualDataList;
    exports.PolarAreaSeries = PolarAreaSeries;
    exports.PolarAreaSeriesView = PolarAreaSeriesView;
    exports.PolarAxes = PolarAxes;
    exports.PolarAxisInfoCache = PolarAxisInfoCache;
    exports.PolarAxisRenderingManager = PolarAxisRenderingManager;
    exports.PolarAxisRenderingParameters = PolarAxisRenderingParameters;
    exports.PolarBase = PolarBase;
    exports.PolarBaseView = PolarBaseView;
    exports.PolarFrame = PolarFrame;
    exports.PolarLinePlanner = PolarLinePlanner;
    exports.PolarLineSeries = PolarLineSeries;
    exports.PolarLineSeriesBase = PolarLineSeriesBase;
    exports.PolarLineSeriesBaseView = PolarLineSeriesBaseView;
    exports.PolarLineSeriesView = PolarLineSeriesView;
    exports.PolarScatterSeries = PolarScatterSeries;
    exports.PolarScatterSeriesView = PolarScatterSeriesView;
    exports.PolarSeriesRenderManager = PolarSeriesRenderManager;
    exports.PolarSplineAreaSeries = PolarSplineAreaSeries;
    exports.PolarSplineAreaSeriesView = PolarSplineAreaSeriesView;
    exports.PolarSplineSeries = PolarSplineSeries;
    exports.PolarSplineSeriesView = PolarSplineSeriesView;
    exports.PolarTrendLineManager = PolarTrendLineManager;
    exports.PolygonMessage_Spark = PolygonMessage_Spark;
    exports.PolylineBuilder = PolylineBuilder;
    exports.PositiveVolumeIndexIndicator = PositiveVolumeIndexIndicator;
    exports.PositiveVolumeIndexIndicatorStrategy = PositiveVolumeIndexIndicatorStrategy;
    exports.PreparationParams = PreparationParams;
    exports.PriceChannelBucketCalculator = PriceChannelBucketCalculator;
    exports.PriceChannelOverlay = PriceChannelOverlay;
    exports.PriceChannelOverlayView = PriceChannelOverlayView;
    exports.PriceDisplayType = PriceDisplayType;
    exports.PriceDisplayType_$type = PriceDisplayType_$type;
    exports.PriceVolumeTrendIndicator = PriceVolumeTrendIndicator;
    exports.PriceVolumeTrendIndicatorStrategy = PriceVolumeTrendIndicatorStrategy;
    exports.ProgressiveLoadStatusEventArgs = ProgressiveLoadStatusEventArgs;
    exports.PropertyChangedMessage = PropertyChangedMessage;
    exports.PropertyChangedMessage_Spark = PropertyChangedMessage_Spark;
    exports.RadialAreaSeries = RadialAreaSeries;
    exports.RadialAreaSeriesView = RadialAreaSeriesView;
    exports.RadialAxes = RadialAxes;
    exports.RadialAxisLabelPanel = RadialAxisLabelPanel;
    exports.RadialAxisLabelPanelView = RadialAxisLabelPanelView;
    exports.RadialAxisRenderingParameters = RadialAxisRenderingParameters;
    exports.RadialBase = RadialBase;
    exports.RadialBaseView = RadialBaseView;
    exports.RadialBucketCalculator = RadialBucketCalculator;
    exports.RadialColumnSeries = RadialColumnSeries;
    exports.RadialColumnSeriesView = RadialColumnSeriesView;
    exports.RadialFrame = RadialFrame;
    exports.RadialLineSeries = RadialLineSeries;
    exports.RadialLineSeriesView = RadialLineSeriesView;
    exports.RadialPieSeries = RadialPieSeries;
    exports.RadialPieSeriesView = RadialPieSeriesView;
    exports.RadialSeriesRenderManager = RadialSeriesRenderManager;
    exports.RadialTrendLineManager = RadialTrendLineManager;
    exports.RangeAreaSeries = RangeAreaSeries;
    exports.RangeAreaSeriesView = RangeAreaSeriesView;
    exports.RangeCategoryBucketCalculator = RangeCategoryBucketCalculator;
    exports.RangeCategoryFramePreparer = RangeCategoryFramePreparer;
    exports.RangeCategorySeries = RangeCategorySeries;
    exports.RangeCategorySeriesView = RangeCategorySeriesView;
    exports.RangeColumnSeries = RangeColumnSeries;
    exports.RangeColumnSeriesView = RangeColumnSeriesView;
    exports.RangeInfo = RangeInfo;
    exports.RangeValueList = RangeValueList;
    exports.RateOfChangeAndMomentumIndicator = RateOfChangeAndMomentumIndicator;
    exports.RateOfChangeAndMomentumIndicatorStrategy = RateOfChangeAndMomentumIndicatorStrategy;
    exports.RefreshCompletedEventArgs = RefreshCompletedEventArgs;
    exports.RelativeStrengthIndexIndicator = RelativeStrengthIndexIndicator;
    exports.RelativeStrengthIndexIndicatorStrategy = RelativeStrengthIndexIndicatorStrategy;
    exports.RenderOuterLabelMessage = RenderOuterLabelMessage;
    exports.RenderRequestedEventArgs = RenderRequestedEventArgs;
    exports.RenderSliceMessage = RenderSliceMessage;
    exports.RenderSurface = RenderSurface;
    exports.RenderingMessage = RenderingMessage;
    exports.RenderingMessage_Spark = RenderingMessage_Spark;
    exports.Ring = Ring;
    exports.RingCollection = RingCollection;
    exports.RingControl = RingControl;
    exports.RingControlView = RingControlView;
    exports.RingSeries = RingSeries;
    exports.RingSeriesBase = RingSeriesBase;
    exports.RingSeriesBaseView = RingSeriesBaseView;
    exports.RingSeriesCollection = RingSeriesCollection;
    exports.RingSeriesVisualData = RingSeriesVisualData;
    exports.RingSeriesVisualDataList = RingSeriesVisualDataList;
    exports.RingVisualData = RingVisualData;
    exports.RingVisualDataList = RingVisualDataList;
    exports.SafeEnumerable = SafeEnumerable;
    exports.SafeReadOnlyDoubleCollection = SafeReadOnlyDoubleCollection;
    exports.SafeSortedReadOnlyDoubleCollection = SafeSortedReadOnlyDoubleCollection;
    exports.ScaleLegend = ScaleLegend;
    exports.ScaleLegendView = ScaleLegendView;
    exports.ScalerParams = ScalerParams;
    exports.ScatterAreaSeries = ScatterAreaSeries;
    exports.ScatterAreaSeriesView = ScatterAreaSeriesView;
    exports.ScatterAxisInfoCache = ScatterAxisInfoCache;
    exports.ScatterBase = ScatterBase;
    exports.ScatterBaseView = ScatterBaseView;
    exports.ScatterContourSeries = ScatterContourSeries;
    exports.ScatterContourSeriesView = ScatterContourSeriesView;
    exports.ScatterErrorBarSettings = ScatterErrorBarSettings;
    exports.ScatterFrame = ScatterFrame;
    exports.ScatterFrameBase$1 = ScatterFrameBase$1;
    exports.ScatterItemSearchMode = ScatterItemSearchMode;
    exports.ScatterItemSearchMode_$type = ScatterItemSearchMode_$type;
    exports.ScatterLineSeries = ScatterLineSeries;
    exports.ScatterLineSeriesView = ScatterLineSeriesView;
    exports.ScatterPolygonSeries = ScatterPolygonSeries;
    exports.ScatterPolygonSeriesView = ScatterPolygonSeriesView;
    exports.ScatterPolylineSeries = ScatterPolylineSeries;
    exports.ScatterPolylineSeriesView = ScatterPolylineSeriesView;
    exports.ScatterSeries = ScatterSeries;
    exports.ScatterSeriesRenderManager = ScatterSeriesRenderManager;
    exports.ScatterSeriesView = ScatterSeriesView;
    exports.ScatterSplineSeries = ScatterSplineSeries;
    exports.ScatterSplineSeriesView = ScatterSplineSeriesView;
    exports.ScatterTrendLineManager = ScatterTrendLineManager;
    exports.ScatterTriangulationSeries = ScatterTriangulationSeries;
    exports.SearchArgs = SearchArgs;
    exports.SearchData = SearchData;
    exports.SelectedItemChangedEventArgs = SelectedItemChangedEventArgs;
    exports.SelectedItemChangingEventArgs = SelectedItemChangingEventArgs;
    exports.SelectedItemsChangedEventArgs = SelectedItemsChangedEventArgs;
    exports.SelectedItemsChangedMessage = SelectedItemsChangedMessage;
    exports.SelectedItemsChangingEventArgs = SelectedItemsChangingEventArgs;
    exports.Series = Series;
    exports.SeriesCollection = SeriesCollection;
    exports.SeriesComponentsForView = SeriesComponentsForView;
    exports.SeriesComponentsFromView = SeriesComponentsFromView;
    exports.SeriesHighlightingBehavior = SeriesHighlightingBehavior;
    exports.SeriesHighlightingBehavior_$type = SeriesHighlightingBehavior_$type;
    exports.SeriesHighlightingMode = SeriesHighlightingMode;
    exports.SeriesHighlightingMode_$type = SeriesHighlightingMode_$type;
    exports.SeriesHitTestMode = SeriesHitTestMode;
    exports.SeriesHitTestMode_$type = SeriesHitTestMode_$type;
    exports.SeriesInteractionManager = SeriesInteractionManager;
    exports.SeriesOutlineMode = SeriesOutlineMode;
    exports.SeriesOutlineMode_$type = SeriesOutlineMode_$type;
    exports.SeriesPointOfInterest = SeriesPointOfInterest;
    exports.SeriesRenderManager = SeriesRenderManager;
    exports.SeriesRenderer$2 = SeriesRenderer$2;
    exports.SeriesRenderingArguments = SeriesRenderingArguments;
    exports.SeriesView = SeriesView;
    exports.SeriesViewer = SeriesViewer;
    exports.SeriesViewerComponentsForView = SeriesViewerComponentsForView;
    exports.SeriesViewerComponentsFromView = SeriesViewerComponentsFromView;
    exports.SeriesViewerInteractionManager = SeriesViewerInteractionManager;
    exports.SeriesViewerManipulationEventArgs = SeriesViewerManipulationEventArgs;
    exports.SeriesViewerSurfaceViewer = SeriesViewerSurfaceViewer;
    exports.SeriesViewerView = SeriesViewerView;
    exports.SeriesViewerViewManager = SeriesViewerViewManager;
    exports.SeriesVisibleRangeMode = SeriesVisibleRangeMode;
    exports.SeriesVisibleRangeMode_$type = SeriesVisibleRangeMode_$type;
    exports.SeriesVisualData = SeriesVisualData;
    exports.SeriesVisualDataList = SeriesVisualDataList;
    exports.SeriesVisualDataManager = SeriesVisualDataManager;
    exports.ServiceProvider = ServiceProvider;
    exports.ServiceProvider_Spark = ServiceProvider_Spark;
    exports.SetAreaSizeMessage = SetAreaSizeMessage;
    exports.ShapeAxisInfoCache = ShapeAxisInfoCache;
    exports.ShapeHitRegion = ShapeHitRegion;
    exports.ShapeItemSearchMode = ShapeItemSearchMode;
    exports.ShapeItemSearchMode_$type = ShapeItemSearchMode_$type;
    exports.ShapeSeriesBase = ShapeSeriesBase;
    exports.ShapeSeriesRenderManager = ShapeSeriesRenderManager;
    exports.ShapeSeriesViewBase = ShapeSeriesViewBase;
    exports.SingleValuesHolder = SingleValuesHolder;
    exports.SizeScale = SizeScale;
    exports.Slice = Slice;
    exports.SliceAndDiceCalculator = SliceAndDiceCalculator;
    exports.SliceAppearance = SliceAppearance;
    exports.SliceClickEventArgs = SliceClickEventArgs;
    exports.SliceClickedMessage = SliceClickedMessage;
    exports.SliceCollection = SliceCollection;
    exports.SliceCoords = SliceCoords;
    exports.SliceEventArgs = SliceEventArgs;
    exports.SliceInfo = SliceInfo;
    exports.SliceInfoList = SliceInfoList;
    exports.SliceItem = SliceItem;
    exports.SliceMouseMessage = SliceMouseMessage;
    exports.SliceMouseMessageType_$type = SliceMouseMessageType_$type;
    exports.SliceSelectionManager = SliceSelectionManager;
    exports.SliceSelectionMode = SliceSelectionMode;
    exports.SliceSelectionMode_$type = SliceSelectionMode_$type;
    exports.SliceView = SliceView;
    exports.SliceVisualData = SliceVisualData;
    exports.SliceVisualDataList = SliceVisualDataList;
    exports.SlowStochasticOscillatorIndicator = SlowStochasticOscillatorIndicator;
    exports.SlowStochasticOscillatorIndicatorStrategy = SlowStochasticOscillatorIndicatorStrategy;
    exports.Snapper = Snapper;
    exports.SortedListView$1 = SortedListView$1;
    exports.SortingTrendLineManager = SortingTrendLineManager;
    exports.SparkFrame = SparkFrame;
    exports.SparkFramePreparer = SparkFramePreparer;
    exports.SparkLayerType_$type = SparkLayerType_$type;
    exports.SparklineAxisVisualData = SparklineAxisVisualData;
    exports.SparklineConnector = SparklineConnector;
    exports.SparklineController = SparklineController;
    exports.SparklineDisplayType = SparklineDisplayType;
    exports.SparklineDisplayType_$type = SparklineDisplayType_$type;
    exports.SparklineStylingDefaults = SparklineStylingDefaults;
    exports.SparklineToolTipContext = SparklineToolTipContext;
    exports.SparklineVisualData = SparklineVisualData;
    exports.SplineAreaFragment = SplineAreaFragment;
    exports.SplineAreaFragmentView = SplineAreaFragmentView;
    exports.SplineAreaSeries = SplineAreaSeries;
    exports.SplineAreaSeriesView = SplineAreaSeriesView;
    exports.SplineFragment = SplineFragment;
    exports.SplineFragmentBase = SplineFragmentBase;
    exports.SplineFragmentBaseValueList = SplineFragmentBaseValueList;
    exports.SplineFragmentBucketCalculator = SplineFragmentBucketCalculator;
    exports.SplineFragmentView = SplineFragmentView;
    exports.SplineSeries = SplineSeries;
    exports.SplineSeriesBase = SplineSeriesBase;
    exports.SplineSeriesBaseView = SplineSeriesBaseView;
    exports.SplineSeriesView = SplineSeriesView;
    exports.SplineType = SplineType;
    exports.SplineType_$type = SplineType_$type;
    exports.SquarifiedCalculator = SquarifiedCalculator;
    exports.Stacked100AreaSeries = Stacked100AreaSeries;
    exports.Stacked100AreaSeriesView = Stacked100AreaSeriesView;
    exports.Stacked100BarBucketCalculator = Stacked100BarBucketCalculator;
    exports.Stacked100BarSeries = Stacked100BarSeries;
    exports.Stacked100BarSeriesView = Stacked100BarSeriesView;
    exports.Stacked100ColumnBucketCalculator = Stacked100ColumnBucketCalculator;
    exports.Stacked100ColumnSeries = Stacked100ColumnSeries;
    exports.Stacked100ColumnSeriesView = Stacked100ColumnSeriesView;
    exports.Stacked100DataPreparer = Stacked100DataPreparer;
    exports.Stacked100LineSeries = Stacked100LineSeries;
    exports.Stacked100LineSeriesView = Stacked100LineSeriesView;
    exports.Stacked100SplineAreaSeries = Stacked100SplineAreaSeries;
    exports.Stacked100SplineAreaSeriesView = Stacked100SplineAreaSeriesView;
    exports.Stacked100SplineSeries = Stacked100SplineSeries;
    exports.Stacked100SplineSeriesView = Stacked100SplineSeriesView;
    exports.StackedAreaSeries = StackedAreaSeries;
    exports.StackedAreaSeriesView = StackedAreaSeriesView;
    exports.StackedBarBucketCalculator = StackedBarBucketCalculator;
    exports.StackedBarSeries = StackedBarSeries;
    exports.StackedBarSeriesView = StackedBarSeriesView;
    exports.StackedBucketCalculator = StackedBucketCalculator;
    exports.StackedColumnBucketCalculator = StackedColumnBucketCalculator;
    exports.StackedColumnSeries = StackedColumnSeries;
    exports.StackedColumnSeriesView = StackedColumnSeriesView;
    exports.StackedFragmentSeries = StackedFragmentSeries;
    exports.StackedLineSeries = StackedLineSeries;
    exports.StackedLineSeriesView = StackedLineSeriesView;
    exports.StackedSeriesBase = StackedSeriesBase;
    exports.StackedSeriesCollection = StackedSeriesCollection;
    exports.StackedSeriesCreatedEventArgs = StackedSeriesCreatedEventArgs;
    exports.StackedSeriesFramePreparer = StackedSeriesFramePreparer;
    exports.StackedSeriesManager = StackedSeriesManager;
    exports.StackedSeriesView = StackedSeriesView;
    exports.StackedSeriesVisualData = StackedSeriesVisualData;
    exports.StackedSplineAreaSeries = StackedSplineAreaSeries;
    exports.StackedSplineAreaSeriesView = StackedSplineAreaSeriesView;
    exports.StackedSplineSeries = StackedSplineSeries;
    exports.StackedSplineSeriesView = StackedSplineSeriesView;
    exports.StandardDeviationIndicator = StandardDeviationIndicator;
    exports.StandardDeviationIndicatorStrategy = StandardDeviationIndicatorStrategy;
    exports.StepAreaSeries = StepAreaSeries;
    exports.StepAreaSeriesView = StepAreaSeriesView;
    exports.StepLineSeries = StepLineSeries;
    exports.StepLineSeriesView = StepLineSeriesView;
    exports.StochRSIIndicator = StochRSIIndicator;
    exports.StochRSIIndicatorStrategy = StochRSIIndicatorStrategy;
    exports.StraightNumericAxisBase = StraightNumericAxisBase;
    exports.StraightNumericAxisBaseView = StraightNumericAxisBaseView;
    exports.StrategyBasedIndicator = StrategyBasedIndicator;
    exports.StreamingIndicatorCalculationStrategy = StreamingIndicatorCalculationStrategy;
    exports.StringColumn = StringColumn;
    exports.StrippedCalculator = StrippedCalculator;
    exports.StyleSelector = StyleSelector;
    exports.StyleShapeEventArgs = StyleShapeEventArgs;
    exports.SupportingCalculation$1 = SupportingCalculation$1;
    exports.SyncLink = SyncLink;
    exports.SyncLinkManager = SyncLinkManager;
    exports.SyncManager = SyncManager;
    exports.SyncSettings = SyncSettings;
    exports.SyncSettingsConverter = SyncSettingsConverter;
    exports.TRIXIndicator = TRIXIndicator;
    exports.TRIXIndicatorStrategy = TRIXIndicatorStrategy;
    exports.TemplateChangedMessage = TemplateChangedMessage;
    exports.TemplatePicker = TemplatePicker;
    exports.TemplatedHtmlControl = TemplatedHtmlControl;
    exports.ThumbRangePosition = ThumbRangePosition;
    exports.ThumbRangePosition_$type = ThumbRangePosition_$type;
    exports.TickmarkValues = TickmarkValues;
    exports.TickmarkValuesInitializationParameters = TickmarkValuesInitializationParameters;
    exports.TileZoomInfo = TileZoomInfo;
    exports.TileZoomManager = TileZoomManager;
    exports.TileZoomTile = TileZoomTile;
    exports.TileZoomTileCache = TileZoomTileCache;
    exports.TileZoomTileInfo = TileZoomTileInfo;
    exports.TimeAxisBase = TimeAxisBase;
    exports.TimeAxisBreak = TimeAxisBreak;
    exports.TimeAxisBreakCollection = TimeAxisBreakCollection;
    exports.TimeAxisDisplayType = TimeAxisDisplayType;
    exports.TimeAxisDisplayType_$type = TimeAxisDisplayType_$type;
    exports.TimeAxisInterval = TimeAxisInterval;
    exports.TimeAxisIntervalCollection = TimeAxisIntervalCollection;
    exports.TimeAxisIntervalType = TimeAxisIntervalType;
    exports.TimeAxisIntervalType_$type = TimeAxisIntervalType_$type;
    exports.TimeAxisLabelFormat = TimeAxisLabelFormat;
    exports.TimeAxisLabelFormatCollection = TimeAxisLabelFormatCollection;
    exports.TimeAxisLabellingMode = TimeAxisLabellingMode;
    exports.TimeAxisLabellingMode_$type = TimeAxisLabellingMode_$type;
    exports.TimeRepetitionLevel_$type = TimeRepetitionLevel_$type;
    exports.TimeXAxis = TimeXAxis;
    exports.TitleSettings = TitleSettings;
    exports.ToolTipType = ToolTipType;
    exports.ToolTipType_$type = ToolTipType_$type;
    exports.Tooltip = Tooltip;
    exports.TooltipMessage_Spark = TooltipMessage_Spark;
    exports.TooltipUpdateMessage = TooltipUpdateMessage;
    exports.TooltipValueChangedMessage = TooltipValueChangedMessage;
    exports.ToooltipTemplateMessage_Spark = ToooltipTemplateMessage_Spark;
    exports.TrackShadeOrientation_$type = TrackShadeOrientation_$type;
    exports.TrackThumb = TrackThumb;
    exports.TrackThumbRange = TrackThumbRange;
    exports.TransitionInSpeedType = TransitionInSpeedType;
    exports.TransitionInSpeedType_$type = TransitionInSpeedType_$type;
    exports.Treemap = Treemap;
    exports.TreemapFillScaleMode = TreemapFillScaleMode;
    exports.TreemapFillScaleMode_$type = TreemapFillScaleMode_$type;
    exports.TreemapFrame = TreemapFrame;
    exports.TreemapHeaderDisplayMode = TreemapHeaderDisplayMode;
    exports.TreemapHeaderDisplayMode_$type = TreemapHeaderDisplayMode_$type;
    exports.TreemapLabelHorizontalFitMode = TreemapLabelHorizontalFitMode;
    exports.TreemapLabelHorizontalFitMode_$type = TreemapLabelHorizontalFitMode_$type;
    exports.TreemapLabelVerticalFitMode = TreemapLabelVerticalFitMode;
    exports.TreemapLabelVerticalFitMode_$type = TreemapLabelVerticalFitMode_$type;
    exports.TreemapLabelVisualData = TreemapLabelVisualData;
    exports.TreemapLayoutCalculator = TreemapLayoutCalculator;
    exports.TreemapLayoutSettings = TreemapLayoutSettings;
    exports.TreemapLayoutType = TreemapLayoutType;
    exports.TreemapLayoutType_$type = TreemapLayoutType_$type;
    exports.TreemapNodeFrame = TreemapNodeFrame;
    exports.TreemapNodePointerEventArgs = TreemapNodePointerEventArgs;
    exports.TreemapNodeStyle = TreemapNodeStyle;
    exports.TreemapNodeStyleMapping = TreemapNodeStyleMapping;
    exports.TreemapNodeStyleMappingCollection = TreemapNodeStyleMappingCollection;
    exports.TreemapNodeStyleMappingTargetType = TreemapNodeStyleMappingTargetType;
    exports.TreemapNodeStyleMappingTargetType_$type = TreemapNodeStyleMappingTargetType_$type;
    exports.TreemapNodeStylingEventArgs = TreemapNodeStylingEventArgs;
    exports.TreemapNodeVisualData = TreemapNodeVisualData;
    exports.TreemapNodeVisualDataList = TreemapNodeVisualDataList;
    exports.TreemapOrientation = TreemapOrientation;
    exports.TreemapOrientation_$type = TreemapOrientation_$type;
    exports.TreemapTreeData = TreemapTreeData;
    exports.TreemapTreeNode = TreemapTreeNode;
    exports.TreemapValueMappingMode = TreemapValueMappingMode;
    exports.TreemapValueMappingMode_$type = TreemapValueMappingMode_$type;
    exports.TreemapView = TreemapView;
    exports.TreemapViewRenderer = TreemapViewRenderer;
    exports.TreemapVisual = TreemapVisual;
    exports.TreemapVisualData = TreemapVisualData;
    exports.TrendAverageCalculator = TrendAverageCalculator;
    exports.TrendFitCalculator = TrendFitCalculator;
    exports.TrendLineManagerBase$1 = TrendLineManagerBase$1;
    exports.TrendLineManagerNames = TrendLineManagerNames;
    exports.TrendLineManagerType_$type = TrendLineManagerType_$type;
    exports.TrendLineMessage_Spark = TrendLineMessage_Spark;
    exports.TrendResolutionParams = TrendResolutionParams;
    exports.TriangleRasterizer = TriangleRasterizer;
    exports.TriangleRasterizer_PointAndValue = TriangleRasterizer_PointAndValue;
    exports.TypicalPriceIndicator = TypicalPriceIndicator;
    exports.TypicalPriceIndicatorStrategy = TypicalPriceIndicatorStrategy;
    exports.UltimateOscillatorIndicator = UltimateOscillatorIndicator;
    exports.UltimateOscillatorIndicatorCalculationStrategy = UltimateOscillatorIndicatorCalculationStrategy;
    exports.UserSelectedItemsChangedMessage = UserSelectedItemsChangedMessage;
    exports.ValueBrushScale = ValueBrushScale;
    exports.ValueOverlay = ValueOverlay;
    exports.ValueOverlayView = ValueOverlayView;
    exports.ValuesHolder = ValuesHolder;
    exports.VerticalAnchoredCategorySeries = VerticalAnchoredCategorySeries;
    exports.VerticalAnchoredCategorySeriesInteractionManager = VerticalAnchoredCategorySeriesInteractionManager;
    exports.VerticalAxisLabelPanel = VerticalAxisLabelPanel;
    exports.VerticalAxisLabelPanelView = VerticalAxisLabelPanelView;
    exports.VerticalAxisView = VerticalAxisView;
    exports.VerticalLinearScaler = VerticalLinearScaler;
    exports.VerticalLogarithmicScaler = VerticalLogarithmicScaler;
    exports.VerticalPercentChangeScaler = VerticalPercentChangeScaler;
    exports.VerticalStackedSeriesBase = VerticalStackedSeriesBase;
    exports.ViewPropertyChangedMessage = ViewPropertyChangedMessage;
    exports.ViewerSurfaceUsage = ViewerSurfaceUsage;
    exports.ViewerSurfaceUsage_$type = ViewerSurfaceUsage_$type;
    exports.ViewportChangedMessage = ViewportChangedMessage;
    exports.ViewportChangedMessage_Spark = ViewportChangedMessage_Spark;
    exports.ViewportUtils = ViewportUtils;
    exports.VisibilityMessage_Spark = VisibilityMessage_Spark;
    exports.VisualDataFactoryManager = VisualDataFactoryManager;
    exports.VisualDataSerializer = VisualDataSerializer;
    exports.VisualExportHelper = VisualExportHelper;
    exports.WaterfallSeries = WaterfallSeries;
    exports.WaterfallSeriesView = WaterfallSeriesView;
    exports.WeightedCloseIndicator = WeightedCloseIndicator;
    exports.WeightedCloseIndicatorStrategy = WeightedCloseIndicatorStrategy;
    exports.WilliamsPercentRIndicator = WilliamsPercentRIndicator;
    exports.WilliamsPercentRIndicatorStrategy = WilliamsPercentRIndicatorStrategy;
    exports.WinLossColumnMessage_Spark = WinLossColumnMessage_Spark;
    exports.WindowResponse = WindowResponse;
    exports.WindowResponse_$type = WindowResponse_$type;
    exports.XAxisLabelLocation = XAxisLabelLocation;
    exports.XAxisLabelLocation_$type = XAxisLabelLocation_$type;
    exports.XYChart = XYChart;
    exports.XamDataChart = XamDataChart;
    exports.XamDataChartView = XamDataChartView;
    exports.XamDoughnutChart = XamDoughnutChart;
    exports.XamDoughnutChartView = XamDoughnutChartView;
    exports.XamFunnelChart = XamFunnelChart;
    exports.XamFunnelConnector = XamFunnelConnector;
    exports.XamFunnelController = XamFunnelController;
    exports.XamFunnelSlice = XamFunnelSlice;
    exports.XamFunnelView = XamFunnelView;
    exports.XamPieChart = XamPieChart;
    exports.XamPieChartView = XamPieChartView;
    exports.XamSparkline = XamSparkline;
    exports.XamSparklineView = XamSparklineView;
    exports.YAxisLabelLocation = YAxisLabelLocation;
    exports.YAxisLabelLocation_$type = YAxisLabelLocation_$type;
    exports.ZoomCoercionMode = ZoomCoercionMode;
    exports.ZoomCoercionMode_$type = ZoomCoercionMode_$type;
    exports.ZoomSlider = ZoomSlider;
    exports.ZoomSliderCursor_$type = ZoomSliderCursor_$type;
    exports.ZoomSliderOrientation = ZoomSliderOrientation;
    exports.ZoomSliderOrientation_$type = ZoomSliderOrientation_$type;
    exports.ZoomSliderResolvingAxisValueEventArgs = ZoomSliderResolvingAxisValueEventArgs;
    exports.ZoomSliderView = ZoomSliderView;
    exports.ZoomSliderVisualArea_$type = ZoomSliderVisualArea_$type;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=igniteui-angular-charts.umd.js.map
